# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. ANSSI. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_csn1dir/ec_packet_channel_request_message_content_cc1.py
# * Created : 2018-11-21
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: TS 44.018 - d80
# section: 9.1.65 EC Packet Channel Request
# top-level object: EC PACKET CHANNEL REQUEST message content CC1



# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

ec_packet_channel_request_message_content_cc3 = CSN1List(name='ec_packet_channel_request_message_content_cc3', list=[
  CSN1Bit(name='ec_numberofblocks', bit=3),
  CSN1Bit(name='ec_priority'),
  CSN1Bit(name='randombits', bit=3),
  CSN1Bit(name='selected_dl_coverage_class', bit=3)])

ec_packet_channel_request_message_content_cc1 = CSN1List(name='ec_packet_channel_request_message_content_cc1', list=[
  CSN1Bit(name='ec_numberofblocks', bit=3),
  CSN1Bit(name='ec_priority'),
  CSN1Bit(name='randombits', bit=3),
  CSN1Bit(name='selected_dl_coverage_class', bit=3)])

ec_packet_channel_request_message_content_cc4 = CSN1List(name='ec_packet_channel_request_message_content_cc4', list=[
  CSN1Bit(name='ec_numberofblocks', bit=3),
  CSN1Bit(name='ec_priority'),
  CSN1Bit(name='randombits', bit=3),
  CSN1Bit(name='selected_dl_coverage_class', bit=3)])

ec_packet_channel_request_message_content_cc2 = CSN1List(name='ec_packet_channel_request_message_content_cc2', list=[
  CSN1Bit(name='ec_numberofblocks', bit=3),
  CSN1Bit(name='ec_priority'),
  CSN1Bit(name='randombits', bit=3),
  CSN1Bit(name='selected_dl_coverage_class', bit=3)])

