# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.4
# *
# * Copyright 2018. Benoit Michau. ANSSI. P1sec.
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Lesser General Public
# * License as published by the Free Software Foundation; either
# * version 2.1 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Lesser General Public License for more details.
# *
# * You should have received a copy of the GNU Lesser General Public
# * License along with this library; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# * MA 02110-1301  USA
# *
# *--------------------------------------------------------
# * File Name : pycrate_csn1dir/packet_cell_change_failure_message_content.py
# * Created : 2018-11-21
# * Authors : Benoit Michau
# *--------------------------------------------------------
#*/
# specification: TS 44.060 - d60
# section: 11.2.3 Packet Cell Change Failure
# top-level object: Packet Cell Change Failure message content

# external references
from pycrate_csn1dir.padding_bits import padding_bits
from pycrate_csn1dir.utran_fdd_target_cell_ie import utran_fdd_target_cell_ie
from pycrate_csn1dir.utran_tdd_target_cell_ie import utran_tdd_target_cell_ie
from pycrate_csn1dir.utran_csg_target_cell_ie import utran_csg_target_cell_ie
from pycrate_csn1dir.e_utran_target_cell_ie import e_utran_target_cell_ie
from pycrate_csn1dir.e_utran_target_cell_with_extended_earfcn_ie import e_utran_target_cell_with_extended_earfcn_ie
from pycrate_csn1dir.e_utran_csg_target_cell_ie import e_utran_csg_target_cell_ie

# code automatically generated by pycrate_csn1
# change object type with type=CSN1T_BSTR (default type is CSN1T_UINT) in init
# add dict for value interpretation with dic={...} in CSN1Bit init
# add dict for key interpretation with kdic={...} in CSN1Alt init

from pycrate_csn1.csnobj import *

packet_cell_change_failure_message_content = CSN1List(name='packet_cell_change_failure_message_content', list=[
  CSN1Bit(name='tlli_g_rnti', bit=32),
  CSN1Bit(name='arfcn', bit=10),
  CSN1Bit(name='bsic', bit=6),
  CSN1Bit(name='cause', bit=4),
  CSN1Alt(alt={
    '0': ('', [
    CSN1Bit(bit=-1)]),
    '1': ('', [
    CSN1Alt(alt={
      '0': ('', []),
      '1': ('', [
      CSN1Ref(name='utran_fdd_target_cell', obj=utran_fdd_target_cell_ie)])}),
    CSN1Alt(alt={
      '0': ('', []),
      '1': ('', [
      CSN1Ref(name='utran_tdd_target_cell', obj=utran_tdd_target_cell_ie)])}),
    CSN1Alt(alt={
      '0': ('', [
      CSN1Bit(bit=-1)]),
      '1': ('', [
      CSN1Alt(alt={
        '0': ('', []),
        '1': ('', [
        CSN1Bit(name='g_rnti_extension', bit=4)])}),
      CSN1Alt(alt={
        '0': ('', [
        CSN1Bit(bit=-1)]),
        '1': ('', [
        CSN1Alt(alt={
          '0': ('', []),
          '1': ('', [
          CSN1Ref(name='e_utran_target_cell', obj=e_utran_target_cell_ie)])}),
        CSN1Alt(alt={
          '0': ('', [
          CSN1Bit(bit=-1)]),
          '1': ('', [
          CSN1Alt(alt={
            '0': ('', []),
            '1': ('', [
            CSN1Ref(name='utran_csg_target_cell', obj=utran_csg_target_cell_ie)])}),
          CSN1Alt(alt={
            '0': ('', []),
            '1': ('', [
            CSN1Ref(name='e_utran_csg_target_cell', obj=e_utran_csg_target_cell_ie)])}),
          CSN1Alt(alt={
            '0': ('', [
            CSN1Bit(bit=-1)]),
            '1': ('', [
            CSN1Alt(alt={
              '0': ('', []),
              '1': ('', [
              CSN1Ref(name='e_utran_target_cell_with_extended_earfcn', obj=e_utran_target_cell_with_extended_earfcn_ie)])}),
            CSN1Ref(obj=padding_bits)]),
            None: ('', [])})]),
          None: ('', [])})]),
        None: ('', [])})]),
      None: ('', [])})]),
    None: ('', [])})])

