# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class E1AP_CommonDataTypes:

    _name_  = 'E1AP-CommonDataTypes'
    _oid_   = [0, 4, 0, 0, 22, 3, 5, 1, 3]
    
    _obj_ = [
        'maxPrivateIEs',
        'maxProtocolExtensions',
        'maxProtocolIEs',
        'Criticality',
        'Presence',
        'PrivateIE-ID',
        'ProcedureCode',
        'ProtocolExtensionID',
        'ProtocolIE-ID',
        'TriggeringMessage',
        ]
    _type_ = [
        'Criticality',
        'Presence',
        'PrivateIE-ID',
        'ProcedureCode',
        'ProtocolExtensionID',
        'ProtocolIE-ID',
        'TriggeringMessage',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxPrivateIEs',
        'maxProtocolExtensions',
        'maxProtocolIEs',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< maxPrivateIEs >-----#
    maxPrivateIEs = INT(name='maxPrivateIEs', mode=MODE_VALUE)
    maxPrivateIEs._val = 65535
    
    #-----< maxProtocolExtensions >-----#
    maxProtocolExtensions = INT(name='maxProtocolExtensions', mode=MODE_VALUE)
    maxProtocolExtensions._val = 65535
    
    #-----< maxProtocolIEs >-----#
    maxProtocolIEs = INT(name='maxProtocolIEs', mode=MODE_VALUE)
    maxProtocolIEs._val = 65535
    
    #-----< Criticality >-----#
    Criticality = ENUM(name='Criticality', mode=MODE_TYPE)
    Criticality._cont = ASN1Dict([('reject', 0), ('ignore', 1), ('notify', 2)])
    Criticality._ext = None
    
    #-----< Presence >-----#
    Presence = ENUM(name='Presence', mode=MODE_TYPE)
    Presence._cont = ASN1Dict([('optional', 0), ('conditional', 1), ('mandatory', 2)])
    Presence._ext = None
    
    #-----< PrivateIE-ID >-----#
    PrivateIE_ID = CHOICE(name='PrivateIE-ID', mode=MODE_TYPE)
    _PrivateIE_ID_local = INT(name='local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrivateIE_ID_local._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PrivateIE_ID_global_ = OID(name='global', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    PrivateIE_ID._cont = ASN1Dict([
        ('local', _PrivateIE_ID_local),
        ('global', _PrivateIE_ID_global_),
        ])
    PrivateIE_ID._ext = None
    
    #-----< ProcedureCode >-----#
    ProcedureCode = INT(name='ProcedureCode', mode=MODE_TYPE)
    ProcedureCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ProtocolExtensionID >-----#
    ProtocolExtensionID = INT(name='ProtocolExtensionID', mode=MODE_TYPE)
    ProtocolExtensionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< ProtocolIE-ID >-----#
    ProtocolIE_ID = INT(name='ProtocolIE-ID', mode=MODE_TYPE)
    ProtocolIE_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TriggeringMessage >-----#
    TriggeringMessage = ENUM(name='TriggeringMessage', mode=MODE_TYPE)
    TriggeringMessage._cont = ASN1Dict([('initiating-message', 0), ('successful-outcome', 1), ('unsuccessful-outcome', 2)])
    TriggeringMessage._ext = None
    
    _all_ = [
        maxPrivateIEs,
        maxProtocolExtensions,
        maxProtocolIEs,
        Criticality,
        Presence,
        _PrivateIE_ID_local,
        _PrivateIE_ID_global_,
        PrivateIE_ID,
        ProcedureCode,
        ProtocolExtensionID,
        ProtocolIE_ID,
        TriggeringMessage,
    ]

class E1AP_Constants:

    _name_  = 'E1AP-Constants'
    _oid_   = [0, 4, 0, 0, 22, 3, 5, 1, 4]
    
    _obj_ = [
        'id-reset',
        'id-errorIndication',
        'id-privateMessage',
        'id-gNB-CU-UP-E1Setup',
        'id-gNB-CU-CP-E1Setup',
        'id-gNB-CU-UP-ConfigurationUpdate',
        'id-gNB-CU-CP-ConfigurationUpdate',
        'id-e1Release',
        'id-bearerContextSetup',
        'id-bearerContextModification',
        'id-bearerContextModificationRequired',
        'id-bearerContextRelease',
        'id-bearerContextReleaseRequest',
        'id-bearerContextInactivityNotification',
        'id-dLDataNotification',
        'id-dataUsageReport',
        'id-gNB-CU-UP-CounterCheck',
        'id-gNB-CU-UP-StatusIndication',
        'id-uLDataNotification',
        'id-mRDC-DataUsageReport',
        'id-TraceStart',
        'id-DeactivateTrace',
        'id-resourceStatusReportingInitiation',
        'id-resourceStatusReporting',
        'id-iAB-UPTNLAddressUpdate',
        'id-CellTrafficTrace',
        'id-earlyForwardingSNTransfer',
        'id-gNB-CU-CPMeasurementResultsInformation',
        'id-iABPSKNotification',
        'id-BCBearerContextSetup',
        'id-BCBearerContextModification',
        'id-BCBearerContextModificationRequired',
        'id-BCBearerContextRelease',
        'id-BCBearerContextReleaseRequest',
        'id-MCBearerContextSetup',
        'id-MCBearerContextModification',
        'id-MCBearerContextModificationRequired',
        'id-MCBearerContextRelease',
        'id-MCBearerContextReleaseRequest',
        'maxnoofErrors',
        'maxnoofSPLMNs',
        'maxnoofSliceItems',
        'maxnoofIndividualE1ConnectionsToReset',
        'maxnoofEUTRANQOSParameters',
        'maxnoofNGRANQOSParameters',
        'maxnoofDRBs',
        'maxnoofNRCGI',
        'maxnoofPDUSessionResource',
        'maxnoofQoSFlows',
        'maxnoofUPParameters',
        'maxnoofCellGroups',
        'maxnooftimeperiods',
        'maxnoofTNLAssociations',
        'maxnoofTLAs',
        'maxnoofGTPTLAs',
        'maxnoofTNLAddresses',
        'maxnoofMDTPLMNs',
        'maxnoofQoSParaSets',
        'maxnoofExtSliceItems',
        'maxnoofDataForwardingTunneltoE-UTRAN',
        'maxnoofExtNRCGI',
        'maxnoofPSKs',
        'maxnoofECGI',
        'maxnoofSMBRValues',
        'maxnoofMBSAreaSessionIDs',
        'maxnoofSharedNG-UTerminations',
        'maxnoofMRBs',
        'maxnoofMBSSessionIDs',
        'id-Cause',
        'id-CriticalityDiagnostics',
        'id-gNB-CU-CP-UE-E1AP-ID',
        'id-gNB-CU-UP-UE-E1AP-ID',
        'id-ResetType',
        'id-UE-associatedLogicalE1-ConnectionItem',
        'id-UE-associatedLogicalE1-ConnectionListResAck',
        'id-gNB-CU-UP-ID',
        'id-gNB-CU-UP-Name',
        'id-gNB-CU-CP-Name',
        'id-CNSupport',
        'id-SupportedPLMNs',
        'id-TimeToWait',
        'id-SecurityInformation',
        'id-UEDLAggregateMaximumBitRate',
        'id-System-BearerContextSetupRequest',
        'id-System-BearerContextSetupResponse',
        'id-BearerContextStatusChange',
        'id-System-BearerContextModificationRequest',
        'id-System-BearerContextModificationResponse',
        'id-System-BearerContextModificationConfirm',
        'id-System-BearerContextModificationRequired',
        'id-DRB-Status-List',
        'id-ActivityNotificationLevel',
        'id-ActivityInformation',
        'id-Data-Usage-Report-List',
        'id-New-UL-TNL-Information-Required',
        'id-GNB-CU-CP-TNLA-To-Add-List',
        'id-GNB-CU-CP-TNLA-To-Remove-List',
        'id-GNB-CU-CP-TNLA-To-Update-List',
        'id-GNB-CU-CP-TNLA-Setup-List',
        'id-GNB-CU-CP-TNLA-Failed-To-Setup-List',
        'id-DRB-To-Setup-List-EUTRAN',
        'id-DRB-To-Modify-List-EUTRAN',
        'id-DRB-To-Remove-List-EUTRAN',
        'id-DRB-Required-To-Modify-List-EUTRAN',
        'id-DRB-Required-To-Remove-List-EUTRAN',
        'id-DRB-Setup-List-EUTRAN',
        'id-DRB-Failed-List-EUTRAN',
        'id-DRB-Modified-List-EUTRAN',
        'id-DRB-Failed-To-Modify-List-EUTRAN',
        'id-DRB-Confirm-Modified-List-EUTRAN',
        'id-PDU-Session-Resource-To-Setup-List',
        'id-PDU-Session-Resource-To-Modify-List',
        'id-PDU-Session-Resource-To-Remove-List',
        'id-PDU-Session-Resource-Required-To-Modify-List',
        'id-PDU-Session-Resource-Setup-List',
        'id-PDU-Session-Resource-Failed-List',
        'id-PDU-Session-Resource-Modified-List',
        'id-PDU-Session-Resource-Failed-To-Modify-List',
        'id-PDU-Session-Resource-Confirm-Modified-List',
        'id-DRB-To-Setup-Mod-List-EUTRAN',
        'id-DRB-Setup-Mod-List-EUTRAN',
        'id-DRB-Failed-Mod-List-EUTRAN',
        'id-PDU-Session-Resource-Setup-Mod-List',
        'id-PDU-Session-Resource-Failed-Mod-List',
        'id-PDU-Session-Resource-To-Setup-Mod-List',
        'id-TransactionID',
        'id-Serving-PLMN',
        'id-UE-Inactivity-Timer',
        'id-System-GNB-CU-UP-CounterCheckRequest',
        'id-DRBs-Subject-To-Counter-Check-List-EUTRAN',
        'id-DRBs-Subject-To-Counter-Check-List-NG-RAN',
        'id-PPI',
        'id-gNB-CU-UP-Capacity',
        'id-GNB-CU-UP-OverloadInformation',
        'id-UEDLMaximumIntegrityProtectedDataRate',
        'id-PDU-Session-To-Notify-List',
        'id-PDU-Session-Resource-Data-Usage-List',
        'id-SNSSAI',
        'id-DataDiscardRequired',
        'id-OldQoSFlowMap-ULendmarkerexpected',
        'id-DRB-QoS',
        'id-GNB-CU-UP-TNLA-To-Remove-List',
        'id-endpoint-IP-Address-and-Port',
        'id-TNLAssociationTransportLayerAddressgNBCUUP',
        'id-RANUEID',
        'id-GNB-DU-ID',
        'id-CommonNetworkInstance',
        'id-NetworkInstance',
        'id-QoSFlowMappingIndication',
        'id-TraceActivation',
        'id-TraceID',
        'id-SubscriberProfileIDforRFP',
        'id-AdditionalRRMPriorityIndex',
        'id-RetainabilityMeasurementsInfo',
        'id-Transport-Layer-Address-Info',
        'id-QoSMonitoringRequest',
        'id-PDCP-StatusReportIndication',
        'id-gNB-CU-CP-Measurement-ID',
        'id-gNB-CU-UP-Measurement-ID',
        'id-RegistrationRequest',
        'id-ReportCharacteristics',
        'id-ReportingPeriodicity',
        'id-TNL-AvailableCapacityIndicator',
        'id-HW-CapacityIndicator',
        'id-RedundantCommonNetworkInstance',
        'id-redundant-nG-UL-UP-TNL-Information',
        'id-redundant-nG-DL-UP-TNL-Information',
        'id-RedundantQosFlowIndicator',
        'id-TSCTrafficCharacteristics',
        'id-CNPacketDelayBudgetDownlink',
        'id-CNPacketDelayBudgetUplink',
        'id-ExtendedPacketDelayBudget',
        'id-AdditionalPDCPduplicationInformation',
        'id-RedundantPDUSessionInformation',
        'id-RedundantPDUSessionInformation-used',
        'id-QoS-Mapping-Information',
        'id-DLUPTNLAddressToUpdateList',
        'id-ULUPTNLAddressToUpdateList',
        'id-NPNSupportInfo',
        'id-NPNContextInfo',
        'id-MDTConfiguration',
        'id-ManagementBasedMDTPLMNList',
        'id-TraceCollectionEntityIPAddress',
        'id-PrivacyIndicator',
        'id-TraceCollectionEntityURI',
        'id-URIaddress',
        'id-EHC-Parameters',
        'id-DRBs-Subject-To-Early-Forwarding-List',
        'id-DAPSRequestInfo',
        'id-CHOInitiation',
        'id-EarlyForwardingCOUNTReq',
        'id-EarlyForwardingCOUNTInfo',
        'id-AlternativeQoSParaSetList',
        'id-ExtendedSliceSupportList',
        'id-MCG-OfferedGBRQoSFlowInfo',
        'id-Number-of-tunnels',
        'id-DRB-Measurement-Results-Information-List',
        'id-Extended-GNB-CU-CP-Name',
        'id-Extended-GNB-CU-UP-Name',
        'id-DataForwardingtoE-UTRANInformationList',
        'id-QosMonitoringReportingFrequency',
        'id-QoSMonitoringDisabled',
        'id-AdditionalHandoverInfo',
        'id-Extended-NR-CGI-Support-List',
        'id-DataForwardingtoNG-RANQoSFlowInformationList',
        'id-MaxCIDEHCDL',
        'id-ignoreMappingRuleIndication',
        'id-DirectForwardingPathAvailability',
        'id-EarlyDataForwardingIndicator',
        'id-QoSFlowsDRBRemapping',
        'id-DataForwardingSourceIPAddress',
        'id-SecurityIndicationModify',
        'id-IAB-Donor-CU-UPPSKInfo',
        'id-ECGI-Support-List',
        'id-MDTPollutedMeasurementIndicator',
        'id-M4ReportAmount',
        'id-M6ReportAmount',
        'id-M7ReportAmount',
        'id-UESliceMaximumBitRateList',
        'id-PDUSession-PairID',
        'id-SurvivalTime',
        'id-UDC-Parameters',
        'id-SCGActivationStatus',
        'id-GNB-CU-CP-MBS-E1AP-ID',
        'id-GNB-CU-UP-MBS-E1AP-ID',
        'id-GlobalMBSSessionID',
        'id-BCBearerContextToSetup',
        'id-BCBearerContextToSetupResponse',
        'id-BCBearerContextToModify',
        'id-BCBearerContextToModifyResponse',
        'id-BCBearerContextToModifyRequired',
        'id-BCBearerContextToModifyConfirm',
        'id-MCBearerContextToSetup',
        'id-MCBearerContextToSetupResponse',
        'id-MCBearerContextToModify',
        'id-MCBearerContextToModifyResponse',
        'id-MCBearerContextToModifyRequired',
        'id-MCBearerContextToModifyConfirm',
        'id-MBSMulticastF1UContextDescriptor',
        'id-gNB-CU-UP-MBS-Support-Info',
        'id-SecurityIndication',
        'id-SecurityResult',
        'id-SDTContinueROHC',
        'id-SDTindicatorSetup',
        'id-SDTindicatorMod',
        'id-DiscardTimerExtended',
        'id-ManagementBasedMDTPLMNModificationList',
        'id-MCForwardingResourceRequest',
        'id-MCForwardingResourceIndication',
        'id-MCForwardingResourceResponse',
        'id-MCForwardingResourceRelease',
        'id-MCForwardingResourceReleaseIndication',
        'id-PDCP-COUNT-Reset',
        'id-MBSSessionAssociatedInfoNonSupportToSupport',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        'id-reset',
        'id-errorIndication',
        'id-privateMessage',
        'id-gNB-CU-UP-E1Setup',
        'id-gNB-CU-CP-E1Setup',
        'id-gNB-CU-UP-ConfigurationUpdate',
        'id-gNB-CU-CP-ConfigurationUpdate',
        'id-e1Release',
        'id-bearerContextSetup',
        'id-bearerContextModification',
        'id-bearerContextModificationRequired',
        'id-bearerContextRelease',
        'id-bearerContextReleaseRequest',
        'id-bearerContextInactivityNotification',
        'id-dLDataNotification',
        'id-dataUsageReport',
        'id-gNB-CU-UP-CounterCheck',
        'id-gNB-CU-UP-StatusIndication',
        'id-uLDataNotification',
        'id-mRDC-DataUsageReport',
        'id-TraceStart',
        'id-DeactivateTrace',
        'id-resourceStatusReportingInitiation',
        'id-resourceStatusReporting',
        'id-iAB-UPTNLAddressUpdate',
        'id-CellTrafficTrace',
        'id-earlyForwardingSNTransfer',
        'id-gNB-CU-CPMeasurementResultsInformation',
        'id-iABPSKNotification',
        'id-BCBearerContextSetup',
        'id-BCBearerContextModification',
        'id-BCBearerContextModificationRequired',
        'id-BCBearerContextRelease',
        'id-BCBearerContextReleaseRequest',
        'id-MCBearerContextSetup',
        'id-MCBearerContextModification',
        'id-MCBearerContextModificationRequired',
        'id-MCBearerContextRelease',
        'id-MCBearerContextReleaseRequest',
        'maxnoofErrors',
        'maxnoofSPLMNs',
        'maxnoofSliceItems',
        'maxnoofIndividualE1ConnectionsToReset',
        'maxnoofEUTRANQOSParameters',
        'maxnoofNGRANQOSParameters',
        'maxnoofDRBs',
        'maxnoofNRCGI',
        'maxnoofPDUSessionResource',
        'maxnoofQoSFlows',
        'maxnoofUPParameters',
        'maxnoofCellGroups',
        'maxnooftimeperiods',
        'maxnoofTNLAssociations',
        'maxnoofTLAs',
        'maxnoofGTPTLAs',
        'maxnoofTNLAddresses',
        'maxnoofMDTPLMNs',
        'maxnoofQoSParaSets',
        'maxnoofExtSliceItems',
        'maxnoofDataForwardingTunneltoE-UTRAN',
        'maxnoofExtNRCGI',
        'maxnoofPSKs',
        'maxnoofECGI',
        'maxnoofSMBRValues',
        'maxnoofMBSAreaSessionIDs',
        'maxnoofSharedNG-UTerminations',
        'maxnoofMRBs',
        'maxnoofMBSSessionIDs',
        'id-Cause',
        'id-CriticalityDiagnostics',
        'id-gNB-CU-CP-UE-E1AP-ID',
        'id-gNB-CU-UP-UE-E1AP-ID',
        'id-ResetType',
        'id-UE-associatedLogicalE1-ConnectionItem',
        'id-UE-associatedLogicalE1-ConnectionListResAck',
        'id-gNB-CU-UP-ID',
        'id-gNB-CU-UP-Name',
        'id-gNB-CU-CP-Name',
        'id-CNSupport',
        'id-SupportedPLMNs',
        'id-TimeToWait',
        'id-SecurityInformation',
        'id-UEDLAggregateMaximumBitRate',
        'id-System-BearerContextSetupRequest',
        'id-System-BearerContextSetupResponse',
        'id-BearerContextStatusChange',
        'id-System-BearerContextModificationRequest',
        'id-System-BearerContextModificationResponse',
        'id-System-BearerContextModificationConfirm',
        'id-System-BearerContextModificationRequired',
        'id-DRB-Status-List',
        'id-ActivityNotificationLevel',
        'id-ActivityInformation',
        'id-Data-Usage-Report-List',
        'id-New-UL-TNL-Information-Required',
        'id-GNB-CU-CP-TNLA-To-Add-List',
        'id-GNB-CU-CP-TNLA-To-Remove-List',
        'id-GNB-CU-CP-TNLA-To-Update-List',
        'id-GNB-CU-CP-TNLA-Setup-List',
        'id-GNB-CU-CP-TNLA-Failed-To-Setup-List',
        'id-DRB-To-Setup-List-EUTRAN',
        'id-DRB-To-Modify-List-EUTRAN',
        'id-DRB-To-Remove-List-EUTRAN',
        'id-DRB-Required-To-Modify-List-EUTRAN',
        'id-DRB-Required-To-Remove-List-EUTRAN',
        'id-DRB-Setup-List-EUTRAN',
        'id-DRB-Failed-List-EUTRAN',
        'id-DRB-Modified-List-EUTRAN',
        'id-DRB-Failed-To-Modify-List-EUTRAN',
        'id-DRB-Confirm-Modified-List-EUTRAN',
        'id-PDU-Session-Resource-To-Setup-List',
        'id-PDU-Session-Resource-To-Modify-List',
        'id-PDU-Session-Resource-To-Remove-List',
        'id-PDU-Session-Resource-Required-To-Modify-List',
        'id-PDU-Session-Resource-Setup-List',
        'id-PDU-Session-Resource-Failed-List',
        'id-PDU-Session-Resource-Modified-List',
        'id-PDU-Session-Resource-Failed-To-Modify-List',
        'id-PDU-Session-Resource-Confirm-Modified-List',
        'id-DRB-To-Setup-Mod-List-EUTRAN',
        'id-DRB-Setup-Mod-List-EUTRAN',
        'id-DRB-Failed-Mod-List-EUTRAN',
        'id-PDU-Session-Resource-Setup-Mod-List',
        'id-PDU-Session-Resource-Failed-Mod-List',
        'id-PDU-Session-Resource-To-Setup-Mod-List',
        'id-TransactionID',
        'id-Serving-PLMN',
        'id-UE-Inactivity-Timer',
        'id-System-GNB-CU-UP-CounterCheckRequest',
        'id-DRBs-Subject-To-Counter-Check-List-EUTRAN',
        'id-DRBs-Subject-To-Counter-Check-List-NG-RAN',
        'id-PPI',
        'id-gNB-CU-UP-Capacity',
        'id-GNB-CU-UP-OverloadInformation',
        'id-UEDLMaximumIntegrityProtectedDataRate',
        'id-PDU-Session-To-Notify-List',
        'id-PDU-Session-Resource-Data-Usage-List',
        'id-SNSSAI',
        'id-DataDiscardRequired',
        'id-OldQoSFlowMap-ULendmarkerexpected',
        'id-DRB-QoS',
        'id-GNB-CU-UP-TNLA-To-Remove-List',
        'id-endpoint-IP-Address-and-Port',
        'id-TNLAssociationTransportLayerAddressgNBCUUP',
        'id-RANUEID',
        'id-GNB-DU-ID',
        'id-CommonNetworkInstance',
        'id-NetworkInstance',
        'id-QoSFlowMappingIndication',
        'id-TraceActivation',
        'id-TraceID',
        'id-SubscriberProfileIDforRFP',
        'id-AdditionalRRMPriorityIndex',
        'id-RetainabilityMeasurementsInfo',
        'id-Transport-Layer-Address-Info',
        'id-QoSMonitoringRequest',
        'id-PDCP-StatusReportIndication',
        'id-gNB-CU-CP-Measurement-ID',
        'id-gNB-CU-UP-Measurement-ID',
        'id-RegistrationRequest',
        'id-ReportCharacteristics',
        'id-ReportingPeriodicity',
        'id-TNL-AvailableCapacityIndicator',
        'id-HW-CapacityIndicator',
        'id-RedundantCommonNetworkInstance',
        'id-redundant-nG-UL-UP-TNL-Information',
        'id-redundant-nG-DL-UP-TNL-Information',
        'id-RedundantQosFlowIndicator',
        'id-TSCTrafficCharacteristics',
        'id-CNPacketDelayBudgetDownlink',
        'id-CNPacketDelayBudgetUplink',
        'id-ExtendedPacketDelayBudget',
        'id-AdditionalPDCPduplicationInformation',
        'id-RedundantPDUSessionInformation',
        'id-RedundantPDUSessionInformation-used',
        'id-QoS-Mapping-Information',
        'id-DLUPTNLAddressToUpdateList',
        'id-ULUPTNLAddressToUpdateList',
        'id-NPNSupportInfo',
        'id-NPNContextInfo',
        'id-MDTConfiguration',
        'id-ManagementBasedMDTPLMNList',
        'id-TraceCollectionEntityIPAddress',
        'id-PrivacyIndicator',
        'id-TraceCollectionEntityURI',
        'id-URIaddress',
        'id-EHC-Parameters',
        'id-DRBs-Subject-To-Early-Forwarding-List',
        'id-DAPSRequestInfo',
        'id-CHOInitiation',
        'id-EarlyForwardingCOUNTReq',
        'id-EarlyForwardingCOUNTInfo',
        'id-AlternativeQoSParaSetList',
        'id-ExtendedSliceSupportList',
        'id-MCG-OfferedGBRQoSFlowInfo',
        'id-Number-of-tunnels',
        'id-DRB-Measurement-Results-Information-List',
        'id-Extended-GNB-CU-CP-Name',
        'id-Extended-GNB-CU-UP-Name',
        'id-DataForwardingtoE-UTRANInformationList',
        'id-QosMonitoringReportingFrequency',
        'id-QoSMonitoringDisabled',
        'id-AdditionalHandoverInfo',
        'id-Extended-NR-CGI-Support-List',
        'id-DataForwardingtoNG-RANQoSFlowInformationList',
        'id-MaxCIDEHCDL',
        'id-ignoreMappingRuleIndication',
        'id-DirectForwardingPathAvailability',
        'id-EarlyDataForwardingIndicator',
        'id-QoSFlowsDRBRemapping',
        'id-DataForwardingSourceIPAddress',
        'id-SecurityIndicationModify',
        'id-IAB-Donor-CU-UPPSKInfo',
        'id-ECGI-Support-List',
        'id-MDTPollutedMeasurementIndicator',
        'id-M4ReportAmount',
        'id-M6ReportAmount',
        'id-M7ReportAmount',
        'id-UESliceMaximumBitRateList',
        'id-PDUSession-PairID',
        'id-SurvivalTime',
        'id-UDC-Parameters',
        'id-SCGActivationStatus',
        'id-GNB-CU-CP-MBS-E1AP-ID',
        'id-GNB-CU-UP-MBS-E1AP-ID',
        'id-GlobalMBSSessionID',
        'id-BCBearerContextToSetup',
        'id-BCBearerContextToSetupResponse',
        'id-BCBearerContextToModify',
        'id-BCBearerContextToModifyResponse',
        'id-BCBearerContextToModifyRequired',
        'id-BCBearerContextToModifyConfirm',
        'id-MCBearerContextToSetup',
        'id-MCBearerContextToSetupResponse',
        'id-MCBearerContextToModify',
        'id-MCBearerContextToModifyResponse',
        'id-MCBearerContextToModifyRequired',
        'id-MCBearerContextToModifyConfirm',
        'id-MBSMulticastF1UContextDescriptor',
        'id-gNB-CU-UP-MBS-Support-Info',
        'id-SecurityIndication',
        'id-SecurityResult',
        'id-SDTContinueROHC',
        'id-SDTindicatorSetup',
        'id-SDTindicatorMod',
        'id-DiscardTimerExtended',
        'id-ManagementBasedMDTPLMNModificationList',
        'id-MCForwardingResourceRequest',
        'id-MCForwardingResourceIndication',
        'id-MCForwardingResourceResponse',
        'id-MCForwardingResourceRelease',
        'id-MCForwardingResourceReleaseIndication',
        'id-PDCP-COUNT-Reset',
        'id-MBSSessionAssociatedInfoNonSupportToSupport',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< id-reset >-----#
    id_reset = INT(name='id-reset', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_reset._val = 0
    
    #-----< id-errorIndication >-----#
    id_errorIndication = INT(name='id-errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_errorIndication._val = 1
    
    #-----< id-privateMessage >-----#
    id_privateMessage = INT(name='id-privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_privateMessage._val = 2
    
    #-----< id-gNB-CU-UP-E1Setup >-----#
    id_gNB_CU_UP_E1Setup = INT(name='id-gNB-CU-UP-E1Setup', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_gNB_CU_UP_E1Setup._val = 3
    
    #-----< id-gNB-CU-CP-E1Setup >-----#
    id_gNB_CU_CP_E1Setup = INT(name='id-gNB-CU-CP-E1Setup', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_gNB_CU_CP_E1Setup._val = 4
    
    #-----< id-gNB-CU-UP-ConfigurationUpdate >-----#
    id_gNB_CU_UP_ConfigurationUpdate = INT(name='id-gNB-CU-UP-ConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_gNB_CU_UP_ConfigurationUpdate._val = 5
    
    #-----< id-gNB-CU-CP-ConfigurationUpdate >-----#
    id_gNB_CU_CP_ConfigurationUpdate = INT(name='id-gNB-CU-CP-ConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_gNB_CU_CP_ConfigurationUpdate._val = 6
    
    #-----< id-e1Release >-----#
    id_e1Release = INT(name='id-e1Release', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_e1Release._val = 7
    
    #-----< id-bearerContextSetup >-----#
    id_bearerContextSetup = INT(name='id-bearerContextSetup', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_bearerContextSetup._val = 8
    
    #-----< id-bearerContextModification >-----#
    id_bearerContextModification = INT(name='id-bearerContextModification', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_bearerContextModification._val = 9
    
    #-----< id-bearerContextModificationRequired >-----#
    id_bearerContextModificationRequired = INT(name='id-bearerContextModificationRequired', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_bearerContextModificationRequired._val = 10
    
    #-----< id-bearerContextRelease >-----#
    id_bearerContextRelease = INT(name='id-bearerContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_bearerContextRelease._val = 11
    
    #-----< id-bearerContextReleaseRequest >-----#
    id_bearerContextReleaseRequest = INT(name='id-bearerContextReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_bearerContextReleaseRequest._val = 12
    
    #-----< id-bearerContextInactivityNotification >-----#
    id_bearerContextInactivityNotification = INT(name='id-bearerContextInactivityNotification', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_bearerContextInactivityNotification._val = 13
    
    #-----< id-dLDataNotification >-----#
    id_dLDataNotification = INT(name='id-dLDataNotification', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_dLDataNotification._val = 14
    
    #-----< id-dataUsageReport >-----#
    id_dataUsageReport = INT(name='id-dataUsageReport', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_dataUsageReport._val = 15
    
    #-----< id-gNB-CU-UP-CounterCheck >-----#
    id_gNB_CU_UP_CounterCheck = INT(name='id-gNB-CU-UP-CounterCheck', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_gNB_CU_UP_CounterCheck._val = 16
    
    #-----< id-gNB-CU-UP-StatusIndication >-----#
    id_gNB_CU_UP_StatusIndication = INT(name='id-gNB-CU-UP-StatusIndication', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_gNB_CU_UP_StatusIndication._val = 17
    
    #-----< id-uLDataNotification >-----#
    id_uLDataNotification = INT(name='id-uLDataNotification', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_uLDataNotification._val = 18
    
    #-----< id-mRDC-DataUsageReport >-----#
    id_mRDC_DataUsageReport = INT(name='id-mRDC-DataUsageReport', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_mRDC_DataUsageReport._val = 19
    
    #-----< id-TraceStart >-----#
    id_TraceStart = INT(name='id-TraceStart', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_TraceStart._val = 20
    
    #-----< id-DeactivateTrace >-----#
    id_DeactivateTrace = INT(name='id-DeactivateTrace', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_DeactivateTrace._val = 21
    
    #-----< id-resourceStatusReportingInitiation >-----#
    id_resourceStatusReportingInitiation = INT(name='id-resourceStatusReportingInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_resourceStatusReportingInitiation._val = 22
    
    #-----< id-resourceStatusReporting >-----#
    id_resourceStatusReporting = INT(name='id-resourceStatusReporting', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_resourceStatusReporting._val = 23
    
    #-----< id-iAB-UPTNLAddressUpdate >-----#
    id_iAB_UPTNLAddressUpdate = INT(name='id-iAB-UPTNLAddressUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_iAB_UPTNLAddressUpdate._val = 24
    
    #-----< id-CellTrafficTrace >-----#
    id_CellTrafficTrace = INT(name='id-CellTrafficTrace', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_CellTrafficTrace._val = 25
    
    #-----< id-earlyForwardingSNTransfer >-----#
    id_earlyForwardingSNTransfer = INT(name='id-earlyForwardingSNTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_earlyForwardingSNTransfer._val = 26
    
    #-----< id-gNB-CU-CPMeasurementResultsInformation >-----#
    id_gNB_CU_CPMeasurementResultsInformation = INT(name='id-gNB-CU-CPMeasurementResultsInformation', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_gNB_CU_CPMeasurementResultsInformation._val = 27
    
    #-----< id-iABPSKNotification >-----#
    id_iABPSKNotification = INT(name='id-iABPSKNotification', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_iABPSKNotification._val = 28
    
    #-----< id-BCBearerContextSetup >-----#
    id_BCBearerContextSetup = INT(name='id-BCBearerContextSetup', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_BCBearerContextSetup._val = 29
    
    #-----< id-BCBearerContextModification >-----#
    id_BCBearerContextModification = INT(name='id-BCBearerContextModification', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_BCBearerContextModification._val = 30
    
    #-----< id-BCBearerContextModificationRequired >-----#
    id_BCBearerContextModificationRequired = INT(name='id-BCBearerContextModificationRequired', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_BCBearerContextModificationRequired._val = 31
    
    #-----< id-BCBearerContextRelease >-----#
    id_BCBearerContextRelease = INT(name='id-BCBearerContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_BCBearerContextRelease._val = 32
    
    #-----< id-BCBearerContextReleaseRequest >-----#
    id_BCBearerContextReleaseRequest = INT(name='id-BCBearerContextReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_BCBearerContextReleaseRequest._val = 33
    
    #-----< id-MCBearerContextSetup >-----#
    id_MCBearerContextSetup = INT(name='id-MCBearerContextSetup', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_MCBearerContextSetup._val = 34
    
    #-----< id-MCBearerContextModification >-----#
    id_MCBearerContextModification = INT(name='id-MCBearerContextModification', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_MCBearerContextModification._val = 35
    
    #-----< id-MCBearerContextModificationRequired >-----#
    id_MCBearerContextModificationRequired = INT(name='id-MCBearerContextModificationRequired', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_MCBearerContextModificationRequired._val = 36
    
    #-----< id-MCBearerContextRelease >-----#
    id_MCBearerContextRelease = INT(name='id-MCBearerContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_MCBearerContextRelease._val = 37
    
    #-----< id-MCBearerContextReleaseRequest >-----#
    id_MCBearerContextReleaseRequest = INT(name='id-MCBearerContextReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')))
    id_MCBearerContextReleaseRequest._val = 38
    
    #-----< maxnoofErrors >-----#
    maxnoofErrors = INT(name='maxnoofErrors', mode=MODE_VALUE)
    maxnoofErrors._val = 256
    
    #-----< maxnoofSPLMNs >-----#
    maxnoofSPLMNs = INT(name='maxnoofSPLMNs', mode=MODE_VALUE)
    maxnoofSPLMNs._val = 12
    
    #-----< maxnoofSliceItems >-----#
    maxnoofSliceItems = INT(name='maxnoofSliceItems', mode=MODE_VALUE)
    maxnoofSliceItems._val = 1024
    
    #-----< maxnoofIndividualE1ConnectionsToReset >-----#
    maxnoofIndividualE1ConnectionsToReset = INT(name='maxnoofIndividualE1ConnectionsToReset', mode=MODE_VALUE)
    maxnoofIndividualE1ConnectionsToReset._val = 65536
    
    #-----< maxnoofEUTRANQOSParameters >-----#
    maxnoofEUTRANQOSParameters = INT(name='maxnoofEUTRANQOSParameters', mode=MODE_VALUE)
    maxnoofEUTRANQOSParameters._val = 256
    
    #-----< maxnoofNGRANQOSParameters >-----#
    maxnoofNGRANQOSParameters = INT(name='maxnoofNGRANQOSParameters', mode=MODE_VALUE)
    maxnoofNGRANQOSParameters._val = 256
    
    #-----< maxnoofDRBs >-----#
    maxnoofDRBs = INT(name='maxnoofDRBs', mode=MODE_VALUE)
    maxnoofDRBs._val = 32
    
    #-----< maxnoofNRCGI >-----#
    maxnoofNRCGI = INT(name='maxnoofNRCGI', mode=MODE_VALUE)
    maxnoofNRCGI._val = 512
    
    #-----< maxnoofPDUSessionResource >-----#
    maxnoofPDUSessionResource = INT(name='maxnoofPDUSessionResource', mode=MODE_VALUE)
    maxnoofPDUSessionResource._val = 256
    
    #-----< maxnoofQoSFlows >-----#
    maxnoofQoSFlows = INT(name='maxnoofQoSFlows', mode=MODE_VALUE)
    maxnoofQoSFlows._val = 64
    
    #-----< maxnoofUPParameters >-----#
    maxnoofUPParameters = INT(name='maxnoofUPParameters', mode=MODE_VALUE)
    maxnoofUPParameters._val = 8
    
    #-----< maxnoofCellGroups >-----#
    maxnoofCellGroups = INT(name='maxnoofCellGroups', mode=MODE_VALUE)
    maxnoofCellGroups._val = 4
    
    #-----< maxnooftimeperiods >-----#
    maxnooftimeperiods = INT(name='maxnooftimeperiods', mode=MODE_VALUE)
    maxnooftimeperiods._val = 2
    
    #-----< maxnoofTNLAssociations >-----#
    maxnoofTNLAssociations = INT(name='maxnoofTNLAssociations', mode=MODE_VALUE)
    maxnoofTNLAssociations._val = 32
    
    #-----< maxnoofTLAs >-----#
    maxnoofTLAs = INT(name='maxnoofTLAs', mode=MODE_VALUE)
    maxnoofTLAs._val = 16
    
    #-----< maxnoofGTPTLAs >-----#
    maxnoofGTPTLAs = INT(name='maxnoofGTPTLAs', mode=MODE_VALUE)
    maxnoofGTPTLAs._val = 16
    
    #-----< maxnoofTNLAddresses >-----#
    maxnoofTNLAddresses = INT(name='maxnoofTNLAddresses', mode=MODE_VALUE)
    maxnoofTNLAddresses._val = 8
    
    #-----< maxnoofMDTPLMNs >-----#
    maxnoofMDTPLMNs = INT(name='maxnoofMDTPLMNs', mode=MODE_VALUE)
    maxnoofMDTPLMNs._val = 16
    
    #-----< maxnoofQoSParaSets >-----#
    maxnoofQoSParaSets = INT(name='maxnoofQoSParaSets', mode=MODE_VALUE)
    maxnoofQoSParaSets._val = 8
    
    #-----< maxnoofExtSliceItems >-----#
    maxnoofExtSliceItems = INT(name='maxnoofExtSliceItems', mode=MODE_VALUE)
    maxnoofExtSliceItems._val = 65535
    
    #-----< maxnoofDataForwardingTunneltoE-UTRAN >-----#
    maxnoofDataForwardingTunneltoE_UTRAN = INT(name='maxnoofDataForwardingTunneltoE-UTRAN', mode=MODE_VALUE)
    maxnoofDataForwardingTunneltoE_UTRAN._val = 256
    
    #-----< maxnoofExtNRCGI >-----#
    maxnoofExtNRCGI = INT(name='maxnoofExtNRCGI', mode=MODE_VALUE)
    maxnoofExtNRCGI._val = 16384
    
    #-----< maxnoofPSKs >-----#
    maxnoofPSKs = INT(name='maxnoofPSKs', mode=MODE_VALUE)
    maxnoofPSKs._val = 256
    
    #-----< maxnoofECGI >-----#
    maxnoofECGI = INT(name='maxnoofECGI', mode=MODE_VALUE)
    maxnoofECGI._val = 512
    
    #-----< maxnoofSMBRValues >-----#
    maxnoofSMBRValues = INT(name='maxnoofSMBRValues', mode=MODE_VALUE)
    maxnoofSMBRValues._val = 8
    
    #-----< maxnoofMBSAreaSessionIDs >-----#
    maxnoofMBSAreaSessionIDs = INT(name='maxnoofMBSAreaSessionIDs', mode=MODE_VALUE)
    maxnoofMBSAreaSessionIDs._val = 256
    
    #-----< maxnoofSharedNG-UTerminations >-----#
    maxnoofSharedNG_UTerminations = INT(name='maxnoofSharedNG-UTerminations', mode=MODE_VALUE)
    maxnoofSharedNG_UTerminations._val = 8
    
    #-----< maxnoofMRBs >-----#
    maxnoofMRBs = INT(name='maxnoofMRBs', mode=MODE_VALUE)
    maxnoofMRBs._val = 32
    
    #-----< maxnoofMBSSessionIDs >-----#
    maxnoofMBSSessionIDs = INT(name='maxnoofMBSSessionIDs', mode=MODE_VALUE)
    maxnoofMBSSessionIDs._val = 512
    
    #-----< id-Cause >-----#
    id_Cause = INT(name='id-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cause._val = 0
    
    #-----< id-CriticalityDiagnostics >-----#
    id_CriticalityDiagnostics = INT(name='id-CriticalityDiagnostics', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CriticalityDiagnostics._val = 1
    
    #-----< id-gNB-CU-CP-UE-E1AP-ID >-----#
    id_gNB_CU_CP_UE_E1AP_ID = INT(name='id-gNB-CU-CP-UE-E1AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNB_CU_CP_UE_E1AP_ID._val = 2
    
    #-----< id-gNB-CU-UP-UE-E1AP-ID >-----#
    id_gNB_CU_UP_UE_E1AP_ID = INT(name='id-gNB-CU-UP-UE-E1AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNB_CU_UP_UE_E1AP_ID._val = 3
    
    #-----< id-ResetType >-----#
    id_ResetType = INT(name='id-ResetType', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResetType._val = 4
    
    #-----< id-UE-associatedLogicalE1-ConnectionItem >-----#
    id_UE_associatedLogicalE1_ConnectionItem = INT(name='id-UE-associatedLogicalE1-ConnectionItem', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_associatedLogicalE1_ConnectionItem._val = 5
    
    #-----< id-UE-associatedLogicalE1-ConnectionListResAck >-----#
    id_UE_associatedLogicalE1_ConnectionListResAck = INT(name='id-UE-associatedLogicalE1-ConnectionListResAck', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_associatedLogicalE1_ConnectionListResAck._val = 6
    
    #-----< id-gNB-CU-UP-ID >-----#
    id_gNB_CU_UP_ID = INT(name='id-gNB-CU-UP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNB_CU_UP_ID._val = 7
    
    #-----< id-gNB-CU-UP-Name >-----#
    id_gNB_CU_UP_Name = INT(name='id-gNB-CU-UP-Name', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNB_CU_UP_Name._val = 8
    
    #-----< id-gNB-CU-CP-Name >-----#
    id_gNB_CU_CP_Name = INT(name='id-gNB-CU-CP-Name', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNB_CU_CP_Name._val = 9
    
    #-----< id-CNSupport >-----#
    id_CNSupport = INT(name='id-CNSupport', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CNSupport._val = 10
    
    #-----< id-SupportedPLMNs >-----#
    id_SupportedPLMNs = INT(name='id-SupportedPLMNs', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SupportedPLMNs._val = 11
    
    #-----< id-TimeToWait >-----#
    id_TimeToWait = INT(name='id-TimeToWait', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeToWait._val = 12
    
    #-----< id-SecurityInformation >-----#
    id_SecurityInformation = INT(name='id-SecurityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecurityInformation._val = 13
    
    #-----< id-UEDLAggregateMaximumBitRate >-----#
    id_UEDLAggregateMaximumBitRate = INT(name='id-UEDLAggregateMaximumBitRate', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEDLAggregateMaximumBitRate._val = 14
    
    #-----< id-System-BearerContextSetupRequest >-----#
    id_System_BearerContextSetupRequest = INT(name='id-System-BearerContextSetupRequest', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_System_BearerContextSetupRequest._val = 15
    
    #-----< id-System-BearerContextSetupResponse >-----#
    id_System_BearerContextSetupResponse = INT(name='id-System-BearerContextSetupResponse', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_System_BearerContextSetupResponse._val = 16
    
    #-----< id-BearerContextStatusChange >-----#
    id_BearerContextStatusChange = INT(name='id-BearerContextStatusChange', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BearerContextStatusChange._val = 17
    
    #-----< id-System-BearerContextModificationRequest >-----#
    id_System_BearerContextModificationRequest = INT(name='id-System-BearerContextModificationRequest', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_System_BearerContextModificationRequest._val = 18
    
    #-----< id-System-BearerContextModificationResponse >-----#
    id_System_BearerContextModificationResponse = INT(name='id-System-BearerContextModificationResponse', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_System_BearerContextModificationResponse._val = 19
    
    #-----< id-System-BearerContextModificationConfirm >-----#
    id_System_BearerContextModificationConfirm = INT(name='id-System-BearerContextModificationConfirm', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_System_BearerContextModificationConfirm._val = 20
    
    #-----< id-System-BearerContextModificationRequired >-----#
    id_System_BearerContextModificationRequired = INT(name='id-System-BearerContextModificationRequired', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_System_BearerContextModificationRequired._val = 21
    
    #-----< id-DRB-Status-List >-----#
    id_DRB_Status_List = INT(name='id-DRB-Status-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_Status_List._val = 22
    
    #-----< id-ActivityNotificationLevel >-----#
    id_ActivityNotificationLevel = INT(name='id-ActivityNotificationLevel', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ActivityNotificationLevel._val = 23
    
    #-----< id-ActivityInformation >-----#
    id_ActivityInformation = INT(name='id-ActivityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ActivityInformation._val = 24
    
    #-----< id-Data-Usage-Report-List >-----#
    id_Data_Usage_Report_List = INT(name='id-Data-Usage-Report-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Data_Usage_Report_List._val = 25
    
    #-----< id-New-UL-TNL-Information-Required >-----#
    id_New_UL_TNL_Information_Required = INT(name='id-New-UL-TNL-Information-Required', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_New_UL_TNL_Information_Required._val = 26
    
    #-----< id-GNB-CU-CP-TNLA-To-Add-List >-----#
    id_GNB_CU_CP_TNLA_To_Add_List = INT(name='id-GNB-CU-CP-TNLA-To-Add-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_CP_TNLA_To_Add_List._val = 27
    
    #-----< id-GNB-CU-CP-TNLA-To-Remove-List >-----#
    id_GNB_CU_CP_TNLA_To_Remove_List = INT(name='id-GNB-CU-CP-TNLA-To-Remove-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_CP_TNLA_To_Remove_List._val = 28
    
    #-----< id-GNB-CU-CP-TNLA-To-Update-List >-----#
    id_GNB_CU_CP_TNLA_To_Update_List = INT(name='id-GNB-CU-CP-TNLA-To-Update-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_CP_TNLA_To_Update_List._val = 29
    
    #-----< id-GNB-CU-CP-TNLA-Setup-List >-----#
    id_GNB_CU_CP_TNLA_Setup_List = INT(name='id-GNB-CU-CP-TNLA-Setup-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_CP_TNLA_Setup_List._val = 30
    
    #-----< id-GNB-CU-CP-TNLA-Failed-To-Setup-List >-----#
    id_GNB_CU_CP_TNLA_Failed_To_Setup_List = INT(name='id-GNB-CU-CP-TNLA-Failed-To-Setup-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_CP_TNLA_Failed_To_Setup_List._val = 31
    
    #-----< id-DRB-To-Setup-List-EUTRAN >-----#
    id_DRB_To_Setup_List_EUTRAN = INT(name='id-DRB-To-Setup-List-EUTRAN', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_To_Setup_List_EUTRAN._val = 32
    
    #-----< id-DRB-To-Modify-List-EUTRAN >-----#
    id_DRB_To_Modify_List_EUTRAN = INT(name='id-DRB-To-Modify-List-EUTRAN', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_To_Modify_List_EUTRAN._val = 33
    
    #-----< id-DRB-To-Remove-List-EUTRAN >-----#
    id_DRB_To_Remove_List_EUTRAN = INT(name='id-DRB-To-Remove-List-EUTRAN', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_To_Remove_List_EUTRAN._val = 34
    
    #-----< id-DRB-Required-To-Modify-List-EUTRAN >-----#
    id_DRB_Required_To_Modify_List_EUTRAN = INT(name='id-DRB-Required-To-Modify-List-EUTRAN', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_Required_To_Modify_List_EUTRAN._val = 35
    
    #-----< id-DRB-Required-To-Remove-List-EUTRAN >-----#
    id_DRB_Required_To_Remove_List_EUTRAN = INT(name='id-DRB-Required-To-Remove-List-EUTRAN', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_Required_To_Remove_List_EUTRAN._val = 36
    
    #-----< id-DRB-Setup-List-EUTRAN >-----#
    id_DRB_Setup_List_EUTRAN = INT(name='id-DRB-Setup-List-EUTRAN', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_Setup_List_EUTRAN._val = 37
    
    #-----< id-DRB-Failed-List-EUTRAN >-----#
    id_DRB_Failed_List_EUTRAN = INT(name='id-DRB-Failed-List-EUTRAN', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_Failed_List_EUTRAN._val = 38
    
    #-----< id-DRB-Modified-List-EUTRAN >-----#
    id_DRB_Modified_List_EUTRAN = INT(name='id-DRB-Modified-List-EUTRAN', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_Modified_List_EUTRAN._val = 39
    
    #-----< id-DRB-Failed-To-Modify-List-EUTRAN >-----#
    id_DRB_Failed_To_Modify_List_EUTRAN = INT(name='id-DRB-Failed-To-Modify-List-EUTRAN', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_Failed_To_Modify_List_EUTRAN._val = 40
    
    #-----< id-DRB-Confirm-Modified-List-EUTRAN >-----#
    id_DRB_Confirm_Modified_List_EUTRAN = INT(name='id-DRB-Confirm-Modified-List-EUTRAN', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_Confirm_Modified_List_EUTRAN._val = 41
    
    #-----< id-PDU-Session-Resource-To-Setup-List >-----#
    id_PDU_Session_Resource_To_Setup_List = INT(name='id-PDU-Session-Resource-To-Setup-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDU_Session_Resource_To_Setup_List._val = 42
    
    #-----< id-PDU-Session-Resource-To-Modify-List >-----#
    id_PDU_Session_Resource_To_Modify_List = INT(name='id-PDU-Session-Resource-To-Modify-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDU_Session_Resource_To_Modify_List._val = 43
    
    #-----< id-PDU-Session-Resource-To-Remove-List >-----#
    id_PDU_Session_Resource_To_Remove_List = INT(name='id-PDU-Session-Resource-To-Remove-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDU_Session_Resource_To_Remove_List._val = 44
    
    #-----< id-PDU-Session-Resource-Required-To-Modify-List >-----#
    id_PDU_Session_Resource_Required_To_Modify_List = INT(name='id-PDU-Session-Resource-Required-To-Modify-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDU_Session_Resource_Required_To_Modify_List._val = 45
    
    #-----< id-PDU-Session-Resource-Setup-List >-----#
    id_PDU_Session_Resource_Setup_List = INT(name='id-PDU-Session-Resource-Setup-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDU_Session_Resource_Setup_List._val = 46
    
    #-----< id-PDU-Session-Resource-Failed-List >-----#
    id_PDU_Session_Resource_Failed_List = INT(name='id-PDU-Session-Resource-Failed-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDU_Session_Resource_Failed_List._val = 47
    
    #-----< id-PDU-Session-Resource-Modified-List >-----#
    id_PDU_Session_Resource_Modified_List = INT(name='id-PDU-Session-Resource-Modified-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDU_Session_Resource_Modified_List._val = 48
    
    #-----< id-PDU-Session-Resource-Failed-To-Modify-List >-----#
    id_PDU_Session_Resource_Failed_To_Modify_List = INT(name='id-PDU-Session-Resource-Failed-To-Modify-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDU_Session_Resource_Failed_To_Modify_List._val = 49
    
    #-----< id-PDU-Session-Resource-Confirm-Modified-List >-----#
    id_PDU_Session_Resource_Confirm_Modified_List = INT(name='id-PDU-Session-Resource-Confirm-Modified-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDU_Session_Resource_Confirm_Modified_List._val = 50
    
    #-----< id-DRB-To-Setup-Mod-List-EUTRAN >-----#
    id_DRB_To_Setup_Mod_List_EUTRAN = INT(name='id-DRB-To-Setup-Mod-List-EUTRAN', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_To_Setup_Mod_List_EUTRAN._val = 51
    
    #-----< id-DRB-Setup-Mod-List-EUTRAN >-----#
    id_DRB_Setup_Mod_List_EUTRAN = INT(name='id-DRB-Setup-Mod-List-EUTRAN', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_Setup_Mod_List_EUTRAN._val = 52
    
    #-----< id-DRB-Failed-Mod-List-EUTRAN >-----#
    id_DRB_Failed_Mod_List_EUTRAN = INT(name='id-DRB-Failed-Mod-List-EUTRAN', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_Failed_Mod_List_EUTRAN._val = 53
    
    #-----< id-PDU-Session-Resource-Setup-Mod-List >-----#
    id_PDU_Session_Resource_Setup_Mod_List = INT(name='id-PDU-Session-Resource-Setup-Mod-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDU_Session_Resource_Setup_Mod_List._val = 54
    
    #-----< id-PDU-Session-Resource-Failed-Mod-List >-----#
    id_PDU_Session_Resource_Failed_Mod_List = INT(name='id-PDU-Session-Resource-Failed-Mod-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDU_Session_Resource_Failed_Mod_List._val = 55
    
    #-----< id-PDU-Session-Resource-To-Setup-Mod-List >-----#
    id_PDU_Session_Resource_To_Setup_Mod_List = INT(name='id-PDU-Session-Resource-To-Setup-Mod-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDU_Session_Resource_To_Setup_Mod_List._val = 56
    
    #-----< id-TransactionID >-----#
    id_TransactionID = INT(name='id-TransactionID', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransactionID._val = 57
    
    #-----< id-Serving-PLMN >-----#
    id_Serving_PLMN = INT(name='id-Serving-PLMN', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Serving_PLMN._val = 58
    
    #-----< id-UE-Inactivity-Timer >-----#
    id_UE_Inactivity_Timer = INT(name='id-UE-Inactivity-Timer', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_Inactivity_Timer._val = 59
    
    #-----< id-System-GNB-CU-UP-CounterCheckRequest >-----#
    id_System_GNB_CU_UP_CounterCheckRequest = INT(name='id-System-GNB-CU-UP-CounterCheckRequest', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_System_GNB_CU_UP_CounterCheckRequest._val = 60
    
    #-----< id-DRBs-Subject-To-Counter-Check-List-EUTRAN >-----#
    id_DRBs_Subject_To_Counter_Check_List_EUTRAN = INT(name='id-DRBs-Subject-To-Counter-Check-List-EUTRAN', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_Subject_To_Counter_Check_List_EUTRAN._val = 61
    
    #-----< id-DRBs-Subject-To-Counter-Check-List-NG-RAN >-----#
    id_DRBs_Subject_To_Counter_Check_List_NG_RAN = INT(name='id-DRBs-Subject-To-Counter-Check-List-NG-RAN', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_Subject_To_Counter_Check_List_NG_RAN._val = 62
    
    #-----< id-PPI >-----#
    id_PPI = INT(name='id-PPI', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PPI._val = 63
    
    #-----< id-gNB-CU-UP-Capacity >-----#
    id_gNB_CU_UP_Capacity = INT(name='id-gNB-CU-UP-Capacity', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNB_CU_UP_Capacity._val = 64
    
    #-----< id-GNB-CU-UP-OverloadInformation >-----#
    id_GNB_CU_UP_OverloadInformation = INT(name='id-GNB-CU-UP-OverloadInformation', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_UP_OverloadInformation._val = 65
    
    #-----< id-UEDLMaximumIntegrityProtectedDataRate >-----#
    id_UEDLMaximumIntegrityProtectedDataRate = INT(name='id-UEDLMaximumIntegrityProtectedDataRate', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEDLMaximumIntegrityProtectedDataRate._val = 66
    
    #-----< id-PDU-Session-To-Notify-List >-----#
    id_PDU_Session_To_Notify_List = INT(name='id-PDU-Session-To-Notify-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDU_Session_To_Notify_List._val = 67
    
    #-----< id-PDU-Session-Resource-Data-Usage-List >-----#
    id_PDU_Session_Resource_Data_Usage_List = INT(name='id-PDU-Session-Resource-Data-Usage-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDU_Session_Resource_Data_Usage_List._val = 68
    
    #-----< id-SNSSAI >-----#
    id_SNSSAI = INT(name='id-SNSSAI', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SNSSAI._val = 69
    
    #-----< id-DataDiscardRequired >-----#
    id_DataDiscardRequired = INT(name='id-DataDiscardRequired', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DataDiscardRequired._val = 70
    
    #-----< id-OldQoSFlowMap-ULendmarkerexpected >-----#
    id_OldQoSFlowMap_ULendmarkerexpected = INT(name='id-OldQoSFlowMap-ULendmarkerexpected', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_OldQoSFlowMap_ULendmarkerexpected._val = 71
    
    #-----< id-DRB-QoS >-----#
    id_DRB_QoS = INT(name='id-DRB-QoS', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_QoS._val = 72
    
    #-----< id-GNB-CU-UP-TNLA-To-Remove-List >-----#
    id_GNB_CU_UP_TNLA_To_Remove_List = INT(name='id-GNB-CU-UP-TNLA-To-Remove-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_UP_TNLA_To_Remove_List._val = 73
    
    #-----< id-endpoint-IP-Address-and-Port >-----#
    id_endpoint_IP_Address_and_Port = INT(name='id-endpoint-IP-Address-and-Port', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_endpoint_IP_Address_and_Port._val = 74
    
    #-----< id-TNLAssociationTransportLayerAddressgNBCUUP >-----#
    id_TNLAssociationTransportLayerAddressgNBCUUP = INT(name='id-TNLAssociationTransportLayerAddressgNBCUUP', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TNLAssociationTransportLayerAddressgNBCUUP._val = 75
    
    #-----< id-RANUEID >-----#
    id_RANUEID = INT(name='id-RANUEID', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RANUEID._val = 76
    
    #-----< id-GNB-DU-ID >-----#
    id_GNB_DU_ID = INT(name='id-GNB-DU-ID', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_DU_ID._val = 77
    
    #-----< id-CommonNetworkInstance >-----#
    id_CommonNetworkInstance = INT(name='id-CommonNetworkInstance', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CommonNetworkInstance._val = 78
    
    #-----< id-NetworkInstance >-----#
    id_NetworkInstance = INT(name='id-NetworkInstance', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NetworkInstance._val = 79
    
    #-----< id-QoSFlowMappingIndication >-----#
    id_QoSFlowMappingIndication = INT(name='id-QoSFlowMappingIndication', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QoSFlowMappingIndication._val = 80
    
    #-----< id-TraceActivation >-----#
    id_TraceActivation = INT(name='id-TraceActivation', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceActivation._val = 81
    
    #-----< id-TraceID >-----#
    id_TraceID = INT(name='id-TraceID', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceID._val = 82
    
    #-----< id-SubscriberProfileIDforRFP >-----#
    id_SubscriberProfileIDforRFP = INT(name='id-SubscriberProfileIDforRFP', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SubscriberProfileIDforRFP._val = 83
    
    #-----< id-AdditionalRRMPriorityIndex >-----#
    id_AdditionalRRMPriorityIndex = INT(name='id-AdditionalRRMPriorityIndex', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalRRMPriorityIndex._val = 84
    
    #-----< id-RetainabilityMeasurementsInfo >-----#
    id_RetainabilityMeasurementsInfo = INT(name='id-RetainabilityMeasurementsInfo', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RetainabilityMeasurementsInfo._val = 85
    
    #-----< id-Transport-Layer-Address-Info >-----#
    id_Transport_Layer_Address_Info = INT(name='id-Transport-Layer-Address-Info', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Transport_Layer_Address_Info._val = 86
    
    #-----< id-QoSMonitoringRequest >-----#
    id_QoSMonitoringRequest = INT(name='id-QoSMonitoringRequest', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QoSMonitoringRequest._val = 87
    
    #-----< id-PDCP-StatusReportIndication >-----#
    id_PDCP_StatusReportIndication = INT(name='id-PDCP-StatusReportIndication', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDCP_StatusReportIndication._val = 88
    
    #-----< id-gNB-CU-CP-Measurement-ID >-----#
    id_gNB_CU_CP_Measurement_ID = INT(name='id-gNB-CU-CP-Measurement-ID', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNB_CU_CP_Measurement_ID._val = 89
    
    #-----< id-gNB-CU-UP-Measurement-ID >-----#
    id_gNB_CU_UP_Measurement_ID = INT(name='id-gNB-CU-UP-Measurement-ID', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNB_CU_UP_Measurement_ID._val = 90
    
    #-----< id-RegistrationRequest >-----#
    id_RegistrationRequest = INT(name='id-RegistrationRequest', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RegistrationRequest._val = 91
    
    #-----< id-ReportCharacteristics >-----#
    id_ReportCharacteristics = INT(name='id-ReportCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReportCharacteristics._val = 92
    
    #-----< id-ReportingPeriodicity >-----#
    id_ReportingPeriodicity = INT(name='id-ReportingPeriodicity', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReportingPeriodicity._val = 93
    
    #-----< id-TNL-AvailableCapacityIndicator >-----#
    id_TNL_AvailableCapacityIndicator = INT(name='id-TNL-AvailableCapacityIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TNL_AvailableCapacityIndicator._val = 94
    
    #-----< id-HW-CapacityIndicator >-----#
    id_HW_CapacityIndicator = INT(name='id-HW-CapacityIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HW_CapacityIndicator._val = 95
    
    #-----< id-RedundantCommonNetworkInstance >-----#
    id_RedundantCommonNetworkInstance = INT(name='id-RedundantCommonNetworkInstance', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RedundantCommonNetworkInstance._val = 96
    
    #-----< id-redundant-nG-UL-UP-TNL-Information >-----#
    id_redundant_nG_UL_UP_TNL_Information = INT(name='id-redundant-nG-UL-UP-TNL-Information', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_redundant_nG_UL_UP_TNL_Information._val = 97
    
    #-----< id-redundant-nG-DL-UP-TNL-Information >-----#
    id_redundant_nG_DL_UP_TNL_Information = INT(name='id-redundant-nG-DL-UP-TNL-Information', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_redundant_nG_DL_UP_TNL_Information._val = 98
    
    #-----< id-RedundantQosFlowIndicator >-----#
    id_RedundantQosFlowIndicator = INT(name='id-RedundantQosFlowIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RedundantQosFlowIndicator._val = 99
    
    #-----< id-TSCTrafficCharacteristics >-----#
    id_TSCTrafficCharacteristics = INT(name='id-TSCTrafficCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TSCTrafficCharacteristics._val = 100
    
    #-----< id-CNPacketDelayBudgetDownlink >-----#
    id_CNPacketDelayBudgetDownlink = INT(name='id-CNPacketDelayBudgetDownlink', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CNPacketDelayBudgetDownlink._val = 101
    
    #-----< id-CNPacketDelayBudgetUplink >-----#
    id_CNPacketDelayBudgetUplink = INT(name='id-CNPacketDelayBudgetUplink', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CNPacketDelayBudgetUplink._val = 102
    
    #-----< id-ExtendedPacketDelayBudget >-----#
    id_ExtendedPacketDelayBudget = INT(name='id-ExtendedPacketDelayBudget', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedPacketDelayBudget._val = 103
    
    #-----< id-AdditionalPDCPduplicationInformation >-----#
    id_AdditionalPDCPduplicationInformation = INT(name='id-AdditionalPDCPduplicationInformation', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalPDCPduplicationInformation._val = 104
    
    #-----< id-RedundantPDUSessionInformation >-----#
    id_RedundantPDUSessionInformation = INT(name='id-RedundantPDUSessionInformation', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RedundantPDUSessionInformation._val = 105
    
    #-----< id-RedundantPDUSessionInformation-used >-----#
    id_RedundantPDUSessionInformation_used = INT(name='id-RedundantPDUSessionInformation-used', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RedundantPDUSessionInformation_used._val = 106
    
    #-----< id-QoS-Mapping-Information >-----#
    id_QoS_Mapping_Information = INT(name='id-QoS-Mapping-Information', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QoS_Mapping_Information._val = 107
    
    #-----< id-DLUPTNLAddressToUpdateList >-----#
    id_DLUPTNLAddressToUpdateList = INT(name='id-DLUPTNLAddressToUpdateList', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DLUPTNLAddressToUpdateList._val = 108
    
    #-----< id-ULUPTNLAddressToUpdateList >-----#
    id_ULUPTNLAddressToUpdateList = INT(name='id-ULUPTNLAddressToUpdateList', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ULUPTNLAddressToUpdateList._val = 109
    
    #-----< id-NPNSupportInfo >-----#
    id_NPNSupportInfo = INT(name='id-NPNSupportInfo', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NPNSupportInfo._val = 110
    
    #-----< id-NPNContextInfo >-----#
    id_NPNContextInfo = INT(name='id-NPNContextInfo', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NPNContextInfo._val = 111
    
    #-----< id-MDTConfiguration >-----#
    id_MDTConfiguration = INT(name='id-MDTConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MDTConfiguration._val = 112
    
    #-----< id-ManagementBasedMDTPLMNList >-----#
    id_ManagementBasedMDTPLMNList = INT(name='id-ManagementBasedMDTPLMNList', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ManagementBasedMDTPLMNList._val = 113
    
    #-----< id-TraceCollectionEntityIPAddress >-----#
    id_TraceCollectionEntityIPAddress = INT(name='id-TraceCollectionEntityIPAddress', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceCollectionEntityIPAddress._val = 114
    
    #-----< id-PrivacyIndicator >-----#
    id_PrivacyIndicator = INT(name='id-PrivacyIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PrivacyIndicator._val = 115
    
    #-----< id-TraceCollectionEntityURI >-----#
    id_TraceCollectionEntityURI = INT(name='id-TraceCollectionEntityURI', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceCollectionEntityURI._val = 116
    
    #-----< id-URIaddress >-----#
    id_URIaddress = INT(name='id-URIaddress', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_URIaddress._val = 117
    
    #-----< id-EHC-Parameters >-----#
    id_EHC_Parameters = INT(name='id-EHC-Parameters', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EHC_Parameters._val = 118
    
    #-----< id-DRBs-Subject-To-Early-Forwarding-List >-----#
    id_DRBs_Subject_To_Early_Forwarding_List = INT(name='id-DRBs-Subject-To-Early-Forwarding-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_Subject_To_Early_Forwarding_List._val = 119
    
    #-----< id-DAPSRequestInfo >-----#
    id_DAPSRequestInfo = INT(name='id-DAPSRequestInfo', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DAPSRequestInfo._val = 120
    
    #-----< id-CHOInitiation >-----#
    id_CHOInitiation = INT(name='id-CHOInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CHOInitiation._val = 121
    
    #-----< id-EarlyForwardingCOUNTReq >-----#
    id_EarlyForwardingCOUNTReq = INT(name='id-EarlyForwardingCOUNTReq', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EarlyForwardingCOUNTReq._val = 122
    
    #-----< id-EarlyForwardingCOUNTInfo >-----#
    id_EarlyForwardingCOUNTInfo = INT(name='id-EarlyForwardingCOUNTInfo', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EarlyForwardingCOUNTInfo._val = 123
    
    #-----< id-AlternativeQoSParaSetList >-----#
    id_AlternativeQoSParaSetList = INT(name='id-AlternativeQoSParaSetList', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AlternativeQoSParaSetList._val = 124
    
    #-----< id-ExtendedSliceSupportList >-----#
    id_ExtendedSliceSupportList = INT(name='id-ExtendedSliceSupportList', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedSliceSupportList._val = 125
    
    #-----< id-MCG-OfferedGBRQoSFlowInfo >-----#
    id_MCG_OfferedGBRQoSFlowInfo = INT(name='id-MCG-OfferedGBRQoSFlowInfo', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MCG_OfferedGBRQoSFlowInfo._val = 126
    
    #-----< id-Number-of-tunnels >-----#
    id_Number_of_tunnels = INT(name='id-Number-of-tunnels', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Number_of_tunnels._val = 127
    
    #-----< id-DRB-Measurement-Results-Information-List >-----#
    id_DRB_Measurement_Results_Information_List = INT(name='id-DRB-Measurement-Results-Information-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_Measurement_Results_Information_List._val = 128
    
    #-----< id-Extended-GNB-CU-CP-Name >-----#
    id_Extended_GNB_CU_CP_Name = INT(name='id-Extended-GNB-CU-CP-Name', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_GNB_CU_CP_Name._val = 129
    
    #-----< id-Extended-GNB-CU-UP-Name >-----#
    id_Extended_GNB_CU_UP_Name = INT(name='id-Extended-GNB-CU-UP-Name', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_GNB_CU_UP_Name._val = 130
    
    #-----< id-DataForwardingtoE-UTRANInformationList >-----#
    id_DataForwardingtoE_UTRANInformationList = INT(name='id-DataForwardingtoE-UTRANInformationList', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DataForwardingtoE_UTRANInformationList._val = 131
    
    #-----< id-QosMonitoringReportingFrequency >-----#
    id_QosMonitoringReportingFrequency = INT(name='id-QosMonitoringReportingFrequency', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QosMonitoringReportingFrequency._val = 132
    
    #-----< id-QoSMonitoringDisabled >-----#
    id_QoSMonitoringDisabled = INT(name='id-QoSMonitoringDisabled', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QoSMonitoringDisabled._val = 133
    
    #-----< id-AdditionalHandoverInfo >-----#
    id_AdditionalHandoverInfo = INT(name='id-AdditionalHandoverInfo', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalHandoverInfo._val = 134
    
    #-----< id-Extended-NR-CGI-Support-List >-----#
    id_Extended_NR_CGI_Support_List = INT(name='id-Extended-NR-CGI-Support-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_NR_CGI_Support_List._val = 135
    
    #-----< id-DataForwardingtoNG-RANQoSFlowInformationList >-----#
    id_DataForwardingtoNG_RANQoSFlowInformationList = INT(name='id-DataForwardingtoNG-RANQoSFlowInformationList', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DataForwardingtoNG_RANQoSFlowInformationList._val = 136
    
    #-----< id-MaxCIDEHCDL >-----#
    id_MaxCIDEHCDL = INT(name='id-MaxCIDEHCDL', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MaxCIDEHCDL._val = 137
    
    #-----< id-ignoreMappingRuleIndication >-----#
    id_ignoreMappingRuleIndication = INT(name='id-ignoreMappingRuleIndication', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ignoreMappingRuleIndication._val = 138
    
    #-----< id-DirectForwardingPathAvailability >-----#
    id_DirectForwardingPathAvailability = INT(name='id-DirectForwardingPathAvailability', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DirectForwardingPathAvailability._val = 139
    
    #-----< id-EarlyDataForwardingIndicator >-----#
    id_EarlyDataForwardingIndicator = INT(name='id-EarlyDataForwardingIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EarlyDataForwardingIndicator._val = 140
    
    #-----< id-QoSFlowsDRBRemapping >-----#
    id_QoSFlowsDRBRemapping = INT(name='id-QoSFlowsDRBRemapping', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QoSFlowsDRBRemapping._val = 141
    
    #-----< id-DataForwardingSourceIPAddress >-----#
    id_DataForwardingSourceIPAddress = INT(name='id-DataForwardingSourceIPAddress', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DataForwardingSourceIPAddress._val = 142
    
    #-----< id-SecurityIndicationModify >-----#
    id_SecurityIndicationModify = INT(name='id-SecurityIndicationModify', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecurityIndicationModify._val = 143
    
    #-----< id-IAB-Donor-CU-UPPSKInfo >-----#
    id_IAB_Donor_CU_UPPSKInfo = INT(name='id-IAB-Donor-CU-UPPSKInfo', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_Donor_CU_UPPSKInfo._val = 144
    
    #-----< id-ECGI-Support-List >-----#
    id_ECGI_Support_List = INT(name='id-ECGI-Support-List', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ECGI_Support_List._val = 145
    
    #-----< id-MDTPollutedMeasurementIndicator >-----#
    id_MDTPollutedMeasurementIndicator = INT(name='id-MDTPollutedMeasurementIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MDTPollutedMeasurementIndicator._val = 146
    
    #-----< id-M4ReportAmount >-----#
    id_M4ReportAmount = INT(name='id-M4ReportAmount', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M4ReportAmount._val = 147
    
    #-----< id-M6ReportAmount >-----#
    id_M6ReportAmount = INT(name='id-M6ReportAmount', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M6ReportAmount._val = 148
    
    #-----< id-M7ReportAmount >-----#
    id_M7ReportAmount = INT(name='id-M7ReportAmount', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M7ReportAmount._val = 149
    
    #-----< id-UESliceMaximumBitRateList >-----#
    id_UESliceMaximumBitRateList = INT(name='id-UESliceMaximumBitRateList', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UESliceMaximumBitRateList._val = 150
    
    #-----< id-PDUSession-PairID >-----#
    id_PDUSession_PairID = INT(name='id-PDUSession-PairID', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSession_PairID._val = 151
    
    #-----< id-SurvivalTime >-----#
    id_SurvivalTime = INT(name='id-SurvivalTime', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SurvivalTime._val = 152
    
    #-----< id-UDC-Parameters >-----#
    id_UDC_Parameters = INT(name='id-UDC-Parameters', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UDC_Parameters._val = 153
    
    #-----< id-SCGActivationStatus >-----#
    id_SCGActivationStatus = INT(name='id-SCGActivationStatus', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCGActivationStatus._val = 154
    
    #-----< id-GNB-CU-CP-MBS-E1AP-ID >-----#
    id_GNB_CU_CP_MBS_E1AP_ID = INT(name='id-GNB-CU-CP-MBS-E1AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_CP_MBS_E1AP_ID._val = 155
    
    #-----< id-GNB-CU-UP-MBS-E1AP-ID >-----#
    id_GNB_CU_UP_MBS_E1AP_ID = INT(name='id-GNB-CU-UP-MBS-E1AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_UP_MBS_E1AP_ID._val = 156
    
    #-----< id-GlobalMBSSessionID >-----#
    id_GlobalMBSSessionID = INT(name='id-GlobalMBSSessionID', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GlobalMBSSessionID._val = 157
    
    #-----< id-BCBearerContextToSetup >-----#
    id_BCBearerContextToSetup = INT(name='id-BCBearerContextToSetup', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BCBearerContextToSetup._val = 158
    
    #-----< id-BCBearerContextToSetupResponse >-----#
    id_BCBearerContextToSetupResponse = INT(name='id-BCBearerContextToSetupResponse', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BCBearerContextToSetupResponse._val = 159
    
    #-----< id-BCBearerContextToModify >-----#
    id_BCBearerContextToModify = INT(name='id-BCBearerContextToModify', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BCBearerContextToModify._val = 160
    
    #-----< id-BCBearerContextToModifyResponse >-----#
    id_BCBearerContextToModifyResponse = INT(name='id-BCBearerContextToModifyResponse', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BCBearerContextToModifyResponse._val = 161
    
    #-----< id-BCBearerContextToModifyRequired >-----#
    id_BCBearerContextToModifyRequired = INT(name='id-BCBearerContextToModifyRequired', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BCBearerContextToModifyRequired._val = 162
    
    #-----< id-BCBearerContextToModifyConfirm >-----#
    id_BCBearerContextToModifyConfirm = INT(name='id-BCBearerContextToModifyConfirm', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BCBearerContextToModifyConfirm._val = 163
    
    #-----< id-MCBearerContextToSetup >-----#
    id_MCBearerContextToSetup = INT(name='id-MCBearerContextToSetup', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MCBearerContextToSetup._val = 164
    
    #-----< id-MCBearerContextToSetupResponse >-----#
    id_MCBearerContextToSetupResponse = INT(name='id-MCBearerContextToSetupResponse', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MCBearerContextToSetupResponse._val = 165
    
    #-----< id-MCBearerContextToModify >-----#
    id_MCBearerContextToModify = INT(name='id-MCBearerContextToModify', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MCBearerContextToModify._val = 166
    
    #-----< id-MCBearerContextToModifyResponse >-----#
    id_MCBearerContextToModifyResponse = INT(name='id-MCBearerContextToModifyResponse', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MCBearerContextToModifyResponse._val = 167
    
    #-----< id-MCBearerContextToModifyRequired >-----#
    id_MCBearerContextToModifyRequired = INT(name='id-MCBearerContextToModifyRequired', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MCBearerContextToModifyRequired._val = 168
    
    #-----< id-MCBearerContextToModifyConfirm >-----#
    id_MCBearerContextToModifyConfirm = INT(name='id-MCBearerContextToModifyConfirm', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MCBearerContextToModifyConfirm._val = 169
    
    #-----< id-MBSMulticastF1UContextDescriptor >-----#
    id_MBSMulticastF1UContextDescriptor = INT(name='id-MBSMulticastF1UContextDescriptor', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSMulticastF1UContextDescriptor._val = 170
    
    #-----< id-gNB-CU-UP-MBS-Support-Info >-----#
    id_gNB_CU_UP_MBS_Support_Info = INT(name='id-gNB-CU-UP-MBS-Support-Info', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNB_CU_UP_MBS_Support_Info._val = 171
    
    #-----< id-SecurityIndication >-----#
    id_SecurityIndication = INT(name='id-SecurityIndication', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecurityIndication._val = 172
    
    #-----< id-SecurityResult >-----#
    id_SecurityResult = INT(name='id-SecurityResult', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecurityResult._val = 173
    
    #-----< id-SDTContinueROHC >-----#
    id_SDTContinueROHC = INT(name='id-SDTContinueROHC', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SDTContinueROHC._val = 174
    
    #-----< id-SDTindicatorSetup >-----#
    id_SDTindicatorSetup = INT(name='id-SDTindicatorSetup', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SDTindicatorSetup._val = 175
    
    #-----< id-SDTindicatorMod >-----#
    id_SDTindicatorMod = INT(name='id-SDTindicatorMod', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SDTindicatorMod._val = 176
    
    #-----< id-DiscardTimerExtended >-----#
    id_DiscardTimerExtended = INT(name='id-DiscardTimerExtended', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DiscardTimerExtended._val = 177
    
    #-----< id-ManagementBasedMDTPLMNModificationList >-----#
    id_ManagementBasedMDTPLMNModificationList = INT(name='id-ManagementBasedMDTPLMNModificationList', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ManagementBasedMDTPLMNModificationList._val = 178
    
    #-----< id-MCForwardingResourceRequest >-----#
    id_MCForwardingResourceRequest = INT(name='id-MCForwardingResourceRequest', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MCForwardingResourceRequest._val = 179
    
    #-----< id-MCForwardingResourceIndication >-----#
    id_MCForwardingResourceIndication = INT(name='id-MCForwardingResourceIndication', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MCForwardingResourceIndication._val = 180
    
    #-----< id-MCForwardingResourceResponse >-----#
    id_MCForwardingResourceResponse = INT(name='id-MCForwardingResourceResponse', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MCForwardingResourceResponse._val = 181
    
    #-----< id-MCForwardingResourceRelease >-----#
    id_MCForwardingResourceRelease = INT(name='id-MCForwardingResourceRelease', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MCForwardingResourceRelease._val = 182
    
    #-----< id-MCForwardingResourceReleaseIndication >-----#
    id_MCForwardingResourceReleaseIndication = INT(name='id-MCForwardingResourceReleaseIndication', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MCForwardingResourceReleaseIndication._val = 183
    
    #-----< id-PDCP-COUNT-Reset >-----#
    id_PDCP_COUNT_Reset = INT(name='id-PDCP-COUNT-Reset', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDCP_COUNT_Reset._val = 184
    
    #-----< id-MBSSessionAssociatedInfoNonSupportToSupport >-----#
    id_MBSSessionAssociatedInfoNonSupportToSupport = INT(name='id-MBSSessionAssociatedInfoNonSupportToSupport', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSSessionAssociatedInfoNonSupportToSupport._val = 185
    
    _all_ = [
        id_reset,
        id_errorIndication,
        id_privateMessage,
        id_gNB_CU_UP_E1Setup,
        id_gNB_CU_CP_E1Setup,
        id_gNB_CU_UP_ConfigurationUpdate,
        id_gNB_CU_CP_ConfigurationUpdate,
        id_e1Release,
        id_bearerContextSetup,
        id_bearerContextModification,
        id_bearerContextModificationRequired,
        id_bearerContextRelease,
        id_bearerContextReleaseRequest,
        id_bearerContextInactivityNotification,
        id_dLDataNotification,
        id_dataUsageReport,
        id_gNB_CU_UP_CounterCheck,
        id_gNB_CU_UP_StatusIndication,
        id_uLDataNotification,
        id_mRDC_DataUsageReport,
        id_TraceStart,
        id_DeactivateTrace,
        id_resourceStatusReportingInitiation,
        id_resourceStatusReporting,
        id_iAB_UPTNLAddressUpdate,
        id_CellTrafficTrace,
        id_earlyForwardingSNTransfer,
        id_gNB_CU_CPMeasurementResultsInformation,
        id_iABPSKNotification,
        id_BCBearerContextSetup,
        id_BCBearerContextModification,
        id_BCBearerContextModificationRequired,
        id_BCBearerContextRelease,
        id_BCBearerContextReleaseRequest,
        id_MCBearerContextSetup,
        id_MCBearerContextModification,
        id_MCBearerContextModificationRequired,
        id_MCBearerContextRelease,
        id_MCBearerContextReleaseRequest,
        maxnoofErrors,
        maxnoofSPLMNs,
        maxnoofSliceItems,
        maxnoofIndividualE1ConnectionsToReset,
        maxnoofEUTRANQOSParameters,
        maxnoofNGRANQOSParameters,
        maxnoofDRBs,
        maxnoofNRCGI,
        maxnoofPDUSessionResource,
        maxnoofQoSFlows,
        maxnoofUPParameters,
        maxnoofCellGroups,
        maxnooftimeperiods,
        maxnoofTNLAssociations,
        maxnoofTLAs,
        maxnoofGTPTLAs,
        maxnoofTNLAddresses,
        maxnoofMDTPLMNs,
        maxnoofQoSParaSets,
        maxnoofExtSliceItems,
        maxnoofDataForwardingTunneltoE_UTRAN,
        maxnoofExtNRCGI,
        maxnoofPSKs,
        maxnoofECGI,
        maxnoofSMBRValues,
        maxnoofMBSAreaSessionIDs,
        maxnoofSharedNG_UTerminations,
        maxnoofMRBs,
        maxnoofMBSSessionIDs,
        id_Cause,
        id_CriticalityDiagnostics,
        id_gNB_CU_CP_UE_E1AP_ID,
        id_gNB_CU_UP_UE_E1AP_ID,
        id_ResetType,
        id_UE_associatedLogicalE1_ConnectionItem,
        id_UE_associatedLogicalE1_ConnectionListResAck,
        id_gNB_CU_UP_ID,
        id_gNB_CU_UP_Name,
        id_gNB_CU_CP_Name,
        id_CNSupport,
        id_SupportedPLMNs,
        id_TimeToWait,
        id_SecurityInformation,
        id_UEDLAggregateMaximumBitRate,
        id_System_BearerContextSetupRequest,
        id_System_BearerContextSetupResponse,
        id_BearerContextStatusChange,
        id_System_BearerContextModificationRequest,
        id_System_BearerContextModificationResponse,
        id_System_BearerContextModificationConfirm,
        id_System_BearerContextModificationRequired,
        id_DRB_Status_List,
        id_ActivityNotificationLevel,
        id_ActivityInformation,
        id_Data_Usage_Report_List,
        id_New_UL_TNL_Information_Required,
        id_GNB_CU_CP_TNLA_To_Add_List,
        id_GNB_CU_CP_TNLA_To_Remove_List,
        id_GNB_CU_CP_TNLA_To_Update_List,
        id_GNB_CU_CP_TNLA_Setup_List,
        id_GNB_CU_CP_TNLA_Failed_To_Setup_List,
        id_DRB_To_Setup_List_EUTRAN,
        id_DRB_To_Modify_List_EUTRAN,
        id_DRB_To_Remove_List_EUTRAN,
        id_DRB_Required_To_Modify_List_EUTRAN,
        id_DRB_Required_To_Remove_List_EUTRAN,
        id_DRB_Setup_List_EUTRAN,
        id_DRB_Failed_List_EUTRAN,
        id_DRB_Modified_List_EUTRAN,
        id_DRB_Failed_To_Modify_List_EUTRAN,
        id_DRB_Confirm_Modified_List_EUTRAN,
        id_PDU_Session_Resource_To_Setup_List,
        id_PDU_Session_Resource_To_Modify_List,
        id_PDU_Session_Resource_To_Remove_List,
        id_PDU_Session_Resource_Required_To_Modify_List,
        id_PDU_Session_Resource_Setup_List,
        id_PDU_Session_Resource_Failed_List,
        id_PDU_Session_Resource_Modified_List,
        id_PDU_Session_Resource_Failed_To_Modify_List,
        id_PDU_Session_Resource_Confirm_Modified_List,
        id_DRB_To_Setup_Mod_List_EUTRAN,
        id_DRB_Setup_Mod_List_EUTRAN,
        id_DRB_Failed_Mod_List_EUTRAN,
        id_PDU_Session_Resource_Setup_Mod_List,
        id_PDU_Session_Resource_Failed_Mod_List,
        id_PDU_Session_Resource_To_Setup_Mod_List,
        id_TransactionID,
        id_Serving_PLMN,
        id_UE_Inactivity_Timer,
        id_System_GNB_CU_UP_CounterCheckRequest,
        id_DRBs_Subject_To_Counter_Check_List_EUTRAN,
        id_DRBs_Subject_To_Counter_Check_List_NG_RAN,
        id_PPI,
        id_gNB_CU_UP_Capacity,
        id_GNB_CU_UP_OverloadInformation,
        id_UEDLMaximumIntegrityProtectedDataRate,
        id_PDU_Session_To_Notify_List,
        id_PDU_Session_Resource_Data_Usage_List,
        id_SNSSAI,
        id_DataDiscardRequired,
        id_OldQoSFlowMap_ULendmarkerexpected,
        id_DRB_QoS,
        id_GNB_CU_UP_TNLA_To_Remove_List,
        id_endpoint_IP_Address_and_Port,
        id_TNLAssociationTransportLayerAddressgNBCUUP,
        id_RANUEID,
        id_GNB_DU_ID,
        id_CommonNetworkInstance,
        id_NetworkInstance,
        id_QoSFlowMappingIndication,
        id_TraceActivation,
        id_TraceID,
        id_SubscriberProfileIDforRFP,
        id_AdditionalRRMPriorityIndex,
        id_RetainabilityMeasurementsInfo,
        id_Transport_Layer_Address_Info,
        id_QoSMonitoringRequest,
        id_PDCP_StatusReportIndication,
        id_gNB_CU_CP_Measurement_ID,
        id_gNB_CU_UP_Measurement_ID,
        id_RegistrationRequest,
        id_ReportCharacteristics,
        id_ReportingPeriodicity,
        id_TNL_AvailableCapacityIndicator,
        id_HW_CapacityIndicator,
        id_RedundantCommonNetworkInstance,
        id_redundant_nG_UL_UP_TNL_Information,
        id_redundant_nG_DL_UP_TNL_Information,
        id_RedundantQosFlowIndicator,
        id_TSCTrafficCharacteristics,
        id_CNPacketDelayBudgetDownlink,
        id_CNPacketDelayBudgetUplink,
        id_ExtendedPacketDelayBudget,
        id_AdditionalPDCPduplicationInformation,
        id_RedundantPDUSessionInformation,
        id_RedundantPDUSessionInformation_used,
        id_QoS_Mapping_Information,
        id_DLUPTNLAddressToUpdateList,
        id_ULUPTNLAddressToUpdateList,
        id_NPNSupportInfo,
        id_NPNContextInfo,
        id_MDTConfiguration,
        id_ManagementBasedMDTPLMNList,
        id_TraceCollectionEntityIPAddress,
        id_PrivacyIndicator,
        id_TraceCollectionEntityURI,
        id_URIaddress,
        id_EHC_Parameters,
        id_DRBs_Subject_To_Early_Forwarding_List,
        id_DAPSRequestInfo,
        id_CHOInitiation,
        id_EarlyForwardingCOUNTReq,
        id_EarlyForwardingCOUNTInfo,
        id_AlternativeQoSParaSetList,
        id_ExtendedSliceSupportList,
        id_MCG_OfferedGBRQoSFlowInfo,
        id_Number_of_tunnels,
        id_DRB_Measurement_Results_Information_List,
        id_Extended_GNB_CU_CP_Name,
        id_Extended_GNB_CU_UP_Name,
        id_DataForwardingtoE_UTRANInformationList,
        id_QosMonitoringReportingFrequency,
        id_QoSMonitoringDisabled,
        id_AdditionalHandoverInfo,
        id_Extended_NR_CGI_Support_List,
        id_DataForwardingtoNG_RANQoSFlowInformationList,
        id_MaxCIDEHCDL,
        id_ignoreMappingRuleIndication,
        id_DirectForwardingPathAvailability,
        id_EarlyDataForwardingIndicator,
        id_QoSFlowsDRBRemapping,
        id_DataForwardingSourceIPAddress,
        id_SecurityIndicationModify,
        id_IAB_Donor_CU_UPPSKInfo,
        id_ECGI_Support_List,
        id_MDTPollutedMeasurementIndicator,
        id_M4ReportAmount,
        id_M6ReportAmount,
        id_M7ReportAmount,
        id_UESliceMaximumBitRateList,
        id_PDUSession_PairID,
        id_SurvivalTime,
        id_UDC_Parameters,
        id_SCGActivationStatus,
        id_GNB_CU_CP_MBS_E1AP_ID,
        id_GNB_CU_UP_MBS_E1AP_ID,
        id_GlobalMBSSessionID,
        id_BCBearerContextToSetup,
        id_BCBearerContextToSetupResponse,
        id_BCBearerContextToModify,
        id_BCBearerContextToModifyResponse,
        id_BCBearerContextToModifyRequired,
        id_BCBearerContextToModifyConfirm,
        id_MCBearerContextToSetup,
        id_MCBearerContextToSetupResponse,
        id_MCBearerContextToModify,
        id_MCBearerContextToModifyResponse,
        id_MCBearerContextToModifyRequired,
        id_MCBearerContextToModifyConfirm,
        id_MBSMulticastF1UContextDescriptor,
        id_gNB_CU_UP_MBS_Support_Info,
        id_SecurityIndication,
        id_SecurityResult,
        id_SDTContinueROHC,
        id_SDTindicatorSetup,
        id_SDTindicatorMod,
        id_DiscardTimerExtended,
        id_ManagementBasedMDTPLMNModificationList,
        id_MCForwardingResourceRequest,
        id_MCForwardingResourceIndication,
        id_MCForwardingResourceResponse,
        id_MCForwardingResourceRelease,
        id_MCForwardingResourceReleaseIndication,
        id_PDCP_COUNT_Reset,
        id_MBSSessionAssociatedInfoNonSupportToSupport,
    ]

class E1AP_Containers:

    _name_  = 'E1AP-Containers'
    _oid_   = [0, 4, 0, 0, 22, 3, 5, 1, 5]
    
    _obj_ = [
        'E1AP-PROTOCOL-IES',
        'E1AP-PROTOCOL-EXTENSION',
        'E1AP-PRIVATE-IES',
        'ProtocolIE-Container',
        'ProtocolIE-SingleContainer',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    _type_ = [
        'E1AP-PROTOCOL-IES',
        'E1AP-PROTOCOL-EXTENSION',
        'E1AP-PRIVATE-IES',
        'ProtocolIE-Container',
        'ProtocolIE-SingleContainer',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        'E1AP-PROTOCOL-IES',
        'E1AP-PROTOCOL-EXTENSION',
        'E1AP-PRIVATE-IES',
        ]
    _param_ = [
        'ProtocolIE-Container',
        'ProtocolIE-SingleContainer',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    
    #-----< E1AP-PROTOCOL-IES >-----#
    E1AP_PROTOCOL_IES = CLASS(name='E1AP-PROTOCOL-IES', mode=MODE_TYPE)
    _E1AP_PROTOCOL_IES_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _E1AP_PROTOCOL_IES_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'Criticality')))
    _E1AP_PROTOCOL_IES_Value = OPEN(name='Value', mode=MODE_TYPE)
    _E1AP_PROTOCOL_IES_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'Presence')))
    E1AP_PROTOCOL_IES._cont = ASN1Dict([
        ('id', _E1AP_PROTOCOL_IES_id),
        ('criticality', _E1AP_PROTOCOL_IES_criticality),
        ('Value', _E1AP_PROTOCOL_IES_Value),
        ('presence', _E1AP_PROTOCOL_IES_presence),
        ])
    
    #-----< E1AP-PROTOCOL-EXTENSION >-----#
    E1AP_PROTOCOL_EXTENSION = CLASS(name='E1AP-PROTOCOL-EXTENSION', mode=MODE_TYPE)
    _E1AP_PROTOCOL_EXTENSION_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _E1AP_PROTOCOL_EXTENSION_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'Criticality')))
    _E1AP_PROTOCOL_EXTENSION_Extension = OPEN(name='Extension', mode=MODE_TYPE)
    _E1AP_PROTOCOL_EXTENSION_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'Presence')))
    E1AP_PROTOCOL_EXTENSION._cont = ASN1Dict([
        ('id', _E1AP_PROTOCOL_EXTENSION_id),
        ('criticality', _E1AP_PROTOCOL_EXTENSION_criticality),
        ('Extension', _E1AP_PROTOCOL_EXTENSION_Extension),
        ('presence', _E1AP_PROTOCOL_EXTENSION_presence),
        ])
    
    #-----< E1AP-PRIVATE-IES >-----#
    E1AP_PRIVATE_IES = CLASS(name='E1AP-PRIVATE-IES', mode=MODE_TYPE)
    _E1AP_PRIVATE_IES_id = CHOICE(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'PrivateIE-ID')))
    _E1AP_PRIVATE_IES_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'Criticality')))
    _E1AP_PRIVATE_IES_Value = OPEN(name='Value', mode=MODE_TYPE)
    _E1AP_PRIVATE_IES_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'Presence')))
    E1AP_PRIVATE_IES._cont = ASN1Dict([
        ('id', _E1AP_PRIVATE_IES_id),
        ('criticality', _E1AP_PRIVATE_IES_criticality),
        ('Value', _E1AP_PRIVATE_IES_Value),
        ('presence', _E1AP_PRIVATE_IES_presence),
        ])
    
    #-----< ProtocolIE-Container >-----#
    ProtocolIE_Container = SEQ_OF(name='ProtocolIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-SingleContainer >-----#
    ProtocolIE_SingleContainer = SEQ(name='ProtocolIE-SingleContainer', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')), param=True)
    
    #-----< ProtocolIE-Field >-----#
    ProtocolIE_Field = SEQ(name='ProtocolIE-Field', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerList >-----#
    ProtocolIE_ContainerList = SEQ_OF(name='ProtocolIE-ContainerList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionContainer >-----#
    ProtocolExtensionContainer = SEQ_OF(name='ProtocolExtensionContainer', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionField >-----#
    ProtocolExtensionField = SEQ(name='ProtocolExtensionField', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Container >-----#
    PrivateIE_Container = SEQ_OF(name='PrivateIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Field >-----#
    PrivateIE_Field = SEQ(name='PrivateIE-Field', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _E1AP_PROTOCOL_IES_id,
        _E1AP_PROTOCOL_IES_criticality,
        _E1AP_PROTOCOL_IES_Value,
        _E1AP_PROTOCOL_IES_presence,
        E1AP_PROTOCOL_IES,
        _E1AP_PROTOCOL_EXTENSION_id,
        _E1AP_PROTOCOL_EXTENSION_criticality,
        _E1AP_PROTOCOL_EXTENSION_Extension,
        _E1AP_PROTOCOL_EXTENSION_presence,
        E1AP_PROTOCOL_EXTENSION,
        _E1AP_PRIVATE_IES_id,
        _E1AP_PRIVATE_IES_criticality,
        _E1AP_PRIVATE_IES_Value,
        _E1AP_PRIVATE_IES_presence,
        E1AP_PRIVATE_IES,
    ]

class E1AP_IEs:

    _name_  = 'E1AP-IEs'
    _oid_   = [0, 4, 0, 0, 22, 3, 5, 1, 2]
    
    _obj_ = [
        'ActivityInformation',
        'ActivityInformation-ExtIEs',
        'ActivityNotificationLevel',
        'AdditionalHandoverInfo',
        'AdditionalPDCPduplicationInformation',
        'AdditionalRRMPriorityIndex',
        'AveragingWindow',
        'AlternativeQoSParaSetList',
        'AlternativeQoSParaSetItem',
        'AlternativeQoSParaSetItem-ExtIEs',
        'BCBearerContextToSetup',
        'BCBearerContextToSetup-ExtIEs',
        'BCBearerContextNGU-TNLInfoat5GC',
        'BCBearerContextNGU-TNLInfoat5GC-ExtIEs',
        'BCMRBSetupConfiguration',
        'BCMRBSetupConfiguration-Item',
        'BCMRBSetupConfiguration-Item-ExtIEs',
        'BCBearerContextToSetupResponse',
        'BCBearerContextToSetupResponse-ExtIEs',
        'BCBearerContextNGU-TNLInfoatNGRAN',
        'BCBearerContextNGU-TNLInfoatNGRAN-ExtIEs',
        'BCMRBSetupResponseList',
        'BCMRBSetupResponseList-Item',
        'BCMRBSetupResponseList-Item-ExtIEs',
        'BCBearerContextF1U-TNLInfoatCU',
        'BCBearerContextF1U-TNLInfoatCU-ExtIEs',
        'BCMRBFailedList',
        'BCMRBFailedList-Item',
        'BCMRBFailedList-Item-ExtIEs',
        'BCBearerContextToModify',
        'BCBearerContextToModify-ExtIEs',
        'BCMRBModifyConfiguration',
        'BCMRBModifyConfiguration-Item',
        'BCMRBModifyConfiguration-Item-ExtIEs',
        'BCBearerContextF1U-TNLInfoatDU',
        'BCBearerContextF1U-TNLInfoatDU-ExtIEs',
        'BCMRBRemoveConfiguration',
        'BCBearerContextToModifyResponse',
        'BCBearerContextToModifyResponse-ExtIEs',
        'BCMRBSetupModifyResponseList',
        'BCMRBSetupModifyResponseList-Item',
        'BCMRBSetupModifyResponseList-Item-ExtIEs',
        'BCBearerContextToModifyRequired',
        'BCBearerContextToModifyRequired-ExtIEs',
        'BCBearerContextToModifyConfirm',
        'BCBearerContextToModifyConfirm-ExtIEs',
        'BearerContextStatusChange',
        'BitRate',
        'BufferSize',
        'Cause',
        'Cause-ExtIEs',
        'CauseMisc',
        'CauseProtocol',
        'CauseRadioNetwork',
        'CauseTransport',
        'Cell-Group-Information',
        'Cell-Group-Information-Item',
        'Cell-Group-Information-Item-ExtIEs',
        'Cell-Group-ID',
        'CHOInitiation',
        'Number-of-tunnels',
        'CipheringAlgorithm',
        'CNSupport',
        'CommonNetworkInstance',
        'ConfidentialityProtectionIndication',
        'ConfidentialityProtectionResult',
        'CP-TNL-Information',
        'CP-TNL-Information-ExtIEs',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-ExtIEs',
        'CriticalityDiagnostics-IE-List',
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'DAPSRequestInfo',
        'DAPSRequestInfo-ExtIEs',
        'Data-Forwarding-Information-Request',
        'Data-Forwarding-Information-Request-ExtIEs',
        'Data-Forwarding-Information',
        'Data-Forwarding-Information-ExtIEs',
        'Data-Forwarding-Request',
        'DataForwardingtoE-UTRANInformationList',
        'DataForwardingtoE-UTRANInformationListItem',
        'DataForwardingtoE-UTRANInformationListItem-ExtIEs',
        'Data-Usage-per-PDU-Session-Report',
        'Data-Usage-per-PDU-Session-Report-ExtIEs',
        'Data-Usage-per-QoS-Flow-List',
        'Data-Usage-per-QoS-Flow-Item',
        'Data-Usage-per-QoS-Flow-Item-ExtIEs',
        'Data-Usage-Report-List',
        'Data-Usage-Report-Item',
        'Data-Usage-Report-ItemExtIEs',
        'DefaultDRB',
        'Dictionary',
        'DirectForwardingPathAvailability',
        'DiscardTimer',
        'DiscardTimerExtended',
        'DLDiscarding',
        'DLDiscarding-ExtIEs',
        'DLUPTNLAddressToUpdateItem',
        'DLUPTNLAddressToUpdateItemExtIEs',
        'DL-TX-Stop',
        'DRB-Activity',
        'DRB-Activity-List',
        'DRB-Activity-Item',
        'DRB-Activity-ItemExtIEs',
        'DRB-Confirm-Modified-List-EUTRAN',
        'DRB-Confirm-Modified-Item-EUTRAN',
        'DRB-Confirm-Modified-Item-EUTRAN-ExtIEs',
        'DRB-Confirm-Modified-List-NG-RAN',
        'DRB-Confirm-Modified-Item-NG-RAN',
        'DRB-Confirm-Modified-Item-NG-RAN-ExtIEs',
        'DRB-Failed-List-EUTRAN',
        'DRB-Failed-Item-EUTRAN',
        'DRB-Failed-Item-EUTRAN-ExtIEs',
        'DRB-Failed-Mod-List-EUTRAN',
        'DRB-Failed-Mod-Item-EUTRAN',
        'DRB-Failed-Mod-Item-EUTRAN-ExtIEs',
        'DRB-Failed-List-NG-RAN',
        'DRB-Failed-Item-NG-RAN',
        'DRB-Failed-Item-NG-RAN-ExtIEs',
        'DRB-Failed-Mod-List-NG-RAN',
        'DRB-Failed-Mod-Item-NG-RAN',
        'DRB-Failed-Mod-Item-NG-RAN-ExtIEs',
        'DRB-Failed-To-Modify-List-EUTRAN',
        'DRB-Failed-To-Modify-Item-EUTRAN',
        'DRB-Failed-To-Modify-Item-EUTRAN-ExtIEs',
        'DRB-Failed-To-Modify-List-NG-RAN',
        'DRB-Failed-To-Modify-Item-NG-RAN',
        'DRB-Failed-To-Modify-Item-NG-RAN-ExtIEs',
        'DRB-ID',
        'DRB-Measurement-Results-Information-List',
        'DRB-Measurement-Results-Information-Item',
        'DRB-Measurement-Results-Information-Item-ExtIEs',
        'DRB-Modified-List-EUTRAN',
        'DRB-Modified-Item-EUTRAN',
        'DRB-Modified-Item-EUTRAN-ExtIEs',
        'DRB-Modified-List-NG-RAN',
        'DRB-Modified-Item-NG-RAN',
        'DRB-Modified-Item-NG-RAN-ExtIEs',
        'DRB-Removed-Item',
        'DRB-Removed-Item-ExtIEs',
        'DRB-Required-To-Modify-List-EUTRAN',
        'DRB-Required-To-Modify-Item-EUTRAN',
        'DRB-Required-To-Modify-Item-EUTRAN-ExtIEs',
        'DRB-Required-To-Modify-List-NG-RAN',
        'DRB-Required-To-Modify-Item-NG-RAN',
        'DRB-Required-To-Modify-Item-NG-RAN-ExtIEs',
        'DRB-Setup-List-EUTRAN',
        'DRB-Setup-Item-EUTRAN',
        'DRB-Setup-Item-EUTRAN-ExtIEs',
        'DRB-Setup-Mod-List-EUTRAN',
        'DRB-Setup-Mod-Item-EUTRAN',
        'DRB-Setup-Mod-Item-EUTRAN-ExtIEs',
        'DRB-Setup-List-NG-RAN',
        'DRB-Setup-Item-NG-RAN',
        'DRB-Setup-Item-NG-RAN-ExtIEs',
        'DRB-Setup-Mod-List-NG-RAN',
        'DRB-Setup-Mod-Item-NG-RAN',
        'DRB-Setup-Mod-Item-NG-RAN-ExtIEs',
        'DRB-Status-Item',
        'DRB-Status-ItemExtIEs',
        'DRBs-Subject-To-Counter-Check-List-EUTRAN',
        'DRBs-Subject-To-Counter-Check-Item-EUTRAN',
        'DRBs-Subject-To-Counter-Check-Item-EUTRAN-ExtIEs',
        'DRBs-Subject-To-Counter-Check-List-NG-RAN',
        'DRBs-Subject-To-Counter-Check-Item-NG-RAN',
        'DRBs-Subject-To-Counter-Check-Item-NG-RAN-ExtIEs',
        'DRBs-Subject-To-Early-Forwarding-List',
        'DRBs-Subject-To-Early-Forwarding-Item',
        'DRBs-Subject-To-Early-Forwarding-Item-ExtIEs',
        'DRB-To-Modify-List-EUTRAN',
        'DRB-To-Modify-Item-EUTRAN',
        'DRB-To-Modify-Item-EUTRAN-ExtIEs',
        'DRB-To-Modify-List-NG-RAN',
        'DRB-To-Modify-Item-NG-RAN',
        'DRB-To-Modify-Item-NG-RAN-ExtIEs',
        'DRB-To-Remove-List-EUTRAN',
        'DRB-To-Remove-Item-EUTRAN',
        'DRB-To-Remove-Item-EUTRAN-ExtIEs',
        'DRB-Required-To-Remove-List-EUTRAN',
        'DRB-Required-To-Remove-Item-EUTRAN',
        'DRB-Required-To-Remove-Item-EUTRAN-ExtIEs',
        'DRB-To-Remove-List-NG-RAN',
        'DRB-To-Remove-Item-NG-RAN',
        'DRB-To-Remove-Item-NG-RAN-ExtIEs',
        'DRB-Required-To-Remove-List-NG-RAN',
        'DRB-Required-To-Remove-Item-NG-RAN',
        'DRB-Required-To-Remove-Item-NG-RAN-ExtIEs',
        'DRB-To-Setup-List-EUTRAN',
        'DRB-To-Setup-Item-EUTRAN',
        'DRB-To-Setup-Item-EUTRAN-ExtIEs',
        'DRB-To-Setup-Mod-List-EUTRAN',
        'DRB-To-Setup-Mod-Item-EUTRAN',
        'DRB-To-Setup-Mod-Item-EUTRAN-ExtIEs',
        'DRB-To-Setup-List-NG-RAN',
        'DRB-To-Setup-Item-NG-RAN',
        'DRB-To-Setup-Item-NG-RAN-ExtIEs',
        'DRB-To-Setup-Mod-List-NG-RAN',
        'DRB-To-Setup-Mod-Item-NG-RAN',
        'DRB-To-Setup-Mod-Item-NG-RAN-ExtIEs',
        'DRB-Usage-Report-List',
        'DRB-Usage-Report-Item',
        'DRB-Usage-Report-Item-ExtIEs',
        'Duplication-Activation',
        'Dynamic5QIDescriptor',
        'Dynamic5QIDescriptor-ExtIEs',
        'DataDiscardRequired',
        'EarlyDataForwardingIndicator',
        'EarlyForwardingCOUNTInfo',
        'EarlyForwardingCOUNTInfo-ExtIEs',
        'EarlyForwardingCOUNTReq',
        'EHC-Common-Parameters',
        'EHC-Common-Parameters-ExtIEs',
        'EHC-Downlink-Parameters',
        'EHC-Downlink-Parameters-ExtIEs',
        'EHC-Uplink-Parameters',
        'EHC-Uplink-Parameters-ExtIEs',
        'EHC-Parameters',
        'EHC-Parameters-ExtIEs',
        'EncryptionKey',
        'Endpoint-IP-address-and-port',
        'Endpoint-IP-address-and-port-ExtIEs',
        'EUTRANAllocationAndRetentionPriority',
        'ExtendedPacketDelayBudget',
        'EUTRANAllocationAndRetentionPriority-ExtIEs',
        'E-UTRAN-Cell-Identity',
        'ECGI',
        'ECGI-ExtIEs',
        'ECGI-Support-List',
        'ECGI-Support-Item',
        'ECGI-Support-Item-ExtIEs',
        'EUTRAN-QoS-Support-List',
        'EUTRAN-QoS-Support-Item',
        'EUTRAN-QoS-Support-Item-ExtIEs',
        'EUTRAN-QoS',
        'EUTRAN-QoS-ExtIEs',
        'ExtendedSliceSupportList',
        'FirstDLCount',
        'FirstDLCount-ExtIEs',
        'GlobalMBSSessionID',
        'GlobalMBSSessionID-ExtIEs',
        'GNB-CU-CP-Name',
        'Extended-GNB-CU-CP-Name',
        'Extended-GNB-CU-CP-Name-ExtIEs',
        'GNB-CU-CP-MBS-E1AP-ID',
        'GNB-CU-CP-NameVisibleString',
        'GNB-CU-CP-NameUTF8String',
        'GNB-CU-CP-UE-E1AP-ID',
        'GNB-CU-UP-Capacity',
        'GNB-CU-UP-CellGroupRelatedConfiguration',
        'GNB-CU-UP-CellGroupRelatedConfiguration-Item',
        'GNB-CU-UP-CellGroupRelatedConfiguration-Item-ExtIEs',
        'GNB-CU-UP-ID',
        'GNB-CU-UP-MBS-Support-Info',
        'GNB-CU-UP-MBS-Support-Info-ExtIEs',
        'GNB-CU-UP-Name',
        'Extended-GNB-CU-UP-Name',
        'Extended-GNB-CU-UP-Name-ExtIEs',
        'GNB-CU-UP-MBS-E1AP-ID',
        'GNB-CU-UP-NameVisibleString',
        'GNB-CU-UP-NameUTF8String',
        'GNB-CU-UP-UE-E1AP-ID',
        'GNB-CU-CP-TNLA-Setup-Item',
        'GNB-CU-CP-TNLA-Setup-Item-ExtIEs',
        'GNB-CU-CP-TNLA-Failed-To-Setup-Item',
        'GNB-CU-CP-TNLA-Failed-To-Setup-Item-ExtIEs',
        'GNB-CU-CP-TNLA-To-Add-Item',
        'GNB-CU-CP-TNLA-To-Add-Item-ExtIEs',
        'GNB-CU-CP-TNLA-To-Remove-Item',
        'GNB-CU-CP-TNLA-To-Remove-Item-ExtIEs',
        'GNB-CU-CP-TNLA-To-Update-Item',
        'GNB-CU-CP-TNLA-To-Update-Item-ExtIEs',
        'GNB-CU-UP-TNLA-To-Remove-Item',
        'GNB-CU-UP-TNLA-To-Remove-Item-ExtIEs',
        'GBR-QosInformation',
        'GBR-QosInformation-ExtIEs',
        'GBR-QoSFlowInformation',
        'GBR-QosFlowInformation-ExtIEs',
        'GTP-TEID',
        'GTPTLAs',
        'GTPTLA-Item',
        'GTPTLA-Item-ExtIEs',
        'GTPTunnel',
        'GTPTunnel-ExtIEs',
        'GNB-CU-UP-OverloadInformation',
        'GNB-DU-ID',
        'HFN',
        'HW-CapacityIndicator',
        'HW-CapacityIndicator-ExtIEs',
        'IgnoreMappingRuleIndication',
        'IntegrityProtectionIndication',
        'IntegrityProtectionAlgorithm',
        'IntegrityProtectionKey',
        'IntegrityProtectionResult',
        'Inactivity-Timer',
        'InterfacesToTrace',
        'ImmediateMDT',
        'ImmediateMDT-ExtIEs',
        'IAB-Donor-CU-UPPSKInfo-Item',
        'IAB-donor-CU-UPPSKInfoItemExtIEs',
        'IAB-donor-CU-UPPSK',
        'Links-to-log',
        'LocationDependentMBSNGUInformationAt5GC',
        'LocationDependentMBSNGUInformationAt5GC-Item',
        'LocationDependentMBSNGUInformationAt5GC-Item-ExtIEs',
        'LocationDependentMBSF1UInformationAtCU',
        'LocationDependentMBSF1UInformationAtCU-Item',
        'LocationDependentMBSF1UInformationAtCU-Item-ExtIEs',
        'LocationDependentMBSF1UInformationAtDU',
        'LocationDependentMBSF1UInformationAtDU-Item',
        'LocationDependentMBSF1UInformationAtDU-Item-ExtIEs',
        'LocationDependentMBSNGUInformationAtNGRAN',
        'LocationDependentMBSNGUInformationAtNGRAN-Item',
        'LocationDependentMBSNGUInformationAtNGRAN-Item-ExtIEs',
        'MaxDataBurstVolume',
        'MaximumIPdatarate',
        'MaximumIPdatarate-ExtIEs',
        'MaxIPrate',
        'MaxPacketLossRate',
        'MaxCIDEHCDL',
        'MBSAreaSessionID',
        'MBSF1UInformationAtCU',
        'MBSF1UInformationAtCU-ExtIEs',
        'MBSF1UInformationAtDU',
        'MBSF1UInformationAtDU-ExtIEs',
        'MBSNGUInformationAt5GC',
        'MBSNGUInformationAt5GC-ExtIEs',
        'MBSNGUInformationAt5GC-Multicast',
        'MBSNGUInformationAt5GC-Multicast-ExtIEs',
        'MBSNGUInformationAtNGRAN',
        'MBSNGUInformationAtNGRAN-ExtIEs',
        'MBSSessionAssociatedInfoNonSupportToSupport',
        'MBSSessionAssociatedInfoNonSupportToSupport-ExtIEs',
        'MBSSessionAssociatedInformation',
        'MBSSessionAssociatedInformation-ExtIEs',
        'MBSSessionAssociatedInformationList',
        'MBSSessionAssociatedInformation-Item',
        'MBSSessionAssociatedInformation-Item-ExtIEs',
        'MBS-Support-Info-ToAdd-List',
        'MBS-Support-Info-ToAdd-Item',
        'MBS-Support-Info-ToAdd-Item-ExtIEs',
        'MBS-Support-Info-ToRemove-List',
        'MBS-Support-Info-ToRemove-Item',
        'MBS-Support-Info-ToRemove-Item-ExtIEs',
        'MCBearerContextToSetup',
        'MCBearerContextToSetup-ExtIEs',
        'MCMRBSetupConfiguration',
        'MCMRBSetupConfiguration-Item',
        'MCMRBSetupConfiguration-Item-ExtIEs',
        'MCBearerContextToSetupResponse',
        'MCBearerContextToSetupResponse-ExtIEs',
        'MCBearerContextNGU-TNLInfoatNGRAN',
        'MCBearerContextNGU-TNLInfoatNGRAN-ExtIEs',
        'MCMRBSetupResponseList',
        'MCMRBSetupResponseList-Item',
        'MCMRBSetupResponseList-Item-ExtIEs',
        'MBS-PDCP-COUNT',
        'MCMRBFailedList',
        'MCMRBFailedList-Item',
        'MCMRBFailedList-Item-ExtIEs',
        'MCBearerContextToModify',
        'MCBearerContextToModify-ExtIEs',
        'MCBearerContextNGUTNLInfoat5GC',
        'MCBearerContextNGUTNLInfoat5GC-ExtIEs',
        'MCBearerContextNGUTnlInfoatNGRANRequest',
        'MCBearerContextNGUTnlInfoatNGRANRequest-ExtIEs',
        'MCMRBSetupModifyConfiguration',
        'MCMRBSetupModifyConfiguration-Item',
        'MCMRBSetupModifyConfiguration-Item-ExtIEs',
        'MCBearerContextF1UTNLInfoatDU',
        'MCBearerContextF1UTNLInfoatDU-ExtIEs',
        'MulticastF1UContextReferenceE1',
        'MBSMulticastF1UContextDescriptor',
        'MBSMulticastF1UContextDescriptor-ExtIEs',
        'MCMRBRemoveConfiguration',
        'MBS-PDCP-COUNT-Req',
        'MCBearerContextToModifyResponse',
        'MCBearerContextToModifyResponse-ExtIEs',
        'MCBearerContextNGU-TNLInfoatNGRANModifyResponse',
        'MCBearerContextNGU-TNLInfoatNGRANModifyResponse-ExtIEs',
        'MCMRBSetupModifyResponseList',
        'MCMRBSetupModifyResponseList-Item',
        'MCMRBSetupModifyResponseList-Item-ExtIEs',
        'MCBearerContextToModifyRequired',
        'MCBearerContextToModifyRequired-ExtIEs',
        'MCMRBModifyRequiredConfiguration',
        'MCMRBModifyRequiredConfiguration-Item',
        'MCMRBModifyRequiredConfiguration-Item-ExtIEs',
        'MCBearerContextToModifyConfirm',
        'MCMRBModifyConfirmList',
        'MCMRBModifyConfirmList-Item',
        'MCMRBModifyConfirmList-Item-ExtIEs',
        'MCBearerContextToModifyConfirm-ExtIEs',
        'MCForwardingResourceRequest',
        'MCForwardingResourceRequest-ExtIEs',
        'MRBForwardingResourceRequestList',
        'MRBForwardingResourceRequest-Item',
        'MRBForwardingResourceRequest-Item-ExtIEs',
        'MCForwardingResourceIndication',
        'MCForwardingResourceIndication-ExtIEs',
        'MRBForwardingResourceIndicationList',
        'MRBForwardingResourceIndication-Item',
        'MRBForwardingResourceIndication-Item-ExtIEs',
        'MCForwardingResourceResponse',
        'MCForwardingResourceResponse-ExtIEs',
        'MRBForwardingResourceResponseList',
        'MRBForwardingResourceResponse-Item',
        'MRBForwardingResourceResponse-Item-ExtIEs',
        'MCForwardingResourceRelease',
        'MCForwardingResourceRelease-ExtIEs',
        'MCForwardingResourceReleaseIndication',
        'MCForwardingResourceReleaseIndication-ExtIEs',
        'MCForwardingResourceID',
        'MDTPollutedMeasurementIndicator',
        'MRB-ID',
        'MRB-ProgressInformation',
        'MRB-ProgressInformation-ExtIEs',
        'MRB-ProgressInformationSNs',
        'MRB-ProgressInformationSNs-ExtIEs',
        'MRB-ProgressInformationType',
        'MRDC-Data-Usage-Report-Item',
        'MRDC-Data-Usage-Report-Item-ExtIEs',
        'MRDC-Usage-Information',
        'MRDC-Usage-Information-ExtIEs',
        'M4Configuration',
        'M4Configuration-ExtIEs',
        'M4period',
        'M4ReportAmount',
        'M6Configuration',
        'M6Configuration-ExtIEs',
        'M6ReportAmount',
        'M6report-Interval',
        'M7Configuration',
        'M7Configuration-ExtIEs',
        'M7period',
        'M7ReportAmount',
        'MDT-Activation',
        'MDT-Configuration',
        'MDT-Configuration-ExtIEs',
        'MDTMode',
        'MDTMode-ExtIEs',
        'MeasurementsToActivate',
        'MDTPLMNList',
        'MDTPLMNModificationList',
        'NetworkInstance',
        'New-UL-TNL-Information-Required',
        'NGRANAllocationAndRetentionPriority',
        'NGRANAllocationAndRetentionPriority-ExtIEs',
        'NG-RAN-QoS-Support-List',
        'NG-RAN-QoS-Support-Item',
        'NG-RAN-QoS-Support-Item-ExtIEs',
        'NID',
        'Non-Dynamic5QIDescriptor',
        'Non-Dynamic5QIDescriptor-ExtIEs',
        'NPNSupportInfo',
        'NPNSupportInfo-ExtIEs',
        'NPNSupportInfo-SNPN',
        'NPNSupportInfo-SNPN-ExtIEs',
        'NPNContextInfo',
        'NPNContextInfo-ExtIEs',
        'NPNContextInfo-SNPN',
        'NPNContextInfo-SNPN-ExtIEs',
        'NR-Cell-Identity',
        'NR-CGI',
        'NR-CGI-ExtIEs',
        'NR-CGI-Support-List',
        'NR-CGI-Support-Item',
        'NR-CGI-Support-Item-ExtIEs',
        'Extended-NR-CGI-Support-List',
        'Extended-NR-CGI-Support-Item',
        'Extended-NR-CGI-Support-Item-ExtIEs',
        'OutOfOrderDelivery',
        'PacketDelayBudget',
        'PacketErrorRate',
        'PacketErrorRate-ExtIEs',
        'PER-Scalar',
        'PER-Exponent',
        'PDCP-Configuration',
        'PDCP-Configuration-ExtIEs',
        'PDCP-COUNT-Reset',
        'PDCP-Count',
        'PDCP-Count-ExtIEs',
        'PDCP-SN-Status-Request',
        'PDCP-DataRecovery',
        'PDCP-Duplication',
        'PDCP-Reestablishment',
        'PDU-Session-Resource-Data-Usage-List',
        'PDU-Session-Resource-Data-Usage-Item',
        'PDU-Session-Resource-Data-Usage-Item-ExtIEs',
        'PDCP-SN',
        'PDCP-SN-Size',
        'PDCP-SN-Status-Information',
        'PDCP-StatusReportIndication',
        'PDCP-SN-Status-Information-ExtIEs',
        'DRBBStatusTransfer',
        'DRBBStatusTransfer-ExtIEs',
        'PDU-Session-ID',
        'PDUSession-PairID',
        'PDU-Session-Resource-Activity',
        'PDU-Session-Resource-Activity-List',
        'PDU-Session-Resource-Activity-Item',
        'PDU-Session-Resource-Activity-ItemExtIEs',
        'PDU-Session-Resource-Confirm-Modified-List',
        'PDU-Session-Resource-Confirm-Modified-Item',
        'PDU-Session-Resource-Confirm-Modified-Item-ExtIEs',
        'PDU-Session-Resource-Failed-List',
        'PDU-Session-Resource-Failed-Item',
        'PDU-Session-Resource-Failed-Item-ExtIEs',
        'PDU-Session-Resource-Failed-Mod-List',
        'PDU-Session-Resource-Failed-Mod-Item',
        'PDU-Session-Resource-Failed-Mod-Item-ExtIEs',
        'PDU-Session-Resource-Failed-To-Modify-List',
        'PDU-Session-Resource-Failed-To-Modify-Item',
        'PDU-Session-Resource-Failed-To-Modify-Item-ExtIEs',
        'PDU-Session-Resource-Modified-List',
        'PDU-Session-Resource-Modified-Item',
        'PDU-Session-Resource-Modified-Item-ExtIEs',
        'PDU-Session-Resource-Required-To-Modify-List',
        'PDU-Session-Resource-Required-To-Modify-Item',
        'PDU-Session-Resource-Required-To-Modify-Item-ExtIEs',
        'PDU-Session-Resource-Setup-List',
        'PDU-Session-Resource-Setup-Item',
        'PDU-Session-Resource-Setup-Item-ExtIEs',
        'PDU-Session-Resource-Setup-Mod-List',
        'PDU-Session-Resource-Setup-Mod-Item',
        'PDU-Session-Resource-Setup-Mod-Item-ExtIEs',
        'PDU-Session-Resource-To-Modify-List',
        'PDU-Session-Resource-To-Modify-Item',
        'PDU-Session-Resource-To-Modify-Item-ExtIEs',
        'PDU-Session-Resource-To-Remove-List',
        'PDU-Session-Resource-To-Remove-Item',
        'PDU-Session-Resource-To-Remove-Item-ExtIEs',
        'PDU-Session-Resource-To-Setup-List',
        'PDU-Session-Resource-To-Setup-Item',
        'PDU-Session-Resource-To-Setup-Item-ExtIEs',
        'PDU-Session-Resource-To-Setup-Mod-List',
        'PDU-Session-Resource-To-Setup-Mod-Item',
        'PDU-Session-Resource-To-Setup-Mod-Item-ExtIEs',
        'PDU-Session-To-Notify-List',
        'PDU-Session-To-Notify-Item',
        'PDU-Session-To-Notify-Item-ExtIEs',
        'PDU-Session-Type',
        'PLMN-Identity',
        'PortNumber',
        'PPI',
        'PriorityLevel',
        'Pre-emptionCapability',
        'Pre-emptionVulnerability',
        'PrivacyIndicator',
        'QCI',
        'QoS-Characteristics',
        'QoS-Characteristics-ExtIEs',
        'QoS-Flow-Identifier',
        'QoS-Flow-List',
        'QoS-Flow-Item',
        'QoS-Flow-Item-ExtIEs',
        'QoS-Flow-Failed-List',
        'QoS-Flow-Failed-Item',
        'QoS-Flow-Failed-Item-ExtIEs',
        'QoS-Flow-Mapping-List',
        'QoS-Flow-Mapping-Item',
        'QoS-Flow-Mapping-Item-ExtIEs',
        'QoS-Flow-Mapping-Indication',
        'QoS-Flows-DRB-Remapping',
        'QoS-Parameters-Support-List',
        'QoS-Parameters-Support-List-ItemExtIEs',
        'QoSPriorityLevel',
        'QoS-Flow-QoS-Parameter-List',
        'QoS-Flow-QoS-Parameter-Item',
        'QoS-Flow-QoS-Parameter-Item-ExtIEs',
        'QoSFlowLevelQoSParameters',
        'QoSFlowLevelQoSParameters-ExtIEs',
        'QosMonitoringRequest',
        'QosMonitoringReportingFrequency',
        'QosMonitoringDisabled',
        'QoS-Flow-Removed-Item',
        'QoS-Flow-Removed-Item-ExtIEs',
        'QoS-Flows-to-be-forwarded-List',
        'QoS-Flows-to-be-forwarded-Item',
        'QoS-Flows-to-be-forwarded-Item-ExtIEs',
        'QoS-Mapping-Information',
        'DataForwardingtoNG-RANQoSFlowInformationList',
        'DataForwardingtoNG-RANQoSFlowInformationList-Item',
        'DataForwardingtoNG-RANQoSFlowInformationList-Item-ExtIEs',
        'RANUEID',
        'RAT-Type',
        'RedundantQoSFlowIndicator',
        'RedundantPDUSessionInformation',
        'RedundantPDUSessionInformation-ExtIEs',
        'RSN',
        'RetainabilityMeasurementsInfo',
        'RegistrationRequest',
        'ReportCharacteristics',
        'ReportingPeriodicity',
        'RequestedAction4AvailNGUTermination',
        'RLC-Mode',
        'ROHC-Parameters',
        'ROHC-Parameters-ExtIEs',
        'ROHC',
        'ROHC-ExtIEs',
        'SCGActivationStatus',
        'SecurityAlgorithm',
        'SecurityAlgorithm-ExtIEs',
        'SecurityIndication',
        'SecurityIndication-ExtIEs',
        'SecurityInformation',
        'SecurityInformation-ExtIEs',
        'SecurityResult',
        'SecurityResult-ExtIEs',
        'Slice-Support-List',
        'Slice-Support-Item',
        'Slice-Support-Item-ExtIEs',
        'SNSSAI',
        'SNSSAI-ExtIEs',
        'SDAP-Configuration',
        'SDAP-Configuration-ExtIEs',
        'SDAP-Header-DL',
        'SDAP-Header-UL',
        'SDTContinueROHC',
        'SDTindicatorSetup',
        'SDTindicatorMod',
        'SubscriberProfileIDforRFP',
        'SurvivalTime',
        'TimeToWait',
        'TNLAssociationUsage',
        'TNL-AvailableCapacityIndicator',
        'TNL-AvailableCapacityIndicator-ExtIEs',
        'TSCTrafficCharacteristics',
        'TSCTrafficCharacteristics-ExtIEs',
        'TSCTrafficInformation',
        'TSCTrafficInformation-ExtIEs',
        'Periodicity',
        'BurstArrivalTime',
        'TraceActivation',
        'TraceActivation-ExtIEs',
        'TraceDepth',
        'TraceID',
        'TransportLayerAddress',
        'TransactionID',
        'T-Reordering',
        'T-ReorderingTimer',
        'T-ReorderingTimer-ExtIEs',
        'TypeOfError',
        'Transport-Layer-Address-Info',
        'Transport-Layer-Address-Info-ExtIEs',
        'Transport-UP-Layer-Addresses-Info-To-Add-List',
        'Transport-UP-Layer-Addresses-Info-To-Add-Item',
        'Transport-UP-Layer-Addresses-Info-To-Add-ItemExtIEs',
        'Transport-UP-Layer-Addresses-Info-To-Remove-List',
        'Transport-UP-Layer-Addresses-Info-To-Remove-Item',
        'Transport-UP-Layer-Addresses-Info-To-Remove-ItemExtIEs',
        'UDC-Parameters',
        'UDC-Parameters-ExtIEs',
        'UE-Activity',
        'UE-associatedLogicalE1-ConnectionItem',
        'UE-associatedLogicalE1-ConnectionItemExtIEs',
        'UESliceMaximumBitRateList',
        'UESliceMaximumBitRateItem',
        'UESliceMaximumBitRateItem-ExtIEs',
        'UL-Configuration',
        'ULUPTNLAddressToUpdateItem',
        'ULUPTNLAddressToUpdateItemExtIEs',
        'ULDataSplitThreshold',
        'UP-Parameters',
        'UP-Parameters-Item',
        'UP-Parameters-Item-ExtIEs',
        'UPSecuritykey',
        'UPSecuritykey-ExtIEs',
        'UP-TNL-Information',
        'UP-TNL-Information-ExtIEs',
        'UplinkOnlyROHC',
        'UplinkOnlyROHC-ExtIEs',
        'URIaddress',
        ]
    _type_ = [
        'ActivityInformation',
        'ActivityNotificationLevel',
        'AdditionalHandoverInfo',
        'AdditionalPDCPduplicationInformation',
        'AdditionalRRMPriorityIndex',
        'AveragingWindow',
        'AlternativeQoSParaSetList',
        'AlternativeQoSParaSetItem',
        'BCBearerContextToSetup',
        'BCBearerContextNGU-TNLInfoat5GC',
        'BCMRBSetupConfiguration',
        'BCMRBSetupConfiguration-Item',
        'BCBearerContextToSetupResponse',
        'BCBearerContextNGU-TNLInfoatNGRAN',
        'BCMRBSetupResponseList',
        'BCMRBSetupResponseList-Item',
        'BCBearerContextF1U-TNLInfoatCU',
        'BCMRBFailedList',
        'BCMRBFailedList-Item',
        'BCBearerContextToModify',
        'BCMRBModifyConfiguration',
        'BCMRBModifyConfiguration-Item',
        'BCBearerContextF1U-TNLInfoatDU',
        'BCMRBRemoveConfiguration',
        'BCBearerContextToModifyResponse',
        'BCMRBSetupModifyResponseList',
        'BCMRBSetupModifyResponseList-Item',
        'BCBearerContextToModifyRequired',
        'BCBearerContextToModifyConfirm',
        'BearerContextStatusChange',
        'BitRate',
        'BufferSize',
        'Cause',
        'CauseMisc',
        'CauseProtocol',
        'CauseRadioNetwork',
        'CauseTransport',
        'Cell-Group-Information',
        'Cell-Group-Information-Item',
        'Cell-Group-ID',
        'CHOInitiation',
        'Number-of-tunnels',
        'CipheringAlgorithm',
        'CNSupport',
        'CommonNetworkInstance',
        'ConfidentialityProtectionIndication',
        'ConfidentialityProtectionResult',
        'CP-TNL-Information',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-IE-List',
        'DAPSRequestInfo',
        'Data-Forwarding-Information-Request',
        'Data-Forwarding-Information',
        'Data-Forwarding-Request',
        'DataForwardingtoE-UTRANInformationList',
        'DataForwardingtoE-UTRANInformationListItem',
        'Data-Usage-per-PDU-Session-Report',
        'Data-Usage-per-QoS-Flow-List',
        'Data-Usage-per-QoS-Flow-Item',
        'Data-Usage-Report-List',
        'Data-Usage-Report-Item',
        'DefaultDRB',
        'Dictionary',
        'DirectForwardingPathAvailability',
        'DiscardTimer',
        'DiscardTimerExtended',
        'DLDiscarding',
        'DLUPTNLAddressToUpdateItem',
        'DL-TX-Stop',
        'DRB-Activity',
        'DRB-Activity-List',
        'DRB-Activity-Item',
        'DRB-Confirm-Modified-List-EUTRAN',
        'DRB-Confirm-Modified-Item-EUTRAN',
        'DRB-Confirm-Modified-List-NG-RAN',
        'DRB-Confirm-Modified-Item-NG-RAN',
        'DRB-Failed-List-EUTRAN',
        'DRB-Failed-Item-EUTRAN',
        'DRB-Failed-Mod-List-EUTRAN',
        'DRB-Failed-Mod-Item-EUTRAN',
        'DRB-Failed-List-NG-RAN',
        'DRB-Failed-Item-NG-RAN',
        'DRB-Failed-Mod-List-NG-RAN',
        'DRB-Failed-Mod-Item-NG-RAN',
        'DRB-Failed-To-Modify-List-EUTRAN',
        'DRB-Failed-To-Modify-Item-EUTRAN',
        'DRB-Failed-To-Modify-List-NG-RAN',
        'DRB-Failed-To-Modify-Item-NG-RAN',
        'DRB-ID',
        'DRB-Measurement-Results-Information-List',
        'DRB-Measurement-Results-Information-Item',
        'DRB-Modified-List-EUTRAN',
        'DRB-Modified-Item-EUTRAN',
        'DRB-Modified-List-NG-RAN',
        'DRB-Modified-Item-NG-RAN',
        'DRB-Removed-Item',
        'DRB-Required-To-Modify-List-EUTRAN',
        'DRB-Required-To-Modify-Item-EUTRAN',
        'DRB-Required-To-Modify-List-NG-RAN',
        'DRB-Required-To-Modify-Item-NG-RAN',
        'DRB-Setup-List-EUTRAN',
        'DRB-Setup-Item-EUTRAN',
        'DRB-Setup-Mod-List-EUTRAN',
        'DRB-Setup-Mod-Item-EUTRAN',
        'DRB-Setup-List-NG-RAN',
        'DRB-Setup-Item-NG-RAN',
        'DRB-Setup-Mod-List-NG-RAN',
        'DRB-Setup-Mod-Item-NG-RAN',
        'DRB-Status-Item',
        'DRBs-Subject-To-Counter-Check-List-EUTRAN',
        'DRBs-Subject-To-Counter-Check-Item-EUTRAN',
        'DRBs-Subject-To-Counter-Check-List-NG-RAN',
        'DRBs-Subject-To-Counter-Check-Item-NG-RAN',
        'DRBs-Subject-To-Early-Forwarding-List',
        'DRBs-Subject-To-Early-Forwarding-Item',
        'DRB-To-Modify-List-EUTRAN',
        'DRB-To-Modify-Item-EUTRAN',
        'DRB-To-Modify-List-NG-RAN',
        'DRB-To-Modify-Item-NG-RAN',
        'DRB-To-Remove-List-EUTRAN',
        'DRB-To-Remove-Item-EUTRAN',
        'DRB-Required-To-Remove-List-EUTRAN',
        'DRB-Required-To-Remove-Item-EUTRAN',
        'DRB-To-Remove-List-NG-RAN',
        'DRB-To-Remove-Item-NG-RAN',
        'DRB-Required-To-Remove-List-NG-RAN',
        'DRB-Required-To-Remove-Item-NG-RAN',
        'DRB-To-Setup-List-EUTRAN',
        'DRB-To-Setup-Item-EUTRAN',
        'DRB-To-Setup-Mod-List-EUTRAN',
        'DRB-To-Setup-Mod-Item-EUTRAN',
        'DRB-To-Setup-List-NG-RAN',
        'DRB-To-Setup-Item-NG-RAN',
        'DRB-To-Setup-Mod-List-NG-RAN',
        'DRB-To-Setup-Mod-Item-NG-RAN',
        'DRB-Usage-Report-List',
        'DRB-Usage-Report-Item',
        'Duplication-Activation',
        'Dynamic5QIDescriptor',
        'DataDiscardRequired',
        'EarlyDataForwardingIndicator',
        'EarlyForwardingCOUNTInfo',
        'EarlyForwardingCOUNTReq',
        'EHC-Common-Parameters',
        'EHC-Downlink-Parameters',
        'EHC-Uplink-Parameters',
        'EHC-Parameters',
        'EncryptionKey',
        'Endpoint-IP-address-and-port',
        'EUTRANAllocationAndRetentionPriority',
        'ExtendedPacketDelayBudget',
        'E-UTRAN-Cell-Identity',
        'ECGI',
        'ECGI-Support-List',
        'ECGI-Support-Item',
        'EUTRAN-QoS-Support-List',
        'EUTRAN-QoS-Support-Item',
        'EUTRAN-QoS',
        'ExtendedSliceSupportList',
        'FirstDLCount',
        'GlobalMBSSessionID',
        'GNB-CU-CP-Name',
        'Extended-GNB-CU-CP-Name',
        'GNB-CU-CP-MBS-E1AP-ID',
        'GNB-CU-CP-NameVisibleString',
        'GNB-CU-CP-NameUTF8String',
        'GNB-CU-CP-UE-E1AP-ID',
        'GNB-CU-UP-Capacity',
        'GNB-CU-UP-CellGroupRelatedConfiguration',
        'GNB-CU-UP-CellGroupRelatedConfiguration-Item',
        'GNB-CU-UP-ID',
        'GNB-CU-UP-MBS-Support-Info',
        'GNB-CU-UP-Name',
        'Extended-GNB-CU-UP-Name',
        'GNB-CU-UP-MBS-E1AP-ID',
        'GNB-CU-UP-NameVisibleString',
        'GNB-CU-UP-NameUTF8String',
        'GNB-CU-UP-UE-E1AP-ID',
        'GNB-CU-CP-TNLA-Setup-Item',
        'GNB-CU-CP-TNLA-Failed-To-Setup-Item',
        'GNB-CU-CP-TNLA-To-Add-Item',
        'GNB-CU-CP-TNLA-To-Remove-Item',
        'GNB-CU-CP-TNLA-To-Update-Item',
        'GNB-CU-UP-TNLA-To-Remove-Item',
        'GBR-QosInformation',
        'GBR-QoSFlowInformation',
        'GTP-TEID',
        'GTPTLAs',
        'GTPTLA-Item',
        'GTPTunnel',
        'GNB-CU-UP-OverloadInformation',
        'GNB-DU-ID',
        'HFN',
        'HW-CapacityIndicator',
        'IgnoreMappingRuleIndication',
        'IntegrityProtectionIndication',
        'IntegrityProtectionAlgorithm',
        'IntegrityProtectionKey',
        'IntegrityProtectionResult',
        'Inactivity-Timer',
        'InterfacesToTrace',
        'ImmediateMDT',
        'IAB-Donor-CU-UPPSKInfo-Item',
        'IAB-donor-CU-UPPSK',
        'Links-to-log',
        'LocationDependentMBSNGUInformationAt5GC',
        'LocationDependentMBSNGUInformationAt5GC-Item',
        'LocationDependentMBSF1UInformationAtCU',
        'LocationDependentMBSF1UInformationAtCU-Item',
        'LocationDependentMBSF1UInformationAtDU',
        'LocationDependentMBSF1UInformationAtDU-Item',
        'LocationDependentMBSNGUInformationAtNGRAN',
        'LocationDependentMBSNGUInformationAtNGRAN-Item',
        'MaxDataBurstVolume',
        'MaximumIPdatarate',
        'MaxIPrate',
        'MaxPacketLossRate',
        'MaxCIDEHCDL',
        'MBSAreaSessionID',
        'MBSF1UInformationAtCU',
        'MBSF1UInformationAtDU',
        'MBSNGUInformationAt5GC',
        'MBSNGUInformationAt5GC-Multicast',
        'MBSNGUInformationAtNGRAN',
        'MBSSessionAssociatedInfoNonSupportToSupport',
        'MBSSessionAssociatedInformation',
        'MBSSessionAssociatedInformationList',
        'MBSSessionAssociatedInformation-Item',
        'MBS-Support-Info-ToAdd-List',
        'MBS-Support-Info-ToAdd-Item',
        'MBS-Support-Info-ToRemove-List',
        'MBS-Support-Info-ToRemove-Item',
        'MCBearerContextToSetup',
        'MCMRBSetupConfiguration',
        'MCMRBSetupConfiguration-Item',
        'MCBearerContextToSetupResponse',
        'MCBearerContextNGU-TNLInfoatNGRAN',
        'MCMRBSetupResponseList',
        'MCMRBSetupResponseList-Item',
        'MBS-PDCP-COUNT',
        'MCMRBFailedList',
        'MCMRBFailedList-Item',
        'MCBearerContextToModify',
        'MCBearerContextNGUTNLInfoat5GC',
        'MCBearerContextNGUTnlInfoatNGRANRequest',
        'MCMRBSetupModifyConfiguration',
        'MCMRBSetupModifyConfiguration-Item',
        'MCBearerContextF1UTNLInfoatDU',
        'MulticastF1UContextReferenceE1',
        'MBSMulticastF1UContextDescriptor',
        'MCMRBRemoveConfiguration',
        'MBS-PDCP-COUNT-Req',
        'MCBearerContextToModifyResponse',
        'MCBearerContextNGU-TNLInfoatNGRANModifyResponse',
        'MCMRBSetupModifyResponseList',
        'MCMRBSetupModifyResponseList-Item',
        'MCBearerContextToModifyRequired',
        'MCMRBModifyRequiredConfiguration',
        'MCMRBModifyRequiredConfiguration-Item',
        'MCBearerContextToModifyConfirm',
        'MCMRBModifyConfirmList',
        'MCMRBModifyConfirmList-Item',
        'MCForwardingResourceRequest',
        'MRBForwardingResourceRequestList',
        'MRBForwardingResourceRequest-Item',
        'MCForwardingResourceIndication',
        'MRBForwardingResourceIndicationList',
        'MRBForwardingResourceIndication-Item',
        'MCForwardingResourceResponse',
        'MRBForwardingResourceResponseList',
        'MRBForwardingResourceResponse-Item',
        'MCForwardingResourceRelease',
        'MCForwardingResourceReleaseIndication',
        'MCForwardingResourceID',
        'MDTPollutedMeasurementIndicator',
        'MRB-ID',
        'MRB-ProgressInformation',
        'MRB-ProgressInformationSNs',
        'MRB-ProgressInformationType',
        'MRDC-Data-Usage-Report-Item',
        'MRDC-Usage-Information',
        'M4Configuration',
        'M4period',
        'M4ReportAmount',
        'M6Configuration',
        'M6ReportAmount',
        'M6report-Interval',
        'M7Configuration',
        'M7period',
        'M7ReportAmount',
        'MDT-Activation',
        'MDT-Configuration',
        'MDTMode',
        'MeasurementsToActivate',
        'MDTPLMNList',
        'MDTPLMNModificationList',
        'NetworkInstance',
        'New-UL-TNL-Information-Required',
        'NGRANAllocationAndRetentionPriority',
        'NG-RAN-QoS-Support-List',
        'NG-RAN-QoS-Support-Item',
        'NID',
        'Non-Dynamic5QIDescriptor',
        'NPNSupportInfo',
        'NPNSupportInfo-SNPN',
        'NPNContextInfo',
        'NPNContextInfo-SNPN',
        'NR-Cell-Identity',
        'NR-CGI',
        'NR-CGI-Support-List',
        'NR-CGI-Support-Item',
        'Extended-NR-CGI-Support-List',
        'Extended-NR-CGI-Support-Item',
        'OutOfOrderDelivery',
        'PacketDelayBudget',
        'PacketErrorRate',
        'PER-Scalar',
        'PER-Exponent',
        'PDCP-Configuration',
        'PDCP-COUNT-Reset',
        'PDCP-Count',
        'PDCP-SN-Status-Request',
        'PDCP-DataRecovery',
        'PDCP-Duplication',
        'PDCP-Reestablishment',
        'PDU-Session-Resource-Data-Usage-List',
        'PDU-Session-Resource-Data-Usage-Item',
        'PDCP-SN',
        'PDCP-SN-Size',
        'PDCP-SN-Status-Information',
        'PDCP-StatusReportIndication',
        'DRBBStatusTransfer',
        'PDU-Session-ID',
        'PDUSession-PairID',
        'PDU-Session-Resource-Activity',
        'PDU-Session-Resource-Activity-List',
        'PDU-Session-Resource-Activity-Item',
        'PDU-Session-Resource-Confirm-Modified-List',
        'PDU-Session-Resource-Confirm-Modified-Item',
        'PDU-Session-Resource-Failed-List',
        'PDU-Session-Resource-Failed-Item',
        'PDU-Session-Resource-Failed-Mod-List',
        'PDU-Session-Resource-Failed-Mod-Item',
        'PDU-Session-Resource-Failed-To-Modify-List',
        'PDU-Session-Resource-Failed-To-Modify-Item',
        'PDU-Session-Resource-Modified-List',
        'PDU-Session-Resource-Modified-Item',
        'PDU-Session-Resource-Required-To-Modify-List',
        'PDU-Session-Resource-Required-To-Modify-Item',
        'PDU-Session-Resource-Setup-List',
        'PDU-Session-Resource-Setup-Item',
        'PDU-Session-Resource-Setup-Mod-List',
        'PDU-Session-Resource-Setup-Mod-Item',
        'PDU-Session-Resource-To-Modify-List',
        'PDU-Session-Resource-To-Modify-Item',
        'PDU-Session-Resource-To-Remove-List',
        'PDU-Session-Resource-To-Remove-Item',
        'PDU-Session-Resource-To-Setup-List',
        'PDU-Session-Resource-To-Setup-Item',
        'PDU-Session-Resource-To-Setup-Mod-List',
        'PDU-Session-Resource-To-Setup-Mod-Item',
        'PDU-Session-To-Notify-List',
        'PDU-Session-To-Notify-Item',
        'PDU-Session-Type',
        'PLMN-Identity',
        'PortNumber',
        'PPI',
        'PriorityLevel',
        'Pre-emptionCapability',
        'Pre-emptionVulnerability',
        'PrivacyIndicator',
        'QCI',
        'QoS-Characteristics',
        'QoS-Flow-Identifier',
        'QoS-Flow-List',
        'QoS-Flow-Item',
        'QoS-Flow-Failed-List',
        'QoS-Flow-Failed-Item',
        'QoS-Flow-Mapping-List',
        'QoS-Flow-Mapping-Item',
        'QoS-Flow-Mapping-Indication',
        'QoS-Flows-DRB-Remapping',
        'QoS-Parameters-Support-List',
        'QoSPriorityLevel',
        'QoS-Flow-QoS-Parameter-List',
        'QoS-Flow-QoS-Parameter-Item',
        'QoSFlowLevelQoSParameters',
        'QosMonitoringRequest',
        'QosMonitoringReportingFrequency',
        'QosMonitoringDisabled',
        'QoS-Flow-Removed-Item',
        'QoS-Flows-to-be-forwarded-List',
        'QoS-Flows-to-be-forwarded-Item',
        'QoS-Mapping-Information',
        'DataForwardingtoNG-RANQoSFlowInformationList',
        'DataForwardingtoNG-RANQoSFlowInformationList-Item',
        'RANUEID',
        'RAT-Type',
        'RedundantQoSFlowIndicator',
        'RedundantPDUSessionInformation',
        'RSN',
        'RetainabilityMeasurementsInfo',
        'RegistrationRequest',
        'ReportCharacteristics',
        'ReportingPeriodicity',
        'RequestedAction4AvailNGUTermination',
        'RLC-Mode',
        'ROHC-Parameters',
        'ROHC',
        'SCGActivationStatus',
        'SecurityAlgorithm',
        'SecurityIndication',
        'SecurityInformation',
        'SecurityResult',
        'Slice-Support-List',
        'Slice-Support-Item',
        'SNSSAI',
        'SDAP-Configuration',
        'SDAP-Header-DL',
        'SDAP-Header-UL',
        'SDTContinueROHC',
        'SDTindicatorSetup',
        'SDTindicatorMod',
        'SubscriberProfileIDforRFP',
        'SurvivalTime',
        'TimeToWait',
        'TNLAssociationUsage',
        'TNL-AvailableCapacityIndicator',
        'TSCTrafficCharacteristics',
        'TSCTrafficInformation',
        'Periodicity',
        'BurstArrivalTime',
        'TraceActivation',
        'TraceDepth',
        'TraceID',
        'TransportLayerAddress',
        'TransactionID',
        'T-Reordering',
        'T-ReorderingTimer',
        'TypeOfError',
        'Transport-Layer-Address-Info',
        'Transport-UP-Layer-Addresses-Info-To-Add-List',
        'Transport-UP-Layer-Addresses-Info-To-Add-Item',
        'Transport-UP-Layer-Addresses-Info-To-Remove-List',
        'Transport-UP-Layer-Addresses-Info-To-Remove-Item',
        'UDC-Parameters',
        'UE-Activity',
        'UE-associatedLogicalE1-ConnectionItem',
        'UESliceMaximumBitRateList',
        'UESliceMaximumBitRateItem',
        'UL-Configuration',
        'ULUPTNLAddressToUpdateItem',
        'ULDataSplitThreshold',
        'UP-Parameters',
        'UP-Parameters-Item',
        'UPSecuritykey',
        'UP-TNL-Information',
        'UplinkOnlyROHC',
        'URIaddress',
        ]
    _set_ = [
        'ActivityInformation-ExtIEs',
        'AlternativeQoSParaSetItem-ExtIEs',
        'BCBearerContextToSetup-ExtIEs',
        'BCBearerContextNGU-TNLInfoat5GC-ExtIEs',
        'BCMRBSetupConfiguration-Item-ExtIEs',
        'BCBearerContextToSetupResponse-ExtIEs',
        'BCBearerContextNGU-TNLInfoatNGRAN-ExtIEs',
        'BCMRBSetupResponseList-Item-ExtIEs',
        'BCBearerContextF1U-TNLInfoatCU-ExtIEs',
        'BCMRBFailedList-Item-ExtIEs',
        'BCBearerContextToModify-ExtIEs',
        'BCMRBModifyConfiguration-Item-ExtIEs',
        'BCBearerContextF1U-TNLInfoatDU-ExtIEs',
        'BCBearerContextToModifyResponse-ExtIEs',
        'BCMRBSetupModifyResponseList-Item-ExtIEs',
        'BCBearerContextToModifyRequired-ExtIEs',
        'BCBearerContextToModifyConfirm-ExtIEs',
        'Cause-ExtIEs',
        'Cell-Group-Information-Item-ExtIEs',
        'CP-TNL-Information-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'DAPSRequestInfo-ExtIEs',
        'Data-Forwarding-Information-Request-ExtIEs',
        'Data-Forwarding-Information-ExtIEs',
        'DataForwardingtoE-UTRANInformationListItem-ExtIEs',
        'Data-Usage-per-PDU-Session-Report-ExtIEs',
        'Data-Usage-per-QoS-Flow-Item-ExtIEs',
        'Data-Usage-Report-ItemExtIEs',
        'DLDiscarding-ExtIEs',
        'DLUPTNLAddressToUpdateItemExtIEs',
        'DRB-Activity-ItemExtIEs',
        'DRB-Confirm-Modified-Item-EUTRAN-ExtIEs',
        'DRB-Confirm-Modified-Item-NG-RAN-ExtIEs',
        'DRB-Failed-Item-EUTRAN-ExtIEs',
        'DRB-Failed-Mod-Item-EUTRAN-ExtIEs',
        'DRB-Failed-Item-NG-RAN-ExtIEs',
        'DRB-Failed-Mod-Item-NG-RAN-ExtIEs',
        'DRB-Failed-To-Modify-Item-EUTRAN-ExtIEs',
        'DRB-Failed-To-Modify-Item-NG-RAN-ExtIEs',
        'DRB-Measurement-Results-Information-Item-ExtIEs',
        'DRB-Modified-Item-EUTRAN-ExtIEs',
        'DRB-Modified-Item-NG-RAN-ExtIEs',
        'DRB-Removed-Item-ExtIEs',
        'DRB-Required-To-Modify-Item-EUTRAN-ExtIEs',
        'DRB-Required-To-Modify-Item-NG-RAN-ExtIEs',
        'DRB-Setup-Item-EUTRAN-ExtIEs',
        'DRB-Setup-Mod-Item-EUTRAN-ExtIEs',
        'DRB-Setup-Item-NG-RAN-ExtIEs',
        'DRB-Setup-Mod-Item-NG-RAN-ExtIEs',
        'DRB-Status-ItemExtIEs',
        'DRBs-Subject-To-Counter-Check-Item-EUTRAN-ExtIEs',
        'DRBs-Subject-To-Counter-Check-Item-NG-RAN-ExtIEs',
        'DRBs-Subject-To-Early-Forwarding-Item-ExtIEs',
        'DRB-To-Modify-Item-EUTRAN-ExtIEs',
        'DRB-To-Modify-Item-NG-RAN-ExtIEs',
        'DRB-To-Remove-Item-EUTRAN-ExtIEs',
        'DRB-Required-To-Remove-Item-EUTRAN-ExtIEs',
        'DRB-To-Remove-Item-NG-RAN-ExtIEs',
        'DRB-Required-To-Remove-Item-NG-RAN-ExtIEs',
        'DRB-To-Setup-Item-EUTRAN-ExtIEs',
        'DRB-To-Setup-Mod-Item-EUTRAN-ExtIEs',
        'DRB-To-Setup-Item-NG-RAN-ExtIEs',
        'DRB-To-Setup-Mod-Item-NG-RAN-ExtIEs',
        'DRB-Usage-Report-Item-ExtIEs',
        'Dynamic5QIDescriptor-ExtIEs',
        'EarlyForwardingCOUNTInfo-ExtIEs',
        'EHC-Common-Parameters-ExtIEs',
        'EHC-Downlink-Parameters-ExtIEs',
        'EHC-Uplink-Parameters-ExtIEs',
        'EHC-Parameters-ExtIEs',
        'Endpoint-IP-address-and-port-ExtIEs',
        'EUTRANAllocationAndRetentionPriority-ExtIEs',
        'ECGI-ExtIEs',
        'ECGI-Support-Item-ExtIEs',
        'EUTRAN-QoS-Support-Item-ExtIEs',
        'EUTRAN-QoS-ExtIEs',
        'FirstDLCount-ExtIEs',
        'GlobalMBSSessionID-ExtIEs',
        'Extended-GNB-CU-CP-Name-ExtIEs',
        'GNB-CU-UP-CellGroupRelatedConfiguration-Item-ExtIEs',
        'GNB-CU-UP-MBS-Support-Info-ExtIEs',
        'Extended-GNB-CU-UP-Name-ExtIEs',
        'GNB-CU-CP-TNLA-Setup-Item-ExtIEs',
        'GNB-CU-CP-TNLA-Failed-To-Setup-Item-ExtIEs',
        'GNB-CU-CP-TNLA-To-Add-Item-ExtIEs',
        'GNB-CU-CP-TNLA-To-Remove-Item-ExtIEs',
        'GNB-CU-CP-TNLA-To-Update-Item-ExtIEs',
        'GNB-CU-UP-TNLA-To-Remove-Item-ExtIEs',
        'GBR-QosInformation-ExtIEs',
        'GBR-QosFlowInformation-ExtIEs',
        'GTPTLA-Item-ExtIEs',
        'GTPTunnel-ExtIEs',
        'HW-CapacityIndicator-ExtIEs',
        'ImmediateMDT-ExtIEs',
        'IAB-donor-CU-UPPSKInfoItemExtIEs',
        'LocationDependentMBSNGUInformationAt5GC-Item-ExtIEs',
        'LocationDependentMBSF1UInformationAtCU-Item-ExtIEs',
        'LocationDependentMBSF1UInformationAtDU-Item-ExtIEs',
        'LocationDependentMBSNGUInformationAtNGRAN-Item-ExtIEs',
        'MaximumIPdatarate-ExtIEs',
        'MBSF1UInformationAtCU-ExtIEs',
        'MBSF1UInformationAtDU-ExtIEs',
        'MBSNGUInformationAt5GC-ExtIEs',
        'MBSNGUInformationAt5GC-Multicast-ExtIEs',
        'MBSNGUInformationAtNGRAN-ExtIEs',
        'MBSSessionAssociatedInfoNonSupportToSupport-ExtIEs',
        'MBSSessionAssociatedInformation-ExtIEs',
        'MBSSessionAssociatedInformation-Item-ExtIEs',
        'MBS-Support-Info-ToAdd-Item-ExtIEs',
        'MBS-Support-Info-ToRemove-Item-ExtIEs',
        'MCBearerContextToSetup-ExtIEs',
        'MCMRBSetupConfiguration-Item-ExtIEs',
        'MCBearerContextToSetupResponse-ExtIEs',
        'MCBearerContextNGU-TNLInfoatNGRAN-ExtIEs',
        'MCMRBSetupResponseList-Item-ExtIEs',
        'MCMRBFailedList-Item-ExtIEs',
        'MCBearerContextToModify-ExtIEs',
        'MCBearerContextNGUTNLInfoat5GC-ExtIEs',
        'MCBearerContextNGUTnlInfoatNGRANRequest-ExtIEs',
        'MCMRBSetupModifyConfiguration-Item-ExtIEs',
        'MCBearerContextF1UTNLInfoatDU-ExtIEs',
        'MBSMulticastF1UContextDescriptor-ExtIEs',
        'MCBearerContextToModifyResponse-ExtIEs',
        'MCBearerContextNGU-TNLInfoatNGRANModifyResponse-ExtIEs',
        'MCMRBSetupModifyResponseList-Item-ExtIEs',
        'MCBearerContextToModifyRequired-ExtIEs',
        'MCMRBModifyRequiredConfiguration-Item-ExtIEs',
        'MCMRBModifyConfirmList-Item-ExtIEs',
        'MCBearerContextToModifyConfirm-ExtIEs',
        'MCForwardingResourceRequest-ExtIEs',
        'MRBForwardingResourceRequest-Item-ExtIEs',
        'MCForwardingResourceIndication-ExtIEs',
        'MRBForwardingResourceIndication-Item-ExtIEs',
        'MCForwardingResourceResponse-ExtIEs',
        'MRBForwardingResourceResponse-Item-ExtIEs',
        'MCForwardingResourceRelease-ExtIEs',
        'MCForwardingResourceReleaseIndication-ExtIEs',
        'MRB-ProgressInformation-ExtIEs',
        'MRB-ProgressInformationSNs-ExtIEs',
        'MRDC-Data-Usage-Report-Item-ExtIEs',
        'MRDC-Usage-Information-ExtIEs',
        'M4Configuration-ExtIEs',
        'M6Configuration-ExtIEs',
        'M7Configuration-ExtIEs',
        'MDT-Configuration-ExtIEs',
        'MDTMode-ExtIEs',
        'NGRANAllocationAndRetentionPriority-ExtIEs',
        'NG-RAN-QoS-Support-Item-ExtIEs',
        'Non-Dynamic5QIDescriptor-ExtIEs',
        'NPNSupportInfo-ExtIEs',
        'NPNSupportInfo-SNPN-ExtIEs',
        'NPNContextInfo-ExtIEs',
        'NPNContextInfo-SNPN-ExtIEs',
        'NR-CGI-ExtIEs',
        'NR-CGI-Support-Item-ExtIEs',
        'Extended-NR-CGI-Support-Item-ExtIEs',
        'PacketErrorRate-ExtIEs',
        'PDCP-Configuration-ExtIEs',
        'PDCP-Count-ExtIEs',
        'PDU-Session-Resource-Data-Usage-Item-ExtIEs',
        'PDCP-SN-Status-Information-ExtIEs',
        'DRBBStatusTransfer-ExtIEs',
        'PDU-Session-Resource-Activity-ItemExtIEs',
        'PDU-Session-Resource-Confirm-Modified-Item-ExtIEs',
        'PDU-Session-Resource-Failed-Item-ExtIEs',
        'PDU-Session-Resource-Failed-Mod-Item-ExtIEs',
        'PDU-Session-Resource-Failed-To-Modify-Item-ExtIEs',
        'PDU-Session-Resource-Modified-Item-ExtIEs',
        'PDU-Session-Resource-Required-To-Modify-Item-ExtIEs',
        'PDU-Session-Resource-Setup-Item-ExtIEs',
        'PDU-Session-Resource-Setup-Mod-Item-ExtIEs',
        'PDU-Session-Resource-To-Modify-Item-ExtIEs',
        'PDU-Session-Resource-To-Remove-Item-ExtIEs',
        'PDU-Session-Resource-To-Setup-Item-ExtIEs',
        'PDU-Session-Resource-To-Setup-Mod-Item-ExtIEs',
        'PDU-Session-To-Notify-Item-ExtIEs',
        'QoS-Characteristics-ExtIEs',
        'QoS-Flow-Item-ExtIEs',
        'QoS-Flow-Failed-Item-ExtIEs',
        'QoS-Flow-Mapping-Item-ExtIEs',
        'QoS-Parameters-Support-List-ItemExtIEs',
        'QoS-Flow-QoS-Parameter-Item-ExtIEs',
        'QoSFlowLevelQoSParameters-ExtIEs',
        'QoS-Flow-Removed-Item-ExtIEs',
        'QoS-Flows-to-be-forwarded-Item-ExtIEs',
        'DataForwardingtoNG-RANQoSFlowInformationList-Item-ExtIEs',
        'RedundantPDUSessionInformation-ExtIEs',
        'ROHC-Parameters-ExtIEs',
        'ROHC-ExtIEs',
        'SecurityAlgorithm-ExtIEs',
        'SecurityIndication-ExtIEs',
        'SecurityInformation-ExtIEs',
        'SecurityResult-ExtIEs',
        'Slice-Support-Item-ExtIEs',
        'SNSSAI-ExtIEs',
        'SDAP-Configuration-ExtIEs',
        'TNL-AvailableCapacityIndicator-ExtIEs',
        'TSCTrafficCharacteristics-ExtIEs',
        'TSCTrafficInformation-ExtIEs',
        'TraceActivation-ExtIEs',
        'T-ReorderingTimer-ExtIEs',
        'Transport-Layer-Address-Info-ExtIEs',
        'Transport-UP-Layer-Addresses-Info-To-Add-ItemExtIEs',
        'Transport-UP-Layer-Addresses-Info-To-Remove-ItemExtIEs',
        'UDC-Parameters-ExtIEs',
        'UE-associatedLogicalE1-ConnectionItemExtIEs',
        'UESliceMaximumBitRateItem-ExtIEs',
        'ULUPTNLAddressToUpdateItemExtIEs',
        'UP-Parameters-Item-ExtIEs',
        'UPSecuritykey-ExtIEs',
        'UP-TNL-Information-ExtIEs',
        'UplinkOnlyROHC-ExtIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        'ActivityInformation-ExtIEs',
        'AlternativeQoSParaSetItem-ExtIEs',
        'BCBearerContextToSetup-ExtIEs',
        'BCBearerContextNGU-TNLInfoat5GC-ExtIEs',
        'BCMRBSetupConfiguration-Item-ExtIEs',
        'BCBearerContextToSetupResponse-ExtIEs',
        'BCBearerContextNGU-TNLInfoatNGRAN-ExtIEs',
        'BCMRBSetupResponseList-Item-ExtIEs',
        'BCBearerContextF1U-TNLInfoatCU-ExtIEs',
        'BCMRBFailedList-Item-ExtIEs',
        'BCBearerContextToModify-ExtIEs',
        'BCMRBModifyConfiguration-Item-ExtIEs',
        'BCBearerContextF1U-TNLInfoatDU-ExtIEs',
        'BCBearerContextToModifyResponse-ExtIEs',
        'BCMRBSetupModifyResponseList-Item-ExtIEs',
        'BCBearerContextToModifyRequired-ExtIEs',
        'BCBearerContextToModifyConfirm-ExtIEs',
        'Cause-ExtIEs',
        'Cell-Group-Information-Item-ExtIEs',
        'CP-TNL-Information-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'DAPSRequestInfo-ExtIEs',
        'Data-Forwarding-Information-Request-ExtIEs',
        'Data-Forwarding-Information-ExtIEs',
        'DataForwardingtoE-UTRANInformationListItem-ExtIEs',
        'Data-Usage-per-PDU-Session-Report-ExtIEs',
        'Data-Usage-per-QoS-Flow-Item-ExtIEs',
        'Data-Usage-Report-ItemExtIEs',
        'DLDiscarding-ExtIEs',
        'DLUPTNLAddressToUpdateItemExtIEs',
        'DRB-Activity-ItemExtIEs',
        'DRB-Confirm-Modified-Item-EUTRAN-ExtIEs',
        'DRB-Confirm-Modified-Item-NG-RAN-ExtIEs',
        'DRB-Failed-Item-EUTRAN-ExtIEs',
        'DRB-Failed-Mod-Item-EUTRAN-ExtIEs',
        'DRB-Failed-Item-NG-RAN-ExtIEs',
        'DRB-Failed-Mod-Item-NG-RAN-ExtIEs',
        'DRB-Failed-To-Modify-Item-EUTRAN-ExtIEs',
        'DRB-Failed-To-Modify-Item-NG-RAN-ExtIEs',
        'DRB-Measurement-Results-Information-Item-ExtIEs',
        'DRB-Modified-Item-EUTRAN-ExtIEs',
        'DRB-Modified-Item-NG-RAN-ExtIEs',
        'DRB-Removed-Item-ExtIEs',
        'DRB-Required-To-Modify-Item-EUTRAN-ExtIEs',
        'DRB-Required-To-Modify-Item-NG-RAN-ExtIEs',
        'DRB-Setup-Item-EUTRAN-ExtIEs',
        'DRB-Setup-Mod-Item-EUTRAN-ExtIEs',
        'DRB-Setup-Item-NG-RAN-ExtIEs',
        'DRB-Setup-Mod-Item-NG-RAN-ExtIEs',
        'DRB-Status-ItemExtIEs',
        'DRBs-Subject-To-Counter-Check-Item-EUTRAN-ExtIEs',
        'DRBs-Subject-To-Counter-Check-Item-NG-RAN-ExtIEs',
        'DRBs-Subject-To-Early-Forwarding-Item-ExtIEs',
        'DRB-To-Modify-Item-EUTRAN-ExtIEs',
        'DRB-To-Modify-Item-NG-RAN-ExtIEs',
        'DRB-To-Remove-Item-EUTRAN-ExtIEs',
        'DRB-Required-To-Remove-Item-EUTRAN-ExtIEs',
        'DRB-To-Remove-Item-NG-RAN-ExtIEs',
        'DRB-Required-To-Remove-Item-NG-RAN-ExtIEs',
        'DRB-To-Setup-Item-EUTRAN-ExtIEs',
        'DRB-To-Setup-Mod-Item-EUTRAN-ExtIEs',
        'DRB-To-Setup-Item-NG-RAN-ExtIEs',
        'DRB-To-Setup-Mod-Item-NG-RAN-ExtIEs',
        'DRB-Usage-Report-Item-ExtIEs',
        'Dynamic5QIDescriptor-ExtIEs',
        'EarlyForwardingCOUNTInfo-ExtIEs',
        'EHC-Common-Parameters-ExtIEs',
        'EHC-Downlink-Parameters-ExtIEs',
        'EHC-Uplink-Parameters-ExtIEs',
        'EHC-Parameters-ExtIEs',
        'Endpoint-IP-address-and-port-ExtIEs',
        'EUTRANAllocationAndRetentionPriority-ExtIEs',
        'ECGI-ExtIEs',
        'ECGI-Support-Item-ExtIEs',
        'EUTRAN-QoS-Support-Item-ExtIEs',
        'EUTRAN-QoS-ExtIEs',
        'FirstDLCount-ExtIEs',
        'GlobalMBSSessionID-ExtIEs',
        'Extended-GNB-CU-CP-Name-ExtIEs',
        'GNB-CU-UP-CellGroupRelatedConfiguration-Item-ExtIEs',
        'GNB-CU-UP-MBS-Support-Info-ExtIEs',
        'Extended-GNB-CU-UP-Name-ExtIEs',
        'GNB-CU-CP-TNLA-Setup-Item-ExtIEs',
        'GNB-CU-CP-TNLA-Failed-To-Setup-Item-ExtIEs',
        'GNB-CU-CP-TNLA-To-Add-Item-ExtIEs',
        'GNB-CU-CP-TNLA-To-Remove-Item-ExtIEs',
        'GNB-CU-CP-TNLA-To-Update-Item-ExtIEs',
        'GNB-CU-UP-TNLA-To-Remove-Item-ExtIEs',
        'GBR-QosInformation-ExtIEs',
        'GBR-QosFlowInformation-ExtIEs',
        'GTPTLA-Item-ExtIEs',
        'GTPTunnel-ExtIEs',
        'HW-CapacityIndicator-ExtIEs',
        'ImmediateMDT-ExtIEs',
        'IAB-donor-CU-UPPSKInfoItemExtIEs',
        'LocationDependentMBSNGUInformationAt5GC-Item-ExtIEs',
        'LocationDependentMBSF1UInformationAtCU-Item-ExtIEs',
        'LocationDependentMBSF1UInformationAtDU-Item-ExtIEs',
        'LocationDependentMBSNGUInformationAtNGRAN-Item-ExtIEs',
        'MaximumIPdatarate-ExtIEs',
        'MBSF1UInformationAtCU-ExtIEs',
        'MBSF1UInformationAtDU-ExtIEs',
        'MBSNGUInformationAt5GC-ExtIEs',
        'MBSNGUInformationAt5GC-Multicast-ExtIEs',
        'MBSNGUInformationAtNGRAN-ExtIEs',
        'MBSSessionAssociatedInfoNonSupportToSupport-ExtIEs',
        'MBSSessionAssociatedInformation-ExtIEs',
        'MBSSessionAssociatedInformation-Item-ExtIEs',
        'MBS-Support-Info-ToAdd-Item-ExtIEs',
        'MBS-Support-Info-ToRemove-Item-ExtIEs',
        'MCBearerContextToSetup-ExtIEs',
        'MCMRBSetupConfiguration-Item-ExtIEs',
        'MCBearerContextToSetupResponse-ExtIEs',
        'MCBearerContextNGU-TNLInfoatNGRAN-ExtIEs',
        'MCMRBSetupResponseList-Item-ExtIEs',
        'MCMRBFailedList-Item-ExtIEs',
        'MCBearerContextToModify-ExtIEs',
        'MCBearerContextNGUTNLInfoat5GC-ExtIEs',
        'MCBearerContextNGUTnlInfoatNGRANRequest-ExtIEs',
        'MCMRBSetupModifyConfiguration-Item-ExtIEs',
        'MCBearerContextF1UTNLInfoatDU-ExtIEs',
        'MBSMulticastF1UContextDescriptor-ExtIEs',
        'MCBearerContextToModifyResponse-ExtIEs',
        'MCBearerContextNGU-TNLInfoatNGRANModifyResponse-ExtIEs',
        'MCMRBSetupModifyResponseList-Item-ExtIEs',
        'MCBearerContextToModifyRequired-ExtIEs',
        'MCMRBModifyRequiredConfiguration-Item-ExtIEs',
        'MCMRBModifyConfirmList-Item-ExtIEs',
        'MCBearerContextToModifyConfirm-ExtIEs',
        'MCForwardingResourceRequest-ExtIEs',
        'MRBForwardingResourceRequest-Item-ExtIEs',
        'MCForwardingResourceIndication-ExtIEs',
        'MRBForwardingResourceIndication-Item-ExtIEs',
        'MCForwardingResourceResponse-ExtIEs',
        'MRBForwardingResourceResponse-Item-ExtIEs',
        'MCForwardingResourceRelease-ExtIEs',
        'MCForwardingResourceReleaseIndication-ExtIEs',
        'MRB-ProgressInformation-ExtIEs',
        'MRB-ProgressInformationSNs-ExtIEs',
        'MRDC-Data-Usage-Report-Item-ExtIEs',
        'MRDC-Usage-Information-ExtIEs',
        'M4Configuration-ExtIEs',
        'M6Configuration-ExtIEs',
        'M7Configuration-ExtIEs',
        'MDT-Configuration-ExtIEs',
        'MDTMode-ExtIEs',
        'NGRANAllocationAndRetentionPriority-ExtIEs',
        'NG-RAN-QoS-Support-Item-ExtIEs',
        'Non-Dynamic5QIDescriptor-ExtIEs',
        'NPNSupportInfo-ExtIEs',
        'NPNSupportInfo-SNPN-ExtIEs',
        'NPNContextInfo-ExtIEs',
        'NPNContextInfo-SNPN-ExtIEs',
        'NR-CGI-ExtIEs',
        'NR-CGI-Support-Item-ExtIEs',
        'Extended-NR-CGI-Support-Item-ExtIEs',
        'PacketErrorRate-ExtIEs',
        'PDCP-Configuration-ExtIEs',
        'PDCP-Count-ExtIEs',
        'PDU-Session-Resource-Data-Usage-Item-ExtIEs',
        'PDCP-SN-Status-Information-ExtIEs',
        'DRBBStatusTransfer-ExtIEs',
        'PDU-Session-Resource-Activity-ItemExtIEs',
        'PDU-Session-Resource-Confirm-Modified-Item-ExtIEs',
        'PDU-Session-Resource-Failed-Item-ExtIEs',
        'PDU-Session-Resource-Failed-Mod-Item-ExtIEs',
        'PDU-Session-Resource-Failed-To-Modify-Item-ExtIEs',
        'PDU-Session-Resource-Modified-Item-ExtIEs',
        'PDU-Session-Resource-Required-To-Modify-Item-ExtIEs',
        'PDU-Session-Resource-Setup-Item-ExtIEs',
        'PDU-Session-Resource-Setup-Mod-Item-ExtIEs',
        'PDU-Session-Resource-To-Modify-Item-ExtIEs',
        'PDU-Session-Resource-To-Remove-Item-ExtIEs',
        'PDU-Session-Resource-To-Setup-Item-ExtIEs',
        'PDU-Session-Resource-To-Setup-Mod-Item-ExtIEs',
        'PDU-Session-To-Notify-Item-ExtIEs',
        'QoS-Characteristics-ExtIEs',
        'QoS-Flow-Item-ExtIEs',
        'QoS-Flow-Failed-Item-ExtIEs',
        'QoS-Flow-Mapping-Item-ExtIEs',
        'QoS-Parameters-Support-List-ItemExtIEs',
        'QoS-Flow-QoS-Parameter-Item-ExtIEs',
        'QoSFlowLevelQoSParameters-ExtIEs',
        'QoS-Flow-Removed-Item-ExtIEs',
        'QoS-Flows-to-be-forwarded-Item-ExtIEs',
        'DataForwardingtoNG-RANQoSFlowInformationList-Item-ExtIEs',
        'RedundantPDUSessionInformation-ExtIEs',
        'ROHC-Parameters-ExtIEs',
        'ROHC-ExtIEs',
        'SecurityAlgorithm-ExtIEs',
        'SecurityIndication-ExtIEs',
        'SecurityInformation-ExtIEs',
        'SecurityResult-ExtIEs',
        'Slice-Support-Item-ExtIEs',
        'SNSSAI-ExtIEs',
        'SDAP-Configuration-ExtIEs',
        'TNL-AvailableCapacityIndicator-ExtIEs',
        'TSCTrafficCharacteristics-ExtIEs',
        'TSCTrafficInformation-ExtIEs',
        'TraceActivation-ExtIEs',
        'T-ReorderingTimer-ExtIEs',
        'Transport-Layer-Address-Info-ExtIEs',
        'Transport-UP-Layer-Addresses-Info-To-Add-ItemExtIEs',
        'Transport-UP-Layer-Addresses-Info-To-Remove-ItemExtIEs',
        'UDC-Parameters-ExtIEs',
        'UE-associatedLogicalE1-ConnectionItemExtIEs',
        'UESliceMaximumBitRateItem-ExtIEs',
        'ULUPTNLAddressToUpdateItemExtIEs',
        'UP-Parameters-Item-ExtIEs',
        'UPSecuritykey-ExtIEs',
        'UP-TNL-Information-ExtIEs',
        'UplinkOnlyROHC-ExtIEs',
        ]
    _param_ = [
        ]
    
    #-----< ActivityInformation >-----#
    ActivityInformation = CHOICE(name='ActivityInformation', mode=MODE_TYPE)
    _ActivityInformation_dRB_Activity_List = SEQ_OF(name='dRB-Activity-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-Activity-List')))
    _ActivityInformation_pDU_Session_Resource_Activity_List = SEQ_OF(name='pDU-Session-Resource-Activity-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Activity-List')))
    _ActivityInformation_uE_Activity = ENUM(name='uE-Activity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UE-Activity')))
    _ActivityInformation_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __ActivityInformation_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___ActivityInformation_choice_extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___ActivityInformation_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ActivityInformation_choice_extension_id._const_tab = ___ActivityInformation_choice_extension_id_tab
    __ActivityInformation_choice_extension_id._const_tab_at = None
    __ActivityInformation_choice_extension_id._const_tab_id = 'id'
    __ActivityInformation_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___ActivityInformation_choice_extension_criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___ActivityInformation_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ActivityInformation_choice_extension_criticality._const_tab = ___ActivityInformation_choice_extension_criticality_tab
    __ActivityInformation_choice_extension_criticality._const_tab_at = ('..', 'id')
    __ActivityInformation_choice_extension_criticality._const_tab_id = 'criticality'
    __ActivityInformation_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___ActivityInformation_choice_extension_value_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___ActivityInformation_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ActivityInformation_choice_extension_value._const_tab = ___ActivityInformation_choice_extension_value_tab
    __ActivityInformation_choice_extension_value._const_tab_at = ('..', 'id')
    __ActivityInformation_choice_extension_value._const_tab_id = 'Value'
    _ActivityInformation_choice_extension._cont = ASN1Dict([
        ('id', __ActivityInformation_choice_extension_id),
        ('criticality', __ActivityInformation_choice_extension_criticality),
        ('value', __ActivityInformation_choice_extension_value),
        ])
    _ActivityInformation_choice_extension._ext = None
    ActivityInformation._cont = ASN1Dict([
        ('dRB-Activity-List', _ActivityInformation_dRB_Activity_List),
        ('pDU-Session-Resource-Activity-List', _ActivityInformation_pDU_Session_Resource_Activity_List),
        ('uE-Activity', _ActivityInformation_uE_Activity),
        ('choice-extension', _ActivityInformation_choice_extension),
        ])
    ActivityInformation._ext = None
    
    #-----< ActivityInformation-ExtIEs >-----#
    ActivityInformation_ExtIEs = CLASS(name='ActivityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ActivityInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ActivityNotificationLevel >-----#
    ActivityNotificationLevel = ENUM(name='ActivityNotificationLevel', mode=MODE_TYPE)
    ActivityNotificationLevel._cont = ASN1Dict([('drb', 0), ('pdu-session', 1), ('ue', 2)])
    ActivityNotificationLevel._ext = []
    
    #-----< AdditionalHandoverInfo >-----#
    AdditionalHandoverInfo = ENUM(name='AdditionalHandoverInfo', mode=MODE_TYPE)
    AdditionalHandoverInfo._cont = ASN1Dict([('discard-pdpc-SN', 0)])
    AdditionalHandoverInfo._ext = []
    
    #-----< AdditionalPDCPduplicationInformation >-----#
    AdditionalPDCPduplicationInformation = ENUM(name='AdditionalPDCPduplicationInformation', mode=MODE_TYPE)
    AdditionalPDCPduplicationInformation._cont = ASN1Dict([('three', 0), ('four', 1)])
    AdditionalPDCPduplicationInformation._ext = []
    
    #-----< AdditionalRRMPriorityIndex >-----#
    AdditionalRRMPriorityIndex = BIT_STR(name='AdditionalRRMPriorityIndex', mode=MODE_TYPE)
    AdditionalRRMPriorityIndex._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< AveragingWindow >-----#
    AveragingWindow = INT(name='AveragingWindow', mode=MODE_TYPE)
    AveragingWindow._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[])
    
    #-----< AlternativeQoSParaSetList >-----#
    AlternativeQoSParaSetList = SEQ_OF(name='AlternativeQoSParaSetList', mode=MODE_TYPE)
    _AlternativeQoSParaSetList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'AlternativeQoSParaSetItem')))
    AlternativeQoSParaSetList._cont = _AlternativeQoSParaSetList__item_
    AlternativeQoSParaSetList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< AlternativeQoSParaSetItem >-----#
    AlternativeQoSParaSetItem = SEQ(name='AlternativeQoSParaSetItem', mode=MODE_TYPE)
    _AlternativeQoSParaSetItem_alternativeQoSParameterIndex = INT(name='alternativeQoSParameterIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlternativeQoSParaSetItem_alternativeQoSParameterIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=[], er=[])
    _AlternativeQoSParaSetItem_guaranteedFlowBitRateDL = INT(name='guaranteedFlowBitRateDL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BitRate')), opt=True)
    _AlternativeQoSParaSetItem_guaranteedFlowBitRateUL = INT(name='guaranteedFlowBitRateUL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BitRate')), opt=True)
    _AlternativeQoSParaSetItem_packetDelayBudget = INT(name='packetDelayBudget', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PacketDelayBudget')), opt=True)
    _AlternativeQoSParaSetItem_packetErrorRate = SEQ(name='packetErrorRate', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PacketErrorRate')), opt=True)
    _AlternativeQoSParaSetItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AlternativeQoSParaSetItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___AlternativeQoSParaSetItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AlternativeQoSParaSetItem_iE_Extensions__item__id._const_tab = ____AlternativeQoSParaSetItem_iE_Extensions__item__id_tab
    ___AlternativeQoSParaSetItem_iE_Extensions__item__id._const_tab_at = None
    ___AlternativeQoSParaSetItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality._const_tab = ____AlternativeQoSParaSetItem_iE_Extensions__item__criticality_tab
    ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue._const_tab = ____AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue_tab
    ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AlternativeQoSParaSetItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AlternativeQoSParaSetItem_iE_Extensions__item__id),
        ('criticality', ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality),
        ('extensionValue', ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue),
        ])
    __AlternativeQoSParaSetItem_iE_Extensions__item_._ext = None
    _AlternativeQoSParaSetItem_iE_Extensions._cont = __AlternativeQoSParaSetItem_iE_Extensions__item_
    _AlternativeQoSParaSetItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AlternativeQoSParaSetItem._cont = ASN1Dict([
        ('alternativeQoSParameterIndex', _AlternativeQoSParaSetItem_alternativeQoSParameterIndex),
        ('guaranteedFlowBitRateDL', _AlternativeQoSParaSetItem_guaranteedFlowBitRateDL),
        ('guaranteedFlowBitRateUL', _AlternativeQoSParaSetItem_guaranteedFlowBitRateUL),
        ('packetDelayBudget', _AlternativeQoSParaSetItem_packetDelayBudget),
        ('packetErrorRate', _AlternativeQoSParaSetItem_packetErrorRate),
        ('iE-Extensions', _AlternativeQoSParaSetItem_iE_Extensions),
        ])
    AlternativeQoSParaSetItem._ext = []
    
    #-----< AlternativeQoSParaSetItem-ExtIEs >-----#
    AlternativeQoSParaSetItem_ExtIEs = CLASS(name='AlternativeQoSParaSetItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    AlternativeQoSParaSetItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BCBearerContextToSetup >-----#
    BCBearerContextToSetup = SEQ(name='BCBearerContextToSetup', mode=MODE_TYPE)
    _BCBearerContextToSetup_snssai = SEQ(name='snssai', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'SNSSAI')))
    _BCBearerContextToSetup_bcBearerContextNGU_TNLInfoat5GC = CHOICE(name='bcBearerContextNGU-TNLInfoat5GC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BCBearerContextNGU-TNLInfoat5GC')))
    _BCBearerContextToSetup_bcMRBToSetupList = SEQ_OF(name='bcMRBToSetupList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BCMRBSetupConfiguration')))
    _BCBearerContextToSetup_requestedAction = ENUM(name='requestedAction', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'RequestedAction4AvailNGUTermination')), opt=True)
    _BCBearerContextToSetup_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BCBearerContextToSetup_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___BCBearerContextToSetup_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BCBearerContextToSetup_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCBearerContextToSetup_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCBearerContextToSetup_iE_Extensions__item__id._const_tab = ____BCBearerContextToSetup_iE_Extensions__item__id_tab
    ___BCBearerContextToSetup_iE_Extensions__item__id._const_tab_at = None
    ___BCBearerContextToSetup_iE_Extensions__item__id._const_tab_id = 'id'
    ___BCBearerContextToSetup_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BCBearerContextToSetup_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCBearerContextToSetup_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCBearerContextToSetup_iE_Extensions__item__criticality._const_tab = ____BCBearerContextToSetup_iE_Extensions__item__criticality_tab
    ___BCBearerContextToSetup_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BCBearerContextToSetup_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BCBearerContextToSetup_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BCBearerContextToSetup_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCBearerContextToSetup_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCBearerContextToSetup_iE_Extensions__item__extensionValue._const_tab = ____BCBearerContextToSetup_iE_Extensions__item__extensionValue_tab
    ___BCBearerContextToSetup_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BCBearerContextToSetup_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BCBearerContextToSetup_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BCBearerContextToSetup_iE_Extensions__item__id),
        ('criticality', ___BCBearerContextToSetup_iE_Extensions__item__criticality),
        ('extensionValue', ___BCBearerContextToSetup_iE_Extensions__item__extensionValue),
        ])
    __BCBearerContextToSetup_iE_Extensions__item_._ext = None
    _BCBearerContextToSetup_iE_Extensions._cont = __BCBearerContextToSetup_iE_Extensions__item_
    _BCBearerContextToSetup_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BCBearerContextToSetup._cont = ASN1Dict([
        ('snssai', _BCBearerContextToSetup_snssai),
        ('bcBearerContextNGU-TNLInfoat5GC', _BCBearerContextToSetup_bcBearerContextNGU_TNLInfoat5GC),
        ('bcMRBToSetupList', _BCBearerContextToSetup_bcMRBToSetupList),
        ('requestedAction', _BCBearerContextToSetup_requestedAction),
        ('iE-Extensions', _BCBearerContextToSetup_iE_Extensions),
        ])
    BCBearerContextToSetup._ext = []
    
    #-----< BCBearerContextToSetup-ExtIEs >-----#
    BCBearerContextToSetup_ExtIEs = CLASS(name='BCBearerContextToSetup-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    BCBearerContextToSetup_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BCBearerContextNGU-TNLInfoat5GC >-----#
    BCBearerContextNGU_TNLInfoat5GC = CHOICE(name='BCBearerContextNGU-TNLInfoat5GC', mode=MODE_TYPE)
    _BCBearerContextNGU_TNLInfoat5GC_locationindependent = CHOICE(name='locationindependent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSNGUInformationAt5GC')))
    _BCBearerContextNGU_TNLInfoat5GC_locationdependent = SEQ_OF(name='locationdependent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'LocationDependentMBSNGUInformationAt5GC')))
    _BCBearerContextNGU_TNLInfoat5GC_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BCBearerContextNGU_TNLInfoat5GC_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___BCBearerContextNGU_TNLInfoat5GC_choice_extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___BCBearerContextNGU_TNLInfoat5GC_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BCBearerContextNGU_TNLInfoat5GC_choice_extension_id._const_tab = ___BCBearerContextNGU_TNLInfoat5GC_choice_extension_id_tab
    __BCBearerContextNGU_TNLInfoat5GC_choice_extension_id._const_tab_at = None
    __BCBearerContextNGU_TNLInfoat5GC_choice_extension_id._const_tab_id = 'id'
    __BCBearerContextNGU_TNLInfoat5GC_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BCBearerContextNGU_TNLInfoat5GC_choice_extension_criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___BCBearerContextNGU_TNLInfoat5GC_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BCBearerContextNGU_TNLInfoat5GC_choice_extension_criticality._const_tab = ___BCBearerContextNGU_TNLInfoat5GC_choice_extension_criticality_tab
    __BCBearerContextNGU_TNLInfoat5GC_choice_extension_criticality._const_tab_at = ('..', 'id')
    __BCBearerContextNGU_TNLInfoat5GC_choice_extension_criticality._const_tab_id = 'criticality'
    __BCBearerContextNGU_TNLInfoat5GC_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BCBearerContextNGU_TNLInfoat5GC_choice_extension_value_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___BCBearerContextNGU_TNLInfoat5GC_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BCBearerContextNGU_TNLInfoat5GC_choice_extension_value._const_tab = ___BCBearerContextNGU_TNLInfoat5GC_choice_extension_value_tab
    __BCBearerContextNGU_TNLInfoat5GC_choice_extension_value._const_tab_at = ('..', 'id')
    __BCBearerContextNGU_TNLInfoat5GC_choice_extension_value._const_tab_id = 'Value'
    _BCBearerContextNGU_TNLInfoat5GC_choice_extension._cont = ASN1Dict([
        ('id', __BCBearerContextNGU_TNLInfoat5GC_choice_extension_id),
        ('criticality', __BCBearerContextNGU_TNLInfoat5GC_choice_extension_criticality),
        ('value', __BCBearerContextNGU_TNLInfoat5GC_choice_extension_value),
        ])
    _BCBearerContextNGU_TNLInfoat5GC_choice_extension._ext = None
    BCBearerContextNGU_TNLInfoat5GC._cont = ASN1Dict([
        ('locationindependent', _BCBearerContextNGU_TNLInfoat5GC_locationindependent),
        ('locationdependent', _BCBearerContextNGU_TNLInfoat5GC_locationdependent),
        ('choice-extension', _BCBearerContextNGU_TNLInfoat5GC_choice_extension),
        ])
    BCBearerContextNGU_TNLInfoat5GC._ext = None
    
    #-----< BCBearerContextNGU-TNLInfoat5GC-ExtIEs >-----#
    BCBearerContextNGU_TNLInfoat5GC_ExtIEs = CLASS(name='BCBearerContextNGU-TNLInfoat5GC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    BCBearerContextNGU_TNLInfoat5GC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BCMRBSetupConfiguration >-----#
    BCMRBSetupConfiguration = SEQ_OF(name='BCMRBSetupConfiguration', mode=MODE_TYPE)
    _BCMRBSetupConfiguration__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BCMRBSetupConfiguration-Item')))
    BCMRBSetupConfiguration._cont = _BCMRBSetupConfiguration__item_
    BCMRBSetupConfiguration._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< BCMRBSetupConfiguration-Item >-----#
    BCMRBSetupConfiguration_Item = SEQ(name='BCMRBSetupConfiguration-Item', mode=MODE_TYPE)
    _BCMRBSetupConfiguration_Item_mrb_ID = INT(name='mrb-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MRB-ID')))
    _BCMRBSetupConfiguration_Item_sdap_config = SEQ(name='sdap-config', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'SDAP-Configuration')))
    _BCMRBSetupConfiguration_Item_mbs_pdcp_config = SEQ(name='mbs-pdcp-config', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-Configuration')))
    _BCMRBSetupConfiguration_Item_qoS_Flow_QoS_Parameter_List = SEQ_OF(name='qoS-Flow-QoS-Parameter-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-QoS-Parameter-List')))
    _BCMRBSetupConfiguration_Item_qoSFlowLevelQoSParameters = SEQ(name='qoSFlowLevelQoSParameters', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoSFlowLevelQoSParameters')), opt=True)
    _BCMRBSetupConfiguration_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BCMRBSetupConfiguration_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___BCMRBSetupConfiguration_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BCMRBSetupConfiguration_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCMRBSetupConfiguration_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCMRBSetupConfiguration_Item_iE_Extensions__item__id._const_tab = ____BCMRBSetupConfiguration_Item_iE_Extensions__item__id_tab
    ___BCMRBSetupConfiguration_Item_iE_Extensions__item__id._const_tab_at = None
    ___BCMRBSetupConfiguration_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BCMRBSetupConfiguration_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BCMRBSetupConfiguration_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCMRBSetupConfiguration_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCMRBSetupConfiguration_Item_iE_Extensions__item__criticality._const_tab = ____BCMRBSetupConfiguration_Item_iE_Extensions__item__criticality_tab
    ___BCMRBSetupConfiguration_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BCMRBSetupConfiguration_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BCMRBSetupConfiguration_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BCMRBSetupConfiguration_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCMRBSetupConfiguration_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCMRBSetupConfiguration_Item_iE_Extensions__item__extensionValue._const_tab = ____BCMRBSetupConfiguration_Item_iE_Extensions__item__extensionValue_tab
    ___BCMRBSetupConfiguration_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BCMRBSetupConfiguration_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BCMRBSetupConfiguration_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BCMRBSetupConfiguration_Item_iE_Extensions__item__id),
        ('criticality', ___BCMRBSetupConfiguration_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BCMRBSetupConfiguration_Item_iE_Extensions__item__extensionValue),
        ])
    __BCMRBSetupConfiguration_Item_iE_Extensions__item_._ext = None
    _BCMRBSetupConfiguration_Item_iE_Extensions._cont = __BCMRBSetupConfiguration_Item_iE_Extensions__item_
    _BCMRBSetupConfiguration_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BCMRBSetupConfiguration_Item._cont = ASN1Dict([
        ('mrb-ID', _BCMRBSetupConfiguration_Item_mrb_ID),
        ('sdap-config', _BCMRBSetupConfiguration_Item_sdap_config),
        ('mbs-pdcp-config', _BCMRBSetupConfiguration_Item_mbs_pdcp_config),
        ('qoS-Flow-QoS-Parameter-List', _BCMRBSetupConfiguration_Item_qoS_Flow_QoS_Parameter_List),
        ('qoSFlowLevelQoSParameters', _BCMRBSetupConfiguration_Item_qoSFlowLevelQoSParameters),
        ('iE-Extensions', _BCMRBSetupConfiguration_Item_iE_Extensions),
        ])
    BCMRBSetupConfiguration_Item._ext = []
    
    #-----< BCMRBSetupConfiguration-Item-ExtIEs >-----#
    BCMRBSetupConfiguration_Item_ExtIEs = CLASS(name='BCMRBSetupConfiguration-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    BCMRBSetupConfiguration_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BCBearerContextToSetupResponse >-----#
    BCBearerContextToSetupResponse = SEQ(name='BCBearerContextToSetupResponse', mode=MODE_TYPE)
    _BCBearerContextToSetupResponse_bcBearerContextNGU_TNLInfoatNGRAN = CHOICE(name='bcBearerContextNGU-TNLInfoatNGRAN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BCBearerContextNGU-TNLInfoatNGRAN')), opt=True)
    _BCBearerContextToSetupResponse_bcMRBSetupResponseList = SEQ_OF(name='bcMRBSetupResponseList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BCMRBSetupResponseList')))
    _BCBearerContextToSetupResponse_bcMRBFailedList = SEQ_OF(name='bcMRBFailedList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BCMRBFailedList')), opt=True)
    _BCBearerContextToSetupResponse_availableBCMRBConfig = SEQ_OF(name='availableBCMRBConfig', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BCMRBSetupConfiguration')), opt=True)
    _BCBearerContextToSetupResponse_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BCBearerContextToSetupResponse_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___BCBearerContextToSetupResponse_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BCBearerContextToSetupResponse_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCBearerContextToSetupResponse_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCBearerContextToSetupResponse_iE_Extensions__item__id._const_tab = ____BCBearerContextToSetupResponse_iE_Extensions__item__id_tab
    ___BCBearerContextToSetupResponse_iE_Extensions__item__id._const_tab_at = None
    ___BCBearerContextToSetupResponse_iE_Extensions__item__id._const_tab_id = 'id'
    ___BCBearerContextToSetupResponse_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BCBearerContextToSetupResponse_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCBearerContextToSetupResponse_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCBearerContextToSetupResponse_iE_Extensions__item__criticality._const_tab = ____BCBearerContextToSetupResponse_iE_Extensions__item__criticality_tab
    ___BCBearerContextToSetupResponse_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BCBearerContextToSetupResponse_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BCBearerContextToSetupResponse_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BCBearerContextToSetupResponse_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCBearerContextToSetupResponse_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCBearerContextToSetupResponse_iE_Extensions__item__extensionValue._const_tab = ____BCBearerContextToSetupResponse_iE_Extensions__item__extensionValue_tab
    ___BCBearerContextToSetupResponse_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BCBearerContextToSetupResponse_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BCBearerContextToSetupResponse_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BCBearerContextToSetupResponse_iE_Extensions__item__id),
        ('criticality', ___BCBearerContextToSetupResponse_iE_Extensions__item__criticality),
        ('extensionValue', ___BCBearerContextToSetupResponse_iE_Extensions__item__extensionValue),
        ])
    __BCBearerContextToSetupResponse_iE_Extensions__item_._ext = None
    _BCBearerContextToSetupResponse_iE_Extensions._cont = __BCBearerContextToSetupResponse_iE_Extensions__item_
    _BCBearerContextToSetupResponse_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BCBearerContextToSetupResponse._cont = ASN1Dict([
        ('bcBearerContextNGU-TNLInfoatNGRAN', _BCBearerContextToSetupResponse_bcBearerContextNGU_TNLInfoatNGRAN),
        ('bcMRBSetupResponseList', _BCBearerContextToSetupResponse_bcMRBSetupResponseList),
        ('bcMRBFailedList', _BCBearerContextToSetupResponse_bcMRBFailedList),
        ('availableBCMRBConfig', _BCBearerContextToSetupResponse_availableBCMRBConfig),
        ('iE-Extensions', _BCBearerContextToSetupResponse_iE_Extensions),
        ])
    BCBearerContextToSetupResponse._ext = []
    
    #-----< BCBearerContextToSetupResponse-ExtIEs >-----#
    BCBearerContextToSetupResponse_ExtIEs = CLASS(name='BCBearerContextToSetupResponse-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    BCBearerContextToSetupResponse_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BCBearerContextNGU-TNLInfoatNGRAN >-----#
    BCBearerContextNGU_TNLInfoatNGRAN = CHOICE(name='BCBearerContextNGU-TNLInfoatNGRAN', mode=MODE_TYPE)
    _BCBearerContextNGU_TNLInfoatNGRAN_locationindependent = CHOICE(name='locationindependent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSNGUInformationAtNGRAN')))
    _BCBearerContextNGU_TNLInfoatNGRAN_locationdependent = SEQ_OF(name='locationdependent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'LocationDependentMBSNGUInformationAtNGRAN')))
    _BCBearerContextNGU_TNLInfoatNGRAN_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_id._const_tab = ___BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_id_tab
    __BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_id._const_tab_at = None
    __BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_id._const_tab_id = 'id'
    __BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_criticality._const_tab = ___BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_criticality_tab
    __BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_criticality._const_tab_at = ('..', 'id')
    __BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_criticality._const_tab_id = 'criticality'
    __BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_value_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_value._const_tab = ___BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_value_tab
    __BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_value._const_tab_at = ('..', 'id')
    __BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_value._const_tab_id = 'Value'
    _BCBearerContextNGU_TNLInfoatNGRAN_choice_extension._cont = ASN1Dict([
        ('id', __BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_id),
        ('criticality', __BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_criticality),
        ('value', __BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_value),
        ])
    _BCBearerContextNGU_TNLInfoatNGRAN_choice_extension._ext = None
    BCBearerContextNGU_TNLInfoatNGRAN._cont = ASN1Dict([
        ('locationindependent', _BCBearerContextNGU_TNLInfoatNGRAN_locationindependent),
        ('locationdependent', _BCBearerContextNGU_TNLInfoatNGRAN_locationdependent),
        ('choice-extension', _BCBearerContextNGU_TNLInfoatNGRAN_choice_extension),
        ])
    BCBearerContextNGU_TNLInfoatNGRAN._ext = None
    
    #-----< BCBearerContextNGU-TNLInfoatNGRAN-ExtIEs >-----#
    BCBearerContextNGU_TNLInfoatNGRAN_ExtIEs = CLASS(name='BCBearerContextNGU-TNLInfoatNGRAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    BCBearerContextNGU_TNLInfoatNGRAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BCMRBSetupResponseList >-----#
    BCMRBSetupResponseList = SEQ_OF(name='BCMRBSetupResponseList', mode=MODE_TYPE)
    _BCMRBSetupResponseList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BCMRBSetupResponseList-Item')))
    BCMRBSetupResponseList._cont = _BCMRBSetupResponseList__item_
    BCMRBSetupResponseList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< BCMRBSetupResponseList-Item >-----#
    BCMRBSetupResponseList_Item = SEQ(name='BCMRBSetupResponseList-Item', mode=MODE_TYPE)
    _BCMRBSetupResponseList_Item_mrb_ID = INT(name='mrb-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MRB-ID')))
    _BCMRBSetupResponseList_Item_qosflow_setup = SEQ_OF(name='qosflow-setup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-List')))
    _BCMRBSetupResponseList_Item_qosflow_failed = SEQ_OF(name='qosflow-failed', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Failed-List')), opt=True)
    _BCMRBSetupResponseList_Item_bcBearerContextF1U_TNLInfoatCU = CHOICE(name='bcBearerContextF1U-TNLInfoatCU', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BCBearerContextF1U-TNLInfoatCU')))
    _BCMRBSetupResponseList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BCMRBSetupResponseList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___BCMRBSetupResponseList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BCMRBSetupResponseList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCMRBSetupResponseList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCMRBSetupResponseList_Item_iE_Extensions__item__id._const_tab = ____BCMRBSetupResponseList_Item_iE_Extensions__item__id_tab
    ___BCMRBSetupResponseList_Item_iE_Extensions__item__id._const_tab_at = None
    ___BCMRBSetupResponseList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BCMRBSetupResponseList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BCMRBSetupResponseList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCMRBSetupResponseList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCMRBSetupResponseList_Item_iE_Extensions__item__criticality._const_tab = ____BCMRBSetupResponseList_Item_iE_Extensions__item__criticality_tab
    ___BCMRBSetupResponseList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BCMRBSetupResponseList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BCMRBSetupResponseList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BCMRBSetupResponseList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCMRBSetupResponseList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCMRBSetupResponseList_Item_iE_Extensions__item__extensionValue._const_tab = ____BCMRBSetupResponseList_Item_iE_Extensions__item__extensionValue_tab
    ___BCMRBSetupResponseList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BCMRBSetupResponseList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BCMRBSetupResponseList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BCMRBSetupResponseList_Item_iE_Extensions__item__id),
        ('criticality', ___BCMRBSetupResponseList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BCMRBSetupResponseList_Item_iE_Extensions__item__extensionValue),
        ])
    __BCMRBSetupResponseList_Item_iE_Extensions__item_._ext = None
    _BCMRBSetupResponseList_Item_iE_Extensions._cont = __BCMRBSetupResponseList_Item_iE_Extensions__item_
    _BCMRBSetupResponseList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BCMRBSetupResponseList_Item._cont = ASN1Dict([
        ('mrb-ID', _BCMRBSetupResponseList_Item_mrb_ID),
        ('qosflow-setup', _BCMRBSetupResponseList_Item_qosflow_setup),
        ('qosflow-failed', _BCMRBSetupResponseList_Item_qosflow_failed),
        ('bcBearerContextF1U-TNLInfoatCU', _BCMRBSetupResponseList_Item_bcBearerContextF1U_TNLInfoatCU),
        ('iE-Extensions', _BCMRBSetupResponseList_Item_iE_Extensions),
        ])
    BCMRBSetupResponseList_Item._ext = []
    
    #-----< BCMRBSetupResponseList-Item-ExtIEs >-----#
    BCMRBSetupResponseList_Item_ExtIEs = CLASS(name='BCMRBSetupResponseList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    BCMRBSetupResponseList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BCBearerContextF1U-TNLInfoatCU >-----#
    BCBearerContextF1U_TNLInfoatCU = CHOICE(name='BCBearerContextF1U-TNLInfoatCU', mode=MODE_TYPE)
    _BCBearerContextF1U_TNLInfoatCU_locationindependent = SEQ(name='locationindependent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSF1UInformationAtCU')))
    _BCBearerContextF1U_TNLInfoatCU_locationdependent = SEQ_OF(name='locationdependent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'LocationDependentMBSF1UInformationAtCU')))
    _BCBearerContextF1U_TNLInfoatCU_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BCBearerContextF1U_TNLInfoatCU_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___BCBearerContextF1U_TNLInfoatCU_choice_extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___BCBearerContextF1U_TNLInfoatCU_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BCBearerContextF1U_TNLInfoatCU_choice_extension_id._const_tab = ___BCBearerContextF1U_TNLInfoatCU_choice_extension_id_tab
    __BCBearerContextF1U_TNLInfoatCU_choice_extension_id._const_tab_at = None
    __BCBearerContextF1U_TNLInfoatCU_choice_extension_id._const_tab_id = 'id'
    __BCBearerContextF1U_TNLInfoatCU_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BCBearerContextF1U_TNLInfoatCU_choice_extension_criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___BCBearerContextF1U_TNLInfoatCU_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BCBearerContextF1U_TNLInfoatCU_choice_extension_criticality._const_tab = ___BCBearerContextF1U_TNLInfoatCU_choice_extension_criticality_tab
    __BCBearerContextF1U_TNLInfoatCU_choice_extension_criticality._const_tab_at = ('..', 'id')
    __BCBearerContextF1U_TNLInfoatCU_choice_extension_criticality._const_tab_id = 'criticality'
    __BCBearerContextF1U_TNLInfoatCU_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BCBearerContextF1U_TNLInfoatCU_choice_extension_value_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___BCBearerContextF1U_TNLInfoatCU_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BCBearerContextF1U_TNLInfoatCU_choice_extension_value._const_tab = ___BCBearerContextF1U_TNLInfoatCU_choice_extension_value_tab
    __BCBearerContextF1U_TNLInfoatCU_choice_extension_value._const_tab_at = ('..', 'id')
    __BCBearerContextF1U_TNLInfoatCU_choice_extension_value._const_tab_id = 'Value'
    _BCBearerContextF1U_TNLInfoatCU_choice_extension._cont = ASN1Dict([
        ('id', __BCBearerContextF1U_TNLInfoatCU_choice_extension_id),
        ('criticality', __BCBearerContextF1U_TNLInfoatCU_choice_extension_criticality),
        ('value', __BCBearerContextF1U_TNLInfoatCU_choice_extension_value),
        ])
    _BCBearerContextF1U_TNLInfoatCU_choice_extension._ext = None
    BCBearerContextF1U_TNLInfoatCU._cont = ASN1Dict([
        ('locationindependent', _BCBearerContextF1U_TNLInfoatCU_locationindependent),
        ('locationdependent', _BCBearerContextF1U_TNLInfoatCU_locationdependent),
        ('choice-extension', _BCBearerContextF1U_TNLInfoatCU_choice_extension),
        ])
    BCBearerContextF1U_TNLInfoatCU._ext = None
    
    #-----< BCBearerContextF1U-TNLInfoatCU-ExtIEs >-----#
    BCBearerContextF1U_TNLInfoatCU_ExtIEs = CLASS(name='BCBearerContextF1U-TNLInfoatCU-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    BCBearerContextF1U_TNLInfoatCU_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BCMRBFailedList >-----#
    BCMRBFailedList = SEQ_OF(name='BCMRBFailedList', mode=MODE_TYPE)
    _BCMRBFailedList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BCMRBFailedList-Item')))
    BCMRBFailedList._cont = _BCMRBFailedList__item_
    BCMRBFailedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< BCMRBFailedList-Item >-----#
    BCMRBFailedList_Item = SEQ(name='BCMRBFailedList-Item', mode=MODE_TYPE)
    _BCMRBFailedList_Item_mrb_ID = INT(name='mrb-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MRB-ID')))
    _BCMRBFailedList_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _BCMRBFailedList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BCMRBFailedList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___BCMRBFailedList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BCMRBFailedList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCMRBFailedList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCMRBFailedList_Item_iE_Extensions__item__id._const_tab = ____BCMRBFailedList_Item_iE_Extensions__item__id_tab
    ___BCMRBFailedList_Item_iE_Extensions__item__id._const_tab_at = None
    ___BCMRBFailedList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BCMRBFailedList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BCMRBFailedList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCMRBFailedList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCMRBFailedList_Item_iE_Extensions__item__criticality._const_tab = ____BCMRBFailedList_Item_iE_Extensions__item__criticality_tab
    ___BCMRBFailedList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BCMRBFailedList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BCMRBFailedList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BCMRBFailedList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCMRBFailedList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCMRBFailedList_Item_iE_Extensions__item__extensionValue._const_tab = ____BCMRBFailedList_Item_iE_Extensions__item__extensionValue_tab
    ___BCMRBFailedList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BCMRBFailedList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BCMRBFailedList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BCMRBFailedList_Item_iE_Extensions__item__id),
        ('criticality', ___BCMRBFailedList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BCMRBFailedList_Item_iE_Extensions__item__extensionValue),
        ])
    __BCMRBFailedList_Item_iE_Extensions__item_._ext = None
    _BCMRBFailedList_Item_iE_Extensions._cont = __BCMRBFailedList_Item_iE_Extensions__item_
    _BCMRBFailedList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BCMRBFailedList_Item._cont = ASN1Dict([
        ('mrb-ID', _BCMRBFailedList_Item_mrb_ID),
        ('cause', _BCMRBFailedList_Item_cause),
        ('iE-Extensions', _BCMRBFailedList_Item_iE_Extensions),
        ])
    BCMRBFailedList_Item._ext = []
    
    #-----< BCMRBFailedList-Item-ExtIEs >-----#
    BCMRBFailedList_Item_ExtIEs = CLASS(name='BCMRBFailedList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    BCMRBFailedList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BCBearerContextToModify >-----#
    BCBearerContextToModify = SEQ(name='BCBearerContextToModify', mode=MODE_TYPE)
    _BCBearerContextToModify_bcBearerContextNGU_TNLInfoat5GC = CHOICE(name='bcBearerContextNGU-TNLInfoat5GC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BCBearerContextNGU-TNLInfoat5GC')), opt=True)
    _BCBearerContextToModify_bcMRBToSetupList = SEQ_OF(name='bcMRBToSetupList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BCMRBSetupConfiguration')), opt=True)
    _BCBearerContextToModify_bcMRBToModifyList = SEQ_OF(name='bcMRBToModifyList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BCMRBModifyConfiguration')), opt=True)
    _BCBearerContextToModify_bcMRBToRemoveList = SEQ_OF(name='bcMRBToRemoveList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BCMRBRemoveConfiguration')), opt=True)
    _BCBearerContextToModify_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BCBearerContextToModify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___BCBearerContextToModify_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BCBearerContextToModify_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCBearerContextToModify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCBearerContextToModify_iE_Extensions__item__id._const_tab = ____BCBearerContextToModify_iE_Extensions__item__id_tab
    ___BCBearerContextToModify_iE_Extensions__item__id._const_tab_at = None
    ___BCBearerContextToModify_iE_Extensions__item__id._const_tab_id = 'id'
    ___BCBearerContextToModify_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BCBearerContextToModify_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCBearerContextToModify_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCBearerContextToModify_iE_Extensions__item__criticality._const_tab = ____BCBearerContextToModify_iE_Extensions__item__criticality_tab
    ___BCBearerContextToModify_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BCBearerContextToModify_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BCBearerContextToModify_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BCBearerContextToModify_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCBearerContextToModify_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCBearerContextToModify_iE_Extensions__item__extensionValue._const_tab = ____BCBearerContextToModify_iE_Extensions__item__extensionValue_tab
    ___BCBearerContextToModify_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BCBearerContextToModify_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BCBearerContextToModify_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BCBearerContextToModify_iE_Extensions__item__id),
        ('criticality', ___BCBearerContextToModify_iE_Extensions__item__criticality),
        ('extensionValue', ___BCBearerContextToModify_iE_Extensions__item__extensionValue),
        ])
    __BCBearerContextToModify_iE_Extensions__item_._ext = None
    _BCBearerContextToModify_iE_Extensions._cont = __BCBearerContextToModify_iE_Extensions__item_
    _BCBearerContextToModify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BCBearerContextToModify._cont = ASN1Dict([
        ('bcBearerContextNGU-TNLInfoat5GC', _BCBearerContextToModify_bcBearerContextNGU_TNLInfoat5GC),
        ('bcMRBToSetupList', _BCBearerContextToModify_bcMRBToSetupList),
        ('bcMRBToModifyList', _BCBearerContextToModify_bcMRBToModifyList),
        ('bcMRBToRemoveList', _BCBearerContextToModify_bcMRBToRemoveList),
        ('iE-Extensions', _BCBearerContextToModify_iE_Extensions),
        ])
    BCBearerContextToModify._ext = []
    
    #-----< BCBearerContextToModify-ExtIEs >-----#
    BCBearerContextToModify_ExtIEs = CLASS(name='BCBearerContextToModify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    BCBearerContextToModify_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BCMRBModifyConfiguration >-----#
    BCMRBModifyConfiguration = SEQ_OF(name='BCMRBModifyConfiguration', mode=MODE_TYPE)
    _BCMRBModifyConfiguration__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BCMRBModifyConfiguration-Item')))
    BCMRBModifyConfiguration._cont = _BCMRBModifyConfiguration__item_
    BCMRBModifyConfiguration._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< BCMRBModifyConfiguration-Item >-----#
    BCMRBModifyConfiguration_Item = SEQ(name='BCMRBModifyConfiguration-Item', mode=MODE_TYPE)
    _BCMRBModifyConfiguration_Item_mrb_ID = INT(name='mrb-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MRB-ID')))
    _BCMRBModifyConfiguration_Item_bcBearerContextF1U_TNLInfoatDU = CHOICE(name='bcBearerContextF1U-TNLInfoatDU', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BCBearerContextF1U-TNLInfoatDU')), opt=True)
    _BCMRBModifyConfiguration_Item_sdap_config = SEQ(name='sdap-config', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'SDAP-Configuration')), opt=True)
    _BCMRBModifyConfiguration_Item_mbs_pdcp_config = SEQ(name='mbs-pdcp-config', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-Configuration')), opt=True)
    _BCMRBModifyConfiguration_Item_qoS_Flow_QoS_Parameter_List = SEQ_OF(name='qoS-Flow-QoS-Parameter-List', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-QoS-Parameter-List')), opt=True)
    _BCMRBModifyConfiguration_Item_qoSFlowLevelQoSParameters = SEQ(name='qoSFlowLevelQoSParameters', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoSFlowLevelQoSParameters')), opt=True)
    _BCMRBModifyConfiguration_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BCMRBModifyConfiguration_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___BCMRBModifyConfiguration_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BCMRBModifyConfiguration_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCMRBModifyConfiguration_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCMRBModifyConfiguration_Item_iE_Extensions__item__id._const_tab = ____BCMRBModifyConfiguration_Item_iE_Extensions__item__id_tab
    ___BCMRBModifyConfiguration_Item_iE_Extensions__item__id._const_tab_at = None
    ___BCMRBModifyConfiguration_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BCMRBModifyConfiguration_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BCMRBModifyConfiguration_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCMRBModifyConfiguration_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCMRBModifyConfiguration_Item_iE_Extensions__item__criticality._const_tab = ____BCMRBModifyConfiguration_Item_iE_Extensions__item__criticality_tab
    ___BCMRBModifyConfiguration_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BCMRBModifyConfiguration_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BCMRBModifyConfiguration_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BCMRBModifyConfiguration_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCMRBModifyConfiguration_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCMRBModifyConfiguration_Item_iE_Extensions__item__extensionValue._const_tab = ____BCMRBModifyConfiguration_Item_iE_Extensions__item__extensionValue_tab
    ___BCMRBModifyConfiguration_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BCMRBModifyConfiguration_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BCMRBModifyConfiguration_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BCMRBModifyConfiguration_Item_iE_Extensions__item__id),
        ('criticality', ___BCMRBModifyConfiguration_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BCMRBModifyConfiguration_Item_iE_Extensions__item__extensionValue),
        ])
    __BCMRBModifyConfiguration_Item_iE_Extensions__item_._ext = None
    _BCMRBModifyConfiguration_Item_iE_Extensions._cont = __BCMRBModifyConfiguration_Item_iE_Extensions__item_
    _BCMRBModifyConfiguration_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BCMRBModifyConfiguration_Item._cont = ASN1Dict([
        ('mrb-ID', _BCMRBModifyConfiguration_Item_mrb_ID),
        ('bcBearerContextF1U-TNLInfoatDU', _BCMRBModifyConfiguration_Item_bcBearerContextF1U_TNLInfoatDU),
        ('sdap-config', _BCMRBModifyConfiguration_Item_sdap_config),
        ('mbs-pdcp-config', _BCMRBModifyConfiguration_Item_mbs_pdcp_config),
        ('qoS-Flow-QoS-Parameter-List', _BCMRBModifyConfiguration_Item_qoS_Flow_QoS_Parameter_List),
        ('qoSFlowLevelQoSParameters', _BCMRBModifyConfiguration_Item_qoSFlowLevelQoSParameters),
        ('iE-Extensions', _BCMRBModifyConfiguration_Item_iE_Extensions),
        ])
    BCMRBModifyConfiguration_Item._ext = []
    
    #-----< BCMRBModifyConfiguration-Item-ExtIEs >-----#
    BCMRBModifyConfiguration_Item_ExtIEs = CLASS(name='BCMRBModifyConfiguration-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    BCMRBModifyConfiguration_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BCBearerContextF1U-TNLInfoatDU >-----#
    BCBearerContextF1U_TNLInfoatDU = CHOICE(name='BCBearerContextF1U-TNLInfoatDU', mode=MODE_TYPE)
    _BCBearerContextF1U_TNLInfoatDU_locationindependent = SEQ(name='locationindependent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSF1UInformationAtDU')))
    _BCBearerContextF1U_TNLInfoatDU_locationdependent = SEQ_OF(name='locationdependent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'LocationDependentMBSF1UInformationAtDU')))
    _BCBearerContextF1U_TNLInfoatDU_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BCBearerContextF1U_TNLInfoatDU_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___BCBearerContextF1U_TNLInfoatDU_choice_extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___BCBearerContextF1U_TNLInfoatDU_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BCBearerContextF1U_TNLInfoatDU_choice_extension_id._const_tab = ___BCBearerContextF1U_TNLInfoatDU_choice_extension_id_tab
    __BCBearerContextF1U_TNLInfoatDU_choice_extension_id._const_tab_at = None
    __BCBearerContextF1U_TNLInfoatDU_choice_extension_id._const_tab_id = 'id'
    __BCBearerContextF1U_TNLInfoatDU_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BCBearerContextF1U_TNLInfoatDU_choice_extension_criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___BCBearerContextF1U_TNLInfoatDU_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BCBearerContextF1U_TNLInfoatDU_choice_extension_criticality._const_tab = ___BCBearerContextF1U_TNLInfoatDU_choice_extension_criticality_tab
    __BCBearerContextF1U_TNLInfoatDU_choice_extension_criticality._const_tab_at = ('..', 'id')
    __BCBearerContextF1U_TNLInfoatDU_choice_extension_criticality._const_tab_id = 'criticality'
    __BCBearerContextF1U_TNLInfoatDU_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BCBearerContextF1U_TNLInfoatDU_choice_extension_value_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___BCBearerContextF1U_TNLInfoatDU_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BCBearerContextF1U_TNLInfoatDU_choice_extension_value._const_tab = ___BCBearerContextF1U_TNLInfoatDU_choice_extension_value_tab
    __BCBearerContextF1U_TNLInfoatDU_choice_extension_value._const_tab_at = ('..', 'id')
    __BCBearerContextF1U_TNLInfoatDU_choice_extension_value._const_tab_id = 'Value'
    _BCBearerContextF1U_TNLInfoatDU_choice_extension._cont = ASN1Dict([
        ('id', __BCBearerContextF1U_TNLInfoatDU_choice_extension_id),
        ('criticality', __BCBearerContextF1U_TNLInfoatDU_choice_extension_criticality),
        ('value', __BCBearerContextF1U_TNLInfoatDU_choice_extension_value),
        ])
    _BCBearerContextF1U_TNLInfoatDU_choice_extension._ext = None
    BCBearerContextF1U_TNLInfoatDU._cont = ASN1Dict([
        ('locationindependent', _BCBearerContextF1U_TNLInfoatDU_locationindependent),
        ('locationdependent', _BCBearerContextF1U_TNLInfoatDU_locationdependent),
        ('choice-extension', _BCBearerContextF1U_TNLInfoatDU_choice_extension),
        ])
    BCBearerContextF1U_TNLInfoatDU._ext = None
    
    #-----< BCBearerContextF1U-TNLInfoatDU-ExtIEs >-----#
    BCBearerContextF1U_TNLInfoatDU_ExtIEs = CLASS(name='BCBearerContextF1U-TNLInfoatDU-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    BCBearerContextF1U_TNLInfoatDU_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BCMRBRemoveConfiguration >-----#
    BCMRBRemoveConfiguration = SEQ_OF(name='BCMRBRemoveConfiguration', mode=MODE_TYPE)
    _BCMRBRemoveConfiguration__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MRB-ID')))
    BCMRBRemoveConfiguration._cont = _BCMRBRemoveConfiguration__item_
    BCMRBRemoveConfiguration._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< BCBearerContextToModifyResponse >-----#
    BCBearerContextToModifyResponse = SEQ(name='BCBearerContextToModifyResponse', mode=MODE_TYPE)
    _BCBearerContextToModifyResponse_bcBearerContextNGU_TNLInfoatNGRAN = CHOICE(name='bcBearerContextNGU-TNLInfoatNGRAN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BCBearerContextNGU-TNLInfoatNGRAN')), opt=True)
    _BCBearerContextToModifyResponse_bcMRBSetupModifyResponseList = SEQ_OF(name='bcMRBSetupModifyResponseList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BCMRBSetupModifyResponseList')))
    _BCBearerContextToModifyResponse_bcMRBFailedList = SEQ_OF(name='bcMRBFailedList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BCMRBFailedList')), opt=True)
    _BCBearerContextToModifyResponse_availableBCMRBConfig = SEQ_OF(name='availableBCMRBConfig', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BCMRBSetupConfiguration')), opt=True)
    _BCBearerContextToModifyResponse_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BCBearerContextToModifyResponse_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___BCBearerContextToModifyResponse_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BCBearerContextToModifyResponse_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCBearerContextToModifyResponse_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCBearerContextToModifyResponse_iE_Extensions__item__id._const_tab = ____BCBearerContextToModifyResponse_iE_Extensions__item__id_tab
    ___BCBearerContextToModifyResponse_iE_Extensions__item__id._const_tab_at = None
    ___BCBearerContextToModifyResponse_iE_Extensions__item__id._const_tab_id = 'id'
    ___BCBearerContextToModifyResponse_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BCBearerContextToModifyResponse_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCBearerContextToModifyResponse_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCBearerContextToModifyResponse_iE_Extensions__item__criticality._const_tab = ____BCBearerContextToModifyResponse_iE_Extensions__item__criticality_tab
    ___BCBearerContextToModifyResponse_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BCBearerContextToModifyResponse_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BCBearerContextToModifyResponse_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BCBearerContextToModifyResponse_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCBearerContextToModifyResponse_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCBearerContextToModifyResponse_iE_Extensions__item__extensionValue._const_tab = ____BCBearerContextToModifyResponse_iE_Extensions__item__extensionValue_tab
    ___BCBearerContextToModifyResponse_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BCBearerContextToModifyResponse_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BCBearerContextToModifyResponse_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BCBearerContextToModifyResponse_iE_Extensions__item__id),
        ('criticality', ___BCBearerContextToModifyResponse_iE_Extensions__item__criticality),
        ('extensionValue', ___BCBearerContextToModifyResponse_iE_Extensions__item__extensionValue),
        ])
    __BCBearerContextToModifyResponse_iE_Extensions__item_._ext = None
    _BCBearerContextToModifyResponse_iE_Extensions._cont = __BCBearerContextToModifyResponse_iE_Extensions__item_
    _BCBearerContextToModifyResponse_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BCBearerContextToModifyResponse._cont = ASN1Dict([
        ('bcBearerContextNGU-TNLInfoatNGRAN', _BCBearerContextToModifyResponse_bcBearerContextNGU_TNLInfoatNGRAN),
        ('bcMRBSetupModifyResponseList', _BCBearerContextToModifyResponse_bcMRBSetupModifyResponseList),
        ('bcMRBFailedList', _BCBearerContextToModifyResponse_bcMRBFailedList),
        ('availableBCMRBConfig', _BCBearerContextToModifyResponse_availableBCMRBConfig),
        ('iE-Extensions', _BCBearerContextToModifyResponse_iE_Extensions),
        ])
    BCBearerContextToModifyResponse._ext = []
    
    #-----< BCBearerContextToModifyResponse-ExtIEs >-----#
    BCBearerContextToModifyResponse_ExtIEs = CLASS(name='BCBearerContextToModifyResponse-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    BCBearerContextToModifyResponse_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BCMRBSetupModifyResponseList >-----#
    BCMRBSetupModifyResponseList = SEQ_OF(name='BCMRBSetupModifyResponseList', mode=MODE_TYPE)
    _BCMRBSetupModifyResponseList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BCMRBSetupModifyResponseList-Item')))
    BCMRBSetupModifyResponseList._cont = _BCMRBSetupModifyResponseList__item_
    BCMRBSetupModifyResponseList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< BCMRBSetupModifyResponseList-Item >-----#
    BCMRBSetupModifyResponseList_Item = SEQ(name='BCMRBSetupModifyResponseList-Item', mode=MODE_TYPE)
    _BCMRBSetupModifyResponseList_Item_mrb_ID = INT(name='mrb-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MRB-ID')))
    _BCMRBSetupModifyResponseList_Item_qosflow_setup = SEQ_OF(name='qosflow-setup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-List')), opt=True)
    _BCMRBSetupModifyResponseList_Item_qosflow_failed = SEQ_OF(name='qosflow-failed', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Failed-List')), opt=True)
    _BCMRBSetupModifyResponseList_Item_bcBearerContextF1U_TNLInfoatCU = CHOICE(name='bcBearerContextF1U-TNLInfoatCU', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BCBearerContextF1U-TNLInfoatCU')), opt=True)
    _BCMRBSetupModifyResponseList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BCMRBSetupModifyResponseList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___BCMRBSetupModifyResponseList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BCMRBSetupModifyResponseList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCMRBSetupModifyResponseList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCMRBSetupModifyResponseList_Item_iE_Extensions__item__id._const_tab = ____BCMRBSetupModifyResponseList_Item_iE_Extensions__item__id_tab
    ___BCMRBSetupModifyResponseList_Item_iE_Extensions__item__id._const_tab_at = None
    ___BCMRBSetupModifyResponseList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BCMRBSetupModifyResponseList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BCMRBSetupModifyResponseList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCMRBSetupModifyResponseList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCMRBSetupModifyResponseList_Item_iE_Extensions__item__criticality._const_tab = ____BCMRBSetupModifyResponseList_Item_iE_Extensions__item__criticality_tab
    ___BCMRBSetupModifyResponseList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BCMRBSetupModifyResponseList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BCMRBSetupModifyResponseList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BCMRBSetupModifyResponseList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCMRBSetupModifyResponseList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCMRBSetupModifyResponseList_Item_iE_Extensions__item__extensionValue._const_tab = ____BCMRBSetupModifyResponseList_Item_iE_Extensions__item__extensionValue_tab
    ___BCMRBSetupModifyResponseList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BCMRBSetupModifyResponseList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BCMRBSetupModifyResponseList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BCMRBSetupModifyResponseList_Item_iE_Extensions__item__id),
        ('criticality', ___BCMRBSetupModifyResponseList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BCMRBSetupModifyResponseList_Item_iE_Extensions__item__extensionValue),
        ])
    __BCMRBSetupModifyResponseList_Item_iE_Extensions__item_._ext = None
    _BCMRBSetupModifyResponseList_Item_iE_Extensions._cont = __BCMRBSetupModifyResponseList_Item_iE_Extensions__item_
    _BCMRBSetupModifyResponseList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BCMRBSetupModifyResponseList_Item._cont = ASN1Dict([
        ('mrb-ID', _BCMRBSetupModifyResponseList_Item_mrb_ID),
        ('qosflow-setup', _BCMRBSetupModifyResponseList_Item_qosflow_setup),
        ('qosflow-failed', _BCMRBSetupModifyResponseList_Item_qosflow_failed),
        ('bcBearerContextF1U-TNLInfoatCU', _BCMRBSetupModifyResponseList_Item_bcBearerContextF1U_TNLInfoatCU),
        ('iE-Extensions', _BCMRBSetupModifyResponseList_Item_iE_Extensions),
        ])
    BCMRBSetupModifyResponseList_Item._ext = []
    
    #-----< BCMRBSetupModifyResponseList-Item-ExtIEs >-----#
    BCMRBSetupModifyResponseList_Item_ExtIEs = CLASS(name='BCMRBSetupModifyResponseList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    BCMRBSetupModifyResponseList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BCBearerContextToModifyRequired >-----#
    BCBearerContextToModifyRequired = SEQ(name='BCBearerContextToModifyRequired', mode=MODE_TYPE)
    _BCBearerContextToModifyRequired_bcMRBToRemoveList = SEQ_OF(name='bcMRBToRemoveList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BCMRBRemoveConfiguration')), opt=True)
    _BCBearerContextToModifyRequired_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BCBearerContextToModifyRequired_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___BCBearerContextToModifyRequired_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BCBearerContextToModifyRequired_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCBearerContextToModifyRequired_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCBearerContextToModifyRequired_iE_Extensions__item__id._const_tab = ____BCBearerContextToModifyRequired_iE_Extensions__item__id_tab
    ___BCBearerContextToModifyRequired_iE_Extensions__item__id._const_tab_at = None
    ___BCBearerContextToModifyRequired_iE_Extensions__item__id._const_tab_id = 'id'
    ___BCBearerContextToModifyRequired_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BCBearerContextToModifyRequired_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCBearerContextToModifyRequired_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCBearerContextToModifyRequired_iE_Extensions__item__criticality._const_tab = ____BCBearerContextToModifyRequired_iE_Extensions__item__criticality_tab
    ___BCBearerContextToModifyRequired_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BCBearerContextToModifyRequired_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BCBearerContextToModifyRequired_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BCBearerContextToModifyRequired_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCBearerContextToModifyRequired_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCBearerContextToModifyRequired_iE_Extensions__item__extensionValue._const_tab = ____BCBearerContextToModifyRequired_iE_Extensions__item__extensionValue_tab
    ___BCBearerContextToModifyRequired_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BCBearerContextToModifyRequired_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BCBearerContextToModifyRequired_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BCBearerContextToModifyRequired_iE_Extensions__item__id),
        ('criticality', ___BCBearerContextToModifyRequired_iE_Extensions__item__criticality),
        ('extensionValue', ___BCBearerContextToModifyRequired_iE_Extensions__item__extensionValue),
        ])
    __BCBearerContextToModifyRequired_iE_Extensions__item_._ext = None
    _BCBearerContextToModifyRequired_iE_Extensions._cont = __BCBearerContextToModifyRequired_iE_Extensions__item_
    _BCBearerContextToModifyRequired_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BCBearerContextToModifyRequired._cont = ASN1Dict([
        ('bcMRBToRemoveList', _BCBearerContextToModifyRequired_bcMRBToRemoveList),
        ('iE-Extensions', _BCBearerContextToModifyRequired_iE_Extensions),
        ])
    BCBearerContextToModifyRequired._ext = []
    
    #-----< BCBearerContextToModifyRequired-ExtIEs >-----#
    BCBearerContextToModifyRequired_ExtIEs = CLASS(name='BCBearerContextToModifyRequired-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    BCBearerContextToModifyRequired_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BCBearerContextToModifyConfirm >-----#
    BCBearerContextToModifyConfirm = SEQ(name='BCBearerContextToModifyConfirm', mode=MODE_TYPE)
    _BCBearerContextToModifyConfirm_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BCBearerContextToModifyConfirm_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___BCBearerContextToModifyConfirm_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BCBearerContextToModifyConfirm_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCBearerContextToModifyConfirm_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCBearerContextToModifyConfirm_iE_Extensions__item__id._const_tab = ____BCBearerContextToModifyConfirm_iE_Extensions__item__id_tab
    ___BCBearerContextToModifyConfirm_iE_Extensions__item__id._const_tab_at = None
    ___BCBearerContextToModifyConfirm_iE_Extensions__item__id._const_tab_id = 'id'
    ___BCBearerContextToModifyConfirm_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BCBearerContextToModifyConfirm_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCBearerContextToModifyConfirm_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCBearerContextToModifyConfirm_iE_Extensions__item__criticality._const_tab = ____BCBearerContextToModifyConfirm_iE_Extensions__item__criticality_tab
    ___BCBearerContextToModifyConfirm_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BCBearerContextToModifyConfirm_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BCBearerContextToModifyConfirm_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BCBearerContextToModifyConfirm_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____BCBearerContextToModifyConfirm_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCBearerContextToModifyConfirm_iE_Extensions__item__extensionValue._const_tab = ____BCBearerContextToModifyConfirm_iE_Extensions__item__extensionValue_tab
    ___BCBearerContextToModifyConfirm_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BCBearerContextToModifyConfirm_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BCBearerContextToModifyConfirm_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BCBearerContextToModifyConfirm_iE_Extensions__item__id),
        ('criticality', ___BCBearerContextToModifyConfirm_iE_Extensions__item__criticality),
        ('extensionValue', ___BCBearerContextToModifyConfirm_iE_Extensions__item__extensionValue),
        ])
    __BCBearerContextToModifyConfirm_iE_Extensions__item_._ext = None
    _BCBearerContextToModifyConfirm_iE_Extensions._cont = __BCBearerContextToModifyConfirm_iE_Extensions__item_
    _BCBearerContextToModifyConfirm_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BCBearerContextToModifyConfirm._cont = ASN1Dict([
        ('iE-Extensions', _BCBearerContextToModifyConfirm_iE_Extensions),
        ])
    BCBearerContextToModifyConfirm._ext = []
    
    #-----< BCBearerContextToModifyConfirm-ExtIEs >-----#
    BCBearerContextToModifyConfirm_ExtIEs = CLASS(name='BCBearerContextToModifyConfirm-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    BCBearerContextToModifyConfirm_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BearerContextStatusChange >-----#
    BearerContextStatusChange = ENUM(name='BearerContextStatusChange', mode=MODE_TYPE)
    BearerContextStatusChange._cont = ASN1Dict([('suspend', 0), ('resume', 1), ('resumeforSDT', 2)])
    BearerContextStatusChange._ext = ['resumeforSDT']
    
    #-----< BitRate >-----#
    BitRate = INT(name='BitRate', mode=MODE_TYPE)
    BitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4000000000000)], ev=[], er=[])
    
    #-----< BufferSize >-----#
    BufferSize = ENUM(name='BufferSize', mode=MODE_TYPE)
    BufferSize._cont = ASN1Dict([('kbyte2', 0), ('kbyte4', 1), ('kbyte8', 2)])
    BufferSize._ext = []
    
    #-----< Cause >-----#
    Cause = CHOICE(name='Cause', mode=MODE_TYPE)
    _Cause_radioNetwork = ENUM(name='radioNetwork', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'CauseRadioNetwork')))
    _Cause_transport = ENUM(name='transport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'CauseTransport')))
    _Cause_protocol = ENUM(name='protocol', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'CauseProtocol')))
    _Cause_misc = ENUM(name='misc', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'CauseMisc')))
    _Cause_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Cause_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___Cause_choice_extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___Cause_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Cause_choice_extension_id._const_tab = ___Cause_choice_extension_id_tab
    __Cause_choice_extension_id._const_tab_at = None
    __Cause_choice_extension_id._const_tab_id = 'id'
    __Cause_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___Cause_choice_extension_criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___Cause_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Cause_choice_extension_criticality._const_tab = ___Cause_choice_extension_criticality_tab
    __Cause_choice_extension_criticality._const_tab_at = ('..', 'id')
    __Cause_choice_extension_criticality._const_tab_id = 'criticality'
    __Cause_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___Cause_choice_extension_value_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___Cause_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Cause_choice_extension_value._const_tab = ___Cause_choice_extension_value_tab
    __Cause_choice_extension_value._const_tab_at = ('..', 'id')
    __Cause_choice_extension_value._const_tab_id = 'Value'
    _Cause_choice_extension._cont = ASN1Dict([
        ('id', __Cause_choice_extension_id),
        ('criticality', __Cause_choice_extension_criticality),
        ('value', __Cause_choice_extension_value),
        ])
    _Cause_choice_extension._ext = None
    Cause._cont = ASN1Dict([
        ('radioNetwork', _Cause_radioNetwork),
        ('transport', _Cause_transport),
        ('protocol', _Cause_protocol),
        ('misc', _Cause_misc),
        ('choice-extension', _Cause_choice_extension),
        ])
    Cause._ext = None
    
    #-----< Cause-ExtIEs >-----#
    Cause_ExtIEs = CLASS(name='Cause-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    Cause_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CauseMisc >-----#
    CauseMisc = ENUM(name='CauseMisc', mode=MODE_TYPE)
    CauseMisc._cont = ASN1Dict([('control-processing-overload', 0), ('not-enough-user-plane-processing-resources', 1), ('hardware-failure', 2), ('om-intervention', 3), ('unspecified', 4)])
    CauseMisc._ext = []
    
    #-----< CauseProtocol >-----#
    CauseProtocol = ENUM(name='CauseProtocol', mode=MODE_TYPE)
    CauseProtocol._cont = ASN1Dict([('transfer-syntax-error', 0), ('abstract-syntax-error-reject', 1), ('abstract-syntax-error-ignore-and-notify', 2), ('message-not-compatible-with-receiver-state', 3), ('semantic-error', 4), ('abstract-syntax-error-falsely-constructed-message', 5), ('unspecified', 6)])
    CauseProtocol._ext = []
    
    #-----< CauseRadioNetwork >-----#
    CauseRadioNetwork = ENUM(name='CauseRadioNetwork', mode=MODE_TYPE)
    CauseRadioNetwork._cont = ASN1Dict([('unspecified', 0), ('unknown-or-already-allocated-gnb-cu-cp-ue-e1ap-id', 1), ('unknown-or-already-allocated-gnb-cu-up-ue-e1ap-id', 2), ('unknown-or-inconsistent-pair-of-ue-e1ap-id', 3), ('interaction-with-other-procedure', 4), ('pPDCP-Count-wrap-around', 5), ('not-supported-QCI-value', 6), ('not-supported-5QI-value', 7), ('encryption-algorithms-not-supported', 8), ('integrity-protection-algorithms-not-supported', 9), ('uP-integrity-protection-not-possible', 10), ('uP-confidentiality-protection-not-possible', 11), ('multiple-PDU-Session-ID-Instances', 12), ('unknown-PDU-Session-ID', 13), ('multiple-QoS-Flow-ID-Instances', 14), ('unknown-QoS-Flow-ID', 15), ('multiple-DRB-ID-Instances', 16), ('unknown-DRB-ID', 17), ('invalid-QoS-combination', 18), ('procedure-cancelled', 19), ('normal-release', 20), ('no-radio-resources-available', 21), ('action-desirable-for-radio-reasons', 22), ('resources-not-available-for-the-slice', 23), ('pDCP-configuration-not-supported', 24), ('ue-dl-max-IP-data-rate-reason', 25), ('uP-integrity-protection-failure', 26), ('release-due-to-pre-emption', 27), ('rsn-not-available-for-the-up', 28), ('nPN-not-supported', 29), ('report-characteristic-empty', 30), ('existing-measurement-ID', 31), ('measurement-temporarily-not-available', 32), ('measurement-not-supported-for-the-object', 33), ('scg-activation-deactivation-failure', 34), ('scg-deactivation-failure-due-to-data-transmission', 35), ('unknown-or-already-allocated-gNB-CU-CP-MBS-E1AP-ID', 36), ('unknown-or-already-allocated-gNB-CU-UP-MBS-E1AP-ID', 37), ('unknown-or-inconsistent-pair-of-MBS-E1AP-ID', 38), ('unknown-or-inconsistent-MRB-ID', 39)])
    CauseRadioNetwork._ext = ['ue-dl-max-IP-data-rate-reason', 'uP-integrity-protection-failure', 'release-due-to-pre-emption', 'rsn-not-available-for-the-up', 'nPN-not-supported', 'report-characteristic-empty', 'existing-measurement-ID', 'measurement-temporarily-not-available', 'measurement-not-supported-for-the-object', 'scg-activation-deactivation-failure', 'scg-deactivation-failure-due-to-data-transmission', 'unknown-or-already-allocated-gNB-CU-CP-MBS-E1AP-ID', 'unknown-or-already-allocated-gNB-CU-UP-MBS-E1AP-ID', 'unknown-or-inconsistent-pair-of-MBS-E1AP-ID', 'unknown-or-inconsistent-MRB-ID']
    
    #-----< CauseTransport >-----#
    CauseTransport = ENUM(name='CauseTransport', mode=MODE_TYPE)
    CauseTransport._cont = ASN1Dict([('unspecified', 0), ('transport-resource-unavailable', 1), ('unknown-TNL-address-for-IAB', 2)])
    CauseTransport._ext = ['unknown-TNL-address-for-IAB']
    
    #-----< Cell-Group-Information >-----#
    Cell_Group_Information = SEQ_OF(name='Cell-Group-Information', mode=MODE_TYPE)
    _Cell_Group_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cell-Group-Information-Item')))
    Cell_Group_Information._cont = _Cell_Group_Information__item_
    Cell_Group_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< Cell-Group-Information-Item >-----#
    Cell_Group_Information_Item = SEQ(name='Cell-Group-Information-Item', mode=MODE_TYPE)
    _Cell_Group_Information_Item_cell_Group_ID = INT(name='cell-Group-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cell-Group-ID')))
    _Cell_Group_Information_Item_uL_Configuration = ENUM(name='uL-Configuration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UL-Configuration')), opt=True)
    _Cell_Group_Information_Item_dL_TX_Stop = ENUM(name='dL-TX-Stop', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DL-TX-Stop')), opt=True)
    _Cell_Group_Information_Item_rAT_Type = ENUM(name='rAT-Type', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'RAT-Type')), opt=True)
    _Cell_Group_Information_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_Group_Information_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___Cell_Group_Information_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Cell_Group_Information_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____Cell_Group_Information_Item_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Number-of-tunnels')))
    ____Cell_Group_Information_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 127), ('criticality', 'ignore'), ('Extension', _____Cell_Group_Information_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Cell_Group_Information_Item_iE_Extensions__item__id._const_tab = ____Cell_Group_Information_Item_iE_Extensions__item__id_tab
    ___Cell_Group_Information_Item_iE_Extensions__item__id._const_tab_at = None
    ___Cell_Group_Information_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cell_Group_Information_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Cell_Group_Information_Item_iE_Extensions__item__criticality._const_tab = ____Cell_Group_Information_Item_iE_Extensions__item__id_tab
    ___Cell_Group_Information_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cell_Group_Information_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cell_Group_Information_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Cell_Group_Information_Item_iE_Extensions__item__extensionValue._const_tab = ____Cell_Group_Information_Item_iE_Extensions__item__id_tab
    ___Cell_Group_Information_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cell_Group_Information_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cell_Group_Information_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cell_Group_Information_Item_iE_Extensions__item__id),
        ('criticality', ___Cell_Group_Information_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Cell_Group_Information_Item_iE_Extensions__item__extensionValue),
        ])
    __Cell_Group_Information_Item_iE_Extensions__item_._ext = None
    _Cell_Group_Information_Item_iE_Extensions._cont = __Cell_Group_Information_Item_iE_Extensions__item_
    _Cell_Group_Information_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_Group_Information_Item._cont = ASN1Dict([
        ('cell-Group-ID', _Cell_Group_Information_Item_cell_Group_ID),
        ('uL-Configuration', _Cell_Group_Information_Item_uL_Configuration),
        ('dL-TX-Stop', _Cell_Group_Information_Item_dL_TX_Stop),
        ('rAT-Type', _Cell_Group_Information_Item_rAT_Type),
        ('iE-Extensions', _Cell_Group_Information_Item_iE_Extensions),
        ])
    Cell_Group_Information_Item._ext = []
    
    #-----< Cell-Group-Information-Item-ExtIEs >-----#
    Cell_Group_Information_Item_ExtIEs = CLASS(name='Cell-Group-Information-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _Cell_Group_Information_Item_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Number-of-tunnels')))
    Cell_Group_Information_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 127), ('criticality', 'ignore'), ('Extension', _Cell_Group_Information_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Cell-Group-ID >-----#
    Cell_Group_ID = INT(name='Cell-Group-ID', mode=MODE_TYPE)
    Cell_Group_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=[], er=[])
    
    #-----< CHOInitiation >-----#
    CHOInitiation = ENUM(name='CHOInitiation', mode=MODE_TYPE)
    CHOInitiation._cont = ASN1Dict([('true', 0)])
    CHOInitiation._ext = []
    
    #-----< Number-of-tunnels >-----#
    Number_of_tunnels = INT(name='Number-of-tunnels', mode=MODE_TYPE)
    Number_of_tunnels._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=[], er=[])
    
    #-----< CipheringAlgorithm >-----#
    CipheringAlgorithm = ENUM(name='CipheringAlgorithm', mode=MODE_TYPE)
    CipheringAlgorithm._cont = ASN1Dict([('nEA0', 0), ('c-128-NEA1', 1), ('c-128-NEA2', 2), ('c-128-NEA3', 3)])
    CipheringAlgorithm._ext = []
    
    #-----< CNSupport >-----#
    CNSupport = ENUM(name='CNSupport', mode=MODE_TYPE)
    CNSupport._cont = ASN1Dict([('c-epc', 0), ('c-5gc', 1), ('both', 2)])
    CNSupport._ext = []
    
    #-----< CommonNetworkInstance >-----#
    CommonNetworkInstance = OCT_STR(name='CommonNetworkInstance', mode=MODE_TYPE)
    
    #-----< ConfidentialityProtectionIndication >-----#
    ConfidentialityProtectionIndication = ENUM(name='ConfidentialityProtectionIndication', mode=MODE_TYPE)
    ConfidentialityProtectionIndication._cont = ASN1Dict([('required', 0), ('preferred', 1), ('not-needed', 2)])
    ConfidentialityProtectionIndication._ext = []
    
    #-----< ConfidentialityProtectionResult >-----#
    ConfidentialityProtectionResult = ENUM(name='ConfidentialityProtectionResult', mode=MODE_TYPE)
    ConfidentialityProtectionResult._cont = ASN1Dict([('performed', 0), ('not-performed', 1)])
    ConfidentialityProtectionResult._ext = []
    
    #-----< CP-TNL-Information >-----#
    CP_TNL_Information = CHOICE(name='CP-TNL-Information', mode=MODE_TYPE)
    _CP_TNL_Information_endpoint_IP_Address = BIT_STR(name='endpoint-IP-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    _CP_TNL_Information_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __CP_TNL_Information_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___CP_TNL_Information_choice_extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ____CP_TNL_Information_choice_extension_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Endpoint-IP-address-and-port')))
    ___CP_TNL_Information_choice_extension_id_tab._val = ASN1Set(rv=[dict([('id', 74), ('criticality', 'reject'), ('Value', ____CP_TNL_Information_choice_extension_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __CP_TNL_Information_choice_extension_id._const_tab = ___CP_TNL_Information_choice_extension_id_tab
    __CP_TNL_Information_choice_extension_id._const_tab_at = None
    __CP_TNL_Information_choice_extension_id._const_tab_id = 'id'
    __CP_TNL_Information_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    __CP_TNL_Information_choice_extension_criticality._const_tab = ___CP_TNL_Information_choice_extension_id_tab
    __CP_TNL_Information_choice_extension_criticality._const_tab_at = ('..', 'id')
    __CP_TNL_Information_choice_extension_criticality._const_tab_id = 'criticality'
    __CP_TNL_Information_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    __CP_TNL_Information_choice_extension_value._const_tab = ___CP_TNL_Information_choice_extension_id_tab
    __CP_TNL_Information_choice_extension_value._const_tab_at = ('..', 'id')
    __CP_TNL_Information_choice_extension_value._const_tab_id = 'Value'
    _CP_TNL_Information_choice_extension._cont = ASN1Dict([
        ('id', __CP_TNL_Information_choice_extension_id),
        ('criticality', __CP_TNL_Information_choice_extension_criticality),
        ('value', __CP_TNL_Information_choice_extension_value),
        ])
    _CP_TNL_Information_choice_extension._ext = None
    CP_TNL_Information._cont = ASN1Dict([
        ('endpoint-IP-Address', _CP_TNL_Information_endpoint_IP_Address),
        ('choice-extension', _CP_TNL_Information_choice_extension),
        ])
    CP_TNL_Information._ext = None
    
    #-----< CP-TNL-Information-ExtIEs >-----#
    CP_TNL_Information_ExtIEs = CLASS(name='CP-TNL-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _CP_TNL_Information_ExtIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Endpoint-IP-address-and-port')))
    CP_TNL_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 74), ('criticality', 'reject'), ('Value', _CP_TNL_Information_ExtIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CriticalityDiagnostics >-----#
    CriticalityDiagnostics = SEQ(name='CriticalityDiagnostics', mode=MODE_TYPE)
    _CriticalityDiagnostics_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')), opt=True)
    _CriticalityDiagnostics_triggeringMessage = ENUM(name='triggeringMessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-CommonDataTypes', 'TriggeringMessage')), opt=True)
    _CriticalityDiagnostics_procedureCriticality = ENUM(name='procedureCriticality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-CommonDataTypes', 'Criticality')), opt=True)
    _CriticalityDiagnostics_transactionID = INT(name='transactionID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')), opt=True)
    _CriticalityDiagnostics_iEsCriticalityDiagnostics = SEQ_OF(name='iEsCriticalityDiagnostics', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics-IE-List')), opt=True)
    _CriticalityDiagnostics_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_id = 'id'
    ___CriticalityDiagnostics_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CriticalityDiagnostics_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CriticalityDiagnostics_iE_Extensions__item__id),
        ('criticality', ___CriticalityDiagnostics_iE_Extensions__item__criticality),
        ('extensionValue', ___CriticalityDiagnostics_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_iE_Extensions._cont = __CriticalityDiagnostics_iE_Extensions__item_
    _CriticalityDiagnostics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics._cont = ASN1Dict([
        ('procedureCode', _CriticalityDiagnostics_procedureCode),
        ('triggeringMessage', _CriticalityDiagnostics_triggeringMessage),
        ('procedureCriticality', _CriticalityDiagnostics_procedureCriticality),
        ('transactionID', _CriticalityDiagnostics_transactionID),
        ('iEsCriticalityDiagnostics', _CriticalityDiagnostics_iEsCriticalityDiagnostics),
        ('iE-Extensions', _CriticalityDiagnostics_iE_Extensions),
        ])
    CriticalityDiagnostics._ext = []
    
    #-----< CriticalityDiagnostics-ExtIEs >-----#
    CriticalityDiagnostics_ExtIEs = CLASS(name='CriticalityDiagnostics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CriticalityDiagnostics-IE-List >-----#
    CriticalityDiagnostics_IE_List = SEQ_OF(name='CriticalityDiagnostics-IE-List', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_List__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CriticalityDiagnostics_IE_List__item__iECriticality = ENUM(name='iECriticality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-CommonDataTypes', 'Criticality')))
    __CriticalityDiagnostics_IE_List__item__iE_ID = INT(name='iE-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProtocolIE-ID')))
    __CriticalityDiagnostics_IE_List__item__typeOfError = ENUM(name='typeOfError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'TypeOfError')))
    __CriticalityDiagnostics_IE_List__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_at = None
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id),
        ('criticality', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality),
        ('extensionValue', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue),
        ])
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._ext = None
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._cont = ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _CriticalityDiagnostics_IE_List__item_._cont = ASN1Dict([
        ('iECriticality', __CriticalityDiagnostics_IE_List__item__iECriticality),
        ('iE-ID', __CriticalityDiagnostics_IE_List__item__iE_ID),
        ('typeOfError', __CriticalityDiagnostics_IE_List__item__typeOfError),
        ('iE-Extensions', __CriticalityDiagnostics_IE_List__item__iE_Extensions),
        ])
    _CriticalityDiagnostics_IE_List__item_._ext = []
    CriticalityDiagnostics_IE_List._cont = _CriticalityDiagnostics_IE_List__item_
    CriticalityDiagnostics_IE_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CriticalityDiagnostics-IE-List-ExtIEs >-----#
    CriticalityDiagnostics_IE_List_ExtIEs = CLASS(name='CriticalityDiagnostics-IE-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_IE_List_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DAPSRequestInfo >-----#
    DAPSRequestInfo = SEQ(name='DAPSRequestInfo', mode=MODE_TYPE)
    _DAPSRequestInfo_dapsIndicator = ENUM(name='dapsIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DAPSRequestInfo_dapsIndicator._cont = ASN1Dict([('daps-HO-required', 0)])
    _DAPSRequestInfo_dapsIndicator._ext = []
    _DAPSRequestInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DAPSRequestInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DAPSRequestInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DAPSRequestInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DAPSRequestInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSRequestInfo_iE_Extensions__item__id._const_tab = ____DAPSRequestInfo_iE_Extensions__item__id_tab
    ___DAPSRequestInfo_iE_Extensions__item__id._const_tab_at = None
    ___DAPSRequestInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___DAPSRequestInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DAPSRequestInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DAPSRequestInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSRequestInfo_iE_Extensions__item__criticality._const_tab = ____DAPSRequestInfo_iE_Extensions__item__criticality_tab
    ___DAPSRequestInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DAPSRequestInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DAPSRequestInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DAPSRequestInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DAPSRequestInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSRequestInfo_iE_Extensions__item__extensionValue._const_tab = ____DAPSRequestInfo_iE_Extensions__item__extensionValue_tab
    ___DAPSRequestInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DAPSRequestInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DAPSRequestInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DAPSRequestInfo_iE_Extensions__item__id),
        ('criticality', ___DAPSRequestInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___DAPSRequestInfo_iE_Extensions__item__extensionValue),
        ])
    __DAPSRequestInfo_iE_Extensions__item_._ext = None
    _DAPSRequestInfo_iE_Extensions._cont = __DAPSRequestInfo_iE_Extensions__item_
    _DAPSRequestInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DAPSRequestInfo._cont = ASN1Dict([
        ('dapsIndicator', _DAPSRequestInfo_dapsIndicator),
        ('iE-Extensions', _DAPSRequestInfo_iE_Extensions),
        ])
    DAPSRequestInfo._ext = []
    
    #-----< DAPSRequestInfo-ExtIEs >-----#
    DAPSRequestInfo_ExtIEs = CLASS(name='DAPSRequestInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DAPSRequestInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Data-Forwarding-Information-Request >-----#
    Data_Forwarding_Information_Request = SEQ(name='Data-Forwarding-Information-Request', mode=MODE_TYPE)
    _Data_Forwarding_Information_Request_data_Forwarding_Request = ENUM(name='data-Forwarding-Request', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Data-Forwarding-Request')))
    _Data_Forwarding_Information_Request_qoS_Flows_Forwarded_On_Fwd_Tunnels = SEQ_OF(name='qoS-Flows-Forwarded-On-Fwd-Tunnels', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Mapping-List')), opt=True)
    _Data_Forwarding_Information_Request_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Data_Forwarding_Information_Request_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___Data_Forwarding_Information_Request_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Data_Forwarding_Information_Request_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Data_Forwarding_Information_Request_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Data_Forwarding_Information_Request_iE_Extensions__item__id._const_tab = ____Data_Forwarding_Information_Request_iE_Extensions__item__id_tab
    ___Data_Forwarding_Information_Request_iE_Extensions__item__id._const_tab_at = None
    ___Data_Forwarding_Information_Request_iE_Extensions__item__id._const_tab_id = 'id'
    ___Data_Forwarding_Information_Request_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Data_Forwarding_Information_Request_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Data_Forwarding_Information_Request_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Data_Forwarding_Information_Request_iE_Extensions__item__criticality._const_tab = ____Data_Forwarding_Information_Request_iE_Extensions__item__criticality_tab
    ___Data_Forwarding_Information_Request_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Data_Forwarding_Information_Request_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Data_Forwarding_Information_Request_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Data_Forwarding_Information_Request_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Data_Forwarding_Information_Request_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Data_Forwarding_Information_Request_iE_Extensions__item__extensionValue._const_tab = ____Data_Forwarding_Information_Request_iE_Extensions__item__extensionValue_tab
    ___Data_Forwarding_Information_Request_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Data_Forwarding_Information_Request_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Data_Forwarding_Information_Request_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Data_Forwarding_Information_Request_iE_Extensions__item__id),
        ('criticality', ___Data_Forwarding_Information_Request_iE_Extensions__item__criticality),
        ('extensionValue', ___Data_Forwarding_Information_Request_iE_Extensions__item__extensionValue),
        ])
    __Data_Forwarding_Information_Request_iE_Extensions__item_._ext = None
    _Data_Forwarding_Information_Request_iE_Extensions._cont = __Data_Forwarding_Information_Request_iE_Extensions__item_
    _Data_Forwarding_Information_Request_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Data_Forwarding_Information_Request._cont = ASN1Dict([
        ('data-Forwarding-Request', _Data_Forwarding_Information_Request_data_Forwarding_Request),
        ('qoS-Flows-Forwarded-On-Fwd-Tunnels', _Data_Forwarding_Information_Request_qoS_Flows_Forwarded_On_Fwd_Tunnels),
        ('iE-Extensions', _Data_Forwarding_Information_Request_iE_Extensions),
        ])
    Data_Forwarding_Information_Request._ext = []
    
    #-----< Data-Forwarding-Information-Request-ExtIEs >-----#
    Data_Forwarding_Information_Request_ExtIEs = CLASS(name='Data-Forwarding-Information-Request-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    Data_Forwarding_Information_Request_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Data-Forwarding-Information >-----#
    Data_Forwarding_Information = SEQ(name='Data-Forwarding-Information', mode=MODE_TYPE)
    _Data_Forwarding_Information_uL_Data_Forwarding = CHOICE(name='uL-Data-Forwarding', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')), opt=True)
    _Data_Forwarding_Information_dL_Data_Forwarding = CHOICE(name='dL-Data-Forwarding', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')), opt=True)
    _Data_Forwarding_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Data_Forwarding_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___Data_Forwarding_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Data_Forwarding_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____Data_Forwarding_Information_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DataForwardingtoNG-RANQoSFlowInformationList')))
    ____Data_Forwarding_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 136), ('criticality', 'ignore'), ('Extension', _____Data_Forwarding_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Data_Forwarding_Information_iE_Extensions__item__id._const_tab = ____Data_Forwarding_Information_iE_Extensions__item__id_tab
    ___Data_Forwarding_Information_iE_Extensions__item__id._const_tab_at = None
    ___Data_Forwarding_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___Data_Forwarding_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Data_Forwarding_Information_iE_Extensions__item__criticality._const_tab = ____Data_Forwarding_Information_iE_Extensions__item__id_tab
    ___Data_Forwarding_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Data_Forwarding_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Data_Forwarding_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Data_Forwarding_Information_iE_Extensions__item__extensionValue._const_tab = ____Data_Forwarding_Information_iE_Extensions__item__id_tab
    ___Data_Forwarding_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Data_Forwarding_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Data_Forwarding_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Data_Forwarding_Information_iE_Extensions__item__id),
        ('criticality', ___Data_Forwarding_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___Data_Forwarding_Information_iE_Extensions__item__extensionValue),
        ])
    __Data_Forwarding_Information_iE_Extensions__item_._ext = None
    _Data_Forwarding_Information_iE_Extensions._cont = __Data_Forwarding_Information_iE_Extensions__item_
    _Data_Forwarding_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Data_Forwarding_Information._cont = ASN1Dict([
        ('uL-Data-Forwarding', _Data_Forwarding_Information_uL_Data_Forwarding),
        ('dL-Data-Forwarding', _Data_Forwarding_Information_dL_Data_Forwarding),
        ('iE-Extensions', _Data_Forwarding_Information_iE_Extensions),
        ])
    Data_Forwarding_Information._ext = []
    
    #-----< Data-Forwarding-Information-ExtIEs >-----#
    Data_Forwarding_Information_ExtIEs = CLASS(name='Data-Forwarding-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _Data_Forwarding_Information_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DataForwardingtoNG-RANQoSFlowInformationList')))
    Data_Forwarding_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 136), ('criticality', 'ignore'), ('Extension', _Data_Forwarding_Information_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Data-Forwarding-Request >-----#
    Data_Forwarding_Request = ENUM(name='Data-Forwarding-Request', mode=MODE_TYPE)
    Data_Forwarding_Request._cont = ASN1Dict([('uL', 0), ('dL', 1), ('both', 2)])
    Data_Forwarding_Request._ext = []
    
    #-----< DataForwardingtoE-UTRANInformationList >-----#
    DataForwardingtoE_UTRANInformationList = SEQ_OF(name='DataForwardingtoE-UTRANInformationList', mode=MODE_TYPE)
    _DataForwardingtoE_UTRANInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DataForwardingtoE-UTRANInformationListItem')))
    DataForwardingtoE_UTRANInformationList._cont = _DataForwardingtoE_UTRANInformationList__item_
    DataForwardingtoE_UTRANInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< DataForwardingtoE-UTRANInformationListItem >-----#
    DataForwardingtoE_UTRANInformationListItem = SEQ(name='DataForwardingtoE-UTRANInformationListItem', mode=MODE_TYPE)
    _DataForwardingtoE_UTRANInformationListItem_data_forwarding_tunnel_information = CHOICE(name='data-forwarding-tunnel-information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _DataForwardingtoE_UTRANInformationListItem_qoS_Flows_to_be_forwarded_List = SEQ_OF(name='qoS-Flows-to-be-forwarded-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flows-to-be-forwarded-List')))
    _DataForwardingtoE_UTRANInformationListItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__id._const_tab = ____DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__id_tab
    ___DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__id._const_tab_at = None
    ___DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__criticality._const_tab = ____DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__criticality_tab
    ___DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__extensionValue._const_tab = ____DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__extensionValue_tab
    ___DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__id),
        ('criticality', ___DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__criticality),
        ('extensionValue', ___DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__extensionValue),
        ])
    __DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item_._ext = None
    _DataForwardingtoE_UTRANInformationListItem_iE_Extensions._cont = __DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item_
    _DataForwardingtoE_UTRANInformationListItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DataForwardingtoE_UTRANInformationListItem._cont = ASN1Dict([
        ('data-forwarding-tunnel-information', _DataForwardingtoE_UTRANInformationListItem_data_forwarding_tunnel_information),
        ('qoS-Flows-to-be-forwarded-List', _DataForwardingtoE_UTRANInformationListItem_qoS_Flows_to_be_forwarded_List),
        ('iE-Extensions', _DataForwardingtoE_UTRANInformationListItem_iE_Extensions),
        ])
    DataForwardingtoE_UTRANInformationListItem._ext = []
    
    #-----< DataForwardingtoE-UTRANInformationListItem-ExtIEs >-----#
    DataForwardingtoE_UTRANInformationListItem_ExtIEs = CLASS(name='DataForwardingtoE-UTRANInformationListItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DataForwardingtoE_UTRANInformationListItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Data-Usage-per-PDU-Session-Report >-----#
    Data_Usage_per_PDU_Session_Report = SEQ(name='Data-Usage-per-PDU-Session-Report', mode=MODE_TYPE)
    _Data_Usage_per_PDU_Session_Report_secondaryRATType = ENUM(name='secondaryRATType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Data_Usage_per_PDU_Session_Report_secondaryRATType._cont = ASN1Dict([('nR', 0), ('e-UTRA', 1)])
    _Data_Usage_per_PDU_Session_Report_secondaryRATType._ext = []
    _Data_Usage_per_PDU_Session_Report_pDU_session_Timed_Report_List = SEQ_OF(name='pDU-session-Timed-Report-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Data_Usage_per_PDU_Session_Report_pDU_session_Timed_Report_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MRDC-Data-Usage-Report-Item')))
    _Data_Usage_per_PDU_Session_Report_pDU_session_Timed_Report_List._cont = __Data_Usage_per_PDU_Session_Report_pDU_session_Timed_Report_List__item_
    _Data_Usage_per_PDU_Session_Report_pDU_session_Timed_Report_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _Data_Usage_per_PDU_Session_Report_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Data_Usage_per_PDU_Session_Report_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___Data_Usage_per_PDU_Session_Report_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Data_Usage_per_PDU_Session_Report_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Data_Usage_per_PDU_Session_Report_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Data_Usage_per_PDU_Session_Report_iE_Extensions__item__id._const_tab = ____Data_Usage_per_PDU_Session_Report_iE_Extensions__item__id_tab
    ___Data_Usage_per_PDU_Session_Report_iE_Extensions__item__id._const_tab_at = None
    ___Data_Usage_per_PDU_Session_Report_iE_Extensions__item__id._const_tab_id = 'id'
    ___Data_Usage_per_PDU_Session_Report_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Data_Usage_per_PDU_Session_Report_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Data_Usage_per_PDU_Session_Report_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Data_Usage_per_PDU_Session_Report_iE_Extensions__item__criticality._const_tab = ____Data_Usage_per_PDU_Session_Report_iE_Extensions__item__criticality_tab
    ___Data_Usage_per_PDU_Session_Report_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Data_Usage_per_PDU_Session_Report_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Data_Usage_per_PDU_Session_Report_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Data_Usage_per_PDU_Session_Report_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Data_Usage_per_PDU_Session_Report_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Data_Usage_per_PDU_Session_Report_iE_Extensions__item__extensionValue._const_tab = ____Data_Usage_per_PDU_Session_Report_iE_Extensions__item__extensionValue_tab
    ___Data_Usage_per_PDU_Session_Report_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Data_Usage_per_PDU_Session_Report_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Data_Usage_per_PDU_Session_Report_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Data_Usage_per_PDU_Session_Report_iE_Extensions__item__id),
        ('criticality', ___Data_Usage_per_PDU_Session_Report_iE_Extensions__item__criticality),
        ('extensionValue', ___Data_Usage_per_PDU_Session_Report_iE_Extensions__item__extensionValue),
        ])
    __Data_Usage_per_PDU_Session_Report_iE_Extensions__item_._ext = None
    _Data_Usage_per_PDU_Session_Report_iE_Extensions._cont = __Data_Usage_per_PDU_Session_Report_iE_Extensions__item_
    _Data_Usage_per_PDU_Session_Report_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Data_Usage_per_PDU_Session_Report._cont = ASN1Dict([
        ('secondaryRATType', _Data_Usage_per_PDU_Session_Report_secondaryRATType),
        ('pDU-session-Timed-Report-List', _Data_Usage_per_PDU_Session_Report_pDU_session_Timed_Report_List),
        ('iE-Extensions', _Data_Usage_per_PDU_Session_Report_iE_Extensions),
        ])
    Data_Usage_per_PDU_Session_Report._ext = []
    
    #-----< Data-Usage-per-PDU-Session-Report-ExtIEs >-----#
    Data_Usage_per_PDU_Session_Report_ExtIEs = CLASS(name='Data-Usage-per-PDU-Session-Report-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    Data_Usage_per_PDU_Session_Report_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Data-Usage-per-QoS-Flow-List >-----#
    Data_Usage_per_QoS_Flow_List = SEQ_OF(name='Data-Usage-per-QoS-Flow-List', mode=MODE_TYPE)
    _Data_Usage_per_QoS_Flow_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Data-Usage-per-QoS-Flow-Item')))
    Data_Usage_per_QoS_Flow_List._cont = _Data_Usage_per_QoS_Flow_List__item_
    Data_Usage_per_QoS_Flow_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< Data-Usage-per-QoS-Flow-Item >-----#
    Data_Usage_per_QoS_Flow_Item = SEQ(name='Data-Usage-per-QoS-Flow-Item', mode=MODE_TYPE)
    _Data_Usage_per_QoS_Flow_Item_qoS_Flow_Identifier = INT(name='qoS-Flow-Identifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Identifier')))
    _Data_Usage_per_QoS_Flow_Item_secondaryRATType = ENUM(name='secondaryRATType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Data_Usage_per_QoS_Flow_Item_secondaryRATType._cont = ASN1Dict([('nR', 0), ('e-UTRA', 1)])
    _Data_Usage_per_QoS_Flow_Item_secondaryRATType._ext = []
    _Data_Usage_per_QoS_Flow_Item_qoS_Flow_Timed_Report_List = SEQ_OF(name='qoS-Flow-Timed-Report-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Data_Usage_per_QoS_Flow_Item_qoS_Flow_Timed_Report_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MRDC-Data-Usage-Report-Item')))
    _Data_Usage_per_QoS_Flow_Item_qoS_Flow_Timed_Report_List._cont = __Data_Usage_per_QoS_Flow_Item_qoS_Flow_Timed_Report_List__item_
    _Data_Usage_per_QoS_Flow_Item_qoS_Flow_Timed_Report_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _Data_Usage_per_QoS_Flow_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Data_Usage_per_QoS_Flow_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__id._const_tab = ____Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__id_tab
    ___Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__id._const_tab_at = None
    ___Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__criticality._const_tab = ____Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__criticality_tab
    ___Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__extensionValue._const_tab = ____Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__extensionValue_tab
    ___Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Data_Usage_per_QoS_Flow_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__id),
        ('criticality', ___Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__extensionValue),
        ])
    __Data_Usage_per_QoS_Flow_Item_iE_Extensions__item_._ext = None
    _Data_Usage_per_QoS_Flow_Item_iE_Extensions._cont = __Data_Usage_per_QoS_Flow_Item_iE_Extensions__item_
    _Data_Usage_per_QoS_Flow_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Data_Usage_per_QoS_Flow_Item._cont = ASN1Dict([
        ('qoS-Flow-Identifier', _Data_Usage_per_QoS_Flow_Item_qoS_Flow_Identifier),
        ('secondaryRATType', _Data_Usage_per_QoS_Flow_Item_secondaryRATType),
        ('qoS-Flow-Timed-Report-List', _Data_Usage_per_QoS_Flow_Item_qoS_Flow_Timed_Report_List),
        ('iE-Extensions', _Data_Usage_per_QoS_Flow_Item_iE_Extensions),
        ])
    Data_Usage_per_QoS_Flow_Item._ext = []
    
    #-----< Data-Usage-per-QoS-Flow-Item-ExtIEs >-----#
    Data_Usage_per_QoS_Flow_Item_ExtIEs = CLASS(name='Data-Usage-per-QoS-Flow-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    Data_Usage_per_QoS_Flow_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Data-Usage-Report-List >-----#
    Data_Usage_Report_List = SEQ_OF(name='Data-Usage-Report-List', mode=MODE_TYPE)
    _Data_Usage_Report_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Data-Usage-Report-Item')))
    Data_Usage_Report_List._cont = _Data_Usage_Report_List__item_
    Data_Usage_Report_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Data-Usage-Report-Item >-----#
    Data_Usage_Report_Item = SEQ(name='Data-Usage-Report-Item', mode=MODE_TYPE)
    _Data_Usage_Report_Item_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _Data_Usage_Report_Item_rAT_Type = ENUM(name='rAT-Type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'RAT-Type')))
    _Data_Usage_Report_Item_dRB_Usage_Report_List = SEQ_OF(name='dRB-Usage-Report-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-Usage-Report-List')))
    _Data_Usage_Report_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Data_Usage_Report_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___Data_Usage_Report_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Data_Usage_Report_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Data_Usage_Report_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Data_Usage_Report_Item_iE_Extensions__item__id._const_tab = ____Data_Usage_Report_Item_iE_Extensions__item__id_tab
    ___Data_Usage_Report_Item_iE_Extensions__item__id._const_tab_at = None
    ___Data_Usage_Report_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Data_Usage_Report_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Data_Usage_Report_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Data_Usage_Report_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Data_Usage_Report_Item_iE_Extensions__item__criticality._const_tab = ____Data_Usage_Report_Item_iE_Extensions__item__criticality_tab
    ___Data_Usage_Report_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Data_Usage_Report_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Data_Usage_Report_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Data_Usage_Report_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Data_Usage_Report_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Data_Usage_Report_Item_iE_Extensions__item__extensionValue._const_tab = ____Data_Usage_Report_Item_iE_Extensions__item__extensionValue_tab
    ___Data_Usage_Report_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Data_Usage_Report_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Data_Usage_Report_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Data_Usage_Report_Item_iE_Extensions__item__id),
        ('criticality', ___Data_Usage_Report_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Data_Usage_Report_Item_iE_Extensions__item__extensionValue),
        ])
    __Data_Usage_Report_Item_iE_Extensions__item_._ext = None
    _Data_Usage_Report_Item_iE_Extensions._cont = __Data_Usage_Report_Item_iE_Extensions__item_
    _Data_Usage_Report_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Data_Usage_Report_Item._cont = ASN1Dict([
        ('dRB-ID', _Data_Usage_Report_Item_dRB_ID),
        ('rAT-Type', _Data_Usage_Report_Item_rAT_Type),
        ('dRB-Usage-Report-List', _Data_Usage_Report_Item_dRB_Usage_Report_List),
        ('iE-Extensions', _Data_Usage_Report_Item_iE_Extensions),
        ])
    Data_Usage_Report_Item._ext = []
    
    #-----< Data-Usage-Report-ItemExtIEs >-----#
    Data_Usage_Report_ItemExtIEs = CLASS(name='Data-Usage-Report-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    Data_Usage_Report_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DefaultDRB >-----#
    DefaultDRB = ENUM(name='DefaultDRB', mode=MODE_TYPE)
    DefaultDRB._cont = ASN1Dict([('true', 0), ('false', 1)])
    DefaultDRB._ext = []
    
    #-----< Dictionary >-----#
    Dictionary = ENUM(name='Dictionary', mode=MODE_TYPE)
    Dictionary._cont = ASN1Dict([('sip-SDP', 0), ('operator', 1)])
    Dictionary._ext = []
    
    #-----< DirectForwardingPathAvailability >-----#
    DirectForwardingPathAvailability = ENUM(name='DirectForwardingPathAvailability', mode=MODE_TYPE)
    DirectForwardingPathAvailability._cont = ASN1Dict([('inter-system-direct-path-available', 0), ('intra-system-direct-path-available', 1)])
    DirectForwardingPathAvailability._ext = ['intra-system-direct-path-available']
    
    #-----< DiscardTimer >-----#
    DiscardTimer = ENUM(name='DiscardTimer', mode=MODE_TYPE)
    DiscardTimer._cont = ASN1Dict([('ms10', 0), ('ms20', 1), ('ms30', 2), ('ms40', 3), ('ms50', 4), ('ms60', 5), ('ms75', 6), ('ms100', 7), ('ms150', 8), ('ms200', 9), ('ms250', 10), ('ms300', 11), ('ms500', 12), ('ms750', 13), ('ms1500', 14), ('infinity', 15)])
    DiscardTimer._ext = None
    
    #-----< DiscardTimerExtended >-----#
    DiscardTimerExtended = ENUM(name='DiscardTimerExtended', mode=MODE_TYPE)
    DiscardTimerExtended._cont = ASN1Dict([('ms0dot5', 0), ('ms1', 1), ('ms2', 2), ('ms4', 3), ('ms6', 4), ('ms8', 5), ('ms2000', 6)])
    DiscardTimerExtended._ext = ['ms2000']
    
    #-----< DLDiscarding >-----#
    DLDiscarding = SEQ(name='DLDiscarding', mode=MODE_TYPE)
    _DLDiscarding_dLDiscardingCountVal = SEQ(name='dLDiscardingCountVal', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-Count')))
    _DLDiscarding_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DLDiscarding_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DLDiscarding_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DLDiscarding_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DLDiscarding_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLDiscarding_iE_Extensions__item__id._const_tab = ____DLDiscarding_iE_Extensions__item__id_tab
    ___DLDiscarding_iE_Extensions__item__id._const_tab_at = None
    ___DLDiscarding_iE_Extensions__item__id._const_tab_id = 'id'
    ___DLDiscarding_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DLDiscarding_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DLDiscarding_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLDiscarding_iE_Extensions__item__criticality._const_tab = ____DLDiscarding_iE_Extensions__item__criticality_tab
    ___DLDiscarding_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DLDiscarding_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DLDiscarding_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DLDiscarding_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DLDiscarding_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLDiscarding_iE_Extensions__item__extensionValue._const_tab = ____DLDiscarding_iE_Extensions__item__extensionValue_tab
    ___DLDiscarding_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DLDiscarding_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DLDiscarding_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DLDiscarding_iE_Extensions__item__id),
        ('criticality', ___DLDiscarding_iE_Extensions__item__criticality),
        ('extensionValue', ___DLDiscarding_iE_Extensions__item__extensionValue),
        ])
    __DLDiscarding_iE_Extensions__item_._ext = None
    _DLDiscarding_iE_Extensions._cont = __DLDiscarding_iE_Extensions__item_
    _DLDiscarding_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DLDiscarding._cont = ASN1Dict([
        ('dLDiscardingCountVal', _DLDiscarding_dLDiscardingCountVal),
        ('iE-Extensions', _DLDiscarding_iE_Extensions),
        ])
    DLDiscarding._ext = None
    
    #-----< DLDiscarding-ExtIEs >-----#
    DLDiscarding_ExtIEs = CLASS(name='DLDiscarding-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DLDiscarding_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DLUPTNLAddressToUpdateItem >-----#
    DLUPTNLAddressToUpdateItem = SEQ(name='DLUPTNLAddressToUpdateItem', mode=MODE_TYPE)
    _DLUPTNLAddressToUpdateItem_oldTNLAdress = BIT_STR(name='oldTNLAdress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    _DLUPTNLAddressToUpdateItem_newTNLAdress = BIT_STR(name='newTNLAdress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    _DLUPTNLAddressToUpdateItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DLUPTNLAddressToUpdateItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DLUPTNLAddressToUpdateItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DLUPTNLAddressToUpdateItem_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DLUPTNLAddressToUpdateItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLUPTNLAddressToUpdateItem_iE_Extensions__item__id._const_tab = ____DLUPTNLAddressToUpdateItem_iE_Extensions__item__id_tab
    ___DLUPTNLAddressToUpdateItem_iE_Extensions__item__id._const_tab_at = None
    ___DLUPTNLAddressToUpdateItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___DLUPTNLAddressToUpdateItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DLUPTNLAddressToUpdateItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DLUPTNLAddressToUpdateItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLUPTNLAddressToUpdateItem_iE_Extensions__item__criticality._const_tab = ____DLUPTNLAddressToUpdateItem_iE_Extensions__item__criticality_tab
    ___DLUPTNLAddressToUpdateItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DLUPTNLAddressToUpdateItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DLUPTNLAddressToUpdateItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DLUPTNLAddressToUpdateItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DLUPTNLAddressToUpdateItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLUPTNLAddressToUpdateItem_iE_Extensions__item__extensionValue._const_tab = ____DLUPTNLAddressToUpdateItem_iE_Extensions__item__extensionValue_tab
    ___DLUPTNLAddressToUpdateItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DLUPTNLAddressToUpdateItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DLUPTNLAddressToUpdateItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DLUPTNLAddressToUpdateItem_iE_Extensions__item__id),
        ('criticality', ___DLUPTNLAddressToUpdateItem_iE_Extensions__item__criticality),
        ('extensionValue', ___DLUPTNLAddressToUpdateItem_iE_Extensions__item__extensionValue),
        ])
    __DLUPTNLAddressToUpdateItem_iE_Extensions__item_._ext = None
    _DLUPTNLAddressToUpdateItem_iE_Extensions._cont = __DLUPTNLAddressToUpdateItem_iE_Extensions__item_
    _DLUPTNLAddressToUpdateItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DLUPTNLAddressToUpdateItem._cont = ASN1Dict([
        ('oldTNLAdress', _DLUPTNLAddressToUpdateItem_oldTNLAdress),
        ('newTNLAdress', _DLUPTNLAddressToUpdateItem_newTNLAdress),
        ('iE-Extensions', _DLUPTNLAddressToUpdateItem_iE_Extensions),
        ])
    DLUPTNLAddressToUpdateItem._ext = []
    
    #-----< DLUPTNLAddressToUpdateItemExtIEs >-----#
    DLUPTNLAddressToUpdateItemExtIEs = CLASS(name='DLUPTNLAddressToUpdateItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DLUPTNLAddressToUpdateItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-TX-Stop >-----#
    DL_TX_Stop = ENUM(name='DL-TX-Stop', mode=MODE_TYPE)
    DL_TX_Stop._cont = ASN1Dict([('stop', 0), ('resume', 1)])
    DL_TX_Stop._ext = []
    
    #-----< DRB-Activity >-----#
    DRB_Activity = ENUM(name='DRB-Activity', mode=MODE_TYPE)
    DRB_Activity._cont = ASN1Dict([('active', 0), ('not-active', 1)])
    DRB_Activity._ext = []
    
    #-----< DRB-Activity-List >-----#
    DRB_Activity_List = SEQ_OF(name='DRB-Activity-List', mode=MODE_TYPE)
    _DRB_Activity_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Activity-Item')))
    DRB_Activity_List._cont = _DRB_Activity_List__item_
    DRB_Activity_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-Activity-Item >-----#
    DRB_Activity_Item = SEQ(name='DRB-Activity-Item', mode=MODE_TYPE)
    _DRB_Activity_Item_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_Activity_Item_dRB_Activity = ENUM(name='dRB-Activity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-Activity')))
    _DRB_Activity_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Activity_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Activity_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Activity_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Activity_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Activity_Item_iE_Extensions__item__id._const_tab = ____DRB_Activity_Item_iE_Extensions__item__id_tab
    ___DRB_Activity_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Activity_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Activity_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRB_Activity_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Activity_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Activity_Item_iE_Extensions__item__criticality._const_tab = ____DRB_Activity_Item_iE_Extensions__item__criticality_tab
    ___DRB_Activity_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Activity_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Activity_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRB_Activity_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Activity_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Activity_Item_iE_Extensions__item__extensionValue._const_tab = ____DRB_Activity_Item_iE_Extensions__item__extensionValue_tab
    ___DRB_Activity_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Activity_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Activity_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Activity_Item_iE_Extensions__item__id),
        ('criticality', ___DRB_Activity_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Activity_Item_iE_Extensions__item__extensionValue),
        ])
    __DRB_Activity_Item_iE_Extensions__item_._ext = None
    _DRB_Activity_Item_iE_Extensions._cont = __DRB_Activity_Item_iE_Extensions__item_
    _DRB_Activity_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Activity_Item._cont = ASN1Dict([
        ('dRB-ID', _DRB_Activity_Item_dRB_ID),
        ('dRB-Activity', _DRB_Activity_Item_dRB_Activity),
        ('iE-Extensions', _DRB_Activity_Item_iE_Extensions),
        ])
    DRB_Activity_Item._ext = []
    
    #-----< DRB-Activity-ItemExtIEs >-----#
    DRB_Activity_ItemExtIEs = CLASS(name='DRB-Activity-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRB_Activity_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-Confirm-Modified-List-EUTRAN >-----#
    DRB_Confirm_Modified_List_EUTRAN = SEQ_OF(name='DRB-Confirm-Modified-List-EUTRAN', mode=MODE_TYPE)
    _DRB_Confirm_Modified_List_EUTRAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Confirm-Modified-Item-EUTRAN')))
    DRB_Confirm_Modified_List_EUTRAN._cont = _DRB_Confirm_Modified_List_EUTRAN__item_
    DRB_Confirm_Modified_List_EUTRAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-Confirm-Modified-Item-EUTRAN >-----#
    DRB_Confirm_Modified_Item_EUTRAN = SEQ(name='DRB-Confirm-Modified-Item-EUTRAN', mode=MODE_TYPE)
    _DRB_Confirm_Modified_Item_EUTRAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_Confirm_Modified_Item_EUTRAN_cell_Group_Information = SEQ_OF(name='cell-Group-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cell-Group-Information')), opt=True)
    _DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__id._const_tab = ____DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__id_tab
    ___DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__criticality._const_tab = ____DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__criticality_tab
    ___DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__extensionValue_tab
    ___DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__id),
        ('criticality', ___DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item_._ext = None
    _DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions._cont = __DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item_
    _DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Confirm_Modified_Item_EUTRAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_Confirm_Modified_Item_EUTRAN_dRB_ID),
        ('cell-Group-Information', _DRB_Confirm_Modified_Item_EUTRAN_cell_Group_Information),
        ('iE-Extensions', _DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions),
        ])
    DRB_Confirm_Modified_Item_EUTRAN._ext = []
    
    #-----< DRB-Confirm-Modified-Item-EUTRAN-ExtIEs >-----#
    DRB_Confirm_Modified_Item_EUTRAN_ExtIEs = CLASS(name='DRB-Confirm-Modified-Item-EUTRAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRB_Confirm_Modified_Item_EUTRAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-Confirm-Modified-List-NG-RAN >-----#
    DRB_Confirm_Modified_List_NG_RAN = SEQ_OF(name='DRB-Confirm-Modified-List-NG-RAN', mode=MODE_TYPE)
    _DRB_Confirm_Modified_List_NG_RAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Confirm-Modified-Item-NG-RAN')))
    DRB_Confirm_Modified_List_NG_RAN._cont = _DRB_Confirm_Modified_List_NG_RAN__item_
    DRB_Confirm_Modified_List_NG_RAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-Confirm-Modified-Item-NG-RAN >-----#
    DRB_Confirm_Modified_Item_NG_RAN = SEQ(name='DRB-Confirm-Modified-Item-NG-RAN', mode=MODE_TYPE)
    _DRB_Confirm_Modified_Item_NG_RAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_Confirm_Modified_Item_NG_RAN_cell_Group_Information = SEQ_OF(name='cell-Group-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cell-Group-Information')), opt=True)
    _DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__id._const_tab = ____DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__id_tab
    ___DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__criticality._const_tab = ____DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__criticality_tab
    ___DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__extensionValue_tab
    ___DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__id),
        ('criticality', ___DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item_._ext = None
    _DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions._cont = __DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item_
    _DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Confirm_Modified_Item_NG_RAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_Confirm_Modified_Item_NG_RAN_dRB_ID),
        ('cell-Group-Information', _DRB_Confirm_Modified_Item_NG_RAN_cell_Group_Information),
        ('iE-Extensions', _DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions),
        ])
    DRB_Confirm_Modified_Item_NG_RAN._ext = []
    
    #-----< DRB-Confirm-Modified-Item-NG-RAN-ExtIEs >-----#
    DRB_Confirm_Modified_Item_NG_RAN_ExtIEs = CLASS(name='DRB-Confirm-Modified-Item-NG-RAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRB_Confirm_Modified_Item_NG_RAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-Failed-List-EUTRAN >-----#
    DRB_Failed_List_EUTRAN = SEQ_OF(name='DRB-Failed-List-EUTRAN', mode=MODE_TYPE)
    _DRB_Failed_List_EUTRAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Failed-Item-EUTRAN')))
    DRB_Failed_List_EUTRAN._cont = _DRB_Failed_List_EUTRAN__item_
    DRB_Failed_List_EUTRAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-Failed-Item-EUTRAN >-----#
    DRB_Failed_Item_EUTRAN = SEQ(name='DRB-Failed-Item-EUTRAN', mode=MODE_TYPE)
    _DRB_Failed_Item_EUTRAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_Failed_Item_EUTRAN_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _DRB_Failed_Item_EUTRAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Failed_Item_EUTRAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Failed_Item_EUTRAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Failed_Item_EUTRAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Failed_Item_EUTRAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Failed_Item_EUTRAN_iE_Extensions__item__id._const_tab = ____DRB_Failed_Item_EUTRAN_iE_Extensions__item__id_tab
    ___DRB_Failed_Item_EUTRAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Failed_Item_EUTRAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Failed_Item_EUTRAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRB_Failed_Item_EUTRAN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Failed_Item_EUTRAN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Failed_Item_EUTRAN_iE_Extensions__item__criticality._const_tab = ____DRB_Failed_Item_EUTRAN_iE_Extensions__item__criticality_tab
    ___DRB_Failed_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Failed_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Failed_Item_EUTRAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRB_Failed_Item_EUTRAN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Failed_Item_EUTRAN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Failed_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_Failed_Item_EUTRAN_iE_Extensions__item__extensionValue_tab
    ___DRB_Failed_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Failed_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Failed_Item_EUTRAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Failed_Item_EUTRAN_iE_Extensions__item__id),
        ('criticality', ___DRB_Failed_Item_EUTRAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Failed_Item_EUTRAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_Failed_Item_EUTRAN_iE_Extensions__item_._ext = None
    _DRB_Failed_Item_EUTRAN_iE_Extensions._cont = __DRB_Failed_Item_EUTRAN_iE_Extensions__item_
    _DRB_Failed_Item_EUTRAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Failed_Item_EUTRAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_Failed_Item_EUTRAN_dRB_ID),
        ('cause', _DRB_Failed_Item_EUTRAN_cause),
        ('iE-Extensions', _DRB_Failed_Item_EUTRAN_iE_Extensions),
        ])
    DRB_Failed_Item_EUTRAN._ext = []
    
    #-----< DRB-Failed-Item-EUTRAN-ExtIEs >-----#
    DRB_Failed_Item_EUTRAN_ExtIEs = CLASS(name='DRB-Failed-Item-EUTRAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRB_Failed_Item_EUTRAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-Failed-Mod-List-EUTRAN >-----#
    DRB_Failed_Mod_List_EUTRAN = SEQ_OF(name='DRB-Failed-Mod-List-EUTRAN', mode=MODE_TYPE)
    _DRB_Failed_Mod_List_EUTRAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Failed-Mod-Item-EUTRAN')))
    DRB_Failed_Mod_List_EUTRAN._cont = _DRB_Failed_Mod_List_EUTRAN__item_
    DRB_Failed_Mod_List_EUTRAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-Failed-Mod-Item-EUTRAN >-----#
    DRB_Failed_Mod_Item_EUTRAN = SEQ(name='DRB-Failed-Mod-Item-EUTRAN', mode=MODE_TYPE)
    _DRB_Failed_Mod_Item_EUTRAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_Failed_Mod_Item_EUTRAN_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _DRB_Failed_Mod_Item_EUTRAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__id._const_tab = ____DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__id_tab
    ___DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__criticality._const_tab = ____DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__criticality_tab
    ___DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__extensionValue_tab
    ___DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__id),
        ('criticality', ___DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item_._ext = None
    _DRB_Failed_Mod_Item_EUTRAN_iE_Extensions._cont = __DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item_
    _DRB_Failed_Mod_Item_EUTRAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Failed_Mod_Item_EUTRAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_Failed_Mod_Item_EUTRAN_dRB_ID),
        ('cause', _DRB_Failed_Mod_Item_EUTRAN_cause),
        ('iE-Extensions', _DRB_Failed_Mod_Item_EUTRAN_iE_Extensions),
        ])
    DRB_Failed_Mod_Item_EUTRAN._ext = []
    
    #-----< DRB-Failed-Mod-Item-EUTRAN-ExtIEs >-----#
    DRB_Failed_Mod_Item_EUTRAN_ExtIEs = CLASS(name='DRB-Failed-Mod-Item-EUTRAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRB_Failed_Mod_Item_EUTRAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-Failed-List-NG-RAN >-----#
    DRB_Failed_List_NG_RAN = SEQ_OF(name='DRB-Failed-List-NG-RAN', mode=MODE_TYPE)
    _DRB_Failed_List_NG_RAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Failed-Item-NG-RAN')))
    DRB_Failed_List_NG_RAN._cont = _DRB_Failed_List_NG_RAN__item_
    DRB_Failed_List_NG_RAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-Failed-Item-NG-RAN >-----#
    DRB_Failed_Item_NG_RAN = SEQ(name='DRB-Failed-Item-NG-RAN', mode=MODE_TYPE)
    _DRB_Failed_Item_NG_RAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_Failed_Item_NG_RAN_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _DRB_Failed_Item_NG_RAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Failed_Item_NG_RAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Failed_Item_NG_RAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Failed_Item_NG_RAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Failed_Item_NG_RAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Failed_Item_NG_RAN_iE_Extensions__item__id._const_tab = ____DRB_Failed_Item_NG_RAN_iE_Extensions__item__id_tab
    ___DRB_Failed_Item_NG_RAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Failed_Item_NG_RAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Failed_Item_NG_RAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRB_Failed_Item_NG_RAN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Failed_Item_NG_RAN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Failed_Item_NG_RAN_iE_Extensions__item__criticality._const_tab = ____DRB_Failed_Item_NG_RAN_iE_Extensions__item__criticality_tab
    ___DRB_Failed_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Failed_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Failed_Item_NG_RAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRB_Failed_Item_NG_RAN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Failed_Item_NG_RAN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Failed_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_Failed_Item_NG_RAN_iE_Extensions__item__extensionValue_tab
    ___DRB_Failed_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Failed_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Failed_Item_NG_RAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Failed_Item_NG_RAN_iE_Extensions__item__id),
        ('criticality', ___DRB_Failed_Item_NG_RAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Failed_Item_NG_RAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_Failed_Item_NG_RAN_iE_Extensions__item_._ext = None
    _DRB_Failed_Item_NG_RAN_iE_Extensions._cont = __DRB_Failed_Item_NG_RAN_iE_Extensions__item_
    _DRB_Failed_Item_NG_RAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Failed_Item_NG_RAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_Failed_Item_NG_RAN_dRB_ID),
        ('cause', _DRB_Failed_Item_NG_RAN_cause),
        ('iE-Extensions', _DRB_Failed_Item_NG_RAN_iE_Extensions),
        ])
    DRB_Failed_Item_NG_RAN._ext = []
    
    #-----< DRB-Failed-Item-NG-RAN-ExtIEs >-----#
    DRB_Failed_Item_NG_RAN_ExtIEs = CLASS(name='DRB-Failed-Item-NG-RAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRB_Failed_Item_NG_RAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-Failed-Mod-List-NG-RAN >-----#
    DRB_Failed_Mod_List_NG_RAN = SEQ_OF(name='DRB-Failed-Mod-List-NG-RAN', mode=MODE_TYPE)
    _DRB_Failed_Mod_List_NG_RAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Failed-Mod-Item-NG-RAN')))
    DRB_Failed_Mod_List_NG_RAN._cont = _DRB_Failed_Mod_List_NG_RAN__item_
    DRB_Failed_Mod_List_NG_RAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-Failed-Mod-Item-NG-RAN >-----#
    DRB_Failed_Mod_Item_NG_RAN = SEQ(name='DRB-Failed-Mod-Item-NG-RAN', mode=MODE_TYPE)
    _DRB_Failed_Mod_Item_NG_RAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_Failed_Mod_Item_NG_RAN_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _DRB_Failed_Mod_Item_NG_RAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__id._const_tab = ____DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__id_tab
    ___DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__criticality._const_tab = ____DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__criticality_tab
    ___DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue_tab
    ___DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__id),
        ('criticality', ___DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item_._ext = None
    _DRB_Failed_Mod_Item_NG_RAN_iE_Extensions._cont = __DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item_
    _DRB_Failed_Mod_Item_NG_RAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Failed_Mod_Item_NG_RAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_Failed_Mod_Item_NG_RAN_dRB_ID),
        ('cause', _DRB_Failed_Mod_Item_NG_RAN_cause),
        ('iE-Extensions', _DRB_Failed_Mod_Item_NG_RAN_iE_Extensions),
        ])
    DRB_Failed_Mod_Item_NG_RAN._ext = []
    
    #-----< DRB-Failed-Mod-Item-NG-RAN-ExtIEs >-----#
    DRB_Failed_Mod_Item_NG_RAN_ExtIEs = CLASS(name='DRB-Failed-Mod-Item-NG-RAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRB_Failed_Mod_Item_NG_RAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-Failed-To-Modify-List-EUTRAN >-----#
    DRB_Failed_To_Modify_List_EUTRAN = SEQ_OF(name='DRB-Failed-To-Modify-List-EUTRAN', mode=MODE_TYPE)
    _DRB_Failed_To_Modify_List_EUTRAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Failed-To-Modify-Item-EUTRAN')))
    DRB_Failed_To_Modify_List_EUTRAN._cont = _DRB_Failed_To_Modify_List_EUTRAN__item_
    DRB_Failed_To_Modify_List_EUTRAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-Failed-To-Modify-Item-EUTRAN >-----#
    DRB_Failed_To_Modify_Item_EUTRAN = SEQ(name='DRB-Failed-To-Modify-Item-EUTRAN', mode=MODE_TYPE)
    _DRB_Failed_To_Modify_Item_EUTRAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_Failed_To_Modify_Item_EUTRAN_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__id._const_tab = ____DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__id_tab
    ___DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality._const_tab = ____DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality_tab
    ___DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue_tab
    ___DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__id),
        ('criticality', ___DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item_._ext = None
    _DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions._cont = __DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item_
    _DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Failed_To_Modify_Item_EUTRAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_Failed_To_Modify_Item_EUTRAN_dRB_ID),
        ('cause', _DRB_Failed_To_Modify_Item_EUTRAN_cause),
        ('iE-Extensions', _DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions),
        ])
    DRB_Failed_To_Modify_Item_EUTRAN._ext = []
    
    #-----< DRB-Failed-To-Modify-Item-EUTRAN-ExtIEs >-----#
    DRB_Failed_To_Modify_Item_EUTRAN_ExtIEs = CLASS(name='DRB-Failed-To-Modify-Item-EUTRAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRB_Failed_To_Modify_Item_EUTRAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-Failed-To-Modify-List-NG-RAN >-----#
    DRB_Failed_To_Modify_List_NG_RAN = SEQ_OF(name='DRB-Failed-To-Modify-List-NG-RAN', mode=MODE_TYPE)
    _DRB_Failed_To_Modify_List_NG_RAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Failed-To-Modify-Item-NG-RAN')))
    DRB_Failed_To_Modify_List_NG_RAN._cont = _DRB_Failed_To_Modify_List_NG_RAN__item_
    DRB_Failed_To_Modify_List_NG_RAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-Failed-To-Modify-Item-NG-RAN >-----#
    DRB_Failed_To_Modify_Item_NG_RAN = SEQ(name='DRB-Failed-To-Modify-Item-NG-RAN', mode=MODE_TYPE)
    _DRB_Failed_To_Modify_Item_NG_RAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_Failed_To_Modify_Item_NG_RAN_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__id._const_tab = ____DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab
    ___DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality._const_tab = ____DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality_tab
    ___DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue_tab
    ___DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__id),
        ('criticality', ___DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item_._ext = None
    _DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions._cont = __DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item_
    _DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Failed_To_Modify_Item_NG_RAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_Failed_To_Modify_Item_NG_RAN_dRB_ID),
        ('cause', _DRB_Failed_To_Modify_Item_NG_RAN_cause),
        ('iE-Extensions', _DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions),
        ])
    DRB_Failed_To_Modify_Item_NG_RAN._ext = []
    
    #-----< DRB-Failed-To-Modify-Item-NG-RAN-ExtIEs >-----#
    DRB_Failed_To_Modify_Item_NG_RAN_ExtIEs = CLASS(name='DRB-Failed-To-Modify-Item-NG-RAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRB_Failed_To_Modify_Item_NG_RAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-ID >-----#
    DRB_ID = INT(name='DRB-ID', mode=MODE_TYPE)
    DRB_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    
    #-----< DRB-Measurement-Results-Information-List >-----#
    DRB_Measurement_Results_Information_List = SEQ_OF(name='DRB-Measurement-Results-Information-List', mode=MODE_TYPE)
    _DRB_Measurement_Results_Information_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Measurement-Results-Information-Item')))
    DRB_Measurement_Results_Information_List._cont = _DRB_Measurement_Results_Information_List__item_
    DRB_Measurement_Results_Information_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-Measurement-Results-Information-Item >-----#
    DRB_Measurement_Results_Information_Item = SEQ(name='DRB-Measurement-Results-Information-Item', mode=MODE_TYPE)
    _DRB_Measurement_Results_Information_Item_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_Measurement_Results_Information_Item_uL_D1_Result = INT(name='uL-D1-Result', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DRB_Measurement_Results_Information_Item_uL_D1_Result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10000)], ev=[], er=[])
    _DRB_Measurement_Results_Information_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Measurement_Results_Information_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Measurement_Results_Information_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Measurement_Results_Information_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Measurement_Results_Information_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Measurement_Results_Information_Item_iE_Extensions__item__id._const_tab = ____DRB_Measurement_Results_Information_Item_iE_Extensions__item__id_tab
    ___DRB_Measurement_Results_Information_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Measurement_Results_Information_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Measurement_Results_Information_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRB_Measurement_Results_Information_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Measurement_Results_Information_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Measurement_Results_Information_Item_iE_Extensions__item__criticality._const_tab = ____DRB_Measurement_Results_Information_Item_iE_Extensions__item__criticality_tab
    ___DRB_Measurement_Results_Information_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Measurement_Results_Information_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Measurement_Results_Information_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRB_Measurement_Results_Information_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Measurement_Results_Information_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Measurement_Results_Information_Item_iE_Extensions__item__extensionValue._const_tab = ____DRB_Measurement_Results_Information_Item_iE_Extensions__item__extensionValue_tab
    ___DRB_Measurement_Results_Information_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Measurement_Results_Information_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Measurement_Results_Information_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Measurement_Results_Information_Item_iE_Extensions__item__id),
        ('criticality', ___DRB_Measurement_Results_Information_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Measurement_Results_Information_Item_iE_Extensions__item__extensionValue),
        ])
    __DRB_Measurement_Results_Information_Item_iE_Extensions__item_._ext = None
    _DRB_Measurement_Results_Information_Item_iE_Extensions._cont = __DRB_Measurement_Results_Information_Item_iE_Extensions__item_
    _DRB_Measurement_Results_Information_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Measurement_Results_Information_Item._cont = ASN1Dict([
        ('dRB-ID', _DRB_Measurement_Results_Information_Item_dRB_ID),
        ('uL-D1-Result', _DRB_Measurement_Results_Information_Item_uL_D1_Result),
        ('iE-Extensions', _DRB_Measurement_Results_Information_Item_iE_Extensions),
        ])
    DRB_Measurement_Results_Information_Item._ext = []
    
    #-----< DRB-Measurement-Results-Information-Item-ExtIEs >-----#
    DRB_Measurement_Results_Information_Item_ExtIEs = CLASS(name='DRB-Measurement-Results-Information-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRB_Measurement_Results_Information_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-Modified-List-EUTRAN >-----#
    DRB_Modified_List_EUTRAN = SEQ_OF(name='DRB-Modified-List-EUTRAN', mode=MODE_TYPE)
    _DRB_Modified_List_EUTRAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Modified-Item-EUTRAN')))
    DRB_Modified_List_EUTRAN._cont = _DRB_Modified_List_EUTRAN__item_
    DRB_Modified_List_EUTRAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-Modified-Item-EUTRAN >-----#
    DRB_Modified_Item_EUTRAN = SEQ(name='DRB-Modified-Item-EUTRAN', mode=MODE_TYPE)
    _DRB_Modified_Item_EUTRAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_Modified_Item_EUTRAN_s1_DL_UP_TNL_Information = CHOICE(name='s1-DL-UP-TNL-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')), opt=True)
    _DRB_Modified_Item_EUTRAN_pDCP_SN_Status_Information = SEQ(name='pDCP-SN-Status-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-SN-Status-Information')), opt=True)
    _DRB_Modified_Item_EUTRAN_uL_UP_Transport_Parameters = SEQ_OF(name='uL-UP-Transport-Parameters', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-Parameters')), opt=True)
    _DRB_Modified_Item_EUTRAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Modified_Item_EUTRAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Modified_Item_EUTRAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Modified_Item_EUTRAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Modified_Item_EUTRAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Modified_Item_EUTRAN_iE_Extensions__item__id._const_tab = ____DRB_Modified_Item_EUTRAN_iE_Extensions__item__id_tab
    ___DRB_Modified_Item_EUTRAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Modified_Item_EUTRAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Modified_Item_EUTRAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRB_Modified_Item_EUTRAN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Modified_Item_EUTRAN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Modified_Item_EUTRAN_iE_Extensions__item__criticality._const_tab = ____DRB_Modified_Item_EUTRAN_iE_Extensions__item__criticality_tab
    ___DRB_Modified_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Modified_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Modified_Item_EUTRAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRB_Modified_Item_EUTRAN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Modified_Item_EUTRAN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Modified_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_Modified_Item_EUTRAN_iE_Extensions__item__extensionValue_tab
    ___DRB_Modified_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Modified_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Modified_Item_EUTRAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Modified_Item_EUTRAN_iE_Extensions__item__id),
        ('criticality', ___DRB_Modified_Item_EUTRAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Modified_Item_EUTRAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_Modified_Item_EUTRAN_iE_Extensions__item_._ext = None
    _DRB_Modified_Item_EUTRAN_iE_Extensions._cont = __DRB_Modified_Item_EUTRAN_iE_Extensions__item_
    _DRB_Modified_Item_EUTRAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Modified_Item_EUTRAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_Modified_Item_EUTRAN_dRB_ID),
        ('s1-DL-UP-TNL-Information', _DRB_Modified_Item_EUTRAN_s1_DL_UP_TNL_Information),
        ('pDCP-SN-Status-Information', _DRB_Modified_Item_EUTRAN_pDCP_SN_Status_Information),
        ('uL-UP-Transport-Parameters', _DRB_Modified_Item_EUTRAN_uL_UP_Transport_Parameters),
        ('iE-Extensions', _DRB_Modified_Item_EUTRAN_iE_Extensions),
        ])
    DRB_Modified_Item_EUTRAN._ext = []
    
    #-----< DRB-Modified-Item-EUTRAN-ExtIEs >-----#
    DRB_Modified_Item_EUTRAN_ExtIEs = CLASS(name='DRB-Modified-Item-EUTRAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRB_Modified_Item_EUTRAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-Modified-List-NG-RAN >-----#
    DRB_Modified_List_NG_RAN = SEQ_OF(name='DRB-Modified-List-NG-RAN', mode=MODE_TYPE)
    _DRB_Modified_List_NG_RAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Modified-Item-NG-RAN')))
    DRB_Modified_List_NG_RAN._cont = _DRB_Modified_List_NG_RAN__item_
    DRB_Modified_List_NG_RAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-Modified-Item-NG-RAN >-----#
    DRB_Modified_Item_NG_RAN = SEQ(name='DRB-Modified-Item-NG-RAN', mode=MODE_TYPE)
    _DRB_Modified_Item_NG_RAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_Modified_Item_NG_RAN_uL_UP_Transport_Parameters = SEQ_OF(name='uL-UP-Transport-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-Parameters')), opt=True)
    _DRB_Modified_Item_NG_RAN_pDCP_SN_Status_Information = SEQ(name='pDCP-SN-Status-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-SN-Status-Information')), opt=True)
    _DRB_Modified_Item_NG_RAN_flow_Setup_List = SEQ_OF(name='flow-Setup-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-List')), opt=True)
    _DRB_Modified_Item_NG_RAN_flow_Failed_List = SEQ_OF(name='flow-Failed-List', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Failed-List')), opt=True)
    _DRB_Modified_Item_NG_RAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Modified_Item_NG_RAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Modified_Item_NG_RAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Modified_Item_NG_RAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____DRB_Modified_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'EarlyForwardingCOUNTInfo')))
    _____DRB_Modified_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-List')))
    ____DRB_Modified_Item_NG_RAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 123), ('criticality', 'reject'), ('Extension', _____DRB_Modified_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 71), ('criticality', 'ignore'), ('Extension', _____DRB_Modified_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DRB_Modified_Item_NG_RAN_iE_Extensions__item__id._const_tab = ____DRB_Modified_Item_NG_RAN_iE_Extensions__item__id_tab
    ___DRB_Modified_Item_NG_RAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Modified_Item_NG_RAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Modified_Item_NG_RAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DRB_Modified_Item_NG_RAN_iE_Extensions__item__criticality._const_tab = ____DRB_Modified_Item_NG_RAN_iE_Extensions__item__id_tab
    ___DRB_Modified_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Modified_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Modified_Item_NG_RAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DRB_Modified_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_Modified_Item_NG_RAN_iE_Extensions__item__id_tab
    ___DRB_Modified_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Modified_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Modified_Item_NG_RAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Modified_Item_NG_RAN_iE_Extensions__item__id),
        ('criticality', ___DRB_Modified_Item_NG_RAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Modified_Item_NG_RAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_Modified_Item_NG_RAN_iE_Extensions__item_._ext = None
    _DRB_Modified_Item_NG_RAN_iE_Extensions._cont = __DRB_Modified_Item_NG_RAN_iE_Extensions__item_
    _DRB_Modified_Item_NG_RAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Modified_Item_NG_RAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_Modified_Item_NG_RAN_dRB_ID),
        ('uL-UP-Transport-Parameters', _DRB_Modified_Item_NG_RAN_uL_UP_Transport_Parameters),
        ('pDCP-SN-Status-Information', _DRB_Modified_Item_NG_RAN_pDCP_SN_Status_Information),
        ('flow-Setup-List', _DRB_Modified_Item_NG_RAN_flow_Setup_List),
        ('flow-Failed-List', _DRB_Modified_Item_NG_RAN_flow_Failed_List),
        ('iE-Extensions', _DRB_Modified_Item_NG_RAN_iE_Extensions),
        ])
    DRB_Modified_Item_NG_RAN._ext = []
    
    #-----< DRB-Modified-Item-NG-RAN-ExtIEs >-----#
    DRB_Modified_Item_NG_RAN_ExtIEs = CLASS(name='DRB-Modified-Item-NG-RAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _DRB_Modified_Item_NG_RAN_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'EarlyForwardingCOUNTInfo')))
    _DRB_Modified_Item_NG_RAN_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-List')))
    DRB_Modified_Item_NG_RAN_ExtIEs._val = ASN1Set(rv=[dict([('id', 123), ('criticality', 'reject'), ('Extension', _DRB_Modified_Item_NG_RAN_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 71), ('criticality', 'ignore'), ('Extension', _DRB_Modified_Item_NG_RAN_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRB-Removed-Item >-----#
    DRB_Removed_Item = SEQ(name='DRB-Removed-Item', mode=MODE_TYPE)
    _DRB_Removed_Item_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_Removed_Item_dRB_Released_In_Session = ENUM(name='dRB-Released-In-Session', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DRB_Removed_Item_dRB_Released_In_Session._cont = ASN1Dict([('released-in-session', 0), ('not-released-in-session', 1)])
    _DRB_Removed_Item_dRB_Released_In_Session._ext = []
    _DRB_Removed_Item_dRB_Accumulated_Session_Time = OCT_STR(name='dRB-Accumulated-Session-Time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DRB_Removed_Item_dRB_Accumulated_Session_Time._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _DRB_Removed_Item_qoS_Flow_Removed_List = SEQ_OF(name='qoS-Flow-Removed-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __DRB_Removed_Item_qoS_Flow_Removed_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Removed-Item')))
    _DRB_Removed_Item_qoS_Flow_Removed_List._cont = __DRB_Removed_Item_qoS_Flow_Removed_List__item_
    _DRB_Removed_Item_qoS_Flow_Removed_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _DRB_Removed_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Removed_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Removed_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Removed_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Removed_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Removed_Item_iE_Extensions__item__id._const_tab = ____DRB_Removed_Item_iE_Extensions__item__id_tab
    ___DRB_Removed_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Removed_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Removed_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRB_Removed_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Removed_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Removed_Item_iE_Extensions__item__criticality._const_tab = ____DRB_Removed_Item_iE_Extensions__item__criticality_tab
    ___DRB_Removed_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Removed_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Removed_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRB_Removed_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Removed_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Removed_Item_iE_Extensions__item__extensionValue._const_tab = ____DRB_Removed_Item_iE_Extensions__item__extensionValue_tab
    ___DRB_Removed_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Removed_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Removed_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Removed_Item_iE_Extensions__item__id),
        ('criticality', ___DRB_Removed_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Removed_Item_iE_Extensions__item__extensionValue),
        ])
    __DRB_Removed_Item_iE_Extensions__item_._ext = None
    _DRB_Removed_Item_iE_Extensions._cont = __DRB_Removed_Item_iE_Extensions__item_
    _DRB_Removed_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Removed_Item._cont = ASN1Dict([
        ('dRB-ID', _DRB_Removed_Item_dRB_ID),
        ('dRB-Released-In-Session', _DRB_Removed_Item_dRB_Released_In_Session),
        ('dRB-Accumulated-Session-Time', _DRB_Removed_Item_dRB_Accumulated_Session_Time),
        ('qoS-Flow-Removed-List', _DRB_Removed_Item_qoS_Flow_Removed_List),
        ('iE-Extensions', _DRB_Removed_Item_iE_Extensions),
        ])
    DRB_Removed_Item._ext = []
    
    #-----< DRB-Removed-Item-ExtIEs >-----#
    DRB_Removed_Item_ExtIEs = CLASS(name='DRB-Removed-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRB_Removed_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-Required-To-Modify-List-EUTRAN >-----#
    DRB_Required_To_Modify_List_EUTRAN = SEQ_OF(name='DRB-Required-To-Modify-List-EUTRAN', mode=MODE_TYPE)
    _DRB_Required_To_Modify_List_EUTRAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Required-To-Modify-Item-EUTRAN')))
    DRB_Required_To_Modify_List_EUTRAN._cont = _DRB_Required_To_Modify_List_EUTRAN__item_
    DRB_Required_To_Modify_List_EUTRAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-Required-To-Modify-Item-EUTRAN >-----#
    DRB_Required_To_Modify_Item_EUTRAN = SEQ(name='DRB-Required-To-Modify-Item-EUTRAN', mode=MODE_TYPE)
    _DRB_Required_To_Modify_Item_EUTRAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_Required_To_Modify_Item_EUTRAN_s1_DL_UP_TNL_Information = CHOICE(name='s1-DL-UP-TNL-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')), opt=True)
    _DRB_Required_To_Modify_Item_EUTRAN_gNB_CU_UP_CellGroupRelatedConfiguration = SEQ_OF(name='gNB-CU-UP-CellGroupRelatedConfiguration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-CellGroupRelatedConfiguration')), opt=True)
    _DRB_Required_To_Modify_Item_EUTRAN_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cause')), opt=True)
    _DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__id._const_tab = ____DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__id_tab
    ___DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality._const_tab = ____DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality_tab
    ___DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue_tab
    ___DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__id),
        ('criticality', ___DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item_._ext = None
    _DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions._cont = __DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item_
    _DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Required_To_Modify_Item_EUTRAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_Required_To_Modify_Item_EUTRAN_dRB_ID),
        ('s1-DL-UP-TNL-Information', _DRB_Required_To_Modify_Item_EUTRAN_s1_DL_UP_TNL_Information),
        ('gNB-CU-UP-CellGroupRelatedConfiguration', _DRB_Required_To_Modify_Item_EUTRAN_gNB_CU_UP_CellGroupRelatedConfiguration),
        ('cause', _DRB_Required_To_Modify_Item_EUTRAN_cause),
        ('iE-Extensions', _DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions),
        ])
    DRB_Required_To_Modify_Item_EUTRAN._ext = []
    
    #-----< DRB-Required-To-Modify-Item-EUTRAN-ExtIEs >-----#
    DRB_Required_To_Modify_Item_EUTRAN_ExtIEs = CLASS(name='DRB-Required-To-Modify-Item-EUTRAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRB_Required_To_Modify_Item_EUTRAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-Required-To-Modify-List-NG-RAN >-----#
    DRB_Required_To_Modify_List_NG_RAN = SEQ_OF(name='DRB-Required-To-Modify-List-NG-RAN', mode=MODE_TYPE)
    _DRB_Required_To_Modify_List_NG_RAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Required-To-Modify-Item-NG-RAN')))
    DRB_Required_To_Modify_List_NG_RAN._cont = _DRB_Required_To_Modify_List_NG_RAN__item_
    DRB_Required_To_Modify_List_NG_RAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-Required-To-Modify-Item-NG-RAN >-----#
    DRB_Required_To_Modify_Item_NG_RAN = SEQ(name='DRB-Required-To-Modify-Item-NG-RAN', mode=MODE_TYPE)
    _DRB_Required_To_Modify_Item_NG_RAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_Required_To_Modify_Item_NG_RAN_gNB_CU_UP_CellGroupRelatedConfiguration = SEQ_OF(name='gNB-CU-UP-CellGroupRelatedConfiguration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-CellGroupRelatedConfiguration')), opt=True)
    _DRB_Required_To_Modify_Item_NG_RAN_flow_To_Remove = SEQ_OF(name='flow-To-Remove', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-List')), opt=True)
    _DRB_Required_To_Modify_Item_NG_RAN_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cause')), opt=True)
    _DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__id._const_tab = ____DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab
    ___DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality._const_tab = ____DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality_tab
    ___DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue_tab
    ___DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__id),
        ('criticality', ___DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item_._ext = None
    _DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions._cont = __DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item_
    _DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Required_To_Modify_Item_NG_RAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_Required_To_Modify_Item_NG_RAN_dRB_ID),
        ('gNB-CU-UP-CellGroupRelatedConfiguration', _DRB_Required_To_Modify_Item_NG_RAN_gNB_CU_UP_CellGroupRelatedConfiguration),
        ('flow-To-Remove', _DRB_Required_To_Modify_Item_NG_RAN_flow_To_Remove),
        ('cause', _DRB_Required_To_Modify_Item_NG_RAN_cause),
        ('iE-Extensions', _DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions),
        ])
    DRB_Required_To_Modify_Item_NG_RAN._ext = []
    
    #-----< DRB-Required-To-Modify-Item-NG-RAN-ExtIEs >-----#
    DRB_Required_To_Modify_Item_NG_RAN_ExtIEs = CLASS(name='DRB-Required-To-Modify-Item-NG-RAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRB_Required_To_Modify_Item_NG_RAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-Setup-List-EUTRAN >-----#
    DRB_Setup_List_EUTRAN = SEQ_OF(name='DRB-Setup-List-EUTRAN', mode=MODE_TYPE)
    _DRB_Setup_List_EUTRAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Setup-Item-EUTRAN')))
    DRB_Setup_List_EUTRAN._cont = _DRB_Setup_List_EUTRAN__item_
    DRB_Setup_List_EUTRAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-Setup-Item-EUTRAN >-----#
    DRB_Setup_Item_EUTRAN = SEQ(name='DRB-Setup-Item-EUTRAN', mode=MODE_TYPE)
    _DRB_Setup_Item_EUTRAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_Setup_Item_EUTRAN_s1_DL_UP_TNL_Information = CHOICE(name='s1-DL-UP-TNL-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _DRB_Setup_Item_EUTRAN_data_Forwarding_Information_Response = SEQ(name='data-Forwarding-Information-Response', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Data-Forwarding-Information')), opt=True)
    _DRB_Setup_Item_EUTRAN_uL_UP_Transport_Parameters = SEQ_OF(name='uL-UP-Transport-Parameters', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-Parameters')))
    _DRB_Setup_Item_EUTRAN_s1_DL_UP_Unchanged = ENUM(name='s1-DL-UP-Unchanged', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DRB_Setup_Item_EUTRAN_s1_DL_UP_Unchanged._cont = ASN1Dict([('true', 0)])
    _DRB_Setup_Item_EUTRAN_s1_DL_UP_Unchanged._ext = []
    _DRB_Setup_Item_EUTRAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Setup_Item_EUTRAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Setup_Item_EUTRAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Setup_Item_EUTRAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____DRB_Setup_Item_EUTRAN_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    _____DRB_Setup_Item_EUTRAN_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SecurityResult')))
    ____DRB_Setup_Item_EUTRAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 142), ('criticality', 'ignore'), ('Extension', _____DRB_Setup_Item_EUTRAN_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 173), ('criticality', 'ignore'), ('Extension', _____DRB_Setup_Item_EUTRAN_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DRB_Setup_Item_EUTRAN_iE_Extensions__item__id._const_tab = ____DRB_Setup_Item_EUTRAN_iE_Extensions__item__id_tab
    ___DRB_Setup_Item_EUTRAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Setup_Item_EUTRAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Setup_Item_EUTRAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DRB_Setup_Item_EUTRAN_iE_Extensions__item__criticality._const_tab = ____DRB_Setup_Item_EUTRAN_iE_Extensions__item__id_tab
    ___DRB_Setup_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Setup_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Setup_Item_EUTRAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DRB_Setup_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_Setup_Item_EUTRAN_iE_Extensions__item__id_tab
    ___DRB_Setup_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Setup_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Setup_Item_EUTRAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Setup_Item_EUTRAN_iE_Extensions__item__id),
        ('criticality', ___DRB_Setup_Item_EUTRAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Setup_Item_EUTRAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_Setup_Item_EUTRAN_iE_Extensions__item_._ext = None
    _DRB_Setup_Item_EUTRAN_iE_Extensions._cont = __DRB_Setup_Item_EUTRAN_iE_Extensions__item_
    _DRB_Setup_Item_EUTRAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Setup_Item_EUTRAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_Setup_Item_EUTRAN_dRB_ID),
        ('s1-DL-UP-TNL-Information', _DRB_Setup_Item_EUTRAN_s1_DL_UP_TNL_Information),
        ('data-Forwarding-Information-Response', _DRB_Setup_Item_EUTRAN_data_Forwarding_Information_Response),
        ('uL-UP-Transport-Parameters', _DRB_Setup_Item_EUTRAN_uL_UP_Transport_Parameters),
        ('s1-DL-UP-Unchanged', _DRB_Setup_Item_EUTRAN_s1_DL_UP_Unchanged),
        ('iE-Extensions', _DRB_Setup_Item_EUTRAN_iE_Extensions),
        ])
    DRB_Setup_Item_EUTRAN._ext = []
    
    #-----< DRB-Setup-Item-EUTRAN-ExtIEs >-----#
    DRB_Setup_Item_EUTRAN_ExtIEs = CLASS(name='DRB-Setup-Item-EUTRAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _DRB_Setup_Item_EUTRAN_ExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    _DRB_Setup_Item_EUTRAN_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SecurityResult')))
    DRB_Setup_Item_EUTRAN_ExtIEs._val = ASN1Set(rv=[dict([('id', 142), ('criticality', 'ignore'), ('Extension', _DRB_Setup_Item_EUTRAN_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 173), ('criticality', 'ignore'), ('Extension', _DRB_Setup_Item_EUTRAN_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRB-Setup-Mod-List-EUTRAN >-----#
    DRB_Setup_Mod_List_EUTRAN = SEQ_OF(name='DRB-Setup-Mod-List-EUTRAN', mode=MODE_TYPE)
    _DRB_Setup_Mod_List_EUTRAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Setup-Mod-Item-EUTRAN')))
    DRB_Setup_Mod_List_EUTRAN._cont = _DRB_Setup_Mod_List_EUTRAN__item_
    DRB_Setup_Mod_List_EUTRAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-Setup-Mod-Item-EUTRAN >-----#
    DRB_Setup_Mod_Item_EUTRAN = SEQ(name='DRB-Setup-Mod-Item-EUTRAN', mode=MODE_TYPE)
    _DRB_Setup_Mod_Item_EUTRAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_Setup_Mod_Item_EUTRAN_s1_DL_UP_TNL_Information = CHOICE(name='s1-DL-UP-TNL-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _DRB_Setup_Mod_Item_EUTRAN_data_Forwarding_Information_Response = SEQ(name='data-Forwarding-Information-Response', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Data-Forwarding-Information')), opt=True)
    _DRB_Setup_Mod_Item_EUTRAN_uL_UP_Transport_Parameters = SEQ_OF(name='uL-UP-Transport-Parameters', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-Parameters')))
    _DRB_Setup_Mod_Item_EUTRAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SecurityResult')))
    _____DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    ____DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 173), ('criticality', 'ignore'), ('Extension', _____DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 142), ('criticality', 'ignore'), ('Extension', _____DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id._const_tab = ____DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id_tab
    ___DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__criticality._const_tab = ____DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id_tab
    ___DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id_tab
    ___DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id),
        ('criticality', ___DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item_._ext = None
    _DRB_Setup_Mod_Item_EUTRAN_iE_Extensions._cont = __DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item_
    _DRB_Setup_Mod_Item_EUTRAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Setup_Mod_Item_EUTRAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_Setup_Mod_Item_EUTRAN_dRB_ID),
        ('s1-DL-UP-TNL-Information', _DRB_Setup_Mod_Item_EUTRAN_s1_DL_UP_TNL_Information),
        ('data-Forwarding-Information-Response', _DRB_Setup_Mod_Item_EUTRAN_data_Forwarding_Information_Response),
        ('uL-UP-Transport-Parameters', _DRB_Setup_Mod_Item_EUTRAN_uL_UP_Transport_Parameters),
        ('iE-Extensions', _DRB_Setup_Mod_Item_EUTRAN_iE_Extensions),
        ])
    DRB_Setup_Mod_Item_EUTRAN._ext = []
    
    #-----< DRB-Setup-Mod-Item-EUTRAN-ExtIEs >-----#
    DRB_Setup_Mod_Item_EUTRAN_ExtIEs = CLASS(name='DRB-Setup-Mod-Item-EUTRAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _DRB_Setup_Mod_Item_EUTRAN_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SecurityResult')))
    _DRB_Setup_Mod_Item_EUTRAN_ExtIEs_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    DRB_Setup_Mod_Item_EUTRAN_ExtIEs._val = ASN1Set(rv=[dict([('id', 173), ('criticality', 'ignore'), ('Extension', _DRB_Setup_Mod_Item_EUTRAN_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 142), ('criticality', 'ignore'), ('Extension', _DRB_Setup_Mod_Item_EUTRAN_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRB-Setup-List-NG-RAN >-----#
    DRB_Setup_List_NG_RAN = SEQ_OF(name='DRB-Setup-List-NG-RAN', mode=MODE_TYPE)
    _DRB_Setup_List_NG_RAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Setup-Item-NG-RAN')))
    DRB_Setup_List_NG_RAN._cont = _DRB_Setup_List_NG_RAN__item_
    DRB_Setup_List_NG_RAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-Setup-Item-NG-RAN >-----#
    DRB_Setup_Item_NG_RAN = SEQ(name='DRB-Setup-Item-NG-RAN', mode=MODE_TYPE)
    _DRB_Setup_Item_NG_RAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_Setup_Item_NG_RAN_dRB_data_Forwarding_Information_Response = SEQ(name='dRB-data-Forwarding-Information-Response', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Data-Forwarding-Information')), opt=True)
    _DRB_Setup_Item_NG_RAN_uL_UP_Transport_Parameters = SEQ_OF(name='uL-UP-Transport-Parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-Parameters')))
    _DRB_Setup_Item_NG_RAN_flow_Setup_List = SEQ_OF(name='flow-Setup-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-List')))
    _DRB_Setup_Item_NG_RAN_flow_Failed_List = SEQ_OF(name='flow-Failed-List', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Failed-List')), opt=True)
    _DRB_Setup_Item_NG_RAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Setup_Item_NG_RAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Setup_Item_NG_RAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Setup_Item_NG_RAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Setup_Item_NG_RAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Setup_Item_NG_RAN_iE_Extensions__item__id._const_tab = ____DRB_Setup_Item_NG_RAN_iE_Extensions__item__id_tab
    ___DRB_Setup_Item_NG_RAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Setup_Item_NG_RAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Setup_Item_NG_RAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRB_Setup_Item_NG_RAN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Setup_Item_NG_RAN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Setup_Item_NG_RAN_iE_Extensions__item__criticality._const_tab = ____DRB_Setup_Item_NG_RAN_iE_Extensions__item__criticality_tab
    ___DRB_Setup_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Setup_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Setup_Item_NG_RAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRB_Setup_Item_NG_RAN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Setup_Item_NG_RAN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Setup_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_Setup_Item_NG_RAN_iE_Extensions__item__extensionValue_tab
    ___DRB_Setup_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Setup_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Setup_Item_NG_RAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Setup_Item_NG_RAN_iE_Extensions__item__id),
        ('criticality', ___DRB_Setup_Item_NG_RAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Setup_Item_NG_RAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_Setup_Item_NG_RAN_iE_Extensions__item_._ext = None
    _DRB_Setup_Item_NG_RAN_iE_Extensions._cont = __DRB_Setup_Item_NG_RAN_iE_Extensions__item_
    _DRB_Setup_Item_NG_RAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Setup_Item_NG_RAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_Setup_Item_NG_RAN_dRB_ID),
        ('dRB-data-Forwarding-Information-Response', _DRB_Setup_Item_NG_RAN_dRB_data_Forwarding_Information_Response),
        ('uL-UP-Transport-Parameters', _DRB_Setup_Item_NG_RAN_uL_UP_Transport_Parameters),
        ('flow-Setup-List', _DRB_Setup_Item_NG_RAN_flow_Setup_List),
        ('flow-Failed-List', _DRB_Setup_Item_NG_RAN_flow_Failed_List),
        ('iE-Extensions', _DRB_Setup_Item_NG_RAN_iE_Extensions),
        ])
    DRB_Setup_Item_NG_RAN._ext = []
    
    #-----< DRB-Setup-Item-NG-RAN-ExtIEs >-----#
    DRB_Setup_Item_NG_RAN_ExtIEs = CLASS(name='DRB-Setup-Item-NG-RAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRB_Setup_Item_NG_RAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-Setup-Mod-List-NG-RAN >-----#
    DRB_Setup_Mod_List_NG_RAN = SEQ_OF(name='DRB-Setup-Mod-List-NG-RAN', mode=MODE_TYPE)
    _DRB_Setup_Mod_List_NG_RAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Setup-Mod-Item-NG-RAN')))
    DRB_Setup_Mod_List_NG_RAN._cont = _DRB_Setup_Mod_List_NG_RAN__item_
    DRB_Setup_Mod_List_NG_RAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-Setup-Mod-Item-NG-RAN >-----#
    DRB_Setup_Mod_Item_NG_RAN = SEQ(name='DRB-Setup-Mod-Item-NG-RAN', mode=MODE_TYPE)
    _DRB_Setup_Mod_Item_NG_RAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_Setup_Mod_Item_NG_RAN_dRB_data_Forwarding_Information_Response = SEQ(name='dRB-data-Forwarding-Information-Response', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Data-Forwarding-Information')), opt=True)
    _DRB_Setup_Mod_Item_NG_RAN_uL_UP_Transport_Parameters = SEQ_OF(name='uL-UP-Transport-Parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-Parameters')))
    _DRB_Setup_Mod_Item_NG_RAN_flow_Setup_List = SEQ_OF(name='flow-Setup-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-List')))
    _DRB_Setup_Mod_Item_NG_RAN_flow_Failed_List = SEQ_OF(name='flow-Failed-List', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Failed-List')), opt=True)
    _DRB_Setup_Mod_Item_NG_RAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id._const_tab = ____DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id_tab
    ___DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__criticality._const_tab = ____DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__criticality_tab
    ___DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue_tab
    ___DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id),
        ('criticality', ___DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item_._ext = None
    _DRB_Setup_Mod_Item_NG_RAN_iE_Extensions._cont = __DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item_
    _DRB_Setup_Mod_Item_NG_RAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Setup_Mod_Item_NG_RAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_Setup_Mod_Item_NG_RAN_dRB_ID),
        ('dRB-data-Forwarding-Information-Response', _DRB_Setup_Mod_Item_NG_RAN_dRB_data_Forwarding_Information_Response),
        ('uL-UP-Transport-Parameters', _DRB_Setup_Mod_Item_NG_RAN_uL_UP_Transport_Parameters),
        ('flow-Setup-List', _DRB_Setup_Mod_Item_NG_RAN_flow_Setup_List),
        ('flow-Failed-List', _DRB_Setup_Mod_Item_NG_RAN_flow_Failed_List),
        ('iE-Extensions', _DRB_Setup_Mod_Item_NG_RAN_iE_Extensions),
        ])
    DRB_Setup_Mod_Item_NG_RAN._ext = []
    
    #-----< DRB-Setup-Mod-Item-NG-RAN-ExtIEs >-----#
    DRB_Setup_Mod_Item_NG_RAN_ExtIEs = CLASS(name='DRB-Setup-Mod-Item-NG-RAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRB_Setup_Mod_Item_NG_RAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-Status-Item >-----#
    DRB_Status_Item = SEQ(name='DRB-Status-Item', mode=MODE_TYPE)
    _DRB_Status_Item_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_Status_Item_pDCP_DL_Count = SEQ(name='pDCP-DL-Count', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-Count')), opt=True)
    _DRB_Status_Item_pDCP_UL_Count = SEQ(name='pDCP-UL-Count', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-Count')), opt=True)
    _DRB_Status_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Status_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Status_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Status_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Status_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Status_Item_iE_Extensions__item__id._const_tab = ____DRB_Status_Item_iE_Extensions__item__id_tab
    ___DRB_Status_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Status_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Status_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRB_Status_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Status_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Status_Item_iE_Extensions__item__criticality._const_tab = ____DRB_Status_Item_iE_Extensions__item__criticality_tab
    ___DRB_Status_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Status_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Status_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRB_Status_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Status_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Status_Item_iE_Extensions__item__extensionValue._const_tab = ____DRB_Status_Item_iE_Extensions__item__extensionValue_tab
    ___DRB_Status_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Status_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Status_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Status_Item_iE_Extensions__item__id),
        ('criticality', ___DRB_Status_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Status_Item_iE_Extensions__item__extensionValue),
        ])
    __DRB_Status_Item_iE_Extensions__item_._ext = None
    _DRB_Status_Item_iE_Extensions._cont = __DRB_Status_Item_iE_Extensions__item_
    _DRB_Status_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Status_Item._cont = ASN1Dict([
        ('dRB-ID', _DRB_Status_Item_dRB_ID),
        ('pDCP-DL-Count', _DRB_Status_Item_pDCP_DL_Count),
        ('pDCP-UL-Count', _DRB_Status_Item_pDCP_UL_Count),
        ('iE-Extensions', _DRB_Status_Item_iE_Extensions),
        ])
    DRB_Status_Item._ext = []
    
    #-----< DRB-Status-ItemExtIEs >-----#
    DRB_Status_ItemExtIEs = CLASS(name='DRB-Status-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRB_Status_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBs-Subject-To-Counter-Check-List-EUTRAN >-----#
    DRBs_Subject_To_Counter_Check_List_EUTRAN = SEQ_OF(name='DRBs-Subject-To-Counter-Check-List-EUTRAN', mode=MODE_TYPE)
    _DRBs_Subject_To_Counter_Check_List_EUTRAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRBs-Subject-To-Counter-Check-Item-EUTRAN')))
    DRBs_Subject_To_Counter_Check_List_EUTRAN._cont = _DRBs_Subject_To_Counter_Check_List_EUTRAN__item_
    DRBs_Subject_To_Counter_Check_List_EUTRAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRBs-Subject-To-Counter-Check-Item-EUTRAN >-----#
    DRBs_Subject_To_Counter_Check_Item_EUTRAN = SEQ(name='DRBs-Subject-To-Counter-Check-Item-EUTRAN', mode=MODE_TYPE)
    _DRBs_Subject_To_Counter_Check_Item_EUTRAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRBs_Subject_To_Counter_Check_Item_EUTRAN_pDCP_UL_Count = SEQ(name='pDCP-UL-Count', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-Count')))
    _DRBs_Subject_To_Counter_Check_Item_EUTRAN_pDCP_DL_Count = SEQ(name='pDCP-DL-Count', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-Count')))
    _DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__id._const_tab = ____DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__id_tab
    ___DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__criticality._const_tab = ____DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__criticality_tab
    ___DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab = ____DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__extensionValue_tab
    ___DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__id),
        ('criticality', ___DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__extensionValue),
        ])
    __DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item_._ext = None
    _DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions._cont = __DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item_
    _DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_Subject_To_Counter_Check_Item_EUTRAN._cont = ASN1Dict([
        ('dRB-ID', _DRBs_Subject_To_Counter_Check_Item_EUTRAN_dRB_ID),
        ('pDCP-UL-Count', _DRBs_Subject_To_Counter_Check_Item_EUTRAN_pDCP_UL_Count),
        ('pDCP-DL-Count', _DRBs_Subject_To_Counter_Check_Item_EUTRAN_pDCP_DL_Count),
        ('iE-Extensions', _DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions),
        ])
    DRBs_Subject_To_Counter_Check_Item_EUTRAN._ext = []
    
    #-----< DRBs-Subject-To-Counter-Check-Item-EUTRAN-ExtIEs >-----#
    DRBs_Subject_To_Counter_Check_Item_EUTRAN_ExtIEs = CLASS(name='DRBs-Subject-To-Counter-Check-Item-EUTRAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRBs_Subject_To_Counter_Check_Item_EUTRAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBs-Subject-To-Counter-Check-List-NG-RAN >-----#
    DRBs_Subject_To_Counter_Check_List_NG_RAN = SEQ_OF(name='DRBs-Subject-To-Counter-Check-List-NG-RAN', mode=MODE_TYPE)
    _DRBs_Subject_To_Counter_Check_List_NG_RAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRBs-Subject-To-Counter-Check-Item-NG-RAN')))
    DRBs_Subject_To_Counter_Check_List_NG_RAN._cont = _DRBs_Subject_To_Counter_Check_List_NG_RAN__item_
    DRBs_Subject_To_Counter_Check_List_NG_RAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRBs-Subject-To-Counter-Check-Item-NG-RAN >-----#
    DRBs_Subject_To_Counter_Check_Item_NG_RAN = SEQ(name='DRBs-Subject-To-Counter-Check-Item-NG-RAN', mode=MODE_TYPE)
    _DRBs_Subject_To_Counter_Check_Item_NG_RAN_pDU_Session_ID = INT(name='pDU-Session-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-ID')))
    _DRBs_Subject_To_Counter_Check_Item_NG_RAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRBs_Subject_To_Counter_Check_Item_NG_RAN_pDCP_UL_Count = SEQ(name='pDCP-UL-Count', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-Count')))
    _DRBs_Subject_To_Counter_Check_Item_NG_RAN_pDCP_DL_Count = SEQ(name='pDCP-DL-Count', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-Count')))
    _DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__id._const_tab = ____DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__id_tab
    ___DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__criticality._const_tab = ____DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__criticality_tab
    ___DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab = ____DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__extensionValue_tab
    ___DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__id),
        ('criticality', ___DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__extensionValue),
        ])
    __DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item_._ext = None
    _DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions._cont = __DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item_
    _DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_Subject_To_Counter_Check_Item_NG_RAN._cont = ASN1Dict([
        ('pDU-Session-ID', _DRBs_Subject_To_Counter_Check_Item_NG_RAN_pDU_Session_ID),
        ('dRB-ID', _DRBs_Subject_To_Counter_Check_Item_NG_RAN_dRB_ID),
        ('pDCP-UL-Count', _DRBs_Subject_To_Counter_Check_Item_NG_RAN_pDCP_UL_Count),
        ('pDCP-DL-Count', _DRBs_Subject_To_Counter_Check_Item_NG_RAN_pDCP_DL_Count),
        ('iE-Extensions', _DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions),
        ])
    DRBs_Subject_To_Counter_Check_Item_NG_RAN._ext = []
    
    #-----< DRBs-Subject-To-Counter-Check-Item-NG-RAN-ExtIEs >-----#
    DRBs_Subject_To_Counter_Check_Item_NG_RAN_ExtIEs = CLASS(name='DRBs-Subject-To-Counter-Check-Item-NG-RAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRBs_Subject_To_Counter_Check_Item_NG_RAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBs-Subject-To-Early-Forwarding-List >-----#
    DRBs_Subject_To_Early_Forwarding_List = SEQ_OF(name='DRBs-Subject-To-Early-Forwarding-List', mode=MODE_TYPE)
    _DRBs_Subject_To_Early_Forwarding_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRBs-Subject-To-Early-Forwarding-Item')))
    DRBs_Subject_To_Early_Forwarding_List._cont = _DRBs_Subject_To_Early_Forwarding_List__item_
    DRBs_Subject_To_Early_Forwarding_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRBs-Subject-To-Early-Forwarding-Item >-----#
    DRBs_Subject_To_Early_Forwarding_Item = SEQ(name='DRBs-Subject-To-Early-Forwarding-Item', mode=MODE_TYPE)
    _DRBs_Subject_To_Early_Forwarding_Item_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRBs_Subject_To_Early_Forwarding_Item_dLCountValue = SEQ(name='dLCountValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-Count')))
    _DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__id._const_tab = ____DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__id_tab
    ___DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__criticality_tab
    ___DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__extensionValue_tab
    ___DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__id),
        ('criticality', ___DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item_._ext = None
    _DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions._cont = __DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item_
    _DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_Subject_To_Early_Forwarding_Item._cont = ASN1Dict([
        ('dRB-ID', _DRBs_Subject_To_Early_Forwarding_Item_dRB_ID),
        ('dLCountValue', _DRBs_Subject_To_Early_Forwarding_Item_dLCountValue),
        ('iE-Extensions', _DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions),
        ])
    DRBs_Subject_To_Early_Forwarding_Item._ext = []
    
    #-----< DRBs-Subject-To-Early-Forwarding-Item-ExtIEs >-----#
    DRBs_Subject_To_Early_Forwarding_Item_ExtIEs = CLASS(name='DRBs-Subject-To-Early-Forwarding-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRBs_Subject_To_Early_Forwarding_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-To-Modify-List-EUTRAN >-----#
    DRB_To_Modify_List_EUTRAN = SEQ_OF(name='DRB-To-Modify-List-EUTRAN', mode=MODE_TYPE)
    _DRB_To_Modify_List_EUTRAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-To-Modify-Item-EUTRAN')))
    DRB_To_Modify_List_EUTRAN._cont = _DRB_To_Modify_List_EUTRAN__item_
    DRB_To_Modify_List_EUTRAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-To-Modify-Item-EUTRAN >-----#
    DRB_To_Modify_Item_EUTRAN = SEQ(name='DRB-To-Modify-Item-EUTRAN', mode=MODE_TYPE)
    _DRB_To_Modify_Item_EUTRAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_To_Modify_Item_EUTRAN_pDCP_Configuration = SEQ(name='pDCP-Configuration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-Configuration')), opt=True)
    _DRB_To_Modify_Item_EUTRAN_eUTRAN_QoS = SEQ(name='eUTRAN-QoS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'EUTRAN-QoS')), opt=True)
    _DRB_To_Modify_Item_EUTRAN_s1_UL_UP_TNL_Information = CHOICE(name='s1-UL-UP-TNL-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')), opt=True)
    _DRB_To_Modify_Item_EUTRAN_data_Forwarding_Information = SEQ(name='data-Forwarding-Information', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Data-Forwarding-Information')), opt=True)
    _DRB_To_Modify_Item_EUTRAN_pDCP_SN_Status_Request = ENUM(name='pDCP-SN-Status-Request', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-SN-Status-Request')), opt=True)
    _DRB_To_Modify_Item_EUTRAN_pDCP_SN_Status_Information = SEQ(name='pDCP-SN-Status-Information', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-SN-Status-Information')), opt=True)
    _DRB_To_Modify_Item_EUTRAN_dL_UP_Parameters = SEQ_OF(name='dL-UP-Parameters', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-Parameters')), opt=True)
    _DRB_To_Modify_Item_EUTRAN_cell_Group_To_Add = SEQ_OF(name='cell-Group-To-Add', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cell-Group-Information')), opt=True)
    _DRB_To_Modify_Item_EUTRAN_cell_Group_To_Modify = SEQ_OF(name='cell-Group-To-Modify', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cell-Group-Information')), opt=True)
    _DRB_To_Modify_Item_EUTRAN_cell_Group_To_Remove = SEQ_OF(name='cell-Group-To-Remove', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cell-Group-Information')), opt=True)
    _DRB_To_Modify_Item_EUTRAN_dRB_Inactivity_Timer = INT(name='dRB-Inactivity-Timer', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Inactivity-Timer')), opt=True)
    _DRB_To_Modify_Item_EUTRAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_To_Modify_Item_EUTRAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__id._const_tab = ____DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__id_tab
    ___DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality._const_tab = ____DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality_tab
    ___DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue_tab
    ___DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_To_Modify_Item_EUTRAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__id),
        ('criticality', ___DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_To_Modify_Item_EUTRAN_iE_Extensions__item_._ext = None
    _DRB_To_Modify_Item_EUTRAN_iE_Extensions._cont = __DRB_To_Modify_Item_EUTRAN_iE_Extensions__item_
    _DRB_To_Modify_Item_EUTRAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_To_Modify_Item_EUTRAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_To_Modify_Item_EUTRAN_dRB_ID),
        ('pDCP-Configuration', _DRB_To_Modify_Item_EUTRAN_pDCP_Configuration),
        ('eUTRAN-QoS', _DRB_To_Modify_Item_EUTRAN_eUTRAN_QoS),
        ('s1-UL-UP-TNL-Information', _DRB_To_Modify_Item_EUTRAN_s1_UL_UP_TNL_Information),
        ('data-Forwarding-Information', _DRB_To_Modify_Item_EUTRAN_data_Forwarding_Information),
        ('pDCP-SN-Status-Request', _DRB_To_Modify_Item_EUTRAN_pDCP_SN_Status_Request),
        ('pDCP-SN-Status-Information', _DRB_To_Modify_Item_EUTRAN_pDCP_SN_Status_Information),
        ('dL-UP-Parameters', _DRB_To_Modify_Item_EUTRAN_dL_UP_Parameters),
        ('cell-Group-To-Add', _DRB_To_Modify_Item_EUTRAN_cell_Group_To_Add),
        ('cell-Group-To-Modify', _DRB_To_Modify_Item_EUTRAN_cell_Group_To_Modify),
        ('cell-Group-To-Remove', _DRB_To_Modify_Item_EUTRAN_cell_Group_To_Remove),
        ('dRB-Inactivity-Timer', _DRB_To_Modify_Item_EUTRAN_dRB_Inactivity_Timer),
        ('iE-Extensions', _DRB_To_Modify_Item_EUTRAN_iE_Extensions),
        ])
    DRB_To_Modify_Item_EUTRAN._ext = []
    
    #-----< DRB-To-Modify-Item-EUTRAN-ExtIEs >-----#
    DRB_To_Modify_Item_EUTRAN_ExtIEs = CLASS(name='DRB-To-Modify-Item-EUTRAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRB_To_Modify_Item_EUTRAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-To-Modify-List-NG-RAN >-----#
    DRB_To_Modify_List_NG_RAN = SEQ_OF(name='DRB-To-Modify-List-NG-RAN', mode=MODE_TYPE)
    _DRB_To_Modify_List_NG_RAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-To-Modify-Item-NG-RAN')))
    DRB_To_Modify_List_NG_RAN._cont = _DRB_To_Modify_List_NG_RAN__item_
    DRB_To_Modify_List_NG_RAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-To-Modify-Item-NG-RAN >-----#
    DRB_To_Modify_Item_NG_RAN = SEQ(name='DRB-To-Modify-Item-NG-RAN', mode=MODE_TYPE)
    _DRB_To_Modify_Item_NG_RAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_To_Modify_Item_NG_RAN_sDAP_Configuration = SEQ(name='sDAP-Configuration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'SDAP-Configuration')), opt=True)
    _DRB_To_Modify_Item_NG_RAN_pDCP_Configuration = SEQ(name='pDCP-Configuration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-Configuration')), opt=True)
    _DRB_To_Modify_Item_NG_RAN_dRB_Data_Forwarding_Information = SEQ(name='dRB-Data-Forwarding-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Data-Forwarding-Information')), opt=True)
    _DRB_To_Modify_Item_NG_RAN_pDCP_SN_Status_Request = ENUM(name='pDCP-SN-Status-Request', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-SN-Status-Request')), opt=True)
    _DRB_To_Modify_Item_NG_RAN_pdcp_SN_Status_Information = SEQ(name='pdcp-SN-Status-Information', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-SN-Status-Information')), opt=True)
    _DRB_To_Modify_Item_NG_RAN_dL_UP_Parameters = SEQ_OF(name='dL-UP-Parameters', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-Parameters')), opt=True)
    _DRB_To_Modify_Item_NG_RAN_cell_Group_To_Add = SEQ_OF(name='cell-Group-To-Add', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cell-Group-Information')), opt=True)
    _DRB_To_Modify_Item_NG_RAN_cell_Group_To_Modify = SEQ_OF(name='cell-Group-To-Modify', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cell-Group-Information')), opt=True)
    _DRB_To_Modify_Item_NG_RAN_cell_Group_To_Remove = SEQ_OF(name='cell-Group-To-Remove', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cell-Group-Information')), opt=True)
    _DRB_To_Modify_Item_NG_RAN_flow_Mapping_Information = SEQ_OF(name='flow-Mapping-Information', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-QoS-Parameter-List')), opt=True)
    _DRB_To_Modify_Item_NG_RAN_dRB_Inactivity_Timer = INT(name='dRB-Inactivity-Timer', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Inactivity-Timer')), opt=True)
    _DRB_To_Modify_Item_NG_RAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_To_Modify_Item_NG_RAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-List')))
    _____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QoSFlowLevelQoSParameters')))
    _____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'EarlyForwardingCOUNTReq')))
    _____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_3 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'EarlyForwardingCOUNTInfo')))
    _____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DAPSRequestInfo')))
    _____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'EarlyDataForwardingIndicator')))
    _____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SDTindicatorMod')))
    _____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_7 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDCP-COUNT-Reset')))
    ____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 71), ('criticality', 'reject'), ('Extension', _____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 72), ('criticality', 'ignore'), ('Extension', _____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 122), ('criticality', 'reject'), ('Extension', _____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 123), ('criticality', 'reject'), ('Extension', _____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 120), ('criticality', 'ignore'), ('Extension', _____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 140), ('criticality', 'ignore'), ('Extension', _____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 176), ('criticality', 'reject'), ('Extension', _____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 184), ('criticality', 'reject'), ('Extension', _____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id._const_tab = ____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab
    ___DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality._const_tab = ____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab
    ___DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab
    ___DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_To_Modify_Item_NG_RAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id),
        ('criticality', ___DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_To_Modify_Item_NG_RAN_iE_Extensions__item_._ext = None
    _DRB_To_Modify_Item_NG_RAN_iE_Extensions._cont = __DRB_To_Modify_Item_NG_RAN_iE_Extensions__item_
    _DRB_To_Modify_Item_NG_RAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_To_Modify_Item_NG_RAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_To_Modify_Item_NG_RAN_dRB_ID),
        ('sDAP-Configuration', _DRB_To_Modify_Item_NG_RAN_sDAP_Configuration),
        ('pDCP-Configuration', _DRB_To_Modify_Item_NG_RAN_pDCP_Configuration),
        ('dRB-Data-Forwarding-Information', _DRB_To_Modify_Item_NG_RAN_dRB_Data_Forwarding_Information),
        ('pDCP-SN-Status-Request', _DRB_To_Modify_Item_NG_RAN_pDCP_SN_Status_Request),
        ('pdcp-SN-Status-Information', _DRB_To_Modify_Item_NG_RAN_pdcp_SN_Status_Information),
        ('dL-UP-Parameters', _DRB_To_Modify_Item_NG_RAN_dL_UP_Parameters),
        ('cell-Group-To-Add', _DRB_To_Modify_Item_NG_RAN_cell_Group_To_Add),
        ('cell-Group-To-Modify', _DRB_To_Modify_Item_NG_RAN_cell_Group_To_Modify),
        ('cell-Group-To-Remove', _DRB_To_Modify_Item_NG_RAN_cell_Group_To_Remove),
        ('flow-Mapping-Information', _DRB_To_Modify_Item_NG_RAN_flow_Mapping_Information),
        ('dRB-Inactivity-Timer', _DRB_To_Modify_Item_NG_RAN_dRB_Inactivity_Timer),
        ('iE-Extensions', _DRB_To_Modify_Item_NG_RAN_iE_Extensions),
        ])
    DRB_To_Modify_Item_NG_RAN._ext = []
    
    #-----< DRB-To-Modify-Item-NG-RAN-ExtIEs >-----#
    DRB_To_Modify_Item_NG_RAN_ExtIEs = CLASS(name='DRB-To-Modify-Item-NG-RAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _DRB_To_Modify_Item_NG_RAN_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-List')))
    _DRB_To_Modify_Item_NG_RAN_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QoSFlowLevelQoSParameters')))
    _DRB_To_Modify_Item_NG_RAN_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'EarlyForwardingCOUNTReq')))
    _DRB_To_Modify_Item_NG_RAN_ExtIEs_val_Extension_3 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'EarlyForwardingCOUNTInfo')))
    _DRB_To_Modify_Item_NG_RAN_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DAPSRequestInfo')))
    _DRB_To_Modify_Item_NG_RAN_ExtIEs_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'EarlyDataForwardingIndicator')))
    _DRB_To_Modify_Item_NG_RAN_ExtIEs_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SDTindicatorMod')))
    _DRB_To_Modify_Item_NG_RAN_ExtIEs_val_Extension_7 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDCP-COUNT-Reset')))
    DRB_To_Modify_Item_NG_RAN_ExtIEs._val = ASN1Set(rv=[dict([('id', 71), ('criticality', 'reject'), ('Extension', _DRB_To_Modify_Item_NG_RAN_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 72), ('criticality', 'ignore'), ('Extension', _DRB_To_Modify_Item_NG_RAN_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 122), ('criticality', 'reject'), ('Extension', _DRB_To_Modify_Item_NG_RAN_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 123), ('criticality', 'reject'), ('Extension', _DRB_To_Modify_Item_NG_RAN_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 120), ('criticality', 'ignore'), ('Extension', _DRB_To_Modify_Item_NG_RAN_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 140), ('criticality', 'ignore'), ('Extension', _DRB_To_Modify_Item_NG_RAN_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 176), ('criticality', 'reject'), ('Extension', _DRB_To_Modify_Item_NG_RAN_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 184), ('criticality', 'reject'), ('Extension', _DRB_To_Modify_Item_NG_RAN_ExtIEs_val_Extension_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRB-To-Remove-List-EUTRAN >-----#
    DRB_To_Remove_List_EUTRAN = SEQ_OF(name='DRB-To-Remove-List-EUTRAN', mode=MODE_TYPE)
    _DRB_To_Remove_List_EUTRAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-To-Remove-Item-EUTRAN')))
    DRB_To_Remove_List_EUTRAN._cont = _DRB_To_Remove_List_EUTRAN__item_
    DRB_To_Remove_List_EUTRAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-To-Remove-Item-EUTRAN >-----#
    DRB_To_Remove_Item_EUTRAN = SEQ(name='DRB-To-Remove-Item-EUTRAN', mode=MODE_TYPE)
    _DRB_To_Remove_Item_EUTRAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_To_Remove_Item_EUTRAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_To_Remove_Item_EUTRAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__id._const_tab = ____DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__id_tab
    ___DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__criticality._const_tab = ____DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__criticality_tab
    ___DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__extensionValue_tab
    ___DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_To_Remove_Item_EUTRAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__id),
        ('criticality', ___DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_To_Remove_Item_EUTRAN_iE_Extensions__item_._ext = None
    _DRB_To_Remove_Item_EUTRAN_iE_Extensions._cont = __DRB_To_Remove_Item_EUTRAN_iE_Extensions__item_
    _DRB_To_Remove_Item_EUTRAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_To_Remove_Item_EUTRAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_To_Remove_Item_EUTRAN_dRB_ID),
        ('iE-Extensions', _DRB_To_Remove_Item_EUTRAN_iE_Extensions),
        ])
    DRB_To_Remove_Item_EUTRAN._ext = []
    
    #-----< DRB-To-Remove-Item-EUTRAN-ExtIEs >-----#
    DRB_To_Remove_Item_EUTRAN_ExtIEs = CLASS(name='DRB-To-Remove-Item-EUTRAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRB_To_Remove_Item_EUTRAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-Required-To-Remove-List-EUTRAN >-----#
    DRB_Required_To_Remove_List_EUTRAN = SEQ_OF(name='DRB-Required-To-Remove-List-EUTRAN', mode=MODE_TYPE)
    _DRB_Required_To_Remove_List_EUTRAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Required-To-Remove-Item-EUTRAN')))
    DRB_Required_To_Remove_List_EUTRAN._cont = _DRB_Required_To_Remove_List_EUTRAN__item_
    DRB_Required_To_Remove_List_EUTRAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-Required-To-Remove-Item-EUTRAN >-----#
    DRB_Required_To_Remove_Item_EUTRAN = SEQ(name='DRB-Required-To-Remove-Item-EUTRAN', mode=MODE_TYPE)
    _DRB_Required_To_Remove_Item_EUTRAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_Required_To_Remove_Item_EUTRAN_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__id._const_tab = ____DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__id_tab
    ___DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__criticality._const_tab = ____DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__criticality_tab
    ___DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__extensionValue_tab
    ___DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__id),
        ('criticality', ___DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item_._ext = None
    _DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions._cont = __DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item_
    _DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Required_To_Remove_Item_EUTRAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_Required_To_Remove_Item_EUTRAN_dRB_ID),
        ('cause', _DRB_Required_To_Remove_Item_EUTRAN_cause),
        ('iE-Extensions', _DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions),
        ])
    DRB_Required_To_Remove_Item_EUTRAN._ext = []
    
    #-----< DRB-Required-To-Remove-Item-EUTRAN-ExtIEs >-----#
    DRB_Required_To_Remove_Item_EUTRAN_ExtIEs = CLASS(name='DRB-Required-To-Remove-Item-EUTRAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRB_Required_To_Remove_Item_EUTRAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-To-Remove-List-NG-RAN >-----#
    DRB_To_Remove_List_NG_RAN = SEQ_OF(name='DRB-To-Remove-List-NG-RAN', mode=MODE_TYPE)
    _DRB_To_Remove_List_NG_RAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-To-Remove-Item-NG-RAN')))
    DRB_To_Remove_List_NG_RAN._cont = _DRB_To_Remove_List_NG_RAN__item_
    DRB_To_Remove_List_NG_RAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-To-Remove-Item-NG-RAN >-----#
    DRB_To_Remove_Item_NG_RAN = SEQ(name='DRB-To-Remove-Item-NG-RAN', mode=MODE_TYPE)
    _DRB_To_Remove_Item_NG_RAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_To_Remove_Item_NG_RAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_To_Remove_Item_NG_RAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__id._const_tab = ____DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__id_tab
    ___DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__criticality._const_tab = ____DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__criticality_tab
    ___DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__extensionValue_tab
    ___DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_To_Remove_Item_NG_RAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__id),
        ('criticality', ___DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_To_Remove_Item_NG_RAN_iE_Extensions__item_._ext = None
    _DRB_To_Remove_Item_NG_RAN_iE_Extensions._cont = __DRB_To_Remove_Item_NG_RAN_iE_Extensions__item_
    _DRB_To_Remove_Item_NG_RAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_To_Remove_Item_NG_RAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_To_Remove_Item_NG_RAN_dRB_ID),
        ('iE-Extensions', _DRB_To_Remove_Item_NG_RAN_iE_Extensions),
        ])
    DRB_To_Remove_Item_NG_RAN._ext = []
    
    #-----< DRB-To-Remove-Item-NG-RAN-ExtIEs >-----#
    DRB_To_Remove_Item_NG_RAN_ExtIEs = CLASS(name='DRB-To-Remove-Item-NG-RAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRB_To_Remove_Item_NG_RAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-Required-To-Remove-List-NG-RAN >-----#
    DRB_Required_To_Remove_List_NG_RAN = SEQ_OF(name='DRB-Required-To-Remove-List-NG-RAN', mode=MODE_TYPE)
    _DRB_Required_To_Remove_List_NG_RAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Required-To-Remove-Item-NG-RAN')))
    DRB_Required_To_Remove_List_NG_RAN._cont = _DRB_Required_To_Remove_List_NG_RAN__item_
    DRB_Required_To_Remove_List_NG_RAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-Required-To-Remove-Item-NG-RAN >-----#
    DRB_Required_To_Remove_Item_NG_RAN = SEQ(name='DRB-Required-To-Remove-Item-NG-RAN', mode=MODE_TYPE)
    _DRB_Required_To_Remove_Item_NG_RAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_Required_To_Remove_Item_NG_RAN_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__id._const_tab = ____DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__id_tab
    ___DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__criticality._const_tab = ____DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__criticality_tab
    ___DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__extensionValue_tab
    ___DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__id),
        ('criticality', ___DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item_._ext = None
    _DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions._cont = __DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item_
    _DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Required_To_Remove_Item_NG_RAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_Required_To_Remove_Item_NG_RAN_dRB_ID),
        ('cause', _DRB_Required_To_Remove_Item_NG_RAN_cause),
        ('iE-Extensions', _DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions),
        ])
    DRB_Required_To_Remove_Item_NG_RAN._ext = []
    
    #-----< DRB-Required-To-Remove-Item-NG-RAN-ExtIEs >-----#
    DRB_Required_To_Remove_Item_NG_RAN_ExtIEs = CLASS(name='DRB-Required-To-Remove-Item-NG-RAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRB_Required_To_Remove_Item_NG_RAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-To-Setup-List-EUTRAN >-----#
    DRB_To_Setup_List_EUTRAN = SEQ_OF(name='DRB-To-Setup-List-EUTRAN', mode=MODE_TYPE)
    _DRB_To_Setup_List_EUTRAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-To-Setup-Item-EUTRAN')))
    DRB_To_Setup_List_EUTRAN._cont = _DRB_To_Setup_List_EUTRAN__item_
    DRB_To_Setup_List_EUTRAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-To-Setup-Item-EUTRAN >-----#
    DRB_To_Setup_Item_EUTRAN = SEQ(name='DRB-To-Setup-Item-EUTRAN', mode=MODE_TYPE)
    _DRB_To_Setup_Item_EUTRAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_To_Setup_Item_EUTRAN_pDCP_Configuration = SEQ(name='pDCP-Configuration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-Configuration')))
    _DRB_To_Setup_Item_EUTRAN_eUTRAN_QoS = SEQ(name='eUTRAN-QoS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'EUTRAN-QoS')))
    _DRB_To_Setup_Item_EUTRAN_s1_UL_UP_TNL_Information = CHOICE(name='s1-UL-UP-TNL-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _DRB_To_Setup_Item_EUTRAN_data_Forwarding_Information_Request = SEQ(name='data-Forwarding-Information-Request', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Data-Forwarding-Information-Request')), opt=True)
    _DRB_To_Setup_Item_EUTRAN_cell_Group_Information = SEQ_OF(name='cell-Group-Information', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cell-Group-Information')))
    _DRB_To_Setup_Item_EUTRAN_dL_UP_Parameters = SEQ_OF(name='dL-UP-Parameters', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-Parameters')), opt=True)
    _DRB_To_Setup_Item_EUTRAN_dRB_Inactivity_Timer = INT(name='dRB-Inactivity-Timer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Inactivity-Timer')), opt=True)
    _DRB_To_Setup_Item_EUTRAN_existing_Allocated_S1_DL_UP_TNL_Info = CHOICE(name='existing-Allocated-S1-DL-UP-TNL-Info', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')), opt=True)
    _DRB_To_Setup_Item_EUTRAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_To_Setup_Item_EUTRAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    _____DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SecurityIndication')))
    ____DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 142), ('criticality', 'ignore'), ('Extension', _____DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 172), ('criticality', 'reject'), ('Extension', _____DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__id._const_tab = ____DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__id_tab
    ___DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__criticality._const_tab = ____DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__id_tab
    ___DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__id_tab
    ___DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_To_Setup_Item_EUTRAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__id),
        ('criticality', ___DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_To_Setup_Item_EUTRAN_iE_Extensions__item_._ext = None
    _DRB_To_Setup_Item_EUTRAN_iE_Extensions._cont = __DRB_To_Setup_Item_EUTRAN_iE_Extensions__item_
    _DRB_To_Setup_Item_EUTRAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_To_Setup_Item_EUTRAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_To_Setup_Item_EUTRAN_dRB_ID),
        ('pDCP-Configuration', _DRB_To_Setup_Item_EUTRAN_pDCP_Configuration),
        ('eUTRAN-QoS', _DRB_To_Setup_Item_EUTRAN_eUTRAN_QoS),
        ('s1-UL-UP-TNL-Information', _DRB_To_Setup_Item_EUTRAN_s1_UL_UP_TNL_Information),
        ('data-Forwarding-Information-Request', _DRB_To_Setup_Item_EUTRAN_data_Forwarding_Information_Request),
        ('cell-Group-Information', _DRB_To_Setup_Item_EUTRAN_cell_Group_Information),
        ('dL-UP-Parameters', _DRB_To_Setup_Item_EUTRAN_dL_UP_Parameters),
        ('dRB-Inactivity-Timer', _DRB_To_Setup_Item_EUTRAN_dRB_Inactivity_Timer),
        ('existing-Allocated-S1-DL-UP-TNL-Info', _DRB_To_Setup_Item_EUTRAN_existing_Allocated_S1_DL_UP_TNL_Info),
        ('iE-Extensions', _DRB_To_Setup_Item_EUTRAN_iE_Extensions),
        ])
    DRB_To_Setup_Item_EUTRAN._ext = []
    
    #-----< DRB-To-Setup-Item-EUTRAN-ExtIEs >-----#
    DRB_To_Setup_Item_EUTRAN_ExtIEs = CLASS(name='DRB-To-Setup-Item-EUTRAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _DRB_To_Setup_Item_EUTRAN_ExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    _DRB_To_Setup_Item_EUTRAN_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SecurityIndication')))
    DRB_To_Setup_Item_EUTRAN_ExtIEs._val = ASN1Set(rv=[dict([('id', 142), ('criticality', 'ignore'), ('Extension', _DRB_To_Setup_Item_EUTRAN_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 172), ('criticality', 'reject'), ('Extension', _DRB_To_Setup_Item_EUTRAN_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRB-To-Setup-Mod-List-EUTRAN >-----#
    DRB_To_Setup_Mod_List_EUTRAN = SEQ_OF(name='DRB-To-Setup-Mod-List-EUTRAN', mode=MODE_TYPE)
    _DRB_To_Setup_Mod_List_EUTRAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-To-Setup-Mod-Item-EUTRAN')))
    DRB_To_Setup_Mod_List_EUTRAN._cont = _DRB_To_Setup_Mod_List_EUTRAN__item_
    DRB_To_Setup_Mod_List_EUTRAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-To-Setup-Mod-Item-EUTRAN >-----#
    DRB_To_Setup_Mod_Item_EUTRAN = SEQ(name='DRB-To-Setup-Mod-Item-EUTRAN', mode=MODE_TYPE)
    _DRB_To_Setup_Mod_Item_EUTRAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_To_Setup_Mod_Item_EUTRAN_pDCP_Configuration = SEQ(name='pDCP-Configuration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-Configuration')))
    _DRB_To_Setup_Mod_Item_EUTRAN_eUTRAN_QoS = SEQ(name='eUTRAN-QoS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'EUTRAN-QoS')))
    _DRB_To_Setup_Mod_Item_EUTRAN_s1_UL_UP_TNL_Information = CHOICE(name='s1-UL-UP-TNL-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _DRB_To_Setup_Mod_Item_EUTRAN_data_Forwarding_Information_Request = SEQ(name='data-Forwarding-Information-Request', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Data-Forwarding-Information-Request')), opt=True)
    _DRB_To_Setup_Mod_Item_EUTRAN_cell_Group_Information = SEQ_OF(name='cell-Group-Information', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cell-Group-Information')))
    _DRB_To_Setup_Mod_Item_EUTRAN_dL_UP_Parameters = SEQ_OF(name='dL-UP-Parameters', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-Parameters')), opt=True)
    _DRB_To_Setup_Mod_Item_EUTRAN_dRB_Inactivity_Timer = INT(name='dRB-Inactivity-Timer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Inactivity-Timer')), opt=True)
    _DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SecurityIndication')))
    _____DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    ____DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 172), ('criticality', 'reject'), ('Extension', _____DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 142), ('criticality', 'ignore'), ('Extension', _____DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id._const_tab = ____DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id_tab
    ___DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__criticality._const_tab = ____DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id_tab
    ___DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id_tab
    ___DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id),
        ('criticality', ___DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item_._ext = None
    _DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions._cont = __DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item_
    _DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_To_Setup_Mod_Item_EUTRAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_To_Setup_Mod_Item_EUTRAN_dRB_ID),
        ('pDCP-Configuration', _DRB_To_Setup_Mod_Item_EUTRAN_pDCP_Configuration),
        ('eUTRAN-QoS', _DRB_To_Setup_Mod_Item_EUTRAN_eUTRAN_QoS),
        ('s1-UL-UP-TNL-Information', _DRB_To_Setup_Mod_Item_EUTRAN_s1_UL_UP_TNL_Information),
        ('data-Forwarding-Information-Request', _DRB_To_Setup_Mod_Item_EUTRAN_data_Forwarding_Information_Request),
        ('cell-Group-Information', _DRB_To_Setup_Mod_Item_EUTRAN_cell_Group_Information),
        ('dL-UP-Parameters', _DRB_To_Setup_Mod_Item_EUTRAN_dL_UP_Parameters),
        ('dRB-Inactivity-Timer', _DRB_To_Setup_Mod_Item_EUTRAN_dRB_Inactivity_Timer),
        ('iE-Extensions', _DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions),
        ])
    DRB_To_Setup_Mod_Item_EUTRAN._ext = []
    
    #-----< DRB-To-Setup-Mod-Item-EUTRAN-ExtIEs >-----#
    DRB_To_Setup_Mod_Item_EUTRAN_ExtIEs = CLASS(name='DRB-To-Setup-Mod-Item-EUTRAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _DRB_To_Setup_Mod_Item_EUTRAN_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SecurityIndication')))
    _DRB_To_Setup_Mod_Item_EUTRAN_ExtIEs_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    DRB_To_Setup_Mod_Item_EUTRAN_ExtIEs._val = ASN1Set(rv=[dict([('id', 172), ('criticality', 'reject'), ('Extension', _DRB_To_Setup_Mod_Item_EUTRAN_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 142), ('criticality', 'ignore'), ('Extension', _DRB_To_Setup_Mod_Item_EUTRAN_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRB-To-Setup-List-NG-RAN >-----#
    DRB_To_Setup_List_NG_RAN = SEQ_OF(name='DRB-To-Setup-List-NG-RAN', mode=MODE_TYPE)
    _DRB_To_Setup_List_NG_RAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-To-Setup-Item-NG-RAN')))
    DRB_To_Setup_List_NG_RAN._cont = _DRB_To_Setup_List_NG_RAN__item_
    DRB_To_Setup_List_NG_RAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-To-Setup-Item-NG-RAN >-----#
    DRB_To_Setup_Item_NG_RAN = SEQ(name='DRB-To-Setup-Item-NG-RAN', mode=MODE_TYPE)
    _DRB_To_Setup_Item_NG_RAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_To_Setup_Item_NG_RAN_sDAP_Configuration = SEQ(name='sDAP-Configuration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'SDAP-Configuration')))
    _DRB_To_Setup_Item_NG_RAN_pDCP_Configuration = SEQ(name='pDCP-Configuration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-Configuration')))
    _DRB_To_Setup_Item_NG_RAN_cell_Group_Information = SEQ_OF(name='cell-Group-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cell-Group-Information')))
    _DRB_To_Setup_Item_NG_RAN_qos_flow_Information_To_Be_Setup = SEQ_OF(name='qos-flow-Information-To-Be-Setup', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-QoS-Parameter-List')))
    _DRB_To_Setup_Item_NG_RAN_dRB_Data_Forwarding_Information_Request = SEQ(name='dRB-Data-Forwarding-Information-Request', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Data-Forwarding-Information-Request')), opt=True)
    _DRB_To_Setup_Item_NG_RAN_dRB_Inactivity_Timer = INT(name='dRB-Inactivity-Timer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Inactivity-Timer')), opt=True)
    _DRB_To_Setup_Item_NG_RAN_pDCP_SN_Status_Information = SEQ(name='pDCP-SN-Status-Information', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-SN-Status-Information')), opt=True)
    _DRB_To_Setup_Item_NG_RAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_To_Setup_Item_NG_RAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QoSFlowLevelQoSParameters')))
    _____DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DAPSRequestInfo')))
    _____DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'IgnoreMappingRuleIndication')))
    _____DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flows-DRB-Remapping')))
    _____DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SDTindicatorSetup')))
    ____DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 72), ('criticality', 'ignore'), ('Extension', _____DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 120), ('criticality', 'ignore'), ('Extension', _____DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 138), ('criticality', 'reject'), ('Extension', _____DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 141), ('criticality', 'reject'), ('Extension', _____DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 175), ('criticality', 'reject'), ('Extension', _____DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id._const_tab = ____DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id_tab
    ___DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__criticality._const_tab = ____DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id_tab
    ___DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id_tab
    ___DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_To_Setup_Item_NG_RAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id),
        ('criticality', ___DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_To_Setup_Item_NG_RAN_iE_Extensions__item_._ext = None
    _DRB_To_Setup_Item_NG_RAN_iE_Extensions._cont = __DRB_To_Setup_Item_NG_RAN_iE_Extensions__item_
    _DRB_To_Setup_Item_NG_RAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_To_Setup_Item_NG_RAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_To_Setup_Item_NG_RAN_dRB_ID),
        ('sDAP-Configuration', _DRB_To_Setup_Item_NG_RAN_sDAP_Configuration),
        ('pDCP-Configuration', _DRB_To_Setup_Item_NG_RAN_pDCP_Configuration),
        ('cell-Group-Information', _DRB_To_Setup_Item_NG_RAN_cell_Group_Information),
        ('qos-flow-Information-To-Be-Setup', _DRB_To_Setup_Item_NG_RAN_qos_flow_Information_To_Be_Setup),
        ('dRB-Data-Forwarding-Information-Request', _DRB_To_Setup_Item_NG_RAN_dRB_Data_Forwarding_Information_Request),
        ('dRB-Inactivity-Timer', _DRB_To_Setup_Item_NG_RAN_dRB_Inactivity_Timer),
        ('pDCP-SN-Status-Information', _DRB_To_Setup_Item_NG_RAN_pDCP_SN_Status_Information),
        ('iE-Extensions', _DRB_To_Setup_Item_NG_RAN_iE_Extensions),
        ])
    DRB_To_Setup_Item_NG_RAN._ext = []
    
    #-----< DRB-To-Setup-Item-NG-RAN-ExtIEs >-----#
    DRB_To_Setup_Item_NG_RAN_ExtIEs = CLASS(name='DRB-To-Setup-Item-NG-RAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _DRB_To_Setup_Item_NG_RAN_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QoSFlowLevelQoSParameters')))
    _DRB_To_Setup_Item_NG_RAN_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DAPSRequestInfo')))
    _DRB_To_Setup_Item_NG_RAN_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'IgnoreMappingRuleIndication')))
    _DRB_To_Setup_Item_NG_RAN_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flows-DRB-Remapping')))
    _DRB_To_Setup_Item_NG_RAN_ExtIEs_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SDTindicatorSetup')))
    DRB_To_Setup_Item_NG_RAN_ExtIEs._val = ASN1Set(rv=[dict([('id', 72), ('criticality', 'ignore'), ('Extension', _DRB_To_Setup_Item_NG_RAN_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 120), ('criticality', 'ignore'), ('Extension', _DRB_To_Setup_Item_NG_RAN_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 138), ('criticality', 'reject'), ('Extension', _DRB_To_Setup_Item_NG_RAN_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 141), ('criticality', 'reject'), ('Extension', _DRB_To_Setup_Item_NG_RAN_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 175), ('criticality', 'reject'), ('Extension', _DRB_To_Setup_Item_NG_RAN_ExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRB-To-Setup-Mod-List-NG-RAN >-----#
    DRB_To_Setup_Mod_List_NG_RAN = SEQ_OF(name='DRB-To-Setup-Mod-List-NG-RAN', mode=MODE_TYPE)
    _DRB_To_Setup_Mod_List_NG_RAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-To-Setup-Mod-Item-NG-RAN')))
    DRB_To_Setup_Mod_List_NG_RAN._cont = _DRB_To_Setup_Mod_List_NG_RAN__item_
    DRB_To_Setup_Mod_List_NG_RAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRB-To-Setup-Mod-Item-NG-RAN >-----#
    DRB_To_Setup_Mod_Item_NG_RAN = SEQ(name='DRB-To-Setup-Mod-Item-NG-RAN', mode=MODE_TYPE)
    _DRB_To_Setup_Mod_Item_NG_RAN_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-ID')))
    _DRB_To_Setup_Mod_Item_NG_RAN_sDAP_Configuration = SEQ(name='sDAP-Configuration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'SDAP-Configuration')))
    _DRB_To_Setup_Mod_Item_NG_RAN_pDCP_Configuration = SEQ(name='pDCP-Configuration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-Configuration')))
    _DRB_To_Setup_Mod_Item_NG_RAN_cell_Group_Information = SEQ_OF(name='cell-Group-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cell-Group-Information')))
    _DRB_To_Setup_Mod_Item_NG_RAN_flow_Mapping_Information = SEQ_OF(name='flow-Mapping-Information', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-QoS-Parameter-List')))
    _DRB_To_Setup_Mod_Item_NG_RAN_dRB_Data_Forwarding_Information_Request = SEQ(name='dRB-Data-Forwarding-Information-Request', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Data-Forwarding-Information-Request')), opt=True)
    _DRB_To_Setup_Mod_Item_NG_RAN_dRB_Inactivity_Timer = INT(name='dRB-Inactivity-Timer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Inactivity-Timer')), opt=True)
    _DRB_To_Setup_Mod_Item_NG_RAN_pDCP_SN_Status_Information = SEQ(name='pDCP-SN-Status-Information', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-SN-Status-Information')), opt=True)
    _DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QoSFlowLevelQoSParameters')))
    _____DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'IgnoreMappingRuleIndication')))
    _____DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DAPSRequestInfo')))
    _____DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SDTindicatorSetup')))
    ____DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 72), ('criticality', 'ignore'), ('Extension', _____DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 138), ('criticality', 'reject'), ('Extension', _____DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 120), ('criticality', 'ignore'), ('Extension', _____DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 175), ('criticality', 'reject'), ('Extension', _____DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id._const_tab = ____DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id_tab
    ___DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id._const_tab_at = None
    ___DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__criticality._const_tab = ____DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id_tab
    ___DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab = ____DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id_tab
    ___DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id),
        ('criticality', ___DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue),
        ])
    __DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item_._ext = None
    _DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions._cont = __DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item_
    _DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_To_Setup_Mod_Item_NG_RAN._cont = ASN1Dict([
        ('dRB-ID', _DRB_To_Setup_Mod_Item_NG_RAN_dRB_ID),
        ('sDAP-Configuration', _DRB_To_Setup_Mod_Item_NG_RAN_sDAP_Configuration),
        ('pDCP-Configuration', _DRB_To_Setup_Mod_Item_NG_RAN_pDCP_Configuration),
        ('cell-Group-Information', _DRB_To_Setup_Mod_Item_NG_RAN_cell_Group_Information),
        ('flow-Mapping-Information', _DRB_To_Setup_Mod_Item_NG_RAN_flow_Mapping_Information),
        ('dRB-Data-Forwarding-Information-Request', _DRB_To_Setup_Mod_Item_NG_RAN_dRB_Data_Forwarding_Information_Request),
        ('dRB-Inactivity-Timer', _DRB_To_Setup_Mod_Item_NG_RAN_dRB_Inactivity_Timer),
        ('pDCP-SN-Status-Information', _DRB_To_Setup_Mod_Item_NG_RAN_pDCP_SN_Status_Information),
        ('iE-Extensions', _DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions),
        ])
    DRB_To_Setup_Mod_Item_NG_RAN._ext = []
    
    #-----< DRB-To-Setup-Mod-Item-NG-RAN-ExtIEs >-----#
    DRB_To_Setup_Mod_Item_NG_RAN_ExtIEs = CLASS(name='DRB-To-Setup-Mod-Item-NG-RAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _DRB_To_Setup_Mod_Item_NG_RAN_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QoSFlowLevelQoSParameters')))
    _DRB_To_Setup_Mod_Item_NG_RAN_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'IgnoreMappingRuleIndication')))
    _DRB_To_Setup_Mod_Item_NG_RAN_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DAPSRequestInfo')))
    _DRB_To_Setup_Mod_Item_NG_RAN_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SDTindicatorSetup')))
    DRB_To_Setup_Mod_Item_NG_RAN_ExtIEs._val = ASN1Set(rv=[dict([('id', 72), ('criticality', 'ignore'), ('Extension', _DRB_To_Setup_Mod_Item_NG_RAN_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 138), ('criticality', 'reject'), ('Extension', _DRB_To_Setup_Mod_Item_NG_RAN_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 120), ('criticality', 'ignore'), ('Extension', _DRB_To_Setup_Mod_Item_NG_RAN_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 175), ('criticality', 'reject'), ('Extension', _DRB_To_Setup_Mod_Item_NG_RAN_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRB-Usage-Report-List >-----#
    DRB_Usage_Report_List = SEQ_OF(name='DRB-Usage-Report-List', mode=MODE_TYPE)
    _DRB_Usage_Report_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Usage-Report-Item')))
    DRB_Usage_Report_List._cont = _DRB_Usage_Report_List__item_
    DRB_Usage_Report_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< DRB-Usage-Report-Item >-----#
    DRB_Usage_Report_Item = SEQ(name='DRB-Usage-Report-Item', mode=MODE_TYPE)
    _DRB_Usage_Report_Item_startTimeStamp = OCT_STR(name='startTimeStamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DRB_Usage_Report_Item_startTimeStamp._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _DRB_Usage_Report_Item_endTimeStamp = OCT_STR(name='endTimeStamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DRB_Usage_Report_Item_endTimeStamp._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _DRB_Usage_Report_Item_usageCountUL = INT(name='usageCountUL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DRB_Usage_Report_Item_usageCountUL._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=18446744073709551615)], ev=None, er=[])
    _DRB_Usage_Report_Item_usageCountDL = INT(name='usageCountDL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DRB_Usage_Report_Item_usageCountDL._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=18446744073709551615)], ev=None, er=[])
    _DRB_Usage_Report_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Usage_Report_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Usage_Report_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Usage_Report_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Usage_Report_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Usage_Report_Item_iE_Extensions__item__id._const_tab = ____DRB_Usage_Report_Item_iE_Extensions__item__id_tab
    ___DRB_Usage_Report_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Usage_Report_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Usage_Report_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRB_Usage_Report_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Usage_Report_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Usage_Report_Item_iE_Extensions__item__criticality._const_tab = ____DRB_Usage_Report_Item_iE_Extensions__item__criticality_tab
    ___DRB_Usage_Report_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Usage_Report_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Usage_Report_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRB_Usage_Report_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRB_Usage_Report_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Usage_Report_Item_iE_Extensions__item__extensionValue._const_tab = ____DRB_Usage_Report_Item_iE_Extensions__item__extensionValue_tab
    ___DRB_Usage_Report_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Usage_Report_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Usage_Report_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Usage_Report_Item_iE_Extensions__item__id),
        ('criticality', ___DRB_Usage_Report_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Usage_Report_Item_iE_Extensions__item__extensionValue),
        ])
    __DRB_Usage_Report_Item_iE_Extensions__item_._ext = None
    _DRB_Usage_Report_Item_iE_Extensions._cont = __DRB_Usage_Report_Item_iE_Extensions__item_
    _DRB_Usage_Report_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Usage_Report_Item._cont = ASN1Dict([
        ('startTimeStamp', _DRB_Usage_Report_Item_startTimeStamp),
        ('endTimeStamp', _DRB_Usage_Report_Item_endTimeStamp),
        ('usageCountUL', _DRB_Usage_Report_Item_usageCountUL),
        ('usageCountDL', _DRB_Usage_Report_Item_usageCountDL),
        ('iE-Extensions', _DRB_Usage_Report_Item_iE_Extensions),
        ])
    DRB_Usage_Report_Item._ext = []
    
    #-----< DRB-Usage-Report-Item-ExtIEs >-----#
    DRB_Usage_Report_Item_ExtIEs = CLASS(name='DRB-Usage-Report-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRB_Usage_Report_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Duplication-Activation >-----#
    Duplication_Activation = ENUM(name='Duplication-Activation', mode=MODE_TYPE)
    Duplication_Activation._cont = ASN1Dict([('active', 0), ('inactive', 1)])
    Duplication_Activation._ext = []
    
    #-----< Dynamic5QIDescriptor >-----#
    Dynamic5QIDescriptor = SEQ(name='Dynamic5QIDescriptor', mode=MODE_TYPE)
    _Dynamic5QIDescriptor_qoSPriorityLevel = INT(name='qoSPriorityLevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoSPriorityLevel')))
    _Dynamic5QIDescriptor_packetDelayBudget = INT(name='packetDelayBudget', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PacketDelayBudget')))
    _Dynamic5QIDescriptor_packetErrorRate = SEQ(name='packetErrorRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PacketErrorRate')))
    _Dynamic5QIDescriptor_fiveQI = INT(name='fiveQI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Dynamic5QIDescriptor_fiveQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    _Dynamic5QIDescriptor_delayCritical = ENUM(name='delayCritical', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Dynamic5QIDescriptor_delayCritical._cont = ASN1Dict([('delay-critical', 0), ('non-delay-critical', 1)])
    _Dynamic5QIDescriptor_delayCritical._ext = None
    _Dynamic5QIDescriptor_averagingWindow = INT(name='averagingWindow', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'AveragingWindow')), opt=True)
    _Dynamic5QIDescriptor_maxDataBurstVolume = INT(name='maxDataBurstVolume', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MaxDataBurstVolume')), opt=True)
    _Dynamic5QIDescriptor_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Dynamic5QIDescriptor_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___Dynamic5QIDescriptor_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ExtendedPacketDelayBudget')))
    _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ExtendedPacketDelayBudget')))
    _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ExtendedPacketDelayBudget')))
    ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 103), ('criticality', 'ignore'), ('Extension', _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 101), ('criticality', 'ignore'), ('Extension', _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 102), ('criticality', 'ignore'), ('Extension', _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Dynamic5QIDescriptor_iE_Extensions__item__id._const_tab = ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___Dynamic5QIDescriptor_iE_Extensions__item__id._const_tab_at = None
    ___Dynamic5QIDescriptor_iE_Extensions__item__id._const_tab_id = 'id'
    ___Dynamic5QIDescriptor_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Dynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab = ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___Dynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Dynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab = ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Dynamic5QIDescriptor_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Dynamic5QIDescriptor_iE_Extensions__item__id),
        ('criticality', ___Dynamic5QIDescriptor_iE_Extensions__item__criticality),
        ('extensionValue', ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue),
        ])
    __Dynamic5QIDescriptor_iE_Extensions__item_._ext = None
    _Dynamic5QIDescriptor_iE_Extensions._cont = __Dynamic5QIDescriptor_iE_Extensions__item_
    _Dynamic5QIDescriptor_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Dynamic5QIDescriptor._cont = ASN1Dict([
        ('qoSPriorityLevel', _Dynamic5QIDescriptor_qoSPriorityLevel),
        ('packetDelayBudget', _Dynamic5QIDescriptor_packetDelayBudget),
        ('packetErrorRate', _Dynamic5QIDescriptor_packetErrorRate),
        ('fiveQI', _Dynamic5QIDescriptor_fiveQI),
        ('delayCritical', _Dynamic5QIDescriptor_delayCritical),
        ('averagingWindow', _Dynamic5QIDescriptor_averagingWindow),
        ('maxDataBurstVolume', _Dynamic5QIDescriptor_maxDataBurstVolume),
        ('iE-Extensions', _Dynamic5QIDescriptor_iE_Extensions),
        ])
    Dynamic5QIDescriptor._ext = None
    
    #-----< Dynamic5QIDescriptor-ExtIEs >-----#
    Dynamic5QIDescriptor_ExtIEs = CLASS(name='Dynamic5QIDescriptor-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _Dynamic5QIDescriptor_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ExtendedPacketDelayBudget')))
    _Dynamic5QIDescriptor_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ExtendedPacketDelayBudget')))
    _Dynamic5QIDescriptor_ExtIEs_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ExtendedPacketDelayBudget')))
    Dynamic5QIDescriptor_ExtIEs._val = ASN1Set(rv=[dict([('id', 103), ('criticality', 'ignore'), ('Extension', _Dynamic5QIDescriptor_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 101), ('criticality', 'ignore'), ('Extension', _Dynamic5QIDescriptor_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 102), ('criticality', 'ignore'), ('Extension', _Dynamic5QIDescriptor_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DataDiscardRequired >-----#
    DataDiscardRequired = ENUM(name='DataDiscardRequired', mode=MODE_TYPE)
    DataDiscardRequired._cont = ASN1Dict([('required', 0)])
    DataDiscardRequired._ext = []
    
    #-----< EarlyDataForwardingIndicator >-----#
    EarlyDataForwardingIndicator = ENUM(name='EarlyDataForwardingIndicator', mode=MODE_TYPE)
    EarlyDataForwardingIndicator._cont = ASN1Dict([('stop', 0)])
    EarlyDataForwardingIndicator._ext = []
    
    #-----< EarlyForwardingCOUNTInfo >-----#
    EarlyForwardingCOUNTInfo = CHOICE(name='EarlyForwardingCOUNTInfo', mode=MODE_TYPE)
    _EarlyForwardingCOUNTInfo_firstDLCount = SEQ(name='firstDLCount', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'FirstDLCount')))
    _EarlyForwardingCOUNTInfo_dLDiscardingCount = SEQ(name='dLDiscardingCount', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DLDiscarding')))
    _EarlyForwardingCOUNTInfo_choice_Extension = SEQ(name='choice-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __EarlyForwardingCOUNTInfo_choice_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___EarlyForwardingCOUNTInfo_choice_Extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___EarlyForwardingCOUNTInfo_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __EarlyForwardingCOUNTInfo_choice_Extension_id._const_tab = ___EarlyForwardingCOUNTInfo_choice_Extension_id_tab
    __EarlyForwardingCOUNTInfo_choice_Extension_id._const_tab_at = None
    __EarlyForwardingCOUNTInfo_choice_Extension_id._const_tab_id = 'id'
    __EarlyForwardingCOUNTInfo_choice_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___EarlyForwardingCOUNTInfo_choice_Extension_criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___EarlyForwardingCOUNTInfo_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __EarlyForwardingCOUNTInfo_choice_Extension_criticality._const_tab = ___EarlyForwardingCOUNTInfo_choice_Extension_criticality_tab
    __EarlyForwardingCOUNTInfo_choice_Extension_criticality._const_tab_at = ('..', 'id')
    __EarlyForwardingCOUNTInfo_choice_Extension_criticality._const_tab_id = 'criticality'
    __EarlyForwardingCOUNTInfo_choice_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___EarlyForwardingCOUNTInfo_choice_Extension_value_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___EarlyForwardingCOUNTInfo_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __EarlyForwardingCOUNTInfo_choice_Extension_value._const_tab = ___EarlyForwardingCOUNTInfo_choice_Extension_value_tab
    __EarlyForwardingCOUNTInfo_choice_Extension_value._const_tab_at = ('..', 'id')
    __EarlyForwardingCOUNTInfo_choice_Extension_value._const_tab_id = 'Value'
    _EarlyForwardingCOUNTInfo_choice_Extension._cont = ASN1Dict([
        ('id', __EarlyForwardingCOUNTInfo_choice_Extension_id),
        ('criticality', __EarlyForwardingCOUNTInfo_choice_Extension_criticality),
        ('value', __EarlyForwardingCOUNTInfo_choice_Extension_value),
        ])
    _EarlyForwardingCOUNTInfo_choice_Extension._ext = None
    EarlyForwardingCOUNTInfo._cont = ASN1Dict([
        ('firstDLCount', _EarlyForwardingCOUNTInfo_firstDLCount),
        ('dLDiscardingCount', _EarlyForwardingCOUNTInfo_dLDiscardingCount),
        ('choice-Extension', _EarlyForwardingCOUNTInfo_choice_Extension),
        ])
    EarlyForwardingCOUNTInfo._ext = None
    
    #-----< EarlyForwardingCOUNTInfo-ExtIEs >-----#
    EarlyForwardingCOUNTInfo_ExtIEs = CLASS(name='EarlyForwardingCOUNTInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    EarlyForwardingCOUNTInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EarlyForwardingCOUNTReq >-----#
    EarlyForwardingCOUNTReq = ENUM(name='EarlyForwardingCOUNTReq', mode=MODE_TYPE)
    EarlyForwardingCOUNTReq._cont = ASN1Dict([('first-dl-count', 0), ('dl-discarding', 1)])
    EarlyForwardingCOUNTReq._ext = []
    
    #-----< EHC-Common-Parameters >-----#
    EHC_Common_Parameters = SEQ(name='EHC-Common-Parameters', mode=MODE_TYPE)
    _EHC_Common_Parameters_ehc_CID_Length = ENUM(name='ehc-CID-Length', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EHC_Common_Parameters_ehc_CID_Length._cont = ASN1Dict([('bits7', 0), ('bits15', 1)])
    _EHC_Common_Parameters_ehc_CID_Length._ext = []
    _EHC_Common_Parameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EHC_Common_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___EHC_Common_Parameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____EHC_Common_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____EHC_Common_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EHC_Common_Parameters_iE_Extensions__item__id._const_tab = ____EHC_Common_Parameters_iE_Extensions__item__id_tab
    ___EHC_Common_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___EHC_Common_Parameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___EHC_Common_Parameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EHC_Common_Parameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____EHC_Common_Parameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EHC_Common_Parameters_iE_Extensions__item__criticality._const_tab = ____EHC_Common_Parameters_iE_Extensions__item__criticality_tab
    ___EHC_Common_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EHC_Common_Parameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EHC_Common_Parameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EHC_Common_Parameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____EHC_Common_Parameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EHC_Common_Parameters_iE_Extensions__item__extensionValue._const_tab = ____EHC_Common_Parameters_iE_Extensions__item__extensionValue_tab
    ___EHC_Common_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EHC_Common_Parameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EHC_Common_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EHC_Common_Parameters_iE_Extensions__item__id),
        ('criticality', ___EHC_Common_Parameters_iE_Extensions__item__criticality),
        ('extensionValue', ___EHC_Common_Parameters_iE_Extensions__item__extensionValue),
        ])
    __EHC_Common_Parameters_iE_Extensions__item_._ext = None
    _EHC_Common_Parameters_iE_Extensions._cont = __EHC_Common_Parameters_iE_Extensions__item_
    _EHC_Common_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EHC_Common_Parameters._cont = ASN1Dict([
        ('ehc-CID-Length', _EHC_Common_Parameters_ehc_CID_Length),
        ('iE-Extensions', _EHC_Common_Parameters_iE_Extensions),
        ])
    EHC_Common_Parameters._ext = None
    
    #-----< EHC-Common-Parameters-ExtIEs >-----#
    EHC_Common_Parameters_ExtIEs = CLASS(name='EHC-Common-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    EHC_Common_Parameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EHC-Downlink-Parameters >-----#
    EHC_Downlink_Parameters = SEQ(name='EHC-Downlink-Parameters', mode=MODE_TYPE)
    _EHC_Downlink_Parameters_drb_ContinueEHC_DL = ENUM(name='drb-ContinueEHC-DL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EHC_Downlink_Parameters_drb_ContinueEHC_DL._cont = ASN1Dict([('true', 0), ('false', 1)])
    _EHC_Downlink_Parameters_drb_ContinueEHC_DL._ext = ['false']
    _EHC_Downlink_Parameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EHC_Downlink_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___EHC_Downlink_Parameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____EHC_Downlink_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____EHC_Downlink_Parameters_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MaxCIDEHCDL')))
    ____EHC_Downlink_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 137), ('criticality', 'ignore'), ('Extension', _____EHC_Downlink_Parameters_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___EHC_Downlink_Parameters_iE_Extensions__item__id._const_tab = ____EHC_Downlink_Parameters_iE_Extensions__item__id_tab
    ___EHC_Downlink_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___EHC_Downlink_Parameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___EHC_Downlink_Parameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___EHC_Downlink_Parameters_iE_Extensions__item__criticality._const_tab = ____EHC_Downlink_Parameters_iE_Extensions__item__id_tab
    ___EHC_Downlink_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EHC_Downlink_Parameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EHC_Downlink_Parameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___EHC_Downlink_Parameters_iE_Extensions__item__extensionValue._const_tab = ____EHC_Downlink_Parameters_iE_Extensions__item__id_tab
    ___EHC_Downlink_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EHC_Downlink_Parameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EHC_Downlink_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EHC_Downlink_Parameters_iE_Extensions__item__id),
        ('criticality', ___EHC_Downlink_Parameters_iE_Extensions__item__criticality),
        ('extensionValue', ___EHC_Downlink_Parameters_iE_Extensions__item__extensionValue),
        ])
    __EHC_Downlink_Parameters_iE_Extensions__item_._ext = None
    _EHC_Downlink_Parameters_iE_Extensions._cont = __EHC_Downlink_Parameters_iE_Extensions__item_
    _EHC_Downlink_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EHC_Downlink_Parameters._cont = ASN1Dict([
        ('drb-ContinueEHC-DL', _EHC_Downlink_Parameters_drb_ContinueEHC_DL),
        ('iE-Extensions', _EHC_Downlink_Parameters_iE_Extensions),
        ])
    EHC_Downlink_Parameters._ext = None
    
    #-----< EHC-Downlink-Parameters-ExtIEs >-----#
    EHC_Downlink_Parameters_ExtIEs = CLASS(name='EHC-Downlink-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _EHC_Downlink_Parameters_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MaxCIDEHCDL')))
    EHC_Downlink_Parameters_ExtIEs._val = ASN1Set(rv=[dict([('id', 137), ('criticality', 'ignore'), ('Extension', _EHC_Downlink_Parameters_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< EHC-Uplink-Parameters >-----#
    EHC_Uplink_Parameters = SEQ(name='EHC-Uplink-Parameters', mode=MODE_TYPE)
    _EHC_Uplink_Parameters_drb_ContinueEHC_UL = ENUM(name='drb-ContinueEHC-UL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EHC_Uplink_Parameters_drb_ContinueEHC_UL._cont = ASN1Dict([('true', 0), ('false', 1)])
    _EHC_Uplink_Parameters_drb_ContinueEHC_UL._ext = ['false']
    _EHC_Uplink_Parameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EHC_Uplink_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___EHC_Uplink_Parameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____EHC_Uplink_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____EHC_Uplink_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EHC_Uplink_Parameters_iE_Extensions__item__id._const_tab = ____EHC_Uplink_Parameters_iE_Extensions__item__id_tab
    ___EHC_Uplink_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___EHC_Uplink_Parameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___EHC_Uplink_Parameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EHC_Uplink_Parameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____EHC_Uplink_Parameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EHC_Uplink_Parameters_iE_Extensions__item__criticality._const_tab = ____EHC_Uplink_Parameters_iE_Extensions__item__criticality_tab
    ___EHC_Uplink_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EHC_Uplink_Parameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EHC_Uplink_Parameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EHC_Uplink_Parameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____EHC_Uplink_Parameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EHC_Uplink_Parameters_iE_Extensions__item__extensionValue._const_tab = ____EHC_Uplink_Parameters_iE_Extensions__item__extensionValue_tab
    ___EHC_Uplink_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EHC_Uplink_Parameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EHC_Uplink_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EHC_Uplink_Parameters_iE_Extensions__item__id),
        ('criticality', ___EHC_Uplink_Parameters_iE_Extensions__item__criticality),
        ('extensionValue', ___EHC_Uplink_Parameters_iE_Extensions__item__extensionValue),
        ])
    __EHC_Uplink_Parameters_iE_Extensions__item_._ext = None
    _EHC_Uplink_Parameters_iE_Extensions._cont = __EHC_Uplink_Parameters_iE_Extensions__item_
    _EHC_Uplink_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EHC_Uplink_Parameters._cont = ASN1Dict([
        ('drb-ContinueEHC-UL', _EHC_Uplink_Parameters_drb_ContinueEHC_UL),
        ('iE-Extensions', _EHC_Uplink_Parameters_iE_Extensions),
        ])
    EHC_Uplink_Parameters._ext = None
    
    #-----< EHC-Uplink-Parameters-ExtIEs >-----#
    EHC_Uplink_Parameters_ExtIEs = CLASS(name='EHC-Uplink-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    EHC_Uplink_Parameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EHC-Parameters >-----#
    EHC_Parameters = SEQ(name='EHC-Parameters', mode=MODE_TYPE)
    _EHC_Parameters_ehc_Common = SEQ(name='ehc-Common', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'EHC-Common-Parameters')))
    _EHC_Parameters_ehc_Downlink = SEQ(name='ehc-Downlink', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'EHC-Downlink-Parameters')), opt=True)
    _EHC_Parameters_ehc_Uplink = SEQ(name='ehc-Uplink', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'EHC-Uplink-Parameters')), opt=True)
    _EHC_Parameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EHC_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___EHC_Parameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____EHC_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____EHC_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EHC_Parameters_iE_Extensions__item__id._const_tab = ____EHC_Parameters_iE_Extensions__item__id_tab
    ___EHC_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___EHC_Parameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___EHC_Parameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EHC_Parameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____EHC_Parameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EHC_Parameters_iE_Extensions__item__criticality._const_tab = ____EHC_Parameters_iE_Extensions__item__criticality_tab
    ___EHC_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EHC_Parameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EHC_Parameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EHC_Parameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____EHC_Parameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EHC_Parameters_iE_Extensions__item__extensionValue._const_tab = ____EHC_Parameters_iE_Extensions__item__extensionValue_tab
    ___EHC_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EHC_Parameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EHC_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EHC_Parameters_iE_Extensions__item__id),
        ('criticality', ___EHC_Parameters_iE_Extensions__item__criticality),
        ('extensionValue', ___EHC_Parameters_iE_Extensions__item__extensionValue),
        ])
    __EHC_Parameters_iE_Extensions__item_._ext = None
    _EHC_Parameters_iE_Extensions._cont = __EHC_Parameters_iE_Extensions__item_
    _EHC_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EHC_Parameters._cont = ASN1Dict([
        ('ehc-Common', _EHC_Parameters_ehc_Common),
        ('ehc-Downlink', _EHC_Parameters_ehc_Downlink),
        ('ehc-Uplink', _EHC_Parameters_ehc_Uplink),
        ('iE-Extensions', _EHC_Parameters_iE_Extensions),
        ])
    EHC_Parameters._ext = None
    
    #-----< EHC-Parameters-ExtIEs >-----#
    EHC_Parameters_ExtIEs = CLASS(name='EHC-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    EHC_Parameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EncryptionKey >-----#
    EncryptionKey = OCT_STR(name='EncryptionKey', mode=MODE_TYPE)
    
    #-----< Endpoint-IP-address-and-port >-----#
    Endpoint_IP_address_and_port = SEQ(name='Endpoint-IP-address-and-port', mode=MODE_TYPE)
    _Endpoint_IP_address_and_port_endpoint_IP_Address = BIT_STR(name='endpoint-IP-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    _Endpoint_IP_address_and_port_portNumber = BIT_STR(name='portNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PortNumber')))
    _Endpoint_IP_address_and_port_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Endpoint_IP_address_and_port_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___Endpoint_IP_address_and_port_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Endpoint_IP_address_and_port_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Endpoint_IP_address_and_port_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Endpoint_IP_address_and_port_iE_Extensions__item__id._const_tab = ____Endpoint_IP_address_and_port_iE_Extensions__item__id_tab
    ___Endpoint_IP_address_and_port_iE_Extensions__item__id._const_tab_at = None
    ___Endpoint_IP_address_and_port_iE_Extensions__item__id._const_tab_id = 'id'
    ___Endpoint_IP_address_and_port_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Endpoint_IP_address_and_port_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Endpoint_IP_address_and_port_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Endpoint_IP_address_and_port_iE_Extensions__item__criticality._const_tab = ____Endpoint_IP_address_and_port_iE_Extensions__item__criticality_tab
    ___Endpoint_IP_address_and_port_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Endpoint_IP_address_and_port_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Endpoint_IP_address_and_port_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Endpoint_IP_address_and_port_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Endpoint_IP_address_and_port_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Endpoint_IP_address_and_port_iE_Extensions__item__extensionValue._const_tab = ____Endpoint_IP_address_and_port_iE_Extensions__item__extensionValue_tab
    ___Endpoint_IP_address_and_port_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Endpoint_IP_address_and_port_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Endpoint_IP_address_and_port_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Endpoint_IP_address_and_port_iE_Extensions__item__id),
        ('criticality', ___Endpoint_IP_address_and_port_iE_Extensions__item__criticality),
        ('extensionValue', ___Endpoint_IP_address_and_port_iE_Extensions__item__extensionValue),
        ])
    __Endpoint_IP_address_and_port_iE_Extensions__item_._ext = None
    _Endpoint_IP_address_and_port_iE_Extensions._cont = __Endpoint_IP_address_and_port_iE_Extensions__item_
    _Endpoint_IP_address_and_port_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Endpoint_IP_address_and_port._cont = ASN1Dict([
        ('endpoint-IP-Address', _Endpoint_IP_address_and_port_endpoint_IP_Address),
        ('portNumber', _Endpoint_IP_address_and_port_portNumber),
        ('iE-Extensions', _Endpoint_IP_address_and_port_iE_Extensions),
        ])
    Endpoint_IP_address_and_port._ext = None
    
    #-----< Endpoint-IP-address-and-port-ExtIEs >-----#
    Endpoint_IP_address_and_port_ExtIEs = CLASS(name='Endpoint-IP-address-and-port-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    Endpoint_IP_address_and_port_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRANAllocationAndRetentionPriority >-----#
    EUTRANAllocationAndRetentionPriority = SEQ(name='EUTRANAllocationAndRetentionPriority', mode=MODE_TYPE)
    _EUTRANAllocationAndRetentionPriority_priorityLevel = INT(name='priorityLevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PriorityLevel')))
    _EUTRANAllocationAndRetentionPriority_pre_emptionCapability = ENUM(name='pre-emptionCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Pre-emptionCapability')))
    _EUTRANAllocationAndRetentionPriority_pre_emptionVulnerability = ENUM(name='pre-emptionVulnerability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Pre-emptionVulnerability')))
    _EUTRANAllocationAndRetentionPriority_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRANAllocationAndRetentionPriority_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___EUTRANAllocationAndRetentionPriority_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____EUTRANAllocationAndRetentionPriority_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____EUTRANAllocationAndRetentionPriority_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRANAllocationAndRetentionPriority_iE_Extensions__item__id._const_tab = ____EUTRANAllocationAndRetentionPriority_iE_Extensions__item__id_tab
    ___EUTRANAllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_at = None
    ___EUTRANAllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_id = 'id'
    ___EUTRANAllocationAndRetentionPriority_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EUTRANAllocationAndRetentionPriority_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____EUTRANAllocationAndRetentionPriority_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRANAllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab = ____EUTRANAllocationAndRetentionPriority_iE_Extensions__item__criticality_tab
    ___EUTRANAllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EUTRANAllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EUTRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EUTRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____EUTRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab = ____EUTRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab
    ___EUTRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EUTRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EUTRANAllocationAndRetentionPriority_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EUTRANAllocationAndRetentionPriority_iE_Extensions__item__id),
        ('criticality', ___EUTRANAllocationAndRetentionPriority_iE_Extensions__item__criticality),
        ('extensionValue', ___EUTRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue),
        ])
    __EUTRANAllocationAndRetentionPriority_iE_Extensions__item_._ext = None
    _EUTRANAllocationAndRetentionPriority_iE_Extensions._cont = __EUTRANAllocationAndRetentionPriority_iE_Extensions__item_
    _EUTRANAllocationAndRetentionPriority_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRANAllocationAndRetentionPriority._cont = ASN1Dict([
        ('priorityLevel', _EUTRANAllocationAndRetentionPriority_priorityLevel),
        ('pre-emptionCapability', _EUTRANAllocationAndRetentionPriority_pre_emptionCapability),
        ('pre-emptionVulnerability', _EUTRANAllocationAndRetentionPriority_pre_emptionVulnerability),
        ('iE-Extensions', _EUTRANAllocationAndRetentionPriority_iE_Extensions),
        ])
    EUTRANAllocationAndRetentionPriority._ext = []
    
    #-----< ExtendedPacketDelayBudget >-----#
    ExtendedPacketDelayBudget = INT(name='ExtendedPacketDelayBudget', mode=MODE_TYPE)
    ExtendedPacketDelayBudget._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=[], er=[])
    
    #-----< EUTRANAllocationAndRetentionPriority-ExtIEs >-----#
    EUTRANAllocationAndRetentionPriority_ExtIEs = CLASS(name='EUTRANAllocationAndRetentionPriority-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    EUTRANAllocationAndRetentionPriority_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-UTRAN-Cell-Identity >-----#
    E_UTRAN_Cell_Identity = BIT_STR(name='E-UTRAN-Cell-Identity', mode=MODE_TYPE)
    E_UTRAN_Cell_Identity._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    
    #-----< ECGI >-----#
    ECGI = SEQ(name='ECGI', mode=MODE_TYPE)
    _ECGI_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PLMN-Identity')))
    _ECGI_eUTRAN_Cell_Identity = BIT_STR(name='eUTRAN-Cell-Identity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'E-UTRAN-Cell-Identity')))
    _ECGI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ECGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___ECGI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ECGI_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____ECGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ECGI_iE_Extensions__item__id._const_tab = ____ECGI_iE_Extensions__item__id_tab
    ___ECGI_iE_Extensions__item__id._const_tab_at = None
    ___ECGI_iE_Extensions__item__id._const_tab_id = 'id'
    ___ECGI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ECGI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____ECGI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ECGI_iE_Extensions__item__criticality._const_tab = ____ECGI_iE_Extensions__item__criticality_tab
    ___ECGI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ECGI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ECGI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ECGI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____ECGI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ECGI_iE_Extensions__item__extensionValue._const_tab = ____ECGI_iE_Extensions__item__extensionValue_tab
    ___ECGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ECGI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ECGI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ECGI_iE_Extensions__item__id),
        ('criticality', ___ECGI_iE_Extensions__item__criticality),
        ('extensionValue', ___ECGI_iE_Extensions__item__extensionValue),
        ])
    __ECGI_iE_Extensions__item_._ext = None
    _ECGI_iE_Extensions._cont = __ECGI_iE_Extensions__item_
    _ECGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ECGI._cont = ASN1Dict([
        ('pLMN-Identity', _ECGI_pLMN_Identity),
        ('eUTRAN-Cell-Identity', _ECGI_eUTRAN_Cell_Identity),
        ('iE-Extensions', _ECGI_iE_Extensions),
        ])
    ECGI._ext = None
    
    #-----< ECGI-ExtIEs >-----#
    ECGI_ExtIEs = CLASS(name='ECGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ECGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ECGI-Support-List >-----#
    ECGI_Support_List = SEQ_OF(name='ECGI-Support-List', mode=MODE_TYPE)
    _ECGI_Support_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ECGI-Support-Item')))
    ECGI_Support_List._cont = _ECGI_Support_List__item_
    ECGI_Support_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< ECGI-Support-Item >-----#
    ECGI_Support_Item = SEQ(name='ECGI-Support-Item', mode=MODE_TYPE)
    _ECGI_Support_Item_eCGI = SEQ(name='eCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'ECGI')))
    _ECGI_Support_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ECGI_Support_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___ECGI_Support_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ECGI_Support_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____ECGI_Support_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ECGI_Support_Item_iE_Extensions__item__id._const_tab = ____ECGI_Support_Item_iE_Extensions__item__id_tab
    ___ECGI_Support_Item_iE_Extensions__item__id._const_tab_at = None
    ___ECGI_Support_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ECGI_Support_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ECGI_Support_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____ECGI_Support_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ECGI_Support_Item_iE_Extensions__item__criticality._const_tab = ____ECGI_Support_Item_iE_Extensions__item__criticality_tab
    ___ECGI_Support_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ECGI_Support_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ECGI_Support_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ECGI_Support_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____ECGI_Support_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ECGI_Support_Item_iE_Extensions__item__extensionValue._const_tab = ____ECGI_Support_Item_iE_Extensions__item__extensionValue_tab
    ___ECGI_Support_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ECGI_Support_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ECGI_Support_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ECGI_Support_Item_iE_Extensions__item__id),
        ('criticality', ___ECGI_Support_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ECGI_Support_Item_iE_Extensions__item__extensionValue),
        ])
    __ECGI_Support_Item_iE_Extensions__item_._ext = None
    _ECGI_Support_Item_iE_Extensions._cont = __ECGI_Support_Item_iE_Extensions__item_
    _ECGI_Support_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ECGI_Support_Item._cont = ASN1Dict([
        ('eCGI', _ECGI_Support_Item_eCGI),
        ('iE-Extensions', _ECGI_Support_Item_iE_Extensions),
        ])
    ECGI_Support_Item._ext = None
    
    #-----< ECGI-Support-Item-ExtIEs >-----#
    ECGI_Support_Item_ExtIEs = CLASS(name='ECGI-Support-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ECGI_Support_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRAN-QoS-Support-List >-----#
    EUTRAN_QoS_Support_List = SEQ_OF(name='EUTRAN-QoS-Support-List', mode=MODE_TYPE)
    _EUTRAN_QoS_Support_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'EUTRAN-QoS-Support-Item')))
    EUTRAN_QoS_Support_List._cont = _EUTRAN_QoS_Support_List__item_
    EUTRAN_QoS_Support_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< EUTRAN-QoS-Support-Item >-----#
    EUTRAN_QoS_Support_Item = SEQ(name='EUTRAN-QoS-Support-Item', mode=MODE_TYPE)
    _EUTRAN_QoS_Support_Item_eUTRAN_QoS = SEQ(name='eUTRAN-QoS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'EUTRAN-QoS')))
    _EUTRAN_QoS_Support_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRAN_QoS_Support_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___EUTRAN_QoS_Support_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____EUTRAN_QoS_Support_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____EUTRAN_QoS_Support_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_QoS_Support_Item_iE_Extensions__item__id._const_tab = ____EUTRAN_QoS_Support_Item_iE_Extensions__item__id_tab
    ___EUTRAN_QoS_Support_Item_iE_Extensions__item__id._const_tab_at = None
    ___EUTRAN_QoS_Support_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___EUTRAN_QoS_Support_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EUTRAN_QoS_Support_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____EUTRAN_QoS_Support_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_QoS_Support_Item_iE_Extensions__item__criticality._const_tab = ____EUTRAN_QoS_Support_Item_iE_Extensions__item__criticality_tab
    ___EUTRAN_QoS_Support_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EUTRAN_QoS_Support_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EUTRAN_QoS_Support_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EUTRAN_QoS_Support_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____EUTRAN_QoS_Support_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_QoS_Support_Item_iE_Extensions__item__extensionValue._const_tab = ____EUTRAN_QoS_Support_Item_iE_Extensions__item__extensionValue_tab
    ___EUTRAN_QoS_Support_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EUTRAN_QoS_Support_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EUTRAN_QoS_Support_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EUTRAN_QoS_Support_Item_iE_Extensions__item__id),
        ('criticality', ___EUTRAN_QoS_Support_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___EUTRAN_QoS_Support_Item_iE_Extensions__item__extensionValue),
        ])
    __EUTRAN_QoS_Support_Item_iE_Extensions__item_._ext = None
    _EUTRAN_QoS_Support_Item_iE_Extensions._cont = __EUTRAN_QoS_Support_Item_iE_Extensions__item_
    _EUTRAN_QoS_Support_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRAN_QoS_Support_Item._cont = ASN1Dict([
        ('eUTRAN-QoS', _EUTRAN_QoS_Support_Item_eUTRAN_QoS),
        ('iE-Extensions', _EUTRAN_QoS_Support_Item_iE_Extensions),
        ])
    EUTRAN_QoS_Support_Item._ext = None
    
    #-----< EUTRAN-QoS-Support-Item-ExtIEs >-----#
    EUTRAN_QoS_Support_Item_ExtIEs = CLASS(name='EUTRAN-QoS-Support-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    EUTRAN_QoS_Support_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRAN-QoS >-----#
    EUTRAN_QoS = SEQ(name='EUTRAN-QoS', mode=MODE_TYPE)
    _EUTRAN_QoS_qCI = INT(name='qCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QCI')))
    _EUTRAN_QoS_eUTRANallocationAndRetentionPriority = SEQ(name='eUTRANallocationAndRetentionPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'EUTRANAllocationAndRetentionPriority')))
    _EUTRAN_QoS_gbrQosInformation = SEQ(name='gbrQosInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'GBR-QosInformation')), opt=True)
    _EUTRAN_QoS_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRAN_QoS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___EUTRAN_QoS_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____EUTRAN_QoS_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____EUTRAN_QoS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_QoS_iE_Extensions__item__id._const_tab = ____EUTRAN_QoS_iE_Extensions__item__id_tab
    ___EUTRAN_QoS_iE_Extensions__item__id._const_tab_at = None
    ___EUTRAN_QoS_iE_Extensions__item__id._const_tab_id = 'id'
    ___EUTRAN_QoS_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EUTRAN_QoS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____EUTRAN_QoS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_QoS_iE_Extensions__item__criticality._const_tab = ____EUTRAN_QoS_iE_Extensions__item__criticality_tab
    ___EUTRAN_QoS_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EUTRAN_QoS_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EUTRAN_QoS_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EUTRAN_QoS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____EUTRAN_QoS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_QoS_iE_Extensions__item__extensionValue._const_tab = ____EUTRAN_QoS_iE_Extensions__item__extensionValue_tab
    ___EUTRAN_QoS_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EUTRAN_QoS_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EUTRAN_QoS_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EUTRAN_QoS_iE_Extensions__item__id),
        ('criticality', ___EUTRAN_QoS_iE_Extensions__item__criticality),
        ('extensionValue', ___EUTRAN_QoS_iE_Extensions__item__extensionValue),
        ])
    __EUTRAN_QoS_iE_Extensions__item_._ext = None
    _EUTRAN_QoS_iE_Extensions._cont = __EUTRAN_QoS_iE_Extensions__item_
    _EUTRAN_QoS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRAN_QoS._cont = ASN1Dict([
        ('qCI', _EUTRAN_QoS_qCI),
        ('eUTRANallocationAndRetentionPriority', _EUTRAN_QoS_eUTRANallocationAndRetentionPriority),
        ('gbrQosInformation', _EUTRAN_QoS_gbrQosInformation),
        ('iE-Extensions', _EUTRAN_QoS_iE_Extensions),
        ])
    EUTRAN_QoS._ext = []
    
    #-----< EUTRAN-QoS-ExtIEs >-----#
    EUTRAN_QoS_ExtIEs = CLASS(name='EUTRAN-QoS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    EUTRAN_QoS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExtendedSliceSupportList >-----#
    ExtendedSliceSupportList = SEQ_OF(name='ExtendedSliceSupportList', mode=MODE_TYPE)
    _ExtendedSliceSupportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Slice-Support-Item')))
    ExtendedSliceSupportList._cont = _ExtendedSliceSupportList__item_
    ExtendedSliceSupportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< FirstDLCount >-----#
    FirstDLCount = SEQ(name='FirstDLCount', mode=MODE_TYPE)
    _FirstDLCount_firstDLCountVal = SEQ(name='firstDLCountVal', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-Count')))
    _FirstDLCount_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FirstDLCount_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___FirstDLCount_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____FirstDLCount_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____FirstDLCount_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FirstDLCount_iE_Extensions__item__id._const_tab = ____FirstDLCount_iE_Extensions__item__id_tab
    ___FirstDLCount_iE_Extensions__item__id._const_tab_at = None
    ___FirstDLCount_iE_Extensions__item__id._const_tab_id = 'id'
    ___FirstDLCount_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FirstDLCount_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____FirstDLCount_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FirstDLCount_iE_Extensions__item__criticality._const_tab = ____FirstDLCount_iE_Extensions__item__criticality_tab
    ___FirstDLCount_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FirstDLCount_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FirstDLCount_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FirstDLCount_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____FirstDLCount_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FirstDLCount_iE_Extensions__item__extensionValue._const_tab = ____FirstDLCount_iE_Extensions__item__extensionValue_tab
    ___FirstDLCount_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FirstDLCount_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FirstDLCount_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FirstDLCount_iE_Extensions__item__id),
        ('criticality', ___FirstDLCount_iE_Extensions__item__criticality),
        ('extensionValue', ___FirstDLCount_iE_Extensions__item__extensionValue),
        ])
    __FirstDLCount_iE_Extensions__item_._ext = None
    _FirstDLCount_iE_Extensions._cont = __FirstDLCount_iE_Extensions__item_
    _FirstDLCount_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FirstDLCount._cont = ASN1Dict([
        ('firstDLCountVal', _FirstDLCount_firstDLCountVal),
        ('iE-Extensions', _FirstDLCount_iE_Extensions),
        ])
    FirstDLCount._ext = None
    
    #-----< FirstDLCount-ExtIEs >-----#
    FirstDLCount_ExtIEs = CLASS(name='FirstDLCount-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    FirstDLCount_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GlobalMBSSessionID >-----#
    GlobalMBSSessionID = SEQ(name='GlobalMBSSessionID', mode=MODE_TYPE)
    _GlobalMBSSessionID_tmgi = OCT_STR(name='tmgi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GlobalMBSSessionID_tmgi._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    _GlobalMBSSessionID_nid = BIT_STR(name='nid', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'NID')), opt=True)
    _GlobalMBSSessionID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GlobalMBSSessionID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___GlobalMBSSessionID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GlobalMBSSessionID_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GlobalMBSSessionID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalMBSSessionID_iE_Extensions__item__id._const_tab = ____GlobalMBSSessionID_iE_Extensions__item__id_tab
    ___GlobalMBSSessionID_iE_Extensions__item__id._const_tab_at = None
    ___GlobalMBSSessionID_iE_Extensions__item__id._const_tab_id = 'id'
    ___GlobalMBSSessionID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GlobalMBSSessionID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GlobalMBSSessionID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalMBSSessionID_iE_Extensions__item__criticality._const_tab = ____GlobalMBSSessionID_iE_Extensions__item__criticality_tab
    ___GlobalMBSSessionID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GlobalMBSSessionID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GlobalMBSSessionID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GlobalMBSSessionID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GlobalMBSSessionID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalMBSSessionID_iE_Extensions__item__extensionValue._const_tab = ____GlobalMBSSessionID_iE_Extensions__item__extensionValue_tab
    ___GlobalMBSSessionID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GlobalMBSSessionID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GlobalMBSSessionID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GlobalMBSSessionID_iE_Extensions__item__id),
        ('criticality', ___GlobalMBSSessionID_iE_Extensions__item__criticality),
        ('extensionValue', ___GlobalMBSSessionID_iE_Extensions__item__extensionValue),
        ])
    __GlobalMBSSessionID_iE_Extensions__item_._ext = None
    _GlobalMBSSessionID_iE_Extensions._cont = __GlobalMBSSessionID_iE_Extensions__item_
    _GlobalMBSSessionID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GlobalMBSSessionID._cont = ASN1Dict([
        ('tmgi', _GlobalMBSSessionID_tmgi),
        ('nid', _GlobalMBSSessionID_nid),
        ('iE-Extensions', _GlobalMBSSessionID_iE_Extensions),
        ])
    GlobalMBSSessionID._ext = []
    
    #-----< GlobalMBSSessionID-ExtIEs >-----#
    GlobalMBSSessionID_ExtIEs = CLASS(name='GlobalMBSSessionID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    GlobalMBSSessionID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-CP-Name >-----#
    GNB_CU_CP_Name = STR_PRINT(name='GNB-CU-CP-Name', mode=MODE_TYPE)
    GNB_CU_CP_Name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< Extended-GNB-CU-CP-Name >-----#
    Extended_GNB_CU_CP_Name = SEQ(name='Extended-GNB-CU-CP-Name', mode=MODE_TYPE)
    _Extended_GNB_CU_CP_Name_gNB_CU_CP_NameVisibleString = STR_VIS(name='gNB-CU-CP-NameVisibleString', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-NameVisibleString')), opt=True)
    _Extended_GNB_CU_CP_Name_gNB_CU_CP_NameUTF8String = STR_UTF8(name='gNB-CU-CP-NameUTF8String', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-NameUTF8String')), opt=True)
    _Extended_GNB_CU_CP_Name_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Extended_GNB_CU_CP_Name_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___Extended_GNB_CU_CP_Name_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Extended_GNB_CU_CP_Name_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Extended_GNB_CU_CP_Name_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_GNB_CU_CP_Name_iE_Extensions__item__id._const_tab = ____Extended_GNB_CU_CP_Name_iE_Extensions__item__id_tab
    ___Extended_GNB_CU_CP_Name_iE_Extensions__item__id._const_tab_at = None
    ___Extended_GNB_CU_CP_Name_iE_Extensions__item__id._const_tab_id = 'id'
    ___Extended_GNB_CU_CP_Name_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Extended_GNB_CU_CP_Name_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Extended_GNB_CU_CP_Name_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_GNB_CU_CP_Name_iE_Extensions__item__criticality._const_tab = ____Extended_GNB_CU_CP_Name_iE_Extensions__item__criticality_tab
    ___Extended_GNB_CU_CP_Name_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Extended_GNB_CU_CP_Name_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Extended_GNB_CU_CP_Name_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Extended_GNB_CU_CP_Name_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Extended_GNB_CU_CP_Name_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_GNB_CU_CP_Name_iE_Extensions__item__extensionValue._const_tab = ____Extended_GNB_CU_CP_Name_iE_Extensions__item__extensionValue_tab
    ___Extended_GNB_CU_CP_Name_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Extended_GNB_CU_CP_Name_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Extended_GNB_CU_CP_Name_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Extended_GNB_CU_CP_Name_iE_Extensions__item__id),
        ('criticality', ___Extended_GNB_CU_CP_Name_iE_Extensions__item__criticality),
        ('extensionValue', ___Extended_GNB_CU_CP_Name_iE_Extensions__item__extensionValue),
        ])
    __Extended_GNB_CU_CP_Name_iE_Extensions__item_._ext = None
    _Extended_GNB_CU_CP_Name_iE_Extensions._cont = __Extended_GNB_CU_CP_Name_iE_Extensions__item_
    _Extended_GNB_CU_CP_Name_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Extended_GNB_CU_CP_Name._cont = ASN1Dict([
        ('gNB-CU-CP-NameVisibleString', _Extended_GNB_CU_CP_Name_gNB_CU_CP_NameVisibleString),
        ('gNB-CU-CP-NameUTF8String', _Extended_GNB_CU_CP_Name_gNB_CU_CP_NameUTF8String),
        ('iE-Extensions', _Extended_GNB_CU_CP_Name_iE_Extensions),
        ])
    Extended_GNB_CU_CP_Name._ext = []
    
    #-----< Extended-GNB-CU-CP-Name-ExtIEs >-----#
    Extended_GNB_CU_CP_Name_ExtIEs = CLASS(name='Extended-GNB-CU-CP-Name-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    Extended_GNB_CU_CP_Name_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-CP-MBS-E1AP-ID >-----#
    GNB_CU_CP_MBS_E1AP_ID = INT(name='GNB-CU-CP-MBS-E1AP-ID', mode=MODE_TYPE)
    GNB_CU_CP_MBS_E1AP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=None, er=[])
    
    #-----< GNB-CU-CP-NameVisibleString >-----#
    GNB_CU_CP_NameVisibleString = STR_VIS(name='GNB-CU-CP-NameVisibleString', mode=MODE_TYPE)
    GNB_CU_CP_NameVisibleString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< GNB-CU-CP-NameUTF8String >-----#
    GNB_CU_CP_NameUTF8String = STR_UTF8(name='GNB-CU-CP-NameUTF8String', mode=MODE_TYPE)
    GNB_CU_CP_NameUTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< GNB-CU-CP-UE-E1AP-ID >-----#
    GNB_CU_CP_UE_E1AP_ID = INT(name='GNB-CU-CP-UE-E1AP-ID', mode=MODE_TYPE)
    GNB_CU_CP_UE_E1AP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< GNB-CU-UP-Capacity >-----#
    GNB_CU_UP_Capacity = INT(name='GNB-CU-UP-Capacity', mode=MODE_TYPE)
    GNB_CU_UP_Capacity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< GNB-CU-UP-CellGroupRelatedConfiguration >-----#
    GNB_CU_UP_CellGroupRelatedConfiguration = SEQ_OF(name='GNB-CU-UP-CellGroupRelatedConfiguration', mode=MODE_TYPE)
    _GNB_CU_UP_CellGroupRelatedConfiguration__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-CellGroupRelatedConfiguration-Item')))
    GNB_CU_UP_CellGroupRelatedConfiguration._cont = _GNB_CU_UP_CellGroupRelatedConfiguration__item_
    GNB_CU_UP_CellGroupRelatedConfiguration._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< GNB-CU-UP-CellGroupRelatedConfiguration-Item >-----#
    GNB_CU_UP_CellGroupRelatedConfiguration_Item = SEQ(name='GNB-CU-UP-CellGroupRelatedConfiguration-Item', mode=MODE_TYPE)
    _GNB_CU_UP_CellGroupRelatedConfiguration_Item_cell_Group_ID = INT(name='cell-Group-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cell-Group-ID')))
    _GNB_CU_UP_CellGroupRelatedConfiguration_Item_uP_TNL_Information = CHOICE(name='uP-TNL-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _GNB_CU_UP_CellGroupRelatedConfiguration_Item_uL_Configuration = ENUM(name='uL-Configuration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UL-Configuration')), opt=True)
    _GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__id._const_tab = ____GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__id_tab
    ___GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__id._const_tab_at = None
    ___GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__criticality._const_tab = ____GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__criticality_tab
    ___GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__extensionValue._const_tab = ____GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__extensionValue_tab
    ___GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__id),
        ('criticality', ___GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__extensionValue),
        ])
    __GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item_._ext = None
    _GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions._cont = __GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item_
    _GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_CU_UP_CellGroupRelatedConfiguration_Item._cont = ASN1Dict([
        ('cell-Group-ID', _GNB_CU_UP_CellGroupRelatedConfiguration_Item_cell_Group_ID),
        ('uP-TNL-Information', _GNB_CU_UP_CellGroupRelatedConfiguration_Item_uP_TNL_Information),
        ('uL-Configuration', _GNB_CU_UP_CellGroupRelatedConfiguration_Item_uL_Configuration),
        ('iE-Extensions', _GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions),
        ])
    GNB_CU_UP_CellGroupRelatedConfiguration_Item._ext = None
    
    #-----< GNB-CU-UP-CellGroupRelatedConfiguration-Item-ExtIEs >-----#
    GNB_CU_UP_CellGroupRelatedConfiguration_Item_ExtIEs = CLASS(name='GNB-CU-UP-CellGroupRelatedConfiguration-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    GNB_CU_UP_CellGroupRelatedConfiguration_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-UP-ID >-----#
    GNB_CU_UP_ID = INT(name='GNB-CU-UP-ID', mode=MODE_TYPE)
    GNB_CU_UP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=68719476735)], ev=None, er=[])
    
    #-----< GNB-CU-UP-MBS-Support-Info >-----#
    GNB_CU_UP_MBS_Support_Info = SEQ(name='GNB-CU-UP-MBS-Support-Info', mode=MODE_TYPE)
    _GNB_CU_UP_MBS_Support_Info_mbs_Support_Info_ToAdd_List = SEQ_OF(name='mbs-Support-Info-ToAdd-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBS-Support-Info-ToAdd-List')), opt=True)
    _GNB_CU_UP_MBS_Support_Info_mbs_Support_Info_ToRemove_List = SEQ_OF(name='mbs-Support-Info-ToRemove-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBS-Support-Info-ToRemove-List')), opt=True)
    _GNB_CU_UP_MBS_Support_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_CU_UP_MBS_Support_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__id._const_tab = ____GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__id_tab
    ___GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__id._const_tab_at = None
    ___GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__criticality._const_tab = ____GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__criticality_tab
    ___GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__extensionValue._const_tab = ____GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__extensionValue_tab
    ___GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GNB_CU_UP_MBS_Support_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__id),
        ('criticality', ___GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__extensionValue),
        ])
    __GNB_CU_UP_MBS_Support_Info_iE_Extensions__item_._ext = None
    _GNB_CU_UP_MBS_Support_Info_iE_Extensions._cont = __GNB_CU_UP_MBS_Support_Info_iE_Extensions__item_
    _GNB_CU_UP_MBS_Support_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_CU_UP_MBS_Support_Info._cont = ASN1Dict([
        ('mbs-Support-Info-ToAdd-List', _GNB_CU_UP_MBS_Support_Info_mbs_Support_Info_ToAdd_List),
        ('mbs-Support-Info-ToRemove-List', _GNB_CU_UP_MBS_Support_Info_mbs_Support_Info_ToRemove_List),
        ('iE-Extensions', _GNB_CU_UP_MBS_Support_Info_iE_Extensions),
        ])
    GNB_CU_UP_MBS_Support_Info._ext = []
    
    #-----< GNB-CU-UP-MBS-Support-Info-ExtIEs >-----#
    GNB_CU_UP_MBS_Support_Info_ExtIEs = CLASS(name='GNB-CU-UP-MBS-Support-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    GNB_CU_UP_MBS_Support_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-UP-Name >-----#
    GNB_CU_UP_Name = STR_PRINT(name='GNB-CU-UP-Name', mode=MODE_TYPE)
    GNB_CU_UP_Name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< Extended-GNB-CU-UP-Name >-----#
    Extended_GNB_CU_UP_Name = SEQ(name='Extended-GNB-CU-UP-Name', mode=MODE_TYPE)
    _Extended_GNB_CU_UP_Name_gNB_CU_UP_NameVisibleString = STR_VIS(name='gNB-CU-UP-NameVisibleString', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-NameVisibleString')), opt=True)
    _Extended_GNB_CU_UP_Name_gNB_CU_UP_NameUTF8String = STR_UTF8(name='gNB-CU-UP-NameUTF8String', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-NameUTF8String')), opt=True)
    _Extended_GNB_CU_UP_Name_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Extended_GNB_CU_UP_Name_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___Extended_GNB_CU_UP_Name_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Extended_GNB_CU_UP_Name_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Extended_GNB_CU_UP_Name_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_GNB_CU_UP_Name_iE_Extensions__item__id._const_tab = ____Extended_GNB_CU_UP_Name_iE_Extensions__item__id_tab
    ___Extended_GNB_CU_UP_Name_iE_Extensions__item__id._const_tab_at = None
    ___Extended_GNB_CU_UP_Name_iE_Extensions__item__id._const_tab_id = 'id'
    ___Extended_GNB_CU_UP_Name_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Extended_GNB_CU_UP_Name_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Extended_GNB_CU_UP_Name_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_GNB_CU_UP_Name_iE_Extensions__item__criticality._const_tab = ____Extended_GNB_CU_UP_Name_iE_Extensions__item__criticality_tab
    ___Extended_GNB_CU_UP_Name_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Extended_GNB_CU_UP_Name_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Extended_GNB_CU_UP_Name_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Extended_GNB_CU_UP_Name_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Extended_GNB_CU_UP_Name_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_GNB_CU_UP_Name_iE_Extensions__item__extensionValue._const_tab = ____Extended_GNB_CU_UP_Name_iE_Extensions__item__extensionValue_tab
    ___Extended_GNB_CU_UP_Name_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Extended_GNB_CU_UP_Name_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Extended_GNB_CU_UP_Name_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Extended_GNB_CU_UP_Name_iE_Extensions__item__id),
        ('criticality', ___Extended_GNB_CU_UP_Name_iE_Extensions__item__criticality),
        ('extensionValue', ___Extended_GNB_CU_UP_Name_iE_Extensions__item__extensionValue),
        ])
    __Extended_GNB_CU_UP_Name_iE_Extensions__item_._ext = None
    _Extended_GNB_CU_UP_Name_iE_Extensions._cont = __Extended_GNB_CU_UP_Name_iE_Extensions__item_
    _Extended_GNB_CU_UP_Name_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Extended_GNB_CU_UP_Name._cont = ASN1Dict([
        ('gNB-CU-UP-NameVisibleString', _Extended_GNB_CU_UP_Name_gNB_CU_UP_NameVisibleString),
        ('gNB-CU-UP-NameUTF8String', _Extended_GNB_CU_UP_Name_gNB_CU_UP_NameUTF8String),
        ('iE-Extensions', _Extended_GNB_CU_UP_Name_iE_Extensions),
        ])
    Extended_GNB_CU_UP_Name._ext = []
    
    #-----< Extended-GNB-CU-UP-Name-ExtIEs >-----#
    Extended_GNB_CU_UP_Name_ExtIEs = CLASS(name='Extended-GNB-CU-UP-Name-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    Extended_GNB_CU_UP_Name_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-UP-MBS-E1AP-ID >-----#
    GNB_CU_UP_MBS_E1AP_ID = INT(name='GNB-CU-UP-MBS-E1AP-ID', mode=MODE_TYPE)
    GNB_CU_UP_MBS_E1AP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< GNB-CU-UP-NameVisibleString >-----#
    GNB_CU_UP_NameVisibleString = STR_VIS(name='GNB-CU-UP-NameVisibleString', mode=MODE_TYPE)
    GNB_CU_UP_NameVisibleString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< GNB-CU-UP-NameUTF8String >-----#
    GNB_CU_UP_NameUTF8String = STR_UTF8(name='GNB-CU-UP-NameUTF8String', mode=MODE_TYPE)
    GNB_CU_UP_NameUTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< GNB-CU-UP-UE-E1AP-ID >-----#
    GNB_CU_UP_UE_E1AP_ID = INT(name='GNB-CU-UP-UE-E1AP-ID', mode=MODE_TYPE)
    GNB_CU_UP_UE_E1AP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< GNB-CU-CP-TNLA-Setup-Item >-----#
    GNB_CU_CP_TNLA_Setup_Item = SEQ(name='GNB-CU-CP-TNLA-Setup-Item', mode=MODE_TYPE)
    _GNB_CU_CP_TNLA_Setup_Item_tNLAssociationTransportLayerAddress = CHOICE(name='tNLAssociationTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'CP-TNL-Information')))
    _GNB_CU_CP_TNLA_Setup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__id._const_tab = ____GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__id_tab
    ___GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__id._const_tab_at = None
    ___GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__criticality._const_tab = ____GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__criticality_tab
    ___GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__extensionValue._const_tab = ____GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__extensionValue_tab
    ___GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__id),
        ('criticality', ___GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__extensionValue),
        ])
    __GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item_._ext = None
    _GNB_CU_CP_TNLA_Setup_Item_iE_Extensions._cont = __GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item_
    _GNB_CU_CP_TNLA_Setup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_CU_CP_TNLA_Setup_Item._cont = ASN1Dict([
        ('tNLAssociationTransportLayerAddress', _GNB_CU_CP_TNLA_Setup_Item_tNLAssociationTransportLayerAddress),
        ('iE-Extensions', _GNB_CU_CP_TNLA_Setup_Item_iE_Extensions),
        ])
    GNB_CU_CP_TNLA_Setup_Item._ext = []
    
    #-----< GNB-CU-CP-TNLA-Setup-Item-ExtIEs >-----#
    GNB_CU_CP_TNLA_Setup_Item_ExtIEs = CLASS(name='GNB-CU-CP-TNLA-Setup-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    GNB_CU_CP_TNLA_Setup_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-CP-TNLA-Failed-To-Setup-Item >-----#
    GNB_CU_CP_TNLA_Failed_To_Setup_Item = SEQ(name='GNB-CU-CP-TNLA-Failed-To-Setup-Item', mode=MODE_TYPE)
    _GNB_CU_CP_TNLA_Failed_To_Setup_Item_tNLAssociationTransportLayerAddress = CHOICE(name='tNLAssociationTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'CP-TNL-Information')))
    _GNB_CU_CP_TNLA_Failed_To_Setup_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__id._const_tab = ____GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__id_tab
    ___GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__id._const_tab_at = None
    ___GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__criticality._const_tab = ____GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__criticality_tab
    ___GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__extensionValue._const_tab = ____GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__extensionValue_tab
    ___GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__id),
        ('criticality', ___GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__extensionValue),
        ])
    __GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item_._ext = None
    _GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions._cont = __GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item_
    _GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_CU_CP_TNLA_Failed_To_Setup_Item._cont = ASN1Dict([
        ('tNLAssociationTransportLayerAddress', _GNB_CU_CP_TNLA_Failed_To_Setup_Item_tNLAssociationTransportLayerAddress),
        ('cause', _GNB_CU_CP_TNLA_Failed_To_Setup_Item_cause),
        ('iE-Extensions', _GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions),
        ])
    GNB_CU_CP_TNLA_Failed_To_Setup_Item._ext = None
    
    #-----< GNB-CU-CP-TNLA-Failed-To-Setup-Item-ExtIEs >-----#
    GNB_CU_CP_TNLA_Failed_To_Setup_Item_ExtIEs = CLASS(name='GNB-CU-CP-TNLA-Failed-To-Setup-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    GNB_CU_CP_TNLA_Failed_To_Setup_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-CP-TNLA-To-Add-Item >-----#
    GNB_CU_CP_TNLA_To_Add_Item = SEQ(name='GNB-CU-CP-TNLA-To-Add-Item', mode=MODE_TYPE)
    _GNB_CU_CP_TNLA_To_Add_Item_tNLAssociationTransportLayerAddress = CHOICE(name='tNLAssociationTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'CP-TNL-Information')))
    _GNB_CU_CP_TNLA_To_Add_Item_tNLAssociationUsage = ENUM(name='tNLAssociationUsage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'TNLAssociationUsage')))
    _GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__id._const_tab = ____GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__id_tab
    ___GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__id._const_tab_at = None
    ___GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__criticality._const_tab = ____GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__criticality_tab
    ___GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__extensionValue._const_tab = ____GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__extensionValue_tab
    ___GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__id),
        ('criticality', ___GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__extensionValue),
        ])
    __GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item_._ext = None
    _GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions._cont = __GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item_
    _GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_CU_CP_TNLA_To_Add_Item._cont = ASN1Dict([
        ('tNLAssociationTransportLayerAddress', _GNB_CU_CP_TNLA_To_Add_Item_tNLAssociationTransportLayerAddress),
        ('tNLAssociationUsage', _GNB_CU_CP_TNLA_To_Add_Item_tNLAssociationUsage),
        ('iE-Extensions', _GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions),
        ])
    GNB_CU_CP_TNLA_To_Add_Item._ext = None
    
    #-----< GNB-CU-CP-TNLA-To-Add-Item-ExtIEs >-----#
    GNB_CU_CP_TNLA_To_Add_Item_ExtIEs = CLASS(name='GNB-CU-CP-TNLA-To-Add-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    GNB_CU_CP_TNLA_To_Add_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-CP-TNLA-To-Remove-Item >-----#
    GNB_CU_CP_TNLA_To_Remove_Item = SEQ(name='GNB-CU-CP-TNLA-To-Remove-Item', mode=MODE_TYPE)
    _GNB_CU_CP_TNLA_To_Remove_Item_tNLAssociationTransportLayerAddress = CHOICE(name='tNLAssociationTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'CP-TNL-Information')))
    _GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CP-TNL-Information')))
    ____GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 75), ('criticality', 'reject'), ('Extension', _____GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__id._const_tab = ____GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__id_tab
    ___GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__id._const_tab_at = None
    ___GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__criticality._const_tab = ____GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__id_tab
    ___GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab = ____GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__id_tab
    ___GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__id),
        ('criticality', ___GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__extensionValue),
        ])
    __GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item_._ext = None
    _GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions._cont = __GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item_
    _GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_CU_CP_TNLA_To_Remove_Item._cont = ASN1Dict([
        ('tNLAssociationTransportLayerAddress', _GNB_CU_CP_TNLA_To_Remove_Item_tNLAssociationTransportLayerAddress),
        ('iE-Extensions', _GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions),
        ])
    GNB_CU_CP_TNLA_To_Remove_Item._ext = None
    
    #-----< GNB-CU-CP-TNLA-To-Remove-Item-ExtIEs >-----#
    GNB_CU_CP_TNLA_To_Remove_Item_ExtIEs = CLASS(name='GNB-CU-CP-TNLA-To-Remove-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _GNB_CU_CP_TNLA_To_Remove_Item_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CP-TNL-Information')))
    GNB_CU_CP_TNLA_To_Remove_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 75), ('criticality', 'reject'), ('Extension', _GNB_CU_CP_TNLA_To_Remove_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-CP-TNLA-To-Update-Item >-----#
    GNB_CU_CP_TNLA_To_Update_Item = SEQ(name='GNB-CU-CP-TNLA-To-Update-Item', mode=MODE_TYPE)
    _GNB_CU_CP_TNLA_To_Update_Item_tNLAssociationTransportLayerAddress = CHOICE(name='tNLAssociationTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'CP-TNL-Information')))
    _GNB_CU_CP_TNLA_To_Update_Item_tNLAssociationUsage = ENUM(name='tNLAssociationUsage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'TNLAssociationUsage')), opt=True)
    _GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__id._const_tab = ____GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__id_tab
    ___GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__id._const_tab_at = None
    ___GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__criticality._const_tab = ____GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__criticality_tab
    ___GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__extensionValue._const_tab = ____GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__extensionValue_tab
    ___GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__id),
        ('criticality', ___GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__extensionValue),
        ])
    __GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item_._ext = None
    _GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions._cont = __GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item_
    _GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_CU_CP_TNLA_To_Update_Item._cont = ASN1Dict([
        ('tNLAssociationTransportLayerAddress', _GNB_CU_CP_TNLA_To_Update_Item_tNLAssociationTransportLayerAddress),
        ('tNLAssociationUsage', _GNB_CU_CP_TNLA_To_Update_Item_tNLAssociationUsage),
        ('iE-Extensions', _GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions),
        ])
    GNB_CU_CP_TNLA_To_Update_Item._ext = None
    
    #-----< GNB-CU-CP-TNLA-To-Update-Item-ExtIEs >-----#
    GNB_CU_CP_TNLA_To_Update_Item_ExtIEs = CLASS(name='GNB-CU-CP-TNLA-To-Update-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    GNB_CU_CP_TNLA_To_Update_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-UP-TNLA-To-Remove-Item >-----#
    GNB_CU_UP_TNLA_To_Remove_Item = SEQ(name='GNB-CU-UP-TNLA-To-Remove-Item', mode=MODE_TYPE)
    _GNB_CU_UP_TNLA_To_Remove_Item_tNLAssociationTransportLayerAddress = CHOICE(name='tNLAssociationTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'CP-TNL-Information')))
    _GNB_CU_UP_TNLA_To_Remove_Item_tNLAssociationTransportLayerAddressgNBCUCP = CHOICE(name='tNLAssociationTransportLayerAddressgNBCUCP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'CP-TNL-Information')), opt=True)
    _GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__id._const_tab = ____GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__id_tab
    ___GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__id._const_tab_at = None
    ___GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__criticality._const_tab = ____GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__criticality_tab
    ___GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab = ____GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__extensionValue_tab
    ___GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__id),
        ('criticality', ___GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__extensionValue),
        ])
    __GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item_._ext = None
    _GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions._cont = __GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item_
    _GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_CU_UP_TNLA_To_Remove_Item._cont = ASN1Dict([
        ('tNLAssociationTransportLayerAddress', _GNB_CU_UP_TNLA_To_Remove_Item_tNLAssociationTransportLayerAddress),
        ('tNLAssociationTransportLayerAddressgNBCUCP', _GNB_CU_UP_TNLA_To_Remove_Item_tNLAssociationTransportLayerAddressgNBCUCP),
        ('iE-Extensions', _GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions),
        ])
    GNB_CU_UP_TNLA_To_Remove_Item._ext = None
    
    #-----< GNB-CU-UP-TNLA-To-Remove-Item-ExtIEs >-----#
    GNB_CU_UP_TNLA_To_Remove_Item_ExtIEs = CLASS(name='GNB-CU-UP-TNLA-To-Remove-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    GNB_CU_UP_TNLA_To_Remove_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GBR-QosInformation >-----#
    GBR_QosInformation = SEQ(name='GBR-QosInformation', mode=MODE_TYPE)
    _GBR_QosInformation_e_RAB_MaximumBitrateDL = INT(name='e-RAB-MaximumBitrateDL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BitRate')))
    _GBR_QosInformation_e_RAB_MaximumBitrateUL = INT(name='e-RAB-MaximumBitrateUL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BitRate')))
    _GBR_QosInformation_e_RAB_GuaranteedBitrateDL = INT(name='e-RAB-GuaranteedBitrateDL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BitRate')))
    _GBR_QosInformation_e_RAB_GuaranteedBitrateUL = INT(name='e-RAB-GuaranteedBitrateUL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BitRate')))
    _GBR_QosInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GBR_QosInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___GBR_QosInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GBR_QosInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GBR_QosInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab = ____GBR_QosInformation_iE_Extensions__item__id_tab
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab_at = None
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___GBR_QosInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GBR_QosInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GBR_QosInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab = ____GBR_QosInformation_iE_Extensions__item__criticality_tab
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GBR_QosInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GBR_QosInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GBR_QosInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab = ____GBR_QosInformation_iE_Extensions__item__extensionValue_tab
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GBR_QosInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GBR_QosInformation_iE_Extensions__item__id),
        ('criticality', ___GBR_QosInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___GBR_QosInformation_iE_Extensions__item__extensionValue),
        ])
    __GBR_QosInformation_iE_Extensions__item_._ext = None
    _GBR_QosInformation_iE_Extensions._cont = __GBR_QosInformation_iE_Extensions__item_
    _GBR_QosInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GBR_QosInformation._cont = ASN1Dict([
        ('e-RAB-MaximumBitrateDL', _GBR_QosInformation_e_RAB_MaximumBitrateDL),
        ('e-RAB-MaximumBitrateUL', _GBR_QosInformation_e_RAB_MaximumBitrateUL),
        ('e-RAB-GuaranteedBitrateDL', _GBR_QosInformation_e_RAB_GuaranteedBitrateDL),
        ('e-RAB-GuaranteedBitrateUL', _GBR_QosInformation_e_RAB_GuaranteedBitrateUL),
        ('iE-Extensions', _GBR_QosInformation_iE_Extensions),
        ])
    GBR_QosInformation._ext = []
    
    #-----< GBR-QosInformation-ExtIEs >-----#
    GBR_QosInformation_ExtIEs = CLASS(name='GBR-QosInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    GBR_QosInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GBR-QoSFlowInformation >-----#
    GBR_QoSFlowInformation = SEQ(name='GBR-QoSFlowInformation', mode=MODE_TYPE)
    _GBR_QoSFlowInformation_maxFlowBitRateDownlink = INT(name='maxFlowBitRateDownlink', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BitRate')))
    _GBR_QoSFlowInformation_maxFlowBitRateUplink = INT(name='maxFlowBitRateUplink', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BitRate')))
    _GBR_QoSFlowInformation_guaranteedFlowBitRateDownlink = INT(name='guaranteedFlowBitRateDownlink', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BitRate')))
    _GBR_QoSFlowInformation_guaranteedFlowBitRateUplink = INT(name='guaranteedFlowBitRateUplink', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BitRate')))
    _GBR_QoSFlowInformation_maxPacketLossRateDownlink = INT(name='maxPacketLossRateDownlink', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MaxPacketLossRate')), opt=True)
    _GBR_QoSFlowInformation_maxPacketLossRateUplink = INT(name='maxPacketLossRateUplink', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MaxPacketLossRate')), opt=True)
    _GBR_QoSFlowInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GBR_QoSFlowInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___GBR_QoSFlowInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GBR_QoSFlowInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____GBR_QoSFlowInformation_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'AlternativeQoSParaSetList')))
    ____GBR_QoSFlowInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 124), ('criticality', 'ignore'), ('Extension', _____GBR_QoSFlowInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GBR_QoSFlowInformation_iE_Extensions__item__id._const_tab = ____GBR_QoSFlowInformation_iE_Extensions__item__id_tab
    ___GBR_QoSFlowInformation_iE_Extensions__item__id._const_tab_at = None
    ___GBR_QoSFlowInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___GBR_QoSFlowInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GBR_QoSFlowInformation_iE_Extensions__item__criticality._const_tab = ____GBR_QoSFlowInformation_iE_Extensions__item__id_tab
    ___GBR_QoSFlowInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GBR_QoSFlowInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GBR_QoSFlowInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GBR_QoSFlowInformation_iE_Extensions__item__extensionValue._const_tab = ____GBR_QoSFlowInformation_iE_Extensions__item__id_tab
    ___GBR_QoSFlowInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GBR_QoSFlowInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GBR_QoSFlowInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GBR_QoSFlowInformation_iE_Extensions__item__id),
        ('criticality', ___GBR_QoSFlowInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___GBR_QoSFlowInformation_iE_Extensions__item__extensionValue),
        ])
    __GBR_QoSFlowInformation_iE_Extensions__item_._ext = None
    _GBR_QoSFlowInformation_iE_Extensions._cont = __GBR_QoSFlowInformation_iE_Extensions__item_
    _GBR_QoSFlowInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GBR_QoSFlowInformation._cont = ASN1Dict([
        ('maxFlowBitRateDownlink', _GBR_QoSFlowInformation_maxFlowBitRateDownlink),
        ('maxFlowBitRateUplink', _GBR_QoSFlowInformation_maxFlowBitRateUplink),
        ('guaranteedFlowBitRateDownlink', _GBR_QoSFlowInformation_guaranteedFlowBitRateDownlink),
        ('guaranteedFlowBitRateUplink', _GBR_QoSFlowInformation_guaranteedFlowBitRateUplink),
        ('maxPacketLossRateDownlink', _GBR_QoSFlowInformation_maxPacketLossRateDownlink),
        ('maxPacketLossRateUplink', _GBR_QoSFlowInformation_maxPacketLossRateUplink),
        ('iE-Extensions', _GBR_QoSFlowInformation_iE_Extensions),
        ])
    GBR_QoSFlowInformation._ext = []
    
    #-----< GBR-QosFlowInformation-ExtIEs >-----#
    GBR_QosFlowInformation_ExtIEs = CLASS(name='GBR-QosFlowInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _GBR_QosFlowInformation_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'AlternativeQoSParaSetList')))
    GBR_QosFlowInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 124), ('criticality', 'ignore'), ('Extension', _GBR_QosFlowInformation_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GTP-TEID >-----#
    GTP_TEID = OCT_STR(name='GTP-TEID', mode=MODE_TYPE)
    GTP_TEID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< GTPTLAs >-----#
    GTPTLAs = SEQ_OF(name='GTPTLAs', mode=MODE_TYPE)
    _GTPTLAs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GTPTLA-Item')))
    GTPTLAs._cont = _GTPTLAs__item_
    GTPTLAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< GTPTLA-Item >-----#
    GTPTLA_Item = SEQ(name='GTPTLA-Item', mode=MODE_TYPE)
    _GTPTLA_Item_gTPTransportLayerAddresses = BIT_STR(name='gTPTransportLayerAddresses', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    _GTPTLA_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GTPTLA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___GTPTLA_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GTPTLA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GTPTLA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTLA_Item_iE_Extensions__item__id._const_tab = ____GTPTLA_Item_iE_Extensions__item__id_tab
    ___GTPTLA_Item_iE_Extensions__item__id._const_tab_at = None
    ___GTPTLA_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___GTPTLA_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GTPTLA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GTPTLA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTLA_Item_iE_Extensions__item__criticality._const_tab = ____GTPTLA_Item_iE_Extensions__item__criticality_tab
    ___GTPTLA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GTPTLA_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GTPTLA_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GTPTLA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GTPTLA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTLA_Item_iE_Extensions__item__extensionValue._const_tab = ____GTPTLA_Item_iE_Extensions__item__extensionValue_tab
    ___GTPTLA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GTPTLA_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GTPTLA_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GTPTLA_Item_iE_Extensions__item__id),
        ('criticality', ___GTPTLA_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___GTPTLA_Item_iE_Extensions__item__extensionValue),
        ])
    __GTPTLA_Item_iE_Extensions__item_._ext = None
    _GTPTLA_Item_iE_Extensions._cont = __GTPTLA_Item_iE_Extensions__item_
    _GTPTLA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GTPTLA_Item._cont = ASN1Dict([
        ('gTPTransportLayerAddresses', _GTPTLA_Item_gTPTransportLayerAddresses),
        ('iE-Extensions', _GTPTLA_Item_iE_Extensions),
        ])
    GTPTLA_Item._ext = []
    
    #-----< GTPTLA-Item-ExtIEs >-----#
    GTPTLA_Item_ExtIEs = CLASS(name='GTPTLA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    GTPTLA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GTPTunnel >-----#
    GTPTunnel = SEQ(name='GTPTunnel', mode=MODE_TYPE)
    _GTPTunnel_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    _GTPTunnel_gTP_TEID = OCT_STR(name='gTP-TEID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'GTP-TEID')))
    _GTPTunnel_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GTPTunnel_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___GTPTunnel_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GTPTunnel_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GTPTunnel_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTunnel_iE_Extensions__item__id._const_tab = ____GTPTunnel_iE_Extensions__item__id_tab
    ___GTPTunnel_iE_Extensions__item__id._const_tab_at = None
    ___GTPTunnel_iE_Extensions__item__id._const_tab_id = 'id'
    ___GTPTunnel_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GTPTunnel_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GTPTunnel_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTunnel_iE_Extensions__item__criticality._const_tab = ____GTPTunnel_iE_Extensions__item__criticality_tab
    ___GTPTunnel_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GTPTunnel_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GTPTunnel_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GTPTunnel_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____GTPTunnel_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTunnel_iE_Extensions__item__extensionValue._const_tab = ____GTPTunnel_iE_Extensions__item__extensionValue_tab
    ___GTPTunnel_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GTPTunnel_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GTPTunnel_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GTPTunnel_iE_Extensions__item__id),
        ('criticality', ___GTPTunnel_iE_Extensions__item__criticality),
        ('extensionValue', ___GTPTunnel_iE_Extensions__item__extensionValue),
        ])
    __GTPTunnel_iE_Extensions__item_._ext = None
    _GTPTunnel_iE_Extensions._cont = __GTPTunnel_iE_Extensions__item_
    _GTPTunnel_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GTPTunnel._cont = ASN1Dict([
        ('transportLayerAddress', _GTPTunnel_transportLayerAddress),
        ('gTP-TEID', _GTPTunnel_gTP_TEID),
        ('iE-Extensions', _GTPTunnel_iE_Extensions),
        ])
    GTPTunnel._ext = []
    
    #-----< GTPTunnel-ExtIEs >-----#
    GTPTunnel_ExtIEs = CLASS(name='GTPTunnel-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    GTPTunnel_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-UP-OverloadInformation >-----#
    GNB_CU_UP_OverloadInformation = ENUM(name='GNB-CU-UP-OverloadInformation', mode=MODE_TYPE)
    GNB_CU_UP_OverloadInformation._cont = ASN1Dict([('overloaded', 0), ('not-overloaded', 1)])
    GNB_CU_UP_OverloadInformation._ext = None
    
    #-----< GNB-DU-ID >-----#
    GNB_DU_ID = INT(name='GNB-DU-ID', mode=MODE_TYPE)
    GNB_DU_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=68719476735)], ev=None, er=[])
    
    #-----< HFN >-----#
    HFN = INT(name='HFN', mode=MODE_TYPE)
    HFN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< HW-CapacityIndicator >-----#
    HW_CapacityIndicator = SEQ(name='HW-CapacityIndicator', mode=MODE_TYPE)
    _HW_CapacityIndicator_offeredThroughput = INT(name='offeredThroughput', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HW_CapacityIndicator_offeredThroughput._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16777216)], ev=[], er=[])
    _HW_CapacityIndicator_availableThroughput = INT(name='availableThroughput', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HW_CapacityIndicator_availableThroughput._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=[], er=[])
    _HW_CapacityIndicator_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HW_CapacityIndicator_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___HW_CapacityIndicator_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____HW_CapacityIndicator_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____HW_CapacityIndicator_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HW_CapacityIndicator_iE_Extensions__item__id._const_tab = ____HW_CapacityIndicator_iE_Extensions__item__id_tab
    ___HW_CapacityIndicator_iE_Extensions__item__id._const_tab_at = None
    ___HW_CapacityIndicator_iE_Extensions__item__id._const_tab_id = 'id'
    ___HW_CapacityIndicator_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HW_CapacityIndicator_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____HW_CapacityIndicator_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HW_CapacityIndicator_iE_Extensions__item__criticality._const_tab = ____HW_CapacityIndicator_iE_Extensions__item__criticality_tab
    ___HW_CapacityIndicator_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HW_CapacityIndicator_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HW_CapacityIndicator_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HW_CapacityIndicator_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____HW_CapacityIndicator_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HW_CapacityIndicator_iE_Extensions__item__extensionValue._const_tab = ____HW_CapacityIndicator_iE_Extensions__item__extensionValue_tab
    ___HW_CapacityIndicator_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HW_CapacityIndicator_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HW_CapacityIndicator_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HW_CapacityIndicator_iE_Extensions__item__id),
        ('criticality', ___HW_CapacityIndicator_iE_Extensions__item__criticality),
        ('extensionValue', ___HW_CapacityIndicator_iE_Extensions__item__extensionValue),
        ])
    __HW_CapacityIndicator_iE_Extensions__item_._ext = None
    _HW_CapacityIndicator_iE_Extensions._cont = __HW_CapacityIndicator_iE_Extensions__item_
    _HW_CapacityIndicator_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HW_CapacityIndicator._cont = ASN1Dict([
        ('offeredThroughput', _HW_CapacityIndicator_offeredThroughput),
        ('availableThroughput', _HW_CapacityIndicator_availableThroughput),
        ('iE-Extensions', _HW_CapacityIndicator_iE_Extensions),
        ])
    HW_CapacityIndicator._ext = []
    
    #-----< HW-CapacityIndicator-ExtIEs >-----#
    HW_CapacityIndicator_ExtIEs = CLASS(name='HW-CapacityIndicator-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    HW_CapacityIndicator_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IgnoreMappingRuleIndication >-----#
    IgnoreMappingRuleIndication = ENUM(name='IgnoreMappingRuleIndication', mode=MODE_TYPE)
    IgnoreMappingRuleIndication._cont = ASN1Dict([('true', 0)])
    IgnoreMappingRuleIndication._ext = []
    
    #-----< IntegrityProtectionIndication >-----#
    IntegrityProtectionIndication = ENUM(name='IntegrityProtectionIndication', mode=MODE_TYPE)
    IntegrityProtectionIndication._cont = ASN1Dict([('required', 0), ('preferred', 1), ('not-needed', 2)])
    IntegrityProtectionIndication._ext = []
    
    #-----< IntegrityProtectionAlgorithm >-----#
    IntegrityProtectionAlgorithm = ENUM(name='IntegrityProtectionAlgorithm', mode=MODE_TYPE)
    IntegrityProtectionAlgorithm._cont = ASN1Dict([('nIA0', 0), ('i-128-NIA1', 1), ('i-128-NIA2', 2), ('i-128-NIA3', 3)])
    IntegrityProtectionAlgorithm._ext = []
    
    #-----< IntegrityProtectionKey >-----#
    IntegrityProtectionKey = OCT_STR(name='IntegrityProtectionKey', mode=MODE_TYPE)
    
    #-----< IntegrityProtectionResult >-----#
    IntegrityProtectionResult = ENUM(name='IntegrityProtectionResult', mode=MODE_TYPE)
    IntegrityProtectionResult._cont = ASN1Dict([('performed', 0), ('not-performed', 1)])
    IntegrityProtectionResult._ext = []
    
    #-----< Inactivity-Timer >-----#
    Inactivity_Timer = INT(name='Inactivity-Timer', mode=MODE_TYPE)
    Inactivity_Timer._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7200)], ev=[], er=[])
    
    #-----< InterfacesToTrace >-----#
    InterfacesToTrace = BIT_STR(name='InterfacesToTrace', mode=MODE_TYPE)
    InterfacesToTrace._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< ImmediateMDT >-----#
    ImmediateMDT = SEQ(name='ImmediateMDT', mode=MODE_TYPE)
    _ImmediateMDT_measurementsToActivate = BIT_STR(name='measurementsToActivate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MeasurementsToActivate')))
    _ImmediateMDT_measurementFour = SEQ(name='measurementFour', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'M4Configuration')), opt=True)
    _ImmediateMDT_measurementSix = SEQ(name='measurementSix', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'M6Configuration')), opt=True)
    _ImmediateMDT_measurementSeven = SEQ(name='measurementSeven', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'M7Configuration')), opt=True)
    _ImmediateMDT_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ImmediateMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___ImmediateMDT_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ImmediateMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____ImmediateMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ImmediateMDT_iE_Extensions__item__id._const_tab = ____ImmediateMDT_iE_Extensions__item__id_tab
    ___ImmediateMDT_iE_Extensions__item__id._const_tab_at = None
    ___ImmediateMDT_iE_Extensions__item__id._const_tab_id = 'id'
    ___ImmediateMDT_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ImmediateMDT_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____ImmediateMDT_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ImmediateMDT_iE_Extensions__item__criticality._const_tab = ____ImmediateMDT_iE_Extensions__item__criticality_tab
    ___ImmediateMDT_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ImmediateMDT_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ImmediateMDT_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ImmediateMDT_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____ImmediateMDT_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ImmediateMDT_iE_Extensions__item__extensionValue._const_tab = ____ImmediateMDT_iE_Extensions__item__extensionValue_tab
    ___ImmediateMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ImmediateMDT_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ImmediateMDT_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ImmediateMDT_iE_Extensions__item__id),
        ('criticality', ___ImmediateMDT_iE_Extensions__item__criticality),
        ('extensionValue', ___ImmediateMDT_iE_Extensions__item__extensionValue),
        ])
    __ImmediateMDT_iE_Extensions__item_._ext = None
    _ImmediateMDT_iE_Extensions._cont = __ImmediateMDT_iE_Extensions__item_
    _ImmediateMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ImmediateMDT._cont = ASN1Dict([
        ('measurementsToActivate', _ImmediateMDT_measurementsToActivate),
        ('measurementFour', _ImmediateMDT_measurementFour),
        ('measurementSix', _ImmediateMDT_measurementSix),
        ('measurementSeven', _ImmediateMDT_measurementSeven),
        ('iE-Extensions', _ImmediateMDT_iE_Extensions),
        ])
    ImmediateMDT._ext = []
    
    #-----< ImmediateMDT-ExtIEs >-----#
    ImmediateMDT_ExtIEs = CLASS(name='ImmediateMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ImmediateMDT_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IAB-Donor-CU-UPPSKInfo-Item >-----#
    IAB_Donor_CU_UPPSKInfo_Item = SEQ(name='IAB-Donor-CU-UPPSKInfo-Item', mode=MODE_TYPE)
    _IAB_Donor_CU_UPPSKInfo_Item_iAB_donor_CU_UPPSK = OCT_STR(name='iAB-donor-CU-UPPSK', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'IAB-donor-CU-UPPSK')))
    _IAB_Donor_CU_UPPSKInfo_Item_iAB_donor_CU_UPIPAddress = BIT_STR(name='iAB-donor-CU-UPIPAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    _IAB_Donor_CU_UPPSKInfo_Item_iAB_DUIPAddress = BIT_STR(name='iAB-DUIPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    _IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__id._const_tab = ____IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__id_tab
    ___IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__id._const_tab_at = None
    ___IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__criticality._const_tab = ____IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__criticality_tab
    ___IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__extensionValue._const_tab = ____IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__extensionValue_tab
    ___IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__id),
        ('criticality', ___IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__extensionValue),
        ])
    __IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item_._ext = None
    _IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions._cont = __IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item_
    _IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IAB_Donor_CU_UPPSKInfo_Item._cont = ASN1Dict([
        ('iAB-donor-CU-UPPSK', _IAB_Donor_CU_UPPSKInfo_Item_iAB_donor_CU_UPPSK),
        ('iAB-donor-CU-UPIPAddress', _IAB_Donor_CU_UPPSKInfo_Item_iAB_donor_CU_UPIPAddress),
        ('iAB-DUIPAddress', _IAB_Donor_CU_UPPSKInfo_Item_iAB_DUIPAddress),
        ('iE-Extensions', _IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions),
        ])
    IAB_Donor_CU_UPPSKInfo_Item._ext = []
    
    #-----< IAB-donor-CU-UPPSKInfoItemExtIEs >-----#
    IAB_donor_CU_UPPSKInfoItemExtIEs = CLASS(name='IAB-donor-CU-UPPSKInfoItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    IAB_donor_CU_UPPSKInfoItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IAB-donor-CU-UPPSK >-----#
    IAB_donor_CU_UPPSK = OCT_STR(name='IAB-donor-CU-UPPSK', mode=MODE_TYPE)
    
    #-----< Links-to-log >-----#
    Links_to_log = ENUM(name='Links-to-log', mode=MODE_TYPE)
    Links_to_log._cont = ASN1Dict([('uplink', 0), ('downlink', 1), ('both-uplink-and-downlink', 2)])
    Links_to_log._ext = []
    
    #-----< LocationDependentMBSNGUInformationAt5GC >-----#
    LocationDependentMBSNGUInformationAt5GC = SEQ_OF(name='LocationDependentMBSNGUInformationAt5GC', mode=MODE_TYPE)
    _LocationDependentMBSNGUInformationAt5GC__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'LocationDependentMBSNGUInformationAt5GC-Item')))
    LocationDependentMBSNGUInformationAt5GC._cont = _LocationDependentMBSNGUInformationAt5GC__item_
    LocationDependentMBSNGUInformationAt5GC._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< LocationDependentMBSNGUInformationAt5GC-Item >-----#
    LocationDependentMBSNGUInformationAt5GC_Item = SEQ(name='LocationDependentMBSNGUInformationAt5GC-Item', mode=MODE_TYPE)
    _LocationDependentMBSNGUInformationAt5GC_Item_mbsAreaSession_ID = INT(name='mbsAreaSession-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSAreaSessionID')))
    _LocationDependentMBSNGUInformationAt5GC_Item_mbsNGUInformationAt5GC = CHOICE(name='mbsNGUInformationAt5GC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSNGUInformationAt5GC')))
    _LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__id._const_tab = ____LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__id_tab
    ___LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__id._const_tab_at = None
    ___LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__criticality._const_tab = ____LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__criticality_tab
    ___LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__extensionValue._const_tab = ____LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__extensionValue_tab
    ___LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__id),
        ('criticality', ___LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__extensionValue),
        ])
    __LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item_._ext = None
    _LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions._cont = __LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item_
    _LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationDependentMBSNGUInformationAt5GC_Item._cont = ASN1Dict([
        ('mbsAreaSession-ID', _LocationDependentMBSNGUInformationAt5GC_Item_mbsAreaSession_ID),
        ('mbsNGUInformationAt5GC', _LocationDependentMBSNGUInformationAt5GC_Item_mbsNGUInformationAt5GC),
        ('iE-Extensions', _LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions),
        ])
    LocationDependentMBSNGUInformationAt5GC_Item._ext = []
    
    #-----< LocationDependentMBSNGUInformationAt5GC-Item-ExtIEs >-----#
    LocationDependentMBSNGUInformationAt5GC_Item_ExtIEs = CLASS(name='LocationDependentMBSNGUInformationAt5GC-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    LocationDependentMBSNGUInformationAt5GC_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LocationDependentMBSF1UInformationAtCU >-----#
    LocationDependentMBSF1UInformationAtCU = SEQ_OF(name='LocationDependentMBSF1UInformationAtCU', mode=MODE_TYPE)
    _LocationDependentMBSF1UInformationAtCU__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'LocationDependentMBSF1UInformationAtCU-Item')))
    LocationDependentMBSF1UInformationAtCU._cont = _LocationDependentMBSF1UInformationAtCU__item_
    LocationDependentMBSF1UInformationAtCU._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< LocationDependentMBSF1UInformationAtCU-Item >-----#
    LocationDependentMBSF1UInformationAtCU_Item = SEQ(name='LocationDependentMBSF1UInformationAtCU-Item', mode=MODE_TYPE)
    _LocationDependentMBSF1UInformationAtCU_Item_mbsAreaSession_ID = INT(name='mbsAreaSession-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSAreaSessionID')))
    _LocationDependentMBSF1UInformationAtCU_Item_mbs_f1u_info_at_CU = CHOICE(name='mbs-f1u-info-at-CU', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__id._const_tab = ____LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__id_tab
    ___LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__id._const_tab_at = None
    ___LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__criticality._const_tab = ____LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__criticality_tab
    ___LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__extensionValue._const_tab = ____LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__extensionValue_tab
    ___LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__id),
        ('criticality', ___LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__extensionValue),
        ])
    __LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item_._ext = None
    _LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions._cont = __LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item_
    _LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationDependentMBSF1UInformationAtCU_Item._cont = ASN1Dict([
        ('mbsAreaSession-ID', _LocationDependentMBSF1UInformationAtCU_Item_mbsAreaSession_ID),
        ('mbs-f1u-info-at-CU', _LocationDependentMBSF1UInformationAtCU_Item_mbs_f1u_info_at_CU),
        ('iE-Extensions', _LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions),
        ])
    LocationDependentMBSF1UInformationAtCU_Item._ext = []
    
    #-----< LocationDependentMBSF1UInformationAtCU-Item-ExtIEs >-----#
    LocationDependentMBSF1UInformationAtCU_Item_ExtIEs = CLASS(name='LocationDependentMBSF1UInformationAtCU-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    LocationDependentMBSF1UInformationAtCU_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LocationDependentMBSF1UInformationAtDU >-----#
    LocationDependentMBSF1UInformationAtDU = SEQ_OF(name='LocationDependentMBSF1UInformationAtDU', mode=MODE_TYPE)
    _LocationDependentMBSF1UInformationAtDU__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'LocationDependentMBSF1UInformationAtDU-Item')))
    LocationDependentMBSF1UInformationAtDU._cont = _LocationDependentMBSF1UInformationAtDU__item_
    LocationDependentMBSF1UInformationAtDU._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< LocationDependentMBSF1UInformationAtDU-Item >-----#
    LocationDependentMBSF1UInformationAtDU_Item = SEQ(name='LocationDependentMBSF1UInformationAtDU-Item', mode=MODE_TYPE)
    _LocationDependentMBSF1UInformationAtDU_Item_mbsAreaSession_ID = INT(name='mbsAreaSession-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSAreaSessionID')))
    _LocationDependentMBSF1UInformationAtDU_Item_mbs_f1u_info_at_DU = CHOICE(name='mbs-f1u-info-at-DU', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__id._const_tab = ____LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__id_tab
    ___LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__id._const_tab_at = None
    ___LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__criticality._const_tab = ____LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__criticality_tab
    ___LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__extensionValue._const_tab = ____LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__extensionValue_tab
    ___LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__id),
        ('criticality', ___LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__extensionValue),
        ])
    __LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item_._ext = None
    _LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions._cont = __LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item_
    _LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationDependentMBSF1UInformationAtDU_Item._cont = ASN1Dict([
        ('mbsAreaSession-ID', _LocationDependentMBSF1UInformationAtDU_Item_mbsAreaSession_ID),
        ('mbs-f1u-info-at-DU', _LocationDependentMBSF1UInformationAtDU_Item_mbs_f1u_info_at_DU),
        ('iE-Extensions', _LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions),
        ])
    LocationDependentMBSF1UInformationAtDU_Item._ext = []
    
    #-----< LocationDependentMBSF1UInformationAtDU-Item-ExtIEs >-----#
    LocationDependentMBSF1UInformationAtDU_Item_ExtIEs = CLASS(name='LocationDependentMBSF1UInformationAtDU-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    LocationDependentMBSF1UInformationAtDU_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LocationDependentMBSNGUInformationAtNGRAN >-----#
    LocationDependentMBSNGUInformationAtNGRAN = SEQ_OF(name='LocationDependentMBSNGUInformationAtNGRAN', mode=MODE_TYPE)
    _LocationDependentMBSNGUInformationAtNGRAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'LocationDependentMBSNGUInformationAtNGRAN-Item')))
    LocationDependentMBSNGUInformationAtNGRAN._cont = _LocationDependentMBSNGUInformationAtNGRAN__item_
    LocationDependentMBSNGUInformationAtNGRAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< LocationDependentMBSNGUInformationAtNGRAN-Item >-----#
    LocationDependentMBSNGUInformationAtNGRAN_Item = SEQ(name='LocationDependentMBSNGUInformationAtNGRAN-Item', mode=MODE_TYPE)
    _LocationDependentMBSNGUInformationAtNGRAN_Item_mbsAreaSession_ID = INT(name='mbsAreaSession-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSAreaSessionID')))
    _LocationDependentMBSNGUInformationAtNGRAN_Item_mbsNGUInformationAtNGRAN = CHOICE(name='mbsNGUInformationAtNGRAN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSNGUInformationAtNGRAN')))
    _LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__id._const_tab = ____LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__id_tab
    ___LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__id._const_tab_at = None
    ___LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__criticality._const_tab = ____LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__criticality_tab
    ___LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__extensionValue._const_tab = ____LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__extensionValue_tab
    ___LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__id),
        ('criticality', ___LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__extensionValue),
        ])
    __LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item_._ext = None
    _LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions._cont = __LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item_
    _LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationDependentMBSNGUInformationAtNGRAN_Item._cont = ASN1Dict([
        ('mbsAreaSession-ID', _LocationDependentMBSNGUInformationAtNGRAN_Item_mbsAreaSession_ID),
        ('mbsNGUInformationAtNGRAN', _LocationDependentMBSNGUInformationAtNGRAN_Item_mbsNGUInformationAtNGRAN),
        ('iE-Extensions', _LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions),
        ])
    LocationDependentMBSNGUInformationAtNGRAN_Item._ext = []
    
    #-----< LocationDependentMBSNGUInformationAtNGRAN-Item-ExtIEs >-----#
    LocationDependentMBSNGUInformationAtNGRAN_Item_ExtIEs = CLASS(name='LocationDependentMBSNGUInformationAtNGRAN-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    LocationDependentMBSNGUInformationAtNGRAN_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MaxDataBurstVolume >-----#
    MaxDataBurstVolume = INT(name='MaxDataBurstVolume', mode=MODE_TYPE)
    MaxDataBurstVolume._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[ASN1RangeInt(lb=4096, ub=2000000)])
    
    #-----< MaximumIPdatarate >-----#
    MaximumIPdatarate = SEQ(name='MaximumIPdatarate', mode=MODE_TYPE)
    _MaximumIPdatarate_maxIPrate = ENUM(name='maxIPrate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MaxIPrate')))
    _MaximumIPdatarate_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MaximumIPdatarate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MaximumIPdatarate_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MaximumIPdatarate_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MaximumIPdatarate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MaximumIPdatarate_iE_Extensions__item__id._const_tab = ____MaximumIPdatarate_iE_Extensions__item__id_tab
    ___MaximumIPdatarate_iE_Extensions__item__id._const_tab_at = None
    ___MaximumIPdatarate_iE_Extensions__item__id._const_tab_id = 'id'
    ___MaximumIPdatarate_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MaximumIPdatarate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MaximumIPdatarate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MaximumIPdatarate_iE_Extensions__item__criticality._const_tab = ____MaximumIPdatarate_iE_Extensions__item__criticality_tab
    ___MaximumIPdatarate_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MaximumIPdatarate_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MaximumIPdatarate_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MaximumIPdatarate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MaximumIPdatarate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MaximumIPdatarate_iE_Extensions__item__extensionValue._const_tab = ____MaximumIPdatarate_iE_Extensions__item__extensionValue_tab
    ___MaximumIPdatarate_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MaximumIPdatarate_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MaximumIPdatarate_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MaximumIPdatarate_iE_Extensions__item__id),
        ('criticality', ___MaximumIPdatarate_iE_Extensions__item__criticality),
        ('extensionValue', ___MaximumIPdatarate_iE_Extensions__item__extensionValue),
        ])
    __MaximumIPdatarate_iE_Extensions__item_._ext = None
    _MaximumIPdatarate_iE_Extensions._cont = __MaximumIPdatarate_iE_Extensions__item_
    _MaximumIPdatarate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MaximumIPdatarate._cont = ASN1Dict([
        ('maxIPrate', _MaximumIPdatarate_maxIPrate),
        ('iE-Extensions', _MaximumIPdatarate_iE_Extensions),
        ])
    MaximumIPdatarate._ext = []
    
    #-----< MaximumIPdatarate-ExtIEs >-----#
    MaximumIPdatarate_ExtIEs = CLASS(name='MaximumIPdatarate-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MaximumIPdatarate_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MaxIPrate >-----#
    MaxIPrate = ENUM(name='MaxIPrate', mode=MODE_TYPE)
    MaxIPrate._cont = ASN1Dict([('bitrate64kbs', 0), ('max-UErate', 1)])
    MaxIPrate._ext = []
    
    #-----< MaxPacketLossRate >-----#
    MaxPacketLossRate = INT(name='MaxPacketLossRate', mode=MODE_TYPE)
    MaxPacketLossRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1000)], ev=[], er=[])
    
    #-----< MaxCIDEHCDL >-----#
    MaxCIDEHCDL = INT(name='MaxCIDEHCDL', mode=MODE_TYPE)
    MaxCIDEHCDL._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32767)], ev=[], er=[])
    
    #-----< MBSAreaSessionID >-----#
    MBSAreaSessionID = INT(name='MBSAreaSessionID', mode=MODE_TYPE)
    MBSAreaSessionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=[], er=[])
    
    #-----< MBSF1UInformationAtCU >-----#
    MBSF1UInformationAtCU = SEQ(name='MBSF1UInformationAtCU', mode=MODE_TYPE)
    _MBSF1UInformationAtCU_mbs_f1u_info_at_CU = CHOICE(name='mbs-f1u-info-at-CU', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _MBSF1UInformationAtCU_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBSF1UInformationAtCU_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MBSF1UInformationAtCU_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MBSF1UInformationAtCU_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBSF1UInformationAtCU_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSF1UInformationAtCU_iE_Extensions__item__id._const_tab = ____MBSF1UInformationAtCU_iE_Extensions__item__id_tab
    ___MBSF1UInformationAtCU_iE_Extensions__item__id._const_tab_at = None
    ___MBSF1UInformationAtCU_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBSF1UInformationAtCU_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBSF1UInformationAtCU_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBSF1UInformationAtCU_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSF1UInformationAtCU_iE_Extensions__item__criticality._const_tab = ____MBSF1UInformationAtCU_iE_Extensions__item__criticality_tab
    ___MBSF1UInformationAtCU_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBSF1UInformationAtCU_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBSF1UInformationAtCU_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBSF1UInformationAtCU_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBSF1UInformationAtCU_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSF1UInformationAtCU_iE_Extensions__item__extensionValue._const_tab = ____MBSF1UInformationAtCU_iE_Extensions__item__extensionValue_tab
    ___MBSF1UInformationAtCU_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBSF1UInformationAtCU_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBSF1UInformationAtCU_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBSF1UInformationAtCU_iE_Extensions__item__id),
        ('criticality', ___MBSF1UInformationAtCU_iE_Extensions__item__criticality),
        ('extensionValue', ___MBSF1UInformationAtCU_iE_Extensions__item__extensionValue),
        ])
    __MBSF1UInformationAtCU_iE_Extensions__item_._ext = None
    _MBSF1UInformationAtCU_iE_Extensions._cont = __MBSF1UInformationAtCU_iE_Extensions__item_
    _MBSF1UInformationAtCU_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBSF1UInformationAtCU._cont = ASN1Dict([
        ('mbs-f1u-info-at-CU', _MBSF1UInformationAtCU_mbs_f1u_info_at_CU),
        ('iE-Extensions', _MBSF1UInformationAtCU_iE_Extensions),
        ])
    MBSF1UInformationAtCU._ext = []
    
    #-----< MBSF1UInformationAtCU-ExtIEs >-----#
    MBSF1UInformationAtCU_ExtIEs = CLASS(name='MBSF1UInformationAtCU-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MBSF1UInformationAtCU_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBSF1UInformationAtDU >-----#
    MBSF1UInformationAtDU = SEQ(name='MBSF1UInformationAtDU', mode=MODE_TYPE)
    _MBSF1UInformationAtDU_mbs_f1u_info_at_DU = CHOICE(name='mbs-f1u-info-at-DU', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _MBSF1UInformationAtDU_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBSF1UInformationAtDU_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MBSF1UInformationAtDU_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MBSF1UInformationAtDU_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBSF1UInformationAtDU_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSF1UInformationAtDU_iE_Extensions__item__id._const_tab = ____MBSF1UInformationAtDU_iE_Extensions__item__id_tab
    ___MBSF1UInformationAtDU_iE_Extensions__item__id._const_tab_at = None
    ___MBSF1UInformationAtDU_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBSF1UInformationAtDU_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBSF1UInformationAtDU_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBSF1UInformationAtDU_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSF1UInformationAtDU_iE_Extensions__item__criticality._const_tab = ____MBSF1UInformationAtDU_iE_Extensions__item__criticality_tab
    ___MBSF1UInformationAtDU_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBSF1UInformationAtDU_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBSF1UInformationAtDU_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBSF1UInformationAtDU_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBSF1UInformationAtDU_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSF1UInformationAtDU_iE_Extensions__item__extensionValue._const_tab = ____MBSF1UInformationAtDU_iE_Extensions__item__extensionValue_tab
    ___MBSF1UInformationAtDU_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBSF1UInformationAtDU_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBSF1UInformationAtDU_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBSF1UInformationAtDU_iE_Extensions__item__id),
        ('criticality', ___MBSF1UInformationAtDU_iE_Extensions__item__criticality),
        ('extensionValue', ___MBSF1UInformationAtDU_iE_Extensions__item__extensionValue),
        ])
    __MBSF1UInformationAtDU_iE_Extensions__item_._ext = None
    _MBSF1UInformationAtDU_iE_Extensions._cont = __MBSF1UInformationAtDU_iE_Extensions__item_
    _MBSF1UInformationAtDU_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBSF1UInformationAtDU._cont = ASN1Dict([
        ('mbs-f1u-info-at-DU', _MBSF1UInformationAtDU_mbs_f1u_info_at_DU),
        ('iE-Extensions', _MBSF1UInformationAtDU_iE_Extensions),
        ])
    MBSF1UInformationAtDU._ext = []
    
    #-----< MBSF1UInformationAtDU-ExtIEs >-----#
    MBSF1UInformationAtDU_ExtIEs = CLASS(name='MBSF1UInformationAtDU-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MBSF1UInformationAtDU_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBSNGUInformationAt5GC >-----#
    MBSNGUInformationAt5GC = CHOICE(name='MBSNGUInformationAt5GC', mode=MODE_TYPE)
    _MBSNGUInformationAt5GC_multicast = SEQ(name='multicast', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSNGUInformationAt5GC-Multicast')))
    _MBSNGUInformationAt5GC_unicast = CHOICE(name='unicast', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _MBSNGUInformationAt5GC_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __MBSNGUInformationAt5GC_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___MBSNGUInformationAt5GC_choice_extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___MBSNGUInformationAt5GC_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MBSNGUInformationAt5GC_choice_extension_id._const_tab = ___MBSNGUInformationAt5GC_choice_extension_id_tab
    __MBSNGUInformationAt5GC_choice_extension_id._const_tab_at = None
    __MBSNGUInformationAt5GC_choice_extension_id._const_tab_id = 'id'
    __MBSNGUInformationAt5GC_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___MBSNGUInformationAt5GC_choice_extension_criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___MBSNGUInformationAt5GC_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MBSNGUInformationAt5GC_choice_extension_criticality._const_tab = ___MBSNGUInformationAt5GC_choice_extension_criticality_tab
    __MBSNGUInformationAt5GC_choice_extension_criticality._const_tab_at = ('..', 'id')
    __MBSNGUInformationAt5GC_choice_extension_criticality._const_tab_id = 'criticality'
    __MBSNGUInformationAt5GC_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___MBSNGUInformationAt5GC_choice_extension_value_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___MBSNGUInformationAt5GC_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MBSNGUInformationAt5GC_choice_extension_value._const_tab = ___MBSNGUInformationAt5GC_choice_extension_value_tab
    __MBSNGUInformationAt5GC_choice_extension_value._const_tab_at = ('..', 'id')
    __MBSNGUInformationAt5GC_choice_extension_value._const_tab_id = 'Value'
    _MBSNGUInformationAt5GC_choice_extension._cont = ASN1Dict([
        ('id', __MBSNGUInformationAt5GC_choice_extension_id),
        ('criticality', __MBSNGUInformationAt5GC_choice_extension_criticality),
        ('value', __MBSNGUInformationAt5GC_choice_extension_value),
        ])
    _MBSNGUInformationAt5GC_choice_extension._ext = None
    MBSNGUInformationAt5GC._cont = ASN1Dict([
        ('multicast', _MBSNGUInformationAt5GC_multicast),
        ('unicast', _MBSNGUInformationAt5GC_unicast),
        ('choice-extension', _MBSNGUInformationAt5GC_choice_extension),
        ])
    MBSNGUInformationAt5GC._ext = None
    
    #-----< MBSNGUInformationAt5GC-ExtIEs >-----#
    MBSNGUInformationAt5GC_ExtIEs = CLASS(name='MBSNGUInformationAt5GC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    MBSNGUInformationAt5GC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBSNGUInformationAt5GC-Multicast >-----#
    MBSNGUInformationAt5GC_Multicast = SEQ(name='MBSNGUInformationAt5GC-Multicast', mode=MODE_TYPE)
    _MBSNGUInformationAt5GC_Multicast_ipmcAddress = BIT_STR(name='ipmcAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    _MBSNGUInformationAt5GC_Multicast_ipsourceAddress = BIT_STR(name='ipsourceAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    _MBSNGUInformationAt5GC_Multicast_gtpDLTEID = OCT_STR(name='gtpDLTEID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'GTP-TEID')))
    _MBSNGUInformationAt5GC_Multicast_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBSNGUInformationAt5GC_Multicast_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__id._const_tab = ____MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__id_tab
    ___MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__id._const_tab_at = None
    ___MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__criticality._const_tab = ____MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__criticality_tab
    ___MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__extensionValue._const_tab = ____MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__extensionValue_tab
    ___MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBSNGUInformationAt5GC_Multicast_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__id),
        ('criticality', ___MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__criticality),
        ('extensionValue', ___MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__extensionValue),
        ])
    __MBSNGUInformationAt5GC_Multicast_iE_Extensions__item_._ext = None
    _MBSNGUInformationAt5GC_Multicast_iE_Extensions._cont = __MBSNGUInformationAt5GC_Multicast_iE_Extensions__item_
    _MBSNGUInformationAt5GC_Multicast_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBSNGUInformationAt5GC_Multicast._cont = ASN1Dict([
        ('ipmcAddress', _MBSNGUInformationAt5GC_Multicast_ipmcAddress),
        ('ipsourceAddress', _MBSNGUInformationAt5GC_Multicast_ipsourceAddress),
        ('gtpDLTEID', _MBSNGUInformationAt5GC_Multicast_gtpDLTEID),
        ('iE-Extensions', _MBSNGUInformationAt5GC_Multicast_iE_Extensions),
        ])
    MBSNGUInformationAt5GC_Multicast._ext = []
    
    #-----< MBSNGUInformationAt5GC-Multicast-ExtIEs >-----#
    MBSNGUInformationAt5GC_Multicast_ExtIEs = CLASS(name='MBSNGUInformationAt5GC-Multicast-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MBSNGUInformationAt5GC_Multicast_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBSNGUInformationAtNGRAN >-----#
    MBSNGUInformationAtNGRAN = CHOICE(name='MBSNGUInformationAtNGRAN', mode=MODE_TYPE)
    _MBSNGUInformationAtNGRAN_unicast = CHOICE(name='unicast', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _MBSNGUInformationAtNGRAN_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __MBSNGUInformationAtNGRAN_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___MBSNGUInformationAtNGRAN_choice_extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___MBSNGUInformationAtNGRAN_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MBSNGUInformationAtNGRAN_choice_extension_id._const_tab = ___MBSNGUInformationAtNGRAN_choice_extension_id_tab
    __MBSNGUInformationAtNGRAN_choice_extension_id._const_tab_at = None
    __MBSNGUInformationAtNGRAN_choice_extension_id._const_tab_id = 'id'
    __MBSNGUInformationAtNGRAN_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___MBSNGUInformationAtNGRAN_choice_extension_criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___MBSNGUInformationAtNGRAN_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MBSNGUInformationAtNGRAN_choice_extension_criticality._const_tab = ___MBSNGUInformationAtNGRAN_choice_extension_criticality_tab
    __MBSNGUInformationAtNGRAN_choice_extension_criticality._const_tab_at = ('..', 'id')
    __MBSNGUInformationAtNGRAN_choice_extension_criticality._const_tab_id = 'criticality'
    __MBSNGUInformationAtNGRAN_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___MBSNGUInformationAtNGRAN_choice_extension_value_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___MBSNGUInformationAtNGRAN_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MBSNGUInformationAtNGRAN_choice_extension_value._const_tab = ___MBSNGUInformationAtNGRAN_choice_extension_value_tab
    __MBSNGUInformationAtNGRAN_choice_extension_value._const_tab_at = ('..', 'id')
    __MBSNGUInformationAtNGRAN_choice_extension_value._const_tab_id = 'Value'
    _MBSNGUInformationAtNGRAN_choice_extension._cont = ASN1Dict([
        ('id', __MBSNGUInformationAtNGRAN_choice_extension_id),
        ('criticality', __MBSNGUInformationAtNGRAN_choice_extension_criticality),
        ('value', __MBSNGUInformationAtNGRAN_choice_extension_value),
        ])
    _MBSNGUInformationAtNGRAN_choice_extension._ext = None
    MBSNGUInformationAtNGRAN._cont = ASN1Dict([
        ('unicast', _MBSNGUInformationAtNGRAN_unicast),
        ('choice-extension', _MBSNGUInformationAtNGRAN_choice_extension),
        ])
    MBSNGUInformationAtNGRAN._ext = None
    
    #-----< MBSNGUInformationAtNGRAN-ExtIEs >-----#
    MBSNGUInformationAtNGRAN_ExtIEs = CLASS(name='MBSNGUInformationAtNGRAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    MBSNGUInformationAtNGRAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBSSessionAssociatedInfoNonSupportToSupport >-----#
    MBSSessionAssociatedInfoNonSupportToSupport = SEQ(name='MBSSessionAssociatedInfoNonSupportToSupport', mode=MODE_TYPE)
    _MBSSessionAssociatedInfoNonSupportToSupport_ue_Reference_ID = INT(name='ue-Reference-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _MBSSessionAssociatedInfoNonSupportToSupport_pDU_Session_ID = INT(name='pDU-Session-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-ID')))
    _MBSSessionAssociatedInfoNonSupportToSupport_associatedQoSFlowInformationList = SEQ_OF(name='associatedQoSFlowInformationList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSSessionAssociatedInformationList')))
    _MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__id._const_tab = ____MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__id_tab
    ___MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__id._const_tab_at = None
    ___MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__criticality._const_tab = ____MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__criticality_tab
    ___MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__extensionValue._const_tab = ____MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__extensionValue_tab
    ___MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__id),
        ('criticality', ___MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__criticality),
        ('extensionValue', ___MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__extensionValue),
        ])
    __MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item_._ext = None
    _MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions._cont = __MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item_
    _MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBSSessionAssociatedInfoNonSupportToSupport._cont = ASN1Dict([
        ('ue-Reference-ID', _MBSSessionAssociatedInfoNonSupportToSupport_ue_Reference_ID),
        ('pDU-Session-ID', _MBSSessionAssociatedInfoNonSupportToSupport_pDU_Session_ID),
        ('associatedQoSFlowInformationList', _MBSSessionAssociatedInfoNonSupportToSupport_associatedQoSFlowInformationList),
        ('iE-Extensions', _MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions),
        ])
    MBSSessionAssociatedInfoNonSupportToSupport._ext = []
    
    #-----< MBSSessionAssociatedInfoNonSupportToSupport-ExtIEs >-----#
    MBSSessionAssociatedInfoNonSupportToSupport_ExtIEs = CLASS(name='MBSSessionAssociatedInfoNonSupportToSupport-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MBSSessionAssociatedInfoNonSupportToSupport_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBSSessionAssociatedInformation >-----#
    MBSSessionAssociatedInformation = SEQ(name='MBSSessionAssociatedInformation', mode=MODE_TYPE)
    _MBSSessionAssociatedInformation_mbsSessionAssociatedInformationList = SEQ_OF(name='mbsSessionAssociatedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSSessionAssociatedInformationList')))
    _MBSSessionAssociatedInformation_mbsSessionForwardingAddress = BIT_STR(name='mbsSessionForwardingAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    _MBSSessionAssociatedInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBSSessionAssociatedInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MBSSessionAssociatedInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MBSSessionAssociatedInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBSSessionAssociatedInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionAssociatedInformation_iE_Extensions__item__id._const_tab = ____MBSSessionAssociatedInformation_iE_Extensions__item__id_tab
    ___MBSSessionAssociatedInformation_iE_Extensions__item__id._const_tab_at = None
    ___MBSSessionAssociatedInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBSSessionAssociatedInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBSSessionAssociatedInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBSSessionAssociatedInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionAssociatedInformation_iE_Extensions__item__criticality._const_tab = ____MBSSessionAssociatedInformation_iE_Extensions__item__criticality_tab
    ___MBSSessionAssociatedInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBSSessionAssociatedInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBSSessionAssociatedInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBSSessionAssociatedInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBSSessionAssociatedInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionAssociatedInformation_iE_Extensions__item__extensionValue._const_tab = ____MBSSessionAssociatedInformation_iE_Extensions__item__extensionValue_tab
    ___MBSSessionAssociatedInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBSSessionAssociatedInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBSSessionAssociatedInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBSSessionAssociatedInformation_iE_Extensions__item__id),
        ('criticality', ___MBSSessionAssociatedInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___MBSSessionAssociatedInformation_iE_Extensions__item__extensionValue),
        ])
    __MBSSessionAssociatedInformation_iE_Extensions__item_._ext = None
    _MBSSessionAssociatedInformation_iE_Extensions._cont = __MBSSessionAssociatedInformation_iE_Extensions__item_
    _MBSSessionAssociatedInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBSSessionAssociatedInformation._cont = ASN1Dict([
        ('mbsSessionAssociatedInformationList', _MBSSessionAssociatedInformation_mbsSessionAssociatedInformationList),
        ('mbsSessionForwardingAddress', _MBSSessionAssociatedInformation_mbsSessionForwardingAddress),
        ('iE-Extensions', _MBSSessionAssociatedInformation_iE_Extensions),
        ])
    MBSSessionAssociatedInformation._ext = []
    
    #-----< MBSSessionAssociatedInformation-ExtIEs >-----#
    MBSSessionAssociatedInformation_ExtIEs = CLASS(name='MBSSessionAssociatedInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MBSSessionAssociatedInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBSSessionAssociatedInformationList >-----#
    MBSSessionAssociatedInformationList = SEQ_OF(name='MBSSessionAssociatedInformationList', mode=MODE_TYPE)
    _MBSSessionAssociatedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MBSSessionAssociatedInformation-Item')))
    MBSSessionAssociatedInformationList._cont = _MBSSessionAssociatedInformationList__item_
    MBSSessionAssociatedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< MBSSessionAssociatedInformation-Item >-----#
    MBSSessionAssociatedInformation_Item = SEQ(name='MBSSessionAssociatedInformation-Item', mode=MODE_TYPE)
    _MBSSessionAssociatedInformation_Item_mbs_QoS_Flow_Identifier = INT(name='mbs-QoS-Flow-Identifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Identifier')))
    _MBSSessionAssociatedInformation_Item_associated_unicast_QoS_Flow_Identifier = INT(name='associated-unicast-QoS-Flow-Identifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Identifier')))
    _MBSSessionAssociatedInformation_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBSSessionAssociatedInformation_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MBSSessionAssociatedInformation_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MBSSessionAssociatedInformation_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBSSessionAssociatedInformation_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionAssociatedInformation_Item_iE_Extensions__item__id._const_tab = ____MBSSessionAssociatedInformation_Item_iE_Extensions__item__id_tab
    ___MBSSessionAssociatedInformation_Item_iE_Extensions__item__id._const_tab_at = None
    ___MBSSessionAssociatedInformation_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBSSessionAssociatedInformation_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBSSessionAssociatedInformation_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBSSessionAssociatedInformation_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionAssociatedInformation_Item_iE_Extensions__item__criticality._const_tab = ____MBSSessionAssociatedInformation_Item_iE_Extensions__item__criticality_tab
    ___MBSSessionAssociatedInformation_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBSSessionAssociatedInformation_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBSSessionAssociatedInformation_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBSSessionAssociatedInformation_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBSSessionAssociatedInformation_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionAssociatedInformation_Item_iE_Extensions__item__extensionValue._const_tab = ____MBSSessionAssociatedInformation_Item_iE_Extensions__item__extensionValue_tab
    ___MBSSessionAssociatedInformation_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBSSessionAssociatedInformation_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBSSessionAssociatedInformation_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBSSessionAssociatedInformation_Item_iE_Extensions__item__id),
        ('criticality', ___MBSSessionAssociatedInformation_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MBSSessionAssociatedInformation_Item_iE_Extensions__item__extensionValue),
        ])
    __MBSSessionAssociatedInformation_Item_iE_Extensions__item_._ext = None
    _MBSSessionAssociatedInformation_Item_iE_Extensions._cont = __MBSSessionAssociatedInformation_Item_iE_Extensions__item_
    _MBSSessionAssociatedInformation_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBSSessionAssociatedInformation_Item._cont = ASN1Dict([
        ('mbs-QoS-Flow-Identifier', _MBSSessionAssociatedInformation_Item_mbs_QoS_Flow_Identifier),
        ('associated-unicast-QoS-Flow-Identifier', _MBSSessionAssociatedInformation_Item_associated_unicast_QoS_Flow_Identifier),
        ('iE-Extensions', _MBSSessionAssociatedInformation_Item_iE_Extensions),
        ])
    MBSSessionAssociatedInformation_Item._ext = []
    
    #-----< MBSSessionAssociatedInformation-Item-ExtIEs >-----#
    MBSSessionAssociatedInformation_Item_ExtIEs = CLASS(name='MBSSessionAssociatedInformation-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MBSSessionAssociatedInformation_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-Support-Info-ToAdd-List >-----#
    MBS_Support_Info_ToAdd_List = SEQ_OF(name='MBS-Support-Info-ToAdd-List', mode=MODE_TYPE)
    _MBS_Support_Info_ToAdd_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MBS-Support-Info-ToAdd-Item')))
    MBS_Support_Info_ToAdd_List._cont = _MBS_Support_Info_ToAdd_List__item_
    MBS_Support_Info_ToAdd_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< MBS-Support-Info-ToAdd-Item >-----#
    MBS_Support_Info_ToAdd_Item = SEQ(name='MBS-Support-Info-ToAdd-Item', mode=MODE_TYPE)
    _MBS_Support_Info_ToAdd_Item_globalMBSSessionID = SEQ(name='globalMBSSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'GlobalMBSSessionID')))
    _MBS_Support_Info_ToAdd_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBS_Support_Info_ToAdd_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MBS_Support_Info_ToAdd_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MBS_Support_Info_ToAdd_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBS_Support_Info_ToAdd_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_Support_Info_ToAdd_Item_iE_Extensions__item__id._const_tab = ____MBS_Support_Info_ToAdd_Item_iE_Extensions__item__id_tab
    ___MBS_Support_Info_ToAdd_Item_iE_Extensions__item__id._const_tab_at = None
    ___MBS_Support_Info_ToAdd_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBS_Support_Info_ToAdd_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBS_Support_Info_ToAdd_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBS_Support_Info_ToAdd_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_Support_Info_ToAdd_Item_iE_Extensions__item__criticality._const_tab = ____MBS_Support_Info_ToAdd_Item_iE_Extensions__item__criticality_tab
    ___MBS_Support_Info_ToAdd_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBS_Support_Info_ToAdd_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBS_Support_Info_ToAdd_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBS_Support_Info_ToAdd_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBS_Support_Info_ToAdd_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_Support_Info_ToAdd_Item_iE_Extensions__item__extensionValue._const_tab = ____MBS_Support_Info_ToAdd_Item_iE_Extensions__item__extensionValue_tab
    ___MBS_Support_Info_ToAdd_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBS_Support_Info_ToAdd_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBS_Support_Info_ToAdd_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBS_Support_Info_ToAdd_Item_iE_Extensions__item__id),
        ('criticality', ___MBS_Support_Info_ToAdd_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MBS_Support_Info_ToAdd_Item_iE_Extensions__item__extensionValue),
        ])
    __MBS_Support_Info_ToAdd_Item_iE_Extensions__item_._ext = None
    _MBS_Support_Info_ToAdd_Item_iE_Extensions._cont = __MBS_Support_Info_ToAdd_Item_iE_Extensions__item_
    _MBS_Support_Info_ToAdd_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBS_Support_Info_ToAdd_Item._cont = ASN1Dict([
        ('globalMBSSessionID', _MBS_Support_Info_ToAdd_Item_globalMBSSessionID),
        ('iE-Extensions', _MBS_Support_Info_ToAdd_Item_iE_Extensions),
        ])
    MBS_Support_Info_ToAdd_Item._ext = []
    
    #-----< MBS-Support-Info-ToAdd-Item-ExtIEs >-----#
    MBS_Support_Info_ToAdd_Item_ExtIEs = CLASS(name='MBS-Support-Info-ToAdd-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MBS_Support_Info_ToAdd_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-Support-Info-ToRemove-List >-----#
    MBS_Support_Info_ToRemove_List = SEQ_OF(name='MBS-Support-Info-ToRemove-List', mode=MODE_TYPE)
    _MBS_Support_Info_ToRemove_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MBS-Support-Info-ToRemove-Item')))
    MBS_Support_Info_ToRemove_List._cont = _MBS_Support_Info_ToRemove_List__item_
    MBS_Support_Info_ToRemove_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< MBS-Support-Info-ToRemove-Item >-----#
    MBS_Support_Info_ToRemove_Item = SEQ(name='MBS-Support-Info-ToRemove-Item', mode=MODE_TYPE)
    _MBS_Support_Info_ToRemove_Item_globalMBSSessionID = SEQ(name='globalMBSSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'GlobalMBSSessionID')))
    _MBS_Support_Info_ToRemove_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBS_Support_Info_ToRemove_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MBS_Support_Info_ToRemove_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MBS_Support_Info_ToRemove_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBS_Support_Info_ToRemove_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_Support_Info_ToRemove_Item_iE_Extensions__item__id._const_tab = ____MBS_Support_Info_ToRemove_Item_iE_Extensions__item__id_tab
    ___MBS_Support_Info_ToRemove_Item_iE_Extensions__item__id._const_tab_at = None
    ___MBS_Support_Info_ToRemove_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBS_Support_Info_ToRemove_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBS_Support_Info_ToRemove_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBS_Support_Info_ToRemove_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_Support_Info_ToRemove_Item_iE_Extensions__item__criticality._const_tab = ____MBS_Support_Info_ToRemove_Item_iE_Extensions__item__criticality_tab
    ___MBS_Support_Info_ToRemove_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBS_Support_Info_ToRemove_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBS_Support_Info_ToRemove_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBS_Support_Info_ToRemove_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBS_Support_Info_ToRemove_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_Support_Info_ToRemove_Item_iE_Extensions__item__extensionValue._const_tab = ____MBS_Support_Info_ToRemove_Item_iE_Extensions__item__extensionValue_tab
    ___MBS_Support_Info_ToRemove_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBS_Support_Info_ToRemove_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBS_Support_Info_ToRemove_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBS_Support_Info_ToRemove_Item_iE_Extensions__item__id),
        ('criticality', ___MBS_Support_Info_ToRemove_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MBS_Support_Info_ToRemove_Item_iE_Extensions__item__extensionValue),
        ])
    __MBS_Support_Info_ToRemove_Item_iE_Extensions__item_._ext = None
    _MBS_Support_Info_ToRemove_Item_iE_Extensions._cont = __MBS_Support_Info_ToRemove_Item_iE_Extensions__item_
    _MBS_Support_Info_ToRemove_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBS_Support_Info_ToRemove_Item._cont = ASN1Dict([
        ('globalMBSSessionID', _MBS_Support_Info_ToRemove_Item_globalMBSSessionID),
        ('iE-Extensions', _MBS_Support_Info_ToRemove_Item_iE_Extensions),
        ])
    MBS_Support_Info_ToRemove_Item._ext = []
    
    #-----< MBS-Support-Info-ToRemove-Item-ExtIEs >-----#
    MBS_Support_Info_ToRemove_Item_ExtIEs = CLASS(name='MBS-Support-Info-ToRemove-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MBS_Support_Info_ToRemove_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MCBearerContextToSetup >-----#
    MCBearerContextToSetup = SEQ(name='MCBearerContextToSetup', mode=MODE_TYPE)
    _MCBearerContextToSetup_snssai = SEQ(name='snssai', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'SNSSAI')))
    _MCBearerContextToSetup_mcMRBToSetupList = SEQ_OF(name='mcMRBToSetupList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MCMRBSetupConfiguration')), opt=True)
    _MCBearerContextToSetup_requestedAction = ENUM(name='requestedAction', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'RequestedAction4AvailNGUTermination')), opt=True)
    _MCBearerContextToSetup_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MCBearerContextToSetup_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MCBearerContextToSetup_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MCBearerContextToSetup_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____MCBearerContextToSetup_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MBSSessionAssociatedInfoNonSupportToSupport')))
    ____MCBearerContextToSetup_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 185), ('criticality', 'ignore'), ('Extension', _____MCBearerContextToSetup_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MCBearerContextToSetup_iE_Extensions__item__id._const_tab = ____MCBearerContextToSetup_iE_Extensions__item__id_tab
    ___MCBearerContextToSetup_iE_Extensions__item__id._const_tab_at = None
    ___MCBearerContextToSetup_iE_Extensions__item__id._const_tab_id = 'id'
    ___MCBearerContextToSetup_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___MCBearerContextToSetup_iE_Extensions__item__criticality._const_tab = ____MCBearerContextToSetup_iE_Extensions__item__id_tab
    ___MCBearerContextToSetup_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MCBearerContextToSetup_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MCBearerContextToSetup_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___MCBearerContextToSetup_iE_Extensions__item__extensionValue._const_tab = ____MCBearerContextToSetup_iE_Extensions__item__id_tab
    ___MCBearerContextToSetup_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MCBearerContextToSetup_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MCBearerContextToSetup_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MCBearerContextToSetup_iE_Extensions__item__id),
        ('criticality', ___MCBearerContextToSetup_iE_Extensions__item__criticality),
        ('extensionValue', ___MCBearerContextToSetup_iE_Extensions__item__extensionValue),
        ])
    __MCBearerContextToSetup_iE_Extensions__item_._ext = None
    _MCBearerContextToSetup_iE_Extensions._cont = __MCBearerContextToSetup_iE_Extensions__item_
    _MCBearerContextToSetup_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MCBearerContextToSetup._cont = ASN1Dict([
        ('snssai', _MCBearerContextToSetup_snssai),
        ('mcMRBToSetupList', _MCBearerContextToSetup_mcMRBToSetupList),
        ('requestedAction', _MCBearerContextToSetup_requestedAction),
        ('iE-Extensions', _MCBearerContextToSetup_iE_Extensions),
        ])
    MCBearerContextToSetup._ext = []
    
    #-----< MCBearerContextToSetup-ExtIEs >-----#
    MCBearerContextToSetup_ExtIEs = CLASS(name='MCBearerContextToSetup-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _MCBearerContextToSetup_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MBSSessionAssociatedInfoNonSupportToSupport')))
    MCBearerContextToSetup_ExtIEs._val = ASN1Set(rv=[dict([('id', 185), ('criticality', 'ignore'), ('Extension', _MCBearerContextToSetup_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MCMRBSetupConfiguration >-----#
    MCMRBSetupConfiguration = SEQ_OF(name='MCMRBSetupConfiguration', mode=MODE_TYPE)
    _MCMRBSetupConfiguration__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCMRBSetupConfiguration-Item')))
    MCMRBSetupConfiguration._cont = _MCMRBSetupConfiguration__item_
    MCMRBSetupConfiguration._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MCMRBSetupConfiguration-Item >-----#
    MCMRBSetupConfiguration_Item = SEQ(name='MCMRBSetupConfiguration-Item', mode=MODE_TYPE)
    _MCMRBSetupConfiguration_Item_mrb_ID = INT(name='mrb-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MRB-ID')))
    _MCMRBSetupConfiguration_Item_sdap_config = SEQ(name='sdap-config', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'SDAP-Configuration')))
    _MCMRBSetupConfiguration_Item_mbs_pdcp_config = SEQ(name='mbs-pdcp-config', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-Configuration')))
    _MCMRBSetupConfiguration_Item_qoS_Flow_QoS_Parameter_List = SEQ_OF(name='qoS-Flow-QoS-Parameter-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-QoS-Parameter-List')))
    _MCMRBSetupConfiguration_Item_qoSFlowLevelQoSParameters = SEQ(name='qoSFlowLevelQoSParameters', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoSFlowLevelQoSParameters')), opt=True)
    _MCMRBSetupConfiguration_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MCMRBSetupConfiguration_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MCMRBSetupConfiguration_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MCMRBSetupConfiguration_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCMRBSetupConfiguration_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCMRBSetupConfiguration_Item_iE_Extensions__item__id._const_tab = ____MCMRBSetupConfiguration_Item_iE_Extensions__item__id_tab
    ___MCMRBSetupConfiguration_Item_iE_Extensions__item__id._const_tab_at = None
    ___MCMRBSetupConfiguration_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MCMRBSetupConfiguration_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MCMRBSetupConfiguration_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCMRBSetupConfiguration_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCMRBSetupConfiguration_Item_iE_Extensions__item__criticality._const_tab = ____MCMRBSetupConfiguration_Item_iE_Extensions__item__criticality_tab
    ___MCMRBSetupConfiguration_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MCMRBSetupConfiguration_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MCMRBSetupConfiguration_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MCMRBSetupConfiguration_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCMRBSetupConfiguration_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCMRBSetupConfiguration_Item_iE_Extensions__item__extensionValue._const_tab = ____MCMRBSetupConfiguration_Item_iE_Extensions__item__extensionValue_tab
    ___MCMRBSetupConfiguration_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MCMRBSetupConfiguration_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MCMRBSetupConfiguration_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MCMRBSetupConfiguration_Item_iE_Extensions__item__id),
        ('criticality', ___MCMRBSetupConfiguration_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MCMRBSetupConfiguration_Item_iE_Extensions__item__extensionValue),
        ])
    __MCMRBSetupConfiguration_Item_iE_Extensions__item_._ext = None
    _MCMRBSetupConfiguration_Item_iE_Extensions._cont = __MCMRBSetupConfiguration_Item_iE_Extensions__item_
    _MCMRBSetupConfiguration_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MCMRBSetupConfiguration_Item._cont = ASN1Dict([
        ('mrb-ID', _MCMRBSetupConfiguration_Item_mrb_ID),
        ('sdap-config', _MCMRBSetupConfiguration_Item_sdap_config),
        ('mbs-pdcp-config', _MCMRBSetupConfiguration_Item_mbs_pdcp_config),
        ('qoS-Flow-QoS-Parameter-List', _MCMRBSetupConfiguration_Item_qoS_Flow_QoS_Parameter_List),
        ('qoSFlowLevelQoSParameters', _MCMRBSetupConfiguration_Item_qoSFlowLevelQoSParameters),
        ('iE-Extensions', _MCMRBSetupConfiguration_Item_iE_Extensions),
        ])
    MCMRBSetupConfiguration_Item._ext = []
    
    #-----< MCMRBSetupConfiguration-Item-ExtIEs >-----#
    MCMRBSetupConfiguration_Item_ExtIEs = CLASS(name='MCMRBSetupConfiguration-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MCMRBSetupConfiguration_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MCBearerContextToSetupResponse >-----#
    MCBearerContextToSetupResponse = SEQ(name='MCBearerContextToSetupResponse', mode=MODE_TYPE)
    _MCBearerContextToSetupResponse_mcBearerContextNGU_TNLInfoatNGRAN = CHOICE(name='mcBearerContextNGU-TNLInfoatNGRAN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MCBearerContextNGU-TNLInfoatNGRAN')), opt=True)
    _MCBearerContextToSetupResponse_mcMRBSetupResponseList = SEQ_OF(name='mcMRBSetupResponseList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MCMRBSetupResponseList')), opt=True)
    _MCBearerContextToSetupResponse_mcMRBFailedList = SEQ_OF(name='mcMRBFailedList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MCMRBFailedList')), opt=True)
    _MCBearerContextToSetupResponse_availableMCMRBConfig = SEQ_OF(name='availableMCMRBConfig', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MCMRBSetupConfiguration')), opt=True)
    _MCBearerContextToSetupResponse_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MCBearerContextToSetupResponse_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MCBearerContextToSetupResponse_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MCBearerContextToSetupResponse_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCBearerContextToSetupResponse_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCBearerContextToSetupResponse_iE_Extensions__item__id._const_tab = ____MCBearerContextToSetupResponse_iE_Extensions__item__id_tab
    ___MCBearerContextToSetupResponse_iE_Extensions__item__id._const_tab_at = None
    ___MCBearerContextToSetupResponse_iE_Extensions__item__id._const_tab_id = 'id'
    ___MCBearerContextToSetupResponse_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MCBearerContextToSetupResponse_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCBearerContextToSetupResponse_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCBearerContextToSetupResponse_iE_Extensions__item__criticality._const_tab = ____MCBearerContextToSetupResponse_iE_Extensions__item__criticality_tab
    ___MCBearerContextToSetupResponse_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MCBearerContextToSetupResponse_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MCBearerContextToSetupResponse_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MCBearerContextToSetupResponse_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCBearerContextToSetupResponse_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCBearerContextToSetupResponse_iE_Extensions__item__extensionValue._const_tab = ____MCBearerContextToSetupResponse_iE_Extensions__item__extensionValue_tab
    ___MCBearerContextToSetupResponse_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MCBearerContextToSetupResponse_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MCBearerContextToSetupResponse_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MCBearerContextToSetupResponse_iE_Extensions__item__id),
        ('criticality', ___MCBearerContextToSetupResponse_iE_Extensions__item__criticality),
        ('extensionValue', ___MCBearerContextToSetupResponse_iE_Extensions__item__extensionValue),
        ])
    __MCBearerContextToSetupResponse_iE_Extensions__item_._ext = None
    _MCBearerContextToSetupResponse_iE_Extensions._cont = __MCBearerContextToSetupResponse_iE_Extensions__item_
    _MCBearerContextToSetupResponse_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MCBearerContextToSetupResponse._cont = ASN1Dict([
        ('mcBearerContextNGU-TNLInfoatNGRAN', _MCBearerContextToSetupResponse_mcBearerContextNGU_TNLInfoatNGRAN),
        ('mcMRBSetupResponseList', _MCBearerContextToSetupResponse_mcMRBSetupResponseList),
        ('mcMRBFailedList', _MCBearerContextToSetupResponse_mcMRBFailedList),
        ('availableMCMRBConfig', _MCBearerContextToSetupResponse_availableMCMRBConfig),
        ('iE-Extensions', _MCBearerContextToSetupResponse_iE_Extensions),
        ])
    MCBearerContextToSetupResponse._ext = []
    
    #-----< MCBearerContextToSetupResponse-ExtIEs >-----#
    MCBearerContextToSetupResponse_ExtIEs = CLASS(name='MCBearerContextToSetupResponse-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MCBearerContextToSetupResponse_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MCBearerContextNGU-TNLInfoatNGRAN >-----#
    MCBearerContextNGU_TNLInfoatNGRAN = CHOICE(name='MCBearerContextNGU-TNLInfoatNGRAN', mode=MODE_TYPE)
    _MCBearerContextNGU_TNLInfoatNGRAN_locationindependent = CHOICE(name='locationindependent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSNGUInformationAtNGRAN')))
    _MCBearerContextNGU_TNLInfoatNGRAN_locationdependent = SEQ_OF(name='locationdependent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'LocationDependentMBSNGUInformationAtNGRAN')))
    _MCBearerContextNGU_TNLInfoatNGRAN_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_id._const_tab = ___MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_id_tab
    __MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_id._const_tab_at = None
    __MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_id._const_tab_id = 'id'
    __MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_criticality._const_tab = ___MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_criticality_tab
    __MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_criticality._const_tab_at = ('..', 'id')
    __MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_criticality._const_tab_id = 'criticality'
    __MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_value_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_value._const_tab = ___MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_value_tab
    __MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_value._const_tab_at = ('..', 'id')
    __MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_value._const_tab_id = 'Value'
    _MCBearerContextNGU_TNLInfoatNGRAN_choice_extension._cont = ASN1Dict([
        ('id', __MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_id),
        ('criticality', __MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_criticality),
        ('value', __MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_value),
        ])
    _MCBearerContextNGU_TNLInfoatNGRAN_choice_extension._ext = None
    MCBearerContextNGU_TNLInfoatNGRAN._cont = ASN1Dict([
        ('locationindependent', _MCBearerContextNGU_TNLInfoatNGRAN_locationindependent),
        ('locationdependent', _MCBearerContextNGU_TNLInfoatNGRAN_locationdependent),
        ('choice-extension', _MCBearerContextNGU_TNLInfoatNGRAN_choice_extension),
        ])
    MCBearerContextNGU_TNLInfoatNGRAN._ext = None
    
    #-----< MCBearerContextNGU-TNLInfoatNGRAN-ExtIEs >-----#
    MCBearerContextNGU_TNLInfoatNGRAN_ExtIEs = CLASS(name='MCBearerContextNGU-TNLInfoatNGRAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    MCBearerContextNGU_TNLInfoatNGRAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MCMRBSetupResponseList >-----#
    MCMRBSetupResponseList = SEQ_OF(name='MCMRBSetupResponseList', mode=MODE_TYPE)
    _MCMRBSetupResponseList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCMRBSetupResponseList-Item')))
    MCMRBSetupResponseList._cont = _MCMRBSetupResponseList__item_
    MCMRBSetupResponseList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MCMRBSetupResponseList-Item >-----#
    MCMRBSetupResponseList_Item = SEQ(name='MCMRBSetupResponseList-Item', mode=MODE_TYPE)
    _MCMRBSetupResponseList_Item_mrb_ID = INT(name='mrb-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MRB-ID')))
    _MCMRBSetupResponseList_Item_qosflow_setup = SEQ_OF(name='qosflow-setup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-List')))
    _MCMRBSetupResponseList_Item_qosflow_failed = SEQ_OF(name='qosflow-failed', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Failed-List')), opt=True)
    _MCMRBSetupResponseList_Item_mBS_PDCP_COUNT = BIT_STR(name='mBS-PDCP-COUNT', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBS-PDCP-COUNT')), opt=True)
    _MCMRBSetupResponseList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MCMRBSetupResponseList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MCMRBSetupResponseList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MCMRBSetupResponseList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCMRBSetupResponseList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCMRBSetupResponseList_Item_iE_Extensions__item__id._const_tab = ____MCMRBSetupResponseList_Item_iE_Extensions__item__id_tab
    ___MCMRBSetupResponseList_Item_iE_Extensions__item__id._const_tab_at = None
    ___MCMRBSetupResponseList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MCMRBSetupResponseList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MCMRBSetupResponseList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCMRBSetupResponseList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCMRBSetupResponseList_Item_iE_Extensions__item__criticality._const_tab = ____MCMRBSetupResponseList_Item_iE_Extensions__item__criticality_tab
    ___MCMRBSetupResponseList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MCMRBSetupResponseList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MCMRBSetupResponseList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MCMRBSetupResponseList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCMRBSetupResponseList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCMRBSetupResponseList_Item_iE_Extensions__item__extensionValue._const_tab = ____MCMRBSetupResponseList_Item_iE_Extensions__item__extensionValue_tab
    ___MCMRBSetupResponseList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MCMRBSetupResponseList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MCMRBSetupResponseList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MCMRBSetupResponseList_Item_iE_Extensions__item__id),
        ('criticality', ___MCMRBSetupResponseList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MCMRBSetupResponseList_Item_iE_Extensions__item__extensionValue),
        ])
    __MCMRBSetupResponseList_Item_iE_Extensions__item_._ext = None
    _MCMRBSetupResponseList_Item_iE_Extensions._cont = __MCMRBSetupResponseList_Item_iE_Extensions__item_
    _MCMRBSetupResponseList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MCMRBSetupResponseList_Item._cont = ASN1Dict([
        ('mrb-ID', _MCMRBSetupResponseList_Item_mrb_ID),
        ('qosflow-setup', _MCMRBSetupResponseList_Item_qosflow_setup),
        ('qosflow-failed', _MCMRBSetupResponseList_Item_qosflow_failed),
        ('mBS-PDCP-COUNT', _MCMRBSetupResponseList_Item_mBS_PDCP_COUNT),
        ('iE-Extensions', _MCMRBSetupResponseList_Item_iE_Extensions),
        ])
    MCMRBSetupResponseList_Item._ext = []
    
    #-----< MCMRBSetupResponseList-Item-ExtIEs >-----#
    MCMRBSetupResponseList_Item_ExtIEs = CLASS(name='MCMRBSetupResponseList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MCMRBSetupResponseList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-PDCP-COUNT >-----#
    MBS_PDCP_COUNT = BIT_STR(name='MBS-PDCP-COUNT', mode=MODE_TYPE)
    MBS_PDCP_COUNT._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< MCMRBFailedList >-----#
    MCMRBFailedList = SEQ_OF(name='MCMRBFailedList', mode=MODE_TYPE)
    _MCMRBFailedList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCMRBFailedList-Item')))
    MCMRBFailedList._cont = _MCMRBFailedList__item_
    MCMRBFailedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MCMRBFailedList-Item >-----#
    MCMRBFailedList_Item = SEQ(name='MCMRBFailedList-Item', mode=MODE_TYPE)
    _MCMRBFailedList_Item_mrb_ID = INT(name='mrb-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MRB-ID')))
    _MCMRBFailedList_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _MCMRBFailedList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MCMRBFailedList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MCMRBFailedList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MCMRBFailedList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCMRBFailedList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCMRBFailedList_Item_iE_Extensions__item__id._const_tab = ____MCMRBFailedList_Item_iE_Extensions__item__id_tab
    ___MCMRBFailedList_Item_iE_Extensions__item__id._const_tab_at = None
    ___MCMRBFailedList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MCMRBFailedList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MCMRBFailedList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCMRBFailedList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCMRBFailedList_Item_iE_Extensions__item__criticality._const_tab = ____MCMRBFailedList_Item_iE_Extensions__item__criticality_tab
    ___MCMRBFailedList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MCMRBFailedList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MCMRBFailedList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MCMRBFailedList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCMRBFailedList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCMRBFailedList_Item_iE_Extensions__item__extensionValue._const_tab = ____MCMRBFailedList_Item_iE_Extensions__item__extensionValue_tab
    ___MCMRBFailedList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MCMRBFailedList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MCMRBFailedList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MCMRBFailedList_Item_iE_Extensions__item__id),
        ('criticality', ___MCMRBFailedList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MCMRBFailedList_Item_iE_Extensions__item__extensionValue),
        ])
    __MCMRBFailedList_Item_iE_Extensions__item_._ext = None
    _MCMRBFailedList_Item_iE_Extensions._cont = __MCMRBFailedList_Item_iE_Extensions__item_
    _MCMRBFailedList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MCMRBFailedList_Item._cont = ASN1Dict([
        ('mrb-ID', _MCMRBFailedList_Item_mrb_ID),
        ('cause', _MCMRBFailedList_Item_cause),
        ('iE-Extensions', _MCMRBFailedList_Item_iE_Extensions),
        ])
    MCMRBFailedList_Item._ext = []
    
    #-----< MCMRBFailedList-Item-ExtIEs >-----#
    MCMRBFailedList_Item_ExtIEs = CLASS(name='MCMRBFailedList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MCMRBFailedList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MCBearerContextToModify >-----#
    MCBearerContextToModify = SEQ(name='MCBearerContextToModify', mode=MODE_TYPE)
    _MCBearerContextToModify_mcBearerContextNGUTNLInfoat5GC = SEQ(name='mcBearerContextNGUTNLInfoat5GC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MCBearerContextNGUTNLInfoat5GC')), opt=True)
    _MCBearerContextToModify_mcBearerContextNGUTnlInfoatNGRANRequest = SEQ(name='mcBearerContextNGUTnlInfoatNGRANRequest', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MCBearerContextNGUTnlInfoatNGRANRequest')), opt=True)
    _MCBearerContextToModify_mbsMulticastF1UContextDescriptor = SEQ(name='mbsMulticastF1UContextDescriptor', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSMulticastF1UContextDescriptor')), opt=True)
    _MCBearerContextToModify_requestedAction = ENUM(name='requestedAction', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'RequestedAction4AvailNGUTermination')), opt=True)
    _MCBearerContextToModify_mcMRBToSetupModifyList = SEQ_OF(name='mcMRBToSetupModifyList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MCMRBSetupModifyConfiguration')), opt=True)
    _MCBearerContextToModify_mcMRBToRemoveList = SEQ_OF(name='mcMRBToRemoveList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MCMRBRemoveConfiguration')), opt=True)
    _MCBearerContextToModify_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MCBearerContextToModify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MCBearerContextToModify_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MCBearerContextToModify_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____MCBearerContextToModify_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCForwardingResourceRequest')))
    _____MCBearerContextToModify_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCForwardingResourceIndication')))
    _____MCBearerContextToModify_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCForwardingResourceRelease')))
    _____MCBearerContextToModify_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MBSSessionAssociatedInfoNonSupportToSupport')))
    ____MCBearerContextToModify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 179), ('criticality', 'ignore'), ('Extension', _____MCBearerContextToModify_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 180), ('criticality', 'ignore'), ('Extension', _____MCBearerContextToModify_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 182), ('criticality', 'ignore'), ('Extension', _____MCBearerContextToModify_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 185), ('criticality', 'ignore'), ('Extension', _____MCBearerContextToModify_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MCBearerContextToModify_iE_Extensions__item__id._const_tab = ____MCBearerContextToModify_iE_Extensions__item__id_tab
    ___MCBearerContextToModify_iE_Extensions__item__id._const_tab_at = None
    ___MCBearerContextToModify_iE_Extensions__item__id._const_tab_id = 'id'
    ___MCBearerContextToModify_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___MCBearerContextToModify_iE_Extensions__item__criticality._const_tab = ____MCBearerContextToModify_iE_Extensions__item__id_tab
    ___MCBearerContextToModify_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MCBearerContextToModify_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MCBearerContextToModify_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___MCBearerContextToModify_iE_Extensions__item__extensionValue._const_tab = ____MCBearerContextToModify_iE_Extensions__item__id_tab
    ___MCBearerContextToModify_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MCBearerContextToModify_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MCBearerContextToModify_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MCBearerContextToModify_iE_Extensions__item__id),
        ('criticality', ___MCBearerContextToModify_iE_Extensions__item__criticality),
        ('extensionValue', ___MCBearerContextToModify_iE_Extensions__item__extensionValue),
        ])
    __MCBearerContextToModify_iE_Extensions__item_._ext = None
    _MCBearerContextToModify_iE_Extensions._cont = __MCBearerContextToModify_iE_Extensions__item_
    _MCBearerContextToModify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MCBearerContextToModify._cont = ASN1Dict([
        ('mcBearerContextNGUTNLInfoat5GC', _MCBearerContextToModify_mcBearerContextNGUTNLInfoat5GC),
        ('mcBearerContextNGUTnlInfoatNGRANRequest', _MCBearerContextToModify_mcBearerContextNGUTnlInfoatNGRANRequest),
        ('mbsMulticastF1UContextDescriptor', _MCBearerContextToModify_mbsMulticastF1UContextDescriptor),
        ('requestedAction', _MCBearerContextToModify_requestedAction),
        ('mcMRBToSetupModifyList', _MCBearerContextToModify_mcMRBToSetupModifyList),
        ('mcMRBToRemoveList', _MCBearerContextToModify_mcMRBToRemoveList),
        ('iE-Extensions', _MCBearerContextToModify_iE_Extensions),
        ])
    MCBearerContextToModify._ext = []
    
    #-----< MCBearerContextToModify-ExtIEs >-----#
    MCBearerContextToModify_ExtIEs = CLASS(name='MCBearerContextToModify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _MCBearerContextToModify_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCForwardingResourceRequest')))
    _MCBearerContextToModify_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCForwardingResourceIndication')))
    _MCBearerContextToModify_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCForwardingResourceRelease')))
    _MCBearerContextToModify_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MBSSessionAssociatedInfoNonSupportToSupport')))
    MCBearerContextToModify_ExtIEs._val = ASN1Set(rv=[dict([('id', 179), ('criticality', 'ignore'), ('Extension', _MCBearerContextToModify_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 180), ('criticality', 'ignore'), ('Extension', _MCBearerContextToModify_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 182), ('criticality', 'ignore'), ('Extension', _MCBearerContextToModify_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 185), ('criticality', 'ignore'), ('Extension', _MCBearerContextToModify_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MCBearerContextNGUTNLInfoat5GC >-----#
    MCBearerContextNGUTNLInfoat5GC = SEQ(name='MCBearerContextNGUTNLInfoat5GC', mode=MODE_TYPE)
    _MCBearerContextNGUTNLInfoat5GC_mbsNGUInformationAt5GC = CHOICE(name='mbsNGUInformationAt5GC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSNGUInformationAt5GC')))
    _MCBearerContextNGUTNLInfoat5GC_mbsAreaSession_ID = INT(name='mbsAreaSession-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSAreaSessionID')), opt=True)
    _MCBearerContextNGUTNLInfoat5GC_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__id._const_tab = ____MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__id_tab
    ___MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__id._const_tab_at = None
    ___MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__id._const_tab_id = 'id'
    ___MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__criticality._const_tab = ____MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__criticality_tab
    ___MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__extensionValue._const_tab = ____MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__extensionValue_tab
    ___MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__id),
        ('criticality', ___MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__criticality),
        ('extensionValue', ___MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__extensionValue),
        ])
    __MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item_._ext = None
    _MCBearerContextNGUTNLInfoat5GC_iE_Extensions._cont = __MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item_
    _MCBearerContextNGUTNLInfoat5GC_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MCBearerContextNGUTNLInfoat5GC._cont = ASN1Dict([
        ('mbsNGUInformationAt5GC', _MCBearerContextNGUTNLInfoat5GC_mbsNGUInformationAt5GC),
        ('mbsAreaSession-ID', _MCBearerContextNGUTNLInfoat5GC_mbsAreaSession_ID),
        ('iE-Extensions', _MCBearerContextNGUTNLInfoat5GC_iE_Extensions),
        ])
    MCBearerContextNGUTNLInfoat5GC._ext = []
    
    #-----< MCBearerContextNGUTNLInfoat5GC-ExtIEs >-----#
    MCBearerContextNGUTNLInfoat5GC_ExtIEs = CLASS(name='MCBearerContextNGUTNLInfoat5GC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MCBearerContextNGUTNLInfoat5GC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MCBearerContextNGUTnlInfoatNGRANRequest >-----#
    MCBearerContextNGUTnlInfoatNGRANRequest = SEQ(name='MCBearerContextNGUTnlInfoatNGRANRequest', mode=MODE_TYPE)
    _MCBearerContextNGUTnlInfoatNGRANRequest_ngRANNGUTNLRequested = ENUM(name='ngRANNGUTNLRequested', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MCBearerContextNGUTnlInfoatNGRANRequest_ngRANNGUTNLRequested._cont = ASN1Dict([('requested', 0)])
    _MCBearerContextNGUTnlInfoatNGRANRequest_ngRANNGUTNLRequested._ext = []
    _MCBearerContextNGUTnlInfoatNGRANRequest_mbsAreaSession_ID = INT(name='mbsAreaSession-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSAreaSessionID')), opt=True)
    _MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__id._const_tab = ____MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__id_tab
    ___MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__id._const_tab_at = None
    ___MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__id._const_tab_id = 'id'
    ___MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__criticality._const_tab = ____MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__criticality_tab
    ___MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__extensionValue._const_tab = ____MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__extensionValue_tab
    ___MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__id),
        ('criticality', ___MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__criticality),
        ('extensionValue', ___MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__extensionValue),
        ])
    __MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item_._ext = None
    _MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions._cont = __MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item_
    _MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MCBearerContextNGUTnlInfoatNGRANRequest._cont = ASN1Dict([
        ('ngRANNGUTNLRequested', _MCBearerContextNGUTnlInfoatNGRANRequest_ngRANNGUTNLRequested),
        ('mbsAreaSession-ID', _MCBearerContextNGUTnlInfoatNGRANRequest_mbsAreaSession_ID),
        ('iE-Extensions', _MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions),
        ])
    MCBearerContextNGUTnlInfoatNGRANRequest._ext = []
    
    #-----< MCBearerContextNGUTnlInfoatNGRANRequest-ExtIEs >-----#
    MCBearerContextNGUTnlInfoatNGRANRequest_ExtIEs = CLASS(name='MCBearerContextNGUTnlInfoatNGRANRequest-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MCBearerContextNGUTnlInfoatNGRANRequest_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MCMRBSetupModifyConfiguration >-----#
    MCMRBSetupModifyConfiguration = SEQ_OF(name='MCMRBSetupModifyConfiguration', mode=MODE_TYPE)
    _MCMRBSetupModifyConfiguration__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCMRBSetupModifyConfiguration-Item')))
    MCMRBSetupModifyConfiguration._cont = _MCMRBSetupModifyConfiguration__item_
    MCMRBSetupModifyConfiguration._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MCMRBSetupModifyConfiguration-Item >-----#
    MCMRBSetupModifyConfiguration_Item = SEQ(name='MCMRBSetupModifyConfiguration-Item', mode=MODE_TYPE)
    _MCMRBSetupModifyConfiguration_Item_mrb_ID = INT(name='mrb-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MRB-ID')))
    _MCMRBSetupModifyConfiguration_Item_f1uTNLatDU = SEQ(name='f1uTNLatDU', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MCBearerContextF1UTNLInfoatDU')), opt=True)
    _MCMRBSetupModifyConfiguration_Item_sdap_config = SEQ(name='sdap-config', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'SDAP-Configuration')), opt=True)
    _MCMRBSetupModifyConfiguration_Item_mbs_pdcp_config = SEQ(name='mbs-pdcp-config', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-Configuration')), opt=True)
    _MCMRBSetupModifyConfiguration_Item_qoS_Flow_QoS_Parameter_List = SEQ_OF(name='qoS-Flow-QoS-Parameter-List', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-QoS-Parameter-List')), opt=True)
    _MCMRBSetupModifyConfiguration_Item_mrbQoS = SEQ(name='mrbQoS', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoSFlowLevelQoSParameters')), opt=True)
    _MCMRBSetupModifyConfiguration_Item_mbs_PDCP_COUNT_Req = ENUM(name='mbs-PDCP-COUNT-Req', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBS-PDCP-COUNT-Req')), opt=True)
    _MCMRBSetupModifyConfiguration_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MCMRBSetupModifyConfiguration_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__id._const_tab = ____MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__id_tab
    ___MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__id._const_tab_at = None
    ___MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__criticality._const_tab = ____MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__criticality_tab
    ___MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__extensionValue._const_tab = ____MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__extensionValue_tab
    ___MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MCMRBSetupModifyConfiguration_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__id),
        ('criticality', ___MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__extensionValue),
        ])
    __MCMRBSetupModifyConfiguration_Item_iE_Extensions__item_._ext = None
    _MCMRBSetupModifyConfiguration_Item_iE_Extensions._cont = __MCMRBSetupModifyConfiguration_Item_iE_Extensions__item_
    _MCMRBSetupModifyConfiguration_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MCMRBSetupModifyConfiguration_Item._cont = ASN1Dict([
        ('mrb-ID', _MCMRBSetupModifyConfiguration_Item_mrb_ID),
        ('f1uTNLatDU', _MCMRBSetupModifyConfiguration_Item_f1uTNLatDU),
        ('sdap-config', _MCMRBSetupModifyConfiguration_Item_sdap_config),
        ('mbs-pdcp-config', _MCMRBSetupModifyConfiguration_Item_mbs_pdcp_config),
        ('qoS-Flow-QoS-Parameter-List', _MCMRBSetupModifyConfiguration_Item_qoS_Flow_QoS_Parameter_List),
        ('mrbQoS', _MCMRBSetupModifyConfiguration_Item_mrbQoS),
        ('mbs-PDCP-COUNT-Req', _MCMRBSetupModifyConfiguration_Item_mbs_PDCP_COUNT_Req),
        ('iE-Extensions', _MCMRBSetupModifyConfiguration_Item_iE_Extensions),
        ])
    MCMRBSetupModifyConfiguration_Item._ext = []
    
    #-----< MCMRBSetupModifyConfiguration-Item-ExtIEs >-----#
    MCMRBSetupModifyConfiguration_Item_ExtIEs = CLASS(name='MCMRBSetupModifyConfiguration-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MCMRBSetupModifyConfiguration_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MCBearerContextF1UTNLInfoatDU >-----#
    MCBearerContextF1UTNLInfoatDU = SEQ(name='MCBearerContextF1UTNLInfoatDU', mode=MODE_TYPE)
    _MCBearerContextF1UTNLInfoatDU_mbsF1UInfoatDU = CHOICE(name='mbsF1UInfoatDU', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _MCBearerContextF1UTNLInfoatDU_mbsMulticastF1UContextDescriptor = SEQ(name='mbsMulticastF1UContextDescriptor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSMulticastF1UContextDescriptor')))
    _MCBearerContextF1UTNLInfoatDU_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MCBearerContextF1UTNLInfoatDU_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__id._const_tab = ____MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__id_tab
    ___MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__id._const_tab_at = None
    ___MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__id._const_tab_id = 'id'
    ___MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__criticality._const_tab = ____MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__criticality_tab
    ___MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__extensionValue._const_tab = ____MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__extensionValue_tab
    ___MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MCBearerContextF1UTNLInfoatDU_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__id),
        ('criticality', ___MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__criticality),
        ('extensionValue', ___MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__extensionValue),
        ])
    __MCBearerContextF1UTNLInfoatDU_iE_Extensions__item_._ext = None
    _MCBearerContextF1UTNLInfoatDU_iE_Extensions._cont = __MCBearerContextF1UTNLInfoatDU_iE_Extensions__item_
    _MCBearerContextF1UTNLInfoatDU_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MCBearerContextF1UTNLInfoatDU._cont = ASN1Dict([
        ('mbsF1UInfoatDU', _MCBearerContextF1UTNLInfoatDU_mbsF1UInfoatDU),
        ('mbsMulticastF1UContextDescriptor', _MCBearerContextF1UTNLInfoatDU_mbsMulticastF1UContextDescriptor),
        ('iE-Extensions', _MCBearerContextF1UTNLInfoatDU_iE_Extensions),
        ])
    MCBearerContextF1UTNLInfoatDU._ext = []
    
    #-----< MCBearerContextF1UTNLInfoatDU-ExtIEs >-----#
    MCBearerContextF1UTNLInfoatDU_ExtIEs = CLASS(name='MCBearerContextF1UTNLInfoatDU-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MCBearerContextF1UTNLInfoatDU_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MulticastF1UContextReferenceE1 >-----#
    MulticastF1UContextReferenceE1 = OCT_STR(name='MulticastF1UContextReferenceE1', mode=MODE_TYPE)
    MulticastF1UContextReferenceE1._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< MBSMulticastF1UContextDescriptor >-----#
    MBSMulticastF1UContextDescriptor = SEQ(name='MBSMulticastF1UContextDescriptor', mode=MODE_TYPE)
    _MBSMulticastF1UContextDescriptor_multicastF1UContextReferenceE1 = OCT_STR(name='multicastF1UContextReferenceE1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MulticastF1UContextReferenceE1')))
    _MBSMulticastF1UContextDescriptor_mc_F1UCtxtusage = ENUM(name='mc-F1UCtxtusage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MBSMulticastF1UContextDescriptor_mc_F1UCtxtusage._cont = ASN1Dict([('ptm', 0), ('ptp', 1), ('ptp-retransmission', 2), ('ptp-forwarding', 3)])
    _MBSMulticastF1UContextDescriptor_mc_F1UCtxtusage._ext = []
    _MBSMulticastF1UContextDescriptor_mbsAreaSession = INT(name='mbsAreaSession', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSAreaSessionID')), opt=True)
    _MBSMulticastF1UContextDescriptor_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBSMulticastF1UContextDescriptor_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MBSMulticastF1UContextDescriptor_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBSMulticastF1UContextDescriptor_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__id._const_tab = ____MBSMulticastF1UContextDescriptor_iE_Extensions__item__id_tab
    ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__id._const_tab_at = None
    ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBSMulticastF1UContextDescriptor_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBSMulticastF1UContextDescriptor_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__criticality._const_tab = ____MBSMulticastF1UContextDescriptor_iE_Extensions__item__criticality_tab
    ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBSMulticastF1UContextDescriptor_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MBSMulticastF1UContextDescriptor_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__extensionValue._const_tab = ____MBSMulticastF1UContextDescriptor_iE_Extensions__item__extensionValue_tab
    ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBSMulticastF1UContextDescriptor_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__id),
        ('criticality', ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__criticality),
        ('extensionValue', ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__extensionValue),
        ])
    __MBSMulticastF1UContextDescriptor_iE_Extensions__item_._ext = None
    _MBSMulticastF1UContextDescriptor_iE_Extensions._cont = __MBSMulticastF1UContextDescriptor_iE_Extensions__item_
    _MBSMulticastF1UContextDescriptor_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBSMulticastF1UContextDescriptor._cont = ASN1Dict([
        ('multicastF1UContextReferenceE1', _MBSMulticastF1UContextDescriptor_multicastF1UContextReferenceE1),
        ('mc-F1UCtxtusage', _MBSMulticastF1UContextDescriptor_mc_F1UCtxtusage),
        ('mbsAreaSession', _MBSMulticastF1UContextDescriptor_mbsAreaSession),
        ('iE-Extensions', _MBSMulticastF1UContextDescriptor_iE_Extensions),
        ])
    MBSMulticastF1UContextDescriptor._ext = []
    
    #-----< MBSMulticastF1UContextDescriptor-ExtIEs >-----#
    MBSMulticastF1UContextDescriptor_ExtIEs = CLASS(name='MBSMulticastF1UContextDescriptor-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MBSMulticastF1UContextDescriptor_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MCMRBRemoveConfiguration >-----#
    MCMRBRemoveConfiguration = SEQ_OF(name='MCMRBRemoveConfiguration', mode=MODE_TYPE)
    _MCMRBRemoveConfiguration__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MRB-ID')))
    MCMRBRemoveConfiguration._cont = _MCMRBRemoveConfiguration__item_
    MCMRBRemoveConfiguration._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MBS-PDCP-COUNT-Req >-----#
    MBS_PDCP_COUNT_Req = ENUM(name='MBS-PDCP-COUNT-Req', mode=MODE_TYPE)
    MBS_PDCP_COUNT_Req._cont = ASN1Dict([('true', 0)])
    MBS_PDCP_COUNT_Req._ext = []
    
    #-----< MCBearerContextToModifyResponse >-----#
    MCBearerContextToModifyResponse = SEQ(name='MCBearerContextToModifyResponse', mode=MODE_TYPE)
    _MCBearerContextToModifyResponse_mcBearerContextNGU_TNLInfoatNGRANModifyResponse = SEQ(name='mcBearerContextNGU-TNLInfoatNGRANModifyResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MCBearerContextNGU-TNLInfoatNGRANModifyResponse')), opt=True)
    _MCBearerContextToModifyResponse_mbsMulticastF1UContextDescriptor = SEQ(name='mbsMulticastF1UContextDescriptor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSMulticastF1UContextDescriptor')), opt=True)
    _MCBearerContextToModifyResponse_mcMRBModifySetupResponseList = SEQ_OF(name='mcMRBModifySetupResponseList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MCMRBSetupModifyResponseList')), opt=True)
    _MCBearerContextToModifyResponse_mcMRBFailedList = SEQ_OF(name='mcMRBFailedList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MCMRBFailedList')), opt=True)
    _MCBearerContextToModifyResponse_availableMCMRBConfig = SEQ_OF(name='availableMCMRBConfig', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MCMRBSetupConfiguration')), opt=True)
    _MCBearerContextToModifyResponse_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MCBearerContextToModifyResponse_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MCBearerContextToModifyResponse_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MCBearerContextToModifyResponse_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____MCBearerContextToModifyResponse_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCForwardingResourceResponse')))
    ____MCBearerContextToModifyResponse_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 181), ('criticality', 'ignore'), ('Extension', _____MCBearerContextToModifyResponse_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MCBearerContextToModifyResponse_iE_Extensions__item__id._const_tab = ____MCBearerContextToModifyResponse_iE_Extensions__item__id_tab
    ___MCBearerContextToModifyResponse_iE_Extensions__item__id._const_tab_at = None
    ___MCBearerContextToModifyResponse_iE_Extensions__item__id._const_tab_id = 'id'
    ___MCBearerContextToModifyResponse_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___MCBearerContextToModifyResponse_iE_Extensions__item__criticality._const_tab = ____MCBearerContextToModifyResponse_iE_Extensions__item__id_tab
    ___MCBearerContextToModifyResponse_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MCBearerContextToModifyResponse_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MCBearerContextToModifyResponse_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___MCBearerContextToModifyResponse_iE_Extensions__item__extensionValue._const_tab = ____MCBearerContextToModifyResponse_iE_Extensions__item__id_tab
    ___MCBearerContextToModifyResponse_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MCBearerContextToModifyResponse_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MCBearerContextToModifyResponse_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MCBearerContextToModifyResponse_iE_Extensions__item__id),
        ('criticality', ___MCBearerContextToModifyResponse_iE_Extensions__item__criticality),
        ('extensionValue', ___MCBearerContextToModifyResponse_iE_Extensions__item__extensionValue),
        ])
    __MCBearerContextToModifyResponse_iE_Extensions__item_._ext = None
    _MCBearerContextToModifyResponse_iE_Extensions._cont = __MCBearerContextToModifyResponse_iE_Extensions__item_
    _MCBearerContextToModifyResponse_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MCBearerContextToModifyResponse._cont = ASN1Dict([
        ('mcBearerContextNGU-TNLInfoatNGRANModifyResponse', _MCBearerContextToModifyResponse_mcBearerContextNGU_TNLInfoatNGRANModifyResponse),
        ('mbsMulticastF1UContextDescriptor', _MCBearerContextToModifyResponse_mbsMulticastF1UContextDescriptor),
        ('mcMRBModifySetupResponseList', _MCBearerContextToModifyResponse_mcMRBModifySetupResponseList),
        ('mcMRBFailedList', _MCBearerContextToModifyResponse_mcMRBFailedList),
        ('availableMCMRBConfig', _MCBearerContextToModifyResponse_availableMCMRBConfig),
        ('iE-Extensions', _MCBearerContextToModifyResponse_iE_Extensions),
        ])
    MCBearerContextToModifyResponse._ext = []
    
    #-----< MCBearerContextToModifyResponse-ExtIEs >-----#
    MCBearerContextToModifyResponse_ExtIEs = CLASS(name='MCBearerContextToModifyResponse-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _MCBearerContextToModifyResponse_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCForwardingResourceResponse')))
    MCBearerContextToModifyResponse_ExtIEs._val = ASN1Set(rv=[dict([('id', 181), ('criticality', 'ignore'), ('Extension', _MCBearerContextToModifyResponse_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MCBearerContextNGU-TNLInfoatNGRANModifyResponse >-----#
    MCBearerContextNGU_TNLInfoatNGRANModifyResponse = SEQ(name='MCBearerContextNGU-TNLInfoatNGRANModifyResponse', mode=MODE_TYPE)
    _MCBearerContextNGU_TNLInfoatNGRANModifyResponse_mbs_NGU_InfoatNGRAN = CHOICE(name='mbs-NGU-InfoatNGRAN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSNGUInformationAtNGRAN')))
    _MCBearerContextNGU_TNLInfoatNGRANModifyResponse_mbsAreaSession = INT(name='mbsAreaSession', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSAreaSessionID')), opt=True)
    _MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__id._const_tab = ____MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__id_tab
    ___MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__id._const_tab_at = None
    ___MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__id._const_tab_id = 'id'
    ___MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__criticality._const_tab = ____MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__criticality_tab
    ___MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__extensionValue._const_tab = ____MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__extensionValue_tab
    ___MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__id),
        ('criticality', ___MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__criticality),
        ('extensionValue', ___MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__extensionValue),
        ])
    __MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item_._ext = None
    _MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions._cont = __MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item_
    _MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MCBearerContextNGU_TNLInfoatNGRANModifyResponse._cont = ASN1Dict([
        ('mbs-NGU-InfoatNGRAN', _MCBearerContextNGU_TNLInfoatNGRANModifyResponse_mbs_NGU_InfoatNGRAN),
        ('mbsAreaSession', _MCBearerContextNGU_TNLInfoatNGRANModifyResponse_mbsAreaSession),
        ('iE-Extensions', _MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions),
        ])
    MCBearerContextNGU_TNLInfoatNGRANModifyResponse._ext = []
    
    #-----< MCBearerContextNGU-TNLInfoatNGRANModifyResponse-ExtIEs >-----#
    MCBearerContextNGU_TNLInfoatNGRANModifyResponse_ExtIEs = CLASS(name='MCBearerContextNGU-TNLInfoatNGRANModifyResponse-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MCBearerContextNGU_TNLInfoatNGRANModifyResponse_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MCMRBSetupModifyResponseList >-----#
    MCMRBSetupModifyResponseList = SEQ_OF(name='MCMRBSetupModifyResponseList', mode=MODE_TYPE)
    _MCMRBSetupModifyResponseList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCMRBSetupModifyResponseList-Item')))
    MCMRBSetupModifyResponseList._cont = _MCMRBSetupModifyResponseList__item_
    MCMRBSetupModifyResponseList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MCMRBSetupModifyResponseList-Item >-----#
    MCMRBSetupModifyResponseList_Item = SEQ(name='MCMRBSetupModifyResponseList-Item', mode=MODE_TYPE)
    _MCMRBSetupModifyResponseList_Item_mrb_ID = INT(name='mrb-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MRB-ID')))
    _MCMRBSetupModifyResponseList_Item_qosflow_setup = SEQ_OF(name='qosflow-setup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-List')), opt=True)
    _MCMRBSetupModifyResponseList_Item_qosflow_failed = SEQ_OF(name='qosflow-failed', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Failed-List')), opt=True)
    _MCMRBSetupModifyResponseList_Item_mcBearerContextF1UTNLInfoatCU = CHOICE(name='mcBearerContextF1UTNLInfoatCU', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')), opt=True)
    _MCMRBSetupModifyResponseList_Item_mBS_PDCP_COUNT = BIT_STR(name='mBS-PDCP-COUNT', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBS-PDCP-COUNT')), opt=True)
    _MCMRBSetupModifyResponseList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MCMRBSetupModifyResponseList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MCMRBSetupModifyResponseList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MCMRBSetupModifyResponseList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCMRBSetupModifyResponseList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCMRBSetupModifyResponseList_Item_iE_Extensions__item__id._const_tab = ____MCMRBSetupModifyResponseList_Item_iE_Extensions__item__id_tab
    ___MCMRBSetupModifyResponseList_Item_iE_Extensions__item__id._const_tab_at = None
    ___MCMRBSetupModifyResponseList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MCMRBSetupModifyResponseList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MCMRBSetupModifyResponseList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCMRBSetupModifyResponseList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCMRBSetupModifyResponseList_Item_iE_Extensions__item__criticality._const_tab = ____MCMRBSetupModifyResponseList_Item_iE_Extensions__item__criticality_tab
    ___MCMRBSetupModifyResponseList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MCMRBSetupModifyResponseList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MCMRBSetupModifyResponseList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MCMRBSetupModifyResponseList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCMRBSetupModifyResponseList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCMRBSetupModifyResponseList_Item_iE_Extensions__item__extensionValue._const_tab = ____MCMRBSetupModifyResponseList_Item_iE_Extensions__item__extensionValue_tab
    ___MCMRBSetupModifyResponseList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MCMRBSetupModifyResponseList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MCMRBSetupModifyResponseList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MCMRBSetupModifyResponseList_Item_iE_Extensions__item__id),
        ('criticality', ___MCMRBSetupModifyResponseList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MCMRBSetupModifyResponseList_Item_iE_Extensions__item__extensionValue),
        ])
    __MCMRBSetupModifyResponseList_Item_iE_Extensions__item_._ext = None
    _MCMRBSetupModifyResponseList_Item_iE_Extensions._cont = __MCMRBSetupModifyResponseList_Item_iE_Extensions__item_
    _MCMRBSetupModifyResponseList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MCMRBSetupModifyResponseList_Item._cont = ASN1Dict([
        ('mrb-ID', _MCMRBSetupModifyResponseList_Item_mrb_ID),
        ('qosflow-setup', _MCMRBSetupModifyResponseList_Item_qosflow_setup),
        ('qosflow-failed', _MCMRBSetupModifyResponseList_Item_qosflow_failed),
        ('mcBearerContextF1UTNLInfoatCU', _MCMRBSetupModifyResponseList_Item_mcBearerContextF1UTNLInfoatCU),
        ('mBS-PDCP-COUNT', _MCMRBSetupModifyResponseList_Item_mBS_PDCP_COUNT),
        ('iE-Extensions', _MCMRBSetupModifyResponseList_Item_iE_Extensions),
        ])
    MCMRBSetupModifyResponseList_Item._ext = []
    
    #-----< MCMRBSetupModifyResponseList-Item-ExtIEs >-----#
    MCMRBSetupModifyResponseList_Item_ExtIEs = CLASS(name='MCMRBSetupModifyResponseList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MCMRBSetupModifyResponseList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MCBearerContextToModifyRequired >-----#
    MCBearerContextToModifyRequired = SEQ(name='MCBearerContextToModifyRequired', mode=MODE_TYPE)
    _MCBearerContextToModifyRequired_mbsMulticastF1UContextDescriptor = SEQ(name='mbsMulticastF1UContextDescriptor', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSMulticastF1UContextDescriptor')), opt=True)
    _MCBearerContextToModifyRequired_mcMRBToRemoveRequiredList = SEQ_OF(name='mcMRBToRemoveRequiredList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MCMRBRemoveConfiguration')), opt=True)
    _MCBearerContextToModifyRequired_mcMRBToModifyRequiredList = SEQ_OF(name='mcMRBToModifyRequiredList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MCMRBModifyRequiredConfiguration')), opt=True)
    _MCBearerContextToModifyRequired_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MCBearerContextToModifyRequired_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MCBearerContextToModifyRequired_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MCBearerContextToModifyRequired_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____MCBearerContextToModifyRequired_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCForwardingResourceReleaseIndication')))
    ____MCBearerContextToModifyRequired_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 183), ('criticality', 'ignore'), ('Extension', _____MCBearerContextToModifyRequired_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MCBearerContextToModifyRequired_iE_Extensions__item__id._const_tab = ____MCBearerContextToModifyRequired_iE_Extensions__item__id_tab
    ___MCBearerContextToModifyRequired_iE_Extensions__item__id._const_tab_at = None
    ___MCBearerContextToModifyRequired_iE_Extensions__item__id._const_tab_id = 'id'
    ___MCBearerContextToModifyRequired_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___MCBearerContextToModifyRequired_iE_Extensions__item__criticality._const_tab = ____MCBearerContextToModifyRequired_iE_Extensions__item__id_tab
    ___MCBearerContextToModifyRequired_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MCBearerContextToModifyRequired_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MCBearerContextToModifyRequired_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___MCBearerContextToModifyRequired_iE_Extensions__item__extensionValue._const_tab = ____MCBearerContextToModifyRequired_iE_Extensions__item__id_tab
    ___MCBearerContextToModifyRequired_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MCBearerContextToModifyRequired_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MCBearerContextToModifyRequired_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MCBearerContextToModifyRequired_iE_Extensions__item__id),
        ('criticality', ___MCBearerContextToModifyRequired_iE_Extensions__item__criticality),
        ('extensionValue', ___MCBearerContextToModifyRequired_iE_Extensions__item__extensionValue),
        ])
    __MCBearerContextToModifyRequired_iE_Extensions__item_._ext = None
    _MCBearerContextToModifyRequired_iE_Extensions._cont = __MCBearerContextToModifyRequired_iE_Extensions__item_
    _MCBearerContextToModifyRequired_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MCBearerContextToModifyRequired._cont = ASN1Dict([
        ('mbsMulticastF1UContextDescriptor', _MCBearerContextToModifyRequired_mbsMulticastF1UContextDescriptor),
        ('mcMRBToRemoveRequiredList', _MCBearerContextToModifyRequired_mcMRBToRemoveRequiredList),
        ('mcMRBToModifyRequiredList', _MCBearerContextToModifyRequired_mcMRBToModifyRequiredList),
        ('iE-Extensions', _MCBearerContextToModifyRequired_iE_Extensions),
        ])
    MCBearerContextToModifyRequired._ext = []
    
    #-----< MCBearerContextToModifyRequired-ExtIEs >-----#
    MCBearerContextToModifyRequired_ExtIEs = CLASS(name='MCBearerContextToModifyRequired-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _MCBearerContextToModifyRequired_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCForwardingResourceReleaseIndication')))
    MCBearerContextToModifyRequired_ExtIEs._val = ASN1Set(rv=[dict([('id', 183), ('criticality', 'ignore'), ('Extension', _MCBearerContextToModifyRequired_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MCMRBModifyRequiredConfiguration >-----#
    MCMRBModifyRequiredConfiguration = SEQ_OF(name='MCMRBModifyRequiredConfiguration', mode=MODE_TYPE)
    _MCMRBModifyRequiredConfiguration__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCMRBModifyRequiredConfiguration-Item')))
    MCMRBModifyRequiredConfiguration._cont = _MCMRBModifyRequiredConfiguration__item_
    MCMRBModifyRequiredConfiguration._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MCMRBModifyRequiredConfiguration-Item >-----#
    MCMRBModifyRequiredConfiguration_Item = SEQ(name='MCMRBModifyRequiredConfiguration-Item', mode=MODE_TYPE)
    _MCMRBModifyRequiredConfiguration_Item_mrb_ID = INT(name='mrb-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MRB-ID')))
    _MCMRBModifyRequiredConfiguration_Item_mBS_PDCP_COUNT = BIT_STR(name='mBS-PDCP-COUNT', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBS-PDCP-COUNT')), opt=True)
    _MCMRBModifyRequiredConfiguration_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__id._const_tab = ____MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__id_tab
    ___MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__id._const_tab_at = None
    ___MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__criticality._const_tab = ____MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__criticality_tab
    ___MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__extensionValue._const_tab = ____MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__extensionValue_tab
    ___MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__id),
        ('criticality', ___MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__extensionValue),
        ])
    __MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item_._ext = None
    _MCMRBModifyRequiredConfiguration_Item_iE_Extensions._cont = __MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item_
    _MCMRBModifyRequiredConfiguration_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MCMRBModifyRequiredConfiguration_Item._cont = ASN1Dict([
        ('mrb-ID', _MCMRBModifyRequiredConfiguration_Item_mrb_ID),
        ('mBS-PDCP-COUNT', _MCMRBModifyRequiredConfiguration_Item_mBS_PDCP_COUNT),
        ('iE-Extensions', _MCMRBModifyRequiredConfiguration_Item_iE_Extensions),
        ])
    MCMRBModifyRequiredConfiguration_Item._ext = []
    
    #-----< MCMRBModifyRequiredConfiguration-Item-ExtIEs >-----#
    MCMRBModifyRequiredConfiguration_Item_ExtIEs = CLASS(name='MCMRBModifyRequiredConfiguration-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MCMRBModifyRequiredConfiguration_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MCBearerContextToModifyConfirm >-----#
    MCBearerContextToModifyConfirm = SEQ(name='MCBearerContextToModifyConfirm', mode=MODE_TYPE)
    _MCBearerContextToModifyConfirm_mbsMulticastF1UContextDescriptor = SEQ(name='mbsMulticastF1UContextDescriptor', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSMulticastF1UContextDescriptor')), opt=True)
    _MCBearerContextToModifyConfirm_mcMRBModifyConfirmList = SEQ_OF(name='mcMRBModifyConfirmList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MCMRBModifyConfirmList')), opt=True)
    _MCBearerContextToModifyConfirm_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MCBearerContextToModifyConfirm_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MCBearerContextToModifyConfirm_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MCBearerContextToModifyConfirm_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCBearerContextToModifyConfirm_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCBearerContextToModifyConfirm_iE_Extensions__item__id._const_tab = ____MCBearerContextToModifyConfirm_iE_Extensions__item__id_tab
    ___MCBearerContextToModifyConfirm_iE_Extensions__item__id._const_tab_at = None
    ___MCBearerContextToModifyConfirm_iE_Extensions__item__id._const_tab_id = 'id'
    ___MCBearerContextToModifyConfirm_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MCBearerContextToModifyConfirm_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCBearerContextToModifyConfirm_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCBearerContextToModifyConfirm_iE_Extensions__item__criticality._const_tab = ____MCBearerContextToModifyConfirm_iE_Extensions__item__criticality_tab
    ___MCBearerContextToModifyConfirm_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MCBearerContextToModifyConfirm_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MCBearerContextToModifyConfirm_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MCBearerContextToModifyConfirm_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCBearerContextToModifyConfirm_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCBearerContextToModifyConfirm_iE_Extensions__item__extensionValue._const_tab = ____MCBearerContextToModifyConfirm_iE_Extensions__item__extensionValue_tab
    ___MCBearerContextToModifyConfirm_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MCBearerContextToModifyConfirm_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MCBearerContextToModifyConfirm_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MCBearerContextToModifyConfirm_iE_Extensions__item__id),
        ('criticality', ___MCBearerContextToModifyConfirm_iE_Extensions__item__criticality),
        ('extensionValue', ___MCBearerContextToModifyConfirm_iE_Extensions__item__extensionValue),
        ])
    __MCBearerContextToModifyConfirm_iE_Extensions__item_._ext = None
    _MCBearerContextToModifyConfirm_iE_Extensions._cont = __MCBearerContextToModifyConfirm_iE_Extensions__item_
    _MCBearerContextToModifyConfirm_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MCBearerContextToModifyConfirm._cont = ASN1Dict([
        ('mbsMulticastF1UContextDescriptor', _MCBearerContextToModifyConfirm_mbsMulticastF1UContextDescriptor),
        ('mcMRBModifyConfirmList', _MCBearerContextToModifyConfirm_mcMRBModifyConfirmList),
        ('iE-Extensions', _MCBearerContextToModifyConfirm_iE_Extensions),
        ])
    MCBearerContextToModifyConfirm._ext = []
    
    #-----< MCMRBModifyConfirmList >-----#
    MCMRBModifyConfirmList = SEQ_OF(name='MCMRBModifyConfirmList', mode=MODE_TYPE)
    _MCMRBModifyConfirmList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCMRBModifyConfirmList-Item')))
    MCMRBModifyConfirmList._cont = _MCMRBModifyConfirmList__item_
    MCMRBModifyConfirmList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MCMRBModifyConfirmList-Item >-----#
    MCMRBModifyConfirmList_Item = SEQ(name='MCMRBModifyConfirmList-Item', mode=MODE_TYPE)
    _MCMRBModifyConfirmList_Item_mrb_ID = INT(name='mrb-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MRB-ID')))
    _MCMRBModifyConfirmList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MCMRBModifyConfirmList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MCMRBModifyConfirmList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MCMRBModifyConfirmList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCMRBModifyConfirmList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCMRBModifyConfirmList_Item_iE_Extensions__item__id._const_tab = ____MCMRBModifyConfirmList_Item_iE_Extensions__item__id_tab
    ___MCMRBModifyConfirmList_Item_iE_Extensions__item__id._const_tab_at = None
    ___MCMRBModifyConfirmList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MCMRBModifyConfirmList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MCMRBModifyConfirmList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCMRBModifyConfirmList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCMRBModifyConfirmList_Item_iE_Extensions__item__criticality._const_tab = ____MCMRBModifyConfirmList_Item_iE_Extensions__item__criticality_tab
    ___MCMRBModifyConfirmList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MCMRBModifyConfirmList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MCMRBModifyConfirmList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MCMRBModifyConfirmList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCMRBModifyConfirmList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCMRBModifyConfirmList_Item_iE_Extensions__item__extensionValue._const_tab = ____MCMRBModifyConfirmList_Item_iE_Extensions__item__extensionValue_tab
    ___MCMRBModifyConfirmList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MCMRBModifyConfirmList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MCMRBModifyConfirmList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MCMRBModifyConfirmList_Item_iE_Extensions__item__id),
        ('criticality', ___MCMRBModifyConfirmList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MCMRBModifyConfirmList_Item_iE_Extensions__item__extensionValue),
        ])
    __MCMRBModifyConfirmList_Item_iE_Extensions__item_._ext = None
    _MCMRBModifyConfirmList_Item_iE_Extensions._cont = __MCMRBModifyConfirmList_Item_iE_Extensions__item_
    _MCMRBModifyConfirmList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MCMRBModifyConfirmList_Item._cont = ASN1Dict([
        ('mrb-ID', _MCMRBModifyConfirmList_Item_mrb_ID),
        ('iE-Extensions', _MCMRBModifyConfirmList_Item_iE_Extensions),
        ])
    MCMRBModifyConfirmList_Item._ext = []
    
    #-----< MCMRBModifyConfirmList-Item-ExtIEs >-----#
    MCMRBModifyConfirmList_Item_ExtIEs = CLASS(name='MCMRBModifyConfirmList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MCMRBModifyConfirmList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MCBearerContextToModifyConfirm-ExtIEs >-----#
    MCBearerContextToModifyConfirm_ExtIEs = CLASS(name='MCBearerContextToModifyConfirm-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MCBearerContextToModifyConfirm_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MCForwardingResourceRequest >-----#
    MCForwardingResourceRequest = SEQ(name='MCForwardingResourceRequest', mode=MODE_TYPE)
    _MCForwardingResourceRequest_mcForwardingResourceID = OCT_STR(name='mcForwardingResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MCForwardingResourceID')))
    _MCForwardingResourceRequest_mbsAreaSession_ID = INT(name='mbsAreaSession-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSAreaSessionID')), opt=True)
    _MCForwardingResourceRequest_mrbForwardingResourceRequestList = SEQ_OF(name='mrbForwardingResourceRequestList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MRBForwardingResourceRequestList')), opt=True)
    _MCForwardingResourceRequest_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MCForwardingResourceRequest_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MCForwardingResourceRequest_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MCForwardingResourceRequest_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCForwardingResourceRequest_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCForwardingResourceRequest_iE_Extensions__item__id._const_tab = ____MCForwardingResourceRequest_iE_Extensions__item__id_tab
    ___MCForwardingResourceRequest_iE_Extensions__item__id._const_tab_at = None
    ___MCForwardingResourceRequest_iE_Extensions__item__id._const_tab_id = 'id'
    ___MCForwardingResourceRequest_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MCForwardingResourceRequest_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCForwardingResourceRequest_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCForwardingResourceRequest_iE_Extensions__item__criticality._const_tab = ____MCForwardingResourceRequest_iE_Extensions__item__criticality_tab
    ___MCForwardingResourceRequest_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MCForwardingResourceRequest_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MCForwardingResourceRequest_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MCForwardingResourceRequest_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCForwardingResourceRequest_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCForwardingResourceRequest_iE_Extensions__item__extensionValue._const_tab = ____MCForwardingResourceRequest_iE_Extensions__item__extensionValue_tab
    ___MCForwardingResourceRequest_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MCForwardingResourceRequest_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MCForwardingResourceRequest_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MCForwardingResourceRequest_iE_Extensions__item__id),
        ('criticality', ___MCForwardingResourceRequest_iE_Extensions__item__criticality),
        ('extensionValue', ___MCForwardingResourceRequest_iE_Extensions__item__extensionValue),
        ])
    __MCForwardingResourceRequest_iE_Extensions__item_._ext = None
    _MCForwardingResourceRequest_iE_Extensions._cont = __MCForwardingResourceRequest_iE_Extensions__item_
    _MCForwardingResourceRequest_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MCForwardingResourceRequest._cont = ASN1Dict([
        ('mcForwardingResourceID', _MCForwardingResourceRequest_mcForwardingResourceID),
        ('mbsAreaSession-ID', _MCForwardingResourceRequest_mbsAreaSession_ID),
        ('mrbForwardingResourceRequestList', _MCForwardingResourceRequest_mrbForwardingResourceRequestList),
        ('iE-Extensions', _MCForwardingResourceRequest_iE_Extensions),
        ])
    MCForwardingResourceRequest._ext = []
    
    #-----< MCForwardingResourceRequest-ExtIEs >-----#
    MCForwardingResourceRequest_ExtIEs = CLASS(name='MCForwardingResourceRequest-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MCForwardingResourceRequest_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MRBForwardingResourceRequestList >-----#
    MRBForwardingResourceRequestList = SEQ_OF(name='MRBForwardingResourceRequestList', mode=MODE_TYPE)
    _MRBForwardingResourceRequestList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MRBForwardingResourceRequest-Item')))
    MRBForwardingResourceRequestList._cont = _MRBForwardingResourceRequestList__item_
    MRBForwardingResourceRequestList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< MRBForwardingResourceRequest-Item >-----#
    MRBForwardingResourceRequest_Item = SEQ(name='MRBForwardingResourceRequest-Item', mode=MODE_TYPE)
    _MRBForwardingResourceRequest_Item_mrb_ID = INT(name='mrb-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MRB-ID')))
    _MRBForwardingResourceRequest_Item_mrbProgressRequestType = ENUM(name='mrbProgressRequestType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MRB-ProgressInformationType')), opt=True)
    _MRBForwardingResourceRequest_Item_mrbForwardingAddressRequest = ENUM(name='mrbForwardingAddressRequest', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MRBForwardingResourceRequest_Item_mrbForwardingAddressRequest._cont = ASN1Dict([('request', 0)])
    _MRBForwardingResourceRequest_Item_mrbForwardingAddressRequest._ext = []
    _MRBForwardingResourceRequest_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MRBForwardingResourceRequest_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MRBForwardingResourceRequest_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MRBForwardingResourceRequest_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MRBForwardingResourceRequest_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MRBForwardingResourceRequest_Item_iE_Extensions__item__id._const_tab = ____MRBForwardingResourceRequest_Item_iE_Extensions__item__id_tab
    ___MRBForwardingResourceRequest_Item_iE_Extensions__item__id._const_tab_at = None
    ___MRBForwardingResourceRequest_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MRBForwardingResourceRequest_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MRBForwardingResourceRequest_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MRBForwardingResourceRequest_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MRBForwardingResourceRequest_Item_iE_Extensions__item__criticality._const_tab = ____MRBForwardingResourceRequest_Item_iE_Extensions__item__criticality_tab
    ___MRBForwardingResourceRequest_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MRBForwardingResourceRequest_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MRBForwardingResourceRequest_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MRBForwardingResourceRequest_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MRBForwardingResourceRequest_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MRBForwardingResourceRequest_Item_iE_Extensions__item__extensionValue._const_tab = ____MRBForwardingResourceRequest_Item_iE_Extensions__item__extensionValue_tab
    ___MRBForwardingResourceRequest_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MRBForwardingResourceRequest_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MRBForwardingResourceRequest_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MRBForwardingResourceRequest_Item_iE_Extensions__item__id),
        ('criticality', ___MRBForwardingResourceRequest_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MRBForwardingResourceRequest_Item_iE_Extensions__item__extensionValue),
        ])
    __MRBForwardingResourceRequest_Item_iE_Extensions__item_._ext = None
    _MRBForwardingResourceRequest_Item_iE_Extensions._cont = __MRBForwardingResourceRequest_Item_iE_Extensions__item_
    _MRBForwardingResourceRequest_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MRBForwardingResourceRequest_Item._cont = ASN1Dict([
        ('mrb-ID', _MRBForwardingResourceRequest_Item_mrb_ID),
        ('mrbProgressRequestType', _MRBForwardingResourceRequest_Item_mrbProgressRequestType),
        ('mrbForwardingAddressRequest', _MRBForwardingResourceRequest_Item_mrbForwardingAddressRequest),
        ('iE-Extensions', _MRBForwardingResourceRequest_Item_iE_Extensions),
        ])
    MRBForwardingResourceRequest_Item._ext = []
    
    #-----< MRBForwardingResourceRequest-Item-ExtIEs >-----#
    MRBForwardingResourceRequest_Item_ExtIEs = CLASS(name='MRBForwardingResourceRequest-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MRBForwardingResourceRequest_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MCForwardingResourceIndication >-----#
    MCForwardingResourceIndication = SEQ(name='MCForwardingResourceIndication', mode=MODE_TYPE)
    _MCForwardingResourceIndication_mcForwardingResourceID = OCT_STR(name='mcForwardingResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MCForwardingResourceID')))
    _MCForwardingResourceIndication_mrbForwardingResourceIndicationList = SEQ_OF(name='mrbForwardingResourceIndicationList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MRBForwardingResourceIndicationList')), opt=True)
    _MCForwardingResourceIndication_mbsSessionAssociatedInformation = SEQ(name='mbsSessionAssociatedInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MBSSessionAssociatedInformation')), opt=True)
    _MCForwardingResourceIndication_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MCForwardingResourceIndication_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MCForwardingResourceIndication_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MCForwardingResourceIndication_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCForwardingResourceIndication_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCForwardingResourceIndication_iE_Extensions__item__id._const_tab = ____MCForwardingResourceIndication_iE_Extensions__item__id_tab
    ___MCForwardingResourceIndication_iE_Extensions__item__id._const_tab_at = None
    ___MCForwardingResourceIndication_iE_Extensions__item__id._const_tab_id = 'id'
    ___MCForwardingResourceIndication_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MCForwardingResourceIndication_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCForwardingResourceIndication_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCForwardingResourceIndication_iE_Extensions__item__criticality._const_tab = ____MCForwardingResourceIndication_iE_Extensions__item__criticality_tab
    ___MCForwardingResourceIndication_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MCForwardingResourceIndication_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MCForwardingResourceIndication_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MCForwardingResourceIndication_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCForwardingResourceIndication_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCForwardingResourceIndication_iE_Extensions__item__extensionValue._const_tab = ____MCForwardingResourceIndication_iE_Extensions__item__extensionValue_tab
    ___MCForwardingResourceIndication_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MCForwardingResourceIndication_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MCForwardingResourceIndication_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MCForwardingResourceIndication_iE_Extensions__item__id),
        ('criticality', ___MCForwardingResourceIndication_iE_Extensions__item__criticality),
        ('extensionValue', ___MCForwardingResourceIndication_iE_Extensions__item__extensionValue),
        ])
    __MCForwardingResourceIndication_iE_Extensions__item_._ext = None
    _MCForwardingResourceIndication_iE_Extensions._cont = __MCForwardingResourceIndication_iE_Extensions__item_
    _MCForwardingResourceIndication_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MCForwardingResourceIndication._cont = ASN1Dict([
        ('mcForwardingResourceID', _MCForwardingResourceIndication_mcForwardingResourceID),
        ('mrbForwardingResourceIndicationList', _MCForwardingResourceIndication_mrbForwardingResourceIndicationList),
        ('mbsSessionAssociatedInformation', _MCForwardingResourceIndication_mbsSessionAssociatedInformation),
        ('iE-Extensions', _MCForwardingResourceIndication_iE_Extensions),
        ])
    MCForwardingResourceIndication._ext = []
    
    #-----< MCForwardingResourceIndication-ExtIEs >-----#
    MCForwardingResourceIndication_ExtIEs = CLASS(name='MCForwardingResourceIndication-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MCForwardingResourceIndication_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MRBForwardingResourceIndicationList >-----#
    MRBForwardingResourceIndicationList = SEQ_OF(name='MRBForwardingResourceIndicationList', mode=MODE_TYPE)
    _MRBForwardingResourceIndicationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MRBForwardingResourceIndication-Item')))
    MRBForwardingResourceIndicationList._cont = _MRBForwardingResourceIndicationList__item_
    MRBForwardingResourceIndicationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< MRBForwardingResourceIndication-Item >-----#
    MRBForwardingResourceIndication_Item = SEQ(name='MRBForwardingResourceIndication-Item', mode=MODE_TYPE)
    _MRBForwardingResourceIndication_Item_mrb_ID = INT(name='mrb-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MRB-ID')))
    _MRBForwardingResourceIndication_Item_mrb_ProgressInformation = SEQ(name='mrb-ProgressInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MRB-ProgressInformation')), opt=True)
    _MRBForwardingResourceIndication_Item_mrbForwardingAddress = CHOICE(name='mrbForwardingAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')), opt=True)
    _MRBForwardingResourceIndication_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MRBForwardingResourceIndication_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MRBForwardingResourceIndication_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MRBForwardingResourceIndication_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MRBForwardingResourceIndication_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MRBForwardingResourceIndication_Item_iE_Extensions__item__id._const_tab = ____MRBForwardingResourceIndication_Item_iE_Extensions__item__id_tab
    ___MRBForwardingResourceIndication_Item_iE_Extensions__item__id._const_tab_at = None
    ___MRBForwardingResourceIndication_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MRBForwardingResourceIndication_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MRBForwardingResourceIndication_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MRBForwardingResourceIndication_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MRBForwardingResourceIndication_Item_iE_Extensions__item__criticality._const_tab = ____MRBForwardingResourceIndication_Item_iE_Extensions__item__criticality_tab
    ___MRBForwardingResourceIndication_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MRBForwardingResourceIndication_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MRBForwardingResourceIndication_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MRBForwardingResourceIndication_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MRBForwardingResourceIndication_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MRBForwardingResourceIndication_Item_iE_Extensions__item__extensionValue._const_tab = ____MRBForwardingResourceIndication_Item_iE_Extensions__item__extensionValue_tab
    ___MRBForwardingResourceIndication_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MRBForwardingResourceIndication_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MRBForwardingResourceIndication_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MRBForwardingResourceIndication_Item_iE_Extensions__item__id),
        ('criticality', ___MRBForwardingResourceIndication_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MRBForwardingResourceIndication_Item_iE_Extensions__item__extensionValue),
        ])
    __MRBForwardingResourceIndication_Item_iE_Extensions__item_._ext = None
    _MRBForwardingResourceIndication_Item_iE_Extensions._cont = __MRBForwardingResourceIndication_Item_iE_Extensions__item_
    _MRBForwardingResourceIndication_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MRBForwardingResourceIndication_Item._cont = ASN1Dict([
        ('mrb-ID', _MRBForwardingResourceIndication_Item_mrb_ID),
        ('mrb-ProgressInformation', _MRBForwardingResourceIndication_Item_mrb_ProgressInformation),
        ('mrbForwardingAddress', _MRBForwardingResourceIndication_Item_mrbForwardingAddress),
        ('iE-Extensions', _MRBForwardingResourceIndication_Item_iE_Extensions),
        ])
    MRBForwardingResourceIndication_Item._ext = []
    
    #-----< MRBForwardingResourceIndication-Item-ExtIEs >-----#
    MRBForwardingResourceIndication_Item_ExtIEs = CLASS(name='MRBForwardingResourceIndication-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MRBForwardingResourceIndication_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MCForwardingResourceResponse >-----#
    MCForwardingResourceResponse = SEQ(name='MCForwardingResourceResponse', mode=MODE_TYPE)
    _MCForwardingResourceResponse_mcForwardingResourceID = OCT_STR(name='mcForwardingResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MCForwardingResourceID')))
    _MCForwardingResourceResponse_mrbForwardingResourceResponseList = SEQ_OF(name='mrbForwardingResourceResponseList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MRBForwardingResourceResponseList')), opt=True)
    _MCForwardingResourceResponse_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MCForwardingResourceResponse_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MCForwardingResourceResponse_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MCForwardingResourceResponse_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCForwardingResourceResponse_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCForwardingResourceResponse_iE_Extensions__item__id._const_tab = ____MCForwardingResourceResponse_iE_Extensions__item__id_tab
    ___MCForwardingResourceResponse_iE_Extensions__item__id._const_tab_at = None
    ___MCForwardingResourceResponse_iE_Extensions__item__id._const_tab_id = 'id'
    ___MCForwardingResourceResponse_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MCForwardingResourceResponse_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCForwardingResourceResponse_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCForwardingResourceResponse_iE_Extensions__item__criticality._const_tab = ____MCForwardingResourceResponse_iE_Extensions__item__criticality_tab
    ___MCForwardingResourceResponse_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MCForwardingResourceResponse_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MCForwardingResourceResponse_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MCForwardingResourceResponse_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCForwardingResourceResponse_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCForwardingResourceResponse_iE_Extensions__item__extensionValue._const_tab = ____MCForwardingResourceResponse_iE_Extensions__item__extensionValue_tab
    ___MCForwardingResourceResponse_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MCForwardingResourceResponse_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MCForwardingResourceResponse_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MCForwardingResourceResponse_iE_Extensions__item__id),
        ('criticality', ___MCForwardingResourceResponse_iE_Extensions__item__criticality),
        ('extensionValue', ___MCForwardingResourceResponse_iE_Extensions__item__extensionValue),
        ])
    __MCForwardingResourceResponse_iE_Extensions__item_._ext = None
    _MCForwardingResourceResponse_iE_Extensions._cont = __MCForwardingResourceResponse_iE_Extensions__item_
    _MCForwardingResourceResponse_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MCForwardingResourceResponse._cont = ASN1Dict([
        ('mcForwardingResourceID', _MCForwardingResourceResponse_mcForwardingResourceID),
        ('mrbForwardingResourceResponseList', _MCForwardingResourceResponse_mrbForwardingResourceResponseList),
        ('iE-Extensions', _MCForwardingResourceResponse_iE_Extensions),
        ])
    MCForwardingResourceResponse._ext = []
    
    #-----< MCForwardingResourceResponse-ExtIEs >-----#
    MCForwardingResourceResponse_ExtIEs = CLASS(name='MCForwardingResourceResponse-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MCForwardingResourceResponse_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MRBForwardingResourceResponseList >-----#
    MRBForwardingResourceResponseList = SEQ_OF(name='MRBForwardingResourceResponseList', mode=MODE_TYPE)
    _MRBForwardingResourceResponseList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MRBForwardingResourceResponse-Item')))
    MRBForwardingResourceResponseList._cont = _MRBForwardingResourceResponseList__item_
    MRBForwardingResourceResponseList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< MRBForwardingResourceResponse-Item >-----#
    MRBForwardingResourceResponse_Item = SEQ(name='MRBForwardingResourceResponse-Item', mode=MODE_TYPE)
    _MRBForwardingResourceResponse_Item_mrb_ID = INT(name='mrb-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MRB-ID')))
    _MRBForwardingResourceResponse_Item_mrb_ProgressInformation = SEQ(name='mrb-ProgressInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MRB-ProgressInformation')), opt=True)
    _MRBForwardingResourceResponse_Item_mrbForwardingAddress = CHOICE(name='mrbForwardingAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')), opt=True)
    _MRBForwardingResourceResponse_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MRBForwardingResourceResponse_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MRBForwardingResourceResponse_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MRBForwardingResourceResponse_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MRBForwardingResourceResponse_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MRBForwardingResourceResponse_Item_iE_Extensions__item__id._const_tab = ____MRBForwardingResourceResponse_Item_iE_Extensions__item__id_tab
    ___MRBForwardingResourceResponse_Item_iE_Extensions__item__id._const_tab_at = None
    ___MRBForwardingResourceResponse_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MRBForwardingResourceResponse_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MRBForwardingResourceResponse_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MRBForwardingResourceResponse_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MRBForwardingResourceResponse_Item_iE_Extensions__item__criticality._const_tab = ____MRBForwardingResourceResponse_Item_iE_Extensions__item__criticality_tab
    ___MRBForwardingResourceResponse_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MRBForwardingResourceResponse_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MRBForwardingResourceResponse_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MRBForwardingResourceResponse_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MRBForwardingResourceResponse_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MRBForwardingResourceResponse_Item_iE_Extensions__item__extensionValue._const_tab = ____MRBForwardingResourceResponse_Item_iE_Extensions__item__extensionValue_tab
    ___MRBForwardingResourceResponse_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MRBForwardingResourceResponse_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MRBForwardingResourceResponse_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MRBForwardingResourceResponse_Item_iE_Extensions__item__id),
        ('criticality', ___MRBForwardingResourceResponse_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MRBForwardingResourceResponse_Item_iE_Extensions__item__extensionValue),
        ])
    __MRBForwardingResourceResponse_Item_iE_Extensions__item_._ext = None
    _MRBForwardingResourceResponse_Item_iE_Extensions._cont = __MRBForwardingResourceResponse_Item_iE_Extensions__item_
    _MRBForwardingResourceResponse_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MRBForwardingResourceResponse_Item._cont = ASN1Dict([
        ('mrb-ID', _MRBForwardingResourceResponse_Item_mrb_ID),
        ('mrb-ProgressInformation', _MRBForwardingResourceResponse_Item_mrb_ProgressInformation),
        ('mrbForwardingAddress', _MRBForwardingResourceResponse_Item_mrbForwardingAddress),
        ('iE-Extensions', _MRBForwardingResourceResponse_Item_iE_Extensions),
        ])
    MRBForwardingResourceResponse_Item._ext = []
    
    #-----< MRBForwardingResourceResponse-Item-ExtIEs >-----#
    MRBForwardingResourceResponse_Item_ExtIEs = CLASS(name='MRBForwardingResourceResponse-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MRBForwardingResourceResponse_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MCForwardingResourceRelease >-----#
    MCForwardingResourceRelease = SEQ(name='MCForwardingResourceRelease', mode=MODE_TYPE)
    _MCForwardingResourceRelease_mcForwardingResourceID = OCT_STR(name='mcForwardingResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MCForwardingResourceID')))
    _MCForwardingResourceRelease_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MCForwardingResourceRelease_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MCForwardingResourceRelease_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MCForwardingResourceRelease_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCForwardingResourceRelease_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCForwardingResourceRelease_iE_Extensions__item__id._const_tab = ____MCForwardingResourceRelease_iE_Extensions__item__id_tab
    ___MCForwardingResourceRelease_iE_Extensions__item__id._const_tab_at = None
    ___MCForwardingResourceRelease_iE_Extensions__item__id._const_tab_id = 'id'
    ___MCForwardingResourceRelease_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MCForwardingResourceRelease_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCForwardingResourceRelease_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCForwardingResourceRelease_iE_Extensions__item__criticality._const_tab = ____MCForwardingResourceRelease_iE_Extensions__item__criticality_tab
    ___MCForwardingResourceRelease_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MCForwardingResourceRelease_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MCForwardingResourceRelease_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MCForwardingResourceRelease_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCForwardingResourceRelease_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCForwardingResourceRelease_iE_Extensions__item__extensionValue._const_tab = ____MCForwardingResourceRelease_iE_Extensions__item__extensionValue_tab
    ___MCForwardingResourceRelease_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MCForwardingResourceRelease_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MCForwardingResourceRelease_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MCForwardingResourceRelease_iE_Extensions__item__id),
        ('criticality', ___MCForwardingResourceRelease_iE_Extensions__item__criticality),
        ('extensionValue', ___MCForwardingResourceRelease_iE_Extensions__item__extensionValue),
        ])
    __MCForwardingResourceRelease_iE_Extensions__item_._ext = None
    _MCForwardingResourceRelease_iE_Extensions._cont = __MCForwardingResourceRelease_iE_Extensions__item_
    _MCForwardingResourceRelease_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MCForwardingResourceRelease._cont = ASN1Dict([
        ('mcForwardingResourceID', _MCForwardingResourceRelease_mcForwardingResourceID),
        ('iE-Extensions', _MCForwardingResourceRelease_iE_Extensions),
        ])
    MCForwardingResourceRelease._ext = []
    
    #-----< MCForwardingResourceRelease-ExtIEs >-----#
    MCForwardingResourceRelease_ExtIEs = CLASS(name='MCForwardingResourceRelease-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MCForwardingResourceRelease_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MCForwardingResourceReleaseIndication >-----#
    MCForwardingResourceReleaseIndication = SEQ(name='MCForwardingResourceReleaseIndication', mode=MODE_TYPE)
    _MCForwardingResourceReleaseIndication_mcForwardingResourceID = OCT_STR(name='mcForwardingResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MCForwardingResourceID')))
    _MCForwardingResourceReleaseIndication_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MCForwardingResourceReleaseIndication_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MCForwardingResourceReleaseIndication_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MCForwardingResourceReleaseIndication_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCForwardingResourceReleaseIndication_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCForwardingResourceReleaseIndication_iE_Extensions__item__id._const_tab = ____MCForwardingResourceReleaseIndication_iE_Extensions__item__id_tab
    ___MCForwardingResourceReleaseIndication_iE_Extensions__item__id._const_tab_at = None
    ___MCForwardingResourceReleaseIndication_iE_Extensions__item__id._const_tab_id = 'id'
    ___MCForwardingResourceReleaseIndication_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MCForwardingResourceReleaseIndication_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCForwardingResourceReleaseIndication_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCForwardingResourceReleaseIndication_iE_Extensions__item__criticality._const_tab = ____MCForwardingResourceReleaseIndication_iE_Extensions__item__criticality_tab
    ___MCForwardingResourceReleaseIndication_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MCForwardingResourceReleaseIndication_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MCForwardingResourceReleaseIndication_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MCForwardingResourceReleaseIndication_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MCForwardingResourceReleaseIndication_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCForwardingResourceReleaseIndication_iE_Extensions__item__extensionValue._const_tab = ____MCForwardingResourceReleaseIndication_iE_Extensions__item__extensionValue_tab
    ___MCForwardingResourceReleaseIndication_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MCForwardingResourceReleaseIndication_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MCForwardingResourceReleaseIndication_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MCForwardingResourceReleaseIndication_iE_Extensions__item__id),
        ('criticality', ___MCForwardingResourceReleaseIndication_iE_Extensions__item__criticality),
        ('extensionValue', ___MCForwardingResourceReleaseIndication_iE_Extensions__item__extensionValue),
        ])
    __MCForwardingResourceReleaseIndication_iE_Extensions__item_._ext = None
    _MCForwardingResourceReleaseIndication_iE_Extensions._cont = __MCForwardingResourceReleaseIndication_iE_Extensions__item_
    _MCForwardingResourceReleaseIndication_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MCForwardingResourceReleaseIndication._cont = ASN1Dict([
        ('mcForwardingResourceID', _MCForwardingResourceReleaseIndication_mcForwardingResourceID),
        ('iE-Extensions', _MCForwardingResourceReleaseIndication_iE_Extensions),
        ])
    MCForwardingResourceReleaseIndication._ext = []
    
    #-----< MCForwardingResourceReleaseIndication-ExtIEs >-----#
    MCForwardingResourceReleaseIndication_ExtIEs = CLASS(name='MCForwardingResourceReleaseIndication-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MCForwardingResourceReleaseIndication_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MCForwardingResourceID >-----#
    MCForwardingResourceID = OCT_STR(name='MCForwardingResourceID', mode=MODE_TYPE)
    MCForwardingResourceID._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< MDTPollutedMeasurementIndicator >-----#
    MDTPollutedMeasurementIndicator = ENUM(name='MDTPollutedMeasurementIndicator', mode=MODE_TYPE)
    MDTPollutedMeasurementIndicator._cont = ASN1Dict([('iDC', 0), ('no-IDC', 1)])
    MDTPollutedMeasurementIndicator._ext = []
    
    #-----< MRB-ID >-----#
    MRB_ID = INT(name='MRB-ID', mode=MODE_TYPE)
    MRB_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=[], er=[])
    
    #-----< MRB-ProgressInformation >-----#
    MRB_ProgressInformation = SEQ(name='MRB-ProgressInformation', mode=MODE_TYPE)
    _MRB_ProgressInformation_mrb_ProgressInformationSNs = CHOICE(name='mrb-ProgressInformationSNs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MRB-ProgressInformationSNs')))
    _MRB_ProgressInformation_mrb_ProgressInformationType = ENUM(name='mrb-ProgressInformationType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MRB-ProgressInformationType')))
    _MRB_ProgressInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MRB_ProgressInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MRB_ProgressInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MRB_ProgressInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MRB_ProgressInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MRB_ProgressInformation_iE_Extensions__item__id._const_tab = ____MRB_ProgressInformation_iE_Extensions__item__id_tab
    ___MRB_ProgressInformation_iE_Extensions__item__id._const_tab_at = None
    ___MRB_ProgressInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___MRB_ProgressInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MRB_ProgressInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MRB_ProgressInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MRB_ProgressInformation_iE_Extensions__item__criticality._const_tab = ____MRB_ProgressInformation_iE_Extensions__item__criticality_tab
    ___MRB_ProgressInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MRB_ProgressInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MRB_ProgressInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MRB_ProgressInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MRB_ProgressInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MRB_ProgressInformation_iE_Extensions__item__extensionValue._const_tab = ____MRB_ProgressInformation_iE_Extensions__item__extensionValue_tab
    ___MRB_ProgressInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MRB_ProgressInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MRB_ProgressInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MRB_ProgressInformation_iE_Extensions__item__id),
        ('criticality', ___MRB_ProgressInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___MRB_ProgressInformation_iE_Extensions__item__extensionValue),
        ])
    __MRB_ProgressInformation_iE_Extensions__item_._ext = None
    _MRB_ProgressInformation_iE_Extensions._cont = __MRB_ProgressInformation_iE_Extensions__item_
    _MRB_ProgressInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MRB_ProgressInformation._cont = ASN1Dict([
        ('mrb-ProgressInformationSNs', _MRB_ProgressInformation_mrb_ProgressInformationSNs),
        ('mrb-ProgressInformationType', _MRB_ProgressInformation_mrb_ProgressInformationType),
        ('iE-Extensions', _MRB_ProgressInformation_iE_Extensions),
        ])
    MRB_ProgressInformation._ext = []
    
    #-----< MRB-ProgressInformation-ExtIEs >-----#
    MRB_ProgressInformation_ExtIEs = CLASS(name='MRB-ProgressInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MRB_ProgressInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MRB-ProgressInformationSNs >-----#
    MRB_ProgressInformationSNs = CHOICE(name='MRB-ProgressInformationSNs', mode=MODE_TYPE)
    _MRB_ProgressInformationSNs_pdcp_SN12 = INT(name='pdcp-SN12', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MRB_ProgressInformationSNs_pdcp_SN12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _MRB_ProgressInformationSNs_pdcp_SN18 = INT(name='pdcp-SN18', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MRB_ProgressInformationSNs_pdcp_SN18._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=262143)], ev=None, er=[])
    _MRB_ProgressInformationSNs_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __MRB_ProgressInformationSNs_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___MRB_ProgressInformationSNs_choice_extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___MRB_ProgressInformationSNs_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MRB_ProgressInformationSNs_choice_extension_id._const_tab = ___MRB_ProgressInformationSNs_choice_extension_id_tab
    __MRB_ProgressInformationSNs_choice_extension_id._const_tab_at = None
    __MRB_ProgressInformationSNs_choice_extension_id._const_tab_id = 'id'
    __MRB_ProgressInformationSNs_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___MRB_ProgressInformationSNs_choice_extension_criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___MRB_ProgressInformationSNs_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MRB_ProgressInformationSNs_choice_extension_criticality._const_tab = ___MRB_ProgressInformationSNs_choice_extension_criticality_tab
    __MRB_ProgressInformationSNs_choice_extension_criticality._const_tab_at = ('..', 'id')
    __MRB_ProgressInformationSNs_choice_extension_criticality._const_tab_id = 'criticality'
    __MRB_ProgressInformationSNs_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___MRB_ProgressInformationSNs_choice_extension_value_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___MRB_ProgressInformationSNs_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MRB_ProgressInformationSNs_choice_extension_value._const_tab = ___MRB_ProgressInformationSNs_choice_extension_value_tab
    __MRB_ProgressInformationSNs_choice_extension_value._const_tab_at = ('..', 'id')
    __MRB_ProgressInformationSNs_choice_extension_value._const_tab_id = 'Value'
    _MRB_ProgressInformationSNs_choice_extension._cont = ASN1Dict([
        ('id', __MRB_ProgressInformationSNs_choice_extension_id),
        ('criticality', __MRB_ProgressInformationSNs_choice_extension_criticality),
        ('value', __MRB_ProgressInformationSNs_choice_extension_value),
        ])
    _MRB_ProgressInformationSNs_choice_extension._ext = None
    MRB_ProgressInformationSNs._cont = ASN1Dict([
        ('pdcp-SN12', _MRB_ProgressInformationSNs_pdcp_SN12),
        ('pdcp-SN18', _MRB_ProgressInformationSNs_pdcp_SN18),
        ('choice-extension', _MRB_ProgressInformationSNs_choice_extension),
        ])
    MRB_ProgressInformationSNs._ext = None
    
    #-----< MRB-ProgressInformationSNs-ExtIEs >-----#
    MRB_ProgressInformationSNs_ExtIEs = CLASS(name='MRB-ProgressInformationSNs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    MRB_ProgressInformationSNs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MRB-ProgressInformationType >-----#
    MRB_ProgressInformationType = ENUM(name='MRB-ProgressInformationType', mode=MODE_TYPE)
    MRB_ProgressInformationType._cont = ASN1Dict([('oldest-available', 0), ('last-delivered', 1)])
    MRB_ProgressInformationType._ext = []
    
    #-----< MRDC-Data-Usage-Report-Item >-----#
    MRDC_Data_Usage_Report_Item = SEQ(name='MRDC-Data-Usage-Report-Item', mode=MODE_TYPE)
    _MRDC_Data_Usage_Report_Item_startTimeStamp = OCT_STR(name='startTimeStamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MRDC_Data_Usage_Report_Item_startTimeStamp._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _MRDC_Data_Usage_Report_Item_endTimeStamp = OCT_STR(name='endTimeStamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MRDC_Data_Usage_Report_Item_endTimeStamp._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _MRDC_Data_Usage_Report_Item_usageCountUL = INT(name='usageCountUL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MRDC_Data_Usage_Report_Item_usageCountUL._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=18446744073709551615)], ev=None, er=[])
    _MRDC_Data_Usage_Report_Item_usageCountDL = INT(name='usageCountDL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MRDC_Data_Usage_Report_Item_usageCountDL._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=18446744073709551615)], ev=None, er=[])
    _MRDC_Data_Usage_Report_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MRDC_Data_Usage_Report_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MRDC_Data_Usage_Report_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MRDC_Data_Usage_Report_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MRDC_Data_Usage_Report_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MRDC_Data_Usage_Report_Item_iE_Extensions__item__id._const_tab = ____MRDC_Data_Usage_Report_Item_iE_Extensions__item__id_tab
    ___MRDC_Data_Usage_Report_Item_iE_Extensions__item__id._const_tab_at = None
    ___MRDC_Data_Usage_Report_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MRDC_Data_Usage_Report_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MRDC_Data_Usage_Report_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MRDC_Data_Usage_Report_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MRDC_Data_Usage_Report_Item_iE_Extensions__item__criticality._const_tab = ____MRDC_Data_Usage_Report_Item_iE_Extensions__item__criticality_tab
    ___MRDC_Data_Usage_Report_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MRDC_Data_Usage_Report_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MRDC_Data_Usage_Report_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MRDC_Data_Usage_Report_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MRDC_Data_Usage_Report_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MRDC_Data_Usage_Report_Item_iE_Extensions__item__extensionValue._const_tab = ____MRDC_Data_Usage_Report_Item_iE_Extensions__item__extensionValue_tab
    ___MRDC_Data_Usage_Report_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MRDC_Data_Usage_Report_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MRDC_Data_Usage_Report_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MRDC_Data_Usage_Report_Item_iE_Extensions__item__id),
        ('criticality', ___MRDC_Data_Usage_Report_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MRDC_Data_Usage_Report_Item_iE_Extensions__item__extensionValue),
        ])
    __MRDC_Data_Usage_Report_Item_iE_Extensions__item_._ext = None
    _MRDC_Data_Usage_Report_Item_iE_Extensions._cont = __MRDC_Data_Usage_Report_Item_iE_Extensions__item_
    _MRDC_Data_Usage_Report_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MRDC_Data_Usage_Report_Item._cont = ASN1Dict([
        ('startTimeStamp', _MRDC_Data_Usage_Report_Item_startTimeStamp),
        ('endTimeStamp', _MRDC_Data_Usage_Report_Item_endTimeStamp),
        ('usageCountUL', _MRDC_Data_Usage_Report_Item_usageCountUL),
        ('usageCountDL', _MRDC_Data_Usage_Report_Item_usageCountDL),
        ('iE-Extensions', _MRDC_Data_Usage_Report_Item_iE_Extensions),
        ])
    MRDC_Data_Usage_Report_Item._ext = []
    
    #-----< MRDC-Data-Usage-Report-Item-ExtIEs >-----#
    MRDC_Data_Usage_Report_Item_ExtIEs = CLASS(name='MRDC-Data-Usage-Report-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MRDC_Data_Usage_Report_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MRDC-Usage-Information >-----#
    MRDC_Usage_Information = SEQ(name='MRDC-Usage-Information', mode=MODE_TYPE)
    _MRDC_Usage_Information_data_Usage_per_PDU_Session_Report = SEQ(name='data-Usage-per-PDU-Session-Report', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Data-Usage-per-PDU-Session-Report')), opt=True)
    _MRDC_Usage_Information_data_Usage_per_QoS_Flow_List = SEQ_OF(name='data-Usage-per-QoS-Flow-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Data-Usage-per-QoS-Flow-List')), opt=True)
    _MRDC_Usage_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MRDC_Usage_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MRDC_Usage_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MRDC_Usage_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MRDC_Usage_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MRDC_Usage_Information_iE_Extensions__item__id._const_tab = ____MRDC_Usage_Information_iE_Extensions__item__id_tab
    ___MRDC_Usage_Information_iE_Extensions__item__id._const_tab_at = None
    ___MRDC_Usage_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___MRDC_Usage_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MRDC_Usage_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MRDC_Usage_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MRDC_Usage_Information_iE_Extensions__item__criticality._const_tab = ____MRDC_Usage_Information_iE_Extensions__item__criticality_tab
    ___MRDC_Usage_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MRDC_Usage_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MRDC_Usage_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MRDC_Usage_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MRDC_Usage_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MRDC_Usage_Information_iE_Extensions__item__extensionValue._const_tab = ____MRDC_Usage_Information_iE_Extensions__item__extensionValue_tab
    ___MRDC_Usage_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MRDC_Usage_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MRDC_Usage_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MRDC_Usage_Information_iE_Extensions__item__id),
        ('criticality', ___MRDC_Usage_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___MRDC_Usage_Information_iE_Extensions__item__extensionValue),
        ])
    __MRDC_Usage_Information_iE_Extensions__item_._ext = None
    _MRDC_Usage_Information_iE_Extensions._cont = __MRDC_Usage_Information_iE_Extensions__item_
    _MRDC_Usage_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MRDC_Usage_Information._cont = ASN1Dict([
        ('data-Usage-per-PDU-Session-Report', _MRDC_Usage_Information_data_Usage_per_PDU_Session_Report),
        ('data-Usage-per-QoS-Flow-List', _MRDC_Usage_Information_data_Usage_per_QoS_Flow_List),
        ('iE-Extensions', _MRDC_Usage_Information_iE_Extensions),
        ])
    MRDC_Usage_Information._ext = []
    
    #-----< MRDC-Usage-Information-ExtIEs >-----#
    MRDC_Usage_Information_ExtIEs = CLASS(name='MRDC-Usage-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MRDC_Usage_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M4Configuration >-----#
    M4Configuration = SEQ(name='M4Configuration', mode=MODE_TYPE)
    _M4Configuration_m4period = ENUM(name='m4period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'M4period')))
    _M4Configuration_m4_links_to_log = ENUM(name='m4-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Links-to-log')))
    _M4Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M4Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___M4Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____M4Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____M4Configuration_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'M4ReportAmount')))
    ____M4Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 147), ('criticality', 'ignore'), ('Extension', _____M4Configuration_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___M4Configuration_iE_Extensions__item__id._const_tab = ____M4Configuration_iE_Extensions__item__id_tab
    ___M4Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M4Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___M4Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___M4Configuration_iE_Extensions__item__criticality._const_tab = ____M4Configuration_iE_Extensions__item__id_tab
    ___M4Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M4Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M4Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___M4Configuration_iE_Extensions__item__extensionValue._const_tab = ____M4Configuration_iE_Extensions__item__id_tab
    ___M4Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M4Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M4Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M4Configuration_iE_Extensions__item__id),
        ('criticality', ___M4Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___M4Configuration_iE_Extensions__item__extensionValue),
        ])
    __M4Configuration_iE_Extensions__item_._ext = None
    _M4Configuration_iE_Extensions._cont = __M4Configuration_iE_Extensions__item_
    _M4Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M4Configuration._cont = ASN1Dict([
        ('m4period', _M4Configuration_m4period),
        ('m4-links-to-log', _M4Configuration_m4_links_to_log),
        ('iE-Extensions', _M4Configuration_iE_Extensions),
        ])
    M4Configuration._ext = []
    
    #-----< M4Configuration-ExtIEs >-----#
    M4Configuration_ExtIEs = CLASS(name='M4Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _M4Configuration_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'M4ReportAmount')))
    M4Configuration_ExtIEs._val = ASN1Set(rv=[dict([('id', 147), ('criticality', 'ignore'), ('Extension', _M4Configuration_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< M4period >-----#
    M4period = ENUM(name='M4period', mode=MODE_TYPE)
    M4period._cont = ASN1Dict([('ms1024', 0), ('ms2048', 1), ('ms5120', 2), ('ms10240', 3), ('min1', 4)])
    M4period._ext = []
    
    #-----< M4ReportAmount >-----#
    M4ReportAmount = ENUM(name='M4ReportAmount', mode=MODE_TYPE)
    M4ReportAmount._cont = ASN1Dict([('r1', 0), ('r2', 1), ('r4', 2), ('r8', 3), ('r16', 4), ('r32', 5), ('r64', 6), ('infinity', 7)])
    M4ReportAmount._ext = []
    
    #-----< M6Configuration >-----#
    M6Configuration = SEQ(name='M6Configuration', mode=MODE_TYPE)
    _M6Configuration_m6report_Interval = ENUM(name='m6report-Interval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'M6report-Interval')))
    _M6Configuration_m6_links_to_log = ENUM(name='m6-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Links-to-log')))
    _M6Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M6Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___M6Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____M6Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____M6Configuration_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'M6ReportAmount')))
    ____M6Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 148), ('criticality', 'ignore'), ('Extension', _____M6Configuration_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___M6Configuration_iE_Extensions__item__id._const_tab = ____M6Configuration_iE_Extensions__item__id_tab
    ___M6Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M6Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___M6Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___M6Configuration_iE_Extensions__item__criticality._const_tab = ____M6Configuration_iE_Extensions__item__id_tab
    ___M6Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M6Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M6Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab = ____M6Configuration_iE_Extensions__item__id_tab
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M6Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M6Configuration_iE_Extensions__item__id),
        ('criticality', ___M6Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___M6Configuration_iE_Extensions__item__extensionValue),
        ])
    __M6Configuration_iE_Extensions__item_._ext = None
    _M6Configuration_iE_Extensions._cont = __M6Configuration_iE_Extensions__item_
    _M6Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M6Configuration._cont = ASN1Dict([
        ('m6report-Interval', _M6Configuration_m6report_Interval),
        ('m6-links-to-log', _M6Configuration_m6_links_to_log),
        ('iE-Extensions', _M6Configuration_iE_Extensions),
        ])
    M6Configuration._ext = []
    
    #-----< M6Configuration-ExtIEs >-----#
    M6Configuration_ExtIEs = CLASS(name='M6Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _M6Configuration_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'M6ReportAmount')))
    M6Configuration_ExtIEs._val = ASN1Set(rv=[dict([('id', 148), ('criticality', 'ignore'), ('Extension', _M6Configuration_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< M6ReportAmount >-----#
    M6ReportAmount = ENUM(name='M6ReportAmount', mode=MODE_TYPE)
    M6ReportAmount._cont = ASN1Dict([('r1', 0), ('r2', 1), ('r4', 2), ('r8', 3), ('r16', 4), ('r32', 5), ('r64', 6), ('infinity', 7)])
    M6ReportAmount._ext = []
    
    #-----< M6report-Interval >-----#
    M6report_Interval = ENUM(name='M6report-Interval', mode=MODE_TYPE)
    M6report_Interval._cont = ASN1Dict([('ms120', 0), ('ms240', 1), ('ms480', 2), ('ms640', 3), ('ms1024', 4), ('ms2048', 5), ('ms5120', 6), ('ms10240', 7), ('ms20480', 8), ('ms40960', 9), ('min1', 10), ('min6', 11), ('min12', 12), ('min30', 13)])
    M6report_Interval._ext = []
    
    #-----< M7Configuration >-----#
    M7Configuration = SEQ(name='M7Configuration', mode=MODE_TYPE)
    _M7Configuration_m7period = INT(name='m7period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'M7period')))
    _M7Configuration_m7_links_to_log = ENUM(name='m7-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Links-to-log')))
    _M7Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M7Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___M7Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____M7Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____M7Configuration_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'M7ReportAmount')))
    ____M7Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 149), ('criticality', 'ignore'), ('Extension', _____M7Configuration_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___M7Configuration_iE_Extensions__item__id._const_tab = ____M7Configuration_iE_Extensions__item__id_tab
    ___M7Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M7Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___M7Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___M7Configuration_iE_Extensions__item__criticality._const_tab = ____M7Configuration_iE_Extensions__item__id_tab
    ___M7Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M7Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M7Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab = ____M7Configuration_iE_Extensions__item__id_tab
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M7Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M7Configuration_iE_Extensions__item__id),
        ('criticality', ___M7Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___M7Configuration_iE_Extensions__item__extensionValue),
        ])
    __M7Configuration_iE_Extensions__item_._ext = None
    _M7Configuration_iE_Extensions._cont = __M7Configuration_iE_Extensions__item_
    _M7Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M7Configuration._cont = ASN1Dict([
        ('m7period', _M7Configuration_m7period),
        ('m7-links-to-log', _M7Configuration_m7_links_to_log),
        ('iE-Extensions', _M7Configuration_iE_Extensions),
        ])
    M7Configuration._ext = []
    
    #-----< M7Configuration-ExtIEs >-----#
    M7Configuration_ExtIEs = CLASS(name='M7Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _M7Configuration_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'M7ReportAmount')))
    M7Configuration_ExtIEs._val = ASN1Set(rv=[dict([('id', 149), ('criticality', 'ignore'), ('Extension', _M7Configuration_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< M7period >-----#
    M7period = INT(name='M7period', mode=MODE_TYPE)
    M7period._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=60)], ev=[], er=[])
    
    #-----< M7ReportAmount >-----#
    M7ReportAmount = ENUM(name='M7ReportAmount', mode=MODE_TYPE)
    M7ReportAmount._cont = ASN1Dict([('r1', 0), ('r2', 1), ('r4', 2), ('r8', 3), ('r16', 4), ('r32', 5), ('r64', 6), ('infinity', 7)])
    M7ReportAmount._ext = []
    
    #-----< MDT-Activation >-----#
    MDT_Activation = ENUM(name='MDT-Activation', mode=MODE_TYPE)
    MDT_Activation._cont = ASN1Dict([('immediate-MDT-only', 0), ('immediate-MDT-and-Trace', 1)])
    MDT_Activation._ext = []
    
    #-----< MDT-Configuration >-----#
    MDT_Configuration = SEQ(name='MDT-Configuration', mode=MODE_TYPE)
    _MDT_Configuration_mdt_Activation = ENUM(name='mdt-Activation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MDT-Activation')))
    _MDT_Configuration_mDTMode = CHOICE(name='mDTMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MDTMode')))
    _MDT_Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MDT_Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___MDT_Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MDT_Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MDT_Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Configuration_iE_Extensions__item__id._const_tab = ____MDT_Configuration_iE_Extensions__item__id_tab
    ___MDT_Configuration_iE_Extensions__item__id._const_tab_at = None
    ___MDT_Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___MDT_Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MDT_Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MDT_Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab = ____MDT_Configuration_iE_Extensions__item__criticality_tab
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MDT_Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MDT_Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____MDT_Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab = ____MDT_Configuration_iE_Extensions__item__extensionValue_tab
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MDT_Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MDT_Configuration_iE_Extensions__item__id),
        ('criticality', ___MDT_Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___MDT_Configuration_iE_Extensions__item__extensionValue),
        ])
    __MDT_Configuration_iE_Extensions__item_._ext = None
    _MDT_Configuration_iE_Extensions._cont = __MDT_Configuration_iE_Extensions__item_
    _MDT_Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MDT_Configuration._cont = ASN1Dict([
        ('mdt-Activation', _MDT_Configuration_mdt_Activation),
        ('mDTMode', _MDT_Configuration_mDTMode),
        ('iE-Extensions', _MDT_Configuration_iE_Extensions),
        ])
    MDT_Configuration._ext = []
    
    #-----< MDT-Configuration-ExtIEs >-----#
    MDT_Configuration_ExtIEs = CLASS(name='MDT-Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    MDT_Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MDTMode >-----#
    MDTMode = CHOICE(name='MDTMode', mode=MODE_TYPE)
    _MDTMode_immediateMDT = SEQ(name='immediateMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'ImmediateMDT')))
    _MDTMode_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __MDTMode_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___MDTMode_choice_extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___MDTMode_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MDTMode_choice_extension_id._const_tab = ___MDTMode_choice_extension_id_tab
    __MDTMode_choice_extension_id._const_tab_at = None
    __MDTMode_choice_extension_id._const_tab_id = 'id'
    __MDTMode_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___MDTMode_choice_extension_criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___MDTMode_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MDTMode_choice_extension_criticality._const_tab = ___MDTMode_choice_extension_criticality_tab
    __MDTMode_choice_extension_criticality._const_tab_at = ('..', 'id')
    __MDTMode_choice_extension_criticality._const_tab_id = 'criticality'
    __MDTMode_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___MDTMode_choice_extension_value_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___MDTMode_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MDTMode_choice_extension_value._const_tab = ___MDTMode_choice_extension_value_tab
    __MDTMode_choice_extension_value._const_tab_at = ('..', 'id')
    __MDTMode_choice_extension_value._const_tab_id = 'Value'
    _MDTMode_choice_extension._cont = ASN1Dict([
        ('id', __MDTMode_choice_extension_id),
        ('criticality', __MDTMode_choice_extension_criticality),
        ('value', __MDTMode_choice_extension_value),
        ])
    _MDTMode_choice_extension._ext = None
    MDTMode._cont = ASN1Dict([
        ('immediateMDT', _MDTMode_immediateMDT),
        ('choice-extension', _MDTMode_choice_extension),
        ])
    MDTMode._ext = None
    
    #-----< MDTMode-ExtIEs >-----#
    MDTMode_ExtIEs = CLASS(name='MDTMode-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    MDTMode_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MeasurementsToActivate >-----#
    MeasurementsToActivate = BIT_STR(name='MeasurementsToActivate', mode=MODE_TYPE)
    MeasurementsToActivate._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< MDTPLMNList >-----#
    MDTPLMNList = SEQ_OF(name='MDTPLMNList', mode=MODE_TYPE)
    _MDTPLMNList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PLMN-Identity')))
    MDTPLMNList._cont = _MDTPLMNList__item_
    MDTPLMNList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< MDTPLMNModificationList >-----#
    MDTPLMNModificationList = SEQ_OF(name='MDTPLMNModificationList', mode=MODE_TYPE)
    _MDTPLMNModificationList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PLMN-Identity')))
    MDTPLMNModificationList._cont = _MDTPLMNModificationList__item_
    MDTPLMNModificationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< NetworkInstance >-----#
    NetworkInstance = INT(name='NetworkInstance', mode=MODE_TYPE)
    NetworkInstance._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=[], er=[])
    
    #-----< New-UL-TNL-Information-Required >-----#
    New_UL_TNL_Information_Required = ENUM(name='New-UL-TNL-Information-Required', mode=MODE_TYPE)
    New_UL_TNL_Information_Required._cont = ASN1Dict([('required', 0)])
    New_UL_TNL_Information_Required._ext = []
    
    #-----< NGRANAllocationAndRetentionPriority >-----#
    NGRANAllocationAndRetentionPriority = SEQ(name='NGRANAllocationAndRetentionPriority', mode=MODE_TYPE)
    _NGRANAllocationAndRetentionPriority_priorityLevel = INT(name='priorityLevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PriorityLevel')))
    _NGRANAllocationAndRetentionPriority_pre_emptionCapability = ENUM(name='pre-emptionCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Pre-emptionCapability')))
    _NGRANAllocationAndRetentionPriority_pre_emptionVulnerability = ENUM(name='pre-emptionVulnerability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Pre-emptionVulnerability')))
    _NGRANAllocationAndRetentionPriority_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NGRANAllocationAndRetentionPriority_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__id._const_tab = ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__id_tab
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_at = None
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_id = 'id'
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab = ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality_tab
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab = ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NGRANAllocationAndRetentionPriority_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__id),
        ('criticality', ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality),
        ('extensionValue', ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue),
        ])
    __NGRANAllocationAndRetentionPriority_iE_Extensions__item_._ext = None
    _NGRANAllocationAndRetentionPriority_iE_Extensions._cont = __NGRANAllocationAndRetentionPriority_iE_Extensions__item_
    _NGRANAllocationAndRetentionPriority_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NGRANAllocationAndRetentionPriority._cont = ASN1Dict([
        ('priorityLevel', _NGRANAllocationAndRetentionPriority_priorityLevel),
        ('pre-emptionCapability', _NGRANAllocationAndRetentionPriority_pre_emptionCapability),
        ('pre-emptionVulnerability', _NGRANAllocationAndRetentionPriority_pre_emptionVulnerability),
        ('iE-Extensions', _NGRANAllocationAndRetentionPriority_iE_Extensions),
        ])
    NGRANAllocationAndRetentionPriority._ext = None
    
    #-----< NGRANAllocationAndRetentionPriority-ExtIEs >-----#
    NGRANAllocationAndRetentionPriority_ExtIEs = CLASS(name='NGRANAllocationAndRetentionPriority-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    NGRANAllocationAndRetentionPriority_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NG-RAN-QoS-Support-List >-----#
    NG_RAN_QoS_Support_List = SEQ_OF(name='NG-RAN-QoS-Support-List', mode=MODE_TYPE)
    _NG_RAN_QoS_Support_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'NG-RAN-QoS-Support-Item')))
    NG_RAN_QoS_Support_List._cont = _NG_RAN_QoS_Support_List__item_
    NG_RAN_QoS_Support_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< NG-RAN-QoS-Support-Item >-----#
    NG_RAN_QoS_Support_Item = SEQ(name='NG-RAN-QoS-Support-Item', mode=MODE_TYPE)
    _NG_RAN_QoS_Support_Item_non_Dynamic5QIDescriptor = SEQ(name='non-Dynamic5QIDescriptor', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Non-Dynamic5QIDescriptor')))
    _NG_RAN_QoS_Support_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NG_RAN_QoS_Support_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___NG_RAN_QoS_Support_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NG_RAN_QoS_Support_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____NG_RAN_QoS_Support_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NG_RAN_QoS_Support_Item_iE_Extensions__item__id._const_tab = ____NG_RAN_QoS_Support_Item_iE_Extensions__item__id_tab
    ___NG_RAN_QoS_Support_Item_iE_Extensions__item__id._const_tab_at = None
    ___NG_RAN_QoS_Support_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___NG_RAN_QoS_Support_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NG_RAN_QoS_Support_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____NG_RAN_QoS_Support_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NG_RAN_QoS_Support_Item_iE_Extensions__item__criticality._const_tab = ____NG_RAN_QoS_Support_Item_iE_Extensions__item__criticality_tab
    ___NG_RAN_QoS_Support_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NG_RAN_QoS_Support_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NG_RAN_QoS_Support_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NG_RAN_QoS_Support_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____NG_RAN_QoS_Support_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NG_RAN_QoS_Support_Item_iE_Extensions__item__extensionValue._const_tab = ____NG_RAN_QoS_Support_Item_iE_Extensions__item__extensionValue_tab
    ___NG_RAN_QoS_Support_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NG_RAN_QoS_Support_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NG_RAN_QoS_Support_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NG_RAN_QoS_Support_Item_iE_Extensions__item__id),
        ('criticality', ___NG_RAN_QoS_Support_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___NG_RAN_QoS_Support_Item_iE_Extensions__item__extensionValue),
        ])
    __NG_RAN_QoS_Support_Item_iE_Extensions__item_._ext = None
    _NG_RAN_QoS_Support_Item_iE_Extensions._cont = __NG_RAN_QoS_Support_Item_iE_Extensions__item_
    _NG_RAN_QoS_Support_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NG_RAN_QoS_Support_Item._cont = ASN1Dict([
        ('non-Dynamic5QIDescriptor', _NG_RAN_QoS_Support_Item_non_Dynamic5QIDescriptor),
        ('iE-Extensions', _NG_RAN_QoS_Support_Item_iE_Extensions),
        ])
    NG_RAN_QoS_Support_Item._ext = None
    
    #-----< NG-RAN-QoS-Support-Item-ExtIEs >-----#
    NG_RAN_QoS_Support_Item_ExtIEs = CLASS(name='NG-RAN-QoS-Support-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    NG_RAN_QoS_Support_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NID >-----#
    NID = BIT_STR(name='NID', mode=MODE_TYPE)
    NID._const_sz = ASN1Set(rv=[44], rr=[], ev=None, er=[])
    
    #-----< Non-Dynamic5QIDescriptor >-----#
    Non_Dynamic5QIDescriptor = SEQ(name='Non-Dynamic5QIDescriptor', mode=MODE_TYPE)
    _Non_Dynamic5QIDescriptor_fiveQI = INT(name='fiveQI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Non_Dynamic5QIDescriptor_fiveQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    _Non_Dynamic5QIDescriptor_qoSPriorityLevel = INT(name='qoSPriorityLevel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoSPriorityLevel')), opt=True)
    _Non_Dynamic5QIDescriptor_averagingWindow = INT(name='averagingWindow', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'AveragingWindow')), opt=True)
    _Non_Dynamic5QIDescriptor_maxDataBurstVolume = INT(name='maxDataBurstVolume', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MaxDataBurstVolume')), opt=True)
    _Non_Dynamic5QIDescriptor_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Non_Dynamic5QIDescriptor_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___Non_Dynamic5QIDescriptor_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Non_Dynamic5QIDescriptor_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____Non_Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ExtendedPacketDelayBudget')))
    _____Non_Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ExtendedPacketDelayBudget')))
    ____Non_Dynamic5QIDescriptor_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 101), ('criticality', 'ignore'), ('Extension', _____Non_Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 102), ('criticality', 'ignore'), ('Extension', _____Non_Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Non_Dynamic5QIDescriptor_iE_Extensions__item__id._const_tab = ____Non_Dynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___Non_Dynamic5QIDescriptor_iE_Extensions__item__id._const_tab_at = None
    ___Non_Dynamic5QIDescriptor_iE_Extensions__item__id._const_tab_id = 'id'
    ___Non_Dynamic5QIDescriptor_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Non_Dynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab = ____Non_Dynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___Non_Dynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Non_Dynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Non_Dynamic5QIDescriptor_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Non_Dynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab = ____Non_Dynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___Non_Dynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Non_Dynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Non_Dynamic5QIDescriptor_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Non_Dynamic5QIDescriptor_iE_Extensions__item__id),
        ('criticality', ___Non_Dynamic5QIDescriptor_iE_Extensions__item__criticality),
        ('extensionValue', ___Non_Dynamic5QIDescriptor_iE_Extensions__item__extensionValue),
        ])
    __Non_Dynamic5QIDescriptor_iE_Extensions__item_._ext = None
    _Non_Dynamic5QIDescriptor_iE_Extensions._cont = __Non_Dynamic5QIDescriptor_iE_Extensions__item_
    _Non_Dynamic5QIDescriptor_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Non_Dynamic5QIDescriptor._cont = ASN1Dict([
        ('fiveQI', _Non_Dynamic5QIDescriptor_fiveQI),
        ('qoSPriorityLevel', _Non_Dynamic5QIDescriptor_qoSPriorityLevel),
        ('averagingWindow', _Non_Dynamic5QIDescriptor_averagingWindow),
        ('maxDataBurstVolume', _Non_Dynamic5QIDescriptor_maxDataBurstVolume),
        ('iE-Extensions', _Non_Dynamic5QIDescriptor_iE_Extensions),
        ])
    Non_Dynamic5QIDescriptor._ext = None
    
    #-----< Non-Dynamic5QIDescriptor-ExtIEs >-----#
    Non_Dynamic5QIDescriptor_ExtIEs = CLASS(name='Non-Dynamic5QIDescriptor-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _Non_Dynamic5QIDescriptor_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ExtendedPacketDelayBudget')))
    _Non_Dynamic5QIDescriptor_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ExtendedPacketDelayBudget')))
    Non_Dynamic5QIDescriptor_ExtIEs._val = ASN1Set(rv=[dict([('id', 101), ('criticality', 'ignore'), ('Extension', _Non_Dynamic5QIDescriptor_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 102), ('criticality', 'ignore'), ('Extension', _Non_Dynamic5QIDescriptor_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< NPNSupportInfo >-----#
    NPNSupportInfo = CHOICE(name='NPNSupportInfo', mode=MODE_TYPE)
    _NPNSupportInfo_sNPN = SEQ(name='sNPN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'NPNSupportInfo-SNPN')))
    _NPNSupportInfo_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __NPNSupportInfo_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___NPNSupportInfo_choice_extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___NPNSupportInfo_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPNSupportInfo_choice_extension_id._const_tab = ___NPNSupportInfo_choice_extension_id_tab
    __NPNSupportInfo_choice_extension_id._const_tab_at = None
    __NPNSupportInfo_choice_extension_id._const_tab_id = 'id'
    __NPNSupportInfo_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___NPNSupportInfo_choice_extension_criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___NPNSupportInfo_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPNSupportInfo_choice_extension_criticality._const_tab = ___NPNSupportInfo_choice_extension_criticality_tab
    __NPNSupportInfo_choice_extension_criticality._const_tab_at = ('..', 'id')
    __NPNSupportInfo_choice_extension_criticality._const_tab_id = 'criticality'
    __NPNSupportInfo_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___NPNSupportInfo_choice_extension_value_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___NPNSupportInfo_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPNSupportInfo_choice_extension_value._const_tab = ___NPNSupportInfo_choice_extension_value_tab
    __NPNSupportInfo_choice_extension_value._const_tab_at = ('..', 'id')
    __NPNSupportInfo_choice_extension_value._const_tab_id = 'Value'
    _NPNSupportInfo_choice_extension._cont = ASN1Dict([
        ('id', __NPNSupportInfo_choice_extension_id),
        ('criticality', __NPNSupportInfo_choice_extension_criticality),
        ('value', __NPNSupportInfo_choice_extension_value),
        ])
    _NPNSupportInfo_choice_extension._ext = None
    NPNSupportInfo._cont = ASN1Dict([
        ('sNPN', _NPNSupportInfo_sNPN),
        ('choice-extension', _NPNSupportInfo_choice_extension),
        ])
    NPNSupportInfo._ext = None
    
    #-----< NPNSupportInfo-ExtIEs >-----#
    NPNSupportInfo_ExtIEs = CLASS(name='NPNSupportInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    NPNSupportInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NPNSupportInfo-SNPN >-----#
    NPNSupportInfo_SNPN = SEQ(name='NPNSupportInfo-SNPN', mode=MODE_TYPE)
    _NPNSupportInfo_SNPN_nID = BIT_STR(name='nID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'NID')))
    _NPNSupportInfo_SNPN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NPNSupportInfo_SNPN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___NPNSupportInfo_SNPN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NPNSupportInfo_SNPN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____NPNSupportInfo_SNPN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPNSupportInfo_SNPN_iE_Extensions__item__id._const_tab = ____NPNSupportInfo_SNPN_iE_Extensions__item__id_tab
    ___NPNSupportInfo_SNPN_iE_Extensions__item__id._const_tab_at = None
    ___NPNSupportInfo_SNPN_iE_Extensions__item__id._const_tab_id = 'id'
    ___NPNSupportInfo_SNPN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NPNSupportInfo_SNPN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____NPNSupportInfo_SNPN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPNSupportInfo_SNPN_iE_Extensions__item__criticality._const_tab = ____NPNSupportInfo_SNPN_iE_Extensions__item__criticality_tab
    ___NPNSupportInfo_SNPN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NPNSupportInfo_SNPN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NPNSupportInfo_SNPN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NPNSupportInfo_SNPN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____NPNSupportInfo_SNPN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPNSupportInfo_SNPN_iE_Extensions__item__extensionValue._const_tab = ____NPNSupportInfo_SNPN_iE_Extensions__item__extensionValue_tab
    ___NPNSupportInfo_SNPN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NPNSupportInfo_SNPN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NPNSupportInfo_SNPN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NPNSupportInfo_SNPN_iE_Extensions__item__id),
        ('criticality', ___NPNSupportInfo_SNPN_iE_Extensions__item__criticality),
        ('extensionValue', ___NPNSupportInfo_SNPN_iE_Extensions__item__extensionValue),
        ])
    __NPNSupportInfo_SNPN_iE_Extensions__item_._ext = None
    _NPNSupportInfo_SNPN_iE_Extensions._cont = __NPNSupportInfo_SNPN_iE_Extensions__item_
    _NPNSupportInfo_SNPN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NPNSupportInfo_SNPN._cont = ASN1Dict([
        ('nID', _NPNSupportInfo_SNPN_nID),
        ('iE-Extensions', _NPNSupportInfo_SNPN_iE_Extensions),
        ])
    NPNSupportInfo_SNPN._ext = None
    
    #-----< NPNSupportInfo-SNPN-ExtIEs >-----#
    NPNSupportInfo_SNPN_ExtIEs = CLASS(name='NPNSupportInfo-SNPN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    NPNSupportInfo_SNPN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NPNContextInfo >-----#
    NPNContextInfo = CHOICE(name='NPNContextInfo', mode=MODE_TYPE)
    _NPNContextInfo_sNPN = SEQ(name='sNPN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'NPNContextInfo-SNPN')))
    _NPNContextInfo_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __NPNContextInfo_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___NPNContextInfo_choice_extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___NPNContextInfo_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPNContextInfo_choice_extension_id._const_tab = ___NPNContextInfo_choice_extension_id_tab
    __NPNContextInfo_choice_extension_id._const_tab_at = None
    __NPNContextInfo_choice_extension_id._const_tab_id = 'id'
    __NPNContextInfo_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___NPNContextInfo_choice_extension_criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___NPNContextInfo_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPNContextInfo_choice_extension_criticality._const_tab = ___NPNContextInfo_choice_extension_criticality_tab
    __NPNContextInfo_choice_extension_criticality._const_tab_at = ('..', 'id')
    __NPNContextInfo_choice_extension_criticality._const_tab_id = 'criticality'
    __NPNContextInfo_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___NPNContextInfo_choice_extension_value_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___NPNContextInfo_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPNContextInfo_choice_extension_value._const_tab = ___NPNContextInfo_choice_extension_value_tab
    __NPNContextInfo_choice_extension_value._const_tab_at = ('..', 'id')
    __NPNContextInfo_choice_extension_value._const_tab_id = 'Value'
    _NPNContextInfo_choice_extension._cont = ASN1Dict([
        ('id', __NPNContextInfo_choice_extension_id),
        ('criticality', __NPNContextInfo_choice_extension_criticality),
        ('value', __NPNContextInfo_choice_extension_value),
        ])
    _NPNContextInfo_choice_extension._ext = None
    NPNContextInfo._cont = ASN1Dict([
        ('sNPN', _NPNContextInfo_sNPN),
        ('choice-extension', _NPNContextInfo_choice_extension),
        ])
    NPNContextInfo._ext = None
    
    #-----< NPNContextInfo-ExtIEs >-----#
    NPNContextInfo_ExtIEs = CLASS(name='NPNContextInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    NPNContextInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NPNContextInfo-SNPN >-----#
    NPNContextInfo_SNPN = SEQ(name='NPNContextInfo-SNPN', mode=MODE_TYPE)
    _NPNContextInfo_SNPN_nID = BIT_STR(name='nID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'NID')))
    _NPNContextInfo_SNPN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NPNContextInfo_SNPN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___NPNContextInfo_SNPN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NPNContextInfo_SNPN_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____NPNContextInfo_SNPN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPNContextInfo_SNPN_iE_Extensions__item__id._const_tab = ____NPNContextInfo_SNPN_iE_Extensions__item__id_tab
    ___NPNContextInfo_SNPN_iE_Extensions__item__id._const_tab_at = None
    ___NPNContextInfo_SNPN_iE_Extensions__item__id._const_tab_id = 'id'
    ___NPNContextInfo_SNPN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NPNContextInfo_SNPN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____NPNContextInfo_SNPN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPNContextInfo_SNPN_iE_Extensions__item__criticality._const_tab = ____NPNContextInfo_SNPN_iE_Extensions__item__criticality_tab
    ___NPNContextInfo_SNPN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NPNContextInfo_SNPN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NPNContextInfo_SNPN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NPNContextInfo_SNPN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____NPNContextInfo_SNPN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPNContextInfo_SNPN_iE_Extensions__item__extensionValue._const_tab = ____NPNContextInfo_SNPN_iE_Extensions__item__extensionValue_tab
    ___NPNContextInfo_SNPN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NPNContextInfo_SNPN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NPNContextInfo_SNPN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NPNContextInfo_SNPN_iE_Extensions__item__id),
        ('criticality', ___NPNContextInfo_SNPN_iE_Extensions__item__criticality),
        ('extensionValue', ___NPNContextInfo_SNPN_iE_Extensions__item__extensionValue),
        ])
    __NPNContextInfo_SNPN_iE_Extensions__item_._ext = None
    _NPNContextInfo_SNPN_iE_Extensions._cont = __NPNContextInfo_SNPN_iE_Extensions__item_
    _NPNContextInfo_SNPN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NPNContextInfo_SNPN._cont = ASN1Dict([
        ('nID', _NPNContextInfo_SNPN_nID),
        ('iE-Extensions', _NPNContextInfo_SNPN_iE_Extensions),
        ])
    NPNContextInfo_SNPN._ext = None
    
    #-----< NPNContextInfo-SNPN-ExtIEs >-----#
    NPNContextInfo_SNPN_ExtIEs = CLASS(name='NPNContextInfo-SNPN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    NPNContextInfo_SNPN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NR-Cell-Identity >-----#
    NR_Cell_Identity = BIT_STR(name='NR-Cell-Identity', mode=MODE_TYPE)
    NR_Cell_Identity._const_sz = ASN1Set(rv=[36], rr=[], ev=None, er=[])
    
    #-----< NR-CGI >-----#
    NR_CGI = SEQ(name='NR-CGI', mode=MODE_TYPE)
    _NR_CGI_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PLMN-Identity')))
    _NR_CGI_nR_Cell_Identity = BIT_STR(name='nR-Cell-Identity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'NR-Cell-Identity')))
    _NR_CGI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NR_CGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___NR_CGI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NR_CGI_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____NR_CGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_CGI_iE_Extensions__item__id._const_tab = ____NR_CGI_iE_Extensions__item__id_tab
    ___NR_CGI_iE_Extensions__item__id._const_tab_at = None
    ___NR_CGI_iE_Extensions__item__id._const_tab_id = 'id'
    ___NR_CGI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NR_CGI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____NR_CGI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_CGI_iE_Extensions__item__criticality._const_tab = ____NR_CGI_iE_Extensions__item__criticality_tab
    ___NR_CGI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NR_CGI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NR_CGI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NR_CGI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____NR_CGI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_CGI_iE_Extensions__item__extensionValue._const_tab = ____NR_CGI_iE_Extensions__item__extensionValue_tab
    ___NR_CGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NR_CGI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NR_CGI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NR_CGI_iE_Extensions__item__id),
        ('criticality', ___NR_CGI_iE_Extensions__item__criticality),
        ('extensionValue', ___NR_CGI_iE_Extensions__item__extensionValue),
        ])
    __NR_CGI_iE_Extensions__item_._ext = None
    _NR_CGI_iE_Extensions._cont = __NR_CGI_iE_Extensions__item_
    _NR_CGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NR_CGI._cont = ASN1Dict([
        ('pLMN-Identity', _NR_CGI_pLMN_Identity),
        ('nR-Cell-Identity', _NR_CGI_nR_Cell_Identity),
        ('iE-Extensions', _NR_CGI_iE_Extensions),
        ])
    NR_CGI._ext = None
    
    #-----< NR-CGI-ExtIEs >-----#
    NR_CGI_ExtIEs = CLASS(name='NR-CGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    NR_CGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NR-CGI-Support-List >-----#
    NR_CGI_Support_List = SEQ_OF(name='NR-CGI-Support-List', mode=MODE_TYPE)
    _NR_CGI_Support_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'NR-CGI-Support-Item')))
    NR_CGI_Support_List._cont = _NR_CGI_Support_List__item_
    NR_CGI_Support_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< NR-CGI-Support-Item >-----#
    NR_CGI_Support_Item = SEQ(name='NR-CGI-Support-Item', mode=MODE_TYPE)
    _NR_CGI_Support_Item_nR_CGI = SEQ(name='nR-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'NR-CGI')))
    _NR_CGI_Support_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NR_CGI_Support_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___NR_CGI_Support_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NR_CGI_Support_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____NR_CGI_Support_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_CGI_Support_Item_iE_Extensions__item__id._const_tab = ____NR_CGI_Support_Item_iE_Extensions__item__id_tab
    ___NR_CGI_Support_Item_iE_Extensions__item__id._const_tab_at = None
    ___NR_CGI_Support_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___NR_CGI_Support_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NR_CGI_Support_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____NR_CGI_Support_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_CGI_Support_Item_iE_Extensions__item__criticality._const_tab = ____NR_CGI_Support_Item_iE_Extensions__item__criticality_tab
    ___NR_CGI_Support_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NR_CGI_Support_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NR_CGI_Support_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NR_CGI_Support_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____NR_CGI_Support_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_CGI_Support_Item_iE_Extensions__item__extensionValue._const_tab = ____NR_CGI_Support_Item_iE_Extensions__item__extensionValue_tab
    ___NR_CGI_Support_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NR_CGI_Support_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NR_CGI_Support_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NR_CGI_Support_Item_iE_Extensions__item__id),
        ('criticality', ___NR_CGI_Support_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___NR_CGI_Support_Item_iE_Extensions__item__extensionValue),
        ])
    __NR_CGI_Support_Item_iE_Extensions__item_._ext = None
    _NR_CGI_Support_Item_iE_Extensions._cont = __NR_CGI_Support_Item_iE_Extensions__item_
    _NR_CGI_Support_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NR_CGI_Support_Item._cont = ASN1Dict([
        ('nR-CGI', _NR_CGI_Support_Item_nR_CGI),
        ('iE-Extensions', _NR_CGI_Support_Item_iE_Extensions),
        ])
    NR_CGI_Support_Item._ext = None
    
    #-----< NR-CGI-Support-Item-ExtIEs >-----#
    NR_CGI_Support_Item_ExtIEs = CLASS(name='NR-CGI-Support-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    NR_CGI_Support_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Extended-NR-CGI-Support-List >-----#
    Extended_NR_CGI_Support_List = SEQ_OF(name='Extended-NR-CGI-Support-List', mode=MODE_TYPE)
    _Extended_NR_CGI_Support_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Extended-NR-CGI-Support-Item')))
    Extended_NR_CGI_Support_List._cont = _Extended_NR_CGI_Support_List__item_
    Extended_NR_CGI_Support_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< Extended-NR-CGI-Support-Item >-----#
    Extended_NR_CGI_Support_Item = SEQ(name='Extended-NR-CGI-Support-Item', mode=MODE_TYPE)
    _Extended_NR_CGI_Support_Item_nR_CGI = SEQ(name='nR-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'NR-CGI')))
    _Extended_NR_CGI_Support_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Extended_NR_CGI_Support_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___Extended_NR_CGI_Support_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Extended_NR_CGI_Support_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Extended_NR_CGI_Support_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_NR_CGI_Support_Item_iE_Extensions__item__id._const_tab = ____Extended_NR_CGI_Support_Item_iE_Extensions__item__id_tab
    ___Extended_NR_CGI_Support_Item_iE_Extensions__item__id._const_tab_at = None
    ___Extended_NR_CGI_Support_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Extended_NR_CGI_Support_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Extended_NR_CGI_Support_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Extended_NR_CGI_Support_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_NR_CGI_Support_Item_iE_Extensions__item__criticality._const_tab = ____Extended_NR_CGI_Support_Item_iE_Extensions__item__criticality_tab
    ___Extended_NR_CGI_Support_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Extended_NR_CGI_Support_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Extended_NR_CGI_Support_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Extended_NR_CGI_Support_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Extended_NR_CGI_Support_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_NR_CGI_Support_Item_iE_Extensions__item__extensionValue._const_tab = ____Extended_NR_CGI_Support_Item_iE_Extensions__item__extensionValue_tab
    ___Extended_NR_CGI_Support_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Extended_NR_CGI_Support_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Extended_NR_CGI_Support_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Extended_NR_CGI_Support_Item_iE_Extensions__item__id),
        ('criticality', ___Extended_NR_CGI_Support_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Extended_NR_CGI_Support_Item_iE_Extensions__item__extensionValue),
        ])
    __Extended_NR_CGI_Support_Item_iE_Extensions__item_._ext = None
    _Extended_NR_CGI_Support_Item_iE_Extensions._cont = __Extended_NR_CGI_Support_Item_iE_Extensions__item_
    _Extended_NR_CGI_Support_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Extended_NR_CGI_Support_Item._cont = ASN1Dict([
        ('nR-CGI', _Extended_NR_CGI_Support_Item_nR_CGI),
        ('iE-Extensions', _Extended_NR_CGI_Support_Item_iE_Extensions),
        ])
    Extended_NR_CGI_Support_Item._ext = None
    
    #-----< Extended-NR-CGI-Support-Item-ExtIEs >-----#
    Extended_NR_CGI_Support_Item_ExtIEs = CLASS(name='Extended-NR-CGI-Support-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    Extended_NR_CGI_Support_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< OutOfOrderDelivery >-----#
    OutOfOrderDelivery = ENUM(name='OutOfOrderDelivery', mode=MODE_TYPE)
    OutOfOrderDelivery._cont = ASN1Dict([('true', 0)])
    OutOfOrderDelivery._ext = []
    
    #-----< PacketDelayBudget >-----#
    PacketDelayBudget = INT(name='PacketDelayBudget', mode=MODE_TYPE)
    PacketDelayBudget._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=[], er=[])
    
    #-----< PacketErrorRate >-----#
    PacketErrorRate = SEQ(name='PacketErrorRate', mode=MODE_TYPE)
    _PacketErrorRate_pER_Scalar = INT(name='pER-Scalar', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PER-Scalar')))
    _PacketErrorRate_pER_Exponent = INT(name='pER-Exponent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PER-Exponent')))
    _PacketErrorRate_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PacketErrorRate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___PacketErrorRate_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PacketErrorRate_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PacketErrorRate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PacketErrorRate_iE_Extensions__item__id._const_tab = ____PacketErrorRate_iE_Extensions__item__id_tab
    ___PacketErrorRate_iE_Extensions__item__id._const_tab_at = None
    ___PacketErrorRate_iE_Extensions__item__id._const_tab_id = 'id'
    ___PacketErrorRate_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PacketErrorRate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PacketErrorRate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PacketErrorRate_iE_Extensions__item__criticality._const_tab = ____PacketErrorRate_iE_Extensions__item__criticality_tab
    ___PacketErrorRate_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PacketErrorRate_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PacketErrorRate_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PacketErrorRate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PacketErrorRate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PacketErrorRate_iE_Extensions__item__extensionValue._const_tab = ____PacketErrorRate_iE_Extensions__item__extensionValue_tab
    ___PacketErrorRate_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PacketErrorRate_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PacketErrorRate_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PacketErrorRate_iE_Extensions__item__id),
        ('criticality', ___PacketErrorRate_iE_Extensions__item__criticality),
        ('extensionValue', ___PacketErrorRate_iE_Extensions__item__extensionValue),
        ])
    __PacketErrorRate_iE_Extensions__item_._ext = None
    _PacketErrorRate_iE_Extensions._cont = __PacketErrorRate_iE_Extensions__item_
    _PacketErrorRate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PacketErrorRate._cont = ASN1Dict([
        ('pER-Scalar', _PacketErrorRate_pER_Scalar),
        ('pER-Exponent', _PacketErrorRate_pER_Exponent),
        ('iE-Extensions', _PacketErrorRate_iE_Extensions),
        ])
    PacketErrorRate._ext = []
    
    #-----< PacketErrorRate-ExtIEs >-----#
    PacketErrorRate_ExtIEs = CLASS(name='PacketErrorRate-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    PacketErrorRate_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PER-Scalar >-----#
    PER_Scalar = INT(name='PER-Scalar', mode=MODE_TYPE)
    PER_Scalar._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=[], er=[])
    
    #-----< PER-Exponent >-----#
    PER_Exponent = INT(name='PER-Exponent', mode=MODE_TYPE)
    PER_Exponent._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=[], er=[])
    
    #-----< PDCP-Configuration >-----#
    PDCP_Configuration = SEQ(name='PDCP-Configuration', mode=MODE_TYPE)
    _PDCP_Configuration_pDCP_SN_Size_UL = ENUM(name='pDCP-SN-Size-UL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-SN-Size')))
    _PDCP_Configuration_pDCP_SN_Size_DL = ENUM(name='pDCP-SN-Size-DL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-SN-Size')))
    _PDCP_Configuration_rLC_Mode = ENUM(name='rLC-Mode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'RLC-Mode')))
    _PDCP_Configuration_rOHC_Parameters = CHOICE(name='rOHC-Parameters', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'ROHC-Parameters')), opt=True)
    _PDCP_Configuration_t_ReorderingTimer = SEQ(name='t-ReorderingTimer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'T-ReorderingTimer')), opt=True)
    _PDCP_Configuration_discardTimer = ENUM(name='discardTimer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DiscardTimer')), opt=True)
    _PDCP_Configuration_uLDataSplitThreshold = ENUM(name='uLDataSplitThreshold', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'ULDataSplitThreshold')), opt=True)
    _PDCP_Configuration_pDCP_Duplication = ENUM(name='pDCP-Duplication', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-Duplication')), opt=True)
    _PDCP_Configuration_pDCP_Reestablishment = ENUM(name='pDCP-Reestablishment', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-Reestablishment')), opt=True)
    _PDCP_Configuration_pDCP_DataRecovery = ENUM(name='pDCP-DataRecovery', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-DataRecovery')), opt=True)
    _PDCP_Configuration_duplication_Activation = ENUM(name='duplication-Activation', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Duplication-Activation')), opt=True)
    _PDCP_Configuration_outOfOrderDelivery = ENUM(name='outOfOrderDelivery', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'OutOfOrderDelivery')), opt=True)
    _PDCP_Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDCP_Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___PDCP_Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PDCP_Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____PDCP_Configuration_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDCP-StatusReportIndication')))
    _____PDCP_Configuration_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'AdditionalPDCPduplicationInformation')))
    _____PDCP_Configuration_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'EHC-Parameters')))
    _____PDCP_Configuration_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UDC-Parameters')))
    _____PDCP_Configuration_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DiscardTimerExtended')))
    ____PDCP_Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 88), ('criticality', 'ignore'), ('Extension', _____PDCP_Configuration_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Extension', _____PDCP_Configuration_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 118), ('criticality', 'ignore'), ('Extension', _____PDCP_Configuration_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 153), ('criticality', 'ignore'), ('Extension', _____PDCP_Configuration_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'reject'), ('Extension', _____PDCP_Configuration_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDCP_Configuration_iE_Extensions__item__id._const_tab = ____PDCP_Configuration_iE_Extensions__item__id_tab
    ___PDCP_Configuration_iE_Extensions__item__id._const_tab_at = None
    ___PDCP_Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDCP_Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PDCP_Configuration_iE_Extensions__item__criticality._const_tab = ____PDCP_Configuration_iE_Extensions__item__id_tab
    ___PDCP_Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDCP_Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDCP_Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PDCP_Configuration_iE_Extensions__item__extensionValue._const_tab = ____PDCP_Configuration_iE_Extensions__item__id_tab
    ___PDCP_Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDCP_Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDCP_Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDCP_Configuration_iE_Extensions__item__id),
        ('criticality', ___PDCP_Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___PDCP_Configuration_iE_Extensions__item__extensionValue),
        ])
    __PDCP_Configuration_iE_Extensions__item_._ext = None
    _PDCP_Configuration_iE_Extensions._cont = __PDCP_Configuration_iE_Extensions__item_
    _PDCP_Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDCP_Configuration._cont = ASN1Dict([
        ('pDCP-SN-Size-UL', _PDCP_Configuration_pDCP_SN_Size_UL),
        ('pDCP-SN-Size-DL', _PDCP_Configuration_pDCP_SN_Size_DL),
        ('rLC-Mode', _PDCP_Configuration_rLC_Mode),
        ('rOHC-Parameters', _PDCP_Configuration_rOHC_Parameters),
        ('t-ReorderingTimer', _PDCP_Configuration_t_ReorderingTimer),
        ('discardTimer', _PDCP_Configuration_discardTimer),
        ('uLDataSplitThreshold', _PDCP_Configuration_uLDataSplitThreshold),
        ('pDCP-Duplication', _PDCP_Configuration_pDCP_Duplication),
        ('pDCP-Reestablishment', _PDCP_Configuration_pDCP_Reestablishment),
        ('pDCP-DataRecovery', _PDCP_Configuration_pDCP_DataRecovery),
        ('duplication-Activation', _PDCP_Configuration_duplication_Activation),
        ('outOfOrderDelivery', _PDCP_Configuration_outOfOrderDelivery),
        ('iE-Extensions', _PDCP_Configuration_iE_Extensions),
        ])
    PDCP_Configuration._ext = []
    
    #-----< PDCP-Configuration-ExtIEs >-----#
    PDCP_Configuration_ExtIEs = CLASS(name='PDCP-Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _PDCP_Configuration_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDCP-StatusReportIndication')))
    _PDCP_Configuration_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'AdditionalPDCPduplicationInformation')))
    _PDCP_Configuration_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'EHC-Parameters')))
    _PDCP_Configuration_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UDC-Parameters')))
    _PDCP_Configuration_ExtIEs_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DiscardTimerExtended')))
    PDCP_Configuration_ExtIEs._val = ASN1Set(rv=[dict([('id', 88), ('criticality', 'ignore'), ('Extension', _PDCP_Configuration_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Extension', _PDCP_Configuration_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 118), ('criticality', 'ignore'), ('Extension', _PDCP_Configuration_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 153), ('criticality', 'ignore'), ('Extension', _PDCP_Configuration_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'reject'), ('Extension', _PDCP_Configuration_ExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDCP-COUNT-Reset >-----#
    PDCP_COUNT_Reset = ENUM(name='PDCP-COUNT-Reset', mode=MODE_TYPE)
    PDCP_COUNT_Reset._cont = ASN1Dict([('true', 0)])
    PDCP_COUNT_Reset._ext = []
    
    #-----< PDCP-Count >-----#
    PDCP_Count = SEQ(name='PDCP-Count', mode=MODE_TYPE)
    _PDCP_Count_pDCP_SN = INT(name='pDCP-SN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-SN')))
    _PDCP_Count_hFN = INT(name='hFN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'HFN')))
    _PDCP_Count_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDCP_Count_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___PDCP_Count_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PDCP_Count_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDCP_Count_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDCP_Count_iE_Extensions__item__id._const_tab = ____PDCP_Count_iE_Extensions__item__id_tab
    ___PDCP_Count_iE_Extensions__item__id._const_tab_at = None
    ___PDCP_Count_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDCP_Count_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDCP_Count_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDCP_Count_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDCP_Count_iE_Extensions__item__criticality._const_tab = ____PDCP_Count_iE_Extensions__item__criticality_tab
    ___PDCP_Count_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDCP_Count_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDCP_Count_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDCP_Count_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDCP_Count_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDCP_Count_iE_Extensions__item__extensionValue._const_tab = ____PDCP_Count_iE_Extensions__item__extensionValue_tab
    ___PDCP_Count_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDCP_Count_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDCP_Count_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDCP_Count_iE_Extensions__item__id),
        ('criticality', ___PDCP_Count_iE_Extensions__item__criticality),
        ('extensionValue', ___PDCP_Count_iE_Extensions__item__extensionValue),
        ])
    __PDCP_Count_iE_Extensions__item_._ext = None
    _PDCP_Count_iE_Extensions._cont = __PDCP_Count_iE_Extensions__item_
    _PDCP_Count_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDCP_Count._cont = ASN1Dict([
        ('pDCP-SN', _PDCP_Count_pDCP_SN),
        ('hFN', _PDCP_Count_hFN),
        ('iE-Extensions', _PDCP_Count_iE_Extensions),
        ])
    PDCP_Count._ext = []
    
    #-----< PDCP-Count-ExtIEs >-----#
    PDCP_Count_ExtIEs = CLASS(name='PDCP-Count-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    PDCP_Count_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDCP-SN-Status-Request >-----#
    PDCP_SN_Status_Request = ENUM(name='PDCP-SN-Status-Request', mode=MODE_TYPE)
    PDCP_SN_Status_Request._cont = ASN1Dict([('requested', 0)])
    PDCP_SN_Status_Request._ext = []
    
    #-----< PDCP-DataRecovery >-----#
    PDCP_DataRecovery = ENUM(name='PDCP-DataRecovery', mode=MODE_TYPE)
    PDCP_DataRecovery._cont = ASN1Dict([('true', 0)])
    PDCP_DataRecovery._ext = []
    
    #-----< PDCP-Duplication >-----#
    PDCP_Duplication = ENUM(name='PDCP-Duplication', mode=MODE_TYPE)
    PDCP_Duplication._cont = ASN1Dict([('true', 0)])
    PDCP_Duplication._ext = []
    
    #-----< PDCP-Reestablishment >-----#
    PDCP_Reestablishment = ENUM(name='PDCP-Reestablishment', mode=MODE_TYPE)
    PDCP_Reestablishment._cont = ASN1Dict([('true', 0)])
    PDCP_Reestablishment._ext = []
    
    #-----< PDU-Session-Resource-Data-Usage-List >-----#
    PDU_Session_Resource_Data_Usage_List = SEQ_OF(name='PDU-Session-Resource-Data-Usage-List', mode=MODE_TYPE)
    _PDU_Session_Resource_Data_Usage_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Data-Usage-Item')))
    PDU_Session_Resource_Data_Usage_List._cont = _PDU_Session_Resource_Data_Usage_List__item_
    PDU_Session_Resource_Data_Usage_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDU-Session-Resource-Data-Usage-Item >-----#
    PDU_Session_Resource_Data_Usage_Item = SEQ(name='PDU-Session-Resource-Data-Usage-Item', mode=MODE_TYPE)
    _PDU_Session_Resource_Data_Usage_Item_pDU_Session_ID = INT(name='pDU-Session-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-ID')))
    _PDU_Session_Resource_Data_Usage_Item_mRDC_Usage_Information = SEQ(name='mRDC-Usage-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MRDC-Usage-Information')))
    _PDU_Session_Resource_Data_Usage_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__id._const_tab = ____PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__id._const_tab_at = None
    ___PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__criticality._const_tab = ____PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__criticality_tab
    ___PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__extensionValue._const_tab = ____PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__extensionValue_tab
    ___PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__id),
        ('criticality', ___PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__extensionValue),
        ])
    __PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item_._ext = None
    _PDU_Session_Resource_Data_Usage_Item_iE_Extensions._cont = __PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item_
    _PDU_Session_Resource_Data_Usage_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDU_Session_Resource_Data_Usage_Item._cont = ASN1Dict([
        ('pDU-Session-ID', _PDU_Session_Resource_Data_Usage_Item_pDU_Session_ID),
        ('mRDC-Usage-Information', _PDU_Session_Resource_Data_Usage_Item_mRDC_Usage_Information),
        ('iE-Extensions', _PDU_Session_Resource_Data_Usage_Item_iE_Extensions),
        ])
    PDU_Session_Resource_Data_Usage_Item._ext = []
    
    #-----< PDU-Session-Resource-Data-Usage-Item-ExtIEs >-----#
    PDU_Session_Resource_Data_Usage_Item_ExtIEs = CLASS(name='PDU-Session-Resource-Data-Usage-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    PDU_Session_Resource_Data_Usage_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDCP-SN >-----#
    PDCP_SN = INT(name='PDCP-SN', mode=MODE_TYPE)
    PDCP_SN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=262143)], ev=None, er=[])
    
    #-----< PDCP-SN-Size >-----#
    PDCP_SN_Size = ENUM(name='PDCP-SN-Size', mode=MODE_TYPE)
    PDCP_SN_Size._cont = ASN1Dict([('s-12', 0), ('s-18', 1), ('s-7', 2), ('s-15', 3), ('s-16', 4)])
    PDCP_SN_Size._ext = ['s-7', 's-15', 's-16']
    
    #-----< PDCP-SN-Status-Information >-----#
    PDCP_SN_Status_Information = SEQ(name='PDCP-SN-Status-Information', mode=MODE_TYPE)
    _PDCP_SN_Status_Information_pdcpStatusTransfer_UL = SEQ(name='pdcpStatusTransfer-UL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRBBStatusTransfer')))
    _PDCP_SN_Status_Information_pdcpStatusTransfer_DL = SEQ(name='pdcpStatusTransfer-DL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-Count')))
    _PDCP_SN_Status_Information_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDCP_SN_Status_Information_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___PDCP_SN_Status_Information_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PDCP_SN_Status_Information_iE_Extension__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDCP_SN_Status_Information_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDCP_SN_Status_Information_iE_Extension__item__id._const_tab = ____PDCP_SN_Status_Information_iE_Extension__item__id_tab
    ___PDCP_SN_Status_Information_iE_Extension__item__id._const_tab_at = None
    ___PDCP_SN_Status_Information_iE_Extension__item__id._const_tab_id = 'id'
    ___PDCP_SN_Status_Information_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDCP_SN_Status_Information_iE_Extension__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDCP_SN_Status_Information_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDCP_SN_Status_Information_iE_Extension__item__criticality._const_tab = ____PDCP_SN_Status_Information_iE_Extension__item__criticality_tab
    ___PDCP_SN_Status_Information_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___PDCP_SN_Status_Information_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___PDCP_SN_Status_Information_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDCP_SN_Status_Information_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDCP_SN_Status_Information_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDCP_SN_Status_Information_iE_Extension__item__extensionValue._const_tab = ____PDCP_SN_Status_Information_iE_Extension__item__extensionValue_tab
    ___PDCP_SN_Status_Information_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDCP_SN_Status_Information_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __PDCP_SN_Status_Information_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___PDCP_SN_Status_Information_iE_Extension__item__id),
        ('criticality', ___PDCP_SN_Status_Information_iE_Extension__item__criticality),
        ('extensionValue', ___PDCP_SN_Status_Information_iE_Extension__item__extensionValue),
        ])
    __PDCP_SN_Status_Information_iE_Extension__item_._ext = None
    _PDCP_SN_Status_Information_iE_Extension._cont = __PDCP_SN_Status_Information_iE_Extension__item_
    _PDCP_SN_Status_Information_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDCP_SN_Status_Information._cont = ASN1Dict([
        ('pdcpStatusTransfer-UL', _PDCP_SN_Status_Information_pdcpStatusTransfer_UL),
        ('pdcpStatusTransfer-DL', _PDCP_SN_Status_Information_pdcpStatusTransfer_DL),
        ('iE-Extension', _PDCP_SN_Status_Information_iE_Extension),
        ])
    PDCP_SN_Status_Information._ext = []
    
    #-----< PDCP-StatusReportIndication >-----#
    PDCP_StatusReportIndication = ENUM(name='PDCP-StatusReportIndication', mode=MODE_TYPE)
    PDCP_StatusReportIndication._cont = ASN1Dict([('downlink', 0), ('uplink', 1), ('both', 2)])
    PDCP_StatusReportIndication._ext = []
    
    #-----< PDCP-SN-Status-Information-ExtIEs >-----#
    PDCP_SN_Status_Information_ExtIEs = CLASS(name='PDCP-SN-Status-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    PDCP_SN_Status_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBBStatusTransfer >-----#
    DRBBStatusTransfer = SEQ(name='DRBBStatusTransfer', mode=MODE_TYPE)
    _DRBBStatusTransfer_receiveStatusofPDCPSDU = BIT_STR(name='receiveStatusofPDCPSDU', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DRBBStatusTransfer_receiveStatusofPDCPSDU._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=131072)], ev=None, er=[])
    _DRBBStatusTransfer_countValue = SEQ(name='countValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDCP-Count')))
    _DRBBStatusTransfer_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBBStatusTransfer_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DRBBStatusTransfer_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRBBStatusTransfer_iE_Extension__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRBBStatusTransfer_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBBStatusTransfer_iE_Extension__item__id._const_tab = ____DRBBStatusTransfer_iE_Extension__item__id_tab
    ___DRBBStatusTransfer_iE_Extension__item__id._const_tab_at = None
    ___DRBBStatusTransfer_iE_Extension__item__id._const_tab_id = 'id'
    ___DRBBStatusTransfer_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRBBStatusTransfer_iE_Extension__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRBBStatusTransfer_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBBStatusTransfer_iE_Extension__item__criticality._const_tab = ____DRBBStatusTransfer_iE_Extension__item__criticality_tab
    ___DRBBStatusTransfer_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___DRBBStatusTransfer_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___DRBBStatusTransfer_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRBBStatusTransfer_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DRBBStatusTransfer_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBBStatusTransfer_iE_Extension__item__extensionValue._const_tab = ____DRBBStatusTransfer_iE_Extension__item__extensionValue_tab
    ___DRBBStatusTransfer_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRBBStatusTransfer_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __DRBBStatusTransfer_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___DRBBStatusTransfer_iE_Extension__item__id),
        ('criticality', ___DRBBStatusTransfer_iE_Extension__item__criticality),
        ('extensionValue', ___DRBBStatusTransfer_iE_Extension__item__extensionValue),
        ])
    __DRBBStatusTransfer_iE_Extension__item_._ext = None
    _DRBBStatusTransfer_iE_Extension._cont = __DRBBStatusTransfer_iE_Extension__item_
    _DRBBStatusTransfer_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBBStatusTransfer._cont = ASN1Dict([
        ('receiveStatusofPDCPSDU', _DRBBStatusTransfer_receiveStatusofPDCPSDU),
        ('countValue', _DRBBStatusTransfer_countValue),
        ('iE-Extension', _DRBBStatusTransfer_iE_Extension),
        ])
    DRBBStatusTransfer._ext = []
    
    #-----< DRBBStatusTransfer-ExtIEs >-----#
    DRBBStatusTransfer_ExtIEs = CLASS(name='DRBBStatusTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DRBBStatusTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDU-Session-ID >-----#
    PDU_Session_ID = INT(name='PDU-Session-ID', mode=MODE_TYPE)
    PDU_Session_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< PDUSession-PairID >-----#
    PDUSession_PairID = INT(name='PDUSession-PairID', mode=MODE_TYPE)
    PDUSession_PairID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< PDU-Session-Resource-Activity >-----#
    PDU_Session_Resource_Activity = ENUM(name='PDU-Session-Resource-Activity', mode=MODE_TYPE)
    PDU_Session_Resource_Activity._cont = ASN1Dict([('active', 0), ('not-active', 1)])
    PDU_Session_Resource_Activity._ext = []
    
    #-----< PDU-Session-Resource-Activity-List >-----#
    PDU_Session_Resource_Activity_List = SEQ_OF(name='PDU-Session-Resource-Activity-List', mode=MODE_TYPE)
    _PDU_Session_Resource_Activity_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Activity-Item')))
    PDU_Session_Resource_Activity_List._cont = _PDU_Session_Resource_Activity_List__item_
    PDU_Session_Resource_Activity_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDU-Session-Resource-Activity-Item >-----#
    PDU_Session_Resource_Activity_Item = SEQ(name='PDU-Session-Resource-Activity-Item', mode=MODE_TYPE)
    _PDU_Session_Resource_Activity_Item_pDU_Session_ID = INT(name='pDU-Session-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-ID')))
    _PDU_Session_Resource_Activity_Item_pDU_Session_Resource_Activity = ENUM(name='pDU-Session-Resource-Activity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Activity')))
    _PDU_Session_Resource_Activity_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDU_Session_Resource_Activity_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___PDU_Session_Resource_Activity_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PDU_Session_Resource_Activity_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDU_Session_Resource_Activity_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_Activity_Item_iE_Extensions__item__id._const_tab = ____PDU_Session_Resource_Activity_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_Activity_Item_iE_Extensions__item__id._const_tab_at = None
    ___PDU_Session_Resource_Activity_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDU_Session_Resource_Activity_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDU_Session_Resource_Activity_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDU_Session_Resource_Activity_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_Activity_Item_iE_Extensions__item__criticality._const_tab = ____PDU_Session_Resource_Activity_Item_iE_Extensions__item__criticality_tab
    ___PDU_Session_Resource_Activity_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_Activity_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDU_Session_Resource_Activity_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDU_Session_Resource_Activity_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDU_Session_Resource_Activity_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_Activity_Item_iE_Extensions__item__extensionValue._const_tab = ____PDU_Session_Resource_Activity_Item_iE_Extensions__item__extensionValue_tab
    ___PDU_Session_Resource_Activity_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_Activity_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDU_Session_Resource_Activity_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDU_Session_Resource_Activity_Item_iE_Extensions__item__id),
        ('criticality', ___PDU_Session_Resource_Activity_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PDU_Session_Resource_Activity_Item_iE_Extensions__item__extensionValue),
        ])
    __PDU_Session_Resource_Activity_Item_iE_Extensions__item_._ext = None
    _PDU_Session_Resource_Activity_Item_iE_Extensions._cont = __PDU_Session_Resource_Activity_Item_iE_Extensions__item_
    _PDU_Session_Resource_Activity_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDU_Session_Resource_Activity_Item._cont = ASN1Dict([
        ('pDU-Session-ID', _PDU_Session_Resource_Activity_Item_pDU_Session_ID),
        ('pDU-Session-Resource-Activity', _PDU_Session_Resource_Activity_Item_pDU_Session_Resource_Activity),
        ('iE-Extensions', _PDU_Session_Resource_Activity_Item_iE_Extensions),
        ])
    PDU_Session_Resource_Activity_Item._ext = []
    
    #-----< PDU-Session-Resource-Activity-ItemExtIEs >-----#
    PDU_Session_Resource_Activity_ItemExtIEs = CLASS(name='PDU-Session-Resource-Activity-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    PDU_Session_Resource_Activity_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDU-Session-Resource-Confirm-Modified-List >-----#
    PDU_Session_Resource_Confirm_Modified_List = SEQ_OF(name='PDU-Session-Resource-Confirm-Modified-List', mode=MODE_TYPE)
    _PDU_Session_Resource_Confirm_Modified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Confirm-Modified-Item')))
    PDU_Session_Resource_Confirm_Modified_List._cont = _PDU_Session_Resource_Confirm_Modified_List__item_
    PDU_Session_Resource_Confirm_Modified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDU-Session-Resource-Confirm-Modified-Item >-----#
    PDU_Session_Resource_Confirm_Modified_Item = SEQ(name='PDU-Session-Resource-Confirm-Modified-Item', mode=MODE_TYPE)
    _PDU_Session_Resource_Confirm_Modified_Item_pDU_Session_ID = INT(name='pDU-Session-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-ID')))
    _PDU_Session_Resource_Confirm_Modified_Item_dRB_Confirm_Modified_List_NG_RAN = SEQ_OF(name='dRB-Confirm-Modified-List-NG-RAN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-Confirm-Modified-List-NG-RAN')), opt=True)
    _PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__id._const_tab = ____PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__id._const_tab_at = None
    ___PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__criticality._const_tab = ____PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__criticality_tab
    ___PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__extensionValue._const_tab = ____PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__extensionValue_tab
    ___PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__id),
        ('criticality', ___PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__extensionValue),
        ])
    __PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item_._ext = None
    _PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions._cont = __PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item_
    _PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDU_Session_Resource_Confirm_Modified_Item._cont = ASN1Dict([
        ('pDU-Session-ID', _PDU_Session_Resource_Confirm_Modified_Item_pDU_Session_ID),
        ('dRB-Confirm-Modified-List-NG-RAN', _PDU_Session_Resource_Confirm_Modified_Item_dRB_Confirm_Modified_List_NG_RAN),
        ('iE-Extensions', _PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions),
        ])
    PDU_Session_Resource_Confirm_Modified_Item._ext = []
    
    #-----< PDU-Session-Resource-Confirm-Modified-Item-ExtIEs >-----#
    PDU_Session_Resource_Confirm_Modified_Item_ExtIEs = CLASS(name='PDU-Session-Resource-Confirm-Modified-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    PDU_Session_Resource_Confirm_Modified_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDU-Session-Resource-Failed-List >-----#
    PDU_Session_Resource_Failed_List = SEQ_OF(name='PDU-Session-Resource-Failed-List', mode=MODE_TYPE)
    _PDU_Session_Resource_Failed_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Failed-Item')))
    PDU_Session_Resource_Failed_List._cont = _PDU_Session_Resource_Failed_List__item_
    PDU_Session_Resource_Failed_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDU-Session-Resource-Failed-Item >-----#
    PDU_Session_Resource_Failed_Item = SEQ(name='PDU-Session-Resource-Failed-Item', mode=MODE_TYPE)
    _PDU_Session_Resource_Failed_Item_pDU_Session_ID = INT(name='pDU-Session-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-ID')))
    _PDU_Session_Resource_Failed_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _PDU_Session_Resource_Failed_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDU_Session_Resource_Failed_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___PDU_Session_Resource_Failed_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PDU_Session_Resource_Failed_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDU_Session_Resource_Failed_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_Failed_Item_iE_Extensions__item__id._const_tab = ____PDU_Session_Resource_Failed_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_Failed_Item_iE_Extensions__item__id._const_tab_at = None
    ___PDU_Session_Resource_Failed_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDU_Session_Resource_Failed_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDU_Session_Resource_Failed_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDU_Session_Resource_Failed_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_Failed_Item_iE_Extensions__item__criticality._const_tab = ____PDU_Session_Resource_Failed_Item_iE_Extensions__item__criticality_tab
    ___PDU_Session_Resource_Failed_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_Failed_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDU_Session_Resource_Failed_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDU_Session_Resource_Failed_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDU_Session_Resource_Failed_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_Failed_Item_iE_Extensions__item__extensionValue._const_tab = ____PDU_Session_Resource_Failed_Item_iE_Extensions__item__extensionValue_tab
    ___PDU_Session_Resource_Failed_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_Failed_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDU_Session_Resource_Failed_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDU_Session_Resource_Failed_Item_iE_Extensions__item__id),
        ('criticality', ___PDU_Session_Resource_Failed_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PDU_Session_Resource_Failed_Item_iE_Extensions__item__extensionValue),
        ])
    __PDU_Session_Resource_Failed_Item_iE_Extensions__item_._ext = None
    _PDU_Session_Resource_Failed_Item_iE_Extensions._cont = __PDU_Session_Resource_Failed_Item_iE_Extensions__item_
    _PDU_Session_Resource_Failed_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDU_Session_Resource_Failed_Item._cont = ASN1Dict([
        ('pDU-Session-ID', _PDU_Session_Resource_Failed_Item_pDU_Session_ID),
        ('cause', _PDU_Session_Resource_Failed_Item_cause),
        ('iE-Extensions', _PDU_Session_Resource_Failed_Item_iE_Extensions),
        ])
    PDU_Session_Resource_Failed_Item._ext = []
    
    #-----< PDU-Session-Resource-Failed-Item-ExtIEs >-----#
    PDU_Session_Resource_Failed_Item_ExtIEs = CLASS(name='PDU-Session-Resource-Failed-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    PDU_Session_Resource_Failed_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDU-Session-Resource-Failed-Mod-List >-----#
    PDU_Session_Resource_Failed_Mod_List = SEQ_OF(name='PDU-Session-Resource-Failed-Mod-List', mode=MODE_TYPE)
    _PDU_Session_Resource_Failed_Mod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Failed-Mod-Item')))
    PDU_Session_Resource_Failed_Mod_List._cont = _PDU_Session_Resource_Failed_Mod_List__item_
    PDU_Session_Resource_Failed_Mod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDU-Session-Resource-Failed-Mod-Item >-----#
    PDU_Session_Resource_Failed_Mod_Item = SEQ(name='PDU-Session-Resource-Failed-Mod-Item', mode=MODE_TYPE)
    _PDU_Session_Resource_Failed_Mod_Item_pDU_Session_ID = INT(name='pDU-Session-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-ID')))
    _PDU_Session_Resource_Failed_Mod_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _PDU_Session_Resource_Failed_Mod_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__id._const_tab = ____PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__id._const_tab_at = None
    ___PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__criticality._const_tab = ____PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__criticality_tab
    ___PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__extensionValue._const_tab = ____PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__extensionValue_tab
    ___PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__id),
        ('criticality', ___PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__extensionValue),
        ])
    __PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item_._ext = None
    _PDU_Session_Resource_Failed_Mod_Item_iE_Extensions._cont = __PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item_
    _PDU_Session_Resource_Failed_Mod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDU_Session_Resource_Failed_Mod_Item._cont = ASN1Dict([
        ('pDU-Session-ID', _PDU_Session_Resource_Failed_Mod_Item_pDU_Session_ID),
        ('cause', _PDU_Session_Resource_Failed_Mod_Item_cause),
        ('iE-Extensions', _PDU_Session_Resource_Failed_Mod_Item_iE_Extensions),
        ])
    PDU_Session_Resource_Failed_Mod_Item._ext = []
    
    #-----< PDU-Session-Resource-Failed-Mod-Item-ExtIEs >-----#
    PDU_Session_Resource_Failed_Mod_Item_ExtIEs = CLASS(name='PDU-Session-Resource-Failed-Mod-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    PDU_Session_Resource_Failed_Mod_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDU-Session-Resource-Failed-To-Modify-List >-----#
    PDU_Session_Resource_Failed_To_Modify_List = SEQ_OF(name='PDU-Session-Resource-Failed-To-Modify-List', mode=MODE_TYPE)
    _PDU_Session_Resource_Failed_To_Modify_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Failed-To-Modify-Item')))
    PDU_Session_Resource_Failed_To_Modify_List._cont = _PDU_Session_Resource_Failed_To_Modify_List__item_
    PDU_Session_Resource_Failed_To_Modify_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDU-Session-Resource-Failed-To-Modify-Item >-----#
    PDU_Session_Resource_Failed_To_Modify_Item = SEQ(name='PDU-Session-Resource-Failed-To-Modify-Item', mode=MODE_TYPE)
    _PDU_Session_Resource_Failed_To_Modify_Item_pDU_Session_ID = INT(name='pDU-Session-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-ID')))
    _PDU_Session_Resource_Failed_To_Modify_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__id._const_tab = ____PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__id._const_tab_at = None
    ___PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__criticality._const_tab = ____PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__criticality_tab
    ___PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__extensionValue._const_tab = ____PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__extensionValue_tab
    ___PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__id),
        ('criticality', ___PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__extensionValue),
        ])
    __PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item_._ext = None
    _PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions._cont = __PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item_
    _PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDU_Session_Resource_Failed_To_Modify_Item._cont = ASN1Dict([
        ('pDU-Session-ID', _PDU_Session_Resource_Failed_To_Modify_Item_pDU_Session_ID),
        ('cause', _PDU_Session_Resource_Failed_To_Modify_Item_cause),
        ('iE-Extensions', _PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions),
        ])
    PDU_Session_Resource_Failed_To_Modify_Item._ext = []
    
    #-----< PDU-Session-Resource-Failed-To-Modify-Item-ExtIEs >-----#
    PDU_Session_Resource_Failed_To_Modify_Item_ExtIEs = CLASS(name='PDU-Session-Resource-Failed-To-Modify-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    PDU_Session_Resource_Failed_To_Modify_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDU-Session-Resource-Modified-List >-----#
    PDU_Session_Resource_Modified_List = SEQ_OF(name='PDU-Session-Resource-Modified-List', mode=MODE_TYPE)
    _PDU_Session_Resource_Modified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Modified-Item')))
    PDU_Session_Resource_Modified_List._cont = _PDU_Session_Resource_Modified_List__item_
    PDU_Session_Resource_Modified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDU-Session-Resource-Modified-Item >-----#
    PDU_Session_Resource_Modified_Item = SEQ(name='PDU-Session-Resource-Modified-Item', mode=MODE_TYPE)
    _PDU_Session_Resource_Modified_Item_pDU_Session_ID = INT(name='pDU-Session-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-ID')))
    _PDU_Session_Resource_Modified_Item_nG_DL_UP_TNL_Information = CHOICE(name='nG-DL-UP-TNL-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')), opt=True)
    _PDU_Session_Resource_Modified_Item_securityResult = SEQ(name='securityResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'SecurityResult')), opt=True)
    _PDU_Session_Resource_Modified_Item_pDU_Session_Data_Forwarding_Information_Response = SEQ(name='pDU-Session-Data-Forwarding-Information-Response', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Data-Forwarding-Information')), opt=True)
    _PDU_Session_Resource_Modified_Item_dRB_Setup_List_NG_RAN = SEQ_OF(name='dRB-Setup-List-NG-RAN', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-Setup-List-NG-RAN')), opt=True)
    _PDU_Session_Resource_Modified_Item_dRB_Failed_List_NG_RAN = SEQ_OF(name='dRB-Failed-List-NG-RAN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-Failed-List-NG-RAN')), opt=True)
    _PDU_Session_Resource_Modified_Item_dRB_Modified_List_NG_RAN = SEQ_OF(name='dRB-Modified-List-NG-RAN', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-Modified-List-NG-RAN')), opt=True)
    _PDU_Session_Resource_Modified_Item_dRB_Failed_To_Modify_List_NG_RAN = SEQ_OF(name='dRB-Failed-To-Modify-List-NG-RAN', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-Failed-To-Modify-List-NG-RAN')), opt=True)
    _PDU_Session_Resource_Modified_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDU_Session_Resource_Modified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___PDU_Session_Resource_Modified_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PDU_Session_Resource_Modified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____PDU_Session_Resource_Modified_Item_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    ____PDU_Session_Resource_Modified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 98), ('criticality', 'ignore'), ('Extension', _____PDU_Session_Resource_Modified_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_Modified_Item_iE_Extensions__item__id._const_tab = ____PDU_Session_Resource_Modified_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_Modified_Item_iE_Extensions__item__id._const_tab_at = None
    ___PDU_Session_Resource_Modified_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDU_Session_Resource_Modified_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PDU_Session_Resource_Modified_Item_iE_Extensions__item__criticality._const_tab = ____PDU_Session_Resource_Modified_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_Modified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_Modified_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDU_Session_Resource_Modified_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PDU_Session_Resource_Modified_Item_iE_Extensions__item__extensionValue._const_tab = ____PDU_Session_Resource_Modified_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_Modified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_Modified_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDU_Session_Resource_Modified_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDU_Session_Resource_Modified_Item_iE_Extensions__item__id),
        ('criticality', ___PDU_Session_Resource_Modified_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PDU_Session_Resource_Modified_Item_iE_Extensions__item__extensionValue),
        ])
    __PDU_Session_Resource_Modified_Item_iE_Extensions__item_._ext = None
    _PDU_Session_Resource_Modified_Item_iE_Extensions._cont = __PDU_Session_Resource_Modified_Item_iE_Extensions__item_
    _PDU_Session_Resource_Modified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDU_Session_Resource_Modified_Item._cont = ASN1Dict([
        ('pDU-Session-ID', _PDU_Session_Resource_Modified_Item_pDU_Session_ID),
        ('nG-DL-UP-TNL-Information', _PDU_Session_Resource_Modified_Item_nG_DL_UP_TNL_Information),
        ('securityResult', _PDU_Session_Resource_Modified_Item_securityResult),
        ('pDU-Session-Data-Forwarding-Information-Response', _PDU_Session_Resource_Modified_Item_pDU_Session_Data_Forwarding_Information_Response),
        ('dRB-Setup-List-NG-RAN', _PDU_Session_Resource_Modified_Item_dRB_Setup_List_NG_RAN),
        ('dRB-Failed-List-NG-RAN', _PDU_Session_Resource_Modified_Item_dRB_Failed_List_NG_RAN),
        ('dRB-Modified-List-NG-RAN', _PDU_Session_Resource_Modified_Item_dRB_Modified_List_NG_RAN),
        ('dRB-Failed-To-Modify-List-NG-RAN', _PDU_Session_Resource_Modified_Item_dRB_Failed_To_Modify_List_NG_RAN),
        ('iE-Extensions', _PDU_Session_Resource_Modified_Item_iE_Extensions),
        ])
    PDU_Session_Resource_Modified_Item._ext = []
    
    #-----< PDU-Session-Resource-Modified-Item-ExtIEs >-----#
    PDU_Session_Resource_Modified_Item_ExtIEs = CLASS(name='PDU-Session-Resource-Modified-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _PDU_Session_Resource_Modified_Item_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    PDU_Session_Resource_Modified_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 98), ('criticality', 'ignore'), ('Extension', _PDU_Session_Resource_Modified_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDU-Session-Resource-Required-To-Modify-List >-----#
    PDU_Session_Resource_Required_To_Modify_List = SEQ_OF(name='PDU-Session-Resource-Required-To-Modify-List', mode=MODE_TYPE)
    _PDU_Session_Resource_Required_To_Modify_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Required-To-Modify-Item')))
    PDU_Session_Resource_Required_To_Modify_List._cont = _PDU_Session_Resource_Required_To_Modify_List__item_
    PDU_Session_Resource_Required_To_Modify_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDU-Session-Resource-Required-To-Modify-Item >-----#
    PDU_Session_Resource_Required_To_Modify_Item = SEQ(name='PDU-Session-Resource-Required-To-Modify-Item', mode=MODE_TYPE)
    _PDU_Session_Resource_Required_To_Modify_Item_pDU_Session_ID = INT(name='pDU-Session-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-ID')))
    _PDU_Session_Resource_Required_To_Modify_Item_nG_DL_UP_TNL_Information = CHOICE(name='nG-DL-UP-TNL-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')), opt=True)
    _PDU_Session_Resource_Required_To_Modify_Item_dRB_Required_To_Modify_List_NG_RAN = SEQ_OF(name='dRB-Required-To-Modify-List-NG-RAN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-Required-To-Modify-List-NG-RAN')), opt=True)
    _PDU_Session_Resource_Required_To_Modify_Item_dRB_Required_To_Remove_List_NG_RAN = SEQ_OF(name='dRB-Required-To-Remove-List-NG-RAN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-Required-To-Remove-List-NG-RAN')), opt=True)
    _PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    ____PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 98), ('criticality', 'ignore'), ('Extension', _____PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__id._const_tab = ____PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__id._const_tab_at = None
    ___PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__criticality._const_tab = ____PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__extensionValue._const_tab = ____PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__id),
        ('criticality', ___PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__extensionValue),
        ])
    __PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item_._ext = None
    _PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions._cont = __PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item_
    _PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDU_Session_Resource_Required_To_Modify_Item._cont = ASN1Dict([
        ('pDU-Session-ID', _PDU_Session_Resource_Required_To_Modify_Item_pDU_Session_ID),
        ('nG-DL-UP-TNL-Information', _PDU_Session_Resource_Required_To_Modify_Item_nG_DL_UP_TNL_Information),
        ('dRB-Required-To-Modify-List-NG-RAN', _PDU_Session_Resource_Required_To_Modify_Item_dRB_Required_To_Modify_List_NG_RAN),
        ('dRB-Required-To-Remove-List-NG-RAN', _PDU_Session_Resource_Required_To_Modify_Item_dRB_Required_To_Remove_List_NG_RAN),
        ('iE-Extensions', _PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions),
        ])
    PDU_Session_Resource_Required_To_Modify_Item._ext = []
    
    #-----< PDU-Session-Resource-Required-To-Modify-Item-ExtIEs >-----#
    PDU_Session_Resource_Required_To_Modify_Item_ExtIEs = CLASS(name='PDU-Session-Resource-Required-To-Modify-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _PDU_Session_Resource_Required_To_Modify_Item_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    PDU_Session_Resource_Required_To_Modify_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 98), ('criticality', 'ignore'), ('Extension', _PDU_Session_Resource_Required_To_Modify_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDU-Session-Resource-Setup-List >-----#
    PDU_Session_Resource_Setup_List = SEQ_OF(name='PDU-Session-Resource-Setup-List', mode=MODE_TYPE)
    _PDU_Session_Resource_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Setup-Item')))
    PDU_Session_Resource_Setup_List._cont = _PDU_Session_Resource_Setup_List__item_
    PDU_Session_Resource_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDU-Session-Resource-Setup-Item >-----#
    PDU_Session_Resource_Setup_Item = SEQ(name='PDU-Session-Resource-Setup-Item', mode=MODE_TYPE)
    _PDU_Session_Resource_Setup_Item_pDU_Session_ID = INT(name='pDU-Session-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-ID')))
    _PDU_Session_Resource_Setup_Item_securityResult = SEQ(name='securityResult', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'SecurityResult')), opt=True)
    _PDU_Session_Resource_Setup_Item_nG_DL_UP_TNL_Information = CHOICE(name='nG-DL-UP-TNL-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _PDU_Session_Resource_Setup_Item_pDU_Session_Data_Forwarding_Information_Response = SEQ(name='pDU-Session-Data-Forwarding-Information-Response', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Data-Forwarding-Information')), opt=True)
    _PDU_Session_Resource_Setup_Item_nG_DL_UP_Unchanged = ENUM(name='nG-DL-UP-Unchanged', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PDU_Session_Resource_Setup_Item_nG_DL_UP_Unchanged._cont = ASN1Dict([('true', 0)])
    _PDU_Session_Resource_Setup_Item_nG_DL_UP_Unchanged._ext = []
    _PDU_Session_Resource_Setup_Item_dRB_Setup_List_NG_RAN = SEQ_OF(name='dRB-Setup-List-NG-RAN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-Setup-List-NG-RAN')))
    _PDU_Session_Resource_Setup_Item_dRB_Failed_List_NG_RAN = SEQ_OF(name='dRB-Failed-List-NG-RAN', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-Failed-List-NG-RAN')), opt=True)
    _PDU_Session_Resource_Setup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDU_Session_Resource_Setup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___PDU_Session_Resource_Setup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PDU_Session_Resource_Setup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____PDU_Session_Resource_Setup_Item_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _____PDU_Session_Resource_Setup_Item_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'RedundantPDUSessionInformation')))
    ____PDU_Session_Resource_Setup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 98), ('criticality', 'ignore'), ('Extension', _____PDU_Session_Resource_Setup_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 106), ('criticality', 'ignore'), ('Extension', _____PDU_Session_Resource_Setup_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_Setup_Item_iE_Extensions__item__id._const_tab = ____PDU_Session_Resource_Setup_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_Setup_Item_iE_Extensions__item__id._const_tab_at = None
    ___PDU_Session_Resource_Setup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDU_Session_Resource_Setup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PDU_Session_Resource_Setup_Item_iE_Extensions__item__criticality._const_tab = ____PDU_Session_Resource_Setup_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_Setup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_Setup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDU_Session_Resource_Setup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PDU_Session_Resource_Setup_Item_iE_Extensions__item__extensionValue._const_tab = ____PDU_Session_Resource_Setup_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_Setup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_Setup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDU_Session_Resource_Setup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDU_Session_Resource_Setup_Item_iE_Extensions__item__id),
        ('criticality', ___PDU_Session_Resource_Setup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PDU_Session_Resource_Setup_Item_iE_Extensions__item__extensionValue),
        ])
    __PDU_Session_Resource_Setup_Item_iE_Extensions__item_._ext = None
    _PDU_Session_Resource_Setup_Item_iE_Extensions._cont = __PDU_Session_Resource_Setup_Item_iE_Extensions__item_
    _PDU_Session_Resource_Setup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDU_Session_Resource_Setup_Item._cont = ASN1Dict([
        ('pDU-Session-ID', _PDU_Session_Resource_Setup_Item_pDU_Session_ID),
        ('securityResult', _PDU_Session_Resource_Setup_Item_securityResult),
        ('nG-DL-UP-TNL-Information', _PDU_Session_Resource_Setup_Item_nG_DL_UP_TNL_Information),
        ('pDU-Session-Data-Forwarding-Information-Response', _PDU_Session_Resource_Setup_Item_pDU_Session_Data_Forwarding_Information_Response),
        ('nG-DL-UP-Unchanged', _PDU_Session_Resource_Setup_Item_nG_DL_UP_Unchanged),
        ('dRB-Setup-List-NG-RAN', _PDU_Session_Resource_Setup_Item_dRB_Setup_List_NG_RAN),
        ('dRB-Failed-List-NG-RAN', _PDU_Session_Resource_Setup_Item_dRB_Failed_List_NG_RAN),
        ('iE-Extensions', _PDU_Session_Resource_Setup_Item_iE_Extensions),
        ])
    PDU_Session_Resource_Setup_Item._ext = []
    
    #-----< PDU-Session-Resource-Setup-Item-ExtIEs >-----#
    PDU_Session_Resource_Setup_Item_ExtIEs = CLASS(name='PDU-Session-Resource-Setup-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _PDU_Session_Resource_Setup_Item_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _PDU_Session_Resource_Setup_Item_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'RedundantPDUSessionInformation')))
    PDU_Session_Resource_Setup_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 98), ('criticality', 'ignore'), ('Extension', _PDU_Session_Resource_Setup_Item_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 106), ('criticality', 'ignore'), ('Extension', _PDU_Session_Resource_Setup_Item_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDU-Session-Resource-Setup-Mod-List >-----#
    PDU_Session_Resource_Setup_Mod_List = SEQ_OF(name='PDU-Session-Resource-Setup-Mod-List', mode=MODE_TYPE)
    _PDU_Session_Resource_Setup_Mod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Setup-Mod-Item')))
    PDU_Session_Resource_Setup_Mod_List._cont = _PDU_Session_Resource_Setup_Mod_List__item_
    PDU_Session_Resource_Setup_Mod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDU-Session-Resource-Setup-Mod-Item >-----#
    PDU_Session_Resource_Setup_Mod_Item = SEQ(name='PDU-Session-Resource-Setup-Mod-Item', mode=MODE_TYPE)
    _PDU_Session_Resource_Setup_Mod_Item_pDU_Session_ID = INT(name='pDU-Session-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-ID')))
    _PDU_Session_Resource_Setup_Mod_Item_securityResult = SEQ(name='securityResult', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'SecurityResult')), opt=True)
    _PDU_Session_Resource_Setup_Mod_Item_nG_DL_UP_TNL_Information = CHOICE(name='nG-DL-UP-TNL-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _PDU_Session_Resource_Setup_Mod_Item_pDU_Session_Data_Forwarding_Information_Response = SEQ(name='pDU-Session-Data-Forwarding-Information-Response', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Data-Forwarding-Information')), opt=True)
    _PDU_Session_Resource_Setup_Mod_Item_dRB_Setup_Mod_List_NG_RAN = SEQ_OF(name='dRB-Setup-Mod-List-NG-RAN', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-Setup-Mod-List-NG-RAN')))
    _PDU_Session_Resource_Setup_Mod_Item_dRB_Failed_Mod_List_NG_RAN = SEQ_OF(name='dRB-Failed-Mod-List-NG-RAN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-Failed-Mod-List-NG-RAN')), opt=True)
    _PDU_Session_Resource_Setup_Mod_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    ____PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 98), ('criticality', 'ignore'), ('Extension', _____PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__id._const_tab = ____PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__id._const_tab_at = None
    ___PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__criticality._const_tab = ____PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__extensionValue._const_tab = ____PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__id),
        ('criticality', ___PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__extensionValue),
        ])
    __PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item_._ext = None
    _PDU_Session_Resource_Setup_Mod_Item_iE_Extensions._cont = __PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item_
    _PDU_Session_Resource_Setup_Mod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDU_Session_Resource_Setup_Mod_Item._cont = ASN1Dict([
        ('pDU-Session-ID', _PDU_Session_Resource_Setup_Mod_Item_pDU_Session_ID),
        ('securityResult', _PDU_Session_Resource_Setup_Mod_Item_securityResult),
        ('nG-DL-UP-TNL-Information', _PDU_Session_Resource_Setup_Mod_Item_nG_DL_UP_TNL_Information),
        ('pDU-Session-Data-Forwarding-Information-Response', _PDU_Session_Resource_Setup_Mod_Item_pDU_Session_Data_Forwarding_Information_Response),
        ('dRB-Setup-Mod-List-NG-RAN', _PDU_Session_Resource_Setup_Mod_Item_dRB_Setup_Mod_List_NG_RAN),
        ('dRB-Failed-Mod-List-NG-RAN', _PDU_Session_Resource_Setup_Mod_Item_dRB_Failed_Mod_List_NG_RAN),
        ('iE-Extensions', _PDU_Session_Resource_Setup_Mod_Item_iE_Extensions),
        ])
    PDU_Session_Resource_Setup_Mod_Item._ext = []
    
    #-----< PDU-Session-Resource-Setup-Mod-Item-ExtIEs >-----#
    PDU_Session_Resource_Setup_Mod_Item_ExtIEs = CLASS(name='PDU-Session-Resource-Setup-Mod-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _PDU_Session_Resource_Setup_Mod_Item_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    PDU_Session_Resource_Setup_Mod_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 98), ('criticality', 'ignore'), ('Extension', _PDU_Session_Resource_Setup_Mod_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDU-Session-Resource-To-Modify-List >-----#
    PDU_Session_Resource_To_Modify_List = SEQ_OF(name='PDU-Session-Resource-To-Modify-List', mode=MODE_TYPE)
    _PDU_Session_Resource_To_Modify_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-To-Modify-Item')))
    PDU_Session_Resource_To_Modify_List._cont = _PDU_Session_Resource_To_Modify_List__item_
    PDU_Session_Resource_To_Modify_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDU-Session-Resource-To-Modify-Item >-----#
    PDU_Session_Resource_To_Modify_Item = SEQ(name='PDU-Session-Resource-To-Modify-Item', mode=MODE_TYPE)
    _PDU_Session_Resource_To_Modify_Item_pDU_Session_ID = INT(name='pDU-Session-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-ID')))
    _PDU_Session_Resource_To_Modify_Item_securityIndication = SEQ(name='securityIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'SecurityIndication')), opt=True)
    _PDU_Session_Resource_To_Modify_Item_pDU_Session_Resource_DL_AMBR = INT(name='pDU-Session-Resource-DL-AMBR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BitRate')), opt=True)
    _PDU_Session_Resource_To_Modify_Item_nG_UL_UP_TNL_Information = CHOICE(name='nG-UL-UP-TNL-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')), opt=True)
    _PDU_Session_Resource_To_Modify_Item_pDU_Session_Data_Forwarding_Information_Request = SEQ(name='pDU-Session-Data-Forwarding-Information-Request', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Data-Forwarding-Information-Request')), opt=True)
    _PDU_Session_Resource_To_Modify_Item_pDU_Session_Data_Forwarding_Information = SEQ(name='pDU-Session-Data-Forwarding-Information', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Data-Forwarding-Information')), opt=True)
    _PDU_Session_Resource_To_Modify_Item_pDU_Session_Inactivity_Timer = INT(name='pDU-Session-Inactivity-Timer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Inactivity-Timer')), opt=True)
    _PDU_Session_Resource_To_Modify_Item_networkInstance = INT(name='networkInstance', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'NetworkInstance')), opt=True)
    _PDU_Session_Resource_To_Modify_Item_dRB_To_Setup_List_NG_RAN = SEQ_OF(name='dRB-To-Setup-List-NG-RAN', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-To-Setup-List-NG-RAN')), opt=True)
    _PDU_Session_Resource_To_Modify_Item_dRB_To_Modify_List_NG_RAN = SEQ_OF(name='dRB-To-Modify-List-NG-RAN', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-To-Modify-List-NG-RAN')), opt=True)
    _PDU_Session_Resource_To_Modify_Item_dRB_To_Remove_List_NG_RAN = SEQ_OF(name='dRB-To-Remove-List-NG-RAN', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-To-Remove-List-NG-RAN')), opt=True)
    _PDU_Session_Resource_To_Modify_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDU_Session_Resource_To_Modify_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SNSSAI')))
    _____PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CommonNetworkInstance')))
    _____PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _____PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id_tab_val_Extension_3 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CommonNetworkInstance')))
    _____PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DataForwardingtoE-UTRANInformationList')))
    _____PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SecurityIndication')))
    ____PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 69), ('criticality', 'reject'), ('Extension', _____PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 78), ('criticality', 'ignore'), ('Extension', _____PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 97), ('criticality', 'ignore'), ('Extension', _____PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'ignore'), ('Extension', _____PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 131), ('criticality', 'ignore'), ('Extension', _____PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 143), ('criticality', 'ignore'), ('Extension', _____PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id._const_tab = ____PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id._const_tab_at = None
    ___PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__criticality._const_tab = ____PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__extensionValue._const_tab = ____PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDU_Session_Resource_To_Modify_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id),
        ('criticality', ___PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__extensionValue),
        ])
    __PDU_Session_Resource_To_Modify_Item_iE_Extensions__item_._ext = None
    _PDU_Session_Resource_To_Modify_Item_iE_Extensions._cont = __PDU_Session_Resource_To_Modify_Item_iE_Extensions__item_
    _PDU_Session_Resource_To_Modify_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDU_Session_Resource_To_Modify_Item._cont = ASN1Dict([
        ('pDU-Session-ID', _PDU_Session_Resource_To_Modify_Item_pDU_Session_ID),
        ('securityIndication', _PDU_Session_Resource_To_Modify_Item_securityIndication),
        ('pDU-Session-Resource-DL-AMBR', _PDU_Session_Resource_To_Modify_Item_pDU_Session_Resource_DL_AMBR),
        ('nG-UL-UP-TNL-Information', _PDU_Session_Resource_To_Modify_Item_nG_UL_UP_TNL_Information),
        ('pDU-Session-Data-Forwarding-Information-Request', _PDU_Session_Resource_To_Modify_Item_pDU_Session_Data_Forwarding_Information_Request),
        ('pDU-Session-Data-Forwarding-Information', _PDU_Session_Resource_To_Modify_Item_pDU_Session_Data_Forwarding_Information),
        ('pDU-Session-Inactivity-Timer', _PDU_Session_Resource_To_Modify_Item_pDU_Session_Inactivity_Timer),
        ('networkInstance', _PDU_Session_Resource_To_Modify_Item_networkInstance),
        ('dRB-To-Setup-List-NG-RAN', _PDU_Session_Resource_To_Modify_Item_dRB_To_Setup_List_NG_RAN),
        ('dRB-To-Modify-List-NG-RAN', _PDU_Session_Resource_To_Modify_Item_dRB_To_Modify_List_NG_RAN),
        ('dRB-To-Remove-List-NG-RAN', _PDU_Session_Resource_To_Modify_Item_dRB_To_Remove_List_NG_RAN),
        ('iE-Extensions', _PDU_Session_Resource_To_Modify_Item_iE_Extensions),
        ])
    PDU_Session_Resource_To_Modify_Item._ext = []
    
    #-----< PDU-Session-Resource-To-Modify-Item-ExtIEs >-----#
    PDU_Session_Resource_To_Modify_Item_ExtIEs = CLASS(name='PDU-Session-Resource-To-Modify-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _PDU_Session_Resource_To_Modify_Item_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SNSSAI')))
    _PDU_Session_Resource_To_Modify_Item_ExtIEs_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CommonNetworkInstance')))
    _PDU_Session_Resource_To_Modify_Item_ExtIEs_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _PDU_Session_Resource_To_Modify_Item_ExtIEs_val_Extension_3 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CommonNetworkInstance')))
    _PDU_Session_Resource_To_Modify_Item_ExtIEs_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DataForwardingtoE-UTRANInformationList')))
    _PDU_Session_Resource_To_Modify_Item_ExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SecurityIndication')))
    PDU_Session_Resource_To_Modify_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 69), ('criticality', 'reject'), ('Extension', _PDU_Session_Resource_To_Modify_Item_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 78), ('criticality', 'ignore'), ('Extension', _PDU_Session_Resource_To_Modify_Item_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 97), ('criticality', 'ignore'), ('Extension', _PDU_Session_Resource_To_Modify_Item_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'ignore'), ('Extension', _PDU_Session_Resource_To_Modify_Item_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 131), ('criticality', 'ignore'), ('Extension', _PDU_Session_Resource_To_Modify_Item_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 143), ('criticality', 'ignore'), ('Extension', _PDU_Session_Resource_To_Modify_Item_ExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDU-Session-Resource-To-Remove-List >-----#
    PDU_Session_Resource_To_Remove_List = SEQ_OF(name='PDU-Session-Resource-To-Remove-List', mode=MODE_TYPE)
    _PDU_Session_Resource_To_Remove_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-To-Remove-Item')))
    PDU_Session_Resource_To_Remove_List._cont = _PDU_Session_Resource_To_Remove_List__item_
    PDU_Session_Resource_To_Remove_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDU-Session-Resource-To-Remove-Item >-----#
    PDU_Session_Resource_To_Remove_Item = SEQ(name='PDU-Session-Resource-To-Remove-Item', mode=MODE_TYPE)
    _PDU_Session_Resource_To_Remove_Item_pDU_Session_ID = INT(name='pDU-Session-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-ID')))
    _PDU_Session_Resource_To_Remove_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDU_Session_Resource_To_Remove_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    ____PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Extension', _____PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__id._const_tab = ____PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__id._const_tab_at = None
    ___PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__criticality._const_tab = ____PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab = ____PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDU_Session_Resource_To_Remove_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__id),
        ('criticality', ___PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__extensionValue),
        ])
    __PDU_Session_Resource_To_Remove_Item_iE_Extensions__item_._ext = None
    _PDU_Session_Resource_To_Remove_Item_iE_Extensions._cont = __PDU_Session_Resource_To_Remove_Item_iE_Extensions__item_
    _PDU_Session_Resource_To_Remove_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDU_Session_Resource_To_Remove_Item._cont = ASN1Dict([
        ('pDU-Session-ID', _PDU_Session_Resource_To_Remove_Item_pDU_Session_ID),
        ('iE-Extensions', _PDU_Session_Resource_To_Remove_Item_iE_Extensions),
        ])
    PDU_Session_Resource_To_Remove_Item._ext = []
    
    #-----< PDU-Session-Resource-To-Remove-Item-ExtIEs >-----#
    PDU_Session_Resource_To_Remove_Item_ExtIEs = CLASS(name='PDU-Session-Resource-To-Remove-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _PDU_Session_Resource_To_Remove_Item_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    PDU_Session_Resource_To_Remove_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Extension', _PDU_Session_Resource_To_Remove_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDU-Session-Resource-To-Setup-List >-----#
    PDU_Session_Resource_To_Setup_List = SEQ_OF(name='PDU-Session-Resource-To-Setup-List', mode=MODE_TYPE)
    _PDU_Session_Resource_To_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-To-Setup-Item')))
    PDU_Session_Resource_To_Setup_List._cont = _PDU_Session_Resource_To_Setup_List__item_
    PDU_Session_Resource_To_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDU-Session-Resource-To-Setup-Item >-----#
    PDU_Session_Resource_To_Setup_Item = SEQ(name='PDU-Session-Resource-To-Setup-Item', mode=MODE_TYPE)
    _PDU_Session_Resource_To_Setup_Item_pDU_Session_ID = INT(name='pDU-Session-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-ID')))
    _PDU_Session_Resource_To_Setup_Item_pDU_Session_Type = ENUM(name='pDU-Session-Type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Type')))
    _PDU_Session_Resource_To_Setup_Item_sNSSAI = SEQ(name='sNSSAI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'SNSSAI')))
    _PDU_Session_Resource_To_Setup_Item_securityIndication = SEQ(name='securityIndication', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'SecurityIndication')))
    _PDU_Session_Resource_To_Setup_Item_pDU_Session_Resource_DL_AMBR = INT(name='pDU-Session-Resource-DL-AMBR', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BitRate')), opt=True)
    _PDU_Session_Resource_To_Setup_Item_nG_UL_UP_TNL_Information = CHOICE(name='nG-UL-UP-TNL-Information', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _PDU_Session_Resource_To_Setup_Item_pDU_Session_Data_Forwarding_Information_Request = SEQ(name='pDU-Session-Data-Forwarding-Information-Request', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Data-Forwarding-Information-Request')), opt=True)
    _PDU_Session_Resource_To_Setup_Item_pDU_Session_Inactivity_Timer = INT(name='pDU-Session-Inactivity-Timer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Inactivity-Timer')), opt=True)
    _PDU_Session_Resource_To_Setup_Item_existing_Allocated_NG_DL_UP_TNL_Info = CHOICE(name='existing-Allocated-NG-DL-UP-TNL-Info', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')), opt=True)
    _PDU_Session_Resource_To_Setup_Item_networkInstance = INT(name='networkInstance', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'NetworkInstance')), opt=True)
    _PDU_Session_Resource_To_Setup_Item_dRB_To_Setup_List_NG_RAN = SEQ_OF(name='dRB-To-Setup-List-NG-RAN', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-To-Setup-List-NG-RAN')))
    _PDU_Session_Resource_To_Setup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDU_Session_Resource_To_Setup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CommonNetworkInstance')))
    _____PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _____PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__id_tab_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CommonNetworkInstance')))
    _____PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'RedundantPDUSessionInformation')))
    ____PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'ignore'), ('Extension', _____PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 97), ('criticality', 'ignore'), ('Extension', _____PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'ignore'), ('Extension', _____PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 105), ('criticality', 'ignore'), ('Extension', _____PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__id._const_tab = ____PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__id._const_tab_at = None
    ___PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__criticality._const_tab = ____PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__extensionValue._const_tab = ____PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDU_Session_Resource_To_Setup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__id),
        ('criticality', ___PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__extensionValue),
        ])
    __PDU_Session_Resource_To_Setup_Item_iE_Extensions__item_._ext = None
    _PDU_Session_Resource_To_Setup_Item_iE_Extensions._cont = __PDU_Session_Resource_To_Setup_Item_iE_Extensions__item_
    _PDU_Session_Resource_To_Setup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDU_Session_Resource_To_Setup_Item._cont = ASN1Dict([
        ('pDU-Session-ID', _PDU_Session_Resource_To_Setup_Item_pDU_Session_ID),
        ('pDU-Session-Type', _PDU_Session_Resource_To_Setup_Item_pDU_Session_Type),
        ('sNSSAI', _PDU_Session_Resource_To_Setup_Item_sNSSAI),
        ('securityIndication', _PDU_Session_Resource_To_Setup_Item_securityIndication),
        ('pDU-Session-Resource-DL-AMBR', _PDU_Session_Resource_To_Setup_Item_pDU_Session_Resource_DL_AMBR),
        ('nG-UL-UP-TNL-Information', _PDU_Session_Resource_To_Setup_Item_nG_UL_UP_TNL_Information),
        ('pDU-Session-Data-Forwarding-Information-Request', _PDU_Session_Resource_To_Setup_Item_pDU_Session_Data_Forwarding_Information_Request),
        ('pDU-Session-Inactivity-Timer', _PDU_Session_Resource_To_Setup_Item_pDU_Session_Inactivity_Timer),
        ('existing-Allocated-NG-DL-UP-TNL-Info', _PDU_Session_Resource_To_Setup_Item_existing_Allocated_NG_DL_UP_TNL_Info),
        ('networkInstance', _PDU_Session_Resource_To_Setup_Item_networkInstance),
        ('dRB-To-Setup-List-NG-RAN', _PDU_Session_Resource_To_Setup_Item_dRB_To_Setup_List_NG_RAN),
        ('iE-Extensions', _PDU_Session_Resource_To_Setup_Item_iE_Extensions),
        ])
    PDU_Session_Resource_To_Setup_Item._ext = []
    
    #-----< PDU-Session-Resource-To-Setup-Item-ExtIEs >-----#
    PDU_Session_Resource_To_Setup_Item_ExtIEs = CLASS(name='PDU-Session-Resource-To-Setup-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _PDU_Session_Resource_To_Setup_Item_ExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CommonNetworkInstance')))
    _PDU_Session_Resource_To_Setup_Item_ExtIEs_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _PDU_Session_Resource_To_Setup_Item_ExtIEs_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CommonNetworkInstance')))
    _PDU_Session_Resource_To_Setup_Item_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'RedundantPDUSessionInformation')))
    PDU_Session_Resource_To_Setup_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'ignore'), ('Extension', _PDU_Session_Resource_To_Setup_Item_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 97), ('criticality', 'ignore'), ('Extension', _PDU_Session_Resource_To_Setup_Item_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'ignore'), ('Extension', _PDU_Session_Resource_To_Setup_Item_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 105), ('criticality', 'ignore'), ('Extension', _PDU_Session_Resource_To_Setup_Item_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDU-Session-Resource-To-Setup-Mod-List >-----#
    PDU_Session_Resource_To_Setup_Mod_List = SEQ_OF(name='PDU-Session-Resource-To-Setup-Mod-List', mode=MODE_TYPE)
    _PDU_Session_Resource_To_Setup_Mod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-To-Setup-Mod-Item')))
    PDU_Session_Resource_To_Setup_Mod_List._cont = _PDU_Session_Resource_To_Setup_Mod_List__item_
    PDU_Session_Resource_To_Setup_Mod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDU-Session-Resource-To-Setup-Mod-Item >-----#
    PDU_Session_Resource_To_Setup_Mod_Item = SEQ(name='PDU-Session-Resource-To-Setup-Mod-Item', mode=MODE_TYPE)
    _PDU_Session_Resource_To_Setup_Mod_Item_pDU_Session_ID = INT(name='pDU-Session-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-ID')))
    _PDU_Session_Resource_To_Setup_Mod_Item_pDU_Session_Type = ENUM(name='pDU-Session-Type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Type')))
    _PDU_Session_Resource_To_Setup_Mod_Item_sNSSAI = SEQ(name='sNSSAI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'SNSSAI')))
    _PDU_Session_Resource_To_Setup_Mod_Item_securityIndication = SEQ(name='securityIndication', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'SecurityIndication')))
    _PDU_Session_Resource_To_Setup_Mod_Item_pDU_Session_Resource_AMBR = INT(name='pDU-Session-Resource-AMBR', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BitRate')), opt=True)
    _PDU_Session_Resource_To_Setup_Mod_Item_nG_UL_UP_TNL_Information = CHOICE(name='nG-UL-UP-TNL-Information', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _PDU_Session_Resource_To_Setup_Mod_Item_pDU_Session_Data_Forwarding_Information_Request = SEQ(name='pDU-Session-Data-Forwarding-Information-Request', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Data-Forwarding-Information-Request')), opt=True)
    _PDU_Session_Resource_To_Setup_Mod_Item_pDU_Session_Inactivity_Timer = INT(name='pDU-Session-Inactivity-Timer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Inactivity-Timer')), opt=True)
    _PDU_Session_Resource_To_Setup_Mod_Item_dRB_To_Setup_Mod_List_NG_RAN = SEQ_OF(name='dRB-To-Setup-Mod-List-NG-RAN', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DRB-To-Setup-Mod-List-NG-RAN')))
    _PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'NetworkInstance')))
    _____PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CommonNetworkInstance')))
    _____PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _____PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__id_tab_val_Extension_3 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CommonNetworkInstance')))
    ____PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 79), ('criticality', 'ignore'), ('Extension', _____PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 78), ('criticality', 'ignore'), ('Extension', _____PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 97), ('criticality', 'ignore'), ('Extension', _____PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'ignore'), ('Extension', _____PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__id._const_tab = ____PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__id._const_tab_at = None
    ___PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__criticality._const_tab = ____PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__extensionValue._const_tab = ____PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__id_tab
    ___PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__id),
        ('criticality', ___PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__extensionValue),
        ])
    __PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item_._ext = None
    _PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions._cont = __PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item_
    _PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDU_Session_Resource_To_Setup_Mod_Item._cont = ASN1Dict([
        ('pDU-Session-ID', _PDU_Session_Resource_To_Setup_Mod_Item_pDU_Session_ID),
        ('pDU-Session-Type', _PDU_Session_Resource_To_Setup_Mod_Item_pDU_Session_Type),
        ('sNSSAI', _PDU_Session_Resource_To_Setup_Mod_Item_sNSSAI),
        ('securityIndication', _PDU_Session_Resource_To_Setup_Mod_Item_securityIndication),
        ('pDU-Session-Resource-AMBR', _PDU_Session_Resource_To_Setup_Mod_Item_pDU_Session_Resource_AMBR),
        ('nG-UL-UP-TNL-Information', _PDU_Session_Resource_To_Setup_Mod_Item_nG_UL_UP_TNL_Information),
        ('pDU-Session-Data-Forwarding-Information-Request', _PDU_Session_Resource_To_Setup_Mod_Item_pDU_Session_Data_Forwarding_Information_Request),
        ('pDU-Session-Inactivity-Timer', _PDU_Session_Resource_To_Setup_Mod_Item_pDU_Session_Inactivity_Timer),
        ('dRB-To-Setup-Mod-List-NG-RAN', _PDU_Session_Resource_To_Setup_Mod_Item_dRB_To_Setup_Mod_List_NG_RAN),
        ('iE-Extensions', _PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions),
        ])
    PDU_Session_Resource_To_Setup_Mod_Item._ext = []
    
    #-----< PDU-Session-Resource-To-Setup-Mod-Item-ExtIEs >-----#
    PDU_Session_Resource_To_Setup_Mod_Item_ExtIEs = CLASS(name='PDU-Session-Resource-To-Setup-Mod-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _PDU_Session_Resource_To_Setup_Mod_Item_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'NetworkInstance')))
    _PDU_Session_Resource_To_Setup_Mod_Item_ExtIEs_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CommonNetworkInstance')))
    _PDU_Session_Resource_To_Setup_Mod_Item_ExtIEs_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _PDU_Session_Resource_To_Setup_Mod_Item_ExtIEs_val_Extension_3 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CommonNetworkInstance')))
    PDU_Session_Resource_To_Setup_Mod_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 79), ('criticality', 'ignore'), ('Extension', _PDU_Session_Resource_To_Setup_Mod_Item_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 78), ('criticality', 'ignore'), ('Extension', _PDU_Session_Resource_To_Setup_Mod_Item_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 97), ('criticality', 'ignore'), ('Extension', _PDU_Session_Resource_To_Setup_Mod_Item_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'ignore'), ('Extension', _PDU_Session_Resource_To_Setup_Mod_Item_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDU-Session-To-Notify-List >-----#
    PDU_Session_To_Notify_List = SEQ_OF(name='PDU-Session-To-Notify-List', mode=MODE_TYPE)
    _PDU_Session_To_Notify_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-To-Notify-Item')))
    PDU_Session_To_Notify_List._cont = _PDU_Session_To_Notify_List__item_
    PDU_Session_To_Notify_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDU-Session-To-Notify-Item >-----#
    PDU_Session_To_Notify_Item = SEQ(name='PDU-Session-To-Notify-Item', mode=MODE_TYPE)
    _PDU_Session_To_Notify_Item_pDU_Session_ID = INT(name='pDU-Session-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-ID')))
    _PDU_Session_To_Notify_Item_qoS_Flow_List = SEQ_OF(name='qoS-Flow-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-List')))
    _PDU_Session_To_Notify_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDU_Session_To_Notify_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___PDU_Session_To_Notify_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PDU_Session_To_Notify_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDU_Session_To_Notify_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDU_Session_To_Notify_Item_iE_Extensions__item__id._const_tab = ____PDU_Session_To_Notify_Item_iE_Extensions__item__id_tab
    ___PDU_Session_To_Notify_Item_iE_Extensions__item__id._const_tab_at = None
    ___PDU_Session_To_Notify_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDU_Session_To_Notify_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDU_Session_To_Notify_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDU_Session_To_Notify_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDU_Session_To_Notify_Item_iE_Extensions__item__criticality._const_tab = ____PDU_Session_To_Notify_Item_iE_Extensions__item__criticality_tab
    ___PDU_Session_To_Notify_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDU_Session_To_Notify_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDU_Session_To_Notify_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDU_Session_To_Notify_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____PDU_Session_To_Notify_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDU_Session_To_Notify_Item_iE_Extensions__item__extensionValue._const_tab = ____PDU_Session_To_Notify_Item_iE_Extensions__item__extensionValue_tab
    ___PDU_Session_To_Notify_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDU_Session_To_Notify_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDU_Session_To_Notify_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDU_Session_To_Notify_Item_iE_Extensions__item__id),
        ('criticality', ___PDU_Session_To_Notify_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PDU_Session_To_Notify_Item_iE_Extensions__item__extensionValue),
        ])
    __PDU_Session_To_Notify_Item_iE_Extensions__item_._ext = None
    _PDU_Session_To_Notify_Item_iE_Extensions._cont = __PDU_Session_To_Notify_Item_iE_Extensions__item_
    _PDU_Session_To_Notify_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDU_Session_To_Notify_Item._cont = ASN1Dict([
        ('pDU-Session-ID', _PDU_Session_To_Notify_Item_pDU_Session_ID),
        ('qoS-Flow-List', _PDU_Session_To_Notify_Item_qoS_Flow_List),
        ('iE-Extensions', _PDU_Session_To_Notify_Item_iE_Extensions),
        ])
    PDU_Session_To_Notify_Item._ext = []
    
    #-----< PDU-Session-To-Notify-Item-ExtIEs >-----#
    PDU_Session_To_Notify_Item_ExtIEs = CLASS(name='PDU-Session-To-Notify-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    PDU_Session_To_Notify_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDU-Session-Type >-----#
    PDU_Session_Type = ENUM(name='PDU-Session-Type', mode=MODE_TYPE)
    PDU_Session_Type._cont = ASN1Dict([('ipv4', 0), ('ipv6', 1), ('ipv4v6', 2), ('ethernet', 3), ('unstructured', 4)])
    PDU_Session_Type._ext = []
    
    #-----< PLMN-Identity >-----#
    PLMN_Identity = OCT_STR(name='PLMN-Identity', mode=MODE_TYPE)
    PLMN_Identity._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< PortNumber >-----#
    PortNumber = BIT_STR(name='PortNumber', mode=MODE_TYPE)
    PortNumber._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< PPI >-----#
    PPI = INT(name='PPI', mode=MODE_TYPE)
    PPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=[], er=[])
    
    #-----< PriorityLevel >-----#
    PriorityLevel = INT(name='PriorityLevel', mode=MODE_TYPE)
    PriorityLevel._cont = ASN1Dict([('spare', 0), ('highest', 1), ('lowest', 14), ('no-priority', 15)])
    PriorityLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< Pre-emptionCapability >-----#
    Pre_emptionCapability = ENUM(name='Pre-emptionCapability', mode=MODE_TYPE)
    Pre_emptionCapability._cont = ASN1Dict([('shall-not-trigger-pre-emption', 0), ('may-trigger-pre-emption', 1)])
    Pre_emptionCapability._ext = None
    
    #-----< Pre-emptionVulnerability >-----#
    Pre_emptionVulnerability = ENUM(name='Pre-emptionVulnerability', mode=MODE_TYPE)
    Pre_emptionVulnerability._cont = ASN1Dict([('not-pre-emptable', 0), ('pre-emptable', 1)])
    Pre_emptionVulnerability._ext = None
    
    #-----< PrivacyIndicator >-----#
    PrivacyIndicator = ENUM(name='PrivacyIndicator', mode=MODE_TYPE)
    PrivacyIndicator._cont = ASN1Dict([('immediate-MDT', 0), ('logged-MDT', 1)])
    PrivacyIndicator._ext = []
    
    #-----< QCI >-----#
    QCI = INT(name='QCI', mode=MODE_TYPE)
    QCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< QoS-Characteristics >-----#
    QoS_Characteristics = CHOICE(name='QoS-Characteristics', mode=MODE_TYPE)
    _QoS_Characteristics_non_Dynamic_5QI = SEQ(name='non-Dynamic-5QI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Non-Dynamic5QIDescriptor')))
    _QoS_Characteristics_dynamic_5QI = SEQ(name='dynamic-5QI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Dynamic5QIDescriptor')))
    _QoS_Characteristics_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __QoS_Characteristics_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___QoS_Characteristics_choice_extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___QoS_Characteristics_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __QoS_Characteristics_choice_extension_id._const_tab = ___QoS_Characteristics_choice_extension_id_tab
    __QoS_Characteristics_choice_extension_id._const_tab_at = None
    __QoS_Characteristics_choice_extension_id._const_tab_id = 'id'
    __QoS_Characteristics_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___QoS_Characteristics_choice_extension_criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___QoS_Characteristics_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __QoS_Characteristics_choice_extension_criticality._const_tab = ___QoS_Characteristics_choice_extension_criticality_tab
    __QoS_Characteristics_choice_extension_criticality._const_tab_at = ('..', 'id')
    __QoS_Characteristics_choice_extension_criticality._const_tab_id = 'criticality'
    __QoS_Characteristics_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___QoS_Characteristics_choice_extension_value_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___QoS_Characteristics_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __QoS_Characteristics_choice_extension_value._const_tab = ___QoS_Characteristics_choice_extension_value_tab
    __QoS_Characteristics_choice_extension_value._const_tab_at = ('..', 'id')
    __QoS_Characteristics_choice_extension_value._const_tab_id = 'Value'
    _QoS_Characteristics_choice_extension._cont = ASN1Dict([
        ('id', __QoS_Characteristics_choice_extension_id),
        ('criticality', __QoS_Characteristics_choice_extension_criticality),
        ('value', __QoS_Characteristics_choice_extension_value),
        ])
    _QoS_Characteristics_choice_extension._ext = None
    QoS_Characteristics._cont = ASN1Dict([
        ('non-Dynamic-5QI', _QoS_Characteristics_non_Dynamic_5QI),
        ('dynamic-5QI', _QoS_Characteristics_dynamic_5QI),
        ('choice-extension', _QoS_Characteristics_choice_extension),
        ])
    QoS_Characteristics._ext = None
    
    #-----< QoS-Characteristics-ExtIEs >-----#
    QoS_Characteristics_ExtIEs = CLASS(name='QoS-Characteristics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    QoS_Characteristics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QoS-Flow-Identifier >-----#
    QoS_Flow_Identifier = INT(name='QoS-Flow-Identifier', mode=MODE_TYPE)
    QoS_Flow_Identifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< QoS-Flow-List >-----#
    QoS_Flow_List = SEQ_OF(name='QoS-Flow-List', mode=MODE_TYPE)
    _QoS_Flow_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Item')))
    QoS_Flow_List._cont = _QoS_Flow_List__item_
    QoS_Flow_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QoS-Flow-Item >-----#
    QoS_Flow_Item = SEQ(name='QoS-Flow-Item', mode=MODE_TYPE)
    _QoS_Flow_Item_qoS_Flow_Identifier = INT(name='qoS-Flow-Identifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Identifier')))
    _QoS_Flow_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QoS_Flow_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___QoS_Flow_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____QoS_Flow_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____QoS_Flow_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Mapping-Indication')))
    _____QoS_Flow_Item_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    ____QoS_Flow_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 80), ('criticality', 'ignore'), ('Extension', _____QoS_Flow_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 142), ('criticality', 'ignore'), ('Extension', _____QoS_Flow_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___QoS_Flow_Item_iE_Extensions__item__id._const_tab = ____QoS_Flow_Item_iE_Extensions__item__id_tab
    ___QoS_Flow_Item_iE_Extensions__item__id._const_tab_at = None
    ___QoS_Flow_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___QoS_Flow_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___QoS_Flow_Item_iE_Extensions__item__criticality._const_tab = ____QoS_Flow_Item_iE_Extensions__item__id_tab
    ___QoS_Flow_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QoS_Flow_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QoS_Flow_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___QoS_Flow_Item_iE_Extensions__item__extensionValue._const_tab = ____QoS_Flow_Item_iE_Extensions__item__id_tab
    ___QoS_Flow_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QoS_Flow_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QoS_Flow_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QoS_Flow_Item_iE_Extensions__item__id),
        ('criticality', ___QoS_Flow_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___QoS_Flow_Item_iE_Extensions__item__extensionValue),
        ])
    __QoS_Flow_Item_iE_Extensions__item_._ext = None
    _QoS_Flow_Item_iE_Extensions._cont = __QoS_Flow_Item_iE_Extensions__item_
    _QoS_Flow_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QoS_Flow_Item._cont = ASN1Dict([
        ('qoS-Flow-Identifier', _QoS_Flow_Item_qoS_Flow_Identifier),
        ('iE-Extensions', _QoS_Flow_Item_iE_Extensions),
        ])
    QoS_Flow_Item._ext = []
    
    #-----< QoS-Flow-Item-ExtIEs >-----#
    QoS_Flow_Item_ExtIEs = CLASS(name='QoS-Flow-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _QoS_Flow_Item_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Mapping-Indication')))
    _QoS_Flow_Item_ExtIEs_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    QoS_Flow_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 80), ('criticality', 'ignore'), ('Extension', _QoS_Flow_Item_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 142), ('criticality', 'ignore'), ('Extension', _QoS_Flow_Item_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< QoS-Flow-Failed-List >-----#
    QoS_Flow_Failed_List = SEQ_OF(name='QoS-Flow-Failed-List', mode=MODE_TYPE)
    _QoS_Flow_Failed_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Failed-Item')))
    QoS_Flow_Failed_List._cont = _QoS_Flow_Failed_List__item_
    QoS_Flow_Failed_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QoS-Flow-Failed-Item >-----#
    QoS_Flow_Failed_Item = SEQ(name='QoS-Flow-Failed-Item', mode=MODE_TYPE)
    _QoS_Flow_Failed_Item_qoS_Flow_Identifier = INT(name='qoS-Flow-Identifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Identifier')))
    _QoS_Flow_Failed_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _QoS_Flow_Failed_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QoS_Flow_Failed_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___QoS_Flow_Failed_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____QoS_Flow_Failed_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____QoS_Flow_Failed_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoS_Flow_Failed_Item_iE_Extensions__item__id._const_tab = ____QoS_Flow_Failed_Item_iE_Extensions__item__id_tab
    ___QoS_Flow_Failed_Item_iE_Extensions__item__id._const_tab_at = None
    ___QoS_Flow_Failed_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___QoS_Flow_Failed_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____QoS_Flow_Failed_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____QoS_Flow_Failed_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoS_Flow_Failed_Item_iE_Extensions__item__criticality._const_tab = ____QoS_Flow_Failed_Item_iE_Extensions__item__criticality_tab
    ___QoS_Flow_Failed_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QoS_Flow_Failed_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QoS_Flow_Failed_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____QoS_Flow_Failed_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____QoS_Flow_Failed_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoS_Flow_Failed_Item_iE_Extensions__item__extensionValue._const_tab = ____QoS_Flow_Failed_Item_iE_Extensions__item__extensionValue_tab
    ___QoS_Flow_Failed_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QoS_Flow_Failed_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QoS_Flow_Failed_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QoS_Flow_Failed_Item_iE_Extensions__item__id),
        ('criticality', ___QoS_Flow_Failed_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___QoS_Flow_Failed_Item_iE_Extensions__item__extensionValue),
        ])
    __QoS_Flow_Failed_Item_iE_Extensions__item_._ext = None
    _QoS_Flow_Failed_Item_iE_Extensions._cont = __QoS_Flow_Failed_Item_iE_Extensions__item_
    _QoS_Flow_Failed_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QoS_Flow_Failed_Item._cont = ASN1Dict([
        ('qoS-Flow-Identifier', _QoS_Flow_Failed_Item_qoS_Flow_Identifier),
        ('cause', _QoS_Flow_Failed_Item_cause),
        ('iE-Extensions', _QoS_Flow_Failed_Item_iE_Extensions),
        ])
    QoS_Flow_Failed_Item._ext = []
    
    #-----< QoS-Flow-Failed-Item-ExtIEs >-----#
    QoS_Flow_Failed_Item_ExtIEs = CLASS(name='QoS-Flow-Failed-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    QoS_Flow_Failed_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QoS-Flow-Mapping-List >-----#
    QoS_Flow_Mapping_List = SEQ_OF(name='QoS-Flow-Mapping-List', mode=MODE_TYPE)
    _QoS_Flow_Mapping_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Mapping-Item')))
    QoS_Flow_Mapping_List._cont = _QoS_Flow_Mapping_List__item_
    QoS_Flow_Mapping_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QoS-Flow-Mapping-Item >-----#
    QoS_Flow_Mapping_Item = SEQ(name='QoS-Flow-Mapping-Item', mode=MODE_TYPE)
    _QoS_Flow_Mapping_Item_qoS_Flow_Identifier = INT(name='qoS-Flow-Identifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Identifier')))
    _QoS_Flow_Mapping_Item_qoSFlowMappingIndication = ENUM(name='qoSFlowMappingIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Mapping-Indication')), opt=True)
    _QoS_Flow_Mapping_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QoS_Flow_Mapping_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___QoS_Flow_Mapping_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____QoS_Flow_Mapping_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____QoS_Flow_Mapping_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoS_Flow_Mapping_Item_iE_Extensions__item__id._const_tab = ____QoS_Flow_Mapping_Item_iE_Extensions__item__id_tab
    ___QoS_Flow_Mapping_Item_iE_Extensions__item__id._const_tab_at = None
    ___QoS_Flow_Mapping_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___QoS_Flow_Mapping_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____QoS_Flow_Mapping_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____QoS_Flow_Mapping_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoS_Flow_Mapping_Item_iE_Extensions__item__criticality._const_tab = ____QoS_Flow_Mapping_Item_iE_Extensions__item__criticality_tab
    ___QoS_Flow_Mapping_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QoS_Flow_Mapping_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QoS_Flow_Mapping_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____QoS_Flow_Mapping_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____QoS_Flow_Mapping_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoS_Flow_Mapping_Item_iE_Extensions__item__extensionValue._const_tab = ____QoS_Flow_Mapping_Item_iE_Extensions__item__extensionValue_tab
    ___QoS_Flow_Mapping_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QoS_Flow_Mapping_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QoS_Flow_Mapping_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QoS_Flow_Mapping_Item_iE_Extensions__item__id),
        ('criticality', ___QoS_Flow_Mapping_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___QoS_Flow_Mapping_Item_iE_Extensions__item__extensionValue),
        ])
    __QoS_Flow_Mapping_Item_iE_Extensions__item_._ext = None
    _QoS_Flow_Mapping_Item_iE_Extensions._cont = __QoS_Flow_Mapping_Item_iE_Extensions__item_
    _QoS_Flow_Mapping_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QoS_Flow_Mapping_Item._cont = ASN1Dict([
        ('qoS-Flow-Identifier', _QoS_Flow_Mapping_Item_qoS_Flow_Identifier),
        ('qoSFlowMappingIndication', _QoS_Flow_Mapping_Item_qoSFlowMappingIndication),
        ('iE-Extensions', _QoS_Flow_Mapping_Item_iE_Extensions),
        ])
    QoS_Flow_Mapping_Item._ext = []
    
    #-----< QoS-Flow-Mapping-Item-ExtIEs >-----#
    QoS_Flow_Mapping_Item_ExtIEs = CLASS(name='QoS-Flow-Mapping-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    QoS_Flow_Mapping_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QoS-Flow-Mapping-Indication >-----#
    QoS_Flow_Mapping_Indication = ENUM(name='QoS-Flow-Mapping-Indication', mode=MODE_TYPE)
    QoS_Flow_Mapping_Indication._cont = ASN1Dict([('ul', 0), ('dl', 1)])
    QoS_Flow_Mapping_Indication._ext = []
    
    #-----< QoS-Flows-DRB-Remapping >-----#
    QoS_Flows_DRB_Remapping = ENUM(name='QoS-Flows-DRB-Remapping', mode=MODE_TYPE)
    QoS_Flows_DRB_Remapping._cont = ASN1Dict([('update', 0), ('source-configuration', 1)])
    QoS_Flows_DRB_Remapping._ext = []
    
    #-----< QoS-Parameters-Support-List >-----#
    QoS_Parameters_Support_List = SEQ(name='QoS-Parameters-Support-List', mode=MODE_TYPE)
    _QoS_Parameters_Support_List_eUTRAN_QoS_Support_List = SEQ_OF(name='eUTRAN-QoS-Support-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'EUTRAN-QoS-Support-List')), opt=True)
    _QoS_Parameters_Support_List_nG_RAN_QoS_Support_List = SEQ_OF(name='nG-RAN-QoS-Support-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'NG-RAN-QoS-Support-List')), opt=True)
    _QoS_Parameters_Support_List_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QoS_Parameters_Support_List_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___QoS_Parameters_Support_List_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____QoS_Parameters_Support_List_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____QoS_Parameters_Support_List_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoS_Parameters_Support_List_iE_Extensions__item__id._const_tab = ____QoS_Parameters_Support_List_iE_Extensions__item__id_tab
    ___QoS_Parameters_Support_List_iE_Extensions__item__id._const_tab_at = None
    ___QoS_Parameters_Support_List_iE_Extensions__item__id._const_tab_id = 'id'
    ___QoS_Parameters_Support_List_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____QoS_Parameters_Support_List_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____QoS_Parameters_Support_List_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoS_Parameters_Support_List_iE_Extensions__item__criticality._const_tab = ____QoS_Parameters_Support_List_iE_Extensions__item__criticality_tab
    ___QoS_Parameters_Support_List_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QoS_Parameters_Support_List_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QoS_Parameters_Support_List_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____QoS_Parameters_Support_List_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____QoS_Parameters_Support_List_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoS_Parameters_Support_List_iE_Extensions__item__extensionValue._const_tab = ____QoS_Parameters_Support_List_iE_Extensions__item__extensionValue_tab
    ___QoS_Parameters_Support_List_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QoS_Parameters_Support_List_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QoS_Parameters_Support_List_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QoS_Parameters_Support_List_iE_Extensions__item__id),
        ('criticality', ___QoS_Parameters_Support_List_iE_Extensions__item__criticality),
        ('extensionValue', ___QoS_Parameters_Support_List_iE_Extensions__item__extensionValue),
        ])
    __QoS_Parameters_Support_List_iE_Extensions__item_._ext = None
    _QoS_Parameters_Support_List_iE_Extensions._cont = __QoS_Parameters_Support_List_iE_Extensions__item_
    _QoS_Parameters_Support_List_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QoS_Parameters_Support_List._cont = ASN1Dict([
        ('eUTRAN-QoS-Support-List', _QoS_Parameters_Support_List_eUTRAN_QoS_Support_List),
        ('nG-RAN-QoS-Support-List', _QoS_Parameters_Support_List_nG_RAN_QoS_Support_List),
        ('iE-Extensions', _QoS_Parameters_Support_List_iE_Extensions),
        ])
    QoS_Parameters_Support_List._ext = []
    
    #-----< QoS-Parameters-Support-List-ItemExtIEs >-----#
    QoS_Parameters_Support_List_ItemExtIEs = CLASS(name='QoS-Parameters-Support-List-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    QoS_Parameters_Support_List_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QoSPriorityLevel >-----#
    QoSPriorityLevel = INT(name='QoSPriorityLevel', mode=MODE_TYPE)
    QoSPriorityLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=[], er=[])
    
    #-----< QoS-Flow-QoS-Parameter-List >-----#
    QoS_Flow_QoS_Parameter_List = SEQ_OF(name='QoS-Flow-QoS-Parameter-List', mode=MODE_TYPE)
    _QoS_Flow_QoS_Parameter_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-QoS-Parameter-Item')))
    QoS_Flow_QoS_Parameter_List._cont = _QoS_Flow_QoS_Parameter_List__item_
    QoS_Flow_QoS_Parameter_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QoS-Flow-QoS-Parameter-Item >-----#
    QoS_Flow_QoS_Parameter_Item = SEQ(name='QoS-Flow-QoS-Parameter-Item', mode=MODE_TYPE)
    _QoS_Flow_QoS_Parameter_Item_qoS_Flow_Identifier = INT(name='qoS-Flow-Identifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Identifier')))
    _QoS_Flow_QoS_Parameter_Item_qoSFlowLevelQoSParameters = SEQ(name='qoSFlowLevelQoSParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoSFlowLevelQoSParameters')))
    _QoS_Flow_QoS_Parameter_Item_qoSFlowMappingIndication = ENUM(name='qoSFlowMappingIndication', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Mapping-Indication')), opt=True)
    _QoS_Flow_QoS_Parameter_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QoS_Flow_QoS_Parameter_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'RedundantQoSFlowIndicator')))
    _____QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TSCTrafficCharacteristics')))
    ____QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 99), ('criticality', 'ignore'), ('Extension', _____QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 100), ('criticality', 'ignore'), ('Extension', _____QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__id._const_tab = ____QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__id_tab
    ___QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__id._const_tab_at = None
    ___QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__criticality._const_tab = ____QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__id_tab
    ___QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__extensionValue._const_tab = ____QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__id_tab
    ___QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QoS_Flow_QoS_Parameter_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__id),
        ('criticality', ___QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__extensionValue),
        ])
    __QoS_Flow_QoS_Parameter_Item_iE_Extensions__item_._ext = None
    _QoS_Flow_QoS_Parameter_Item_iE_Extensions._cont = __QoS_Flow_QoS_Parameter_Item_iE_Extensions__item_
    _QoS_Flow_QoS_Parameter_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QoS_Flow_QoS_Parameter_Item._cont = ASN1Dict([
        ('qoS-Flow-Identifier', _QoS_Flow_QoS_Parameter_Item_qoS_Flow_Identifier),
        ('qoSFlowLevelQoSParameters', _QoS_Flow_QoS_Parameter_Item_qoSFlowLevelQoSParameters),
        ('qoSFlowMappingIndication', _QoS_Flow_QoS_Parameter_Item_qoSFlowMappingIndication),
        ('iE-Extensions', _QoS_Flow_QoS_Parameter_Item_iE_Extensions),
        ])
    QoS_Flow_QoS_Parameter_Item._ext = []
    
    #-----< QoS-Flow-QoS-Parameter-Item-ExtIEs >-----#
    QoS_Flow_QoS_Parameter_Item_ExtIEs = CLASS(name='QoS-Flow-QoS-Parameter-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _QoS_Flow_QoS_Parameter_Item_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'RedundantQoSFlowIndicator')))
    _QoS_Flow_QoS_Parameter_Item_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TSCTrafficCharacteristics')))
    QoS_Flow_QoS_Parameter_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 99), ('criticality', 'ignore'), ('Extension', _QoS_Flow_QoS_Parameter_Item_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 100), ('criticality', 'ignore'), ('Extension', _QoS_Flow_QoS_Parameter_Item_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< QoSFlowLevelQoSParameters >-----#
    QoSFlowLevelQoSParameters = SEQ(name='QoSFlowLevelQoSParameters', mode=MODE_TYPE)
    _QoSFlowLevelQoSParameters_qoS_Characteristics = CHOICE(name='qoS-Characteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Characteristics')))
    _QoSFlowLevelQoSParameters_nGRANallocationRetentionPriority = SEQ(name='nGRANallocationRetentionPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'NGRANAllocationAndRetentionPriority')))
    _QoSFlowLevelQoSParameters_gBR_QoS_Flow_Information = SEQ(name='gBR-QoS-Flow-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'GBR-QoSFlowInformation')), opt=True)
    _QoSFlowLevelQoSParameters_reflective_QoS_Attribute = ENUM(name='reflective-QoS-Attribute', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _QoSFlowLevelQoSParameters_reflective_QoS_Attribute._cont = ASN1Dict([('subject-to', 0)])
    _QoSFlowLevelQoSParameters_reflective_QoS_Attribute._ext = []
    _QoSFlowLevelQoSParameters_additional_QoS_Information = ENUM(name='additional-QoS-Information', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _QoSFlowLevelQoSParameters_additional_QoS_Information._cont = ASN1Dict([('more-likely', 0)])
    _QoSFlowLevelQoSParameters_additional_QoS_Information._ext = []
    _QoSFlowLevelQoSParameters_paging_Policy_Indicator = INT(name='paging-Policy-Indicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _QoSFlowLevelQoSParameters_paging_Policy_Indicator._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=[], er=[])
    _QoSFlowLevelQoSParameters_reflective_QoS_Indicator = ENUM(name='reflective-QoS-Indicator', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _QoSFlowLevelQoSParameters_reflective_QoS_Indicator._cont = ASN1Dict([('enabled', 0)])
    _QoSFlowLevelQoSParameters_reflective_QoS_Indicator._ext = []
    _QoSFlowLevelQoSParameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QoSFlowLevelQoSParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QosMonitoringRequest')))
    _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GBR-QoSFlowInformation')))
    _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QosMonitoringReportingFrequency')))
    _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QosMonitoringDisabled')))
    _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_4 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    ____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 87), ('criticality', 'ignore'), ('Extension', _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 126), ('criticality', 'ignore'), ('Extension', _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 132), ('criticality', 'ignore'), ('Extension', _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 133), ('criticality', 'ignore'), ('Extension', _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 142), ('criticality', 'ignore'), ('Extension', _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__id._const_tab = ____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__id._const_tab_at = None
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__criticality._const_tab = ____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__extensionValue._const_tab = ____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QoSFlowLevelQoSParameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QoSFlowLevelQoSParameters_iE_Extensions__item__id),
        ('criticality', ___QoSFlowLevelQoSParameters_iE_Extensions__item__criticality),
        ('extensionValue', ___QoSFlowLevelQoSParameters_iE_Extensions__item__extensionValue),
        ])
    __QoSFlowLevelQoSParameters_iE_Extensions__item_._ext = None
    _QoSFlowLevelQoSParameters_iE_Extensions._cont = __QoSFlowLevelQoSParameters_iE_Extensions__item_
    _QoSFlowLevelQoSParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QoSFlowLevelQoSParameters._cont = ASN1Dict([
        ('qoS-Characteristics', _QoSFlowLevelQoSParameters_qoS_Characteristics),
        ('nGRANallocationRetentionPriority', _QoSFlowLevelQoSParameters_nGRANallocationRetentionPriority),
        ('gBR-QoS-Flow-Information', _QoSFlowLevelQoSParameters_gBR_QoS_Flow_Information),
        ('reflective-QoS-Attribute', _QoSFlowLevelQoSParameters_reflective_QoS_Attribute),
        ('additional-QoS-Information', _QoSFlowLevelQoSParameters_additional_QoS_Information),
        ('paging-Policy-Indicator', _QoSFlowLevelQoSParameters_paging_Policy_Indicator),
        ('reflective-QoS-Indicator', _QoSFlowLevelQoSParameters_reflective_QoS_Indicator),
        ('iE-Extensions', _QoSFlowLevelQoSParameters_iE_Extensions),
        ])
    QoSFlowLevelQoSParameters._ext = None
    
    #-----< QoSFlowLevelQoSParameters-ExtIEs >-----#
    QoSFlowLevelQoSParameters_ExtIEs = CLASS(name='QoSFlowLevelQoSParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QosMonitoringRequest')))
    _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GBR-QoSFlowInformation')))
    _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QosMonitoringReportingFrequency')))
    _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QosMonitoringDisabled')))
    _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_4 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    QoSFlowLevelQoSParameters_ExtIEs._val = ASN1Set(rv=[dict([('id', 87), ('criticality', 'ignore'), ('Extension', _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 126), ('criticality', 'ignore'), ('Extension', _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 132), ('criticality', 'ignore'), ('Extension', _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 133), ('criticality', 'ignore'), ('Extension', _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 142), ('criticality', 'ignore'), ('Extension', _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< QosMonitoringRequest >-----#
    QosMonitoringRequest = ENUM(name='QosMonitoringRequest', mode=MODE_TYPE)
    QosMonitoringRequest._cont = ASN1Dict([('ul', 0), ('dl', 1), ('both', 2)])
    QosMonitoringRequest._ext = None
    
    #-----< QosMonitoringReportingFrequency >-----#
    QosMonitoringReportingFrequency = INT(name='QosMonitoringReportingFrequency', mode=MODE_TYPE)
    QosMonitoringReportingFrequency._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1800)], ev=[], er=[])
    
    #-----< QosMonitoringDisabled >-----#
    QosMonitoringDisabled = ENUM(name='QosMonitoringDisabled', mode=MODE_TYPE)
    QosMonitoringDisabled._cont = ASN1Dict([('true', 0)])
    QosMonitoringDisabled._ext = []
    
    #-----< QoS-Flow-Removed-Item >-----#
    QoS_Flow_Removed_Item = SEQ(name='QoS-Flow-Removed-Item', mode=MODE_TYPE)
    _QoS_Flow_Removed_Item_qoS_Flow_Identifier = INT(name='qoS-Flow-Identifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Identifier')))
    _QoS_Flow_Removed_Item_qoS_Flow_Released_In_Session = ENUM(name='qoS-Flow-Released-In-Session', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _QoS_Flow_Removed_Item_qoS_Flow_Released_In_Session._cont = ASN1Dict([('released-in-session', 0), ('not-released-in-session', 1)])
    _QoS_Flow_Removed_Item_qoS_Flow_Released_In_Session._ext = []
    _QoS_Flow_Removed_Item_qoS_Flow_Accumulated_Session_Time = OCT_STR(name='qoS-Flow-Accumulated-Session-Time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _QoS_Flow_Removed_Item_qoS_Flow_Accumulated_Session_Time._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _QoS_Flow_Removed_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QoS_Flow_Removed_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___QoS_Flow_Removed_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____QoS_Flow_Removed_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____QoS_Flow_Removed_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoS_Flow_Removed_Item_iE_Extensions__item__id._const_tab = ____QoS_Flow_Removed_Item_iE_Extensions__item__id_tab
    ___QoS_Flow_Removed_Item_iE_Extensions__item__id._const_tab_at = None
    ___QoS_Flow_Removed_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___QoS_Flow_Removed_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____QoS_Flow_Removed_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____QoS_Flow_Removed_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoS_Flow_Removed_Item_iE_Extensions__item__criticality._const_tab = ____QoS_Flow_Removed_Item_iE_Extensions__item__criticality_tab
    ___QoS_Flow_Removed_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QoS_Flow_Removed_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QoS_Flow_Removed_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____QoS_Flow_Removed_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____QoS_Flow_Removed_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoS_Flow_Removed_Item_iE_Extensions__item__extensionValue._const_tab = ____QoS_Flow_Removed_Item_iE_Extensions__item__extensionValue_tab
    ___QoS_Flow_Removed_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QoS_Flow_Removed_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QoS_Flow_Removed_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QoS_Flow_Removed_Item_iE_Extensions__item__id),
        ('criticality', ___QoS_Flow_Removed_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___QoS_Flow_Removed_Item_iE_Extensions__item__extensionValue),
        ])
    __QoS_Flow_Removed_Item_iE_Extensions__item_._ext = None
    _QoS_Flow_Removed_Item_iE_Extensions._cont = __QoS_Flow_Removed_Item_iE_Extensions__item_
    _QoS_Flow_Removed_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QoS_Flow_Removed_Item._cont = ASN1Dict([
        ('qoS-Flow-Identifier', _QoS_Flow_Removed_Item_qoS_Flow_Identifier),
        ('qoS-Flow-Released-In-Session', _QoS_Flow_Removed_Item_qoS_Flow_Released_In_Session),
        ('qoS-Flow-Accumulated-Session-Time', _QoS_Flow_Removed_Item_qoS_Flow_Accumulated_Session_Time),
        ('iE-Extensions', _QoS_Flow_Removed_Item_iE_Extensions),
        ])
    QoS_Flow_Removed_Item._ext = []
    
    #-----< QoS-Flow-Removed-Item-ExtIEs >-----#
    QoS_Flow_Removed_Item_ExtIEs = CLASS(name='QoS-Flow-Removed-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    QoS_Flow_Removed_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QoS-Flows-to-be-forwarded-List >-----#
    QoS_Flows_to_be_forwarded_List = SEQ_OF(name='QoS-Flows-to-be-forwarded-List', mode=MODE_TYPE)
    _QoS_Flows_to_be_forwarded_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flows-to-be-forwarded-Item')))
    QoS_Flows_to_be_forwarded_List._cont = _QoS_Flows_to_be_forwarded_List__item_
    QoS_Flows_to_be_forwarded_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QoS-Flows-to-be-forwarded-Item >-----#
    QoS_Flows_to_be_forwarded_Item = SEQ(name='QoS-Flows-to-be-forwarded-Item', mode=MODE_TYPE)
    _QoS_Flows_to_be_forwarded_Item_qoS_Flow_Identifier = INT(name='qoS-Flow-Identifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Identifier')))
    _QoS_Flows_to_be_forwarded_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QoS_Flows_to_be_forwarded_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__id._const_tab = ____QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__id_tab
    ___QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__id._const_tab_at = None
    ___QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__criticality._const_tab = ____QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__criticality_tab
    ___QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__extensionValue._const_tab = ____QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__extensionValue_tab
    ___QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QoS_Flows_to_be_forwarded_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__id),
        ('criticality', ___QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__extensionValue),
        ])
    __QoS_Flows_to_be_forwarded_Item_iE_Extensions__item_._ext = None
    _QoS_Flows_to_be_forwarded_Item_iE_Extensions._cont = __QoS_Flows_to_be_forwarded_Item_iE_Extensions__item_
    _QoS_Flows_to_be_forwarded_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QoS_Flows_to_be_forwarded_Item._cont = ASN1Dict([
        ('qoS-Flow-Identifier', _QoS_Flows_to_be_forwarded_Item_qoS_Flow_Identifier),
        ('iE-Extensions', _QoS_Flows_to_be_forwarded_Item_iE_Extensions),
        ])
    QoS_Flows_to_be_forwarded_Item._ext = []
    
    #-----< QoS-Flows-to-be-forwarded-Item-ExtIEs >-----#
    QoS_Flows_to_be_forwarded_Item_ExtIEs = CLASS(name='QoS-Flows-to-be-forwarded-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    QoS_Flows_to_be_forwarded_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QoS-Mapping-Information >-----#
    QoS_Mapping_Information = SEQ(name='QoS-Mapping-Information', mode=MODE_TYPE)
    _QoS_Mapping_Information_dscp = BIT_STR(name='dscp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _QoS_Mapping_Information_dscp._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    _QoS_Mapping_Information_flow_label = BIT_STR(name='flow-label', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _QoS_Mapping_Information_flow_label._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    QoS_Mapping_Information._cont = ASN1Dict([
        ('dscp', _QoS_Mapping_Information_dscp),
        ('flow-label', _QoS_Mapping_Information_flow_label),
        ])
    QoS_Mapping_Information._ext = []
    
    #-----< DataForwardingtoNG-RANQoSFlowInformationList >-----#
    DataForwardingtoNG_RANQoSFlowInformationList = SEQ_OF(name='DataForwardingtoNG-RANQoSFlowInformationList', mode=MODE_TYPE)
    _DataForwardingtoNG_RANQoSFlowInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DataForwardingtoNG-RANQoSFlowInformationList-Item')))
    DataForwardingtoNG_RANQoSFlowInformationList._cont = _DataForwardingtoNG_RANQoSFlowInformationList__item_
    DataForwardingtoNG_RANQoSFlowInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< DataForwardingtoNG-RANQoSFlowInformationList-Item >-----#
    DataForwardingtoNG_RANQoSFlowInformationList_Item = SEQ(name='DataForwardingtoNG-RANQoSFlowInformationList-Item', mode=MODE_TYPE)
    _DataForwardingtoNG_RANQoSFlowInformationList_Item_qoS_Flow_Identifier = INT(name='qoS-Flow-Identifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Flow-Identifier')))
    _DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__id._const_tab = ____DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__id_tab
    ___DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__id._const_tab_at = None
    ___DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__criticality._const_tab = ____DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__criticality_tab
    ___DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__extensionValue._const_tab = ____DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__extensionValue_tab
    ___DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__id),
        ('criticality', ___DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__extensionValue),
        ])
    __DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item_._ext = None
    _DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions._cont = __DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item_
    _DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DataForwardingtoNG_RANQoSFlowInformationList_Item._cont = ASN1Dict([
        ('qoS-Flow-Identifier', _DataForwardingtoNG_RANQoSFlowInformationList_Item_qoS_Flow_Identifier),
        ('iE-Extensions', _DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions),
        ])
    DataForwardingtoNG_RANQoSFlowInformationList_Item._ext = []
    
    #-----< DataForwardingtoNG-RANQoSFlowInformationList-Item-ExtIEs >-----#
    DataForwardingtoNG_RANQoSFlowInformationList_Item_ExtIEs = CLASS(name='DataForwardingtoNG-RANQoSFlowInformationList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    DataForwardingtoNG_RANQoSFlowInformationList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RANUEID >-----#
    RANUEID = OCT_STR(name='RANUEID', mode=MODE_TYPE)
    RANUEID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< RAT-Type >-----#
    RAT_Type = ENUM(name='RAT-Type', mode=MODE_TYPE)
    RAT_Type._cont = ASN1Dict([('e-UTRA', 0), ('nR', 1)])
    RAT_Type._ext = []
    
    #-----< RedundantQoSFlowIndicator >-----#
    RedundantQoSFlowIndicator = ENUM(name='RedundantQoSFlowIndicator', mode=MODE_TYPE)
    RedundantQoSFlowIndicator._cont = ASN1Dict([('true', 0), ('false', 1)])
    RedundantQoSFlowIndicator._ext = None
    
    #-----< RedundantPDUSessionInformation >-----#
    RedundantPDUSessionInformation = SEQ(name='RedundantPDUSessionInformation', mode=MODE_TYPE)
    _RedundantPDUSessionInformation_rSN = ENUM(name='rSN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'RSN')))
    _RedundantPDUSessionInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RedundantPDUSessionInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___RedundantPDUSessionInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RedundantPDUSessionInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____RedundantPDUSessionInformation_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDUSession-PairID')))
    ____RedundantPDUSessionInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 151), ('criticality', 'ignore'), ('Extension', _____RedundantPDUSessionInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RedundantPDUSessionInformation_iE_Extensions__item__id._const_tab = ____RedundantPDUSessionInformation_iE_Extensions__item__id_tab
    ___RedundantPDUSessionInformation_iE_Extensions__item__id._const_tab_at = None
    ___RedundantPDUSessionInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___RedundantPDUSessionInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RedundantPDUSessionInformation_iE_Extensions__item__criticality._const_tab = ____RedundantPDUSessionInformation_iE_Extensions__item__id_tab
    ___RedundantPDUSessionInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RedundantPDUSessionInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RedundantPDUSessionInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RedundantPDUSessionInformation_iE_Extensions__item__extensionValue._const_tab = ____RedundantPDUSessionInformation_iE_Extensions__item__id_tab
    ___RedundantPDUSessionInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RedundantPDUSessionInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RedundantPDUSessionInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RedundantPDUSessionInformation_iE_Extensions__item__id),
        ('criticality', ___RedundantPDUSessionInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___RedundantPDUSessionInformation_iE_Extensions__item__extensionValue),
        ])
    __RedundantPDUSessionInformation_iE_Extensions__item_._ext = None
    _RedundantPDUSessionInformation_iE_Extensions._cont = __RedundantPDUSessionInformation_iE_Extensions__item_
    _RedundantPDUSessionInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RedundantPDUSessionInformation._cont = ASN1Dict([
        ('rSN', _RedundantPDUSessionInformation_rSN),
        ('iE-Extensions', _RedundantPDUSessionInformation_iE_Extensions),
        ])
    RedundantPDUSessionInformation._ext = []
    
    #-----< RedundantPDUSessionInformation-ExtIEs >-----#
    RedundantPDUSessionInformation_ExtIEs = CLASS(name='RedundantPDUSessionInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _RedundantPDUSessionInformation_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDUSession-PairID')))
    RedundantPDUSessionInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 151), ('criticality', 'ignore'), ('Extension', _RedundantPDUSessionInformation_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RSN >-----#
    RSN = ENUM(name='RSN', mode=MODE_TYPE)
    RSN._cont = ASN1Dict([('v1', 0), ('v2', 1)])
    RSN._ext = []
    
    #-----< RetainabilityMeasurementsInfo >-----#
    RetainabilityMeasurementsInfo = SEQ_OF(name='RetainabilityMeasurementsInfo', mode=MODE_TYPE)
    _RetainabilityMeasurementsInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Removed-Item')))
    RetainabilityMeasurementsInfo._cont = _RetainabilityMeasurementsInfo__item_
    RetainabilityMeasurementsInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< RegistrationRequest >-----#
    RegistrationRequest = ENUM(name='RegistrationRequest', mode=MODE_TYPE)
    RegistrationRequest._cont = ASN1Dict([('start', 0), ('stop', 1)])
    RegistrationRequest._ext = []
    
    #-----< ReportCharacteristics >-----#
    ReportCharacteristics = BIT_STR(name='ReportCharacteristics', mode=MODE_TYPE)
    ReportCharacteristics._const_sz = ASN1Set(rv=[36], rr=[], ev=None, er=[])
    
    #-----< ReportingPeriodicity >-----#
    ReportingPeriodicity = ENUM(name='ReportingPeriodicity', mode=MODE_TYPE)
    ReportingPeriodicity._cont = ASN1Dict([('ms500', 0), ('ms1000', 1), ('ms2000', 2), ('ms5000', 3), ('ms10000', 4), ('ms20000', 5), ('ms30000', 6), ('ms40000', 7), ('ms50000', 8), ('ms60000', 9), ('ms70000', 10), ('ms80000', 11), ('ms90000', 12), ('ms100000', 13), ('ms110000', 14), ('ms120000', 15)])
    ReportingPeriodicity._ext = []
    
    #-----< RequestedAction4AvailNGUTermination >-----#
    RequestedAction4AvailNGUTermination = ENUM(name='RequestedAction4AvailNGUTermination', mode=MODE_TYPE)
    RequestedAction4AvailNGUTermination._cont = ASN1Dict([('apply-available-configuration', 0), ('apply-requested-configuration', 1), ('apply-available-configuration-if-same-as-requested', 2)])
    RequestedAction4AvailNGUTermination._ext = ['apply-available-configuration-if-same-as-requested']
    
    #-----< RLC-Mode >-----#
    RLC_Mode = ENUM(name='RLC-Mode', mode=MODE_TYPE)
    RLC_Mode._cont = ASN1Dict([('rlc-tm', 0), ('rlc-am', 1), ('rlc-um-bidirectional', 2), ('rlc-um-unidirectional-ul', 3), ('rlc-um-unidirectional-dl', 4)])
    RLC_Mode._ext = []
    
    #-----< ROHC-Parameters >-----#
    ROHC_Parameters = CHOICE(name='ROHC-Parameters', mode=MODE_TYPE)
    _ROHC_Parameters_rOHC = SEQ(name='rOHC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'ROHC')))
    _ROHC_Parameters_uPlinkOnlyROHC = SEQ(name='uPlinkOnlyROHC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UplinkOnlyROHC')))
    _ROHC_Parameters_choice_Extension = SEQ(name='choice-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __ROHC_Parameters_choice_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___ROHC_Parameters_choice_Extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___ROHC_Parameters_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ROHC_Parameters_choice_Extension_id._const_tab = ___ROHC_Parameters_choice_Extension_id_tab
    __ROHC_Parameters_choice_Extension_id._const_tab_at = None
    __ROHC_Parameters_choice_Extension_id._const_tab_id = 'id'
    __ROHC_Parameters_choice_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___ROHC_Parameters_choice_Extension_criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___ROHC_Parameters_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ROHC_Parameters_choice_Extension_criticality._const_tab = ___ROHC_Parameters_choice_Extension_criticality_tab
    __ROHC_Parameters_choice_Extension_criticality._const_tab_at = ('..', 'id')
    __ROHC_Parameters_choice_Extension_criticality._const_tab_id = 'criticality'
    __ROHC_Parameters_choice_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___ROHC_Parameters_choice_Extension_value_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___ROHC_Parameters_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ROHC_Parameters_choice_Extension_value._const_tab = ___ROHC_Parameters_choice_Extension_value_tab
    __ROHC_Parameters_choice_Extension_value._const_tab_at = ('..', 'id')
    __ROHC_Parameters_choice_Extension_value._const_tab_id = 'Value'
    _ROHC_Parameters_choice_Extension._cont = ASN1Dict([
        ('id', __ROHC_Parameters_choice_Extension_id),
        ('criticality', __ROHC_Parameters_choice_Extension_criticality),
        ('value', __ROHC_Parameters_choice_Extension_value),
        ])
    _ROHC_Parameters_choice_Extension._ext = None
    ROHC_Parameters._cont = ASN1Dict([
        ('rOHC', _ROHC_Parameters_rOHC),
        ('uPlinkOnlyROHC', _ROHC_Parameters_uPlinkOnlyROHC),
        ('choice-Extension', _ROHC_Parameters_choice_Extension),
        ])
    ROHC_Parameters._ext = None
    
    #-----< ROHC-Parameters-ExtIEs >-----#
    ROHC_Parameters_ExtIEs = CLASS(name='ROHC-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ROHC_Parameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ROHC >-----#
    ROHC = SEQ(name='ROHC', mode=MODE_TYPE)
    _ROHC_maxCID = INT(name='maxCID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ROHC_maxCID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=[], er=[])
    _ROHC_rOHC_Profiles = INT(name='rOHC-Profiles', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ROHC_rOHC_Profiles._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=[], er=[])
    _ROHC_continueROHC = ENUM(name='continueROHC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ROHC_continueROHC._cont = ASN1Dict([('true', 0)])
    _ROHC_continueROHC._ext = []
    _ROHC_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ROHC_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___ROHC_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ROHC_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____ROHC_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ROHC_iE_Extensions__item__id._const_tab = ____ROHC_iE_Extensions__item__id_tab
    ___ROHC_iE_Extensions__item__id._const_tab_at = None
    ___ROHC_iE_Extensions__item__id._const_tab_id = 'id'
    ___ROHC_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ROHC_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____ROHC_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ROHC_iE_Extensions__item__criticality._const_tab = ____ROHC_iE_Extensions__item__criticality_tab
    ___ROHC_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ROHC_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ROHC_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ROHC_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____ROHC_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ROHC_iE_Extensions__item__extensionValue._const_tab = ____ROHC_iE_Extensions__item__extensionValue_tab
    ___ROHC_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ROHC_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ROHC_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ROHC_iE_Extensions__item__id),
        ('criticality', ___ROHC_iE_Extensions__item__criticality),
        ('extensionValue', ___ROHC_iE_Extensions__item__extensionValue),
        ])
    __ROHC_iE_Extensions__item_._ext = None
    _ROHC_iE_Extensions._cont = __ROHC_iE_Extensions__item_
    _ROHC_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ROHC._cont = ASN1Dict([
        ('maxCID', _ROHC_maxCID),
        ('rOHC-Profiles', _ROHC_rOHC_Profiles),
        ('continueROHC', _ROHC_continueROHC),
        ('iE-Extensions', _ROHC_iE_Extensions),
        ])
    ROHC._ext = None
    
    #-----< ROHC-ExtIEs >-----#
    ROHC_ExtIEs = CLASS(name='ROHC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ROHC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SCGActivationStatus >-----#
    SCGActivationStatus = ENUM(name='SCGActivationStatus', mode=MODE_TYPE)
    SCGActivationStatus._cont = ASN1Dict([('scg-activated', 0), ('scg-deactivated', 1)])
    SCGActivationStatus._ext = []
    
    #-----< SecurityAlgorithm >-----#
    SecurityAlgorithm = SEQ(name='SecurityAlgorithm', mode=MODE_TYPE)
    _SecurityAlgorithm_cipheringAlgorithm = ENUM(name='cipheringAlgorithm', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'CipheringAlgorithm')))
    _SecurityAlgorithm_integrityProtectionAlgorithm = ENUM(name='integrityProtectionAlgorithm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'IntegrityProtectionAlgorithm')), opt=True)
    _SecurityAlgorithm_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecurityAlgorithm_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___SecurityAlgorithm_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SecurityAlgorithm_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____SecurityAlgorithm_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityAlgorithm_iE_Extensions__item__id._const_tab = ____SecurityAlgorithm_iE_Extensions__item__id_tab
    ___SecurityAlgorithm_iE_Extensions__item__id._const_tab_at = None
    ___SecurityAlgorithm_iE_Extensions__item__id._const_tab_id = 'id'
    ___SecurityAlgorithm_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SecurityAlgorithm_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____SecurityAlgorithm_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityAlgorithm_iE_Extensions__item__criticality._const_tab = ____SecurityAlgorithm_iE_Extensions__item__criticality_tab
    ___SecurityAlgorithm_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SecurityAlgorithm_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SecurityAlgorithm_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SecurityAlgorithm_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____SecurityAlgorithm_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityAlgorithm_iE_Extensions__item__extensionValue._const_tab = ____SecurityAlgorithm_iE_Extensions__item__extensionValue_tab
    ___SecurityAlgorithm_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecurityAlgorithm_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SecurityAlgorithm_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SecurityAlgorithm_iE_Extensions__item__id),
        ('criticality', ___SecurityAlgorithm_iE_Extensions__item__criticality),
        ('extensionValue', ___SecurityAlgorithm_iE_Extensions__item__extensionValue),
        ])
    __SecurityAlgorithm_iE_Extensions__item_._ext = None
    _SecurityAlgorithm_iE_Extensions._cont = __SecurityAlgorithm_iE_Extensions__item_
    _SecurityAlgorithm_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecurityAlgorithm._cont = ASN1Dict([
        ('cipheringAlgorithm', _SecurityAlgorithm_cipheringAlgorithm),
        ('integrityProtectionAlgorithm', _SecurityAlgorithm_integrityProtectionAlgorithm),
        ('iE-Extensions', _SecurityAlgorithm_iE_Extensions),
        ])
    SecurityAlgorithm._ext = []
    
    #-----< SecurityAlgorithm-ExtIEs >-----#
    SecurityAlgorithm_ExtIEs = CLASS(name='SecurityAlgorithm-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    SecurityAlgorithm_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecurityIndication >-----#
    SecurityIndication = SEQ(name='SecurityIndication', mode=MODE_TYPE)
    _SecurityIndication_integrityProtectionIndication = ENUM(name='integrityProtectionIndication', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'IntegrityProtectionIndication')))
    _SecurityIndication_confidentialityProtectionIndication = ENUM(name='confidentialityProtectionIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'ConfidentialityProtectionIndication')))
    _SecurityIndication_maximumIPdatarate = SEQ(name='maximumIPdatarate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'MaximumIPdatarate')), opt=True)
    _SecurityIndication_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecurityIndication_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___SecurityIndication_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SecurityIndication_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____SecurityIndication_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityIndication_iE_Extensions__item__id._const_tab = ____SecurityIndication_iE_Extensions__item__id_tab
    ___SecurityIndication_iE_Extensions__item__id._const_tab_at = None
    ___SecurityIndication_iE_Extensions__item__id._const_tab_id = 'id'
    ___SecurityIndication_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SecurityIndication_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____SecurityIndication_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityIndication_iE_Extensions__item__criticality._const_tab = ____SecurityIndication_iE_Extensions__item__criticality_tab
    ___SecurityIndication_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SecurityIndication_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SecurityIndication_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SecurityIndication_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____SecurityIndication_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityIndication_iE_Extensions__item__extensionValue._const_tab = ____SecurityIndication_iE_Extensions__item__extensionValue_tab
    ___SecurityIndication_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecurityIndication_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SecurityIndication_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SecurityIndication_iE_Extensions__item__id),
        ('criticality', ___SecurityIndication_iE_Extensions__item__criticality),
        ('extensionValue', ___SecurityIndication_iE_Extensions__item__extensionValue),
        ])
    __SecurityIndication_iE_Extensions__item_._ext = None
    _SecurityIndication_iE_Extensions._cont = __SecurityIndication_iE_Extensions__item_
    _SecurityIndication_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecurityIndication._cont = ASN1Dict([
        ('integrityProtectionIndication', _SecurityIndication_integrityProtectionIndication),
        ('confidentialityProtectionIndication', _SecurityIndication_confidentialityProtectionIndication),
        ('maximumIPdatarate', _SecurityIndication_maximumIPdatarate),
        ('iE-Extensions', _SecurityIndication_iE_Extensions),
        ])
    SecurityIndication._ext = []
    
    #-----< SecurityIndication-ExtIEs >-----#
    SecurityIndication_ExtIEs = CLASS(name='SecurityIndication-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    SecurityIndication_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecurityInformation >-----#
    SecurityInformation = SEQ(name='SecurityInformation', mode=MODE_TYPE)
    _SecurityInformation_securityAlgorithm = SEQ(name='securityAlgorithm', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'SecurityAlgorithm')))
    _SecurityInformation_uPSecuritykey = SEQ(name='uPSecuritykey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UPSecuritykey')))
    _SecurityInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecurityInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___SecurityInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SecurityInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____SecurityInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityInformation_iE_Extensions__item__id._const_tab = ____SecurityInformation_iE_Extensions__item__id_tab
    ___SecurityInformation_iE_Extensions__item__id._const_tab_at = None
    ___SecurityInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___SecurityInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SecurityInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____SecurityInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityInformation_iE_Extensions__item__criticality._const_tab = ____SecurityInformation_iE_Extensions__item__criticality_tab
    ___SecurityInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SecurityInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SecurityInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SecurityInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____SecurityInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityInformation_iE_Extensions__item__extensionValue._const_tab = ____SecurityInformation_iE_Extensions__item__extensionValue_tab
    ___SecurityInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecurityInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SecurityInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SecurityInformation_iE_Extensions__item__id),
        ('criticality', ___SecurityInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___SecurityInformation_iE_Extensions__item__extensionValue),
        ])
    __SecurityInformation_iE_Extensions__item_._ext = None
    _SecurityInformation_iE_Extensions._cont = __SecurityInformation_iE_Extensions__item_
    _SecurityInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecurityInformation._cont = ASN1Dict([
        ('securityAlgorithm', _SecurityInformation_securityAlgorithm),
        ('uPSecuritykey', _SecurityInformation_uPSecuritykey),
        ('iE-Extensions', _SecurityInformation_iE_Extensions),
        ])
    SecurityInformation._ext = []
    
    #-----< SecurityInformation-ExtIEs >-----#
    SecurityInformation_ExtIEs = CLASS(name='SecurityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    SecurityInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecurityResult >-----#
    SecurityResult = SEQ(name='SecurityResult', mode=MODE_TYPE)
    _SecurityResult_integrityProtectionResult = ENUM(name='integrityProtectionResult', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'IntegrityProtectionResult')))
    _SecurityResult_confidentialityProtectionResult = ENUM(name='confidentialityProtectionResult', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'ConfidentialityProtectionResult')))
    _SecurityResult_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecurityResult_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___SecurityResult_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SecurityResult_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____SecurityResult_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityResult_iE_Extensions__item__id._const_tab = ____SecurityResult_iE_Extensions__item__id_tab
    ___SecurityResult_iE_Extensions__item__id._const_tab_at = None
    ___SecurityResult_iE_Extensions__item__id._const_tab_id = 'id'
    ___SecurityResult_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SecurityResult_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____SecurityResult_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityResult_iE_Extensions__item__criticality._const_tab = ____SecurityResult_iE_Extensions__item__criticality_tab
    ___SecurityResult_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SecurityResult_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SecurityResult_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SecurityResult_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____SecurityResult_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityResult_iE_Extensions__item__extensionValue._const_tab = ____SecurityResult_iE_Extensions__item__extensionValue_tab
    ___SecurityResult_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecurityResult_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SecurityResult_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SecurityResult_iE_Extensions__item__id),
        ('criticality', ___SecurityResult_iE_Extensions__item__criticality),
        ('extensionValue', ___SecurityResult_iE_Extensions__item__extensionValue),
        ])
    __SecurityResult_iE_Extensions__item_._ext = None
    _SecurityResult_iE_Extensions._cont = __SecurityResult_iE_Extensions__item_
    _SecurityResult_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecurityResult._cont = ASN1Dict([
        ('integrityProtectionResult', _SecurityResult_integrityProtectionResult),
        ('confidentialityProtectionResult', _SecurityResult_confidentialityProtectionResult),
        ('iE-Extensions', _SecurityResult_iE_Extensions),
        ])
    SecurityResult._ext = []
    
    #-----< SecurityResult-ExtIEs >-----#
    SecurityResult_ExtIEs = CLASS(name='SecurityResult-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    SecurityResult_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Slice-Support-List >-----#
    Slice_Support_List = SEQ_OF(name='Slice-Support-List', mode=MODE_TYPE)
    _Slice_Support_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Slice-Support-Item')))
    Slice_Support_List._cont = _Slice_Support_List__item_
    Slice_Support_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< Slice-Support-Item >-----#
    Slice_Support_Item = SEQ(name='Slice-Support-Item', mode=MODE_TYPE)
    _Slice_Support_Item_sNSSAI = SEQ(name='sNSSAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'SNSSAI')))
    _Slice_Support_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Slice_Support_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___Slice_Support_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Slice_Support_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Slice_Support_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Slice_Support_Item_iE_Extensions__item__id._const_tab = ____Slice_Support_Item_iE_Extensions__item__id_tab
    ___Slice_Support_Item_iE_Extensions__item__id._const_tab_at = None
    ___Slice_Support_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Slice_Support_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Slice_Support_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Slice_Support_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Slice_Support_Item_iE_Extensions__item__criticality._const_tab = ____Slice_Support_Item_iE_Extensions__item__criticality_tab
    ___Slice_Support_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Slice_Support_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Slice_Support_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Slice_Support_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Slice_Support_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Slice_Support_Item_iE_Extensions__item__extensionValue._const_tab = ____Slice_Support_Item_iE_Extensions__item__extensionValue_tab
    ___Slice_Support_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Slice_Support_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Slice_Support_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Slice_Support_Item_iE_Extensions__item__id),
        ('criticality', ___Slice_Support_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Slice_Support_Item_iE_Extensions__item__extensionValue),
        ])
    __Slice_Support_Item_iE_Extensions__item_._ext = None
    _Slice_Support_Item_iE_Extensions._cont = __Slice_Support_Item_iE_Extensions__item_
    _Slice_Support_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Slice_Support_Item._cont = ASN1Dict([
        ('sNSSAI', _Slice_Support_Item_sNSSAI),
        ('iE-Extensions', _Slice_Support_Item_iE_Extensions),
        ])
    Slice_Support_Item._ext = None
    
    #-----< Slice-Support-Item-ExtIEs >-----#
    Slice_Support_Item_ExtIEs = CLASS(name='Slice-Support-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    Slice_Support_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SNSSAI >-----#
    SNSSAI = SEQ(name='SNSSAI', mode=MODE_TYPE)
    _SNSSAI_sST = OCT_STR(name='sST', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SNSSAI_sST._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _SNSSAI_sD = OCT_STR(name='sD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SNSSAI_sD._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _SNSSAI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SNSSAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___SNSSAI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SNSSAI_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____SNSSAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNSSAI_iE_Extensions__item__id._const_tab = ____SNSSAI_iE_Extensions__item__id_tab
    ___SNSSAI_iE_Extensions__item__id._const_tab_at = None
    ___SNSSAI_iE_Extensions__item__id._const_tab_id = 'id'
    ___SNSSAI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SNSSAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____SNSSAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNSSAI_iE_Extensions__item__criticality._const_tab = ____SNSSAI_iE_Extensions__item__criticality_tab
    ___SNSSAI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SNSSAI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SNSSAI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SNSSAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____SNSSAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNSSAI_iE_Extensions__item__extensionValue._const_tab = ____SNSSAI_iE_Extensions__item__extensionValue_tab
    ___SNSSAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SNSSAI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SNSSAI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SNSSAI_iE_Extensions__item__id),
        ('criticality', ___SNSSAI_iE_Extensions__item__criticality),
        ('extensionValue', ___SNSSAI_iE_Extensions__item__extensionValue),
        ])
    __SNSSAI_iE_Extensions__item_._ext = None
    _SNSSAI_iE_Extensions._cont = __SNSSAI_iE_Extensions__item_
    _SNSSAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SNSSAI._cont = ASN1Dict([
        ('sST', _SNSSAI_sST),
        ('sD', _SNSSAI_sD),
        ('iE-Extensions', _SNSSAI_iE_Extensions),
        ])
    SNSSAI._ext = []
    
    #-----< SNSSAI-ExtIEs >-----#
    SNSSAI_ExtIEs = CLASS(name='SNSSAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    SNSSAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SDAP-Configuration >-----#
    SDAP_Configuration = SEQ(name='SDAP-Configuration', mode=MODE_TYPE)
    _SDAP_Configuration_defaultDRB = ENUM(name='defaultDRB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'DefaultDRB')))
    _SDAP_Configuration_sDAP_Header_UL = ENUM(name='sDAP-Header-UL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'SDAP-Header-UL')))
    _SDAP_Configuration_sDAP_Header_DL = ENUM(name='sDAP-Header-DL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'SDAP-Header-DL')))
    _SDAP_Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SDAP_Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___SDAP_Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SDAP_Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____SDAP_Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SDAP_Configuration_iE_Extensions__item__id._const_tab = ____SDAP_Configuration_iE_Extensions__item__id_tab
    ___SDAP_Configuration_iE_Extensions__item__id._const_tab_at = None
    ___SDAP_Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___SDAP_Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SDAP_Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____SDAP_Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SDAP_Configuration_iE_Extensions__item__criticality._const_tab = ____SDAP_Configuration_iE_Extensions__item__criticality_tab
    ___SDAP_Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SDAP_Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SDAP_Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SDAP_Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____SDAP_Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SDAP_Configuration_iE_Extensions__item__extensionValue._const_tab = ____SDAP_Configuration_iE_Extensions__item__extensionValue_tab
    ___SDAP_Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SDAP_Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SDAP_Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SDAP_Configuration_iE_Extensions__item__id),
        ('criticality', ___SDAP_Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___SDAP_Configuration_iE_Extensions__item__extensionValue),
        ])
    __SDAP_Configuration_iE_Extensions__item_._ext = None
    _SDAP_Configuration_iE_Extensions._cont = __SDAP_Configuration_iE_Extensions__item_
    _SDAP_Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SDAP_Configuration._cont = ASN1Dict([
        ('defaultDRB', _SDAP_Configuration_defaultDRB),
        ('sDAP-Header-UL', _SDAP_Configuration_sDAP_Header_UL),
        ('sDAP-Header-DL', _SDAP_Configuration_sDAP_Header_DL),
        ('iE-Extensions', _SDAP_Configuration_iE_Extensions),
        ])
    SDAP_Configuration._ext = []
    
    #-----< SDAP-Configuration-ExtIEs >-----#
    SDAP_Configuration_ExtIEs = CLASS(name='SDAP-Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    SDAP_Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SDAP-Header-DL >-----#
    SDAP_Header_DL = ENUM(name='SDAP-Header-DL', mode=MODE_TYPE)
    SDAP_Header_DL._cont = ASN1Dict([('present', 0), ('absent', 1)])
    SDAP_Header_DL._ext = []
    
    #-----< SDAP-Header-UL >-----#
    SDAP_Header_UL = ENUM(name='SDAP-Header-UL', mode=MODE_TYPE)
    SDAP_Header_UL._cont = ASN1Dict([('present', 0), ('absent', 1)])
    SDAP_Header_UL._ext = []
    
    #-----< SDTContinueROHC >-----#
    SDTContinueROHC = ENUM(name='SDTContinueROHC', mode=MODE_TYPE)
    SDTContinueROHC._cont = ASN1Dict([('true', 0)])
    SDTContinueROHC._ext = []
    
    #-----< SDTindicatorSetup >-----#
    SDTindicatorSetup = ENUM(name='SDTindicatorSetup', mode=MODE_TYPE)
    SDTindicatorSetup._cont = ASN1Dict([('true', 0)])
    SDTindicatorSetup._ext = []
    
    #-----< SDTindicatorMod >-----#
    SDTindicatorMod = ENUM(name='SDTindicatorMod', mode=MODE_TYPE)
    SDTindicatorMod._cont = ASN1Dict([('true', 0), ('false', 1)])
    SDTindicatorMod._ext = []
    
    #-----< SubscriberProfileIDforRFP >-----#
    SubscriberProfileIDforRFP = INT(name='SubscriberProfileIDforRFP', mode=MODE_TYPE)
    SubscriberProfileIDforRFP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=[], er=[])
    
    #-----< SurvivalTime >-----#
    SurvivalTime = INT(name='SurvivalTime', mode=MODE_TYPE)
    SurvivalTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1920000)], ev=[], er=[])
    
    #-----< TimeToWait >-----#
    TimeToWait = ENUM(name='TimeToWait', mode=MODE_TYPE)
    TimeToWait._cont = ASN1Dict([('v1s', 0), ('v2s', 1), ('v5s', 2), ('v10s', 3), ('v20s', 4), ('v60s', 5)])
    TimeToWait._ext = []
    
    #-----< TNLAssociationUsage >-----#
    TNLAssociationUsage = ENUM(name='TNLAssociationUsage', mode=MODE_TYPE)
    TNLAssociationUsage._cont = ASN1Dict([('ue', 0), ('non-ue', 1), ('both', 2)])
    TNLAssociationUsage._ext = []
    
    #-----< TNL-AvailableCapacityIndicator >-----#
    TNL_AvailableCapacityIndicator = SEQ(name='TNL-AvailableCapacityIndicator', mode=MODE_TYPE)
    _TNL_AvailableCapacityIndicator_dL_TNL_OfferedCapacity = INT(name='dL-TNL-OfferedCapacity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TNL_AvailableCapacityIndicator_dL_TNL_OfferedCapacity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777216)], ev=[], er=[])
    _TNL_AvailableCapacityIndicator_dL_TNL_AvailableCapacity = INT(name='dL-TNL-AvailableCapacity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TNL_AvailableCapacityIndicator_dL_TNL_AvailableCapacity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=[], er=[])
    _TNL_AvailableCapacityIndicator_uL_TNL_OfferedCapacity = INT(name='uL-TNL-OfferedCapacity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TNL_AvailableCapacityIndicator_uL_TNL_OfferedCapacity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777216)], ev=[], er=[])
    _TNL_AvailableCapacityIndicator_uL_TNL_AvailableCapacity = INT(name='uL-TNL-AvailableCapacity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TNL_AvailableCapacityIndicator_uL_TNL_AvailableCapacity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=[], er=[])
    _TNL_AvailableCapacityIndicator_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TNL_AvailableCapacityIndicator_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___TNL_AvailableCapacityIndicator_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TNL_AvailableCapacityIndicator_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____TNL_AvailableCapacityIndicator_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNL_AvailableCapacityIndicator_iE_Extensions__item__id._const_tab = ____TNL_AvailableCapacityIndicator_iE_Extensions__item__id_tab
    ___TNL_AvailableCapacityIndicator_iE_Extensions__item__id._const_tab_at = None
    ___TNL_AvailableCapacityIndicator_iE_Extensions__item__id._const_tab_id = 'id'
    ___TNL_AvailableCapacityIndicator_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TNL_AvailableCapacityIndicator_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____TNL_AvailableCapacityIndicator_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNL_AvailableCapacityIndicator_iE_Extensions__item__criticality._const_tab = ____TNL_AvailableCapacityIndicator_iE_Extensions__item__criticality_tab
    ___TNL_AvailableCapacityIndicator_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TNL_AvailableCapacityIndicator_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TNL_AvailableCapacityIndicator_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TNL_AvailableCapacityIndicator_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____TNL_AvailableCapacityIndicator_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNL_AvailableCapacityIndicator_iE_Extensions__item__extensionValue._const_tab = ____TNL_AvailableCapacityIndicator_iE_Extensions__item__extensionValue_tab
    ___TNL_AvailableCapacityIndicator_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TNL_AvailableCapacityIndicator_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TNL_AvailableCapacityIndicator_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TNL_AvailableCapacityIndicator_iE_Extensions__item__id),
        ('criticality', ___TNL_AvailableCapacityIndicator_iE_Extensions__item__criticality),
        ('extensionValue', ___TNL_AvailableCapacityIndicator_iE_Extensions__item__extensionValue),
        ])
    __TNL_AvailableCapacityIndicator_iE_Extensions__item_._ext = None
    _TNL_AvailableCapacityIndicator_iE_Extensions._cont = __TNL_AvailableCapacityIndicator_iE_Extensions__item_
    _TNL_AvailableCapacityIndicator_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TNL_AvailableCapacityIndicator._cont = ASN1Dict([
        ('dL-TNL-OfferedCapacity', _TNL_AvailableCapacityIndicator_dL_TNL_OfferedCapacity),
        ('dL-TNL-AvailableCapacity', _TNL_AvailableCapacityIndicator_dL_TNL_AvailableCapacity),
        ('uL-TNL-OfferedCapacity', _TNL_AvailableCapacityIndicator_uL_TNL_OfferedCapacity),
        ('uL-TNL-AvailableCapacity', _TNL_AvailableCapacityIndicator_uL_TNL_AvailableCapacity),
        ('iE-Extensions', _TNL_AvailableCapacityIndicator_iE_Extensions),
        ])
    TNL_AvailableCapacityIndicator._ext = []
    
    #-----< TNL-AvailableCapacityIndicator-ExtIEs >-----#
    TNL_AvailableCapacityIndicator_ExtIEs = CLASS(name='TNL-AvailableCapacityIndicator-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    TNL_AvailableCapacityIndicator_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TSCTrafficCharacteristics >-----#
    TSCTrafficCharacteristics = SEQ(name='TSCTrafficCharacteristics', mode=MODE_TYPE)
    _TSCTrafficCharacteristics_tSCTrafficCharacteristicsUL = SEQ(name='tSCTrafficCharacteristicsUL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'TSCTrafficInformation')), opt=True)
    _TSCTrafficCharacteristics_tSCTrafficCharacteristicsDL = SEQ(name='tSCTrafficCharacteristicsDL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'TSCTrafficInformation')), opt=True)
    _TSCTrafficCharacteristics_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TSCTrafficCharacteristics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___TSCTrafficCharacteristics_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TSCTrafficCharacteristics_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____TSCTrafficCharacteristics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TSCTrafficCharacteristics_iE_Extensions__item__id._const_tab = ____TSCTrafficCharacteristics_iE_Extensions__item__id_tab
    ___TSCTrafficCharacteristics_iE_Extensions__item__id._const_tab_at = None
    ___TSCTrafficCharacteristics_iE_Extensions__item__id._const_tab_id = 'id'
    ___TSCTrafficCharacteristics_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TSCTrafficCharacteristics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____TSCTrafficCharacteristics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TSCTrafficCharacteristics_iE_Extensions__item__criticality._const_tab = ____TSCTrafficCharacteristics_iE_Extensions__item__criticality_tab
    ___TSCTrafficCharacteristics_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TSCTrafficCharacteristics_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TSCTrafficCharacteristics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____TSCTrafficCharacteristics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue._const_tab = ____TSCTrafficCharacteristics_iE_Extensions__item__extensionValue_tab
    ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TSCTrafficCharacteristics_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TSCTrafficCharacteristics_iE_Extensions__item__id),
        ('criticality', ___TSCTrafficCharacteristics_iE_Extensions__item__criticality),
        ('extensionValue', ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue),
        ])
    __TSCTrafficCharacteristics_iE_Extensions__item_._ext = None
    _TSCTrafficCharacteristics_iE_Extensions._cont = __TSCTrafficCharacteristics_iE_Extensions__item_
    _TSCTrafficCharacteristics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TSCTrafficCharacteristics._cont = ASN1Dict([
        ('tSCTrafficCharacteristicsUL', _TSCTrafficCharacteristics_tSCTrafficCharacteristicsUL),
        ('tSCTrafficCharacteristicsDL', _TSCTrafficCharacteristics_tSCTrafficCharacteristicsDL),
        ('iE-Extensions', _TSCTrafficCharacteristics_iE_Extensions),
        ])
    TSCTrafficCharacteristics._ext = None
    
    #-----< TSCTrafficCharacteristics-ExtIEs >-----#
    TSCTrafficCharacteristics_ExtIEs = CLASS(name='TSCTrafficCharacteristics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    TSCTrafficCharacteristics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TSCTrafficInformation >-----#
    TSCTrafficInformation = SEQ(name='TSCTrafficInformation', mode=MODE_TYPE)
    _TSCTrafficInformation_periodicity = INT(name='periodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Periodicity')))
    _TSCTrafficInformation_burstArrivalTime = OCT_STR(name='burstArrivalTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BurstArrivalTime')), opt=True)
    _TSCTrafficInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TSCTrafficInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___TSCTrafficInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TSCTrafficInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____TSCTrafficInformation_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SurvivalTime')))
    ____TSCTrafficInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 152), ('criticality', 'ignore'), ('Extension', _____TSCTrafficInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TSCTrafficInformation_iE_Extensions__item__id._const_tab = ____TSCTrafficInformation_iE_Extensions__item__id_tab
    ___TSCTrafficInformation_iE_Extensions__item__id._const_tab_at = None
    ___TSCTrafficInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TSCTrafficInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TSCTrafficInformation_iE_Extensions__item__criticality._const_tab = ____TSCTrafficInformation_iE_Extensions__item__id_tab
    ___TSCTrafficInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TSCTrafficInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TSCTrafficInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TSCTrafficInformation_iE_Extensions__item__extensionValue._const_tab = ____TSCTrafficInformation_iE_Extensions__item__id_tab
    ___TSCTrafficInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TSCTrafficInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TSCTrafficInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TSCTrafficInformation_iE_Extensions__item__id),
        ('criticality', ___TSCTrafficInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___TSCTrafficInformation_iE_Extensions__item__extensionValue),
        ])
    __TSCTrafficInformation_iE_Extensions__item_._ext = None
    _TSCTrafficInformation_iE_Extensions._cont = __TSCTrafficInformation_iE_Extensions__item_
    _TSCTrafficInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TSCTrafficInformation._cont = ASN1Dict([
        ('periodicity', _TSCTrafficInformation_periodicity),
        ('burstArrivalTime', _TSCTrafficInformation_burstArrivalTime),
        ('iE-Extensions', _TSCTrafficInformation_iE_Extensions),
        ])
    TSCTrafficInformation._ext = None
    
    #-----< TSCTrafficInformation-ExtIEs >-----#
    TSCTrafficInformation_ExtIEs = CLASS(name='TSCTrafficInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _TSCTrafficInformation_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SurvivalTime')))
    TSCTrafficInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 152), ('criticality', 'ignore'), ('Extension', _TSCTrafficInformation_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Periodicity >-----#
    Periodicity = INT(name='Periodicity', mode=MODE_TYPE)
    Periodicity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=640000)], ev=[], er=[])
    
    #-----< BurstArrivalTime >-----#
    BurstArrivalTime = OCT_STR(name='BurstArrivalTime', mode=MODE_TYPE)
    
    #-----< TraceActivation >-----#
    TraceActivation = SEQ(name='TraceActivation', mode=MODE_TYPE)
    _TraceActivation_traceID = OCT_STR(name='traceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'TraceID')))
    _TraceActivation_interfacesToTrace = BIT_STR(name='interfacesToTrace', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'InterfacesToTrace')))
    _TraceActivation_traceDepth = ENUM(name='traceDepth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'TraceDepth')))
    _TraceActivation_traceCollectionEntityIPAddress = BIT_STR(name='traceCollectionEntityIPAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    _TraceActivation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TraceActivation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___TraceActivation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TraceActivation_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MDT-Configuration')))
    _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_1 = STR_VIS(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'URIaddress')))
    ____TraceActivation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 112), ('criticality', 'ignore'), ('Extension', _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 116), ('criticality', 'ignore'), ('Extension', _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TraceActivation_iE_Extensions__item__id._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__id._const_tab_at = None
    ___TraceActivation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TraceActivation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TraceActivation_iE_Extensions__item__criticality._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TraceActivation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TraceActivation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TraceActivation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TraceActivation_iE_Extensions__item__id),
        ('criticality', ___TraceActivation_iE_Extensions__item__criticality),
        ('extensionValue', ___TraceActivation_iE_Extensions__item__extensionValue),
        ])
    __TraceActivation_iE_Extensions__item_._ext = None
    _TraceActivation_iE_Extensions._cont = __TraceActivation_iE_Extensions__item_
    _TraceActivation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TraceActivation._cont = ASN1Dict([
        ('traceID', _TraceActivation_traceID),
        ('interfacesToTrace', _TraceActivation_interfacesToTrace),
        ('traceDepth', _TraceActivation_traceDepth),
        ('traceCollectionEntityIPAddress', _TraceActivation_traceCollectionEntityIPAddress),
        ('iE-Extensions', _TraceActivation_iE_Extensions),
        ])
    TraceActivation._ext = []
    
    #-----< TraceActivation-ExtIEs >-----#
    TraceActivation_ExtIEs = CLASS(name='TraceActivation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _TraceActivation_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MDT-Configuration')))
    _TraceActivation_ExtIEs_val_Extension_1 = STR_VIS(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'URIaddress')))
    TraceActivation_ExtIEs._val = ASN1Set(rv=[dict([('id', 112), ('criticality', 'ignore'), ('Extension', _TraceActivation_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 116), ('criticality', 'ignore'), ('Extension', _TraceActivation_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TraceDepth >-----#
    TraceDepth = ENUM(name='TraceDepth', mode=MODE_TYPE)
    TraceDepth._cont = ASN1Dict([('minimum', 0), ('medium', 1), ('maximum', 2), ('minimumWithoutVendorSpecificExtension', 3), ('mediumWithoutVendorSpecificExtension', 4), ('maximumWithoutVendorSpecificExtension', 5)])
    TraceDepth._ext = []
    
    #-----< TraceID >-----#
    TraceID = OCT_STR(name='TraceID', mode=MODE_TYPE)
    TraceID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< TransportLayerAddress >-----#
    TransportLayerAddress = BIT_STR(name='TransportLayerAddress', mode=MODE_TYPE)
    TransportLayerAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=[], er=[])
    
    #-----< TransactionID >-----#
    TransactionID = INT(name='TransactionID', mode=MODE_TYPE)
    TransactionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< T-Reordering >-----#
    T_Reordering = ENUM(name='T-Reordering', mode=MODE_TYPE)
    T_Reordering._cont = ASN1Dict([('ms0', 0), ('ms1', 1), ('ms2', 2), ('ms4', 3), ('ms5', 4), ('ms8', 5), ('ms10', 6), ('ms15', 7), ('ms20', 8), ('ms30', 9), ('ms40', 10), ('ms50', 11), ('ms60', 12), ('ms80', 13), ('ms100', 14), ('ms120', 15), ('ms140', 16), ('ms160', 17), ('ms180', 18), ('ms200', 19), ('ms220', 20), ('ms240', 21), ('ms260', 22), ('ms280', 23), ('ms300', 24), ('ms500', 25), ('ms750', 26), ('ms1000', 27), ('ms1250', 28), ('ms1500', 29), ('ms1750', 30), ('ms2000', 31), ('ms2250', 32), ('ms2500', 33), ('ms2750', 34), ('ms3000', 35)])
    T_Reordering._ext = []
    
    #-----< T-ReorderingTimer >-----#
    T_ReorderingTimer = SEQ(name='T-ReorderingTimer', mode=MODE_TYPE)
    _T_ReorderingTimer_t_Reordering = ENUM(name='t-Reordering', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'T-Reordering')))
    _T_ReorderingTimer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __T_ReorderingTimer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___T_ReorderingTimer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____T_ReorderingTimer_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____T_ReorderingTimer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___T_ReorderingTimer_iE_Extensions__item__id._const_tab = ____T_ReorderingTimer_iE_Extensions__item__id_tab
    ___T_ReorderingTimer_iE_Extensions__item__id._const_tab_at = None
    ___T_ReorderingTimer_iE_Extensions__item__id._const_tab_id = 'id'
    ___T_ReorderingTimer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____T_ReorderingTimer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____T_ReorderingTimer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___T_ReorderingTimer_iE_Extensions__item__criticality._const_tab = ____T_ReorderingTimer_iE_Extensions__item__criticality_tab
    ___T_ReorderingTimer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___T_ReorderingTimer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___T_ReorderingTimer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____T_ReorderingTimer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____T_ReorderingTimer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___T_ReorderingTimer_iE_Extensions__item__extensionValue._const_tab = ____T_ReorderingTimer_iE_Extensions__item__extensionValue_tab
    ___T_ReorderingTimer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___T_ReorderingTimer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __T_ReorderingTimer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___T_ReorderingTimer_iE_Extensions__item__id),
        ('criticality', ___T_ReorderingTimer_iE_Extensions__item__criticality),
        ('extensionValue', ___T_ReorderingTimer_iE_Extensions__item__extensionValue),
        ])
    __T_ReorderingTimer_iE_Extensions__item_._ext = None
    _T_ReorderingTimer_iE_Extensions._cont = __T_ReorderingTimer_iE_Extensions__item_
    _T_ReorderingTimer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    T_ReorderingTimer._cont = ASN1Dict([
        ('t-Reordering', _T_ReorderingTimer_t_Reordering),
        ('iE-Extensions', _T_ReorderingTimer_iE_Extensions),
        ])
    T_ReorderingTimer._ext = []
    
    #-----< T-ReorderingTimer-ExtIEs >-----#
    T_ReorderingTimer_ExtIEs = CLASS(name='T-ReorderingTimer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    T_ReorderingTimer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TypeOfError >-----#
    TypeOfError = ENUM(name='TypeOfError', mode=MODE_TYPE)
    TypeOfError._cont = ASN1Dict([('not-understood', 0), ('missing', 1)])
    TypeOfError._ext = []
    
    #-----< Transport-Layer-Address-Info >-----#
    Transport_Layer_Address_Info = SEQ(name='Transport-Layer-Address-Info', mode=MODE_TYPE)
    _Transport_Layer_Address_Info_transport_UP_Layer_Addresses_Info_To_Add_List = SEQ_OF(name='transport-UP-Layer-Addresses-Info-To-Add-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Transport-UP-Layer-Addresses-Info-To-Add-List')), opt=True)
    _Transport_Layer_Address_Info_transport_UP_Layer_Addresses_Info_To_Remove_List = SEQ_OF(name='transport-UP-Layer-Addresses-Info-To-Remove-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Transport-UP-Layer-Addresses-Info-To-Remove-List')), opt=True)
    _Transport_Layer_Address_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Transport_Layer_Address_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___Transport_Layer_Address_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Transport_Layer_Address_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Transport_Layer_Address_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_Layer_Address_Info_iE_Extensions__item__id._const_tab = ____Transport_Layer_Address_Info_iE_Extensions__item__id_tab
    ___Transport_Layer_Address_Info_iE_Extensions__item__id._const_tab_at = None
    ___Transport_Layer_Address_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___Transport_Layer_Address_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Transport_Layer_Address_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Transport_Layer_Address_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_Layer_Address_Info_iE_Extensions__item__criticality._const_tab = ____Transport_Layer_Address_Info_iE_Extensions__item__criticality_tab
    ___Transport_Layer_Address_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Transport_Layer_Address_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Transport_Layer_Address_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Transport_Layer_Address_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Transport_Layer_Address_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_Layer_Address_Info_iE_Extensions__item__extensionValue._const_tab = ____Transport_Layer_Address_Info_iE_Extensions__item__extensionValue_tab
    ___Transport_Layer_Address_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Transport_Layer_Address_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Transport_Layer_Address_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Transport_Layer_Address_Info_iE_Extensions__item__id),
        ('criticality', ___Transport_Layer_Address_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___Transport_Layer_Address_Info_iE_Extensions__item__extensionValue),
        ])
    __Transport_Layer_Address_Info_iE_Extensions__item_._ext = None
    _Transport_Layer_Address_Info_iE_Extensions._cont = __Transport_Layer_Address_Info_iE_Extensions__item_
    _Transport_Layer_Address_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Transport_Layer_Address_Info._cont = ASN1Dict([
        ('transport-UP-Layer-Addresses-Info-To-Add-List', _Transport_Layer_Address_Info_transport_UP_Layer_Addresses_Info_To_Add_List),
        ('transport-UP-Layer-Addresses-Info-To-Remove-List', _Transport_Layer_Address_Info_transport_UP_Layer_Addresses_Info_To_Remove_List),
        ('iE-Extensions', _Transport_Layer_Address_Info_iE_Extensions),
        ])
    Transport_Layer_Address_Info._ext = []
    
    #-----< Transport-Layer-Address-Info-ExtIEs >-----#
    Transport_Layer_Address_Info_ExtIEs = CLASS(name='Transport-Layer-Address-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    Transport_Layer_Address_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Transport-UP-Layer-Addresses-Info-To-Add-List >-----#
    Transport_UP_Layer_Addresses_Info_To_Add_List = SEQ_OF(name='Transport-UP-Layer-Addresses-Info-To-Add-List', mode=MODE_TYPE)
    _Transport_UP_Layer_Addresses_Info_To_Add_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Transport-UP-Layer-Addresses-Info-To-Add-Item')))
    Transport_UP_Layer_Addresses_Info_To_Add_List._cont = _Transport_UP_Layer_Addresses_Info_To_Add_List__item_
    Transport_UP_Layer_Addresses_Info_To_Add_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Transport-UP-Layer-Addresses-Info-To-Add-Item >-----#
    Transport_UP_Layer_Addresses_Info_To_Add_Item = SEQ(name='Transport-UP-Layer-Addresses-Info-To-Add-Item', mode=MODE_TYPE)
    _Transport_UP_Layer_Addresses_Info_To_Add_Item_iP_SecTransportLayerAddress = BIT_STR(name='iP-SecTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    _Transport_UP_Layer_Addresses_Info_To_Add_Item_gTPTransportLayerAddressesToAdd = SEQ_OF(name='gTPTransportLayerAddressesToAdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'GTPTLAs')), opt=True)
    _Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__id._const_tab = ____Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__id_tab
    ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__id._const_tab_at = None
    ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__criticality._const_tab = ____Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__criticality_tab
    ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__extensionValue._const_tab = ____Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__extensionValue_tab
    ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__id),
        ('criticality', ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__extensionValue),
        ])
    __Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item_._ext = None
    _Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions._cont = __Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item_
    _Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Transport_UP_Layer_Addresses_Info_To_Add_Item._cont = ASN1Dict([
        ('iP-SecTransportLayerAddress', _Transport_UP_Layer_Addresses_Info_To_Add_Item_iP_SecTransportLayerAddress),
        ('gTPTransportLayerAddressesToAdd', _Transport_UP_Layer_Addresses_Info_To_Add_Item_gTPTransportLayerAddressesToAdd),
        ('iE-Extensions', _Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions),
        ])
    Transport_UP_Layer_Addresses_Info_To_Add_Item._ext = []
    
    #-----< Transport-UP-Layer-Addresses-Info-To-Add-ItemExtIEs >-----#
    Transport_UP_Layer_Addresses_Info_To_Add_ItemExtIEs = CLASS(name='Transport-UP-Layer-Addresses-Info-To-Add-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    Transport_UP_Layer_Addresses_Info_To_Add_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Transport-UP-Layer-Addresses-Info-To-Remove-List >-----#
    Transport_UP_Layer_Addresses_Info_To_Remove_List = SEQ_OF(name='Transport-UP-Layer-Addresses-Info-To-Remove-List', mode=MODE_TYPE)
    _Transport_UP_Layer_Addresses_Info_To_Remove_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Transport-UP-Layer-Addresses-Info-To-Remove-Item')))
    Transport_UP_Layer_Addresses_Info_To_Remove_List._cont = _Transport_UP_Layer_Addresses_Info_To_Remove_List__item_
    Transport_UP_Layer_Addresses_Info_To_Remove_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Transport-UP-Layer-Addresses-Info-To-Remove-Item >-----#
    Transport_UP_Layer_Addresses_Info_To_Remove_Item = SEQ(name='Transport-UP-Layer-Addresses-Info-To-Remove-Item', mode=MODE_TYPE)
    _Transport_UP_Layer_Addresses_Info_To_Remove_Item_iP_SecTransportLayerAddress = BIT_STR(name='iP-SecTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    _Transport_UP_Layer_Addresses_Info_To_Remove_Item_gTPTransportLayerAddressesToRemove = SEQ_OF(name='gTPTransportLayerAddressesToRemove', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'GTPTLAs')), opt=True)
    _Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__id._const_tab = ____Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__id_tab
    ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__id._const_tab_at = None
    ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__criticality._const_tab = ____Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__criticality_tab
    ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab = ____Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__extensionValue_tab
    ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__id),
        ('criticality', ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__extensionValue),
        ])
    __Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item_._ext = None
    _Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions._cont = __Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item_
    _Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Transport_UP_Layer_Addresses_Info_To_Remove_Item._cont = ASN1Dict([
        ('iP-SecTransportLayerAddress', _Transport_UP_Layer_Addresses_Info_To_Remove_Item_iP_SecTransportLayerAddress),
        ('gTPTransportLayerAddressesToRemove', _Transport_UP_Layer_Addresses_Info_To_Remove_Item_gTPTransportLayerAddressesToRemove),
        ('iE-Extensions', _Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions),
        ])
    Transport_UP_Layer_Addresses_Info_To_Remove_Item._ext = []
    
    #-----< Transport-UP-Layer-Addresses-Info-To-Remove-ItemExtIEs >-----#
    Transport_UP_Layer_Addresses_Info_To_Remove_ItemExtIEs = CLASS(name='Transport-UP-Layer-Addresses-Info-To-Remove-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    Transport_UP_Layer_Addresses_Info_To_Remove_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UDC-Parameters >-----#
    UDC_Parameters = SEQ(name='UDC-Parameters', mode=MODE_TYPE)
    _UDC_Parameters_bufferSize = ENUM(name='bufferSize', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BufferSize')))
    _UDC_Parameters_dictionary = ENUM(name='dictionary', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Dictionary')), opt=True)
    _UDC_Parameters_continueUDC = ENUM(name='continueUDC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UDC_Parameters_continueUDC._cont = ASN1Dict([('true', 0)])
    _UDC_Parameters_continueUDC._ext = []
    _UDC_Parameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UDC_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___UDC_Parameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UDC_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____UDC_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UDC_Parameters_iE_Extensions__item__id._const_tab = ____UDC_Parameters_iE_Extensions__item__id_tab
    ___UDC_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___UDC_Parameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___UDC_Parameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UDC_Parameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____UDC_Parameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UDC_Parameters_iE_Extensions__item__criticality._const_tab = ____UDC_Parameters_iE_Extensions__item__criticality_tab
    ___UDC_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UDC_Parameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UDC_Parameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UDC_Parameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____UDC_Parameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UDC_Parameters_iE_Extensions__item__extensionValue._const_tab = ____UDC_Parameters_iE_Extensions__item__extensionValue_tab
    ___UDC_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UDC_Parameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UDC_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UDC_Parameters_iE_Extensions__item__id),
        ('criticality', ___UDC_Parameters_iE_Extensions__item__criticality),
        ('extensionValue', ___UDC_Parameters_iE_Extensions__item__extensionValue),
        ])
    __UDC_Parameters_iE_Extensions__item_._ext = None
    _UDC_Parameters_iE_Extensions._cont = __UDC_Parameters_iE_Extensions__item_
    _UDC_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UDC_Parameters._cont = ASN1Dict([
        ('bufferSize', _UDC_Parameters_bufferSize),
        ('dictionary', _UDC_Parameters_dictionary),
        ('continueUDC', _UDC_Parameters_continueUDC),
        ('iE-Extensions', _UDC_Parameters_iE_Extensions),
        ])
    UDC_Parameters._ext = None
    
    #-----< UDC-Parameters-ExtIEs >-----#
    UDC_Parameters_ExtIEs = CLASS(name='UDC-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    UDC_Parameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-Activity >-----#
    UE_Activity = ENUM(name='UE-Activity', mode=MODE_TYPE)
    UE_Activity._cont = ASN1Dict([('active', 0), ('not-active', 1)])
    UE_Activity._ext = []
    
    #-----< UE-associatedLogicalE1-ConnectionItem >-----#
    UE_associatedLogicalE1_ConnectionItem = SEQ(name='UE-associatedLogicalE1-ConnectionItem', mode=MODE_TYPE)
    _UE_associatedLogicalE1_ConnectionItem_gNB_CU_CP_UE_E1AP_ID = INT(name='gNB-CU-CP-UE-E1AP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')), opt=True)
    _UE_associatedLogicalE1_ConnectionItem_gNB_CU_UP_UE_E1AP_ID = INT(name='gNB-CU-UP-UE-E1AP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')), opt=True)
    _UE_associatedLogicalE1_ConnectionItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__id._const_tab = ____UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__id_tab
    ___UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__id._const_tab_at = None
    ___UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__criticality._const_tab = ____UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__criticality_tab
    ___UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__extensionValue._const_tab = ____UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__extensionValue_tab
    ___UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__id),
        ('criticality', ___UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__extensionValue),
        ])
    __UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item_._ext = None
    _UE_associatedLogicalE1_ConnectionItem_iE_Extensions._cont = __UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item_
    _UE_associatedLogicalE1_ConnectionItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_associatedLogicalE1_ConnectionItem._cont = ASN1Dict([
        ('gNB-CU-CP-UE-E1AP-ID', _UE_associatedLogicalE1_ConnectionItem_gNB_CU_CP_UE_E1AP_ID),
        ('gNB-CU-UP-UE-E1AP-ID', _UE_associatedLogicalE1_ConnectionItem_gNB_CU_UP_UE_E1AP_ID),
        ('iE-Extensions', _UE_associatedLogicalE1_ConnectionItem_iE_Extensions),
        ])
    UE_associatedLogicalE1_ConnectionItem._ext = []
    
    #-----< UE-associatedLogicalE1-ConnectionItemExtIEs >-----#
    UE_associatedLogicalE1_ConnectionItemExtIEs = CLASS(name='UE-associatedLogicalE1-ConnectionItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    UE_associatedLogicalE1_ConnectionItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UESliceMaximumBitRateList >-----#
    UESliceMaximumBitRateList = SEQ_OF(name='UESliceMaximumBitRateList', mode=MODE_TYPE)
    _UESliceMaximumBitRateList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UESliceMaximumBitRateItem')))
    UESliceMaximumBitRateList._cont = _UESliceMaximumBitRateList__item_
    UESliceMaximumBitRateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< UESliceMaximumBitRateItem >-----#
    UESliceMaximumBitRateItem = SEQ(name='UESliceMaximumBitRateItem', mode=MODE_TYPE)
    _UESliceMaximumBitRateItem_sNSSAI = SEQ(name='sNSSAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'SNSSAI')))
    _UESliceMaximumBitRateItem_uESliceMaximumBitRateDL = INT(name='uESliceMaximumBitRateDL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'BitRate')))
    _UESliceMaximumBitRateItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UESliceMaximumBitRateItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___UESliceMaximumBitRateItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UESliceMaximumBitRateItem_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____UESliceMaximumBitRateItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESliceMaximumBitRateItem_iE_Extensions__item__id._const_tab = ____UESliceMaximumBitRateItem_iE_Extensions__item__id_tab
    ___UESliceMaximumBitRateItem_iE_Extensions__item__id._const_tab_at = None
    ___UESliceMaximumBitRateItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UESliceMaximumBitRateItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UESliceMaximumBitRateItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____UESliceMaximumBitRateItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESliceMaximumBitRateItem_iE_Extensions__item__criticality._const_tab = ____UESliceMaximumBitRateItem_iE_Extensions__item__criticality_tab
    ___UESliceMaximumBitRateItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UESliceMaximumBitRateItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UESliceMaximumBitRateItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UESliceMaximumBitRateItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____UESliceMaximumBitRateItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESliceMaximumBitRateItem_iE_Extensions__item__extensionValue._const_tab = ____UESliceMaximumBitRateItem_iE_Extensions__item__extensionValue_tab
    ___UESliceMaximumBitRateItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UESliceMaximumBitRateItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UESliceMaximumBitRateItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UESliceMaximumBitRateItem_iE_Extensions__item__id),
        ('criticality', ___UESliceMaximumBitRateItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UESliceMaximumBitRateItem_iE_Extensions__item__extensionValue),
        ])
    __UESliceMaximumBitRateItem_iE_Extensions__item_._ext = None
    _UESliceMaximumBitRateItem_iE_Extensions._cont = __UESliceMaximumBitRateItem_iE_Extensions__item_
    _UESliceMaximumBitRateItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UESliceMaximumBitRateItem._cont = ASN1Dict([
        ('sNSSAI', _UESliceMaximumBitRateItem_sNSSAI),
        ('uESliceMaximumBitRateDL', _UESliceMaximumBitRateItem_uESliceMaximumBitRateDL),
        ('iE-Extensions', _UESliceMaximumBitRateItem_iE_Extensions),
        ])
    UESliceMaximumBitRateItem._ext = []
    
    #-----< UESliceMaximumBitRateItem-ExtIEs >-----#
    UESliceMaximumBitRateItem_ExtIEs = CLASS(name='UESliceMaximumBitRateItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    UESliceMaximumBitRateItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-Configuration >-----#
    UL_Configuration = ENUM(name='UL-Configuration', mode=MODE_TYPE)
    UL_Configuration._cont = ASN1Dict([('no-data', 0), ('shared', 1), ('only', 2)])
    UL_Configuration._ext = []
    
    #-----< ULUPTNLAddressToUpdateItem >-----#
    ULUPTNLAddressToUpdateItem = SEQ(name='ULUPTNLAddressToUpdateItem', mode=MODE_TYPE)
    _ULUPTNLAddressToUpdateItem_oldTNLAdress = BIT_STR(name='oldTNLAdress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    _ULUPTNLAddressToUpdateItem_newTNLAdress = BIT_STR(name='newTNLAdress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    _ULUPTNLAddressToUpdateItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ULUPTNLAddressToUpdateItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___ULUPTNLAddressToUpdateItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ULUPTNLAddressToUpdateItem_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____ULUPTNLAddressToUpdateItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ULUPTNLAddressToUpdateItem_iE_Extensions__item__id._const_tab = ____ULUPTNLAddressToUpdateItem_iE_Extensions__item__id_tab
    ___ULUPTNLAddressToUpdateItem_iE_Extensions__item__id._const_tab_at = None
    ___ULUPTNLAddressToUpdateItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___ULUPTNLAddressToUpdateItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ULUPTNLAddressToUpdateItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____ULUPTNLAddressToUpdateItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ULUPTNLAddressToUpdateItem_iE_Extensions__item__criticality._const_tab = ____ULUPTNLAddressToUpdateItem_iE_Extensions__item__criticality_tab
    ___ULUPTNLAddressToUpdateItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ULUPTNLAddressToUpdateItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ULUPTNLAddressToUpdateItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ULUPTNLAddressToUpdateItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____ULUPTNLAddressToUpdateItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ULUPTNLAddressToUpdateItem_iE_Extensions__item__extensionValue._const_tab = ____ULUPTNLAddressToUpdateItem_iE_Extensions__item__extensionValue_tab
    ___ULUPTNLAddressToUpdateItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ULUPTNLAddressToUpdateItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ULUPTNLAddressToUpdateItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ULUPTNLAddressToUpdateItem_iE_Extensions__item__id),
        ('criticality', ___ULUPTNLAddressToUpdateItem_iE_Extensions__item__criticality),
        ('extensionValue', ___ULUPTNLAddressToUpdateItem_iE_Extensions__item__extensionValue),
        ])
    __ULUPTNLAddressToUpdateItem_iE_Extensions__item_._ext = None
    _ULUPTNLAddressToUpdateItem_iE_Extensions._cont = __ULUPTNLAddressToUpdateItem_iE_Extensions__item_
    _ULUPTNLAddressToUpdateItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ULUPTNLAddressToUpdateItem._cont = ASN1Dict([
        ('oldTNLAdress', _ULUPTNLAddressToUpdateItem_oldTNLAdress),
        ('newTNLAdress', _ULUPTNLAddressToUpdateItem_newTNLAdress),
        ('iE-Extensions', _ULUPTNLAddressToUpdateItem_iE_Extensions),
        ])
    ULUPTNLAddressToUpdateItem._ext = []
    
    #-----< ULUPTNLAddressToUpdateItemExtIEs >-----#
    ULUPTNLAddressToUpdateItemExtIEs = CLASS(name='ULUPTNLAddressToUpdateItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ULUPTNLAddressToUpdateItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ULDataSplitThreshold >-----#
    ULDataSplitThreshold = ENUM(name='ULDataSplitThreshold', mode=MODE_TYPE)
    ULDataSplitThreshold._cont = ASN1Dict([('b0', 0), ('b100', 1), ('b200', 2), ('b400', 3), ('b800', 4), ('b1600', 5), ('b3200', 6), ('b6400', 7), ('b12800', 8), ('b25600', 9), ('b51200', 10), ('b102400', 11), ('b204800', 12), ('b409600', 13), ('b819200', 14), ('b1228800', 15), ('b1638400', 16), ('b2457600', 17), ('b3276800', 18), ('b4096000', 19), ('b4915200', 20), ('b5734400', 21), ('b6553600', 22), ('infinity', 23)])
    ULDataSplitThreshold._ext = []
    
    #-----< UP-Parameters >-----#
    UP_Parameters = SEQ_OF(name='UP-Parameters', mode=MODE_TYPE)
    _UP_Parameters__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UP-Parameters-Item')))
    UP_Parameters._cont = _UP_Parameters__item_
    UP_Parameters._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< UP-Parameters-Item >-----#
    UP_Parameters_Item = SEQ(name='UP-Parameters-Item', mode=MODE_TYPE)
    _UP_Parameters_Item_uP_TNL_Information = CHOICE(name='uP-TNL-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'UP-TNL-Information')))
    _UP_Parameters_Item_cell_Group_ID = INT(name='cell-Group-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Cell-Group-ID')))
    _UP_Parameters_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UP_Parameters_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___UP_Parameters_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UP_Parameters_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____UP_Parameters_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QoS-Mapping-Information')))
    ____UP_Parameters_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 107), ('criticality', 'reject'), ('Extension', _____UP_Parameters_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UP_Parameters_Item_iE_Extensions__item__id._const_tab = ____UP_Parameters_Item_iE_Extensions__item__id_tab
    ___UP_Parameters_Item_iE_Extensions__item__id._const_tab_at = None
    ___UP_Parameters_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___UP_Parameters_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UP_Parameters_Item_iE_Extensions__item__criticality._const_tab = ____UP_Parameters_Item_iE_Extensions__item__id_tab
    ___UP_Parameters_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UP_Parameters_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UP_Parameters_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UP_Parameters_Item_iE_Extensions__item__extensionValue._const_tab = ____UP_Parameters_Item_iE_Extensions__item__id_tab
    ___UP_Parameters_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UP_Parameters_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UP_Parameters_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UP_Parameters_Item_iE_Extensions__item__id),
        ('criticality', ___UP_Parameters_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___UP_Parameters_Item_iE_Extensions__item__extensionValue),
        ])
    __UP_Parameters_Item_iE_Extensions__item_._ext = None
    _UP_Parameters_Item_iE_Extensions._cont = __UP_Parameters_Item_iE_Extensions__item_
    _UP_Parameters_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UP_Parameters_Item._cont = ASN1Dict([
        ('uP-TNL-Information', _UP_Parameters_Item_uP_TNL_Information),
        ('cell-Group-ID', _UP_Parameters_Item_cell_Group_ID),
        ('iE-Extensions', _UP_Parameters_Item_iE_Extensions),
        ])
    UP_Parameters_Item._ext = []
    
    #-----< UP-Parameters-Item-ExtIEs >-----#
    UP_Parameters_Item_ExtIEs = CLASS(name='UP-Parameters-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _UP_Parameters_Item_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'QoS-Mapping-Information')))
    UP_Parameters_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 107), ('criticality', 'reject'), ('Extension', _UP_Parameters_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UPSecuritykey >-----#
    UPSecuritykey = SEQ(name='UPSecuritykey', mode=MODE_TYPE)
    _UPSecuritykey_encryptionKey = OCT_STR(name='encryptionKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'EncryptionKey')))
    _UPSecuritykey_integrityProtectionKey = OCT_STR(name='integrityProtectionKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'IntegrityProtectionKey')), opt=True)
    _UPSecuritykey_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UPSecuritykey_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___UPSecuritykey_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UPSecuritykey_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____UPSecuritykey_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UPSecuritykey_iE_Extensions__item__id._const_tab = ____UPSecuritykey_iE_Extensions__item__id_tab
    ___UPSecuritykey_iE_Extensions__item__id._const_tab_at = None
    ___UPSecuritykey_iE_Extensions__item__id._const_tab_id = 'id'
    ___UPSecuritykey_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UPSecuritykey_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____UPSecuritykey_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UPSecuritykey_iE_Extensions__item__criticality._const_tab = ____UPSecuritykey_iE_Extensions__item__criticality_tab
    ___UPSecuritykey_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UPSecuritykey_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UPSecuritykey_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UPSecuritykey_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____UPSecuritykey_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UPSecuritykey_iE_Extensions__item__extensionValue._const_tab = ____UPSecuritykey_iE_Extensions__item__extensionValue_tab
    ___UPSecuritykey_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UPSecuritykey_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UPSecuritykey_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UPSecuritykey_iE_Extensions__item__id),
        ('criticality', ___UPSecuritykey_iE_Extensions__item__criticality),
        ('extensionValue', ___UPSecuritykey_iE_Extensions__item__extensionValue),
        ])
    __UPSecuritykey_iE_Extensions__item_._ext = None
    _UPSecuritykey_iE_Extensions._cont = __UPSecuritykey_iE_Extensions__item_
    _UPSecuritykey_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UPSecuritykey._cont = ASN1Dict([
        ('encryptionKey', _UPSecuritykey_encryptionKey),
        ('integrityProtectionKey', _UPSecuritykey_integrityProtectionKey),
        ('iE-Extensions', _UPSecuritykey_iE_Extensions),
        ])
    UPSecuritykey._ext = []
    
    #-----< UPSecuritykey-ExtIEs >-----#
    UPSecuritykey_ExtIEs = CLASS(name='UPSecuritykey-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    UPSecuritykey_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UP-TNL-Information >-----#
    UP_TNL_Information = CHOICE(name='UP-TNL-Information', mode=MODE_TYPE)
    _UP_TNL_Information_gTPTunnel = SEQ(name='gTPTunnel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'GTPTunnel')))
    _UP_TNL_Information_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UP_TNL_Information_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___UP_TNL_Information_choice_extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___UP_TNL_Information_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UP_TNL_Information_choice_extension_id._const_tab = ___UP_TNL_Information_choice_extension_id_tab
    __UP_TNL_Information_choice_extension_id._const_tab_at = None
    __UP_TNL_Information_choice_extension_id._const_tab_id = 'id'
    __UP_TNL_Information_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___UP_TNL_Information_choice_extension_criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___UP_TNL_Information_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UP_TNL_Information_choice_extension_criticality._const_tab = ___UP_TNL_Information_choice_extension_criticality_tab
    __UP_TNL_Information_choice_extension_criticality._const_tab_at = ('..', 'id')
    __UP_TNL_Information_choice_extension_criticality._const_tab_id = 'criticality'
    __UP_TNL_Information_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___UP_TNL_Information_choice_extension_value_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___UP_TNL_Information_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UP_TNL_Information_choice_extension_value._const_tab = ___UP_TNL_Information_choice_extension_value_tab
    __UP_TNL_Information_choice_extension_value._const_tab_at = ('..', 'id')
    __UP_TNL_Information_choice_extension_value._const_tab_id = 'Value'
    _UP_TNL_Information_choice_extension._cont = ASN1Dict([
        ('id', __UP_TNL_Information_choice_extension_id),
        ('criticality', __UP_TNL_Information_choice_extension_criticality),
        ('value', __UP_TNL_Information_choice_extension_value),
        ])
    _UP_TNL_Information_choice_extension._ext = None
    UP_TNL_Information._cont = ASN1Dict([
        ('gTPTunnel', _UP_TNL_Information_gTPTunnel),
        ('choice-extension', _UP_TNL_Information_choice_extension),
        ])
    UP_TNL_Information._ext = None
    
    #-----< UP-TNL-Information-ExtIEs >-----#
    UP_TNL_Information_ExtIEs = CLASS(name='UP-TNL-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    UP_TNL_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UplinkOnlyROHC >-----#
    UplinkOnlyROHC = SEQ(name='UplinkOnlyROHC', mode=MODE_TYPE)
    _UplinkOnlyROHC_maxCID = INT(name='maxCID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UplinkOnlyROHC_maxCID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=[], er=[])
    _UplinkOnlyROHC_rOHC_Profiles = INT(name='rOHC-Profiles', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UplinkOnlyROHC_rOHC_Profiles._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=[], er=[])
    _UplinkOnlyROHC_continueROHC = ENUM(name='continueROHC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UplinkOnlyROHC_continueROHC._cont = ASN1Dict([('true', 0)])
    _UplinkOnlyROHC_continueROHC._ext = []
    _UplinkOnlyROHC_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UplinkOnlyROHC_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___UplinkOnlyROHC_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UplinkOnlyROHC_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____UplinkOnlyROHC_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UplinkOnlyROHC_iE_Extensions__item__id._const_tab = ____UplinkOnlyROHC_iE_Extensions__item__id_tab
    ___UplinkOnlyROHC_iE_Extensions__item__id._const_tab_at = None
    ___UplinkOnlyROHC_iE_Extensions__item__id._const_tab_id = 'id'
    ___UplinkOnlyROHC_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UplinkOnlyROHC_iE_Extensions__item__criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____UplinkOnlyROHC_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UplinkOnlyROHC_iE_Extensions__item__criticality._const_tab = ____UplinkOnlyROHC_iE_Extensions__item__criticality_tab
    ___UplinkOnlyROHC_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UplinkOnlyROHC_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UplinkOnlyROHC_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UplinkOnlyROHC_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    ____UplinkOnlyROHC_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UplinkOnlyROHC_iE_Extensions__item__extensionValue._const_tab = ____UplinkOnlyROHC_iE_Extensions__item__extensionValue_tab
    ___UplinkOnlyROHC_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UplinkOnlyROHC_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UplinkOnlyROHC_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UplinkOnlyROHC_iE_Extensions__item__id),
        ('criticality', ___UplinkOnlyROHC_iE_Extensions__item__criticality),
        ('extensionValue', ___UplinkOnlyROHC_iE_Extensions__item__extensionValue),
        ])
    __UplinkOnlyROHC_iE_Extensions__item_._ext = None
    _UplinkOnlyROHC_iE_Extensions._cont = __UplinkOnlyROHC_iE_Extensions__item_
    _UplinkOnlyROHC_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UplinkOnlyROHC._cont = ASN1Dict([
        ('maxCID', _UplinkOnlyROHC_maxCID),
        ('rOHC-Profiles', _UplinkOnlyROHC_rOHC_Profiles),
        ('continueROHC', _UplinkOnlyROHC_continueROHC),
        ('iE-Extensions', _UplinkOnlyROHC_iE_Extensions),
        ])
    UplinkOnlyROHC._ext = None
    
    #-----< UplinkOnlyROHC-ExtIEs >-----#
    UplinkOnlyROHC_ExtIEs = CLASS(name='UplinkOnlyROHC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    UplinkOnlyROHC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< URIaddress >-----#
    URIaddress = STR_VIS(name='URIaddress', mode=MODE_TYPE)
    
    _all_ = [
        _ActivityInformation_dRB_Activity_List,
        _ActivityInformation_pDU_Session_Resource_Activity_List,
        _ActivityInformation_uE_Activity,
        ___ActivityInformation_choice_extension_id_tab,
        __ActivityInformation_choice_extension_id,
        ___ActivityInformation_choice_extension_criticality_tab,
        __ActivityInformation_choice_extension_criticality,
        ___ActivityInformation_choice_extension_value_tab,
        __ActivityInformation_choice_extension_value,
        _ActivityInformation_choice_extension,
        ActivityInformation,
        ActivityInformation_ExtIEs,
        ActivityNotificationLevel,
        AdditionalHandoverInfo,
        AdditionalPDCPduplicationInformation,
        AdditionalRRMPriorityIndex,
        AveragingWindow,
        _AlternativeQoSParaSetList__item_,
        AlternativeQoSParaSetList,
        _AlternativeQoSParaSetItem_alternativeQoSParameterIndex,
        _AlternativeQoSParaSetItem_guaranteedFlowBitRateDL,
        _AlternativeQoSParaSetItem_guaranteedFlowBitRateUL,
        _AlternativeQoSParaSetItem_packetDelayBudget,
        _AlternativeQoSParaSetItem_packetErrorRate,
        ____AlternativeQoSParaSetItem_iE_Extensions__item__id_tab,
        ___AlternativeQoSParaSetItem_iE_Extensions__item__id,
        ____AlternativeQoSParaSetItem_iE_Extensions__item__criticality_tab,
        ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality,
        ____AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue_tab,
        ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue,
        __AlternativeQoSParaSetItem_iE_Extensions__item_,
        _AlternativeQoSParaSetItem_iE_Extensions,
        AlternativeQoSParaSetItem,
        AlternativeQoSParaSetItem_ExtIEs,
        _BCBearerContextToSetup_snssai,
        _BCBearerContextToSetup_bcBearerContextNGU_TNLInfoat5GC,
        _BCBearerContextToSetup_bcMRBToSetupList,
        _BCBearerContextToSetup_requestedAction,
        ____BCBearerContextToSetup_iE_Extensions__item__id_tab,
        ___BCBearerContextToSetup_iE_Extensions__item__id,
        ____BCBearerContextToSetup_iE_Extensions__item__criticality_tab,
        ___BCBearerContextToSetup_iE_Extensions__item__criticality,
        ____BCBearerContextToSetup_iE_Extensions__item__extensionValue_tab,
        ___BCBearerContextToSetup_iE_Extensions__item__extensionValue,
        __BCBearerContextToSetup_iE_Extensions__item_,
        _BCBearerContextToSetup_iE_Extensions,
        BCBearerContextToSetup,
        BCBearerContextToSetup_ExtIEs,
        _BCBearerContextNGU_TNLInfoat5GC_locationindependent,
        _BCBearerContextNGU_TNLInfoat5GC_locationdependent,
        ___BCBearerContextNGU_TNLInfoat5GC_choice_extension_id_tab,
        __BCBearerContextNGU_TNLInfoat5GC_choice_extension_id,
        ___BCBearerContextNGU_TNLInfoat5GC_choice_extension_criticality_tab,
        __BCBearerContextNGU_TNLInfoat5GC_choice_extension_criticality,
        ___BCBearerContextNGU_TNLInfoat5GC_choice_extension_value_tab,
        __BCBearerContextNGU_TNLInfoat5GC_choice_extension_value,
        _BCBearerContextNGU_TNLInfoat5GC_choice_extension,
        BCBearerContextNGU_TNLInfoat5GC,
        BCBearerContextNGU_TNLInfoat5GC_ExtIEs,
        _BCMRBSetupConfiguration__item_,
        BCMRBSetupConfiguration,
        _BCMRBSetupConfiguration_Item_mrb_ID,
        _BCMRBSetupConfiguration_Item_sdap_config,
        _BCMRBSetupConfiguration_Item_mbs_pdcp_config,
        _BCMRBSetupConfiguration_Item_qoS_Flow_QoS_Parameter_List,
        _BCMRBSetupConfiguration_Item_qoSFlowLevelQoSParameters,
        ____BCMRBSetupConfiguration_Item_iE_Extensions__item__id_tab,
        ___BCMRBSetupConfiguration_Item_iE_Extensions__item__id,
        ____BCMRBSetupConfiguration_Item_iE_Extensions__item__criticality_tab,
        ___BCMRBSetupConfiguration_Item_iE_Extensions__item__criticality,
        ____BCMRBSetupConfiguration_Item_iE_Extensions__item__extensionValue_tab,
        ___BCMRBSetupConfiguration_Item_iE_Extensions__item__extensionValue,
        __BCMRBSetupConfiguration_Item_iE_Extensions__item_,
        _BCMRBSetupConfiguration_Item_iE_Extensions,
        BCMRBSetupConfiguration_Item,
        BCMRBSetupConfiguration_Item_ExtIEs,
        _BCBearerContextToSetupResponse_bcBearerContextNGU_TNLInfoatNGRAN,
        _BCBearerContextToSetupResponse_bcMRBSetupResponseList,
        _BCBearerContextToSetupResponse_bcMRBFailedList,
        _BCBearerContextToSetupResponse_availableBCMRBConfig,
        ____BCBearerContextToSetupResponse_iE_Extensions__item__id_tab,
        ___BCBearerContextToSetupResponse_iE_Extensions__item__id,
        ____BCBearerContextToSetupResponse_iE_Extensions__item__criticality_tab,
        ___BCBearerContextToSetupResponse_iE_Extensions__item__criticality,
        ____BCBearerContextToSetupResponse_iE_Extensions__item__extensionValue_tab,
        ___BCBearerContextToSetupResponse_iE_Extensions__item__extensionValue,
        __BCBearerContextToSetupResponse_iE_Extensions__item_,
        _BCBearerContextToSetupResponse_iE_Extensions,
        BCBearerContextToSetupResponse,
        BCBearerContextToSetupResponse_ExtIEs,
        _BCBearerContextNGU_TNLInfoatNGRAN_locationindependent,
        _BCBearerContextNGU_TNLInfoatNGRAN_locationdependent,
        ___BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_id_tab,
        __BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_id,
        ___BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_criticality_tab,
        __BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_criticality,
        ___BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_value_tab,
        __BCBearerContextNGU_TNLInfoatNGRAN_choice_extension_value,
        _BCBearerContextNGU_TNLInfoatNGRAN_choice_extension,
        BCBearerContextNGU_TNLInfoatNGRAN,
        BCBearerContextNGU_TNLInfoatNGRAN_ExtIEs,
        _BCMRBSetupResponseList__item_,
        BCMRBSetupResponseList,
        _BCMRBSetupResponseList_Item_mrb_ID,
        _BCMRBSetupResponseList_Item_qosflow_setup,
        _BCMRBSetupResponseList_Item_qosflow_failed,
        _BCMRBSetupResponseList_Item_bcBearerContextF1U_TNLInfoatCU,
        ____BCMRBSetupResponseList_Item_iE_Extensions__item__id_tab,
        ___BCMRBSetupResponseList_Item_iE_Extensions__item__id,
        ____BCMRBSetupResponseList_Item_iE_Extensions__item__criticality_tab,
        ___BCMRBSetupResponseList_Item_iE_Extensions__item__criticality,
        ____BCMRBSetupResponseList_Item_iE_Extensions__item__extensionValue_tab,
        ___BCMRBSetupResponseList_Item_iE_Extensions__item__extensionValue,
        __BCMRBSetupResponseList_Item_iE_Extensions__item_,
        _BCMRBSetupResponseList_Item_iE_Extensions,
        BCMRBSetupResponseList_Item,
        BCMRBSetupResponseList_Item_ExtIEs,
        _BCBearerContextF1U_TNLInfoatCU_locationindependent,
        _BCBearerContextF1U_TNLInfoatCU_locationdependent,
        ___BCBearerContextF1U_TNLInfoatCU_choice_extension_id_tab,
        __BCBearerContextF1U_TNLInfoatCU_choice_extension_id,
        ___BCBearerContextF1U_TNLInfoatCU_choice_extension_criticality_tab,
        __BCBearerContextF1U_TNLInfoatCU_choice_extension_criticality,
        ___BCBearerContextF1U_TNLInfoatCU_choice_extension_value_tab,
        __BCBearerContextF1U_TNLInfoatCU_choice_extension_value,
        _BCBearerContextF1U_TNLInfoatCU_choice_extension,
        BCBearerContextF1U_TNLInfoatCU,
        BCBearerContextF1U_TNLInfoatCU_ExtIEs,
        _BCMRBFailedList__item_,
        BCMRBFailedList,
        _BCMRBFailedList_Item_mrb_ID,
        _BCMRBFailedList_Item_cause,
        ____BCMRBFailedList_Item_iE_Extensions__item__id_tab,
        ___BCMRBFailedList_Item_iE_Extensions__item__id,
        ____BCMRBFailedList_Item_iE_Extensions__item__criticality_tab,
        ___BCMRBFailedList_Item_iE_Extensions__item__criticality,
        ____BCMRBFailedList_Item_iE_Extensions__item__extensionValue_tab,
        ___BCMRBFailedList_Item_iE_Extensions__item__extensionValue,
        __BCMRBFailedList_Item_iE_Extensions__item_,
        _BCMRBFailedList_Item_iE_Extensions,
        BCMRBFailedList_Item,
        BCMRBFailedList_Item_ExtIEs,
        _BCBearerContextToModify_bcBearerContextNGU_TNLInfoat5GC,
        _BCBearerContextToModify_bcMRBToSetupList,
        _BCBearerContextToModify_bcMRBToModifyList,
        _BCBearerContextToModify_bcMRBToRemoveList,
        ____BCBearerContextToModify_iE_Extensions__item__id_tab,
        ___BCBearerContextToModify_iE_Extensions__item__id,
        ____BCBearerContextToModify_iE_Extensions__item__criticality_tab,
        ___BCBearerContextToModify_iE_Extensions__item__criticality,
        ____BCBearerContextToModify_iE_Extensions__item__extensionValue_tab,
        ___BCBearerContextToModify_iE_Extensions__item__extensionValue,
        __BCBearerContextToModify_iE_Extensions__item_,
        _BCBearerContextToModify_iE_Extensions,
        BCBearerContextToModify,
        BCBearerContextToModify_ExtIEs,
        _BCMRBModifyConfiguration__item_,
        BCMRBModifyConfiguration,
        _BCMRBModifyConfiguration_Item_mrb_ID,
        _BCMRBModifyConfiguration_Item_bcBearerContextF1U_TNLInfoatDU,
        _BCMRBModifyConfiguration_Item_sdap_config,
        _BCMRBModifyConfiguration_Item_mbs_pdcp_config,
        _BCMRBModifyConfiguration_Item_qoS_Flow_QoS_Parameter_List,
        _BCMRBModifyConfiguration_Item_qoSFlowLevelQoSParameters,
        ____BCMRBModifyConfiguration_Item_iE_Extensions__item__id_tab,
        ___BCMRBModifyConfiguration_Item_iE_Extensions__item__id,
        ____BCMRBModifyConfiguration_Item_iE_Extensions__item__criticality_tab,
        ___BCMRBModifyConfiguration_Item_iE_Extensions__item__criticality,
        ____BCMRBModifyConfiguration_Item_iE_Extensions__item__extensionValue_tab,
        ___BCMRBModifyConfiguration_Item_iE_Extensions__item__extensionValue,
        __BCMRBModifyConfiguration_Item_iE_Extensions__item_,
        _BCMRBModifyConfiguration_Item_iE_Extensions,
        BCMRBModifyConfiguration_Item,
        BCMRBModifyConfiguration_Item_ExtIEs,
        _BCBearerContextF1U_TNLInfoatDU_locationindependent,
        _BCBearerContextF1U_TNLInfoatDU_locationdependent,
        ___BCBearerContextF1U_TNLInfoatDU_choice_extension_id_tab,
        __BCBearerContextF1U_TNLInfoatDU_choice_extension_id,
        ___BCBearerContextF1U_TNLInfoatDU_choice_extension_criticality_tab,
        __BCBearerContextF1U_TNLInfoatDU_choice_extension_criticality,
        ___BCBearerContextF1U_TNLInfoatDU_choice_extension_value_tab,
        __BCBearerContextF1U_TNLInfoatDU_choice_extension_value,
        _BCBearerContextF1U_TNLInfoatDU_choice_extension,
        BCBearerContextF1U_TNLInfoatDU,
        BCBearerContextF1U_TNLInfoatDU_ExtIEs,
        _BCMRBRemoveConfiguration__item_,
        BCMRBRemoveConfiguration,
        _BCBearerContextToModifyResponse_bcBearerContextNGU_TNLInfoatNGRAN,
        _BCBearerContextToModifyResponse_bcMRBSetupModifyResponseList,
        _BCBearerContextToModifyResponse_bcMRBFailedList,
        _BCBearerContextToModifyResponse_availableBCMRBConfig,
        ____BCBearerContextToModifyResponse_iE_Extensions__item__id_tab,
        ___BCBearerContextToModifyResponse_iE_Extensions__item__id,
        ____BCBearerContextToModifyResponse_iE_Extensions__item__criticality_tab,
        ___BCBearerContextToModifyResponse_iE_Extensions__item__criticality,
        ____BCBearerContextToModifyResponse_iE_Extensions__item__extensionValue_tab,
        ___BCBearerContextToModifyResponse_iE_Extensions__item__extensionValue,
        __BCBearerContextToModifyResponse_iE_Extensions__item_,
        _BCBearerContextToModifyResponse_iE_Extensions,
        BCBearerContextToModifyResponse,
        BCBearerContextToModifyResponse_ExtIEs,
        _BCMRBSetupModifyResponseList__item_,
        BCMRBSetupModifyResponseList,
        _BCMRBSetupModifyResponseList_Item_mrb_ID,
        _BCMRBSetupModifyResponseList_Item_qosflow_setup,
        _BCMRBSetupModifyResponseList_Item_qosflow_failed,
        _BCMRBSetupModifyResponseList_Item_bcBearerContextF1U_TNLInfoatCU,
        ____BCMRBSetupModifyResponseList_Item_iE_Extensions__item__id_tab,
        ___BCMRBSetupModifyResponseList_Item_iE_Extensions__item__id,
        ____BCMRBSetupModifyResponseList_Item_iE_Extensions__item__criticality_tab,
        ___BCMRBSetupModifyResponseList_Item_iE_Extensions__item__criticality,
        ____BCMRBSetupModifyResponseList_Item_iE_Extensions__item__extensionValue_tab,
        ___BCMRBSetupModifyResponseList_Item_iE_Extensions__item__extensionValue,
        __BCMRBSetupModifyResponseList_Item_iE_Extensions__item_,
        _BCMRBSetupModifyResponseList_Item_iE_Extensions,
        BCMRBSetupModifyResponseList_Item,
        BCMRBSetupModifyResponseList_Item_ExtIEs,
        _BCBearerContextToModifyRequired_bcMRBToRemoveList,
        ____BCBearerContextToModifyRequired_iE_Extensions__item__id_tab,
        ___BCBearerContextToModifyRequired_iE_Extensions__item__id,
        ____BCBearerContextToModifyRequired_iE_Extensions__item__criticality_tab,
        ___BCBearerContextToModifyRequired_iE_Extensions__item__criticality,
        ____BCBearerContextToModifyRequired_iE_Extensions__item__extensionValue_tab,
        ___BCBearerContextToModifyRequired_iE_Extensions__item__extensionValue,
        __BCBearerContextToModifyRequired_iE_Extensions__item_,
        _BCBearerContextToModifyRequired_iE_Extensions,
        BCBearerContextToModifyRequired,
        BCBearerContextToModifyRequired_ExtIEs,
        ____BCBearerContextToModifyConfirm_iE_Extensions__item__id_tab,
        ___BCBearerContextToModifyConfirm_iE_Extensions__item__id,
        ____BCBearerContextToModifyConfirm_iE_Extensions__item__criticality_tab,
        ___BCBearerContextToModifyConfirm_iE_Extensions__item__criticality,
        ____BCBearerContextToModifyConfirm_iE_Extensions__item__extensionValue_tab,
        ___BCBearerContextToModifyConfirm_iE_Extensions__item__extensionValue,
        __BCBearerContextToModifyConfirm_iE_Extensions__item_,
        _BCBearerContextToModifyConfirm_iE_Extensions,
        BCBearerContextToModifyConfirm,
        BCBearerContextToModifyConfirm_ExtIEs,
        BearerContextStatusChange,
        BitRate,
        BufferSize,
        _Cause_radioNetwork,
        _Cause_transport,
        _Cause_protocol,
        _Cause_misc,
        ___Cause_choice_extension_id_tab,
        __Cause_choice_extension_id,
        ___Cause_choice_extension_criticality_tab,
        __Cause_choice_extension_criticality,
        ___Cause_choice_extension_value_tab,
        __Cause_choice_extension_value,
        _Cause_choice_extension,
        Cause,
        Cause_ExtIEs,
        CauseMisc,
        CauseProtocol,
        CauseRadioNetwork,
        CauseTransport,
        _Cell_Group_Information__item_,
        Cell_Group_Information,
        _Cell_Group_Information_Item_cell_Group_ID,
        _Cell_Group_Information_Item_uL_Configuration,
        _Cell_Group_Information_Item_dL_TX_Stop,
        _Cell_Group_Information_Item_rAT_Type,
        ____Cell_Group_Information_Item_iE_Extensions__item__id_tab,
        _____Cell_Group_Information_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___Cell_Group_Information_Item_iE_Extensions__item__id,
        ___Cell_Group_Information_Item_iE_Extensions__item__criticality,
        ___Cell_Group_Information_Item_iE_Extensions__item__extensionValue,
        __Cell_Group_Information_Item_iE_Extensions__item_,
        _Cell_Group_Information_Item_iE_Extensions,
        Cell_Group_Information_Item,
        Cell_Group_Information_Item_ExtIEs,
        _Cell_Group_Information_Item_ExtIEs_val_Extension_0,
        Cell_Group_ID,
        CHOInitiation,
        Number_of_tunnels,
        CipheringAlgorithm,
        CNSupport,
        CommonNetworkInstance,
        ConfidentialityProtectionIndication,
        ConfidentialityProtectionResult,
        _CP_TNL_Information_endpoint_IP_Address,
        ___CP_TNL_Information_choice_extension_id_tab,
        ____CP_TNL_Information_choice_extension_id_tab_val_Value_0,
        __CP_TNL_Information_choice_extension_id,
        __CP_TNL_Information_choice_extension_criticality,
        __CP_TNL_Information_choice_extension_value,
        _CP_TNL_Information_choice_extension,
        CP_TNL_Information,
        CP_TNL_Information_ExtIEs,
        _CP_TNL_Information_ExtIEs_val_Value_0,
        _CriticalityDiagnostics_procedureCode,
        _CriticalityDiagnostics_triggeringMessage,
        _CriticalityDiagnostics_procedureCriticality,
        _CriticalityDiagnostics_transactionID,
        _CriticalityDiagnostics_iEsCriticalityDiagnostics,
        ____CriticalityDiagnostics_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__id,
        ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_iE_Extensions__item_,
        _CriticalityDiagnostics_iE_Extensions,
        CriticalityDiagnostics,
        CriticalityDiagnostics_ExtIEs,
        __CriticalityDiagnostics_IE_List__item__iECriticality,
        __CriticalityDiagnostics_IE_List__item__iE_ID,
        __CriticalityDiagnostics_IE_List__item__typeOfError,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue,
        ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_,
        __CriticalityDiagnostics_IE_List__item__iE_Extensions,
        _CriticalityDiagnostics_IE_List__item_,
        CriticalityDiagnostics_IE_List,
        CriticalityDiagnostics_IE_List_ExtIEs,
        _DAPSRequestInfo_dapsIndicator,
        ____DAPSRequestInfo_iE_Extensions__item__id_tab,
        ___DAPSRequestInfo_iE_Extensions__item__id,
        ____DAPSRequestInfo_iE_Extensions__item__criticality_tab,
        ___DAPSRequestInfo_iE_Extensions__item__criticality,
        ____DAPSRequestInfo_iE_Extensions__item__extensionValue_tab,
        ___DAPSRequestInfo_iE_Extensions__item__extensionValue,
        __DAPSRequestInfo_iE_Extensions__item_,
        _DAPSRequestInfo_iE_Extensions,
        DAPSRequestInfo,
        DAPSRequestInfo_ExtIEs,
        _Data_Forwarding_Information_Request_data_Forwarding_Request,
        _Data_Forwarding_Information_Request_qoS_Flows_Forwarded_On_Fwd_Tunnels,
        ____Data_Forwarding_Information_Request_iE_Extensions__item__id_tab,
        ___Data_Forwarding_Information_Request_iE_Extensions__item__id,
        ____Data_Forwarding_Information_Request_iE_Extensions__item__criticality_tab,
        ___Data_Forwarding_Information_Request_iE_Extensions__item__criticality,
        ____Data_Forwarding_Information_Request_iE_Extensions__item__extensionValue_tab,
        ___Data_Forwarding_Information_Request_iE_Extensions__item__extensionValue,
        __Data_Forwarding_Information_Request_iE_Extensions__item_,
        _Data_Forwarding_Information_Request_iE_Extensions,
        Data_Forwarding_Information_Request,
        Data_Forwarding_Information_Request_ExtIEs,
        _Data_Forwarding_Information_uL_Data_Forwarding,
        _Data_Forwarding_Information_dL_Data_Forwarding,
        ____Data_Forwarding_Information_iE_Extensions__item__id_tab,
        _____Data_Forwarding_Information_iE_Extensions__item__id_tab_val_Extension_0,
        ___Data_Forwarding_Information_iE_Extensions__item__id,
        ___Data_Forwarding_Information_iE_Extensions__item__criticality,
        ___Data_Forwarding_Information_iE_Extensions__item__extensionValue,
        __Data_Forwarding_Information_iE_Extensions__item_,
        _Data_Forwarding_Information_iE_Extensions,
        Data_Forwarding_Information,
        Data_Forwarding_Information_ExtIEs,
        _Data_Forwarding_Information_ExtIEs_val_Extension_0,
        Data_Forwarding_Request,
        _DataForwardingtoE_UTRANInformationList__item_,
        DataForwardingtoE_UTRANInformationList,
        _DataForwardingtoE_UTRANInformationListItem_data_forwarding_tunnel_information,
        _DataForwardingtoE_UTRANInformationListItem_qoS_Flows_to_be_forwarded_List,
        ____DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__id_tab,
        ___DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__id,
        ____DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__criticality_tab,
        ___DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__criticality,
        ____DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__extensionValue_tab,
        ___DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item__extensionValue,
        __DataForwardingtoE_UTRANInformationListItem_iE_Extensions__item_,
        _DataForwardingtoE_UTRANInformationListItem_iE_Extensions,
        DataForwardingtoE_UTRANInformationListItem,
        DataForwardingtoE_UTRANInformationListItem_ExtIEs,
        _Data_Usage_per_PDU_Session_Report_secondaryRATType,
        __Data_Usage_per_PDU_Session_Report_pDU_session_Timed_Report_List__item_,
        _Data_Usage_per_PDU_Session_Report_pDU_session_Timed_Report_List,
        ____Data_Usage_per_PDU_Session_Report_iE_Extensions__item__id_tab,
        ___Data_Usage_per_PDU_Session_Report_iE_Extensions__item__id,
        ____Data_Usage_per_PDU_Session_Report_iE_Extensions__item__criticality_tab,
        ___Data_Usage_per_PDU_Session_Report_iE_Extensions__item__criticality,
        ____Data_Usage_per_PDU_Session_Report_iE_Extensions__item__extensionValue_tab,
        ___Data_Usage_per_PDU_Session_Report_iE_Extensions__item__extensionValue,
        __Data_Usage_per_PDU_Session_Report_iE_Extensions__item_,
        _Data_Usage_per_PDU_Session_Report_iE_Extensions,
        Data_Usage_per_PDU_Session_Report,
        Data_Usage_per_PDU_Session_Report_ExtIEs,
        _Data_Usage_per_QoS_Flow_List__item_,
        Data_Usage_per_QoS_Flow_List,
        _Data_Usage_per_QoS_Flow_Item_qoS_Flow_Identifier,
        _Data_Usage_per_QoS_Flow_Item_secondaryRATType,
        __Data_Usage_per_QoS_Flow_Item_qoS_Flow_Timed_Report_List__item_,
        _Data_Usage_per_QoS_Flow_Item_qoS_Flow_Timed_Report_List,
        ____Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__id_tab,
        ___Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__id,
        ____Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__criticality_tab,
        ___Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__criticality,
        ____Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__extensionValue_tab,
        ___Data_Usage_per_QoS_Flow_Item_iE_Extensions__item__extensionValue,
        __Data_Usage_per_QoS_Flow_Item_iE_Extensions__item_,
        _Data_Usage_per_QoS_Flow_Item_iE_Extensions,
        Data_Usage_per_QoS_Flow_Item,
        Data_Usage_per_QoS_Flow_Item_ExtIEs,
        _Data_Usage_Report_List__item_,
        Data_Usage_Report_List,
        _Data_Usage_Report_Item_dRB_ID,
        _Data_Usage_Report_Item_rAT_Type,
        _Data_Usage_Report_Item_dRB_Usage_Report_List,
        ____Data_Usage_Report_Item_iE_Extensions__item__id_tab,
        ___Data_Usage_Report_Item_iE_Extensions__item__id,
        ____Data_Usage_Report_Item_iE_Extensions__item__criticality_tab,
        ___Data_Usage_Report_Item_iE_Extensions__item__criticality,
        ____Data_Usage_Report_Item_iE_Extensions__item__extensionValue_tab,
        ___Data_Usage_Report_Item_iE_Extensions__item__extensionValue,
        __Data_Usage_Report_Item_iE_Extensions__item_,
        _Data_Usage_Report_Item_iE_Extensions,
        Data_Usage_Report_Item,
        Data_Usage_Report_ItemExtIEs,
        DefaultDRB,
        Dictionary,
        DirectForwardingPathAvailability,
        DiscardTimer,
        DiscardTimerExtended,
        _DLDiscarding_dLDiscardingCountVal,
        ____DLDiscarding_iE_Extensions__item__id_tab,
        ___DLDiscarding_iE_Extensions__item__id,
        ____DLDiscarding_iE_Extensions__item__criticality_tab,
        ___DLDiscarding_iE_Extensions__item__criticality,
        ____DLDiscarding_iE_Extensions__item__extensionValue_tab,
        ___DLDiscarding_iE_Extensions__item__extensionValue,
        __DLDiscarding_iE_Extensions__item_,
        _DLDiscarding_iE_Extensions,
        DLDiscarding,
        DLDiscarding_ExtIEs,
        _DLUPTNLAddressToUpdateItem_oldTNLAdress,
        _DLUPTNLAddressToUpdateItem_newTNLAdress,
        ____DLUPTNLAddressToUpdateItem_iE_Extensions__item__id_tab,
        ___DLUPTNLAddressToUpdateItem_iE_Extensions__item__id,
        ____DLUPTNLAddressToUpdateItem_iE_Extensions__item__criticality_tab,
        ___DLUPTNLAddressToUpdateItem_iE_Extensions__item__criticality,
        ____DLUPTNLAddressToUpdateItem_iE_Extensions__item__extensionValue_tab,
        ___DLUPTNLAddressToUpdateItem_iE_Extensions__item__extensionValue,
        __DLUPTNLAddressToUpdateItem_iE_Extensions__item_,
        _DLUPTNLAddressToUpdateItem_iE_Extensions,
        DLUPTNLAddressToUpdateItem,
        DLUPTNLAddressToUpdateItemExtIEs,
        DL_TX_Stop,
        DRB_Activity,
        _DRB_Activity_List__item_,
        DRB_Activity_List,
        _DRB_Activity_Item_dRB_ID,
        _DRB_Activity_Item_dRB_Activity,
        ____DRB_Activity_Item_iE_Extensions__item__id_tab,
        ___DRB_Activity_Item_iE_Extensions__item__id,
        ____DRB_Activity_Item_iE_Extensions__item__criticality_tab,
        ___DRB_Activity_Item_iE_Extensions__item__criticality,
        ____DRB_Activity_Item_iE_Extensions__item__extensionValue_tab,
        ___DRB_Activity_Item_iE_Extensions__item__extensionValue,
        __DRB_Activity_Item_iE_Extensions__item_,
        _DRB_Activity_Item_iE_Extensions,
        DRB_Activity_Item,
        DRB_Activity_ItemExtIEs,
        _DRB_Confirm_Modified_List_EUTRAN__item_,
        DRB_Confirm_Modified_List_EUTRAN,
        _DRB_Confirm_Modified_Item_EUTRAN_dRB_ID,
        _DRB_Confirm_Modified_Item_EUTRAN_cell_Group_Information,
        ____DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__id_tab,
        ___DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__id,
        ____DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__criticality_tab,
        ___DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__criticality,
        ____DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__extensionValue_tab,
        ___DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item__extensionValue,
        __DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions__item_,
        _DRB_Confirm_Modified_Item_EUTRAN_iE_Extensions,
        DRB_Confirm_Modified_Item_EUTRAN,
        DRB_Confirm_Modified_Item_EUTRAN_ExtIEs,
        _DRB_Confirm_Modified_List_NG_RAN__item_,
        DRB_Confirm_Modified_List_NG_RAN,
        _DRB_Confirm_Modified_Item_NG_RAN_dRB_ID,
        _DRB_Confirm_Modified_Item_NG_RAN_cell_Group_Information,
        ____DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__id_tab,
        ___DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__id,
        ____DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__criticality_tab,
        ___DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__criticality,
        ____DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__extensionValue_tab,
        ___DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item__extensionValue,
        __DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions__item_,
        _DRB_Confirm_Modified_Item_NG_RAN_iE_Extensions,
        DRB_Confirm_Modified_Item_NG_RAN,
        DRB_Confirm_Modified_Item_NG_RAN_ExtIEs,
        _DRB_Failed_List_EUTRAN__item_,
        DRB_Failed_List_EUTRAN,
        _DRB_Failed_Item_EUTRAN_dRB_ID,
        _DRB_Failed_Item_EUTRAN_cause,
        ____DRB_Failed_Item_EUTRAN_iE_Extensions__item__id_tab,
        ___DRB_Failed_Item_EUTRAN_iE_Extensions__item__id,
        ____DRB_Failed_Item_EUTRAN_iE_Extensions__item__criticality_tab,
        ___DRB_Failed_Item_EUTRAN_iE_Extensions__item__criticality,
        ____DRB_Failed_Item_EUTRAN_iE_Extensions__item__extensionValue_tab,
        ___DRB_Failed_Item_EUTRAN_iE_Extensions__item__extensionValue,
        __DRB_Failed_Item_EUTRAN_iE_Extensions__item_,
        _DRB_Failed_Item_EUTRAN_iE_Extensions,
        DRB_Failed_Item_EUTRAN,
        DRB_Failed_Item_EUTRAN_ExtIEs,
        _DRB_Failed_Mod_List_EUTRAN__item_,
        DRB_Failed_Mod_List_EUTRAN,
        _DRB_Failed_Mod_Item_EUTRAN_dRB_ID,
        _DRB_Failed_Mod_Item_EUTRAN_cause,
        ____DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__id_tab,
        ___DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__id,
        ____DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__criticality_tab,
        ___DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__criticality,
        ____DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__extensionValue_tab,
        ___DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item__extensionValue,
        __DRB_Failed_Mod_Item_EUTRAN_iE_Extensions__item_,
        _DRB_Failed_Mod_Item_EUTRAN_iE_Extensions,
        DRB_Failed_Mod_Item_EUTRAN,
        DRB_Failed_Mod_Item_EUTRAN_ExtIEs,
        _DRB_Failed_List_NG_RAN__item_,
        DRB_Failed_List_NG_RAN,
        _DRB_Failed_Item_NG_RAN_dRB_ID,
        _DRB_Failed_Item_NG_RAN_cause,
        ____DRB_Failed_Item_NG_RAN_iE_Extensions__item__id_tab,
        ___DRB_Failed_Item_NG_RAN_iE_Extensions__item__id,
        ____DRB_Failed_Item_NG_RAN_iE_Extensions__item__criticality_tab,
        ___DRB_Failed_Item_NG_RAN_iE_Extensions__item__criticality,
        ____DRB_Failed_Item_NG_RAN_iE_Extensions__item__extensionValue_tab,
        ___DRB_Failed_Item_NG_RAN_iE_Extensions__item__extensionValue,
        __DRB_Failed_Item_NG_RAN_iE_Extensions__item_,
        _DRB_Failed_Item_NG_RAN_iE_Extensions,
        DRB_Failed_Item_NG_RAN,
        DRB_Failed_Item_NG_RAN_ExtIEs,
        _DRB_Failed_Mod_List_NG_RAN__item_,
        DRB_Failed_Mod_List_NG_RAN,
        _DRB_Failed_Mod_Item_NG_RAN_dRB_ID,
        _DRB_Failed_Mod_Item_NG_RAN_cause,
        ____DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__id_tab,
        ___DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__id,
        ____DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__criticality_tab,
        ___DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__criticality,
        ____DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue_tab,
        ___DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue,
        __DRB_Failed_Mod_Item_NG_RAN_iE_Extensions__item_,
        _DRB_Failed_Mod_Item_NG_RAN_iE_Extensions,
        DRB_Failed_Mod_Item_NG_RAN,
        DRB_Failed_Mod_Item_NG_RAN_ExtIEs,
        _DRB_Failed_To_Modify_List_EUTRAN__item_,
        DRB_Failed_To_Modify_List_EUTRAN,
        _DRB_Failed_To_Modify_Item_EUTRAN_dRB_ID,
        _DRB_Failed_To_Modify_Item_EUTRAN_cause,
        ____DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__id_tab,
        ___DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__id,
        ____DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality_tab,
        ___DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality,
        ____DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue_tab,
        ___DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue,
        __DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions__item_,
        _DRB_Failed_To_Modify_Item_EUTRAN_iE_Extensions,
        DRB_Failed_To_Modify_Item_EUTRAN,
        DRB_Failed_To_Modify_Item_EUTRAN_ExtIEs,
        _DRB_Failed_To_Modify_List_NG_RAN__item_,
        DRB_Failed_To_Modify_List_NG_RAN,
        _DRB_Failed_To_Modify_Item_NG_RAN_dRB_ID,
        _DRB_Failed_To_Modify_Item_NG_RAN_cause,
        ____DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab,
        ___DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__id,
        ____DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality_tab,
        ___DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality,
        ____DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue_tab,
        ___DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue,
        __DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions__item_,
        _DRB_Failed_To_Modify_Item_NG_RAN_iE_Extensions,
        DRB_Failed_To_Modify_Item_NG_RAN,
        DRB_Failed_To_Modify_Item_NG_RAN_ExtIEs,
        DRB_ID,
        _DRB_Measurement_Results_Information_List__item_,
        DRB_Measurement_Results_Information_List,
        _DRB_Measurement_Results_Information_Item_dRB_ID,
        _DRB_Measurement_Results_Information_Item_uL_D1_Result,
        ____DRB_Measurement_Results_Information_Item_iE_Extensions__item__id_tab,
        ___DRB_Measurement_Results_Information_Item_iE_Extensions__item__id,
        ____DRB_Measurement_Results_Information_Item_iE_Extensions__item__criticality_tab,
        ___DRB_Measurement_Results_Information_Item_iE_Extensions__item__criticality,
        ____DRB_Measurement_Results_Information_Item_iE_Extensions__item__extensionValue_tab,
        ___DRB_Measurement_Results_Information_Item_iE_Extensions__item__extensionValue,
        __DRB_Measurement_Results_Information_Item_iE_Extensions__item_,
        _DRB_Measurement_Results_Information_Item_iE_Extensions,
        DRB_Measurement_Results_Information_Item,
        DRB_Measurement_Results_Information_Item_ExtIEs,
        _DRB_Modified_List_EUTRAN__item_,
        DRB_Modified_List_EUTRAN,
        _DRB_Modified_Item_EUTRAN_dRB_ID,
        _DRB_Modified_Item_EUTRAN_s1_DL_UP_TNL_Information,
        _DRB_Modified_Item_EUTRAN_pDCP_SN_Status_Information,
        _DRB_Modified_Item_EUTRAN_uL_UP_Transport_Parameters,
        ____DRB_Modified_Item_EUTRAN_iE_Extensions__item__id_tab,
        ___DRB_Modified_Item_EUTRAN_iE_Extensions__item__id,
        ____DRB_Modified_Item_EUTRAN_iE_Extensions__item__criticality_tab,
        ___DRB_Modified_Item_EUTRAN_iE_Extensions__item__criticality,
        ____DRB_Modified_Item_EUTRAN_iE_Extensions__item__extensionValue_tab,
        ___DRB_Modified_Item_EUTRAN_iE_Extensions__item__extensionValue,
        __DRB_Modified_Item_EUTRAN_iE_Extensions__item_,
        _DRB_Modified_Item_EUTRAN_iE_Extensions,
        DRB_Modified_Item_EUTRAN,
        DRB_Modified_Item_EUTRAN_ExtIEs,
        _DRB_Modified_List_NG_RAN__item_,
        DRB_Modified_List_NG_RAN,
        _DRB_Modified_Item_NG_RAN_dRB_ID,
        _DRB_Modified_Item_NG_RAN_uL_UP_Transport_Parameters,
        _DRB_Modified_Item_NG_RAN_pDCP_SN_Status_Information,
        _DRB_Modified_Item_NG_RAN_flow_Setup_List,
        _DRB_Modified_Item_NG_RAN_flow_Failed_List,
        ____DRB_Modified_Item_NG_RAN_iE_Extensions__item__id_tab,
        _____DRB_Modified_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRB_Modified_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_1,
        ___DRB_Modified_Item_NG_RAN_iE_Extensions__item__id,
        ___DRB_Modified_Item_NG_RAN_iE_Extensions__item__criticality,
        ___DRB_Modified_Item_NG_RAN_iE_Extensions__item__extensionValue,
        __DRB_Modified_Item_NG_RAN_iE_Extensions__item_,
        _DRB_Modified_Item_NG_RAN_iE_Extensions,
        DRB_Modified_Item_NG_RAN,
        DRB_Modified_Item_NG_RAN_ExtIEs,
        _DRB_Modified_Item_NG_RAN_ExtIEs_val_Extension_0,
        _DRB_Modified_Item_NG_RAN_ExtIEs_val_Extension_1,
        _DRB_Removed_Item_dRB_ID,
        _DRB_Removed_Item_dRB_Released_In_Session,
        _DRB_Removed_Item_dRB_Accumulated_Session_Time,
        __DRB_Removed_Item_qoS_Flow_Removed_List__item_,
        _DRB_Removed_Item_qoS_Flow_Removed_List,
        ____DRB_Removed_Item_iE_Extensions__item__id_tab,
        ___DRB_Removed_Item_iE_Extensions__item__id,
        ____DRB_Removed_Item_iE_Extensions__item__criticality_tab,
        ___DRB_Removed_Item_iE_Extensions__item__criticality,
        ____DRB_Removed_Item_iE_Extensions__item__extensionValue_tab,
        ___DRB_Removed_Item_iE_Extensions__item__extensionValue,
        __DRB_Removed_Item_iE_Extensions__item_,
        _DRB_Removed_Item_iE_Extensions,
        DRB_Removed_Item,
        DRB_Removed_Item_ExtIEs,
        _DRB_Required_To_Modify_List_EUTRAN__item_,
        DRB_Required_To_Modify_List_EUTRAN,
        _DRB_Required_To_Modify_Item_EUTRAN_dRB_ID,
        _DRB_Required_To_Modify_Item_EUTRAN_s1_DL_UP_TNL_Information,
        _DRB_Required_To_Modify_Item_EUTRAN_gNB_CU_UP_CellGroupRelatedConfiguration,
        _DRB_Required_To_Modify_Item_EUTRAN_cause,
        ____DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__id_tab,
        ___DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__id,
        ____DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality_tab,
        ___DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality,
        ____DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue_tab,
        ___DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue,
        __DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions__item_,
        _DRB_Required_To_Modify_Item_EUTRAN_iE_Extensions,
        DRB_Required_To_Modify_Item_EUTRAN,
        DRB_Required_To_Modify_Item_EUTRAN_ExtIEs,
        _DRB_Required_To_Modify_List_NG_RAN__item_,
        DRB_Required_To_Modify_List_NG_RAN,
        _DRB_Required_To_Modify_Item_NG_RAN_dRB_ID,
        _DRB_Required_To_Modify_Item_NG_RAN_gNB_CU_UP_CellGroupRelatedConfiguration,
        _DRB_Required_To_Modify_Item_NG_RAN_flow_To_Remove,
        _DRB_Required_To_Modify_Item_NG_RAN_cause,
        ____DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab,
        ___DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__id,
        ____DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality_tab,
        ___DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality,
        ____DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue_tab,
        ___DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue,
        __DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions__item_,
        _DRB_Required_To_Modify_Item_NG_RAN_iE_Extensions,
        DRB_Required_To_Modify_Item_NG_RAN,
        DRB_Required_To_Modify_Item_NG_RAN_ExtIEs,
        _DRB_Setup_List_EUTRAN__item_,
        DRB_Setup_List_EUTRAN,
        _DRB_Setup_Item_EUTRAN_dRB_ID,
        _DRB_Setup_Item_EUTRAN_s1_DL_UP_TNL_Information,
        _DRB_Setup_Item_EUTRAN_data_Forwarding_Information_Response,
        _DRB_Setup_Item_EUTRAN_uL_UP_Transport_Parameters,
        _DRB_Setup_Item_EUTRAN_s1_DL_UP_Unchanged,
        ____DRB_Setup_Item_EUTRAN_iE_Extensions__item__id_tab,
        _____DRB_Setup_Item_EUTRAN_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRB_Setup_Item_EUTRAN_iE_Extensions__item__id_tab_val_Extension_1,
        ___DRB_Setup_Item_EUTRAN_iE_Extensions__item__id,
        ___DRB_Setup_Item_EUTRAN_iE_Extensions__item__criticality,
        ___DRB_Setup_Item_EUTRAN_iE_Extensions__item__extensionValue,
        __DRB_Setup_Item_EUTRAN_iE_Extensions__item_,
        _DRB_Setup_Item_EUTRAN_iE_Extensions,
        DRB_Setup_Item_EUTRAN,
        DRB_Setup_Item_EUTRAN_ExtIEs,
        _DRB_Setup_Item_EUTRAN_ExtIEs_val_Extension_0,
        _DRB_Setup_Item_EUTRAN_ExtIEs_val_Extension_1,
        _DRB_Setup_Mod_List_EUTRAN__item_,
        DRB_Setup_Mod_List_EUTRAN,
        _DRB_Setup_Mod_Item_EUTRAN_dRB_ID,
        _DRB_Setup_Mod_Item_EUTRAN_s1_DL_UP_TNL_Information,
        _DRB_Setup_Mod_Item_EUTRAN_data_Forwarding_Information_Response,
        _DRB_Setup_Mod_Item_EUTRAN_uL_UP_Transport_Parameters,
        ____DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id_tab,
        _____DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id_tab_val_Extension_1,
        ___DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id,
        ___DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__criticality,
        ___DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item__extensionValue,
        __DRB_Setup_Mod_Item_EUTRAN_iE_Extensions__item_,
        _DRB_Setup_Mod_Item_EUTRAN_iE_Extensions,
        DRB_Setup_Mod_Item_EUTRAN,
        DRB_Setup_Mod_Item_EUTRAN_ExtIEs,
        _DRB_Setup_Mod_Item_EUTRAN_ExtIEs_val_Extension_0,
        _DRB_Setup_Mod_Item_EUTRAN_ExtIEs_val_Extension_1,
        _DRB_Setup_List_NG_RAN__item_,
        DRB_Setup_List_NG_RAN,
        _DRB_Setup_Item_NG_RAN_dRB_ID,
        _DRB_Setup_Item_NG_RAN_dRB_data_Forwarding_Information_Response,
        _DRB_Setup_Item_NG_RAN_uL_UP_Transport_Parameters,
        _DRB_Setup_Item_NG_RAN_flow_Setup_List,
        _DRB_Setup_Item_NG_RAN_flow_Failed_List,
        ____DRB_Setup_Item_NG_RAN_iE_Extensions__item__id_tab,
        ___DRB_Setup_Item_NG_RAN_iE_Extensions__item__id,
        ____DRB_Setup_Item_NG_RAN_iE_Extensions__item__criticality_tab,
        ___DRB_Setup_Item_NG_RAN_iE_Extensions__item__criticality,
        ____DRB_Setup_Item_NG_RAN_iE_Extensions__item__extensionValue_tab,
        ___DRB_Setup_Item_NG_RAN_iE_Extensions__item__extensionValue,
        __DRB_Setup_Item_NG_RAN_iE_Extensions__item_,
        _DRB_Setup_Item_NG_RAN_iE_Extensions,
        DRB_Setup_Item_NG_RAN,
        DRB_Setup_Item_NG_RAN_ExtIEs,
        _DRB_Setup_Mod_List_NG_RAN__item_,
        DRB_Setup_Mod_List_NG_RAN,
        _DRB_Setup_Mod_Item_NG_RAN_dRB_ID,
        _DRB_Setup_Mod_Item_NG_RAN_dRB_data_Forwarding_Information_Response,
        _DRB_Setup_Mod_Item_NG_RAN_uL_UP_Transport_Parameters,
        _DRB_Setup_Mod_Item_NG_RAN_flow_Setup_List,
        _DRB_Setup_Mod_Item_NG_RAN_flow_Failed_List,
        ____DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id_tab,
        ___DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id,
        ____DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__criticality_tab,
        ___DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__criticality,
        ____DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue_tab,
        ___DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue,
        __DRB_Setup_Mod_Item_NG_RAN_iE_Extensions__item_,
        _DRB_Setup_Mod_Item_NG_RAN_iE_Extensions,
        DRB_Setup_Mod_Item_NG_RAN,
        DRB_Setup_Mod_Item_NG_RAN_ExtIEs,
        _DRB_Status_Item_dRB_ID,
        _DRB_Status_Item_pDCP_DL_Count,
        _DRB_Status_Item_pDCP_UL_Count,
        ____DRB_Status_Item_iE_Extensions__item__id_tab,
        ___DRB_Status_Item_iE_Extensions__item__id,
        ____DRB_Status_Item_iE_Extensions__item__criticality_tab,
        ___DRB_Status_Item_iE_Extensions__item__criticality,
        ____DRB_Status_Item_iE_Extensions__item__extensionValue_tab,
        ___DRB_Status_Item_iE_Extensions__item__extensionValue,
        __DRB_Status_Item_iE_Extensions__item_,
        _DRB_Status_Item_iE_Extensions,
        DRB_Status_Item,
        DRB_Status_ItemExtIEs,
        _DRBs_Subject_To_Counter_Check_List_EUTRAN__item_,
        DRBs_Subject_To_Counter_Check_List_EUTRAN,
        _DRBs_Subject_To_Counter_Check_Item_EUTRAN_dRB_ID,
        _DRBs_Subject_To_Counter_Check_Item_EUTRAN_pDCP_UL_Count,
        _DRBs_Subject_To_Counter_Check_Item_EUTRAN_pDCP_DL_Count,
        ____DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__id_tab,
        ___DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__id,
        ____DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__criticality_tab,
        ___DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__criticality,
        ____DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__extensionValue_tab,
        ___DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item__extensionValue,
        __DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions__item_,
        _DRBs_Subject_To_Counter_Check_Item_EUTRAN_iE_Extensions,
        DRBs_Subject_To_Counter_Check_Item_EUTRAN,
        DRBs_Subject_To_Counter_Check_Item_EUTRAN_ExtIEs,
        _DRBs_Subject_To_Counter_Check_List_NG_RAN__item_,
        DRBs_Subject_To_Counter_Check_List_NG_RAN,
        _DRBs_Subject_To_Counter_Check_Item_NG_RAN_pDU_Session_ID,
        _DRBs_Subject_To_Counter_Check_Item_NG_RAN_dRB_ID,
        _DRBs_Subject_To_Counter_Check_Item_NG_RAN_pDCP_UL_Count,
        _DRBs_Subject_To_Counter_Check_Item_NG_RAN_pDCP_DL_Count,
        ____DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__id_tab,
        ___DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__id,
        ____DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__criticality_tab,
        ___DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__criticality,
        ____DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__extensionValue_tab,
        ___DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item__extensionValue,
        __DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions__item_,
        _DRBs_Subject_To_Counter_Check_Item_NG_RAN_iE_Extensions,
        DRBs_Subject_To_Counter_Check_Item_NG_RAN,
        DRBs_Subject_To_Counter_Check_Item_NG_RAN_ExtIEs,
        _DRBs_Subject_To_Early_Forwarding_List__item_,
        DRBs_Subject_To_Early_Forwarding_List,
        _DRBs_Subject_To_Early_Forwarding_Item_dRB_ID,
        _DRBs_Subject_To_Early_Forwarding_Item_dLCountValue,
        ____DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__id_tab,
        ___DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__id,
        ____DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__criticality_tab,
        ___DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__criticality,
        ____DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__extensionValue_tab,
        ___DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item__extensionValue,
        __DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions__item_,
        _DRBs_Subject_To_Early_Forwarding_Item_iE_Extensions,
        DRBs_Subject_To_Early_Forwarding_Item,
        DRBs_Subject_To_Early_Forwarding_Item_ExtIEs,
        _DRB_To_Modify_List_EUTRAN__item_,
        DRB_To_Modify_List_EUTRAN,
        _DRB_To_Modify_Item_EUTRAN_dRB_ID,
        _DRB_To_Modify_Item_EUTRAN_pDCP_Configuration,
        _DRB_To_Modify_Item_EUTRAN_eUTRAN_QoS,
        _DRB_To_Modify_Item_EUTRAN_s1_UL_UP_TNL_Information,
        _DRB_To_Modify_Item_EUTRAN_data_Forwarding_Information,
        _DRB_To_Modify_Item_EUTRAN_pDCP_SN_Status_Request,
        _DRB_To_Modify_Item_EUTRAN_pDCP_SN_Status_Information,
        _DRB_To_Modify_Item_EUTRAN_dL_UP_Parameters,
        _DRB_To_Modify_Item_EUTRAN_cell_Group_To_Add,
        _DRB_To_Modify_Item_EUTRAN_cell_Group_To_Modify,
        _DRB_To_Modify_Item_EUTRAN_cell_Group_To_Remove,
        _DRB_To_Modify_Item_EUTRAN_dRB_Inactivity_Timer,
        ____DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__id_tab,
        ___DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__id,
        ____DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality_tab,
        ___DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__criticality,
        ____DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue_tab,
        ___DRB_To_Modify_Item_EUTRAN_iE_Extensions__item__extensionValue,
        __DRB_To_Modify_Item_EUTRAN_iE_Extensions__item_,
        _DRB_To_Modify_Item_EUTRAN_iE_Extensions,
        DRB_To_Modify_Item_EUTRAN,
        DRB_To_Modify_Item_EUTRAN_ExtIEs,
        _DRB_To_Modify_List_NG_RAN__item_,
        DRB_To_Modify_List_NG_RAN,
        _DRB_To_Modify_Item_NG_RAN_dRB_ID,
        _DRB_To_Modify_Item_NG_RAN_sDAP_Configuration,
        _DRB_To_Modify_Item_NG_RAN_pDCP_Configuration,
        _DRB_To_Modify_Item_NG_RAN_dRB_Data_Forwarding_Information,
        _DRB_To_Modify_Item_NG_RAN_pDCP_SN_Status_Request,
        _DRB_To_Modify_Item_NG_RAN_pdcp_SN_Status_Information,
        _DRB_To_Modify_Item_NG_RAN_dL_UP_Parameters,
        _DRB_To_Modify_Item_NG_RAN_cell_Group_To_Add,
        _DRB_To_Modify_Item_NG_RAN_cell_Group_To_Modify,
        _DRB_To_Modify_Item_NG_RAN_cell_Group_To_Remove,
        _DRB_To_Modify_Item_NG_RAN_flow_Mapping_Information,
        _DRB_To_Modify_Item_NG_RAN_dRB_Inactivity_Timer,
        ____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab,
        _____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_1,
        _____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_2,
        _____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_3,
        _____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_4,
        _____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_5,
        _____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_6,
        _____DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_7,
        ___DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__id,
        ___DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__criticality,
        ___DRB_To_Modify_Item_NG_RAN_iE_Extensions__item__extensionValue,
        __DRB_To_Modify_Item_NG_RAN_iE_Extensions__item_,
        _DRB_To_Modify_Item_NG_RAN_iE_Extensions,
        DRB_To_Modify_Item_NG_RAN,
        DRB_To_Modify_Item_NG_RAN_ExtIEs,
        _DRB_To_Modify_Item_NG_RAN_ExtIEs_val_Extension_0,
        _DRB_To_Modify_Item_NG_RAN_ExtIEs_val_Extension_1,
        _DRB_To_Modify_Item_NG_RAN_ExtIEs_val_Extension_2,
        _DRB_To_Modify_Item_NG_RAN_ExtIEs_val_Extension_3,
        _DRB_To_Modify_Item_NG_RAN_ExtIEs_val_Extension_4,
        _DRB_To_Modify_Item_NG_RAN_ExtIEs_val_Extension_5,
        _DRB_To_Modify_Item_NG_RAN_ExtIEs_val_Extension_6,
        _DRB_To_Modify_Item_NG_RAN_ExtIEs_val_Extension_7,
        _DRB_To_Remove_List_EUTRAN__item_,
        DRB_To_Remove_List_EUTRAN,
        _DRB_To_Remove_Item_EUTRAN_dRB_ID,
        ____DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__id_tab,
        ___DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__id,
        ____DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__criticality_tab,
        ___DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__criticality,
        ____DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__extensionValue_tab,
        ___DRB_To_Remove_Item_EUTRAN_iE_Extensions__item__extensionValue,
        __DRB_To_Remove_Item_EUTRAN_iE_Extensions__item_,
        _DRB_To_Remove_Item_EUTRAN_iE_Extensions,
        DRB_To_Remove_Item_EUTRAN,
        DRB_To_Remove_Item_EUTRAN_ExtIEs,
        _DRB_Required_To_Remove_List_EUTRAN__item_,
        DRB_Required_To_Remove_List_EUTRAN,
        _DRB_Required_To_Remove_Item_EUTRAN_dRB_ID,
        _DRB_Required_To_Remove_Item_EUTRAN_cause,
        ____DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__id_tab,
        ___DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__id,
        ____DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__criticality_tab,
        ___DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__criticality,
        ____DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__extensionValue_tab,
        ___DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item__extensionValue,
        __DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions__item_,
        _DRB_Required_To_Remove_Item_EUTRAN_iE_Extensions,
        DRB_Required_To_Remove_Item_EUTRAN,
        DRB_Required_To_Remove_Item_EUTRAN_ExtIEs,
        _DRB_To_Remove_List_NG_RAN__item_,
        DRB_To_Remove_List_NG_RAN,
        _DRB_To_Remove_Item_NG_RAN_dRB_ID,
        ____DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__id_tab,
        ___DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__id,
        ____DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__criticality_tab,
        ___DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__criticality,
        ____DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__extensionValue_tab,
        ___DRB_To_Remove_Item_NG_RAN_iE_Extensions__item__extensionValue,
        __DRB_To_Remove_Item_NG_RAN_iE_Extensions__item_,
        _DRB_To_Remove_Item_NG_RAN_iE_Extensions,
        DRB_To_Remove_Item_NG_RAN,
        DRB_To_Remove_Item_NG_RAN_ExtIEs,
        _DRB_Required_To_Remove_List_NG_RAN__item_,
        DRB_Required_To_Remove_List_NG_RAN,
        _DRB_Required_To_Remove_Item_NG_RAN_dRB_ID,
        _DRB_Required_To_Remove_Item_NG_RAN_cause,
        ____DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__id_tab,
        ___DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__id,
        ____DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__criticality_tab,
        ___DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__criticality,
        ____DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__extensionValue_tab,
        ___DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item__extensionValue,
        __DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions__item_,
        _DRB_Required_To_Remove_Item_NG_RAN_iE_Extensions,
        DRB_Required_To_Remove_Item_NG_RAN,
        DRB_Required_To_Remove_Item_NG_RAN_ExtIEs,
        _DRB_To_Setup_List_EUTRAN__item_,
        DRB_To_Setup_List_EUTRAN,
        _DRB_To_Setup_Item_EUTRAN_dRB_ID,
        _DRB_To_Setup_Item_EUTRAN_pDCP_Configuration,
        _DRB_To_Setup_Item_EUTRAN_eUTRAN_QoS,
        _DRB_To_Setup_Item_EUTRAN_s1_UL_UP_TNL_Information,
        _DRB_To_Setup_Item_EUTRAN_data_Forwarding_Information_Request,
        _DRB_To_Setup_Item_EUTRAN_cell_Group_Information,
        _DRB_To_Setup_Item_EUTRAN_dL_UP_Parameters,
        _DRB_To_Setup_Item_EUTRAN_dRB_Inactivity_Timer,
        _DRB_To_Setup_Item_EUTRAN_existing_Allocated_S1_DL_UP_TNL_Info,
        ____DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__id_tab,
        _____DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__id_tab_val_Extension_1,
        ___DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__id,
        ___DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__criticality,
        ___DRB_To_Setup_Item_EUTRAN_iE_Extensions__item__extensionValue,
        __DRB_To_Setup_Item_EUTRAN_iE_Extensions__item_,
        _DRB_To_Setup_Item_EUTRAN_iE_Extensions,
        DRB_To_Setup_Item_EUTRAN,
        DRB_To_Setup_Item_EUTRAN_ExtIEs,
        _DRB_To_Setup_Item_EUTRAN_ExtIEs_val_Extension_0,
        _DRB_To_Setup_Item_EUTRAN_ExtIEs_val_Extension_1,
        _DRB_To_Setup_Mod_List_EUTRAN__item_,
        DRB_To_Setup_Mod_List_EUTRAN,
        _DRB_To_Setup_Mod_Item_EUTRAN_dRB_ID,
        _DRB_To_Setup_Mod_Item_EUTRAN_pDCP_Configuration,
        _DRB_To_Setup_Mod_Item_EUTRAN_eUTRAN_QoS,
        _DRB_To_Setup_Mod_Item_EUTRAN_s1_UL_UP_TNL_Information,
        _DRB_To_Setup_Mod_Item_EUTRAN_data_Forwarding_Information_Request,
        _DRB_To_Setup_Mod_Item_EUTRAN_cell_Group_Information,
        _DRB_To_Setup_Mod_Item_EUTRAN_dL_UP_Parameters,
        _DRB_To_Setup_Mod_Item_EUTRAN_dRB_Inactivity_Timer,
        ____DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id_tab,
        _____DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id_tab_val_Extension_1,
        ___DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__id,
        ___DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__criticality,
        ___DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item__extensionValue,
        __DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions__item_,
        _DRB_To_Setup_Mod_Item_EUTRAN_iE_Extensions,
        DRB_To_Setup_Mod_Item_EUTRAN,
        DRB_To_Setup_Mod_Item_EUTRAN_ExtIEs,
        _DRB_To_Setup_Mod_Item_EUTRAN_ExtIEs_val_Extension_0,
        _DRB_To_Setup_Mod_Item_EUTRAN_ExtIEs_val_Extension_1,
        _DRB_To_Setup_List_NG_RAN__item_,
        DRB_To_Setup_List_NG_RAN,
        _DRB_To_Setup_Item_NG_RAN_dRB_ID,
        _DRB_To_Setup_Item_NG_RAN_sDAP_Configuration,
        _DRB_To_Setup_Item_NG_RAN_pDCP_Configuration,
        _DRB_To_Setup_Item_NG_RAN_cell_Group_Information,
        _DRB_To_Setup_Item_NG_RAN_qos_flow_Information_To_Be_Setup,
        _DRB_To_Setup_Item_NG_RAN_dRB_Data_Forwarding_Information_Request,
        _DRB_To_Setup_Item_NG_RAN_dRB_Inactivity_Timer,
        _DRB_To_Setup_Item_NG_RAN_pDCP_SN_Status_Information,
        ____DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id_tab,
        _____DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_1,
        _____DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_2,
        _____DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_3,
        _____DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_4,
        ___DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__id,
        ___DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__criticality,
        ___DRB_To_Setup_Item_NG_RAN_iE_Extensions__item__extensionValue,
        __DRB_To_Setup_Item_NG_RAN_iE_Extensions__item_,
        _DRB_To_Setup_Item_NG_RAN_iE_Extensions,
        DRB_To_Setup_Item_NG_RAN,
        DRB_To_Setup_Item_NG_RAN_ExtIEs,
        _DRB_To_Setup_Item_NG_RAN_ExtIEs_val_Extension_0,
        _DRB_To_Setup_Item_NG_RAN_ExtIEs_val_Extension_1,
        _DRB_To_Setup_Item_NG_RAN_ExtIEs_val_Extension_2,
        _DRB_To_Setup_Item_NG_RAN_ExtIEs_val_Extension_3,
        _DRB_To_Setup_Item_NG_RAN_ExtIEs_val_Extension_4,
        _DRB_To_Setup_Mod_List_NG_RAN__item_,
        DRB_To_Setup_Mod_List_NG_RAN,
        _DRB_To_Setup_Mod_Item_NG_RAN_dRB_ID,
        _DRB_To_Setup_Mod_Item_NG_RAN_sDAP_Configuration,
        _DRB_To_Setup_Mod_Item_NG_RAN_pDCP_Configuration,
        _DRB_To_Setup_Mod_Item_NG_RAN_cell_Group_Information,
        _DRB_To_Setup_Mod_Item_NG_RAN_flow_Mapping_Information,
        _DRB_To_Setup_Mod_Item_NG_RAN_dRB_Data_Forwarding_Information_Request,
        _DRB_To_Setup_Mod_Item_NG_RAN_dRB_Inactivity_Timer,
        _DRB_To_Setup_Mod_Item_NG_RAN_pDCP_SN_Status_Information,
        ____DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id_tab,
        _____DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_1,
        _____DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_2,
        _____DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id_tab_val_Extension_3,
        ___DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__id,
        ___DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__criticality,
        ___DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item__extensionValue,
        __DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions__item_,
        _DRB_To_Setup_Mod_Item_NG_RAN_iE_Extensions,
        DRB_To_Setup_Mod_Item_NG_RAN,
        DRB_To_Setup_Mod_Item_NG_RAN_ExtIEs,
        _DRB_To_Setup_Mod_Item_NG_RAN_ExtIEs_val_Extension_0,
        _DRB_To_Setup_Mod_Item_NG_RAN_ExtIEs_val_Extension_1,
        _DRB_To_Setup_Mod_Item_NG_RAN_ExtIEs_val_Extension_2,
        _DRB_To_Setup_Mod_Item_NG_RAN_ExtIEs_val_Extension_3,
        _DRB_Usage_Report_List__item_,
        DRB_Usage_Report_List,
        _DRB_Usage_Report_Item_startTimeStamp,
        _DRB_Usage_Report_Item_endTimeStamp,
        _DRB_Usage_Report_Item_usageCountUL,
        _DRB_Usage_Report_Item_usageCountDL,
        ____DRB_Usage_Report_Item_iE_Extensions__item__id_tab,
        ___DRB_Usage_Report_Item_iE_Extensions__item__id,
        ____DRB_Usage_Report_Item_iE_Extensions__item__criticality_tab,
        ___DRB_Usage_Report_Item_iE_Extensions__item__criticality,
        ____DRB_Usage_Report_Item_iE_Extensions__item__extensionValue_tab,
        ___DRB_Usage_Report_Item_iE_Extensions__item__extensionValue,
        __DRB_Usage_Report_Item_iE_Extensions__item_,
        _DRB_Usage_Report_Item_iE_Extensions,
        DRB_Usage_Report_Item,
        DRB_Usage_Report_Item_ExtIEs,
        Duplication_Activation,
        _Dynamic5QIDescriptor_qoSPriorityLevel,
        _Dynamic5QIDescriptor_packetDelayBudget,
        _Dynamic5QIDescriptor_packetErrorRate,
        _Dynamic5QIDescriptor_fiveQI,
        _Dynamic5QIDescriptor_delayCritical,
        _Dynamic5QIDescriptor_averagingWindow,
        _Dynamic5QIDescriptor_maxDataBurstVolume,
        ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab,
        _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0,
        _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1,
        _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_2,
        ___Dynamic5QIDescriptor_iE_Extensions__item__id,
        ___Dynamic5QIDescriptor_iE_Extensions__item__criticality,
        ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue,
        __Dynamic5QIDescriptor_iE_Extensions__item_,
        _Dynamic5QIDescriptor_iE_Extensions,
        Dynamic5QIDescriptor,
        Dynamic5QIDescriptor_ExtIEs,
        _Dynamic5QIDescriptor_ExtIEs_val_Extension_0,
        _Dynamic5QIDescriptor_ExtIEs_val_Extension_1,
        _Dynamic5QIDescriptor_ExtIEs_val_Extension_2,
        DataDiscardRequired,
        EarlyDataForwardingIndicator,
        _EarlyForwardingCOUNTInfo_firstDLCount,
        _EarlyForwardingCOUNTInfo_dLDiscardingCount,
        ___EarlyForwardingCOUNTInfo_choice_Extension_id_tab,
        __EarlyForwardingCOUNTInfo_choice_Extension_id,
        ___EarlyForwardingCOUNTInfo_choice_Extension_criticality_tab,
        __EarlyForwardingCOUNTInfo_choice_Extension_criticality,
        ___EarlyForwardingCOUNTInfo_choice_Extension_value_tab,
        __EarlyForwardingCOUNTInfo_choice_Extension_value,
        _EarlyForwardingCOUNTInfo_choice_Extension,
        EarlyForwardingCOUNTInfo,
        EarlyForwardingCOUNTInfo_ExtIEs,
        EarlyForwardingCOUNTReq,
        _EHC_Common_Parameters_ehc_CID_Length,
        ____EHC_Common_Parameters_iE_Extensions__item__id_tab,
        ___EHC_Common_Parameters_iE_Extensions__item__id,
        ____EHC_Common_Parameters_iE_Extensions__item__criticality_tab,
        ___EHC_Common_Parameters_iE_Extensions__item__criticality,
        ____EHC_Common_Parameters_iE_Extensions__item__extensionValue_tab,
        ___EHC_Common_Parameters_iE_Extensions__item__extensionValue,
        __EHC_Common_Parameters_iE_Extensions__item_,
        _EHC_Common_Parameters_iE_Extensions,
        EHC_Common_Parameters,
        EHC_Common_Parameters_ExtIEs,
        _EHC_Downlink_Parameters_drb_ContinueEHC_DL,
        ____EHC_Downlink_Parameters_iE_Extensions__item__id_tab,
        _____EHC_Downlink_Parameters_iE_Extensions__item__id_tab_val_Extension_0,
        ___EHC_Downlink_Parameters_iE_Extensions__item__id,
        ___EHC_Downlink_Parameters_iE_Extensions__item__criticality,
        ___EHC_Downlink_Parameters_iE_Extensions__item__extensionValue,
        __EHC_Downlink_Parameters_iE_Extensions__item_,
        _EHC_Downlink_Parameters_iE_Extensions,
        EHC_Downlink_Parameters,
        EHC_Downlink_Parameters_ExtIEs,
        _EHC_Downlink_Parameters_ExtIEs_val_Extension_0,
        _EHC_Uplink_Parameters_drb_ContinueEHC_UL,
        ____EHC_Uplink_Parameters_iE_Extensions__item__id_tab,
        ___EHC_Uplink_Parameters_iE_Extensions__item__id,
        ____EHC_Uplink_Parameters_iE_Extensions__item__criticality_tab,
        ___EHC_Uplink_Parameters_iE_Extensions__item__criticality,
        ____EHC_Uplink_Parameters_iE_Extensions__item__extensionValue_tab,
        ___EHC_Uplink_Parameters_iE_Extensions__item__extensionValue,
        __EHC_Uplink_Parameters_iE_Extensions__item_,
        _EHC_Uplink_Parameters_iE_Extensions,
        EHC_Uplink_Parameters,
        EHC_Uplink_Parameters_ExtIEs,
        _EHC_Parameters_ehc_Common,
        _EHC_Parameters_ehc_Downlink,
        _EHC_Parameters_ehc_Uplink,
        ____EHC_Parameters_iE_Extensions__item__id_tab,
        ___EHC_Parameters_iE_Extensions__item__id,
        ____EHC_Parameters_iE_Extensions__item__criticality_tab,
        ___EHC_Parameters_iE_Extensions__item__criticality,
        ____EHC_Parameters_iE_Extensions__item__extensionValue_tab,
        ___EHC_Parameters_iE_Extensions__item__extensionValue,
        __EHC_Parameters_iE_Extensions__item_,
        _EHC_Parameters_iE_Extensions,
        EHC_Parameters,
        EHC_Parameters_ExtIEs,
        EncryptionKey,
        _Endpoint_IP_address_and_port_endpoint_IP_Address,
        _Endpoint_IP_address_and_port_portNumber,
        ____Endpoint_IP_address_and_port_iE_Extensions__item__id_tab,
        ___Endpoint_IP_address_and_port_iE_Extensions__item__id,
        ____Endpoint_IP_address_and_port_iE_Extensions__item__criticality_tab,
        ___Endpoint_IP_address_and_port_iE_Extensions__item__criticality,
        ____Endpoint_IP_address_and_port_iE_Extensions__item__extensionValue_tab,
        ___Endpoint_IP_address_and_port_iE_Extensions__item__extensionValue,
        __Endpoint_IP_address_and_port_iE_Extensions__item_,
        _Endpoint_IP_address_and_port_iE_Extensions,
        Endpoint_IP_address_and_port,
        Endpoint_IP_address_and_port_ExtIEs,
        _EUTRANAllocationAndRetentionPriority_priorityLevel,
        _EUTRANAllocationAndRetentionPriority_pre_emptionCapability,
        _EUTRANAllocationAndRetentionPriority_pre_emptionVulnerability,
        ____EUTRANAllocationAndRetentionPriority_iE_Extensions__item__id_tab,
        ___EUTRANAllocationAndRetentionPriority_iE_Extensions__item__id,
        ____EUTRANAllocationAndRetentionPriority_iE_Extensions__item__criticality_tab,
        ___EUTRANAllocationAndRetentionPriority_iE_Extensions__item__criticality,
        ____EUTRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab,
        ___EUTRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue,
        __EUTRANAllocationAndRetentionPriority_iE_Extensions__item_,
        _EUTRANAllocationAndRetentionPriority_iE_Extensions,
        EUTRANAllocationAndRetentionPriority,
        ExtendedPacketDelayBudget,
        EUTRANAllocationAndRetentionPriority_ExtIEs,
        E_UTRAN_Cell_Identity,
        _ECGI_pLMN_Identity,
        _ECGI_eUTRAN_Cell_Identity,
        ____ECGI_iE_Extensions__item__id_tab,
        ___ECGI_iE_Extensions__item__id,
        ____ECGI_iE_Extensions__item__criticality_tab,
        ___ECGI_iE_Extensions__item__criticality,
        ____ECGI_iE_Extensions__item__extensionValue_tab,
        ___ECGI_iE_Extensions__item__extensionValue,
        __ECGI_iE_Extensions__item_,
        _ECGI_iE_Extensions,
        ECGI,
        ECGI_ExtIEs,
        _ECGI_Support_List__item_,
        ECGI_Support_List,
        _ECGI_Support_Item_eCGI,
        ____ECGI_Support_Item_iE_Extensions__item__id_tab,
        ___ECGI_Support_Item_iE_Extensions__item__id,
        ____ECGI_Support_Item_iE_Extensions__item__criticality_tab,
        ___ECGI_Support_Item_iE_Extensions__item__criticality,
        ____ECGI_Support_Item_iE_Extensions__item__extensionValue_tab,
        ___ECGI_Support_Item_iE_Extensions__item__extensionValue,
        __ECGI_Support_Item_iE_Extensions__item_,
        _ECGI_Support_Item_iE_Extensions,
        ECGI_Support_Item,
        ECGI_Support_Item_ExtIEs,
        _EUTRAN_QoS_Support_List__item_,
        EUTRAN_QoS_Support_List,
        _EUTRAN_QoS_Support_Item_eUTRAN_QoS,
        ____EUTRAN_QoS_Support_Item_iE_Extensions__item__id_tab,
        ___EUTRAN_QoS_Support_Item_iE_Extensions__item__id,
        ____EUTRAN_QoS_Support_Item_iE_Extensions__item__criticality_tab,
        ___EUTRAN_QoS_Support_Item_iE_Extensions__item__criticality,
        ____EUTRAN_QoS_Support_Item_iE_Extensions__item__extensionValue_tab,
        ___EUTRAN_QoS_Support_Item_iE_Extensions__item__extensionValue,
        __EUTRAN_QoS_Support_Item_iE_Extensions__item_,
        _EUTRAN_QoS_Support_Item_iE_Extensions,
        EUTRAN_QoS_Support_Item,
        EUTRAN_QoS_Support_Item_ExtIEs,
        _EUTRAN_QoS_qCI,
        _EUTRAN_QoS_eUTRANallocationAndRetentionPriority,
        _EUTRAN_QoS_gbrQosInformation,
        ____EUTRAN_QoS_iE_Extensions__item__id_tab,
        ___EUTRAN_QoS_iE_Extensions__item__id,
        ____EUTRAN_QoS_iE_Extensions__item__criticality_tab,
        ___EUTRAN_QoS_iE_Extensions__item__criticality,
        ____EUTRAN_QoS_iE_Extensions__item__extensionValue_tab,
        ___EUTRAN_QoS_iE_Extensions__item__extensionValue,
        __EUTRAN_QoS_iE_Extensions__item_,
        _EUTRAN_QoS_iE_Extensions,
        EUTRAN_QoS,
        EUTRAN_QoS_ExtIEs,
        _ExtendedSliceSupportList__item_,
        ExtendedSliceSupportList,
        _FirstDLCount_firstDLCountVal,
        ____FirstDLCount_iE_Extensions__item__id_tab,
        ___FirstDLCount_iE_Extensions__item__id,
        ____FirstDLCount_iE_Extensions__item__criticality_tab,
        ___FirstDLCount_iE_Extensions__item__criticality,
        ____FirstDLCount_iE_Extensions__item__extensionValue_tab,
        ___FirstDLCount_iE_Extensions__item__extensionValue,
        __FirstDLCount_iE_Extensions__item_,
        _FirstDLCount_iE_Extensions,
        FirstDLCount,
        FirstDLCount_ExtIEs,
        _GlobalMBSSessionID_tmgi,
        _GlobalMBSSessionID_nid,
        ____GlobalMBSSessionID_iE_Extensions__item__id_tab,
        ___GlobalMBSSessionID_iE_Extensions__item__id,
        ____GlobalMBSSessionID_iE_Extensions__item__criticality_tab,
        ___GlobalMBSSessionID_iE_Extensions__item__criticality,
        ____GlobalMBSSessionID_iE_Extensions__item__extensionValue_tab,
        ___GlobalMBSSessionID_iE_Extensions__item__extensionValue,
        __GlobalMBSSessionID_iE_Extensions__item_,
        _GlobalMBSSessionID_iE_Extensions,
        GlobalMBSSessionID,
        GlobalMBSSessionID_ExtIEs,
        GNB_CU_CP_Name,
        _Extended_GNB_CU_CP_Name_gNB_CU_CP_NameVisibleString,
        _Extended_GNB_CU_CP_Name_gNB_CU_CP_NameUTF8String,
        ____Extended_GNB_CU_CP_Name_iE_Extensions__item__id_tab,
        ___Extended_GNB_CU_CP_Name_iE_Extensions__item__id,
        ____Extended_GNB_CU_CP_Name_iE_Extensions__item__criticality_tab,
        ___Extended_GNB_CU_CP_Name_iE_Extensions__item__criticality,
        ____Extended_GNB_CU_CP_Name_iE_Extensions__item__extensionValue_tab,
        ___Extended_GNB_CU_CP_Name_iE_Extensions__item__extensionValue,
        __Extended_GNB_CU_CP_Name_iE_Extensions__item_,
        _Extended_GNB_CU_CP_Name_iE_Extensions,
        Extended_GNB_CU_CP_Name,
        Extended_GNB_CU_CP_Name_ExtIEs,
        GNB_CU_CP_MBS_E1AP_ID,
        GNB_CU_CP_NameVisibleString,
        GNB_CU_CP_NameUTF8String,
        GNB_CU_CP_UE_E1AP_ID,
        GNB_CU_UP_Capacity,
        _GNB_CU_UP_CellGroupRelatedConfiguration__item_,
        GNB_CU_UP_CellGroupRelatedConfiguration,
        _GNB_CU_UP_CellGroupRelatedConfiguration_Item_cell_Group_ID,
        _GNB_CU_UP_CellGroupRelatedConfiguration_Item_uP_TNL_Information,
        _GNB_CU_UP_CellGroupRelatedConfiguration_Item_uL_Configuration,
        ____GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__id_tab,
        ___GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__id,
        ____GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__criticality_tab,
        ___GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__criticality,
        ____GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__extensionValue_tab,
        ___GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item__extensionValue,
        __GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions__item_,
        _GNB_CU_UP_CellGroupRelatedConfiguration_Item_iE_Extensions,
        GNB_CU_UP_CellGroupRelatedConfiguration_Item,
        GNB_CU_UP_CellGroupRelatedConfiguration_Item_ExtIEs,
        GNB_CU_UP_ID,
        _GNB_CU_UP_MBS_Support_Info_mbs_Support_Info_ToAdd_List,
        _GNB_CU_UP_MBS_Support_Info_mbs_Support_Info_ToRemove_List,
        ____GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__id_tab,
        ___GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__id,
        ____GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__criticality_tab,
        ___GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__criticality,
        ____GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__extensionValue_tab,
        ___GNB_CU_UP_MBS_Support_Info_iE_Extensions__item__extensionValue,
        __GNB_CU_UP_MBS_Support_Info_iE_Extensions__item_,
        _GNB_CU_UP_MBS_Support_Info_iE_Extensions,
        GNB_CU_UP_MBS_Support_Info,
        GNB_CU_UP_MBS_Support_Info_ExtIEs,
        GNB_CU_UP_Name,
        _Extended_GNB_CU_UP_Name_gNB_CU_UP_NameVisibleString,
        _Extended_GNB_CU_UP_Name_gNB_CU_UP_NameUTF8String,
        ____Extended_GNB_CU_UP_Name_iE_Extensions__item__id_tab,
        ___Extended_GNB_CU_UP_Name_iE_Extensions__item__id,
        ____Extended_GNB_CU_UP_Name_iE_Extensions__item__criticality_tab,
        ___Extended_GNB_CU_UP_Name_iE_Extensions__item__criticality,
        ____Extended_GNB_CU_UP_Name_iE_Extensions__item__extensionValue_tab,
        ___Extended_GNB_CU_UP_Name_iE_Extensions__item__extensionValue,
        __Extended_GNB_CU_UP_Name_iE_Extensions__item_,
        _Extended_GNB_CU_UP_Name_iE_Extensions,
        Extended_GNB_CU_UP_Name,
        Extended_GNB_CU_UP_Name_ExtIEs,
        GNB_CU_UP_MBS_E1AP_ID,
        GNB_CU_UP_NameVisibleString,
        GNB_CU_UP_NameUTF8String,
        GNB_CU_UP_UE_E1AP_ID,
        _GNB_CU_CP_TNLA_Setup_Item_tNLAssociationTransportLayerAddress,
        ____GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__id_tab,
        ___GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__id,
        ____GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__criticality_tab,
        ___GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__criticality,
        ____GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__extensionValue_tab,
        ___GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item__extensionValue,
        __GNB_CU_CP_TNLA_Setup_Item_iE_Extensions__item_,
        _GNB_CU_CP_TNLA_Setup_Item_iE_Extensions,
        GNB_CU_CP_TNLA_Setup_Item,
        GNB_CU_CP_TNLA_Setup_Item_ExtIEs,
        _GNB_CU_CP_TNLA_Failed_To_Setup_Item_tNLAssociationTransportLayerAddress,
        _GNB_CU_CP_TNLA_Failed_To_Setup_Item_cause,
        ____GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__id_tab,
        ___GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__id,
        ____GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__criticality_tab,
        ___GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__criticality,
        ____GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__extensionValue_tab,
        ___GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item__extensionValue,
        __GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions__item_,
        _GNB_CU_CP_TNLA_Failed_To_Setup_Item_iE_Extensions,
        GNB_CU_CP_TNLA_Failed_To_Setup_Item,
        GNB_CU_CP_TNLA_Failed_To_Setup_Item_ExtIEs,
        _GNB_CU_CP_TNLA_To_Add_Item_tNLAssociationTransportLayerAddress,
        _GNB_CU_CP_TNLA_To_Add_Item_tNLAssociationUsage,
        ____GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__id_tab,
        ___GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__id,
        ____GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__criticality_tab,
        ___GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__criticality,
        ____GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__extensionValue_tab,
        ___GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item__extensionValue,
        __GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions__item_,
        _GNB_CU_CP_TNLA_To_Add_Item_iE_Extensions,
        GNB_CU_CP_TNLA_To_Add_Item,
        GNB_CU_CP_TNLA_To_Add_Item_ExtIEs,
        _GNB_CU_CP_TNLA_To_Remove_Item_tNLAssociationTransportLayerAddress,
        ____GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__id_tab,
        _____GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__id,
        ___GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__criticality,
        ___GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item__extensionValue,
        __GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions__item_,
        _GNB_CU_CP_TNLA_To_Remove_Item_iE_Extensions,
        GNB_CU_CP_TNLA_To_Remove_Item,
        GNB_CU_CP_TNLA_To_Remove_Item_ExtIEs,
        _GNB_CU_CP_TNLA_To_Remove_Item_ExtIEs_val_Extension_0,
        _GNB_CU_CP_TNLA_To_Update_Item_tNLAssociationTransportLayerAddress,
        _GNB_CU_CP_TNLA_To_Update_Item_tNLAssociationUsage,
        ____GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__id_tab,
        ___GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__id,
        ____GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__criticality_tab,
        ___GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__criticality,
        ____GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__extensionValue_tab,
        ___GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item__extensionValue,
        __GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions__item_,
        _GNB_CU_CP_TNLA_To_Update_Item_iE_Extensions,
        GNB_CU_CP_TNLA_To_Update_Item,
        GNB_CU_CP_TNLA_To_Update_Item_ExtIEs,
        _GNB_CU_UP_TNLA_To_Remove_Item_tNLAssociationTransportLayerAddress,
        _GNB_CU_UP_TNLA_To_Remove_Item_tNLAssociationTransportLayerAddressgNBCUCP,
        ____GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__id_tab,
        ___GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__id,
        ____GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__criticality_tab,
        ___GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__criticality,
        ____GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__extensionValue_tab,
        ___GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item__extensionValue,
        __GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions__item_,
        _GNB_CU_UP_TNLA_To_Remove_Item_iE_Extensions,
        GNB_CU_UP_TNLA_To_Remove_Item,
        GNB_CU_UP_TNLA_To_Remove_Item_ExtIEs,
        _GBR_QosInformation_e_RAB_MaximumBitrateDL,
        _GBR_QosInformation_e_RAB_MaximumBitrateUL,
        _GBR_QosInformation_e_RAB_GuaranteedBitrateDL,
        _GBR_QosInformation_e_RAB_GuaranteedBitrateUL,
        ____GBR_QosInformation_iE_Extensions__item__id_tab,
        ___GBR_QosInformation_iE_Extensions__item__id,
        ____GBR_QosInformation_iE_Extensions__item__criticality_tab,
        ___GBR_QosInformation_iE_Extensions__item__criticality,
        ____GBR_QosInformation_iE_Extensions__item__extensionValue_tab,
        ___GBR_QosInformation_iE_Extensions__item__extensionValue,
        __GBR_QosInformation_iE_Extensions__item_,
        _GBR_QosInformation_iE_Extensions,
        GBR_QosInformation,
        GBR_QosInformation_ExtIEs,
        _GBR_QoSFlowInformation_maxFlowBitRateDownlink,
        _GBR_QoSFlowInformation_maxFlowBitRateUplink,
        _GBR_QoSFlowInformation_guaranteedFlowBitRateDownlink,
        _GBR_QoSFlowInformation_guaranteedFlowBitRateUplink,
        _GBR_QoSFlowInformation_maxPacketLossRateDownlink,
        _GBR_QoSFlowInformation_maxPacketLossRateUplink,
        ____GBR_QoSFlowInformation_iE_Extensions__item__id_tab,
        _____GBR_QoSFlowInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___GBR_QoSFlowInformation_iE_Extensions__item__id,
        ___GBR_QoSFlowInformation_iE_Extensions__item__criticality,
        ___GBR_QoSFlowInformation_iE_Extensions__item__extensionValue,
        __GBR_QoSFlowInformation_iE_Extensions__item_,
        _GBR_QoSFlowInformation_iE_Extensions,
        GBR_QoSFlowInformation,
        GBR_QosFlowInformation_ExtIEs,
        _GBR_QosFlowInformation_ExtIEs_val_Extension_0,
        GTP_TEID,
        _GTPTLAs__item_,
        GTPTLAs,
        _GTPTLA_Item_gTPTransportLayerAddresses,
        ____GTPTLA_Item_iE_Extensions__item__id_tab,
        ___GTPTLA_Item_iE_Extensions__item__id,
        ____GTPTLA_Item_iE_Extensions__item__criticality_tab,
        ___GTPTLA_Item_iE_Extensions__item__criticality,
        ____GTPTLA_Item_iE_Extensions__item__extensionValue_tab,
        ___GTPTLA_Item_iE_Extensions__item__extensionValue,
        __GTPTLA_Item_iE_Extensions__item_,
        _GTPTLA_Item_iE_Extensions,
        GTPTLA_Item,
        GTPTLA_Item_ExtIEs,
        _GTPTunnel_transportLayerAddress,
        _GTPTunnel_gTP_TEID,
        ____GTPTunnel_iE_Extensions__item__id_tab,
        ___GTPTunnel_iE_Extensions__item__id,
        ____GTPTunnel_iE_Extensions__item__criticality_tab,
        ___GTPTunnel_iE_Extensions__item__criticality,
        ____GTPTunnel_iE_Extensions__item__extensionValue_tab,
        ___GTPTunnel_iE_Extensions__item__extensionValue,
        __GTPTunnel_iE_Extensions__item_,
        _GTPTunnel_iE_Extensions,
        GTPTunnel,
        GTPTunnel_ExtIEs,
        GNB_CU_UP_OverloadInformation,
        GNB_DU_ID,
        HFN,
        _HW_CapacityIndicator_offeredThroughput,
        _HW_CapacityIndicator_availableThroughput,
        ____HW_CapacityIndicator_iE_Extensions__item__id_tab,
        ___HW_CapacityIndicator_iE_Extensions__item__id,
        ____HW_CapacityIndicator_iE_Extensions__item__criticality_tab,
        ___HW_CapacityIndicator_iE_Extensions__item__criticality,
        ____HW_CapacityIndicator_iE_Extensions__item__extensionValue_tab,
        ___HW_CapacityIndicator_iE_Extensions__item__extensionValue,
        __HW_CapacityIndicator_iE_Extensions__item_,
        _HW_CapacityIndicator_iE_Extensions,
        HW_CapacityIndicator,
        HW_CapacityIndicator_ExtIEs,
        IgnoreMappingRuleIndication,
        IntegrityProtectionIndication,
        IntegrityProtectionAlgorithm,
        IntegrityProtectionKey,
        IntegrityProtectionResult,
        Inactivity_Timer,
        InterfacesToTrace,
        _ImmediateMDT_measurementsToActivate,
        _ImmediateMDT_measurementFour,
        _ImmediateMDT_measurementSix,
        _ImmediateMDT_measurementSeven,
        ____ImmediateMDT_iE_Extensions__item__id_tab,
        ___ImmediateMDT_iE_Extensions__item__id,
        ____ImmediateMDT_iE_Extensions__item__criticality_tab,
        ___ImmediateMDT_iE_Extensions__item__criticality,
        ____ImmediateMDT_iE_Extensions__item__extensionValue_tab,
        ___ImmediateMDT_iE_Extensions__item__extensionValue,
        __ImmediateMDT_iE_Extensions__item_,
        _ImmediateMDT_iE_Extensions,
        ImmediateMDT,
        ImmediateMDT_ExtIEs,
        _IAB_Donor_CU_UPPSKInfo_Item_iAB_donor_CU_UPPSK,
        _IAB_Donor_CU_UPPSKInfo_Item_iAB_donor_CU_UPIPAddress,
        _IAB_Donor_CU_UPPSKInfo_Item_iAB_DUIPAddress,
        ____IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__id_tab,
        ___IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__id,
        ____IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__criticality_tab,
        ___IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__criticality,
        ____IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__extensionValue_tab,
        ___IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item__extensionValue,
        __IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions__item_,
        _IAB_Donor_CU_UPPSKInfo_Item_iE_Extensions,
        IAB_Donor_CU_UPPSKInfo_Item,
        IAB_donor_CU_UPPSKInfoItemExtIEs,
        IAB_donor_CU_UPPSK,
        Links_to_log,
        _LocationDependentMBSNGUInformationAt5GC__item_,
        LocationDependentMBSNGUInformationAt5GC,
        _LocationDependentMBSNGUInformationAt5GC_Item_mbsAreaSession_ID,
        _LocationDependentMBSNGUInformationAt5GC_Item_mbsNGUInformationAt5GC,
        ____LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__id_tab,
        ___LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__id,
        ____LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__criticality_tab,
        ___LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__criticality,
        ____LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__extensionValue_tab,
        ___LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item__extensionValue,
        __LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions__item_,
        _LocationDependentMBSNGUInformationAt5GC_Item_iE_Extensions,
        LocationDependentMBSNGUInformationAt5GC_Item,
        LocationDependentMBSNGUInformationAt5GC_Item_ExtIEs,
        _LocationDependentMBSF1UInformationAtCU__item_,
        LocationDependentMBSF1UInformationAtCU,
        _LocationDependentMBSF1UInformationAtCU_Item_mbsAreaSession_ID,
        _LocationDependentMBSF1UInformationAtCU_Item_mbs_f1u_info_at_CU,
        ____LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__id_tab,
        ___LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__id,
        ____LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__criticality_tab,
        ___LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__criticality,
        ____LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__extensionValue_tab,
        ___LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item__extensionValue,
        __LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions__item_,
        _LocationDependentMBSF1UInformationAtCU_Item_iE_Extensions,
        LocationDependentMBSF1UInformationAtCU_Item,
        LocationDependentMBSF1UInformationAtCU_Item_ExtIEs,
        _LocationDependentMBSF1UInformationAtDU__item_,
        LocationDependentMBSF1UInformationAtDU,
        _LocationDependentMBSF1UInformationAtDU_Item_mbsAreaSession_ID,
        _LocationDependentMBSF1UInformationAtDU_Item_mbs_f1u_info_at_DU,
        ____LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__id_tab,
        ___LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__id,
        ____LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__criticality_tab,
        ___LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__criticality,
        ____LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__extensionValue_tab,
        ___LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item__extensionValue,
        __LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions__item_,
        _LocationDependentMBSF1UInformationAtDU_Item_iE_Extensions,
        LocationDependentMBSF1UInformationAtDU_Item,
        LocationDependentMBSF1UInformationAtDU_Item_ExtIEs,
        _LocationDependentMBSNGUInformationAtNGRAN__item_,
        LocationDependentMBSNGUInformationAtNGRAN,
        _LocationDependentMBSNGUInformationAtNGRAN_Item_mbsAreaSession_ID,
        _LocationDependentMBSNGUInformationAtNGRAN_Item_mbsNGUInformationAtNGRAN,
        ____LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__id_tab,
        ___LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__id,
        ____LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__criticality_tab,
        ___LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__criticality,
        ____LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__extensionValue_tab,
        ___LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item__extensionValue,
        __LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions__item_,
        _LocationDependentMBSNGUInformationAtNGRAN_Item_iE_Extensions,
        LocationDependentMBSNGUInformationAtNGRAN_Item,
        LocationDependentMBSNGUInformationAtNGRAN_Item_ExtIEs,
        MaxDataBurstVolume,
        _MaximumIPdatarate_maxIPrate,
        ____MaximumIPdatarate_iE_Extensions__item__id_tab,
        ___MaximumIPdatarate_iE_Extensions__item__id,
        ____MaximumIPdatarate_iE_Extensions__item__criticality_tab,
        ___MaximumIPdatarate_iE_Extensions__item__criticality,
        ____MaximumIPdatarate_iE_Extensions__item__extensionValue_tab,
        ___MaximumIPdatarate_iE_Extensions__item__extensionValue,
        __MaximumIPdatarate_iE_Extensions__item_,
        _MaximumIPdatarate_iE_Extensions,
        MaximumIPdatarate,
        MaximumIPdatarate_ExtIEs,
        MaxIPrate,
        MaxPacketLossRate,
        MaxCIDEHCDL,
        MBSAreaSessionID,
        _MBSF1UInformationAtCU_mbs_f1u_info_at_CU,
        ____MBSF1UInformationAtCU_iE_Extensions__item__id_tab,
        ___MBSF1UInformationAtCU_iE_Extensions__item__id,
        ____MBSF1UInformationAtCU_iE_Extensions__item__criticality_tab,
        ___MBSF1UInformationAtCU_iE_Extensions__item__criticality,
        ____MBSF1UInformationAtCU_iE_Extensions__item__extensionValue_tab,
        ___MBSF1UInformationAtCU_iE_Extensions__item__extensionValue,
        __MBSF1UInformationAtCU_iE_Extensions__item_,
        _MBSF1UInformationAtCU_iE_Extensions,
        MBSF1UInformationAtCU,
        MBSF1UInformationAtCU_ExtIEs,
        _MBSF1UInformationAtDU_mbs_f1u_info_at_DU,
        ____MBSF1UInformationAtDU_iE_Extensions__item__id_tab,
        ___MBSF1UInformationAtDU_iE_Extensions__item__id,
        ____MBSF1UInformationAtDU_iE_Extensions__item__criticality_tab,
        ___MBSF1UInformationAtDU_iE_Extensions__item__criticality,
        ____MBSF1UInformationAtDU_iE_Extensions__item__extensionValue_tab,
        ___MBSF1UInformationAtDU_iE_Extensions__item__extensionValue,
        __MBSF1UInformationAtDU_iE_Extensions__item_,
        _MBSF1UInformationAtDU_iE_Extensions,
        MBSF1UInformationAtDU,
        MBSF1UInformationAtDU_ExtIEs,
        _MBSNGUInformationAt5GC_multicast,
        _MBSNGUInformationAt5GC_unicast,
        ___MBSNGUInformationAt5GC_choice_extension_id_tab,
        __MBSNGUInformationAt5GC_choice_extension_id,
        ___MBSNGUInformationAt5GC_choice_extension_criticality_tab,
        __MBSNGUInformationAt5GC_choice_extension_criticality,
        ___MBSNGUInformationAt5GC_choice_extension_value_tab,
        __MBSNGUInformationAt5GC_choice_extension_value,
        _MBSNGUInformationAt5GC_choice_extension,
        MBSNGUInformationAt5GC,
        MBSNGUInformationAt5GC_ExtIEs,
        _MBSNGUInformationAt5GC_Multicast_ipmcAddress,
        _MBSNGUInformationAt5GC_Multicast_ipsourceAddress,
        _MBSNGUInformationAt5GC_Multicast_gtpDLTEID,
        ____MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__id_tab,
        ___MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__id,
        ____MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__criticality_tab,
        ___MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__criticality,
        ____MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__extensionValue_tab,
        ___MBSNGUInformationAt5GC_Multicast_iE_Extensions__item__extensionValue,
        __MBSNGUInformationAt5GC_Multicast_iE_Extensions__item_,
        _MBSNGUInformationAt5GC_Multicast_iE_Extensions,
        MBSNGUInformationAt5GC_Multicast,
        MBSNGUInformationAt5GC_Multicast_ExtIEs,
        _MBSNGUInformationAtNGRAN_unicast,
        ___MBSNGUInformationAtNGRAN_choice_extension_id_tab,
        __MBSNGUInformationAtNGRAN_choice_extension_id,
        ___MBSNGUInformationAtNGRAN_choice_extension_criticality_tab,
        __MBSNGUInformationAtNGRAN_choice_extension_criticality,
        ___MBSNGUInformationAtNGRAN_choice_extension_value_tab,
        __MBSNGUInformationAtNGRAN_choice_extension_value,
        _MBSNGUInformationAtNGRAN_choice_extension,
        MBSNGUInformationAtNGRAN,
        MBSNGUInformationAtNGRAN_ExtIEs,
        _MBSSessionAssociatedInfoNonSupportToSupport_ue_Reference_ID,
        _MBSSessionAssociatedInfoNonSupportToSupport_pDU_Session_ID,
        _MBSSessionAssociatedInfoNonSupportToSupport_associatedQoSFlowInformationList,
        ____MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__id_tab,
        ___MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__id,
        ____MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__criticality_tab,
        ___MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__criticality,
        ____MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__extensionValue_tab,
        ___MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item__extensionValue,
        __MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions__item_,
        _MBSSessionAssociatedInfoNonSupportToSupport_iE_Extensions,
        MBSSessionAssociatedInfoNonSupportToSupport,
        MBSSessionAssociatedInfoNonSupportToSupport_ExtIEs,
        _MBSSessionAssociatedInformation_mbsSessionAssociatedInformationList,
        _MBSSessionAssociatedInformation_mbsSessionForwardingAddress,
        ____MBSSessionAssociatedInformation_iE_Extensions__item__id_tab,
        ___MBSSessionAssociatedInformation_iE_Extensions__item__id,
        ____MBSSessionAssociatedInformation_iE_Extensions__item__criticality_tab,
        ___MBSSessionAssociatedInformation_iE_Extensions__item__criticality,
        ____MBSSessionAssociatedInformation_iE_Extensions__item__extensionValue_tab,
        ___MBSSessionAssociatedInformation_iE_Extensions__item__extensionValue,
        __MBSSessionAssociatedInformation_iE_Extensions__item_,
        _MBSSessionAssociatedInformation_iE_Extensions,
        MBSSessionAssociatedInformation,
        MBSSessionAssociatedInformation_ExtIEs,
        _MBSSessionAssociatedInformationList__item_,
        MBSSessionAssociatedInformationList,
        _MBSSessionAssociatedInformation_Item_mbs_QoS_Flow_Identifier,
        _MBSSessionAssociatedInformation_Item_associated_unicast_QoS_Flow_Identifier,
        ____MBSSessionAssociatedInformation_Item_iE_Extensions__item__id_tab,
        ___MBSSessionAssociatedInformation_Item_iE_Extensions__item__id,
        ____MBSSessionAssociatedInformation_Item_iE_Extensions__item__criticality_tab,
        ___MBSSessionAssociatedInformation_Item_iE_Extensions__item__criticality,
        ____MBSSessionAssociatedInformation_Item_iE_Extensions__item__extensionValue_tab,
        ___MBSSessionAssociatedInformation_Item_iE_Extensions__item__extensionValue,
        __MBSSessionAssociatedInformation_Item_iE_Extensions__item_,
        _MBSSessionAssociatedInformation_Item_iE_Extensions,
        MBSSessionAssociatedInformation_Item,
        MBSSessionAssociatedInformation_Item_ExtIEs,
        _MBS_Support_Info_ToAdd_List__item_,
        MBS_Support_Info_ToAdd_List,
        _MBS_Support_Info_ToAdd_Item_globalMBSSessionID,
        ____MBS_Support_Info_ToAdd_Item_iE_Extensions__item__id_tab,
        ___MBS_Support_Info_ToAdd_Item_iE_Extensions__item__id,
        ____MBS_Support_Info_ToAdd_Item_iE_Extensions__item__criticality_tab,
        ___MBS_Support_Info_ToAdd_Item_iE_Extensions__item__criticality,
        ____MBS_Support_Info_ToAdd_Item_iE_Extensions__item__extensionValue_tab,
        ___MBS_Support_Info_ToAdd_Item_iE_Extensions__item__extensionValue,
        __MBS_Support_Info_ToAdd_Item_iE_Extensions__item_,
        _MBS_Support_Info_ToAdd_Item_iE_Extensions,
        MBS_Support_Info_ToAdd_Item,
        MBS_Support_Info_ToAdd_Item_ExtIEs,
        _MBS_Support_Info_ToRemove_List__item_,
        MBS_Support_Info_ToRemove_List,
        _MBS_Support_Info_ToRemove_Item_globalMBSSessionID,
        ____MBS_Support_Info_ToRemove_Item_iE_Extensions__item__id_tab,
        ___MBS_Support_Info_ToRemove_Item_iE_Extensions__item__id,
        ____MBS_Support_Info_ToRemove_Item_iE_Extensions__item__criticality_tab,
        ___MBS_Support_Info_ToRemove_Item_iE_Extensions__item__criticality,
        ____MBS_Support_Info_ToRemove_Item_iE_Extensions__item__extensionValue_tab,
        ___MBS_Support_Info_ToRemove_Item_iE_Extensions__item__extensionValue,
        __MBS_Support_Info_ToRemove_Item_iE_Extensions__item_,
        _MBS_Support_Info_ToRemove_Item_iE_Extensions,
        MBS_Support_Info_ToRemove_Item,
        MBS_Support_Info_ToRemove_Item_ExtIEs,
        _MCBearerContextToSetup_snssai,
        _MCBearerContextToSetup_mcMRBToSetupList,
        _MCBearerContextToSetup_requestedAction,
        ____MCBearerContextToSetup_iE_Extensions__item__id_tab,
        _____MCBearerContextToSetup_iE_Extensions__item__id_tab_val_Extension_0,
        ___MCBearerContextToSetup_iE_Extensions__item__id,
        ___MCBearerContextToSetup_iE_Extensions__item__criticality,
        ___MCBearerContextToSetup_iE_Extensions__item__extensionValue,
        __MCBearerContextToSetup_iE_Extensions__item_,
        _MCBearerContextToSetup_iE_Extensions,
        MCBearerContextToSetup,
        MCBearerContextToSetup_ExtIEs,
        _MCBearerContextToSetup_ExtIEs_val_Extension_0,
        _MCMRBSetupConfiguration__item_,
        MCMRBSetupConfiguration,
        _MCMRBSetupConfiguration_Item_mrb_ID,
        _MCMRBSetupConfiguration_Item_sdap_config,
        _MCMRBSetupConfiguration_Item_mbs_pdcp_config,
        _MCMRBSetupConfiguration_Item_qoS_Flow_QoS_Parameter_List,
        _MCMRBSetupConfiguration_Item_qoSFlowLevelQoSParameters,
        ____MCMRBSetupConfiguration_Item_iE_Extensions__item__id_tab,
        ___MCMRBSetupConfiguration_Item_iE_Extensions__item__id,
        ____MCMRBSetupConfiguration_Item_iE_Extensions__item__criticality_tab,
        ___MCMRBSetupConfiguration_Item_iE_Extensions__item__criticality,
        ____MCMRBSetupConfiguration_Item_iE_Extensions__item__extensionValue_tab,
        ___MCMRBSetupConfiguration_Item_iE_Extensions__item__extensionValue,
        __MCMRBSetupConfiguration_Item_iE_Extensions__item_,
        _MCMRBSetupConfiguration_Item_iE_Extensions,
        MCMRBSetupConfiguration_Item,
        MCMRBSetupConfiguration_Item_ExtIEs,
        _MCBearerContextToSetupResponse_mcBearerContextNGU_TNLInfoatNGRAN,
        _MCBearerContextToSetupResponse_mcMRBSetupResponseList,
        _MCBearerContextToSetupResponse_mcMRBFailedList,
        _MCBearerContextToSetupResponse_availableMCMRBConfig,
        ____MCBearerContextToSetupResponse_iE_Extensions__item__id_tab,
        ___MCBearerContextToSetupResponse_iE_Extensions__item__id,
        ____MCBearerContextToSetupResponse_iE_Extensions__item__criticality_tab,
        ___MCBearerContextToSetupResponse_iE_Extensions__item__criticality,
        ____MCBearerContextToSetupResponse_iE_Extensions__item__extensionValue_tab,
        ___MCBearerContextToSetupResponse_iE_Extensions__item__extensionValue,
        __MCBearerContextToSetupResponse_iE_Extensions__item_,
        _MCBearerContextToSetupResponse_iE_Extensions,
        MCBearerContextToSetupResponse,
        MCBearerContextToSetupResponse_ExtIEs,
        _MCBearerContextNGU_TNLInfoatNGRAN_locationindependent,
        _MCBearerContextNGU_TNLInfoatNGRAN_locationdependent,
        ___MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_id_tab,
        __MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_id,
        ___MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_criticality_tab,
        __MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_criticality,
        ___MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_value_tab,
        __MCBearerContextNGU_TNLInfoatNGRAN_choice_extension_value,
        _MCBearerContextNGU_TNLInfoatNGRAN_choice_extension,
        MCBearerContextNGU_TNLInfoatNGRAN,
        MCBearerContextNGU_TNLInfoatNGRAN_ExtIEs,
        _MCMRBSetupResponseList__item_,
        MCMRBSetupResponseList,
        _MCMRBSetupResponseList_Item_mrb_ID,
        _MCMRBSetupResponseList_Item_qosflow_setup,
        _MCMRBSetupResponseList_Item_qosflow_failed,
        _MCMRBSetupResponseList_Item_mBS_PDCP_COUNT,
        ____MCMRBSetupResponseList_Item_iE_Extensions__item__id_tab,
        ___MCMRBSetupResponseList_Item_iE_Extensions__item__id,
        ____MCMRBSetupResponseList_Item_iE_Extensions__item__criticality_tab,
        ___MCMRBSetupResponseList_Item_iE_Extensions__item__criticality,
        ____MCMRBSetupResponseList_Item_iE_Extensions__item__extensionValue_tab,
        ___MCMRBSetupResponseList_Item_iE_Extensions__item__extensionValue,
        __MCMRBSetupResponseList_Item_iE_Extensions__item_,
        _MCMRBSetupResponseList_Item_iE_Extensions,
        MCMRBSetupResponseList_Item,
        MCMRBSetupResponseList_Item_ExtIEs,
        MBS_PDCP_COUNT,
        _MCMRBFailedList__item_,
        MCMRBFailedList,
        _MCMRBFailedList_Item_mrb_ID,
        _MCMRBFailedList_Item_cause,
        ____MCMRBFailedList_Item_iE_Extensions__item__id_tab,
        ___MCMRBFailedList_Item_iE_Extensions__item__id,
        ____MCMRBFailedList_Item_iE_Extensions__item__criticality_tab,
        ___MCMRBFailedList_Item_iE_Extensions__item__criticality,
        ____MCMRBFailedList_Item_iE_Extensions__item__extensionValue_tab,
        ___MCMRBFailedList_Item_iE_Extensions__item__extensionValue,
        __MCMRBFailedList_Item_iE_Extensions__item_,
        _MCMRBFailedList_Item_iE_Extensions,
        MCMRBFailedList_Item,
        MCMRBFailedList_Item_ExtIEs,
        _MCBearerContextToModify_mcBearerContextNGUTNLInfoat5GC,
        _MCBearerContextToModify_mcBearerContextNGUTnlInfoatNGRANRequest,
        _MCBearerContextToModify_mbsMulticastF1UContextDescriptor,
        _MCBearerContextToModify_requestedAction,
        _MCBearerContextToModify_mcMRBToSetupModifyList,
        _MCBearerContextToModify_mcMRBToRemoveList,
        ____MCBearerContextToModify_iE_Extensions__item__id_tab,
        _____MCBearerContextToModify_iE_Extensions__item__id_tab_val_Extension_0,
        _____MCBearerContextToModify_iE_Extensions__item__id_tab_val_Extension_1,
        _____MCBearerContextToModify_iE_Extensions__item__id_tab_val_Extension_2,
        _____MCBearerContextToModify_iE_Extensions__item__id_tab_val_Extension_3,
        ___MCBearerContextToModify_iE_Extensions__item__id,
        ___MCBearerContextToModify_iE_Extensions__item__criticality,
        ___MCBearerContextToModify_iE_Extensions__item__extensionValue,
        __MCBearerContextToModify_iE_Extensions__item_,
        _MCBearerContextToModify_iE_Extensions,
        MCBearerContextToModify,
        MCBearerContextToModify_ExtIEs,
        _MCBearerContextToModify_ExtIEs_val_Extension_0,
        _MCBearerContextToModify_ExtIEs_val_Extension_1,
        _MCBearerContextToModify_ExtIEs_val_Extension_2,
        _MCBearerContextToModify_ExtIEs_val_Extension_3,
        _MCBearerContextNGUTNLInfoat5GC_mbsNGUInformationAt5GC,
        _MCBearerContextNGUTNLInfoat5GC_mbsAreaSession_ID,
        ____MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__id_tab,
        ___MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__id,
        ____MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__criticality_tab,
        ___MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__criticality,
        ____MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__extensionValue_tab,
        ___MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item__extensionValue,
        __MCBearerContextNGUTNLInfoat5GC_iE_Extensions__item_,
        _MCBearerContextNGUTNLInfoat5GC_iE_Extensions,
        MCBearerContextNGUTNLInfoat5GC,
        MCBearerContextNGUTNLInfoat5GC_ExtIEs,
        _MCBearerContextNGUTnlInfoatNGRANRequest_ngRANNGUTNLRequested,
        _MCBearerContextNGUTnlInfoatNGRANRequest_mbsAreaSession_ID,
        ____MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__id_tab,
        ___MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__id,
        ____MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__criticality_tab,
        ___MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__criticality,
        ____MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__extensionValue_tab,
        ___MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item__extensionValue,
        __MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions__item_,
        _MCBearerContextNGUTnlInfoatNGRANRequest_iE_Extensions,
        MCBearerContextNGUTnlInfoatNGRANRequest,
        MCBearerContextNGUTnlInfoatNGRANRequest_ExtIEs,
        _MCMRBSetupModifyConfiguration__item_,
        MCMRBSetupModifyConfiguration,
        _MCMRBSetupModifyConfiguration_Item_mrb_ID,
        _MCMRBSetupModifyConfiguration_Item_f1uTNLatDU,
        _MCMRBSetupModifyConfiguration_Item_sdap_config,
        _MCMRBSetupModifyConfiguration_Item_mbs_pdcp_config,
        _MCMRBSetupModifyConfiguration_Item_qoS_Flow_QoS_Parameter_List,
        _MCMRBSetupModifyConfiguration_Item_mrbQoS,
        _MCMRBSetupModifyConfiguration_Item_mbs_PDCP_COUNT_Req,
        ____MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__id_tab,
        ___MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__id,
        ____MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__criticality_tab,
        ___MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__criticality,
        ____MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__extensionValue_tab,
        ___MCMRBSetupModifyConfiguration_Item_iE_Extensions__item__extensionValue,
        __MCMRBSetupModifyConfiguration_Item_iE_Extensions__item_,
        _MCMRBSetupModifyConfiguration_Item_iE_Extensions,
        MCMRBSetupModifyConfiguration_Item,
        MCMRBSetupModifyConfiguration_Item_ExtIEs,
        _MCBearerContextF1UTNLInfoatDU_mbsF1UInfoatDU,
        _MCBearerContextF1UTNLInfoatDU_mbsMulticastF1UContextDescriptor,
        ____MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__id_tab,
        ___MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__id,
        ____MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__criticality_tab,
        ___MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__criticality,
        ____MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__extensionValue_tab,
        ___MCBearerContextF1UTNLInfoatDU_iE_Extensions__item__extensionValue,
        __MCBearerContextF1UTNLInfoatDU_iE_Extensions__item_,
        _MCBearerContextF1UTNLInfoatDU_iE_Extensions,
        MCBearerContextF1UTNLInfoatDU,
        MCBearerContextF1UTNLInfoatDU_ExtIEs,
        MulticastF1UContextReferenceE1,
        _MBSMulticastF1UContextDescriptor_multicastF1UContextReferenceE1,
        _MBSMulticastF1UContextDescriptor_mc_F1UCtxtusage,
        _MBSMulticastF1UContextDescriptor_mbsAreaSession,
        ____MBSMulticastF1UContextDescriptor_iE_Extensions__item__id_tab,
        ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__id,
        ____MBSMulticastF1UContextDescriptor_iE_Extensions__item__criticality_tab,
        ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__criticality,
        ____MBSMulticastF1UContextDescriptor_iE_Extensions__item__extensionValue_tab,
        ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__extensionValue,
        __MBSMulticastF1UContextDescriptor_iE_Extensions__item_,
        _MBSMulticastF1UContextDescriptor_iE_Extensions,
        MBSMulticastF1UContextDescriptor,
        MBSMulticastF1UContextDescriptor_ExtIEs,
        _MCMRBRemoveConfiguration__item_,
        MCMRBRemoveConfiguration,
        MBS_PDCP_COUNT_Req,
        _MCBearerContextToModifyResponse_mcBearerContextNGU_TNLInfoatNGRANModifyResponse,
        _MCBearerContextToModifyResponse_mbsMulticastF1UContextDescriptor,
        _MCBearerContextToModifyResponse_mcMRBModifySetupResponseList,
        _MCBearerContextToModifyResponse_mcMRBFailedList,
        _MCBearerContextToModifyResponse_availableMCMRBConfig,
        ____MCBearerContextToModifyResponse_iE_Extensions__item__id_tab,
        _____MCBearerContextToModifyResponse_iE_Extensions__item__id_tab_val_Extension_0,
        ___MCBearerContextToModifyResponse_iE_Extensions__item__id,
        ___MCBearerContextToModifyResponse_iE_Extensions__item__criticality,
        ___MCBearerContextToModifyResponse_iE_Extensions__item__extensionValue,
        __MCBearerContextToModifyResponse_iE_Extensions__item_,
        _MCBearerContextToModifyResponse_iE_Extensions,
        MCBearerContextToModifyResponse,
        MCBearerContextToModifyResponse_ExtIEs,
        _MCBearerContextToModifyResponse_ExtIEs_val_Extension_0,
        _MCBearerContextNGU_TNLInfoatNGRANModifyResponse_mbs_NGU_InfoatNGRAN,
        _MCBearerContextNGU_TNLInfoatNGRANModifyResponse_mbsAreaSession,
        ____MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__id_tab,
        ___MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__id,
        ____MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__criticality_tab,
        ___MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__criticality,
        ____MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__extensionValue_tab,
        ___MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item__extensionValue,
        __MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions__item_,
        _MCBearerContextNGU_TNLInfoatNGRANModifyResponse_iE_Extensions,
        MCBearerContextNGU_TNLInfoatNGRANModifyResponse,
        MCBearerContextNGU_TNLInfoatNGRANModifyResponse_ExtIEs,
        _MCMRBSetupModifyResponseList__item_,
        MCMRBSetupModifyResponseList,
        _MCMRBSetupModifyResponseList_Item_mrb_ID,
        _MCMRBSetupModifyResponseList_Item_qosflow_setup,
        _MCMRBSetupModifyResponseList_Item_qosflow_failed,
        _MCMRBSetupModifyResponseList_Item_mcBearerContextF1UTNLInfoatCU,
        _MCMRBSetupModifyResponseList_Item_mBS_PDCP_COUNT,
        ____MCMRBSetupModifyResponseList_Item_iE_Extensions__item__id_tab,
        ___MCMRBSetupModifyResponseList_Item_iE_Extensions__item__id,
        ____MCMRBSetupModifyResponseList_Item_iE_Extensions__item__criticality_tab,
        ___MCMRBSetupModifyResponseList_Item_iE_Extensions__item__criticality,
        ____MCMRBSetupModifyResponseList_Item_iE_Extensions__item__extensionValue_tab,
        ___MCMRBSetupModifyResponseList_Item_iE_Extensions__item__extensionValue,
        __MCMRBSetupModifyResponseList_Item_iE_Extensions__item_,
        _MCMRBSetupModifyResponseList_Item_iE_Extensions,
        MCMRBSetupModifyResponseList_Item,
        MCMRBSetupModifyResponseList_Item_ExtIEs,
        _MCBearerContextToModifyRequired_mbsMulticastF1UContextDescriptor,
        _MCBearerContextToModifyRequired_mcMRBToRemoveRequiredList,
        _MCBearerContextToModifyRequired_mcMRBToModifyRequiredList,
        ____MCBearerContextToModifyRequired_iE_Extensions__item__id_tab,
        _____MCBearerContextToModifyRequired_iE_Extensions__item__id_tab_val_Extension_0,
        ___MCBearerContextToModifyRequired_iE_Extensions__item__id,
        ___MCBearerContextToModifyRequired_iE_Extensions__item__criticality,
        ___MCBearerContextToModifyRequired_iE_Extensions__item__extensionValue,
        __MCBearerContextToModifyRequired_iE_Extensions__item_,
        _MCBearerContextToModifyRequired_iE_Extensions,
        MCBearerContextToModifyRequired,
        MCBearerContextToModifyRequired_ExtIEs,
        _MCBearerContextToModifyRequired_ExtIEs_val_Extension_0,
        _MCMRBModifyRequiredConfiguration__item_,
        MCMRBModifyRequiredConfiguration,
        _MCMRBModifyRequiredConfiguration_Item_mrb_ID,
        _MCMRBModifyRequiredConfiguration_Item_mBS_PDCP_COUNT,
        ____MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__id_tab,
        ___MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__id,
        ____MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__criticality_tab,
        ___MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__criticality,
        ____MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__extensionValue_tab,
        ___MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item__extensionValue,
        __MCMRBModifyRequiredConfiguration_Item_iE_Extensions__item_,
        _MCMRBModifyRequiredConfiguration_Item_iE_Extensions,
        MCMRBModifyRequiredConfiguration_Item,
        MCMRBModifyRequiredConfiguration_Item_ExtIEs,
        _MCBearerContextToModifyConfirm_mbsMulticastF1UContextDescriptor,
        _MCBearerContextToModifyConfirm_mcMRBModifyConfirmList,
        ____MCBearerContextToModifyConfirm_iE_Extensions__item__id_tab,
        ___MCBearerContextToModifyConfirm_iE_Extensions__item__id,
        ____MCBearerContextToModifyConfirm_iE_Extensions__item__criticality_tab,
        ___MCBearerContextToModifyConfirm_iE_Extensions__item__criticality,
        ____MCBearerContextToModifyConfirm_iE_Extensions__item__extensionValue_tab,
        ___MCBearerContextToModifyConfirm_iE_Extensions__item__extensionValue,
        __MCBearerContextToModifyConfirm_iE_Extensions__item_,
        _MCBearerContextToModifyConfirm_iE_Extensions,
        MCBearerContextToModifyConfirm,
        _MCMRBModifyConfirmList__item_,
        MCMRBModifyConfirmList,
        _MCMRBModifyConfirmList_Item_mrb_ID,
        ____MCMRBModifyConfirmList_Item_iE_Extensions__item__id_tab,
        ___MCMRBModifyConfirmList_Item_iE_Extensions__item__id,
        ____MCMRBModifyConfirmList_Item_iE_Extensions__item__criticality_tab,
        ___MCMRBModifyConfirmList_Item_iE_Extensions__item__criticality,
        ____MCMRBModifyConfirmList_Item_iE_Extensions__item__extensionValue_tab,
        ___MCMRBModifyConfirmList_Item_iE_Extensions__item__extensionValue,
        __MCMRBModifyConfirmList_Item_iE_Extensions__item_,
        _MCMRBModifyConfirmList_Item_iE_Extensions,
        MCMRBModifyConfirmList_Item,
        MCMRBModifyConfirmList_Item_ExtIEs,
        MCBearerContextToModifyConfirm_ExtIEs,
        _MCForwardingResourceRequest_mcForwardingResourceID,
        _MCForwardingResourceRequest_mbsAreaSession_ID,
        _MCForwardingResourceRequest_mrbForwardingResourceRequestList,
        ____MCForwardingResourceRequest_iE_Extensions__item__id_tab,
        ___MCForwardingResourceRequest_iE_Extensions__item__id,
        ____MCForwardingResourceRequest_iE_Extensions__item__criticality_tab,
        ___MCForwardingResourceRequest_iE_Extensions__item__criticality,
        ____MCForwardingResourceRequest_iE_Extensions__item__extensionValue_tab,
        ___MCForwardingResourceRequest_iE_Extensions__item__extensionValue,
        __MCForwardingResourceRequest_iE_Extensions__item_,
        _MCForwardingResourceRequest_iE_Extensions,
        MCForwardingResourceRequest,
        MCForwardingResourceRequest_ExtIEs,
        _MRBForwardingResourceRequestList__item_,
        MRBForwardingResourceRequestList,
        _MRBForwardingResourceRequest_Item_mrb_ID,
        _MRBForwardingResourceRequest_Item_mrbProgressRequestType,
        _MRBForwardingResourceRequest_Item_mrbForwardingAddressRequest,
        ____MRBForwardingResourceRequest_Item_iE_Extensions__item__id_tab,
        ___MRBForwardingResourceRequest_Item_iE_Extensions__item__id,
        ____MRBForwardingResourceRequest_Item_iE_Extensions__item__criticality_tab,
        ___MRBForwardingResourceRequest_Item_iE_Extensions__item__criticality,
        ____MRBForwardingResourceRequest_Item_iE_Extensions__item__extensionValue_tab,
        ___MRBForwardingResourceRequest_Item_iE_Extensions__item__extensionValue,
        __MRBForwardingResourceRequest_Item_iE_Extensions__item_,
        _MRBForwardingResourceRequest_Item_iE_Extensions,
        MRBForwardingResourceRequest_Item,
        MRBForwardingResourceRequest_Item_ExtIEs,
        _MCForwardingResourceIndication_mcForwardingResourceID,
        _MCForwardingResourceIndication_mrbForwardingResourceIndicationList,
        _MCForwardingResourceIndication_mbsSessionAssociatedInformation,
        ____MCForwardingResourceIndication_iE_Extensions__item__id_tab,
        ___MCForwardingResourceIndication_iE_Extensions__item__id,
        ____MCForwardingResourceIndication_iE_Extensions__item__criticality_tab,
        ___MCForwardingResourceIndication_iE_Extensions__item__criticality,
        ____MCForwardingResourceIndication_iE_Extensions__item__extensionValue_tab,
        ___MCForwardingResourceIndication_iE_Extensions__item__extensionValue,
        __MCForwardingResourceIndication_iE_Extensions__item_,
        _MCForwardingResourceIndication_iE_Extensions,
        MCForwardingResourceIndication,
        MCForwardingResourceIndication_ExtIEs,
        _MRBForwardingResourceIndicationList__item_,
        MRBForwardingResourceIndicationList,
        _MRBForwardingResourceIndication_Item_mrb_ID,
        _MRBForwardingResourceIndication_Item_mrb_ProgressInformation,
        _MRBForwardingResourceIndication_Item_mrbForwardingAddress,
        ____MRBForwardingResourceIndication_Item_iE_Extensions__item__id_tab,
        ___MRBForwardingResourceIndication_Item_iE_Extensions__item__id,
        ____MRBForwardingResourceIndication_Item_iE_Extensions__item__criticality_tab,
        ___MRBForwardingResourceIndication_Item_iE_Extensions__item__criticality,
        ____MRBForwardingResourceIndication_Item_iE_Extensions__item__extensionValue_tab,
        ___MRBForwardingResourceIndication_Item_iE_Extensions__item__extensionValue,
        __MRBForwardingResourceIndication_Item_iE_Extensions__item_,
        _MRBForwardingResourceIndication_Item_iE_Extensions,
        MRBForwardingResourceIndication_Item,
        MRBForwardingResourceIndication_Item_ExtIEs,
        _MCForwardingResourceResponse_mcForwardingResourceID,
        _MCForwardingResourceResponse_mrbForwardingResourceResponseList,
        ____MCForwardingResourceResponse_iE_Extensions__item__id_tab,
        ___MCForwardingResourceResponse_iE_Extensions__item__id,
        ____MCForwardingResourceResponse_iE_Extensions__item__criticality_tab,
        ___MCForwardingResourceResponse_iE_Extensions__item__criticality,
        ____MCForwardingResourceResponse_iE_Extensions__item__extensionValue_tab,
        ___MCForwardingResourceResponse_iE_Extensions__item__extensionValue,
        __MCForwardingResourceResponse_iE_Extensions__item_,
        _MCForwardingResourceResponse_iE_Extensions,
        MCForwardingResourceResponse,
        MCForwardingResourceResponse_ExtIEs,
        _MRBForwardingResourceResponseList__item_,
        MRBForwardingResourceResponseList,
        _MRBForwardingResourceResponse_Item_mrb_ID,
        _MRBForwardingResourceResponse_Item_mrb_ProgressInformation,
        _MRBForwardingResourceResponse_Item_mrbForwardingAddress,
        ____MRBForwardingResourceResponse_Item_iE_Extensions__item__id_tab,
        ___MRBForwardingResourceResponse_Item_iE_Extensions__item__id,
        ____MRBForwardingResourceResponse_Item_iE_Extensions__item__criticality_tab,
        ___MRBForwardingResourceResponse_Item_iE_Extensions__item__criticality,
        ____MRBForwardingResourceResponse_Item_iE_Extensions__item__extensionValue_tab,
        ___MRBForwardingResourceResponse_Item_iE_Extensions__item__extensionValue,
        __MRBForwardingResourceResponse_Item_iE_Extensions__item_,
        _MRBForwardingResourceResponse_Item_iE_Extensions,
        MRBForwardingResourceResponse_Item,
        MRBForwardingResourceResponse_Item_ExtIEs,
        _MCForwardingResourceRelease_mcForwardingResourceID,
        ____MCForwardingResourceRelease_iE_Extensions__item__id_tab,
        ___MCForwardingResourceRelease_iE_Extensions__item__id,
        ____MCForwardingResourceRelease_iE_Extensions__item__criticality_tab,
        ___MCForwardingResourceRelease_iE_Extensions__item__criticality,
        ____MCForwardingResourceRelease_iE_Extensions__item__extensionValue_tab,
        ___MCForwardingResourceRelease_iE_Extensions__item__extensionValue,
        __MCForwardingResourceRelease_iE_Extensions__item_,
        _MCForwardingResourceRelease_iE_Extensions,
        MCForwardingResourceRelease,
        MCForwardingResourceRelease_ExtIEs,
        _MCForwardingResourceReleaseIndication_mcForwardingResourceID,
        ____MCForwardingResourceReleaseIndication_iE_Extensions__item__id_tab,
        ___MCForwardingResourceReleaseIndication_iE_Extensions__item__id,
        ____MCForwardingResourceReleaseIndication_iE_Extensions__item__criticality_tab,
        ___MCForwardingResourceReleaseIndication_iE_Extensions__item__criticality,
        ____MCForwardingResourceReleaseIndication_iE_Extensions__item__extensionValue_tab,
        ___MCForwardingResourceReleaseIndication_iE_Extensions__item__extensionValue,
        __MCForwardingResourceReleaseIndication_iE_Extensions__item_,
        _MCForwardingResourceReleaseIndication_iE_Extensions,
        MCForwardingResourceReleaseIndication,
        MCForwardingResourceReleaseIndication_ExtIEs,
        MCForwardingResourceID,
        MDTPollutedMeasurementIndicator,
        MRB_ID,
        _MRB_ProgressInformation_mrb_ProgressInformationSNs,
        _MRB_ProgressInformation_mrb_ProgressInformationType,
        ____MRB_ProgressInformation_iE_Extensions__item__id_tab,
        ___MRB_ProgressInformation_iE_Extensions__item__id,
        ____MRB_ProgressInformation_iE_Extensions__item__criticality_tab,
        ___MRB_ProgressInformation_iE_Extensions__item__criticality,
        ____MRB_ProgressInformation_iE_Extensions__item__extensionValue_tab,
        ___MRB_ProgressInformation_iE_Extensions__item__extensionValue,
        __MRB_ProgressInformation_iE_Extensions__item_,
        _MRB_ProgressInformation_iE_Extensions,
        MRB_ProgressInformation,
        MRB_ProgressInformation_ExtIEs,
        _MRB_ProgressInformationSNs_pdcp_SN12,
        _MRB_ProgressInformationSNs_pdcp_SN18,
        ___MRB_ProgressInformationSNs_choice_extension_id_tab,
        __MRB_ProgressInformationSNs_choice_extension_id,
        ___MRB_ProgressInformationSNs_choice_extension_criticality_tab,
        __MRB_ProgressInformationSNs_choice_extension_criticality,
        ___MRB_ProgressInformationSNs_choice_extension_value_tab,
        __MRB_ProgressInformationSNs_choice_extension_value,
        _MRB_ProgressInformationSNs_choice_extension,
        MRB_ProgressInformationSNs,
        MRB_ProgressInformationSNs_ExtIEs,
        MRB_ProgressInformationType,
        _MRDC_Data_Usage_Report_Item_startTimeStamp,
        _MRDC_Data_Usage_Report_Item_endTimeStamp,
        _MRDC_Data_Usage_Report_Item_usageCountUL,
        _MRDC_Data_Usage_Report_Item_usageCountDL,
        ____MRDC_Data_Usage_Report_Item_iE_Extensions__item__id_tab,
        ___MRDC_Data_Usage_Report_Item_iE_Extensions__item__id,
        ____MRDC_Data_Usage_Report_Item_iE_Extensions__item__criticality_tab,
        ___MRDC_Data_Usage_Report_Item_iE_Extensions__item__criticality,
        ____MRDC_Data_Usage_Report_Item_iE_Extensions__item__extensionValue_tab,
        ___MRDC_Data_Usage_Report_Item_iE_Extensions__item__extensionValue,
        __MRDC_Data_Usage_Report_Item_iE_Extensions__item_,
        _MRDC_Data_Usage_Report_Item_iE_Extensions,
        MRDC_Data_Usage_Report_Item,
        MRDC_Data_Usage_Report_Item_ExtIEs,
        _MRDC_Usage_Information_data_Usage_per_PDU_Session_Report,
        _MRDC_Usage_Information_data_Usage_per_QoS_Flow_List,
        ____MRDC_Usage_Information_iE_Extensions__item__id_tab,
        ___MRDC_Usage_Information_iE_Extensions__item__id,
        ____MRDC_Usage_Information_iE_Extensions__item__criticality_tab,
        ___MRDC_Usage_Information_iE_Extensions__item__criticality,
        ____MRDC_Usage_Information_iE_Extensions__item__extensionValue_tab,
        ___MRDC_Usage_Information_iE_Extensions__item__extensionValue,
        __MRDC_Usage_Information_iE_Extensions__item_,
        _MRDC_Usage_Information_iE_Extensions,
        MRDC_Usage_Information,
        MRDC_Usage_Information_ExtIEs,
        _M4Configuration_m4period,
        _M4Configuration_m4_links_to_log,
        ____M4Configuration_iE_Extensions__item__id_tab,
        _____M4Configuration_iE_Extensions__item__id_tab_val_Extension_0,
        ___M4Configuration_iE_Extensions__item__id,
        ___M4Configuration_iE_Extensions__item__criticality,
        ___M4Configuration_iE_Extensions__item__extensionValue,
        __M4Configuration_iE_Extensions__item_,
        _M4Configuration_iE_Extensions,
        M4Configuration,
        M4Configuration_ExtIEs,
        _M4Configuration_ExtIEs_val_Extension_0,
        M4period,
        M4ReportAmount,
        _M6Configuration_m6report_Interval,
        _M6Configuration_m6_links_to_log,
        ____M6Configuration_iE_Extensions__item__id_tab,
        _____M6Configuration_iE_Extensions__item__id_tab_val_Extension_0,
        ___M6Configuration_iE_Extensions__item__id,
        ___M6Configuration_iE_Extensions__item__criticality,
        ___M6Configuration_iE_Extensions__item__extensionValue,
        __M6Configuration_iE_Extensions__item_,
        _M6Configuration_iE_Extensions,
        M6Configuration,
        M6Configuration_ExtIEs,
        _M6Configuration_ExtIEs_val_Extension_0,
        M6ReportAmount,
        M6report_Interval,
        _M7Configuration_m7period,
        _M7Configuration_m7_links_to_log,
        ____M7Configuration_iE_Extensions__item__id_tab,
        _____M7Configuration_iE_Extensions__item__id_tab_val_Extension_0,
        ___M7Configuration_iE_Extensions__item__id,
        ___M7Configuration_iE_Extensions__item__criticality,
        ___M7Configuration_iE_Extensions__item__extensionValue,
        __M7Configuration_iE_Extensions__item_,
        _M7Configuration_iE_Extensions,
        M7Configuration,
        M7Configuration_ExtIEs,
        _M7Configuration_ExtIEs_val_Extension_0,
        M7period,
        M7ReportAmount,
        MDT_Activation,
        _MDT_Configuration_mdt_Activation,
        _MDT_Configuration_mDTMode,
        ____MDT_Configuration_iE_Extensions__item__id_tab,
        ___MDT_Configuration_iE_Extensions__item__id,
        ____MDT_Configuration_iE_Extensions__item__criticality_tab,
        ___MDT_Configuration_iE_Extensions__item__criticality,
        ____MDT_Configuration_iE_Extensions__item__extensionValue_tab,
        ___MDT_Configuration_iE_Extensions__item__extensionValue,
        __MDT_Configuration_iE_Extensions__item_,
        _MDT_Configuration_iE_Extensions,
        MDT_Configuration,
        MDT_Configuration_ExtIEs,
        _MDTMode_immediateMDT,
        ___MDTMode_choice_extension_id_tab,
        __MDTMode_choice_extension_id,
        ___MDTMode_choice_extension_criticality_tab,
        __MDTMode_choice_extension_criticality,
        ___MDTMode_choice_extension_value_tab,
        __MDTMode_choice_extension_value,
        _MDTMode_choice_extension,
        MDTMode,
        MDTMode_ExtIEs,
        MeasurementsToActivate,
        _MDTPLMNList__item_,
        MDTPLMNList,
        _MDTPLMNModificationList__item_,
        MDTPLMNModificationList,
        NetworkInstance,
        New_UL_TNL_Information_Required,
        _NGRANAllocationAndRetentionPriority_priorityLevel,
        _NGRANAllocationAndRetentionPriority_pre_emptionCapability,
        _NGRANAllocationAndRetentionPriority_pre_emptionVulnerability,
        ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__id_tab,
        ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__id,
        ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality_tab,
        ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality,
        ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab,
        ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue,
        __NGRANAllocationAndRetentionPriority_iE_Extensions__item_,
        _NGRANAllocationAndRetentionPriority_iE_Extensions,
        NGRANAllocationAndRetentionPriority,
        NGRANAllocationAndRetentionPriority_ExtIEs,
        _NG_RAN_QoS_Support_List__item_,
        NG_RAN_QoS_Support_List,
        _NG_RAN_QoS_Support_Item_non_Dynamic5QIDescriptor,
        ____NG_RAN_QoS_Support_Item_iE_Extensions__item__id_tab,
        ___NG_RAN_QoS_Support_Item_iE_Extensions__item__id,
        ____NG_RAN_QoS_Support_Item_iE_Extensions__item__criticality_tab,
        ___NG_RAN_QoS_Support_Item_iE_Extensions__item__criticality,
        ____NG_RAN_QoS_Support_Item_iE_Extensions__item__extensionValue_tab,
        ___NG_RAN_QoS_Support_Item_iE_Extensions__item__extensionValue,
        __NG_RAN_QoS_Support_Item_iE_Extensions__item_,
        _NG_RAN_QoS_Support_Item_iE_Extensions,
        NG_RAN_QoS_Support_Item,
        NG_RAN_QoS_Support_Item_ExtIEs,
        NID,
        _Non_Dynamic5QIDescriptor_fiveQI,
        _Non_Dynamic5QIDescriptor_qoSPriorityLevel,
        _Non_Dynamic5QIDescriptor_averagingWindow,
        _Non_Dynamic5QIDescriptor_maxDataBurstVolume,
        ____Non_Dynamic5QIDescriptor_iE_Extensions__item__id_tab,
        _____Non_Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0,
        _____Non_Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1,
        ___Non_Dynamic5QIDescriptor_iE_Extensions__item__id,
        ___Non_Dynamic5QIDescriptor_iE_Extensions__item__criticality,
        ___Non_Dynamic5QIDescriptor_iE_Extensions__item__extensionValue,
        __Non_Dynamic5QIDescriptor_iE_Extensions__item_,
        _Non_Dynamic5QIDescriptor_iE_Extensions,
        Non_Dynamic5QIDescriptor,
        Non_Dynamic5QIDescriptor_ExtIEs,
        _Non_Dynamic5QIDescriptor_ExtIEs_val_Extension_0,
        _Non_Dynamic5QIDescriptor_ExtIEs_val_Extension_1,
        _NPNSupportInfo_sNPN,
        ___NPNSupportInfo_choice_extension_id_tab,
        __NPNSupportInfo_choice_extension_id,
        ___NPNSupportInfo_choice_extension_criticality_tab,
        __NPNSupportInfo_choice_extension_criticality,
        ___NPNSupportInfo_choice_extension_value_tab,
        __NPNSupportInfo_choice_extension_value,
        _NPNSupportInfo_choice_extension,
        NPNSupportInfo,
        NPNSupportInfo_ExtIEs,
        _NPNSupportInfo_SNPN_nID,
        ____NPNSupportInfo_SNPN_iE_Extensions__item__id_tab,
        ___NPNSupportInfo_SNPN_iE_Extensions__item__id,
        ____NPNSupportInfo_SNPN_iE_Extensions__item__criticality_tab,
        ___NPNSupportInfo_SNPN_iE_Extensions__item__criticality,
        ____NPNSupportInfo_SNPN_iE_Extensions__item__extensionValue_tab,
        ___NPNSupportInfo_SNPN_iE_Extensions__item__extensionValue,
        __NPNSupportInfo_SNPN_iE_Extensions__item_,
        _NPNSupportInfo_SNPN_iE_Extensions,
        NPNSupportInfo_SNPN,
        NPNSupportInfo_SNPN_ExtIEs,
        _NPNContextInfo_sNPN,
        ___NPNContextInfo_choice_extension_id_tab,
        __NPNContextInfo_choice_extension_id,
        ___NPNContextInfo_choice_extension_criticality_tab,
        __NPNContextInfo_choice_extension_criticality,
        ___NPNContextInfo_choice_extension_value_tab,
        __NPNContextInfo_choice_extension_value,
        _NPNContextInfo_choice_extension,
        NPNContextInfo,
        NPNContextInfo_ExtIEs,
        _NPNContextInfo_SNPN_nID,
        ____NPNContextInfo_SNPN_iE_Extensions__item__id_tab,
        ___NPNContextInfo_SNPN_iE_Extensions__item__id,
        ____NPNContextInfo_SNPN_iE_Extensions__item__criticality_tab,
        ___NPNContextInfo_SNPN_iE_Extensions__item__criticality,
        ____NPNContextInfo_SNPN_iE_Extensions__item__extensionValue_tab,
        ___NPNContextInfo_SNPN_iE_Extensions__item__extensionValue,
        __NPNContextInfo_SNPN_iE_Extensions__item_,
        _NPNContextInfo_SNPN_iE_Extensions,
        NPNContextInfo_SNPN,
        NPNContextInfo_SNPN_ExtIEs,
        NR_Cell_Identity,
        _NR_CGI_pLMN_Identity,
        _NR_CGI_nR_Cell_Identity,
        ____NR_CGI_iE_Extensions__item__id_tab,
        ___NR_CGI_iE_Extensions__item__id,
        ____NR_CGI_iE_Extensions__item__criticality_tab,
        ___NR_CGI_iE_Extensions__item__criticality,
        ____NR_CGI_iE_Extensions__item__extensionValue_tab,
        ___NR_CGI_iE_Extensions__item__extensionValue,
        __NR_CGI_iE_Extensions__item_,
        _NR_CGI_iE_Extensions,
        NR_CGI,
        NR_CGI_ExtIEs,
        _NR_CGI_Support_List__item_,
        NR_CGI_Support_List,
        _NR_CGI_Support_Item_nR_CGI,
        ____NR_CGI_Support_Item_iE_Extensions__item__id_tab,
        ___NR_CGI_Support_Item_iE_Extensions__item__id,
        ____NR_CGI_Support_Item_iE_Extensions__item__criticality_tab,
        ___NR_CGI_Support_Item_iE_Extensions__item__criticality,
        ____NR_CGI_Support_Item_iE_Extensions__item__extensionValue_tab,
        ___NR_CGI_Support_Item_iE_Extensions__item__extensionValue,
        __NR_CGI_Support_Item_iE_Extensions__item_,
        _NR_CGI_Support_Item_iE_Extensions,
        NR_CGI_Support_Item,
        NR_CGI_Support_Item_ExtIEs,
        _Extended_NR_CGI_Support_List__item_,
        Extended_NR_CGI_Support_List,
        _Extended_NR_CGI_Support_Item_nR_CGI,
        ____Extended_NR_CGI_Support_Item_iE_Extensions__item__id_tab,
        ___Extended_NR_CGI_Support_Item_iE_Extensions__item__id,
        ____Extended_NR_CGI_Support_Item_iE_Extensions__item__criticality_tab,
        ___Extended_NR_CGI_Support_Item_iE_Extensions__item__criticality,
        ____Extended_NR_CGI_Support_Item_iE_Extensions__item__extensionValue_tab,
        ___Extended_NR_CGI_Support_Item_iE_Extensions__item__extensionValue,
        __Extended_NR_CGI_Support_Item_iE_Extensions__item_,
        _Extended_NR_CGI_Support_Item_iE_Extensions,
        Extended_NR_CGI_Support_Item,
        Extended_NR_CGI_Support_Item_ExtIEs,
        OutOfOrderDelivery,
        PacketDelayBudget,
        _PacketErrorRate_pER_Scalar,
        _PacketErrorRate_pER_Exponent,
        ____PacketErrorRate_iE_Extensions__item__id_tab,
        ___PacketErrorRate_iE_Extensions__item__id,
        ____PacketErrorRate_iE_Extensions__item__criticality_tab,
        ___PacketErrorRate_iE_Extensions__item__criticality,
        ____PacketErrorRate_iE_Extensions__item__extensionValue_tab,
        ___PacketErrorRate_iE_Extensions__item__extensionValue,
        __PacketErrorRate_iE_Extensions__item_,
        _PacketErrorRate_iE_Extensions,
        PacketErrorRate,
        PacketErrorRate_ExtIEs,
        PER_Scalar,
        PER_Exponent,
        _PDCP_Configuration_pDCP_SN_Size_UL,
        _PDCP_Configuration_pDCP_SN_Size_DL,
        _PDCP_Configuration_rLC_Mode,
        _PDCP_Configuration_rOHC_Parameters,
        _PDCP_Configuration_t_ReorderingTimer,
        _PDCP_Configuration_discardTimer,
        _PDCP_Configuration_uLDataSplitThreshold,
        _PDCP_Configuration_pDCP_Duplication,
        _PDCP_Configuration_pDCP_Reestablishment,
        _PDCP_Configuration_pDCP_DataRecovery,
        _PDCP_Configuration_duplication_Activation,
        _PDCP_Configuration_outOfOrderDelivery,
        ____PDCP_Configuration_iE_Extensions__item__id_tab,
        _____PDCP_Configuration_iE_Extensions__item__id_tab_val_Extension_0,
        _____PDCP_Configuration_iE_Extensions__item__id_tab_val_Extension_1,
        _____PDCP_Configuration_iE_Extensions__item__id_tab_val_Extension_2,
        _____PDCP_Configuration_iE_Extensions__item__id_tab_val_Extension_3,
        _____PDCP_Configuration_iE_Extensions__item__id_tab_val_Extension_4,
        ___PDCP_Configuration_iE_Extensions__item__id,
        ___PDCP_Configuration_iE_Extensions__item__criticality,
        ___PDCP_Configuration_iE_Extensions__item__extensionValue,
        __PDCP_Configuration_iE_Extensions__item_,
        _PDCP_Configuration_iE_Extensions,
        PDCP_Configuration,
        PDCP_Configuration_ExtIEs,
        _PDCP_Configuration_ExtIEs_val_Extension_0,
        _PDCP_Configuration_ExtIEs_val_Extension_1,
        _PDCP_Configuration_ExtIEs_val_Extension_2,
        _PDCP_Configuration_ExtIEs_val_Extension_3,
        _PDCP_Configuration_ExtIEs_val_Extension_4,
        PDCP_COUNT_Reset,
        _PDCP_Count_pDCP_SN,
        _PDCP_Count_hFN,
        ____PDCP_Count_iE_Extensions__item__id_tab,
        ___PDCP_Count_iE_Extensions__item__id,
        ____PDCP_Count_iE_Extensions__item__criticality_tab,
        ___PDCP_Count_iE_Extensions__item__criticality,
        ____PDCP_Count_iE_Extensions__item__extensionValue_tab,
        ___PDCP_Count_iE_Extensions__item__extensionValue,
        __PDCP_Count_iE_Extensions__item_,
        _PDCP_Count_iE_Extensions,
        PDCP_Count,
        PDCP_Count_ExtIEs,
        PDCP_SN_Status_Request,
        PDCP_DataRecovery,
        PDCP_Duplication,
        PDCP_Reestablishment,
        _PDU_Session_Resource_Data_Usage_List__item_,
        PDU_Session_Resource_Data_Usage_List,
        _PDU_Session_Resource_Data_Usage_Item_pDU_Session_ID,
        _PDU_Session_Resource_Data_Usage_Item_mRDC_Usage_Information,
        ____PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__id_tab,
        ___PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__id,
        ____PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__criticality_tab,
        ___PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__criticality,
        ____PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__extensionValue_tab,
        ___PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item__extensionValue,
        __PDU_Session_Resource_Data_Usage_Item_iE_Extensions__item_,
        _PDU_Session_Resource_Data_Usage_Item_iE_Extensions,
        PDU_Session_Resource_Data_Usage_Item,
        PDU_Session_Resource_Data_Usage_Item_ExtIEs,
        PDCP_SN,
        PDCP_SN_Size,
        _PDCP_SN_Status_Information_pdcpStatusTransfer_UL,
        _PDCP_SN_Status_Information_pdcpStatusTransfer_DL,
        ____PDCP_SN_Status_Information_iE_Extension__item__id_tab,
        ___PDCP_SN_Status_Information_iE_Extension__item__id,
        ____PDCP_SN_Status_Information_iE_Extension__item__criticality_tab,
        ___PDCP_SN_Status_Information_iE_Extension__item__criticality,
        ____PDCP_SN_Status_Information_iE_Extension__item__extensionValue_tab,
        ___PDCP_SN_Status_Information_iE_Extension__item__extensionValue,
        __PDCP_SN_Status_Information_iE_Extension__item_,
        _PDCP_SN_Status_Information_iE_Extension,
        PDCP_SN_Status_Information,
        PDCP_StatusReportIndication,
        PDCP_SN_Status_Information_ExtIEs,
        _DRBBStatusTransfer_receiveStatusofPDCPSDU,
        _DRBBStatusTransfer_countValue,
        ____DRBBStatusTransfer_iE_Extension__item__id_tab,
        ___DRBBStatusTransfer_iE_Extension__item__id,
        ____DRBBStatusTransfer_iE_Extension__item__criticality_tab,
        ___DRBBStatusTransfer_iE_Extension__item__criticality,
        ____DRBBStatusTransfer_iE_Extension__item__extensionValue_tab,
        ___DRBBStatusTransfer_iE_Extension__item__extensionValue,
        __DRBBStatusTransfer_iE_Extension__item_,
        _DRBBStatusTransfer_iE_Extension,
        DRBBStatusTransfer,
        DRBBStatusTransfer_ExtIEs,
        PDU_Session_ID,
        PDUSession_PairID,
        PDU_Session_Resource_Activity,
        _PDU_Session_Resource_Activity_List__item_,
        PDU_Session_Resource_Activity_List,
        _PDU_Session_Resource_Activity_Item_pDU_Session_ID,
        _PDU_Session_Resource_Activity_Item_pDU_Session_Resource_Activity,
        ____PDU_Session_Resource_Activity_Item_iE_Extensions__item__id_tab,
        ___PDU_Session_Resource_Activity_Item_iE_Extensions__item__id,
        ____PDU_Session_Resource_Activity_Item_iE_Extensions__item__criticality_tab,
        ___PDU_Session_Resource_Activity_Item_iE_Extensions__item__criticality,
        ____PDU_Session_Resource_Activity_Item_iE_Extensions__item__extensionValue_tab,
        ___PDU_Session_Resource_Activity_Item_iE_Extensions__item__extensionValue,
        __PDU_Session_Resource_Activity_Item_iE_Extensions__item_,
        _PDU_Session_Resource_Activity_Item_iE_Extensions,
        PDU_Session_Resource_Activity_Item,
        PDU_Session_Resource_Activity_ItemExtIEs,
        _PDU_Session_Resource_Confirm_Modified_List__item_,
        PDU_Session_Resource_Confirm_Modified_List,
        _PDU_Session_Resource_Confirm_Modified_Item_pDU_Session_ID,
        _PDU_Session_Resource_Confirm_Modified_Item_dRB_Confirm_Modified_List_NG_RAN,
        ____PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__id_tab,
        ___PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__id,
        ____PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__criticality_tab,
        ___PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__criticality,
        ____PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__extensionValue_tab,
        ___PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item__extensionValue,
        __PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions__item_,
        _PDU_Session_Resource_Confirm_Modified_Item_iE_Extensions,
        PDU_Session_Resource_Confirm_Modified_Item,
        PDU_Session_Resource_Confirm_Modified_Item_ExtIEs,
        _PDU_Session_Resource_Failed_List__item_,
        PDU_Session_Resource_Failed_List,
        _PDU_Session_Resource_Failed_Item_pDU_Session_ID,
        _PDU_Session_Resource_Failed_Item_cause,
        ____PDU_Session_Resource_Failed_Item_iE_Extensions__item__id_tab,
        ___PDU_Session_Resource_Failed_Item_iE_Extensions__item__id,
        ____PDU_Session_Resource_Failed_Item_iE_Extensions__item__criticality_tab,
        ___PDU_Session_Resource_Failed_Item_iE_Extensions__item__criticality,
        ____PDU_Session_Resource_Failed_Item_iE_Extensions__item__extensionValue_tab,
        ___PDU_Session_Resource_Failed_Item_iE_Extensions__item__extensionValue,
        __PDU_Session_Resource_Failed_Item_iE_Extensions__item_,
        _PDU_Session_Resource_Failed_Item_iE_Extensions,
        PDU_Session_Resource_Failed_Item,
        PDU_Session_Resource_Failed_Item_ExtIEs,
        _PDU_Session_Resource_Failed_Mod_List__item_,
        PDU_Session_Resource_Failed_Mod_List,
        _PDU_Session_Resource_Failed_Mod_Item_pDU_Session_ID,
        _PDU_Session_Resource_Failed_Mod_Item_cause,
        ____PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__id_tab,
        ___PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__id,
        ____PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__criticality_tab,
        ___PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__criticality,
        ____PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__extensionValue_tab,
        ___PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item__extensionValue,
        __PDU_Session_Resource_Failed_Mod_Item_iE_Extensions__item_,
        _PDU_Session_Resource_Failed_Mod_Item_iE_Extensions,
        PDU_Session_Resource_Failed_Mod_Item,
        PDU_Session_Resource_Failed_Mod_Item_ExtIEs,
        _PDU_Session_Resource_Failed_To_Modify_List__item_,
        PDU_Session_Resource_Failed_To_Modify_List,
        _PDU_Session_Resource_Failed_To_Modify_Item_pDU_Session_ID,
        _PDU_Session_Resource_Failed_To_Modify_Item_cause,
        ____PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__id_tab,
        ___PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__id,
        ____PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__criticality_tab,
        ___PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__criticality,
        ____PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__extensionValue_tab,
        ___PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item__extensionValue,
        __PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions__item_,
        _PDU_Session_Resource_Failed_To_Modify_Item_iE_Extensions,
        PDU_Session_Resource_Failed_To_Modify_Item,
        PDU_Session_Resource_Failed_To_Modify_Item_ExtIEs,
        _PDU_Session_Resource_Modified_List__item_,
        PDU_Session_Resource_Modified_List,
        _PDU_Session_Resource_Modified_Item_pDU_Session_ID,
        _PDU_Session_Resource_Modified_Item_nG_DL_UP_TNL_Information,
        _PDU_Session_Resource_Modified_Item_securityResult,
        _PDU_Session_Resource_Modified_Item_pDU_Session_Data_Forwarding_Information_Response,
        _PDU_Session_Resource_Modified_Item_dRB_Setup_List_NG_RAN,
        _PDU_Session_Resource_Modified_Item_dRB_Failed_List_NG_RAN,
        _PDU_Session_Resource_Modified_Item_dRB_Modified_List_NG_RAN,
        _PDU_Session_Resource_Modified_Item_dRB_Failed_To_Modify_List_NG_RAN,
        ____PDU_Session_Resource_Modified_Item_iE_Extensions__item__id_tab,
        _____PDU_Session_Resource_Modified_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___PDU_Session_Resource_Modified_Item_iE_Extensions__item__id,
        ___PDU_Session_Resource_Modified_Item_iE_Extensions__item__criticality,
        ___PDU_Session_Resource_Modified_Item_iE_Extensions__item__extensionValue,
        __PDU_Session_Resource_Modified_Item_iE_Extensions__item_,
        _PDU_Session_Resource_Modified_Item_iE_Extensions,
        PDU_Session_Resource_Modified_Item,
        PDU_Session_Resource_Modified_Item_ExtIEs,
        _PDU_Session_Resource_Modified_Item_ExtIEs_val_Extension_0,
        _PDU_Session_Resource_Required_To_Modify_List__item_,
        PDU_Session_Resource_Required_To_Modify_List,
        _PDU_Session_Resource_Required_To_Modify_Item_pDU_Session_ID,
        _PDU_Session_Resource_Required_To_Modify_Item_nG_DL_UP_TNL_Information,
        _PDU_Session_Resource_Required_To_Modify_Item_dRB_Required_To_Modify_List_NG_RAN,
        _PDU_Session_Resource_Required_To_Modify_Item_dRB_Required_To_Remove_List_NG_RAN,
        ____PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__id_tab,
        _____PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__id,
        ___PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__criticality,
        ___PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item__extensionValue,
        __PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions__item_,
        _PDU_Session_Resource_Required_To_Modify_Item_iE_Extensions,
        PDU_Session_Resource_Required_To_Modify_Item,
        PDU_Session_Resource_Required_To_Modify_Item_ExtIEs,
        _PDU_Session_Resource_Required_To_Modify_Item_ExtIEs_val_Extension_0,
        _PDU_Session_Resource_Setup_List__item_,
        PDU_Session_Resource_Setup_List,
        _PDU_Session_Resource_Setup_Item_pDU_Session_ID,
        _PDU_Session_Resource_Setup_Item_securityResult,
        _PDU_Session_Resource_Setup_Item_nG_DL_UP_TNL_Information,
        _PDU_Session_Resource_Setup_Item_pDU_Session_Data_Forwarding_Information_Response,
        _PDU_Session_Resource_Setup_Item_nG_DL_UP_Unchanged,
        _PDU_Session_Resource_Setup_Item_dRB_Setup_List_NG_RAN,
        _PDU_Session_Resource_Setup_Item_dRB_Failed_List_NG_RAN,
        ____PDU_Session_Resource_Setup_Item_iE_Extensions__item__id_tab,
        _____PDU_Session_Resource_Setup_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____PDU_Session_Resource_Setup_Item_iE_Extensions__item__id_tab_val_Extension_1,
        ___PDU_Session_Resource_Setup_Item_iE_Extensions__item__id,
        ___PDU_Session_Resource_Setup_Item_iE_Extensions__item__criticality,
        ___PDU_Session_Resource_Setup_Item_iE_Extensions__item__extensionValue,
        __PDU_Session_Resource_Setup_Item_iE_Extensions__item_,
        _PDU_Session_Resource_Setup_Item_iE_Extensions,
        PDU_Session_Resource_Setup_Item,
        PDU_Session_Resource_Setup_Item_ExtIEs,
        _PDU_Session_Resource_Setup_Item_ExtIEs_val_Extension_0,
        _PDU_Session_Resource_Setup_Item_ExtIEs_val_Extension_1,
        _PDU_Session_Resource_Setup_Mod_List__item_,
        PDU_Session_Resource_Setup_Mod_List,
        _PDU_Session_Resource_Setup_Mod_Item_pDU_Session_ID,
        _PDU_Session_Resource_Setup_Mod_Item_securityResult,
        _PDU_Session_Resource_Setup_Mod_Item_nG_DL_UP_TNL_Information,
        _PDU_Session_Resource_Setup_Mod_Item_pDU_Session_Data_Forwarding_Information_Response,
        _PDU_Session_Resource_Setup_Mod_Item_dRB_Setup_Mod_List_NG_RAN,
        _PDU_Session_Resource_Setup_Mod_Item_dRB_Failed_Mod_List_NG_RAN,
        ____PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__id_tab,
        _____PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__id,
        ___PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__criticality,
        ___PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item__extensionValue,
        __PDU_Session_Resource_Setup_Mod_Item_iE_Extensions__item_,
        _PDU_Session_Resource_Setup_Mod_Item_iE_Extensions,
        PDU_Session_Resource_Setup_Mod_Item,
        PDU_Session_Resource_Setup_Mod_Item_ExtIEs,
        _PDU_Session_Resource_Setup_Mod_Item_ExtIEs_val_Extension_0,
        _PDU_Session_Resource_To_Modify_List__item_,
        PDU_Session_Resource_To_Modify_List,
        _PDU_Session_Resource_To_Modify_Item_pDU_Session_ID,
        _PDU_Session_Resource_To_Modify_Item_securityIndication,
        _PDU_Session_Resource_To_Modify_Item_pDU_Session_Resource_DL_AMBR,
        _PDU_Session_Resource_To_Modify_Item_nG_UL_UP_TNL_Information,
        _PDU_Session_Resource_To_Modify_Item_pDU_Session_Data_Forwarding_Information_Request,
        _PDU_Session_Resource_To_Modify_Item_pDU_Session_Data_Forwarding_Information,
        _PDU_Session_Resource_To_Modify_Item_pDU_Session_Inactivity_Timer,
        _PDU_Session_Resource_To_Modify_Item_networkInstance,
        _PDU_Session_Resource_To_Modify_Item_dRB_To_Setup_List_NG_RAN,
        _PDU_Session_Resource_To_Modify_Item_dRB_To_Modify_List_NG_RAN,
        _PDU_Session_Resource_To_Modify_Item_dRB_To_Remove_List_NG_RAN,
        ____PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id_tab,
        _____PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id_tab_val_Extension_2,
        _____PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id_tab_val_Extension_3,
        _____PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id_tab_val_Extension_4,
        _____PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id_tab_val_Extension_5,
        ___PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__id,
        ___PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__criticality,
        ___PDU_Session_Resource_To_Modify_Item_iE_Extensions__item__extensionValue,
        __PDU_Session_Resource_To_Modify_Item_iE_Extensions__item_,
        _PDU_Session_Resource_To_Modify_Item_iE_Extensions,
        PDU_Session_Resource_To_Modify_Item,
        PDU_Session_Resource_To_Modify_Item_ExtIEs,
        _PDU_Session_Resource_To_Modify_Item_ExtIEs_val_Extension_0,
        _PDU_Session_Resource_To_Modify_Item_ExtIEs_val_Extension_1,
        _PDU_Session_Resource_To_Modify_Item_ExtIEs_val_Extension_2,
        _PDU_Session_Resource_To_Modify_Item_ExtIEs_val_Extension_3,
        _PDU_Session_Resource_To_Modify_Item_ExtIEs_val_Extension_4,
        _PDU_Session_Resource_To_Modify_Item_ExtIEs_val_Extension_5,
        _PDU_Session_Resource_To_Remove_List__item_,
        PDU_Session_Resource_To_Remove_List,
        _PDU_Session_Resource_To_Remove_Item_pDU_Session_ID,
        ____PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__id_tab,
        _____PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__id,
        ___PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__criticality,
        ___PDU_Session_Resource_To_Remove_Item_iE_Extensions__item__extensionValue,
        __PDU_Session_Resource_To_Remove_Item_iE_Extensions__item_,
        _PDU_Session_Resource_To_Remove_Item_iE_Extensions,
        PDU_Session_Resource_To_Remove_Item,
        PDU_Session_Resource_To_Remove_Item_ExtIEs,
        _PDU_Session_Resource_To_Remove_Item_ExtIEs_val_Extension_0,
        _PDU_Session_Resource_To_Setup_List__item_,
        PDU_Session_Resource_To_Setup_List,
        _PDU_Session_Resource_To_Setup_Item_pDU_Session_ID,
        _PDU_Session_Resource_To_Setup_Item_pDU_Session_Type,
        _PDU_Session_Resource_To_Setup_Item_sNSSAI,
        _PDU_Session_Resource_To_Setup_Item_securityIndication,
        _PDU_Session_Resource_To_Setup_Item_pDU_Session_Resource_DL_AMBR,
        _PDU_Session_Resource_To_Setup_Item_nG_UL_UP_TNL_Information,
        _PDU_Session_Resource_To_Setup_Item_pDU_Session_Data_Forwarding_Information_Request,
        _PDU_Session_Resource_To_Setup_Item_pDU_Session_Inactivity_Timer,
        _PDU_Session_Resource_To_Setup_Item_existing_Allocated_NG_DL_UP_TNL_Info,
        _PDU_Session_Resource_To_Setup_Item_networkInstance,
        _PDU_Session_Resource_To_Setup_Item_dRB_To_Setup_List_NG_RAN,
        ____PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__id_tab,
        _____PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__id_tab_val_Extension_2,
        _____PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__id_tab_val_Extension_3,
        ___PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__id,
        ___PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__criticality,
        ___PDU_Session_Resource_To_Setup_Item_iE_Extensions__item__extensionValue,
        __PDU_Session_Resource_To_Setup_Item_iE_Extensions__item_,
        _PDU_Session_Resource_To_Setup_Item_iE_Extensions,
        PDU_Session_Resource_To_Setup_Item,
        PDU_Session_Resource_To_Setup_Item_ExtIEs,
        _PDU_Session_Resource_To_Setup_Item_ExtIEs_val_Extension_0,
        _PDU_Session_Resource_To_Setup_Item_ExtIEs_val_Extension_1,
        _PDU_Session_Resource_To_Setup_Item_ExtIEs_val_Extension_2,
        _PDU_Session_Resource_To_Setup_Item_ExtIEs_val_Extension_3,
        _PDU_Session_Resource_To_Setup_Mod_List__item_,
        PDU_Session_Resource_To_Setup_Mod_List,
        _PDU_Session_Resource_To_Setup_Mod_Item_pDU_Session_ID,
        _PDU_Session_Resource_To_Setup_Mod_Item_pDU_Session_Type,
        _PDU_Session_Resource_To_Setup_Mod_Item_sNSSAI,
        _PDU_Session_Resource_To_Setup_Mod_Item_securityIndication,
        _PDU_Session_Resource_To_Setup_Mod_Item_pDU_Session_Resource_AMBR,
        _PDU_Session_Resource_To_Setup_Mod_Item_nG_UL_UP_TNL_Information,
        _PDU_Session_Resource_To_Setup_Mod_Item_pDU_Session_Data_Forwarding_Information_Request,
        _PDU_Session_Resource_To_Setup_Mod_Item_pDU_Session_Inactivity_Timer,
        _PDU_Session_Resource_To_Setup_Mod_Item_dRB_To_Setup_Mod_List_NG_RAN,
        ____PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__id_tab,
        _____PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__id_tab_val_Extension_2,
        _____PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__id_tab_val_Extension_3,
        ___PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__id,
        ___PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__criticality,
        ___PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item__extensionValue,
        __PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions__item_,
        _PDU_Session_Resource_To_Setup_Mod_Item_iE_Extensions,
        PDU_Session_Resource_To_Setup_Mod_Item,
        PDU_Session_Resource_To_Setup_Mod_Item_ExtIEs,
        _PDU_Session_Resource_To_Setup_Mod_Item_ExtIEs_val_Extension_0,
        _PDU_Session_Resource_To_Setup_Mod_Item_ExtIEs_val_Extension_1,
        _PDU_Session_Resource_To_Setup_Mod_Item_ExtIEs_val_Extension_2,
        _PDU_Session_Resource_To_Setup_Mod_Item_ExtIEs_val_Extension_3,
        _PDU_Session_To_Notify_List__item_,
        PDU_Session_To_Notify_List,
        _PDU_Session_To_Notify_Item_pDU_Session_ID,
        _PDU_Session_To_Notify_Item_qoS_Flow_List,
        ____PDU_Session_To_Notify_Item_iE_Extensions__item__id_tab,
        ___PDU_Session_To_Notify_Item_iE_Extensions__item__id,
        ____PDU_Session_To_Notify_Item_iE_Extensions__item__criticality_tab,
        ___PDU_Session_To_Notify_Item_iE_Extensions__item__criticality,
        ____PDU_Session_To_Notify_Item_iE_Extensions__item__extensionValue_tab,
        ___PDU_Session_To_Notify_Item_iE_Extensions__item__extensionValue,
        __PDU_Session_To_Notify_Item_iE_Extensions__item_,
        _PDU_Session_To_Notify_Item_iE_Extensions,
        PDU_Session_To_Notify_Item,
        PDU_Session_To_Notify_Item_ExtIEs,
        PDU_Session_Type,
        PLMN_Identity,
        PortNumber,
        PPI,
        PriorityLevel,
        Pre_emptionCapability,
        Pre_emptionVulnerability,
        PrivacyIndicator,
        QCI,
        _QoS_Characteristics_non_Dynamic_5QI,
        _QoS_Characteristics_dynamic_5QI,
        ___QoS_Characteristics_choice_extension_id_tab,
        __QoS_Characteristics_choice_extension_id,
        ___QoS_Characteristics_choice_extension_criticality_tab,
        __QoS_Characteristics_choice_extension_criticality,
        ___QoS_Characteristics_choice_extension_value_tab,
        __QoS_Characteristics_choice_extension_value,
        _QoS_Characteristics_choice_extension,
        QoS_Characteristics,
        QoS_Characteristics_ExtIEs,
        QoS_Flow_Identifier,
        _QoS_Flow_List__item_,
        QoS_Flow_List,
        _QoS_Flow_Item_qoS_Flow_Identifier,
        ____QoS_Flow_Item_iE_Extensions__item__id_tab,
        _____QoS_Flow_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____QoS_Flow_Item_iE_Extensions__item__id_tab_val_Extension_1,
        ___QoS_Flow_Item_iE_Extensions__item__id,
        ___QoS_Flow_Item_iE_Extensions__item__criticality,
        ___QoS_Flow_Item_iE_Extensions__item__extensionValue,
        __QoS_Flow_Item_iE_Extensions__item_,
        _QoS_Flow_Item_iE_Extensions,
        QoS_Flow_Item,
        QoS_Flow_Item_ExtIEs,
        _QoS_Flow_Item_ExtIEs_val_Extension_0,
        _QoS_Flow_Item_ExtIEs_val_Extension_1,
        _QoS_Flow_Failed_List__item_,
        QoS_Flow_Failed_List,
        _QoS_Flow_Failed_Item_qoS_Flow_Identifier,
        _QoS_Flow_Failed_Item_cause,
        ____QoS_Flow_Failed_Item_iE_Extensions__item__id_tab,
        ___QoS_Flow_Failed_Item_iE_Extensions__item__id,
        ____QoS_Flow_Failed_Item_iE_Extensions__item__criticality_tab,
        ___QoS_Flow_Failed_Item_iE_Extensions__item__criticality,
        ____QoS_Flow_Failed_Item_iE_Extensions__item__extensionValue_tab,
        ___QoS_Flow_Failed_Item_iE_Extensions__item__extensionValue,
        __QoS_Flow_Failed_Item_iE_Extensions__item_,
        _QoS_Flow_Failed_Item_iE_Extensions,
        QoS_Flow_Failed_Item,
        QoS_Flow_Failed_Item_ExtIEs,
        _QoS_Flow_Mapping_List__item_,
        QoS_Flow_Mapping_List,
        _QoS_Flow_Mapping_Item_qoS_Flow_Identifier,
        _QoS_Flow_Mapping_Item_qoSFlowMappingIndication,
        ____QoS_Flow_Mapping_Item_iE_Extensions__item__id_tab,
        ___QoS_Flow_Mapping_Item_iE_Extensions__item__id,
        ____QoS_Flow_Mapping_Item_iE_Extensions__item__criticality_tab,
        ___QoS_Flow_Mapping_Item_iE_Extensions__item__criticality,
        ____QoS_Flow_Mapping_Item_iE_Extensions__item__extensionValue_tab,
        ___QoS_Flow_Mapping_Item_iE_Extensions__item__extensionValue,
        __QoS_Flow_Mapping_Item_iE_Extensions__item_,
        _QoS_Flow_Mapping_Item_iE_Extensions,
        QoS_Flow_Mapping_Item,
        QoS_Flow_Mapping_Item_ExtIEs,
        QoS_Flow_Mapping_Indication,
        QoS_Flows_DRB_Remapping,
        _QoS_Parameters_Support_List_eUTRAN_QoS_Support_List,
        _QoS_Parameters_Support_List_nG_RAN_QoS_Support_List,
        ____QoS_Parameters_Support_List_iE_Extensions__item__id_tab,
        ___QoS_Parameters_Support_List_iE_Extensions__item__id,
        ____QoS_Parameters_Support_List_iE_Extensions__item__criticality_tab,
        ___QoS_Parameters_Support_List_iE_Extensions__item__criticality,
        ____QoS_Parameters_Support_List_iE_Extensions__item__extensionValue_tab,
        ___QoS_Parameters_Support_List_iE_Extensions__item__extensionValue,
        __QoS_Parameters_Support_List_iE_Extensions__item_,
        _QoS_Parameters_Support_List_iE_Extensions,
        QoS_Parameters_Support_List,
        QoS_Parameters_Support_List_ItemExtIEs,
        QoSPriorityLevel,
        _QoS_Flow_QoS_Parameter_List__item_,
        QoS_Flow_QoS_Parameter_List,
        _QoS_Flow_QoS_Parameter_Item_qoS_Flow_Identifier,
        _QoS_Flow_QoS_Parameter_Item_qoSFlowLevelQoSParameters,
        _QoS_Flow_QoS_Parameter_Item_qoSFlowMappingIndication,
        ____QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__id_tab,
        _____QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__id_tab_val_Extension_1,
        ___QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__id,
        ___QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__criticality,
        ___QoS_Flow_QoS_Parameter_Item_iE_Extensions__item__extensionValue,
        __QoS_Flow_QoS_Parameter_Item_iE_Extensions__item_,
        _QoS_Flow_QoS_Parameter_Item_iE_Extensions,
        QoS_Flow_QoS_Parameter_Item,
        QoS_Flow_QoS_Parameter_Item_ExtIEs,
        _QoS_Flow_QoS_Parameter_Item_ExtIEs_val_Extension_0,
        _QoS_Flow_QoS_Parameter_Item_ExtIEs_val_Extension_1,
        _QoSFlowLevelQoSParameters_qoS_Characteristics,
        _QoSFlowLevelQoSParameters_nGRANallocationRetentionPriority,
        _QoSFlowLevelQoSParameters_gBR_QoS_Flow_Information,
        _QoSFlowLevelQoSParameters_reflective_QoS_Attribute,
        _QoSFlowLevelQoSParameters_additional_QoS_Information,
        _QoSFlowLevelQoSParameters_paging_Policy_Indicator,
        _QoSFlowLevelQoSParameters_reflective_QoS_Indicator,
        ____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab,
        _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_0,
        _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_1,
        _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_2,
        _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_3,
        _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_4,
        ___QoSFlowLevelQoSParameters_iE_Extensions__item__id,
        ___QoSFlowLevelQoSParameters_iE_Extensions__item__criticality,
        ___QoSFlowLevelQoSParameters_iE_Extensions__item__extensionValue,
        __QoSFlowLevelQoSParameters_iE_Extensions__item_,
        _QoSFlowLevelQoSParameters_iE_Extensions,
        QoSFlowLevelQoSParameters,
        QoSFlowLevelQoSParameters_ExtIEs,
        _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_0,
        _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_1,
        _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_2,
        _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_3,
        _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_4,
        QosMonitoringRequest,
        QosMonitoringReportingFrequency,
        QosMonitoringDisabled,
        _QoS_Flow_Removed_Item_qoS_Flow_Identifier,
        _QoS_Flow_Removed_Item_qoS_Flow_Released_In_Session,
        _QoS_Flow_Removed_Item_qoS_Flow_Accumulated_Session_Time,
        ____QoS_Flow_Removed_Item_iE_Extensions__item__id_tab,
        ___QoS_Flow_Removed_Item_iE_Extensions__item__id,
        ____QoS_Flow_Removed_Item_iE_Extensions__item__criticality_tab,
        ___QoS_Flow_Removed_Item_iE_Extensions__item__criticality,
        ____QoS_Flow_Removed_Item_iE_Extensions__item__extensionValue_tab,
        ___QoS_Flow_Removed_Item_iE_Extensions__item__extensionValue,
        __QoS_Flow_Removed_Item_iE_Extensions__item_,
        _QoS_Flow_Removed_Item_iE_Extensions,
        QoS_Flow_Removed_Item,
        QoS_Flow_Removed_Item_ExtIEs,
        _QoS_Flows_to_be_forwarded_List__item_,
        QoS_Flows_to_be_forwarded_List,
        _QoS_Flows_to_be_forwarded_Item_qoS_Flow_Identifier,
        ____QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__id_tab,
        ___QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__id,
        ____QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__criticality_tab,
        ___QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__criticality,
        ____QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__extensionValue_tab,
        ___QoS_Flows_to_be_forwarded_Item_iE_Extensions__item__extensionValue,
        __QoS_Flows_to_be_forwarded_Item_iE_Extensions__item_,
        _QoS_Flows_to_be_forwarded_Item_iE_Extensions,
        QoS_Flows_to_be_forwarded_Item,
        QoS_Flows_to_be_forwarded_Item_ExtIEs,
        _QoS_Mapping_Information_dscp,
        _QoS_Mapping_Information_flow_label,
        QoS_Mapping_Information,
        _DataForwardingtoNG_RANQoSFlowInformationList__item_,
        DataForwardingtoNG_RANQoSFlowInformationList,
        _DataForwardingtoNG_RANQoSFlowInformationList_Item_qoS_Flow_Identifier,
        ____DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__id_tab,
        ___DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__id,
        ____DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__criticality_tab,
        ___DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__criticality,
        ____DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__extensionValue_tab,
        ___DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item__extensionValue,
        __DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions__item_,
        _DataForwardingtoNG_RANQoSFlowInformationList_Item_iE_Extensions,
        DataForwardingtoNG_RANQoSFlowInformationList_Item,
        DataForwardingtoNG_RANQoSFlowInformationList_Item_ExtIEs,
        RANUEID,
        RAT_Type,
        RedundantQoSFlowIndicator,
        _RedundantPDUSessionInformation_rSN,
        ____RedundantPDUSessionInformation_iE_Extensions__item__id_tab,
        _____RedundantPDUSessionInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___RedundantPDUSessionInformation_iE_Extensions__item__id,
        ___RedundantPDUSessionInformation_iE_Extensions__item__criticality,
        ___RedundantPDUSessionInformation_iE_Extensions__item__extensionValue,
        __RedundantPDUSessionInformation_iE_Extensions__item_,
        _RedundantPDUSessionInformation_iE_Extensions,
        RedundantPDUSessionInformation,
        RedundantPDUSessionInformation_ExtIEs,
        _RedundantPDUSessionInformation_ExtIEs_val_Extension_0,
        RSN,
        _RetainabilityMeasurementsInfo__item_,
        RetainabilityMeasurementsInfo,
        RegistrationRequest,
        ReportCharacteristics,
        ReportingPeriodicity,
        RequestedAction4AvailNGUTermination,
        RLC_Mode,
        _ROHC_Parameters_rOHC,
        _ROHC_Parameters_uPlinkOnlyROHC,
        ___ROHC_Parameters_choice_Extension_id_tab,
        __ROHC_Parameters_choice_Extension_id,
        ___ROHC_Parameters_choice_Extension_criticality_tab,
        __ROHC_Parameters_choice_Extension_criticality,
        ___ROHC_Parameters_choice_Extension_value_tab,
        __ROHC_Parameters_choice_Extension_value,
        _ROHC_Parameters_choice_Extension,
        ROHC_Parameters,
        ROHC_Parameters_ExtIEs,
        _ROHC_maxCID,
        _ROHC_rOHC_Profiles,
        _ROHC_continueROHC,
        ____ROHC_iE_Extensions__item__id_tab,
        ___ROHC_iE_Extensions__item__id,
        ____ROHC_iE_Extensions__item__criticality_tab,
        ___ROHC_iE_Extensions__item__criticality,
        ____ROHC_iE_Extensions__item__extensionValue_tab,
        ___ROHC_iE_Extensions__item__extensionValue,
        __ROHC_iE_Extensions__item_,
        _ROHC_iE_Extensions,
        ROHC,
        ROHC_ExtIEs,
        SCGActivationStatus,
        _SecurityAlgorithm_cipheringAlgorithm,
        _SecurityAlgorithm_integrityProtectionAlgorithm,
        ____SecurityAlgorithm_iE_Extensions__item__id_tab,
        ___SecurityAlgorithm_iE_Extensions__item__id,
        ____SecurityAlgorithm_iE_Extensions__item__criticality_tab,
        ___SecurityAlgorithm_iE_Extensions__item__criticality,
        ____SecurityAlgorithm_iE_Extensions__item__extensionValue_tab,
        ___SecurityAlgorithm_iE_Extensions__item__extensionValue,
        __SecurityAlgorithm_iE_Extensions__item_,
        _SecurityAlgorithm_iE_Extensions,
        SecurityAlgorithm,
        SecurityAlgorithm_ExtIEs,
        _SecurityIndication_integrityProtectionIndication,
        _SecurityIndication_confidentialityProtectionIndication,
        _SecurityIndication_maximumIPdatarate,
        ____SecurityIndication_iE_Extensions__item__id_tab,
        ___SecurityIndication_iE_Extensions__item__id,
        ____SecurityIndication_iE_Extensions__item__criticality_tab,
        ___SecurityIndication_iE_Extensions__item__criticality,
        ____SecurityIndication_iE_Extensions__item__extensionValue_tab,
        ___SecurityIndication_iE_Extensions__item__extensionValue,
        __SecurityIndication_iE_Extensions__item_,
        _SecurityIndication_iE_Extensions,
        SecurityIndication,
        SecurityIndication_ExtIEs,
        _SecurityInformation_securityAlgorithm,
        _SecurityInformation_uPSecuritykey,
        ____SecurityInformation_iE_Extensions__item__id_tab,
        ___SecurityInformation_iE_Extensions__item__id,
        ____SecurityInformation_iE_Extensions__item__criticality_tab,
        ___SecurityInformation_iE_Extensions__item__criticality,
        ____SecurityInformation_iE_Extensions__item__extensionValue_tab,
        ___SecurityInformation_iE_Extensions__item__extensionValue,
        __SecurityInformation_iE_Extensions__item_,
        _SecurityInformation_iE_Extensions,
        SecurityInformation,
        SecurityInformation_ExtIEs,
        _SecurityResult_integrityProtectionResult,
        _SecurityResult_confidentialityProtectionResult,
        ____SecurityResult_iE_Extensions__item__id_tab,
        ___SecurityResult_iE_Extensions__item__id,
        ____SecurityResult_iE_Extensions__item__criticality_tab,
        ___SecurityResult_iE_Extensions__item__criticality,
        ____SecurityResult_iE_Extensions__item__extensionValue_tab,
        ___SecurityResult_iE_Extensions__item__extensionValue,
        __SecurityResult_iE_Extensions__item_,
        _SecurityResult_iE_Extensions,
        SecurityResult,
        SecurityResult_ExtIEs,
        _Slice_Support_List__item_,
        Slice_Support_List,
        _Slice_Support_Item_sNSSAI,
        ____Slice_Support_Item_iE_Extensions__item__id_tab,
        ___Slice_Support_Item_iE_Extensions__item__id,
        ____Slice_Support_Item_iE_Extensions__item__criticality_tab,
        ___Slice_Support_Item_iE_Extensions__item__criticality,
        ____Slice_Support_Item_iE_Extensions__item__extensionValue_tab,
        ___Slice_Support_Item_iE_Extensions__item__extensionValue,
        __Slice_Support_Item_iE_Extensions__item_,
        _Slice_Support_Item_iE_Extensions,
        Slice_Support_Item,
        Slice_Support_Item_ExtIEs,
        _SNSSAI_sST,
        _SNSSAI_sD,
        ____SNSSAI_iE_Extensions__item__id_tab,
        ___SNSSAI_iE_Extensions__item__id,
        ____SNSSAI_iE_Extensions__item__criticality_tab,
        ___SNSSAI_iE_Extensions__item__criticality,
        ____SNSSAI_iE_Extensions__item__extensionValue_tab,
        ___SNSSAI_iE_Extensions__item__extensionValue,
        __SNSSAI_iE_Extensions__item_,
        _SNSSAI_iE_Extensions,
        SNSSAI,
        SNSSAI_ExtIEs,
        _SDAP_Configuration_defaultDRB,
        _SDAP_Configuration_sDAP_Header_UL,
        _SDAP_Configuration_sDAP_Header_DL,
        ____SDAP_Configuration_iE_Extensions__item__id_tab,
        ___SDAP_Configuration_iE_Extensions__item__id,
        ____SDAP_Configuration_iE_Extensions__item__criticality_tab,
        ___SDAP_Configuration_iE_Extensions__item__criticality,
        ____SDAP_Configuration_iE_Extensions__item__extensionValue_tab,
        ___SDAP_Configuration_iE_Extensions__item__extensionValue,
        __SDAP_Configuration_iE_Extensions__item_,
        _SDAP_Configuration_iE_Extensions,
        SDAP_Configuration,
        SDAP_Configuration_ExtIEs,
        SDAP_Header_DL,
        SDAP_Header_UL,
        SDTContinueROHC,
        SDTindicatorSetup,
        SDTindicatorMod,
        SubscriberProfileIDforRFP,
        SurvivalTime,
        TimeToWait,
        TNLAssociationUsage,
        _TNL_AvailableCapacityIndicator_dL_TNL_OfferedCapacity,
        _TNL_AvailableCapacityIndicator_dL_TNL_AvailableCapacity,
        _TNL_AvailableCapacityIndicator_uL_TNL_OfferedCapacity,
        _TNL_AvailableCapacityIndicator_uL_TNL_AvailableCapacity,
        ____TNL_AvailableCapacityIndicator_iE_Extensions__item__id_tab,
        ___TNL_AvailableCapacityIndicator_iE_Extensions__item__id,
        ____TNL_AvailableCapacityIndicator_iE_Extensions__item__criticality_tab,
        ___TNL_AvailableCapacityIndicator_iE_Extensions__item__criticality,
        ____TNL_AvailableCapacityIndicator_iE_Extensions__item__extensionValue_tab,
        ___TNL_AvailableCapacityIndicator_iE_Extensions__item__extensionValue,
        __TNL_AvailableCapacityIndicator_iE_Extensions__item_,
        _TNL_AvailableCapacityIndicator_iE_Extensions,
        TNL_AvailableCapacityIndicator,
        TNL_AvailableCapacityIndicator_ExtIEs,
        _TSCTrafficCharacteristics_tSCTrafficCharacteristicsUL,
        _TSCTrafficCharacteristics_tSCTrafficCharacteristicsDL,
        ____TSCTrafficCharacteristics_iE_Extensions__item__id_tab,
        ___TSCTrafficCharacteristics_iE_Extensions__item__id,
        ____TSCTrafficCharacteristics_iE_Extensions__item__criticality_tab,
        ___TSCTrafficCharacteristics_iE_Extensions__item__criticality,
        ____TSCTrafficCharacteristics_iE_Extensions__item__extensionValue_tab,
        ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue,
        __TSCTrafficCharacteristics_iE_Extensions__item_,
        _TSCTrafficCharacteristics_iE_Extensions,
        TSCTrafficCharacteristics,
        TSCTrafficCharacteristics_ExtIEs,
        _TSCTrafficInformation_periodicity,
        _TSCTrafficInformation_burstArrivalTime,
        ____TSCTrafficInformation_iE_Extensions__item__id_tab,
        _____TSCTrafficInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___TSCTrafficInformation_iE_Extensions__item__id,
        ___TSCTrafficInformation_iE_Extensions__item__criticality,
        ___TSCTrafficInformation_iE_Extensions__item__extensionValue,
        __TSCTrafficInformation_iE_Extensions__item_,
        _TSCTrafficInformation_iE_Extensions,
        TSCTrafficInformation,
        TSCTrafficInformation_ExtIEs,
        _TSCTrafficInformation_ExtIEs_val_Extension_0,
        Periodicity,
        BurstArrivalTime,
        _TraceActivation_traceID,
        _TraceActivation_interfacesToTrace,
        _TraceActivation_traceDepth,
        _TraceActivation_traceCollectionEntityIPAddress,
        ____TraceActivation_iE_Extensions__item__id_tab,
        _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0,
        _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_1,
        ___TraceActivation_iE_Extensions__item__id,
        ___TraceActivation_iE_Extensions__item__criticality,
        ___TraceActivation_iE_Extensions__item__extensionValue,
        __TraceActivation_iE_Extensions__item_,
        _TraceActivation_iE_Extensions,
        TraceActivation,
        TraceActivation_ExtIEs,
        _TraceActivation_ExtIEs_val_Extension_0,
        _TraceActivation_ExtIEs_val_Extension_1,
        TraceDepth,
        TraceID,
        TransportLayerAddress,
        TransactionID,
        T_Reordering,
        _T_ReorderingTimer_t_Reordering,
        ____T_ReorderingTimer_iE_Extensions__item__id_tab,
        ___T_ReorderingTimer_iE_Extensions__item__id,
        ____T_ReorderingTimer_iE_Extensions__item__criticality_tab,
        ___T_ReorderingTimer_iE_Extensions__item__criticality,
        ____T_ReorderingTimer_iE_Extensions__item__extensionValue_tab,
        ___T_ReorderingTimer_iE_Extensions__item__extensionValue,
        __T_ReorderingTimer_iE_Extensions__item_,
        _T_ReorderingTimer_iE_Extensions,
        T_ReorderingTimer,
        T_ReorderingTimer_ExtIEs,
        TypeOfError,
        _Transport_Layer_Address_Info_transport_UP_Layer_Addresses_Info_To_Add_List,
        _Transport_Layer_Address_Info_transport_UP_Layer_Addresses_Info_To_Remove_List,
        ____Transport_Layer_Address_Info_iE_Extensions__item__id_tab,
        ___Transport_Layer_Address_Info_iE_Extensions__item__id,
        ____Transport_Layer_Address_Info_iE_Extensions__item__criticality_tab,
        ___Transport_Layer_Address_Info_iE_Extensions__item__criticality,
        ____Transport_Layer_Address_Info_iE_Extensions__item__extensionValue_tab,
        ___Transport_Layer_Address_Info_iE_Extensions__item__extensionValue,
        __Transport_Layer_Address_Info_iE_Extensions__item_,
        _Transport_Layer_Address_Info_iE_Extensions,
        Transport_Layer_Address_Info,
        Transport_Layer_Address_Info_ExtIEs,
        _Transport_UP_Layer_Addresses_Info_To_Add_List__item_,
        Transport_UP_Layer_Addresses_Info_To_Add_List,
        _Transport_UP_Layer_Addresses_Info_To_Add_Item_iP_SecTransportLayerAddress,
        _Transport_UP_Layer_Addresses_Info_To_Add_Item_gTPTransportLayerAddressesToAdd,
        ____Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__id_tab,
        ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__id,
        ____Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__criticality_tab,
        ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__criticality,
        ____Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__extensionValue_tab,
        ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__extensionValue,
        __Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item_,
        _Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions,
        Transport_UP_Layer_Addresses_Info_To_Add_Item,
        Transport_UP_Layer_Addresses_Info_To_Add_ItemExtIEs,
        _Transport_UP_Layer_Addresses_Info_To_Remove_List__item_,
        Transport_UP_Layer_Addresses_Info_To_Remove_List,
        _Transport_UP_Layer_Addresses_Info_To_Remove_Item_iP_SecTransportLayerAddress,
        _Transport_UP_Layer_Addresses_Info_To_Remove_Item_gTPTransportLayerAddressesToRemove,
        ____Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__id_tab,
        ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__id,
        ____Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__criticality_tab,
        ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__criticality,
        ____Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__extensionValue_tab,
        ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__extensionValue,
        __Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item_,
        _Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions,
        Transport_UP_Layer_Addresses_Info_To_Remove_Item,
        Transport_UP_Layer_Addresses_Info_To_Remove_ItemExtIEs,
        _UDC_Parameters_bufferSize,
        _UDC_Parameters_dictionary,
        _UDC_Parameters_continueUDC,
        ____UDC_Parameters_iE_Extensions__item__id_tab,
        ___UDC_Parameters_iE_Extensions__item__id,
        ____UDC_Parameters_iE_Extensions__item__criticality_tab,
        ___UDC_Parameters_iE_Extensions__item__criticality,
        ____UDC_Parameters_iE_Extensions__item__extensionValue_tab,
        ___UDC_Parameters_iE_Extensions__item__extensionValue,
        __UDC_Parameters_iE_Extensions__item_,
        _UDC_Parameters_iE_Extensions,
        UDC_Parameters,
        UDC_Parameters_ExtIEs,
        UE_Activity,
        _UE_associatedLogicalE1_ConnectionItem_gNB_CU_CP_UE_E1AP_ID,
        _UE_associatedLogicalE1_ConnectionItem_gNB_CU_UP_UE_E1AP_ID,
        ____UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__id_tab,
        ___UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__id,
        ____UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__criticality_tab,
        ___UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__criticality,
        ____UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__extensionValue_tab,
        ___UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item__extensionValue,
        __UE_associatedLogicalE1_ConnectionItem_iE_Extensions__item_,
        _UE_associatedLogicalE1_ConnectionItem_iE_Extensions,
        UE_associatedLogicalE1_ConnectionItem,
        UE_associatedLogicalE1_ConnectionItemExtIEs,
        _UESliceMaximumBitRateList__item_,
        UESliceMaximumBitRateList,
        _UESliceMaximumBitRateItem_sNSSAI,
        _UESliceMaximumBitRateItem_uESliceMaximumBitRateDL,
        ____UESliceMaximumBitRateItem_iE_Extensions__item__id_tab,
        ___UESliceMaximumBitRateItem_iE_Extensions__item__id,
        ____UESliceMaximumBitRateItem_iE_Extensions__item__criticality_tab,
        ___UESliceMaximumBitRateItem_iE_Extensions__item__criticality,
        ____UESliceMaximumBitRateItem_iE_Extensions__item__extensionValue_tab,
        ___UESliceMaximumBitRateItem_iE_Extensions__item__extensionValue,
        __UESliceMaximumBitRateItem_iE_Extensions__item_,
        _UESliceMaximumBitRateItem_iE_Extensions,
        UESliceMaximumBitRateItem,
        UESliceMaximumBitRateItem_ExtIEs,
        UL_Configuration,
        _ULUPTNLAddressToUpdateItem_oldTNLAdress,
        _ULUPTNLAddressToUpdateItem_newTNLAdress,
        ____ULUPTNLAddressToUpdateItem_iE_Extensions__item__id_tab,
        ___ULUPTNLAddressToUpdateItem_iE_Extensions__item__id,
        ____ULUPTNLAddressToUpdateItem_iE_Extensions__item__criticality_tab,
        ___ULUPTNLAddressToUpdateItem_iE_Extensions__item__criticality,
        ____ULUPTNLAddressToUpdateItem_iE_Extensions__item__extensionValue_tab,
        ___ULUPTNLAddressToUpdateItem_iE_Extensions__item__extensionValue,
        __ULUPTNLAddressToUpdateItem_iE_Extensions__item_,
        _ULUPTNLAddressToUpdateItem_iE_Extensions,
        ULUPTNLAddressToUpdateItem,
        ULUPTNLAddressToUpdateItemExtIEs,
        ULDataSplitThreshold,
        _UP_Parameters__item_,
        UP_Parameters,
        _UP_Parameters_Item_uP_TNL_Information,
        _UP_Parameters_Item_cell_Group_ID,
        ____UP_Parameters_Item_iE_Extensions__item__id_tab,
        _____UP_Parameters_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___UP_Parameters_Item_iE_Extensions__item__id,
        ___UP_Parameters_Item_iE_Extensions__item__criticality,
        ___UP_Parameters_Item_iE_Extensions__item__extensionValue,
        __UP_Parameters_Item_iE_Extensions__item_,
        _UP_Parameters_Item_iE_Extensions,
        UP_Parameters_Item,
        UP_Parameters_Item_ExtIEs,
        _UP_Parameters_Item_ExtIEs_val_Extension_0,
        _UPSecuritykey_encryptionKey,
        _UPSecuritykey_integrityProtectionKey,
        ____UPSecuritykey_iE_Extensions__item__id_tab,
        ___UPSecuritykey_iE_Extensions__item__id,
        ____UPSecuritykey_iE_Extensions__item__criticality_tab,
        ___UPSecuritykey_iE_Extensions__item__criticality,
        ____UPSecuritykey_iE_Extensions__item__extensionValue_tab,
        ___UPSecuritykey_iE_Extensions__item__extensionValue,
        __UPSecuritykey_iE_Extensions__item_,
        _UPSecuritykey_iE_Extensions,
        UPSecuritykey,
        UPSecuritykey_ExtIEs,
        _UP_TNL_Information_gTPTunnel,
        ___UP_TNL_Information_choice_extension_id_tab,
        __UP_TNL_Information_choice_extension_id,
        ___UP_TNL_Information_choice_extension_criticality_tab,
        __UP_TNL_Information_choice_extension_criticality,
        ___UP_TNL_Information_choice_extension_value_tab,
        __UP_TNL_Information_choice_extension_value,
        _UP_TNL_Information_choice_extension,
        UP_TNL_Information,
        UP_TNL_Information_ExtIEs,
        _UplinkOnlyROHC_maxCID,
        _UplinkOnlyROHC_rOHC_Profiles,
        _UplinkOnlyROHC_continueROHC,
        ____UplinkOnlyROHC_iE_Extensions__item__id_tab,
        ___UplinkOnlyROHC_iE_Extensions__item__id,
        ____UplinkOnlyROHC_iE_Extensions__item__criticality_tab,
        ___UplinkOnlyROHC_iE_Extensions__item__criticality,
        ____UplinkOnlyROHC_iE_Extensions__item__extensionValue_tab,
        ___UplinkOnlyROHC_iE_Extensions__item__extensionValue,
        __UplinkOnlyROHC_iE_Extensions__item_,
        _UplinkOnlyROHC_iE_Extensions,
        UplinkOnlyROHC,
        UplinkOnlyROHC_ExtIEs,
        URIaddress,
    ]

class E1AP_PDU_Contents:

    _name_  = 'E1AP-PDU-Contents'
    _oid_   = [0, 4, 0, 0, 22, 3, 5, 1, 1]
    
    _obj_ = [
        'Reset',
        'ResetIEs',
        'ResetType',
        'ResetType-ExtIEs',
        'ResetAll',
        'UE-associatedLogicalE1-ConnectionListRes',
        'UE-associatedLogicalE1-ConnectionItemRes',
        'ResetAcknowledge',
        'ResetAcknowledgeIEs',
        'UE-associatedLogicalE1-ConnectionListResAck',
        'UE-associatedLogicalE1-ConnectionItemResAck',
        'ErrorIndication',
        'ErrorIndication-IEs',
        'GNB-CU-UP-E1SetupRequest',
        'GNB-CU-UP-E1SetupRequestIEs',
        'SupportedPLMNs-List',
        'SupportedPLMNs-Item',
        'SupportedPLMNs-ExtIEs',
        'GNB-CU-UP-E1SetupResponse',
        'GNB-CU-UP-E1SetupResponseIEs',
        'GNB-CU-UP-E1SetupFailure',
        'GNB-CU-UP-E1SetupFailureIEs',
        'GNB-CU-CP-E1SetupRequest',
        'GNB-CU-CP-E1SetupRequestIEs',
        'GNB-CU-CP-E1SetupResponse',
        'GNB-CU-CP-E1SetupResponseIEs',
        'GNB-CU-CP-E1SetupFailure',
        'GNB-CU-CP-E1SetupFailureIEs',
        'GNB-CU-UP-ConfigurationUpdate',
        'GNB-CU-UP-ConfigurationUpdateIEs',
        'GNB-CU-UP-TNLA-To-Remove-List',
        'GNB-CU-UP-ConfigurationUpdateAcknowledge',
        'GNB-CU-UP-ConfigurationUpdateAcknowledgeIEs',
        'GNB-CU-UP-ConfigurationUpdateFailure',
        'GNB-CU-UP-ConfigurationUpdateFailureIEs',
        'GNB-CU-CP-ConfigurationUpdate',
        'GNB-CU-CP-ConfigurationUpdateIEs',
        'GNB-CU-CP-TNLA-To-Add-List',
        'GNB-CU-CP-TNLA-To-Remove-List',
        'GNB-CU-CP-TNLA-To-Update-List',
        'GNB-CU-CP-ConfigurationUpdateAcknowledge',
        'GNB-CU-CP-ConfigurationUpdateAcknowledgeIEs',
        'GNB-CU-CP-TNLA-Setup-List',
        'GNB-CU-CP-TNLA-Failed-To-Setup-List',
        'GNB-CU-CP-ConfigurationUpdateFailure',
        'GNB-CU-CP-ConfigurationUpdateFailureIEs',
        'E1ReleaseRequest',
        'E1ReleaseRequestIEs',
        'E1ReleaseResponse',
        'E1ReleaseResponseIEs',
        'BearerContextSetupRequest',
        'BearerContextSetupRequestIEs',
        'System-BearerContextSetupRequest',
        'System-BearerContextSetupRequest-ExtIEs',
        'EUTRAN-BearerContextSetupRequest',
        'NG-RAN-BearerContextSetupRequest',
        'BearerContextSetupResponse',
        'BearerContextSetupResponseIEs',
        'System-BearerContextSetupResponse',
        'System-BearerContextSetupResponse-ExtIEs',
        'EUTRAN-BearerContextSetupResponse',
        'NG-RAN-BearerContextSetupResponse',
        'BearerContextSetupFailure',
        'BearerContextSetupFailureIEs',
        'BearerContextModificationRequest',
        'BearerContextModificationRequestIEs',
        'System-BearerContextModificationRequest',
        'System-BearerContextModificationRequest-ExtIEs',
        'EUTRAN-BearerContextModificationRequest',
        'NG-RAN-BearerContextModificationRequest',
        'BearerContextModificationResponse',
        'BearerContextModificationResponseIEs',
        'System-BearerContextModificationResponse',
        'System-BearerContextModificationResponse-ExtIEs',
        'EUTRAN-BearerContextModificationResponse',
        'NG-RAN-BearerContextModificationResponse',
        'BearerContextModificationFailure',
        'BearerContextModificationFailureIEs',
        'BearerContextModificationRequired',
        'BearerContextModificationRequiredIEs',
        'System-BearerContextModificationRequired',
        'System-BearerContextModificationRequired-ExtIEs',
        'EUTRAN-BearerContextModificationRequired',
        'NG-RAN-BearerContextModificationRequired',
        'BearerContextModificationConfirm',
        'BearerContextModificationConfirmIEs',
        'System-BearerContextModificationConfirm',
        'System-BearerContextModificationConfirm-ExtIEs',
        'EUTRAN-BearerContextModificationConfirm',
        'NG-RAN-BearerContextModificationConfirm',
        'BearerContextReleaseCommand',
        'BearerContextReleaseCommandIEs',
        'BearerContextReleaseComplete',
        'BearerContextReleaseCompleteIEs',
        'BearerContextReleaseRequest',
        'BearerContextReleaseRequestIEs',
        'DRB-Status-List',
        'BearerContextInactivityNotification',
        'BearerContextInactivityNotificationIEs',
        'DLDataNotification',
        'DLDataNotificationIEs',
        'ULDataNotification',
        'ULDataNotificationIEs',
        'DataUsageReport',
        'DataUsageReportIEs',
        'GNB-CU-UP-CounterCheckRequest',
        'GNB-CU-UP-CounterCheckRequestIEs',
        'System-GNB-CU-UP-CounterCheckRequest',
        'System-GNB-CU-UP-CounterCheckRequest-ExtIEs',
        'EUTRAN-GNB-CU-UP-CounterCheckRequest',
        'NG-RAN-GNB-CU-UP-CounterCheckRequest',
        'GNB-CU-UP-StatusIndication',
        'GNB-CU-UP-StatusIndicationIEs',
        'GNB-CU-CPMeasurementResultsInformation',
        'GNB-CU-CPMeasurementResultsInformationIEs',
        'MRDC-DataUsageReport',
        'MRDC-DataUsageReportIEs',
        'TraceStart',
        'TraceStartIEs',
        'DeactivateTrace',
        'DeactivateTraceIEs',
        'CellTrafficTrace',
        'CellTrafficTraceIEs',
        'PrivateMessage',
        'PrivateMessage-IEs',
        'ResourceStatusRequest',
        'ResourceStatusRequestIEs',
        'ResourceStatusResponse',
        'ResourceStatusResponseIEs',
        'ResourceStatusFailure',
        'ResourceStatusFailureIEs',
        'ResourceStatusUpdate',
        'ResourceStatusUpdateIEs',
        'IAB-UPTNLAddressUpdate',
        'IAB-UPTNLAddressUpdateIEs',
        'DLUPTNLAddressToUpdateList',
        'IAB-UPTNLAddressUpdateAcknowledge',
        'IAB-UPTNLAddressUpdateAcknowledgeIEs',
        'ULUPTNLAddressToUpdateList',
        'IAB-UPTNLAddressUpdateFailure',
        'IAB-UPTNLAddressUpdateFailureIEs',
        'EarlyForwardingSNTransfer',
        'EarlyForwardingSNTransferIEs',
        'IABPSKNotification',
        'IABPSKNotificationIEs',
        'IAB-Donor-CU-UPPSKInfo',
        'BCBearerContextSetupRequest',
        'BCBearerContextSetupRequestIEs',
        'BCBearerContextSetupResponse',
        'BCBearerContextSetupResponseIEs',
        'BCBearerContextSetupFailure',
        'BCBearerContextSetupFailureIEs',
        'BCBearerContextModificationRequest',
        'BCBearerContextModificationRequestIEs',
        'BCBearerContextModificationResponse',
        'BCBearerContextModificationResponseIEs',
        'BCBearerContextModificationFailure',
        'BCBearerContextModificationFailureIEs',
        'BCBearerContextModificationRequired',
        'BCBearerContextModificationRequiredIEs',
        'BCBearerContextModificationConfirm',
        'BCBearerContextModificationConfirmIEs',
        'BCBearerContextReleaseCommand',
        'BCBearerContextReleaseCommandIEs',
        'BCBearerContextReleaseComplete',
        'BCBearerContextReleaseCompleteIEs',
        'BCBearerContextReleaseRequest',
        'BCBearerContextReleaseRequestIEs',
        'MCBearerContextSetupRequest',
        'MCBearerContextSetupRequestIEs',
        'MCBearerContextSetupResponse',
        'MCBearerContextSetupResponseIEs',
        'MCBearerContextSetupFailure',
        'MCBearerContextSetupFailureIEs',
        'MCBearerContextModificationRequest',
        'MCBearerContextModificationRequestIEs',
        'MCBearerContextModificationResponse',
        'MCBearerContextModificationResponseIEs',
        'MCBearerContextModificationFailure',
        'MCBearerContextModificationFailureIEs',
        'MCBearerContextModificationRequired',
        'MCBearerContextModificationRequiredIEs',
        'MCBearerContextModificationConfirm',
        'MCBearerContextModificationConfirmIEs',
        'MCBearerContextReleaseCommand',
        'MCBearerContextReleaseCommandIEs',
        'MCBearerContextReleaseComplete',
        'MCBearerContextReleaseCompleteIEs',
        'MCBearerContextReleaseRequest',
        'MCBearerContextReleaseRequestIEs',
        ]
    _type_ = [
        'Reset',
        'ResetType',
        'ResetAll',
        'UE-associatedLogicalE1-ConnectionListRes',
        'ResetAcknowledge',
        'UE-associatedLogicalE1-ConnectionListResAck',
        'ErrorIndication',
        'GNB-CU-UP-E1SetupRequest',
        'SupportedPLMNs-List',
        'SupportedPLMNs-Item',
        'GNB-CU-UP-E1SetupResponse',
        'GNB-CU-UP-E1SetupFailure',
        'GNB-CU-CP-E1SetupRequest',
        'GNB-CU-CP-E1SetupResponse',
        'GNB-CU-CP-E1SetupFailure',
        'GNB-CU-UP-ConfigurationUpdate',
        'GNB-CU-UP-TNLA-To-Remove-List',
        'GNB-CU-UP-ConfigurationUpdateAcknowledge',
        'GNB-CU-UP-ConfigurationUpdateFailure',
        'GNB-CU-CP-ConfigurationUpdate',
        'GNB-CU-CP-TNLA-To-Add-List',
        'GNB-CU-CP-TNLA-To-Remove-List',
        'GNB-CU-CP-TNLA-To-Update-List',
        'GNB-CU-CP-ConfigurationUpdateAcknowledge',
        'GNB-CU-CP-TNLA-Setup-List',
        'GNB-CU-CP-TNLA-Failed-To-Setup-List',
        'GNB-CU-CP-ConfigurationUpdateFailure',
        'E1ReleaseRequest',
        'E1ReleaseResponse',
        'BearerContextSetupRequest',
        'System-BearerContextSetupRequest',
        'BearerContextSetupResponse',
        'System-BearerContextSetupResponse',
        'BearerContextSetupFailure',
        'BearerContextModificationRequest',
        'System-BearerContextModificationRequest',
        'BearerContextModificationResponse',
        'System-BearerContextModificationResponse',
        'BearerContextModificationFailure',
        'BearerContextModificationRequired',
        'System-BearerContextModificationRequired',
        'BearerContextModificationConfirm',
        'System-BearerContextModificationConfirm',
        'BearerContextReleaseCommand',
        'BearerContextReleaseComplete',
        'BearerContextReleaseRequest',
        'DRB-Status-List',
        'BearerContextInactivityNotification',
        'DLDataNotification',
        'ULDataNotification',
        'DataUsageReport',
        'GNB-CU-UP-CounterCheckRequest',
        'System-GNB-CU-UP-CounterCheckRequest',
        'GNB-CU-UP-StatusIndication',
        'GNB-CU-CPMeasurementResultsInformation',
        'MRDC-DataUsageReport',
        'TraceStart',
        'DeactivateTrace',
        'CellTrafficTrace',
        'PrivateMessage',
        'ResourceStatusRequest',
        'ResourceStatusResponse',
        'ResourceStatusFailure',
        'ResourceStatusUpdate',
        'IAB-UPTNLAddressUpdate',
        'DLUPTNLAddressToUpdateList',
        'IAB-UPTNLAddressUpdateAcknowledge',
        'ULUPTNLAddressToUpdateList',
        'IAB-UPTNLAddressUpdateFailure',
        'EarlyForwardingSNTransfer',
        'IABPSKNotification',
        'IAB-Donor-CU-UPPSKInfo',
        'BCBearerContextSetupRequest',
        'BCBearerContextSetupResponse',
        'BCBearerContextSetupFailure',
        'BCBearerContextModificationRequest',
        'BCBearerContextModificationResponse',
        'BCBearerContextModificationFailure',
        'BCBearerContextModificationRequired',
        'BCBearerContextModificationConfirm',
        'BCBearerContextReleaseCommand',
        'BCBearerContextReleaseComplete',
        'BCBearerContextReleaseRequest',
        'MCBearerContextSetupRequest',
        'MCBearerContextSetupResponse',
        'MCBearerContextSetupFailure',
        'MCBearerContextModificationRequest',
        'MCBearerContextModificationResponse',
        'MCBearerContextModificationFailure',
        'MCBearerContextModificationRequired',
        'MCBearerContextModificationConfirm',
        'MCBearerContextReleaseCommand',
        'MCBearerContextReleaseComplete',
        'MCBearerContextReleaseRequest',
        ]
    _set_ = [
        'ResetIEs',
        'ResetType-ExtIEs',
        'UE-associatedLogicalE1-ConnectionItemRes',
        'ResetAcknowledgeIEs',
        'UE-associatedLogicalE1-ConnectionItemResAck',
        'ErrorIndication-IEs',
        'GNB-CU-UP-E1SetupRequestIEs',
        'SupportedPLMNs-ExtIEs',
        'GNB-CU-UP-E1SetupResponseIEs',
        'GNB-CU-UP-E1SetupFailureIEs',
        'GNB-CU-CP-E1SetupRequestIEs',
        'GNB-CU-CP-E1SetupResponseIEs',
        'GNB-CU-CP-E1SetupFailureIEs',
        'GNB-CU-UP-ConfigurationUpdateIEs',
        'GNB-CU-UP-ConfigurationUpdateAcknowledgeIEs',
        'GNB-CU-UP-ConfigurationUpdateFailureIEs',
        'GNB-CU-CP-ConfigurationUpdateIEs',
        'GNB-CU-CP-ConfigurationUpdateAcknowledgeIEs',
        'GNB-CU-CP-ConfigurationUpdateFailureIEs',
        'E1ReleaseRequestIEs',
        'E1ReleaseResponseIEs',
        'BearerContextSetupRequestIEs',
        'System-BearerContextSetupRequest-ExtIEs',
        'EUTRAN-BearerContextSetupRequest',
        'NG-RAN-BearerContextSetupRequest',
        'BearerContextSetupResponseIEs',
        'System-BearerContextSetupResponse-ExtIEs',
        'EUTRAN-BearerContextSetupResponse',
        'NG-RAN-BearerContextSetupResponse',
        'BearerContextSetupFailureIEs',
        'BearerContextModificationRequestIEs',
        'System-BearerContextModificationRequest-ExtIEs',
        'EUTRAN-BearerContextModificationRequest',
        'NG-RAN-BearerContextModificationRequest',
        'BearerContextModificationResponseIEs',
        'System-BearerContextModificationResponse-ExtIEs',
        'EUTRAN-BearerContextModificationResponse',
        'NG-RAN-BearerContextModificationResponse',
        'BearerContextModificationFailureIEs',
        'BearerContextModificationRequiredIEs',
        'System-BearerContextModificationRequired-ExtIEs',
        'EUTRAN-BearerContextModificationRequired',
        'NG-RAN-BearerContextModificationRequired',
        'BearerContextModificationConfirmIEs',
        'System-BearerContextModificationConfirm-ExtIEs',
        'EUTRAN-BearerContextModificationConfirm',
        'NG-RAN-BearerContextModificationConfirm',
        'BearerContextReleaseCommandIEs',
        'BearerContextReleaseCompleteIEs',
        'BearerContextReleaseRequestIEs',
        'BearerContextInactivityNotificationIEs',
        'DLDataNotificationIEs',
        'ULDataNotificationIEs',
        'DataUsageReportIEs',
        'GNB-CU-UP-CounterCheckRequestIEs',
        'System-GNB-CU-UP-CounterCheckRequest-ExtIEs',
        'EUTRAN-GNB-CU-UP-CounterCheckRequest',
        'NG-RAN-GNB-CU-UP-CounterCheckRequest',
        'GNB-CU-UP-StatusIndicationIEs',
        'GNB-CU-CPMeasurementResultsInformationIEs',
        'MRDC-DataUsageReportIEs',
        'TraceStartIEs',
        'DeactivateTraceIEs',
        'CellTrafficTraceIEs',
        'PrivateMessage-IEs',
        'ResourceStatusRequestIEs',
        'ResourceStatusResponseIEs',
        'ResourceStatusFailureIEs',
        'ResourceStatusUpdateIEs',
        'IAB-UPTNLAddressUpdateIEs',
        'IAB-UPTNLAddressUpdateAcknowledgeIEs',
        'IAB-UPTNLAddressUpdateFailureIEs',
        'EarlyForwardingSNTransferIEs',
        'IABPSKNotificationIEs',
        'BCBearerContextSetupRequestIEs',
        'BCBearerContextSetupResponseIEs',
        'BCBearerContextSetupFailureIEs',
        'BCBearerContextModificationRequestIEs',
        'BCBearerContextModificationResponseIEs',
        'BCBearerContextModificationFailureIEs',
        'BCBearerContextModificationRequiredIEs',
        'BCBearerContextModificationConfirmIEs',
        'BCBearerContextReleaseCommandIEs',
        'BCBearerContextReleaseCompleteIEs',
        'BCBearerContextReleaseRequestIEs',
        'MCBearerContextSetupRequestIEs',
        'MCBearerContextSetupResponseIEs',
        'MCBearerContextSetupFailureIEs',
        'MCBearerContextModificationRequestIEs',
        'MCBearerContextModificationResponseIEs',
        'MCBearerContextModificationFailureIEs',
        'MCBearerContextModificationRequiredIEs',
        'MCBearerContextModificationConfirmIEs',
        'MCBearerContextReleaseCommandIEs',
        'MCBearerContextReleaseCompleteIEs',
        'MCBearerContextReleaseRequestIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        'ResetIEs',
        'ResetType-ExtIEs',
        'UE-associatedLogicalE1-ConnectionItemRes',
        'ResetAcknowledgeIEs',
        'UE-associatedLogicalE1-ConnectionItemResAck',
        'ErrorIndication-IEs',
        'GNB-CU-UP-E1SetupRequestIEs',
        'SupportedPLMNs-ExtIEs',
        'GNB-CU-UP-E1SetupResponseIEs',
        'GNB-CU-UP-E1SetupFailureIEs',
        'GNB-CU-CP-E1SetupRequestIEs',
        'GNB-CU-CP-E1SetupResponseIEs',
        'GNB-CU-CP-E1SetupFailureIEs',
        'GNB-CU-UP-ConfigurationUpdateIEs',
        'GNB-CU-UP-ConfigurationUpdateAcknowledgeIEs',
        'GNB-CU-UP-ConfigurationUpdateFailureIEs',
        'GNB-CU-CP-ConfigurationUpdateIEs',
        'GNB-CU-CP-ConfigurationUpdateAcknowledgeIEs',
        'GNB-CU-CP-ConfigurationUpdateFailureIEs',
        'E1ReleaseRequestIEs',
        'E1ReleaseResponseIEs',
        'BearerContextSetupRequestIEs',
        'System-BearerContextSetupRequest-ExtIEs',
        'EUTRAN-BearerContextSetupRequest',
        'NG-RAN-BearerContextSetupRequest',
        'BearerContextSetupResponseIEs',
        'System-BearerContextSetupResponse-ExtIEs',
        'EUTRAN-BearerContextSetupResponse',
        'NG-RAN-BearerContextSetupResponse',
        'BearerContextSetupFailureIEs',
        'BearerContextModificationRequestIEs',
        'System-BearerContextModificationRequest-ExtIEs',
        'EUTRAN-BearerContextModificationRequest',
        'NG-RAN-BearerContextModificationRequest',
        'BearerContextModificationResponseIEs',
        'System-BearerContextModificationResponse-ExtIEs',
        'EUTRAN-BearerContextModificationResponse',
        'NG-RAN-BearerContextModificationResponse',
        'BearerContextModificationFailureIEs',
        'BearerContextModificationRequiredIEs',
        'System-BearerContextModificationRequired-ExtIEs',
        'EUTRAN-BearerContextModificationRequired',
        'NG-RAN-BearerContextModificationRequired',
        'BearerContextModificationConfirmIEs',
        'System-BearerContextModificationConfirm-ExtIEs',
        'EUTRAN-BearerContextModificationConfirm',
        'NG-RAN-BearerContextModificationConfirm',
        'BearerContextReleaseCommandIEs',
        'BearerContextReleaseCompleteIEs',
        'BearerContextReleaseRequestIEs',
        'BearerContextInactivityNotificationIEs',
        'DLDataNotificationIEs',
        'ULDataNotificationIEs',
        'DataUsageReportIEs',
        'GNB-CU-UP-CounterCheckRequestIEs',
        'System-GNB-CU-UP-CounterCheckRequest-ExtIEs',
        'EUTRAN-GNB-CU-UP-CounterCheckRequest',
        'NG-RAN-GNB-CU-UP-CounterCheckRequest',
        'GNB-CU-UP-StatusIndicationIEs',
        'GNB-CU-CPMeasurementResultsInformationIEs',
        'MRDC-DataUsageReportIEs',
        'TraceStartIEs',
        'DeactivateTraceIEs',
        'CellTrafficTraceIEs',
        'PrivateMessage-IEs',
        'ResourceStatusRequestIEs',
        'ResourceStatusResponseIEs',
        'ResourceStatusFailureIEs',
        'ResourceStatusUpdateIEs',
        'IAB-UPTNLAddressUpdateIEs',
        'IAB-UPTNLAddressUpdateAcknowledgeIEs',
        'IAB-UPTNLAddressUpdateFailureIEs',
        'EarlyForwardingSNTransferIEs',
        'IABPSKNotificationIEs',
        'BCBearerContextSetupRequestIEs',
        'BCBearerContextSetupResponseIEs',
        'BCBearerContextSetupFailureIEs',
        'BCBearerContextModificationRequestIEs',
        'BCBearerContextModificationResponseIEs',
        'BCBearerContextModificationFailureIEs',
        'BCBearerContextModificationRequiredIEs',
        'BCBearerContextModificationConfirmIEs',
        'BCBearerContextReleaseCommandIEs',
        'BCBearerContextReleaseCompleteIEs',
        'BCBearerContextReleaseRequestIEs',
        'MCBearerContextSetupRequestIEs',
        'MCBearerContextSetupResponseIEs',
        'MCBearerContextSetupFailureIEs',
        'MCBearerContextModificationRequestIEs',
        'MCBearerContextModificationResponseIEs',
        'MCBearerContextModificationFailureIEs',
        'MCBearerContextModificationRequiredIEs',
        'MCBearerContextModificationConfirmIEs',
        'MCBearerContextReleaseCommandIEs',
        'MCBearerContextReleaseCompleteIEs',
        'MCBearerContextReleaseRequestIEs',
        ]
    _param_ = [
        ]
    
    #-----< Reset >-----#
    Reset = SEQ(name='Reset', mode=MODE_TYPE)
    _Reset_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __Reset_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___Reset_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____Reset_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____Reset_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____Reset_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _____Reset_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResetType')))
    ____Reset_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____Reset_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____Reset_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'reject'), ('Value', _____Reset_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___Reset_protocolIEs__item__id._const_tab = ____Reset_protocolIEs__item__id_tab
    ___Reset_protocolIEs__item__id._const_tab_at = None
    ___Reset_protocolIEs__item__id._const_tab_id = 'id'
    ___Reset_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___Reset_protocolIEs__item__criticality._const_tab = ____Reset_protocolIEs__item__id_tab
    ___Reset_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___Reset_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___Reset_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___Reset_protocolIEs__item__value._const_tab = ____Reset_protocolIEs__item__id_tab
    ___Reset_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___Reset_protocolIEs__item__value._const_tab_id = 'Value'
    __Reset_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___Reset_protocolIEs__item__id),
        ('criticality', ___Reset_protocolIEs__item__criticality),
        ('value', ___Reset_protocolIEs__item__value),
        ])
    __Reset_protocolIEs__item_._ext = None
    _Reset_protocolIEs._cont = __Reset_protocolIEs__item_
    _Reset_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    Reset._cont = ASN1Dict([
        ('protocolIEs', _Reset_protocolIEs),
        ])
    Reset._ext = []
    
    #-----< ResetIEs >-----#
    ResetIEs = CLASS(name='ResetIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _ResetIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _ResetIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _ResetIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResetType')))
    ResetIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _ResetIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _ResetIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'reject'), ('Value', _ResetIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ResetType >-----#
    ResetType = CHOICE(name='ResetType', mode=MODE_TYPE)
    _ResetType_e1_Interface = ENUM(name='e1-Interface', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResetAll')))
    _ResetType_partOfE1_Interface = SEQ_OF(name='partOfE1-Interface', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-PDU-Contents', 'UE-associatedLogicalE1-ConnectionListRes')))
    _ResetType_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __ResetType_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___ResetType_choice_extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___ResetType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResetType_choice_extension_id._const_tab = ___ResetType_choice_extension_id_tab
    __ResetType_choice_extension_id._const_tab_at = None
    __ResetType_choice_extension_id._const_tab_id = 'id'
    __ResetType_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___ResetType_choice_extension_criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___ResetType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResetType_choice_extension_criticality._const_tab = ___ResetType_choice_extension_criticality_tab
    __ResetType_choice_extension_criticality._const_tab_at = ('..', 'id')
    __ResetType_choice_extension_criticality._const_tab_id = 'criticality'
    __ResetType_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___ResetType_choice_extension_value_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___ResetType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResetType_choice_extension_value._const_tab = ___ResetType_choice_extension_value_tab
    __ResetType_choice_extension_value._const_tab_at = ('..', 'id')
    __ResetType_choice_extension_value._const_tab_id = 'Value'
    _ResetType_choice_extension._cont = ASN1Dict([
        ('id', __ResetType_choice_extension_id),
        ('criticality', __ResetType_choice_extension_criticality),
        ('value', __ResetType_choice_extension_value),
        ])
    _ResetType_choice_extension._ext = None
    ResetType._cont = ASN1Dict([
        ('e1-Interface', _ResetType_e1_Interface),
        ('partOfE1-Interface', _ResetType_partOfE1_Interface),
        ('choice-extension', _ResetType_choice_extension),
        ])
    ResetType._ext = None
    
    #-----< ResetType-ExtIEs >-----#
    ResetType_ExtIEs = CLASS(name='ResetType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ResetType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResetAll >-----#
    ResetAll = ENUM(name='ResetAll', mode=MODE_TYPE)
    ResetAll._cont = ASN1Dict([('reset-all', 0)])
    ResetAll._ext = []
    
    #-----< UE-associatedLogicalE1-ConnectionListRes >-----#
    UE_associatedLogicalE1_ConnectionListRes = SEQ_OF(name='UE-associatedLogicalE1-ConnectionListRes', mode=MODE_TYPE)
    _UE_associatedLogicalE1_ConnectionListRes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UE_associatedLogicalE1_ConnectionListRes__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___UE_associatedLogicalE1_ConnectionListRes__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ____UE_associatedLogicalE1_ConnectionListRes__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UE-associatedLogicalE1-ConnectionItem')))
    ___UE_associatedLogicalE1_ConnectionListRes__item__id_tab._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'reject'), ('Value', ____UE_associatedLogicalE1_ConnectionListRes__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __UE_associatedLogicalE1_ConnectionListRes__item__id._const_tab = ___UE_associatedLogicalE1_ConnectionListRes__item__id_tab
    __UE_associatedLogicalE1_ConnectionListRes__item__id._const_tab_at = None
    __UE_associatedLogicalE1_ConnectionListRes__item__id._const_tab_id = 'id'
    __UE_associatedLogicalE1_ConnectionListRes__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    __UE_associatedLogicalE1_ConnectionListRes__item__criticality._const_tab = ___UE_associatedLogicalE1_ConnectionListRes__item__id_tab
    __UE_associatedLogicalE1_ConnectionListRes__item__criticality._const_tab_at = ('..', 'id')
    __UE_associatedLogicalE1_ConnectionListRes__item__criticality._const_tab_id = 'criticality'
    __UE_associatedLogicalE1_ConnectionListRes__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    __UE_associatedLogicalE1_ConnectionListRes__item__value._const_tab = ___UE_associatedLogicalE1_ConnectionListRes__item__id_tab
    __UE_associatedLogicalE1_ConnectionListRes__item__value._const_tab_at = ('..', 'id')
    __UE_associatedLogicalE1_ConnectionListRes__item__value._const_tab_id = 'Value'
    _UE_associatedLogicalE1_ConnectionListRes__item_._cont = ASN1Dict([
        ('id', __UE_associatedLogicalE1_ConnectionListRes__item__id),
        ('criticality', __UE_associatedLogicalE1_ConnectionListRes__item__criticality),
        ('value', __UE_associatedLogicalE1_ConnectionListRes__item__value),
        ])
    _UE_associatedLogicalE1_ConnectionListRes__item_._ext = None
    UE_associatedLogicalE1_ConnectionListRes._cont = _UE_associatedLogicalE1_ConnectionListRes__item_
    UE_associatedLogicalE1_ConnectionListRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< UE-associatedLogicalE1-ConnectionItemRes >-----#
    UE_associatedLogicalE1_ConnectionItemRes = CLASS(name='UE-associatedLogicalE1-ConnectionItemRes', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _UE_associatedLogicalE1_ConnectionItemRes_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UE-associatedLogicalE1-ConnectionItem')))
    UE_associatedLogicalE1_ConnectionItemRes._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'reject'), ('Value', _UE_associatedLogicalE1_ConnectionItemRes_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ResetAcknowledge >-----#
    ResetAcknowledge = SEQ(name='ResetAcknowledge', mode=MODE_TYPE)
    _ResetAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __ResetAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___ResetAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____ResetAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'UE-associatedLogicalE1-ConnectionListResAck')))
    _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____ResetAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'ignore'), ('Value', _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResetAcknowledge_protocolIEs__item__id._const_tab = ____ResetAcknowledge_protocolIEs__item__id_tab
    ___ResetAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___ResetAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___ResetAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___ResetAcknowledge_protocolIEs__item__criticality._const_tab = ____ResetAcknowledge_protocolIEs__item__id_tab
    ___ResetAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ResetAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ResetAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___ResetAcknowledge_protocolIEs__item__value._const_tab = ____ResetAcknowledge_protocolIEs__item__id_tab
    ___ResetAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ResetAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __ResetAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ResetAcknowledge_protocolIEs__item__id),
        ('criticality', ___ResetAcknowledge_protocolIEs__item__criticality),
        ('value', ___ResetAcknowledge_protocolIEs__item__value),
        ])
    __ResetAcknowledge_protocolIEs__item_._ext = None
    _ResetAcknowledge_protocolIEs._cont = __ResetAcknowledge_protocolIEs__item_
    _ResetAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResetAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _ResetAcknowledge_protocolIEs),
        ])
    ResetAcknowledge._ext = []
    
    #-----< ResetAcknowledgeIEs >-----#
    ResetAcknowledgeIEs = CLASS(name='ResetAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _ResetAcknowledgeIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _ResetAcknowledgeIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'UE-associatedLogicalE1-ConnectionListResAck')))
    _ResetAcknowledgeIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ResetAcknowledgeIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _ResetAcknowledgeIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'ignore'), ('Value', _ResetAcknowledgeIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _ResetAcknowledgeIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UE-associatedLogicalE1-ConnectionListResAck >-----#
    UE_associatedLogicalE1_ConnectionListResAck = SEQ_OF(name='UE-associatedLogicalE1-ConnectionListResAck', mode=MODE_TYPE)
    _UE_associatedLogicalE1_ConnectionListResAck__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UE_associatedLogicalE1_ConnectionListResAck__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___UE_associatedLogicalE1_ConnectionListResAck__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ____UE_associatedLogicalE1_ConnectionListResAck__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UE-associatedLogicalE1-ConnectionItem')))
    ___UE_associatedLogicalE1_ConnectionListResAck__item__id_tab._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'ignore'), ('Value', ____UE_associatedLogicalE1_ConnectionListResAck__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __UE_associatedLogicalE1_ConnectionListResAck__item__id._const_tab = ___UE_associatedLogicalE1_ConnectionListResAck__item__id_tab
    __UE_associatedLogicalE1_ConnectionListResAck__item__id._const_tab_at = None
    __UE_associatedLogicalE1_ConnectionListResAck__item__id._const_tab_id = 'id'
    __UE_associatedLogicalE1_ConnectionListResAck__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    __UE_associatedLogicalE1_ConnectionListResAck__item__criticality._const_tab = ___UE_associatedLogicalE1_ConnectionListResAck__item__id_tab
    __UE_associatedLogicalE1_ConnectionListResAck__item__criticality._const_tab_at = ('..', 'id')
    __UE_associatedLogicalE1_ConnectionListResAck__item__criticality._const_tab_id = 'criticality'
    __UE_associatedLogicalE1_ConnectionListResAck__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    __UE_associatedLogicalE1_ConnectionListResAck__item__value._const_tab = ___UE_associatedLogicalE1_ConnectionListResAck__item__id_tab
    __UE_associatedLogicalE1_ConnectionListResAck__item__value._const_tab_at = ('..', 'id')
    __UE_associatedLogicalE1_ConnectionListResAck__item__value._const_tab_id = 'Value'
    _UE_associatedLogicalE1_ConnectionListResAck__item_._cont = ASN1Dict([
        ('id', __UE_associatedLogicalE1_ConnectionListResAck__item__id),
        ('criticality', __UE_associatedLogicalE1_ConnectionListResAck__item__criticality),
        ('value', __UE_associatedLogicalE1_ConnectionListResAck__item__value),
        ])
    _UE_associatedLogicalE1_ConnectionListResAck__item_._ext = None
    UE_associatedLogicalE1_ConnectionListResAck._cont = _UE_associatedLogicalE1_ConnectionListResAck__item_
    UE_associatedLogicalE1_ConnectionListResAck._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< UE-associatedLogicalE1-ConnectionItemResAck >-----#
    UE_associatedLogicalE1_ConnectionItemResAck = CLASS(name='UE-associatedLogicalE1-ConnectionItemResAck', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _UE_associatedLogicalE1_ConnectionItemResAck_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UE-associatedLogicalE1-ConnectionItem')))
    UE_associatedLogicalE1_ConnectionItemResAck._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'ignore'), ('Value', _UE_associatedLogicalE1_ConnectionItemResAck_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ErrorIndication >-----#
    ErrorIndication = SEQ(name='ErrorIndication', mode=MODE_TYPE)
    _ErrorIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __ErrorIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___ErrorIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____ErrorIndication_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    ____ErrorIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 155), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 156), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolIEs__item__id._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__id._const_tab_at = None
    ___ErrorIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___ErrorIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___ErrorIndication_protocolIEs__item__criticality._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ErrorIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___ErrorIndication_protocolIEs__item__value._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __ErrorIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ErrorIndication_protocolIEs__item__id),
        ('criticality', ___ErrorIndication_protocolIEs__item__criticality),
        ('value', ___ErrorIndication_protocolIEs__item__value),
        ])
    __ErrorIndication_protocolIEs__item_._ext = None
    _ErrorIndication_protocolIEs._cont = __ErrorIndication_protocolIEs__item_
    _ErrorIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ErrorIndication._cont = ASN1Dict([
        ('protocolIEs', _ErrorIndication_protocolIEs),
        ])
    ErrorIndication._ext = []
    
    #-----< ErrorIndication-IEs >-----#
    ErrorIndication_IEs = CLASS(name='ErrorIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _ErrorIndication_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _ErrorIndication_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _ErrorIndication_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _ErrorIndication_IEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _ErrorIndication_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    _ErrorIndication_IEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _ErrorIndication_IEs_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    ErrorIndication_IEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _ErrorIndication_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _ErrorIndication_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _ErrorIndication_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _ErrorIndication_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _ErrorIndication_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 155), ('criticality', 'ignore'), ('Value', _ErrorIndication_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 156), ('criticality', 'ignore'), ('Value', _ErrorIndication_IEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-UP-E1SetupRequest >-----#
    GNB_CU_UP_E1SetupRequest = SEQ(name='GNB-CU-UP-E1SetupRequest', mode=MODE_TYPE)
    _GNB_CU_UP_E1SetupRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __GNB_CU_UP_E1SetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___GNB_CU_UP_E1SetupRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-ID')))
    _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_2 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-Name')))
    _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CNSupport')))
    _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'SupportedPLMNs-List')))
    _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-Capacity')))
    _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Transport-Layer-Address-Info')))
    _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Extended-GNB-CU-UP-Name')))
    _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-Support-Info')))
    ____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'reject'), ('Value', _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 10), ('criticality', 'reject'), ('Value', _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 11), ('criticality', 'reject'), ('Value', _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 64), ('criticality', 'ignore'), ('Value', _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 130), ('criticality', 'ignore'), ('Value', _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'reject'), ('Value', _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNB_CU_UP_E1SetupRequest_protocolIEs__item__id._const_tab = ____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab
    ___GNB_CU_UP_E1SetupRequest_protocolIEs__item__id._const_tab_at = None
    ___GNB_CU_UP_E1SetupRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___GNB_CU_UP_E1SetupRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___GNB_CU_UP_E1SetupRequest_protocolIEs__item__criticality._const_tab = ____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab
    ___GNB_CU_UP_E1SetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_UP_E1SetupRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_UP_E1SetupRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___GNB_CU_UP_E1SetupRequest_protocolIEs__item__value._const_tab = ____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab
    ___GNB_CU_UP_E1SetupRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNB_CU_UP_E1SetupRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __GNB_CU_UP_E1SetupRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_UP_E1SetupRequest_protocolIEs__item__id),
        ('criticality', ___GNB_CU_UP_E1SetupRequest_protocolIEs__item__criticality),
        ('value', ___GNB_CU_UP_E1SetupRequest_protocolIEs__item__value),
        ])
    __GNB_CU_UP_E1SetupRequest_protocolIEs__item_._ext = None
    _GNB_CU_UP_E1SetupRequest_protocolIEs._cont = __GNB_CU_UP_E1SetupRequest_protocolIEs__item_
    _GNB_CU_UP_E1SetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNB_CU_UP_E1SetupRequest._cont = ASN1Dict([
        ('protocolIEs', _GNB_CU_UP_E1SetupRequest_protocolIEs),
        ])
    GNB_CU_UP_E1SetupRequest._ext = []
    
    #-----< GNB-CU-UP-E1SetupRequestIEs >-----#
    GNB_CU_UP_E1SetupRequestIEs = CLASS(name='GNB-CU-UP-E1SetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _GNB_CU_UP_E1SetupRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _GNB_CU_UP_E1SetupRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-ID')))
    _GNB_CU_UP_E1SetupRequestIEs_val_Value_2 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-Name')))
    _GNB_CU_UP_E1SetupRequestIEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CNSupport')))
    _GNB_CU_UP_E1SetupRequestIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'SupportedPLMNs-List')))
    _GNB_CU_UP_E1SetupRequestIEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-Capacity')))
    _GNB_CU_UP_E1SetupRequestIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Transport-Layer-Address-Info')))
    _GNB_CU_UP_E1SetupRequestIEs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Extended-GNB-CU-UP-Name')))
    _GNB_CU_UP_E1SetupRequestIEs_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-Support-Info')))
    GNB_CU_UP_E1SetupRequestIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _GNB_CU_UP_E1SetupRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'reject'), ('Value', _GNB_CU_UP_E1SetupRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _GNB_CU_UP_E1SetupRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 10), ('criticality', 'reject'), ('Value', _GNB_CU_UP_E1SetupRequestIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 11), ('criticality', 'reject'), ('Value', _GNB_CU_UP_E1SetupRequestIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 64), ('criticality', 'ignore'), ('Value', _GNB_CU_UP_E1SetupRequestIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _GNB_CU_UP_E1SetupRequestIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 130), ('criticality', 'ignore'), ('Value', _GNB_CU_UP_E1SetupRequestIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'reject'), ('Value', _GNB_CU_UP_E1SetupRequestIEs_val_Value_8), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SupportedPLMNs-List >-----#
    SupportedPLMNs_List = SEQ_OF(name='SupportedPLMNs-List', mode=MODE_TYPE)
    _SupportedPLMNs_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'SupportedPLMNs-Item')))
    SupportedPLMNs_List._cont = _SupportedPLMNs_List__item_
    SupportedPLMNs_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< SupportedPLMNs-Item >-----#
    SupportedPLMNs_Item = SEQ(name='SupportedPLMNs-Item', mode=MODE_TYPE)
    _SupportedPLMNs_Item_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'PLMN-Identity')))
    _SupportedPLMNs_Item_slice_Support_List = SEQ_OF(name='slice-Support-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'Slice-Support-List')), opt=True)
    _SupportedPLMNs_Item_nR_CGI_Support_List = SEQ_OF(name='nR-CGI-Support-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'NR-CGI-Support-List')), opt=True)
    _SupportedPLMNs_Item_qoS_Parameters_Support_List = SEQ(name='qoS-Parameters-Support-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-IEs', 'QoS-Parameters-Support-List')), opt=True)
    _SupportedPLMNs_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SupportedPLMNs_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolExtensionField')))
    ___SupportedPLMNs_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SupportedPLMNs_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _____SupportedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'NPNSupportInfo')))
    _____SupportedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ExtendedSliceSupportList')))
    _____SupportedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Extended-NR-CGI-Support-List')))
    _____SupportedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ECGI-Support-List')))
    ____SupportedPLMNs_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 110), ('criticality', 'reject'), ('Extension', _____SupportedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 125), ('criticality', 'reject'), ('Extension', _____SupportedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 135), ('criticality', 'ignore'), ('Extension', _____SupportedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 145), ('criticality', 'ignore'), ('Extension', _____SupportedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SupportedPLMNs_Item_iE_Extensions__item__id._const_tab = ____SupportedPLMNs_Item_iE_Extensions__item__id_tab
    ___SupportedPLMNs_Item_iE_Extensions__item__id._const_tab_at = None
    ___SupportedPLMNs_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SupportedPLMNs_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SupportedPLMNs_Item_iE_Extensions__item__criticality._const_tab = ____SupportedPLMNs_Item_iE_Extensions__item__id_tab
    ___SupportedPLMNs_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SupportedPLMNs_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SupportedPLMNs_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SupportedPLMNs_Item_iE_Extensions__item__extensionValue._const_tab = ____SupportedPLMNs_Item_iE_Extensions__item__id_tab
    ___SupportedPLMNs_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SupportedPLMNs_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SupportedPLMNs_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SupportedPLMNs_Item_iE_Extensions__item__id),
        ('criticality', ___SupportedPLMNs_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SupportedPLMNs_Item_iE_Extensions__item__extensionValue),
        ])
    __SupportedPLMNs_Item_iE_Extensions__item_._ext = None
    _SupportedPLMNs_Item_iE_Extensions._cont = __SupportedPLMNs_Item_iE_Extensions__item_
    _SupportedPLMNs_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SupportedPLMNs_Item._cont = ASN1Dict([
        ('pLMN-Identity', _SupportedPLMNs_Item_pLMN_Identity),
        ('slice-Support-List', _SupportedPLMNs_Item_slice_Support_List),
        ('nR-CGI-Support-List', _SupportedPLMNs_Item_nR_CGI_Support_List),
        ('qoS-Parameters-Support-List', _SupportedPLMNs_Item_qoS_Parameters_Support_List),
        ('iE-Extensions', _SupportedPLMNs_Item_iE_Extensions),
        ])
    SupportedPLMNs_Item._ext = []
    
    #-----< SupportedPLMNs-ExtIEs >-----#
    SupportedPLMNs_ExtIEs = CLASS(name='SupportedPLMNs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-EXTENSION')))
    _SupportedPLMNs_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'NPNSupportInfo')))
    _SupportedPLMNs_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ExtendedSliceSupportList')))
    _SupportedPLMNs_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Extended-NR-CGI-Support-List')))
    _SupportedPLMNs_ExtIEs_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ECGI-Support-List')))
    SupportedPLMNs_ExtIEs._val = ASN1Set(rv=[dict([('id', 110), ('criticality', 'reject'), ('Extension', _SupportedPLMNs_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 125), ('criticality', 'reject'), ('Extension', _SupportedPLMNs_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 135), ('criticality', 'ignore'), ('Extension', _SupportedPLMNs_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 145), ('criticality', 'ignore'), ('Extension', _SupportedPLMNs_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-UP-E1SetupResponse >-----#
    GNB_CU_UP_E1SetupResponse = SEQ(name='GNB-CU-UP-E1SetupResponse', mode=MODE_TYPE)
    _GNB_CU_UP_E1SetupResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __GNB_CU_UP_E1SetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___GNB_CU_UP_E1SetupResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____GNB_CU_UP_E1SetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____GNB_CU_UP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____GNB_CU_UP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_1 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-Name')))
    _____GNB_CU_UP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Transport-Layer-Address-Info')))
    _____GNB_CU_UP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Extended-GNB-CU-CP-Name')))
    _____GNB_CU_UP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____GNB_CU_UP_E1SetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____GNB_CU_UP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____GNB_CU_UP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _____GNB_CU_UP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 129), ('criticality', 'ignore'), ('Value', _____GNB_CU_UP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____GNB_CU_UP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNB_CU_UP_E1SetupResponse_protocolIEs__item__id._const_tab = ____GNB_CU_UP_E1SetupResponse_protocolIEs__item__id_tab
    ___GNB_CU_UP_E1SetupResponse_protocolIEs__item__id._const_tab_at = None
    ___GNB_CU_UP_E1SetupResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___GNB_CU_UP_E1SetupResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___GNB_CU_UP_E1SetupResponse_protocolIEs__item__criticality._const_tab = ____GNB_CU_UP_E1SetupResponse_protocolIEs__item__id_tab
    ___GNB_CU_UP_E1SetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_UP_E1SetupResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_UP_E1SetupResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___GNB_CU_UP_E1SetupResponse_protocolIEs__item__value._const_tab = ____GNB_CU_UP_E1SetupResponse_protocolIEs__item__id_tab
    ___GNB_CU_UP_E1SetupResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNB_CU_UP_E1SetupResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __GNB_CU_UP_E1SetupResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_UP_E1SetupResponse_protocolIEs__item__id),
        ('criticality', ___GNB_CU_UP_E1SetupResponse_protocolIEs__item__criticality),
        ('value', ___GNB_CU_UP_E1SetupResponse_protocolIEs__item__value),
        ])
    __GNB_CU_UP_E1SetupResponse_protocolIEs__item_._ext = None
    _GNB_CU_UP_E1SetupResponse_protocolIEs._cont = __GNB_CU_UP_E1SetupResponse_protocolIEs__item_
    _GNB_CU_UP_E1SetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNB_CU_UP_E1SetupResponse._cont = ASN1Dict([
        ('protocolIEs', _GNB_CU_UP_E1SetupResponse_protocolIEs),
        ])
    GNB_CU_UP_E1SetupResponse._ext = []
    
    #-----< GNB-CU-UP-E1SetupResponseIEs >-----#
    GNB_CU_UP_E1SetupResponseIEs = CLASS(name='GNB-CU-UP-E1SetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _GNB_CU_UP_E1SetupResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _GNB_CU_UP_E1SetupResponseIEs_val_Value_1 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-Name')))
    _GNB_CU_UP_E1SetupResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Transport-Layer-Address-Info')))
    _GNB_CU_UP_E1SetupResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Extended-GNB-CU-CP-Name')))
    _GNB_CU_UP_E1SetupResponseIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    GNB_CU_UP_E1SetupResponseIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _GNB_CU_UP_E1SetupResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _GNB_CU_UP_E1SetupResponseIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _GNB_CU_UP_E1SetupResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 129), ('criticality', 'ignore'), ('Value', _GNB_CU_UP_E1SetupResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _GNB_CU_UP_E1SetupResponseIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-UP-E1SetupFailure >-----#
    GNB_CU_UP_E1SetupFailure = SEQ(name='GNB-CU-UP-E1SetupFailure', mode=MODE_TYPE)
    _GNB_CU_UP_E1SetupFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __GNB_CU_UP_E1SetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___GNB_CU_UP_E1SetupFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____GNB_CU_UP_E1SetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____GNB_CU_UP_E1SetupFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____GNB_CU_UP_E1SetupFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _____GNB_CU_UP_E1SetupFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TimeToWait')))
    _____GNB_CU_UP_E1SetupFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____GNB_CU_UP_E1SetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____GNB_CU_UP_E1SetupFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____GNB_CU_UP_E1SetupFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 12), ('criticality', 'ignore'), ('Value', _____GNB_CU_UP_E1SetupFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____GNB_CU_UP_E1SetupFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNB_CU_UP_E1SetupFailure_protocolIEs__item__id._const_tab = ____GNB_CU_UP_E1SetupFailure_protocolIEs__item__id_tab
    ___GNB_CU_UP_E1SetupFailure_protocolIEs__item__id._const_tab_at = None
    ___GNB_CU_UP_E1SetupFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___GNB_CU_UP_E1SetupFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___GNB_CU_UP_E1SetupFailure_protocolIEs__item__criticality._const_tab = ____GNB_CU_UP_E1SetupFailure_protocolIEs__item__id_tab
    ___GNB_CU_UP_E1SetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_UP_E1SetupFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_UP_E1SetupFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___GNB_CU_UP_E1SetupFailure_protocolIEs__item__value._const_tab = ____GNB_CU_UP_E1SetupFailure_protocolIEs__item__id_tab
    ___GNB_CU_UP_E1SetupFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNB_CU_UP_E1SetupFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __GNB_CU_UP_E1SetupFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_UP_E1SetupFailure_protocolIEs__item__id),
        ('criticality', ___GNB_CU_UP_E1SetupFailure_protocolIEs__item__criticality),
        ('value', ___GNB_CU_UP_E1SetupFailure_protocolIEs__item__value),
        ])
    __GNB_CU_UP_E1SetupFailure_protocolIEs__item_._ext = None
    _GNB_CU_UP_E1SetupFailure_protocolIEs._cont = __GNB_CU_UP_E1SetupFailure_protocolIEs__item_
    _GNB_CU_UP_E1SetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNB_CU_UP_E1SetupFailure._cont = ASN1Dict([
        ('protocolIEs', _GNB_CU_UP_E1SetupFailure_protocolIEs),
        ])
    GNB_CU_UP_E1SetupFailure._ext = []
    
    #-----< GNB-CU-UP-E1SetupFailureIEs >-----#
    GNB_CU_UP_E1SetupFailureIEs = CLASS(name='GNB-CU-UP-E1SetupFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _GNB_CU_UP_E1SetupFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _GNB_CU_UP_E1SetupFailureIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _GNB_CU_UP_E1SetupFailureIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TimeToWait')))
    _GNB_CU_UP_E1SetupFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    GNB_CU_UP_E1SetupFailureIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _GNB_CU_UP_E1SetupFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _GNB_CU_UP_E1SetupFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 12), ('criticality', 'ignore'), ('Value', _GNB_CU_UP_E1SetupFailureIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _GNB_CU_UP_E1SetupFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-CP-E1SetupRequest >-----#
    GNB_CU_CP_E1SetupRequest = SEQ(name='GNB-CU-CP-E1SetupRequest', mode=MODE_TYPE)
    _GNB_CU_CP_E1SetupRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __GNB_CU_CP_E1SetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___GNB_CU_CP_E1SetupRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____GNB_CU_CP_E1SetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____GNB_CU_CP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____GNB_CU_CP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_1 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-Name')))
    _____GNB_CU_CP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Transport-Layer-Address-Info')))
    _____GNB_CU_CP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Extended-GNB-CU-CP-Name')))
    ____GNB_CU_CP_E1SetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____GNB_CU_CP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____GNB_CU_CP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _____GNB_CU_CP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 129), ('criticality', 'ignore'), ('Value', _____GNB_CU_CP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNB_CU_CP_E1SetupRequest_protocolIEs__item__id._const_tab = ____GNB_CU_CP_E1SetupRequest_protocolIEs__item__id_tab
    ___GNB_CU_CP_E1SetupRequest_protocolIEs__item__id._const_tab_at = None
    ___GNB_CU_CP_E1SetupRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___GNB_CU_CP_E1SetupRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___GNB_CU_CP_E1SetupRequest_protocolIEs__item__criticality._const_tab = ____GNB_CU_CP_E1SetupRequest_protocolIEs__item__id_tab
    ___GNB_CU_CP_E1SetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_CP_E1SetupRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_CP_E1SetupRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___GNB_CU_CP_E1SetupRequest_protocolIEs__item__value._const_tab = ____GNB_CU_CP_E1SetupRequest_protocolIEs__item__id_tab
    ___GNB_CU_CP_E1SetupRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNB_CU_CP_E1SetupRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __GNB_CU_CP_E1SetupRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_CP_E1SetupRequest_protocolIEs__item__id),
        ('criticality', ___GNB_CU_CP_E1SetupRequest_protocolIEs__item__criticality),
        ('value', ___GNB_CU_CP_E1SetupRequest_protocolIEs__item__value),
        ])
    __GNB_CU_CP_E1SetupRequest_protocolIEs__item_._ext = None
    _GNB_CU_CP_E1SetupRequest_protocolIEs._cont = __GNB_CU_CP_E1SetupRequest_protocolIEs__item_
    _GNB_CU_CP_E1SetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNB_CU_CP_E1SetupRequest._cont = ASN1Dict([
        ('protocolIEs', _GNB_CU_CP_E1SetupRequest_protocolIEs),
        ])
    GNB_CU_CP_E1SetupRequest._ext = []
    
    #-----< GNB-CU-CP-E1SetupRequestIEs >-----#
    GNB_CU_CP_E1SetupRequestIEs = CLASS(name='GNB-CU-CP-E1SetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _GNB_CU_CP_E1SetupRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _GNB_CU_CP_E1SetupRequestIEs_val_Value_1 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-Name')))
    _GNB_CU_CP_E1SetupRequestIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Transport-Layer-Address-Info')))
    _GNB_CU_CP_E1SetupRequestIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Extended-GNB-CU-CP-Name')))
    GNB_CU_CP_E1SetupRequestIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _GNB_CU_CP_E1SetupRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _GNB_CU_CP_E1SetupRequestIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _GNB_CU_CP_E1SetupRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 129), ('criticality', 'ignore'), ('Value', _GNB_CU_CP_E1SetupRequestIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-CP-E1SetupResponse >-----#
    GNB_CU_CP_E1SetupResponse = SEQ(name='GNB-CU-CP-E1SetupResponse', mode=MODE_TYPE)
    _GNB_CU_CP_E1SetupResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __GNB_CU_CP_E1SetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___GNB_CU_CP_E1SetupResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-ID')))
    _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_2 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-Name')))
    _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CNSupport')))
    _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'SupportedPLMNs-List')))
    _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-Capacity')))
    _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Transport-Layer-Address-Info')))
    _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Extended-GNB-CU-UP-Name')))
    _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'reject'), ('Value', _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 10), ('criticality', 'reject'), ('Value', _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 11), ('criticality', 'reject'), ('Value', _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 64), ('criticality', 'ignore'), ('Value', _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 130), ('criticality', 'ignore'), ('Value', _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNB_CU_CP_E1SetupResponse_protocolIEs__item__id._const_tab = ____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab
    ___GNB_CU_CP_E1SetupResponse_protocolIEs__item__id._const_tab_at = None
    ___GNB_CU_CP_E1SetupResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___GNB_CU_CP_E1SetupResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___GNB_CU_CP_E1SetupResponse_protocolIEs__item__criticality._const_tab = ____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab
    ___GNB_CU_CP_E1SetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_CP_E1SetupResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_CP_E1SetupResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___GNB_CU_CP_E1SetupResponse_protocolIEs__item__value._const_tab = ____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab
    ___GNB_CU_CP_E1SetupResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNB_CU_CP_E1SetupResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __GNB_CU_CP_E1SetupResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_CP_E1SetupResponse_protocolIEs__item__id),
        ('criticality', ___GNB_CU_CP_E1SetupResponse_protocolIEs__item__criticality),
        ('value', ___GNB_CU_CP_E1SetupResponse_protocolIEs__item__value),
        ])
    __GNB_CU_CP_E1SetupResponse_protocolIEs__item_._ext = None
    _GNB_CU_CP_E1SetupResponse_protocolIEs._cont = __GNB_CU_CP_E1SetupResponse_protocolIEs__item_
    _GNB_CU_CP_E1SetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNB_CU_CP_E1SetupResponse._cont = ASN1Dict([
        ('protocolIEs', _GNB_CU_CP_E1SetupResponse_protocolIEs),
        ])
    GNB_CU_CP_E1SetupResponse._ext = []
    
    #-----< GNB-CU-CP-E1SetupResponseIEs >-----#
    GNB_CU_CP_E1SetupResponseIEs = CLASS(name='GNB-CU-CP-E1SetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _GNB_CU_CP_E1SetupResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _GNB_CU_CP_E1SetupResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-ID')))
    _GNB_CU_CP_E1SetupResponseIEs_val_Value_2 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-Name')))
    _GNB_CU_CP_E1SetupResponseIEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CNSupport')))
    _GNB_CU_CP_E1SetupResponseIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'SupportedPLMNs-List')))
    _GNB_CU_CP_E1SetupResponseIEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-Capacity')))
    _GNB_CU_CP_E1SetupResponseIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Transport-Layer-Address-Info')))
    _GNB_CU_CP_E1SetupResponseIEs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Extended-GNB-CU-UP-Name')))
    _GNB_CU_CP_E1SetupResponseIEs_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    GNB_CU_CP_E1SetupResponseIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _GNB_CU_CP_E1SetupResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'reject'), ('Value', _GNB_CU_CP_E1SetupResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _GNB_CU_CP_E1SetupResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 10), ('criticality', 'reject'), ('Value', _GNB_CU_CP_E1SetupResponseIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 11), ('criticality', 'reject'), ('Value', _GNB_CU_CP_E1SetupResponseIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 64), ('criticality', 'ignore'), ('Value', _GNB_CU_CP_E1SetupResponseIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _GNB_CU_CP_E1SetupResponseIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 130), ('criticality', 'ignore'), ('Value', _GNB_CU_CP_E1SetupResponseIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _GNB_CU_CP_E1SetupResponseIEs_val_Value_8), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-CP-E1SetupFailure >-----#
    GNB_CU_CP_E1SetupFailure = SEQ(name='GNB-CU-CP-E1SetupFailure', mode=MODE_TYPE)
    _GNB_CU_CP_E1SetupFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __GNB_CU_CP_E1SetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___GNB_CU_CP_E1SetupFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____GNB_CU_CP_E1SetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____GNB_CU_CP_E1SetupFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____GNB_CU_CP_E1SetupFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _____GNB_CU_CP_E1SetupFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TimeToWait')))
    _____GNB_CU_CP_E1SetupFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____GNB_CU_CP_E1SetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____GNB_CU_CP_E1SetupFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____GNB_CU_CP_E1SetupFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 12), ('criticality', 'ignore'), ('Value', _____GNB_CU_CP_E1SetupFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____GNB_CU_CP_E1SetupFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNB_CU_CP_E1SetupFailure_protocolIEs__item__id._const_tab = ____GNB_CU_CP_E1SetupFailure_protocolIEs__item__id_tab
    ___GNB_CU_CP_E1SetupFailure_protocolIEs__item__id._const_tab_at = None
    ___GNB_CU_CP_E1SetupFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___GNB_CU_CP_E1SetupFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___GNB_CU_CP_E1SetupFailure_protocolIEs__item__criticality._const_tab = ____GNB_CU_CP_E1SetupFailure_protocolIEs__item__id_tab
    ___GNB_CU_CP_E1SetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_CP_E1SetupFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_CP_E1SetupFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___GNB_CU_CP_E1SetupFailure_protocolIEs__item__value._const_tab = ____GNB_CU_CP_E1SetupFailure_protocolIEs__item__id_tab
    ___GNB_CU_CP_E1SetupFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNB_CU_CP_E1SetupFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __GNB_CU_CP_E1SetupFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_CP_E1SetupFailure_protocolIEs__item__id),
        ('criticality', ___GNB_CU_CP_E1SetupFailure_protocolIEs__item__criticality),
        ('value', ___GNB_CU_CP_E1SetupFailure_protocolIEs__item__value),
        ])
    __GNB_CU_CP_E1SetupFailure_protocolIEs__item_._ext = None
    _GNB_CU_CP_E1SetupFailure_protocolIEs._cont = __GNB_CU_CP_E1SetupFailure_protocolIEs__item_
    _GNB_CU_CP_E1SetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNB_CU_CP_E1SetupFailure._cont = ASN1Dict([
        ('protocolIEs', _GNB_CU_CP_E1SetupFailure_protocolIEs),
        ])
    GNB_CU_CP_E1SetupFailure._ext = []
    
    #-----< GNB-CU-CP-E1SetupFailureIEs >-----#
    GNB_CU_CP_E1SetupFailureIEs = CLASS(name='GNB-CU-CP-E1SetupFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _GNB_CU_CP_E1SetupFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _GNB_CU_CP_E1SetupFailureIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _GNB_CU_CP_E1SetupFailureIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TimeToWait')))
    _GNB_CU_CP_E1SetupFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    GNB_CU_CP_E1SetupFailureIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _GNB_CU_CP_E1SetupFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _GNB_CU_CP_E1SetupFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 12), ('criticality', 'ignore'), ('Value', _GNB_CU_CP_E1SetupFailureIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _GNB_CU_CP_E1SetupFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-UP-ConfigurationUpdate >-----#
    GNB_CU_UP_ConfigurationUpdate = SEQ(name='GNB-CU-UP-ConfigurationUpdate', mode=MODE_TYPE)
    _GNB_CU_UP_ConfigurationUpdate_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __GNB_CU_UP_ConfigurationUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-ID')))
    _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-Name')))
    _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'SupportedPLMNs-List')))
    _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-Capacity')))
    _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-TNLA-To-Remove-List')))
    _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Transport-Layer-Address-Info')))
    _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Extended-GNB-CU-UP-Name')))
    _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-Support-Info')))
    ____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'reject'), ('Value', _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 11), ('criticality', 'reject'), ('Value', _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 64), ('criticality', 'ignore'), ('Value', _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 73), ('criticality', 'reject'), ('Value', _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 130), ('criticality', 'ignore'), ('Value', _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'reject'), ('Value', _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id._const_tab = ____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab
    ___GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id._const_tab_at = None
    ___GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id._const_tab_id = 'id'
    ___GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__criticality._const_tab = ____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab
    ___GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__value._const_tab = ____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab
    ___GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__value._const_tab_id = 'Value'
    __GNB_CU_UP_ConfigurationUpdate_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id),
        ('criticality', ___GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__criticality),
        ('value', ___GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__value),
        ])
    __GNB_CU_UP_ConfigurationUpdate_protocolIEs__item_._ext = None
    _GNB_CU_UP_ConfigurationUpdate_protocolIEs._cont = __GNB_CU_UP_ConfigurationUpdate_protocolIEs__item_
    _GNB_CU_UP_ConfigurationUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNB_CU_UP_ConfigurationUpdate._cont = ASN1Dict([
        ('protocolIEs', _GNB_CU_UP_ConfigurationUpdate_protocolIEs),
        ])
    GNB_CU_UP_ConfigurationUpdate._ext = []
    
    #-----< GNB-CU-UP-ConfigurationUpdateIEs >-----#
    GNB_CU_UP_ConfigurationUpdateIEs = CLASS(name='GNB-CU-UP-ConfigurationUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-ID')))
    _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_2 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-Name')))
    _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'SupportedPLMNs-List')))
    _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-Capacity')))
    _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-TNLA-To-Remove-List')))
    _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Transport-Layer-Address-Info')))
    _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Extended-GNB-CU-UP-Name')))
    _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-Support-Info')))
    GNB_CU_UP_ConfigurationUpdateIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'reject'), ('Value', _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 11), ('criticality', 'reject'), ('Value', _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 64), ('criticality', 'ignore'), ('Value', _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 73), ('criticality', 'reject'), ('Value', _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 130), ('criticality', 'ignore'), ('Value', _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'reject'), ('Value', _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_8), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-UP-TNLA-To-Remove-List >-----#
    GNB_CU_UP_TNLA_To_Remove_List = SEQ_OF(name='GNB-CU-UP-TNLA-To-Remove-List', mode=MODE_TYPE)
    _GNB_CU_UP_TNLA_To_Remove_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-TNLA-To-Remove-Item')))
    GNB_CU_UP_TNLA_To_Remove_List._cont = _GNB_CU_UP_TNLA_To_Remove_List__item_
    GNB_CU_UP_TNLA_To_Remove_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< GNB-CU-UP-ConfigurationUpdateAcknowledge >-----#
    GNB_CU_UP_ConfigurationUpdateAcknowledge = SEQ(name='GNB-CU-UP-ConfigurationUpdateAcknowledge', mode=MODE_TYPE)
    _GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    _____GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Transport-Layer-Address-Info')))
    ____GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _____GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab = ____GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab = ____GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab = ____GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__id),
        ('criticality', ___GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__criticality),
        ('value', ___GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__value),
        ])
    __GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item_._ext = None
    _GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs._cont = __GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item_
    _GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNB_CU_UP_ConfigurationUpdateAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs),
        ])
    GNB_CU_UP_ConfigurationUpdateAcknowledge._ext = []
    
    #-----< GNB-CU-UP-ConfigurationUpdateAcknowledgeIEs >-----#
    GNB_CU_UP_ConfigurationUpdateAcknowledgeIEs = CLASS(name='GNB-CU-UP-ConfigurationUpdateAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _GNB_CU_UP_ConfigurationUpdateAcknowledgeIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _GNB_CU_UP_ConfigurationUpdateAcknowledgeIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    _GNB_CU_UP_ConfigurationUpdateAcknowledgeIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Transport-Layer-Address-Info')))
    GNB_CU_UP_ConfigurationUpdateAcknowledgeIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _GNB_CU_UP_ConfigurationUpdateAcknowledgeIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _GNB_CU_UP_ConfigurationUpdateAcknowledgeIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _GNB_CU_UP_ConfigurationUpdateAcknowledgeIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-UP-ConfigurationUpdateFailure >-----#
    GNB_CU_UP_ConfigurationUpdateFailure = SEQ(name='GNB-CU-UP-ConfigurationUpdateFailure', mode=MODE_TYPE)
    _GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _____GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TimeToWait')))
    _____GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 12), ('criticality', 'ignore'), ('Value', _____GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__id._const_tab = ____GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab = ____GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__value._const_tab = ____GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__id),
        ('criticality', ___GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__criticality),
        ('value', ___GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__value),
        ])
    __GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item_._ext = None
    _GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs._cont = __GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item_
    _GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNB_CU_UP_ConfigurationUpdateFailure._cont = ASN1Dict([
        ('protocolIEs', _GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs),
        ])
    GNB_CU_UP_ConfigurationUpdateFailure._ext = []
    
    #-----< GNB-CU-UP-ConfigurationUpdateFailureIEs >-----#
    GNB_CU_UP_ConfigurationUpdateFailureIEs = CLASS(name='GNB-CU-UP-ConfigurationUpdateFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _GNB_CU_UP_ConfigurationUpdateFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _GNB_CU_UP_ConfigurationUpdateFailureIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _GNB_CU_UP_ConfigurationUpdateFailureIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TimeToWait')))
    _GNB_CU_UP_ConfigurationUpdateFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    GNB_CU_UP_ConfigurationUpdateFailureIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _GNB_CU_UP_ConfigurationUpdateFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _GNB_CU_UP_ConfigurationUpdateFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 12), ('criticality', 'ignore'), ('Value', _GNB_CU_UP_ConfigurationUpdateFailureIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _GNB_CU_UP_ConfigurationUpdateFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-CP-ConfigurationUpdate >-----#
    GNB_CU_CP_ConfigurationUpdate = SEQ(name='GNB-CU-CP-ConfigurationUpdate', mode=MODE_TYPE)
    _GNB_CU_CP_ConfigurationUpdate_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __GNB_CU_CP_ConfigurationUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-Name')))
    _____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-TNLA-To-Add-List')))
    _____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-TNLA-To-Remove-List')))
    _____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-TNLA-To-Update-List')))
    _____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Transport-Layer-Address-Info')))
    _____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Extended-GNB-CU-CP-Name')))
    ____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 27), ('criticality', 'ignore'), ('Value', _____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 28), ('criticality', 'ignore'), ('Value', _____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 29), ('criticality', 'ignore'), ('Value', _____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 129), ('criticality', 'ignore'), ('Value', _____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id._const_tab = ____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab
    ___GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id._const_tab_at = None
    ___GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id._const_tab_id = 'id'
    ___GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__criticality._const_tab = ____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab
    ___GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__value._const_tab = ____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab
    ___GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__value._const_tab_id = 'Value'
    __GNB_CU_CP_ConfigurationUpdate_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id),
        ('criticality', ___GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__criticality),
        ('value', ___GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__value),
        ])
    __GNB_CU_CP_ConfigurationUpdate_protocolIEs__item_._ext = None
    _GNB_CU_CP_ConfigurationUpdate_protocolIEs._cont = __GNB_CU_CP_ConfigurationUpdate_protocolIEs__item_
    _GNB_CU_CP_ConfigurationUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNB_CU_CP_ConfigurationUpdate._cont = ASN1Dict([
        ('protocolIEs', _GNB_CU_CP_ConfigurationUpdate_protocolIEs),
        ])
    GNB_CU_CP_ConfigurationUpdate._ext = []
    
    #-----< GNB-CU-CP-ConfigurationUpdateIEs >-----#
    GNB_CU_CP_ConfigurationUpdateIEs = CLASS(name='GNB-CU-CP-ConfigurationUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _GNB_CU_CP_ConfigurationUpdateIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _GNB_CU_CP_ConfigurationUpdateIEs_val_Value_1 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-Name')))
    _GNB_CU_CP_ConfigurationUpdateIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-TNLA-To-Add-List')))
    _GNB_CU_CP_ConfigurationUpdateIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-TNLA-To-Remove-List')))
    _GNB_CU_CP_ConfigurationUpdateIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-TNLA-To-Update-List')))
    _GNB_CU_CP_ConfigurationUpdateIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Transport-Layer-Address-Info')))
    _GNB_CU_CP_ConfigurationUpdateIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Extended-GNB-CU-CP-Name')))
    GNB_CU_CP_ConfigurationUpdateIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _GNB_CU_CP_ConfigurationUpdateIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _GNB_CU_CP_ConfigurationUpdateIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 27), ('criticality', 'ignore'), ('Value', _GNB_CU_CP_ConfigurationUpdateIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 28), ('criticality', 'ignore'), ('Value', _GNB_CU_CP_ConfigurationUpdateIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 29), ('criticality', 'ignore'), ('Value', _GNB_CU_CP_ConfigurationUpdateIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _GNB_CU_CP_ConfigurationUpdateIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 129), ('criticality', 'ignore'), ('Value', _GNB_CU_CP_ConfigurationUpdateIEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-CP-TNLA-To-Add-List >-----#
    GNB_CU_CP_TNLA_To_Add_List = SEQ_OF(name='GNB-CU-CP-TNLA-To-Add-List', mode=MODE_TYPE)
    _GNB_CU_CP_TNLA_To_Add_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-TNLA-To-Add-Item')))
    GNB_CU_CP_TNLA_To_Add_List._cont = _GNB_CU_CP_TNLA_To_Add_List__item_
    GNB_CU_CP_TNLA_To_Add_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< GNB-CU-CP-TNLA-To-Remove-List >-----#
    GNB_CU_CP_TNLA_To_Remove_List = SEQ_OF(name='GNB-CU-CP-TNLA-To-Remove-List', mode=MODE_TYPE)
    _GNB_CU_CP_TNLA_To_Remove_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-TNLA-To-Remove-Item')))
    GNB_CU_CP_TNLA_To_Remove_List._cont = _GNB_CU_CP_TNLA_To_Remove_List__item_
    GNB_CU_CP_TNLA_To_Remove_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< GNB-CU-CP-TNLA-To-Update-List >-----#
    GNB_CU_CP_TNLA_To_Update_List = SEQ_OF(name='GNB-CU-CP-TNLA-To-Update-List', mode=MODE_TYPE)
    _GNB_CU_CP_TNLA_To_Update_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-TNLA-To-Update-Item')))
    GNB_CU_CP_TNLA_To_Update_List._cont = _GNB_CU_CP_TNLA_To_Update_List__item_
    GNB_CU_CP_TNLA_To_Update_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< GNB-CU-CP-ConfigurationUpdateAcknowledge >-----#
    GNB_CU_CP_ConfigurationUpdateAcknowledge = SEQ(name='GNB-CU-CP-ConfigurationUpdateAcknowledge', mode=MODE_TYPE)
    _GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    _____GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-TNLA-Setup-List')))
    _____GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-TNLA-Failed-To-Setup-List')))
    _____GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Transport-Layer-Address-Info')))
    ____GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 30), ('criticality', 'ignore'), ('Value', _____GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 31), ('criticality', 'ignore'), ('Value', _____GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _____GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab = ____GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab = ____GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab = ____GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id),
        ('criticality', ___GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__criticality),
        ('value', ___GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__value),
        ])
    __GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item_._ext = None
    _GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs._cont = __GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item_
    _GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNB_CU_CP_ConfigurationUpdateAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs),
        ])
    GNB_CU_CP_ConfigurationUpdateAcknowledge._ext = []
    
    #-----< GNB-CU-CP-ConfigurationUpdateAcknowledgeIEs >-----#
    GNB_CU_CP_ConfigurationUpdateAcknowledgeIEs = CLASS(name='GNB-CU-CP-ConfigurationUpdateAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _GNB_CU_CP_ConfigurationUpdateAcknowledgeIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _GNB_CU_CP_ConfigurationUpdateAcknowledgeIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    _GNB_CU_CP_ConfigurationUpdateAcknowledgeIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-TNLA-Setup-List')))
    _GNB_CU_CP_ConfigurationUpdateAcknowledgeIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-TNLA-Failed-To-Setup-List')))
    _GNB_CU_CP_ConfigurationUpdateAcknowledgeIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Transport-Layer-Address-Info')))
    GNB_CU_CP_ConfigurationUpdateAcknowledgeIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _GNB_CU_CP_ConfigurationUpdateAcknowledgeIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _GNB_CU_CP_ConfigurationUpdateAcknowledgeIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 30), ('criticality', 'ignore'), ('Value', _GNB_CU_CP_ConfigurationUpdateAcknowledgeIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 31), ('criticality', 'ignore'), ('Value', _GNB_CU_CP_ConfigurationUpdateAcknowledgeIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _GNB_CU_CP_ConfigurationUpdateAcknowledgeIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-CP-TNLA-Setup-List >-----#
    GNB_CU_CP_TNLA_Setup_List = SEQ_OF(name='GNB-CU-CP-TNLA-Setup-List', mode=MODE_TYPE)
    _GNB_CU_CP_TNLA_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-TNLA-Setup-Item')))
    GNB_CU_CP_TNLA_Setup_List._cont = _GNB_CU_CP_TNLA_Setup_List__item_
    GNB_CU_CP_TNLA_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< GNB-CU-CP-TNLA-Failed-To-Setup-List >-----#
    GNB_CU_CP_TNLA_Failed_To_Setup_List = SEQ_OF(name='GNB-CU-CP-TNLA-Failed-To-Setup-List', mode=MODE_TYPE)
    _GNB_CU_CP_TNLA_Failed_To_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-TNLA-Failed-To-Setup-Item')))
    GNB_CU_CP_TNLA_Failed_To_Setup_List._cont = _GNB_CU_CP_TNLA_Failed_To_Setup_List__item_
    GNB_CU_CP_TNLA_Failed_To_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< GNB-CU-CP-ConfigurationUpdateFailure >-----#
    GNB_CU_CP_ConfigurationUpdateFailure = SEQ(name='GNB-CU-CP-ConfigurationUpdateFailure', mode=MODE_TYPE)
    _GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _____GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TimeToWait')))
    _____GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 12), ('criticality', 'ignore'), ('Value', _____GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__id._const_tab = ____GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab = ____GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__value._const_tab = ____GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__id),
        ('criticality', ___GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__criticality),
        ('value', ___GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__value),
        ])
    __GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item_._ext = None
    _GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs._cont = __GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item_
    _GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNB_CU_CP_ConfigurationUpdateFailure._cont = ASN1Dict([
        ('protocolIEs', _GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs),
        ])
    GNB_CU_CP_ConfigurationUpdateFailure._ext = []
    
    #-----< GNB-CU-CP-ConfigurationUpdateFailureIEs >-----#
    GNB_CU_CP_ConfigurationUpdateFailureIEs = CLASS(name='GNB-CU-CP-ConfigurationUpdateFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _GNB_CU_CP_ConfigurationUpdateFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _GNB_CU_CP_ConfigurationUpdateFailureIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _GNB_CU_CP_ConfigurationUpdateFailureIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TimeToWait')))
    _GNB_CU_CP_ConfigurationUpdateFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    GNB_CU_CP_ConfigurationUpdateFailureIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _GNB_CU_CP_ConfigurationUpdateFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _GNB_CU_CP_ConfigurationUpdateFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 12), ('criticality', 'ignore'), ('Value', _GNB_CU_CP_ConfigurationUpdateFailureIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _GNB_CU_CP_ConfigurationUpdateFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E1ReleaseRequest >-----#
    E1ReleaseRequest = SEQ(name='E1ReleaseRequest', mode=MODE_TYPE)
    _E1ReleaseRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __E1ReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___E1ReleaseRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____E1ReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____E1ReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____E1ReleaseRequest_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    ____E1ReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____E1ReleaseRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____E1ReleaseRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___E1ReleaseRequest_protocolIEs__item__id._const_tab = ____E1ReleaseRequest_protocolIEs__item__id_tab
    ___E1ReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___E1ReleaseRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___E1ReleaseRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___E1ReleaseRequest_protocolIEs__item__criticality._const_tab = ____E1ReleaseRequest_protocolIEs__item__id_tab
    ___E1ReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E1ReleaseRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E1ReleaseRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___E1ReleaseRequest_protocolIEs__item__value._const_tab = ____E1ReleaseRequest_protocolIEs__item__id_tab
    ___E1ReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E1ReleaseRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __E1ReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E1ReleaseRequest_protocolIEs__item__id),
        ('criticality', ___E1ReleaseRequest_protocolIEs__item__criticality),
        ('value', ___E1ReleaseRequest_protocolIEs__item__value),
        ])
    __E1ReleaseRequest_protocolIEs__item_._ext = None
    _E1ReleaseRequest_protocolIEs._cont = __E1ReleaseRequest_protocolIEs__item_
    _E1ReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E1ReleaseRequest._cont = ASN1Dict([
        ('protocolIEs', _E1ReleaseRequest_protocolIEs),
        ])
    E1ReleaseRequest._ext = []
    
    #-----< E1ReleaseRequestIEs >-----#
    E1ReleaseRequestIEs = CLASS(name='E1ReleaseRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _E1ReleaseRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _E1ReleaseRequestIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    E1ReleaseRequestIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _E1ReleaseRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _E1ReleaseRequestIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E1ReleaseResponse >-----#
    E1ReleaseResponse = SEQ(name='E1ReleaseResponse', mode=MODE_TYPE)
    _E1ReleaseResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __E1ReleaseResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___E1ReleaseResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____E1ReleaseResponse_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____E1ReleaseResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____E1ReleaseResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____E1ReleaseResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____E1ReleaseResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____E1ReleaseResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E1ReleaseResponse_protocolIEs__item__id._const_tab = ____E1ReleaseResponse_protocolIEs__item__id_tab
    ___E1ReleaseResponse_protocolIEs__item__id._const_tab_at = None
    ___E1ReleaseResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___E1ReleaseResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___E1ReleaseResponse_protocolIEs__item__criticality._const_tab = ____E1ReleaseResponse_protocolIEs__item__id_tab
    ___E1ReleaseResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E1ReleaseResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E1ReleaseResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___E1ReleaseResponse_protocolIEs__item__value._const_tab = ____E1ReleaseResponse_protocolIEs__item__id_tab
    ___E1ReleaseResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E1ReleaseResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __E1ReleaseResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E1ReleaseResponse_protocolIEs__item__id),
        ('criticality', ___E1ReleaseResponse_protocolIEs__item__criticality),
        ('value', ___E1ReleaseResponse_protocolIEs__item__value),
        ])
    __E1ReleaseResponse_protocolIEs__item_._ext = None
    _E1ReleaseResponse_protocolIEs._cont = __E1ReleaseResponse_protocolIEs__item_
    _E1ReleaseResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E1ReleaseResponse._cont = ASN1Dict([
        ('protocolIEs', _E1ReleaseResponse_protocolIEs),
        ])
    E1ReleaseResponse._ext = []
    
    #-----< E1ReleaseResponseIEs >-----#
    E1ReleaseResponseIEs = CLASS(name='E1ReleaseResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _E1ReleaseResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _E1ReleaseResponseIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    E1ReleaseResponseIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _E1ReleaseResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _E1ReleaseResponseIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BearerContextSetupRequest >-----#
    BearerContextSetupRequest = SEQ(name='BearerContextSetupRequest', mode=MODE_TYPE)
    _BearerContextSetupRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __BearerContextSetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___BearerContextSetupRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____BearerContextSetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SecurityInformation')))
    _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BitRate')))
    _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BitRate')))
    _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PLMN-Identity')))
    _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ActivityNotificationLevel')))
    _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Inactivity-Timer')))
    _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BearerContextStatusChange')))
    _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_8 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'System-BearerContextSetupRequest')))
    _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_9 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'RANUEID')))
    _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_10 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-DU-ID')))
    _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TraceActivation')))
    _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_12 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'NPNContextInfo')))
    _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_13 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MDTPLMNList')))
    _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_14 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CHOInitiation')))
    _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_15 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'AdditionalHandoverInfo')))
    _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_16 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DirectForwardingPathAvailability')))
    _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_17 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_18 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MDTPollutedMeasurementIndicator')))
    _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_19 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UESliceMaximumBitRateList')))
    _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_20 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SCGActivationStatus')))
    ____BearerContextSetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'reject'), ('Value', _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 14), ('criticality', 'reject'), ('Value', _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 66), ('criticality', 'reject'), ('Value', _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 23), ('criticality', 'reject'), ('Value', _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'mandatory')]), dict([('id', 59), ('criticality', 'reject'), ('Value', _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'reject'), ('Value', _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 15), ('criticality', 'reject'), ('Value', _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_8), ('presence', 'mandatory')]), dict([('id', 76), ('criticality', 'ignore'), ('Value', _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 81), ('criticality', 'ignore'), ('Value', _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 111), ('criticality', 'reject'), ('Value', _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 113), ('criticality', 'ignore'), ('Value', _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 121), ('criticality', 'reject'), ('Value', _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 134), ('criticality', 'ignore'), ('Value', _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 139), ('criticality', 'ignore'), ('Value', _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_17), ('presence', 'optional')]), dict([('id', 146), ('criticality', 'ignore'), ('Value', _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_18), ('presence', 'optional')]), dict([('id', 150), ('criticality', 'ignore'), ('Value', _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_19), ('presence', 'optional')]), dict([('id', 154), ('criticality', 'ignore'), ('Value', _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_20), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BearerContextSetupRequest_protocolIEs__item__id._const_tab = ____BearerContextSetupRequest_protocolIEs__item__id_tab
    ___BearerContextSetupRequest_protocolIEs__item__id._const_tab_at = None
    ___BearerContextSetupRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___BearerContextSetupRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BearerContextSetupRequest_protocolIEs__item__criticality._const_tab = ____BearerContextSetupRequest_protocolIEs__item__id_tab
    ___BearerContextSetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BearerContextSetupRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BearerContextSetupRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BearerContextSetupRequest_protocolIEs__item__value._const_tab = ____BearerContextSetupRequest_protocolIEs__item__id_tab
    ___BearerContextSetupRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BearerContextSetupRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __BearerContextSetupRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BearerContextSetupRequest_protocolIEs__item__id),
        ('criticality', ___BearerContextSetupRequest_protocolIEs__item__criticality),
        ('value', ___BearerContextSetupRequest_protocolIEs__item__value),
        ])
    __BearerContextSetupRequest_protocolIEs__item_._ext = None
    _BearerContextSetupRequest_protocolIEs._cont = __BearerContextSetupRequest_protocolIEs__item_
    _BearerContextSetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BearerContextSetupRequest._cont = ASN1Dict([
        ('protocolIEs', _BearerContextSetupRequest_protocolIEs),
        ])
    BearerContextSetupRequest._ext = []
    
    #-----< BearerContextSetupRequestIEs >-----#
    BearerContextSetupRequestIEs = CLASS(name='BearerContextSetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _BearerContextSetupRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _BearerContextSetupRequestIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SecurityInformation')))
    _BearerContextSetupRequestIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BitRate')))
    _BearerContextSetupRequestIEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BitRate')))
    _BearerContextSetupRequestIEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PLMN-Identity')))
    _BearerContextSetupRequestIEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ActivityNotificationLevel')))
    _BearerContextSetupRequestIEs_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Inactivity-Timer')))
    _BearerContextSetupRequestIEs_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BearerContextStatusChange')))
    _BearerContextSetupRequestIEs_val_Value_8 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'System-BearerContextSetupRequest')))
    _BearerContextSetupRequestIEs_val_Value_9 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'RANUEID')))
    _BearerContextSetupRequestIEs_val_Value_10 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-DU-ID')))
    _BearerContextSetupRequestIEs_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TraceActivation')))
    _BearerContextSetupRequestIEs_val_Value_12 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'NPNContextInfo')))
    _BearerContextSetupRequestIEs_val_Value_13 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MDTPLMNList')))
    _BearerContextSetupRequestIEs_val_Value_14 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CHOInitiation')))
    _BearerContextSetupRequestIEs_val_Value_15 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'AdditionalHandoverInfo')))
    _BearerContextSetupRequestIEs_val_Value_16 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DirectForwardingPathAvailability')))
    _BearerContextSetupRequestIEs_val_Value_17 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _BearerContextSetupRequestIEs_val_Value_18 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MDTPollutedMeasurementIndicator')))
    _BearerContextSetupRequestIEs_val_Value_19 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UESliceMaximumBitRateList')))
    _BearerContextSetupRequestIEs_val_Value_20 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SCGActivationStatus')))
    BearerContextSetupRequestIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _BearerContextSetupRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'reject'), ('Value', _BearerContextSetupRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 14), ('criticality', 'reject'), ('Value', _BearerContextSetupRequestIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 66), ('criticality', 'reject'), ('Value', _BearerContextSetupRequestIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _BearerContextSetupRequestIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 23), ('criticality', 'reject'), ('Value', _BearerContextSetupRequestIEs_val_Value_5), ('presence', 'mandatory')]), dict([('id', 59), ('criticality', 'reject'), ('Value', _BearerContextSetupRequestIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'reject'), ('Value', _BearerContextSetupRequestIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 15), ('criticality', 'reject'), ('Value', _BearerContextSetupRequestIEs_val_Value_8), ('presence', 'mandatory')]), dict([('id', 76), ('criticality', 'ignore'), ('Value', _BearerContextSetupRequestIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _BearerContextSetupRequestIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 81), ('criticality', 'ignore'), ('Value', _BearerContextSetupRequestIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 111), ('criticality', 'reject'), ('Value', _BearerContextSetupRequestIEs_val_Value_12), ('presence', 'optional')]), dict([('id', 113), ('criticality', 'ignore'), ('Value', _BearerContextSetupRequestIEs_val_Value_13), ('presence', 'optional')]), dict([('id', 121), ('criticality', 'reject'), ('Value', _BearerContextSetupRequestIEs_val_Value_14), ('presence', 'optional')]), dict([('id', 134), ('criticality', 'ignore'), ('Value', _BearerContextSetupRequestIEs_val_Value_15), ('presence', 'optional')]), dict([('id', 139), ('criticality', 'ignore'), ('Value', _BearerContextSetupRequestIEs_val_Value_16), ('presence', 'optional')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _BearerContextSetupRequestIEs_val_Value_17), ('presence', 'optional')]), dict([('id', 146), ('criticality', 'ignore'), ('Value', _BearerContextSetupRequestIEs_val_Value_18), ('presence', 'optional')]), dict([('id', 150), ('criticality', 'ignore'), ('Value', _BearerContextSetupRequestIEs_val_Value_19), ('presence', 'optional')]), dict([('id', 154), ('criticality', 'ignore'), ('Value', _BearerContextSetupRequestIEs_val_Value_20), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< System-BearerContextSetupRequest >-----#
    System_BearerContextSetupRequest = CHOICE(name='System-BearerContextSetupRequest', mode=MODE_TYPE)
    _System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest = SEQ_OF(name='e-UTRAN-BearerContextSetupRequest', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-To-Setup-List-EUTRAN')))
    _____System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SubscriberProfileIDforRFP')))
    _____System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__id_tab_val_Value_2 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'AdditionalRRMPriorityIndex')))
    ____System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__id_tab._val = ASN1Set(rv=[dict([('id', 32), ('criticality', 'reject'), ('Value', _____System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 83), ('criticality', 'ignore'), ('Value', _____System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 84), ('criticality', 'ignore'), ('Value', _____System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__id._const_tab = ____System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__id_tab
    ___System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__id._const_tab_at = None
    ___System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__id._const_tab_id = 'id'
    ___System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__criticality._const_tab = ____System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__id_tab
    ___System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__criticality._const_tab_at = ('..', 'id')
    ___System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__criticality._const_tab_id = 'criticality'
    ___System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__value._const_tab = ____System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__id_tab
    ___System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__value._const_tab_at = ('..', 'id')
    ___System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__value._const_tab_id = 'Value'
    __System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item_._cont = ASN1Dict([
        ('id', ___System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__id),
        ('criticality', ___System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__criticality),
        ('value', ___System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__value),
        ])
    __System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item_._ext = None
    _System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest._cont = __System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item_
    _System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest = SEQ_OF(name='nG-RAN-BearerContextSetupRequest', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-To-Setup-List')))
    ____System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__id_tab._val = ASN1Set(rv=[dict([('id', 42), ('criticality', 'reject'), ('Value', _____System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__id._const_tab = ____System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__id_tab
    ___System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__id._const_tab_at = None
    ___System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__id._const_tab_id = 'id'
    ___System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__criticality._const_tab = ____System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__id_tab
    ___System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__criticality._const_tab_at = ('..', 'id')
    ___System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__criticality._const_tab_id = 'criticality'
    ___System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__value._const_tab = ____System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__id_tab
    ___System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__value._const_tab_at = ('..', 'id')
    ___System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__value._const_tab_id = 'Value'
    __System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item_._cont = ASN1Dict([
        ('id', ___System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__id),
        ('criticality', ___System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__criticality),
        ('value', ___System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__value),
        ])
    __System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item_._ext = None
    _System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest._cont = __System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item_
    _System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _System_BearerContextSetupRequest_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __System_BearerContextSetupRequest_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___System_BearerContextSetupRequest_choice_extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___System_BearerContextSetupRequest_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __System_BearerContextSetupRequest_choice_extension_id._const_tab = ___System_BearerContextSetupRequest_choice_extension_id_tab
    __System_BearerContextSetupRequest_choice_extension_id._const_tab_at = None
    __System_BearerContextSetupRequest_choice_extension_id._const_tab_id = 'id'
    __System_BearerContextSetupRequest_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___System_BearerContextSetupRequest_choice_extension_criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___System_BearerContextSetupRequest_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __System_BearerContextSetupRequest_choice_extension_criticality._const_tab = ___System_BearerContextSetupRequest_choice_extension_criticality_tab
    __System_BearerContextSetupRequest_choice_extension_criticality._const_tab_at = ('..', 'id')
    __System_BearerContextSetupRequest_choice_extension_criticality._const_tab_id = 'criticality'
    __System_BearerContextSetupRequest_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___System_BearerContextSetupRequest_choice_extension_value_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___System_BearerContextSetupRequest_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __System_BearerContextSetupRequest_choice_extension_value._const_tab = ___System_BearerContextSetupRequest_choice_extension_value_tab
    __System_BearerContextSetupRequest_choice_extension_value._const_tab_at = ('..', 'id')
    __System_BearerContextSetupRequest_choice_extension_value._const_tab_id = 'Value'
    _System_BearerContextSetupRequest_choice_extension._cont = ASN1Dict([
        ('id', __System_BearerContextSetupRequest_choice_extension_id),
        ('criticality', __System_BearerContextSetupRequest_choice_extension_criticality),
        ('value', __System_BearerContextSetupRequest_choice_extension_value),
        ])
    _System_BearerContextSetupRequest_choice_extension._ext = None
    System_BearerContextSetupRequest._cont = ASN1Dict([
        ('e-UTRAN-BearerContextSetupRequest', _System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest),
        ('nG-RAN-BearerContextSetupRequest', _System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest),
        ('choice-extension', _System_BearerContextSetupRequest_choice_extension),
        ])
    System_BearerContextSetupRequest._ext = None
    
    #-----< System-BearerContextSetupRequest-ExtIEs >-----#
    System_BearerContextSetupRequest_ExtIEs = CLASS(name='System-BearerContextSetupRequest-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    System_BearerContextSetupRequest_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRAN-BearerContextSetupRequest >-----#
    EUTRAN_BearerContextSetupRequest = CLASS(name='EUTRAN-BearerContextSetupRequest', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _EUTRAN_BearerContextSetupRequest_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-To-Setup-List-EUTRAN')))
    _EUTRAN_BearerContextSetupRequest_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SubscriberProfileIDforRFP')))
    _EUTRAN_BearerContextSetupRequest_val_Value_2 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'AdditionalRRMPriorityIndex')))
    EUTRAN_BearerContextSetupRequest._val = ASN1Set(rv=[dict([('id', 32), ('criticality', 'reject'), ('Value', _EUTRAN_BearerContextSetupRequest_val_Value_0), ('presence', 'mandatory')]), dict([('id', 83), ('criticality', 'ignore'), ('Value', _EUTRAN_BearerContextSetupRequest_val_Value_1), ('presence', 'optional')]), dict([('id', 84), ('criticality', 'ignore'), ('Value', _EUTRAN_BearerContextSetupRequest_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< NG-RAN-BearerContextSetupRequest >-----#
    NG_RAN_BearerContextSetupRequest = CLASS(name='NG-RAN-BearerContextSetupRequest', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _NG_RAN_BearerContextSetupRequest_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-To-Setup-List')))
    NG_RAN_BearerContextSetupRequest._val = ASN1Set(rv=[dict([('id', 42), ('criticality', 'reject'), ('Value', _NG_RAN_BearerContextSetupRequest_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BearerContextSetupResponse >-----#
    BearerContextSetupResponse = SEQ(name='BearerContextSetupResponse', mode=MODE_TYPE)
    _BearerContextSetupResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __BearerContextSetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___BearerContextSetupResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____BearerContextSetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____BearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _____BearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _____BearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'System-BearerContextSetupResponse')))
    _____BearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____BearerContextSetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____BearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____BearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 16), ('criticality', 'ignore'), ('Value', _____BearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____BearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BearerContextSetupResponse_protocolIEs__item__id._const_tab = ____BearerContextSetupResponse_protocolIEs__item__id_tab
    ___BearerContextSetupResponse_protocolIEs__item__id._const_tab_at = None
    ___BearerContextSetupResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___BearerContextSetupResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BearerContextSetupResponse_protocolIEs__item__criticality._const_tab = ____BearerContextSetupResponse_protocolIEs__item__id_tab
    ___BearerContextSetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BearerContextSetupResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BearerContextSetupResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BearerContextSetupResponse_protocolIEs__item__value._const_tab = ____BearerContextSetupResponse_protocolIEs__item__id_tab
    ___BearerContextSetupResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BearerContextSetupResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __BearerContextSetupResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BearerContextSetupResponse_protocolIEs__item__id),
        ('criticality', ___BearerContextSetupResponse_protocolIEs__item__criticality),
        ('value', ___BearerContextSetupResponse_protocolIEs__item__value),
        ])
    __BearerContextSetupResponse_protocolIEs__item_._ext = None
    _BearerContextSetupResponse_protocolIEs._cont = __BearerContextSetupResponse_protocolIEs__item_
    _BearerContextSetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BearerContextSetupResponse._cont = ASN1Dict([
        ('protocolIEs', _BearerContextSetupResponse_protocolIEs),
        ])
    BearerContextSetupResponse._ext = []
    
    #-----< BearerContextSetupResponseIEs >-----#
    BearerContextSetupResponseIEs = CLASS(name='BearerContextSetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _BearerContextSetupResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _BearerContextSetupResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _BearerContextSetupResponseIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'System-BearerContextSetupResponse')))
    _BearerContextSetupResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    BearerContextSetupResponseIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _BearerContextSetupResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _BearerContextSetupResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 16), ('criticality', 'ignore'), ('Value', _BearerContextSetupResponseIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _BearerContextSetupResponseIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< System-BearerContextSetupResponse >-----#
    System_BearerContextSetupResponse = CHOICE(name='System-BearerContextSetupResponse', mode=MODE_TYPE)
    _System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse = SEQ_OF(name='e-UTRAN-BearerContextSetupResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Setup-List-EUTRAN')))
    _____System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Failed-List-EUTRAN')))
    ____System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__id_tab._val = ASN1Set(rv=[dict([('id', 37), ('criticality', 'ignore'), ('Value', _____System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 38), ('criticality', 'ignore'), ('Value', _____System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__id._const_tab = ____System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__id_tab
    ___System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__id._const_tab_at = None
    ___System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__id._const_tab_id = 'id'
    ___System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__criticality._const_tab = ____System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__id_tab
    ___System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__criticality._const_tab_at = ('..', 'id')
    ___System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__criticality._const_tab_id = 'criticality'
    ___System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__value._const_tab = ____System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__id_tab
    ___System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__value._const_tab_at = ('..', 'id')
    ___System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__value._const_tab_id = 'Value'
    __System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item_._cont = ASN1Dict([
        ('id', ___System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__id),
        ('criticality', ___System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__criticality),
        ('value', ___System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__value),
        ])
    __System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item_._ext = None
    _System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse._cont = __System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item_
    _System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse = SEQ_OF(name='nG-RAN-BearerContextSetupResponse', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Setup-List')))
    _____System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Failed-List')))
    ____System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__id_tab._val = ASN1Set(rv=[dict([('id', 46), ('criticality', 'ignore'), ('Value', _____System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 47), ('criticality', 'ignore'), ('Value', _____System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__id._const_tab = ____System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__id_tab
    ___System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__id._const_tab_at = None
    ___System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__id._const_tab_id = 'id'
    ___System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__criticality._const_tab = ____System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__id_tab
    ___System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__criticality._const_tab_at = ('..', 'id')
    ___System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__criticality._const_tab_id = 'criticality'
    ___System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__value._const_tab = ____System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__id_tab
    ___System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__value._const_tab_at = ('..', 'id')
    ___System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__value._const_tab_id = 'Value'
    __System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item_._cont = ASN1Dict([
        ('id', ___System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__id),
        ('criticality', ___System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__criticality),
        ('value', ___System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__value),
        ])
    __System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item_._ext = None
    _System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse._cont = __System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item_
    _System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _System_BearerContextSetupResponse_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __System_BearerContextSetupResponse_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___System_BearerContextSetupResponse_choice_extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___System_BearerContextSetupResponse_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __System_BearerContextSetupResponse_choice_extension_id._const_tab = ___System_BearerContextSetupResponse_choice_extension_id_tab
    __System_BearerContextSetupResponse_choice_extension_id._const_tab_at = None
    __System_BearerContextSetupResponse_choice_extension_id._const_tab_id = 'id'
    __System_BearerContextSetupResponse_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___System_BearerContextSetupResponse_choice_extension_criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___System_BearerContextSetupResponse_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __System_BearerContextSetupResponse_choice_extension_criticality._const_tab = ___System_BearerContextSetupResponse_choice_extension_criticality_tab
    __System_BearerContextSetupResponse_choice_extension_criticality._const_tab_at = ('..', 'id')
    __System_BearerContextSetupResponse_choice_extension_criticality._const_tab_id = 'criticality'
    __System_BearerContextSetupResponse_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___System_BearerContextSetupResponse_choice_extension_value_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___System_BearerContextSetupResponse_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __System_BearerContextSetupResponse_choice_extension_value._const_tab = ___System_BearerContextSetupResponse_choice_extension_value_tab
    __System_BearerContextSetupResponse_choice_extension_value._const_tab_at = ('..', 'id')
    __System_BearerContextSetupResponse_choice_extension_value._const_tab_id = 'Value'
    _System_BearerContextSetupResponse_choice_extension._cont = ASN1Dict([
        ('id', __System_BearerContextSetupResponse_choice_extension_id),
        ('criticality', __System_BearerContextSetupResponse_choice_extension_criticality),
        ('value', __System_BearerContextSetupResponse_choice_extension_value),
        ])
    _System_BearerContextSetupResponse_choice_extension._ext = None
    System_BearerContextSetupResponse._cont = ASN1Dict([
        ('e-UTRAN-BearerContextSetupResponse', _System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse),
        ('nG-RAN-BearerContextSetupResponse', _System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse),
        ('choice-extension', _System_BearerContextSetupResponse_choice_extension),
        ])
    System_BearerContextSetupResponse._ext = None
    
    #-----< System-BearerContextSetupResponse-ExtIEs >-----#
    System_BearerContextSetupResponse_ExtIEs = CLASS(name='System-BearerContextSetupResponse-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    System_BearerContextSetupResponse_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRAN-BearerContextSetupResponse >-----#
    EUTRAN_BearerContextSetupResponse = CLASS(name='EUTRAN-BearerContextSetupResponse', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _EUTRAN_BearerContextSetupResponse_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Setup-List-EUTRAN')))
    _EUTRAN_BearerContextSetupResponse_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Failed-List-EUTRAN')))
    EUTRAN_BearerContextSetupResponse._val = ASN1Set(rv=[dict([('id', 37), ('criticality', 'ignore'), ('Value', _EUTRAN_BearerContextSetupResponse_val_Value_0), ('presence', 'mandatory')]), dict([('id', 38), ('criticality', 'ignore'), ('Value', _EUTRAN_BearerContextSetupResponse_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< NG-RAN-BearerContextSetupResponse >-----#
    NG_RAN_BearerContextSetupResponse = CLASS(name='NG-RAN-BearerContextSetupResponse', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _NG_RAN_BearerContextSetupResponse_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Setup-List')))
    _NG_RAN_BearerContextSetupResponse_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Failed-List')))
    NG_RAN_BearerContextSetupResponse._val = ASN1Set(rv=[dict([('id', 46), ('criticality', 'ignore'), ('Value', _NG_RAN_BearerContextSetupResponse_val_Value_0), ('presence', 'mandatory')]), dict([('id', 47), ('criticality', 'ignore'), ('Value', _NG_RAN_BearerContextSetupResponse_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BearerContextSetupFailure >-----#
    BearerContextSetupFailure = SEQ(name='BearerContextSetupFailure', mode=MODE_TYPE)
    _BearerContextSetupFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __BearerContextSetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___BearerContextSetupFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____BearerContextSetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____BearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _____BearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _____BearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _____BearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____BearerContextSetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____BearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _____BearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____BearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____BearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BearerContextSetupFailure_protocolIEs__item__id._const_tab = ____BearerContextSetupFailure_protocolIEs__item__id_tab
    ___BearerContextSetupFailure_protocolIEs__item__id._const_tab_at = None
    ___BearerContextSetupFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___BearerContextSetupFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BearerContextSetupFailure_protocolIEs__item__criticality._const_tab = ____BearerContextSetupFailure_protocolIEs__item__id_tab
    ___BearerContextSetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BearerContextSetupFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BearerContextSetupFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BearerContextSetupFailure_protocolIEs__item__value._const_tab = ____BearerContextSetupFailure_protocolIEs__item__id_tab
    ___BearerContextSetupFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BearerContextSetupFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __BearerContextSetupFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BearerContextSetupFailure_protocolIEs__item__id),
        ('criticality', ___BearerContextSetupFailure_protocolIEs__item__criticality),
        ('value', ___BearerContextSetupFailure_protocolIEs__item__value),
        ])
    __BearerContextSetupFailure_protocolIEs__item_._ext = None
    _BearerContextSetupFailure_protocolIEs._cont = __BearerContextSetupFailure_protocolIEs__item_
    _BearerContextSetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BearerContextSetupFailure._cont = ASN1Dict([
        ('protocolIEs', _BearerContextSetupFailure_protocolIEs),
        ])
    BearerContextSetupFailure._ext = []
    
    #-----< BearerContextSetupFailureIEs >-----#
    BearerContextSetupFailureIEs = CLASS(name='BearerContextSetupFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _BearerContextSetupFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _BearerContextSetupFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _BearerContextSetupFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _BearerContextSetupFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    BearerContextSetupFailureIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _BearerContextSetupFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _BearerContextSetupFailureIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _BearerContextSetupFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _BearerContextSetupFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BearerContextModificationRequest >-----#
    BearerContextModificationRequest = SEQ(name='BearerContextModificationRequest', mode=MODE_TYPE)
    _BearerContextModificationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __BearerContextModificationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___BearerContextModificationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____BearerContextModificationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SecurityInformation')))
    _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BitRate')))
    _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BitRate')))
    _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BearerContextStatusChange')))
    _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'New-UL-TNL-Information-Required')))
    _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_7 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Inactivity-Timer')))
    _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_8 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DataDiscardRequired')))
    _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_9 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'System-BearerContextModificationRequest')))
    _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_10 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'RANUEID')))
    _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_11 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-DU-ID')))
    _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ActivityNotificationLevel')))
    _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MDTPollutedMeasurementIndicator')))
    _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_14 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UESliceMaximumBitRateList')))
    _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_15 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SCGActivationStatus')))
    _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_16 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SDTContinueROHC')))
    _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_17 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MDTPLMNModificationList')))
    ____BearerContextModificationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'reject'), ('Value', _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 14), ('criticality', 'reject'), ('Value', _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 66), ('criticality', 'reject'), ('Value', _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'reject'), ('Value', _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 26), ('criticality', 'reject'), ('Value', _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 59), ('criticality', 'reject'), ('Value', _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 70), ('criticality', 'ignore'), ('Value', _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 18), ('criticality', 'reject'), ('Value', _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 76), ('criticality', 'ignore'), ('Value', _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 23), ('criticality', 'ignore'), ('Value', _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 146), ('criticality', 'ignore'), ('Value', _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 150), ('criticality', 'ignore'), ('Value', _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 154), ('criticality', 'ignore'), ('Value', _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 174), ('criticality', 'reject'), ('Value', _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')]), dict([('id', 178), ('criticality', 'ignore'), ('Value', _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_17), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BearerContextModificationRequest_protocolIEs__item__id._const_tab = ____BearerContextModificationRequest_protocolIEs__item__id_tab
    ___BearerContextModificationRequest_protocolIEs__item__id._const_tab_at = None
    ___BearerContextModificationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___BearerContextModificationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BearerContextModificationRequest_protocolIEs__item__criticality._const_tab = ____BearerContextModificationRequest_protocolIEs__item__id_tab
    ___BearerContextModificationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BearerContextModificationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BearerContextModificationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BearerContextModificationRequest_protocolIEs__item__value._const_tab = ____BearerContextModificationRequest_protocolIEs__item__id_tab
    ___BearerContextModificationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BearerContextModificationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __BearerContextModificationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BearerContextModificationRequest_protocolIEs__item__id),
        ('criticality', ___BearerContextModificationRequest_protocolIEs__item__criticality),
        ('value', ___BearerContextModificationRequest_protocolIEs__item__value),
        ])
    __BearerContextModificationRequest_protocolIEs__item_._ext = None
    _BearerContextModificationRequest_protocolIEs._cont = __BearerContextModificationRequest_protocolIEs__item_
    _BearerContextModificationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BearerContextModificationRequest._cont = ASN1Dict([
        ('protocolIEs', _BearerContextModificationRequest_protocolIEs),
        ])
    BearerContextModificationRequest._ext = []
    
    #-----< BearerContextModificationRequestIEs >-----#
    BearerContextModificationRequestIEs = CLASS(name='BearerContextModificationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _BearerContextModificationRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _BearerContextModificationRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _BearerContextModificationRequestIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SecurityInformation')))
    _BearerContextModificationRequestIEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BitRate')))
    _BearerContextModificationRequestIEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BitRate')))
    _BearerContextModificationRequestIEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BearerContextStatusChange')))
    _BearerContextModificationRequestIEs_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'New-UL-TNL-Information-Required')))
    _BearerContextModificationRequestIEs_val_Value_7 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Inactivity-Timer')))
    _BearerContextModificationRequestIEs_val_Value_8 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DataDiscardRequired')))
    _BearerContextModificationRequestIEs_val_Value_9 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'System-BearerContextModificationRequest')))
    _BearerContextModificationRequestIEs_val_Value_10 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'RANUEID')))
    _BearerContextModificationRequestIEs_val_Value_11 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-DU-ID')))
    _BearerContextModificationRequestIEs_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ActivityNotificationLevel')))
    _BearerContextModificationRequestIEs_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MDTPollutedMeasurementIndicator')))
    _BearerContextModificationRequestIEs_val_Value_14 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'UESliceMaximumBitRateList')))
    _BearerContextModificationRequestIEs_val_Value_15 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SCGActivationStatus')))
    _BearerContextModificationRequestIEs_val_Value_16 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SDTContinueROHC')))
    _BearerContextModificationRequestIEs_val_Value_17 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MDTPLMNModificationList')))
    BearerContextModificationRequestIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _BearerContextModificationRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _BearerContextModificationRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'reject'), ('Value', _BearerContextModificationRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 14), ('criticality', 'reject'), ('Value', _BearerContextModificationRequestIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 66), ('criticality', 'reject'), ('Value', _BearerContextModificationRequestIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'reject'), ('Value', _BearerContextModificationRequestIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 26), ('criticality', 'reject'), ('Value', _BearerContextModificationRequestIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 59), ('criticality', 'reject'), ('Value', _BearerContextModificationRequestIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 70), ('criticality', 'ignore'), ('Value', _BearerContextModificationRequestIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 18), ('criticality', 'reject'), ('Value', _BearerContextModificationRequestIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 76), ('criticality', 'ignore'), ('Value', _BearerContextModificationRequestIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _BearerContextModificationRequestIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 23), ('criticality', 'ignore'), ('Value', _BearerContextModificationRequestIEs_val_Value_12), ('presence', 'optional')]), dict([('id', 146), ('criticality', 'ignore'), ('Value', _BearerContextModificationRequestIEs_val_Value_13), ('presence', 'optional')]), dict([('id', 150), ('criticality', 'ignore'), ('Value', _BearerContextModificationRequestIEs_val_Value_14), ('presence', 'optional')]), dict([('id', 154), ('criticality', 'ignore'), ('Value', _BearerContextModificationRequestIEs_val_Value_15), ('presence', 'optional')]), dict([('id', 174), ('criticality', 'reject'), ('Value', _BearerContextModificationRequestIEs_val_Value_16), ('presence', 'optional')]), dict([('id', 178), ('criticality', 'ignore'), ('Value', _BearerContextModificationRequestIEs_val_Value_17), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< System-BearerContextModificationRequest >-----#
    System_BearerContextModificationRequest = CHOICE(name='System-BearerContextModificationRequest', mode=MODE_TYPE)
    _System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest = SEQ_OF(name='e-UTRAN-BearerContextModificationRequest', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-To-Setup-Mod-List-EUTRAN')))
    _____System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-To-Modify-List-EUTRAN')))
    _____System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-To-Remove-List-EUTRAN')))
    _____System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SubscriberProfileIDforRFP')))
    _____System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id_tab_val_Value_4 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'AdditionalRRMPriorityIndex')))
    ____System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id_tab._val = ASN1Set(rv=[dict([('id', 51), ('criticality', 'reject'), ('Value', _____System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 33), ('criticality', 'reject'), ('Value', _____System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 34), ('criticality', 'reject'), ('Value', _____System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 83), ('criticality', 'ignore'), ('Value', _____System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 84), ('criticality', 'ignore'), ('Value', _____System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id._const_tab = ____System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id_tab
    ___System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id._const_tab_at = None
    ___System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id._const_tab_id = 'id'
    ___System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__criticality._const_tab = ____System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id_tab
    ___System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__criticality._const_tab_at = ('..', 'id')
    ___System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__criticality._const_tab_id = 'criticality'
    ___System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__value._const_tab = ____System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id_tab
    ___System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__value._const_tab_at = ('..', 'id')
    ___System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__value._const_tab_id = 'Value'
    __System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item_._cont = ASN1Dict([
        ('id', ___System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id),
        ('criticality', ___System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__criticality),
        ('value', ___System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__value),
        ])
    __System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item_._ext = None
    _System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest._cont = __System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item_
    _System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest = SEQ_OF(name='nG-RAN-BearerContextModificationRequest', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-To-Setup-Mod-List')))
    _____System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-To-Modify-List')))
    _____System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-To-Remove-List')))
    ____System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__id_tab._val = ASN1Set(rv=[dict([('id', 56), ('criticality', 'reject'), ('Value', _____System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 43), ('criticality', 'reject'), ('Value', _____System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 44), ('criticality', 'reject'), ('Value', _____System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__id._const_tab = ____System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__id_tab
    ___System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__id._const_tab_at = None
    ___System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__id._const_tab_id = 'id'
    ___System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__criticality._const_tab = ____System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__id_tab
    ___System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__criticality._const_tab_at = ('..', 'id')
    ___System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__criticality._const_tab_id = 'criticality'
    ___System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__value._const_tab = ____System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__id_tab
    ___System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__value._const_tab_at = ('..', 'id')
    ___System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__value._const_tab_id = 'Value'
    __System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item_._cont = ASN1Dict([
        ('id', ___System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__id),
        ('criticality', ___System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__criticality),
        ('value', ___System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__value),
        ])
    __System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item_._ext = None
    _System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest._cont = __System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item_
    _System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _System_BearerContextModificationRequest_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __System_BearerContextModificationRequest_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___System_BearerContextModificationRequest_choice_extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___System_BearerContextModificationRequest_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __System_BearerContextModificationRequest_choice_extension_id._const_tab = ___System_BearerContextModificationRequest_choice_extension_id_tab
    __System_BearerContextModificationRequest_choice_extension_id._const_tab_at = None
    __System_BearerContextModificationRequest_choice_extension_id._const_tab_id = 'id'
    __System_BearerContextModificationRequest_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___System_BearerContextModificationRequest_choice_extension_criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___System_BearerContextModificationRequest_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __System_BearerContextModificationRequest_choice_extension_criticality._const_tab = ___System_BearerContextModificationRequest_choice_extension_criticality_tab
    __System_BearerContextModificationRequest_choice_extension_criticality._const_tab_at = ('..', 'id')
    __System_BearerContextModificationRequest_choice_extension_criticality._const_tab_id = 'criticality'
    __System_BearerContextModificationRequest_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___System_BearerContextModificationRequest_choice_extension_value_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___System_BearerContextModificationRequest_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __System_BearerContextModificationRequest_choice_extension_value._const_tab = ___System_BearerContextModificationRequest_choice_extension_value_tab
    __System_BearerContextModificationRequest_choice_extension_value._const_tab_at = ('..', 'id')
    __System_BearerContextModificationRequest_choice_extension_value._const_tab_id = 'Value'
    _System_BearerContextModificationRequest_choice_extension._cont = ASN1Dict([
        ('id', __System_BearerContextModificationRequest_choice_extension_id),
        ('criticality', __System_BearerContextModificationRequest_choice_extension_criticality),
        ('value', __System_BearerContextModificationRequest_choice_extension_value),
        ])
    _System_BearerContextModificationRequest_choice_extension._ext = None
    System_BearerContextModificationRequest._cont = ASN1Dict([
        ('e-UTRAN-BearerContextModificationRequest', _System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest),
        ('nG-RAN-BearerContextModificationRequest', _System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest),
        ('choice-extension', _System_BearerContextModificationRequest_choice_extension),
        ])
    System_BearerContextModificationRequest._ext = None
    
    #-----< System-BearerContextModificationRequest-ExtIEs >-----#
    System_BearerContextModificationRequest_ExtIEs = CLASS(name='System-BearerContextModificationRequest-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    System_BearerContextModificationRequest_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRAN-BearerContextModificationRequest >-----#
    EUTRAN_BearerContextModificationRequest = CLASS(name='EUTRAN-BearerContextModificationRequest', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _EUTRAN_BearerContextModificationRequest_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-To-Setup-Mod-List-EUTRAN')))
    _EUTRAN_BearerContextModificationRequest_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-To-Modify-List-EUTRAN')))
    _EUTRAN_BearerContextModificationRequest_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-To-Remove-List-EUTRAN')))
    _EUTRAN_BearerContextModificationRequest_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'SubscriberProfileIDforRFP')))
    _EUTRAN_BearerContextModificationRequest_val_Value_4 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'AdditionalRRMPriorityIndex')))
    EUTRAN_BearerContextModificationRequest._val = ASN1Set(rv=[dict([('id', 51), ('criticality', 'reject'), ('Value', _EUTRAN_BearerContextModificationRequest_val_Value_0), ('presence', 'optional')]), dict([('id', 33), ('criticality', 'reject'), ('Value', _EUTRAN_BearerContextModificationRequest_val_Value_1), ('presence', 'optional')]), dict([('id', 34), ('criticality', 'reject'), ('Value', _EUTRAN_BearerContextModificationRequest_val_Value_2), ('presence', 'optional')]), dict([('id', 83), ('criticality', 'ignore'), ('Value', _EUTRAN_BearerContextModificationRequest_val_Value_3), ('presence', 'optional')]), dict([('id', 84), ('criticality', 'ignore'), ('Value', _EUTRAN_BearerContextModificationRequest_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< NG-RAN-BearerContextModificationRequest >-----#
    NG_RAN_BearerContextModificationRequest = CLASS(name='NG-RAN-BearerContextModificationRequest', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _NG_RAN_BearerContextModificationRequest_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-To-Setup-Mod-List')))
    _NG_RAN_BearerContextModificationRequest_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-To-Modify-List')))
    _NG_RAN_BearerContextModificationRequest_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-To-Remove-List')))
    NG_RAN_BearerContextModificationRequest._val = ASN1Set(rv=[dict([('id', 56), ('criticality', 'reject'), ('Value', _NG_RAN_BearerContextModificationRequest_val_Value_0), ('presence', 'optional')]), dict([('id', 43), ('criticality', 'reject'), ('Value', _NG_RAN_BearerContextModificationRequest_val_Value_1), ('presence', 'optional')]), dict([('id', 44), ('criticality', 'reject'), ('Value', _NG_RAN_BearerContextModificationRequest_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BearerContextModificationResponse >-----#
    BearerContextModificationResponse = SEQ(name='BearerContextModificationResponse', mode=MODE_TYPE)
    _BearerContextModificationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __BearerContextModificationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___BearerContextModificationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____BearerContextModificationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____BearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _____BearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _____BearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'System-BearerContextModificationResponse')))
    _____BearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____BearerContextModificationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____BearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____BearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____BearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____BearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BearerContextModificationResponse_protocolIEs__item__id._const_tab = ____BearerContextModificationResponse_protocolIEs__item__id_tab
    ___BearerContextModificationResponse_protocolIEs__item__id._const_tab_at = None
    ___BearerContextModificationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___BearerContextModificationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BearerContextModificationResponse_protocolIEs__item__criticality._const_tab = ____BearerContextModificationResponse_protocolIEs__item__id_tab
    ___BearerContextModificationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BearerContextModificationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BearerContextModificationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BearerContextModificationResponse_protocolIEs__item__value._const_tab = ____BearerContextModificationResponse_protocolIEs__item__id_tab
    ___BearerContextModificationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BearerContextModificationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __BearerContextModificationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BearerContextModificationResponse_protocolIEs__item__id),
        ('criticality', ___BearerContextModificationResponse_protocolIEs__item__criticality),
        ('value', ___BearerContextModificationResponse_protocolIEs__item__value),
        ])
    __BearerContextModificationResponse_protocolIEs__item_._ext = None
    _BearerContextModificationResponse_protocolIEs._cont = __BearerContextModificationResponse_protocolIEs__item_
    _BearerContextModificationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BearerContextModificationResponse._cont = ASN1Dict([
        ('protocolIEs', _BearerContextModificationResponse_protocolIEs),
        ])
    BearerContextModificationResponse._ext = []
    
    #-----< BearerContextModificationResponseIEs >-----#
    BearerContextModificationResponseIEs = CLASS(name='BearerContextModificationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _BearerContextModificationResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _BearerContextModificationResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _BearerContextModificationResponseIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'System-BearerContextModificationResponse')))
    _BearerContextModificationResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    BearerContextModificationResponseIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _BearerContextModificationResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _BearerContextModificationResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _BearerContextModificationResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _BearerContextModificationResponseIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< System-BearerContextModificationResponse >-----#
    System_BearerContextModificationResponse = CHOICE(name='System-BearerContextModificationResponse', mode=MODE_TYPE)
    _System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse = SEQ_OF(name='e-UTRAN-BearerContextModificationResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Setup-Mod-List-EUTRAN')))
    _____System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Failed-Mod-List-EUTRAN')))
    _____System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Modified-List-EUTRAN')))
    _____System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Failed-To-Modify-List-EUTRAN')))
    _____System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'RetainabilityMeasurementsInfo')))
    ____System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id_tab._val = ASN1Set(rv=[dict([('id', 52), ('criticality', 'ignore'), ('Value', _____System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 53), ('criticality', 'ignore'), ('Value', _____System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 39), ('criticality', 'ignore'), ('Value', _____System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 40), ('criticality', 'ignore'), ('Value', _____System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id._const_tab = ____System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id_tab
    ___System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id._const_tab_at = None
    ___System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id._const_tab_id = 'id'
    ___System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__criticality._const_tab = ____System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id_tab
    ___System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__criticality._const_tab_at = ('..', 'id')
    ___System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__criticality._const_tab_id = 'criticality'
    ___System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__value._const_tab = ____System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id_tab
    ___System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__value._const_tab_at = ('..', 'id')
    ___System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__value._const_tab_id = 'Value'
    __System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item_._cont = ASN1Dict([
        ('id', ___System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id),
        ('criticality', ___System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__criticality),
        ('value', ___System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__value),
        ])
    __System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item_._ext = None
    _System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse._cont = __System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item_
    _System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse = SEQ_OF(name='nG-RAN-BearerContextModificationResponse', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Setup-Mod-List')))
    _____System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Failed-Mod-List')))
    _____System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Modified-List')))
    _____System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Failed-To-Modify-List')))
    _____System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'RetainabilityMeasurementsInfo')))
    ____System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id_tab._val = ASN1Set(rv=[dict([('id', 54), ('criticality', 'reject'), ('Value', _____System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 55), ('criticality', 'reject'), ('Value', _____System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 48), ('criticality', 'reject'), ('Value', _____System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 49), ('criticality', 'reject'), ('Value', _____System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id._const_tab = ____System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id_tab
    ___System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id._const_tab_at = None
    ___System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id._const_tab_id = 'id'
    ___System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__criticality._const_tab = ____System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id_tab
    ___System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__criticality._const_tab_at = ('..', 'id')
    ___System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__criticality._const_tab_id = 'criticality'
    ___System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__value._const_tab = ____System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id_tab
    ___System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__value._const_tab_at = ('..', 'id')
    ___System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__value._const_tab_id = 'Value'
    __System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item_._cont = ASN1Dict([
        ('id', ___System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id),
        ('criticality', ___System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__criticality),
        ('value', ___System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__value),
        ])
    __System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item_._ext = None
    _System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse._cont = __System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item_
    _System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _System_BearerContextModificationResponse_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __System_BearerContextModificationResponse_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___System_BearerContextModificationResponse_choice_extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___System_BearerContextModificationResponse_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __System_BearerContextModificationResponse_choice_extension_id._const_tab = ___System_BearerContextModificationResponse_choice_extension_id_tab
    __System_BearerContextModificationResponse_choice_extension_id._const_tab_at = None
    __System_BearerContextModificationResponse_choice_extension_id._const_tab_id = 'id'
    __System_BearerContextModificationResponse_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___System_BearerContextModificationResponse_choice_extension_criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___System_BearerContextModificationResponse_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __System_BearerContextModificationResponse_choice_extension_criticality._const_tab = ___System_BearerContextModificationResponse_choice_extension_criticality_tab
    __System_BearerContextModificationResponse_choice_extension_criticality._const_tab_at = ('..', 'id')
    __System_BearerContextModificationResponse_choice_extension_criticality._const_tab_id = 'criticality'
    __System_BearerContextModificationResponse_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___System_BearerContextModificationResponse_choice_extension_value_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___System_BearerContextModificationResponse_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __System_BearerContextModificationResponse_choice_extension_value._const_tab = ___System_BearerContextModificationResponse_choice_extension_value_tab
    __System_BearerContextModificationResponse_choice_extension_value._const_tab_at = ('..', 'id')
    __System_BearerContextModificationResponse_choice_extension_value._const_tab_id = 'Value'
    _System_BearerContextModificationResponse_choice_extension._cont = ASN1Dict([
        ('id', __System_BearerContextModificationResponse_choice_extension_id),
        ('criticality', __System_BearerContextModificationResponse_choice_extension_criticality),
        ('value', __System_BearerContextModificationResponse_choice_extension_value),
        ])
    _System_BearerContextModificationResponse_choice_extension._ext = None
    System_BearerContextModificationResponse._cont = ASN1Dict([
        ('e-UTRAN-BearerContextModificationResponse', _System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse),
        ('nG-RAN-BearerContextModificationResponse', _System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse),
        ('choice-extension', _System_BearerContextModificationResponse_choice_extension),
        ])
    System_BearerContextModificationResponse._ext = None
    
    #-----< System-BearerContextModificationResponse-ExtIEs >-----#
    System_BearerContextModificationResponse_ExtIEs = CLASS(name='System-BearerContextModificationResponse-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    System_BearerContextModificationResponse_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRAN-BearerContextModificationResponse >-----#
    EUTRAN_BearerContextModificationResponse = CLASS(name='EUTRAN-BearerContextModificationResponse', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _EUTRAN_BearerContextModificationResponse_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Setup-Mod-List-EUTRAN')))
    _EUTRAN_BearerContextModificationResponse_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Failed-Mod-List-EUTRAN')))
    _EUTRAN_BearerContextModificationResponse_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Modified-List-EUTRAN')))
    _EUTRAN_BearerContextModificationResponse_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Failed-To-Modify-List-EUTRAN')))
    _EUTRAN_BearerContextModificationResponse_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'RetainabilityMeasurementsInfo')))
    EUTRAN_BearerContextModificationResponse._val = ASN1Set(rv=[dict([('id', 52), ('criticality', 'ignore'), ('Value', _EUTRAN_BearerContextModificationResponse_val_Value_0), ('presence', 'optional')]), dict([('id', 53), ('criticality', 'ignore'), ('Value', _EUTRAN_BearerContextModificationResponse_val_Value_1), ('presence', 'optional')]), dict([('id', 39), ('criticality', 'ignore'), ('Value', _EUTRAN_BearerContextModificationResponse_val_Value_2), ('presence', 'optional')]), dict([('id', 40), ('criticality', 'ignore'), ('Value', _EUTRAN_BearerContextModificationResponse_val_Value_3), ('presence', 'optional')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _EUTRAN_BearerContextModificationResponse_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< NG-RAN-BearerContextModificationResponse >-----#
    NG_RAN_BearerContextModificationResponse = CLASS(name='NG-RAN-BearerContextModificationResponse', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _NG_RAN_BearerContextModificationResponse_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Setup-Mod-List')))
    _NG_RAN_BearerContextModificationResponse_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Failed-Mod-List')))
    _NG_RAN_BearerContextModificationResponse_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Modified-List')))
    _NG_RAN_BearerContextModificationResponse_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Failed-To-Modify-List')))
    _NG_RAN_BearerContextModificationResponse_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'RetainabilityMeasurementsInfo')))
    NG_RAN_BearerContextModificationResponse._val = ASN1Set(rv=[dict([('id', 54), ('criticality', 'reject'), ('Value', _NG_RAN_BearerContextModificationResponse_val_Value_0), ('presence', 'optional')]), dict([('id', 55), ('criticality', 'reject'), ('Value', _NG_RAN_BearerContextModificationResponse_val_Value_1), ('presence', 'optional')]), dict([('id', 48), ('criticality', 'reject'), ('Value', _NG_RAN_BearerContextModificationResponse_val_Value_2), ('presence', 'optional')]), dict([('id', 49), ('criticality', 'reject'), ('Value', _NG_RAN_BearerContextModificationResponse_val_Value_3), ('presence', 'optional')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _NG_RAN_BearerContextModificationResponse_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BearerContextModificationFailure >-----#
    BearerContextModificationFailure = SEQ(name='BearerContextModificationFailure', mode=MODE_TYPE)
    _BearerContextModificationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __BearerContextModificationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___BearerContextModificationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____BearerContextModificationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____BearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _____BearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _____BearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _____BearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____BearerContextModificationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____BearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____BearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____BearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____BearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BearerContextModificationFailure_protocolIEs__item__id._const_tab = ____BearerContextModificationFailure_protocolIEs__item__id_tab
    ___BearerContextModificationFailure_protocolIEs__item__id._const_tab_at = None
    ___BearerContextModificationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___BearerContextModificationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BearerContextModificationFailure_protocolIEs__item__criticality._const_tab = ____BearerContextModificationFailure_protocolIEs__item__id_tab
    ___BearerContextModificationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BearerContextModificationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BearerContextModificationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BearerContextModificationFailure_protocolIEs__item__value._const_tab = ____BearerContextModificationFailure_protocolIEs__item__id_tab
    ___BearerContextModificationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BearerContextModificationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __BearerContextModificationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BearerContextModificationFailure_protocolIEs__item__id),
        ('criticality', ___BearerContextModificationFailure_protocolIEs__item__criticality),
        ('value', ___BearerContextModificationFailure_protocolIEs__item__value),
        ])
    __BearerContextModificationFailure_protocolIEs__item_._ext = None
    _BearerContextModificationFailure_protocolIEs._cont = __BearerContextModificationFailure_protocolIEs__item_
    _BearerContextModificationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BearerContextModificationFailure._cont = ASN1Dict([
        ('protocolIEs', _BearerContextModificationFailure_protocolIEs),
        ])
    BearerContextModificationFailure._ext = []
    
    #-----< BearerContextModificationFailureIEs >-----#
    BearerContextModificationFailureIEs = CLASS(name='BearerContextModificationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _BearerContextModificationFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _BearerContextModificationFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _BearerContextModificationFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _BearerContextModificationFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    BearerContextModificationFailureIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _BearerContextModificationFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _BearerContextModificationFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _BearerContextModificationFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _BearerContextModificationFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BearerContextModificationRequired >-----#
    BearerContextModificationRequired = SEQ(name='BearerContextModificationRequired', mode=MODE_TYPE)
    _BearerContextModificationRequired_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __BearerContextModificationRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___BearerContextModificationRequired_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____BearerContextModificationRequired_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____BearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _____BearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _____BearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'System-BearerContextModificationRequired')))
    ____BearerContextModificationRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____BearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____BearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 21), ('criticality', 'reject'), ('Value', _____BearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___BearerContextModificationRequired_protocolIEs__item__id._const_tab = ____BearerContextModificationRequired_protocolIEs__item__id_tab
    ___BearerContextModificationRequired_protocolIEs__item__id._const_tab_at = None
    ___BearerContextModificationRequired_protocolIEs__item__id._const_tab_id = 'id'
    ___BearerContextModificationRequired_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BearerContextModificationRequired_protocolIEs__item__criticality._const_tab = ____BearerContextModificationRequired_protocolIEs__item__id_tab
    ___BearerContextModificationRequired_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BearerContextModificationRequired_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BearerContextModificationRequired_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BearerContextModificationRequired_protocolIEs__item__value._const_tab = ____BearerContextModificationRequired_protocolIEs__item__id_tab
    ___BearerContextModificationRequired_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BearerContextModificationRequired_protocolIEs__item__value._const_tab_id = 'Value'
    __BearerContextModificationRequired_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BearerContextModificationRequired_protocolIEs__item__id),
        ('criticality', ___BearerContextModificationRequired_protocolIEs__item__criticality),
        ('value', ___BearerContextModificationRequired_protocolIEs__item__value),
        ])
    __BearerContextModificationRequired_protocolIEs__item_._ext = None
    _BearerContextModificationRequired_protocolIEs._cont = __BearerContextModificationRequired_protocolIEs__item_
    _BearerContextModificationRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BearerContextModificationRequired._cont = ASN1Dict([
        ('protocolIEs', _BearerContextModificationRequired_protocolIEs),
        ])
    BearerContextModificationRequired._ext = []
    
    #-----< BearerContextModificationRequiredIEs >-----#
    BearerContextModificationRequiredIEs = CLASS(name='BearerContextModificationRequiredIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _BearerContextModificationRequiredIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _BearerContextModificationRequiredIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _BearerContextModificationRequiredIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'System-BearerContextModificationRequired')))
    BearerContextModificationRequiredIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _BearerContextModificationRequiredIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _BearerContextModificationRequiredIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 21), ('criticality', 'reject'), ('Value', _BearerContextModificationRequiredIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< System-BearerContextModificationRequired >-----#
    System_BearerContextModificationRequired = CHOICE(name='System-BearerContextModificationRequired', mode=MODE_TYPE)
    _System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired = SEQ_OF(name='e-UTRAN-BearerContextModificationRequired', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Required-To-Modify-List-EUTRAN')))
    _____System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Required-To-Remove-List-EUTRAN')))
    ____System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__id_tab._val = ASN1Set(rv=[dict([('id', 35), ('criticality', 'reject'), ('Value', _____System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 36), ('criticality', 'reject'), ('Value', _____System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__id._const_tab = ____System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__id_tab
    ___System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__id._const_tab_at = None
    ___System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__id._const_tab_id = 'id'
    ___System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__criticality._const_tab = ____System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__id_tab
    ___System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__criticality._const_tab_at = ('..', 'id')
    ___System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__criticality._const_tab_id = 'criticality'
    ___System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__value._const_tab = ____System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__id_tab
    ___System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__value._const_tab_at = ('..', 'id')
    ___System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__value._const_tab_id = 'Value'
    __System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item_._cont = ASN1Dict([
        ('id', ___System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__id),
        ('criticality', ___System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__criticality),
        ('value', ___System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__value),
        ])
    __System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item_._ext = None
    _System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired._cont = __System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item_
    _System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired = SEQ_OF(name='nG-RAN-BearerContextModificationRequired', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Required-To-Modify-List')))
    _____System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-To-Remove-List')))
    ____System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__id_tab._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'reject'), ('Value', _____System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 44), ('criticality', 'reject'), ('Value', _____System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__id._const_tab = ____System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__id_tab
    ___System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__id._const_tab_at = None
    ___System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__id._const_tab_id = 'id'
    ___System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__criticality._const_tab = ____System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__id_tab
    ___System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__criticality._const_tab_at = ('..', 'id')
    ___System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__criticality._const_tab_id = 'criticality'
    ___System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__value._const_tab = ____System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__id_tab
    ___System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__value._const_tab_at = ('..', 'id')
    ___System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__value._const_tab_id = 'Value'
    __System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item_._cont = ASN1Dict([
        ('id', ___System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__id),
        ('criticality', ___System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__criticality),
        ('value', ___System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__value),
        ])
    __System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item_._ext = None
    _System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired._cont = __System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item_
    _System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _System_BearerContextModificationRequired_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __System_BearerContextModificationRequired_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___System_BearerContextModificationRequired_choice_extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___System_BearerContextModificationRequired_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __System_BearerContextModificationRequired_choice_extension_id._const_tab = ___System_BearerContextModificationRequired_choice_extension_id_tab
    __System_BearerContextModificationRequired_choice_extension_id._const_tab_at = None
    __System_BearerContextModificationRequired_choice_extension_id._const_tab_id = 'id'
    __System_BearerContextModificationRequired_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___System_BearerContextModificationRequired_choice_extension_criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___System_BearerContextModificationRequired_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __System_BearerContextModificationRequired_choice_extension_criticality._const_tab = ___System_BearerContextModificationRequired_choice_extension_criticality_tab
    __System_BearerContextModificationRequired_choice_extension_criticality._const_tab_at = ('..', 'id')
    __System_BearerContextModificationRequired_choice_extension_criticality._const_tab_id = 'criticality'
    __System_BearerContextModificationRequired_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___System_BearerContextModificationRequired_choice_extension_value_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___System_BearerContextModificationRequired_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __System_BearerContextModificationRequired_choice_extension_value._const_tab = ___System_BearerContextModificationRequired_choice_extension_value_tab
    __System_BearerContextModificationRequired_choice_extension_value._const_tab_at = ('..', 'id')
    __System_BearerContextModificationRequired_choice_extension_value._const_tab_id = 'Value'
    _System_BearerContextModificationRequired_choice_extension._cont = ASN1Dict([
        ('id', __System_BearerContextModificationRequired_choice_extension_id),
        ('criticality', __System_BearerContextModificationRequired_choice_extension_criticality),
        ('value', __System_BearerContextModificationRequired_choice_extension_value),
        ])
    _System_BearerContextModificationRequired_choice_extension._ext = None
    System_BearerContextModificationRequired._cont = ASN1Dict([
        ('e-UTRAN-BearerContextModificationRequired', _System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired),
        ('nG-RAN-BearerContextModificationRequired', _System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired),
        ('choice-extension', _System_BearerContextModificationRequired_choice_extension),
        ])
    System_BearerContextModificationRequired._ext = None
    
    #-----< System-BearerContextModificationRequired-ExtIEs >-----#
    System_BearerContextModificationRequired_ExtIEs = CLASS(name='System-BearerContextModificationRequired-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    System_BearerContextModificationRequired_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRAN-BearerContextModificationRequired >-----#
    EUTRAN_BearerContextModificationRequired = CLASS(name='EUTRAN-BearerContextModificationRequired', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _EUTRAN_BearerContextModificationRequired_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Required-To-Modify-List-EUTRAN')))
    _EUTRAN_BearerContextModificationRequired_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Required-To-Remove-List-EUTRAN')))
    EUTRAN_BearerContextModificationRequired._val = ASN1Set(rv=[dict([('id', 35), ('criticality', 'reject'), ('Value', _EUTRAN_BearerContextModificationRequired_val_Value_0), ('presence', 'optional')]), dict([('id', 36), ('criticality', 'reject'), ('Value', _EUTRAN_BearerContextModificationRequired_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< NG-RAN-BearerContextModificationRequired >-----#
    NG_RAN_BearerContextModificationRequired = CLASS(name='NG-RAN-BearerContextModificationRequired', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _NG_RAN_BearerContextModificationRequired_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Required-To-Modify-List')))
    _NG_RAN_BearerContextModificationRequired_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-To-Remove-List')))
    NG_RAN_BearerContextModificationRequired._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'reject'), ('Value', _NG_RAN_BearerContextModificationRequired_val_Value_0), ('presence', 'optional')]), dict([('id', 44), ('criticality', 'reject'), ('Value', _NG_RAN_BearerContextModificationRequired_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BearerContextModificationConfirm >-----#
    BearerContextModificationConfirm = SEQ(name='BearerContextModificationConfirm', mode=MODE_TYPE)
    _BearerContextModificationConfirm_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __BearerContextModificationConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___BearerContextModificationConfirm_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____BearerContextModificationConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____BearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _____BearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _____BearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'System-BearerContextModificationConfirm')))
    _____BearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____BearerContextModificationConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____BearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____BearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 20), ('criticality', 'ignore'), ('Value', _____BearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____BearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BearerContextModificationConfirm_protocolIEs__item__id._const_tab = ____BearerContextModificationConfirm_protocolIEs__item__id_tab
    ___BearerContextModificationConfirm_protocolIEs__item__id._const_tab_at = None
    ___BearerContextModificationConfirm_protocolIEs__item__id._const_tab_id = 'id'
    ___BearerContextModificationConfirm_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BearerContextModificationConfirm_protocolIEs__item__criticality._const_tab = ____BearerContextModificationConfirm_protocolIEs__item__id_tab
    ___BearerContextModificationConfirm_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BearerContextModificationConfirm_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BearerContextModificationConfirm_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BearerContextModificationConfirm_protocolIEs__item__value._const_tab = ____BearerContextModificationConfirm_protocolIEs__item__id_tab
    ___BearerContextModificationConfirm_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BearerContextModificationConfirm_protocolIEs__item__value._const_tab_id = 'Value'
    __BearerContextModificationConfirm_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BearerContextModificationConfirm_protocolIEs__item__id),
        ('criticality', ___BearerContextModificationConfirm_protocolIEs__item__criticality),
        ('value', ___BearerContextModificationConfirm_protocolIEs__item__value),
        ])
    __BearerContextModificationConfirm_protocolIEs__item_._ext = None
    _BearerContextModificationConfirm_protocolIEs._cont = __BearerContextModificationConfirm_protocolIEs__item_
    _BearerContextModificationConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BearerContextModificationConfirm._cont = ASN1Dict([
        ('protocolIEs', _BearerContextModificationConfirm_protocolIEs),
        ])
    BearerContextModificationConfirm._ext = []
    
    #-----< BearerContextModificationConfirmIEs >-----#
    BearerContextModificationConfirmIEs = CLASS(name='BearerContextModificationConfirmIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _BearerContextModificationConfirmIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _BearerContextModificationConfirmIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _BearerContextModificationConfirmIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'System-BearerContextModificationConfirm')))
    _BearerContextModificationConfirmIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    BearerContextModificationConfirmIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _BearerContextModificationConfirmIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _BearerContextModificationConfirmIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 20), ('criticality', 'ignore'), ('Value', _BearerContextModificationConfirmIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _BearerContextModificationConfirmIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< System-BearerContextModificationConfirm >-----#
    System_BearerContextModificationConfirm = CHOICE(name='System-BearerContextModificationConfirm', mode=MODE_TYPE)
    _System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm = SEQ_OF(name='e-UTRAN-BearerContextModificationConfirm', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Confirm-Modified-List-EUTRAN')))
    ____System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__id_tab._val = ASN1Set(rv=[dict([('id', 41), ('criticality', 'ignore'), ('Value', _____System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__id._const_tab = ____System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__id_tab
    ___System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__id._const_tab_at = None
    ___System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__id._const_tab_id = 'id'
    ___System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__criticality._const_tab = ____System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__id_tab
    ___System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__criticality._const_tab_at = ('..', 'id')
    ___System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__criticality._const_tab_id = 'criticality'
    ___System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__value._const_tab = ____System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__id_tab
    ___System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__value._const_tab_at = ('..', 'id')
    ___System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__value._const_tab_id = 'Value'
    __System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item_._cont = ASN1Dict([
        ('id', ___System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__id),
        ('criticality', ___System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__criticality),
        ('value', ___System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__value),
        ])
    __System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item_._ext = None
    _System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm._cont = __System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item_
    _System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm = SEQ_OF(name='nG-RAN-BearerContextModificationConfirm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Confirm-Modified-List')))
    ____System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__id_tab._val = ASN1Set(rv=[dict([('id', 50), ('criticality', 'ignore'), ('Value', _____System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__id._const_tab = ____System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__id_tab
    ___System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__id._const_tab_at = None
    ___System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__id._const_tab_id = 'id'
    ___System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__criticality._const_tab = ____System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__id_tab
    ___System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__criticality._const_tab_at = ('..', 'id')
    ___System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__criticality._const_tab_id = 'criticality'
    ___System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__value._const_tab = ____System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__id_tab
    ___System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__value._const_tab_at = ('..', 'id')
    ___System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__value._const_tab_id = 'Value'
    __System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item_._cont = ASN1Dict([
        ('id', ___System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__id),
        ('criticality', ___System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__criticality),
        ('value', ___System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__value),
        ])
    __System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item_._ext = None
    _System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm._cont = __System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item_
    _System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _System_BearerContextModificationConfirm_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __System_BearerContextModificationConfirm_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___System_BearerContextModificationConfirm_choice_extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___System_BearerContextModificationConfirm_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __System_BearerContextModificationConfirm_choice_extension_id._const_tab = ___System_BearerContextModificationConfirm_choice_extension_id_tab
    __System_BearerContextModificationConfirm_choice_extension_id._const_tab_at = None
    __System_BearerContextModificationConfirm_choice_extension_id._const_tab_id = 'id'
    __System_BearerContextModificationConfirm_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___System_BearerContextModificationConfirm_choice_extension_criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___System_BearerContextModificationConfirm_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __System_BearerContextModificationConfirm_choice_extension_criticality._const_tab = ___System_BearerContextModificationConfirm_choice_extension_criticality_tab
    __System_BearerContextModificationConfirm_choice_extension_criticality._const_tab_at = ('..', 'id')
    __System_BearerContextModificationConfirm_choice_extension_criticality._const_tab_id = 'criticality'
    __System_BearerContextModificationConfirm_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___System_BearerContextModificationConfirm_choice_extension_value_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___System_BearerContextModificationConfirm_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __System_BearerContextModificationConfirm_choice_extension_value._const_tab = ___System_BearerContextModificationConfirm_choice_extension_value_tab
    __System_BearerContextModificationConfirm_choice_extension_value._const_tab_at = ('..', 'id')
    __System_BearerContextModificationConfirm_choice_extension_value._const_tab_id = 'Value'
    _System_BearerContextModificationConfirm_choice_extension._cont = ASN1Dict([
        ('id', __System_BearerContextModificationConfirm_choice_extension_id),
        ('criticality', __System_BearerContextModificationConfirm_choice_extension_criticality),
        ('value', __System_BearerContextModificationConfirm_choice_extension_value),
        ])
    _System_BearerContextModificationConfirm_choice_extension._ext = None
    System_BearerContextModificationConfirm._cont = ASN1Dict([
        ('e-UTRAN-BearerContextModificationConfirm', _System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm),
        ('nG-RAN-BearerContextModificationConfirm', _System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm),
        ('choice-extension', _System_BearerContextModificationConfirm_choice_extension),
        ])
    System_BearerContextModificationConfirm._ext = None
    
    #-----< System-BearerContextModificationConfirm-ExtIEs >-----#
    System_BearerContextModificationConfirm_ExtIEs = CLASS(name='System-BearerContextModificationConfirm-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    System_BearerContextModificationConfirm_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRAN-BearerContextModificationConfirm >-----#
    EUTRAN_BearerContextModificationConfirm = CLASS(name='EUTRAN-BearerContextModificationConfirm', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _EUTRAN_BearerContextModificationConfirm_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Confirm-Modified-List-EUTRAN')))
    EUTRAN_BearerContextModificationConfirm._val = ASN1Set(rv=[dict([('id', 41), ('criticality', 'ignore'), ('Value', _EUTRAN_BearerContextModificationConfirm_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< NG-RAN-BearerContextModificationConfirm >-----#
    NG_RAN_BearerContextModificationConfirm = CLASS(name='NG-RAN-BearerContextModificationConfirm', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _NG_RAN_BearerContextModificationConfirm_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Confirm-Modified-List')))
    NG_RAN_BearerContextModificationConfirm._val = ASN1Set(rv=[dict([('id', 50), ('criticality', 'ignore'), ('Value', _NG_RAN_BearerContextModificationConfirm_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BearerContextReleaseCommand >-----#
    BearerContextReleaseCommand = SEQ(name='BearerContextReleaseCommand', mode=MODE_TYPE)
    _BearerContextReleaseCommand_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __BearerContextReleaseCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___BearerContextReleaseCommand_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____BearerContextReleaseCommand_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____BearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _____BearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _____BearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    ____BearerContextReleaseCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____BearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____BearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____BearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___BearerContextReleaseCommand_protocolIEs__item__id._const_tab = ____BearerContextReleaseCommand_protocolIEs__item__id_tab
    ___BearerContextReleaseCommand_protocolIEs__item__id._const_tab_at = None
    ___BearerContextReleaseCommand_protocolIEs__item__id._const_tab_id = 'id'
    ___BearerContextReleaseCommand_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BearerContextReleaseCommand_protocolIEs__item__criticality._const_tab = ____BearerContextReleaseCommand_protocolIEs__item__id_tab
    ___BearerContextReleaseCommand_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BearerContextReleaseCommand_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BearerContextReleaseCommand_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BearerContextReleaseCommand_protocolIEs__item__value._const_tab = ____BearerContextReleaseCommand_protocolIEs__item__id_tab
    ___BearerContextReleaseCommand_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BearerContextReleaseCommand_protocolIEs__item__value._const_tab_id = 'Value'
    __BearerContextReleaseCommand_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BearerContextReleaseCommand_protocolIEs__item__id),
        ('criticality', ___BearerContextReleaseCommand_protocolIEs__item__criticality),
        ('value', ___BearerContextReleaseCommand_protocolIEs__item__value),
        ])
    __BearerContextReleaseCommand_protocolIEs__item_._ext = None
    _BearerContextReleaseCommand_protocolIEs._cont = __BearerContextReleaseCommand_protocolIEs__item_
    _BearerContextReleaseCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BearerContextReleaseCommand._cont = ASN1Dict([
        ('protocolIEs', _BearerContextReleaseCommand_protocolIEs),
        ])
    BearerContextReleaseCommand._ext = []
    
    #-----< BearerContextReleaseCommandIEs >-----#
    BearerContextReleaseCommandIEs = CLASS(name='BearerContextReleaseCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _BearerContextReleaseCommandIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _BearerContextReleaseCommandIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _BearerContextReleaseCommandIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    BearerContextReleaseCommandIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _BearerContextReleaseCommandIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _BearerContextReleaseCommandIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _BearerContextReleaseCommandIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BearerContextReleaseComplete >-----#
    BearerContextReleaseComplete = SEQ(name='BearerContextReleaseComplete', mode=MODE_TYPE)
    _BearerContextReleaseComplete_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __BearerContextReleaseComplete_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___BearerContextReleaseComplete_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____BearerContextReleaseComplete_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____BearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _____BearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _____BearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    _____BearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'RetainabilityMeasurementsInfo')))
    ____BearerContextReleaseComplete_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____BearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____BearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____BearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____BearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BearerContextReleaseComplete_protocolIEs__item__id._const_tab = ____BearerContextReleaseComplete_protocolIEs__item__id_tab
    ___BearerContextReleaseComplete_protocolIEs__item__id._const_tab_at = None
    ___BearerContextReleaseComplete_protocolIEs__item__id._const_tab_id = 'id'
    ___BearerContextReleaseComplete_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BearerContextReleaseComplete_protocolIEs__item__criticality._const_tab = ____BearerContextReleaseComplete_protocolIEs__item__id_tab
    ___BearerContextReleaseComplete_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BearerContextReleaseComplete_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BearerContextReleaseComplete_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BearerContextReleaseComplete_protocolIEs__item__value._const_tab = ____BearerContextReleaseComplete_protocolIEs__item__id_tab
    ___BearerContextReleaseComplete_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BearerContextReleaseComplete_protocolIEs__item__value._const_tab_id = 'Value'
    __BearerContextReleaseComplete_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BearerContextReleaseComplete_protocolIEs__item__id),
        ('criticality', ___BearerContextReleaseComplete_protocolIEs__item__criticality),
        ('value', ___BearerContextReleaseComplete_protocolIEs__item__value),
        ])
    __BearerContextReleaseComplete_protocolIEs__item_._ext = None
    _BearerContextReleaseComplete_protocolIEs._cont = __BearerContextReleaseComplete_protocolIEs__item_
    _BearerContextReleaseComplete_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BearerContextReleaseComplete._cont = ASN1Dict([
        ('protocolIEs', _BearerContextReleaseComplete_protocolIEs),
        ])
    BearerContextReleaseComplete._ext = []
    
    #-----< BearerContextReleaseCompleteIEs >-----#
    BearerContextReleaseCompleteIEs = CLASS(name='BearerContextReleaseCompleteIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _BearerContextReleaseCompleteIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _BearerContextReleaseCompleteIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _BearerContextReleaseCompleteIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    _BearerContextReleaseCompleteIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'RetainabilityMeasurementsInfo')))
    BearerContextReleaseCompleteIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _BearerContextReleaseCompleteIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _BearerContextReleaseCompleteIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _BearerContextReleaseCompleteIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _BearerContextReleaseCompleteIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BearerContextReleaseRequest >-----#
    BearerContextReleaseRequest = SEQ(name='BearerContextReleaseRequest', mode=MODE_TYPE)
    _BearerContextReleaseRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __BearerContextReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___BearerContextReleaseRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____BearerContextReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____BearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _____BearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _____BearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'DRB-Status-List')))
    _____BearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    ____BearerContextReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____BearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____BearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 22), ('criticality', 'ignore'), ('Value', _____BearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____BearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___BearerContextReleaseRequest_protocolIEs__item__id._const_tab = ____BearerContextReleaseRequest_protocolIEs__item__id_tab
    ___BearerContextReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___BearerContextReleaseRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___BearerContextReleaseRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BearerContextReleaseRequest_protocolIEs__item__criticality._const_tab = ____BearerContextReleaseRequest_protocolIEs__item__id_tab
    ___BearerContextReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BearerContextReleaseRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BearerContextReleaseRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BearerContextReleaseRequest_protocolIEs__item__value._const_tab = ____BearerContextReleaseRequest_protocolIEs__item__id_tab
    ___BearerContextReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BearerContextReleaseRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __BearerContextReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BearerContextReleaseRequest_protocolIEs__item__id),
        ('criticality', ___BearerContextReleaseRequest_protocolIEs__item__criticality),
        ('value', ___BearerContextReleaseRequest_protocolIEs__item__value),
        ])
    __BearerContextReleaseRequest_protocolIEs__item_._ext = None
    _BearerContextReleaseRequest_protocolIEs._cont = __BearerContextReleaseRequest_protocolIEs__item_
    _BearerContextReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BearerContextReleaseRequest._cont = ASN1Dict([
        ('protocolIEs', _BearerContextReleaseRequest_protocolIEs),
        ])
    BearerContextReleaseRequest._ext = []
    
    #-----< BearerContextReleaseRequestIEs >-----#
    BearerContextReleaseRequestIEs = CLASS(name='BearerContextReleaseRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _BearerContextReleaseRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _BearerContextReleaseRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _BearerContextReleaseRequestIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'DRB-Status-List')))
    _BearerContextReleaseRequestIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    BearerContextReleaseRequestIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _BearerContextReleaseRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _BearerContextReleaseRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 22), ('criticality', 'ignore'), ('Value', _BearerContextReleaseRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _BearerContextReleaseRequestIEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DRB-Status-List >-----#
    DRB_Status_List = SEQ_OF(name='DRB-Status-List', mode=MODE_TYPE)
    _DRB_Status_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Status-Item')))
    DRB_Status_List._cont = _DRB_Status_List__item_
    DRB_Status_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< BearerContextInactivityNotification >-----#
    BearerContextInactivityNotification = SEQ(name='BearerContextInactivityNotification', mode=MODE_TYPE)
    _BearerContextInactivityNotification_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __BearerContextInactivityNotification_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___BearerContextInactivityNotification_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____BearerContextInactivityNotification_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____BearerContextInactivityNotification_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _____BearerContextInactivityNotification_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _____BearerContextInactivityNotification_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ActivityInformation')))
    ____BearerContextInactivityNotification_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____BearerContextInactivityNotification_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____BearerContextInactivityNotification_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 24), ('criticality', 'reject'), ('Value', _____BearerContextInactivityNotification_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___BearerContextInactivityNotification_protocolIEs__item__id._const_tab = ____BearerContextInactivityNotification_protocolIEs__item__id_tab
    ___BearerContextInactivityNotification_protocolIEs__item__id._const_tab_at = None
    ___BearerContextInactivityNotification_protocolIEs__item__id._const_tab_id = 'id'
    ___BearerContextInactivityNotification_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BearerContextInactivityNotification_protocolIEs__item__criticality._const_tab = ____BearerContextInactivityNotification_protocolIEs__item__id_tab
    ___BearerContextInactivityNotification_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BearerContextInactivityNotification_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BearerContextInactivityNotification_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BearerContextInactivityNotification_protocolIEs__item__value._const_tab = ____BearerContextInactivityNotification_protocolIEs__item__id_tab
    ___BearerContextInactivityNotification_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BearerContextInactivityNotification_protocolIEs__item__value._const_tab_id = 'Value'
    __BearerContextInactivityNotification_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BearerContextInactivityNotification_protocolIEs__item__id),
        ('criticality', ___BearerContextInactivityNotification_protocolIEs__item__criticality),
        ('value', ___BearerContextInactivityNotification_protocolIEs__item__value),
        ])
    __BearerContextInactivityNotification_protocolIEs__item_._ext = None
    _BearerContextInactivityNotification_protocolIEs._cont = __BearerContextInactivityNotification_protocolIEs__item_
    _BearerContextInactivityNotification_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BearerContextInactivityNotification._cont = ASN1Dict([
        ('protocolIEs', _BearerContextInactivityNotification_protocolIEs),
        ])
    BearerContextInactivityNotification._ext = []
    
    #-----< BearerContextInactivityNotificationIEs >-----#
    BearerContextInactivityNotificationIEs = CLASS(name='BearerContextInactivityNotificationIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _BearerContextInactivityNotificationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _BearerContextInactivityNotificationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _BearerContextInactivityNotificationIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ActivityInformation')))
    BearerContextInactivityNotificationIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _BearerContextInactivityNotificationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _BearerContextInactivityNotificationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 24), ('criticality', 'reject'), ('Value', _BearerContextInactivityNotificationIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DLDataNotification >-----#
    DLDataNotification = SEQ(name='DLDataNotification', mode=MODE_TYPE)
    _DLDataNotification_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __DLDataNotification_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___DLDataNotification_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____DLDataNotification_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____DLDataNotification_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _____DLDataNotification_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _____DLDataNotification_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PPI')))
    _____DLDataNotification_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-To-Notify-List')))
    ____DLDataNotification_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____DLDataNotification_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____DLDataNotification_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 63), ('criticality', 'ignore'), ('Value', _____DLDataNotification_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 67), ('criticality', 'ignore'), ('Value', _____DLDataNotification_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DLDataNotification_protocolIEs__item__id._const_tab = ____DLDataNotification_protocolIEs__item__id_tab
    ___DLDataNotification_protocolIEs__item__id._const_tab_at = None
    ___DLDataNotification_protocolIEs__item__id._const_tab_id = 'id'
    ___DLDataNotification_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___DLDataNotification_protocolIEs__item__criticality._const_tab = ____DLDataNotification_protocolIEs__item__id_tab
    ___DLDataNotification_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DLDataNotification_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DLDataNotification_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___DLDataNotification_protocolIEs__item__value._const_tab = ____DLDataNotification_protocolIEs__item__id_tab
    ___DLDataNotification_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DLDataNotification_protocolIEs__item__value._const_tab_id = 'Value'
    __DLDataNotification_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DLDataNotification_protocolIEs__item__id),
        ('criticality', ___DLDataNotification_protocolIEs__item__criticality),
        ('value', ___DLDataNotification_protocolIEs__item__value),
        ])
    __DLDataNotification_protocolIEs__item_._ext = None
    _DLDataNotification_protocolIEs._cont = __DLDataNotification_protocolIEs__item_
    _DLDataNotification_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DLDataNotification._cont = ASN1Dict([
        ('protocolIEs', _DLDataNotification_protocolIEs),
        ])
    DLDataNotification._ext = []
    
    #-----< DLDataNotificationIEs >-----#
    DLDataNotificationIEs = CLASS(name='DLDataNotificationIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _DLDataNotificationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _DLDataNotificationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _DLDataNotificationIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PPI')))
    _DLDataNotificationIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-To-Notify-List')))
    DLDataNotificationIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _DLDataNotificationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _DLDataNotificationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 63), ('criticality', 'ignore'), ('Value', _DLDataNotificationIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 67), ('criticality', 'ignore'), ('Value', _DLDataNotificationIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ULDataNotification >-----#
    ULDataNotification = SEQ(name='ULDataNotification', mode=MODE_TYPE)
    _ULDataNotification_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __ULDataNotification_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___ULDataNotification_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____ULDataNotification_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____ULDataNotification_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _____ULDataNotification_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _____ULDataNotification_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-To-Notify-List')))
    ____ULDataNotification_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____ULDataNotification_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____ULDataNotification_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 67), ('criticality', 'reject'), ('Value', _____ULDataNotification_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___ULDataNotification_protocolIEs__item__id._const_tab = ____ULDataNotification_protocolIEs__item__id_tab
    ___ULDataNotification_protocolIEs__item__id._const_tab_at = None
    ___ULDataNotification_protocolIEs__item__id._const_tab_id = 'id'
    ___ULDataNotification_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___ULDataNotification_protocolIEs__item__criticality._const_tab = ____ULDataNotification_protocolIEs__item__id_tab
    ___ULDataNotification_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ULDataNotification_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ULDataNotification_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___ULDataNotification_protocolIEs__item__value._const_tab = ____ULDataNotification_protocolIEs__item__id_tab
    ___ULDataNotification_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ULDataNotification_protocolIEs__item__value._const_tab_id = 'Value'
    __ULDataNotification_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ULDataNotification_protocolIEs__item__id),
        ('criticality', ___ULDataNotification_protocolIEs__item__criticality),
        ('value', ___ULDataNotification_protocolIEs__item__value),
        ])
    __ULDataNotification_protocolIEs__item_._ext = None
    _ULDataNotification_protocolIEs._cont = __ULDataNotification_protocolIEs__item_
    _ULDataNotification_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ULDataNotification._cont = ASN1Dict([
        ('protocolIEs', _ULDataNotification_protocolIEs),
        ])
    ULDataNotification._ext = []
    
    #-----< ULDataNotificationIEs >-----#
    ULDataNotificationIEs = CLASS(name='ULDataNotificationIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _ULDataNotificationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _ULDataNotificationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _ULDataNotificationIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-To-Notify-List')))
    ULDataNotificationIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _ULDataNotificationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _ULDataNotificationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 67), ('criticality', 'reject'), ('Value', _ULDataNotificationIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DataUsageReport >-----#
    DataUsageReport = SEQ(name='DataUsageReport', mode=MODE_TYPE)
    _DataUsageReport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __DataUsageReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___DataUsageReport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____DataUsageReport_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____DataUsageReport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _____DataUsageReport_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _____DataUsageReport_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Data-Usage-Report-List')))
    ____DataUsageReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____DataUsageReport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____DataUsageReport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 25), ('criticality', 'ignore'), ('Value', _____DataUsageReport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___DataUsageReport_protocolIEs__item__id._const_tab = ____DataUsageReport_protocolIEs__item__id_tab
    ___DataUsageReport_protocolIEs__item__id._const_tab_at = None
    ___DataUsageReport_protocolIEs__item__id._const_tab_id = 'id'
    ___DataUsageReport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___DataUsageReport_protocolIEs__item__criticality._const_tab = ____DataUsageReport_protocolIEs__item__id_tab
    ___DataUsageReport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DataUsageReport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DataUsageReport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___DataUsageReport_protocolIEs__item__value._const_tab = ____DataUsageReport_protocolIEs__item__id_tab
    ___DataUsageReport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DataUsageReport_protocolIEs__item__value._const_tab_id = 'Value'
    __DataUsageReport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DataUsageReport_protocolIEs__item__id),
        ('criticality', ___DataUsageReport_protocolIEs__item__criticality),
        ('value', ___DataUsageReport_protocolIEs__item__value),
        ])
    __DataUsageReport_protocolIEs__item_._ext = None
    _DataUsageReport_protocolIEs._cont = __DataUsageReport_protocolIEs__item_
    _DataUsageReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DataUsageReport._cont = ASN1Dict([
        ('protocolIEs', _DataUsageReport_protocolIEs),
        ])
    DataUsageReport._ext = []
    
    #-----< DataUsageReportIEs >-----#
    DataUsageReportIEs = CLASS(name='DataUsageReportIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _DataUsageReportIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _DataUsageReportIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _DataUsageReportIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Data-Usage-Report-List')))
    DataUsageReportIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _DataUsageReportIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _DataUsageReportIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 25), ('criticality', 'ignore'), ('Value', _DataUsageReportIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-UP-CounterCheckRequest >-----#
    GNB_CU_UP_CounterCheckRequest = SEQ(name='GNB-CU-UP-CounterCheckRequest', mode=MODE_TYPE)
    _GNB_CU_UP_CounterCheckRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __GNB_CU_UP_CounterCheckRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___GNB_CU_UP_CounterCheckRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____GNB_CU_UP_CounterCheckRequest_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____GNB_CU_UP_CounterCheckRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _____GNB_CU_UP_CounterCheckRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _____GNB_CU_UP_CounterCheckRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'System-GNB-CU-UP-CounterCheckRequest')))
    ____GNB_CU_UP_CounterCheckRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____GNB_CU_UP_CounterCheckRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____GNB_CU_UP_CounterCheckRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 60), ('criticality', 'reject'), ('Value', _____GNB_CU_UP_CounterCheckRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___GNB_CU_UP_CounterCheckRequest_protocolIEs__item__id._const_tab = ____GNB_CU_UP_CounterCheckRequest_protocolIEs__item__id_tab
    ___GNB_CU_UP_CounterCheckRequest_protocolIEs__item__id._const_tab_at = None
    ___GNB_CU_UP_CounterCheckRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___GNB_CU_UP_CounterCheckRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___GNB_CU_UP_CounterCheckRequest_protocolIEs__item__criticality._const_tab = ____GNB_CU_UP_CounterCheckRequest_protocolIEs__item__id_tab
    ___GNB_CU_UP_CounterCheckRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_UP_CounterCheckRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_UP_CounterCheckRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___GNB_CU_UP_CounterCheckRequest_protocolIEs__item__value._const_tab = ____GNB_CU_UP_CounterCheckRequest_protocolIEs__item__id_tab
    ___GNB_CU_UP_CounterCheckRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNB_CU_UP_CounterCheckRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __GNB_CU_UP_CounterCheckRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_UP_CounterCheckRequest_protocolIEs__item__id),
        ('criticality', ___GNB_CU_UP_CounterCheckRequest_protocolIEs__item__criticality),
        ('value', ___GNB_CU_UP_CounterCheckRequest_protocolIEs__item__value),
        ])
    __GNB_CU_UP_CounterCheckRequest_protocolIEs__item_._ext = None
    _GNB_CU_UP_CounterCheckRequest_protocolIEs._cont = __GNB_CU_UP_CounterCheckRequest_protocolIEs__item_
    _GNB_CU_UP_CounterCheckRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNB_CU_UP_CounterCheckRequest._cont = ASN1Dict([
        ('protocolIEs', _GNB_CU_UP_CounterCheckRequest_protocolIEs),
        ])
    GNB_CU_UP_CounterCheckRequest._ext = []
    
    #-----< GNB-CU-UP-CounterCheckRequestIEs >-----#
    GNB_CU_UP_CounterCheckRequestIEs = CLASS(name='GNB-CU-UP-CounterCheckRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _GNB_CU_UP_CounterCheckRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _GNB_CU_UP_CounterCheckRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _GNB_CU_UP_CounterCheckRequestIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'System-GNB-CU-UP-CounterCheckRequest')))
    GNB_CU_UP_CounterCheckRequestIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _GNB_CU_UP_CounterCheckRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _GNB_CU_UP_CounterCheckRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 60), ('criticality', 'reject'), ('Value', _GNB_CU_UP_CounterCheckRequestIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< System-GNB-CU-UP-CounterCheckRequest >-----#
    System_GNB_CU_UP_CounterCheckRequest = CHOICE(name='System-GNB-CU-UP-CounterCheckRequest', mode=MODE_TYPE)
    _System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest = SEQ_OF(name='e-UTRAN-GNB-CU-UP-CounterCheckRequest', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRBs-Subject-To-Counter-Check-List-EUTRAN')))
    ____System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__id_tab._val = ASN1Set(rv=[dict([('id', 61), ('criticality', 'ignore'), ('Value', _____System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__id._const_tab = ____System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__id_tab
    ___System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__id._const_tab_at = None
    ___System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__id._const_tab_id = 'id'
    ___System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__criticality._const_tab = ____System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__id_tab
    ___System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__criticality._const_tab_at = ('..', 'id')
    ___System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__criticality._const_tab_id = 'criticality'
    ___System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__value._const_tab = ____System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__id_tab
    ___System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__value._const_tab_at = ('..', 'id')
    ___System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__value._const_tab_id = 'Value'
    __System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item_._cont = ASN1Dict([
        ('id', ___System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__id),
        ('criticality', ___System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__criticality),
        ('value', ___System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__value),
        ])
    __System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item_._ext = None
    _System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest._cont = __System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item_
    _System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest = SEQ_OF(name='nG-RAN-GNB-CU-UP-CounterCheckRequest', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRBs-Subject-To-Counter-Check-List-NG-RAN')))
    ____System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__id_tab._val = ASN1Set(rv=[dict([('id', 62), ('criticality', 'ignore'), ('Value', _____System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__id._const_tab = ____System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__id_tab
    ___System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__id._const_tab_at = None
    ___System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__id._const_tab_id = 'id'
    ___System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__criticality._const_tab = ____System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__id_tab
    ___System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__criticality._const_tab_at = ('..', 'id')
    ___System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__criticality._const_tab_id = 'criticality'
    ___System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__value._const_tab = ____System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__id_tab
    ___System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__value._const_tab_at = ('..', 'id')
    ___System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__value._const_tab_id = 'Value'
    __System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item_._cont = ASN1Dict([
        ('id', ___System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__id),
        ('criticality', ___System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__criticality),
        ('value', ___System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__value),
        ])
    __System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item_._ext = None
    _System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest._cont = __System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item_
    _System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _System_GNB_CU_UP_CounterCheckRequest_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-SingleContainer')))
    __System_GNB_CU_UP_CounterCheckRequest_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ___System_GNB_CU_UP_CounterCheckRequest_choice_extension_id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___System_GNB_CU_UP_CounterCheckRequest_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __System_GNB_CU_UP_CounterCheckRequest_choice_extension_id._const_tab = ___System_GNB_CU_UP_CounterCheckRequest_choice_extension_id_tab
    __System_GNB_CU_UP_CounterCheckRequest_choice_extension_id._const_tab_at = None
    __System_GNB_CU_UP_CounterCheckRequest_choice_extension_id._const_tab_id = 'id'
    __System_GNB_CU_UP_CounterCheckRequest_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___System_GNB_CU_UP_CounterCheckRequest_choice_extension_criticality_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___System_GNB_CU_UP_CounterCheckRequest_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __System_GNB_CU_UP_CounterCheckRequest_choice_extension_criticality._const_tab = ___System_GNB_CU_UP_CounterCheckRequest_choice_extension_criticality_tab
    __System_GNB_CU_UP_CounterCheckRequest_choice_extension_criticality._const_tab_at = ('..', 'id')
    __System_GNB_CU_UP_CounterCheckRequest_choice_extension_criticality._const_tab_id = 'criticality'
    __System_GNB_CU_UP_CounterCheckRequest_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___System_GNB_CU_UP_CounterCheckRequest_choice_extension_value_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    ___System_GNB_CU_UP_CounterCheckRequest_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __System_GNB_CU_UP_CounterCheckRequest_choice_extension_value._const_tab = ___System_GNB_CU_UP_CounterCheckRequest_choice_extension_value_tab
    __System_GNB_CU_UP_CounterCheckRequest_choice_extension_value._const_tab_at = ('..', 'id')
    __System_GNB_CU_UP_CounterCheckRequest_choice_extension_value._const_tab_id = 'Value'
    _System_GNB_CU_UP_CounterCheckRequest_choice_extension._cont = ASN1Dict([
        ('id', __System_GNB_CU_UP_CounterCheckRequest_choice_extension_id),
        ('criticality', __System_GNB_CU_UP_CounterCheckRequest_choice_extension_criticality),
        ('value', __System_GNB_CU_UP_CounterCheckRequest_choice_extension_value),
        ])
    _System_GNB_CU_UP_CounterCheckRequest_choice_extension._ext = None
    System_GNB_CU_UP_CounterCheckRequest._cont = ASN1Dict([
        ('e-UTRAN-GNB-CU-UP-CounterCheckRequest', _System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest),
        ('nG-RAN-GNB-CU-UP-CounterCheckRequest', _System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest),
        ('choice-extension', _System_GNB_CU_UP_CounterCheckRequest_choice_extension),
        ])
    System_GNB_CU_UP_CounterCheckRequest._ext = None
    
    #-----< System-GNB-CU-UP-CounterCheckRequest-ExtIEs >-----#
    System_GNB_CU_UP_CounterCheckRequest_ExtIEs = CLASS(name='System-GNB-CU-UP-CounterCheckRequest-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    System_GNB_CU_UP_CounterCheckRequest_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRAN-GNB-CU-UP-CounterCheckRequest >-----#
    EUTRAN_GNB_CU_UP_CounterCheckRequest = CLASS(name='EUTRAN-GNB-CU-UP-CounterCheckRequest', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _EUTRAN_GNB_CU_UP_CounterCheckRequest_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRBs-Subject-To-Counter-Check-List-EUTRAN')))
    EUTRAN_GNB_CU_UP_CounterCheckRequest._val = ASN1Set(rv=[dict([('id', 61), ('criticality', 'ignore'), ('Value', _EUTRAN_GNB_CU_UP_CounterCheckRequest_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< NG-RAN-GNB-CU-UP-CounterCheckRequest >-----#
    NG_RAN_GNB_CU_UP_CounterCheckRequest = CLASS(name='NG-RAN-GNB-CU-UP-CounterCheckRequest', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _NG_RAN_GNB_CU_UP_CounterCheckRequest_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRBs-Subject-To-Counter-Check-List-NG-RAN')))
    NG_RAN_GNB_CU_UP_CounterCheckRequest._val = ASN1Set(rv=[dict([('id', 62), ('criticality', 'ignore'), ('Value', _NG_RAN_GNB_CU_UP_CounterCheckRequest_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-UP-StatusIndication >-----#
    GNB_CU_UP_StatusIndication = SEQ(name='GNB-CU-UP-StatusIndication', mode=MODE_TYPE)
    _GNB_CU_UP_StatusIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __GNB_CU_UP_StatusIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___GNB_CU_UP_StatusIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____GNB_CU_UP_StatusIndication_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____GNB_CU_UP_StatusIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____GNB_CU_UP_StatusIndication_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-OverloadInformation')))
    ____GNB_CU_UP_StatusIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____GNB_CU_UP_StatusIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 65), ('criticality', 'reject'), ('Value', _____GNB_CU_UP_StatusIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___GNB_CU_UP_StatusIndication_protocolIEs__item__id._const_tab = ____GNB_CU_UP_StatusIndication_protocolIEs__item__id_tab
    ___GNB_CU_UP_StatusIndication_protocolIEs__item__id._const_tab_at = None
    ___GNB_CU_UP_StatusIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___GNB_CU_UP_StatusIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___GNB_CU_UP_StatusIndication_protocolIEs__item__criticality._const_tab = ____GNB_CU_UP_StatusIndication_protocolIEs__item__id_tab
    ___GNB_CU_UP_StatusIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_UP_StatusIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_UP_StatusIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___GNB_CU_UP_StatusIndication_protocolIEs__item__value._const_tab = ____GNB_CU_UP_StatusIndication_protocolIEs__item__id_tab
    ___GNB_CU_UP_StatusIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNB_CU_UP_StatusIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __GNB_CU_UP_StatusIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_UP_StatusIndication_protocolIEs__item__id),
        ('criticality', ___GNB_CU_UP_StatusIndication_protocolIEs__item__criticality),
        ('value', ___GNB_CU_UP_StatusIndication_protocolIEs__item__value),
        ])
    __GNB_CU_UP_StatusIndication_protocolIEs__item_._ext = None
    _GNB_CU_UP_StatusIndication_protocolIEs._cont = __GNB_CU_UP_StatusIndication_protocolIEs__item_
    _GNB_CU_UP_StatusIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNB_CU_UP_StatusIndication._cont = ASN1Dict([
        ('protocolIEs', _GNB_CU_UP_StatusIndication_protocolIEs),
        ])
    GNB_CU_UP_StatusIndication._ext = []
    
    #-----< GNB-CU-UP-StatusIndicationIEs >-----#
    GNB_CU_UP_StatusIndicationIEs = CLASS(name='GNB-CU-UP-StatusIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _GNB_CU_UP_StatusIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _GNB_CU_UP_StatusIndicationIEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-OverloadInformation')))
    GNB_CU_UP_StatusIndicationIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _GNB_CU_UP_StatusIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 65), ('criticality', 'reject'), ('Value', _GNB_CU_UP_StatusIndicationIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-CPMeasurementResultsInformation >-----#
    GNB_CU_CPMeasurementResultsInformation = SEQ(name='GNB-CU-CPMeasurementResultsInformation', mode=MODE_TYPE)
    _GNB_CU_CPMeasurementResultsInformation_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __GNB_CU_CPMeasurementResultsInformation_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _____GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _____GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Measurement-Results-Information-List')))
    ____GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 128), ('criticality', 'ignore'), ('Value', _____GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__id._const_tab = ____GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__id_tab
    ___GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__id._const_tab_at = None
    ___GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__id._const_tab_id = 'id'
    ___GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__criticality._const_tab = ____GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__id_tab
    ___GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__value._const_tab = ____GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__id_tab
    ___GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__value._const_tab_id = 'Value'
    __GNB_CU_CPMeasurementResultsInformation_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__id),
        ('criticality', ___GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__criticality),
        ('value', ___GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__value),
        ])
    __GNB_CU_CPMeasurementResultsInformation_protocolIEs__item_._ext = None
    _GNB_CU_CPMeasurementResultsInformation_protocolIEs._cont = __GNB_CU_CPMeasurementResultsInformation_protocolIEs__item_
    _GNB_CU_CPMeasurementResultsInformation_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNB_CU_CPMeasurementResultsInformation._cont = ASN1Dict([
        ('protocolIEs', _GNB_CU_CPMeasurementResultsInformation_protocolIEs),
        ])
    GNB_CU_CPMeasurementResultsInformation._ext = []
    
    #-----< GNB-CU-CPMeasurementResultsInformationIEs >-----#
    GNB_CU_CPMeasurementResultsInformationIEs = CLASS(name='GNB-CU-CPMeasurementResultsInformationIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _GNB_CU_CPMeasurementResultsInformationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _GNB_CU_CPMeasurementResultsInformationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _GNB_CU_CPMeasurementResultsInformationIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRB-Measurement-Results-Information-List')))
    GNB_CU_CPMeasurementResultsInformationIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _GNB_CU_CPMeasurementResultsInformationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _GNB_CU_CPMeasurementResultsInformationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 128), ('criticality', 'ignore'), ('Value', _GNB_CU_CPMeasurementResultsInformationIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MRDC-DataUsageReport >-----#
    MRDC_DataUsageReport = SEQ(name='MRDC-DataUsageReport', mode=MODE_TYPE)
    _MRDC_DataUsageReport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __MRDC_DataUsageReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___MRDC_DataUsageReport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____MRDC_DataUsageReport_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____MRDC_DataUsageReport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _____MRDC_DataUsageReport_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _____MRDC_DataUsageReport_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Data-Usage-List')))
    ____MRDC_DataUsageReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____MRDC_DataUsageReport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____MRDC_DataUsageReport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 68), ('criticality', 'ignore'), ('Value', _____MRDC_DataUsageReport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MRDC_DataUsageReport_protocolIEs__item__id._const_tab = ____MRDC_DataUsageReport_protocolIEs__item__id_tab
    ___MRDC_DataUsageReport_protocolIEs__item__id._const_tab_at = None
    ___MRDC_DataUsageReport_protocolIEs__item__id._const_tab_id = 'id'
    ___MRDC_DataUsageReport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___MRDC_DataUsageReport_protocolIEs__item__criticality._const_tab = ____MRDC_DataUsageReport_protocolIEs__item__id_tab
    ___MRDC_DataUsageReport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MRDC_DataUsageReport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MRDC_DataUsageReport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___MRDC_DataUsageReport_protocolIEs__item__value._const_tab = ____MRDC_DataUsageReport_protocolIEs__item__id_tab
    ___MRDC_DataUsageReport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MRDC_DataUsageReport_protocolIEs__item__value._const_tab_id = 'Value'
    __MRDC_DataUsageReport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MRDC_DataUsageReport_protocolIEs__item__id),
        ('criticality', ___MRDC_DataUsageReport_protocolIEs__item__criticality),
        ('value', ___MRDC_DataUsageReport_protocolIEs__item__value),
        ])
    __MRDC_DataUsageReport_protocolIEs__item_._ext = None
    _MRDC_DataUsageReport_protocolIEs._cont = __MRDC_DataUsageReport_protocolIEs__item_
    _MRDC_DataUsageReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MRDC_DataUsageReport._cont = ASN1Dict([
        ('protocolIEs', _MRDC_DataUsageReport_protocolIEs),
        ])
    MRDC_DataUsageReport._ext = []
    
    #-----< MRDC-DataUsageReportIEs >-----#
    MRDC_DataUsageReportIEs = CLASS(name='MRDC-DataUsageReportIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _MRDC_DataUsageReportIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _MRDC_DataUsageReportIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _MRDC_DataUsageReportIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PDU-Session-Resource-Data-Usage-List')))
    MRDC_DataUsageReportIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _MRDC_DataUsageReportIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _MRDC_DataUsageReportIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 68), ('criticality', 'ignore'), ('Value', _MRDC_DataUsageReportIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TraceStart >-----#
    TraceStart = SEQ(name='TraceStart', mode=MODE_TYPE)
    _TraceStart_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __TraceStart_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___TraceStart_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____TraceStart_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____TraceStart_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _____TraceStart_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _____TraceStart_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TraceActivation')))
    ____TraceStart_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____TraceStart_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____TraceStart_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 81), ('criticality', 'ignore'), ('Value', _____TraceStart_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___TraceStart_protocolIEs__item__id._const_tab = ____TraceStart_protocolIEs__item__id_tab
    ___TraceStart_protocolIEs__item__id._const_tab_at = None
    ___TraceStart_protocolIEs__item__id._const_tab_id = 'id'
    ___TraceStart_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___TraceStart_protocolIEs__item__criticality._const_tab = ____TraceStart_protocolIEs__item__id_tab
    ___TraceStart_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___TraceStart_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___TraceStart_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___TraceStart_protocolIEs__item__value._const_tab = ____TraceStart_protocolIEs__item__id_tab
    ___TraceStart_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___TraceStart_protocolIEs__item__value._const_tab_id = 'Value'
    __TraceStart_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___TraceStart_protocolIEs__item__id),
        ('criticality', ___TraceStart_protocolIEs__item__criticality),
        ('value', ___TraceStart_protocolIEs__item__value),
        ])
    __TraceStart_protocolIEs__item_._ext = None
    _TraceStart_protocolIEs._cont = __TraceStart_protocolIEs__item_
    _TraceStart_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TraceStart._cont = ASN1Dict([
        ('protocolIEs', _TraceStart_protocolIEs),
        ])
    TraceStart._ext = []
    
    #-----< TraceStartIEs >-----#
    TraceStartIEs = CLASS(name='TraceStartIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _TraceStartIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _TraceStartIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _TraceStartIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TraceActivation')))
    TraceStartIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _TraceStartIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _TraceStartIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 81), ('criticality', 'ignore'), ('Value', _TraceStartIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DeactivateTrace >-----#
    DeactivateTrace = SEQ(name='DeactivateTrace', mode=MODE_TYPE)
    _DeactivateTrace_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __DeactivateTrace_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___DeactivateTrace_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____DeactivateTrace_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TraceID')))
    ____DeactivateTrace_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 82), ('criticality', 'ignore'), ('Value', _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___DeactivateTrace_protocolIEs__item__id._const_tab = ____DeactivateTrace_protocolIEs__item__id_tab
    ___DeactivateTrace_protocolIEs__item__id._const_tab_at = None
    ___DeactivateTrace_protocolIEs__item__id._const_tab_id = 'id'
    ___DeactivateTrace_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___DeactivateTrace_protocolIEs__item__criticality._const_tab = ____DeactivateTrace_protocolIEs__item__id_tab
    ___DeactivateTrace_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DeactivateTrace_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DeactivateTrace_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___DeactivateTrace_protocolIEs__item__value._const_tab = ____DeactivateTrace_protocolIEs__item__id_tab
    ___DeactivateTrace_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DeactivateTrace_protocolIEs__item__value._const_tab_id = 'Value'
    __DeactivateTrace_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DeactivateTrace_protocolIEs__item__id),
        ('criticality', ___DeactivateTrace_protocolIEs__item__criticality),
        ('value', ___DeactivateTrace_protocolIEs__item__value),
        ])
    __DeactivateTrace_protocolIEs__item_._ext = None
    _DeactivateTrace_protocolIEs._cont = __DeactivateTrace_protocolIEs__item_
    _DeactivateTrace_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DeactivateTrace._cont = ASN1Dict([
        ('protocolIEs', _DeactivateTrace_protocolIEs),
        ])
    DeactivateTrace._ext = []
    
    #-----< DeactivateTraceIEs >-----#
    DeactivateTraceIEs = CLASS(name='DeactivateTraceIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _DeactivateTraceIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _DeactivateTraceIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _DeactivateTraceIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TraceID')))
    DeactivateTraceIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _DeactivateTraceIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _DeactivateTraceIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 82), ('criticality', 'ignore'), ('Value', _DeactivateTraceIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CellTrafficTrace >-----#
    CellTrafficTrace = SEQ(name='CellTrafficTrace', mode=MODE_TYPE)
    _CellTrafficTrace_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __CellTrafficTrace_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___CellTrafficTrace_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____CellTrafficTrace_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TraceID')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PrivacyIndicator')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_5 = STR_VIS(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'URIaddress')))
    ____CellTrafficTrace_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 82), ('criticality', 'ignore'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 114), ('criticality', 'ignore'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 115), ('criticality', 'ignore'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 117), ('criticality', 'ignore'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellTrafficTrace_protocolIEs__item__id._const_tab = ____CellTrafficTrace_protocolIEs__item__id_tab
    ___CellTrafficTrace_protocolIEs__item__id._const_tab_at = None
    ___CellTrafficTrace_protocolIEs__item__id._const_tab_id = 'id'
    ___CellTrafficTrace_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___CellTrafficTrace_protocolIEs__item__criticality._const_tab = ____CellTrafficTrace_protocolIEs__item__id_tab
    ___CellTrafficTrace_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellTrafficTrace_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellTrafficTrace_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___CellTrafficTrace_protocolIEs__item__value._const_tab = ____CellTrafficTrace_protocolIEs__item__id_tab
    ___CellTrafficTrace_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellTrafficTrace_protocolIEs__item__value._const_tab_id = 'Value'
    __CellTrafficTrace_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellTrafficTrace_protocolIEs__item__id),
        ('criticality', ___CellTrafficTrace_protocolIEs__item__criticality),
        ('value', ___CellTrafficTrace_protocolIEs__item__value),
        ])
    __CellTrafficTrace_protocolIEs__item_._ext = None
    _CellTrafficTrace_protocolIEs._cont = __CellTrafficTrace_protocolIEs__item_
    _CellTrafficTrace_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    CellTrafficTrace._cont = ASN1Dict([
        ('protocolIEs', _CellTrafficTrace_protocolIEs),
        ])
    CellTrafficTrace._ext = []
    
    #-----< CellTrafficTraceIEs >-----#
    CellTrafficTraceIEs = CLASS(name='CellTrafficTraceIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _CellTrafficTraceIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _CellTrafficTraceIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _CellTrafficTraceIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TraceID')))
    _CellTrafficTraceIEs_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransportLayerAddress')))
    _CellTrafficTraceIEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'PrivacyIndicator')))
    _CellTrafficTraceIEs_val_Value_5 = STR_VIS(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'URIaddress')))
    CellTrafficTraceIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _CellTrafficTraceIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _CellTrafficTraceIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 82), ('criticality', 'ignore'), ('Value', _CellTrafficTraceIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 114), ('criticality', 'ignore'), ('Value', _CellTrafficTraceIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 115), ('criticality', 'ignore'), ('Value', _CellTrafficTraceIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 117), ('criticality', 'ignore'), ('Value', _CellTrafficTraceIEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PrivateMessage >-----#
    PrivateMessage = SEQ(name='PrivateMessage', mode=MODE_TYPE)
    _PrivateMessage_privateIEs = SEQ_OF(name='privateIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'PrivateIE-Container')))
    __PrivateMessage_privateIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'PrivateIE-Field')))
    ___PrivateMessage_privateIEs__item__id = CHOICE(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PRIVATE-IES'), ['id']))
    ____PrivateMessage_privateIEs__item__id_tab = CLASS(name='_tab_E1AP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__id._const_tab = ____PrivateMessage_privateIEs__item__id_tab
    ___PrivateMessage_privateIEs__item__id._const_tab_at = None
    ___PrivateMessage_privateIEs__item__id._const_tab_id = 'id'
    ___PrivateMessage_privateIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PRIVATE-IES'), ['criticality']))
    ____PrivateMessage_privateIEs__item__criticality_tab = CLASS(name='_tab_E1AP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__criticality._const_tab = ____PrivateMessage_privateIEs__item__criticality_tab
    ___PrivateMessage_privateIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PrivateMessage_privateIEs__item__criticality._const_tab_id = 'criticality'
    ___PrivateMessage_privateIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PRIVATE-IES'), ['Value']))
    ____PrivateMessage_privateIEs__item__value_tab = CLASS(name='_tab_E1AP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__value._const_tab = ____PrivateMessage_privateIEs__item__value_tab
    ___PrivateMessage_privateIEs__item__value._const_tab_at = ('..', 'id')
    ___PrivateMessage_privateIEs__item__value._const_tab_id = 'Value'
    __PrivateMessage_privateIEs__item_._cont = ASN1Dict([
        ('id', ___PrivateMessage_privateIEs__item__id),
        ('criticality', ___PrivateMessage_privateIEs__item__criticality),
        ('value', ___PrivateMessage_privateIEs__item__value),
        ])
    __PrivateMessage_privateIEs__item_._ext = None
    _PrivateMessage_privateIEs._cont = __PrivateMessage_privateIEs__item_
    _PrivateMessage_privateIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrivateMessage._cont = ASN1Dict([
        ('privateIEs', _PrivateMessage_privateIEs),
        ])
    PrivateMessage._ext = []
    
    #-----< PrivateMessage-IEs >-----#
    PrivateMessage_IEs = CLASS(name='PrivateMessage-IEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PRIVATE-IES')))
    PrivateMessage_IEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceStatusRequest >-----#
    ResourceStatusRequest = SEQ(name='ResourceStatusRequest', mode=MODE_TYPE)
    _ResourceStatusRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __ResourceStatusRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___ResourceStatusRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____ResourceStatusRequest_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE)
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4095)], ev=[], er=[])
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE)
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4095)], ev=[], er=[])
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'RegistrationRequest')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_4 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ReportCharacteristics')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ReportingPeriodicity')))
    ____ResourceStatusRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 89), ('criticality', 'reject'), ('Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 90), ('criticality', 'ignore'), ('Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 91), ('criticality', 'reject'), ('Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 92), ('criticality', 'reject'), ('Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'conditional')]), dict([('id', 93), ('criticality', 'reject'), ('Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResourceStatusRequest_protocolIEs__item__id._const_tab = ____ResourceStatusRequest_protocolIEs__item__id_tab
    ___ResourceStatusRequest_protocolIEs__item__id._const_tab_at = None
    ___ResourceStatusRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___ResourceStatusRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___ResourceStatusRequest_protocolIEs__item__criticality._const_tab = ____ResourceStatusRequest_protocolIEs__item__id_tab
    ___ResourceStatusRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceStatusRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ResourceStatusRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___ResourceStatusRequest_protocolIEs__item__value._const_tab = ____ResourceStatusRequest_protocolIEs__item__id_tab
    ___ResourceStatusRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ResourceStatusRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __ResourceStatusRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ResourceStatusRequest_protocolIEs__item__id),
        ('criticality', ___ResourceStatusRequest_protocolIEs__item__criticality),
        ('value', ___ResourceStatusRequest_protocolIEs__item__value),
        ])
    __ResourceStatusRequest_protocolIEs__item_._ext = None
    _ResourceStatusRequest_protocolIEs._cont = __ResourceStatusRequest_protocolIEs__item_
    _ResourceStatusRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResourceStatusRequest._cont = ASN1Dict([
        ('protocolIEs', _ResourceStatusRequest_protocolIEs),
        ])
    ResourceStatusRequest._ext = []
    
    #-----< ResourceStatusRequestIEs >-----#
    ResourceStatusRequestIEs = CLASS(name='ResourceStatusRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _ResourceStatusRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _ResourceStatusRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE)
    _ResourceStatusRequestIEs_val_Value_1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4095)], ev=[], er=[])
    _ResourceStatusRequestIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE)
    _ResourceStatusRequestIEs_val_Value_2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4095)], ev=[], er=[])
    _ResourceStatusRequestIEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'RegistrationRequest')))
    _ResourceStatusRequestIEs_val_Value_4 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ReportCharacteristics')))
    _ResourceStatusRequestIEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ReportingPeriodicity')))
    ResourceStatusRequestIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _ResourceStatusRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 89), ('criticality', 'reject'), ('Value', _ResourceStatusRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 90), ('criticality', 'ignore'), ('Value', _ResourceStatusRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 91), ('criticality', 'reject'), ('Value', _ResourceStatusRequestIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 92), ('criticality', 'reject'), ('Value', _ResourceStatusRequestIEs_val_Value_4), ('presence', 'conditional')]), dict([('id', 93), ('criticality', 'reject'), ('Value', _ResourceStatusRequestIEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResourceStatusResponse >-----#
    ResourceStatusResponse = SEQ(name='ResourceStatusResponse', mode=MODE_TYPE)
    _ResourceStatusResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __ResourceStatusResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___ResourceStatusResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____ResourceStatusResponse_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE)
    _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4095)], ev=[], er=[])
    _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE)
    _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4095)], ev=[], er=[])
    _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____ResourceStatusResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 89), ('criticality', 'reject'), ('Value', _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 90), ('criticality', 'ignore'), ('Value', _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResourceStatusResponse_protocolIEs__item__id._const_tab = ____ResourceStatusResponse_protocolIEs__item__id_tab
    ___ResourceStatusResponse_protocolIEs__item__id._const_tab_at = None
    ___ResourceStatusResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___ResourceStatusResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___ResourceStatusResponse_protocolIEs__item__criticality._const_tab = ____ResourceStatusResponse_protocolIEs__item__id_tab
    ___ResourceStatusResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceStatusResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ResourceStatusResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___ResourceStatusResponse_protocolIEs__item__value._const_tab = ____ResourceStatusResponse_protocolIEs__item__id_tab
    ___ResourceStatusResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ResourceStatusResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __ResourceStatusResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ResourceStatusResponse_protocolIEs__item__id),
        ('criticality', ___ResourceStatusResponse_protocolIEs__item__criticality),
        ('value', ___ResourceStatusResponse_protocolIEs__item__value),
        ])
    __ResourceStatusResponse_protocolIEs__item_._ext = None
    _ResourceStatusResponse_protocolIEs._cont = __ResourceStatusResponse_protocolIEs__item_
    _ResourceStatusResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResourceStatusResponse._cont = ASN1Dict([
        ('protocolIEs', _ResourceStatusResponse_protocolIEs),
        ])
    ResourceStatusResponse._ext = []
    
    #-----< ResourceStatusResponseIEs >-----#
    ResourceStatusResponseIEs = CLASS(name='ResourceStatusResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _ResourceStatusResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _ResourceStatusResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE)
    _ResourceStatusResponseIEs_val_Value_1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4095)], ev=[], er=[])
    _ResourceStatusResponseIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE)
    _ResourceStatusResponseIEs_val_Value_2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4095)], ev=[], er=[])
    _ResourceStatusResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ResourceStatusResponseIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _ResourceStatusResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 89), ('criticality', 'reject'), ('Value', _ResourceStatusResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 90), ('criticality', 'ignore'), ('Value', _ResourceStatusResponseIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _ResourceStatusResponseIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResourceStatusFailure >-----#
    ResourceStatusFailure = SEQ(name='ResourceStatusFailure', mode=MODE_TYPE)
    _ResourceStatusFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __ResourceStatusFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___ResourceStatusFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____ResourceStatusFailure_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE)
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4095)], ev=[], er=[])
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE)
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4095)], ev=[], er=[])
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____ResourceStatusFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 89), ('criticality', 'reject'), ('Value', _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 90), ('criticality', 'ignore'), ('Value', _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResourceStatusFailure_protocolIEs__item__id._const_tab = ____ResourceStatusFailure_protocolIEs__item__id_tab
    ___ResourceStatusFailure_protocolIEs__item__id._const_tab_at = None
    ___ResourceStatusFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___ResourceStatusFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___ResourceStatusFailure_protocolIEs__item__criticality._const_tab = ____ResourceStatusFailure_protocolIEs__item__id_tab
    ___ResourceStatusFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceStatusFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ResourceStatusFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___ResourceStatusFailure_protocolIEs__item__value._const_tab = ____ResourceStatusFailure_protocolIEs__item__id_tab
    ___ResourceStatusFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ResourceStatusFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __ResourceStatusFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ResourceStatusFailure_protocolIEs__item__id),
        ('criticality', ___ResourceStatusFailure_protocolIEs__item__criticality),
        ('value', ___ResourceStatusFailure_protocolIEs__item__value),
        ])
    __ResourceStatusFailure_protocolIEs__item_._ext = None
    _ResourceStatusFailure_protocolIEs._cont = __ResourceStatusFailure_protocolIEs__item_
    _ResourceStatusFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResourceStatusFailure._cont = ASN1Dict([
        ('protocolIEs', _ResourceStatusFailure_protocolIEs),
        ])
    ResourceStatusFailure._ext = []
    
    #-----< ResourceStatusFailureIEs >-----#
    ResourceStatusFailureIEs = CLASS(name='ResourceStatusFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _ResourceStatusFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _ResourceStatusFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE)
    _ResourceStatusFailureIEs_val_Value_1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4095)], ev=[], er=[])
    _ResourceStatusFailureIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE)
    _ResourceStatusFailureIEs_val_Value_2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4095)], ev=[], er=[])
    _ResourceStatusFailureIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _ResourceStatusFailureIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ResourceStatusFailureIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _ResourceStatusFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 89), ('criticality', 'reject'), ('Value', _ResourceStatusFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 90), ('criticality', 'ignore'), ('Value', _ResourceStatusFailureIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _ResourceStatusFailureIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _ResourceStatusFailureIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResourceStatusUpdate >-----#
    ResourceStatusUpdate = SEQ(name='ResourceStatusUpdate', mode=MODE_TYPE)
    _ResourceStatusUpdate_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __ResourceStatusUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___ResourceStatusUpdate_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____ResourceStatusUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE)
    _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4095)], ev=[], er=[])
    _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE)
    _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4095)], ev=[], er=[])
    _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TNL-AvailableCapacityIndicator')))
    _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'HW-CapacityIndicator')))
    ____ResourceStatusUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 89), ('criticality', 'reject'), ('Value', _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 90), ('criticality', 'ignore'), ('Value', _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 94), ('criticality', 'ignore'), ('Value', _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 95), ('criticality', 'ignore'), ('Value', _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___ResourceStatusUpdate_protocolIEs__item__id._const_tab = ____ResourceStatusUpdate_protocolIEs__item__id_tab
    ___ResourceStatusUpdate_protocolIEs__item__id._const_tab_at = None
    ___ResourceStatusUpdate_protocolIEs__item__id._const_tab_id = 'id'
    ___ResourceStatusUpdate_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___ResourceStatusUpdate_protocolIEs__item__criticality._const_tab = ____ResourceStatusUpdate_protocolIEs__item__id_tab
    ___ResourceStatusUpdate_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceStatusUpdate_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ResourceStatusUpdate_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___ResourceStatusUpdate_protocolIEs__item__value._const_tab = ____ResourceStatusUpdate_protocolIEs__item__id_tab
    ___ResourceStatusUpdate_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ResourceStatusUpdate_protocolIEs__item__value._const_tab_id = 'Value'
    __ResourceStatusUpdate_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ResourceStatusUpdate_protocolIEs__item__id),
        ('criticality', ___ResourceStatusUpdate_protocolIEs__item__criticality),
        ('value', ___ResourceStatusUpdate_protocolIEs__item__value),
        ])
    __ResourceStatusUpdate_protocolIEs__item_._ext = None
    _ResourceStatusUpdate_protocolIEs._cont = __ResourceStatusUpdate_protocolIEs__item_
    _ResourceStatusUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResourceStatusUpdate._cont = ASN1Dict([
        ('protocolIEs', _ResourceStatusUpdate_protocolIEs),
        ])
    ResourceStatusUpdate._ext = []
    
    #-----< ResourceStatusUpdateIEs >-----#
    ResourceStatusUpdateIEs = CLASS(name='ResourceStatusUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _ResourceStatusUpdateIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _ResourceStatusUpdateIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE)
    _ResourceStatusUpdateIEs_val_Value_1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4095)], ev=[], er=[])
    _ResourceStatusUpdateIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE)
    _ResourceStatusUpdateIEs_val_Value_2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4095)], ev=[], er=[])
    _ResourceStatusUpdateIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TNL-AvailableCapacityIndicator')))
    _ResourceStatusUpdateIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'HW-CapacityIndicator')))
    ResourceStatusUpdateIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _ResourceStatusUpdateIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 89), ('criticality', 'reject'), ('Value', _ResourceStatusUpdateIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 90), ('criticality', 'ignore'), ('Value', _ResourceStatusUpdateIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 94), ('criticality', 'ignore'), ('Value', _ResourceStatusUpdateIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 95), ('criticality', 'ignore'), ('Value', _ResourceStatusUpdateIEs_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< IAB-UPTNLAddressUpdate >-----#
    IAB_UPTNLAddressUpdate = SEQ(name='IAB-UPTNLAddressUpdate', mode=MODE_TYPE)
    _IAB_UPTNLAddressUpdate_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __IAB_UPTNLAddressUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___IAB_UPTNLAddressUpdate_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____IAB_UPTNLAddressUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____IAB_UPTNLAddressUpdate_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____IAB_UPTNLAddressUpdate_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'DLUPTNLAddressToUpdateList')))
    ____IAB_UPTNLAddressUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____IAB_UPTNLAddressUpdate_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 108), ('criticality', 'ignore'), ('Value', _____IAB_UPTNLAddressUpdate_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___IAB_UPTNLAddressUpdate_protocolIEs__item__id._const_tab = ____IAB_UPTNLAddressUpdate_protocolIEs__item__id_tab
    ___IAB_UPTNLAddressUpdate_protocolIEs__item__id._const_tab_at = None
    ___IAB_UPTNLAddressUpdate_protocolIEs__item__id._const_tab_id = 'id'
    ___IAB_UPTNLAddressUpdate_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___IAB_UPTNLAddressUpdate_protocolIEs__item__criticality._const_tab = ____IAB_UPTNLAddressUpdate_protocolIEs__item__id_tab
    ___IAB_UPTNLAddressUpdate_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___IAB_UPTNLAddressUpdate_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___IAB_UPTNLAddressUpdate_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___IAB_UPTNLAddressUpdate_protocolIEs__item__value._const_tab = ____IAB_UPTNLAddressUpdate_protocolIEs__item__id_tab
    ___IAB_UPTNLAddressUpdate_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___IAB_UPTNLAddressUpdate_protocolIEs__item__value._const_tab_id = 'Value'
    __IAB_UPTNLAddressUpdate_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___IAB_UPTNLAddressUpdate_protocolIEs__item__id),
        ('criticality', ___IAB_UPTNLAddressUpdate_protocolIEs__item__criticality),
        ('value', ___IAB_UPTNLAddressUpdate_protocolIEs__item__value),
        ])
    __IAB_UPTNLAddressUpdate_protocolIEs__item_._ext = None
    _IAB_UPTNLAddressUpdate_protocolIEs._cont = __IAB_UPTNLAddressUpdate_protocolIEs__item_
    _IAB_UPTNLAddressUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    IAB_UPTNLAddressUpdate._cont = ASN1Dict([
        ('protocolIEs', _IAB_UPTNLAddressUpdate_protocolIEs),
        ])
    IAB_UPTNLAddressUpdate._ext = []
    
    #-----< IAB-UPTNLAddressUpdateIEs >-----#
    IAB_UPTNLAddressUpdateIEs = CLASS(name='IAB-UPTNLAddressUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _IAB_UPTNLAddressUpdateIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _IAB_UPTNLAddressUpdateIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'DLUPTNLAddressToUpdateList')))
    IAB_UPTNLAddressUpdateIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _IAB_UPTNLAddressUpdateIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 108), ('criticality', 'ignore'), ('Value', _IAB_UPTNLAddressUpdateIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DLUPTNLAddressToUpdateList >-----#
    DLUPTNLAddressToUpdateList = SEQ_OF(name='DLUPTNLAddressToUpdateList', mode=MODE_TYPE)
    _DLUPTNLAddressToUpdateList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DLUPTNLAddressToUpdateItem')))
    DLUPTNLAddressToUpdateList._cont = _DLUPTNLAddressToUpdateList__item_
    DLUPTNLAddressToUpdateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< IAB-UPTNLAddressUpdateAcknowledge >-----#
    IAB_UPTNLAddressUpdateAcknowledge = SEQ(name='IAB-UPTNLAddressUpdateAcknowledge', mode=MODE_TYPE)
    _IAB_UPTNLAddressUpdateAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    _____IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ULUPTNLAddressToUpdateList')))
    ____IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 109), ('criticality', 'ignore'), ('Value', _____IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__id._const_tab = ____IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__id_tab
    ___IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__criticality._const_tab = ____IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__id_tab
    ___IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__value._const_tab = ____IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__id_tab
    ___IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__id),
        ('criticality', ___IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__criticality),
        ('value', ___IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__value),
        ])
    __IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item_._ext = None
    _IAB_UPTNLAddressUpdateAcknowledge_protocolIEs._cont = __IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item_
    _IAB_UPTNLAddressUpdateAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    IAB_UPTNLAddressUpdateAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _IAB_UPTNLAddressUpdateAcknowledge_protocolIEs),
        ])
    IAB_UPTNLAddressUpdateAcknowledge._ext = []
    
    #-----< IAB-UPTNLAddressUpdateAcknowledgeIEs >-----#
    IAB_UPTNLAddressUpdateAcknowledgeIEs = CLASS(name='IAB-UPTNLAddressUpdateAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _IAB_UPTNLAddressUpdateAcknowledgeIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _IAB_UPTNLAddressUpdateAcknowledgeIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    _IAB_UPTNLAddressUpdateAcknowledgeIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ULUPTNLAddressToUpdateList')))
    IAB_UPTNLAddressUpdateAcknowledgeIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _IAB_UPTNLAddressUpdateAcknowledgeIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _IAB_UPTNLAddressUpdateAcknowledgeIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 109), ('criticality', 'ignore'), ('Value', _IAB_UPTNLAddressUpdateAcknowledgeIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ULUPTNLAddressToUpdateList >-----#
    ULUPTNLAddressToUpdateList = SEQ_OF(name='ULUPTNLAddressToUpdateList', mode=MODE_TYPE)
    _ULUPTNLAddressToUpdateList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'ULUPTNLAddressToUpdateItem')))
    ULUPTNLAddressToUpdateList._cont = _ULUPTNLAddressToUpdateList__item_
    ULUPTNLAddressToUpdateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< IAB-UPTNLAddressUpdateFailure >-----#
    IAB_UPTNLAddressUpdateFailure = SEQ(name='IAB-UPTNLAddressUpdateFailure', mode=MODE_TYPE)
    _IAB_UPTNLAddressUpdateFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __IAB_UPTNLAddressUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___IAB_UPTNLAddressUpdateFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____IAB_UPTNLAddressUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____IAB_UPTNLAddressUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____IAB_UPTNLAddressUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _____IAB_UPTNLAddressUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TimeToWait')))
    _____IAB_UPTNLAddressUpdateFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____IAB_UPTNLAddressUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____IAB_UPTNLAddressUpdateFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____IAB_UPTNLAddressUpdateFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 12), ('criticality', 'ignore'), ('Value', _____IAB_UPTNLAddressUpdateFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____IAB_UPTNLAddressUpdateFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___IAB_UPTNLAddressUpdateFailure_protocolIEs__item__id._const_tab = ____IAB_UPTNLAddressUpdateFailure_protocolIEs__item__id_tab
    ___IAB_UPTNLAddressUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___IAB_UPTNLAddressUpdateFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___IAB_UPTNLAddressUpdateFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___IAB_UPTNLAddressUpdateFailure_protocolIEs__item__criticality._const_tab = ____IAB_UPTNLAddressUpdateFailure_protocolIEs__item__id_tab
    ___IAB_UPTNLAddressUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___IAB_UPTNLAddressUpdateFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___IAB_UPTNLAddressUpdateFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___IAB_UPTNLAddressUpdateFailure_protocolIEs__item__value._const_tab = ____IAB_UPTNLAddressUpdateFailure_protocolIEs__item__id_tab
    ___IAB_UPTNLAddressUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___IAB_UPTNLAddressUpdateFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __IAB_UPTNLAddressUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___IAB_UPTNLAddressUpdateFailure_protocolIEs__item__id),
        ('criticality', ___IAB_UPTNLAddressUpdateFailure_protocolIEs__item__criticality),
        ('value', ___IAB_UPTNLAddressUpdateFailure_protocolIEs__item__value),
        ])
    __IAB_UPTNLAddressUpdateFailure_protocolIEs__item_._ext = None
    _IAB_UPTNLAddressUpdateFailure_protocolIEs._cont = __IAB_UPTNLAddressUpdateFailure_protocolIEs__item_
    _IAB_UPTNLAddressUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    IAB_UPTNLAddressUpdateFailure._cont = ASN1Dict([
        ('protocolIEs', _IAB_UPTNLAddressUpdateFailure_protocolIEs),
        ])
    IAB_UPTNLAddressUpdateFailure._ext = []
    
    #-----< IAB-UPTNLAddressUpdateFailureIEs >-----#
    IAB_UPTNLAddressUpdateFailureIEs = CLASS(name='IAB-UPTNLAddressUpdateFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _IAB_UPTNLAddressUpdateFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _IAB_UPTNLAddressUpdateFailureIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _IAB_UPTNLAddressUpdateFailureIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TimeToWait')))
    _IAB_UPTNLAddressUpdateFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    IAB_UPTNLAddressUpdateFailureIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _IAB_UPTNLAddressUpdateFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _IAB_UPTNLAddressUpdateFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 12), ('criticality', 'ignore'), ('Value', _IAB_UPTNLAddressUpdateFailureIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _IAB_UPTNLAddressUpdateFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< EarlyForwardingSNTransfer >-----#
    EarlyForwardingSNTransfer = SEQ(name='EarlyForwardingSNTransfer', mode=MODE_TYPE)
    _EarlyForwardingSNTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __EarlyForwardingSNTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___EarlyForwardingSNTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____EarlyForwardingSNTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____EarlyForwardingSNTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _____EarlyForwardingSNTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _____EarlyForwardingSNTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRBs-Subject-To-Early-Forwarding-List')))
    ____EarlyForwardingSNTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____EarlyForwardingSNTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____EarlyForwardingSNTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 119), ('criticality', 'reject'), ('Value', _____EarlyForwardingSNTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___EarlyForwardingSNTransfer_protocolIEs__item__id._const_tab = ____EarlyForwardingSNTransfer_protocolIEs__item__id_tab
    ___EarlyForwardingSNTransfer_protocolIEs__item__id._const_tab_at = None
    ___EarlyForwardingSNTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___EarlyForwardingSNTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___EarlyForwardingSNTransfer_protocolIEs__item__criticality._const_tab = ____EarlyForwardingSNTransfer_protocolIEs__item__id_tab
    ___EarlyForwardingSNTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___EarlyForwardingSNTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___EarlyForwardingSNTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___EarlyForwardingSNTransfer_protocolIEs__item__value._const_tab = ____EarlyForwardingSNTransfer_protocolIEs__item__id_tab
    ___EarlyForwardingSNTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___EarlyForwardingSNTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __EarlyForwardingSNTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___EarlyForwardingSNTransfer_protocolIEs__item__id),
        ('criticality', ___EarlyForwardingSNTransfer_protocolIEs__item__criticality),
        ('value', ___EarlyForwardingSNTransfer_protocolIEs__item__value),
        ])
    __EarlyForwardingSNTransfer_protocolIEs__item_._ext = None
    _EarlyForwardingSNTransfer_protocolIEs._cont = __EarlyForwardingSNTransfer_protocolIEs__item_
    _EarlyForwardingSNTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    EarlyForwardingSNTransfer._cont = ASN1Dict([
        ('protocolIEs', _EarlyForwardingSNTransfer_protocolIEs),
        ])
    EarlyForwardingSNTransfer._ext = []
    
    #-----< EarlyForwardingSNTransferIEs >-----#
    EarlyForwardingSNTransferIEs = CLASS(name='EarlyForwardingSNTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _EarlyForwardingSNTransferIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-UE-E1AP-ID')))
    _EarlyForwardingSNTransferIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-UE-E1AP-ID')))
    _EarlyForwardingSNTransferIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'DRBs-Subject-To-Early-Forwarding-List')))
    EarlyForwardingSNTransferIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _EarlyForwardingSNTransferIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _EarlyForwardingSNTransferIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 119), ('criticality', 'reject'), ('Value', _EarlyForwardingSNTransferIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< IABPSKNotification >-----#
    IABPSKNotification = SEQ(name='IABPSKNotification', mode=MODE_TYPE)
    _IABPSKNotification_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __IABPSKNotification_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___IABPSKNotification_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____IABPSKNotification_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____IABPSKNotification_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _____IABPSKNotification_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IAB-Donor-CU-UPPSKInfo')))
    ____IABPSKNotification_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____IABPSKNotification_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 144), ('criticality', 'reject'), ('Value', _____IABPSKNotification_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___IABPSKNotification_protocolIEs__item__id._const_tab = ____IABPSKNotification_protocolIEs__item__id_tab
    ___IABPSKNotification_protocolIEs__item__id._const_tab_at = None
    ___IABPSKNotification_protocolIEs__item__id._const_tab_id = 'id'
    ___IABPSKNotification_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___IABPSKNotification_protocolIEs__item__criticality._const_tab = ____IABPSKNotification_protocolIEs__item__id_tab
    ___IABPSKNotification_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___IABPSKNotification_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___IABPSKNotification_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___IABPSKNotification_protocolIEs__item__value._const_tab = ____IABPSKNotification_protocolIEs__item__id_tab
    ___IABPSKNotification_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___IABPSKNotification_protocolIEs__item__value._const_tab_id = 'Value'
    __IABPSKNotification_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___IABPSKNotification_protocolIEs__item__id),
        ('criticality', ___IABPSKNotification_protocolIEs__item__criticality),
        ('value', ___IABPSKNotification_protocolIEs__item__value),
        ])
    __IABPSKNotification_protocolIEs__item_._ext = None
    _IABPSKNotification_protocolIEs._cont = __IABPSKNotification_protocolIEs__item_
    _IABPSKNotification_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    IABPSKNotification._cont = ASN1Dict([
        ('protocolIEs', _IABPSKNotification_protocolIEs),
        ])
    IABPSKNotification._ext = []
    
    #-----< IABPSKNotificationIEs >-----#
    IABPSKNotificationIEs = CLASS(name='IABPSKNotificationIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _IABPSKNotificationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'TransactionID')))
    _IABPSKNotificationIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IAB-Donor-CU-UPPSKInfo')))
    IABPSKNotificationIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _IABPSKNotificationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 144), ('criticality', 'reject'), ('Value', _IABPSKNotificationIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< IAB-Donor-CU-UPPSKInfo >-----#
    IAB_Donor_CU_UPPSKInfo = SEQ_OF(name='IAB-Donor-CU-UPPSKInfo', mode=MODE_TYPE)
    _IAB_Donor_CU_UPPSKInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'IAB-Donor-CU-UPPSKInfo-Item')))
    IAB_Donor_CU_UPPSKInfo._cont = _IAB_Donor_CU_UPPSKInfo__item_
    IAB_Donor_CU_UPPSKInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< BCBearerContextSetupRequest >-----#
    BCBearerContextSetupRequest = SEQ(name='BCBearerContextSetupRequest', mode=MODE_TYPE)
    _BCBearerContextSetupRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __BCBearerContextSetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___BCBearerContextSetupRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____BCBearerContextSetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____BCBearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _____BCBearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GlobalMBSSessionID')))
    _____BCBearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BCBearerContextToSetup')))
    ____BCBearerContextSetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _____BCBearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____BCBearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 158), ('criticality', 'reject'), ('Value', _____BCBearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___BCBearerContextSetupRequest_protocolIEs__item__id._const_tab = ____BCBearerContextSetupRequest_protocolIEs__item__id_tab
    ___BCBearerContextSetupRequest_protocolIEs__item__id._const_tab_at = None
    ___BCBearerContextSetupRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___BCBearerContextSetupRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BCBearerContextSetupRequest_protocolIEs__item__criticality._const_tab = ____BCBearerContextSetupRequest_protocolIEs__item__id_tab
    ___BCBearerContextSetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BCBearerContextSetupRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BCBearerContextSetupRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BCBearerContextSetupRequest_protocolIEs__item__value._const_tab = ____BCBearerContextSetupRequest_protocolIEs__item__id_tab
    ___BCBearerContextSetupRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BCBearerContextSetupRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __BCBearerContextSetupRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BCBearerContextSetupRequest_protocolIEs__item__id),
        ('criticality', ___BCBearerContextSetupRequest_protocolIEs__item__criticality),
        ('value', ___BCBearerContextSetupRequest_protocolIEs__item__value),
        ])
    __BCBearerContextSetupRequest_protocolIEs__item_._ext = None
    _BCBearerContextSetupRequest_protocolIEs._cont = __BCBearerContextSetupRequest_protocolIEs__item_
    _BCBearerContextSetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BCBearerContextSetupRequest._cont = ASN1Dict([
        ('protocolIEs', _BCBearerContextSetupRequest_protocolIEs),
        ])
    BCBearerContextSetupRequest._ext = []
    
    #-----< BCBearerContextSetupRequestIEs >-----#
    BCBearerContextSetupRequestIEs = CLASS(name='BCBearerContextSetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _BCBearerContextSetupRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _BCBearerContextSetupRequestIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GlobalMBSSessionID')))
    _BCBearerContextSetupRequestIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BCBearerContextToSetup')))
    BCBearerContextSetupRequestIEs._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _BCBearerContextSetupRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _BCBearerContextSetupRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 158), ('criticality', 'reject'), ('Value', _BCBearerContextSetupRequestIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BCBearerContextSetupResponse >-----#
    BCBearerContextSetupResponse = SEQ(name='BCBearerContextSetupResponse', mode=MODE_TYPE)
    _BCBearerContextSetupResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __BCBearerContextSetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___BCBearerContextSetupResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____BCBearerContextSetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____BCBearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _____BCBearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _____BCBearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BCBearerContextToSetupResponse')))
    _____BCBearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____BCBearerContextSetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _____BCBearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____BCBearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 159), ('criticality', 'reject'), ('Value', _____BCBearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____BCBearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BCBearerContextSetupResponse_protocolIEs__item__id._const_tab = ____BCBearerContextSetupResponse_protocolIEs__item__id_tab
    ___BCBearerContextSetupResponse_protocolIEs__item__id._const_tab_at = None
    ___BCBearerContextSetupResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___BCBearerContextSetupResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BCBearerContextSetupResponse_protocolIEs__item__criticality._const_tab = ____BCBearerContextSetupResponse_protocolIEs__item__id_tab
    ___BCBearerContextSetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BCBearerContextSetupResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BCBearerContextSetupResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BCBearerContextSetupResponse_protocolIEs__item__value._const_tab = ____BCBearerContextSetupResponse_protocolIEs__item__id_tab
    ___BCBearerContextSetupResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BCBearerContextSetupResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __BCBearerContextSetupResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BCBearerContextSetupResponse_protocolIEs__item__id),
        ('criticality', ___BCBearerContextSetupResponse_protocolIEs__item__criticality),
        ('value', ___BCBearerContextSetupResponse_protocolIEs__item__value),
        ])
    __BCBearerContextSetupResponse_protocolIEs__item_._ext = None
    _BCBearerContextSetupResponse_protocolIEs._cont = __BCBearerContextSetupResponse_protocolIEs__item_
    _BCBearerContextSetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BCBearerContextSetupResponse._cont = ASN1Dict([
        ('protocolIEs', _BCBearerContextSetupResponse_protocolIEs),
        ])
    BCBearerContextSetupResponse._ext = []
    
    #-----< BCBearerContextSetupResponseIEs >-----#
    BCBearerContextSetupResponseIEs = CLASS(name='BCBearerContextSetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _BCBearerContextSetupResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _BCBearerContextSetupResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _BCBearerContextSetupResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BCBearerContextToSetupResponse')))
    _BCBearerContextSetupResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    BCBearerContextSetupResponseIEs._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _BCBearerContextSetupResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _BCBearerContextSetupResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 159), ('criticality', 'reject'), ('Value', _BCBearerContextSetupResponseIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _BCBearerContextSetupResponseIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BCBearerContextSetupFailure >-----#
    BCBearerContextSetupFailure = SEQ(name='BCBearerContextSetupFailure', mode=MODE_TYPE)
    _BCBearerContextSetupFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __BCBearerContextSetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___BCBearerContextSetupFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____BCBearerContextSetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____BCBearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _____BCBearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _____BCBearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _____BCBearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____BCBearerContextSetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _____BCBearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'ignore'), ('Value', _____BCBearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____BCBearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____BCBearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BCBearerContextSetupFailure_protocolIEs__item__id._const_tab = ____BCBearerContextSetupFailure_protocolIEs__item__id_tab
    ___BCBearerContextSetupFailure_protocolIEs__item__id._const_tab_at = None
    ___BCBearerContextSetupFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___BCBearerContextSetupFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BCBearerContextSetupFailure_protocolIEs__item__criticality._const_tab = ____BCBearerContextSetupFailure_protocolIEs__item__id_tab
    ___BCBearerContextSetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BCBearerContextSetupFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BCBearerContextSetupFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BCBearerContextSetupFailure_protocolIEs__item__value._const_tab = ____BCBearerContextSetupFailure_protocolIEs__item__id_tab
    ___BCBearerContextSetupFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BCBearerContextSetupFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __BCBearerContextSetupFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BCBearerContextSetupFailure_protocolIEs__item__id),
        ('criticality', ___BCBearerContextSetupFailure_protocolIEs__item__criticality),
        ('value', ___BCBearerContextSetupFailure_protocolIEs__item__value),
        ])
    __BCBearerContextSetupFailure_protocolIEs__item_._ext = None
    _BCBearerContextSetupFailure_protocolIEs._cont = __BCBearerContextSetupFailure_protocolIEs__item_
    _BCBearerContextSetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BCBearerContextSetupFailure._cont = ASN1Dict([
        ('protocolIEs', _BCBearerContextSetupFailure_protocolIEs),
        ])
    BCBearerContextSetupFailure._ext = []
    
    #-----< BCBearerContextSetupFailureIEs >-----#
    BCBearerContextSetupFailureIEs = CLASS(name='BCBearerContextSetupFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _BCBearerContextSetupFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _BCBearerContextSetupFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _BCBearerContextSetupFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _BCBearerContextSetupFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    BCBearerContextSetupFailureIEs._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _BCBearerContextSetupFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'ignore'), ('Value', _BCBearerContextSetupFailureIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _BCBearerContextSetupFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _BCBearerContextSetupFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BCBearerContextModificationRequest >-----#
    BCBearerContextModificationRequest = SEQ(name='BCBearerContextModificationRequest', mode=MODE_TYPE)
    _BCBearerContextModificationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __BCBearerContextModificationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___BCBearerContextModificationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____BCBearerContextModificationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____BCBearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _____BCBearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _____BCBearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BCBearerContextToModify')))
    ____BCBearerContextModificationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _____BCBearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____BCBearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 160), ('criticality', 'reject'), ('Value', _____BCBearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___BCBearerContextModificationRequest_protocolIEs__item__id._const_tab = ____BCBearerContextModificationRequest_protocolIEs__item__id_tab
    ___BCBearerContextModificationRequest_protocolIEs__item__id._const_tab_at = None
    ___BCBearerContextModificationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___BCBearerContextModificationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BCBearerContextModificationRequest_protocolIEs__item__criticality._const_tab = ____BCBearerContextModificationRequest_protocolIEs__item__id_tab
    ___BCBearerContextModificationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BCBearerContextModificationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BCBearerContextModificationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BCBearerContextModificationRequest_protocolIEs__item__value._const_tab = ____BCBearerContextModificationRequest_protocolIEs__item__id_tab
    ___BCBearerContextModificationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BCBearerContextModificationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __BCBearerContextModificationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BCBearerContextModificationRequest_protocolIEs__item__id),
        ('criticality', ___BCBearerContextModificationRequest_protocolIEs__item__criticality),
        ('value', ___BCBearerContextModificationRequest_protocolIEs__item__value),
        ])
    __BCBearerContextModificationRequest_protocolIEs__item_._ext = None
    _BCBearerContextModificationRequest_protocolIEs._cont = __BCBearerContextModificationRequest_protocolIEs__item_
    _BCBearerContextModificationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BCBearerContextModificationRequest._cont = ASN1Dict([
        ('protocolIEs', _BCBearerContextModificationRequest_protocolIEs),
        ])
    BCBearerContextModificationRequest._ext = []
    
    #-----< BCBearerContextModificationRequestIEs >-----#
    BCBearerContextModificationRequestIEs = CLASS(name='BCBearerContextModificationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _BCBearerContextModificationRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _BCBearerContextModificationRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _BCBearerContextModificationRequestIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BCBearerContextToModify')))
    BCBearerContextModificationRequestIEs._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _BCBearerContextModificationRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _BCBearerContextModificationRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 160), ('criticality', 'reject'), ('Value', _BCBearerContextModificationRequestIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BCBearerContextModificationResponse >-----#
    BCBearerContextModificationResponse = SEQ(name='BCBearerContextModificationResponse', mode=MODE_TYPE)
    _BCBearerContextModificationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __BCBearerContextModificationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___BCBearerContextModificationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____BCBearerContextModificationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____BCBearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _____BCBearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _____BCBearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BCBearerContextToModifyResponse')))
    _____BCBearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____BCBearerContextModificationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _____BCBearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____BCBearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 161), ('criticality', 'reject'), ('Value', _____BCBearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____BCBearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BCBearerContextModificationResponse_protocolIEs__item__id._const_tab = ____BCBearerContextModificationResponse_protocolIEs__item__id_tab
    ___BCBearerContextModificationResponse_protocolIEs__item__id._const_tab_at = None
    ___BCBearerContextModificationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___BCBearerContextModificationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BCBearerContextModificationResponse_protocolIEs__item__criticality._const_tab = ____BCBearerContextModificationResponse_protocolIEs__item__id_tab
    ___BCBearerContextModificationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BCBearerContextModificationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BCBearerContextModificationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BCBearerContextModificationResponse_protocolIEs__item__value._const_tab = ____BCBearerContextModificationResponse_protocolIEs__item__id_tab
    ___BCBearerContextModificationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BCBearerContextModificationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __BCBearerContextModificationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BCBearerContextModificationResponse_protocolIEs__item__id),
        ('criticality', ___BCBearerContextModificationResponse_protocolIEs__item__criticality),
        ('value', ___BCBearerContextModificationResponse_protocolIEs__item__value),
        ])
    __BCBearerContextModificationResponse_protocolIEs__item_._ext = None
    _BCBearerContextModificationResponse_protocolIEs._cont = __BCBearerContextModificationResponse_protocolIEs__item_
    _BCBearerContextModificationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BCBearerContextModificationResponse._cont = ASN1Dict([
        ('protocolIEs', _BCBearerContextModificationResponse_protocolIEs),
        ])
    BCBearerContextModificationResponse._ext = []
    
    #-----< BCBearerContextModificationResponseIEs >-----#
    BCBearerContextModificationResponseIEs = CLASS(name='BCBearerContextModificationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _BCBearerContextModificationResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _BCBearerContextModificationResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _BCBearerContextModificationResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BCBearerContextToModifyResponse')))
    _BCBearerContextModificationResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    BCBearerContextModificationResponseIEs._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _BCBearerContextModificationResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _BCBearerContextModificationResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 161), ('criticality', 'reject'), ('Value', _BCBearerContextModificationResponseIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _BCBearerContextModificationResponseIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BCBearerContextModificationFailure >-----#
    BCBearerContextModificationFailure = SEQ(name='BCBearerContextModificationFailure', mode=MODE_TYPE)
    _BCBearerContextModificationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __BCBearerContextModificationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___BCBearerContextModificationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____BCBearerContextModificationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____BCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _____BCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _____BCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _____BCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____BCBearerContextModificationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _____BCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____BCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____BCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____BCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BCBearerContextModificationFailure_protocolIEs__item__id._const_tab = ____BCBearerContextModificationFailure_protocolIEs__item__id_tab
    ___BCBearerContextModificationFailure_protocolIEs__item__id._const_tab_at = None
    ___BCBearerContextModificationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___BCBearerContextModificationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BCBearerContextModificationFailure_protocolIEs__item__criticality._const_tab = ____BCBearerContextModificationFailure_protocolIEs__item__id_tab
    ___BCBearerContextModificationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BCBearerContextModificationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BCBearerContextModificationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BCBearerContextModificationFailure_protocolIEs__item__value._const_tab = ____BCBearerContextModificationFailure_protocolIEs__item__id_tab
    ___BCBearerContextModificationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BCBearerContextModificationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __BCBearerContextModificationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BCBearerContextModificationFailure_protocolIEs__item__id),
        ('criticality', ___BCBearerContextModificationFailure_protocolIEs__item__criticality),
        ('value', ___BCBearerContextModificationFailure_protocolIEs__item__value),
        ])
    __BCBearerContextModificationFailure_protocolIEs__item_._ext = None
    _BCBearerContextModificationFailure_protocolIEs._cont = __BCBearerContextModificationFailure_protocolIEs__item_
    _BCBearerContextModificationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BCBearerContextModificationFailure._cont = ASN1Dict([
        ('protocolIEs', _BCBearerContextModificationFailure_protocolIEs),
        ])
    BCBearerContextModificationFailure._ext = []
    
    #-----< BCBearerContextModificationFailureIEs >-----#
    BCBearerContextModificationFailureIEs = CLASS(name='BCBearerContextModificationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _BCBearerContextModificationFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _BCBearerContextModificationFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _BCBearerContextModificationFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _BCBearerContextModificationFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    BCBearerContextModificationFailureIEs._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _BCBearerContextModificationFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _BCBearerContextModificationFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _BCBearerContextModificationFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _BCBearerContextModificationFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BCBearerContextModificationRequired >-----#
    BCBearerContextModificationRequired = SEQ(name='BCBearerContextModificationRequired', mode=MODE_TYPE)
    _BCBearerContextModificationRequired_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __BCBearerContextModificationRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___BCBearerContextModificationRequired_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____BCBearerContextModificationRequired_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____BCBearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _____BCBearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _____BCBearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BCBearerContextToModifyRequired')))
    ____BCBearerContextModificationRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _____BCBearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____BCBearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 162), ('criticality', 'reject'), ('Value', _____BCBearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___BCBearerContextModificationRequired_protocolIEs__item__id._const_tab = ____BCBearerContextModificationRequired_protocolIEs__item__id_tab
    ___BCBearerContextModificationRequired_protocolIEs__item__id._const_tab_at = None
    ___BCBearerContextModificationRequired_protocolIEs__item__id._const_tab_id = 'id'
    ___BCBearerContextModificationRequired_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BCBearerContextModificationRequired_protocolIEs__item__criticality._const_tab = ____BCBearerContextModificationRequired_protocolIEs__item__id_tab
    ___BCBearerContextModificationRequired_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BCBearerContextModificationRequired_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BCBearerContextModificationRequired_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BCBearerContextModificationRequired_protocolIEs__item__value._const_tab = ____BCBearerContextModificationRequired_protocolIEs__item__id_tab
    ___BCBearerContextModificationRequired_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BCBearerContextModificationRequired_protocolIEs__item__value._const_tab_id = 'Value'
    __BCBearerContextModificationRequired_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BCBearerContextModificationRequired_protocolIEs__item__id),
        ('criticality', ___BCBearerContextModificationRequired_protocolIEs__item__criticality),
        ('value', ___BCBearerContextModificationRequired_protocolIEs__item__value),
        ])
    __BCBearerContextModificationRequired_protocolIEs__item_._ext = None
    _BCBearerContextModificationRequired_protocolIEs._cont = __BCBearerContextModificationRequired_protocolIEs__item_
    _BCBearerContextModificationRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BCBearerContextModificationRequired._cont = ASN1Dict([
        ('protocolIEs', _BCBearerContextModificationRequired_protocolIEs),
        ])
    BCBearerContextModificationRequired._ext = []
    
    #-----< BCBearerContextModificationRequiredIEs >-----#
    BCBearerContextModificationRequiredIEs = CLASS(name='BCBearerContextModificationRequiredIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _BCBearerContextModificationRequiredIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _BCBearerContextModificationRequiredIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _BCBearerContextModificationRequiredIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BCBearerContextToModifyRequired')))
    BCBearerContextModificationRequiredIEs._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _BCBearerContextModificationRequiredIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _BCBearerContextModificationRequiredIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 162), ('criticality', 'reject'), ('Value', _BCBearerContextModificationRequiredIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BCBearerContextModificationConfirm >-----#
    BCBearerContextModificationConfirm = SEQ(name='BCBearerContextModificationConfirm', mode=MODE_TYPE)
    _BCBearerContextModificationConfirm_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __BCBearerContextModificationConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___BCBearerContextModificationConfirm_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____BCBearerContextModificationConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____BCBearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _____BCBearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _____BCBearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BCBearerContextToModifyConfirm')))
    _____BCBearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____BCBearerContextModificationConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _____BCBearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____BCBearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 163), ('criticality', 'reject'), ('Value', _____BCBearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____BCBearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BCBearerContextModificationConfirm_protocolIEs__item__id._const_tab = ____BCBearerContextModificationConfirm_protocolIEs__item__id_tab
    ___BCBearerContextModificationConfirm_protocolIEs__item__id._const_tab_at = None
    ___BCBearerContextModificationConfirm_protocolIEs__item__id._const_tab_id = 'id'
    ___BCBearerContextModificationConfirm_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BCBearerContextModificationConfirm_protocolIEs__item__criticality._const_tab = ____BCBearerContextModificationConfirm_protocolIEs__item__id_tab
    ___BCBearerContextModificationConfirm_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BCBearerContextModificationConfirm_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BCBearerContextModificationConfirm_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BCBearerContextModificationConfirm_protocolIEs__item__value._const_tab = ____BCBearerContextModificationConfirm_protocolIEs__item__id_tab
    ___BCBearerContextModificationConfirm_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BCBearerContextModificationConfirm_protocolIEs__item__value._const_tab_id = 'Value'
    __BCBearerContextModificationConfirm_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BCBearerContextModificationConfirm_protocolIEs__item__id),
        ('criticality', ___BCBearerContextModificationConfirm_protocolIEs__item__criticality),
        ('value', ___BCBearerContextModificationConfirm_protocolIEs__item__value),
        ])
    __BCBearerContextModificationConfirm_protocolIEs__item_._ext = None
    _BCBearerContextModificationConfirm_protocolIEs._cont = __BCBearerContextModificationConfirm_protocolIEs__item_
    _BCBearerContextModificationConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BCBearerContextModificationConfirm._cont = ASN1Dict([
        ('protocolIEs', _BCBearerContextModificationConfirm_protocolIEs),
        ])
    BCBearerContextModificationConfirm._ext = []
    
    #-----< BCBearerContextModificationConfirmIEs >-----#
    BCBearerContextModificationConfirmIEs = CLASS(name='BCBearerContextModificationConfirmIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _BCBearerContextModificationConfirmIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _BCBearerContextModificationConfirmIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _BCBearerContextModificationConfirmIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'BCBearerContextToModifyConfirm')))
    _BCBearerContextModificationConfirmIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    BCBearerContextModificationConfirmIEs._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _BCBearerContextModificationConfirmIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _BCBearerContextModificationConfirmIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 163), ('criticality', 'reject'), ('Value', _BCBearerContextModificationConfirmIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _BCBearerContextModificationConfirmIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BCBearerContextReleaseCommand >-----#
    BCBearerContextReleaseCommand = SEQ(name='BCBearerContextReleaseCommand', mode=MODE_TYPE)
    _BCBearerContextReleaseCommand_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __BCBearerContextReleaseCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___BCBearerContextReleaseCommand_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____BCBearerContextReleaseCommand_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____BCBearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _____BCBearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _____BCBearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    ____BCBearerContextReleaseCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _____BCBearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____BCBearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____BCBearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___BCBearerContextReleaseCommand_protocolIEs__item__id._const_tab = ____BCBearerContextReleaseCommand_protocolIEs__item__id_tab
    ___BCBearerContextReleaseCommand_protocolIEs__item__id._const_tab_at = None
    ___BCBearerContextReleaseCommand_protocolIEs__item__id._const_tab_id = 'id'
    ___BCBearerContextReleaseCommand_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BCBearerContextReleaseCommand_protocolIEs__item__criticality._const_tab = ____BCBearerContextReleaseCommand_protocolIEs__item__id_tab
    ___BCBearerContextReleaseCommand_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BCBearerContextReleaseCommand_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BCBearerContextReleaseCommand_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BCBearerContextReleaseCommand_protocolIEs__item__value._const_tab = ____BCBearerContextReleaseCommand_protocolIEs__item__id_tab
    ___BCBearerContextReleaseCommand_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BCBearerContextReleaseCommand_protocolIEs__item__value._const_tab_id = 'Value'
    __BCBearerContextReleaseCommand_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BCBearerContextReleaseCommand_protocolIEs__item__id),
        ('criticality', ___BCBearerContextReleaseCommand_protocolIEs__item__criticality),
        ('value', ___BCBearerContextReleaseCommand_protocolIEs__item__value),
        ])
    __BCBearerContextReleaseCommand_protocolIEs__item_._ext = None
    _BCBearerContextReleaseCommand_protocolIEs._cont = __BCBearerContextReleaseCommand_protocolIEs__item_
    _BCBearerContextReleaseCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BCBearerContextReleaseCommand._cont = ASN1Dict([
        ('protocolIEs', _BCBearerContextReleaseCommand_protocolIEs),
        ])
    BCBearerContextReleaseCommand._ext = []
    
    #-----< BCBearerContextReleaseCommandIEs >-----#
    BCBearerContextReleaseCommandIEs = CLASS(name='BCBearerContextReleaseCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _BCBearerContextReleaseCommandIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _BCBearerContextReleaseCommandIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _BCBearerContextReleaseCommandIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    BCBearerContextReleaseCommandIEs._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _BCBearerContextReleaseCommandIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _BCBearerContextReleaseCommandIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _BCBearerContextReleaseCommandIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BCBearerContextReleaseComplete >-----#
    BCBearerContextReleaseComplete = SEQ(name='BCBearerContextReleaseComplete', mode=MODE_TYPE)
    _BCBearerContextReleaseComplete_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __BCBearerContextReleaseComplete_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___BCBearerContextReleaseComplete_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____BCBearerContextReleaseComplete_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____BCBearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _____BCBearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _____BCBearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____BCBearerContextReleaseComplete_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _____BCBearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____BCBearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____BCBearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BCBearerContextReleaseComplete_protocolIEs__item__id._const_tab = ____BCBearerContextReleaseComplete_protocolIEs__item__id_tab
    ___BCBearerContextReleaseComplete_protocolIEs__item__id._const_tab_at = None
    ___BCBearerContextReleaseComplete_protocolIEs__item__id._const_tab_id = 'id'
    ___BCBearerContextReleaseComplete_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BCBearerContextReleaseComplete_protocolIEs__item__criticality._const_tab = ____BCBearerContextReleaseComplete_protocolIEs__item__id_tab
    ___BCBearerContextReleaseComplete_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BCBearerContextReleaseComplete_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BCBearerContextReleaseComplete_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BCBearerContextReleaseComplete_protocolIEs__item__value._const_tab = ____BCBearerContextReleaseComplete_protocolIEs__item__id_tab
    ___BCBearerContextReleaseComplete_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BCBearerContextReleaseComplete_protocolIEs__item__value._const_tab_id = 'Value'
    __BCBearerContextReleaseComplete_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BCBearerContextReleaseComplete_protocolIEs__item__id),
        ('criticality', ___BCBearerContextReleaseComplete_protocolIEs__item__criticality),
        ('value', ___BCBearerContextReleaseComplete_protocolIEs__item__value),
        ])
    __BCBearerContextReleaseComplete_protocolIEs__item_._ext = None
    _BCBearerContextReleaseComplete_protocolIEs._cont = __BCBearerContextReleaseComplete_protocolIEs__item_
    _BCBearerContextReleaseComplete_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BCBearerContextReleaseComplete._cont = ASN1Dict([
        ('protocolIEs', _BCBearerContextReleaseComplete_protocolIEs),
        ])
    BCBearerContextReleaseComplete._ext = []
    
    #-----< BCBearerContextReleaseCompleteIEs >-----#
    BCBearerContextReleaseCompleteIEs = CLASS(name='BCBearerContextReleaseCompleteIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _BCBearerContextReleaseCompleteIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _BCBearerContextReleaseCompleteIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _BCBearerContextReleaseCompleteIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    BCBearerContextReleaseCompleteIEs._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _BCBearerContextReleaseCompleteIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _BCBearerContextReleaseCompleteIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _BCBearerContextReleaseCompleteIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BCBearerContextReleaseRequest >-----#
    BCBearerContextReleaseRequest = SEQ(name='BCBearerContextReleaseRequest', mode=MODE_TYPE)
    _BCBearerContextReleaseRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __BCBearerContextReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___BCBearerContextReleaseRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____BCBearerContextReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____BCBearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _____BCBearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _____BCBearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    ____BCBearerContextReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _____BCBearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____BCBearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____BCBearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___BCBearerContextReleaseRequest_protocolIEs__item__id._const_tab = ____BCBearerContextReleaseRequest_protocolIEs__item__id_tab
    ___BCBearerContextReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___BCBearerContextReleaseRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___BCBearerContextReleaseRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___BCBearerContextReleaseRequest_protocolIEs__item__criticality._const_tab = ____BCBearerContextReleaseRequest_protocolIEs__item__id_tab
    ___BCBearerContextReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BCBearerContextReleaseRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BCBearerContextReleaseRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___BCBearerContextReleaseRequest_protocolIEs__item__value._const_tab = ____BCBearerContextReleaseRequest_protocolIEs__item__id_tab
    ___BCBearerContextReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BCBearerContextReleaseRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __BCBearerContextReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BCBearerContextReleaseRequest_protocolIEs__item__id),
        ('criticality', ___BCBearerContextReleaseRequest_protocolIEs__item__criticality),
        ('value', ___BCBearerContextReleaseRequest_protocolIEs__item__value),
        ])
    __BCBearerContextReleaseRequest_protocolIEs__item_._ext = None
    _BCBearerContextReleaseRequest_protocolIEs._cont = __BCBearerContextReleaseRequest_protocolIEs__item_
    _BCBearerContextReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BCBearerContextReleaseRequest._cont = ASN1Dict([
        ('protocolIEs', _BCBearerContextReleaseRequest_protocolIEs),
        ])
    BCBearerContextReleaseRequest._ext = []
    
    #-----< BCBearerContextReleaseRequestIEs >-----#
    BCBearerContextReleaseRequestIEs = CLASS(name='BCBearerContextReleaseRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _BCBearerContextReleaseRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _BCBearerContextReleaseRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _BCBearerContextReleaseRequestIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    BCBearerContextReleaseRequestIEs._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _BCBearerContextReleaseRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _BCBearerContextReleaseRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _BCBearerContextReleaseRequestIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MCBearerContextSetupRequest >-----#
    MCBearerContextSetupRequest = SEQ(name='MCBearerContextSetupRequest', mode=MODE_TYPE)
    _MCBearerContextSetupRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __MCBearerContextSetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___MCBearerContextSetupRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____MCBearerContextSetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____MCBearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _____MCBearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GlobalMBSSessionID')))
    _____MCBearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCBearerContextToSetup')))
    ____MCBearerContextSetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _____MCBearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____MCBearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 164), ('criticality', 'reject'), ('Value', _____MCBearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MCBearerContextSetupRequest_protocolIEs__item__id._const_tab = ____MCBearerContextSetupRequest_protocolIEs__item__id_tab
    ___MCBearerContextSetupRequest_protocolIEs__item__id._const_tab_at = None
    ___MCBearerContextSetupRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___MCBearerContextSetupRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___MCBearerContextSetupRequest_protocolIEs__item__criticality._const_tab = ____MCBearerContextSetupRequest_protocolIEs__item__id_tab
    ___MCBearerContextSetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MCBearerContextSetupRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MCBearerContextSetupRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___MCBearerContextSetupRequest_protocolIEs__item__value._const_tab = ____MCBearerContextSetupRequest_protocolIEs__item__id_tab
    ___MCBearerContextSetupRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MCBearerContextSetupRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __MCBearerContextSetupRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MCBearerContextSetupRequest_protocolIEs__item__id),
        ('criticality', ___MCBearerContextSetupRequest_protocolIEs__item__criticality),
        ('value', ___MCBearerContextSetupRequest_protocolIEs__item__value),
        ])
    __MCBearerContextSetupRequest_protocolIEs__item_._ext = None
    _MCBearerContextSetupRequest_protocolIEs._cont = __MCBearerContextSetupRequest_protocolIEs__item_
    _MCBearerContextSetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MCBearerContextSetupRequest._cont = ASN1Dict([
        ('protocolIEs', _MCBearerContextSetupRequest_protocolIEs),
        ])
    MCBearerContextSetupRequest._ext = []
    
    #-----< MCBearerContextSetupRequestIEs >-----#
    MCBearerContextSetupRequestIEs = CLASS(name='MCBearerContextSetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _MCBearerContextSetupRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _MCBearerContextSetupRequestIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GlobalMBSSessionID')))
    _MCBearerContextSetupRequestIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCBearerContextToSetup')))
    MCBearerContextSetupRequestIEs._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _MCBearerContextSetupRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _MCBearerContextSetupRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 164), ('criticality', 'reject'), ('Value', _MCBearerContextSetupRequestIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MCBearerContextSetupResponse >-----#
    MCBearerContextSetupResponse = SEQ(name='MCBearerContextSetupResponse', mode=MODE_TYPE)
    _MCBearerContextSetupResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __MCBearerContextSetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___MCBearerContextSetupResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____MCBearerContextSetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____MCBearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _____MCBearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _____MCBearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCBearerContextToSetupResponse')))
    _____MCBearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____MCBearerContextSetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _____MCBearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____MCBearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 165), ('criticality', 'reject'), ('Value', _____MCBearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____MCBearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MCBearerContextSetupResponse_protocolIEs__item__id._const_tab = ____MCBearerContextSetupResponse_protocolIEs__item__id_tab
    ___MCBearerContextSetupResponse_protocolIEs__item__id._const_tab_at = None
    ___MCBearerContextSetupResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___MCBearerContextSetupResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___MCBearerContextSetupResponse_protocolIEs__item__criticality._const_tab = ____MCBearerContextSetupResponse_protocolIEs__item__id_tab
    ___MCBearerContextSetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MCBearerContextSetupResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MCBearerContextSetupResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___MCBearerContextSetupResponse_protocolIEs__item__value._const_tab = ____MCBearerContextSetupResponse_protocolIEs__item__id_tab
    ___MCBearerContextSetupResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MCBearerContextSetupResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __MCBearerContextSetupResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MCBearerContextSetupResponse_protocolIEs__item__id),
        ('criticality', ___MCBearerContextSetupResponse_protocolIEs__item__criticality),
        ('value', ___MCBearerContextSetupResponse_protocolIEs__item__value),
        ])
    __MCBearerContextSetupResponse_protocolIEs__item_._ext = None
    _MCBearerContextSetupResponse_protocolIEs._cont = __MCBearerContextSetupResponse_protocolIEs__item_
    _MCBearerContextSetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MCBearerContextSetupResponse._cont = ASN1Dict([
        ('protocolIEs', _MCBearerContextSetupResponse_protocolIEs),
        ])
    MCBearerContextSetupResponse._ext = []
    
    #-----< MCBearerContextSetupResponseIEs >-----#
    MCBearerContextSetupResponseIEs = CLASS(name='MCBearerContextSetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _MCBearerContextSetupResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _MCBearerContextSetupResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _MCBearerContextSetupResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCBearerContextToSetupResponse')))
    _MCBearerContextSetupResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    MCBearerContextSetupResponseIEs._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _MCBearerContextSetupResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _MCBearerContextSetupResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 165), ('criticality', 'reject'), ('Value', _MCBearerContextSetupResponseIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _MCBearerContextSetupResponseIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MCBearerContextSetupFailure >-----#
    MCBearerContextSetupFailure = SEQ(name='MCBearerContextSetupFailure', mode=MODE_TYPE)
    _MCBearerContextSetupFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __MCBearerContextSetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___MCBearerContextSetupFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____MCBearerContextSetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____MCBearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _____MCBearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _____MCBearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _____MCBearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____MCBearerContextSetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _____MCBearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'ignore'), ('Value', _____MCBearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____MCBearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____MCBearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MCBearerContextSetupFailure_protocolIEs__item__id._const_tab = ____MCBearerContextSetupFailure_protocolIEs__item__id_tab
    ___MCBearerContextSetupFailure_protocolIEs__item__id._const_tab_at = None
    ___MCBearerContextSetupFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___MCBearerContextSetupFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___MCBearerContextSetupFailure_protocolIEs__item__criticality._const_tab = ____MCBearerContextSetupFailure_protocolIEs__item__id_tab
    ___MCBearerContextSetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MCBearerContextSetupFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MCBearerContextSetupFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___MCBearerContextSetupFailure_protocolIEs__item__value._const_tab = ____MCBearerContextSetupFailure_protocolIEs__item__id_tab
    ___MCBearerContextSetupFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MCBearerContextSetupFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __MCBearerContextSetupFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MCBearerContextSetupFailure_protocolIEs__item__id),
        ('criticality', ___MCBearerContextSetupFailure_protocolIEs__item__criticality),
        ('value', ___MCBearerContextSetupFailure_protocolIEs__item__value),
        ])
    __MCBearerContextSetupFailure_protocolIEs__item_._ext = None
    _MCBearerContextSetupFailure_protocolIEs._cont = __MCBearerContextSetupFailure_protocolIEs__item_
    _MCBearerContextSetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MCBearerContextSetupFailure._cont = ASN1Dict([
        ('protocolIEs', _MCBearerContextSetupFailure_protocolIEs),
        ])
    MCBearerContextSetupFailure._ext = []
    
    #-----< MCBearerContextSetupFailureIEs >-----#
    MCBearerContextSetupFailureIEs = CLASS(name='MCBearerContextSetupFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _MCBearerContextSetupFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _MCBearerContextSetupFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _MCBearerContextSetupFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _MCBearerContextSetupFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    MCBearerContextSetupFailureIEs._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _MCBearerContextSetupFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'ignore'), ('Value', _MCBearerContextSetupFailureIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _MCBearerContextSetupFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _MCBearerContextSetupFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MCBearerContextModificationRequest >-----#
    MCBearerContextModificationRequest = SEQ(name='MCBearerContextModificationRequest', mode=MODE_TYPE)
    _MCBearerContextModificationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __MCBearerContextModificationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___MCBearerContextModificationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____MCBearerContextModificationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____MCBearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _____MCBearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _____MCBearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCBearerContextToModify')))
    ____MCBearerContextModificationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _____MCBearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____MCBearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 166), ('criticality', 'reject'), ('Value', _____MCBearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MCBearerContextModificationRequest_protocolIEs__item__id._const_tab = ____MCBearerContextModificationRequest_protocolIEs__item__id_tab
    ___MCBearerContextModificationRequest_protocolIEs__item__id._const_tab_at = None
    ___MCBearerContextModificationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___MCBearerContextModificationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___MCBearerContextModificationRequest_protocolIEs__item__criticality._const_tab = ____MCBearerContextModificationRequest_protocolIEs__item__id_tab
    ___MCBearerContextModificationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MCBearerContextModificationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MCBearerContextModificationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___MCBearerContextModificationRequest_protocolIEs__item__value._const_tab = ____MCBearerContextModificationRequest_protocolIEs__item__id_tab
    ___MCBearerContextModificationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MCBearerContextModificationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __MCBearerContextModificationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MCBearerContextModificationRequest_protocolIEs__item__id),
        ('criticality', ___MCBearerContextModificationRequest_protocolIEs__item__criticality),
        ('value', ___MCBearerContextModificationRequest_protocolIEs__item__value),
        ])
    __MCBearerContextModificationRequest_protocolIEs__item_._ext = None
    _MCBearerContextModificationRequest_protocolIEs._cont = __MCBearerContextModificationRequest_protocolIEs__item_
    _MCBearerContextModificationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MCBearerContextModificationRequest._cont = ASN1Dict([
        ('protocolIEs', _MCBearerContextModificationRequest_protocolIEs),
        ])
    MCBearerContextModificationRequest._ext = []
    
    #-----< MCBearerContextModificationRequestIEs >-----#
    MCBearerContextModificationRequestIEs = CLASS(name='MCBearerContextModificationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _MCBearerContextModificationRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _MCBearerContextModificationRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _MCBearerContextModificationRequestIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCBearerContextToModify')))
    MCBearerContextModificationRequestIEs._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _MCBearerContextModificationRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _MCBearerContextModificationRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 166), ('criticality', 'reject'), ('Value', _MCBearerContextModificationRequestIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MCBearerContextModificationResponse >-----#
    MCBearerContextModificationResponse = SEQ(name='MCBearerContextModificationResponse', mode=MODE_TYPE)
    _MCBearerContextModificationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __MCBearerContextModificationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___MCBearerContextModificationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____MCBearerContextModificationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____MCBearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _____MCBearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _____MCBearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCBearerContextToModifyResponse')))
    _____MCBearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____MCBearerContextModificationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _____MCBearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____MCBearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 167), ('criticality', 'reject'), ('Value', _____MCBearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____MCBearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MCBearerContextModificationResponse_protocolIEs__item__id._const_tab = ____MCBearerContextModificationResponse_protocolIEs__item__id_tab
    ___MCBearerContextModificationResponse_protocolIEs__item__id._const_tab_at = None
    ___MCBearerContextModificationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___MCBearerContextModificationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___MCBearerContextModificationResponse_protocolIEs__item__criticality._const_tab = ____MCBearerContextModificationResponse_protocolIEs__item__id_tab
    ___MCBearerContextModificationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MCBearerContextModificationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MCBearerContextModificationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___MCBearerContextModificationResponse_protocolIEs__item__value._const_tab = ____MCBearerContextModificationResponse_protocolIEs__item__id_tab
    ___MCBearerContextModificationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MCBearerContextModificationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __MCBearerContextModificationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MCBearerContextModificationResponse_protocolIEs__item__id),
        ('criticality', ___MCBearerContextModificationResponse_protocolIEs__item__criticality),
        ('value', ___MCBearerContextModificationResponse_protocolIEs__item__value),
        ])
    __MCBearerContextModificationResponse_protocolIEs__item_._ext = None
    _MCBearerContextModificationResponse_protocolIEs._cont = __MCBearerContextModificationResponse_protocolIEs__item_
    _MCBearerContextModificationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MCBearerContextModificationResponse._cont = ASN1Dict([
        ('protocolIEs', _MCBearerContextModificationResponse_protocolIEs),
        ])
    MCBearerContextModificationResponse._ext = []
    
    #-----< MCBearerContextModificationResponseIEs >-----#
    MCBearerContextModificationResponseIEs = CLASS(name='MCBearerContextModificationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _MCBearerContextModificationResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _MCBearerContextModificationResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _MCBearerContextModificationResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCBearerContextToModifyResponse')))
    _MCBearerContextModificationResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    MCBearerContextModificationResponseIEs._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _MCBearerContextModificationResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _MCBearerContextModificationResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 167), ('criticality', 'reject'), ('Value', _MCBearerContextModificationResponseIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _MCBearerContextModificationResponseIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MCBearerContextModificationFailure >-----#
    MCBearerContextModificationFailure = SEQ(name='MCBearerContextModificationFailure', mode=MODE_TYPE)
    _MCBearerContextModificationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __MCBearerContextModificationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___MCBearerContextModificationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____MCBearerContextModificationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____MCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _____MCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _____MCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MBSMulticastF1UContextDescriptor')))
    _____MCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _____MCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____MCBearerContextModificationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _____MCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____MCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 170), ('criticality', 'reject'), ('Value', _____MCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____MCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____MCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MCBearerContextModificationFailure_protocolIEs__item__id._const_tab = ____MCBearerContextModificationFailure_protocolIEs__item__id_tab
    ___MCBearerContextModificationFailure_protocolIEs__item__id._const_tab_at = None
    ___MCBearerContextModificationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___MCBearerContextModificationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___MCBearerContextModificationFailure_protocolIEs__item__criticality._const_tab = ____MCBearerContextModificationFailure_protocolIEs__item__id_tab
    ___MCBearerContextModificationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MCBearerContextModificationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MCBearerContextModificationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___MCBearerContextModificationFailure_protocolIEs__item__value._const_tab = ____MCBearerContextModificationFailure_protocolIEs__item__id_tab
    ___MCBearerContextModificationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MCBearerContextModificationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __MCBearerContextModificationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MCBearerContextModificationFailure_protocolIEs__item__id),
        ('criticality', ___MCBearerContextModificationFailure_protocolIEs__item__criticality),
        ('value', ___MCBearerContextModificationFailure_protocolIEs__item__value),
        ])
    __MCBearerContextModificationFailure_protocolIEs__item_._ext = None
    _MCBearerContextModificationFailure_protocolIEs._cont = __MCBearerContextModificationFailure_protocolIEs__item_
    _MCBearerContextModificationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MCBearerContextModificationFailure._cont = ASN1Dict([
        ('protocolIEs', _MCBearerContextModificationFailure_protocolIEs),
        ])
    MCBearerContextModificationFailure._ext = []
    
    #-----< MCBearerContextModificationFailureIEs >-----#
    MCBearerContextModificationFailureIEs = CLASS(name='MCBearerContextModificationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _MCBearerContextModificationFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _MCBearerContextModificationFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _MCBearerContextModificationFailureIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MBSMulticastF1UContextDescriptor')))
    _MCBearerContextModificationFailureIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    _MCBearerContextModificationFailureIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    MCBearerContextModificationFailureIEs._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _MCBearerContextModificationFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _MCBearerContextModificationFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 170), ('criticality', 'reject'), ('Value', _MCBearerContextModificationFailureIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _MCBearerContextModificationFailureIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _MCBearerContextModificationFailureIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MCBearerContextModificationRequired >-----#
    MCBearerContextModificationRequired = SEQ(name='MCBearerContextModificationRequired', mode=MODE_TYPE)
    _MCBearerContextModificationRequired_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __MCBearerContextModificationRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___MCBearerContextModificationRequired_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____MCBearerContextModificationRequired_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____MCBearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _____MCBearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _____MCBearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCBearerContextToModifyRequired')))
    ____MCBearerContextModificationRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _____MCBearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____MCBearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 168), ('criticality', 'ignore'), ('Value', _____MCBearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MCBearerContextModificationRequired_protocolIEs__item__id._const_tab = ____MCBearerContextModificationRequired_protocolIEs__item__id_tab
    ___MCBearerContextModificationRequired_protocolIEs__item__id._const_tab_at = None
    ___MCBearerContextModificationRequired_protocolIEs__item__id._const_tab_id = 'id'
    ___MCBearerContextModificationRequired_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___MCBearerContextModificationRequired_protocolIEs__item__criticality._const_tab = ____MCBearerContextModificationRequired_protocolIEs__item__id_tab
    ___MCBearerContextModificationRequired_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MCBearerContextModificationRequired_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MCBearerContextModificationRequired_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___MCBearerContextModificationRequired_protocolIEs__item__value._const_tab = ____MCBearerContextModificationRequired_protocolIEs__item__id_tab
    ___MCBearerContextModificationRequired_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MCBearerContextModificationRequired_protocolIEs__item__value._const_tab_id = 'Value'
    __MCBearerContextModificationRequired_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MCBearerContextModificationRequired_protocolIEs__item__id),
        ('criticality', ___MCBearerContextModificationRequired_protocolIEs__item__criticality),
        ('value', ___MCBearerContextModificationRequired_protocolIEs__item__value),
        ])
    __MCBearerContextModificationRequired_protocolIEs__item_._ext = None
    _MCBearerContextModificationRequired_protocolIEs._cont = __MCBearerContextModificationRequired_protocolIEs__item_
    _MCBearerContextModificationRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MCBearerContextModificationRequired._cont = ASN1Dict([
        ('protocolIEs', _MCBearerContextModificationRequired_protocolIEs),
        ])
    MCBearerContextModificationRequired._ext = []
    
    #-----< MCBearerContextModificationRequiredIEs >-----#
    MCBearerContextModificationRequiredIEs = CLASS(name='MCBearerContextModificationRequiredIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _MCBearerContextModificationRequiredIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _MCBearerContextModificationRequiredIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _MCBearerContextModificationRequiredIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCBearerContextToModifyRequired')))
    MCBearerContextModificationRequiredIEs._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _MCBearerContextModificationRequiredIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _MCBearerContextModificationRequiredIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 168), ('criticality', 'ignore'), ('Value', _MCBearerContextModificationRequiredIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MCBearerContextModificationConfirm >-----#
    MCBearerContextModificationConfirm = SEQ(name='MCBearerContextModificationConfirm', mode=MODE_TYPE)
    _MCBearerContextModificationConfirm_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __MCBearerContextModificationConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___MCBearerContextModificationConfirm_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____MCBearerContextModificationConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____MCBearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _____MCBearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _____MCBearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCBearerContextToModifyConfirm')))
    _____MCBearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____MCBearerContextModificationConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _____MCBearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____MCBearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 169), ('criticality', 'reject'), ('Value', _____MCBearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____MCBearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MCBearerContextModificationConfirm_protocolIEs__item__id._const_tab = ____MCBearerContextModificationConfirm_protocolIEs__item__id_tab
    ___MCBearerContextModificationConfirm_protocolIEs__item__id._const_tab_at = None
    ___MCBearerContextModificationConfirm_protocolIEs__item__id._const_tab_id = 'id'
    ___MCBearerContextModificationConfirm_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___MCBearerContextModificationConfirm_protocolIEs__item__criticality._const_tab = ____MCBearerContextModificationConfirm_protocolIEs__item__id_tab
    ___MCBearerContextModificationConfirm_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MCBearerContextModificationConfirm_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MCBearerContextModificationConfirm_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___MCBearerContextModificationConfirm_protocolIEs__item__value._const_tab = ____MCBearerContextModificationConfirm_protocolIEs__item__id_tab
    ___MCBearerContextModificationConfirm_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MCBearerContextModificationConfirm_protocolIEs__item__value._const_tab_id = 'Value'
    __MCBearerContextModificationConfirm_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MCBearerContextModificationConfirm_protocolIEs__item__id),
        ('criticality', ___MCBearerContextModificationConfirm_protocolIEs__item__criticality),
        ('value', ___MCBearerContextModificationConfirm_protocolIEs__item__value),
        ])
    __MCBearerContextModificationConfirm_protocolIEs__item_._ext = None
    _MCBearerContextModificationConfirm_protocolIEs._cont = __MCBearerContextModificationConfirm_protocolIEs__item_
    _MCBearerContextModificationConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MCBearerContextModificationConfirm._cont = ASN1Dict([
        ('protocolIEs', _MCBearerContextModificationConfirm_protocolIEs),
        ])
    MCBearerContextModificationConfirm._ext = []
    
    #-----< MCBearerContextModificationConfirmIEs >-----#
    MCBearerContextModificationConfirmIEs = CLASS(name='MCBearerContextModificationConfirmIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _MCBearerContextModificationConfirmIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _MCBearerContextModificationConfirmIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _MCBearerContextModificationConfirmIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'MCBearerContextToModifyConfirm')))
    _MCBearerContextModificationConfirmIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    MCBearerContextModificationConfirmIEs._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _MCBearerContextModificationConfirmIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _MCBearerContextModificationConfirmIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 169), ('criticality', 'reject'), ('Value', _MCBearerContextModificationConfirmIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _MCBearerContextModificationConfirmIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MCBearerContextReleaseCommand >-----#
    MCBearerContextReleaseCommand = SEQ(name='MCBearerContextReleaseCommand', mode=MODE_TYPE)
    _MCBearerContextReleaseCommand_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __MCBearerContextReleaseCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___MCBearerContextReleaseCommand_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____MCBearerContextReleaseCommand_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____MCBearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _____MCBearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _____MCBearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    ____MCBearerContextReleaseCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _____MCBearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____MCBearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____MCBearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MCBearerContextReleaseCommand_protocolIEs__item__id._const_tab = ____MCBearerContextReleaseCommand_protocolIEs__item__id_tab
    ___MCBearerContextReleaseCommand_protocolIEs__item__id._const_tab_at = None
    ___MCBearerContextReleaseCommand_protocolIEs__item__id._const_tab_id = 'id'
    ___MCBearerContextReleaseCommand_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___MCBearerContextReleaseCommand_protocolIEs__item__criticality._const_tab = ____MCBearerContextReleaseCommand_protocolIEs__item__id_tab
    ___MCBearerContextReleaseCommand_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MCBearerContextReleaseCommand_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MCBearerContextReleaseCommand_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___MCBearerContextReleaseCommand_protocolIEs__item__value._const_tab = ____MCBearerContextReleaseCommand_protocolIEs__item__id_tab
    ___MCBearerContextReleaseCommand_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MCBearerContextReleaseCommand_protocolIEs__item__value._const_tab_id = 'Value'
    __MCBearerContextReleaseCommand_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MCBearerContextReleaseCommand_protocolIEs__item__id),
        ('criticality', ___MCBearerContextReleaseCommand_protocolIEs__item__criticality),
        ('value', ___MCBearerContextReleaseCommand_protocolIEs__item__value),
        ])
    __MCBearerContextReleaseCommand_protocolIEs__item_._ext = None
    _MCBearerContextReleaseCommand_protocolIEs._cont = __MCBearerContextReleaseCommand_protocolIEs__item_
    _MCBearerContextReleaseCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MCBearerContextReleaseCommand._cont = ASN1Dict([
        ('protocolIEs', _MCBearerContextReleaseCommand_protocolIEs),
        ])
    MCBearerContextReleaseCommand._ext = []
    
    #-----< MCBearerContextReleaseCommandIEs >-----#
    MCBearerContextReleaseCommandIEs = CLASS(name='MCBearerContextReleaseCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _MCBearerContextReleaseCommandIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _MCBearerContextReleaseCommandIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _MCBearerContextReleaseCommandIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    MCBearerContextReleaseCommandIEs._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _MCBearerContextReleaseCommandIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _MCBearerContextReleaseCommandIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _MCBearerContextReleaseCommandIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MCBearerContextReleaseComplete >-----#
    MCBearerContextReleaseComplete = SEQ(name='MCBearerContextReleaseComplete', mode=MODE_TYPE)
    _MCBearerContextReleaseComplete_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __MCBearerContextReleaseComplete_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___MCBearerContextReleaseComplete_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____MCBearerContextReleaseComplete_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____MCBearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _____MCBearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _____MCBearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    ____MCBearerContextReleaseComplete_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _____MCBearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____MCBearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____MCBearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MCBearerContextReleaseComplete_protocolIEs__item__id._const_tab = ____MCBearerContextReleaseComplete_protocolIEs__item__id_tab
    ___MCBearerContextReleaseComplete_protocolIEs__item__id._const_tab_at = None
    ___MCBearerContextReleaseComplete_protocolIEs__item__id._const_tab_id = 'id'
    ___MCBearerContextReleaseComplete_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___MCBearerContextReleaseComplete_protocolIEs__item__criticality._const_tab = ____MCBearerContextReleaseComplete_protocolIEs__item__id_tab
    ___MCBearerContextReleaseComplete_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MCBearerContextReleaseComplete_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MCBearerContextReleaseComplete_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___MCBearerContextReleaseComplete_protocolIEs__item__value._const_tab = ____MCBearerContextReleaseComplete_protocolIEs__item__id_tab
    ___MCBearerContextReleaseComplete_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MCBearerContextReleaseComplete_protocolIEs__item__value._const_tab_id = 'Value'
    __MCBearerContextReleaseComplete_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MCBearerContextReleaseComplete_protocolIEs__item__id),
        ('criticality', ___MCBearerContextReleaseComplete_protocolIEs__item__criticality),
        ('value', ___MCBearerContextReleaseComplete_protocolIEs__item__value),
        ])
    __MCBearerContextReleaseComplete_protocolIEs__item_._ext = None
    _MCBearerContextReleaseComplete_protocolIEs._cont = __MCBearerContextReleaseComplete_protocolIEs__item_
    _MCBearerContextReleaseComplete_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MCBearerContextReleaseComplete._cont = ASN1Dict([
        ('protocolIEs', _MCBearerContextReleaseComplete_protocolIEs),
        ])
    MCBearerContextReleaseComplete._ext = []
    
    #-----< MCBearerContextReleaseCompleteIEs >-----#
    MCBearerContextReleaseCompleteIEs = CLASS(name='MCBearerContextReleaseCompleteIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _MCBearerContextReleaseCompleteIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _MCBearerContextReleaseCompleteIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _MCBearerContextReleaseCompleteIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'CriticalityDiagnostics')))
    MCBearerContextReleaseCompleteIEs._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _MCBearerContextReleaseCompleteIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _MCBearerContextReleaseCompleteIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _MCBearerContextReleaseCompleteIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MCBearerContextReleaseRequest >-----#
    MCBearerContextReleaseRequest = SEQ(name='MCBearerContextReleaseRequest', mode=MODE_TYPE)
    _MCBearerContextReleaseRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Container')))
    __MCBearerContextReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-Containers', 'ProtocolIE-Field')))
    ___MCBearerContextReleaseRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['id']))
    ____MCBearerContextReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_E1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _____MCBearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _____MCBearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _____MCBearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    ____MCBearerContextReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _____MCBearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____MCBearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____MCBearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MCBearerContextReleaseRequest_protocolIEs__item__id._const_tab = ____MCBearerContextReleaseRequest_protocolIEs__item__id_tab
    ___MCBearerContextReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___MCBearerContextReleaseRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___MCBearerContextReleaseRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['criticality']))
    ___MCBearerContextReleaseRequest_protocolIEs__item__criticality._const_tab = ____MCBearerContextReleaseRequest_protocolIEs__item__id_tab
    ___MCBearerContextReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MCBearerContextReleaseRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MCBearerContextReleaseRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-Containers', 'E1AP-PROTOCOL-IES'), ['Value']))
    ___MCBearerContextReleaseRequest_protocolIEs__item__value._const_tab = ____MCBearerContextReleaseRequest_protocolIEs__item__id_tab
    ___MCBearerContextReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MCBearerContextReleaseRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __MCBearerContextReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MCBearerContextReleaseRequest_protocolIEs__item__id),
        ('criticality', ___MCBearerContextReleaseRequest_protocolIEs__item__criticality),
        ('value', ___MCBearerContextReleaseRequest_protocolIEs__item__value),
        ])
    __MCBearerContextReleaseRequest_protocolIEs__item_._ext = None
    _MCBearerContextReleaseRequest_protocolIEs._cont = __MCBearerContextReleaseRequest_protocolIEs__item_
    _MCBearerContextReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MCBearerContextReleaseRequest._cont = ASN1Dict([
        ('protocolIEs', _MCBearerContextReleaseRequest_protocolIEs),
        ])
    MCBearerContextReleaseRequest._ext = []
    
    #-----< MCBearerContextReleaseRequestIEs >-----#
    MCBearerContextReleaseRequestIEs = CLASS(name='MCBearerContextReleaseRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('E1AP-Containers', 'E1AP-PROTOCOL-IES')))
    _MCBearerContextReleaseRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-CP-MBS-E1AP-ID')))
    _MCBearerContextReleaseRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'GNB-CU-UP-MBS-E1AP-ID')))
    _MCBearerContextReleaseRequestIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-IEs', 'Cause')))
    MCBearerContextReleaseRequestIEs._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _MCBearerContextReleaseRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _MCBearerContextReleaseRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _MCBearerContextReleaseRequestIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    _all_ = [
        ____Reset_protocolIEs__item__id_tab,
        _____Reset_protocolIEs__item__id_tab_val_Value_0,
        _____Reset_protocolIEs__item__id_tab_val_Value_1,
        _____Reset_protocolIEs__item__id_tab_val_Value_2,
        ___Reset_protocolIEs__item__id,
        ___Reset_protocolIEs__item__criticality,
        ___Reset_protocolIEs__item__value,
        __Reset_protocolIEs__item_,
        _Reset_protocolIEs,
        Reset,
        ResetIEs,
        _ResetIEs_val_Value_0,
        _ResetIEs_val_Value_1,
        _ResetIEs_val_Value_2,
        _ResetType_e1_Interface,
        _ResetType_partOfE1_Interface,
        ___ResetType_choice_extension_id_tab,
        __ResetType_choice_extension_id,
        ___ResetType_choice_extension_criticality_tab,
        __ResetType_choice_extension_criticality,
        ___ResetType_choice_extension_value_tab,
        __ResetType_choice_extension_value,
        _ResetType_choice_extension,
        ResetType,
        ResetType_ExtIEs,
        ResetAll,
        ___UE_associatedLogicalE1_ConnectionListRes__item__id_tab,
        ____UE_associatedLogicalE1_ConnectionListRes__item__id_tab_val_Value_0,
        __UE_associatedLogicalE1_ConnectionListRes__item__id,
        __UE_associatedLogicalE1_ConnectionListRes__item__criticality,
        __UE_associatedLogicalE1_ConnectionListRes__item__value,
        _UE_associatedLogicalE1_ConnectionListRes__item_,
        UE_associatedLogicalE1_ConnectionListRes,
        UE_associatedLogicalE1_ConnectionItemRes,
        _UE_associatedLogicalE1_ConnectionItemRes_val_Value_0,
        ____ResetAcknowledge_protocolIEs__item__id_tab,
        _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        ___ResetAcknowledge_protocolIEs__item__id,
        ___ResetAcknowledge_protocolIEs__item__criticality,
        ___ResetAcknowledge_protocolIEs__item__value,
        __ResetAcknowledge_protocolIEs__item_,
        _ResetAcknowledge_protocolIEs,
        ResetAcknowledge,
        ResetAcknowledgeIEs,
        _ResetAcknowledgeIEs_val_Value_0,
        _ResetAcknowledgeIEs_val_Value_1,
        _ResetAcknowledgeIEs_val_Value_2,
        ___UE_associatedLogicalE1_ConnectionListResAck__item__id_tab,
        ____UE_associatedLogicalE1_ConnectionListResAck__item__id_tab_val_Value_0,
        __UE_associatedLogicalE1_ConnectionListResAck__item__id,
        __UE_associatedLogicalE1_ConnectionListResAck__item__criticality,
        __UE_associatedLogicalE1_ConnectionListResAck__item__value,
        _UE_associatedLogicalE1_ConnectionListResAck__item_,
        UE_associatedLogicalE1_ConnectionListResAck,
        UE_associatedLogicalE1_ConnectionItemResAck,
        _UE_associatedLogicalE1_ConnectionItemResAck_val_Value_0,
        ____ErrorIndication_protocolIEs__item__id_tab,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_5,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_6,
        ___ErrorIndication_protocolIEs__item__id,
        ___ErrorIndication_protocolIEs__item__criticality,
        ___ErrorIndication_protocolIEs__item__value,
        __ErrorIndication_protocolIEs__item_,
        _ErrorIndication_protocolIEs,
        ErrorIndication,
        ErrorIndication_IEs,
        _ErrorIndication_IEs_val_Value_0,
        _ErrorIndication_IEs_val_Value_1,
        _ErrorIndication_IEs_val_Value_2,
        _ErrorIndication_IEs_val_Value_3,
        _ErrorIndication_IEs_val_Value_4,
        _ErrorIndication_IEs_val_Value_5,
        _ErrorIndication_IEs_val_Value_6,
        ____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab,
        _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_2,
        _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_3,
        _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_4,
        _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_5,
        _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_6,
        _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_7,
        _____GNB_CU_UP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_8,
        ___GNB_CU_UP_E1SetupRequest_protocolIEs__item__id,
        ___GNB_CU_UP_E1SetupRequest_protocolIEs__item__criticality,
        ___GNB_CU_UP_E1SetupRequest_protocolIEs__item__value,
        __GNB_CU_UP_E1SetupRequest_protocolIEs__item_,
        _GNB_CU_UP_E1SetupRequest_protocolIEs,
        GNB_CU_UP_E1SetupRequest,
        GNB_CU_UP_E1SetupRequestIEs,
        _GNB_CU_UP_E1SetupRequestIEs_val_Value_0,
        _GNB_CU_UP_E1SetupRequestIEs_val_Value_1,
        _GNB_CU_UP_E1SetupRequestIEs_val_Value_2,
        _GNB_CU_UP_E1SetupRequestIEs_val_Value_3,
        _GNB_CU_UP_E1SetupRequestIEs_val_Value_4,
        _GNB_CU_UP_E1SetupRequestIEs_val_Value_5,
        _GNB_CU_UP_E1SetupRequestIEs_val_Value_6,
        _GNB_CU_UP_E1SetupRequestIEs_val_Value_7,
        _GNB_CU_UP_E1SetupRequestIEs_val_Value_8,
        _SupportedPLMNs_List__item_,
        SupportedPLMNs_List,
        _SupportedPLMNs_Item_pLMN_Identity,
        _SupportedPLMNs_Item_slice_Support_List,
        _SupportedPLMNs_Item_nR_CGI_Support_List,
        _SupportedPLMNs_Item_qoS_Parameters_Support_List,
        ____SupportedPLMNs_Item_iE_Extensions__item__id_tab,
        _____SupportedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____SupportedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____SupportedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_2,
        _____SupportedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_3,
        ___SupportedPLMNs_Item_iE_Extensions__item__id,
        ___SupportedPLMNs_Item_iE_Extensions__item__criticality,
        ___SupportedPLMNs_Item_iE_Extensions__item__extensionValue,
        __SupportedPLMNs_Item_iE_Extensions__item_,
        _SupportedPLMNs_Item_iE_Extensions,
        SupportedPLMNs_Item,
        SupportedPLMNs_ExtIEs,
        _SupportedPLMNs_ExtIEs_val_Extension_0,
        _SupportedPLMNs_ExtIEs_val_Extension_1,
        _SupportedPLMNs_ExtIEs_val_Extension_2,
        _SupportedPLMNs_ExtIEs_val_Extension_3,
        ____GNB_CU_UP_E1SetupResponse_protocolIEs__item__id_tab,
        _____GNB_CU_UP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____GNB_CU_UP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____GNB_CU_UP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____GNB_CU_UP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_3,
        _____GNB_CU_UP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_4,
        ___GNB_CU_UP_E1SetupResponse_protocolIEs__item__id,
        ___GNB_CU_UP_E1SetupResponse_protocolIEs__item__criticality,
        ___GNB_CU_UP_E1SetupResponse_protocolIEs__item__value,
        __GNB_CU_UP_E1SetupResponse_protocolIEs__item_,
        _GNB_CU_UP_E1SetupResponse_protocolIEs,
        GNB_CU_UP_E1SetupResponse,
        GNB_CU_UP_E1SetupResponseIEs,
        _GNB_CU_UP_E1SetupResponseIEs_val_Value_0,
        _GNB_CU_UP_E1SetupResponseIEs_val_Value_1,
        _GNB_CU_UP_E1SetupResponseIEs_val_Value_2,
        _GNB_CU_UP_E1SetupResponseIEs_val_Value_3,
        _GNB_CU_UP_E1SetupResponseIEs_val_Value_4,
        ____GNB_CU_UP_E1SetupFailure_protocolIEs__item__id_tab,
        _____GNB_CU_UP_E1SetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____GNB_CU_UP_E1SetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____GNB_CU_UP_E1SetupFailure_protocolIEs__item__id_tab_val_Value_2,
        _____GNB_CU_UP_E1SetupFailure_protocolIEs__item__id_tab_val_Value_3,
        ___GNB_CU_UP_E1SetupFailure_protocolIEs__item__id,
        ___GNB_CU_UP_E1SetupFailure_protocolIEs__item__criticality,
        ___GNB_CU_UP_E1SetupFailure_protocolIEs__item__value,
        __GNB_CU_UP_E1SetupFailure_protocolIEs__item_,
        _GNB_CU_UP_E1SetupFailure_protocolIEs,
        GNB_CU_UP_E1SetupFailure,
        GNB_CU_UP_E1SetupFailureIEs,
        _GNB_CU_UP_E1SetupFailureIEs_val_Value_0,
        _GNB_CU_UP_E1SetupFailureIEs_val_Value_1,
        _GNB_CU_UP_E1SetupFailureIEs_val_Value_2,
        _GNB_CU_UP_E1SetupFailureIEs_val_Value_3,
        ____GNB_CU_CP_E1SetupRequest_protocolIEs__item__id_tab,
        _____GNB_CU_CP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____GNB_CU_CP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____GNB_CU_CP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_2,
        _____GNB_CU_CP_E1SetupRequest_protocolIEs__item__id_tab_val_Value_3,
        ___GNB_CU_CP_E1SetupRequest_protocolIEs__item__id,
        ___GNB_CU_CP_E1SetupRequest_protocolIEs__item__criticality,
        ___GNB_CU_CP_E1SetupRequest_protocolIEs__item__value,
        __GNB_CU_CP_E1SetupRequest_protocolIEs__item_,
        _GNB_CU_CP_E1SetupRequest_protocolIEs,
        GNB_CU_CP_E1SetupRequest,
        GNB_CU_CP_E1SetupRequestIEs,
        _GNB_CU_CP_E1SetupRequestIEs_val_Value_0,
        _GNB_CU_CP_E1SetupRequestIEs_val_Value_1,
        _GNB_CU_CP_E1SetupRequestIEs_val_Value_2,
        _GNB_CU_CP_E1SetupRequestIEs_val_Value_3,
        ____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab,
        _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_3,
        _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_4,
        _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_5,
        _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_6,
        _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_7,
        _____GNB_CU_CP_E1SetupResponse_protocolIEs__item__id_tab_val_Value_8,
        ___GNB_CU_CP_E1SetupResponse_protocolIEs__item__id,
        ___GNB_CU_CP_E1SetupResponse_protocolIEs__item__criticality,
        ___GNB_CU_CP_E1SetupResponse_protocolIEs__item__value,
        __GNB_CU_CP_E1SetupResponse_protocolIEs__item_,
        _GNB_CU_CP_E1SetupResponse_protocolIEs,
        GNB_CU_CP_E1SetupResponse,
        GNB_CU_CP_E1SetupResponseIEs,
        _GNB_CU_CP_E1SetupResponseIEs_val_Value_0,
        _GNB_CU_CP_E1SetupResponseIEs_val_Value_1,
        _GNB_CU_CP_E1SetupResponseIEs_val_Value_2,
        _GNB_CU_CP_E1SetupResponseIEs_val_Value_3,
        _GNB_CU_CP_E1SetupResponseIEs_val_Value_4,
        _GNB_CU_CP_E1SetupResponseIEs_val_Value_5,
        _GNB_CU_CP_E1SetupResponseIEs_val_Value_6,
        _GNB_CU_CP_E1SetupResponseIEs_val_Value_7,
        _GNB_CU_CP_E1SetupResponseIEs_val_Value_8,
        ____GNB_CU_CP_E1SetupFailure_protocolIEs__item__id_tab,
        _____GNB_CU_CP_E1SetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____GNB_CU_CP_E1SetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____GNB_CU_CP_E1SetupFailure_protocolIEs__item__id_tab_val_Value_2,
        _____GNB_CU_CP_E1SetupFailure_protocolIEs__item__id_tab_val_Value_3,
        ___GNB_CU_CP_E1SetupFailure_protocolIEs__item__id,
        ___GNB_CU_CP_E1SetupFailure_protocolIEs__item__criticality,
        ___GNB_CU_CP_E1SetupFailure_protocolIEs__item__value,
        __GNB_CU_CP_E1SetupFailure_protocolIEs__item_,
        _GNB_CU_CP_E1SetupFailure_protocolIEs,
        GNB_CU_CP_E1SetupFailure,
        GNB_CU_CP_E1SetupFailureIEs,
        _GNB_CU_CP_E1SetupFailureIEs_val_Value_0,
        _GNB_CU_CP_E1SetupFailureIEs_val_Value_1,
        _GNB_CU_CP_E1SetupFailureIEs_val_Value_2,
        _GNB_CU_CP_E1SetupFailureIEs_val_Value_3,
        ____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab,
        _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3,
        _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4,
        _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5,
        _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6,
        _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_7,
        _____GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_8,
        ___GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__id,
        ___GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__criticality,
        ___GNB_CU_UP_ConfigurationUpdate_protocolIEs__item__value,
        __GNB_CU_UP_ConfigurationUpdate_protocolIEs__item_,
        _GNB_CU_UP_ConfigurationUpdate_protocolIEs,
        GNB_CU_UP_ConfigurationUpdate,
        GNB_CU_UP_ConfigurationUpdateIEs,
        _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_0,
        _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_1,
        _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_2,
        _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_3,
        _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_4,
        _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_5,
        _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_6,
        _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_7,
        _GNB_CU_UP_ConfigurationUpdateIEs_val_Value_8,
        _GNB_CU_UP_TNLA_To_Remove_List__item_,
        GNB_CU_UP_TNLA_To_Remove_List,
        ____GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab,
        _____GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        ___GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__id,
        ___GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__criticality,
        ___GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item__value,
        __GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs__item_,
        _GNB_CU_UP_ConfigurationUpdateAcknowledge_protocolIEs,
        GNB_CU_UP_ConfigurationUpdateAcknowledge,
        GNB_CU_UP_ConfigurationUpdateAcknowledgeIEs,
        _GNB_CU_UP_ConfigurationUpdateAcknowledgeIEs_val_Value_0,
        _GNB_CU_UP_ConfigurationUpdateAcknowledgeIEs_val_Value_1,
        _GNB_CU_UP_ConfigurationUpdateAcknowledgeIEs_val_Value_2,
        ____GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__id_tab,
        _____GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        _____GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3,
        ___GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__id,
        ___GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__criticality,
        ___GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item__value,
        __GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs__item_,
        _GNB_CU_UP_ConfigurationUpdateFailure_protocolIEs,
        GNB_CU_UP_ConfigurationUpdateFailure,
        GNB_CU_UP_ConfigurationUpdateFailureIEs,
        _GNB_CU_UP_ConfigurationUpdateFailureIEs_val_Value_0,
        _GNB_CU_UP_ConfigurationUpdateFailureIEs_val_Value_1,
        _GNB_CU_UP_ConfigurationUpdateFailureIEs_val_Value_2,
        _GNB_CU_UP_ConfigurationUpdateFailureIEs_val_Value_3,
        ____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab,
        _____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3,
        _____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4,
        _____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5,
        _____GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6,
        ___GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__id,
        ___GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__criticality,
        ___GNB_CU_CP_ConfigurationUpdate_protocolIEs__item__value,
        __GNB_CU_CP_ConfigurationUpdate_protocolIEs__item_,
        _GNB_CU_CP_ConfigurationUpdate_protocolIEs,
        GNB_CU_CP_ConfigurationUpdate,
        GNB_CU_CP_ConfigurationUpdateIEs,
        _GNB_CU_CP_ConfigurationUpdateIEs_val_Value_0,
        _GNB_CU_CP_ConfigurationUpdateIEs_val_Value_1,
        _GNB_CU_CP_ConfigurationUpdateIEs_val_Value_2,
        _GNB_CU_CP_ConfigurationUpdateIEs_val_Value_3,
        _GNB_CU_CP_ConfigurationUpdateIEs_val_Value_4,
        _GNB_CU_CP_ConfigurationUpdateIEs_val_Value_5,
        _GNB_CU_CP_ConfigurationUpdateIEs_val_Value_6,
        _GNB_CU_CP_TNLA_To_Add_List__item_,
        GNB_CU_CP_TNLA_To_Add_List,
        _GNB_CU_CP_TNLA_To_Remove_List__item_,
        GNB_CU_CP_TNLA_To_Remove_List,
        _GNB_CU_CP_TNLA_To_Update_List__item_,
        GNB_CU_CP_TNLA_To_Update_List,
        ____GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab,
        _____GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        ___GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__id,
        ___GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__criticality,
        ___GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item__value,
        __GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs__item_,
        _GNB_CU_CP_ConfigurationUpdateAcknowledge_protocolIEs,
        GNB_CU_CP_ConfigurationUpdateAcknowledge,
        GNB_CU_CP_ConfigurationUpdateAcknowledgeIEs,
        _GNB_CU_CP_ConfigurationUpdateAcknowledgeIEs_val_Value_0,
        _GNB_CU_CP_ConfigurationUpdateAcknowledgeIEs_val_Value_1,
        _GNB_CU_CP_ConfigurationUpdateAcknowledgeIEs_val_Value_2,
        _GNB_CU_CP_ConfigurationUpdateAcknowledgeIEs_val_Value_3,
        _GNB_CU_CP_ConfigurationUpdateAcknowledgeIEs_val_Value_4,
        _GNB_CU_CP_TNLA_Setup_List__item_,
        GNB_CU_CP_TNLA_Setup_List,
        _GNB_CU_CP_TNLA_Failed_To_Setup_List__item_,
        GNB_CU_CP_TNLA_Failed_To_Setup_List,
        ____GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__id_tab,
        _____GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        _____GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3,
        ___GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__id,
        ___GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__criticality,
        ___GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item__value,
        __GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs__item_,
        _GNB_CU_CP_ConfigurationUpdateFailure_protocolIEs,
        GNB_CU_CP_ConfigurationUpdateFailure,
        GNB_CU_CP_ConfigurationUpdateFailureIEs,
        _GNB_CU_CP_ConfigurationUpdateFailureIEs_val_Value_0,
        _GNB_CU_CP_ConfigurationUpdateFailureIEs_val_Value_1,
        _GNB_CU_CP_ConfigurationUpdateFailureIEs_val_Value_2,
        _GNB_CU_CP_ConfigurationUpdateFailureIEs_val_Value_3,
        ____E1ReleaseRequest_protocolIEs__item__id_tab,
        _____E1ReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        _____E1ReleaseRequest_protocolIEs__item__id_tab_val_Value_1,
        ___E1ReleaseRequest_protocolIEs__item__id,
        ___E1ReleaseRequest_protocolIEs__item__criticality,
        ___E1ReleaseRequest_protocolIEs__item__value,
        __E1ReleaseRequest_protocolIEs__item_,
        _E1ReleaseRequest_protocolIEs,
        E1ReleaseRequest,
        E1ReleaseRequestIEs,
        _E1ReleaseRequestIEs_val_Value_0,
        _E1ReleaseRequestIEs_val_Value_1,
        ____E1ReleaseResponse_protocolIEs__item__id_tab,
        _____E1ReleaseResponse_protocolIEs__item__id_tab_val_Value_0,
        _____E1ReleaseResponse_protocolIEs__item__id_tab_val_Value_1,
        ___E1ReleaseResponse_protocolIEs__item__id,
        ___E1ReleaseResponse_protocolIEs__item__criticality,
        ___E1ReleaseResponse_protocolIEs__item__value,
        __E1ReleaseResponse_protocolIEs__item_,
        _E1ReleaseResponse_protocolIEs,
        E1ReleaseResponse,
        E1ReleaseResponseIEs,
        _E1ReleaseResponseIEs_val_Value_0,
        _E1ReleaseResponseIEs_val_Value_1,
        ____BearerContextSetupRequest_protocolIEs__item__id_tab,
        _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_2,
        _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_3,
        _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_4,
        _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_5,
        _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_6,
        _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_7,
        _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_8,
        _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_9,
        _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_10,
        _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_11,
        _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_12,
        _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_13,
        _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_14,
        _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_15,
        _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_16,
        _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_17,
        _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_18,
        _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_19,
        _____BearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_20,
        ___BearerContextSetupRequest_protocolIEs__item__id,
        ___BearerContextSetupRequest_protocolIEs__item__criticality,
        ___BearerContextSetupRequest_protocolIEs__item__value,
        __BearerContextSetupRequest_protocolIEs__item_,
        _BearerContextSetupRequest_protocolIEs,
        BearerContextSetupRequest,
        BearerContextSetupRequestIEs,
        _BearerContextSetupRequestIEs_val_Value_0,
        _BearerContextSetupRequestIEs_val_Value_1,
        _BearerContextSetupRequestIEs_val_Value_2,
        _BearerContextSetupRequestIEs_val_Value_3,
        _BearerContextSetupRequestIEs_val_Value_4,
        _BearerContextSetupRequestIEs_val_Value_5,
        _BearerContextSetupRequestIEs_val_Value_6,
        _BearerContextSetupRequestIEs_val_Value_7,
        _BearerContextSetupRequestIEs_val_Value_8,
        _BearerContextSetupRequestIEs_val_Value_9,
        _BearerContextSetupRequestIEs_val_Value_10,
        _BearerContextSetupRequestIEs_val_Value_11,
        _BearerContextSetupRequestIEs_val_Value_12,
        _BearerContextSetupRequestIEs_val_Value_13,
        _BearerContextSetupRequestIEs_val_Value_14,
        _BearerContextSetupRequestIEs_val_Value_15,
        _BearerContextSetupRequestIEs_val_Value_16,
        _BearerContextSetupRequestIEs_val_Value_17,
        _BearerContextSetupRequestIEs_val_Value_18,
        _BearerContextSetupRequestIEs_val_Value_19,
        _BearerContextSetupRequestIEs_val_Value_20,
        ____System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__id_tab,
        _____System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__id_tab_val_Value_0,
        _____System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__id_tab_val_Value_1,
        _____System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__id_tab_val_Value_2,
        ___System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__id,
        ___System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__criticality,
        ___System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item__value,
        __System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest__item_,
        _System_BearerContextSetupRequest_e_UTRAN_BearerContextSetupRequest,
        ____System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__id_tab,
        _____System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__id_tab_val_Value_0,
        ___System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__id,
        ___System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__criticality,
        ___System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item__value,
        __System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest__item_,
        _System_BearerContextSetupRequest_nG_RAN_BearerContextSetupRequest,
        ___System_BearerContextSetupRequest_choice_extension_id_tab,
        __System_BearerContextSetupRequest_choice_extension_id,
        ___System_BearerContextSetupRequest_choice_extension_criticality_tab,
        __System_BearerContextSetupRequest_choice_extension_criticality,
        ___System_BearerContextSetupRequest_choice_extension_value_tab,
        __System_BearerContextSetupRequest_choice_extension_value,
        _System_BearerContextSetupRequest_choice_extension,
        System_BearerContextSetupRequest,
        System_BearerContextSetupRequest_ExtIEs,
        EUTRAN_BearerContextSetupRequest,
        _EUTRAN_BearerContextSetupRequest_val_Value_0,
        _EUTRAN_BearerContextSetupRequest_val_Value_1,
        _EUTRAN_BearerContextSetupRequest_val_Value_2,
        NG_RAN_BearerContextSetupRequest,
        _NG_RAN_BearerContextSetupRequest_val_Value_0,
        ____BearerContextSetupResponse_protocolIEs__item__id_tab,
        _____BearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____BearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____BearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____BearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_3,
        ___BearerContextSetupResponse_protocolIEs__item__id,
        ___BearerContextSetupResponse_protocolIEs__item__criticality,
        ___BearerContextSetupResponse_protocolIEs__item__value,
        __BearerContextSetupResponse_protocolIEs__item_,
        _BearerContextSetupResponse_protocolIEs,
        BearerContextSetupResponse,
        BearerContextSetupResponseIEs,
        _BearerContextSetupResponseIEs_val_Value_0,
        _BearerContextSetupResponseIEs_val_Value_1,
        _BearerContextSetupResponseIEs_val_Value_2,
        _BearerContextSetupResponseIEs_val_Value_3,
        ____System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__id_tab,
        _____System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__id_tab_val_Value_0,
        _____System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__id_tab_val_Value_1,
        ___System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__id,
        ___System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__criticality,
        ___System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item__value,
        __System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse__item_,
        _System_BearerContextSetupResponse_e_UTRAN_BearerContextSetupResponse,
        ____System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__id_tab,
        _____System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__id_tab_val_Value_0,
        _____System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__id_tab_val_Value_1,
        ___System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__id,
        ___System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__criticality,
        ___System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item__value,
        __System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse__item_,
        _System_BearerContextSetupResponse_nG_RAN_BearerContextSetupResponse,
        ___System_BearerContextSetupResponse_choice_extension_id_tab,
        __System_BearerContextSetupResponse_choice_extension_id,
        ___System_BearerContextSetupResponse_choice_extension_criticality_tab,
        __System_BearerContextSetupResponse_choice_extension_criticality,
        ___System_BearerContextSetupResponse_choice_extension_value_tab,
        __System_BearerContextSetupResponse_choice_extension_value,
        _System_BearerContextSetupResponse_choice_extension,
        System_BearerContextSetupResponse,
        System_BearerContextSetupResponse_ExtIEs,
        EUTRAN_BearerContextSetupResponse,
        _EUTRAN_BearerContextSetupResponse_val_Value_0,
        _EUTRAN_BearerContextSetupResponse_val_Value_1,
        NG_RAN_BearerContextSetupResponse,
        _NG_RAN_BearerContextSetupResponse_val_Value_0,
        _NG_RAN_BearerContextSetupResponse_val_Value_1,
        ____BearerContextSetupFailure_protocolIEs__item__id_tab,
        _____BearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____BearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____BearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_2,
        _____BearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_3,
        ___BearerContextSetupFailure_protocolIEs__item__id,
        ___BearerContextSetupFailure_protocolIEs__item__criticality,
        ___BearerContextSetupFailure_protocolIEs__item__value,
        __BearerContextSetupFailure_protocolIEs__item_,
        _BearerContextSetupFailure_protocolIEs,
        BearerContextSetupFailure,
        BearerContextSetupFailureIEs,
        _BearerContextSetupFailureIEs_val_Value_0,
        _BearerContextSetupFailureIEs_val_Value_1,
        _BearerContextSetupFailureIEs_val_Value_2,
        _BearerContextSetupFailureIEs_val_Value_3,
        ____BearerContextModificationRequest_protocolIEs__item__id_tab,
        _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_5,
        _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_6,
        _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_7,
        _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_8,
        _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_9,
        _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_10,
        _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_11,
        _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_12,
        _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_13,
        _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_14,
        _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_15,
        _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_16,
        _____BearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_17,
        ___BearerContextModificationRequest_protocolIEs__item__id,
        ___BearerContextModificationRequest_protocolIEs__item__criticality,
        ___BearerContextModificationRequest_protocolIEs__item__value,
        __BearerContextModificationRequest_protocolIEs__item_,
        _BearerContextModificationRequest_protocolIEs,
        BearerContextModificationRequest,
        BearerContextModificationRequestIEs,
        _BearerContextModificationRequestIEs_val_Value_0,
        _BearerContextModificationRequestIEs_val_Value_1,
        _BearerContextModificationRequestIEs_val_Value_2,
        _BearerContextModificationRequestIEs_val_Value_3,
        _BearerContextModificationRequestIEs_val_Value_4,
        _BearerContextModificationRequestIEs_val_Value_5,
        _BearerContextModificationRequestIEs_val_Value_6,
        _BearerContextModificationRequestIEs_val_Value_7,
        _BearerContextModificationRequestIEs_val_Value_8,
        _BearerContextModificationRequestIEs_val_Value_9,
        _BearerContextModificationRequestIEs_val_Value_10,
        _BearerContextModificationRequestIEs_val_Value_11,
        _BearerContextModificationRequestIEs_val_Value_12,
        _BearerContextModificationRequestIEs_val_Value_13,
        _BearerContextModificationRequestIEs_val_Value_14,
        _BearerContextModificationRequestIEs_val_Value_15,
        _BearerContextModificationRequestIEs_val_Value_16,
        _BearerContextModificationRequestIEs_val_Value_17,
        ____System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id_tab,
        _____System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id_tab_val_Value_0,
        _____System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id_tab_val_Value_1,
        _____System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id_tab_val_Value_2,
        _____System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id_tab_val_Value_3,
        _____System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id_tab_val_Value_4,
        ___System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__id,
        ___System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__criticality,
        ___System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item__value,
        __System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest__item_,
        _System_BearerContextModificationRequest_e_UTRAN_BearerContextModificationRequest,
        ____System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__id_tab,
        _____System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__id_tab_val_Value_0,
        _____System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__id_tab_val_Value_1,
        _____System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__id_tab_val_Value_2,
        ___System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__id,
        ___System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__criticality,
        ___System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item__value,
        __System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest__item_,
        _System_BearerContextModificationRequest_nG_RAN_BearerContextModificationRequest,
        ___System_BearerContextModificationRequest_choice_extension_id_tab,
        __System_BearerContextModificationRequest_choice_extension_id,
        ___System_BearerContextModificationRequest_choice_extension_criticality_tab,
        __System_BearerContextModificationRequest_choice_extension_criticality,
        ___System_BearerContextModificationRequest_choice_extension_value_tab,
        __System_BearerContextModificationRequest_choice_extension_value,
        _System_BearerContextModificationRequest_choice_extension,
        System_BearerContextModificationRequest,
        System_BearerContextModificationRequest_ExtIEs,
        EUTRAN_BearerContextModificationRequest,
        _EUTRAN_BearerContextModificationRequest_val_Value_0,
        _EUTRAN_BearerContextModificationRequest_val_Value_1,
        _EUTRAN_BearerContextModificationRequest_val_Value_2,
        _EUTRAN_BearerContextModificationRequest_val_Value_3,
        _EUTRAN_BearerContextModificationRequest_val_Value_4,
        NG_RAN_BearerContextModificationRequest,
        _NG_RAN_BearerContextModificationRequest_val_Value_0,
        _NG_RAN_BearerContextModificationRequest_val_Value_1,
        _NG_RAN_BearerContextModificationRequest_val_Value_2,
        ____BearerContextModificationResponse_protocolIEs__item__id_tab,
        _____BearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____BearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____BearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____BearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_3,
        ___BearerContextModificationResponse_protocolIEs__item__id,
        ___BearerContextModificationResponse_protocolIEs__item__criticality,
        ___BearerContextModificationResponse_protocolIEs__item__value,
        __BearerContextModificationResponse_protocolIEs__item_,
        _BearerContextModificationResponse_protocolIEs,
        BearerContextModificationResponse,
        BearerContextModificationResponseIEs,
        _BearerContextModificationResponseIEs_val_Value_0,
        _BearerContextModificationResponseIEs_val_Value_1,
        _BearerContextModificationResponseIEs_val_Value_2,
        _BearerContextModificationResponseIEs_val_Value_3,
        ____System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id_tab,
        _____System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id_tab_val_Value_0,
        _____System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id_tab_val_Value_1,
        _____System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id_tab_val_Value_2,
        _____System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id_tab_val_Value_3,
        _____System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id_tab_val_Value_4,
        ___System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__id,
        ___System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__criticality,
        ___System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item__value,
        __System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse__item_,
        _System_BearerContextModificationResponse_e_UTRAN_BearerContextModificationResponse,
        ____System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id_tab,
        _____System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id_tab_val_Value_0,
        _____System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id_tab_val_Value_1,
        _____System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id_tab_val_Value_2,
        _____System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id_tab_val_Value_3,
        _____System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id_tab_val_Value_4,
        ___System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__id,
        ___System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__criticality,
        ___System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item__value,
        __System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse__item_,
        _System_BearerContextModificationResponse_nG_RAN_BearerContextModificationResponse,
        ___System_BearerContextModificationResponse_choice_extension_id_tab,
        __System_BearerContextModificationResponse_choice_extension_id,
        ___System_BearerContextModificationResponse_choice_extension_criticality_tab,
        __System_BearerContextModificationResponse_choice_extension_criticality,
        ___System_BearerContextModificationResponse_choice_extension_value_tab,
        __System_BearerContextModificationResponse_choice_extension_value,
        _System_BearerContextModificationResponse_choice_extension,
        System_BearerContextModificationResponse,
        System_BearerContextModificationResponse_ExtIEs,
        EUTRAN_BearerContextModificationResponse,
        _EUTRAN_BearerContextModificationResponse_val_Value_0,
        _EUTRAN_BearerContextModificationResponse_val_Value_1,
        _EUTRAN_BearerContextModificationResponse_val_Value_2,
        _EUTRAN_BearerContextModificationResponse_val_Value_3,
        _EUTRAN_BearerContextModificationResponse_val_Value_4,
        NG_RAN_BearerContextModificationResponse,
        _NG_RAN_BearerContextModificationResponse_val_Value_0,
        _NG_RAN_BearerContextModificationResponse_val_Value_1,
        _NG_RAN_BearerContextModificationResponse_val_Value_2,
        _NG_RAN_BearerContextModificationResponse_val_Value_3,
        _NG_RAN_BearerContextModificationResponse_val_Value_4,
        ____BearerContextModificationFailure_protocolIEs__item__id_tab,
        _____BearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____BearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____BearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____BearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_3,
        ___BearerContextModificationFailure_protocolIEs__item__id,
        ___BearerContextModificationFailure_protocolIEs__item__criticality,
        ___BearerContextModificationFailure_protocolIEs__item__value,
        __BearerContextModificationFailure_protocolIEs__item_,
        _BearerContextModificationFailure_protocolIEs,
        BearerContextModificationFailure,
        BearerContextModificationFailureIEs,
        _BearerContextModificationFailureIEs_val_Value_0,
        _BearerContextModificationFailureIEs_val_Value_1,
        _BearerContextModificationFailureIEs_val_Value_2,
        _BearerContextModificationFailureIEs_val_Value_3,
        ____BearerContextModificationRequired_protocolIEs__item__id_tab,
        _____BearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_0,
        _____BearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_1,
        _____BearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_2,
        ___BearerContextModificationRequired_protocolIEs__item__id,
        ___BearerContextModificationRequired_protocolIEs__item__criticality,
        ___BearerContextModificationRequired_protocolIEs__item__value,
        __BearerContextModificationRequired_protocolIEs__item_,
        _BearerContextModificationRequired_protocolIEs,
        BearerContextModificationRequired,
        BearerContextModificationRequiredIEs,
        _BearerContextModificationRequiredIEs_val_Value_0,
        _BearerContextModificationRequiredIEs_val_Value_1,
        _BearerContextModificationRequiredIEs_val_Value_2,
        ____System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__id_tab,
        _____System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__id_tab_val_Value_0,
        _____System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__id_tab_val_Value_1,
        ___System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__id,
        ___System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__criticality,
        ___System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item__value,
        __System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired__item_,
        _System_BearerContextModificationRequired_e_UTRAN_BearerContextModificationRequired,
        ____System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__id_tab,
        _____System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__id_tab_val_Value_0,
        _____System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__id_tab_val_Value_1,
        ___System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__id,
        ___System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__criticality,
        ___System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item__value,
        __System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired__item_,
        _System_BearerContextModificationRequired_nG_RAN_BearerContextModificationRequired,
        ___System_BearerContextModificationRequired_choice_extension_id_tab,
        __System_BearerContextModificationRequired_choice_extension_id,
        ___System_BearerContextModificationRequired_choice_extension_criticality_tab,
        __System_BearerContextModificationRequired_choice_extension_criticality,
        ___System_BearerContextModificationRequired_choice_extension_value_tab,
        __System_BearerContextModificationRequired_choice_extension_value,
        _System_BearerContextModificationRequired_choice_extension,
        System_BearerContextModificationRequired,
        System_BearerContextModificationRequired_ExtIEs,
        EUTRAN_BearerContextModificationRequired,
        _EUTRAN_BearerContextModificationRequired_val_Value_0,
        _EUTRAN_BearerContextModificationRequired_val_Value_1,
        NG_RAN_BearerContextModificationRequired,
        _NG_RAN_BearerContextModificationRequired_val_Value_0,
        _NG_RAN_BearerContextModificationRequired_val_Value_1,
        ____BearerContextModificationConfirm_protocolIEs__item__id_tab,
        _____BearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_0,
        _____BearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_1,
        _____BearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_2,
        _____BearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_3,
        ___BearerContextModificationConfirm_protocolIEs__item__id,
        ___BearerContextModificationConfirm_protocolIEs__item__criticality,
        ___BearerContextModificationConfirm_protocolIEs__item__value,
        __BearerContextModificationConfirm_protocolIEs__item_,
        _BearerContextModificationConfirm_protocolIEs,
        BearerContextModificationConfirm,
        BearerContextModificationConfirmIEs,
        _BearerContextModificationConfirmIEs_val_Value_0,
        _BearerContextModificationConfirmIEs_val_Value_1,
        _BearerContextModificationConfirmIEs_val_Value_2,
        _BearerContextModificationConfirmIEs_val_Value_3,
        ____System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__id_tab,
        _____System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__id_tab_val_Value_0,
        ___System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__id,
        ___System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__criticality,
        ___System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item__value,
        __System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm__item_,
        _System_BearerContextModificationConfirm_e_UTRAN_BearerContextModificationConfirm,
        ____System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__id_tab,
        _____System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__id_tab_val_Value_0,
        ___System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__id,
        ___System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__criticality,
        ___System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item__value,
        __System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm__item_,
        _System_BearerContextModificationConfirm_nG_RAN_BearerContextModificationConfirm,
        ___System_BearerContextModificationConfirm_choice_extension_id_tab,
        __System_BearerContextModificationConfirm_choice_extension_id,
        ___System_BearerContextModificationConfirm_choice_extension_criticality_tab,
        __System_BearerContextModificationConfirm_choice_extension_criticality,
        ___System_BearerContextModificationConfirm_choice_extension_value_tab,
        __System_BearerContextModificationConfirm_choice_extension_value,
        _System_BearerContextModificationConfirm_choice_extension,
        System_BearerContextModificationConfirm,
        System_BearerContextModificationConfirm_ExtIEs,
        EUTRAN_BearerContextModificationConfirm,
        _EUTRAN_BearerContextModificationConfirm_val_Value_0,
        NG_RAN_BearerContextModificationConfirm,
        _NG_RAN_BearerContextModificationConfirm_val_Value_0,
        ____BearerContextReleaseCommand_protocolIEs__item__id_tab,
        _____BearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0,
        _____BearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1,
        _____BearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_2,
        ___BearerContextReleaseCommand_protocolIEs__item__id,
        ___BearerContextReleaseCommand_protocolIEs__item__criticality,
        ___BearerContextReleaseCommand_protocolIEs__item__value,
        __BearerContextReleaseCommand_protocolIEs__item_,
        _BearerContextReleaseCommand_protocolIEs,
        BearerContextReleaseCommand,
        BearerContextReleaseCommandIEs,
        _BearerContextReleaseCommandIEs_val_Value_0,
        _BearerContextReleaseCommandIEs_val_Value_1,
        _BearerContextReleaseCommandIEs_val_Value_2,
        ____BearerContextReleaseComplete_protocolIEs__item__id_tab,
        _____BearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0,
        _____BearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1,
        _____BearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2,
        _____BearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_3,
        ___BearerContextReleaseComplete_protocolIEs__item__id,
        ___BearerContextReleaseComplete_protocolIEs__item__criticality,
        ___BearerContextReleaseComplete_protocolIEs__item__value,
        __BearerContextReleaseComplete_protocolIEs__item_,
        _BearerContextReleaseComplete_protocolIEs,
        BearerContextReleaseComplete,
        BearerContextReleaseCompleteIEs,
        _BearerContextReleaseCompleteIEs_val_Value_0,
        _BearerContextReleaseCompleteIEs_val_Value_1,
        _BearerContextReleaseCompleteIEs_val_Value_2,
        _BearerContextReleaseCompleteIEs_val_Value_3,
        ____BearerContextReleaseRequest_protocolIEs__item__id_tab,
        _____BearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        _____BearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1,
        _____BearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2,
        _____BearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_3,
        ___BearerContextReleaseRequest_protocolIEs__item__id,
        ___BearerContextReleaseRequest_protocolIEs__item__criticality,
        ___BearerContextReleaseRequest_protocolIEs__item__value,
        __BearerContextReleaseRequest_protocolIEs__item_,
        _BearerContextReleaseRequest_protocolIEs,
        BearerContextReleaseRequest,
        BearerContextReleaseRequestIEs,
        _BearerContextReleaseRequestIEs_val_Value_0,
        _BearerContextReleaseRequestIEs_val_Value_1,
        _BearerContextReleaseRequestIEs_val_Value_2,
        _BearerContextReleaseRequestIEs_val_Value_3,
        _DRB_Status_List__item_,
        DRB_Status_List,
        ____BearerContextInactivityNotification_protocolIEs__item__id_tab,
        _____BearerContextInactivityNotification_protocolIEs__item__id_tab_val_Value_0,
        _____BearerContextInactivityNotification_protocolIEs__item__id_tab_val_Value_1,
        _____BearerContextInactivityNotification_protocolIEs__item__id_tab_val_Value_2,
        ___BearerContextInactivityNotification_protocolIEs__item__id,
        ___BearerContextInactivityNotification_protocolIEs__item__criticality,
        ___BearerContextInactivityNotification_protocolIEs__item__value,
        __BearerContextInactivityNotification_protocolIEs__item_,
        _BearerContextInactivityNotification_protocolIEs,
        BearerContextInactivityNotification,
        BearerContextInactivityNotificationIEs,
        _BearerContextInactivityNotificationIEs_val_Value_0,
        _BearerContextInactivityNotificationIEs_val_Value_1,
        _BearerContextInactivityNotificationIEs_val_Value_2,
        ____DLDataNotification_protocolIEs__item__id_tab,
        _____DLDataNotification_protocolIEs__item__id_tab_val_Value_0,
        _____DLDataNotification_protocolIEs__item__id_tab_val_Value_1,
        _____DLDataNotification_protocolIEs__item__id_tab_val_Value_2,
        _____DLDataNotification_protocolIEs__item__id_tab_val_Value_3,
        ___DLDataNotification_protocolIEs__item__id,
        ___DLDataNotification_protocolIEs__item__criticality,
        ___DLDataNotification_protocolIEs__item__value,
        __DLDataNotification_protocolIEs__item_,
        _DLDataNotification_protocolIEs,
        DLDataNotification,
        DLDataNotificationIEs,
        _DLDataNotificationIEs_val_Value_0,
        _DLDataNotificationIEs_val_Value_1,
        _DLDataNotificationIEs_val_Value_2,
        _DLDataNotificationIEs_val_Value_3,
        ____ULDataNotification_protocolIEs__item__id_tab,
        _____ULDataNotification_protocolIEs__item__id_tab_val_Value_0,
        _____ULDataNotification_protocolIEs__item__id_tab_val_Value_1,
        _____ULDataNotification_protocolIEs__item__id_tab_val_Value_2,
        ___ULDataNotification_protocolIEs__item__id,
        ___ULDataNotification_protocolIEs__item__criticality,
        ___ULDataNotification_protocolIEs__item__value,
        __ULDataNotification_protocolIEs__item_,
        _ULDataNotification_protocolIEs,
        ULDataNotification,
        ULDataNotificationIEs,
        _ULDataNotificationIEs_val_Value_0,
        _ULDataNotificationIEs_val_Value_1,
        _ULDataNotificationIEs_val_Value_2,
        ____DataUsageReport_protocolIEs__item__id_tab,
        _____DataUsageReport_protocolIEs__item__id_tab_val_Value_0,
        _____DataUsageReport_protocolIEs__item__id_tab_val_Value_1,
        _____DataUsageReport_protocolIEs__item__id_tab_val_Value_2,
        ___DataUsageReport_protocolIEs__item__id,
        ___DataUsageReport_protocolIEs__item__criticality,
        ___DataUsageReport_protocolIEs__item__value,
        __DataUsageReport_protocolIEs__item_,
        _DataUsageReport_protocolIEs,
        DataUsageReport,
        DataUsageReportIEs,
        _DataUsageReportIEs_val_Value_0,
        _DataUsageReportIEs_val_Value_1,
        _DataUsageReportIEs_val_Value_2,
        ____GNB_CU_UP_CounterCheckRequest_protocolIEs__item__id_tab,
        _____GNB_CU_UP_CounterCheckRequest_protocolIEs__item__id_tab_val_Value_0,
        _____GNB_CU_UP_CounterCheckRequest_protocolIEs__item__id_tab_val_Value_1,
        _____GNB_CU_UP_CounterCheckRequest_protocolIEs__item__id_tab_val_Value_2,
        ___GNB_CU_UP_CounterCheckRequest_protocolIEs__item__id,
        ___GNB_CU_UP_CounterCheckRequest_protocolIEs__item__criticality,
        ___GNB_CU_UP_CounterCheckRequest_protocolIEs__item__value,
        __GNB_CU_UP_CounterCheckRequest_protocolIEs__item_,
        _GNB_CU_UP_CounterCheckRequest_protocolIEs,
        GNB_CU_UP_CounterCheckRequest,
        GNB_CU_UP_CounterCheckRequestIEs,
        _GNB_CU_UP_CounterCheckRequestIEs_val_Value_0,
        _GNB_CU_UP_CounterCheckRequestIEs_val_Value_1,
        _GNB_CU_UP_CounterCheckRequestIEs_val_Value_2,
        ____System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__id_tab,
        _____System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__id_tab_val_Value_0,
        ___System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__id,
        ___System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__criticality,
        ___System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item__value,
        __System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest__item_,
        _System_GNB_CU_UP_CounterCheckRequest_e_UTRAN_GNB_CU_UP_CounterCheckRequest,
        ____System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__id_tab,
        _____System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__id_tab_val_Value_0,
        ___System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__id,
        ___System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__criticality,
        ___System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item__value,
        __System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest__item_,
        _System_GNB_CU_UP_CounterCheckRequest_nG_RAN_GNB_CU_UP_CounterCheckRequest,
        ___System_GNB_CU_UP_CounterCheckRequest_choice_extension_id_tab,
        __System_GNB_CU_UP_CounterCheckRequest_choice_extension_id,
        ___System_GNB_CU_UP_CounterCheckRequest_choice_extension_criticality_tab,
        __System_GNB_CU_UP_CounterCheckRequest_choice_extension_criticality,
        ___System_GNB_CU_UP_CounterCheckRequest_choice_extension_value_tab,
        __System_GNB_CU_UP_CounterCheckRequest_choice_extension_value,
        _System_GNB_CU_UP_CounterCheckRequest_choice_extension,
        System_GNB_CU_UP_CounterCheckRequest,
        System_GNB_CU_UP_CounterCheckRequest_ExtIEs,
        EUTRAN_GNB_CU_UP_CounterCheckRequest,
        _EUTRAN_GNB_CU_UP_CounterCheckRequest_val_Value_0,
        NG_RAN_GNB_CU_UP_CounterCheckRequest,
        _NG_RAN_GNB_CU_UP_CounterCheckRequest_val_Value_0,
        ____GNB_CU_UP_StatusIndication_protocolIEs__item__id_tab,
        _____GNB_CU_UP_StatusIndication_protocolIEs__item__id_tab_val_Value_0,
        _____GNB_CU_UP_StatusIndication_protocolIEs__item__id_tab_val_Value_1,
        ___GNB_CU_UP_StatusIndication_protocolIEs__item__id,
        ___GNB_CU_UP_StatusIndication_protocolIEs__item__criticality,
        ___GNB_CU_UP_StatusIndication_protocolIEs__item__value,
        __GNB_CU_UP_StatusIndication_protocolIEs__item_,
        _GNB_CU_UP_StatusIndication_protocolIEs,
        GNB_CU_UP_StatusIndication,
        GNB_CU_UP_StatusIndicationIEs,
        _GNB_CU_UP_StatusIndicationIEs_val_Value_0,
        _GNB_CU_UP_StatusIndicationIEs_val_Value_1,
        ____GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__id_tab,
        _____GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__id_tab_val_Value_0,
        _____GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__id_tab_val_Value_1,
        _____GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__id_tab_val_Value_2,
        ___GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__id,
        ___GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__criticality,
        ___GNB_CU_CPMeasurementResultsInformation_protocolIEs__item__value,
        __GNB_CU_CPMeasurementResultsInformation_protocolIEs__item_,
        _GNB_CU_CPMeasurementResultsInformation_protocolIEs,
        GNB_CU_CPMeasurementResultsInformation,
        GNB_CU_CPMeasurementResultsInformationIEs,
        _GNB_CU_CPMeasurementResultsInformationIEs_val_Value_0,
        _GNB_CU_CPMeasurementResultsInformationIEs_val_Value_1,
        _GNB_CU_CPMeasurementResultsInformationIEs_val_Value_2,
        ____MRDC_DataUsageReport_protocolIEs__item__id_tab,
        _____MRDC_DataUsageReport_protocolIEs__item__id_tab_val_Value_0,
        _____MRDC_DataUsageReport_protocolIEs__item__id_tab_val_Value_1,
        _____MRDC_DataUsageReport_protocolIEs__item__id_tab_val_Value_2,
        ___MRDC_DataUsageReport_protocolIEs__item__id,
        ___MRDC_DataUsageReport_protocolIEs__item__criticality,
        ___MRDC_DataUsageReport_protocolIEs__item__value,
        __MRDC_DataUsageReport_protocolIEs__item_,
        _MRDC_DataUsageReport_protocolIEs,
        MRDC_DataUsageReport,
        MRDC_DataUsageReportIEs,
        _MRDC_DataUsageReportIEs_val_Value_0,
        _MRDC_DataUsageReportIEs_val_Value_1,
        _MRDC_DataUsageReportIEs_val_Value_2,
        ____TraceStart_protocolIEs__item__id_tab,
        _____TraceStart_protocolIEs__item__id_tab_val_Value_0,
        _____TraceStart_protocolIEs__item__id_tab_val_Value_1,
        _____TraceStart_protocolIEs__item__id_tab_val_Value_2,
        ___TraceStart_protocolIEs__item__id,
        ___TraceStart_protocolIEs__item__criticality,
        ___TraceStart_protocolIEs__item__value,
        __TraceStart_protocolIEs__item_,
        _TraceStart_protocolIEs,
        TraceStart,
        TraceStartIEs,
        _TraceStartIEs_val_Value_0,
        _TraceStartIEs_val_Value_1,
        _TraceStartIEs_val_Value_2,
        ____DeactivateTrace_protocolIEs__item__id_tab,
        _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_0,
        _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_1,
        _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_2,
        ___DeactivateTrace_protocolIEs__item__id,
        ___DeactivateTrace_protocolIEs__item__criticality,
        ___DeactivateTrace_protocolIEs__item__value,
        __DeactivateTrace_protocolIEs__item_,
        _DeactivateTrace_protocolIEs,
        DeactivateTrace,
        DeactivateTraceIEs,
        _DeactivateTraceIEs_val_Value_0,
        _DeactivateTraceIEs_val_Value_1,
        _DeactivateTraceIEs_val_Value_2,
        ____CellTrafficTrace_protocolIEs__item__id_tab,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_0,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_1,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_2,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_3,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_4,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_5,
        ___CellTrafficTrace_protocolIEs__item__id,
        ___CellTrafficTrace_protocolIEs__item__criticality,
        ___CellTrafficTrace_protocolIEs__item__value,
        __CellTrafficTrace_protocolIEs__item_,
        _CellTrafficTrace_protocolIEs,
        CellTrafficTrace,
        CellTrafficTraceIEs,
        _CellTrafficTraceIEs_val_Value_0,
        _CellTrafficTraceIEs_val_Value_1,
        _CellTrafficTraceIEs_val_Value_2,
        _CellTrafficTraceIEs_val_Value_3,
        _CellTrafficTraceIEs_val_Value_4,
        _CellTrafficTraceIEs_val_Value_5,
        ____PrivateMessage_privateIEs__item__id_tab,
        ___PrivateMessage_privateIEs__item__id,
        ____PrivateMessage_privateIEs__item__criticality_tab,
        ___PrivateMessage_privateIEs__item__criticality,
        ____PrivateMessage_privateIEs__item__value_tab,
        ___PrivateMessage_privateIEs__item__value,
        __PrivateMessage_privateIEs__item_,
        _PrivateMessage_privateIEs,
        PrivateMessage,
        PrivateMessage_IEs,
        ____ResourceStatusRequest_protocolIEs__item__id_tab,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_0,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_1,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_2,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_3,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_4,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_5,
        ___ResourceStatusRequest_protocolIEs__item__id,
        ___ResourceStatusRequest_protocolIEs__item__criticality,
        ___ResourceStatusRequest_protocolIEs__item__value,
        __ResourceStatusRequest_protocolIEs__item_,
        _ResourceStatusRequest_protocolIEs,
        ResourceStatusRequest,
        ResourceStatusRequestIEs,
        _ResourceStatusRequestIEs_val_Value_0,
        _ResourceStatusRequestIEs_val_Value_1,
        _ResourceStatusRequestIEs_val_Value_2,
        _ResourceStatusRequestIEs_val_Value_3,
        _ResourceStatusRequestIEs_val_Value_4,
        _ResourceStatusRequestIEs_val_Value_5,
        ____ResourceStatusResponse_protocolIEs__item__id_tab,
        _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_0,
        _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_1,
        _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_2,
        _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_3,
        ___ResourceStatusResponse_protocolIEs__item__id,
        ___ResourceStatusResponse_protocolIEs__item__criticality,
        ___ResourceStatusResponse_protocolIEs__item__value,
        __ResourceStatusResponse_protocolIEs__item_,
        _ResourceStatusResponse_protocolIEs,
        ResourceStatusResponse,
        ResourceStatusResponseIEs,
        _ResourceStatusResponseIEs_val_Value_0,
        _ResourceStatusResponseIEs_val_Value_1,
        _ResourceStatusResponseIEs_val_Value_2,
        _ResourceStatusResponseIEs_val_Value_3,
        ____ResourceStatusFailure_protocolIEs__item__id_tab,
        _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_0,
        _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_1,
        _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_2,
        _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_3,
        _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_4,
        ___ResourceStatusFailure_protocolIEs__item__id,
        ___ResourceStatusFailure_protocolIEs__item__criticality,
        ___ResourceStatusFailure_protocolIEs__item__value,
        __ResourceStatusFailure_protocolIEs__item_,
        _ResourceStatusFailure_protocolIEs,
        ResourceStatusFailure,
        ResourceStatusFailureIEs,
        _ResourceStatusFailureIEs_val_Value_0,
        _ResourceStatusFailureIEs_val_Value_1,
        _ResourceStatusFailureIEs_val_Value_2,
        _ResourceStatusFailureIEs_val_Value_3,
        _ResourceStatusFailureIEs_val_Value_4,
        ____ResourceStatusUpdate_protocolIEs__item__id_tab,
        _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_3,
        _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_4,
        ___ResourceStatusUpdate_protocolIEs__item__id,
        ___ResourceStatusUpdate_protocolIEs__item__criticality,
        ___ResourceStatusUpdate_protocolIEs__item__value,
        __ResourceStatusUpdate_protocolIEs__item_,
        _ResourceStatusUpdate_protocolIEs,
        ResourceStatusUpdate,
        ResourceStatusUpdateIEs,
        _ResourceStatusUpdateIEs_val_Value_0,
        _ResourceStatusUpdateIEs_val_Value_1,
        _ResourceStatusUpdateIEs_val_Value_2,
        _ResourceStatusUpdateIEs_val_Value_3,
        _ResourceStatusUpdateIEs_val_Value_4,
        ____IAB_UPTNLAddressUpdate_protocolIEs__item__id_tab,
        _____IAB_UPTNLAddressUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____IAB_UPTNLAddressUpdate_protocolIEs__item__id_tab_val_Value_1,
        ___IAB_UPTNLAddressUpdate_protocolIEs__item__id,
        ___IAB_UPTNLAddressUpdate_protocolIEs__item__criticality,
        ___IAB_UPTNLAddressUpdate_protocolIEs__item__value,
        __IAB_UPTNLAddressUpdate_protocolIEs__item_,
        _IAB_UPTNLAddressUpdate_protocolIEs,
        IAB_UPTNLAddressUpdate,
        IAB_UPTNLAddressUpdateIEs,
        _IAB_UPTNLAddressUpdateIEs_val_Value_0,
        _IAB_UPTNLAddressUpdateIEs_val_Value_1,
        _DLUPTNLAddressToUpdateList__item_,
        DLUPTNLAddressToUpdateList,
        ____IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__id_tab,
        _____IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        ___IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__id,
        ___IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__criticality,
        ___IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item__value,
        __IAB_UPTNLAddressUpdateAcknowledge_protocolIEs__item_,
        _IAB_UPTNLAddressUpdateAcknowledge_protocolIEs,
        IAB_UPTNLAddressUpdateAcknowledge,
        IAB_UPTNLAddressUpdateAcknowledgeIEs,
        _IAB_UPTNLAddressUpdateAcknowledgeIEs_val_Value_0,
        _IAB_UPTNLAddressUpdateAcknowledgeIEs_val_Value_1,
        _IAB_UPTNLAddressUpdateAcknowledgeIEs_val_Value_2,
        _ULUPTNLAddressToUpdateList__item_,
        ULUPTNLAddressToUpdateList,
        ____IAB_UPTNLAddressUpdateFailure_protocolIEs__item__id_tab,
        _____IAB_UPTNLAddressUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____IAB_UPTNLAddressUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____IAB_UPTNLAddressUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        _____IAB_UPTNLAddressUpdateFailure_protocolIEs__item__id_tab_val_Value_3,
        ___IAB_UPTNLAddressUpdateFailure_protocolIEs__item__id,
        ___IAB_UPTNLAddressUpdateFailure_protocolIEs__item__criticality,
        ___IAB_UPTNLAddressUpdateFailure_protocolIEs__item__value,
        __IAB_UPTNLAddressUpdateFailure_protocolIEs__item_,
        _IAB_UPTNLAddressUpdateFailure_protocolIEs,
        IAB_UPTNLAddressUpdateFailure,
        IAB_UPTNLAddressUpdateFailureIEs,
        _IAB_UPTNLAddressUpdateFailureIEs_val_Value_0,
        _IAB_UPTNLAddressUpdateFailureIEs_val_Value_1,
        _IAB_UPTNLAddressUpdateFailureIEs_val_Value_2,
        _IAB_UPTNLAddressUpdateFailureIEs_val_Value_3,
        ____EarlyForwardingSNTransfer_protocolIEs__item__id_tab,
        _____EarlyForwardingSNTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____EarlyForwardingSNTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____EarlyForwardingSNTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___EarlyForwardingSNTransfer_protocolIEs__item__id,
        ___EarlyForwardingSNTransfer_protocolIEs__item__criticality,
        ___EarlyForwardingSNTransfer_protocolIEs__item__value,
        __EarlyForwardingSNTransfer_protocolIEs__item_,
        _EarlyForwardingSNTransfer_protocolIEs,
        EarlyForwardingSNTransfer,
        EarlyForwardingSNTransferIEs,
        _EarlyForwardingSNTransferIEs_val_Value_0,
        _EarlyForwardingSNTransferIEs_val_Value_1,
        _EarlyForwardingSNTransferIEs_val_Value_2,
        ____IABPSKNotification_protocolIEs__item__id_tab,
        _____IABPSKNotification_protocolIEs__item__id_tab_val_Value_0,
        _____IABPSKNotification_protocolIEs__item__id_tab_val_Value_1,
        ___IABPSKNotification_protocolIEs__item__id,
        ___IABPSKNotification_protocolIEs__item__criticality,
        ___IABPSKNotification_protocolIEs__item__value,
        __IABPSKNotification_protocolIEs__item_,
        _IABPSKNotification_protocolIEs,
        IABPSKNotification,
        IABPSKNotificationIEs,
        _IABPSKNotificationIEs_val_Value_0,
        _IABPSKNotificationIEs_val_Value_1,
        _IAB_Donor_CU_UPPSKInfo__item_,
        IAB_Donor_CU_UPPSKInfo,
        ____BCBearerContextSetupRequest_protocolIEs__item__id_tab,
        _____BCBearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____BCBearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____BCBearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_2,
        ___BCBearerContextSetupRequest_protocolIEs__item__id,
        ___BCBearerContextSetupRequest_protocolIEs__item__criticality,
        ___BCBearerContextSetupRequest_protocolIEs__item__value,
        __BCBearerContextSetupRequest_protocolIEs__item_,
        _BCBearerContextSetupRequest_protocolIEs,
        BCBearerContextSetupRequest,
        BCBearerContextSetupRequestIEs,
        _BCBearerContextSetupRequestIEs_val_Value_0,
        _BCBearerContextSetupRequestIEs_val_Value_1,
        _BCBearerContextSetupRequestIEs_val_Value_2,
        ____BCBearerContextSetupResponse_protocolIEs__item__id_tab,
        _____BCBearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____BCBearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____BCBearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____BCBearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_3,
        ___BCBearerContextSetupResponse_protocolIEs__item__id,
        ___BCBearerContextSetupResponse_protocolIEs__item__criticality,
        ___BCBearerContextSetupResponse_protocolIEs__item__value,
        __BCBearerContextSetupResponse_protocolIEs__item_,
        _BCBearerContextSetupResponse_protocolIEs,
        BCBearerContextSetupResponse,
        BCBearerContextSetupResponseIEs,
        _BCBearerContextSetupResponseIEs_val_Value_0,
        _BCBearerContextSetupResponseIEs_val_Value_1,
        _BCBearerContextSetupResponseIEs_val_Value_2,
        _BCBearerContextSetupResponseIEs_val_Value_3,
        ____BCBearerContextSetupFailure_protocolIEs__item__id_tab,
        _____BCBearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____BCBearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____BCBearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_2,
        _____BCBearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_3,
        ___BCBearerContextSetupFailure_protocolIEs__item__id,
        ___BCBearerContextSetupFailure_protocolIEs__item__criticality,
        ___BCBearerContextSetupFailure_protocolIEs__item__value,
        __BCBearerContextSetupFailure_protocolIEs__item_,
        _BCBearerContextSetupFailure_protocolIEs,
        BCBearerContextSetupFailure,
        BCBearerContextSetupFailureIEs,
        _BCBearerContextSetupFailureIEs_val_Value_0,
        _BCBearerContextSetupFailureIEs_val_Value_1,
        _BCBearerContextSetupFailureIEs_val_Value_2,
        _BCBearerContextSetupFailureIEs_val_Value_3,
        ____BCBearerContextModificationRequest_protocolIEs__item__id_tab,
        _____BCBearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____BCBearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____BCBearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_2,
        ___BCBearerContextModificationRequest_protocolIEs__item__id,
        ___BCBearerContextModificationRequest_protocolIEs__item__criticality,
        ___BCBearerContextModificationRequest_protocolIEs__item__value,
        __BCBearerContextModificationRequest_protocolIEs__item_,
        _BCBearerContextModificationRequest_protocolIEs,
        BCBearerContextModificationRequest,
        BCBearerContextModificationRequestIEs,
        _BCBearerContextModificationRequestIEs_val_Value_0,
        _BCBearerContextModificationRequestIEs_val_Value_1,
        _BCBearerContextModificationRequestIEs_val_Value_2,
        ____BCBearerContextModificationResponse_protocolIEs__item__id_tab,
        _____BCBearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____BCBearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____BCBearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____BCBearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_3,
        ___BCBearerContextModificationResponse_protocolIEs__item__id,
        ___BCBearerContextModificationResponse_protocolIEs__item__criticality,
        ___BCBearerContextModificationResponse_protocolIEs__item__value,
        __BCBearerContextModificationResponse_protocolIEs__item_,
        _BCBearerContextModificationResponse_protocolIEs,
        BCBearerContextModificationResponse,
        BCBearerContextModificationResponseIEs,
        _BCBearerContextModificationResponseIEs_val_Value_0,
        _BCBearerContextModificationResponseIEs_val_Value_1,
        _BCBearerContextModificationResponseIEs_val_Value_2,
        _BCBearerContextModificationResponseIEs_val_Value_3,
        ____BCBearerContextModificationFailure_protocolIEs__item__id_tab,
        _____BCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____BCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____BCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____BCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_3,
        ___BCBearerContextModificationFailure_protocolIEs__item__id,
        ___BCBearerContextModificationFailure_protocolIEs__item__criticality,
        ___BCBearerContextModificationFailure_protocolIEs__item__value,
        __BCBearerContextModificationFailure_protocolIEs__item_,
        _BCBearerContextModificationFailure_protocolIEs,
        BCBearerContextModificationFailure,
        BCBearerContextModificationFailureIEs,
        _BCBearerContextModificationFailureIEs_val_Value_0,
        _BCBearerContextModificationFailureIEs_val_Value_1,
        _BCBearerContextModificationFailureIEs_val_Value_2,
        _BCBearerContextModificationFailureIEs_val_Value_3,
        ____BCBearerContextModificationRequired_protocolIEs__item__id_tab,
        _____BCBearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_0,
        _____BCBearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_1,
        _____BCBearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_2,
        ___BCBearerContextModificationRequired_protocolIEs__item__id,
        ___BCBearerContextModificationRequired_protocolIEs__item__criticality,
        ___BCBearerContextModificationRequired_protocolIEs__item__value,
        __BCBearerContextModificationRequired_protocolIEs__item_,
        _BCBearerContextModificationRequired_protocolIEs,
        BCBearerContextModificationRequired,
        BCBearerContextModificationRequiredIEs,
        _BCBearerContextModificationRequiredIEs_val_Value_0,
        _BCBearerContextModificationRequiredIEs_val_Value_1,
        _BCBearerContextModificationRequiredIEs_val_Value_2,
        ____BCBearerContextModificationConfirm_protocolIEs__item__id_tab,
        _____BCBearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_0,
        _____BCBearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_1,
        _____BCBearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_2,
        _____BCBearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_3,
        ___BCBearerContextModificationConfirm_protocolIEs__item__id,
        ___BCBearerContextModificationConfirm_protocolIEs__item__criticality,
        ___BCBearerContextModificationConfirm_protocolIEs__item__value,
        __BCBearerContextModificationConfirm_protocolIEs__item_,
        _BCBearerContextModificationConfirm_protocolIEs,
        BCBearerContextModificationConfirm,
        BCBearerContextModificationConfirmIEs,
        _BCBearerContextModificationConfirmIEs_val_Value_0,
        _BCBearerContextModificationConfirmIEs_val_Value_1,
        _BCBearerContextModificationConfirmIEs_val_Value_2,
        _BCBearerContextModificationConfirmIEs_val_Value_3,
        ____BCBearerContextReleaseCommand_protocolIEs__item__id_tab,
        _____BCBearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0,
        _____BCBearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1,
        _____BCBearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_2,
        ___BCBearerContextReleaseCommand_protocolIEs__item__id,
        ___BCBearerContextReleaseCommand_protocolIEs__item__criticality,
        ___BCBearerContextReleaseCommand_protocolIEs__item__value,
        __BCBearerContextReleaseCommand_protocolIEs__item_,
        _BCBearerContextReleaseCommand_protocolIEs,
        BCBearerContextReleaseCommand,
        BCBearerContextReleaseCommandIEs,
        _BCBearerContextReleaseCommandIEs_val_Value_0,
        _BCBearerContextReleaseCommandIEs_val_Value_1,
        _BCBearerContextReleaseCommandIEs_val_Value_2,
        ____BCBearerContextReleaseComplete_protocolIEs__item__id_tab,
        _____BCBearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0,
        _____BCBearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1,
        _____BCBearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2,
        ___BCBearerContextReleaseComplete_protocolIEs__item__id,
        ___BCBearerContextReleaseComplete_protocolIEs__item__criticality,
        ___BCBearerContextReleaseComplete_protocolIEs__item__value,
        __BCBearerContextReleaseComplete_protocolIEs__item_,
        _BCBearerContextReleaseComplete_protocolIEs,
        BCBearerContextReleaseComplete,
        BCBearerContextReleaseCompleteIEs,
        _BCBearerContextReleaseCompleteIEs_val_Value_0,
        _BCBearerContextReleaseCompleteIEs_val_Value_1,
        _BCBearerContextReleaseCompleteIEs_val_Value_2,
        ____BCBearerContextReleaseRequest_protocolIEs__item__id_tab,
        _____BCBearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        _____BCBearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1,
        _____BCBearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2,
        ___BCBearerContextReleaseRequest_protocolIEs__item__id,
        ___BCBearerContextReleaseRequest_protocolIEs__item__criticality,
        ___BCBearerContextReleaseRequest_protocolIEs__item__value,
        __BCBearerContextReleaseRequest_protocolIEs__item_,
        _BCBearerContextReleaseRequest_protocolIEs,
        BCBearerContextReleaseRequest,
        BCBearerContextReleaseRequestIEs,
        _BCBearerContextReleaseRequestIEs_val_Value_0,
        _BCBearerContextReleaseRequestIEs_val_Value_1,
        _BCBearerContextReleaseRequestIEs_val_Value_2,
        ____MCBearerContextSetupRequest_protocolIEs__item__id_tab,
        _____MCBearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____MCBearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____MCBearerContextSetupRequest_protocolIEs__item__id_tab_val_Value_2,
        ___MCBearerContextSetupRequest_protocolIEs__item__id,
        ___MCBearerContextSetupRequest_protocolIEs__item__criticality,
        ___MCBearerContextSetupRequest_protocolIEs__item__value,
        __MCBearerContextSetupRequest_protocolIEs__item_,
        _MCBearerContextSetupRequest_protocolIEs,
        MCBearerContextSetupRequest,
        MCBearerContextSetupRequestIEs,
        _MCBearerContextSetupRequestIEs_val_Value_0,
        _MCBearerContextSetupRequestIEs_val_Value_1,
        _MCBearerContextSetupRequestIEs_val_Value_2,
        ____MCBearerContextSetupResponse_protocolIEs__item__id_tab,
        _____MCBearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____MCBearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____MCBearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____MCBearerContextSetupResponse_protocolIEs__item__id_tab_val_Value_3,
        ___MCBearerContextSetupResponse_protocolIEs__item__id,
        ___MCBearerContextSetupResponse_protocolIEs__item__criticality,
        ___MCBearerContextSetupResponse_protocolIEs__item__value,
        __MCBearerContextSetupResponse_protocolIEs__item_,
        _MCBearerContextSetupResponse_protocolIEs,
        MCBearerContextSetupResponse,
        MCBearerContextSetupResponseIEs,
        _MCBearerContextSetupResponseIEs_val_Value_0,
        _MCBearerContextSetupResponseIEs_val_Value_1,
        _MCBearerContextSetupResponseIEs_val_Value_2,
        _MCBearerContextSetupResponseIEs_val_Value_3,
        ____MCBearerContextSetupFailure_protocolIEs__item__id_tab,
        _____MCBearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____MCBearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____MCBearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_2,
        _____MCBearerContextSetupFailure_protocolIEs__item__id_tab_val_Value_3,
        ___MCBearerContextSetupFailure_protocolIEs__item__id,
        ___MCBearerContextSetupFailure_protocolIEs__item__criticality,
        ___MCBearerContextSetupFailure_protocolIEs__item__value,
        __MCBearerContextSetupFailure_protocolIEs__item_,
        _MCBearerContextSetupFailure_protocolIEs,
        MCBearerContextSetupFailure,
        MCBearerContextSetupFailureIEs,
        _MCBearerContextSetupFailureIEs_val_Value_0,
        _MCBearerContextSetupFailureIEs_val_Value_1,
        _MCBearerContextSetupFailureIEs_val_Value_2,
        _MCBearerContextSetupFailureIEs_val_Value_3,
        ____MCBearerContextModificationRequest_protocolIEs__item__id_tab,
        _____MCBearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____MCBearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____MCBearerContextModificationRequest_protocolIEs__item__id_tab_val_Value_2,
        ___MCBearerContextModificationRequest_protocolIEs__item__id,
        ___MCBearerContextModificationRequest_protocolIEs__item__criticality,
        ___MCBearerContextModificationRequest_protocolIEs__item__value,
        __MCBearerContextModificationRequest_protocolIEs__item_,
        _MCBearerContextModificationRequest_protocolIEs,
        MCBearerContextModificationRequest,
        MCBearerContextModificationRequestIEs,
        _MCBearerContextModificationRequestIEs_val_Value_0,
        _MCBearerContextModificationRequestIEs_val_Value_1,
        _MCBearerContextModificationRequestIEs_val_Value_2,
        ____MCBearerContextModificationResponse_protocolIEs__item__id_tab,
        _____MCBearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____MCBearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____MCBearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____MCBearerContextModificationResponse_protocolIEs__item__id_tab_val_Value_3,
        ___MCBearerContextModificationResponse_protocolIEs__item__id,
        ___MCBearerContextModificationResponse_protocolIEs__item__criticality,
        ___MCBearerContextModificationResponse_protocolIEs__item__value,
        __MCBearerContextModificationResponse_protocolIEs__item_,
        _MCBearerContextModificationResponse_protocolIEs,
        MCBearerContextModificationResponse,
        MCBearerContextModificationResponseIEs,
        _MCBearerContextModificationResponseIEs_val_Value_0,
        _MCBearerContextModificationResponseIEs_val_Value_1,
        _MCBearerContextModificationResponseIEs_val_Value_2,
        _MCBearerContextModificationResponseIEs_val_Value_3,
        ____MCBearerContextModificationFailure_protocolIEs__item__id_tab,
        _____MCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____MCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____MCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____MCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_3,
        _____MCBearerContextModificationFailure_protocolIEs__item__id_tab_val_Value_4,
        ___MCBearerContextModificationFailure_protocolIEs__item__id,
        ___MCBearerContextModificationFailure_protocolIEs__item__criticality,
        ___MCBearerContextModificationFailure_protocolIEs__item__value,
        __MCBearerContextModificationFailure_protocolIEs__item_,
        _MCBearerContextModificationFailure_protocolIEs,
        MCBearerContextModificationFailure,
        MCBearerContextModificationFailureIEs,
        _MCBearerContextModificationFailureIEs_val_Value_0,
        _MCBearerContextModificationFailureIEs_val_Value_1,
        _MCBearerContextModificationFailureIEs_val_Value_2,
        _MCBearerContextModificationFailureIEs_val_Value_3,
        _MCBearerContextModificationFailureIEs_val_Value_4,
        ____MCBearerContextModificationRequired_protocolIEs__item__id_tab,
        _____MCBearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_0,
        _____MCBearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_1,
        _____MCBearerContextModificationRequired_protocolIEs__item__id_tab_val_Value_2,
        ___MCBearerContextModificationRequired_protocolIEs__item__id,
        ___MCBearerContextModificationRequired_protocolIEs__item__criticality,
        ___MCBearerContextModificationRequired_protocolIEs__item__value,
        __MCBearerContextModificationRequired_protocolIEs__item_,
        _MCBearerContextModificationRequired_protocolIEs,
        MCBearerContextModificationRequired,
        MCBearerContextModificationRequiredIEs,
        _MCBearerContextModificationRequiredIEs_val_Value_0,
        _MCBearerContextModificationRequiredIEs_val_Value_1,
        _MCBearerContextModificationRequiredIEs_val_Value_2,
        ____MCBearerContextModificationConfirm_protocolIEs__item__id_tab,
        _____MCBearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_0,
        _____MCBearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_1,
        _____MCBearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_2,
        _____MCBearerContextModificationConfirm_protocolIEs__item__id_tab_val_Value_3,
        ___MCBearerContextModificationConfirm_protocolIEs__item__id,
        ___MCBearerContextModificationConfirm_protocolIEs__item__criticality,
        ___MCBearerContextModificationConfirm_protocolIEs__item__value,
        __MCBearerContextModificationConfirm_protocolIEs__item_,
        _MCBearerContextModificationConfirm_protocolIEs,
        MCBearerContextModificationConfirm,
        MCBearerContextModificationConfirmIEs,
        _MCBearerContextModificationConfirmIEs_val_Value_0,
        _MCBearerContextModificationConfirmIEs_val_Value_1,
        _MCBearerContextModificationConfirmIEs_val_Value_2,
        _MCBearerContextModificationConfirmIEs_val_Value_3,
        ____MCBearerContextReleaseCommand_protocolIEs__item__id_tab,
        _____MCBearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0,
        _____MCBearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1,
        _____MCBearerContextReleaseCommand_protocolIEs__item__id_tab_val_Value_2,
        ___MCBearerContextReleaseCommand_protocolIEs__item__id,
        ___MCBearerContextReleaseCommand_protocolIEs__item__criticality,
        ___MCBearerContextReleaseCommand_protocolIEs__item__value,
        __MCBearerContextReleaseCommand_protocolIEs__item_,
        _MCBearerContextReleaseCommand_protocolIEs,
        MCBearerContextReleaseCommand,
        MCBearerContextReleaseCommandIEs,
        _MCBearerContextReleaseCommandIEs_val_Value_0,
        _MCBearerContextReleaseCommandIEs_val_Value_1,
        _MCBearerContextReleaseCommandIEs_val_Value_2,
        ____MCBearerContextReleaseComplete_protocolIEs__item__id_tab,
        _____MCBearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0,
        _____MCBearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1,
        _____MCBearerContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2,
        ___MCBearerContextReleaseComplete_protocolIEs__item__id,
        ___MCBearerContextReleaseComplete_protocolIEs__item__criticality,
        ___MCBearerContextReleaseComplete_protocolIEs__item__value,
        __MCBearerContextReleaseComplete_protocolIEs__item_,
        _MCBearerContextReleaseComplete_protocolIEs,
        MCBearerContextReleaseComplete,
        MCBearerContextReleaseCompleteIEs,
        _MCBearerContextReleaseCompleteIEs_val_Value_0,
        _MCBearerContextReleaseCompleteIEs_val_Value_1,
        _MCBearerContextReleaseCompleteIEs_val_Value_2,
        ____MCBearerContextReleaseRequest_protocolIEs__item__id_tab,
        _____MCBearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        _____MCBearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1,
        _____MCBearerContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2,
        ___MCBearerContextReleaseRequest_protocolIEs__item__id,
        ___MCBearerContextReleaseRequest_protocolIEs__item__criticality,
        ___MCBearerContextReleaseRequest_protocolIEs__item__value,
        __MCBearerContextReleaseRequest_protocolIEs__item_,
        _MCBearerContextReleaseRequest_protocolIEs,
        MCBearerContextReleaseRequest,
        MCBearerContextReleaseRequestIEs,
        _MCBearerContextReleaseRequestIEs_val_Value_0,
        _MCBearerContextReleaseRequestIEs_val_Value_1,
        _MCBearerContextReleaseRequestIEs_val_Value_2,
    ]

class E1AP_PDU_Descriptions:

    _name_  = 'E1AP-PDU-Descriptions'
    _oid_   = [0, 4, 0, 0, 22, 3, 5, 1, 0]
    
    _obj_ = [
        'E1AP-ELEMENTARY-PROCEDURE',
        'E1AP-PDU',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        'E1AP-ELEMENTARY-PROCEDURES',
        'E1AP-ELEMENTARY-PROCEDURES-CLASS-1',
        'E1AP-ELEMENTARY-PROCEDURES-CLASS-2',
        'reset',
        'errorIndication',
        'gNB-CU-UP-E1Setup',
        'gNB-CU-CP-E1Setup',
        'gNB-CU-UP-ConfigurationUpdate',
        'gNB-CU-CP-ConfigurationUpdate',
        'e1Release',
        'bearerContextSetup',
        'bearerContextModification',
        'bearerContextModificationRequired',
        'bearerContextRelease',
        'bearerContextReleaseRequest',
        'bearerContextInactivityNotification',
        'dLDataNotification',
        'uLDataNotification',
        'dataUsageReport',
        'gNB-CU-UP-CounterCheck',
        'gNB-CU-UP-StatusIndication',
        'privateMessage',
        'gNB-CU-CPMeasurementResultsInformation',
        'mRDC-DataUsageReport',
        'deactivateTrace',
        'traceStart',
        'resourceStatusReportingInitiation',
        'resourceStatusReporting',
        'iAB-UPTNLAddressUpdate',
        'cellTrafficTrace',
        'earlyForwardingSNTransfer',
        'iABPSKNotification',
        'bCBearerContextSetup',
        'bCBearerContextModification',
        'bCBearerContextModificationRequired',
        'bCBearerContextRelease',
        'bCBearerContextReleaseRequest',
        'mCBearerContextSetup',
        'mCBearerContextModification',
        'mCBearerContextModificationRequired',
        'mCBearerContextRelease',
        'mCBearerContextReleaseRequest',
        ]
    _type_ = [
        'E1AP-ELEMENTARY-PROCEDURE',
        'E1AP-PDU',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        ]
    _set_ = [
        'E1AP-ELEMENTARY-PROCEDURES',
        'E1AP-ELEMENTARY-PROCEDURES-CLASS-1',
        'E1AP-ELEMENTARY-PROCEDURES-CLASS-2',
        ]
    _val_ = [
        'reset',
        'errorIndication',
        'gNB-CU-UP-E1Setup',
        'gNB-CU-CP-E1Setup',
        'gNB-CU-UP-ConfigurationUpdate',
        'gNB-CU-CP-ConfigurationUpdate',
        'e1Release',
        'bearerContextSetup',
        'bearerContextModification',
        'bearerContextModificationRequired',
        'bearerContextRelease',
        'bearerContextReleaseRequest',
        'bearerContextInactivityNotification',
        'dLDataNotification',
        'uLDataNotification',
        'dataUsageReport',
        'gNB-CU-UP-CounterCheck',
        'gNB-CU-UP-StatusIndication',
        'privateMessage',
        'gNB-CU-CPMeasurementResultsInformation',
        'mRDC-DataUsageReport',
        'deactivateTrace',
        'traceStart',
        'resourceStatusReportingInitiation',
        'resourceStatusReporting',
        'iAB-UPTNLAddressUpdate',
        'cellTrafficTrace',
        'earlyForwardingSNTransfer',
        'iABPSKNotification',
        'bCBearerContextSetup',
        'bCBearerContextModification',
        'bCBearerContextModificationRequired',
        'bCBearerContextRelease',
        'bCBearerContextReleaseRequest',
        'mCBearerContextSetup',
        'mCBearerContextModification',
        'mCBearerContextModificationRequired',
        'mCBearerContextRelease',
        'mCBearerContextReleaseRequest',
        ]
    _class_ = [
        'E1AP-ELEMENTARY-PROCEDURE',
        'E1AP-ELEMENTARY-PROCEDURES',
        'E1AP-ELEMENTARY-PROCEDURES-CLASS-1',
        'E1AP-ELEMENTARY-PROCEDURES-CLASS-2',
        'reset',
        'errorIndication',
        'gNB-CU-UP-E1Setup',
        'gNB-CU-CP-E1Setup',
        'gNB-CU-UP-ConfigurationUpdate',
        'gNB-CU-CP-ConfigurationUpdate',
        'e1Release',
        'bearerContextSetup',
        'bearerContextModification',
        'bearerContextModificationRequired',
        'bearerContextRelease',
        'bearerContextReleaseRequest',
        'bearerContextInactivityNotification',
        'dLDataNotification',
        'uLDataNotification',
        'dataUsageReport',
        'gNB-CU-UP-CounterCheck',
        'gNB-CU-UP-StatusIndication',
        'privateMessage',
        'gNB-CU-CPMeasurementResultsInformation',
        'mRDC-DataUsageReport',
        'deactivateTrace',
        'traceStart',
        'resourceStatusReportingInitiation',
        'resourceStatusReporting',
        'iAB-UPTNLAddressUpdate',
        'cellTrafficTrace',
        'earlyForwardingSNTransfer',
        'iABPSKNotification',
        'bCBearerContextSetup',
        'bCBearerContextModification',
        'bCBearerContextModificationRequired',
        'bCBearerContextRelease',
        'bCBearerContextReleaseRequest',
        'mCBearerContextSetup',
        'mCBearerContextModification',
        'mCBearerContextModificationRequired',
        'mCBearerContextRelease',
        'mCBearerContextReleaseRequest',
        ]
    _param_ = [
        ]
    
    #-----< E1AP-ELEMENTARY-PROCEDURE >-----#
    E1AP_ELEMENTARY_PROCEDURE = CLASS(name='E1AP-ELEMENTARY-PROCEDURE', mode=MODE_TYPE)
    _E1AP_ELEMENTARY_PROCEDURE_InitiatingMessage = OPEN(name='InitiatingMessage', mode=MODE_TYPE)
    _E1AP_ELEMENTARY_PROCEDURE_SuccessfulOutcome = OPEN(name='SuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _E1AP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome = OPEN(name='UnsuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _E1AP_ELEMENTARY_PROCEDURE_procedureCode = INT(name='procedureCode', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'ProcedureCode')), uniq=True)
    _E1AP_ELEMENTARY_PROCEDURE_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-CommonDataTypes', 'Criticality')), default='ignore')
    E1AP_ELEMENTARY_PROCEDURE._cont = ASN1Dict([
        ('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURE_InitiatingMessage),
        ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURE_SuccessfulOutcome),
        ('UnsuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome),
        ('procedureCode', _E1AP_ELEMENTARY_PROCEDURE_procedureCode),
        ('criticality', _E1AP_ELEMENTARY_PROCEDURE_criticality),
        ])
    
    #-----< E1AP-PDU >-----#
    E1AP_PDU = CHOICE(name='E1AP-PDU', mode=MODE_TYPE)
    _E1AP_PDU_initiatingMessage = SEQ(name='initiatingMessage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'InitiatingMessage')))
    _E1AP_PDU_successfulOutcome = SEQ(name='successfulOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'SuccessfulOutcome')))
    _E1AP_PDU_unsuccessfulOutcome = SEQ(name='unsuccessfulOutcome', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'UnsuccessfulOutcome')))
    E1AP_PDU._cont = ASN1Dict([
        ('initiatingMessage', _E1AP_PDU_initiatingMessage),
        ('successfulOutcome', _E1AP_PDU_successfulOutcome),
        ('unsuccessfulOutcome', _E1AP_PDU_unsuccessfulOutcome),
        ])
    E1AP_PDU._ext = []
    
    #-----< InitiatingMessage >-----#
    InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE)
    _InitiatingMessage_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __InitiatingMessage_procedureCode_tab = CLASS(name='_tab_E1AP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'Reset')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResetAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-E1SetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-E1SetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-E1SetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-E1SetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-E1SetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-E1SetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-ConfigurationUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-ConfigurationUpdateAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-ConfigurationUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-ConfigurationUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-ConfigurationUpdateAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-ConfigurationUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'E1ReleaseRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'E1ReleaseResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextSetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextSetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextSetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationRequired')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextReleaseCommand')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextReleaseComplete')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResourceStatusRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResourceStatusResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResourceStatusFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IAB-UPTNLAddressUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IAB-UPTNLAddressUpdateAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IAB-UPTNLAddressUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextSetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextSetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextSetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationRequired')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextReleaseCommand')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextReleaseComplete')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextSetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextSetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_16 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextSetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_17 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationRequired')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextReleaseCommand')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextReleaseComplete')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ErrorIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextReleaseRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextInactivityNotification')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'DLDataNotification')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ULDataNotification')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'DataUsageReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-CounterCheckRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-StatusIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MRDC-DataUsageReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'DeactivateTrace')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'TraceStart')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'PrivateMessage')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'CellTrafficTrace')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResourceStatusUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'EarlyForwardingSNTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CPMeasurementResultsInformation')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IABPSKNotification')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextReleaseRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextReleaseRequest')))
    __InitiatingMessage_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0), ('procedureCode', 0), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6), ('procedureCode', 8), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8), ('procedureCode', 10), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9), ('procedureCode', 11), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_10), ('procedureCode', 22), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_11), ('procedureCode', 24), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_12), ('procedureCode', 29), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_13), ('procedureCode', 30), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_14), ('procedureCode', 31), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_15), ('procedureCode', 32), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_16), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_16), ('procedureCode', 34), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_17), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_17), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_18), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_19), ('procedureCode', 37), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20), ('procedureCode', 1), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26), ('procedureCode', 16), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27), ('procedureCode', 17), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29), ('procedureCode', 21), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30), ('procedureCode', 20), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32), ('procedureCode', 25), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33), ('procedureCode', 23), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34), ('procedureCode', 26), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35), ('procedureCode', 27), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36), ('procedureCode', 28), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37), ('procedureCode', 33), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38), ('procedureCode', 38), ('criticality', 'reject')])], rr=[], ev=None, er=[])
    _InitiatingMessage_procedureCode._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_procedureCode._const_tab_at = None
    _InitiatingMessage_procedureCode._const_tab_id = 'procedureCode'
    _InitiatingMessage_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _InitiatingMessage_criticality._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_criticality._const_tab_at = ('..', 'procedureCode')
    _InitiatingMessage_criticality._const_tab_id = 'criticality'
    _InitiatingMessage_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE'), ['InitiatingMessage']))
    _InitiatingMessage_value._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_value._const_tab_at = ('..', 'procedureCode')
    _InitiatingMessage_value._const_tab_id = 'InitiatingMessage'
    InitiatingMessage._cont = ASN1Dict([
        ('procedureCode', _InitiatingMessage_procedureCode),
        ('criticality', _InitiatingMessage_criticality),
        ('value', _InitiatingMessage_value),
        ])
    InitiatingMessage._ext = None
    
    #-----< SuccessfulOutcome >-----#
    SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE)
    _SuccessfulOutcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __SuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_E1AP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'Reset')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResetAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-E1SetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-E1SetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-E1SetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-E1SetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-E1SetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-E1SetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-ConfigurationUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-ConfigurationUpdateAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-ConfigurationUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-ConfigurationUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-ConfigurationUpdateAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-ConfigurationUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'E1ReleaseRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'E1ReleaseResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextSetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextSetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextSetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextReleaseCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextReleaseComplete')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResourceStatusRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResourceStatusResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResourceStatusFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IAB-UPTNLAddressUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IAB-UPTNLAddressUpdateAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IAB-UPTNLAddressUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextSetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextSetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextSetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextReleaseCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextReleaseComplete')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextSetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextSetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextSetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_17 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextReleaseCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextReleaseComplete')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ErrorIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextReleaseRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextInactivityNotification')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'DLDataNotification')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ULDataNotification')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'DataUsageReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-CounterCheckRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-StatusIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MRDC-DataUsageReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'DeactivateTrace')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'TraceStart')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'PrivateMessage')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'CellTrafficTrace')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResourceStatusUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'EarlyForwardingSNTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CPMeasurementResultsInformation')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IABPSKNotification')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextReleaseRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextReleaseRequest')))
    __SuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), ('procedureCode', 0), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6), ('procedureCode', 8), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), ('procedureCode', 10), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9), ('procedureCode', 11), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10), ('procedureCode', 22), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11), ('procedureCode', 24), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12), ('procedureCode', 29), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13), ('procedureCode', 30), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14), ('procedureCode', 31), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15), ('procedureCode', 32), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16), ('procedureCode', 34), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_17), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19), ('procedureCode', 37), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20), ('procedureCode', 1), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26), ('procedureCode', 16), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27), ('procedureCode', 17), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29), ('procedureCode', 21), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30), ('procedureCode', 20), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32), ('procedureCode', 25), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33), ('procedureCode', 23), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34), ('procedureCode', 26), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35), ('procedureCode', 27), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36), ('procedureCode', 28), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37), ('procedureCode', 33), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38), ('procedureCode', 38), ('criticality', 'reject')])], rr=[], ev=None, er=[])
    _SuccessfulOutcome_procedureCode._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_procedureCode._const_tab_at = None
    _SuccessfulOutcome_procedureCode._const_tab_id = 'procedureCode'
    _SuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _SuccessfulOutcome_criticality._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureCode')
    _SuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _SuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE'), ['SuccessfulOutcome']))
    _SuccessfulOutcome_value._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_value._const_tab_at = ('..', 'procedureCode')
    _SuccessfulOutcome_value._const_tab_id = 'SuccessfulOutcome'
    SuccessfulOutcome._cont = ASN1Dict([
        ('procedureCode', _SuccessfulOutcome_procedureCode),
        ('criticality', _SuccessfulOutcome_criticality),
        ('value', _SuccessfulOutcome_value),
        ])
    SuccessfulOutcome._ext = None
    
    #-----< UnsuccessfulOutcome >-----#
    UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE)
    _UnsuccessfulOutcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __UnsuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_E1AP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'Reset')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResetAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-E1SetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-E1SetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-E1SetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-E1SetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-E1SetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-E1SetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-ConfigurationUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-ConfigurationUpdateAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-ConfigurationUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-ConfigurationUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-ConfigurationUpdateAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-ConfigurationUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'E1ReleaseRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'E1ReleaseResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextSetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextSetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextSetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextReleaseCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextReleaseComplete')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResourceStatusRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResourceStatusResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResourceStatusFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IAB-UPTNLAddressUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IAB-UPTNLAddressUpdateAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IAB-UPTNLAddressUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextSetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextSetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextSetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextReleaseCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextReleaseComplete')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextSetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextSetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextSetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_17 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextReleaseCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextReleaseComplete')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ErrorIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextReleaseRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextInactivityNotification')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'DLDataNotification')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ULDataNotification')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'DataUsageReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-CounterCheckRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-StatusIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MRDC-DataUsageReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'DeactivateTrace')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'TraceStart')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'PrivateMessage')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'CellTrafficTrace')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResourceStatusUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'EarlyForwardingSNTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CPMeasurementResultsInformation')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IABPSKNotification')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextReleaseRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextReleaseRequest')))
    __UnsuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), ('procedureCode', 0), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6), ('procedureCode', 8), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), ('procedureCode', 10), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9), ('procedureCode', 11), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10), ('procedureCode', 22), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11), ('procedureCode', 24), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12), ('procedureCode', 29), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13), ('procedureCode', 30), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14), ('procedureCode', 31), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15), ('procedureCode', 32), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16), ('procedureCode', 34), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_17), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19), ('procedureCode', 37), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20), ('procedureCode', 1), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26), ('procedureCode', 16), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27), ('procedureCode', 17), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29), ('procedureCode', 21), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30), ('procedureCode', 20), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32), ('procedureCode', 25), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33), ('procedureCode', 23), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34), ('procedureCode', 26), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35), ('procedureCode', 27), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36), ('procedureCode', 28), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37), ('procedureCode', 33), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38), ('procedureCode', 38), ('criticality', 'reject')])], rr=[], ev=None, er=[])
    _UnsuccessfulOutcome_procedureCode._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_procedureCode._const_tab_at = None
    _UnsuccessfulOutcome_procedureCode._const_tab_id = 'procedureCode'
    _UnsuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _UnsuccessfulOutcome_criticality._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureCode')
    _UnsuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _UnsuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE'), ['UnsuccessfulOutcome']))
    _UnsuccessfulOutcome_value._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_value._const_tab_at = ('..', 'procedureCode')
    _UnsuccessfulOutcome_value._const_tab_id = 'UnsuccessfulOutcome'
    UnsuccessfulOutcome._cont = ASN1Dict([
        ('procedureCode', _UnsuccessfulOutcome_procedureCode),
        ('criticality', _UnsuccessfulOutcome_criticality),
        ('value', _UnsuccessfulOutcome_value),
        ])
    UnsuccessfulOutcome._ext = None
    
    #-----< E1AP-ELEMENTARY-PROCEDURES >-----#
    E1AP_ELEMENTARY_PROCEDURES = CLASS(name='E1AP-ELEMENTARY-PROCEDURES', mode=MODE_SET, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'Reset')))
    _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResetAcknowledge')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-E1SetupRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-E1SetupResponse')))
    _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-E1SetupFailure')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-E1SetupRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-E1SetupResponse')))
    _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-E1SetupFailure')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-ConfigurationUpdate')))
    _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-ConfigurationUpdateAcknowledge')))
    _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-ConfigurationUpdateFailure')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-ConfigurationUpdate')))
    _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-ConfigurationUpdateAcknowledge')))
    _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-ConfigurationUpdateFailure')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'E1ReleaseRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'E1ReleaseResponse')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextSetupRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextSetupResponse')))
    _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextSetupFailure')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationResponse')))
    _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationFailure')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationRequired')))
    _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationConfirm')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextReleaseCommand')))
    _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextReleaseComplete')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResourceStatusRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResourceStatusResponse')))
    _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResourceStatusFailure')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IAB-UPTNLAddressUpdate')))
    _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IAB-UPTNLAddressUpdateAcknowledge')))
    _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IAB-UPTNLAddressUpdateFailure')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextSetupRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextSetupResponse')))
    _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextSetupFailure')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationResponse')))
    _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationFailure')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationRequired')))
    _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationConfirm')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextReleaseCommand')))
    _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextReleaseComplete')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextSetupRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextSetupResponse')))
    _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_16 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextSetupFailure')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationResponse')))
    _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_17 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationFailure')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationRequired')))
    _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationConfirm')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextReleaseCommand')))
    _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextReleaseComplete')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ErrorIndication')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextReleaseRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextInactivityNotification')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'DLDataNotification')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ULDataNotification')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'DataUsageReport')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-CounterCheckRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-StatusIndication')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MRDC-DataUsageReport')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'DeactivateTrace')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'TraceStart')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'PrivateMessage')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'CellTrafficTrace')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResourceStatusUpdate')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'EarlyForwardingSNTransfer')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CPMeasurementResultsInformation')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IABPSKNotification')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextReleaseRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextReleaseRequest')))
    E1AP_ELEMENTARY_PROCEDURES._val = ASN1Set(rv=[dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0), ('procedureCode', 0), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6), ('procedureCode', 8), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8), ('procedureCode', 10), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9), ('procedureCode', 11), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_10), ('procedureCode', 22), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11), ('procedureCode', 24), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12), ('procedureCode', 29), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13), ('procedureCode', 30), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14), ('procedureCode', 31), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15), ('procedureCode', 32), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_16), ('UnsuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_16), ('procedureCode', 34), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_17), ('UnsuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_17), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_18), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_19), ('procedureCode', 37), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20), ('procedureCode', 1), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26), ('procedureCode', 16), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27), ('procedureCode', 17), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29), ('procedureCode', 21), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30), ('procedureCode', 20), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32), ('procedureCode', 25), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33), ('procedureCode', 23), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34), ('procedureCode', 26), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35), ('procedureCode', 27), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36), ('procedureCode', 28), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37), ('procedureCode', 33), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38), ('procedureCode', 38), ('criticality', 'reject')])], rr=[], ev=[], er=[])
    
    #-----< E1AP-ELEMENTARY-PROCEDURES-CLASS-1 >-----#
    E1AP_ELEMENTARY_PROCEDURES_CLASS_1 = CLASS(name='E1AP-ELEMENTARY-PROCEDURES-CLASS-1', mode=MODE_SET, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'Reset')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResetAcknowledge')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-E1SetupRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-E1SetupResponse')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-E1SetupFailure')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-E1SetupRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-E1SetupResponse')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-E1SetupFailure')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-ConfigurationUpdate')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-ConfigurationUpdateAcknowledge')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-ConfigurationUpdateFailure')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-ConfigurationUpdate')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-ConfigurationUpdateAcknowledge')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-ConfigurationUpdateFailure')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'E1ReleaseRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'E1ReleaseResponse')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextSetupRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextSetupResponse')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextSetupFailure')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationResponse')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationFailure')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationRequired')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationConfirm')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextReleaseCommand')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextReleaseComplete')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResourceStatusRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResourceStatusResponse')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResourceStatusFailure')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IAB-UPTNLAddressUpdate')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IAB-UPTNLAddressUpdateAcknowledge')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IAB-UPTNLAddressUpdateFailure')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextSetupRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextSetupResponse')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextSetupFailure')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationResponse')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationFailure')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationRequired')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationConfirm')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextReleaseCommand')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextReleaseComplete')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextSetupRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextSetupResponse')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_16 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextSetupFailure')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationResponse')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_17 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationFailure')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationRequired')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationConfirm')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextReleaseCommand')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextReleaseComplete')))
    E1AP_ELEMENTARY_PROCEDURES_CLASS_1._val = ASN1Set(rv=[dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0), ('procedureCode', 0), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6), ('procedureCode', 8), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8), ('procedureCode', 10), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9), ('procedureCode', 11), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10), ('procedureCode', 22), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11), ('procedureCode', 24), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12), ('procedureCode', 29), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13), ('procedureCode', 30), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14), ('procedureCode', 31), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15), ('procedureCode', 32), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16), ('UnsuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_16), ('procedureCode', 34), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17), ('UnsuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_17), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19), ('SuccessfulOutcome', _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19), ('procedureCode', 37), ('criticality', 'reject')])], rr=[], ev=[], er=[])
    
    #-----< E1AP-ELEMENTARY-PROCEDURES-CLASS-2 >-----#
    E1AP_ELEMENTARY_PROCEDURES_CLASS_2 = CLASS(name='E1AP-ELEMENTARY-PROCEDURES-CLASS-2', mode=MODE_SET, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ErrorIndication')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextReleaseRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextInactivityNotification')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'DLDataNotification')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ULDataNotification')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'DataUsageReport')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-CounterCheckRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-StatusIndication')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MRDC-DataUsageReport')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'DeactivateTrace')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'TraceStart')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'PrivateMessage')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'CellTrafficTrace')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResourceStatusUpdate')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'EarlyForwardingSNTransfer')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CPMeasurementResultsInformation')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IABPSKNotification')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextReleaseRequest')))
    _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextReleaseRequest')))
    E1AP_ELEMENTARY_PROCEDURES_CLASS_2._val = ASN1Set(rv=[dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0), ('procedureCode', 1), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6), ('procedureCode', 16), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7), ('procedureCode', 17), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9), ('procedureCode', 21), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10), ('procedureCode', 20), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12), ('procedureCode', 25), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13), ('procedureCode', 23), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14), ('procedureCode', 26), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15), ('procedureCode', 27), ('criticality', 'ignore')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16), ('procedureCode', 28), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17), ('procedureCode', 33), ('criticality', 'reject')]), dict([('InitiatingMessage', _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18), ('procedureCode', 38), ('criticality', 'reject')])], rr=[], ev=[], er=[])
    
    #-----< reset >-----#
    reset = CLASS(name='reset', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _reset_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'Reset')))
    _reset_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResetAcknowledge')))
    reset._val = dict([('InitiatingMessage', _reset_val_InitiatingMessage), ('SuccessfulOutcome', _reset_val_SuccessfulOutcome), ('procedureCode', 0), ('criticality', 'reject')])
    
    #-----< errorIndication >-----#
    errorIndication = CLASS(name='errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _errorIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ErrorIndication')))
    errorIndication._val = dict([('InitiatingMessage', _errorIndication_val_InitiatingMessage), ('procedureCode', 1), ('criticality', 'ignore')])
    
    #-----< gNB-CU-UP-E1Setup >-----#
    gNB_CU_UP_E1Setup = CLASS(name='gNB-CU-UP-E1Setup', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _gNB_CU_UP_E1Setup_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-E1SetupRequest')))
    _gNB_CU_UP_E1Setup_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-E1SetupResponse')))
    _gNB_CU_UP_E1Setup_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-E1SetupFailure')))
    gNB_CU_UP_E1Setup._val = dict([('InitiatingMessage', _gNB_CU_UP_E1Setup_val_InitiatingMessage), ('SuccessfulOutcome', _gNB_CU_UP_E1Setup_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _gNB_CU_UP_E1Setup_val_UnsuccessfulOutcome), ('procedureCode', 3), ('criticality', 'reject')])
    
    #-----< gNB-CU-CP-E1Setup >-----#
    gNB_CU_CP_E1Setup = CLASS(name='gNB-CU-CP-E1Setup', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _gNB_CU_CP_E1Setup_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-E1SetupRequest')))
    _gNB_CU_CP_E1Setup_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-E1SetupResponse')))
    _gNB_CU_CP_E1Setup_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-E1SetupFailure')))
    gNB_CU_CP_E1Setup._val = dict([('InitiatingMessage', _gNB_CU_CP_E1Setup_val_InitiatingMessage), ('SuccessfulOutcome', _gNB_CU_CP_E1Setup_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _gNB_CU_CP_E1Setup_val_UnsuccessfulOutcome), ('procedureCode', 4), ('criticality', 'reject')])
    
    #-----< gNB-CU-UP-ConfigurationUpdate >-----#
    gNB_CU_UP_ConfigurationUpdate = CLASS(name='gNB-CU-UP-ConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _gNB_CU_UP_ConfigurationUpdate_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-ConfigurationUpdate')))
    _gNB_CU_UP_ConfigurationUpdate_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-ConfigurationUpdateAcknowledge')))
    _gNB_CU_UP_ConfigurationUpdate_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-ConfigurationUpdateFailure')))
    gNB_CU_UP_ConfigurationUpdate._val = dict([('InitiatingMessage', _gNB_CU_UP_ConfigurationUpdate_val_InitiatingMessage), ('SuccessfulOutcome', _gNB_CU_UP_ConfigurationUpdate_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _gNB_CU_UP_ConfigurationUpdate_val_UnsuccessfulOutcome), ('procedureCode', 5), ('criticality', 'reject')])
    
    #-----< gNB-CU-CP-ConfigurationUpdate >-----#
    gNB_CU_CP_ConfigurationUpdate = CLASS(name='gNB-CU-CP-ConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _gNB_CU_CP_ConfigurationUpdate_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-ConfigurationUpdate')))
    _gNB_CU_CP_ConfigurationUpdate_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-ConfigurationUpdateAcknowledge')))
    _gNB_CU_CP_ConfigurationUpdate_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CP-ConfigurationUpdateFailure')))
    gNB_CU_CP_ConfigurationUpdate._val = dict([('InitiatingMessage', _gNB_CU_CP_ConfigurationUpdate_val_InitiatingMessage), ('SuccessfulOutcome', _gNB_CU_CP_ConfigurationUpdate_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _gNB_CU_CP_ConfigurationUpdate_val_UnsuccessfulOutcome), ('procedureCode', 6), ('criticality', 'reject')])
    
    #-----< e1Release >-----#
    e1Release = CLASS(name='e1Release', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _e1Release_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'E1ReleaseRequest')))
    _e1Release_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'E1ReleaseResponse')))
    e1Release._val = dict([('InitiatingMessage', _e1Release_val_InitiatingMessage), ('SuccessfulOutcome', _e1Release_val_SuccessfulOutcome), ('procedureCode', 7), ('criticality', 'reject')])
    
    #-----< bearerContextSetup >-----#
    bearerContextSetup = CLASS(name='bearerContextSetup', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _bearerContextSetup_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextSetupRequest')))
    _bearerContextSetup_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextSetupResponse')))
    _bearerContextSetup_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextSetupFailure')))
    bearerContextSetup._val = dict([('InitiatingMessage', _bearerContextSetup_val_InitiatingMessage), ('SuccessfulOutcome', _bearerContextSetup_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _bearerContextSetup_val_UnsuccessfulOutcome), ('procedureCode', 8), ('criticality', 'reject')])
    
    #-----< bearerContextModification >-----#
    bearerContextModification = CLASS(name='bearerContextModification', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _bearerContextModification_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationRequest')))
    _bearerContextModification_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationResponse')))
    _bearerContextModification_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationFailure')))
    bearerContextModification._val = dict([('InitiatingMessage', _bearerContextModification_val_InitiatingMessage), ('SuccessfulOutcome', _bearerContextModification_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _bearerContextModification_val_UnsuccessfulOutcome), ('procedureCode', 9), ('criticality', 'reject')])
    
    #-----< bearerContextModificationRequired >-----#
    bearerContextModificationRequired = CLASS(name='bearerContextModificationRequired', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _bearerContextModificationRequired_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationRequired')))
    _bearerContextModificationRequired_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextModificationConfirm')))
    bearerContextModificationRequired._val = dict([('InitiatingMessage', _bearerContextModificationRequired_val_InitiatingMessage), ('SuccessfulOutcome', _bearerContextModificationRequired_val_SuccessfulOutcome), ('procedureCode', 10), ('criticality', 'reject')])
    
    #-----< bearerContextRelease >-----#
    bearerContextRelease = CLASS(name='bearerContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _bearerContextRelease_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextReleaseCommand')))
    _bearerContextRelease_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextReleaseComplete')))
    bearerContextRelease._val = dict([('InitiatingMessage', _bearerContextRelease_val_InitiatingMessage), ('SuccessfulOutcome', _bearerContextRelease_val_SuccessfulOutcome), ('procedureCode', 11), ('criticality', 'reject')])
    
    #-----< bearerContextReleaseRequest >-----#
    bearerContextReleaseRequest = CLASS(name='bearerContextReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _bearerContextReleaseRequest_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextReleaseRequest')))
    bearerContextReleaseRequest._val = dict([('InitiatingMessage', _bearerContextReleaseRequest_val_InitiatingMessage), ('procedureCode', 12), ('criticality', 'ignore')])
    
    #-----< bearerContextInactivityNotification >-----#
    bearerContextInactivityNotification = CLASS(name='bearerContextInactivityNotification', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _bearerContextInactivityNotification_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BearerContextInactivityNotification')))
    bearerContextInactivityNotification._val = dict([('InitiatingMessage', _bearerContextInactivityNotification_val_InitiatingMessage), ('procedureCode', 13), ('criticality', 'ignore')])
    
    #-----< dLDataNotification >-----#
    dLDataNotification = CLASS(name='dLDataNotification', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _dLDataNotification_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'DLDataNotification')))
    dLDataNotification._val = dict([('InitiatingMessage', _dLDataNotification_val_InitiatingMessage), ('procedureCode', 14), ('criticality', 'ignore')])
    
    #-----< uLDataNotification >-----#
    uLDataNotification = CLASS(name='uLDataNotification', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _uLDataNotification_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ULDataNotification')))
    uLDataNotification._val = dict([('InitiatingMessage', _uLDataNotification_val_InitiatingMessage), ('procedureCode', 18), ('criticality', 'ignore')])
    
    #-----< dataUsageReport >-----#
    dataUsageReport = CLASS(name='dataUsageReport', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _dataUsageReport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'DataUsageReport')))
    dataUsageReport._val = dict([('InitiatingMessage', _dataUsageReport_val_InitiatingMessage), ('procedureCode', 15), ('criticality', 'ignore')])
    
    #-----< gNB-CU-UP-CounterCheck >-----#
    gNB_CU_UP_CounterCheck = CLASS(name='gNB-CU-UP-CounterCheck', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _gNB_CU_UP_CounterCheck_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-CounterCheckRequest')))
    gNB_CU_UP_CounterCheck._val = dict([('InitiatingMessage', _gNB_CU_UP_CounterCheck_val_InitiatingMessage), ('procedureCode', 16), ('criticality', 'ignore')])
    
    #-----< gNB-CU-UP-StatusIndication >-----#
    gNB_CU_UP_StatusIndication = CLASS(name='gNB-CU-UP-StatusIndication', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _gNB_CU_UP_StatusIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-UP-StatusIndication')))
    gNB_CU_UP_StatusIndication._val = dict([('InitiatingMessage', _gNB_CU_UP_StatusIndication_val_InitiatingMessage), ('procedureCode', 17), ('criticality', 'ignore')])
    
    #-----< privateMessage >-----#
    privateMessage = CLASS(name='privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _privateMessage_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'PrivateMessage')))
    privateMessage._val = dict([('InitiatingMessage', _privateMessage_val_InitiatingMessage), ('procedureCode', 2), ('criticality', 'ignore')])
    
    #-----< gNB-CU-CPMeasurementResultsInformation >-----#
    gNB_CU_CPMeasurementResultsInformation = CLASS(name='gNB-CU-CPMeasurementResultsInformation', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _gNB_CU_CPMeasurementResultsInformation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'GNB-CU-CPMeasurementResultsInformation')))
    gNB_CU_CPMeasurementResultsInformation._val = dict([('InitiatingMessage', _gNB_CU_CPMeasurementResultsInformation_val_InitiatingMessage), ('procedureCode', 27), ('criticality', 'ignore')])
    
    #-----< mRDC-DataUsageReport >-----#
    mRDC_DataUsageReport = CLASS(name='mRDC-DataUsageReport', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _mRDC_DataUsageReport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MRDC-DataUsageReport')))
    mRDC_DataUsageReport._val = dict([('InitiatingMessage', _mRDC_DataUsageReport_val_InitiatingMessage), ('procedureCode', 19), ('criticality', 'ignore')])
    
    #-----< deactivateTrace >-----#
    deactivateTrace = CLASS(name='deactivateTrace', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _deactivateTrace_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'DeactivateTrace')))
    deactivateTrace._val = dict([('InitiatingMessage', _deactivateTrace_val_InitiatingMessage), ('procedureCode', 21), ('criticality', 'ignore')])
    
    #-----< traceStart >-----#
    traceStart = CLASS(name='traceStart', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _traceStart_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'TraceStart')))
    traceStart._val = dict([('InitiatingMessage', _traceStart_val_InitiatingMessage), ('procedureCode', 20), ('criticality', 'ignore')])
    
    #-----< resourceStatusReportingInitiation >-----#
    resourceStatusReportingInitiation = CLASS(name='resourceStatusReportingInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _resourceStatusReportingInitiation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResourceStatusRequest')))
    _resourceStatusReportingInitiation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResourceStatusResponse')))
    _resourceStatusReportingInitiation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResourceStatusFailure')))
    resourceStatusReportingInitiation._val = dict([('InitiatingMessage', _resourceStatusReportingInitiation_val_InitiatingMessage), ('SuccessfulOutcome', _resourceStatusReportingInitiation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _resourceStatusReportingInitiation_val_UnsuccessfulOutcome), ('procedureCode', 22), ('criticality', 'reject')])
    
    #-----< resourceStatusReporting >-----#
    resourceStatusReporting = CLASS(name='resourceStatusReporting', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _resourceStatusReporting_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'ResourceStatusUpdate')))
    resourceStatusReporting._val = dict([('InitiatingMessage', _resourceStatusReporting_val_InitiatingMessage), ('procedureCode', 23), ('criticality', 'ignore')])
    
    #-----< iAB-UPTNLAddressUpdate >-----#
    iAB_UPTNLAddressUpdate = CLASS(name='iAB-UPTNLAddressUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _iAB_UPTNLAddressUpdate_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IAB-UPTNLAddressUpdate')))
    _iAB_UPTNLAddressUpdate_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IAB-UPTNLAddressUpdateAcknowledge')))
    _iAB_UPTNLAddressUpdate_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IAB-UPTNLAddressUpdateFailure')))
    iAB_UPTNLAddressUpdate._val = dict([('InitiatingMessage', _iAB_UPTNLAddressUpdate_val_InitiatingMessage), ('SuccessfulOutcome', _iAB_UPTNLAddressUpdate_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _iAB_UPTNLAddressUpdate_val_UnsuccessfulOutcome), ('procedureCode', 24), ('criticality', 'reject')])
    
    #-----< cellTrafficTrace >-----#
    cellTrafficTrace = CLASS(name='cellTrafficTrace', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _cellTrafficTrace_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'CellTrafficTrace')))
    cellTrafficTrace._val = dict([('InitiatingMessage', _cellTrafficTrace_val_InitiatingMessage), ('procedureCode', 25), ('criticality', 'ignore')])
    
    #-----< earlyForwardingSNTransfer >-----#
    earlyForwardingSNTransfer = CLASS(name='earlyForwardingSNTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _earlyForwardingSNTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'EarlyForwardingSNTransfer')))
    earlyForwardingSNTransfer._val = dict([('InitiatingMessage', _earlyForwardingSNTransfer_val_InitiatingMessage), ('procedureCode', 26), ('criticality', 'ignore')])
    
    #-----< iABPSKNotification >-----#
    iABPSKNotification = CLASS(name='iABPSKNotification', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _iABPSKNotification_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'IABPSKNotification')))
    iABPSKNotification._val = dict([('InitiatingMessage', _iABPSKNotification_val_InitiatingMessage), ('procedureCode', 28), ('criticality', 'reject')])
    
    #-----< bCBearerContextSetup >-----#
    bCBearerContextSetup = CLASS(name='bCBearerContextSetup', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _bCBearerContextSetup_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextSetupRequest')))
    _bCBearerContextSetup_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextSetupResponse')))
    _bCBearerContextSetup_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextSetupFailure')))
    bCBearerContextSetup._val = dict([('InitiatingMessage', _bCBearerContextSetup_val_InitiatingMessage), ('SuccessfulOutcome', _bCBearerContextSetup_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _bCBearerContextSetup_val_UnsuccessfulOutcome), ('procedureCode', 29), ('criticality', 'reject')])
    
    #-----< bCBearerContextModification >-----#
    bCBearerContextModification = CLASS(name='bCBearerContextModification', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _bCBearerContextModification_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationRequest')))
    _bCBearerContextModification_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationResponse')))
    _bCBearerContextModification_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationFailure')))
    bCBearerContextModification._val = dict([('InitiatingMessage', _bCBearerContextModification_val_InitiatingMessage), ('SuccessfulOutcome', _bCBearerContextModification_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _bCBearerContextModification_val_UnsuccessfulOutcome), ('procedureCode', 30), ('criticality', 'reject')])
    
    #-----< bCBearerContextModificationRequired >-----#
    bCBearerContextModificationRequired = CLASS(name='bCBearerContextModificationRequired', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _bCBearerContextModificationRequired_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationRequired')))
    _bCBearerContextModificationRequired_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextModificationConfirm')))
    bCBearerContextModificationRequired._val = dict([('InitiatingMessage', _bCBearerContextModificationRequired_val_InitiatingMessage), ('SuccessfulOutcome', _bCBearerContextModificationRequired_val_SuccessfulOutcome), ('procedureCode', 31), ('criticality', 'reject')])
    
    #-----< bCBearerContextRelease >-----#
    bCBearerContextRelease = CLASS(name='bCBearerContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _bCBearerContextRelease_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextReleaseCommand')))
    _bCBearerContextRelease_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextReleaseComplete')))
    bCBearerContextRelease._val = dict([('InitiatingMessage', _bCBearerContextRelease_val_InitiatingMessage), ('SuccessfulOutcome', _bCBearerContextRelease_val_SuccessfulOutcome), ('procedureCode', 32), ('criticality', 'reject')])
    
    #-----< bCBearerContextReleaseRequest >-----#
    bCBearerContextReleaseRequest = CLASS(name='bCBearerContextReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _bCBearerContextReleaseRequest_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'BCBearerContextReleaseRequest')))
    bCBearerContextReleaseRequest._val = dict([('InitiatingMessage', _bCBearerContextReleaseRequest_val_InitiatingMessage), ('procedureCode', 33), ('criticality', 'reject')])
    
    #-----< mCBearerContextSetup >-----#
    mCBearerContextSetup = CLASS(name='mCBearerContextSetup', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _mCBearerContextSetup_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextSetupRequest')))
    _mCBearerContextSetup_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextSetupResponse')))
    _mCBearerContextSetup_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextSetupFailure')))
    mCBearerContextSetup._val = dict([('InitiatingMessage', _mCBearerContextSetup_val_InitiatingMessage), ('SuccessfulOutcome', _mCBearerContextSetup_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _mCBearerContextSetup_val_UnsuccessfulOutcome), ('procedureCode', 34), ('criticality', 'reject')])
    
    #-----< mCBearerContextModification >-----#
    mCBearerContextModification = CLASS(name='mCBearerContextModification', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _mCBearerContextModification_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationRequest')))
    _mCBearerContextModification_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationResponse')))
    _mCBearerContextModification_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationFailure')))
    mCBearerContextModification._val = dict([('InitiatingMessage', _mCBearerContextModification_val_InitiatingMessage), ('SuccessfulOutcome', _mCBearerContextModification_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _mCBearerContextModification_val_UnsuccessfulOutcome), ('procedureCode', 35), ('criticality', 'reject')])
    
    #-----< mCBearerContextModificationRequired >-----#
    mCBearerContextModificationRequired = CLASS(name='mCBearerContextModificationRequired', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _mCBearerContextModificationRequired_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationRequired')))
    _mCBearerContextModificationRequired_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextModificationConfirm')))
    mCBearerContextModificationRequired._val = dict([('InitiatingMessage', _mCBearerContextModificationRequired_val_InitiatingMessage), ('SuccessfulOutcome', _mCBearerContextModificationRequired_val_SuccessfulOutcome), ('procedureCode', 36), ('criticality', 'reject')])
    
    #-----< mCBearerContextRelease >-----#
    mCBearerContextRelease = CLASS(name='mCBearerContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _mCBearerContextRelease_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextReleaseCommand')))
    _mCBearerContextRelease_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextReleaseComplete')))
    mCBearerContextRelease._val = dict([('InitiatingMessage', _mCBearerContextRelease_val_InitiatingMessage), ('SuccessfulOutcome', _mCBearerContextRelease_val_SuccessfulOutcome), ('procedureCode', 37), ('criticality', 'reject')])
    
    #-----< mCBearerContextReleaseRequest >-----#
    mCBearerContextReleaseRequest = CLASS(name='mCBearerContextReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('E1AP-PDU-Descriptions', 'E1AP-ELEMENTARY-PROCEDURE')))
    _mCBearerContextReleaseRequest_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('E1AP-PDU-Contents', 'MCBearerContextReleaseRequest')))
    mCBearerContextReleaseRequest._val = dict([('InitiatingMessage', _mCBearerContextReleaseRequest_val_InitiatingMessage), ('procedureCode', 38), ('criticality', 'reject')])
    
    _all_ = [
        _E1AP_ELEMENTARY_PROCEDURE_InitiatingMessage,
        _E1AP_ELEMENTARY_PROCEDURE_SuccessfulOutcome,
        _E1AP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome,
        _E1AP_ELEMENTARY_PROCEDURE_procedureCode,
        _E1AP_ELEMENTARY_PROCEDURE_criticality,
        E1AP_ELEMENTARY_PROCEDURE,
        _E1AP_PDU_initiatingMessage,
        _E1AP_PDU_successfulOutcome,
        _E1AP_PDU_unsuccessfulOutcome,
        E1AP_PDU,
        __InitiatingMessage_procedureCode_tab,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_10,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_11,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_12,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_13,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_13,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_14,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_15,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_16,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_16,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_17,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_17,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_18,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_19,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38,
        _InitiatingMessage_procedureCode,
        _InitiatingMessage_criticality,
        _InitiatingMessage_value,
        InitiatingMessage,
        __SuccessfulOutcome_procedureCode_tab,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_17,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38,
        _SuccessfulOutcome_procedureCode,
        _SuccessfulOutcome_criticality,
        _SuccessfulOutcome_value,
        SuccessfulOutcome,
        __UnsuccessfulOutcome_procedureCode_tab,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_17,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38,
        _UnsuccessfulOutcome_procedureCode,
        _UnsuccessfulOutcome_criticality,
        _UnsuccessfulOutcome_value,
        UnsuccessfulOutcome,
        E1AP_ELEMENTARY_PROCEDURES,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0,
        _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1,
        _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1,
        _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2,
        _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2,
        _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3,
        _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3,
        _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4,
        _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4,
        _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5,
        _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6,
        _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6,
        _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7,
        _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7,
        _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8,
        _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9,
        _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10,
        _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10,
        _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_10,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11,
        _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11,
        _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12,
        _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12,
        _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13,
        _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13,
        _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14,
        _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15,
        _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16,
        _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_16,
        _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_16,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17,
        _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_17,
        _E1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_17,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18,
        _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_18,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19,
        _E1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_19,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37,
        _E1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38,
        E1AP_ELEMENTARY_PROCEDURES_CLASS_1,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_16,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_17,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19,
        E1AP_ELEMENTARY_PROCEDURES_CLASS_2,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17,
        _E1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18,
        reset,
        _reset_val_InitiatingMessage,
        _reset_val_SuccessfulOutcome,
        errorIndication,
        _errorIndication_val_InitiatingMessage,
        gNB_CU_UP_E1Setup,
        _gNB_CU_UP_E1Setup_val_InitiatingMessage,
        _gNB_CU_UP_E1Setup_val_SuccessfulOutcome,
        _gNB_CU_UP_E1Setup_val_UnsuccessfulOutcome,
        gNB_CU_CP_E1Setup,
        _gNB_CU_CP_E1Setup_val_InitiatingMessage,
        _gNB_CU_CP_E1Setup_val_SuccessfulOutcome,
        _gNB_CU_CP_E1Setup_val_UnsuccessfulOutcome,
        gNB_CU_UP_ConfigurationUpdate,
        _gNB_CU_UP_ConfigurationUpdate_val_InitiatingMessage,
        _gNB_CU_UP_ConfigurationUpdate_val_SuccessfulOutcome,
        _gNB_CU_UP_ConfigurationUpdate_val_UnsuccessfulOutcome,
        gNB_CU_CP_ConfigurationUpdate,
        _gNB_CU_CP_ConfigurationUpdate_val_InitiatingMessage,
        _gNB_CU_CP_ConfigurationUpdate_val_SuccessfulOutcome,
        _gNB_CU_CP_ConfigurationUpdate_val_UnsuccessfulOutcome,
        e1Release,
        _e1Release_val_InitiatingMessage,
        _e1Release_val_SuccessfulOutcome,
        bearerContextSetup,
        _bearerContextSetup_val_InitiatingMessage,
        _bearerContextSetup_val_SuccessfulOutcome,
        _bearerContextSetup_val_UnsuccessfulOutcome,
        bearerContextModification,
        _bearerContextModification_val_InitiatingMessage,
        _bearerContextModification_val_SuccessfulOutcome,
        _bearerContextModification_val_UnsuccessfulOutcome,
        bearerContextModificationRequired,
        _bearerContextModificationRequired_val_InitiatingMessage,
        _bearerContextModificationRequired_val_SuccessfulOutcome,
        bearerContextRelease,
        _bearerContextRelease_val_InitiatingMessage,
        _bearerContextRelease_val_SuccessfulOutcome,
        bearerContextReleaseRequest,
        _bearerContextReleaseRequest_val_InitiatingMessage,
        bearerContextInactivityNotification,
        _bearerContextInactivityNotification_val_InitiatingMessage,
        dLDataNotification,
        _dLDataNotification_val_InitiatingMessage,
        uLDataNotification,
        _uLDataNotification_val_InitiatingMessage,
        dataUsageReport,
        _dataUsageReport_val_InitiatingMessage,
        gNB_CU_UP_CounterCheck,
        _gNB_CU_UP_CounterCheck_val_InitiatingMessage,
        gNB_CU_UP_StatusIndication,
        _gNB_CU_UP_StatusIndication_val_InitiatingMessage,
        privateMessage,
        _privateMessage_val_InitiatingMessage,
        gNB_CU_CPMeasurementResultsInformation,
        _gNB_CU_CPMeasurementResultsInformation_val_InitiatingMessage,
        mRDC_DataUsageReport,
        _mRDC_DataUsageReport_val_InitiatingMessage,
        deactivateTrace,
        _deactivateTrace_val_InitiatingMessage,
        traceStart,
        _traceStart_val_InitiatingMessage,
        resourceStatusReportingInitiation,
        _resourceStatusReportingInitiation_val_InitiatingMessage,
        _resourceStatusReportingInitiation_val_SuccessfulOutcome,
        _resourceStatusReportingInitiation_val_UnsuccessfulOutcome,
        resourceStatusReporting,
        _resourceStatusReporting_val_InitiatingMessage,
        iAB_UPTNLAddressUpdate,
        _iAB_UPTNLAddressUpdate_val_InitiatingMessage,
        _iAB_UPTNLAddressUpdate_val_SuccessfulOutcome,
        _iAB_UPTNLAddressUpdate_val_UnsuccessfulOutcome,
        cellTrafficTrace,
        _cellTrafficTrace_val_InitiatingMessage,
        earlyForwardingSNTransfer,
        _earlyForwardingSNTransfer_val_InitiatingMessage,
        iABPSKNotification,
        _iABPSKNotification_val_InitiatingMessage,
        bCBearerContextSetup,
        _bCBearerContextSetup_val_InitiatingMessage,
        _bCBearerContextSetup_val_SuccessfulOutcome,
        _bCBearerContextSetup_val_UnsuccessfulOutcome,
        bCBearerContextModification,
        _bCBearerContextModification_val_InitiatingMessage,
        _bCBearerContextModification_val_SuccessfulOutcome,
        _bCBearerContextModification_val_UnsuccessfulOutcome,
        bCBearerContextModificationRequired,
        _bCBearerContextModificationRequired_val_InitiatingMessage,
        _bCBearerContextModificationRequired_val_SuccessfulOutcome,
        bCBearerContextRelease,
        _bCBearerContextRelease_val_InitiatingMessage,
        _bCBearerContextRelease_val_SuccessfulOutcome,
        bCBearerContextReleaseRequest,
        _bCBearerContextReleaseRequest_val_InitiatingMessage,
        mCBearerContextSetup,
        _mCBearerContextSetup_val_InitiatingMessage,
        _mCBearerContextSetup_val_SuccessfulOutcome,
        _mCBearerContextSetup_val_UnsuccessfulOutcome,
        mCBearerContextModification,
        _mCBearerContextModification_val_InitiatingMessage,
        _mCBearerContextModification_val_SuccessfulOutcome,
        _mCBearerContextModification_val_UnsuccessfulOutcome,
        mCBearerContextModificationRequired,
        _mCBearerContextModificationRequired_val_InitiatingMessage,
        _mCBearerContextModificationRequired_val_SuccessfulOutcome,
        mCBearerContextRelease,
        _mCBearerContextRelease_val_InitiatingMessage,
        _mCBearerContextRelease_val_SuccessfulOutcome,
        mCBearerContextReleaseRequest,
        _mCBearerContextReleaseRequest_val_InitiatingMessage,
    ]

init_modules(E1AP_CommonDataTypes, E1AP_Constants, E1AP_Containers, E1AP_IEs, E1AP_PDU_Contents, E1AP_PDU_Descriptions)
