# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class F1AP_CommonDataTypes:

    _name_  = 'F1AP-CommonDataTypes'
    _oid_   = [0, 4, 0, 0, 22, 3, 3, 1, 3]
    
    _obj_ = [
        'Criticality',
        'Presence',
        'PrivateIE-ID',
        'ProcedureCode',
        'ProtocolExtensionID',
        'ProtocolIE-ID',
        'TriggeringMessage',
        ]
    _type_ = [
        'Criticality',
        'Presence',
        'PrivateIE-ID',
        'ProcedureCode',
        'ProtocolExtensionID',
        'ProtocolIE-ID',
        'TriggeringMessage',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< Criticality >-----#
    Criticality = ENUM(name='Criticality', mode=MODE_TYPE)
    Criticality._cont = ASN1Dict([('reject', 0), ('ignore', 1), ('notify', 2)])
    Criticality._ext = None
    
    #-----< Presence >-----#
    Presence = ENUM(name='Presence', mode=MODE_TYPE)
    Presence._cont = ASN1Dict([('optional', 0), ('conditional', 1), ('mandatory', 2)])
    Presence._ext = None
    
    #-----< PrivateIE-ID >-----#
    PrivateIE_ID = CHOICE(name='PrivateIE-ID', mode=MODE_TYPE)
    _PrivateIE_ID_local = INT(name='local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrivateIE_ID_local._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PrivateIE_ID_global_ = OID(name='global', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    PrivateIE_ID._cont = ASN1Dict([
        ('local', _PrivateIE_ID_local),
        ('global', _PrivateIE_ID_global_),
        ])
    PrivateIE_ID._ext = None
    
    #-----< ProcedureCode >-----#
    ProcedureCode = INT(name='ProcedureCode', mode=MODE_TYPE)
    ProcedureCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ProtocolExtensionID >-----#
    ProtocolExtensionID = INT(name='ProtocolExtensionID', mode=MODE_TYPE)
    ProtocolExtensionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< ProtocolIE-ID >-----#
    ProtocolIE_ID = INT(name='ProtocolIE-ID', mode=MODE_TYPE)
    ProtocolIE_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TriggeringMessage >-----#
    TriggeringMessage = ENUM(name='TriggeringMessage', mode=MODE_TYPE)
    TriggeringMessage._cont = ASN1Dict([('initiating-message', 0), ('successful-outcome', 1), ('unsuccessful-outcome', 2)])
    TriggeringMessage._ext = None
    
    _all_ = [
        Criticality,
        Presence,
        _PrivateIE_ID_local,
        _PrivateIE_ID_global_,
        PrivateIE_ID,
        ProcedureCode,
        ProtocolExtensionID,
        ProtocolIE_ID,
        TriggeringMessage,
    ]

class F1AP_Constants:

    _name_  = 'F1AP-Constants'
    _oid_   = [0, 4, 0, 0, 22, 3, 3, 1, 4]
    
    _obj_ = [
        'id-Reset',
        'id-F1Setup',
        'id-ErrorIndication',
        'id-gNBDUConfigurationUpdate',
        'id-gNBCUConfigurationUpdate',
        'id-UEContextSetup',
        'id-UEContextRelease',
        'id-UEContextModification',
        'id-UEContextModificationRequired',
        'id-UEMobilityCommand',
        'id-UEContextReleaseRequest',
        'id-InitialULRRCMessageTransfer',
        'id-DLRRCMessageTransfer',
        'id-ULRRCMessageTransfer',
        'id-privateMessage',
        'id-UEInactivityNotification',
        'id-GNBDUResourceCoordination',
        'id-SystemInformationDeliveryCommand',
        'id-Paging',
        'id-Notify',
        'id-WriteReplaceWarning',
        'id-PWSCancel',
        'id-PWSRestartIndication',
        'id-PWSFailureIndication',
        'id-GNBDUStatusIndication',
        'id-RRCDeliveryReport',
        'id-F1Removal',
        'id-NetworkAccessRateReduction',
        'id-TraceStart',
        'id-DeactivateTrace',
        'id-DUCURadioInformationTransfer',
        'id-CUDURadioInformationTransfer',
        'id-BAPMappingConfiguration',
        'id-GNBDUResourceConfiguration',
        'id-IABTNLAddressAllocation',
        'id-IABUPConfigurationUpdate',
        'id-resourceStatusReportingInitiation',
        'id-resourceStatusReporting',
        'id-accessAndMobilityIndication',
        'id-accessSuccess',
        'id-cellTrafficTrace',
        'id-PositioningMeasurementExchange',
        'id-PositioningAssistanceInformationControl',
        'id-PositioningAssistanceInformationFeedback',
        'id-PositioningMeasurementReport',
        'id-PositioningMeasurementAbort',
        'id-PositioningMeasurementFailureIndication',
        'id-PositioningMeasurementUpdate',
        'id-TRPInformationExchange',
        'id-PositioningInformationExchange',
        'id-PositioningActivation',
        'id-PositioningDeactivation',
        'id-E-CIDMeasurementInitiation',
        'id-E-CIDMeasurementFailureIndication',
        'id-E-CIDMeasurementReport',
        'id-E-CIDMeasurementTermination',
        'id-PositioningInformationUpdate',
        'id-ReferenceTimeInformationReport',
        'id-ReferenceTimeInformationReportingControl',
        'id-BroadcastContextSetup',
        'id-BroadcastContextRelease',
        'id-BroadcastContextReleaseRequest',
        'id-BroadcastContextModification',
        'id-MulticastGroupPaging',
        'id-MulticastContextSetup',
        'id-MulticastContextRelease',
        'id-MulticastContextReleaseRequest',
        'id-MulticastContextModification',
        'id-MulticastDistributionSetup',
        'id-MulticastDistributionRelease',
        'id-PDCMeasurementInitiation',
        'id-PDCMeasurementReport',
        'id-PDCMeasurementInitiationRequest',
        'id-PDCMeasurementInitiationResponse',
        'id-PDCMeasurementInitiationFailure',
        'id-pRSConfigurationExchange',
        'id-measurementPreconfiguration',
        'id-measurementActivation',
        'id-QoEInformationTransfer',
        'id-PDCMeasurementTerminationCommand',
        'id-PDCMeasurementFailureIndication',
        'id-PosSystemInformationDeliveryCommand',
        'maxPrivateIEs',
        'maxProtocolExtensions',
        'maxProtocolIEs',
        'maxNRARFCN',
        'maxnoofErrors',
        'maxnoofIndividualF1ConnectionsToReset',
        'maxCellingNBDU',
        'maxnoofSCells',
        'maxnoofSRBs',
        'maxnoofDRBs',
        'maxnoofULUPTNLInformation',
        'maxnoofDLUPTNLInformation',
        'maxnoofBPLMNs',
        'maxnoofCandidateSpCells',
        'maxnoofPotentialSpCells',
        'maxnoofNrCellBands',
        'maxnoofSIBTypes',
        'maxnoofSITypes',
        'maxnoofPagingCells',
        'maxnoofTNLAssociations',
        'maxnoofQoSFlows',
        'maxnoofSliceItems',
        'maxCellineNB',
        'maxnoofExtendedBPLMNs',
        'maxnoofUEIDs',
        'maxnoofBPLMNsNR',
        'maxnoofUACPLMNs',
        'maxnoofUACperPLMN',
        'maxnoofAdditionalSIBs',
        'maxnoofslots',
        'maxnoofTLAs',
        'maxnoofGTPTLAs',
        'maxnoofBHRLCChannels',
        'maxnoofRoutingEntries',
        'maxnoofIABSTCInfo',
        'maxnoofSymbols',
        'maxnoofServingCells',
        'maxnoofDUFSlots',
        'maxnoofHSNASlots',
        'maxnoofServedCellsIAB',
        'maxnoofChildIABNodes',
        'maxnoofNonUPTrafficMappings',
        'maxnoofTLAsIAB',
        'maxnoofMappingEntries',
        'maxnoofDSInfo',
        'maxnoofEgressLinks',
        'maxnoofULUPTNLInformationforIAB',
        'maxnoofUPTNLAddresses',
        'maxnoofSLDRBs',
        'maxnoofQoSParaSets',
        'maxnoofPC5QoSFlows',
        'maxnoofSSBAreas',
        'maxnoofPhysicalResourceBlocks',
        'maxnoofPhysicalResourceBlocks-1',
        'maxnoofPRACHconfigs',
        'maxnoofRACHReports',
        'maxnoofRLFReports',
        'maxnoofAdditionalPDCPDuplicationTNL',
        'maxnoofRLCDuplicationState',
        'maxnoofCHOcells',
        'maxnoofMDTPLMNs',
        'maxnoofCAGsupported',
        'maxnoofNIDsupported',
        'maxnoofNRSCSs',
        'maxnoofExtSliceItems',
        'maxnoofPosMeas',
        'maxnoofTRPInfoTypes',
        'maxnoofTRPs',
        'maxnoofSRSTriggerStates',
        'maxnoofSpatialRelations',
        'maxnoBcastCell',
        'maxnoofAngleInfo',
        'maxnooflcs-gcs-translation',
        'maxnoofPath',
        'maxnoofMeasE-CID',
        'maxnoofSSBs',
        'maxnoSRS-ResourceSets',
        'maxnoSRS-ResourcePerSet',
        'maxnoSRS-Carriers',
        'maxnoSCSs',
        'maxnoSRS-Resources',
        'maxnoSRS-PosResources',
        'maxnoSRS-PosResourceSets',
        'maxnoSRS-PosResourcePerSet',
        'maxnoofPRS-ResourceSets',
        'maxnoofPRS-ResourcesPerSet',
        'maxNoOfMeasTRPs',
        'maxnoofPRSresourceSets',
        'maxnoofPRSresources',
        'maxnoofSuccessfulHOReports',
        'maxnoofNR-UChannelIDs',
        'maxServedCellforSON',
        'maxNeighbourCellforSON',
        'maxAffectedCells',
        'maxnoofMRBs',
        'maxnoofMBSQoSFlows',
        'maxnoofMBSFSAs',
        'maxnoofUEIDforPaging',
        'maxnoofCellsforMBS',
        'maxnoofTAIforMBS',
        'maxnoofMBSAreaSessionIDs',
        'maxnoofMBSServiceAreaInformation',
        'maxnoofIABCongInd',
        'maxnoofNeighbourNodeCellsIAB',
        'maxnoofRBsetsPerCell',
        'maxnoofRBsetsPerCell-1',
        'maxnoofMeasPDC',
        'maxnoARPs',
        'maxnoofULAoAs',
        'maxNoPathExtended',
        'maxnoTRPTEGs',
        'maxFreqLayers',
        'maxNumResourcesPerAngle',
        'maxnoAzimuthAngles',
        'maxnoElevationAngles',
        'maxnoofPRSTRPs',
        'maxnoofQoEInformation',
        'maxnoofUuRLCChannels',
        'maxnoofPC5RLCChannels',
        'maxnoofSMBRValues',
        'maxnoofMRBsforUE',
        'maxnoofMBSSessionsofUE',
        'maxnoofSLdestinations',
        'maxnoofNSAGs',
        'maxnoofSDTBearers',
        'maxnoofServingCellMOs',
        'maxNrofBWPs',
        'maxnoofPosSITypes',
        'id-Cause',
        'id-Cells-Failed-to-be-Activated-List',
        'id-Cells-Failed-to-be-Activated-List-Item',
        'id-Cells-to-be-Activated-List',
        'id-Cells-to-be-Activated-List-Item',
        'id-Cells-to-be-Deactivated-List',
        'id-Cells-to-be-Deactivated-List-Item',
        'id-CriticalityDiagnostics',
        'id-CUtoDURRCInformation',
        'id-DRBs-FailedToBeModified-Item',
        'id-DRBs-FailedToBeModified-List',
        'id-DRBs-FailedToBeSetup-Item',
        'id-DRBs-FailedToBeSetup-List',
        'id-DRBs-FailedToBeSetupMod-Item',
        'id-DRBs-FailedToBeSetupMod-List',
        'id-DRBs-ModifiedConf-Item',
        'id-DRBs-ModifiedConf-List',
        'id-DRBs-Modified-Item',
        'id-DRBs-Modified-List',
        'id-DRBs-Required-ToBeModified-Item',
        'id-DRBs-Required-ToBeModified-List',
        'id-DRBs-Required-ToBeReleased-Item',
        'id-DRBs-Required-ToBeReleased-List',
        'id-DRBs-Setup-Item',
        'id-DRBs-Setup-List',
        'id-DRBs-SetupMod-Item',
        'id-DRBs-SetupMod-List',
        'id-DRBs-ToBeModified-Item',
        'id-DRBs-ToBeModified-List',
        'id-DRBs-ToBeReleased-Item',
        'id-DRBs-ToBeReleased-List',
        'id-DRBs-ToBeSetup-Item',
        'id-DRBs-ToBeSetup-List',
        'id-DRBs-ToBeSetupMod-Item',
        'id-DRBs-ToBeSetupMod-List',
        'id-DRXCycle',
        'id-DUtoCURRCInformation',
        'id-gNB-CU-UE-F1AP-ID',
        'id-gNB-DU-UE-F1AP-ID',
        'id-gNB-DU-ID',
        'id-GNB-DU-Served-Cells-Item',
        'id-gNB-DU-Served-Cells-List',
        'id-gNB-DU-Name',
        'id-NRCellID',
        'id-oldgNB-DU-UE-F1AP-ID',
        'id-ResetType',
        'id-ResourceCoordinationTransferContainer',
        'id-RRCContainer',
        'id-SCell-ToBeRemoved-Item',
        'id-SCell-ToBeRemoved-List',
        'id-SCell-ToBeSetup-Item',
        'id-SCell-ToBeSetup-List',
        'id-SCell-ToBeSetupMod-Item',
        'id-SCell-ToBeSetupMod-List',
        'id-Served-Cells-To-Add-Item',
        'id-Served-Cells-To-Add-List',
        'id-Served-Cells-To-Delete-Item',
        'id-Served-Cells-To-Delete-List',
        'id-Served-Cells-To-Modify-Item',
        'id-Served-Cells-To-Modify-List',
        'id-SpCell-ID',
        'id-SRBID',
        'id-SRBs-FailedToBeSetup-Item',
        'id-SRBs-FailedToBeSetup-List',
        'id-SRBs-FailedToBeSetupMod-Item',
        'id-SRBs-FailedToBeSetupMod-List',
        'id-SRBs-Required-ToBeReleased-Item',
        'id-SRBs-Required-ToBeReleased-List',
        'id-SRBs-ToBeReleased-Item',
        'id-SRBs-ToBeReleased-List',
        'id-SRBs-ToBeSetup-Item',
        'id-SRBs-ToBeSetup-List',
        'id-SRBs-ToBeSetupMod-Item',
        'id-SRBs-ToBeSetupMod-List',
        'id-TimeToWait',
        'id-TransactionID',
        'id-TransmissionActionIndicator',
        'id-UE-associatedLogicalF1-ConnectionItem',
        'id-UE-associatedLogicalF1-ConnectionListResAck',
        'id-gNB-CU-Name',
        'id-SCell-FailedtoSetup-List',
        'id-SCell-FailedtoSetup-Item',
        'id-SCell-FailedtoSetupMod-List',
        'id-SCell-FailedtoSetupMod-Item',
        'id-RRCReconfigurationCompleteIndicator',
        'id-Cells-Status-Item',
        'id-Cells-Status-List',
        'id-Candidate-SpCell-List',
        'id-Candidate-SpCell-Item',
        'id-Potential-SpCell-List',
        'id-Potential-SpCell-Item',
        'id-FullConfiguration',
        'id-C-RNTI',
        'id-SpCellULConfigured',
        'id-InactivityMonitoringRequest',
        'id-InactivityMonitoringResponse',
        'id-DRB-Activity-Item',
        'id-DRB-Activity-List',
        'id-EUTRA-NR-CellResourceCoordinationReq-Container',
        'id-EUTRA-NR-CellResourceCoordinationReqAck-Container',
        'id-Protected-EUTRA-Resources-List',
        'id-RequestType',
        'id-ServCellIndex',
        'id-RAT-FrequencyPriorityInformation',
        'id-ExecuteDuplication',
        'id-NRCGI',
        'id-PagingCell-Item',
        'id-PagingCell-List',
        'id-PagingDRX',
        'id-PagingPriority',
        'id-SItype-List',
        'id-UEIdentityIndexValue',
        'id-gNB-CUSystemInformation',
        'id-HandoverPreparationInformation',
        'id-GNB-CU-TNL-Association-To-Add-Item',
        'id-GNB-CU-TNL-Association-To-Add-List',
        'id-GNB-CU-TNL-Association-To-Remove-Item',
        'id-GNB-CU-TNL-Association-To-Remove-List',
        'id-GNB-CU-TNL-Association-To-Update-Item',
        'id-GNB-CU-TNL-Association-To-Update-List',
        'id-MaskedIMEISV',
        'id-PagingIdentity',
        'id-DUtoCURRCContainer',
        'id-Cells-to-be-Barred-List',
        'id-Cells-to-be-Barred-Item',
        'id-TAISliceSupportList',
        'id-GNB-CU-TNL-Association-Setup-List',
        'id-GNB-CU-TNL-Association-Setup-Item',
        'id-GNB-CU-TNL-Association-Failed-To-Setup-List',
        'id-GNB-CU-TNL-Association-Failed-To-Setup-Item',
        'id-DRB-Notify-Item',
        'id-DRB-Notify-List',
        'id-NotficationControl',
        'id-RANAC',
        'id-PWSSystemInformation',
        'id-RepetitionPeriod',
        'id-NumberofBroadcastRequest',
        'id-Cells-To-Be-Broadcast-List',
        'id-Cells-To-Be-Broadcast-Item',
        'id-Cells-Broadcast-Completed-List',
        'id-Cells-Broadcast-Completed-Item',
        'id-Broadcast-To-Be-Cancelled-List',
        'id-Broadcast-To-Be-Cancelled-Item',
        'id-Cells-Broadcast-Cancelled-List',
        'id-Cells-Broadcast-Cancelled-Item',
        'id-NR-CGI-List-For-Restart-List',
        'id-NR-CGI-List-For-Restart-Item',
        'id-PWS-Failed-NR-CGI-List',
        'id-PWS-Failed-NR-CGI-Item',
        'id-ConfirmedUEID',
        'id-Cancel-all-Warning-Messages-Indicator',
        'id-GNB-DU-UE-AMBR-UL',
        'id-DRXConfigurationIndicator',
        'id-RLC-Status',
        'id-DLPDCPSNLength',
        'id-GNB-DUConfigurationQuery',
        'id-MeasurementTimingConfiguration',
        'id-DRB-Information',
        'id-ServingPLMN',
        'id-Protected-EUTRA-Resources-Item',
        'id-GNB-CU-RRC-Version',
        'id-GNB-DU-RRC-Version',
        'id-GNBDUOverloadInformation',
        'id-CellGroupConfig',
        'id-RLCFailureIndication',
        'id-UplinkTxDirectCurrentListInformation',
        'id-DC-Based-Duplication-Configured',
        'id-DC-Based-Duplication-Activation',
        'id-SULAccessIndication',
        'id-AvailablePLMNList',
        'id-PDUSessionID',
        'id-ULPDUSessionAggregateMaximumBitRate',
        'id-ServingCellMO',
        'id-QoSFlowMappingIndication',
        'id-RRCDeliveryStatusRequest',
        'id-RRCDeliveryStatus',
        'id-BearerTypeChange',
        'id-RLCMode',
        'id-Duplication-Activation',
        'id-Dedicated-SIDelivery-NeededUE-List',
        'id-Dedicated-SIDelivery-NeededUE-Item',
        'id-DRX-LongCycleStartOffset',
        'id-ULPDCPSNLength',
        'id-SelectedBandCombinationIndex',
        'id-SelectedFeatureSetEntryIndex',
        'id-ResourceCoordinationTransferInformation',
        'id-ExtendedServedPLMNs-List',
        'id-ExtendedAvailablePLMN-List',
        'id-Associated-SCell-List',
        'id-latest-RRC-Version-Enhanced',
        'id-Associated-SCell-Item',
        'id-Cell-Direction',
        'id-SRBs-Setup-List',
        'id-SRBs-Setup-Item',
        'id-SRBs-SetupMod-List',
        'id-SRBs-SetupMod-Item',
        'id-SRBs-Modified-List',
        'id-SRBs-Modified-Item',
        'id-Ph-InfoSCG',
        'id-RequestedBandCombinationIndex',
        'id-RequestedFeatureSetEntryIndex',
        'id-RequestedP-MaxFR2',
        'id-DRX-Config',
        'id-IgnoreResourceCoordinationContainer',
        'id-UEAssistanceInformation',
        'id-NeedforGap',
        'id-PagingOrigin',
        'id-new-gNB-CU-UE-F1AP-ID',
        'id-RedirectedRRCmessage',
        'id-new-gNB-DU-UE-F1AP-ID',
        'id-NotificationInformation',
        'id-PLMNAssistanceInfoForNetShar',
        'id-UEContextNotRetrievable',
        'id-BPLMN-ID-Info-List',
        'id-SelectedPLMNID',
        'id-UAC-Assistance-Info',
        'id-RANUEID',
        'id-GNB-DU-TNL-Association-To-Remove-Item',
        'id-GNB-DU-TNL-Association-To-Remove-List',
        'id-TNLAssociationTransportLayerAddressgNBDU',
        'id-portNumber',
        'id-AdditionalSIBMessageList',
        'id-Cell-Type',
        'id-IgnorePRACHConfiguration',
        'id-CG-Config',
        'id-PDCCH-BlindDetectionSCG',
        'id-Requested-PDCCH-BlindDetectionSCG',
        'id-Ph-InfoMCG',
        'id-MeasGapSharingConfig',
        'id-systemInformationAreaID',
        'id-areaScope',
        'id-RRCContainer-RRCSetupComplete',
        'id-TraceActivation',
        'id-TraceID',
        'id-Neighbour-Cell-Information-List',
        'id-SymbolAllocInSlot',
        'id-NumDLULSymbols',
        'id-AdditionalRRMPriorityIndex',
        'id-DUCURadioInformationType',
        'id-CUDURadioInformationType',
        'id-AggressorgNBSetID',
        'id-VictimgNBSetID',
        'id-LowerLayerPresenceStatusChange',
        'id-Transport-Layer-Address-Info',
        'id-Neighbour-Cell-Information-Item',
        'id-IntendedTDD-DL-ULConfig',
        'id-QosMonitoringRequest',
        'id-BHChannels-ToBeSetup-List',
        'id-BHChannels-ToBeSetup-Item',
        'id-BHChannels-Setup-List',
        'id-BHChannels-Setup-Item',
        'id-BHChannels-ToBeModified-Item',
        'id-BHChannels-ToBeModified-List',
        'id-BHChannels-ToBeReleased-Item',
        'id-BHChannels-ToBeReleased-List',
        'id-BHChannels-ToBeSetupMod-Item',
        'id-BHChannels-ToBeSetupMod-List',
        'id-BHChannels-FailedToBeModified-Item',
        'id-BHChannels-FailedToBeModified-List',
        'id-BHChannels-FailedToBeSetupMod-Item',
        'id-BHChannels-FailedToBeSetupMod-List',
        'id-BHChannels-Modified-Item',
        'id-BHChannels-Modified-List',
        'id-BHChannels-SetupMod-Item',
        'id-BHChannels-SetupMod-List',
        'id-BHChannels-Required-ToBeReleased-Item',
        'id-BHChannels-Required-ToBeReleased-List',
        'id-BHChannels-FailedToBeSetup-Item',
        'id-BHChannels-FailedToBeSetup-List',
        'id-BHInfo',
        'id-BAPAddress',
        'id-ConfiguredBAPAddress',
        'id-BH-Routing-Information-Added-List',
        'id-BH-Routing-Information-Added-List-Item',
        'id-BH-Routing-Information-Removed-List',
        'id-BH-Routing-Information-Removed-List-Item',
        'id-UL-BH-Non-UP-Traffic-Mapping',
        'id-Activated-Cells-to-be-Updated-List',
        'id-Child-Nodes-List',
        'id-IAB-Info-IAB-DU',
        'id-IAB-Info-IAB-donor-CU',
        'id-IAB-TNL-Addresses-To-Remove-List',
        'id-IAB-TNL-Addresses-To-Remove-Item',
        'id-IAB-Allocated-TNL-Address-List',
        'id-IAB-Allocated-TNL-Address-Item',
        'id-IABIPv6RequestType',
        'id-IABv4AddressesRequested',
        'id-IAB-Barred',
        'id-TrafficMappingInformation',
        'id-UL-UP-TNL-Information-to-Update-List',
        'id-UL-UP-TNL-Information-to-Update-List-Item',
        'id-UL-UP-TNL-Address-to-Update-List',
        'id-UL-UP-TNL-Address-to-Update-List-Item',
        'id-DL-UP-TNL-Address-to-Update-List',
        'id-DL-UP-TNL-Address-to-Update-List-Item',
        'id-NRV2XServicesAuthorized',
        'id-LTEV2XServicesAuthorized',
        'id-NRUESidelinkAggregateMaximumBitrate',
        'id-LTEUESidelinkAggregateMaximumBitrate',
        'id-SIB12-message',
        'id-SIB13-message',
        'id-SIB14-message',
        'id-SLDRBs-FailedToBeModified-Item',
        'id-SLDRBs-FailedToBeModified-List',
        'id-SLDRBs-FailedToBeSetup-Item',
        'id-SLDRBs-FailedToBeSetup-List',
        'id-SLDRBs-Modified-Item',
        'id-SLDRBs-Modified-List',
        'id-SLDRBs-Required-ToBeModified-Item',
        'id-SLDRBs-Required-ToBeModified-List',
        'id-SLDRBs-Required-ToBeReleased-Item',
        'id-SLDRBs-Required-ToBeReleased-List',
        'id-SLDRBs-Setup-Item',
        'id-SLDRBs-Setup-List',
        'id-SLDRBs-ToBeModified-Item',
        'id-SLDRBs-ToBeModified-List',
        'id-SLDRBs-ToBeReleased-Item',
        'id-SLDRBs-ToBeReleased-List',
        'id-SLDRBs-ToBeSetup-Item',
        'id-SLDRBs-ToBeSetup-List',
        'id-SLDRBs-ToBeSetupMod-Item',
        'id-SLDRBs-ToBeSetupMod-List',
        'id-SLDRBs-SetupMod-List',
        'id-SLDRBs-FailedToBeSetupMod-List',
        'id-SLDRBs-SetupMod-Item',
        'id-SLDRBs-FailedToBeSetupMod-Item',
        'id-SLDRBs-ModifiedConf-List',
        'id-SLDRBs-ModifiedConf-Item',
        'id-UEAssistanceInformationEUTRA',
        'id-PC5LinkAMBR',
        'id-SL-PHY-MAC-RLC-Config',
        'id-SL-ConfigDedicatedEUTRA-Info',
        'id-AlternativeQoSParaSetList',
        'id-CurrentQoSParaSetIndex',
        'id-gNBCUMeasurementID',
        'id-gNBDUMeasurementID',
        'id-RegistrationRequest',
        'id-ReportCharacteristics',
        'id-CellToReportList',
        'id-CellMeasurementResultList',
        'id-HardwareLoadIndicator',
        'id-ReportingPeriodicity',
        'id-TNLCapacityIndicator',
        'id-CarrierList',
        'id-ULCarrierList',
        'id-FrequencyShift7p5khz',
        'id-SSB-PositionsInBurst',
        'id-NRPRACHConfig',
        'id-RACHReportInformationList',
        'id-RLFReportInformationList',
        'id-TDD-UL-DLConfigCommonNR',
        'id-CNPacketDelayBudgetDownlink',
        'id-ExtendedPacketDelayBudget',
        'id-TSCTrafficCharacteristics',
        'id-ReportingRequestType',
        'id-TimeReferenceInformation',
        'id-CNPacketDelayBudgetUplink',
        'id-AdditionalPDCPDuplicationTNL-List',
        'id-RLCDuplicationInformation',
        'id-AdditionalDuplicationIndication',
        'id-ConditionalInterDUMobilityInformation',
        'id-ConditionalIntraDUMobilityInformation',
        'id-targetCellsToCancel',
        'id-requestedTargetCellGlobalID',
        'id-ManagementBasedMDTPLMNList',
        'id-TraceCollectionEntityIPAddress',
        'id-PrivacyIndicator',
        'id-TraceCollectionEntityURI',
        'id-mdtConfiguration',
        'id-ServingNID',
        'id-NPNBroadcastInformation',
        'id-NPNSupportInfo',
        'id-NID',
        'id-AvailableSNPN-ID-List',
        'id-SIB10-message',
        'id-DLCarrierList',
        'id-ExtendedTAISliceSupportList',
        'id-RequestedSRSTransmissionCharacteristics',
        'id-PosAssistance-Information',
        'id-PosBroadcast',
        'id-RoutingID',
        'id-PosAssistanceInformationFailureList',
        'id-PosMeasurementQuantities',
        'id-PosMeasurementResultList',
        'id-TRPInformationTypeListTRPReq',
        'id-TRPInformationTypeItem',
        'id-TRPInformationListTRPResp',
        'id-TRPInformationItem',
        'id-LMF-MeasurementID',
        'id-SRSType',
        'id-ActivationTime',
        'id-AbortTransmission',
        'id-PositioningBroadcastCells',
        'id-SRSConfiguration',
        'id-PosReportCharacteristics',
        'id-PosMeasurementPeriodicity',
        'id-TRPList',
        'id-RAN-MeasurementID',
        'id-LMF-UE-MeasurementID',
        'id-RAN-UE-MeasurementID',
        'id-E-CID-MeasurementQuantities',
        'id-E-CID-MeasurementQuantities-Item',
        'id-E-CID-MeasurementPeriodicity',
        'id-E-CID-MeasurementResult',
        'id-Cell-Portion-ID',
        'id-SFNInitialisationTime',
        'id-SystemFrameNumber',
        'id-SlotNumber',
        'id-TRP-MeasurementRequestList',
        'id-MeasurementBeamInfoRequest',
        'id-E-CID-ReportCharacteristics',
        'id-ConfiguredTACIndication',
        'id-Extended-GNB-CU-Name',
        'id-Extended-GNB-DU-Name',
        'id-F1CTransferPath',
        'id-SFN-Offset',
        'id-TransmissionStopIndicator',
        'id-SrsFrequency',
        'id-SCGIndicator',
        'id-EstimatedArrivalProbability',
        'id-TRPType',
        'id-SRSSpatialRelationPerSRSResource',
        'id-PDCPTerminatingNodeDLTNLAddrInfo',
        'id-ENBDLTNLAddress',
        'id-PosMeasurementPeriodicityExtended',
        'id-PRS-Resource-ID',
        'id-LocationMeasurementInformation',
        'id-SliceRadioResourceStatus',
        'id-CompositeAvailableCapacity-SUL',
        'id-SuccessfulHOReportInformationList',
        'id-NR-U-Channel-List',
        'id-NR-U',
        'id-Coverage-Modification-Notification',
        'id-CCO-Assistance-Information',
        'id-Neighbor-node-CCO-Assistance-Information-List',
        'id-CellsForSON-List',
        'id-MIMOPRBusageInformation',
        'id-gNB-CU-MBS-F1AP-ID',
        'id-gNB-DU-MBS-F1AP-ID',
        'id-MBS-Area-Session-ID',
        'id-MBS-CUtoDURRCInformation',
        'id-MBS-Session-ID',
        'id-SNSSAI',
        'id-MBS-Broadcast-NeighbourCellList',
        'id-BroadcastMRBs-FailedToBeModified-List',
        'id-BroadcastMRBs-FailedToBeModified-Item',
        'id-BroadcastMRBs-FailedToBeSetup-List',
        'id-BroadcastMRBs-FailedToBeSetup-Item',
        'id-BroadcastMRBs-FailedToBeSetupMod-List',
        'id-BroadcastMRBs-FailedToBeSetupMod-Item',
        'id-BroadcastMRBs-Modified-List',
        'id-BroadcastMRBs-Modified-Item',
        'id-BroadcastMRBs-Setup-List',
        'id-BroadcastMRBs-Setup-Item',
        'id-BroadcastMRBs-SetupMod-List',
        'id-BroadcastMRBs-SetupMod-Item',
        'id-BroadcastMRBs-ToBeModified-List',
        'id-BroadcastMRBs-ToBeModified-Item',
        'id-BroadcastMRBs-ToBeReleased-List',
        'id-BroadcastMRBs-ToBeReleased-Item',
        'id-BroadcastMRBs-ToBeSetup-List',
        'id-BroadcastMRBs-ToBeSetup-Item',
        'id-BroadcastMRBs-ToBeSetupMod-List',
        'id-BroadcastMRBs-ToBeSetupMod-Item',
        'id-Supported-MBS-FSA-ID-List',
        'id-UEIdentity-List-For-Paging-List',
        'id-UEIdentity-List-For-Paging-Item',
        'id-MBS-ServiceArea',
        'id-MulticastMRBs-FailedToBeModified-List',
        'id-MulticastMRBs-FailedToBeModified-Item',
        'id-MulticastMRBs-FailedToBeSetup-List',
        'id-MulticastMRBs-FailedToBeSetup-Item',
        'id-MulticastMRBs-FailedToBeSetupMod-List',
        'id-MulticastMRBs-FailedToBeSetupMod-Item',
        'id-MulticastMRBs-Modified-List',
        'id-MulticastMRBs-Modified-Item',
        'id-MulticastMRBs-Setup-List',
        'id-MulticastMRBs-Setup-Item',
        'id-MulticastMRBs-SetupMod-List',
        'id-MulticastMRBs-SetupMod-Item',
        'id-MulticastMRBs-ToBeModified-List',
        'id-MulticastMRBs-ToBeModified-Item',
        'id-MulticastMRBs-ToBeReleased-List',
        'id-MulticastMRBs-ToBeReleased-Item',
        'id-MulticastMRBs-ToBeSetup-List',
        'id-MulticastMRBs-ToBeSetup-Item',
        'id-MulticastMRBs-ToBeSetupMod-List',
        'id-MulticastMRBs-ToBeSetupMod-Item',
        'id-MBSMulticastF1UContextDescriptor',
        'id-MulticastF1UContext-ToBeSetup-List',
        'id-MulticastF1UContext-ToBeSetup-Item',
        'id-MulticastF1UContext-Setup-List',
        'id-MulticastF1UContext-Setup-Item',
        'id-MulticastF1UContext-FailedToBeSetup-List',
        'id-MulticastF1UContext-FailedToBeSetup-Item',
        'id-IABCongestionIndication',
        'id-IABConditionalRRCMessageDeliveryIndication',
        'id-F1CTransferPathNRDC',
        'id-BufferSizeThresh',
        'id-IAB-TNL-Addresses-Exception',
        'id-BAP-Header-Rewriting-Added-List',
        'id-BAP-Header-Rewriting-Added-List-Item',
        'id-Re-routingEnableIndicator',
        'id-NonF1terminatingTopologyIndicator',
        'id-EgressNonF1terminatingTopologyIndicator',
        'id-IngressNonF1terminatingTopologyIndicator',
        'id-rBSetConfiguration',
        'id-frequency-Domain-HSNA-Configuration-List',
        'id-child-IAB-Nodes-NA-Resource-List',
        'id-Parent-IAB-Nodes-NA-Resource-Configuration-List',
        'id-uL-FreqInfo',
        'id-uL-Transmission-Bandwidth',
        'id-dL-FreqInfo',
        'id-dL-Transmission-Bandwidth',
        'id-uL-NR-Carrier-List',
        'id-dL-NR-Carrier-List',
        'id-nRFreqInfo',
        'id-transmission-Bandwidth',
        'id-nR-Carrier-List',
        'id-Neighbour-Node-Cells-List',
        'id-Serving-Cells-List',
        'id-permutation',
        'id-MDTPollutedMeasurementIndicator',
        'id-M5ReportAmount',
        'id-M6ReportAmount',
        'id-M7ReportAmount',
        'id-SurvivalTime',
        'id-PDCMeasurementPeriodicity',
        'id-PDCMeasurementQuantities',
        'id-PDCMeasurementQuantities-Item',
        'id-PDCMeasurementResult',
        'id-PDCReportType',
        'id-RAN-UE-PDC-MeasID',
        'id-SCGActivationRequest',
        'id-SCGActivationStatus',
        'id-PRSTRPList',
        'id-PRSTransmissionTRPList',
        'id-OnDemandPRS',
        'id-AoA-SearchWindow',
        'id-TRP-MeasurementUpdateList',
        'id-ZoAInformation',
        'id-ResponseTime',
        'id-ARPLocationInfo',
        'id-ARP-ID',
        'id-MultipleULAoA',
        'id-UL-SRS-RSRPP',
        'id-SRSResourcetype',
        'id-ExtendedAdditionalPathList',
        'id-LoS-NLoSInformation',
        'id-NumberOfTRPRxTEG',
        'id-NumberOfTRPRxTxTEG',
        'id-TRPTxTEGAssociation',
        'id-TRPTEGInformation',
        'id-TRPRx-TEGInformation',
        'id-TRP-PRS-Info-List',
        'id-PRS-Measurement-Info-List',
        'id-PRSConfigRequestType',
        'id-MeasurementTimeOccasion',
        'id-MeasurementCharacteristicsRequestIndicator',
        'id-UEReportingInformation',
        'id-PosConextRevIndication',
        'id-TRPBeamAntennaInformation',
        'id-NRRedCapUEIndication',
        'id-Redcap-Bcast-Information',
        'id-RANUEPagingDRX',
        'id-CNUEPagingDRX',
        'id-NRPagingeDRXInformation',
        'id-NRPagingeDRXInformationforRRCINACTIVE',
        'id-NR-TADV',
        'id-QoEInformation',
        'id-CG-SDTQueryIndication',
        'id-SDT-MAC-PHY-CG-Config',
        'id-CG-SDTKeptIndicator',
        'id-CG-SDTindicatorSetup',
        'id-CG-SDTindicatorMod',
        'id-CG-SDTSessionInfoOld',
        'id-SDTInformation',
        'id-SDTRLCBearerConfiguration',
        'id-FiveG-ProSeAuthorized',
        'id-FiveG-ProSeUEPC5AggregateMaximumBitrate',
        'id-FiveG-ProSePC5LinkAMBR',
        'id-SRBMappingInfo',
        'id-DRBMappingInfo',
        'id-UuRLCChannelToBeSetupList',
        'id-UuRLCChannelToBeModifiedList',
        'id-UuRLCChannelToBeReleasedList',
        'id-UuRLCChannelSetupList',
        'id-UuRLCChannelFailedToBeSetupList',
        'id-UuRLCChannelModifiedList',
        'id-UuRLCChannelFailedToBeModifiedList',
        'id-UuRLCChannelRequiredToBeModifiedList',
        'id-UuRLCChannelRequiredToBeReleasedList',
        'id-PC5RLCChannelToBeSetupList',
        'id-PC5RLCChannelToBeModifiedList',
        'id-PC5RLCChannelToBeReleasedList',
        'id-PC5RLCChannelSetupList',
        'id-PC5RLCChannelFailedToBeSetupList',
        'id-PC5RLCChannelFailedToBeModifiedList',
        'id-PC5RLCChannelRequiredToBeModifiedList',
        'id-PC5RLCChannelRequiredToBeReleasedList',
        'id-PC5RLCChannelModifiedList',
        'id-SidelinkRelayConfiguration',
        'id-UpdatedRemoteUELocalID',
        'id-PathSwitchConfiguration',
        'id-PagingCause',
        'id-MUSIM-GapConfig',
        'id-PEIPSAssistanceInfo',
        'id-UEPagingCapability',
        'id-LastUsedCellIndication',
        'id-SIB17-message',
        'id-GNBDUUESliceMaximumBitRateList',
        'id-SIB20-message',
        'id-UE-MulticastMRBs-ToBeReleased-List',
        'id-UE-MulticastMRBs-ToBeReleased-Item',
        'id-UE-MulticastMRBs-ToBeSetup-List',
        'id-UE-MulticastMRBs-ToBeSetup-Item',
        'id-MulticastMBSSessionSetupList',
        'id-MulticastMBSSessionRemoveList',
        'id-PosMeasurementAmount',
        'id-SDT-Termination-Request',
        'id-pathPower',
        'id-DU-RX-MT-RX-Extend',
        'id-DU-TX-MT-TX-Extend',
        'id-DU-RX-MT-TX-Extend',
        'id-DU-TX-MT-RX-Extend',
        'id-BAP-Header-Rewriting-Removed-List',
        'id-BAP-Header-Rewriting-Removed-List-Item',
        'id-SLDRXCycleList',
        'id-TAINSAGSupportList',
        'id-SL-RLC-ChannelToAddModList',
        'id-BroadcastAreaScope',
        'id-ManagementBasedMDTPLMNModificationList',
        'id-SIB15-message',
        'id-ActivationRequestType',
        'id-PosMeasGapPreConfigList',
        'id-InterFrequencyConfig-NoGap',
        'id-MBSInterestIndication',
        'id-UE-MulticastMRBs-ConfirmedToBeModified-List',
        'id-UE-MulticastMRBs-ConfirmedToBeModified-Item',
        'id-UE-MulticastMRBs-RequiredToBeModified-List',
        'id-UE-MulticastMRBs-RequiredToBeModified-Item',
        'id-UE-MulticastMRBs-RequiredToBeReleased-List',
        'id-UE-MulticastMRBs-RequiredToBeReleased-Item',
        'id-L571Info',
        'id-L1151Info',
        'id-SCS-480',
        'id-SCS-960',
        'id-SRSPortIndex',
        'id-PEISubgroupingSupportIndication',
        'id-NeedForGapsInfoNR',
        'id-NeedForGapNCSGInfoNR',
        'id-NeedForGapNCSGInfoEUTRA',
        'id-procedure-code-668-not-to-be-used',
        'id-procedure-code-669-not-to-be-used',
        'id-procedure-code-670-not-to-be-used',
        'id-Source-MRB-ID',
        'id-PosMeasurementPeriodicityNR-AoA',
        'id-RedCapIndication',
        'id-SRSPosRRCInactiveConfig',
        'id-SDTBearerConfigurationQueryIndication',
        'id-SDTBearerConfigurationInfo',
        'id-UL-GapFR2-Config',
        'id-ConfigRestrictInfoDAPS',
        'id-UE-MulticastMRBs-Setup-List',
        'id-UE-MulticastMRBs-Setup-Item',
        'id-MulticastF1UContextReferenceCU',
        'id-PosSItypeList',
        'id-DAPS-HO-Status',
        'id-UplinkTxDirectCurrentTwoCarrierListInfo',
        'id-UE-MulticastMRBs-ToBeSetup-atModify-List',
        'id-UE-MulticastMRBs-ToBeSetup-atModify-Item',
        'id-MC-PagingCell-List',
        'id-MC-PagingCell-Item',
        'id-SRSPosRRCInactiveQueryIndication',
        'id-UlTxDirectCurrentMoreCarrierInformation',
        'id-CPACMCGInformation',
        'id-TwoPHRModeMCG',
        'id-TwoPHRModeSCG',
        'id-ExtendedUEIdentityIndexValue',
        'id-ServingCellMO-List',
        'id-ServingCellMO-List-Item',
        'id-ServingCellMO-encoded-in-CGC-List',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        'id-Reset',
        'id-F1Setup',
        'id-ErrorIndication',
        'id-gNBDUConfigurationUpdate',
        'id-gNBCUConfigurationUpdate',
        'id-UEContextSetup',
        'id-UEContextRelease',
        'id-UEContextModification',
        'id-UEContextModificationRequired',
        'id-UEMobilityCommand',
        'id-UEContextReleaseRequest',
        'id-InitialULRRCMessageTransfer',
        'id-DLRRCMessageTransfer',
        'id-ULRRCMessageTransfer',
        'id-privateMessage',
        'id-UEInactivityNotification',
        'id-GNBDUResourceCoordination',
        'id-SystemInformationDeliveryCommand',
        'id-Paging',
        'id-Notify',
        'id-WriteReplaceWarning',
        'id-PWSCancel',
        'id-PWSRestartIndication',
        'id-PWSFailureIndication',
        'id-GNBDUStatusIndication',
        'id-RRCDeliveryReport',
        'id-F1Removal',
        'id-NetworkAccessRateReduction',
        'id-TraceStart',
        'id-DeactivateTrace',
        'id-DUCURadioInformationTransfer',
        'id-CUDURadioInformationTransfer',
        'id-BAPMappingConfiguration',
        'id-GNBDUResourceConfiguration',
        'id-IABTNLAddressAllocation',
        'id-IABUPConfigurationUpdate',
        'id-resourceStatusReportingInitiation',
        'id-resourceStatusReporting',
        'id-accessAndMobilityIndication',
        'id-accessSuccess',
        'id-cellTrafficTrace',
        'id-PositioningMeasurementExchange',
        'id-PositioningAssistanceInformationControl',
        'id-PositioningAssistanceInformationFeedback',
        'id-PositioningMeasurementReport',
        'id-PositioningMeasurementAbort',
        'id-PositioningMeasurementFailureIndication',
        'id-PositioningMeasurementUpdate',
        'id-TRPInformationExchange',
        'id-PositioningInformationExchange',
        'id-PositioningActivation',
        'id-PositioningDeactivation',
        'id-E-CIDMeasurementInitiation',
        'id-E-CIDMeasurementFailureIndication',
        'id-E-CIDMeasurementReport',
        'id-E-CIDMeasurementTermination',
        'id-PositioningInformationUpdate',
        'id-ReferenceTimeInformationReport',
        'id-ReferenceTimeInformationReportingControl',
        'id-BroadcastContextSetup',
        'id-BroadcastContextRelease',
        'id-BroadcastContextReleaseRequest',
        'id-BroadcastContextModification',
        'id-MulticastGroupPaging',
        'id-MulticastContextSetup',
        'id-MulticastContextRelease',
        'id-MulticastContextReleaseRequest',
        'id-MulticastContextModification',
        'id-MulticastDistributionSetup',
        'id-MulticastDistributionRelease',
        'id-PDCMeasurementInitiation',
        'id-PDCMeasurementReport',
        'id-PDCMeasurementInitiationRequest',
        'id-PDCMeasurementInitiationResponse',
        'id-PDCMeasurementInitiationFailure',
        'id-pRSConfigurationExchange',
        'id-measurementPreconfiguration',
        'id-measurementActivation',
        'id-QoEInformationTransfer',
        'id-PDCMeasurementTerminationCommand',
        'id-PDCMeasurementFailureIndication',
        'id-PosSystemInformationDeliveryCommand',
        'maxPrivateIEs',
        'maxProtocolExtensions',
        'maxProtocolIEs',
        'maxNRARFCN',
        'maxnoofErrors',
        'maxnoofIndividualF1ConnectionsToReset',
        'maxCellingNBDU',
        'maxnoofSCells',
        'maxnoofSRBs',
        'maxnoofDRBs',
        'maxnoofULUPTNLInformation',
        'maxnoofDLUPTNLInformation',
        'maxnoofBPLMNs',
        'maxnoofCandidateSpCells',
        'maxnoofPotentialSpCells',
        'maxnoofNrCellBands',
        'maxnoofSIBTypes',
        'maxnoofSITypes',
        'maxnoofPagingCells',
        'maxnoofTNLAssociations',
        'maxnoofQoSFlows',
        'maxnoofSliceItems',
        'maxCellineNB',
        'maxnoofExtendedBPLMNs',
        'maxnoofUEIDs',
        'maxnoofBPLMNsNR',
        'maxnoofUACPLMNs',
        'maxnoofUACperPLMN',
        'maxnoofAdditionalSIBs',
        'maxnoofslots',
        'maxnoofTLAs',
        'maxnoofGTPTLAs',
        'maxnoofBHRLCChannels',
        'maxnoofRoutingEntries',
        'maxnoofIABSTCInfo',
        'maxnoofSymbols',
        'maxnoofServingCells',
        'maxnoofDUFSlots',
        'maxnoofHSNASlots',
        'maxnoofServedCellsIAB',
        'maxnoofChildIABNodes',
        'maxnoofNonUPTrafficMappings',
        'maxnoofTLAsIAB',
        'maxnoofMappingEntries',
        'maxnoofDSInfo',
        'maxnoofEgressLinks',
        'maxnoofULUPTNLInformationforIAB',
        'maxnoofUPTNLAddresses',
        'maxnoofSLDRBs',
        'maxnoofQoSParaSets',
        'maxnoofPC5QoSFlows',
        'maxnoofSSBAreas',
        'maxnoofPhysicalResourceBlocks',
        'maxnoofPhysicalResourceBlocks-1',
        'maxnoofPRACHconfigs',
        'maxnoofRACHReports',
        'maxnoofRLFReports',
        'maxnoofAdditionalPDCPDuplicationTNL',
        'maxnoofRLCDuplicationState',
        'maxnoofCHOcells',
        'maxnoofMDTPLMNs',
        'maxnoofCAGsupported',
        'maxnoofNIDsupported',
        'maxnoofNRSCSs',
        'maxnoofExtSliceItems',
        'maxnoofPosMeas',
        'maxnoofTRPInfoTypes',
        'maxnoofTRPs',
        'maxnoofSRSTriggerStates',
        'maxnoofSpatialRelations',
        'maxnoBcastCell',
        'maxnoofAngleInfo',
        'maxnooflcs-gcs-translation',
        'maxnoofPath',
        'maxnoofMeasE-CID',
        'maxnoofSSBs',
        'maxnoSRS-ResourceSets',
        'maxnoSRS-ResourcePerSet',
        'maxnoSRS-Carriers',
        'maxnoSCSs',
        'maxnoSRS-Resources',
        'maxnoSRS-PosResources',
        'maxnoSRS-PosResourceSets',
        'maxnoSRS-PosResourcePerSet',
        'maxnoofPRS-ResourceSets',
        'maxnoofPRS-ResourcesPerSet',
        'maxNoOfMeasTRPs',
        'maxnoofPRSresourceSets',
        'maxnoofPRSresources',
        'maxnoofSuccessfulHOReports',
        'maxnoofNR-UChannelIDs',
        'maxServedCellforSON',
        'maxNeighbourCellforSON',
        'maxAffectedCells',
        'maxnoofMRBs',
        'maxnoofMBSQoSFlows',
        'maxnoofMBSFSAs',
        'maxnoofUEIDforPaging',
        'maxnoofCellsforMBS',
        'maxnoofTAIforMBS',
        'maxnoofMBSAreaSessionIDs',
        'maxnoofMBSServiceAreaInformation',
        'maxnoofIABCongInd',
        'maxnoofNeighbourNodeCellsIAB',
        'maxnoofRBsetsPerCell',
        'maxnoofRBsetsPerCell-1',
        'maxnoofMeasPDC',
        'maxnoARPs',
        'maxnoofULAoAs',
        'maxNoPathExtended',
        'maxnoTRPTEGs',
        'maxFreqLayers',
        'maxNumResourcesPerAngle',
        'maxnoAzimuthAngles',
        'maxnoElevationAngles',
        'maxnoofPRSTRPs',
        'maxnoofQoEInformation',
        'maxnoofUuRLCChannels',
        'maxnoofPC5RLCChannels',
        'maxnoofSMBRValues',
        'maxnoofMRBsforUE',
        'maxnoofMBSSessionsofUE',
        'maxnoofSLdestinations',
        'maxnoofNSAGs',
        'maxnoofSDTBearers',
        'maxnoofServingCellMOs',
        'maxNrofBWPs',
        'maxnoofPosSITypes',
        'id-Cause',
        'id-Cells-Failed-to-be-Activated-List',
        'id-Cells-Failed-to-be-Activated-List-Item',
        'id-Cells-to-be-Activated-List',
        'id-Cells-to-be-Activated-List-Item',
        'id-Cells-to-be-Deactivated-List',
        'id-Cells-to-be-Deactivated-List-Item',
        'id-CriticalityDiagnostics',
        'id-CUtoDURRCInformation',
        'id-DRBs-FailedToBeModified-Item',
        'id-DRBs-FailedToBeModified-List',
        'id-DRBs-FailedToBeSetup-Item',
        'id-DRBs-FailedToBeSetup-List',
        'id-DRBs-FailedToBeSetupMod-Item',
        'id-DRBs-FailedToBeSetupMod-List',
        'id-DRBs-ModifiedConf-Item',
        'id-DRBs-ModifiedConf-List',
        'id-DRBs-Modified-Item',
        'id-DRBs-Modified-List',
        'id-DRBs-Required-ToBeModified-Item',
        'id-DRBs-Required-ToBeModified-List',
        'id-DRBs-Required-ToBeReleased-Item',
        'id-DRBs-Required-ToBeReleased-List',
        'id-DRBs-Setup-Item',
        'id-DRBs-Setup-List',
        'id-DRBs-SetupMod-Item',
        'id-DRBs-SetupMod-List',
        'id-DRBs-ToBeModified-Item',
        'id-DRBs-ToBeModified-List',
        'id-DRBs-ToBeReleased-Item',
        'id-DRBs-ToBeReleased-List',
        'id-DRBs-ToBeSetup-Item',
        'id-DRBs-ToBeSetup-List',
        'id-DRBs-ToBeSetupMod-Item',
        'id-DRBs-ToBeSetupMod-List',
        'id-DRXCycle',
        'id-DUtoCURRCInformation',
        'id-gNB-CU-UE-F1AP-ID',
        'id-gNB-DU-UE-F1AP-ID',
        'id-gNB-DU-ID',
        'id-GNB-DU-Served-Cells-Item',
        'id-gNB-DU-Served-Cells-List',
        'id-gNB-DU-Name',
        'id-NRCellID',
        'id-oldgNB-DU-UE-F1AP-ID',
        'id-ResetType',
        'id-ResourceCoordinationTransferContainer',
        'id-RRCContainer',
        'id-SCell-ToBeRemoved-Item',
        'id-SCell-ToBeRemoved-List',
        'id-SCell-ToBeSetup-Item',
        'id-SCell-ToBeSetup-List',
        'id-SCell-ToBeSetupMod-Item',
        'id-SCell-ToBeSetupMod-List',
        'id-Served-Cells-To-Add-Item',
        'id-Served-Cells-To-Add-List',
        'id-Served-Cells-To-Delete-Item',
        'id-Served-Cells-To-Delete-List',
        'id-Served-Cells-To-Modify-Item',
        'id-Served-Cells-To-Modify-List',
        'id-SpCell-ID',
        'id-SRBID',
        'id-SRBs-FailedToBeSetup-Item',
        'id-SRBs-FailedToBeSetup-List',
        'id-SRBs-FailedToBeSetupMod-Item',
        'id-SRBs-FailedToBeSetupMod-List',
        'id-SRBs-Required-ToBeReleased-Item',
        'id-SRBs-Required-ToBeReleased-List',
        'id-SRBs-ToBeReleased-Item',
        'id-SRBs-ToBeReleased-List',
        'id-SRBs-ToBeSetup-Item',
        'id-SRBs-ToBeSetup-List',
        'id-SRBs-ToBeSetupMod-Item',
        'id-SRBs-ToBeSetupMod-List',
        'id-TimeToWait',
        'id-TransactionID',
        'id-TransmissionActionIndicator',
        'id-UE-associatedLogicalF1-ConnectionItem',
        'id-UE-associatedLogicalF1-ConnectionListResAck',
        'id-gNB-CU-Name',
        'id-SCell-FailedtoSetup-List',
        'id-SCell-FailedtoSetup-Item',
        'id-SCell-FailedtoSetupMod-List',
        'id-SCell-FailedtoSetupMod-Item',
        'id-RRCReconfigurationCompleteIndicator',
        'id-Cells-Status-Item',
        'id-Cells-Status-List',
        'id-Candidate-SpCell-List',
        'id-Candidate-SpCell-Item',
        'id-Potential-SpCell-List',
        'id-Potential-SpCell-Item',
        'id-FullConfiguration',
        'id-C-RNTI',
        'id-SpCellULConfigured',
        'id-InactivityMonitoringRequest',
        'id-InactivityMonitoringResponse',
        'id-DRB-Activity-Item',
        'id-DRB-Activity-List',
        'id-EUTRA-NR-CellResourceCoordinationReq-Container',
        'id-EUTRA-NR-CellResourceCoordinationReqAck-Container',
        'id-Protected-EUTRA-Resources-List',
        'id-RequestType',
        'id-ServCellIndex',
        'id-RAT-FrequencyPriorityInformation',
        'id-ExecuteDuplication',
        'id-NRCGI',
        'id-PagingCell-Item',
        'id-PagingCell-List',
        'id-PagingDRX',
        'id-PagingPriority',
        'id-SItype-List',
        'id-UEIdentityIndexValue',
        'id-gNB-CUSystemInformation',
        'id-HandoverPreparationInformation',
        'id-GNB-CU-TNL-Association-To-Add-Item',
        'id-GNB-CU-TNL-Association-To-Add-List',
        'id-GNB-CU-TNL-Association-To-Remove-Item',
        'id-GNB-CU-TNL-Association-To-Remove-List',
        'id-GNB-CU-TNL-Association-To-Update-Item',
        'id-GNB-CU-TNL-Association-To-Update-List',
        'id-MaskedIMEISV',
        'id-PagingIdentity',
        'id-DUtoCURRCContainer',
        'id-Cells-to-be-Barred-List',
        'id-Cells-to-be-Barred-Item',
        'id-TAISliceSupportList',
        'id-GNB-CU-TNL-Association-Setup-List',
        'id-GNB-CU-TNL-Association-Setup-Item',
        'id-GNB-CU-TNL-Association-Failed-To-Setup-List',
        'id-GNB-CU-TNL-Association-Failed-To-Setup-Item',
        'id-DRB-Notify-Item',
        'id-DRB-Notify-List',
        'id-NotficationControl',
        'id-RANAC',
        'id-PWSSystemInformation',
        'id-RepetitionPeriod',
        'id-NumberofBroadcastRequest',
        'id-Cells-To-Be-Broadcast-List',
        'id-Cells-To-Be-Broadcast-Item',
        'id-Cells-Broadcast-Completed-List',
        'id-Cells-Broadcast-Completed-Item',
        'id-Broadcast-To-Be-Cancelled-List',
        'id-Broadcast-To-Be-Cancelled-Item',
        'id-Cells-Broadcast-Cancelled-List',
        'id-Cells-Broadcast-Cancelled-Item',
        'id-NR-CGI-List-For-Restart-List',
        'id-NR-CGI-List-For-Restart-Item',
        'id-PWS-Failed-NR-CGI-List',
        'id-PWS-Failed-NR-CGI-Item',
        'id-ConfirmedUEID',
        'id-Cancel-all-Warning-Messages-Indicator',
        'id-GNB-DU-UE-AMBR-UL',
        'id-DRXConfigurationIndicator',
        'id-RLC-Status',
        'id-DLPDCPSNLength',
        'id-GNB-DUConfigurationQuery',
        'id-MeasurementTimingConfiguration',
        'id-DRB-Information',
        'id-ServingPLMN',
        'id-Protected-EUTRA-Resources-Item',
        'id-GNB-CU-RRC-Version',
        'id-GNB-DU-RRC-Version',
        'id-GNBDUOverloadInformation',
        'id-CellGroupConfig',
        'id-RLCFailureIndication',
        'id-UplinkTxDirectCurrentListInformation',
        'id-DC-Based-Duplication-Configured',
        'id-DC-Based-Duplication-Activation',
        'id-SULAccessIndication',
        'id-AvailablePLMNList',
        'id-PDUSessionID',
        'id-ULPDUSessionAggregateMaximumBitRate',
        'id-ServingCellMO',
        'id-QoSFlowMappingIndication',
        'id-RRCDeliveryStatusRequest',
        'id-RRCDeliveryStatus',
        'id-BearerTypeChange',
        'id-RLCMode',
        'id-Duplication-Activation',
        'id-Dedicated-SIDelivery-NeededUE-List',
        'id-Dedicated-SIDelivery-NeededUE-Item',
        'id-DRX-LongCycleStartOffset',
        'id-ULPDCPSNLength',
        'id-SelectedBandCombinationIndex',
        'id-SelectedFeatureSetEntryIndex',
        'id-ResourceCoordinationTransferInformation',
        'id-ExtendedServedPLMNs-List',
        'id-ExtendedAvailablePLMN-List',
        'id-Associated-SCell-List',
        'id-latest-RRC-Version-Enhanced',
        'id-Associated-SCell-Item',
        'id-Cell-Direction',
        'id-SRBs-Setup-List',
        'id-SRBs-Setup-Item',
        'id-SRBs-SetupMod-List',
        'id-SRBs-SetupMod-Item',
        'id-SRBs-Modified-List',
        'id-SRBs-Modified-Item',
        'id-Ph-InfoSCG',
        'id-RequestedBandCombinationIndex',
        'id-RequestedFeatureSetEntryIndex',
        'id-RequestedP-MaxFR2',
        'id-DRX-Config',
        'id-IgnoreResourceCoordinationContainer',
        'id-UEAssistanceInformation',
        'id-NeedforGap',
        'id-PagingOrigin',
        'id-new-gNB-CU-UE-F1AP-ID',
        'id-RedirectedRRCmessage',
        'id-new-gNB-DU-UE-F1AP-ID',
        'id-NotificationInformation',
        'id-PLMNAssistanceInfoForNetShar',
        'id-UEContextNotRetrievable',
        'id-BPLMN-ID-Info-List',
        'id-SelectedPLMNID',
        'id-UAC-Assistance-Info',
        'id-RANUEID',
        'id-GNB-DU-TNL-Association-To-Remove-Item',
        'id-GNB-DU-TNL-Association-To-Remove-List',
        'id-TNLAssociationTransportLayerAddressgNBDU',
        'id-portNumber',
        'id-AdditionalSIBMessageList',
        'id-Cell-Type',
        'id-IgnorePRACHConfiguration',
        'id-CG-Config',
        'id-PDCCH-BlindDetectionSCG',
        'id-Requested-PDCCH-BlindDetectionSCG',
        'id-Ph-InfoMCG',
        'id-MeasGapSharingConfig',
        'id-systemInformationAreaID',
        'id-areaScope',
        'id-RRCContainer-RRCSetupComplete',
        'id-TraceActivation',
        'id-TraceID',
        'id-Neighbour-Cell-Information-List',
        'id-SymbolAllocInSlot',
        'id-NumDLULSymbols',
        'id-AdditionalRRMPriorityIndex',
        'id-DUCURadioInformationType',
        'id-CUDURadioInformationType',
        'id-AggressorgNBSetID',
        'id-VictimgNBSetID',
        'id-LowerLayerPresenceStatusChange',
        'id-Transport-Layer-Address-Info',
        'id-Neighbour-Cell-Information-Item',
        'id-IntendedTDD-DL-ULConfig',
        'id-QosMonitoringRequest',
        'id-BHChannels-ToBeSetup-List',
        'id-BHChannels-ToBeSetup-Item',
        'id-BHChannels-Setup-List',
        'id-BHChannels-Setup-Item',
        'id-BHChannels-ToBeModified-Item',
        'id-BHChannels-ToBeModified-List',
        'id-BHChannels-ToBeReleased-Item',
        'id-BHChannels-ToBeReleased-List',
        'id-BHChannels-ToBeSetupMod-Item',
        'id-BHChannels-ToBeSetupMod-List',
        'id-BHChannels-FailedToBeModified-Item',
        'id-BHChannels-FailedToBeModified-List',
        'id-BHChannels-FailedToBeSetupMod-Item',
        'id-BHChannels-FailedToBeSetupMod-List',
        'id-BHChannels-Modified-Item',
        'id-BHChannels-Modified-List',
        'id-BHChannels-SetupMod-Item',
        'id-BHChannels-SetupMod-List',
        'id-BHChannels-Required-ToBeReleased-Item',
        'id-BHChannels-Required-ToBeReleased-List',
        'id-BHChannels-FailedToBeSetup-Item',
        'id-BHChannels-FailedToBeSetup-List',
        'id-BHInfo',
        'id-BAPAddress',
        'id-ConfiguredBAPAddress',
        'id-BH-Routing-Information-Added-List',
        'id-BH-Routing-Information-Added-List-Item',
        'id-BH-Routing-Information-Removed-List',
        'id-BH-Routing-Information-Removed-List-Item',
        'id-UL-BH-Non-UP-Traffic-Mapping',
        'id-Activated-Cells-to-be-Updated-List',
        'id-Child-Nodes-List',
        'id-IAB-Info-IAB-DU',
        'id-IAB-Info-IAB-donor-CU',
        'id-IAB-TNL-Addresses-To-Remove-List',
        'id-IAB-TNL-Addresses-To-Remove-Item',
        'id-IAB-Allocated-TNL-Address-List',
        'id-IAB-Allocated-TNL-Address-Item',
        'id-IABIPv6RequestType',
        'id-IABv4AddressesRequested',
        'id-IAB-Barred',
        'id-TrafficMappingInformation',
        'id-UL-UP-TNL-Information-to-Update-List',
        'id-UL-UP-TNL-Information-to-Update-List-Item',
        'id-UL-UP-TNL-Address-to-Update-List',
        'id-UL-UP-TNL-Address-to-Update-List-Item',
        'id-DL-UP-TNL-Address-to-Update-List',
        'id-DL-UP-TNL-Address-to-Update-List-Item',
        'id-NRV2XServicesAuthorized',
        'id-LTEV2XServicesAuthorized',
        'id-NRUESidelinkAggregateMaximumBitrate',
        'id-LTEUESidelinkAggregateMaximumBitrate',
        'id-SIB12-message',
        'id-SIB13-message',
        'id-SIB14-message',
        'id-SLDRBs-FailedToBeModified-Item',
        'id-SLDRBs-FailedToBeModified-List',
        'id-SLDRBs-FailedToBeSetup-Item',
        'id-SLDRBs-FailedToBeSetup-List',
        'id-SLDRBs-Modified-Item',
        'id-SLDRBs-Modified-List',
        'id-SLDRBs-Required-ToBeModified-Item',
        'id-SLDRBs-Required-ToBeModified-List',
        'id-SLDRBs-Required-ToBeReleased-Item',
        'id-SLDRBs-Required-ToBeReleased-List',
        'id-SLDRBs-Setup-Item',
        'id-SLDRBs-Setup-List',
        'id-SLDRBs-ToBeModified-Item',
        'id-SLDRBs-ToBeModified-List',
        'id-SLDRBs-ToBeReleased-Item',
        'id-SLDRBs-ToBeReleased-List',
        'id-SLDRBs-ToBeSetup-Item',
        'id-SLDRBs-ToBeSetup-List',
        'id-SLDRBs-ToBeSetupMod-Item',
        'id-SLDRBs-ToBeSetupMod-List',
        'id-SLDRBs-SetupMod-List',
        'id-SLDRBs-FailedToBeSetupMod-List',
        'id-SLDRBs-SetupMod-Item',
        'id-SLDRBs-FailedToBeSetupMod-Item',
        'id-SLDRBs-ModifiedConf-List',
        'id-SLDRBs-ModifiedConf-Item',
        'id-UEAssistanceInformationEUTRA',
        'id-PC5LinkAMBR',
        'id-SL-PHY-MAC-RLC-Config',
        'id-SL-ConfigDedicatedEUTRA-Info',
        'id-AlternativeQoSParaSetList',
        'id-CurrentQoSParaSetIndex',
        'id-gNBCUMeasurementID',
        'id-gNBDUMeasurementID',
        'id-RegistrationRequest',
        'id-ReportCharacteristics',
        'id-CellToReportList',
        'id-CellMeasurementResultList',
        'id-HardwareLoadIndicator',
        'id-ReportingPeriodicity',
        'id-TNLCapacityIndicator',
        'id-CarrierList',
        'id-ULCarrierList',
        'id-FrequencyShift7p5khz',
        'id-SSB-PositionsInBurst',
        'id-NRPRACHConfig',
        'id-RACHReportInformationList',
        'id-RLFReportInformationList',
        'id-TDD-UL-DLConfigCommonNR',
        'id-CNPacketDelayBudgetDownlink',
        'id-ExtendedPacketDelayBudget',
        'id-TSCTrafficCharacteristics',
        'id-ReportingRequestType',
        'id-TimeReferenceInformation',
        'id-CNPacketDelayBudgetUplink',
        'id-AdditionalPDCPDuplicationTNL-List',
        'id-RLCDuplicationInformation',
        'id-AdditionalDuplicationIndication',
        'id-ConditionalInterDUMobilityInformation',
        'id-ConditionalIntraDUMobilityInformation',
        'id-targetCellsToCancel',
        'id-requestedTargetCellGlobalID',
        'id-ManagementBasedMDTPLMNList',
        'id-TraceCollectionEntityIPAddress',
        'id-PrivacyIndicator',
        'id-TraceCollectionEntityURI',
        'id-mdtConfiguration',
        'id-ServingNID',
        'id-NPNBroadcastInformation',
        'id-NPNSupportInfo',
        'id-NID',
        'id-AvailableSNPN-ID-List',
        'id-SIB10-message',
        'id-DLCarrierList',
        'id-ExtendedTAISliceSupportList',
        'id-RequestedSRSTransmissionCharacteristics',
        'id-PosAssistance-Information',
        'id-PosBroadcast',
        'id-RoutingID',
        'id-PosAssistanceInformationFailureList',
        'id-PosMeasurementQuantities',
        'id-PosMeasurementResultList',
        'id-TRPInformationTypeListTRPReq',
        'id-TRPInformationTypeItem',
        'id-TRPInformationListTRPResp',
        'id-TRPInformationItem',
        'id-LMF-MeasurementID',
        'id-SRSType',
        'id-ActivationTime',
        'id-AbortTransmission',
        'id-PositioningBroadcastCells',
        'id-SRSConfiguration',
        'id-PosReportCharacteristics',
        'id-PosMeasurementPeriodicity',
        'id-TRPList',
        'id-RAN-MeasurementID',
        'id-LMF-UE-MeasurementID',
        'id-RAN-UE-MeasurementID',
        'id-E-CID-MeasurementQuantities',
        'id-E-CID-MeasurementQuantities-Item',
        'id-E-CID-MeasurementPeriodicity',
        'id-E-CID-MeasurementResult',
        'id-Cell-Portion-ID',
        'id-SFNInitialisationTime',
        'id-SystemFrameNumber',
        'id-SlotNumber',
        'id-TRP-MeasurementRequestList',
        'id-MeasurementBeamInfoRequest',
        'id-E-CID-ReportCharacteristics',
        'id-ConfiguredTACIndication',
        'id-Extended-GNB-CU-Name',
        'id-Extended-GNB-DU-Name',
        'id-F1CTransferPath',
        'id-SFN-Offset',
        'id-TransmissionStopIndicator',
        'id-SrsFrequency',
        'id-SCGIndicator',
        'id-EstimatedArrivalProbability',
        'id-TRPType',
        'id-SRSSpatialRelationPerSRSResource',
        'id-PDCPTerminatingNodeDLTNLAddrInfo',
        'id-ENBDLTNLAddress',
        'id-PosMeasurementPeriodicityExtended',
        'id-PRS-Resource-ID',
        'id-LocationMeasurementInformation',
        'id-SliceRadioResourceStatus',
        'id-CompositeAvailableCapacity-SUL',
        'id-SuccessfulHOReportInformationList',
        'id-NR-U-Channel-List',
        'id-NR-U',
        'id-Coverage-Modification-Notification',
        'id-CCO-Assistance-Information',
        'id-Neighbor-node-CCO-Assistance-Information-List',
        'id-CellsForSON-List',
        'id-MIMOPRBusageInformation',
        'id-gNB-CU-MBS-F1AP-ID',
        'id-gNB-DU-MBS-F1AP-ID',
        'id-MBS-Area-Session-ID',
        'id-MBS-CUtoDURRCInformation',
        'id-MBS-Session-ID',
        'id-SNSSAI',
        'id-MBS-Broadcast-NeighbourCellList',
        'id-BroadcastMRBs-FailedToBeModified-List',
        'id-BroadcastMRBs-FailedToBeModified-Item',
        'id-BroadcastMRBs-FailedToBeSetup-List',
        'id-BroadcastMRBs-FailedToBeSetup-Item',
        'id-BroadcastMRBs-FailedToBeSetupMod-List',
        'id-BroadcastMRBs-FailedToBeSetupMod-Item',
        'id-BroadcastMRBs-Modified-List',
        'id-BroadcastMRBs-Modified-Item',
        'id-BroadcastMRBs-Setup-List',
        'id-BroadcastMRBs-Setup-Item',
        'id-BroadcastMRBs-SetupMod-List',
        'id-BroadcastMRBs-SetupMod-Item',
        'id-BroadcastMRBs-ToBeModified-List',
        'id-BroadcastMRBs-ToBeModified-Item',
        'id-BroadcastMRBs-ToBeReleased-List',
        'id-BroadcastMRBs-ToBeReleased-Item',
        'id-BroadcastMRBs-ToBeSetup-List',
        'id-BroadcastMRBs-ToBeSetup-Item',
        'id-BroadcastMRBs-ToBeSetupMod-List',
        'id-BroadcastMRBs-ToBeSetupMod-Item',
        'id-Supported-MBS-FSA-ID-List',
        'id-UEIdentity-List-For-Paging-List',
        'id-UEIdentity-List-For-Paging-Item',
        'id-MBS-ServiceArea',
        'id-MulticastMRBs-FailedToBeModified-List',
        'id-MulticastMRBs-FailedToBeModified-Item',
        'id-MulticastMRBs-FailedToBeSetup-List',
        'id-MulticastMRBs-FailedToBeSetup-Item',
        'id-MulticastMRBs-FailedToBeSetupMod-List',
        'id-MulticastMRBs-FailedToBeSetupMod-Item',
        'id-MulticastMRBs-Modified-List',
        'id-MulticastMRBs-Modified-Item',
        'id-MulticastMRBs-Setup-List',
        'id-MulticastMRBs-Setup-Item',
        'id-MulticastMRBs-SetupMod-List',
        'id-MulticastMRBs-SetupMod-Item',
        'id-MulticastMRBs-ToBeModified-List',
        'id-MulticastMRBs-ToBeModified-Item',
        'id-MulticastMRBs-ToBeReleased-List',
        'id-MulticastMRBs-ToBeReleased-Item',
        'id-MulticastMRBs-ToBeSetup-List',
        'id-MulticastMRBs-ToBeSetup-Item',
        'id-MulticastMRBs-ToBeSetupMod-List',
        'id-MulticastMRBs-ToBeSetupMod-Item',
        'id-MBSMulticastF1UContextDescriptor',
        'id-MulticastF1UContext-ToBeSetup-List',
        'id-MulticastF1UContext-ToBeSetup-Item',
        'id-MulticastF1UContext-Setup-List',
        'id-MulticastF1UContext-Setup-Item',
        'id-MulticastF1UContext-FailedToBeSetup-List',
        'id-MulticastF1UContext-FailedToBeSetup-Item',
        'id-IABCongestionIndication',
        'id-IABConditionalRRCMessageDeliveryIndication',
        'id-F1CTransferPathNRDC',
        'id-BufferSizeThresh',
        'id-IAB-TNL-Addresses-Exception',
        'id-BAP-Header-Rewriting-Added-List',
        'id-BAP-Header-Rewriting-Added-List-Item',
        'id-Re-routingEnableIndicator',
        'id-NonF1terminatingTopologyIndicator',
        'id-EgressNonF1terminatingTopologyIndicator',
        'id-IngressNonF1terminatingTopologyIndicator',
        'id-rBSetConfiguration',
        'id-frequency-Domain-HSNA-Configuration-List',
        'id-child-IAB-Nodes-NA-Resource-List',
        'id-Parent-IAB-Nodes-NA-Resource-Configuration-List',
        'id-uL-FreqInfo',
        'id-uL-Transmission-Bandwidth',
        'id-dL-FreqInfo',
        'id-dL-Transmission-Bandwidth',
        'id-uL-NR-Carrier-List',
        'id-dL-NR-Carrier-List',
        'id-nRFreqInfo',
        'id-transmission-Bandwidth',
        'id-nR-Carrier-List',
        'id-Neighbour-Node-Cells-List',
        'id-Serving-Cells-List',
        'id-permutation',
        'id-MDTPollutedMeasurementIndicator',
        'id-M5ReportAmount',
        'id-M6ReportAmount',
        'id-M7ReportAmount',
        'id-SurvivalTime',
        'id-PDCMeasurementPeriodicity',
        'id-PDCMeasurementQuantities',
        'id-PDCMeasurementQuantities-Item',
        'id-PDCMeasurementResult',
        'id-PDCReportType',
        'id-RAN-UE-PDC-MeasID',
        'id-SCGActivationRequest',
        'id-SCGActivationStatus',
        'id-PRSTRPList',
        'id-PRSTransmissionTRPList',
        'id-OnDemandPRS',
        'id-AoA-SearchWindow',
        'id-TRP-MeasurementUpdateList',
        'id-ZoAInformation',
        'id-ResponseTime',
        'id-ARPLocationInfo',
        'id-ARP-ID',
        'id-MultipleULAoA',
        'id-UL-SRS-RSRPP',
        'id-SRSResourcetype',
        'id-ExtendedAdditionalPathList',
        'id-LoS-NLoSInformation',
        'id-NumberOfTRPRxTEG',
        'id-NumberOfTRPRxTxTEG',
        'id-TRPTxTEGAssociation',
        'id-TRPTEGInformation',
        'id-TRPRx-TEGInformation',
        'id-TRP-PRS-Info-List',
        'id-PRS-Measurement-Info-List',
        'id-PRSConfigRequestType',
        'id-MeasurementTimeOccasion',
        'id-MeasurementCharacteristicsRequestIndicator',
        'id-UEReportingInformation',
        'id-PosConextRevIndication',
        'id-TRPBeamAntennaInformation',
        'id-NRRedCapUEIndication',
        'id-Redcap-Bcast-Information',
        'id-RANUEPagingDRX',
        'id-CNUEPagingDRX',
        'id-NRPagingeDRXInformation',
        'id-NRPagingeDRXInformationforRRCINACTIVE',
        'id-NR-TADV',
        'id-QoEInformation',
        'id-CG-SDTQueryIndication',
        'id-SDT-MAC-PHY-CG-Config',
        'id-CG-SDTKeptIndicator',
        'id-CG-SDTindicatorSetup',
        'id-CG-SDTindicatorMod',
        'id-CG-SDTSessionInfoOld',
        'id-SDTInformation',
        'id-SDTRLCBearerConfiguration',
        'id-FiveG-ProSeAuthorized',
        'id-FiveG-ProSeUEPC5AggregateMaximumBitrate',
        'id-FiveG-ProSePC5LinkAMBR',
        'id-SRBMappingInfo',
        'id-DRBMappingInfo',
        'id-UuRLCChannelToBeSetupList',
        'id-UuRLCChannelToBeModifiedList',
        'id-UuRLCChannelToBeReleasedList',
        'id-UuRLCChannelSetupList',
        'id-UuRLCChannelFailedToBeSetupList',
        'id-UuRLCChannelModifiedList',
        'id-UuRLCChannelFailedToBeModifiedList',
        'id-UuRLCChannelRequiredToBeModifiedList',
        'id-UuRLCChannelRequiredToBeReleasedList',
        'id-PC5RLCChannelToBeSetupList',
        'id-PC5RLCChannelToBeModifiedList',
        'id-PC5RLCChannelToBeReleasedList',
        'id-PC5RLCChannelSetupList',
        'id-PC5RLCChannelFailedToBeSetupList',
        'id-PC5RLCChannelFailedToBeModifiedList',
        'id-PC5RLCChannelRequiredToBeModifiedList',
        'id-PC5RLCChannelRequiredToBeReleasedList',
        'id-PC5RLCChannelModifiedList',
        'id-SidelinkRelayConfiguration',
        'id-UpdatedRemoteUELocalID',
        'id-PathSwitchConfiguration',
        'id-PagingCause',
        'id-MUSIM-GapConfig',
        'id-PEIPSAssistanceInfo',
        'id-UEPagingCapability',
        'id-LastUsedCellIndication',
        'id-SIB17-message',
        'id-GNBDUUESliceMaximumBitRateList',
        'id-SIB20-message',
        'id-UE-MulticastMRBs-ToBeReleased-List',
        'id-UE-MulticastMRBs-ToBeReleased-Item',
        'id-UE-MulticastMRBs-ToBeSetup-List',
        'id-UE-MulticastMRBs-ToBeSetup-Item',
        'id-MulticastMBSSessionSetupList',
        'id-MulticastMBSSessionRemoveList',
        'id-PosMeasurementAmount',
        'id-SDT-Termination-Request',
        'id-pathPower',
        'id-DU-RX-MT-RX-Extend',
        'id-DU-TX-MT-TX-Extend',
        'id-DU-RX-MT-TX-Extend',
        'id-DU-TX-MT-RX-Extend',
        'id-BAP-Header-Rewriting-Removed-List',
        'id-BAP-Header-Rewriting-Removed-List-Item',
        'id-SLDRXCycleList',
        'id-TAINSAGSupportList',
        'id-SL-RLC-ChannelToAddModList',
        'id-BroadcastAreaScope',
        'id-ManagementBasedMDTPLMNModificationList',
        'id-SIB15-message',
        'id-ActivationRequestType',
        'id-PosMeasGapPreConfigList',
        'id-InterFrequencyConfig-NoGap',
        'id-MBSInterestIndication',
        'id-UE-MulticastMRBs-ConfirmedToBeModified-List',
        'id-UE-MulticastMRBs-ConfirmedToBeModified-Item',
        'id-UE-MulticastMRBs-RequiredToBeModified-List',
        'id-UE-MulticastMRBs-RequiredToBeModified-Item',
        'id-UE-MulticastMRBs-RequiredToBeReleased-List',
        'id-UE-MulticastMRBs-RequiredToBeReleased-Item',
        'id-L571Info',
        'id-L1151Info',
        'id-SCS-480',
        'id-SCS-960',
        'id-SRSPortIndex',
        'id-PEISubgroupingSupportIndication',
        'id-NeedForGapsInfoNR',
        'id-NeedForGapNCSGInfoNR',
        'id-NeedForGapNCSGInfoEUTRA',
        'id-procedure-code-668-not-to-be-used',
        'id-procedure-code-669-not-to-be-used',
        'id-procedure-code-670-not-to-be-used',
        'id-Source-MRB-ID',
        'id-PosMeasurementPeriodicityNR-AoA',
        'id-RedCapIndication',
        'id-SRSPosRRCInactiveConfig',
        'id-SDTBearerConfigurationQueryIndication',
        'id-SDTBearerConfigurationInfo',
        'id-UL-GapFR2-Config',
        'id-ConfigRestrictInfoDAPS',
        'id-UE-MulticastMRBs-Setup-List',
        'id-UE-MulticastMRBs-Setup-Item',
        'id-MulticastF1UContextReferenceCU',
        'id-PosSItypeList',
        'id-DAPS-HO-Status',
        'id-UplinkTxDirectCurrentTwoCarrierListInfo',
        'id-UE-MulticastMRBs-ToBeSetup-atModify-List',
        'id-UE-MulticastMRBs-ToBeSetup-atModify-Item',
        'id-MC-PagingCell-List',
        'id-MC-PagingCell-Item',
        'id-SRSPosRRCInactiveQueryIndication',
        'id-UlTxDirectCurrentMoreCarrierInformation',
        'id-CPACMCGInformation',
        'id-TwoPHRModeMCG',
        'id-TwoPHRModeSCG',
        'id-ExtendedUEIdentityIndexValue',
        'id-ServingCellMO-List',
        'id-ServingCellMO-List-Item',
        'id-ServingCellMO-encoded-in-CGC-List',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< id-Reset >-----#
    id_Reset = INT(name='id-Reset', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_Reset._val = 0
    
    #-----< id-F1Setup >-----#
    id_F1Setup = INT(name='id-F1Setup', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_F1Setup._val = 1
    
    #-----< id-ErrorIndication >-----#
    id_ErrorIndication = INT(name='id-ErrorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_ErrorIndication._val = 2
    
    #-----< id-gNBDUConfigurationUpdate >-----#
    id_gNBDUConfigurationUpdate = INT(name='id-gNBDUConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_gNBDUConfigurationUpdate._val = 3
    
    #-----< id-gNBCUConfigurationUpdate >-----#
    id_gNBCUConfigurationUpdate = INT(name='id-gNBCUConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_gNBCUConfigurationUpdate._val = 4
    
    #-----< id-UEContextSetup >-----#
    id_UEContextSetup = INT(name='id-UEContextSetup', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextSetup._val = 5
    
    #-----< id-UEContextRelease >-----#
    id_UEContextRelease = INT(name='id-UEContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextRelease._val = 6
    
    #-----< id-UEContextModification >-----#
    id_UEContextModification = INT(name='id-UEContextModification', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextModification._val = 7
    
    #-----< id-UEContextModificationRequired >-----#
    id_UEContextModificationRequired = INT(name='id-UEContextModificationRequired', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextModificationRequired._val = 8
    
    #-----< id-UEMobilityCommand >-----#
    id_UEMobilityCommand = INT(name='id-UEMobilityCommand', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEMobilityCommand._val = 9
    
    #-----< id-UEContextReleaseRequest >-----#
    id_UEContextReleaseRequest = INT(name='id-UEContextReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextReleaseRequest._val = 10
    
    #-----< id-InitialULRRCMessageTransfer >-----#
    id_InitialULRRCMessageTransfer = INT(name='id-InitialULRRCMessageTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_InitialULRRCMessageTransfer._val = 11
    
    #-----< id-DLRRCMessageTransfer >-----#
    id_DLRRCMessageTransfer = INT(name='id-DLRRCMessageTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_DLRRCMessageTransfer._val = 12
    
    #-----< id-ULRRCMessageTransfer >-----#
    id_ULRRCMessageTransfer = INT(name='id-ULRRCMessageTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_ULRRCMessageTransfer._val = 13
    
    #-----< id-privateMessage >-----#
    id_privateMessage = INT(name='id-privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_privateMessage._val = 14
    
    #-----< id-UEInactivityNotification >-----#
    id_UEInactivityNotification = INT(name='id-UEInactivityNotification', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEInactivityNotification._val = 15
    
    #-----< id-GNBDUResourceCoordination >-----#
    id_GNBDUResourceCoordination = INT(name='id-GNBDUResourceCoordination', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_GNBDUResourceCoordination._val = 16
    
    #-----< id-SystemInformationDeliveryCommand >-----#
    id_SystemInformationDeliveryCommand = INT(name='id-SystemInformationDeliveryCommand', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_SystemInformationDeliveryCommand._val = 17
    
    #-----< id-Paging >-----#
    id_Paging = INT(name='id-Paging', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_Paging._val = 18
    
    #-----< id-Notify >-----#
    id_Notify = INT(name='id-Notify', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_Notify._val = 19
    
    #-----< id-WriteReplaceWarning >-----#
    id_WriteReplaceWarning = INT(name='id-WriteReplaceWarning', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_WriteReplaceWarning._val = 20
    
    #-----< id-PWSCancel >-----#
    id_PWSCancel = INT(name='id-PWSCancel', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PWSCancel._val = 21
    
    #-----< id-PWSRestartIndication >-----#
    id_PWSRestartIndication = INT(name='id-PWSRestartIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PWSRestartIndication._val = 22
    
    #-----< id-PWSFailureIndication >-----#
    id_PWSFailureIndication = INT(name='id-PWSFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PWSFailureIndication._val = 23
    
    #-----< id-GNBDUStatusIndication >-----#
    id_GNBDUStatusIndication = INT(name='id-GNBDUStatusIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_GNBDUStatusIndication._val = 24
    
    #-----< id-RRCDeliveryReport >-----#
    id_RRCDeliveryReport = INT(name='id-RRCDeliveryReport', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_RRCDeliveryReport._val = 25
    
    #-----< id-F1Removal >-----#
    id_F1Removal = INT(name='id-F1Removal', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_F1Removal._val = 26
    
    #-----< id-NetworkAccessRateReduction >-----#
    id_NetworkAccessRateReduction = INT(name='id-NetworkAccessRateReduction', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_NetworkAccessRateReduction._val = 27
    
    #-----< id-TraceStart >-----#
    id_TraceStart = INT(name='id-TraceStart', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_TraceStart._val = 28
    
    #-----< id-DeactivateTrace >-----#
    id_DeactivateTrace = INT(name='id-DeactivateTrace', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_DeactivateTrace._val = 29
    
    #-----< id-DUCURadioInformationTransfer >-----#
    id_DUCURadioInformationTransfer = INT(name='id-DUCURadioInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_DUCURadioInformationTransfer._val = 30
    
    #-----< id-CUDURadioInformationTransfer >-----#
    id_CUDURadioInformationTransfer = INT(name='id-CUDURadioInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_CUDURadioInformationTransfer._val = 31
    
    #-----< id-BAPMappingConfiguration >-----#
    id_BAPMappingConfiguration = INT(name='id-BAPMappingConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_BAPMappingConfiguration._val = 32
    
    #-----< id-GNBDUResourceConfiguration >-----#
    id_GNBDUResourceConfiguration = INT(name='id-GNBDUResourceConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_GNBDUResourceConfiguration._val = 33
    
    #-----< id-IABTNLAddressAllocation >-----#
    id_IABTNLAddressAllocation = INT(name='id-IABTNLAddressAllocation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_IABTNLAddressAllocation._val = 34
    
    #-----< id-IABUPConfigurationUpdate >-----#
    id_IABUPConfigurationUpdate = INT(name='id-IABUPConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_IABUPConfigurationUpdate._val = 35
    
    #-----< id-resourceStatusReportingInitiation >-----#
    id_resourceStatusReportingInitiation = INT(name='id-resourceStatusReportingInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_resourceStatusReportingInitiation._val = 36
    
    #-----< id-resourceStatusReporting >-----#
    id_resourceStatusReporting = INT(name='id-resourceStatusReporting', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_resourceStatusReporting._val = 37
    
    #-----< id-accessAndMobilityIndication >-----#
    id_accessAndMobilityIndication = INT(name='id-accessAndMobilityIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_accessAndMobilityIndication._val = 38
    
    #-----< id-accessSuccess >-----#
    id_accessSuccess = INT(name='id-accessSuccess', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_accessSuccess._val = 39
    
    #-----< id-cellTrafficTrace >-----#
    id_cellTrafficTrace = INT(name='id-cellTrafficTrace', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_cellTrafficTrace._val = 40
    
    #-----< id-PositioningMeasurementExchange >-----#
    id_PositioningMeasurementExchange = INT(name='id-PositioningMeasurementExchange', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PositioningMeasurementExchange._val = 41
    
    #-----< id-PositioningAssistanceInformationControl >-----#
    id_PositioningAssistanceInformationControl = INT(name='id-PositioningAssistanceInformationControl', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PositioningAssistanceInformationControl._val = 42
    
    #-----< id-PositioningAssistanceInformationFeedback >-----#
    id_PositioningAssistanceInformationFeedback = INT(name='id-PositioningAssistanceInformationFeedback', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PositioningAssistanceInformationFeedback._val = 43
    
    #-----< id-PositioningMeasurementReport >-----#
    id_PositioningMeasurementReport = INT(name='id-PositioningMeasurementReport', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PositioningMeasurementReport._val = 44
    
    #-----< id-PositioningMeasurementAbort >-----#
    id_PositioningMeasurementAbort = INT(name='id-PositioningMeasurementAbort', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PositioningMeasurementAbort._val = 45
    
    #-----< id-PositioningMeasurementFailureIndication >-----#
    id_PositioningMeasurementFailureIndication = INT(name='id-PositioningMeasurementFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PositioningMeasurementFailureIndication._val = 46
    
    #-----< id-PositioningMeasurementUpdate >-----#
    id_PositioningMeasurementUpdate = INT(name='id-PositioningMeasurementUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PositioningMeasurementUpdate._val = 47
    
    #-----< id-TRPInformationExchange >-----#
    id_TRPInformationExchange = INT(name='id-TRPInformationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_TRPInformationExchange._val = 48
    
    #-----< id-PositioningInformationExchange >-----#
    id_PositioningInformationExchange = INT(name='id-PositioningInformationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PositioningInformationExchange._val = 49
    
    #-----< id-PositioningActivation >-----#
    id_PositioningActivation = INT(name='id-PositioningActivation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PositioningActivation._val = 50
    
    #-----< id-PositioningDeactivation >-----#
    id_PositioningDeactivation = INT(name='id-PositioningDeactivation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PositioningDeactivation._val = 51
    
    #-----< id-E-CIDMeasurementInitiation >-----#
    id_E_CIDMeasurementInitiation = INT(name='id-E-CIDMeasurementInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_E_CIDMeasurementInitiation._val = 52
    
    #-----< id-E-CIDMeasurementFailureIndication >-----#
    id_E_CIDMeasurementFailureIndication = INT(name='id-E-CIDMeasurementFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_E_CIDMeasurementFailureIndication._val = 53
    
    #-----< id-E-CIDMeasurementReport >-----#
    id_E_CIDMeasurementReport = INT(name='id-E-CIDMeasurementReport', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_E_CIDMeasurementReport._val = 54
    
    #-----< id-E-CIDMeasurementTermination >-----#
    id_E_CIDMeasurementTermination = INT(name='id-E-CIDMeasurementTermination', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_E_CIDMeasurementTermination._val = 55
    
    #-----< id-PositioningInformationUpdate >-----#
    id_PositioningInformationUpdate = INT(name='id-PositioningInformationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PositioningInformationUpdate._val = 56
    
    #-----< id-ReferenceTimeInformationReport >-----#
    id_ReferenceTimeInformationReport = INT(name='id-ReferenceTimeInformationReport', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_ReferenceTimeInformationReport._val = 57
    
    #-----< id-ReferenceTimeInformationReportingControl >-----#
    id_ReferenceTimeInformationReportingControl = INT(name='id-ReferenceTimeInformationReportingControl', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_ReferenceTimeInformationReportingControl._val = 58
    
    #-----< id-BroadcastContextSetup >-----#
    id_BroadcastContextSetup = INT(name='id-BroadcastContextSetup', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_BroadcastContextSetup._val = 59
    
    #-----< id-BroadcastContextRelease >-----#
    id_BroadcastContextRelease = INT(name='id-BroadcastContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_BroadcastContextRelease._val = 60
    
    #-----< id-BroadcastContextReleaseRequest >-----#
    id_BroadcastContextReleaseRequest = INT(name='id-BroadcastContextReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_BroadcastContextReleaseRequest._val = 61
    
    #-----< id-BroadcastContextModification >-----#
    id_BroadcastContextModification = INT(name='id-BroadcastContextModification', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_BroadcastContextModification._val = 62
    
    #-----< id-MulticastGroupPaging >-----#
    id_MulticastGroupPaging = INT(name='id-MulticastGroupPaging', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_MulticastGroupPaging._val = 63
    
    #-----< id-MulticastContextSetup >-----#
    id_MulticastContextSetup = INT(name='id-MulticastContextSetup', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_MulticastContextSetup._val = 64
    
    #-----< id-MulticastContextRelease >-----#
    id_MulticastContextRelease = INT(name='id-MulticastContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_MulticastContextRelease._val = 65
    
    #-----< id-MulticastContextReleaseRequest >-----#
    id_MulticastContextReleaseRequest = INT(name='id-MulticastContextReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_MulticastContextReleaseRequest._val = 66
    
    #-----< id-MulticastContextModification >-----#
    id_MulticastContextModification = INT(name='id-MulticastContextModification', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_MulticastContextModification._val = 67
    
    #-----< id-MulticastDistributionSetup >-----#
    id_MulticastDistributionSetup = INT(name='id-MulticastDistributionSetup', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_MulticastDistributionSetup._val = 68
    
    #-----< id-MulticastDistributionRelease >-----#
    id_MulticastDistributionRelease = INT(name='id-MulticastDistributionRelease', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_MulticastDistributionRelease._val = 69
    
    #-----< id-PDCMeasurementInitiation >-----#
    id_PDCMeasurementInitiation = INT(name='id-PDCMeasurementInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PDCMeasurementInitiation._val = 70
    
    #-----< id-PDCMeasurementReport >-----#
    id_PDCMeasurementReport = INT(name='id-PDCMeasurementReport', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PDCMeasurementReport._val = 71
    
    #-----< id-PDCMeasurementInitiationRequest >-----#
    id_PDCMeasurementInitiationRequest = INT(name='id-PDCMeasurementInitiationRequest', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PDCMeasurementInitiationRequest._val = 72
    
    #-----< id-PDCMeasurementInitiationResponse >-----#
    id_PDCMeasurementInitiationResponse = INT(name='id-PDCMeasurementInitiationResponse', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PDCMeasurementInitiationResponse._val = 73
    
    #-----< id-PDCMeasurementInitiationFailure >-----#
    id_PDCMeasurementInitiationFailure = INT(name='id-PDCMeasurementInitiationFailure', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PDCMeasurementInitiationFailure._val = 74
    
    #-----< id-pRSConfigurationExchange >-----#
    id_pRSConfigurationExchange = INT(name='id-pRSConfigurationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_pRSConfigurationExchange._val = 75
    
    #-----< id-measurementPreconfiguration >-----#
    id_measurementPreconfiguration = INT(name='id-measurementPreconfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_measurementPreconfiguration._val = 76
    
    #-----< id-measurementActivation >-----#
    id_measurementActivation = INT(name='id-measurementActivation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_measurementActivation._val = 77
    
    #-----< id-QoEInformationTransfer >-----#
    id_QoEInformationTransfer = INT(name='id-QoEInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_QoEInformationTransfer._val = 78
    
    #-----< id-PDCMeasurementTerminationCommand >-----#
    id_PDCMeasurementTerminationCommand = INT(name='id-PDCMeasurementTerminationCommand', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PDCMeasurementTerminationCommand._val = 79
    
    #-----< id-PDCMeasurementFailureIndication >-----#
    id_PDCMeasurementFailureIndication = INT(name='id-PDCMeasurementFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PDCMeasurementFailureIndication._val = 80
    
    #-----< id-PosSystemInformationDeliveryCommand >-----#
    id_PosSystemInformationDeliveryCommand = INT(name='id-PosSystemInformationDeliveryCommand', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')))
    id_PosSystemInformationDeliveryCommand._val = 81
    
    #-----< maxPrivateIEs >-----#
    maxPrivateIEs = INT(name='maxPrivateIEs', mode=MODE_VALUE)
    maxPrivateIEs._val = 65535
    
    #-----< maxProtocolExtensions >-----#
    maxProtocolExtensions = INT(name='maxProtocolExtensions', mode=MODE_VALUE)
    maxProtocolExtensions._val = 65535
    
    #-----< maxProtocolIEs >-----#
    maxProtocolIEs = INT(name='maxProtocolIEs', mode=MODE_VALUE)
    maxProtocolIEs._val = 65535
    
    #-----< maxNRARFCN >-----#
    maxNRARFCN = INT(name='maxNRARFCN', mode=MODE_VALUE)
    maxNRARFCN._val = 3279165
    
    #-----< maxnoofErrors >-----#
    maxnoofErrors = INT(name='maxnoofErrors', mode=MODE_VALUE)
    maxnoofErrors._val = 256
    
    #-----< maxnoofIndividualF1ConnectionsToReset >-----#
    maxnoofIndividualF1ConnectionsToReset = INT(name='maxnoofIndividualF1ConnectionsToReset', mode=MODE_VALUE)
    maxnoofIndividualF1ConnectionsToReset._val = 65536
    
    #-----< maxCellingNBDU >-----#
    maxCellingNBDU = INT(name='maxCellingNBDU', mode=MODE_VALUE)
    maxCellingNBDU._val = 512
    
    #-----< maxnoofSCells >-----#
    maxnoofSCells = INT(name='maxnoofSCells', mode=MODE_VALUE)
    maxnoofSCells._val = 32
    
    #-----< maxnoofSRBs >-----#
    maxnoofSRBs = INT(name='maxnoofSRBs', mode=MODE_VALUE)
    maxnoofSRBs._val = 8
    
    #-----< maxnoofDRBs >-----#
    maxnoofDRBs = INT(name='maxnoofDRBs', mode=MODE_VALUE)
    maxnoofDRBs._val = 64
    
    #-----< maxnoofULUPTNLInformation >-----#
    maxnoofULUPTNLInformation = INT(name='maxnoofULUPTNLInformation', mode=MODE_VALUE)
    maxnoofULUPTNLInformation._val = 2
    
    #-----< maxnoofDLUPTNLInformation >-----#
    maxnoofDLUPTNLInformation = INT(name='maxnoofDLUPTNLInformation', mode=MODE_VALUE)
    maxnoofDLUPTNLInformation._val = 2
    
    #-----< maxnoofBPLMNs >-----#
    maxnoofBPLMNs = INT(name='maxnoofBPLMNs', mode=MODE_VALUE)
    maxnoofBPLMNs._val = 6
    
    #-----< maxnoofCandidateSpCells >-----#
    maxnoofCandidateSpCells = INT(name='maxnoofCandidateSpCells', mode=MODE_VALUE)
    maxnoofCandidateSpCells._val = 64
    
    #-----< maxnoofPotentialSpCells >-----#
    maxnoofPotentialSpCells = INT(name='maxnoofPotentialSpCells', mode=MODE_VALUE)
    maxnoofPotentialSpCells._val = 64
    
    #-----< maxnoofNrCellBands >-----#
    maxnoofNrCellBands = INT(name='maxnoofNrCellBands', mode=MODE_VALUE)
    maxnoofNrCellBands._val = 32
    
    #-----< maxnoofSIBTypes >-----#
    maxnoofSIBTypes = INT(name='maxnoofSIBTypes', mode=MODE_VALUE)
    maxnoofSIBTypes._val = 32
    
    #-----< maxnoofSITypes >-----#
    maxnoofSITypes = INT(name='maxnoofSITypes', mode=MODE_VALUE)
    maxnoofSITypes._val = 32
    
    #-----< maxnoofPagingCells >-----#
    maxnoofPagingCells = INT(name='maxnoofPagingCells', mode=MODE_VALUE)
    maxnoofPagingCells._val = 512
    
    #-----< maxnoofTNLAssociations >-----#
    maxnoofTNLAssociations = INT(name='maxnoofTNLAssociations', mode=MODE_VALUE)
    maxnoofTNLAssociations._val = 32
    
    #-----< maxnoofQoSFlows >-----#
    maxnoofQoSFlows = INT(name='maxnoofQoSFlows', mode=MODE_VALUE)
    maxnoofQoSFlows._val = 64
    
    #-----< maxnoofSliceItems >-----#
    maxnoofSliceItems = INT(name='maxnoofSliceItems', mode=MODE_VALUE)
    maxnoofSliceItems._val = 1024
    
    #-----< maxCellineNB >-----#
    maxCellineNB = INT(name='maxCellineNB', mode=MODE_VALUE)
    maxCellineNB._val = 256
    
    #-----< maxnoofExtendedBPLMNs >-----#
    maxnoofExtendedBPLMNs = INT(name='maxnoofExtendedBPLMNs', mode=MODE_VALUE)
    maxnoofExtendedBPLMNs._val = 6
    
    #-----< maxnoofUEIDs >-----#
    maxnoofUEIDs = INT(name='maxnoofUEIDs', mode=MODE_VALUE)
    maxnoofUEIDs._val = 65536
    
    #-----< maxnoofBPLMNsNR >-----#
    maxnoofBPLMNsNR = INT(name='maxnoofBPLMNsNR', mode=MODE_VALUE)
    maxnoofBPLMNsNR._val = 12
    
    #-----< maxnoofUACPLMNs >-----#
    maxnoofUACPLMNs = INT(name='maxnoofUACPLMNs', mode=MODE_VALUE)
    maxnoofUACPLMNs._val = 12
    
    #-----< maxnoofUACperPLMN >-----#
    maxnoofUACperPLMN = INT(name='maxnoofUACperPLMN', mode=MODE_VALUE)
    maxnoofUACperPLMN._val = 64
    
    #-----< maxnoofAdditionalSIBs >-----#
    maxnoofAdditionalSIBs = INT(name='maxnoofAdditionalSIBs', mode=MODE_VALUE)
    maxnoofAdditionalSIBs._val = 63
    
    #-----< maxnoofslots >-----#
    maxnoofslots = INT(name='maxnoofslots', mode=MODE_VALUE)
    maxnoofslots._val = 5120
    
    #-----< maxnoofTLAs >-----#
    maxnoofTLAs = INT(name='maxnoofTLAs', mode=MODE_VALUE)
    maxnoofTLAs._val = 16
    
    #-----< maxnoofGTPTLAs >-----#
    maxnoofGTPTLAs = INT(name='maxnoofGTPTLAs', mode=MODE_VALUE)
    maxnoofGTPTLAs._val = 16
    
    #-----< maxnoofBHRLCChannels >-----#
    maxnoofBHRLCChannels = INT(name='maxnoofBHRLCChannels', mode=MODE_VALUE)
    maxnoofBHRLCChannels._val = 65536
    
    #-----< maxnoofRoutingEntries >-----#
    maxnoofRoutingEntries = INT(name='maxnoofRoutingEntries', mode=MODE_VALUE)
    maxnoofRoutingEntries._val = 1024
    
    #-----< maxnoofIABSTCInfo >-----#
    maxnoofIABSTCInfo = INT(name='maxnoofIABSTCInfo', mode=MODE_VALUE)
    maxnoofIABSTCInfo._val = 45
    
    #-----< maxnoofSymbols >-----#
    maxnoofSymbols = INT(name='maxnoofSymbols', mode=MODE_VALUE)
    maxnoofSymbols._val = 14
    
    #-----< maxnoofServingCells >-----#
    maxnoofServingCells = INT(name='maxnoofServingCells', mode=MODE_VALUE)
    maxnoofServingCells._val = 32
    
    #-----< maxnoofDUFSlots >-----#
    maxnoofDUFSlots = INT(name='maxnoofDUFSlots', mode=MODE_VALUE)
    maxnoofDUFSlots._val = 320
    
    #-----< maxnoofHSNASlots >-----#
    maxnoofHSNASlots = INT(name='maxnoofHSNASlots', mode=MODE_VALUE)
    maxnoofHSNASlots._val = 5120
    
    #-----< maxnoofServedCellsIAB >-----#
    maxnoofServedCellsIAB = INT(name='maxnoofServedCellsIAB', mode=MODE_VALUE)
    maxnoofServedCellsIAB._val = 512
    
    #-----< maxnoofChildIABNodes >-----#
    maxnoofChildIABNodes = INT(name='maxnoofChildIABNodes', mode=MODE_VALUE)
    maxnoofChildIABNodes._val = 1024
    
    #-----< maxnoofNonUPTrafficMappings >-----#
    maxnoofNonUPTrafficMappings = INT(name='maxnoofNonUPTrafficMappings', mode=MODE_VALUE)
    maxnoofNonUPTrafficMappings._val = 32
    
    #-----< maxnoofTLAsIAB >-----#
    maxnoofTLAsIAB = INT(name='maxnoofTLAsIAB', mode=MODE_VALUE)
    maxnoofTLAsIAB._val = 1024
    
    #-----< maxnoofMappingEntries >-----#
    maxnoofMappingEntries = INT(name='maxnoofMappingEntries', mode=MODE_VALUE)
    maxnoofMappingEntries._val = 67108864
    
    #-----< maxnoofDSInfo >-----#
    maxnoofDSInfo = INT(name='maxnoofDSInfo', mode=MODE_VALUE)
    maxnoofDSInfo._val = 64
    
    #-----< maxnoofEgressLinks >-----#
    maxnoofEgressLinks = INT(name='maxnoofEgressLinks', mode=MODE_VALUE)
    maxnoofEgressLinks._val = 2
    
    #-----< maxnoofULUPTNLInformationforIAB >-----#
    maxnoofULUPTNLInformationforIAB = INT(name='maxnoofULUPTNLInformationforIAB', mode=MODE_VALUE)
    maxnoofULUPTNLInformationforIAB._val = 32678
    
    #-----< maxnoofUPTNLAddresses >-----#
    maxnoofUPTNLAddresses = INT(name='maxnoofUPTNLAddresses', mode=MODE_VALUE)
    maxnoofUPTNLAddresses._val = 8
    
    #-----< maxnoofSLDRBs >-----#
    maxnoofSLDRBs = INT(name='maxnoofSLDRBs', mode=MODE_VALUE)
    maxnoofSLDRBs._val = 512
    
    #-----< maxnoofQoSParaSets >-----#
    maxnoofQoSParaSets = INT(name='maxnoofQoSParaSets', mode=MODE_VALUE)
    maxnoofQoSParaSets._val = 8
    
    #-----< maxnoofPC5QoSFlows >-----#
    maxnoofPC5QoSFlows = INT(name='maxnoofPC5QoSFlows', mode=MODE_VALUE)
    maxnoofPC5QoSFlows._val = 2048
    
    #-----< maxnoofSSBAreas >-----#
    maxnoofSSBAreas = INT(name='maxnoofSSBAreas', mode=MODE_VALUE)
    maxnoofSSBAreas._val = 64
    
    #-----< maxnoofPhysicalResourceBlocks >-----#
    maxnoofPhysicalResourceBlocks = INT(name='maxnoofPhysicalResourceBlocks', mode=MODE_VALUE)
    maxnoofPhysicalResourceBlocks._val = 275
    
    #-----< maxnoofPhysicalResourceBlocks-1 >-----#
    maxnoofPhysicalResourceBlocks_1 = INT(name='maxnoofPhysicalResourceBlocks-1', mode=MODE_VALUE)
    maxnoofPhysicalResourceBlocks_1._val = 274
    
    #-----< maxnoofPRACHconfigs >-----#
    maxnoofPRACHconfigs = INT(name='maxnoofPRACHconfigs', mode=MODE_VALUE)
    maxnoofPRACHconfigs._val = 16
    
    #-----< maxnoofRACHReports >-----#
    maxnoofRACHReports = INT(name='maxnoofRACHReports', mode=MODE_VALUE)
    maxnoofRACHReports._val = 64
    
    #-----< maxnoofRLFReports >-----#
    maxnoofRLFReports = INT(name='maxnoofRLFReports', mode=MODE_VALUE)
    maxnoofRLFReports._val = 64
    
    #-----< maxnoofAdditionalPDCPDuplicationTNL >-----#
    maxnoofAdditionalPDCPDuplicationTNL = INT(name='maxnoofAdditionalPDCPDuplicationTNL', mode=MODE_VALUE)
    maxnoofAdditionalPDCPDuplicationTNL._val = 2
    
    #-----< maxnoofRLCDuplicationState >-----#
    maxnoofRLCDuplicationState = INT(name='maxnoofRLCDuplicationState', mode=MODE_VALUE)
    maxnoofRLCDuplicationState._val = 3
    
    #-----< maxnoofCHOcells >-----#
    maxnoofCHOcells = INT(name='maxnoofCHOcells', mode=MODE_VALUE)
    maxnoofCHOcells._val = 8
    
    #-----< maxnoofMDTPLMNs >-----#
    maxnoofMDTPLMNs = INT(name='maxnoofMDTPLMNs', mode=MODE_VALUE)
    maxnoofMDTPLMNs._val = 16
    
    #-----< maxnoofCAGsupported >-----#
    maxnoofCAGsupported = INT(name='maxnoofCAGsupported', mode=MODE_VALUE)
    maxnoofCAGsupported._val = 12
    
    #-----< maxnoofNIDsupported >-----#
    maxnoofNIDsupported = INT(name='maxnoofNIDsupported', mode=MODE_VALUE)
    maxnoofNIDsupported._val = 12
    
    #-----< maxnoofNRSCSs >-----#
    maxnoofNRSCSs = INT(name='maxnoofNRSCSs', mode=MODE_VALUE)
    maxnoofNRSCSs._val = 5
    
    #-----< maxnoofExtSliceItems >-----#
    maxnoofExtSliceItems = INT(name='maxnoofExtSliceItems', mode=MODE_VALUE)
    maxnoofExtSliceItems._val = 65535
    
    #-----< maxnoofPosMeas >-----#
    maxnoofPosMeas = INT(name='maxnoofPosMeas', mode=MODE_VALUE)
    maxnoofPosMeas._val = 16384
    
    #-----< maxnoofTRPInfoTypes >-----#
    maxnoofTRPInfoTypes = INT(name='maxnoofTRPInfoTypes', mode=MODE_VALUE)
    maxnoofTRPInfoTypes._val = 64
    
    #-----< maxnoofTRPs >-----#
    maxnoofTRPs = INT(name='maxnoofTRPs', mode=MODE_VALUE)
    maxnoofTRPs._val = 65535
    
    #-----< maxnoofSRSTriggerStates >-----#
    maxnoofSRSTriggerStates = INT(name='maxnoofSRSTriggerStates', mode=MODE_VALUE)
    maxnoofSRSTriggerStates._val = 3
    
    #-----< maxnoofSpatialRelations >-----#
    maxnoofSpatialRelations = INT(name='maxnoofSpatialRelations', mode=MODE_VALUE)
    maxnoofSpatialRelations._val = 64
    
    #-----< maxnoBcastCell >-----#
    maxnoBcastCell = INT(name='maxnoBcastCell', mode=MODE_VALUE)
    maxnoBcastCell._val = 16384
    
    #-----< maxnoofAngleInfo >-----#
    maxnoofAngleInfo = INT(name='maxnoofAngleInfo', mode=MODE_VALUE)
    maxnoofAngleInfo._val = 65535
    
    #-----< maxnooflcs-gcs-translation >-----#
    maxnooflcs_gcs_translation = INT(name='maxnooflcs-gcs-translation', mode=MODE_VALUE)
    maxnooflcs_gcs_translation._val = 3
    
    #-----< maxnoofPath >-----#
    maxnoofPath = INT(name='maxnoofPath', mode=MODE_VALUE)
    maxnoofPath._val = 2
    
    #-----< maxnoofMeasE-CID >-----#
    maxnoofMeasE_CID = INT(name='maxnoofMeasE-CID', mode=MODE_VALUE)
    maxnoofMeasE_CID._val = 64
    
    #-----< maxnoofSSBs >-----#
    maxnoofSSBs = INT(name='maxnoofSSBs', mode=MODE_VALUE)
    maxnoofSSBs._val = 255
    
    #-----< maxnoSRS-ResourceSets >-----#
    maxnoSRS_ResourceSets = INT(name='maxnoSRS-ResourceSets', mode=MODE_VALUE)
    maxnoSRS_ResourceSets._val = 16
    
    #-----< maxnoSRS-ResourcePerSet >-----#
    maxnoSRS_ResourcePerSet = INT(name='maxnoSRS-ResourcePerSet', mode=MODE_VALUE)
    maxnoSRS_ResourcePerSet._val = 16
    
    #-----< maxnoSRS-Carriers >-----#
    maxnoSRS_Carriers = INT(name='maxnoSRS-Carriers', mode=MODE_VALUE)
    maxnoSRS_Carriers._val = 32
    
    #-----< maxnoSCSs >-----#
    maxnoSCSs = INT(name='maxnoSCSs', mode=MODE_VALUE)
    maxnoSCSs._val = 5
    
    #-----< maxnoSRS-Resources >-----#
    maxnoSRS_Resources = INT(name='maxnoSRS-Resources', mode=MODE_VALUE)
    maxnoSRS_Resources._val = 64
    
    #-----< maxnoSRS-PosResources >-----#
    maxnoSRS_PosResources = INT(name='maxnoSRS-PosResources', mode=MODE_VALUE)
    maxnoSRS_PosResources._val = 64
    
    #-----< maxnoSRS-PosResourceSets >-----#
    maxnoSRS_PosResourceSets = INT(name='maxnoSRS-PosResourceSets', mode=MODE_VALUE)
    maxnoSRS_PosResourceSets._val = 16
    
    #-----< maxnoSRS-PosResourcePerSet >-----#
    maxnoSRS_PosResourcePerSet = INT(name='maxnoSRS-PosResourcePerSet', mode=MODE_VALUE)
    maxnoSRS_PosResourcePerSet._val = 16
    
    #-----< maxnoofPRS-ResourceSets >-----#
    maxnoofPRS_ResourceSets = INT(name='maxnoofPRS-ResourceSets', mode=MODE_VALUE)
    maxnoofPRS_ResourceSets._val = 2
    
    #-----< maxnoofPRS-ResourcesPerSet >-----#
    maxnoofPRS_ResourcesPerSet = INT(name='maxnoofPRS-ResourcesPerSet', mode=MODE_VALUE)
    maxnoofPRS_ResourcesPerSet._val = 64
    
    #-----< maxNoOfMeasTRPs >-----#
    maxNoOfMeasTRPs = INT(name='maxNoOfMeasTRPs', mode=MODE_VALUE)
    maxNoOfMeasTRPs._val = 64
    
    #-----< maxnoofPRSresourceSets >-----#
    maxnoofPRSresourceSets = INT(name='maxnoofPRSresourceSets', mode=MODE_VALUE)
    maxnoofPRSresourceSets._val = 8
    
    #-----< maxnoofPRSresources >-----#
    maxnoofPRSresources = INT(name='maxnoofPRSresources', mode=MODE_VALUE)
    maxnoofPRSresources._val = 64
    
    #-----< maxnoofSuccessfulHOReports >-----#
    maxnoofSuccessfulHOReports = INT(name='maxnoofSuccessfulHOReports', mode=MODE_VALUE)
    maxnoofSuccessfulHOReports._val = 64
    
    #-----< maxnoofNR-UChannelIDs >-----#
    maxnoofNR_UChannelIDs = INT(name='maxnoofNR-UChannelIDs', mode=MODE_VALUE)
    maxnoofNR_UChannelIDs._val = 16
    
    #-----< maxServedCellforSON >-----#
    maxServedCellforSON = INT(name='maxServedCellforSON', mode=MODE_VALUE)
    maxServedCellforSON._val = 256
    
    #-----< maxNeighbourCellforSON >-----#
    maxNeighbourCellforSON = INT(name='maxNeighbourCellforSON', mode=MODE_VALUE)
    maxNeighbourCellforSON._val = 32
    
    #-----< maxAffectedCells >-----#
    maxAffectedCells = INT(name='maxAffectedCells', mode=MODE_VALUE)
    maxAffectedCells._val = 32
    
    #-----< maxnoofMRBs >-----#
    maxnoofMRBs = INT(name='maxnoofMRBs', mode=MODE_VALUE)
    maxnoofMRBs._val = 32
    
    #-----< maxnoofMBSQoSFlows >-----#
    maxnoofMBSQoSFlows = INT(name='maxnoofMBSQoSFlows', mode=MODE_VALUE)
    maxnoofMBSQoSFlows._val = 64
    
    #-----< maxnoofMBSFSAs >-----#
    maxnoofMBSFSAs = INT(name='maxnoofMBSFSAs', mode=MODE_VALUE)
    maxnoofMBSFSAs._val = 256
    
    #-----< maxnoofUEIDforPaging >-----#
    maxnoofUEIDforPaging = INT(name='maxnoofUEIDforPaging', mode=MODE_VALUE)
    maxnoofUEIDforPaging._val = 4096
    
    #-----< maxnoofCellsforMBS >-----#
    maxnoofCellsforMBS = INT(name='maxnoofCellsforMBS', mode=MODE_VALUE)
    maxnoofCellsforMBS._val = 512
    
    #-----< maxnoofTAIforMBS >-----#
    maxnoofTAIforMBS = INT(name='maxnoofTAIforMBS', mode=MODE_VALUE)
    maxnoofTAIforMBS._val = 512
    
    #-----< maxnoofMBSAreaSessionIDs >-----#
    maxnoofMBSAreaSessionIDs = INT(name='maxnoofMBSAreaSessionIDs', mode=MODE_VALUE)
    maxnoofMBSAreaSessionIDs._val = 256
    
    #-----< maxnoofMBSServiceAreaInformation >-----#
    maxnoofMBSServiceAreaInformation = INT(name='maxnoofMBSServiceAreaInformation', mode=MODE_VALUE)
    maxnoofMBSServiceAreaInformation._val = 256
    
    #-----< maxnoofIABCongInd >-----#
    maxnoofIABCongInd = INT(name='maxnoofIABCongInd', mode=MODE_VALUE)
    maxnoofIABCongInd._val = 1024
    
    #-----< maxnoofNeighbourNodeCellsIAB >-----#
    maxnoofNeighbourNodeCellsIAB = INT(name='maxnoofNeighbourNodeCellsIAB', mode=MODE_VALUE)
    maxnoofNeighbourNodeCellsIAB._val = 1024
    
    #-----< maxnoofRBsetsPerCell >-----#
    maxnoofRBsetsPerCell = INT(name='maxnoofRBsetsPerCell', mode=MODE_VALUE)
    maxnoofRBsetsPerCell._val = 8
    
    #-----< maxnoofRBsetsPerCell-1 >-----#
    maxnoofRBsetsPerCell_1 = INT(name='maxnoofRBsetsPerCell-1', mode=MODE_VALUE)
    maxnoofRBsetsPerCell_1._val = 7
    
    #-----< maxnoofMeasPDC >-----#
    maxnoofMeasPDC = INT(name='maxnoofMeasPDC', mode=MODE_VALUE)
    maxnoofMeasPDC._val = 16
    
    #-----< maxnoARPs >-----#
    maxnoARPs = INT(name='maxnoARPs', mode=MODE_VALUE)
    maxnoARPs._val = 16
    
    #-----< maxnoofULAoAs >-----#
    maxnoofULAoAs = INT(name='maxnoofULAoAs', mode=MODE_VALUE)
    maxnoofULAoAs._val = 8
    
    #-----< maxNoPathExtended >-----#
    maxNoPathExtended = INT(name='maxNoPathExtended', mode=MODE_VALUE)
    maxNoPathExtended._val = 8
    
    #-----< maxnoTRPTEGs >-----#
    maxnoTRPTEGs = INT(name='maxnoTRPTEGs', mode=MODE_VALUE)
    maxnoTRPTEGs._val = 8
    
    #-----< maxFreqLayers >-----#
    maxFreqLayers = INT(name='maxFreqLayers', mode=MODE_VALUE)
    maxFreqLayers._val = 4
    
    #-----< maxNumResourcesPerAngle >-----#
    maxNumResourcesPerAngle = INT(name='maxNumResourcesPerAngle', mode=MODE_VALUE)
    maxNumResourcesPerAngle._val = 24
    
    #-----< maxnoAzimuthAngles >-----#
    maxnoAzimuthAngles = INT(name='maxnoAzimuthAngles', mode=MODE_VALUE)
    maxnoAzimuthAngles._val = 3600
    
    #-----< maxnoElevationAngles >-----#
    maxnoElevationAngles = INT(name='maxnoElevationAngles', mode=MODE_VALUE)
    maxnoElevationAngles._val = 1801
    
    #-----< maxnoofPRSTRPs >-----#
    maxnoofPRSTRPs = INT(name='maxnoofPRSTRPs', mode=MODE_VALUE)
    maxnoofPRSTRPs._val = 256
    
    #-----< maxnoofQoEInformation >-----#
    maxnoofQoEInformation = INT(name='maxnoofQoEInformation', mode=MODE_VALUE)
    maxnoofQoEInformation._val = 16
    
    #-----< maxnoofUuRLCChannels >-----#
    maxnoofUuRLCChannels = INT(name='maxnoofUuRLCChannels', mode=MODE_VALUE)
    maxnoofUuRLCChannels._val = 32
    
    #-----< maxnoofPC5RLCChannels >-----#
    maxnoofPC5RLCChannels = INT(name='maxnoofPC5RLCChannels', mode=MODE_VALUE)
    maxnoofPC5RLCChannels._val = 512
    
    #-----< maxnoofSMBRValues >-----#
    maxnoofSMBRValues = INT(name='maxnoofSMBRValues', mode=MODE_VALUE)
    maxnoofSMBRValues._val = 8
    
    #-----< maxnoofMRBsforUE >-----#
    maxnoofMRBsforUE = INT(name='maxnoofMRBsforUE', mode=MODE_VALUE)
    maxnoofMRBsforUE._val = 64
    
    #-----< maxnoofMBSSessionsofUE >-----#
    maxnoofMBSSessionsofUE = INT(name='maxnoofMBSSessionsofUE', mode=MODE_VALUE)
    maxnoofMBSSessionsofUE._val = 256
    
    #-----< maxnoofSLdestinations >-----#
    maxnoofSLdestinations = INT(name='maxnoofSLdestinations', mode=MODE_VALUE)
    maxnoofSLdestinations._val = 32
    
    #-----< maxnoofNSAGs >-----#
    maxnoofNSAGs = INT(name='maxnoofNSAGs', mode=MODE_VALUE)
    maxnoofNSAGs._val = 256
    
    #-----< maxnoofSDTBearers >-----#
    maxnoofSDTBearers = INT(name='maxnoofSDTBearers', mode=MODE_VALUE)
    maxnoofSDTBearers._val = 72
    
    #-----< maxnoofServingCellMOs >-----#
    maxnoofServingCellMOs = INT(name='maxnoofServingCellMOs', mode=MODE_VALUE)
    maxnoofServingCellMOs._val = 16
    
    #-----< maxNrofBWPs >-----#
    maxNrofBWPs = INT(name='maxNrofBWPs', mode=MODE_VALUE)
    maxNrofBWPs._val = 8
    
    #-----< maxnoofPosSITypes >-----#
    maxnoofPosSITypes = INT(name='maxnoofPosSITypes', mode=MODE_VALUE)
    maxnoofPosSITypes._val = 32
    
    #-----< id-Cause >-----#
    id_Cause = INT(name='id-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cause._val = 0
    
    #-----< id-Cells-Failed-to-be-Activated-List >-----#
    id_Cells_Failed_to_be_Activated_List = INT(name='id-Cells-Failed-to-be-Activated-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_Failed_to_be_Activated_List._val = 1
    
    #-----< id-Cells-Failed-to-be-Activated-List-Item >-----#
    id_Cells_Failed_to_be_Activated_List_Item = INT(name='id-Cells-Failed-to-be-Activated-List-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_Failed_to_be_Activated_List_Item._val = 2
    
    #-----< id-Cells-to-be-Activated-List >-----#
    id_Cells_to_be_Activated_List = INT(name='id-Cells-to-be-Activated-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_to_be_Activated_List._val = 3
    
    #-----< id-Cells-to-be-Activated-List-Item >-----#
    id_Cells_to_be_Activated_List_Item = INT(name='id-Cells-to-be-Activated-List-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_to_be_Activated_List_Item._val = 4
    
    #-----< id-Cells-to-be-Deactivated-List >-----#
    id_Cells_to_be_Deactivated_List = INT(name='id-Cells-to-be-Deactivated-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_to_be_Deactivated_List._val = 5
    
    #-----< id-Cells-to-be-Deactivated-List-Item >-----#
    id_Cells_to_be_Deactivated_List_Item = INT(name='id-Cells-to-be-Deactivated-List-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_to_be_Deactivated_List_Item._val = 6
    
    #-----< id-CriticalityDiagnostics >-----#
    id_CriticalityDiagnostics = INT(name='id-CriticalityDiagnostics', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CriticalityDiagnostics._val = 7
    
    #-----< id-CUtoDURRCInformation >-----#
    id_CUtoDURRCInformation = INT(name='id-CUtoDURRCInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CUtoDURRCInformation._val = 9
    
    #-----< id-DRBs-FailedToBeModified-Item >-----#
    id_DRBs_FailedToBeModified_Item = INT(name='id-DRBs-FailedToBeModified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_FailedToBeModified_Item._val = 12
    
    #-----< id-DRBs-FailedToBeModified-List >-----#
    id_DRBs_FailedToBeModified_List = INT(name='id-DRBs-FailedToBeModified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_FailedToBeModified_List._val = 13
    
    #-----< id-DRBs-FailedToBeSetup-Item >-----#
    id_DRBs_FailedToBeSetup_Item = INT(name='id-DRBs-FailedToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_FailedToBeSetup_Item._val = 14
    
    #-----< id-DRBs-FailedToBeSetup-List >-----#
    id_DRBs_FailedToBeSetup_List = INT(name='id-DRBs-FailedToBeSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_FailedToBeSetup_List._val = 15
    
    #-----< id-DRBs-FailedToBeSetupMod-Item >-----#
    id_DRBs_FailedToBeSetupMod_Item = INT(name='id-DRBs-FailedToBeSetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_FailedToBeSetupMod_Item._val = 16
    
    #-----< id-DRBs-FailedToBeSetupMod-List >-----#
    id_DRBs_FailedToBeSetupMod_List = INT(name='id-DRBs-FailedToBeSetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_FailedToBeSetupMod_List._val = 17
    
    #-----< id-DRBs-ModifiedConf-Item >-----#
    id_DRBs_ModifiedConf_Item = INT(name='id-DRBs-ModifiedConf-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_ModifiedConf_Item._val = 18
    
    #-----< id-DRBs-ModifiedConf-List >-----#
    id_DRBs_ModifiedConf_List = INT(name='id-DRBs-ModifiedConf-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_ModifiedConf_List._val = 19
    
    #-----< id-DRBs-Modified-Item >-----#
    id_DRBs_Modified_Item = INT(name='id-DRBs-Modified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_Modified_Item._val = 20
    
    #-----< id-DRBs-Modified-List >-----#
    id_DRBs_Modified_List = INT(name='id-DRBs-Modified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_Modified_List._val = 21
    
    #-----< id-DRBs-Required-ToBeModified-Item >-----#
    id_DRBs_Required_ToBeModified_Item = INT(name='id-DRBs-Required-ToBeModified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_Required_ToBeModified_Item._val = 22
    
    #-----< id-DRBs-Required-ToBeModified-List >-----#
    id_DRBs_Required_ToBeModified_List = INT(name='id-DRBs-Required-ToBeModified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_Required_ToBeModified_List._val = 23
    
    #-----< id-DRBs-Required-ToBeReleased-Item >-----#
    id_DRBs_Required_ToBeReleased_Item = INT(name='id-DRBs-Required-ToBeReleased-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_Required_ToBeReleased_Item._val = 24
    
    #-----< id-DRBs-Required-ToBeReleased-List >-----#
    id_DRBs_Required_ToBeReleased_List = INT(name='id-DRBs-Required-ToBeReleased-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_Required_ToBeReleased_List._val = 25
    
    #-----< id-DRBs-Setup-Item >-----#
    id_DRBs_Setup_Item = INT(name='id-DRBs-Setup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_Setup_Item._val = 26
    
    #-----< id-DRBs-Setup-List >-----#
    id_DRBs_Setup_List = INT(name='id-DRBs-Setup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_Setup_List._val = 27
    
    #-----< id-DRBs-SetupMod-Item >-----#
    id_DRBs_SetupMod_Item = INT(name='id-DRBs-SetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_SetupMod_Item._val = 28
    
    #-----< id-DRBs-SetupMod-List >-----#
    id_DRBs_SetupMod_List = INT(name='id-DRBs-SetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_SetupMod_List._val = 29
    
    #-----< id-DRBs-ToBeModified-Item >-----#
    id_DRBs_ToBeModified_Item = INT(name='id-DRBs-ToBeModified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_ToBeModified_Item._val = 30
    
    #-----< id-DRBs-ToBeModified-List >-----#
    id_DRBs_ToBeModified_List = INT(name='id-DRBs-ToBeModified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_ToBeModified_List._val = 31
    
    #-----< id-DRBs-ToBeReleased-Item >-----#
    id_DRBs_ToBeReleased_Item = INT(name='id-DRBs-ToBeReleased-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_ToBeReleased_Item._val = 32
    
    #-----< id-DRBs-ToBeReleased-List >-----#
    id_DRBs_ToBeReleased_List = INT(name='id-DRBs-ToBeReleased-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_ToBeReleased_List._val = 33
    
    #-----< id-DRBs-ToBeSetup-Item >-----#
    id_DRBs_ToBeSetup_Item = INT(name='id-DRBs-ToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_ToBeSetup_Item._val = 34
    
    #-----< id-DRBs-ToBeSetup-List >-----#
    id_DRBs_ToBeSetup_List = INT(name='id-DRBs-ToBeSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_ToBeSetup_List._val = 35
    
    #-----< id-DRBs-ToBeSetupMod-Item >-----#
    id_DRBs_ToBeSetupMod_Item = INT(name='id-DRBs-ToBeSetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_ToBeSetupMod_Item._val = 36
    
    #-----< id-DRBs-ToBeSetupMod-List >-----#
    id_DRBs_ToBeSetupMod_List = INT(name='id-DRBs-ToBeSetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBs_ToBeSetupMod_List._val = 37
    
    #-----< id-DRXCycle >-----#
    id_DRXCycle = INT(name='id-DRXCycle', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRXCycle._val = 38
    
    #-----< id-DUtoCURRCInformation >-----#
    id_DUtoCURRCInformation = INT(name='id-DUtoCURRCInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DUtoCURRCInformation._val = 39
    
    #-----< id-gNB-CU-UE-F1AP-ID >-----#
    id_gNB_CU_UE_F1AP_ID = INT(name='id-gNB-CU-UE-F1AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNB_CU_UE_F1AP_ID._val = 40
    
    #-----< id-gNB-DU-UE-F1AP-ID >-----#
    id_gNB_DU_UE_F1AP_ID = INT(name='id-gNB-DU-UE-F1AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNB_DU_UE_F1AP_ID._val = 41
    
    #-----< id-gNB-DU-ID >-----#
    id_gNB_DU_ID = INT(name='id-gNB-DU-ID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNB_DU_ID._val = 42
    
    #-----< id-GNB-DU-Served-Cells-Item >-----#
    id_GNB_DU_Served_Cells_Item = INT(name='id-GNB-DU-Served-Cells-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_DU_Served_Cells_Item._val = 43
    
    #-----< id-gNB-DU-Served-Cells-List >-----#
    id_gNB_DU_Served_Cells_List = INT(name='id-gNB-DU-Served-Cells-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNB_DU_Served_Cells_List._val = 44
    
    #-----< id-gNB-DU-Name >-----#
    id_gNB_DU_Name = INT(name='id-gNB-DU-Name', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNB_DU_Name._val = 45
    
    #-----< id-NRCellID >-----#
    id_NRCellID = INT(name='id-NRCellID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRCellID._val = 46
    
    #-----< id-oldgNB-DU-UE-F1AP-ID >-----#
    id_oldgNB_DU_UE_F1AP_ID = INT(name='id-oldgNB-DU-UE-F1AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_oldgNB_DU_UE_F1AP_ID._val = 47
    
    #-----< id-ResetType >-----#
    id_ResetType = INT(name='id-ResetType', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResetType._val = 48
    
    #-----< id-ResourceCoordinationTransferContainer >-----#
    id_ResourceCoordinationTransferContainer = INT(name='id-ResourceCoordinationTransferContainer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResourceCoordinationTransferContainer._val = 49
    
    #-----< id-RRCContainer >-----#
    id_RRCContainer = INT(name='id-RRCContainer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRCContainer._val = 50
    
    #-----< id-SCell-ToBeRemoved-Item >-----#
    id_SCell_ToBeRemoved_Item = INT(name='id-SCell-ToBeRemoved-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCell_ToBeRemoved_Item._val = 51
    
    #-----< id-SCell-ToBeRemoved-List >-----#
    id_SCell_ToBeRemoved_List = INT(name='id-SCell-ToBeRemoved-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCell_ToBeRemoved_List._val = 52
    
    #-----< id-SCell-ToBeSetup-Item >-----#
    id_SCell_ToBeSetup_Item = INT(name='id-SCell-ToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCell_ToBeSetup_Item._val = 53
    
    #-----< id-SCell-ToBeSetup-List >-----#
    id_SCell_ToBeSetup_List = INT(name='id-SCell-ToBeSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCell_ToBeSetup_List._val = 54
    
    #-----< id-SCell-ToBeSetupMod-Item >-----#
    id_SCell_ToBeSetupMod_Item = INT(name='id-SCell-ToBeSetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCell_ToBeSetupMod_Item._val = 55
    
    #-----< id-SCell-ToBeSetupMod-List >-----#
    id_SCell_ToBeSetupMod_List = INT(name='id-SCell-ToBeSetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCell_ToBeSetupMod_List._val = 56
    
    #-----< id-Served-Cells-To-Add-Item >-----#
    id_Served_Cells_To_Add_Item = INT(name='id-Served-Cells-To-Add-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Served_Cells_To_Add_Item._val = 57
    
    #-----< id-Served-Cells-To-Add-List >-----#
    id_Served_Cells_To_Add_List = INT(name='id-Served-Cells-To-Add-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Served_Cells_To_Add_List._val = 58
    
    #-----< id-Served-Cells-To-Delete-Item >-----#
    id_Served_Cells_To_Delete_Item = INT(name='id-Served-Cells-To-Delete-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Served_Cells_To_Delete_Item._val = 59
    
    #-----< id-Served-Cells-To-Delete-List >-----#
    id_Served_Cells_To_Delete_List = INT(name='id-Served-Cells-To-Delete-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Served_Cells_To_Delete_List._val = 60
    
    #-----< id-Served-Cells-To-Modify-Item >-----#
    id_Served_Cells_To_Modify_Item = INT(name='id-Served-Cells-To-Modify-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Served_Cells_To_Modify_Item._val = 61
    
    #-----< id-Served-Cells-To-Modify-List >-----#
    id_Served_Cells_To_Modify_List = INT(name='id-Served-Cells-To-Modify-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Served_Cells_To_Modify_List._val = 62
    
    #-----< id-SpCell-ID >-----#
    id_SpCell_ID = INT(name='id-SpCell-ID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SpCell_ID._val = 63
    
    #-----< id-SRBID >-----#
    id_SRBID = INT(name='id-SRBID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBID._val = 64
    
    #-----< id-SRBs-FailedToBeSetup-Item >-----#
    id_SRBs_FailedToBeSetup_Item = INT(name='id-SRBs-FailedToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_FailedToBeSetup_Item._val = 65
    
    #-----< id-SRBs-FailedToBeSetup-List >-----#
    id_SRBs_FailedToBeSetup_List = INT(name='id-SRBs-FailedToBeSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_FailedToBeSetup_List._val = 66
    
    #-----< id-SRBs-FailedToBeSetupMod-Item >-----#
    id_SRBs_FailedToBeSetupMod_Item = INT(name='id-SRBs-FailedToBeSetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_FailedToBeSetupMod_Item._val = 67
    
    #-----< id-SRBs-FailedToBeSetupMod-List >-----#
    id_SRBs_FailedToBeSetupMod_List = INT(name='id-SRBs-FailedToBeSetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_FailedToBeSetupMod_List._val = 68
    
    #-----< id-SRBs-Required-ToBeReleased-Item >-----#
    id_SRBs_Required_ToBeReleased_Item = INT(name='id-SRBs-Required-ToBeReleased-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_Required_ToBeReleased_Item._val = 69
    
    #-----< id-SRBs-Required-ToBeReleased-List >-----#
    id_SRBs_Required_ToBeReleased_List = INT(name='id-SRBs-Required-ToBeReleased-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_Required_ToBeReleased_List._val = 70
    
    #-----< id-SRBs-ToBeReleased-Item >-----#
    id_SRBs_ToBeReleased_Item = INT(name='id-SRBs-ToBeReleased-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_ToBeReleased_Item._val = 71
    
    #-----< id-SRBs-ToBeReleased-List >-----#
    id_SRBs_ToBeReleased_List = INT(name='id-SRBs-ToBeReleased-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_ToBeReleased_List._val = 72
    
    #-----< id-SRBs-ToBeSetup-Item >-----#
    id_SRBs_ToBeSetup_Item = INT(name='id-SRBs-ToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_ToBeSetup_Item._val = 73
    
    #-----< id-SRBs-ToBeSetup-List >-----#
    id_SRBs_ToBeSetup_List = INT(name='id-SRBs-ToBeSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_ToBeSetup_List._val = 74
    
    #-----< id-SRBs-ToBeSetupMod-Item >-----#
    id_SRBs_ToBeSetupMod_Item = INT(name='id-SRBs-ToBeSetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_ToBeSetupMod_Item._val = 75
    
    #-----< id-SRBs-ToBeSetupMod-List >-----#
    id_SRBs_ToBeSetupMod_List = INT(name='id-SRBs-ToBeSetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_ToBeSetupMod_List._val = 76
    
    #-----< id-TimeToWait >-----#
    id_TimeToWait = INT(name='id-TimeToWait', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeToWait._val = 77
    
    #-----< id-TransactionID >-----#
    id_TransactionID = INT(name='id-TransactionID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransactionID._val = 78
    
    #-----< id-TransmissionActionIndicator >-----#
    id_TransmissionActionIndicator = INT(name='id-TransmissionActionIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransmissionActionIndicator._val = 79
    
    #-----< id-UE-associatedLogicalF1-ConnectionItem >-----#
    id_UE_associatedLogicalF1_ConnectionItem = INT(name='id-UE-associatedLogicalF1-ConnectionItem', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_associatedLogicalF1_ConnectionItem._val = 80
    
    #-----< id-UE-associatedLogicalF1-ConnectionListResAck >-----#
    id_UE_associatedLogicalF1_ConnectionListResAck = INT(name='id-UE-associatedLogicalF1-ConnectionListResAck', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_associatedLogicalF1_ConnectionListResAck._val = 81
    
    #-----< id-gNB-CU-Name >-----#
    id_gNB_CU_Name = INT(name='id-gNB-CU-Name', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNB_CU_Name._val = 82
    
    #-----< id-SCell-FailedtoSetup-List >-----#
    id_SCell_FailedtoSetup_List = INT(name='id-SCell-FailedtoSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCell_FailedtoSetup_List._val = 83
    
    #-----< id-SCell-FailedtoSetup-Item >-----#
    id_SCell_FailedtoSetup_Item = INT(name='id-SCell-FailedtoSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCell_FailedtoSetup_Item._val = 84
    
    #-----< id-SCell-FailedtoSetupMod-List >-----#
    id_SCell_FailedtoSetupMod_List = INT(name='id-SCell-FailedtoSetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCell_FailedtoSetupMod_List._val = 85
    
    #-----< id-SCell-FailedtoSetupMod-Item >-----#
    id_SCell_FailedtoSetupMod_Item = INT(name='id-SCell-FailedtoSetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCell_FailedtoSetupMod_Item._val = 86
    
    #-----< id-RRCReconfigurationCompleteIndicator >-----#
    id_RRCReconfigurationCompleteIndicator = INT(name='id-RRCReconfigurationCompleteIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRCReconfigurationCompleteIndicator._val = 87
    
    #-----< id-Cells-Status-Item >-----#
    id_Cells_Status_Item = INT(name='id-Cells-Status-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_Status_Item._val = 88
    
    #-----< id-Cells-Status-List >-----#
    id_Cells_Status_List = INT(name='id-Cells-Status-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_Status_List._val = 89
    
    #-----< id-Candidate-SpCell-List >-----#
    id_Candidate_SpCell_List = INT(name='id-Candidate-SpCell-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Candidate_SpCell_List._val = 90
    
    #-----< id-Candidate-SpCell-Item >-----#
    id_Candidate_SpCell_Item = INT(name='id-Candidate-SpCell-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Candidate_SpCell_Item._val = 91
    
    #-----< id-Potential-SpCell-List >-----#
    id_Potential_SpCell_List = INT(name='id-Potential-SpCell-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Potential_SpCell_List._val = 92
    
    #-----< id-Potential-SpCell-Item >-----#
    id_Potential_SpCell_Item = INT(name='id-Potential-SpCell-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Potential_SpCell_Item._val = 93
    
    #-----< id-FullConfiguration >-----#
    id_FullConfiguration = INT(name='id-FullConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FullConfiguration._val = 94
    
    #-----< id-C-RNTI >-----#
    id_C_RNTI = INT(name='id-C-RNTI', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_C_RNTI._val = 95
    
    #-----< id-SpCellULConfigured >-----#
    id_SpCellULConfigured = INT(name='id-SpCellULConfigured', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SpCellULConfigured._val = 96
    
    #-----< id-InactivityMonitoringRequest >-----#
    id_InactivityMonitoringRequest = INT(name='id-InactivityMonitoringRequest', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InactivityMonitoringRequest._val = 97
    
    #-----< id-InactivityMonitoringResponse >-----#
    id_InactivityMonitoringResponse = INT(name='id-InactivityMonitoringResponse', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InactivityMonitoringResponse._val = 98
    
    #-----< id-DRB-Activity-Item >-----#
    id_DRB_Activity_Item = INT(name='id-DRB-Activity-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_Activity_Item._val = 99
    
    #-----< id-DRB-Activity-List >-----#
    id_DRB_Activity_List = INT(name='id-DRB-Activity-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_Activity_List._val = 100
    
    #-----< id-EUTRA-NR-CellResourceCoordinationReq-Container >-----#
    id_EUTRA_NR_CellResourceCoordinationReq_Container = INT(name='id-EUTRA-NR-CellResourceCoordinationReq-Container', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EUTRA_NR_CellResourceCoordinationReq_Container._val = 101
    
    #-----< id-EUTRA-NR-CellResourceCoordinationReqAck-Container >-----#
    id_EUTRA_NR_CellResourceCoordinationReqAck_Container = INT(name='id-EUTRA-NR-CellResourceCoordinationReqAck-Container', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EUTRA_NR_CellResourceCoordinationReqAck_Container._val = 102
    
    #-----< id-Protected-EUTRA-Resources-List >-----#
    id_Protected_EUTRA_Resources_List = INT(name='id-Protected-EUTRA-Resources-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Protected_EUTRA_Resources_List._val = 105
    
    #-----< id-RequestType >-----#
    id_RequestType = INT(name='id-RequestType', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RequestType._val = 106
    
    #-----< id-ServCellIndex >-----#
    id_ServCellIndex = INT(name='id-ServCellIndex', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServCellIndex._val = 107
    
    #-----< id-RAT-FrequencyPriorityInformation >-----#
    id_RAT_FrequencyPriorityInformation = INT(name='id-RAT-FrequencyPriorityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RAT_FrequencyPriorityInformation._val = 108
    
    #-----< id-ExecuteDuplication >-----#
    id_ExecuteDuplication = INT(name='id-ExecuteDuplication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExecuteDuplication._val = 109
    
    #-----< id-NRCGI >-----#
    id_NRCGI = INT(name='id-NRCGI', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRCGI._val = 111
    
    #-----< id-PagingCell-Item >-----#
    id_PagingCell_Item = INT(name='id-PagingCell-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingCell_Item._val = 112
    
    #-----< id-PagingCell-List >-----#
    id_PagingCell_List = INT(name='id-PagingCell-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingCell_List._val = 113
    
    #-----< id-PagingDRX >-----#
    id_PagingDRX = INT(name='id-PagingDRX', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingDRX._val = 114
    
    #-----< id-PagingPriority >-----#
    id_PagingPriority = INT(name='id-PagingPriority', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingPriority._val = 115
    
    #-----< id-SItype-List >-----#
    id_SItype_List = INT(name='id-SItype-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SItype_List._val = 116
    
    #-----< id-UEIdentityIndexValue >-----#
    id_UEIdentityIndexValue = INT(name='id-UEIdentityIndexValue', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEIdentityIndexValue._val = 117
    
    #-----< id-gNB-CUSystemInformation >-----#
    id_gNB_CUSystemInformation = INT(name='id-gNB-CUSystemInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNB_CUSystemInformation._val = 118
    
    #-----< id-HandoverPreparationInformation >-----#
    id_HandoverPreparationInformation = INT(name='id-HandoverPreparationInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HandoverPreparationInformation._val = 119
    
    #-----< id-GNB-CU-TNL-Association-To-Add-Item >-----#
    id_GNB_CU_TNL_Association_To_Add_Item = INT(name='id-GNB-CU-TNL-Association-To-Add-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_TNL_Association_To_Add_Item._val = 120
    
    #-----< id-GNB-CU-TNL-Association-To-Add-List >-----#
    id_GNB_CU_TNL_Association_To_Add_List = INT(name='id-GNB-CU-TNL-Association-To-Add-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_TNL_Association_To_Add_List._val = 121
    
    #-----< id-GNB-CU-TNL-Association-To-Remove-Item >-----#
    id_GNB_CU_TNL_Association_To_Remove_Item = INT(name='id-GNB-CU-TNL-Association-To-Remove-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_TNL_Association_To_Remove_Item._val = 122
    
    #-----< id-GNB-CU-TNL-Association-To-Remove-List >-----#
    id_GNB_CU_TNL_Association_To_Remove_List = INT(name='id-GNB-CU-TNL-Association-To-Remove-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_TNL_Association_To_Remove_List._val = 123
    
    #-----< id-GNB-CU-TNL-Association-To-Update-Item >-----#
    id_GNB_CU_TNL_Association_To_Update_Item = INT(name='id-GNB-CU-TNL-Association-To-Update-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_TNL_Association_To_Update_Item._val = 124
    
    #-----< id-GNB-CU-TNL-Association-To-Update-List >-----#
    id_GNB_CU_TNL_Association_To_Update_List = INT(name='id-GNB-CU-TNL-Association-To-Update-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_TNL_Association_To_Update_List._val = 125
    
    #-----< id-MaskedIMEISV >-----#
    id_MaskedIMEISV = INT(name='id-MaskedIMEISV', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MaskedIMEISV._val = 126
    
    #-----< id-PagingIdentity >-----#
    id_PagingIdentity = INT(name='id-PagingIdentity', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingIdentity._val = 127
    
    #-----< id-DUtoCURRCContainer >-----#
    id_DUtoCURRCContainer = INT(name='id-DUtoCURRCContainer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DUtoCURRCContainer._val = 128
    
    #-----< id-Cells-to-be-Barred-List >-----#
    id_Cells_to_be_Barred_List = INT(name='id-Cells-to-be-Barred-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_to_be_Barred_List._val = 129
    
    #-----< id-Cells-to-be-Barred-Item >-----#
    id_Cells_to_be_Barred_Item = INT(name='id-Cells-to-be-Barred-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_to_be_Barred_Item._val = 130
    
    #-----< id-TAISliceSupportList >-----#
    id_TAISliceSupportList = INT(name='id-TAISliceSupportList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TAISliceSupportList._val = 131
    
    #-----< id-GNB-CU-TNL-Association-Setup-List >-----#
    id_GNB_CU_TNL_Association_Setup_List = INT(name='id-GNB-CU-TNL-Association-Setup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_TNL_Association_Setup_List._val = 132
    
    #-----< id-GNB-CU-TNL-Association-Setup-Item >-----#
    id_GNB_CU_TNL_Association_Setup_Item = INT(name='id-GNB-CU-TNL-Association-Setup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_TNL_Association_Setup_Item._val = 133
    
    #-----< id-GNB-CU-TNL-Association-Failed-To-Setup-List >-----#
    id_GNB_CU_TNL_Association_Failed_To_Setup_List = INT(name='id-GNB-CU-TNL-Association-Failed-To-Setup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_TNL_Association_Failed_To_Setup_List._val = 134
    
    #-----< id-GNB-CU-TNL-Association-Failed-To-Setup-Item >-----#
    id_GNB_CU_TNL_Association_Failed_To_Setup_Item = INT(name='id-GNB-CU-TNL-Association-Failed-To-Setup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_TNL_Association_Failed_To_Setup_Item._val = 135
    
    #-----< id-DRB-Notify-Item >-----#
    id_DRB_Notify_Item = INT(name='id-DRB-Notify-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_Notify_Item._val = 136
    
    #-----< id-DRB-Notify-List >-----#
    id_DRB_Notify_List = INT(name='id-DRB-Notify-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_Notify_List._val = 137
    
    #-----< id-NotficationControl >-----#
    id_NotficationControl = INT(name='id-NotficationControl', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NotficationControl._val = 138
    
    #-----< id-RANAC >-----#
    id_RANAC = INT(name='id-RANAC', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RANAC._val = 139
    
    #-----< id-PWSSystemInformation >-----#
    id_PWSSystemInformation = INT(name='id-PWSSystemInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PWSSystemInformation._val = 140
    
    #-----< id-RepetitionPeriod >-----#
    id_RepetitionPeriod = INT(name='id-RepetitionPeriod', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RepetitionPeriod._val = 141
    
    #-----< id-NumberofBroadcastRequest >-----#
    id_NumberofBroadcastRequest = INT(name='id-NumberofBroadcastRequest', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NumberofBroadcastRequest._val = 142
    
    #-----< id-Cells-To-Be-Broadcast-List >-----#
    id_Cells_To_Be_Broadcast_List = INT(name='id-Cells-To-Be-Broadcast-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_To_Be_Broadcast_List._val = 144
    
    #-----< id-Cells-To-Be-Broadcast-Item >-----#
    id_Cells_To_Be_Broadcast_Item = INT(name='id-Cells-To-Be-Broadcast-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_To_Be_Broadcast_Item._val = 145
    
    #-----< id-Cells-Broadcast-Completed-List >-----#
    id_Cells_Broadcast_Completed_List = INT(name='id-Cells-Broadcast-Completed-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_Broadcast_Completed_List._val = 146
    
    #-----< id-Cells-Broadcast-Completed-Item >-----#
    id_Cells_Broadcast_Completed_Item = INT(name='id-Cells-Broadcast-Completed-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_Broadcast_Completed_Item._val = 147
    
    #-----< id-Broadcast-To-Be-Cancelled-List >-----#
    id_Broadcast_To_Be_Cancelled_List = INT(name='id-Broadcast-To-Be-Cancelled-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Broadcast_To_Be_Cancelled_List._val = 148
    
    #-----< id-Broadcast-To-Be-Cancelled-Item >-----#
    id_Broadcast_To_Be_Cancelled_Item = INT(name='id-Broadcast-To-Be-Cancelled-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Broadcast_To_Be_Cancelled_Item._val = 149
    
    #-----< id-Cells-Broadcast-Cancelled-List >-----#
    id_Cells_Broadcast_Cancelled_List = INT(name='id-Cells-Broadcast-Cancelled-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_Broadcast_Cancelled_List._val = 150
    
    #-----< id-Cells-Broadcast-Cancelled-Item >-----#
    id_Cells_Broadcast_Cancelled_Item = INT(name='id-Cells-Broadcast-Cancelled-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cells_Broadcast_Cancelled_Item._val = 151
    
    #-----< id-NR-CGI-List-For-Restart-List >-----#
    id_NR_CGI_List_For_Restart_List = INT(name='id-NR-CGI-List-For-Restart-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NR_CGI_List_For_Restart_List._val = 152
    
    #-----< id-NR-CGI-List-For-Restart-Item >-----#
    id_NR_CGI_List_For_Restart_Item = INT(name='id-NR-CGI-List-For-Restart-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NR_CGI_List_For_Restart_Item._val = 153
    
    #-----< id-PWS-Failed-NR-CGI-List >-----#
    id_PWS_Failed_NR_CGI_List = INT(name='id-PWS-Failed-NR-CGI-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PWS_Failed_NR_CGI_List._val = 154
    
    #-----< id-PWS-Failed-NR-CGI-Item >-----#
    id_PWS_Failed_NR_CGI_Item = INT(name='id-PWS-Failed-NR-CGI-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PWS_Failed_NR_CGI_Item._val = 155
    
    #-----< id-ConfirmedUEID >-----#
    id_ConfirmedUEID = INT(name='id-ConfirmedUEID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ConfirmedUEID._val = 156
    
    #-----< id-Cancel-all-Warning-Messages-Indicator >-----#
    id_Cancel_all_Warning_Messages_Indicator = INT(name='id-Cancel-all-Warning-Messages-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cancel_all_Warning_Messages_Indicator._val = 157
    
    #-----< id-GNB-DU-UE-AMBR-UL >-----#
    id_GNB_DU_UE_AMBR_UL = INT(name='id-GNB-DU-UE-AMBR-UL', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_DU_UE_AMBR_UL._val = 158
    
    #-----< id-DRXConfigurationIndicator >-----#
    id_DRXConfigurationIndicator = INT(name='id-DRXConfigurationIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRXConfigurationIndicator._val = 159
    
    #-----< id-RLC-Status >-----#
    id_RLC_Status = INT(name='id-RLC-Status', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RLC_Status._val = 160
    
    #-----< id-DLPDCPSNLength >-----#
    id_DLPDCPSNLength = INT(name='id-DLPDCPSNLength', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DLPDCPSNLength._val = 161
    
    #-----< id-GNB-DUConfigurationQuery >-----#
    id_GNB_DUConfigurationQuery = INT(name='id-GNB-DUConfigurationQuery', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_DUConfigurationQuery._val = 162
    
    #-----< id-MeasurementTimingConfiguration >-----#
    id_MeasurementTimingConfiguration = INT(name='id-MeasurementTimingConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementTimingConfiguration._val = 163
    
    #-----< id-DRB-Information >-----#
    id_DRB_Information = INT(name='id-DRB-Information', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_Information._val = 164
    
    #-----< id-ServingPLMN >-----#
    id_ServingPLMN = INT(name='id-ServingPLMN', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServingPLMN._val = 165
    
    #-----< id-Protected-EUTRA-Resources-Item >-----#
    id_Protected_EUTRA_Resources_Item = INT(name='id-Protected-EUTRA-Resources-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Protected_EUTRA_Resources_Item._val = 168
    
    #-----< id-GNB-CU-RRC-Version >-----#
    id_GNB_CU_RRC_Version = INT(name='id-GNB-CU-RRC-Version', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_CU_RRC_Version._val = 170
    
    #-----< id-GNB-DU-RRC-Version >-----#
    id_GNB_DU_RRC_Version = INT(name='id-GNB-DU-RRC-Version', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_DU_RRC_Version._val = 171
    
    #-----< id-GNBDUOverloadInformation >-----#
    id_GNBDUOverloadInformation = INT(name='id-GNBDUOverloadInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNBDUOverloadInformation._val = 172
    
    #-----< id-CellGroupConfig >-----#
    id_CellGroupConfig = INT(name='id-CellGroupConfig', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellGroupConfig._val = 173
    
    #-----< id-RLCFailureIndication >-----#
    id_RLCFailureIndication = INT(name='id-RLCFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RLCFailureIndication._val = 174
    
    #-----< id-UplinkTxDirectCurrentListInformation >-----#
    id_UplinkTxDirectCurrentListInformation = INT(name='id-UplinkTxDirectCurrentListInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UplinkTxDirectCurrentListInformation._val = 175
    
    #-----< id-DC-Based-Duplication-Configured >-----#
    id_DC_Based_Duplication_Configured = INT(name='id-DC-Based-Duplication-Configured', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DC_Based_Duplication_Configured._val = 176
    
    #-----< id-DC-Based-Duplication-Activation >-----#
    id_DC_Based_Duplication_Activation = INT(name='id-DC-Based-Duplication-Activation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DC_Based_Duplication_Activation._val = 177
    
    #-----< id-SULAccessIndication >-----#
    id_SULAccessIndication = INT(name='id-SULAccessIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SULAccessIndication._val = 178
    
    #-----< id-AvailablePLMNList >-----#
    id_AvailablePLMNList = INT(name='id-AvailablePLMNList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AvailablePLMNList._val = 179
    
    #-----< id-PDUSessionID >-----#
    id_PDUSessionID = INT(name='id-PDUSessionID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionID._val = 180
    
    #-----< id-ULPDUSessionAggregateMaximumBitRate >-----#
    id_ULPDUSessionAggregateMaximumBitRate = INT(name='id-ULPDUSessionAggregateMaximumBitRate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ULPDUSessionAggregateMaximumBitRate._val = 181
    
    #-----< id-ServingCellMO >-----#
    id_ServingCellMO = INT(name='id-ServingCellMO', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServingCellMO._val = 182
    
    #-----< id-QoSFlowMappingIndication >-----#
    id_QoSFlowMappingIndication = INT(name='id-QoSFlowMappingIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QoSFlowMappingIndication._val = 183
    
    #-----< id-RRCDeliveryStatusRequest >-----#
    id_RRCDeliveryStatusRequest = INT(name='id-RRCDeliveryStatusRequest', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRCDeliveryStatusRequest._val = 184
    
    #-----< id-RRCDeliveryStatus >-----#
    id_RRCDeliveryStatus = INT(name='id-RRCDeliveryStatus', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRCDeliveryStatus._val = 185
    
    #-----< id-BearerTypeChange >-----#
    id_BearerTypeChange = INT(name='id-BearerTypeChange', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BearerTypeChange._val = 186
    
    #-----< id-RLCMode >-----#
    id_RLCMode = INT(name='id-RLCMode', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RLCMode._val = 187
    
    #-----< id-Duplication-Activation >-----#
    id_Duplication_Activation = INT(name='id-Duplication-Activation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Duplication_Activation._val = 188
    
    #-----< id-Dedicated-SIDelivery-NeededUE-List >-----#
    id_Dedicated_SIDelivery_NeededUE_List = INT(name='id-Dedicated-SIDelivery-NeededUE-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Dedicated_SIDelivery_NeededUE_List._val = 189
    
    #-----< id-Dedicated-SIDelivery-NeededUE-Item >-----#
    id_Dedicated_SIDelivery_NeededUE_Item = INT(name='id-Dedicated-SIDelivery-NeededUE-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Dedicated_SIDelivery_NeededUE_Item._val = 190
    
    #-----< id-DRX-LongCycleStartOffset >-----#
    id_DRX_LongCycleStartOffset = INT(name='id-DRX-LongCycleStartOffset', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRX_LongCycleStartOffset._val = 191
    
    #-----< id-ULPDCPSNLength >-----#
    id_ULPDCPSNLength = INT(name='id-ULPDCPSNLength', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ULPDCPSNLength._val = 192
    
    #-----< id-SelectedBandCombinationIndex >-----#
    id_SelectedBandCombinationIndex = INT(name='id-SelectedBandCombinationIndex', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SelectedBandCombinationIndex._val = 193
    
    #-----< id-SelectedFeatureSetEntryIndex >-----#
    id_SelectedFeatureSetEntryIndex = INT(name='id-SelectedFeatureSetEntryIndex', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SelectedFeatureSetEntryIndex._val = 194
    
    #-----< id-ResourceCoordinationTransferInformation >-----#
    id_ResourceCoordinationTransferInformation = INT(name='id-ResourceCoordinationTransferInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResourceCoordinationTransferInformation._val = 195
    
    #-----< id-ExtendedServedPLMNs-List >-----#
    id_ExtendedServedPLMNs_List = INT(name='id-ExtendedServedPLMNs-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedServedPLMNs_List._val = 196
    
    #-----< id-ExtendedAvailablePLMN-List >-----#
    id_ExtendedAvailablePLMN_List = INT(name='id-ExtendedAvailablePLMN-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedAvailablePLMN_List._val = 197
    
    #-----< id-Associated-SCell-List >-----#
    id_Associated_SCell_List = INT(name='id-Associated-SCell-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Associated_SCell_List._val = 198
    
    #-----< id-latest-RRC-Version-Enhanced >-----#
    id_latest_RRC_Version_Enhanced = INT(name='id-latest-RRC-Version-Enhanced', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_latest_RRC_Version_Enhanced._val = 199
    
    #-----< id-Associated-SCell-Item >-----#
    id_Associated_SCell_Item = INT(name='id-Associated-SCell-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Associated_SCell_Item._val = 200
    
    #-----< id-Cell-Direction >-----#
    id_Cell_Direction = INT(name='id-Cell-Direction', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cell_Direction._val = 201
    
    #-----< id-SRBs-Setup-List >-----#
    id_SRBs_Setup_List = INT(name='id-SRBs-Setup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_Setup_List._val = 202
    
    #-----< id-SRBs-Setup-Item >-----#
    id_SRBs_Setup_Item = INT(name='id-SRBs-Setup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_Setup_Item._val = 203
    
    #-----< id-SRBs-SetupMod-List >-----#
    id_SRBs_SetupMod_List = INT(name='id-SRBs-SetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_SetupMod_List._val = 204
    
    #-----< id-SRBs-SetupMod-Item >-----#
    id_SRBs_SetupMod_Item = INT(name='id-SRBs-SetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_SetupMod_Item._val = 205
    
    #-----< id-SRBs-Modified-List >-----#
    id_SRBs_Modified_List = INT(name='id-SRBs-Modified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_Modified_List._val = 206
    
    #-----< id-SRBs-Modified-Item >-----#
    id_SRBs_Modified_Item = INT(name='id-SRBs-Modified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBs_Modified_Item._val = 207
    
    #-----< id-Ph-InfoSCG >-----#
    id_Ph_InfoSCG = INT(name='id-Ph-InfoSCG', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Ph_InfoSCG._val = 208
    
    #-----< id-RequestedBandCombinationIndex >-----#
    id_RequestedBandCombinationIndex = INT(name='id-RequestedBandCombinationIndex', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RequestedBandCombinationIndex._val = 209
    
    #-----< id-RequestedFeatureSetEntryIndex >-----#
    id_RequestedFeatureSetEntryIndex = INT(name='id-RequestedFeatureSetEntryIndex', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RequestedFeatureSetEntryIndex._val = 210
    
    #-----< id-RequestedP-MaxFR2 >-----#
    id_RequestedP_MaxFR2 = INT(name='id-RequestedP-MaxFR2', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RequestedP_MaxFR2._val = 211
    
    #-----< id-DRX-Config >-----#
    id_DRX_Config = INT(name='id-DRX-Config', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRX_Config._val = 212
    
    #-----< id-IgnoreResourceCoordinationContainer >-----#
    id_IgnoreResourceCoordinationContainer = INT(name='id-IgnoreResourceCoordinationContainer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IgnoreResourceCoordinationContainer._val = 213
    
    #-----< id-UEAssistanceInformation >-----#
    id_UEAssistanceInformation = INT(name='id-UEAssistanceInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEAssistanceInformation._val = 214
    
    #-----< id-NeedforGap >-----#
    id_NeedforGap = INT(name='id-NeedforGap', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NeedforGap._val = 215
    
    #-----< id-PagingOrigin >-----#
    id_PagingOrigin = INT(name='id-PagingOrigin', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingOrigin._val = 216
    
    #-----< id-new-gNB-CU-UE-F1AP-ID >-----#
    id_new_gNB_CU_UE_F1AP_ID = INT(name='id-new-gNB-CU-UE-F1AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_new_gNB_CU_UE_F1AP_ID._val = 217
    
    #-----< id-RedirectedRRCmessage >-----#
    id_RedirectedRRCmessage = INT(name='id-RedirectedRRCmessage', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RedirectedRRCmessage._val = 218
    
    #-----< id-new-gNB-DU-UE-F1AP-ID >-----#
    id_new_gNB_DU_UE_F1AP_ID = INT(name='id-new-gNB-DU-UE-F1AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_new_gNB_DU_UE_F1AP_ID._val = 219
    
    #-----< id-NotificationInformation >-----#
    id_NotificationInformation = INT(name='id-NotificationInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NotificationInformation._val = 220
    
    #-----< id-PLMNAssistanceInfoForNetShar >-----#
    id_PLMNAssistanceInfoForNetShar = INT(name='id-PLMNAssistanceInfoForNetShar', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PLMNAssistanceInfoForNetShar._val = 221
    
    #-----< id-UEContextNotRetrievable >-----#
    id_UEContextNotRetrievable = INT(name='id-UEContextNotRetrievable', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEContextNotRetrievable._val = 222
    
    #-----< id-BPLMN-ID-Info-List >-----#
    id_BPLMN_ID_Info_List = INT(name='id-BPLMN-ID-Info-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BPLMN_ID_Info_List._val = 223
    
    #-----< id-SelectedPLMNID >-----#
    id_SelectedPLMNID = INT(name='id-SelectedPLMNID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SelectedPLMNID._val = 224
    
    #-----< id-UAC-Assistance-Info >-----#
    id_UAC_Assistance_Info = INT(name='id-UAC-Assistance-Info', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UAC_Assistance_Info._val = 225
    
    #-----< id-RANUEID >-----#
    id_RANUEID = INT(name='id-RANUEID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RANUEID._val = 226
    
    #-----< id-GNB-DU-TNL-Association-To-Remove-Item >-----#
    id_GNB_DU_TNL_Association_To_Remove_Item = INT(name='id-GNB-DU-TNL-Association-To-Remove-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_DU_TNL_Association_To_Remove_Item._val = 227
    
    #-----< id-GNB-DU-TNL-Association-To-Remove-List >-----#
    id_GNB_DU_TNL_Association_To_Remove_List = INT(name='id-GNB-DU-TNL-Association-To-Remove-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNB_DU_TNL_Association_To_Remove_List._val = 228
    
    #-----< id-TNLAssociationTransportLayerAddressgNBDU >-----#
    id_TNLAssociationTransportLayerAddressgNBDU = INT(name='id-TNLAssociationTransportLayerAddressgNBDU', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TNLAssociationTransportLayerAddressgNBDU._val = 229
    
    #-----< id-portNumber >-----#
    id_portNumber = INT(name='id-portNumber', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_portNumber._val = 230
    
    #-----< id-AdditionalSIBMessageList >-----#
    id_AdditionalSIBMessageList = INT(name='id-AdditionalSIBMessageList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalSIBMessageList._val = 231
    
    #-----< id-Cell-Type >-----#
    id_Cell_Type = INT(name='id-Cell-Type', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cell_Type._val = 232
    
    #-----< id-IgnorePRACHConfiguration >-----#
    id_IgnorePRACHConfiguration = INT(name='id-IgnorePRACHConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IgnorePRACHConfiguration._val = 233
    
    #-----< id-CG-Config >-----#
    id_CG_Config = INT(name='id-CG-Config', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CG_Config._val = 234
    
    #-----< id-PDCCH-BlindDetectionSCG >-----#
    id_PDCCH_BlindDetectionSCG = INT(name='id-PDCCH-BlindDetectionSCG', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDCCH_BlindDetectionSCG._val = 235
    
    #-----< id-Requested-PDCCH-BlindDetectionSCG >-----#
    id_Requested_PDCCH_BlindDetectionSCG = INT(name='id-Requested-PDCCH-BlindDetectionSCG', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Requested_PDCCH_BlindDetectionSCG._val = 236
    
    #-----< id-Ph-InfoMCG >-----#
    id_Ph_InfoMCG = INT(name='id-Ph-InfoMCG', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Ph_InfoMCG._val = 237
    
    #-----< id-MeasGapSharingConfig >-----#
    id_MeasGapSharingConfig = INT(name='id-MeasGapSharingConfig', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasGapSharingConfig._val = 238
    
    #-----< id-systemInformationAreaID >-----#
    id_systemInformationAreaID = INT(name='id-systemInformationAreaID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_systemInformationAreaID._val = 239
    
    #-----< id-areaScope >-----#
    id_areaScope = INT(name='id-areaScope', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_areaScope._val = 240
    
    #-----< id-RRCContainer-RRCSetupComplete >-----#
    id_RRCContainer_RRCSetupComplete = INT(name='id-RRCContainer-RRCSetupComplete', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRCContainer_RRCSetupComplete._val = 241
    
    #-----< id-TraceActivation >-----#
    id_TraceActivation = INT(name='id-TraceActivation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceActivation._val = 242
    
    #-----< id-TraceID >-----#
    id_TraceID = INT(name='id-TraceID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceID._val = 243
    
    #-----< id-Neighbour-Cell-Information-List >-----#
    id_Neighbour_Cell_Information_List = INT(name='id-Neighbour-Cell-Information-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Neighbour_Cell_Information_List._val = 244
    
    #-----< id-SymbolAllocInSlot >-----#
    id_SymbolAllocInSlot = INT(name='id-SymbolAllocInSlot', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SymbolAllocInSlot._val = 246
    
    #-----< id-NumDLULSymbols >-----#
    id_NumDLULSymbols = INT(name='id-NumDLULSymbols', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NumDLULSymbols._val = 247
    
    #-----< id-AdditionalRRMPriorityIndex >-----#
    id_AdditionalRRMPriorityIndex = INT(name='id-AdditionalRRMPriorityIndex', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalRRMPriorityIndex._val = 248
    
    #-----< id-DUCURadioInformationType >-----#
    id_DUCURadioInformationType = INT(name='id-DUCURadioInformationType', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DUCURadioInformationType._val = 249
    
    #-----< id-CUDURadioInformationType >-----#
    id_CUDURadioInformationType = INT(name='id-CUDURadioInformationType', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CUDURadioInformationType._val = 250
    
    #-----< id-AggressorgNBSetID >-----#
    id_AggressorgNBSetID = INT(name='id-AggressorgNBSetID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AggressorgNBSetID._val = 251
    
    #-----< id-VictimgNBSetID >-----#
    id_VictimgNBSetID = INT(name='id-VictimgNBSetID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_VictimgNBSetID._val = 252
    
    #-----< id-LowerLayerPresenceStatusChange >-----#
    id_LowerLayerPresenceStatusChange = INT(name='id-LowerLayerPresenceStatusChange', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LowerLayerPresenceStatusChange._val = 253
    
    #-----< id-Transport-Layer-Address-Info >-----#
    id_Transport_Layer_Address_Info = INT(name='id-Transport-Layer-Address-Info', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Transport_Layer_Address_Info._val = 254
    
    #-----< id-Neighbour-Cell-Information-Item >-----#
    id_Neighbour_Cell_Information_Item = INT(name='id-Neighbour-Cell-Information-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Neighbour_Cell_Information_Item._val = 255
    
    #-----< id-IntendedTDD-DL-ULConfig >-----#
    id_IntendedTDD_DL_ULConfig = INT(name='id-IntendedTDD-DL-ULConfig', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IntendedTDD_DL_ULConfig._val = 256
    
    #-----< id-QosMonitoringRequest >-----#
    id_QosMonitoringRequest = INT(name='id-QosMonitoringRequest', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QosMonitoringRequest._val = 257
    
    #-----< id-BHChannels-ToBeSetup-List >-----#
    id_BHChannels_ToBeSetup_List = INT(name='id-BHChannels-ToBeSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_ToBeSetup_List._val = 258
    
    #-----< id-BHChannels-ToBeSetup-Item >-----#
    id_BHChannels_ToBeSetup_Item = INT(name='id-BHChannels-ToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_ToBeSetup_Item._val = 259
    
    #-----< id-BHChannels-Setup-List >-----#
    id_BHChannels_Setup_List = INT(name='id-BHChannels-Setup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_Setup_List._val = 260
    
    #-----< id-BHChannels-Setup-Item >-----#
    id_BHChannels_Setup_Item = INT(name='id-BHChannels-Setup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_Setup_Item._val = 261
    
    #-----< id-BHChannels-ToBeModified-Item >-----#
    id_BHChannels_ToBeModified_Item = INT(name='id-BHChannels-ToBeModified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_ToBeModified_Item._val = 262
    
    #-----< id-BHChannels-ToBeModified-List >-----#
    id_BHChannels_ToBeModified_List = INT(name='id-BHChannels-ToBeModified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_ToBeModified_List._val = 263
    
    #-----< id-BHChannels-ToBeReleased-Item >-----#
    id_BHChannels_ToBeReleased_Item = INT(name='id-BHChannels-ToBeReleased-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_ToBeReleased_Item._val = 264
    
    #-----< id-BHChannels-ToBeReleased-List >-----#
    id_BHChannels_ToBeReleased_List = INT(name='id-BHChannels-ToBeReleased-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_ToBeReleased_List._val = 265
    
    #-----< id-BHChannels-ToBeSetupMod-Item >-----#
    id_BHChannels_ToBeSetupMod_Item = INT(name='id-BHChannels-ToBeSetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_ToBeSetupMod_Item._val = 266
    
    #-----< id-BHChannels-ToBeSetupMod-List >-----#
    id_BHChannels_ToBeSetupMod_List = INT(name='id-BHChannels-ToBeSetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_ToBeSetupMod_List._val = 267
    
    #-----< id-BHChannels-FailedToBeModified-Item >-----#
    id_BHChannels_FailedToBeModified_Item = INT(name='id-BHChannels-FailedToBeModified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_FailedToBeModified_Item._val = 268
    
    #-----< id-BHChannels-FailedToBeModified-List >-----#
    id_BHChannels_FailedToBeModified_List = INT(name='id-BHChannels-FailedToBeModified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_FailedToBeModified_List._val = 269
    
    #-----< id-BHChannels-FailedToBeSetupMod-Item >-----#
    id_BHChannels_FailedToBeSetupMod_Item = INT(name='id-BHChannels-FailedToBeSetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_FailedToBeSetupMod_Item._val = 270
    
    #-----< id-BHChannels-FailedToBeSetupMod-List >-----#
    id_BHChannels_FailedToBeSetupMod_List = INT(name='id-BHChannels-FailedToBeSetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_FailedToBeSetupMod_List._val = 271
    
    #-----< id-BHChannels-Modified-Item >-----#
    id_BHChannels_Modified_Item = INT(name='id-BHChannels-Modified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_Modified_Item._val = 272
    
    #-----< id-BHChannels-Modified-List >-----#
    id_BHChannels_Modified_List = INT(name='id-BHChannels-Modified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_Modified_List._val = 273
    
    #-----< id-BHChannels-SetupMod-Item >-----#
    id_BHChannels_SetupMod_Item = INT(name='id-BHChannels-SetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_SetupMod_Item._val = 274
    
    #-----< id-BHChannels-SetupMod-List >-----#
    id_BHChannels_SetupMod_List = INT(name='id-BHChannels-SetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_SetupMod_List._val = 275
    
    #-----< id-BHChannels-Required-ToBeReleased-Item >-----#
    id_BHChannels_Required_ToBeReleased_Item = INT(name='id-BHChannels-Required-ToBeReleased-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_Required_ToBeReleased_Item._val = 276
    
    #-----< id-BHChannels-Required-ToBeReleased-List >-----#
    id_BHChannels_Required_ToBeReleased_List = INT(name='id-BHChannels-Required-ToBeReleased-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_Required_ToBeReleased_List._val = 277
    
    #-----< id-BHChannels-FailedToBeSetup-Item >-----#
    id_BHChannels_FailedToBeSetup_Item = INT(name='id-BHChannels-FailedToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_FailedToBeSetup_Item._val = 278
    
    #-----< id-BHChannels-FailedToBeSetup-List >-----#
    id_BHChannels_FailedToBeSetup_List = INT(name='id-BHChannels-FailedToBeSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHChannels_FailedToBeSetup_List._val = 279
    
    #-----< id-BHInfo >-----#
    id_BHInfo = INT(name='id-BHInfo', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BHInfo._val = 280
    
    #-----< id-BAPAddress >-----#
    id_BAPAddress = INT(name='id-BAPAddress', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BAPAddress._val = 281
    
    #-----< id-ConfiguredBAPAddress >-----#
    id_ConfiguredBAPAddress = INT(name='id-ConfiguredBAPAddress', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ConfiguredBAPAddress._val = 282
    
    #-----< id-BH-Routing-Information-Added-List >-----#
    id_BH_Routing_Information_Added_List = INT(name='id-BH-Routing-Information-Added-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BH_Routing_Information_Added_List._val = 283
    
    #-----< id-BH-Routing-Information-Added-List-Item >-----#
    id_BH_Routing_Information_Added_List_Item = INT(name='id-BH-Routing-Information-Added-List-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BH_Routing_Information_Added_List_Item._val = 284
    
    #-----< id-BH-Routing-Information-Removed-List >-----#
    id_BH_Routing_Information_Removed_List = INT(name='id-BH-Routing-Information-Removed-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BH_Routing_Information_Removed_List._val = 285
    
    #-----< id-BH-Routing-Information-Removed-List-Item >-----#
    id_BH_Routing_Information_Removed_List_Item = INT(name='id-BH-Routing-Information-Removed-List-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BH_Routing_Information_Removed_List_Item._val = 286
    
    #-----< id-UL-BH-Non-UP-Traffic-Mapping >-----#
    id_UL_BH_Non_UP_Traffic_Mapping = INT(name='id-UL-BH-Non-UP-Traffic-Mapping', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_BH_Non_UP_Traffic_Mapping._val = 287
    
    #-----< id-Activated-Cells-to-be-Updated-List >-----#
    id_Activated_Cells_to_be_Updated_List = INT(name='id-Activated-Cells-to-be-Updated-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Activated_Cells_to_be_Updated_List._val = 288
    
    #-----< id-Child-Nodes-List >-----#
    id_Child_Nodes_List = INT(name='id-Child-Nodes-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Child_Nodes_List._val = 289
    
    #-----< id-IAB-Info-IAB-DU >-----#
    id_IAB_Info_IAB_DU = INT(name='id-IAB-Info-IAB-DU', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_Info_IAB_DU._val = 290
    
    #-----< id-IAB-Info-IAB-donor-CU >-----#
    id_IAB_Info_IAB_donor_CU = INT(name='id-IAB-Info-IAB-donor-CU', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_Info_IAB_donor_CU._val = 291
    
    #-----< id-IAB-TNL-Addresses-To-Remove-List >-----#
    id_IAB_TNL_Addresses_To_Remove_List = INT(name='id-IAB-TNL-Addresses-To-Remove-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_TNL_Addresses_To_Remove_List._val = 292
    
    #-----< id-IAB-TNL-Addresses-To-Remove-Item >-----#
    id_IAB_TNL_Addresses_To_Remove_Item = INT(name='id-IAB-TNL-Addresses-To-Remove-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_TNL_Addresses_To_Remove_Item._val = 293
    
    #-----< id-IAB-Allocated-TNL-Address-List >-----#
    id_IAB_Allocated_TNL_Address_List = INT(name='id-IAB-Allocated-TNL-Address-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_Allocated_TNL_Address_List._val = 294
    
    #-----< id-IAB-Allocated-TNL-Address-Item >-----#
    id_IAB_Allocated_TNL_Address_Item = INT(name='id-IAB-Allocated-TNL-Address-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_Allocated_TNL_Address_Item._val = 295
    
    #-----< id-IABIPv6RequestType >-----#
    id_IABIPv6RequestType = INT(name='id-IABIPv6RequestType', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IABIPv6RequestType._val = 296
    
    #-----< id-IABv4AddressesRequested >-----#
    id_IABv4AddressesRequested = INT(name='id-IABv4AddressesRequested', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IABv4AddressesRequested._val = 297
    
    #-----< id-IAB-Barred >-----#
    id_IAB_Barred = INT(name='id-IAB-Barred', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_Barred._val = 298
    
    #-----< id-TrafficMappingInformation >-----#
    id_TrafficMappingInformation = INT(name='id-TrafficMappingInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TrafficMappingInformation._val = 299
    
    #-----< id-UL-UP-TNL-Information-to-Update-List >-----#
    id_UL_UP_TNL_Information_to_Update_List = INT(name='id-UL-UP-TNL-Information-to-Update-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_UP_TNL_Information_to_Update_List._val = 300
    
    #-----< id-UL-UP-TNL-Information-to-Update-List-Item >-----#
    id_UL_UP_TNL_Information_to_Update_List_Item = INT(name='id-UL-UP-TNL-Information-to-Update-List-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_UP_TNL_Information_to_Update_List_Item._val = 301
    
    #-----< id-UL-UP-TNL-Address-to-Update-List >-----#
    id_UL_UP_TNL_Address_to_Update_List = INT(name='id-UL-UP-TNL-Address-to-Update-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_UP_TNL_Address_to_Update_List._val = 302
    
    #-----< id-UL-UP-TNL-Address-to-Update-List-Item >-----#
    id_UL_UP_TNL_Address_to_Update_List_Item = INT(name='id-UL-UP-TNL-Address-to-Update-List-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_UP_TNL_Address_to_Update_List_Item._val = 303
    
    #-----< id-DL-UP-TNL-Address-to-Update-List >-----#
    id_DL_UP_TNL_Address_to_Update_List = INT(name='id-DL-UP-TNL-Address-to-Update-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_UP_TNL_Address_to_Update_List._val = 304
    
    #-----< id-DL-UP-TNL-Address-to-Update-List-Item >-----#
    id_DL_UP_TNL_Address_to_Update_List_Item = INT(name='id-DL-UP-TNL-Address-to-Update-List-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_UP_TNL_Address_to_Update_List_Item._val = 305
    
    #-----< id-NRV2XServicesAuthorized >-----#
    id_NRV2XServicesAuthorized = INT(name='id-NRV2XServicesAuthorized', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRV2XServicesAuthorized._val = 306
    
    #-----< id-LTEV2XServicesAuthorized >-----#
    id_LTEV2XServicesAuthorized = INT(name='id-LTEV2XServicesAuthorized', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LTEV2XServicesAuthorized._val = 307
    
    #-----< id-NRUESidelinkAggregateMaximumBitrate >-----#
    id_NRUESidelinkAggregateMaximumBitrate = INT(name='id-NRUESidelinkAggregateMaximumBitrate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRUESidelinkAggregateMaximumBitrate._val = 308
    
    #-----< id-LTEUESidelinkAggregateMaximumBitrate >-----#
    id_LTEUESidelinkAggregateMaximumBitrate = INT(name='id-LTEUESidelinkAggregateMaximumBitrate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LTEUESidelinkAggregateMaximumBitrate._val = 309
    
    #-----< id-SIB12-message >-----#
    id_SIB12_message = INT(name='id-SIB12-message', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SIB12_message._val = 310
    
    #-----< id-SIB13-message >-----#
    id_SIB13_message = INT(name='id-SIB13-message', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SIB13_message._val = 311
    
    #-----< id-SIB14-message >-----#
    id_SIB14_message = INT(name='id-SIB14-message', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SIB14_message._val = 312
    
    #-----< id-SLDRBs-FailedToBeModified-Item >-----#
    id_SLDRBs_FailedToBeModified_Item = INT(name='id-SLDRBs-FailedToBeModified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_FailedToBeModified_Item._val = 313
    
    #-----< id-SLDRBs-FailedToBeModified-List >-----#
    id_SLDRBs_FailedToBeModified_List = INT(name='id-SLDRBs-FailedToBeModified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_FailedToBeModified_List._val = 314
    
    #-----< id-SLDRBs-FailedToBeSetup-Item >-----#
    id_SLDRBs_FailedToBeSetup_Item = INT(name='id-SLDRBs-FailedToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_FailedToBeSetup_Item._val = 315
    
    #-----< id-SLDRBs-FailedToBeSetup-List >-----#
    id_SLDRBs_FailedToBeSetup_List = INT(name='id-SLDRBs-FailedToBeSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_FailedToBeSetup_List._val = 316
    
    #-----< id-SLDRBs-Modified-Item >-----#
    id_SLDRBs_Modified_Item = INT(name='id-SLDRBs-Modified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_Modified_Item._val = 317
    
    #-----< id-SLDRBs-Modified-List >-----#
    id_SLDRBs_Modified_List = INT(name='id-SLDRBs-Modified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_Modified_List._val = 318
    
    #-----< id-SLDRBs-Required-ToBeModified-Item >-----#
    id_SLDRBs_Required_ToBeModified_Item = INT(name='id-SLDRBs-Required-ToBeModified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_Required_ToBeModified_Item._val = 319
    
    #-----< id-SLDRBs-Required-ToBeModified-List >-----#
    id_SLDRBs_Required_ToBeModified_List = INT(name='id-SLDRBs-Required-ToBeModified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_Required_ToBeModified_List._val = 320
    
    #-----< id-SLDRBs-Required-ToBeReleased-Item >-----#
    id_SLDRBs_Required_ToBeReleased_Item = INT(name='id-SLDRBs-Required-ToBeReleased-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_Required_ToBeReleased_Item._val = 321
    
    #-----< id-SLDRBs-Required-ToBeReleased-List >-----#
    id_SLDRBs_Required_ToBeReleased_List = INT(name='id-SLDRBs-Required-ToBeReleased-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_Required_ToBeReleased_List._val = 322
    
    #-----< id-SLDRBs-Setup-Item >-----#
    id_SLDRBs_Setup_Item = INT(name='id-SLDRBs-Setup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_Setup_Item._val = 323
    
    #-----< id-SLDRBs-Setup-List >-----#
    id_SLDRBs_Setup_List = INT(name='id-SLDRBs-Setup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_Setup_List._val = 324
    
    #-----< id-SLDRBs-ToBeModified-Item >-----#
    id_SLDRBs_ToBeModified_Item = INT(name='id-SLDRBs-ToBeModified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_ToBeModified_Item._val = 325
    
    #-----< id-SLDRBs-ToBeModified-List >-----#
    id_SLDRBs_ToBeModified_List = INT(name='id-SLDRBs-ToBeModified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_ToBeModified_List._val = 326
    
    #-----< id-SLDRBs-ToBeReleased-Item >-----#
    id_SLDRBs_ToBeReleased_Item = INT(name='id-SLDRBs-ToBeReleased-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_ToBeReleased_Item._val = 327
    
    #-----< id-SLDRBs-ToBeReleased-List >-----#
    id_SLDRBs_ToBeReleased_List = INT(name='id-SLDRBs-ToBeReleased-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_ToBeReleased_List._val = 328
    
    #-----< id-SLDRBs-ToBeSetup-Item >-----#
    id_SLDRBs_ToBeSetup_Item = INT(name='id-SLDRBs-ToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_ToBeSetup_Item._val = 329
    
    #-----< id-SLDRBs-ToBeSetup-List >-----#
    id_SLDRBs_ToBeSetup_List = INT(name='id-SLDRBs-ToBeSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_ToBeSetup_List._val = 330
    
    #-----< id-SLDRBs-ToBeSetupMod-Item >-----#
    id_SLDRBs_ToBeSetupMod_Item = INT(name='id-SLDRBs-ToBeSetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_ToBeSetupMod_Item._val = 331
    
    #-----< id-SLDRBs-ToBeSetupMod-List >-----#
    id_SLDRBs_ToBeSetupMod_List = INT(name='id-SLDRBs-ToBeSetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_ToBeSetupMod_List._val = 332
    
    #-----< id-SLDRBs-SetupMod-List >-----#
    id_SLDRBs_SetupMod_List = INT(name='id-SLDRBs-SetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_SetupMod_List._val = 333
    
    #-----< id-SLDRBs-FailedToBeSetupMod-List >-----#
    id_SLDRBs_FailedToBeSetupMod_List = INT(name='id-SLDRBs-FailedToBeSetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_FailedToBeSetupMod_List._val = 334
    
    #-----< id-SLDRBs-SetupMod-Item >-----#
    id_SLDRBs_SetupMod_Item = INT(name='id-SLDRBs-SetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_SetupMod_Item._val = 335
    
    #-----< id-SLDRBs-FailedToBeSetupMod-Item >-----#
    id_SLDRBs_FailedToBeSetupMod_Item = INT(name='id-SLDRBs-FailedToBeSetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_FailedToBeSetupMod_Item._val = 336
    
    #-----< id-SLDRBs-ModifiedConf-List >-----#
    id_SLDRBs_ModifiedConf_List = INT(name='id-SLDRBs-ModifiedConf-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_ModifiedConf_List._val = 337
    
    #-----< id-SLDRBs-ModifiedConf-Item >-----#
    id_SLDRBs_ModifiedConf_Item = INT(name='id-SLDRBs-ModifiedConf-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRBs_ModifiedConf_Item._val = 338
    
    #-----< id-UEAssistanceInformationEUTRA >-----#
    id_UEAssistanceInformationEUTRA = INT(name='id-UEAssistanceInformationEUTRA', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEAssistanceInformationEUTRA._val = 339
    
    #-----< id-PC5LinkAMBR >-----#
    id_PC5LinkAMBR = INT(name='id-PC5LinkAMBR', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PC5LinkAMBR._val = 340
    
    #-----< id-SL-PHY-MAC-RLC-Config >-----#
    id_SL_PHY_MAC_RLC_Config = INT(name='id-SL-PHY-MAC-RLC-Config', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SL_PHY_MAC_RLC_Config._val = 341
    
    #-----< id-SL-ConfigDedicatedEUTRA-Info >-----#
    id_SL_ConfigDedicatedEUTRA_Info = INT(name='id-SL-ConfigDedicatedEUTRA-Info', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SL_ConfigDedicatedEUTRA_Info._val = 342
    
    #-----< id-AlternativeQoSParaSetList >-----#
    id_AlternativeQoSParaSetList = INT(name='id-AlternativeQoSParaSetList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AlternativeQoSParaSetList._val = 343
    
    #-----< id-CurrentQoSParaSetIndex >-----#
    id_CurrentQoSParaSetIndex = INT(name='id-CurrentQoSParaSetIndex', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CurrentQoSParaSetIndex._val = 344
    
    #-----< id-gNBCUMeasurementID >-----#
    id_gNBCUMeasurementID = INT(name='id-gNBCUMeasurementID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNBCUMeasurementID._val = 345
    
    #-----< id-gNBDUMeasurementID >-----#
    id_gNBDUMeasurementID = INT(name='id-gNBDUMeasurementID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNBDUMeasurementID._val = 346
    
    #-----< id-RegistrationRequest >-----#
    id_RegistrationRequest = INT(name='id-RegistrationRequest', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RegistrationRequest._val = 347
    
    #-----< id-ReportCharacteristics >-----#
    id_ReportCharacteristics = INT(name='id-ReportCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReportCharacteristics._val = 348
    
    #-----< id-CellToReportList >-----#
    id_CellToReportList = INT(name='id-CellToReportList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellToReportList._val = 349
    
    #-----< id-CellMeasurementResultList >-----#
    id_CellMeasurementResultList = INT(name='id-CellMeasurementResultList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellMeasurementResultList._val = 350
    
    #-----< id-HardwareLoadIndicator >-----#
    id_HardwareLoadIndicator = INT(name='id-HardwareLoadIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HardwareLoadIndicator._val = 351
    
    #-----< id-ReportingPeriodicity >-----#
    id_ReportingPeriodicity = INT(name='id-ReportingPeriodicity', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReportingPeriodicity._val = 352
    
    #-----< id-TNLCapacityIndicator >-----#
    id_TNLCapacityIndicator = INT(name='id-TNLCapacityIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TNLCapacityIndicator._val = 353
    
    #-----< id-CarrierList >-----#
    id_CarrierList = INT(name='id-CarrierList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CarrierList._val = 354
    
    #-----< id-ULCarrierList >-----#
    id_ULCarrierList = INT(name='id-ULCarrierList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ULCarrierList._val = 355
    
    #-----< id-FrequencyShift7p5khz >-----#
    id_FrequencyShift7p5khz = INT(name='id-FrequencyShift7p5khz', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FrequencyShift7p5khz._val = 356
    
    #-----< id-SSB-PositionsInBurst >-----#
    id_SSB_PositionsInBurst = INT(name='id-SSB-PositionsInBurst', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SSB_PositionsInBurst._val = 357
    
    #-----< id-NRPRACHConfig >-----#
    id_NRPRACHConfig = INT(name='id-NRPRACHConfig', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRPRACHConfig._val = 358
    
    #-----< id-RACHReportInformationList >-----#
    id_RACHReportInformationList = INT(name='id-RACHReportInformationList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RACHReportInformationList._val = 359
    
    #-----< id-RLFReportInformationList >-----#
    id_RLFReportInformationList = INT(name='id-RLFReportInformationList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RLFReportInformationList._val = 360
    
    #-----< id-TDD-UL-DLConfigCommonNR >-----#
    id_TDD_UL_DLConfigCommonNR = INT(name='id-TDD-UL-DLConfigCommonNR', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD_UL_DLConfigCommonNR._val = 361
    
    #-----< id-CNPacketDelayBudgetDownlink >-----#
    id_CNPacketDelayBudgetDownlink = INT(name='id-CNPacketDelayBudgetDownlink', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CNPacketDelayBudgetDownlink._val = 362
    
    #-----< id-ExtendedPacketDelayBudget >-----#
    id_ExtendedPacketDelayBudget = INT(name='id-ExtendedPacketDelayBudget', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedPacketDelayBudget._val = 363
    
    #-----< id-TSCTrafficCharacteristics >-----#
    id_TSCTrafficCharacteristics = INT(name='id-TSCTrafficCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TSCTrafficCharacteristics._val = 364
    
    #-----< id-ReportingRequestType >-----#
    id_ReportingRequestType = INT(name='id-ReportingRequestType', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReportingRequestType._val = 365
    
    #-----< id-TimeReferenceInformation >-----#
    id_TimeReferenceInformation = INT(name='id-TimeReferenceInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeReferenceInformation._val = 366
    
    #-----< id-CNPacketDelayBudgetUplink >-----#
    id_CNPacketDelayBudgetUplink = INT(name='id-CNPacketDelayBudgetUplink', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CNPacketDelayBudgetUplink._val = 369
    
    #-----< id-AdditionalPDCPDuplicationTNL-List >-----#
    id_AdditionalPDCPDuplicationTNL_List = INT(name='id-AdditionalPDCPDuplicationTNL-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalPDCPDuplicationTNL_List._val = 370
    
    #-----< id-RLCDuplicationInformation >-----#
    id_RLCDuplicationInformation = INT(name='id-RLCDuplicationInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RLCDuplicationInformation._val = 371
    
    #-----< id-AdditionalDuplicationIndication >-----#
    id_AdditionalDuplicationIndication = INT(name='id-AdditionalDuplicationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalDuplicationIndication._val = 372
    
    #-----< id-ConditionalInterDUMobilityInformation >-----#
    id_ConditionalInterDUMobilityInformation = INT(name='id-ConditionalInterDUMobilityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ConditionalInterDUMobilityInformation._val = 373
    
    #-----< id-ConditionalIntraDUMobilityInformation >-----#
    id_ConditionalIntraDUMobilityInformation = INT(name='id-ConditionalIntraDUMobilityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ConditionalIntraDUMobilityInformation._val = 374
    
    #-----< id-targetCellsToCancel >-----#
    id_targetCellsToCancel = INT(name='id-targetCellsToCancel', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_targetCellsToCancel._val = 375
    
    #-----< id-requestedTargetCellGlobalID >-----#
    id_requestedTargetCellGlobalID = INT(name='id-requestedTargetCellGlobalID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_requestedTargetCellGlobalID._val = 376
    
    #-----< id-ManagementBasedMDTPLMNList >-----#
    id_ManagementBasedMDTPLMNList = INT(name='id-ManagementBasedMDTPLMNList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ManagementBasedMDTPLMNList._val = 377
    
    #-----< id-TraceCollectionEntityIPAddress >-----#
    id_TraceCollectionEntityIPAddress = INT(name='id-TraceCollectionEntityIPAddress', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceCollectionEntityIPAddress._val = 378
    
    #-----< id-PrivacyIndicator >-----#
    id_PrivacyIndicator = INT(name='id-PrivacyIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PrivacyIndicator._val = 379
    
    #-----< id-TraceCollectionEntityURI >-----#
    id_TraceCollectionEntityURI = INT(name='id-TraceCollectionEntityURI', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceCollectionEntityURI._val = 380
    
    #-----< id-mdtConfiguration >-----#
    id_mdtConfiguration = INT(name='id-mdtConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_mdtConfiguration._val = 381
    
    #-----< id-ServingNID >-----#
    id_ServingNID = INT(name='id-ServingNID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServingNID._val = 382
    
    #-----< id-NPNBroadcastInformation >-----#
    id_NPNBroadcastInformation = INT(name='id-NPNBroadcastInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NPNBroadcastInformation._val = 383
    
    #-----< id-NPNSupportInfo >-----#
    id_NPNSupportInfo = INT(name='id-NPNSupportInfo', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NPNSupportInfo._val = 384
    
    #-----< id-NID >-----#
    id_NID = INT(name='id-NID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NID._val = 385
    
    #-----< id-AvailableSNPN-ID-List >-----#
    id_AvailableSNPN_ID_List = INT(name='id-AvailableSNPN-ID-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AvailableSNPN_ID_List._val = 386
    
    #-----< id-SIB10-message >-----#
    id_SIB10_message = INT(name='id-SIB10-message', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SIB10_message._val = 387
    
    #-----< id-DLCarrierList >-----#
    id_DLCarrierList = INT(name='id-DLCarrierList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DLCarrierList._val = 389
    
    #-----< id-ExtendedTAISliceSupportList >-----#
    id_ExtendedTAISliceSupportList = INT(name='id-ExtendedTAISliceSupportList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedTAISliceSupportList._val = 390
    
    #-----< id-RequestedSRSTransmissionCharacteristics >-----#
    id_RequestedSRSTransmissionCharacteristics = INT(name='id-RequestedSRSTransmissionCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RequestedSRSTransmissionCharacteristics._val = 391
    
    #-----< id-PosAssistance-Information >-----#
    id_PosAssistance_Information = INT(name='id-PosAssistance-Information', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PosAssistance_Information._val = 392
    
    #-----< id-PosBroadcast >-----#
    id_PosBroadcast = INT(name='id-PosBroadcast', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PosBroadcast._val = 393
    
    #-----< id-RoutingID >-----#
    id_RoutingID = INT(name='id-RoutingID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RoutingID._val = 394
    
    #-----< id-PosAssistanceInformationFailureList >-----#
    id_PosAssistanceInformationFailureList = INT(name='id-PosAssistanceInformationFailureList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PosAssistanceInformationFailureList._val = 395
    
    #-----< id-PosMeasurementQuantities >-----#
    id_PosMeasurementQuantities = INT(name='id-PosMeasurementQuantities', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PosMeasurementQuantities._val = 396
    
    #-----< id-PosMeasurementResultList >-----#
    id_PosMeasurementResultList = INT(name='id-PosMeasurementResultList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PosMeasurementResultList._val = 397
    
    #-----< id-TRPInformationTypeListTRPReq >-----#
    id_TRPInformationTypeListTRPReq = INT(name='id-TRPInformationTypeListTRPReq', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPInformationTypeListTRPReq._val = 398
    
    #-----< id-TRPInformationTypeItem >-----#
    id_TRPInformationTypeItem = INT(name='id-TRPInformationTypeItem', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPInformationTypeItem._val = 399
    
    #-----< id-TRPInformationListTRPResp >-----#
    id_TRPInformationListTRPResp = INT(name='id-TRPInformationListTRPResp', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPInformationListTRPResp._val = 400
    
    #-----< id-TRPInformationItem >-----#
    id_TRPInformationItem = INT(name='id-TRPInformationItem', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPInformationItem._val = 401
    
    #-----< id-LMF-MeasurementID >-----#
    id_LMF_MeasurementID = INT(name='id-LMF-MeasurementID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LMF_MeasurementID._val = 402
    
    #-----< id-SRSType >-----#
    id_SRSType = INT(name='id-SRSType', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRSType._val = 403
    
    #-----< id-ActivationTime >-----#
    id_ActivationTime = INT(name='id-ActivationTime', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ActivationTime._val = 404
    
    #-----< id-AbortTransmission >-----#
    id_AbortTransmission = INT(name='id-AbortTransmission', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AbortTransmission._val = 405
    
    #-----< id-PositioningBroadcastCells >-----#
    id_PositioningBroadcastCells = INT(name='id-PositioningBroadcastCells', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PositioningBroadcastCells._val = 406
    
    #-----< id-SRSConfiguration >-----#
    id_SRSConfiguration = INT(name='id-SRSConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRSConfiguration._val = 407
    
    #-----< id-PosReportCharacteristics >-----#
    id_PosReportCharacteristics = INT(name='id-PosReportCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PosReportCharacteristics._val = 408
    
    #-----< id-PosMeasurementPeriodicity >-----#
    id_PosMeasurementPeriodicity = INT(name='id-PosMeasurementPeriodicity', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PosMeasurementPeriodicity._val = 409
    
    #-----< id-TRPList >-----#
    id_TRPList = INT(name='id-TRPList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPList._val = 410
    
    #-----< id-RAN-MeasurementID >-----#
    id_RAN_MeasurementID = INT(name='id-RAN-MeasurementID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RAN_MeasurementID._val = 411
    
    #-----< id-LMF-UE-MeasurementID >-----#
    id_LMF_UE_MeasurementID = INT(name='id-LMF-UE-MeasurementID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LMF_UE_MeasurementID._val = 412
    
    #-----< id-RAN-UE-MeasurementID >-----#
    id_RAN_UE_MeasurementID = INT(name='id-RAN-UE-MeasurementID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RAN_UE_MeasurementID._val = 413
    
    #-----< id-E-CID-MeasurementQuantities >-----#
    id_E_CID_MeasurementQuantities = INT(name='id-E-CID-MeasurementQuantities', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_CID_MeasurementQuantities._val = 414
    
    #-----< id-E-CID-MeasurementQuantities-Item >-----#
    id_E_CID_MeasurementQuantities_Item = INT(name='id-E-CID-MeasurementQuantities-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_CID_MeasurementQuantities_Item._val = 415
    
    #-----< id-E-CID-MeasurementPeriodicity >-----#
    id_E_CID_MeasurementPeriodicity = INT(name='id-E-CID-MeasurementPeriodicity', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_CID_MeasurementPeriodicity._val = 416
    
    #-----< id-E-CID-MeasurementResult >-----#
    id_E_CID_MeasurementResult = INT(name='id-E-CID-MeasurementResult', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_CID_MeasurementResult._val = 417
    
    #-----< id-Cell-Portion-ID >-----#
    id_Cell_Portion_ID = INT(name='id-Cell-Portion-ID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cell_Portion_ID._val = 418
    
    #-----< id-SFNInitialisationTime >-----#
    id_SFNInitialisationTime = INT(name='id-SFNInitialisationTime', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SFNInitialisationTime._val = 419
    
    #-----< id-SystemFrameNumber >-----#
    id_SystemFrameNumber = INT(name='id-SystemFrameNumber', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SystemFrameNumber._val = 420
    
    #-----< id-SlotNumber >-----#
    id_SlotNumber = INT(name='id-SlotNumber', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SlotNumber._val = 421
    
    #-----< id-TRP-MeasurementRequestList >-----#
    id_TRP_MeasurementRequestList = INT(name='id-TRP-MeasurementRequestList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRP_MeasurementRequestList._val = 422
    
    #-----< id-MeasurementBeamInfoRequest >-----#
    id_MeasurementBeamInfoRequest = INT(name='id-MeasurementBeamInfoRequest', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementBeamInfoRequest._val = 423
    
    #-----< id-E-CID-ReportCharacteristics >-----#
    id_E_CID_ReportCharacteristics = INT(name='id-E-CID-ReportCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_CID_ReportCharacteristics._val = 424
    
    #-----< id-ConfiguredTACIndication >-----#
    id_ConfiguredTACIndication = INT(name='id-ConfiguredTACIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ConfiguredTACIndication._val = 425
    
    #-----< id-Extended-GNB-CU-Name >-----#
    id_Extended_GNB_CU_Name = INT(name='id-Extended-GNB-CU-Name', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_GNB_CU_Name._val = 426
    
    #-----< id-Extended-GNB-DU-Name >-----#
    id_Extended_GNB_DU_Name = INT(name='id-Extended-GNB-DU-Name', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_GNB_DU_Name._val = 427
    
    #-----< id-F1CTransferPath >-----#
    id_F1CTransferPath = INT(name='id-F1CTransferPath', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_F1CTransferPath._val = 428
    
    #-----< id-SFN-Offset >-----#
    id_SFN_Offset = INT(name='id-SFN-Offset', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SFN_Offset._val = 429
    
    #-----< id-TransmissionStopIndicator >-----#
    id_TransmissionStopIndicator = INT(name='id-TransmissionStopIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransmissionStopIndicator._val = 430
    
    #-----< id-SrsFrequency >-----#
    id_SrsFrequency = INT(name='id-SrsFrequency', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SrsFrequency._val = 431
    
    #-----< id-SCGIndicator >-----#
    id_SCGIndicator = INT(name='id-SCGIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCGIndicator._val = 432
    
    #-----< id-EstimatedArrivalProbability >-----#
    id_EstimatedArrivalProbability = INT(name='id-EstimatedArrivalProbability', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EstimatedArrivalProbability._val = 433
    
    #-----< id-TRPType >-----#
    id_TRPType = INT(name='id-TRPType', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPType._val = 434
    
    #-----< id-SRSSpatialRelationPerSRSResource >-----#
    id_SRSSpatialRelationPerSRSResource = INT(name='id-SRSSpatialRelationPerSRSResource', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRSSpatialRelationPerSRSResource._val = 435
    
    #-----< id-PDCPTerminatingNodeDLTNLAddrInfo >-----#
    id_PDCPTerminatingNodeDLTNLAddrInfo = INT(name='id-PDCPTerminatingNodeDLTNLAddrInfo', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDCPTerminatingNodeDLTNLAddrInfo._val = 436
    
    #-----< id-ENBDLTNLAddress >-----#
    id_ENBDLTNLAddress = INT(name='id-ENBDLTNLAddress', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ENBDLTNLAddress._val = 437
    
    #-----< id-PosMeasurementPeriodicityExtended >-----#
    id_PosMeasurementPeriodicityExtended = INT(name='id-PosMeasurementPeriodicityExtended', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PosMeasurementPeriodicityExtended._val = 438
    
    #-----< id-PRS-Resource-ID >-----#
    id_PRS_Resource_ID = INT(name='id-PRS-Resource-ID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PRS_Resource_ID._val = 439
    
    #-----< id-LocationMeasurementInformation >-----#
    id_LocationMeasurementInformation = INT(name='id-LocationMeasurementInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LocationMeasurementInformation._val = 440
    
    #-----< id-SliceRadioResourceStatus >-----#
    id_SliceRadioResourceStatus = INT(name='id-SliceRadioResourceStatus', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SliceRadioResourceStatus._val = 441
    
    #-----< id-CompositeAvailableCapacity-SUL >-----#
    id_CompositeAvailableCapacity_SUL = INT(name='id-CompositeAvailableCapacity-SUL', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CompositeAvailableCapacity_SUL._val = 442
    
    #-----< id-SuccessfulHOReportInformationList >-----#
    id_SuccessfulHOReportInformationList = INT(name='id-SuccessfulHOReportInformationList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SuccessfulHOReportInformationList._val = 443
    
    #-----< id-NR-U-Channel-List >-----#
    id_NR_U_Channel_List = INT(name='id-NR-U-Channel-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NR_U_Channel_List._val = 444
    
    #-----< id-NR-U >-----#
    id_NR_U = INT(name='id-NR-U', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NR_U._val = 445
    
    #-----< id-Coverage-Modification-Notification >-----#
    id_Coverage_Modification_Notification = INT(name='id-Coverage-Modification-Notification', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Coverage_Modification_Notification._val = 446
    
    #-----< id-CCO-Assistance-Information >-----#
    id_CCO_Assistance_Information = INT(name='id-CCO-Assistance-Information', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCO_Assistance_Information._val = 447
    
    #-----< id-Neighbor-node-CCO-Assistance-Information-List >-----#
    id_Neighbor_node_CCO_Assistance_Information_List = INT(name='id-Neighbor-node-CCO-Assistance-Information-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Neighbor_node_CCO_Assistance_Information_List._val = 448
    
    #-----< id-CellsForSON-List >-----#
    id_CellsForSON_List = INT(name='id-CellsForSON-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellsForSON_List._val = 449
    
    #-----< id-MIMOPRBusageInformation >-----#
    id_MIMOPRBusageInformation = INT(name='id-MIMOPRBusageInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MIMOPRBusageInformation._val = 450
    
    #-----< id-gNB-CU-MBS-F1AP-ID >-----#
    id_gNB_CU_MBS_F1AP_ID = INT(name='id-gNB-CU-MBS-F1AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNB_CU_MBS_F1AP_ID._val = 451
    
    #-----< id-gNB-DU-MBS-F1AP-ID >-----#
    id_gNB_DU_MBS_F1AP_ID = INT(name='id-gNB-DU-MBS-F1AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_gNB_DU_MBS_F1AP_ID._val = 452
    
    #-----< id-MBS-Area-Session-ID >-----#
    id_MBS_Area_Session_ID = INT(name='id-MBS-Area-Session-ID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBS_Area_Session_ID._val = 453
    
    #-----< id-MBS-CUtoDURRCInformation >-----#
    id_MBS_CUtoDURRCInformation = INT(name='id-MBS-CUtoDURRCInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBS_CUtoDURRCInformation._val = 454
    
    #-----< id-MBS-Session-ID >-----#
    id_MBS_Session_ID = INT(name='id-MBS-Session-ID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBS_Session_ID._val = 455
    
    #-----< id-SNSSAI >-----#
    id_SNSSAI = INT(name='id-SNSSAI', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SNSSAI._val = 456
    
    #-----< id-MBS-Broadcast-NeighbourCellList >-----#
    id_MBS_Broadcast_NeighbourCellList = INT(name='id-MBS-Broadcast-NeighbourCellList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBS_Broadcast_NeighbourCellList._val = 457
    
    #-----< id-BroadcastMRBs-FailedToBeModified-List >-----#
    id_BroadcastMRBs_FailedToBeModified_List = INT(name='id-BroadcastMRBs-FailedToBeModified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastMRBs_FailedToBeModified_List._val = 458
    
    #-----< id-BroadcastMRBs-FailedToBeModified-Item >-----#
    id_BroadcastMRBs_FailedToBeModified_Item = INT(name='id-BroadcastMRBs-FailedToBeModified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastMRBs_FailedToBeModified_Item._val = 459
    
    #-----< id-BroadcastMRBs-FailedToBeSetup-List >-----#
    id_BroadcastMRBs_FailedToBeSetup_List = INT(name='id-BroadcastMRBs-FailedToBeSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastMRBs_FailedToBeSetup_List._val = 460
    
    #-----< id-BroadcastMRBs-FailedToBeSetup-Item >-----#
    id_BroadcastMRBs_FailedToBeSetup_Item = INT(name='id-BroadcastMRBs-FailedToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastMRBs_FailedToBeSetup_Item._val = 461
    
    #-----< id-BroadcastMRBs-FailedToBeSetupMod-List >-----#
    id_BroadcastMRBs_FailedToBeSetupMod_List = INT(name='id-BroadcastMRBs-FailedToBeSetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastMRBs_FailedToBeSetupMod_List._val = 462
    
    #-----< id-BroadcastMRBs-FailedToBeSetupMod-Item >-----#
    id_BroadcastMRBs_FailedToBeSetupMod_Item = INT(name='id-BroadcastMRBs-FailedToBeSetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastMRBs_FailedToBeSetupMod_Item._val = 463
    
    #-----< id-BroadcastMRBs-Modified-List >-----#
    id_BroadcastMRBs_Modified_List = INT(name='id-BroadcastMRBs-Modified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastMRBs_Modified_List._val = 464
    
    #-----< id-BroadcastMRBs-Modified-Item >-----#
    id_BroadcastMRBs_Modified_Item = INT(name='id-BroadcastMRBs-Modified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastMRBs_Modified_Item._val = 465
    
    #-----< id-BroadcastMRBs-Setup-List >-----#
    id_BroadcastMRBs_Setup_List = INT(name='id-BroadcastMRBs-Setup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastMRBs_Setup_List._val = 466
    
    #-----< id-BroadcastMRBs-Setup-Item >-----#
    id_BroadcastMRBs_Setup_Item = INT(name='id-BroadcastMRBs-Setup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastMRBs_Setup_Item._val = 467
    
    #-----< id-BroadcastMRBs-SetupMod-List >-----#
    id_BroadcastMRBs_SetupMod_List = INT(name='id-BroadcastMRBs-SetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastMRBs_SetupMod_List._val = 468
    
    #-----< id-BroadcastMRBs-SetupMod-Item >-----#
    id_BroadcastMRBs_SetupMod_Item = INT(name='id-BroadcastMRBs-SetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastMRBs_SetupMod_Item._val = 469
    
    #-----< id-BroadcastMRBs-ToBeModified-List >-----#
    id_BroadcastMRBs_ToBeModified_List = INT(name='id-BroadcastMRBs-ToBeModified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastMRBs_ToBeModified_List._val = 470
    
    #-----< id-BroadcastMRBs-ToBeModified-Item >-----#
    id_BroadcastMRBs_ToBeModified_Item = INT(name='id-BroadcastMRBs-ToBeModified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastMRBs_ToBeModified_Item._val = 471
    
    #-----< id-BroadcastMRBs-ToBeReleased-List >-----#
    id_BroadcastMRBs_ToBeReleased_List = INT(name='id-BroadcastMRBs-ToBeReleased-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastMRBs_ToBeReleased_List._val = 472
    
    #-----< id-BroadcastMRBs-ToBeReleased-Item >-----#
    id_BroadcastMRBs_ToBeReleased_Item = INT(name='id-BroadcastMRBs-ToBeReleased-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastMRBs_ToBeReleased_Item._val = 473
    
    #-----< id-BroadcastMRBs-ToBeSetup-List >-----#
    id_BroadcastMRBs_ToBeSetup_List = INT(name='id-BroadcastMRBs-ToBeSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastMRBs_ToBeSetup_List._val = 474
    
    #-----< id-BroadcastMRBs-ToBeSetup-Item >-----#
    id_BroadcastMRBs_ToBeSetup_Item = INT(name='id-BroadcastMRBs-ToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastMRBs_ToBeSetup_Item._val = 475
    
    #-----< id-BroadcastMRBs-ToBeSetupMod-List >-----#
    id_BroadcastMRBs_ToBeSetupMod_List = INT(name='id-BroadcastMRBs-ToBeSetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastMRBs_ToBeSetupMod_List._val = 476
    
    #-----< id-BroadcastMRBs-ToBeSetupMod-Item >-----#
    id_BroadcastMRBs_ToBeSetupMod_Item = INT(name='id-BroadcastMRBs-ToBeSetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastMRBs_ToBeSetupMod_Item._val = 477
    
    #-----< id-Supported-MBS-FSA-ID-List >-----#
    id_Supported_MBS_FSA_ID_List = INT(name='id-Supported-MBS-FSA-ID-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Supported_MBS_FSA_ID_List._val = 478
    
    #-----< id-UEIdentity-List-For-Paging-List >-----#
    id_UEIdentity_List_For_Paging_List = INT(name='id-UEIdentity-List-For-Paging-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEIdentity_List_For_Paging_List._val = 479
    
    #-----< id-UEIdentity-List-For-Paging-Item >-----#
    id_UEIdentity_List_For_Paging_Item = INT(name='id-UEIdentity-List-For-Paging-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEIdentity_List_For_Paging_Item._val = 480
    
    #-----< id-MBS-ServiceArea >-----#
    id_MBS_ServiceArea = INT(name='id-MBS-ServiceArea', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBS_ServiceArea._val = 481
    
    #-----< id-MulticastMRBs-FailedToBeModified-List >-----#
    id_MulticastMRBs_FailedToBeModified_List = INT(name='id-MulticastMRBs-FailedToBeModified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastMRBs_FailedToBeModified_List._val = 482
    
    #-----< id-MulticastMRBs-FailedToBeModified-Item >-----#
    id_MulticastMRBs_FailedToBeModified_Item = INT(name='id-MulticastMRBs-FailedToBeModified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastMRBs_FailedToBeModified_Item._val = 483
    
    #-----< id-MulticastMRBs-FailedToBeSetup-List >-----#
    id_MulticastMRBs_FailedToBeSetup_List = INT(name='id-MulticastMRBs-FailedToBeSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastMRBs_FailedToBeSetup_List._val = 484
    
    #-----< id-MulticastMRBs-FailedToBeSetup-Item >-----#
    id_MulticastMRBs_FailedToBeSetup_Item = INT(name='id-MulticastMRBs-FailedToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastMRBs_FailedToBeSetup_Item._val = 485
    
    #-----< id-MulticastMRBs-FailedToBeSetupMod-List >-----#
    id_MulticastMRBs_FailedToBeSetupMod_List = INT(name='id-MulticastMRBs-FailedToBeSetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastMRBs_FailedToBeSetupMod_List._val = 486
    
    #-----< id-MulticastMRBs-FailedToBeSetupMod-Item >-----#
    id_MulticastMRBs_FailedToBeSetupMod_Item = INT(name='id-MulticastMRBs-FailedToBeSetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastMRBs_FailedToBeSetupMod_Item._val = 487
    
    #-----< id-MulticastMRBs-Modified-List >-----#
    id_MulticastMRBs_Modified_List = INT(name='id-MulticastMRBs-Modified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastMRBs_Modified_List._val = 488
    
    #-----< id-MulticastMRBs-Modified-Item >-----#
    id_MulticastMRBs_Modified_Item = INT(name='id-MulticastMRBs-Modified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastMRBs_Modified_Item._val = 489
    
    #-----< id-MulticastMRBs-Setup-List >-----#
    id_MulticastMRBs_Setup_List = INT(name='id-MulticastMRBs-Setup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastMRBs_Setup_List._val = 490
    
    #-----< id-MulticastMRBs-Setup-Item >-----#
    id_MulticastMRBs_Setup_Item = INT(name='id-MulticastMRBs-Setup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastMRBs_Setup_Item._val = 491
    
    #-----< id-MulticastMRBs-SetupMod-List >-----#
    id_MulticastMRBs_SetupMod_List = INT(name='id-MulticastMRBs-SetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastMRBs_SetupMod_List._val = 492
    
    #-----< id-MulticastMRBs-SetupMod-Item >-----#
    id_MulticastMRBs_SetupMod_Item = INT(name='id-MulticastMRBs-SetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastMRBs_SetupMod_Item._val = 493
    
    #-----< id-MulticastMRBs-ToBeModified-List >-----#
    id_MulticastMRBs_ToBeModified_List = INT(name='id-MulticastMRBs-ToBeModified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastMRBs_ToBeModified_List._val = 494
    
    #-----< id-MulticastMRBs-ToBeModified-Item >-----#
    id_MulticastMRBs_ToBeModified_Item = INT(name='id-MulticastMRBs-ToBeModified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastMRBs_ToBeModified_Item._val = 495
    
    #-----< id-MulticastMRBs-ToBeReleased-List >-----#
    id_MulticastMRBs_ToBeReleased_List = INT(name='id-MulticastMRBs-ToBeReleased-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastMRBs_ToBeReleased_List._val = 496
    
    #-----< id-MulticastMRBs-ToBeReleased-Item >-----#
    id_MulticastMRBs_ToBeReleased_Item = INT(name='id-MulticastMRBs-ToBeReleased-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastMRBs_ToBeReleased_Item._val = 497
    
    #-----< id-MulticastMRBs-ToBeSetup-List >-----#
    id_MulticastMRBs_ToBeSetup_List = INT(name='id-MulticastMRBs-ToBeSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastMRBs_ToBeSetup_List._val = 498
    
    #-----< id-MulticastMRBs-ToBeSetup-Item >-----#
    id_MulticastMRBs_ToBeSetup_Item = INT(name='id-MulticastMRBs-ToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastMRBs_ToBeSetup_Item._val = 499
    
    #-----< id-MulticastMRBs-ToBeSetupMod-List >-----#
    id_MulticastMRBs_ToBeSetupMod_List = INT(name='id-MulticastMRBs-ToBeSetupMod-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastMRBs_ToBeSetupMod_List._val = 500
    
    #-----< id-MulticastMRBs-ToBeSetupMod-Item >-----#
    id_MulticastMRBs_ToBeSetupMod_Item = INT(name='id-MulticastMRBs-ToBeSetupMod-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastMRBs_ToBeSetupMod_Item._val = 501
    
    #-----< id-MBSMulticastF1UContextDescriptor >-----#
    id_MBSMulticastF1UContextDescriptor = INT(name='id-MBSMulticastF1UContextDescriptor', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSMulticastF1UContextDescriptor._val = 502
    
    #-----< id-MulticastF1UContext-ToBeSetup-List >-----#
    id_MulticastF1UContext_ToBeSetup_List = INT(name='id-MulticastF1UContext-ToBeSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastF1UContext_ToBeSetup_List._val = 503
    
    #-----< id-MulticastF1UContext-ToBeSetup-Item >-----#
    id_MulticastF1UContext_ToBeSetup_Item = INT(name='id-MulticastF1UContext-ToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastF1UContext_ToBeSetup_Item._val = 504
    
    #-----< id-MulticastF1UContext-Setup-List >-----#
    id_MulticastF1UContext_Setup_List = INT(name='id-MulticastF1UContext-Setup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastF1UContext_Setup_List._val = 505
    
    #-----< id-MulticastF1UContext-Setup-Item >-----#
    id_MulticastF1UContext_Setup_Item = INT(name='id-MulticastF1UContext-Setup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastF1UContext_Setup_Item._val = 506
    
    #-----< id-MulticastF1UContext-FailedToBeSetup-List >-----#
    id_MulticastF1UContext_FailedToBeSetup_List = INT(name='id-MulticastF1UContext-FailedToBeSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastF1UContext_FailedToBeSetup_List._val = 507
    
    #-----< id-MulticastF1UContext-FailedToBeSetup-Item >-----#
    id_MulticastF1UContext_FailedToBeSetup_Item = INT(name='id-MulticastF1UContext-FailedToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastF1UContext_FailedToBeSetup_Item._val = 508
    
    #-----< id-IABCongestionIndication >-----#
    id_IABCongestionIndication = INT(name='id-IABCongestionIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IABCongestionIndication._val = 509
    
    #-----< id-IABConditionalRRCMessageDeliveryIndication >-----#
    id_IABConditionalRRCMessageDeliveryIndication = INT(name='id-IABConditionalRRCMessageDeliveryIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IABConditionalRRCMessageDeliveryIndication._val = 510
    
    #-----< id-F1CTransferPathNRDC >-----#
    id_F1CTransferPathNRDC = INT(name='id-F1CTransferPathNRDC', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_F1CTransferPathNRDC._val = 511
    
    #-----< id-BufferSizeThresh >-----#
    id_BufferSizeThresh = INT(name='id-BufferSizeThresh', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BufferSizeThresh._val = 512
    
    #-----< id-IAB-TNL-Addresses-Exception >-----#
    id_IAB_TNL_Addresses_Exception = INT(name='id-IAB-TNL-Addresses-Exception', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_TNL_Addresses_Exception._val = 513
    
    #-----< id-BAP-Header-Rewriting-Added-List >-----#
    id_BAP_Header_Rewriting_Added_List = INT(name='id-BAP-Header-Rewriting-Added-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BAP_Header_Rewriting_Added_List._val = 514
    
    #-----< id-BAP-Header-Rewriting-Added-List-Item >-----#
    id_BAP_Header_Rewriting_Added_List_Item = INT(name='id-BAP-Header-Rewriting-Added-List-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BAP_Header_Rewriting_Added_List_Item._val = 515
    
    #-----< id-Re-routingEnableIndicator >-----#
    id_Re_routingEnableIndicator = INT(name='id-Re-routingEnableIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Re_routingEnableIndicator._val = 516
    
    #-----< id-NonF1terminatingTopologyIndicator >-----#
    id_NonF1terminatingTopologyIndicator = INT(name='id-NonF1terminatingTopologyIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NonF1terminatingTopologyIndicator._val = 517
    
    #-----< id-EgressNonF1terminatingTopologyIndicator >-----#
    id_EgressNonF1terminatingTopologyIndicator = INT(name='id-EgressNonF1terminatingTopologyIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EgressNonF1terminatingTopologyIndicator._val = 518
    
    #-----< id-IngressNonF1terminatingTopologyIndicator >-----#
    id_IngressNonF1terminatingTopologyIndicator = INT(name='id-IngressNonF1terminatingTopologyIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IngressNonF1terminatingTopologyIndicator._val = 519
    
    #-----< id-rBSetConfiguration >-----#
    id_rBSetConfiguration = INT(name='id-rBSetConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_rBSetConfiguration._val = 520
    
    #-----< id-frequency-Domain-HSNA-Configuration-List >-----#
    id_frequency_Domain_HSNA_Configuration_List = INT(name='id-frequency-Domain-HSNA-Configuration-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_frequency_Domain_HSNA_Configuration_List._val = 521
    
    #-----< id-child-IAB-Nodes-NA-Resource-List >-----#
    id_child_IAB_Nodes_NA_Resource_List = INT(name='id-child-IAB-Nodes-NA-Resource-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_child_IAB_Nodes_NA_Resource_List._val = 522
    
    #-----< id-Parent-IAB-Nodes-NA-Resource-Configuration-List >-----#
    id_Parent_IAB_Nodes_NA_Resource_Configuration_List = INT(name='id-Parent-IAB-Nodes-NA-Resource-Configuration-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Parent_IAB_Nodes_NA_Resource_Configuration_List._val = 523
    
    #-----< id-uL-FreqInfo >-----#
    id_uL_FreqInfo = INT(name='id-uL-FreqInfo', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_uL_FreqInfo._val = 524
    
    #-----< id-uL-Transmission-Bandwidth >-----#
    id_uL_Transmission_Bandwidth = INT(name='id-uL-Transmission-Bandwidth', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_uL_Transmission_Bandwidth._val = 525
    
    #-----< id-dL-FreqInfo >-----#
    id_dL_FreqInfo = INT(name='id-dL-FreqInfo', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_dL_FreqInfo._val = 526
    
    #-----< id-dL-Transmission-Bandwidth >-----#
    id_dL_Transmission_Bandwidth = INT(name='id-dL-Transmission-Bandwidth', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_dL_Transmission_Bandwidth._val = 527
    
    #-----< id-uL-NR-Carrier-List >-----#
    id_uL_NR_Carrier_List = INT(name='id-uL-NR-Carrier-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_uL_NR_Carrier_List._val = 528
    
    #-----< id-dL-NR-Carrier-List >-----#
    id_dL_NR_Carrier_List = INT(name='id-dL-NR-Carrier-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_dL_NR_Carrier_List._val = 529
    
    #-----< id-nRFreqInfo >-----#
    id_nRFreqInfo = INT(name='id-nRFreqInfo', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_nRFreqInfo._val = 530
    
    #-----< id-transmission-Bandwidth >-----#
    id_transmission_Bandwidth = INT(name='id-transmission-Bandwidth', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_transmission_Bandwidth._val = 531
    
    #-----< id-nR-Carrier-List >-----#
    id_nR_Carrier_List = INT(name='id-nR-Carrier-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_nR_Carrier_List._val = 532
    
    #-----< id-Neighbour-Node-Cells-List >-----#
    id_Neighbour_Node_Cells_List = INT(name='id-Neighbour-Node-Cells-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Neighbour_Node_Cells_List._val = 533
    
    #-----< id-Serving-Cells-List >-----#
    id_Serving_Cells_List = INT(name='id-Serving-Cells-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Serving_Cells_List._val = 534
    
    #-----< id-permutation >-----#
    id_permutation = INT(name='id-permutation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_permutation._val = 535
    
    #-----< id-MDTPollutedMeasurementIndicator >-----#
    id_MDTPollutedMeasurementIndicator = INT(name='id-MDTPollutedMeasurementIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MDTPollutedMeasurementIndicator._val = 536
    
    #-----< id-M5ReportAmount >-----#
    id_M5ReportAmount = INT(name='id-M5ReportAmount', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M5ReportAmount._val = 537
    
    #-----< id-M6ReportAmount >-----#
    id_M6ReportAmount = INT(name='id-M6ReportAmount', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M6ReportAmount._val = 538
    
    #-----< id-M7ReportAmount >-----#
    id_M7ReportAmount = INT(name='id-M7ReportAmount', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M7ReportAmount._val = 539
    
    #-----< id-SurvivalTime >-----#
    id_SurvivalTime = INT(name='id-SurvivalTime', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SurvivalTime._val = 540
    
    #-----< id-PDCMeasurementPeriodicity >-----#
    id_PDCMeasurementPeriodicity = INT(name='id-PDCMeasurementPeriodicity', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDCMeasurementPeriodicity._val = 541
    
    #-----< id-PDCMeasurementQuantities >-----#
    id_PDCMeasurementQuantities = INT(name='id-PDCMeasurementQuantities', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDCMeasurementQuantities._val = 542
    
    #-----< id-PDCMeasurementQuantities-Item >-----#
    id_PDCMeasurementQuantities_Item = INT(name='id-PDCMeasurementQuantities-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDCMeasurementQuantities_Item._val = 543
    
    #-----< id-PDCMeasurementResult >-----#
    id_PDCMeasurementResult = INT(name='id-PDCMeasurementResult', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDCMeasurementResult._val = 544
    
    #-----< id-PDCReportType >-----#
    id_PDCReportType = INT(name='id-PDCReportType', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDCReportType._val = 545
    
    #-----< id-RAN-UE-PDC-MeasID >-----#
    id_RAN_UE_PDC_MeasID = INT(name='id-RAN-UE-PDC-MeasID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RAN_UE_PDC_MeasID._val = 546
    
    #-----< id-SCGActivationRequest >-----#
    id_SCGActivationRequest = INT(name='id-SCGActivationRequest', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCGActivationRequest._val = 547
    
    #-----< id-SCGActivationStatus >-----#
    id_SCGActivationStatus = INT(name='id-SCGActivationStatus', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCGActivationStatus._val = 548
    
    #-----< id-PRSTRPList >-----#
    id_PRSTRPList = INT(name='id-PRSTRPList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PRSTRPList._val = 549
    
    #-----< id-PRSTransmissionTRPList >-----#
    id_PRSTransmissionTRPList = INT(name='id-PRSTransmissionTRPList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PRSTransmissionTRPList._val = 550
    
    #-----< id-OnDemandPRS >-----#
    id_OnDemandPRS = INT(name='id-OnDemandPRS', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_OnDemandPRS._val = 551
    
    #-----< id-AoA-SearchWindow >-----#
    id_AoA_SearchWindow = INT(name='id-AoA-SearchWindow', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AoA_SearchWindow._val = 552
    
    #-----< id-TRP-MeasurementUpdateList >-----#
    id_TRP_MeasurementUpdateList = INT(name='id-TRP-MeasurementUpdateList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRP_MeasurementUpdateList._val = 553
    
    #-----< id-ZoAInformation >-----#
    id_ZoAInformation = INT(name='id-ZoAInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ZoAInformation._val = 554
    
    #-----< id-ResponseTime >-----#
    id_ResponseTime = INT(name='id-ResponseTime', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResponseTime._val = 555
    
    #-----< id-ARPLocationInfo >-----#
    id_ARPLocationInfo = INT(name='id-ARPLocationInfo', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ARPLocationInfo._val = 556
    
    #-----< id-ARP-ID >-----#
    id_ARP_ID = INT(name='id-ARP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ARP_ID._val = 557
    
    #-----< id-MultipleULAoA >-----#
    id_MultipleULAoA = INT(name='id-MultipleULAoA', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MultipleULAoA._val = 558
    
    #-----< id-UL-SRS-RSRPP >-----#
    id_UL_SRS_RSRPP = INT(name='id-UL-SRS-RSRPP', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_SRS_RSRPP._val = 559
    
    #-----< id-SRSResourcetype >-----#
    id_SRSResourcetype = INT(name='id-SRSResourcetype', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRSResourcetype._val = 560
    
    #-----< id-ExtendedAdditionalPathList >-----#
    id_ExtendedAdditionalPathList = INT(name='id-ExtendedAdditionalPathList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedAdditionalPathList._val = 561
    
    #-----< id-LoS-NLoSInformation >-----#
    id_LoS_NLoSInformation = INT(name='id-LoS-NLoSInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LoS_NLoSInformation._val = 562
    
    #-----< id-NumberOfTRPRxTEG >-----#
    id_NumberOfTRPRxTEG = INT(name='id-NumberOfTRPRxTEG', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NumberOfTRPRxTEG._val = 564
    
    #-----< id-NumberOfTRPRxTxTEG >-----#
    id_NumberOfTRPRxTxTEG = INT(name='id-NumberOfTRPRxTxTEG', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NumberOfTRPRxTxTEG._val = 565
    
    #-----< id-TRPTxTEGAssociation >-----#
    id_TRPTxTEGAssociation = INT(name='id-TRPTxTEGAssociation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPTxTEGAssociation._val = 566
    
    #-----< id-TRPTEGInformation >-----#
    id_TRPTEGInformation = INT(name='id-TRPTEGInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPTEGInformation._val = 567
    
    #-----< id-TRPRx-TEGInformation >-----#
    id_TRPRx_TEGInformation = INT(name='id-TRPRx-TEGInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPRx_TEGInformation._val = 568
    
    #-----< id-TRP-PRS-Info-List >-----#
    id_TRP_PRS_Info_List = INT(name='id-TRP-PRS-Info-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRP_PRS_Info_List._val = 569
    
    #-----< id-PRS-Measurement-Info-List >-----#
    id_PRS_Measurement_Info_List = INT(name='id-PRS-Measurement-Info-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PRS_Measurement_Info_List._val = 570
    
    #-----< id-PRSConfigRequestType >-----#
    id_PRSConfigRequestType = INT(name='id-PRSConfigRequestType', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PRSConfigRequestType._val = 571
    
    #-----< id-MeasurementTimeOccasion >-----#
    id_MeasurementTimeOccasion = INT(name='id-MeasurementTimeOccasion', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementTimeOccasion._val = 573
    
    #-----< id-MeasurementCharacteristicsRequestIndicator >-----#
    id_MeasurementCharacteristicsRequestIndicator = INT(name='id-MeasurementCharacteristicsRequestIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementCharacteristicsRequestIndicator._val = 574
    
    #-----< id-UEReportingInformation >-----#
    id_UEReportingInformation = INT(name='id-UEReportingInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEReportingInformation._val = 575
    
    #-----< id-PosConextRevIndication >-----#
    id_PosConextRevIndication = INT(name='id-PosConextRevIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PosConextRevIndication._val = 576
    
    #-----< id-TRPBeamAntennaInformation >-----#
    id_TRPBeamAntennaInformation = INT(name='id-TRPBeamAntennaInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPBeamAntennaInformation._val = 577
    
    #-----< id-NRRedCapUEIndication >-----#
    id_NRRedCapUEIndication = INT(name='id-NRRedCapUEIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRRedCapUEIndication._val = 578
    
    #-----< id-Redcap-Bcast-Information >-----#
    id_Redcap_Bcast_Information = INT(name='id-Redcap-Bcast-Information', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Redcap_Bcast_Information._val = 579
    
    #-----< id-RANUEPagingDRX >-----#
    id_RANUEPagingDRX = INT(name='id-RANUEPagingDRX', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RANUEPagingDRX._val = 580
    
    #-----< id-CNUEPagingDRX >-----#
    id_CNUEPagingDRX = INT(name='id-CNUEPagingDRX', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CNUEPagingDRX._val = 581
    
    #-----< id-NRPagingeDRXInformation >-----#
    id_NRPagingeDRXInformation = INT(name='id-NRPagingeDRXInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRPagingeDRXInformation._val = 582
    
    #-----< id-NRPagingeDRXInformationforRRCINACTIVE >-----#
    id_NRPagingeDRXInformationforRRCINACTIVE = INT(name='id-NRPagingeDRXInformationforRRCINACTIVE', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRPagingeDRXInformationforRRCINACTIVE._val = 583
    
    #-----< id-NR-TADV >-----#
    id_NR_TADV = INT(name='id-NR-TADV', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NR_TADV._val = 584
    
    #-----< id-QoEInformation >-----#
    id_QoEInformation = INT(name='id-QoEInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QoEInformation._val = 585
    
    #-----< id-CG-SDTQueryIndication >-----#
    id_CG_SDTQueryIndication = INT(name='id-CG-SDTQueryIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CG_SDTQueryIndication._val = 586
    
    #-----< id-SDT-MAC-PHY-CG-Config >-----#
    id_SDT_MAC_PHY_CG_Config = INT(name='id-SDT-MAC-PHY-CG-Config', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SDT_MAC_PHY_CG_Config._val = 587
    
    #-----< id-CG-SDTKeptIndicator >-----#
    id_CG_SDTKeptIndicator = INT(name='id-CG-SDTKeptIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CG_SDTKeptIndicator._val = 588
    
    #-----< id-CG-SDTindicatorSetup >-----#
    id_CG_SDTindicatorSetup = INT(name='id-CG-SDTindicatorSetup', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CG_SDTindicatorSetup._val = 589
    
    #-----< id-CG-SDTindicatorMod >-----#
    id_CG_SDTindicatorMod = INT(name='id-CG-SDTindicatorMod', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CG_SDTindicatorMod._val = 590
    
    #-----< id-CG-SDTSessionInfoOld >-----#
    id_CG_SDTSessionInfoOld = INT(name='id-CG-SDTSessionInfoOld', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CG_SDTSessionInfoOld._val = 591
    
    #-----< id-SDTInformation >-----#
    id_SDTInformation = INT(name='id-SDTInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SDTInformation._val = 592
    
    #-----< id-SDTRLCBearerConfiguration >-----#
    id_SDTRLCBearerConfiguration = INT(name='id-SDTRLCBearerConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SDTRLCBearerConfiguration._val = 593
    
    #-----< id-FiveG-ProSeAuthorized >-----#
    id_FiveG_ProSeAuthorized = INT(name='id-FiveG-ProSeAuthorized', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FiveG_ProSeAuthorized._val = 594
    
    #-----< id-FiveG-ProSeUEPC5AggregateMaximumBitrate >-----#
    id_FiveG_ProSeUEPC5AggregateMaximumBitrate = INT(name='id-FiveG-ProSeUEPC5AggregateMaximumBitrate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FiveG_ProSeUEPC5AggregateMaximumBitrate._val = 595
    
    #-----< id-FiveG-ProSePC5LinkAMBR >-----#
    id_FiveG_ProSePC5LinkAMBR = INT(name='id-FiveG-ProSePC5LinkAMBR', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FiveG_ProSePC5LinkAMBR._val = 596
    
    #-----< id-SRBMappingInfo >-----#
    id_SRBMappingInfo = INT(name='id-SRBMappingInfo', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBMappingInfo._val = 597
    
    #-----< id-DRBMappingInfo >-----#
    id_DRBMappingInfo = INT(name='id-DRBMappingInfo', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRBMappingInfo._val = 598
    
    #-----< id-UuRLCChannelToBeSetupList >-----#
    id_UuRLCChannelToBeSetupList = INT(name='id-UuRLCChannelToBeSetupList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UuRLCChannelToBeSetupList._val = 599
    
    #-----< id-UuRLCChannelToBeModifiedList >-----#
    id_UuRLCChannelToBeModifiedList = INT(name='id-UuRLCChannelToBeModifiedList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UuRLCChannelToBeModifiedList._val = 600
    
    #-----< id-UuRLCChannelToBeReleasedList >-----#
    id_UuRLCChannelToBeReleasedList = INT(name='id-UuRLCChannelToBeReleasedList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UuRLCChannelToBeReleasedList._val = 601
    
    #-----< id-UuRLCChannelSetupList >-----#
    id_UuRLCChannelSetupList = INT(name='id-UuRLCChannelSetupList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UuRLCChannelSetupList._val = 602
    
    #-----< id-UuRLCChannelFailedToBeSetupList >-----#
    id_UuRLCChannelFailedToBeSetupList = INT(name='id-UuRLCChannelFailedToBeSetupList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UuRLCChannelFailedToBeSetupList._val = 603
    
    #-----< id-UuRLCChannelModifiedList >-----#
    id_UuRLCChannelModifiedList = INT(name='id-UuRLCChannelModifiedList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UuRLCChannelModifiedList._val = 604
    
    #-----< id-UuRLCChannelFailedToBeModifiedList >-----#
    id_UuRLCChannelFailedToBeModifiedList = INT(name='id-UuRLCChannelFailedToBeModifiedList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UuRLCChannelFailedToBeModifiedList._val = 605
    
    #-----< id-UuRLCChannelRequiredToBeModifiedList >-----#
    id_UuRLCChannelRequiredToBeModifiedList = INT(name='id-UuRLCChannelRequiredToBeModifiedList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UuRLCChannelRequiredToBeModifiedList._val = 606
    
    #-----< id-UuRLCChannelRequiredToBeReleasedList >-----#
    id_UuRLCChannelRequiredToBeReleasedList = INT(name='id-UuRLCChannelRequiredToBeReleasedList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UuRLCChannelRequiredToBeReleasedList._val = 607
    
    #-----< id-PC5RLCChannelToBeSetupList >-----#
    id_PC5RLCChannelToBeSetupList = INT(name='id-PC5RLCChannelToBeSetupList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PC5RLCChannelToBeSetupList._val = 608
    
    #-----< id-PC5RLCChannelToBeModifiedList >-----#
    id_PC5RLCChannelToBeModifiedList = INT(name='id-PC5RLCChannelToBeModifiedList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PC5RLCChannelToBeModifiedList._val = 609
    
    #-----< id-PC5RLCChannelToBeReleasedList >-----#
    id_PC5RLCChannelToBeReleasedList = INT(name='id-PC5RLCChannelToBeReleasedList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PC5RLCChannelToBeReleasedList._val = 610
    
    #-----< id-PC5RLCChannelSetupList >-----#
    id_PC5RLCChannelSetupList = INT(name='id-PC5RLCChannelSetupList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PC5RLCChannelSetupList._val = 611
    
    #-----< id-PC5RLCChannelFailedToBeSetupList >-----#
    id_PC5RLCChannelFailedToBeSetupList = INT(name='id-PC5RLCChannelFailedToBeSetupList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PC5RLCChannelFailedToBeSetupList._val = 612
    
    #-----< id-PC5RLCChannelFailedToBeModifiedList >-----#
    id_PC5RLCChannelFailedToBeModifiedList = INT(name='id-PC5RLCChannelFailedToBeModifiedList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PC5RLCChannelFailedToBeModifiedList._val = 613
    
    #-----< id-PC5RLCChannelRequiredToBeModifiedList >-----#
    id_PC5RLCChannelRequiredToBeModifiedList = INT(name='id-PC5RLCChannelRequiredToBeModifiedList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PC5RLCChannelRequiredToBeModifiedList._val = 614
    
    #-----< id-PC5RLCChannelRequiredToBeReleasedList >-----#
    id_PC5RLCChannelRequiredToBeReleasedList = INT(name='id-PC5RLCChannelRequiredToBeReleasedList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PC5RLCChannelRequiredToBeReleasedList._val = 615
    
    #-----< id-PC5RLCChannelModifiedList >-----#
    id_PC5RLCChannelModifiedList = INT(name='id-PC5RLCChannelModifiedList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PC5RLCChannelModifiedList._val = 616
    
    #-----< id-SidelinkRelayConfiguration >-----#
    id_SidelinkRelayConfiguration = INT(name='id-SidelinkRelayConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SidelinkRelayConfiguration._val = 617
    
    #-----< id-UpdatedRemoteUELocalID >-----#
    id_UpdatedRemoteUELocalID = INT(name='id-UpdatedRemoteUELocalID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UpdatedRemoteUELocalID._val = 618
    
    #-----< id-PathSwitchConfiguration >-----#
    id_PathSwitchConfiguration = INT(name='id-PathSwitchConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PathSwitchConfiguration._val = 619
    
    #-----< id-PagingCause >-----#
    id_PagingCause = INT(name='id-PagingCause', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingCause._val = 620
    
    #-----< id-MUSIM-GapConfig >-----#
    id_MUSIM_GapConfig = INT(name='id-MUSIM-GapConfig', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MUSIM_GapConfig._val = 621
    
    #-----< id-PEIPSAssistanceInfo >-----#
    id_PEIPSAssistanceInfo = INT(name='id-PEIPSAssistanceInfo', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PEIPSAssistanceInfo._val = 622
    
    #-----< id-UEPagingCapability >-----#
    id_UEPagingCapability = INT(name='id-UEPagingCapability', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEPagingCapability._val = 623
    
    #-----< id-LastUsedCellIndication >-----#
    id_LastUsedCellIndication = INT(name='id-LastUsedCellIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LastUsedCellIndication._val = 624
    
    #-----< id-SIB17-message >-----#
    id_SIB17_message = INT(name='id-SIB17-message', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SIB17_message._val = 625
    
    #-----< id-GNBDUUESliceMaximumBitRateList >-----#
    id_GNBDUUESliceMaximumBitRateList = INT(name='id-GNBDUUESliceMaximumBitRateList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNBDUUESliceMaximumBitRateList._val = 626
    
    #-----< id-SIB20-message >-----#
    id_SIB20_message = INT(name='id-SIB20-message', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SIB20_message._val = 627
    
    #-----< id-UE-MulticastMRBs-ToBeReleased-List >-----#
    id_UE_MulticastMRBs_ToBeReleased_List = INT(name='id-UE-MulticastMRBs-ToBeReleased-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_MulticastMRBs_ToBeReleased_List._val = 628
    
    #-----< id-UE-MulticastMRBs-ToBeReleased-Item >-----#
    id_UE_MulticastMRBs_ToBeReleased_Item = INT(name='id-UE-MulticastMRBs-ToBeReleased-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_MulticastMRBs_ToBeReleased_Item._val = 629
    
    #-----< id-UE-MulticastMRBs-ToBeSetup-List >-----#
    id_UE_MulticastMRBs_ToBeSetup_List = INT(name='id-UE-MulticastMRBs-ToBeSetup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_MulticastMRBs_ToBeSetup_List._val = 630
    
    #-----< id-UE-MulticastMRBs-ToBeSetup-Item >-----#
    id_UE_MulticastMRBs_ToBeSetup_Item = INT(name='id-UE-MulticastMRBs-ToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_MulticastMRBs_ToBeSetup_Item._val = 631
    
    #-----< id-MulticastMBSSessionSetupList >-----#
    id_MulticastMBSSessionSetupList = INT(name='id-MulticastMBSSessionSetupList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastMBSSessionSetupList._val = 632
    
    #-----< id-MulticastMBSSessionRemoveList >-----#
    id_MulticastMBSSessionRemoveList = INT(name='id-MulticastMBSSessionRemoveList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastMBSSessionRemoveList._val = 633
    
    #-----< id-PosMeasurementAmount >-----#
    id_PosMeasurementAmount = INT(name='id-PosMeasurementAmount', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PosMeasurementAmount._val = 634
    
    #-----< id-SDT-Termination-Request >-----#
    id_SDT_Termination_Request = INT(name='id-SDT-Termination-Request', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SDT_Termination_Request._val = 635
    
    #-----< id-pathPower >-----#
    id_pathPower = INT(name='id-pathPower', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_pathPower._val = 636
    
    #-----< id-DU-RX-MT-RX-Extend >-----#
    id_DU_RX_MT_RX_Extend = INT(name='id-DU-RX-MT-RX-Extend', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DU_RX_MT_RX_Extend._val = 637
    
    #-----< id-DU-TX-MT-TX-Extend >-----#
    id_DU_TX_MT_TX_Extend = INT(name='id-DU-TX-MT-TX-Extend', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DU_TX_MT_TX_Extend._val = 638
    
    #-----< id-DU-RX-MT-TX-Extend >-----#
    id_DU_RX_MT_TX_Extend = INT(name='id-DU-RX-MT-TX-Extend', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DU_RX_MT_TX_Extend._val = 639
    
    #-----< id-DU-TX-MT-RX-Extend >-----#
    id_DU_TX_MT_RX_Extend = INT(name='id-DU-TX-MT-RX-Extend', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DU_TX_MT_RX_Extend._val = 640
    
    #-----< id-BAP-Header-Rewriting-Removed-List >-----#
    id_BAP_Header_Rewriting_Removed_List = INT(name='id-BAP-Header-Rewriting-Removed-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BAP_Header_Rewriting_Removed_List._val = 641
    
    #-----< id-BAP-Header-Rewriting-Removed-List-Item >-----#
    id_BAP_Header_Rewriting_Removed_List_Item = INT(name='id-BAP-Header-Rewriting-Removed-List-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BAP_Header_Rewriting_Removed_List_Item._val = 642
    
    #-----< id-SLDRXCycleList >-----#
    id_SLDRXCycleList = INT(name='id-SLDRXCycleList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SLDRXCycleList._val = 643
    
    #-----< id-TAINSAGSupportList >-----#
    id_TAINSAGSupportList = INT(name='id-TAINSAGSupportList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TAINSAGSupportList._val = 644
    
    #-----< id-SL-RLC-ChannelToAddModList >-----#
    id_SL_RLC_ChannelToAddModList = INT(name='id-SL-RLC-ChannelToAddModList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SL_RLC_ChannelToAddModList._val = 645
    
    #-----< id-BroadcastAreaScope >-----#
    id_BroadcastAreaScope = INT(name='id-BroadcastAreaScope', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastAreaScope._val = 646
    
    #-----< id-ManagementBasedMDTPLMNModificationList >-----#
    id_ManagementBasedMDTPLMNModificationList = INT(name='id-ManagementBasedMDTPLMNModificationList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ManagementBasedMDTPLMNModificationList._val = 647
    
    #-----< id-SIB15-message >-----#
    id_SIB15_message = INT(name='id-SIB15-message', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SIB15_message._val = 648
    
    #-----< id-ActivationRequestType >-----#
    id_ActivationRequestType = INT(name='id-ActivationRequestType', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ActivationRequestType._val = 649
    
    #-----< id-PosMeasGapPreConfigList >-----#
    id_PosMeasGapPreConfigList = INT(name='id-PosMeasGapPreConfigList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PosMeasGapPreConfigList._val = 650
    
    #-----< id-InterFrequencyConfig-NoGap >-----#
    id_InterFrequencyConfig_NoGap = INT(name='id-InterFrequencyConfig-NoGap', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InterFrequencyConfig_NoGap._val = 651
    
    #-----< id-MBSInterestIndication >-----#
    id_MBSInterestIndication = INT(name='id-MBSInterestIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSInterestIndication._val = 652
    
    #-----< id-UE-MulticastMRBs-ConfirmedToBeModified-List >-----#
    id_UE_MulticastMRBs_ConfirmedToBeModified_List = INT(name='id-UE-MulticastMRBs-ConfirmedToBeModified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_MulticastMRBs_ConfirmedToBeModified_List._val = 653
    
    #-----< id-UE-MulticastMRBs-ConfirmedToBeModified-Item >-----#
    id_UE_MulticastMRBs_ConfirmedToBeModified_Item = INT(name='id-UE-MulticastMRBs-ConfirmedToBeModified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_MulticastMRBs_ConfirmedToBeModified_Item._val = 654
    
    #-----< id-UE-MulticastMRBs-RequiredToBeModified-List >-----#
    id_UE_MulticastMRBs_RequiredToBeModified_List = INT(name='id-UE-MulticastMRBs-RequiredToBeModified-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_MulticastMRBs_RequiredToBeModified_List._val = 655
    
    #-----< id-UE-MulticastMRBs-RequiredToBeModified-Item >-----#
    id_UE_MulticastMRBs_RequiredToBeModified_Item = INT(name='id-UE-MulticastMRBs-RequiredToBeModified-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_MulticastMRBs_RequiredToBeModified_Item._val = 656
    
    #-----< id-UE-MulticastMRBs-RequiredToBeReleased-List >-----#
    id_UE_MulticastMRBs_RequiredToBeReleased_List = INT(name='id-UE-MulticastMRBs-RequiredToBeReleased-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_MulticastMRBs_RequiredToBeReleased_List._val = 657
    
    #-----< id-UE-MulticastMRBs-RequiredToBeReleased-Item >-----#
    id_UE_MulticastMRBs_RequiredToBeReleased_Item = INT(name='id-UE-MulticastMRBs-RequiredToBeReleased-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_MulticastMRBs_RequiredToBeReleased_Item._val = 658
    
    #-----< id-L571Info >-----#
    id_L571Info = INT(name='id-L571Info', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_L571Info._val = 659
    
    #-----< id-L1151Info >-----#
    id_L1151Info = INT(name='id-L1151Info', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_L1151Info._val = 660
    
    #-----< id-SCS-480 >-----#
    id_SCS_480 = INT(name='id-SCS-480', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCS_480._val = 661
    
    #-----< id-SCS-960 >-----#
    id_SCS_960 = INT(name='id-SCS-960', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCS_960._val = 662
    
    #-----< id-SRSPortIndex >-----#
    id_SRSPortIndex = INT(name='id-SRSPortIndex', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRSPortIndex._val = 663
    
    #-----< id-PEISubgroupingSupportIndication >-----#
    id_PEISubgroupingSupportIndication = INT(name='id-PEISubgroupingSupportIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PEISubgroupingSupportIndication._val = 664
    
    #-----< id-NeedForGapsInfoNR >-----#
    id_NeedForGapsInfoNR = INT(name='id-NeedForGapsInfoNR', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NeedForGapsInfoNR._val = 665
    
    #-----< id-NeedForGapNCSGInfoNR >-----#
    id_NeedForGapNCSGInfoNR = INT(name='id-NeedForGapNCSGInfoNR', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NeedForGapNCSGInfoNR._val = 666
    
    #-----< id-NeedForGapNCSGInfoEUTRA >-----#
    id_NeedForGapNCSGInfoEUTRA = INT(name='id-NeedForGapNCSGInfoEUTRA', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NeedForGapNCSGInfoEUTRA._val = 667
    
    #-----< id-procedure-code-668-not-to-be-used >-----#
    id_procedure_code_668_not_to_be_used = INT(name='id-procedure-code-668-not-to-be-used', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_procedure_code_668_not_to_be_used._val = 668
    
    #-----< id-procedure-code-669-not-to-be-used >-----#
    id_procedure_code_669_not_to_be_used = INT(name='id-procedure-code-669-not-to-be-used', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_procedure_code_669_not_to_be_used._val = 669
    
    #-----< id-procedure-code-670-not-to-be-used >-----#
    id_procedure_code_670_not_to_be_used = INT(name='id-procedure-code-670-not-to-be-used', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_procedure_code_670_not_to_be_used._val = 670
    
    #-----< id-Source-MRB-ID >-----#
    id_Source_MRB_ID = INT(name='id-Source-MRB-ID', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Source_MRB_ID._val = 671
    
    #-----< id-PosMeasurementPeriodicityNR-AoA >-----#
    id_PosMeasurementPeriodicityNR_AoA = INT(name='id-PosMeasurementPeriodicityNR-AoA', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PosMeasurementPeriodicityNR_AoA._val = 672
    
    #-----< id-RedCapIndication >-----#
    id_RedCapIndication = INT(name='id-RedCapIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RedCapIndication._val = 673
    
    #-----< id-SRSPosRRCInactiveConfig >-----#
    id_SRSPosRRCInactiveConfig = INT(name='id-SRSPosRRCInactiveConfig', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRSPosRRCInactiveConfig._val = 674
    
    #-----< id-SDTBearerConfigurationQueryIndication >-----#
    id_SDTBearerConfigurationQueryIndication = INT(name='id-SDTBearerConfigurationQueryIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SDTBearerConfigurationQueryIndication._val = 675
    
    #-----< id-SDTBearerConfigurationInfo >-----#
    id_SDTBearerConfigurationInfo = INT(name='id-SDTBearerConfigurationInfo', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SDTBearerConfigurationInfo._val = 676
    
    #-----< id-UL-GapFR2-Config >-----#
    id_UL_GapFR2_Config = INT(name='id-UL-GapFR2-Config', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_GapFR2_Config._val = 677
    
    #-----< id-ConfigRestrictInfoDAPS >-----#
    id_ConfigRestrictInfoDAPS = INT(name='id-ConfigRestrictInfoDAPS', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ConfigRestrictInfoDAPS._val = 678
    
    #-----< id-UE-MulticastMRBs-Setup-List >-----#
    id_UE_MulticastMRBs_Setup_List = INT(name='id-UE-MulticastMRBs-Setup-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_MulticastMRBs_Setup_List._val = 679
    
    #-----< id-UE-MulticastMRBs-Setup-Item >-----#
    id_UE_MulticastMRBs_Setup_Item = INT(name='id-UE-MulticastMRBs-Setup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_MulticastMRBs_Setup_Item._val = 680
    
    #-----< id-MulticastF1UContextReferenceCU >-----#
    id_MulticastF1UContextReferenceCU = INT(name='id-MulticastF1UContextReferenceCU', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastF1UContextReferenceCU._val = 681
    
    #-----< id-PosSItypeList >-----#
    id_PosSItypeList = INT(name='id-PosSItypeList', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PosSItypeList._val = 682
    
    #-----< id-DAPS-HO-Status >-----#
    id_DAPS_HO_Status = INT(name='id-DAPS-HO-Status', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DAPS_HO_Status._val = 683
    
    #-----< id-UplinkTxDirectCurrentTwoCarrierListInfo >-----#
    id_UplinkTxDirectCurrentTwoCarrierListInfo = INT(name='id-UplinkTxDirectCurrentTwoCarrierListInfo', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UplinkTxDirectCurrentTwoCarrierListInfo._val = 684
    
    #-----< id-UE-MulticastMRBs-ToBeSetup-atModify-List >-----#
    id_UE_MulticastMRBs_ToBeSetup_atModify_List = INT(name='id-UE-MulticastMRBs-ToBeSetup-atModify-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_MulticastMRBs_ToBeSetup_atModify_List._val = 685
    
    #-----< id-UE-MulticastMRBs-ToBeSetup-atModify-Item >-----#
    id_UE_MulticastMRBs_ToBeSetup_atModify_Item = INT(name='id-UE-MulticastMRBs-ToBeSetup-atModify-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_MulticastMRBs_ToBeSetup_atModify_Item._val = 686
    
    #-----< id-MC-PagingCell-List >-----#
    id_MC_PagingCell_List = INT(name='id-MC-PagingCell-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MC_PagingCell_List._val = 687
    
    #-----< id-MC-PagingCell-Item >-----#
    id_MC_PagingCell_Item = INT(name='id-MC-PagingCell-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MC_PagingCell_Item._val = 688
    
    #-----< id-SRSPosRRCInactiveQueryIndication >-----#
    id_SRSPosRRCInactiveQueryIndication = INT(name='id-SRSPosRRCInactiveQueryIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRSPosRRCInactiveQueryIndication._val = 689
    
    #-----< id-UlTxDirectCurrentMoreCarrierInformation >-----#
    id_UlTxDirectCurrentMoreCarrierInformation = INT(name='id-UlTxDirectCurrentMoreCarrierInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UlTxDirectCurrentMoreCarrierInformation._val = 690
    
    #-----< id-CPACMCGInformation >-----#
    id_CPACMCGInformation = INT(name='id-CPACMCGInformation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CPACMCGInformation._val = 691
    
    #-----< id-TwoPHRModeMCG >-----#
    id_TwoPHRModeMCG = INT(name='id-TwoPHRModeMCG', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TwoPHRModeMCG._val = 692
    
    #-----< id-TwoPHRModeSCG >-----#
    id_TwoPHRModeSCG = INT(name='id-TwoPHRModeSCG', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TwoPHRModeSCG._val = 693
    
    #-----< id-ExtendedUEIdentityIndexValue >-----#
    id_ExtendedUEIdentityIndexValue = INT(name='id-ExtendedUEIdentityIndexValue', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedUEIdentityIndexValue._val = 694
    
    #-----< id-ServingCellMO-List >-----#
    id_ServingCellMO_List = INT(name='id-ServingCellMO-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServingCellMO_List._val = 695
    
    #-----< id-ServingCellMO-List-Item >-----#
    id_ServingCellMO_List_Item = INT(name='id-ServingCellMO-List-Item', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServingCellMO_List_Item._val = 696
    
    #-----< id-ServingCellMO-encoded-in-CGC-List >-----#
    id_ServingCellMO_encoded_in_CGC_List = INT(name='id-ServingCellMO-encoded-in-CGC-List', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServingCellMO_encoded_in_CGC_List._val = 697
    
    _all_ = [
        id_Reset,
        id_F1Setup,
        id_ErrorIndication,
        id_gNBDUConfigurationUpdate,
        id_gNBCUConfigurationUpdate,
        id_UEContextSetup,
        id_UEContextRelease,
        id_UEContextModification,
        id_UEContextModificationRequired,
        id_UEMobilityCommand,
        id_UEContextReleaseRequest,
        id_InitialULRRCMessageTransfer,
        id_DLRRCMessageTransfer,
        id_ULRRCMessageTransfer,
        id_privateMessage,
        id_UEInactivityNotification,
        id_GNBDUResourceCoordination,
        id_SystemInformationDeliveryCommand,
        id_Paging,
        id_Notify,
        id_WriteReplaceWarning,
        id_PWSCancel,
        id_PWSRestartIndication,
        id_PWSFailureIndication,
        id_GNBDUStatusIndication,
        id_RRCDeliveryReport,
        id_F1Removal,
        id_NetworkAccessRateReduction,
        id_TraceStart,
        id_DeactivateTrace,
        id_DUCURadioInformationTransfer,
        id_CUDURadioInformationTransfer,
        id_BAPMappingConfiguration,
        id_GNBDUResourceConfiguration,
        id_IABTNLAddressAllocation,
        id_IABUPConfigurationUpdate,
        id_resourceStatusReportingInitiation,
        id_resourceStatusReporting,
        id_accessAndMobilityIndication,
        id_accessSuccess,
        id_cellTrafficTrace,
        id_PositioningMeasurementExchange,
        id_PositioningAssistanceInformationControl,
        id_PositioningAssistanceInformationFeedback,
        id_PositioningMeasurementReport,
        id_PositioningMeasurementAbort,
        id_PositioningMeasurementFailureIndication,
        id_PositioningMeasurementUpdate,
        id_TRPInformationExchange,
        id_PositioningInformationExchange,
        id_PositioningActivation,
        id_PositioningDeactivation,
        id_E_CIDMeasurementInitiation,
        id_E_CIDMeasurementFailureIndication,
        id_E_CIDMeasurementReport,
        id_E_CIDMeasurementTermination,
        id_PositioningInformationUpdate,
        id_ReferenceTimeInformationReport,
        id_ReferenceTimeInformationReportingControl,
        id_BroadcastContextSetup,
        id_BroadcastContextRelease,
        id_BroadcastContextReleaseRequest,
        id_BroadcastContextModification,
        id_MulticastGroupPaging,
        id_MulticastContextSetup,
        id_MulticastContextRelease,
        id_MulticastContextReleaseRequest,
        id_MulticastContextModification,
        id_MulticastDistributionSetup,
        id_MulticastDistributionRelease,
        id_PDCMeasurementInitiation,
        id_PDCMeasurementReport,
        id_PDCMeasurementInitiationRequest,
        id_PDCMeasurementInitiationResponse,
        id_PDCMeasurementInitiationFailure,
        id_pRSConfigurationExchange,
        id_measurementPreconfiguration,
        id_measurementActivation,
        id_QoEInformationTransfer,
        id_PDCMeasurementTerminationCommand,
        id_PDCMeasurementFailureIndication,
        id_PosSystemInformationDeliveryCommand,
        maxPrivateIEs,
        maxProtocolExtensions,
        maxProtocolIEs,
        maxNRARFCN,
        maxnoofErrors,
        maxnoofIndividualF1ConnectionsToReset,
        maxCellingNBDU,
        maxnoofSCells,
        maxnoofSRBs,
        maxnoofDRBs,
        maxnoofULUPTNLInformation,
        maxnoofDLUPTNLInformation,
        maxnoofBPLMNs,
        maxnoofCandidateSpCells,
        maxnoofPotentialSpCells,
        maxnoofNrCellBands,
        maxnoofSIBTypes,
        maxnoofSITypes,
        maxnoofPagingCells,
        maxnoofTNLAssociations,
        maxnoofQoSFlows,
        maxnoofSliceItems,
        maxCellineNB,
        maxnoofExtendedBPLMNs,
        maxnoofUEIDs,
        maxnoofBPLMNsNR,
        maxnoofUACPLMNs,
        maxnoofUACperPLMN,
        maxnoofAdditionalSIBs,
        maxnoofslots,
        maxnoofTLAs,
        maxnoofGTPTLAs,
        maxnoofBHRLCChannels,
        maxnoofRoutingEntries,
        maxnoofIABSTCInfo,
        maxnoofSymbols,
        maxnoofServingCells,
        maxnoofDUFSlots,
        maxnoofHSNASlots,
        maxnoofServedCellsIAB,
        maxnoofChildIABNodes,
        maxnoofNonUPTrafficMappings,
        maxnoofTLAsIAB,
        maxnoofMappingEntries,
        maxnoofDSInfo,
        maxnoofEgressLinks,
        maxnoofULUPTNLInformationforIAB,
        maxnoofUPTNLAddresses,
        maxnoofSLDRBs,
        maxnoofQoSParaSets,
        maxnoofPC5QoSFlows,
        maxnoofSSBAreas,
        maxnoofPhysicalResourceBlocks,
        maxnoofPhysicalResourceBlocks_1,
        maxnoofPRACHconfigs,
        maxnoofRACHReports,
        maxnoofRLFReports,
        maxnoofAdditionalPDCPDuplicationTNL,
        maxnoofRLCDuplicationState,
        maxnoofCHOcells,
        maxnoofMDTPLMNs,
        maxnoofCAGsupported,
        maxnoofNIDsupported,
        maxnoofNRSCSs,
        maxnoofExtSliceItems,
        maxnoofPosMeas,
        maxnoofTRPInfoTypes,
        maxnoofTRPs,
        maxnoofSRSTriggerStates,
        maxnoofSpatialRelations,
        maxnoBcastCell,
        maxnoofAngleInfo,
        maxnooflcs_gcs_translation,
        maxnoofPath,
        maxnoofMeasE_CID,
        maxnoofSSBs,
        maxnoSRS_ResourceSets,
        maxnoSRS_ResourcePerSet,
        maxnoSRS_Carriers,
        maxnoSCSs,
        maxnoSRS_Resources,
        maxnoSRS_PosResources,
        maxnoSRS_PosResourceSets,
        maxnoSRS_PosResourcePerSet,
        maxnoofPRS_ResourceSets,
        maxnoofPRS_ResourcesPerSet,
        maxNoOfMeasTRPs,
        maxnoofPRSresourceSets,
        maxnoofPRSresources,
        maxnoofSuccessfulHOReports,
        maxnoofNR_UChannelIDs,
        maxServedCellforSON,
        maxNeighbourCellforSON,
        maxAffectedCells,
        maxnoofMRBs,
        maxnoofMBSQoSFlows,
        maxnoofMBSFSAs,
        maxnoofUEIDforPaging,
        maxnoofCellsforMBS,
        maxnoofTAIforMBS,
        maxnoofMBSAreaSessionIDs,
        maxnoofMBSServiceAreaInformation,
        maxnoofIABCongInd,
        maxnoofNeighbourNodeCellsIAB,
        maxnoofRBsetsPerCell,
        maxnoofRBsetsPerCell_1,
        maxnoofMeasPDC,
        maxnoARPs,
        maxnoofULAoAs,
        maxNoPathExtended,
        maxnoTRPTEGs,
        maxFreqLayers,
        maxNumResourcesPerAngle,
        maxnoAzimuthAngles,
        maxnoElevationAngles,
        maxnoofPRSTRPs,
        maxnoofQoEInformation,
        maxnoofUuRLCChannels,
        maxnoofPC5RLCChannels,
        maxnoofSMBRValues,
        maxnoofMRBsforUE,
        maxnoofMBSSessionsofUE,
        maxnoofSLdestinations,
        maxnoofNSAGs,
        maxnoofSDTBearers,
        maxnoofServingCellMOs,
        maxNrofBWPs,
        maxnoofPosSITypes,
        id_Cause,
        id_Cells_Failed_to_be_Activated_List,
        id_Cells_Failed_to_be_Activated_List_Item,
        id_Cells_to_be_Activated_List,
        id_Cells_to_be_Activated_List_Item,
        id_Cells_to_be_Deactivated_List,
        id_Cells_to_be_Deactivated_List_Item,
        id_CriticalityDiagnostics,
        id_CUtoDURRCInformation,
        id_DRBs_FailedToBeModified_Item,
        id_DRBs_FailedToBeModified_List,
        id_DRBs_FailedToBeSetup_Item,
        id_DRBs_FailedToBeSetup_List,
        id_DRBs_FailedToBeSetupMod_Item,
        id_DRBs_FailedToBeSetupMod_List,
        id_DRBs_ModifiedConf_Item,
        id_DRBs_ModifiedConf_List,
        id_DRBs_Modified_Item,
        id_DRBs_Modified_List,
        id_DRBs_Required_ToBeModified_Item,
        id_DRBs_Required_ToBeModified_List,
        id_DRBs_Required_ToBeReleased_Item,
        id_DRBs_Required_ToBeReleased_List,
        id_DRBs_Setup_Item,
        id_DRBs_Setup_List,
        id_DRBs_SetupMod_Item,
        id_DRBs_SetupMod_List,
        id_DRBs_ToBeModified_Item,
        id_DRBs_ToBeModified_List,
        id_DRBs_ToBeReleased_Item,
        id_DRBs_ToBeReleased_List,
        id_DRBs_ToBeSetup_Item,
        id_DRBs_ToBeSetup_List,
        id_DRBs_ToBeSetupMod_Item,
        id_DRBs_ToBeSetupMod_List,
        id_DRXCycle,
        id_DUtoCURRCInformation,
        id_gNB_CU_UE_F1AP_ID,
        id_gNB_DU_UE_F1AP_ID,
        id_gNB_DU_ID,
        id_GNB_DU_Served_Cells_Item,
        id_gNB_DU_Served_Cells_List,
        id_gNB_DU_Name,
        id_NRCellID,
        id_oldgNB_DU_UE_F1AP_ID,
        id_ResetType,
        id_ResourceCoordinationTransferContainer,
        id_RRCContainer,
        id_SCell_ToBeRemoved_Item,
        id_SCell_ToBeRemoved_List,
        id_SCell_ToBeSetup_Item,
        id_SCell_ToBeSetup_List,
        id_SCell_ToBeSetupMod_Item,
        id_SCell_ToBeSetupMod_List,
        id_Served_Cells_To_Add_Item,
        id_Served_Cells_To_Add_List,
        id_Served_Cells_To_Delete_Item,
        id_Served_Cells_To_Delete_List,
        id_Served_Cells_To_Modify_Item,
        id_Served_Cells_To_Modify_List,
        id_SpCell_ID,
        id_SRBID,
        id_SRBs_FailedToBeSetup_Item,
        id_SRBs_FailedToBeSetup_List,
        id_SRBs_FailedToBeSetupMod_Item,
        id_SRBs_FailedToBeSetupMod_List,
        id_SRBs_Required_ToBeReleased_Item,
        id_SRBs_Required_ToBeReleased_List,
        id_SRBs_ToBeReleased_Item,
        id_SRBs_ToBeReleased_List,
        id_SRBs_ToBeSetup_Item,
        id_SRBs_ToBeSetup_List,
        id_SRBs_ToBeSetupMod_Item,
        id_SRBs_ToBeSetupMod_List,
        id_TimeToWait,
        id_TransactionID,
        id_TransmissionActionIndicator,
        id_UE_associatedLogicalF1_ConnectionItem,
        id_UE_associatedLogicalF1_ConnectionListResAck,
        id_gNB_CU_Name,
        id_SCell_FailedtoSetup_List,
        id_SCell_FailedtoSetup_Item,
        id_SCell_FailedtoSetupMod_List,
        id_SCell_FailedtoSetupMod_Item,
        id_RRCReconfigurationCompleteIndicator,
        id_Cells_Status_Item,
        id_Cells_Status_List,
        id_Candidate_SpCell_List,
        id_Candidate_SpCell_Item,
        id_Potential_SpCell_List,
        id_Potential_SpCell_Item,
        id_FullConfiguration,
        id_C_RNTI,
        id_SpCellULConfigured,
        id_InactivityMonitoringRequest,
        id_InactivityMonitoringResponse,
        id_DRB_Activity_Item,
        id_DRB_Activity_List,
        id_EUTRA_NR_CellResourceCoordinationReq_Container,
        id_EUTRA_NR_CellResourceCoordinationReqAck_Container,
        id_Protected_EUTRA_Resources_List,
        id_RequestType,
        id_ServCellIndex,
        id_RAT_FrequencyPriorityInformation,
        id_ExecuteDuplication,
        id_NRCGI,
        id_PagingCell_Item,
        id_PagingCell_List,
        id_PagingDRX,
        id_PagingPriority,
        id_SItype_List,
        id_UEIdentityIndexValue,
        id_gNB_CUSystemInformation,
        id_HandoverPreparationInformation,
        id_GNB_CU_TNL_Association_To_Add_Item,
        id_GNB_CU_TNL_Association_To_Add_List,
        id_GNB_CU_TNL_Association_To_Remove_Item,
        id_GNB_CU_TNL_Association_To_Remove_List,
        id_GNB_CU_TNL_Association_To_Update_Item,
        id_GNB_CU_TNL_Association_To_Update_List,
        id_MaskedIMEISV,
        id_PagingIdentity,
        id_DUtoCURRCContainer,
        id_Cells_to_be_Barred_List,
        id_Cells_to_be_Barred_Item,
        id_TAISliceSupportList,
        id_GNB_CU_TNL_Association_Setup_List,
        id_GNB_CU_TNL_Association_Setup_Item,
        id_GNB_CU_TNL_Association_Failed_To_Setup_List,
        id_GNB_CU_TNL_Association_Failed_To_Setup_Item,
        id_DRB_Notify_Item,
        id_DRB_Notify_List,
        id_NotficationControl,
        id_RANAC,
        id_PWSSystemInformation,
        id_RepetitionPeriod,
        id_NumberofBroadcastRequest,
        id_Cells_To_Be_Broadcast_List,
        id_Cells_To_Be_Broadcast_Item,
        id_Cells_Broadcast_Completed_List,
        id_Cells_Broadcast_Completed_Item,
        id_Broadcast_To_Be_Cancelled_List,
        id_Broadcast_To_Be_Cancelled_Item,
        id_Cells_Broadcast_Cancelled_List,
        id_Cells_Broadcast_Cancelled_Item,
        id_NR_CGI_List_For_Restart_List,
        id_NR_CGI_List_For_Restart_Item,
        id_PWS_Failed_NR_CGI_List,
        id_PWS_Failed_NR_CGI_Item,
        id_ConfirmedUEID,
        id_Cancel_all_Warning_Messages_Indicator,
        id_GNB_DU_UE_AMBR_UL,
        id_DRXConfigurationIndicator,
        id_RLC_Status,
        id_DLPDCPSNLength,
        id_GNB_DUConfigurationQuery,
        id_MeasurementTimingConfiguration,
        id_DRB_Information,
        id_ServingPLMN,
        id_Protected_EUTRA_Resources_Item,
        id_GNB_CU_RRC_Version,
        id_GNB_DU_RRC_Version,
        id_GNBDUOverloadInformation,
        id_CellGroupConfig,
        id_RLCFailureIndication,
        id_UplinkTxDirectCurrentListInformation,
        id_DC_Based_Duplication_Configured,
        id_DC_Based_Duplication_Activation,
        id_SULAccessIndication,
        id_AvailablePLMNList,
        id_PDUSessionID,
        id_ULPDUSessionAggregateMaximumBitRate,
        id_ServingCellMO,
        id_QoSFlowMappingIndication,
        id_RRCDeliveryStatusRequest,
        id_RRCDeliveryStatus,
        id_BearerTypeChange,
        id_RLCMode,
        id_Duplication_Activation,
        id_Dedicated_SIDelivery_NeededUE_List,
        id_Dedicated_SIDelivery_NeededUE_Item,
        id_DRX_LongCycleStartOffset,
        id_ULPDCPSNLength,
        id_SelectedBandCombinationIndex,
        id_SelectedFeatureSetEntryIndex,
        id_ResourceCoordinationTransferInformation,
        id_ExtendedServedPLMNs_List,
        id_ExtendedAvailablePLMN_List,
        id_Associated_SCell_List,
        id_latest_RRC_Version_Enhanced,
        id_Associated_SCell_Item,
        id_Cell_Direction,
        id_SRBs_Setup_List,
        id_SRBs_Setup_Item,
        id_SRBs_SetupMod_List,
        id_SRBs_SetupMod_Item,
        id_SRBs_Modified_List,
        id_SRBs_Modified_Item,
        id_Ph_InfoSCG,
        id_RequestedBandCombinationIndex,
        id_RequestedFeatureSetEntryIndex,
        id_RequestedP_MaxFR2,
        id_DRX_Config,
        id_IgnoreResourceCoordinationContainer,
        id_UEAssistanceInformation,
        id_NeedforGap,
        id_PagingOrigin,
        id_new_gNB_CU_UE_F1AP_ID,
        id_RedirectedRRCmessage,
        id_new_gNB_DU_UE_F1AP_ID,
        id_NotificationInformation,
        id_PLMNAssistanceInfoForNetShar,
        id_UEContextNotRetrievable,
        id_BPLMN_ID_Info_List,
        id_SelectedPLMNID,
        id_UAC_Assistance_Info,
        id_RANUEID,
        id_GNB_DU_TNL_Association_To_Remove_Item,
        id_GNB_DU_TNL_Association_To_Remove_List,
        id_TNLAssociationTransportLayerAddressgNBDU,
        id_portNumber,
        id_AdditionalSIBMessageList,
        id_Cell_Type,
        id_IgnorePRACHConfiguration,
        id_CG_Config,
        id_PDCCH_BlindDetectionSCG,
        id_Requested_PDCCH_BlindDetectionSCG,
        id_Ph_InfoMCG,
        id_MeasGapSharingConfig,
        id_systemInformationAreaID,
        id_areaScope,
        id_RRCContainer_RRCSetupComplete,
        id_TraceActivation,
        id_TraceID,
        id_Neighbour_Cell_Information_List,
        id_SymbolAllocInSlot,
        id_NumDLULSymbols,
        id_AdditionalRRMPriorityIndex,
        id_DUCURadioInformationType,
        id_CUDURadioInformationType,
        id_AggressorgNBSetID,
        id_VictimgNBSetID,
        id_LowerLayerPresenceStatusChange,
        id_Transport_Layer_Address_Info,
        id_Neighbour_Cell_Information_Item,
        id_IntendedTDD_DL_ULConfig,
        id_QosMonitoringRequest,
        id_BHChannels_ToBeSetup_List,
        id_BHChannels_ToBeSetup_Item,
        id_BHChannels_Setup_List,
        id_BHChannels_Setup_Item,
        id_BHChannels_ToBeModified_Item,
        id_BHChannels_ToBeModified_List,
        id_BHChannels_ToBeReleased_Item,
        id_BHChannels_ToBeReleased_List,
        id_BHChannels_ToBeSetupMod_Item,
        id_BHChannels_ToBeSetupMod_List,
        id_BHChannels_FailedToBeModified_Item,
        id_BHChannels_FailedToBeModified_List,
        id_BHChannels_FailedToBeSetupMod_Item,
        id_BHChannels_FailedToBeSetupMod_List,
        id_BHChannels_Modified_Item,
        id_BHChannels_Modified_List,
        id_BHChannels_SetupMod_Item,
        id_BHChannels_SetupMod_List,
        id_BHChannels_Required_ToBeReleased_Item,
        id_BHChannels_Required_ToBeReleased_List,
        id_BHChannels_FailedToBeSetup_Item,
        id_BHChannels_FailedToBeSetup_List,
        id_BHInfo,
        id_BAPAddress,
        id_ConfiguredBAPAddress,
        id_BH_Routing_Information_Added_List,
        id_BH_Routing_Information_Added_List_Item,
        id_BH_Routing_Information_Removed_List,
        id_BH_Routing_Information_Removed_List_Item,
        id_UL_BH_Non_UP_Traffic_Mapping,
        id_Activated_Cells_to_be_Updated_List,
        id_Child_Nodes_List,
        id_IAB_Info_IAB_DU,
        id_IAB_Info_IAB_donor_CU,
        id_IAB_TNL_Addresses_To_Remove_List,
        id_IAB_TNL_Addresses_To_Remove_Item,
        id_IAB_Allocated_TNL_Address_List,
        id_IAB_Allocated_TNL_Address_Item,
        id_IABIPv6RequestType,
        id_IABv4AddressesRequested,
        id_IAB_Barred,
        id_TrafficMappingInformation,
        id_UL_UP_TNL_Information_to_Update_List,
        id_UL_UP_TNL_Information_to_Update_List_Item,
        id_UL_UP_TNL_Address_to_Update_List,
        id_UL_UP_TNL_Address_to_Update_List_Item,
        id_DL_UP_TNL_Address_to_Update_List,
        id_DL_UP_TNL_Address_to_Update_List_Item,
        id_NRV2XServicesAuthorized,
        id_LTEV2XServicesAuthorized,
        id_NRUESidelinkAggregateMaximumBitrate,
        id_LTEUESidelinkAggregateMaximumBitrate,
        id_SIB12_message,
        id_SIB13_message,
        id_SIB14_message,
        id_SLDRBs_FailedToBeModified_Item,
        id_SLDRBs_FailedToBeModified_List,
        id_SLDRBs_FailedToBeSetup_Item,
        id_SLDRBs_FailedToBeSetup_List,
        id_SLDRBs_Modified_Item,
        id_SLDRBs_Modified_List,
        id_SLDRBs_Required_ToBeModified_Item,
        id_SLDRBs_Required_ToBeModified_List,
        id_SLDRBs_Required_ToBeReleased_Item,
        id_SLDRBs_Required_ToBeReleased_List,
        id_SLDRBs_Setup_Item,
        id_SLDRBs_Setup_List,
        id_SLDRBs_ToBeModified_Item,
        id_SLDRBs_ToBeModified_List,
        id_SLDRBs_ToBeReleased_Item,
        id_SLDRBs_ToBeReleased_List,
        id_SLDRBs_ToBeSetup_Item,
        id_SLDRBs_ToBeSetup_List,
        id_SLDRBs_ToBeSetupMod_Item,
        id_SLDRBs_ToBeSetupMod_List,
        id_SLDRBs_SetupMod_List,
        id_SLDRBs_FailedToBeSetupMod_List,
        id_SLDRBs_SetupMod_Item,
        id_SLDRBs_FailedToBeSetupMod_Item,
        id_SLDRBs_ModifiedConf_List,
        id_SLDRBs_ModifiedConf_Item,
        id_UEAssistanceInformationEUTRA,
        id_PC5LinkAMBR,
        id_SL_PHY_MAC_RLC_Config,
        id_SL_ConfigDedicatedEUTRA_Info,
        id_AlternativeQoSParaSetList,
        id_CurrentQoSParaSetIndex,
        id_gNBCUMeasurementID,
        id_gNBDUMeasurementID,
        id_RegistrationRequest,
        id_ReportCharacteristics,
        id_CellToReportList,
        id_CellMeasurementResultList,
        id_HardwareLoadIndicator,
        id_ReportingPeriodicity,
        id_TNLCapacityIndicator,
        id_CarrierList,
        id_ULCarrierList,
        id_FrequencyShift7p5khz,
        id_SSB_PositionsInBurst,
        id_NRPRACHConfig,
        id_RACHReportInformationList,
        id_RLFReportInformationList,
        id_TDD_UL_DLConfigCommonNR,
        id_CNPacketDelayBudgetDownlink,
        id_ExtendedPacketDelayBudget,
        id_TSCTrafficCharacteristics,
        id_ReportingRequestType,
        id_TimeReferenceInformation,
        id_CNPacketDelayBudgetUplink,
        id_AdditionalPDCPDuplicationTNL_List,
        id_RLCDuplicationInformation,
        id_AdditionalDuplicationIndication,
        id_ConditionalInterDUMobilityInformation,
        id_ConditionalIntraDUMobilityInformation,
        id_targetCellsToCancel,
        id_requestedTargetCellGlobalID,
        id_ManagementBasedMDTPLMNList,
        id_TraceCollectionEntityIPAddress,
        id_PrivacyIndicator,
        id_TraceCollectionEntityURI,
        id_mdtConfiguration,
        id_ServingNID,
        id_NPNBroadcastInformation,
        id_NPNSupportInfo,
        id_NID,
        id_AvailableSNPN_ID_List,
        id_SIB10_message,
        id_DLCarrierList,
        id_ExtendedTAISliceSupportList,
        id_RequestedSRSTransmissionCharacteristics,
        id_PosAssistance_Information,
        id_PosBroadcast,
        id_RoutingID,
        id_PosAssistanceInformationFailureList,
        id_PosMeasurementQuantities,
        id_PosMeasurementResultList,
        id_TRPInformationTypeListTRPReq,
        id_TRPInformationTypeItem,
        id_TRPInformationListTRPResp,
        id_TRPInformationItem,
        id_LMF_MeasurementID,
        id_SRSType,
        id_ActivationTime,
        id_AbortTransmission,
        id_PositioningBroadcastCells,
        id_SRSConfiguration,
        id_PosReportCharacteristics,
        id_PosMeasurementPeriodicity,
        id_TRPList,
        id_RAN_MeasurementID,
        id_LMF_UE_MeasurementID,
        id_RAN_UE_MeasurementID,
        id_E_CID_MeasurementQuantities,
        id_E_CID_MeasurementQuantities_Item,
        id_E_CID_MeasurementPeriodicity,
        id_E_CID_MeasurementResult,
        id_Cell_Portion_ID,
        id_SFNInitialisationTime,
        id_SystemFrameNumber,
        id_SlotNumber,
        id_TRP_MeasurementRequestList,
        id_MeasurementBeamInfoRequest,
        id_E_CID_ReportCharacteristics,
        id_ConfiguredTACIndication,
        id_Extended_GNB_CU_Name,
        id_Extended_GNB_DU_Name,
        id_F1CTransferPath,
        id_SFN_Offset,
        id_TransmissionStopIndicator,
        id_SrsFrequency,
        id_SCGIndicator,
        id_EstimatedArrivalProbability,
        id_TRPType,
        id_SRSSpatialRelationPerSRSResource,
        id_PDCPTerminatingNodeDLTNLAddrInfo,
        id_ENBDLTNLAddress,
        id_PosMeasurementPeriodicityExtended,
        id_PRS_Resource_ID,
        id_LocationMeasurementInformation,
        id_SliceRadioResourceStatus,
        id_CompositeAvailableCapacity_SUL,
        id_SuccessfulHOReportInformationList,
        id_NR_U_Channel_List,
        id_NR_U,
        id_Coverage_Modification_Notification,
        id_CCO_Assistance_Information,
        id_Neighbor_node_CCO_Assistance_Information_List,
        id_CellsForSON_List,
        id_MIMOPRBusageInformation,
        id_gNB_CU_MBS_F1AP_ID,
        id_gNB_DU_MBS_F1AP_ID,
        id_MBS_Area_Session_ID,
        id_MBS_CUtoDURRCInformation,
        id_MBS_Session_ID,
        id_SNSSAI,
        id_MBS_Broadcast_NeighbourCellList,
        id_BroadcastMRBs_FailedToBeModified_List,
        id_BroadcastMRBs_FailedToBeModified_Item,
        id_BroadcastMRBs_FailedToBeSetup_List,
        id_BroadcastMRBs_FailedToBeSetup_Item,
        id_BroadcastMRBs_FailedToBeSetupMod_List,
        id_BroadcastMRBs_FailedToBeSetupMod_Item,
        id_BroadcastMRBs_Modified_List,
        id_BroadcastMRBs_Modified_Item,
        id_BroadcastMRBs_Setup_List,
        id_BroadcastMRBs_Setup_Item,
        id_BroadcastMRBs_SetupMod_List,
        id_BroadcastMRBs_SetupMod_Item,
        id_BroadcastMRBs_ToBeModified_List,
        id_BroadcastMRBs_ToBeModified_Item,
        id_BroadcastMRBs_ToBeReleased_List,
        id_BroadcastMRBs_ToBeReleased_Item,
        id_BroadcastMRBs_ToBeSetup_List,
        id_BroadcastMRBs_ToBeSetup_Item,
        id_BroadcastMRBs_ToBeSetupMod_List,
        id_BroadcastMRBs_ToBeSetupMod_Item,
        id_Supported_MBS_FSA_ID_List,
        id_UEIdentity_List_For_Paging_List,
        id_UEIdentity_List_For_Paging_Item,
        id_MBS_ServiceArea,
        id_MulticastMRBs_FailedToBeModified_List,
        id_MulticastMRBs_FailedToBeModified_Item,
        id_MulticastMRBs_FailedToBeSetup_List,
        id_MulticastMRBs_FailedToBeSetup_Item,
        id_MulticastMRBs_FailedToBeSetupMod_List,
        id_MulticastMRBs_FailedToBeSetupMod_Item,
        id_MulticastMRBs_Modified_List,
        id_MulticastMRBs_Modified_Item,
        id_MulticastMRBs_Setup_List,
        id_MulticastMRBs_Setup_Item,
        id_MulticastMRBs_SetupMod_List,
        id_MulticastMRBs_SetupMod_Item,
        id_MulticastMRBs_ToBeModified_List,
        id_MulticastMRBs_ToBeModified_Item,
        id_MulticastMRBs_ToBeReleased_List,
        id_MulticastMRBs_ToBeReleased_Item,
        id_MulticastMRBs_ToBeSetup_List,
        id_MulticastMRBs_ToBeSetup_Item,
        id_MulticastMRBs_ToBeSetupMod_List,
        id_MulticastMRBs_ToBeSetupMod_Item,
        id_MBSMulticastF1UContextDescriptor,
        id_MulticastF1UContext_ToBeSetup_List,
        id_MulticastF1UContext_ToBeSetup_Item,
        id_MulticastF1UContext_Setup_List,
        id_MulticastF1UContext_Setup_Item,
        id_MulticastF1UContext_FailedToBeSetup_List,
        id_MulticastF1UContext_FailedToBeSetup_Item,
        id_IABCongestionIndication,
        id_IABConditionalRRCMessageDeliveryIndication,
        id_F1CTransferPathNRDC,
        id_BufferSizeThresh,
        id_IAB_TNL_Addresses_Exception,
        id_BAP_Header_Rewriting_Added_List,
        id_BAP_Header_Rewriting_Added_List_Item,
        id_Re_routingEnableIndicator,
        id_NonF1terminatingTopologyIndicator,
        id_EgressNonF1terminatingTopologyIndicator,
        id_IngressNonF1terminatingTopologyIndicator,
        id_rBSetConfiguration,
        id_frequency_Domain_HSNA_Configuration_List,
        id_child_IAB_Nodes_NA_Resource_List,
        id_Parent_IAB_Nodes_NA_Resource_Configuration_List,
        id_uL_FreqInfo,
        id_uL_Transmission_Bandwidth,
        id_dL_FreqInfo,
        id_dL_Transmission_Bandwidth,
        id_uL_NR_Carrier_List,
        id_dL_NR_Carrier_List,
        id_nRFreqInfo,
        id_transmission_Bandwidth,
        id_nR_Carrier_List,
        id_Neighbour_Node_Cells_List,
        id_Serving_Cells_List,
        id_permutation,
        id_MDTPollutedMeasurementIndicator,
        id_M5ReportAmount,
        id_M6ReportAmount,
        id_M7ReportAmount,
        id_SurvivalTime,
        id_PDCMeasurementPeriodicity,
        id_PDCMeasurementQuantities,
        id_PDCMeasurementQuantities_Item,
        id_PDCMeasurementResult,
        id_PDCReportType,
        id_RAN_UE_PDC_MeasID,
        id_SCGActivationRequest,
        id_SCGActivationStatus,
        id_PRSTRPList,
        id_PRSTransmissionTRPList,
        id_OnDemandPRS,
        id_AoA_SearchWindow,
        id_TRP_MeasurementUpdateList,
        id_ZoAInformation,
        id_ResponseTime,
        id_ARPLocationInfo,
        id_ARP_ID,
        id_MultipleULAoA,
        id_UL_SRS_RSRPP,
        id_SRSResourcetype,
        id_ExtendedAdditionalPathList,
        id_LoS_NLoSInformation,
        id_NumberOfTRPRxTEG,
        id_NumberOfTRPRxTxTEG,
        id_TRPTxTEGAssociation,
        id_TRPTEGInformation,
        id_TRPRx_TEGInformation,
        id_TRP_PRS_Info_List,
        id_PRS_Measurement_Info_List,
        id_PRSConfigRequestType,
        id_MeasurementTimeOccasion,
        id_MeasurementCharacteristicsRequestIndicator,
        id_UEReportingInformation,
        id_PosConextRevIndication,
        id_TRPBeamAntennaInformation,
        id_NRRedCapUEIndication,
        id_Redcap_Bcast_Information,
        id_RANUEPagingDRX,
        id_CNUEPagingDRX,
        id_NRPagingeDRXInformation,
        id_NRPagingeDRXInformationforRRCINACTIVE,
        id_NR_TADV,
        id_QoEInformation,
        id_CG_SDTQueryIndication,
        id_SDT_MAC_PHY_CG_Config,
        id_CG_SDTKeptIndicator,
        id_CG_SDTindicatorSetup,
        id_CG_SDTindicatorMod,
        id_CG_SDTSessionInfoOld,
        id_SDTInformation,
        id_SDTRLCBearerConfiguration,
        id_FiveG_ProSeAuthorized,
        id_FiveG_ProSeUEPC5AggregateMaximumBitrate,
        id_FiveG_ProSePC5LinkAMBR,
        id_SRBMappingInfo,
        id_DRBMappingInfo,
        id_UuRLCChannelToBeSetupList,
        id_UuRLCChannelToBeModifiedList,
        id_UuRLCChannelToBeReleasedList,
        id_UuRLCChannelSetupList,
        id_UuRLCChannelFailedToBeSetupList,
        id_UuRLCChannelModifiedList,
        id_UuRLCChannelFailedToBeModifiedList,
        id_UuRLCChannelRequiredToBeModifiedList,
        id_UuRLCChannelRequiredToBeReleasedList,
        id_PC5RLCChannelToBeSetupList,
        id_PC5RLCChannelToBeModifiedList,
        id_PC5RLCChannelToBeReleasedList,
        id_PC5RLCChannelSetupList,
        id_PC5RLCChannelFailedToBeSetupList,
        id_PC5RLCChannelFailedToBeModifiedList,
        id_PC5RLCChannelRequiredToBeModifiedList,
        id_PC5RLCChannelRequiredToBeReleasedList,
        id_PC5RLCChannelModifiedList,
        id_SidelinkRelayConfiguration,
        id_UpdatedRemoteUELocalID,
        id_PathSwitchConfiguration,
        id_PagingCause,
        id_MUSIM_GapConfig,
        id_PEIPSAssistanceInfo,
        id_UEPagingCapability,
        id_LastUsedCellIndication,
        id_SIB17_message,
        id_GNBDUUESliceMaximumBitRateList,
        id_SIB20_message,
        id_UE_MulticastMRBs_ToBeReleased_List,
        id_UE_MulticastMRBs_ToBeReleased_Item,
        id_UE_MulticastMRBs_ToBeSetup_List,
        id_UE_MulticastMRBs_ToBeSetup_Item,
        id_MulticastMBSSessionSetupList,
        id_MulticastMBSSessionRemoveList,
        id_PosMeasurementAmount,
        id_SDT_Termination_Request,
        id_pathPower,
        id_DU_RX_MT_RX_Extend,
        id_DU_TX_MT_TX_Extend,
        id_DU_RX_MT_TX_Extend,
        id_DU_TX_MT_RX_Extend,
        id_BAP_Header_Rewriting_Removed_List,
        id_BAP_Header_Rewriting_Removed_List_Item,
        id_SLDRXCycleList,
        id_TAINSAGSupportList,
        id_SL_RLC_ChannelToAddModList,
        id_BroadcastAreaScope,
        id_ManagementBasedMDTPLMNModificationList,
        id_SIB15_message,
        id_ActivationRequestType,
        id_PosMeasGapPreConfigList,
        id_InterFrequencyConfig_NoGap,
        id_MBSInterestIndication,
        id_UE_MulticastMRBs_ConfirmedToBeModified_List,
        id_UE_MulticastMRBs_ConfirmedToBeModified_Item,
        id_UE_MulticastMRBs_RequiredToBeModified_List,
        id_UE_MulticastMRBs_RequiredToBeModified_Item,
        id_UE_MulticastMRBs_RequiredToBeReleased_List,
        id_UE_MulticastMRBs_RequiredToBeReleased_Item,
        id_L571Info,
        id_L1151Info,
        id_SCS_480,
        id_SCS_960,
        id_SRSPortIndex,
        id_PEISubgroupingSupportIndication,
        id_NeedForGapsInfoNR,
        id_NeedForGapNCSGInfoNR,
        id_NeedForGapNCSGInfoEUTRA,
        id_procedure_code_668_not_to_be_used,
        id_procedure_code_669_not_to_be_used,
        id_procedure_code_670_not_to_be_used,
        id_Source_MRB_ID,
        id_PosMeasurementPeriodicityNR_AoA,
        id_RedCapIndication,
        id_SRSPosRRCInactiveConfig,
        id_SDTBearerConfigurationQueryIndication,
        id_SDTBearerConfigurationInfo,
        id_UL_GapFR2_Config,
        id_ConfigRestrictInfoDAPS,
        id_UE_MulticastMRBs_Setup_List,
        id_UE_MulticastMRBs_Setup_Item,
        id_MulticastF1UContextReferenceCU,
        id_PosSItypeList,
        id_DAPS_HO_Status,
        id_UplinkTxDirectCurrentTwoCarrierListInfo,
        id_UE_MulticastMRBs_ToBeSetup_atModify_List,
        id_UE_MulticastMRBs_ToBeSetup_atModify_Item,
        id_MC_PagingCell_List,
        id_MC_PagingCell_Item,
        id_SRSPosRRCInactiveQueryIndication,
        id_UlTxDirectCurrentMoreCarrierInformation,
        id_CPACMCGInformation,
        id_TwoPHRModeMCG,
        id_TwoPHRModeSCG,
        id_ExtendedUEIdentityIndexValue,
        id_ServingCellMO_List,
        id_ServingCellMO_List_Item,
        id_ServingCellMO_encoded_in_CGC_List,
    ]

class F1AP_Containers:

    _name_  = 'F1AP-Containers'
    _oid_   = [0, 4, 0, 0, 22, 3, 3, 1, 5]
    
    _obj_ = [
        'F1AP-PROTOCOL-IES',
        'F1AP-PROTOCOL-IES-PAIR',
        'F1AP-PROTOCOL-EXTENSION',
        'F1AP-PRIVATE-IES',
        'ProtocolIE-Container',
        'ProtocolIE-SingleContainer',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerPair',
        'ProtocolIE-FieldPair',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    _type_ = [
        'F1AP-PROTOCOL-IES',
        'F1AP-PROTOCOL-IES-PAIR',
        'F1AP-PROTOCOL-EXTENSION',
        'F1AP-PRIVATE-IES',
        'ProtocolIE-Container',
        'ProtocolIE-SingleContainer',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerPair',
        'ProtocolIE-FieldPair',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        'F1AP-PROTOCOL-IES',
        'F1AP-PROTOCOL-IES-PAIR',
        'F1AP-PROTOCOL-EXTENSION',
        'F1AP-PRIVATE-IES',
        ]
    _param_ = [
        'ProtocolIE-Container',
        'ProtocolIE-SingleContainer',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerPair',
        'ProtocolIE-FieldPair',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    
    #-----< F1AP-PROTOCOL-IES >-----#
    F1AP_PROTOCOL_IES = CLASS(name='F1AP-PROTOCOL-IES', mode=MODE_TYPE)
    _F1AP_PROTOCOL_IES_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _F1AP_PROTOCOL_IES_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'Criticality')))
    _F1AP_PROTOCOL_IES_Value = OPEN(name='Value', mode=MODE_TYPE)
    _F1AP_PROTOCOL_IES_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'Presence')))
    F1AP_PROTOCOL_IES._cont = ASN1Dict([
        ('id', _F1AP_PROTOCOL_IES_id),
        ('criticality', _F1AP_PROTOCOL_IES_criticality),
        ('Value', _F1AP_PROTOCOL_IES_Value),
        ('presence', _F1AP_PROTOCOL_IES_presence),
        ])
    
    #-----< F1AP-PROTOCOL-IES-PAIR >-----#
    F1AP_PROTOCOL_IES_PAIR = CLASS(name='F1AP-PROTOCOL-IES-PAIR', mode=MODE_TYPE)
    _F1AP_PROTOCOL_IES_PAIR_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _F1AP_PROTOCOL_IES_PAIR_firstCriticality = ENUM(name='firstCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'Criticality')))
    _F1AP_PROTOCOL_IES_PAIR_FirstValue = OPEN(name='FirstValue', mode=MODE_TYPE)
    _F1AP_PROTOCOL_IES_PAIR_secondCriticality = ENUM(name='secondCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'Criticality')))
    _F1AP_PROTOCOL_IES_PAIR_SecondValue = OPEN(name='SecondValue', mode=MODE_TYPE)
    _F1AP_PROTOCOL_IES_PAIR_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'Presence')))
    F1AP_PROTOCOL_IES_PAIR._cont = ASN1Dict([
        ('id', _F1AP_PROTOCOL_IES_PAIR_id),
        ('firstCriticality', _F1AP_PROTOCOL_IES_PAIR_firstCriticality),
        ('FirstValue', _F1AP_PROTOCOL_IES_PAIR_FirstValue),
        ('secondCriticality', _F1AP_PROTOCOL_IES_PAIR_secondCriticality),
        ('SecondValue', _F1AP_PROTOCOL_IES_PAIR_SecondValue),
        ('presence', _F1AP_PROTOCOL_IES_PAIR_presence),
        ])
    
    #-----< F1AP-PROTOCOL-EXTENSION >-----#
    F1AP_PROTOCOL_EXTENSION = CLASS(name='F1AP-PROTOCOL-EXTENSION', mode=MODE_TYPE)
    _F1AP_PROTOCOL_EXTENSION_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolExtensionID')), uniq=True)
    _F1AP_PROTOCOL_EXTENSION_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'Criticality')))
    _F1AP_PROTOCOL_EXTENSION_Extension = OPEN(name='Extension', mode=MODE_TYPE)
    _F1AP_PROTOCOL_EXTENSION_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'Presence')))
    F1AP_PROTOCOL_EXTENSION._cont = ASN1Dict([
        ('id', _F1AP_PROTOCOL_EXTENSION_id),
        ('criticality', _F1AP_PROTOCOL_EXTENSION_criticality),
        ('Extension', _F1AP_PROTOCOL_EXTENSION_Extension),
        ('presence', _F1AP_PROTOCOL_EXTENSION_presence),
        ])
    
    #-----< F1AP-PRIVATE-IES >-----#
    F1AP_PRIVATE_IES = CLASS(name='F1AP-PRIVATE-IES', mode=MODE_TYPE)
    _F1AP_PRIVATE_IES_id = CHOICE(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'PrivateIE-ID')))
    _F1AP_PRIVATE_IES_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'Criticality')))
    _F1AP_PRIVATE_IES_Value = OPEN(name='Value', mode=MODE_TYPE)
    _F1AP_PRIVATE_IES_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'Presence')))
    F1AP_PRIVATE_IES._cont = ASN1Dict([
        ('id', _F1AP_PRIVATE_IES_id),
        ('criticality', _F1AP_PRIVATE_IES_criticality),
        ('Value', _F1AP_PRIVATE_IES_Value),
        ('presence', _F1AP_PRIVATE_IES_presence),
        ])
    
    #-----< ProtocolIE-Container >-----#
    ProtocolIE_Container = SEQ_OF(name='ProtocolIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-SingleContainer >-----#
    ProtocolIE_SingleContainer = SEQ(name='ProtocolIE-SingleContainer', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')), param=True)
    
    #-----< ProtocolIE-Field >-----#
    ProtocolIE_Field = SEQ(name='ProtocolIE-Field', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPair >-----#
    ProtocolIE_ContainerPair = SEQ_OF(name='ProtocolIE-ContainerPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-FieldPair >-----#
    ProtocolIE_FieldPair = SEQ(name='ProtocolIE-FieldPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionContainer >-----#
    ProtocolExtensionContainer = SEQ_OF(name='ProtocolExtensionContainer', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionField >-----#
    ProtocolExtensionField = SEQ(name='ProtocolExtensionField', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Container >-----#
    PrivateIE_Container = SEQ_OF(name='PrivateIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Field >-----#
    PrivateIE_Field = SEQ(name='PrivateIE-Field', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _F1AP_PROTOCOL_IES_id,
        _F1AP_PROTOCOL_IES_criticality,
        _F1AP_PROTOCOL_IES_Value,
        _F1AP_PROTOCOL_IES_presence,
        F1AP_PROTOCOL_IES,
        _F1AP_PROTOCOL_IES_PAIR_id,
        _F1AP_PROTOCOL_IES_PAIR_firstCriticality,
        _F1AP_PROTOCOL_IES_PAIR_FirstValue,
        _F1AP_PROTOCOL_IES_PAIR_secondCriticality,
        _F1AP_PROTOCOL_IES_PAIR_SecondValue,
        _F1AP_PROTOCOL_IES_PAIR_presence,
        F1AP_PROTOCOL_IES_PAIR,
        _F1AP_PROTOCOL_EXTENSION_id,
        _F1AP_PROTOCOL_EXTENSION_criticality,
        _F1AP_PROTOCOL_EXTENSION_Extension,
        _F1AP_PROTOCOL_EXTENSION_presence,
        F1AP_PROTOCOL_EXTENSION,
        _F1AP_PRIVATE_IES_id,
        _F1AP_PRIVATE_IES_criticality,
        _F1AP_PRIVATE_IES_Value,
        _F1AP_PRIVATE_IES_presence,
        F1AP_PRIVATE_IES,
    ]

class F1AP_IEs:

    _name_  = 'F1AP-IEs'
    _oid_   = [0, 4, 0, 0, 22, 3, 3, 1, 2]
    
    _obj_ = [
        'AbortTransmission',
        'AbortTransmission-ExtIEs',
        'AccessPointPosition',
        'AccessPointPosition-ExtIEs',
        'Activated-Cells-to-be-Updated-List',
        'Activated-Cells-to-be-Updated-List-Item',
        'Activated-Cells-to-be-Updated-List-Item-ExtIEs',
        'ActivationRequestType',
        'ActiveULBWP',
        'ActiveULBWP-ExtIEs',
        'AdditionalDuplicationIndication',
        'AdditionalPath-List',
        'AdditionalPath-Item',
        'AdditionalPath-Item-ExtIEs',
        'ExtendedAdditionalPathList',
        'ExtendedAdditionalPathList-Item',
        'ExtendedAdditionalPathList-Item-ExtIEs',
        'AdditionalPDCPDuplicationTNL-List',
        'AdditionalPDCPDuplicationTNL-Item',
        'AdditionalPDCPDuplicationTNL-ItemExtIEs',
        'AdditionalSIBMessageList',
        'AdditionalSIBMessageList-Item',
        'AdditionalSIBMessageList-Item-ExtIEs',
        'AdditionalRRMPriorityIndex',
        'AffectedCellsAndBeams-List',
        'AffectedCellsAndBeams-Item',
        'AffectedCellsAndBeams-Item-ExtIEs',
        'AffectedSSB-List',
        'AffectedSSB-Item',
        'AffectedSSB-Item-ExtIEs',
        'AggressorCellList',
        'AggressorCellList-Item',
        'AggressorCellList-Item-ExtIEs',
        'AggressorgNBSetID',
        'AggressorgNBSetID-ExtIEs',
        'AllocationAndRetentionPriority',
        'AllocationAndRetentionPriority-ExtIEs',
        'AlternativeQoSParaSetList',
        'AlternativeQoSParaSetItem',
        'AlternativeQoSParaSetItem-ExtIEs',
        'AngleMeasurementQuality',
        'AngleMeasurementQuality-ExtIEs',
        'AperiodicSRSResourceTriggerList',
        'AperiodicSRSResourceTrigger',
        'Associated-SCell-Item',
        'Associated-SCell-ItemExtIEs',
        'AvailablePLMNList',
        'AvailablePLMNList-Item',
        'AvailablePLMNList-Item-ExtIEs',
        'AvailableSNPN-ID-List',
        'AvailableSNPN-ID-List-Item',
        'AvailableSNPN-ID-List-ItemExtIEs',
        'AveragingWindow',
        'AreaScope',
        'AoA-AssistanceInfo',
        'AoA-AssistanceInfo-ExtIEs',
        'AngleMeasurementType',
        'AngleMeasurementType-ExtIEs',
        'AppLayerBufferLevelList',
        'ARP-ID',
        'ARPLocationInformation',
        'ARPLocationInformation-Item',
        'ARPLocationInformation-ExtIEs',
        'ARPLocationType',
        'ARPLocationType-ExtIEs',
        'BAP-Header-Rewriting-Added-List-Item',
        'BAP-Header-Rewriting-Added-List-Item-ExtIEs',
        'BAP-Header-Rewriting-Removed-List-Item',
        'BAP-Header-Rewriting-Removed-List-Item-ExtIEs',
        'BandwidthSRS',
        'BandwidthSRS-ExtIEs',
        'BAPAddress',
        'BAPCtrlPDUChannel',
        'BAPlayerBHRLCchannelMappingInfo',
        'BAPlayerBHRLCchannelMappingInfo-ExtIEs',
        'BAPlayerBHRLCchannelMappingInfoList',
        'BAPlayerBHRLCchannelMappingInfo-Item',
        'BAPlayerBHRLCchannelMappingInfo-ItemExtIEs',
        'BAPPathID',
        'BAPRoutingID',
        'BAPRoutingIDExtIEs',
        'BCBearerContextF1U-TNLInfo',
        'BCBearerContextF1U-TNLInfo-ExtIEs',
        'BitRate',
        'BearerTypeChange',
        'BHRLCChannelID',
        'BHChannels-FailedToBeModified-Item',
        'BHChannels-FailedToBeModified-ItemExtIEs',
        'BHChannels-FailedToBeSetup-Item',
        'BHChannels-FailedToBeSetup-ItemExtIEs',
        'BHChannels-FailedToBeSetupMod-Item',
        'BHChannels-FailedToBeSetupMod-ItemExtIEs',
        'BHChannels-Modified-Item',
        'BHChannels-Modified-ItemExtIEs',
        'BHChannels-Required-ToBeReleased-Item',
        'BHChannels-Required-ToBeReleased-ItemExtIEs',
        'BHChannels-Setup-Item',
        'BHChannels-Setup-ItemExtIEs',
        'BHChannels-SetupMod-Item',
        'BHChannels-SetupMod-ItemExtIEs',
        'BHChannels-ToBeModified-Item',
        'BHChannels-ToBeModified-ItemExtIEs',
        'BHChannels-ToBeReleased-Item',
        'BHChannels-ToBeReleased-ItemExtIEs',
        'BHChannels-ToBeSetup-Item',
        'BHChannels-ToBeSetup-ItemExtIEs',
        'BHChannels-ToBeSetupMod-Item',
        'BHChannels-ToBeSetupMod-ItemExtIEs',
        'BHInfo',
        'BHInfo-ExtIEs',
        'BHQoSInformation',
        'BHQoSInformation-ExtIEs',
        'BHRLCCHList',
        'BHRLCCHItem',
        'BHRLCCHItemExtIEs',
        'BH-Routing-Information-Added-List-Item',
        'BH-Routing-Information-Added-List-ItemExtIEs',
        'BH-Routing-Information-Removed-List-Item',
        'BH-Routing-Information-Removed-List-ItemExtIEs',
        'BPLMN-ID-Info-List',
        'BPLMN-ID-Info-Item',
        'BPLMN-ID-Info-ItemExtIEs',
        'ServedPLMNs-List',
        'ServedPLMNs-Item',
        'ServedPLMNs-ItemExtIEs',
        'BroadcastCAGList',
        'BroadcastMRBs-FailedToBeModified-Item',
        'BroadcastMRBs-FailedtoBeModified-Item-ExtIEs',
        'BroadcastMRBs-FailedToBeSetup-Item',
        'BroadcastMRBs-FailedToBeSetup-Item-ExtIEs',
        'BroadcastMRBs-FailedToBeSetupMod-Item',
        'BroadcastMRBs-FailedToBeSetupMod-Item-ExtIEs',
        'BroadcastMRBs-Modified-Item',
        'BroadcastMRBs-Modified-Item-ExtIEs',
        'BroadcastMRBs-Setup-Item',
        'BroadcastMRBs-Setup-Item-ExtIEs',
        'BroadcastMRBs-SetupMod-Item',
        'BroadcastMRBs-SetupMod-Item-ExtIEs',
        'BroadcastMRBs-ToBeModified-Item',
        'BroadcastMRBs-ToBeModified-Item-ExtIEs',
        'BroadcastMRBs-ToBeReleased-Item',
        'BroadcastMRBs-ToBeReleased-ItemExtIEs',
        'BroadcastMRBs-ToBeSetup-Item',
        'BroadcastMRBs-ToBeSetup-Item-ExtIEs',
        'BroadcastMRBs-ToBeSetupMod-Item',
        'BroadcastMRBs-ToBeSetupMod-Item-ExtIEs',
        'BroadcastNIDList',
        'BroadcastSNPN-ID-List',
        'BroadcastSNPN-ID-List-Item',
        'BroadcastSNPN-ID-List-ItemExtIEs',
        'BroadcastPNI-NPN-ID-List',
        'BroadcastPNI-NPN-ID-List-Item',
        'BroadcastPNI-NPN-ID-List-ItemExtIEs',
        'BroadcastAreaScope',
        'BroadcastAreaScope-ExtIEs',
        'BroadcastCellList',
        'Broadcast-Cell-List-Item',
        'Broadcast-Cell-List-ItemExtIEs',
        'BufferSizeThresh',
        'BurstArrivalTime',
        'CAGID',
        'Cancel-all-Warning-Messages-Indicator',
        'Candidate-SpCell-Item',
        'Candidate-SpCell-ItemExtIEs',
        'CapacityValue',
        'CapacityValue-ExtIEs',
        'Cause',
        'Cause-ExtIEs',
        'CauseMisc',
        'CauseProtocol',
        'CauseRadioNetwork',
        'CauseTransport',
        'CellGroupConfig',
        'CellCapacityClassValue',
        'Cell-Direction',
        'CellMeasurementResultList',
        'CellMeasurementResultItem',
        'CellMeasurementResultItem-ExtIEs',
        'Cell-Portion-ID',
        'CellsForSON-List',
        'CellsForSON-Item',
        'CellsForSON-Item-ExtIEs',
        'Cells-Failed-to-be-Activated-List-Item',
        'Cells-Failed-to-be-Activated-List-ItemExtIEs',
        'Cells-Status-Item',
        'Cells-Status-ItemExtIEs',
        'Cells-To-Be-Broadcast-Item',
        'Cells-To-Be-Broadcast-ItemExtIEs',
        'Cells-Broadcast-Completed-Item',
        'Cells-Broadcast-Completed-ItemExtIEs',
        'Broadcast-To-Be-Cancelled-Item',
        'Broadcast-To-Be-Cancelled-ItemExtIEs',
        'Cells-Broadcast-Cancelled-Item',
        'Cells-Broadcast-Cancelled-ItemExtIEs',
        'Cells-to-be-Activated-List-Item',
        'Cells-to-be-Activated-List-ItemExtIEs',
        'Cells-to-be-Deactivated-List-Item',
        'Cells-to-be-Deactivated-List-ItemExtIEs',
        'Cells-to-be-Barred-Item',
        'Cells-to-be-Barred-Item-ExtIEs',
        'CellBarred',
        'CellSize',
        'CellToReportList',
        'CellToReportItem',
        'CellToReportItem-ExtIEs',
        'CellType',
        'CellType-ExtIEs',
        'CellULConfigured',
        'CG-SDTQueryIndication',
        'CG-SDTKeptIndicator',
        'CG-SDTindicatorSetup',
        'CG-SDTindicatorMod',
        'CG-SDTSessionInfo',
        'CG-SDTSessionInfo-ExtIEs',
        'ChannelOccupancyTimePercentage',
        'Child-IAB-Nodes-NA-Resource-List',
        'Child-IAB-Nodes-NA-Resource-List-Item',
        'Child-IAB-Nodes-NA-Resource-List-Item-ExtIEs',
        'Child-Node-Cells-List',
        'Child-Node-Cells-List-Item',
        'Child-Node-Cells-List-Item-ExtIEs',
        'Child-Nodes-List',
        'Child-Nodes-List-Item',
        'Child-Nodes-List-Item-ExtIEs',
        'CHOtrigger-InterDU',
        'CHOtrigger-IntraDU',
        'CNSubgroupID',
        'CNUEPagingIdentity',
        'CNUEPagingIdentity-ExtIEs',
        'CompositeAvailableCapacityGroup',
        'CompositeAvailableCapacityGroup-ExtIEs',
        'CompositeAvailableCapacity',
        'CompositeAvailableCapacity-ExtIEs',
        'CHO-Probability',
        'ConditionalInterDUMobilityInformation',
        'ConditionalInterDUMobilityInformation-ExtIEs',
        'ConditionalIntraDUMobilityInformation',
        'ConditionalIntraDUMobilityInformation-ExtIEs',
        'ConfigRestrictInfoDAPS',
        'ConfiguredTACIndication',
        'CoordinateID',
        'Coverage-Modification-Notification',
        'Coverage-Modification-Notification-ExtIEs',
        'Coverage-Modification-List',
        'Coverage-Modification-Item',
        'Coverage-Modification-Item-ExtIEs',
        'CellCoverageState',
        'CCO-Assistance-Information',
        'CCO-Assistance-Information-ExtIEs',
        'CCO-issue-detection',
        'CP-TransportLayerAddress',
        'CP-TransportLayerAddress-ExtIEs',
        'CPACMCGInformation',
        'CPACMCGInformation-ExtIEs',
        'CPAC-trigger',
        'CPTrafficType',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-ExtIEs',
        'CriticalityDiagnostics-IE-List',
        'CriticalityDiagnostics-IE-Item',
        'CriticalityDiagnostics-IE-Item-ExtIEs',
        'C-RNTI',
        'CUDURadioInformationType',
        'CUDURadioInformationType-ExtIEs',
        'CUDURIMInformation',
        'CUDURIMInformation-ExtIEs',
        'CUtoDURRCInformation',
        'CUtoDURRCInformation-ExtIEs',
        'DAPS-HO-Status',
        'DCBasedDuplicationConfigured',
        'Dedicated-SIDelivery-NeededUE-Item',
        'DedicatedSIDeliveryNeededUE-Item-ExtIEs',
        'DL-PRS',
        'DL-PRS-ExtIEs',
        'DL-PRSMutingPattern',
        'DL-PRSMutingPattern-ExtIEs',
        'DLPRSResourceCoordinates',
        'DLPRSResourceCoordinates-ExtIEs',
        'DLPRSResourceSetARP',
        'DLPRSResourceSetARP-ExtIEs',
        'DL-PRSResourceSetARPLocation',
        'DL-PRSResourceSetARPLocation-ExtIEs',
        'DLPRSResourceARP',
        'DLPRSResourceARP-ExtIEs',
        'DL-PRSResourceARPLocation',
        'DL-PRSResourceARPLocation-ExtIEs',
        'DL-UP-TNL-Address-to-Update-List-Item',
        'DL-UP-TNL-Address-to-Update-List-ItemExtIEs',
        'DLUPTNLInformation-ToBeSetup-List',
        'DLUPTNLInformation-ToBeSetup-Item',
        'DLUPTNLInformation-ToBeSetup-ItemExtIEs',
        'DRB-Activity-Item',
        'DRB-Activity-ItemExtIEs',
        'DRB-Activity',
        'DRBID',
        'DRBs-FailedToBeModified-Item',
        'DRBs-FailedToBeModified-ItemExtIEs',
        'DRBs-FailedToBeSetup-Item',
        'DRBs-FailedToBeSetup-ItemExtIEs',
        'DRBs-FailedToBeSetupMod-Item',
        'DRBs-FailedToBeSetupMod-ItemExtIEs',
        'DRB-Information',
        'DRB-Information-ItemExtIEs',
        'DRBs-Modified-Item',
        'DRBs-Modified-ItemExtIEs',
        'DRBs-ModifiedConf-Item',
        'DRBs-ModifiedConf-ItemExtIEs',
        'DRB-Notify-Item',
        'DRB-Notify-ItemExtIEs',
        'DRBs-Required-ToBeModified-Item',
        'DRBs-Required-ToBeModified-ItemExtIEs',
        'DRBs-Required-ToBeReleased-Item',
        'DRBs-Required-ToBeReleased-ItemExtIEs',
        'DRBs-Setup-Item',
        'DRBs-Setup-ItemExtIEs',
        'DRBs-SetupMod-Item',
        'DRBs-SetupMod-ItemExtIEs',
        'DRBs-ToBeModified-Item',
        'DRBs-ToBeModified-ItemExtIEs',
        'DRBs-ToBeReleased-Item',
        'DRBs-ToBeReleased-ItemExtIEs',
        'DRBs-ToBeSetup-Item',
        'DRBs-ToBeSetup-ItemExtIEs',
        'DRBs-ToBeSetupMod-Item',
        'DRBs-ToBeSetupMod-ItemExtIEs',
        'DRXCycle',
        'DRXCycle-ExtIEs',
        'DRX-Config',
        'DRXConfigurationIndicator',
        'DRX-LongCycleStartOffset',
        'DSInformationList',
        'DSCP',
        'DUtoCURRCContainer',
        'DUCURadioInformationType',
        'DUCURadioInformationType-ExtIEs',
        'DUCURIMInformation',
        'DUCURIMInformation-ExtIEs',
        'DUF-Slot-Config-Item',
        'DUF-Slot-Config-Item-ExtIEs',
        'DUF-Slot-Config-List',
        'DUFSlotformatIndex',
        'DUFTransmissionPeriodicity',
        'DU-RX-MT-RX',
        'DU-TX-MT-TX',
        'DU-RX-MT-TX',
        'DU-TX-MT-RX',
        'DU-RX-MT-RX-Extend',
        'DU-TX-MT-TX-Extend',
        'DU-RX-MT-TX-Extend',
        'DU-TX-MT-RX-Extend',
        'DUtoCURRCInformation',
        'DUtoCURRCInformation-ExtIEs',
        'DuplicationActivation',
        'DuplicationIndication',
        'DuplicationState',
        'Dynamic5QIDescriptor',
        'Dynamic5QIDescriptor-ExtIEs',
        'DynamicPQIDescriptor',
        'DynamicPQIDescriptor-ExtIEs',
        'E-CID-MeasurementQuantities',
        'E-CID-MeasurementQuantities-ItemIEs',
        'E-CID-MeasurementQuantities-Item',
        'E-CID-MeasurementQuantitiesValue-ExtIEs',
        'E-CID-MeasurementQuantitiesValue',
        'E-CID-MeasurementResult',
        'E-CID-MeasurementResult-ExtIEs',
        'E-CID-MeasuredResults-List',
        'E-CID-MeasuredResults-Item',
        'E-CID-MeasuredResults-Item-ExtIEs',
        'E-CID-MeasuredResults-Value',
        'E-CID-MeasuredResults-Value-ExtIEs',
        'E-CID-ReportCharacteristics',
        'EgressBHRLCCHList',
        'EgressBHRLCCHItem',
        'EgressBHRLCCHItemExtIEs',
        'EgressNonF1terminatingTopologyIndicator',
        'Endpoint-IP-address-and-port',
        'Endpoint-IP-address-and-port-ExtIEs',
        'EnergyDetectionThreshold',
        'ExtendedAvailablePLMN-List',
        'ExtendedAvailablePLMN-Item',
        'ExplicitFormat',
        'ExplicitFormat-ExtIEs',
        'ExtendedAvailablePLMN-Item-ExtIEs',
        'ExtendedServedPLMNs-List',
        'ExtendedServedPLMNs-Item',
        'ExtendedServedPLMNs-ItemExtIEs',
        'ExtendedSliceSupportList',
        'ExtendedUEIdentityIndexValue',
        'EUTRACells-List',
        'EUTRACells-List-item',
        'EUTRACells-List-itemExtIEs',
        'EUTRA-Cell-ID',
        'EUTRA-Coex-FDD-Info',
        'EUTRA-Coex-FDD-Info-ExtIEs',
        'EUTRA-Coex-Mode-Info',
        'EUTRA-Coex-TDD-Info',
        'EUTRA-Coex-TDD-Info-ExtIEs',
        'EUTRA-CyclicPrefixDL',
        'EUTRA-CyclicPrefixUL',
        'EUTRA-PRACH-Configuration',
        'EUTRA-PRACH-Configuration-ExtIEs',
        'EUTRA-SpecialSubframe-Info',
        'EUTRA-SpecialSubframe-Info-ExtIEs',
        'EUTRA-SpecialSubframePatterns',
        'EUTRA-SubframeAssignment',
        'EUTRA-Transmission-Bandwidth',
        'EUTRANQoS',
        'EUTRANQoS-ExtIEs',
        'ExecuteDuplication',
        'ExtendedEARFCN',
        'EUTRA-Mode-Info',
        'EUTRA-Mode-Info-ExtIEs',
        'EUTRA-NR-CellResourceCoordinationReq-Container',
        'EUTRA-NR-CellResourceCoordinationReqAck-Container',
        'EUTRA-FDD-Info',
        'EUTRA-FDD-Info-ExtIEs',
        'EUTRA-TDD-Info',
        'EUTRA-TDD-Info-ExtIEs',
        'EventType',
        'ExtendedPacketDelayBudget',
        'Expected-UL-AoA',
        'Expected-UL-AoA-ExtIEs',
        'Expected-ZoA-only',
        'Expected-ZoA-only-ExtIEs',
        'Expected-Azimuth-AoA',
        'Expected-Azimuth-AoA-ExtIEs',
        'Expected-Zenith-AoA',
        'Expected-Zenith-AoA-ExtIEs',
        'Expected-Value-AoA',
        'Expected-Value-ZoA',
        'F1CPathNSA',
        'F1CTransferPath',
        'F1CTransferPath-ExtIEs',
        'F1CPathNRDC',
        'F1CTransferPathNRDC',
        'F1CTransferPathNRDC-ExtIEs',
        'FDD-Info',
        'FDD-Info-ExtIEs',
        'FDD-InfoRel16',
        'FDD-InfoRel16-ExtIEs',
        'FiveG-ProSeAuthorized',
        'FiveG-ProSeAuthorized-ExtIEs',
        'FiveG-ProSeDirectDiscovery',
        'FiveG-ProSeDirectCommunication',
        'FiveG-ProSeLayer2UEtoNetworkRelay',
        'FiveG-ProSeLayer3UEtoNetworkRelay',
        'FiveG-ProSeLayer2RemoteUE',
        'Flows-Mapped-To-DRB-List',
        'Flows-Mapped-To-DRB-Item',
        'Flows-Mapped-To-DRB-ItemExtIEs',
        'FR1-Bandwidth',
        'FR2-Bandwidth',
        'FreqBandNrItem',
        'FreqBandNrItem-ExtIEs',
        'FreqDomainLength',
        'FreqDomainLength-ExtIEs',
        'FreqInfoRel16',
        'FreqInfoRel16-ExtIEs',
        'FrequencyShift7p5khz',
        'Frequency-Domain-HSNA-Configuration-List',
        'Frequency-Domain-HSNA-Configuration-Item',
        'Frequency-Domain-HSNA-Configuration-Item-ExtIEs',
        'Frequency-Domain-HSNA-Slot-Configuration-List',
        'Frequency-Domain-HSNA-Slot-Configuration-Item',
        'Frequency-Domain-HSNA-Slot-Configuration-Item-ExtIEs',
        'FullConfiguration',
        'FlowsMappedToSLDRB-List',
        'FlowsMappedToSLDRB-Item',
        'FlowsMappedToSLDRB-Item-ExtIEs',
        'GBR-QosInformation',
        'GBR-QosInformation-ExtIEs',
        'GBR-QoSFlowInformation',
        'GBR-QosFlowInformation-ExtIEs',
        'CG-Config',
        'GeographicalCoordinates',
        'GeographicalCoordinates-ExtIEs',
        'GNB-CU-MBS-F1AP-ID',
        'GNBCUMeasurementID',
        'GNBDUMeasurementID',
        'GNB-CUSystemInformation',
        'GNB-CUSystemInformation-ExtIEs',
        'GNB-CU-TNL-Association-Setup-Item',
        'GNB-CU-TNL-Association-Setup-Item-ExtIEs',
        'GNB-CU-TNL-Association-Failed-To-Setup-Item',
        'GNB-CU-TNL-Association-Failed-To-Setup-Item-ExtIEs',
        'GNB-CU-TNL-Association-To-Add-Item',
        'GNB-CU-TNL-Association-To-Add-Item-ExtIEs',
        'GNB-CU-TNL-Association-To-Remove-Item',
        'GNB-CU-TNL-Association-To-Remove-Item-ExtIEs',
        'GNB-CU-TNL-Association-To-Update-Item',
        'GNB-CU-TNL-Association-To-Update-Item-ExtIEs',
        'GNB-CU-UE-F1AP-ID',
        'GNB-DU-Cell-Resource-Configuration',
        'GNB-DU-Cell-Resource-Configuration-ExtIEs',
        'GNB-DU-MBS-F1AP-ID',
        'GNB-DU-UE-F1AP-ID',
        'GNB-DU-ID',
        'GNB-CU-Name',
        'GNB-DU-Name',
        'Extended-GNB-CU-Name',
        'Extended-GNB-CU-Name-ExtIEs',
        'GNB-CU-NameVisibleString',
        'GNB-CU-NameUTF8String',
        'Extended-GNB-DU-Name',
        'Extended-GNB-DU-Name-ExtIEs',
        'GNB-DU-NameVisibleString',
        'GNB-DU-NameUTF8String',
        'GNB-DU-Served-Cells-Item',
        'GNB-DU-Served-Cells-ItemExtIEs',
        'GNB-DU-System-Information',
        'GNB-DU-System-Information-ExtIEs',
        'GNB-DUConfigurationQuery',
        'GNBDUOverloadInformation',
        'GNB-DU-TNL-Association-To-Remove-Item',
        'GNB-DU-TNL-Association-To-Remove-Item-ExtIEs',
        'GNBDUUESliceMaximumBitRateList',
        'GNBDUUESliceMaximumBitRateItem',
        'GNBDUUESliceMaximumBitRateItem-ExtIEs',
        'GNB-RxTxTimeDiff',
        'GNB-RxTxTimeDiff-ExtIEs',
        'GNBRxTxTimeDiffMeas',
        'GNBRxTxTimeDiffMeas-ExtIEs',
        'GNBSetID',
        'GTP-TEID',
        'GTPTLAs',
        'GTPTLA-Item',
        'GTPTLA-Item-ExtIEs',
        'GTPTunnel',
        'GTPTunnel-ExtIEs',
        'HandoverPreparationInformation',
        'HardwareLoadIndicator',
        'HardwareLoadIndicator-ExtIEs',
        'HSNASlotConfigList',
        'HSNASlotConfigItem',
        'HSNASlotConfigItem-ExtIEs',
        'HSNADownlink',
        'HSNAFlexible',
        'HSNAUplink',
        'HSNATransmissionPeriodicity',
        'IAB-Barred',
        'IABConditionalRRCMessageDeliveryIndication',
        'IABCongestionIndication',
        'IAB-Congestion-Indication-List-ExtIEs',
        'IAB-Congestion-Indication-List',
        'IAB-Congestion-Indication-Item',
        'IAB-Congestion-Indication-ItemExtIEs',
        'IAB-Info-IAB-donor-CU',
        'IAB-Info-IAB-donor-CU-ExtIEs',
        'IAB-Info-IAB-DU',
        'IAB-Info-IAB-DU-ExtIEs',
        'IAB-MT-Cell-List',
        'IAB-MT-Cell-List-Item',
        'IAB-MT-Cell-List-Item-ExtIEs',
        'IAB-MT-Cell-NA-Resource-Configuration-Mode-Info',
        'IAB-MT-Cell-NA-Resource-Configuration-Mode-Info-ExtIEs',
        'IAB-MT-Cell-NA-Resource-Configuration-FDD-Info',
        'IAB-MT-Cell-NA-Resource-Configuration-FDD-Info-ExtIEs',
        'IAB-MT-Cell-NA-Resource-Configuration-TDD-Info',
        'IAB-MT-Cell-NA-Resource-Configuration-TDD-Info-ExtIEs',
        'IAB-STC-Info',
        'IAB-STC-Info-ExtIEs',
        'IAB-STC-Info-List',
        'IAB-STC-Info-Item',
        'IAB-STC-Info-Item-ExtIEs',
        'IAB-Allocated-TNL-Address-Item',
        'IAB-Allocated-TNL-Address-Item-ExtIEs',
        'IAB-DU-Cell-Resource-Configuration-Mode-Info',
        'IAB-DU-Cell-Resource-Configuration-Mode-Info-ExtIEs',
        'IAB-DU-Cell-Resource-Configuration-FDD-Info',
        'IAB-DU-Cell-Resource-Configuration-FDD-Info-ExtIEs',
        'IAB-DU-Cell-Resource-Configuration-TDD-Info',
        'IAB-DU-Cell-Resource-Configuration-TDD-Info-ExtIEs',
        'IABIPv6RequestType',
        'IABIPv6RequestType-ExtIEs',
        'IABTNLAddress',
        'IABTNLAddress-ExtIEs',
        'IABTNLAddressesRequested',
        'IABTNLAddressesRequested-ExtIEs',
        'IAB-TNL-Addresses-To-Remove-Item',
        'IAB-TNL-Addresses-To-Remove-Item-ExtIEs',
        'IAB-TNL-Addresses-Exception',
        'IAB-TNL-Addresses-Exception-ExtIEs',
        'IABTNLAddressList',
        'IABTNLAddress-Item',
        'IABTNLAddress-ItemExtIEs',
        'IABTNLAddressUsage',
        'IABv4AddressesRequested',
        'IABv4AddressesRequested-ExtIEs',
        'ImplicitFormat',
        'ImplicitFormat-ExtIEs',
        'IgnorePRACHConfiguration',
        'IgnoreResourceCoordinationContainer',
        'InactivityMonitoringRequest',
        'InactivityMonitoringResponse',
        'InterfacesToTrace',
        'IntendedTDD-DL-ULConfig',
        'InterFrequencyConfig-NoGap',
        'IngressNonF1terminatingTopologyIndicator',
        'IntendedTDD-DL-ULConfig-ExtIEs',
        'IPHeaderInformation',
        'IPHeaderInformation-ItemExtIEs',
        'IPtolayer2TrafficMappingInfo',
        'IPtolayer2TrafficMappingInfoList',
        'IPtolayer2TrafficMappingInfo-Item',
        'IPtolayer2TrafficMappingInfo-ItemExtIEs',
        'L139Info',
        'L139Info-ExtIEs',
        'L839Info',
        'L839Info-ExtIEs',
        'L571Info',
        'L571Info-ExtIEs',
        'L1151Info',
        'L1151Info-ExtIEs',
        'LastUsedCellIndication',
        'LCID',
        'LCS-to-GCS-Translation',
        'LCS-to-GCS-Translation-ExtIEs',
        'LCStoGCSTranslationList',
        'LCStoGCSTranslation',
        'LCStoGCSTranslation-ExtIEs',
        'LMF-MeasurementID',
        'LMF-UE-MeasurementID',
        'LocationDependentMBSF1UInformation',
        'LocationDependentMBSF1UInformation-Item',
        'LocationDependentMBSF1UInformation-Item-ExtIEs',
        'LocationMeasurementInformation',
        'LocationUncertainty',
        'LocationUncertainty-ExtIEs',
        'LongDRXCycleLength',
        'LowerLayerPresenceStatusChange',
        'LoS-NLoSIndicatorHard',
        'LoS-NLoSIndicatorSoft',
        'LoS-NLoSInformation',
        'LoS-NLoSInformation-ExtIEs',
        'LTEUESidelinkAggregateMaximumBitrate',
        'LTEUESidelinkAggregateMaximumBitrate-ExtIEs',
        'LTEV2XServicesAuthorized',
        'LTEV2XServicesAuthorized-ExtIEs',
        'MappingInformationIndex',
        'MappingInformationtoRemove',
        'MaskedIMEISV',
        'MaxDataBurstVolume',
        'MaxPacketLossRate',
        'MBS-Broadcast-NeighbourCellList',
        'MBS-Flows-Mapped-To-MRB-List',
        'MBS-Flows-Mapped-To-MRB-Item',
        'MBS-Flows-Mapped-To-MRB-Item-ExtIEs',
        'MBSF1UInformation',
        'MBSF1UInformation-ExtIEs',
        'MBSInterestIndication',
        'MBS-Session-ID',
        'MBS-Session-ID-ExtIEs',
        'MBS-Area-Session-ID',
        'MBS-CUtoDURRCInformation',
        'MBS-CUtoDURRCInformation-ExtIEs',
        'MBS-Broadcast-Cell-List',
        'MBS-Broadcast-Cell-Item',
        'MBS-Broadcast-Cell-Item-ExtIEs',
        'MBS-Broadcast-MRB-List',
        'MBS-Broadcast-MRB-Item',
        'MBS-Broadcast-MRB-Item-ExtIEs',
        'MBSMulticastF1UContextDescriptor',
        'MBSMulticastF1UContextDescriptor-ExtIEs',
        'MulticastF1UContext-ToBeSetup-Item',
        'MulticastF1UContext-ToBeSetup-Item-ExtIEs',
        'MulticastF1UContext-Setup-Item',
        'MulticastF1UContext-Setup-Item-ExtIEs',
        'MulticastF1UContext-FailedToBeSetup-Item',
        'MulticastF1UContext-FailedToBeSetup-Item-ExtIEs',
        'MBSPTPRetransmissionTunnelRequired',
        'MBS-ServiceArea',
        'MBSServiceArea-ExtIEs',
        'MBS-ServiceAreaInformation',
        'MBS-ServiceAreaInformation-ExtIEs',
        'MBS-ServiceAreaCellList',
        'MBS-ServiceAreaTAIList',
        'MBS-ServiceAreaTAIList-Item',
        'MBS-ServiceAreaTAIList-Item-ExtIEs',
        'MBS-ServiceAreaInformationList',
        'MBS-ServiceAreaInformationItem',
        'MBS-ServiceAreaInformationItem-ExtIEs',
        'MC-PagingCell-Item',
        'MC-PagingCell-ItemExtIEs',
        'MIB-message',
        'MeasConfig',
        'MeasGapConfig',
        'MeasGapSharingConfig',
        'PosMeasurementAmount',
        'MeasurementBeamInfoRequest',
        'MeasurementBeamInfo',
        'MeasurementBeamInfo-ExtIEs',
        'MeasurementTimingConfiguration',
        'MessageIdentifier',
        'MeasurementTimeOccasion',
        'MeasurementCharacteristicsRequestIndicator',
        'MRB-ProgressInformation',
        'MRB-ProgressInformation-ExtIEs',
        'MulticastF1UContextReferenceF1',
        'MulticastF1UContextReferenceCU',
        'MultipleULAoA',
        'MultipleULAoA-ExtIEs',
        'MultipleULAoA-List',
        'MultipleULAoA-Item',
        'MultipleULAoA-Item-ExtIEs',
        'MDTPollutedMeasurementIndicator',
        'MRB-ID',
        'MulticastMBSSessionList',
        'MulticastMBSSessionList-Item',
        'MulticastMBSSessionList-Item-ExtIEs',
        'MulticastMRBs-FailedToBeModified-Item',
        'MulticastMRBs-FailedtoBeModified-Item-ExtIEs',
        'MulticastMRBs-FailedToBeSetup-Item',
        'MulticastMRBs-FailedToBeSetup-Item-ExtIEs',
        'MulticastMRBs-FailedToBeSetupMod-Item',
        'MulticastMRBs-FailedToBeSetupMod-Item-ExtIEs',
        'MulticastMRBs-Modified-Item',
        'MulticastMRBs-Modified-Item-ExtIEs',
        'MulticastMRBs-Setup-Item',
        'MulticastMRBs-Setup-Item-ExtIEs',
        'MulticastMRBs-SetupMod-Item',
        'MulticastMRBs-SetupMod-Item-ExtIEs',
        'MulticastMRBs-ToBeModified-Item',
        'MulticastMRBs-ToBeModified-Item-ExtIEs',
        'MulticastMRBs-ToBeReleased-Item',
        'MulticastMRBs-ToBeReleased-ItemExtIEs',
        'MulticastMRBs-ToBeSetup-Item',
        'MulticastMRBs-ToBeSetup-Item-ExtIEs',
        'MulticastMRBs-ToBeSetupMod-Item',
        'MulticastMRBs-ToBeSetupMod-Item-ExtIEs',
        'MultiplexingInfo',
        'MultiplexingInfo-ExtIEs',
        'M2Configuration',
        'M5Configuration',
        'M5Configuration-ExtIEs',
        'M5period',
        'M5ReportAmount',
        'M5-Links-to-log',
        'M6Configuration',
        'M6Configuration-ExtIEs',
        'M6report-Interval',
        'M6ReportAmount',
        'M6-Links-to-log',
        'M7Configuration',
        'M7Configuration-ExtIEs',
        'M7period',
        'M7ReportAmount',
        'M7-Links-to-log',
        'MDT-Activation',
        'MDTConfiguration',
        'MDTConfiguration-ExtIEs',
        'MDTPLMNList',
        'MDTPLMNModificationList',
        'MeasuredResultsValue',
        'MeasuredResultsValue-ExtIEs',
        'MeasurementsToActivate',
        'MUSIM-GapConfig',
        'NA-Resource-Configuration-List',
        'NA-Resource-Configuration-Item',
        'NA-Resource-Configuration-Item-ExtIEs',
        'NADownlink',
        'NAFlexible',
        'NAUplink',
        'Neighbour-Node-Cells-List',
        'Neighbour-Node-Cells-List-Item',
        'Neighbour-Node-Cells-List-Item-ExtIEs',
        'NeedforGap',
        'NeedForGapsInfoNR',
        'NeedForGapNCSGInfoNR',
        'NeedForGapNCSGInfoEUTRA',
        'Neighbour-Cell-Information-Item',
        'Neighbour-Cell-Information-ItemExtIEs',
        'NeighbourNR-CellsForSON-List',
        'NeighbourNR-CellsForSON-Item',
        'NeighbourNR-CellsForSON-Item-ExtIEs',
        'NGRANAllocationAndRetentionPriority',
        'NGRANAllocationAndRetentionPriority-ExtIEs',
        'NGRANHighAccuracyAccessPointPosition',
        'NGRANHighAccuracyAccessPointPosition-ExtIEs',
        'NID',
        'NonF1terminatingTopologyIndicator',
        'NR-CGI-List-For-Restart-Item',
        'NR-CGI-List-For-Restart-ItemExtIEs',
        'NR-PRSBeamInformation',
        'NR-PRSBeamInformation-ExtIEs',
        'NR-PRSBeamInformationList',
        'NR-PRSBeamInformationItem',
        'NR-PRSBeamInformationItem-ExtIEs',
        'NR-TADV',
        'NRRedCapUEIndication',
        'NRPagingeDRXInformation',
        'NRPagingeDRXInformation-ExtIEs',
        'NRPaging-eDRX-Cycle-Idle',
        'NRPaging-Time-Window',
        'NRPagingeDRXInformationforRRCINACTIVE',
        'NRPagingeDRXInformationforRRCINACTIVE-ExtIEs',
        'NRPaging-eDRX-Cycle-Inactive',
        'NonDynamic5QIDescriptor',
        'NonDynamic5QIDescriptor-ExtIEs',
        'NonDynamicPQIDescriptor',
        'NonDynamicPQIDescriptor-ExtIEs',
        'NonUPTrafficType',
        'NoofDownlinkSymbols',
        'NoofUplinkSymbols',
        'Notification-Cause',
        'NotificationControl',
        'NotificationInformation',
        'NotificationInformationExtIEs',
        'NPNBroadcastInformation',
        'NPNBroadcastInformation-ExtIEs',
        'NPN-Broadcast-Information-SNPN',
        'NPN-Broadcast-Information-SNPN-ExtIEs',
        'NPN-Broadcast-Information-PNI-NPN',
        'NPN-Broadcast-Information-PNI-NPN-ExtIEs',
        'NPNSupportInfo',
        'NPNSupportInfo-ExtIEs',
        'NRCarrierList',
        'NRCarrierItem',
        'NRCarrierItem-ExtIEs',
        'NRFreqInfo',
        'NRFreqInfoExtIEs',
        'NRCGI',
        'NRCGI-ExtIEs',
        'NR-Mode-Info',
        'NR-Mode-Info-ExtIEs',
        'NR-ModeInfoRel16',
        'NR-ModeInfoRel16-ExtIEs',
        'NRPRACHConfig',
        'NRPRACHConfig-ExtIEs',
        'NRCellIdentity',
        'NRNRB',
        'NRPCI',
        'NRPRACHConfigList',
        'NRPRACHConfigItem',
        'NRPRACHConfigItem-ExtIEs',
        'NRSCS',
        'NRUERLFReportContainer',
        'NR-U-Channel-Info-List',
        'NR-U-Channel-Info-Item',
        'NR-U-Channel-Info-List-ExtIEs',
        'NR-U-Channel-List',
        'NR-U-Channel-Item',
        'NR-U-Channel-Item-ExtIEs',
        'NumberofActiveUEs',
        'NumberOfBroadcasts',
        'NumberofBroadcastRequest',
        'NumberOfTRPRxTEG',
        'NumberOfTRPRxTxTEG',
        'NumDLULSymbols',
        'NumDLULSymbols-ExtIEs',
        'NRV2XServicesAuthorized',
        'NRV2XServicesAuthorized-ExtIEs',
        'NRUESidelinkAggregateMaximumBitrate',
        'NRUESidelinkAggregateMaximumBitrate-ExtIEs',
        'NZP-CSI-RS-ResourceID',
        'OffsetToPointA',
        'OnDemandPRS-Info',
        'OnDemandPRS-Info-ExtIEs',
        'PacketDelayBudget',
        'PacketErrorRate',
        'PacketErrorRate-ExtIEs',
        'PER-Scalar',
        'PER-Exponent',
        'PagingCell-Item',
        'PagingCell-ItemExtIEs',
        'PagingDRX',
        'PagingIdentity',
        'PagingCause',
        'PagingIdentity-ExtIEs',
        'PagingOrigin',
        'PagingPriority',
        'PEIPSAssistanceInfo',
        'PEIPSAssistanceInfo-ExtIEs',
        'RelativePathDelay',
        'RelativePathDelay-ExtIEs',
        'Parent-IAB-Nodes-NA-Resource-Configuration-List',
        'Parent-IAB-Nodes-NA-Resource-Configuration-Item',
        'Parent-IAB-Nodes-NA-Resource-Configuration-Item-ExtIEs',
        'PartialSuccessCell',
        'PartialSuccessCell-ExtIEs',
        'PathlossReferenceInfo',
        'PathlossReferenceInfo-ExtIEs',
        'PathlossReferenceSignal',
        'PathlossReferenceSignal-ExtIEs',
        'PathSwitchConfiguration',
        'PathSwitchConfiguration-ExtIEs',
        'PC5QoSFlowIdentifier',
        'PC5-QoS-Characteristics',
        'PC5-QoS-Characteristics-ExtIEs',
        'PC5QoSParameters',
        'PC5QoSParameters-ExtIEs',
        'PC5FlowBitRates',
        'PC5FlowBitRates-ExtIEs',
        'PC5RLCChannelID',
        'PC5RLCChannelQoSInformation',
        'PC5RLCChannelQoSInformation-ExtIEs',
        'PC5RLCChannelToBeSetupList',
        'PC5RLCChannelToBeSetupItem',
        'PC5RLCChannelToBeSetupItem-ExtIEs',
        'PC5RLCChannelToBeModifiedList',
        'PC5RLCChannelToBeModifiedItem',
        'PC5RLCChannelToBeModifiedItem-ExtIEs',
        'PC5RLCChannelToBeReleasedList',
        'PC5RLCChannelToBeReleasedItem',
        'PC5RLCChannelToBeReleasedItem-ExtIEs',
        'PC5RLCChannelSetupList',
        'PC5RLCChannelSetupItem',
        'PC5RLCChannelSetupItem-ExtIEs',
        'PC5RLCChannelFailedToBeSetupList',
        'PC5RLCChannelFailedToBeSetupItem',
        'PC5RLCChannelFailedToBeSetupItem-ExtIEs',
        'PC5RLCChannelModifiedList',
        'PC5RLCChannelModifiedItem',
        'PC5RLCChannelModifiedItem-ExtIEs',
        'PC5RLCChannelFailedToBeModifiedList',
        'PC5RLCChannelFailedToBeModifiedItem',
        'PC5RLCChannelFailedToBeModifiedItem-ExtIEs',
        'PC5RLCChannelRequiredToBeModifiedList',
        'PC5RLCChannelRequiredToBeModifiedItem',
        'PC5RLCChannelRequiredToBeModifiedItem-ExtIEs',
        'PC5RLCChannelRequiredToBeReleasedList',
        'PC5RLCChannelRequiredToBeReleasedItem',
        'PC5RLCChannelRequiredToBeReleasedItem-ExtIEs',
        'PDCCH-BlindDetectionSCG',
        'PDCMeasurementPeriodicity',
        'PDCMeasurementQuantities',
        'PDCMeasurementQuantities-ItemIEs',
        'PDCMeasurementQuantities-Item',
        'PDCMeasurementQuantitiesValue-ExtIEs',
        'PDCMeasurementQuantitiesValue',
        'PDCMeasurementResult',
        'PDCMeasurementResult-ExtIEs',
        'PDCMeasuredResultsList',
        'PDCMeasuredResults-Item',
        'PDCMeasuredResults-Item-ExtIEs',
        'PDCMeasuredResults-Value',
        'PDCMeasuredResults-Value-ExtIEs',
        'PDCReportType',
        'PDC-RxTxTimeDiff',
        'PDC-TADV-NR',
        'PDCP-SN',
        'PDCPSNLength',
        'PDUSessionID',
        'PEISubgroupingSupportIndication',
        'ReportingPeriodicityValue',
        'Periodicity',
        'PeriodicitySRS',
        'PeriodicityList',
        'PeriodicityList-Item',
        'PeriodicityList-ItemExtIEs',
        'Permutation',
        'Ph-InfoMCG',
        'Ph-InfoSCG',
        'PLMN-Identity',
        'PlayoutDelayForMediaStartup',
        'PortNumber',
        'PosAssistance-Information',
        'PosAssistanceInformationFailureList',
        'PosBroadcast',
        'PosConextRevIndication',
        'PositioningBroadcastCells',
        'PosMeasGapPreConfigList',
        'PosMeasGapPreConfigList-ExtIEs',
        'MeasurementPeriodicity',
        'MeasurementPeriodicityExtended',
        'PosMeasurementPeriodicityNR-AoA',
        'PosMeasurementQuantities',
        'PosMeasurementQuantities-Item',
        'PosMeasurementQuantities-ItemExtIEs',
        'PosMeasurementResult',
        'PosMeasurementResultItem',
        'PosMeasurementResultItemExtIEs',
        'PosMeasurementResultList',
        'PosMeasurementResultList-Item',
        'PosMeasurementResultList-ItemExtIEs',
        'PosMeasurementType',
        'PosReportCharacteristics',
        'PosResourceSetType',
        'PosResourceSetType-ExtIEs',
        'PosResourceSetTypePR',
        'PosResourceSetTypePR-ExtIEs',
        'PosResourceSetTypeSP',
        'PosResourceSetTypeSP-ExtIEs',
        'PosResourceSetTypeAP',
        'PosResourceSetTypeAP-ExtIEs',
        'PosSItypeList',
        'PosSItype-Item',
        'PosSItype-ItemExtIEs',
        'PosSItype',
        'PosSRSResourceID-List',
        'PosSRSResource-Item',
        'PosSRSResource-Item-ExtIEs',
        'PosSRSResource-List',
        'PosSRSResourceSet-Item',
        'PosSRSResourceSet-Item-ExtIEs',
        'PosSRSResourceSet-List',
        'PrimaryPathIndication',
        'Pre-emptionCapability',
        'Pre-emptionVulnerability',
        'PriorityLevel',
        'ProtectedEUTRAResourceIndication',
        'Protected-EUTRA-Resources-Item',
        'Protected-EUTRA-Resources-ItemExtIEs',
        'PRSConfiguration',
        'PRSConfiguration-ExtIEs',
        'PRSInformationPos',
        'PRSInformationPos-ExtIEs',
        'PRS-Measurement-Info-List',
        'PRS-Measurement-Info-List-Item',
        'PRS-Measurement-Info-List-Item-ExtIEs',
        'Potential-SpCell-Item',
        'Potential-SpCell-ItemExtIEs',
        'PRSAngleList',
        'PRSAngleItem',
        'PRSAngleItem-ItemExtIEs',
        'PRSConfigRequestType',
        'PRSMuting',
        'PRSMuting-ExtIEs',
        'PRSMutingOption1',
        'PRSMutingOption1-ExtIEs',
        'PRSMutingOption2',
        'PRSMutingOption2-ExtIEs',
        'PRS-Resource-ID',
        'PRSResource-List',
        'PRSResource-Item',
        'PRSResource-Item-ExtIEs',
        'PRSResource-QCLInfo',
        'PRSResource-QCLInfo-ExtIEs',
        'PRSResource-QCLSourceSSB',
        'PRSResource-QCLSourceSSB-ExtIEs',
        'PRSResource-QCLSourcePRS',
        'PRSResource-QCLSourcePRS-ExtIEs',
        'PRS-Resource-Set-ID',
        'PRSResourceSet-List',
        'PRSResourceSet-Item',
        'PRSResourceSet-Item-ExtIEs',
        'PRSTransmissionOffIndication',
        'PRSTransmissionOffIndication-ExtIEs',
        'PRSTransmissionOffPerResource',
        'PRSTransmissionOffPerResource-Item',
        'PRSTransmissionOffPerResource-Item-ExtIEs',
        'PRSTransmissionOffIndicationPerResource-Item',
        'PRSTransmissionOffIndicationPerResource-Item-ExtIEs',
        'PRSTransmissionOffInformation',
        'PRSTransmissionOffInformation-ExtIEs',
        'PRSTransmissionOffPerResourceSet',
        'PRSTransmissionOffPerResourceSet-Item',
        'PRSTransmissionOffPerResourceSet-Item-ExtIEs',
        'PWS-Failed-NR-CGI-Item',
        'PWS-Failed-NR-CGI-ItemExtIEs',
        'PWSSystemInformation',
        'PWSSystemInformationExtIEs',
        'PrivacyIndicator',
        'PRS-ID',
        'PRSTRPList',
        'PRSTRPItem',
        'PRSTRPItem-ExtIEs',
        'RequestedDLPRSTransmissionCharacteristics',
        'RequestedDLPRSTransmissionCharacteristics-ExtIEs',
        'RequestedDLPRSResourceSet-List',
        'RequestedDLPRSResourceSet-Item',
        'RequestedDLPRSResourceSet-Item-ExtIEs',
        'RequestedDLPRSResource-List',
        'RequestedDLPRSResource-Item',
        'RequestedDLPRSResource-Item-ExtIEs',
        'PRSTransmissionTRPList',
        'PRSTransmissionTRPItem',
        'PRSTransmissionTRPItem-ExtIEs',
        'QCI',
        'QoEInformation',
        'QoEInformation-ExtIEs',
        'QoEInformationList',
        'QoEInformationList-Item',
        'QoEInformationList-Item-ExtIEs',
        'QoEMetrics',
        'QoEMetrics-ExtIEs',
        'QoS-Characteristics',
        'QoS-Characteristics-ExtIEs',
        'QoSFlowIdentifier',
        'QoSFlowLevelQoSParameters',
        'QoSFlowLevelQoSParameters-ExtIEs',
        'QoSFlowMappingIndication',
        'QoSInformation',
        'QoSInformation-ExtIEs',
        'QosMonitoringRequest',
        'QoSParaSetIndex',
        'QoSParaSetNotifyIndex',
        'RACH-Config-Common',
        'RACH-Config-Common-IAB',
        'RACHReportContainer',
        'RACHReportInformationList',
        'RACHReportInformationItem',
        'RACHReportInformationItem-ExtIEs',
        'RadioResourceStatus',
        'RadioResourceStatus-ExtIEs',
        'MIMOPRBusageInformation',
        'MIMOPRBusageInformation-ExtIEs',
        'RANAC',
        'RAN-MeasurementID',
        'RAN-UE-MeasurementID',
        'RAN-UE-PDC-MeasID',
        'RANUEID',
        'RANUEPagingIdentity',
        'RANUEPagingIdentity-ExtIEs',
        'RAT-FrequencyPriorityInformation',
        'RAT-FrequencyPriorityInformation-ExtIEs',
        'RAT-FrequencySelectionPriority',
        'RBSetConfiguration',
        'RBSetConfiguration-ExtIEs',
        'RBSetSize',
        'Re-routingEnableIndicator',
        'Redcap-Bcast-Information',
        'RedCapIndication',
        'Reestablishment-Indication',
        'ReferencePoint',
        'ReferencePoint-ExtIEs',
        'ReferenceSFN',
        'ReferenceSignal',
        'ReferenceSignal-ExtIEs',
        'RelativeCartesianLocation',
        'RelativeCartesianLocation-ExtIEs',
        'RelativeGeodeticLocation',
        'RelativeGeodeticLocation-ExtIEs',
        'RemoteUELocalID',
        'ReferenceTime',
        'RegistrationRequest',
        'ReportCharacteristics',
        'ReportingPeriodicity',
        'RequestedBandCombinationIndex',
        'RequestedFeatureSetEntryIndex',
        'RequestedP-MaxFR2',
        'Requested-PDCCH-BlindDetectionSCG',
        'RequestedSRSTransmissionCharacteristics',
        'RequestedSRSTransmissionCharacteristics-ExtIEs',
        'RequestType',
        'ResourceCoordinationEUTRACellInfo',
        'ResourceCoordinationEUTRACellInfo-ExtIEs',
        'ResourceCoordinationTransferInformation',
        'ResourceCoordinationTransferInformation-ExtIEs',
        'ResourceCoordinationTransferContainer',
        'ResourceSetType',
        'ResourceSetType-ExtIEs',
        'ResourceSetTypePeriodic',
        'ResourceSetTypePeriodic-ExtIEs',
        'ResourceSetTypeSemi-persistent',
        'ResourceSetTypeSemi-persistent-ExtIEs',
        'ResourceSetTypeAperiodic',
        'ResourceSetTypeAperiodic-ExtIEs',
        'RepetitionPeriod',
        'ReportingRequestType',
        'ReportingRequestType-ExtIEs',
        'ResourceType',
        'ResourceType-ExtIEs',
        'ResourceTypePeriodic',
        'ResourceTypePeriodic-ExtIEs',
        'ResourceTypeSemi-persistent',
        'ResourceTypeSemi-persistent-ExtIEs',
        'ResourceTypeAperiodic',
        'ResourceTypeAperiodic-ExtIEs',
        'ResourceTypePos',
        'ResourceTypePos-ExtIEs',
        'ResourceTypePeriodicPos',
        'ResourceTypePeriodicPos-ExtIEs',
        'ResourceTypeSemi-persistentPos',
        'ResourceTypeSemi-persistentPos-ExtIEs',
        'ResourceTypeAperiodicPos',
        'ResourceTypeAperiodicPos-ExtIEs',
        'RLCDuplicationInformation',
        'RLCDuplicationInformation-ExtIEs',
        'RLCDuplicationStateList',
        'RLCDuplicationState-Item',
        'RLCDuplicationState-Item-ExtIEs',
        'RLCFailureIndication',
        'RLCFailureIndication-ExtIEs',
        'RLCMode',
        'RLC-Status',
        'RLC-Status-ExtIEs',
        'RLFReportInformationList',
        'RLFReportInformationItem',
        'RLFReportInformationItem-ExtIEs',
        'RIMRSDetectionStatus',
        'RRCContainer',
        'RRCContainer-RRCSetupComplete',
        'RRCDeliveryStatus',
        'RRCDeliveryStatus-ExtIEs',
        'RRCDeliveryStatusRequest',
        'RRCReconfigurationCompleteIndicator',
        'RRC-Version',
        'RRC-Version-ExtIEs',
        'RoutingID',
        'ResponseTime',
        'ResponseTime-ExtIEs',
        'RxTxTimingErrorMargin',
        'SCell-FailedtoSetup-Item',
        'SCell-FailedtoSetup-ItemExtIEs',
        'SCell-FailedtoSetupMod-Item',
        'SCell-FailedtoSetupMod-ItemExtIEs',
        'SCell-ToBeRemoved-Item',
        'SCell-ToBeRemoved-ItemExtIEs',
        'SCell-ToBeSetup-Item',
        'SCell-ToBeSetup-ItemExtIEs',
        'SCell-ToBeSetupMod-Item',
        'SCell-ToBeSetupMod-ItemExtIEs',
        'SCellIndex',
        'SCGActivationRequest',
        'SCGActivationStatus',
        'SCGIndicator',
        'SCS-480',
        'SCS-960',
        'SCS-SpecificCarrier',
        'SCS-SpecificCarrier-ExtIEs',
        'SDTBearerConfigurationQueryIndication',
        'SDTBearerConfigurationInfo',
        'SDTBearerConfigurationInfo-ExtIEs',
        'SDTBearerConfig-List',
        'SDTBearerConfig-List-Item',
        'SDTBearerConfig-List-Item-ExtIEs',
        'SDTBearerType',
        'SDTBearerType-ExtIEs',
        'SDT-MAC-PHY-CG-Config',
        'SDTInformation',
        'SDTInformation-ExtIEs',
        'SDTRLCBearerConfiguration',
        'SDT-Termination-Request',
        'Search-window-information',
        'Search-window-information-ExtIEs',
        'SerialNumber',
        'SIBType-PWS',
        'SelectedBandCombinationIndex',
        'SelectedFeatureSetEntryIndex',
        'CG-ConfigInfo',
        'ServCellIndex',
        'ServingCellMO',
        'ServingCellMO-List-Item',
        'ServingCellMO-List-Item-ExtIEs',
        'ServingCellMO-encoded-in-CGC-List',
        'ServingCellMO-encoded-in-CGC-Item',
        'ServingCellMO-encoded-in-CGC-Item-ExtIEs',
        'Served-Cell-Information',
        'Served-Cell-Information-ExtIEs',
        'Serving-Cells-List',
        'Serving-Cells-List-Item',
        'Serving-Cells-List-Item-ExtIEs',
        'Supported-MBS-FSA-ID-List',
        'MBS-FrequencySelectionArea-Identity',
        'SFN-Offset',
        'SFN-Offset-ExtIEs',
        'Served-Cells-To-Add-Item',
        'Served-Cells-To-Add-ItemExtIEs',
        'Served-Cells-To-Delete-Item',
        'Served-Cells-To-Delete-ItemExtIEs',
        'Served-Cells-To-Modify-Item',
        'Served-Cells-To-Modify-ItemExtIEs',
        'Served-EUTRA-Cells-Information',
        'Served-EUTRA-Cell-Information-ExtIEs',
        'Service-State',
        'Service-Status',
        'Service-Status-ExtIEs',
        'RelativeTime1900',
        'ShortDRXCycleLength',
        'ShortDRXCycleTimer',
        'SIB1-message',
        'SIB10-message',
        'SIB12-message',
        'SIB13-message',
        'SIB14-message',
        'SIB15-message',
        'SIB17-message',
        'SIB20-message',
        'SItype',
        'SItype-List',
        'SItype-Item',
        'SItype-ItemExtIEs',
        'SibtypetobeupdatedListItem',
        'SibtypetobeupdatedListItem-ExtIEs',
        'SidelinkRelayConfiguration',
        'SidelinkRelayConfiguration-ExtIEs',
        'SidelinkConfigurationContainer',
        'SLDRBID',
        'SLDRBInformation',
        'SLDRBs-FailedToBeModified-Item',
        'SLDRBs-FailedToBeModified-ItemExtIEs',
        'SLDRBs-FailedToBeSetup-Item',
        'SLDRBs-FailedToBeSetup-ItemExtIEs',
        'SLDRBs-FailedToBeSetupMod-Item',
        'SLDRBs-FailedToBeSetupMod-ItemExtIEs',
        'SLDRBs-Modified-Item',
        'SLDRBs-Modified-ItemExtIEs',
        'SLDRBs-ModifiedConf-Item',
        'SLDRBs-ModifiedConf-ItemExtIEs',
        'SLDRBs-Required-ToBeModified-Item',
        'SLDRBs-Required-ToBeModified-ItemExtIEs',
        'SLDRBs-Required-ToBeReleased-Item',
        'SLDRBs-Required-ToBeReleased-ItemExtIEs',
        'SLDRBs-Setup-Item',
        'SLDRBs-Setup-ItemExtIEs',
        'SLDRBs-SetupMod-Item',
        'SLDRBs-SetupMod-ItemExtIEs',
        'SLDRBs-ToBeModified-Item',
        'SLDRBs-ToBeModified-ItemExtIEs',
        'SLDRBs-ToBeReleased-Item',
        'SLDRBs-ToBeReleased-ItemExtIEs',
        'SLDRBs-ToBeSetup-Item',
        'SLDRBs-ToBeSetup-ItemExtIEs',
        'SLDRBs-ToBeSetupMod-Item',
        'SLDRBs-ToBeSetupMod-ItemExtIEs',
        'SLDRXCycleList',
        'SLDRXCycleItem',
        'SLDRXCycleItem-ExtIEs',
        'SLDRXInformation',
        'SLDRXCycleLength',
        'SLDRXConfigurationIndicator',
        'SLDRXInformation-ExtIEs',
        'SL-PHY-MAC-RLC-Config',
        'SL-RLC-ChannelToAddModList',
        'SL-ConfigDedicatedEUTRA-Info',
        'SliceAvailableCapacity',
        'SliceAvailableCapacity-ExtIEs',
        'SliceAvailableCapacityList',
        'SliceAvailableCapacityItem',
        'SliceAvailableCapacityItem-ExtIEs',
        'SNSSAIAvailableCapacity-List',
        'SNSSAIAvailableCapacity-Item',
        'SNSSAIAvailableCapacity-Item-ExtIEs',
        'SliceRadioResourceStatus',
        'SliceRadioResourceStatus-ExtIEs',
        'SliceRadioResourceStatus-List',
        'SliceRadioResourceStatus-Item',
        'SliceRadioResourceStatus-Item-ExtIEs',
        'SNSSAIRadioResourceStatus-List',
        'SNSSAIRadioResourceStatus-Item',
        'SNSSAIRadioResourceStatus-Item-ExtIEs',
        'SliceSupportList',
        'SliceSupportItem',
        'SliceSupportItem-ExtIEs',
        'SliceToReportList',
        'SliceToReportItem',
        'SliceToReportItem-ExtIEs',
        'SlotNumber',
        'SNSSAI-list',
        'SNSSAI-Item',
        'SNSSAI-Item-ExtIEs',
        'Slot-Configuration-List',
        'Slot-Configuration-Item',
        'Slot-Configuration-ItemExtIEs',
        'SNSSAI',
        'SNSSAI-ExtIEs',
        'SpatialDirectionInformation',
        'SpatialDirectionInformation-ExtIEs',
        'SpatialRelationInfo',
        'SpatialRelationInfo-ExtIEs',
        'SpatialRelationforResourceID',
        'SpatialRelationforResourceIDItem',
        'SpatialRelationforResourceIDItem-ExtIEs',
        'SpatialRelationPerSRSResource',
        'SpatialRelationPerSRSResource-ExtIEs',
        'SpatialRelationPerSRSResource-List',
        'SpatialRelationPerSRSResourceItem',
        'SpatialRelationPerSRSResourceItem-ExtIEs',
        'SpatialRelationPos',
        'SpatialInformationPos-ExtIEs',
        'SpectrumSharingGroupID',
        'SRBID',
        'SRBs-FailedToBeSetup-Item',
        'SRBs-FailedToBeSetup-ItemExtIEs',
        'SRBs-FailedToBeSetupMod-Item',
        'SRBs-FailedToBeSetupMod-ItemExtIEs',
        'SRBs-Modified-Item',
        'SRBs-Modified-ItemExtIEs',
        'SRBs-Required-ToBeReleased-Item',
        'SRBs-Required-ToBeReleased-ItemExtIEs',
        'SRBs-Setup-Item',
        'SRBs-Setup-ItemExtIEs',
        'SRBs-SetupMod-Item',
        'SRBs-SetupMod-ItemExtIEs',
        'SRBs-ToBeReleased-Item',
        'SRBs-ToBeReleased-ItemExtIEs',
        'SRBs-ToBeSetup-Item',
        'SRBs-ToBeSetup-ItemExtIEs',
        'SRBs-ToBeSetupMod-Item',
        'SRBs-ToBeSetupMod-ItemExtIEs',
        'SRSCarrier-List',
        'SRSCarrier-List-Item',
        'SRSCarrier-List-Item-ExtIEs',
        'SRSConfig',
        'SRSConfig-ExtIEs',
        'SRSConfiguration',
        'SRSConfiguration-ExtIEs',
        'SrsFrequency',
        'SRSPortIndex',
        'SRSPosResourceID',
        'SRSResource',
        'SRSResource-ExtIEs',
        'SRSResourceID',
        'SRSResourceID-List',
        'SRSResource-List',
        'SRSResourceSet',
        'SRSResourceSet-ExtIEs',
        'SRSResourceSetID',
        'SRSResourceSetList',
        'SRSResourceSetItem',
        'SRSResourceSetItemExtIEs',
        'SRSResourceSet-List',
        'SRSResourceTrigger',
        'SRSResourceTrigger-ExtIEs',
        'SRSResourcetype',
        'SRSResourcetype-ExtIEs',
        'SRSResourceTypeChoice',
        'SRSResourceTypeChoice-ExtIEs',
        'SRSInfo',
        'SRSPosRRCInactiveConfig',
        'SRSPosRRCInactiveQueryIndication',
        'PosSRSInfo',
        'SSB',
        'SSBCoverageModification-List',
        'SSBCoverageModification-Item',
        'SSBCoverageModification-Item-ExtIEs',
        'SSBCoverageState',
        'SSB-ExtIEs',
        'SSB-freqInfo',
        'SSB-Index',
        'SSB-subcarrierSpacing',
        'SSB-transmissionPeriodicity',
        'SSB-transmissionTimingOffset',
        'SSB-transmissionBitmap',
        'SSB-transmisisonBitmap-ExtIEs',
        'SSBAreaCapacityValueList',
        'SSBAreaCapacityValueItem',
        'SSBAreaCapacityValueItem-ExtIEs',
        'SSBAreaRadioResourceStatusList',
        'SSBAreaRadioResourceStatusItem',
        'SSBAreaRadioResourceStatusItem-ExtIEs',
        'SSBInformation',
        'SSBInformation-ExtIEs',
        'SSBInformationList',
        'SSBInformationItem',
        'SSBInformationItem-ExtIEs',
        'SSB-PositionsInBurst',
        'SSB-PositionsInBurst-ExtIEs',
        'SSB-TF-Configuration',
        'SSB-TF-Configuration-ExtIEs',
        'SSBToReportList',
        'SSBToReportItem',
        'SSBToReportItem-ExtIEs',
        'StartTimeAndDuration',
        'StartTimeAndDuration-ExtIEs',
        'SUL-Information',
        'SUL-InformationExtIEs',
        'SubcarrierSpacing',
        'SubscriberProfileIDforRFP',
        'SuccessfulHOReportInformationList',
        'SuccessfulHOReportInformation-Item',
        'SuccessfulHOReportInformation-Item-ExtIEs',
        'SULAccessIndication',
        'SupportedSULFreqBandItem',
        'SupportedSULFreqBandItem-ExtIEs',
        'SurvivalTime',
        'SymbolAllocInSlot',
        'SymbolAllocInSlot-ExtIEs',
        'SystemFrameNumber',
        'SystemInformationAreaID',
        'FiveGS-TAC',
        'Configured-EPS-TAC',
        'TargetCellList',
        'TargetCellList-Item',
        'TargetCellList-Item-ExtIEs',
        'NSAGSupportList',
        'NSAGSupportItem',
        'NSAGSupportItem-ExtIEs',
        'NSAG-ID',
        'TDD-Info',
        'TDD-Info-ExtIEs',
        'TDD-InfoRel16',
        'TDD-InfoRel16-ExtIEs',
        'TDD-UL-DLConfigCommonNR',
        'TRPTEGInformation',
        'TRPTEGInformation-ExtIEs',
        'RxTxTEG',
        'RxTxTEG-ExtIEs',
        'RxTEG',
        'RxTEG-ExtIEs',
        'TimeReferenceInformation',
        'TimeReferenceInformation-ExtIEs',
        'TimeInformationType',
        'TimeStamp',
        'TimeStamp-ExtIEs',
        'TimeStampSlotIndex',
        'TimeStampSlotIndex-ExtIEs',
        'TimeToWait',
        'TimingErrorMargin',
        'TimingMeasurementQuality',
        'TimingMeasurementQuality-ExtIEs',
        'TMGI',
        'TNLAssociationUsage',
        'TNLCapacityIndicator',
        'TNLCapacityIndicator-ExtIEs',
        'TraceActivation',
        'TraceActivation-ExtIEs',
        'TraceDepth',
        'TraceID',
        'TrafficMappingInfo',
        'TrafficMappingInfo-ExtIEs',
        'TransportLayerAddress',
        'TransactionID',
        'Transmission-Bandwidth',
        'Transmission-Bandwidth-ExtIEs',
        'TransmissionComb',
        'TransmissionComb-ExtIEs',
        'TransmissionCombPos',
        'TransmissionCombPos-ExtIEs',
        'TransmissionStopIndicator',
        'Transport-UP-Layer-Address-Info-To-Add-List',
        'Transport-UP-Layer-Address-Info-To-Add-Item',
        'Transport-UP-Layer-Address-Info-To-Add-ItemExtIEs',
        'Transport-UP-Layer-Address-Info-To-Remove-List',
        'Transport-UP-Layer-Address-Info-To-Remove-Item',
        'Transport-UP-Layer-Address-Info-To-Remove-ItemExtIEs',
        'TransmissionActionIndicator',
        'TRPBeamAntennaInformation',
        'TRPBeamAntennaInformation-ExtIEs',
        'Choice-TRP-Beam-Antenna-Info-Item',
        'Choice-TRP-Beam-Info-Item-ExtIEs',
        'TRP-BeamAntennaExplicitInformation',
        'TRP-BeamAntennaExplicitInformation-ExtIEs',
        'TRP-BeamAntennaAngles',
        'TRP-BeamAntennaAnglesList-Item',
        'TRP-BeamAntennaAnglesList-Item-ExtIEs',
        'TRP-ElevationAngleList-Item',
        'TRP-ElevationAngleList-Item-ExtIEs',
        'TRP-Beam-Power-Item',
        'TRP-Beam-Power-Item-ExtIEs',
        'TRPID',
        'TRPInformation',
        'TRPInformation-ExtIEs',
        'TRPInformationItem',
        'TRPInformationItem-ExtIEs',
        'TRPInformationTypeItem',
        'TRPInformationTypeResponseList',
        'TRPInformationTypeResponseItem',
        'TRPInformationTypeResponseItem-ExtIEs',
        'TRPList',
        'TRPListItem',
        'TRPListItem-ExtIEs',
        'TRPMeasurementQuality',
        'TRPMeasurementQuality-ExtIEs',
        'TRPMeasurementQuality-Item',
        'TRPMeasurementQuality-Item-ExtIEs',
        'TRP-MeasurementRequestList',
        'TRP-MeasurementRequestItem',
        'TRP-MeasurementRequestItem-ExtIEs',
        'TRP-PRS-Info-List',
        'TRP-PRS-Info-List-Item',
        'TRP-PRS-Info-List-Item-ExtIEs',
        'TRPPositionDefinitionType',
        'TRPPositionDefinitionType-ExtIEs',
        'TRPPositionDirect',
        'TRPPositionDirect-ExtIEs',
        'TRPPositionDirectAccuracy',
        'TRPPositionDirectAccuracy-ExtIEs',
        'TRPPositionReferenced',
        'TRPPositionReferenced-ExtIEs',
        'TRPReferencePointType',
        'TRPReferencePointType-ExtIEs',
        'TRP-Rx-TEGInformation',
        'TRP-Rx-TEGInformation-ExtIEs',
        'TRP-RxTx-TEGInformation',
        'TRP-RxTx-TEGInformation-ExtIEs',
        'TRP-Tx-TEGInformation',
        'TRP-Tx-TEGInformation-ExtIEs',
        'TRPTxTEGAssociation',
        'TRPTEG-Item',
        'TRPTEGItem-ExtIEs',
        'DLPRSResourceID-Item',
        'DLPRSResource-Item-ExtIEs',
        'TypeOfError',
        'Transport-Layer-Address-Info',
        'Transport-Layer-Address-Info-ExtIEs',
        'TRPType',
        'TSCAssistanceInformation',
        'TSCAssistanceInformation-ExtIEs',
        'TSCTrafficCharacteristics',
        'TSCTrafficCharacteristics-ExtIEs',
        'TRP-MeasurementUpdateList',
        'TRP-MeasurementUpdateItem',
        'TRP-MeasurementUpdateItem-ExtIEs',
        'TwoPHRModeMCG',
        'TwoPHRModeSCG',
        'UAC-Assistance-Info',
        'UAC-Assistance-InfoExtIEs',
        'UACPLMN-List',
        'UACPLMN-Item',
        'UACPLMN-Item-ExtIEs',
        'UACType-List',
        'UACType-Item',
        'UACType-Item-ExtIEs',
        'UACCategoryType',
        'UACCategoryType-ExtIEs',
        'UACOperatorDefined',
        'UACOperatorDefined-ExtIEs',
        'UACAction',
        'UACReductionIndication',
        'UE-associatedLogicalF1-ConnectionItem',
        'UEAssistanceInformation',
        'UEAssistanceInformationEUTRA',
        'UE-associatedLogicalF1-ConnectionItemExtIEs',
        'UE-CapabilityRAT-ContainerList',
        'UEContextNotRetrievable',
        'UEIdentityIndexValue',
        'UEIdentityIndexValueChoice-ExtIEs',
        'UEIdentity-List-For-Paging-Item',
        'UEIdentity-List-For-Paging-Item-ExtIEs',
        'UE-MulticastMRBs-ConfirmedToBeModified-Item',
        'UE-MulticastMRBs-ConfirmedToBeModified-Item-ExtIEs',
        'UE-MulticastMRBs-RequiredToBeModified-Item',
        'UE-MulticastMRBs-RequiredToBeModified-Item-ExtIEs',
        'UE-MulticastMRBs-RequiredToBeReleased-Item',
        'UE-MulticastMRBs-RequiredToBeReleased-Item-ExtIEs',
        'UE-MulticastMRBs-Setup-Item',
        'UE-MulticastMRBs-Setup-Item-ExtIEs',
        'UE-MulticastMRBs-ToBeReleased-Item',
        'UE-MulticastMRBs-ToBeReleased-Item-ExtIEs',
        'UE-MulticastMRBs-ToBeSetup-Item',
        'UE-MulticastMRBs-ToBeSetup-Item-ExtIEs',
        'UE-MulticastMRBs-ToBeSetup-atModify-Item',
        'UE-MulticastMRBs-ToBeSetup-atModify-Item-ExtIEs',
        'UEPagingCapability',
        'UEPagingCapability-ExtIEs',
        'UEReportingInformation',
        'UEReportingInformation-ExtIEs',
        'UlTxDirectCurrentMoreCarrierInformation',
        'UL-AoA',
        'UL-AoA-ExtIEs',
        'UL-BH-Non-UP-Traffic-Mapping',
        'UL-BH-Non-UP-Traffic-Mapping-ExtIEs',
        'UL-BH-Non-UP-Traffic-Mapping-List',
        'UL-BH-Non-UP-Traffic-Mapping-Item',
        'UL-BH-Non-UP-Traffic-Mapping-ItemExtIEs',
        'ULConfiguration',
        'ULConfigurationExtIEs',
        'UL-GapFR2-Config',
        'UL-RTOA-Measurement',
        'UL-RTOA-Measurement-ExtIEs',
        'UL-RTOA-MeasurementItem',
        'UL-RTOA-MeasurementItem-ExtIEs',
        'UL-SRS-RSRP',
        'UL-SRS-RSRPP',
        'UL-SRS-RSRPP-ExtIEs',
        'ULUEConfiguration',
        'UL-UP-TNL-Information-to-Update-List-Item',
        'UL-UP-TNL-Information-to-Update-List-ItemExtIEs',
        'UL-UP-TNL-Address-to-Update-List-Item',
        'UL-UP-TNL-Address-to-Update-List-ItemExtIEs',
        'ULUPTNLInformation-ToBeSetup-List',
        'ULUPTNLInformation-ToBeSetup-Item',
        'ULUPTNLInformation-ToBeSetup-ItemExtIEs',
        'Uncertainty',
        'UplinkChannelBW-PerSCS-List',
        'UplinkTxDirectCurrentListInformation',
        'UplinkTxDirectCurrentTwoCarrierListInfo',
        'UPTransportLayerInformation',
        'UPTransportLayerInformation-ExtIEs',
        'URI-address',
        'Uncertainty-range-AoA',
        'Uncertainty-range-ZoA',
        'UuRLCChannelID',
        'UuRLCChannelQoSInformation',
        'UuRLCChannelQoSInformation-ExtIEs',
        'UuRLCChannelToBeSetupList',
        'UuRLCChannelToBeSetupItem',
        'UuRLCChannelToBeSetupItem-ExtIEs',
        'UuRLCChannelToBeModifiedList',
        'UuRLCChannelToBeModifiedItem',
        'UuRLCChannelToBeModifiedItem-ExtIEs',
        'UuRLCChannelToBeReleasedList',
        'UuRLCChannelToBeReleasedItem',
        'UuRLCChannelToBeReleasedItem-ExtIEs',
        'UuRLCChannelSetupList',
        'UuRLCChannelSetupItem',
        'UuRLCChannelSetupItem-ExtIEs',
        'UuRLCChannelFailedToBeSetupList',
        'UuRLCChannelFailedToBeSetupItem',
        'UuRLCChannelFailedToBeSetupItem-ExtIEs',
        'UuRLCChannelModifiedList',
        'UuRLCChannelModifiedItem',
        'UuRLCChannelModifiedItem-ExtIEs',
        'UuRLCChannelFailedToBeModifiedList',
        'UuRLCChannelFailedToBeModifiedItem',
        'UuRLCChannelFailedToBeModifiedItem-ExtIEs',
        'UuRLCChannelRequiredToBeModifiedList',
        'UuRLCChannelRequiredToBeModifiedItem',
        'UuRLCChannelRequiredToBeModifiedItem-ExtIEs',
        'UuRLCChannelRequiredToBeReleasedList',
        'UuRLCChannelRequiredToBeReleasedItem',
        'UuRLCChannelRequiredToBeReleasedItem-ExtIEs',
        'VictimgNBSetID',
        'VictimgNBSetID-ExtIEs',
        'VehicleUE',
        'PedestrianUE',
        'ZoAInformation',
        'ZoAInformation-ExtIEs',
        ]
    _type_ = [
        'AbortTransmission',
        'AccessPointPosition',
        'Activated-Cells-to-be-Updated-List',
        'Activated-Cells-to-be-Updated-List-Item',
        'ActivationRequestType',
        'ActiveULBWP',
        'AdditionalDuplicationIndication',
        'AdditionalPath-List',
        'AdditionalPath-Item',
        'ExtendedAdditionalPathList',
        'ExtendedAdditionalPathList-Item',
        'AdditionalPDCPDuplicationTNL-List',
        'AdditionalPDCPDuplicationTNL-Item',
        'AdditionalSIBMessageList',
        'AdditionalSIBMessageList-Item',
        'AdditionalRRMPriorityIndex',
        'AffectedCellsAndBeams-List',
        'AffectedCellsAndBeams-Item',
        'AffectedSSB-List',
        'AffectedSSB-Item',
        'AggressorCellList',
        'AggressorCellList-Item',
        'AggressorgNBSetID',
        'AllocationAndRetentionPriority',
        'AlternativeQoSParaSetList',
        'AlternativeQoSParaSetItem',
        'AngleMeasurementQuality',
        'AperiodicSRSResourceTriggerList',
        'AperiodicSRSResourceTrigger',
        'Associated-SCell-Item',
        'AvailablePLMNList',
        'AvailablePLMNList-Item',
        'AvailableSNPN-ID-List',
        'AvailableSNPN-ID-List-Item',
        'AveragingWindow',
        'AreaScope',
        'AoA-AssistanceInfo',
        'AngleMeasurementType',
        'AppLayerBufferLevelList',
        'ARP-ID',
        'ARPLocationInformation',
        'ARPLocationInformation-Item',
        'ARPLocationType',
        'BAP-Header-Rewriting-Added-List-Item',
        'BAP-Header-Rewriting-Removed-List-Item',
        'BandwidthSRS',
        'BAPAddress',
        'BAPCtrlPDUChannel',
        'BAPlayerBHRLCchannelMappingInfo',
        'BAPlayerBHRLCchannelMappingInfoList',
        'BAPlayerBHRLCchannelMappingInfo-Item',
        'BAPPathID',
        'BAPRoutingID',
        'BCBearerContextF1U-TNLInfo',
        'BitRate',
        'BearerTypeChange',
        'BHRLCChannelID',
        'BHChannels-FailedToBeModified-Item',
        'BHChannels-FailedToBeSetup-Item',
        'BHChannels-FailedToBeSetupMod-Item',
        'BHChannels-Modified-Item',
        'BHChannels-Required-ToBeReleased-Item',
        'BHChannels-Setup-Item',
        'BHChannels-SetupMod-Item',
        'BHChannels-ToBeModified-Item',
        'BHChannels-ToBeReleased-Item',
        'BHChannels-ToBeSetup-Item',
        'BHChannels-ToBeSetupMod-Item',
        'BHInfo',
        'BHQoSInformation',
        'BHRLCCHList',
        'BHRLCCHItem',
        'BH-Routing-Information-Added-List-Item',
        'BH-Routing-Information-Removed-List-Item',
        'BPLMN-ID-Info-List',
        'BPLMN-ID-Info-Item',
        'ServedPLMNs-List',
        'ServedPLMNs-Item',
        'BroadcastCAGList',
        'BroadcastMRBs-FailedToBeModified-Item',
        'BroadcastMRBs-FailedToBeSetup-Item',
        'BroadcastMRBs-FailedToBeSetupMod-Item',
        'BroadcastMRBs-Modified-Item',
        'BroadcastMRBs-Setup-Item',
        'BroadcastMRBs-SetupMod-Item',
        'BroadcastMRBs-ToBeModified-Item',
        'BroadcastMRBs-ToBeReleased-Item',
        'BroadcastMRBs-ToBeSetup-Item',
        'BroadcastMRBs-ToBeSetupMod-Item',
        'BroadcastNIDList',
        'BroadcastSNPN-ID-List',
        'BroadcastSNPN-ID-List-Item',
        'BroadcastPNI-NPN-ID-List',
        'BroadcastPNI-NPN-ID-List-Item',
        'BroadcastAreaScope',
        'BroadcastCellList',
        'Broadcast-Cell-List-Item',
        'BufferSizeThresh',
        'BurstArrivalTime',
        'CAGID',
        'Cancel-all-Warning-Messages-Indicator',
        'Candidate-SpCell-Item',
        'CapacityValue',
        'Cause',
        'CauseMisc',
        'CauseProtocol',
        'CauseRadioNetwork',
        'CauseTransport',
        'CellGroupConfig',
        'CellCapacityClassValue',
        'Cell-Direction',
        'CellMeasurementResultList',
        'CellMeasurementResultItem',
        'Cell-Portion-ID',
        'CellsForSON-List',
        'CellsForSON-Item',
        'Cells-Failed-to-be-Activated-List-Item',
        'Cells-Status-Item',
        'Cells-To-Be-Broadcast-Item',
        'Cells-Broadcast-Completed-Item',
        'Broadcast-To-Be-Cancelled-Item',
        'Cells-Broadcast-Cancelled-Item',
        'Cells-to-be-Activated-List-Item',
        'Cells-to-be-Deactivated-List-Item',
        'Cells-to-be-Barred-Item',
        'CellBarred',
        'CellSize',
        'CellToReportList',
        'CellToReportItem',
        'CellType',
        'CellULConfigured',
        'CG-SDTQueryIndication',
        'CG-SDTKeptIndicator',
        'CG-SDTindicatorSetup',
        'CG-SDTindicatorMod',
        'CG-SDTSessionInfo',
        'ChannelOccupancyTimePercentage',
        'Child-IAB-Nodes-NA-Resource-List',
        'Child-IAB-Nodes-NA-Resource-List-Item',
        'Child-Node-Cells-List',
        'Child-Node-Cells-List-Item',
        'Child-Nodes-List',
        'Child-Nodes-List-Item',
        'CHOtrigger-InterDU',
        'CHOtrigger-IntraDU',
        'CNSubgroupID',
        'CNUEPagingIdentity',
        'CompositeAvailableCapacityGroup',
        'CompositeAvailableCapacity',
        'CHO-Probability',
        'ConditionalInterDUMobilityInformation',
        'ConditionalIntraDUMobilityInformation',
        'ConfigRestrictInfoDAPS',
        'ConfiguredTACIndication',
        'CoordinateID',
        'Coverage-Modification-Notification',
        'Coverage-Modification-List',
        'Coverage-Modification-Item',
        'CellCoverageState',
        'CCO-Assistance-Information',
        'CCO-issue-detection',
        'CP-TransportLayerAddress',
        'CPACMCGInformation',
        'CPAC-trigger',
        'CPTrafficType',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-IE-List',
        'CriticalityDiagnostics-IE-Item',
        'C-RNTI',
        'CUDURadioInformationType',
        'CUDURIMInformation',
        'CUtoDURRCInformation',
        'DAPS-HO-Status',
        'DCBasedDuplicationConfigured',
        'Dedicated-SIDelivery-NeededUE-Item',
        'DL-PRS',
        'DL-PRSMutingPattern',
        'DLPRSResourceCoordinates',
        'DLPRSResourceSetARP',
        'DL-PRSResourceSetARPLocation',
        'DLPRSResourceARP',
        'DL-PRSResourceARPLocation',
        'DL-UP-TNL-Address-to-Update-List-Item',
        'DLUPTNLInformation-ToBeSetup-List',
        'DLUPTNLInformation-ToBeSetup-Item',
        'DRB-Activity-Item',
        'DRB-Activity',
        'DRBID',
        'DRBs-FailedToBeModified-Item',
        'DRBs-FailedToBeSetup-Item',
        'DRBs-FailedToBeSetupMod-Item',
        'DRB-Information',
        'DRBs-Modified-Item',
        'DRBs-ModifiedConf-Item',
        'DRB-Notify-Item',
        'DRBs-Required-ToBeModified-Item',
        'DRBs-Required-ToBeReleased-Item',
        'DRBs-Setup-Item',
        'DRBs-SetupMod-Item',
        'DRBs-ToBeModified-Item',
        'DRBs-ToBeReleased-Item',
        'DRBs-ToBeSetup-Item',
        'DRBs-ToBeSetupMod-Item',
        'DRXCycle',
        'DRX-Config',
        'DRXConfigurationIndicator',
        'DRX-LongCycleStartOffset',
        'DSInformationList',
        'DSCP',
        'DUtoCURRCContainer',
        'DUCURadioInformationType',
        'DUCURIMInformation',
        'DUF-Slot-Config-Item',
        'DUF-Slot-Config-List',
        'DUFSlotformatIndex',
        'DUFTransmissionPeriodicity',
        'DU-RX-MT-RX',
        'DU-TX-MT-TX',
        'DU-RX-MT-TX',
        'DU-TX-MT-RX',
        'DU-RX-MT-RX-Extend',
        'DU-TX-MT-TX-Extend',
        'DU-RX-MT-TX-Extend',
        'DU-TX-MT-RX-Extend',
        'DUtoCURRCInformation',
        'DuplicationActivation',
        'DuplicationIndication',
        'DuplicationState',
        'Dynamic5QIDescriptor',
        'DynamicPQIDescriptor',
        'E-CID-MeasurementQuantities',
        'E-CID-MeasurementQuantities-Item',
        'E-CID-MeasurementQuantitiesValue',
        'E-CID-MeasurementResult',
        'E-CID-MeasuredResults-List',
        'E-CID-MeasuredResults-Item',
        'E-CID-MeasuredResults-Value',
        'E-CID-ReportCharacteristics',
        'EgressBHRLCCHList',
        'EgressBHRLCCHItem',
        'EgressNonF1terminatingTopologyIndicator',
        'Endpoint-IP-address-and-port',
        'EnergyDetectionThreshold',
        'ExtendedAvailablePLMN-List',
        'ExtendedAvailablePLMN-Item',
        'ExplicitFormat',
        'ExtendedServedPLMNs-List',
        'ExtendedServedPLMNs-Item',
        'ExtendedSliceSupportList',
        'ExtendedUEIdentityIndexValue',
        'EUTRACells-List',
        'EUTRACells-List-item',
        'EUTRA-Cell-ID',
        'EUTRA-Coex-FDD-Info',
        'EUTRA-Coex-Mode-Info',
        'EUTRA-Coex-TDD-Info',
        'EUTRA-CyclicPrefixDL',
        'EUTRA-CyclicPrefixUL',
        'EUTRA-PRACH-Configuration',
        'EUTRA-SpecialSubframe-Info',
        'EUTRA-SpecialSubframePatterns',
        'EUTRA-SubframeAssignment',
        'EUTRA-Transmission-Bandwidth',
        'EUTRANQoS',
        'ExecuteDuplication',
        'ExtendedEARFCN',
        'EUTRA-Mode-Info',
        'EUTRA-NR-CellResourceCoordinationReq-Container',
        'EUTRA-NR-CellResourceCoordinationReqAck-Container',
        'EUTRA-FDD-Info',
        'EUTRA-TDD-Info',
        'EventType',
        'ExtendedPacketDelayBudget',
        'Expected-UL-AoA',
        'Expected-ZoA-only',
        'Expected-Azimuth-AoA',
        'Expected-Zenith-AoA',
        'Expected-Value-AoA',
        'Expected-Value-ZoA',
        'F1CPathNSA',
        'F1CTransferPath',
        'F1CPathNRDC',
        'F1CTransferPathNRDC',
        'FDD-Info',
        'FDD-InfoRel16',
        'FiveG-ProSeAuthorized',
        'FiveG-ProSeDirectDiscovery',
        'FiveG-ProSeDirectCommunication',
        'FiveG-ProSeLayer2UEtoNetworkRelay',
        'FiveG-ProSeLayer3UEtoNetworkRelay',
        'FiveG-ProSeLayer2RemoteUE',
        'Flows-Mapped-To-DRB-List',
        'Flows-Mapped-To-DRB-Item',
        'FR1-Bandwidth',
        'FR2-Bandwidth',
        'FreqBandNrItem',
        'FreqDomainLength',
        'FreqInfoRel16',
        'FrequencyShift7p5khz',
        'Frequency-Domain-HSNA-Configuration-List',
        'Frequency-Domain-HSNA-Configuration-Item',
        'Frequency-Domain-HSNA-Slot-Configuration-List',
        'Frequency-Domain-HSNA-Slot-Configuration-Item',
        'FullConfiguration',
        'FlowsMappedToSLDRB-List',
        'FlowsMappedToSLDRB-Item',
        'GBR-QosInformation',
        'GBR-QoSFlowInformation',
        'CG-Config',
        'GeographicalCoordinates',
        'GNB-CU-MBS-F1AP-ID',
        'GNBCUMeasurementID',
        'GNBDUMeasurementID',
        'GNB-CUSystemInformation',
        'GNB-CU-TNL-Association-Setup-Item',
        'GNB-CU-TNL-Association-Failed-To-Setup-Item',
        'GNB-CU-TNL-Association-To-Add-Item',
        'GNB-CU-TNL-Association-To-Remove-Item',
        'GNB-CU-TNL-Association-To-Update-Item',
        'GNB-CU-UE-F1AP-ID',
        'GNB-DU-Cell-Resource-Configuration',
        'GNB-DU-MBS-F1AP-ID',
        'GNB-DU-UE-F1AP-ID',
        'GNB-DU-ID',
        'GNB-CU-Name',
        'GNB-DU-Name',
        'Extended-GNB-CU-Name',
        'GNB-CU-NameVisibleString',
        'GNB-CU-NameUTF8String',
        'Extended-GNB-DU-Name',
        'GNB-DU-NameVisibleString',
        'GNB-DU-NameUTF8String',
        'GNB-DU-Served-Cells-Item',
        'GNB-DU-System-Information',
        'GNB-DUConfigurationQuery',
        'GNBDUOverloadInformation',
        'GNB-DU-TNL-Association-To-Remove-Item',
        'GNBDUUESliceMaximumBitRateList',
        'GNBDUUESliceMaximumBitRateItem',
        'GNB-RxTxTimeDiff',
        'GNBRxTxTimeDiffMeas',
        'GNBSetID',
        'GTP-TEID',
        'GTPTLAs',
        'GTPTLA-Item',
        'GTPTunnel',
        'HandoverPreparationInformation',
        'HardwareLoadIndicator',
        'HSNASlotConfigList',
        'HSNASlotConfigItem',
        'HSNADownlink',
        'HSNAFlexible',
        'HSNAUplink',
        'HSNATransmissionPeriodicity',
        'IAB-Barred',
        'IABConditionalRRCMessageDeliveryIndication',
        'IABCongestionIndication',
        'IAB-Congestion-Indication-List',
        'IAB-Congestion-Indication-Item',
        'IAB-Info-IAB-donor-CU',
        'IAB-Info-IAB-DU',
        'IAB-MT-Cell-List',
        'IAB-MT-Cell-List-Item',
        'IAB-MT-Cell-NA-Resource-Configuration-Mode-Info',
        'IAB-MT-Cell-NA-Resource-Configuration-FDD-Info',
        'IAB-MT-Cell-NA-Resource-Configuration-TDD-Info',
        'IAB-STC-Info',
        'IAB-STC-Info-List',
        'IAB-STC-Info-Item',
        'IAB-Allocated-TNL-Address-Item',
        'IAB-DU-Cell-Resource-Configuration-Mode-Info',
        'IAB-DU-Cell-Resource-Configuration-FDD-Info',
        'IAB-DU-Cell-Resource-Configuration-TDD-Info',
        'IABIPv6RequestType',
        'IABTNLAddress',
        'IABTNLAddressesRequested',
        'IAB-TNL-Addresses-To-Remove-Item',
        'IAB-TNL-Addresses-Exception',
        'IABTNLAddressList',
        'IABTNLAddress-Item',
        'IABTNLAddressUsage',
        'IABv4AddressesRequested',
        'ImplicitFormat',
        'IgnorePRACHConfiguration',
        'IgnoreResourceCoordinationContainer',
        'InactivityMonitoringRequest',
        'InactivityMonitoringResponse',
        'InterfacesToTrace',
        'IntendedTDD-DL-ULConfig',
        'InterFrequencyConfig-NoGap',
        'IngressNonF1terminatingTopologyIndicator',
        'IPHeaderInformation',
        'IPtolayer2TrafficMappingInfo',
        'IPtolayer2TrafficMappingInfoList',
        'IPtolayer2TrafficMappingInfo-Item',
        'L139Info',
        'L839Info',
        'L571Info',
        'L1151Info',
        'LastUsedCellIndication',
        'LCID',
        'LCS-to-GCS-Translation',
        'LCStoGCSTranslationList',
        'LCStoGCSTranslation',
        'LMF-MeasurementID',
        'LMF-UE-MeasurementID',
        'LocationDependentMBSF1UInformation',
        'LocationDependentMBSF1UInformation-Item',
        'LocationMeasurementInformation',
        'LocationUncertainty',
        'LongDRXCycleLength',
        'LowerLayerPresenceStatusChange',
        'LoS-NLoSIndicatorHard',
        'LoS-NLoSIndicatorSoft',
        'LoS-NLoSInformation',
        'LTEUESidelinkAggregateMaximumBitrate',
        'LTEV2XServicesAuthorized',
        'MappingInformationIndex',
        'MappingInformationtoRemove',
        'MaskedIMEISV',
        'MaxDataBurstVolume',
        'MaxPacketLossRate',
        'MBS-Broadcast-NeighbourCellList',
        'MBS-Flows-Mapped-To-MRB-List',
        'MBS-Flows-Mapped-To-MRB-Item',
        'MBSF1UInformation',
        'MBSInterestIndication',
        'MBS-Session-ID',
        'MBS-Area-Session-ID',
        'MBS-CUtoDURRCInformation',
        'MBS-Broadcast-Cell-List',
        'MBS-Broadcast-Cell-Item',
        'MBS-Broadcast-MRB-List',
        'MBS-Broadcast-MRB-Item',
        'MBSMulticastF1UContextDescriptor',
        'MulticastF1UContext-ToBeSetup-Item',
        'MulticastF1UContext-Setup-Item',
        'MulticastF1UContext-FailedToBeSetup-Item',
        'MBSPTPRetransmissionTunnelRequired',
        'MBS-ServiceArea',
        'MBS-ServiceAreaInformation',
        'MBS-ServiceAreaCellList',
        'MBS-ServiceAreaTAIList',
        'MBS-ServiceAreaTAIList-Item',
        'MBS-ServiceAreaInformationList',
        'MBS-ServiceAreaInformationItem',
        'MC-PagingCell-Item',
        'MIB-message',
        'MeasConfig',
        'MeasGapConfig',
        'MeasGapSharingConfig',
        'PosMeasurementAmount',
        'MeasurementBeamInfoRequest',
        'MeasurementBeamInfo',
        'MeasurementTimingConfiguration',
        'MessageIdentifier',
        'MeasurementTimeOccasion',
        'MeasurementCharacteristicsRequestIndicator',
        'MRB-ProgressInformation',
        'MulticastF1UContextReferenceF1',
        'MulticastF1UContextReferenceCU',
        'MultipleULAoA',
        'MultipleULAoA-List',
        'MultipleULAoA-Item',
        'MDTPollutedMeasurementIndicator',
        'MRB-ID',
        'MulticastMBSSessionList',
        'MulticastMBSSessionList-Item',
        'MulticastMRBs-FailedToBeModified-Item',
        'MulticastMRBs-FailedToBeSetup-Item',
        'MulticastMRBs-FailedToBeSetupMod-Item',
        'MulticastMRBs-Modified-Item',
        'MulticastMRBs-Setup-Item',
        'MulticastMRBs-SetupMod-Item',
        'MulticastMRBs-ToBeModified-Item',
        'MulticastMRBs-ToBeReleased-Item',
        'MulticastMRBs-ToBeSetup-Item',
        'MulticastMRBs-ToBeSetupMod-Item',
        'MultiplexingInfo',
        'M2Configuration',
        'M5Configuration',
        'M5period',
        'M5ReportAmount',
        'M5-Links-to-log',
        'M6Configuration',
        'M6report-Interval',
        'M6ReportAmount',
        'M6-Links-to-log',
        'M7Configuration',
        'M7period',
        'M7ReportAmount',
        'M7-Links-to-log',
        'MDT-Activation',
        'MDTConfiguration',
        'MDTPLMNList',
        'MDTPLMNModificationList',
        'MeasuredResultsValue',
        'MeasurementsToActivate',
        'MUSIM-GapConfig',
        'NA-Resource-Configuration-List',
        'NA-Resource-Configuration-Item',
        'NADownlink',
        'NAFlexible',
        'NAUplink',
        'Neighbour-Node-Cells-List',
        'Neighbour-Node-Cells-List-Item',
        'NeedforGap',
        'NeedForGapsInfoNR',
        'NeedForGapNCSGInfoNR',
        'NeedForGapNCSGInfoEUTRA',
        'Neighbour-Cell-Information-Item',
        'NeighbourNR-CellsForSON-List',
        'NeighbourNR-CellsForSON-Item',
        'NGRANAllocationAndRetentionPriority',
        'NGRANHighAccuracyAccessPointPosition',
        'NID',
        'NonF1terminatingTopologyIndicator',
        'NR-CGI-List-For-Restart-Item',
        'NR-PRSBeamInformation',
        'NR-PRSBeamInformationList',
        'NR-PRSBeamInformationItem',
        'NR-TADV',
        'NRRedCapUEIndication',
        'NRPagingeDRXInformation',
        'NRPaging-eDRX-Cycle-Idle',
        'NRPaging-Time-Window',
        'NRPagingeDRXInformationforRRCINACTIVE',
        'NRPaging-eDRX-Cycle-Inactive',
        'NonDynamic5QIDescriptor',
        'NonDynamicPQIDescriptor',
        'NonUPTrafficType',
        'NoofDownlinkSymbols',
        'NoofUplinkSymbols',
        'Notification-Cause',
        'NotificationControl',
        'NotificationInformation',
        'NPNBroadcastInformation',
        'NPN-Broadcast-Information-SNPN',
        'NPN-Broadcast-Information-PNI-NPN',
        'NPNSupportInfo',
        'NRCarrierList',
        'NRCarrierItem',
        'NRFreqInfo',
        'NRCGI',
        'NR-Mode-Info',
        'NR-ModeInfoRel16',
        'NRPRACHConfig',
        'NRCellIdentity',
        'NRNRB',
        'NRPCI',
        'NRPRACHConfigList',
        'NRPRACHConfigItem',
        'NRSCS',
        'NRUERLFReportContainer',
        'NR-U-Channel-Info-List',
        'NR-U-Channel-Info-Item',
        'NR-U-Channel-List',
        'NR-U-Channel-Item',
        'NumberofActiveUEs',
        'NumberOfBroadcasts',
        'NumberofBroadcastRequest',
        'NumberOfTRPRxTEG',
        'NumberOfTRPRxTxTEG',
        'NumDLULSymbols',
        'NRV2XServicesAuthorized',
        'NRUESidelinkAggregateMaximumBitrate',
        'NZP-CSI-RS-ResourceID',
        'OffsetToPointA',
        'OnDemandPRS-Info',
        'PacketDelayBudget',
        'PacketErrorRate',
        'PER-Scalar',
        'PER-Exponent',
        'PagingCell-Item',
        'PagingDRX',
        'PagingIdentity',
        'PagingCause',
        'PagingOrigin',
        'PagingPriority',
        'PEIPSAssistanceInfo',
        'RelativePathDelay',
        'Parent-IAB-Nodes-NA-Resource-Configuration-List',
        'Parent-IAB-Nodes-NA-Resource-Configuration-Item',
        'PartialSuccessCell',
        'PathlossReferenceInfo',
        'PathlossReferenceSignal',
        'PathSwitchConfiguration',
        'PC5QoSFlowIdentifier',
        'PC5-QoS-Characteristics',
        'PC5QoSParameters',
        'PC5FlowBitRates',
        'PC5RLCChannelID',
        'PC5RLCChannelQoSInformation',
        'PC5RLCChannelToBeSetupList',
        'PC5RLCChannelToBeSetupItem',
        'PC5RLCChannelToBeModifiedList',
        'PC5RLCChannelToBeModifiedItem',
        'PC5RLCChannelToBeReleasedList',
        'PC5RLCChannelToBeReleasedItem',
        'PC5RLCChannelSetupList',
        'PC5RLCChannelSetupItem',
        'PC5RLCChannelFailedToBeSetupList',
        'PC5RLCChannelFailedToBeSetupItem',
        'PC5RLCChannelModifiedList',
        'PC5RLCChannelModifiedItem',
        'PC5RLCChannelFailedToBeModifiedList',
        'PC5RLCChannelFailedToBeModifiedItem',
        'PC5RLCChannelRequiredToBeModifiedList',
        'PC5RLCChannelRequiredToBeModifiedItem',
        'PC5RLCChannelRequiredToBeReleasedList',
        'PC5RLCChannelRequiredToBeReleasedItem',
        'PDCCH-BlindDetectionSCG',
        'PDCMeasurementPeriodicity',
        'PDCMeasurementQuantities',
        'PDCMeasurementQuantities-Item',
        'PDCMeasurementQuantitiesValue',
        'PDCMeasurementResult',
        'PDCMeasuredResultsList',
        'PDCMeasuredResults-Item',
        'PDCMeasuredResults-Value',
        'PDCReportType',
        'PDC-RxTxTimeDiff',
        'PDC-TADV-NR',
        'PDCP-SN',
        'PDCPSNLength',
        'PDUSessionID',
        'PEISubgroupingSupportIndication',
        'ReportingPeriodicityValue',
        'Periodicity',
        'PeriodicitySRS',
        'PeriodicityList',
        'PeriodicityList-Item',
        'Permutation',
        'Ph-InfoMCG',
        'Ph-InfoSCG',
        'PLMN-Identity',
        'PlayoutDelayForMediaStartup',
        'PortNumber',
        'PosAssistance-Information',
        'PosAssistanceInformationFailureList',
        'PosBroadcast',
        'PosConextRevIndication',
        'PositioningBroadcastCells',
        'PosMeasGapPreConfigList',
        'MeasurementPeriodicity',
        'MeasurementPeriodicityExtended',
        'PosMeasurementPeriodicityNR-AoA',
        'PosMeasurementQuantities',
        'PosMeasurementQuantities-Item',
        'PosMeasurementResult',
        'PosMeasurementResultItem',
        'PosMeasurementResultList',
        'PosMeasurementResultList-Item',
        'PosMeasurementType',
        'PosReportCharacteristics',
        'PosResourceSetType',
        'PosResourceSetTypePR',
        'PosResourceSetTypeSP',
        'PosResourceSetTypeAP',
        'PosSItypeList',
        'PosSItype-Item',
        'PosSItype',
        'PosSRSResourceID-List',
        'PosSRSResource-Item',
        'PosSRSResource-List',
        'PosSRSResourceSet-Item',
        'PosSRSResourceSet-List',
        'PrimaryPathIndication',
        'Pre-emptionCapability',
        'Pre-emptionVulnerability',
        'PriorityLevel',
        'ProtectedEUTRAResourceIndication',
        'Protected-EUTRA-Resources-Item',
        'PRSConfiguration',
        'PRSInformationPos',
        'PRS-Measurement-Info-List',
        'PRS-Measurement-Info-List-Item',
        'Potential-SpCell-Item',
        'PRSAngleList',
        'PRSAngleItem',
        'PRSConfigRequestType',
        'PRSMuting',
        'PRSMutingOption1',
        'PRSMutingOption2',
        'PRS-Resource-ID',
        'PRSResource-List',
        'PRSResource-Item',
        'PRSResource-QCLInfo',
        'PRSResource-QCLSourceSSB',
        'PRSResource-QCLSourcePRS',
        'PRS-Resource-Set-ID',
        'PRSResourceSet-List',
        'PRSResourceSet-Item',
        'PRSTransmissionOffIndication',
        'PRSTransmissionOffPerResource',
        'PRSTransmissionOffPerResource-Item',
        'PRSTransmissionOffIndicationPerResource-Item',
        'PRSTransmissionOffInformation',
        'PRSTransmissionOffPerResourceSet',
        'PRSTransmissionOffPerResourceSet-Item',
        'PWS-Failed-NR-CGI-Item',
        'PWSSystemInformation',
        'PrivacyIndicator',
        'PRS-ID',
        'PRSTRPList',
        'PRSTRPItem',
        'RequestedDLPRSTransmissionCharacteristics',
        'RequestedDLPRSResourceSet-List',
        'RequestedDLPRSResourceSet-Item',
        'RequestedDLPRSResource-List',
        'RequestedDLPRSResource-Item',
        'PRSTransmissionTRPList',
        'PRSTransmissionTRPItem',
        'QCI',
        'QoEInformation',
        'QoEInformationList',
        'QoEInformationList-Item',
        'QoEMetrics',
        'QoS-Characteristics',
        'QoSFlowIdentifier',
        'QoSFlowLevelQoSParameters',
        'QoSFlowMappingIndication',
        'QoSInformation',
        'QosMonitoringRequest',
        'QoSParaSetIndex',
        'QoSParaSetNotifyIndex',
        'RACH-Config-Common',
        'RACH-Config-Common-IAB',
        'RACHReportContainer',
        'RACHReportInformationList',
        'RACHReportInformationItem',
        'RadioResourceStatus',
        'MIMOPRBusageInformation',
        'RANAC',
        'RAN-MeasurementID',
        'RAN-UE-MeasurementID',
        'RAN-UE-PDC-MeasID',
        'RANUEID',
        'RANUEPagingIdentity',
        'RAT-FrequencyPriorityInformation',
        'RAT-FrequencySelectionPriority',
        'RBSetConfiguration',
        'RBSetSize',
        'Re-routingEnableIndicator',
        'Redcap-Bcast-Information',
        'RedCapIndication',
        'Reestablishment-Indication',
        'ReferencePoint',
        'ReferenceSFN',
        'ReferenceSignal',
        'RelativeCartesianLocation',
        'RelativeGeodeticLocation',
        'RemoteUELocalID',
        'ReferenceTime',
        'RegistrationRequest',
        'ReportCharacteristics',
        'ReportingPeriodicity',
        'RequestedBandCombinationIndex',
        'RequestedFeatureSetEntryIndex',
        'RequestedP-MaxFR2',
        'Requested-PDCCH-BlindDetectionSCG',
        'RequestedSRSTransmissionCharacteristics',
        'RequestType',
        'ResourceCoordinationEUTRACellInfo',
        'ResourceCoordinationTransferInformation',
        'ResourceCoordinationTransferContainer',
        'ResourceSetType',
        'ResourceSetTypePeriodic',
        'ResourceSetTypeSemi-persistent',
        'ResourceSetTypeAperiodic',
        'RepetitionPeriod',
        'ReportingRequestType',
        'ResourceType',
        'ResourceTypePeriodic',
        'ResourceTypeSemi-persistent',
        'ResourceTypeAperiodic',
        'ResourceTypePos',
        'ResourceTypePeriodicPos',
        'ResourceTypeSemi-persistentPos',
        'ResourceTypeAperiodicPos',
        'RLCDuplicationInformation',
        'RLCDuplicationStateList',
        'RLCDuplicationState-Item',
        'RLCFailureIndication',
        'RLCMode',
        'RLC-Status',
        'RLFReportInformationList',
        'RLFReportInformationItem',
        'RIMRSDetectionStatus',
        'RRCContainer',
        'RRCContainer-RRCSetupComplete',
        'RRCDeliveryStatus',
        'RRCDeliveryStatusRequest',
        'RRCReconfigurationCompleteIndicator',
        'RRC-Version',
        'RoutingID',
        'ResponseTime',
        'RxTxTimingErrorMargin',
        'SCell-FailedtoSetup-Item',
        'SCell-FailedtoSetupMod-Item',
        'SCell-ToBeRemoved-Item',
        'SCell-ToBeSetup-Item',
        'SCell-ToBeSetupMod-Item',
        'SCellIndex',
        'SCGActivationRequest',
        'SCGActivationStatus',
        'SCGIndicator',
        'SCS-480',
        'SCS-960',
        'SCS-SpecificCarrier',
        'SDTBearerConfigurationQueryIndication',
        'SDTBearerConfigurationInfo',
        'SDTBearerConfig-List',
        'SDTBearerConfig-List-Item',
        'SDTBearerType',
        'SDT-MAC-PHY-CG-Config',
        'SDTInformation',
        'SDTRLCBearerConfiguration',
        'SDT-Termination-Request',
        'Search-window-information',
        'SerialNumber',
        'SIBType-PWS',
        'SelectedBandCombinationIndex',
        'SelectedFeatureSetEntryIndex',
        'CG-ConfigInfo',
        'ServCellIndex',
        'ServingCellMO',
        'ServingCellMO-List-Item',
        'ServingCellMO-encoded-in-CGC-List',
        'ServingCellMO-encoded-in-CGC-Item',
        'Served-Cell-Information',
        'Serving-Cells-List',
        'Serving-Cells-List-Item',
        'Supported-MBS-FSA-ID-List',
        'MBS-FrequencySelectionArea-Identity',
        'SFN-Offset',
        'Served-Cells-To-Add-Item',
        'Served-Cells-To-Delete-Item',
        'Served-Cells-To-Modify-Item',
        'Served-EUTRA-Cells-Information',
        'Service-State',
        'Service-Status',
        'RelativeTime1900',
        'ShortDRXCycleLength',
        'ShortDRXCycleTimer',
        'SIB1-message',
        'SIB10-message',
        'SIB12-message',
        'SIB13-message',
        'SIB14-message',
        'SIB15-message',
        'SIB17-message',
        'SIB20-message',
        'SItype',
        'SItype-List',
        'SItype-Item',
        'SibtypetobeupdatedListItem',
        'SidelinkRelayConfiguration',
        'SidelinkConfigurationContainer',
        'SLDRBID',
        'SLDRBInformation',
        'SLDRBs-FailedToBeModified-Item',
        'SLDRBs-FailedToBeSetup-Item',
        'SLDRBs-FailedToBeSetupMod-Item',
        'SLDRBs-Modified-Item',
        'SLDRBs-ModifiedConf-Item',
        'SLDRBs-Required-ToBeModified-Item',
        'SLDRBs-Required-ToBeReleased-Item',
        'SLDRBs-Setup-Item',
        'SLDRBs-SetupMod-Item',
        'SLDRBs-ToBeModified-Item',
        'SLDRBs-ToBeReleased-Item',
        'SLDRBs-ToBeSetup-Item',
        'SLDRBs-ToBeSetupMod-Item',
        'SLDRXCycleList',
        'SLDRXCycleItem',
        'SLDRXInformation',
        'SLDRXCycleLength',
        'SLDRXConfigurationIndicator',
        'SL-PHY-MAC-RLC-Config',
        'SL-RLC-ChannelToAddModList',
        'SL-ConfigDedicatedEUTRA-Info',
        'SliceAvailableCapacity',
        'SliceAvailableCapacityList',
        'SliceAvailableCapacityItem',
        'SNSSAIAvailableCapacity-List',
        'SNSSAIAvailableCapacity-Item',
        'SliceRadioResourceStatus',
        'SliceRadioResourceStatus-List',
        'SliceRadioResourceStatus-Item',
        'SNSSAIRadioResourceStatus-List',
        'SNSSAIRadioResourceStatus-Item',
        'SliceSupportList',
        'SliceSupportItem',
        'SliceToReportList',
        'SliceToReportItem',
        'SlotNumber',
        'SNSSAI-list',
        'SNSSAI-Item',
        'Slot-Configuration-List',
        'Slot-Configuration-Item',
        'SNSSAI',
        'SpatialDirectionInformation',
        'SpatialRelationInfo',
        'SpatialRelationforResourceID',
        'SpatialRelationforResourceIDItem',
        'SpatialRelationPerSRSResource',
        'SpatialRelationPerSRSResource-List',
        'SpatialRelationPerSRSResourceItem',
        'SpatialRelationPos',
        'SpectrumSharingGroupID',
        'SRBID',
        'SRBs-FailedToBeSetup-Item',
        'SRBs-FailedToBeSetupMod-Item',
        'SRBs-Modified-Item',
        'SRBs-Required-ToBeReleased-Item',
        'SRBs-Setup-Item',
        'SRBs-SetupMod-Item',
        'SRBs-ToBeReleased-Item',
        'SRBs-ToBeSetup-Item',
        'SRBs-ToBeSetupMod-Item',
        'SRSCarrier-List',
        'SRSCarrier-List-Item',
        'SRSConfig',
        'SRSConfiguration',
        'SrsFrequency',
        'SRSPortIndex',
        'SRSPosResourceID',
        'SRSResource',
        'SRSResourceID',
        'SRSResourceID-List',
        'SRSResource-List',
        'SRSResourceSet',
        'SRSResourceSetID',
        'SRSResourceSetList',
        'SRSResourceSetItem',
        'SRSResourceSet-List',
        'SRSResourceTrigger',
        'SRSResourcetype',
        'SRSResourceTypeChoice',
        'SRSInfo',
        'SRSPosRRCInactiveConfig',
        'SRSPosRRCInactiveQueryIndication',
        'PosSRSInfo',
        'SSB',
        'SSBCoverageModification-List',
        'SSBCoverageModification-Item',
        'SSBCoverageState',
        'SSB-freqInfo',
        'SSB-Index',
        'SSB-subcarrierSpacing',
        'SSB-transmissionPeriodicity',
        'SSB-transmissionTimingOffset',
        'SSB-transmissionBitmap',
        'SSBAreaCapacityValueList',
        'SSBAreaCapacityValueItem',
        'SSBAreaRadioResourceStatusList',
        'SSBAreaRadioResourceStatusItem',
        'SSBInformation',
        'SSBInformationList',
        'SSBInformationItem',
        'SSB-PositionsInBurst',
        'SSB-TF-Configuration',
        'SSBToReportList',
        'SSBToReportItem',
        'StartTimeAndDuration',
        'SUL-Information',
        'SubcarrierSpacing',
        'SubscriberProfileIDforRFP',
        'SuccessfulHOReportInformationList',
        'SuccessfulHOReportInformation-Item',
        'SULAccessIndication',
        'SupportedSULFreqBandItem',
        'SurvivalTime',
        'SymbolAllocInSlot',
        'SystemFrameNumber',
        'SystemInformationAreaID',
        'FiveGS-TAC',
        'Configured-EPS-TAC',
        'TargetCellList',
        'TargetCellList-Item',
        'NSAGSupportList',
        'NSAGSupportItem',
        'NSAG-ID',
        'TDD-Info',
        'TDD-InfoRel16',
        'TDD-UL-DLConfigCommonNR',
        'TRPTEGInformation',
        'RxTxTEG',
        'RxTEG',
        'TimeReferenceInformation',
        'TimeInformationType',
        'TimeStamp',
        'TimeStampSlotIndex',
        'TimeToWait',
        'TimingErrorMargin',
        'TimingMeasurementQuality',
        'TMGI',
        'TNLAssociationUsage',
        'TNLCapacityIndicator',
        'TraceActivation',
        'TraceDepth',
        'TraceID',
        'TrafficMappingInfo',
        'TransportLayerAddress',
        'TransactionID',
        'Transmission-Bandwidth',
        'TransmissionComb',
        'TransmissionCombPos',
        'TransmissionStopIndicator',
        'Transport-UP-Layer-Address-Info-To-Add-List',
        'Transport-UP-Layer-Address-Info-To-Add-Item',
        'Transport-UP-Layer-Address-Info-To-Remove-List',
        'Transport-UP-Layer-Address-Info-To-Remove-Item',
        'TransmissionActionIndicator',
        'TRPBeamAntennaInformation',
        'Choice-TRP-Beam-Antenna-Info-Item',
        'TRP-BeamAntennaExplicitInformation',
        'TRP-BeamAntennaAngles',
        'TRP-BeamAntennaAnglesList-Item',
        'TRP-ElevationAngleList-Item',
        'TRP-Beam-Power-Item',
        'TRPID',
        'TRPInformation',
        'TRPInformationItem',
        'TRPInformationTypeItem',
        'TRPInformationTypeResponseList',
        'TRPInformationTypeResponseItem',
        'TRPList',
        'TRPListItem',
        'TRPMeasurementQuality',
        'TRPMeasurementQuality-Item',
        'TRP-MeasurementRequestList',
        'TRP-MeasurementRequestItem',
        'TRP-PRS-Info-List',
        'TRP-PRS-Info-List-Item',
        'TRPPositionDefinitionType',
        'TRPPositionDirect',
        'TRPPositionDirectAccuracy',
        'TRPPositionReferenced',
        'TRPReferencePointType',
        'TRP-Rx-TEGInformation',
        'TRP-RxTx-TEGInformation',
        'TRP-Tx-TEGInformation',
        'TRPTxTEGAssociation',
        'TRPTEG-Item',
        'DLPRSResourceID-Item',
        'TypeOfError',
        'Transport-Layer-Address-Info',
        'TRPType',
        'TSCAssistanceInformation',
        'TSCTrafficCharacteristics',
        'TRP-MeasurementUpdateList',
        'TRP-MeasurementUpdateItem',
        'TwoPHRModeMCG',
        'TwoPHRModeSCG',
        'UAC-Assistance-Info',
        'UACPLMN-List',
        'UACPLMN-Item',
        'UACType-List',
        'UACType-Item',
        'UACCategoryType',
        'UACOperatorDefined',
        'UACAction',
        'UACReductionIndication',
        'UE-associatedLogicalF1-ConnectionItem',
        'UEAssistanceInformation',
        'UEAssistanceInformationEUTRA',
        'UE-CapabilityRAT-ContainerList',
        'UEContextNotRetrievable',
        'UEIdentityIndexValue',
        'UEIdentity-List-For-Paging-Item',
        'UE-MulticastMRBs-ConfirmedToBeModified-Item',
        'UE-MulticastMRBs-RequiredToBeModified-Item',
        'UE-MulticastMRBs-RequiredToBeReleased-Item',
        'UE-MulticastMRBs-Setup-Item',
        'UE-MulticastMRBs-ToBeReleased-Item',
        'UE-MulticastMRBs-ToBeSetup-Item',
        'UE-MulticastMRBs-ToBeSetup-atModify-Item',
        'UEPagingCapability',
        'UEReportingInformation',
        'UlTxDirectCurrentMoreCarrierInformation',
        'UL-AoA',
        'UL-BH-Non-UP-Traffic-Mapping',
        'UL-BH-Non-UP-Traffic-Mapping-List',
        'UL-BH-Non-UP-Traffic-Mapping-Item',
        'ULConfiguration',
        'UL-GapFR2-Config',
        'UL-RTOA-Measurement',
        'UL-RTOA-MeasurementItem',
        'UL-SRS-RSRP',
        'UL-SRS-RSRPP',
        'ULUEConfiguration',
        'UL-UP-TNL-Information-to-Update-List-Item',
        'UL-UP-TNL-Address-to-Update-List-Item',
        'ULUPTNLInformation-ToBeSetup-List',
        'ULUPTNLInformation-ToBeSetup-Item',
        'Uncertainty',
        'UplinkChannelBW-PerSCS-List',
        'UplinkTxDirectCurrentListInformation',
        'UplinkTxDirectCurrentTwoCarrierListInfo',
        'UPTransportLayerInformation',
        'URI-address',
        'Uncertainty-range-AoA',
        'Uncertainty-range-ZoA',
        'UuRLCChannelID',
        'UuRLCChannelQoSInformation',
        'UuRLCChannelToBeSetupList',
        'UuRLCChannelToBeSetupItem',
        'UuRLCChannelToBeModifiedList',
        'UuRLCChannelToBeModifiedItem',
        'UuRLCChannelToBeReleasedList',
        'UuRLCChannelToBeReleasedItem',
        'UuRLCChannelSetupList',
        'UuRLCChannelSetupItem',
        'UuRLCChannelFailedToBeSetupList',
        'UuRLCChannelFailedToBeSetupItem',
        'UuRLCChannelModifiedList',
        'UuRLCChannelModifiedItem',
        'UuRLCChannelFailedToBeModifiedList',
        'UuRLCChannelFailedToBeModifiedItem',
        'UuRLCChannelRequiredToBeModifiedList',
        'UuRLCChannelRequiredToBeModifiedItem',
        'UuRLCChannelRequiredToBeReleasedList',
        'UuRLCChannelRequiredToBeReleasedItem',
        'VictimgNBSetID',
        'VehicleUE',
        'PedestrianUE',
        'ZoAInformation',
        ]
    _set_ = [
        'AbortTransmission-ExtIEs',
        'AccessPointPosition-ExtIEs',
        'Activated-Cells-to-be-Updated-List-Item-ExtIEs',
        'ActiveULBWP-ExtIEs',
        'AdditionalPath-Item-ExtIEs',
        'ExtendedAdditionalPathList-Item-ExtIEs',
        'AdditionalPDCPDuplicationTNL-ItemExtIEs',
        'AdditionalSIBMessageList-Item-ExtIEs',
        'AffectedCellsAndBeams-Item-ExtIEs',
        'AffectedSSB-Item-ExtIEs',
        'AggressorCellList-Item-ExtIEs',
        'AggressorgNBSetID-ExtIEs',
        'AllocationAndRetentionPriority-ExtIEs',
        'AlternativeQoSParaSetItem-ExtIEs',
        'AngleMeasurementQuality-ExtIEs',
        'Associated-SCell-ItemExtIEs',
        'AvailablePLMNList-Item-ExtIEs',
        'AvailableSNPN-ID-List-ItemExtIEs',
        'AoA-AssistanceInfo-ExtIEs',
        'AngleMeasurementType-ExtIEs',
        'ARPLocationInformation-ExtIEs',
        'ARPLocationType-ExtIEs',
        'BAP-Header-Rewriting-Added-List-Item-ExtIEs',
        'BAP-Header-Rewriting-Removed-List-Item-ExtIEs',
        'BandwidthSRS-ExtIEs',
        'BAPlayerBHRLCchannelMappingInfo-ExtIEs',
        'BAPlayerBHRLCchannelMappingInfo-ItemExtIEs',
        'BAPRoutingIDExtIEs',
        'BCBearerContextF1U-TNLInfo-ExtIEs',
        'BHChannels-FailedToBeModified-ItemExtIEs',
        'BHChannels-FailedToBeSetup-ItemExtIEs',
        'BHChannels-FailedToBeSetupMod-ItemExtIEs',
        'BHChannels-Modified-ItemExtIEs',
        'BHChannels-Required-ToBeReleased-ItemExtIEs',
        'BHChannels-Setup-ItemExtIEs',
        'BHChannels-SetupMod-ItemExtIEs',
        'BHChannels-ToBeModified-ItemExtIEs',
        'BHChannels-ToBeReleased-ItemExtIEs',
        'BHChannels-ToBeSetup-ItemExtIEs',
        'BHChannels-ToBeSetupMod-ItemExtIEs',
        'BHInfo-ExtIEs',
        'BHQoSInformation-ExtIEs',
        'BHRLCCHItemExtIEs',
        'BH-Routing-Information-Added-List-ItemExtIEs',
        'BH-Routing-Information-Removed-List-ItemExtIEs',
        'BPLMN-ID-Info-ItemExtIEs',
        'ServedPLMNs-ItemExtIEs',
        'BroadcastMRBs-FailedtoBeModified-Item-ExtIEs',
        'BroadcastMRBs-FailedToBeSetup-Item-ExtIEs',
        'BroadcastMRBs-FailedToBeSetupMod-Item-ExtIEs',
        'BroadcastMRBs-Modified-Item-ExtIEs',
        'BroadcastMRBs-Setup-Item-ExtIEs',
        'BroadcastMRBs-SetupMod-Item-ExtIEs',
        'BroadcastMRBs-ToBeModified-Item-ExtIEs',
        'BroadcastMRBs-ToBeReleased-ItemExtIEs',
        'BroadcastMRBs-ToBeSetup-Item-ExtIEs',
        'BroadcastMRBs-ToBeSetupMod-Item-ExtIEs',
        'BroadcastSNPN-ID-List-ItemExtIEs',
        'BroadcastPNI-NPN-ID-List-ItemExtIEs',
        'BroadcastAreaScope-ExtIEs',
        'Broadcast-Cell-List-ItemExtIEs',
        'Candidate-SpCell-ItemExtIEs',
        'CapacityValue-ExtIEs',
        'Cause-ExtIEs',
        'CellMeasurementResultItem-ExtIEs',
        'CellsForSON-Item-ExtIEs',
        'Cells-Failed-to-be-Activated-List-ItemExtIEs',
        'Cells-Status-ItemExtIEs',
        'Cells-To-Be-Broadcast-ItemExtIEs',
        'Cells-Broadcast-Completed-ItemExtIEs',
        'Broadcast-To-Be-Cancelled-ItemExtIEs',
        'Cells-Broadcast-Cancelled-ItemExtIEs',
        'Cells-to-be-Activated-List-ItemExtIEs',
        'Cells-to-be-Deactivated-List-ItemExtIEs',
        'Cells-to-be-Barred-Item-ExtIEs',
        'CellToReportItem-ExtIEs',
        'CellType-ExtIEs',
        'CG-SDTSessionInfo-ExtIEs',
        'Child-IAB-Nodes-NA-Resource-List-Item-ExtIEs',
        'Child-Node-Cells-List-Item-ExtIEs',
        'Child-Nodes-List-Item-ExtIEs',
        'CNUEPagingIdentity-ExtIEs',
        'CompositeAvailableCapacityGroup-ExtIEs',
        'CompositeAvailableCapacity-ExtIEs',
        'ConditionalInterDUMobilityInformation-ExtIEs',
        'ConditionalIntraDUMobilityInformation-ExtIEs',
        'Coverage-Modification-Notification-ExtIEs',
        'Coverage-Modification-Item-ExtIEs',
        'CCO-Assistance-Information-ExtIEs',
        'CP-TransportLayerAddress-ExtIEs',
        'CPACMCGInformation-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'CriticalityDiagnostics-IE-Item-ExtIEs',
        'CUDURadioInformationType-ExtIEs',
        'CUDURIMInformation-ExtIEs',
        'CUtoDURRCInformation-ExtIEs',
        'DedicatedSIDeliveryNeededUE-Item-ExtIEs',
        'DL-PRS-ExtIEs',
        'DL-PRSMutingPattern-ExtIEs',
        'DLPRSResourceCoordinates-ExtIEs',
        'DLPRSResourceSetARP-ExtIEs',
        'DL-PRSResourceSetARPLocation-ExtIEs',
        'DLPRSResourceARP-ExtIEs',
        'DL-PRSResourceARPLocation-ExtIEs',
        'DL-UP-TNL-Address-to-Update-List-ItemExtIEs',
        'DLUPTNLInformation-ToBeSetup-ItemExtIEs',
        'DRB-Activity-ItemExtIEs',
        'DRBs-FailedToBeModified-ItemExtIEs',
        'DRBs-FailedToBeSetup-ItemExtIEs',
        'DRBs-FailedToBeSetupMod-ItemExtIEs',
        'DRB-Information-ItemExtIEs',
        'DRBs-Modified-ItemExtIEs',
        'DRBs-ModifiedConf-ItemExtIEs',
        'DRB-Notify-ItemExtIEs',
        'DRBs-Required-ToBeModified-ItemExtIEs',
        'DRBs-Required-ToBeReleased-ItemExtIEs',
        'DRBs-Setup-ItemExtIEs',
        'DRBs-SetupMod-ItemExtIEs',
        'DRBs-ToBeModified-ItemExtIEs',
        'DRBs-ToBeReleased-ItemExtIEs',
        'DRBs-ToBeSetup-ItemExtIEs',
        'DRBs-ToBeSetupMod-ItemExtIEs',
        'DRXCycle-ExtIEs',
        'DUCURadioInformationType-ExtIEs',
        'DUCURIMInformation-ExtIEs',
        'DUF-Slot-Config-Item-ExtIEs',
        'DUtoCURRCInformation-ExtIEs',
        'Dynamic5QIDescriptor-ExtIEs',
        'DynamicPQIDescriptor-ExtIEs',
        'E-CID-MeasurementQuantities-ItemIEs',
        'E-CID-MeasurementQuantitiesValue-ExtIEs',
        'E-CID-MeasurementResult-ExtIEs',
        'E-CID-MeasuredResults-Item-ExtIEs',
        'E-CID-MeasuredResults-Value-ExtIEs',
        'EgressBHRLCCHItemExtIEs',
        'Endpoint-IP-address-and-port-ExtIEs',
        'ExplicitFormat-ExtIEs',
        'ExtendedAvailablePLMN-Item-ExtIEs',
        'ExtendedServedPLMNs-ItemExtIEs',
        'EUTRACells-List-itemExtIEs',
        'EUTRA-Coex-FDD-Info-ExtIEs',
        'EUTRA-Coex-TDD-Info-ExtIEs',
        'EUTRA-PRACH-Configuration-ExtIEs',
        'EUTRA-SpecialSubframe-Info-ExtIEs',
        'EUTRANQoS-ExtIEs',
        'EUTRA-Mode-Info-ExtIEs',
        'EUTRA-FDD-Info-ExtIEs',
        'EUTRA-TDD-Info-ExtIEs',
        'Expected-UL-AoA-ExtIEs',
        'Expected-ZoA-only-ExtIEs',
        'Expected-Azimuth-AoA-ExtIEs',
        'Expected-Zenith-AoA-ExtIEs',
        'F1CTransferPath-ExtIEs',
        'F1CTransferPathNRDC-ExtIEs',
        'FDD-Info-ExtIEs',
        'FDD-InfoRel16-ExtIEs',
        'FiveG-ProSeAuthorized-ExtIEs',
        'Flows-Mapped-To-DRB-ItemExtIEs',
        'FreqBandNrItem-ExtIEs',
        'FreqDomainLength-ExtIEs',
        'FreqInfoRel16-ExtIEs',
        'Frequency-Domain-HSNA-Configuration-Item-ExtIEs',
        'Frequency-Domain-HSNA-Slot-Configuration-Item-ExtIEs',
        'FlowsMappedToSLDRB-Item-ExtIEs',
        'GBR-QosInformation-ExtIEs',
        'GBR-QosFlowInformation-ExtIEs',
        'GeographicalCoordinates-ExtIEs',
        'GNB-CUSystemInformation-ExtIEs',
        'GNB-CU-TNL-Association-Setup-Item-ExtIEs',
        'GNB-CU-TNL-Association-Failed-To-Setup-Item-ExtIEs',
        'GNB-CU-TNL-Association-To-Add-Item-ExtIEs',
        'GNB-CU-TNL-Association-To-Remove-Item-ExtIEs',
        'GNB-CU-TNL-Association-To-Update-Item-ExtIEs',
        'GNB-DU-Cell-Resource-Configuration-ExtIEs',
        'Extended-GNB-CU-Name-ExtIEs',
        'Extended-GNB-DU-Name-ExtIEs',
        'GNB-DU-Served-Cells-ItemExtIEs',
        'GNB-DU-System-Information-ExtIEs',
        'GNB-DU-TNL-Association-To-Remove-Item-ExtIEs',
        'GNBDUUESliceMaximumBitRateItem-ExtIEs',
        'GNB-RxTxTimeDiff-ExtIEs',
        'GNBRxTxTimeDiffMeas-ExtIEs',
        'GTPTLA-Item-ExtIEs',
        'GTPTunnel-ExtIEs',
        'HardwareLoadIndicator-ExtIEs',
        'HSNASlotConfigItem-ExtIEs',
        'IAB-Congestion-Indication-List-ExtIEs',
        'IAB-Congestion-Indication-ItemExtIEs',
        'IAB-Info-IAB-donor-CU-ExtIEs',
        'IAB-Info-IAB-DU-ExtIEs',
        'IAB-MT-Cell-List-Item-ExtIEs',
        'IAB-MT-Cell-NA-Resource-Configuration-Mode-Info-ExtIEs',
        'IAB-MT-Cell-NA-Resource-Configuration-FDD-Info-ExtIEs',
        'IAB-MT-Cell-NA-Resource-Configuration-TDD-Info-ExtIEs',
        'IAB-STC-Info-ExtIEs',
        'IAB-STC-Info-Item-ExtIEs',
        'IAB-Allocated-TNL-Address-Item-ExtIEs',
        'IAB-DU-Cell-Resource-Configuration-Mode-Info-ExtIEs',
        'IAB-DU-Cell-Resource-Configuration-FDD-Info-ExtIEs',
        'IAB-DU-Cell-Resource-Configuration-TDD-Info-ExtIEs',
        'IABIPv6RequestType-ExtIEs',
        'IABTNLAddress-ExtIEs',
        'IABTNLAddressesRequested-ExtIEs',
        'IAB-TNL-Addresses-To-Remove-Item-ExtIEs',
        'IAB-TNL-Addresses-Exception-ExtIEs',
        'IABTNLAddress-ItemExtIEs',
        'IABv4AddressesRequested-ExtIEs',
        'ImplicitFormat-ExtIEs',
        'IntendedTDD-DL-ULConfig-ExtIEs',
        'IPHeaderInformation-ItemExtIEs',
        'IPtolayer2TrafficMappingInfo-ItemExtIEs',
        'L139Info-ExtIEs',
        'L839Info-ExtIEs',
        'L571Info-ExtIEs',
        'L1151Info-ExtIEs',
        'LCS-to-GCS-Translation-ExtIEs',
        'LCStoGCSTranslation-ExtIEs',
        'LocationDependentMBSF1UInformation-Item-ExtIEs',
        'LocationUncertainty-ExtIEs',
        'LoS-NLoSInformation-ExtIEs',
        'LTEUESidelinkAggregateMaximumBitrate-ExtIEs',
        'LTEV2XServicesAuthorized-ExtIEs',
        'MBS-Flows-Mapped-To-MRB-Item-ExtIEs',
        'MBSF1UInformation-ExtIEs',
        'MBS-Session-ID-ExtIEs',
        'MBS-CUtoDURRCInformation-ExtIEs',
        'MBS-Broadcast-Cell-Item-ExtIEs',
        'MBS-Broadcast-MRB-Item-ExtIEs',
        'MBSMulticastF1UContextDescriptor-ExtIEs',
        'MulticastF1UContext-ToBeSetup-Item-ExtIEs',
        'MulticastF1UContext-Setup-Item-ExtIEs',
        'MulticastF1UContext-FailedToBeSetup-Item-ExtIEs',
        'MBSServiceArea-ExtIEs',
        'MBS-ServiceAreaInformation-ExtIEs',
        'MBS-ServiceAreaTAIList-Item-ExtIEs',
        'MBS-ServiceAreaInformationItem-ExtIEs',
        'MC-PagingCell-ItemExtIEs',
        'MeasurementBeamInfo-ExtIEs',
        'MRB-ProgressInformation-ExtIEs',
        'MultipleULAoA-ExtIEs',
        'MultipleULAoA-Item-ExtIEs',
        'MulticastMBSSessionList-Item-ExtIEs',
        'MulticastMRBs-FailedtoBeModified-Item-ExtIEs',
        'MulticastMRBs-FailedToBeSetup-Item-ExtIEs',
        'MulticastMRBs-FailedToBeSetupMod-Item-ExtIEs',
        'MulticastMRBs-Modified-Item-ExtIEs',
        'MulticastMRBs-Setup-Item-ExtIEs',
        'MulticastMRBs-SetupMod-Item-ExtIEs',
        'MulticastMRBs-ToBeModified-Item-ExtIEs',
        'MulticastMRBs-ToBeReleased-ItemExtIEs',
        'MulticastMRBs-ToBeSetup-Item-ExtIEs',
        'MulticastMRBs-ToBeSetupMod-Item-ExtIEs',
        'MultiplexingInfo-ExtIEs',
        'M5Configuration-ExtIEs',
        'M6Configuration-ExtIEs',
        'M7Configuration-ExtIEs',
        'MDTConfiguration-ExtIEs',
        'MeasuredResultsValue-ExtIEs',
        'NA-Resource-Configuration-Item-ExtIEs',
        'Neighbour-Node-Cells-List-Item-ExtIEs',
        'Neighbour-Cell-Information-ItemExtIEs',
        'NeighbourNR-CellsForSON-Item-ExtIEs',
        'NGRANAllocationAndRetentionPriority-ExtIEs',
        'NGRANHighAccuracyAccessPointPosition-ExtIEs',
        'NR-CGI-List-For-Restart-ItemExtIEs',
        'NR-PRSBeamInformation-ExtIEs',
        'NR-PRSBeamInformationItem-ExtIEs',
        'NRPagingeDRXInformation-ExtIEs',
        'NRPagingeDRXInformationforRRCINACTIVE-ExtIEs',
        'NonDynamic5QIDescriptor-ExtIEs',
        'NonDynamicPQIDescriptor-ExtIEs',
        'NotificationInformationExtIEs',
        'NPNBroadcastInformation-ExtIEs',
        'NPN-Broadcast-Information-SNPN-ExtIEs',
        'NPN-Broadcast-Information-PNI-NPN-ExtIEs',
        'NPNSupportInfo-ExtIEs',
        'NRCarrierItem-ExtIEs',
        'NRFreqInfoExtIEs',
        'NRCGI-ExtIEs',
        'NR-Mode-Info-ExtIEs',
        'NR-ModeInfoRel16-ExtIEs',
        'NRPRACHConfig-ExtIEs',
        'NRPRACHConfigItem-ExtIEs',
        'NR-U-Channel-Info-List-ExtIEs',
        'NR-U-Channel-Item-ExtIEs',
        'NumDLULSymbols-ExtIEs',
        'NRV2XServicesAuthorized-ExtIEs',
        'NRUESidelinkAggregateMaximumBitrate-ExtIEs',
        'OnDemandPRS-Info-ExtIEs',
        'PacketErrorRate-ExtIEs',
        'PagingCell-ItemExtIEs',
        'PagingIdentity-ExtIEs',
        'PEIPSAssistanceInfo-ExtIEs',
        'RelativePathDelay-ExtIEs',
        'Parent-IAB-Nodes-NA-Resource-Configuration-Item-ExtIEs',
        'PartialSuccessCell-ExtIEs',
        'PathlossReferenceInfo-ExtIEs',
        'PathlossReferenceSignal-ExtIEs',
        'PathSwitchConfiguration-ExtIEs',
        'PC5-QoS-Characteristics-ExtIEs',
        'PC5QoSParameters-ExtIEs',
        'PC5FlowBitRates-ExtIEs',
        'PC5RLCChannelQoSInformation-ExtIEs',
        'PC5RLCChannelToBeSetupItem-ExtIEs',
        'PC5RLCChannelToBeModifiedItem-ExtIEs',
        'PC5RLCChannelToBeReleasedItem-ExtIEs',
        'PC5RLCChannelSetupItem-ExtIEs',
        'PC5RLCChannelFailedToBeSetupItem-ExtIEs',
        'PC5RLCChannelModifiedItem-ExtIEs',
        'PC5RLCChannelFailedToBeModifiedItem-ExtIEs',
        'PC5RLCChannelRequiredToBeModifiedItem-ExtIEs',
        'PC5RLCChannelRequiredToBeReleasedItem-ExtIEs',
        'PDCMeasurementQuantities-ItemIEs',
        'PDCMeasurementQuantitiesValue-ExtIEs',
        'PDCMeasurementResult-ExtIEs',
        'PDCMeasuredResults-Item-ExtIEs',
        'PDCMeasuredResults-Value-ExtIEs',
        'PeriodicityList-ItemExtIEs',
        'PosMeasGapPreConfigList-ExtIEs',
        'PosMeasurementQuantities-ItemExtIEs',
        'PosMeasurementResultItemExtIEs',
        'PosMeasurementResultList-ItemExtIEs',
        'PosResourceSetType-ExtIEs',
        'PosResourceSetTypePR-ExtIEs',
        'PosResourceSetTypeSP-ExtIEs',
        'PosResourceSetTypeAP-ExtIEs',
        'PosSItype-ItemExtIEs',
        'PosSRSResource-Item-ExtIEs',
        'PosSRSResourceSet-Item-ExtIEs',
        'Protected-EUTRA-Resources-ItemExtIEs',
        'PRSConfiguration-ExtIEs',
        'PRSInformationPos-ExtIEs',
        'PRS-Measurement-Info-List-Item-ExtIEs',
        'Potential-SpCell-ItemExtIEs',
        'PRSAngleItem-ItemExtIEs',
        'PRSMuting-ExtIEs',
        'PRSMutingOption1-ExtIEs',
        'PRSMutingOption2-ExtIEs',
        'PRSResource-Item-ExtIEs',
        'PRSResource-QCLInfo-ExtIEs',
        'PRSResource-QCLSourceSSB-ExtIEs',
        'PRSResource-QCLSourcePRS-ExtIEs',
        'PRSResourceSet-Item-ExtIEs',
        'PRSTransmissionOffIndication-ExtIEs',
        'PRSTransmissionOffPerResource-Item-ExtIEs',
        'PRSTransmissionOffIndicationPerResource-Item-ExtIEs',
        'PRSTransmissionOffInformation-ExtIEs',
        'PRSTransmissionOffPerResourceSet-Item-ExtIEs',
        'PWS-Failed-NR-CGI-ItemExtIEs',
        'PWSSystemInformationExtIEs',
        'PRSTRPItem-ExtIEs',
        'RequestedDLPRSTransmissionCharacteristics-ExtIEs',
        'RequestedDLPRSResourceSet-Item-ExtIEs',
        'RequestedDLPRSResource-Item-ExtIEs',
        'PRSTransmissionTRPItem-ExtIEs',
        'QoEInformation-ExtIEs',
        'QoEInformationList-Item-ExtIEs',
        'QoEMetrics-ExtIEs',
        'QoS-Characteristics-ExtIEs',
        'QoSFlowLevelQoSParameters-ExtIEs',
        'QoSInformation-ExtIEs',
        'RACHReportInformationItem-ExtIEs',
        'RadioResourceStatus-ExtIEs',
        'MIMOPRBusageInformation-ExtIEs',
        'RANUEPagingIdentity-ExtIEs',
        'RAT-FrequencyPriorityInformation-ExtIEs',
        'RBSetConfiguration-ExtIEs',
        'ReferencePoint-ExtIEs',
        'ReferenceSignal-ExtIEs',
        'RelativeCartesianLocation-ExtIEs',
        'RelativeGeodeticLocation-ExtIEs',
        'RequestedSRSTransmissionCharacteristics-ExtIEs',
        'ResourceCoordinationEUTRACellInfo-ExtIEs',
        'ResourceCoordinationTransferInformation-ExtIEs',
        'ResourceSetType-ExtIEs',
        'ResourceSetTypePeriodic-ExtIEs',
        'ResourceSetTypeSemi-persistent-ExtIEs',
        'ResourceSetTypeAperiodic-ExtIEs',
        'ReportingRequestType-ExtIEs',
        'ResourceType-ExtIEs',
        'ResourceTypePeriodic-ExtIEs',
        'ResourceTypeSemi-persistent-ExtIEs',
        'ResourceTypeAperiodic-ExtIEs',
        'ResourceTypePos-ExtIEs',
        'ResourceTypePeriodicPos-ExtIEs',
        'ResourceTypeSemi-persistentPos-ExtIEs',
        'ResourceTypeAperiodicPos-ExtIEs',
        'RLCDuplicationInformation-ExtIEs',
        'RLCDuplicationState-Item-ExtIEs',
        'RLCFailureIndication-ExtIEs',
        'RLC-Status-ExtIEs',
        'RLFReportInformationItem-ExtIEs',
        'RRCDeliveryStatus-ExtIEs',
        'RRC-Version-ExtIEs',
        'ResponseTime-ExtIEs',
        'SCell-FailedtoSetup-ItemExtIEs',
        'SCell-FailedtoSetupMod-ItemExtIEs',
        'SCell-ToBeRemoved-ItemExtIEs',
        'SCell-ToBeSetup-ItemExtIEs',
        'SCell-ToBeSetupMod-ItemExtIEs',
        'SCS-SpecificCarrier-ExtIEs',
        'SDTBearerConfigurationInfo-ExtIEs',
        'SDTBearerConfig-List-Item-ExtIEs',
        'SDTBearerType-ExtIEs',
        'SDTInformation-ExtIEs',
        'Search-window-information-ExtIEs',
        'ServingCellMO-List-Item-ExtIEs',
        'ServingCellMO-encoded-in-CGC-Item-ExtIEs',
        'Served-Cell-Information-ExtIEs',
        'Serving-Cells-List-Item-ExtIEs',
        'SFN-Offset-ExtIEs',
        'Served-Cells-To-Add-ItemExtIEs',
        'Served-Cells-To-Delete-ItemExtIEs',
        'Served-Cells-To-Modify-ItemExtIEs',
        'Served-EUTRA-Cell-Information-ExtIEs',
        'Service-Status-ExtIEs',
        'SItype-ItemExtIEs',
        'SibtypetobeupdatedListItem-ExtIEs',
        'SidelinkRelayConfiguration-ExtIEs',
        'SLDRBs-FailedToBeModified-ItemExtIEs',
        'SLDRBs-FailedToBeSetup-ItemExtIEs',
        'SLDRBs-FailedToBeSetupMod-ItemExtIEs',
        'SLDRBs-Modified-ItemExtIEs',
        'SLDRBs-ModifiedConf-ItemExtIEs',
        'SLDRBs-Required-ToBeModified-ItemExtIEs',
        'SLDRBs-Required-ToBeReleased-ItemExtIEs',
        'SLDRBs-Setup-ItemExtIEs',
        'SLDRBs-SetupMod-ItemExtIEs',
        'SLDRBs-ToBeModified-ItemExtIEs',
        'SLDRBs-ToBeReleased-ItemExtIEs',
        'SLDRBs-ToBeSetup-ItemExtIEs',
        'SLDRBs-ToBeSetupMod-ItemExtIEs',
        'SLDRXCycleItem-ExtIEs',
        'SLDRXInformation-ExtIEs',
        'SliceAvailableCapacity-ExtIEs',
        'SliceAvailableCapacityItem-ExtIEs',
        'SNSSAIAvailableCapacity-Item-ExtIEs',
        'SliceRadioResourceStatus-ExtIEs',
        'SliceRadioResourceStatus-Item-ExtIEs',
        'SNSSAIRadioResourceStatus-Item-ExtIEs',
        'SliceSupportItem-ExtIEs',
        'SliceToReportItem-ExtIEs',
        'SNSSAI-Item-ExtIEs',
        'Slot-Configuration-ItemExtIEs',
        'SNSSAI-ExtIEs',
        'SpatialDirectionInformation-ExtIEs',
        'SpatialRelationInfo-ExtIEs',
        'SpatialRelationforResourceIDItem-ExtIEs',
        'SpatialRelationPerSRSResource-ExtIEs',
        'SpatialRelationPerSRSResourceItem-ExtIEs',
        'SpatialInformationPos-ExtIEs',
        'SRBs-FailedToBeSetup-ItemExtIEs',
        'SRBs-FailedToBeSetupMod-ItemExtIEs',
        'SRBs-Modified-ItemExtIEs',
        'SRBs-Required-ToBeReleased-ItemExtIEs',
        'SRBs-Setup-ItemExtIEs',
        'SRBs-SetupMod-ItemExtIEs',
        'SRBs-ToBeReleased-ItemExtIEs',
        'SRBs-ToBeSetup-ItemExtIEs',
        'SRBs-ToBeSetupMod-ItemExtIEs',
        'SRSCarrier-List-Item-ExtIEs',
        'SRSConfig-ExtIEs',
        'SRSConfiguration-ExtIEs',
        'SRSResource-ExtIEs',
        'SRSResourceSet-ExtIEs',
        'SRSResourceSetItemExtIEs',
        'SRSResourceTrigger-ExtIEs',
        'SRSResourcetype-ExtIEs',
        'SRSResourceTypeChoice-ExtIEs',
        'SSBCoverageModification-Item-ExtIEs',
        'SSB-ExtIEs',
        'SSB-transmisisonBitmap-ExtIEs',
        'SSBAreaCapacityValueItem-ExtIEs',
        'SSBAreaRadioResourceStatusItem-ExtIEs',
        'SSBInformation-ExtIEs',
        'SSBInformationItem-ExtIEs',
        'SSB-PositionsInBurst-ExtIEs',
        'SSB-TF-Configuration-ExtIEs',
        'SSBToReportItem-ExtIEs',
        'StartTimeAndDuration-ExtIEs',
        'SUL-InformationExtIEs',
        'SuccessfulHOReportInformation-Item-ExtIEs',
        'SupportedSULFreqBandItem-ExtIEs',
        'SymbolAllocInSlot-ExtIEs',
        'TargetCellList-Item-ExtIEs',
        'NSAGSupportItem-ExtIEs',
        'TDD-Info-ExtIEs',
        'TDD-InfoRel16-ExtIEs',
        'TRPTEGInformation-ExtIEs',
        'RxTxTEG-ExtIEs',
        'RxTEG-ExtIEs',
        'TimeReferenceInformation-ExtIEs',
        'TimeStamp-ExtIEs',
        'TimeStampSlotIndex-ExtIEs',
        'TimingMeasurementQuality-ExtIEs',
        'TNLCapacityIndicator-ExtIEs',
        'TraceActivation-ExtIEs',
        'TrafficMappingInfo-ExtIEs',
        'Transmission-Bandwidth-ExtIEs',
        'TransmissionComb-ExtIEs',
        'TransmissionCombPos-ExtIEs',
        'Transport-UP-Layer-Address-Info-To-Add-ItemExtIEs',
        'Transport-UP-Layer-Address-Info-To-Remove-ItemExtIEs',
        'TRPBeamAntennaInformation-ExtIEs',
        'Choice-TRP-Beam-Info-Item-ExtIEs',
        'TRP-BeamAntennaExplicitInformation-ExtIEs',
        'TRP-BeamAntennaAnglesList-Item-ExtIEs',
        'TRP-ElevationAngleList-Item-ExtIEs',
        'TRP-Beam-Power-Item-ExtIEs',
        'TRPInformation-ExtIEs',
        'TRPInformationItem-ExtIEs',
        'TRPInformationTypeResponseItem-ExtIEs',
        'TRPListItem-ExtIEs',
        'TRPMeasurementQuality-ExtIEs',
        'TRPMeasurementQuality-Item-ExtIEs',
        'TRP-MeasurementRequestItem-ExtIEs',
        'TRP-PRS-Info-List-Item-ExtIEs',
        'TRPPositionDefinitionType-ExtIEs',
        'TRPPositionDirect-ExtIEs',
        'TRPPositionDirectAccuracy-ExtIEs',
        'TRPPositionReferenced-ExtIEs',
        'TRPReferencePointType-ExtIEs',
        'TRP-Rx-TEGInformation-ExtIEs',
        'TRP-RxTx-TEGInformation-ExtIEs',
        'TRP-Tx-TEGInformation-ExtIEs',
        'TRPTEGItem-ExtIEs',
        'DLPRSResource-Item-ExtIEs',
        'Transport-Layer-Address-Info-ExtIEs',
        'TSCAssistanceInformation-ExtIEs',
        'TSCTrafficCharacteristics-ExtIEs',
        'TRP-MeasurementUpdateItem-ExtIEs',
        'UAC-Assistance-InfoExtIEs',
        'UACPLMN-Item-ExtIEs',
        'UACType-Item-ExtIEs',
        'UACCategoryType-ExtIEs',
        'UACOperatorDefined-ExtIEs',
        'UE-associatedLogicalF1-ConnectionItemExtIEs',
        'UEIdentityIndexValueChoice-ExtIEs',
        'UEIdentity-List-For-Paging-Item-ExtIEs',
        'UE-MulticastMRBs-ConfirmedToBeModified-Item-ExtIEs',
        'UE-MulticastMRBs-RequiredToBeModified-Item-ExtIEs',
        'UE-MulticastMRBs-RequiredToBeReleased-Item-ExtIEs',
        'UE-MulticastMRBs-Setup-Item-ExtIEs',
        'UE-MulticastMRBs-ToBeReleased-Item-ExtIEs',
        'UE-MulticastMRBs-ToBeSetup-Item-ExtIEs',
        'UE-MulticastMRBs-ToBeSetup-atModify-Item-ExtIEs',
        'UEPagingCapability-ExtIEs',
        'UEReportingInformation-ExtIEs',
        'UL-AoA-ExtIEs',
        'UL-BH-Non-UP-Traffic-Mapping-ExtIEs',
        'UL-BH-Non-UP-Traffic-Mapping-ItemExtIEs',
        'ULConfigurationExtIEs',
        'UL-RTOA-Measurement-ExtIEs',
        'UL-RTOA-MeasurementItem-ExtIEs',
        'UL-SRS-RSRPP-ExtIEs',
        'UL-UP-TNL-Information-to-Update-List-ItemExtIEs',
        'UL-UP-TNL-Address-to-Update-List-ItemExtIEs',
        'ULUPTNLInformation-ToBeSetup-ItemExtIEs',
        'UPTransportLayerInformation-ExtIEs',
        'UuRLCChannelQoSInformation-ExtIEs',
        'UuRLCChannelToBeSetupItem-ExtIEs',
        'UuRLCChannelToBeModifiedItem-ExtIEs',
        'UuRLCChannelToBeReleasedItem-ExtIEs',
        'UuRLCChannelSetupItem-ExtIEs',
        'UuRLCChannelFailedToBeSetupItem-ExtIEs',
        'UuRLCChannelModifiedItem-ExtIEs',
        'UuRLCChannelFailedToBeModifiedItem-ExtIEs',
        'UuRLCChannelRequiredToBeModifiedItem-ExtIEs',
        'UuRLCChannelRequiredToBeReleasedItem-ExtIEs',
        'VictimgNBSetID-ExtIEs',
        'ZoAInformation-ExtIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        'AbortTransmission-ExtIEs',
        'AccessPointPosition-ExtIEs',
        'Activated-Cells-to-be-Updated-List-Item-ExtIEs',
        'ActiveULBWP-ExtIEs',
        'AdditionalPath-Item-ExtIEs',
        'ExtendedAdditionalPathList-Item-ExtIEs',
        'AdditionalPDCPDuplicationTNL-ItemExtIEs',
        'AdditionalSIBMessageList-Item-ExtIEs',
        'AffectedCellsAndBeams-Item-ExtIEs',
        'AffectedSSB-Item-ExtIEs',
        'AggressorCellList-Item-ExtIEs',
        'AggressorgNBSetID-ExtIEs',
        'AllocationAndRetentionPriority-ExtIEs',
        'AlternativeQoSParaSetItem-ExtIEs',
        'AngleMeasurementQuality-ExtIEs',
        'Associated-SCell-ItemExtIEs',
        'AvailablePLMNList-Item-ExtIEs',
        'AvailableSNPN-ID-List-ItemExtIEs',
        'AoA-AssistanceInfo-ExtIEs',
        'AngleMeasurementType-ExtIEs',
        'ARPLocationInformation-ExtIEs',
        'ARPLocationType-ExtIEs',
        'BAP-Header-Rewriting-Added-List-Item-ExtIEs',
        'BAP-Header-Rewriting-Removed-List-Item-ExtIEs',
        'BandwidthSRS-ExtIEs',
        'BAPlayerBHRLCchannelMappingInfo-ExtIEs',
        'BAPlayerBHRLCchannelMappingInfo-ItemExtIEs',
        'BAPRoutingIDExtIEs',
        'BCBearerContextF1U-TNLInfo-ExtIEs',
        'BHChannels-FailedToBeModified-ItemExtIEs',
        'BHChannels-FailedToBeSetup-ItemExtIEs',
        'BHChannels-FailedToBeSetupMod-ItemExtIEs',
        'BHChannels-Modified-ItemExtIEs',
        'BHChannels-Required-ToBeReleased-ItemExtIEs',
        'BHChannels-Setup-ItemExtIEs',
        'BHChannels-SetupMod-ItemExtIEs',
        'BHChannels-ToBeModified-ItemExtIEs',
        'BHChannels-ToBeReleased-ItemExtIEs',
        'BHChannels-ToBeSetup-ItemExtIEs',
        'BHChannels-ToBeSetupMod-ItemExtIEs',
        'BHInfo-ExtIEs',
        'BHQoSInformation-ExtIEs',
        'BHRLCCHItemExtIEs',
        'BH-Routing-Information-Added-List-ItemExtIEs',
        'BH-Routing-Information-Removed-List-ItemExtIEs',
        'BPLMN-ID-Info-ItemExtIEs',
        'ServedPLMNs-ItemExtIEs',
        'BroadcastMRBs-FailedtoBeModified-Item-ExtIEs',
        'BroadcastMRBs-FailedToBeSetup-Item-ExtIEs',
        'BroadcastMRBs-FailedToBeSetupMod-Item-ExtIEs',
        'BroadcastMRBs-Modified-Item-ExtIEs',
        'BroadcastMRBs-Setup-Item-ExtIEs',
        'BroadcastMRBs-SetupMod-Item-ExtIEs',
        'BroadcastMRBs-ToBeModified-Item-ExtIEs',
        'BroadcastMRBs-ToBeReleased-ItemExtIEs',
        'BroadcastMRBs-ToBeSetup-Item-ExtIEs',
        'BroadcastMRBs-ToBeSetupMod-Item-ExtIEs',
        'BroadcastSNPN-ID-List-ItemExtIEs',
        'BroadcastPNI-NPN-ID-List-ItemExtIEs',
        'BroadcastAreaScope-ExtIEs',
        'Broadcast-Cell-List-ItemExtIEs',
        'Candidate-SpCell-ItemExtIEs',
        'CapacityValue-ExtIEs',
        'Cause-ExtIEs',
        'CellMeasurementResultItem-ExtIEs',
        'CellsForSON-Item-ExtIEs',
        'Cells-Failed-to-be-Activated-List-ItemExtIEs',
        'Cells-Status-ItemExtIEs',
        'Cells-To-Be-Broadcast-ItemExtIEs',
        'Cells-Broadcast-Completed-ItemExtIEs',
        'Broadcast-To-Be-Cancelled-ItemExtIEs',
        'Cells-Broadcast-Cancelled-ItemExtIEs',
        'Cells-to-be-Activated-List-ItemExtIEs',
        'Cells-to-be-Deactivated-List-ItemExtIEs',
        'Cells-to-be-Barred-Item-ExtIEs',
        'CellToReportItem-ExtIEs',
        'CellType-ExtIEs',
        'CG-SDTSessionInfo-ExtIEs',
        'Child-IAB-Nodes-NA-Resource-List-Item-ExtIEs',
        'Child-Node-Cells-List-Item-ExtIEs',
        'Child-Nodes-List-Item-ExtIEs',
        'CNUEPagingIdentity-ExtIEs',
        'CompositeAvailableCapacityGroup-ExtIEs',
        'CompositeAvailableCapacity-ExtIEs',
        'ConditionalInterDUMobilityInformation-ExtIEs',
        'ConditionalIntraDUMobilityInformation-ExtIEs',
        'Coverage-Modification-Notification-ExtIEs',
        'Coverage-Modification-Item-ExtIEs',
        'CCO-Assistance-Information-ExtIEs',
        'CP-TransportLayerAddress-ExtIEs',
        'CPACMCGInformation-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'CriticalityDiagnostics-IE-Item-ExtIEs',
        'CUDURadioInformationType-ExtIEs',
        'CUDURIMInformation-ExtIEs',
        'CUtoDURRCInformation-ExtIEs',
        'DedicatedSIDeliveryNeededUE-Item-ExtIEs',
        'DL-PRS-ExtIEs',
        'DL-PRSMutingPattern-ExtIEs',
        'DLPRSResourceCoordinates-ExtIEs',
        'DLPRSResourceSetARP-ExtIEs',
        'DL-PRSResourceSetARPLocation-ExtIEs',
        'DLPRSResourceARP-ExtIEs',
        'DL-PRSResourceARPLocation-ExtIEs',
        'DL-UP-TNL-Address-to-Update-List-ItemExtIEs',
        'DLUPTNLInformation-ToBeSetup-ItemExtIEs',
        'DRB-Activity-ItemExtIEs',
        'DRBs-FailedToBeModified-ItemExtIEs',
        'DRBs-FailedToBeSetup-ItemExtIEs',
        'DRBs-FailedToBeSetupMod-ItemExtIEs',
        'DRB-Information-ItemExtIEs',
        'DRBs-Modified-ItemExtIEs',
        'DRBs-ModifiedConf-ItemExtIEs',
        'DRB-Notify-ItemExtIEs',
        'DRBs-Required-ToBeModified-ItemExtIEs',
        'DRBs-Required-ToBeReleased-ItemExtIEs',
        'DRBs-Setup-ItemExtIEs',
        'DRBs-SetupMod-ItemExtIEs',
        'DRBs-ToBeModified-ItemExtIEs',
        'DRBs-ToBeReleased-ItemExtIEs',
        'DRBs-ToBeSetup-ItemExtIEs',
        'DRBs-ToBeSetupMod-ItemExtIEs',
        'DRXCycle-ExtIEs',
        'DUCURadioInformationType-ExtIEs',
        'DUCURIMInformation-ExtIEs',
        'DUF-Slot-Config-Item-ExtIEs',
        'DUtoCURRCInformation-ExtIEs',
        'Dynamic5QIDescriptor-ExtIEs',
        'DynamicPQIDescriptor-ExtIEs',
        'E-CID-MeasurementQuantities-ItemIEs',
        'E-CID-MeasurementQuantitiesValue-ExtIEs',
        'E-CID-MeasurementResult-ExtIEs',
        'E-CID-MeasuredResults-Item-ExtIEs',
        'E-CID-MeasuredResults-Value-ExtIEs',
        'EgressBHRLCCHItemExtIEs',
        'Endpoint-IP-address-and-port-ExtIEs',
        'ExplicitFormat-ExtIEs',
        'ExtendedAvailablePLMN-Item-ExtIEs',
        'ExtendedServedPLMNs-ItemExtIEs',
        'EUTRACells-List-itemExtIEs',
        'EUTRA-Coex-FDD-Info-ExtIEs',
        'EUTRA-Coex-TDD-Info-ExtIEs',
        'EUTRA-PRACH-Configuration-ExtIEs',
        'EUTRA-SpecialSubframe-Info-ExtIEs',
        'EUTRANQoS-ExtIEs',
        'EUTRA-Mode-Info-ExtIEs',
        'EUTRA-FDD-Info-ExtIEs',
        'EUTRA-TDD-Info-ExtIEs',
        'Expected-UL-AoA-ExtIEs',
        'Expected-ZoA-only-ExtIEs',
        'Expected-Azimuth-AoA-ExtIEs',
        'Expected-Zenith-AoA-ExtIEs',
        'F1CTransferPath-ExtIEs',
        'F1CTransferPathNRDC-ExtIEs',
        'FDD-Info-ExtIEs',
        'FDD-InfoRel16-ExtIEs',
        'FiveG-ProSeAuthorized-ExtIEs',
        'Flows-Mapped-To-DRB-ItemExtIEs',
        'FreqBandNrItem-ExtIEs',
        'FreqDomainLength-ExtIEs',
        'FreqInfoRel16-ExtIEs',
        'Frequency-Domain-HSNA-Configuration-Item-ExtIEs',
        'Frequency-Domain-HSNA-Slot-Configuration-Item-ExtIEs',
        'FlowsMappedToSLDRB-Item-ExtIEs',
        'GBR-QosInformation-ExtIEs',
        'GBR-QosFlowInformation-ExtIEs',
        'GeographicalCoordinates-ExtIEs',
        'GNB-CUSystemInformation-ExtIEs',
        'GNB-CU-TNL-Association-Setup-Item-ExtIEs',
        'GNB-CU-TNL-Association-Failed-To-Setup-Item-ExtIEs',
        'GNB-CU-TNL-Association-To-Add-Item-ExtIEs',
        'GNB-CU-TNL-Association-To-Remove-Item-ExtIEs',
        'GNB-CU-TNL-Association-To-Update-Item-ExtIEs',
        'GNB-DU-Cell-Resource-Configuration-ExtIEs',
        'Extended-GNB-CU-Name-ExtIEs',
        'Extended-GNB-DU-Name-ExtIEs',
        'GNB-DU-Served-Cells-ItemExtIEs',
        'GNB-DU-System-Information-ExtIEs',
        'GNB-DU-TNL-Association-To-Remove-Item-ExtIEs',
        'GNBDUUESliceMaximumBitRateItem-ExtIEs',
        'GNB-RxTxTimeDiff-ExtIEs',
        'GNBRxTxTimeDiffMeas-ExtIEs',
        'GTPTLA-Item-ExtIEs',
        'GTPTunnel-ExtIEs',
        'HardwareLoadIndicator-ExtIEs',
        'HSNASlotConfigItem-ExtIEs',
        'IAB-Congestion-Indication-List-ExtIEs',
        'IAB-Congestion-Indication-ItemExtIEs',
        'IAB-Info-IAB-donor-CU-ExtIEs',
        'IAB-Info-IAB-DU-ExtIEs',
        'IAB-MT-Cell-List-Item-ExtIEs',
        'IAB-MT-Cell-NA-Resource-Configuration-Mode-Info-ExtIEs',
        'IAB-MT-Cell-NA-Resource-Configuration-FDD-Info-ExtIEs',
        'IAB-MT-Cell-NA-Resource-Configuration-TDD-Info-ExtIEs',
        'IAB-STC-Info-ExtIEs',
        'IAB-STC-Info-Item-ExtIEs',
        'IAB-Allocated-TNL-Address-Item-ExtIEs',
        'IAB-DU-Cell-Resource-Configuration-Mode-Info-ExtIEs',
        'IAB-DU-Cell-Resource-Configuration-FDD-Info-ExtIEs',
        'IAB-DU-Cell-Resource-Configuration-TDD-Info-ExtIEs',
        'IABIPv6RequestType-ExtIEs',
        'IABTNLAddress-ExtIEs',
        'IABTNLAddressesRequested-ExtIEs',
        'IAB-TNL-Addresses-To-Remove-Item-ExtIEs',
        'IAB-TNL-Addresses-Exception-ExtIEs',
        'IABTNLAddress-ItemExtIEs',
        'IABv4AddressesRequested-ExtIEs',
        'ImplicitFormat-ExtIEs',
        'IntendedTDD-DL-ULConfig-ExtIEs',
        'IPHeaderInformation-ItemExtIEs',
        'IPtolayer2TrafficMappingInfo-ItemExtIEs',
        'L139Info-ExtIEs',
        'L839Info-ExtIEs',
        'L571Info-ExtIEs',
        'L1151Info-ExtIEs',
        'LCS-to-GCS-Translation-ExtIEs',
        'LCStoGCSTranslation-ExtIEs',
        'LocationDependentMBSF1UInformation-Item-ExtIEs',
        'LocationUncertainty-ExtIEs',
        'LoS-NLoSInformation-ExtIEs',
        'LTEUESidelinkAggregateMaximumBitrate-ExtIEs',
        'LTEV2XServicesAuthorized-ExtIEs',
        'MBS-Flows-Mapped-To-MRB-Item-ExtIEs',
        'MBSF1UInformation-ExtIEs',
        'MBS-Session-ID-ExtIEs',
        'MBS-CUtoDURRCInformation-ExtIEs',
        'MBS-Broadcast-Cell-Item-ExtIEs',
        'MBS-Broadcast-MRB-Item-ExtIEs',
        'MBSMulticastF1UContextDescriptor-ExtIEs',
        'MulticastF1UContext-ToBeSetup-Item-ExtIEs',
        'MulticastF1UContext-Setup-Item-ExtIEs',
        'MulticastF1UContext-FailedToBeSetup-Item-ExtIEs',
        'MBSServiceArea-ExtIEs',
        'MBS-ServiceAreaInformation-ExtIEs',
        'MBS-ServiceAreaTAIList-Item-ExtIEs',
        'MBS-ServiceAreaInformationItem-ExtIEs',
        'MC-PagingCell-ItemExtIEs',
        'MeasurementBeamInfo-ExtIEs',
        'MRB-ProgressInformation-ExtIEs',
        'MultipleULAoA-ExtIEs',
        'MultipleULAoA-Item-ExtIEs',
        'MulticastMBSSessionList-Item-ExtIEs',
        'MulticastMRBs-FailedtoBeModified-Item-ExtIEs',
        'MulticastMRBs-FailedToBeSetup-Item-ExtIEs',
        'MulticastMRBs-FailedToBeSetupMod-Item-ExtIEs',
        'MulticastMRBs-Modified-Item-ExtIEs',
        'MulticastMRBs-Setup-Item-ExtIEs',
        'MulticastMRBs-SetupMod-Item-ExtIEs',
        'MulticastMRBs-ToBeModified-Item-ExtIEs',
        'MulticastMRBs-ToBeReleased-ItemExtIEs',
        'MulticastMRBs-ToBeSetup-Item-ExtIEs',
        'MulticastMRBs-ToBeSetupMod-Item-ExtIEs',
        'MultiplexingInfo-ExtIEs',
        'M5Configuration-ExtIEs',
        'M6Configuration-ExtIEs',
        'M7Configuration-ExtIEs',
        'MDTConfiguration-ExtIEs',
        'MeasuredResultsValue-ExtIEs',
        'NA-Resource-Configuration-Item-ExtIEs',
        'Neighbour-Node-Cells-List-Item-ExtIEs',
        'Neighbour-Cell-Information-ItemExtIEs',
        'NeighbourNR-CellsForSON-Item-ExtIEs',
        'NGRANAllocationAndRetentionPriority-ExtIEs',
        'NGRANHighAccuracyAccessPointPosition-ExtIEs',
        'NR-CGI-List-For-Restart-ItemExtIEs',
        'NR-PRSBeamInformation-ExtIEs',
        'NR-PRSBeamInformationItem-ExtIEs',
        'NRPagingeDRXInformation-ExtIEs',
        'NRPagingeDRXInformationforRRCINACTIVE-ExtIEs',
        'NonDynamic5QIDescriptor-ExtIEs',
        'NonDynamicPQIDescriptor-ExtIEs',
        'NotificationInformationExtIEs',
        'NPNBroadcastInformation-ExtIEs',
        'NPN-Broadcast-Information-SNPN-ExtIEs',
        'NPN-Broadcast-Information-PNI-NPN-ExtIEs',
        'NPNSupportInfo-ExtIEs',
        'NRCarrierItem-ExtIEs',
        'NRFreqInfoExtIEs',
        'NRCGI-ExtIEs',
        'NR-Mode-Info-ExtIEs',
        'NR-ModeInfoRel16-ExtIEs',
        'NRPRACHConfig-ExtIEs',
        'NRPRACHConfigItem-ExtIEs',
        'NR-U-Channel-Info-List-ExtIEs',
        'NR-U-Channel-Item-ExtIEs',
        'NumDLULSymbols-ExtIEs',
        'NRV2XServicesAuthorized-ExtIEs',
        'NRUESidelinkAggregateMaximumBitrate-ExtIEs',
        'OnDemandPRS-Info-ExtIEs',
        'PacketErrorRate-ExtIEs',
        'PagingCell-ItemExtIEs',
        'PagingIdentity-ExtIEs',
        'PEIPSAssistanceInfo-ExtIEs',
        'RelativePathDelay-ExtIEs',
        'Parent-IAB-Nodes-NA-Resource-Configuration-Item-ExtIEs',
        'PartialSuccessCell-ExtIEs',
        'PathlossReferenceInfo-ExtIEs',
        'PathlossReferenceSignal-ExtIEs',
        'PathSwitchConfiguration-ExtIEs',
        'PC5-QoS-Characteristics-ExtIEs',
        'PC5QoSParameters-ExtIEs',
        'PC5FlowBitRates-ExtIEs',
        'PC5RLCChannelQoSInformation-ExtIEs',
        'PC5RLCChannelToBeSetupItem-ExtIEs',
        'PC5RLCChannelToBeModifiedItem-ExtIEs',
        'PC5RLCChannelToBeReleasedItem-ExtIEs',
        'PC5RLCChannelSetupItem-ExtIEs',
        'PC5RLCChannelFailedToBeSetupItem-ExtIEs',
        'PC5RLCChannelModifiedItem-ExtIEs',
        'PC5RLCChannelFailedToBeModifiedItem-ExtIEs',
        'PC5RLCChannelRequiredToBeModifiedItem-ExtIEs',
        'PC5RLCChannelRequiredToBeReleasedItem-ExtIEs',
        'PDCMeasurementQuantities-ItemIEs',
        'PDCMeasurementQuantitiesValue-ExtIEs',
        'PDCMeasurementResult-ExtIEs',
        'PDCMeasuredResults-Item-ExtIEs',
        'PDCMeasuredResults-Value-ExtIEs',
        'PeriodicityList-ItemExtIEs',
        'PosMeasGapPreConfigList-ExtIEs',
        'PosMeasurementQuantities-ItemExtIEs',
        'PosMeasurementResultItemExtIEs',
        'PosMeasurementResultList-ItemExtIEs',
        'PosResourceSetType-ExtIEs',
        'PosResourceSetTypePR-ExtIEs',
        'PosResourceSetTypeSP-ExtIEs',
        'PosResourceSetTypeAP-ExtIEs',
        'PosSItype-ItemExtIEs',
        'PosSRSResource-Item-ExtIEs',
        'PosSRSResourceSet-Item-ExtIEs',
        'Protected-EUTRA-Resources-ItemExtIEs',
        'PRSConfiguration-ExtIEs',
        'PRSInformationPos-ExtIEs',
        'PRS-Measurement-Info-List-Item-ExtIEs',
        'Potential-SpCell-ItemExtIEs',
        'PRSAngleItem-ItemExtIEs',
        'PRSMuting-ExtIEs',
        'PRSMutingOption1-ExtIEs',
        'PRSMutingOption2-ExtIEs',
        'PRSResource-Item-ExtIEs',
        'PRSResource-QCLInfo-ExtIEs',
        'PRSResource-QCLSourceSSB-ExtIEs',
        'PRSResource-QCLSourcePRS-ExtIEs',
        'PRSResourceSet-Item-ExtIEs',
        'PRSTransmissionOffIndication-ExtIEs',
        'PRSTransmissionOffPerResource-Item-ExtIEs',
        'PRSTransmissionOffIndicationPerResource-Item-ExtIEs',
        'PRSTransmissionOffInformation-ExtIEs',
        'PRSTransmissionOffPerResourceSet-Item-ExtIEs',
        'PWS-Failed-NR-CGI-ItemExtIEs',
        'PWSSystemInformationExtIEs',
        'PRSTRPItem-ExtIEs',
        'RequestedDLPRSTransmissionCharacteristics-ExtIEs',
        'RequestedDLPRSResourceSet-Item-ExtIEs',
        'RequestedDLPRSResource-Item-ExtIEs',
        'PRSTransmissionTRPItem-ExtIEs',
        'QoEInformation-ExtIEs',
        'QoEInformationList-Item-ExtIEs',
        'QoEMetrics-ExtIEs',
        'QoS-Characteristics-ExtIEs',
        'QoSFlowLevelQoSParameters-ExtIEs',
        'QoSInformation-ExtIEs',
        'RACHReportInformationItem-ExtIEs',
        'RadioResourceStatus-ExtIEs',
        'MIMOPRBusageInformation-ExtIEs',
        'RANUEPagingIdentity-ExtIEs',
        'RAT-FrequencyPriorityInformation-ExtIEs',
        'RBSetConfiguration-ExtIEs',
        'ReferencePoint-ExtIEs',
        'ReferenceSignal-ExtIEs',
        'RelativeCartesianLocation-ExtIEs',
        'RelativeGeodeticLocation-ExtIEs',
        'RequestedSRSTransmissionCharacteristics-ExtIEs',
        'ResourceCoordinationEUTRACellInfo-ExtIEs',
        'ResourceCoordinationTransferInformation-ExtIEs',
        'ResourceSetType-ExtIEs',
        'ResourceSetTypePeriodic-ExtIEs',
        'ResourceSetTypeSemi-persistent-ExtIEs',
        'ResourceSetTypeAperiodic-ExtIEs',
        'ReportingRequestType-ExtIEs',
        'ResourceType-ExtIEs',
        'ResourceTypePeriodic-ExtIEs',
        'ResourceTypeSemi-persistent-ExtIEs',
        'ResourceTypeAperiodic-ExtIEs',
        'ResourceTypePos-ExtIEs',
        'ResourceTypePeriodicPos-ExtIEs',
        'ResourceTypeSemi-persistentPos-ExtIEs',
        'ResourceTypeAperiodicPos-ExtIEs',
        'RLCDuplicationInformation-ExtIEs',
        'RLCDuplicationState-Item-ExtIEs',
        'RLCFailureIndication-ExtIEs',
        'RLC-Status-ExtIEs',
        'RLFReportInformationItem-ExtIEs',
        'RRCDeliveryStatus-ExtIEs',
        'RRC-Version-ExtIEs',
        'ResponseTime-ExtIEs',
        'SCell-FailedtoSetup-ItemExtIEs',
        'SCell-FailedtoSetupMod-ItemExtIEs',
        'SCell-ToBeRemoved-ItemExtIEs',
        'SCell-ToBeSetup-ItemExtIEs',
        'SCell-ToBeSetupMod-ItemExtIEs',
        'SCS-SpecificCarrier-ExtIEs',
        'SDTBearerConfigurationInfo-ExtIEs',
        'SDTBearerConfig-List-Item-ExtIEs',
        'SDTBearerType-ExtIEs',
        'SDTInformation-ExtIEs',
        'Search-window-information-ExtIEs',
        'ServingCellMO-List-Item-ExtIEs',
        'ServingCellMO-encoded-in-CGC-Item-ExtIEs',
        'Served-Cell-Information-ExtIEs',
        'Serving-Cells-List-Item-ExtIEs',
        'SFN-Offset-ExtIEs',
        'Served-Cells-To-Add-ItemExtIEs',
        'Served-Cells-To-Delete-ItemExtIEs',
        'Served-Cells-To-Modify-ItemExtIEs',
        'Served-EUTRA-Cell-Information-ExtIEs',
        'Service-Status-ExtIEs',
        'SItype-ItemExtIEs',
        'SibtypetobeupdatedListItem-ExtIEs',
        'SidelinkRelayConfiguration-ExtIEs',
        'SLDRBs-FailedToBeModified-ItemExtIEs',
        'SLDRBs-FailedToBeSetup-ItemExtIEs',
        'SLDRBs-FailedToBeSetupMod-ItemExtIEs',
        'SLDRBs-Modified-ItemExtIEs',
        'SLDRBs-ModifiedConf-ItemExtIEs',
        'SLDRBs-Required-ToBeModified-ItemExtIEs',
        'SLDRBs-Required-ToBeReleased-ItemExtIEs',
        'SLDRBs-Setup-ItemExtIEs',
        'SLDRBs-SetupMod-ItemExtIEs',
        'SLDRBs-ToBeModified-ItemExtIEs',
        'SLDRBs-ToBeReleased-ItemExtIEs',
        'SLDRBs-ToBeSetup-ItemExtIEs',
        'SLDRBs-ToBeSetupMod-ItemExtIEs',
        'SLDRXCycleItem-ExtIEs',
        'SLDRXInformation-ExtIEs',
        'SliceAvailableCapacity-ExtIEs',
        'SliceAvailableCapacityItem-ExtIEs',
        'SNSSAIAvailableCapacity-Item-ExtIEs',
        'SliceRadioResourceStatus-ExtIEs',
        'SliceRadioResourceStatus-Item-ExtIEs',
        'SNSSAIRadioResourceStatus-Item-ExtIEs',
        'SliceSupportItem-ExtIEs',
        'SliceToReportItem-ExtIEs',
        'SNSSAI-Item-ExtIEs',
        'Slot-Configuration-ItemExtIEs',
        'SNSSAI-ExtIEs',
        'SpatialDirectionInformation-ExtIEs',
        'SpatialRelationInfo-ExtIEs',
        'SpatialRelationforResourceIDItem-ExtIEs',
        'SpatialRelationPerSRSResource-ExtIEs',
        'SpatialRelationPerSRSResourceItem-ExtIEs',
        'SpatialInformationPos-ExtIEs',
        'SRBs-FailedToBeSetup-ItemExtIEs',
        'SRBs-FailedToBeSetupMod-ItemExtIEs',
        'SRBs-Modified-ItemExtIEs',
        'SRBs-Required-ToBeReleased-ItemExtIEs',
        'SRBs-Setup-ItemExtIEs',
        'SRBs-SetupMod-ItemExtIEs',
        'SRBs-ToBeReleased-ItemExtIEs',
        'SRBs-ToBeSetup-ItemExtIEs',
        'SRBs-ToBeSetupMod-ItemExtIEs',
        'SRSCarrier-List-Item-ExtIEs',
        'SRSConfig-ExtIEs',
        'SRSConfiguration-ExtIEs',
        'SRSResource-ExtIEs',
        'SRSResourceSet-ExtIEs',
        'SRSResourceSetItemExtIEs',
        'SRSResourceTrigger-ExtIEs',
        'SRSResourcetype-ExtIEs',
        'SRSResourceTypeChoice-ExtIEs',
        'SSBCoverageModification-Item-ExtIEs',
        'SSB-ExtIEs',
        'SSB-transmisisonBitmap-ExtIEs',
        'SSBAreaCapacityValueItem-ExtIEs',
        'SSBAreaRadioResourceStatusItem-ExtIEs',
        'SSBInformation-ExtIEs',
        'SSBInformationItem-ExtIEs',
        'SSB-PositionsInBurst-ExtIEs',
        'SSB-TF-Configuration-ExtIEs',
        'SSBToReportItem-ExtIEs',
        'StartTimeAndDuration-ExtIEs',
        'SUL-InformationExtIEs',
        'SuccessfulHOReportInformation-Item-ExtIEs',
        'SupportedSULFreqBandItem-ExtIEs',
        'SymbolAllocInSlot-ExtIEs',
        'TargetCellList-Item-ExtIEs',
        'NSAGSupportItem-ExtIEs',
        'TDD-Info-ExtIEs',
        'TDD-InfoRel16-ExtIEs',
        'TRPTEGInformation-ExtIEs',
        'RxTxTEG-ExtIEs',
        'RxTEG-ExtIEs',
        'TimeReferenceInformation-ExtIEs',
        'TimeStamp-ExtIEs',
        'TimeStampSlotIndex-ExtIEs',
        'TimingMeasurementQuality-ExtIEs',
        'TNLCapacityIndicator-ExtIEs',
        'TraceActivation-ExtIEs',
        'TrafficMappingInfo-ExtIEs',
        'Transmission-Bandwidth-ExtIEs',
        'TransmissionComb-ExtIEs',
        'TransmissionCombPos-ExtIEs',
        'Transport-UP-Layer-Address-Info-To-Add-ItemExtIEs',
        'Transport-UP-Layer-Address-Info-To-Remove-ItemExtIEs',
        'TRPBeamAntennaInformation-ExtIEs',
        'Choice-TRP-Beam-Info-Item-ExtIEs',
        'TRP-BeamAntennaExplicitInformation-ExtIEs',
        'TRP-BeamAntennaAnglesList-Item-ExtIEs',
        'TRP-ElevationAngleList-Item-ExtIEs',
        'TRP-Beam-Power-Item-ExtIEs',
        'TRPInformation-ExtIEs',
        'TRPInformationItem-ExtIEs',
        'TRPInformationTypeResponseItem-ExtIEs',
        'TRPListItem-ExtIEs',
        'TRPMeasurementQuality-ExtIEs',
        'TRPMeasurementQuality-Item-ExtIEs',
        'TRP-MeasurementRequestItem-ExtIEs',
        'TRP-PRS-Info-List-Item-ExtIEs',
        'TRPPositionDefinitionType-ExtIEs',
        'TRPPositionDirect-ExtIEs',
        'TRPPositionDirectAccuracy-ExtIEs',
        'TRPPositionReferenced-ExtIEs',
        'TRPReferencePointType-ExtIEs',
        'TRP-Rx-TEGInformation-ExtIEs',
        'TRP-RxTx-TEGInformation-ExtIEs',
        'TRP-Tx-TEGInformation-ExtIEs',
        'TRPTEGItem-ExtIEs',
        'DLPRSResource-Item-ExtIEs',
        'Transport-Layer-Address-Info-ExtIEs',
        'TSCAssistanceInformation-ExtIEs',
        'TSCTrafficCharacteristics-ExtIEs',
        'TRP-MeasurementUpdateItem-ExtIEs',
        'UAC-Assistance-InfoExtIEs',
        'UACPLMN-Item-ExtIEs',
        'UACType-Item-ExtIEs',
        'UACCategoryType-ExtIEs',
        'UACOperatorDefined-ExtIEs',
        'UE-associatedLogicalF1-ConnectionItemExtIEs',
        'UEIdentityIndexValueChoice-ExtIEs',
        'UEIdentity-List-For-Paging-Item-ExtIEs',
        'UE-MulticastMRBs-ConfirmedToBeModified-Item-ExtIEs',
        'UE-MulticastMRBs-RequiredToBeModified-Item-ExtIEs',
        'UE-MulticastMRBs-RequiredToBeReleased-Item-ExtIEs',
        'UE-MulticastMRBs-Setup-Item-ExtIEs',
        'UE-MulticastMRBs-ToBeReleased-Item-ExtIEs',
        'UE-MulticastMRBs-ToBeSetup-Item-ExtIEs',
        'UE-MulticastMRBs-ToBeSetup-atModify-Item-ExtIEs',
        'UEPagingCapability-ExtIEs',
        'UEReportingInformation-ExtIEs',
        'UL-AoA-ExtIEs',
        'UL-BH-Non-UP-Traffic-Mapping-ExtIEs',
        'UL-BH-Non-UP-Traffic-Mapping-ItemExtIEs',
        'ULConfigurationExtIEs',
        'UL-RTOA-Measurement-ExtIEs',
        'UL-RTOA-MeasurementItem-ExtIEs',
        'UL-SRS-RSRPP-ExtIEs',
        'UL-UP-TNL-Information-to-Update-List-ItemExtIEs',
        'UL-UP-TNL-Address-to-Update-List-ItemExtIEs',
        'ULUPTNLInformation-ToBeSetup-ItemExtIEs',
        'UPTransportLayerInformation-ExtIEs',
        'UuRLCChannelQoSInformation-ExtIEs',
        'UuRLCChannelToBeSetupItem-ExtIEs',
        'UuRLCChannelToBeModifiedItem-ExtIEs',
        'UuRLCChannelToBeReleasedItem-ExtIEs',
        'UuRLCChannelSetupItem-ExtIEs',
        'UuRLCChannelFailedToBeSetupItem-ExtIEs',
        'UuRLCChannelModifiedItem-ExtIEs',
        'UuRLCChannelFailedToBeModifiedItem-ExtIEs',
        'UuRLCChannelRequiredToBeModifiedItem-ExtIEs',
        'UuRLCChannelRequiredToBeReleasedItem-ExtIEs',
        'VictimgNBSetID-ExtIEs',
        'ZoAInformation-ExtIEs',
        ]
    _param_ = [
        ]
    
    #-----< AbortTransmission >-----#
    AbortTransmission = CHOICE(name='AbortTransmission', mode=MODE_TYPE)
    _AbortTransmission_sRSResourceSetID = INT(name='sRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceSetID')))
    _AbortTransmission_releaseALL = NULL(name='releaseALL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AbortTransmission_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __AbortTransmission_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___AbortTransmission_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___AbortTransmission_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AbortTransmission_choice_extension_id._const_tab = ___AbortTransmission_choice_extension_id_tab
    __AbortTransmission_choice_extension_id._const_tab_at = None
    __AbortTransmission_choice_extension_id._const_tab_id = 'id'
    __AbortTransmission_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___AbortTransmission_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___AbortTransmission_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AbortTransmission_choice_extension_criticality._const_tab = ___AbortTransmission_choice_extension_criticality_tab
    __AbortTransmission_choice_extension_criticality._const_tab_at = ('..', 'id')
    __AbortTransmission_choice_extension_criticality._const_tab_id = 'criticality'
    __AbortTransmission_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___AbortTransmission_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___AbortTransmission_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AbortTransmission_choice_extension_value._const_tab = ___AbortTransmission_choice_extension_value_tab
    __AbortTransmission_choice_extension_value._const_tab_at = ('..', 'id')
    __AbortTransmission_choice_extension_value._const_tab_id = 'Value'
    _AbortTransmission_choice_extension._cont = ASN1Dict([
        ('id', __AbortTransmission_choice_extension_id),
        ('criticality', __AbortTransmission_choice_extension_criticality),
        ('value', __AbortTransmission_choice_extension_value),
        ])
    _AbortTransmission_choice_extension._ext = None
    AbortTransmission._cont = ASN1Dict([
        ('sRSResourceSetID', _AbortTransmission_sRSResourceSetID),
        ('releaseALL', _AbortTransmission_releaseALL),
        ('choice-extension', _AbortTransmission_choice_extension),
        ])
    AbortTransmission._ext = None
    
    #-----< AbortTransmission-ExtIEs >-----#
    AbortTransmission_ExtIEs = CLASS(name='AbortTransmission-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    AbortTransmission_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AccessPointPosition >-----#
    AccessPointPosition = SEQ(name='AccessPointPosition', mode=MODE_TYPE)
    _AccessPointPosition_latitudeSign = ENUM(name='latitudeSign', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPointPosition_latitudeSign._cont = ASN1Dict([('north', 0), ('south', 1)])
    _AccessPointPosition_latitudeSign._ext = None
    _AccessPointPosition_latitude = INT(name='latitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPointPosition_latitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    _AccessPointPosition_longitude = INT(name='longitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPointPosition_longitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _AccessPointPosition_directionOfAltitude = ENUM(name='directionOfAltitude', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPointPosition_directionOfAltitude._cont = ASN1Dict([('height', 0), ('depth', 1)])
    _AccessPointPosition_directionOfAltitude._ext = None
    _AccessPointPosition_altitude = INT(name='altitude', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPointPosition_altitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _AccessPointPosition_uncertaintySemi_major = INT(name='uncertaintySemi-major', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPointPosition_uncertaintySemi_major._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _AccessPointPosition_uncertaintySemi_minor = INT(name='uncertaintySemi-minor', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPointPosition_uncertaintySemi_minor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _AccessPointPosition_orientationOfMajorAxis = INT(name='orientationOfMajorAxis', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPointPosition_orientationOfMajorAxis._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    _AccessPointPosition_uncertaintyAltitude = INT(name='uncertaintyAltitude', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPointPosition_uncertaintyAltitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _AccessPointPosition_confidence = INT(name='confidence', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPointPosition_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _AccessPointPosition_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AccessPointPosition_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AccessPointPosition_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____AccessPointPosition_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AccessPointPosition_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AccessPointPosition_iE_Extensions__item__id._const_tab = ____AccessPointPosition_iE_Extensions__item__id_tab
    ___AccessPointPosition_iE_Extensions__item__id._const_tab_at = None
    ___AccessPointPosition_iE_Extensions__item__id._const_tab_id = 'id'
    ___AccessPointPosition_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AccessPointPosition_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AccessPointPosition_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AccessPointPosition_iE_Extensions__item__criticality._const_tab = ____AccessPointPosition_iE_Extensions__item__criticality_tab
    ___AccessPointPosition_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AccessPointPosition_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AccessPointPosition_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AccessPointPosition_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AccessPointPosition_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AccessPointPosition_iE_Extensions__item__extensionValue._const_tab = ____AccessPointPosition_iE_Extensions__item__extensionValue_tab
    ___AccessPointPosition_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AccessPointPosition_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AccessPointPosition_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AccessPointPosition_iE_Extensions__item__id),
        ('criticality', ___AccessPointPosition_iE_Extensions__item__criticality),
        ('extensionValue', ___AccessPointPosition_iE_Extensions__item__extensionValue),
        ])
    __AccessPointPosition_iE_Extensions__item_._ext = None
    _AccessPointPosition_iE_Extensions._cont = __AccessPointPosition_iE_Extensions__item_
    _AccessPointPosition_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AccessPointPosition._cont = ASN1Dict([
        ('latitudeSign', _AccessPointPosition_latitudeSign),
        ('latitude', _AccessPointPosition_latitude),
        ('longitude', _AccessPointPosition_longitude),
        ('directionOfAltitude', _AccessPointPosition_directionOfAltitude),
        ('altitude', _AccessPointPosition_altitude),
        ('uncertaintySemi-major', _AccessPointPosition_uncertaintySemi_major),
        ('uncertaintySemi-minor', _AccessPointPosition_uncertaintySemi_minor),
        ('orientationOfMajorAxis', _AccessPointPosition_orientationOfMajorAxis),
        ('uncertaintyAltitude', _AccessPointPosition_uncertaintyAltitude),
        ('confidence', _AccessPointPosition_confidence),
        ('iE-Extensions', _AccessPointPosition_iE_Extensions),
        ])
    AccessPointPosition._ext = None
    
    #-----< AccessPointPosition-ExtIEs >-----#
    AccessPointPosition_ExtIEs = CLASS(name='AccessPointPosition-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    AccessPointPosition_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Activated-Cells-to-be-Updated-List >-----#
    Activated_Cells_to_be_Updated_List = SEQ_OF(name='Activated-Cells-to-be-Updated-List', mode=MODE_TYPE)
    _Activated_Cells_to_be_Updated_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Activated-Cells-to-be-Updated-List-Item')))
    Activated_Cells_to_be_Updated_List._cont = _Activated_Cells_to_be_Updated_List__item_
    Activated_Cells_to_be_Updated_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< Activated-Cells-to-be-Updated-List-Item >-----#
    Activated_Cells_to_be_Updated_List_Item = SEQ(name='Activated-Cells-to-be-Updated-List-Item', mode=MODE_TYPE)
    _Activated_Cells_to_be_Updated_List_Item_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Activated_Cells_to_be_Updated_List_Item_iAB_DU_Cell_Resource_Configuration_Mode_Info = CHOICE(name='iAB-DU-Cell-Resource-Configuration-Mode-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IAB-DU-Cell-Resource-Configuration-Mode-Info')))
    _Activated_Cells_to_be_Updated_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__id._const_tab = ____Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__id_tab
    ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__criticality._const_tab = ____Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__criticality_tab
    ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__extensionValue._const_tab = ____Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__extensionValue_tab
    ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__id),
        ('criticality', ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__extensionValue),
        ])
    __Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item_._ext = None
    _Activated_Cells_to_be_Updated_List_Item_iE_Extensions._cont = __Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item_
    _Activated_Cells_to_be_Updated_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Activated_Cells_to_be_Updated_List_Item._cont = ASN1Dict([
        ('nRCGI', _Activated_Cells_to_be_Updated_List_Item_nRCGI),
        ('iAB-DU-Cell-Resource-Configuration-Mode-Info', _Activated_Cells_to_be_Updated_List_Item_iAB_DU_Cell_Resource_Configuration_Mode_Info),
        ('iE-Extensions', _Activated_Cells_to_be_Updated_List_Item_iE_Extensions),
        ])
    Activated_Cells_to_be_Updated_List_Item._ext = None
    
    #-----< Activated-Cells-to-be-Updated-List-Item-ExtIEs >-----#
    Activated_Cells_to_be_Updated_List_Item_ExtIEs = CLASS(name='Activated-Cells-to-be-Updated-List-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Activated_Cells_to_be_Updated_List_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ActivationRequestType >-----#
    ActivationRequestType = ENUM(name='ActivationRequestType', mode=MODE_TYPE)
    ActivationRequestType._cont = ASN1Dict([('activate', 0), ('deactivate', 1)])
    ActivationRequestType._ext = []
    
    #-----< ActiveULBWP >-----#
    ActiveULBWP = SEQ(name='ActiveULBWP', mode=MODE_TYPE)
    _ActiveULBWP_locationAndBandwidth = INT(name='locationAndBandwidth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ActiveULBWP_locationAndBandwidth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=37949)], ev=[], er=[])
    _ActiveULBWP_subcarrierSpacing = ENUM(name='subcarrierSpacing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ActiveULBWP_subcarrierSpacing._cont = ASN1Dict([('kHz15', 0), ('kHz30', 1), ('kHz60', 2), ('kHz120', 3)])
    _ActiveULBWP_subcarrierSpacing._ext = []
    _ActiveULBWP_cyclicPrefix = ENUM(name='cyclicPrefix', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ActiveULBWP_cyclicPrefix._cont = ASN1Dict([('normal', 0), ('extended', 1)])
    _ActiveULBWP_cyclicPrefix._ext = None
    _ActiveULBWP_txDirectCurrentLocation = INT(name='txDirectCurrentLocation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ActiveULBWP_txDirectCurrentLocation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3301)], ev=[], er=[])
    _ActiveULBWP_shift7dot5kHz = ENUM(name='shift7dot5kHz', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ActiveULBWP_shift7dot5kHz._cont = ASN1Dict([('true', 0)])
    _ActiveULBWP_shift7dot5kHz._ext = []
    _ActiveULBWP_sRSConfig = SEQ(name='sRSConfig', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSConfig')))
    _ActiveULBWP_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ActiveULBWP_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ActiveULBWP_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ActiveULBWP_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ActiveULBWP_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ActiveULBWP_iE_Extensions__item__id._const_tab = ____ActiveULBWP_iE_Extensions__item__id_tab
    ___ActiveULBWP_iE_Extensions__item__id._const_tab_at = None
    ___ActiveULBWP_iE_Extensions__item__id._const_tab_id = 'id'
    ___ActiveULBWP_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ActiveULBWP_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ActiveULBWP_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ActiveULBWP_iE_Extensions__item__criticality._const_tab = ____ActiveULBWP_iE_Extensions__item__criticality_tab
    ___ActiveULBWP_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ActiveULBWP_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ActiveULBWP_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ActiveULBWP_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ActiveULBWP_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ActiveULBWP_iE_Extensions__item__extensionValue._const_tab = ____ActiveULBWP_iE_Extensions__item__extensionValue_tab
    ___ActiveULBWP_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ActiveULBWP_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ActiveULBWP_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ActiveULBWP_iE_Extensions__item__id),
        ('criticality', ___ActiveULBWP_iE_Extensions__item__criticality),
        ('extensionValue', ___ActiveULBWP_iE_Extensions__item__extensionValue),
        ])
    __ActiveULBWP_iE_Extensions__item_._ext = None
    _ActiveULBWP_iE_Extensions._cont = __ActiveULBWP_iE_Extensions__item_
    _ActiveULBWP_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ActiveULBWP._cont = ASN1Dict([
        ('locationAndBandwidth', _ActiveULBWP_locationAndBandwidth),
        ('subcarrierSpacing', _ActiveULBWP_subcarrierSpacing),
        ('cyclicPrefix', _ActiveULBWP_cyclicPrefix),
        ('txDirectCurrentLocation', _ActiveULBWP_txDirectCurrentLocation),
        ('shift7dot5kHz', _ActiveULBWP_shift7dot5kHz),
        ('sRSConfig', _ActiveULBWP_sRSConfig),
        ('iE-Extensions', _ActiveULBWP_iE_Extensions),
        ])
    ActiveULBWP._ext = None
    
    #-----< ActiveULBWP-ExtIEs >-----#
    ActiveULBWP_ExtIEs = CLASS(name='ActiveULBWP-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ActiveULBWP_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AdditionalDuplicationIndication >-----#
    AdditionalDuplicationIndication = ENUM(name='AdditionalDuplicationIndication', mode=MODE_TYPE)
    AdditionalDuplicationIndication._cont = ASN1Dict([('three', 0), ('four', 1)])
    AdditionalDuplicationIndication._ext = []
    
    #-----< AdditionalPath-List >-----#
    AdditionalPath_List = SEQ_OF(name='AdditionalPath-List', mode=MODE_TYPE)
    _AdditionalPath_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPath-Item')))
    AdditionalPath_List._cont = _AdditionalPath_List__item_
    AdditionalPath_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< AdditionalPath-Item >-----#
    AdditionalPath_Item = SEQ(name='AdditionalPath-Item', mode=MODE_TYPE)
    _AdditionalPath_Item_relativePathDelay = CHOICE(name='relativePathDelay', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RelativePathDelay')))
    _AdditionalPath_Item_pathQuality = SEQ(name='pathQuality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPMeasurementQuality')), opt=True)
    _AdditionalPath_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AdditionalPath_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AdditionalPath_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____AdditionalPath_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____AdditionalPath_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MultipleULAoA')))
    _____AdditionalPath_Item_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-SRS-RSRPP')))
    ____AdditionalPath_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 558), ('criticality', 'ignore'), ('Extension', _____AdditionalPath_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 636), ('criticality', 'ignore'), ('Extension', _____AdditionalPath_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___AdditionalPath_Item_iE_Extensions__item__id._const_tab = ____AdditionalPath_Item_iE_Extensions__item__id_tab
    ___AdditionalPath_Item_iE_Extensions__item__id._const_tab_at = None
    ___AdditionalPath_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___AdditionalPath_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___AdditionalPath_Item_iE_Extensions__item__criticality._const_tab = ____AdditionalPath_Item_iE_Extensions__item__id_tab
    ___AdditionalPath_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AdditionalPath_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AdditionalPath_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___AdditionalPath_Item_iE_Extensions__item__extensionValue._const_tab = ____AdditionalPath_Item_iE_Extensions__item__id_tab
    ___AdditionalPath_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AdditionalPath_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AdditionalPath_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AdditionalPath_Item_iE_Extensions__item__id),
        ('criticality', ___AdditionalPath_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___AdditionalPath_Item_iE_Extensions__item__extensionValue),
        ])
    __AdditionalPath_Item_iE_Extensions__item_._ext = None
    _AdditionalPath_Item_iE_Extensions._cont = __AdditionalPath_Item_iE_Extensions__item_
    _AdditionalPath_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AdditionalPath_Item._cont = ASN1Dict([
        ('relativePathDelay', _AdditionalPath_Item_relativePathDelay),
        ('pathQuality', _AdditionalPath_Item_pathQuality),
        ('iE-Extensions', _AdditionalPath_Item_iE_Extensions),
        ])
    AdditionalPath_Item._ext = None
    
    #-----< AdditionalPath-Item-ExtIEs >-----#
    AdditionalPath_Item_ExtIEs = CLASS(name='AdditionalPath-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _AdditionalPath_Item_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MultipleULAoA')))
    _AdditionalPath_Item_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-SRS-RSRPP')))
    AdditionalPath_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 558), ('criticality', 'ignore'), ('Extension', _AdditionalPath_Item_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 636), ('criticality', 'ignore'), ('Extension', _AdditionalPath_Item_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ExtendedAdditionalPathList >-----#
    ExtendedAdditionalPathList = SEQ_OF(name='ExtendedAdditionalPathList', mode=MODE_TYPE)
    _ExtendedAdditionalPathList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedAdditionalPathList-Item')))
    ExtendedAdditionalPathList._cont = _ExtendedAdditionalPathList__item_
    ExtendedAdditionalPathList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ExtendedAdditionalPathList-Item >-----#
    ExtendedAdditionalPathList_Item = SEQ(name='ExtendedAdditionalPathList-Item', mode=MODE_TYPE)
    _ExtendedAdditionalPathList_Item_relativeTimeOfPath = CHOICE(name='relativeTimeOfPath', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RelativePathDelay')))
    _ExtendedAdditionalPathList_Item_pathQuality = SEQ(name='pathQuality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPMeasurementQuality')), opt=True)
    _ExtendedAdditionalPathList_Item_multipleULAoA = SEQ(name='multipleULAoA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MultipleULAoA')), opt=True)
    _ExtendedAdditionalPathList_Item_pathPower = SEQ(name='pathPower', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UL-SRS-RSRPP')), opt=True)
    _ExtendedAdditionalPathList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExtendedAdditionalPathList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ExtendedAdditionalPathList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ExtendedAdditionalPathList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ExtendedAdditionalPathList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtendedAdditionalPathList_Item_iE_Extensions__item__id._const_tab = ____ExtendedAdditionalPathList_Item_iE_Extensions__item__id_tab
    ___ExtendedAdditionalPathList_Item_iE_Extensions__item__id._const_tab_at = None
    ___ExtendedAdditionalPathList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ExtendedAdditionalPathList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ExtendedAdditionalPathList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ExtendedAdditionalPathList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtendedAdditionalPathList_Item_iE_Extensions__item__criticality._const_tab = ____ExtendedAdditionalPathList_Item_iE_Extensions__item__criticality_tab
    ___ExtendedAdditionalPathList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ExtendedAdditionalPathList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ExtendedAdditionalPathList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ExtendedAdditionalPathList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ExtendedAdditionalPathList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtendedAdditionalPathList_Item_iE_Extensions__item__extensionValue._const_tab = ____ExtendedAdditionalPathList_Item_iE_Extensions__item__extensionValue_tab
    ___ExtendedAdditionalPathList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ExtendedAdditionalPathList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ExtendedAdditionalPathList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ExtendedAdditionalPathList_Item_iE_Extensions__item__id),
        ('criticality', ___ExtendedAdditionalPathList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ExtendedAdditionalPathList_Item_iE_Extensions__item__extensionValue),
        ])
    __ExtendedAdditionalPathList_Item_iE_Extensions__item_._ext = None
    _ExtendedAdditionalPathList_Item_iE_Extensions._cont = __ExtendedAdditionalPathList_Item_iE_Extensions__item_
    _ExtendedAdditionalPathList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExtendedAdditionalPathList_Item._cont = ASN1Dict([
        ('relativeTimeOfPath', _ExtendedAdditionalPathList_Item_relativeTimeOfPath),
        ('pathQuality', _ExtendedAdditionalPathList_Item_pathQuality),
        ('multipleULAoA', _ExtendedAdditionalPathList_Item_multipleULAoA),
        ('pathPower', _ExtendedAdditionalPathList_Item_pathPower),
        ('iE-Extensions', _ExtendedAdditionalPathList_Item_iE_Extensions),
        ])
    ExtendedAdditionalPathList_Item._ext = []
    
    #-----< ExtendedAdditionalPathList-Item-ExtIEs >-----#
    ExtendedAdditionalPathList_Item_ExtIEs = CLASS(name='ExtendedAdditionalPathList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ExtendedAdditionalPathList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AdditionalPDCPDuplicationTNL-List >-----#
    AdditionalPDCPDuplicationTNL_List = SEQ_OF(name='AdditionalPDCPDuplicationTNL-List', mode=MODE_TYPE)
    _AdditionalPDCPDuplicationTNL_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-Item')))
    AdditionalPDCPDuplicationTNL_List._cont = _AdditionalPDCPDuplicationTNL_List__item_
    AdditionalPDCPDuplicationTNL_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< AdditionalPDCPDuplicationTNL-Item >-----#
    AdditionalPDCPDuplicationTNL_Item = SEQ(name='AdditionalPDCPDuplicationTNL-Item', mode=MODE_TYPE)
    _AdditionalPDCPDuplicationTNL_Item_additionalPDCPDuplicationUPTNLInformation = CHOICE(name='additionalPDCPDuplicationUPTNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UPTransportLayerInformation')))
    _AdditionalPDCPDuplicationTNL_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHInfo')))
    ____AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'ignore'), ('Extension', _____AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id._const_tab = ____AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id_tab
    ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id._const_tab_at = None
    ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__criticality._const_tab = ____AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id_tab
    ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__extensionValue._const_tab = ____AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id_tab
    ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id),
        ('criticality', ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__extensionValue),
        ])
    __AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item_._ext = None
    _AdditionalPDCPDuplicationTNL_Item_iE_Extensions._cont = __AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item_
    _AdditionalPDCPDuplicationTNL_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AdditionalPDCPDuplicationTNL_Item._cont = ASN1Dict([
        ('additionalPDCPDuplicationUPTNLInformation', _AdditionalPDCPDuplicationTNL_Item_additionalPDCPDuplicationUPTNLInformation),
        ('iE-Extensions', _AdditionalPDCPDuplicationTNL_Item_iE_Extensions),
        ])
    AdditionalPDCPDuplicationTNL_Item._ext = []
    
    #-----< AdditionalPDCPDuplicationTNL-ItemExtIEs >-----#
    AdditionalPDCPDuplicationTNL_ItemExtIEs = CLASS(name='AdditionalPDCPDuplicationTNL-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _AdditionalPDCPDuplicationTNL_ItemExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHInfo')))
    AdditionalPDCPDuplicationTNL_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'ignore'), ('Extension', _AdditionalPDCPDuplicationTNL_ItemExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< AdditionalSIBMessageList >-----#
    AdditionalSIBMessageList = SEQ_OF(name='AdditionalSIBMessageList', mode=MODE_TYPE)
    _AdditionalSIBMessageList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalSIBMessageList-Item')))
    AdditionalSIBMessageList._cont = _AdditionalSIBMessageList__item_
    AdditionalSIBMessageList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    
    #-----< AdditionalSIBMessageList-Item >-----#
    AdditionalSIBMessageList_Item = SEQ(name='AdditionalSIBMessageList-Item', mode=MODE_TYPE)
    _AdditionalSIBMessageList_Item_additionalSIB = OCT_STR(name='additionalSIB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AdditionalSIBMessageList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AdditionalSIBMessageList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AdditionalSIBMessageList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____AdditionalSIBMessageList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AdditionalSIBMessageList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalSIBMessageList_Item_iE_Extensions__item__id._const_tab = ____AdditionalSIBMessageList_Item_iE_Extensions__item__id_tab
    ___AdditionalSIBMessageList_Item_iE_Extensions__item__id._const_tab_at = None
    ___AdditionalSIBMessageList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___AdditionalSIBMessageList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AdditionalSIBMessageList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AdditionalSIBMessageList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalSIBMessageList_Item_iE_Extensions__item__criticality._const_tab = ____AdditionalSIBMessageList_Item_iE_Extensions__item__criticality_tab
    ___AdditionalSIBMessageList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AdditionalSIBMessageList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AdditionalSIBMessageList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AdditionalSIBMessageList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AdditionalSIBMessageList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalSIBMessageList_Item_iE_Extensions__item__extensionValue._const_tab = ____AdditionalSIBMessageList_Item_iE_Extensions__item__extensionValue_tab
    ___AdditionalSIBMessageList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AdditionalSIBMessageList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AdditionalSIBMessageList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AdditionalSIBMessageList_Item_iE_Extensions__item__id),
        ('criticality', ___AdditionalSIBMessageList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___AdditionalSIBMessageList_Item_iE_Extensions__item__extensionValue),
        ])
    __AdditionalSIBMessageList_Item_iE_Extensions__item_._ext = None
    _AdditionalSIBMessageList_Item_iE_Extensions._cont = __AdditionalSIBMessageList_Item_iE_Extensions__item_
    _AdditionalSIBMessageList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AdditionalSIBMessageList_Item._cont = ASN1Dict([
        ('additionalSIB', _AdditionalSIBMessageList_Item_additionalSIB),
        ('iE-Extensions', _AdditionalSIBMessageList_Item_iE_Extensions),
        ])
    AdditionalSIBMessageList_Item._ext = None
    
    #-----< AdditionalSIBMessageList-Item-ExtIEs >-----#
    AdditionalSIBMessageList_Item_ExtIEs = CLASS(name='AdditionalSIBMessageList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    AdditionalSIBMessageList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AdditionalRRMPriorityIndex >-----#
    AdditionalRRMPriorityIndex = BIT_STR(name='AdditionalRRMPriorityIndex', mode=MODE_TYPE)
    AdditionalRRMPriorityIndex._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< AffectedCellsAndBeams-List >-----#
    AffectedCellsAndBeams_List = SEQ_OF(name='AffectedCellsAndBeams-List', mode=MODE_TYPE)
    _AffectedCellsAndBeams_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AffectedCellsAndBeams-Item')))
    AffectedCellsAndBeams_List._cont = _AffectedCellsAndBeams_List__item_
    AffectedCellsAndBeams_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< AffectedCellsAndBeams-Item >-----#
    AffectedCellsAndBeams_Item = SEQ(name='AffectedCellsAndBeams-Item', mode=MODE_TYPE)
    _AffectedCellsAndBeams_Item_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _AffectedCellsAndBeams_Item_affectedSSB_List = SEQ_OF(name='affectedSSB-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AffectedSSB-List')), opt=True)
    _AffectedCellsAndBeams_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AffectedCellsAndBeams_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AffectedCellsAndBeams_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____AffectedCellsAndBeams_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AffectedCellsAndBeams_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AffectedCellsAndBeams_Item_iE_Extensions__item__id._const_tab = ____AffectedCellsAndBeams_Item_iE_Extensions__item__id_tab
    ___AffectedCellsAndBeams_Item_iE_Extensions__item__id._const_tab_at = None
    ___AffectedCellsAndBeams_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___AffectedCellsAndBeams_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AffectedCellsAndBeams_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AffectedCellsAndBeams_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AffectedCellsAndBeams_Item_iE_Extensions__item__criticality._const_tab = ____AffectedCellsAndBeams_Item_iE_Extensions__item__criticality_tab
    ___AffectedCellsAndBeams_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AffectedCellsAndBeams_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AffectedCellsAndBeams_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AffectedCellsAndBeams_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AffectedCellsAndBeams_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AffectedCellsAndBeams_Item_iE_Extensions__item__extensionValue._const_tab = ____AffectedCellsAndBeams_Item_iE_Extensions__item__extensionValue_tab
    ___AffectedCellsAndBeams_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AffectedCellsAndBeams_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AffectedCellsAndBeams_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AffectedCellsAndBeams_Item_iE_Extensions__item__id),
        ('criticality', ___AffectedCellsAndBeams_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___AffectedCellsAndBeams_Item_iE_Extensions__item__extensionValue),
        ])
    __AffectedCellsAndBeams_Item_iE_Extensions__item_._ext = None
    _AffectedCellsAndBeams_Item_iE_Extensions._cont = __AffectedCellsAndBeams_Item_iE_Extensions__item_
    _AffectedCellsAndBeams_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AffectedCellsAndBeams_Item._cont = ASN1Dict([
        ('nRCGI', _AffectedCellsAndBeams_Item_nRCGI),
        ('affectedSSB-List', _AffectedCellsAndBeams_Item_affectedSSB_List),
        ('iE-Extensions', _AffectedCellsAndBeams_Item_iE_Extensions),
        ])
    AffectedCellsAndBeams_Item._ext = []
    
    #-----< AffectedCellsAndBeams-Item-ExtIEs >-----#
    AffectedCellsAndBeams_Item_ExtIEs = CLASS(name='AffectedCellsAndBeams-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    AffectedCellsAndBeams_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AffectedSSB-List >-----#
    AffectedSSB_List = SEQ_OF(name='AffectedSSB-List', mode=MODE_TYPE)
    _AffectedSSB_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AffectedSSB-Item')))
    AffectedSSB_List._cont = _AffectedSSB_List__item_
    AffectedSSB_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< AffectedSSB-Item >-----#
    AffectedSSB_Item = SEQ(name='AffectedSSB-Item', mode=MODE_TYPE)
    _AffectedSSB_Item_sSB_Index = INT(name='sSB-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AffectedSSB_Item_sSB_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _AffectedSSB_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AffectedSSB_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AffectedSSB_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____AffectedSSB_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AffectedSSB_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AffectedSSB_Item_iE_Extensions__item__id._const_tab = ____AffectedSSB_Item_iE_Extensions__item__id_tab
    ___AffectedSSB_Item_iE_Extensions__item__id._const_tab_at = None
    ___AffectedSSB_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___AffectedSSB_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AffectedSSB_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AffectedSSB_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AffectedSSB_Item_iE_Extensions__item__criticality._const_tab = ____AffectedSSB_Item_iE_Extensions__item__criticality_tab
    ___AffectedSSB_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AffectedSSB_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AffectedSSB_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AffectedSSB_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AffectedSSB_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AffectedSSB_Item_iE_Extensions__item__extensionValue._const_tab = ____AffectedSSB_Item_iE_Extensions__item__extensionValue_tab
    ___AffectedSSB_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AffectedSSB_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AffectedSSB_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AffectedSSB_Item_iE_Extensions__item__id),
        ('criticality', ___AffectedSSB_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___AffectedSSB_Item_iE_Extensions__item__extensionValue),
        ])
    __AffectedSSB_Item_iE_Extensions__item_._ext = None
    _AffectedSSB_Item_iE_Extensions._cont = __AffectedSSB_Item_iE_Extensions__item_
    _AffectedSSB_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AffectedSSB_Item._cont = ASN1Dict([
        ('sSB-Index', _AffectedSSB_Item_sSB_Index),
        ('iE-Extensions', _AffectedSSB_Item_iE_Extensions),
        ])
    AffectedSSB_Item._ext = []
    
    #-----< AffectedSSB-Item-ExtIEs >-----#
    AffectedSSB_Item_ExtIEs = CLASS(name='AffectedSSB-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    AffectedSSB_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AggressorCellList >-----#
    AggressorCellList = SEQ_OF(name='AggressorCellList', mode=MODE_TYPE)
    _AggressorCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AggressorCellList-Item')))
    AggressorCellList._cont = _AggressorCellList__item_
    AggressorCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< AggressorCellList-Item >-----#
    AggressorCellList_Item = SEQ(name='AggressorCellList-Item', mode=MODE_TYPE)
    _AggressorCellList_Item_aggressorCell_ID = SEQ(name='aggressorCell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _AggressorCellList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AggressorCellList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AggressorCellList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____AggressorCellList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AggressorCellList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AggressorCellList_Item_iE_Extensions__item__id._const_tab = ____AggressorCellList_Item_iE_Extensions__item__id_tab
    ___AggressorCellList_Item_iE_Extensions__item__id._const_tab_at = None
    ___AggressorCellList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___AggressorCellList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AggressorCellList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AggressorCellList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AggressorCellList_Item_iE_Extensions__item__criticality._const_tab = ____AggressorCellList_Item_iE_Extensions__item__criticality_tab
    ___AggressorCellList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AggressorCellList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AggressorCellList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AggressorCellList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AggressorCellList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AggressorCellList_Item_iE_Extensions__item__extensionValue._const_tab = ____AggressorCellList_Item_iE_Extensions__item__extensionValue_tab
    ___AggressorCellList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AggressorCellList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AggressorCellList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AggressorCellList_Item_iE_Extensions__item__id),
        ('criticality', ___AggressorCellList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___AggressorCellList_Item_iE_Extensions__item__extensionValue),
        ])
    __AggressorCellList_Item_iE_Extensions__item_._ext = None
    _AggressorCellList_Item_iE_Extensions._cont = __AggressorCellList_Item_iE_Extensions__item_
    _AggressorCellList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AggressorCellList_Item._cont = ASN1Dict([
        ('aggressorCell-ID', _AggressorCellList_Item_aggressorCell_ID),
        ('iE-Extensions', _AggressorCellList_Item_iE_Extensions),
        ])
    AggressorCellList_Item._ext = None
    
    #-----< AggressorCellList-Item-ExtIEs >-----#
    AggressorCellList_Item_ExtIEs = CLASS(name='AggressorCellList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    AggressorCellList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AggressorgNBSetID >-----#
    AggressorgNBSetID = SEQ(name='AggressorgNBSetID', mode=MODE_TYPE)
    _AggressorgNBSetID_aggressorgNBSetID = BIT_STR(name='aggressorgNBSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNBSetID')))
    _AggressorgNBSetID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AggressorgNBSetID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AggressorgNBSetID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____AggressorgNBSetID_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AggressorgNBSetID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AggressorgNBSetID_iE_Extensions__item__id._const_tab = ____AggressorgNBSetID_iE_Extensions__item__id_tab
    ___AggressorgNBSetID_iE_Extensions__item__id._const_tab_at = None
    ___AggressorgNBSetID_iE_Extensions__item__id._const_tab_id = 'id'
    ___AggressorgNBSetID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AggressorgNBSetID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AggressorgNBSetID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AggressorgNBSetID_iE_Extensions__item__criticality._const_tab = ____AggressorgNBSetID_iE_Extensions__item__criticality_tab
    ___AggressorgNBSetID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AggressorgNBSetID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AggressorgNBSetID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AggressorgNBSetID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AggressorgNBSetID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AggressorgNBSetID_iE_Extensions__item__extensionValue._const_tab = ____AggressorgNBSetID_iE_Extensions__item__extensionValue_tab
    ___AggressorgNBSetID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AggressorgNBSetID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AggressorgNBSetID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AggressorgNBSetID_iE_Extensions__item__id),
        ('criticality', ___AggressorgNBSetID_iE_Extensions__item__criticality),
        ('extensionValue', ___AggressorgNBSetID_iE_Extensions__item__extensionValue),
        ])
    __AggressorgNBSetID_iE_Extensions__item_._ext = None
    _AggressorgNBSetID_iE_Extensions._cont = __AggressorgNBSetID_iE_Extensions__item_
    _AggressorgNBSetID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AggressorgNBSetID._cont = ASN1Dict([
        ('aggressorgNBSetID', _AggressorgNBSetID_aggressorgNBSetID),
        ('iE-Extensions', _AggressorgNBSetID_iE_Extensions),
        ])
    AggressorgNBSetID._ext = None
    
    #-----< AggressorgNBSetID-ExtIEs >-----#
    AggressorgNBSetID_ExtIEs = CLASS(name='AggressorgNBSetID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    AggressorgNBSetID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AllocationAndRetentionPriority >-----#
    AllocationAndRetentionPriority = SEQ(name='AllocationAndRetentionPriority', mode=MODE_TYPE)
    _AllocationAndRetentionPriority_priorityLevel = INT(name='priorityLevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PriorityLevel')))
    _AllocationAndRetentionPriority_pre_emptionCapability = ENUM(name='pre-emptionCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Pre-emptionCapability')))
    _AllocationAndRetentionPriority_pre_emptionVulnerability = ENUM(name='pre-emptionVulnerability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Pre-emptionVulnerability')))
    _AllocationAndRetentionPriority_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AllocationAndRetentionPriority_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AllocationAndRetentionPriority_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_at = None
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_id = 'id'
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AllocationAndRetentionPriority_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AllocationAndRetentionPriority_iE_Extensions__item__id),
        ('criticality', ___AllocationAndRetentionPriority_iE_Extensions__item__criticality),
        ('extensionValue', ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue),
        ])
    __AllocationAndRetentionPriority_iE_Extensions__item_._ext = None
    _AllocationAndRetentionPriority_iE_Extensions._cont = __AllocationAndRetentionPriority_iE_Extensions__item_
    _AllocationAndRetentionPriority_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AllocationAndRetentionPriority._cont = ASN1Dict([
        ('priorityLevel', _AllocationAndRetentionPriority_priorityLevel),
        ('pre-emptionCapability', _AllocationAndRetentionPriority_pre_emptionCapability),
        ('pre-emptionVulnerability', _AllocationAndRetentionPriority_pre_emptionVulnerability),
        ('iE-Extensions', _AllocationAndRetentionPriority_iE_Extensions),
        ])
    AllocationAndRetentionPriority._ext = []
    
    #-----< AllocationAndRetentionPriority-ExtIEs >-----#
    AllocationAndRetentionPriority_ExtIEs = CLASS(name='AllocationAndRetentionPriority-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    AllocationAndRetentionPriority_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AlternativeQoSParaSetList >-----#
    AlternativeQoSParaSetList = SEQ_OF(name='AlternativeQoSParaSetList', mode=MODE_TYPE)
    _AlternativeQoSParaSetList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AlternativeQoSParaSetItem')))
    AlternativeQoSParaSetList._cont = _AlternativeQoSParaSetList__item_
    AlternativeQoSParaSetList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< AlternativeQoSParaSetItem >-----#
    AlternativeQoSParaSetItem = SEQ(name='AlternativeQoSParaSetItem', mode=MODE_TYPE)
    _AlternativeQoSParaSetItem_alternativeQoSParaSetIndex = INT(name='alternativeQoSParaSetIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSParaSetIndex')))
    _AlternativeQoSParaSetItem_guaranteedFlowBitRateDL = INT(name='guaranteedFlowBitRateDL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')), opt=True)
    _AlternativeQoSParaSetItem_guaranteedFlowBitRateUL = INT(name='guaranteedFlowBitRateUL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')), opt=True)
    _AlternativeQoSParaSetItem_packetDelayBudget = INT(name='packetDelayBudget', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PacketDelayBudget')), opt=True)
    _AlternativeQoSParaSetItem_packetErrorRate = SEQ(name='packetErrorRate', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PacketErrorRate')), opt=True)
    _AlternativeQoSParaSetItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AlternativeQoSParaSetItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AlternativeQoSParaSetItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AlternativeQoSParaSetItem_iE_Extensions__item__id._const_tab = ____AlternativeQoSParaSetItem_iE_Extensions__item__id_tab
    ___AlternativeQoSParaSetItem_iE_Extensions__item__id._const_tab_at = None
    ___AlternativeQoSParaSetItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality._const_tab = ____AlternativeQoSParaSetItem_iE_Extensions__item__criticality_tab
    ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue._const_tab = ____AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue_tab
    ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AlternativeQoSParaSetItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AlternativeQoSParaSetItem_iE_Extensions__item__id),
        ('criticality', ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality),
        ('extensionValue', ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue),
        ])
    __AlternativeQoSParaSetItem_iE_Extensions__item_._ext = None
    _AlternativeQoSParaSetItem_iE_Extensions._cont = __AlternativeQoSParaSetItem_iE_Extensions__item_
    _AlternativeQoSParaSetItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AlternativeQoSParaSetItem._cont = ASN1Dict([
        ('alternativeQoSParaSetIndex', _AlternativeQoSParaSetItem_alternativeQoSParaSetIndex),
        ('guaranteedFlowBitRateDL', _AlternativeQoSParaSetItem_guaranteedFlowBitRateDL),
        ('guaranteedFlowBitRateUL', _AlternativeQoSParaSetItem_guaranteedFlowBitRateUL),
        ('packetDelayBudget', _AlternativeQoSParaSetItem_packetDelayBudget),
        ('packetErrorRate', _AlternativeQoSParaSetItem_packetErrorRate),
        ('iE-Extensions', _AlternativeQoSParaSetItem_iE_Extensions),
        ])
    AlternativeQoSParaSetItem._ext = []
    
    #-----< AlternativeQoSParaSetItem-ExtIEs >-----#
    AlternativeQoSParaSetItem_ExtIEs = CLASS(name='AlternativeQoSParaSetItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    AlternativeQoSParaSetItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AngleMeasurementQuality >-----#
    AngleMeasurementQuality = SEQ(name='AngleMeasurementQuality', mode=MODE_TYPE)
    _AngleMeasurementQuality_azimuthQuality = INT(name='azimuthQuality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AngleMeasurementQuality_azimuthQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _AngleMeasurementQuality_zenithQuality = INT(name='zenithQuality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AngleMeasurementQuality_zenithQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _AngleMeasurementQuality_resolution = ENUM(name='resolution', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AngleMeasurementQuality_resolution._cont = ASN1Dict([('deg0dot1', 0)])
    _AngleMeasurementQuality_resolution._ext = []
    _AngleMeasurementQuality_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AngleMeasurementQuality_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AngleMeasurementQuality_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____AngleMeasurementQuality_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AngleMeasurementQuality_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AngleMeasurementQuality_iE_Extensions__item__id._const_tab = ____AngleMeasurementQuality_iE_Extensions__item__id_tab
    ___AngleMeasurementQuality_iE_Extensions__item__id._const_tab_at = None
    ___AngleMeasurementQuality_iE_Extensions__item__id._const_tab_id = 'id'
    ___AngleMeasurementQuality_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AngleMeasurementQuality_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AngleMeasurementQuality_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AngleMeasurementQuality_iE_Extensions__item__criticality._const_tab = ____AngleMeasurementQuality_iE_Extensions__item__criticality_tab
    ___AngleMeasurementQuality_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AngleMeasurementQuality_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AngleMeasurementQuality_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AngleMeasurementQuality_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AngleMeasurementQuality_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AngleMeasurementQuality_iE_Extensions__item__extensionValue._const_tab = ____AngleMeasurementQuality_iE_Extensions__item__extensionValue_tab
    ___AngleMeasurementQuality_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AngleMeasurementQuality_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AngleMeasurementQuality_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AngleMeasurementQuality_iE_Extensions__item__id),
        ('criticality', ___AngleMeasurementQuality_iE_Extensions__item__criticality),
        ('extensionValue', ___AngleMeasurementQuality_iE_Extensions__item__extensionValue),
        ])
    __AngleMeasurementQuality_iE_Extensions__item_._ext = None
    _AngleMeasurementQuality_iE_Extensions._cont = __AngleMeasurementQuality_iE_Extensions__item_
    _AngleMeasurementQuality_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AngleMeasurementQuality._cont = ASN1Dict([
        ('azimuthQuality', _AngleMeasurementQuality_azimuthQuality),
        ('zenithQuality', _AngleMeasurementQuality_zenithQuality),
        ('resolution', _AngleMeasurementQuality_resolution),
        ('iE-Extensions', _AngleMeasurementQuality_iE_Extensions),
        ])
    AngleMeasurementQuality._ext = None
    
    #-----< AngleMeasurementQuality-ExtIEs >-----#
    AngleMeasurementQuality_ExtIEs = CLASS(name='AngleMeasurementQuality-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    AngleMeasurementQuality_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AperiodicSRSResourceTriggerList >-----#
    AperiodicSRSResourceTriggerList = SEQ_OF(name='AperiodicSRSResourceTriggerList', mode=MODE_TYPE)
    _AperiodicSRSResourceTriggerList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AperiodicSRSResourceTrigger')))
    AperiodicSRSResourceTriggerList._cont = _AperiodicSRSResourceTriggerList__item_
    AperiodicSRSResourceTriggerList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< AperiodicSRSResourceTrigger >-----#
    AperiodicSRSResourceTrigger = INT(name='AperiodicSRSResourceTrigger', mode=MODE_TYPE)
    AperiodicSRSResourceTrigger._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< Associated-SCell-Item >-----#
    Associated_SCell_Item = SEQ(name='Associated-SCell-Item', mode=MODE_TYPE)
    _Associated_SCell_Item_sCell_ID = SEQ(name='sCell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Associated_SCell_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Associated_SCell_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Associated_SCell_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Associated_SCell_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Associated_SCell_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Associated_SCell_Item_iE_Extensions__item__id._const_tab = ____Associated_SCell_Item_iE_Extensions__item__id_tab
    ___Associated_SCell_Item_iE_Extensions__item__id._const_tab_at = None
    ___Associated_SCell_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Associated_SCell_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Associated_SCell_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Associated_SCell_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Associated_SCell_Item_iE_Extensions__item__criticality._const_tab = ____Associated_SCell_Item_iE_Extensions__item__criticality_tab
    ___Associated_SCell_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Associated_SCell_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Associated_SCell_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Associated_SCell_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Associated_SCell_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Associated_SCell_Item_iE_Extensions__item__extensionValue._const_tab = ____Associated_SCell_Item_iE_Extensions__item__extensionValue_tab
    ___Associated_SCell_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Associated_SCell_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Associated_SCell_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Associated_SCell_Item_iE_Extensions__item__id),
        ('criticality', ___Associated_SCell_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Associated_SCell_Item_iE_Extensions__item__extensionValue),
        ])
    __Associated_SCell_Item_iE_Extensions__item_._ext = None
    _Associated_SCell_Item_iE_Extensions._cont = __Associated_SCell_Item_iE_Extensions__item_
    _Associated_SCell_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Associated_SCell_Item._cont = ASN1Dict([
        ('sCell-ID', _Associated_SCell_Item_sCell_ID),
        ('iE-Extensions', _Associated_SCell_Item_iE_Extensions),
        ])
    Associated_SCell_Item._ext = None
    
    #-----< Associated-SCell-ItemExtIEs >-----#
    Associated_SCell_ItemExtIEs = CLASS(name='Associated-SCell-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Associated_SCell_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AvailablePLMNList >-----#
    AvailablePLMNList = SEQ_OF(name='AvailablePLMNList', mode=MODE_TYPE)
    _AvailablePLMNList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AvailablePLMNList-Item')))
    AvailablePLMNList._cont = _AvailablePLMNList__item_
    AvailablePLMNList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< AvailablePLMNList-Item >-----#
    AvailablePLMNList_Item = SEQ(name='AvailablePLMNList-Item', mode=MODE_TYPE)
    _AvailablePLMNList_Item_pLMNIdentity = OCT_STR(name='pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _AvailablePLMNList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AvailablePLMNList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AvailablePLMNList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____AvailablePLMNList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AvailablePLMNList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AvailablePLMNList_Item_iE_Extensions__item__id._const_tab = ____AvailablePLMNList_Item_iE_Extensions__item__id_tab
    ___AvailablePLMNList_Item_iE_Extensions__item__id._const_tab_at = None
    ___AvailablePLMNList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___AvailablePLMNList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AvailablePLMNList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AvailablePLMNList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AvailablePLMNList_Item_iE_Extensions__item__criticality._const_tab = ____AvailablePLMNList_Item_iE_Extensions__item__criticality_tab
    ___AvailablePLMNList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AvailablePLMNList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AvailablePLMNList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AvailablePLMNList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AvailablePLMNList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AvailablePLMNList_Item_iE_Extensions__item__extensionValue._const_tab = ____AvailablePLMNList_Item_iE_Extensions__item__extensionValue_tab
    ___AvailablePLMNList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AvailablePLMNList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AvailablePLMNList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AvailablePLMNList_Item_iE_Extensions__item__id),
        ('criticality', ___AvailablePLMNList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___AvailablePLMNList_Item_iE_Extensions__item__extensionValue),
        ])
    __AvailablePLMNList_Item_iE_Extensions__item_._ext = None
    _AvailablePLMNList_Item_iE_Extensions._cont = __AvailablePLMNList_Item_iE_Extensions__item_
    _AvailablePLMNList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AvailablePLMNList_Item._cont = ASN1Dict([
        ('pLMNIdentity', _AvailablePLMNList_Item_pLMNIdentity),
        ('iE-Extensions', _AvailablePLMNList_Item_iE_Extensions),
        ])
    AvailablePLMNList_Item._ext = None
    
    #-----< AvailablePLMNList-Item-ExtIEs >-----#
    AvailablePLMNList_Item_ExtIEs = CLASS(name='AvailablePLMNList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    AvailablePLMNList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AvailableSNPN-ID-List >-----#
    AvailableSNPN_ID_List = SEQ_OF(name='AvailableSNPN-ID-List', mode=MODE_TYPE)
    _AvailableSNPN_ID_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AvailableSNPN-ID-List-Item')))
    AvailableSNPN_ID_List._cont = _AvailableSNPN_ID_List__item_
    AvailableSNPN_ID_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< AvailableSNPN-ID-List-Item >-----#
    AvailableSNPN_ID_List_Item = SEQ(name='AvailableSNPN-ID-List-Item', mode=MODE_TYPE)
    _AvailableSNPN_ID_List_Item_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _AvailableSNPN_ID_List_Item_availableNIDList = SEQ_OF(name='availableNIDList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BroadcastNIDList')))
    _AvailableSNPN_ID_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AvailableSNPN_ID_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AvailableSNPN_ID_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____AvailableSNPN_ID_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AvailableSNPN_ID_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AvailableSNPN_ID_List_Item_iE_Extensions__item__id._const_tab = ____AvailableSNPN_ID_List_Item_iE_Extensions__item__id_tab
    ___AvailableSNPN_ID_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___AvailableSNPN_ID_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___AvailableSNPN_ID_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AvailableSNPN_ID_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AvailableSNPN_ID_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AvailableSNPN_ID_List_Item_iE_Extensions__item__criticality._const_tab = ____AvailableSNPN_ID_List_Item_iE_Extensions__item__criticality_tab
    ___AvailableSNPN_ID_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AvailableSNPN_ID_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AvailableSNPN_ID_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AvailableSNPN_ID_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AvailableSNPN_ID_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AvailableSNPN_ID_List_Item_iE_Extensions__item__extensionValue._const_tab = ____AvailableSNPN_ID_List_Item_iE_Extensions__item__extensionValue_tab
    ___AvailableSNPN_ID_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AvailableSNPN_ID_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AvailableSNPN_ID_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AvailableSNPN_ID_List_Item_iE_Extensions__item__id),
        ('criticality', ___AvailableSNPN_ID_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___AvailableSNPN_ID_List_Item_iE_Extensions__item__extensionValue),
        ])
    __AvailableSNPN_ID_List_Item_iE_Extensions__item_._ext = None
    _AvailableSNPN_ID_List_Item_iE_Extensions._cont = __AvailableSNPN_ID_List_Item_iE_Extensions__item_
    _AvailableSNPN_ID_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AvailableSNPN_ID_List_Item._cont = ASN1Dict([
        ('pLMN-Identity', _AvailableSNPN_ID_List_Item_pLMN_Identity),
        ('availableNIDList', _AvailableSNPN_ID_List_Item_availableNIDList),
        ('iE-Extensions', _AvailableSNPN_ID_List_Item_iE_Extensions),
        ])
    AvailableSNPN_ID_List_Item._ext = []
    
    #-----< AvailableSNPN-ID-List-ItemExtIEs >-----#
    AvailableSNPN_ID_List_ItemExtIEs = CLASS(name='AvailableSNPN-ID-List-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    AvailableSNPN_ID_List_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AveragingWindow >-----#
    AveragingWindow = INT(name='AveragingWindow', mode=MODE_TYPE)
    AveragingWindow._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[])
    
    #-----< AreaScope >-----#
    AreaScope = ENUM(name='AreaScope', mode=MODE_TYPE)
    AreaScope._cont = ASN1Dict([('true', 0)])
    AreaScope._ext = []
    
    #-----< AoA-AssistanceInfo >-----#
    AoA_AssistanceInfo = SEQ(name='AoA-AssistanceInfo', mode=MODE_TYPE)
    _AoA_AssistanceInfo_angleMeasurement = CHOICE(name='angleMeasurement', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AngleMeasurementType')))
    _AoA_AssistanceInfo_lCS_to_GCS_Translation = SEQ(name='lCS-to-GCS-Translation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LCS-to-GCS-Translation')), opt=True)
    _AoA_AssistanceInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AoA_AssistanceInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AoA_AssistanceInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____AoA_AssistanceInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AoA_AssistanceInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AoA_AssistanceInfo_iE_Extensions__item__id._const_tab = ____AoA_AssistanceInfo_iE_Extensions__item__id_tab
    ___AoA_AssistanceInfo_iE_Extensions__item__id._const_tab_at = None
    ___AoA_AssistanceInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___AoA_AssistanceInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AoA_AssistanceInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AoA_AssistanceInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AoA_AssistanceInfo_iE_Extensions__item__criticality._const_tab = ____AoA_AssistanceInfo_iE_Extensions__item__criticality_tab
    ___AoA_AssistanceInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AoA_AssistanceInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AoA_AssistanceInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AoA_AssistanceInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AoA_AssistanceInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AoA_AssistanceInfo_iE_Extensions__item__extensionValue._const_tab = ____AoA_AssistanceInfo_iE_Extensions__item__extensionValue_tab
    ___AoA_AssistanceInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AoA_AssistanceInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AoA_AssistanceInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AoA_AssistanceInfo_iE_Extensions__item__id),
        ('criticality', ___AoA_AssistanceInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___AoA_AssistanceInfo_iE_Extensions__item__extensionValue),
        ])
    __AoA_AssistanceInfo_iE_Extensions__item_._ext = None
    _AoA_AssistanceInfo_iE_Extensions._cont = __AoA_AssistanceInfo_iE_Extensions__item_
    _AoA_AssistanceInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AoA_AssistanceInfo._cont = ASN1Dict([
        ('angleMeasurement', _AoA_AssistanceInfo_angleMeasurement),
        ('lCS-to-GCS-Translation', _AoA_AssistanceInfo_lCS_to_GCS_Translation),
        ('iE-Extensions', _AoA_AssistanceInfo_iE_Extensions),
        ])
    AoA_AssistanceInfo._ext = []
    
    #-----< AoA-AssistanceInfo-ExtIEs >-----#
    AoA_AssistanceInfo_ExtIEs = CLASS(name='AoA-AssistanceInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    AoA_AssistanceInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AngleMeasurementType >-----#
    AngleMeasurementType = CHOICE(name='AngleMeasurementType', mode=MODE_TYPE)
    _AngleMeasurementType_expected_ULAoA = SEQ(name='expected-ULAoA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Expected-UL-AoA')))
    _AngleMeasurementType_expected_ZoA = SEQ(name='expected-ZoA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Expected-ZoA-only')))
    _AngleMeasurementType_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __AngleMeasurementType_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___AngleMeasurementType_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___AngleMeasurementType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AngleMeasurementType_choice_extension_id._const_tab = ___AngleMeasurementType_choice_extension_id_tab
    __AngleMeasurementType_choice_extension_id._const_tab_at = None
    __AngleMeasurementType_choice_extension_id._const_tab_id = 'id'
    __AngleMeasurementType_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___AngleMeasurementType_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___AngleMeasurementType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AngleMeasurementType_choice_extension_criticality._const_tab = ___AngleMeasurementType_choice_extension_criticality_tab
    __AngleMeasurementType_choice_extension_criticality._const_tab_at = ('..', 'id')
    __AngleMeasurementType_choice_extension_criticality._const_tab_id = 'criticality'
    __AngleMeasurementType_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___AngleMeasurementType_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___AngleMeasurementType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AngleMeasurementType_choice_extension_value._const_tab = ___AngleMeasurementType_choice_extension_value_tab
    __AngleMeasurementType_choice_extension_value._const_tab_at = ('..', 'id')
    __AngleMeasurementType_choice_extension_value._const_tab_id = 'Value'
    _AngleMeasurementType_choice_extension._cont = ASN1Dict([
        ('id', __AngleMeasurementType_choice_extension_id),
        ('criticality', __AngleMeasurementType_choice_extension_criticality),
        ('value', __AngleMeasurementType_choice_extension_value),
        ])
    _AngleMeasurementType_choice_extension._ext = None
    AngleMeasurementType._cont = ASN1Dict([
        ('expected-ULAoA', _AngleMeasurementType_expected_ULAoA),
        ('expected-ZoA', _AngleMeasurementType_expected_ZoA),
        ('choice-extension', _AngleMeasurementType_choice_extension),
        ])
    AngleMeasurementType._ext = None
    
    #-----< AngleMeasurementType-ExtIEs >-----#
    AngleMeasurementType_ExtIEs = CLASS(name='AngleMeasurementType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    AngleMeasurementType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AppLayerBufferLevelList >-----#
    AppLayerBufferLevelList = OCT_STR(name='AppLayerBufferLevelList', mode=MODE_TYPE)
    
    #-----< ARP-ID >-----#
    ARP_ID = INT(name='ARP-ID', mode=MODE_TYPE)
    ARP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=[], er=[])
    
    #-----< ARPLocationInformation >-----#
    ARPLocationInformation = SEQ_OF(name='ARPLocationInformation', mode=MODE_TYPE)
    _ARPLocationInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ARPLocationInformation-Item')))
    ARPLocationInformation._cont = _ARPLocationInformation__item_
    ARPLocationInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< ARPLocationInformation-Item >-----#
    ARPLocationInformation_Item = SEQ(name='ARPLocationInformation-Item', mode=MODE_TYPE)
    _ARPLocationInformation_Item_aRP_ID = INT(name='aRP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ARP-ID')))
    _ARPLocationInformation_Item_aRPLocationType = CHOICE(name='aRPLocationType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ARPLocationType')))
    _ARPLocationInformation_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ARPLocationInformation_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ARPLocationInformation_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ARPLocationInformation_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ARPLocationInformation_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ARPLocationInformation_Item_iE_Extensions__item__id._const_tab = ____ARPLocationInformation_Item_iE_Extensions__item__id_tab
    ___ARPLocationInformation_Item_iE_Extensions__item__id._const_tab_at = None
    ___ARPLocationInformation_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ARPLocationInformation_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ARPLocationInformation_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ARPLocationInformation_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ARPLocationInformation_Item_iE_Extensions__item__criticality._const_tab = ____ARPLocationInformation_Item_iE_Extensions__item__criticality_tab
    ___ARPLocationInformation_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ARPLocationInformation_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ARPLocationInformation_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ARPLocationInformation_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ARPLocationInformation_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ARPLocationInformation_Item_iE_Extensions__item__extensionValue._const_tab = ____ARPLocationInformation_Item_iE_Extensions__item__extensionValue_tab
    ___ARPLocationInformation_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ARPLocationInformation_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ARPLocationInformation_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ARPLocationInformation_Item_iE_Extensions__item__id),
        ('criticality', ___ARPLocationInformation_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ARPLocationInformation_Item_iE_Extensions__item__extensionValue),
        ])
    __ARPLocationInformation_Item_iE_Extensions__item_._ext = None
    _ARPLocationInformation_Item_iE_Extensions._cont = __ARPLocationInformation_Item_iE_Extensions__item_
    _ARPLocationInformation_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ARPLocationInformation_Item._cont = ASN1Dict([
        ('aRP-ID', _ARPLocationInformation_Item_aRP_ID),
        ('aRPLocationType', _ARPLocationInformation_Item_aRPLocationType),
        ('iE-Extensions', _ARPLocationInformation_Item_iE_Extensions),
        ])
    ARPLocationInformation_Item._ext = []
    
    #-----< ARPLocationInformation-ExtIEs >-----#
    ARPLocationInformation_ExtIEs = CLASS(name='ARPLocationInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ARPLocationInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ARPLocationType >-----#
    ARPLocationType = CHOICE(name='ARPLocationType', mode=MODE_TYPE)
    _ARPLocationType_aRPPositionRelativeGeodetic = SEQ(name='aRPPositionRelativeGeodetic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RelativeGeodeticLocation')))
    _ARPLocationType_aRPPositionRelativeCartesian = SEQ(name='aRPPositionRelativeCartesian', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RelativeCartesianLocation')))
    _ARPLocationType_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __ARPLocationType_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___ARPLocationType_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ARPLocationType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ARPLocationType_choice_extension_id._const_tab = ___ARPLocationType_choice_extension_id_tab
    __ARPLocationType_choice_extension_id._const_tab_at = None
    __ARPLocationType_choice_extension_id._const_tab_id = 'id'
    __ARPLocationType_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___ARPLocationType_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ARPLocationType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ARPLocationType_choice_extension_criticality._const_tab = ___ARPLocationType_choice_extension_criticality_tab
    __ARPLocationType_choice_extension_criticality._const_tab_at = ('..', 'id')
    __ARPLocationType_choice_extension_criticality._const_tab_id = 'criticality'
    __ARPLocationType_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___ARPLocationType_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ARPLocationType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ARPLocationType_choice_extension_value._const_tab = ___ARPLocationType_choice_extension_value_tab
    __ARPLocationType_choice_extension_value._const_tab_at = ('..', 'id')
    __ARPLocationType_choice_extension_value._const_tab_id = 'Value'
    _ARPLocationType_choice_extension._cont = ASN1Dict([
        ('id', __ARPLocationType_choice_extension_id),
        ('criticality', __ARPLocationType_choice_extension_criticality),
        ('value', __ARPLocationType_choice_extension_value),
        ])
    _ARPLocationType_choice_extension._ext = None
    ARPLocationType._cont = ASN1Dict([
        ('aRPPositionRelativeGeodetic', _ARPLocationType_aRPPositionRelativeGeodetic),
        ('aRPPositionRelativeCartesian', _ARPLocationType_aRPPositionRelativeCartesian),
        ('choice-extension', _ARPLocationType_choice_extension),
        ])
    ARPLocationType._ext = None
    
    #-----< ARPLocationType-ExtIEs >-----#
    ARPLocationType_ExtIEs = CLASS(name='ARPLocationType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ARPLocationType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BAP-Header-Rewriting-Added-List-Item >-----#
    BAP_Header_Rewriting_Added_List_Item = SEQ(name='BAP-Header-Rewriting-Added-List-Item', mode=MODE_TYPE)
    _BAP_Header_Rewriting_Added_List_Item_ingressBAPRoutingID = SEQ(name='ingressBAPRoutingID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPRoutingID')))
    _BAP_Header_Rewriting_Added_List_Item_egressBAPRoutingID = SEQ(name='egressBAPRoutingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPRoutingID')))
    _BAP_Header_Rewriting_Added_List_Item_nonF1terminatingTopologyIndicator = ENUM(name='nonF1terminatingTopologyIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NonF1terminatingTopologyIndicator')), opt=True)
    _BAP_Header_Rewriting_Added_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__id._const_tab = ____BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__id_tab
    ___BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__criticality._const_tab = ____BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__criticality_tab
    ___BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__extensionValue._const_tab = ____BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__extensionValue_tab
    ___BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__id),
        ('criticality', ___BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__extensionValue),
        ])
    __BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item_._ext = None
    _BAP_Header_Rewriting_Added_List_Item_iE_Extensions._cont = __BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item_
    _BAP_Header_Rewriting_Added_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BAP_Header_Rewriting_Added_List_Item._cont = ASN1Dict([
        ('ingressBAPRoutingID', _BAP_Header_Rewriting_Added_List_Item_ingressBAPRoutingID),
        ('egressBAPRoutingID', _BAP_Header_Rewriting_Added_List_Item_egressBAPRoutingID),
        ('nonF1terminatingTopologyIndicator', _BAP_Header_Rewriting_Added_List_Item_nonF1terminatingTopologyIndicator),
        ('iE-Extensions', _BAP_Header_Rewriting_Added_List_Item_iE_Extensions),
        ])
    BAP_Header_Rewriting_Added_List_Item._ext = None
    
    #-----< BAP-Header-Rewriting-Added-List-Item-ExtIEs >-----#
    BAP_Header_Rewriting_Added_List_Item_ExtIEs = CLASS(name='BAP-Header-Rewriting-Added-List-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BAP_Header_Rewriting_Added_List_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BAP-Header-Rewriting-Removed-List-Item >-----#
    BAP_Header_Rewriting_Removed_List_Item = SEQ(name='BAP-Header-Rewriting-Removed-List-Item', mode=MODE_TYPE)
    _BAP_Header_Rewriting_Removed_List_Item_ingressBAPRoutingID = SEQ(name='ingressBAPRoutingID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPRoutingID')))
    _BAP_Header_Rewriting_Removed_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__id._const_tab = ____BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__id_tab
    ___BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__criticality._const_tab = ____BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__criticality_tab
    ___BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__extensionValue._const_tab = ____BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__extensionValue_tab
    ___BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__id),
        ('criticality', ___BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__extensionValue),
        ])
    __BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item_._ext = None
    _BAP_Header_Rewriting_Removed_List_Item_iE_Extensions._cont = __BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item_
    _BAP_Header_Rewriting_Removed_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BAP_Header_Rewriting_Removed_List_Item._cont = ASN1Dict([
        ('ingressBAPRoutingID', _BAP_Header_Rewriting_Removed_List_Item_ingressBAPRoutingID),
        ('iE-Extensions', _BAP_Header_Rewriting_Removed_List_Item_iE_Extensions),
        ])
    BAP_Header_Rewriting_Removed_List_Item._ext = None
    
    #-----< BAP-Header-Rewriting-Removed-List-Item-ExtIEs >-----#
    BAP_Header_Rewriting_Removed_List_Item_ExtIEs = CLASS(name='BAP-Header-Rewriting-Removed-List-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BAP_Header_Rewriting_Removed_List_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BandwidthSRS >-----#
    BandwidthSRS = CHOICE(name='BandwidthSRS', mode=MODE_TYPE)
    _BandwidthSRS_fR1 = ENUM(name='fR1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FR1-Bandwidth')))
    _BandwidthSRS_fR2 = ENUM(name='fR2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FR2-Bandwidth')))
    _BandwidthSRS_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BandwidthSRS_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BandwidthSRS_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___BandwidthSRS_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BandwidthSRS_choice_extension_id._const_tab = ___BandwidthSRS_choice_extension_id_tab
    __BandwidthSRS_choice_extension_id._const_tab_at = None
    __BandwidthSRS_choice_extension_id._const_tab_id = 'id'
    __BandwidthSRS_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___BandwidthSRS_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___BandwidthSRS_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BandwidthSRS_choice_extension_criticality._const_tab = ___BandwidthSRS_choice_extension_criticality_tab
    __BandwidthSRS_choice_extension_criticality._const_tab_at = ('..', 'id')
    __BandwidthSRS_choice_extension_criticality._const_tab_id = 'criticality'
    __BandwidthSRS_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___BandwidthSRS_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___BandwidthSRS_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BandwidthSRS_choice_extension_value._const_tab = ___BandwidthSRS_choice_extension_value_tab
    __BandwidthSRS_choice_extension_value._const_tab_at = ('..', 'id')
    __BandwidthSRS_choice_extension_value._const_tab_id = 'Value'
    _BandwidthSRS_choice_extension._cont = ASN1Dict([
        ('id', __BandwidthSRS_choice_extension_id),
        ('criticality', __BandwidthSRS_choice_extension_criticality),
        ('value', __BandwidthSRS_choice_extension_value),
        ])
    _BandwidthSRS_choice_extension._ext = None
    BandwidthSRS._cont = ASN1Dict([
        ('fR1', _BandwidthSRS_fR1),
        ('fR2', _BandwidthSRS_fR2),
        ('choice-extension', _BandwidthSRS_choice_extension),
        ])
    BandwidthSRS._ext = None
    
    #-----< BandwidthSRS-ExtIEs >-----#
    BandwidthSRS_ExtIEs = CLASS(name='BandwidthSRS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    BandwidthSRS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BAPAddress >-----#
    BAPAddress = BIT_STR(name='BAPAddress', mode=MODE_TYPE)
    BAPAddress._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    
    #-----< BAPCtrlPDUChannel >-----#
    BAPCtrlPDUChannel = ENUM(name='BAPCtrlPDUChannel', mode=MODE_TYPE)
    BAPCtrlPDUChannel._cont = ASN1Dict([('true', 0)])
    BAPCtrlPDUChannel._ext = []
    
    #-----< BAPlayerBHRLCchannelMappingInfo >-----#
    BAPlayerBHRLCchannelMappingInfo = SEQ(name='BAPlayerBHRLCchannelMappingInfo', mode=MODE_TYPE)
    _BAPlayerBHRLCchannelMappingInfo_bAPlayerBHRLCchannelMappingInfoToAdd = SEQ_OF(name='bAPlayerBHRLCchannelMappingInfoToAdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPlayerBHRLCchannelMappingInfoList')), opt=True)
    _BAPlayerBHRLCchannelMappingInfo_bAPlayerBHRLCchannelMappingInfoToRemove = SEQ_OF(name='bAPlayerBHRLCchannelMappingInfoToRemove', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MappingInformationtoRemove')), opt=True)
    _BAPlayerBHRLCchannelMappingInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__id._const_tab = ____BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__id_tab
    ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__id._const_tab_at = None
    ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__criticality._const_tab = ____BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__criticality_tab
    ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__extensionValue._const_tab = ____BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__extensionValue_tab
    ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__id),
        ('criticality', ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__extensionValue),
        ])
    __BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item_._ext = None
    _BAPlayerBHRLCchannelMappingInfo_iE_Extensions._cont = __BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item_
    _BAPlayerBHRLCchannelMappingInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BAPlayerBHRLCchannelMappingInfo._cont = ASN1Dict([
        ('bAPlayerBHRLCchannelMappingInfoToAdd', _BAPlayerBHRLCchannelMappingInfo_bAPlayerBHRLCchannelMappingInfoToAdd),
        ('bAPlayerBHRLCchannelMappingInfoToRemove', _BAPlayerBHRLCchannelMappingInfo_bAPlayerBHRLCchannelMappingInfoToRemove),
        ('iE-Extensions', _BAPlayerBHRLCchannelMappingInfo_iE_Extensions),
        ])
    BAPlayerBHRLCchannelMappingInfo._ext = []
    
    #-----< BAPlayerBHRLCchannelMappingInfo-ExtIEs >-----#
    BAPlayerBHRLCchannelMappingInfo_ExtIEs = CLASS(name='BAPlayerBHRLCchannelMappingInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BAPlayerBHRLCchannelMappingInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BAPlayerBHRLCchannelMappingInfoList >-----#
    BAPlayerBHRLCchannelMappingInfoList = SEQ_OF(name='BAPlayerBHRLCchannelMappingInfoList', mode=MODE_TYPE)
    _BAPlayerBHRLCchannelMappingInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAPlayerBHRLCchannelMappingInfo-Item')))
    BAPlayerBHRLCchannelMappingInfoList._cont = _BAPlayerBHRLCchannelMappingInfoList__item_
    BAPlayerBHRLCchannelMappingInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=67108864)], ev=None, er=[])
    
    #-----< BAPlayerBHRLCchannelMappingInfo-Item >-----#
    BAPlayerBHRLCchannelMappingInfo_Item = SEQ(name='BAPlayerBHRLCchannelMappingInfo-Item', mode=MODE_TYPE)
    _BAPlayerBHRLCchannelMappingInfo_Item_mappingInformationIndex = BIT_STR(name='mappingInformationIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MappingInformationIndex')))
    _BAPlayerBHRLCchannelMappingInfo_Item_priorHopBAPAddress = BIT_STR(name='priorHopBAPAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')), opt=True)
    _BAPlayerBHRLCchannelMappingInfo_Item_ingressbHRLCChannelID = BIT_STR(name='ingressbHRLCChannelID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')), opt=True)
    _BAPlayerBHRLCchannelMappingInfo_Item_nextHopBAPAddress = BIT_STR(name='nextHopBAPAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')), opt=True)
    _BAPlayerBHRLCchannelMappingInfo_Item_egressbHRLCChannelID = BIT_STR(name='egressbHRLCChannelID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')), opt=True)
    _BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IngressNonF1terminatingTopologyIndicator')))
    _____BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'EgressNonF1terminatingTopologyIndicator')))
    ____BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 519), ('criticality', 'ignore'), ('Extension', _____BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 518), ('criticality', 'ignore'), ('Extension', _____BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id._const_tab = ____BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id_tab
    ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id._const_tab_at = None
    ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__criticality._const_tab = ____BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id_tab
    ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__extensionValue._const_tab = ____BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id_tab
    ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id),
        ('criticality', ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__extensionValue),
        ])
    __BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item_._ext = None
    _BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions._cont = __BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item_
    _BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BAPlayerBHRLCchannelMappingInfo_Item._cont = ASN1Dict([
        ('mappingInformationIndex', _BAPlayerBHRLCchannelMappingInfo_Item_mappingInformationIndex),
        ('priorHopBAPAddress', _BAPlayerBHRLCchannelMappingInfo_Item_priorHopBAPAddress),
        ('ingressbHRLCChannelID', _BAPlayerBHRLCchannelMappingInfo_Item_ingressbHRLCChannelID),
        ('nextHopBAPAddress', _BAPlayerBHRLCchannelMappingInfo_Item_nextHopBAPAddress),
        ('egressbHRLCChannelID', _BAPlayerBHRLCchannelMappingInfo_Item_egressbHRLCChannelID),
        ('iE-Extensions', _BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions),
        ])
    BAPlayerBHRLCchannelMappingInfo_Item._ext = []
    
    #-----< BAPlayerBHRLCchannelMappingInfo-ItemExtIEs >-----#
    BAPlayerBHRLCchannelMappingInfo_ItemExtIEs = CLASS(name='BAPlayerBHRLCchannelMappingInfo-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _BAPlayerBHRLCchannelMappingInfo_ItemExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IngressNonF1terminatingTopologyIndicator')))
    _BAPlayerBHRLCchannelMappingInfo_ItemExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'EgressNonF1terminatingTopologyIndicator')))
    BAPlayerBHRLCchannelMappingInfo_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 519), ('criticality', 'ignore'), ('Extension', _BAPlayerBHRLCchannelMappingInfo_ItemExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 518), ('criticality', 'ignore'), ('Extension', _BAPlayerBHRLCchannelMappingInfo_ItemExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BAPPathID >-----#
    BAPPathID = BIT_STR(name='BAPPathID', mode=MODE_TYPE)
    BAPPathID._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    
    #-----< BAPRoutingID >-----#
    BAPRoutingID = SEQ(name='BAPRoutingID', mode=MODE_TYPE)
    _BAPRoutingID_bAPAddress = BIT_STR(name='bAPAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    _BAPRoutingID_bAPPathID = BIT_STR(name='bAPPathID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPPathID')))
    _BAPRoutingID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BAPRoutingID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BAPRoutingID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BAPRoutingID_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BAPRoutingID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BAPRoutingID_iE_Extensions__item__id._const_tab = ____BAPRoutingID_iE_Extensions__item__id_tab
    ___BAPRoutingID_iE_Extensions__item__id._const_tab_at = None
    ___BAPRoutingID_iE_Extensions__item__id._const_tab_id = 'id'
    ___BAPRoutingID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BAPRoutingID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BAPRoutingID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BAPRoutingID_iE_Extensions__item__criticality._const_tab = ____BAPRoutingID_iE_Extensions__item__criticality_tab
    ___BAPRoutingID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BAPRoutingID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BAPRoutingID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BAPRoutingID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BAPRoutingID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BAPRoutingID_iE_Extensions__item__extensionValue._const_tab = ____BAPRoutingID_iE_Extensions__item__extensionValue_tab
    ___BAPRoutingID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BAPRoutingID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BAPRoutingID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BAPRoutingID_iE_Extensions__item__id),
        ('criticality', ___BAPRoutingID_iE_Extensions__item__criticality),
        ('extensionValue', ___BAPRoutingID_iE_Extensions__item__extensionValue),
        ])
    __BAPRoutingID_iE_Extensions__item_._ext = None
    _BAPRoutingID_iE_Extensions._cont = __BAPRoutingID_iE_Extensions__item_
    _BAPRoutingID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BAPRoutingID._cont = ASN1Dict([
        ('bAPAddress', _BAPRoutingID_bAPAddress),
        ('bAPPathID', _BAPRoutingID_bAPPathID),
        ('iE-Extensions', _BAPRoutingID_iE_Extensions),
        ])
    BAPRoutingID._ext = None
    
    #-----< BAPRoutingIDExtIEs >-----#
    BAPRoutingIDExtIEs = CLASS(name='BAPRoutingIDExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BAPRoutingIDExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BCBearerContextF1U-TNLInfo >-----#
    BCBearerContextF1U_TNLInfo = CHOICE(name='BCBearerContextF1U-TNLInfo', mode=MODE_TYPE)
    _BCBearerContextF1U_TNLInfo_locationindpendent = SEQ(name='locationindpendent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MBSF1UInformation')))
    _BCBearerContextF1U_TNLInfo_locationdependent = SEQ_OF(name='locationdependent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LocationDependentMBSF1UInformation')))
    _BCBearerContextF1U_TNLInfo_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BCBearerContextF1U_TNLInfo_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BCBearerContextF1U_TNLInfo_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___BCBearerContextF1U_TNLInfo_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BCBearerContextF1U_TNLInfo_choice_extension_id._const_tab = ___BCBearerContextF1U_TNLInfo_choice_extension_id_tab
    __BCBearerContextF1U_TNLInfo_choice_extension_id._const_tab_at = None
    __BCBearerContextF1U_TNLInfo_choice_extension_id._const_tab_id = 'id'
    __BCBearerContextF1U_TNLInfo_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___BCBearerContextF1U_TNLInfo_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___BCBearerContextF1U_TNLInfo_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BCBearerContextF1U_TNLInfo_choice_extension_criticality._const_tab = ___BCBearerContextF1U_TNLInfo_choice_extension_criticality_tab
    __BCBearerContextF1U_TNLInfo_choice_extension_criticality._const_tab_at = ('..', 'id')
    __BCBearerContextF1U_TNLInfo_choice_extension_criticality._const_tab_id = 'criticality'
    __BCBearerContextF1U_TNLInfo_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___BCBearerContextF1U_TNLInfo_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___BCBearerContextF1U_TNLInfo_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BCBearerContextF1U_TNLInfo_choice_extension_value._const_tab = ___BCBearerContextF1U_TNLInfo_choice_extension_value_tab
    __BCBearerContextF1U_TNLInfo_choice_extension_value._const_tab_at = ('..', 'id')
    __BCBearerContextF1U_TNLInfo_choice_extension_value._const_tab_id = 'Value'
    _BCBearerContextF1U_TNLInfo_choice_extension._cont = ASN1Dict([
        ('id', __BCBearerContextF1U_TNLInfo_choice_extension_id),
        ('criticality', __BCBearerContextF1U_TNLInfo_choice_extension_criticality),
        ('value', __BCBearerContextF1U_TNLInfo_choice_extension_value),
        ])
    _BCBearerContextF1U_TNLInfo_choice_extension._ext = None
    BCBearerContextF1U_TNLInfo._cont = ASN1Dict([
        ('locationindpendent', _BCBearerContextF1U_TNLInfo_locationindpendent),
        ('locationdependent', _BCBearerContextF1U_TNLInfo_locationdependent),
        ('choice-extension', _BCBearerContextF1U_TNLInfo_choice_extension),
        ])
    BCBearerContextF1U_TNLInfo._ext = None
    
    #-----< BCBearerContextF1U-TNLInfo-ExtIEs >-----#
    BCBearerContextF1U_TNLInfo_ExtIEs = CLASS(name='BCBearerContextF1U-TNLInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    BCBearerContextF1U_TNLInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BitRate >-----#
    BitRate = INT(name='BitRate', mode=MODE_TYPE)
    BitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4000000000000)], ev=[], er=[])
    
    #-----< BearerTypeChange >-----#
    BearerTypeChange = ENUM(name='BearerTypeChange', mode=MODE_TYPE)
    BearerTypeChange._cont = ASN1Dict([('true', 0)])
    BearerTypeChange._ext = []
    
    #-----< BHRLCChannelID >-----#
    BHRLCChannelID = BIT_STR(name='BHRLCChannelID', mode=MODE_TYPE)
    BHRLCChannelID._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< BHChannels-FailedToBeModified-Item >-----#
    BHChannels_FailedToBeModified_Item = SEQ(name='BHChannels-FailedToBeModified-Item', mode=MODE_TYPE)
    _BHChannels_FailedToBeModified_Item_bHRLCChannelID = BIT_STR(name='bHRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')))
    _BHChannels_FailedToBeModified_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _BHChannels_FailedToBeModified_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BHChannels_FailedToBeModified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BHChannels_FailedToBeModified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_FailedToBeModified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__id._const_tab = ____BHChannels_FailedToBeModified_Item_iE_Extensions__item__id_tab
    ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__id._const_tab_at = None
    ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BHChannels_FailedToBeModified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_FailedToBeModified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__criticality._const_tab = ____BHChannels_FailedToBeModified_Item_iE_Extensions__item__criticality_tab
    ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BHChannels_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab = ____BHChannels_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab
    ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BHChannels_FailedToBeModified_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__id),
        ('criticality', ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__extensionValue),
        ])
    __BHChannels_FailedToBeModified_Item_iE_Extensions__item_._ext = None
    _BHChannels_FailedToBeModified_Item_iE_Extensions._cont = __BHChannels_FailedToBeModified_Item_iE_Extensions__item_
    _BHChannels_FailedToBeModified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BHChannels_FailedToBeModified_Item._cont = ASN1Dict([
        ('bHRLCChannelID', _BHChannels_FailedToBeModified_Item_bHRLCChannelID),
        ('cause', _BHChannels_FailedToBeModified_Item_cause),
        ('iE-Extensions', _BHChannels_FailedToBeModified_Item_iE_Extensions),
        ])
    BHChannels_FailedToBeModified_Item._ext = None
    
    #-----< BHChannels-FailedToBeModified-ItemExtIEs >-----#
    BHChannels_FailedToBeModified_ItemExtIEs = CLASS(name='BHChannels-FailedToBeModified-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BHChannels_FailedToBeModified_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BHChannels-FailedToBeSetup-Item >-----#
    BHChannels_FailedToBeSetup_Item = SEQ(name='BHChannels-FailedToBeSetup-Item', mode=MODE_TYPE)
    _BHChannels_FailedToBeSetup_Item_bHRLCChannelID = BIT_STR(name='bHRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')))
    _BHChannels_FailedToBeSetup_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _BHChannels_FailedToBeSetup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BHChannels_FailedToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BHChannels_FailedToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_FailedToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab = ____BHChannels_FailedToBeSetup_Item_iE_Extensions__item__id_tab
    ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BHChannels_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____BHChannels_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab
    ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BHChannels_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____BHChannels_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab
    ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BHChannels_FailedToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__id),
        ('criticality', ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __BHChannels_FailedToBeSetup_Item_iE_Extensions__item_._ext = None
    _BHChannels_FailedToBeSetup_Item_iE_Extensions._cont = __BHChannels_FailedToBeSetup_Item_iE_Extensions__item_
    _BHChannels_FailedToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BHChannels_FailedToBeSetup_Item._cont = ASN1Dict([
        ('bHRLCChannelID', _BHChannels_FailedToBeSetup_Item_bHRLCChannelID),
        ('cause', _BHChannels_FailedToBeSetup_Item_cause),
        ('iE-Extensions', _BHChannels_FailedToBeSetup_Item_iE_Extensions),
        ])
    BHChannels_FailedToBeSetup_Item._ext = None
    
    #-----< BHChannels-FailedToBeSetup-ItemExtIEs >-----#
    BHChannels_FailedToBeSetup_ItemExtIEs = CLASS(name='BHChannels-FailedToBeSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BHChannels_FailedToBeSetup_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BHChannels-FailedToBeSetupMod-Item >-----#
    BHChannels_FailedToBeSetupMod_Item = SEQ(name='BHChannels-FailedToBeSetupMod-Item', mode=MODE_TYPE)
    _BHChannels_FailedToBeSetupMod_Item_bHRLCChannelID = BIT_STR(name='bHRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')))
    _BHChannels_FailedToBeSetupMod_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _BHChannels_FailedToBeSetupMod_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab = ____BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab = ____BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab
    ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__id),
        ('criticality', ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item_._ext = None
    _BHChannels_FailedToBeSetupMod_Item_iE_Extensions._cont = __BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item_
    _BHChannels_FailedToBeSetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BHChannels_FailedToBeSetupMod_Item._cont = ASN1Dict([
        ('bHRLCChannelID', _BHChannels_FailedToBeSetupMod_Item_bHRLCChannelID),
        ('cause', _BHChannels_FailedToBeSetupMod_Item_cause),
        ('iE-Extensions', _BHChannels_FailedToBeSetupMod_Item_iE_Extensions),
        ])
    BHChannels_FailedToBeSetupMod_Item._ext = None
    
    #-----< BHChannels-FailedToBeSetupMod-ItemExtIEs >-----#
    BHChannels_FailedToBeSetupMod_ItemExtIEs = CLASS(name='BHChannels-FailedToBeSetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BHChannels_FailedToBeSetupMod_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BHChannels-Modified-Item >-----#
    BHChannels_Modified_Item = SEQ(name='BHChannels-Modified-Item', mode=MODE_TYPE)
    _BHChannels_Modified_Item_bHRLCChannelID = BIT_STR(name='bHRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')))
    _BHChannels_Modified_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BHChannels_Modified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BHChannels_Modified_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BHChannels_Modified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_Modified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_Modified_Item_iE_Extensions__item__id._const_tab = ____BHChannels_Modified_Item_iE_Extensions__item__id_tab
    ___BHChannels_Modified_Item_iE_Extensions__item__id._const_tab_at = None
    ___BHChannels_Modified_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BHChannels_Modified_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BHChannels_Modified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_Modified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_Modified_Item_iE_Extensions__item__criticality._const_tab = ____BHChannels_Modified_Item_iE_Extensions__item__criticality_tab
    ___BHChannels_Modified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BHChannels_Modified_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BHChannels_Modified_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BHChannels_Modified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_Modified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_Modified_Item_iE_Extensions__item__extensionValue._const_tab = ____BHChannels_Modified_Item_iE_Extensions__item__extensionValue_tab
    ___BHChannels_Modified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BHChannels_Modified_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BHChannels_Modified_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BHChannels_Modified_Item_iE_Extensions__item__id),
        ('criticality', ___BHChannels_Modified_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BHChannels_Modified_Item_iE_Extensions__item__extensionValue),
        ])
    __BHChannels_Modified_Item_iE_Extensions__item_._ext = None
    _BHChannels_Modified_Item_iE_Extensions._cont = __BHChannels_Modified_Item_iE_Extensions__item_
    _BHChannels_Modified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BHChannels_Modified_Item._cont = ASN1Dict([
        ('bHRLCChannelID', _BHChannels_Modified_Item_bHRLCChannelID),
        ('iE-Extensions', _BHChannels_Modified_Item_iE_Extensions),
        ])
    BHChannels_Modified_Item._ext = None
    
    #-----< BHChannels-Modified-ItemExtIEs >-----#
    BHChannels_Modified_ItemExtIEs = CLASS(name='BHChannels-Modified-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BHChannels_Modified_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BHChannels-Required-ToBeReleased-Item >-----#
    BHChannels_Required_ToBeReleased_Item = SEQ(name='BHChannels-Required-ToBeReleased-Item', mode=MODE_TYPE)
    _BHChannels_Required_ToBeReleased_Item_bHRLCChannelID = BIT_STR(name='bHRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')))
    _BHChannels_Required_ToBeReleased_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BHChannels_Required_ToBeReleased_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__id._const_tab = ____BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__id_tab
    ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__id._const_tab_at = None
    ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab = ____BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab
    ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab = ____BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab
    ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BHChannels_Required_ToBeReleased_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__id),
        ('criticality', ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue),
        ])
    __BHChannels_Required_ToBeReleased_Item_iE_Extensions__item_._ext = None
    _BHChannels_Required_ToBeReleased_Item_iE_Extensions._cont = __BHChannels_Required_ToBeReleased_Item_iE_Extensions__item_
    _BHChannels_Required_ToBeReleased_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BHChannels_Required_ToBeReleased_Item._cont = ASN1Dict([
        ('bHRLCChannelID', _BHChannels_Required_ToBeReleased_Item_bHRLCChannelID),
        ('iE-Extensions', _BHChannels_Required_ToBeReleased_Item_iE_Extensions),
        ])
    BHChannels_Required_ToBeReleased_Item._ext = None
    
    #-----< BHChannels-Required-ToBeReleased-ItemExtIEs >-----#
    BHChannels_Required_ToBeReleased_ItemExtIEs = CLASS(name='BHChannels-Required-ToBeReleased-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BHChannels_Required_ToBeReleased_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BHChannels-Setup-Item >-----#
    BHChannels_Setup_Item = SEQ(name='BHChannels-Setup-Item', mode=MODE_TYPE)
    _BHChannels_Setup_Item_bHRLCChannelID = BIT_STR(name='bHRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')))
    _BHChannels_Setup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BHChannels_Setup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BHChannels_Setup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BHChannels_Setup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_Setup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_Setup_Item_iE_Extensions__item__id._const_tab = ____BHChannels_Setup_Item_iE_Extensions__item__id_tab
    ___BHChannels_Setup_Item_iE_Extensions__item__id._const_tab_at = None
    ___BHChannels_Setup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BHChannels_Setup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BHChannels_Setup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_Setup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_Setup_Item_iE_Extensions__item__criticality._const_tab = ____BHChannels_Setup_Item_iE_Extensions__item__criticality_tab
    ___BHChannels_Setup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BHChannels_Setup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BHChannels_Setup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BHChannels_Setup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_Setup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_Setup_Item_iE_Extensions__item__extensionValue._const_tab = ____BHChannels_Setup_Item_iE_Extensions__item__extensionValue_tab
    ___BHChannels_Setup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BHChannels_Setup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BHChannels_Setup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BHChannels_Setup_Item_iE_Extensions__item__id),
        ('criticality', ___BHChannels_Setup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BHChannels_Setup_Item_iE_Extensions__item__extensionValue),
        ])
    __BHChannels_Setup_Item_iE_Extensions__item_._ext = None
    _BHChannels_Setup_Item_iE_Extensions._cont = __BHChannels_Setup_Item_iE_Extensions__item_
    _BHChannels_Setup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BHChannels_Setup_Item._cont = ASN1Dict([
        ('bHRLCChannelID', _BHChannels_Setup_Item_bHRLCChannelID),
        ('iE-Extensions', _BHChannels_Setup_Item_iE_Extensions),
        ])
    BHChannels_Setup_Item._ext = None
    
    #-----< BHChannels-Setup-ItemExtIEs >-----#
    BHChannels_Setup_ItemExtIEs = CLASS(name='BHChannels-Setup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BHChannels_Setup_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BHChannels-SetupMod-Item >-----#
    BHChannels_SetupMod_Item = SEQ(name='BHChannels-SetupMod-Item', mode=MODE_TYPE)
    _BHChannels_SetupMod_Item_bHRLCChannelID = BIT_STR(name='bHRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')))
    _BHChannels_SetupMod_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BHChannels_SetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BHChannels_SetupMod_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BHChannels_SetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_SetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_SetupMod_Item_iE_Extensions__item__id._const_tab = ____BHChannels_SetupMod_Item_iE_Extensions__item__id_tab
    ___BHChannels_SetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___BHChannels_SetupMod_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BHChannels_SetupMod_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BHChannels_SetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_SetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_SetupMod_Item_iE_Extensions__item__criticality._const_tab = ____BHChannels_SetupMod_Item_iE_Extensions__item__criticality_tab
    ___BHChannels_SetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BHChannels_SetupMod_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BHChannels_SetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BHChannels_SetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_SetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____BHChannels_SetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___BHChannels_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BHChannels_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BHChannels_SetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BHChannels_SetupMod_Item_iE_Extensions__item__id),
        ('criticality', ___BHChannels_SetupMod_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BHChannels_SetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __BHChannels_SetupMod_Item_iE_Extensions__item_._ext = None
    _BHChannels_SetupMod_Item_iE_Extensions._cont = __BHChannels_SetupMod_Item_iE_Extensions__item_
    _BHChannels_SetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BHChannels_SetupMod_Item._cont = ASN1Dict([
        ('bHRLCChannelID', _BHChannels_SetupMod_Item_bHRLCChannelID),
        ('iE-Extensions', _BHChannels_SetupMod_Item_iE_Extensions),
        ])
    BHChannels_SetupMod_Item._ext = None
    
    #-----< BHChannels-SetupMod-ItemExtIEs >-----#
    BHChannels_SetupMod_ItemExtIEs = CLASS(name='BHChannels-SetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BHChannels_SetupMod_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BHChannels-ToBeModified-Item >-----#
    BHChannels_ToBeModified_Item = SEQ(name='BHChannels-ToBeModified-Item', mode=MODE_TYPE)
    _BHChannels_ToBeModified_Item_bHRLCChannelID = BIT_STR(name='bHRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')))
    _BHChannels_ToBeModified_Item_bHQoSInformation = CHOICE(name='bHQoSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHQoSInformation')))
    _BHChannels_ToBeModified_Item_rLCmode = ENUM(name='rLCmode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RLCMode')), opt=True)
    _BHChannels_ToBeModified_Item_bAPCtrlPDUChannel = ENUM(name='bAPCtrlPDUChannel', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPCtrlPDUChannel')), opt=True)
    _BHChannels_ToBeModified_Item_trafficMappingInfo = CHOICE(name='trafficMappingInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TrafficMappingInfo')), opt=True)
    _BHChannels_ToBeModified_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BHChannels_ToBeModified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BHChannels_ToBeModified_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BHChannels_ToBeModified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_ToBeModified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_ToBeModified_Item_iE_Extensions__item__id._const_tab = ____BHChannels_ToBeModified_Item_iE_Extensions__item__id_tab
    ___BHChannels_ToBeModified_Item_iE_Extensions__item__id._const_tab_at = None
    ___BHChannels_ToBeModified_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BHChannels_ToBeModified_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BHChannels_ToBeModified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_ToBeModified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_ToBeModified_Item_iE_Extensions__item__criticality._const_tab = ____BHChannels_ToBeModified_Item_iE_Extensions__item__criticality_tab
    ___BHChannels_ToBeModified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BHChannels_ToBeModified_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BHChannels_ToBeModified_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BHChannels_ToBeModified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_ToBeModified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab = ____BHChannels_ToBeModified_Item_iE_Extensions__item__extensionValue_tab
    ___BHChannels_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BHChannels_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BHChannels_ToBeModified_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BHChannels_ToBeModified_Item_iE_Extensions__item__id),
        ('criticality', ___BHChannels_ToBeModified_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BHChannels_ToBeModified_Item_iE_Extensions__item__extensionValue),
        ])
    __BHChannels_ToBeModified_Item_iE_Extensions__item_._ext = None
    _BHChannels_ToBeModified_Item_iE_Extensions._cont = __BHChannels_ToBeModified_Item_iE_Extensions__item_
    _BHChannels_ToBeModified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BHChannels_ToBeModified_Item._cont = ASN1Dict([
        ('bHRLCChannelID', _BHChannels_ToBeModified_Item_bHRLCChannelID),
        ('bHQoSInformation', _BHChannels_ToBeModified_Item_bHQoSInformation),
        ('rLCmode', _BHChannels_ToBeModified_Item_rLCmode),
        ('bAPCtrlPDUChannel', _BHChannels_ToBeModified_Item_bAPCtrlPDUChannel),
        ('trafficMappingInfo', _BHChannels_ToBeModified_Item_trafficMappingInfo),
        ('iE-Extensions', _BHChannels_ToBeModified_Item_iE_Extensions),
        ])
    BHChannels_ToBeModified_Item._ext = None
    
    #-----< BHChannels-ToBeModified-ItemExtIEs >-----#
    BHChannels_ToBeModified_ItemExtIEs = CLASS(name='BHChannels-ToBeModified-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BHChannels_ToBeModified_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BHChannels-ToBeReleased-Item >-----#
    BHChannels_ToBeReleased_Item = SEQ(name='BHChannels-ToBeReleased-Item', mode=MODE_TYPE)
    _BHChannels_ToBeReleased_Item_bHRLCChannelID = BIT_STR(name='bHRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')))
    _BHChannels_ToBeReleased_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BHChannels_ToBeReleased_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BHChannels_ToBeReleased_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BHChannels_ToBeReleased_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_ToBeReleased_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_ToBeReleased_Item_iE_Extensions__item__id._const_tab = ____BHChannels_ToBeReleased_Item_iE_Extensions__item__id_tab
    ___BHChannels_ToBeReleased_Item_iE_Extensions__item__id._const_tab_at = None
    ___BHChannels_ToBeReleased_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BHChannels_ToBeReleased_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BHChannels_ToBeReleased_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_ToBeReleased_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab = ____BHChannels_ToBeReleased_Item_iE_Extensions__item__criticality_tab
    ___BHChannels_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BHChannels_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BHChannels_ToBeReleased_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BHChannels_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab = ____BHChannels_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab
    ___BHChannels_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BHChannels_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BHChannels_ToBeReleased_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BHChannels_ToBeReleased_Item_iE_Extensions__item__id),
        ('criticality', ___BHChannels_ToBeReleased_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BHChannels_ToBeReleased_Item_iE_Extensions__item__extensionValue),
        ])
    __BHChannels_ToBeReleased_Item_iE_Extensions__item_._ext = None
    _BHChannels_ToBeReleased_Item_iE_Extensions._cont = __BHChannels_ToBeReleased_Item_iE_Extensions__item_
    _BHChannels_ToBeReleased_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BHChannels_ToBeReleased_Item._cont = ASN1Dict([
        ('bHRLCChannelID', _BHChannels_ToBeReleased_Item_bHRLCChannelID),
        ('iE-Extensions', _BHChannels_ToBeReleased_Item_iE_Extensions),
        ])
    BHChannels_ToBeReleased_Item._ext = None
    
    #-----< BHChannels-ToBeReleased-ItemExtIEs >-----#
    BHChannels_ToBeReleased_ItemExtIEs = CLASS(name='BHChannels-ToBeReleased-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BHChannels_ToBeReleased_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BHChannels-ToBeSetup-Item >-----#
    BHChannels_ToBeSetup_Item = SEQ(name='BHChannels-ToBeSetup-Item', mode=MODE_TYPE)
    _BHChannels_ToBeSetup_Item_bHRLCChannelID = BIT_STR(name='bHRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')))
    _BHChannels_ToBeSetup_Item_bHQoSInformation = CHOICE(name='bHQoSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHQoSInformation')))
    _BHChannels_ToBeSetup_Item_rLCmode = ENUM(name='rLCmode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RLCMode')))
    _BHChannels_ToBeSetup_Item_bAPCtrlPDUChannel = ENUM(name='bAPCtrlPDUChannel', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPCtrlPDUChannel')), opt=True)
    _BHChannels_ToBeSetup_Item_trafficMappingInfo = CHOICE(name='trafficMappingInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TrafficMappingInfo')), opt=True)
    _BHChannels_ToBeSetup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BHChannels_ToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BHChannels_ToBeSetup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BHChannels_ToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_ToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_ToBeSetup_Item_iE_Extensions__item__id._const_tab = ____BHChannels_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___BHChannels_ToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___BHChannels_ToBeSetup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BHChannels_ToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BHChannels_ToBeSetup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_ToBeSetup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____BHChannels_ToBeSetup_Item_iE_Extensions__item__criticality_tab
    ___BHChannels_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BHChannels_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BHChannels_ToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BHChannels_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____BHChannels_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab
    ___BHChannels_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BHChannels_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BHChannels_ToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BHChannels_ToBeSetup_Item_iE_Extensions__item__id),
        ('criticality', ___BHChannels_ToBeSetup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BHChannels_ToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __BHChannels_ToBeSetup_Item_iE_Extensions__item_._ext = None
    _BHChannels_ToBeSetup_Item_iE_Extensions._cont = __BHChannels_ToBeSetup_Item_iE_Extensions__item_
    _BHChannels_ToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BHChannels_ToBeSetup_Item._cont = ASN1Dict([
        ('bHRLCChannelID', _BHChannels_ToBeSetup_Item_bHRLCChannelID),
        ('bHQoSInformation', _BHChannels_ToBeSetup_Item_bHQoSInformation),
        ('rLCmode', _BHChannels_ToBeSetup_Item_rLCmode),
        ('bAPCtrlPDUChannel', _BHChannels_ToBeSetup_Item_bAPCtrlPDUChannel),
        ('trafficMappingInfo', _BHChannels_ToBeSetup_Item_trafficMappingInfo),
        ('iE-Extensions', _BHChannels_ToBeSetup_Item_iE_Extensions),
        ])
    BHChannels_ToBeSetup_Item._ext = None
    
    #-----< BHChannels-ToBeSetup-ItemExtIEs >-----#
    BHChannels_ToBeSetup_ItemExtIEs = CLASS(name='BHChannels-ToBeSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BHChannels_ToBeSetup_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BHChannels-ToBeSetupMod-Item >-----#
    BHChannels_ToBeSetupMod_Item = SEQ(name='BHChannels-ToBeSetupMod-Item', mode=MODE_TYPE)
    _BHChannels_ToBeSetupMod_Item_bHRLCChannelID = BIT_STR(name='bHRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')))
    _BHChannels_ToBeSetupMod_Item_bHQoSInformation = CHOICE(name='bHQoSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHQoSInformation')))
    _BHChannels_ToBeSetupMod_Item_rLCmode = ENUM(name='rLCmode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RLCMode')))
    _BHChannels_ToBeSetupMod_Item_bAPCtrlPDUChannel = ENUM(name='bAPCtrlPDUChannel', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPCtrlPDUChannel')), opt=True)
    _BHChannels_ToBeSetupMod_Item_trafficMappingInfo = CHOICE(name='trafficMappingInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TrafficMappingInfo')), opt=True)
    _BHChannels_ToBeSetupMod_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BHChannels_ToBeSetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BHChannels_ToBeSetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_ToBeSetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab = ____BHChannels_ToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BHChannels_ToBeSetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_ToBeSetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab = ____BHChannels_ToBeSetupMod_Item_iE_Extensions__item__criticality_tab
    ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BHChannels_ToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHChannels_ToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____BHChannels_ToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BHChannels_ToBeSetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__id),
        ('criticality', ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __BHChannels_ToBeSetupMod_Item_iE_Extensions__item_._ext = None
    _BHChannels_ToBeSetupMod_Item_iE_Extensions._cont = __BHChannels_ToBeSetupMod_Item_iE_Extensions__item_
    _BHChannels_ToBeSetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BHChannels_ToBeSetupMod_Item._cont = ASN1Dict([
        ('bHRLCChannelID', _BHChannels_ToBeSetupMod_Item_bHRLCChannelID),
        ('bHQoSInformation', _BHChannels_ToBeSetupMod_Item_bHQoSInformation),
        ('rLCmode', _BHChannels_ToBeSetupMod_Item_rLCmode),
        ('bAPCtrlPDUChannel', _BHChannels_ToBeSetupMod_Item_bAPCtrlPDUChannel),
        ('trafficMappingInfo', _BHChannels_ToBeSetupMod_Item_trafficMappingInfo),
        ('iE-Extensions', _BHChannels_ToBeSetupMod_Item_iE_Extensions),
        ])
    BHChannels_ToBeSetupMod_Item._ext = None
    
    #-----< BHChannels-ToBeSetupMod-ItemExtIEs >-----#
    BHChannels_ToBeSetupMod_ItemExtIEs = CLASS(name='BHChannels-ToBeSetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BHChannels_ToBeSetupMod_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BHInfo >-----#
    BHInfo = SEQ(name='BHInfo', mode=MODE_TYPE)
    _BHInfo_bAProutingID = SEQ(name='bAProutingID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPRoutingID')), opt=True)
    _BHInfo_egressBHRLCCHList = SEQ_OF(name='egressBHRLCCHList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EgressBHRLCCHList')), opt=True)
    _BHInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BHInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BHInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BHInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____BHInfo_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NonF1terminatingTopologyIndicator')))
    ____BHInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 517), ('criticality', 'ignore'), ('Extension', _____BHInfo_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BHInfo_iE_Extensions__item__id._const_tab = ____BHInfo_iE_Extensions__item__id_tab
    ___BHInfo_iE_Extensions__item__id._const_tab_at = None
    ___BHInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___BHInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___BHInfo_iE_Extensions__item__criticality._const_tab = ____BHInfo_iE_Extensions__item__id_tab
    ___BHInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BHInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BHInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___BHInfo_iE_Extensions__item__extensionValue._const_tab = ____BHInfo_iE_Extensions__item__id_tab
    ___BHInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BHInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BHInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BHInfo_iE_Extensions__item__id),
        ('criticality', ___BHInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___BHInfo_iE_Extensions__item__extensionValue),
        ])
    __BHInfo_iE_Extensions__item_._ext = None
    _BHInfo_iE_Extensions._cont = __BHInfo_iE_Extensions__item_
    _BHInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BHInfo._cont = ASN1Dict([
        ('bAProutingID', _BHInfo_bAProutingID),
        ('egressBHRLCCHList', _BHInfo_egressBHRLCCHList),
        ('iE-Extensions', _BHInfo_iE_Extensions),
        ])
    BHInfo._ext = None
    
    #-----< BHInfo-ExtIEs >-----#
    BHInfo_ExtIEs = CLASS(name='BHInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _BHInfo_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NonF1terminatingTopologyIndicator')))
    BHInfo_ExtIEs._val = ASN1Set(rv=[dict([('id', 517), ('criticality', 'ignore'), ('Extension', _BHInfo_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BHQoSInformation >-----#
    BHQoSInformation = CHOICE(name='BHQoSInformation', mode=MODE_TYPE)
    _BHQoSInformation_bHRLCCHQoS = SEQ(name='bHRLCCHQoS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSFlowLevelQoSParameters')))
    _BHQoSInformation_eUTRANBHRLCCHQoS = SEQ(name='eUTRANBHRLCCHQoS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRANQoS')))
    _BHQoSInformation_cPTrafficType = INT(name='cPTrafficType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CPTrafficType')))
    _BHQoSInformation_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BHQoSInformation_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BHQoSInformation_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___BHQoSInformation_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BHQoSInformation_choice_extension_id._const_tab = ___BHQoSInformation_choice_extension_id_tab
    __BHQoSInformation_choice_extension_id._const_tab_at = None
    __BHQoSInformation_choice_extension_id._const_tab_id = 'id'
    __BHQoSInformation_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___BHQoSInformation_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___BHQoSInformation_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BHQoSInformation_choice_extension_criticality._const_tab = ___BHQoSInformation_choice_extension_criticality_tab
    __BHQoSInformation_choice_extension_criticality._const_tab_at = ('..', 'id')
    __BHQoSInformation_choice_extension_criticality._const_tab_id = 'criticality'
    __BHQoSInformation_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___BHQoSInformation_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___BHQoSInformation_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BHQoSInformation_choice_extension_value._const_tab = ___BHQoSInformation_choice_extension_value_tab
    __BHQoSInformation_choice_extension_value._const_tab_at = ('..', 'id')
    __BHQoSInformation_choice_extension_value._const_tab_id = 'Value'
    _BHQoSInformation_choice_extension._cont = ASN1Dict([
        ('id', __BHQoSInformation_choice_extension_id),
        ('criticality', __BHQoSInformation_choice_extension_criticality),
        ('value', __BHQoSInformation_choice_extension_value),
        ])
    _BHQoSInformation_choice_extension._ext = None
    BHQoSInformation._cont = ASN1Dict([
        ('bHRLCCHQoS', _BHQoSInformation_bHRLCCHQoS),
        ('eUTRANBHRLCCHQoS', _BHQoSInformation_eUTRANBHRLCCHQoS),
        ('cPTrafficType', _BHQoSInformation_cPTrafficType),
        ('choice-extension', _BHQoSInformation_choice_extension),
        ])
    BHQoSInformation._ext = None
    
    #-----< BHQoSInformation-ExtIEs >-----#
    BHQoSInformation_ExtIEs = CLASS(name='BHQoSInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    BHQoSInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BHRLCCHList >-----#
    BHRLCCHList = SEQ_OF(name='BHRLCCHList', mode=MODE_TYPE)
    _BHRLCCHList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHRLCCHItem')))
    BHRLCCHList._cont = _BHRLCCHList__item_
    BHRLCCHList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< BHRLCCHItem >-----#
    BHRLCCHItem = SEQ(name='BHRLCCHItem', mode=MODE_TYPE)
    _BHRLCCHItem_bHRLCChannelID = BIT_STR(name='bHRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')))
    _BHRLCCHItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BHRLCCHItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BHRLCCHItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BHRLCCHItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHRLCCHItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHRLCCHItem_iE_Extensions__item__id._const_tab = ____BHRLCCHItem_iE_Extensions__item__id_tab
    ___BHRLCCHItem_iE_Extensions__item__id._const_tab_at = None
    ___BHRLCCHItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___BHRLCCHItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BHRLCCHItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHRLCCHItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHRLCCHItem_iE_Extensions__item__criticality._const_tab = ____BHRLCCHItem_iE_Extensions__item__criticality_tab
    ___BHRLCCHItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BHRLCCHItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BHRLCCHItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BHRLCCHItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BHRLCCHItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BHRLCCHItem_iE_Extensions__item__extensionValue._const_tab = ____BHRLCCHItem_iE_Extensions__item__extensionValue_tab
    ___BHRLCCHItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BHRLCCHItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BHRLCCHItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BHRLCCHItem_iE_Extensions__item__id),
        ('criticality', ___BHRLCCHItem_iE_Extensions__item__criticality),
        ('extensionValue', ___BHRLCCHItem_iE_Extensions__item__extensionValue),
        ])
    __BHRLCCHItem_iE_Extensions__item_._ext = None
    _BHRLCCHItem_iE_Extensions._cont = __BHRLCCHItem_iE_Extensions__item_
    _BHRLCCHItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BHRLCCHItem._cont = ASN1Dict([
        ('bHRLCChannelID', _BHRLCCHItem_bHRLCChannelID),
        ('iE-Extensions', _BHRLCCHItem_iE_Extensions),
        ])
    BHRLCCHItem._ext = None
    
    #-----< BHRLCCHItemExtIEs >-----#
    BHRLCCHItemExtIEs = CLASS(name='BHRLCCHItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BHRLCCHItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BH-Routing-Information-Added-List-Item >-----#
    BH_Routing_Information_Added_List_Item = SEQ(name='BH-Routing-Information-Added-List-Item', mode=MODE_TYPE)
    _BH_Routing_Information_Added_List_Item_bAPRoutingID = SEQ(name='bAPRoutingID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPRoutingID')))
    _BH_Routing_Information_Added_List_Item_nextHopBAPAddress = BIT_STR(name='nextHopBAPAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    _BH_Routing_Information_Added_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BH_Routing_Information_Added_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BH_Routing_Information_Added_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____BH_Routing_Information_Added_List_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NonF1terminatingTopologyIndicator')))
    ____BH_Routing_Information_Added_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 517), ('criticality', 'ignore'), ('Extension', _____BH_Routing_Information_Added_List_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__id._const_tab = ____BH_Routing_Information_Added_List_Item_iE_Extensions__item__id_tab
    ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__criticality._const_tab = ____BH_Routing_Information_Added_List_Item_iE_Extensions__item__id_tab
    ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__extensionValue._const_tab = ____BH_Routing_Information_Added_List_Item_iE_Extensions__item__id_tab
    ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BH_Routing_Information_Added_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__id),
        ('criticality', ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__extensionValue),
        ])
    __BH_Routing_Information_Added_List_Item_iE_Extensions__item_._ext = None
    _BH_Routing_Information_Added_List_Item_iE_Extensions._cont = __BH_Routing_Information_Added_List_Item_iE_Extensions__item_
    _BH_Routing_Information_Added_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BH_Routing_Information_Added_List_Item._cont = ASN1Dict([
        ('bAPRoutingID', _BH_Routing_Information_Added_List_Item_bAPRoutingID),
        ('nextHopBAPAddress', _BH_Routing_Information_Added_List_Item_nextHopBAPAddress),
        ('iE-Extensions', _BH_Routing_Information_Added_List_Item_iE_Extensions),
        ])
    BH_Routing_Information_Added_List_Item._ext = None
    
    #-----< BH-Routing-Information-Added-List-ItemExtIEs >-----#
    BH_Routing_Information_Added_List_ItemExtIEs = CLASS(name='BH-Routing-Information-Added-List-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _BH_Routing_Information_Added_List_ItemExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NonF1terminatingTopologyIndicator')))
    BH_Routing_Information_Added_List_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 517), ('criticality', 'ignore'), ('Extension', _BH_Routing_Information_Added_List_ItemExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BH-Routing-Information-Removed-List-Item >-----#
    BH_Routing_Information_Removed_List_Item = SEQ(name='BH-Routing-Information-Removed-List-Item', mode=MODE_TYPE)
    _BH_Routing_Information_Removed_List_Item_bAPRoutingID = SEQ(name='bAPRoutingID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPRoutingID')))
    _BH_Routing_Information_Removed_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BH_Routing_Information_Removed_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BH_Routing_Information_Removed_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BH_Routing_Information_Removed_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__id._const_tab = ____BH_Routing_Information_Removed_List_Item_iE_Extensions__item__id_tab
    ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BH_Routing_Information_Removed_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BH_Routing_Information_Removed_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__criticality._const_tab = ____BH_Routing_Information_Removed_List_Item_iE_Extensions__item__criticality_tab
    ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BH_Routing_Information_Removed_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BH_Routing_Information_Removed_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__extensionValue._const_tab = ____BH_Routing_Information_Removed_List_Item_iE_Extensions__item__extensionValue_tab
    ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BH_Routing_Information_Removed_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__id),
        ('criticality', ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__extensionValue),
        ])
    __BH_Routing_Information_Removed_List_Item_iE_Extensions__item_._ext = None
    _BH_Routing_Information_Removed_List_Item_iE_Extensions._cont = __BH_Routing_Information_Removed_List_Item_iE_Extensions__item_
    _BH_Routing_Information_Removed_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BH_Routing_Information_Removed_List_Item._cont = ASN1Dict([
        ('bAPRoutingID', _BH_Routing_Information_Removed_List_Item_bAPRoutingID),
        ('iE-Extensions', _BH_Routing_Information_Removed_List_Item_iE_Extensions),
        ])
    BH_Routing_Information_Removed_List_Item._ext = None
    
    #-----< BH-Routing-Information-Removed-List-ItemExtIEs >-----#
    BH_Routing_Information_Removed_List_ItemExtIEs = CLASS(name='BH-Routing-Information-Removed-List-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BH_Routing_Information_Removed_List_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BPLMN-ID-Info-List >-----#
    BPLMN_ID_Info_List = SEQ_OF(name='BPLMN-ID-Info-List', mode=MODE_TYPE)
    _BPLMN_ID_Info_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BPLMN-ID-Info-Item')))
    BPLMN_ID_Info_List._cont = _BPLMN_ID_Info_List__item_
    BPLMN_ID_Info_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< BPLMN-ID-Info-Item >-----#
    BPLMN_ID_Info_Item = SEQ(name='BPLMN-ID-Info-Item', mode=MODE_TYPE)
    _BPLMN_ID_Info_Item_pLMN_Identity_List = SEQ_OF(name='pLMN-Identity-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AvailablePLMNList')))
    _BPLMN_ID_Info_Item_extended_PLMN_Identity_List = SEQ_OF(name='extended-PLMN-Identity-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ExtendedAvailablePLMN-List')), opt=True)
    _BPLMN_ID_Info_Item_fiveGS_TAC = OCT_STR(name='fiveGS-TAC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FiveGS-TAC')), opt=True)
    _BPLMN_ID_Info_Item_nr_cell_ID = BIT_STR(name='nr-cell-ID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCellIdentity')))
    _BPLMN_ID_Info_Item_ranac = INT(name='ranac', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RANAC')), opt=True)
    _BPLMN_ID_Info_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BPLMN_ID_Info_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BPLMN_ID_Info_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BPLMN_ID_Info_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____BPLMN_ID_Info_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ConfiguredTACIndication')))
    _____BPLMN_ID_Info_Item_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NPNBroadcastInformation')))
    ____BPLMN_ID_Info_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 425), ('criticality', 'ignore'), ('Extension', _____BPLMN_ID_Info_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 383), ('criticality', 'reject'), ('Extension', _____BPLMN_ID_Info_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BPLMN_ID_Info_Item_iE_Extensions__item__id._const_tab = ____BPLMN_ID_Info_Item_iE_Extensions__item__id_tab
    ___BPLMN_ID_Info_Item_iE_Extensions__item__id._const_tab_at = None
    ___BPLMN_ID_Info_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BPLMN_ID_Info_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___BPLMN_ID_Info_Item_iE_Extensions__item__criticality._const_tab = ____BPLMN_ID_Info_Item_iE_Extensions__item__id_tab
    ___BPLMN_ID_Info_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BPLMN_ID_Info_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BPLMN_ID_Info_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___BPLMN_ID_Info_Item_iE_Extensions__item__extensionValue._const_tab = ____BPLMN_ID_Info_Item_iE_Extensions__item__id_tab
    ___BPLMN_ID_Info_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BPLMN_ID_Info_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BPLMN_ID_Info_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BPLMN_ID_Info_Item_iE_Extensions__item__id),
        ('criticality', ___BPLMN_ID_Info_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BPLMN_ID_Info_Item_iE_Extensions__item__extensionValue),
        ])
    __BPLMN_ID_Info_Item_iE_Extensions__item_._ext = None
    _BPLMN_ID_Info_Item_iE_Extensions._cont = __BPLMN_ID_Info_Item_iE_Extensions__item_
    _BPLMN_ID_Info_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BPLMN_ID_Info_Item._cont = ASN1Dict([
        ('pLMN-Identity-List', _BPLMN_ID_Info_Item_pLMN_Identity_List),
        ('extended-PLMN-Identity-List', _BPLMN_ID_Info_Item_extended_PLMN_Identity_List),
        ('fiveGS-TAC', _BPLMN_ID_Info_Item_fiveGS_TAC),
        ('nr-cell-ID', _BPLMN_ID_Info_Item_nr_cell_ID),
        ('ranac', _BPLMN_ID_Info_Item_ranac),
        ('iE-Extensions', _BPLMN_ID_Info_Item_iE_Extensions),
        ])
    BPLMN_ID_Info_Item._ext = []
    
    #-----< BPLMN-ID-Info-ItemExtIEs >-----#
    BPLMN_ID_Info_ItemExtIEs = CLASS(name='BPLMN-ID-Info-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _BPLMN_ID_Info_ItemExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ConfiguredTACIndication')))
    _BPLMN_ID_Info_ItemExtIEs_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NPNBroadcastInformation')))
    BPLMN_ID_Info_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 425), ('criticality', 'ignore'), ('Extension', _BPLMN_ID_Info_ItemExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 383), ('criticality', 'reject'), ('Extension', _BPLMN_ID_Info_ItemExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ServedPLMNs-List >-----#
    ServedPLMNs_List = SEQ_OF(name='ServedPLMNs-List', mode=MODE_TYPE)
    _ServedPLMNs_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServedPLMNs-Item')))
    ServedPLMNs_List._cont = _ServedPLMNs_List__item_
    ServedPLMNs_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< ServedPLMNs-Item >-----#
    ServedPLMNs_Item = SEQ(name='ServedPLMNs-Item', mode=MODE_TYPE)
    _ServedPLMNs_Item_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _ServedPLMNs_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ServedPLMNs_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ServedPLMNs_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ServedPLMNs_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____ServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SliceSupportList')))
    _____ServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NPNSupportInfo')))
    _____ServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedSliceSupportList')))
    _____ServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NSAGSupportList')))
    ____ServedPLMNs_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 131), ('criticality', 'ignore'), ('Extension', _____ServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 384), ('criticality', 'reject'), ('Extension', _____ServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 390), ('criticality', 'reject'), ('Extension', _____ServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 644), ('criticality', 'ignore'), ('Extension', _____ServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ServedPLMNs_Item_iE_Extensions__item__id._const_tab = ____ServedPLMNs_Item_iE_Extensions__item__id_tab
    ___ServedPLMNs_Item_iE_Extensions__item__id._const_tab_at = None
    ___ServedPLMNs_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ServedPLMNs_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ServedPLMNs_Item_iE_Extensions__item__criticality._const_tab = ____ServedPLMNs_Item_iE_Extensions__item__id_tab
    ___ServedPLMNs_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ServedPLMNs_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ServedPLMNs_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ServedPLMNs_Item_iE_Extensions__item__extensionValue._const_tab = ____ServedPLMNs_Item_iE_Extensions__item__id_tab
    ___ServedPLMNs_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ServedPLMNs_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ServedPLMNs_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ServedPLMNs_Item_iE_Extensions__item__id),
        ('criticality', ___ServedPLMNs_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ServedPLMNs_Item_iE_Extensions__item__extensionValue),
        ])
    __ServedPLMNs_Item_iE_Extensions__item_._ext = None
    _ServedPLMNs_Item_iE_Extensions._cont = __ServedPLMNs_Item_iE_Extensions__item_
    _ServedPLMNs_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ServedPLMNs_Item._cont = ASN1Dict([
        ('pLMN-Identity', _ServedPLMNs_Item_pLMN_Identity),
        ('iE-Extensions', _ServedPLMNs_Item_iE_Extensions),
        ])
    ServedPLMNs_Item._ext = []
    
    #-----< ServedPLMNs-ItemExtIEs >-----#
    ServedPLMNs_ItemExtIEs = CLASS(name='ServedPLMNs-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _ServedPLMNs_ItemExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SliceSupportList')))
    _ServedPLMNs_ItemExtIEs_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NPNSupportInfo')))
    _ServedPLMNs_ItemExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedSliceSupportList')))
    _ServedPLMNs_ItemExtIEs_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NSAGSupportList')))
    ServedPLMNs_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 131), ('criticality', 'ignore'), ('Extension', _ServedPLMNs_ItemExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 384), ('criticality', 'reject'), ('Extension', _ServedPLMNs_ItemExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 390), ('criticality', 'reject'), ('Extension', _ServedPLMNs_ItemExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 644), ('criticality', 'ignore'), ('Extension', _ServedPLMNs_ItemExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastCAGList >-----#
    BroadcastCAGList = SEQ_OF(name='BroadcastCAGList', mode=MODE_TYPE)
    _BroadcastCAGList__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CAGID')))
    BroadcastCAGList._cont = _BroadcastCAGList__item_
    BroadcastCAGList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< BroadcastMRBs-FailedToBeModified-Item >-----#
    BroadcastMRBs_FailedToBeModified_Item = SEQ(name='BroadcastMRBs-FailedToBeModified-Item', mode=MODE_TYPE)
    _BroadcastMRBs_FailedToBeModified_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _BroadcastMRBs_FailedToBeModified_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _BroadcastMRBs_FailedToBeModified_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__id._const_tab = ____BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__id_tab
    ___BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__id._const_tab_at = None
    ___BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__criticality._const_tab = ____BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__criticality_tab
    ___BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab = ____BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab
    ___BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__id),
        ('criticality', ___BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue),
        ])
    __BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item_._ext = None
    _BroadcastMRBs_FailedToBeModified_Item_iE_Extensions._cont = __BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item_
    _BroadcastMRBs_FailedToBeModified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BroadcastMRBs_FailedToBeModified_Item._cont = ASN1Dict([
        ('mRB-ID', _BroadcastMRBs_FailedToBeModified_Item_mRB_ID),
        ('cause', _BroadcastMRBs_FailedToBeModified_Item_cause),
        ('iE-Extensions', _BroadcastMRBs_FailedToBeModified_Item_iE_Extensions),
        ])
    BroadcastMRBs_FailedToBeModified_Item._ext = []
    
    #-----< BroadcastMRBs-FailedtoBeModified-Item-ExtIEs >-----#
    BroadcastMRBs_FailedtoBeModified_Item_ExtIEs = CLASS(name='BroadcastMRBs-FailedtoBeModified-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BroadcastMRBs_FailedtoBeModified_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BroadcastMRBs-FailedToBeSetup-Item >-----#
    BroadcastMRBs_FailedToBeSetup_Item = SEQ(name='BroadcastMRBs-FailedToBeSetup-Item', mode=MODE_TYPE)
    _BroadcastMRBs_FailedToBeSetup_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _BroadcastMRBs_FailedToBeSetup_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab = ____BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab
    ___BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab
    ___BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab
    ___BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__id),
        ('criticality', ___BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item_._ext = None
    _BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions._cont = __BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item_
    _BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BroadcastMRBs_FailedToBeSetup_Item._cont = ASN1Dict([
        ('mRB-ID', _BroadcastMRBs_FailedToBeSetup_Item_mRB_ID),
        ('cause', _BroadcastMRBs_FailedToBeSetup_Item_cause),
        ('iE-Extensions', _BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions),
        ])
    BroadcastMRBs_FailedToBeSetup_Item._ext = []
    
    #-----< BroadcastMRBs-FailedToBeSetup-Item-ExtIEs >-----#
    BroadcastMRBs_FailedToBeSetup_Item_ExtIEs = CLASS(name='BroadcastMRBs-FailedToBeSetup-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BroadcastMRBs_FailedToBeSetup_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BroadcastMRBs-FailedToBeSetupMod-Item >-----#
    BroadcastMRBs_FailedToBeSetupMod_Item = SEQ(name='BroadcastMRBs-FailedToBeSetupMod-Item', mode=MODE_TYPE)
    _BroadcastMRBs_FailedToBeSetupMod_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _BroadcastMRBs_FailedToBeSetupMod_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab = ____BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab = ____BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab
    ___BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id),
        ('criticality', ___BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item_._ext = None
    _BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions._cont = __BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item_
    _BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BroadcastMRBs_FailedToBeSetupMod_Item._cont = ASN1Dict([
        ('mRB-ID', _BroadcastMRBs_FailedToBeSetupMod_Item_mRB_ID),
        ('cause', _BroadcastMRBs_FailedToBeSetupMod_Item_cause),
        ('iE-Extensions', _BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions),
        ])
    BroadcastMRBs_FailedToBeSetupMod_Item._ext = []
    
    #-----< BroadcastMRBs-FailedToBeSetupMod-Item-ExtIEs >-----#
    BroadcastMRBs_FailedToBeSetupMod_Item_ExtIEs = CLASS(name='BroadcastMRBs-FailedToBeSetupMod-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BroadcastMRBs_FailedToBeSetupMod_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BroadcastMRBs-Modified-Item >-----#
    BroadcastMRBs_Modified_Item = SEQ(name='BroadcastMRBs-Modified-Item', mode=MODE_TYPE)
    _BroadcastMRBs_Modified_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _BroadcastMRBs_Modified_Item_bcBearerCtxtF1U_TNLInfoatDU = CHOICE(name='bcBearerCtxtF1U-TNLInfoatDU', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BCBearerContextF1U-TNLInfo')), opt=True)
    _BroadcastMRBs_Modified_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BroadcastMRBs_Modified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BroadcastMRBs_Modified_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BroadcastMRBs_Modified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_Modified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_Modified_Item_iE_Extensions__item__id._const_tab = ____BroadcastMRBs_Modified_Item_iE_Extensions__item__id_tab
    ___BroadcastMRBs_Modified_Item_iE_Extensions__item__id._const_tab_at = None
    ___BroadcastMRBs_Modified_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BroadcastMRBs_Modified_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BroadcastMRBs_Modified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_Modified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_Modified_Item_iE_Extensions__item__criticality._const_tab = ____BroadcastMRBs_Modified_Item_iE_Extensions__item__criticality_tab
    ___BroadcastMRBs_Modified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastMRBs_Modified_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BroadcastMRBs_Modified_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BroadcastMRBs_Modified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_Modified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_Modified_Item_iE_Extensions__item__extensionValue._const_tab = ____BroadcastMRBs_Modified_Item_iE_Extensions__item__extensionValue_tab
    ___BroadcastMRBs_Modified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BroadcastMRBs_Modified_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BroadcastMRBs_Modified_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BroadcastMRBs_Modified_Item_iE_Extensions__item__id),
        ('criticality', ___BroadcastMRBs_Modified_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BroadcastMRBs_Modified_Item_iE_Extensions__item__extensionValue),
        ])
    __BroadcastMRBs_Modified_Item_iE_Extensions__item_._ext = None
    _BroadcastMRBs_Modified_Item_iE_Extensions._cont = __BroadcastMRBs_Modified_Item_iE_Extensions__item_
    _BroadcastMRBs_Modified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BroadcastMRBs_Modified_Item._cont = ASN1Dict([
        ('mRB-ID', _BroadcastMRBs_Modified_Item_mRB_ID),
        ('bcBearerCtxtF1U-TNLInfoatDU', _BroadcastMRBs_Modified_Item_bcBearerCtxtF1U_TNLInfoatDU),
        ('iE-Extensions', _BroadcastMRBs_Modified_Item_iE_Extensions),
        ])
    BroadcastMRBs_Modified_Item._ext = []
    
    #-----< BroadcastMRBs-Modified-Item-ExtIEs >-----#
    BroadcastMRBs_Modified_Item_ExtIEs = CLASS(name='BroadcastMRBs-Modified-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BroadcastMRBs_Modified_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BroadcastMRBs-Setup-Item >-----#
    BroadcastMRBs_Setup_Item = SEQ(name='BroadcastMRBs-Setup-Item', mode=MODE_TYPE)
    _BroadcastMRBs_Setup_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _BroadcastMRBs_Setup_Item_bcBearerCtxtF1U_TNLInfoatDU = CHOICE(name='bcBearerCtxtF1U-TNLInfoatDU', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BCBearerContextF1U-TNLInfo')))
    _BroadcastMRBs_Setup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BroadcastMRBs_Setup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BroadcastMRBs_Setup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BroadcastMRBs_Setup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_Setup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_Setup_Item_iE_Extensions__item__id._const_tab = ____BroadcastMRBs_Setup_Item_iE_Extensions__item__id_tab
    ___BroadcastMRBs_Setup_Item_iE_Extensions__item__id._const_tab_at = None
    ___BroadcastMRBs_Setup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BroadcastMRBs_Setup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BroadcastMRBs_Setup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_Setup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_Setup_Item_iE_Extensions__item__criticality._const_tab = ____BroadcastMRBs_Setup_Item_iE_Extensions__item__criticality_tab
    ___BroadcastMRBs_Setup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastMRBs_Setup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BroadcastMRBs_Setup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BroadcastMRBs_Setup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_Setup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab = ____BroadcastMRBs_Setup_Item_iE_Extensions__item__extensionValue_tab
    ___BroadcastMRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BroadcastMRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BroadcastMRBs_Setup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BroadcastMRBs_Setup_Item_iE_Extensions__item__id),
        ('criticality', ___BroadcastMRBs_Setup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BroadcastMRBs_Setup_Item_iE_Extensions__item__extensionValue),
        ])
    __BroadcastMRBs_Setup_Item_iE_Extensions__item_._ext = None
    _BroadcastMRBs_Setup_Item_iE_Extensions._cont = __BroadcastMRBs_Setup_Item_iE_Extensions__item_
    _BroadcastMRBs_Setup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BroadcastMRBs_Setup_Item._cont = ASN1Dict([
        ('mRB-ID', _BroadcastMRBs_Setup_Item_mRB_ID),
        ('bcBearerCtxtF1U-TNLInfoatDU', _BroadcastMRBs_Setup_Item_bcBearerCtxtF1U_TNLInfoatDU),
        ('iE-Extensions', _BroadcastMRBs_Setup_Item_iE_Extensions),
        ])
    BroadcastMRBs_Setup_Item._ext = []
    
    #-----< BroadcastMRBs-Setup-Item-ExtIEs >-----#
    BroadcastMRBs_Setup_Item_ExtIEs = CLASS(name='BroadcastMRBs-Setup-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BroadcastMRBs_Setup_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BroadcastMRBs-SetupMod-Item >-----#
    BroadcastMRBs_SetupMod_Item = SEQ(name='BroadcastMRBs-SetupMod-Item', mode=MODE_TYPE)
    _BroadcastMRBs_SetupMod_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _BroadcastMRBs_SetupMod_Item_bcBearerCtxtF1U_TNLInfoatDU = CHOICE(name='bcBearerCtxtF1U-TNLInfoatDU', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BCBearerContextF1U-TNLInfo')))
    _BroadcastMRBs_SetupMod_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BroadcastMRBs_SetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BroadcastMRBs_SetupMod_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BroadcastMRBs_SetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_SetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_SetupMod_Item_iE_Extensions__item__id._const_tab = ____BroadcastMRBs_SetupMod_Item_iE_Extensions__item__id_tab
    ___BroadcastMRBs_SetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___BroadcastMRBs_SetupMod_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BroadcastMRBs_SetupMod_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BroadcastMRBs_SetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_SetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_SetupMod_Item_iE_Extensions__item__criticality._const_tab = ____BroadcastMRBs_SetupMod_Item_iE_Extensions__item__criticality_tab
    ___BroadcastMRBs_SetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastMRBs_SetupMod_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BroadcastMRBs_SetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BroadcastMRBs_SetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_SetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____BroadcastMRBs_SetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___BroadcastMRBs_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BroadcastMRBs_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BroadcastMRBs_SetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BroadcastMRBs_SetupMod_Item_iE_Extensions__item__id),
        ('criticality', ___BroadcastMRBs_SetupMod_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BroadcastMRBs_SetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __BroadcastMRBs_SetupMod_Item_iE_Extensions__item_._ext = None
    _BroadcastMRBs_SetupMod_Item_iE_Extensions._cont = __BroadcastMRBs_SetupMod_Item_iE_Extensions__item_
    _BroadcastMRBs_SetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BroadcastMRBs_SetupMod_Item._cont = ASN1Dict([
        ('mRB-ID', _BroadcastMRBs_SetupMod_Item_mRB_ID),
        ('bcBearerCtxtF1U-TNLInfoatDU', _BroadcastMRBs_SetupMod_Item_bcBearerCtxtF1U_TNLInfoatDU),
        ('iE-Extensions', _BroadcastMRBs_SetupMod_Item_iE_Extensions),
        ])
    BroadcastMRBs_SetupMod_Item._ext = []
    
    #-----< BroadcastMRBs-SetupMod-Item-ExtIEs >-----#
    BroadcastMRBs_SetupMod_Item_ExtIEs = CLASS(name='BroadcastMRBs-SetupMod-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BroadcastMRBs_SetupMod_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BroadcastMRBs-ToBeModified-Item >-----#
    BroadcastMRBs_ToBeModified_Item = SEQ(name='BroadcastMRBs-ToBeModified-Item', mode=MODE_TYPE)
    _BroadcastMRBs_ToBeModified_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _BroadcastMRBs_ToBeModified_Item_mRB_QoSInformation = SEQ(name='mRB-QoSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSFlowLevelQoSParameters')), opt=True)
    _BroadcastMRBs_ToBeModified_Item_mBS_Flows_Mapped_To_MRB_List = SEQ_OF(name='mBS-Flows-Mapped-To-MRB-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MBS-Flows-Mapped-To-MRB-List')), opt=True)
    _BroadcastMRBs_ToBeModified_Item_bcBearerCtxtF1U_TNLInfoatCU = CHOICE(name='bcBearerCtxtF1U-TNLInfoatCU', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BCBearerContextF1U-TNLInfo')), opt=True)
    _BroadcastMRBs_ToBeModified_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BroadcastMRBs_ToBeModified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__id._const_tab = ____BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__id_tab
    ___BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__id._const_tab_at = None
    ___BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__criticality._const_tab = ____BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__criticality_tab
    ___BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab = ____BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__extensionValue_tab
    ___BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BroadcastMRBs_ToBeModified_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__id),
        ('criticality', ___BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__extensionValue),
        ])
    __BroadcastMRBs_ToBeModified_Item_iE_Extensions__item_._ext = None
    _BroadcastMRBs_ToBeModified_Item_iE_Extensions._cont = __BroadcastMRBs_ToBeModified_Item_iE_Extensions__item_
    _BroadcastMRBs_ToBeModified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BroadcastMRBs_ToBeModified_Item._cont = ASN1Dict([
        ('mRB-ID', _BroadcastMRBs_ToBeModified_Item_mRB_ID),
        ('mRB-QoSInformation', _BroadcastMRBs_ToBeModified_Item_mRB_QoSInformation),
        ('mBS-Flows-Mapped-To-MRB-List', _BroadcastMRBs_ToBeModified_Item_mBS_Flows_Mapped_To_MRB_List),
        ('bcBearerCtxtF1U-TNLInfoatCU', _BroadcastMRBs_ToBeModified_Item_bcBearerCtxtF1U_TNLInfoatCU),
        ('iE-Extensions', _BroadcastMRBs_ToBeModified_Item_iE_Extensions),
        ])
    BroadcastMRBs_ToBeModified_Item._ext = []
    
    #-----< BroadcastMRBs-ToBeModified-Item-ExtIEs >-----#
    BroadcastMRBs_ToBeModified_Item_ExtIEs = CLASS(name='BroadcastMRBs-ToBeModified-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BroadcastMRBs_ToBeModified_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BroadcastMRBs-ToBeReleased-Item >-----#
    BroadcastMRBs_ToBeReleased_Item = SEQ(name='BroadcastMRBs-ToBeReleased-Item', mode=MODE_TYPE)
    _BroadcastMRBs_ToBeReleased_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _BroadcastMRBs_ToBeReleased_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab = ____BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__id_tab
    ___BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab_at = None
    ___BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab = ____BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab
    ___BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab = ____BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab
    ___BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__id),
        ('criticality', ___BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue),
        ])
    __BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item_._ext = None
    _BroadcastMRBs_ToBeReleased_Item_iE_Extensions._cont = __BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item_
    _BroadcastMRBs_ToBeReleased_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BroadcastMRBs_ToBeReleased_Item._cont = ASN1Dict([
        ('mRB-ID', _BroadcastMRBs_ToBeReleased_Item_mRB_ID),
        ('iE-Extensions', _BroadcastMRBs_ToBeReleased_Item_iE_Extensions),
        ])
    BroadcastMRBs_ToBeReleased_Item._ext = []
    
    #-----< BroadcastMRBs-ToBeReleased-ItemExtIEs >-----#
    BroadcastMRBs_ToBeReleased_ItemExtIEs = CLASS(name='BroadcastMRBs-ToBeReleased-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BroadcastMRBs_ToBeReleased_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BroadcastMRBs-ToBeSetup-Item >-----#
    BroadcastMRBs_ToBeSetup_Item = SEQ(name='BroadcastMRBs-ToBeSetup-Item', mode=MODE_TYPE)
    _BroadcastMRBs_ToBeSetup_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _BroadcastMRBs_ToBeSetup_Item_mRB_QoSInformation = SEQ(name='mRB-QoSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSFlowLevelQoSParameters')))
    _BroadcastMRBs_ToBeSetup_Item_mBS_Flows_Mapped_To_MRB_List = SEQ_OF(name='mBS-Flows-Mapped-To-MRB-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MBS-Flows-Mapped-To-MRB-List')))
    _BroadcastMRBs_ToBeSetup_Item_bcBearerCtxtF1U_TNLInfoatCU = CHOICE(name='bcBearerCtxtF1U-TNLInfoatCU', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BCBearerContextF1U-TNLInfo')))
    _BroadcastMRBs_ToBeSetup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')))
    __BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab = ____BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality_tab
    ___BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab
    ___BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__id),
        ('criticality', ___BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item_._ext = None
    _BroadcastMRBs_ToBeSetup_Item_iE_Extensions._cont = __BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item_
    _BroadcastMRBs_ToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BroadcastMRBs_ToBeSetup_Item._cont = ASN1Dict([
        ('mRB-ID', _BroadcastMRBs_ToBeSetup_Item_mRB_ID),
        ('mRB-QoSInformation', _BroadcastMRBs_ToBeSetup_Item_mRB_QoSInformation),
        ('mBS-Flows-Mapped-To-MRB-List', _BroadcastMRBs_ToBeSetup_Item_mBS_Flows_Mapped_To_MRB_List),
        ('bcBearerCtxtF1U-TNLInfoatCU', _BroadcastMRBs_ToBeSetup_Item_bcBearerCtxtF1U_TNLInfoatCU),
        ('iE-Extensions', _BroadcastMRBs_ToBeSetup_Item_iE_Extensions),
        ])
    BroadcastMRBs_ToBeSetup_Item._ext = []
    
    #-----< BroadcastMRBs-ToBeSetup-Item-ExtIEs >-----#
    BroadcastMRBs_ToBeSetup_Item_ExtIEs = CLASS(name='BroadcastMRBs-ToBeSetup-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BroadcastMRBs_ToBeSetup_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BroadcastMRBs-ToBeSetupMod-Item >-----#
    BroadcastMRBs_ToBeSetupMod_Item = SEQ(name='BroadcastMRBs-ToBeSetupMod-Item', mode=MODE_TYPE)
    _BroadcastMRBs_ToBeSetupMod_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _BroadcastMRBs_ToBeSetupMod_Item_mRB_QoSInformation = SEQ(name='mRB-QoSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSFlowLevelQoSParameters')))
    _BroadcastMRBs_ToBeSetupMod_Item_mBS_Flows_Mapped_To_MRB_List = SEQ_OF(name='mBS-Flows-Mapped-To-MRB-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MBS-Flows-Mapped-To-MRB-List')))
    _BroadcastMRBs_ToBeSetupMod_Item_bcBearerCtxtF1U_TNLInfoatCU = CHOICE(name='bcBearerCtxtF1U-TNLInfoatCU', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BCBearerContextF1U-TNLInfo')))
    _BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')))
    __BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab = ____BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab = ____BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality_tab
    ___BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__id),
        ('criticality', ___BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item_._ext = None
    _BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions._cont = __BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item_
    _BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BroadcastMRBs_ToBeSetupMod_Item._cont = ASN1Dict([
        ('mRB-ID', _BroadcastMRBs_ToBeSetupMod_Item_mRB_ID),
        ('mRB-QoSInformation', _BroadcastMRBs_ToBeSetupMod_Item_mRB_QoSInformation),
        ('mBS-Flows-Mapped-To-MRB-List', _BroadcastMRBs_ToBeSetupMod_Item_mBS_Flows_Mapped_To_MRB_List),
        ('bcBearerCtxtF1U-TNLInfoatCU', _BroadcastMRBs_ToBeSetupMod_Item_bcBearerCtxtF1U_TNLInfoatCU),
        ('iE-Extensions', _BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions),
        ])
    BroadcastMRBs_ToBeSetupMod_Item._ext = []
    
    #-----< BroadcastMRBs-ToBeSetupMod-Item-ExtIEs >-----#
    BroadcastMRBs_ToBeSetupMod_Item_ExtIEs = CLASS(name='BroadcastMRBs-ToBeSetupMod-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BroadcastMRBs_ToBeSetupMod_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BroadcastNIDList >-----#
    BroadcastNIDList = SEQ_OF(name='BroadcastNIDList', mode=MODE_TYPE)
    _BroadcastNIDList__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NID')))
    BroadcastNIDList._cont = _BroadcastNIDList__item_
    BroadcastNIDList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< BroadcastSNPN-ID-List >-----#
    BroadcastSNPN_ID_List = SEQ_OF(name='BroadcastSNPN-ID-List', mode=MODE_TYPE)
    _BroadcastSNPN_ID_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastSNPN-ID-List-Item')))
    BroadcastSNPN_ID_List._cont = _BroadcastSNPN_ID_List__item_
    BroadcastSNPN_ID_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< BroadcastSNPN-ID-List-Item >-----#
    BroadcastSNPN_ID_List_Item = SEQ(name='BroadcastSNPN-ID-List-Item', mode=MODE_TYPE)
    _BroadcastSNPN_ID_List_Item_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _BroadcastSNPN_ID_List_Item_broadcastNIDList = SEQ_OF(name='broadcastNIDList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BroadcastNIDList')))
    _BroadcastSNPN_ID_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BroadcastSNPN_ID_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BroadcastSNPN_ID_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastSNPN_ID_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__id._const_tab = ____BroadcastSNPN_ID_List_Item_iE_Extensions__item__id_tab
    ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BroadcastSNPN_ID_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastSNPN_ID_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__criticality._const_tab = ____BroadcastSNPN_ID_List_Item_iE_Extensions__item__criticality_tab
    ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BroadcastSNPN_ID_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastSNPN_ID_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__extensionValue._const_tab = ____BroadcastSNPN_ID_List_Item_iE_Extensions__item__extensionValue_tab
    ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BroadcastSNPN_ID_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__id),
        ('criticality', ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__extensionValue),
        ])
    __BroadcastSNPN_ID_List_Item_iE_Extensions__item_._ext = None
    _BroadcastSNPN_ID_List_Item_iE_Extensions._cont = __BroadcastSNPN_ID_List_Item_iE_Extensions__item_
    _BroadcastSNPN_ID_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BroadcastSNPN_ID_List_Item._cont = ASN1Dict([
        ('pLMN-Identity', _BroadcastSNPN_ID_List_Item_pLMN_Identity),
        ('broadcastNIDList', _BroadcastSNPN_ID_List_Item_broadcastNIDList),
        ('iE-Extensions', _BroadcastSNPN_ID_List_Item_iE_Extensions),
        ])
    BroadcastSNPN_ID_List_Item._ext = []
    
    #-----< BroadcastSNPN-ID-List-ItemExtIEs >-----#
    BroadcastSNPN_ID_List_ItemExtIEs = CLASS(name='BroadcastSNPN-ID-List-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BroadcastSNPN_ID_List_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BroadcastPNI-NPN-ID-List >-----#
    BroadcastPNI_NPN_ID_List = SEQ_OF(name='BroadcastPNI-NPN-ID-List', mode=MODE_TYPE)
    _BroadcastPNI_NPN_ID_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastPNI-NPN-ID-List-Item')))
    BroadcastPNI_NPN_ID_List._cont = _BroadcastPNI_NPN_ID_List__item_
    BroadcastPNI_NPN_ID_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< BroadcastPNI-NPN-ID-List-Item >-----#
    BroadcastPNI_NPN_ID_List_Item = SEQ(name='BroadcastPNI-NPN-ID-List-Item', mode=MODE_TYPE)
    _BroadcastPNI_NPN_ID_List_Item_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _BroadcastPNI_NPN_ID_List_Item_broadcastCAGList = SEQ_OF(name='broadcastCAGList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BroadcastCAGList')))
    _BroadcastPNI_NPN_ID_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__id._const_tab = ____BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__id_tab
    ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__criticality._const_tab = ____BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__criticality_tab
    ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__extensionValue._const_tab = ____BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__extensionValue_tab
    ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__id),
        ('criticality', ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__extensionValue),
        ])
    __BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item_._ext = None
    _BroadcastPNI_NPN_ID_List_Item_iE_Extensions._cont = __BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item_
    _BroadcastPNI_NPN_ID_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BroadcastPNI_NPN_ID_List_Item._cont = ASN1Dict([
        ('pLMN-Identity', _BroadcastPNI_NPN_ID_List_Item_pLMN_Identity),
        ('broadcastCAGList', _BroadcastPNI_NPN_ID_List_Item_broadcastCAGList),
        ('iE-Extensions', _BroadcastPNI_NPN_ID_List_Item_iE_Extensions),
        ])
    BroadcastPNI_NPN_ID_List_Item._ext = []
    
    #-----< BroadcastPNI-NPN-ID-List-ItemExtIEs >-----#
    BroadcastPNI_NPN_ID_List_ItemExtIEs = CLASS(name='BroadcastPNI-NPN-ID-List-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    BroadcastPNI_NPN_ID_List_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BroadcastAreaScope >-----#
    BroadcastAreaScope = CHOICE(name='BroadcastAreaScope', mode=MODE_TYPE)
    _BroadcastAreaScope_completeSuccess = NULL(name='completeSuccess', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BroadcastAreaScope_partialSuccess = SEQ(name='partialSuccess', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PartialSuccessCell')))
    _BroadcastAreaScope_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BroadcastAreaScope_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BroadcastAreaScope_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___BroadcastAreaScope_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BroadcastAreaScope_choice_extension_id._const_tab = ___BroadcastAreaScope_choice_extension_id_tab
    __BroadcastAreaScope_choice_extension_id._const_tab_at = None
    __BroadcastAreaScope_choice_extension_id._const_tab_id = 'id'
    __BroadcastAreaScope_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___BroadcastAreaScope_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___BroadcastAreaScope_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BroadcastAreaScope_choice_extension_criticality._const_tab = ___BroadcastAreaScope_choice_extension_criticality_tab
    __BroadcastAreaScope_choice_extension_criticality._const_tab_at = ('..', 'id')
    __BroadcastAreaScope_choice_extension_criticality._const_tab_id = 'criticality'
    __BroadcastAreaScope_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___BroadcastAreaScope_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___BroadcastAreaScope_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BroadcastAreaScope_choice_extension_value._const_tab = ___BroadcastAreaScope_choice_extension_value_tab
    __BroadcastAreaScope_choice_extension_value._const_tab_at = ('..', 'id')
    __BroadcastAreaScope_choice_extension_value._const_tab_id = 'Value'
    _BroadcastAreaScope_choice_extension._cont = ASN1Dict([
        ('id', __BroadcastAreaScope_choice_extension_id),
        ('criticality', __BroadcastAreaScope_choice_extension_criticality),
        ('value', __BroadcastAreaScope_choice_extension_value),
        ])
    _BroadcastAreaScope_choice_extension._ext = None
    BroadcastAreaScope._cont = ASN1Dict([
        ('completeSuccess', _BroadcastAreaScope_completeSuccess),
        ('partialSuccess', _BroadcastAreaScope_partialSuccess),
        ('choice-extension', _BroadcastAreaScope_choice_extension),
        ])
    BroadcastAreaScope._ext = None
    
    #-----< BroadcastAreaScope-ExtIEs >-----#
    BroadcastAreaScope_ExtIEs = CLASS(name='BroadcastAreaScope-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    BroadcastAreaScope_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BroadcastCellList >-----#
    BroadcastCellList = SEQ_OF(name='BroadcastCellList', mode=MODE_TYPE)
    _BroadcastCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Broadcast-Cell-List-Item')))
    BroadcastCellList._cont = _BroadcastCellList__item_
    BroadcastCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< Broadcast-Cell-List-Item >-----#
    Broadcast_Cell_List_Item = SEQ(name='Broadcast-Cell-List-Item', mode=MODE_TYPE)
    _Broadcast_Cell_List_Item_cellID = SEQ(name='cellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Broadcast_Cell_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Broadcast_Cell_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Broadcast_Cell_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Broadcast_Cell_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Broadcast_Cell_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Broadcast_Cell_List_Item_iE_Extensions__item__id._const_tab = ____Broadcast_Cell_List_Item_iE_Extensions__item__id_tab
    ___Broadcast_Cell_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___Broadcast_Cell_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Broadcast_Cell_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Broadcast_Cell_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Broadcast_Cell_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Broadcast_Cell_List_Item_iE_Extensions__item__criticality._const_tab = ____Broadcast_Cell_List_Item_iE_Extensions__item__criticality_tab
    ___Broadcast_Cell_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Broadcast_Cell_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Broadcast_Cell_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Broadcast_Cell_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Broadcast_Cell_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Broadcast_Cell_List_Item_iE_Extensions__item__extensionValue._const_tab = ____Broadcast_Cell_List_Item_iE_Extensions__item__extensionValue_tab
    ___Broadcast_Cell_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Broadcast_Cell_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Broadcast_Cell_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Broadcast_Cell_List_Item_iE_Extensions__item__id),
        ('criticality', ___Broadcast_Cell_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Broadcast_Cell_List_Item_iE_Extensions__item__extensionValue),
        ])
    __Broadcast_Cell_List_Item_iE_Extensions__item_._ext = None
    _Broadcast_Cell_List_Item_iE_Extensions._cont = __Broadcast_Cell_List_Item_iE_Extensions__item_
    _Broadcast_Cell_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Broadcast_Cell_List_Item._cont = ASN1Dict([
        ('cellID', _Broadcast_Cell_List_Item_cellID),
        ('iE-Extensions', _Broadcast_Cell_List_Item_iE_Extensions),
        ])
    Broadcast_Cell_List_Item._ext = []
    
    #-----< Broadcast-Cell-List-ItemExtIEs >-----#
    Broadcast_Cell_List_ItemExtIEs = CLASS(name='Broadcast-Cell-List-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Broadcast_Cell_List_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BufferSizeThresh >-----#
    BufferSizeThresh = INT(name='BufferSizeThresh', mode=MODE_TYPE)
    BufferSizeThresh._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=None, er=[])
    
    #-----< BurstArrivalTime >-----#
    BurstArrivalTime = OCT_STR(name='BurstArrivalTime', mode=MODE_TYPE)
    
    #-----< CAGID >-----#
    CAGID = BIT_STR(name='CAGID', mode=MODE_TYPE)
    CAGID._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< Cancel-all-Warning-Messages-Indicator >-----#
    Cancel_all_Warning_Messages_Indicator = ENUM(name='Cancel-all-Warning-Messages-Indicator', mode=MODE_TYPE)
    Cancel_all_Warning_Messages_Indicator._cont = ASN1Dict([('true', 0)])
    Cancel_all_Warning_Messages_Indicator._ext = []
    
    #-----< Candidate-SpCell-Item >-----#
    Candidate_SpCell_Item = SEQ(name='Candidate-SpCell-Item', mode=MODE_TYPE)
    _Candidate_SpCell_Item_candidate_SpCell_ID = SEQ(name='candidate-SpCell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Candidate_SpCell_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Candidate_SpCell_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Candidate_SpCell_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Candidate_SpCell_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Candidate_SpCell_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Candidate_SpCell_Item_iE_Extensions__item__id._const_tab = ____Candidate_SpCell_Item_iE_Extensions__item__id_tab
    ___Candidate_SpCell_Item_iE_Extensions__item__id._const_tab_at = None
    ___Candidate_SpCell_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Candidate_SpCell_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Candidate_SpCell_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Candidate_SpCell_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Candidate_SpCell_Item_iE_Extensions__item__criticality._const_tab = ____Candidate_SpCell_Item_iE_Extensions__item__criticality_tab
    ___Candidate_SpCell_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Candidate_SpCell_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Candidate_SpCell_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Candidate_SpCell_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Candidate_SpCell_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Candidate_SpCell_Item_iE_Extensions__item__extensionValue._const_tab = ____Candidate_SpCell_Item_iE_Extensions__item__extensionValue_tab
    ___Candidate_SpCell_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Candidate_SpCell_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Candidate_SpCell_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Candidate_SpCell_Item_iE_Extensions__item__id),
        ('criticality', ___Candidate_SpCell_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Candidate_SpCell_Item_iE_Extensions__item__extensionValue),
        ])
    __Candidate_SpCell_Item_iE_Extensions__item_._ext = None
    _Candidate_SpCell_Item_iE_Extensions._cont = __Candidate_SpCell_Item_iE_Extensions__item_
    _Candidate_SpCell_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Candidate_SpCell_Item._cont = ASN1Dict([
        ('candidate-SpCell-ID', _Candidate_SpCell_Item_candidate_SpCell_ID),
        ('iE-Extensions', _Candidate_SpCell_Item_iE_Extensions),
        ])
    Candidate_SpCell_Item._ext = []
    
    #-----< Candidate-SpCell-ItemExtIEs >-----#
    Candidate_SpCell_ItemExtIEs = CLASS(name='Candidate-SpCell-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Candidate_SpCell_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CapacityValue >-----#
    CapacityValue = SEQ(name='CapacityValue', mode=MODE_TYPE)
    _CapacityValue_capacityValue = INT(name='capacityValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CapacityValue_capacityValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _CapacityValue_sSBAreaCapacityValueList = SEQ_OF(name='sSBAreaCapacityValueList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSBAreaCapacityValueList')), opt=True)
    _CapacityValue_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CapacityValue_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___CapacityValue_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CapacityValue_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CapacityValue_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CapacityValue_iE_Extensions__item__id._const_tab = ____CapacityValue_iE_Extensions__item__id_tab
    ___CapacityValue_iE_Extensions__item__id._const_tab_at = None
    ___CapacityValue_iE_Extensions__item__id._const_tab_id = 'id'
    ___CapacityValue_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CapacityValue_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CapacityValue_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CapacityValue_iE_Extensions__item__criticality._const_tab = ____CapacityValue_iE_Extensions__item__criticality_tab
    ___CapacityValue_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CapacityValue_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CapacityValue_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CapacityValue_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CapacityValue_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CapacityValue_iE_Extensions__item__extensionValue._const_tab = ____CapacityValue_iE_Extensions__item__extensionValue_tab
    ___CapacityValue_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CapacityValue_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CapacityValue_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CapacityValue_iE_Extensions__item__id),
        ('criticality', ___CapacityValue_iE_Extensions__item__criticality),
        ('extensionValue', ___CapacityValue_iE_Extensions__item__extensionValue),
        ])
    __CapacityValue_iE_Extensions__item_._ext = None
    _CapacityValue_iE_Extensions._cont = __CapacityValue_iE_Extensions__item_
    _CapacityValue_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CapacityValue._cont = ASN1Dict([
        ('capacityValue', _CapacityValue_capacityValue),
        ('sSBAreaCapacityValueList', _CapacityValue_sSBAreaCapacityValueList),
        ('iE-Extensions', _CapacityValue_iE_Extensions),
        ])
    CapacityValue._ext = None
    
    #-----< CapacityValue-ExtIEs >-----#
    CapacityValue_ExtIEs = CLASS(name='CapacityValue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    CapacityValue_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cause >-----#
    Cause = CHOICE(name='Cause', mode=MODE_TYPE)
    _Cause_radioNetwork = ENUM(name='radioNetwork', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CauseRadioNetwork')))
    _Cause_transport = ENUM(name='transport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CauseTransport')))
    _Cause_protocol = ENUM(name='protocol', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CauseProtocol')))
    _Cause_misc = ENUM(name='misc', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CauseMisc')))
    _Cause_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Cause_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___Cause_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___Cause_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Cause_choice_extension_id._const_tab = ___Cause_choice_extension_id_tab
    __Cause_choice_extension_id._const_tab_at = None
    __Cause_choice_extension_id._const_tab_id = 'id'
    __Cause_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___Cause_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___Cause_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Cause_choice_extension_criticality._const_tab = ___Cause_choice_extension_criticality_tab
    __Cause_choice_extension_criticality._const_tab_at = ('..', 'id')
    __Cause_choice_extension_criticality._const_tab_id = 'criticality'
    __Cause_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___Cause_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___Cause_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Cause_choice_extension_value._const_tab = ___Cause_choice_extension_value_tab
    __Cause_choice_extension_value._const_tab_at = ('..', 'id')
    __Cause_choice_extension_value._const_tab_id = 'Value'
    _Cause_choice_extension._cont = ASN1Dict([
        ('id', __Cause_choice_extension_id),
        ('criticality', __Cause_choice_extension_criticality),
        ('value', __Cause_choice_extension_value),
        ])
    _Cause_choice_extension._ext = None
    Cause._cont = ASN1Dict([
        ('radioNetwork', _Cause_radioNetwork),
        ('transport', _Cause_transport),
        ('protocol', _Cause_protocol),
        ('misc', _Cause_misc),
        ('choice-extension', _Cause_choice_extension),
        ])
    Cause._ext = None
    
    #-----< Cause-ExtIEs >-----#
    Cause_ExtIEs = CLASS(name='Cause-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    Cause_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CauseMisc >-----#
    CauseMisc = ENUM(name='CauseMisc', mode=MODE_TYPE)
    CauseMisc._cont = ASN1Dict([('control-processing-overload', 0), ('not-enough-user-plane-processing-resources', 1), ('hardware-failure', 2), ('om-intervention', 3), ('unspecified', 4)])
    CauseMisc._ext = []
    
    #-----< CauseProtocol >-----#
    CauseProtocol = ENUM(name='CauseProtocol', mode=MODE_TYPE)
    CauseProtocol._cont = ASN1Dict([('transfer-syntax-error', 0), ('abstract-syntax-error-reject', 1), ('abstract-syntax-error-ignore-and-notify', 2), ('message-not-compatible-with-receiver-state', 3), ('semantic-error', 4), ('abstract-syntax-error-falsely-constructed-message', 5), ('unspecified', 6)])
    CauseProtocol._ext = []
    
    #-----< CauseRadioNetwork >-----#
    CauseRadioNetwork = ENUM(name='CauseRadioNetwork', mode=MODE_TYPE)
    CauseRadioNetwork._cont = ASN1Dict([('unspecified', 0), ('rl-failure-rlc', 1), ('unknown-or-already-allocated-gnb-cu-ue-f1ap-id', 2), ('unknown-or-already-allocated-gnb-du-ue-f1ap-id', 3), ('unknown-or-inconsistent-pair-of-ue-f1ap-id', 4), ('interaction-with-other-procedure', 5), ('not-supported-qci-Value', 6), ('action-desirable-for-radio-reasons', 7), ('no-radio-resources-available', 8), ('procedure-cancelled', 9), ('normal-release', 10), ('cell-not-available', 11), ('rl-failure-others', 12), ('ue-rejection', 13), ('resources-not-available-for-the-slice', 14), ('amf-initiated-abnormal-release', 15), ('release-due-to-pre-emption', 16), ('plmn-not-served-by-the-gNB-CU', 17), ('multiple-drb-id-instances', 18), ('unknown-drb-id', 19), ('multiple-bh-rlc-ch-id-instances', 20), ('unknown-bh-rlc-ch-id', 21), ('cho-cpc-resources-tobechanged', 22), ('nPN-not-supported', 23), ('nPN-access-denied', 24), ('gNB-CU-Cell-Capacity-Exceeded', 25), ('report-characteristics-empty', 26), ('existing-measurement-ID', 27), ('measurement-temporarily-not-available', 28), ('measurement-not-supported-for-the-object', 29), ('unknown-bh-address', 30), ('unknown-bap-routing-id', 31), ('insufficient-ue-capabilities', 32), ('scg-activation-deactivation-failure', 33), ('scg-deactivation-failure-due-to-data-transmission', 34), ('requested-item-not-supported-on-time', 35), ('unknown-or-already-allocated-gNB-CU-MBS-F1AP-ID', 36), ('unknown-or-already-allocated-gNB-DU-MBS-F1AP-ID', 37), ('unknown-or-inconsistent-pair-of-MBS-F1AP-ID', 38), ('unknown-or-inconsistent-MRB-ID', 39), ('tat-sdt-expiry', 40)])
    CauseRadioNetwork._ext = ['cell-not-available', 'rl-failure-others', 'ue-rejection', 'resources-not-available-for-the-slice', 'amf-initiated-abnormal-release', 'release-due-to-pre-emption', 'plmn-not-served-by-the-gNB-CU', 'multiple-drb-id-instances', 'unknown-drb-id', 'multiple-bh-rlc-ch-id-instances', 'unknown-bh-rlc-ch-id', 'cho-cpc-resources-tobechanged', 'nPN-not-supported', 'nPN-access-denied', 'gNB-CU-Cell-Capacity-Exceeded', 'report-characteristics-empty', 'existing-measurement-ID', 'measurement-temporarily-not-available', 'measurement-not-supported-for-the-object', 'unknown-bh-address', 'unknown-bap-routing-id', 'insufficient-ue-capabilities', 'scg-activation-deactivation-failure', 'scg-deactivation-failure-due-to-data-transmission', 'requested-item-not-supported-on-time', 'unknown-or-already-allocated-gNB-CU-MBS-F1AP-ID', 'unknown-or-already-allocated-gNB-DU-MBS-F1AP-ID', 'unknown-or-inconsistent-pair-of-MBS-F1AP-ID', 'unknown-or-inconsistent-MRB-ID', 'tat-sdt-expiry']
    
    #-----< CauseTransport >-----#
    CauseTransport = ENUM(name='CauseTransport', mode=MODE_TYPE)
    CauseTransport._cont = ASN1Dict([('unspecified', 0), ('transport-resource-unavailable', 1), ('unknown-TNL-address-for-IAB', 2), ('unknown-UP-TNL-information-for-IAB', 3)])
    CauseTransport._ext = ['unknown-TNL-address-for-IAB', 'unknown-UP-TNL-information-for-IAB']
    
    #-----< CellGroupConfig >-----#
    CellGroupConfig = OCT_STR(name='CellGroupConfig', mode=MODE_TYPE)
    
    #-----< CellCapacityClassValue >-----#
    CellCapacityClassValue = INT(name='CellCapacityClassValue', mode=MODE_TYPE)
    CellCapacityClassValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=[], er=[])
    
    #-----< Cell-Direction >-----#
    Cell_Direction = ENUM(name='Cell-Direction', mode=MODE_TYPE)
    Cell_Direction._cont = ASN1Dict([('dl-only', 0), ('ul-only', 1)])
    Cell_Direction._ext = None
    
    #-----< CellMeasurementResultList >-----#
    CellMeasurementResultList = SEQ_OF(name='CellMeasurementResultList', mode=MODE_TYPE)
    _CellMeasurementResultList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellMeasurementResultItem')))
    CellMeasurementResultList._cont = _CellMeasurementResultList__item_
    CellMeasurementResultList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< CellMeasurementResultItem >-----#
    CellMeasurementResultItem = SEQ(name='CellMeasurementResultItem', mode=MODE_TYPE)
    _CellMeasurementResultItem_cellID = SEQ(name='cellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _CellMeasurementResultItem_radioResourceStatus = SEQ(name='radioResourceStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RadioResourceStatus')), opt=True)
    _CellMeasurementResultItem_compositeAvailableCapacityGroup = SEQ(name='compositeAvailableCapacityGroup', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CompositeAvailableCapacityGroup')), opt=True)
    _CellMeasurementResultItem_sliceAvailableCapacity = SEQ(name='sliceAvailableCapacity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SliceAvailableCapacity')), opt=True)
    _CellMeasurementResultItem_numberofActiveUEs = INT(name='numberofActiveUEs', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NumberofActiveUEs')), opt=True)
    _CellMeasurementResultItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellMeasurementResultItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___CellMeasurementResultItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CellMeasurementResultItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____CellMeasurementResultItem_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NR-U-Channel-List')))
    ____CellMeasurementResultItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 444), ('criticality', 'ignore'), ('Extension', _____CellMeasurementResultItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellMeasurementResultItem_iE_Extensions__item__id._const_tab = ____CellMeasurementResultItem_iE_Extensions__item__id_tab
    ___CellMeasurementResultItem_iE_Extensions__item__id._const_tab_at = None
    ___CellMeasurementResultItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellMeasurementResultItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CellMeasurementResultItem_iE_Extensions__item__criticality._const_tab = ____CellMeasurementResultItem_iE_Extensions__item__id_tab
    ___CellMeasurementResultItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellMeasurementResultItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellMeasurementResultItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CellMeasurementResultItem_iE_Extensions__item__extensionValue._const_tab = ____CellMeasurementResultItem_iE_Extensions__item__id_tab
    ___CellMeasurementResultItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellMeasurementResultItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellMeasurementResultItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellMeasurementResultItem_iE_Extensions__item__id),
        ('criticality', ___CellMeasurementResultItem_iE_Extensions__item__criticality),
        ('extensionValue', ___CellMeasurementResultItem_iE_Extensions__item__extensionValue),
        ])
    __CellMeasurementResultItem_iE_Extensions__item_._ext = None
    _CellMeasurementResultItem_iE_Extensions._cont = __CellMeasurementResultItem_iE_Extensions__item_
    _CellMeasurementResultItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellMeasurementResultItem._cont = ASN1Dict([
        ('cellID', _CellMeasurementResultItem_cellID),
        ('radioResourceStatus', _CellMeasurementResultItem_radioResourceStatus),
        ('compositeAvailableCapacityGroup', _CellMeasurementResultItem_compositeAvailableCapacityGroup),
        ('sliceAvailableCapacity', _CellMeasurementResultItem_sliceAvailableCapacity),
        ('numberofActiveUEs', _CellMeasurementResultItem_numberofActiveUEs),
        ('iE-Extensions', _CellMeasurementResultItem_iE_Extensions),
        ])
    CellMeasurementResultItem._ext = None
    
    #-----< CellMeasurementResultItem-ExtIEs >-----#
    CellMeasurementResultItem_ExtIEs = CLASS(name='CellMeasurementResultItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _CellMeasurementResultItem_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NR-U-Channel-List')))
    CellMeasurementResultItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 444), ('criticality', 'ignore'), ('Extension', _CellMeasurementResultItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Cell-Portion-ID >-----#
    Cell_Portion_ID = INT(name='Cell-Portion-ID', mode=MODE_TYPE)
    Cell_Portion_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[])
    
    #-----< CellsForSON-List >-----#
    CellsForSON_List = SEQ_OF(name='CellsForSON-List', mode=MODE_TYPE)
    _CellsForSON_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellsForSON-Item')))
    CellsForSON_List._cont = _CellsForSON_List__item_
    CellsForSON_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CellsForSON-Item >-----#
    CellsForSON_Item = SEQ(name='CellsForSON-Item', mode=MODE_TYPE)
    _CellsForSON_Item_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _CellsForSON_Item_neighbourNR_CellsForSON_List = SEQ_OF(name='neighbourNR-CellsForSON-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NeighbourNR-CellsForSON-List')), opt=True)
    _CellsForSON_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellsForSON_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___CellsForSON_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CellsForSON_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CellsForSON_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellsForSON_Item_iE_Extensions__item__id._const_tab = ____CellsForSON_Item_iE_Extensions__item__id_tab
    ___CellsForSON_Item_iE_Extensions__item__id._const_tab_at = None
    ___CellsForSON_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellsForSON_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellsForSON_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CellsForSON_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellsForSON_Item_iE_Extensions__item__criticality._const_tab = ____CellsForSON_Item_iE_Extensions__item__criticality_tab
    ___CellsForSON_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellsForSON_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellsForSON_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellsForSON_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CellsForSON_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellsForSON_Item_iE_Extensions__item__extensionValue._const_tab = ____CellsForSON_Item_iE_Extensions__item__extensionValue_tab
    ___CellsForSON_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellsForSON_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellsForSON_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellsForSON_Item_iE_Extensions__item__id),
        ('criticality', ___CellsForSON_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CellsForSON_Item_iE_Extensions__item__extensionValue),
        ])
    __CellsForSON_Item_iE_Extensions__item_._ext = None
    _CellsForSON_Item_iE_Extensions._cont = __CellsForSON_Item_iE_Extensions__item_
    _CellsForSON_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellsForSON_Item._cont = ASN1Dict([
        ('nRCGI', _CellsForSON_Item_nRCGI),
        ('neighbourNR-CellsForSON-List', _CellsForSON_Item_neighbourNR_CellsForSON_List),
        ('iE-Extensions', _CellsForSON_Item_iE_Extensions),
        ])
    CellsForSON_Item._ext = []
    
    #-----< CellsForSON-Item-ExtIEs >-----#
    CellsForSON_Item_ExtIEs = CLASS(name='CellsForSON-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    CellsForSON_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cells-Failed-to-be-Activated-List-Item >-----#
    Cells_Failed_to_be_Activated_List_Item = SEQ(name='Cells-Failed-to-be-Activated-List-Item', mode=MODE_TYPE)
    _Cells_Failed_to_be_Activated_List_Item_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Cells_Failed_to_be_Activated_List_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _Cells_Failed_to_be_Activated_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__id._const_tab = ____Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__id_tab
    ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__criticality._const_tab = ____Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__criticality_tab
    ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__extensionValue._const_tab = ____Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__extensionValue_tab
    ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__id),
        ('criticality', ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__extensionValue),
        ])
    __Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item_._ext = None
    _Cells_Failed_to_be_Activated_List_Item_iE_Extensions._cont = __Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item_
    _Cells_Failed_to_be_Activated_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cells_Failed_to_be_Activated_List_Item._cont = ASN1Dict([
        ('nRCGI', _Cells_Failed_to_be_Activated_List_Item_nRCGI),
        ('cause', _Cells_Failed_to_be_Activated_List_Item_cause),
        ('iE-Extensions', _Cells_Failed_to_be_Activated_List_Item_iE_Extensions),
        ])
    Cells_Failed_to_be_Activated_List_Item._ext = []
    
    #-----< Cells-Failed-to-be-Activated-List-ItemExtIEs >-----#
    Cells_Failed_to_be_Activated_List_ItemExtIEs = CLASS(name='Cells-Failed-to-be-Activated-List-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Cells_Failed_to_be_Activated_List_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cells-Status-Item >-----#
    Cells_Status_Item = SEQ(name='Cells-Status-Item', mode=MODE_TYPE)
    _Cells_Status_Item_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Cells_Status_Item_service_status = SEQ(name='service-status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Service-Status')))
    _Cells_Status_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cells_Status_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Cells_Status_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Cells_Status_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_Status_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_Status_Item_iE_Extensions__item__id._const_tab = ____Cells_Status_Item_iE_Extensions__item__id_tab
    ___Cells_Status_Item_iE_Extensions__item__id._const_tab_at = None
    ___Cells_Status_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cells_Status_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Cells_Status_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_Status_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_Status_Item_iE_Extensions__item__criticality._const_tab = ____Cells_Status_Item_iE_Extensions__item__criticality_tab
    ___Cells_Status_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cells_Status_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cells_Status_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Cells_Status_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_Status_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_Status_Item_iE_Extensions__item__extensionValue._const_tab = ____Cells_Status_Item_iE_Extensions__item__extensionValue_tab
    ___Cells_Status_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cells_Status_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cells_Status_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cells_Status_Item_iE_Extensions__item__id),
        ('criticality', ___Cells_Status_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Cells_Status_Item_iE_Extensions__item__extensionValue),
        ])
    __Cells_Status_Item_iE_Extensions__item_._ext = None
    _Cells_Status_Item_iE_Extensions._cont = __Cells_Status_Item_iE_Extensions__item_
    _Cells_Status_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cells_Status_Item._cont = ASN1Dict([
        ('nRCGI', _Cells_Status_Item_nRCGI),
        ('service-status', _Cells_Status_Item_service_status),
        ('iE-Extensions', _Cells_Status_Item_iE_Extensions),
        ])
    Cells_Status_Item._ext = []
    
    #-----< Cells-Status-ItemExtIEs >-----#
    Cells_Status_ItemExtIEs = CLASS(name='Cells-Status-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Cells_Status_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cells-To-Be-Broadcast-Item >-----#
    Cells_To_Be_Broadcast_Item = SEQ(name='Cells-To-Be-Broadcast-Item', mode=MODE_TYPE)
    _Cells_To_Be_Broadcast_Item_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Cells_To_Be_Broadcast_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cells_To_Be_Broadcast_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Cells_To_Be_Broadcast_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_To_Be_Broadcast_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__id._const_tab = ____Cells_To_Be_Broadcast_Item_iE_Extensions__item__id_tab
    ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__id._const_tab_at = None
    ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Cells_To_Be_Broadcast_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_To_Be_Broadcast_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__criticality._const_tab = ____Cells_To_Be_Broadcast_Item_iE_Extensions__item__criticality_tab
    ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Cells_To_Be_Broadcast_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_To_Be_Broadcast_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__extensionValue._const_tab = ____Cells_To_Be_Broadcast_Item_iE_Extensions__item__extensionValue_tab
    ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cells_To_Be_Broadcast_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__id),
        ('criticality', ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__extensionValue),
        ])
    __Cells_To_Be_Broadcast_Item_iE_Extensions__item_._ext = None
    _Cells_To_Be_Broadcast_Item_iE_Extensions._cont = __Cells_To_Be_Broadcast_Item_iE_Extensions__item_
    _Cells_To_Be_Broadcast_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cells_To_Be_Broadcast_Item._cont = ASN1Dict([
        ('nRCGI', _Cells_To_Be_Broadcast_Item_nRCGI),
        ('iE-Extensions', _Cells_To_Be_Broadcast_Item_iE_Extensions),
        ])
    Cells_To_Be_Broadcast_Item._ext = []
    
    #-----< Cells-To-Be-Broadcast-ItemExtIEs >-----#
    Cells_To_Be_Broadcast_ItemExtIEs = CLASS(name='Cells-To-Be-Broadcast-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Cells_To_Be_Broadcast_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cells-Broadcast-Completed-Item >-----#
    Cells_Broadcast_Completed_Item = SEQ(name='Cells-Broadcast-Completed-Item', mode=MODE_TYPE)
    _Cells_Broadcast_Completed_Item_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Cells_Broadcast_Completed_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cells_Broadcast_Completed_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Cells_Broadcast_Completed_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Cells_Broadcast_Completed_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_Broadcast_Completed_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_Broadcast_Completed_Item_iE_Extensions__item__id._const_tab = ____Cells_Broadcast_Completed_Item_iE_Extensions__item__id_tab
    ___Cells_Broadcast_Completed_Item_iE_Extensions__item__id._const_tab_at = None
    ___Cells_Broadcast_Completed_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cells_Broadcast_Completed_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Cells_Broadcast_Completed_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_Broadcast_Completed_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_Broadcast_Completed_Item_iE_Extensions__item__criticality._const_tab = ____Cells_Broadcast_Completed_Item_iE_Extensions__item__criticality_tab
    ___Cells_Broadcast_Completed_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cells_Broadcast_Completed_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cells_Broadcast_Completed_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Cells_Broadcast_Completed_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_Broadcast_Completed_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_Broadcast_Completed_Item_iE_Extensions__item__extensionValue._const_tab = ____Cells_Broadcast_Completed_Item_iE_Extensions__item__extensionValue_tab
    ___Cells_Broadcast_Completed_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cells_Broadcast_Completed_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cells_Broadcast_Completed_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cells_Broadcast_Completed_Item_iE_Extensions__item__id),
        ('criticality', ___Cells_Broadcast_Completed_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Cells_Broadcast_Completed_Item_iE_Extensions__item__extensionValue),
        ])
    __Cells_Broadcast_Completed_Item_iE_Extensions__item_._ext = None
    _Cells_Broadcast_Completed_Item_iE_Extensions._cont = __Cells_Broadcast_Completed_Item_iE_Extensions__item_
    _Cells_Broadcast_Completed_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cells_Broadcast_Completed_Item._cont = ASN1Dict([
        ('nRCGI', _Cells_Broadcast_Completed_Item_nRCGI),
        ('iE-Extensions', _Cells_Broadcast_Completed_Item_iE_Extensions),
        ])
    Cells_Broadcast_Completed_Item._ext = []
    
    #-----< Cells-Broadcast-Completed-ItemExtIEs >-----#
    Cells_Broadcast_Completed_ItemExtIEs = CLASS(name='Cells-Broadcast-Completed-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Cells_Broadcast_Completed_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Broadcast-To-Be-Cancelled-Item >-----#
    Broadcast_To_Be_Cancelled_Item = SEQ(name='Broadcast-To-Be-Cancelled-Item', mode=MODE_TYPE)
    _Broadcast_To_Be_Cancelled_Item_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Broadcast_To_Be_Cancelled_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Broadcast_To_Be_Cancelled_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__id._const_tab = ____Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__id_tab
    ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__id._const_tab_at = None
    ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__criticality._const_tab = ____Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__criticality_tab
    ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab = ____Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__extensionValue_tab
    ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Broadcast_To_Be_Cancelled_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__id),
        ('criticality', ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__extensionValue),
        ])
    __Broadcast_To_Be_Cancelled_Item_iE_Extensions__item_._ext = None
    _Broadcast_To_Be_Cancelled_Item_iE_Extensions._cont = __Broadcast_To_Be_Cancelled_Item_iE_Extensions__item_
    _Broadcast_To_Be_Cancelled_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Broadcast_To_Be_Cancelled_Item._cont = ASN1Dict([
        ('nRCGI', _Broadcast_To_Be_Cancelled_Item_nRCGI),
        ('iE-Extensions', _Broadcast_To_Be_Cancelled_Item_iE_Extensions),
        ])
    Broadcast_To_Be_Cancelled_Item._ext = []
    
    #-----< Broadcast-To-Be-Cancelled-ItemExtIEs >-----#
    Broadcast_To_Be_Cancelled_ItemExtIEs = CLASS(name='Broadcast-To-Be-Cancelled-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Broadcast_To_Be_Cancelled_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cells-Broadcast-Cancelled-Item >-----#
    Cells_Broadcast_Cancelled_Item = SEQ(name='Cells-Broadcast-Cancelled-Item', mode=MODE_TYPE)
    _Cells_Broadcast_Cancelled_Item_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Cells_Broadcast_Cancelled_Item_numberOfBroadcasts = INT(name='numberOfBroadcasts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NumberOfBroadcasts')))
    _Cells_Broadcast_Cancelled_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cells_Broadcast_Cancelled_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Cells_Broadcast_Cancelled_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_Broadcast_Cancelled_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__id._const_tab = ____Cells_Broadcast_Cancelled_Item_iE_Extensions__item__id_tab
    ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__id._const_tab_at = None
    ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Cells_Broadcast_Cancelled_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_Broadcast_Cancelled_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__criticality._const_tab = ____Cells_Broadcast_Cancelled_Item_iE_Extensions__item__criticality_tab
    ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Cells_Broadcast_Cancelled_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_Broadcast_Cancelled_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab = ____Cells_Broadcast_Cancelled_Item_iE_Extensions__item__extensionValue_tab
    ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cells_Broadcast_Cancelled_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__id),
        ('criticality', ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__extensionValue),
        ])
    __Cells_Broadcast_Cancelled_Item_iE_Extensions__item_._ext = None
    _Cells_Broadcast_Cancelled_Item_iE_Extensions._cont = __Cells_Broadcast_Cancelled_Item_iE_Extensions__item_
    _Cells_Broadcast_Cancelled_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cells_Broadcast_Cancelled_Item._cont = ASN1Dict([
        ('nRCGI', _Cells_Broadcast_Cancelled_Item_nRCGI),
        ('numberOfBroadcasts', _Cells_Broadcast_Cancelled_Item_numberOfBroadcasts),
        ('iE-Extensions', _Cells_Broadcast_Cancelled_Item_iE_Extensions),
        ])
    Cells_Broadcast_Cancelled_Item._ext = []
    
    #-----< Cells-Broadcast-Cancelled-ItemExtIEs >-----#
    Cells_Broadcast_Cancelled_ItemExtIEs = CLASS(name='Cells-Broadcast-Cancelled-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Cells_Broadcast_Cancelled_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cells-to-be-Activated-List-Item >-----#
    Cells_to_be_Activated_List_Item = SEQ(name='Cells-to-be-Activated-List-Item', mode=MODE_TYPE)
    _Cells_to_be_Activated_List_Item_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Cells_to_be_Activated_List_Item_nRPCI = INT(name='nRPCI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRPCI')), opt=True)
    _Cells_to_be_Activated_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cells_to_be_Activated_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Cells_to_be_Activated_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CUSystemInformation')))
    _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AvailablePLMNList')))
    _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedAvailablePLMN-List')))
    _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-Info-IAB-donor-CU')))
    _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AvailableSNPN-ID-List')))
    _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_5 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-Broadcast-NeighbourCellList')))
    ____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 118), ('criticality', 'reject'), ('Extension', _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 179), ('criticality', 'ignore'), ('Extension', _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 197), ('criticality', 'ignore'), ('Extension', _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 291), ('criticality', 'ignore'), ('Extension', _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 386), ('criticality', 'ignore'), ('Extension', _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 457), ('criticality', 'ignore'), ('Extension', _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Cells_to_be_Activated_List_Item_iE_Extensions__item__id._const_tab = ____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab
    ___Cells_to_be_Activated_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___Cells_to_be_Activated_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cells_to_be_Activated_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Cells_to_be_Activated_List_Item_iE_Extensions__item__criticality._const_tab = ____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab
    ___Cells_to_be_Activated_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cells_to_be_Activated_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cells_to_be_Activated_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Cells_to_be_Activated_List_Item_iE_Extensions__item__extensionValue._const_tab = ____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab
    ___Cells_to_be_Activated_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cells_to_be_Activated_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cells_to_be_Activated_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cells_to_be_Activated_List_Item_iE_Extensions__item__id),
        ('criticality', ___Cells_to_be_Activated_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Cells_to_be_Activated_List_Item_iE_Extensions__item__extensionValue),
        ])
    __Cells_to_be_Activated_List_Item_iE_Extensions__item_._ext = None
    _Cells_to_be_Activated_List_Item_iE_Extensions._cont = __Cells_to_be_Activated_List_Item_iE_Extensions__item_
    _Cells_to_be_Activated_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cells_to_be_Activated_List_Item._cont = ASN1Dict([
        ('nRCGI', _Cells_to_be_Activated_List_Item_nRCGI),
        ('nRPCI', _Cells_to_be_Activated_List_Item_nRPCI),
        ('iE-Extensions', _Cells_to_be_Activated_List_Item_iE_Extensions),
        ])
    Cells_to_be_Activated_List_Item._ext = []
    
    #-----< Cells-to-be-Activated-List-ItemExtIEs >-----#
    Cells_to_be_Activated_List_ItemExtIEs = CLASS(name='Cells-to-be-Activated-List-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CUSystemInformation')))
    _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AvailablePLMNList')))
    _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedAvailablePLMN-List')))
    _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-Info-IAB-donor-CU')))
    _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AvailableSNPN-ID-List')))
    _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_5 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-Broadcast-NeighbourCellList')))
    Cells_to_be_Activated_List_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 118), ('criticality', 'reject'), ('Extension', _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 179), ('criticality', 'ignore'), ('Extension', _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 197), ('criticality', 'ignore'), ('Extension', _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 291), ('criticality', 'ignore'), ('Extension', _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 386), ('criticality', 'ignore'), ('Extension', _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 457), ('criticality', 'ignore'), ('Extension', _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Cells-to-be-Deactivated-List-Item >-----#
    Cells_to_be_Deactivated_List_Item = SEQ(name='Cells-to-be-Deactivated-List-Item', mode=MODE_TYPE)
    _Cells_to_be_Deactivated_List_Item_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Cells_to_be_Deactivated_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cells_to_be_Deactivated_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Cells_to_be_Deactivated_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_to_be_Deactivated_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__id._const_tab = ____Cells_to_be_Deactivated_List_Item_iE_Extensions__item__id_tab
    ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Cells_to_be_Deactivated_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_to_be_Deactivated_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__criticality._const_tab = ____Cells_to_be_Deactivated_List_Item_iE_Extensions__item__criticality_tab
    ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Cells_to_be_Deactivated_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Cells_to_be_Deactivated_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__extensionValue._const_tab = ____Cells_to_be_Deactivated_List_Item_iE_Extensions__item__extensionValue_tab
    ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cells_to_be_Deactivated_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__id),
        ('criticality', ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__extensionValue),
        ])
    __Cells_to_be_Deactivated_List_Item_iE_Extensions__item_._ext = None
    _Cells_to_be_Deactivated_List_Item_iE_Extensions._cont = __Cells_to_be_Deactivated_List_Item_iE_Extensions__item_
    _Cells_to_be_Deactivated_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cells_to_be_Deactivated_List_Item._cont = ASN1Dict([
        ('nRCGI', _Cells_to_be_Deactivated_List_Item_nRCGI),
        ('iE-Extensions', _Cells_to_be_Deactivated_List_Item_iE_Extensions),
        ])
    Cells_to_be_Deactivated_List_Item._ext = []
    
    #-----< Cells-to-be-Deactivated-List-ItemExtIEs >-----#
    Cells_to_be_Deactivated_List_ItemExtIEs = CLASS(name='Cells-to-be-Deactivated-List-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Cells_to_be_Deactivated_List_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cells-to-be-Barred-Item >-----#
    Cells_to_be_Barred_Item = SEQ(name='Cells-to-be-Barred-Item', mode=MODE_TYPE)
    _Cells_to_be_Barred_Item_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Cells_to_be_Barred_Item_cellBarred = ENUM(name='cellBarred', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CellBarred')))
    _Cells_to_be_Barred_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cells_to_be_Barred_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Cells_to_be_Barred_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Cells_to_be_Barred_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____Cells_to_be_Barred_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-Barred')))
    ____Cells_to_be_Barred_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 298), ('criticality', 'ignore'), ('Extension', _____Cells_to_be_Barred_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Cells_to_be_Barred_Item_iE_Extensions__item__id._const_tab = ____Cells_to_be_Barred_Item_iE_Extensions__item__id_tab
    ___Cells_to_be_Barred_Item_iE_Extensions__item__id._const_tab_at = None
    ___Cells_to_be_Barred_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cells_to_be_Barred_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Cells_to_be_Barred_Item_iE_Extensions__item__criticality._const_tab = ____Cells_to_be_Barred_Item_iE_Extensions__item__id_tab
    ___Cells_to_be_Barred_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cells_to_be_Barred_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cells_to_be_Barred_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Cells_to_be_Barred_Item_iE_Extensions__item__extensionValue._const_tab = ____Cells_to_be_Barred_Item_iE_Extensions__item__id_tab
    ___Cells_to_be_Barred_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cells_to_be_Barred_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cells_to_be_Barred_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cells_to_be_Barred_Item_iE_Extensions__item__id),
        ('criticality', ___Cells_to_be_Barred_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Cells_to_be_Barred_Item_iE_Extensions__item__extensionValue),
        ])
    __Cells_to_be_Barred_Item_iE_Extensions__item_._ext = None
    _Cells_to_be_Barred_Item_iE_Extensions._cont = __Cells_to_be_Barred_Item_iE_Extensions__item_
    _Cells_to_be_Barred_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cells_to_be_Barred_Item._cont = ASN1Dict([
        ('nRCGI', _Cells_to_be_Barred_Item_nRCGI),
        ('cellBarred', _Cells_to_be_Barred_Item_cellBarred),
        ('iE-Extensions', _Cells_to_be_Barred_Item_iE_Extensions),
        ])
    Cells_to_be_Barred_Item._ext = None
    
    #-----< Cells-to-be-Barred-Item-ExtIEs >-----#
    Cells_to_be_Barred_Item_ExtIEs = CLASS(name='Cells-to-be-Barred-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _Cells_to_be_Barred_Item_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-Barred')))
    Cells_to_be_Barred_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 298), ('criticality', 'ignore'), ('Extension', _Cells_to_be_Barred_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellBarred >-----#
    CellBarred = ENUM(name='CellBarred', mode=MODE_TYPE)
    CellBarred._cont = ASN1Dict([('barred', 0), ('not-barred', 1)])
    CellBarred._ext = []
    
    #-----< CellSize >-----#
    CellSize = ENUM(name='CellSize', mode=MODE_TYPE)
    CellSize._cont = ASN1Dict([('verysmall', 0), ('small', 1), ('medium', 2), ('large', 3)])
    CellSize._ext = []
    
    #-----< CellToReportList >-----#
    CellToReportList = SEQ_OF(name='CellToReportList', mode=MODE_TYPE)
    _CellToReportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellToReportItem')))
    CellToReportList._cont = _CellToReportList__item_
    CellToReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< CellToReportItem >-----#
    CellToReportItem = SEQ(name='CellToReportItem', mode=MODE_TYPE)
    _CellToReportItem_cellID = SEQ(name='cellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _CellToReportItem_sSBToReportList = SEQ_OF(name='sSBToReportList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSBToReportList')), opt=True)
    _CellToReportItem_sliceToReportList = SEQ_OF(name='sliceToReportList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SliceToReportList')), opt=True)
    _CellToReportItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellToReportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___CellToReportItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CellToReportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CellToReportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellToReportItem_iE_Extensions__item__id._const_tab = ____CellToReportItem_iE_Extensions__item__id_tab
    ___CellToReportItem_iE_Extensions__item__id._const_tab_at = None
    ___CellToReportItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellToReportItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellToReportItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CellToReportItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellToReportItem_iE_Extensions__item__criticality._const_tab = ____CellToReportItem_iE_Extensions__item__criticality_tab
    ___CellToReportItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellToReportItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellToReportItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellToReportItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CellToReportItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellToReportItem_iE_Extensions__item__extensionValue._const_tab = ____CellToReportItem_iE_Extensions__item__extensionValue_tab
    ___CellToReportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellToReportItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellToReportItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellToReportItem_iE_Extensions__item__id),
        ('criticality', ___CellToReportItem_iE_Extensions__item__criticality),
        ('extensionValue', ___CellToReportItem_iE_Extensions__item__extensionValue),
        ])
    __CellToReportItem_iE_Extensions__item_._ext = None
    _CellToReportItem_iE_Extensions._cont = __CellToReportItem_iE_Extensions__item_
    _CellToReportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellToReportItem._cont = ASN1Dict([
        ('cellID', _CellToReportItem_cellID),
        ('sSBToReportList', _CellToReportItem_sSBToReportList),
        ('sliceToReportList', _CellToReportItem_sliceToReportList),
        ('iE-Extensions', _CellToReportItem_iE_Extensions),
        ])
    CellToReportItem._ext = None
    
    #-----< CellToReportItem-ExtIEs >-----#
    CellToReportItem_ExtIEs = CLASS(name='CellToReportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    CellToReportItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellType >-----#
    CellType = SEQ(name='CellType', mode=MODE_TYPE)
    _CellType_cellSize = ENUM(name='cellSize', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CellSize')))
    _CellType_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellType_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___CellType_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CellType_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CellType_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellType_iE_Extensions__item__id._const_tab = ____CellType_iE_Extensions__item__id_tab
    ___CellType_iE_Extensions__item__id._const_tab_at = None
    ___CellType_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellType_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellType_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CellType_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellType_iE_Extensions__item__criticality._const_tab = ____CellType_iE_Extensions__item__criticality_tab
    ___CellType_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellType_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellType_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellType_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CellType_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellType_iE_Extensions__item__extensionValue._const_tab = ____CellType_iE_Extensions__item__extensionValue_tab
    ___CellType_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellType_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellType_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellType_iE_Extensions__item__id),
        ('criticality', ___CellType_iE_Extensions__item__criticality),
        ('extensionValue', ___CellType_iE_Extensions__item__extensionValue),
        ])
    __CellType_iE_Extensions__item_._ext = None
    _CellType_iE_Extensions._cont = __CellType_iE_Extensions__item_
    _CellType_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellType._cont = ASN1Dict([
        ('cellSize', _CellType_cellSize),
        ('iE-Extensions', _CellType_iE_Extensions),
        ])
    CellType._ext = []
    
    #-----< CellType-ExtIEs >-----#
    CellType_ExtIEs = CLASS(name='CellType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    CellType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellULConfigured >-----#
    CellULConfigured = ENUM(name='CellULConfigured', mode=MODE_TYPE)
    CellULConfigured._cont = ASN1Dict([('none', 0), ('ul', 1), ('sul', 2), ('ul-and-sul', 3)])
    CellULConfigured._ext = []
    
    #-----< CG-SDTQueryIndication >-----#
    CG_SDTQueryIndication = ENUM(name='CG-SDTQueryIndication', mode=MODE_TYPE)
    CG_SDTQueryIndication._cont = ASN1Dict([('true', 0)])
    CG_SDTQueryIndication._ext = []
    
    #-----< CG-SDTKeptIndicator >-----#
    CG_SDTKeptIndicator = ENUM(name='CG-SDTKeptIndicator', mode=MODE_TYPE)
    CG_SDTKeptIndicator._cont = ASN1Dict([('true', 0)])
    CG_SDTKeptIndicator._ext = []
    
    #-----< CG-SDTindicatorSetup >-----#
    CG_SDTindicatorSetup = ENUM(name='CG-SDTindicatorSetup', mode=MODE_TYPE)
    CG_SDTindicatorSetup._cont = ASN1Dict([('true', 0)])
    CG_SDTindicatorSetup._ext = []
    
    #-----< CG-SDTindicatorMod >-----#
    CG_SDTindicatorMod = ENUM(name='CG-SDTindicatorMod', mode=MODE_TYPE)
    CG_SDTindicatorMod._cont = ASN1Dict([('true', 0), ('false', 1)])
    CG_SDTindicatorMod._ext = []
    
    #-----< CG-SDTSessionInfo >-----#
    CG_SDTSessionInfo = SEQ(name='CG-SDTSessionInfo', mode=MODE_TYPE)
    _CG_SDTSessionInfo_gNB_CU_UE_F1AP_ID = INT(name='gNB-CU-UE-F1AP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _CG_SDTSessionInfo_gNB_DU_UE_F1AP_ID = INT(name='gNB-DU-UE-F1AP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _CG_SDTSessionInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CG_SDTSessionInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___CG_SDTSessionInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CG_SDTSessionInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CG_SDTSessionInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CG_SDTSessionInfo_iE_Extensions__item__id._const_tab = ____CG_SDTSessionInfo_iE_Extensions__item__id_tab
    ___CG_SDTSessionInfo_iE_Extensions__item__id._const_tab_at = None
    ___CG_SDTSessionInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___CG_SDTSessionInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CG_SDTSessionInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CG_SDTSessionInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CG_SDTSessionInfo_iE_Extensions__item__criticality._const_tab = ____CG_SDTSessionInfo_iE_Extensions__item__criticality_tab
    ___CG_SDTSessionInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CG_SDTSessionInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CG_SDTSessionInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CG_SDTSessionInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CG_SDTSessionInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CG_SDTSessionInfo_iE_Extensions__item__extensionValue._const_tab = ____CG_SDTSessionInfo_iE_Extensions__item__extensionValue_tab
    ___CG_SDTSessionInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CG_SDTSessionInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CG_SDTSessionInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CG_SDTSessionInfo_iE_Extensions__item__id),
        ('criticality', ___CG_SDTSessionInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___CG_SDTSessionInfo_iE_Extensions__item__extensionValue),
        ])
    __CG_SDTSessionInfo_iE_Extensions__item_._ext = None
    _CG_SDTSessionInfo_iE_Extensions._cont = __CG_SDTSessionInfo_iE_Extensions__item_
    _CG_SDTSessionInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CG_SDTSessionInfo._cont = ASN1Dict([
        ('gNB-CU-UE-F1AP-ID', _CG_SDTSessionInfo_gNB_CU_UE_F1AP_ID),
        ('gNB-DU-UE-F1AP-ID', _CG_SDTSessionInfo_gNB_DU_UE_F1AP_ID),
        ('iE-Extensions', _CG_SDTSessionInfo_iE_Extensions),
        ])
    CG_SDTSessionInfo._ext = []
    
    #-----< CG-SDTSessionInfo-ExtIEs >-----#
    CG_SDTSessionInfo_ExtIEs = CLASS(name='CG-SDTSessionInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    CG_SDTSessionInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ChannelOccupancyTimePercentage >-----#
    ChannelOccupancyTimePercentage = INT(name='ChannelOccupancyTimePercentage', mode=MODE_TYPE)
    ChannelOccupancyTimePercentage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=[], er=[])
    
    #-----< Child-IAB-Nodes-NA-Resource-List >-----#
    Child_IAB_Nodes_NA_Resource_List = SEQ_OF(name='Child-IAB-Nodes-NA-Resource-List', mode=MODE_TYPE)
    _Child_IAB_Nodes_NA_Resource_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Child-IAB-Nodes-NA-Resource-List-Item')))
    Child_IAB_Nodes_NA_Resource_List._cont = _Child_IAB_Nodes_NA_Resource_List__item_
    Child_IAB_Nodes_NA_Resource_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< Child-IAB-Nodes-NA-Resource-List-Item >-----#
    Child_IAB_Nodes_NA_Resource_List_Item = SEQ(name='Child-IAB-Nodes-NA-Resource-List-Item', mode=MODE_TYPE)
    _Child_IAB_Nodes_NA_Resource_List_Item_gNB_CU_UE_F1AP_ID = INT(name='gNB-CU-UE-F1AP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _Child_IAB_Nodes_NA_Resource_List_Item_gNB_DU_UE_F1AP_ID = INT(name='gNB-DU-UE-F1AP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _Child_IAB_Nodes_NA_Resource_List_Item_nA_Resource_Configuration_List = SEQ_OF(name='nA-Resource-Configuration-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NA-Resource-Configuration-List')), opt=True)
    _Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__id._const_tab = ____Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__id_tab
    ___Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__criticality._const_tab = ____Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__criticality_tab
    ___Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__extensionValue._const_tab = ____Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__extensionValue_tab
    ___Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__id),
        ('criticality', ___Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__extensionValue),
        ])
    __Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item_._ext = None
    _Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions._cont = __Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item_
    _Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Child_IAB_Nodes_NA_Resource_List_Item._cont = ASN1Dict([
        ('gNB-CU-UE-F1AP-ID', _Child_IAB_Nodes_NA_Resource_List_Item_gNB_CU_UE_F1AP_ID),
        ('gNB-DU-UE-F1AP-ID', _Child_IAB_Nodes_NA_Resource_List_Item_gNB_DU_UE_F1AP_ID),
        ('nA-Resource-Configuration-List', _Child_IAB_Nodes_NA_Resource_List_Item_nA_Resource_Configuration_List),
        ('iE-Extensions', _Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions),
        ])
    Child_IAB_Nodes_NA_Resource_List_Item._ext = None
    
    #-----< Child-IAB-Nodes-NA-Resource-List-Item-ExtIEs >-----#
    Child_IAB_Nodes_NA_Resource_List_Item_ExtIEs = CLASS(name='Child-IAB-Nodes-NA-Resource-List-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Child_IAB_Nodes_NA_Resource_List_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Child-Node-Cells-List >-----#
    Child_Node_Cells_List = SEQ_OF(name='Child-Node-Cells-List', mode=MODE_TYPE)
    _Child_Node_Cells_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Child-Node-Cells-List-Item')))
    Child_Node_Cells_List._cont = _Child_Node_Cells_List__item_
    Child_Node_Cells_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< Child-Node-Cells-List-Item >-----#
    Child_Node_Cells_List_Item = SEQ(name='Child-Node-Cells-List-Item', mode=MODE_TYPE)
    _Child_Node_Cells_List_Item_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Child_Node_Cells_List_Item_iAB_DU_Cell_Resource_Configuration_Mode_Info = CHOICE(name='iAB-DU-Cell-Resource-Configuration-Mode-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IAB-DU-Cell-Resource-Configuration-Mode-Info')), opt=True)
    _Child_Node_Cells_List_Item_iAB_STC_Info = SEQ(name='iAB-STC-Info', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IAB-STC-Info')), opt=True)
    _Child_Node_Cells_List_Item_rACH_Config_Common = OCT_STR(name='rACH-Config-Common', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RACH-Config-Common')), opt=True)
    _Child_Node_Cells_List_Item_rACH_Config_Common_IAB = OCT_STR(name='rACH-Config-Common-IAB', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RACH-Config-Common-IAB')), opt=True)
    _Child_Node_Cells_List_Item_cSI_RS_Configuration = OCT_STR(name='cSI-RS-Configuration', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Child_Node_Cells_List_Item_sR_Configuration = OCT_STR(name='sR-Configuration', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Child_Node_Cells_List_Item_pDCCH_ConfigSIB1 = OCT_STR(name='pDCCH-ConfigSIB1', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Child_Node_Cells_List_Item_sCS_Common = OCT_STR(name='sCS-Common', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Child_Node_Cells_List_Item_multiplexingInfo = SEQ(name='multiplexingInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MultiplexingInfo')), opt=True)
    _Child_Node_Cells_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Child_Node_Cells_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Child_Node_Cells_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Child_Node_Cells_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Child_Node_Cells_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Child_Node_Cells_List_Item_iE_Extensions__item__id._const_tab = ____Child_Node_Cells_List_Item_iE_Extensions__item__id_tab
    ___Child_Node_Cells_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___Child_Node_Cells_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Child_Node_Cells_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Child_Node_Cells_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Child_Node_Cells_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Child_Node_Cells_List_Item_iE_Extensions__item__criticality._const_tab = ____Child_Node_Cells_List_Item_iE_Extensions__item__criticality_tab
    ___Child_Node_Cells_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Child_Node_Cells_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Child_Node_Cells_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Child_Node_Cells_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Child_Node_Cells_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Child_Node_Cells_List_Item_iE_Extensions__item__extensionValue._const_tab = ____Child_Node_Cells_List_Item_iE_Extensions__item__extensionValue_tab
    ___Child_Node_Cells_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Child_Node_Cells_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Child_Node_Cells_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Child_Node_Cells_List_Item_iE_Extensions__item__id),
        ('criticality', ___Child_Node_Cells_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Child_Node_Cells_List_Item_iE_Extensions__item__extensionValue),
        ])
    __Child_Node_Cells_List_Item_iE_Extensions__item_._ext = None
    _Child_Node_Cells_List_Item_iE_Extensions._cont = __Child_Node_Cells_List_Item_iE_Extensions__item_
    _Child_Node_Cells_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Child_Node_Cells_List_Item._cont = ASN1Dict([
        ('nRCGI', _Child_Node_Cells_List_Item_nRCGI),
        ('iAB-DU-Cell-Resource-Configuration-Mode-Info', _Child_Node_Cells_List_Item_iAB_DU_Cell_Resource_Configuration_Mode_Info),
        ('iAB-STC-Info', _Child_Node_Cells_List_Item_iAB_STC_Info),
        ('rACH-Config-Common', _Child_Node_Cells_List_Item_rACH_Config_Common),
        ('rACH-Config-Common-IAB', _Child_Node_Cells_List_Item_rACH_Config_Common_IAB),
        ('cSI-RS-Configuration', _Child_Node_Cells_List_Item_cSI_RS_Configuration),
        ('sR-Configuration', _Child_Node_Cells_List_Item_sR_Configuration),
        ('pDCCH-ConfigSIB1', _Child_Node_Cells_List_Item_pDCCH_ConfigSIB1),
        ('sCS-Common', _Child_Node_Cells_List_Item_sCS_Common),
        ('multiplexingInfo', _Child_Node_Cells_List_Item_multiplexingInfo),
        ('iE-Extensions', _Child_Node_Cells_List_Item_iE_Extensions),
        ])
    Child_Node_Cells_List_Item._ext = None
    
    #-----< Child-Node-Cells-List-Item-ExtIEs >-----#
    Child_Node_Cells_List_Item_ExtIEs = CLASS(name='Child-Node-Cells-List-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Child_Node_Cells_List_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Child-Nodes-List >-----#
    Child_Nodes_List = SEQ_OF(name='Child-Nodes-List', mode=MODE_TYPE)
    _Child_Nodes_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Child-Nodes-List-Item')))
    Child_Nodes_List._cont = _Child_Nodes_List__item_
    Child_Nodes_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< Child-Nodes-List-Item >-----#
    Child_Nodes_List_Item = SEQ(name='Child-Nodes-List-Item', mode=MODE_TYPE)
    _Child_Nodes_List_Item_gNB_CU_UE_F1AP_ID = INT(name='gNB-CU-UE-F1AP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _Child_Nodes_List_Item_gNB_DU_UE_F1AP_ID = INT(name='gNB-DU-UE-F1AP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _Child_Nodes_List_Item_child_Node_Cells_List = SEQ_OF(name='child-Node-Cells-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Child-Node-Cells-List')), opt=True)
    _Child_Nodes_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Child_Nodes_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Child_Nodes_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Child_Nodes_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Child_Nodes_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Child_Nodes_List_Item_iE_Extensions__item__id._const_tab = ____Child_Nodes_List_Item_iE_Extensions__item__id_tab
    ___Child_Nodes_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___Child_Nodes_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Child_Nodes_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Child_Nodes_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Child_Nodes_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Child_Nodes_List_Item_iE_Extensions__item__criticality._const_tab = ____Child_Nodes_List_Item_iE_Extensions__item__criticality_tab
    ___Child_Nodes_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Child_Nodes_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Child_Nodes_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Child_Nodes_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Child_Nodes_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Child_Nodes_List_Item_iE_Extensions__item__extensionValue._const_tab = ____Child_Nodes_List_Item_iE_Extensions__item__extensionValue_tab
    ___Child_Nodes_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Child_Nodes_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Child_Nodes_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Child_Nodes_List_Item_iE_Extensions__item__id),
        ('criticality', ___Child_Nodes_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Child_Nodes_List_Item_iE_Extensions__item__extensionValue),
        ])
    __Child_Nodes_List_Item_iE_Extensions__item_._ext = None
    _Child_Nodes_List_Item_iE_Extensions._cont = __Child_Nodes_List_Item_iE_Extensions__item_
    _Child_Nodes_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Child_Nodes_List_Item._cont = ASN1Dict([
        ('gNB-CU-UE-F1AP-ID', _Child_Nodes_List_Item_gNB_CU_UE_F1AP_ID),
        ('gNB-DU-UE-F1AP-ID', _Child_Nodes_List_Item_gNB_DU_UE_F1AP_ID),
        ('child-Node-Cells-List', _Child_Nodes_List_Item_child_Node_Cells_List),
        ('iE-Extensions', _Child_Nodes_List_Item_iE_Extensions),
        ])
    Child_Nodes_List_Item._ext = None
    
    #-----< Child-Nodes-List-Item-ExtIEs >-----#
    Child_Nodes_List_Item_ExtIEs = CLASS(name='Child-Nodes-List-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Child_Nodes_List_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CHOtrigger-InterDU >-----#
    CHOtrigger_InterDU = ENUM(name='CHOtrigger-InterDU', mode=MODE_TYPE)
    CHOtrigger_InterDU._cont = ASN1Dict([('cho-initiation', 0), ('cho-replace', 1)])
    CHOtrigger_InterDU._ext = []
    
    #-----< CHOtrigger-IntraDU >-----#
    CHOtrigger_IntraDU = ENUM(name='CHOtrigger-IntraDU', mode=MODE_TYPE)
    CHOtrigger_IntraDU._cont = ASN1Dict([('cho-initiation', 0), ('cho-replace', 1), ('cho-cancel', 2)])
    CHOtrigger_IntraDU._ext = []
    
    #-----< CNSubgroupID >-----#
    CNSubgroupID = INT(name='CNSubgroupID', mode=MODE_TYPE)
    CNSubgroupID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=[], er=[])
    
    #-----< CNUEPagingIdentity >-----#
    CNUEPagingIdentity = CHOICE(name='CNUEPagingIdentity', mode=MODE_TYPE)
    _CNUEPagingIdentity_fiveG_S_TMSI = BIT_STR(name='fiveG-S-TMSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CNUEPagingIdentity_fiveG_S_TMSI._const_sz = ASN1Set(rv=[48], rr=[], ev=None, er=[])
    _CNUEPagingIdentity_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __CNUEPagingIdentity_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___CNUEPagingIdentity_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___CNUEPagingIdentity_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CNUEPagingIdentity_choice_extension_id._const_tab = ___CNUEPagingIdentity_choice_extension_id_tab
    __CNUEPagingIdentity_choice_extension_id._const_tab_at = None
    __CNUEPagingIdentity_choice_extension_id._const_tab_id = 'id'
    __CNUEPagingIdentity_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___CNUEPagingIdentity_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___CNUEPagingIdentity_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CNUEPagingIdentity_choice_extension_criticality._const_tab = ___CNUEPagingIdentity_choice_extension_criticality_tab
    __CNUEPagingIdentity_choice_extension_criticality._const_tab_at = ('..', 'id')
    __CNUEPagingIdentity_choice_extension_criticality._const_tab_id = 'criticality'
    __CNUEPagingIdentity_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___CNUEPagingIdentity_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___CNUEPagingIdentity_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CNUEPagingIdentity_choice_extension_value._const_tab = ___CNUEPagingIdentity_choice_extension_value_tab
    __CNUEPagingIdentity_choice_extension_value._const_tab_at = ('..', 'id')
    __CNUEPagingIdentity_choice_extension_value._const_tab_id = 'Value'
    _CNUEPagingIdentity_choice_extension._cont = ASN1Dict([
        ('id', __CNUEPagingIdentity_choice_extension_id),
        ('criticality', __CNUEPagingIdentity_choice_extension_criticality),
        ('value', __CNUEPagingIdentity_choice_extension_value),
        ])
    _CNUEPagingIdentity_choice_extension._ext = None
    CNUEPagingIdentity._cont = ASN1Dict([
        ('fiveG-S-TMSI', _CNUEPagingIdentity_fiveG_S_TMSI),
        ('choice-extension', _CNUEPagingIdentity_choice_extension),
        ])
    CNUEPagingIdentity._ext = None
    
    #-----< CNUEPagingIdentity-ExtIEs >-----#
    CNUEPagingIdentity_ExtIEs = CLASS(name='CNUEPagingIdentity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    CNUEPagingIdentity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CompositeAvailableCapacityGroup >-----#
    CompositeAvailableCapacityGroup = SEQ(name='CompositeAvailableCapacityGroup', mode=MODE_TYPE)
    _CompositeAvailableCapacityGroup_compositeAvailableCapacityDownlink = SEQ(name='compositeAvailableCapacityDownlink', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CompositeAvailableCapacity')))
    _CompositeAvailableCapacityGroup_compositeAvailableCapacityUplink = SEQ(name='compositeAvailableCapacityUplink', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CompositeAvailableCapacity')))
    _CompositeAvailableCapacityGroup_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompositeAvailableCapacityGroup_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CompositeAvailableCapacity')))
    ____CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 442), ('criticality', 'ignore'), ('Extension', _____CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__id._const_tab = ____CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__id._const_tab_at = None
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__id._const_tab_id = 'id'
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__criticality._const_tab = ____CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue._const_tab = ____CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CompositeAvailableCapacityGroup_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CompositeAvailableCapacityGroup_iE_Extensions__item__id),
        ('criticality', ___CompositeAvailableCapacityGroup_iE_Extensions__item__criticality),
        ('extensionValue', ___CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue),
        ])
    __CompositeAvailableCapacityGroup_iE_Extensions__item_._ext = None
    _CompositeAvailableCapacityGroup_iE_Extensions._cont = __CompositeAvailableCapacityGroup_iE_Extensions__item_
    _CompositeAvailableCapacityGroup_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompositeAvailableCapacityGroup._cont = ASN1Dict([
        ('compositeAvailableCapacityDownlink', _CompositeAvailableCapacityGroup_compositeAvailableCapacityDownlink),
        ('compositeAvailableCapacityUplink', _CompositeAvailableCapacityGroup_compositeAvailableCapacityUplink),
        ('iE-Extensions', _CompositeAvailableCapacityGroup_iE_Extensions),
        ])
    CompositeAvailableCapacityGroup._ext = None
    
    #-----< CompositeAvailableCapacityGroup-ExtIEs >-----#
    CompositeAvailableCapacityGroup_ExtIEs = CLASS(name='CompositeAvailableCapacityGroup-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _CompositeAvailableCapacityGroup_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CompositeAvailableCapacity')))
    CompositeAvailableCapacityGroup_ExtIEs._val = ASN1Set(rv=[dict([('id', 442), ('criticality', 'ignore'), ('Extension', _CompositeAvailableCapacityGroup_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CompositeAvailableCapacity >-----#
    CompositeAvailableCapacity = SEQ(name='CompositeAvailableCapacity', mode=MODE_TYPE)
    _CompositeAvailableCapacity_cellCapacityClassValue = INT(name='cellCapacityClassValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CellCapacityClassValue')), opt=True)
    _CompositeAvailableCapacity_capacityValue = SEQ(name='capacityValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CapacityValue')))
    _CompositeAvailableCapacity_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompositeAvailableCapacity_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___CompositeAvailableCapacity_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CompositeAvailableCapacity_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CompositeAvailableCapacity_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompositeAvailableCapacity_iE_Extensions__item__id._const_tab = ____CompositeAvailableCapacity_iE_Extensions__item__id_tab
    ___CompositeAvailableCapacity_iE_Extensions__item__id._const_tab_at = None
    ___CompositeAvailableCapacity_iE_Extensions__item__id._const_tab_id = 'id'
    ___CompositeAvailableCapacity_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CompositeAvailableCapacity_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CompositeAvailableCapacity_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompositeAvailableCapacity_iE_Extensions__item__criticality._const_tab = ____CompositeAvailableCapacity_iE_Extensions__item__criticality_tab
    ___CompositeAvailableCapacity_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CompositeAvailableCapacity_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CompositeAvailableCapacity_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CompositeAvailableCapacity_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue._const_tab = ____CompositeAvailableCapacity_iE_Extensions__item__extensionValue_tab
    ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CompositeAvailableCapacity_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CompositeAvailableCapacity_iE_Extensions__item__id),
        ('criticality', ___CompositeAvailableCapacity_iE_Extensions__item__criticality),
        ('extensionValue', ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue),
        ])
    __CompositeAvailableCapacity_iE_Extensions__item_._ext = None
    _CompositeAvailableCapacity_iE_Extensions._cont = __CompositeAvailableCapacity_iE_Extensions__item_
    _CompositeAvailableCapacity_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompositeAvailableCapacity._cont = ASN1Dict([
        ('cellCapacityClassValue', _CompositeAvailableCapacity_cellCapacityClassValue),
        ('capacityValue', _CompositeAvailableCapacity_capacityValue),
        ('iE-Extensions', _CompositeAvailableCapacity_iE_Extensions),
        ])
    CompositeAvailableCapacity._ext = None
    
    #-----< CompositeAvailableCapacity-ExtIEs >-----#
    CompositeAvailableCapacity_ExtIEs = CLASS(name='CompositeAvailableCapacity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    CompositeAvailableCapacity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CHO-Probability >-----#
    CHO_Probability = INT(name='CHO-Probability', mode=MODE_TYPE)
    CHO_Probability._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    
    #-----< ConditionalInterDUMobilityInformation >-----#
    ConditionalInterDUMobilityInformation = SEQ(name='ConditionalInterDUMobilityInformation', mode=MODE_TYPE)
    _ConditionalInterDUMobilityInformation_cho_trigger = ENUM(name='cho-trigger', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CHOtrigger-InterDU')))
    _ConditionalInterDUMobilityInformation_targetgNB_DUUEF1APID = INT(name='targetgNB-DUUEF1APID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')), opt=True)
    _ConditionalInterDUMobilityInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ConditionalInterDUMobilityInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ConditionalInterDUMobilityInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ConditionalInterDUMobilityInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____ConditionalInterDUMobilityInformation_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CHO-Probability')))
    ____ConditionalInterDUMobilityInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 433), ('criticality', 'ignore'), ('Extension', _____ConditionalInterDUMobilityInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ConditionalInterDUMobilityInformation_iE_Extensions__item__id._const_tab = ____ConditionalInterDUMobilityInformation_iE_Extensions__item__id_tab
    ___ConditionalInterDUMobilityInformation_iE_Extensions__item__id._const_tab_at = None
    ___ConditionalInterDUMobilityInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___ConditionalInterDUMobilityInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ConditionalInterDUMobilityInformation_iE_Extensions__item__criticality._const_tab = ____ConditionalInterDUMobilityInformation_iE_Extensions__item__id_tab
    ___ConditionalInterDUMobilityInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ConditionalInterDUMobilityInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ConditionalInterDUMobilityInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ConditionalInterDUMobilityInformation_iE_Extensions__item__extensionValue._const_tab = ____ConditionalInterDUMobilityInformation_iE_Extensions__item__id_tab
    ___ConditionalInterDUMobilityInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ConditionalInterDUMobilityInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ConditionalInterDUMobilityInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ConditionalInterDUMobilityInformation_iE_Extensions__item__id),
        ('criticality', ___ConditionalInterDUMobilityInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___ConditionalInterDUMobilityInformation_iE_Extensions__item__extensionValue),
        ])
    __ConditionalInterDUMobilityInformation_iE_Extensions__item_._ext = None
    _ConditionalInterDUMobilityInformation_iE_Extensions._cont = __ConditionalInterDUMobilityInformation_iE_Extensions__item_
    _ConditionalInterDUMobilityInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ConditionalInterDUMobilityInformation._cont = ASN1Dict([
        ('cho-trigger', _ConditionalInterDUMobilityInformation_cho_trigger),
        ('targetgNB-DUUEF1APID', _ConditionalInterDUMobilityInformation_targetgNB_DUUEF1APID),
        ('iE-Extensions', _ConditionalInterDUMobilityInformation_iE_Extensions),
        ])
    ConditionalInterDUMobilityInformation._ext = []
    
    #-----< ConditionalInterDUMobilityInformation-ExtIEs >-----#
    ConditionalInterDUMobilityInformation_ExtIEs = CLASS(name='ConditionalInterDUMobilityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _ConditionalInterDUMobilityInformation_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CHO-Probability')))
    ConditionalInterDUMobilityInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 433), ('criticality', 'ignore'), ('Extension', _ConditionalInterDUMobilityInformation_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ConditionalIntraDUMobilityInformation >-----#
    ConditionalIntraDUMobilityInformation = SEQ(name='ConditionalIntraDUMobilityInformation', mode=MODE_TYPE)
    _ConditionalIntraDUMobilityInformation_cho_trigger = ENUM(name='cho-trigger', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CHOtrigger-IntraDU')))
    _ConditionalIntraDUMobilityInformation_targetCellsTocancel = SEQ_OF(name='targetCellsTocancel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TargetCellList')), opt=True)
    _ConditionalIntraDUMobilityInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ConditionalIntraDUMobilityInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ConditionalIntraDUMobilityInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____ConditionalIntraDUMobilityInformation_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CHO-Probability')))
    ____ConditionalIntraDUMobilityInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 433), ('criticality', 'ignore'), ('Extension', _____ConditionalIntraDUMobilityInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__id._const_tab = ____ConditionalIntraDUMobilityInformation_iE_Extensions__item__id_tab
    ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__id._const_tab_at = None
    ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__criticality._const_tab = ____ConditionalIntraDUMobilityInformation_iE_Extensions__item__id_tab
    ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__extensionValue._const_tab = ____ConditionalIntraDUMobilityInformation_iE_Extensions__item__id_tab
    ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ConditionalIntraDUMobilityInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__id),
        ('criticality', ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__extensionValue),
        ])
    __ConditionalIntraDUMobilityInformation_iE_Extensions__item_._ext = None
    _ConditionalIntraDUMobilityInformation_iE_Extensions._cont = __ConditionalIntraDUMobilityInformation_iE_Extensions__item_
    _ConditionalIntraDUMobilityInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ConditionalIntraDUMobilityInformation._cont = ASN1Dict([
        ('cho-trigger', _ConditionalIntraDUMobilityInformation_cho_trigger),
        ('targetCellsTocancel', _ConditionalIntraDUMobilityInformation_targetCellsTocancel),
        ('iE-Extensions', _ConditionalIntraDUMobilityInformation_iE_Extensions),
        ])
    ConditionalIntraDUMobilityInformation._ext = []
    
    #-----< ConditionalIntraDUMobilityInformation-ExtIEs >-----#
    ConditionalIntraDUMobilityInformation_ExtIEs = CLASS(name='ConditionalIntraDUMobilityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _ConditionalIntraDUMobilityInformation_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CHO-Probability')))
    ConditionalIntraDUMobilityInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 433), ('criticality', 'ignore'), ('Extension', _ConditionalIntraDUMobilityInformation_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ConfigRestrictInfoDAPS >-----#
    ConfigRestrictInfoDAPS = OCT_STR(name='ConfigRestrictInfoDAPS', mode=MODE_TYPE)
    
    #-----< ConfiguredTACIndication >-----#
    ConfiguredTACIndication = ENUM(name='ConfiguredTACIndication', mode=MODE_TYPE)
    ConfiguredTACIndication._cont = ASN1Dict([('true', 0)])
    ConfiguredTACIndication._ext = []
    
    #-----< CoordinateID >-----#
    CoordinateID = INT(name='CoordinateID', mode=MODE_TYPE)
    CoordinateID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=[], er=[])
    
    #-----< Coverage-Modification-Notification >-----#
    Coverage_Modification_Notification = SEQ(name='Coverage-Modification-Notification', mode=MODE_TYPE)
    _Coverage_Modification_Notification_coverage_Modification_List = SEQ_OF(name='coverage-Modification-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Coverage-Modification-List')))
    _Coverage_Modification_Notification_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Coverage_Modification_Notification_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Coverage_Modification_Notification_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Coverage_Modification_Notification_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Coverage_Modification_Notification_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Coverage_Modification_Notification_iE_Extensions__item__id._const_tab = ____Coverage_Modification_Notification_iE_Extensions__item__id_tab
    ___Coverage_Modification_Notification_iE_Extensions__item__id._const_tab_at = None
    ___Coverage_Modification_Notification_iE_Extensions__item__id._const_tab_id = 'id'
    ___Coverage_Modification_Notification_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Coverage_Modification_Notification_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Coverage_Modification_Notification_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Coverage_Modification_Notification_iE_Extensions__item__criticality._const_tab = ____Coverage_Modification_Notification_iE_Extensions__item__criticality_tab
    ___Coverage_Modification_Notification_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Coverage_Modification_Notification_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Coverage_Modification_Notification_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Coverage_Modification_Notification_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Coverage_Modification_Notification_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Coverage_Modification_Notification_iE_Extensions__item__extensionValue._const_tab = ____Coverage_Modification_Notification_iE_Extensions__item__extensionValue_tab
    ___Coverage_Modification_Notification_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Coverage_Modification_Notification_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Coverage_Modification_Notification_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Coverage_Modification_Notification_iE_Extensions__item__id),
        ('criticality', ___Coverage_Modification_Notification_iE_Extensions__item__criticality),
        ('extensionValue', ___Coverage_Modification_Notification_iE_Extensions__item__extensionValue),
        ])
    __Coverage_Modification_Notification_iE_Extensions__item_._ext = None
    _Coverage_Modification_Notification_iE_Extensions._cont = __Coverage_Modification_Notification_iE_Extensions__item_
    _Coverage_Modification_Notification_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Coverage_Modification_Notification._cont = ASN1Dict([
        ('coverage-Modification-List', _Coverage_Modification_Notification_coverage_Modification_List),
        ('iE-Extensions', _Coverage_Modification_Notification_iE_Extensions),
        ])
    Coverage_Modification_Notification._ext = []
    
    #-----< Coverage-Modification-Notification-ExtIEs >-----#
    Coverage_Modification_Notification_ExtIEs = CLASS(name='Coverage-Modification-Notification-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Coverage_Modification_Notification_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Coverage-Modification-List >-----#
    Coverage_Modification_List = SEQ_OF(name='Coverage-Modification-List', mode=MODE_TYPE)
    _Coverage_Modification_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Coverage-Modification-Item')))
    Coverage_Modification_List._cont = _Coverage_Modification_List__item_
    Coverage_Modification_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< Coverage-Modification-Item >-----#
    Coverage_Modification_Item = SEQ(name='Coverage-Modification-Item', mode=MODE_TYPE)
    _Coverage_Modification_Item_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Coverage_Modification_Item_cellCoverageState = INT(name='cellCoverageState', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CellCoverageState')))
    _Coverage_Modification_Item_sSBCoverageModificationList = SEQ_OF(name='sSBCoverageModificationList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSBCoverageModification-List')), opt=True)
    _Coverage_Modification_Item_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Coverage_Modification_Item_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Coverage_Modification_Item_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Coverage_Modification_Item_iE_Extension__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Coverage_Modification_Item_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Coverage_Modification_Item_iE_Extension__item__id._const_tab = ____Coverage_Modification_Item_iE_Extension__item__id_tab
    ___Coverage_Modification_Item_iE_Extension__item__id._const_tab_at = None
    ___Coverage_Modification_Item_iE_Extension__item__id._const_tab_id = 'id'
    ___Coverage_Modification_Item_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Coverage_Modification_Item_iE_Extension__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Coverage_Modification_Item_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Coverage_Modification_Item_iE_Extension__item__criticality._const_tab = ____Coverage_Modification_Item_iE_Extension__item__criticality_tab
    ___Coverage_Modification_Item_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___Coverage_Modification_Item_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___Coverage_Modification_Item_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Coverage_Modification_Item_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Coverage_Modification_Item_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Coverage_Modification_Item_iE_Extension__item__extensionValue._const_tab = ____Coverage_Modification_Item_iE_Extension__item__extensionValue_tab
    ___Coverage_Modification_Item_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___Coverage_Modification_Item_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __Coverage_Modification_Item_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___Coverage_Modification_Item_iE_Extension__item__id),
        ('criticality', ___Coverage_Modification_Item_iE_Extension__item__criticality),
        ('extensionValue', ___Coverage_Modification_Item_iE_Extension__item__extensionValue),
        ])
    __Coverage_Modification_Item_iE_Extension__item_._ext = None
    _Coverage_Modification_Item_iE_Extension._cont = __Coverage_Modification_Item_iE_Extension__item_
    _Coverage_Modification_Item_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Coverage_Modification_Item._cont = ASN1Dict([
        ('nRCGI', _Coverage_Modification_Item_nRCGI),
        ('cellCoverageState', _Coverage_Modification_Item_cellCoverageState),
        ('sSBCoverageModificationList', _Coverage_Modification_Item_sSBCoverageModificationList),
        ('iE-Extension', _Coverage_Modification_Item_iE_Extension),
        ])
    Coverage_Modification_Item._ext = []
    
    #-----< Coverage-Modification-Item-ExtIEs >-----#
    Coverage_Modification_Item_ExtIEs = CLASS(name='Coverage-Modification-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Coverage_Modification_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellCoverageState >-----#
    CellCoverageState = INT(name='CellCoverageState', mode=MODE_TYPE)
    CellCoverageState._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=[], er=[])
    
    #-----< CCO-Assistance-Information >-----#
    CCO_Assistance_Information = SEQ(name='CCO-Assistance-Information', mode=MODE_TYPE)
    _CCO_Assistance_Information_cCO_issue_detection = ENUM(name='cCO-issue-detection', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CCO-issue-detection')), opt=True)
    _CCO_Assistance_Information_affectedCellsAndBeams_List = SEQ_OF(name='affectedCellsAndBeams-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AffectedCellsAndBeams-List')), opt=True)
    _CCO_Assistance_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CCO_Assistance_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___CCO_Assistance_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CCO_Assistance_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CCO_Assistance_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCO_Assistance_Information_iE_Extensions__item__id._const_tab = ____CCO_Assistance_Information_iE_Extensions__item__id_tab
    ___CCO_Assistance_Information_iE_Extensions__item__id._const_tab_at = None
    ___CCO_Assistance_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___CCO_Assistance_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CCO_Assistance_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CCO_Assistance_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCO_Assistance_Information_iE_Extensions__item__criticality._const_tab = ____CCO_Assistance_Information_iE_Extensions__item__criticality_tab
    ___CCO_Assistance_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CCO_Assistance_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CCO_Assistance_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CCO_Assistance_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CCO_Assistance_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCO_Assistance_Information_iE_Extensions__item__extensionValue._const_tab = ____CCO_Assistance_Information_iE_Extensions__item__extensionValue_tab
    ___CCO_Assistance_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CCO_Assistance_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CCO_Assistance_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CCO_Assistance_Information_iE_Extensions__item__id),
        ('criticality', ___CCO_Assistance_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___CCO_Assistance_Information_iE_Extensions__item__extensionValue),
        ])
    __CCO_Assistance_Information_iE_Extensions__item_._ext = None
    _CCO_Assistance_Information_iE_Extensions._cont = __CCO_Assistance_Information_iE_Extensions__item_
    _CCO_Assistance_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CCO_Assistance_Information._cont = ASN1Dict([
        ('cCO-issue-detection', _CCO_Assistance_Information_cCO_issue_detection),
        ('affectedCellsAndBeams-List', _CCO_Assistance_Information_affectedCellsAndBeams_List),
        ('iE-Extensions', _CCO_Assistance_Information_iE_Extensions),
        ])
    CCO_Assistance_Information._ext = []
    
    #-----< CCO-Assistance-Information-ExtIEs >-----#
    CCO_Assistance_Information_ExtIEs = CLASS(name='CCO-Assistance-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    CCO_Assistance_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CCO-issue-detection >-----#
    CCO_issue_detection = ENUM(name='CCO-issue-detection', mode=MODE_TYPE)
    CCO_issue_detection._cont = ASN1Dict([('coverage', 0), ('cell-edge-capacity', 1)])
    CCO_issue_detection._ext = []
    
    #-----< CP-TransportLayerAddress >-----#
    CP_TransportLayerAddress = CHOICE(name='CP-TransportLayerAddress', mode=MODE_TYPE)
    _CP_TransportLayerAddress_endpoint_IP_address = BIT_STR(name='endpoint-IP-address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _CP_TransportLayerAddress_endpoint_IP_address_and_port = SEQ(name='endpoint-IP-address-and-port', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Endpoint-IP-address-and-port')))
    _CP_TransportLayerAddress_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __CP_TransportLayerAddress_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___CP_TransportLayerAddress_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___CP_TransportLayerAddress_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CP_TransportLayerAddress_choice_extension_id._const_tab = ___CP_TransportLayerAddress_choice_extension_id_tab
    __CP_TransportLayerAddress_choice_extension_id._const_tab_at = None
    __CP_TransportLayerAddress_choice_extension_id._const_tab_id = 'id'
    __CP_TransportLayerAddress_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___CP_TransportLayerAddress_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___CP_TransportLayerAddress_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CP_TransportLayerAddress_choice_extension_criticality._const_tab = ___CP_TransportLayerAddress_choice_extension_criticality_tab
    __CP_TransportLayerAddress_choice_extension_criticality._const_tab_at = ('..', 'id')
    __CP_TransportLayerAddress_choice_extension_criticality._const_tab_id = 'criticality'
    __CP_TransportLayerAddress_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___CP_TransportLayerAddress_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___CP_TransportLayerAddress_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CP_TransportLayerAddress_choice_extension_value._const_tab = ___CP_TransportLayerAddress_choice_extension_value_tab
    __CP_TransportLayerAddress_choice_extension_value._const_tab_at = ('..', 'id')
    __CP_TransportLayerAddress_choice_extension_value._const_tab_id = 'Value'
    _CP_TransportLayerAddress_choice_extension._cont = ASN1Dict([
        ('id', __CP_TransportLayerAddress_choice_extension_id),
        ('criticality', __CP_TransportLayerAddress_choice_extension_criticality),
        ('value', __CP_TransportLayerAddress_choice_extension_value),
        ])
    _CP_TransportLayerAddress_choice_extension._ext = None
    CP_TransportLayerAddress._cont = ASN1Dict([
        ('endpoint-IP-address', _CP_TransportLayerAddress_endpoint_IP_address),
        ('endpoint-IP-address-and-port', _CP_TransportLayerAddress_endpoint_IP_address_and_port),
        ('choice-extension', _CP_TransportLayerAddress_choice_extension),
        ])
    CP_TransportLayerAddress._ext = None
    
    #-----< CP-TransportLayerAddress-ExtIEs >-----#
    CP_TransportLayerAddress_ExtIEs = CLASS(name='CP-TransportLayerAddress-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    CP_TransportLayerAddress_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CPACMCGInformation >-----#
    CPACMCGInformation = SEQ(name='CPACMCGInformation', mode=MODE_TYPE)
    _CPACMCGInformation_cpac_trigger = ENUM(name='cpac-trigger', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CPAC-trigger')))
    _CPACMCGInformation_pscellid = SEQ(name='pscellid', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _CPACMCGInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CPACMCGInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___CPACMCGInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CPACMCGInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CPACMCGInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPACMCGInformation_iE_Extensions__item__id._const_tab = ____CPACMCGInformation_iE_Extensions__item__id_tab
    ___CPACMCGInformation_iE_Extensions__item__id._const_tab_at = None
    ___CPACMCGInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___CPACMCGInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CPACMCGInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CPACMCGInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPACMCGInformation_iE_Extensions__item__criticality._const_tab = ____CPACMCGInformation_iE_Extensions__item__criticality_tab
    ___CPACMCGInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CPACMCGInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CPACMCGInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CPACMCGInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CPACMCGInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPACMCGInformation_iE_Extensions__item__extensionValue._const_tab = ____CPACMCGInformation_iE_Extensions__item__extensionValue_tab
    ___CPACMCGInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CPACMCGInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CPACMCGInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CPACMCGInformation_iE_Extensions__item__id),
        ('criticality', ___CPACMCGInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___CPACMCGInformation_iE_Extensions__item__extensionValue),
        ])
    __CPACMCGInformation_iE_Extensions__item_._ext = None
    _CPACMCGInformation_iE_Extensions._cont = __CPACMCGInformation_iE_Extensions__item_
    _CPACMCGInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CPACMCGInformation._cont = ASN1Dict([
        ('cpac-trigger', _CPACMCGInformation_cpac_trigger),
        ('pscellid', _CPACMCGInformation_pscellid),
        ('iE-Extensions', _CPACMCGInformation_iE_Extensions),
        ])
    CPACMCGInformation._ext = []
    
    #-----< CPACMCGInformation-ExtIEs >-----#
    CPACMCGInformation_ExtIEs = CLASS(name='CPACMCGInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    CPACMCGInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CPAC-trigger >-----#
    CPAC_trigger = ENUM(name='CPAC-trigger', mode=MODE_TYPE)
    CPAC_trigger._cont = ASN1Dict([('cpac-preparation', 0), ('cpac-executed', 1)])
    CPAC_trigger._ext = []
    
    #-----< CPTrafficType >-----#
    CPTrafficType = INT(name='CPTrafficType', mode=MODE_TYPE)
    CPTrafficType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=[], er=[])
    
    #-----< CriticalityDiagnostics >-----#
    CriticalityDiagnostics = SEQ(name='CriticalityDiagnostics', mode=MODE_TYPE)
    _CriticalityDiagnostics_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')), opt=True)
    _CriticalityDiagnostics_triggeringMessage = ENUM(name='triggeringMessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-CommonDataTypes', 'TriggeringMessage')), opt=True)
    _CriticalityDiagnostics_procedureCriticality = ENUM(name='procedureCriticality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-CommonDataTypes', 'Criticality')), opt=True)
    _CriticalityDiagnostics_transactionID = INT(name='transactionID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')), opt=True)
    _CriticalityDiagnostics_iEsCriticalityDiagnostics = SEQ_OF(name='iEsCriticalityDiagnostics', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics-IE-List')), opt=True)
    _CriticalityDiagnostics_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_id = 'id'
    ___CriticalityDiagnostics_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CriticalityDiagnostics_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CriticalityDiagnostics_iE_Extensions__item__id),
        ('criticality', ___CriticalityDiagnostics_iE_Extensions__item__criticality),
        ('extensionValue', ___CriticalityDiagnostics_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_iE_Extensions._cont = __CriticalityDiagnostics_iE_Extensions__item_
    _CriticalityDiagnostics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics._cont = ASN1Dict([
        ('procedureCode', _CriticalityDiagnostics_procedureCode),
        ('triggeringMessage', _CriticalityDiagnostics_triggeringMessage),
        ('procedureCriticality', _CriticalityDiagnostics_procedureCriticality),
        ('transactionID', _CriticalityDiagnostics_transactionID),
        ('iEsCriticalityDiagnostics', _CriticalityDiagnostics_iEsCriticalityDiagnostics),
        ('iE-Extensions', _CriticalityDiagnostics_iE_Extensions),
        ])
    CriticalityDiagnostics._ext = []
    
    #-----< CriticalityDiagnostics-ExtIEs >-----#
    CriticalityDiagnostics_ExtIEs = CLASS(name='CriticalityDiagnostics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CriticalityDiagnostics-IE-List >-----#
    CriticalityDiagnostics_IE_List = SEQ_OF(name='CriticalityDiagnostics-IE-List', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics-IE-Item')))
    CriticalityDiagnostics_IE_List._cont = _CriticalityDiagnostics_IE_List__item_
    CriticalityDiagnostics_IE_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CriticalityDiagnostics-IE-Item >-----#
    CriticalityDiagnostics_IE_Item = SEQ(name='CriticalityDiagnostics-IE-Item', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_Item_iECriticality = ENUM(name='iECriticality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-CommonDataTypes', 'Criticality')))
    _CriticalityDiagnostics_IE_Item_iE_ID = INT(name='iE-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProtocolIE-ID')))
    _CriticalityDiagnostics_IE_Item_typeOfError = ENUM(name='typeOfError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TypeOfError')))
    _CriticalityDiagnostics_IE_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_IE_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CriticalityDiagnostics_IE_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id),
        ('criticality', ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_IE_Item_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_IE_Item_iE_Extensions._cont = __CriticalityDiagnostics_IE_Item_iE_Extensions__item_
    _CriticalityDiagnostics_IE_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics_IE_Item._cont = ASN1Dict([
        ('iECriticality', _CriticalityDiagnostics_IE_Item_iECriticality),
        ('iE-ID', _CriticalityDiagnostics_IE_Item_iE_ID),
        ('typeOfError', _CriticalityDiagnostics_IE_Item_typeOfError),
        ('iE-Extensions', _CriticalityDiagnostics_IE_Item_iE_Extensions),
        ])
    CriticalityDiagnostics_IE_Item._ext = []
    
    #-----< CriticalityDiagnostics-IE-Item-ExtIEs >-----#
    CriticalityDiagnostics_IE_Item_ExtIEs = CLASS(name='CriticalityDiagnostics-IE-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_IE_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< C-RNTI >-----#
    C_RNTI = INT(name='C-RNTI', mode=MODE_TYPE)
    C_RNTI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=[], er=[])
    
    #-----< CUDURadioInformationType >-----#
    CUDURadioInformationType = CHOICE(name='CUDURadioInformationType', mode=MODE_TYPE)
    _CUDURadioInformationType_rIM = SEQ(name='rIM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CUDURIMInformation')))
    _CUDURadioInformationType_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __CUDURadioInformationType_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___CUDURadioInformationType_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___CUDURadioInformationType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CUDURadioInformationType_choice_extension_id._const_tab = ___CUDURadioInformationType_choice_extension_id_tab
    __CUDURadioInformationType_choice_extension_id._const_tab_at = None
    __CUDURadioInformationType_choice_extension_id._const_tab_id = 'id'
    __CUDURadioInformationType_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___CUDURadioInformationType_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___CUDURadioInformationType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CUDURadioInformationType_choice_extension_criticality._const_tab = ___CUDURadioInformationType_choice_extension_criticality_tab
    __CUDURadioInformationType_choice_extension_criticality._const_tab_at = ('..', 'id')
    __CUDURadioInformationType_choice_extension_criticality._const_tab_id = 'criticality'
    __CUDURadioInformationType_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___CUDURadioInformationType_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___CUDURadioInformationType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CUDURadioInformationType_choice_extension_value._const_tab = ___CUDURadioInformationType_choice_extension_value_tab
    __CUDURadioInformationType_choice_extension_value._const_tab_at = ('..', 'id')
    __CUDURadioInformationType_choice_extension_value._const_tab_id = 'Value'
    _CUDURadioInformationType_choice_extension._cont = ASN1Dict([
        ('id', __CUDURadioInformationType_choice_extension_id),
        ('criticality', __CUDURadioInformationType_choice_extension_criticality),
        ('value', __CUDURadioInformationType_choice_extension_value),
        ])
    _CUDURadioInformationType_choice_extension._ext = None
    CUDURadioInformationType._cont = ASN1Dict([
        ('rIM', _CUDURadioInformationType_rIM),
        ('choice-extension', _CUDURadioInformationType_choice_extension),
        ])
    CUDURadioInformationType._ext = None
    
    #-----< CUDURadioInformationType-ExtIEs >-----#
    CUDURadioInformationType_ExtIEs = CLASS(name='CUDURadioInformationType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    CUDURadioInformationType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CUDURIMInformation >-----#
    CUDURIMInformation = SEQ(name='CUDURIMInformation', mode=MODE_TYPE)
    _CUDURIMInformation_victimgNBSetID = BIT_STR(name='victimgNBSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNBSetID')))
    _CUDURIMInformation_rIMRSDetectionStatus = ENUM(name='rIMRSDetectionStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RIMRSDetectionStatus')))
    _CUDURIMInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CUDURIMInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___CUDURIMInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CUDURIMInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CUDURIMInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CUDURIMInformation_iE_Extensions__item__id._const_tab = ____CUDURIMInformation_iE_Extensions__item__id_tab
    ___CUDURIMInformation_iE_Extensions__item__id._const_tab_at = None
    ___CUDURIMInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___CUDURIMInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CUDURIMInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CUDURIMInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CUDURIMInformation_iE_Extensions__item__criticality._const_tab = ____CUDURIMInformation_iE_Extensions__item__criticality_tab
    ___CUDURIMInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CUDURIMInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CUDURIMInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CUDURIMInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____CUDURIMInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CUDURIMInformation_iE_Extensions__item__extensionValue._const_tab = ____CUDURIMInformation_iE_Extensions__item__extensionValue_tab
    ___CUDURIMInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CUDURIMInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CUDURIMInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CUDURIMInformation_iE_Extensions__item__id),
        ('criticality', ___CUDURIMInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___CUDURIMInformation_iE_Extensions__item__extensionValue),
        ])
    __CUDURIMInformation_iE_Extensions__item_._ext = None
    _CUDURIMInformation_iE_Extensions._cont = __CUDURIMInformation_iE_Extensions__item_
    _CUDURIMInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CUDURIMInformation._cont = ASN1Dict([
        ('victimgNBSetID', _CUDURIMInformation_victimgNBSetID),
        ('rIMRSDetectionStatus', _CUDURIMInformation_rIMRSDetectionStatus),
        ('iE-Extensions', _CUDURIMInformation_iE_Extensions),
        ])
    CUDURIMInformation._ext = None
    
    #-----< CUDURIMInformation-ExtIEs >-----#
    CUDURIMInformation_ExtIEs = CLASS(name='CUDURIMInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    CUDURIMInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CUtoDURRCInformation >-----#
    CUtoDURRCInformation = SEQ(name='CUtoDURRCInformation', mode=MODE_TYPE)
    _CUtoDURRCInformation_cG_ConfigInfo = OCT_STR(name='cG-ConfigInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CG-ConfigInfo')), opt=True)
    _CUtoDURRCInformation_uE_CapabilityRAT_ContainerList = OCT_STR(name='uE-CapabilityRAT-ContainerList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UE-CapabilityRAT-ContainerList')), opt=True)
    _CUtoDURRCInformation_measConfig = OCT_STR(name='measConfig', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MeasConfig')), opt=True)
    _CUtoDURRCInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CUtoDURRCInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___CUtoDURRCInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CUtoDURRCInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'HandoverPreparationInformation')))
    _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellGroupConfig')))
    _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementTimingConfiguration')))
    _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_3 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UEAssistanceInformation')))
    _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_4 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CG-Config')))
    _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_5 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UEAssistanceInformationEUTRA')))
    _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_6 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LocationMeasurementInformation')))
    _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_7 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MUSIM-GapConfig')))
    _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_8 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SDT-MAC-PHY-CG-Config')))
    _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_9 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBSInterestIndication')))
    _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_10 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NeedForGapsInfoNR')))
    _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_11 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NeedForGapNCSGInfoNR')))
    _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_12 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NeedForGapNCSGInfoEUTRA')))
    _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_13 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ConfigRestrictInfoDAPS')))
    ____CUtoDURRCInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 119), ('criticality', 'ignore'), ('Extension', _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 173), ('criticality', 'ignore'), ('Extension', _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 163), ('criticality', 'ignore'), ('Extension', _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 214), ('criticality', 'ignore'), ('Extension', _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 234), ('criticality', 'ignore'), ('Extension', _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 339), ('criticality', 'ignore'), ('Extension', _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 440), ('criticality', 'ignore'), ('Extension', _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 621), ('criticality', 'reject'), ('Extension', _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 587), ('criticality', 'ignore'), ('Extension', _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 652), ('criticality', 'ignore'), ('Extension', _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 665), ('criticality', 'ignore'), ('Extension', _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 666), ('criticality', 'ignore'), ('Extension', _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_11), ('presence', 'optional')]), dict([('id', 667), ('criticality', 'ignore'), ('Extension', _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_12), ('presence', 'optional')]), dict([('id', 678), ('criticality', 'ignore'), ('Extension', _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_13), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CUtoDURRCInformation_iE_Extensions__item__id._const_tab = ____CUtoDURRCInformation_iE_Extensions__item__id_tab
    ___CUtoDURRCInformation_iE_Extensions__item__id._const_tab_at = None
    ___CUtoDURRCInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___CUtoDURRCInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CUtoDURRCInformation_iE_Extensions__item__criticality._const_tab = ____CUtoDURRCInformation_iE_Extensions__item__id_tab
    ___CUtoDURRCInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CUtoDURRCInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CUtoDURRCInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CUtoDURRCInformation_iE_Extensions__item__extensionValue._const_tab = ____CUtoDURRCInformation_iE_Extensions__item__id_tab
    ___CUtoDURRCInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CUtoDURRCInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CUtoDURRCInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CUtoDURRCInformation_iE_Extensions__item__id),
        ('criticality', ___CUtoDURRCInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___CUtoDURRCInformation_iE_Extensions__item__extensionValue),
        ])
    __CUtoDURRCInformation_iE_Extensions__item_._ext = None
    _CUtoDURRCInformation_iE_Extensions._cont = __CUtoDURRCInformation_iE_Extensions__item_
    _CUtoDURRCInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CUtoDURRCInformation._cont = ASN1Dict([
        ('cG-ConfigInfo', _CUtoDURRCInformation_cG_ConfigInfo),
        ('uE-CapabilityRAT-ContainerList', _CUtoDURRCInformation_uE_CapabilityRAT_ContainerList),
        ('measConfig', _CUtoDURRCInformation_measConfig),
        ('iE-Extensions', _CUtoDURRCInformation_iE_Extensions),
        ])
    CUtoDURRCInformation._ext = []
    
    #-----< CUtoDURRCInformation-ExtIEs >-----#
    CUtoDURRCInformation_ExtIEs = CLASS(name='CUtoDURRCInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _CUtoDURRCInformation_ExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'HandoverPreparationInformation')))
    _CUtoDURRCInformation_ExtIEs_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellGroupConfig')))
    _CUtoDURRCInformation_ExtIEs_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementTimingConfiguration')))
    _CUtoDURRCInformation_ExtIEs_val_Extension_3 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UEAssistanceInformation')))
    _CUtoDURRCInformation_ExtIEs_val_Extension_4 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CG-Config')))
    _CUtoDURRCInformation_ExtIEs_val_Extension_5 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UEAssistanceInformationEUTRA')))
    _CUtoDURRCInformation_ExtIEs_val_Extension_6 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LocationMeasurementInformation')))
    _CUtoDURRCInformation_ExtIEs_val_Extension_7 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MUSIM-GapConfig')))
    _CUtoDURRCInformation_ExtIEs_val_Extension_8 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SDT-MAC-PHY-CG-Config')))
    _CUtoDURRCInformation_ExtIEs_val_Extension_9 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBSInterestIndication')))
    _CUtoDURRCInformation_ExtIEs_val_Extension_10 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NeedForGapsInfoNR')))
    _CUtoDURRCInformation_ExtIEs_val_Extension_11 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NeedForGapNCSGInfoNR')))
    _CUtoDURRCInformation_ExtIEs_val_Extension_12 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NeedForGapNCSGInfoEUTRA')))
    _CUtoDURRCInformation_ExtIEs_val_Extension_13 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ConfigRestrictInfoDAPS')))
    CUtoDURRCInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 119), ('criticality', 'ignore'), ('Extension', _CUtoDURRCInformation_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 173), ('criticality', 'ignore'), ('Extension', _CUtoDURRCInformation_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 163), ('criticality', 'ignore'), ('Extension', _CUtoDURRCInformation_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 214), ('criticality', 'ignore'), ('Extension', _CUtoDURRCInformation_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 234), ('criticality', 'ignore'), ('Extension', _CUtoDURRCInformation_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 339), ('criticality', 'ignore'), ('Extension', _CUtoDURRCInformation_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 440), ('criticality', 'ignore'), ('Extension', _CUtoDURRCInformation_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 621), ('criticality', 'reject'), ('Extension', _CUtoDURRCInformation_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 587), ('criticality', 'ignore'), ('Extension', _CUtoDURRCInformation_ExtIEs_val_Extension_8), ('presence', 'optional')]), dict([('id', 652), ('criticality', 'ignore'), ('Extension', _CUtoDURRCInformation_ExtIEs_val_Extension_9), ('presence', 'optional')]), dict([('id', 665), ('criticality', 'ignore'), ('Extension', _CUtoDURRCInformation_ExtIEs_val_Extension_10), ('presence', 'optional')]), dict([('id', 666), ('criticality', 'ignore'), ('Extension', _CUtoDURRCInformation_ExtIEs_val_Extension_11), ('presence', 'optional')]), dict([('id', 667), ('criticality', 'ignore'), ('Extension', _CUtoDURRCInformation_ExtIEs_val_Extension_12), ('presence', 'optional')]), dict([('id', 678), ('criticality', 'ignore'), ('Extension', _CUtoDURRCInformation_ExtIEs_val_Extension_13), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DAPS-HO-Status >-----#
    DAPS_HO_Status = ENUM(name='DAPS-HO-Status', mode=MODE_TYPE)
    DAPS_HO_Status._cont = ASN1Dict([('initiation', 0)])
    DAPS_HO_Status._ext = []
    
    #-----< DCBasedDuplicationConfigured >-----#
    DCBasedDuplicationConfigured = ENUM(name='DCBasedDuplicationConfigured', mode=MODE_TYPE)
    DCBasedDuplicationConfigured._cont = ASN1Dict([('true', 0), ('false', 1)])
    DCBasedDuplicationConfigured._ext = ['false']
    
    #-----< Dedicated-SIDelivery-NeededUE-Item >-----#
    Dedicated_SIDelivery_NeededUE_Item = SEQ(name='Dedicated-SIDelivery-NeededUE-Item', mode=MODE_TYPE)
    _Dedicated_SIDelivery_NeededUE_Item_gNB_CU_UE_F1AP_ID = INT(name='gNB-CU-UE-F1AP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _Dedicated_SIDelivery_NeededUE_Item_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Dedicated_SIDelivery_NeededUE_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__id._const_tab = ____Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__id_tab
    ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__id._const_tab_at = None
    ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__criticality._const_tab = ____Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__criticality_tab
    ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__extensionValue._const_tab = ____Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__extensionValue_tab
    ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__id),
        ('criticality', ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__extensionValue),
        ])
    __Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item_._ext = None
    _Dedicated_SIDelivery_NeededUE_Item_iE_Extensions._cont = __Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item_
    _Dedicated_SIDelivery_NeededUE_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Dedicated_SIDelivery_NeededUE_Item._cont = ASN1Dict([
        ('gNB-CU-UE-F1AP-ID', _Dedicated_SIDelivery_NeededUE_Item_gNB_CU_UE_F1AP_ID),
        ('nRCGI', _Dedicated_SIDelivery_NeededUE_Item_nRCGI),
        ('iE-Extensions', _Dedicated_SIDelivery_NeededUE_Item_iE_Extensions),
        ])
    Dedicated_SIDelivery_NeededUE_Item._ext = []
    
    #-----< DedicatedSIDeliveryNeededUE-Item-ExtIEs >-----#
    DedicatedSIDeliveryNeededUE_Item_ExtIEs = CLASS(name='DedicatedSIDeliveryNeededUE-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DedicatedSIDeliveryNeededUE_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-PRS >-----#
    DL_PRS = SEQ(name='DL-PRS', mode=MODE_TYPE)
    _DL_PRS_prsid = INT(name='prsid', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRS_prsid._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _DL_PRS_dl_PRSResourceSetID = INT(name='dl-PRSResourceSetID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-Set-ID')))
    _DL_PRS_dl_PRSResourceID = INT(name='dl-PRSResourceID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-ID')), opt=True)
    _DL_PRS_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_PRS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DL_PRS_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_PRS_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DL_PRS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_PRS_iE_Extensions__item__id._const_tab = ____DL_PRS_iE_Extensions__item__id_tab
    ___DL_PRS_iE_Extensions__item__id._const_tab_at = None
    ___DL_PRS_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_PRS_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_PRS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DL_PRS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_PRS_iE_Extensions__item__criticality._const_tab = ____DL_PRS_iE_Extensions__item__criticality_tab
    ___DL_PRS_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_PRS_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_PRS_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_PRS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DL_PRS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_PRS_iE_Extensions__item__extensionValue._const_tab = ____DL_PRS_iE_Extensions__item__extensionValue_tab
    ___DL_PRS_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_PRS_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_PRS_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_PRS_iE_Extensions__item__id),
        ('criticality', ___DL_PRS_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_PRS_iE_Extensions__item__extensionValue),
        ])
    __DL_PRS_iE_Extensions__item_._ext = None
    _DL_PRS_iE_Extensions._cont = __DL_PRS_iE_Extensions__item_
    _DL_PRS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_PRS._cont = ASN1Dict([
        ('prsid', _DL_PRS_prsid),
        ('dl-PRSResourceSetID', _DL_PRS_dl_PRSResourceSetID),
        ('dl-PRSResourceID', _DL_PRS_dl_PRSResourceID),
        ('iE-Extensions', _DL_PRS_iE_Extensions),
        ])
    DL_PRS._ext = None
    
    #-----< DL-PRS-ExtIEs >-----#
    DL_PRS_ExtIEs = CLASS(name='DL-PRS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DL_PRS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-PRSMutingPattern >-----#
    DL_PRSMutingPattern = CHOICE(name='DL-PRSMutingPattern', mode=MODE_TYPE)
    _DL_PRSMutingPattern_two = BIT_STR(name='two', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRSMutingPattern_two._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _DL_PRSMutingPattern_four = BIT_STR(name='four', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRSMutingPattern_four._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _DL_PRSMutingPattern_six = BIT_STR(name='six', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRSMutingPattern_six._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    _DL_PRSMutingPattern_eight = BIT_STR(name='eight', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRSMutingPattern_eight._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _DL_PRSMutingPattern_sixteen = BIT_STR(name='sixteen', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRSMutingPattern_sixteen._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _DL_PRSMutingPattern_thirty_two = BIT_STR(name='thirty-two', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRSMutingPattern_thirty_two._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _DL_PRSMutingPattern_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DL_PRSMutingPattern_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___DL_PRSMutingPattern_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DL_PRSMutingPattern_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSMutingPattern_choice_extension_id._const_tab = ___DL_PRSMutingPattern_choice_extension_id_tab
    __DL_PRSMutingPattern_choice_extension_id._const_tab_at = None
    __DL_PRSMutingPattern_choice_extension_id._const_tab_id = 'id'
    __DL_PRSMutingPattern_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___DL_PRSMutingPattern_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DL_PRSMutingPattern_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSMutingPattern_choice_extension_criticality._const_tab = ___DL_PRSMutingPattern_choice_extension_criticality_tab
    __DL_PRSMutingPattern_choice_extension_criticality._const_tab_at = ('..', 'id')
    __DL_PRSMutingPattern_choice_extension_criticality._const_tab_id = 'criticality'
    __DL_PRSMutingPattern_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___DL_PRSMutingPattern_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DL_PRSMutingPattern_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSMutingPattern_choice_extension_value._const_tab = ___DL_PRSMutingPattern_choice_extension_value_tab
    __DL_PRSMutingPattern_choice_extension_value._const_tab_at = ('..', 'id')
    __DL_PRSMutingPattern_choice_extension_value._const_tab_id = 'Value'
    _DL_PRSMutingPattern_choice_extension._cont = ASN1Dict([
        ('id', __DL_PRSMutingPattern_choice_extension_id),
        ('criticality', __DL_PRSMutingPattern_choice_extension_criticality),
        ('value', __DL_PRSMutingPattern_choice_extension_value),
        ])
    _DL_PRSMutingPattern_choice_extension._ext = None
    DL_PRSMutingPattern._cont = ASN1Dict([
        ('two', _DL_PRSMutingPattern_two),
        ('four', _DL_PRSMutingPattern_four),
        ('six', _DL_PRSMutingPattern_six),
        ('eight', _DL_PRSMutingPattern_eight),
        ('sixteen', _DL_PRSMutingPattern_sixteen),
        ('thirty-two', _DL_PRSMutingPattern_thirty_two),
        ('choice-extension', _DL_PRSMutingPattern_choice_extension),
        ])
    DL_PRSMutingPattern._ext = None
    
    #-----< DL-PRSMutingPattern-ExtIEs >-----#
    DL_PRSMutingPattern_ExtIEs = CLASS(name='DL-PRSMutingPattern-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    DL_PRSMutingPattern_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DLPRSResourceCoordinates >-----#
    DLPRSResourceCoordinates = SEQ(name='DLPRSResourceCoordinates', mode=MODE_TYPE)
    _DLPRSResourceCoordinates_listofDL_PRSResourceSetARP = SEQ_OF(name='listofDL-PRSResourceSetARP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DLPRSResourceCoordinates_listofDL_PRSResourceSetARP__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DLPRSResourceSetARP')))
    _DLPRSResourceCoordinates_listofDL_PRSResourceSetARP._cont = __DLPRSResourceCoordinates_listofDL_PRSResourceSetARP__item_
    _DLPRSResourceCoordinates_listofDL_PRSResourceSetARP._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _DLPRSResourceCoordinates_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DLPRSResourceCoordinates_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DLPRSResourceCoordinates_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DLPRSResourceCoordinates_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLPRSResourceCoordinates_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceCoordinates_iE_Extensions__item__id._const_tab = ____DLPRSResourceCoordinates_iE_Extensions__item__id_tab
    ___DLPRSResourceCoordinates_iE_Extensions__item__id._const_tab_at = None
    ___DLPRSResourceCoordinates_iE_Extensions__item__id._const_tab_id = 'id'
    ___DLPRSResourceCoordinates_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DLPRSResourceCoordinates_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLPRSResourceCoordinates_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceCoordinates_iE_Extensions__item__criticality._const_tab = ____DLPRSResourceCoordinates_iE_Extensions__item__criticality_tab
    ___DLPRSResourceCoordinates_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DLPRSResourceCoordinates_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DLPRSResourceCoordinates_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DLPRSResourceCoordinates_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLPRSResourceCoordinates_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceCoordinates_iE_Extensions__item__extensionValue._const_tab = ____DLPRSResourceCoordinates_iE_Extensions__item__extensionValue_tab
    ___DLPRSResourceCoordinates_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DLPRSResourceCoordinates_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DLPRSResourceCoordinates_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DLPRSResourceCoordinates_iE_Extensions__item__id),
        ('criticality', ___DLPRSResourceCoordinates_iE_Extensions__item__criticality),
        ('extensionValue', ___DLPRSResourceCoordinates_iE_Extensions__item__extensionValue),
        ])
    __DLPRSResourceCoordinates_iE_Extensions__item_._ext = None
    _DLPRSResourceCoordinates_iE_Extensions._cont = __DLPRSResourceCoordinates_iE_Extensions__item_
    _DLPRSResourceCoordinates_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DLPRSResourceCoordinates._cont = ASN1Dict([
        ('listofDL-PRSResourceSetARP', _DLPRSResourceCoordinates_listofDL_PRSResourceSetARP),
        ('iE-Extensions', _DLPRSResourceCoordinates_iE_Extensions),
        ])
    DLPRSResourceCoordinates._ext = None
    
    #-----< DLPRSResourceCoordinates-ExtIEs >-----#
    DLPRSResourceCoordinates_ExtIEs = CLASS(name='DLPRSResourceCoordinates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DLPRSResourceCoordinates_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DLPRSResourceSetARP >-----#
    DLPRSResourceSetARP = SEQ(name='DLPRSResourceSetARP', mode=MODE_TYPE)
    _DLPRSResourceSetARP_dl_PRSResourceSetID = INT(name='dl-PRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-Set-ID')))
    _DLPRSResourceSetARP_dL_PRSResourceSetARPLocation = CHOICE(name='dL-PRSResourceSetARPLocation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DL-PRSResourceSetARPLocation')))
    _DLPRSResourceSetARP_listofDL_PRSResourceARP = SEQ_OF(name='listofDL-PRSResourceARP', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DLPRSResourceSetARP_listofDL_PRSResourceARP__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DLPRSResourceARP')))
    _DLPRSResourceSetARP_listofDL_PRSResourceARP._cont = __DLPRSResourceSetARP_listofDL_PRSResourceARP__item_
    _DLPRSResourceSetARP_listofDL_PRSResourceARP._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _DLPRSResourceSetARP_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DLPRSResourceSetARP_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DLPRSResourceSetARP_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DLPRSResourceSetARP_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLPRSResourceSetARP_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceSetARP_iE_Extensions__item__id._const_tab = ____DLPRSResourceSetARP_iE_Extensions__item__id_tab
    ___DLPRSResourceSetARP_iE_Extensions__item__id._const_tab_at = None
    ___DLPRSResourceSetARP_iE_Extensions__item__id._const_tab_id = 'id'
    ___DLPRSResourceSetARP_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DLPRSResourceSetARP_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLPRSResourceSetARP_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceSetARP_iE_Extensions__item__criticality._const_tab = ____DLPRSResourceSetARP_iE_Extensions__item__criticality_tab
    ___DLPRSResourceSetARP_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DLPRSResourceSetARP_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DLPRSResourceSetARP_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DLPRSResourceSetARP_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLPRSResourceSetARP_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceSetARP_iE_Extensions__item__extensionValue._const_tab = ____DLPRSResourceSetARP_iE_Extensions__item__extensionValue_tab
    ___DLPRSResourceSetARP_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DLPRSResourceSetARP_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DLPRSResourceSetARP_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DLPRSResourceSetARP_iE_Extensions__item__id),
        ('criticality', ___DLPRSResourceSetARP_iE_Extensions__item__criticality),
        ('extensionValue', ___DLPRSResourceSetARP_iE_Extensions__item__extensionValue),
        ])
    __DLPRSResourceSetARP_iE_Extensions__item_._ext = None
    _DLPRSResourceSetARP_iE_Extensions._cont = __DLPRSResourceSetARP_iE_Extensions__item_
    _DLPRSResourceSetARP_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DLPRSResourceSetARP._cont = ASN1Dict([
        ('dl-PRSResourceSetID', _DLPRSResourceSetARP_dl_PRSResourceSetID),
        ('dL-PRSResourceSetARPLocation', _DLPRSResourceSetARP_dL_PRSResourceSetARPLocation),
        ('listofDL-PRSResourceARP', _DLPRSResourceSetARP_listofDL_PRSResourceARP),
        ('iE-Extensions', _DLPRSResourceSetARP_iE_Extensions),
        ])
    DLPRSResourceSetARP._ext = None
    
    #-----< DLPRSResourceSetARP-ExtIEs >-----#
    DLPRSResourceSetARP_ExtIEs = CLASS(name='DLPRSResourceSetARP-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DLPRSResourceSetARP_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-PRSResourceSetARPLocation >-----#
    DL_PRSResourceSetARPLocation = CHOICE(name='DL-PRSResourceSetARPLocation', mode=MODE_TYPE)
    _DL_PRSResourceSetARPLocation_relativeGeodeticLocation = SEQ(name='relativeGeodeticLocation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RelativeGeodeticLocation')))
    _DL_PRSResourceSetARPLocation_relativeCartesianLocation = SEQ(name='relativeCartesianLocation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RelativeCartesianLocation')))
    _DL_PRSResourceSetARPLocation_choice_Extension = SEQ(name='choice-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DL_PRSResourceSetARPLocation_choice_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___DL_PRSResourceSetARPLocation_choice_Extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DL_PRSResourceSetARPLocation_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSResourceSetARPLocation_choice_Extension_id._const_tab = ___DL_PRSResourceSetARPLocation_choice_Extension_id_tab
    __DL_PRSResourceSetARPLocation_choice_Extension_id._const_tab_at = None
    __DL_PRSResourceSetARPLocation_choice_Extension_id._const_tab_id = 'id'
    __DL_PRSResourceSetARPLocation_choice_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___DL_PRSResourceSetARPLocation_choice_Extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DL_PRSResourceSetARPLocation_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSResourceSetARPLocation_choice_Extension_criticality._const_tab = ___DL_PRSResourceSetARPLocation_choice_Extension_criticality_tab
    __DL_PRSResourceSetARPLocation_choice_Extension_criticality._const_tab_at = ('..', 'id')
    __DL_PRSResourceSetARPLocation_choice_Extension_criticality._const_tab_id = 'criticality'
    __DL_PRSResourceSetARPLocation_choice_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___DL_PRSResourceSetARPLocation_choice_Extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DL_PRSResourceSetARPLocation_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSResourceSetARPLocation_choice_Extension_value._const_tab = ___DL_PRSResourceSetARPLocation_choice_Extension_value_tab
    __DL_PRSResourceSetARPLocation_choice_Extension_value._const_tab_at = ('..', 'id')
    __DL_PRSResourceSetARPLocation_choice_Extension_value._const_tab_id = 'Value'
    _DL_PRSResourceSetARPLocation_choice_Extension._cont = ASN1Dict([
        ('id', __DL_PRSResourceSetARPLocation_choice_Extension_id),
        ('criticality', __DL_PRSResourceSetARPLocation_choice_Extension_criticality),
        ('value', __DL_PRSResourceSetARPLocation_choice_Extension_value),
        ])
    _DL_PRSResourceSetARPLocation_choice_Extension._ext = None
    DL_PRSResourceSetARPLocation._cont = ASN1Dict([
        ('relativeGeodeticLocation', _DL_PRSResourceSetARPLocation_relativeGeodeticLocation),
        ('relativeCartesianLocation', _DL_PRSResourceSetARPLocation_relativeCartesianLocation),
        ('choice-Extension', _DL_PRSResourceSetARPLocation_choice_Extension),
        ])
    DL_PRSResourceSetARPLocation._ext = None
    
    #-----< DL-PRSResourceSetARPLocation-ExtIEs >-----#
    DL_PRSResourceSetARPLocation_ExtIEs = CLASS(name='DL-PRSResourceSetARPLocation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    DL_PRSResourceSetARPLocation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DLPRSResourceARP >-----#
    DLPRSResourceARP = SEQ(name='DLPRSResourceARP', mode=MODE_TYPE)
    _DLPRSResourceARP_dl_PRSResourceID = INT(name='dl-PRSResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-ID')))
    _DLPRSResourceARP_dL_PRSResourceARPLocation = CHOICE(name='dL-PRSResourceARPLocation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DL-PRSResourceARPLocation')))
    _DLPRSResourceARP_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DLPRSResourceARP_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DLPRSResourceARP_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DLPRSResourceARP_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLPRSResourceARP_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceARP_iE_Extensions__item__id._const_tab = ____DLPRSResourceARP_iE_Extensions__item__id_tab
    ___DLPRSResourceARP_iE_Extensions__item__id._const_tab_at = None
    ___DLPRSResourceARP_iE_Extensions__item__id._const_tab_id = 'id'
    ___DLPRSResourceARP_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DLPRSResourceARP_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLPRSResourceARP_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceARP_iE_Extensions__item__criticality._const_tab = ____DLPRSResourceARP_iE_Extensions__item__criticality_tab
    ___DLPRSResourceARP_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DLPRSResourceARP_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DLPRSResourceARP_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DLPRSResourceARP_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLPRSResourceARP_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceARP_iE_Extensions__item__extensionValue._const_tab = ____DLPRSResourceARP_iE_Extensions__item__extensionValue_tab
    ___DLPRSResourceARP_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DLPRSResourceARP_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DLPRSResourceARP_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DLPRSResourceARP_iE_Extensions__item__id),
        ('criticality', ___DLPRSResourceARP_iE_Extensions__item__criticality),
        ('extensionValue', ___DLPRSResourceARP_iE_Extensions__item__extensionValue),
        ])
    __DLPRSResourceARP_iE_Extensions__item_._ext = None
    _DLPRSResourceARP_iE_Extensions._cont = __DLPRSResourceARP_iE_Extensions__item_
    _DLPRSResourceARP_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DLPRSResourceARP._cont = ASN1Dict([
        ('dl-PRSResourceID', _DLPRSResourceARP_dl_PRSResourceID),
        ('dL-PRSResourceARPLocation', _DLPRSResourceARP_dL_PRSResourceARPLocation),
        ('iE-Extensions', _DLPRSResourceARP_iE_Extensions),
        ])
    DLPRSResourceARP._ext = None
    
    #-----< DLPRSResourceARP-ExtIEs >-----#
    DLPRSResourceARP_ExtIEs = CLASS(name='DLPRSResourceARP-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DLPRSResourceARP_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-PRSResourceARPLocation >-----#
    DL_PRSResourceARPLocation = CHOICE(name='DL-PRSResourceARPLocation', mode=MODE_TYPE)
    _DL_PRSResourceARPLocation_relativeGeodeticLocation = SEQ(name='relativeGeodeticLocation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RelativeGeodeticLocation')))
    _DL_PRSResourceARPLocation_relativeCartesianLocation = SEQ(name='relativeCartesianLocation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RelativeCartesianLocation')))
    _DL_PRSResourceARPLocation_choice_Extension = SEQ(name='choice-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DL_PRSResourceARPLocation_choice_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___DL_PRSResourceARPLocation_choice_Extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DL_PRSResourceARPLocation_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSResourceARPLocation_choice_Extension_id._const_tab = ___DL_PRSResourceARPLocation_choice_Extension_id_tab
    __DL_PRSResourceARPLocation_choice_Extension_id._const_tab_at = None
    __DL_PRSResourceARPLocation_choice_Extension_id._const_tab_id = 'id'
    __DL_PRSResourceARPLocation_choice_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___DL_PRSResourceARPLocation_choice_Extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DL_PRSResourceARPLocation_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSResourceARPLocation_choice_Extension_criticality._const_tab = ___DL_PRSResourceARPLocation_choice_Extension_criticality_tab
    __DL_PRSResourceARPLocation_choice_Extension_criticality._const_tab_at = ('..', 'id')
    __DL_PRSResourceARPLocation_choice_Extension_criticality._const_tab_id = 'criticality'
    __DL_PRSResourceARPLocation_choice_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___DL_PRSResourceARPLocation_choice_Extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DL_PRSResourceARPLocation_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSResourceARPLocation_choice_Extension_value._const_tab = ___DL_PRSResourceARPLocation_choice_Extension_value_tab
    __DL_PRSResourceARPLocation_choice_Extension_value._const_tab_at = ('..', 'id')
    __DL_PRSResourceARPLocation_choice_Extension_value._const_tab_id = 'Value'
    _DL_PRSResourceARPLocation_choice_Extension._cont = ASN1Dict([
        ('id', __DL_PRSResourceARPLocation_choice_Extension_id),
        ('criticality', __DL_PRSResourceARPLocation_choice_Extension_criticality),
        ('value', __DL_PRSResourceARPLocation_choice_Extension_value),
        ])
    _DL_PRSResourceARPLocation_choice_Extension._ext = None
    DL_PRSResourceARPLocation._cont = ASN1Dict([
        ('relativeGeodeticLocation', _DL_PRSResourceARPLocation_relativeGeodeticLocation),
        ('relativeCartesianLocation', _DL_PRSResourceARPLocation_relativeCartesianLocation),
        ('choice-Extension', _DL_PRSResourceARPLocation_choice_Extension),
        ])
    DL_PRSResourceARPLocation._ext = None
    
    #-----< DL-PRSResourceARPLocation-ExtIEs >-----#
    DL_PRSResourceARPLocation_ExtIEs = CLASS(name='DL-PRSResourceARPLocation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    DL_PRSResourceARPLocation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-UP-TNL-Address-to-Update-List-Item >-----#
    DL_UP_TNL_Address_to_Update_List_Item = SEQ(name='DL-UP-TNL-Address-to-Update-List-Item', mode=MODE_TYPE)
    _DL_UP_TNL_Address_to_Update_List_Item_oldIPAdress = BIT_STR(name='oldIPAdress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _DL_UP_TNL_Address_to_Update_List_Item_newIPAdress = BIT_STR(name='newIPAdress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id._const_tab = ____DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id_tab
    ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality._const_tab = ____DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality_tab
    ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue._const_tab = ____DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue_tab
    ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id),
        ('criticality', ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue),
        ])
    __DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item_._ext = None
    _DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions._cont = __DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item_
    _DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_UP_TNL_Address_to_Update_List_Item._cont = ASN1Dict([
        ('oldIPAdress', _DL_UP_TNL_Address_to_Update_List_Item_oldIPAdress),
        ('newIPAdress', _DL_UP_TNL_Address_to_Update_List_Item_newIPAdress),
        ('iE-Extensions', _DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions),
        ])
    DL_UP_TNL_Address_to_Update_List_Item._ext = []
    
    #-----< DL-UP-TNL-Address-to-Update-List-ItemExtIEs >-----#
    DL_UP_TNL_Address_to_Update_List_ItemExtIEs = CLASS(name='DL-UP-TNL-Address-to-Update-List-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DL_UP_TNL_Address_to_Update_List_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DLUPTNLInformation-ToBeSetup-List >-----#
    DLUPTNLInformation_ToBeSetup_List = SEQ_OF(name='DLUPTNLInformation-ToBeSetup-List', mode=MODE_TYPE)
    _DLUPTNLInformation_ToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DLUPTNLInformation-ToBeSetup-Item')))
    DLUPTNLInformation_ToBeSetup_List._cont = _DLUPTNLInformation_ToBeSetup_List__item_
    DLUPTNLInformation_ToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< DLUPTNLInformation-ToBeSetup-Item >-----#
    DLUPTNLInformation_ToBeSetup_Item = SEQ(name='DLUPTNLInformation-ToBeSetup-Item', mode=MODE_TYPE)
    _DLUPTNLInformation_ToBeSetup_Item_dLUPTNLInformation = CHOICE(name='dLUPTNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UPTransportLayerInformation')))
    _DLUPTNLInformation_ToBeSetup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id._const_tab = ____DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality_tab
    ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab
    ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id),
        ('criticality', ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item_._ext = None
    _DLUPTNLInformation_ToBeSetup_Item_iE_Extensions._cont = __DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item_
    _DLUPTNLInformation_ToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DLUPTNLInformation_ToBeSetup_Item._cont = ASN1Dict([
        ('dLUPTNLInformation', _DLUPTNLInformation_ToBeSetup_Item_dLUPTNLInformation),
        ('iE-Extensions', _DLUPTNLInformation_ToBeSetup_Item_iE_Extensions),
        ])
    DLUPTNLInformation_ToBeSetup_Item._ext = []
    
    #-----< DLUPTNLInformation-ToBeSetup-ItemExtIEs >-----#
    DLUPTNLInformation_ToBeSetup_ItemExtIEs = CLASS(name='DLUPTNLInformation-ToBeSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DLUPTNLInformation_ToBeSetup_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-Activity-Item >-----#
    DRB_Activity_Item = SEQ(name='DRB-Activity-Item', mode=MODE_TYPE)
    _DRB_Activity_Item_dRBID = INT(name='dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRB_Activity_Item_dRB_Activity = ENUM(name='dRB-Activity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRB-Activity')), opt=True)
    _DRB_Activity_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Activity_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Activity_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Activity_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRB_Activity_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Activity_Item_iE_Extensions__item__id._const_tab = ____DRB_Activity_Item_iE_Extensions__item__id_tab
    ___DRB_Activity_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Activity_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Activity_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRB_Activity_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRB_Activity_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Activity_Item_iE_Extensions__item__criticality._const_tab = ____DRB_Activity_Item_iE_Extensions__item__criticality_tab
    ___DRB_Activity_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Activity_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Activity_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRB_Activity_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRB_Activity_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Activity_Item_iE_Extensions__item__extensionValue._const_tab = ____DRB_Activity_Item_iE_Extensions__item__extensionValue_tab
    ___DRB_Activity_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Activity_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Activity_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Activity_Item_iE_Extensions__item__id),
        ('criticality', ___DRB_Activity_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Activity_Item_iE_Extensions__item__extensionValue),
        ])
    __DRB_Activity_Item_iE_Extensions__item_._ext = None
    _DRB_Activity_Item_iE_Extensions._cont = __DRB_Activity_Item_iE_Extensions__item_
    _DRB_Activity_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Activity_Item._cont = ASN1Dict([
        ('dRBID', _DRB_Activity_Item_dRBID),
        ('dRB-Activity', _DRB_Activity_Item_dRB_Activity),
        ('iE-Extensions', _DRB_Activity_Item_iE_Extensions),
        ])
    DRB_Activity_Item._ext = []
    
    #-----< DRB-Activity-ItemExtIEs >-----#
    DRB_Activity_ItemExtIEs = CLASS(name='DRB-Activity-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DRB_Activity_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-Activity >-----#
    DRB_Activity = ENUM(name='DRB-Activity', mode=MODE_TYPE)
    DRB_Activity._cont = ASN1Dict([('active', 0), ('not-active', 1)])
    DRB_Activity._ext = None
    
    #-----< DRBID >-----#
    DRBID = INT(name='DRBID', mode=MODE_TYPE)
    DRBID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    
    #-----< DRBs-FailedToBeModified-Item >-----#
    DRBs_FailedToBeModified_Item = SEQ(name='DRBs-FailedToBeModified-Item', mode=MODE_TYPE)
    _DRBs_FailedToBeModified_Item_dRBID = INT(name='dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_FailedToBeModified_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _DRBs_FailedToBeModified_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_FailedToBeModified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_FailedToBeModified_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRBs_FailedToBeModified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_FailedToBeModified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_FailedToBeModified_Item_iE_Extensions__item__id._const_tab = ____DRBs_FailedToBeModified_Item_iE_Extensions__item__id_tab
    ___DRBs_FailedToBeModified_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_FailedToBeModified_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRBs_FailedToBeModified_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRBs_FailedToBeModified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_FailedToBeModified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_FailedToBeModified_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_FailedToBeModified_Item_iE_Extensions__item__criticality_tab
    ___DRBs_FailedToBeModified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRBs_FailedToBeModified_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab
    ___DRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRBs_FailedToBeModified_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRBs_FailedToBeModified_Item_iE_Extensions__item__id),
        ('criticality', ___DRBs_FailedToBeModified_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_FailedToBeModified_Item_iE_Extensions__item_._ext = None
    _DRBs_FailedToBeModified_Item_iE_Extensions._cont = __DRBs_FailedToBeModified_Item_iE_Extensions__item_
    _DRBs_FailedToBeModified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_FailedToBeModified_Item._cont = ASN1Dict([
        ('dRBID', _DRBs_FailedToBeModified_Item_dRBID),
        ('cause', _DRBs_FailedToBeModified_Item_cause),
        ('iE-Extensions', _DRBs_FailedToBeModified_Item_iE_Extensions),
        ])
    DRBs_FailedToBeModified_Item._ext = []
    
    #-----< DRBs-FailedToBeModified-ItemExtIEs >-----#
    DRBs_FailedToBeModified_ItemExtIEs = CLASS(name='DRBs-FailedToBeModified-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DRBs_FailedToBeModified_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBs-FailedToBeSetup-Item >-----#
    DRBs_FailedToBeSetup_Item = SEQ(name='DRBs-FailedToBeSetup-Item', mode=MODE_TYPE)
    _DRBs_FailedToBeSetup_Item_dRBID = INT(name='dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_FailedToBeSetup_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _DRBs_FailedToBeSetup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_FailedToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab = ____DRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab
    ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab
    ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab
    ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRBs_FailedToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__id),
        ('criticality', ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_FailedToBeSetup_Item_iE_Extensions__item_._ext = None
    _DRBs_FailedToBeSetup_Item_iE_Extensions._cont = __DRBs_FailedToBeSetup_Item_iE_Extensions__item_
    _DRBs_FailedToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_FailedToBeSetup_Item._cont = ASN1Dict([
        ('dRBID', _DRBs_FailedToBeSetup_Item_dRBID),
        ('cause', _DRBs_FailedToBeSetup_Item_cause),
        ('iE-Extensions', _DRBs_FailedToBeSetup_Item_iE_Extensions),
        ])
    DRBs_FailedToBeSetup_Item._ext = []
    
    #-----< DRBs-FailedToBeSetup-ItemExtIEs >-----#
    DRBs_FailedToBeSetup_ItemExtIEs = CLASS(name='DRBs-FailedToBeSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DRBs_FailedToBeSetup_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBs-FailedToBeSetupMod-Item >-----#
    DRBs_FailedToBeSetupMod_Item = SEQ(name='DRBs-FailedToBeSetupMod-Item', mode=MODE_TYPE)
    _DRBs_FailedToBeSetupMod_Item_dRBID = INT(name='dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_FailedToBeSetupMod_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _DRBs_FailedToBeSetupMod_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_FailedToBeSetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab = ____DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab
    ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRBs_FailedToBeSetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id),
        ('criticality', ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_FailedToBeSetupMod_Item_iE_Extensions__item_._ext = None
    _DRBs_FailedToBeSetupMod_Item_iE_Extensions._cont = __DRBs_FailedToBeSetupMod_Item_iE_Extensions__item_
    _DRBs_FailedToBeSetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_FailedToBeSetupMod_Item._cont = ASN1Dict([
        ('dRBID', _DRBs_FailedToBeSetupMod_Item_dRBID),
        ('cause', _DRBs_FailedToBeSetupMod_Item_cause),
        ('iE-Extensions', _DRBs_FailedToBeSetupMod_Item_iE_Extensions),
        ])
    DRBs_FailedToBeSetupMod_Item._ext = []
    
    #-----< DRBs-FailedToBeSetupMod-ItemExtIEs >-----#
    DRBs_FailedToBeSetupMod_ItemExtIEs = CLASS(name='DRBs-FailedToBeSetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DRBs_FailedToBeSetupMod_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-Information >-----#
    DRB_Information = SEQ(name='DRB-Information', mode=MODE_TYPE)
    _DRB_Information_dRB_QoS = SEQ(name='dRB-QoS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSFlowLevelQoSParameters')))
    _DRB_Information_sNSSAI = SEQ(name='sNSSAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SNSSAI')))
    _DRB_Information_notificationControl = ENUM(name='notificationControl', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NotificationControl')), opt=True)
    _DRB_Information_flows_Mapped_To_DRB_List = SEQ_OF(name='flows-Mapped-To-DRB-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Flows-Mapped-To-DRB-List')))
    _DRB_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRB_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Information_iE_Extensions__item__id._const_tab = ____DRB_Information_iE_Extensions__item__id_tab
    ___DRB_Information_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRB_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRB_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Information_iE_Extensions__item__criticality._const_tab = ____DRB_Information_iE_Extensions__item__criticality_tab
    ___DRB_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRB_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRB_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRB_Information_iE_Extensions__item__extensionValue._const_tab = ____DRB_Information_iE_Extensions__item__extensionValue_tab
    ___DRB_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Information_iE_Extensions__item__id),
        ('criticality', ___DRB_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Information_iE_Extensions__item__extensionValue),
        ])
    __DRB_Information_iE_Extensions__item_._ext = None
    _DRB_Information_iE_Extensions._cont = __DRB_Information_iE_Extensions__item_
    _DRB_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Information._cont = ASN1Dict([
        ('dRB-QoS', _DRB_Information_dRB_QoS),
        ('sNSSAI', _DRB_Information_sNSSAI),
        ('notificationControl', _DRB_Information_notificationControl),
        ('flows-Mapped-To-DRB-List', _DRB_Information_flows_Mapped_To_DRB_List),
        ('iE-Extensions', _DRB_Information_iE_Extensions),
        ])
    DRB_Information._ext = None
    
    #-----< DRB-Information-ItemExtIEs >-----#
    DRB_Information_ItemExtIEs = CLASS(name='DRB-Information-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DRB_Information_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBs-Modified-Item >-----#
    DRBs_Modified_Item = SEQ(name='DRBs-Modified-Item', mode=MODE_TYPE)
    _DRBs_Modified_Item_dRBID = INT(name='dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_Modified_Item_lCID = INT(name='lCID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LCID')), opt=True)
    _DRBs_Modified_Item_dLUPTNLInformation_ToBeSetup_List = SEQ_OF(name='dLUPTNLInformation-ToBeSetup-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DLUPTNLInformation-ToBeSetup-List')))
    _DRBs_Modified_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_Modified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_Modified_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRBs_Modified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____DRBs_Modified_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLC-Status')))
    _____DRBs_Modified_Item_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    _____DRBs_Modified_Item_iE_Extensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QoSParaSetIndex')))
    ____DRBs_Modified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 160), ('criticality', 'ignore'), ('Extension', _____DRBs_Modified_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 370), ('criticality', 'ignore'), ('Extension', _____DRBs_Modified_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 344), ('criticality', 'ignore'), ('Extension', _____DRBs_Modified_Item_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DRBs_Modified_Item_iE_Extensions__item__id._const_tab = ____DRBs_Modified_Item_iE_Extensions__item__id_tab
    ___DRBs_Modified_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_Modified_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRBs_Modified_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DRBs_Modified_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_Modified_Item_iE_Extensions__item__id_tab
    ___DRBs_Modified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRBs_Modified_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRBs_Modified_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DRBs_Modified_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_Modified_Item_iE_Extensions__item__id_tab
    ___DRBs_Modified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRBs_Modified_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRBs_Modified_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRBs_Modified_Item_iE_Extensions__item__id),
        ('criticality', ___DRBs_Modified_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DRBs_Modified_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_Modified_Item_iE_Extensions__item_._ext = None
    _DRBs_Modified_Item_iE_Extensions._cont = __DRBs_Modified_Item_iE_Extensions__item_
    _DRBs_Modified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_Modified_Item._cont = ASN1Dict([
        ('dRBID', _DRBs_Modified_Item_dRBID),
        ('lCID', _DRBs_Modified_Item_lCID),
        ('dLUPTNLInformation-ToBeSetup-List', _DRBs_Modified_Item_dLUPTNLInformation_ToBeSetup_List),
        ('iE-Extensions', _DRBs_Modified_Item_iE_Extensions),
        ])
    DRBs_Modified_Item._ext = []
    
    #-----< DRBs-Modified-ItemExtIEs >-----#
    DRBs_Modified_ItemExtIEs = CLASS(name='DRBs-Modified-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _DRBs_Modified_ItemExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLC-Status')))
    _DRBs_Modified_ItemExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    _DRBs_Modified_ItemExtIEs_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QoSParaSetIndex')))
    DRBs_Modified_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 160), ('criticality', 'ignore'), ('Extension', _DRBs_Modified_ItemExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 370), ('criticality', 'ignore'), ('Extension', _DRBs_Modified_ItemExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 344), ('criticality', 'ignore'), ('Extension', _DRBs_Modified_ItemExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-ModifiedConf-Item >-----#
    DRBs_ModifiedConf_Item = SEQ(name='DRBs-ModifiedConf-Item', mode=MODE_TYPE)
    _DRBs_ModifiedConf_Item_dRBID = INT(name='dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_ModifiedConf_Item_uLUPTNLInformation_ToBeSetup_List = SEQ_OF(name='uLUPTNLInformation-ToBeSetup-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ULUPTNLInformation-ToBeSetup-List')))
    _DRBs_ModifiedConf_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_ModifiedConf_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_ModifiedConf_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRBs_ModifiedConf_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____DRBs_ModifiedConf_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    ____DRBs_ModifiedConf_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 370), ('criticality', 'ignore'), ('Extension', _____DRBs_ModifiedConf_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DRBs_ModifiedConf_Item_iE_Extensions__item__id._const_tab = ____DRBs_ModifiedConf_Item_iE_Extensions__item__id_tab
    ___DRBs_ModifiedConf_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_ModifiedConf_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRBs_ModifiedConf_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DRBs_ModifiedConf_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_ModifiedConf_Item_iE_Extensions__item__id_tab
    ___DRBs_ModifiedConf_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRBs_ModifiedConf_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_ModifiedConf_Item_iE_Extensions__item__id_tab
    ___DRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRBs_ModifiedConf_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRBs_ModifiedConf_Item_iE_Extensions__item__id),
        ('criticality', ___DRBs_ModifiedConf_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_ModifiedConf_Item_iE_Extensions__item_._ext = None
    _DRBs_ModifiedConf_Item_iE_Extensions._cont = __DRBs_ModifiedConf_Item_iE_Extensions__item_
    _DRBs_ModifiedConf_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_ModifiedConf_Item._cont = ASN1Dict([
        ('dRBID', _DRBs_ModifiedConf_Item_dRBID),
        ('uLUPTNLInformation-ToBeSetup-List', _DRBs_ModifiedConf_Item_uLUPTNLInformation_ToBeSetup_List),
        ('iE-Extensions', _DRBs_ModifiedConf_Item_iE_Extensions),
        ])
    DRBs_ModifiedConf_Item._ext = []
    
    #-----< DRBs-ModifiedConf-ItemExtIEs >-----#
    DRBs_ModifiedConf_ItemExtIEs = CLASS(name='DRBs-ModifiedConf-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _DRBs_ModifiedConf_ItemExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    DRBs_ModifiedConf_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 370), ('criticality', 'ignore'), ('Extension', _DRBs_ModifiedConf_ItemExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRB-Notify-Item >-----#
    DRB_Notify_Item = SEQ(name='DRB-Notify-Item', mode=MODE_TYPE)
    _DRB_Notify_Item_dRBID = INT(name='dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRB_Notify_Item_notification_Cause = ENUM(name='notification-Cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Notification-Cause')))
    _DRB_Notify_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRB_Notify_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRB_Notify_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRB_Notify_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____DRB_Notify_Item_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QoSParaSetNotifyIndex')))
    ____DRB_Notify_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 344), ('criticality', 'ignore'), ('Extension', _____DRB_Notify_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DRB_Notify_Item_iE_Extensions__item__id._const_tab = ____DRB_Notify_Item_iE_Extensions__item__id_tab
    ___DRB_Notify_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRB_Notify_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRB_Notify_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DRB_Notify_Item_iE_Extensions__item__criticality._const_tab = ____DRB_Notify_Item_iE_Extensions__item__id_tab
    ___DRB_Notify_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRB_Notify_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRB_Notify_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DRB_Notify_Item_iE_Extensions__item__extensionValue._const_tab = ____DRB_Notify_Item_iE_Extensions__item__id_tab
    ___DRB_Notify_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRB_Notify_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRB_Notify_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRB_Notify_Item_iE_Extensions__item__id),
        ('criticality', ___DRB_Notify_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DRB_Notify_Item_iE_Extensions__item__extensionValue),
        ])
    __DRB_Notify_Item_iE_Extensions__item_._ext = None
    _DRB_Notify_Item_iE_Extensions._cont = __DRB_Notify_Item_iE_Extensions__item_
    _DRB_Notify_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRB_Notify_Item._cont = ASN1Dict([
        ('dRBID', _DRB_Notify_Item_dRBID),
        ('notification-Cause', _DRB_Notify_Item_notification_Cause),
        ('iE-Extensions', _DRB_Notify_Item_iE_Extensions),
        ])
    DRB_Notify_Item._ext = []
    
    #-----< DRB-Notify-ItemExtIEs >-----#
    DRB_Notify_ItemExtIEs = CLASS(name='DRB-Notify-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _DRB_Notify_ItemExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QoSParaSetNotifyIndex')))
    DRB_Notify_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 344), ('criticality', 'ignore'), ('Extension', _DRB_Notify_ItemExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-Required-ToBeModified-Item >-----#
    DRBs_Required_ToBeModified_Item = SEQ(name='DRBs-Required-ToBeModified-Item', mode=MODE_TYPE)
    _DRBs_Required_ToBeModified_Item_dRBID = INT(name='dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_Required_ToBeModified_Item_dLUPTNLInformation_ToBeSetup_List = SEQ_OF(name='dLUPTNLInformation-ToBeSetup-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DLUPTNLInformation-ToBeSetup-List')))
    _DRBs_Required_ToBeModified_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_Required_ToBeModified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____DRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLC-Status')))
    _____DRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    ____DRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 160), ('criticality', 'ignore'), ('Extension', _____DRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 370), ('criticality', 'ignore'), ('Extension', _____DRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__id._const_tab = ____DRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab
    ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab
    ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab
    ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRBs_Required_ToBeModified_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__id),
        ('criticality', ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_Required_ToBeModified_Item_iE_Extensions__item_._ext = None
    _DRBs_Required_ToBeModified_Item_iE_Extensions._cont = __DRBs_Required_ToBeModified_Item_iE_Extensions__item_
    _DRBs_Required_ToBeModified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_Required_ToBeModified_Item._cont = ASN1Dict([
        ('dRBID', _DRBs_Required_ToBeModified_Item_dRBID),
        ('dLUPTNLInformation-ToBeSetup-List', _DRBs_Required_ToBeModified_Item_dLUPTNLInformation_ToBeSetup_List),
        ('iE-Extensions', _DRBs_Required_ToBeModified_Item_iE_Extensions),
        ])
    DRBs_Required_ToBeModified_Item._ext = []
    
    #-----< DRBs-Required-ToBeModified-ItemExtIEs >-----#
    DRBs_Required_ToBeModified_ItemExtIEs = CLASS(name='DRBs-Required-ToBeModified-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _DRBs_Required_ToBeModified_ItemExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLC-Status')))
    _DRBs_Required_ToBeModified_ItemExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    DRBs_Required_ToBeModified_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 160), ('criticality', 'ignore'), ('Extension', _DRBs_Required_ToBeModified_ItemExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 370), ('criticality', 'ignore'), ('Extension', _DRBs_Required_ToBeModified_ItemExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-Required-ToBeReleased-Item >-----#
    DRBs_Required_ToBeReleased_Item = SEQ(name='DRBs-Required-ToBeReleased-Item', mode=MODE_TYPE)
    _DRBs_Required_ToBeReleased_Item_dRBID = INT(name='dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_Required_ToBeReleased_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_Required_ToBeReleased_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRBs_Required_ToBeReleased_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_Required_ToBeReleased_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__id._const_tab = ____DRBs_Required_ToBeReleased_Item_iE_Extensions__item__id_tab
    ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab
    ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab
    ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRBs_Required_ToBeReleased_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__id),
        ('criticality', ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_Required_ToBeReleased_Item_iE_Extensions__item_._ext = None
    _DRBs_Required_ToBeReleased_Item_iE_Extensions._cont = __DRBs_Required_ToBeReleased_Item_iE_Extensions__item_
    _DRBs_Required_ToBeReleased_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_Required_ToBeReleased_Item._cont = ASN1Dict([
        ('dRBID', _DRBs_Required_ToBeReleased_Item_dRBID),
        ('iE-Extensions', _DRBs_Required_ToBeReleased_Item_iE_Extensions),
        ])
    DRBs_Required_ToBeReleased_Item._ext = []
    
    #-----< DRBs-Required-ToBeReleased-ItemExtIEs >-----#
    DRBs_Required_ToBeReleased_ItemExtIEs = CLASS(name='DRBs-Required-ToBeReleased-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DRBs_Required_ToBeReleased_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBs-Setup-Item >-----#
    DRBs_Setup_Item = SEQ(name='DRBs-Setup-Item', mode=MODE_TYPE)
    _DRBs_Setup_Item_dRBID = INT(name='dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_Setup_Item_lCID = INT(name='lCID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LCID')), opt=True)
    _DRBs_Setup_Item_dLUPTNLInformation_ToBeSetup_List = SEQ_OF(name='dLUPTNLInformation-ToBeSetup-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DLUPTNLInformation-ToBeSetup-List')))
    _DRBs_Setup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_Setup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_Setup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRBs_Setup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____DRBs_Setup_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    _____DRBs_Setup_Item_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QoSParaSetIndex')))
    ____DRBs_Setup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 370), ('criticality', 'ignore'), ('Extension', _____DRBs_Setup_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 344), ('criticality', 'ignore'), ('Extension', _____DRBs_Setup_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DRBs_Setup_Item_iE_Extensions__item__id._const_tab = ____DRBs_Setup_Item_iE_Extensions__item__id_tab
    ___DRBs_Setup_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_Setup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRBs_Setup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DRBs_Setup_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_Setup_Item_iE_Extensions__item__id_tab
    ___DRBs_Setup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRBs_Setup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRBs_Setup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_Setup_Item_iE_Extensions__item__id_tab
    ___DRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRBs_Setup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRBs_Setup_Item_iE_Extensions__item__id),
        ('criticality', ___DRBs_Setup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DRBs_Setup_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_Setup_Item_iE_Extensions__item_._ext = None
    _DRBs_Setup_Item_iE_Extensions._cont = __DRBs_Setup_Item_iE_Extensions__item_
    _DRBs_Setup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_Setup_Item._cont = ASN1Dict([
        ('dRBID', _DRBs_Setup_Item_dRBID),
        ('lCID', _DRBs_Setup_Item_lCID),
        ('dLUPTNLInformation-ToBeSetup-List', _DRBs_Setup_Item_dLUPTNLInformation_ToBeSetup_List),
        ('iE-Extensions', _DRBs_Setup_Item_iE_Extensions),
        ])
    DRBs_Setup_Item._ext = []
    
    #-----< DRBs-Setup-ItemExtIEs >-----#
    DRBs_Setup_ItemExtIEs = CLASS(name='DRBs-Setup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _DRBs_Setup_ItemExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    _DRBs_Setup_ItemExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QoSParaSetIndex')))
    DRBs_Setup_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 370), ('criticality', 'ignore'), ('Extension', _DRBs_Setup_ItemExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 344), ('criticality', 'ignore'), ('Extension', _DRBs_Setup_ItemExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-SetupMod-Item >-----#
    DRBs_SetupMod_Item = SEQ(name='DRBs-SetupMod-Item', mode=MODE_TYPE)
    _DRBs_SetupMod_Item_dRBID = INT(name='dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_SetupMod_Item_lCID = INT(name='lCID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LCID')), opt=True)
    _DRBs_SetupMod_Item_dLUPTNLInformation_ToBeSetup_List = SEQ_OF(name='dLUPTNLInformation-ToBeSetup-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DLUPTNLInformation-ToBeSetup-List')))
    _DRBs_SetupMod_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_SetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_SetupMod_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRBs_SetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____DRBs_SetupMod_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    _____DRBs_SetupMod_Item_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QoSParaSetIndex')))
    ____DRBs_SetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 370), ('criticality', 'ignore'), ('Extension', _____DRBs_SetupMod_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 344), ('criticality', 'ignore'), ('Extension', _____DRBs_SetupMod_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DRBs_SetupMod_Item_iE_Extensions__item__id._const_tab = ____DRBs_SetupMod_Item_iE_Extensions__item__id_tab
    ___DRBs_SetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_SetupMod_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRBs_SetupMod_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DRBs_SetupMod_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_SetupMod_Item_iE_Extensions__item__id_tab
    ___DRBs_SetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRBs_SetupMod_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRBs_SetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DRBs_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_SetupMod_Item_iE_Extensions__item__id_tab
    ___DRBs_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRBs_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRBs_SetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRBs_SetupMod_Item_iE_Extensions__item__id),
        ('criticality', ___DRBs_SetupMod_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DRBs_SetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_SetupMod_Item_iE_Extensions__item_._ext = None
    _DRBs_SetupMod_Item_iE_Extensions._cont = __DRBs_SetupMod_Item_iE_Extensions__item_
    _DRBs_SetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_SetupMod_Item._cont = ASN1Dict([
        ('dRBID', _DRBs_SetupMod_Item_dRBID),
        ('lCID', _DRBs_SetupMod_Item_lCID),
        ('dLUPTNLInformation-ToBeSetup-List', _DRBs_SetupMod_Item_dLUPTNLInformation_ToBeSetup_List),
        ('iE-Extensions', _DRBs_SetupMod_Item_iE_Extensions),
        ])
    DRBs_SetupMod_Item._ext = []
    
    #-----< DRBs-SetupMod-ItemExtIEs >-----#
    DRBs_SetupMod_ItemExtIEs = CLASS(name='DRBs-SetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _DRBs_SetupMod_ItemExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    _DRBs_SetupMod_ItemExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QoSParaSetIndex')))
    DRBs_SetupMod_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 370), ('criticality', 'ignore'), ('Extension', _DRBs_SetupMod_ItemExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 344), ('criticality', 'ignore'), ('Extension', _DRBs_SetupMod_ItemExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-ToBeModified-Item >-----#
    DRBs_ToBeModified_Item = SEQ(name='DRBs-ToBeModified-Item', mode=MODE_TYPE)
    _DRBs_ToBeModified_Item_dRBID = INT(name='dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_ToBeModified_Item_qoSInformation = CHOICE(name='qoSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSInformation')), opt=True)
    _DRBs_ToBeModified_Item_uLUPTNLInformation_ToBeSetup_List = SEQ_OF(name='uLUPTNLInformation-ToBeSetup-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ULUPTNLInformation-ToBeSetup-List')))
    _DRBs_ToBeModified_Item_uLConfiguration = SEQ(name='uLConfiguration', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ULConfiguration')), opt=True)
    _DRBs_ToBeModified_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_ToBeModified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_ToBeModified_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BearerTypeChange')))
    _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLCMode')))
    _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DuplicationActivation')))
    _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DCBasedDuplicationConfigured')))
    _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DuplicationActivation')))
    _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_7 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLCDuplicationInformation')))
    _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_9 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransmissionStopIndicator')))
    _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_10 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CG-SDTindicatorMod')))
    ____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 161), ('criticality', 'ignore'), ('Extension', _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 192), ('criticality', 'ignore'), ('Extension', _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 186), ('criticality', 'ignore'), ('Extension', _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 187), ('criticality', 'ignore'), ('Extension', _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 188), ('criticality', 'reject'), ('Extension', _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 176), ('criticality', 'reject'), ('Extension', _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'reject'), ('Extension', _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 370), ('criticality', 'ignore'), ('Extension', _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 371), ('criticality', 'ignore'), ('Extension', _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 430), ('criticality', 'ignore'), ('Extension', _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 590), ('criticality', 'reject'), ('Extension', _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_10), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DRBs_ToBeModified_Item_iE_Extensions__item__id._const_tab = ____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab
    ___DRBs_ToBeModified_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_ToBeModified_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRBs_ToBeModified_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DRBs_ToBeModified_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab
    ___DRBs_ToBeModified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRBs_ToBeModified_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRBs_ToBeModified_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DRBs_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab
    ___DRBs_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRBs_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRBs_ToBeModified_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRBs_ToBeModified_Item_iE_Extensions__item__id),
        ('criticality', ___DRBs_ToBeModified_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DRBs_ToBeModified_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_ToBeModified_Item_iE_Extensions__item_._ext = None
    _DRBs_ToBeModified_Item_iE_Extensions._cont = __DRBs_ToBeModified_Item_iE_Extensions__item_
    _DRBs_ToBeModified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_ToBeModified_Item._cont = ASN1Dict([
        ('dRBID', _DRBs_ToBeModified_Item_dRBID),
        ('qoSInformation', _DRBs_ToBeModified_Item_qoSInformation),
        ('uLUPTNLInformation-ToBeSetup-List', _DRBs_ToBeModified_Item_uLUPTNLInformation_ToBeSetup_List),
        ('uLConfiguration', _DRBs_ToBeModified_Item_uLConfiguration),
        ('iE-Extensions', _DRBs_ToBeModified_Item_iE_Extensions),
        ])
    DRBs_ToBeModified_Item._ext = []
    
    #-----< DRBs-ToBeModified-ItemExtIEs >-----#
    DRBs_ToBeModified_ItemExtIEs = CLASS(name='DRBs-ToBeModified-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _DRBs_ToBeModified_ItemExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _DRBs_ToBeModified_ItemExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _DRBs_ToBeModified_ItemExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BearerTypeChange')))
    _DRBs_ToBeModified_ItemExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLCMode')))
    _DRBs_ToBeModified_ItemExtIEs_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DuplicationActivation')))
    _DRBs_ToBeModified_ItemExtIEs_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DCBasedDuplicationConfigured')))
    _DRBs_ToBeModified_ItemExtIEs_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DuplicationActivation')))
    _DRBs_ToBeModified_ItemExtIEs_val_Extension_7 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    _DRBs_ToBeModified_ItemExtIEs_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLCDuplicationInformation')))
    _DRBs_ToBeModified_ItemExtIEs_val_Extension_9 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransmissionStopIndicator')))
    _DRBs_ToBeModified_ItemExtIEs_val_Extension_10 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CG-SDTindicatorMod')))
    DRBs_ToBeModified_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 161), ('criticality', 'ignore'), ('Extension', _DRBs_ToBeModified_ItemExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 192), ('criticality', 'ignore'), ('Extension', _DRBs_ToBeModified_ItemExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 186), ('criticality', 'ignore'), ('Extension', _DRBs_ToBeModified_ItemExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 187), ('criticality', 'ignore'), ('Extension', _DRBs_ToBeModified_ItemExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 188), ('criticality', 'reject'), ('Extension', _DRBs_ToBeModified_ItemExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 176), ('criticality', 'reject'), ('Extension', _DRBs_ToBeModified_ItemExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'reject'), ('Extension', _DRBs_ToBeModified_ItemExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 370), ('criticality', 'ignore'), ('Extension', _DRBs_ToBeModified_ItemExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 371), ('criticality', 'ignore'), ('Extension', _DRBs_ToBeModified_ItemExtIEs_val_Extension_8), ('presence', 'optional')]), dict([('id', 430), ('criticality', 'ignore'), ('Extension', _DRBs_ToBeModified_ItemExtIEs_val_Extension_9), ('presence', 'optional')]), dict([('id', 590), ('criticality', 'reject'), ('Extension', _DRBs_ToBeModified_ItemExtIEs_val_Extension_10), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-ToBeReleased-Item >-----#
    DRBs_ToBeReleased_Item = SEQ(name='DRBs-ToBeReleased-Item', mode=MODE_TYPE)
    _DRBs_ToBeReleased_Item_dRBID = INT(name='dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_ToBeReleased_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_ToBeReleased_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_ToBeReleased_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRBs_ToBeReleased_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_ToBeReleased_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab = ____DRBs_ToBeReleased_Item_iE_Extensions__item__id_tab
    ___DRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRBs_ToBeReleased_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab
    ___DRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab
    ___DRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRBs_ToBeReleased_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRBs_ToBeReleased_Item_iE_Extensions__item__id),
        ('criticality', ___DRBs_ToBeReleased_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_ToBeReleased_Item_iE_Extensions__item_._ext = None
    _DRBs_ToBeReleased_Item_iE_Extensions._cont = __DRBs_ToBeReleased_Item_iE_Extensions__item_
    _DRBs_ToBeReleased_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_ToBeReleased_Item._cont = ASN1Dict([
        ('dRBID', _DRBs_ToBeReleased_Item_dRBID),
        ('iE-Extensions', _DRBs_ToBeReleased_Item_iE_Extensions),
        ])
    DRBs_ToBeReleased_Item._ext = []
    
    #-----< DRBs-ToBeReleased-ItemExtIEs >-----#
    DRBs_ToBeReleased_ItemExtIEs = CLASS(name='DRBs-ToBeReleased-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DRBs_ToBeReleased_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBs-ToBeSetup-Item >-----#
    DRBs_ToBeSetup_Item = SEQ(name='DRBs-ToBeSetup-Item', mode=MODE_TYPE)
    _DRBs_ToBeSetup_Item_dRBID = INT(name='dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_ToBeSetup_Item_qoSInformation = CHOICE(name='qoSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSInformation')))
    _DRBs_ToBeSetup_Item_uLUPTNLInformation_ToBeSetup_List = SEQ_OF(name='uLUPTNLInformation-ToBeSetup-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ULUPTNLInformation-ToBeSetup-List')))
    _DRBs_ToBeSetup_Item_rLCMode = ENUM(name='rLCMode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RLCMode')))
    _DRBs_ToBeSetup_Item_uLConfiguration = SEQ(name='uLConfiguration', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ULConfiguration')), opt=True)
    _DRBs_ToBeSetup_Item_duplicationActivation = ENUM(name='duplicationActivation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DuplicationActivation')), opt=True)
    _DRBs_ToBeSetup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_ToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_ToBeSetup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DCBasedDuplicationConfigured')))
    _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DuplicationActivation')))
    _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLCDuplicationInformation')))
    _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_6 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SDTRLCBearerConfiguration')))
    ____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 176), ('criticality', 'reject'), ('Extension', _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'reject'), ('Extension', _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 161), ('criticality', 'ignore'), ('Extension', _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'mandatory')]), dict([('id', 192), ('criticality', 'ignore'), ('Extension', _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 370), ('criticality', 'ignore'), ('Extension', _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 371), ('criticality', 'ignore'), ('Extension', _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 593), ('criticality', 'ignore'), ('Extension', _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab = ____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___DRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRBs_ToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___DRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___DRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRBs_ToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRBs_ToBeSetup_Item_iE_Extensions__item__id),
        ('criticality', ___DRBs_ToBeSetup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_ToBeSetup_Item_iE_Extensions__item_._ext = None
    _DRBs_ToBeSetup_Item_iE_Extensions._cont = __DRBs_ToBeSetup_Item_iE_Extensions__item_
    _DRBs_ToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_ToBeSetup_Item._cont = ASN1Dict([
        ('dRBID', _DRBs_ToBeSetup_Item_dRBID),
        ('qoSInformation', _DRBs_ToBeSetup_Item_qoSInformation),
        ('uLUPTNLInformation-ToBeSetup-List', _DRBs_ToBeSetup_Item_uLUPTNLInformation_ToBeSetup_List),
        ('rLCMode', _DRBs_ToBeSetup_Item_rLCMode),
        ('uLConfiguration', _DRBs_ToBeSetup_Item_uLConfiguration),
        ('duplicationActivation', _DRBs_ToBeSetup_Item_duplicationActivation),
        ('iE-Extensions', _DRBs_ToBeSetup_Item_iE_Extensions),
        ])
    DRBs_ToBeSetup_Item._ext = []
    
    #-----< DRBs-ToBeSetup-ItemExtIEs >-----#
    DRBs_ToBeSetup_ItemExtIEs = CLASS(name='DRBs-ToBeSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _DRBs_ToBeSetup_ItemExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DCBasedDuplicationConfigured')))
    _DRBs_ToBeSetup_ItemExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DuplicationActivation')))
    _DRBs_ToBeSetup_ItemExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _DRBs_ToBeSetup_ItemExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _DRBs_ToBeSetup_ItemExtIEs_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    _DRBs_ToBeSetup_ItemExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLCDuplicationInformation')))
    _DRBs_ToBeSetup_ItemExtIEs_val_Extension_6 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SDTRLCBearerConfiguration')))
    DRBs_ToBeSetup_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 176), ('criticality', 'reject'), ('Extension', _DRBs_ToBeSetup_ItemExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'reject'), ('Extension', _DRBs_ToBeSetup_ItemExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 161), ('criticality', 'ignore'), ('Extension', _DRBs_ToBeSetup_ItemExtIEs_val_Extension_2), ('presence', 'mandatory')]), dict([('id', 192), ('criticality', 'ignore'), ('Extension', _DRBs_ToBeSetup_ItemExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 370), ('criticality', 'ignore'), ('Extension', _DRBs_ToBeSetup_ItemExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 371), ('criticality', 'ignore'), ('Extension', _DRBs_ToBeSetup_ItemExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 593), ('criticality', 'ignore'), ('Extension', _DRBs_ToBeSetup_ItemExtIEs_val_Extension_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-ToBeSetupMod-Item >-----#
    DRBs_ToBeSetupMod_Item = SEQ(name='DRBs-ToBeSetupMod-Item', mode=MODE_TYPE)
    _DRBs_ToBeSetupMod_Item_dRBID = INT(name='dRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _DRBs_ToBeSetupMod_Item_qoSInformation = CHOICE(name='qoSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSInformation')))
    _DRBs_ToBeSetupMod_Item_uLUPTNLInformation_ToBeSetup_List = SEQ_OF(name='uLUPTNLInformation-ToBeSetup-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ULUPTNLInformation-ToBeSetup-List')))
    _DRBs_ToBeSetupMod_Item_rLCMode = ENUM(name='rLCMode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RLCMode')))
    _DRBs_ToBeSetupMod_Item_uLConfiguration = SEQ(name='uLConfiguration', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ULConfiguration')), opt=True)
    _DRBs_ToBeSetupMod_Item_duplicationActivation = ENUM(name='duplicationActivation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DuplicationActivation')), opt=True)
    _DRBs_ToBeSetupMod_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBs_ToBeSetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DCBasedDuplicationConfigured')))
    _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DuplicationActivation')))
    _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLCDuplicationInformation')))
    _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CG-SDTindicatorSetup')))
    ____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 176), ('criticality', 'reject'), ('Extension', _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'reject'), ('Extension', _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 161), ('criticality', 'ignore'), ('Extension', _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 192), ('criticality', 'ignore'), ('Extension', _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 370), ('criticality', 'ignore'), ('Extension', _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 371), ('criticality', 'ignore'), ('Extension', _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 589), ('criticality', 'reject'), ('Extension', _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab = ____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab = ____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRBs_ToBeSetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__id),
        ('criticality', ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __DRBs_ToBeSetupMod_Item_iE_Extensions__item_._ext = None
    _DRBs_ToBeSetupMod_Item_iE_Extensions._cont = __DRBs_ToBeSetupMod_Item_iE_Extensions__item_
    _DRBs_ToBeSetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBs_ToBeSetupMod_Item._cont = ASN1Dict([
        ('dRBID', _DRBs_ToBeSetupMod_Item_dRBID),
        ('qoSInformation', _DRBs_ToBeSetupMod_Item_qoSInformation),
        ('uLUPTNLInformation-ToBeSetup-List', _DRBs_ToBeSetupMod_Item_uLUPTNLInformation_ToBeSetup_List),
        ('rLCMode', _DRBs_ToBeSetupMod_Item_rLCMode),
        ('uLConfiguration', _DRBs_ToBeSetupMod_Item_uLConfiguration),
        ('duplicationActivation', _DRBs_ToBeSetupMod_Item_duplicationActivation),
        ('iE-Extensions', _DRBs_ToBeSetupMod_Item_iE_Extensions),
        ])
    DRBs_ToBeSetupMod_Item._ext = []
    
    #-----< DRBs-ToBeSetupMod-ItemExtIEs >-----#
    DRBs_ToBeSetupMod_ItemExtIEs = CLASS(name='DRBs-ToBeSetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DCBasedDuplicationConfigured')))
    _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DuplicationActivation')))
    _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPDCPDuplicationTNL-List')))
    _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLCDuplicationInformation')))
    _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CG-SDTindicatorSetup')))
    DRBs_ToBeSetupMod_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 176), ('criticality', 'reject'), ('Extension', _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'reject'), ('Extension', _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 161), ('criticality', 'ignore'), ('Extension', _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 192), ('criticality', 'ignore'), ('Extension', _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 370), ('criticality', 'ignore'), ('Extension', _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 371), ('criticality', 'ignore'), ('Extension', _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 589), ('criticality', 'reject'), ('Extension', _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRXCycle >-----#
    DRXCycle = SEQ(name='DRXCycle', mode=MODE_TYPE)
    _DRXCycle_longDRXCycleLength = ENUM(name='longDRXCycleLength', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LongDRXCycleLength')))
    _DRXCycle_shortDRXCycleLength = ENUM(name='shortDRXCycleLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ShortDRXCycleLength')), opt=True)
    _DRXCycle_shortDRXCycleTimer = INT(name='shortDRXCycleTimer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ShortDRXCycleTimer')), opt=True)
    _DRXCycle_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRXCycle_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DRXCycle_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DRXCycle_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRXCycle_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRXCycle_iE_Extensions__item__id._const_tab = ____DRXCycle_iE_Extensions__item__id_tab
    ___DRXCycle_iE_Extensions__item__id._const_tab_at = None
    ___DRXCycle_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRXCycle_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRXCycle_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRXCycle_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRXCycle_iE_Extensions__item__criticality._const_tab = ____DRXCycle_iE_Extensions__item__criticality_tab
    ___DRXCycle_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRXCycle_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRXCycle_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRXCycle_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DRXCycle_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRXCycle_iE_Extensions__item__extensionValue._const_tab = ____DRXCycle_iE_Extensions__item__extensionValue_tab
    ___DRXCycle_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRXCycle_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRXCycle_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRXCycle_iE_Extensions__item__id),
        ('criticality', ___DRXCycle_iE_Extensions__item__criticality),
        ('extensionValue', ___DRXCycle_iE_Extensions__item__extensionValue),
        ])
    __DRXCycle_iE_Extensions__item_._ext = None
    _DRXCycle_iE_Extensions._cont = __DRXCycle_iE_Extensions__item_
    _DRXCycle_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRXCycle._cont = ASN1Dict([
        ('longDRXCycleLength', _DRXCycle_longDRXCycleLength),
        ('shortDRXCycleLength', _DRXCycle_shortDRXCycleLength),
        ('shortDRXCycleTimer', _DRXCycle_shortDRXCycleTimer),
        ('iE-Extensions', _DRXCycle_iE_Extensions),
        ])
    DRXCycle._ext = []
    
    #-----< DRXCycle-ExtIEs >-----#
    DRXCycle_ExtIEs = CLASS(name='DRXCycle-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DRXCycle_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRX-Config >-----#
    DRX_Config = OCT_STR(name='DRX-Config', mode=MODE_TYPE)
    
    #-----< DRXConfigurationIndicator >-----#
    DRXConfigurationIndicator = ENUM(name='DRXConfigurationIndicator', mode=MODE_TYPE)
    DRXConfigurationIndicator._cont = ASN1Dict([('release', 0)])
    DRXConfigurationIndicator._ext = []
    
    #-----< DRX-LongCycleStartOffset >-----#
    DRX_LongCycleStartOffset = INT(name='DRX-LongCycleStartOffset', mode=MODE_TYPE)
    DRX_LongCycleStartOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10239)], ev=None, er=[])
    
    #-----< DSInformationList >-----#
    DSInformationList = SEQ_OF(name='DSInformationList', mode=MODE_TYPE)
    _DSInformationList__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DSCP')))
    DSInformationList._cont = _DSInformationList__item_
    DSInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=64)], ev=None, er=[])
    
    #-----< DSCP >-----#
    DSCP = BIT_STR(name='DSCP', mode=MODE_TYPE)
    DSCP._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< DUtoCURRCContainer >-----#
    DUtoCURRCContainer = OCT_STR(name='DUtoCURRCContainer', mode=MODE_TYPE)
    
    #-----< DUCURadioInformationType >-----#
    DUCURadioInformationType = CHOICE(name='DUCURadioInformationType', mode=MODE_TYPE)
    _DUCURadioInformationType_rIM = SEQ(name='rIM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DUCURIMInformation')))
    _DUCURadioInformationType_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DUCURadioInformationType_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___DUCURadioInformationType_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DUCURadioInformationType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DUCURadioInformationType_choice_extension_id._const_tab = ___DUCURadioInformationType_choice_extension_id_tab
    __DUCURadioInformationType_choice_extension_id._const_tab_at = None
    __DUCURadioInformationType_choice_extension_id._const_tab_id = 'id'
    __DUCURadioInformationType_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___DUCURadioInformationType_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DUCURadioInformationType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DUCURadioInformationType_choice_extension_criticality._const_tab = ___DUCURadioInformationType_choice_extension_criticality_tab
    __DUCURadioInformationType_choice_extension_criticality._const_tab_at = ('..', 'id')
    __DUCURadioInformationType_choice_extension_criticality._const_tab_id = 'criticality'
    __DUCURadioInformationType_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___DUCURadioInformationType_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DUCURadioInformationType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DUCURadioInformationType_choice_extension_value._const_tab = ___DUCURadioInformationType_choice_extension_value_tab
    __DUCURadioInformationType_choice_extension_value._const_tab_at = ('..', 'id')
    __DUCURadioInformationType_choice_extension_value._const_tab_id = 'Value'
    _DUCURadioInformationType_choice_extension._cont = ASN1Dict([
        ('id', __DUCURadioInformationType_choice_extension_id),
        ('criticality', __DUCURadioInformationType_choice_extension_criticality),
        ('value', __DUCURadioInformationType_choice_extension_value),
        ])
    _DUCURadioInformationType_choice_extension._ext = None
    DUCURadioInformationType._cont = ASN1Dict([
        ('rIM', _DUCURadioInformationType_rIM),
        ('choice-extension', _DUCURadioInformationType_choice_extension),
        ])
    DUCURadioInformationType._ext = None
    
    #-----< DUCURadioInformationType-ExtIEs >-----#
    DUCURadioInformationType_ExtIEs = CLASS(name='DUCURadioInformationType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    DUCURadioInformationType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DUCURIMInformation >-----#
    DUCURIMInformation = SEQ(name='DUCURIMInformation', mode=MODE_TYPE)
    _DUCURIMInformation_victimgNBSetID = BIT_STR(name='victimgNBSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNBSetID')))
    _DUCURIMInformation_rIMRSDetectionStatus = ENUM(name='rIMRSDetectionStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RIMRSDetectionStatus')))
    _DUCURIMInformation_aggressorCellList = SEQ_OF(name='aggressorCellList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AggressorCellList')))
    _DUCURIMInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DUCURIMInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DUCURIMInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DUCURIMInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DUCURIMInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DUCURIMInformation_iE_Extensions__item__id._const_tab = ____DUCURIMInformation_iE_Extensions__item__id_tab
    ___DUCURIMInformation_iE_Extensions__item__id._const_tab_at = None
    ___DUCURIMInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___DUCURIMInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DUCURIMInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DUCURIMInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DUCURIMInformation_iE_Extensions__item__criticality._const_tab = ____DUCURIMInformation_iE_Extensions__item__criticality_tab
    ___DUCURIMInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DUCURIMInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DUCURIMInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DUCURIMInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DUCURIMInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DUCURIMInformation_iE_Extensions__item__extensionValue._const_tab = ____DUCURIMInformation_iE_Extensions__item__extensionValue_tab
    ___DUCURIMInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DUCURIMInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DUCURIMInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DUCURIMInformation_iE_Extensions__item__id),
        ('criticality', ___DUCURIMInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___DUCURIMInformation_iE_Extensions__item__extensionValue),
        ])
    __DUCURIMInformation_iE_Extensions__item_._ext = None
    _DUCURIMInformation_iE_Extensions._cont = __DUCURIMInformation_iE_Extensions__item_
    _DUCURIMInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DUCURIMInformation._cont = ASN1Dict([
        ('victimgNBSetID', _DUCURIMInformation_victimgNBSetID),
        ('rIMRSDetectionStatus', _DUCURIMInformation_rIMRSDetectionStatus),
        ('aggressorCellList', _DUCURIMInformation_aggressorCellList),
        ('iE-Extensions', _DUCURIMInformation_iE_Extensions),
        ])
    DUCURIMInformation._ext = None
    
    #-----< DUCURIMInformation-ExtIEs >-----#
    DUCURIMInformation_ExtIEs = CLASS(name='DUCURIMInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DUCURIMInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DUF-Slot-Config-Item >-----#
    DUF_Slot_Config_Item = CHOICE(name='DUF-Slot-Config-Item', mode=MODE_TYPE)
    _DUF_Slot_Config_Item_explicitFormat = SEQ(name='explicitFormat', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ExplicitFormat')))
    _DUF_Slot_Config_Item_implicitFormat = SEQ(name='implicitFormat', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ImplicitFormat')))
    _DUF_Slot_Config_Item_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DUF_Slot_Config_Item_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___DUF_Slot_Config_Item_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DUF_Slot_Config_Item_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DUF_Slot_Config_Item_choice_extension_id._const_tab = ___DUF_Slot_Config_Item_choice_extension_id_tab
    __DUF_Slot_Config_Item_choice_extension_id._const_tab_at = None
    __DUF_Slot_Config_Item_choice_extension_id._const_tab_id = 'id'
    __DUF_Slot_Config_Item_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___DUF_Slot_Config_Item_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DUF_Slot_Config_Item_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DUF_Slot_Config_Item_choice_extension_criticality._const_tab = ___DUF_Slot_Config_Item_choice_extension_criticality_tab
    __DUF_Slot_Config_Item_choice_extension_criticality._const_tab_at = ('..', 'id')
    __DUF_Slot_Config_Item_choice_extension_criticality._const_tab_id = 'criticality'
    __DUF_Slot_Config_Item_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___DUF_Slot_Config_Item_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___DUF_Slot_Config_Item_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DUF_Slot_Config_Item_choice_extension_value._const_tab = ___DUF_Slot_Config_Item_choice_extension_value_tab
    __DUF_Slot_Config_Item_choice_extension_value._const_tab_at = ('..', 'id')
    __DUF_Slot_Config_Item_choice_extension_value._const_tab_id = 'Value'
    _DUF_Slot_Config_Item_choice_extension._cont = ASN1Dict([
        ('id', __DUF_Slot_Config_Item_choice_extension_id),
        ('criticality', __DUF_Slot_Config_Item_choice_extension_criticality),
        ('value', __DUF_Slot_Config_Item_choice_extension_value),
        ])
    _DUF_Slot_Config_Item_choice_extension._ext = None
    DUF_Slot_Config_Item._cont = ASN1Dict([
        ('explicitFormat', _DUF_Slot_Config_Item_explicitFormat),
        ('implicitFormat', _DUF_Slot_Config_Item_implicitFormat),
        ('choice-extension', _DUF_Slot_Config_Item_choice_extension),
        ])
    DUF_Slot_Config_Item._ext = None
    
    #-----< DUF-Slot-Config-Item-ExtIEs >-----#
    DUF_Slot_Config_Item_ExtIEs = CLASS(name='DUF-Slot-Config-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    DUF_Slot_Config_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DUF-Slot-Config-List >-----#
    DUF_Slot_Config_List = SEQ_OF(name='DUF-Slot-Config-List', mode=MODE_TYPE)
    _DUF_Slot_Config_List__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DUF-Slot-Config-Item')))
    DUF_Slot_Config_List._cont = _DUF_Slot_Config_List__item_
    DUF_Slot_Config_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=320)], ev=None, er=[])
    
    #-----< DUFSlotformatIndex >-----#
    DUFSlotformatIndex = INT(name='DUFSlotformatIndex', mode=MODE_TYPE)
    DUFSlotformatIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=254)], ev=None, er=[])
    
    #-----< DUFTransmissionPeriodicity >-----#
    DUFTransmissionPeriodicity = ENUM(name='DUFTransmissionPeriodicity', mode=MODE_TYPE)
    DUFTransmissionPeriodicity._cont = ASN1Dict([('ms0p5', 0), ('ms0p625', 1), ('ms1', 2), ('ms1p25', 3), ('ms2', 4), ('ms2p5', 5), ('ms5', 6), ('ms10', 7)])
    DUFTransmissionPeriodicity._ext = []
    
    #-----< DU-RX-MT-RX >-----#
    DU_RX_MT_RX = ENUM(name='DU-RX-MT-RX', mode=MODE_TYPE)
    DU_RX_MT_RX._cont = ASN1Dict([('supported', 0), ('not-supported', 1)])
    DU_RX_MT_RX._ext = None
    
    #-----< DU-TX-MT-TX >-----#
    DU_TX_MT_TX = ENUM(name='DU-TX-MT-TX', mode=MODE_TYPE)
    DU_TX_MT_TX._cont = ASN1Dict([('supported', 0), ('not-supported', 1)])
    DU_TX_MT_TX._ext = None
    
    #-----< DU-RX-MT-TX >-----#
    DU_RX_MT_TX = ENUM(name='DU-RX-MT-TX', mode=MODE_TYPE)
    DU_RX_MT_TX._cont = ASN1Dict([('supported', 0), ('not-supported', 1)])
    DU_RX_MT_TX._ext = None
    
    #-----< DU-TX-MT-RX >-----#
    DU_TX_MT_RX = ENUM(name='DU-TX-MT-RX', mode=MODE_TYPE)
    DU_TX_MT_RX._cont = ASN1Dict([('supported', 0), ('not-supported', 1)])
    DU_TX_MT_RX._ext = None
    
    #-----< DU-RX-MT-RX-Extend >-----#
    DU_RX_MT_RX_Extend = ENUM(name='DU-RX-MT-RX-Extend', mode=MODE_TYPE)
    DU_RX_MT_RX_Extend._cont = ASN1Dict([('supported', 0), ('not-supported', 1), ('supported-and-FDM-required', 2)])
    DU_RX_MT_RX_Extend._ext = []
    
    #-----< DU-TX-MT-TX-Extend >-----#
    DU_TX_MT_TX_Extend = ENUM(name='DU-TX-MT-TX-Extend', mode=MODE_TYPE)
    DU_TX_MT_TX_Extend._cont = ASN1Dict([('supported', 0), ('not-supported', 1), ('supported-and-FDM-required', 2)])
    DU_TX_MT_TX_Extend._ext = []
    
    #-----< DU-RX-MT-TX-Extend >-----#
    DU_RX_MT_TX_Extend = ENUM(name='DU-RX-MT-TX-Extend', mode=MODE_TYPE)
    DU_RX_MT_TX_Extend._cont = ASN1Dict([('supported', 0), ('not-supported', 1), ('supported-and-FDM-required', 2)])
    DU_RX_MT_TX_Extend._ext = []
    
    #-----< DU-TX-MT-RX-Extend >-----#
    DU_TX_MT_RX_Extend = ENUM(name='DU-TX-MT-RX-Extend', mode=MODE_TYPE)
    DU_TX_MT_RX_Extend._cont = ASN1Dict([('supported', 0), ('not-supported', 1), ('supported-and-FDM-required', 2)])
    DU_TX_MT_RX_Extend._ext = []
    
    #-----< DUtoCURRCInformation >-----#
    DUtoCURRCInformation = SEQ(name='DUtoCURRCInformation', mode=MODE_TYPE)
    _DUtoCURRCInformation_cellGroupConfig = OCT_STR(name='cellGroupConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CellGroupConfig')))
    _DUtoCURRCInformation_measGapConfig = OCT_STR(name='measGapConfig', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MeasGapConfig')), opt=True)
    _DUtoCURRCInformation_requestedP_MaxFR1 = OCT_STR(name='requestedP-MaxFR1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DUtoCURRCInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DUtoCURRCInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DUtoCURRCInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DUtoCURRCInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRX-LongCycleStartOffset')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SelectedBandCombinationIndex')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SelectedFeatureSetEntryIndex')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_3 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Ph-InfoSCG')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_4 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RequestedBandCombinationIndex')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_5 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RequestedFeatureSetEntryIndex')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_6 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRX-Config')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_7 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCCH-BlindDetectionSCG')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_8 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Requested-PDCCH-BlindDetectionSCG')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_9 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Ph-InfoMCG')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_10 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasGapSharingConfig')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_11 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SL-PHY-MAC-RLC-Config')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_12 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SL-ConfigDedicatedEUTRA-Info')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_13 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RequestedP-MaxFR2')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_14 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SDT-MAC-PHY-CG-Config')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_15 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MUSIM-GapConfig')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_16 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SL-RLC-ChannelToAddModList')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_17 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'InterFrequencyConfig-NoGap')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_18 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-GapFR2-Config')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_19 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TwoPHRModeMCG')))
    _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_20 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TwoPHRModeSCG')))
    ____DUtoCURRCInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 191), ('criticality', 'ignore'), ('Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 193), ('criticality', 'ignore'), ('Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 194), ('criticality', 'ignore'), ('Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 208), ('criticality', 'ignore'), ('Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 209), ('criticality', 'ignore'), ('Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 210), ('criticality', 'ignore'), ('Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 212), ('criticality', 'ignore'), ('Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 235), ('criticality', 'ignore'), ('Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 236), ('criticality', 'ignore'), ('Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 237), ('criticality', 'ignore'), ('Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 238), ('criticality', 'ignore'), ('Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 341), ('criticality', 'ignore'), ('Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_11), ('presence', 'optional')]), dict([('id', 342), ('criticality', 'ignore'), ('Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_12), ('presence', 'optional')]), dict([('id', 211), ('criticality', 'ignore'), ('Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_13), ('presence', 'optional')]), dict([('id', 587), ('criticality', 'ignore'), ('Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_14), ('presence', 'optional')]), dict([('id', 621), ('criticality', 'ignore'), ('Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_15), ('presence', 'optional')]), dict([('id', 645), ('criticality', 'ignore'), ('Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_16), ('presence', 'optional')]), dict([('id', 651), ('criticality', 'ignore'), ('Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_17), ('presence', 'optional')]), dict([('id', 677), ('criticality', 'ignore'), ('Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_18), ('presence', 'optional')]), dict([('id', 692), ('criticality', 'ignore'), ('Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_19), ('presence', 'optional')]), dict([('id', 693), ('criticality', 'ignore'), ('Extension', _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_20), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DUtoCURRCInformation_iE_Extensions__item__id._const_tab = ____DUtoCURRCInformation_iE_Extensions__item__id_tab
    ___DUtoCURRCInformation_iE_Extensions__item__id._const_tab_at = None
    ___DUtoCURRCInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___DUtoCURRCInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DUtoCURRCInformation_iE_Extensions__item__criticality._const_tab = ____DUtoCURRCInformation_iE_Extensions__item__id_tab
    ___DUtoCURRCInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DUtoCURRCInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DUtoCURRCInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DUtoCURRCInformation_iE_Extensions__item__extensionValue._const_tab = ____DUtoCURRCInformation_iE_Extensions__item__id_tab
    ___DUtoCURRCInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DUtoCURRCInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DUtoCURRCInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DUtoCURRCInformation_iE_Extensions__item__id),
        ('criticality', ___DUtoCURRCInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___DUtoCURRCInformation_iE_Extensions__item__extensionValue),
        ])
    __DUtoCURRCInformation_iE_Extensions__item_._ext = None
    _DUtoCURRCInformation_iE_Extensions._cont = __DUtoCURRCInformation_iE_Extensions__item_
    _DUtoCURRCInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DUtoCURRCInformation._cont = ASN1Dict([
        ('cellGroupConfig', _DUtoCURRCInformation_cellGroupConfig),
        ('measGapConfig', _DUtoCURRCInformation_measGapConfig),
        ('requestedP-MaxFR1', _DUtoCURRCInformation_requestedP_MaxFR1),
        ('iE-Extensions', _DUtoCURRCInformation_iE_Extensions),
        ])
    DUtoCURRCInformation._ext = []
    
    #-----< DUtoCURRCInformation-ExtIEs >-----#
    DUtoCURRCInformation_ExtIEs = CLASS(name='DUtoCURRCInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRX-LongCycleStartOffset')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SelectedBandCombinationIndex')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SelectedFeatureSetEntryIndex')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_3 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Ph-InfoSCG')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_4 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RequestedBandCombinationIndex')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_5 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RequestedFeatureSetEntryIndex')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_6 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRX-Config')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_7 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCCH-BlindDetectionSCG')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_8 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Requested-PDCCH-BlindDetectionSCG')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_9 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Ph-InfoMCG')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_10 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasGapSharingConfig')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_11 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SL-PHY-MAC-RLC-Config')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_12 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SL-ConfigDedicatedEUTRA-Info')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_13 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RequestedP-MaxFR2')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_14 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SDT-MAC-PHY-CG-Config')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_15 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MUSIM-GapConfig')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_16 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SL-RLC-ChannelToAddModList')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_17 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'InterFrequencyConfig-NoGap')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_18 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-GapFR2-Config')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_19 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TwoPHRModeMCG')))
    _DUtoCURRCInformation_ExtIEs_val_Extension_20 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TwoPHRModeSCG')))
    DUtoCURRCInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 191), ('criticality', 'ignore'), ('Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 193), ('criticality', 'ignore'), ('Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 194), ('criticality', 'ignore'), ('Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 208), ('criticality', 'ignore'), ('Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 209), ('criticality', 'ignore'), ('Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 210), ('criticality', 'ignore'), ('Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 212), ('criticality', 'ignore'), ('Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 235), ('criticality', 'ignore'), ('Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 236), ('criticality', 'ignore'), ('Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_8), ('presence', 'optional')]), dict([('id', 237), ('criticality', 'ignore'), ('Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_9), ('presence', 'optional')]), dict([('id', 238), ('criticality', 'ignore'), ('Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_10), ('presence', 'optional')]), dict([('id', 341), ('criticality', 'ignore'), ('Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_11), ('presence', 'optional')]), dict([('id', 342), ('criticality', 'ignore'), ('Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_12), ('presence', 'optional')]), dict([('id', 211), ('criticality', 'ignore'), ('Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_13), ('presence', 'optional')]), dict([('id', 587), ('criticality', 'ignore'), ('Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_14), ('presence', 'optional')]), dict([('id', 621), ('criticality', 'ignore'), ('Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_15), ('presence', 'optional')]), dict([('id', 645), ('criticality', 'ignore'), ('Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_16), ('presence', 'optional')]), dict([('id', 651), ('criticality', 'ignore'), ('Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_17), ('presence', 'optional')]), dict([('id', 677), ('criticality', 'ignore'), ('Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_18), ('presence', 'optional')]), dict([('id', 692), ('criticality', 'ignore'), ('Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_19), ('presence', 'optional')]), dict([('id', 693), ('criticality', 'ignore'), ('Extension', _DUtoCURRCInformation_ExtIEs_val_Extension_20), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DuplicationActivation >-----#
    DuplicationActivation = ENUM(name='DuplicationActivation', mode=MODE_TYPE)
    DuplicationActivation._cont = ASN1Dict([('active', 0), ('inactive', 1)])
    DuplicationActivation._ext = []
    
    #-----< DuplicationIndication >-----#
    DuplicationIndication = ENUM(name='DuplicationIndication', mode=MODE_TYPE)
    DuplicationIndication._cont = ASN1Dict([('true', 0), ('false', 1)])
    DuplicationIndication._ext = ['false']
    
    #-----< DuplicationState >-----#
    DuplicationState = ENUM(name='DuplicationState', mode=MODE_TYPE)
    DuplicationState._cont = ASN1Dict([('active', 0), ('inactive', 1)])
    DuplicationState._ext = []
    
    #-----< Dynamic5QIDescriptor >-----#
    Dynamic5QIDescriptor = SEQ(name='Dynamic5QIDescriptor', mode=MODE_TYPE)
    _Dynamic5QIDescriptor_qoSPriorityLevel = INT(name='qoSPriorityLevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Dynamic5QIDescriptor_qoSPriorityLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _Dynamic5QIDescriptor_packetDelayBudget = INT(name='packetDelayBudget', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PacketDelayBudget')))
    _Dynamic5QIDescriptor_packetErrorRate = SEQ(name='packetErrorRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PacketErrorRate')))
    _Dynamic5QIDescriptor_fiveQI = INT(name='fiveQI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Dynamic5QIDescriptor_fiveQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    _Dynamic5QIDescriptor_delayCritical = ENUM(name='delayCritical', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Dynamic5QIDescriptor_delayCritical._cont = ASN1Dict([('delay-critical', 0), ('non-delay-critical', 1)])
    _Dynamic5QIDescriptor_delayCritical._ext = None
    _Dynamic5QIDescriptor_averagingWindow = INT(name='averagingWindow', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AveragingWindow')), opt=True)
    _Dynamic5QIDescriptor_maxDataBurstVolume = INT(name='maxDataBurstVolume', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MaxDataBurstVolume')), opt=True)
    _Dynamic5QIDescriptor_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Dynamic5QIDescriptor_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Dynamic5QIDescriptor_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedPacketDelayBudget')))
    _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedPacketDelayBudget')))
    _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedPacketDelayBudget')))
    ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 363), ('criticality', 'ignore'), ('Extension', _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 362), ('criticality', 'ignore'), ('Extension', _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 369), ('criticality', 'ignore'), ('Extension', _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Dynamic5QIDescriptor_iE_Extensions__item__id._const_tab = ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___Dynamic5QIDescriptor_iE_Extensions__item__id._const_tab_at = None
    ___Dynamic5QIDescriptor_iE_Extensions__item__id._const_tab_id = 'id'
    ___Dynamic5QIDescriptor_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Dynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab = ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___Dynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Dynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab = ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Dynamic5QIDescriptor_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Dynamic5QIDescriptor_iE_Extensions__item__id),
        ('criticality', ___Dynamic5QIDescriptor_iE_Extensions__item__criticality),
        ('extensionValue', ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue),
        ])
    __Dynamic5QIDescriptor_iE_Extensions__item_._ext = None
    _Dynamic5QIDescriptor_iE_Extensions._cont = __Dynamic5QIDescriptor_iE_Extensions__item_
    _Dynamic5QIDescriptor_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Dynamic5QIDescriptor._cont = ASN1Dict([
        ('qoSPriorityLevel', _Dynamic5QIDescriptor_qoSPriorityLevel),
        ('packetDelayBudget', _Dynamic5QIDescriptor_packetDelayBudget),
        ('packetErrorRate', _Dynamic5QIDescriptor_packetErrorRate),
        ('fiveQI', _Dynamic5QIDescriptor_fiveQI),
        ('delayCritical', _Dynamic5QIDescriptor_delayCritical),
        ('averagingWindow', _Dynamic5QIDescriptor_averagingWindow),
        ('maxDataBurstVolume', _Dynamic5QIDescriptor_maxDataBurstVolume),
        ('iE-Extensions', _Dynamic5QIDescriptor_iE_Extensions),
        ])
    Dynamic5QIDescriptor._ext = None
    
    #-----< Dynamic5QIDescriptor-ExtIEs >-----#
    Dynamic5QIDescriptor_ExtIEs = CLASS(name='Dynamic5QIDescriptor-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _Dynamic5QIDescriptor_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedPacketDelayBudget')))
    _Dynamic5QIDescriptor_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedPacketDelayBudget')))
    _Dynamic5QIDescriptor_ExtIEs_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedPacketDelayBudget')))
    Dynamic5QIDescriptor_ExtIEs._val = ASN1Set(rv=[dict([('id', 363), ('criticality', 'ignore'), ('Extension', _Dynamic5QIDescriptor_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 362), ('criticality', 'ignore'), ('Extension', _Dynamic5QIDescriptor_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 369), ('criticality', 'ignore'), ('Extension', _Dynamic5QIDescriptor_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DynamicPQIDescriptor >-----#
    DynamicPQIDescriptor = SEQ(name='DynamicPQIDescriptor', mode=MODE_TYPE)
    _DynamicPQIDescriptor_resourceType = ENUM(name='resourceType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DynamicPQIDescriptor_resourceType._cont = ASN1Dict([('gbr', 0), ('non-gbr', 1), ('delay-critical-grb', 2)])
    _DynamicPQIDescriptor_resourceType._ext = []
    _DynamicPQIDescriptor_qoSPriorityLevel = INT(name='qoSPriorityLevel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DynamicPQIDescriptor_qoSPriorityLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=[], er=[])
    _DynamicPQIDescriptor_packetDelayBudget = INT(name='packetDelayBudget', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PacketDelayBudget')))
    _DynamicPQIDescriptor_packetErrorRate = SEQ(name='packetErrorRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PacketErrorRate')))
    _DynamicPQIDescriptor_averagingWindow = INT(name='averagingWindow', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AveragingWindow')), opt=True)
    _DynamicPQIDescriptor_maxDataBurstVolume = INT(name='maxDataBurstVolume', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MaxDataBurstVolume')), opt=True)
    _DynamicPQIDescriptor_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DynamicPQIDescriptor_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DynamicPQIDescriptor_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DynamicPQIDescriptor_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DynamicPQIDescriptor_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DynamicPQIDescriptor_iE_Extensions__item__id._const_tab = ____DynamicPQIDescriptor_iE_Extensions__item__id_tab
    ___DynamicPQIDescriptor_iE_Extensions__item__id._const_tab_at = None
    ___DynamicPQIDescriptor_iE_Extensions__item__id._const_tab_id = 'id'
    ___DynamicPQIDescriptor_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DynamicPQIDescriptor_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DynamicPQIDescriptor_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DynamicPQIDescriptor_iE_Extensions__item__criticality._const_tab = ____DynamicPQIDescriptor_iE_Extensions__item__criticality_tab
    ___DynamicPQIDescriptor_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DynamicPQIDescriptor_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DynamicPQIDescriptor_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DynamicPQIDescriptor_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DynamicPQIDescriptor_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DynamicPQIDescriptor_iE_Extensions__item__extensionValue._const_tab = ____DynamicPQIDescriptor_iE_Extensions__item__extensionValue_tab
    ___DynamicPQIDescriptor_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DynamicPQIDescriptor_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DynamicPQIDescriptor_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DynamicPQIDescriptor_iE_Extensions__item__id),
        ('criticality', ___DynamicPQIDescriptor_iE_Extensions__item__criticality),
        ('extensionValue', ___DynamicPQIDescriptor_iE_Extensions__item__extensionValue),
        ])
    __DynamicPQIDescriptor_iE_Extensions__item_._ext = None
    _DynamicPQIDescriptor_iE_Extensions._cont = __DynamicPQIDescriptor_iE_Extensions__item_
    _DynamicPQIDescriptor_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DynamicPQIDescriptor._cont = ASN1Dict([
        ('resourceType', _DynamicPQIDescriptor_resourceType),
        ('qoSPriorityLevel', _DynamicPQIDescriptor_qoSPriorityLevel),
        ('packetDelayBudget', _DynamicPQIDescriptor_packetDelayBudget),
        ('packetErrorRate', _DynamicPQIDescriptor_packetErrorRate),
        ('averagingWindow', _DynamicPQIDescriptor_averagingWindow),
        ('maxDataBurstVolume', _DynamicPQIDescriptor_maxDataBurstVolume),
        ('iE-Extensions', _DynamicPQIDescriptor_iE_Extensions),
        ])
    DynamicPQIDescriptor._ext = None
    
    #-----< DynamicPQIDescriptor-ExtIEs >-----#
    DynamicPQIDescriptor_ExtIEs = CLASS(name='DynamicPQIDescriptor-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DynamicPQIDescriptor_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-CID-MeasurementQuantities >-----#
    E_CID_MeasurementQuantities = SEQ_OF(name='E-CID-MeasurementQuantities', mode=MODE_TYPE)
    _E_CID_MeasurementQuantities__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_CID_MeasurementQuantities__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___E_CID_MeasurementQuantities__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____E_CID_MeasurementQuantities__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'E-CID-MeasurementQuantities-Item')))
    ___E_CID_MeasurementQuantities__item__id_tab._val = ASN1Set(rv=[dict([('id', 415), ('criticality', 'reject'), ('Value', ____E_CID_MeasurementQuantities__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_CID_MeasurementQuantities__item__id._const_tab = ___E_CID_MeasurementQuantities__item__id_tab
    __E_CID_MeasurementQuantities__item__id._const_tab_at = None
    __E_CID_MeasurementQuantities__item__id._const_tab_id = 'id'
    __E_CID_MeasurementQuantities__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __E_CID_MeasurementQuantities__item__criticality._const_tab = ___E_CID_MeasurementQuantities__item__id_tab
    __E_CID_MeasurementQuantities__item__criticality._const_tab_at = ('..', 'id')
    __E_CID_MeasurementQuantities__item__criticality._const_tab_id = 'criticality'
    __E_CID_MeasurementQuantities__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __E_CID_MeasurementQuantities__item__value._const_tab = ___E_CID_MeasurementQuantities__item__id_tab
    __E_CID_MeasurementQuantities__item__value._const_tab_at = ('..', 'id')
    __E_CID_MeasurementQuantities__item__value._const_tab_id = 'Value'
    _E_CID_MeasurementQuantities__item_._cont = ASN1Dict([
        ('id', __E_CID_MeasurementQuantities__item__id),
        ('criticality', __E_CID_MeasurementQuantities__item__criticality),
        ('value', __E_CID_MeasurementQuantities__item__value),
        ])
    _E_CID_MeasurementQuantities__item_._ext = None
    E_CID_MeasurementQuantities._cont = _E_CID_MeasurementQuantities__item_
    E_CID_MeasurementQuantities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< E-CID-MeasurementQuantities-ItemIEs >-----#
    E_CID_MeasurementQuantities_ItemIEs = CLASS(name='E-CID-MeasurementQuantities-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _E_CID_MeasurementQuantities_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'E-CID-MeasurementQuantities-Item')))
    E_CID_MeasurementQuantities_ItemIEs._val = ASN1Set(rv=[dict([('id', 415), ('criticality', 'reject'), ('Value', _E_CID_MeasurementQuantities_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-CID-MeasurementQuantities-Item >-----#
    E_CID_MeasurementQuantities_Item = SEQ(name='E-CID-MeasurementQuantities-Item', mode=MODE_TYPE)
    _E_CID_MeasurementQuantities_Item_e_CIDmeasurementQuantitiesValue = ENUM(name='e-CIDmeasurementQuantitiesValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'E-CID-MeasurementQuantitiesValue')))
    _E_CID_MeasurementQuantities_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_CID_MeasurementQuantities_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_CID_MeasurementQuantities_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____E_CID_MeasurementQuantities_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__id._const_tab = ____E_CID_MeasurementQuantities_Item_iE_Extensions__item__id_tab
    ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_CID_MeasurementQuantities_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____E_CID_MeasurementQuantities_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab = ____E_CID_MeasurementQuantities_Item_iE_Extensions__item__criticality_tab
    ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_CID_MeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____E_CID_MeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab = ____E_CID_MeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab
    ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_CID_MeasurementQuantities_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__id),
        ('criticality', ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__extensionValue),
        ])
    __E_CID_MeasurementQuantities_Item_iE_Extensions__item_._ext = None
    _E_CID_MeasurementQuantities_Item_iE_Extensions._cont = __E_CID_MeasurementQuantities_Item_iE_Extensions__item_
    _E_CID_MeasurementQuantities_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_CID_MeasurementQuantities_Item._cont = ASN1Dict([
        ('e-CIDmeasurementQuantitiesValue', _E_CID_MeasurementQuantities_Item_e_CIDmeasurementQuantitiesValue),
        ('iE-Extensions', _E_CID_MeasurementQuantities_Item_iE_Extensions),
        ])
    E_CID_MeasurementQuantities_Item._ext = None
    
    #-----< E-CID-MeasurementQuantitiesValue-ExtIEs >-----#
    E_CID_MeasurementQuantitiesValue_ExtIEs = CLASS(name='E-CID-MeasurementQuantitiesValue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    E_CID_MeasurementQuantitiesValue_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-CID-MeasurementQuantitiesValue >-----#
    E_CID_MeasurementQuantitiesValue = ENUM(name='E-CID-MeasurementQuantitiesValue', mode=MODE_TYPE)
    E_CID_MeasurementQuantitiesValue._cont = ASN1Dict([('default', 0), ('angleOfArrivalNR', 1), ('timingAdvanceNR', 2)])
    E_CID_MeasurementQuantitiesValue._ext = ['timingAdvanceNR']
    
    #-----< E-CID-MeasurementResult >-----#
    E_CID_MeasurementResult = SEQ(name='E-CID-MeasurementResult', mode=MODE_TYPE)
    _E_CID_MeasurementResult_geographicalCoordinates = SEQ(name='geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GeographicalCoordinates')), opt=True)
    _E_CID_MeasurementResult_measuredResults_List = SEQ_OF(name='measuredResults-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'E-CID-MeasuredResults-List')), opt=True)
    _E_CID_MeasurementResult_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_CID_MeasurementResult_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___E_CID_MeasurementResult_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_CID_MeasurementResult_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____E_CID_MeasurementResult_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_CID_MeasurementResult_iE_Extensions__item__id._const_tab = ____E_CID_MeasurementResult_iE_Extensions__item__id_tab
    ___E_CID_MeasurementResult_iE_Extensions__item__id._const_tab_at = None
    ___E_CID_MeasurementResult_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_CID_MeasurementResult_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_CID_MeasurementResult_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____E_CID_MeasurementResult_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_CID_MeasurementResult_iE_Extensions__item__criticality._const_tab = ____E_CID_MeasurementResult_iE_Extensions__item__criticality_tab
    ___E_CID_MeasurementResult_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_CID_MeasurementResult_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_CID_MeasurementResult_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_CID_MeasurementResult_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____E_CID_MeasurementResult_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_CID_MeasurementResult_iE_Extensions__item__extensionValue._const_tab = ____E_CID_MeasurementResult_iE_Extensions__item__extensionValue_tab
    ___E_CID_MeasurementResult_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_CID_MeasurementResult_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_CID_MeasurementResult_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_CID_MeasurementResult_iE_Extensions__item__id),
        ('criticality', ___E_CID_MeasurementResult_iE_Extensions__item__criticality),
        ('extensionValue', ___E_CID_MeasurementResult_iE_Extensions__item__extensionValue),
        ])
    __E_CID_MeasurementResult_iE_Extensions__item_._ext = None
    _E_CID_MeasurementResult_iE_Extensions._cont = __E_CID_MeasurementResult_iE_Extensions__item_
    _E_CID_MeasurementResult_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_CID_MeasurementResult._cont = ASN1Dict([
        ('geographicalCoordinates', _E_CID_MeasurementResult_geographicalCoordinates),
        ('measuredResults-List', _E_CID_MeasurementResult_measuredResults_List),
        ('iE-Extensions', _E_CID_MeasurementResult_iE_Extensions),
        ])
    E_CID_MeasurementResult._ext = None
    
    #-----< E-CID-MeasurementResult-ExtIEs >-----#
    E_CID_MeasurementResult_ExtIEs = CLASS(name='E-CID-MeasurementResult-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    E_CID_MeasurementResult_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-CID-MeasuredResults-List >-----#
    E_CID_MeasuredResults_List = SEQ_OF(name='E-CID-MeasuredResults-List', mode=MODE_TYPE)
    _E_CID_MeasuredResults_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'E-CID-MeasuredResults-Item')))
    E_CID_MeasuredResults_List._cont = _E_CID_MeasuredResults_List__item_
    E_CID_MeasuredResults_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< E-CID-MeasuredResults-Item >-----#
    E_CID_MeasuredResults_Item = SEQ(name='E-CID-MeasuredResults-Item', mode=MODE_TYPE)
    _E_CID_MeasuredResults_Item_e_CID_MeasuredResults_Value = CHOICE(name='e-CID-MeasuredResults-Value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'E-CID-MeasuredResults-Value')))
    _E_CID_MeasuredResults_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_CID_MeasuredResults_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___E_CID_MeasuredResults_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_CID_MeasuredResults_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____E_CID_MeasuredResults_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_CID_MeasuredResults_Item_iE_Extensions__item__id._const_tab = ____E_CID_MeasuredResults_Item_iE_Extensions__item__id_tab
    ___E_CID_MeasuredResults_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_CID_MeasuredResults_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_CID_MeasuredResults_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_CID_MeasuredResults_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____E_CID_MeasuredResults_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_CID_MeasuredResults_Item_iE_Extensions__item__criticality._const_tab = ____E_CID_MeasuredResults_Item_iE_Extensions__item__criticality_tab
    ___E_CID_MeasuredResults_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_CID_MeasuredResults_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_CID_MeasuredResults_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_CID_MeasuredResults_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____E_CID_MeasuredResults_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_CID_MeasuredResults_Item_iE_Extensions__item__extensionValue._const_tab = ____E_CID_MeasuredResults_Item_iE_Extensions__item__extensionValue_tab
    ___E_CID_MeasuredResults_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_CID_MeasuredResults_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_CID_MeasuredResults_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_CID_MeasuredResults_Item_iE_Extensions__item__id),
        ('criticality', ___E_CID_MeasuredResults_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_CID_MeasuredResults_Item_iE_Extensions__item__extensionValue),
        ])
    __E_CID_MeasuredResults_Item_iE_Extensions__item_._ext = None
    _E_CID_MeasuredResults_Item_iE_Extensions._cont = __E_CID_MeasuredResults_Item_iE_Extensions__item_
    _E_CID_MeasuredResults_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_CID_MeasuredResults_Item._cont = ASN1Dict([
        ('e-CID-MeasuredResults-Value', _E_CID_MeasuredResults_Item_e_CID_MeasuredResults_Value),
        ('iE-Extensions', _E_CID_MeasuredResults_Item_iE_Extensions),
        ])
    E_CID_MeasuredResults_Item._ext = None
    
    #-----< E-CID-MeasuredResults-Item-ExtIEs >-----#
    E_CID_MeasuredResults_Item_ExtIEs = CLASS(name='E-CID-MeasuredResults-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    E_CID_MeasuredResults_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-CID-MeasuredResults-Value >-----#
    E_CID_MeasuredResults_Value = CHOICE(name='E-CID-MeasuredResults-Value', mode=MODE_TYPE)
    _E_CID_MeasuredResults_Value_valueAngleofArrivalNR = SEQ(name='valueAngleofArrivalNR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UL-AoA')))
    _E_CID_MeasuredResults_Value_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_CID_MeasuredResults_Value_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___E_CID_MeasuredResults_Value_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____E_CID_MeasuredResults_Value_choice_extension_id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NR-TADV')))
    ___E_CID_MeasuredResults_Value_choice_extension_id_tab._val = ASN1Set(rv=[dict([('id', 584), ('criticality', 'ignore'), ('Value', ____E_CID_MeasuredResults_Value_choice_extension_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_CID_MeasuredResults_Value_choice_extension_id._const_tab = ___E_CID_MeasuredResults_Value_choice_extension_id_tab
    __E_CID_MeasuredResults_Value_choice_extension_id._const_tab_at = None
    __E_CID_MeasuredResults_Value_choice_extension_id._const_tab_id = 'id'
    __E_CID_MeasuredResults_Value_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __E_CID_MeasuredResults_Value_choice_extension_criticality._const_tab = ___E_CID_MeasuredResults_Value_choice_extension_id_tab
    __E_CID_MeasuredResults_Value_choice_extension_criticality._const_tab_at = ('..', 'id')
    __E_CID_MeasuredResults_Value_choice_extension_criticality._const_tab_id = 'criticality'
    __E_CID_MeasuredResults_Value_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __E_CID_MeasuredResults_Value_choice_extension_value._const_tab = ___E_CID_MeasuredResults_Value_choice_extension_id_tab
    __E_CID_MeasuredResults_Value_choice_extension_value._const_tab_at = ('..', 'id')
    __E_CID_MeasuredResults_Value_choice_extension_value._const_tab_id = 'Value'
    _E_CID_MeasuredResults_Value_choice_extension._cont = ASN1Dict([
        ('id', __E_CID_MeasuredResults_Value_choice_extension_id),
        ('criticality', __E_CID_MeasuredResults_Value_choice_extension_criticality),
        ('value', __E_CID_MeasuredResults_Value_choice_extension_value),
        ])
    _E_CID_MeasuredResults_Value_choice_extension._ext = None
    E_CID_MeasuredResults_Value._cont = ASN1Dict([
        ('valueAngleofArrivalNR', _E_CID_MeasuredResults_Value_valueAngleofArrivalNR),
        ('choice-extension', _E_CID_MeasuredResults_Value_choice_extension),
        ])
    E_CID_MeasuredResults_Value._ext = None
    
    #-----< E-CID-MeasuredResults-Value-ExtIEs >-----#
    E_CID_MeasuredResults_Value_ExtIEs = CLASS(name='E-CID-MeasuredResults-Value-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _E_CID_MeasuredResults_Value_ExtIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NR-TADV')))
    E_CID_MeasuredResults_Value_ExtIEs._val = ASN1Set(rv=[dict([('id', 584), ('criticality', 'ignore'), ('Value', _E_CID_MeasuredResults_Value_ExtIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-CID-ReportCharacteristics >-----#
    E_CID_ReportCharacteristics = ENUM(name='E-CID-ReportCharacteristics', mode=MODE_TYPE)
    E_CID_ReportCharacteristics._cont = ASN1Dict([('onDemand', 0), ('periodic', 1)])
    E_CID_ReportCharacteristics._ext = []
    
    #-----< EgressBHRLCCHList >-----#
    EgressBHRLCCHList = SEQ_OF(name='EgressBHRLCCHList', mode=MODE_TYPE)
    _EgressBHRLCCHList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'EgressBHRLCCHItem')))
    EgressBHRLCCHList._cont = _EgressBHRLCCHList__item_
    EgressBHRLCCHList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< EgressBHRLCCHItem >-----#
    EgressBHRLCCHItem = SEQ(name='EgressBHRLCCHItem', mode=MODE_TYPE)
    _EgressBHRLCCHItem_nextHopBAPAddress = BIT_STR(name='nextHopBAPAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    _EgressBHRLCCHItem_bHRLCChannelID = BIT_STR(name='bHRLCChannelID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCChannelID')))
    _EgressBHRLCCHItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EgressBHRLCCHItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___EgressBHRLCCHItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____EgressBHRLCCHItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EgressBHRLCCHItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EgressBHRLCCHItem_iE_Extensions__item__id._const_tab = ____EgressBHRLCCHItem_iE_Extensions__item__id_tab
    ___EgressBHRLCCHItem_iE_Extensions__item__id._const_tab_at = None
    ___EgressBHRLCCHItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___EgressBHRLCCHItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EgressBHRLCCHItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EgressBHRLCCHItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EgressBHRLCCHItem_iE_Extensions__item__criticality._const_tab = ____EgressBHRLCCHItem_iE_Extensions__item__criticality_tab
    ___EgressBHRLCCHItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EgressBHRLCCHItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EgressBHRLCCHItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EgressBHRLCCHItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EgressBHRLCCHItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EgressBHRLCCHItem_iE_Extensions__item__extensionValue._const_tab = ____EgressBHRLCCHItem_iE_Extensions__item__extensionValue_tab
    ___EgressBHRLCCHItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EgressBHRLCCHItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EgressBHRLCCHItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EgressBHRLCCHItem_iE_Extensions__item__id),
        ('criticality', ___EgressBHRLCCHItem_iE_Extensions__item__criticality),
        ('extensionValue', ___EgressBHRLCCHItem_iE_Extensions__item__extensionValue),
        ])
    __EgressBHRLCCHItem_iE_Extensions__item_._ext = None
    _EgressBHRLCCHItem_iE_Extensions._cont = __EgressBHRLCCHItem_iE_Extensions__item_
    _EgressBHRLCCHItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EgressBHRLCCHItem._cont = ASN1Dict([
        ('nextHopBAPAddress', _EgressBHRLCCHItem_nextHopBAPAddress),
        ('bHRLCChannelID', _EgressBHRLCCHItem_bHRLCChannelID),
        ('iE-Extensions', _EgressBHRLCCHItem_iE_Extensions),
        ])
    EgressBHRLCCHItem._ext = None
    
    #-----< EgressBHRLCCHItemExtIEs >-----#
    EgressBHRLCCHItemExtIEs = CLASS(name='EgressBHRLCCHItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    EgressBHRLCCHItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EgressNonF1terminatingTopologyIndicator >-----#
    EgressNonF1terminatingTopologyIndicator = ENUM(name='EgressNonF1terminatingTopologyIndicator', mode=MODE_TYPE)
    EgressNonF1terminatingTopologyIndicator._cont = ASN1Dict([('true', 0)])
    EgressNonF1terminatingTopologyIndicator._ext = []
    
    #-----< Endpoint-IP-address-and-port >-----#
    Endpoint_IP_address_and_port = SEQ(name='Endpoint-IP-address-and-port', mode=MODE_TYPE)
    _Endpoint_IP_address_and_port_endpointIPAddress = BIT_STR(name='endpointIPAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _Endpoint_IP_address_and_port_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Endpoint_IP_address_and_port_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Endpoint_IP_address_and_port_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Endpoint_IP_address_and_port_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____Endpoint_IP_address_and_port_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PortNumber')))
    ____Endpoint_IP_address_and_port_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 230), ('criticality', 'reject'), ('Extension', _____Endpoint_IP_address_and_port_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Endpoint_IP_address_and_port_iE_Extensions__item__id._const_tab = ____Endpoint_IP_address_and_port_iE_Extensions__item__id_tab
    ___Endpoint_IP_address_and_port_iE_Extensions__item__id._const_tab_at = None
    ___Endpoint_IP_address_and_port_iE_Extensions__item__id._const_tab_id = 'id'
    ___Endpoint_IP_address_and_port_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Endpoint_IP_address_and_port_iE_Extensions__item__criticality._const_tab = ____Endpoint_IP_address_and_port_iE_Extensions__item__id_tab
    ___Endpoint_IP_address_and_port_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Endpoint_IP_address_and_port_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Endpoint_IP_address_and_port_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Endpoint_IP_address_and_port_iE_Extensions__item__extensionValue._const_tab = ____Endpoint_IP_address_and_port_iE_Extensions__item__id_tab
    ___Endpoint_IP_address_and_port_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Endpoint_IP_address_and_port_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Endpoint_IP_address_and_port_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Endpoint_IP_address_and_port_iE_Extensions__item__id),
        ('criticality', ___Endpoint_IP_address_and_port_iE_Extensions__item__criticality),
        ('extensionValue', ___Endpoint_IP_address_and_port_iE_Extensions__item__extensionValue),
        ])
    __Endpoint_IP_address_and_port_iE_Extensions__item_._ext = None
    _Endpoint_IP_address_and_port_iE_Extensions._cont = __Endpoint_IP_address_and_port_iE_Extensions__item_
    _Endpoint_IP_address_and_port_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Endpoint_IP_address_and_port._cont = ASN1Dict([
        ('endpointIPAddress', _Endpoint_IP_address_and_port_endpointIPAddress),
        ('iE-Extensions', _Endpoint_IP_address_and_port_iE_Extensions),
        ])
    Endpoint_IP_address_and_port._ext = None
    
    #-----< Endpoint-IP-address-and-port-ExtIEs >-----#
    Endpoint_IP_address_and_port_ExtIEs = CLASS(name='Endpoint-IP-address-and-port-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _Endpoint_IP_address_and_port_ExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PortNumber')))
    Endpoint_IP_address_and_port_ExtIEs._val = ASN1Set(rv=[dict([('id', 230), ('criticality', 'reject'), ('Extension', _Endpoint_IP_address_and_port_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< EnergyDetectionThreshold >-----#
    EnergyDetectionThreshold = INT(name='EnergyDetectionThreshold', mode=MODE_TYPE)
    EnergyDetectionThreshold._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-100, ub=-50)], ev=[], er=[])
    
    #-----< ExtendedAvailablePLMN-List >-----#
    ExtendedAvailablePLMN_List = SEQ_OF(name='ExtendedAvailablePLMN-List', mode=MODE_TYPE)
    _ExtendedAvailablePLMN_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedAvailablePLMN-Item')))
    ExtendedAvailablePLMN_List._cont = _ExtendedAvailablePLMN_List__item_
    ExtendedAvailablePLMN_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< ExtendedAvailablePLMN-Item >-----#
    ExtendedAvailablePLMN_Item = SEQ(name='ExtendedAvailablePLMN-Item', mode=MODE_TYPE)
    _ExtendedAvailablePLMN_Item_pLMNIdentity = OCT_STR(name='pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _ExtendedAvailablePLMN_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExtendedAvailablePLMN_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ExtendedAvailablePLMN_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ExtendedAvailablePLMN_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ExtendedAvailablePLMN_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtendedAvailablePLMN_Item_iE_Extensions__item__id._const_tab = ____ExtendedAvailablePLMN_Item_iE_Extensions__item__id_tab
    ___ExtendedAvailablePLMN_Item_iE_Extensions__item__id._const_tab_at = None
    ___ExtendedAvailablePLMN_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ExtendedAvailablePLMN_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ExtendedAvailablePLMN_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ExtendedAvailablePLMN_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtendedAvailablePLMN_Item_iE_Extensions__item__criticality._const_tab = ____ExtendedAvailablePLMN_Item_iE_Extensions__item__criticality_tab
    ___ExtendedAvailablePLMN_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ExtendedAvailablePLMN_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ExtendedAvailablePLMN_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ExtendedAvailablePLMN_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ExtendedAvailablePLMN_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtendedAvailablePLMN_Item_iE_Extensions__item__extensionValue._const_tab = ____ExtendedAvailablePLMN_Item_iE_Extensions__item__extensionValue_tab
    ___ExtendedAvailablePLMN_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ExtendedAvailablePLMN_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ExtendedAvailablePLMN_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ExtendedAvailablePLMN_Item_iE_Extensions__item__id),
        ('criticality', ___ExtendedAvailablePLMN_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ExtendedAvailablePLMN_Item_iE_Extensions__item__extensionValue),
        ])
    __ExtendedAvailablePLMN_Item_iE_Extensions__item_._ext = None
    _ExtendedAvailablePLMN_Item_iE_Extensions._cont = __ExtendedAvailablePLMN_Item_iE_Extensions__item_
    _ExtendedAvailablePLMN_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExtendedAvailablePLMN_Item._cont = ASN1Dict([
        ('pLMNIdentity', _ExtendedAvailablePLMN_Item_pLMNIdentity),
        ('iE-Extensions', _ExtendedAvailablePLMN_Item_iE_Extensions),
        ])
    ExtendedAvailablePLMN_Item._ext = None
    
    #-----< ExplicitFormat >-----#
    ExplicitFormat = SEQ(name='ExplicitFormat', mode=MODE_TYPE)
    _ExplicitFormat_permutation = ENUM(name='permutation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Permutation')))
    _ExplicitFormat_noofDownlinkSymbols = INT(name='noofDownlinkSymbols', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NoofDownlinkSymbols')), opt=True)
    _ExplicitFormat_noofUplinkSymbols = INT(name='noofUplinkSymbols', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NoofUplinkSymbols')), opt=True)
    _ExplicitFormat_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExplicitFormat_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ExplicitFormat_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ExplicitFormat_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ExplicitFormat_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExplicitFormat_iE_Extensions__item__id._const_tab = ____ExplicitFormat_iE_Extensions__item__id_tab
    ___ExplicitFormat_iE_Extensions__item__id._const_tab_at = None
    ___ExplicitFormat_iE_Extensions__item__id._const_tab_id = 'id'
    ___ExplicitFormat_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ExplicitFormat_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ExplicitFormat_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExplicitFormat_iE_Extensions__item__criticality._const_tab = ____ExplicitFormat_iE_Extensions__item__criticality_tab
    ___ExplicitFormat_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ExplicitFormat_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ExplicitFormat_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ExplicitFormat_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ExplicitFormat_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExplicitFormat_iE_Extensions__item__extensionValue._const_tab = ____ExplicitFormat_iE_Extensions__item__extensionValue_tab
    ___ExplicitFormat_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ExplicitFormat_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ExplicitFormat_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ExplicitFormat_iE_Extensions__item__id),
        ('criticality', ___ExplicitFormat_iE_Extensions__item__criticality),
        ('extensionValue', ___ExplicitFormat_iE_Extensions__item__extensionValue),
        ])
    __ExplicitFormat_iE_Extensions__item_._ext = None
    _ExplicitFormat_iE_Extensions._cont = __ExplicitFormat_iE_Extensions__item_
    _ExplicitFormat_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExplicitFormat._cont = ASN1Dict([
        ('permutation', _ExplicitFormat_permutation),
        ('noofDownlinkSymbols', _ExplicitFormat_noofDownlinkSymbols),
        ('noofUplinkSymbols', _ExplicitFormat_noofUplinkSymbols),
        ('iE-Extensions', _ExplicitFormat_iE_Extensions),
        ])
    ExplicitFormat._ext = None
    
    #-----< ExplicitFormat-ExtIEs >-----#
    ExplicitFormat_ExtIEs = CLASS(name='ExplicitFormat-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ExplicitFormat_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExtendedAvailablePLMN-Item-ExtIEs >-----#
    ExtendedAvailablePLMN_Item_ExtIEs = CLASS(name='ExtendedAvailablePLMN-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ExtendedAvailablePLMN_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExtendedServedPLMNs-List >-----#
    ExtendedServedPLMNs_List = SEQ_OF(name='ExtendedServedPLMNs-List', mode=MODE_TYPE)
    _ExtendedServedPLMNs_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedServedPLMNs-Item')))
    ExtendedServedPLMNs_List._cont = _ExtendedServedPLMNs_List__item_
    ExtendedServedPLMNs_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< ExtendedServedPLMNs-Item >-----#
    ExtendedServedPLMNs_Item = SEQ(name='ExtendedServedPLMNs-Item', mode=MODE_TYPE)
    _ExtendedServedPLMNs_Item_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _ExtendedServedPLMNs_Item_tAISliceSupportList = SEQ_OF(name='tAISliceSupportList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SliceSupportList')), opt=True)
    _ExtendedServedPLMNs_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExtendedServedPLMNs_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ExtendedServedPLMNs_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NPNSupportInfo')))
    _____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedSliceSupportList')))
    _____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NSAGSupportList')))
    ____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 384), ('criticality', 'reject'), ('Extension', _____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 390), ('criticality', 'reject'), ('Extension', _____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 644), ('criticality', 'ignore'), ('Extension', _____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ExtendedServedPLMNs_Item_iE_Extensions__item__id._const_tab = ____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab
    ___ExtendedServedPLMNs_Item_iE_Extensions__item__id._const_tab_at = None
    ___ExtendedServedPLMNs_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ExtendedServedPLMNs_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ExtendedServedPLMNs_Item_iE_Extensions__item__criticality._const_tab = ____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab
    ___ExtendedServedPLMNs_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ExtendedServedPLMNs_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ExtendedServedPLMNs_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ExtendedServedPLMNs_Item_iE_Extensions__item__extensionValue._const_tab = ____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab
    ___ExtendedServedPLMNs_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ExtendedServedPLMNs_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ExtendedServedPLMNs_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ExtendedServedPLMNs_Item_iE_Extensions__item__id),
        ('criticality', ___ExtendedServedPLMNs_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ExtendedServedPLMNs_Item_iE_Extensions__item__extensionValue),
        ])
    __ExtendedServedPLMNs_Item_iE_Extensions__item_._ext = None
    _ExtendedServedPLMNs_Item_iE_Extensions._cont = __ExtendedServedPLMNs_Item_iE_Extensions__item_
    _ExtendedServedPLMNs_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExtendedServedPLMNs_Item._cont = ASN1Dict([
        ('pLMN-Identity', _ExtendedServedPLMNs_Item_pLMN_Identity),
        ('tAISliceSupportList', _ExtendedServedPLMNs_Item_tAISliceSupportList),
        ('iE-Extensions', _ExtendedServedPLMNs_Item_iE_Extensions),
        ])
    ExtendedServedPLMNs_Item._ext = []
    
    #-----< ExtendedServedPLMNs-ItemExtIEs >-----#
    ExtendedServedPLMNs_ItemExtIEs = CLASS(name='ExtendedServedPLMNs-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _ExtendedServedPLMNs_ItemExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NPNSupportInfo')))
    _ExtendedServedPLMNs_ItemExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedSliceSupportList')))
    _ExtendedServedPLMNs_ItemExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NSAGSupportList')))
    ExtendedServedPLMNs_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 384), ('criticality', 'reject'), ('Extension', _ExtendedServedPLMNs_ItemExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 390), ('criticality', 'reject'), ('Extension', _ExtendedServedPLMNs_ItemExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 644), ('criticality', 'ignore'), ('Extension', _ExtendedServedPLMNs_ItemExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ExtendedSliceSupportList >-----#
    ExtendedSliceSupportList = SEQ_OF(name='ExtendedSliceSupportList', mode=MODE_TYPE)
    _ExtendedSliceSupportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SliceSupportItem')))
    ExtendedSliceSupportList._cont = _ExtendedSliceSupportList__item_
    ExtendedSliceSupportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< ExtendedUEIdentityIndexValue >-----#
    ExtendedUEIdentityIndexValue = BIT_STR(name='ExtendedUEIdentityIndexValue', mode=MODE_TYPE)
    ExtendedUEIdentityIndexValue._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< EUTRACells-List >-----#
    EUTRACells_List = SEQ_OF(name='EUTRACells-List', mode=MODE_TYPE)
    _EUTRACells_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'EUTRACells-List-item')))
    EUTRACells_List._cont = _EUTRACells_List__item_
    EUTRACells_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< EUTRACells-List-item >-----#
    EUTRACells_List_item = SEQ(name='EUTRACells-List-item', mode=MODE_TYPE)
    _EUTRACells_List_item_eUTRA_Cell_ID = BIT_STR(name='eUTRA-Cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-Cell-ID')))
    _EUTRACells_List_item_served_EUTRA_Cells_Information = SEQ(name='served-EUTRA-Cells-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Served-EUTRA-Cells-Information')))
    _EUTRACells_List_item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRACells_List_item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___EUTRACells_List_item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____EUTRACells_List_item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRACells_List_item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRACells_List_item_iE_Extensions__item__id._const_tab = ____EUTRACells_List_item_iE_Extensions__item__id_tab
    ___EUTRACells_List_item_iE_Extensions__item__id._const_tab_at = None
    ___EUTRACells_List_item_iE_Extensions__item__id._const_tab_id = 'id'
    ___EUTRACells_List_item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EUTRACells_List_item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRACells_List_item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRACells_List_item_iE_Extensions__item__criticality._const_tab = ____EUTRACells_List_item_iE_Extensions__item__criticality_tab
    ___EUTRACells_List_item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EUTRACells_List_item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EUTRACells_List_item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EUTRACells_List_item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRACells_List_item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRACells_List_item_iE_Extensions__item__extensionValue._const_tab = ____EUTRACells_List_item_iE_Extensions__item__extensionValue_tab
    ___EUTRACells_List_item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EUTRACells_List_item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EUTRACells_List_item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EUTRACells_List_item_iE_Extensions__item__id),
        ('criticality', ___EUTRACells_List_item_iE_Extensions__item__criticality),
        ('extensionValue', ___EUTRACells_List_item_iE_Extensions__item__extensionValue),
        ])
    __EUTRACells_List_item_iE_Extensions__item_._ext = None
    _EUTRACells_List_item_iE_Extensions._cont = __EUTRACells_List_item_iE_Extensions__item_
    _EUTRACells_List_item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRACells_List_item._cont = ASN1Dict([
        ('eUTRA-Cell-ID', _EUTRACells_List_item_eUTRA_Cell_ID),
        ('served-EUTRA-Cells-Information', _EUTRACells_List_item_served_EUTRA_Cells_Information),
        ('iE-Extensions', _EUTRACells_List_item_iE_Extensions),
        ])
    EUTRACells_List_item._ext = None
    
    #-----< EUTRACells-List-itemExtIEs >-----#
    EUTRACells_List_itemExtIEs = CLASS(name='EUTRACells-List-itemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    EUTRACells_List_itemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRA-Cell-ID >-----#
    EUTRA_Cell_ID = BIT_STR(name='EUTRA-Cell-ID', mode=MODE_TYPE)
    EUTRA_Cell_ID._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    
    #-----< EUTRA-Coex-FDD-Info >-----#
    EUTRA_Coex_FDD_Info = SEQ(name='EUTRA-Coex-FDD-Info', mode=MODE_TYPE)
    _EUTRA_Coex_FDD_Info_uL_EARFCN = INT(name='uL-EARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ExtendedEARFCN')), opt=True)
    _EUTRA_Coex_FDD_Info_dL_EARFCN = INT(name='dL-EARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ExtendedEARFCN')))
    _EUTRA_Coex_FDD_Info_uL_Transmission_Bandwidth = ENUM(name='uL-Transmission-Bandwidth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-Transmission-Bandwidth')), opt=True)
    _EUTRA_Coex_FDD_Info_dL_Transmission_Bandwidth = ENUM(name='dL-Transmission-Bandwidth', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-Transmission-Bandwidth')))
    _EUTRA_Coex_FDD_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRA_Coex_FDD_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___EUTRA_Coex_FDD_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____EUTRA_Coex_FDD_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_Coex_FDD_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_Coex_FDD_Info_iE_Extensions__item__id._const_tab = ____EUTRA_Coex_FDD_Info_iE_Extensions__item__id_tab
    ___EUTRA_Coex_FDD_Info_iE_Extensions__item__id._const_tab_at = None
    ___EUTRA_Coex_FDD_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___EUTRA_Coex_FDD_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EUTRA_Coex_FDD_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_Coex_FDD_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_Coex_FDD_Info_iE_Extensions__item__criticality._const_tab = ____EUTRA_Coex_FDD_Info_iE_Extensions__item__criticality_tab
    ___EUTRA_Coex_FDD_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EUTRA_Coex_FDD_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EUTRA_Coex_FDD_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EUTRA_Coex_FDD_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_Coex_FDD_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_Coex_FDD_Info_iE_Extensions__item__extensionValue._const_tab = ____EUTRA_Coex_FDD_Info_iE_Extensions__item__extensionValue_tab
    ___EUTRA_Coex_FDD_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EUTRA_Coex_FDD_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EUTRA_Coex_FDD_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EUTRA_Coex_FDD_Info_iE_Extensions__item__id),
        ('criticality', ___EUTRA_Coex_FDD_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___EUTRA_Coex_FDD_Info_iE_Extensions__item__extensionValue),
        ])
    __EUTRA_Coex_FDD_Info_iE_Extensions__item_._ext = None
    _EUTRA_Coex_FDD_Info_iE_Extensions._cont = __EUTRA_Coex_FDD_Info_iE_Extensions__item_
    _EUTRA_Coex_FDD_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRA_Coex_FDD_Info._cont = ASN1Dict([
        ('uL-EARFCN', _EUTRA_Coex_FDD_Info_uL_EARFCN),
        ('dL-EARFCN', _EUTRA_Coex_FDD_Info_dL_EARFCN),
        ('uL-Transmission-Bandwidth', _EUTRA_Coex_FDD_Info_uL_Transmission_Bandwidth),
        ('dL-Transmission-Bandwidth', _EUTRA_Coex_FDD_Info_dL_Transmission_Bandwidth),
        ('iE-Extensions', _EUTRA_Coex_FDD_Info_iE_Extensions),
        ])
    EUTRA_Coex_FDD_Info._ext = []
    
    #-----< EUTRA-Coex-FDD-Info-ExtIEs >-----#
    EUTRA_Coex_FDD_Info_ExtIEs = CLASS(name='EUTRA-Coex-FDD-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    EUTRA_Coex_FDD_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRA-Coex-Mode-Info >-----#
    EUTRA_Coex_Mode_Info = CHOICE(name='EUTRA-Coex-Mode-Info', mode=MODE_TYPE)
    _EUTRA_Coex_Mode_Info_fDD = SEQ(name='fDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-Coex-FDD-Info')))
    _EUTRA_Coex_Mode_Info_tDD = SEQ(name='tDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-Coex-TDD-Info')))
    EUTRA_Coex_Mode_Info._cont = ASN1Dict([
        ('fDD', _EUTRA_Coex_Mode_Info_fDD),
        ('tDD', _EUTRA_Coex_Mode_Info_tDD),
        ])
    EUTRA_Coex_Mode_Info._ext = []
    
    #-----< EUTRA-Coex-TDD-Info >-----#
    EUTRA_Coex_TDD_Info = SEQ(name='EUTRA-Coex-TDD-Info', mode=MODE_TYPE)
    _EUTRA_Coex_TDD_Info_eARFCN = INT(name='eARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ExtendedEARFCN')))
    _EUTRA_Coex_TDD_Info_transmission_Bandwidth = ENUM(name='transmission-Bandwidth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-Transmission-Bandwidth')))
    _EUTRA_Coex_TDD_Info_subframeAssignment = ENUM(name='subframeAssignment', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-SubframeAssignment')))
    _EUTRA_Coex_TDD_Info_specialSubframe_Info = SEQ(name='specialSubframe-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-SpecialSubframe-Info')))
    _EUTRA_Coex_TDD_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRA_Coex_TDD_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___EUTRA_Coex_TDD_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____EUTRA_Coex_TDD_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_Coex_TDD_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_Coex_TDD_Info_iE_Extensions__item__id._const_tab = ____EUTRA_Coex_TDD_Info_iE_Extensions__item__id_tab
    ___EUTRA_Coex_TDD_Info_iE_Extensions__item__id._const_tab_at = None
    ___EUTRA_Coex_TDD_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___EUTRA_Coex_TDD_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EUTRA_Coex_TDD_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_Coex_TDD_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_Coex_TDD_Info_iE_Extensions__item__criticality._const_tab = ____EUTRA_Coex_TDD_Info_iE_Extensions__item__criticality_tab
    ___EUTRA_Coex_TDD_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EUTRA_Coex_TDD_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EUTRA_Coex_TDD_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EUTRA_Coex_TDD_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_Coex_TDD_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_Coex_TDD_Info_iE_Extensions__item__extensionValue._const_tab = ____EUTRA_Coex_TDD_Info_iE_Extensions__item__extensionValue_tab
    ___EUTRA_Coex_TDD_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EUTRA_Coex_TDD_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EUTRA_Coex_TDD_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EUTRA_Coex_TDD_Info_iE_Extensions__item__id),
        ('criticality', ___EUTRA_Coex_TDD_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___EUTRA_Coex_TDD_Info_iE_Extensions__item__extensionValue),
        ])
    __EUTRA_Coex_TDD_Info_iE_Extensions__item_._ext = None
    _EUTRA_Coex_TDD_Info_iE_Extensions._cont = __EUTRA_Coex_TDD_Info_iE_Extensions__item_
    _EUTRA_Coex_TDD_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRA_Coex_TDD_Info._cont = ASN1Dict([
        ('eARFCN', _EUTRA_Coex_TDD_Info_eARFCN),
        ('transmission-Bandwidth', _EUTRA_Coex_TDD_Info_transmission_Bandwidth),
        ('subframeAssignment', _EUTRA_Coex_TDD_Info_subframeAssignment),
        ('specialSubframe-Info', _EUTRA_Coex_TDD_Info_specialSubframe_Info),
        ('iE-Extensions', _EUTRA_Coex_TDD_Info_iE_Extensions),
        ])
    EUTRA_Coex_TDD_Info._ext = []
    
    #-----< EUTRA-Coex-TDD-Info-ExtIEs >-----#
    EUTRA_Coex_TDD_Info_ExtIEs = CLASS(name='EUTRA-Coex-TDD-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    EUTRA_Coex_TDD_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRA-CyclicPrefixDL >-----#
    EUTRA_CyclicPrefixDL = ENUM(name='EUTRA-CyclicPrefixDL', mode=MODE_TYPE)
    EUTRA_CyclicPrefixDL._cont = ASN1Dict([('normal', 0), ('extended', 1)])
    EUTRA_CyclicPrefixDL._ext = []
    
    #-----< EUTRA-CyclicPrefixUL >-----#
    EUTRA_CyclicPrefixUL = ENUM(name='EUTRA-CyclicPrefixUL', mode=MODE_TYPE)
    EUTRA_CyclicPrefixUL._cont = ASN1Dict([('normal', 0), ('extended', 1)])
    EUTRA_CyclicPrefixUL._ext = []
    
    #-----< EUTRA-PRACH-Configuration >-----#
    EUTRA_PRACH_Configuration = SEQ(name='EUTRA-PRACH-Configuration', mode=MODE_TYPE)
    _EUTRA_PRACH_Configuration_rootSequenceIndex = INT(name='rootSequenceIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EUTRA_PRACH_Configuration_rootSequenceIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=837)], ev=None, er=[])
    _EUTRA_PRACH_Configuration_zeroCorrelationIndex = INT(name='zeroCorrelationIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EUTRA_PRACH_Configuration_zeroCorrelationIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _EUTRA_PRACH_Configuration_highSpeedFlag = BOOL(name='highSpeedFlag', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EUTRA_PRACH_Configuration_prach_FreqOffset = INT(name='prach-FreqOffset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EUTRA_PRACH_Configuration_prach_FreqOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=94)], ev=None, er=[])
    _EUTRA_PRACH_Configuration_prach_ConfigIndex = INT(name='prach-ConfigIndex', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EUTRA_PRACH_Configuration_prach_ConfigIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _EUTRA_PRACH_Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRA_PRACH_Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___EUTRA_PRACH_Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____EUTRA_PRACH_Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_PRACH_Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_PRACH_Configuration_iE_Extensions__item__id._const_tab = ____EUTRA_PRACH_Configuration_iE_Extensions__item__id_tab
    ___EUTRA_PRACH_Configuration_iE_Extensions__item__id._const_tab_at = None
    ___EUTRA_PRACH_Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___EUTRA_PRACH_Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EUTRA_PRACH_Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_PRACH_Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_PRACH_Configuration_iE_Extensions__item__criticality._const_tab = ____EUTRA_PRACH_Configuration_iE_Extensions__item__criticality_tab
    ___EUTRA_PRACH_Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EUTRA_PRACH_Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EUTRA_PRACH_Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EUTRA_PRACH_Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_PRACH_Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_PRACH_Configuration_iE_Extensions__item__extensionValue._const_tab = ____EUTRA_PRACH_Configuration_iE_Extensions__item__extensionValue_tab
    ___EUTRA_PRACH_Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EUTRA_PRACH_Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EUTRA_PRACH_Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EUTRA_PRACH_Configuration_iE_Extensions__item__id),
        ('criticality', ___EUTRA_PRACH_Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___EUTRA_PRACH_Configuration_iE_Extensions__item__extensionValue),
        ])
    __EUTRA_PRACH_Configuration_iE_Extensions__item_._ext = None
    _EUTRA_PRACH_Configuration_iE_Extensions._cont = __EUTRA_PRACH_Configuration_iE_Extensions__item_
    _EUTRA_PRACH_Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRA_PRACH_Configuration._cont = ASN1Dict([
        ('rootSequenceIndex', _EUTRA_PRACH_Configuration_rootSequenceIndex),
        ('zeroCorrelationIndex', _EUTRA_PRACH_Configuration_zeroCorrelationIndex),
        ('highSpeedFlag', _EUTRA_PRACH_Configuration_highSpeedFlag),
        ('prach-FreqOffset', _EUTRA_PRACH_Configuration_prach_FreqOffset),
        ('prach-ConfigIndex', _EUTRA_PRACH_Configuration_prach_ConfigIndex),
        ('iE-Extensions', _EUTRA_PRACH_Configuration_iE_Extensions),
        ])
    EUTRA_PRACH_Configuration._ext = []
    
    #-----< EUTRA-PRACH-Configuration-ExtIEs >-----#
    EUTRA_PRACH_Configuration_ExtIEs = CLASS(name='EUTRA-PRACH-Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    EUTRA_PRACH_Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRA-SpecialSubframe-Info >-----#
    EUTRA_SpecialSubframe_Info = SEQ(name='EUTRA-SpecialSubframe-Info', mode=MODE_TYPE)
    _EUTRA_SpecialSubframe_Info_specialSubframePatterns = ENUM(name='specialSubframePatterns', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-SpecialSubframePatterns')))
    _EUTRA_SpecialSubframe_Info_cyclicPrefixDL = ENUM(name='cyclicPrefixDL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-CyclicPrefixDL')))
    _EUTRA_SpecialSubframe_Info_cyclicPrefixUL = ENUM(name='cyclicPrefixUL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-CyclicPrefixUL')))
    _EUTRA_SpecialSubframe_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRA_SpecialSubframe_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____EUTRA_SpecialSubframe_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_SpecialSubframe_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__id._const_tab = ____EUTRA_SpecialSubframe_Info_iE_Extensions__item__id_tab
    ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__id._const_tab_at = None
    ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EUTRA_SpecialSubframe_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_SpecialSubframe_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__criticality._const_tab = ____EUTRA_SpecialSubframe_Info_iE_Extensions__item__criticality_tab
    ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EUTRA_SpecialSubframe_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_SpecialSubframe_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__extensionValue._const_tab = ____EUTRA_SpecialSubframe_Info_iE_Extensions__item__extensionValue_tab
    ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EUTRA_SpecialSubframe_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__id),
        ('criticality', ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__extensionValue),
        ])
    __EUTRA_SpecialSubframe_Info_iE_Extensions__item_._ext = None
    _EUTRA_SpecialSubframe_Info_iE_Extensions._cont = __EUTRA_SpecialSubframe_Info_iE_Extensions__item_
    _EUTRA_SpecialSubframe_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRA_SpecialSubframe_Info._cont = ASN1Dict([
        ('specialSubframePatterns', _EUTRA_SpecialSubframe_Info_specialSubframePatterns),
        ('cyclicPrefixDL', _EUTRA_SpecialSubframe_Info_cyclicPrefixDL),
        ('cyclicPrefixUL', _EUTRA_SpecialSubframe_Info_cyclicPrefixUL),
        ('iE-Extensions', _EUTRA_SpecialSubframe_Info_iE_Extensions),
        ])
    EUTRA_SpecialSubframe_Info._ext = []
    
    #-----< EUTRA-SpecialSubframe-Info-ExtIEs >-----#
    EUTRA_SpecialSubframe_Info_ExtIEs = CLASS(name='EUTRA-SpecialSubframe-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    EUTRA_SpecialSubframe_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRA-SpecialSubframePatterns >-----#
    EUTRA_SpecialSubframePatterns = ENUM(name='EUTRA-SpecialSubframePatterns', mode=MODE_TYPE)
    EUTRA_SpecialSubframePatterns._cont = ASN1Dict([('ssp0', 0), ('ssp1', 1), ('ssp2', 2), ('ssp3', 3), ('ssp4', 4), ('ssp5', 5), ('ssp6', 6), ('ssp7', 7), ('ssp8', 8), ('ssp9', 9), ('ssp10', 10)])
    EUTRA_SpecialSubframePatterns._ext = []
    
    #-----< EUTRA-SubframeAssignment >-----#
    EUTRA_SubframeAssignment = ENUM(name='EUTRA-SubframeAssignment', mode=MODE_TYPE)
    EUTRA_SubframeAssignment._cont = ASN1Dict([('sa0', 0), ('sa1', 1), ('sa2', 2), ('sa3', 3), ('sa4', 4), ('sa5', 5), ('sa6', 6)])
    EUTRA_SubframeAssignment._ext = []
    
    #-----< EUTRA-Transmission-Bandwidth >-----#
    EUTRA_Transmission_Bandwidth = ENUM(name='EUTRA-Transmission-Bandwidth', mode=MODE_TYPE)
    EUTRA_Transmission_Bandwidth._cont = ASN1Dict([('bw6', 0), ('bw15', 1), ('bw25', 2), ('bw50', 3), ('bw75', 4), ('bw100', 5)])
    EUTRA_Transmission_Bandwidth._ext = []
    
    #-----< EUTRANQoS >-----#
    EUTRANQoS = SEQ(name='EUTRANQoS', mode=MODE_TYPE)
    _EUTRANQoS_qCI = INT(name='qCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QCI')))
    _EUTRANQoS_allocationAndRetentionPriority = SEQ(name='allocationAndRetentionPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AllocationAndRetentionPriority')))
    _EUTRANQoS_gbrQosInformation = SEQ(name='gbrQosInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GBR-QosInformation')), opt=True)
    _EUTRANQoS_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRANQoS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___EUTRANQoS_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____EUTRANQoS_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____EUTRANQoS_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    ____EUTRANQoS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 437), ('criticality', 'ignore'), ('Extension', _____EUTRANQoS_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___EUTRANQoS_iE_Extensions__item__id._const_tab = ____EUTRANQoS_iE_Extensions__item__id_tab
    ___EUTRANQoS_iE_Extensions__item__id._const_tab_at = None
    ___EUTRANQoS_iE_Extensions__item__id._const_tab_id = 'id'
    ___EUTRANQoS_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___EUTRANQoS_iE_Extensions__item__criticality._const_tab = ____EUTRANQoS_iE_Extensions__item__id_tab
    ___EUTRANQoS_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EUTRANQoS_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EUTRANQoS_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___EUTRANQoS_iE_Extensions__item__extensionValue._const_tab = ____EUTRANQoS_iE_Extensions__item__id_tab
    ___EUTRANQoS_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EUTRANQoS_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EUTRANQoS_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EUTRANQoS_iE_Extensions__item__id),
        ('criticality', ___EUTRANQoS_iE_Extensions__item__criticality),
        ('extensionValue', ___EUTRANQoS_iE_Extensions__item__extensionValue),
        ])
    __EUTRANQoS_iE_Extensions__item_._ext = None
    _EUTRANQoS_iE_Extensions._cont = __EUTRANQoS_iE_Extensions__item_
    _EUTRANQoS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRANQoS._cont = ASN1Dict([
        ('qCI', _EUTRANQoS_qCI),
        ('allocationAndRetentionPriority', _EUTRANQoS_allocationAndRetentionPriority),
        ('gbrQosInformation', _EUTRANQoS_gbrQosInformation),
        ('iE-Extensions', _EUTRANQoS_iE_Extensions),
        ])
    EUTRANQoS._ext = []
    
    #-----< EUTRANQoS-ExtIEs >-----#
    EUTRANQoS_ExtIEs = CLASS(name='EUTRANQoS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _EUTRANQoS_ExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    EUTRANQoS_ExtIEs._val = ASN1Set(rv=[dict([('id', 437), ('criticality', 'ignore'), ('Extension', _EUTRANQoS_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ExecuteDuplication >-----#
    ExecuteDuplication = ENUM(name='ExecuteDuplication', mode=MODE_TYPE)
    ExecuteDuplication._cont = ASN1Dict([('true', 0)])
    ExecuteDuplication._ext = []
    
    #-----< ExtendedEARFCN >-----#
    ExtendedEARFCN = INT(name='ExtendedEARFCN', mode=MODE_TYPE)
    ExtendedEARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=262143)], ev=None, er=[])
    
    #-----< EUTRA-Mode-Info >-----#
    EUTRA_Mode_Info = CHOICE(name='EUTRA-Mode-Info', mode=MODE_TYPE)
    _EUTRA_Mode_Info_eUTRAFDD = SEQ(name='eUTRAFDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-FDD-Info')))
    _EUTRA_Mode_Info_eUTRATDD = SEQ(name='eUTRATDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-TDD-Info')))
    _EUTRA_Mode_Info_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __EUTRA_Mode_Info_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___EUTRA_Mode_Info_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___EUTRA_Mode_Info_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __EUTRA_Mode_Info_choice_extension_id._const_tab = ___EUTRA_Mode_Info_choice_extension_id_tab
    __EUTRA_Mode_Info_choice_extension_id._const_tab_at = None
    __EUTRA_Mode_Info_choice_extension_id._const_tab_id = 'id'
    __EUTRA_Mode_Info_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___EUTRA_Mode_Info_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___EUTRA_Mode_Info_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __EUTRA_Mode_Info_choice_extension_criticality._const_tab = ___EUTRA_Mode_Info_choice_extension_criticality_tab
    __EUTRA_Mode_Info_choice_extension_criticality._const_tab_at = ('..', 'id')
    __EUTRA_Mode_Info_choice_extension_criticality._const_tab_id = 'criticality'
    __EUTRA_Mode_Info_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___EUTRA_Mode_Info_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___EUTRA_Mode_Info_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __EUTRA_Mode_Info_choice_extension_value._const_tab = ___EUTRA_Mode_Info_choice_extension_value_tab
    __EUTRA_Mode_Info_choice_extension_value._const_tab_at = ('..', 'id')
    __EUTRA_Mode_Info_choice_extension_value._const_tab_id = 'Value'
    _EUTRA_Mode_Info_choice_extension._cont = ASN1Dict([
        ('id', __EUTRA_Mode_Info_choice_extension_id),
        ('criticality', __EUTRA_Mode_Info_choice_extension_criticality),
        ('value', __EUTRA_Mode_Info_choice_extension_value),
        ])
    _EUTRA_Mode_Info_choice_extension._ext = None
    EUTRA_Mode_Info._cont = ASN1Dict([
        ('eUTRAFDD', _EUTRA_Mode_Info_eUTRAFDD),
        ('eUTRATDD', _EUTRA_Mode_Info_eUTRATDD),
        ('choice-extension', _EUTRA_Mode_Info_choice_extension),
        ])
    EUTRA_Mode_Info._ext = None
    
    #-----< EUTRA-Mode-Info-ExtIEs >-----#
    EUTRA_Mode_Info_ExtIEs = CLASS(name='EUTRA-Mode-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    EUTRA_Mode_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRA-NR-CellResourceCoordinationReq-Container >-----#
    EUTRA_NR_CellResourceCoordinationReq_Container = OCT_STR(name='EUTRA-NR-CellResourceCoordinationReq-Container', mode=MODE_TYPE)
    
    #-----< EUTRA-NR-CellResourceCoordinationReqAck-Container >-----#
    EUTRA_NR_CellResourceCoordinationReqAck_Container = OCT_STR(name='EUTRA-NR-CellResourceCoordinationReqAck-Container', mode=MODE_TYPE)
    
    #-----< EUTRA-FDD-Info >-----#
    EUTRA_FDD_Info = SEQ(name='EUTRA-FDD-Info', mode=MODE_TYPE)
    _EUTRA_FDD_Info_uL_offsetToPointA = INT(name='uL-offsetToPointA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'OffsetToPointA')))
    _EUTRA_FDD_Info_dL_offsetToPointA = INT(name='dL-offsetToPointA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'OffsetToPointA')))
    _EUTRA_FDD_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRA_FDD_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___EUTRA_FDD_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____EUTRA_FDD_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_FDD_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_FDD_Info_iE_Extensions__item__id._const_tab = ____EUTRA_FDD_Info_iE_Extensions__item__id_tab
    ___EUTRA_FDD_Info_iE_Extensions__item__id._const_tab_at = None
    ___EUTRA_FDD_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___EUTRA_FDD_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EUTRA_FDD_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_FDD_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_FDD_Info_iE_Extensions__item__criticality._const_tab = ____EUTRA_FDD_Info_iE_Extensions__item__criticality_tab
    ___EUTRA_FDD_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EUTRA_FDD_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EUTRA_FDD_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EUTRA_FDD_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_FDD_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_FDD_Info_iE_Extensions__item__extensionValue._const_tab = ____EUTRA_FDD_Info_iE_Extensions__item__extensionValue_tab
    ___EUTRA_FDD_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EUTRA_FDD_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EUTRA_FDD_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EUTRA_FDD_Info_iE_Extensions__item__id),
        ('criticality', ___EUTRA_FDD_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___EUTRA_FDD_Info_iE_Extensions__item__extensionValue),
        ])
    __EUTRA_FDD_Info_iE_Extensions__item_._ext = None
    _EUTRA_FDD_Info_iE_Extensions._cont = __EUTRA_FDD_Info_iE_Extensions__item_
    _EUTRA_FDD_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRA_FDD_Info._cont = ASN1Dict([
        ('uL-offsetToPointA', _EUTRA_FDD_Info_uL_offsetToPointA),
        ('dL-offsetToPointA', _EUTRA_FDD_Info_dL_offsetToPointA),
        ('iE-Extensions', _EUTRA_FDD_Info_iE_Extensions),
        ])
    EUTRA_FDD_Info._ext = []
    
    #-----< EUTRA-FDD-Info-ExtIEs >-----#
    EUTRA_FDD_Info_ExtIEs = CLASS(name='EUTRA-FDD-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    EUTRA_FDD_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRA-TDD-Info >-----#
    EUTRA_TDD_Info = SEQ(name='EUTRA-TDD-Info', mode=MODE_TYPE)
    _EUTRA_TDD_Info_offsetToPointA = INT(name='offsetToPointA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'OffsetToPointA')))
    _EUTRA_TDD_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRA_TDD_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___EUTRA_TDD_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____EUTRA_TDD_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_TDD_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_TDD_Info_iE_Extensions__item__id._const_tab = ____EUTRA_TDD_Info_iE_Extensions__item__id_tab
    ___EUTRA_TDD_Info_iE_Extensions__item__id._const_tab_at = None
    ___EUTRA_TDD_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___EUTRA_TDD_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EUTRA_TDD_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_TDD_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_TDD_Info_iE_Extensions__item__criticality._const_tab = ____EUTRA_TDD_Info_iE_Extensions__item__criticality_tab
    ___EUTRA_TDD_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EUTRA_TDD_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EUTRA_TDD_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EUTRA_TDD_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____EUTRA_TDD_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_TDD_Info_iE_Extensions__item__extensionValue._const_tab = ____EUTRA_TDD_Info_iE_Extensions__item__extensionValue_tab
    ___EUTRA_TDD_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EUTRA_TDD_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EUTRA_TDD_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EUTRA_TDD_Info_iE_Extensions__item__id),
        ('criticality', ___EUTRA_TDD_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___EUTRA_TDD_Info_iE_Extensions__item__extensionValue),
        ])
    __EUTRA_TDD_Info_iE_Extensions__item_._ext = None
    _EUTRA_TDD_Info_iE_Extensions._cont = __EUTRA_TDD_Info_iE_Extensions__item_
    _EUTRA_TDD_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRA_TDD_Info._cont = ASN1Dict([
        ('offsetToPointA', _EUTRA_TDD_Info_offsetToPointA),
        ('iE-Extensions', _EUTRA_TDD_Info_iE_Extensions),
        ])
    EUTRA_TDD_Info._ext = []
    
    #-----< EUTRA-TDD-Info-ExtIEs >-----#
    EUTRA_TDD_Info_ExtIEs = CLASS(name='EUTRA-TDD-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    EUTRA_TDD_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EventType >-----#
    EventType = ENUM(name='EventType', mode=MODE_TYPE)
    EventType._cont = ASN1Dict([('on-demand', 0), ('periodic', 1), ('stop', 2)])
    EventType._ext = []
    
    #-----< ExtendedPacketDelayBudget >-----#
    ExtendedPacketDelayBudget = INT(name='ExtendedPacketDelayBudget', mode=MODE_TYPE)
    ExtendedPacketDelayBudget._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=[], er=[])
    
    #-----< Expected-UL-AoA >-----#
    Expected_UL_AoA = SEQ(name='Expected-UL-AoA', mode=MODE_TYPE)
    _Expected_UL_AoA_expected_Azimuth_AoA = SEQ(name='expected-Azimuth-AoA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Expected-Azimuth-AoA')))
    _Expected_UL_AoA_expected_Zenith_AoA = SEQ(name='expected-Zenith-AoA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Expected-Zenith-AoA')), opt=True)
    _Expected_UL_AoA_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Expected_UL_AoA_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Expected_UL_AoA_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Expected_UL_AoA_iE_extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Expected_UL_AoA_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Expected_UL_AoA_iE_extensions__item__id._const_tab = ____Expected_UL_AoA_iE_extensions__item__id_tab
    ___Expected_UL_AoA_iE_extensions__item__id._const_tab_at = None
    ___Expected_UL_AoA_iE_extensions__item__id._const_tab_id = 'id'
    ___Expected_UL_AoA_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Expected_UL_AoA_iE_extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Expected_UL_AoA_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Expected_UL_AoA_iE_extensions__item__criticality._const_tab = ____Expected_UL_AoA_iE_extensions__item__criticality_tab
    ___Expected_UL_AoA_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Expected_UL_AoA_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___Expected_UL_AoA_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Expected_UL_AoA_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Expected_UL_AoA_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Expected_UL_AoA_iE_extensions__item__extensionValue._const_tab = ____Expected_UL_AoA_iE_extensions__item__extensionValue_tab
    ___Expected_UL_AoA_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Expected_UL_AoA_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __Expected_UL_AoA_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___Expected_UL_AoA_iE_extensions__item__id),
        ('criticality', ___Expected_UL_AoA_iE_extensions__item__criticality),
        ('extensionValue', ___Expected_UL_AoA_iE_extensions__item__extensionValue),
        ])
    __Expected_UL_AoA_iE_extensions__item_._ext = None
    _Expected_UL_AoA_iE_extensions._cont = __Expected_UL_AoA_iE_extensions__item_
    _Expected_UL_AoA_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Expected_UL_AoA._cont = ASN1Dict([
        ('expected-Azimuth-AoA', _Expected_UL_AoA_expected_Azimuth_AoA),
        ('expected-Zenith-AoA', _Expected_UL_AoA_expected_Zenith_AoA),
        ('iE-extensions', _Expected_UL_AoA_iE_extensions),
        ])
    Expected_UL_AoA._ext = []
    
    #-----< Expected-UL-AoA-ExtIEs >-----#
    Expected_UL_AoA_ExtIEs = CLASS(name='Expected-UL-AoA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Expected_UL_AoA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Expected-ZoA-only >-----#
    Expected_ZoA_only = SEQ(name='Expected-ZoA-only', mode=MODE_TYPE)
    _Expected_ZoA_only_expected_ZoA_only = SEQ(name='expected-ZoA-only', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Expected-Zenith-AoA')))
    _Expected_ZoA_only_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Expected_ZoA_only_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Expected_ZoA_only_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Expected_ZoA_only_iE_extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Expected_ZoA_only_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Expected_ZoA_only_iE_extensions__item__id._const_tab = ____Expected_ZoA_only_iE_extensions__item__id_tab
    ___Expected_ZoA_only_iE_extensions__item__id._const_tab_at = None
    ___Expected_ZoA_only_iE_extensions__item__id._const_tab_id = 'id'
    ___Expected_ZoA_only_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Expected_ZoA_only_iE_extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Expected_ZoA_only_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Expected_ZoA_only_iE_extensions__item__criticality._const_tab = ____Expected_ZoA_only_iE_extensions__item__criticality_tab
    ___Expected_ZoA_only_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Expected_ZoA_only_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___Expected_ZoA_only_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Expected_ZoA_only_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Expected_ZoA_only_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Expected_ZoA_only_iE_extensions__item__extensionValue._const_tab = ____Expected_ZoA_only_iE_extensions__item__extensionValue_tab
    ___Expected_ZoA_only_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Expected_ZoA_only_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __Expected_ZoA_only_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___Expected_ZoA_only_iE_extensions__item__id),
        ('criticality', ___Expected_ZoA_only_iE_extensions__item__criticality),
        ('extensionValue', ___Expected_ZoA_only_iE_extensions__item__extensionValue),
        ])
    __Expected_ZoA_only_iE_extensions__item_._ext = None
    _Expected_ZoA_only_iE_extensions._cont = __Expected_ZoA_only_iE_extensions__item_
    _Expected_ZoA_only_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Expected_ZoA_only._cont = ASN1Dict([
        ('expected-ZoA-only', _Expected_ZoA_only_expected_ZoA_only),
        ('iE-extensions', _Expected_ZoA_only_iE_extensions),
        ])
    Expected_ZoA_only._ext = []
    
    #-----< Expected-ZoA-only-ExtIEs >-----#
    Expected_ZoA_only_ExtIEs = CLASS(name='Expected-ZoA-only-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Expected_ZoA_only_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Expected-Azimuth-AoA >-----#
    Expected_Azimuth_AoA = SEQ(name='Expected-Azimuth-AoA', mode=MODE_TYPE)
    _Expected_Azimuth_AoA_expected_Azimuth_AoA_value = INT(name='expected-Azimuth-AoA-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Expected-Value-AoA')))
    _Expected_Azimuth_AoA_expected_Azimuth_AoA_uncertainty = INT(name='expected-Azimuth-AoA-uncertainty', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Uncertainty-range-AoA')))
    _Expected_Azimuth_AoA_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Expected_Azimuth_AoA_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Expected_Azimuth_AoA_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Expected_Azimuth_AoA_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Expected_Azimuth_AoA_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Expected_Azimuth_AoA_iE_Extensions__item__id._const_tab = ____Expected_Azimuth_AoA_iE_Extensions__item__id_tab
    ___Expected_Azimuth_AoA_iE_Extensions__item__id._const_tab_at = None
    ___Expected_Azimuth_AoA_iE_Extensions__item__id._const_tab_id = 'id'
    ___Expected_Azimuth_AoA_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Expected_Azimuth_AoA_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Expected_Azimuth_AoA_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Expected_Azimuth_AoA_iE_Extensions__item__criticality._const_tab = ____Expected_Azimuth_AoA_iE_Extensions__item__criticality_tab
    ___Expected_Azimuth_AoA_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Expected_Azimuth_AoA_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Expected_Azimuth_AoA_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Expected_Azimuth_AoA_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Expected_Azimuth_AoA_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Expected_Azimuth_AoA_iE_Extensions__item__extensionValue._const_tab = ____Expected_Azimuth_AoA_iE_Extensions__item__extensionValue_tab
    ___Expected_Azimuth_AoA_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Expected_Azimuth_AoA_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Expected_Azimuth_AoA_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Expected_Azimuth_AoA_iE_Extensions__item__id),
        ('criticality', ___Expected_Azimuth_AoA_iE_Extensions__item__criticality),
        ('extensionValue', ___Expected_Azimuth_AoA_iE_Extensions__item__extensionValue),
        ])
    __Expected_Azimuth_AoA_iE_Extensions__item_._ext = None
    _Expected_Azimuth_AoA_iE_Extensions._cont = __Expected_Azimuth_AoA_iE_Extensions__item_
    _Expected_Azimuth_AoA_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Expected_Azimuth_AoA._cont = ASN1Dict([
        ('expected-Azimuth-AoA-value', _Expected_Azimuth_AoA_expected_Azimuth_AoA_value),
        ('expected-Azimuth-AoA-uncertainty', _Expected_Azimuth_AoA_expected_Azimuth_AoA_uncertainty),
        ('iE-Extensions', _Expected_Azimuth_AoA_iE_Extensions),
        ])
    Expected_Azimuth_AoA._ext = []
    
    #-----< Expected-Azimuth-AoA-ExtIEs >-----#
    Expected_Azimuth_AoA_ExtIEs = CLASS(name='Expected-Azimuth-AoA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Expected_Azimuth_AoA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Expected-Zenith-AoA >-----#
    Expected_Zenith_AoA = SEQ(name='Expected-Zenith-AoA', mode=MODE_TYPE)
    _Expected_Zenith_AoA_expected_Zenith_AoA_value = INT(name='expected-Zenith-AoA-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Expected-Value-ZoA')))
    _Expected_Zenith_AoA_expected_Zenith_AoA_uncertainty = INT(name='expected-Zenith-AoA-uncertainty', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Uncertainty-range-ZoA')))
    _Expected_Zenith_AoA_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Expected_Zenith_AoA_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Expected_Zenith_AoA_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Expected_Zenith_AoA_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Expected_Zenith_AoA_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Expected_Zenith_AoA_iE_Extensions__item__id._const_tab = ____Expected_Zenith_AoA_iE_Extensions__item__id_tab
    ___Expected_Zenith_AoA_iE_Extensions__item__id._const_tab_at = None
    ___Expected_Zenith_AoA_iE_Extensions__item__id._const_tab_id = 'id'
    ___Expected_Zenith_AoA_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Expected_Zenith_AoA_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Expected_Zenith_AoA_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Expected_Zenith_AoA_iE_Extensions__item__criticality._const_tab = ____Expected_Zenith_AoA_iE_Extensions__item__criticality_tab
    ___Expected_Zenith_AoA_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Expected_Zenith_AoA_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Expected_Zenith_AoA_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Expected_Zenith_AoA_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Expected_Zenith_AoA_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Expected_Zenith_AoA_iE_Extensions__item__extensionValue._const_tab = ____Expected_Zenith_AoA_iE_Extensions__item__extensionValue_tab
    ___Expected_Zenith_AoA_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Expected_Zenith_AoA_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Expected_Zenith_AoA_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Expected_Zenith_AoA_iE_Extensions__item__id),
        ('criticality', ___Expected_Zenith_AoA_iE_Extensions__item__criticality),
        ('extensionValue', ___Expected_Zenith_AoA_iE_Extensions__item__extensionValue),
        ])
    __Expected_Zenith_AoA_iE_Extensions__item_._ext = None
    _Expected_Zenith_AoA_iE_Extensions._cont = __Expected_Zenith_AoA_iE_Extensions__item_
    _Expected_Zenith_AoA_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Expected_Zenith_AoA._cont = ASN1Dict([
        ('expected-Zenith-AoA-value', _Expected_Zenith_AoA_expected_Zenith_AoA_value),
        ('expected-Zenith-AoA-uncertainty', _Expected_Zenith_AoA_expected_Zenith_AoA_uncertainty),
        ('iE-Extensions', _Expected_Zenith_AoA_iE_Extensions),
        ])
    Expected_Zenith_AoA._ext = []
    
    #-----< Expected-Zenith-AoA-ExtIEs >-----#
    Expected_Zenith_AoA_ExtIEs = CLASS(name='Expected-Zenith-AoA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Expected_Zenith_AoA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Expected-Value-AoA >-----#
    Expected_Value_AoA = INT(name='Expected-Value-AoA', mode=MODE_TYPE)
    Expected_Value_AoA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    
    #-----< Expected-Value-ZoA >-----#
    Expected_Value_ZoA = INT(name='Expected-Value-ZoA', mode=MODE_TYPE)
    Expected_Value_ZoA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1799)], ev=None, er=[])
    
    #-----< F1CPathNSA >-----#
    F1CPathNSA = ENUM(name='F1CPathNSA', mode=MODE_TYPE)
    F1CPathNSA._cont = ASN1Dict([('lte', 0), ('nr', 1), ('both', 2)])
    F1CPathNSA._ext = None
    
    #-----< F1CTransferPath >-----#
    F1CTransferPath = SEQ(name='F1CTransferPath', mode=MODE_TYPE)
    _F1CTransferPath_f1CPathNSA = ENUM(name='f1CPathNSA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'F1CPathNSA')))
    _F1CTransferPath_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __F1CTransferPath_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___F1CTransferPath_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____F1CTransferPath_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____F1CTransferPath_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F1CTransferPath_iE_Extensions__item__id._const_tab = ____F1CTransferPath_iE_Extensions__item__id_tab
    ___F1CTransferPath_iE_Extensions__item__id._const_tab_at = None
    ___F1CTransferPath_iE_Extensions__item__id._const_tab_id = 'id'
    ___F1CTransferPath_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____F1CTransferPath_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____F1CTransferPath_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F1CTransferPath_iE_Extensions__item__criticality._const_tab = ____F1CTransferPath_iE_Extensions__item__criticality_tab
    ___F1CTransferPath_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___F1CTransferPath_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___F1CTransferPath_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____F1CTransferPath_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____F1CTransferPath_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F1CTransferPath_iE_Extensions__item__extensionValue._const_tab = ____F1CTransferPath_iE_Extensions__item__extensionValue_tab
    ___F1CTransferPath_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___F1CTransferPath_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __F1CTransferPath_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___F1CTransferPath_iE_Extensions__item__id),
        ('criticality', ___F1CTransferPath_iE_Extensions__item__criticality),
        ('extensionValue', ___F1CTransferPath_iE_Extensions__item__extensionValue),
        ])
    __F1CTransferPath_iE_Extensions__item_._ext = None
    _F1CTransferPath_iE_Extensions._cont = __F1CTransferPath_iE_Extensions__item_
    _F1CTransferPath_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    F1CTransferPath._cont = ASN1Dict([
        ('f1CPathNSA', _F1CTransferPath_f1CPathNSA),
        ('iE-Extensions', _F1CTransferPath_iE_Extensions),
        ])
    F1CTransferPath._ext = []
    
    #-----< F1CTransferPath-ExtIEs >-----#
    F1CTransferPath_ExtIEs = CLASS(name='F1CTransferPath-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    F1CTransferPath_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< F1CPathNRDC >-----#
    F1CPathNRDC = ENUM(name='F1CPathNRDC', mode=MODE_TYPE)
    F1CPathNRDC._cont = ASN1Dict([('mcg', 0), ('scg', 1), ('both', 2)])
    F1CPathNRDC._ext = None
    
    #-----< F1CTransferPathNRDC >-----#
    F1CTransferPathNRDC = SEQ(name='F1CTransferPathNRDC', mode=MODE_TYPE)
    _F1CTransferPathNRDC_f1CPathNRDC = ENUM(name='f1CPathNRDC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'F1CPathNRDC')))
    _F1CTransferPathNRDC_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __F1CTransferPathNRDC_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___F1CTransferPathNRDC_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____F1CTransferPathNRDC_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____F1CTransferPathNRDC_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F1CTransferPathNRDC_iE_Extensions__item__id._const_tab = ____F1CTransferPathNRDC_iE_Extensions__item__id_tab
    ___F1CTransferPathNRDC_iE_Extensions__item__id._const_tab_at = None
    ___F1CTransferPathNRDC_iE_Extensions__item__id._const_tab_id = 'id'
    ___F1CTransferPathNRDC_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____F1CTransferPathNRDC_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____F1CTransferPathNRDC_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F1CTransferPathNRDC_iE_Extensions__item__criticality._const_tab = ____F1CTransferPathNRDC_iE_Extensions__item__criticality_tab
    ___F1CTransferPathNRDC_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___F1CTransferPathNRDC_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___F1CTransferPathNRDC_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____F1CTransferPathNRDC_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____F1CTransferPathNRDC_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F1CTransferPathNRDC_iE_Extensions__item__extensionValue._const_tab = ____F1CTransferPathNRDC_iE_Extensions__item__extensionValue_tab
    ___F1CTransferPathNRDC_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___F1CTransferPathNRDC_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __F1CTransferPathNRDC_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___F1CTransferPathNRDC_iE_Extensions__item__id),
        ('criticality', ___F1CTransferPathNRDC_iE_Extensions__item__criticality),
        ('extensionValue', ___F1CTransferPathNRDC_iE_Extensions__item__extensionValue),
        ])
    __F1CTransferPathNRDC_iE_Extensions__item_._ext = None
    _F1CTransferPathNRDC_iE_Extensions._cont = __F1CTransferPathNRDC_iE_Extensions__item_
    _F1CTransferPathNRDC_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    F1CTransferPathNRDC._cont = ASN1Dict([
        ('f1CPathNRDC', _F1CTransferPathNRDC_f1CPathNRDC),
        ('iE-Extensions', _F1CTransferPathNRDC_iE_Extensions),
        ])
    F1CTransferPathNRDC._ext = []
    
    #-----< F1CTransferPathNRDC-ExtIEs >-----#
    F1CTransferPathNRDC_ExtIEs = CLASS(name='F1CTransferPathNRDC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    F1CTransferPathNRDC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FDD-Info >-----#
    FDD_Info = SEQ(name='FDD-Info', mode=MODE_TYPE)
    _FDD_Info_uL_NRFreqInfo = SEQ(name='uL-NRFreqInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRFreqInfo')))
    _FDD_Info_dL_NRFreqInfo = SEQ(name='dL-NRFreqInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRFreqInfo')))
    _FDD_Info_uL_Transmission_Bandwidth = SEQ(name='uL-Transmission-Bandwidth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Transmission-Bandwidth')))
    _FDD_Info_dL_Transmission_Bandwidth = SEQ(name='dL-Transmission-Bandwidth', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Transmission-Bandwidth')))
    _FDD_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FDD_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___FDD_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____FDD_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')))
    _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')))
    ____FDD_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 355), ('criticality', 'ignore'), ('Extension', _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 389), ('criticality', 'ignore'), ('Extension', _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___FDD_Info_iE_Extensions__item__id._const_tab = ____FDD_Info_iE_Extensions__item__id_tab
    ___FDD_Info_iE_Extensions__item__id._const_tab_at = None
    ___FDD_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___FDD_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___FDD_Info_iE_Extensions__item__criticality._const_tab = ____FDD_Info_iE_Extensions__item__id_tab
    ___FDD_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FDD_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FDD_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___FDD_Info_iE_Extensions__item__extensionValue._const_tab = ____FDD_Info_iE_Extensions__item__id_tab
    ___FDD_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FDD_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FDD_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FDD_Info_iE_Extensions__item__id),
        ('criticality', ___FDD_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___FDD_Info_iE_Extensions__item__extensionValue),
        ])
    __FDD_Info_iE_Extensions__item_._ext = None
    _FDD_Info_iE_Extensions._cont = __FDD_Info_iE_Extensions__item_
    _FDD_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FDD_Info._cont = ASN1Dict([
        ('uL-NRFreqInfo', _FDD_Info_uL_NRFreqInfo),
        ('dL-NRFreqInfo', _FDD_Info_dL_NRFreqInfo),
        ('uL-Transmission-Bandwidth', _FDD_Info_uL_Transmission_Bandwidth),
        ('dL-Transmission-Bandwidth', _FDD_Info_dL_Transmission_Bandwidth),
        ('iE-Extensions', _FDD_Info_iE_Extensions),
        ])
    FDD_Info._ext = []
    
    #-----< FDD-Info-ExtIEs >-----#
    FDD_Info_ExtIEs = CLASS(name='FDD-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _FDD_Info_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')))
    _FDD_Info_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')))
    FDD_Info_ExtIEs._val = ASN1Set(rv=[dict([('id', 355), ('criticality', 'ignore'), ('Extension', _FDD_Info_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 389), ('criticality', 'ignore'), ('Extension', _FDD_Info_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< FDD-InfoRel16 >-----#
    FDD_InfoRel16 = SEQ(name='FDD-InfoRel16', mode=MODE_TYPE)
    _FDD_InfoRel16_uL_FreqInfo = SEQ(name='uL-FreqInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FreqInfoRel16')), opt=True)
    _FDD_InfoRel16_sUL_FreqInfo = SEQ(name='sUL-FreqInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FreqInfoRel16')), opt=True)
    _FDD_InfoRel16_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FDD_InfoRel16_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___FDD_InfoRel16_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____FDD_InfoRel16_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____FDD_InfoRel16_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FDD_InfoRel16_iE_Extensions__item__id._const_tab = ____FDD_InfoRel16_iE_Extensions__item__id_tab
    ___FDD_InfoRel16_iE_Extensions__item__id._const_tab_at = None
    ___FDD_InfoRel16_iE_Extensions__item__id._const_tab_id = 'id'
    ___FDD_InfoRel16_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FDD_InfoRel16_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____FDD_InfoRel16_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FDD_InfoRel16_iE_Extensions__item__criticality._const_tab = ____FDD_InfoRel16_iE_Extensions__item__criticality_tab
    ___FDD_InfoRel16_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FDD_InfoRel16_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FDD_InfoRel16_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FDD_InfoRel16_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____FDD_InfoRel16_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FDD_InfoRel16_iE_Extensions__item__extensionValue._const_tab = ____FDD_InfoRel16_iE_Extensions__item__extensionValue_tab
    ___FDD_InfoRel16_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FDD_InfoRel16_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FDD_InfoRel16_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FDD_InfoRel16_iE_Extensions__item__id),
        ('criticality', ___FDD_InfoRel16_iE_Extensions__item__criticality),
        ('extensionValue', ___FDD_InfoRel16_iE_Extensions__item__extensionValue),
        ])
    __FDD_InfoRel16_iE_Extensions__item_._ext = None
    _FDD_InfoRel16_iE_Extensions._cont = __FDD_InfoRel16_iE_Extensions__item_
    _FDD_InfoRel16_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FDD_InfoRel16._cont = ASN1Dict([
        ('uL-FreqInfo', _FDD_InfoRel16_uL_FreqInfo),
        ('sUL-FreqInfo', _FDD_InfoRel16_sUL_FreqInfo),
        ('iE-Extensions', _FDD_InfoRel16_iE_Extensions),
        ])
    FDD_InfoRel16._ext = []
    
    #-----< FDD-InfoRel16-ExtIEs >-----#
    FDD_InfoRel16_ExtIEs = CLASS(name='FDD-InfoRel16-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    FDD_InfoRel16_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FiveG-ProSeAuthorized >-----#
    FiveG_ProSeAuthorized = SEQ(name='FiveG-ProSeAuthorized', mode=MODE_TYPE)
    _FiveG_ProSeAuthorized_fiveG_proSeDirectDiscovery = ENUM(name='fiveG-proSeDirectDiscovery', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FiveG-ProSeDirectDiscovery')), opt=True)
    _FiveG_ProSeAuthorized_fiveG_proSeDirectCommunication = ENUM(name='fiveG-proSeDirectCommunication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FiveG-ProSeDirectCommunication')), opt=True)
    _FiveG_ProSeAuthorized_fiveG_ProSeLayer2UEtoNetworkRelay = ENUM(name='fiveG-ProSeLayer2UEtoNetworkRelay', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FiveG-ProSeLayer2UEtoNetworkRelay')), opt=True)
    _FiveG_ProSeAuthorized_fiveG_ProSeLayer3UEtoNetworkRelay = ENUM(name='fiveG-ProSeLayer3UEtoNetworkRelay', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FiveG-ProSeLayer3UEtoNetworkRelay')), opt=True)
    _FiveG_ProSeAuthorized_fiveG_ProSeLayer2RemoteUE = ENUM(name='fiveG-ProSeLayer2RemoteUE', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FiveG-ProSeLayer2RemoteUE')), opt=True)
    _FiveG_ProSeAuthorized_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FiveG_ProSeAuthorized_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___FiveG_ProSeAuthorized_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____FiveG_ProSeAuthorized_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____FiveG_ProSeAuthorized_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveG_ProSeAuthorized_iE_Extensions__item__id._const_tab = ____FiveG_ProSeAuthorized_iE_Extensions__item__id_tab
    ___FiveG_ProSeAuthorized_iE_Extensions__item__id._const_tab_at = None
    ___FiveG_ProSeAuthorized_iE_Extensions__item__id._const_tab_id = 'id'
    ___FiveG_ProSeAuthorized_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FiveG_ProSeAuthorized_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____FiveG_ProSeAuthorized_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveG_ProSeAuthorized_iE_Extensions__item__criticality._const_tab = ____FiveG_ProSeAuthorized_iE_Extensions__item__criticality_tab
    ___FiveG_ProSeAuthorized_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FiveG_ProSeAuthorized_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FiveG_ProSeAuthorized_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FiveG_ProSeAuthorized_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____FiveG_ProSeAuthorized_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveG_ProSeAuthorized_iE_Extensions__item__extensionValue._const_tab = ____FiveG_ProSeAuthorized_iE_Extensions__item__extensionValue_tab
    ___FiveG_ProSeAuthorized_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FiveG_ProSeAuthorized_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FiveG_ProSeAuthorized_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FiveG_ProSeAuthorized_iE_Extensions__item__id),
        ('criticality', ___FiveG_ProSeAuthorized_iE_Extensions__item__criticality),
        ('extensionValue', ___FiveG_ProSeAuthorized_iE_Extensions__item__extensionValue),
        ])
    __FiveG_ProSeAuthorized_iE_Extensions__item_._ext = None
    _FiveG_ProSeAuthorized_iE_Extensions._cont = __FiveG_ProSeAuthorized_iE_Extensions__item_
    _FiveG_ProSeAuthorized_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FiveG_ProSeAuthorized._cont = ASN1Dict([
        ('fiveG-proSeDirectDiscovery', _FiveG_ProSeAuthorized_fiveG_proSeDirectDiscovery),
        ('fiveG-proSeDirectCommunication', _FiveG_ProSeAuthorized_fiveG_proSeDirectCommunication),
        ('fiveG-ProSeLayer2UEtoNetworkRelay', _FiveG_ProSeAuthorized_fiveG_ProSeLayer2UEtoNetworkRelay),
        ('fiveG-ProSeLayer3UEtoNetworkRelay', _FiveG_ProSeAuthorized_fiveG_ProSeLayer3UEtoNetworkRelay),
        ('fiveG-ProSeLayer2RemoteUE', _FiveG_ProSeAuthorized_fiveG_ProSeLayer2RemoteUE),
        ('iE-Extensions', _FiveG_ProSeAuthorized_iE_Extensions),
        ])
    FiveG_ProSeAuthorized._ext = []
    
    #-----< FiveG-ProSeAuthorized-ExtIEs >-----#
    FiveG_ProSeAuthorized_ExtIEs = CLASS(name='FiveG-ProSeAuthorized-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    FiveG_ProSeAuthorized_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FiveG-ProSeDirectDiscovery >-----#
    FiveG_ProSeDirectDiscovery = ENUM(name='FiveG-ProSeDirectDiscovery', mode=MODE_TYPE)
    FiveG_ProSeDirectDiscovery._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    FiveG_ProSeDirectDiscovery._ext = []
    
    #-----< FiveG-ProSeDirectCommunication >-----#
    FiveG_ProSeDirectCommunication = ENUM(name='FiveG-ProSeDirectCommunication', mode=MODE_TYPE)
    FiveG_ProSeDirectCommunication._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    FiveG_ProSeDirectCommunication._ext = []
    
    #-----< FiveG-ProSeLayer2UEtoNetworkRelay >-----#
    FiveG_ProSeLayer2UEtoNetworkRelay = ENUM(name='FiveG-ProSeLayer2UEtoNetworkRelay', mode=MODE_TYPE)
    FiveG_ProSeLayer2UEtoNetworkRelay._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    FiveG_ProSeLayer2UEtoNetworkRelay._ext = []
    
    #-----< FiveG-ProSeLayer3UEtoNetworkRelay >-----#
    FiveG_ProSeLayer3UEtoNetworkRelay = ENUM(name='FiveG-ProSeLayer3UEtoNetworkRelay', mode=MODE_TYPE)
    FiveG_ProSeLayer3UEtoNetworkRelay._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    FiveG_ProSeLayer3UEtoNetworkRelay._ext = []
    
    #-----< FiveG-ProSeLayer2RemoteUE >-----#
    FiveG_ProSeLayer2RemoteUE = ENUM(name='FiveG-ProSeLayer2RemoteUE', mode=MODE_TYPE)
    FiveG_ProSeLayer2RemoteUE._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    FiveG_ProSeLayer2RemoteUE._ext = []
    
    #-----< Flows-Mapped-To-DRB-List >-----#
    Flows_Mapped_To_DRB_List = SEQ_OF(name='Flows-Mapped-To-DRB-List', mode=MODE_TYPE)
    _Flows_Mapped_To_DRB_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Flows-Mapped-To-DRB-Item')))
    Flows_Mapped_To_DRB_List._cont = _Flows_Mapped_To_DRB_List__item_
    Flows_Mapped_To_DRB_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< Flows-Mapped-To-DRB-Item >-----#
    Flows_Mapped_To_DRB_Item = SEQ(name='Flows-Mapped-To-DRB-Item', mode=MODE_TYPE)
    _Flows_Mapped_To_DRB_Item_qoSFlowIdentifier = INT(name='qoSFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSFlowIdentifier')))
    _Flows_Mapped_To_DRB_Item_qoSFlowLevelQoSParameters = SEQ(name='qoSFlowLevelQoSParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSFlowLevelQoSParameters')))
    _Flows_Mapped_To_DRB_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Flows_Mapped_To_DRB_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Flows_Mapped_To_DRB_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____Flows_Mapped_To_DRB_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QoSFlowMappingIndication')))
    _____Flows_Mapped_To_DRB_Item_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TSCTrafficCharacteristics')))
    ____Flows_Mapped_To_DRB_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 183), ('criticality', 'ignore'), ('Extension', _____Flows_Mapped_To_DRB_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 364), ('criticality', 'ignore'), ('Extension', _____Flows_Mapped_To_DRB_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__id._const_tab = ____Flows_Mapped_To_DRB_Item_iE_Extensions__item__id_tab
    ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__id._const_tab_at = None
    ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__criticality._const_tab = ____Flows_Mapped_To_DRB_Item_iE_Extensions__item__id_tab
    ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__extensionValue._const_tab = ____Flows_Mapped_To_DRB_Item_iE_Extensions__item__id_tab
    ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Flows_Mapped_To_DRB_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__id),
        ('criticality', ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__extensionValue),
        ])
    __Flows_Mapped_To_DRB_Item_iE_Extensions__item_._ext = None
    _Flows_Mapped_To_DRB_Item_iE_Extensions._cont = __Flows_Mapped_To_DRB_Item_iE_Extensions__item_
    _Flows_Mapped_To_DRB_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Flows_Mapped_To_DRB_Item._cont = ASN1Dict([
        ('qoSFlowIdentifier', _Flows_Mapped_To_DRB_Item_qoSFlowIdentifier),
        ('qoSFlowLevelQoSParameters', _Flows_Mapped_To_DRB_Item_qoSFlowLevelQoSParameters),
        ('iE-Extensions', _Flows_Mapped_To_DRB_Item_iE_Extensions),
        ])
    Flows_Mapped_To_DRB_Item._ext = None
    
    #-----< Flows-Mapped-To-DRB-ItemExtIEs >-----#
    Flows_Mapped_To_DRB_ItemExtIEs = CLASS(name='Flows-Mapped-To-DRB-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _Flows_Mapped_To_DRB_ItemExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QoSFlowMappingIndication')))
    _Flows_Mapped_To_DRB_ItemExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TSCTrafficCharacteristics')))
    Flows_Mapped_To_DRB_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 183), ('criticality', 'ignore'), ('Extension', _Flows_Mapped_To_DRB_ItemExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 364), ('criticality', 'ignore'), ('Extension', _Flows_Mapped_To_DRB_ItemExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< FR1-Bandwidth >-----#
    FR1_Bandwidth = ENUM(name='FR1-Bandwidth', mode=MODE_TYPE)
    FR1_Bandwidth._cont = ASN1Dict([('bw5', 0), ('bw10', 1), ('bw20', 2), ('bw40', 3), ('bw50', 4), ('bw80', 5), ('bw100', 6)])
    FR1_Bandwidth._ext = []
    
    #-----< FR2-Bandwidth >-----#
    FR2_Bandwidth = ENUM(name='FR2-Bandwidth', mode=MODE_TYPE)
    FR2_Bandwidth._cont = ASN1Dict([('bw50', 0), ('bw100', 1), ('bw200', 2), ('bw400', 3), ('bw800', 4), ('bw1600', 5), ('bw2000', 6)])
    FR2_Bandwidth._ext = ['bw800', 'bw1600', 'bw2000']
    
    #-----< FreqBandNrItem >-----#
    FreqBandNrItem = SEQ(name='FreqBandNrItem', mode=MODE_TYPE)
    _FreqBandNrItem_freqBandIndicatorNr = INT(name='freqBandIndicatorNr', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _FreqBandNrItem_freqBandIndicatorNr._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=[], er=[])
    _FreqBandNrItem_supportedSULBandList = SEQ_OF(name='supportedSULBandList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __FreqBandNrItem_supportedSULBandList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SupportedSULFreqBandItem')))
    _FreqBandNrItem_supportedSULBandList._cont = __FreqBandNrItem_supportedSULBandList__item_
    _FreqBandNrItem_supportedSULBandList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32)], ev=None, er=[])
    _FreqBandNrItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FreqBandNrItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___FreqBandNrItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____FreqBandNrItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____FreqBandNrItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FreqBandNrItem_iE_Extensions__item__id._const_tab = ____FreqBandNrItem_iE_Extensions__item__id_tab
    ___FreqBandNrItem_iE_Extensions__item__id._const_tab_at = None
    ___FreqBandNrItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___FreqBandNrItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FreqBandNrItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____FreqBandNrItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FreqBandNrItem_iE_Extensions__item__criticality._const_tab = ____FreqBandNrItem_iE_Extensions__item__criticality_tab
    ___FreqBandNrItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FreqBandNrItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FreqBandNrItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FreqBandNrItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____FreqBandNrItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FreqBandNrItem_iE_Extensions__item__extensionValue._const_tab = ____FreqBandNrItem_iE_Extensions__item__extensionValue_tab
    ___FreqBandNrItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FreqBandNrItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FreqBandNrItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FreqBandNrItem_iE_Extensions__item__id),
        ('criticality', ___FreqBandNrItem_iE_Extensions__item__criticality),
        ('extensionValue', ___FreqBandNrItem_iE_Extensions__item__extensionValue),
        ])
    __FreqBandNrItem_iE_Extensions__item_._ext = None
    _FreqBandNrItem_iE_Extensions._cont = __FreqBandNrItem_iE_Extensions__item_
    _FreqBandNrItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FreqBandNrItem._cont = ASN1Dict([
        ('freqBandIndicatorNr', _FreqBandNrItem_freqBandIndicatorNr),
        ('supportedSULBandList', _FreqBandNrItem_supportedSULBandList),
        ('iE-Extensions', _FreqBandNrItem_iE_Extensions),
        ])
    FreqBandNrItem._ext = []
    
    #-----< FreqBandNrItem-ExtIEs >-----#
    FreqBandNrItem_ExtIEs = CLASS(name='FreqBandNrItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    FreqBandNrItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FreqDomainLength >-----#
    FreqDomainLength = CHOICE(name='FreqDomainLength', mode=MODE_TYPE)
    _FreqDomainLength_l839 = SEQ(name='l839', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'L839Info')))
    _FreqDomainLength_l139 = SEQ(name='l139', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'L139Info')))
    _FreqDomainLength_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __FreqDomainLength_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___FreqDomainLength_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____FreqDomainLength_choice_extension_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'L571Info')))
    ____FreqDomainLength_choice_extension_id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'L1151Info')))
    ___FreqDomainLength_choice_extension_id_tab._val = ASN1Set(rv=[dict([('id', 659), ('criticality', 'reject'), ('Value', ____FreqDomainLength_choice_extension_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 660), ('criticality', 'reject'), ('Value', ____FreqDomainLength_choice_extension_id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __FreqDomainLength_choice_extension_id._const_tab = ___FreqDomainLength_choice_extension_id_tab
    __FreqDomainLength_choice_extension_id._const_tab_at = None
    __FreqDomainLength_choice_extension_id._const_tab_id = 'id'
    __FreqDomainLength_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __FreqDomainLength_choice_extension_criticality._const_tab = ___FreqDomainLength_choice_extension_id_tab
    __FreqDomainLength_choice_extension_criticality._const_tab_at = ('..', 'id')
    __FreqDomainLength_choice_extension_criticality._const_tab_id = 'criticality'
    __FreqDomainLength_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __FreqDomainLength_choice_extension_value._const_tab = ___FreqDomainLength_choice_extension_id_tab
    __FreqDomainLength_choice_extension_value._const_tab_at = ('..', 'id')
    __FreqDomainLength_choice_extension_value._const_tab_id = 'Value'
    _FreqDomainLength_choice_extension._cont = ASN1Dict([
        ('id', __FreqDomainLength_choice_extension_id),
        ('criticality', __FreqDomainLength_choice_extension_criticality),
        ('value', __FreqDomainLength_choice_extension_value),
        ])
    _FreqDomainLength_choice_extension._ext = None
    FreqDomainLength._cont = ASN1Dict([
        ('l839', _FreqDomainLength_l839),
        ('l139', _FreqDomainLength_l139),
        ('choice-extension', _FreqDomainLength_choice_extension),
        ])
    FreqDomainLength._ext = None
    
    #-----< FreqDomainLength-ExtIEs >-----#
    FreqDomainLength_ExtIEs = CLASS(name='FreqDomainLength-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _FreqDomainLength_ExtIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'L571Info')))
    _FreqDomainLength_ExtIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'L1151Info')))
    FreqDomainLength_ExtIEs._val = ASN1Set(rv=[dict([('id', 659), ('criticality', 'reject'), ('Value', _FreqDomainLength_ExtIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 660), ('criticality', 'reject'), ('Value', _FreqDomainLength_ExtIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< FreqInfoRel16 >-----#
    FreqInfoRel16 = SEQ(name='FreqInfoRel16', mode=MODE_TYPE)
    _FreqInfoRel16_nRARFCN = INT(name='nRARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _FreqInfoRel16_nRARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _FreqInfoRel16_frequencyShift7p5khz = ENUM(name='frequencyShift7p5khz', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FrequencyShift7p5khz')), opt=True)
    _FreqInfoRel16_carrierList = SEQ_OF(name='carrierList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')), opt=True)
    _FreqInfoRel16_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FreqInfoRel16_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___FreqInfoRel16_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____FreqInfoRel16_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____FreqInfoRel16_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FreqInfoRel16_iE_Extensions__item__id._const_tab = ____FreqInfoRel16_iE_Extensions__item__id_tab
    ___FreqInfoRel16_iE_Extensions__item__id._const_tab_at = None
    ___FreqInfoRel16_iE_Extensions__item__id._const_tab_id = 'id'
    ___FreqInfoRel16_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FreqInfoRel16_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____FreqInfoRel16_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FreqInfoRel16_iE_Extensions__item__criticality._const_tab = ____FreqInfoRel16_iE_Extensions__item__criticality_tab
    ___FreqInfoRel16_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FreqInfoRel16_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FreqInfoRel16_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FreqInfoRel16_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____FreqInfoRel16_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FreqInfoRel16_iE_Extensions__item__extensionValue._const_tab = ____FreqInfoRel16_iE_Extensions__item__extensionValue_tab
    ___FreqInfoRel16_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FreqInfoRel16_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FreqInfoRel16_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FreqInfoRel16_iE_Extensions__item__id),
        ('criticality', ___FreqInfoRel16_iE_Extensions__item__criticality),
        ('extensionValue', ___FreqInfoRel16_iE_Extensions__item__extensionValue),
        ])
    __FreqInfoRel16_iE_Extensions__item_._ext = None
    _FreqInfoRel16_iE_Extensions._cont = __FreqInfoRel16_iE_Extensions__item_
    _FreqInfoRel16_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FreqInfoRel16._cont = ASN1Dict([
        ('nRARFCN', _FreqInfoRel16_nRARFCN),
        ('frequencyShift7p5khz', _FreqInfoRel16_frequencyShift7p5khz),
        ('carrierList', _FreqInfoRel16_carrierList),
        ('iE-Extensions', _FreqInfoRel16_iE_Extensions),
        ])
    FreqInfoRel16._ext = []
    
    #-----< FreqInfoRel16-ExtIEs >-----#
    FreqInfoRel16_ExtIEs = CLASS(name='FreqInfoRel16-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    FreqInfoRel16_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FrequencyShift7p5khz >-----#
    FrequencyShift7p5khz = ENUM(name='FrequencyShift7p5khz', mode=MODE_TYPE)
    FrequencyShift7p5khz._cont = ASN1Dict([('false', 0), ('true', 1)])
    FrequencyShift7p5khz._ext = []
    
    #-----< Frequency-Domain-HSNA-Configuration-List >-----#
    Frequency_Domain_HSNA_Configuration_List = SEQ_OF(name='Frequency-Domain-HSNA-Configuration-List', mode=MODE_TYPE)
    _Frequency_Domain_HSNA_Configuration_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Frequency-Domain-HSNA-Configuration-Item')))
    Frequency_Domain_HSNA_Configuration_List._cont = _Frequency_Domain_HSNA_Configuration_List__item_
    Frequency_Domain_HSNA_Configuration_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Frequency-Domain-HSNA-Configuration-Item >-----#
    Frequency_Domain_HSNA_Configuration_Item = SEQ(name='Frequency-Domain-HSNA-Configuration-Item', mode=MODE_TYPE)
    _Frequency_Domain_HSNA_Configuration_Item_rBSetIndex = INT(name='rBSetIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Frequency_Domain_HSNA_Configuration_Item_rBSetIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=[], er=[])
    _Frequency_Domain_HSNA_Configuration_Item_frequency_Domain_HSNA_Slot_Configuration_List = SEQ_OF(name='frequency-Domain-HSNA-Slot-Configuration-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Frequency-Domain-HSNA-Slot-Configuration-List')))
    _Frequency_Domain_HSNA_Configuration_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__id._const_tab = ____Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__id_tab
    ___Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__id._const_tab_at = None
    ___Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__criticality._const_tab = ____Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__criticality_tab
    ___Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__extensionValue._const_tab = ____Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__extensionValue_tab
    ___Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__id),
        ('criticality', ___Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__extensionValue),
        ])
    __Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item_._ext = None
    _Frequency_Domain_HSNA_Configuration_Item_iE_Extensions._cont = __Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item_
    _Frequency_Domain_HSNA_Configuration_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Frequency_Domain_HSNA_Configuration_Item._cont = ASN1Dict([
        ('rBSetIndex', _Frequency_Domain_HSNA_Configuration_Item_rBSetIndex),
        ('frequency-Domain-HSNA-Slot-Configuration-List', _Frequency_Domain_HSNA_Configuration_Item_frequency_Domain_HSNA_Slot_Configuration_List),
        ('iE-Extensions', _Frequency_Domain_HSNA_Configuration_Item_iE_Extensions),
        ])
    Frequency_Domain_HSNA_Configuration_Item._ext = None
    
    #-----< Frequency-Domain-HSNA-Configuration-Item-ExtIEs >-----#
    Frequency_Domain_HSNA_Configuration_Item_ExtIEs = CLASS(name='Frequency-Domain-HSNA-Configuration-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Frequency_Domain_HSNA_Configuration_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Frequency-Domain-HSNA-Slot-Configuration-List >-----#
    Frequency_Domain_HSNA_Slot_Configuration_List = SEQ_OF(name='Frequency-Domain-HSNA-Slot-Configuration-List', mode=MODE_TYPE)
    _Frequency_Domain_HSNA_Slot_Configuration_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Frequency-Domain-HSNA-Slot-Configuration-Item')))
    Frequency_Domain_HSNA_Slot_Configuration_List._cont = _Frequency_Domain_HSNA_Slot_Configuration_List__item_
    Frequency_Domain_HSNA_Slot_Configuration_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5120)], ev=None, er=[])
    
    #-----< Frequency-Domain-HSNA-Slot-Configuration-Item >-----#
    Frequency_Domain_HSNA_Slot_Configuration_Item = SEQ(name='Frequency-Domain-HSNA-Slot-Configuration-Item', mode=MODE_TYPE)
    _Frequency_Domain_HSNA_Slot_Configuration_Item_slotIndex = INT(name='slotIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Frequency_Domain_HSNA_Slot_Configuration_Item_slotIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5119)], ev=None, er=[])
    _Frequency_Domain_HSNA_Slot_Configuration_Item_hSNADownlink = ENUM(name='hSNADownlink', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'HSNADownlink')), opt=True)
    _Frequency_Domain_HSNA_Slot_Configuration_Item_hSNAUplink = ENUM(name='hSNAUplink', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'HSNAUplink')), opt=True)
    _Frequency_Domain_HSNA_Slot_Configuration_Item_hSNAFlexible = ENUM(name='hSNAFlexible', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'HSNAFlexible')), opt=True)
    _Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__id._const_tab = ____Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__id_tab
    ___Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__id._const_tab_at = None
    ___Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__criticality._const_tab = ____Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__criticality_tab
    ___Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__extensionValue._const_tab = ____Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__extensionValue_tab
    ___Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__id),
        ('criticality', ___Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__extensionValue),
        ])
    __Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item_._ext = None
    _Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions._cont = __Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item_
    _Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Frequency_Domain_HSNA_Slot_Configuration_Item._cont = ASN1Dict([
        ('slotIndex', _Frequency_Domain_HSNA_Slot_Configuration_Item_slotIndex),
        ('hSNADownlink', _Frequency_Domain_HSNA_Slot_Configuration_Item_hSNADownlink),
        ('hSNAUplink', _Frequency_Domain_HSNA_Slot_Configuration_Item_hSNAUplink),
        ('hSNAFlexible', _Frequency_Domain_HSNA_Slot_Configuration_Item_hSNAFlexible),
        ('iE-Extensions', _Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions),
        ])
    Frequency_Domain_HSNA_Slot_Configuration_Item._ext = None
    
    #-----< Frequency-Domain-HSNA-Slot-Configuration-Item-ExtIEs >-----#
    Frequency_Domain_HSNA_Slot_Configuration_Item_ExtIEs = CLASS(name='Frequency-Domain-HSNA-Slot-Configuration-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Frequency_Domain_HSNA_Slot_Configuration_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FullConfiguration >-----#
    FullConfiguration = ENUM(name='FullConfiguration', mode=MODE_TYPE)
    FullConfiguration._cont = ASN1Dict([('full', 0)])
    FullConfiguration._ext = []
    
    #-----< FlowsMappedToSLDRB-List >-----#
    FlowsMappedToSLDRB_List = SEQ_OF(name='FlowsMappedToSLDRB-List', mode=MODE_TYPE)
    _FlowsMappedToSLDRB_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FlowsMappedToSLDRB-Item')))
    FlowsMappedToSLDRB_List._cont = _FlowsMappedToSLDRB_List__item_
    FlowsMappedToSLDRB_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    
    #-----< FlowsMappedToSLDRB-Item >-----#
    FlowsMappedToSLDRB_Item = SEQ(name='FlowsMappedToSLDRB-Item', mode=MODE_TYPE)
    _FlowsMappedToSLDRB_Item_pc5QoSFlowIdentifier = INT(name='pc5QoSFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PC5QoSFlowIdentifier')))
    _FlowsMappedToSLDRB_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FlowsMappedToSLDRB_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___FlowsMappedToSLDRB_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____FlowsMappedToSLDRB_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____FlowsMappedToSLDRB_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FlowsMappedToSLDRB_Item_iE_Extensions__item__id._const_tab = ____FlowsMappedToSLDRB_Item_iE_Extensions__item__id_tab
    ___FlowsMappedToSLDRB_Item_iE_Extensions__item__id._const_tab_at = None
    ___FlowsMappedToSLDRB_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___FlowsMappedToSLDRB_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FlowsMappedToSLDRB_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____FlowsMappedToSLDRB_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FlowsMappedToSLDRB_Item_iE_Extensions__item__criticality._const_tab = ____FlowsMappedToSLDRB_Item_iE_Extensions__item__criticality_tab
    ___FlowsMappedToSLDRB_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FlowsMappedToSLDRB_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FlowsMappedToSLDRB_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FlowsMappedToSLDRB_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____FlowsMappedToSLDRB_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FlowsMappedToSLDRB_Item_iE_Extensions__item__extensionValue._const_tab = ____FlowsMappedToSLDRB_Item_iE_Extensions__item__extensionValue_tab
    ___FlowsMappedToSLDRB_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FlowsMappedToSLDRB_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FlowsMappedToSLDRB_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FlowsMappedToSLDRB_Item_iE_Extensions__item__id),
        ('criticality', ___FlowsMappedToSLDRB_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___FlowsMappedToSLDRB_Item_iE_Extensions__item__extensionValue),
        ])
    __FlowsMappedToSLDRB_Item_iE_Extensions__item_._ext = None
    _FlowsMappedToSLDRB_Item_iE_Extensions._cont = __FlowsMappedToSLDRB_Item_iE_Extensions__item_
    _FlowsMappedToSLDRB_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FlowsMappedToSLDRB_Item._cont = ASN1Dict([
        ('pc5QoSFlowIdentifier', _FlowsMappedToSLDRB_Item_pc5QoSFlowIdentifier),
        ('iE-Extensions', _FlowsMappedToSLDRB_Item_iE_Extensions),
        ])
    FlowsMappedToSLDRB_Item._ext = []
    
    #-----< FlowsMappedToSLDRB-Item-ExtIEs >-----#
    FlowsMappedToSLDRB_Item_ExtIEs = CLASS(name='FlowsMappedToSLDRB-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    FlowsMappedToSLDRB_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GBR-QosInformation >-----#
    GBR_QosInformation = SEQ(name='GBR-QosInformation', mode=MODE_TYPE)
    _GBR_QosInformation_e_RAB_MaximumBitrateDL = INT(name='e-RAB-MaximumBitrateDL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _GBR_QosInformation_e_RAB_MaximumBitrateUL = INT(name='e-RAB-MaximumBitrateUL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _GBR_QosInformation_e_RAB_GuaranteedBitrateDL = INT(name='e-RAB-GuaranteedBitrateDL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _GBR_QosInformation_e_RAB_GuaranteedBitrateUL = INT(name='e-RAB-GuaranteedBitrateUL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _GBR_QosInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GBR_QosInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GBR_QosInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GBR_QosInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GBR_QosInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab = ____GBR_QosInformation_iE_Extensions__item__id_tab
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab_at = None
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___GBR_QosInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GBR_QosInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GBR_QosInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab = ____GBR_QosInformation_iE_Extensions__item__criticality_tab
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GBR_QosInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GBR_QosInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GBR_QosInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab = ____GBR_QosInformation_iE_Extensions__item__extensionValue_tab
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GBR_QosInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GBR_QosInformation_iE_Extensions__item__id),
        ('criticality', ___GBR_QosInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___GBR_QosInformation_iE_Extensions__item__extensionValue),
        ])
    __GBR_QosInformation_iE_Extensions__item_._ext = None
    _GBR_QosInformation_iE_Extensions._cont = __GBR_QosInformation_iE_Extensions__item_
    _GBR_QosInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GBR_QosInformation._cont = ASN1Dict([
        ('e-RAB-MaximumBitrateDL', _GBR_QosInformation_e_RAB_MaximumBitrateDL),
        ('e-RAB-MaximumBitrateUL', _GBR_QosInformation_e_RAB_MaximumBitrateUL),
        ('e-RAB-GuaranteedBitrateDL', _GBR_QosInformation_e_RAB_GuaranteedBitrateDL),
        ('e-RAB-GuaranteedBitrateUL', _GBR_QosInformation_e_RAB_GuaranteedBitrateUL),
        ('iE-Extensions', _GBR_QosInformation_iE_Extensions),
        ])
    GBR_QosInformation._ext = []
    
    #-----< GBR-QosInformation-ExtIEs >-----#
    GBR_QosInformation_ExtIEs = CLASS(name='GBR-QosInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    GBR_QosInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GBR-QoSFlowInformation >-----#
    GBR_QoSFlowInformation = SEQ(name='GBR-QoSFlowInformation', mode=MODE_TYPE)
    _GBR_QoSFlowInformation_maxFlowBitRateDownlink = INT(name='maxFlowBitRateDownlink', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _GBR_QoSFlowInformation_maxFlowBitRateUplink = INT(name='maxFlowBitRateUplink', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _GBR_QoSFlowInformation_guaranteedFlowBitRateDownlink = INT(name='guaranteedFlowBitRateDownlink', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _GBR_QoSFlowInformation_guaranteedFlowBitRateUplink = INT(name='guaranteedFlowBitRateUplink', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _GBR_QoSFlowInformation_maxPacketLossRateDownlink = INT(name='maxPacketLossRateDownlink', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MaxPacketLossRate')), opt=True)
    _GBR_QoSFlowInformation_maxPacketLossRateUplink = INT(name='maxPacketLossRateUplink', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MaxPacketLossRate')), opt=True)
    _GBR_QoSFlowInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GBR_QoSFlowInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GBR_QoSFlowInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GBR_QoSFlowInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____GBR_QoSFlowInformation_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AlternativeQoSParaSetList')))
    ____GBR_QoSFlowInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 343), ('criticality', 'ignore'), ('Extension', _____GBR_QoSFlowInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GBR_QoSFlowInformation_iE_Extensions__item__id._const_tab = ____GBR_QoSFlowInformation_iE_Extensions__item__id_tab
    ___GBR_QoSFlowInformation_iE_Extensions__item__id._const_tab_at = None
    ___GBR_QoSFlowInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___GBR_QoSFlowInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GBR_QoSFlowInformation_iE_Extensions__item__criticality._const_tab = ____GBR_QoSFlowInformation_iE_Extensions__item__id_tab
    ___GBR_QoSFlowInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GBR_QoSFlowInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GBR_QoSFlowInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GBR_QoSFlowInformation_iE_Extensions__item__extensionValue._const_tab = ____GBR_QoSFlowInformation_iE_Extensions__item__id_tab
    ___GBR_QoSFlowInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GBR_QoSFlowInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GBR_QoSFlowInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GBR_QoSFlowInformation_iE_Extensions__item__id),
        ('criticality', ___GBR_QoSFlowInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___GBR_QoSFlowInformation_iE_Extensions__item__extensionValue),
        ])
    __GBR_QoSFlowInformation_iE_Extensions__item_._ext = None
    _GBR_QoSFlowInformation_iE_Extensions._cont = __GBR_QoSFlowInformation_iE_Extensions__item_
    _GBR_QoSFlowInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GBR_QoSFlowInformation._cont = ASN1Dict([
        ('maxFlowBitRateDownlink', _GBR_QoSFlowInformation_maxFlowBitRateDownlink),
        ('maxFlowBitRateUplink', _GBR_QoSFlowInformation_maxFlowBitRateUplink),
        ('guaranteedFlowBitRateDownlink', _GBR_QoSFlowInformation_guaranteedFlowBitRateDownlink),
        ('guaranteedFlowBitRateUplink', _GBR_QoSFlowInformation_guaranteedFlowBitRateUplink),
        ('maxPacketLossRateDownlink', _GBR_QoSFlowInformation_maxPacketLossRateDownlink),
        ('maxPacketLossRateUplink', _GBR_QoSFlowInformation_maxPacketLossRateUplink),
        ('iE-Extensions', _GBR_QoSFlowInformation_iE_Extensions),
        ])
    GBR_QoSFlowInformation._ext = []
    
    #-----< GBR-QosFlowInformation-ExtIEs >-----#
    GBR_QosFlowInformation_ExtIEs = CLASS(name='GBR-QosFlowInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _GBR_QosFlowInformation_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AlternativeQoSParaSetList')))
    GBR_QosFlowInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 343), ('criticality', 'ignore'), ('Extension', _GBR_QosFlowInformation_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CG-Config >-----#
    CG_Config = OCT_STR(name='CG-Config', mode=MODE_TYPE)
    
    #-----< GeographicalCoordinates >-----#
    GeographicalCoordinates = SEQ(name='GeographicalCoordinates', mode=MODE_TYPE)
    _GeographicalCoordinates_tRPPositionDefinitionType = CHOICE(name='tRPPositionDefinitionType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPPositionDefinitionType')))
    _GeographicalCoordinates_dLPRSResourceCoordinates = SEQ(name='dLPRSResourceCoordinates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DLPRSResourceCoordinates')), opt=True)
    _GeographicalCoordinates_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GeographicalCoordinates_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GeographicalCoordinates_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GeographicalCoordinates_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____GeographicalCoordinates_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ARPLocationInformation')))
    ____GeographicalCoordinates_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 556), ('criticality', 'ignore'), ('Extension', _____GeographicalCoordinates_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GeographicalCoordinates_iE_Extensions__item__id._const_tab = ____GeographicalCoordinates_iE_Extensions__item__id_tab
    ___GeographicalCoordinates_iE_Extensions__item__id._const_tab_at = None
    ___GeographicalCoordinates_iE_Extensions__item__id._const_tab_id = 'id'
    ___GeographicalCoordinates_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GeographicalCoordinates_iE_Extensions__item__criticality._const_tab = ____GeographicalCoordinates_iE_Extensions__item__id_tab
    ___GeographicalCoordinates_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GeographicalCoordinates_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue._const_tab = ____GeographicalCoordinates_iE_Extensions__item__id_tab
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GeographicalCoordinates_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GeographicalCoordinates_iE_Extensions__item__id),
        ('criticality', ___GeographicalCoordinates_iE_Extensions__item__criticality),
        ('extensionValue', ___GeographicalCoordinates_iE_Extensions__item__extensionValue),
        ])
    __GeographicalCoordinates_iE_Extensions__item_._ext = None
    _GeographicalCoordinates_iE_Extensions._cont = __GeographicalCoordinates_iE_Extensions__item_
    _GeographicalCoordinates_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GeographicalCoordinates._cont = ASN1Dict([
        ('tRPPositionDefinitionType', _GeographicalCoordinates_tRPPositionDefinitionType),
        ('dLPRSResourceCoordinates', _GeographicalCoordinates_dLPRSResourceCoordinates),
        ('iE-Extensions', _GeographicalCoordinates_iE_Extensions),
        ])
    GeographicalCoordinates._ext = None
    
    #-----< GeographicalCoordinates-ExtIEs >-----#
    GeographicalCoordinates_ExtIEs = CLASS(name='GeographicalCoordinates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _GeographicalCoordinates_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ARPLocationInformation')))
    GeographicalCoordinates_ExtIEs._val = ASN1Set(rv=[dict([('id', 556), ('criticality', 'ignore'), ('Extension', _GeographicalCoordinates_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-MBS-F1AP-ID >-----#
    GNB_CU_MBS_F1AP_ID = INT(name='GNB-CU-MBS-F1AP-ID', mode=MODE_TYPE)
    GNB_CU_MBS_F1AP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< GNBCUMeasurementID >-----#
    GNBCUMeasurementID = INT(name='GNBCUMeasurementID', mode=MODE_TYPE)
    GNBCUMeasurementID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[])
    
    #-----< GNBDUMeasurementID >-----#
    GNBDUMeasurementID = INT(name='GNBDUMeasurementID', mode=MODE_TYPE)
    GNBDUMeasurementID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[])
    
    #-----< GNB-CUSystemInformation >-----#
    GNB_CUSystemInformation = SEQ(name='GNB-CUSystemInformation', mode=MODE_TYPE)
    _GNB_CUSystemInformation_sibtypetobeupdatedlist = SEQ_OF(name='sibtypetobeupdatedlist', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GNB_CUSystemInformation_sibtypetobeupdatedlist__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SibtypetobeupdatedListItem')))
    _GNB_CUSystemInformation_sibtypetobeupdatedlist._cont = __GNB_CUSystemInformation_sibtypetobeupdatedlist__item_
    _GNB_CUSystemInformation_sibtypetobeupdatedlist._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _GNB_CUSystemInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_CUSystemInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_CUSystemInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GNB_CUSystemInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____GNB_CUSystemInformation_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SystemInformationAreaID')))
    ____GNB_CUSystemInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 239), ('criticality', 'ignore'), ('Extension', _____GNB_CUSystemInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNB_CUSystemInformation_iE_Extensions__item__id._const_tab = ____GNB_CUSystemInformation_iE_Extensions__item__id_tab
    ___GNB_CUSystemInformation_iE_Extensions__item__id._const_tab_at = None
    ___GNB_CUSystemInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___GNB_CUSystemInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GNB_CUSystemInformation_iE_Extensions__item__criticality._const_tab = ____GNB_CUSystemInformation_iE_Extensions__item__id_tab
    ___GNB_CUSystemInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CUSystemInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GNB_CUSystemInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GNB_CUSystemInformation_iE_Extensions__item__extensionValue._const_tab = ____GNB_CUSystemInformation_iE_Extensions__item__id_tab
    ___GNB_CUSystemInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GNB_CUSystemInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GNB_CUSystemInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GNB_CUSystemInformation_iE_Extensions__item__id),
        ('criticality', ___GNB_CUSystemInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___GNB_CUSystemInformation_iE_Extensions__item__extensionValue),
        ])
    __GNB_CUSystemInformation_iE_Extensions__item_._ext = None
    _GNB_CUSystemInformation_iE_Extensions._cont = __GNB_CUSystemInformation_iE_Extensions__item_
    _GNB_CUSystemInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_CUSystemInformation._cont = ASN1Dict([
        ('sibtypetobeupdatedlist', _GNB_CUSystemInformation_sibtypetobeupdatedlist),
        ('iE-Extensions', _GNB_CUSystemInformation_iE_Extensions),
        ])
    GNB_CUSystemInformation._ext = []
    
    #-----< GNB-CUSystemInformation-ExtIEs >-----#
    GNB_CUSystemInformation_ExtIEs = CLASS(name='GNB-CUSystemInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _GNB_CUSystemInformation_ExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SystemInformationAreaID')))
    GNB_CUSystemInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 239), ('criticality', 'ignore'), ('Extension', _GNB_CUSystemInformation_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-TNL-Association-Setup-Item >-----#
    GNB_CU_TNL_Association_Setup_Item = SEQ(name='GNB-CU-TNL-Association-Setup-Item', mode=MODE_TYPE)
    _GNB_CU_TNL_Association_Setup_Item_tNLAssociationTransportLayerAddress = CHOICE(name='tNLAssociationTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CP-TransportLayerAddress')))
    _GNB_CU_TNL_Association_Setup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__id._const_tab = ____GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__id_tab
    ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__id._const_tab_at = None
    ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__criticality._const_tab = ____GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__criticality_tab
    ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__extensionValue._const_tab = ____GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__extensionValue_tab
    ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__id),
        ('criticality', ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__extensionValue),
        ])
    __GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item_._ext = None
    _GNB_CU_TNL_Association_Setup_Item_iE_Extensions._cont = __GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item_
    _GNB_CU_TNL_Association_Setup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_CU_TNL_Association_Setup_Item._cont = ASN1Dict([
        ('tNLAssociationTransportLayerAddress', _GNB_CU_TNL_Association_Setup_Item_tNLAssociationTransportLayerAddress),
        ('iE-Extensions', _GNB_CU_TNL_Association_Setup_Item_iE_Extensions),
        ])
    GNB_CU_TNL_Association_Setup_Item._ext = None
    
    #-----< GNB-CU-TNL-Association-Setup-Item-ExtIEs >-----#
    GNB_CU_TNL_Association_Setup_Item_ExtIEs = CLASS(name='GNB-CU-TNL-Association-Setup-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    GNB_CU_TNL_Association_Setup_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-TNL-Association-Failed-To-Setup-Item >-----#
    GNB_CU_TNL_Association_Failed_To_Setup_Item = SEQ(name='GNB-CU-TNL-Association-Failed-To-Setup-Item', mode=MODE_TYPE)
    _GNB_CU_TNL_Association_Failed_To_Setup_Item_tNLAssociationTransportLayerAddress = CHOICE(name='tNLAssociationTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CP-TransportLayerAddress')))
    _GNB_CU_TNL_Association_Failed_To_Setup_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__id._const_tab = ____GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__id_tab
    ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__id._const_tab_at = None
    ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__criticality._const_tab = ____GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__criticality_tab
    ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__extensionValue._const_tab = ____GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__extensionValue_tab
    ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__id),
        ('criticality', ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__extensionValue),
        ])
    __GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item_._ext = None
    _GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions._cont = __GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item_
    _GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_CU_TNL_Association_Failed_To_Setup_Item._cont = ASN1Dict([
        ('tNLAssociationTransportLayerAddress', _GNB_CU_TNL_Association_Failed_To_Setup_Item_tNLAssociationTransportLayerAddress),
        ('cause', _GNB_CU_TNL_Association_Failed_To_Setup_Item_cause),
        ('iE-Extensions', _GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions),
        ])
    GNB_CU_TNL_Association_Failed_To_Setup_Item._ext = None
    
    #-----< GNB-CU-TNL-Association-Failed-To-Setup-Item-ExtIEs >-----#
    GNB_CU_TNL_Association_Failed_To_Setup_Item_ExtIEs = CLASS(name='GNB-CU-TNL-Association-Failed-To-Setup-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    GNB_CU_TNL_Association_Failed_To_Setup_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-TNL-Association-To-Add-Item >-----#
    GNB_CU_TNL_Association_To_Add_Item = SEQ(name='GNB-CU-TNL-Association-To-Add-Item', mode=MODE_TYPE)
    _GNB_CU_TNL_Association_To_Add_Item_tNLAssociationTransportLayerAddress = CHOICE(name='tNLAssociationTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CP-TransportLayerAddress')))
    _GNB_CU_TNL_Association_To_Add_Item_tNLAssociationUsage = ENUM(name='tNLAssociationUsage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TNLAssociationUsage')))
    _GNB_CU_TNL_Association_To_Add_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__id._const_tab = ____GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__id_tab
    ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__id._const_tab_at = None
    ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__criticality._const_tab = ____GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__criticality_tab
    ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__extensionValue._const_tab = ____GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__extensionValue_tab
    ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__id),
        ('criticality', ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__extensionValue),
        ])
    __GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item_._ext = None
    _GNB_CU_TNL_Association_To_Add_Item_iE_Extensions._cont = __GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item_
    _GNB_CU_TNL_Association_To_Add_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_CU_TNL_Association_To_Add_Item._cont = ASN1Dict([
        ('tNLAssociationTransportLayerAddress', _GNB_CU_TNL_Association_To_Add_Item_tNLAssociationTransportLayerAddress),
        ('tNLAssociationUsage', _GNB_CU_TNL_Association_To_Add_Item_tNLAssociationUsage),
        ('iE-Extensions', _GNB_CU_TNL_Association_To_Add_Item_iE_Extensions),
        ])
    GNB_CU_TNL_Association_To_Add_Item._ext = None
    
    #-----< GNB-CU-TNL-Association-To-Add-Item-ExtIEs >-----#
    GNB_CU_TNL_Association_To_Add_Item_ExtIEs = CLASS(name='GNB-CU-TNL-Association-To-Add-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    GNB_CU_TNL_Association_To_Add_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-TNL-Association-To-Remove-Item >-----#
    GNB_CU_TNL_Association_To_Remove_Item = SEQ(name='GNB-CU-TNL-Association-To-Remove-Item', mode=MODE_TYPE)
    _GNB_CU_TNL_Association_To_Remove_Item_tNLAssociationTransportLayerAddress = CHOICE(name='tNLAssociationTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CP-TransportLayerAddress')))
    _GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CP-TransportLayerAddress')))
    ____GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 229), ('criticality', 'reject'), ('Extension', _____GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id._const_tab = ____GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab
    ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id._const_tab_at = None
    ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality._const_tab = ____GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab
    ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab = ____GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab
    ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id),
        ('criticality', ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue),
        ])
    __GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item_._ext = None
    _GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions._cont = __GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item_
    _GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_CU_TNL_Association_To_Remove_Item._cont = ASN1Dict([
        ('tNLAssociationTransportLayerAddress', _GNB_CU_TNL_Association_To_Remove_Item_tNLAssociationTransportLayerAddress),
        ('iE-Extensions', _GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions),
        ])
    GNB_CU_TNL_Association_To_Remove_Item._ext = None
    
    #-----< GNB-CU-TNL-Association-To-Remove-Item-ExtIEs >-----#
    GNB_CU_TNL_Association_To_Remove_Item_ExtIEs = CLASS(name='GNB-CU-TNL-Association-To-Remove-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _GNB_CU_TNL_Association_To_Remove_Item_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CP-TransportLayerAddress')))
    GNB_CU_TNL_Association_To_Remove_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 229), ('criticality', 'reject'), ('Extension', _GNB_CU_TNL_Association_To_Remove_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-TNL-Association-To-Update-Item >-----#
    GNB_CU_TNL_Association_To_Update_Item = SEQ(name='GNB-CU-TNL-Association-To-Update-Item', mode=MODE_TYPE)
    _GNB_CU_TNL_Association_To_Update_Item_tNLAssociationTransportLayerAddress = CHOICE(name='tNLAssociationTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CP-TransportLayerAddress')))
    _GNB_CU_TNL_Association_To_Update_Item_tNLAssociationUsage = ENUM(name='tNLAssociationUsage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TNLAssociationUsage')), opt=True)
    _GNB_CU_TNL_Association_To_Update_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__id._const_tab = ____GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__id_tab
    ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__id._const_tab_at = None
    ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__criticality._const_tab = ____GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__criticality_tab
    ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__extensionValue._const_tab = ____GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__extensionValue_tab
    ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__id),
        ('criticality', ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__extensionValue),
        ])
    __GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item_._ext = None
    _GNB_CU_TNL_Association_To_Update_Item_iE_Extensions._cont = __GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item_
    _GNB_CU_TNL_Association_To_Update_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_CU_TNL_Association_To_Update_Item._cont = ASN1Dict([
        ('tNLAssociationTransportLayerAddress', _GNB_CU_TNL_Association_To_Update_Item_tNLAssociationTransportLayerAddress),
        ('tNLAssociationUsage', _GNB_CU_TNL_Association_To_Update_Item_tNLAssociationUsage),
        ('iE-Extensions', _GNB_CU_TNL_Association_To_Update_Item_iE_Extensions),
        ])
    GNB_CU_TNL_Association_To_Update_Item._ext = None
    
    #-----< GNB-CU-TNL-Association-To-Update-Item-ExtIEs >-----#
    GNB_CU_TNL_Association_To_Update_Item_ExtIEs = CLASS(name='GNB-CU-TNL-Association-To-Update-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    GNB_CU_TNL_Association_To_Update_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-UE-F1AP-ID >-----#
    GNB_CU_UE_F1AP_ID = INT(name='GNB-CU-UE-F1AP-ID', mode=MODE_TYPE)
    GNB_CU_UE_F1AP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< GNB-DU-Cell-Resource-Configuration >-----#
    GNB_DU_Cell_Resource_Configuration = SEQ(name='GNB-DU-Cell-Resource-Configuration', mode=MODE_TYPE)
    _GNB_DU_Cell_Resource_Configuration_subcarrierSpacing = ENUM(name='subcarrierSpacing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SubcarrierSpacing')))
    _GNB_DU_Cell_Resource_Configuration_dUFTransmissionPeriodicity = ENUM(name='dUFTransmissionPeriodicity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DUFTransmissionPeriodicity')), opt=True)
    _GNB_DU_Cell_Resource_Configuration_dUF_Slot_Config_List = SEQ_OF(name='dUF-Slot-Config-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DUF-Slot-Config-List')), opt=True)
    _GNB_DU_Cell_Resource_Configuration_hSNATransmissionPeriodicity = ENUM(name='hSNATransmissionPeriodicity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'HSNATransmissionPeriodicity')))
    _GNB_DU_Cell_Resource_Configuration_hsNSASlotConfigList = SEQ_OF(name='hsNSASlotConfigList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'HSNASlotConfigList')), opt=True)
    _GNB_DU_Cell_Resource_Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_DU_Cell_Resource_Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RBSetConfiguration')))
    _____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Frequency-Domain-HSNA-Configuration-List')))
    _____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Child-IAB-Nodes-NA-Resource-List')))
    _____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Parent-IAB-Nodes-NA-Resource-Configuration-List')))
    ____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 520), ('criticality', 'reject'), ('Extension', _____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 521), ('criticality', 'reject'), ('Extension', _____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 522), ('criticality', 'reject'), ('Extension', _____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 523), ('criticality', 'reject'), ('Extension', _____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id._const_tab = ____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id_tab
    ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id._const_tab_at = None
    ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__criticality._const_tab = ____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id_tab
    ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__extensionValue._const_tab = ____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id_tab
    ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GNB_DU_Cell_Resource_Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id),
        ('criticality', ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__extensionValue),
        ])
    __GNB_DU_Cell_Resource_Configuration_iE_Extensions__item_._ext = None
    _GNB_DU_Cell_Resource_Configuration_iE_Extensions._cont = __GNB_DU_Cell_Resource_Configuration_iE_Extensions__item_
    _GNB_DU_Cell_Resource_Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_DU_Cell_Resource_Configuration._cont = ASN1Dict([
        ('subcarrierSpacing', _GNB_DU_Cell_Resource_Configuration_subcarrierSpacing),
        ('dUFTransmissionPeriodicity', _GNB_DU_Cell_Resource_Configuration_dUFTransmissionPeriodicity),
        ('dUF-Slot-Config-List', _GNB_DU_Cell_Resource_Configuration_dUF_Slot_Config_List),
        ('hSNATransmissionPeriodicity', _GNB_DU_Cell_Resource_Configuration_hSNATransmissionPeriodicity),
        ('hsNSASlotConfigList', _GNB_DU_Cell_Resource_Configuration_hsNSASlotConfigList),
        ('iE-Extensions', _GNB_DU_Cell_Resource_Configuration_iE_Extensions),
        ])
    GNB_DU_Cell_Resource_Configuration._ext = None
    
    #-----< GNB-DU-Cell-Resource-Configuration-ExtIEs >-----#
    GNB_DU_Cell_Resource_Configuration_ExtIEs = CLASS(name='GNB-DU-Cell-Resource-Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _GNB_DU_Cell_Resource_Configuration_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RBSetConfiguration')))
    _GNB_DU_Cell_Resource_Configuration_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Frequency-Domain-HSNA-Configuration-List')))
    _GNB_DU_Cell_Resource_Configuration_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Child-IAB-Nodes-NA-Resource-List')))
    _GNB_DU_Cell_Resource_Configuration_ExtIEs_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Parent-IAB-Nodes-NA-Resource-Configuration-List')))
    GNB_DU_Cell_Resource_Configuration_ExtIEs._val = ASN1Set(rv=[dict([('id', 520), ('criticality', 'reject'), ('Extension', _GNB_DU_Cell_Resource_Configuration_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 521), ('criticality', 'reject'), ('Extension', _GNB_DU_Cell_Resource_Configuration_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 522), ('criticality', 'reject'), ('Extension', _GNB_DU_Cell_Resource_Configuration_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 523), ('criticality', 'reject'), ('Extension', _GNB_DU_Cell_Resource_Configuration_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNB-DU-MBS-F1AP-ID >-----#
    GNB_DU_MBS_F1AP_ID = INT(name='GNB-DU-MBS-F1AP-ID', mode=MODE_TYPE)
    GNB_DU_MBS_F1AP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< GNB-DU-UE-F1AP-ID >-----#
    GNB_DU_UE_F1AP_ID = INT(name='GNB-DU-UE-F1AP-ID', mode=MODE_TYPE)
    GNB_DU_UE_F1AP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< GNB-DU-ID >-----#
    GNB_DU_ID = INT(name='GNB-DU-ID', mode=MODE_TYPE)
    GNB_DU_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=68719476735)], ev=None, er=[])
    
    #-----< GNB-CU-Name >-----#
    GNB_CU_Name = STR_PRINT(name='GNB-CU-Name', mode=MODE_TYPE)
    GNB_CU_Name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< GNB-DU-Name >-----#
    GNB_DU_Name = STR_PRINT(name='GNB-DU-Name', mode=MODE_TYPE)
    GNB_DU_Name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< Extended-GNB-CU-Name >-----#
    Extended_GNB_CU_Name = SEQ(name='Extended-GNB-CU-Name', mode=MODE_TYPE)
    _Extended_GNB_CU_Name_gNB_CU_NameVisibleString = STR_VIS(name='gNB-CU-NameVisibleString', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-NameVisibleString')), opt=True)
    _Extended_GNB_CU_Name_gNB_CU_NameUTF8String = STR_UTF8(name='gNB-CU-NameUTF8String', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-NameUTF8String')), opt=True)
    _Extended_GNB_CU_Name_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Extended_GNB_CU_Name_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Extended_GNB_CU_Name_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Extended_GNB_CU_Name_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Extended_GNB_CU_Name_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_GNB_CU_Name_iE_Extensions__item__id._const_tab = ____Extended_GNB_CU_Name_iE_Extensions__item__id_tab
    ___Extended_GNB_CU_Name_iE_Extensions__item__id._const_tab_at = None
    ___Extended_GNB_CU_Name_iE_Extensions__item__id._const_tab_id = 'id'
    ___Extended_GNB_CU_Name_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Extended_GNB_CU_Name_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Extended_GNB_CU_Name_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_GNB_CU_Name_iE_Extensions__item__criticality._const_tab = ____Extended_GNB_CU_Name_iE_Extensions__item__criticality_tab
    ___Extended_GNB_CU_Name_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Extended_GNB_CU_Name_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Extended_GNB_CU_Name_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Extended_GNB_CU_Name_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Extended_GNB_CU_Name_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_GNB_CU_Name_iE_Extensions__item__extensionValue._const_tab = ____Extended_GNB_CU_Name_iE_Extensions__item__extensionValue_tab
    ___Extended_GNB_CU_Name_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Extended_GNB_CU_Name_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Extended_GNB_CU_Name_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Extended_GNB_CU_Name_iE_Extensions__item__id),
        ('criticality', ___Extended_GNB_CU_Name_iE_Extensions__item__criticality),
        ('extensionValue', ___Extended_GNB_CU_Name_iE_Extensions__item__extensionValue),
        ])
    __Extended_GNB_CU_Name_iE_Extensions__item_._ext = None
    _Extended_GNB_CU_Name_iE_Extensions._cont = __Extended_GNB_CU_Name_iE_Extensions__item_
    _Extended_GNB_CU_Name_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Extended_GNB_CU_Name._cont = ASN1Dict([
        ('gNB-CU-NameVisibleString', _Extended_GNB_CU_Name_gNB_CU_NameVisibleString),
        ('gNB-CU-NameUTF8String', _Extended_GNB_CU_Name_gNB_CU_NameUTF8String),
        ('iE-Extensions', _Extended_GNB_CU_Name_iE_Extensions),
        ])
    Extended_GNB_CU_Name._ext = []
    
    #-----< Extended-GNB-CU-Name-ExtIEs >-----#
    Extended_GNB_CU_Name_ExtIEs = CLASS(name='Extended-GNB-CU-Name-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Extended_GNB_CU_Name_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-NameVisibleString >-----#
    GNB_CU_NameVisibleString = STR_VIS(name='GNB-CU-NameVisibleString', mode=MODE_TYPE)
    GNB_CU_NameVisibleString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< GNB-CU-NameUTF8String >-----#
    GNB_CU_NameUTF8String = STR_UTF8(name='GNB-CU-NameUTF8String', mode=MODE_TYPE)
    GNB_CU_NameUTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< Extended-GNB-DU-Name >-----#
    Extended_GNB_DU_Name = SEQ(name='Extended-GNB-DU-Name', mode=MODE_TYPE)
    _Extended_GNB_DU_Name_gNB_DU_NameVisibleString = STR_VIS(name='gNB-DU-NameVisibleString', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-NameVisibleString')), opt=True)
    _Extended_GNB_DU_Name_gNB_DU_NameUTF8String = STR_UTF8(name='gNB-DU-NameUTF8String', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-NameUTF8String')), opt=True)
    _Extended_GNB_DU_Name_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Extended_GNB_DU_Name_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Extended_GNB_DU_Name_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Extended_GNB_DU_Name_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Extended_GNB_DU_Name_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_GNB_DU_Name_iE_Extensions__item__id._const_tab = ____Extended_GNB_DU_Name_iE_Extensions__item__id_tab
    ___Extended_GNB_DU_Name_iE_Extensions__item__id._const_tab_at = None
    ___Extended_GNB_DU_Name_iE_Extensions__item__id._const_tab_id = 'id'
    ___Extended_GNB_DU_Name_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Extended_GNB_DU_Name_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Extended_GNB_DU_Name_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_GNB_DU_Name_iE_Extensions__item__criticality._const_tab = ____Extended_GNB_DU_Name_iE_Extensions__item__criticality_tab
    ___Extended_GNB_DU_Name_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Extended_GNB_DU_Name_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Extended_GNB_DU_Name_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Extended_GNB_DU_Name_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Extended_GNB_DU_Name_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_GNB_DU_Name_iE_Extensions__item__extensionValue._const_tab = ____Extended_GNB_DU_Name_iE_Extensions__item__extensionValue_tab
    ___Extended_GNB_DU_Name_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Extended_GNB_DU_Name_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Extended_GNB_DU_Name_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Extended_GNB_DU_Name_iE_Extensions__item__id),
        ('criticality', ___Extended_GNB_DU_Name_iE_Extensions__item__criticality),
        ('extensionValue', ___Extended_GNB_DU_Name_iE_Extensions__item__extensionValue),
        ])
    __Extended_GNB_DU_Name_iE_Extensions__item_._ext = None
    _Extended_GNB_DU_Name_iE_Extensions._cont = __Extended_GNB_DU_Name_iE_Extensions__item_
    _Extended_GNB_DU_Name_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Extended_GNB_DU_Name._cont = ASN1Dict([
        ('gNB-DU-NameVisibleString', _Extended_GNB_DU_Name_gNB_DU_NameVisibleString),
        ('gNB-DU-NameUTF8String', _Extended_GNB_DU_Name_gNB_DU_NameUTF8String),
        ('iE-Extensions', _Extended_GNB_DU_Name_iE_Extensions),
        ])
    Extended_GNB_DU_Name._ext = []
    
    #-----< Extended-GNB-DU-Name-ExtIEs >-----#
    Extended_GNB_DU_Name_ExtIEs = CLASS(name='Extended-GNB-DU-Name-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Extended_GNB_DU_Name_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-DU-NameVisibleString >-----#
    GNB_DU_NameVisibleString = STR_VIS(name='GNB-DU-NameVisibleString', mode=MODE_TYPE)
    GNB_DU_NameVisibleString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< GNB-DU-NameUTF8String >-----#
    GNB_DU_NameUTF8String = STR_UTF8(name='GNB-DU-NameUTF8String', mode=MODE_TYPE)
    GNB_DU_NameUTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< GNB-DU-Served-Cells-Item >-----#
    GNB_DU_Served_Cells_Item = SEQ(name='GNB-DU-Served-Cells-Item', mode=MODE_TYPE)
    _GNB_DU_Served_Cells_Item_served_Cell_Information = SEQ(name='served-Cell-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Served-Cell-Information')))
    _GNB_DU_Served_Cells_Item_gNB_DU_System_Information = SEQ(name='gNB-DU-System-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-System-Information')), opt=True)
    _GNB_DU_Served_Cells_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_DU_Served_Cells_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_DU_Served_Cells_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GNB_DU_Served_Cells_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_DU_Served_Cells_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_DU_Served_Cells_Item_iE_Extensions__item__id._const_tab = ____GNB_DU_Served_Cells_Item_iE_Extensions__item__id_tab
    ___GNB_DU_Served_Cells_Item_iE_Extensions__item__id._const_tab_at = None
    ___GNB_DU_Served_Cells_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___GNB_DU_Served_Cells_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GNB_DU_Served_Cells_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_DU_Served_Cells_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_DU_Served_Cells_Item_iE_Extensions__item__criticality._const_tab = ____GNB_DU_Served_Cells_Item_iE_Extensions__item__criticality_tab
    ___GNB_DU_Served_Cells_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_DU_Served_Cells_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GNB_DU_Served_Cells_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GNB_DU_Served_Cells_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_DU_Served_Cells_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_DU_Served_Cells_Item_iE_Extensions__item__extensionValue._const_tab = ____GNB_DU_Served_Cells_Item_iE_Extensions__item__extensionValue_tab
    ___GNB_DU_Served_Cells_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GNB_DU_Served_Cells_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GNB_DU_Served_Cells_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GNB_DU_Served_Cells_Item_iE_Extensions__item__id),
        ('criticality', ___GNB_DU_Served_Cells_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___GNB_DU_Served_Cells_Item_iE_Extensions__item__extensionValue),
        ])
    __GNB_DU_Served_Cells_Item_iE_Extensions__item_._ext = None
    _GNB_DU_Served_Cells_Item_iE_Extensions._cont = __GNB_DU_Served_Cells_Item_iE_Extensions__item_
    _GNB_DU_Served_Cells_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_DU_Served_Cells_Item._cont = ASN1Dict([
        ('served-Cell-Information', _GNB_DU_Served_Cells_Item_served_Cell_Information),
        ('gNB-DU-System-Information', _GNB_DU_Served_Cells_Item_gNB_DU_System_Information),
        ('iE-Extensions', _GNB_DU_Served_Cells_Item_iE_Extensions),
        ])
    GNB_DU_Served_Cells_Item._ext = []
    
    #-----< GNB-DU-Served-Cells-ItemExtIEs >-----#
    GNB_DU_Served_Cells_ItemExtIEs = CLASS(name='GNB-DU-Served-Cells-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    GNB_DU_Served_Cells_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-DU-System-Information >-----#
    GNB_DU_System_Information = SEQ(name='GNB-DU-System-Information', mode=MODE_TYPE)
    _GNB_DU_System_Information_mIB_message = OCT_STR(name='mIB-message', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MIB-message')))
    _GNB_DU_System_Information_sIB1_message = OCT_STR(name='sIB1-message', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SIB1-message')))
    _GNB_DU_System_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_DU_System_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_DU_System_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GNB_DU_System_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SIB12-message')))
    _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SIB13-message')))
    _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SIB14-message')))
    _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_3 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SIB10-message')))
    _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_4 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SIB17-message')))
    _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_5 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SIB20-message')))
    _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_6 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SIB15-message')))
    ____GNB_DU_System_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 310), ('criticality', 'ignore'), ('Extension', _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 311), ('criticality', 'ignore'), ('Extension', _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 312), ('criticality', 'ignore'), ('Extension', _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 387), ('criticality', 'ignore'), ('Extension', _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 625), ('criticality', 'ignore'), ('Extension', _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 627), ('criticality', 'ignore'), ('Extension', _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 648), ('criticality', 'ignore'), ('Extension', _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNB_DU_System_Information_iE_Extensions__item__id._const_tab = ____GNB_DU_System_Information_iE_Extensions__item__id_tab
    ___GNB_DU_System_Information_iE_Extensions__item__id._const_tab_at = None
    ___GNB_DU_System_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___GNB_DU_System_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GNB_DU_System_Information_iE_Extensions__item__criticality._const_tab = ____GNB_DU_System_Information_iE_Extensions__item__id_tab
    ___GNB_DU_System_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_DU_System_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GNB_DU_System_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GNB_DU_System_Information_iE_Extensions__item__extensionValue._const_tab = ____GNB_DU_System_Information_iE_Extensions__item__id_tab
    ___GNB_DU_System_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GNB_DU_System_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GNB_DU_System_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GNB_DU_System_Information_iE_Extensions__item__id),
        ('criticality', ___GNB_DU_System_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___GNB_DU_System_Information_iE_Extensions__item__extensionValue),
        ])
    __GNB_DU_System_Information_iE_Extensions__item_._ext = None
    _GNB_DU_System_Information_iE_Extensions._cont = __GNB_DU_System_Information_iE_Extensions__item_
    _GNB_DU_System_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_DU_System_Information._cont = ASN1Dict([
        ('mIB-message', _GNB_DU_System_Information_mIB_message),
        ('sIB1-message', _GNB_DU_System_Information_sIB1_message),
        ('iE-Extensions', _GNB_DU_System_Information_iE_Extensions),
        ])
    GNB_DU_System_Information._ext = []
    
    #-----< GNB-DU-System-Information-ExtIEs >-----#
    GNB_DU_System_Information_ExtIEs = CLASS(name='GNB-DU-System-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _GNB_DU_System_Information_ExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SIB12-message')))
    _GNB_DU_System_Information_ExtIEs_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SIB13-message')))
    _GNB_DU_System_Information_ExtIEs_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SIB14-message')))
    _GNB_DU_System_Information_ExtIEs_val_Extension_3 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SIB10-message')))
    _GNB_DU_System_Information_ExtIEs_val_Extension_4 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SIB17-message')))
    _GNB_DU_System_Information_ExtIEs_val_Extension_5 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SIB20-message')))
    _GNB_DU_System_Information_ExtIEs_val_Extension_6 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SIB15-message')))
    GNB_DU_System_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 310), ('criticality', 'ignore'), ('Extension', _GNB_DU_System_Information_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 311), ('criticality', 'ignore'), ('Extension', _GNB_DU_System_Information_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 312), ('criticality', 'ignore'), ('Extension', _GNB_DU_System_Information_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 387), ('criticality', 'ignore'), ('Extension', _GNB_DU_System_Information_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 625), ('criticality', 'ignore'), ('Extension', _GNB_DU_System_Information_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 627), ('criticality', 'ignore'), ('Extension', _GNB_DU_System_Information_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 648), ('criticality', 'ignore'), ('Extension', _GNB_DU_System_Information_ExtIEs_val_Extension_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNB-DUConfigurationQuery >-----#
    GNB_DUConfigurationQuery = ENUM(name='GNB-DUConfigurationQuery', mode=MODE_TYPE)
    GNB_DUConfigurationQuery._cont = ASN1Dict([('true', 0)])
    GNB_DUConfigurationQuery._ext = []
    
    #-----< GNBDUOverloadInformation >-----#
    GNBDUOverloadInformation = ENUM(name='GNBDUOverloadInformation', mode=MODE_TYPE)
    GNBDUOverloadInformation._cont = ASN1Dict([('overloaded', 0), ('not-overloaded', 1)])
    GNBDUOverloadInformation._ext = None
    
    #-----< GNB-DU-TNL-Association-To-Remove-Item >-----#
    GNB_DU_TNL_Association_To_Remove_Item = SEQ(name='GNB-DU-TNL-Association-To-Remove-Item', mode=MODE_TYPE)
    _GNB_DU_TNL_Association_To_Remove_Item_tNLAssociationTransportLayerAddress = CHOICE(name='tNLAssociationTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CP-TransportLayerAddress')))
    _GNB_DU_TNL_Association_To_Remove_Item_tNLAssociationTransportLayerAddressgNBCU = CHOICE(name='tNLAssociationTransportLayerAddressgNBCU', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CP-TransportLayerAddress')), opt=True)
    _GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__id._const_tab = ____GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab
    ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__id._const_tab_at = None
    ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality._const_tab = ____GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality_tab
    ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab = ____GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue_tab
    ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__id),
        ('criticality', ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue),
        ])
    __GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item_._ext = None
    _GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions._cont = __GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item_
    _GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_DU_TNL_Association_To_Remove_Item._cont = ASN1Dict([
        ('tNLAssociationTransportLayerAddress', _GNB_DU_TNL_Association_To_Remove_Item_tNLAssociationTransportLayerAddress),
        ('tNLAssociationTransportLayerAddressgNBCU', _GNB_DU_TNL_Association_To_Remove_Item_tNLAssociationTransportLayerAddressgNBCU),
        ('iE-Extensions', _GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions),
        ])
    GNB_DU_TNL_Association_To_Remove_Item._ext = None
    
    #-----< GNB-DU-TNL-Association-To-Remove-Item-ExtIEs >-----#
    GNB_DU_TNL_Association_To_Remove_Item_ExtIEs = CLASS(name='GNB-DU-TNL-Association-To-Remove-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    GNB_DU_TNL_Association_To_Remove_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNBDUUESliceMaximumBitRateList >-----#
    GNBDUUESliceMaximumBitRateList = SEQ_OF(name='GNBDUUESliceMaximumBitRateList', mode=MODE_TYPE)
    _GNBDUUESliceMaximumBitRateList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBDUUESliceMaximumBitRateItem')))
    GNBDUUESliceMaximumBitRateList._cont = _GNBDUUESliceMaximumBitRateList__item_
    GNBDUUESliceMaximumBitRateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< GNBDUUESliceMaximumBitRateItem >-----#
    GNBDUUESliceMaximumBitRateItem = SEQ(name='GNBDUUESliceMaximumBitRateItem', mode=MODE_TYPE)
    _GNBDUUESliceMaximumBitRateItem_sNSSAI = SEQ(name='sNSSAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SNSSAI')))
    _GNBDUUESliceMaximumBitRateItem_uESliceMaximumBitRateUL = INT(name='uESliceMaximumBitRateUL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _GNBDUUESliceMaximumBitRateItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNBDUUESliceMaximumBitRateItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__id._const_tab = ____GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__id_tab
    ___GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__id._const_tab_at = None
    ___GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__criticality._const_tab = ____GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__criticality_tab
    ___GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__extensionValue._const_tab = ____GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__extensionValue_tab
    ___GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GNBDUUESliceMaximumBitRateItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__id),
        ('criticality', ___GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__criticality),
        ('extensionValue', ___GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__extensionValue),
        ])
    __GNBDUUESliceMaximumBitRateItem_iE_Extensions__item_._ext = None
    _GNBDUUESliceMaximumBitRateItem_iE_Extensions._cont = __GNBDUUESliceMaximumBitRateItem_iE_Extensions__item_
    _GNBDUUESliceMaximumBitRateItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNBDUUESliceMaximumBitRateItem._cont = ASN1Dict([
        ('sNSSAI', _GNBDUUESliceMaximumBitRateItem_sNSSAI),
        ('uESliceMaximumBitRateUL', _GNBDUUESliceMaximumBitRateItem_uESliceMaximumBitRateUL),
        ('iE-Extensions', _GNBDUUESliceMaximumBitRateItem_iE_Extensions),
        ])
    GNBDUUESliceMaximumBitRateItem._ext = []
    
    #-----< GNBDUUESliceMaximumBitRateItem-ExtIEs >-----#
    GNBDUUESliceMaximumBitRateItem_ExtIEs = CLASS(name='GNBDUUESliceMaximumBitRateItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    GNBDUUESliceMaximumBitRateItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-RxTxTimeDiff >-----#
    GNB_RxTxTimeDiff = SEQ(name='GNB-RxTxTimeDiff', mode=MODE_TYPE)
    _GNB_RxTxTimeDiff_rxTxTimeDiff = CHOICE(name='rxTxTimeDiff', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNBRxTxTimeDiffMeas')))
    _GNB_RxTxTimeDiff_additionalPath_List = SEQ_OF(name='additionalPath-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPath-List')), opt=True)
    _GNB_RxTxTimeDiff_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_RxTxTimeDiff_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_RxTxTimeDiff_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedAdditionalPathList')))
    _____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPTEGInformation')))
    ____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 561), ('criticality', 'ignore'), ('Extension', _____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 567), ('criticality', 'ignore'), ('Extension', _____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNB_RxTxTimeDiff_iE_Extensions__item__id._const_tab = ____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab
    ___GNB_RxTxTimeDiff_iE_Extensions__item__id._const_tab_at = None
    ___GNB_RxTxTimeDiff_iE_Extensions__item__id._const_tab_id = 'id'
    ___GNB_RxTxTimeDiff_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GNB_RxTxTimeDiff_iE_Extensions__item__criticality._const_tab = ____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab
    ___GNB_RxTxTimeDiff_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_RxTxTimeDiff_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue._const_tab = ____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab
    ___GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GNB_RxTxTimeDiff_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GNB_RxTxTimeDiff_iE_Extensions__item__id),
        ('criticality', ___GNB_RxTxTimeDiff_iE_Extensions__item__criticality),
        ('extensionValue', ___GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue),
        ])
    __GNB_RxTxTimeDiff_iE_Extensions__item_._ext = None
    _GNB_RxTxTimeDiff_iE_Extensions._cont = __GNB_RxTxTimeDiff_iE_Extensions__item_
    _GNB_RxTxTimeDiff_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_RxTxTimeDiff._cont = ASN1Dict([
        ('rxTxTimeDiff', _GNB_RxTxTimeDiff_rxTxTimeDiff),
        ('additionalPath-List', _GNB_RxTxTimeDiff_additionalPath_List),
        ('iE-Extensions', _GNB_RxTxTimeDiff_iE_Extensions),
        ])
    GNB_RxTxTimeDiff._ext = None
    
    #-----< GNB-RxTxTimeDiff-ExtIEs >-----#
    GNB_RxTxTimeDiff_ExtIEs = CLASS(name='GNB-RxTxTimeDiff-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _GNB_RxTxTimeDiff_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedAdditionalPathList')))
    _GNB_RxTxTimeDiff_ExtIEs_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPTEGInformation')))
    GNB_RxTxTimeDiff_ExtIEs._val = ASN1Set(rv=[dict([('id', 561), ('criticality', 'ignore'), ('Extension', _GNB_RxTxTimeDiff_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 567), ('criticality', 'ignore'), ('Extension', _GNB_RxTxTimeDiff_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNBRxTxTimeDiffMeas >-----#
    GNBRxTxTimeDiffMeas = CHOICE(name='GNBRxTxTimeDiffMeas', mode=MODE_TYPE)
    _GNBRxTxTimeDiffMeas_k0 = INT(name='k0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNBRxTxTimeDiffMeas_k0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1970049)], ev=None, er=[])
    _GNBRxTxTimeDiffMeas_k1 = INT(name='k1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNBRxTxTimeDiffMeas_k1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=985025)], ev=None, er=[])
    _GNBRxTxTimeDiffMeas_k2 = INT(name='k2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNBRxTxTimeDiffMeas_k2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=492513)], ev=None, er=[])
    _GNBRxTxTimeDiffMeas_k3 = INT(name='k3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNBRxTxTimeDiffMeas_k3._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=246257)], ev=None, er=[])
    _GNBRxTxTimeDiffMeas_k4 = INT(name='k4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNBRxTxTimeDiffMeas_k4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=123129)], ev=None, er=[])
    _GNBRxTxTimeDiffMeas_k5 = INT(name='k5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNBRxTxTimeDiffMeas_k5._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=61565)], ev=None, er=[])
    _GNBRxTxTimeDiffMeas_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __GNBRxTxTimeDiffMeas_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___GNBRxTxTimeDiffMeas_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___GNBRxTxTimeDiffMeas_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __GNBRxTxTimeDiffMeas_choice_extension_id._const_tab = ___GNBRxTxTimeDiffMeas_choice_extension_id_tab
    __GNBRxTxTimeDiffMeas_choice_extension_id._const_tab_at = None
    __GNBRxTxTimeDiffMeas_choice_extension_id._const_tab_id = 'id'
    __GNBRxTxTimeDiffMeas_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___GNBRxTxTimeDiffMeas_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___GNBRxTxTimeDiffMeas_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __GNBRxTxTimeDiffMeas_choice_extension_criticality._const_tab = ___GNBRxTxTimeDiffMeas_choice_extension_criticality_tab
    __GNBRxTxTimeDiffMeas_choice_extension_criticality._const_tab_at = ('..', 'id')
    __GNBRxTxTimeDiffMeas_choice_extension_criticality._const_tab_id = 'criticality'
    __GNBRxTxTimeDiffMeas_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___GNBRxTxTimeDiffMeas_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___GNBRxTxTimeDiffMeas_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __GNBRxTxTimeDiffMeas_choice_extension_value._const_tab = ___GNBRxTxTimeDiffMeas_choice_extension_value_tab
    __GNBRxTxTimeDiffMeas_choice_extension_value._const_tab_at = ('..', 'id')
    __GNBRxTxTimeDiffMeas_choice_extension_value._const_tab_id = 'Value'
    _GNBRxTxTimeDiffMeas_choice_extension._cont = ASN1Dict([
        ('id', __GNBRxTxTimeDiffMeas_choice_extension_id),
        ('criticality', __GNBRxTxTimeDiffMeas_choice_extension_criticality),
        ('value', __GNBRxTxTimeDiffMeas_choice_extension_value),
        ])
    _GNBRxTxTimeDiffMeas_choice_extension._ext = None
    GNBRxTxTimeDiffMeas._cont = ASN1Dict([
        ('k0', _GNBRxTxTimeDiffMeas_k0),
        ('k1', _GNBRxTxTimeDiffMeas_k1),
        ('k2', _GNBRxTxTimeDiffMeas_k2),
        ('k3', _GNBRxTxTimeDiffMeas_k3),
        ('k4', _GNBRxTxTimeDiffMeas_k4),
        ('k5', _GNBRxTxTimeDiffMeas_k5),
        ('choice-extension', _GNBRxTxTimeDiffMeas_choice_extension),
        ])
    GNBRxTxTimeDiffMeas._ext = None
    
    #-----< GNBRxTxTimeDiffMeas-ExtIEs >-----#
    GNBRxTxTimeDiffMeas_ExtIEs = CLASS(name='GNBRxTxTimeDiffMeas-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    GNBRxTxTimeDiffMeas_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNBSetID >-----#
    GNBSetID = BIT_STR(name='GNBSetID', mode=MODE_TYPE)
    GNBSetID._const_sz = ASN1Set(rv=[22], rr=[], ev=None, er=[])
    
    #-----< GTP-TEID >-----#
    GTP_TEID = OCT_STR(name='GTP-TEID', mode=MODE_TYPE)
    GTP_TEID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< GTPTLAs >-----#
    GTPTLAs = SEQ_OF(name='GTPTLAs', mode=MODE_TYPE)
    _GTPTLAs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GTPTLA-Item')))
    GTPTLAs._cont = _GTPTLAs__item_
    GTPTLAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< GTPTLA-Item >-----#
    GTPTLA_Item = SEQ(name='GTPTLA-Item', mode=MODE_TYPE)
    _GTPTLA_Item_gTPTransportLayerAddress = BIT_STR(name='gTPTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _GTPTLA_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GTPTLA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GTPTLA_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GTPTLA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GTPTLA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTLA_Item_iE_Extensions__item__id._const_tab = ____GTPTLA_Item_iE_Extensions__item__id_tab
    ___GTPTLA_Item_iE_Extensions__item__id._const_tab_at = None
    ___GTPTLA_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___GTPTLA_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GTPTLA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GTPTLA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTLA_Item_iE_Extensions__item__criticality._const_tab = ____GTPTLA_Item_iE_Extensions__item__criticality_tab
    ___GTPTLA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GTPTLA_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GTPTLA_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GTPTLA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GTPTLA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTLA_Item_iE_Extensions__item__extensionValue._const_tab = ____GTPTLA_Item_iE_Extensions__item__extensionValue_tab
    ___GTPTLA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GTPTLA_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GTPTLA_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GTPTLA_Item_iE_Extensions__item__id),
        ('criticality', ___GTPTLA_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___GTPTLA_Item_iE_Extensions__item__extensionValue),
        ])
    __GTPTLA_Item_iE_Extensions__item_._ext = None
    _GTPTLA_Item_iE_Extensions._cont = __GTPTLA_Item_iE_Extensions__item_
    _GTPTLA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GTPTLA_Item._cont = ASN1Dict([
        ('gTPTransportLayerAddress', _GTPTLA_Item_gTPTransportLayerAddress),
        ('iE-Extensions', _GTPTLA_Item_iE_Extensions),
        ])
    GTPTLA_Item._ext = None
    
    #-----< GTPTLA-Item-ExtIEs >-----#
    GTPTLA_Item_ExtIEs = CLASS(name='GTPTLA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    GTPTLA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GTPTunnel >-----#
    GTPTunnel = SEQ(name='GTPTunnel', mode=MODE_TYPE)
    _GTPTunnel_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _GTPTunnel_gTP_TEID = OCT_STR(name='gTP-TEID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GTP-TEID')))
    _GTPTunnel_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GTPTunnel_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___GTPTunnel_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GTPTunnel_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GTPTunnel_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTunnel_iE_Extensions__item__id._const_tab = ____GTPTunnel_iE_Extensions__item__id_tab
    ___GTPTunnel_iE_Extensions__item__id._const_tab_at = None
    ___GTPTunnel_iE_Extensions__item__id._const_tab_id = 'id'
    ___GTPTunnel_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GTPTunnel_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GTPTunnel_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTunnel_iE_Extensions__item__criticality._const_tab = ____GTPTunnel_iE_Extensions__item__criticality_tab
    ___GTPTunnel_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GTPTunnel_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GTPTunnel_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GTPTunnel_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____GTPTunnel_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTunnel_iE_Extensions__item__extensionValue._const_tab = ____GTPTunnel_iE_Extensions__item__extensionValue_tab
    ___GTPTunnel_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GTPTunnel_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GTPTunnel_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GTPTunnel_iE_Extensions__item__id),
        ('criticality', ___GTPTunnel_iE_Extensions__item__criticality),
        ('extensionValue', ___GTPTunnel_iE_Extensions__item__extensionValue),
        ])
    __GTPTunnel_iE_Extensions__item_._ext = None
    _GTPTunnel_iE_Extensions._cont = __GTPTunnel_iE_Extensions__item_
    _GTPTunnel_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GTPTunnel._cont = ASN1Dict([
        ('transportLayerAddress', _GTPTunnel_transportLayerAddress),
        ('gTP-TEID', _GTPTunnel_gTP_TEID),
        ('iE-Extensions', _GTPTunnel_iE_Extensions),
        ])
    GTPTunnel._ext = []
    
    #-----< GTPTunnel-ExtIEs >-----#
    GTPTunnel_ExtIEs = CLASS(name='GTPTunnel-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    GTPTunnel_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HandoverPreparationInformation >-----#
    HandoverPreparationInformation = OCT_STR(name='HandoverPreparationInformation', mode=MODE_TYPE)
    
    #-----< HardwareLoadIndicator >-----#
    HardwareLoadIndicator = SEQ(name='HardwareLoadIndicator', mode=MODE_TYPE)
    _HardwareLoadIndicator_dLHardwareLoadIndicator = INT(name='dLHardwareLoadIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HardwareLoadIndicator_dLHardwareLoadIndicator._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=[], er=[])
    _HardwareLoadIndicator_uLHardwareLoadIndicator = INT(name='uLHardwareLoadIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HardwareLoadIndicator_uLHardwareLoadIndicator._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=[], er=[])
    _HardwareLoadIndicator_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HardwareLoadIndicator_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___HardwareLoadIndicator_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____HardwareLoadIndicator_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____HardwareLoadIndicator_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HardwareLoadIndicator_iE_Extensions__item__id._const_tab = ____HardwareLoadIndicator_iE_Extensions__item__id_tab
    ___HardwareLoadIndicator_iE_Extensions__item__id._const_tab_at = None
    ___HardwareLoadIndicator_iE_Extensions__item__id._const_tab_id = 'id'
    ___HardwareLoadIndicator_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HardwareLoadIndicator_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____HardwareLoadIndicator_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HardwareLoadIndicator_iE_Extensions__item__criticality._const_tab = ____HardwareLoadIndicator_iE_Extensions__item__criticality_tab
    ___HardwareLoadIndicator_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HardwareLoadIndicator_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HardwareLoadIndicator_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HardwareLoadIndicator_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____HardwareLoadIndicator_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HardwareLoadIndicator_iE_Extensions__item__extensionValue._const_tab = ____HardwareLoadIndicator_iE_Extensions__item__extensionValue_tab
    ___HardwareLoadIndicator_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HardwareLoadIndicator_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HardwareLoadIndicator_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HardwareLoadIndicator_iE_Extensions__item__id),
        ('criticality', ___HardwareLoadIndicator_iE_Extensions__item__criticality),
        ('extensionValue', ___HardwareLoadIndicator_iE_Extensions__item__extensionValue),
        ])
    __HardwareLoadIndicator_iE_Extensions__item_._ext = None
    _HardwareLoadIndicator_iE_Extensions._cont = __HardwareLoadIndicator_iE_Extensions__item_
    _HardwareLoadIndicator_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HardwareLoadIndicator._cont = ASN1Dict([
        ('dLHardwareLoadIndicator', _HardwareLoadIndicator_dLHardwareLoadIndicator),
        ('uLHardwareLoadIndicator', _HardwareLoadIndicator_uLHardwareLoadIndicator),
        ('iE-Extensions', _HardwareLoadIndicator_iE_Extensions),
        ])
    HardwareLoadIndicator._ext = []
    
    #-----< HardwareLoadIndicator-ExtIEs >-----#
    HardwareLoadIndicator_ExtIEs = CLASS(name='HardwareLoadIndicator-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    HardwareLoadIndicator_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSNASlotConfigList >-----#
    HSNASlotConfigList = SEQ_OF(name='HSNASlotConfigList', mode=MODE_TYPE)
    _HSNASlotConfigList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'HSNASlotConfigItem')))
    HSNASlotConfigList._cont = _HSNASlotConfigList__item_
    HSNASlotConfigList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5120)], ev=None, er=[])
    
    #-----< HSNASlotConfigItem >-----#
    HSNASlotConfigItem = SEQ(name='HSNASlotConfigItem', mode=MODE_TYPE)
    _HSNASlotConfigItem_hSNADownlink = ENUM(name='hSNADownlink', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'HSNADownlink')), opt=True)
    _HSNASlotConfigItem_hSNAUplink = ENUM(name='hSNAUplink', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'HSNAUplink')), opt=True)
    _HSNASlotConfigItem_hSNAFlexible = ENUM(name='hSNAFlexible', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'HSNAFlexible')), opt=True)
    _HSNASlotConfigItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSNASlotConfigItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___HSNASlotConfigItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____HSNASlotConfigItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____HSNASlotConfigItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSNASlotConfigItem_iE_Extensions__item__id._const_tab = ____HSNASlotConfigItem_iE_Extensions__item__id_tab
    ___HSNASlotConfigItem_iE_Extensions__item__id._const_tab_at = None
    ___HSNASlotConfigItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSNASlotConfigItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HSNASlotConfigItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____HSNASlotConfigItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSNASlotConfigItem_iE_Extensions__item__criticality._const_tab = ____HSNASlotConfigItem_iE_Extensions__item__criticality_tab
    ___HSNASlotConfigItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSNASlotConfigItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSNASlotConfigItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HSNASlotConfigItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____HSNASlotConfigItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSNASlotConfigItem_iE_Extensions__item__extensionValue._const_tab = ____HSNASlotConfigItem_iE_Extensions__item__extensionValue_tab
    ___HSNASlotConfigItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSNASlotConfigItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSNASlotConfigItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSNASlotConfigItem_iE_Extensions__item__id),
        ('criticality', ___HSNASlotConfigItem_iE_Extensions__item__criticality),
        ('extensionValue', ___HSNASlotConfigItem_iE_Extensions__item__extensionValue),
        ])
    __HSNASlotConfigItem_iE_Extensions__item_._ext = None
    _HSNASlotConfigItem_iE_Extensions._cont = __HSNASlotConfigItem_iE_Extensions__item_
    _HSNASlotConfigItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSNASlotConfigItem._cont = ASN1Dict([
        ('hSNADownlink', _HSNASlotConfigItem_hSNADownlink),
        ('hSNAUplink', _HSNASlotConfigItem_hSNAUplink),
        ('hSNAFlexible', _HSNASlotConfigItem_hSNAFlexible),
        ('iE-Extensions', _HSNASlotConfigItem_iE_Extensions),
        ])
    HSNASlotConfigItem._ext = None
    
    #-----< HSNASlotConfigItem-ExtIEs >-----#
    HSNASlotConfigItem_ExtIEs = CLASS(name='HSNASlotConfigItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    HSNASlotConfigItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSNADownlink >-----#
    HSNADownlink = ENUM(name='HSNADownlink', mode=MODE_TYPE)
    HSNADownlink._cont = ASN1Dict([('hard', 0), ('soft', 1), ('notavailable', 2)])
    HSNADownlink._ext = None
    
    #-----< HSNAFlexible >-----#
    HSNAFlexible = ENUM(name='HSNAFlexible', mode=MODE_TYPE)
    HSNAFlexible._cont = ASN1Dict([('hard', 0), ('soft', 1), ('notavailable', 2)])
    HSNAFlexible._ext = None
    
    #-----< HSNAUplink >-----#
    HSNAUplink = ENUM(name='HSNAUplink', mode=MODE_TYPE)
    HSNAUplink._cont = ASN1Dict([('hard', 0), ('soft', 1), ('notavailable', 2)])
    HSNAUplink._ext = None
    
    #-----< HSNATransmissionPeriodicity >-----#
    HSNATransmissionPeriodicity = ENUM(name='HSNATransmissionPeriodicity', mode=MODE_TYPE)
    HSNATransmissionPeriodicity._cont = ASN1Dict([('ms0p5', 0), ('ms0p625', 1), ('ms1', 2), ('ms1p25', 3), ('ms2', 4), ('ms2p5', 5), ('ms5', 6), ('ms10', 7), ('ms20', 8), ('ms40', 9), ('ms80', 10), ('ms160', 11)])
    HSNATransmissionPeriodicity._ext = []
    
    #-----< IAB-Barred >-----#
    IAB_Barred = ENUM(name='IAB-Barred', mode=MODE_TYPE)
    IAB_Barred._cont = ASN1Dict([('barred', 0), ('not-barred', 1)])
    IAB_Barred._ext = []
    
    #-----< IABConditionalRRCMessageDeliveryIndication >-----#
    IABConditionalRRCMessageDeliveryIndication = ENUM(name='IABConditionalRRCMessageDeliveryIndication', mode=MODE_TYPE)
    IABConditionalRRCMessageDeliveryIndication._cont = ASN1Dict([('true', 0)])
    IABConditionalRRCMessageDeliveryIndication._ext = []
    
    #-----< IABCongestionIndication >-----#
    IABCongestionIndication = SEQ(name='IABCongestionIndication', mode=MODE_TYPE)
    _IABCongestionIndication_iAB_Congestion_Indication_List = SEQ_OF(name='iAB-Congestion-Indication-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IAB-Congestion-Indication-List')))
    _IABCongestionIndication_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IABCongestionIndication_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IABCongestionIndication_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____IABCongestionIndication_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IABCongestionIndication_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IABCongestionIndication_iE_Extensions__item__id._const_tab = ____IABCongestionIndication_iE_Extensions__item__id_tab
    ___IABCongestionIndication_iE_Extensions__item__id._const_tab_at = None
    ___IABCongestionIndication_iE_Extensions__item__id._const_tab_id = 'id'
    ___IABCongestionIndication_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IABCongestionIndication_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IABCongestionIndication_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IABCongestionIndication_iE_Extensions__item__criticality._const_tab = ____IABCongestionIndication_iE_Extensions__item__criticality_tab
    ___IABCongestionIndication_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IABCongestionIndication_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IABCongestionIndication_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IABCongestionIndication_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IABCongestionIndication_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IABCongestionIndication_iE_Extensions__item__extensionValue._const_tab = ____IABCongestionIndication_iE_Extensions__item__extensionValue_tab
    ___IABCongestionIndication_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IABCongestionIndication_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IABCongestionIndication_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IABCongestionIndication_iE_Extensions__item__id),
        ('criticality', ___IABCongestionIndication_iE_Extensions__item__criticality),
        ('extensionValue', ___IABCongestionIndication_iE_Extensions__item__extensionValue),
        ])
    __IABCongestionIndication_iE_Extensions__item_._ext = None
    _IABCongestionIndication_iE_Extensions._cont = __IABCongestionIndication_iE_Extensions__item_
    _IABCongestionIndication_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IABCongestionIndication._cont = ASN1Dict([
        ('iAB-Congestion-Indication-List', _IABCongestionIndication_iAB_Congestion_Indication_List),
        ('iE-Extensions', _IABCongestionIndication_iE_Extensions),
        ])
    IABCongestionIndication._ext = None
    
    #-----< IAB-Congestion-Indication-List-ExtIEs >-----#
    IAB_Congestion_Indication_List_ExtIEs = CLASS(name='IAB-Congestion-Indication-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IAB_Congestion_Indication_List_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IAB-Congestion-Indication-List >-----#
    IAB_Congestion_Indication_List = SEQ_OF(name='IAB-Congestion-Indication-List', mode=MODE_TYPE)
    _IAB_Congestion_Indication_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-Congestion-Indication-Item')))
    IAB_Congestion_Indication_List._cont = _IAB_Congestion_Indication_List__item_
    IAB_Congestion_Indication_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< IAB-Congestion-Indication-Item >-----#
    IAB_Congestion_Indication_Item = SEQ(name='IAB-Congestion-Indication-Item', mode=MODE_TYPE)
    _IAB_Congestion_Indication_Item_childNodeIdentifier = BIT_STR(name='childNodeIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    _IAB_Congestion_Indication_Item_bHRLCCHList = SEQ_OF(name='bHRLCCHList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHRLCCHList')), opt=True)
    _IAB_Congestion_Indication_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IAB_Congestion_Indication_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IAB_Congestion_Indication_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____IAB_Congestion_Indication_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_Congestion_Indication_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_Congestion_Indication_Item_iE_Extensions__item__id._const_tab = ____IAB_Congestion_Indication_Item_iE_Extensions__item__id_tab
    ___IAB_Congestion_Indication_Item_iE_Extensions__item__id._const_tab_at = None
    ___IAB_Congestion_Indication_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___IAB_Congestion_Indication_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IAB_Congestion_Indication_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_Congestion_Indication_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_Congestion_Indication_Item_iE_Extensions__item__criticality._const_tab = ____IAB_Congestion_Indication_Item_iE_Extensions__item__criticality_tab
    ___IAB_Congestion_Indication_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IAB_Congestion_Indication_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IAB_Congestion_Indication_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IAB_Congestion_Indication_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_Congestion_Indication_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_Congestion_Indication_Item_iE_Extensions__item__extensionValue._const_tab = ____IAB_Congestion_Indication_Item_iE_Extensions__item__extensionValue_tab
    ___IAB_Congestion_Indication_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IAB_Congestion_Indication_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IAB_Congestion_Indication_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IAB_Congestion_Indication_Item_iE_Extensions__item__id),
        ('criticality', ___IAB_Congestion_Indication_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___IAB_Congestion_Indication_Item_iE_Extensions__item__extensionValue),
        ])
    __IAB_Congestion_Indication_Item_iE_Extensions__item_._ext = None
    _IAB_Congestion_Indication_Item_iE_Extensions._cont = __IAB_Congestion_Indication_Item_iE_Extensions__item_
    _IAB_Congestion_Indication_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IAB_Congestion_Indication_Item._cont = ASN1Dict([
        ('childNodeIdentifier', _IAB_Congestion_Indication_Item_childNodeIdentifier),
        ('bHRLCCHList', _IAB_Congestion_Indication_Item_bHRLCCHList),
        ('iE-Extensions', _IAB_Congestion_Indication_Item_iE_Extensions),
        ])
    IAB_Congestion_Indication_Item._ext = None
    
    #-----< IAB-Congestion-Indication-ItemExtIEs >-----#
    IAB_Congestion_Indication_ItemExtIEs = CLASS(name='IAB-Congestion-Indication-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IAB_Congestion_Indication_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IAB-Info-IAB-donor-CU >-----#
    IAB_Info_IAB_donor_CU = SEQ(name='IAB-Info-IAB-donor-CU', mode=MODE_TYPE)
    _IAB_Info_IAB_donor_CU_iAB_STC_Info = SEQ(name='iAB-STC-Info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IAB-STC-Info')), opt=True)
    _IAB_Info_IAB_donor_CU_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IAB_Info_IAB_donor_CU_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IAB_Info_IAB_donor_CU_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____IAB_Info_IAB_donor_CU_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_Info_IAB_donor_CU_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_Info_IAB_donor_CU_iE_Extensions__item__id._const_tab = ____IAB_Info_IAB_donor_CU_iE_Extensions__item__id_tab
    ___IAB_Info_IAB_donor_CU_iE_Extensions__item__id._const_tab_at = None
    ___IAB_Info_IAB_donor_CU_iE_Extensions__item__id._const_tab_id = 'id'
    ___IAB_Info_IAB_donor_CU_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IAB_Info_IAB_donor_CU_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_Info_IAB_donor_CU_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_Info_IAB_donor_CU_iE_Extensions__item__criticality._const_tab = ____IAB_Info_IAB_donor_CU_iE_Extensions__item__criticality_tab
    ___IAB_Info_IAB_donor_CU_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IAB_Info_IAB_donor_CU_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IAB_Info_IAB_donor_CU_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IAB_Info_IAB_donor_CU_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_Info_IAB_donor_CU_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_Info_IAB_donor_CU_iE_Extensions__item__extensionValue._const_tab = ____IAB_Info_IAB_donor_CU_iE_Extensions__item__extensionValue_tab
    ___IAB_Info_IAB_donor_CU_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IAB_Info_IAB_donor_CU_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IAB_Info_IAB_donor_CU_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IAB_Info_IAB_donor_CU_iE_Extensions__item__id),
        ('criticality', ___IAB_Info_IAB_donor_CU_iE_Extensions__item__criticality),
        ('extensionValue', ___IAB_Info_IAB_donor_CU_iE_Extensions__item__extensionValue),
        ])
    __IAB_Info_IAB_donor_CU_iE_Extensions__item_._ext = None
    _IAB_Info_IAB_donor_CU_iE_Extensions._cont = __IAB_Info_IAB_donor_CU_iE_Extensions__item_
    _IAB_Info_IAB_donor_CU_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IAB_Info_IAB_donor_CU._cont = ASN1Dict([
        ('iAB-STC-Info', _IAB_Info_IAB_donor_CU_iAB_STC_Info),
        ('iE-Extensions', _IAB_Info_IAB_donor_CU_iE_Extensions),
        ])
    IAB_Info_IAB_donor_CU._ext = None
    
    #-----< IAB-Info-IAB-donor-CU-ExtIEs >-----#
    IAB_Info_IAB_donor_CU_ExtIEs = CLASS(name='IAB-Info-IAB-donor-CU-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IAB_Info_IAB_donor_CU_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IAB-Info-IAB-DU >-----#
    IAB_Info_IAB_DU = SEQ(name='IAB-Info-IAB-DU', mode=MODE_TYPE)
    _IAB_Info_IAB_DU_multiplexingInfo = SEQ(name='multiplexingInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MultiplexingInfo')), opt=True)
    _IAB_Info_IAB_DU_iAB_STC_Info = SEQ(name='iAB-STC-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IAB-STC-Info')), opt=True)
    _IAB_Info_IAB_DU_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IAB_Info_IAB_DU_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IAB_Info_IAB_DU_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____IAB_Info_IAB_DU_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_Info_IAB_DU_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_Info_IAB_DU_iE_Extensions__item__id._const_tab = ____IAB_Info_IAB_DU_iE_Extensions__item__id_tab
    ___IAB_Info_IAB_DU_iE_Extensions__item__id._const_tab_at = None
    ___IAB_Info_IAB_DU_iE_Extensions__item__id._const_tab_id = 'id'
    ___IAB_Info_IAB_DU_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IAB_Info_IAB_DU_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_Info_IAB_DU_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_Info_IAB_DU_iE_Extensions__item__criticality._const_tab = ____IAB_Info_IAB_DU_iE_Extensions__item__criticality_tab
    ___IAB_Info_IAB_DU_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IAB_Info_IAB_DU_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IAB_Info_IAB_DU_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IAB_Info_IAB_DU_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_Info_IAB_DU_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_Info_IAB_DU_iE_Extensions__item__extensionValue._const_tab = ____IAB_Info_IAB_DU_iE_Extensions__item__extensionValue_tab
    ___IAB_Info_IAB_DU_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IAB_Info_IAB_DU_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IAB_Info_IAB_DU_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IAB_Info_IAB_DU_iE_Extensions__item__id),
        ('criticality', ___IAB_Info_IAB_DU_iE_Extensions__item__criticality),
        ('extensionValue', ___IAB_Info_IAB_DU_iE_Extensions__item__extensionValue),
        ])
    __IAB_Info_IAB_DU_iE_Extensions__item_._ext = None
    _IAB_Info_IAB_DU_iE_Extensions._cont = __IAB_Info_IAB_DU_iE_Extensions__item_
    _IAB_Info_IAB_DU_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IAB_Info_IAB_DU._cont = ASN1Dict([
        ('multiplexingInfo', _IAB_Info_IAB_DU_multiplexingInfo),
        ('iAB-STC-Info', _IAB_Info_IAB_DU_iAB_STC_Info),
        ('iE-Extensions', _IAB_Info_IAB_DU_iE_Extensions),
        ])
    IAB_Info_IAB_DU._ext = None
    
    #-----< IAB-Info-IAB-DU-ExtIEs >-----#
    IAB_Info_IAB_DU_ExtIEs = CLASS(name='IAB-Info-IAB-DU-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IAB_Info_IAB_DU_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IAB-MT-Cell-List >-----#
    IAB_MT_Cell_List = SEQ_OF(name='IAB-MT-Cell-List', mode=MODE_TYPE)
    _IAB_MT_Cell_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-MT-Cell-List-Item')))
    IAB_MT_Cell_List._cont = _IAB_MT_Cell_List__item_
    IAB_MT_Cell_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< IAB-MT-Cell-List-Item >-----#
    IAB_MT_Cell_List_Item = SEQ(name='IAB-MT-Cell-List-Item', mode=MODE_TYPE)
    _IAB_MT_Cell_List_Item_nRCellIdentity = BIT_STR(name='nRCellIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCellIdentity')))
    _IAB_MT_Cell_List_Item_dU_RX_MT_RX = ENUM(name='dU-RX-MT-RX', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DU-RX-MT-RX')))
    _IAB_MT_Cell_List_Item_dU_TX_MT_TX = ENUM(name='dU-TX-MT-TX', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DU-TX-MT-TX')))
    _IAB_MT_Cell_List_Item_dU_RX_MT_TX = ENUM(name='dU-RX-MT-TX', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DU-RX-MT-TX')))
    _IAB_MT_Cell_List_Item_dU_TX_MT_RX = ENUM(name='dU-TX-MT-RX', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DU-TX-MT-RX')))
    _IAB_MT_Cell_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IAB_MT_Cell_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IAB_MT_Cell_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____IAB_MT_Cell_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____IAB_MT_Cell_List_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DU-RX-MT-RX-Extend')))
    _____IAB_MT_Cell_List_Item_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DU-TX-MT-TX-Extend')))
    _____IAB_MT_Cell_List_Item_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DU-RX-MT-TX-Extend')))
    _____IAB_MT_Cell_List_Item_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DU-TX-MT-RX-Extend')))
    ____IAB_MT_Cell_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 637), ('criticality', 'ignore'), ('Extension', _____IAB_MT_Cell_List_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 638), ('criticality', 'ignore'), ('Extension', _____IAB_MT_Cell_List_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 639), ('criticality', 'ignore'), ('Extension', _____IAB_MT_Cell_List_Item_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 640), ('criticality', 'ignore'), ('Extension', _____IAB_MT_Cell_List_Item_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___IAB_MT_Cell_List_Item_iE_Extensions__item__id._const_tab = ____IAB_MT_Cell_List_Item_iE_Extensions__item__id_tab
    ___IAB_MT_Cell_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___IAB_MT_Cell_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___IAB_MT_Cell_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___IAB_MT_Cell_List_Item_iE_Extensions__item__criticality._const_tab = ____IAB_MT_Cell_List_Item_iE_Extensions__item__id_tab
    ___IAB_MT_Cell_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IAB_MT_Cell_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IAB_MT_Cell_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___IAB_MT_Cell_List_Item_iE_Extensions__item__extensionValue._const_tab = ____IAB_MT_Cell_List_Item_iE_Extensions__item__id_tab
    ___IAB_MT_Cell_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IAB_MT_Cell_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IAB_MT_Cell_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IAB_MT_Cell_List_Item_iE_Extensions__item__id),
        ('criticality', ___IAB_MT_Cell_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___IAB_MT_Cell_List_Item_iE_Extensions__item__extensionValue),
        ])
    __IAB_MT_Cell_List_Item_iE_Extensions__item_._ext = None
    _IAB_MT_Cell_List_Item_iE_Extensions._cont = __IAB_MT_Cell_List_Item_iE_Extensions__item_
    _IAB_MT_Cell_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IAB_MT_Cell_List_Item._cont = ASN1Dict([
        ('nRCellIdentity', _IAB_MT_Cell_List_Item_nRCellIdentity),
        ('dU-RX-MT-RX', _IAB_MT_Cell_List_Item_dU_RX_MT_RX),
        ('dU-TX-MT-TX', _IAB_MT_Cell_List_Item_dU_TX_MT_TX),
        ('dU-RX-MT-TX', _IAB_MT_Cell_List_Item_dU_RX_MT_TX),
        ('dU-TX-MT-RX', _IAB_MT_Cell_List_Item_dU_TX_MT_RX),
        ('iE-Extensions', _IAB_MT_Cell_List_Item_iE_Extensions),
        ])
    IAB_MT_Cell_List_Item._ext = None
    
    #-----< IAB-MT-Cell-List-Item-ExtIEs >-----#
    IAB_MT_Cell_List_Item_ExtIEs = CLASS(name='IAB-MT-Cell-List-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _IAB_MT_Cell_List_Item_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DU-RX-MT-RX-Extend')))
    _IAB_MT_Cell_List_Item_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DU-TX-MT-TX-Extend')))
    _IAB_MT_Cell_List_Item_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DU-RX-MT-TX-Extend')))
    _IAB_MT_Cell_List_Item_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DU-TX-MT-RX-Extend')))
    IAB_MT_Cell_List_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 637), ('criticality', 'ignore'), ('Extension', _IAB_MT_Cell_List_Item_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 638), ('criticality', 'ignore'), ('Extension', _IAB_MT_Cell_List_Item_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 639), ('criticality', 'ignore'), ('Extension', _IAB_MT_Cell_List_Item_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 640), ('criticality', 'ignore'), ('Extension', _IAB_MT_Cell_List_Item_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< IAB-MT-Cell-NA-Resource-Configuration-Mode-Info >-----#
    IAB_MT_Cell_NA_Resource_Configuration_Mode_Info = CHOICE(name='IAB-MT-Cell-NA-Resource-Configuration-Mode-Info', mode=MODE_TYPE)
    _IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_fDD = SEQ(name='fDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IAB-MT-Cell-NA-Resource-Configuration-FDD-Info')))
    _IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_tDD = SEQ(name='tDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IAB-MT-Cell-NA-Resource-Configuration-TDD-Info')))
    _IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_id._const_tab = ___IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_id_tab
    __IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_id._const_tab_at = None
    __IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_id._const_tab_id = 'id'
    __IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_criticality._const_tab = ___IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_criticality_tab
    __IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_criticality._const_tab_at = ('..', 'id')
    __IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_criticality._const_tab_id = 'criticality'
    __IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_value._const_tab = ___IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_value_tab
    __IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_value._const_tab_at = ('..', 'id')
    __IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_value._const_tab_id = 'Value'
    _IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension._cont = ASN1Dict([
        ('id', __IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_id),
        ('criticality', __IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_criticality),
        ('value', __IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_value),
        ])
    _IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension._ext = None
    IAB_MT_Cell_NA_Resource_Configuration_Mode_Info._cont = ASN1Dict([
        ('fDD', _IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_fDD),
        ('tDD', _IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_tDD),
        ('choice-extension', _IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension),
        ])
    IAB_MT_Cell_NA_Resource_Configuration_Mode_Info._ext = None
    
    #-----< IAB-MT-Cell-NA-Resource-Configuration-Mode-Info-ExtIEs >-----#
    IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_ExtIEs = CLASS(name='IAB-MT-Cell-NA-Resource-Configuration-Mode-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IAB-MT-Cell-NA-Resource-Configuration-FDD-Info >-----#
    IAB_MT_Cell_NA_Resource_Configuration_FDD_Info = SEQ(name='IAB-MT-Cell-NA-Resource-Configuration-FDD-Info', mode=MODE_TYPE)
    _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_gNB_DU_Cell_NA_Resource_Configuration_FDD_UL = SEQ(name='gNB-DU-Cell-NA-Resource-Configuration-FDD-UL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-Cell-Resource-Configuration')))
    _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_gNB_DU_Cell_NA_Resource_Configuration_FDD_DL = SEQ(name='gNB-DU-Cell-NA-Resource-Configuration-FDD-DL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-Cell-Resource-Configuration')))
    _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_uL_FreqInfo = SEQ(name='uL-FreqInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRFreqInfo')), opt=True)
    _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_uL_Transmission_Bandwidth = SEQ(name='uL-Transmission-Bandwidth', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Transmission-Bandwidth')), opt=True)
    _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_uL_NR_Carrier_List = SEQ_OF(name='uL-NR-Carrier-List', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')), opt=True)
    _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_dL_FreqInfo = SEQ(name='dL-FreqInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRFreqInfo')), opt=True)
    _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_dL_Transmission_Bandwidth = SEQ(name='dL-Transmission-Bandwidth', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Transmission-Bandwidth')), opt=True)
    _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_dL_NR_Carrier_List = SEQ_OF(name='dL-NR-Carrier-List', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')), opt=True)
    _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__id._const_tab = ____IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab
    ___IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__id._const_tab_at = None
    ___IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality._const_tab = ____IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality_tab
    ___IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue._const_tab = ____IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue_tab
    ___IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__id),
        ('criticality', ___IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue),
        ])
    __IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item_._ext = None
    _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions._cont = __IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item_
    _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IAB_MT_Cell_NA_Resource_Configuration_FDD_Info._cont = ASN1Dict([
        ('gNB-DU-Cell-NA-Resource-Configuration-FDD-UL', _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_gNB_DU_Cell_NA_Resource_Configuration_FDD_UL),
        ('gNB-DU-Cell-NA-Resource-Configuration-FDD-DL', _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_gNB_DU_Cell_NA_Resource_Configuration_FDD_DL),
        ('uL-FreqInfo', _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_uL_FreqInfo),
        ('uL-Transmission-Bandwidth', _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_uL_Transmission_Bandwidth),
        ('uL-NR-Carrier-List', _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_uL_NR_Carrier_List),
        ('dL-FreqInfo', _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_dL_FreqInfo),
        ('dL-Transmission-Bandwidth', _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_dL_Transmission_Bandwidth),
        ('dL-NR-Carrier-List', _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_dL_NR_Carrier_List),
        ('iE-Extensions', _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions),
        ])
    IAB_MT_Cell_NA_Resource_Configuration_FDD_Info._ext = []
    
    #-----< IAB-MT-Cell-NA-Resource-Configuration-FDD-Info-ExtIEs >-----#
    IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_ExtIEs = CLASS(name='IAB-MT-Cell-NA-Resource-Configuration-FDD-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IAB-MT-Cell-NA-Resource-Configuration-TDD-Info >-----#
    IAB_MT_Cell_NA_Resource_Configuration_TDD_Info = SEQ(name='IAB-MT-Cell-NA-Resource-Configuration-TDD-Info', mode=MODE_TYPE)
    _IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_gNB_DU_Cell_NA_Resourc_Configuration_TDD = SEQ(name='gNB-DU-Cell-NA-Resourc-Configuration-TDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-Cell-Resource-Configuration')))
    _IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_nRFreqInfo = SEQ(name='nRFreqInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRFreqInfo')), opt=True)
    _IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_transmission_Bandwidth = SEQ(name='transmission-Bandwidth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Transmission-Bandwidth')), opt=True)
    _IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_nR_Carrier_List = SEQ_OF(name='nR-Carrier-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')), opt=True)
    _IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__id._const_tab = ____IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__id_tab
    ___IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__id._const_tab_at = None
    ___IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality._const_tab = ____IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality_tab
    ___IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue._const_tab = ____IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue_tab
    ___IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__id),
        ('criticality', ___IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue),
        ])
    __IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item_._ext = None
    _IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions._cont = __IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item_
    _IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IAB_MT_Cell_NA_Resource_Configuration_TDD_Info._cont = ASN1Dict([
        ('gNB-DU-Cell-NA-Resourc-Configuration-TDD', _IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_gNB_DU_Cell_NA_Resourc_Configuration_TDD),
        ('nRFreqInfo', _IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_nRFreqInfo),
        ('transmission-Bandwidth', _IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_transmission_Bandwidth),
        ('nR-Carrier-List', _IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_nR_Carrier_List),
        ('iE-Extensions', _IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions),
        ])
    IAB_MT_Cell_NA_Resource_Configuration_TDD_Info._ext = []
    
    #-----< IAB-MT-Cell-NA-Resource-Configuration-TDD-Info-ExtIEs >-----#
    IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_ExtIEs = CLASS(name='IAB-MT-Cell-NA-Resource-Configuration-TDD-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IAB-STC-Info >-----#
    IAB_STC_Info = SEQ(name='IAB-STC-Info', mode=MODE_TYPE)
    _IAB_STC_Info_iAB_STC_Info_List = SEQ_OF(name='iAB-STC-Info-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IAB-STC-Info-List')))
    _IAB_STC_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IAB_STC_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IAB_STC_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____IAB_STC_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_STC_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_STC_Info_iE_Extensions__item__id._const_tab = ____IAB_STC_Info_iE_Extensions__item__id_tab
    ___IAB_STC_Info_iE_Extensions__item__id._const_tab_at = None
    ___IAB_STC_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___IAB_STC_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IAB_STC_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_STC_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_STC_Info_iE_Extensions__item__criticality._const_tab = ____IAB_STC_Info_iE_Extensions__item__criticality_tab
    ___IAB_STC_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IAB_STC_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IAB_STC_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IAB_STC_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_STC_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_STC_Info_iE_Extensions__item__extensionValue._const_tab = ____IAB_STC_Info_iE_Extensions__item__extensionValue_tab
    ___IAB_STC_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IAB_STC_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IAB_STC_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IAB_STC_Info_iE_Extensions__item__id),
        ('criticality', ___IAB_STC_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___IAB_STC_Info_iE_Extensions__item__extensionValue),
        ])
    __IAB_STC_Info_iE_Extensions__item_._ext = None
    _IAB_STC_Info_iE_Extensions._cont = __IAB_STC_Info_iE_Extensions__item_
    _IAB_STC_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IAB_STC_Info._cont = ASN1Dict([
        ('iAB-STC-Info-List', _IAB_STC_Info_iAB_STC_Info_List),
        ('iE-Extensions', _IAB_STC_Info_iE_Extensions),
        ])
    IAB_STC_Info._ext = None
    
    #-----< IAB-STC-Info-ExtIEs >-----#
    IAB_STC_Info_ExtIEs = CLASS(name='IAB-STC-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IAB_STC_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IAB-STC-Info-List >-----#
    IAB_STC_Info_List = SEQ_OF(name='IAB-STC-Info-List', mode=MODE_TYPE)
    _IAB_STC_Info_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-STC-Info-Item')))
    IAB_STC_Info_List._cont = _IAB_STC_Info_List__item_
    IAB_STC_Info_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=45)], ev=None, er=[])
    
    #-----< IAB-STC-Info-Item >-----#
    IAB_STC_Info_Item = SEQ(name='IAB-STC-Info-Item', mode=MODE_TYPE)
    _IAB_STC_Info_Item_sSB_freqInfo = INT(name='sSB-freqInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB-freqInfo')))
    _IAB_STC_Info_Item_sSB_subcarrierSpacing = ENUM(name='sSB-subcarrierSpacing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB-subcarrierSpacing')))
    _IAB_STC_Info_Item_sSB_transmissionPeriodicity = ENUM(name='sSB-transmissionPeriodicity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB-transmissionPeriodicity')))
    _IAB_STC_Info_Item_sSB_transmissionTimingOffset = INT(name='sSB-transmissionTimingOffset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB-transmissionTimingOffset')))
    _IAB_STC_Info_Item_sSB_transmissionBitmap = CHOICE(name='sSB-transmissionBitmap', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB-transmissionBitmap')))
    _IAB_STC_Info_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IAB_STC_Info_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IAB_STC_Info_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____IAB_STC_Info_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_STC_Info_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_STC_Info_Item_iE_Extensions__item__id._const_tab = ____IAB_STC_Info_Item_iE_Extensions__item__id_tab
    ___IAB_STC_Info_Item_iE_Extensions__item__id._const_tab_at = None
    ___IAB_STC_Info_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___IAB_STC_Info_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IAB_STC_Info_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_STC_Info_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_STC_Info_Item_iE_Extensions__item__criticality._const_tab = ____IAB_STC_Info_Item_iE_Extensions__item__criticality_tab
    ___IAB_STC_Info_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IAB_STC_Info_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IAB_STC_Info_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IAB_STC_Info_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_STC_Info_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_STC_Info_Item_iE_Extensions__item__extensionValue._const_tab = ____IAB_STC_Info_Item_iE_Extensions__item__extensionValue_tab
    ___IAB_STC_Info_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IAB_STC_Info_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IAB_STC_Info_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IAB_STC_Info_Item_iE_Extensions__item__id),
        ('criticality', ___IAB_STC_Info_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___IAB_STC_Info_Item_iE_Extensions__item__extensionValue),
        ])
    __IAB_STC_Info_Item_iE_Extensions__item_._ext = None
    _IAB_STC_Info_Item_iE_Extensions._cont = __IAB_STC_Info_Item_iE_Extensions__item_
    _IAB_STC_Info_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IAB_STC_Info_Item._cont = ASN1Dict([
        ('sSB-freqInfo', _IAB_STC_Info_Item_sSB_freqInfo),
        ('sSB-subcarrierSpacing', _IAB_STC_Info_Item_sSB_subcarrierSpacing),
        ('sSB-transmissionPeriodicity', _IAB_STC_Info_Item_sSB_transmissionPeriodicity),
        ('sSB-transmissionTimingOffset', _IAB_STC_Info_Item_sSB_transmissionTimingOffset),
        ('sSB-transmissionBitmap', _IAB_STC_Info_Item_sSB_transmissionBitmap),
        ('iE-Extensions', _IAB_STC_Info_Item_iE_Extensions),
        ])
    IAB_STC_Info_Item._ext = None
    
    #-----< IAB-STC-Info-Item-ExtIEs >-----#
    IAB_STC_Info_Item_ExtIEs = CLASS(name='IAB-STC-Info-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IAB_STC_Info_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IAB-Allocated-TNL-Address-Item >-----#
    IAB_Allocated_TNL_Address_Item = SEQ(name='IAB-Allocated-TNL-Address-Item', mode=MODE_TYPE)
    _IAB_Allocated_TNL_Address_Item_iABTNLAddress = CHOICE(name='iABTNLAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IABTNLAddress')))
    _IAB_Allocated_TNL_Address_Item_iABTNLAddressUsage = ENUM(name='iABTNLAddressUsage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IABTNLAddressUsage')), opt=True)
    _IAB_Allocated_TNL_Address_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IAB_Allocated_TNL_Address_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____IAB_Allocated_TNL_Address_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_Allocated_TNL_Address_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__id._const_tab = ____IAB_Allocated_TNL_Address_Item_iE_Extensions__item__id_tab
    ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__id._const_tab_at = None
    ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IAB_Allocated_TNL_Address_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_Allocated_TNL_Address_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__criticality._const_tab = ____IAB_Allocated_TNL_Address_Item_iE_Extensions__item__criticality_tab
    ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IAB_Allocated_TNL_Address_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_Allocated_TNL_Address_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__extensionValue._const_tab = ____IAB_Allocated_TNL_Address_Item_iE_Extensions__item__extensionValue_tab
    ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IAB_Allocated_TNL_Address_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__id),
        ('criticality', ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__extensionValue),
        ])
    __IAB_Allocated_TNL_Address_Item_iE_Extensions__item_._ext = None
    _IAB_Allocated_TNL_Address_Item_iE_Extensions._cont = __IAB_Allocated_TNL_Address_Item_iE_Extensions__item_
    _IAB_Allocated_TNL_Address_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IAB_Allocated_TNL_Address_Item._cont = ASN1Dict([
        ('iABTNLAddress', _IAB_Allocated_TNL_Address_Item_iABTNLAddress),
        ('iABTNLAddressUsage', _IAB_Allocated_TNL_Address_Item_iABTNLAddressUsage),
        ('iE-Extensions', _IAB_Allocated_TNL_Address_Item_iE_Extensions),
        ])
    IAB_Allocated_TNL_Address_Item._ext = None
    
    #-----< IAB-Allocated-TNL-Address-Item-ExtIEs >-----#
    IAB_Allocated_TNL_Address_Item_ExtIEs = CLASS(name='IAB-Allocated-TNL-Address-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IAB_Allocated_TNL_Address_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IAB-DU-Cell-Resource-Configuration-Mode-Info >-----#
    IAB_DU_Cell_Resource_Configuration_Mode_Info = CHOICE(name='IAB-DU-Cell-Resource-Configuration-Mode-Info', mode=MODE_TYPE)
    _IAB_DU_Cell_Resource_Configuration_Mode_Info_fDD = SEQ(name='fDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IAB-DU-Cell-Resource-Configuration-FDD-Info')))
    _IAB_DU_Cell_Resource_Configuration_Mode_Info_tDD = SEQ(name='tDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IAB-DU-Cell-Resource-Configuration-TDD-Info')))
    _IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_id._const_tab = ___IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_id_tab
    __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_id._const_tab_at = None
    __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_id._const_tab_id = 'id'
    __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_criticality._const_tab = ___IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_criticality_tab
    __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_criticality._const_tab_at = ('..', 'id')
    __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_criticality._const_tab_id = 'criticality'
    __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_value._const_tab = ___IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_value_tab
    __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_value._const_tab_at = ('..', 'id')
    __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_value._const_tab_id = 'Value'
    _IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension._cont = ASN1Dict([
        ('id', __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_id),
        ('criticality', __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_criticality),
        ('value', __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_value),
        ])
    _IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension._ext = None
    IAB_DU_Cell_Resource_Configuration_Mode_Info._cont = ASN1Dict([
        ('fDD', _IAB_DU_Cell_Resource_Configuration_Mode_Info_fDD),
        ('tDD', _IAB_DU_Cell_Resource_Configuration_Mode_Info_tDD),
        ('choice-extension', _IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension),
        ])
    IAB_DU_Cell_Resource_Configuration_Mode_Info._ext = None
    
    #-----< IAB-DU-Cell-Resource-Configuration-Mode-Info-ExtIEs >-----#
    IAB_DU_Cell_Resource_Configuration_Mode_Info_ExtIEs = CLASS(name='IAB-DU-Cell-Resource-Configuration-Mode-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    IAB_DU_Cell_Resource_Configuration_Mode_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IAB-DU-Cell-Resource-Configuration-FDD-Info >-----#
    IAB_DU_Cell_Resource_Configuration_FDD_Info = SEQ(name='IAB-DU-Cell-Resource-Configuration-FDD-Info', mode=MODE_TYPE)
    _IAB_DU_Cell_Resource_Configuration_FDD_Info_gNB_DU_Cell_Resource_Configuration_FDD_UL = SEQ(name='gNB-DU-Cell-Resource-Configuration-FDD-UL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-Cell-Resource-Configuration')))
    _IAB_DU_Cell_Resource_Configuration_FDD_Info_gNB_DU_Cell_Resource_Configuration_FDD_DL = SEQ(name='gNB-DU-Cell-Resource-Configuration-FDD-DL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-Cell-Resource-Configuration')))
    _IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRFreqInfo')))
    _____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transmission-Bandwidth')))
    _____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')))
    _____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRFreqInfo')))
    _____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transmission-Bandwidth')))
    _____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')))
    ____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 524), ('criticality', 'reject'), ('Extension', _____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 525), ('criticality', 'reject'), ('Extension', _____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 528), ('criticality', 'reject'), ('Extension', _____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 526), ('criticality', 'reject'), ('Extension', _____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 527), ('criticality', 'reject'), ('Extension', _____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 529), ('criticality', 'reject'), ('Extension', _____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id._const_tab = ____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab
    ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id._const_tab_at = None
    ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality._const_tab = ____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab
    ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue._const_tab = ____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab
    ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id),
        ('criticality', ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue),
        ])
    __IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item_._ext = None
    _IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions._cont = __IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item_
    _IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IAB_DU_Cell_Resource_Configuration_FDD_Info._cont = ASN1Dict([
        ('gNB-DU-Cell-Resource-Configuration-FDD-UL', _IAB_DU_Cell_Resource_Configuration_FDD_Info_gNB_DU_Cell_Resource_Configuration_FDD_UL),
        ('gNB-DU-Cell-Resource-Configuration-FDD-DL', _IAB_DU_Cell_Resource_Configuration_FDD_Info_gNB_DU_Cell_Resource_Configuration_FDD_DL),
        ('iE-Extensions', _IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions),
        ])
    IAB_DU_Cell_Resource_Configuration_FDD_Info._ext = []
    
    #-----< IAB-DU-Cell-Resource-Configuration-FDD-Info-ExtIEs >-----#
    IAB_DU_Cell_Resource_Configuration_FDD_Info_ExtIEs = CLASS(name='IAB-DU-Cell-Resource-Configuration-FDD-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _IAB_DU_Cell_Resource_Configuration_FDD_Info_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRFreqInfo')))
    _IAB_DU_Cell_Resource_Configuration_FDD_Info_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transmission-Bandwidth')))
    _IAB_DU_Cell_Resource_Configuration_FDD_Info_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')))
    _IAB_DU_Cell_Resource_Configuration_FDD_Info_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRFreqInfo')))
    _IAB_DU_Cell_Resource_Configuration_FDD_Info_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transmission-Bandwidth')))
    _IAB_DU_Cell_Resource_Configuration_FDD_Info_ExtIEs_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')))
    IAB_DU_Cell_Resource_Configuration_FDD_Info_ExtIEs._val = ASN1Set(rv=[dict([('id', 524), ('criticality', 'reject'), ('Extension', _IAB_DU_Cell_Resource_Configuration_FDD_Info_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 525), ('criticality', 'reject'), ('Extension', _IAB_DU_Cell_Resource_Configuration_FDD_Info_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 528), ('criticality', 'reject'), ('Extension', _IAB_DU_Cell_Resource_Configuration_FDD_Info_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 526), ('criticality', 'reject'), ('Extension', _IAB_DU_Cell_Resource_Configuration_FDD_Info_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 527), ('criticality', 'reject'), ('Extension', _IAB_DU_Cell_Resource_Configuration_FDD_Info_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 529), ('criticality', 'reject'), ('Extension', _IAB_DU_Cell_Resource_Configuration_FDD_Info_ExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< IAB-DU-Cell-Resource-Configuration-TDD-Info >-----#
    IAB_DU_Cell_Resource_Configuration_TDD_Info = SEQ(name='IAB-DU-Cell-Resource-Configuration-TDD-Info', mode=MODE_TYPE)
    _IAB_DU_Cell_Resource_Configuration_TDD_Info_gNB_DU_Cell_Resourc_Configuration_TDD = SEQ(name='gNB-DU-Cell-Resourc-Configuration-TDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-Cell-Resource-Configuration')))
    _IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRFreqInfo')))
    _____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transmission-Bandwidth')))
    _____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')))
    ____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 530), ('criticality', 'reject'), ('Extension', _____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 531), ('criticality', 'reject'), ('Extension', _____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 532), ('criticality', 'reject'), ('Extension', _____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id._const_tab = ____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id_tab
    ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id._const_tab_at = None
    ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality._const_tab = ____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id_tab
    ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue._const_tab = ____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id_tab
    ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id),
        ('criticality', ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue),
        ])
    __IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item_._ext = None
    _IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions._cont = __IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item_
    _IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IAB_DU_Cell_Resource_Configuration_TDD_Info._cont = ASN1Dict([
        ('gNB-DU-Cell-Resourc-Configuration-TDD', _IAB_DU_Cell_Resource_Configuration_TDD_Info_gNB_DU_Cell_Resourc_Configuration_TDD),
        ('iE-Extensions', _IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions),
        ])
    IAB_DU_Cell_Resource_Configuration_TDD_Info._ext = []
    
    #-----< IAB-DU-Cell-Resource-Configuration-TDD-Info-ExtIEs >-----#
    IAB_DU_Cell_Resource_Configuration_TDD_Info_ExtIEs = CLASS(name='IAB-DU-Cell-Resource-Configuration-TDD-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _IAB_DU_Cell_Resource_Configuration_TDD_Info_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRFreqInfo')))
    _IAB_DU_Cell_Resource_Configuration_TDD_Info_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transmission-Bandwidth')))
    _IAB_DU_Cell_Resource_Configuration_TDD_Info_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')))
    IAB_DU_Cell_Resource_Configuration_TDD_Info_ExtIEs._val = ASN1Set(rv=[dict([('id', 530), ('criticality', 'reject'), ('Extension', _IAB_DU_Cell_Resource_Configuration_TDD_Info_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 531), ('criticality', 'reject'), ('Extension', _IAB_DU_Cell_Resource_Configuration_TDD_Info_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 532), ('criticality', 'reject'), ('Extension', _IAB_DU_Cell_Resource_Configuration_TDD_Info_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< IABIPv6RequestType >-----#
    IABIPv6RequestType = CHOICE(name='IABIPv6RequestType', mode=MODE_TYPE)
    _IABIPv6RequestType_iPv6Address = SEQ(name='iPv6Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IABTNLAddressesRequested')))
    _IABIPv6RequestType_iPv6Prefix = SEQ(name='iPv6Prefix', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IABTNLAddressesRequested')))
    _IABIPv6RequestType_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __IABIPv6RequestType_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___IABIPv6RequestType_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___IABIPv6RequestType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IABIPv6RequestType_choice_extension_id._const_tab = ___IABIPv6RequestType_choice_extension_id_tab
    __IABIPv6RequestType_choice_extension_id._const_tab_at = None
    __IABIPv6RequestType_choice_extension_id._const_tab_id = 'id'
    __IABIPv6RequestType_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___IABIPv6RequestType_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___IABIPv6RequestType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IABIPv6RequestType_choice_extension_criticality._const_tab = ___IABIPv6RequestType_choice_extension_criticality_tab
    __IABIPv6RequestType_choice_extension_criticality._const_tab_at = ('..', 'id')
    __IABIPv6RequestType_choice_extension_criticality._const_tab_id = 'criticality'
    __IABIPv6RequestType_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___IABIPv6RequestType_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___IABIPv6RequestType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IABIPv6RequestType_choice_extension_value._const_tab = ___IABIPv6RequestType_choice_extension_value_tab
    __IABIPv6RequestType_choice_extension_value._const_tab_at = ('..', 'id')
    __IABIPv6RequestType_choice_extension_value._const_tab_id = 'Value'
    _IABIPv6RequestType_choice_extension._cont = ASN1Dict([
        ('id', __IABIPv6RequestType_choice_extension_id),
        ('criticality', __IABIPv6RequestType_choice_extension_criticality),
        ('value', __IABIPv6RequestType_choice_extension_value),
        ])
    _IABIPv6RequestType_choice_extension._ext = None
    IABIPv6RequestType._cont = ASN1Dict([
        ('iPv6Address', _IABIPv6RequestType_iPv6Address),
        ('iPv6Prefix', _IABIPv6RequestType_iPv6Prefix),
        ('choice-extension', _IABIPv6RequestType_choice_extension),
        ])
    IABIPv6RequestType._ext = None
    
    #-----< IABIPv6RequestType-ExtIEs >-----#
    IABIPv6RequestType_ExtIEs = CLASS(name='IABIPv6RequestType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    IABIPv6RequestType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IABTNLAddress >-----#
    IABTNLAddress = CHOICE(name='IABTNLAddress', mode=MODE_TYPE)
    _IABTNLAddress_iPv4Address = BIT_STR(name='iPv4Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IABTNLAddress_iPv4Address._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _IABTNLAddress_iPv6Address = BIT_STR(name='iPv6Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IABTNLAddress_iPv6Address._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    _IABTNLAddress_iPv6Prefix = BIT_STR(name='iPv6Prefix', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IABTNLAddress_iPv6Prefix._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    _IABTNLAddress_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __IABTNLAddress_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___IABTNLAddress_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___IABTNLAddress_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IABTNLAddress_choice_extension_id._const_tab = ___IABTNLAddress_choice_extension_id_tab
    __IABTNLAddress_choice_extension_id._const_tab_at = None
    __IABTNLAddress_choice_extension_id._const_tab_id = 'id'
    __IABTNLAddress_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___IABTNLAddress_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___IABTNLAddress_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IABTNLAddress_choice_extension_criticality._const_tab = ___IABTNLAddress_choice_extension_criticality_tab
    __IABTNLAddress_choice_extension_criticality._const_tab_at = ('..', 'id')
    __IABTNLAddress_choice_extension_criticality._const_tab_id = 'criticality'
    __IABTNLAddress_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___IABTNLAddress_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___IABTNLAddress_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IABTNLAddress_choice_extension_value._const_tab = ___IABTNLAddress_choice_extension_value_tab
    __IABTNLAddress_choice_extension_value._const_tab_at = ('..', 'id')
    __IABTNLAddress_choice_extension_value._const_tab_id = 'Value'
    _IABTNLAddress_choice_extension._cont = ASN1Dict([
        ('id', __IABTNLAddress_choice_extension_id),
        ('criticality', __IABTNLAddress_choice_extension_criticality),
        ('value', __IABTNLAddress_choice_extension_value),
        ])
    _IABTNLAddress_choice_extension._ext = None
    IABTNLAddress._cont = ASN1Dict([
        ('iPv4Address', _IABTNLAddress_iPv4Address),
        ('iPv6Address', _IABTNLAddress_iPv6Address),
        ('iPv6Prefix', _IABTNLAddress_iPv6Prefix),
        ('choice-extension', _IABTNLAddress_choice_extension),
        ])
    IABTNLAddress._ext = None
    
    #-----< IABTNLAddress-ExtIEs >-----#
    IABTNLAddress_ExtIEs = CLASS(name='IABTNLAddress-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    IABTNLAddress_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IABTNLAddressesRequested >-----#
    IABTNLAddressesRequested = SEQ(name='IABTNLAddressesRequested', mode=MODE_TYPE)
    _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedAllTraffic = INT(name='tNLAddressesOrPrefixesRequestedAllTraffic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedAllTraffic._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedF1_C = INT(name='tNLAddressesOrPrefixesRequestedF1-C', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedF1_C._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedF1_U = INT(name='tNLAddressesOrPrefixesRequestedF1-U', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedF1_U._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedNoNF1 = INT(name='tNLAddressesOrPrefixesRequestedNoNF1', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedNoNF1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _IABTNLAddressesRequested_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IABTNLAddressesRequested_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IABTNLAddressesRequested_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____IABTNLAddressesRequested_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IABTNLAddressesRequested_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IABTNLAddressesRequested_iE_Extensions__item__id._const_tab = ____IABTNLAddressesRequested_iE_Extensions__item__id_tab
    ___IABTNLAddressesRequested_iE_Extensions__item__id._const_tab_at = None
    ___IABTNLAddressesRequested_iE_Extensions__item__id._const_tab_id = 'id'
    ___IABTNLAddressesRequested_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IABTNLAddressesRequested_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IABTNLAddressesRequested_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IABTNLAddressesRequested_iE_Extensions__item__criticality._const_tab = ____IABTNLAddressesRequested_iE_Extensions__item__criticality_tab
    ___IABTNLAddressesRequested_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IABTNLAddressesRequested_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IABTNLAddressesRequested_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IABTNLAddressesRequested_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IABTNLAddressesRequested_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IABTNLAddressesRequested_iE_Extensions__item__extensionValue._const_tab = ____IABTNLAddressesRequested_iE_Extensions__item__extensionValue_tab
    ___IABTNLAddressesRequested_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IABTNLAddressesRequested_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IABTNLAddressesRequested_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IABTNLAddressesRequested_iE_Extensions__item__id),
        ('criticality', ___IABTNLAddressesRequested_iE_Extensions__item__criticality),
        ('extensionValue', ___IABTNLAddressesRequested_iE_Extensions__item__extensionValue),
        ])
    __IABTNLAddressesRequested_iE_Extensions__item_._ext = None
    _IABTNLAddressesRequested_iE_Extensions._cont = __IABTNLAddressesRequested_iE_Extensions__item_
    _IABTNLAddressesRequested_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IABTNLAddressesRequested._cont = ASN1Dict([
        ('tNLAddressesOrPrefixesRequestedAllTraffic', _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedAllTraffic),
        ('tNLAddressesOrPrefixesRequestedF1-C', _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedF1_C),
        ('tNLAddressesOrPrefixesRequestedF1-U', _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedF1_U),
        ('tNLAddressesOrPrefixesRequestedNoNF1', _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedNoNF1),
        ('iE-Extensions', _IABTNLAddressesRequested_iE_Extensions),
        ])
    IABTNLAddressesRequested._ext = None
    
    #-----< IABTNLAddressesRequested-ExtIEs >-----#
    IABTNLAddressesRequested_ExtIEs = CLASS(name='IABTNLAddressesRequested-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IABTNLAddressesRequested_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IAB-TNL-Addresses-To-Remove-Item >-----#
    IAB_TNL_Addresses_To_Remove_Item = SEQ(name='IAB-TNL-Addresses-To-Remove-Item', mode=MODE_TYPE)
    _IAB_TNL_Addresses_To_Remove_Item_iABTNLAddress = CHOICE(name='iABTNLAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IABTNLAddress')))
    _IAB_TNL_Addresses_To_Remove_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__id._const_tab = ____IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__id_tab
    ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__id._const_tab_at = None
    ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__criticality._const_tab = ____IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__criticality_tab
    ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab = ____IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__extensionValue_tab
    ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__id),
        ('criticality', ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__extensionValue),
        ])
    __IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item_._ext = None
    _IAB_TNL_Addresses_To_Remove_Item_iE_Extensions._cont = __IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item_
    _IAB_TNL_Addresses_To_Remove_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IAB_TNL_Addresses_To_Remove_Item._cont = ASN1Dict([
        ('iABTNLAddress', _IAB_TNL_Addresses_To_Remove_Item_iABTNLAddress),
        ('iE-Extensions', _IAB_TNL_Addresses_To_Remove_Item_iE_Extensions),
        ])
    IAB_TNL_Addresses_To_Remove_Item._ext = None
    
    #-----< IAB-TNL-Addresses-To-Remove-Item-ExtIEs >-----#
    IAB_TNL_Addresses_To_Remove_Item_ExtIEs = CLASS(name='IAB-TNL-Addresses-To-Remove-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IAB_TNL_Addresses_To_Remove_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IAB-TNL-Addresses-Exception >-----#
    IAB_TNL_Addresses_Exception = SEQ(name='IAB-TNL-Addresses-Exception', mode=MODE_TYPE)
    _IAB_TNL_Addresses_Exception_iABTNLAddressList = SEQ_OF(name='iABTNLAddressList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IABTNLAddressList')))
    _IAB_TNL_Addresses_Exception_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IAB_TNL_Addresses_Exception_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IAB_TNL_Addresses_Exception_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____IAB_TNL_Addresses_Exception_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_TNL_Addresses_Exception_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_TNL_Addresses_Exception_iE_Extensions__item__id._const_tab = ____IAB_TNL_Addresses_Exception_iE_Extensions__item__id_tab
    ___IAB_TNL_Addresses_Exception_iE_Extensions__item__id._const_tab_at = None
    ___IAB_TNL_Addresses_Exception_iE_Extensions__item__id._const_tab_id = 'id'
    ___IAB_TNL_Addresses_Exception_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IAB_TNL_Addresses_Exception_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_TNL_Addresses_Exception_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_TNL_Addresses_Exception_iE_Extensions__item__criticality._const_tab = ____IAB_TNL_Addresses_Exception_iE_Extensions__item__criticality_tab
    ___IAB_TNL_Addresses_Exception_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IAB_TNL_Addresses_Exception_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IAB_TNL_Addresses_Exception_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IAB_TNL_Addresses_Exception_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IAB_TNL_Addresses_Exception_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IAB_TNL_Addresses_Exception_iE_Extensions__item__extensionValue._const_tab = ____IAB_TNL_Addresses_Exception_iE_Extensions__item__extensionValue_tab
    ___IAB_TNL_Addresses_Exception_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IAB_TNL_Addresses_Exception_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IAB_TNL_Addresses_Exception_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IAB_TNL_Addresses_Exception_iE_Extensions__item__id),
        ('criticality', ___IAB_TNL_Addresses_Exception_iE_Extensions__item__criticality),
        ('extensionValue', ___IAB_TNL_Addresses_Exception_iE_Extensions__item__extensionValue),
        ])
    __IAB_TNL_Addresses_Exception_iE_Extensions__item_._ext = None
    _IAB_TNL_Addresses_Exception_iE_Extensions._cont = __IAB_TNL_Addresses_Exception_iE_Extensions__item_
    _IAB_TNL_Addresses_Exception_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IAB_TNL_Addresses_Exception._cont = ASN1Dict([
        ('iABTNLAddressList', _IAB_TNL_Addresses_Exception_iABTNLAddressList),
        ('iE-Extensions', _IAB_TNL_Addresses_Exception_iE_Extensions),
        ])
    IAB_TNL_Addresses_Exception._ext = None
    
    #-----< IAB-TNL-Addresses-Exception-ExtIEs >-----#
    IAB_TNL_Addresses_Exception_ExtIEs = CLASS(name='IAB-TNL-Addresses-Exception-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IAB_TNL_Addresses_Exception_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IABTNLAddressList >-----#
    IABTNLAddressList = SEQ_OF(name='IABTNLAddressList', mode=MODE_TYPE)
    _IABTNLAddressList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IABTNLAddress-Item')))
    IABTNLAddressList._cont = _IABTNLAddressList__item_
    IABTNLAddressList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< IABTNLAddress-Item >-----#
    IABTNLAddress_Item = SEQ(name='IABTNLAddress-Item', mode=MODE_TYPE)
    _IABTNLAddress_Item_iABTNLAddress = CHOICE(name='iABTNLAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IABTNLAddress')))
    _IABTNLAddress_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IABTNLAddress_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IABTNLAddress_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____IABTNLAddress_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IABTNLAddress_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IABTNLAddress_Item_iE_Extensions__item__id._const_tab = ____IABTNLAddress_Item_iE_Extensions__item__id_tab
    ___IABTNLAddress_Item_iE_Extensions__item__id._const_tab_at = None
    ___IABTNLAddress_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___IABTNLAddress_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IABTNLAddress_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IABTNLAddress_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IABTNLAddress_Item_iE_Extensions__item__criticality._const_tab = ____IABTNLAddress_Item_iE_Extensions__item__criticality_tab
    ___IABTNLAddress_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IABTNLAddress_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IABTNLAddress_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IABTNLAddress_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IABTNLAddress_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IABTNLAddress_Item_iE_Extensions__item__extensionValue._const_tab = ____IABTNLAddress_Item_iE_Extensions__item__extensionValue_tab
    ___IABTNLAddress_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IABTNLAddress_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IABTNLAddress_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IABTNLAddress_Item_iE_Extensions__item__id),
        ('criticality', ___IABTNLAddress_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___IABTNLAddress_Item_iE_Extensions__item__extensionValue),
        ])
    __IABTNLAddress_Item_iE_Extensions__item_._ext = None
    _IABTNLAddress_Item_iE_Extensions._cont = __IABTNLAddress_Item_iE_Extensions__item_
    _IABTNLAddress_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IABTNLAddress_Item._cont = ASN1Dict([
        ('iABTNLAddress', _IABTNLAddress_Item_iABTNLAddress),
        ('iE-Extensions', _IABTNLAddress_Item_iE_Extensions),
        ])
    IABTNLAddress_Item._ext = None
    
    #-----< IABTNLAddress-ItemExtIEs >-----#
    IABTNLAddress_ItemExtIEs = CLASS(name='IABTNLAddress-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IABTNLAddress_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IABTNLAddressUsage >-----#
    IABTNLAddressUsage = ENUM(name='IABTNLAddressUsage', mode=MODE_TYPE)
    IABTNLAddressUsage._cont = ASN1Dict([('f1-c', 0), ('f1-u', 1), ('non-f1', 2)])
    IABTNLAddressUsage._ext = []
    
    #-----< IABv4AddressesRequested >-----#
    IABv4AddressesRequested = SEQ(name='IABv4AddressesRequested', mode=MODE_TYPE)
    _IABv4AddressesRequested_iABv4AddressesRequested = SEQ(name='iABv4AddressesRequested', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IABTNLAddressesRequested')))
    _IABv4AddressesRequested_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IABv4AddressesRequested_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IABv4AddressesRequested_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____IABv4AddressesRequested_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IABv4AddressesRequested_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IABv4AddressesRequested_iE_Extensions__item__id._const_tab = ____IABv4AddressesRequested_iE_Extensions__item__id_tab
    ___IABv4AddressesRequested_iE_Extensions__item__id._const_tab_at = None
    ___IABv4AddressesRequested_iE_Extensions__item__id._const_tab_id = 'id'
    ___IABv4AddressesRequested_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IABv4AddressesRequested_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IABv4AddressesRequested_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IABv4AddressesRequested_iE_Extensions__item__criticality._const_tab = ____IABv4AddressesRequested_iE_Extensions__item__criticality_tab
    ___IABv4AddressesRequested_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IABv4AddressesRequested_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IABv4AddressesRequested_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IABv4AddressesRequested_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IABv4AddressesRequested_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IABv4AddressesRequested_iE_Extensions__item__extensionValue._const_tab = ____IABv4AddressesRequested_iE_Extensions__item__extensionValue_tab
    ___IABv4AddressesRequested_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IABv4AddressesRequested_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IABv4AddressesRequested_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IABv4AddressesRequested_iE_Extensions__item__id),
        ('criticality', ___IABv4AddressesRequested_iE_Extensions__item__criticality),
        ('extensionValue', ___IABv4AddressesRequested_iE_Extensions__item__extensionValue),
        ])
    __IABv4AddressesRequested_iE_Extensions__item_._ext = None
    _IABv4AddressesRequested_iE_Extensions._cont = __IABv4AddressesRequested_iE_Extensions__item_
    _IABv4AddressesRequested_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IABv4AddressesRequested._cont = ASN1Dict([
        ('iABv4AddressesRequested', _IABv4AddressesRequested_iABv4AddressesRequested),
        ('iE-Extensions', _IABv4AddressesRequested_iE_Extensions),
        ])
    IABv4AddressesRequested._ext = None
    
    #-----< IABv4AddressesRequested-ExtIEs >-----#
    IABv4AddressesRequested_ExtIEs = CLASS(name='IABv4AddressesRequested-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IABv4AddressesRequested_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ImplicitFormat >-----#
    ImplicitFormat = SEQ(name='ImplicitFormat', mode=MODE_TYPE)
    _ImplicitFormat_dUFSlotformatIndex = INT(name='dUFSlotformatIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DUFSlotformatIndex')))
    _ImplicitFormat_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ImplicitFormat_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ImplicitFormat_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ImplicitFormat_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ImplicitFormat_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ImplicitFormat_iE_Extensions__item__id._const_tab = ____ImplicitFormat_iE_Extensions__item__id_tab
    ___ImplicitFormat_iE_Extensions__item__id._const_tab_at = None
    ___ImplicitFormat_iE_Extensions__item__id._const_tab_id = 'id'
    ___ImplicitFormat_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ImplicitFormat_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ImplicitFormat_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ImplicitFormat_iE_Extensions__item__criticality._const_tab = ____ImplicitFormat_iE_Extensions__item__criticality_tab
    ___ImplicitFormat_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ImplicitFormat_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ImplicitFormat_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ImplicitFormat_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ImplicitFormat_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ImplicitFormat_iE_Extensions__item__extensionValue._const_tab = ____ImplicitFormat_iE_Extensions__item__extensionValue_tab
    ___ImplicitFormat_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ImplicitFormat_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ImplicitFormat_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ImplicitFormat_iE_Extensions__item__id),
        ('criticality', ___ImplicitFormat_iE_Extensions__item__criticality),
        ('extensionValue', ___ImplicitFormat_iE_Extensions__item__extensionValue),
        ])
    __ImplicitFormat_iE_Extensions__item_._ext = None
    _ImplicitFormat_iE_Extensions._cont = __ImplicitFormat_iE_Extensions__item_
    _ImplicitFormat_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ImplicitFormat._cont = ASN1Dict([
        ('dUFSlotformatIndex', _ImplicitFormat_dUFSlotformatIndex),
        ('iE-Extensions', _ImplicitFormat_iE_Extensions),
        ])
    ImplicitFormat._ext = None
    
    #-----< ImplicitFormat-ExtIEs >-----#
    ImplicitFormat_ExtIEs = CLASS(name='ImplicitFormat-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ImplicitFormat_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IgnorePRACHConfiguration >-----#
    IgnorePRACHConfiguration = ENUM(name='IgnorePRACHConfiguration', mode=MODE_TYPE)
    IgnorePRACHConfiguration._cont = ASN1Dict([('true', 0)])
    IgnorePRACHConfiguration._ext = []
    
    #-----< IgnoreResourceCoordinationContainer >-----#
    IgnoreResourceCoordinationContainer = ENUM(name='IgnoreResourceCoordinationContainer', mode=MODE_TYPE)
    IgnoreResourceCoordinationContainer._cont = ASN1Dict([('yes', 0)])
    IgnoreResourceCoordinationContainer._ext = []
    
    #-----< InactivityMonitoringRequest >-----#
    InactivityMonitoringRequest = ENUM(name='InactivityMonitoringRequest', mode=MODE_TYPE)
    InactivityMonitoringRequest._cont = ASN1Dict([('true', 0)])
    InactivityMonitoringRequest._ext = []
    
    #-----< InactivityMonitoringResponse >-----#
    InactivityMonitoringResponse = ENUM(name='InactivityMonitoringResponse', mode=MODE_TYPE)
    InactivityMonitoringResponse._cont = ASN1Dict([('not-supported', 0)])
    InactivityMonitoringResponse._ext = []
    
    #-----< InterfacesToTrace >-----#
    InterfacesToTrace = BIT_STR(name='InterfacesToTrace', mode=MODE_TYPE)
    InterfacesToTrace._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< IntendedTDD-DL-ULConfig >-----#
    IntendedTDD_DL_ULConfig = SEQ(name='IntendedTDD-DL-ULConfig', mode=MODE_TYPE)
    _IntendedTDD_DL_ULConfig_nRSCS = ENUM(name='nRSCS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IntendedTDD_DL_ULConfig_nRSCS._cont = ASN1Dict([('scs15', 0), ('scs30', 1), ('scs60', 2), ('scs120', 3), ('scs480', 4), ('scs960', 5)])
    _IntendedTDD_DL_ULConfig_nRSCS._ext = ['scs480', 'scs960']
    _IntendedTDD_DL_ULConfig_nRCP = ENUM(name='nRCP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IntendedTDD_DL_ULConfig_nRCP._cont = ASN1Dict([('normal', 0), ('extended', 1)])
    _IntendedTDD_DL_ULConfig_nRCP._ext = []
    _IntendedTDD_DL_ULConfig_nRDLULTxPeriodicity = ENUM(name='nRDLULTxPeriodicity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IntendedTDD_DL_ULConfig_nRDLULTxPeriodicity._cont = ASN1Dict([('ms0p5', 0), ('ms0p625', 1), ('ms1', 2), ('ms1p25', 3), ('ms2', 4), ('ms2p5', 5), ('ms3', 6), ('ms4', 7), ('ms5', 8), ('ms10', 9), ('ms20', 10), ('ms40', 11), ('ms60', 12), ('ms80', 13), ('ms100', 14), ('ms120', 15), ('ms140', 16), ('ms160', 17)])
    _IntendedTDD_DL_ULConfig_nRDLULTxPeriodicity._ext = []
    _IntendedTDD_DL_ULConfig_slot_Configuration_List = SEQ_OF(name='slot-Configuration-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Slot-Configuration-List')))
    _IntendedTDD_DL_ULConfig_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IntendedTDD_DL_ULConfig_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IntendedTDD_DL_ULConfig_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____IntendedTDD_DL_ULConfig_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IntendedTDD_DL_ULConfig_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntendedTDD_DL_ULConfig_iE_Extensions__item__id._const_tab = ____IntendedTDD_DL_ULConfig_iE_Extensions__item__id_tab
    ___IntendedTDD_DL_ULConfig_iE_Extensions__item__id._const_tab_at = None
    ___IntendedTDD_DL_ULConfig_iE_Extensions__item__id._const_tab_id = 'id'
    ___IntendedTDD_DL_ULConfig_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IntendedTDD_DL_ULConfig_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IntendedTDD_DL_ULConfig_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntendedTDD_DL_ULConfig_iE_Extensions__item__criticality._const_tab = ____IntendedTDD_DL_ULConfig_iE_Extensions__item__criticality_tab
    ___IntendedTDD_DL_ULConfig_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IntendedTDD_DL_ULConfig_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IntendedTDD_DL_ULConfig_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IntendedTDD_DL_ULConfig_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IntendedTDD_DL_ULConfig_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntendedTDD_DL_ULConfig_iE_Extensions__item__extensionValue._const_tab = ____IntendedTDD_DL_ULConfig_iE_Extensions__item__extensionValue_tab
    ___IntendedTDD_DL_ULConfig_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IntendedTDD_DL_ULConfig_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IntendedTDD_DL_ULConfig_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IntendedTDD_DL_ULConfig_iE_Extensions__item__id),
        ('criticality', ___IntendedTDD_DL_ULConfig_iE_Extensions__item__criticality),
        ('extensionValue', ___IntendedTDD_DL_ULConfig_iE_Extensions__item__extensionValue),
        ])
    __IntendedTDD_DL_ULConfig_iE_Extensions__item_._ext = None
    _IntendedTDD_DL_ULConfig_iE_Extensions._cont = __IntendedTDD_DL_ULConfig_iE_Extensions__item_
    _IntendedTDD_DL_ULConfig_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IntendedTDD_DL_ULConfig._cont = ASN1Dict([
        ('nRSCS', _IntendedTDD_DL_ULConfig_nRSCS),
        ('nRCP', _IntendedTDD_DL_ULConfig_nRCP),
        ('nRDLULTxPeriodicity', _IntendedTDD_DL_ULConfig_nRDLULTxPeriodicity),
        ('slot-Configuration-List', _IntendedTDD_DL_ULConfig_slot_Configuration_List),
        ('iE-Extensions', _IntendedTDD_DL_ULConfig_iE_Extensions),
        ])
    IntendedTDD_DL_ULConfig._ext = None
    
    #-----< InterFrequencyConfig-NoGap >-----#
    InterFrequencyConfig_NoGap = ENUM(name='InterFrequencyConfig-NoGap', mode=MODE_TYPE)
    InterFrequencyConfig_NoGap._cont = ASN1Dict([('true', 0)])
    InterFrequencyConfig_NoGap._ext = []
    
    #-----< IngressNonF1terminatingTopologyIndicator >-----#
    IngressNonF1terminatingTopologyIndicator = ENUM(name='IngressNonF1terminatingTopologyIndicator', mode=MODE_TYPE)
    IngressNonF1terminatingTopologyIndicator._cont = ASN1Dict([('true', 0)])
    IngressNonF1terminatingTopologyIndicator._ext = []
    
    #-----< IntendedTDD-DL-ULConfig-ExtIEs >-----#
    IntendedTDD_DL_ULConfig_ExtIEs = CLASS(name='IntendedTDD-DL-ULConfig-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IntendedTDD_DL_ULConfig_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IPHeaderInformation >-----#
    IPHeaderInformation = SEQ(name='IPHeaderInformation', mode=MODE_TYPE)
    _IPHeaderInformation_destinationIABTNLAddress = CHOICE(name='destinationIABTNLAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IABTNLAddress')))
    _IPHeaderInformation_dsInformationList = SEQ_OF(name='dsInformationList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DSInformationList')), opt=True)
    _IPHeaderInformation_iPv6FlowLabel = BIT_STR(name='iPv6FlowLabel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IPHeaderInformation_iPv6FlowLabel._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    _IPHeaderInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IPHeaderInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IPHeaderInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____IPHeaderInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IPHeaderInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPHeaderInformation_iE_Extensions__item__id._const_tab = ____IPHeaderInformation_iE_Extensions__item__id_tab
    ___IPHeaderInformation_iE_Extensions__item__id._const_tab_at = None
    ___IPHeaderInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___IPHeaderInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IPHeaderInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IPHeaderInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPHeaderInformation_iE_Extensions__item__criticality._const_tab = ____IPHeaderInformation_iE_Extensions__item__criticality_tab
    ___IPHeaderInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IPHeaderInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IPHeaderInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IPHeaderInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IPHeaderInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPHeaderInformation_iE_Extensions__item__extensionValue._const_tab = ____IPHeaderInformation_iE_Extensions__item__extensionValue_tab
    ___IPHeaderInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IPHeaderInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IPHeaderInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IPHeaderInformation_iE_Extensions__item__id),
        ('criticality', ___IPHeaderInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___IPHeaderInformation_iE_Extensions__item__extensionValue),
        ])
    __IPHeaderInformation_iE_Extensions__item_._ext = None
    _IPHeaderInformation_iE_Extensions._cont = __IPHeaderInformation_iE_Extensions__item_
    _IPHeaderInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IPHeaderInformation._cont = ASN1Dict([
        ('destinationIABTNLAddress', _IPHeaderInformation_destinationIABTNLAddress),
        ('dsInformationList', _IPHeaderInformation_dsInformationList),
        ('iPv6FlowLabel', _IPHeaderInformation_iPv6FlowLabel),
        ('iE-Extensions', _IPHeaderInformation_iE_Extensions),
        ])
    IPHeaderInformation._ext = []
    
    #-----< IPHeaderInformation-ItemExtIEs >-----#
    IPHeaderInformation_ItemExtIEs = CLASS(name='IPHeaderInformation-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IPHeaderInformation_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IPtolayer2TrafficMappingInfo >-----#
    IPtolayer2TrafficMappingInfo = SEQ(name='IPtolayer2TrafficMappingInfo', mode=MODE_TYPE)
    _IPtolayer2TrafficMappingInfo_iPtolayer2TrafficMappingInfoToAdd = SEQ_OF(name='iPtolayer2TrafficMappingInfoToAdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IPtolayer2TrafficMappingInfoList')), opt=True)
    _IPtolayer2TrafficMappingInfo_iPtolayer2TrafficMappingInfoToRemove = SEQ_OF(name='iPtolayer2TrafficMappingInfoToRemove', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MappingInformationtoRemove')), opt=True)
    _IPtolayer2TrafficMappingInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IPtolayer2TrafficMappingInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____IPtolayer2TrafficMappingInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IPtolayer2TrafficMappingInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__id._const_tab = ____IPtolayer2TrafficMappingInfo_iE_Extensions__item__id_tab
    ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__id._const_tab_at = None
    ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IPtolayer2TrafficMappingInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IPtolayer2TrafficMappingInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__criticality._const_tab = ____IPtolayer2TrafficMappingInfo_iE_Extensions__item__criticality_tab
    ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IPtolayer2TrafficMappingInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IPtolayer2TrafficMappingInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__extensionValue._const_tab = ____IPtolayer2TrafficMappingInfo_iE_Extensions__item__extensionValue_tab
    ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IPtolayer2TrafficMappingInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__id),
        ('criticality', ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__extensionValue),
        ])
    __IPtolayer2TrafficMappingInfo_iE_Extensions__item_._ext = None
    _IPtolayer2TrafficMappingInfo_iE_Extensions._cont = __IPtolayer2TrafficMappingInfo_iE_Extensions__item_
    _IPtolayer2TrafficMappingInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IPtolayer2TrafficMappingInfo._cont = ASN1Dict([
        ('iPtolayer2TrafficMappingInfoToAdd', _IPtolayer2TrafficMappingInfo_iPtolayer2TrafficMappingInfoToAdd),
        ('iPtolayer2TrafficMappingInfoToRemove', _IPtolayer2TrafficMappingInfo_iPtolayer2TrafficMappingInfoToRemove),
        ('iE-Extensions', _IPtolayer2TrafficMappingInfo_iE_Extensions),
        ])
    IPtolayer2TrafficMappingInfo._ext = []
    
    #-----< IPtolayer2TrafficMappingInfoList >-----#
    IPtolayer2TrafficMappingInfoList = SEQ_OF(name='IPtolayer2TrafficMappingInfoList', mode=MODE_TYPE)
    _IPtolayer2TrafficMappingInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IPtolayer2TrafficMappingInfo-Item')))
    IPtolayer2TrafficMappingInfoList._cont = _IPtolayer2TrafficMappingInfoList__item_
    IPtolayer2TrafficMappingInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=67108864)], ev=None, er=[])
    
    #-----< IPtolayer2TrafficMappingInfo-Item >-----#
    IPtolayer2TrafficMappingInfo_Item = SEQ(name='IPtolayer2TrafficMappingInfo-Item', mode=MODE_TYPE)
    _IPtolayer2TrafficMappingInfo_Item_mappingInformationIndex = BIT_STR(name='mappingInformationIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MappingInformationIndex')))
    _IPtolayer2TrafficMappingInfo_Item_iPHeaderInformation = SEQ(name='iPHeaderInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IPHeaderInformation')))
    _IPtolayer2TrafficMappingInfo_Item_bHInfo = SEQ(name='bHInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHInfo')))
    _IPtolayer2TrafficMappingInfo_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__id._const_tab = ____IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__id_tab
    ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__id._const_tab_at = None
    ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__criticality._const_tab = ____IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__criticality_tab
    ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__extensionValue._const_tab = ____IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__extensionValue_tab
    ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__id),
        ('criticality', ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__extensionValue),
        ])
    __IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item_._ext = None
    _IPtolayer2TrafficMappingInfo_Item_iE_Extensions._cont = __IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item_
    _IPtolayer2TrafficMappingInfo_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IPtolayer2TrafficMappingInfo_Item._cont = ASN1Dict([
        ('mappingInformationIndex', _IPtolayer2TrafficMappingInfo_Item_mappingInformationIndex),
        ('iPHeaderInformation', _IPtolayer2TrafficMappingInfo_Item_iPHeaderInformation),
        ('bHInfo', _IPtolayer2TrafficMappingInfo_Item_bHInfo),
        ('iE-Extensions', _IPtolayer2TrafficMappingInfo_Item_iE_Extensions),
        ])
    IPtolayer2TrafficMappingInfo_Item._ext = []
    
    #-----< IPtolayer2TrafficMappingInfo-ItemExtIEs >-----#
    IPtolayer2TrafficMappingInfo_ItemExtIEs = CLASS(name='IPtolayer2TrafficMappingInfo-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    IPtolayer2TrafficMappingInfo_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< L139Info >-----#
    L139Info = SEQ(name='L139Info', mode=MODE_TYPE)
    _L139Info_prachSCS = ENUM(name='prachSCS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _L139Info_prachSCS._cont = ASN1Dict([('scs15', 0), ('scs30', 1), ('scs60', 2), ('scs120', 3), ('scs480', 4), ('scs960', 5)])
    _L139Info_prachSCS._ext = ['scs480', 'scs960']
    _L139Info_rootSequenceIndex = INT(name='rootSequenceIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _L139Info_rootSequenceIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=137)], ev=None, er=[])
    _L139Info_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __L139Info_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___L139Info_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____L139Info_iE_Extension__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____L139Info_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___L139Info_iE_Extension__item__id._const_tab = ____L139Info_iE_Extension__item__id_tab
    ___L139Info_iE_Extension__item__id._const_tab_at = None
    ___L139Info_iE_Extension__item__id._const_tab_id = 'id'
    ___L139Info_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____L139Info_iE_Extension__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____L139Info_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___L139Info_iE_Extension__item__criticality._const_tab = ____L139Info_iE_Extension__item__criticality_tab
    ___L139Info_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___L139Info_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___L139Info_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____L139Info_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____L139Info_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___L139Info_iE_Extension__item__extensionValue._const_tab = ____L139Info_iE_Extension__item__extensionValue_tab
    ___L139Info_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___L139Info_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __L139Info_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___L139Info_iE_Extension__item__id),
        ('criticality', ___L139Info_iE_Extension__item__criticality),
        ('extensionValue', ___L139Info_iE_Extension__item__extensionValue),
        ])
    __L139Info_iE_Extension__item_._ext = None
    _L139Info_iE_Extension._cont = __L139Info_iE_Extension__item_
    _L139Info_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    L139Info._cont = ASN1Dict([
        ('prachSCS', _L139Info_prachSCS),
        ('rootSequenceIndex', _L139Info_rootSequenceIndex),
        ('iE-Extension', _L139Info_iE_Extension),
        ])
    L139Info._ext = []
    
    #-----< L139Info-ExtIEs >-----#
    L139Info_ExtIEs = CLASS(name='L139Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    L139Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< L839Info >-----#
    L839Info = SEQ(name='L839Info', mode=MODE_TYPE)
    _L839Info_rootSequenceIndex = INT(name='rootSequenceIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _L839Info_rootSequenceIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=837)], ev=None, er=[])
    _L839Info_restrictedSetConfig = ENUM(name='restrictedSetConfig', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _L839Info_restrictedSetConfig._cont = ASN1Dict([('unrestrictedSet', 0), ('restrictedSetTypeA', 1), ('restrictedSetTypeB', 2)])
    _L839Info_restrictedSetConfig._ext = []
    _L839Info_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __L839Info_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___L839Info_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____L839Info_iE_Extension__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____L839Info_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___L839Info_iE_Extension__item__id._const_tab = ____L839Info_iE_Extension__item__id_tab
    ___L839Info_iE_Extension__item__id._const_tab_at = None
    ___L839Info_iE_Extension__item__id._const_tab_id = 'id'
    ___L839Info_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____L839Info_iE_Extension__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____L839Info_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___L839Info_iE_Extension__item__criticality._const_tab = ____L839Info_iE_Extension__item__criticality_tab
    ___L839Info_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___L839Info_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___L839Info_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____L839Info_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____L839Info_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___L839Info_iE_Extension__item__extensionValue._const_tab = ____L839Info_iE_Extension__item__extensionValue_tab
    ___L839Info_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___L839Info_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __L839Info_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___L839Info_iE_Extension__item__id),
        ('criticality', ___L839Info_iE_Extension__item__criticality),
        ('extensionValue', ___L839Info_iE_Extension__item__extensionValue),
        ])
    __L839Info_iE_Extension__item_._ext = None
    _L839Info_iE_Extension._cont = __L839Info_iE_Extension__item_
    _L839Info_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    L839Info._cont = ASN1Dict([
        ('rootSequenceIndex', _L839Info_rootSequenceIndex),
        ('restrictedSetConfig', _L839Info_restrictedSetConfig),
        ('iE-Extension', _L839Info_iE_Extension),
        ])
    L839Info._ext = []
    
    #-----< L839Info-ExtIEs >-----#
    L839Info_ExtIEs = CLASS(name='L839Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    L839Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< L571Info >-----#
    L571Info = SEQ(name='L571Info', mode=MODE_TYPE)
    _L571Info_prachSCSForL571 = ENUM(name='prachSCSForL571', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _L571Info_prachSCSForL571._cont = ASN1Dict([('scs30', 0), ('scs120', 1), ('scs480', 2)])
    _L571Info_prachSCSForL571._ext = ['scs480']
    _L571Info_rootSequenceIndex = INT(name='rootSequenceIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _L571Info_rootSequenceIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=569)], ev=None, er=[])
    _L571Info_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __L571Info_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___L571Info_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____L571Info_iE_Extension__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____L571Info_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___L571Info_iE_Extension__item__id._const_tab = ____L571Info_iE_Extension__item__id_tab
    ___L571Info_iE_Extension__item__id._const_tab_at = None
    ___L571Info_iE_Extension__item__id._const_tab_id = 'id'
    ___L571Info_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____L571Info_iE_Extension__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____L571Info_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___L571Info_iE_Extension__item__criticality._const_tab = ____L571Info_iE_Extension__item__criticality_tab
    ___L571Info_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___L571Info_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___L571Info_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____L571Info_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____L571Info_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___L571Info_iE_Extension__item__extensionValue._const_tab = ____L571Info_iE_Extension__item__extensionValue_tab
    ___L571Info_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___L571Info_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __L571Info_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___L571Info_iE_Extension__item__id),
        ('criticality', ___L571Info_iE_Extension__item__criticality),
        ('extensionValue', ___L571Info_iE_Extension__item__extensionValue),
        ])
    __L571Info_iE_Extension__item_._ext = None
    _L571Info_iE_Extension._cont = __L571Info_iE_Extension__item_
    _L571Info_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    L571Info._cont = ASN1Dict([
        ('prachSCSForL571', _L571Info_prachSCSForL571),
        ('rootSequenceIndex', _L571Info_rootSequenceIndex),
        ('iE-Extension', _L571Info_iE_Extension),
        ])
    L571Info._ext = []
    
    #-----< L571Info-ExtIEs >-----#
    L571Info_ExtIEs = CLASS(name='L571Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    L571Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< L1151Info >-----#
    L1151Info = SEQ(name='L1151Info', mode=MODE_TYPE)
    _L1151Info_prachSCSForL1151 = ENUM(name='prachSCSForL1151', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _L1151Info_prachSCSForL1151._cont = ASN1Dict([('scs15', 0), ('scs120', 1)])
    _L1151Info_prachSCSForL1151._ext = []
    _L1151Info_rootSequenceIndex = INT(name='rootSequenceIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _L1151Info_rootSequenceIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1149)], ev=None, er=[])
    _L1151Info_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __L1151Info_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___L1151Info_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____L1151Info_iE_Extension__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____L1151Info_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___L1151Info_iE_Extension__item__id._const_tab = ____L1151Info_iE_Extension__item__id_tab
    ___L1151Info_iE_Extension__item__id._const_tab_at = None
    ___L1151Info_iE_Extension__item__id._const_tab_id = 'id'
    ___L1151Info_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____L1151Info_iE_Extension__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____L1151Info_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___L1151Info_iE_Extension__item__criticality._const_tab = ____L1151Info_iE_Extension__item__criticality_tab
    ___L1151Info_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___L1151Info_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___L1151Info_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____L1151Info_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____L1151Info_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___L1151Info_iE_Extension__item__extensionValue._const_tab = ____L1151Info_iE_Extension__item__extensionValue_tab
    ___L1151Info_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___L1151Info_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __L1151Info_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___L1151Info_iE_Extension__item__id),
        ('criticality', ___L1151Info_iE_Extension__item__criticality),
        ('extensionValue', ___L1151Info_iE_Extension__item__extensionValue),
        ])
    __L1151Info_iE_Extension__item_._ext = None
    _L1151Info_iE_Extension._cont = __L1151Info_iE_Extension__item_
    _L1151Info_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    L1151Info._cont = ASN1Dict([
        ('prachSCSForL1151', _L1151Info_prachSCSForL1151),
        ('rootSequenceIndex', _L1151Info_rootSequenceIndex),
        ('iE-Extension', _L1151Info_iE_Extension),
        ])
    L1151Info._ext = []
    
    #-----< L1151Info-ExtIEs >-----#
    L1151Info_ExtIEs = CLASS(name='L1151Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    L1151Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LastUsedCellIndication >-----#
    LastUsedCellIndication = ENUM(name='LastUsedCellIndication', mode=MODE_TYPE)
    LastUsedCellIndication._cont = ASN1Dict([('true', 0)])
    LastUsedCellIndication._ext = []
    
    #-----< LCID >-----#
    LCID = INT(name='LCID', mode=MODE_TYPE)
    LCID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    
    #-----< LCS-to-GCS-Translation >-----#
    LCS_to_GCS_Translation = SEQ(name='LCS-to-GCS-Translation', mode=MODE_TYPE)
    _LCS_to_GCS_Translation_alpha = INT(name='alpha', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCS_to_GCS_Translation_alpha._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    _LCS_to_GCS_Translation_beta = INT(name='beta', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCS_to_GCS_Translation_beta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    _LCS_to_GCS_Translation_gamma = INT(name='gamma', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCS_to_GCS_Translation_gamma._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    _LCS_to_GCS_Translation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LCS_to_GCS_Translation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___LCS_to_GCS_Translation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____LCS_to_GCS_Translation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LCS_to_GCS_Translation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCS_to_GCS_Translation_iE_Extensions__item__id._const_tab = ____LCS_to_GCS_Translation_iE_Extensions__item__id_tab
    ___LCS_to_GCS_Translation_iE_Extensions__item__id._const_tab_at = None
    ___LCS_to_GCS_Translation_iE_Extensions__item__id._const_tab_id = 'id'
    ___LCS_to_GCS_Translation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LCS_to_GCS_Translation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LCS_to_GCS_Translation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCS_to_GCS_Translation_iE_Extensions__item__criticality._const_tab = ____LCS_to_GCS_Translation_iE_Extensions__item__criticality_tab
    ___LCS_to_GCS_Translation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LCS_to_GCS_Translation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LCS_to_GCS_Translation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LCS_to_GCS_Translation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LCS_to_GCS_Translation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCS_to_GCS_Translation_iE_Extensions__item__extensionValue._const_tab = ____LCS_to_GCS_Translation_iE_Extensions__item__extensionValue_tab
    ___LCS_to_GCS_Translation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LCS_to_GCS_Translation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LCS_to_GCS_Translation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LCS_to_GCS_Translation_iE_Extensions__item__id),
        ('criticality', ___LCS_to_GCS_Translation_iE_Extensions__item__criticality),
        ('extensionValue', ___LCS_to_GCS_Translation_iE_Extensions__item__extensionValue),
        ])
    __LCS_to_GCS_Translation_iE_Extensions__item_._ext = None
    _LCS_to_GCS_Translation_iE_Extensions._cont = __LCS_to_GCS_Translation_iE_Extensions__item_
    _LCS_to_GCS_Translation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LCS_to_GCS_Translation._cont = ASN1Dict([
        ('alpha', _LCS_to_GCS_Translation_alpha),
        ('beta', _LCS_to_GCS_Translation_beta),
        ('gamma', _LCS_to_GCS_Translation_gamma),
        ('iE-Extensions', _LCS_to_GCS_Translation_iE_Extensions),
        ])
    LCS_to_GCS_Translation._ext = []
    
    #-----< LCS-to-GCS-Translation-ExtIEs >-----#
    LCS_to_GCS_Translation_ExtIEs = CLASS(name='LCS-to-GCS-Translation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    LCS_to_GCS_Translation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LCStoGCSTranslationList >-----#
    LCStoGCSTranslationList = SEQ_OF(name='LCStoGCSTranslationList', mode=MODE_TYPE)
    _LCStoGCSTranslationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LCStoGCSTranslation')))
    LCStoGCSTranslationList._cont = _LCStoGCSTranslationList__item_
    LCStoGCSTranslationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< LCStoGCSTranslation >-----#
    LCStoGCSTranslation = SEQ(name='LCStoGCSTranslation', mode=MODE_TYPE)
    _LCStoGCSTranslation_alpha = INT(name='alpha', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCStoGCSTranslation_alpha._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _LCStoGCSTranslation_alpha_fine = INT(name='alpha-fine', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCStoGCSTranslation_alpha_fine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _LCStoGCSTranslation_beta = INT(name='beta', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCStoGCSTranslation_beta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _LCStoGCSTranslation_beta_fine = INT(name='beta-fine', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCStoGCSTranslation_beta_fine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _LCStoGCSTranslation_gamma = INT(name='gamma', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCStoGCSTranslation_gamma._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _LCStoGCSTranslation_gamma_fine = INT(name='gamma-fine', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCStoGCSTranslation_gamma_fine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _LCStoGCSTranslation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LCStoGCSTranslation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___LCStoGCSTranslation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____LCStoGCSTranslation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LCStoGCSTranslation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCStoGCSTranslation_iE_Extensions__item__id._const_tab = ____LCStoGCSTranslation_iE_Extensions__item__id_tab
    ___LCStoGCSTranslation_iE_Extensions__item__id._const_tab_at = None
    ___LCStoGCSTranslation_iE_Extensions__item__id._const_tab_id = 'id'
    ___LCStoGCSTranslation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LCStoGCSTranslation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LCStoGCSTranslation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCStoGCSTranslation_iE_Extensions__item__criticality._const_tab = ____LCStoGCSTranslation_iE_Extensions__item__criticality_tab
    ___LCStoGCSTranslation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LCStoGCSTranslation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LCStoGCSTranslation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LCStoGCSTranslation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LCStoGCSTranslation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCStoGCSTranslation_iE_Extensions__item__extensionValue._const_tab = ____LCStoGCSTranslation_iE_Extensions__item__extensionValue_tab
    ___LCStoGCSTranslation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LCStoGCSTranslation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LCStoGCSTranslation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LCStoGCSTranslation_iE_Extensions__item__id),
        ('criticality', ___LCStoGCSTranslation_iE_Extensions__item__criticality),
        ('extensionValue', ___LCStoGCSTranslation_iE_Extensions__item__extensionValue),
        ])
    __LCStoGCSTranslation_iE_Extensions__item_._ext = None
    _LCStoGCSTranslation_iE_Extensions._cont = __LCStoGCSTranslation_iE_Extensions__item_
    _LCStoGCSTranslation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LCStoGCSTranslation._cont = ASN1Dict([
        ('alpha', _LCStoGCSTranslation_alpha),
        ('alpha-fine', _LCStoGCSTranslation_alpha_fine),
        ('beta', _LCStoGCSTranslation_beta),
        ('beta-fine', _LCStoGCSTranslation_beta_fine),
        ('gamma', _LCStoGCSTranslation_gamma),
        ('gamma-fine', _LCStoGCSTranslation_gamma_fine),
        ('iE-Extensions', _LCStoGCSTranslation_iE_Extensions),
        ])
    LCStoGCSTranslation._ext = None
    
    #-----< LCStoGCSTranslation-ExtIEs >-----#
    LCStoGCSTranslation_ExtIEs = CLASS(name='LCStoGCSTranslation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    LCStoGCSTranslation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LMF-MeasurementID >-----#
    LMF_MeasurementID = INT(name='LMF-MeasurementID', mode=MODE_TYPE)
    LMF_MeasurementID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=[], er=[])
    
    #-----< LMF-UE-MeasurementID >-----#
    LMF_UE_MeasurementID = INT(name='LMF-UE-MeasurementID', mode=MODE_TYPE)
    LMF_UE_MeasurementID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=[], er=[])
    
    #-----< LocationDependentMBSF1UInformation >-----#
    LocationDependentMBSF1UInformation = SEQ_OF(name='LocationDependentMBSF1UInformation', mode=MODE_TYPE)
    _LocationDependentMBSF1UInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LocationDependentMBSF1UInformation-Item')))
    LocationDependentMBSF1UInformation._cont = _LocationDependentMBSF1UInformation__item_
    LocationDependentMBSF1UInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< LocationDependentMBSF1UInformation-Item >-----#
    LocationDependentMBSF1UInformation_Item = SEQ(name='LocationDependentMBSF1UInformation-Item', mode=MODE_TYPE)
    _LocationDependentMBSF1UInformation_Item_mbsAreaSession_ID = INT(name='mbsAreaSession-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MBS-Area-Session-ID')))
    _LocationDependentMBSF1UInformation_Item_mbs_f1u_info_at_CU = CHOICE(name='mbs-f1u-info-at-CU', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UPTransportLayerInformation')))
    _LocationDependentMBSF1UInformation_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationDependentMBSF1UInformation_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___LocationDependentMBSF1UInformation_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____LocationDependentMBSF1UInformation_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LocationDependentMBSF1UInformation_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationDependentMBSF1UInformation_Item_iE_Extensions__item__id._const_tab = ____LocationDependentMBSF1UInformation_Item_iE_Extensions__item__id_tab
    ___LocationDependentMBSF1UInformation_Item_iE_Extensions__item__id._const_tab_at = None
    ___LocationDependentMBSF1UInformation_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___LocationDependentMBSF1UInformation_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LocationDependentMBSF1UInformation_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LocationDependentMBSF1UInformation_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationDependentMBSF1UInformation_Item_iE_Extensions__item__criticality._const_tab = ____LocationDependentMBSF1UInformation_Item_iE_Extensions__item__criticality_tab
    ___LocationDependentMBSF1UInformation_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LocationDependentMBSF1UInformation_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LocationDependentMBSF1UInformation_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LocationDependentMBSF1UInformation_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LocationDependentMBSF1UInformation_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationDependentMBSF1UInformation_Item_iE_Extensions__item__extensionValue._const_tab = ____LocationDependentMBSF1UInformation_Item_iE_Extensions__item__extensionValue_tab
    ___LocationDependentMBSF1UInformation_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LocationDependentMBSF1UInformation_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LocationDependentMBSF1UInformation_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LocationDependentMBSF1UInformation_Item_iE_Extensions__item__id),
        ('criticality', ___LocationDependentMBSF1UInformation_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___LocationDependentMBSF1UInformation_Item_iE_Extensions__item__extensionValue),
        ])
    __LocationDependentMBSF1UInformation_Item_iE_Extensions__item_._ext = None
    _LocationDependentMBSF1UInformation_Item_iE_Extensions._cont = __LocationDependentMBSF1UInformation_Item_iE_Extensions__item_
    _LocationDependentMBSF1UInformation_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationDependentMBSF1UInformation_Item._cont = ASN1Dict([
        ('mbsAreaSession-ID', _LocationDependentMBSF1UInformation_Item_mbsAreaSession_ID),
        ('mbs-f1u-info-at-CU', _LocationDependentMBSF1UInformation_Item_mbs_f1u_info_at_CU),
        ('iE-Extensions', _LocationDependentMBSF1UInformation_Item_iE_Extensions),
        ])
    LocationDependentMBSF1UInformation_Item._ext = []
    
    #-----< LocationDependentMBSF1UInformation-Item-ExtIEs >-----#
    LocationDependentMBSF1UInformation_Item_ExtIEs = CLASS(name='LocationDependentMBSF1UInformation-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    LocationDependentMBSF1UInformation_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LocationMeasurementInformation >-----#
    LocationMeasurementInformation = OCT_STR(name='LocationMeasurementInformation', mode=MODE_TYPE)
    
    #-----< LocationUncertainty >-----#
    LocationUncertainty = SEQ(name='LocationUncertainty', mode=MODE_TYPE)
    _LocationUncertainty_horizontalUncertainty = INT(name='horizontalUncertainty', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationUncertainty_horizontalUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _LocationUncertainty_horizontalConfidence = INT(name='horizontalConfidence', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationUncertainty_horizontalConfidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _LocationUncertainty_verticalUncertainty = INT(name='verticalUncertainty', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationUncertainty_verticalUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _LocationUncertainty_verticalConfidence = INT(name='verticalConfidence', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationUncertainty_verticalConfidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _LocationUncertainty_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationUncertainty_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___LocationUncertainty_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____LocationUncertainty_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LocationUncertainty_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationUncertainty_iE_Extensions__item__id._const_tab = ____LocationUncertainty_iE_Extensions__item__id_tab
    ___LocationUncertainty_iE_Extensions__item__id._const_tab_at = None
    ___LocationUncertainty_iE_Extensions__item__id._const_tab_id = 'id'
    ___LocationUncertainty_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LocationUncertainty_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LocationUncertainty_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationUncertainty_iE_Extensions__item__criticality._const_tab = ____LocationUncertainty_iE_Extensions__item__criticality_tab
    ___LocationUncertainty_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LocationUncertainty_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LocationUncertainty_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LocationUncertainty_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LocationUncertainty_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationUncertainty_iE_Extensions__item__extensionValue._const_tab = ____LocationUncertainty_iE_Extensions__item__extensionValue_tab
    ___LocationUncertainty_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LocationUncertainty_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LocationUncertainty_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LocationUncertainty_iE_Extensions__item__id),
        ('criticality', ___LocationUncertainty_iE_Extensions__item__criticality),
        ('extensionValue', ___LocationUncertainty_iE_Extensions__item__extensionValue),
        ])
    __LocationUncertainty_iE_Extensions__item_._ext = None
    _LocationUncertainty_iE_Extensions._cont = __LocationUncertainty_iE_Extensions__item_
    _LocationUncertainty_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationUncertainty._cont = ASN1Dict([
        ('horizontalUncertainty', _LocationUncertainty_horizontalUncertainty),
        ('horizontalConfidence', _LocationUncertainty_horizontalConfidence),
        ('verticalUncertainty', _LocationUncertainty_verticalUncertainty),
        ('verticalConfidence', _LocationUncertainty_verticalConfidence),
        ('iE-Extensions', _LocationUncertainty_iE_Extensions),
        ])
    LocationUncertainty._ext = None
    
    #-----< LocationUncertainty-ExtIEs >-----#
    LocationUncertainty_ExtIEs = CLASS(name='LocationUncertainty-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    LocationUncertainty_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LongDRXCycleLength >-----#
    LongDRXCycleLength = ENUM(name='LongDRXCycleLength', mode=MODE_TYPE)
    LongDRXCycleLength._cont = ASN1Dict([('ms10', 0), ('ms20', 1), ('ms32', 2), ('ms40', 3), ('ms60', 4), ('ms64', 5), ('ms70', 6), ('ms80', 7), ('ms128', 8), ('ms160', 9), ('ms256', 10), ('ms320', 11), ('ms512', 12), ('ms640', 13), ('ms1024', 14), ('ms1280', 15), ('ms2048', 16), ('ms2560', 17), ('ms5120', 18), ('ms10240', 19)])
    LongDRXCycleLength._ext = []
    
    #-----< LowerLayerPresenceStatusChange >-----#
    LowerLayerPresenceStatusChange = ENUM(name='LowerLayerPresenceStatusChange', mode=MODE_TYPE)
    LowerLayerPresenceStatusChange._cont = ASN1Dict([('suspend-lower-layers', 0), ('resume-lower-layers', 1)])
    LowerLayerPresenceStatusChange._ext = []
    
    #-----< LoS-NLoSIndicatorHard >-----#
    LoS_NLoSIndicatorHard = ENUM(name='LoS-NLoSIndicatorHard', mode=MODE_TYPE)
    LoS_NLoSIndicatorHard._cont = ASN1Dict([('nLoS', 0), ('loS', 1)])
    LoS_NLoSIndicatorHard._ext = None
    
    #-----< LoS-NLoSIndicatorSoft >-----#
    LoS_NLoSIndicatorSoft = INT(name='LoS-NLoSIndicatorSoft', mode=MODE_TYPE)
    LoS_NLoSIndicatorSoft._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< LoS-NLoSInformation >-----#
    LoS_NLoSInformation = CHOICE(name='LoS-NLoSInformation', mode=MODE_TYPE)
    _LoS_NLoSInformation_loS_NLoSIndicatorSoft = INT(name='loS-NLoSIndicatorSoft', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LoS-NLoSIndicatorSoft')))
    _LoS_NLoSInformation_loS_NLoSIndicatorHard = ENUM(name='loS-NLoSIndicatorHard', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LoS-NLoSIndicatorHard')))
    _LoS_NLoSInformation_choice_Extension = SEQ(name='choice-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __LoS_NLoSInformation_choice_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___LoS_NLoSInformation_choice_Extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___LoS_NLoSInformation_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __LoS_NLoSInformation_choice_Extension_id._const_tab = ___LoS_NLoSInformation_choice_Extension_id_tab
    __LoS_NLoSInformation_choice_Extension_id._const_tab_at = None
    __LoS_NLoSInformation_choice_Extension_id._const_tab_id = 'id'
    __LoS_NLoSInformation_choice_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___LoS_NLoSInformation_choice_Extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___LoS_NLoSInformation_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __LoS_NLoSInformation_choice_Extension_criticality._const_tab = ___LoS_NLoSInformation_choice_Extension_criticality_tab
    __LoS_NLoSInformation_choice_Extension_criticality._const_tab_at = ('..', 'id')
    __LoS_NLoSInformation_choice_Extension_criticality._const_tab_id = 'criticality'
    __LoS_NLoSInformation_choice_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___LoS_NLoSInformation_choice_Extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___LoS_NLoSInformation_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __LoS_NLoSInformation_choice_Extension_value._const_tab = ___LoS_NLoSInformation_choice_Extension_value_tab
    __LoS_NLoSInformation_choice_Extension_value._const_tab_at = ('..', 'id')
    __LoS_NLoSInformation_choice_Extension_value._const_tab_id = 'Value'
    _LoS_NLoSInformation_choice_Extension._cont = ASN1Dict([
        ('id', __LoS_NLoSInformation_choice_Extension_id),
        ('criticality', __LoS_NLoSInformation_choice_Extension_criticality),
        ('value', __LoS_NLoSInformation_choice_Extension_value),
        ])
    _LoS_NLoSInformation_choice_Extension._ext = None
    LoS_NLoSInformation._cont = ASN1Dict([
        ('loS-NLoSIndicatorSoft', _LoS_NLoSInformation_loS_NLoSIndicatorSoft),
        ('loS-NLoSIndicatorHard', _LoS_NLoSInformation_loS_NLoSIndicatorHard),
        ('choice-Extension', _LoS_NLoSInformation_choice_Extension),
        ])
    LoS_NLoSInformation._ext = None
    
    #-----< LoS-NLoSInformation-ExtIEs >-----#
    LoS_NLoSInformation_ExtIEs = CLASS(name='LoS-NLoSInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    LoS_NLoSInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LTEUESidelinkAggregateMaximumBitrate >-----#
    LTEUESidelinkAggregateMaximumBitrate = SEQ(name='LTEUESidelinkAggregateMaximumBitrate', mode=MODE_TYPE)
    _LTEUESidelinkAggregateMaximumBitrate_uELTESidelinkAggregateMaximumBitrate = INT(name='uELTESidelinkAggregateMaximumBitrate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _LTEUESidelinkAggregateMaximumBitrate_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab = ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_at = None
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_id = 'id'
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab = ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab = ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id),
        ('criticality', ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality),
        ('extensionValue', ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue),
        ])
    __LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item_._ext = None
    _LTEUESidelinkAggregateMaximumBitrate_iE_Extensions._cont = __LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item_
    _LTEUESidelinkAggregateMaximumBitrate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LTEUESidelinkAggregateMaximumBitrate._cont = ASN1Dict([
        ('uELTESidelinkAggregateMaximumBitrate', _LTEUESidelinkAggregateMaximumBitrate_uELTESidelinkAggregateMaximumBitrate),
        ('iE-Extensions', _LTEUESidelinkAggregateMaximumBitrate_iE_Extensions),
        ])
    LTEUESidelinkAggregateMaximumBitrate._ext = None
    
    #-----< LTEUESidelinkAggregateMaximumBitrate-ExtIEs >-----#
    LTEUESidelinkAggregateMaximumBitrate_ExtIEs = CLASS(name='LTEUESidelinkAggregateMaximumBitrate-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    LTEUESidelinkAggregateMaximumBitrate_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LTEV2XServicesAuthorized >-----#
    LTEV2XServicesAuthorized = SEQ(name='LTEV2XServicesAuthorized', mode=MODE_TYPE)
    _LTEV2XServicesAuthorized_vehicleUE = ENUM(name='vehicleUE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'VehicleUE')), opt=True)
    _LTEV2XServicesAuthorized_pedestrianUE = ENUM(name='pedestrianUE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PedestrianUE')), opt=True)
    _LTEV2XServicesAuthorized_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LTEV2XServicesAuthorized_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___LTEV2XServicesAuthorized_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____LTEV2XServicesAuthorized_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LTEV2XServicesAuthorized_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTEV2XServicesAuthorized_iE_Extensions__item__id._const_tab = ____LTEV2XServicesAuthorized_iE_Extensions__item__id_tab
    ___LTEV2XServicesAuthorized_iE_Extensions__item__id._const_tab_at = None
    ___LTEV2XServicesAuthorized_iE_Extensions__item__id._const_tab_id = 'id'
    ___LTEV2XServicesAuthorized_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LTEV2XServicesAuthorized_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LTEV2XServicesAuthorized_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTEV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab = ____LTEV2XServicesAuthorized_iE_Extensions__item__criticality_tab
    ___LTEV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LTEV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab = ____LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab
    ___LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LTEV2XServicesAuthorized_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LTEV2XServicesAuthorized_iE_Extensions__item__id),
        ('criticality', ___LTEV2XServicesAuthorized_iE_Extensions__item__criticality),
        ('extensionValue', ___LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue),
        ])
    __LTEV2XServicesAuthorized_iE_Extensions__item_._ext = None
    _LTEV2XServicesAuthorized_iE_Extensions._cont = __LTEV2XServicesAuthorized_iE_Extensions__item_
    _LTEV2XServicesAuthorized_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LTEV2XServicesAuthorized._cont = ASN1Dict([
        ('vehicleUE', _LTEV2XServicesAuthorized_vehicleUE),
        ('pedestrianUE', _LTEV2XServicesAuthorized_pedestrianUE),
        ('iE-Extensions', _LTEV2XServicesAuthorized_iE_Extensions),
        ])
    LTEV2XServicesAuthorized._ext = None
    
    #-----< LTEV2XServicesAuthorized-ExtIEs >-----#
    LTEV2XServicesAuthorized_ExtIEs = CLASS(name='LTEV2XServicesAuthorized-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    LTEV2XServicesAuthorized_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MappingInformationIndex >-----#
    MappingInformationIndex = BIT_STR(name='MappingInformationIndex', mode=MODE_TYPE)
    MappingInformationIndex._const_sz = ASN1Set(rv=[26], rr=[], ev=None, er=[])
    
    #-----< MappingInformationtoRemove >-----#
    MappingInformationtoRemove = SEQ_OF(name='MappingInformationtoRemove', mode=MODE_TYPE)
    _MappingInformationtoRemove__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MappingInformationIndex')))
    MappingInformationtoRemove._cont = _MappingInformationtoRemove__item_
    MappingInformationtoRemove._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=67108864)], ev=None, er=[])
    
    #-----< MaskedIMEISV >-----#
    MaskedIMEISV = BIT_STR(name='MaskedIMEISV', mode=MODE_TYPE)
    MaskedIMEISV._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    
    #-----< MaxDataBurstVolume >-----#
    MaxDataBurstVolume = INT(name='MaxDataBurstVolume', mode=MODE_TYPE)
    MaxDataBurstVolume._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[ASN1RangeInt(lb=4096, ub=2000000)])
    
    #-----< MaxPacketLossRate >-----#
    MaxPacketLossRate = INT(name='MaxPacketLossRate', mode=MODE_TYPE)
    MaxPacketLossRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1000)], ev=None, er=[])
    
    #-----< MBS-Broadcast-NeighbourCellList >-----#
    MBS_Broadcast_NeighbourCellList = OCT_STR(name='MBS-Broadcast-NeighbourCellList', mode=MODE_TYPE)
    
    #-----< MBS-Flows-Mapped-To-MRB-List >-----#
    MBS_Flows_Mapped_To_MRB_List = SEQ_OF(name='MBS-Flows-Mapped-To-MRB-List', mode=MODE_TYPE)
    _MBS_Flows_Mapped_To_MRB_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-Flows-Mapped-To-MRB-Item')))
    MBS_Flows_Mapped_To_MRB_List._cont = _MBS_Flows_Mapped_To_MRB_List__item_
    MBS_Flows_Mapped_To_MRB_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< MBS-Flows-Mapped-To-MRB-Item >-----#
    MBS_Flows_Mapped_To_MRB_Item = SEQ(name='MBS-Flows-Mapped-To-MRB-Item', mode=MODE_TYPE)
    _MBS_Flows_Mapped_To_MRB_Item_mBS_QoSFlowIdentifier = INT(name='mBS-QoSFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSFlowIdentifier')))
    _MBS_Flows_Mapped_To_MRB_Item_mbs_QoSFlowLevelQoSParameters = SEQ(name='mbs-QoSFlowLevelQoSParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSFlowLevelQoSParameters')))
    _MBS_Flows_Mapped_To_MRB_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__id._const_tab = ____MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__id_tab
    ___MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__id._const_tab_at = None
    ___MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__criticality._const_tab = ____MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__criticality_tab
    ___MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__extensionValue._const_tab = ____MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__extensionValue_tab
    ___MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__id),
        ('criticality', ___MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__extensionValue),
        ])
    __MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item_._ext = None
    _MBS_Flows_Mapped_To_MRB_Item_iE_Extensions._cont = __MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item_
    _MBS_Flows_Mapped_To_MRB_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBS_Flows_Mapped_To_MRB_Item._cont = ASN1Dict([
        ('mBS-QoSFlowIdentifier', _MBS_Flows_Mapped_To_MRB_Item_mBS_QoSFlowIdentifier),
        ('mbs-QoSFlowLevelQoSParameters', _MBS_Flows_Mapped_To_MRB_Item_mbs_QoSFlowLevelQoSParameters),
        ('iE-Extensions', _MBS_Flows_Mapped_To_MRB_Item_iE_Extensions),
        ])
    MBS_Flows_Mapped_To_MRB_Item._ext = None
    
    #-----< MBS-Flows-Mapped-To-MRB-Item-ExtIEs >-----#
    MBS_Flows_Mapped_To_MRB_Item_ExtIEs = CLASS(name='MBS-Flows-Mapped-To-MRB-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MBS_Flows_Mapped_To_MRB_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBSF1UInformation >-----#
    MBSF1UInformation = SEQ(name='MBSF1UInformation', mode=MODE_TYPE)
    _MBSF1UInformation_mbs_f1u_info = CHOICE(name='mbs-f1u-info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UPTransportLayerInformation')))
    _MBSF1UInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBSF1UInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MBSF1UInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MBSF1UInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBSF1UInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSF1UInformation_iE_Extensions__item__id._const_tab = ____MBSF1UInformation_iE_Extensions__item__id_tab
    ___MBSF1UInformation_iE_Extensions__item__id._const_tab_at = None
    ___MBSF1UInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBSF1UInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBSF1UInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBSF1UInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSF1UInformation_iE_Extensions__item__criticality._const_tab = ____MBSF1UInformation_iE_Extensions__item__criticality_tab
    ___MBSF1UInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBSF1UInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBSF1UInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBSF1UInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBSF1UInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSF1UInformation_iE_Extensions__item__extensionValue._const_tab = ____MBSF1UInformation_iE_Extensions__item__extensionValue_tab
    ___MBSF1UInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBSF1UInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBSF1UInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBSF1UInformation_iE_Extensions__item__id),
        ('criticality', ___MBSF1UInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___MBSF1UInformation_iE_Extensions__item__extensionValue),
        ])
    __MBSF1UInformation_iE_Extensions__item_._ext = None
    _MBSF1UInformation_iE_Extensions._cont = __MBSF1UInformation_iE_Extensions__item_
    _MBSF1UInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBSF1UInformation._cont = ASN1Dict([
        ('mbs-f1u-info', _MBSF1UInformation_mbs_f1u_info),
        ('iE-Extensions', _MBSF1UInformation_iE_Extensions),
        ])
    MBSF1UInformation._ext = []
    
    #-----< MBSF1UInformation-ExtIEs >-----#
    MBSF1UInformation_ExtIEs = CLASS(name='MBSF1UInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MBSF1UInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBSInterestIndication >-----#
    MBSInterestIndication = OCT_STR(name='MBSInterestIndication', mode=MODE_TYPE)
    
    #-----< MBS-Session-ID >-----#
    MBS_Session_ID = SEQ(name='MBS-Session-ID', mode=MODE_TYPE)
    _MBS_Session_ID_tMGI = OCT_STR(name='tMGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TMGI')))
    _MBS_Session_ID_nID = BIT_STR(name='nID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NID')), opt=True)
    _MBS_Session_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBS_Session_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MBS_Session_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MBS_Session_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBS_Session_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_Session_ID_iE_Extensions__item__id._const_tab = ____MBS_Session_ID_iE_Extensions__item__id_tab
    ___MBS_Session_ID_iE_Extensions__item__id._const_tab_at = None
    ___MBS_Session_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBS_Session_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBS_Session_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBS_Session_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_Session_ID_iE_Extensions__item__criticality._const_tab = ____MBS_Session_ID_iE_Extensions__item__criticality_tab
    ___MBS_Session_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBS_Session_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBS_Session_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBS_Session_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBS_Session_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_Session_ID_iE_Extensions__item__extensionValue._const_tab = ____MBS_Session_ID_iE_Extensions__item__extensionValue_tab
    ___MBS_Session_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBS_Session_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBS_Session_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBS_Session_ID_iE_Extensions__item__id),
        ('criticality', ___MBS_Session_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___MBS_Session_ID_iE_Extensions__item__extensionValue),
        ])
    __MBS_Session_ID_iE_Extensions__item_._ext = None
    _MBS_Session_ID_iE_Extensions._cont = __MBS_Session_ID_iE_Extensions__item_
    _MBS_Session_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBS_Session_ID._cont = ASN1Dict([
        ('tMGI', _MBS_Session_ID_tMGI),
        ('nID', _MBS_Session_ID_nID),
        ('iE-Extensions', _MBS_Session_ID_iE_Extensions),
        ])
    MBS_Session_ID._ext = []
    
    #-----< MBS-Session-ID-ExtIEs >-----#
    MBS_Session_ID_ExtIEs = CLASS(name='MBS-Session-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MBS_Session_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-Area-Session-ID >-----#
    MBS_Area_Session_ID = INT(name='MBS-Area-Session-ID', mode=MODE_TYPE)
    MBS_Area_Session_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=[], er=[])
    
    #-----< MBS-CUtoDURRCInformation >-----#
    MBS_CUtoDURRCInformation = SEQ(name='MBS-CUtoDURRCInformation', mode=MODE_TYPE)
    _MBS_CUtoDURRCInformation_mBS_Broadcast_Cell_List = SEQ_OF(name='mBS-Broadcast-Cell-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MBS-Broadcast-Cell-List')))
    _MBS_CUtoDURRCInformation_mBS_Broadcast_MRB_List = SEQ_OF(name='mBS-Broadcast-MRB-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MBS-Broadcast-MRB-List')))
    _MBS_CUtoDURRCInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBS_CUtoDURRCInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MBS_CUtoDURRCInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MBS_CUtoDURRCInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBS_CUtoDURRCInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_CUtoDURRCInformation_iE_Extensions__item__id._const_tab = ____MBS_CUtoDURRCInformation_iE_Extensions__item__id_tab
    ___MBS_CUtoDURRCInformation_iE_Extensions__item__id._const_tab_at = None
    ___MBS_CUtoDURRCInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBS_CUtoDURRCInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBS_CUtoDURRCInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBS_CUtoDURRCInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_CUtoDURRCInformation_iE_Extensions__item__criticality._const_tab = ____MBS_CUtoDURRCInformation_iE_Extensions__item__criticality_tab
    ___MBS_CUtoDURRCInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBS_CUtoDURRCInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBS_CUtoDURRCInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBS_CUtoDURRCInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBS_CUtoDURRCInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_CUtoDURRCInformation_iE_Extensions__item__extensionValue._const_tab = ____MBS_CUtoDURRCInformation_iE_Extensions__item__extensionValue_tab
    ___MBS_CUtoDURRCInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBS_CUtoDURRCInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBS_CUtoDURRCInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBS_CUtoDURRCInformation_iE_Extensions__item__id),
        ('criticality', ___MBS_CUtoDURRCInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___MBS_CUtoDURRCInformation_iE_Extensions__item__extensionValue),
        ])
    __MBS_CUtoDURRCInformation_iE_Extensions__item_._ext = None
    _MBS_CUtoDURRCInformation_iE_Extensions._cont = __MBS_CUtoDURRCInformation_iE_Extensions__item_
    _MBS_CUtoDURRCInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBS_CUtoDURRCInformation._cont = ASN1Dict([
        ('mBS-Broadcast-Cell-List', _MBS_CUtoDURRCInformation_mBS_Broadcast_Cell_List),
        ('mBS-Broadcast-MRB-List', _MBS_CUtoDURRCInformation_mBS_Broadcast_MRB_List),
        ('iE-Extensions', _MBS_CUtoDURRCInformation_iE_Extensions),
        ])
    MBS_CUtoDURRCInformation._ext = []
    
    #-----< MBS-CUtoDURRCInformation-ExtIEs >-----#
    MBS_CUtoDURRCInformation_ExtIEs = CLASS(name='MBS-CUtoDURRCInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MBS_CUtoDURRCInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-Broadcast-Cell-List >-----#
    MBS_Broadcast_Cell_List = SEQ_OF(name='MBS-Broadcast-Cell-List', mode=MODE_TYPE)
    _MBS_Broadcast_Cell_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-Broadcast-Cell-Item')))
    MBS_Broadcast_Cell_List._cont = _MBS_Broadcast_Cell_List__item_
    MBS_Broadcast_Cell_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< MBS-Broadcast-Cell-Item >-----#
    MBS_Broadcast_Cell_Item = SEQ(name='MBS-Broadcast-Cell-Item', mode=MODE_TYPE)
    _MBS_Broadcast_Cell_Item_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _MBS_Broadcast_Cell_Item_mtch_neighbourCell = OCT_STR(name='mtch-neighbourCell', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MBS_Broadcast_Cell_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBS_Broadcast_Cell_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MBS_Broadcast_Cell_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MBS_Broadcast_Cell_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBS_Broadcast_Cell_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_Broadcast_Cell_Item_iE_Extensions__item__id._const_tab = ____MBS_Broadcast_Cell_Item_iE_Extensions__item__id_tab
    ___MBS_Broadcast_Cell_Item_iE_Extensions__item__id._const_tab_at = None
    ___MBS_Broadcast_Cell_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBS_Broadcast_Cell_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBS_Broadcast_Cell_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBS_Broadcast_Cell_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_Broadcast_Cell_Item_iE_Extensions__item__criticality._const_tab = ____MBS_Broadcast_Cell_Item_iE_Extensions__item__criticality_tab
    ___MBS_Broadcast_Cell_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBS_Broadcast_Cell_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBS_Broadcast_Cell_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBS_Broadcast_Cell_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBS_Broadcast_Cell_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_Broadcast_Cell_Item_iE_Extensions__item__extensionValue._const_tab = ____MBS_Broadcast_Cell_Item_iE_Extensions__item__extensionValue_tab
    ___MBS_Broadcast_Cell_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBS_Broadcast_Cell_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBS_Broadcast_Cell_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBS_Broadcast_Cell_Item_iE_Extensions__item__id),
        ('criticality', ___MBS_Broadcast_Cell_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MBS_Broadcast_Cell_Item_iE_Extensions__item__extensionValue),
        ])
    __MBS_Broadcast_Cell_Item_iE_Extensions__item_._ext = None
    _MBS_Broadcast_Cell_Item_iE_Extensions._cont = __MBS_Broadcast_Cell_Item_iE_Extensions__item_
    _MBS_Broadcast_Cell_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBS_Broadcast_Cell_Item._cont = ASN1Dict([
        ('nRCGI', _MBS_Broadcast_Cell_Item_nRCGI),
        ('mtch-neighbourCell', _MBS_Broadcast_Cell_Item_mtch_neighbourCell),
        ('iE-Extensions', _MBS_Broadcast_Cell_Item_iE_Extensions),
        ])
    MBS_Broadcast_Cell_Item._ext = []
    
    #-----< MBS-Broadcast-Cell-Item-ExtIEs >-----#
    MBS_Broadcast_Cell_Item_ExtIEs = CLASS(name='MBS-Broadcast-Cell-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MBS_Broadcast_Cell_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-Broadcast-MRB-List >-----#
    MBS_Broadcast_MRB_List = SEQ_OF(name='MBS-Broadcast-MRB-List', mode=MODE_TYPE)
    _MBS_Broadcast_MRB_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-Broadcast-MRB-Item')))
    MBS_Broadcast_MRB_List._cont = _MBS_Broadcast_MRB_List__item_
    MBS_Broadcast_MRB_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MBS-Broadcast-MRB-Item >-----#
    MBS_Broadcast_MRB_Item = SEQ(name='MBS-Broadcast-MRB-Item', mode=MODE_TYPE)
    _MBS_Broadcast_MRB_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _MBS_Broadcast_MRB_Item_mRB_PDCP_Config_Broadcast = OCT_STR(name='mRB-PDCP-Config-Broadcast', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MBS_Broadcast_MRB_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBS_Broadcast_MRB_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MBS_Broadcast_MRB_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MBS_Broadcast_MRB_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBS_Broadcast_MRB_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_Broadcast_MRB_Item_iE_Extensions__item__id._const_tab = ____MBS_Broadcast_MRB_Item_iE_Extensions__item__id_tab
    ___MBS_Broadcast_MRB_Item_iE_Extensions__item__id._const_tab_at = None
    ___MBS_Broadcast_MRB_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBS_Broadcast_MRB_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBS_Broadcast_MRB_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBS_Broadcast_MRB_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_Broadcast_MRB_Item_iE_Extensions__item__criticality._const_tab = ____MBS_Broadcast_MRB_Item_iE_Extensions__item__criticality_tab
    ___MBS_Broadcast_MRB_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBS_Broadcast_MRB_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBS_Broadcast_MRB_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBS_Broadcast_MRB_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBS_Broadcast_MRB_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_Broadcast_MRB_Item_iE_Extensions__item__extensionValue._const_tab = ____MBS_Broadcast_MRB_Item_iE_Extensions__item__extensionValue_tab
    ___MBS_Broadcast_MRB_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBS_Broadcast_MRB_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBS_Broadcast_MRB_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBS_Broadcast_MRB_Item_iE_Extensions__item__id),
        ('criticality', ___MBS_Broadcast_MRB_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MBS_Broadcast_MRB_Item_iE_Extensions__item__extensionValue),
        ])
    __MBS_Broadcast_MRB_Item_iE_Extensions__item_._ext = None
    _MBS_Broadcast_MRB_Item_iE_Extensions._cont = __MBS_Broadcast_MRB_Item_iE_Extensions__item_
    _MBS_Broadcast_MRB_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBS_Broadcast_MRB_Item._cont = ASN1Dict([
        ('mRB-ID', _MBS_Broadcast_MRB_Item_mRB_ID),
        ('mRB-PDCP-Config-Broadcast', _MBS_Broadcast_MRB_Item_mRB_PDCP_Config_Broadcast),
        ('iE-Extensions', _MBS_Broadcast_MRB_Item_iE_Extensions),
        ])
    MBS_Broadcast_MRB_Item._ext = []
    
    #-----< MBS-Broadcast-MRB-Item-ExtIEs >-----#
    MBS_Broadcast_MRB_Item_ExtIEs = CLASS(name='MBS-Broadcast-MRB-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MBS_Broadcast_MRB_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBSMulticastF1UContextDescriptor >-----#
    MBSMulticastF1UContextDescriptor = SEQ(name='MBSMulticastF1UContextDescriptor', mode=MODE_TYPE)
    _MBSMulticastF1UContextDescriptor_multicastF1UContextReferenceF1 = OCT_STR(name='multicastF1UContextReferenceF1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MulticastF1UContextReferenceF1')))
    _MBSMulticastF1UContextDescriptor_mc_F1UCtxtusage = ENUM(name='mc-F1UCtxtusage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MBSMulticastF1UContextDescriptor_mc_F1UCtxtusage._cont = ASN1Dict([('ptm', 0), ('ptp', 1), ('ptp-retransmission', 2), ('ptp-forwarding', 3)])
    _MBSMulticastF1UContextDescriptor_mc_F1UCtxtusage._ext = []
    _MBSMulticastF1UContextDescriptor_mbsAreaSession = INT(name='mbsAreaSession', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MBS-Area-Session-ID')), opt=True)
    _MBSMulticastF1UContextDescriptor_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBSMulticastF1UContextDescriptor_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MBSMulticastF1UContextDescriptor_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBSMulticastF1UContextDescriptor_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__id._const_tab = ____MBSMulticastF1UContextDescriptor_iE_Extensions__item__id_tab
    ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__id._const_tab_at = None
    ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBSMulticastF1UContextDescriptor_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBSMulticastF1UContextDescriptor_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__criticality._const_tab = ____MBSMulticastF1UContextDescriptor_iE_Extensions__item__criticality_tab
    ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBSMulticastF1UContextDescriptor_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBSMulticastF1UContextDescriptor_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__extensionValue._const_tab = ____MBSMulticastF1UContextDescriptor_iE_Extensions__item__extensionValue_tab
    ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBSMulticastF1UContextDescriptor_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__id),
        ('criticality', ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__criticality),
        ('extensionValue', ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__extensionValue),
        ])
    __MBSMulticastF1UContextDescriptor_iE_Extensions__item_._ext = None
    _MBSMulticastF1UContextDescriptor_iE_Extensions._cont = __MBSMulticastF1UContextDescriptor_iE_Extensions__item_
    _MBSMulticastF1UContextDescriptor_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBSMulticastF1UContextDescriptor._cont = ASN1Dict([
        ('multicastF1UContextReferenceF1', _MBSMulticastF1UContextDescriptor_multicastF1UContextReferenceF1),
        ('mc-F1UCtxtusage', _MBSMulticastF1UContextDescriptor_mc_F1UCtxtusage),
        ('mbsAreaSession', _MBSMulticastF1UContextDescriptor_mbsAreaSession),
        ('iE-Extensions', _MBSMulticastF1UContextDescriptor_iE_Extensions),
        ])
    MBSMulticastF1UContextDescriptor._ext = []
    
    #-----< MBSMulticastF1UContextDescriptor-ExtIEs >-----#
    MBSMulticastF1UContextDescriptor_ExtIEs = CLASS(name='MBSMulticastF1UContextDescriptor-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MBSMulticastF1UContextDescriptor_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MulticastF1UContext-ToBeSetup-Item >-----#
    MulticastF1UContext_ToBeSetup_Item = SEQ(name='MulticastF1UContext-ToBeSetup-Item', mode=MODE_TYPE)
    _MulticastF1UContext_ToBeSetup_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _MulticastF1UContext_ToBeSetup_Item_mbs_f1u_info_at_DU = CHOICE(name='mbs-f1u-info-at-DU', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UPTransportLayerInformation')))
    _MulticastF1UContext_ToBeSetup_Item_mbsProgressInformation = CHOICE(name='mbsProgressInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ProgressInformation')), opt=True)
    _MulticastF1UContext_ToBeSetup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__id._const_tab = ____MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__criticality_tab
    ___MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab
    ___MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__id),
        ('criticality', ___MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item_._ext = None
    _MulticastF1UContext_ToBeSetup_Item_iE_Extensions._cont = __MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item_
    _MulticastF1UContext_ToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MulticastF1UContext_ToBeSetup_Item._cont = ASN1Dict([
        ('mRB-ID', _MulticastF1UContext_ToBeSetup_Item_mRB_ID),
        ('mbs-f1u-info-at-DU', _MulticastF1UContext_ToBeSetup_Item_mbs_f1u_info_at_DU),
        ('mbsProgressInformation', _MulticastF1UContext_ToBeSetup_Item_mbsProgressInformation),
        ('iE-Extensions', _MulticastF1UContext_ToBeSetup_Item_iE_Extensions),
        ])
    MulticastF1UContext_ToBeSetup_Item._ext = []
    
    #-----< MulticastF1UContext-ToBeSetup-Item-ExtIEs >-----#
    MulticastF1UContext_ToBeSetup_Item_ExtIEs = CLASS(name='MulticastF1UContext-ToBeSetup-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MulticastF1UContext_ToBeSetup_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MulticastF1UContext-Setup-Item >-----#
    MulticastF1UContext_Setup_Item = SEQ(name='MulticastF1UContext-Setup-Item', mode=MODE_TYPE)
    _MulticastF1UContext_Setup_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _MulticastF1UContext_Setup_Item_mbs_f1u_info_at_CU = CHOICE(name='mbs-f1u-info-at-CU', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UPTransportLayerInformation')))
    _MulticastF1UContext_Setup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MulticastF1UContext_Setup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MulticastF1UContext_Setup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MulticastF1UContext_Setup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastF1UContext_Setup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastF1UContext_Setup_Item_iE_Extensions__item__id._const_tab = ____MulticastF1UContext_Setup_Item_iE_Extensions__item__id_tab
    ___MulticastF1UContext_Setup_Item_iE_Extensions__item__id._const_tab_at = None
    ___MulticastF1UContext_Setup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MulticastF1UContext_Setup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MulticastF1UContext_Setup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastF1UContext_Setup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastF1UContext_Setup_Item_iE_Extensions__item__criticality._const_tab = ____MulticastF1UContext_Setup_Item_iE_Extensions__item__criticality_tab
    ___MulticastF1UContext_Setup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastF1UContext_Setup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MulticastF1UContext_Setup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MulticastF1UContext_Setup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastF1UContext_Setup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastF1UContext_Setup_Item_iE_Extensions__item__extensionValue._const_tab = ____MulticastF1UContext_Setup_Item_iE_Extensions__item__extensionValue_tab
    ___MulticastF1UContext_Setup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MulticastF1UContext_Setup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MulticastF1UContext_Setup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MulticastF1UContext_Setup_Item_iE_Extensions__item__id),
        ('criticality', ___MulticastF1UContext_Setup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MulticastF1UContext_Setup_Item_iE_Extensions__item__extensionValue),
        ])
    __MulticastF1UContext_Setup_Item_iE_Extensions__item_._ext = None
    _MulticastF1UContext_Setup_Item_iE_Extensions._cont = __MulticastF1UContext_Setup_Item_iE_Extensions__item_
    _MulticastF1UContext_Setup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MulticastF1UContext_Setup_Item._cont = ASN1Dict([
        ('mRB-ID', _MulticastF1UContext_Setup_Item_mRB_ID),
        ('mbs-f1u-info-at-CU', _MulticastF1UContext_Setup_Item_mbs_f1u_info_at_CU),
        ('iE-Extensions', _MulticastF1UContext_Setup_Item_iE_Extensions),
        ])
    MulticastF1UContext_Setup_Item._ext = []
    
    #-----< MulticastF1UContext-Setup-Item-ExtIEs >-----#
    MulticastF1UContext_Setup_Item_ExtIEs = CLASS(name='MulticastF1UContext-Setup-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MulticastF1UContext_Setup_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MulticastF1UContext-FailedToBeSetup-Item >-----#
    MulticastF1UContext_FailedToBeSetup_Item = SEQ(name='MulticastF1UContext-FailedToBeSetup-Item', mode=MODE_TYPE)
    _MulticastF1UContext_FailedToBeSetup_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _MulticastF1UContext_FailedToBeSetup_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab = ____MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__id_tab
    ___MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab
    ___MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab
    ___MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__id),
        ('criticality', ___MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item_._ext = None
    _MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions._cont = __MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item_
    _MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MulticastF1UContext_FailedToBeSetup_Item._cont = ASN1Dict([
        ('mRB-ID', _MulticastF1UContext_FailedToBeSetup_Item_mRB_ID),
        ('cause', _MulticastF1UContext_FailedToBeSetup_Item_cause),
        ('iE-Extensions', _MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions),
        ])
    MulticastF1UContext_FailedToBeSetup_Item._ext = []
    
    #-----< MulticastF1UContext-FailedToBeSetup-Item-ExtIEs >-----#
    MulticastF1UContext_FailedToBeSetup_Item_ExtIEs = CLASS(name='MulticastF1UContext-FailedToBeSetup-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MulticastF1UContext_FailedToBeSetup_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBSPTPRetransmissionTunnelRequired >-----#
    MBSPTPRetransmissionTunnelRequired = ENUM(name='MBSPTPRetransmissionTunnelRequired', mode=MODE_TYPE)
    MBSPTPRetransmissionTunnelRequired._cont = ASN1Dict([('true', 0)])
    MBSPTPRetransmissionTunnelRequired._ext = []
    
    #-----< MBS-ServiceArea >-----#
    MBS_ServiceArea = CHOICE(name='MBS-ServiceArea', mode=MODE_TYPE)
    _MBS_ServiceArea_locationindependent = SEQ(name='locationindependent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MBS-ServiceAreaInformation')))
    _MBS_ServiceArea_locationdependent = SEQ_OF(name='locationdependent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MBS-ServiceAreaInformationList')))
    _MBS_ServiceArea_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __MBS_ServiceArea_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___MBS_ServiceArea_choice_Extensions_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___MBS_ServiceArea_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MBS_ServiceArea_choice_Extensions_id._const_tab = ___MBS_ServiceArea_choice_Extensions_id_tab
    __MBS_ServiceArea_choice_Extensions_id._const_tab_at = None
    __MBS_ServiceArea_choice_Extensions_id._const_tab_id = 'id'
    __MBS_ServiceArea_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___MBS_ServiceArea_choice_Extensions_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___MBS_ServiceArea_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MBS_ServiceArea_choice_Extensions_criticality._const_tab = ___MBS_ServiceArea_choice_Extensions_criticality_tab
    __MBS_ServiceArea_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __MBS_ServiceArea_choice_Extensions_criticality._const_tab_id = 'criticality'
    __MBS_ServiceArea_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___MBS_ServiceArea_choice_Extensions_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___MBS_ServiceArea_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MBS_ServiceArea_choice_Extensions_value._const_tab = ___MBS_ServiceArea_choice_Extensions_value_tab
    __MBS_ServiceArea_choice_Extensions_value._const_tab_at = ('..', 'id')
    __MBS_ServiceArea_choice_Extensions_value._const_tab_id = 'Value'
    _MBS_ServiceArea_choice_Extensions._cont = ASN1Dict([
        ('id', __MBS_ServiceArea_choice_Extensions_id),
        ('criticality', __MBS_ServiceArea_choice_Extensions_criticality),
        ('value', __MBS_ServiceArea_choice_Extensions_value),
        ])
    _MBS_ServiceArea_choice_Extensions._ext = None
    MBS_ServiceArea._cont = ASN1Dict([
        ('locationindependent', _MBS_ServiceArea_locationindependent),
        ('locationdependent', _MBS_ServiceArea_locationdependent),
        ('choice-Extensions', _MBS_ServiceArea_choice_Extensions),
        ])
    MBS_ServiceArea._ext = None
    
    #-----< MBSServiceArea-ExtIEs >-----#
    MBSServiceArea_ExtIEs = CLASS(name='MBSServiceArea-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    MBSServiceArea_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-ServiceAreaInformation >-----#
    MBS_ServiceAreaInformation = SEQ(name='MBS-ServiceAreaInformation', mode=MODE_TYPE)
    _MBS_ServiceAreaInformation_mBS_ServiceAreaCellList = SEQ_OF(name='mBS-ServiceAreaCellList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MBS-ServiceAreaCellList')), opt=True)
    _MBS_ServiceAreaInformation_mBS_ServiceAreaTAIList = SEQ_OF(name='mBS-ServiceAreaTAIList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MBS-ServiceAreaTAIList')), opt=True)
    _MBS_ServiceAreaInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBS_ServiceAreaInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MBS_ServiceAreaInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MBS_ServiceAreaInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBS_ServiceAreaInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_ServiceAreaInformation_iE_Extensions__item__id._const_tab = ____MBS_ServiceAreaInformation_iE_Extensions__item__id_tab
    ___MBS_ServiceAreaInformation_iE_Extensions__item__id._const_tab_at = None
    ___MBS_ServiceAreaInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBS_ServiceAreaInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBS_ServiceAreaInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBS_ServiceAreaInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_ServiceAreaInformation_iE_Extensions__item__criticality._const_tab = ____MBS_ServiceAreaInformation_iE_Extensions__item__criticality_tab
    ___MBS_ServiceAreaInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBS_ServiceAreaInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBS_ServiceAreaInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBS_ServiceAreaInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBS_ServiceAreaInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_ServiceAreaInformation_iE_Extensions__item__extensionValue._const_tab = ____MBS_ServiceAreaInformation_iE_Extensions__item__extensionValue_tab
    ___MBS_ServiceAreaInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBS_ServiceAreaInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBS_ServiceAreaInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBS_ServiceAreaInformation_iE_Extensions__item__id),
        ('criticality', ___MBS_ServiceAreaInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___MBS_ServiceAreaInformation_iE_Extensions__item__extensionValue),
        ])
    __MBS_ServiceAreaInformation_iE_Extensions__item_._ext = None
    _MBS_ServiceAreaInformation_iE_Extensions._cont = __MBS_ServiceAreaInformation_iE_Extensions__item_
    _MBS_ServiceAreaInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBS_ServiceAreaInformation._cont = ASN1Dict([
        ('mBS-ServiceAreaCellList', _MBS_ServiceAreaInformation_mBS_ServiceAreaCellList),
        ('mBS-ServiceAreaTAIList', _MBS_ServiceAreaInformation_mBS_ServiceAreaTAIList),
        ('iE-Extensions', _MBS_ServiceAreaInformation_iE_Extensions),
        ])
    MBS_ServiceAreaInformation._ext = []
    
    #-----< MBS-ServiceAreaInformation-ExtIEs >-----#
    MBS_ServiceAreaInformation_ExtIEs = CLASS(name='MBS-ServiceAreaInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MBS_ServiceAreaInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-ServiceAreaCellList >-----#
    MBS_ServiceAreaCellList = SEQ_OF(name='MBS-ServiceAreaCellList', mode=MODE_TYPE)
    _MBS_ServiceAreaCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    MBS_ServiceAreaCellList._cont = _MBS_ServiceAreaCellList__item_
    MBS_ServiceAreaCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< MBS-ServiceAreaTAIList >-----#
    MBS_ServiceAreaTAIList = SEQ_OF(name='MBS-ServiceAreaTAIList', mode=MODE_TYPE)
    _MBS_ServiceAreaTAIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-ServiceAreaTAIList-Item')))
    MBS_ServiceAreaTAIList._cont = _MBS_ServiceAreaTAIList__item_
    MBS_ServiceAreaTAIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< MBS-ServiceAreaTAIList-Item >-----#
    MBS_ServiceAreaTAIList_Item = SEQ(name='MBS-ServiceAreaTAIList-Item', mode=MODE_TYPE)
    _MBS_ServiceAreaTAIList_Item_plmn_ID = OCT_STR(name='plmn-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _MBS_ServiceAreaTAIList_Item_five5_TAC = OCT_STR(name='five5-TAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FiveGS-TAC')))
    _MBS_ServiceAreaTAIList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBS_ServiceAreaTAIList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MBS_ServiceAreaTAIList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MBS_ServiceAreaTAIList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBS_ServiceAreaTAIList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_ServiceAreaTAIList_Item_iE_Extensions__item__id._const_tab = ____MBS_ServiceAreaTAIList_Item_iE_Extensions__item__id_tab
    ___MBS_ServiceAreaTAIList_Item_iE_Extensions__item__id._const_tab_at = None
    ___MBS_ServiceAreaTAIList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBS_ServiceAreaTAIList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBS_ServiceAreaTAIList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBS_ServiceAreaTAIList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_ServiceAreaTAIList_Item_iE_Extensions__item__criticality._const_tab = ____MBS_ServiceAreaTAIList_Item_iE_Extensions__item__criticality_tab
    ___MBS_ServiceAreaTAIList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBS_ServiceAreaTAIList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBS_ServiceAreaTAIList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBS_ServiceAreaTAIList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBS_ServiceAreaTAIList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_ServiceAreaTAIList_Item_iE_Extensions__item__extensionValue._const_tab = ____MBS_ServiceAreaTAIList_Item_iE_Extensions__item__extensionValue_tab
    ___MBS_ServiceAreaTAIList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBS_ServiceAreaTAIList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBS_ServiceAreaTAIList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBS_ServiceAreaTAIList_Item_iE_Extensions__item__id),
        ('criticality', ___MBS_ServiceAreaTAIList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MBS_ServiceAreaTAIList_Item_iE_Extensions__item__extensionValue),
        ])
    __MBS_ServiceAreaTAIList_Item_iE_Extensions__item_._ext = None
    _MBS_ServiceAreaTAIList_Item_iE_Extensions._cont = __MBS_ServiceAreaTAIList_Item_iE_Extensions__item_
    _MBS_ServiceAreaTAIList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBS_ServiceAreaTAIList_Item._cont = ASN1Dict([
        ('plmn-ID', _MBS_ServiceAreaTAIList_Item_plmn_ID),
        ('five5-TAC', _MBS_ServiceAreaTAIList_Item_five5_TAC),
        ('iE-Extensions', _MBS_ServiceAreaTAIList_Item_iE_Extensions),
        ])
    MBS_ServiceAreaTAIList_Item._ext = []
    
    #-----< MBS-ServiceAreaTAIList-Item-ExtIEs >-----#
    MBS_ServiceAreaTAIList_Item_ExtIEs = CLASS(name='MBS-ServiceAreaTAIList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MBS_ServiceAreaTAIList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-ServiceAreaInformationList >-----#
    MBS_ServiceAreaInformationList = SEQ_OF(name='MBS-ServiceAreaInformationList', mode=MODE_TYPE)
    _MBS_ServiceAreaInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-ServiceAreaInformationItem')))
    MBS_ServiceAreaInformationList._cont = _MBS_ServiceAreaInformationList__item_
    MBS_ServiceAreaInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< MBS-ServiceAreaInformationItem >-----#
    MBS_ServiceAreaInformationItem = SEQ(name='MBS-ServiceAreaInformationItem', mode=MODE_TYPE)
    _MBS_ServiceAreaInformationItem_mBS_AreaSessionID = INT(name='mBS-AreaSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MBS-Area-Session-ID')))
    _MBS_ServiceAreaInformationItem_mBS_ServiceAreaInformation = SEQ(name='mBS-ServiceAreaInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MBS-ServiceAreaInformation')))
    _MBS_ServiceAreaInformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBS_ServiceAreaInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MBS_ServiceAreaInformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MBS_ServiceAreaInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBS_ServiceAreaInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_ServiceAreaInformationItem_iE_Extensions__item__id._const_tab = ____MBS_ServiceAreaInformationItem_iE_Extensions__item__id_tab
    ___MBS_ServiceAreaInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___MBS_ServiceAreaInformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBS_ServiceAreaInformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBS_ServiceAreaInformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBS_ServiceAreaInformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_ServiceAreaInformationItem_iE_Extensions__item__criticality._const_tab = ____MBS_ServiceAreaInformationItem_iE_Extensions__item__criticality_tab
    ___MBS_ServiceAreaInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBS_ServiceAreaInformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBS_ServiceAreaInformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBS_ServiceAreaInformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MBS_ServiceAreaInformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_ServiceAreaInformationItem_iE_Extensions__item__extensionValue._const_tab = ____MBS_ServiceAreaInformationItem_iE_Extensions__item__extensionValue_tab
    ___MBS_ServiceAreaInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBS_ServiceAreaInformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBS_ServiceAreaInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBS_ServiceAreaInformationItem_iE_Extensions__item__id),
        ('criticality', ___MBS_ServiceAreaInformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___MBS_ServiceAreaInformationItem_iE_Extensions__item__extensionValue),
        ])
    __MBS_ServiceAreaInformationItem_iE_Extensions__item_._ext = None
    _MBS_ServiceAreaInformationItem_iE_Extensions._cont = __MBS_ServiceAreaInformationItem_iE_Extensions__item_
    _MBS_ServiceAreaInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBS_ServiceAreaInformationItem._cont = ASN1Dict([
        ('mBS-AreaSessionID', _MBS_ServiceAreaInformationItem_mBS_AreaSessionID),
        ('mBS-ServiceAreaInformation', _MBS_ServiceAreaInformationItem_mBS_ServiceAreaInformation),
        ('iE-Extensions', _MBS_ServiceAreaInformationItem_iE_Extensions),
        ])
    MBS_ServiceAreaInformationItem._ext = []
    
    #-----< MBS-ServiceAreaInformationItem-ExtIEs >-----#
    MBS_ServiceAreaInformationItem_ExtIEs = CLASS(name='MBS-ServiceAreaInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MBS_ServiceAreaInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MC-PagingCell-Item >-----#
    MC_PagingCell_Item = SEQ(name='MC-PagingCell-Item', mode=MODE_TYPE)
    _MC_PagingCell_Item_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _MC_PagingCell_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MC_PagingCell_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MC_PagingCell_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MC_PagingCell_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MC_PagingCell_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MC_PagingCell_Item_iE_Extensions__item__id._const_tab = ____MC_PagingCell_Item_iE_Extensions__item__id_tab
    ___MC_PagingCell_Item_iE_Extensions__item__id._const_tab_at = None
    ___MC_PagingCell_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MC_PagingCell_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MC_PagingCell_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MC_PagingCell_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MC_PagingCell_Item_iE_Extensions__item__criticality._const_tab = ____MC_PagingCell_Item_iE_Extensions__item__criticality_tab
    ___MC_PagingCell_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MC_PagingCell_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MC_PagingCell_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MC_PagingCell_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MC_PagingCell_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MC_PagingCell_Item_iE_Extensions__item__extensionValue._const_tab = ____MC_PagingCell_Item_iE_Extensions__item__extensionValue_tab
    ___MC_PagingCell_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MC_PagingCell_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MC_PagingCell_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MC_PagingCell_Item_iE_Extensions__item__id),
        ('criticality', ___MC_PagingCell_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MC_PagingCell_Item_iE_Extensions__item__extensionValue),
        ])
    __MC_PagingCell_Item_iE_Extensions__item_._ext = None
    _MC_PagingCell_Item_iE_Extensions._cont = __MC_PagingCell_Item_iE_Extensions__item_
    _MC_PagingCell_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MC_PagingCell_Item._cont = ASN1Dict([
        ('nRCGI', _MC_PagingCell_Item_nRCGI),
        ('iE-Extensions', _MC_PagingCell_Item_iE_Extensions),
        ])
    MC_PagingCell_Item._ext = None
    
    #-----< MC-PagingCell-ItemExtIEs >-----#
    MC_PagingCell_ItemExtIEs = CLASS(name='MC-PagingCell-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MC_PagingCell_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MIB-message >-----#
    MIB_message = OCT_STR(name='MIB-message', mode=MODE_TYPE)
    
    #-----< MeasConfig >-----#
    MeasConfig = OCT_STR(name='MeasConfig', mode=MODE_TYPE)
    
    #-----< MeasGapConfig >-----#
    MeasGapConfig = OCT_STR(name='MeasGapConfig', mode=MODE_TYPE)
    
    #-----< MeasGapSharingConfig >-----#
    MeasGapSharingConfig = OCT_STR(name='MeasGapSharingConfig', mode=MODE_TYPE)
    
    #-----< PosMeasurementAmount >-----#
    PosMeasurementAmount = ENUM(name='PosMeasurementAmount', mode=MODE_TYPE)
    PosMeasurementAmount._cont = ASN1Dict([('ma0', 0), ('ma1', 1), ('ma2', 2), ('ma4', 3), ('ma8', 4), ('ma16', 5), ('ma32', 6), ('ma64', 7)])
    PosMeasurementAmount._ext = None
    
    #-----< MeasurementBeamInfoRequest >-----#
    MeasurementBeamInfoRequest = ENUM(name='MeasurementBeamInfoRequest', mode=MODE_TYPE)
    MeasurementBeamInfoRequest._cont = ASN1Dict([('true', 0)])
    MeasurementBeamInfoRequest._ext = []
    
    #-----< MeasurementBeamInfo >-----#
    MeasurementBeamInfo = SEQ(name='MeasurementBeamInfo', mode=MODE_TYPE)
    _MeasurementBeamInfo_pRS_Resource_ID = INT(name='pRS-Resource-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-ID')), opt=True)
    _MeasurementBeamInfo_pRS_Resource_Set_ID = INT(name='pRS-Resource-Set-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-Set-ID')), opt=True)
    _MeasurementBeamInfo_sSB_Index = INT(name='sSB-Index', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB-Index')), opt=True)
    _MeasurementBeamInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MeasurementBeamInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MeasurementBeamInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MeasurementBeamInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MeasurementBeamInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementBeamInfo_iE_Extensions__item__id._const_tab = ____MeasurementBeamInfo_iE_Extensions__item__id_tab
    ___MeasurementBeamInfo_iE_Extensions__item__id._const_tab_at = None
    ___MeasurementBeamInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___MeasurementBeamInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MeasurementBeamInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MeasurementBeamInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementBeamInfo_iE_Extensions__item__criticality._const_tab = ____MeasurementBeamInfo_iE_Extensions__item__criticality_tab
    ___MeasurementBeamInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MeasurementBeamInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MeasurementBeamInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MeasurementBeamInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MeasurementBeamInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementBeamInfo_iE_Extensions__item__extensionValue._const_tab = ____MeasurementBeamInfo_iE_Extensions__item__extensionValue_tab
    ___MeasurementBeamInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MeasurementBeamInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MeasurementBeamInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MeasurementBeamInfo_iE_Extensions__item__id),
        ('criticality', ___MeasurementBeamInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___MeasurementBeamInfo_iE_Extensions__item__extensionValue),
        ])
    __MeasurementBeamInfo_iE_Extensions__item_._ext = None
    _MeasurementBeamInfo_iE_Extensions._cont = __MeasurementBeamInfo_iE_Extensions__item_
    _MeasurementBeamInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MeasurementBeamInfo._cont = ASN1Dict([
        ('pRS-Resource-ID', _MeasurementBeamInfo_pRS_Resource_ID),
        ('pRS-Resource-Set-ID', _MeasurementBeamInfo_pRS_Resource_Set_ID),
        ('sSB-Index', _MeasurementBeamInfo_sSB_Index),
        ('iE-Extensions', _MeasurementBeamInfo_iE_Extensions),
        ])
    MeasurementBeamInfo._ext = None
    
    #-----< MeasurementBeamInfo-ExtIEs >-----#
    MeasurementBeamInfo_ExtIEs = CLASS(name='MeasurementBeamInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MeasurementBeamInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MeasurementTimingConfiguration >-----#
    MeasurementTimingConfiguration = OCT_STR(name='MeasurementTimingConfiguration', mode=MODE_TYPE)
    
    #-----< MessageIdentifier >-----#
    MessageIdentifier = BIT_STR(name='MessageIdentifier', mode=MODE_TYPE)
    MessageIdentifier._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< MeasurementTimeOccasion >-----#
    MeasurementTimeOccasion = ENUM(name='MeasurementTimeOccasion', mode=MODE_TYPE)
    MeasurementTimeOccasion._cont = ASN1Dict([('o1', 0), ('o4', 1)])
    MeasurementTimeOccasion._ext = []
    
    #-----< MeasurementCharacteristicsRequestIndicator >-----#
    MeasurementCharacteristicsRequestIndicator = BIT_STR(name='MeasurementCharacteristicsRequestIndicator', mode=MODE_TYPE)
    MeasurementCharacteristicsRequestIndicator._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< MRB-ProgressInformation >-----#
    MRB_ProgressInformation = CHOICE(name='MRB-ProgressInformation', mode=MODE_TYPE)
    _MRB_ProgressInformation_pdcp_SN12 = INT(name='pdcp-SN12', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MRB_ProgressInformation_pdcp_SN12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _MRB_ProgressInformation_pdcp_SN18 = INT(name='pdcp-SN18', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MRB_ProgressInformation_pdcp_SN18._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=262143)], ev=None, er=[])
    _MRB_ProgressInformation_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __MRB_ProgressInformation_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___MRB_ProgressInformation_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___MRB_ProgressInformation_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MRB_ProgressInformation_choice_extension_id._const_tab = ___MRB_ProgressInformation_choice_extension_id_tab
    __MRB_ProgressInformation_choice_extension_id._const_tab_at = None
    __MRB_ProgressInformation_choice_extension_id._const_tab_id = 'id'
    __MRB_ProgressInformation_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___MRB_ProgressInformation_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___MRB_ProgressInformation_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MRB_ProgressInformation_choice_extension_criticality._const_tab = ___MRB_ProgressInformation_choice_extension_criticality_tab
    __MRB_ProgressInformation_choice_extension_criticality._const_tab_at = ('..', 'id')
    __MRB_ProgressInformation_choice_extension_criticality._const_tab_id = 'criticality'
    __MRB_ProgressInformation_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___MRB_ProgressInformation_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___MRB_ProgressInformation_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MRB_ProgressInformation_choice_extension_value._const_tab = ___MRB_ProgressInformation_choice_extension_value_tab
    __MRB_ProgressInformation_choice_extension_value._const_tab_at = ('..', 'id')
    __MRB_ProgressInformation_choice_extension_value._const_tab_id = 'Value'
    _MRB_ProgressInformation_choice_extension._cont = ASN1Dict([
        ('id', __MRB_ProgressInformation_choice_extension_id),
        ('criticality', __MRB_ProgressInformation_choice_extension_criticality),
        ('value', __MRB_ProgressInformation_choice_extension_value),
        ])
    _MRB_ProgressInformation_choice_extension._ext = None
    MRB_ProgressInformation._cont = ASN1Dict([
        ('pdcp-SN12', _MRB_ProgressInformation_pdcp_SN12),
        ('pdcp-SN18', _MRB_ProgressInformation_pdcp_SN18),
        ('choice-extension', _MRB_ProgressInformation_choice_extension),
        ])
    MRB_ProgressInformation._ext = None
    
    #-----< MRB-ProgressInformation-ExtIEs >-----#
    MRB_ProgressInformation_ExtIEs = CLASS(name='MRB-ProgressInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    MRB_ProgressInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MulticastF1UContextReferenceF1 >-----#
    MulticastF1UContextReferenceF1 = OCT_STR(name='MulticastF1UContextReferenceF1', mode=MODE_TYPE)
    MulticastF1UContextReferenceF1._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< MulticastF1UContextReferenceCU >-----#
    MulticastF1UContextReferenceCU = OCT_STR(name='MulticastF1UContextReferenceCU', mode=MODE_TYPE)
    MulticastF1UContextReferenceCU._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< MultipleULAoA >-----#
    MultipleULAoA = SEQ(name='MultipleULAoA', mode=MODE_TYPE)
    _MultipleULAoA_multipleULAoA = SEQ_OF(name='multipleULAoA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MultipleULAoA-List')))
    _MultipleULAoA_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MultipleULAoA_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MultipleULAoA_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MultipleULAoA_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MultipleULAoA_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultipleULAoA_iE_Extensions__item__id._const_tab = ____MultipleULAoA_iE_Extensions__item__id_tab
    ___MultipleULAoA_iE_Extensions__item__id._const_tab_at = None
    ___MultipleULAoA_iE_Extensions__item__id._const_tab_id = 'id'
    ___MultipleULAoA_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MultipleULAoA_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MultipleULAoA_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultipleULAoA_iE_Extensions__item__criticality._const_tab = ____MultipleULAoA_iE_Extensions__item__criticality_tab
    ___MultipleULAoA_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MultipleULAoA_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MultipleULAoA_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MultipleULAoA_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MultipleULAoA_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultipleULAoA_iE_Extensions__item__extensionValue._const_tab = ____MultipleULAoA_iE_Extensions__item__extensionValue_tab
    ___MultipleULAoA_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MultipleULAoA_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MultipleULAoA_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MultipleULAoA_iE_Extensions__item__id),
        ('criticality', ___MultipleULAoA_iE_Extensions__item__criticality),
        ('extensionValue', ___MultipleULAoA_iE_Extensions__item__extensionValue),
        ])
    __MultipleULAoA_iE_Extensions__item_._ext = None
    _MultipleULAoA_iE_Extensions._cont = __MultipleULAoA_iE_Extensions__item_
    _MultipleULAoA_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MultipleULAoA._cont = ASN1Dict([
        ('multipleULAoA', _MultipleULAoA_multipleULAoA),
        ('iE-Extensions', _MultipleULAoA_iE_Extensions),
        ])
    MultipleULAoA._ext = []
    
    #-----< MultipleULAoA-ExtIEs >-----#
    MultipleULAoA_ExtIEs = CLASS(name='MultipleULAoA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MultipleULAoA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MultipleULAoA-List >-----#
    MultipleULAoA_List = SEQ_OF(name='MultipleULAoA-List', mode=MODE_TYPE)
    _MultipleULAoA_List__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MultipleULAoA-Item')))
    MultipleULAoA_List._cont = _MultipleULAoA_List__item_
    MultipleULAoA_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MultipleULAoA-Item >-----#
    MultipleULAoA_Item = CHOICE(name='MultipleULAoA-Item', mode=MODE_TYPE)
    _MultipleULAoA_Item_uL_AoA = SEQ(name='uL-AoA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UL-AoA')))
    _MultipleULAoA_Item_ul_ZoA = SEQ(name='ul-ZoA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ZoAInformation')))
    _MultipleULAoA_Item_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __MultipleULAoA_Item_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___MultipleULAoA_Item_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___MultipleULAoA_Item_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MultipleULAoA_Item_choice_extension_id._const_tab = ___MultipleULAoA_Item_choice_extension_id_tab
    __MultipleULAoA_Item_choice_extension_id._const_tab_at = None
    __MultipleULAoA_Item_choice_extension_id._const_tab_id = 'id'
    __MultipleULAoA_Item_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___MultipleULAoA_Item_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___MultipleULAoA_Item_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MultipleULAoA_Item_choice_extension_criticality._const_tab = ___MultipleULAoA_Item_choice_extension_criticality_tab
    __MultipleULAoA_Item_choice_extension_criticality._const_tab_at = ('..', 'id')
    __MultipleULAoA_Item_choice_extension_criticality._const_tab_id = 'criticality'
    __MultipleULAoA_Item_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___MultipleULAoA_Item_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___MultipleULAoA_Item_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MultipleULAoA_Item_choice_extension_value._const_tab = ___MultipleULAoA_Item_choice_extension_value_tab
    __MultipleULAoA_Item_choice_extension_value._const_tab_at = ('..', 'id')
    __MultipleULAoA_Item_choice_extension_value._const_tab_id = 'Value'
    _MultipleULAoA_Item_choice_extension._cont = ASN1Dict([
        ('id', __MultipleULAoA_Item_choice_extension_id),
        ('criticality', __MultipleULAoA_Item_choice_extension_criticality),
        ('value', __MultipleULAoA_Item_choice_extension_value),
        ])
    _MultipleULAoA_Item_choice_extension._ext = None
    MultipleULAoA_Item._cont = ASN1Dict([
        ('uL-AoA', _MultipleULAoA_Item_uL_AoA),
        ('ul-ZoA', _MultipleULAoA_Item_ul_ZoA),
        ('choice-extension', _MultipleULAoA_Item_choice_extension),
        ])
    MultipleULAoA_Item._ext = None
    
    #-----< MultipleULAoA-Item-ExtIEs >-----#
    MultipleULAoA_Item_ExtIEs = CLASS(name='MultipleULAoA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    MultipleULAoA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MDTPollutedMeasurementIndicator >-----#
    MDTPollutedMeasurementIndicator = ENUM(name='MDTPollutedMeasurementIndicator', mode=MODE_TYPE)
    MDTPollutedMeasurementIndicator._cont = ASN1Dict([('iDC', 0), ('no-IDC', 1)])
    MDTPollutedMeasurementIndicator._ext = []
    
    #-----< MRB-ID >-----#
    MRB_ID = INT(name='MRB-ID', mode=MODE_TYPE)
    MRB_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=[], er=[])
    
    #-----< MulticastMBSSessionList >-----#
    MulticastMBSSessionList = SEQ_OF(name='MulticastMBSSessionList', mode=MODE_TYPE)
    _MulticastMBSSessionList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMBSSessionList-Item')))
    MulticastMBSSessionList._cont = _MulticastMBSSessionList__item_
    MulticastMBSSessionList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< MulticastMBSSessionList-Item >-----#
    MulticastMBSSessionList_Item = SEQ(name='MulticastMBSSessionList-Item', mode=MODE_TYPE)
    _MulticastMBSSessionList_Item_mbsSessionId = SEQ(name='mbsSessionId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MBS-Session-ID')))
    _MulticastMBSSessionList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MulticastMBSSessionList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MulticastMBSSessionList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MulticastMBSSessionList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMBSSessionList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMBSSessionList_Item_iE_Extensions__item__id._const_tab = ____MulticastMBSSessionList_Item_iE_Extensions__item__id_tab
    ___MulticastMBSSessionList_Item_iE_Extensions__item__id._const_tab_at = None
    ___MulticastMBSSessionList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MulticastMBSSessionList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MulticastMBSSessionList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMBSSessionList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMBSSessionList_Item_iE_Extensions__item__criticality._const_tab = ____MulticastMBSSessionList_Item_iE_Extensions__item__criticality_tab
    ___MulticastMBSSessionList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastMBSSessionList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MulticastMBSSessionList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MulticastMBSSessionList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMBSSessionList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMBSSessionList_Item_iE_Extensions__item__extensionValue._const_tab = ____MulticastMBSSessionList_Item_iE_Extensions__item__extensionValue_tab
    ___MulticastMBSSessionList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MulticastMBSSessionList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MulticastMBSSessionList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MulticastMBSSessionList_Item_iE_Extensions__item__id),
        ('criticality', ___MulticastMBSSessionList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MulticastMBSSessionList_Item_iE_Extensions__item__extensionValue),
        ])
    __MulticastMBSSessionList_Item_iE_Extensions__item_._ext = None
    _MulticastMBSSessionList_Item_iE_Extensions._cont = __MulticastMBSSessionList_Item_iE_Extensions__item_
    _MulticastMBSSessionList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MulticastMBSSessionList_Item._cont = ASN1Dict([
        ('mbsSessionId', _MulticastMBSSessionList_Item_mbsSessionId),
        ('iE-Extensions', _MulticastMBSSessionList_Item_iE_Extensions),
        ])
    MulticastMBSSessionList_Item._ext = []
    
    #-----< MulticastMBSSessionList-Item-ExtIEs >-----#
    MulticastMBSSessionList_Item_ExtIEs = CLASS(name='MulticastMBSSessionList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MulticastMBSSessionList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MulticastMRBs-FailedToBeModified-Item >-----#
    MulticastMRBs_FailedToBeModified_Item = SEQ(name='MulticastMRBs-FailedToBeModified-Item', mode=MODE_TYPE)
    _MulticastMRBs_FailedToBeModified_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _MulticastMRBs_FailedToBeModified_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _MulticastMRBs_FailedToBeModified_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__id._const_tab = ____MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__id_tab
    ___MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__id._const_tab_at = None
    ___MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__criticality._const_tab = ____MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__criticality_tab
    ___MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab = ____MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab
    ___MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__id),
        ('criticality', ___MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue),
        ])
    __MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item_._ext = None
    _MulticastMRBs_FailedToBeModified_Item_iE_Extensions._cont = __MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item_
    _MulticastMRBs_FailedToBeModified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MulticastMRBs_FailedToBeModified_Item._cont = ASN1Dict([
        ('mRB-ID', _MulticastMRBs_FailedToBeModified_Item_mRB_ID),
        ('cause', _MulticastMRBs_FailedToBeModified_Item_cause),
        ('iE-Extensions', _MulticastMRBs_FailedToBeModified_Item_iE_Extensions),
        ])
    MulticastMRBs_FailedToBeModified_Item._ext = []
    
    #-----< MulticastMRBs-FailedtoBeModified-Item-ExtIEs >-----#
    MulticastMRBs_FailedtoBeModified_Item_ExtIEs = CLASS(name='MulticastMRBs-FailedtoBeModified-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MulticastMRBs_FailedtoBeModified_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MulticastMRBs-FailedToBeSetup-Item >-----#
    MulticastMRBs_FailedToBeSetup_Item = SEQ(name='MulticastMRBs-FailedToBeSetup-Item', mode=MODE_TYPE)
    _MulticastMRBs_FailedToBeSetup_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _MulticastMRBs_FailedToBeSetup_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _MulticastMRBs_FailedToBeSetup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab = ____MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab
    ___MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab
    ___MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab
    ___MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__id),
        ('criticality', ___MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item_._ext = None
    _MulticastMRBs_FailedToBeSetup_Item_iE_Extensions._cont = __MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item_
    _MulticastMRBs_FailedToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MulticastMRBs_FailedToBeSetup_Item._cont = ASN1Dict([
        ('mRB-ID', _MulticastMRBs_FailedToBeSetup_Item_mRB_ID),
        ('cause', _MulticastMRBs_FailedToBeSetup_Item_cause),
        ('iE-Extensions', _MulticastMRBs_FailedToBeSetup_Item_iE_Extensions),
        ])
    MulticastMRBs_FailedToBeSetup_Item._ext = []
    
    #-----< MulticastMRBs-FailedToBeSetup-Item-ExtIEs >-----#
    MulticastMRBs_FailedToBeSetup_Item_ExtIEs = CLASS(name='MulticastMRBs-FailedToBeSetup-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MulticastMRBs_FailedToBeSetup_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MulticastMRBs-FailedToBeSetupMod-Item >-----#
    MulticastMRBs_FailedToBeSetupMod_Item = SEQ(name='MulticastMRBs-FailedToBeSetupMod-Item', mode=MODE_TYPE)
    _MulticastMRBs_FailedToBeSetupMod_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _MulticastMRBs_FailedToBeSetupMod_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab = ____MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab = ____MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab
    ___MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id),
        ('criticality', ___MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item_._ext = None
    _MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions._cont = __MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item_
    _MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MulticastMRBs_FailedToBeSetupMod_Item._cont = ASN1Dict([
        ('mRB-ID', _MulticastMRBs_FailedToBeSetupMod_Item_mRB_ID),
        ('cause', _MulticastMRBs_FailedToBeSetupMod_Item_cause),
        ('iE-Extensions', _MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions),
        ])
    MulticastMRBs_FailedToBeSetupMod_Item._ext = []
    
    #-----< MulticastMRBs-FailedToBeSetupMod-Item-ExtIEs >-----#
    MulticastMRBs_FailedToBeSetupMod_Item_ExtIEs = CLASS(name='MulticastMRBs-FailedToBeSetupMod-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MulticastMRBs_FailedToBeSetupMod_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MulticastMRBs-Modified-Item >-----#
    MulticastMRBs_Modified_Item = SEQ(name='MulticastMRBs-Modified-Item', mode=MODE_TYPE)
    _MulticastMRBs_Modified_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _MulticastMRBs_Modified_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MulticastMRBs_Modified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MulticastMRBs_Modified_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MulticastMRBs_Modified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_Modified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_Modified_Item_iE_Extensions__item__id._const_tab = ____MulticastMRBs_Modified_Item_iE_Extensions__item__id_tab
    ___MulticastMRBs_Modified_Item_iE_Extensions__item__id._const_tab_at = None
    ___MulticastMRBs_Modified_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MulticastMRBs_Modified_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MulticastMRBs_Modified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_Modified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_Modified_Item_iE_Extensions__item__criticality._const_tab = ____MulticastMRBs_Modified_Item_iE_Extensions__item__criticality_tab
    ___MulticastMRBs_Modified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastMRBs_Modified_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MulticastMRBs_Modified_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MulticastMRBs_Modified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_Modified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_Modified_Item_iE_Extensions__item__extensionValue._const_tab = ____MulticastMRBs_Modified_Item_iE_Extensions__item__extensionValue_tab
    ___MulticastMRBs_Modified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MulticastMRBs_Modified_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MulticastMRBs_Modified_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MulticastMRBs_Modified_Item_iE_Extensions__item__id),
        ('criticality', ___MulticastMRBs_Modified_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MulticastMRBs_Modified_Item_iE_Extensions__item__extensionValue),
        ])
    __MulticastMRBs_Modified_Item_iE_Extensions__item_._ext = None
    _MulticastMRBs_Modified_Item_iE_Extensions._cont = __MulticastMRBs_Modified_Item_iE_Extensions__item_
    _MulticastMRBs_Modified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MulticastMRBs_Modified_Item._cont = ASN1Dict([
        ('mRB-ID', _MulticastMRBs_Modified_Item_mRB_ID),
        ('iE-Extensions', _MulticastMRBs_Modified_Item_iE_Extensions),
        ])
    MulticastMRBs_Modified_Item._ext = []
    
    #-----< MulticastMRBs-Modified-Item-ExtIEs >-----#
    MulticastMRBs_Modified_Item_ExtIEs = CLASS(name='MulticastMRBs-Modified-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MulticastMRBs_Modified_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MulticastMRBs-Setup-Item >-----#
    MulticastMRBs_Setup_Item = SEQ(name='MulticastMRBs-Setup-Item', mode=MODE_TYPE)
    _MulticastMRBs_Setup_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _MulticastMRBs_Setup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MulticastMRBs_Setup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MulticastMRBs_Setup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MulticastMRBs_Setup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_Setup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_Setup_Item_iE_Extensions__item__id._const_tab = ____MulticastMRBs_Setup_Item_iE_Extensions__item__id_tab
    ___MulticastMRBs_Setup_Item_iE_Extensions__item__id._const_tab_at = None
    ___MulticastMRBs_Setup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MulticastMRBs_Setup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MulticastMRBs_Setup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_Setup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_Setup_Item_iE_Extensions__item__criticality._const_tab = ____MulticastMRBs_Setup_Item_iE_Extensions__item__criticality_tab
    ___MulticastMRBs_Setup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastMRBs_Setup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MulticastMRBs_Setup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MulticastMRBs_Setup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_Setup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab = ____MulticastMRBs_Setup_Item_iE_Extensions__item__extensionValue_tab
    ___MulticastMRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MulticastMRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MulticastMRBs_Setup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MulticastMRBs_Setup_Item_iE_Extensions__item__id),
        ('criticality', ___MulticastMRBs_Setup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MulticastMRBs_Setup_Item_iE_Extensions__item__extensionValue),
        ])
    __MulticastMRBs_Setup_Item_iE_Extensions__item_._ext = None
    _MulticastMRBs_Setup_Item_iE_Extensions._cont = __MulticastMRBs_Setup_Item_iE_Extensions__item_
    _MulticastMRBs_Setup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MulticastMRBs_Setup_Item._cont = ASN1Dict([
        ('mRB-ID', _MulticastMRBs_Setup_Item_mRB_ID),
        ('iE-Extensions', _MulticastMRBs_Setup_Item_iE_Extensions),
        ])
    MulticastMRBs_Setup_Item._ext = []
    
    #-----< MulticastMRBs-Setup-Item-ExtIEs >-----#
    MulticastMRBs_Setup_Item_ExtIEs = CLASS(name='MulticastMRBs-Setup-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MulticastMRBs_Setup_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MulticastMRBs-SetupMod-Item >-----#
    MulticastMRBs_SetupMod_Item = SEQ(name='MulticastMRBs-SetupMod-Item', mode=MODE_TYPE)
    _MulticastMRBs_SetupMod_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _MulticastMRBs_SetupMod_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MulticastMRBs_SetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MulticastMRBs_SetupMod_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MulticastMRBs_SetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_SetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_SetupMod_Item_iE_Extensions__item__id._const_tab = ____MulticastMRBs_SetupMod_Item_iE_Extensions__item__id_tab
    ___MulticastMRBs_SetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___MulticastMRBs_SetupMod_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MulticastMRBs_SetupMod_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MulticastMRBs_SetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_SetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_SetupMod_Item_iE_Extensions__item__criticality._const_tab = ____MulticastMRBs_SetupMod_Item_iE_Extensions__item__criticality_tab
    ___MulticastMRBs_SetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastMRBs_SetupMod_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MulticastMRBs_SetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MulticastMRBs_SetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_SetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____MulticastMRBs_SetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___MulticastMRBs_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MulticastMRBs_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MulticastMRBs_SetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MulticastMRBs_SetupMod_Item_iE_Extensions__item__id),
        ('criticality', ___MulticastMRBs_SetupMod_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MulticastMRBs_SetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __MulticastMRBs_SetupMod_Item_iE_Extensions__item_._ext = None
    _MulticastMRBs_SetupMod_Item_iE_Extensions._cont = __MulticastMRBs_SetupMod_Item_iE_Extensions__item_
    _MulticastMRBs_SetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MulticastMRBs_SetupMod_Item._cont = ASN1Dict([
        ('mRB-ID', _MulticastMRBs_SetupMod_Item_mRB_ID),
        ('iE-Extensions', _MulticastMRBs_SetupMod_Item_iE_Extensions),
        ])
    MulticastMRBs_SetupMod_Item._ext = []
    
    #-----< MulticastMRBs-SetupMod-Item-ExtIEs >-----#
    MulticastMRBs_SetupMod_Item_ExtIEs = CLASS(name='MulticastMRBs-SetupMod-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MulticastMRBs_SetupMod_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MulticastMRBs-ToBeModified-Item >-----#
    MulticastMRBs_ToBeModified_Item = SEQ(name='MulticastMRBs-ToBeModified-Item', mode=MODE_TYPE)
    _MulticastMRBs_ToBeModified_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _MulticastMRBs_ToBeModified_Item_mRB_QoSInformation = SEQ(name='mRB-QoSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSFlowLevelQoSParameters')), opt=True)
    _MulticastMRBs_ToBeModified_Item_mBS_Flows_Mapped_To_MRB_List = SEQ_OF(name='mBS-Flows-Mapped-To-MRB-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MBS-Flows-Mapped-To-MRB-List')), opt=True)
    _MulticastMRBs_ToBeModified_Item_mBS_DL_PDCP_SN_Length = ENUM(name='mBS-DL-PDCP-SN-Length', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')), opt=True)
    _MulticastMRBs_ToBeModified_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MulticastMRBs_ToBeModified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MulticastMRBs_ToBeModified_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MulticastMRBs_ToBeModified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_ToBeModified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_ToBeModified_Item_iE_Extensions__item__id._const_tab = ____MulticastMRBs_ToBeModified_Item_iE_Extensions__item__id_tab
    ___MulticastMRBs_ToBeModified_Item_iE_Extensions__item__id._const_tab_at = None
    ___MulticastMRBs_ToBeModified_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MulticastMRBs_ToBeModified_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MulticastMRBs_ToBeModified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_ToBeModified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_ToBeModified_Item_iE_Extensions__item__criticality._const_tab = ____MulticastMRBs_ToBeModified_Item_iE_Extensions__item__criticality_tab
    ___MulticastMRBs_ToBeModified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastMRBs_ToBeModified_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MulticastMRBs_ToBeModified_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MulticastMRBs_ToBeModified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_ToBeModified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab = ____MulticastMRBs_ToBeModified_Item_iE_Extensions__item__extensionValue_tab
    ___MulticastMRBs_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MulticastMRBs_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MulticastMRBs_ToBeModified_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MulticastMRBs_ToBeModified_Item_iE_Extensions__item__id),
        ('criticality', ___MulticastMRBs_ToBeModified_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MulticastMRBs_ToBeModified_Item_iE_Extensions__item__extensionValue),
        ])
    __MulticastMRBs_ToBeModified_Item_iE_Extensions__item_._ext = None
    _MulticastMRBs_ToBeModified_Item_iE_Extensions._cont = __MulticastMRBs_ToBeModified_Item_iE_Extensions__item_
    _MulticastMRBs_ToBeModified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MulticastMRBs_ToBeModified_Item._cont = ASN1Dict([
        ('mRB-ID', _MulticastMRBs_ToBeModified_Item_mRB_ID),
        ('mRB-QoSInformation', _MulticastMRBs_ToBeModified_Item_mRB_QoSInformation),
        ('mBS-Flows-Mapped-To-MRB-List', _MulticastMRBs_ToBeModified_Item_mBS_Flows_Mapped_To_MRB_List),
        ('mBS-DL-PDCP-SN-Length', _MulticastMRBs_ToBeModified_Item_mBS_DL_PDCP_SN_Length),
        ('iE-Extensions', _MulticastMRBs_ToBeModified_Item_iE_Extensions),
        ])
    MulticastMRBs_ToBeModified_Item._ext = []
    
    #-----< MulticastMRBs-ToBeModified-Item-ExtIEs >-----#
    MulticastMRBs_ToBeModified_Item_ExtIEs = CLASS(name='MulticastMRBs-ToBeModified-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MulticastMRBs_ToBeModified_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MulticastMRBs-ToBeReleased-Item >-----#
    MulticastMRBs_ToBeReleased_Item = SEQ(name='MulticastMRBs-ToBeReleased-Item', mode=MODE_TYPE)
    _MulticastMRBs_ToBeReleased_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _MulticastMRBs_ToBeReleased_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MulticastMRBs_ToBeReleased_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab = ____MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__id_tab
    ___MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab_at = None
    ___MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab = ____MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab
    ___MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab = ____MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab
    ___MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MulticastMRBs_ToBeReleased_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__id),
        ('criticality', ___MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue),
        ])
    __MulticastMRBs_ToBeReleased_Item_iE_Extensions__item_._ext = None
    _MulticastMRBs_ToBeReleased_Item_iE_Extensions._cont = __MulticastMRBs_ToBeReleased_Item_iE_Extensions__item_
    _MulticastMRBs_ToBeReleased_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MulticastMRBs_ToBeReleased_Item._cont = ASN1Dict([
        ('mRB-ID', _MulticastMRBs_ToBeReleased_Item_mRB_ID),
        ('iE-Extensions', _MulticastMRBs_ToBeReleased_Item_iE_Extensions),
        ])
    MulticastMRBs_ToBeReleased_Item._ext = []
    
    #-----< MulticastMRBs-ToBeReleased-ItemExtIEs >-----#
    MulticastMRBs_ToBeReleased_ItemExtIEs = CLASS(name='MulticastMRBs-ToBeReleased-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MulticastMRBs_ToBeReleased_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MulticastMRBs-ToBeSetup-Item >-----#
    MulticastMRBs_ToBeSetup_Item = SEQ(name='MulticastMRBs-ToBeSetup-Item', mode=MODE_TYPE)
    _MulticastMRBs_ToBeSetup_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _MulticastMRBs_ToBeSetup_Item_mRB_QoSInformation = SEQ(name='mRB-QoSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSFlowLevelQoSParameters')))
    _MulticastMRBs_ToBeSetup_Item_mBS_Flows_Mapped_To_MRB_List = SEQ_OF(name='mBS-Flows-Mapped-To-MRB-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MBS-Flows-Mapped-To-MRB-List')))
    _MulticastMRBs_ToBeSetup_Item_mBS_DL_PDCP_SN_Length = ENUM(name='mBS-DL-PDCP-SN-Length', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _MulticastMRBs_ToBeSetup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')))
    __MulticastMRBs_ToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab = ____MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality_tab
    ___MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab
    ___MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MulticastMRBs_ToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__id),
        ('criticality', ___MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __MulticastMRBs_ToBeSetup_Item_iE_Extensions__item_._ext = None
    _MulticastMRBs_ToBeSetup_Item_iE_Extensions._cont = __MulticastMRBs_ToBeSetup_Item_iE_Extensions__item_
    _MulticastMRBs_ToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MulticastMRBs_ToBeSetup_Item._cont = ASN1Dict([
        ('mRB-ID', _MulticastMRBs_ToBeSetup_Item_mRB_ID),
        ('mRB-QoSInformation', _MulticastMRBs_ToBeSetup_Item_mRB_QoSInformation),
        ('mBS-Flows-Mapped-To-MRB-List', _MulticastMRBs_ToBeSetup_Item_mBS_Flows_Mapped_To_MRB_List),
        ('mBS-DL-PDCP-SN-Length', _MulticastMRBs_ToBeSetup_Item_mBS_DL_PDCP_SN_Length),
        ('iE-Extensions', _MulticastMRBs_ToBeSetup_Item_iE_Extensions),
        ])
    MulticastMRBs_ToBeSetup_Item._ext = []
    
    #-----< MulticastMRBs-ToBeSetup-Item-ExtIEs >-----#
    MulticastMRBs_ToBeSetup_Item_ExtIEs = CLASS(name='MulticastMRBs-ToBeSetup-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MulticastMRBs_ToBeSetup_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MulticastMRBs-ToBeSetupMod-Item >-----#
    MulticastMRBs_ToBeSetupMod_Item = SEQ(name='MulticastMRBs-ToBeSetupMod-Item', mode=MODE_TYPE)
    _MulticastMRBs_ToBeSetupMod_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _MulticastMRBs_ToBeSetupMod_Item_mRB_QoSInformation = SEQ(name='mRB-QoSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSFlowLevelQoSParameters')))
    _MulticastMRBs_ToBeSetupMod_Item_mBS_Flows_Mapped_To_MRB_List = SEQ_OF(name='mBS-Flows-Mapped-To-MRB-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MBS-Flows-Mapped-To-MRB-List')))
    _MulticastMRBs_ToBeSetupMod_Item_mBS_DL_PDCP_SN_Length = ENUM(name='mBS-DL-PDCP-SN-Length', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PDCPSNLength')))
    _MulticastMRBs_ToBeSetupMod_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')))
    __MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab = ____MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab = ____MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality_tab
    ___MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__id),
        ('criticality', ___MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item_._ext = None
    _MulticastMRBs_ToBeSetupMod_Item_iE_Extensions._cont = __MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item_
    _MulticastMRBs_ToBeSetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MulticastMRBs_ToBeSetupMod_Item._cont = ASN1Dict([
        ('mRB-ID', _MulticastMRBs_ToBeSetupMod_Item_mRB_ID),
        ('mRB-QoSInformation', _MulticastMRBs_ToBeSetupMod_Item_mRB_QoSInformation),
        ('mBS-Flows-Mapped-To-MRB-List', _MulticastMRBs_ToBeSetupMod_Item_mBS_Flows_Mapped_To_MRB_List),
        ('mBS-DL-PDCP-SN-Length', _MulticastMRBs_ToBeSetupMod_Item_mBS_DL_PDCP_SN_Length),
        ('iE-Extensions', _MulticastMRBs_ToBeSetupMod_Item_iE_Extensions),
        ])
    MulticastMRBs_ToBeSetupMod_Item._ext = []
    
    #-----< MulticastMRBs-ToBeSetupMod-Item-ExtIEs >-----#
    MulticastMRBs_ToBeSetupMod_Item_ExtIEs = CLASS(name='MulticastMRBs-ToBeSetupMod-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MulticastMRBs_ToBeSetupMod_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MultiplexingInfo >-----#
    MultiplexingInfo = SEQ(name='MultiplexingInfo', mode=MODE_TYPE)
    _MultiplexingInfo_iAB_MT_Cell_List = SEQ_OF(name='iAB-MT-Cell-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IAB-MT-Cell-List')))
    _MultiplexingInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MultiplexingInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MultiplexingInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MultiplexingInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MultiplexingInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultiplexingInfo_iE_Extensions__item__id._const_tab = ____MultiplexingInfo_iE_Extensions__item__id_tab
    ___MultiplexingInfo_iE_Extensions__item__id._const_tab_at = None
    ___MultiplexingInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___MultiplexingInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MultiplexingInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MultiplexingInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultiplexingInfo_iE_Extensions__item__criticality._const_tab = ____MultiplexingInfo_iE_Extensions__item__criticality_tab
    ___MultiplexingInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MultiplexingInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MultiplexingInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MultiplexingInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MultiplexingInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultiplexingInfo_iE_Extensions__item__extensionValue._const_tab = ____MultiplexingInfo_iE_Extensions__item__extensionValue_tab
    ___MultiplexingInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MultiplexingInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MultiplexingInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MultiplexingInfo_iE_Extensions__item__id),
        ('criticality', ___MultiplexingInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___MultiplexingInfo_iE_Extensions__item__extensionValue),
        ])
    __MultiplexingInfo_iE_Extensions__item_._ext = None
    _MultiplexingInfo_iE_Extensions._cont = __MultiplexingInfo_iE_Extensions__item_
    _MultiplexingInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MultiplexingInfo._cont = ASN1Dict([
        ('iAB-MT-Cell-List', _MultiplexingInfo_iAB_MT_Cell_List),
        ('iE-Extensions', _MultiplexingInfo_iE_Extensions),
        ])
    MultiplexingInfo._ext = None
    
    #-----< MultiplexingInfo-ExtIEs >-----#
    MultiplexingInfo_ExtIEs = CLASS(name='MultiplexingInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MultiplexingInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M2Configuration >-----#
    M2Configuration = ENUM(name='M2Configuration', mode=MODE_TYPE)
    M2Configuration._cont = ASN1Dict([('true', 0)])
    M2Configuration._ext = []
    
    #-----< M5Configuration >-----#
    M5Configuration = SEQ(name='M5Configuration', mode=MODE_TYPE)
    _M5Configuration_m5period = ENUM(name='m5period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'M5period')))
    _M5Configuration_m5_links_to_log = ENUM(name='m5-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'M5-Links-to-log')))
    _M5Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M5Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___M5Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____M5Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____M5Configuration_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'M5ReportAmount')))
    ____M5Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 537), ('criticality', 'ignore'), ('Extension', _____M5Configuration_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___M5Configuration_iE_Extensions__item__id._const_tab = ____M5Configuration_iE_Extensions__item__id_tab
    ___M5Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M5Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___M5Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___M5Configuration_iE_Extensions__item__criticality._const_tab = ____M5Configuration_iE_Extensions__item__id_tab
    ___M5Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M5Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M5Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___M5Configuration_iE_Extensions__item__extensionValue._const_tab = ____M5Configuration_iE_Extensions__item__id_tab
    ___M5Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M5Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M5Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M5Configuration_iE_Extensions__item__id),
        ('criticality', ___M5Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___M5Configuration_iE_Extensions__item__extensionValue),
        ])
    __M5Configuration_iE_Extensions__item_._ext = None
    _M5Configuration_iE_Extensions._cont = __M5Configuration_iE_Extensions__item_
    _M5Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M5Configuration._cont = ASN1Dict([
        ('m5period', _M5Configuration_m5period),
        ('m5-links-to-log', _M5Configuration_m5_links_to_log),
        ('iE-Extensions', _M5Configuration_iE_Extensions),
        ])
    M5Configuration._ext = []
    
    #-----< M5Configuration-ExtIEs >-----#
    M5Configuration_ExtIEs = CLASS(name='M5Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _M5Configuration_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'M5ReportAmount')))
    M5Configuration_ExtIEs._val = ASN1Set(rv=[dict([('id', 537), ('criticality', 'ignore'), ('Extension', _M5Configuration_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< M5period >-----#
    M5period = ENUM(name='M5period', mode=MODE_TYPE)
    M5period._cont = ASN1Dict([('ms1024', 0), ('ms2048', 1), ('ms5120', 2), ('ms10240', 3), ('min1', 4)])
    M5period._ext = []
    
    #-----< M5ReportAmount >-----#
    M5ReportAmount = ENUM(name='M5ReportAmount', mode=MODE_TYPE)
    M5ReportAmount._cont = ASN1Dict([('r1', 0), ('r2', 1), ('r4', 2), ('r8', 3), ('r16', 4), ('r32', 5), ('r64', 6), ('infinity', 7)])
    M5ReportAmount._ext = []
    
    #-----< M5-Links-to-log >-----#
    M5_Links_to_log = ENUM(name='M5-Links-to-log', mode=MODE_TYPE)
    M5_Links_to_log._cont = ASN1Dict([('uplink', 0), ('downlink', 1), ('both-uplink-and-downlink', 2)])
    M5_Links_to_log._ext = []
    
    #-----< M6Configuration >-----#
    M6Configuration = SEQ(name='M6Configuration', mode=MODE_TYPE)
    _M6Configuration_m6report_Interval = ENUM(name='m6report-Interval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'M6report-Interval')))
    _M6Configuration_m6_links_to_log = ENUM(name='m6-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'M6-Links-to-log')))
    _M6Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M6Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___M6Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____M6Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____M6Configuration_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'M6ReportAmount')))
    ____M6Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 538), ('criticality', 'ignore'), ('Extension', _____M6Configuration_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___M6Configuration_iE_Extensions__item__id._const_tab = ____M6Configuration_iE_Extensions__item__id_tab
    ___M6Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M6Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___M6Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___M6Configuration_iE_Extensions__item__criticality._const_tab = ____M6Configuration_iE_Extensions__item__id_tab
    ___M6Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M6Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M6Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab = ____M6Configuration_iE_Extensions__item__id_tab
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M6Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M6Configuration_iE_Extensions__item__id),
        ('criticality', ___M6Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___M6Configuration_iE_Extensions__item__extensionValue),
        ])
    __M6Configuration_iE_Extensions__item_._ext = None
    _M6Configuration_iE_Extensions._cont = __M6Configuration_iE_Extensions__item_
    _M6Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M6Configuration._cont = ASN1Dict([
        ('m6report-Interval', _M6Configuration_m6report_Interval),
        ('m6-links-to-log', _M6Configuration_m6_links_to_log),
        ('iE-Extensions', _M6Configuration_iE_Extensions),
        ])
    M6Configuration._ext = []
    
    #-----< M6Configuration-ExtIEs >-----#
    M6Configuration_ExtIEs = CLASS(name='M6Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _M6Configuration_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'M6ReportAmount')))
    M6Configuration_ExtIEs._val = ASN1Set(rv=[dict([('id', 538), ('criticality', 'ignore'), ('Extension', _M6Configuration_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< M6report-Interval >-----#
    M6report_Interval = ENUM(name='M6report-Interval', mode=MODE_TYPE)
    M6report_Interval._cont = ASN1Dict([('ms120', 0), ('ms240', 1), ('ms640', 2), ('ms1024', 3), ('ms2048', 4), ('ms5120', 5), ('ms10240', 6), ('ms20480', 7), ('ms40960', 8), ('min1', 9), ('min6', 10), ('min12', 11), ('min30', 12), ('ms480', 13)])
    M6report_Interval._ext = ['ms480']
    
    #-----< M6ReportAmount >-----#
    M6ReportAmount = ENUM(name='M6ReportAmount', mode=MODE_TYPE)
    M6ReportAmount._cont = ASN1Dict([('r1', 0), ('r2', 1), ('r4', 2), ('r8', 3), ('r16', 4), ('r32', 5), ('r64', 6), ('infinity', 7)])
    M6ReportAmount._ext = []
    
    #-----< M6-Links-to-log >-----#
    M6_Links_to_log = ENUM(name='M6-Links-to-log', mode=MODE_TYPE)
    M6_Links_to_log._cont = ASN1Dict([('uplink', 0), ('downlink', 1), ('both-uplink-and-downlink', 2)])
    M6_Links_to_log._ext = []
    
    #-----< M7Configuration >-----#
    M7Configuration = SEQ(name='M7Configuration', mode=MODE_TYPE)
    _M7Configuration_m7period = INT(name='m7period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'M7period')))
    _M7Configuration_m7_links_to_log = ENUM(name='m7-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'M7-Links-to-log')))
    _M7Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M7Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___M7Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____M7Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____M7Configuration_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'M7ReportAmount')))
    ____M7Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 539), ('criticality', 'ignore'), ('Extension', _____M7Configuration_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___M7Configuration_iE_Extensions__item__id._const_tab = ____M7Configuration_iE_Extensions__item__id_tab
    ___M7Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M7Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___M7Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___M7Configuration_iE_Extensions__item__criticality._const_tab = ____M7Configuration_iE_Extensions__item__id_tab
    ___M7Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M7Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M7Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab = ____M7Configuration_iE_Extensions__item__id_tab
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M7Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M7Configuration_iE_Extensions__item__id),
        ('criticality', ___M7Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___M7Configuration_iE_Extensions__item__extensionValue),
        ])
    __M7Configuration_iE_Extensions__item_._ext = None
    _M7Configuration_iE_Extensions._cont = __M7Configuration_iE_Extensions__item_
    _M7Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M7Configuration._cont = ASN1Dict([
        ('m7period', _M7Configuration_m7period),
        ('m7-links-to-log', _M7Configuration_m7_links_to_log),
        ('iE-Extensions', _M7Configuration_iE_Extensions),
        ])
    M7Configuration._ext = []
    
    #-----< M7Configuration-ExtIEs >-----#
    M7Configuration_ExtIEs = CLASS(name='M7Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _M7Configuration_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'M7ReportAmount')))
    M7Configuration_ExtIEs._val = ASN1Set(rv=[dict([('id', 539), ('criticality', 'ignore'), ('Extension', _M7Configuration_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< M7period >-----#
    M7period = INT(name='M7period', mode=MODE_TYPE)
    M7period._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=60)], ev=[], er=[])
    
    #-----< M7ReportAmount >-----#
    M7ReportAmount = ENUM(name='M7ReportAmount', mode=MODE_TYPE)
    M7ReportAmount._cont = ASN1Dict([('r1', 0), ('r2', 1), ('r4', 2), ('r8', 3), ('r16', 4), ('r32', 5), ('r64', 6), ('infinity', 7)])
    M7ReportAmount._ext = []
    
    #-----< M7-Links-to-log >-----#
    M7_Links_to_log = ENUM(name='M7-Links-to-log', mode=MODE_TYPE)
    M7_Links_to_log._cont = ASN1Dict([('downlink', 0)])
    M7_Links_to_log._ext = []
    
    #-----< MDT-Activation >-----#
    MDT_Activation = ENUM(name='MDT-Activation', mode=MODE_TYPE)
    MDT_Activation._cont = ASN1Dict([('immediate-MDT-only', 0), ('immediate-MDT-and-Trace', 1)])
    MDT_Activation._ext = []
    
    #-----< MDTConfiguration >-----#
    MDTConfiguration = SEQ(name='MDTConfiguration', mode=MODE_TYPE)
    _MDTConfiguration_mdt_Activation = ENUM(name='mdt-Activation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MDT-Activation')))
    _MDTConfiguration_measurementsToActivate = BIT_STR(name='measurementsToActivate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MeasurementsToActivate')))
    _MDTConfiguration_m2Configuration = ENUM(name='m2Configuration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'M2Configuration')), opt=True)
    _MDTConfiguration_m5Configuration = SEQ(name='m5Configuration', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'M5Configuration')), opt=True)
    _MDTConfiguration_m6Configuration = SEQ(name='m6Configuration', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'M6Configuration')), opt=True)
    _MDTConfiguration_m7Configuration = SEQ(name='m7Configuration', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'M7Configuration')), opt=True)
    _MDTConfiguration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MDTConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MDTConfiguration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MDTConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MDTConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDTConfiguration_iE_Extensions__item__id._const_tab = ____MDTConfiguration_iE_Extensions__item__id_tab
    ___MDTConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___MDTConfiguration_iE_Extensions__item__id._const_tab_id = 'id'
    ___MDTConfiguration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MDTConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MDTConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDTConfiguration_iE_Extensions__item__criticality._const_tab = ____MDTConfiguration_iE_Extensions__item__criticality_tab
    ___MDTConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MDTConfiguration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MDTConfiguration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MDTConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MDTConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDTConfiguration_iE_Extensions__item__extensionValue._const_tab = ____MDTConfiguration_iE_Extensions__item__extensionValue_tab
    ___MDTConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MDTConfiguration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MDTConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MDTConfiguration_iE_Extensions__item__id),
        ('criticality', ___MDTConfiguration_iE_Extensions__item__criticality),
        ('extensionValue', ___MDTConfiguration_iE_Extensions__item__extensionValue),
        ])
    __MDTConfiguration_iE_Extensions__item_._ext = None
    _MDTConfiguration_iE_Extensions._cont = __MDTConfiguration_iE_Extensions__item_
    _MDTConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MDTConfiguration._cont = ASN1Dict([
        ('mdt-Activation', _MDTConfiguration_mdt_Activation),
        ('measurementsToActivate', _MDTConfiguration_measurementsToActivate),
        ('m2Configuration', _MDTConfiguration_m2Configuration),
        ('m5Configuration', _MDTConfiguration_m5Configuration),
        ('m6Configuration', _MDTConfiguration_m6Configuration),
        ('m7Configuration', _MDTConfiguration_m7Configuration),
        ('iE-Extensions', _MDTConfiguration_iE_Extensions),
        ])
    MDTConfiguration._ext = []
    
    #-----< MDTConfiguration-ExtIEs >-----#
    MDTConfiguration_ExtIEs = CLASS(name='MDTConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MDTConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MDTPLMNList >-----#
    MDTPLMNList = SEQ_OF(name='MDTPLMNList', mode=MODE_TYPE)
    _MDTPLMNList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    MDTPLMNList._cont = _MDTPLMNList__item_
    MDTPLMNList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< MDTPLMNModificationList >-----#
    MDTPLMNModificationList = SEQ_OF(name='MDTPLMNModificationList', mode=MODE_TYPE)
    _MDTPLMNModificationList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    MDTPLMNModificationList._cont = _MDTPLMNModificationList__item_
    MDTPLMNModificationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< MeasuredResultsValue >-----#
    MeasuredResultsValue = CHOICE(name='MeasuredResultsValue', mode=MODE_TYPE)
    _MeasuredResultsValue_uL_AngleOfArrival = SEQ(name='uL-AngleOfArrival', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UL-AoA')))
    _MeasuredResultsValue_uL_SRS_RSRP = INT(name='uL-SRS-RSRP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UL-SRS-RSRP')))
    _MeasuredResultsValue_uL_RTOA = SEQ(name='uL-RTOA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UL-RTOA-Measurement')))
    _MeasuredResultsValue_gNB_RxTxTimeDiff = SEQ(name='gNB-RxTxTimeDiff', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-RxTxTimeDiff')))
    _MeasuredResultsValue_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __MeasuredResultsValue_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___MeasuredResultsValue_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____MeasuredResultsValue_choice_extension_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ZoAInformation')))
    ____MeasuredResultsValue_choice_extension_id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MultipleULAoA')))
    ____MeasuredResultsValue_choice_extension_id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-SRS-RSRPP')))
    ___MeasuredResultsValue_choice_extension_id_tab._val = ASN1Set(rv=[dict([('id', 554), ('criticality', 'reject'), ('Value', ____MeasuredResultsValue_choice_extension_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 558), ('criticality', 'reject'), ('Value', ____MeasuredResultsValue_choice_extension_id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 559), ('criticality', 'reject'), ('Value', ____MeasuredResultsValue_choice_extension_id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __MeasuredResultsValue_choice_extension_id._const_tab = ___MeasuredResultsValue_choice_extension_id_tab
    __MeasuredResultsValue_choice_extension_id._const_tab_at = None
    __MeasuredResultsValue_choice_extension_id._const_tab_id = 'id'
    __MeasuredResultsValue_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __MeasuredResultsValue_choice_extension_criticality._const_tab = ___MeasuredResultsValue_choice_extension_id_tab
    __MeasuredResultsValue_choice_extension_criticality._const_tab_at = ('..', 'id')
    __MeasuredResultsValue_choice_extension_criticality._const_tab_id = 'criticality'
    __MeasuredResultsValue_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __MeasuredResultsValue_choice_extension_value._const_tab = ___MeasuredResultsValue_choice_extension_id_tab
    __MeasuredResultsValue_choice_extension_value._const_tab_at = ('..', 'id')
    __MeasuredResultsValue_choice_extension_value._const_tab_id = 'Value'
    _MeasuredResultsValue_choice_extension._cont = ASN1Dict([
        ('id', __MeasuredResultsValue_choice_extension_id),
        ('criticality', __MeasuredResultsValue_choice_extension_criticality),
        ('value', __MeasuredResultsValue_choice_extension_value),
        ])
    _MeasuredResultsValue_choice_extension._ext = None
    MeasuredResultsValue._cont = ASN1Dict([
        ('uL-AngleOfArrival', _MeasuredResultsValue_uL_AngleOfArrival),
        ('uL-SRS-RSRP', _MeasuredResultsValue_uL_SRS_RSRP),
        ('uL-RTOA', _MeasuredResultsValue_uL_RTOA),
        ('gNB-RxTxTimeDiff', _MeasuredResultsValue_gNB_RxTxTimeDiff),
        ('choice-extension', _MeasuredResultsValue_choice_extension),
        ])
    MeasuredResultsValue._ext = None
    
    #-----< MeasuredResultsValue-ExtIEs >-----#
    MeasuredResultsValue_ExtIEs = CLASS(name='MeasuredResultsValue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MeasuredResultsValue_ExtIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ZoAInformation')))
    _MeasuredResultsValue_ExtIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MultipleULAoA')))
    _MeasuredResultsValue_ExtIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-SRS-RSRPP')))
    MeasuredResultsValue_ExtIEs._val = ASN1Set(rv=[dict([('id', 554), ('criticality', 'reject'), ('Value', _MeasuredResultsValue_ExtIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 558), ('criticality', 'reject'), ('Value', _MeasuredResultsValue_ExtIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 559), ('criticality', 'reject'), ('Value', _MeasuredResultsValue_ExtIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MeasurementsToActivate >-----#
    MeasurementsToActivate = BIT_STR(name='MeasurementsToActivate', mode=MODE_TYPE)
    MeasurementsToActivate._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< MUSIM-GapConfig >-----#
    MUSIM_GapConfig = OCT_STR(name='MUSIM-GapConfig', mode=MODE_TYPE)
    
    #-----< NA-Resource-Configuration-List >-----#
    NA_Resource_Configuration_List = SEQ_OF(name='NA-Resource-Configuration-List', mode=MODE_TYPE)
    _NA_Resource_Configuration_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NA-Resource-Configuration-Item')))
    NA_Resource_Configuration_List._cont = _NA_Resource_Configuration_List__item_
    NA_Resource_Configuration_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5120)], ev=None, er=[])
    
    #-----< NA-Resource-Configuration-Item >-----#
    NA_Resource_Configuration_Item = SEQ(name='NA-Resource-Configuration-Item', mode=MODE_TYPE)
    _NA_Resource_Configuration_Item_nADownlink = ENUM(name='nADownlink', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NADownlink')), opt=True)
    _NA_Resource_Configuration_Item_nAUplink = ENUM(name='nAUplink', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NAUplink')), opt=True)
    _NA_Resource_Configuration_Item_nAFlexible = ENUM(name='nAFlexible', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NAFlexible')), opt=True)
    _NA_Resource_Configuration_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NA_Resource_Configuration_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NA_Resource_Configuration_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NA_Resource_Configuration_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NA_Resource_Configuration_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NA_Resource_Configuration_Item_iE_Extensions__item__id._const_tab = ____NA_Resource_Configuration_Item_iE_Extensions__item__id_tab
    ___NA_Resource_Configuration_Item_iE_Extensions__item__id._const_tab_at = None
    ___NA_Resource_Configuration_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___NA_Resource_Configuration_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NA_Resource_Configuration_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NA_Resource_Configuration_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NA_Resource_Configuration_Item_iE_Extensions__item__criticality._const_tab = ____NA_Resource_Configuration_Item_iE_Extensions__item__criticality_tab
    ___NA_Resource_Configuration_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NA_Resource_Configuration_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NA_Resource_Configuration_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NA_Resource_Configuration_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NA_Resource_Configuration_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NA_Resource_Configuration_Item_iE_Extensions__item__extensionValue._const_tab = ____NA_Resource_Configuration_Item_iE_Extensions__item__extensionValue_tab
    ___NA_Resource_Configuration_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NA_Resource_Configuration_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NA_Resource_Configuration_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NA_Resource_Configuration_Item_iE_Extensions__item__id),
        ('criticality', ___NA_Resource_Configuration_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___NA_Resource_Configuration_Item_iE_Extensions__item__extensionValue),
        ])
    __NA_Resource_Configuration_Item_iE_Extensions__item_._ext = None
    _NA_Resource_Configuration_Item_iE_Extensions._cont = __NA_Resource_Configuration_Item_iE_Extensions__item_
    _NA_Resource_Configuration_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NA_Resource_Configuration_Item._cont = ASN1Dict([
        ('nADownlink', _NA_Resource_Configuration_Item_nADownlink),
        ('nAUplink', _NA_Resource_Configuration_Item_nAUplink),
        ('nAFlexible', _NA_Resource_Configuration_Item_nAFlexible),
        ('iE-Extensions', _NA_Resource_Configuration_Item_iE_Extensions),
        ])
    NA_Resource_Configuration_Item._ext = None
    
    #-----< NA-Resource-Configuration-Item-ExtIEs >-----#
    NA_Resource_Configuration_Item_ExtIEs = CLASS(name='NA-Resource-Configuration-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NA_Resource_Configuration_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NADownlink >-----#
    NADownlink = ENUM(name='NADownlink', mode=MODE_TYPE)
    NADownlink._cont = ASN1Dict([('true', 0), ('false', 1)])
    NADownlink._ext = []
    
    #-----< NAFlexible >-----#
    NAFlexible = ENUM(name='NAFlexible', mode=MODE_TYPE)
    NAFlexible._cont = ASN1Dict([('true', 0), ('false', 1)])
    NAFlexible._ext = []
    
    #-----< NAUplink >-----#
    NAUplink = ENUM(name='NAUplink', mode=MODE_TYPE)
    NAUplink._cont = ASN1Dict([('true', 0), ('false', 1)])
    NAUplink._ext = []
    
    #-----< Neighbour-Node-Cells-List >-----#
    Neighbour_Node_Cells_List = SEQ_OF(name='Neighbour-Node-Cells-List', mode=MODE_TYPE)
    _Neighbour_Node_Cells_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Neighbour-Node-Cells-List-Item')))
    Neighbour_Node_Cells_List._cont = _Neighbour_Node_Cells_List__item_
    Neighbour_Node_Cells_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< Neighbour-Node-Cells-List-Item >-----#
    Neighbour_Node_Cells_List_Item = SEQ(name='Neighbour-Node-Cells-List-Item', mode=MODE_TYPE)
    _Neighbour_Node_Cells_List_Item_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Neighbour_Node_Cells_List_Item_gNB_CU_UE_F1AP_ID = INT(name='gNB-CU-UE-F1AP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')), opt=True)
    _Neighbour_Node_Cells_List_Item_gNB_DU_UE_F1AP_ID = INT(name='gNB-DU-UE-F1AP-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')), opt=True)
    _Neighbour_Node_Cells_List_Item_peer_Parent_Node_Indicator = ENUM(name='peer-Parent-Node-Indicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Neighbour_Node_Cells_List_Item_peer_Parent_Node_Indicator._cont = ASN1Dict([('true', 0)])
    _Neighbour_Node_Cells_List_Item_peer_Parent_Node_Indicator._ext = []
    _Neighbour_Node_Cells_List_Item_iAB_DU_Cell_Resource_Configuration_Mode_Info = CHOICE(name='iAB-DU-Cell-Resource-Configuration-Mode-Info', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IAB-DU-Cell-Resource-Configuration-Mode-Info')), opt=True)
    _Neighbour_Node_Cells_List_Item_iAB_STC_Info = SEQ(name='iAB-STC-Info', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IAB-STC-Info')), opt=True)
    _Neighbour_Node_Cells_List_Item_rACH_Config_Common = OCT_STR(name='rACH-Config-Common', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RACH-Config-Common')), opt=True)
    _Neighbour_Node_Cells_List_Item_rACH_Config_Common_IAB = OCT_STR(name='rACH-Config-Common-IAB', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RACH-Config-Common-IAB')), opt=True)
    _Neighbour_Node_Cells_List_Item_cSI_RS_Configuration = OCT_STR(name='cSI-RS-Configuration', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Neighbour_Node_Cells_List_Item_sR_Configuration = OCT_STR(name='sR-Configuration', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Neighbour_Node_Cells_List_Item_pDCCH_ConfigSIB1 = OCT_STR(name='pDCCH-ConfigSIB1', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Neighbour_Node_Cells_List_Item_sCS_Common = OCT_STR(name='sCS-Common', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Neighbour_Node_Cells_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Neighbour_Node_Cells_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Neighbour_Node_Cells_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Neighbour_Node_Cells_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Neighbour_Node_Cells_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Neighbour_Node_Cells_List_Item_iE_Extensions__item__id._const_tab = ____Neighbour_Node_Cells_List_Item_iE_Extensions__item__id_tab
    ___Neighbour_Node_Cells_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___Neighbour_Node_Cells_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Neighbour_Node_Cells_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Neighbour_Node_Cells_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Neighbour_Node_Cells_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Neighbour_Node_Cells_List_Item_iE_Extensions__item__criticality._const_tab = ____Neighbour_Node_Cells_List_Item_iE_Extensions__item__criticality_tab
    ___Neighbour_Node_Cells_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Neighbour_Node_Cells_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Neighbour_Node_Cells_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Neighbour_Node_Cells_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Neighbour_Node_Cells_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Neighbour_Node_Cells_List_Item_iE_Extensions__item__extensionValue._const_tab = ____Neighbour_Node_Cells_List_Item_iE_Extensions__item__extensionValue_tab
    ___Neighbour_Node_Cells_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Neighbour_Node_Cells_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Neighbour_Node_Cells_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Neighbour_Node_Cells_List_Item_iE_Extensions__item__id),
        ('criticality', ___Neighbour_Node_Cells_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Neighbour_Node_Cells_List_Item_iE_Extensions__item__extensionValue),
        ])
    __Neighbour_Node_Cells_List_Item_iE_Extensions__item_._ext = None
    _Neighbour_Node_Cells_List_Item_iE_Extensions._cont = __Neighbour_Node_Cells_List_Item_iE_Extensions__item_
    _Neighbour_Node_Cells_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Neighbour_Node_Cells_List_Item._cont = ASN1Dict([
        ('nRCGI', _Neighbour_Node_Cells_List_Item_nRCGI),
        ('gNB-CU-UE-F1AP-ID', _Neighbour_Node_Cells_List_Item_gNB_CU_UE_F1AP_ID),
        ('gNB-DU-UE-F1AP-ID', _Neighbour_Node_Cells_List_Item_gNB_DU_UE_F1AP_ID),
        ('peer-Parent-Node-Indicator', _Neighbour_Node_Cells_List_Item_peer_Parent_Node_Indicator),
        ('iAB-DU-Cell-Resource-Configuration-Mode-Info', _Neighbour_Node_Cells_List_Item_iAB_DU_Cell_Resource_Configuration_Mode_Info),
        ('iAB-STC-Info', _Neighbour_Node_Cells_List_Item_iAB_STC_Info),
        ('rACH-Config-Common', _Neighbour_Node_Cells_List_Item_rACH_Config_Common),
        ('rACH-Config-Common-IAB', _Neighbour_Node_Cells_List_Item_rACH_Config_Common_IAB),
        ('cSI-RS-Configuration', _Neighbour_Node_Cells_List_Item_cSI_RS_Configuration),
        ('sR-Configuration', _Neighbour_Node_Cells_List_Item_sR_Configuration),
        ('pDCCH-ConfigSIB1', _Neighbour_Node_Cells_List_Item_pDCCH_ConfigSIB1),
        ('sCS-Common', _Neighbour_Node_Cells_List_Item_sCS_Common),
        ('iE-Extensions', _Neighbour_Node_Cells_List_Item_iE_Extensions),
        ])
    Neighbour_Node_Cells_List_Item._ext = None
    
    #-----< Neighbour-Node-Cells-List-Item-ExtIEs >-----#
    Neighbour_Node_Cells_List_Item_ExtIEs = CLASS(name='Neighbour-Node-Cells-List-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Neighbour_Node_Cells_List_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NeedforGap >-----#
    NeedforGap = ENUM(name='NeedforGap', mode=MODE_TYPE)
    NeedforGap._cont = ASN1Dict([('true', 0)])
    NeedforGap._ext = []
    
    #-----< NeedForGapsInfoNR >-----#
    NeedForGapsInfoNR = OCT_STR(name='NeedForGapsInfoNR', mode=MODE_TYPE)
    
    #-----< NeedForGapNCSGInfoNR >-----#
    NeedForGapNCSGInfoNR = OCT_STR(name='NeedForGapNCSGInfoNR', mode=MODE_TYPE)
    
    #-----< NeedForGapNCSGInfoEUTRA >-----#
    NeedForGapNCSGInfoEUTRA = OCT_STR(name='NeedForGapNCSGInfoEUTRA', mode=MODE_TYPE)
    
    #-----< Neighbour-Cell-Information-Item >-----#
    Neighbour_Cell_Information_Item = SEQ(name='Neighbour-Cell-Information-Item', mode=MODE_TYPE)
    _Neighbour_Cell_Information_Item_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Neighbour_Cell_Information_Item_intendedTDD_DL_ULConfig = SEQ(name='intendedTDD-DL-ULConfig', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IntendedTDD-DL-ULConfig')), opt=True)
    _Neighbour_Cell_Information_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Neighbour_Cell_Information_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Neighbour_Cell_Information_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Neighbour_Cell_Information_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Neighbour_Cell_Information_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Neighbour_Cell_Information_Item_iE_Extensions__item__id._const_tab = ____Neighbour_Cell_Information_Item_iE_Extensions__item__id_tab
    ___Neighbour_Cell_Information_Item_iE_Extensions__item__id._const_tab_at = None
    ___Neighbour_Cell_Information_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Neighbour_Cell_Information_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Neighbour_Cell_Information_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Neighbour_Cell_Information_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Neighbour_Cell_Information_Item_iE_Extensions__item__criticality._const_tab = ____Neighbour_Cell_Information_Item_iE_Extensions__item__criticality_tab
    ___Neighbour_Cell_Information_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Neighbour_Cell_Information_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Neighbour_Cell_Information_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Neighbour_Cell_Information_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Neighbour_Cell_Information_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Neighbour_Cell_Information_Item_iE_Extensions__item__extensionValue._const_tab = ____Neighbour_Cell_Information_Item_iE_Extensions__item__extensionValue_tab
    ___Neighbour_Cell_Information_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Neighbour_Cell_Information_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Neighbour_Cell_Information_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Neighbour_Cell_Information_Item_iE_Extensions__item__id),
        ('criticality', ___Neighbour_Cell_Information_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Neighbour_Cell_Information_Item_iE_Extensions__item__extensionValue),
        ])
    __Neighbour_Cell_Information_Item_iE_Extensions__item_._ext = None
    _Neighbour_Cell_Information_Item_iE_Extensions._cont = __Neighbour_Cell_Information_Item_iE_Extensions__item_
    _Neighbour_Cell_Information_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Neighbour_Cell_Information_Item._cont = ASN1Dict([
        ('nRCGI', _Neighbour_Cell_Information_Item_nRCGI),
        ('intendedTDD-DL-ULConfig', _Neighbour_Cell_Information_Item_intendedTDD_DL_ULConfig),
        ('iE-Extensions', _Neighbour_Cell_Information_Item_iE_Extensions),
        ])
    Neighbour_Cell_Information_Item._ext = None
    
    #-----< Neighbour-Cell-Information-ItemExtIEs >-----#
    Neighbour_Cell_Information_ItemExtIEs = CLASS(name='Neighbour-Cell-Information-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Neighbour_Cell_Information_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NeighbourNR-CellsForSON-List >-----#
    NeighbourNR_CellsForSON_List = SEQ_OF(name='NeighbourNR-CellsForSON-List', mode=MODE_TYPE)
    _NeighbourNR_CellsForSON_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NeighbourNR-CellsForSON-Item')))
    NeighbourNR_CellsForSON_List._cont = _NeighbourNR_CellsForSON_List__item_
    NeighbourNR_CellsForSON_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< NeighbourNR-CellsForSON-Item >-----#
    NeighbourNR_CellsForSON_Item = SEQ(name='NeighbourNR-CellsForSON-Item', mode=MODE_TYPE)
    _NeighbourNR_CellsForSON_Item_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _NeighbourNR_CellsForSON_Item_nR_ModeInfoRel16 = CHOICE(name='nR-ModeInfoRel16', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NR-ModeInfoRel16')), opt=True)
    _NeighbourNR_CellsForSON_Item_sSB_PositionsInBurst = CHOICE(name='sSB-PositionsInBurst', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB-PositionsInBurst')), opt=True)
    _NeighbourNR_CellsForSON_Item_nRPRACHConfig = SEQ(name='nRPRACHConfig', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRPRACHConfig')), opt=True)
    _NeighbourNR_CellsForSON_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NeighbourNR_CellsForSON_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NeighbourNR_CellsForSON_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NeighbourNR_CellsForSON_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NeighbourNR_CellsForSON_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbourNR_CellsForSON_Item_iE_Extensions__item__id._const_tab = ____NeighbourNR_CellsForSON_Item_iE_Extensions__item__id_tab
    ___NeighbourNR_CellsForSON_Item_iE_Extensions__item__id._const_tab_at = None
    ___NeighbourNR_CellsForSON_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___NeighbourNR_CellsForSON_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NeighbourNR_CellsForSON_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NeighbourNR_CellsForSON_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbourNR_CellsForSON_Item_iE_Extensions__item__criticality._const_tab = ____NeighbourNR_CellsForSON_Item_iE_Extensions__item__criticality_tab
    ___NeighbourNR_CellsForSON_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NeighbourNR_CellsForSON_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NeighbourNR_CellsForSON_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NeighbourNR_CellsForSON_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NeighbourNR_CellsForSON_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbourNR_CellsForSON_Item_iE_Extensions__item__extensionValue._const_tab = ____NeighbourNR_CellsForSON_Item_iE_Extensions__item__extensionValue_tab
    ___NeighbourNR_CellsForSON_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NeighbourNR_CellsForSON_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NeighbourNR_CellsForSON_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NeighbourNR_CellsForSON_Item_iE_Extensions__item__id),
        ('criticality', ___NeighbourNR_CellsForSON_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___NeighbourNR_CellsForSON_Item_iE_Extensions__item__extensionValue),
        ])
    __NeighbourNR_CellsForSON_Item_iE_Extensions__item_._ext = None
    _NeighbourNR_CellsForSON_Item_iE_Extensions._cont = __NeighbourNR_CellsForSON_Item_iE_Extensions__item_
    _NeighbourNR_CellsForSON_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NeighbourNR_CellsForSON_Item._cont = ASN1Dict([
        ('nRCGI', _NeighbourNR_CellsForSON_Item_nRCGI),
        ('nR-ModeInfoRel16', _NeighbourNR_CellsForSON_Item_nR_ModeInfoRel16),
        ('sSB-PositionsInBurst', _NeighbourNR_CellsForSON_Item_sSB_PositionsInBurst),
        ('nRPRACHConfig', _NeighbourNR_CellsForSON_Item_nRPRACHConfig),
        ('iE-Extensions', _NeighbourNR_CellsForSON_Item_iE_Extensions),
        ])
    NeighbourNR_CellsForSON_Item._ext = []
    
    #-----< NeighbourNR-CellsForSON-Item-ExtIEs >-----#
    NeighbourNR_CellsForSON_Item_ExtIEs = CLASS(name='NeighbourNR-CellsForSON-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NeighbourNR_CellsForSON_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NGRANAllocationAndRetentionPriority >-----#
    NGRANAllocationAndRetentionPriority = SEQ(name='NGRANAllocationAndRetentionPriority', mode=MODE_TYPE)
    _NGRANAllocationAndRetentionPriority_priorityLevel = INT(name='priorityLevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PriorityLevel')))
    _NGRANAllocationAndRetentionPriority_pre_emptionCapability = ENUM(name='pre-emptionCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Pre-emptionCapability')))
    _NGRANAllocationAndRetentionPriority_pre_emptionVulnerability = ENUM(name='pre-emptionVulnerability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Pre-emptionVulnerability')))
    _NGRANAllocationAndRetentionPriority_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NGRANAllocationAndRetentionPriority_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__id._const_tab = ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__id_tab
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_at = None
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_id = 'id'
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab = ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality_tab
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab = ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NGRANAllocationAndRetentionPriority_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__id),
        ('criticality', ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality),
        ('extensionValue', ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue),
        ])
    __NGRANAllocationAndRetentionPriority_iE_Extensions__item_._ext = None
    _NGRANAllocationAndRetentionPriority_iE_Extensions._cont = __NGRANAllocationAndRetentionPriority_iE_Extensions__item_
    _NGRANAllocationAndRetentionPriority_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NGRANAllocationAndRetentionPriority._cont = ASN1Dict([
        ('priorityLevel', _NGRANAllocationAndRetentionPriority_priorityLevel),
        ('pre-emptionCapability', _NGRANAllocationAndRetentionPriority_pre_emptionCapability),
        ('pre-emptionVulnerability', _NGRANAllocationAndRetentionPriority_pre_emptionVulnerability),
        ('iE-Extensions', _NGRANAllocationAndRetentionPriority_iE_Extensions),
        ])
    NGRANAllocationAndRetentionPriority._ext = None
    
    #-----< NGRANAllocationAndRetentionPriority-ExtIEs >-----#
    NGRANAllocationAndRetentionPriority_ExtIEs = CLASS(name='NGRANAllocationAndRetentionPriority-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NGRANAllocationAndRetentionPriority_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NGRANHighAccuracyAccessPointPosition >-----#
    NGRANHighAccuracyAccessPointPosition = SEQ(name='NGRANHighAccuracyAccessPointPosition', mode=MODE_TYPE)
    _NGRANHighAccuracyAccessPointPosition_latitude = INT(name='latitude', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_latitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_longitude = INT(name='longitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_longitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_altitude = INT(name='altitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_altitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-64000, ub=1280000)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_major = INT(name='uncertaintySemi-major', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_major._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_minor = INT(name='uncertaintySemi-minor', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_minor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_orientationOfMajorAxis = INT(name='orientationOfMajorAxis', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_orientationOfMajorAxis._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_horizontalConfidence = INT(name='horizontalConfidence', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_horizontalConfidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_uncertaintyAltitude = INT(name='uncertaintyAltitude', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_uncertaintyAltitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_verticalConfidence = INT(name='verticalConfidence', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_verticalConfidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NGRANHighAccuracyAccessPointPosition_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id._const_tab = ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id_tab
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id._const_tab_at = None
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id._const_tab_id = 'id'
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality._const_tab = ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality_tab
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue._const_tab = ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue_tab
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NGRANHighAccuracyAccessPointPosition_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id),
        ('criticality', ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality),
        ('extensionValue', ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue),
        ])
    __NGRANHighAccuracyAccessPointPosition_iE_Extensions__item_._ext = None
    _NGRANHighAccuracyAccessPointPosition_iE_Extensions._cont = __NGRANHighAccuracyAccessPointPosition_iE_Extensions__item_
    _NGRANHighAccuracyAccessPointPosition_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NGRANHighAccuracyAccessPointPosition._cont = ASN1Dict([
        ('latitude', _NGRANHighAccuracyAccessPointPosition_latitude),
        ('longitude', _NGRANHighAccuracyAccessPointPosition_longitude),
        ('altitude', _NGRANHighAccuracyAccessPointPosition_altitude),
        ('uncertaintySemi-major', _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_major),
        ('uncertaintySemi-minor', _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_minor),
        ('orientationOfMajorAxis', _NGRANHighAccuracyAccessPointPosition_orientationOfMajorAxis),
        ('horizontalConfidence', _NGRANHighAccuracyAccessPointPosition_horizontalConfidence),
        ('uncertaintyAltitude', _NGRANHighAccuracyAccessPointPosition_uncertaintyAltitude),
        ('verticalConfidence', _NGRANHighAccuracyAccessPointPosition_verticalConfidence),
        ('iE-Extensions', _NGRANHighAccuracyAccessPointPosition_iE_Extensions),
        ])
    NGRANHighAccuracyAccessPointPosition._ext = None
    
    #-----< NGRANHighAccuracyAccessPointPosition-ExtIEs >-----#
    NGRANHighAccuracyAccessPointPosition_ExtIEs = CLASS(name='NGRANHighAccuracyAccessPointPosition-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NGRANHighAccuracyAccessPointPosition_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NID >-----#
    NID = BIT_STR(name='NID', mode=MODE_TYPE)
    NID._const_sz = ASN1Set(rv=[44], rr=[], ev=None, er=[])
    
    #-----< NonF1terminatingTopologyIndicator >-----#
    NonF1terminatingTopologyIndicator = ENUM(name='NonF1terminatingTopologyIndicator', mode=MODE_TYPE)
    NonF1terminatingTopologyIndicator._cont = ASN1Dict([('true', 0)])
    NonF1terminatingTopologyIndicator._ext = []
    
    #-----< NR-CGI-List-For-Restart-Item >-----#
    NR_CGI_List_For_Restart_Item = SEQ(name='NR-CGI-List-For-Restart-Item', mode=MODE_TYPE)
    _NR_CGI_List_For_Restart_Item_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _NR_CGI_List_For_Restart_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NR_CGI_List_For_Restart_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NR_CGI_List_For_Restart_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NR_CGI_List_For_Restart_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__id._const_tab = ____NR_CGI_List_For_Restart_Item_iE_Extensions__item__id_tab
    ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__id._const_tab_at = None
    ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NR_CGI_List_For_Restart_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NR_CGI_List_For_Restart_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__criticality._const_tab = ____NR_CGI_List_For_Restart_Item_iE_Extensions__item__criticality_tab
    ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NR_CGI_List_For_Restart_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NR_CGI_List_For_Restart_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__extensionValue._const_tab = ____NR_CGI_List_For_Restart_Item_iE_Extensions__item__extensionValue_tab
    ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NR_CGI_List_For_Restart_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__id),
        ('criticality', ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__extensionValue),
        ])
    __NR_CGI_List_For_Restart_Item_iE_Extensions__item_._ext = None
    _NR_CGI_List_For_Restart_Item_iE_Extensions._cont = __NR_CGI_List_For_Restart_Item_iE_Extensions__item_
    _NR_CGI_List_For_Restart_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NR_CGI_List_For_Restart_Item._cont = ASN1Dict([
        ('nRCGI', _NR_CGI_List_For_Restart_Item_nRCGI),
        ('iE-Extensions', _NR_CGI_List_For_Restart_Item_iE_Extensions),
        ])
    NR_CGI_List_For_Restart_Item._ext = []
    
    #-----< NR-CGI-List-For-Restart-ItemExtIEs >-----#
    NR_CGI_List_For_Restart_ItemExtIEs = CLASS(name='NR-CGI-List-For-Restart-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NR_CGI_List_For_Restart_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NR-PRSBeamInformation >-----#
    NR_PRSBeamInformation = SEQ(name='NR-PRSBeamInformation', mode=MODE_TYPE)
    _NR_PRSBeamInformation_nR_PRSBeamInformationList = SEQ_OF(name='nR-PRSBeamInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NR-PRSBeamInformationList')))
    _NR_PRSBeamInformation_lCStoGCSTranslationList = SEQ_OF(name='lCStoGCSTranslationList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LCStoGCSTranslationList')), opt=True)
    _NR_PRSBeamInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NR_PRSBeamInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NR_PRSBeamInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NR_PRSBeamInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NR_PRSBeamInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PRSBeamInformation_iE_Extensions__item__id._const_tab = ____NR_PRSBeamInformation_iE_Extensions__item__id_tab
    ___NR_PRSBeamInformation_iE_Extensions__item__id._const_tab_at = None
    ___NR_PRSBeamInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___NR_PRSBeamInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NR_PRSBeamInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NR_PRSBeamInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PRSBeamInformation_iE_Extensions__item__criticality._const_tab = ____NR_PRSBeamInformation_iE_Extensions__item__criticality_tab
    ___NR_PRSBeamInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NR_PRSBeamInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NR_PRSBeamInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NR_PRSBeamInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NR_PRSBeamInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PRSBeamInformation_iE_Extensions__item__extensionValue._const_tab = ____NR_PRSBeamInformation_iE_Extensions__item__extensionValue_tab
    ___NR_PRSBeamInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NR_PRSBeamInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NR_PRSBeamInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NR_PRSBeamInformation_iE_Extensions__item__id),
        ('criticality', ___NR_PRSBeamInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___NR_PRSBeamInformation_iE_Extensions__item__extensionValue),
        ])
    __NR_PRSBeamInformation_iE_Extensions__item_._ext = None
    _NR_PRSBeamInformation_iE_Extensions._cont = __NR_PRSBeamInformation_iE_Extensions__item_
    _NR_PRSBeamInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NR_PRSBeamInformation._cont = ASN1Dict([
        ('nR-PRSBeamInformationList', _NR_PRSBeamInformation_nR_PRSBeamInformationList),
        ('lCStoGCSTranslationList', _NR_PRSBeamInformation_lCStoGCSTranslationList),
        ('iE-Extensions', _NR_PRSBeamInformation_iE_Extensions),
        ])
    NR_PRSBeamInformation._ext = None
    
    #-----< NR-PRSBeamInformation-ExtIEs >-----#
    NR_PRSBeamInformation_ExtIEs = CLASS(name='NR-PRSBeamInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NR_PRSBeamInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NR-PRSBeamInformationList >-----#
    NR_PRSBeamInformationList = SEQ_OF(name='NR-PRSBeamInformationList', mode=MODE_TYPE)
    _NR_PRSBeamInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NR-PRSBeamInformationItem')))
    NR_PRSBeamInformationList._cont = _NR_PRSBeamInformationList__item_
    NR_PRSBeamInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< NR-PRSBeamInformationItem >-----#
    NR_PRSBeamInformationItem = SEQ(name='NR-PRSBeamInformationItem', mode=MODE_TYPE)
    _NR_PRSBeamInformationItem_pRSResourceSetID = INT(name='pRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-Set-ID')))
    _NR_PRSBeamInformationItem_pRSAngleList = SEQ_OF(name='pRSAngleList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSAngleList')))
    _NR_PRSBeamInformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NR_PRSBeamInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NR_PRSBeamInformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NR_PRSBeamInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NR_PRSBeamInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PRSBeamInformationItem_iE_Extensions__item__id._const_tab = ____NR_PRSBeamInformationItem_iE_Extensions__item__id_tab
    ___NR_PRSBeamInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___NR_PRSBeamInformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___NR_PRSBeamInformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NR_PRSBeamInformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NR_PRSBeamInformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PRSBeamInformationItem_iE_Extensions__item__criticality._const_tab = ____NR_PRSBeamInformationItem_iE_Extensions__item__criticality_tab
    ___NR_PRSBeamInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NR_PRSBeamInformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NR_PRSBeamInformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NR_PRSBeamInformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NR_PRSBeamInformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PRSBeamInformationItem_iE_Extensions__item__extensionValue._const_tab = ____NR_PRSBeamInformationItem_iE_Extensions__item__extensionValue_tab
    ___NR_PRSBeamInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NR_PRSBeamInformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NR_PRSBeamInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NR_PRSBeamInformationItem_iE_Extensions__item__id),
        ('criticality', ___NR_PRSBeamInformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___NR_PRSBeamInformationItem_iE_Extensions__item__extensionValue),
        ])
    __NR_PRSBeamInformationItem_iE_Extensions__item_._ext = None
    _NR_PRSBeamInformationItem_iE_Extensions._cont = __NR_PRSBeamInformationItem_iE_Extensions__item_
    _NR_PRSBeamInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NR_PRSBeamInformationItem._cont = ASN1Dict([
        ('pRSResourceSetID', _NR_PRSBeamInformationItem_pRSResourceSetID),
        ('pRSAngleList', _NR_PRSBeamInformationItem_pRSAngleList),
        ('iE-Extensions', _NR_PRSBeamInformationItem_iE_Extensions),
        ])
    NR_PRSBeamInformationItem._ext = None
    
    #-----< NR-PRSBeamInformationItem-ExtIEs >-----#
    NR_PRSBeamInformationItem_ExtIEs = CLASS(name='NR-PRSBeamInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NR_PRSBeamInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NR-TADV >-----#
    NR_TADV = INT(name='NR-TADV', mode=MODE_TYPE)
    NR_TADV._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7690)], ev=None, er=[])
    
    #-----< NRRedCapUEIndication >-----#
    NRRedCapUEIndication = ENUM(name='NRRedCapUEIndication', mode=MODE_TYPE)
    NRRedCapUEIndication._cont = ASN1Dict([('true', 0)])
    NRRedCapUEIndication._ext = []
    
    #-----< NRPagingeDRXInformation >-----#
    NRPagingeDRXInformation = SEQ(name='NRPagingeDRXInformation', mode=MODE_TYPE)
    _NRPagingeDRXInformation_nrpaging_eDRX_Cycle_Idle = ENUM(name='nrpaging-eDRX-Cycle-Idle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRPaging-eDRX-Cycle-Idle')))
    _NRPagingeDRXInformation_nrpaging_Time_Window = ENUM(name='nrpaging-Time-Window', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRPaging-Time-Window')), opt=True)
    _NRPagingeDRXInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRPagingeDRXInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NRPagingeDRXInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NRPagingeDRXInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRPagingeDRXInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRPagingeDRXInformation_iE_Extensions__item__id._const_tab = ____NRPagingeDRXInformation_iE_Extensions__item__id_tab
    ___NRPagingeDRXInformation_iE_Extensions__item__id._const_tab_at = None
    ___NRPagingeDRXInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___NRPagingeDRXInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRPagingeDRXInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRPagingeDRXInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRPagingeDRXInformation_iE_Extensions__item__criticality._const_tab = ____NRPagingeDRXInformation_iE_Extensions__item__criticality_tab
    ___NRPagingeDRXInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NRPagingeDRXInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NRPagingeDRXInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRPagingeDRXInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRPagingeDRXInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRPagingeDRXInformation_iE_Extensions__item__extensionValue._const_tab = ____NRPagingeDRXInformation_iE_Extensions__item__extensionValue_tab
    ___NRPagingeDRXInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRPagingeDRXInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NRPagingeDRXInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NRPagingeDRXInformation_iE_Extensions__item__id),
        ('criticality', ___NRPagingeDRXInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___NRPagingeDRXInformation_iE_Extensions__item__extensionValue),
        ])
    __NRPagingeDRXInformation_iE_Extensions__item_._ext = None
    _NRPagingeDRXInformation_iE_Extensions._cont = __NRPagingeDRXInformation_iE_Extensions__item_
    _NRPagingeDRXInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRPagingeDRXInformation._cont = ASN1Dict([
        ('nrpaging-eDRX-Cycle-Idle', _NRPagingeDRXInformation_nrpaging_eDRX_Cycle_Idle),
        ('nrpaging-Time-Window', _NRPagingeDRXInformation_nrpaging_Time_Window),
        ('iE-Extensions', _NRPagingeDRXInformation_iE_Extensions),
        ])
    NRPagingeDRXInformation._ext = []
    
    #-----< NRPagingeDRXInformation-ExtIEs >-----#
    NRPagingeDRXInformation_ExtIEs = CLASS(name='NRPagingeDRXInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NRPagingeDRXInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRPaging-eDRX-Cycle-Idle >-----#
    NRPaging_eDRX_Cycle_Idle = ENUM(name='NRPaging-eDRX-Cycle-Idle', mode=MODE_TYPE)
    NRPaging_eDRX_Cycle_Idle._cont = ASN1Dict([('hfquarter', 0), ('hfhalf', 1), ('hf1', 2), ('hf2', 3), ('hf4', 4), ('hf8', 5), ('hf16', 6), ('hf32', 7), ('hf64', 8), ('hf128', 9), ('hf256', 10), ('hf512', 11), ('hf1024', 12)])
    NRPaging_eDRX_Cycle_Idle._ext = []
    
    #-----< NRPaging-Time-Window >-----#
    NRPaging_Time_Window = ENUM(name='NRPaging-Time-Window', mode=MODE_TYPE)
    NRPaging_Time_Window._cont = ASN1Dict([('s1', 0), ('s2', 1), ('s3', 2), ('s4', 3), ('s5', 4), ('s6', 5), ('s7', 6), ('s8', 7), ('s9', 8), ('s10', 9), ('s11', 10), ('s12', 11), ('s13', 12), ('s14', 13), ('s15', 14), ('s16', 15), ('s17', 16), ('s18', 17), ('s19', 18), ('s20', 19), ('s21', 20), ('s22', 21), ('s23', 22), ('s24', 23), ('s25', 24), ('s26', 25), ('s27', 26), ('s28', 27), ('s29', 28), ('s30', 29), ('s31', 30), ('s32', 31)])
    NRPaging_Time_Window._ext = ['s17', 's18', 's19', 's20', 's21', 's22', 's23', 's24', 's25', 's26', 's27', 's28', 's29', 's30', 's31', 's32']
    
    #-----< NRPagingeDRXInformationforRRCINACTIVE >-----#
    NRPagingeDRXInformationforRRCINACTIVE = SEQ(name='NRPagingeDRXInformationforRRCINACTIVE', mode=MODE_TYPE)
    _NRPagingeDRXInformationforRRCINACTIVE_nrpaging_eDRX_Cycle_Inactive = ENUM(name='nrpaging-eDRX-Cycle-Inactive', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRPaging-eDRX-Cycle-Inactive')))
    _NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__id._const_tab = ____NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__id_tab
    ___NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__id._const_tab_at = None
    ___NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__id._const_tab_id = 'id'
    ___NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__criticality._const_tab = ____NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__criticality_tab
    ___NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__extensionValue._const_tab = ____NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__extensionValue_tab
    ___NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__id),
        ('criticality', ___NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__criticality),
        ('extensionValue', ___NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__extensionValue),
        ])
    __NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item_._ext = None
    _NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions._cont = __NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item_
    _NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRPagingeDRXInformationforRRCINACTIVE._cont = ASN1Dict([
        ('nrpaging-eDRX-Cycle-Inactive', _NRPagingeDRXInformationforRRCINACTIVE_nrpaging_eDRX_Cycle_Inactive),
        ('iE-Extensions', _NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions),
        ])
    NRPagingeDRXInformationforRRCINACTIVE._ext = []
    
    #-----< NRPagingeDRXInformationforRRCINACTIVE-ExtIEs >-----#
    NRPagingeDRXInformationforRRCINACTIVE_ExtIEs = CLASS(name='NRPagingeDRXInformationforRRCINACTIVE-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NRPagingeDRXInformationforRRCINACTIVE_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRPaging-eDRX-Cycle-Inactive >-----#
    NRPaging_eDRX_Cycle_Inactive = ENUM(name='NRPaging-eDRX-Cycle-Inactive', mode=MODE_TYPE)
    NRPaging_eDRX_Cycle_Inactive._cont = ASN1Dict([('hfquarter', 0), ('hfhalf', 1), ('hf1', 2)])
    NRPaging_eDRX_Cycle_Inactive._ext = []
    
    #-----< NonDynamic5QIDescriptor >-----#
    NonDynamic5QIDescriptor = SEQ(name='NonDynamic5QIDescriptor', mode=MODE_TYPE)
    _NonDynamic5QIDescriptor_fiveQI = INT(name='fiveQI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NonDynamic5QIDescriptor_fiveQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    _NonDynamic5QIDescriptor_qoSPriorityLevel = INT(name='qoSPriorityLevel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NonDynamic5QIDescriptor_qoSPriorityLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _NonDynamic5QIDescriptor_averagingWindow = INT(name='averagingWindow', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AveragingWindow')), opt=True)
    _NonDynamic5QIDescriptor_maxDataBurstVolume = INT(name='maxDataBurstVolume', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MaxDataBurstVolume')), opt=True)
    _NonDynamic5QIDescriptor_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NonDynamic5QIDescriptor_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NonDynamic5QIDescriptor_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedPacketDelayBudget')))
    _____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedPacketDelayBudget')))
    ____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 362), ('criticality', 'ignore'), ('Extension', _____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 369), ('criticality', 'ignore'), ('Extension', _____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___NonDynamic5QIDescriptor_iE_Extensions__item__id._const_tab = ____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___NonDynamic5QIDescriptor_iE_Extensions__item__id._const_tab_at = None
    ___NonDynamic5QIDescriptor_iE_Extensions__item__id._const_tab_id = 'id'
    ___NonDynamic5QIDescriptor_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___NonDynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab = ____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___NonDynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NonDynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NonDynamic5QIDescriptor_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___NonDynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab = ____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___NonDynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NonDynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NonDynamic5QIDescriptor_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NonDynamic5QIDescriptor_iE_Extensions__item__id),
        ('criticality', ___NonDynamic5QIDescriptor_iE_Extensions__item__criticality),
        ('extensionValue', ___NonDynamic5QIDescriptor_iE_Extensions__item__extensionValue),
        ])
    __NonDynamic5QIDescriptor_iE_Extensions__item_._ext = None
    _NonDynamic5QIDescriptor_iE_Extensions._cont = __NonDynamic5QIDescriptor_iE_Extensions__item_
    _NonDynamic5QIDescriptor_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NonDynamic5QIDescriptor._cont = ASN1Dict([
        ('fiveQI', _NonDynamic5QIDescriptor_fiveQI),
        ('qoSPriorityLevel', _NonDynamic5QIDescriptor_qoSPriorityLevel),
        ('averagingWindow', _NonDynamic5QIDescriptor_averagingWindow),
        ('maxDataBurstVolume', _NonDynamic5QIDescriptor_maxDataBurstVolume),
        ('iE-Extensions', _NonDynamic5QIDescriptor_iE_Extensions),
        ])
    NonDynamic5QIDescriptor._ext = None
    
    #-----< NonDynamic5QIDescriptor-ExtIEs >-----#
    NonDynamic5QIDescriptor_ExtIEs = CLASS(name='NonDynamic5QIDescriptor-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _NonDynamic5QIDescriptor_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedPacketDelayBudget')))
    _NonDynamic5QIDescriptor_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedPacketDelayBudget')))
    NonDynamic5QIDescriptor_ExtIEs._val = ASN1Set(rv=[dict([('id', 362), ('criticality', 'ignore'), ('Extension', _NonDynamic5QIDescriptor_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 369), ('criticality', 'ignore'), ('Extension', _NonDynamic5QIDescriptor_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< NonDynamicPQIDescriptor >-----#
    NonDynamicPQIDescriptor = SEQ(name='NonDynamicPQIDescriptor', mode=MODE_TYPE)
    _NonDynamicPQIDescriptor_fiveQI = INT(name='fiveQI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NonDynamicPQIDescriptor_fiveQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    _NonDynamicPQIDescriptor_qoSPriorityLevel = INT(name='qoSPriorityLevel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NonDynamicPQIDescriptor_qoSPriorityLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=[], er=[])
    _NonDynamicPQIDescriptor_averagingWindow = INT(name='averagingWindow', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AveragingWindow')), opt=True)
    _NonDynamicPQIDescriptor_maxDataBurstVolume = INT(name='maxDataBurstVolume', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MaxDataBurstVolume')), opt=True)
    _NonDynamicPQIDescriptor_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NonDynamicPQIDescriptor_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NonDynamicPQIDescriptor_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NonDynamicPQIDescriptor_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NonDynamicPQIDescriptor_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NonDynamicPQIDescriptor_iE_Extensions__item__id._const_tab = ____NonDynamicPQIDescriptor_iE_Extensions__item__id_tab
    ___NonDynamicPQIDescriptor_iE_Extensions__item__id._const_tab_at = None
    ___NonDynamicPQIDescriptor_iE_Extensions__item__id._const_tab_id = 'id'
    ___NonDynamicPQIDescriptor_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NonDynamicPQIDescriptor_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NonDynamicPQIDescriptor_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NonDynamicPQIDescriptor_iE_Extensions__item__criticality._const_tab = ____NonDynamicPQIDescriptor_iE_Extensions__item__criticality_tab
    ___NonDynamicPQIDescriptor_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NonDynamicPQIDescriptor_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NonDynamicPQIDescriptor_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NonDynamicPQIDescriptor_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NonDynamicPQIDescriptor_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NonDynamicPQIDescriptor_iE_Extensions__item__extensionValue._const_tab = ____NonDynamicPQIDescriptor_iE_Extensions__item__extensionValue_tab
    ___NonDynamicPQIDescriptor_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NonDynamicPQIDescriptor_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NonDynamicPQIDescriptor_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NonDynamicPQIDescriptor_iE_Extensions__item__id),
        ('criticality', ___NonDynamicPQIDescriptor_iE_Extensions__item__criticality),
        ('extensionValue', ___NonDynamicPQIDescriptor_iE_Extensions__item__extensionValue),
        ])
    __NonDynamicPQIDescriptor_iE_Extensions__item_._ext = None
    _NonDynamicPQIDescriptor_iE_Extensions._cont = __NonDynamicPQIDescriptor_iE_Extensions__item_
    _NonDynamicPQIDescriptor_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NonDynamicPQIDescriptor._cont = ASN1Dict([
        ('fiveQI', _NonDynamicPQIDescriptor_fiveQI),
        ('qoSPriorityLevel', _NonDynamicPQIDescriptor_qoSPriorityLevel),
        ('averagingWindow', _NonDynamicPQIDescriptor_averagingWindow),
        ('maxDataBurstVolume', _NonDynamicPQIDescriptor_maxDataBurstVolume),
        ('iE-Extensions', _NonDynamicPQIDescriptor_iE_Extensions),
        ])
    NonDynamicPQIDescriptor._ext = None
    
    #-----< NonDynamicPQIDescriptor-ExtIEs >-----#
    NonDynamicPQIDescriptor_ExtIEs = CLASS(name='NonDynamicPQIDescriptor-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NonDynamicPQIDescriptor_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NonUPTrafficType >-----#
    NonUPTrafficType = ENUM(name='NonUPTrafficType', mode=MODE_TYPE)
    NonUPTrafficType._cont = ASN1Dict([('ue-associated', 0), ('non-ue-associated', 1), ('non-f1', 2), ('bap-control-pdu', 3)])
    NonUPTrafficType._ext = []
    
    #-----< NoofDownlinkSymbols >-----#
    NoofDownlinkSymbols = INT(name='NoofDownlinkSymbols', mode=MODE_TYPE)
    NoofDownlinkSymbols._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=14)], ev=None, er=[])
    
    #-----< NoofUplinkSymbols >-----#
    NoofUplinkSymbols = INT(name='NoofUplinkSymbols', mode=MODE_TYPE)
    NoofUplinkSymbols._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=14)], ev=None, er=[])
    
    #-----< Notification-Cause >-----#
    Notification_Cause = ENUM(name='Notification-Cause', mode=MODE_TYPE)
    Notification_Cause._cont = ASN1Dict([('fulfilled', 0), ('not-fulfilled', 1)])
    Notification_Cause._ext = []
    
    #-----< NotificationControl >-----#
    NotificationControl = ENUM(name='NotificationControl', mode=MODE_TYPE)
    NotificationControl._cont = ASN1Dict([('active', 0), ('not-active', 1)])
    NotificationControl._ext = []
    
    #-----< NotificationInformation >-----#
    NotificationInformation = SEQ(name='NotificationInformation', mode=MODE_TYPE)
    _NotificationInformation_message_Identifier = BIT_STR(name='message-Identifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MessageIdentifier')))
    _NotificationInformation_serialNumber = BIT_STR(name='serialNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SerialNumber')))
    _NotificationInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NotificationInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NotificationInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NotificationInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NotificationInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NotificationInformation_iE_Extensions__item__id._const_tab = ____NotificationInformation_iE_Extensions__item__id_tab
    ___NotificationInformation_iE_Extensions__item__id._const_tab_at = None
    ___NotificationInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___NotificationInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NotificationInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NotificationInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NotificationInformation_iE_Extensions__item__criticality._const_tab = ____NotificationInformation_iE_Extensions__item__criticality_tab
    ___NotificationInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NotificationInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NotificationInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NotificationInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NotificationInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NotificationInformation_iE_Extensions__item__extensionValue._const_tab = ____NotificationInformation_iE_Extensions__item__extensionValue_tab
    ___NotificationInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NotificationInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NotificationInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NotificationInformation_iE_Extensions__item__id),
        ('criticality', ___NotificationInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___NotificationInformation_iE_Extensions__item__extensionValue),
        ])
    __NotificationInformation_iE_Extensions__item_._ext = None
    _NotificationInformation_iE_Extensions._cont = __NotificationInformation_iE_Extensions__item_
    _NotificationInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NotificationInformation._cont = ASN1Dict([
        ('message-Identifier', _NotificationInformation_message_Identifier),
        ('serialNumber', _NotificationInformation_serialNumber),
        ('iE-Extensions', _NotificationInformation_iE_Extensions),
        ])
    NotificationInformation._ext = []
    
    #-----< NotificationInformationExtIEs >-----#
    NotificationInformationExtIEs = CLASS(name='NotificationInformationExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NotificationInformationExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NPNBroadcastInformation >-----#
    NPNBroadcastInformation = CHOICE(name='NPNBroadcastInformation', mode=MODE_TYPE)
    _NPNBroadcastInformation_sNPN_Broadcast_Information = SEQ(name='sNPN-Broadcast-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NPN-Broadcast-Information-SNPN')))
    _NPNBroadcastInformation_pNI_NPN_Broadcast_Information = SEQ(name='pNI-NPN-Broadcast-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NPN-Broadcast-Information-PNI-NPN')))
    _NPNBroadcastInformation_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __NPNBroadcastInformation_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___NPNBroadcastInformation_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___NPNBroadcastInformation_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPNBroadcastInformation_choice_extension_id._const_tab = ___NPNBroadcastInformation_choice_extension_id_tab
    __NPNBroadcastInformation_choice_extension_id._const_tab_at = None
    __NPNBroadcastInformation_choice_extension_id._const_tab_id = 'id'
    __NPNBroadcastInformation_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___NPNBroadcastInformation_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___NPNBroadcastInformation_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPNBroadcastInformation_choice_extension_criticality._const_tab = ___NPNBroadcastInformation_choice_extension_criticality_tab
    __NPNBroadcastInformation_choice_extension_criticality._const_tab_at = ('..', 'id')
    __NPNBroadcastInformation_choice_extension_criticality._const_tab_id = 'criticality'
    __NPNBroadcastInformation_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___NPNBroadcastInformation_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___NPNBroadcastInformation_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPNBroadcastInformation_choice_extension_value._const_tab = ___NPNBroadcastInformation_choice_extension_value_tab
    __NPNBroadcastInformation_choice_extension_value._const_tab_at = ('..', 'id')
    __NPNBroadcastInformation_choice_extension_value._const_tab_id = 'Value'
    _NPNBroadcastInformation_choice_extension._cont = ASN1Dict([
        ('id', __NPNBroadcastInformation_choice_extension_id),
        ('criticality', __NPNBroadcastInformation_choice_extension_criticality),
        ('value', __NPNBroadcastInformation_choice_extension_value),
        ])
    _NPNBroadcastInformation_choice_extension._ext = None
    NPNBroadcastInformation._cont = ASN1Dict([
        ('sNPN-Broadcast-Information', _NPNBroadcastInformation_sNPN_Broadcast_Information),
        ('pNI-NPN-Broadcast-Information', _NPNBroadcastInformation_pNI_NPN_Broadcast_Information),
        ('choice-extension', _NPNBroadcastInformation_choice_extension),
        ])
    NPNBroadcastInformation._ext = None
    
    #-----< NPNBroadcastInformation-ExtIEs >-----#
    NPNBroadcastInformation_ExtIEs = CLASS(name='NPNBroadcastInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    NPNBroadcastInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NPN-Broadcast-Information-SNPN >-----#
    NPN_Broadcast_Information_SNPN = SEQ(name='NPN-Broadcast-Information-SNPN', mode=MODE_TYPE)
    _NPN_Broadcast_Information_SNPN_broadcastSNPNID_List = SEQ_OF(name='broadcastSNPNID-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BroadcastSNPN-ID-List')))
    _NPN_Broadcast_Information_SNPN_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NPN_Broadcast_Information_SNPN_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NPN_Broadcast_Information_SNPN_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NPN_Broadcast_Information_SNPN_iE_Extension__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NPN_Broadcast_Information_SNPN_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPN_Broadcast_Information_SNPN_iE_Extension__item__id._const_tab = ____NPN_Broadcast_Information_SNPN_iE_Extension__item__id_tab
    ___NPN_Broadcast_Information_SNPN_iE_Extension__item__id._const_tab_at = None
    ___NPN_Broadcast_Information_SNPN_iE_Extension__item__id._const_tab_id = 'id'
    ___NPN_Broadcast_Information_SNPN_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NPN_Broadcast_Information_SNPN_iE_Extension__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NPN_Broadcast_Information_SNPN_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPN_Broadcast_Information_SNPN_iE_Extension__item__criticality._const_tab = ____NPN_Broadcast_Information_SNPN_iE_Extension__item__criticality_tab
    ___NPN_Broadcast_Information_SNPN_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___NPN_Broadcast_Information_SNPN_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___NPN_Broadcast_Information_SNPN_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NPN_Broadcast_Information_SNPN_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NPN_Broadcast_Information_SNPN_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPN_Broadcast_Information_SNPN_iE_Extension__item__extensionValue._const_tab = ____NPN_Broadcast_Information_SNPN_iE_Extension__item__extensionValue_tab
    ___NPN_Broadcast_Information_SNPN_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___NPN_Broadcast_Information_SNPN_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __NPN_Broadcast_Information_SNPN_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___NPN_Broadcast_Information_SNPN_iE_Extension__item__id),
        ('criticality', ___NPN_Broadcast_Information_SNPN_iE_Extension__item__criticality),
        ('extensionValue', ___NPN_Broadcast_Information_SNPN_iE_Extension__item__extensionValue),
        ])
    __NPN_Broadcast_Information_SNPN_iE_Extension__item_._ext = None
    _NPN_Broadcast_Information_SNPN_iE_Extension._cont = __NPN_Broadcast_Information_SNPN_iE_Extension__item_
    _NPN_Broadcast_Information_SNPN_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NPN_Broadcast_Information_SNPN._cont = ASN1Dict([
        ('broadcastSNPNID-List', _NPN_Broadcast_Information_SNPN_broadcastSNPNID_List),
        ('iE-Extension', _NPN_Broadcast_Information_SNPN_iE_Extension),
        ])
    NPN_Broadcast_Information_SNPN._ext = []
    
    #-----< NPN-Broadcast-Information-SNPN-ExtIEs >-----#
    NPN_Broadcast_Information_SNPN_ExtIEs = CLASS(name='NPN-Broadcast-Information-SNPN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NPN_Broadcast_Information_SNPN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NPN-Broadcast-Information-PNI-NPN >-----#
    NPN_Broadcast_Information_PNI_NPN = SEQ(name='NPN-Broadcast-Information-PNI-NPN', mode=MODE_TYPE)
    _NPN_Broadcast_Information_PNI_NPN_broadcastPNI_NPN_ID_Information = SEQ_OF(name='broadcastPNI-NPN-ID-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BroadcastPNI-NPN-ID-List')))
    _NPN_Broadcast_Information_PNI_NPN_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NPN_Broadcast_Information_PNI_NPN_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__id._const_tab = ____NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__id_tab
    ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__id._const_tab_at = None
    ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__id._const_tab_id = 'id'
    ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__criticality._const_tab = ____NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__criticality_tab
    ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__extensionValue._const_tab = ____NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__extensionValue_tab
    ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __NPN_Broadcast_Information_PNI_NPN_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__id),
        ('criticality', ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__criticality),
        ('extensionValue', ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__extensionValue),
        ])
    __NPN_Broadcast_Information_PNI_NPN_iE_Extension__item_._ext = None
    _NPN_Broadcast_Information_PNI_NPN_iE_Extension._cont = __NPN_Broadcast_Information_PNI_NPN_iE_Extension__item_
    _NPN_Broadcast_Information_PNI_NPN_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NPN_Broadcast_Information_PNI_NPN._cont = ASN1Dict([
        ('broadcastPNI-NPN-ID-Information', _NPN_Broadcast_Information_PNI_NPN_broadcastPNI_NPN_ID_Information),
        ('iE-Extension', _NPN_Broadcast_Information_PNI_NPN_iE_Extension),
        ])
    NPN_Broadcast_Information_PNI_NPN._ext = []
    
    #-----< NPN-Broadcast-Information-PNI-NPN-ExtIEs >-----#
    NPN_Broadcast_Information_PNI_NPN_ExtIEs = CLASS(name='NPN-Broadcast-Information-PNI-NPN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NPN_Broadcast_Information_PNI_NPN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NPNSupportInfo >-----#
    NPNSupportInfo = CHOICE(name='NPNSupportInfo', mode=MODE_TYPE)
    _NPNSupportInfo_sNPN_Information = BIT_STR(name='sNPN-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NID')))
    _NPNSupportInfo_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __NPNSupportInfo_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___NPNSupportInfo_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___NPNSupportInfo_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPNSupportInfo_choice_extension_id._const_tab = ___NPNSupportInfo_choice_extension_id_tab
    __NPNSupportInfo_choice_extension_id._const_tab_at = None
    __NPNSupportInfo_choice_extension_id._const_tab_id = 'id'
    __NPNSupportInfo_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___NPNSupportInfo_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___NPNSupportInfo_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPNSupportInfo_choice_extension_criticality._const_tab = ___NPNSupportInfo_choice_extension_criticality_tab
    __NPNSupportInfo_choice_extension_criticality._const_tab_at = ('..', 'id')
    __NPNSupportInfo_choice_extension_criticality._const_tab_id = 'criticality'
    __NPNSupportInfo_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___NPNSupportInfo_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___NPNSupportInfo_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPNSupportInfo_choice_extension_value._const_tab = ___NPNSupportInfo_choice_extension_value_tab
    __NPNSupportInfo_choice_extension_value._const_tab_at = ('..', 'id')
    __NPNSupportInfo_choice_extension_value._const_tab_id = 'Value'
    _NPNSupportInfo_choice_extension._cont = ASN1Dict([
        ('id', __NPNSupportInfo_choice_extension_id),
        ('criticality', __NPNSupportInfo_choice_extension_criticality),
        ('value', __NPNSupportInfo_choice_extension_value),
        ])
    _NPNSupportInfo_choice_extension._ext = None
    NPNSupportInfo._cont = ASN1Dict([
        ('sNPN-Information', _NPNSupportInfo_sNPN_Information),
        ('choice-extension', _NPNSupportInfo_choice_extension),
        ])
    NPNSupportInfo._ext = None
    
    #-----< NPNSupportInfo-ExtIEs >-----#
    NPNSupportInfo_ExtIEs = CLASS(name='NPNSupportInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    NPNSupportInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRCarrierList >-----#
    NRCarrierList = SEQ_OF(name='NRCarrierList', mode=MODE_TYPE)
    _NRCarrierList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierItem')))
    NRCarrierList._cont = _NRCarrierList__item_
    NRCarrierList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< NRCarrierItem >-----#
    NRCarrierItem = SEQ(name='NRCarrierItem', mode=MODE_TYPE)
    _NRCarrierItem_carrierSCS = ENUM(name='carrierSCS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRSCS')))
    _NRCarrierItem_offsetToCarrier = INT(name='offsetToCarrier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NRCarrierItem_offsetToCarrier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2199)], ev=[], er=[])
    _NRCarrierItem_carrierBandwidth = INT(name='carrierBandwidth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NRCarrierItem_carrierBandwidth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=275)], ev=[], er=[])
    _NRCarrierItem_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRCarrierItem_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NRCarrierItem_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NRCarrierItem_iE_Extension__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRCarrierItem_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCarrierItem_iE_Extension__item__id._const_tab = ____NRCarrierItem_iE_Extension__item__id_tab
    ___NRCarrierItem_iE_Extension__item__id._const_tab_at = None
    ___NRCarrierItem_iE_Extension__item__id._const_tab_id = 'id'
    ___NRCarrierItem_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRCarrierItem_iE_Extension__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRCarrierItem_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCarrierItem_iE_Extension__item__criticality._const_tab = ____NRCarrierItem_iE_Extension__item__criticality_tab
    ___NRCarrierItem_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___NRCarrierItem_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___NRCarrierItem_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRCarrierItem_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRCarrierItem_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCarrierItem_iE_Extension__item__extensionValue._const_tab = ____NRCarrierItem_iE_Extension__item__extensionValue_tab
    ___NRCarrierItem_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRCarrierItem_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __NRCarrierItem_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___NRCarrierItem_iE_Extension__item__id),
        ('criticality', ___NRCarrierItem_iE_Extension__item__criticality),
        ('extensionValue', ___NRCarrierItem_iE_Extension__item__extensionValue),
        ])
    __NRCarrierItem_iE_Extension__item_._ext = None
    _NRCarrierItem_iE_Extension._cont = __NRCarrierItem_iE_Extension__item_
    _NRCarrierItem_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRCarrierItem._cont = ASN1Dict([
        ('carrierSCS', _NRCarrierItem_carrierSCS),
        ('offsetToCarrier', _NRCarrierItem_offsetToCarrier),
        ('carrierBandwidth', _NRCarrierItem_carrierBandwidth),
        ('iE-Extension', _NRCarrierItem_iE_Extension),
        ])
    NRCarrierItem._ext = []
    
    #-----< NRCarrierItem-ExtIEs >-----#
    NRCarrierItem_ExtIEs = CLASS(name='NRCarrierItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NRCarrierItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRFreqInfo >-----#
    NRFreqInfo = SEQ(name='NRFreqInfo', mode=MODE_TYPE)
    _NRFreqInfo_nRARFCN = INT(name='nRARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NRFreqInfo_nRARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _NRFreqInfo_sul_Information = SEQ(name='sul-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SUL-Information')), opt=True)
    _NRFreqInfo_freqBandListNr = SEQ_OF(name='freqBandListNr', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NRFreqInfo_freqBandListNr__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FreqBandNrItem')))
    _NRFreqInfo_freqBandListNr._cont = __NRFreqInfo_freqBandListNr__item_
    _NRFreqInfo_freqBandListNr._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _NRFreqInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRFreqInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NRFreqInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NRFreqInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____NRFreqInfo_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FrequencyShift7p5khz')))
    ____NRFreqInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 356), ('criticality', 'ignore'), ('Extension', _____NRFreqInfo_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___NRFreqInfo_iE_Extensions__item__id._const_tab = ____NRFreqInfo_iE_Extensions__item__id_tab
    ___NRFreqInfo_iE_Extensions__item__id._const_tab_at = None
    ___NRFreqInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___NRFreqInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___NRFreqInfo_iE_Extensions__item__criticality._const_tab = ____NRFreqInfo_iE_Extensions__item__id_tab
    ___NRFreqInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NRFreqInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NRFreqInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___NRFreqInfo_iE_Extensions__item__extensionValue._const_tab = ____NRFreqInfo_iE_Extensions__item__id_tab
    ___NRFreqInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRFreqInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NRFreqInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NRFreqInfo_iE_Extensions__item__id),
        ('criticality', ___NRFreqInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___NRFreqInfo_iE_Extensions__item__extensionValue),
        ])
    __NRFreqInfo_iE_Extensions__item_._ext = None
    _NRFreqInfo_iE_Extensions._cont = __NRFreqInfo_iE_Extensions__item_
    _NRFreqInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRFreqInfo._cont = ASN1Dict([
        ('nRARFCN', _NRFreqInfo_nRARFCN),
        ('sul-Information', _NRFreqInfo_sul_Information),
        ('freqBandListNr', _NRFreqInfo_freqBandListNr),
        ('iE-Extensions', _NRFreqInfo_iE_Extensions),
        ])
    NRFreqInfo._ext = []
    
    #-----< NRFreqInfoExtIEs >-----#
    NRFreqInfoExtIEs = CLASS(name='NRFreqInfoExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _NRFreqInfoExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FrequencyShift7p5khz')))
    NRFreqInfoExtIEs._val = ASN1Set(rv=[dict([('id', 356), ('criticality', 'ignore'), ('Extension', _NRFreqInfoExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< NRCGI >-----#
    NRCGI = SEQ(name='NRCGI', mode=MODE_TYPE)
    _NRCGI_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _NRCGI_nRCellIdentity = BIT_STR(name='nRCellIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCellIdentity')))
    _NRCGI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRCGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NRCGI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NRCGI_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRCGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCGI_iE_Extensions__item__id._const_tab = ____NRCGI_iE_Extensions__item__id_tab
    ___NRCGI_iE_Extensions__item__id._const_tab_at = None
    ___NRCGI_iE_Extensions__item__id._const_tab_id = 'id'
    ___NRCGI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRCGI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRCGI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCGI_iE_Extensions__item__criticality._const_tab = ____NRCGI_iE_Extensions__item__criticality_tab
    ___NRCGI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NRCGI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NRCGI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRCGI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRCGI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCGI_iE_Extensions__item__extensionValue._const_tab = ____NRCGI_iE_Extensions__item__extensionValue_tab
    ___NRCGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRCGI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NRCGI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NRCGI_iE_Extensions__item__id),
        ('criticality', ___NRCGI_iE_Extensions__item__criticality),
        ('extensionValue', ___NRCGI_iE_Extensions__item__extensionValue),
        ])
    __NRCGI_iE_Extensions__item_._ext = None
    _NRCGI_iE_Extensions._cont = __NRCGI_iE_Extensions__item_
    _NRCGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRCGI._cont = ASN1Dict([
        ('pLMN-Identity', _NRCGI_pLMN_Identity),
        ('nRCellIdentity', _NRCGI_nRCellIdentity),
        ('iE-Extensions', _NRCGI_iE_Extensions),
        ])
    NRCGI._ext = []
    
    #-----< NRCGI-ExtIEs >-----#
    NRCGI_ExtIEs = CLASS(name='NRCGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NRCGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NR-Mode-Info >-----#
    NR_Mode_Info = CHOICE(name='NR-Mode-Info', mode=MODE_TYPE)
    _NR_Mode_Info_fDD = SEQ(name='fDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FDD-Info')))
    _NR_Mode_Info_tDD = SEQ(name='tDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TDD-Info')))
    _NR_Mode_Info_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __NR_Mode_Info_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___NR_Mode_Info_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____NR_Mode_Info_choice_extension_id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NR-U-Channel-Info-List')))
    ___NR_Mode_Info_choice_extension_id_tab._val = ASN1Set(rv=[dict([('id', 445), ('criticality', 'ignore'), ('Value', ____NR_Mode_Info_choice_extension_id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    __NR_Mode_Info_choice_extension_id._const_tab = ___NR_Mode_Info_choice_extension_id_tab
    __NR_Mode_Info_choice_extension_id._const_tab_at = None
    __NR_Mode_Info_choice_extension_id._const_tab_id = 'id'
    __NR_Mode_Info_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __NR_Mode_Info_choice_extension_criticality._const_tab = ___NR_Mode_Info_choice_extension_id_tab
    __NR_Mode_Info_choice_extension_criticality._const_tab_at = ('..', 'id')
    __NR_Mode_Info_choice_extension_criticality._const_tab_id = 'criticality'
    __NR_Mode_Info_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __NR_Mode_Info_choice_extension_value._const_tab = ___NR_Mode_Info_choice_extension_id_tab
    __NR_Mode_Info_choice_extension_value._const_tab_at = ('..', 'id')
    __NR_Mode_Info_choice_extension_value._const_tab_id = 'Value'
    _NR_Mode_Info_choice_extension._cont = ASN1Dict([
        ('id', __NR_Mode_Info_choice_extension_id),
        ('criticality', __NR_Mode_Info_choice_extension_criticality),
        ('value', __NR_Mode_Info_choice_extension_value),
        ])
    _NR_Mode_Info_choice_extension._ext = None
    NR_Mode_Info._cont = ASN1Dict([
        ('fDD', _NR_Mode_Info_fDD),
        ('tDD', _NR_Mode_Info_tDD),
        ('choice-extension', _NR_Mode_Info_choice_extension),
        ])
    NR_Mode_Info._ext = None
    
    #-----< NR-Mode-Info-ExtIEs >-----#
    NR_Mode_Info_ExtIEs = CLASS(name='NR-Mode-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _NR_Mode_Info_ExtIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NR-U-Channel-Info-List')))
    NR_Mode_Info_ExtIEs._val = ASN1Set(rv=[dict([('id', 445), ('criticality', 'ignore'), ('Value', _NR_Mode_Info_ExtIEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< NR-ModeInfoRel16 >-----#
    NR_ModeInfoRel16 = CHOICE(name='NR-ModeInfoRel16', mode=MODE_TYPE)
    _NR_ModeInfoRel16_fDD = SEQ(name='fDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FDD-InfoRel16')))
    _NR_ModeInfoRel16_tDD = SEQ(name='tDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TDD-InfoRel16')))
    _NR_ModeInfoRel16_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __NR_ModeInfoRel16_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___NR_ModeInfoRel16_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___NR_ModeInfoRel16_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NR_ModeInfoRel16_choice_extension_id._const_tab = ___NR_ModeInfoRel16_choice_extension_id_tab
    __NR_ModeInfoRel16_choice_extension_id._const_tab_at = None
    __NR_ModeInfoRel16_choice_extension_id._const_tab_id = 'id'
    __NR_ModeInfoRel16_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___NR_ModeInfoRel16_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___NR_ModeInfoRel16_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NR_ModeInfoRel16_choice_extension_criticality._const_tab = ___NR_ModeInfoRel16_choice_extension_criticality_tab
    __NR_ModeInfoRel16_choice_extension_criticality._const_tab_at = ('..', 'id')
    __NR_ModeInfoRel16_choice_extension_criticality._const_tab_id = 'criticality'
    __NR_ModeInfoRel16_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___NR_ModeInfoRel16_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___NR_ModeInfoRel16_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NR_ModeInfoRel16_choice_extension_value._const_tab = ___NR_ModeInfoRel16_choice_extension_value_tab
    __NR_ModeInfoRel16_choice_extension_value._const_tab_at = ('..', 'id')
    __NR_ModeInfoRel16_choice_extension_value._const_tab_id = 'Value'
    _NR_ModeInfoRel16_choice_extension._cont = ASN1Dict([
        ('id', __NR_ModeInfoRel16_choice_extension_id),
        ('criticality', __NR_ModeInfoRel16_choice_extension_criticality),
        ('value', __NR_ModeInfoRel16_choice_extension_value),
        ])
    _NR_ModeInfoRel16_choice_extension._ext = None
    NR_ModeInfoRel16._cont = ASN1Dict([
        ('fDD', _NR_ModeInfoRel16_fDD),
        ('tDD', _NR_ModeInfoRel16_tDD),
        ('choice-extension', _NR_ModeInfoRel16_choice_extension),
        ])
    NR_ModeInfoRel16._ext = None
    
    #-----< NR-ModeInfoRel16-ExtIEs >-----#
    NR_ModeInfoRel16_ExtIEs = CLASS(name='NR-ModeInfoRel16-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    NR_ModeInfoRel16_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRPRACHConfig >-----#
    NRPRACHConfig = SEQ(name='NRPRACHConfig', mode=MODE_TYPE)
    _NRPRACHConfig_ulPRACHConfigList = SEQ_OF(name='ulPRACHConfigList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRPRACHConfigList')), opt=True)
    _NRPRACHConfig_sulPRACHConfigList = SEQ_OF(name='sulPRACHConfigList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRPRACHConfigList')), opt=True)
    _NRPRACHConfig_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRPRACHConfig_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NRPRACHConfig_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NRPRACHConfig_iE_Extension__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRPRACHConfig_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRPRACHConfig_iE_Extension__item__id._const_tab = ____NRPRACHConfig_iE_Extension__item__id_tab
    ___NRPRACHConfig_iE_Extension__item__id._const_tab_at = None
    ___NRPRACHConfig_iE_Extension__item__id._const_tab_id = 'id'
    ___NRPRACHConfig_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRPRACHConfig_iE_Extension__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRPRACHConfig_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRPRACHConfig_iE_Extension__item__criticality._const_tab = ____NRPRACHConfig_iE_Extension__item__criticality_tab
    ___NRPRACHConfig_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___NRPRACHConfig_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___NRPRACHConfig_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRPRACHConfig_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRPRACHConfig_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRPRACHConfig_iE_Extension__item__extensionValue._const_tab = ____NRPRACHConfig_iE_Extension__item__extensionValue_tab
    ___NRPRACHConfig_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRPRACHConfig_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __NRPRACHConfig_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___NRPRACHConfig_iE_Extension__item__id),
        ('criticality', ___NRPRACHConfig_iE_Extension__item__criticality),
        ('extensionValue', ___NRPRACHConfig_iE_Extension__item__extensionValue),
        ])
    __NRPRACHConfig_iE_Extension__item_._ext = None
    _NRPRACHConfig_iE_Extension._cont = __NRPRACHConfig_iE_Extension__item_
    _NRPRACHConfig_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRPRACHConfig._cont = ASN1Dict([
        ('ulPRACHConfigList', _NRPRACHConfig_ulPRACHConfigList),
        ('sulPRACHConfigList', _NRPRACHConfig_sulPRACHConfigList),
        ('iE-Extension', _NRPRACHConfig_iE_Extension),
        ])
    NRPRACHConfig._ext = []
    
    #-----< NRPRACHConfig-ExtIEs >-----#
    NRPRACHConfig_ExtIEs = CLASS(name='NRPRACHConfig-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NRPRACHConfig_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRCellIdentity >-----#
    NRCellIdentity = BIT_STR(name='NRCellIdentity', mode=MODE_TYPE)
    NRCellIdentity._const_sz = ASN1Set(rv=[36], rr=[], ev=None, er=[])
    
    #-----< NRNRB >-----#
    NRNRB = ENUM(name='NRNRB', mode=MODE_TYPE)
    NRNRB._cont = ASN1Dict([('nrb11', 0), ('nrb18', 1), ('nrb24', 2), ('nrb25', 3), ('nrb31', 4), ('nrb32', 5), ('nrb38', 6), ('nrb51', 7), ('nrb52', 8), ('nrb65', 9), ('nrb66', 10), ('nrb78', 11), ('nrb79', 12), ('nrb93', 13), ('nrb106', 14), ('nrb107', 15), ('nrb121', 16), ('nrb132', 17), ('nrb133', 18), ('nrb135', 19), ('nrb160', 20), ('nrb162', 21), ('nrb189', 22), ('nrb216', 23), ('nrb217', 24), ('nrb245', 25), ('nrb264', 26), ('nrb270', 27), ('nrb273', 28), ('nrb33', 29), ('nrb62', 30), ('nrb124', 31), ('nrb148', 32), ('nrb248', 33), ('nrb44', 34), ('nrb58', 35), ('nrb92', 36), ('nrb119', 37), ('nrb188', 38), ('nrb242', 39)])
    NRNRB._ext = ['nrb33', 'nrb62', 'nrb124', 'nrb148', 'nrb248', 'nrb44', 'nrb58', 'nrb92', 'nrb119', 'nrb188', 'nrb242']
    
    #-----< NRPCI >-----#
    NRPCI = INT(name='NRPCI', mode=MODE_TYPE)
    NRPCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1007)], ev=None, er=[])
    
    #-----< NRPRACHConfigList >-----#
    NRPRACHConfigList = SEQ_OF(name='NRPRACHConfigList', mode=MODE_TYPE)
    _NRPRACHConfigList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRPRACHConfigItem')))
    NRPRACHConfigList._cont = _NRPRACHConfigList__item_
    NRPRACHConfigList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< NRPRACHConfigItem >-----#
    NRPRACHConfigItem = SEQ(name='NRPRACHConfigItem', mode=MODE_TYPE)
    _NRPRACHConfigItem_nRSCS = ENUM(name='nRSCS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRSCS')))
    _NRPRACHConfigItem_prachFreqStartfromCarrier = INT(name='prachFreqStartfromCarrier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NRPRACHConfigItem_prachFreqStartfromCarrier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=274)], ev=[], er=[])
    _NRPRACHConfigItem_prachFDM = ENUM(name='prachFDM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NRPRACHConfigItem_prachFDM._cont = ASN1Dict([('one', 0), ('two', 1), ('four', 2), ('eight', 3)])
    _NRPRACHConfigItem_prachFDM._ext = []
    _NRPRACHConfigItem_prachConfigIndex = INT(name='prachConfigIndex', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NRPRACHConfigItem_prachConfigIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[ASN1RangeInt(lb=256, ub=262)])
    _NRPRACHConfigItem_ssb_perRACH_Occasion = ENUM(name='ssb-perRACH-Occasion', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NRPRACHConfigItem_ssb_perRACH_Occasion._cont = ASN1Dict([('oneEighth', 0), ('oneFourth', 1), ('oneHalf', 2), ('one', 3), ('two', 4), ('four', 5), ('eight', 6), ('sixteen', 7)])
    _NRPRACHConfigItem_ssb_perRACH_Occasion._ext = []
    _NRPRACHConfigItem_freqDomainLength = CHOICE(name='freqDomainLength', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FreqDomainLength')))
    _NRPRACHConfigItem_zeroCorrelZoneConfig = INT(name='zeroCorrelZoneConfig', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NRPRACHConfigItem_zeroCorrelZoneConfig._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _NRPRACHConfigItem_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRPRACHConfigItem_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NRPRACHConfigItem_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NRPRACHConfigItem_iE_Extension__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRPRACHConfigItem_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRPRACHConfigItem_iE_Extension__item__id._const_tab = ____NRPRACHConfigItem_iE_Extension__item__id_tab
    ___NRPRACHConfigItem_iE_Extension__item__id._const_tab_at = None
    ___NRPRACHConfigItem_iE_Extension__item__id._const_tab_id = 'id'
    ___NRPRACHConfigItem_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRPRACHConfigItem_iE_Extension__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRPRACHConfigItem_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRPRACHConfigItem_iE_Extension__item__criticality._const_tab = ____NRPRACHConfigItem_iE_Extension__item__criticality_tab
    ___NRPRACHConfigItem_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___NRPRACHConfigItem_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___NRPRACHConfigItem_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRPRACHConfigItem_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRPRACHConfigItem_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRPRACHConfigItem_iE_Extension__item__extensionValue._const_tab = ____NRPRACHConfigItem_iE_Extension__item__extensionValue_tab
    ___NRPRACHConfigItem_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRPRACHConfigItem_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __NRPRACHConfigItem_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___NRPRACHConfigItem_iE_Extension__item__id),
        ('criticality', ___NRPRACHConfigItem_iE_Extension__item__criticality),
        ('extensionValue', ___NRPRACHConfigItem_iE_Extension__item__extensionValue),
        ])
    __NRPRACHConfigItem_iE_Extension__item_._ext = None
    _NRPRACHConfigItem_iE_Extension._cont = __NRPRACHConfigItem_iE_Extension__item_
    _NRPRACHConfigItem_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRPRACHConfigItem._cont = ASN1Dict([
        ('nRSCS', _NRPRACHConfigItem_nRSCS),
        ('prachFreqStartfromCarrier', _NRPRACHConfigItem_prachFreqStartfromCarrier),
        ('prachFDM', _NRPRACHConfigItem_prachFDM),
        ('prachConfigIndex', _NRPRACHConfigItem_prachConfigIndex),
        ('ssb-perRACH-Occasion', _NRPRACHConfigItem_ssb_perRACH_Occasion),
        ('freqDomainLength', _NRPRACHConfigItem_freqDomainLength),
        ('zeroCorrelZoneConfig', _NRPRACHConfigItem_zeroCorrelZoneConfig),
        ('iE-Extension', _NRPRACHConfigItem_iE_Extension),
        ])
    NRPRACHConfigItem._ext = []
    
    #-----< NRPRACHConfigItem-ExtIEs >-----#
    NRPRACHConfigItem_ExtIEs = CLASS(name='NRPRACHConfigItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NRPRACHConfigItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRSCS >-----#
    NRSCS = ENUM(name='NRSCS', mode=MODE_TYPE)
    NRSCS._cont = ASN1Dict([('scs15', 0), ('scs30', 1), ('scs60', 2), ('scs120', 3), ('scs480', 4), ('scs960', 5)])
    NRSCS._ext = ['scs480', 'scs960']
    
    #-----< NRUERLFReportContainer >-----#
    NRUERLFReportContainer = OCT_STR(name='NRUERLFReportContainer', mode=MODE_TYPE)
    
    #-----< NR-U-Channel-Info-List >-----#
    NR_U_Channel_Info_List = SEQ_OF(name='NR-U-Channel-Info-List', mode=MODE_TYPE)
    _NR_U_Channel_Info_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NR-U-Channel-Info-Item')))
    NR_U_Channel_Info_List._cont = _NR_U_Channel_Info_List__item_
    NR_U_Channel_Info_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< NR-U-Channel-Info-Item >-----#
    NR_U_Channel_Info_Item = SEQ(name='NR-U-Channel-Info-Item', mode=MODE_TYPE)
    _NR_U_Channel_Info_Item_nr_U_channel_ID = INT(name='nr-U-channel-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NR_U_Channel_Info_Item_nr_U_channel_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=[], er=[])
    _NR_U_Channel_Info_Item_nR_ARFCN = INT(name='nR-ARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NR_U_Channel_Info_Item_nR_ARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _NR_U_Channel_Info_Item_bandwidth = ENUM(name='bandwidth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NR_U_Channel_Info_Item_bandwidth._cont = ASN1Dict([('mHz-10', 0), ('mHz-20', 1), ('mHz-40', 2), ('mHz-60', 3), ('mHz-80', 4)])
    _NR_U_Channel_Info_Item_bandwidth._ext = []
    _NR_U_Channel_Info_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NR_U_Channel_Info_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NR_U_Channel_Info_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NR_U_Channel_Info_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NR_U_Channel_Info_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_U_Channel_Info_Item_iE_Extensions__item__id._const_tab = ____NR_U_Channel_Info_Item_iE_Extensions__item__id_tab
    ___NR_U_Channel_Info_Item_iE_Extensions__item__id._const_tab_at = None
    ___NR_U_Channel_Info_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___NR_U_Channel_Info_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NR_U_Channel_Info_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NR_U_Channel_Info_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_U_Channel_Info_Item_iE_Extensions__item__criticality._const_tab = ____NR_U_Channel_Info_Item_iE_Extensions__item__criticality_tab
    ___NR_U_Channel_Info_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NR_U_Channel_Info_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NR_U_Channel_Info_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NR_U_Channel_Info_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NR_U_Channel_Info_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_U_Channel_Info_Item_iE_Extensions__item__extensionValue._const_tab = ____NR_U_Channel_Info_Item_iE_Extensions__item__extensionValue_tab
    ___NR_U_Channel_Info_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NR_U_Channel_Info_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NR_U_Channel_Info_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NR_U_Channel_Info_Item_iE_Extensions__item__id),
        ('criticality', ___NR_U_Channel_Info_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___NR_U_Channel_Info_Item_iE_Extensions__item__extensionValue),
        ])
    __NR_U_Channel_Info_Item_iE_Extensions__item_._ext = None
    _NR_U_Channel_Info_Item_iE_Extensions._cont = __NR_U_Channel_Info_Item_iE_Extensions__item_
    _NR_U_Channel_Info_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NR_U_Channel_Info_Item._cont = ASN1Dict([
        ('nr-U-channel-ID', _NR_U_Channel_Info_Item_nr_U_channel_ID),
        ('nR-ARFCN', _NR_U_Channel_Info_Item_nR_ARFCN),
        ('bandwidth', _NR_U_Channel_Info_Item_bandwidth),
        ('iE-Extensions', _NR_U_Channel_Info_Item_iE_Extensions),
        ])
    NR_U_Channel_Info_Item._ext = []
    
    #-----< NR-U-Channel-Info-List-ExtIEs >-----#
    NR_U_Channel_Info_List_ExtIEs = CLASS(name='NR-U-Channel-Info-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NR_U_Channel_Info_List_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NR-U-Channel-List >-----#
    NR_U_Channel_List = SEQ_OF(name='NR-U-Channel-List', mode=MODE_TYPE)
    _NR_U_Channel_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NR-U-Channel-Item')))
    NR_U_Channel_List._cont = _NR_U_Channel_List__item_
    NR_U_Channel_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< NR-U-Channel-Item >-----#
    NR_U_Channel_Item = SEQ(name='NR-U-Channel-Item', mode=MODE_TYPE)
    _NR_U_Channel_Item_nR_U_ChannelID = INT(name='nR-U-ChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NR_U_Channel_Item_nR_U_ChannelID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _NR_U_Channel_Item_channelOccupancyTimePercentageDL = INT(name='channelOccupancyTimePercentageDL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ChannelOccupancyTimePercentage')))
    _NR_U_Channel_Item_energyDetectionThreshold = INT(name='energyDetectionThreshold', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EnergyDetectionThreshold')))
    _NR_U_Channel_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NR_U_Channel_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NR_U_Channel_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NR_U_Channel_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NR_U_Channel_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_U_Channel_Item_iE_Extensions__item__id._const_tab = ____NR_U_Channel_Item_iE_Extensions__item__id_tab
    ___NR_U_Channel_Item_iE_Extensions__item__id._const_tab_at = None
    ___NR_U_Channel_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___NR_U_Channel_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NR_U_Channel_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NR_U_Channel_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_U_Channel_Item_iE_Extensions__item__criticality._const_tab = ____NR_U_Channel_Item_iE_Extensions__item__criticality_tab
    ___NR_U_Channel_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NR_U_Channel_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NR_U_Channel_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NR_U_Channel_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NR_U_Channel_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_U_Channel_Item_iE_Extensions__item__extensionValue._const_tab = ____NR_U_Channel_Item_iE_Extensions__item__extensionValue_tab
    ___NR_U_Channel_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NR_U_Channel_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NR_U_Channel_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NR_U_Channel_Item_iE_Extensions__item__id),
        ('criticality', ___NR_U_Channel_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___NR_U_Channel_Item_iE_Extensions__item__extensionValue),
        ])
    __NR_U_Channel_Item_iE_Extensions__item_._ext = None
    _NR_U_Channel_Item_iE_Extensions._cont = __NR_U_Channel_Item_iE_Extensions__item_
    _NR_U_Channel_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NR_U_Channel_Item._cont = ASN1Dict([
        ('nR-U-ChannelID', _NR_U_Channel_Item_nR_U_ChannelID),
        ('channelOccupancyTimePercentageDL', _NR_U_Channel_Item_channelOccupancyTimePercentageDL),
        ('energyDetectionThreshold', _NR_U_Channel_Item_energyDetectionThreshold),
        ('iE-Extensions', _NR_U_Channel_Item_iE_Extensions),
        ])
    NR_U_Channel_Item._ext = []
    
    #-----< NR-U-Channel-Item-ExtIEs >-----#
    NR_U_Channel_Item_ExtIEs = CLASS(name='NR-U-Channel-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NR_U_Channel_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NumberofActiveUEs >-----#
    NumberofActiveUEs = INT(name='NumberofActiveUEs', mode=MODE_TYPE)
    NumberofActiveUEs._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=[], er=[])
    
    #-----< NumberOfBroadcasts >-----#
    NumberOfBroadcasts = INT(name='NumberOfBroadcasts', mode=MODE_TYPE)
    NumberOfBroadcasts._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< NumberofBroadcastRequest >-----#
    NumberofBroadcastRequest = INT(name='NumberofBroadcastRequest', mode=MODE_TYPE)
    NumberofBroadcastRequest._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< NumberOfTRPRxTEG >-----#
    NumberOfTRPRxTEG = ENUM(name='NumberOfTRPRxTEG', mode=MODE_TYPE)
    NumberOfTRPRxTEG._cont = ASN1Dict([('two', 0), ('three', 1), ('four', 2), ('six', 3), ('eight', 4)])
    NumberOfTRPRxTEG._ext = []
    
    #-----< NumberOfTRPRxTxTEG >-----#
    NumberOfTRPRxTxTEG = ENUM(name='NumberOfTRPRxTxTEG', mode=MODE_TYPE)
    NumberOfTRPRxTxTEG._cont = ASN1Dict([('wo', 0), ('three', 1), ('four', 2), ('six', 3), ('eight', 4)])
    NumberOfTRPRxTxTEG._ext = []
    
    #-----< NumDLULSymbols >-----#
    NumDLULSymbols = SEQ(name='NumDLULSymbols', mode=MODE_TYPE)
    _NumDLULSymbols_numDLSymbols = INT(name='numDLSymbols', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NumDLULSymbols_numDLSymbols._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=13)], ev=[], er=[])
    _NumDLULSymbols_numULSymbols = INT(name='numULSymbols', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NumDLULSymbols_numULSymbols._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=13)], ev=[], er=[])
    _NumDLULSymbols_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NumDLULSymbols_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NumDLULSymbols_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NumDLULSymbols_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____NumDLULSymbols_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Permutation')))
    ____NumDLULSymbols_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 535), ('criticality', 'ignore'), ('Extension', _____NumDLULSymbols_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___NumDLULSymbols_iE_Extensions__item__id._const_tab = ____NumDLULSymbols_iE_Extensions__item__id_tab
    ___NumDLULSymbols_iE_Extensions__item__id._const_tab_at = None
    ___NumDLULSymbols_iE_Extensions__item__id._const_tab_id = 'id'
    ___NumDLULSymbols_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___NumDLULSymbols_iE_Extensions__item__criticality._const_tab = ____NumDLULSymbols_iE_Extensions__item__id_tab
    ___NumDLULSymbols_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NumDLULSymbols_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NumDLULSymbols_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___NumDLULSymbols_iE_Extensions__item__extensionValue._const_tab = ____NumDLULSymbols_iE_Extensions__item__id_tab
    ___NumDLULSymbols_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NumDLULSymbols_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NumDLULSymbols_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NumDLULSymbols_iE_Extensions__item__id),
        ('criticality', ___NumDLULSymbols_iE_Extensions__item__criticality),
        ('extensionValue', ___NumDLULSymbols_iE_Extensions__item__extensionValue),
        ])
    __NumDLULSymbols_iE_Extensions__item_._ext = None
    _NumDLULSymbols_iE_Extensions._cont = __NumDLULSymbols_iE_Extensions__item_
    _NumDLULSymbols_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NumDLULSymbols._cont = ASN1Dict([
        ('numDLSymbols', _NumDLULSymbols_numDLSymbols),
        ('numULSymbols', _NumDLULSymbols_numULSymbols),
        ('iE-Extensions', _NumDLULSymbols_iE_Extensions),
        ])
    NumDLULSymbols._ext = None
    
    #-----< NumDLULSymbols-ExtIEs >-----#
    NumDLULSymbols_ExtIEs = CLASS(name='NumDLULSymbols-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _NumDLULSymbols_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Permutation')))
    NumDLULSymbols_ExtIEs._val = ASN1Set(rv=[dict([('id', 535), ('criticality', 'ignore'), ('Extension', _NumDLULSymbols_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< NRV2XServicesAuthorized >-----#
    NRV2XServicesAuthorized = SEQ(name='NRV2XServicesAuthorized', mode=MODE_TYPE)
    _NRV2XServicesAuthorized_vehicleUE = ENUM(name='vehicleUE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'VehicleUE')), opt=True)
    _NRV2XServicesAuthorized_pedestrianUE = ENUM(name='pedestrianUE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PedestrianUE')), opt=True)
    _NRV2XServicesAuthorized_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRV2XServicesAuthorized_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NRV2XServicesAuthorized_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRV2XServicesAuthorized_iE_Extensions__item__id._const_tab = ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab
    ___NRV2XServicesAuthorized_iE_Extensions__item__id._const_tab_at = None
    ___NRV2XServicesAuthorized_iE_Extensions__item__id._const_tab_id = 'id'
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab = ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab = ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NRV2XServicesAuthorized_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NRV2XServicesAuthorized_iE_Extensions__item__id),
        ('criticality', ___NRV2XServicesAuthorized_iE_Extensions__item__criticality),
        ('extensionValue', ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue),
        ])
    __NRV2XServicesAuthorized_iE_Extensions__item_._ext = None
    _NRV2XServicesAuthorized_iE_Extensions._cont = __NRV2XServicesAuthorized_iE_Extensions__item_
    _NRV2XServicesAuthorized_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRV2XServicesAuthorized._cont = ASN1Dict([
        ('vehicleUE', _NRV2XServicesAuthorized_vehicleUE),
        ('pedestrianUE', _NRV2XServicesAuthorized_pedestrianUE),
        ('iE-Extensions', _NRV2XServicesAuthorized_iE_Extensions),
        ])
    NRV2XServicesAuthorized._ext = None
    
    #-----< NRV2XServicesAuthorized-ExtIEs >-----#
    NRV2XServicesAuthorized_ExtIEs = CLASS(name='NRV2XServicesAuthorized-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NRV2XServicesAuthorized_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRUESidelinkAggregateMaximumBitrate >-----#
    NRUESidelinkAggregateMaximumBitrate = SEQ(name='NRUESidelinkAggregateMaximumBitrate', mode=MODE_TYPE)
    _NRUESidelinkAggregateMaximumBitrate_uENRSidelinkAggregateMaximumBitrate = INT(name='uENRSidelinkAggregateMaximumBitrate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _NRUESidelinkAggregateMaximumBitrate_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab = ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_at = None
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_id = 'id'
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab = ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab = ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id),
        ('criticality', ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality),
        ('extensionValue', ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue),
        ])
    __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_._ext = None
    _NRUESidelinkAggregateMaximumBitrate_iE_Extensions._cont = __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_
    _NRUESidelinkAggregateMaximumBitrate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRUESidelinkAggregateMaximumBitrate._cont = ASN1Dict([
        ('uENRSidelinkAggregateMaximumBitrate', _NRUESidelinkAggregateMaximumBitrate_uENRSidelinkAggregateMaximumBitrate),
        ('iE-Extensions', _NRUESidelinkAggregateMaximumBitrate_iE_Extensions),
        ])
    NRUESidelinkAggregateMaximumBitrate._ext = None
    
    #-----< NRUESidelinkAggregateMaximumBitrate-ExtIEs >-----#
    NRUESidelinkAggregateMaximumBitrate_ExtIEs = CLASS(name='NRUESidelinkAggregateMaximumBitrate-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NRUESidelinkAggregateMaximumBitrate_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NZP-CSI-RS-ResourceID >-----#
    NZP_CSI_RS_ResourceID = INT(name='NZP-CSI-RS-ResourceID', mode=MODE_TYPE)
    NZP_CSI_RS_ResourceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=191)], ev=None, er=[])
    
    #-----< OffsetToPointA >-----#
    OffsetToPointA = INT(name='OffsetToPointA', mode=MODE_TYPE)
    OffsetToPointA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2199)], ev=[], er=[])
    
    #-----< OnDemandPRS-Info >-----#
    OnDemandPRS_Info = SEQ(name='OnDemandPRS-Info', mode=MODE_TYPE)
    _OnDemandPRS_Info_onDemandPRSRequestAllowed = BIT_STR(name='onDemandPRSRequestAllowed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OnDemandPRS_Info_onDemandPRSRequestAllowed._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _OnDemandPRS_Info_allowedResourceSetPeriodicityValues = BIT_STR(name='allowedResourceSetPeriodicityValues', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OnDemandPRS_Info_allowedResourceSetPeriodicityValues._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _OnDemandPRS_Info_allowedPRSBandwidthValues = BIT_STR(name='allowedPRSBandwidthValues', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OnDemandPRS_Info_allowedPRSBandwidthValues._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    _OnDemandPRS_Info_allowedResourceRepetitionFactorValues = BIT_STR(name='allowedResourceRepetitionFactorValues', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OnDemandPRS_Info_allowedResourceRepetitionFactorValues._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _OnDemandPRS_Info_allowedResourceNumberOfSymbolsValues = BIT_STR(name='allowedResourceNumberOfSymbolsValues', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OnDemandPRS_Info_allowedResourceNumberOfSymbolsValues._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _OnDemandPRS_Info_allowedCombSizeValues = BIT_STR(name='allowedCombSizeValues', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OnDemandPRS_Info_allowedCombSizeValues._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _OnDemandPRS_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __OnDemandPRS_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___OnDemandPRS_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____OnDemandPRS_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____OnDemandPRS_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OnDemandPRS_Info_iE_Extensions__item__id._const_tab = ____OnDemandPRS_Info_iE_Extensions__item__id_tab
    ___OnDemandPRS_Info_iE_Extensions__item__id._const_tab_at = None
    ___OnDemandPRS_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___OnDemandPRS_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____OnDemandPRS_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____OnDemandPRS_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OnDemandPRS_Info_iE_Extensions__item__criticality._const_tab = ____OnDemandPRS_Info_iE_Extensions__item__criticality_tab
    ___OnDemandPRS_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___OnDemandPRS_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___OnDemandPRS_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____OnDemandPRS_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____OnDemandPRS_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OnDemandPRS_Info_iE_Extensions__item__extensionValue._const_tab = ____OnDemandPRS_Info_iE_Extensions__item__extensionValue_tab
    ___OnDemandPRS_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___OnDemandPRS_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __OnDemandPRS_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___OnDemandPRS_Info_iE_Extensions__item__id),
        ('criticality', ___OnDemandPRS_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___OnDemandPRS_Info_iE_Extensions__item__extensionValue),
        ])
    __OnDemandPRS_Info_iE_Extensions__item_._ext = None
    _OnDemandPRS_Info_iE_Extensions._cont = __OnDemandPRS_Info_iE_Extensions__item_
    _OnDemandPRS_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    OnDemandPRS_Info._cont = ASN1Dict([
        ('onDemandPRSRequestAllowed', _OnDemandPRS_Info_onDemandPRSRequestAllowed),
        ('allowedResourceSetPeriodicityValues', _OnDemandPRS_Info_allowedResourceSetPeriodicityValues),
        ('allowedPRSBandwidthValues', _OnDemandPRS_Info_allowedPRSBandwidthValues),
        ('allowedResourceRepetitionFactorValues', _OnDemandPRS_Info_allowedResourceRepetitionFactorValues),
        ('allowedResourceNumberOfSymbolsValues', _OnDemandPRS_Info_allowedResourceNumberOfSymbolsValues),
        ('allowedCombSizeValues', _OnDemandPRS_Info_allowedCombSizeValues),
        ('iE-Extensions', _OnDemandPRS_Info_iE_Extensions),
        ])
    OnDemandPRS_Info._ext = []
    
    #-----< OnDemandPRS-Info-ExtIEs >-----#
    OnDemandPRS_Info_ExtIEs = CLASS(name='OnDemandPRS-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    OnDemandPRS_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PacketDelayBudget >-----#
    PacketDelayBudget = INT(name='PacketDelayBudget', mode=MODE_TYPE)
    PacketDelayBudget._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=[], er=[])
    
    #-----< PacketErrorRate >-----#
    PacketErrorRate = SEQ(name='PacketErrorRate', mode=MODE_TYPE)
    _PacketErrorRate_pER_Scalar = INT(name='pER-Scalar', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PER-Scalar')))
    _PacketErrorRate_pER_Exponent = INT(name='pER-Exponent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PER-Exponent')))
    _PacketErrorRate_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PacketErrorRate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PacketErrorRate_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PacketErrorRate_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PacketErrorRate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PacketErrorRate_iE_Extensions__item__id._const_tab = ____PacketErrorRate_iE_Extensions__item__id_tab
    ___PacketErrorRate_iE_Extensions__item__id._const_tab_at = None
    ___PacketErrorRate_iE_Extensions__item__id._const_tab_id = 'id'
    ___PacketErrorRate_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PacketErrorRate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PacketErrorRate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PacketErrorRate_iE_Extensions__item__criticality._const_tab = ____PacketErrorRate_iE_Extensions__item__criticality_tab
    ___PacketErrorRate_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PacketErrorRate_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PacketErrorRate_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PacketErrorRate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PacketErrorRate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PacketErrorRate_iE_Extensions__item__extensionValue._const_tab = ____PacketErrorRate_iE_Extensions__item__extensionValue_tab
    ___PacketErrorRate_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PacketErrorRate_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PacketErrorRate_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PacketErrorRate_iE_Extensions__item__id),
        ('criticality', ___PacketErrorRate_iE_Extensions__item__criticality),
        ('extensionValue', ___PacketErrorRate_iE_Extensions__item__extensionValue),
        ])
    __PacketErrorRate_iE_Extensions__item_._ext = None
    _PacketErrorRate_iE_Extensions._cont = __PacketErrorRate_iE_Extensions__item_
    _PacketErrorRate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PacketErrorRate._cont = ASN1Dict([
        ('pER-Scalar', _PacketErrorRate_pER_Scalar),
        ('pER-Exponent', _PacketErrorRate_pER_Exponent),
        ('iE-Extensions', _PacketErrorRate_iE_Extensions),
        ])
    PacketErrorRate._ext = []
    
    #-----< PacketErrorRate-ExtIEs >-----#
    PacketErrorRate_ExtIEs = CLASS(name='PacketErrorRate-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PacketErrorRate_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PER-Scalar >-----#
    PER_Scalar = INT(name='PER-Scalar', mode=MODE_TYPE)
    PER_Scalar._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=[], er=[])
    
    #-----< PER-Exponent >-----#
    PER_Exponent = INT(name='PER-Exponent', mode=MODE_TYPE)
    PER_Exponent._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=[], er=[])
    
    #-----< PagingCell-Item >-----#
    PagingCell_Item = SEQ(name='PagingCell-Item', mode=MODE_TYPE)
    _PagingCell_Item_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _PagingCell_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PagingCell_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PagingCell_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PagingCell_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____PagingCell_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LastUsedCellIndication')))
    _____PagingCell_Item_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PEISubgroupingSupportIndication')))
    ____PagingCell_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 624), ('criticality', 'ignore'), ('Extension', _____PagingCell_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 664), ('criticality', 'ignore'), ('Extension', _____PagingCell_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PagingCell_Item_iE_Extensions__item__id._const_tab = ____PagingCell_Item_iE_Extensions__item__id_tab
    ___PagingCell_Item_iE_Extensions__item__id._const_tab_at = None
    ___PagingCell_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PagingCell_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PagingCell_Item_iE_Extensions__item__criticality._const_tab = ____PagingCell_Item_iE_Extensions__item__id_tab
    ___PagingCell_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PagingCell_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PagingCell_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PagingCell_Item_iE_Extensions__item__extensionValue._const_tab = ____PagingCell_Item_iE_Extensions__item__id_tab
    ___PagingCell_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PagingCell_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PagingCell_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PagingCell_Item_iE_Extensions__item__id),
        ('criticality', ___PagingCell_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PagingCell_Item_iE_Extensions__item__extensionValue),
        ])
    __PagingCell_Item_iE_Extensions__item_._ext = None
    _PagingCell_Item_iE_Extensions._cont = __PagingCell_Item_iE_Extensions__item_
    _PagingCell_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PagingCell_Item._cont = ASN1Dict([
        ('nRCGI', _PagingCell_Item_nRCGI),
        ('iE-Extensions', _PagingCell_Item_iE_Extensions),
        ])
    PagingCell_Item._ext = None
    
    #-----< PagingCell-ItemExtIEs >-----#
    PagingCell_ItemExtIEs = CLASS(name='PagingCell-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _PagingCell_ItemExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LastUsedCellIndication')))
    _PagingCell_ItemExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PEISubgroupingSupportIndication')))
    PagingCell_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 624), ('criticality', 'ignore'), ('Extension', _PagingCell_ItemExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 664), ('criticality', 'ignore'), ('Extension', _PagingCell_ItemExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PagingDRX >-----#
    PagingDRX = ENUM(name='PagingDRX', mode=MODE_TYPE)
    PagingDRX._cont = ASN1Dict([('v32', 0), ('v64', 1), ('v128', 2), ('v256', 3)])
    PagingDRX._ext = []
    
    #-----< PagingIdentity >-----#
    PagingIdentity = CHOICE(name='PagingIdentity', mode=MODE_TYPE)
    _PagingIdentity_rANUEPagingIdentity = SEQ(name='rANUEPagingIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RANUEPagingIdentity')))
    _PagingIdentity_cNUEPagingIdentity = CHOICE(name='cNUEPagingIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CNUEPagingIdentity')))
    _PagingIdentity_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __PagingIdentity_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___PagingIdentity_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PagingIdentity_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PagingIdentity_choice_extension_id._const_tab = ___PagingIdentity_choice_extension_id_tab
    __PagingIdentity_choice_extension_id._const_tab_at = None
    __PagingIdentity_choice_extension_id._const_tab_id = 'id'
    __PagingIdentity_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PagingIdentity_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PagingIdentity_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PagingIdentity_choice_extension_criticality._const_tab = ___PagingIdentity_choice_extension_criticality_tab
    __PagingIdentity_choice_extension_criticality._const_tab_at = ('..', 'id')
    __PagingIdentity_choice_extension_criticality._const_tab_id = 'criticality'
    __PagingIdentity_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PagingIdentity_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PagingIdentity_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PagingIdentity_choice_extension_value._const_tab = ___PagingIdentity_choice_extension_value_tab
    __PagingIdentity_choice_extension_value._const_tab_at = ('..', 'id')
    __PagingIdentity_choice_extension_value._const_tab_id = 'Value'
    _PagingIdentity_choice_extension._cont = ASN1Dict([
        ('id', __PagingIdentity_choice_extension_id),
        ('criticality', __PagingIdentity_choice_extension_criticality),
        ('value', __PagingIdentity_choice_extension_value),
        ])
    _PagingIdentity_choice_extension._ext = None
    PagingIdentity._cont = ASN1Dict([
        ('rANUEPagingIdentity', _PagingIdentity_rANUEPagingIdentity),
        ('cNUEPagingIdentity', _PagingIdentity_cNUEPagingIdentity),
        ('choice-extension', _PagingIdentity_choice_extension),
        ])
    PagingIdentity._ext = None
    
    #-----< PagingCause >-----#
    PagingCause = ENUM(name='PagingCause', mode=MODE_TYPE)
    PagingCause._cont = ASN1Dict([('voice', 0)])
    PagingCause._ext = []
    
    #-----< PagingIdentity-ExtIEs >-----#
    PagingIdentity_ExtIEs = CLASS(name='PagingIdentity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    PagingIdentity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PagingOrigin >-----#
    PagingOrigin = ENUM(name='PagingOrigin', mode=MODE_TYPE)
    PagingOrigin._cont = ASN1Dict([('non-3gpp', 0)])
    PagingOrigin._ext = []
    
    #-----< PagingPriority >-----#
    PagingPriority = ENUM(name='PagingPriority', mode=MODE_TYPE)
    PagingPriority._cont = ASN1Dict([('priolevel1', 0), ('priolevel2', 1), ('priolevel3', 2), ('priolevel4', 3), ('priolevel5', 4), ('priolevel6', 5), ('priolevel7', 6), ('priolevel8', 7)])
    PagingPriority._ext = []
    
    #-----< PEIPSAssistanceInfo >-----#
    PEIPSAssistanceInfo = SEQ(name='PEIPSAssistanceInfo', mode=MODE_TYPE)
    _PEIPSAssistanceInfo_cNSubgroupID = INT(name='cNSubgroupID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CNSubgroupID')))
    _PEIPSAssistanceInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PEIPSAssistanceInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PEIPSAssistanceInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PEIPSAssistanceInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PEIPSAssistanceInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PEIPSAssistanceInfo_iE_Extensions__item__id._const_tab = ____PEIPSAssistanceInfo_iE_Extensions__item__id_tab
    ___PEIPSAssistanceInfo_iE_Extensions__item__id._const_tab_at = None
    ___PEIPSAssistanceInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___PEIPSAssistanceInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PEIPSAssistanceInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PEIPSAssistanceInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PEIPSAssistanceInfo_iE_Extensions__item__criticality._const_tab = ____PEIPSAssistanceInfo_iE_Extensions__item__criticality_tab
    ___PEIPSAssistanceInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PEIPSAssistanceInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PEIPSAssistanceInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PEIPSAssistanceInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PEIPSAssistanceInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PEIPSAssistanceInfo_iE_Extensions__item__extensionValue._const_tab = ____PEIPSAssistanceInfo_iE_Extensions__item__extensionValue_tab
    ___PEIPSAssistanceInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PEIPSAssistanceInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PEIPSAssistanceInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PEIPSAssistanceInfo_iE_Extensions__item__id),
        ('criticality', ___PEIPSAssistanceInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___PEIPSAssistanceInfo_iE_Extensions__item__extensionValue),
        ])
    __PEIPSAssistanceInfo_iE_Extensions__item_._ext = None
    _PEIPSAssistanceInfo_iE_Extensions._cont = __PEIPSAssistanceInfo_iE_Extensions__item_
    _PEIPSAssistanceInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PEIPSAssistanceInfo._cont = ASN1Dict([
        ('cNSubgroupID', _PEIPSAssistanceInfo_cNSubgroupID),
        ('iE-Extensions', _PEIPSAssistanceInfo_iE_Extensions),
        ])
    PEIPSAssistanceInfo._ext = None
    
    #-----< PEIPSAssistanceInfo-ExtIEs >-----#
    PEIPSAssistanceInfo_ExtIEs = CLASS(name='PEIPSAssistanceInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PEIPSAssistanceInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelativePathDelay >-----#
    RelativePathDelay = CHOICE(name='RelativePathDelay', mode=MODE_TYPE)
    _RelativePathDelay_k0 = INT(name='k0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativePathDelay_k0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16351)], ev=None, er=[])
    _RelativePathDelay_k1 = INT(name='k1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativePathDelay_k1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8176)], ev=None, er=[])
    _RelativePathDelay_k2 = INT(name='k2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativePathDelay_k2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4088)], ev=None, er=[])
    _RelativePathDelay_k3 = INT(name='k3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativePathDelay_k3._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2044)], ev=None, er=[])
    _RelativePathDelay_k4 = INT(name='k4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativePathDelay_k4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1022)], ev=None, er=[])
    _RelativePathDelay_k5 = INT(name='k5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativePathDelay_k5._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    _RelativePathDelay_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __RelativePathDelay_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___RelativePathDelay_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___RelativePathDelay_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __RelativePathDelay_choice_extension_id._const_tab = ___RelativePathDelay_choice_extension_id_tab
    __RelativePathDelay_choice_extension_id._const_tab_at = None
    __RelativePathDelay_choice_extension_id._const_tab_id = 'id'
    __RelativePathDelay_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___RelativePathDelay_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___RelativePathDelay_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __RelativePathDelay_choice_extension_criticality._const_tab = ___RelativePathDelay_choice_extension_criticality_tab
    __RelativePathDelay_choice_extension_criticality._const_tab_at = ('..', 'id')
    __RelativePathDelay_choice_extension_criticality._const_tab_id = 'criticality'
    __RelativePathDelay_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___RelativePathDelay_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___RelativePathDelay_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __RelativePathDelay_choice_extension_value._const_tab = ___RelativePathDelay_choice_extension_value_tab
    __RelativePathDelay_choice_extension_value._const_tab_at = ('..', 'id')
    __RelativePathDelay_choice_extension_value._const_tab_id = 'Value'
    _RelativePathDelay_choice_extension._cont = ASN1Dict([
        ('id', __RelativePathDelay_choice_extension_id),
        ('criticality', __RelativePathDelay_choice_extension_criticality),
        ('value', __RelativePathDelay_choice_extension_value),
        ])
    _RelativePathDelay_choice_extension._ext = None
    RelativePathDelay._cont = ASN1Dict([
        ('k0', _RelativePathDelay_k0),
        ('k1', _RelativePathDelay_k1),
        ('k2', _RelativePathDelay_k2),
        ('k3', _RelativePathDelay_k3),
        ('k4', _RelativePathDelay_k4),
        ('k5', _RelativePathDelay_k5),
        ('choice-extension', _RelativePathDelay_choice_extension),
        ])
    RelativePathDelay._ext = None
    
    #-----< RelativePathDelay-ExtIEs >-----#
    RelativePathDelay_ExtIEs = CLASS(name='RelativePathDelay-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    RelativePathDelay_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Parent-IAB-Nodes-NA-Resource-Configuration-List >-----#
    Parent_IAB_Nodes_NA_Resource_Configuration_List = SEQ_OF(name='Parent-IAB-Nodes-NA-Resource-Configuration-List', mode=MODE_TYPE)
    _Parent_IAB_Nodes_NA_Resource_Configuration_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Parent-IAB-Nodes-NA-Resource-Configuration-Item')))
    Parent_IAB_Nodes_NA_Resource_Configuration_List._cont = _Parent_IAB_Nodes_NA_Resource_Configuration_List__item_
    Parent_IAB_Nodes_NA_Resource_Configuration_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5120)], ev=None, er=[])
    
    #-----< Parent-IAB-Nodes-NA-Resource-Configuration-Item >-----#
    Parent_IAB_Nodes_NA_Resource_Configuration_Item = SEQ(name='Parent-IAB-Nodes-NA-Resource-Configuration-Item', mode=MODE_TYPE)
    _Parent_IAB_Nodes_NA_Resource_Configuration_Item_nADownlink = ENUM(name='nADownlink', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NADownlink')), opt=True)
    _Parent_IAB_Nodes_NA_Resource_Configuration_Item_nAUplink = ENUM(name='nAUplink', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NAUplink')), opt=True)
    _Parent_IAB_Nodes_NA_Resource_Configuration_Item_nAFlexible = ENUM(name='nAFlexible', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NAFlexible')), opt=True)
    _Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__id._const_tab = ____Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__id_tab
    ___Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__id._const_tab_at = None
    ___Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__criticality._const_tab = ____Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__criticality_tab
    ___Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__extensionValue._const_tab = ____Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__extensionValue_tab
    ___Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__id),
        ('criticality', ___Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__extensionValue),
        ])
    __Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item_._ext = None
    _Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions._cont = __Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item_
    _Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Parent_IAB_Nodes_NA_Resource_Configuration_Item._cont = ASN1Dict([
        ('nADownlink', _Parent_IAB_Nodes_NA_Resource_Configuration_Item_nADownlink),
        ('nAUplink', _Parent_IAB_Nodes_NA_Resource_Configuration_Item_nAUplink),
        ('nAFlexible', _Parent_IAB_Nodes_NA_Resource_Configuration_Item_nAFlexible),
        ('iE-Extensions', _Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions),
        ])
    Parent_IAB_Nodes_NA_Resource_Configuration_Item._ext = None
    
    #-----< Parent-IAB-Nodes-NA-Resource-Configuration-Item-ExtIEs >-----#
    Parent_IAB_Nodes_NA_Resource_Configuration_Item_ExtIEs = CLASS(name='Parent-IAB-Nodes-NA-Resource-Configuration-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Parent_IAB_Nodes_NA_Resource_Configuration_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PartialSuccessCell >-----#
    PartialSuccessCell = SEQ(name='PartialSuccessCell', mode=MODE_TYPE)
    _PartialSuccessCell_broadcastCellList = SEQ_OF(name='broadcastCellList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BroadcastCellList')))
    _PartialSuccessCell_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PartialSuccessCell_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PartialSuccessCell_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PartialSuccessCell_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PartialSuccessCell_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PartialSuccessCell_iE_Extensions__item__id._const_tab = ____PartialSuccessCell_iE_Extensions__item__id_tab
    ___PartialSuccessCell_iE_Extensions__item__id._const_tab_at = None
    ___PartialSuccessCell_iE_Extensions__item__id._const_tab_id = 'id'
    ___PartialSuccessCell_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PartialSuccessCell_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PartialSuccessCell_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PartialSuccessCell_iE_Extensions__item__criticality._const_tab = ____PartialSuccessCell_iE_Extensions__item__criticality_tab
    ___PartialSuccessCell_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PartialSuccessCell_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PartialSuccessCell_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PartialSuccessCell_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PartialSuccessCell_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PartialSuccessCell_iE_Extensions__item__extensionValue._const_tab = ____PartialSuccessCell_iE_Extensions__item__extensionValue_tab
    ___PartialSuccessCell_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PartialSuccessCell_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PartialSuccessCell_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PartialSuccessCell_iE_Extensions__item__id),
        ('criticality', ___PartialSuccessCell_iE_Extensions__item__criticality),
        ('extensionValue', ___PartialSuccessCell_iE_Extensions__item__extensionValue),
        ])
    __PartialSuccessCell_iE_Extensions__item_._ext = None
    _PartialSuccessCell_iE_Extensions._cont = __PartialSuccessCell_iE_Extensions__item_
    _PartialSuccessCell_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PartialSuccessCell._cont = ASN1Dict([
        ('broadcastCellList', _PartialSuccessCell_broadcastCellList),
        ('iE-Extensions', _PartialSuccessCell_iE_Extensions),
        ])
    PartialSuccessCell._ext = []
    
    #-----< PartialSuccessCell-ExtIEs >-----#
    PartialSuccessCell_ExtIEs = CLASS(name='PartialSuccessCell-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PartialSuccessCell_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PathlossReferenceInfo >-----#
    PathlossReferenceInfo = SEQ(name='PathlossReferenceInfo', mode=MODE_TYPE)
    _PathlossReferenceInfo_pathlossReferenceSignal = CHOICE(name='pathlossReferenceSignal', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PathlossReferenceSignal')))
    _PathlossReferenceInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PathlossReferenceInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PathlossReferenceInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PathlossReferenceInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PathlossReferenceInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathlossReferenceInfo_iE_Extensions__item__id._const_tab = ____PathlossReferenceInfo_iE_Extensions__item__id_tab
    ___PathlossReferenceInfo_iE_Extensions__item__id._const_tab_at = None
    ___PathlossReferenceInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___PathlossReferenceInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PathlossReferenceInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PathlossReferenceInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathlossReferenceInfo_iE_Extensions__item__criticality._const_tab = ____PathlossReferenceInfo_iE_Extensions__item__criticality_tab
    ___PathlossReferenceInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PathlossReferenceInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PathlossReferenceInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PathlossReferenceInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PathlossReferenceInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathlossReferenceInfo_iE_Extensions__item__extensionValue._const_tab = ____PathlossReferenceInfo_iE_Extensions__item__extensionValue_tab
    ___PathlossReferenceInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PathlossReferenceInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PathlossReferenceInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PathlossReferenceInfo_iE_Extensions__item__id),
        ('criticality', ___PathlossReferenceInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___PathlossReferenceInfo_iE_Extensions__item__extensionValue),
        ])
    __PathlossReferenceInfo_iE_Extensions__item_._ext = None
    _PathlossReferenceInfo_iE_Extensions._cont = __PathlossReferenceInfo_iE_Extensions__item_
    _PathlossReferenceInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PathlossReferenceInfo._cont = ASN1Dict([
        ('pathlossReferenceSignal', _PathlossReferenceInfo_pathlossReferenceSignal),
        ('iE-Extensions', _PathlossReferenceInfo_iE_Extensions),
        ])
    PathlossReferenceInfo._ext = None
    
    #-----< PathlossReferenceInfo-ExtIEs >-----#
    PathlossReferenceInfo_ExtIEs = CLASS(name='PathlossReferenceInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PathlossReferenceInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PathlossReferenceSignal >-----#
    PathlossReferenceSignal = CHOICE(name='PathlossReferenceSignal', mode=MODE_TYPE)
    _PathlossReferenceSignal_sSB = SEQ(name='sSB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB')))
    _PathlossReferenceSignal_dL_PRS = SEQ(name='dL-PRS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DL-PRS')))
    _PathlossReferenceSignal_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __PathlossReferenceSignal_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___PathlossReferenceSignal_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PathlossReferenceSignal_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PathlossReferenceSignal_choice_extension_id._const_tab = ___PathlossReferenceSignal_choice_extension_id_tab
    __PathlossReferenceSignal_choice_extension_id._const_tab_at = None
    __PathlossReferenceSignal_choice_extension_id._const_tab_id = 'id'
    __PathlossReferenceSignal_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PathlossReferenceSignal_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PathlossReferenceSignal_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PathlossReferenceSignal_choice_extension_criticality._const_tab = ___PathlossReferenceSignal_choice_extension_criticality_tab
    __PathlossReferenceSignal_choice_extension_criticality._const_tab_at = ('..', 'id')
    __PathlossReferenceSignal_choice_extension_criticality._const_tab_id = 'criticality'
    __PathlossReferenceSignal_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PathlossReferenceSignal_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PathlossReferenceSignal_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PathlossReferenceSignal_choice_extension_value._const_tab = ___PathlossReferenceSignal_choice_extension_value_tab
    __PathlossReferenceSignal_choice_extension_value._const_tab_at = ('..', 'id')
    __PathlossReferenceSignal_choice_extension_value._const_tab_id = 'Value'
    _PathlossReferenceSignal_choice_extension._cont = ASN1Dict([
        ('id', __PathlossReferenceSignal_choice_extension_id),
        ('criticality', __PathlossReferenceSignal_choice_extension_criticality),
        ('value', __PathlossReferenceSignal_choice_extension_value),
        ])
    _PathlossReferenceSignal_choice_extension._ext = None
    PathlossReferenceSignal._cont = ASN1Dict([
        ('sSB', _PathlossReferenceSignal_sSB),
        ('dL-PRS', _PathlossReferenceSignal_dL_PRS),
        ('choice-extension', _PathlossReferenceSignal_choice_extension),
        ])
    PathlossReferenceSignal._ext = None
    
    #-----< PathlossReferenceSignal-ExtIEs >-----#
    PathlossReferenceSignal_ExtIEs = CLASS(name='PathlossReferenceSignal-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    PathlossReferenceSignal_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PathSwitchConfiguration >-----#
    PathSwitchConfiguration = SEQ(name='PathSwitchConfiguration', mode=MODE_TYPE)
    _PathSwitchConfiguration_targetRelayUEID = BIT_STR(name='targetRelayUEID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PathSwitchConfiguration_targetRelayUEID._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _PathSwitchConfiguration_remoteUELocalID = INT(name='remoteUELocalID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RemoteUELocalID')))
    _PathSwitchConfiguration_t420 = ENUM(name='t420', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PathSwitchConfiguration_t420._cont = ASN1Dict([('ms50', 0), ('ms100', 1), ('ms150', 2), ('ms200', 3), ('ms500', 4), ('ms1000', 5), ('ms2000', 6), ('ms10000', 7)])
    _PathSwitchConfiguration_t420._ext = None
    _PathSwitchConfiguration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PathSwitchConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PathSwitchConfiguration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PathSwitchConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PathSwitchConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathSwitchConfiguration_iE_Extensions__item__id._const_tab = ____PathSwitchConfiguration_iE_Extensions__item__id_tab
    ___PathSwitchConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___PathSwitchConfiguration_iE_Extensions__item__id._const_tab_id = 'id'
    ___PathSwitchConfiguration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PathSwitchConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PathSwitchConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathSwitchConfiguration_iE_Extensions__item__criticality._const_tab = ____PathSwitchConfiguration_iE_Extensions__item__criticality_tab
    ___PathSwitchConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PathSwitchConfiguration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PathSwitchConfiguration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PathSwitchConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PathSwitchConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathSwitchConfiguration_iE_Extensions__item__extensionValue._const_tab = ____PathSwitchConfiguration_iE_Extensions__item__extensionValue_tab
    ___PathSwitchConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PathSwitchConfiguration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PathSwitchConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PathSwitchConfiguration_iE_Extensions__item__id),
        ('criticality', ___PathSwitchConfiguration_iE_Extensions__item__criticality),
        ('extensionValue', ___PathSwitchConfiguration_iE_Extensions__item__extensionValue),
        ])
    __PathSwitchConfiguration_iE_Extensions__item_._ext = None
    _PathSwitchConfiguration_iE_Extensions._cont = __PathSwitchConfiguration_iE_Extensions__item_
    _PathSwitchConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PathSwitchConfiguration._cont = ASN1Dict([
        ('targetRelayUEID', _PathSwitchConfiguration_targetRelayUEID),
        ('remoteUELocalID', _PathSwitchConfiguration_remoteUELocalID),
        ('t420', _PathSwitchConfiguration_t420),
        ('iE-Extensions', _PathSwitchConfiguration_iE_Extensions),
        ])
    PathSwitchConfiguration._ext = []
    
    #-----< PathSwitchConfiguration-ExtIEs >-----#
    PathSwitchConfiguration_ExtIEs = CLASS(name='PathSwitchConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PathSwitchConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5QoSFlowIdentifier >-----#
    PC5QoSFlowIdentifier = INT(name='PC5QoSFlowIdentifier', mode=MODE_TYPE)
    PC5QoSFlowIdentifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    
    #-----< PC5-QoS-Characteristics >-----#
    PC5_QoS_Characteristics = CHOICE(name='PC5-QoS-Characteristics', mode=MODE_TYPE)
    _PC5_QoS_Characteristics_non_Dynamic_PQI = SEQ(name='non-Dynamic-PQI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NonDynamicPQIDescriptor')))
    _PC5_QoS_Characteristics_dynamic_PQI = SEQ(name='dynamic-PQI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DynamicPQIDescriptor')))
    _PC5_QoS_Characteristics_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __PC5_QoS_Characteristics_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___PC5_QoS_Characteristics_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PC5_QoS_Characteristics_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PC5_QoS_Characteristics_choice_extension_id._const_tab = ___PC5_QoS_Characteristics_choice_extension_id_tab
    __PC5_QoS_Characteristics_choice_extension_id._const_tab_at = None
    __PC5_QoS_Characteristics_choice_extension_id._const_tab_id = 'id'
    __PC5_QoS_Characteristics_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PC5_QoS_Characteristics_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PC5_QoS_Characteristics_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PC5_QoS_Characteristics_choice_extension_criticality._const_tab = ___PC5_QoS_Characteristics_choice_extension_criticality_tab
    __PC5_QoS_Characteristics_choice_extension_criticality._const_tab_at = ('..', 'id')
    __PC5_QoS_Characteristics_choice_extension_criticality._const_tab_id = 'criticality'
    __PC5_QoS_Characteristics_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PC5_QoS_Characteristics_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PC5_QoS_Characteristics_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PC5_QoS_Characteristics_choice_extension_value._const_tab = ___PC5_QoS_Characteristics_choice_extension_value_tab
    __PC5_QoS_Characteristics_choice_extension_value._const_tab_at = ('..', 'id')
    __PC5_QoS_Characteristics_choice_extension_value._const_tab_id = 'Value'
    _PC5_QoS_Characteristics_choice_extension._cont = ASN1Dict([
        ('id', __PC5_QoS_Characteristics_choice_extension_id),
        ('criticality', __PC5_QoS_Characteristics_choice_extension_criticality),
        ('value', __PC5_QoS_Characteristics_choice_extension_value),
        ])
    _PC5_QoS_Characteristics_choice_extension._ext = None
    PC5_QoS_Characteristics._cont = ASN1Dict([
        ('non-Dynamic-PQI', _PC5_QoS_Characteristics_non_Dynamic_PQI),
        ('dynamic-PQI', _PC5_QoS_Characteristics_dynamic_PQI),
        ('choice-extension', _PC5_QoS_Characteristics_choice_extension),
        ])
    PC5_QoS_Characteristics._ext = None
    
    #-----< PC5-QoS-Characteristics-ExtIEs >-----#
    PC5_QoS_Characteristics_ExtIEs = CLASS(name='PC5-QoS-Characteristics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    PC5_QoS_Characteristics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5QoSParameters >-----#
    PC5QoSParameters = SEQ(name='PC5QoSParameters', mode=MODE_TYPE)
    _PC5QoSParameters_pC5_QoS_Characteristics = CHOICE(name='pC5-QoS-Characteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PC5-QoS-Characteristics')))
    _PC5QoSParameters_pC5_QoS_Flow_Bit_Rates = SEQ(name='pC5-QoS-Flow-Bit-Rates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PC5FlowBitRates')), opt=True)
    _PC5QoSParameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5QoSParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PC5QoSParameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PC5QoSParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5QoSParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSParameters_iE_Extensions__item__id._const_tab = ____PC5QoSParameters_iE_Extensions__item__id_tab
    ___PC5QoSParameters_iE_Extensions__item__id._const_tab_at = None
    ___PC5QoSParameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___PC5QoSParameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PC5QoSParameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5QoSParameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSParameters_iE_Extensions__item__criticality._const_tab = ____PC5QoSParameters_iE_Extensions__item__criticality_tab
    ___PC5QoSParameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PC5QoSParameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PC5QoSParameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSParameters_iE_Extensions__item__extensionValue._const_tab = ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab
    ___PC5QoSParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PC5QoSParameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PC5QoSParameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PC5QoSParameters_iE_Extensions__item__id),
        ('criticality', ___PC5QoSParameters_iE_Extensions__item__criticality),
        ('extensionValue', ___PC5QoSParameters_iE_Extensions__item__extensionValue),
        ])
    __PC5QoSParameters_iE_Extensions__item_._ext = None
    _PC5QoSParameters_iE_Extensions._cont = __PC5QoSParameters_iE_Extensions__item_
    _PC5QoSParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5QoSParameters._cont = ASN1Dict([
        ('pC5-QoS-Characteristics', _PC5QoSParameters_pC5_QoS_Characteristics),
        ('pC5-QoS-Flow-Bit-Rates', _PC5QoSParameters_pC5_QoS_Flow_Bit_Rates),
        ('iE-Extensions', _PC5QoSParameters_iE_Extensions),
        ])
    PC5QoSParameters._ext = []
    
    #-----< PC5QoSParameters-ExtIEs >-----#
    PC5QoSParameters_ExtIEs = CLASS(name='PC5QoSParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PC5QoSParameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5FlowBitRates >-----#
    PC5FlowBitRates = SEQ(name='PC5FlowBitRates', mode=MODE_TYPE)
    _PC5FlowBitRates_guaranteedFlowBitRate = INT(name='guaranteedFlowBitRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _PC5FlowBitRates_maximumFlowBitRate = INT(name='maximumFlowBitRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _PC5FlowBitRates_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5FlowBitRates_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PC5FlowBitRates_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PC5FlowBitRates_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5FlowBitRates_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5FlowBitRates_iE_Extensions__item__id._const_tab = ____PC5FlowBitRates_iE_Extensions__item__id_tab
    ___PC5FlowBitRates_iE_Extensions__item__id._const_tab_at = None
    ___PC5FlowBitRates_iE_Extensions__item__id._const_tab_id = 'id'
    ___PC5FlowBitRates_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PC5FlowBitRates_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5FlowBitRates_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5FlowBitRates_iE_Extensions__item__criticality._const_tab = ____PC5FlowBitRates_iE_Extensions__item__criticality_tab
    ___PC5FlowBitRates_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PC5FlowBitRates_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue._const_tab = ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PC5FlowBitRates_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PC5FlowBitRates_iE_Extensions__item__id),
        ('criticality', ___PC5FlowBitRates_iE_Extensions__item__criticality),
        ('extensionValue', ___PC5FlowBitRates_iE_Extensions__item__extensionValue),
        ])
    __PC5FlowBitRates_iE_Extensions__item_._ext = None
    _PC5FlowBitRates_iE_Extensions._cont = __PC5FlowBitRates_iE_Extensions__item_
    _PC5FlowBitRates_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5FlowBitRates._cont = ASN1Dict([
        ('guaranteedFlowBitRate', _PC5FlowBitRates_guaranteedFlowBitRate),
        ('maximumFlowBitRate', _PC5FlowBitRates_maximumFlowBitRate),
        ('iE-Extensions', _PC5FlowBitRates_iE_Extensions),
        ])
    PC5FlowBitRates._ext = []
    
    #-----< PC5FlowBitRates-ExtIEs >-----#
    PC5FlowBitRates_ExtIEs = CLASS(name='PC5FlowBitRates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PC5FlowBitRates_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5RLCChannelID >-----#
    PC5RLCChannelID = INT(name='PC5RLCChannelID', mode=MODE_TYPE)
    PC5RLCChannelID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=[], er=[])
    
    #-----< PC5RLCChannelQoSInformation >-----#
    PC5RLCChannelQoSInformation = CHOICE(name='PC5RLCChannelQoSInformation', mode=MODE_TYPE)
    _PC5RLCChannelQoSInformation_pC5RLCChannelQoS = SEQ(name='pC5RLCChannelQoS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSFlowLevelQoSParameters')))
    _PC5RLCChannelQoSInformation_pC5ControlPlaneTrafficType = ENUM(name='pC5ControlPlaneTrafficType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PC5RLCChannelQoSInformation_pC5ControlPlaneTrafficType._cont = ASN1Dict([('srb1', 0), ('srb2', 1)])
    _PC5RLCChannelQoSInformation_pC5ControlPlaneTrafficType._ext = []
    _PC5RLCChannelQoSInformation_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __PC5RLCChannelQoSInformation_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___PC5RLCChannelQoSInformation_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PC5RLCChannelQoSInformation_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PC5RLCChannelQoSInformation_choice_extension_id._const_tab = ___PC5RLCChannelQoSInformation_choice_extension_id_tab
    __PC5RLCChannelQoSInformation_choice_extension_id._const_tab_at = None
    __PC5RLCChannelQoSInformation_choice_extension_id._const_tab_id = 'id'
    __PC5RLCChannelQoSInformation_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PC5RLCChannelQoSInformation_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PC5RLCChannelQoSInformation_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PC5RLCChannelQoSInformation_choice_extension_criticality._const_tab = ___PC5RLCChannelQoSInformation_choice_extension_criticality_tab
    __PC5RLCChannelQoSInformation_choice_extension_criticality._const_tab_at = ('..', 'id')
    __PC5RLCChannelQoSInformation_choice_extension_criticality._const_tab_id = 'criticality'
    __PC5RLCChannelQoSInformation_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PC5RLCChannelQoSInformation_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PC5RLCChannelQoSInformation_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PC5RLCChannelQoSInformation_choice_extension_value._const_tab = ___PC5RLCChannelQoSInformation_choice_extension_value_tab
    __PC5RLCChannelQoSInformation_choice_extension_value._const_tab_at = ('..', 'id')
    __PC5RLCChannelQoSInformation_choice_extension_value._const_tab_id = 'Value'
    _PC5RLCChannelQoSInformation_choice_extension._cont = ASN1Dict([
        ('id', __PC5RLCChannelQoSInformation_choice_extension_id),
        ('criticality', __PC5RLCChannelQoSInformation_choice_extension_criticality),
        ('value', __PC5RLCChannelQoSInformation_choice_extension_value),
        ])
    _PC5RLCChannelQoSInformation_choice_extension._ext = None
    PC5RLCChannelQoSInformation._cont = ASN1Dict([
        ('pC5RLCChannelQoS', _PC5RLCChannelQoSInformation_pC5RLCChannelQoS),
        ('pC5ControlPlaneTrafficType', _PC5RLCChannelQoSInformation_pC5ControlPlaneTrafficType),
        ('choice-extension', _PC5RLCChannelQoSInformation_choice_extension),
        ])
    PC5RLCChannelQoSInformation._ext = None
    
    #-----< PC5RLCChannelQoSInformation-ExtIEs >-----#
    PC5RLCChannelQoSInformation_ExtIEs = CLASS(name='PC5RLCChannelQoSInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    PC5RLCChannelQoSInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5RLCChannelToBeSetupList >-----#
    PC5RLCChannelToBeSetupList = SEQ_OF(name='PC5RLCChannelToBeSetupList', mode=MODE_TYPE)
    _PC5RLCChannelToBeSetupList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelToBeSetupItem')))
    PC5RLCChannelToBeSetupList._cont = _PC5RLCChannelToBeSetupList__item_
    PC5RLCChannelToBeSetupList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< PC5RLCChannelToBeSetupItem >-----#
    PC5RLCChannelToBeSetupItem = SEQ(name='PC5RLCChannelToBeSetupItem', mode=MODE_TYPE)
    _PC5RLCChannelToBeSetupItem_pC5RLCChannelID = INT(name='pC5RLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelID')))
    _PC5RLCChannelToBeSetupItem_remoteUELocalID = INT(name='remoteUELocalID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RemoteUELocalID')), opt=True)
    _PC5RLCChannelToBeSetupItem_pC5RLCChannelQoSInformation = CHOICE(name='pC5RLCChannelQoSInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelQoSInformation')))
    _PC5RLCChannelToBeSetupItem_rLCMode = ENUM(name='rLCMode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RLCMode')))
    _PC5RLCChannelToBeSetupItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5RLCChannelToBeSetupItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PC5RLCChannelToBeSetupItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PC5RLCChannelToBeSetupItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelToBeSetupItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelToBeSetupItem_iE_Extensions__item__id._const_tab = ____PC5RLCChannelToBeSetupItem_iE_Extensions__item__id_tab
    ___PC5RLCChannelToBeSetupItem_iE_Extensions__item__id._const_tab_at = None
    ___PC5RLCChannelToBeSetupItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PC5RLCChannelToBeSetupItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PC5RLCChannelToBeSetupItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelToBeSetupItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelToBeSetupItem_iE_Extensions__item__criticality._const_tab = ____PC5RLCChannelToBeSetupItem_iE_Extensions__item__criticality_tab
    ___PC5RLCChannelToBeSetupItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PC5RLCChannelToBeSetupItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PC5RLCChannelToBeSetupItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PC5RLCChannelToBeSetupItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelToBeSetupItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelToBeSetupItem_iE_Extensions__item__extensionValue._const_tab = ____PC5RLCChannelToBeSetupItem_iE_Extensions__item__extensionValue_tab
    ___PC5RLCChannelToBeSetupItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PC5RLCChannelToBeSetupItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PC5RLCChannelToBeSetupItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PC5RLCChannelToBeSetupItem_iE_Extensions__item__id),
        ('criticality', ___PC5RLCChannelToBeSetupItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PC5RLCChannelToBeSetupItem_iE_Extensions__item__extensionValue),
        ])
    __PC5RLCChannelToBeSetupItem_iE_Extensions__item_._ext = None
    _PC5RLCChannelToBeSetupItem_iE_Extensions._cont = __PC5RLCChannelToBeSetupItem_iE_Extensions__item_
    _PC5RLCChannelToBeSetupItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5RLCChannelToBeSetupItem._cont = ASN1Dict([
        ('pC5RLCChannelID', _PC5RLCChannelToBeSetupItem_pC5RLCChannelID),
        ('remoteUELocalID', _PC5RLCChannelToBeSetupItem_remoteUELocalID),
        ('pC5RLCChannelQoSInformation', _PC5RLCChannelToBeSetupItem_pC5RLCChannelQoSInformation),
        ('rLCMode', _PC5RLCChannelToBeSetupItem_rLCMode),
        ('iE-Extensions', _PC5RLCChannelToBeSetupItem_iE_Extensions),
        ])
    PC5RLCChannelToBeSetupItem._ext = []
    
    #-----< PC5RLCChannelToBeSetupItem-ExtIEs >-----#
    PC5RLCChannelToBeSetupItem_ExtIEs = CLASS(name='PC5RLCChannelToBeSetupItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PC5RLCChannelToBeSetupItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5RLCChannelToBeModifiedList >-----#
    PC5RLCChannelToBeModifiedList = SEQ_OF(name='PC5RLCChannelToBeModifiedList', mode=MODE_TYPE)
    _PC5RLCChannelToBeModifiedList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelToBeModifiedItem')))
    PC5RLCChannelToBeModifiedList._cont = _PC5RLCChannelToBeModifiedList__item_
    PC5RLCChannelToBeModifiedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< PC5RLCChannelToBeModifiedItem >-----#
    PC5RLCChannelToBeModifiedItem = SEQ(name='PC5RLCChannelToBeModifiedItem', mode=MODE_TYPE)
    _PC5RLCChannelToBeModifiedItem_pC5RLCChannelID = INT(name='pC5RLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelID')))
    _PC5RLCChannelToBeModifiedItem_remoteUELocalID = INT(name='remoteUELocalID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RemoteUELocalID')), opt=True)
    _PC5RLCChannelToBeModifiedItem_pC5RLCChannelQoSInformation = CHOICE(name='pC5RLCChannelQoSInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelQoSInformation')), opt=True)
    _PC5RLCChannelToBeModifiedItem_rLCMode = ENUM(name='rLCMode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RLCMode')), opt=True)
    _PC5RLCChannelToBeModifiedItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5RLCChannelToBeModifiedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PC5RLCChannelToBeModifiedItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PC5RLCChannelToBeModifiedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelToBeModifiedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelToBeModifiedItem_iE_Extensions__item__id._const_tab = ____PC5RLCChannelToBeModifiedItem_iE_Extensions__item__id_tab
    ___PC5RLCChannelToBeModifiedItem_iE_Extensions__item__id._const_tab_at = None
    ___PC5RLCChannelToBeModifiedItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PC5RLCChannelToBeModifiedItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PC5RLCChannelToBeModifiedItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelToBeModifiedItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelToBeModifiedItem_iE_Extensions__item__criticality._const_tab = ____PC5RLCChannelToBeModifiedItem_iE_Extensions__item__criticality_tab
    ___PC5RLCChannelToBeModifiedItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PC5RLCChannelToBeModifiedItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PC5RLCChannelToBeModifiedItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PC5RLCChannelToBeModifiedItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelToBeModifiedItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelToBeModifiedItem_iE_Extensions__item__extensionValue._const_tab = ____PC5RLCChannelToBeModifiedItem_iE_Extensions__item__extensionValue_tab
    ___PC5RLCChannelToBeModifiedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PC5RLCChannelToBeModifiedItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PC5RLCChannelToBeModifiedItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PC5RLCChannelToBeModifiedItem_iE_Extensions__item__id),
        ('criticality', ___PC5RLCChannelToBeModifiedItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PC5RLCChannelToBeModifiedItem_iE_Extensions__item__extensionValue),
        ])
    __PC5RLCChannelToBeModifiedItem_iE_Extensions__item_._ext = None
    _PC5RLCChannelToBeModifiedItem_iE_Extensions._cont = __PC5RLCChannelToBeModifiedItem_iE_Extensions__item_
    _PC5RLCChannelToBeModifiedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5RLCChannelToBeModifiedItem._cont = ASN1Dict([
        ('pC5RLCChannelID', _PC5RLCChannelToBeModifiedItem_pC5RLCChannelID),
        ('remoteUELocalID', _PC5RLCChannelToBeModifiedItem_remoteUELocalID),
        ('pC5RLCChannelQoSInformation', _PC5RLCChannelToBeModifiedItem_pC5RLCChannelQoSInformation),
        ('rLCMode', _PC5RLCChannelToBeModifiedItem_rLCMode),
        ('iE-Extensions', _PC5RLCChannelToBeModifiedItem_iE_Extensions),
        ])
    PC5RLCChannelToBeModifiedItem._ext = []
    
    #-----< PC5RLCChannelToBeModifiedItem-ExtIEs >-----#
    PC5RLCChannelToBeModifiedItem_ExtIEs = CLASS(name='PC5RLCChannelToBeModifiedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PC5RLCChannelToBeModifiedItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5RLCChannelToBeReleasedList >-----#
    PC5RLCChannelToBeReleasedList = SEQ_OF(name='PC5RLCChannelToBeReleasedList', mode=MODE_TYPE)
    _PC5RLCChannelToBeReleasedList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelToBeReleasedItem')))
    PC5RLCChannelToBeReleasedList._cont = _PC5RLCChannelToBeReleasedList__item_
    PC5RLCChannelToBeReleasedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< PC5RLCChannelToBeReleasedItem >-----#
    PC5RLCChannelToBeReleasedItem = SEQ(name='PC5RLCChannelToBeReleasedItem', mode=MODE_TYPE)
    _PC5RLCChannelToBeReleasedItem_pC5RLCChannelID = INT(name='pC5RLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelID')))
    _PC5RLCChannelToBeReleasedItem_remoteUELocalID = INT(name='remoteUELocalID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RemoteUELocalID')), opt=True)
    _PC5RLCChannelToBeReleasedItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5RLCChannelToBeReleasedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PC5RLCChannelToBeReleasedItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PC5RLCChannelToBeReleasedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelToBeReleasedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelToBeReleasedItem_iE_Extensions__item__id._const_tab = ____PC5RLCChannelToBeReleasedItem_iE_Extensions__item__id_tab
    ___PC5RLCChannelToBeReleasedItem_iE_Extensions__item__id._const_tab_at = None
    ___PC5RLCChannelToBeReleasedItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PC5RLCChannelToBeReleasedItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PC5RLCChannelToBeReleasedItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelToBeReleasedItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelToBeReleasedItem_iE_Extensions__item__criticality._const_tab = ____PC5RLCChannelToBeReleasedItem_iE_Extensions__item__criticality_tab
    ___PC5RLCChannelToBeReleasedItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PC5RLCChannelToBeReleasedItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PC5RLCChannelToBeReleasedItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PC5RLCChannelToBeReleasedItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelToBeReleasedItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelToBeReleasedItem_iE_Extensions__item__extensionValue._const_tab = ____PC5RLCChannelToBeReleasedItem_iE_Extensions__item__extensionValue_tab
    ___PC5RLCChannelToBeReleasedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PC5RLCChannelToBeReleasedItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PC5RLCChannelToBeReleasedItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PC5RLCChannelToBeReleasedItem_iE_Extensions__item__id),
        ('criticality', ___PC5RLCChannelToBeReleasedItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PC5RLCChannelToBeReleasedItem_iE_Extensions__item__extensionValue),
        ])
    __PC5RLCChannelToBeReleasedItem_iE_Extensions__item_._ext = None
    _PC5RLCChannelToBeReleasedItem_iE_Extensions._cont = __PC5RLCChannelToBeReleasedItem_iE_Extensions__item_
    _PC5RLCChannelToBeReleasedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5RLCChannelToBeReleasedItem._cont = ASN1Dict([
        ('pC5RLCChannelID', _PC5RLCChannelToBeReleasedItem_pC5RLCChannelID),
        ('remoteUELocalID', _PC5RLCChannelToBeReleasedItem_remoteUELocalID),
        ('iE-Extensions', _PC5RLCChannelToBeReleasedItem_iE_Extensions),
        ])
    PC5RLCChannelToBeReleasedItem._ext = []
    
    #-----< PC5RLCChannelToBeReleasedItem-ExtIEs >-----#
    PC5RLCChannelToBeReleasedItem_ExtIEs = CLASS(name='PC5RLCChannelToBeReleasedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PC5RLCChannelToBeReleasedItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5RLCChannelSetupList >-----#
    PC5RLCChannelSetupList = SEQ_OF(name='PC5RLCChannelSetupList', mode=MODE_TYPE)
    _PC5RLCChannelSetupList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelSetupItem')))
    PC5RLCChannelSetupList._cont = _PC5RLCChannelSetupList__item_
    PC5RLCChannelSetupList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< PC5RLCChannelSetupItem >-----#
    PC5RLCChannelSetupItem = SEQ(name='PC5RLCChannelSetupItem', mode=MODE_TYPE)
    _PC5RLCChannelSetupItem_pC5RLCChannelID = INT(name='pC5RLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelID')))
    _PC5RLCChannelSetupItem_remoteUELocalID = INT(name='remoteUELocalID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RemoteUELocalID')), opt=True)
    _PC5RLCChannelSetupItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5RLCChannelSetupItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PC5RLCChannelSetupItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PC5RLCChannelSetupItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelSetupItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelSetupItem_iE_Extensions__item__id._const_tab = ____PC5RLCChannelSetupItem_iE_Extensions__item__id_tab
    ___PC5RLCChannelSetupItem_iE_Extensions__item__id._const_tab_at = None
    ___PC5RLCChannelSetupItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PC5RLCChannelSetupItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PC5RLCChannelSetupItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelSetupItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelSetupItem_iE_Extensions__item__criticality._const_tab = ____PC5RLCChannelSetupItem_iE_Extensions__item__criticality_tab
    ___PC5RLCChannelSetupItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PC5RLCChannelSetupItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PC5RLCChannelSetupItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PC5RLCChannelSetupItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelSetupItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelSetupItem_iE_Extensions__item__extensionValue._const_tab = ____PC5RLCChannelSetupItem_iE_Extensions__item__extensionValue_tab
    ___PC5RLCChannelSetupItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PC5RLCChannelSetupItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PC5RLCChannelSetupItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PC5RLCChannelSetupItem_iE_Extensions__item__id),
        ('criticality', ___PC5RLCChannelSetupItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PC5RLCChannelSetupItem_iE_Extensions__item__extensionValue),
        ])
    __PC5RLCChannelSetupItem_iE_Extensions__item_._ext = None
    _PC5RLCChannelSetupItem_iE_Extensions._cont = __PC5RLCChannelSetupItem_iE_Extensions__item_
    _PC5RLCChannelSetupItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5RLCChannelSetupItem._cont = ASN1Dict([
        ('pC5RLCChannelID', _PC5RLCChannelSetupItem_pC5RLCChannelID),
        ('remoteUELocalID', _PC5RLCChannelSetupItem_remoteUELocalID),
        ('iE-Extensions', _PC5RLCChannelSetupItem_iE_Extensions),
        ])
    PC5RLCChannelSetupItem._ext = []
    
    #-----< PC5RLCChannelSetupItem-ExtIEs >-----#
    PC5RLCChannelSetupItem_ExtIEs = CLASS(name='PC5RLCChannelSetupItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PC5RLCChannelSetupItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5RLCChannelFailedToBeSetupList >-----#
    PC5RLCChannelFailedToBeSetupList = SEQ_OF(name='PC5RLCChannelFailedToBeSetupList', mode=MODE_TYPE)
    _PC5RLCChannelFailedToBeSetupList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelFailedToBeSetupItem')))
    PC5RLCChannelFailedToBeSetupList._cont = _PC5RLCChannelFailedToBeSetupList__item_
    PC5RLCChannelFailedToBeSetupList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< PC5RLCChannelFailedToBeSetupItem >-----#
    PC5RLCChannelFailedToBeSetupItem = SEQ(name='PC5RLCChannelFailedToBeSetupItem', mode=MODE_TYPE)
    _PC5RLCChannelFailedToBeSetupItem_pC5RLCChannelID = INT(name='pC5RLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelID')))
    _PC5RLCChannelFailedToBeSetupItem_remoteUELocalID = INT(name='remoteUELocalID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RemoteUELocalID')), opt=True)
    _PC5RLCChannelFailedToBeSetupItem_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _PC5RLCChannelFailedToBeSetupItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__id._const_tab = ____PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__id_tab
    ___PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__id._const_tab_at = None
    ___PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__criticality._const_tab = ____PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__criticality_tab
    ___PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__extensionValue._const_tab = ____PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__extensionValue_tab
    ___PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__id),
        ('criticality', ___PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__extensionValue),
        ])
    __PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item_._ext = None
    _PC5RLCChannelFailedToBeSetupItem_iE_Extensions._cont = __PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item_
    _PC5RLCChannelFailedToBeSetupItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5RLCChannelFailedToBeSetupItem._cont = ASN1Dict([
        ('pC5RLCChannelID', _PC5RLCChannelFailedToBeSetupItem_pC5RLCChannelID),
        ('remoteUELocalID', _PC5RLCChannelFailedToBeSetupItem_remoteUELocalID),
        ('cause', _PC5RLCChannelFailedToBeSetupItem_cause),
        ('iE-Extensions', _PC5RLCChannelFailedToBeSetupItem_iE_Extensions),
        ])
    PC5RLCChannelFailedToBeSetupItem._ext = []
    
    #-----< PC5RLCChannelFailedToBeSetupItem-ExtIEs >-----#
    PC5RLCChannelFailedToBeSetupItem_ExtIEs = CLASS(name='PC5RLCChannelFailedToBeSetupItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PC5RLCChannelFailedToBeSetupItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5RLCChannelModifiedList >-----#
    PC5RLCChannelModifiedList = SEQ_OF(name='PC5RLCChannelModifiedList', mode=MODE_TYPE)
    _PC5RLCChannelModifiedList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelModifiedItem')))
    PC5RLCChannelModifiedList._cont = _PC5RLCChannelModifiedList__item_
    PC5RLCChannelModifiedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< PC5RLCChannelModifiedItem >-----#
    PC5RLCChannelModifiedItem = SEQ(name='PC5RLCChannelModifiedItem', mode=MODE_TYPE)
    _PC5RLCChannelModifiedItem_pC5RLCChannelID = INT(name='pC5RLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelID')))
    _PC5RLCChannelModifiedItem_remoteUELocalID = INT(name='remoteUELocalID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RemoteUELocalID')), opt=True)
    _PC5RLCChannelModifiedItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5RLCChannelModifiedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PC5RLCChannelModifiedItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PC5RLCChannelModifiedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelModifiedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelModifiedItem_iE_Extensions__item__id._const_tab = ____PC5RLCChannelModifiedItem_iE_Extensions__item__id_tab
    ___PC5RLCChannelModifiedItem_iE_Extensions__item__id._const_tab_at = None
    ___PC5RLCChannelModifiedItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PC5RLCChannelModifiedItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PC5RLCChannelModifiedItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelModifiedItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelModifiedItem_iE_Extensions__item__criticality._const_tab = ____PC5RLCChannelModifiedItem_iE_Extensions__item__criticality_tab
    ___PC5RLCChannelModifiedItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PC5RLCChannelModifiedItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PC5RLCChannelModifiedItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PC5RLCChannelModifiedItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelModifiedItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelModifiedItem_iE_Extensions__item__extensionValue._const_tab = ____PC5RLCChannelModifiedItem_iE_Extensions__item__extensionValue_tab
    ___PC5RLCChannelModifiedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PC5RLCChannelModifiedItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PC5RLCChannelModifiedItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PC5RLCChannelModifiedItem_iE_Extensions__item__id),
        ('criticality', ___PC5RLCChannelModifiedItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PC5RLCChannelModifiedItem_iE_Extensions__item__extensionValue),
        ])
    __PC5RLCChannelModifiedItem_iE_Extensions__item_._ext = None
    _PC5RLCChannelModifiedItem_iE_Extensions._cont = __PC5RLCChannelModifiedItem_iE_Extensions__item_
    _PC5RLCChannelModifiedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5RLCChannelModifiedItem._cont = ASN1Dict([
        ('pC5RLCChannelID', _PC5RLCChannelModifiedItem_pC5RLCChannelID),
        ('remoteUELocalID', _PC5RLCChannelModifiedItem_remoteUELocalID),
        ('iE-Extensions', _PC5RLCChannelModifiedItem_iE_Extensions),
        ])
    PC5RLCChannelModifiedItem._ext = []
    
    #-----< PC5RLCChannelModifiedItem-ExtIEs >-----#
    PC5RLCChannelModifiedItem_ExtIEs = CLASS(name='PC5RLCChannelModifiedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PC5RLCChannelModifiedItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5RLCChannelFailedToBeModifiedList >-----#
    PC5RLCChannelFailedToBeModifiedList = SEQ_OF(name='PC5RLCChannelFailedToBeModifiedList', mode=MODE_TYPE)
    _PC5RLCChannelFailedToBeModifiedList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelFailedToBeModifiedItem')))
    PC5RLCChannelFailedToBeModifiedList._cont = _PC5RLCChannelFailedToBeModifiedList__item_
    PC5RLCChannelFailedToBeModifiedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< PC5RLCChannelFailedToBeModifiedItem >-----#
    PC5RLCChannelFailedToBeModifiedItem = SEQ(name='PC5RLCChannelFailedToBeModifiedItem', mode=MODE_TYPE)
    _PC5RLCChannelFailedToBeModifiedItem_pC5RLCChannelID = INT(name='pC5RLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelID')))
    _PC5RLCChannelFailedToBeModifiedItem_remoteUELocalID = INT(name='remoteUELocalID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RemoteUELocalID')), opt=True)
    _PC5RLCChannelFailedToBeModifiedItem_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _PC5RLCChannelFailedToBeModifiedItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__id._const_tab = ____PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__id_tab
    ___PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__id._const_tab_at = None
    ___PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__criticality._const_tab = ____PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__criticality_tab
    ___PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__extensionValue._const_tab = ____PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__extensionValue_tab
    ___PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__id),
        ('criticality', ___PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__extensionValue),
        ])
    __PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item_._ext = None
    _PC5RLCChannelFailedToBeModifiedItem_iE_Extensions._cont = __PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item_
    _PC5RLCChannelFailedToBeModifiedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5RLCChannelFailedToBeModifiedItem._cont = ASN1Dict([
        ('pC5RLCChannelID', _PC5RLCChannelFailedToBeModifiedItem_pC5RLCChannelID),
        ('remoteUELocalID', _PC5RLCChannelFailedToBeModifiedItem_remoteUELocalID),
        ('cause', _PC5RLCChannelFailedToBeModifiedItem_cause),
        ('iE-Extensions', _PC5RLCChannelFailedToBeModifiedItem_iE_Extensions),
        ])
    PC5RLCChannelFailedToBeModifiedItem._ext = []
    
    #-----< PC5RLCChannelFailedToBeModifiedItem-ExtIEs >-----#
    PC5RLCChannelFailedToBeModifiedItem_ExtIEs = CLASS(name='PC5RLCChannelFailedToBeModifiedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PC5RLCChannelFailedToBeModifiedItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5RLCChannelRequiredToBeModifiedList >-----#
    PC5RLCChannelRequiredToBeModifiedList = SEQ_OF(name='PC5RLCChannelRequiredToBeModifiedList', mode=MODE_TYPE)
    _PC5RLCChannelRequiredToBeModifiedList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelRequiredToBeModifiedItem')))
    PC5RLCChannelRequiredToBeModifiedList._cont = _PC5RLCChannelRequiredToBeModifiedList__item_
    PC5RLCChannelRequiredToBeModifiedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< PC5RLCChannelRequiredToBeModifiedItem >-----#
    PC5RLCChannelRequiredToBeModifiedItem = SEQ(name='PC5RLCChannelRequiredToBeModifiedItem', mode=MODE_TYPE)
    _PC5RLCChannelRequiredToBeModifiedItem_pC5RLCChannelID = INT(name='pC5RLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelID')))
    _PC5RLCChannelRequiredToBeModifiedItem_remoteUELocalID = INT(name='remoteUELocalID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RemoteUELocalID')), opt=True)
    _PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__id._const_tab = ____PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__id_tab
    ___PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__id._const_tab_at = None
    ___PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__criticality._const_tab = ____PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__criticality_tab
    ___PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__extensionValue._const_tab = ____PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__extensionValue_tab
    ___PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__id),
        ('criticality', ___PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__extensionValue),
        ])
    __PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item_._ext = None
    _PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions._cont = __PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item_
    _PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5RLCChannelRequiredToBeModifiedItem._cont = ASN1Dict([
        ('pC5RLCChannelID', _PC5RLCChannelRequiredToBeModifiedItem_pC5RLCChannelID),
        ('remoteUELocalID', _PC5RLCChannelRequiredToBeModifiedItem_remoteUELocalID),
        ('iE-Extensions', _PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions),
        ])
    PC5RLCChannelRequiredToBeModifiedItem._ext = []
    
    #-----< PC5RLCChannelRequiredToBeModifiedItem-ExtIEs >-----#
    PC5RLCChannelRequiredToBeModifiedItem_ExtIEs = CLASS(name='PC5RLCChannelRequiredToBeModifiedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PC5RLCChannelRequiredToBeModifiedItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5RLCChannelRequiredToBeReleasedList >-----#
    PC5RLCChannelRequiredToBeReleasedList = SEQ_OF(name='PC5RLCChannelRequiredToBeReleasedList', mode=MODE_TYPE)
    _PC5RLCChannelRequiredToBeReleasedList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelRequiredToBeReleasedItem')))
    PC5RLCChannelRequiredToBeReleasedList._cont = _PC5RLCChannelRequiredToBeReleasedList__item_
    PC5RLCChannelRequiredToBeReleasedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< PC5RLCChannelRequiredToBeReleasedItem >-----#
    PC5RLCChannelRequiredToBeReleasedItem = SEQ(name='PC5RLCChannelRequiredToBeReleasedItem', mode=MODE_TYPE)
    _PC5RLCChannelRequiredToBeReleasedItem_pC5RLCChannelID = INT(name='pC5RLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelID')))
    _PC5RLCChannelRequiredToBeReleasedItem_remoteUELocalID = INT(name='remoteUELocalID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RemoteUELocalID')), opt=True)
    _PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__id._const_tab = ____PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__id_tab
    ___PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__id._const_tab_at = None
    ___PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__criticality._const_tab = ____PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__criticality_tab
    ___PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__extensionValue._const_tab = ____PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__extensionValue_tab
    ___PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__id),
        ('criticality', ___PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__extensionValue),
        ])
    __PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item_._ext = None
    _PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions._cont = __PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item_
    _PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5RLCChannelRequiredToBeReleasedItem._cont = ASN1Dict([
        ('pC5RLCChannelID', _PC5RLCChannelRequiredToBeReleasedItem_pC5RLCChannelID),
        ('remoteUELocalID', _PC5RLCChannelRequiredToBeReleasedItem_remoteUELocalID),
        ('iE-Extensions', _PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions),
        ])
    PC5RLCChannelRequiredToBeReleasedItem._ext = []
    
    #-----< PC5RLCChannelRequiredToBeReleasedItem-ExtIEs >-----#
    PC5RLCChannelRequiredToBeReleasedItem_ExtIEs = CLASS(name='PC5RLCChannelRequiredToBeReleasedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PC5RLCChannelRequiredToBeReleasedItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDCCH-BlindDetectionSCG >-----#
    PDCCH_BlindDetectionSCG = OCT_STR(name='PDCCH-BlindDetectionSCG', mode=MODE_TYPE)
    
    #-----< PDCMeasurementPeriodicity >-----#
    PDCMeasurementPeriodicity = ENUM(name='PDCMeasurementPeriodicity', mode=MODE_TYPE)
    PDCMeasurementPeriodicity._cont = ASN1Dict([('ms80', 0), ('ms120', 1), ('ms160', 2), ('ms240', 3), ('ms320', 4), ('ms480', 5), ('ms640', 6), ('ms1024', 7), ('ms1280', 8), ('ms2048', 9), ('ms2560', 10), ('ms5120', 11)])
    PDCMeasurementPeriodicity._ext = []
    
    #-----< PDCMeasurementQuantities >-----#
    PDCMeasurementQuantities = SEQ_OF(name='PDCMeasurementQuantities', mode=MODE_TYPE)
    _PDCMeasurementQuantities__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __PDCMeasurementQuantities__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___PDCMeasurementQuantities__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____PDCMeasurementQuantities__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCMeasurementQuantities-Item')))
    ___PDCMeasurementQuantities__item__id_tab._val = ASN1Set(rv=[dict([('id', 543), ('criticality', 'reject'), ('Value', ____PDCMeasurementQuantities__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __PDCMeasurementQuantities__item__id._const_tab = ___PDCMeasurementQuantities__item__id_tab
    __PDCMeasurementQuantities__item__id._const_tab_at = None
    __PDCMeasurementQuantities__item__id._const_tab_id = 'id'
    __PDCMeasurementQuantities__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __PDCMeasurementQuantities__item__criticality._const_tab = ___PDCMeasurementQuantities__item__id_tab
    __PDCMeasurementQuantities__item__criticality._const_tab_at = ('..', 'id')
    __PDCMeasurementQuantities__item__criticality._const_tab_id = 'criticality'
    __PDCMeasurementQuantities__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __PDCMeasurementQuantities__item__value._const_tab = ___PDCMeasurementQuantities__item__id_tab
    __PDCMeasurementQuantities__item__value._const_tab_at = ('..', 'id')
    __PDCMeasurementQuantities__item__value._const_tab_id = 'Value'
    _PDCMeasurementQuantities__item_._cont = ASN1Dict([
        ('id', __PDCMeasurementQuantities__item__id),
        ('criticality', __PDCMeasurementQuantities__item__criticality),
        ('value', __PDCMeasurementQuantities__item__value),
        ])
    _PDCMeasurementQuantities__item_._ext = None
    PDCMeasurementQuantities._cont = _PDCMeasurementQuantities__item_
    PDCMeasurementQuantities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PDCMeasurementQuantities-ItemIEs >-----#
    PDCMeasurementQuantities_ItemIEs = CLASS(name='PDCMeasurementQuantities-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PDCMeasurementQuantities_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCMeasurementQuantities-Item')))
    PDCMeasurementQuantities_ItemIEs._val = ASN1Set(rv=[dict([('id', 543), ('criticality', 'reject'), ('Value', _PDCMeasurementQuantities_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< PDCMeasurementQuantities-Item >-----#
    PDCMeasurementQuantities_Item = SEQ(name='PDCMeasurementQuantities-Item', mode=MODE_TYPE)
    _PDCMeasurementQuantities_Item_pDCmeasurementQuantitiesValue = ENUM(name='pDCmeasurementQuantitiesValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PDCMeasurementQuantitiesValue')))
    _PDCMeasurementQuantities_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDCMeasurementQuantities_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PDCMeasurementQuantities_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PDCMeasurementQuantities_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PDCMeasurementQuantities_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDCMeasurementQuantities_Item_iE_Extensions__item__id._const_tab = ____PDCMeasurementQuantities_Item_iE_Extensions__item__id_tab
    ___PDCMeasurementQuantities_Item_iE_Extensions__item__id._const_tab_at = None
    ___PDCMeasurementQuantities_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDCMeasurementQuantities_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDCMeasurementQuantities_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PDCMeasurementQuantities_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDCMeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab = ____PDCMeasurementQuantities_Item_iE_Extensions__item__criticality_tab
    ___PDCMeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDCMeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDCMeasurementQuantities_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDCMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PDCMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDCMeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab = ____PDCMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab
    ___PDCMeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDCMeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDCMeasurementQuantities_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDCMeasurementQuantities_Item_iE_Extensions__item__id),
        ('criticality', ___PDCMeasurementQuantities_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PDCMeasurementQuantities_Item_iE_Extensions__item__extensionValue),
        ])
    __PDCMeasurementQuantities_Item_iE_Extensions__item_._ext = None
    _PDCMeasurementQuantities_Item_iE_Extensions._cont = __PDCMeasurementQuantities_Item_iE_Extensions__item_
    _PDCMeasurementQuantities_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDCMeasurementQuantities_Item._cont = ASN1Dict([
        ('pDCmeasurementQuantitiesValue', _PDCMeasurementQuantities_Item_pDCmeasurementQuantitiesValue),
        ('iE-Extensions', _PDCMeasurementQuantities_Item_iE_Extensions),
        ])
    PDCMeasurementQuantities_Item._ext = None
    
    #-----< PDCMeasurementQuantitiesValue-ExtIEs >-----#
    PDCMeasurementQuantitiesValue_ExtIEs = CLASS(name='PDCMeasurementQuantitiesValue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PDCMeasurementQuantitiesValue_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDCMeasurementQuantitiesValue >-----#
    PDCMeasurementQuantitiesValue = ENUM(name='PDCMeasurementQuantitiesValue', mode=MODE_TYPE)
    PDCMeasurementQuantitiesValue._cont = ASN1Dict([('nr-pdc-tadv', 0), ('gNB-rx-tx', 1)])
    PDCMeasurementQuantitiesValue._ext = []
    
    #-----< PDCMeasurementResult >-----#
    PDCMeasurementResult = SEQ(name='PDCMeasurementResult', mode=MODE_TYPE)
    _PDCMeasurementResult_pDCMeasuredResultsList = SEQ_OF(name='pDCMeasuredResultsList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PDCMeasuredResultsList')))
    _PDCMeasurementResult_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDCMeasurementResult_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PDCMeasurementResult_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PDCMeasurementResult_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PDCMeasurementResult_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDCMeasurementResult_iE_Extensions__item__id._const_tab = ____PDCMeasurementResult_iE_Extensions__item__id_tab
    ___PDCMeasurementResult_iE_Extensions__item__id._const_tab_at = None
    ___PDCMeasurementResult_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDCMeasurementResult_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDCMeasurementResult_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PDCMeasurementResult_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDCMeasurementResult_iE_Extensions__item__criticality._const_tab = ____PDCMeasurementResult_iE_Extensions__item__criticality_tab
    ___PDCMeasurementResult_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDCMeasurementResult_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDCMeasurementResult_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDCMeasurementResult_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PDCMeasurementResult_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDCMeasurementResult_iE_Extensions__item__extensionValue._const_tab = ____PDCMeasurementResult_iE_Extensions__item__extensionValue_tab
    ___PDCMeasurementResult_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDCMeasurementResult_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDCMeasurementResult_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDCMeasurementResult_iE_Extensions__item__id),
        ('criticality', ___PDCMeasurementResult_iE_Extensions__item__criticality),
        ('extensionValue', ___PDCMeasurementResult_iE_Extensions__item__extensionValue),
        ])
    __PDCMeasurementResult_iE_Extensions__item_._ext = None
    _PDCMeasurementResult_iE_Extensions._cont = __PDCMeasurementResult_iE_Extensions__item_
    _PDCMeasurementResult_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDCMeasurementResult._cont = ASN1Dict([
        ('pDCMeasuredResultsList', _PDCMeasurementResult_pDCMeasuredResultsList),
        ('iE-Extensions', _PDCMeasurementResult_iE_Extensions),
        ])
    PDCMeasurementResult._ext = None
    
    #-----< PDCMeasurementResult-ExtIEs >-----#
    PDCMeasurementResult_ExtIEs = CLASS(name='PDCMeasurementResult-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PDCMeasurementResult_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDCMeasuredResultsList >-----#
    PDCMeasuredResultsList = SEQ_OF(name='PDCMeasuredResultsList', mode=MODE_TYPE)
    _PDCMeasuredResultsList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCMeasuredResults-Item')))
    PDCMeasuredResultsList._cont = _PDCMeasuredResultsList__item_
    PDCMeasuredResultsList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PDCMeasuredResults-Item >-----#
    PDCMeasuredResults_Item = SEQ(name='PDCMeasuredResults-Item', mode=MODE_TYPE)
    _PDCMeasuredResults_Item_pDCMeasuredResults_Value = CHOICE(name='pDCMeasuredResults-Value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PDCMeasuredResults-Value')))
    _PDCMeasuredResults_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDCMeasuredResults_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PDCMeasuredResults_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PDCMeasuredResults_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PDCMeasuredResults_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDCMeasuredResults_Item_iE_Extensions__item__id._const_tab = ____PDCMeasuredResults_Item_iE_Extensions__item__id_tab
    ___PDCMeasuredResults_Item_iE_Extensions__item__id._const_tab_at = None
    ___PDCMeasuredResults_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDCMeasuredResults_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDCMeasuredResults_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PDCMeasuredResults_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDCMeasuredResults_Item_iE_Extensions__item__criticality._const_tab = ____PDCMeasuredResults_Item_iE_Extensions__item__criticality_tab
    ___PDCMeasuredResults_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDCMeasuredResults_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDCMeasuredResults_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDCMeasuredResults_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PDCMeasuredResults_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDCMeasuredResults_Item_iE_Extensions__item__extensionValue._const_tab = ____PDCMeasuredResults_Item_iE_Extensions__item__extensionValue_tab
    ___PDCMeasuredResults_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDCMeasuredResults_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDCMeasuredResults_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDCMeasuredResults_Item_iE_Extensions__item__id),
        ('criticality', ___PDCMeasuredResults_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PDCMeasuredResults_Item_iE_Extensions__item__extensionValue),
        ])
    __PDCMeasuredResults_Item_iE_Extensions__item_._ext = None
    _PDCMeasuredResults_Item_iE_Extensions._cont = __PDCMeasuredResults_Item_iE_Extensions__item_
    _PDCMeasuredResults_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDCMeasuredResults_Item._cont = ASN1Dict([
        ('pDCMeasuredResults-Value', _PDCMeasuredResults_Item_pDCMeasuredResults_Value),
        ('iE-Extensions', _PDCMeasuredResults_Item_iE_Extensions),
        ])
    PDCMeasuredResults_Item._ext = None
    
    #-----< PDCMeasuredResults-Item-ExtIEs >-----#
    PDCMeasuredResults_Item_ExtIEs = CLASS(name='PDCMeasuredResults-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PDCMeasuredResults_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDCMeasuredResults-Value >-----#
    PDCMeasuredResults_Value = CHOICE(name='PDCMeasuredResults-Value', mode=MODE_TYPE)
    _PDCMeasuredResults_Value_pDC_TADV_NR = INT(name='pDC-TADV-NR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PDC-TADV-NR')))
    _PDCMeasuredResults_Value_pDC_RxTxTimeDiff = INT(name='pDC-RxTxTimeDiff', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PDC-RxTxTimeDiff')))
    _PDCMeasuredResults_Value_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __PDCMeasuredResults_Value_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___PDCMeasuredResults_Value_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PDCMeasuredResults_Value_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PDCMeasuredResults_Value_choice_extension_id._const_tab = ___PDCMeasuredResults_Value_choice_extension_id_tab
    __PDCMeasuredResults_Value_choice_extension_id._const_tab_at = None
    __PDCMeasuredResults_Value_choice_extension_id._const_tab_id = 'id'
    __PDCMeasuredResults_Value_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PDCMeasuredResults_Value_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PDCMeasuredResults_Value_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PDCMeasuredResults_Value_choice_extension_criticality._const_tab = ___PDCMeasuredResults_Value_choice_extension_criticality_tab
    __PDCMeasuredResults_Value_choice_extension_criticality._const_tab_at = ('..', 'id')
    __PDCMeasuredResults_Value_choice_extension_criticality._const_tab_id = 'criticality'
    __PDCMeasuredResults_Value_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PDCMeasuredResults_Value_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PDCMeasuredResults_Value_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PDCMeasuredResults_Value_choice_extension_value._const_tab = ___PDCMeasuredResults_Value_choice_extension_value_tab
    __PDCMeasuredResults_Value_choice_extension_value._const_tab_at = ('..', 'id')
    __PDCMeasuredResults_Value_choice_extension_value._const_tab_id = 'Value'
    _PDCMeasuredResults_Value_choice_extension._cont = ASN1Dict([
        ('id', __PDCMeasuredResults_Value_choice_extension_id),
        ('criticality', __PDCMeasuredResults_Value_choice_extension_criticality),
        ('value', __PDCMeasuredResults_Value_choice_extension_value),
        ])
    _PDCMeasuredResults_Value_choice_extension._ext = None
    PDCMeasuredResults_Value._cont = ASN1Dict([
        ('pDC-TADV-NR', _PDCMeasuredResults_Value_pDC_TADV_NR),
        ('pDC-RxTxTimeDiff', _PDCMeasuredResults_Value_pDC_RxTxTimeDiff),
        ('choice-extension', _PDCMeasuredResults_Value_choice_extension),
        ])
    PDCMeasuredResults_Value._ext = None
    
    #-----< PDCMeasuredResults-Value-ExtIEs >-----#
    PDCMeasuredResults_Value_ExtIEs = CLASS(name='PDCMeasuredResults-Value-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    PDCMeasuredResults_Value_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDCReportType >-----#
    PDCReportType = ENUM(name='PDCReportType', mode=MODE_TYPE)
    PDCReportType._cont = ASN1Dict([('onDemand', 0), ('periodic', 1)])
    PDCReportType._ext = []
    
    #-----< PDC-RxTxTimeDiff >-----#
    PDC_RxTxTimeDiff = INT(name='PDC-RxTxTimeDiff', mode=MODE_TYPE)
    PDC_RxTxTimeDiff._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=61565)], ev=[], er=[])
    
    #-----< PDC-TADV-NR >-----#
    PDC_TADV_NR = INT(name='PDC-TADV-NR', mode=MODE_TYPE)
    PDC_TADV_NR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=62500)], ev=[], er=[])
    
    #-----< PDCP-SN >-----#
    PDCP_SN = INT(name='PDCP-SN', mode=MODE_TYPE)
    PDCP_SN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< PDCPSNLength >-----#
    PDCPSNLength = ENUM(name='PDCPSNLength', mode=MODE_TYPE)
    PDCPSNLength._cont = ASN1Dict([('twelve-bits', 0), ('eighteen-bits', 1)])
    PDCPSNLength._ext = []
    
    #-----< PDUSessionID >-----#
    PDUSessionID = INT(name='PDUSessionID', mode=MODE_TYPE)
    PDUSessionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< PEISubgroupingSupportIndication >-----#
    PEISubgroupingSupportIndication = ENUM(name='PEISubgroupingSupportIndication', mode=MODE_TYPE)
    PEISubgroupingSupportIndication._cont = ASN1Dict([('true', 0)])
    PEISubgroupingSupportIndication._ext = []
    
    #-----< ReportingPeriodicityValue >-----#
    ReportingPeriodicityValue = INT(name='ReportingPeriodicityValue', mode=MODE_TYPE)
    ReportingPeriodicityValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=512)], ev=[], er=[])
    
    #-----< Periodicity >-----#
    Periodicity = INT(name='Periodicity', mode=MODE_TYPE)
    Periodicity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=640000)], ev=[], er=[])
    
    #-----< PeriodicitySRS >-----#
    PeriodicitySRS = ENUM(name='PeriodicitySRS', mode=MODE_TYPE)
    PeriodicitySRS._cont = ASN1Dict([('ms0p125', 0), ('ms0p25', 1), ('ms0p5', 2), ('ms0p625', 3), ('ms1', 4), ('ms1p25', 5), ('ms2', 6), ('ms2p5', 7), ('ms4', 8), ('ms5', 9), ('ms8', 10), ('ms10', 11), ('ms16', 12), ('ms20', 13), ('ms32', 14), ('ms40', 15), ('ms64', 16), ('ms80', 17), ('ms160', 18), ('ms320', 19), ('ms640', 20), ('ms1280', 21), ('ms2560', 22), ('ms5120', 23), ('ms10240', 24)])
    PeriodicitySRS._ext = []
    
    #-----< PeriodicityList >-----#
    PeriodicityList = SEQ_OF(name='PeriodicityList', mode=MODE_TYPE)
    _PeriodicityList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PeriodicityList-Item')))
    PeriodicityList._cont = _PeriodicityList__item_
    PeriodicityList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PeriodicityList-Item >-----#
    PeriodicityList_Item = SEQ(name='PeriodicityList-Item', mode=MODE_TYPE)
    _PeriodicityList_Item_periodicitySRS = ENUM(name='periodicitySRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PeriodicitySRS')))
    _PeriodicityList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PeriodicityList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PeriodicityList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PeriodicityList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PeriodicityList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PeriodicityList_Item_iE_Extensions__item__id._const_tab = ____PeriodicityList_Item_iE_Extensions__item__id_tab
    ___PeriodicityList_Item_iE_Extensions__item__id._const_tab_at = None
    ___PeriodicityList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PeriodicityList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PeriodicityList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PeriodicityList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PeriodicityList_Item_iE_Extensions__item__criticality._const_tab = ____PeriodicityList_Item_iE_Extensions__item__criticality_tab
    ___PeriodicityList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PeriodicityList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PeriodicityList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PeriodicityList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PeriodicityList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PeriodicityList_Item_iE_Extensions__item__extensionValue._const_tab = ____PeriodicityList_Item_iE_Extensions__item__extensionValue_tab
    ___PeriodicityList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PeriodicityList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PeriodicityList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PeriodicityList_Item_iE_Extensions__item__id),
        ('criticality', ___PeriodicityList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PeriodicityList_Item_iE_Extensions__item__extensionValue),
        ])
    __PeriodicityList_Item_iE_Extensions__item_._ext = None
    _PeriodicityList_Item_iE_Extensions._cont = __PeriodicityList_Item_iE_Extensions__item_
    _PeriodicityList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PeriodicityList_Item._cont = ASN1Dict([
        ('periodicitySRS', _PeriodicityList_Item_periodicitySRS),
        ('iE-Extensions', _PeriodicityList_Item_iE_Extensions),
        ])
    PeriodicityList_Item._ext = None
    
    #-----< PeriodicityList-ItemExtIEs >-----#
    PeriodicityList_ItemExtIEs = CLASS(name='PeriodicityList-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PeriodicityList_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Permutation >-----#
    Permutation = ENUM(name='Permutation', mode=MODE_TYPE)
    Permutation._cont = ASN1Dict([('dfu', 0), ('ufd', 1)])
    Permutation._ext = []
    
    #-----< Ph-InfoMCG >-----#
    Ph_InfoMCG = OCT_STR(name='Ph-InfoMCG', mode=MODE_TYPE)
    
    #-----< Ph-InfoSCG >-----#
    Ph_InfoSCG = OCT_STR(name='Ph-InfoSCG', mode=MODE_TYPE)
    
    #-----< PLMN-Identity >-----#
    PLMN_Identity = OCT_STR(name='PLMN-Identity', mode=MODE_TYPE)
    PLMN_Identity._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< PlayoutDelayForMediaStartup >-----#
    PlayoutDelayForMediaStartup = OCT_STR(name='PlayoutDelayForMediaStartup', mode=MODE_TYPE)
    
    #-----< PortNumber >-----#
    PortNumber = BIT_STR(name='PortNumber', mode=MODE_TYPE)
    PortNumber._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< PosAssistance-Information >-----#
    PosAssistance_Information = OCT_STR(name='PosAssistance-Information', mode=MODE_TYPE)
    
    #-----< PosAssistanceInformationFailureList >-----#
    PosAssistanceInformationFailureList = OCT_STR(name='PosAssistanceInformationFailureList', mode=MODE_TYPE)
    
    #-----< PosBroadcast >-----#
    PosBroadcast = ENUM(name='PosBroadcast', mode=MODE_TYPE)
    PosBroadcast._cont = ASN1Dict([('start', 0), ('stop', 1)])
    PosBroadcast._ext = []
    
    #-----< PosConextRevIndication >-----#
    PosConextRevIndication = ENUM(name='PosConextRevIndication', mode=MODE_TYPE)
    PosConextRevIndication._cont = ASN1Dict([('true', 0)])
    PosConextRevIndication._ext = []
    
    #-----< PositioningBroadcastCells >-----#
    PositioningBroadcastCells = SEQ_OF(name='PositioningBroadcastCells', mode=MODE_TYPE)
    _PositioningBroadcastCells__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    PositioningBroadcastCells._cont = _PositioningBroadcastCells__item_
    PositioningBroadcastCells._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< PosMeasGapPreConfigList >-----#
    PosMeasGapPreConfigList = SEQ(name='PosMeasGapPreConfigList', mode=MODE_TYPE)
    _PosMeasGapPreConfigList_posMeasGapPreConfigToAddModList = OCT_STR(name='posMeasGapPreConfigToAddModList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PosMeasGapPreConfigList_posMeasGapPreConfigToReleaseList = OCT_STR(name='posMeasGapPreConfigToReleaseList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PosMeasGapPreConfigList_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosMeasGapPreConfigList_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PosMeasGapPreConfigList_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PosMeasGapPreConfigList_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosMeasGapPreConfigList_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosMeasGapPreConfigList_iE_Extensions__item__id._const_tab = ____PosMeasGapPreConfigList_iE_Extensions__item__id_tab
    ___PosMeasGapPreConfigList_iE_Extensions__item__id._const_tab_at = None
    ___PosMeasGapPreConfigList_iE_Extensions__item__id._const_tab_id = 'id'
    ___PosMeasGapPreConfigList_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PosMeasGapPreConfigList_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosMeasGapPreConfigList_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosMeasGapPreConfigList_iE_Extensions__item__criticality._const_tab = ____PosMeasGapPreConfigList_iE_Extensions__item__criticality_tab
    ___PosMeasGapPreConfigList_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PosMeasGapPreConfigList_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PosMeasGapPreConfigList_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PosMeasGapPreConfigList_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosMeasGapPreConfigList_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosMeasGapPreConfigList_iE_Extensions__item__extensionValue._const_tab = ____PosMeasGapPreConfigList_iE_Extensions__item__extensionValue_tab
    ___PosMeasGapPreConfigList_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PosMeasGapPreConfigList_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PosMeasGapPreConfigList_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PosMeasGapPreConfigList_iE_Extensions__item__id),
        ('criticality', ___PosMeasGapPreConfigList_iE_Extensions__item__criticality),
        ('extensionValue', ___PosMeasGapPreConfigList_iE_Extensions__item__extensionValue),
        ])
    __PosMeasGapPreConfigList_iE_Extensions__item_._ext = None
    _PosMeasGapPreConfigList_iE_Extensions._cont = __PosMeasGapPreConfigList_iE_Extensions__item_
    _PosMeasGapPreConfigList_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosMeasGapPreConfigList._cont = ASN1Dict([
        ('posMeasGapPreConfigToAddModList', _PosMeasGapPreConfigList_posMeasGapPreConfigToAddModList),
        ('posMeasGapPreConfigToReleaseList', _PosMeasGapPreConfigList_posMeasGapPreConfigToReleaseList),
        ('iE-Extensions', _PosMeasGapPreConfigList_iE_Extensions),
        ])
    PosMeasGapPreConfigList._ext = None
    
    #-----< PosMeasGapPreConfigList-ExtIEs >-----#
    PosMeasGapPreConfigList_ExtIEs = CLASS(name='PosMeasGapPreConfigList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PosMeasGapPreConfigList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MeasurementPeriodicity >-----#
    MeasurementPeriodicity = ENUM(name='MeasurementPeriodicity', mode=MODE_TYPE)
    MeasurementPeriodicity._cont = ASN1Dict([('ms120', 0), ('ms240', 1), ('ms480', 2), ('ms640', 3), ('ms1024', 4), ('ms2048', 5), ('ms5120', 6), ('ms10240', 7), ('min1', 8), ('min6', 9), ('min12', 10), ('min30', 11), ('ms20480', 12), ('ms40960', 13), ('extended', 14)])
    MeasurementPeriodicity._ext = ['ms20480', 'ms40960', 'extended']
    
    #-----< MeasurementPeriodicityExtended >-----#
    MeasurementPeriodicityExtended = ENUM(name='MeasurementPeriodicityExtended', mode=MODE_TYPE)
    MeasurementPeriodicityExtended._cont = ASN1Dict([('ms160', 0), ('ms320', 1), ('ms1280', 2), ('ms2560', 3), ('ms61440', 4), ('ms81920', 5), ('ms368640', 6), ('ms737280', 7), ('ms1843200', 8)])
    MeasurementPeriodicityExtended._ext = []
    
    #-----< PosMeasurementPeriodicityNR-AoA >-----#
    PosMeasurementPeriodicityNR_AoA = ENUM(name='PosMeasurementPeriodicityNR-AoA', mode=MODE_TYPE)
    PosMeasurementPeriodicityNR_AoA._cont = ASN1Dict([('ms160', 0), ('ms320', 1), ('ms640', 2), ('ms1280', 3), ('ms2560', 4), ('ms5120', 5), ('ms10240', 6), ('ms20480', 7), ('ms40960', 8), ('ms61440', 9), ('ms81920', 10), ('ms368640', 11), ('ms737280', 12), ('ms1843200', 13)])
    PosMeasurementPeriodicityNR_AoA._ext = []
    
    #-----< PosMeasurementQuantities >-----#
    PosMeasurementQuantities = SEQ_OF(name='PosMeasurementQuantities', mode=MODE_TYPE)
    _PosMeasurementQuantities__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementQuantities-Item')))
    PosMeasurementQuantities._cont = _PosMeasurementQuantities__item_
    PosMeasurementQuantities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< PosMeasurementQuantities-Item >-----#
    PosMeasurementQuantities_Item = SEQ(name='PosMeasurementQuantities-Item', mode=MODE_TYPE)
    _PosMeasurementQuantities_Item_posMeasurementType = ENUM(name='posMeasurementType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementType')))
    _PosMeasurementQuantities_Item_timingReportingGranularityFactor = INT(name='timingReportingGranularityFactor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PosMeasurementQuantities_Item_timingReportingGranularityFactor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5)], ev=None, er=[])
    _PosMeasurementQuantities_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosMeasurementQuantities_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PosMeasurementQuantities_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PosMeasurementQuantities_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosMeasurementQuantities_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosMeasurementQuantities_Item_iE_Extensions__item__id._const_tab = ____PosMeasurementQuantities_Item_iE_Extensions__item__id_tab
    ___PosMeasurementQuantities_Item_iE_Extensions__item__id._const_tab_at = None
    ___PosMeasurementQuantities_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PosMeasurementQuantities_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PosMeasurementQuantities_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosMeasurementQuantities_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosMeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab = ____PosMeasurementQuantities_Item_iE_Extensions__item__criticality_tab
    ___PosMeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PosMeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PosMeasurementQuantities_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PosMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosMeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab = ____PosMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab
    ___PosMeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PosMeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PosMeasurementQuantities_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PosMeasurementQuantities_Item_iE_Extensions__item__id),
        ('criticality', ___PosMeasurementQuantities_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PosMeasurementQuantities_Item_iE_Extensions__item__extensionValue),
        ])
    __PosMeasurementQuantities_Item_iE_Extensions__item_._ext = None
    _PosMeasurementQuantities_Item_iE_Extensions._cont = __PosMeasurementQuantities_Item_iE_Extensions__item_
    _PosMeasurementQuantities_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosMeasurementQuantities_Item._cont = ASN1Dict([
        ('posMeasurementType', _PosMeasurementQuantities_Item_posMeasurementType),
        ('timingReportingGranularityFactor', _PosMeasurementQuantities_Item_timingReportingGranularityFactor),
        ('iE-Extensions', _PosMeasurementQuantities_Item_iE_Extensions),
        ])
    PosMeasurementQuantities_Item._ext = None
    
    #-----< PosMeasurementQuantities-ItemExtIEs >-----#
    PosMeasurementQuantities_ItemExtIEs = CLASS(name='PosMeasurementQuantities-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PosMeasurementQuantities_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosMeasurementResult >-----#
    PosMeasurementResult = SEQ_OF(name='PosMeasurementResult', mode=MODE_TYPE)
    _PosMeasurementResult__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementResultItem')))
    PosMeasurementResult._cont = _PosMeasurementResult__item_
    PosMeasurementResult._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< PosMeasurementResultItem >-----#
    PosMeasurementResultItem = SEQ(name='PosMeasurementResultItem', mode=MODE_TYPE)
    _PosMeasurementResultItem_measuredResultsValue = CHOICE(name='measuredResultsValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MeasuredResultsValue')))
    _PosMeasurementResultItem_timeStamp = SEQ(name='timeStamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TimeStamp')))
    _PosMeasurementResultItem_measurementQuality = SEQ(name='measurementQuality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPMeasurementQuality')), opt=True)
    _PosMeasurementResultItem_measurementBeamInfo = SEQ(name='measurementBeamInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MeasurementBeamInfo')), opt=True)
    _PosMeasurementResultItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosMeasurementResultItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PosMeasurementResultItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PosMeasurementResultItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____PosMeasurementResultItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ARP-ID')))
    _____PosMeasurementResultItem_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSResourcetype')))
    _____PosMeasurementResultItem_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LoS-NLoSInformation')))
    ____PosMeasurementResultItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 557), ('criticality', 'ignore'), ('Extension', _____PosMeasurementResultItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 560), ('criticality', 'ignore'), ('Extension', _____PosMeasurementResultItem_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 562), ('criticality', 'ignore'), ('Extension', _____PosMeasurementResultItem_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PosMeasurementResultItem_iE_Extensions__item__id._const_tab = ____PosMeasurementResultItem_iE_Extensions__item__id_tab
    ___PosMeasurementResultItem_iE_Extensions__item__id._const_tab_at = None
    ___PosMeasurementResultItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PosMeasurementResultItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PosMeasurementResultItem_iE_Extensions__item__criticality._const_tab = ____PosMeasurementResultItem_iE_Extensions__item__id_tab
    ___PosMeasurementResultItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PosMeasurementResultItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PosMeasurementResultItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PosMeasurementResultItem_iE_Extensions__item__extensionValue._const_tab = ____PosMeasurementResultItem_iE_Extensions__item__id_tab
    ___PosMeasurementResultItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PosMeasurementResultItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PosMeasurementResultItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PosMeasurementResultItem_iE_Extensions__item__id),
        ('criticality', ___PosMeasurementResultItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PosMeasurementResultItem_iE_Extensions__item__extensionValue),
        ])
    __PosMeasurementResultItem_iE_Extensions__item_._ext = None
    _PosMeasurementResultItem_iE_Extensions._cont = __PosMeasurementResultItem_iE_Extensions__item_
    _PosMeasurementResultItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosMeasurementResultItem._cont = ASN1Dict([
        ('measuredResultsValue', _PosMeasurementResultItem_measuredResultsValue),
        ('timeStamp', _PosMeasurementResultItem_timeStamp),
        ('measurementQuality', _PosMeasurementResultItem_measurementQuality),
        ('measurementBeamInfo', _PosMeasurementResultItem_measurementBeamInfo),
        ('iE-Extensions', _PosMeasurementResultItem_iE_Extensions),
        ])
    PosMeasurementResultItem._ext = None
    
    #-----< PosMeasurementResultItemExtIEs >-----#
    PosMeasurementResultItemExtIEs = CLASS(name='PosMeasurementResultItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _PosMeasurementResultItemExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ARP-ID')))
    _PosMeasurementResultItemExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSResourcetype')))
    _PosMeasurementResultItemExtIEs_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LoS-NLoSInformation')))
    PosMeasurementResultItemExtIEs._val = ASN1Set(rv=[dict([('id', 557), ('criticality', 'ignore'), ('Extension', _PosMeasurementResultItemExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 560), ('criticality', 'ignore'), ('Extension', _PosMeasurementResultItemExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 562), ('criticality', 'ignore'), ('Extension', _PosMeasurementResultItemExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PosMeasurementResultList >-----#
    PosMeasurementResultList = SEQ_OF(name='PosMeasurementResultList', mode=MODE_TYPE)
    _PosMeasurementResultList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementResultList-Item')))
    PosMeasurementResultList._cont = _PosMeasurementResultList__item_
    PosMeasurementResultList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< PosMeasurementResultList-Item >-----#
    PosMeasurementResultList_Item = SEQ(name='PosMeasurementResultList-Item', mode=MODE_TYPE)
    _PosMeasurementResultList_Item_posMeasurementResult = SEQ_OF(name='posMeasurementResult', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementResult')))
    _PosMeasurementResultList_Item_tRPID = INT(name='tRPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPID')))
    _PosMeasurementResultList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosMeasurementResultList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PosMeasurementResultList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PosMeasurementResultList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____PosMeasurementResultList_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    ____PosMeasurementResultList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Extension', _____PosMeasurementResultList_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PosMeasurementResultList_Item_iE_Extensions__item__id._const_tab = ____PosMeasurementResultList_Item_iE_Extensions__item__id_tab
    ___PosMeasurementResultList_Item_iE_Extensions__item__id._const_tab_at = None
    ___PosMeasurementResultList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PosMeasurementResultList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PosMeasurementResultList_Item_iE_Extensions__item__criticality._const_tab = ____PosMeasurementResultList_Item_iE_Extensions__item__id_tab
    ___PosMeasurementResultList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PosMeasurementResultList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PosMeasurementResultList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PosMeasurementResultList_Item_iE_Extensions__item__extensionValue._const_tab = ____PosMeasurementResultList_Item_iE_Extensions__item__id_tab
    ___PosMeasurementResultList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PosMeasurementResultList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PosMeasurementResultList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PosMeasurementResultList_Item_iE_Extensions__item__id),
        ('criticality', ___PosMeasurementResultList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PosMeasurementResultList_Item_iE_Extensions__item__extensionValue),
        ])
    __PosMeasurementResultList_Item_iE_Extensions__item_._ext = None
    _PosMeasurementResultList_Item_iE_Extensions._cont = __PosMeasurementResultList_Item_iE_Extensions__item_
    _PosMeasurementResultList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosMeasurementResultList_Item._cont = ASN1Dict([
        ('posMeasurementResult', _PosMeasurementResultList_Item_posMeasurementResult),
        ('tRPID', _PosMeasurementResultList_Item_tRPID),
        ('iE-Extensions', _PosMeasurementResultList_Item_iE_Extensions),
        ])
    PosMeasurementResultList_Item._ext = None
    
    #-----< PosMeasurementResultList-ItemExtIEs >-----#
    PosMeasurementResultList_ItemExtIEs = CLASS(name='PosMeasurementResultList-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _PosMeasurementResultList_ItemExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    PosMeasurementResultList_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Extension', _PosMeasurementResultList_ItemExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PosMeasurementType >-----#
    PosMeasurementType = ENUM(name='PosMeasurementType', mode=MODE_TYPE)
    PosMeasurementType._cont = ASN1Dict([('gnb-rx-tx', 0), ('ul-srs-rsrp', 1), ('ul-aoa', 2), ('ul-rtoa', 3), ('multiple-ul-aoa', 4), ('ul-srs-rsrpp', 5)])
    PosMeasurementType._ext = ['multiple-ul-aoa', 'ul-srs-rsrpp']
    
    #-----< PosReportCharacteristics >-----#
    PosReportCharacteristics = ENUM(name='PosReportCharacteristics', mode=MODE_TYPE)
    PosReportCharacteristics._cont = ASN1Dict([('ondemand', 0), ('periodic', 1)])
    PosReportCharacteristics._ext = []
    
    #-----< PosResourceSetType >-----#
    PosResourceSetType = CHOICE(name='PosResourceSetType', mode=MODE_TYPE)
    _PosResourceSetType_periodic = SEQ(name='periodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PosResourceSetTypePR')))
    _PosResourceSetType_semi_persistent = SEQ(name='semi-persistent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PosResourceSetTypeSP')))
    _PosResourceSetType_aperiodic = SEQ(name='aperiodic', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PosResourceSetTypeAP')))
    _PosResourceSetType_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __PosResourceSetType_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___PosResourceSetType_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PosResourceSetType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PosResourceSetType_choice_extension_id._const_tab = ___PosResourceSetType_choice_extension_id_tab
    __PosResourceSetType_choice_extension_id._const_tab_at = None
    __PosResourceSetType_choice_extension_id._const_tab_id = 'id'
    __PosResourceSetType_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PosResourceSetType_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PosResourceSetType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PosResourceSetType_choice_extension_criticality._const_tab = ___PosResourceSetType_choice_extension_criticality_tab
    __PosResourceSetType_choice_extension_criticality._const_tab_at = ('..', 'id')
    __PosResourceSetType_choice_extension_criticality._const_tab_id = 'criticality'
    __PosResourceSetType_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PosResourceSetType_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PosResourceSetType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PosResourceSetType_choice_extension_value._const_tab = ___PosResourceSetType_choice_extension_value_tab
    __PosResourceSetType_choice_extension_value._const_tab_at = ('..', 'id')
    __PosResourceSetType_choice_extension_value._const_tab_id = 'Value'
    _PosResourceSetType_choice_extension._cont = ASN1Dict([
        ('id', __PosResourceSetType_choice_extension_id),
        ('criticality', __PosResourceSetType_choice_extension_criticality),
        ('value', __PosResourceSetType_choice_extension_value),
        ])
    _PosResourceSetType_choice_extension._ext = None
    PosResourceSetType._cont = ASN1Dict([
        ('periodic', _PosResourceSetType_periodic),
        ('semi-persistent', _PosResourceSetType_semi_persistent),
        ('aperiodic', _PosResourceSetType_aperiodic),
        ('choice-extension', _PosResourceSetType_choice_extension),
        ])
    PosResourceSetType._ext = None
    
    #-----< PosResourceSetType-ExtIEs >-----#
    PosResourceSetType_ExtIEs = CLASS(name='PosResourceSetType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    PosResourceSetType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosResourceSetTypePR >-----#
    PosResourceSetTypePR = SEQ(name='PosResourceSetTypePR', mode=MODE_TYPE)
    _PosResourceSetTypePR_posperiodicSet = ENUM(name='posperiodicSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosResourceSetTypePR_posperiodicSet._cont = ASN1Dict([('true', 0)])
    _PosResourceSetTypePR_posperiodicSet._ext = []
    _PosResourceSetTypePR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosResourceSetTypePR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PosResourceSetTypePR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PosResourceSetTypePR_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypePR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypePR_iE_Extensions__item__id._const_tab = ____PosResourceSetTypePR_iE_Extensions__item__id_tab
    ___PosResourceSetTypePR_iE_Extensions__item__id._const_tab_at = None
    ___PosResourceSetTypePR_iE_Extensions__item__id._const_tab_id = 'id'
    ___PosResourceSetTypePR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PosResourceSetTypePR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypePR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypePR_iE_Extensions__item__criticality._const_tab = ____PosResourceSetTypePR_iE_Extensions__item__criticality_tab
    ___PosResourceSetTypePR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PosResourceSetTypePR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PosResourceSetTypePR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PosResourceSetTypePR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypePR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypePR_iE_Extensions__item__extensionValue._const_tab = ____PosResourceSetTypePR_iE_Extensions__item__extensionValue_tab
    ___PosResourceSetTypePR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PosResourceSetTypePR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PosResourceSetTypePR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PosResourceSetTypePR_iE_Extensions__item__id),
        ('criticality', ___PosResourceSetTypePR_iE_Extensions__item__criticality),
        ('extensionValue', ___PosResourceSetTypePR_iE_Extensions__item__extensionValue),
        ])
    __PosResourceSetTypePR_iE_Extensions__item_._ext = None
    _PosResourceSetTypePR_iE_Extensions._cont = __PosResourceSetTypePR_iE_Extensions__item_
    _PosResourceSetTypePR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosResourceSetTypePR._cont = ASN1Dict([
        ('posperiodicSet', _PosResourceSetTypePR_posperiodicSet),
        ('iE-Extensions', _PosResourceSetTypePR_iE_Extensions),
        ])
    PosResourceSetTypePR._ext = None
    
    #-----< PosResourceSetTypePR-ExtIEs >-----#
    PosResourceSetTypePR_ExtIEs = CLASS(name='PosResourceSetTypePR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PosResourceSetTypePR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosResourceSetTypeSP >-----#
    PosResourceSetTypeSP = SEQ(name='PosResourceSetTypeSP', mode=MODE_TYPE)
    _PosResourceSetTypeSP_possemi_persistentSet = ENUM(name='possemi-persistentSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosResourceSetTypeSP_possemi_persistentSet._cont = ASN1Dict([('true', 0)])
    _PosResourceSetTypeSP_possemi_persistentSet._ext = []
    _PosResourceSetTypeSP_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosResourceSetTypeSP_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PosResourceSetTypeSP_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PosResourceSetTypeSP_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypeSP_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypeSP_iE_Extensions__item__id._const_tab = ____PosResourceSetTypeSP_iE_Extensions__item__id_tab
    ___PosResourceSetTypeSP_iE_Extensions__item__id._const_tab_at = None
    ___PosResourceSetTypeSP_iE_Extensions__item__id._const_tab_id = 'id'
    ___PosResourceSetTypeSP_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PosResourceSetTypeSP_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypeSP_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypeSP_iE_Extensions__item__criticality._const_tab = ____PosResourceSetTypeSP_iE_Extensions__item__criticality_tab
    ___PosResourceSetTypeSP_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PosResourceSetTypeSP_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PosResourceSetTypeSP_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PosResourceSetTypeSP_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypeSP_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypeSP_iE_Extensions__item__extensionValue._const_tab = ____PosResourceSetTypeSP_iE_Extensions__item__extensionValue_tab
    ___PosResourceSetTypeSP_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PosResourceSetTypeSP_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PosResourceSetTypeSP_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PosResourceSetTypeSP_iE_Extensions__item__id),
        ('criticality', ___PosResourceSetTypeSP_iE_Extensions__item__criticality),
        ('extensionValue', ___PosResourceSetTypeSP_iE_Extensions__item__extensionValue),
        ])
    __PosResourceSetTypeSP_iE_Extensions__item_._ext = None
    _PosResourceSetTypeSP_iE_Extensions._cont = __PosResourceSetTypeSP_iE_Extensions__item_
    _PosResourceSetTypeSP_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosResourceSetTypeSP._cont = ASN1Dict([
        ('possemi-persistentSet', _PosResourceSetTypeSP_possemi_persistentSet),
        ('iE-Extensions', _PosResourceSetTypeSP_iE_Extensions),
        ])
    PosResourceSetTypeSP._ext = None
    
    #-----< PosResourceSetTypeSP-ExtIEs >-----#
    PosResourceSetTypeSP_ExtIEs = CLASS(name='PosResourceSetTypeSP-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PosResourceSetTypeSP_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosResourceSetTypeAP >-----#
    PosResourceSetTypeAP = SEQ(name='PosResourceSetTypeAP', mode=MODE_TYPE)
    _PosResourceSetTypeAP_sRSResourceTrigger_List = INT(name='sRSResourceTrigger-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosResourceSetTypeAP_sRSResourceTrigger_List._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    _PosResourceSetTypeAP_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosResourceSetTypeAP_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PosResourceSetTypeAP_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PosResourceSetTypeAP_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypeAP_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypeAP_iE_Extensions__item__id._const_tab = ____PosResourceSetTypeAP_iE_Extensions__item__id_tab
    ___PosResourceSetTypeAP_iE_Extensions__item__id._const_tab_at = None
    ___PosResourceSetTypeAP_iE_Extensions__item__id._const_tab_id = 'id'
    ___PosResourceSetTypeAP_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PosResourceSetTypeAP_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypeAP_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypeAP_iE_Extensions__item__criticality._const_tab = ____PosResourceSetTypeAP_iE_Extensions__item__criticality_tab
    ___PosResourceSetTypeAP_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PosResourceSetTypeAP_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PosResourceSetTypeAP_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PosResourceSetTypeAP_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypeAP_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypeAP_iE_Extensions__item__extensionValue._const_tab = ____PosResourceSetTypeAP_iE_Extensions__item__extensionValue_tab
    ___PosResourceSetTypeAP_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PosResourceSetTypeAP_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PosResourceSetTypeAP_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PosResourceSetTypeAP_iE_Extensions__item__id),
        ('criticality', ___PosResourceSetTypeAP_iE_Extensions__item__criticality),
        ('extensionValue', ___PosResourceSetTypeAP_iE_Extensions__item__extensionValue),
        ])
    __PosResourceSetTypeAP_iE_Extensions__item_._ext = None
    _PosResourceSetTypeAP_iE_Extensions._cont = __PosResourceSetTypeAP_iE_Extensions__item_
    _PosResourceSetTypeAP_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosResourceSetTypeAP._cont = ASN1Dict([
        ('sRSResourceTrigger-List', _PosResourceSetTypeAP_sRSResourceTrigger_List),
        ('iE-Extensions', _PosResourceSetTypeAP_iE_Extensions),
        ])
    PosResourceSetTypeAP._ext = None
    
    #-----< PosResourceSetTypeAP-ExtIEs >-----#
    PosResourceSetTypeAP_ExtIEs = CLASS(name='PosResourceSetTypeAP-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PosResourceSetTypeAP_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosSItypeList >-----#
    PosSItypeList = SEQ_OF(name='PosSItypeList', mode=MODE_TYPE)
    _PosSItypeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosSItype-Item')))
    PosSItypeList._cont = _PosSItypeList__item_
    PosSItypeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< PosSItype-Item >-----#
    PosSItype_Item = SEQ(name='PosSItype-Item', mode=MODE_TYPE)
    _PosSItype_Item_posItype = INT(name='posItype', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PosSItype')))
    _PosSItype_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosSItype_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PosSItype_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PosSItype_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosSItype_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSItype_Item_iE_Extensions__item__id._const_tab = ____PosSItype_Item_iE_Extensions__item__id_tab
    ___PosSItype_Item_iE_Extensions__item__id._const_tab_at = None
    ___PosSItype_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PosSItype_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PosSItype_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosSItype_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSItype_Item_iE_Extensions__item__criticality._const_tab = ____PosSItype_Item_iE_Extensions__item__criticality_tab
    ___PosSItype_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PosSItype_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PosSItype_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PosSItype_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosSItype_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSItype_Item_iE_Extensions__item__extensionValue._const_tab = ____PosSItype_Item_iE_Extensions__item__extensionValue_tab
    ___PosSItype_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PosSItype_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PosSItype_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PosSItype_Item_iE_Extensions__item__id),
        ('criticality', ___PosSItype_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PosSItype_Item_iE_Extensions__item__extensionValue),
        ])
    __PosSItype_Item_iE_Extensions__item_._ext = None
    _PosSItype_Item_iE_Extensions._cont = __PosSItype_Item_iE_Extensions__item_
    _PosSItype_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosSItype_Item._cont = ASN1Dict([
        ('posItype', _PosSItype_Item_posItype),
        ('iE-Extensions', _PosSItype_Item_iE_Extensions),
        ])
    PosSItype_Item._ext = None
    
    #-----< PosSItype-ItemExtIEs >-----#
    PosSItype_ItemExtIEs = CLASS(name='PosSItype-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PosSItype_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosSItype >-----#
    PosSItype = INT(name='PosSItype', mode=MODE_TYPE)
    PosSItype._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    
    #-----< PosSRSResourceID-List >-----#
    PosSRSResourceID_List = SEQ_OF(name='PosSRSResourceID-List', mode=MODE_TYPE)
    _PosSRSResourceID_List__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSPosResourceID')))
    PosSRSResourceID_List._cont = _PosSRSResourceID_List__item_
    PosSRSResourceID_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PosSRSResource-Item >-----#
    PosSRSResource_Item = SEQ(name='PosSRSResource-Item', mode=MODE_TYPE)
    _PosSRSResource_Item_srs_PosResourceId = INT(name='srs-PosResourceId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSPosResourceID')))
    _PosSRSResource_Item_transmissionCombPos = CHOICE(name='transmissionCombPos', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransmissionCombPos')))
    _PosSRSResource_Item_startPosition = INT(name='startPosition', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResource_Item_startPosition._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=13)], ev=None, er=[])
    _PosSRSResource_Item_nrofSymbols = ENUM(name='nrofSymbols', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResource_Item_nrofSymbols._cont = ASN1Dict([('n1', 0), ('n2', 1), ('n4', 2), ('n8', 3), ('n12', 4)])
    _PosSRSResource_Item_nrofSymbols._ext = None
    _PosSRSResource_Item_freqDomainShift = INT(name='freqDomainShift', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResource_Item_freqDomainShift._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=268)], ev=None, er=[])
    _PosSRSResource_Item_c_SRS = INT(name='c-SRS', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResource_Item_c_SRS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _PosSRSResource_Item_groupOrSequenceHopping = ENUM(name='groupOrSequenceHopping', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResource_Item_groupOrSequenceHopping._cont = ASN1Dict([('neither', 0), ('groupHopping', 1), ('sequenceHopping', 2)])
    _PosSRSResource_Item_groupOrSequenceHopping._ext = None
    _PosSRSResource_Item_resourceTypePos = CHOICE(name='resourceTypePos', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceTypePos')))
    _PosSRSResource_Item_sequenceId = INT(name='sequenceId', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResource_Item_sequenceId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PosSRSResource_Item_spatialRelationPos = CHOICE(name='spatialRelationPos', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SpatialRelationPos')), opt=True)
    _PosSRSResource_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosSRSResource_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PosSRSResource_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PosSRSResource_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosSRSResource_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSRSResource_Item_iE_Extensions__item__id._const_tab = ____PosSRSResource_Item_iE_Extensions__item__id_tab
    ___PosSRSResource_Item_iE_Extensions__item__id._const_tab_at = None
    ___PosSRSResource_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PosSRSResource_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PosSRSResource_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosSRSResource_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSRSResource_Item_iE_Extensions__item__criticality._const_tab = ____PosSRSResource_Item_iE_Extensions__item__criticality_tab
    ___PosSRSResource_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PosSRSResource_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PosSRSResource_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PosSRSResource_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosSRSResource_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSRSResource_Item_iE_Extensions__item__extensionValue._const_tab = ____PosSRSResource_Item_iE_Extensions__item__extensionValue_tab
    ___PosSRSResource_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PosSRSResource_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PosSRSResource_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PosSRSResource_Item_iE_Extensions__item__id),
        ('criticality', ___PosSRSResource_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PosSRSResource_Item_iE_Extensions__item__extensionValue),
        ])
    __PosSRSResource_Item_iE_Extensions__item_._ext = None
    _PosSRSResource_Item_iE_Extensions._cont = __PosSRSResource_Item_iE_Extensions__item_
    _PosSRSResource_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosSRSResource_Item._cont = ASN1Dict([
        ('srs-PosResourceId', _PosSRSResource_Item_srs_PosResourceId),
        ('transmissionCombPos', _PosSRSResource_Item_transmissionCombPos),
        ('startPosition', _PosSRSResource_Item_startPosition),
        ('nrofSymbols', _PosSRSResource_Item_nrofSymbols),
        ('freqDomainShift', _PosSRSResource_Item_freqDomainShift),
        ('c-SRS', _PosSRSResource_Item_c_SRS),
        ('groupOrSequenceHopping', _PosSRSResource_Item_groupOrSequenceHopping),
        ('resourceTypePos', _PosSRSResource_Item_resourceTypePos),
        ('sequenceId', _PosSRSResource_Item_sequenceId),
        ('spatialRelationPos', _PosSRSResource_Item_spatialRelationPos),
        ('iE-Extensions', _PosSRSResource_Item_iE_Extensions),
        ])
    PosSRSResource_Item._ext = None
    
    #-----< PosSRSResource-Item-ExtIEs >-----#
    PosSRSResource_Item_ExtIEs = CLASS(name='PosSRSResource-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PosSRSResource_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosSRSResource-List >-----#
    PosSRSResource_List = SEQ_OF(name='PosSRSResource-List', mode=MODE_TYPE)
    _PosSRSResource_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosSRSResource-Item')))
    PosSRSResource_List._cont = _PosSRSResource_List__item_
    PosSRSResource_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< PosSRSResourceSet-Item >-----#
    PosSRSResourceSet_Item = SEQ(name='PosSRSResourceSet-Item', mode=MODE_TYPE)
    _PosSRSResourceSet_Item_possrsResourceSetID = INT(name='possrsResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResourceSet_Item_possrsResourceSetID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _PosSRSResourceSet_Item_possRSResourceID_List = SEQ_OF(name='possRSResourceID-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PosSRSResourceID-List')))
    _PosSRSResourceSet_Item_posresourceSetType = CHOICE(name='posresourceSetType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PosResourceSetType')))
    _PosSRSResourceSet_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosSRSResourceSet_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PosSRSResourceSet_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PosSRSResourceSet_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosSRSResourceSet_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSRSResourceSet_Item_iE_Extensions__item__id._const_tab = ____PosSRSResourceSet_Item_iE_Extensions__item__id_tab
    ___PosSRSResourceSet_Item_iE_Extensions__item__id._const_tab_at = None
    ___PosSRSResourceSet_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PosSRSResourceSet_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PosSRSResourceSet_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosSRSResourceSet_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSRSResourceSet_Item_iE_Extensions__item__criticality._const_tab = ____PosSRSResourceSet_Item_iE_Extensions__item__criticality_tab
    ___PosSRSResourceSet_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PosSRSResourceSet_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PosSRSResourceSet_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PosSRSResourceSet_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PosSRSResourceSet_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab = ____PosSRSResourceSet_Item_iE_Extensions__item__extensionValue_tab
    ___PosSRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PosSRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PosSRSResourceSet_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PosSRSResourceSet_Item_iE_Extensions__item__id),
        ('criticality', ___PosSRSResourceSet_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PosSRSResourceSet_Item_iE_Extensions__item__extensionValue),
        ])
    __PosSRSResourceSet_Item_iE_Extensions__item_._ext = None
    _PosSRSResourceSet_Item_iE_Extensions._cont = __PosSRSResourceSet_Item_iE_Extensions__item_
    _PosSRSResourceSet_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosSRSResourceSet_Item._cont = ASN1Dict([
        ('possrsResourceSetID', _PosSRSResourceSet_Item_possrsResourceSetID),
        ('possRSResourceID-List', _PosSRSResourceSet_Item_possRSResourceID_List),
        ('posresourceSetType', _PosSRSResourceSet_Item_posresourceSetType),
        ('iE-Extensions', _PosSRSResourceSet_Item_iE_Extensions),
        ])
    PosSRSResourceSet_Item._ext = None
    
    #-----< PosSRSResourceSet-Item-ExtIEs >-----#
    PosSRSResourceSet_Item_ExtIEs = CLASS(name='PosSRSResourceSet-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PosSRSResourceSet_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosSRSResourceSet-List >-----#
    PosSRSResourceSet_List = SEQ_OF(name='PosSRSResourceSet-List', mode=MODE_TYPE)
    _PosSRSResourceSet_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosSRSResourceSet-Item')))
    PosSRSResourceSet_List._cont = _PosSRSResourceSet_List__item_
    PosSRSResourceSet_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PrimaryPathIndication >-----#
    PrimaryPathIndication = ENUM(name='PrimaryPathIndication', mode=MODE_TYPE)
    PrimaryPathIndication._cont = ASN1Dict([('true', 0), ('false', 1)])
    PrimaryPathIndication._ext = []
    
    #-----< Pre-emptionCapability >-----#
    Pre_emptionCapability = ENUM(name='Pre-emptionCapability', mode=MODE_TYPE)
    Pre_emptionCapability._cont = ASN1Dict([('shall-not-trigger-pre-emption', 0), ('may-trigger-pre-emption', 1)])
    Pre_emptionCapability._ext = None
    
    #-----< Pre-emptionVulnerability >-----#
    Pre_emptionVulnerability = ENUM(name='Pre-emptionVulnerability', mode=MODE_TYPE)
    Pre_emptionVulnerability._cont = ASN1Dict([('not-pre-emptable', 0), ('pre-emptable', 1)])
    Pre_emptionVulnerability._ext = None
    
    #-----< PriorityLevel >-----#
    PriorityLevel = INT(name='PriorityLevel', mode=MODE_TYPE)
    PriorityLevel._cont = ASN1Dict([('spare', 0), ('highest', 1), ('lowest', 14), ('no-priority', 15)])
    PriorityLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< ProtectedEUTRAResourceIndication >-----#
    ProtectedEUTRAResourceIndication = OCT_STR(name='ProtectedEUTRAResourceIndication', mode=MODE_TYPE)
    
    #-----< Protected-EUTRA-Resources-Item >-----#
    Protected_EUTRA_Resources_Item = SEQ(name='Protected-EUTRA-Resources-Item', mode=MODE_TYPE)
    _Protected_EUTRA_Resources_Item_spectrumSharingGroupID = INT(name='spectrumSharingGroupID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SpectrumSharingGroupID')))
    _Protected_EUTRA_Resources_Item_eUTRACells_List = SEQ_OF(name='eUTRACells-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRACells-List')))
    _Protected_EUTRA_Resources_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Protected_EUTRA_Resources_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Protected_EUTRA_Resources_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Protected_EUTRA_Resources_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Protected_EUTRA_Resources_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Protected_EUTRA_Resources_Item_iE_Extensions__item__id._const_tab = ____Protected_EUTRA_Resources_Item_iE_Extensions__item__id_tab
    ___Protected_EUTRA_Resources_Item_iE_Extensions__item__id._const_tab_at = None
    ___Protected_EUTRA_Resources_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Protected_EUTRA_Resources_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Protected_EUTRA_Resources_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Protected_EUTRA_Resources_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Protected_EUTRA_Resources_Item_iE_Extensions__item__criticality._const_tab = ____Protected_EUTRA_Resources_Item_iE_Extensions__item__criticality_tab
    ___Protected_EUTRA_Resources_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Protected_EUTRA_Resources_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Protected_EUTRA_Resources_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Protected_EUTRA_Resources_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Protected_EUTRA_Resources_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Protected_EUTRA_Resources_Item_iE_Extensions__item__extensionValue._const_tab = ____Protected_EUTRA_Resources_Item_iE_Extensions__item__extensionValue_tab
    ___Protected_EUTRA_Resources_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Protected_EUTRA_Resources_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Protected_EUTRA_Resources_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Protected_EUTRA_Resources_Item_iE_Extensions__item__id),
        ('criticality', ___Protected_EUTRA_Resources_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Protected_EUTRA_Resources_Item_iE_Extensions__item__extensionValue),
        ])
    __Protected_EUTRA_Resources_Item_iE_Extensions__item_._ext = None
    _Protected_EUTRA_Resources_Item_iE_Extensions._cont = __Protected_EUTRA_Resources_Item_iE_Extensions__item_
    _Protected_EUTRA_Resources_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Protected_EUTRA_Resources_Item._cont = ASN1Dict([
        ('spectrumSharingGroupID', _Protected_EUTRA_Resources_Item_spectrumSharingGroupID),
        ('eUTRACells-List', _Protected_EUTRA_Resources_Item_eUTRACells_List),
        ('iE-Extensions', _Protected_EUTRA_Resources_Item_iE_Extensions),
        ])
    Protected_EUTRA_Resources_Item._ext = None
    
    #-----< Protected-EUTRA-Resources-ItemExtIEs >-----#
    Protected_EUTRA_Resources_ItemExtIEs = CLASS(name='Protected-EUTRA-Resources-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Protected_EUTRA_Resources_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSConfiguration >-----#
    PRSConfiguration = SEQ(name='PRSConfiguration', mode=MODE_TYPE)
    _PRSConfiguration_pRSResourceSet_List = SEQ_OF(name='pRSResourceSet-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSResourceSet-List')))
    _PRSConfiguration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSConfiguration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PRSConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSConfiguration_iE_Extensions__item__id._const_tab = ____PRSConfiguration_iE_Extensions__item__id_tab
    ___PRSConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___PRSConfiguration_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSConfiguration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSConfiguration_iE_Extensions__item__criticality._const_tab = ____PRSConfiguration_iE_Extensions__item__criticality_tab
    ___PRSConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSConfiguration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSConfiguration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSConfiguration_iE_Extensions__item__extensionValue._const_tab = ____PRSConfiguration_iE_Extensions__item__extensionValue_tab
    ___PRSConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSConfiguration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSConfiguration_iE_Extensions__item__id),
        ('criticality', ___PRSConfiguration_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSConfiguration_iE_Extensions__item__extensionValue),
        ])
    __PRSConfiguration_iE_Extensions__item_._ext = None
    _PRSConfiguration_iE_Extensions._cont = __PRSConfiguration_iE_Extensions__item_
    _PRSConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSConfiguration._cont = ASN1Dict([
        ('pRSResourceSet-List', _PRSConfiguration_pRSResourceSet_List),
        ('iE-Extensions', _PRSConfiguration_iE_Extensions),
        ])
    PRSConfiguration._ext = None
    
    #-----< PRSConfiguration-ExtIEs >-----#
    PRSConfiguration_ExtIEs = CLASS(name='PRSConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PRSConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSInformationPos >-----#
    PRSInformationPos = SEQ(name='PRSInformationPos', mode=MODE_TYPE)
    _PRSInformationPos_pRS_IDPos = INT(name='pRS-IDPos', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSInformationPos_pRS_IDPos._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _PRSInformationPos_pRS_Resource_Set_IDPos = INT(name='pRS-Resource-Set-IDPos', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSInformationPos_pRS_Resource_Set_IDPos._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _PRSInformationPos_pRS_Resource_IDPos = INT(name='pRS-Resource-IDPos', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PRSInformationPos_pRS_Resource_IDPos._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _PRSInformationPos_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSInformationPos_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSInformationPos_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PRSInformationPos_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSInformationPos_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSInformationPos_iE_Extensions__item__id._const_tab = ____PRSInformationPos_iE_Extensions__item__id_tab
    ___PRSInformationPos_iE_Extensions__item__id._const_tab_at = None
    ___PRSInformationPos_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSInformationPos_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSInformationPos_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSInformationPos_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSInformationPos_iE_Extensions__item__criticality._const_tab = ____PRSInformationPos_iE_Extensions__item__criticality_tab
    ___PRSInformationPos_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSInformationPos_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSInformationPos_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSInformationPos_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSInformationPos_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSInformationPos_iE_Extensions__item__extensionValue._const_tab = ____PRSInformationPos_iE_Extensions__item__extensionValue_tab
    ___PRSInformationPos_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSInformationPos_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSInformationPos_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSInformationPos_iE_Extensions__item__id),
        ('criticality', ___PRSInformationPos_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSInformationPos_iE_Extensions__item__extensionValue),
        ])
    __PRSInformationPos_iE_Extensions__item_._ext = None
    _PRSInformationPos_iE_Extensions._cont = __PRSInformationPos_iE_Extensions__item_
    _PRSInformationPos_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSInformationPos._cont = ASN1Dict([
        ('pRS-IDPos', _PRSInformationPos_pRS_IDPos),
        ('pRS-Resource-Set-IDPos', _PRSInformationPos_pRS_Resource_Set_IDPos),
        ('pRS-Resource-IDPos', _PRSInformationPos_pRS_Resource_IDPos),
        ('iE-Extensions', _PRSInformationPos_iE_Extensions),
        ])
    PRSInformationPos._ext = None
    
    #-----< PRSInformationPos-ExtIEs >-----#
    PRSInformationPos_ExtIEs = CLASS(name='PRSInformationPos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PRSInformationPos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRS-Measurement-Info-List >-----#
    PRS_Measurement_Info_List = SEQ_OF(name='PRS-Measurement-Info-List', mode=MODE_TYPE)
    _PRS_Measurement_Info_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PRS-Measurement-Info-List-Item')))
    PRS_Measurement_Info_List._cont = _PRS_Measurement_Info_List__item_
    PRS_Measurement_Info_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< PRS-Measurement-Info-List-Item >-----#
    PRS_Measurement_Info_List_Item = SEQ(name='PRS-Measurement-Info-List-Item', mode=MODE_TYPE)
    _PRS_Measurement_Info_List_Item_pointA = INT(name='pointA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRS_Measurement_Info_List_Item_pointA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _PRS_Measurement_Info_List_Item_measPRSPeriodicity = ENUM(name='measPRSPeriodicity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRS_Measurement_Info_List_Item_measPRSPeriodicity._cont = ASN1Dict([('ms20', 0), ('ms40', 1), ('ms80', 2), ('ms160', 3)])
    _PRS_Measurement_Info_List_Item_measPRSPeriodicity._ext = []
    _PRS_Measurement_Info_List_Item_measPRSOffset = INT(name='measPRSOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRS_Measurement_Info_List_Item_measPRSOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=159)], ev=[], er=[])
    _PRS_Measurement_Info_List_Item_measurementPRSLength = ENUM(name='measurementPRSLength', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRS_Measurement_Info_List_Item_measurementPRSLength._cont = ASN1Dict([('ms1dot5', 0), ('ms3', 1), ('ms3dot5', 2), ('ms4', 3), ('ms5dot5', 4), ('ms6', 5), ('ms10', 6), ('ms20', 7)])
    _PRS_Measurement_Info_List_Item_measurementPRSLength._ext = None
    _PRS_Measurement_Info_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRS_Measurement_Info_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRS_Measurement_Info_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PRS_Measurement_Info_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRS_Measurement_Info_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRS_Measurement_Info_List_Item_iE_Extensions__item__id._const_tab = ____PRS_Measurement_Info_List_Item_iE_Extensions__item__id_tab
    ___PRS_Measurement_Info_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___PRS_Measurement_Info_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRS_Measurement_Info_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRS_Measurement_Info_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRS_Measurement_Info_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRS_Measurement_Info_List_Item_iE_Extensions__item__criticality._const_tab = ____PRS_Measurement_Info_List_Item_iE_Extensions__item__criticality_tab
    ___PRS_Measurement_Info_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRS_Measurement_Info_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRS_Measurement_Info_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRS_Measurement_Info_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRS_Measurement_Info_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRS_Measurement_Info_List_Item_iE_Extensions__item__extensionValue._const_tab = ____PRS_Measurement_Info_List_Item_iE_Extensions__item__extensionValue_tab
    ___PRS_Measurement_Info_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRS_Measurement_Info_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRS_Measurement_Info_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRS_Measurement_Info_List_Item_iE_Extensions__item__id),
        ('criticality', ___PRS_Measurement_Info_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PRS_Measurement_Info_List_Item_iE_Extensions__item__extensionValue),
        ])
    __PRS_Measurement_Info_List_Item_iE_Extensions__item_._ext = None
    _PRS_Measurement_Info_List_Item_iE_Extensions._cont = __PRS_Measurement_Info_List_Item_iE_Extensions__item_
    _PRS_Measurement_Info_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRS_Measurement_Info_List_Item._cont = ASN1Dict([
        ('pointA', _PRS_Measurement_Info_List_Item_pointA),
        ('measPRSPeriodicity', _PRS_Measurement_Info_List_Item_measPRSPeriodicity),
        ('measPRSOffset', _PRS_Measurement_Info_List_Item_measPRSOffset),
        ('measurementPRSLength', _PRS_Measurement_Info_List_Item_measurementPRSLength),
        ('iE-Extensions', _PRS_Measurement_Info_List_Item_iE_Extensions),
        ])
    PRS_Measurement_Info_List_Item._ext = []
    
    #-----< PRS-Measurement-Info-List-Item-ExtIEs >-----#
    PRS_Measurement_Info_List_Item_ExtIEs = CLASS(name='PRS-Measurement-Info-List-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PRS_Measurement_Info_List_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Potential-SpCell-Item >-----#
    Potential_SpCell_Item = SEQ(name='Potential-SpCell-Item', mode=MODE_TYPE)
    _Potential_SpCell_Item_potential_SpCell_ID = SEQ(name='potential-SpCell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Potential_SpCell_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Potential_SpCell_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Potential_SpCell_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Potential_SpCell_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Potential_SpCell_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Potential_SpCell_Item_iE_Extensions__item__id._const_tab = ____Potential_SpCell_Item_iE_Extensions__item__id_tab
    ___Potential_SpCell_Item_iE_Extensions__item__id._const_tab_at = None
    ___Potential_SpCell_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Potential_SpCell_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Potential_SpCell_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Potential_SpCell_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Potential_SpCell_Item_iE_Extensions__item__criticality._const_tab = ____Potential_SpCell_Item_iE_Extensions__item__criticality_tab
    ___Potential_SpCell_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Potential_SpCell_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Potential_SpCell_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Potential_SpCell_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Potential_SpCell_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Potential_SpCell_Item_iE_Extensions__item__extensionValue._const_tab = ____Potential_SpCell_Item_iE_Extensions__item__extensionValue_tab
    ___Potential_SpCell_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Potential_SpCell_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Potential_SpCell_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Potential_SpCell_Item_iE_Extensions__item__id),
        ('criticality', ___Potential_SpCell_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Potential_SpCell_Item_iE_Extensions__item__extensionValue),
        ])
    __Potential_SpCell_Item_iE_Extensions__item_._ext = None
    _Potential_SpCell_Item_iE_Extensions._cont = __Potential_SpCell_Item_iE_Extensions__item_
    _Potential_SpCell_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Potential_SpCell_Item._cont = ASN1Dict([
        ('potential-SpCell-ID', _Potential_SpCell_Item_potential_SpCell_ID),
        ('iE-Extensions', _Potential_SpCell_Item_iE_Extensions),
        ])
    Potential_SpCell_Item._ext = []
    
    #-----< Potential-SpCell-ItemExtIEs >-----#
    Potential_SpCell_ItemExtIEs = CLASS(name='Potential-SpCell-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Potential_SpCell_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSAngleList >-----#
    PRSAngleList = SEQ_OF(name='PRSAngleList', mode=MODE_TYPE)
    _PRSAngleList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PRSAngleItem')))
    PRSAngleList._cont = _PRSAngleList__item_
    PRSAngleList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< PRSAngleItem >-----#
    PRSAngleItem = SEQ(name='PRSAngleItem', mode=MODE_TYPE)
    _PRSAngleItem_nR_PRS_Azimuth = INT(name='nR-PRS-Azimuth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSAngleItem_nR_PRS_Azimuth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _PRSAngleItem_nR_PRS_Azimuth_fine = INT(name='nR-PRS-Azimuth-fine', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSAngleItem_nR_PRS_Azimuth_fine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _PRSAngleItem_nR_PRS_Elevation = INT(name='nR-PRS-Elevation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSAngleItem_nR_PRS_Elevation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=180)], ev=None, er=[])
    _PRSAngleItem_nR_PRS_Elevation_fine = INT(name='nR-PRS-Elevation-fine', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSAngleItem_nR_PRS_Elevation_fine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _PRSAngleItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSAngleItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSAngleItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PRSAngleItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____PRSAngleItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-ID')))
    ____PRSAngleItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 439), ('criticality', 'ignore'), ('Extension', _____PRSAngleItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PRSAngleItem_iE_Extensions__item__id._const_tab = ____PRSAngleItem_iE_Extensions__item__id_tab
    ___PRSAngleItem_iE_Extensions__item__id._const_tab_at = None
    ___PRSAngleItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSAngleItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PRSAngleItem_iE_Extensions__item__criticality._const_tab = ____PRSAngleItem_iE_Extensions__item__id_tab
    ___PRSAngleItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSAngleItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSAngleItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PRSAngleItem_iE_Extensions__item__extensionValue._const_tab = ____PRSAngleItem_iE_Extensions__item__id_tab
    ___PRSAngleItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSAngleItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSAngleItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSAngleItem_iE_Extensions__item__id),
        ('criticality', ___PRSAngleItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSAngleItem_iE_Extensions__item__extensionValue),
        ])
    __PRSAngleItem_iE_Extensions__item_._ext = None
    _PRSAngleItem_iE_Extensions._cont = __PRSAngleItem_iE_Extensions__item_
    _PRSAngleItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSAngleItem._cont = ASN1Dict([
        ('nR-PRS-Azimuth', _PRSAngleItem_nR_PRS_Azimuth),
        ('nR-PRS-Azimuth-fine', _PRSAngleItem_nR_PRS_Azimuth_fine),
        ('nR-PRS-Elevation', _PRSAngleItem_nR_PRS_Elevation),
        ('nR-PRS-Elevation-fine', _PRSAngleItem_nR_PRS_Elevation_fine),
        ('iE-Extensions', _PRSAngleItem_iE_Extensions),
        ])
    PRSAngleItem._ext = None
    
    #-----< PRSAngleItem-ItemExtIEs >-----#
    PRSAngleItem_ItemExtIEs = CLASS(name='PRSAngleItem-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _PRSAngleItem_ItemExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-ID')))
    PRSAngleItem_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 439), ('criticality', 'ignore'), ('Extension', _PRSAngleItem_ItemExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PRSConfigRequestType >-----#
    PRSConfigRequestType = ENUM(name='PRSConfigRequestType', mode=MODE_TYPE)
    PRSConfigRequestType._cont = ASN1Dict([('configure', 0), ('off', 1)])
    PRSConfigRequestType._ext = []
    
    #-----< PRSMuting >-----#
    PRSMuting = SEQ(name='PRSMuting', mode=MODE_TYPE)
    _PRSMuting_pRSMutingOption1 = SEQ(name='pRSMutingOption1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSMutingOption1')), opt=True)
    _PRSMuting_pRSMutingOption2 = SEQ(name='pRSMutingOption2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSMutingOption2')), opt=True)
    _PRSMuting_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSMuting_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSMuting_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PRSMuting_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSMuting_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMuting_iE_Extensions__item__id._const_tab = ____PRSMuting_iE_Extensions__item__id_tab
    ___PRSMuting_iE_Extensions__item__id._const_tab_at = None
    ___PRSMuting_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSMuting_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSMuting_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSMuting_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMuting_iE_Extensions__item__criticality._const_tab = ____PRSMuting_iE_Extensions__item__criticality_tab
    ___PRSMuting_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSMuting_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSMuting_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSMuting_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSMuting_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMuting_iE_Extensions__item__extensionValue._const_tab = ____PRSMuting_iE_Extensions__item__extensionValue_tab
    ___PRSMuting_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSMuting_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSMuting_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSMuting_iE_Extensions__item__id),
        ('criticality', ___PRSMuting_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSMuting_iE_Extensions__item__extensionValue),
        ])
    __PRSMuting_iE_Extensions__item_._ext = None
    _PRSMuting_iE_Extensions._cont = __PRSMuting_iE_Extensions__item_
    _PRSMuting_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSMuting._cont = ASN1Dict([
        ('pRSMutingOption1', _PRSMuting_pRSMutingOption1),
        ('pRSMutingOption2', _PRSMuting_pRSMutingOption2),
        ('iE-Extensions', _PRSMuting_iE_Extensions),
        ])
    PRSMuting._ext = None
    
    #-----< PRSMuting-ExtIEs >-----#
    PRSMuting_ExtIEs = CLASS(name='PRSMuting-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PRSMuting_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSMutingOption1 >-----#
    PRSMutingOption1 = SEQ(name='PRSMutingOption1', mode=MODE_TYPE)
    _PRSMutingOption1_mutingPattern = CHOICE(name='mutingPattern', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DL-PRSMutingPattern')))
    _PRSMutingOption1_mutingBitRepetitionFactor = ENUM(name='mutingBitRepetitionFactor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSMutingOption1_mutingBitRepetitionFactor._cont = ASN1Dict([('rf1', 0), ('rf2', 1), ('rf4', 2), ('rf8', 3)])
    _PRSMutingOption1_mutingBitRepetitionFactor._ext = []
    _PRSMutingOption1_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSMutingOption1_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSMutingOption1_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PRSMutingOption1_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSMutingOption1_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMutingOption1_iE_Extensions__item__id._const_tab = ____PRSMutingOption1_iE_Extensions__item__id_tab
    ___PRSMutingOption1_iE_Extensions__item__id._const_tab_at = None
    ___PRSMutingOption1_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSMutingOption1_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSMutingOption1_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSMutingOption1_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMutingOption1_iE_Extensions__item__criticality._const_tab = ____PRSMutingOption1_iE_Extensions__item__criticality_tab
    ___PRSMutingOption1_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSMutingOption1_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSMutingOption1_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSMutingOption1_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSMutingOption1_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMutingOption1_iE_Extensions__item__extensionValue._const_tab = ____PRSMutingOption1_iE_Extensions__item__extensionValue_tab
    ___PRSMutingOption1_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSMutingOption1_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSMutingOption1_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSMutingOption1_iE_Extensions__item__id),
        ('criticality', ___PRSMutingOption1_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSMutingOption1_iE_Extensions__item__extensionValue),
        ])
    __PRSMutingOption1_iE_Extensions__item_._ext = None
    _PRSMutingOption1_iE_Extensions._cont = __PRSMutingOption1_iE_Extensions__item_
    _PRSMutingOption1_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSMutingOption1._cont = ASN1Dict([
        ('mutingPattern', _PRSMutingOption1_mutingPattern),
        ('mutingBitRepetitionFactor', _PRSMutingOption1_mutingBitRepetitionFactor),
        ('iE-Extensions', _PRSMutingOption1_iE_Extensions),
        ])
    PRSMutingOption1._ext = None
    
    #-----< PRSMutingOption1-ExtIEs >-----#
    PRSMutingOption1_ExtIEs = CLASS(name='PRSMutingOption1-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PRSMutingOption1_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSMutingOption2 >-----#
    PRSMutingOption2 = SEQ(name='PRSMutingOption2', mode=MODE_TYPE)
    _PRSMutingOption2_mutingPattern = CHOICE(name='mutingPattern', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DL-PRSMutingPattern')))
    _PRSMutingOption2_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSMutingOption2_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSMutingOption2_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PRSMutingOption2_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSMutingOption2_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMutingOption2_iE_Extensions__item__id._const_tab = ____PRSMutingOption2_iE_Extensions__item__id_tab
    ___PRSMutingOption2_iE_Extensions__item__id._const_tab_at = None
    ___PRSMutingOption2_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSMutingOption2_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSMutingOption2_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSMutingOption2_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMutingOption2_iE_Extensions__item__criticality._const_tab = ____PRSMutingOption2_iE_Extensions__item__criticality_tab
    ___PRSMutingOption2_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSMutingOption2_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSMutingOption2_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSMutingOption2_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSMutingOption2_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMutingOption2_iE_Extensions__item__extensionValue._const_tab = ____PRSMutingOption2_iE_Extensions__item__extensionValue_tab
    ___PRSMutingOption2_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSMutingOption2_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSMutingOption2_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSMutingOption2_iE_Extensions__item__id),
        ('criticality', ___PRSMutingOption2_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSMutingOption2_iE_Extensions__item__extensionValue),
        ])
    __PRSMutingOption2_iE_Extensions__item_._ext = None
    _PRSMutingOption2_iE_Extensions._cont = __PRSMutingOption2_iE_Extensions__item_
    _PRSMutingOption2_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSMutingOption2._cont = ASN1Dict([
        ('mutingPattern', _PRSMutingOption2_mutingPattern),
        ('iE-Extensions', _PRSMutingOption2_iE_Extensions),
        ])
    PRSMutingOption2._ext = None
    
    #-----< PRSMutingOption2-ExtIEs >-----#
    PRSMutingOption2_ExtIEs = CLASS(name='PRSMutingOption2-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PRSMutingOption2_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRS-Resource-ID >-----#
    PRS_Resource_ID = INT(name='PRS-Resource-ID', mode=MODE_TYPE)
    PRS_Resource_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< PRSResource-List >-----#
    PRSResource_List = SEQ_OF(name='PRSResource-List', mode=MODE_TYPE)
    _PRSResource_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PRSResource-Item')))
    PRSResource_List._cont = _PRSResource_List__item_
    PRSResource_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< PRSResource-Item >-----#
    PRSResource_Item = SEQ(name='PRSResource-Item', mode=MODE_TYPE)
    _PRSResource_Item_pRSResourceID = INT(name='pRSResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-ID')))
    _PRSResource_Item_sequenceID = INT(name='sequenceID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResource_Item_sequenceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _PRSResource_Item_rEOffset = INT(name='rEOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResource_Item_rEOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=11)], ev=[], er=[])
    _PRSResource_Item_resourceSlotOffset = INT(name='resourceSlotOffset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResource_Item_resourceSlotOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    _PRSResource_Item_resourceSymbolOffset = INT(name='resourceSymbolOffset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResource_Item_resourceSymbolOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=12)], ev=None, er=[])
    _PRSResource_Item_qCLInfo = CHOICE(name='qCLInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSResource-QCLInfo')), opt=True)
    _PRSResource_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSResource_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSResource_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PRSResource_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSResource_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_Item_iE_Extensions__item__id._const_tab = ____PRSResource_Item_iE_Extensions__item__id_tab
    ___PRSResource_Item_iE_Extensions__item__id._const_tab_at = None
    ___PRSResource_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSResource_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSResource_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSResource_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_Item_iE_Extensions__item__criticality._const_tab = ____PRSResource_Item_iE_Extensions__item__criticality_tab
    ___PRSResource_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSResource_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSResource_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSResource_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSResource_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_Item_iE_Extensions__item__extensionValue._const_tab = ____PRSResource_Item_iE_Extensions__item__extensionValue_tab
    ___PRSResource_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSResource_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSResource_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSResource_Item_iE_Extensions__item__id),
        ('criticality', ___PRSResource_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSResource_Item_iE_Extensions__item__extensionValue),
        ])
    __PRSResource_Item_iE_Extensions__item_._ext = None
    _PRSResource_Item_iE_Extensions._cont = __PRSResource_Item_iE_Extensions__item_
    _PRSResource_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSResource_Item._cont = ASN1Dict([
        ('pRSResourceID', _PRSResource_Item_pRSResourceID),
        ('sequenceID', _PRSResource_Item_sequenceID),
        ('rEOffset', _PRSResource_Item_rEOffset),
        ('resourceSlotOffset', _PRSResource_Item_resourceSlotOffset),
        ('resourceSymbolOffset', _PRSResource_Item_resourceSymbolOffset),
        ('qCLInfo', _PRSResource_Item_qCLInfo),
        ('iE-Extensions', _PRSResource_Item_iE_Extensions),
        ])
    PRSResource_Item._ext = None
    
    #-----< PRSResource-Item-ExtIEs >-----#
    PRSResource_Item_ExtIEs = CLASS(name='PRSResource-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PRSResource_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSResource-QCLInfo >-----#
    PRSResource_QCLInfo = CHOICE(name='PRSResource-QCLInfo', mode=MODE_TYPE)
    _PRSResource_QCLInfo_qCLSourceSSB = SEQ(name='qCLSourceSSB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSResource-QCLSourceSSB')))
    _PRSResource_QCLInfo_qCLSourcePRS = SEQ(name='qCLSourcePRS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSResource-QCLSourcePRS')))
    _PRSResource_QCLInfo_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __PRSResource_QCLInfo_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___PRSResource_QCLInfo_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PRSResource_QCLInfo_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PRSResource_QCLInfo_choice_extension_id._const_tab = ___PRSResource_QCLInfo_choice_extension_id_tab
    __PRSResource_QCLInfo_choice_extension_id._const_tab_at = None
    __PRSResource_QCLInfo_choice_extension_id._const_tab_id = 'id'
    __PRSResource_QCLInfo_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PRSResource_QCLInfo_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PRSResource_QCLInfo_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PRSResource_QCLInfo_choice_extension_criticality._const_tab = ___PRSResource_QCLInfo_choice_extension_criticality_tab
    __PRSResource_QCLInfo_choice_extension_criticality._const_tab_at = ('..', 'id')
    __PRSResource_QCLInfo_choice_extension_criticality._const_tab_id = 'criticality'
    __PRSResource_QCLInfo_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PRSResource_QCLInfo_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PRSResource_QCLInfo_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PRSResource_QCLInfo_choice_extension_value._const_tab = ___PRSResource_QCLInfo_choice_extension_value_tab
    __PRSResource_QCLInfo_choice_extension_value._const_tab_at = ('..', 'id')
    __PRSResource_QCLInfo_choice_extension_value._const_tab_id = 'Value'
    _PRSResource_QCLInfo_choice_extension._cont = ASN1Dict([
        ('id', __PRSResource_QCLInfo_choice_extension_id),
        ('criticality', __PRSResource_QCLInfo_choice_extension_criticality),
        ('value', __PRSResource_QCLInfo_choice_extension_value),
        ])
    _PRSResource_QCLInfo_choice_extension._ext = None
    PRSResource_QCLInfo._cont = ASN1Dict([
        ('qCLSourceSSB', _PRSResource_QCLInfo_qCLSourceSSB),
        ('qCLSourcePRS', _PRSResource_QCLInfo_qCLSourcePRS),
        ('choice-extension', _PRSResource_QCLInfo_choice_extension),
        ])
    PRSResource_QCLInfo._ext = None
    
    #-----< PRSResource-QCLInfo-ExtIEs >-----#
    PRSResource_QCLInfo_ExtIEs = CLASS(name='PRSResource-QCLInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    PRSResource_QCLInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSResource-QCLSourceSSB >-----#
    PRSResource_QCLSourceSSB = SEQ(name='PRSResource-QCLSourceSSB', mode=MODE_TYPE)
    _PRSResource_QCLSourceSSB_pCI_NR = INT(name='pCI-NR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResource_QCLSourceSSB_pCI_NR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1007)], ev=None, er=[])
    _PRSResource_QCLSourceSSB_sSB_Index = INT(name='sSB-Index', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB-Index')), opt=True)
    _PRSResource_QCLSourceSSB_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSResource_QCLSourceSSB_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PRSResource_QCLSourceSSB_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSResource_QCLSourceSSB_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__id._const_tab = ____PRSResource_QCLSourceSSB_iE_Extensions__item__id_tab
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__id._const_tab_at = None
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSResource_QCLSourceSSB_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSResource_QCLSourceSSB_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__criticality._const_tab = ____PRSResource_QCLSourceSSB_iE_Extensions__item__criticality_tab
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue._const_tab = ____PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue_tab
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSResource_QCLSourceSSB_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSResource_QCLSourceSSB_iE_Extensions__item__id),
        ('criticality', ___PRSResource_QCLSourceSSB_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue),
        ])
    __PRSResource_QCLSourceSSB_iE_Extensions__item_._ext = None
    _PRSResource_QCLSourceSSB_iE_Extensions._cont = __PRSResource_QCLSourceSSB_iE_Extensions__item_
    _PRSResource_QCLSourceSSB_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSResource_QCLSourceSSB._cont = ASN1Dict([
        ('pCI-NR', _PRSResource_QCLSourceSSB_pCI_NR),
        ('sSB-Index', _PRSResource_QCLSourceSSB_sSB_Index),
        ('iE-Extensions', _PRSResource_QCLSourceSSB_iE_Extensions),
        ])
    PRSResource_QCLSourceSSB._ext = []
    
    #-----< PRSResource-QCLSourceSSB-ExtIEs >-----#
    PRSResource_QCLSourceSSB_ExtIEs = CLASS(name='PRSResource-QCLSourceSSB-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PRSResource_QCLSourceSSB_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSResource-QCLSourcePRS >-----#
    PRSResource_QCLSourcePRS = SEQ(name='PRSResource-QCLSourcePRS', mode=MODE_TYPE)
    _PRSResource_QCLSourcePRS_qCLSourcePRSResourceSetID = INT(name='qCLSourcePRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-Set-ID')))
    _PRSResource_QCLSourcePRS_qCLSourcePRSResourceID = INT(name='qCLSourcePRSResourceID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-ID')), opt=True)
    _PRSResource_QCLSourcePRS_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSResource_QCLSourcePRS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PRSResource_QCLSourcePRS_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSResource_QCLSourcePRS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__id._const_tab = ____PRSResource_QCLSourcePRS_iE_Extensions__item__id_tab
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__id._const_tab_at = None
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSResource_QCLSourcePRS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSResource_QCLSourcePRS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__criticality._const_tab = ____PRSResource_QCLSourcePRS_iE_Extensions__item__criticality_tab
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue._const_tab = ____PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue_tab
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSResource_QCLSourcePRS_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSResource_QCLSourcePRS_iE_Extensions__item__id),
        ('criticality', ___PRSResource_QCLSourcePRS_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue),
        ])
    __PRSResource_QCLSourcePRS_iE_Extensions__item_._ext = None
    _PRSResource_QCLSourcePRS_iE_Extensions._cont = __PRSResource_QCLSourcePRS_iE_Extensions__item_
    _PRSResource_QCLSourcePRS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSResource_QCLSourcePRS._cont = ASN1Dict([
        ('qCLSourcePRSResourceSetID', _PRSResource_QCLSourcePRS_qCLSourcePRSResourceSetID),
        ('qCLSourcePRSResourceID', _PRSResource_QCLSourcePRS_qCLSourcePRSResourceID),
        ('iE-Extensions', _PRSResource_QCLSourcePRS_iE_Extensions),
        ])
    PRSResource_QCLSourcePRS._ext = None
    
    #-----< PRSResource-QCLSourcePRS-ExtIEs >-----#
    PRSResource_QCLSourcePRS_ExtIEs = CLASS(name='PRSResource-QCLSourcePRS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PRSResource_QCLSourcePRS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRS-Resource-Set-ID >-----#
    PRS_Resource_Set_ID = INT(name='PRS-Resource-Set-ID', mode=MODE_TYPE)
    PRS_Resource_Set_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< PRSResourceSet-List >-----#
    PRSResourceSet_List = SEQ_OF(name='PRSResourceSet-List', mode=MODE_TYPE)
    _PRSResourceSet_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PRSResourceSet-Item')))
    PRSResourceSet_List._cont = _PRSResourceSet_List__item_
    PRSResourceSet_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< PRSResourceSet-Item >-----#
    PRSResourceSet_Item = SEQ(name='PRSResourceSet-Item', mode=MODE_TYPE)
    _PRSResourceSet_Item_pRSResourceSetID = INT(name='pRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-Set-ID')))
    _PRSResourceSet_Item_subcarrierSpacing = ENUM(name='subcarrierSpacing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_subcarrierSpacing._cont = ASN1Dict([('kHz15', 0), ('kHz30', 1), ('kHz60', 2), ('kHz120', 3)])
    _PRSResourceSet_Item_subcarrierSpacing._ext = []
    _PRSResourceSet_Item_pRSbandwidth = INT(name='pRSbandwidth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_pRSbandwidth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _PRSResourceSet_Item_startPRB = INT(name='startPRB', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_startPRB._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2176)], ev=None, er=[])
    _PRSResourceSet_Item_pointA = INT(name='pointA', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_pointA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _PRSResourceSet_Item_combSize = ENUM(name='combSize', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_combSize._cont = ASN1Dict([('n2', 0), ('n4', 1), ('n6', 2), ('n12', 3)])
    _PRSResourceSet_Item_combSize._ext = []
    _PRSResourceSet_Item_cPType = ENUM(name='cPType', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_cPType._cont = ASN1Dict([('normal', 0), ('extended', 1)])
    _PRSResourceSet_Item_cPType._ext = []
    _PRSResourceSet_Item_resourceSetPeriodicity = ENUM(name='resourceSetPeriodicity', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_resourceSetPeriodicity._cont = ASN1Dict([('n4', 0), ('n5', 1), ('n8', 2), ('n10', 3), ('n16', 4), ('n20', 5), ('n32', 6), ('n40', 7), ('n64', 8), ('n80', 9), ('n160', 10), ('n320', 11), ('n640', 12), ('n1280', 13), ('n2560', 14), ('n5120', 15), ('n10240', 16), ('n20480', 17), ('n40960', 18), ('n81920', 19)])
    _PRSResourceSet_Item_resourceSetPeriodicity._ext = []
    _PRSResourceSet_Item_resourceSetSlotOffset = INT(name='resourceSetSlotOffset', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_resourceSetSlotOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=81919)], ev=[], er=[])
    _PRSResourceSet_Item_resourceRepetitionFactor = ENUM(name='resourceRepetitionFactor', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_resourceRepetitionFactor._cont = ASN1Dict([('rf1', 0), ('rf2', 1), ('rf4', 2), ('rf6', 3), ('rf8', 4), ('rf16', 5), ('rf32', 6)])
    _PRSResourceSet_Item_resourceRepetitionFactor._ext = []
    _PRSResourceSet_Item_resourceTimeGap = ENUM(name='resourceTimeGap', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_resourceTimeGap._cont = ASN1Dict([('tg1', 0), ('tg2', 1), ('tg4', 2), ('tg8', 3), ('tg16', 4), ('tg32', 5)])
    _PRSResourceSet_Item_resourceTimeGap._ext = []
    _PRSResourceSet_Item_resourceNumberofSymbols = ENUM(name='resourceNumberofSymbols', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_resourceNumberofSymbols._cont = ASN1Dict([('n2', 0), ('n4', 1), ('n6', 2), ('n12', 3)])
    _PRSResourceSet_Item_resourceNumberofSymbols._ext = []
    _PRSResourceSet_Item_pRSMuting = SEQ(name='pRSMuting', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSMuting')), opt=True)
    _PRSResourceSet_Item_pRSResourceTransmitPower = INT(name='pRSResourceTransmitPower', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_pRSResourceTransmitPower._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-60, ub=50)], ev=None, er=[])
    _PRSResourceSet_Item_pRSResource_List = SEQ_OF(name='pRSResource-List', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSResource-List')))
    _PRSResourceSet_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSResourceSet_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSResourceSet_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PRSResourceSet_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSResourceSet_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResourceSet_Item_iE_Extensions__item__id._const_tab = ____PRSResourceSet_Item_iE_Extensions__item__id_tab
    ___PRSResourceSet_Item_iE_Extensions__item__id._const_tab_at = None
    ___PRSResourceSet_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSResourceSet_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSResourceSet_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSResourceSet_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResourceSet_Item_iE_Extensions__item__criticality._const_tab = ____PRSResourceSet_Item_iE_Extensions__item__criticality_tab
    ___PRSResourceSet_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSResourceSet_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSResourceSet_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSResourceSet_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSResourceSet_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab = ____PRSResourceSet_Item_iE_Extensions__item__extensionValue_tab
    ___PRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSResourceSet_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSResourceSet_Item_iE_Extensions__item__id),
        ('criticality', ___PRSResourceSet_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSResourceSet_Item_iE_Extensions__item__extensionValue),
        ])
    __PRSResourceSet_Item_iE_Extensions__item_._ext = None
    _PRSResourceSet_Item_iE_Extensions._cont = __PRSResourceSet_Item_iE_Extensions__item_
    _PRSResourceSet_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSResourceSet_Item._cont = ASN1Dict([
        ('pRSResourceSetID', _PRSResourceSet_Item_pRSResourceSetID),
        ('subcarrierSpacing', _PRSResourceSet_Item_subcarrierSpacing),
        ('pRSbandwidth', _PRSResourceSet_Item_pRSbandwidth),
        ('startPRB', _PRSResourceSet_Item_startPRB),
        ('pointA', _PRSResourceSet_Item_pointA),
        ('combSize', _PRSResourceSet_Item_combSize),
        ('cPType', _PRSResourceSet_Item_cPType),
        ('resourceSetPeriodicity', _PRSResourceSet_Item_resourceSetPeriodicity),
        ('resourceSetSlotOffset', _PRSResourceSet_Item_resourceSetSlotOffset),
        ('resourceRepetitionFactor', _PRSResourceSet_Item_resourceRepetitionFactor),
        ('resourceTimeGap', _PRSResourceSet_Item_resourceTimeGap),
        ('resourceNumberofSymbols', _PRSResourceSet_Item_resourceNumberofSymbols),
        ('pRSMuting', _PRSResourceSet_Item_pRSMuting),
        ('pRSResourceTransmitPower', _PRSResourceSet_Item_pRSResourceTransmitPower),
        ('pRSResource-List', _PRSResourceSet_Item_pRSResource_List),
        ('iE-Extensions', _PRSResourceSet_Item_iE_Extensions),
        ])
    PRSResourceSet_Item._ext = None
    
    #-----< PRSResourceSet-Item-ExtIEs >-----#
    PRSResourceSet_Item_ExtIEs = CLASS(name='PRSResourceSet-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PRSResourceSet_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSTransmissionOffIndication >-----#
    PRSTransmissionOffIndication = CHOICE(name='PRSTransmissionOffIndication', mode=MODE_TYPE)
    _PRSTransmissionOffIndication_pRSTransmissionOffPerTRP = NULL(name='pRSTransmissionOffPerTRP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSTransmissionOffIndication_pRSTransmissionOffPerResourceSet = SEQ_OF(name='pRSTransmissionOffPerResourceSet', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSTransmissionOffPerResourceSet')))
    _PRSTransmissionOffIndication_pRSTransmissionOffPerResource = SEQ_OF(name='pRSTransmissionOffPerResource', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSTransmissionOffPerResource')))
    _PRSTransmissionOffIndication_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __PRSTransmissionOffIndication_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___PRSTransmissionOffIndication_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PRSTransmissionOffIndication_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PRSTransmissionOffIndication_choice_extension_id._const_tab = ___PRSTransmissionOffIndication_choice_extension_id_tab
    __PRSTransmissionOffIndication_choice_extension_id._const_tab_at = None
    __PRSTransmissionOffIndication_choice_extension_id._const_tab_id = 'id'
    __PRSTransmissionOffIndication_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PRSTransmissionOffIndication_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PRSTransmissionOffIndication_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PRSTransmissionOffIndication_choice_extension_criticality._const_tab = ___PRSTransmissionOffIndication_choice_extension_criticality_tab
    __PRSTransmissionOffIndication_choice_extension_criticality._const_tab_at = ('..', 'id')
    __PRSTransmissionOffIndication_choice_extension_criticality._const_tab_id = 'criticality'
    __PRSTransmissionOffIndication_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PRSTransmissionOffIndication_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___PRSTransmissionOffIndication_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PRSTransmissionOffIndication_choice_extension_value._const_tab = ___PRSTransmissionOffIndication_choice_extension_value_tab
    __PRSTransmissionOffIndication_choice_extension_value._const_tab_at = ('..', 'id')
    __PRSTransmissionOffIndication_choice_extension_value._const_tab_id = 'Value'
    _PRSTransmissionOffIndication_choice_extension._cont = ASN1Dict([
        ('id', __PRSTransmissionOffIndication_choice_extension_id),
        ('criticality', __PRSTransmissionOffIndication_choice_extension_criticality),
        ('value', __PRSTransmissionOffIndication_choice_extension_value),
        ])
    _PRSTransmissionOffIndication_choice_extension._ext = None
    PRSTransmissionOffIndication._cont = ASN1Dict([
        ('pRSTransmissionOffPerTRP', _PRSTransmissionOffIndication_pRSTransmissionOffPerTRP),
        ('pRSTransmissionOffPerResourceSet', _PRSTransmissionOffIndication_pRSTransmissionOffPerResourceSet),
        ('pRSTransmissionOffPerResource', _PRSTransmissionOffIndication_pRSTransmissionOffPerResource),
        ('choice-extension', _PRSTransmissionOffIndication_choice_extension),
        ])
    PRSTransmissionOffIndication._ext = None
    
    #-----< PRSTransmissionOffIndication-ExtIEs >-----#
    PRSTransmissionOffIndication_ExtIEs = CLASS(name='PRSTransmissionOffIndication-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    PRSTransmissionOffIndication_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSTransmissionOffPerResource >-----#
    PRSTransmissionOffPerResource = SEQ_OF(name='PRSTransmissionOffPerResource', mode=MODE_TYPE)
    _PRSTransmissionOffPerResource__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PRSTransmissionOffPerResource-Item')))
    PRSTransmissionOffPerResource._cont = _PRSTransmissionOffPerResource__item_
    PRSTransmissionOffPerResource._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< PRSTransmissionOffPerResource-Item >-----#
    PRSTransmissionOffPerResource_Item = SEQ(name='PRSTransmissionOffPerResource-Item', mode=MODE_TYPE)
    _PRSTransmissionOffPerResource_Item_pRSResourceSetID = INT(name='pRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-Set-ID')))
    _PRSTransmissionOffPerResource_Item_pRSTransmissionOffIndicationPerResourceList = SEQ_OF(name='pRSTransmissionOffIndicationPerResourceList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PRSTransmissionOffPerResource_Item_pRSTransmissionOffIndicationPerResourceList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PRSTransmissionOffIndicationPerResource-Item')))
    _PRSTransmissionOffPerResource_Item_pRSTransmissionOffIndicationPerResourceList._cont = __PRSTransmissionOffPerResource_Item_pRSTransmissionOffIndicationPerResourceList__item_
    _PRSTransmissionOffPerResource_Item_pRSTransmissionOffIndicationPerResourceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _PRSTransmissionOffPerResource_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSTransmissionOffPerResource_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PRSTransmissionOffPerResource_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSTransmissionOffPerResource_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__id._const_tab = ____PRSTransmissionOffPerResource_Item_iE_Extensions__item__id_tab
    ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__id._const_tab_at = None
    ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSTransmissionOffPerResource_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSTransmissionOffPerResource_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__criticality._const_tab = ____PRSTransmissionOffPerResource_Item_iE_Extensions__item__criticality_tab
    ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSTransmissionOffPerResource_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSTransmissionOffPerResource_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__extensionValue._const_tab = ____PRSTransmissionOffPerResource_Item_iE_Extensions__item__extensionValue_tab
    ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSTransmissionOffPerResource_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__id),
        ('criticality', ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__extensionValue),
        ])
    __PRSTransmissionOffPerResource_Item_iE_Extensions__item_._ext = None
    _PRSTransmissionOffPerResource_Item_iE_Extensions._cont = __PRSTransmissionOffPerResource_Item_iE_Extensions__item_
    _PRSTransmissionOffPerResource_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSTransmissionOffPerResource_Item._cont = ASN1Dict([
        ('pRSResourceSetID', _PRSTransmissionOffPerResource_Item_pRSResourceSetID),
        ('pRSTransmissionOffIndicationPerResourceList', _PRSTransmissionOffPerResource_Item_pRSTransmissionOffIndicationPerResourceList),
        ('iE-Extensions', _PRSTransmissionOffPerResource_Item_iE_Extensions),
        ])
    PRSTransmissionOffPerResource_Item._ext = []
    
    #-----< PRSTransmissionOffPerResource-Item-ExtIEs >-----#
    PRSTransmissionOffPerResource_Item_ExtIEs = CLASS(name='PRSTransmissionOffPerResource-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PRSTransmissionOffPerResource_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSTransmissionOffIndicationPerResource-Item >-----#
    PRSTransmissionOffIndicationPerResource_Item = SEQ(name='PRSTransmissionOffIndicationPerResource-Item', mode=MODE_TYPE)
    _PRSTransmissionOffIndicationPerResource_Item_pRSResourceID = INT(name='pRSResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-ID')))
    _PRSTransmissionOffIndicationPerResource_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__id._const_tab = ____PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__id_tab
    ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__id._const_tab_at = None
    ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__criticality._const_tab = ____PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__criticality_tab
    ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__extensionValue._const_tab = ____PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__extensionValue_tab
    ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__id),
        ('criticality', ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__extensionValue),
        ])
    __PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item_._ext = None
    _PRSTransmissionOffIndicationPerResource_Item_iE_Extensions._cont = __PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item_
    _PRSTransmissionOffIndicationPerResource_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSTransmissionOffIndicationPerResource_Item._cont = ASN1Dict([
        ('pRSResourceID', _PRSTransmissionOffIndicationPerResource_Item_pRSResourceID),
        ('iE-Extensions', _PRSTransmissionOffIndicationPerResource_Item_iE_Extensions),
        ])
    PRSTransmissionOffIndicationPerResource_Item._ext = []
    
    #-----< PRSTransmissionOffIndicationPerResource-Item-ExtIEs >-----#
    PRSTransmissionOffIndicationPerResource_Item_ExtIEs = CLASS(name='PRSTransmissionOffIndicationPerResource-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PRSTransmissionOffIndicationPerResource_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSTransmissionOffInformation >-----#
    PRSTransmissionOffInformation = SEQ(name='PRSTransmissionOffInformation', mode=MODE_TYPE)
    _PRSTransmissionOffInformation_pRSTransmissionOffIndication = CHOICE(name='pRSTransmissionOffIndication', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSTransmissionOffIndication')))
    _PRSTransmissionOffInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSTransmissionOffInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSTransmissionOffInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PRSTransmissionOffInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSTransmissionOffInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionOffInformation_iE_Extensions__item__id._const_tab = ____PRSTransmissionOffInformation_iE_Extensions__item__id_tab
    ___PRSTransmissionOffInformation_iE_Extensions__item__id._const_tab_at = None
    ___PRSTransmissionOffInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSTransmissionOffInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSTransmissionOffInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSTransmissionOffInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionOffInformation_iE_Extensions__item__criticality._const_tab = ____PRSTransmissionOffInformation_iE_Extensions__item__criticality_tab
    ___PRSTransmissionOffInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSTransmissionOffInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSTransmissionOffInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSTransmissionOffInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSTransmissionOffInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionOffInformation_iE_Extensions__item__extensionValue._const_tab = ____PRSTransmissionOffInformation_iE_Extensions__item__extensionValue_tab
    ___PRSTransmissionOffInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSTransmissionOffInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSTransmissionOffInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSTransmissionOffInformation_iE_Extensions__item__id),
        ('criticality', ___PRSTransmissionOffInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSTransmissionOffInformation_iE_Extensions__item__extensionValue),
        ])
    __PRSTransmissionOffInformation_iE_Extensions__item_._ext = None
    _PRSTransmissionOffInformation_iE_Extensions._cont = __PRSTransmissionOffInformation_iE_Extensions__item_
    _PRSTransmissionOffInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSTransmissionOffInformation._cont = ASN1Dict([
        ('pRSTransmissionOffIndication', _PRSTransmissionOffInformation_pRSTransmissionOffIndication),
        ('iE-Extensions', _PRSTransmissionOffInformation_iE_Extensions),
        ])
    PRSTransmissionOffInformation._ext = []
    
    #-----< PRSTransmissionOffInformation-ExtIEs >-----#
    PRSTransmissionOffInformation_ExtIEs = CLASS(name='PRSTransmissionOffInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PRSTransmissionOffInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSTransmissionOffPerResourceSet >-----#
    PRSTransmissionOffPerResourceSet = SEQ_OF(name='PRSTransmissionOffPerResourceSet', mode=MODE_TYPE)
    _PRSTransmissionOffPerResourceSet__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PRSTransmissionOffPerResourceSet-Item')))
    PRSTransmissionOffPerResourceSet._cont = _PRSTransmissionOffPerResourceSet__item_
    PRSTransmissionOffPerResourceSet._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< PRSTransmissionOffPerResourceSet-Item >-----#
    PRSTransmissionOffPerResourceSet_Item = SEQ(name='PRSTransmissionOffPerResourceSet-Item', mode=MODE_TYPE)
    _PRSTransmissionOffPerResourceSet_Item_pRSResourceSetID = INT(name='pRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-Set-ID')))
    _PRSTransmissionOffPerResourceSet_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__id._const_tab = ____PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__id_tab
    ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__id._const_tab_at = None
    ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__criticality._const_tab = ____PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__criticality_tab
    ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__extensionValue._const_tab = ____PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__extensionValue_tab
    ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__id),
        ('criticality', ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__extensionValue),
        ])
    __PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item_._ext = None
    _PRSTransmissionOffPerResourceSet_Item_iE_Extensions._cont = __PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item_
    _PRSTransmissionOffPerResourceSet_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSTransmissionOffPerResourceSet_Item._cont = ASN1Dict([
        ('pRSResourceSetID', _PRSTransmissionOffPerResourceSet_Item_pRSResourceSetID),
        ('iE-Extensions', _PRSTransmissionOffPerResourceSet_Item_iE_Extensions),
        ])
    PRSTransmissionOffPerResourceSet_Item._ext = []
    
    #-----< PRSTransmissionOffPerResourceSet-Item-ExtIEs >-----#
    PRSTransmissionOffPerResourceSet_Item_ExtIEs = CLASS(name='PRSTransmissionOffPerResourceSet-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PRSTransmissionOffPerResourceSet_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PWS-Failed-NR-CGI-Item >-----#
    PWS_Failed_NR_CGI_Item = SEQ(name='PWS-Failed-NR-CGI-Item', mode=MODE_TYPE)
    _PWS_Failed_NR_CGI_Item_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _PWS_Failed_NR_CGI_Item_numberOfBroadcasts = INT(name='numberOfBroadcasts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NumberOfBroadcasts')))
    _PWS_Failed_NR_CGI_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PWS_Failed_NR_CGI_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PWS_Failed_NR_CGI_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PWS_Failed_NR_CGI_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__id._const_tab = ____PWS_Failed_NR_CGI_Item_iE_Extensions__item__id_tab
    ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__id._const_tab_at = None
    ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PWS_Failed_NR_CGI_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PWS_Failed_NR_CGI_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__criticality._const_tab = ____PWS_Failed_NR_CGI_Item_iE_Extensions__item__criticality_tab
    ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PWS_Failed_NR_CGI_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PWS_Failed_NR_CGI_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__extensionValue._const_tab = ____PWS_Failed_NR_CGI_Item_iE_Extensions__item__extensionValue_tab
    ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PWS_Failed_NR_CGI_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__id),
        ('criticality', ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__extensionValue),
        ])
    __PWS_Failed_NR_CGI_Item_iE_Extensions__item_._ext = None
    _PWS_Failed_NR_CGI_Item_iE_Extensions._cont = __PWS_Failed_NR_CGI_Item_iE_Extensions__item_
    _PWS_Failed_NR_CGI_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PWS_Failed_NR_CGI_Item._cont = ASN1Dict([
        ('nRCGI', _PWS_Failed_NR_CGI_Item_nRCGI),
        ('numberOfBroadcasts', _PWS_Failed_NR_CGI_Item_numberOfBroadcasts),
        ('iE-Extensions', _PWS_Failed_NR_CGI_Item_iE_Extensions),
        ])
    PWS_Failed_NR_CGI_Item._ext = []
    
    #-----< PWS-Failed-NR-CGI-ItemExtIEs >-----#
    PWS_Failed_NR_CGI_ItemExtIEs = CLASS(name='PWS-Failed-NR-CGI-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PWS_Failed_NR_CGI_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PWSSystemInformation >-----#
    PWSSystemInformation = SEQ(name='PWSSystemInformation', mode=MODE_TYPE)
    _PWSSystemInformation_sIBtype = INT(name='sIBtype', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SIBType-PWS')))
    _PWSSystemInformation_sIBmessage = OCT_STR(name='sIBmessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PWSSystemInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PWSSystemInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PWSSystemInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PWSSystemInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____PWSSystemInformation_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NotificationInformation')))
    _____PWSSystemInformation_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalSIBMessageList')))
    ____PWSSystemInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 220), ('criticality', 'ignore'), ('Extension', _____PWSSystemInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 231), ('criticality', 'reject'), ('Extension', _____PWSSystemInformation_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PWSSystemInformation_iE_Extensions__item__id._const_tab = ____PWSSystemInformation_iE_Extensions__item__id_tab
    ___PWSSystemInformation_iE_Extensions__item__id._const_tab_at = None
    ___PWSSystemInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___PWSSystemInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PWSSystemInformation_iE_Extensions__item__criticality._const_tab = ____PWSSystemInformation_iE_Extensions__item__id_tab
    ___PWSSystemInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PWSSystemInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PWSSystemInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PWSSystemInformation_iE_Extensions__item__extensionValue._const_tab = ____PWSSystemInformation_iE_Extensions__item__id_tab
    ___PWSSystemInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PWSSystemInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PWSSystemInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PWSSystemInformation_iE_Extensions__item__id),
        ('criticality', ___PWSSystemInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___PWSSystemInformation_iE_Extensions__item__extensionValue),
        ])
    __PWSSystemInformation_iE_Extensions__item_._ext = None
    _PWSSystemInformation_iE_Extensions._cont = __PWSSystemInformation_iE_Extensions__item_
    _PWSSystemInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PWSSystemInformation._cont = ASN1Dict([
        ('sIBtype', _PWSSystemInformation_sIBtype),
        ('sIBmessage', _PWSSystemInformation_sIBmessage),
        ('iE-Extensions', _PWSSystemInformation_iE_Extensions),
        ])
    PWSSystemInformation._ext = []
    
    #-----< PWSSystemInformationExtIEs >-----#
    PWSSystemInformationExtIEs = CLASS(name='PWSSystemInformationExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _PWSSystemInformationExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NotificationInformation')))
    _PWSSystemInformationExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalSIBMessageList')))
    PWSSystemInformationExtIEs._val = ASN1Set(rv=[dict([('id', 220), ('criticality', 'ignore'), ('Extension', _PWSSystemInformationExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 231), ('criticality', 'reject'), ('Extension', _PWSSystemInformationExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PrivacyIndicator >-----#
    PrivacyIndicator = ENUM(name='PrivacyIndicator', mode=MODE_TYPE)
    PrivacyIndicator._cont = ASN1Dict([('immediate-MDT', 0), ('logged-MDT', 1)])
    PrivacyIndicator._ext = []
    
    #-----< PRS-ID >-----#
    PRS_ID = INT(name='PRS-ID', mode=MODE_TYPE)
    PRS_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< PRSTRPList >-----#
    PRSTRPList = SEQ_OF(name='PRSTRPList', mode=MODE_TYPE)
    _PRSTRPList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PRSTRPItem')))
    PRSTRPList._cont = _PRSTRPList__item_
    PRSTRPList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< PRSTRPItem >-----#
    PRSTRPItem = SEQ(name='PRSTRPItem', mode=MODE_TYPE)
    _PRSTRPItem_tRP_ID = INT(name='tRP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPID')))
    _PRSTRPItem_requestedDLPRSTransmissionCharacteristics = SEQ(name='requestedDLPRSTransmissionCharacteristics', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RequestedDLPRSTransmissionCharacteristics')), opt=True)
    _PRSTRPItem_pRSTransmissionOffInformation = SEQ(name='pRSTransmissionOffInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSTransmissionOffInformation')), opt=True)
    _PRSTRPItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSTRPItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSTRPItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PRSTRPItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSTRPItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTRPItem_iE_Extensions__item__id._const_tab = ____PRSTRPItem_iE_Extensions__item__id_tab
    ___PRSTRPItem_iE_Extensions__item__id._const_tab_at = None
    ___PRSTRPItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSTRPItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSTRPItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSTRPItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTRPItem_iE_Extensions__item__criticality._const_tab = ____PRSTRPItem_iE_Extensions__item__criticality_tab
    ___PRSTRPItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSTRPItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSTRPItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSTRPItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSTRPItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTRPItem_iE_Extensions__item__extensionValue._const_tab = ____PRSTRPItem_iE_Extensions__item__extensionValue_tab
    ___PRSTRPItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSTRPItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSTRPItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSTRPItem_iE_Extensions__item__id),
        ('criticality', ___PRSTRPItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSTRPItem_iE_Extensions__item__extensionValue),
        ])
    __PRSTRPItem_iE_Extensions__item_._ext = None
    _PRSTRPItem_iE_Extensions._cont = __PRSTRPItem_iE_Extensions__item_
    _PRSTRPItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSTRPItem._cont = ASN1Dict([
        ('tRP-ID', _PRSTRPItem_tRP_ID),
        ('requestedDLPRSTransmissionCharacteristics', _PRSTRPItem_requestedDLPRSTransmissionCharacteristics),
        ('pRSTransmissionOffInformation', _PRSTRPItem_pRSTransmissionOffInformation),
        ('iE-Extensions', _PRSTRPItem_iE_Extensions),
        ])
    PRSTRPItem._ext = []
    
    #-----< PRSTRPItem-ExtIEs >-----#
    PRSTRPItem_ExtIEs = CLASS(name='PRSTRPItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PRSTRPItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RequestedDLPRSTransmissionCharacteristics >-----#
    RequestedDLPRSTransmissionCharacteristics = SEQ(name='RequestedDLPRSTransmissionCharacteristics', mode=MODE_TYPE)
    _RequestedDLPRSTransmissionCharacteristics_requestedDLPRSResourceSet_List = SEQ_OF(name='requestedDLPRSResourceSet-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RequestedDLPRSResourceSet-List')))
    _RequestedDLPRSTransmissionCharacteristics_numberofFrequencyLayers = INT(name='numberofFrequencyLayers', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedDLPRSTransmissionCharacteristics_numberofFrequencyLayers._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _RequestedDLPRSTransmissionCharacteristics_startTimeAndDuration = SEQ(name='startTimeAndDuration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'StartTimeAndDuration')), opt=True)
    _RequestedDLPRSTransmissionCharacteristics_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__id._const_tab = ____RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__id_tab
    ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__id._const_tab_at = None
    ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__id._const_tab_id = 'id'
    ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__criticality._const_tab = ____RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__criticality_tab
    ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__extensionValue._const_tab = ____RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__extensionValue_tab
    ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__id),
        ('criticality', ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__criticality),
        ('extensionValue', ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__extensionValue),
        ])
    __RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item_._ext = None
    _RequestedDLPRSTransmissionCharacteristics_iE_Extensions._cont = __RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item_
    _RequestedDLPRSTransmissionCharacteristics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RequestedDLPRSTransmissionCharacteristics._cont = ASN1Dict([
        ('requestedDLPRSResourceSet-List', _RequestedDLPRSTransmissionCharacteristics_requestedDLPRSResourceSet_List),
        ('numberofFrequencyLayers', _RequestedDLPRSTransmissionCharacteristics_numberofFrequencyLayers),
        ('startTimeAndDuration', _RequestedDLPRSTransmissionCharacteristics_startTimeAndDuration),
        ('iE-Extensions', _RequestedDLPRSTransmissionCharacteristics_iE_Extensions),
        ])
    RequestedDLPRSTransmissionCharacteristics._ext = []
    
    #-----< RequestedDLPRSTransmissionCharacteristics-ExtIEs >-----#
    RequestedDLPRSTransmissionCharacteristics_ExtIEs = CLASS(name='RequestedDLPRSTransmissionCharacteristics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RequestedDLPRSTransmissionCharacteristics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RequestedDLPRSResourceSet-List >-----#
    RequestedDLPRSResourceSet_List = SEQ_OF(name='RequestedDLPRSResourceSet-List', mode=MODE_TYPE)
    _RequestedDLPRSResourceSet_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RequestedDLPRSResourceSet-Item')))
    RequestedDLPRSResourceSet_List._cont = _RequestedDLPRSResourceSet_List__item_
    RequestedDLPRSResourceSet_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< RequestedDLPRSResourceSet-Item >-----#
    RequestedDLPRSResourceSet_Item = SEQ(name='RequestedDLPRSResourceSet-Item', mode=MODE_TYPE)
    _RequestedDLPRSResourceSet_Item_pRSbandwidth = INT(name='pRSbandwidth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RequestedDLPRSResourceSet_Item_pRSbandwidth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _RequestedDLPRSResourceSet_Item_combSize = ENUM(name='combSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedDLPRSResourceSet_Item_combSize._cont = ASN1Dict([('n2', 0), ('n4', 1), ('n6', 2), ('n12', 3)])
    _RequestedDLPRSResourceSet_Item_combSize._ext = []
    _RequestedDLPRSResourceSet_Item_resourceSetPeriodicity = ENUM(name='resourceSetPeriodicity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedDLPRSResourceSet_Item_resourceSetPeriodicity._cont = ASN1Dict([('n4', 0), ('n5', 1), ('n8', 2), ('n10', 3), ('n16', 4), ('n20', 5), ('n32', 6), ('n40', 7), ('n64', 8), ('n80', 9), ('n160', 10), ('n320', 11), ('n640', 12), ('n1280', 13), ('n2560', 14), ('n5120', 15), ('n10240', 16), ('n20480', 17), ('n40960', 18), ('n81920', 19)])
    _RequestedDLPRSResourceSet_Item_resourceSetPeriodicity._ext = []
    _RequestedDLPRSResourceSet_Item_resourceRepetitionFactor = ENUM(name='resourceRepetitionFactor', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedDLPRSResourceSet_Item_resourceRepetitionFactor._cont = ASN1Dict([('rf1', 0), ('rf2', 1), ('rf4', 2), ('rf6', 3), ('rf8', 4), ('rf16', 5), ('rf32', 6)])
    _RequestedDLPRSResourceSet_Item_resourceRepetitionFactor._ext = []
    _RequestedDLPRSResourceSet_Item_resourceNumberofSymbols = ENUM(name='resourceNumberofSymbols', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedDLPRSResourceSet_Item_resourceNumberofSymbols._cont = ASN1Dict([('n2', 0), ('n4', 1), ('n6', 2), ('n12', 3)])
    _RequestedDLPRSResourceSet_Item_resourceNumberofSymbols._ext = []
    _RequestedDLPRSResourceSet_Item_requestedDLPRSResource_List = SEQ_OF(name='requestedDLPRSResource-List', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RequestedDLPRSResource-List')), opt=True)
    _RequestedDLPRSResourceSet_Item_resourceSetStartTimeAndDuration = SEQ(name='resourceSetStartTimeAndDuration', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'StartTimeAndDuration')), opt=True)
    _RequestedDLPRSResourceSet_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RequestedDLPRSResourceSet_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RequestedDLPRSResourceSet_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RequestedDLPRSResourceSet_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__id._const_tab = ____RequestedDLPRSResourceSet_Item_iE_Extensions__item__id_tab
    ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__id._const_tab_at = None
    ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RequestedDLPRSResourceSet_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RequestedDLPRSResourceSet_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__criticality._const_tab = ____RequestedDLPRSResourceSet_Item_iE_Extensions__item__criticality_tab
    ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RequestedDLPRSResourceSet_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RequestedDLPRSResourceSet_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab = ____RequestedDLPRSResourceSet_Item_iE_Extensions__item__extensionValue_tab
    ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RequestedDLPRSResourceSet_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__id),
        ('criticality', ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__extensionValue),
        ])
    __RequestedDLPRSResourceSet_Item_iE_Extensions__item_._ext = None
    _RequestedDLPRSResourceSet_Item_iE_Extensions._cont = __RequestedDLPRSResourceSet_Item_iE_Extensions__item_
    _RequestedDLPRSResourceSet_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RequestedDLPRSResourceSet_Item._cont = ASN1Dict([
        ('pRSbandwidth', _RequestedDLPRSResourceSet_Item_pRSbandwidth),
        ('combSize', _RequestedDLPRSResourceSet_Item_combSize),
        ('resourceSetPeriodicity', _RequestedDLPRSResourceSet_Item_resourceSetPeriodicity),
        ('resourceRepetitionFactor', _RequestedDLPRSResourceSet_Item_resourceRepetitionFactor),
        ('resourceNumberofSymbols', _RequestedDLPRSResourceSet_Item_resourceNumberofSymbols),
        ('requestedDLPRSResource-List', _RequestedDLPRSResourceSet_Item_requestedDLPRSResource_List),
        ('resourceSetStartTimeAndDuration', _RequestedDLPRSResourceSet_Item_resourceSetStartTimeAndDuration),
        ('iE-Extensions', _RequestedDLPRSResourceSet_Item_iE_Extensions),
        ])
    RequestedDLPRSResourceSet_Item._ext = []
    
    #-----< RequestedDLPRSResourceSet-Item-ExtIEs >-----#
    RequestedDLPRSResourceSet_Item_ExtIEs = CLASS(name='RequestedDLPRSResourceSet-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RequestedDLPRSResourceSet_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RequestedDLPRSResource-List >-----#
    RequestedDLPRSResource_List = SEQ_OF(name='RequestedDLPRSResource-List', mode=MODE_TYPE)
    _RequestedDLPRSResource_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RequestedDLPRSResource-Item')))
    RequestedDLPRSResource_List._cont = _RequestedDLPRSResource_List__item_
    RequestedDLPRSResource_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< RequestedDLPRSResource-Item >-----#
    RequestedDLPRSResource_Item = SEQ(name='RequestedDLPRSResource-Item', mode=MODE_TYPE)
    _RequestedDLPRSResource_Item_qCLInfo = CHOICE(name='qCLInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSResource-QCLInfo')), opt=True)
    _RequestedDLPRSResource_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RequestedDLPRSResource_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RequestedDLPRSResource_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RequestedDLPRSResource_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RequestedDLPRSResource_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestedDLPRSResource_Item_iE_Extensions__item__id._const_tab = ____RequestedDLPRSResource_Item_iE_Extensions__item__id_tab
    ___RequestedDLPRSResource_Item_iE_Extensions__item__id._const_tab_at = None
    ___RequestedDLPRSResource_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___RequestedDLPRSResource_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RequestedDLPRSResource_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RequestedDLPRSResource_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestedDLPRSResource_Item_iE_Extensions__item__criticality._const_tab = ____RequestedDLPRSResource_Item_iE_Extensions__item__criticality_tab
    ___RequestedDLPRSResource_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RequestedDLPRSResource_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RequestedDLPRSResource_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RequestedDLPRSResource_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RequestedDLPRSResource_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestedDLPRSResource_Item_iE_Extensions__item__extensionValue._const_tab = ____RequestedDLPRSResource_Item_iE_Extensions__item__extensionValue_tab
    ___RequestedDLPRSResource_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RequestedDLPRSResource_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RequestedDLPRSResource_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RequestedDLPRSResource_Item_iE_Extensions__item__id),
        ('criticality', ___RequestedDLPRSResource_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___RequestedDLPRSResource_Item_iE_Extensions__item__extensionValue),
        ])
    __RequestedDLPRSResource_Item_iE_Extensions__item_._ext = None
    _RequestedDLPRSResource_Item_iE_Extensions._cont = __RequestedDLPRSResource_Item_iE_Extensions__item_
    _RequestedDLPRSResource_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RequestedDLPRSResource_Item._cont = ASN1Dict([
        ('qCLInfo', _RequestedDLPRSResource_Item_qCLInfo),
        ('iE-Extensions', _RequestedDLPRSResource_Item_iE_Extensions),
        ])
    RequestedDLPRSResource_Item._ext = []
    
    #-----< RequestedDLPRSResource-Item-ExtIEs >-----#
    RequestedDLPRSResource_Item_ExtIEs = CLASS(name='RequestedDLPRSResource-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RequestedDLPRSResource_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSTransmissionTRPList >-----#
    PRSTransmissionTRPList = SEQ_OF(name='PRSTransmissionTRPList', mode=MODE_TYPE)
    _PRSTransmissionTRPList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PRSTransmissionTRPItem')))
    PRSTransmissionTRPList._cont = _PRSTransmissionTRPList__item_
    PRSTransmissionTRPList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< PRSTransmissionTRPItem >-----#
    PRSTransmissionTRPItem = SEQ(name='PRSTransmissionTRPItem', mode=MODE_TYPE)
    _PRSTransmissionTRPItem_tRP_ID = INT(name='tRP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPID')))
    _PRSTransmissionTRPItem_pRSConfiguration = SEQ(name='pRSConfiguration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSConfiguration')))
    _PRSTransmissionTRPItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSTransmissionTRPItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___PRSTransmissionTRPItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PRSTransmissionTRPItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSTransmissionTRPItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionTRPItem_iE_Extensions__item__id._const_tab = ____PRSTransmissionTRPItem_iE_Extensions__item__id_tab
    ___PRSTransmissionTRPItem_iE_Extensions__item__id._const_tab_at = None
    ___PRSTransmissionTRPItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSTransmissionTRPItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSTransmissionTRPItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSTransmissionTRPItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionTRPItem_iE_Extensions__item__criticality._const_tab = ____PRSTransmissionTRPItem_iE_Extensions__item__criticality_tab
    ___PRSTransmissionTRPItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSTransmissionTRPItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSTransmissionTRPItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSTransmissionTRPItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____PRSTransmissionTRPItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionTRPItem_iE_Extensions__item__extensionValue._const_tab = ____PRSTransmissionTRPItem_iE_Extensions__item__extensionValue_tab
    ___PRSTransmissionTRPItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSTransmissionTRPItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSTransmissionTRPItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSTransmissionTRPItem_iE_Extensions__item__id),
        ('criticality', ___PRSTransmissionTRPItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSTransmissionTRPItem_iE_Extensions__item__extensionValue),
        ])
    __PRSTransmissionTRPItem_iE_Extensions__item_._ext = None
    _PRSTransmissionTRPItem_iE_Extensions._cont = __PRSTransmissionTRPItem_iE_Extensions__item_
    _PRSTransmissionTRPItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSTransmissionTRPItem._cont = ASN1Dict([
        ('tRP-ID', _PRSTransmissionTRPItem_tRP_ID),
        ('pRSConfiguration', _PRSTransmissionTRPItem_pRSConfiguration),
        ('iE-Extensions', _PRSTransmissionTRPItem_iE_Extensions),
        ])
    PRSTransmissionTRPItem._ext = []
    
    #-----< PRSTransmissionTRPItem-ExtIEs >-----#
    PRSTransmissionTRPItem_ExtIEs = CLASS(name='PRSTransmissionTRPItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    PRSTransmissionTRPItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QCI >-----#
    QCI = INT(name='QCI', mode=MODE_TYPE)
    QCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< QoEInformation >-----#
    QoEInformation = SEQ(name='QoEInformation', mode=MODE_TYPE)
    _QoEInformation_qoEInformationList = SEQ_OF(name='qoEInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoEInformationList')))
    _QoEInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QoEInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___QoEInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____QoEInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____QoEInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoEInformation_iE_Extensions__item__id._const_tab = ____QoEInformation_iE_Extensions__item__id_tab
    ___QoEInformation_iE_Extensions__item__id._const_tab_at = None
    ___QoEInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___QoEInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____QoEInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____QoEInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoEInformation_iE_Extensions__item__criticality._const_tab = ____QoEInformation_iE_Extensions__item__criticality_tab
    ___QoEInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QoEInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QoEInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____QoEInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____QoEInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoEInformation_iE_Extensions__item__extensionValue._const_tab = ____QoEInformation_iE_Extensions__item__extensionValue_tab
    ___QoEInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QoEInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QoEInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QoEInformation_iE_Extensions__item__id),
        ('criticality', ___QoEInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___QoEInformation_iE_Extensions__item__extensionValue),
        ])
    __QoEInformation_iE_Extensions__item_._ext = None
    _QoEInformation_iE_Extensions._cont = __QoEInformation_iE_Extensions__item_
    _QoEInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QoEInformation._cont = ASN1Dict([
        ('qoEInformationList', _QoEInformation_qoEInformationList),
        ('iE-Extensions', _QoEInformation_iE_Extensions),
        ])
    QoEInformation._ext = None
    
    #-----< QoEInformation-ExtIEs >-----#
    QoEInformation_ExtIEs = CLASS(name='QoEInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    QoEInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QoEInformationList >-----#
    QoEInformationList = SEQ_OF(name='QoEInformationList', mode=MODE_TYPE)
    _QoEInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QoEInformationList-Item')))
    QoEInformationList._cont = _QoEInformationList__item_
    QoEInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< QoEInformationList-Item >-----#
    QoEInformationList_Item = SEQ(name='QoEInformationList-Item', mode=MODE_TYPE)
    _QoEInformationList_Item_qoEMetrics = SEQ(name='qoEMetrics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoEMetrics')), opt=True)
    _QoEInformationList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QoEInformationList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___QoEInformationList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____QoEInformationList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____QoEInformationList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoEInformationList_Item_iE_Extensions__item__id._const_tab = ____QoEInformationList_Item_iE_Extensions__item__id_tab
    ___QoEInformationList_Item_iE_Extensions__item__id._const_tab_at = None
    ___QoEInformationList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___QoEInformationList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____QoEInformationList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____QoEInformationList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoEInformationList_Item_iE_Extensions__item__criticality._const_tab = ____QoEInformationList_Item_iE_Extensions__item__criticality_tab
    ___QoEInformationList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QoEInformationList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QoEInformationList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____QoEInformationList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____QoEInformationList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoEInformationList_Item_iE_Extensions__item__extensionValue._const_tab = ____QoEInformationList_Item_iE_Extensions__item__extensionValue_tab
    ___QoEInformationList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QoEInformationList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QoEInformationList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QoEInformationList_Item_iE_Extensions__item__id),
        ('criticality', ___QoEInformationList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___QoEInformationList_Item_iE_Extensions__item__extensionValue),
        ])
    __QoEInformationList_Item_iE_Extensions__item_._ext = None
    _QoEInformationList_Item_iE_Extensions._cont = __QoEInformationList_Item_iE_Extensions__item_
    _QoEInformationList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QoEInformationList_Item._cont = ASN1Dict([
        ('qoEMetrics', _QoEInformationList_Item_qoEMetrics),
        ('iE-Extensions', _QoEInformationList_Item_iE_Extensions),
        ])
    QoEInformationList_Item._ext = None
    
    #-----< QoEInformationList-Item-ExtIEs >-----#
    QoEInformationList_Item_ExtIEs = CLASS(name='QoEInformationList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    QoEInformationList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QoEMetrics >-----#
    QoEMetrics = SEQ(name='QoEMetrics', mode=MODE_TYPE)
    _QoEMetrics_appLayerBufferLevelList = OCT_STR(name='appLayerBufferLevelList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AppLayerBufferLevelList')), opt=True)
    _QoEMetrics_playoutDelayForMediaStartup = OCT_STR(name='playoutDelayForMediaStartup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PlayoutDelayForMediaStartup')), opt=True)
    _QoEMetrics_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QoEMetrics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___QoEMetrics_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____QoEMetrics_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____QoEMetrics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoEMetrics_iE_Extensions__item__id._const_tab = ____QoEMetrics_iE_Extensions__item__id_tab
    ___QoEMetrics_iE_Extensions__item__id._const_tab_at = None
    ___QoEMetrics_iE_Extensions__item__id._const_tab_id = 'id'
    ___QoEMetrics_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____QoEMetrics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____QoEMetrics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoEMetrics_iE_Extensions__item__criticality._const_tab = ____QoEMetrics_iE_Extensions__item__criticality_tab
    ___QoEMetrics_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QoEMetrics_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QoEMetrics_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____QoEMetrics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____QoEMetrics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoEMetrics_iE_Extensions__item__extensionValue._const_tab = ____QoEMetrics_iE_Extensions__item__extensionValue_tab
    ___QoEMetrics_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QoEMetrics_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QoEMetrics_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QoEMetrics_iE_Extensions__item__id),
        ('criticality', ___QoEMetrics_iE_Extensions__item__criticality),
        ('extensionValue', ___QoEMetrics_iE_Extensions__item__extensionValue),
        ])
    __QoEMetrics_iE_Extensions__item_._ext = None
    _QoEMetrics_iE_Extensions._cont = __QoEMetrics_iE_Extensions__item_
    _QoEMetrics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QoEMetrics._cont = ASN1Dict([
        ('appLayerBufferLevelList', _QoEMetrics_appLayerBufferLevelList),
        ('playoutDelayForMediaStartup', _QoEMetrics_playoutDelayForMediaStartup),
        ('iE-Extensions', _QoEMetrics_iE_Extensions),
        ])
    QoEMetrics._ext = []
    
    #-----< QoEMetrics-ExtIEs >-----#
    QoEMetrics_ExtIEs = CLASS(name='QoEMetrics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    QoEMetrics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QoS-Characteristics >-----#
    QoS_Characteristics = CHOICE(name='QoS-Characteristics', mode=MODE_TYPE)
    _QoS_Characteristics_non_Dynamic_5QI = SEQ(name='non-Dynamic-5QI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NonDynamic5QIDescriptor')))
    _QoS_Characteristics_dynamic_5QI = SEQ(name='dynamic-5QI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Dynamic5QIDescriptor')))
    _QoS_Characteristics_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __QoS_Characteristics_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___QoS_Characteristics_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___QoS_Characteristics_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __QoS_Characteristics_choice_extension_id._const_tab = ___QoS_Characteristics_choice_extension_id_tab
    __QoS_Characteristics_choice_extension_id._const_tab_at = None
    __QoS_Characteristics_choice_extension_id._const_tab_id = 'id'
    __QoS_Characteristics_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___QoS_Characteristics_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___QoS_Characteristics_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __QoS_Characteristics_choice_extension_criticality._const_tab = ___QoS_Characteristics_choice_extension_criticality_tab
    __QoS_Characteristics_choice_extension_criticality._const_tab_at = ('..', 'id')
    __QoS_Characteristics_choice_extension_criticality._const_tab_id = 'criticality'
    __QoS_Characteristics_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___QoS_Characteristics_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___QoS_Characteristics_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __QoS_Characteristics_choice_extension_value._const_tab = ___QoS_Characteristics_choice_extension_value_tab
    __QoS_Characteristics_choice_extension_value._const_tab_at = ('..', 'id')
    __QoS_Characteristics_choice_extension_value._const_tab_id = 'Value'
    _QoS_Characteristics_choice_extension._cont = ASN1Dict([
        ('id', __QoS_Characteristics_choice_extension_id),
        ('criticality', __QoS_Characteristics_choice_extension_criticality),
        ('value', __QoS_Characteristics_choice_extension_value),
        ])
    _QoS_Characteristics_choice_extension._ext = None
    QoS_Characteristics._cont = ASN1Dict([
        ('non-Dynamic-5QI', _QoS_Characteristics_non_Dynamic_5QI),
        ('dynamic-5QI', _QoS_Characteristics_dynamic_5QI),
        ('choice-extension', _QoS_Characteristics_choice_extension),
        ])
    QoS_Characteristics._ext = None
    
    #-----< QoS-Characteristics-ExtIEs >-----#
    QoS_Characteristics_ExtIEs = CLASS(name='QoS-Characteristics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    QoS_Characteristics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QoSFlowIdentifier >-----#
    QoSFlowIdentifier = INT(name='QoSFlowIdentifier', mode=MODE_TYPE)
    QoSFlowIdentifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< QoSFlowLevelQoSParameters >-----#
    QoSFlowLevelQoSParameters = SEQ(name='QoSFlowLevelQoSParameters', mode=MODE_TYPE)
    _QoSFlowLevelQoSParameters_qoS_Characteristics = CHOICE(name='qoS-Characteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoS-Characteristics')))
    _QoSFlowLevelQoSParameters_nGRANallocationRetentionPriority = SEQ(name='nGRANallocationRetentionPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NGRANAllocationAndRetentionPriority')))
    _QoSFlowLevelQoSParameters_gBR_QoS_Flow_Information = SEQ(name='gBR-QoS-Flow-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GBR-QoSFlowInformation')), opt=True)
    _QoSFlowLevelQoSParameters_reflective_QoS_Attribute = ENUM(name='reflective-QoS-Attribute', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _QoSFlowLevelQoSParameters_reflective_QoS_Attribute._cont = ASN1Dict([('subject-to', 0)])
    _QoSFlowLevelQoSParameters_reflective_QoS_Attribute._ext = []
    _QoSFlowLevelQoSParameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QoSFlowLevelQoSParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDUSessionID')))
    _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QosMonitoringRequest')))
    _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    ____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 180), ('criticality', 'ignore'), ('Extension', _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 181), ('criticality', 'ignore'), ('Extension', _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 257), ('criticality', 'ignore'), ('Extension', _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 436), ('criticality', 'ignore'), ('Extension', _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__id._const_tab = ____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__id._const_tab_at = None
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__criticality._const_tab = ____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__extensionValue._const_tab = ____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QoSFlowLevelQoSParameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QoSFlowLevelQoSParameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QoSFlowLevelQoSParameters_iE_Extensions__item__id),
        ('criticality', ___QoSFlowLevelQoSParameters_iE_Extensions__item__criticality),
        ('extensionValue', ___QoSFlowLevelQoSParameters_iE_Extensions__item__extensionValue),
        ])
    __QoSFlowLevelQoSParameters_iE_Extensions__item_._ext = None
    _QoSFlowLevelQoSParameters_iE_Extensions._cont = __QoSFlowLevelQoSParameters_iE_Extensions__item_
    _QoSFlowLevelQoSParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QoSFlowLevelQoSParameters._cont = ASN1Dict([
        ('qoS-Characteristics', _QoSFlowLevelQoSParameters_qoS_Characteristics),
        ('nGRANallocationRetentionPriority', _QoSFlowLevelQoSParameters_nGRANallocationRetentionPriority),
        ('gBR-QoS-Flow-Information', _QoSFlowLevelQoSParameters_gBR_QoS_Flow_Information),
        ('reflective-QoS-Attribute', _QoSFlowLevelQoSParameters_reflective_QoS_Attribute),
        ('iE-Extensions', _QoSFlowLevelQoSParameters_iE_Extensions),
        ])
    QoSFlowLevelQoSParameters._ext = None
    
    #-----< QoSFlowLevelQoSParameters-ExtIEs >-----#
    QoSFlowLevelQoSParameters_ExtIEs = CLASS(name='QoSFlowLevelQoSParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDUSessionID')))
    _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QosMonitoringRequest')))
    _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    QoSFlowLevelQoSParameters_ExtIEs._val = ASN1Set(rv=[dict([('id', 180), ('criticality', 'ignore'), ('Extension', _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 181), ('criticality', 'ignore'), ('Extension', _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 257), ('criticality', 'ignore'), ('Extension', _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 436), ('criticality', 'ignore'), ('Extension', _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< QoSFlowMappingIndication >-----#
    QoSFlowMappingIndication = ENUM(name='QoSFlowMappingIndication', mode=MODE_TYPE)
    QoSFlowMappingIndication._cont = ASN1Dict([('ul', 0), ('dl', 1)])
    QoSFlowMappingIndication._ext = []
    
    #-----< QoSInformation >-----#
    QoSInformation = CHOICE(name='QoSInformation', mode=MODE_TYPE)
    _QoSInformation_eUTRANQoS = SEQ(name='eUTRANQoS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRANQoS')))
    _QoSInformation_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __QoSInformation_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___QoSInformation_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____QoSInformation_choice_extension_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRB-Information')))
    ___QoSInformation_choice_extension_id_tab._val = ASN1Set(rv=[dict([('id', 164), ('criticality', 'ignore'), ('Value', ____QoSInformation_choice_extension_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __QoSInformation_choice_extension_id._const_tab = ___QoSInformation_choice_extension_id_tab
    __QoSInformation_choice_extension_id._const_tab_at = None
    __QoSInformation_choice_extension_id._const_tab_id = 'id'
    __QoSInformation_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __QoSInformation_choice_extension_criticality._const_tab = ___QoSInformation_choice_extension_id_tab
    __QoSInformation_choice_extension_criticality._const_tab_at = ('..', 'id')
    __QoSInformation_choice_extension_criticality._const_tab_id = 'criticality'
    __QoSInformation_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __QoSInformation_choice_extension_value._const_tab = ___QoSInformation_choice_extension_id_tab
    __QoSInformation_choice_extension_value._const_tab_at = ('..', 'id')
    __QoSInformation_choice_extension_value._const_tab_id = 'Value'
    _QoSInformation_choice_extension._cont = ASN1Dict([
        ('id', __QoSInformation_choice_extension_id),
        ('criticality', __QoSInformation_choice_extension_criticality),
        ('value', __QoSInformation_choice_extension_value),
        ])
    _QoSInformation_choice_extension._ext = None
    QoSInformation._cont = ASN1Dict([
        ('eUTRANQoS', _QoSInformation_eUTRANQoS),
        ('choice-extension', _QoSInformation_choice_extension),
        ])
    QoSInformation._ext = None
    
    #-----< QoSInformation-ExtIEs >-----#
    QoSInformation_ExtIEs = CLASS(name='QoSInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _QoSInformation_ExtIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRB-Information')))
    QoSInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 164), ('criticality', 'ignore'), ('Value', _QoSInformation_ExtIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< QosMonitoringRequest >-----#
    QosMonitoringRequest = ENUM(name='QosMonitoringRequest', mode=MODE_TYPE)
    QosMonitoringRequest._cont = ASN1Dict([('ul', 0), ('dl', 1), ('both', 2), ('stop', 3)])
    QosMonitoringRequest._ext = ['stop']
    
    #-----< QoSParaSetIndex >-----#
    QoSParaSetIndex = INT(name='QoSParaSetIndex', mode=MODE_TYPE)
    QoSParaSetIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=[], er=[])
    
    #-----< QoSParaSetNotifyIndex >-----#
    QoSParaSetNotifyIndex = INT(name='QoSParaSetNotifyIndex', mode=MODE_TYPE)
    QoSParaSetNotifyIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=[], er=[])
    
    #-----< RACH-Config-Common >-----#
    RACH_Config_Common = OCT_STR(name='RACH-Config-Common', mode=MODE_TYPE)
    
    #-----< RACH-Config-Common-IAB >-----#
    RACH_Config_Common_IAB = OCT_STR(name='RACH-Config-Common-IAB', mode=MODE_TYPE)
    
    #-----< RACHReportContainer >-----#
    RACHReportContainer = OCT_STR(name='RACHReportContainer', mode=MODE_TYPE)
    
    #-----< RACHReportInformationList >-----#
    RACHReportInformationList = SEQ_OF(name='RACHReportInformationList', mode=MODE_TYPE)
    _RACHReportInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RACHReportInformationItem')))
    RACHReportInformationList._cont = _RACHReportInformationList__item_
    RACHReportInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< RACHReportInformationItem >-----#
    RACHReportInformationItem = SEQ(name='RACHReportInformationItem', mode=MODE_TYPE)
    _RACHReportInformationItem_rACHReportContainer = OCT_STR(name='rACHReportContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RACHReportContainer')))
    _RACHReportInformationItem_uEAssitantIdentifier = INT(name='uEAssitantIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')), opt=True)
    _RACHReportInformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RACHReportInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RACHReportInformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RACHReportInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RACHReportInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RACHReportInformationItem_iE_Extensions__item__id._const_tab = ____RACHReportInformationItem_iE_Extensions__item__id_tab
    ___RACHReportInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___RACHReportInformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___RACHReportInformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RACHReportInformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RACHReportInformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RACHReportInformationItem_iE_Extensions__item__criticality._const_tab = ____RACHReportInformationItem_iE_Extensions__item__criticality_tab
    ___RACHReportInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RACHReportInformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RACHReportInformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RACHReportInformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RACHReportInformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RACHReportInformationItem_iE_Extensions__item__extensionValue._const_tab = ____RACHReportInformationItem_iE_Extensions__item__extensionValue_tab
    ___RACHReportInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RACHReportInformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RACHReportInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RACHReportInformationItem_iE_Extensions__item__id),
        ('criticality', ___RACHReportInformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___RACHReportInformationItem_iE_Extensions__item__extensionValue),
        ])
    __RACHReportInformationItem_iE_Extensions__item_._ext = None
    _RACHReportInformationItem_iE_Extensions._cont = __RACHReportInformationItem_iE_Extensions__item_
    _RACHReportInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RACHReportInformationItem._cont = ASN1Dict([
        ('rACHReportContainer', _RACHReportInformationItem_rACHReportContainer),
        ('uEAssitantIdentifier', _RACHReportInformationItem_uEAssitantIdentifier),
        ('iE-Extensions', _RACHReportInformationItem_iE_Extensions),
        ])
    RACHReportInformationItem._ext = []
    
    #-----< RACHReportInformationItem-ExtIEs >-----#
    RACHReportInformationItem_ExtIEs = CLASS(name='RACHReportInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RACHReportInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioResourceStatus >-----#
    RadioResourceStatus = SEQ(name='RadioResourceStatus', mode=MODE_TYPE)
    _RadioResourceStatus_sSBAreaRadioResourceStatusList = SEQ_OF(name='sSBAreaRadioResourceStatusList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSBAreaRadioResourceStatusList')))
    _RadioResourceStatus_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioResourceStatus_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RadioResourceStatus_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioResourceStatus_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____RadioResourceStatus_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SliceRadioResourceStatus')))
    _____RadioResourceStatus_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MIMOPRBusageInformation')))
    ____RadioResourceStatus_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 441), ('criticality', 'ignore'), ('Extension', _____RadioResourceStatus_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 450), ('criticality', 'ignore'), ('Extension', _____RadioResourceStatus_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioResourceStatus_iE_Extensions__item__id._const_tab = ____RadioResourceStatus_iE_Extensions__item__id_tab
    ___RadioResourceStatus_iE_Extensions__item__id._const_tab_at = None
    ___RadioResourceStatus_iE_Extensions__item__id._const_tab_id = 'id'
    ___RadioResourceStatus_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RadioResourceStatus_iE_Extensions__item__criticality._const_tab = ____RadioResourceStatus_iE_Extensions__item__id_tab
    ___RadioResourceStatus_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioResourceStatus_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RadioResourceStatus_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RadioResourceStatus_iE_Extensions__item__extensionValue._const_tab = ____RadioResourceStatus_iE_Extensions__item__id_tab
    ___RadioResourceStatus_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioResourceStatus_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioResourceStatus_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RadioResourceStatus_iE_Extensions__item__id),
        ('criticality', ___RadioResourceStatus_iE_Extensions__item__criticality),
        ('extensionValue', ___RadioResourceStatus_iE_Extensions__item__extensionValue),
        ])
    __RadioResourceStatus_iE_Extensions__item_._ext = None
    _RadioResourceStatus_iE_Extensions._cont = __RadioResourceStatus_iE_Extensions__item_
    _RadioResourceStatus_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioResourceStatus._cont = ASN1Dict([
        ('sSBAreaRadioResourceStatusList', _RadioResourceStatus_sSBAreaRadioResourceStatusList),
        ('iE-Extensions', _RadioResourceStatus_iE_Extensions),
        ])
    RadioResourceStatus._ext = None
    
    #-----< RadioResourceStatus-ExtIEs >-----#
    RadioResourceStatus_ExtIEs = CLASS(name='RadioResourceStatus-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _RadioResourceStatus_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SliceRadioResourceStatus')))
    _RadioResourceStatus_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MIMOPRBusageInformation')))
    RadioResourceStatus_ExtIEs._val = ASN1Set(rv=[dict([('id', 441), ('criticality', 'ignore'), ('Extension', _RadioResourceStatus_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 450), ('criticality', 'ignore'), ('Extension', _RadioResourceStatus_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MIMOPRBusageInformation >-----#
    MIMOPRBusageInformation = SEQ(name='MIMOPRBusageInformation', mode=MODE_TYPE)
    _MIMOPRBusageInformation_dl_GBR_PRB_usage_for_MIMO = INT(name='dl-GBR-PRB-usage-for-MIMO', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MIMOPRBusageInformation_dl_GBR_PRB_usage_for_MIMO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _MIMOPRBusageInformation_ul_GBR_PRB_usage_for_MIMO = INT(name='ul-GBR-PRB-usage-for-MIMO', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MIMOPRBusageInformation_ul_GBR_PRB_usage_for_MIMO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _MIMOPRBusageInformation_dl_non_GBR_PRB_usage_for_MIMO = INT(name='dl-non-GBR-PRB-usage-for-MIMO', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MIMOPRBusageInformation_dl_non_GBR_PRB_usage_for_MIMO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _MIMOPRBusageInformation_ul_non_GBR_PRB_usage_for_MIMO = INT(name='ul-non-GBR-PRB-usage-for-MIMO', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MIMOPRBusageInformation_ul_non_GBR_PRB_usage_for_MIMO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _MIMOPRBusageInformation_dl_Total_PRB_usage_for_MIMO = INT(name='dl-Total-PRB-usage-for-MIMO', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MIMOPRBusageInformation_dl_Total_PRB_usage_for_MIMO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _MIMOPRBusageInformation_ul_Total_PRB_usage_for_MIMO = INT(name='ul-Total-PRB-usage-for-MIMO', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MIMOPRBusageInformation_ul_Total_PRB_usage_for_MIMO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _MIMOPRBusageInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MIMOPRBusageInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___MIMOPRBusageInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MIMOPRBusageInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MIMOPRBusageInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MIMOPRBusageInformation_iE_Extensions__item__id._const_tab = ____MIMOPRBusageInformation_iE_Extensions__item__id_tab
    ___MIMOPRBusageInformation_iE_Extensions__item__id._const_tab_at = None
    ___MIMOPRBusageInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___MIMOPRBusageInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MIMOPRBusageInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MIMOPRBusageInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MIMOPRBusageInformation_iE_Extensions__item__criticality._const_tab = ____MIMOPRBusageInformation_iE_Extensions__item__criticality_tab
    ___MIMOPRBusageInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MIMOPRBusageInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MIMOPRBusageInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MIMOPRBusageInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____MIMOPRBusageInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MIMOPRBusageInformation_iE_Extensions__item__extensionValue._const_tab = ____MIMOPRBusageInformation_iE_Extensions__item__extensionValue_tab
    ___MIMOPRBusageInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MIMOPRBusageInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MIMOPRBusageInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MIMOPRBusageInformation_iE_Extensions__item__id),
        ('criticality', ___MIMOPRBusageInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___MIMOPRBusageInformation_iE_Extensions__item__extensionValue),
        ])
    __MIMOPRBusageInformation_iE_Extensions__item_._ext = None
    _MIMOPRBusageInformation_iE_Extensions._cont = __MIMOPRBusageInformation_iE_Extensions__item_
    _MIMOPRBusageInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MIMOPRBusageInformation._cont = ASN1Dict([
        ('dl-GBR-PRB-usage-for-MIMO', _MIMOPRBusageInformation_dl_GBR_PRB_usage_for_MIMO),
        ('ul-GBR-PRB-usage-for-MIMO', _MIMOPRBusageInformation_ul_GBR_PRB_usage_for_MIMO),
        ('dl-non-GBR-PRB-usage-for-MIMO', _MIMOPRBusageInformation_dl_non_GBR_PRB_usage_for_MIMO),
        ('ul-non-GBR-PRB-usage-for-MIMO', _MIMOPRBusageInformation_ul_non_GBR_PRB_usage_for_MIMO),
        ('dl-Total-PRB-usage-for-MIMO', _MIMOPRBusageInformation_dl_Total_PRB_usage_for_MIMO),
        ('ul-Total-PRB-usage-for-MIMO', _MIMOPRBusageInformation_ul_Total_PRB_usage_for_MIMO),
        ('iE-Extensions', _MIMOPRBusageInformation_iE_Extensions),
        ])
    MIMOPRBusageInformation._ext = []
    
    #-----< MIMOPRBusageInformation-ExtIEs >-----#
    MIMOPRBusageInformation_ExtIEs = CLASS(name='MIMOPRBusageInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    MIMOPRBusageInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RANAC >-----#
    RANAC = INT(name='RANAC', mode=MODE_TYPE)
    RANAC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< RAN-MeasurementID >-----#
    RAN_MeasurementID = INT(name='RAN-MeasurementID', mode=MODE_TYPE)
    RAN_MeasurementID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=[], er=[])
    
    #-----< RAN-UE-MeasurementID >-----#
    RAN_UE_MeasurementID = INT(name='RAN-UE-MeasurementID', mode=MODE_TYPE)
    RAN_UE_MeasurementID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=[], er=[])
    
    #-----< RAN-UE-PDC-MeasID >-----#
    RAN_UE_PDC_MeasID = INT(name='RAN-UE-PDC-MeasID', mode=MODE_TYPE)
    RAN_UE_PDC_MeasID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=[], er=[])
    
    #-----< RANUEID >-----#
    RANUEID = OCT_STR(name='RANUEID', mode=MODE_TYPE)
    RANUEID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< RANUEPagingIdentity >-----#
    RANUEPagingIdentity = SEQ(name='RANUEPagingIdentity', mode=MODE_TYPE)
    _RANUEPagingIdentity_iRNTI = BIT_STR(name='iRNTI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RANUEPagingIdentity_iRNTI._const_sz = ASN1Set(rv=[40], rr=[], ev=None, er=[])
    _RANUEPagingIdentity_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RANUEPagingIdentity_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RANUEPagingIdentity_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RANUEPagingIdentity_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RANUEPagingIdentity_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RANUEPagingIdentity_iE_Extensions__item__id._const_tab = ____RANUEPagingIdentity_iE_Extensions__item__id_tab
    ___RANUEPagingIdentity_iE_Extensions__item__id._const_tab_at = None
    ___RANUEPagingIdentity_iE_Extensions__item__id._const_tab_id = 'id'
    ___RANUEPagingIdentity_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RANUEPagingIdentity_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RANUEPagingIdentity_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RANUEPagingIdentity_iE_Extensions__item__criticality._const_tab = ____RANUEPagingIdentity_iE_Extensions__item__criticality_tab
    ___RANUEPagingIdentity_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RANUEPagingIdentity_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RANUEPagingIdentity_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RANUEPagingIdentity_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RANUEPagingIdentity_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RANUEPagingIdentity_iE_Extensions__item__extensionValue._const_tab = ____RANUEPagingIdentity_iE_Extensions__item__extensionValue_tab
    ___RANUEPagingIdentity_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RANUEPagingIdentity_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RANUEPagingIdentity_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RANUEPagingIdentity_iE_Extensions__item__id),
        ('criticality', ___RANUEPagingIdentity_iE_Extensions__item__criticality),
        ('extensionValue', ___RANUEPagingIdentity_iE_Extensions__item__extensionValue),
        ])
    __RANUEPagingIdentity_iE_Extensions__item_._ext = None
    _RANUEPagingIdentity_iE_Extensions._cont = __RANUEPagingIdentity_iE_Extensions__item_
    _RANUEPagingIdentity_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RANUEPagingIdentity._cont = ASN1Dict([
        ('iRNTI', _RANUEPagingIdentity_iRNTI),
        ('iE-Extensions', _RANUEPagingIdentity_iE_Extensions),
        ])
    RANUEPagingIdentity._ext = None
    
    #-----< RANUEPagingIdentity-ExtIEs >-----#
    RANUEPagingIdentity_ExtIEs = CLASS(name='RANUEPagingIdentity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RANUEPagingIdentity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAT-FrequencyPriorityInformation >-----#
    RAT_FrequencyPriorityInformation = CHOICE(name='RAT-FrequencyPriorityInformation', mode=MODE_TYPE)
    _RAT_FrequencyPriorityInformation_eNDC = INT(name='eNDC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SubscriberProfileIDforRFP')))
    _RAT_FrequencyPriorityInformation_nGRAN = INT(name='nGRAN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RAT-FrequencySelectionPriority')))
    _RAT_FrequencyPriorityInformation_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __RAT_FrequencyPriorityInformation_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___RAT_FrequencyPriorityInformation_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___RAT_FrequencyPriorityInformation_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __RAT_FrequencyPriorityInformation_choice_extension_id._const_tab = ___RAT_FrequencyPriorityInformation_choice_extension_id_tab
    __RAT_FrequencyPriorityInformation_choice_extension_id._const_tab_at = None
    __RAT_FrequencyPriorityInformation_choice_extension_id._const_tab_id = 'id'
    __RAT_FrequencyPriorityInformation_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___RAT_FrequencyPriorityInformation_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___RAT_FrequencyPriorityInformation_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __RAT_FrequencyPriorityInformation_choice_extension_criticality._const_tab = ___RAT_FrequencyPriorityInformation_choice_extension_criticality_tab
    __RAT_FrequencyPriorityInformation_choice_extension_criticality._const_tab_at = ('..', 'id')
    __RAT_FrequencyPriorityInformation_choice_extension_criticality._const_tab_id = 'criticality'
    __RAT_FrequencyPriorityInformation_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___RAT_FrequencyPriorityInformation_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___RAT_FrequencyPriorityInformation_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __RAT_FrequencyPriorityInformation_choice_extension_value._const_tab = ___RAT_FrequencyPriorityInformation_choice_extension_value_tab
    __RAT_FrequencyPriorityInformation_choice_extension_value._const_tab_at = ('..', 'id')
    __RAT_FrequencyPriorityInformation_choice_extension_value._const_tab_id = 'Value'
    _RAT_FrequencyPriorityInformation_choice_extension._cont = ASN1Dict([
        ('id', __RAT_FrequencyPriorityInformation_choice_extension_id),
        ('criticality', __RAT_FrequencyPriorityInformation_choice_extension_criticality),
        ('value', __RAT_FrequencyPriorityInformation_choice_extension_value),
        ])
    _RAT_FrequencyPriorityInformation_choice_extension._ext = None
    RAT_FrequencyPriorityInformation._cont = ASN1Dict([
        ('eNDC', _RAT_FrequencyPriorityInformation_eNDC),
        ('nGRAN', _RAT_FrequencyPriorityInformation_nGRAN),
        ('choice-extension', _RAT_FrequencyPriorityInformation_choice_extension),
        ])
    RAT_FrequencyPriorityInformation._ext = None
    
    #-----< RAT-FrequencyPriorityInformation-ExtIEs >-----#
    RAT_FrequencyPriorityInformation_ExtIEs = CLASS(name='RAT-FrequencyPriorityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    RAT_FrequencyPriorityInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAT-FrequencySelectionPriority >-----#
    RAT_FrequencySelectionPriority = INT(name='RAT-FrequencySelectionPriority', mode=MODE_TYPE)
    RAT_FrequencySelectionPriority._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=[], er=[])
    
    #-----< RBSetConfiguration >-----#
    RBSetConfiguration = SEQ(name='RBSetConfiguration', mode=MODE_TYPE)
    _RBSetConfiguration_subcarrierSpacing = ENUM(name='subcarrierSpacing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SubcarrierSpacing')))
    _RBSetConfiguration_rBSetSize = ENUM(name='rBSetSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RBSetSize')))
    _RBSetConfiguration_nUmberRBsets = INT(name='nUmberRBsets', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RBSetConfiguration_nUmberRBsets._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _RBSetConfiguration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RBSetConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RBSetConfiguration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RBSetConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RBSetConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RBSetConfiguration_iE_Extensions__item__id._const_tab = ____RBSetConfiguration_iE_Extensions__item__id_tab
    ___RBSetConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___RBSetConfiguration_iE_Extensions__item__id._const_tab_id = 'id'
    ___RBSetConfiguration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RBSetConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RBSetConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RBSetConfiguration_iE_Extensions__item__criticality._const_tab = ____RBSetConfiguration_iE_Extensions__item__criticality_tab
    ___RBSetConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RBSetConfiguration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RBSetConfiguration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RBSetConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RBSetConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RBSetConfiguration_iE_Extensions__item__extensionValue._const_tab = ____RBSetConfiguration_iE_Extensions__item__extensionValue_tab
    ___RBSetConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RBSetConfiguration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RBSetConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RBSetConfiguration_iE_Extensions__item__id),
        ('criticality', ___RBSetConfiguration_iE_Extensions__item__criticality),
        ('extensionValue', ___RBSetConfiguration_iE_Extensions__item__extensionValue),
        ])
    __RBSetConfiguration_iE_Extensions__item_._ext = None
    _RBSetConfiguration_iE_Extensions._cont = __RBSetConfiguration_iE_Extensions__item_
    _RBSetConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RBSetConfiguration._cont = ASN1Dict([
        ('subcarrierSpacing', _RBSetConfiguration_subcarrierSpacing),
        ('rBSetSize', _RBSetConfiguration_rBSetSize),
        ('nUmberRBsets', _RBSetConfiguration_nUmberRBsets),
        ('iE-Extensions', _RBSetConfiguration_iE_Extensions),
        ])
    RBSetConfiguration._ext = None
    
    #-----< RBSetConfiguration-ExtIEs >-----#
    RBSetConfiguration_ExtIEs = CLASS(name='RBSetConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RBSetConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RBSetSize >-----#
    RBSetSize = ENUM(name='RBSetSize', mode=MODE_TYPE)
    RBSetSize._cont = ASN1Dict([('rb2', 0), ('rb4', 1), ('rb8', 2), ('rb16', 3), ('rb32', 4), ('rb64', 5)])
    RBSetSize._ext = None
    
    #-----< Re-routingEnableIndicator >-----#
    Re_routingEnableIndicator = ENUM(name='Re-routingEnableIndicator', mode=MODE_TYPE)
    Re_routingEnableIndicator._cont = ASN1Dict([('true', 0), ('false', 1)])
    Re_routingEnableIndicator._ext = []
    
    #-----< Redcap-Bcast-Information >-----#
    Redcap_Bcast_Information = BIT_STR(name='Redcap-Bcast-Information', mode=MODE_TYPE)
    Redcap_Bcast_Information._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< RedCapIndication >-----#
    RedCapIndication = ENUM(name='RedCapIndication', mode=MODE_TYPE)
    RedCapIndication._cont = ASN1Dict([('true', 0)])
    RedCapIndication._ext = []
    
    #-----< Reestablishment-Indication >-----#
    Reestablishment_Indication = ENUM(name='Reestablishment-Indication', mode=MODE_TYPE)
    Reestablishment_Indication._cont = ASN1Dict([('reestablished', 0)])
    Reestablishment_Indication._ext = []
    
    #-----< ReferencePoint >-----#
    ReferencePoint = CHOICE(name='ReferencePoint', mode=MODE_TYPE)
    _ReferencePoint_coordinateID = INT(name='coordinateID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CoordinateID')))
    _ReferencePoint_referencePointCoordinate = SEQ(name='referencePointCoordinate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AccessPointPosition')))
    _ReferencePoint_referencePointCoordinateHA = SEQ(name='referencePointCoordinateHA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NGRANHighAccuracyAccessPointPosition')))
    _ReferencePoint_choice_Extension = SEQ(name='choice-Extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __ReferencePoint_choice_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___ReferencePoint_choice_Extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ReferencePoint_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReferencePoint_choice_Extension_id._const_tab = ___ReferencePoint_choice_Extension_id_tab
    __ReferencePoint_choice_Extension_id._const_tab_at = None
    __ReferencePoint_choice_Extension_id._const_tab_id = 'id'
    __ReferencePoint_choice_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___ReferencePoint_choice_Extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ReferencePoint_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReferencePoint_choice_Extension_criticality._const_tab = ___ReferencePoint_choice_Extension_criticality_tab
    __ReferencePoint_choice_Extension_criticality._const_tab_at = ('..', 'id')
    __ReferencePoint_choice_Extension_criticality._const_tab_id = 'criticality'
    __ReferencePoint_choice_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___ReferencePoint_choice_Extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ReferencePoint_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReferencePoint_choice_Extension_value._const_tab = ___ReferencePoint_choice_Extension_value_tab
    __ReferencePoint_choice_Extension_value._const_tab_at = ('..', 'id')
    __ReferencePoint_choice_Extension_value._const_tab_id = 'Value'
    _ReferencePoint_choice_Extension._cont = ASN1Dict([
        ('id', __ReferencePoint_choice_Extension_id),
        ('criticality', __ReferencePoint_choice_Extension_criticality),
        ('value', __ReferencePoint_choice_Extension_value),
        ])
    _ReferencePoint_choice_Extension._ext = None
    ReferencePoint._cont = ASN1Dict([
        ('coordinateID', _ReferencePoint_coordinateID),
        ('referencePointCoordinate', _ReferencePoint_referencePointCoordinate),
        ('referencePointCoordinateHA', _ReferencePoint_referencePointCoordinateHA),
        ('choice-Extension', _ReferencePoint_choice_Extension),
        ])
    ReferencePoint._ext = None
    
    #-----< ReferencePoint-ExtIEs >-----#
    ReferencePoint_ExtIEs = CLASS(name='ReferencePoint-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ReferencePoint_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReferenceSFN >-----#
    ReferenceSFN = INT(name='ReferenceSFN', mode=MODE_TYPE)
    ReferenceSFN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    
    #-----< ReferenceSignal >-----#
    ReferenceSignal = CHOICE(name='ReferenceSignal', mode=MODE_TYPE)
    _ReferenceSignal_nZP_CSI_RS = INT(name='nZP-CSI-RS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NZP-CSI-RS-ResourceID')))
    _ReferenceSignal_sSB = SEQ(name='sSB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB')))
    _ReferenceSignal_sRS = INT(name='sRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceID')))
    _ReferenceSignal_positioningSRS = INT(name='positioningSRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSPosResourceID')))
    _ReferenceSignal_dL_PRS = SEQ(name='dL-PRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DL-PRS')))
    _ReferenceSignal_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __ReferenceSignal_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___ReferenceSignal_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ReferenceSignal_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReferenceSignal_choice_extension_id._const_tab = ___ReferenceSignal_choice_extension_id_tab
    __ReferenceSignal_choice_extension_id._const_tab_at = None
    __ReferenceSignal_choice_extension_id._const_tab_id = 'id'
    __ReferenceSignal_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___ReferenceSignal_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ReferenceSignal_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReferenceSignal_choice_extension_criticality._const_tab = ___ReferenceSignal_choice_extension_criticality_tab
    __ReferenceSignal_choice_extension_criticality._const_tab_at = ('..', 'id')
    __ReferenceSignal_choice_extension_criticality._const_tab_id = 'criticality'
    __ReferenceSignal_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___ReferenceSignal_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ReferenceSignal_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReferenceSignal_choice_extension_value._const_tab = ___ReferenceSignal_choice_extension_value_tab
    __ReferenceSignal_choice_extension_value._const_tab_at = ('..', 'id')
    __ReferenceSignal_choice_extension_value._const_tab_id = 'Value'
    _ReferenceSignal_choice_extension._cont = ASN1Dict([
        ('id', __ReferenceSignal_choice_extension_id),
        ('criticality', __ReferenceSignal_choice_extension_criticality),
        ('value', __ReferenceSignal_choice_extension_value),
        ])
    _ReferenceSignal_choice_extension._ext = None
    ReferenceSignal._cont = ASN1Dict([
        ('nZP-CSI-RS', _ReferenceSignal_nZP_CSI_RS),
        ('sSB', _ReferenceSignal_sSB),
        ('sRS', _ReferenceSignal_sRS),
        ('positioningSRS', _ReferenceSignal_positioningSRS),
        ('dL-PRS', _ReferenceSignal_dL_PRS),
        ('choice-extension', _ReferenceSignal_choice_extension),
        ])
    ReferenceSignal._ext = None
    
    #-----< ReferenceSignal-ExtIEs >-----#
    ReferenceSignal_ExtIEs = CLASS(name='ReferenceSignal-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ReferenceSignal_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelativeCartesianLocation >-----#
    RelativeCartesianLocation = SEQ(name='RelativeCartesianLocation', mode=MODE_TYPE)
    _RelativeCartesianLocation_xYZunit = ENUM(name='xYZunit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeCartesianLocation_xYZunit._cont = ASN1Dict([('mm', 0), ('cm', 1), ('dm', 2)])
    _RelativeCartesianLocation_xYZunit._ext = []
    _RelativeCartesianLocation_xvalue = INT(name='xvalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeCartesianLocation_xvalue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-65536, ub=65535)], ev=None, er=[])
    _RelativeCartesianLocation_yvalue = INT(name='yvalue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeCartesianLocation_yvalue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-65536, ub=65535)], ev=None, er=[])
    _RelativeCartesianLocation_zvalue = INT(name='zvalue', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeCartesianLocation_zvalue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _RelativeCartesianLocation_locationUncertainty = SEQ(name='locationUncertainty', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LocationUncertainty')))
    _RelativeCartesianLocation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelativeCartesianLocation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RelativeCartesianLocation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RelativeCartesianLocation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RelativeCartesianLocation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelativeCartesianLocation_iE_Extensions__item__id._const_tab = ____RelativeCartesianLocation_iE_Extensions__item__id_tab
    ___RelativeCartesianLocation_iE_Extensions__item__id._const_tab_at = None
    ___RelativeCartesianLocation_iE_Extensions__item__id._const_tab_id = 'id'
    ___RelativeCartesianLocation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RelativeCartesianLocation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RelativeCartesianLocation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelativeCartesianLocation_iE_Extensions__item__criticality._const_tab = ____RelativeCartesianLocation_iE_Extensions__item__criticality_tab
    ___RelativeCartesianLocation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RelativeCartesianLocation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RelativeCartesianLocation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RelativeCartesianLocation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RelativeCartesianLocation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelativeCartesianLocation_iE_Extensions__item__extensionValue._const_tab = ____RelativeCartesianLocation_iE_Extensions__item__extensionValue_tab
    ___RelativeCartesianLocation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RelativeCartesianLocation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RelativeCartesianLocation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RelativeCartesianLocation_iE_Extensions__item__id),
        ('criticality', ___RelativeCartesianLocation_iE_Extensions__item__criticality),
        ('extensionValue', ___RelativeCartesianLocation_iE_Extensions__item__extensionValue),
        ])
    __RelativeCartesianLocation_iE_Extensions__item_._ext = None
    _RelativeCartesianLocation_iE_Extensions._cont = __RelativeCartesianLocation_iE_Extensions__item_
    _RelativeCartesianLocation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelativeCartesianLocation._cont = ASN1Dict([
        ('xYZunit', _RelativeCartesianLocation_xYZunit),
        ('xvalue', _RelativeCartesianLocation_xvalue),
        ('yvalue', _RelativeCartesianLocation_yvalue),
        ('zvalue', _RelativeCartesianLocation_zvalue),
        ('locationUncertainty', _RelativeCartesianLocation_locationUncertainty),
        ('iE-Extensions', _RelativeCartesianLocation_iE_Extensions),
        ])
    RelativeCartesianLocation._ext = None
    
    #-----< RelativeCartesianLocation-ExtIEs >-----#
    RelativeCartesianLocation_ExtIEs = CLASS(name='RelativeCartesianLocation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RelativeCartesianLocation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelativeGeodeticLocation >-----#
    RelativeGeodeticLocation = SEQ(name='RelativeGeodeticLocation', mode=MODE_TYPE)
    _RelativeGeodeticLocation_milli_Arc_SecondUnits = ENUM(name='milli-Arc-SecondUnits', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeGeodeticLocation_milli_Arc_SecondUnits._cont = ASN1Dict([('zerodot03', 0), ('zerodot3', 1), ('three', 2)])
    _RelativeGeodeticLocation_milli_Arc_SecondUnits._ext = []
    _RelativeGeodeticLocation_heightUnits = ENUM(name='heightUnits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeGeodeticLocation_heightUnits._cont = ASN1Dict([('mm', 0), ('cm', 1), ('m', 2)])
    _RelativeGeodeticLocation_heightUnits._ext = []
    _RelativeGeodeticLocation_deltaLatitude = INT(name='deltaLatitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeGeodeticLocation_deltaLatitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _RelativeGeodeticLocation_deltaLongitude = INT(name='deltaLongitude', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeGeodeticLocation_deltaLongitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _RelativeGeodeticLocation_deltaHeight = INT(name='deltaHeight', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeGeodeticLocation_deltaHeight._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _RelativeGeodeticLocation_locationUncertainty = SEQ(name='locationUncertainty', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LocationUncertainty')))
    _RelativeGeodeticLocation_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelativeGeodeticLocation_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RelativeGeodeticLocation_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RelativeGeodeticLocation_iE_extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RelativeGeodeticLocation_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelativeGeodeticLocation_iE_extensions__item__id._const_tab = ____RelativeGeodeticLocation_iE_extensions__item__id_tab
    ___RelativeGeodeticLocation_iE_extensions__item__id._const_tab_at = None
    ___RelativeGeodeticLocation_iE_extensions__item__id._const_tab_id = 'id'
    ___RelativeGeodeticLocation_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RelativeGeodeticLocation_iE_extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RelativeGeodeticLocation_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelativeGeodeticLocation_iE_extensions__item__criticality._const_tab = ____RelativeGeodeticLocation_iE_extensions__item__criticality_tab
    ___RelativeGeodeticLocation_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RelativeGeodeticLocation_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___RelativeGeodeticLocation_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RelativeGeodeticLocation_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RelativeGeodeticLocation_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelativeGeodeticLocation_iE_extensions__item__extensionValue._const_tab = ____RelativeGeodeticLocation_iE_extensions__item__extensionValue_tab
    ___RelativeGeodeticLocation_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RelativeGeodeticLocation_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __RelativeGeodeticLocation_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___RelativeGeodeticLocation_iE_extensions__item__id),
        ('criticality', ___RelativeGeodeticLocation_iE_extensions__item__criticality),
        ('extensionValue', ___RelativeGeodeticLocation_iE_extensions__item__extensionValue),
        ])
    __RelativeGeodeticLocation_iE_extensions__item_._ext = None
    _RelativeGeodeticLocation_iE_extensions._cont = __RelativeGeodeticLocation_iE_extensions__item_
    _RelativeGeodeticLocation_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelativeGeodeticLocation._cont = ASN1Dict([
        ('milli-Arc-SecondUnits', _RelativeGeodeticLocation_milli_Arc_SecondUnits),
        ('heightUnits', _RelativeGeodeticLocation_heightUnits),
        ('deltaLatitude', _RelativeGeodeticLocation_deltaLatitude),
        ('deltaLongitude', _RelativeGeodeticLocation_deltaLongitude),
        ('deltaHeight', _RelativeGeodeticLocation_deltaHeight),
        ('locationUncertainty', _RelativeGeodeticLocation_locationUncertainty),
        ('iE-extensions', _RelativeGeodeticLocation_iE_extensions),
        ])
    RelativeGeodeticLocation._ext = None
    
    #-----< RelativeGeodeticLocation-ExtIEs >-----#
    RelativeGeodeticLocation_ExtIEs = CLASS(name='RelativeGeodeticLocation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RelativeGeodeticLocation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RemoteUELocalID >-----#
    RemoteUELocalID = INT(name='RemoteUELocalID', mode=MODE_TYPE)
    RemoteUELocalID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< ReferenceTime >-----#
    ReferenceTime = OCT_STR(name='ReferenceTime', mode=MODE_TYPE)
    
    #-----< RegistrationRequest >-----#
    RegistrationRequest = ENUM(name='RegistrationRequest', mode=MODE_TYPE)
    RegistrationRequest._cont = ASN1Dict([('start', 0), ('stop', 1), ('add', 2)])
    RegistrationRequest._ext = []
    
    #-----< ReportCharacteristics >-----#
    ReportCharacteristics = BIT_STR(name='ReportCharacteristics', mode=MODE_TYPE)
    ReportCharacteristics._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< ReportingPeriodicity >-----#
    ReportingPeriodicity = ENUM(name='ReportingPeriodicity', mode=MODE_TYPE)
    ReportingPeriodicity._cont = ASN1Dict([('ms500', 0), ('ms1000', 1), ('ms2000', 2), ('ms5000', 3), ('ms10000', 4)])
    ReportingPeriodicity._ext = []
    
    #-----< RequestedBandCombinationIndex >-----#
    RequestedBandCombinationIndex = OCT_STR(name='RequestedBandCombinationIndex', mode=MODE_TYPE)
    
    #-----< RequestedFeatureSetEntryIndex >-----#
    RequestedFeatureSetEntryIndex = OCT_STR(name='RequestedFeatureSetEntryIndex', mode=MODE_TYPE)
    
    #-----< RequestedP-MaxFR2 >-----#
    RequestedP_MaxFR2 = OCT_STR(name='RequestedP-MaxFR2', mode=MODE_TYPE)
    
    #-----< Requested-PDCCH-BlindDetectionSCG >-----#
    Requested_PDCCH_BlindDetectionSCG = OCT_STR(name='Requested-PDCCH-BlindDetectionSCG', mode=MODE_TYPE)
    
    #-----< RequestedSRSTransmissionCharacteristics >-----#
    RequestedSRSTransmissionCharacteristics = SEQ(name='RequestedSRSTransmissionCharacteristics', mode=MODE_TYPE)
    _RequestedSRSTransmissionCharacteristics_numberOfTransmissions = INT(name='numberOfTransmissions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSRSTransmissionCharacteristics_numberOfTransmissions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=500)], ev=[], er=[])
    _RequestedSRSTransmissionCharacteristics_resourceType = ENUM(name='resourceType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RequestedSRSTransmissionCharacteristics_resourceType._cont = ASN1Dict([('periodic', 0), ('semi-persistent', 1), ('aperiodic', 2)])
    _RequestedSRSTransmissionCharacteristics_resourceType._ext = []
    _RequestedSRSTransmissionCharacteristics_bandwidthSRS = CHOICE(name='bandwidthSRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BandwidthSRS')))
    _RequestedSRSTransmissionCharacteristics_sRSResourceSetList = SEQ_OF(name='sRSResourceSetList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceSetList')), opt=True)
    _RequestedSRSTransmissionCharacteristics_sSBInformation = SEQ(name='sSBInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSBInformation')), opt=True)
    _RequestedSRSTransmissionCharacteristics_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RequestedSRSTransmissionCharacteristics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SrsFrequency')))
    ____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 431), ('criticality', 'ignore'), ('Extension', _____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id._const_tab = ____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id._const_tab_at = None
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id._const_tab_id = 'id'
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__criticality._const_tab = ____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__extensionValue._const_tab = ____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RequestedSRSTransmissionCharacteristics_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id),
        ('criticality', ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__criticality),
        ('extensionValue', ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__extensionValue),
        ])
    __RequestedSRSTransmissionCharacteristics_iE_Extensions__item_._ext = None
    _RequestedSRSTransmissionCharacteristics_iE_Extensions._cont = __RequestedSRSTransmissionCharacteristics_iE_Extensions__item_
    _RequestedSRSTransmissionCharacteristics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RequestedSRSTransmissionCharacteristics._cont = ASN1Dict([
        ('numberOfTransmissions', _RequestedSRSTransmissionCharacteristics_numberOfTransmissions),
        ('resourceType', _RequestedSRSTransmissionCharacteristics_resourceType),
        ('bandwidthSRS', _RequestedSRSTransmissionCharacteristics_bandwidthSRS),
        ('sRSResourceSetList', _RequestedSRSTransmissionCharacteristics_sRSResourceSetList),
        ('sSBInformation', _RequestedSRSTransmissionCharacteristics_sSBInformation),
        ('iE-Extensions', _RequestedSRSTransmissionCharacteristics_iE_Extensions),
        ])
    RequestedSRSTransmissionCharacteristics._ext = None
    
    #-----< RequestedSRSTransmissionCharacteristics-ExtIEs >-----#
    RequestedSRSTransmissionCharacteristics_ExtIEs = CLASS(name='RequestedSRSTransmissionCharacteristics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _RequestedSRSTransmissionCharacteristics_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SrsFrequency')))
    RequestedSRSTransmissionCharacteristics_ExtIEs._val = ASN1Set(rv=[dict([('id', 431), ('criticality', 'ignore'), ('Extension', _RequestedSRSTransmissionCharacteristics_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RequestType >-----#
    RequestType = ENUM(name='RequestType', mode=MODE_TYPE)
    RequestType._cont = ASN1Dict([('offer', 0), ('execution', 1)])
    RequestType._ext = []
    
    #-----< ResourceCoordinationEUTRACellInfo >-----#
    ResourceCoordinationEUTRACellInfo = SEQ(name='ResourceCoordinationEUTRACellInfo', mode=MODE_TYPE)
    _ResourceCoordinationEUTRACellInfo_eUTRA_Mode_Info = CHOICE(name='eUTRA-Mode-Info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-Coex-Mode-Info')))
    _ResourceCoordinationEUTRACellInfo_eUTRA_PRACH_Configuration = SEQ(name='eUTRA-PRACH-Configuration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-PRACH-Configuration')))
    _ResourceCoordinationEUTRACellInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceCoordinationEUTRACellInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IgnorePRACHConfiguration')))
    ____ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 233), ('criticality', 'reject'), ('Extension', _____ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id._const_tab = ____ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id_tab
    ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id._const_tab_at = None
    ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__criticality._const_tab = ____ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id_tab
    ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__extensionValue._const_tab = ____ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id_tab
    ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResourceCoordinationEUTRACellInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id),
        ('criticality', ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__extensionValue),
        ])
    __ResourceCoordinationEUTRACellInfo_iE_Extensions__item_._ext = None
    _ResourceCoordinationEUTRACellInfo_iE_Extensions._cont = __ResourceCoordinationEUTRACellInfo_iE_Extensions__item_
    _ResourceCoordinationEUTRACellInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceCoordinationEUTRACellInfo._cont = ASN1Dict([
        ('eUTRA-Mode-Info', _ResourceCoordinationEUTRACellInfo_eUTRA_Mode_Info),
        ('eUTRA-PRACH-Configuration', _ResourceCoordinationEUTRACellInfo_eUTRA_PRACH_Configuration),
        ('iE-Extensions', _ResourceCoordinationEUTRACellInfo_iE_Extensions),
        ])
    ResourceCoordinationEUTRACellInfo._ext = []
    
    #-----< ResourceCoordinationEUTRACellInfo-ExtIEs >-----#
    ResourceCoordinationEUTRACellInfo_ExtIEs = CLASS(name='ResourceCoordinationEUTRACellInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _ResourceCoordinationEUTRACellInfo_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IgnorePRACHConfiguration')))
    ResourceCoordinationEUTRACellInfo_ExtIEs._val = ASN1Set(rv=[dict([('id', 233), ('criticality', 'reject'), ('Extension', _ResourceCoordinationEUTRACellInfo_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResourceCoordinationTransferInformation >-----#
    ResourceCoordinationTransferInformation = SEQ(name='ResourceCoordinationTransferInformation', mode=MODE_TYPE)
    _ResourceCoordinationTransferInformation_meNB_Cell_ID = BIT_STR(name='meNB-Cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-Cell-ID')))
    _ResourceCoordinationTransferInformation_resourceCoordinationEUTRACellInfo = SEQ(name='resourceCoordinationEUTRACellInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationEUTRACellInfo')), opt=True)
    _ResourceCoordinationTransferInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceCoordinationTransferInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ResourceCoordinationTransferInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ResourceCoordinationTransferInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceCoordinationTransferInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceCoordinationTransferInformation_iE_Extensions__item__id._const_tab = ____ResourceCoordinationTransferInformation_iE_Extensions__item__id_tab
    ___ResourceCoordinationTransferInformation_iE_Extensions__item__id._const_tab_at = None
    ___ResourceCoordinationTransferInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResourceCoordinationTransferInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResourceCoordinationTransferInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceCoordinationTransferInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceCoordinationTransferInformation_iE_Extensions__item__criticality._const_tab = ____ResourceCoordinationTransferInformation_iE_Extensions__item__criticality_tab
    ___ResourceCoordinationTransferInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceCoordinationTransferInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResourceCoordinationTransferInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResourceCoordinationTransferInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceCoordinationTransferInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceCoordinationTransferInformation_iE_Extensions__item__extensionValue._const_tab = ____ResourceCoordinationTransferInformation_iE_Extensions__item__extensionValue_tab
    ___ResourceCoordinationTransferInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResourceCoordinationTransferInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResourceCoordinationTransferInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResourceCoordinationTransferInformation_iE_Extensions__item__id),
        ('criticality', ___ResourceCoordinationTransferInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___ResourceCoordinationTransferInformation_iE_Extensions__item__extensionValue),
        ])
    __ResourceCoordinationTransferInformation_iE_Extensions__item_._ext = None
    _ResourceCoordinationTransferInformation_iE_Extensions._cont = __ResourceCoordinationTransferInformation_iE_Extensions__item_
    _ResourceCoordinationTransferInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceCoordinationTransferInformation._cont = ASN1Dict([
        ('meNB-Cell-ID', _ResourceCoordinationTransferInformation_meNB_Cell_ID),
        ('resourceCoordinationEUTRACellInfo', _ResourceCoordinationTransferInformation_resourceCoordinationEUTRACellInfo),
        ('iE-Extensions', _ResourceCoordinationTransferInformation_iE_Extensions),
        ])
    ResourceCoordinationTransferInformation._ext = []
    
    #-----< ResourceCoordinationTransferInformation-ExtIEs >-----#
    ResourceCoordinationTransferInformation_ExtIEs = CLASS(name='ResourceCoordinationTransferInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ResourceCoordinationTransferInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceCoordinationTransferContainer >-----#
    ResourceCoordinationTransferContainer = OCT_STR(name='ResourceCoordinationTransferContainer', mode=MODE_TYPE)
    
    #-----< ResourceSetType >-----#
    ResourceSetType = CHOICE(name='ResourceSetType', mode=MODE_TYPE)
    _ResourceSetType_periodic = SEQ(name='periodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceSetTypePeriodic')))
    _ResourceSetType_semi_persistent = SEQ(name='semi-persistent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceSetTypeSemi-persistent')))
    _ResourceSetType_aperiodic = SEQ(name='aperiodic', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceSetTypeAperiodic')))
    _ResourceSetType_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __ResourceSetType_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___ResourceSetType_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ResourceSetType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceSetType_choice_extension_id._const_tab = ___ResourceSetType_choice_extension_id_tab
    __ResourceSetType_choice_extension_id._const_tab_at = None
    __ResourceSetType_choice_extension_id._const_tab_id = 'id'
    __ResourceSetType_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___ResourceSetType_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ResourceSetType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceSetType_choice_extension_criticality._const_tab = ___ResourceSetType_choice_extension_criticality_tab
    __ResourceSetType_choice_extension_criticality._const_tab_at = ('..', 'id')
    __ResourceSetType_choice_extension_criticality._const_tab_id = 'criticality'
    __ResourceSetType_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___ResourceSetType_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ResourceSetType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceSetType_choice_extension_value._const_tab = ___ResourceSetType_choice_extension_value_tab
    __ResourceSetType_choice_extension_value._const_tab_at = ('..', 'id')
    __ResourceSetType_choice_extension_value._const_tab_id = 'Value'
    _ResourceSetType_choice_extension._cont = ASN1Dict([
        ('id', __ResourceSetType_choice_extension_id),
        ('criticality', __ResourceSetType_choice_extension_criticality),
        ('value', __ResourceSetType_choice_extension_value),
        ])
    _ResourceSetType_choice_extension._ext = None
    ResourceSetType._cont = ASN1Dict([
        ('periodic', _ResourceSetType_periodic),
        ('semi-persistent', _ResourceSetType_semi_persistent),
        ('aperiodic', _ResourceSetType_aperiodic),
        ('choice-extension', _ResourceSetType_choice_extension),
        ])
    ResourceSetType._ext = None
    
    #-----< ResourceSetType-ExtIEs >-----#
    ResourceSetType_ExtIEs = CLASS(name='ResourceSetType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ResourceSetType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceSetTypePeriodic >-----#
    ResourceSetTypePeriodic = SEQ(name='ResourceSetTypePeriodic', mode=MODE_TYPE)
    _ResourceSetTypePeriodic_periodicSet = ENUM(name='periodicSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceSetTypePeriodic_periodicSet._cont = ASN1Dict([('true', 0)])
    _ResourceSetTypePeriodic_periodicSet._ext = []
    _ResourceSetTypePeriodic_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceSetTypePeriodic_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ResourceSetTypePeriodic_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ResourceSetTypePeriodic_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceSetTypePeriodic_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypePeriodic_iE_Extensions__item__id._const_tab = ____ResourceSetTypePeriodic_iE_Extensions__item__id_tab
    ___ResourceSetTypePeriodic_iE_Extensions__item__id._const_tab_at = None
    ___ResourceSetTypePeriodic_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResourceSetTypePeriodic_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResourceSetTypePeriodic_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceSetTypePeriodic_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypePeriodic_iE_Extensions__item__criticality._const_tab = ____ResourceSetTypePeriodic_iE_Extensions__item__criticality_tab
    ___ResourceSetTypePeriodic_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceSetTypePeriodic_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResourceSetTypePeriodic_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResourceSetTypePeriodic_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceSetTypePeriodic_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypePeriodic_iE_Extensions__item__extensionValue._const_tab = ____ResourceSetTypePeriodic_iE_Extensions__item__extensionValue_tab
    ___ResourceSetTypePeriodic_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResourceSetTypePeriodic_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResourceSetTypePeriodic_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResourceSetTypePeriodic_iE_Extensions__item__id),
        ('criticality', ___ResourceSetTypePeriodic_iE_Extensions__item__criticality),
        ('extensionValue', ___ResourceSetTypePeriodic_iE_Extensions__item__extensionValue),
        ])
    __ResourceSetTypePeriodic_iE_Extensions__item_._ext = None
    _ResourceSetTypePeriodic_iE_Extensions._cont = __ResourceSetTypePeriodic_iE_Extensions__item_
    _ResourceSetTypePeriodic_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceSetTypePeriodic._cont = ASN1Dict([
        ('periodicSet', _ResourceSetTypePeriodic_periodicSet),
        ('iE-Extensions', _ResourceSetTypePeriodic_iE_Extensions),
        ])
    ResourceSetTypePeriodic._ext = None
    
    #-----< ResourceSetTypePeriodic-ExtIEs >-----#
    ResourceSetTypePeriodic_ExtIEs = CLASS(name='ResourceSetTypePeriodic-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ResourceSetTypePeriodic_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceSetTypeSemi-persistent >-----#
    ResourceSetTypeSemi_persistent = SEQ(name='ResourceSetTypeSemi-persistent', mode=MODE_TYPE)
    _ResourceSetTypeSemi_persistent_semi_persistentSet = ENUM(name='semi-persistentSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceSetTypeSemi_persistent_semi_persistentSet._cont = ASN1Dict([('true', 0)])
    _ResourceSetTypeSemi_persistent_semi_persistentSet._ext = []
    _ResourceSetTypeSemi_persistent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceSetTypeSemi_persistent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ResourceSetTypeSemi_persistent_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceSetTypeSemi_persistent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__id._const_tab = ____ResourceSetTypeSemi_persistent_iE_Extensions__item__id_tab
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__id._const_tab_at = None
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality._const_tab = ____ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality_tab
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab = ____ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue_tab
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResourceSetTypeSemi_persistent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResourceSetTypeSemi_persistent_iE_Extensions__item__id),
        ('criticality', ___ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality),
        ('extensionValue', ___ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue),
        ])
    __ResourceSetTypeSemi_persistent_iE_Extensions__item_._ext = None
    _ResourceSetTypeSemi_persistent_iE_Extensions._cont = __ResourceSetTypeSemi_persistent_iE_Extensions__item_
    _ResourceSetTypeSemi_persistent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceSetTypeSemi_persistent._cont = ASN1Dict([
        ('semi-persistentSet', _ResourceSetTypeSemi_persistent_semi_persistentSet),
        ('iE-Extensions', _ResourceSetTypeSemi_persistent_iE_Extensions),
        ])
    ResourceSetTypeSemi_persistent._ext = None
    
    #-----< ResourceSetTypeSemi-persistent-ExtIEs >-----#
    ResourceSetTypeSemi_persistent_ExtIEs = CLASS(name='ResourceSetTypeSemi-persistent-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ResourceSetTypeSemi_persistent_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceSetTypeAperiodic >-----#
    ResourceSetTypeAperiodic = SEQ(name='ResourceSetTypeAperiodic', mode=MODE_TYPE)
    _ResourceSetTypeAperiodic_sRSResourceTrigger_List = INT(name='sRSResourceTrigger-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceSetTypeAperiodic_sRSResourceTrigger_List._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    _ResourceSetTypeAperiodic_slotoffset = INT(name='slotoffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceSetTypeAperiodic_slotoffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32)], ev=None, er=[])
    _ResourceSetTypeAperiodic_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceSetTypeAperiodic_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ResourceSetTypeAperiodic_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ResourceSetTypeAperiodic_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceSetTypeAperiodic_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypeAperiodic_iE_Extensions__item__id._const_tab = ____ResourceSetTypeAperiodic_iE_Extensions__item__id_tab
    ___ResourceSetTypeAperiodic_iE_Extensions__item__id._const_tab_at = None
    ___ResourceSetTypeAperiodic_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResourceSetTypeAperiodic_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResourceSetTypeAperiodic_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceSetTypeAperiodic_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypeAperiodic_iE_Extensions__item__criticality._const_tab = ____ResourceSetTypeAperiodic_iE_Extensions__item__criticality_tab
    ___ResourceSetTypeAperiodic_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceSetTypeAperiodic_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue._const_tab = ____ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue_tab
    ___ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResourceSetTypeAperiodic_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResourceSetTypeAperiodic_iE_Extensions__item__id),
        ('criticality', ___ResourceSetTypeAperiodic_iE_Extensions__item__criticality),
        ('extensionValue', ___ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue),
        ])
    __ResourceSetTypeAperiodic_iE_Extensions__item_._ext = None
    _ResourceSetTypeAperiodic_iE_Extensions._cont = __ResourceSetTypeAperiodic_iE_Extensions__item_
    _ResourceSetTypeAperiodic_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceSetTypeAperiodic._cont = ASN1Dict([
        ('sRSResourceTrigger-List', _ResourceSetTypeAperiodic_sRSResourceTrigger_List),
        ('slotoffset', _ResourceSetTypeAperiodic_slotoffset),
        ('iE-Extensions', _ResourceSetTypeAperiodic_iE_Extensions),
        ])
    ResourceSetTypeAperiodic._ext = None
    
    #-----< ResourceSetTypeAperiodic-ExtIEs >-----#
    ResourceSetTypeAperiodic_ExtIEs = CLASS(name='ResourceSetTypeAperiodic-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ResourceSetTypeAperiodic_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RepetitionPeriod >-----#
    RepetitionPeriod = INT(name='RepetitionPeriod', mode=MODE_TYPE)
    RepetitionPeriod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=131071)], ev=[], er=[])
    
    #-----< ReportingRequestType >-----#
    ReportingRequestType = SEQ(name='ReportingRequestType', mode=MODE_TYPE)
    _ReportingRequestType_eventType = ENUM(name='eventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EventType')))
    _ReportingRequestType_reportingPeriodicityValue = INT(name='reportingPeriodicityValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ReportingPeriodicityValue')), opt=True)
    _ReportingRequestType_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ReportingRequestType_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ReportingRequestType_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ReportingRequestType_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ReportingRequestType_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportingRequestType_iE_Extensions__item__id._const_tab = ____ReportingRequestType_iE_Extensions__item__id_tab
    ___ReportingRequestType_iE_Extensions__item__id._const_tab_at = None
    ___ReportingRequestType_iE_Extensions__item__id._const_tab_id = 'id'
    ___ReportingRequestType_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ReportingRequestType_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ReportingRequestType_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportingRequestType_iE_Extensions__item__criticality._const_tab = ____ReportingRequestType_iE_Extensions__item__criticality_tab
    ___ReportingRequestType_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ReportingRequestType_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ReportingRequestType_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ReportingRequestType_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ReportingRequestType_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportingRequestType_iE_Extensions__item__extensionValue._const_tab = ____ReportingRequestType_iE_Extensions__item__extensionValue_tab
    ___ReportingRequestType_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ReportingRequestType_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ReportingRequestType_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ReportingRequestType_iE_Extensions__item__id),
        ('criticality', ___ReportingRequestType_iE_Extensions__item__criticality),
        ('extensionValue', ___ReportingRequestType_iE_Extensions__item__extensionValue),
        ])
    __ReportingRequestType_iE_Extensions__item_._ext = None
    _ReportingRequestType_iE_Extensions._cont = __ReportingRequestType_iE_Extensions__item_
    _ReportingRequestType_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ReportingRequestType._cont = ASN1Dict([
        ('eventType', _ReportingRequestType_eventType),
        ('reportingPeriodicityValue', _ReportingRequestType_reportingPeriodicityValue),
        ('iE-Extensions', _ReportingRequestType_iE_Extensions),
        ])
    ReportingRequestType._ext = None
    
    #-----< ReportingRequestType-ExtIEs >-----#
    ReportingRequestType_ExtIEs = CLASS(name='ReportingRequestType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ReportingRequestType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceType >-----#
    ResourceType = CHOICE(name='ResourceType', mode=MODE_TYPE)
    _ResourceType_periodic = SEQ(name='periodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceTypePeriodic')))
    _ResourceType_semi_persistent = SEQ(name='semi-persistent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceTypeSemi-persistent')))
    _ResourceType_aperiodic = SEQ(name='aperiodic', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceTypeAperiodic')))
    _ResourceType_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __ResourceType_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___ResourceType_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ResourceType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceType_choice_extension_id._const_tab = ___ResourceType_choice_extension_id_tab
    __ResourceType_choice_extension_id._const_tab_at = None
    __ResourceType_choice_extension_id._const_tab_id = 'id'
    __ResourceType_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___ResourceType_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ResourceType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceType_choice_extension_criticality._const_tab = ___ResourceType_choice_extension_criticality_tab
    __ResourceType_choice_extension_criticality._const_tab_at = ('..', 'id')
    __ResourceType_choice_extension_criticality._const_tab_id = 'criticality'
    __ResourceType_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___ResourceType_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ResourceType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceType_choice_extension_value._const_tab = ___ResourceType_choice_extension_value_tab
    __ResourceType_choice_extension_value._const_tab_at = ('..', 'id')
    __ResourceType_choice_extension_value._const_tab_id = 'Value'
    _ResourceType_choice_extension._cont = ASN1Dict([
        ('id', __ResourceType_choice_extension_id),
        ('criticality', __ResourceType_choice_extension_criticality),
        ('value', __ResourceType_choice_extension_value),
        ])
    _ResourceType_choice_extension._ext = None
    ResourceType._cont = ASN1Dict([
        ('periodic', _ResourceType_periodic),
        ('semi-persistent', _ResourceType_semi_persistent),
        ('aperiodic', _ResourceType_aperiodic),
        ('choice-extension', _ResourceType_choice_extension),
        ])
    ResourceType._ext = None
    
    #-----< ResourceType-ExtIEs >-----#
    ResourceType_ExtIEs = CLASS(name='ResourceType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ResourceType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypePeriodic >-----#
    ResourceTypePeriodic = SEQ(name='ResourceTypePeriodic', mode=MODE_TYPE)
    _ResourceTypePeriodic_periodicity = ENUM(name='periodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypePeriodic_periodicity._cont = ASN1Dict([('slot1', 0), ('slot2', 1), ('slot4', 2), ('slot5', 3), ('slot8', 4), ('slot10', 5), ('slot16', 6), ('slot20', 7), ('slot32', 8), ('slot40', 9), ('slot64', 10), ('slot80', 11), ('slot160', 12), ('slot320', 13), ('slot640', 14), ('slot1280', 15), ('slot2560', 16)])
    _ResourceTypePeriodic_periodicity._ext = []
    _ResourceTypePeriodic_offset = INT(name='offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypePeriodic_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2559)], ev=[], er=[])
    _ResourceTypePeriodic_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceTypePeriodic_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ResourceTypePeriodic_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ResourceTypePeriodic_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypePeriodic_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypePeriodic_iE_Extensions__item__id._const_tab = ____ResourceTypePeriodic_iE_Extensions__item__id_tab
    ___ResourceTypePeriodic_iE_Extensions__item__id._const_tab_at = None
    ___ResourceTypePeriodic_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResourceTypePeriodic_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResourceTypePeriodic_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypePeriodic_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypePeriodic_iE_Extensions__item__criticality._const_tab = ____ResourceTypePeriodic_iE_Extensions__item__criticality_tab
    ___ResourceTypePeriodic_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceTypePeriodic_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResourceTypePeriodic_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResourceTypePeriodic_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypePeriodic_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypePeriodic_iE_Extensions__item__extensionValue._const_tab = ____ResourceTypePeriodic_iE_Extensions__item__extensionValue_tab
    ___ResourceTypePeriodic_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResourceTypePeriodic_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResourceTypePeriodic_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResourceTypePeriodic_iE_Extensions__item__id),
        ('criticality', ___ResourceTypePeriodic_iE_Extensions__item__criticality),
        ('extensionValue', ___ResourceTypePeriodic_iE_Extensions__item__extensionValue),
        ])
    __ResourceTypePeriodic_iE_Extensions__item_._ext = None
    _ResourceTypePeriodic_iE_Extensions._cont = __ResourceTypePeriodic_iE_Extensions__item_
    _ResourceTypePeriodic_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceTypePeriodic._cont = ASN1Dict([
        ('periodicity', _ResourceTypePeriodic_periodicity),
        ('offset', _ResourceTypePeriodic_offset),
        ('iE-Extensions', _ResourceTypePeriodic_iE_Extensions),
        ])
    ResourceTypePeriodic._ext = None
    
    #-----< ResourceTypePeriodic-ExtIEs >-----#
    ResourceTypePeriodic_ExtIEs = CLASS(name='ResourceTypePeriodic-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ResourceTypePeriodic_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypeSemi-persistent >-----#
    ResourceTypeSemi_persistent = SEQ(name='ResourceTypeSemi-persistent', mode=MODE_TYPE)
    _ResourceTypeSemi_persistent_periodicity = ENUM(name='periodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypeSemi_persistent_periodicity._cont = ASN1Dict([('slot1', 0), ('slot2', 1), ('slot4', 2), ('slot5', 3), ('slot8', 4), ('slot10', 5), ('slot16', 6), ('slot20', 7), ('slot32', 8), ('slot40', 9), ('slot64', 10), ('slot80', 11), ('slot160', 12), ('slot320', 13), ('slot640', 14), ('slot1280', 15), ('slot2560', 16)])
    _ResourceTypeSemi_persistent_periodicity._ext = []
    _ResourceTypeSemi_persistent_offset = INT(name='offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypeSemi_persistent_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2559)], ev=[], er=[])
    _ResourceTypeSemi_persistent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceTypeSemi_persistent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ResourceTypeSemi_persistent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ResourceTypeSemi_persistent_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypeSemi_persistent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeSemi_persistent_iE_Extensions__item__id._const_tab = ____ResourceTypeSemi_persistent_iE_Extensions__item__id_tab
    ___ResourceTypeSemi_persistent_iE_Extensions__item__id._const_tab_at = None
    ___ResourceTypeSemi_persistent_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResourceTypeSemi_persistent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResourceTypeSemi_persistent_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypeSemi_persistent_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeSemi_persistent_iE_Extensions__item__criticality._const_tab = ____ResourceTypeSemi_persistent_iE_Extensions__item__criticality_tab
    ___ResourceTypeSemi_persistent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceTypeSemi_persistent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab = ____ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue_tab
    ___ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResourceTypeSemi_persistent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResourceTypeSemi_persistent_iE_Extensions__item__id),
        ('criticality', ___ResourceTypeSemi_persistent_iE_Extensions__item__criticality),
        ('extensionValue', ___ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue),
        ])
    __ResourceTypeSemi_persistent_iE_Extensions__item_._ext = None
    _ResourceTypeSemi_persistent_iE_Extensions._cont = __ResourceTypeSemi_persistent_iE_Extensions__item_
    _ResourceTypeSemi_persistent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceTypeSemi_persistent._cont = ASN1Dict([
        ('periodicity', _ResourceTypeSemi_persistent_periodicity),
        ('offset', _ResourceTypeSemi_persistent_offset),
        ('iE-Extensions', _ResourceTypeSemi_persistent_iE_Extensions),
        ])
    ResourceTypeSemi_persistent._ext = None
    
    #-----< ResourceTypeSemi-persistent-ExtIEs >-----#
    ResourceTypeSemi_persistent_ExtIEs = CLASS(name='ResourceTypeSemi-persistent-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ResourceTypeSemi_persistent_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypeAperiodic >-----#
    ResourceTypeAperiodic = SEQ(name='ResourceTypeAperiodic', mode=MODE_TYPE)
    _ResourceTypeAperiodic_aperiodicResourceType = ENUM(name='aperiodicResourceType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypeAperiodic_aperiodicResourceType._cont = ASN1Dict([('true', 0)])
    _ResourceTypeAperiodic_aperiodicResourceType._ext = []
    _ResourceTypeAperiodic_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceTypeAperiodic_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ResourceTypeAperiodic_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ResourceTypeAperiodic_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypeAperiodic_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeAperiodic_iE_Extensions__item__id._const_tab = ____ResourceTypeAperiodic_iE_Extensions__item__id_tab
    ___ResourceTypeAperiodic_iE_Extensions__item__id._const_tab_at = None
    ___ResourceTypeAperiodic_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResourceTypeAperiodic_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResourceTypeAperiodic_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypeAperiodic_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeAperiodic_iE_Extensions__item__criticality._const_tab = ____ResourceTypeAperiodic_iE_Extensions__item__criticality_tab
    ___ResourceTypeAperiodic_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceTypeAperiodic_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResourceTypeAperiodic_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResourceTypeAperiodic_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypeAperiodic_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeAperiodic_iE_Extensions__item__extensionValue._const_tab = ____ResourceTypeAperiodic_iE_Extensions__item__extensionValue_tab
    ___ResourceTypeAperiodic_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResourceTypeAperiodic_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResourceTypeAperiodic_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResourceTypeAperiodic_iE_Extensions__item__id),
        ('criticality', ___ResourceTypeAperiodic_iE_Extensions__item__criticality),
        ('extensionValue', ___ResourceTypeAperiodic_iE_Extensions__item__extensionValue),
        ])
    __ResourceTypeAperiodic_iE_Extensions__item_._ext = None
    _ResourceTypeAperiodic_iE_Extensions._cont = __ResourceTypeAperiodic_iE_Extensions__item_
    _ResourceTypeAperiodic_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceTypeAperiodic._cont = ASN1Dict([
        ('aperiodicResourceType', _ResourceTypeAperiodic_aperiodicResourceType),
        ('iE-Extensions', _ResourceTypeAperiodic_iE_Extensions),
        ])
    ResourceTypeAperiodic._ext = None
    
    #-----< ResourceTypeAperiodic-ExtIEs >-----#
    ResourceTypeAperiodic_ExtIEs = CLASS(name='ResourceTypeAperiodic-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ResourceTypeAperiodic_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypePos >-----#
    ResourceTypePos = CHOICE(name='ResourceTypePos', mode=MODE_TYPE)
    _ResourceTypePos_periodic = SEQ(name='periodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceTypePeriodicPos')))
    _ResourceTypePos_semi_persistent = SEQ(name='semi-persistent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceTypeSemi-persistentPos')))
    _ResourceTypePos_aperiodic = SEQ(name='aperiodic', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceTypeAperiodicPos')))
    _ResourceTypePos_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __ResourceTypePos_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___ResourceTypePos_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ResourceTypePos_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceTypePos_choice_extension_id._const_tab = ___ResourceTypePos_choice_extension_id_tab
    __ResourceTypePos_choice_extension_id._const_tab_at = None
    __ResourceTypePos_choice_extension_id._const_tab_id = 'id'
    __ResourceTypePos_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___ResourceTypePos_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ResourceTypePos_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceTypePos_choice_extension_criticality._const_tab = ___ResourceTypePos_choice_extension_criticality_tab
    __ResourceTypePos_choice_extension_criticality._const_tab_at = ('..', 'id')
    __ResourceTypePos_choice_extension_criticality._const_tab_id = 'criticality'
    __ResourceTypePos_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___ResourceTypePos_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ResourceTypePos_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceTypePos_choice_extension_value._const_tab = ___ResourceTypePos_choice_extension_value_tab
    __ResourceTypePos_choice_extension_value._const_tab_at = ('..', 'id')
    __ResourceTypePos_choice_extension_value._const_tab_id = 'Value'
    _ResourceTypePos_choice_extension._cont = ASN1Dict([
        ('id', __ResourceTypePos_choice_extension_id),
        ('criticality', __ResourceTypePos_choice_extension_criticality),
        ('value', __ResourceTypePos_choice_extension_value),
        ])
    _ResourceTypePos_choice_extension._ext = None
    ResourceTypePos._cont = ASN1Dict([
        ('periodic', _ResourceTypePos_periodic),
        ('semi-persistent', _ResourceTypePos_semi_persistent),
        ('aperiodic', _ResourceTypePos_aperiodic),
        ('choice-extension', _ResourceTypePos_choice_extension),
        ])
    ResourceTypePos._ext = None
    
    #-----< ResourceTypePos-ExtIEs >-----#
    ResourceTypePos_ExtIEs = CLASS(name='ResourceTypePos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ResourceTypePos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypePeriodicPos >-----#
    ResourceTypePeriodicPos = SEQ(name='ResourceTypePeriodicPos', mode=MODE_TYPE)
    _ResourceTypePeriodicPos_periodicity = ENUM(name='periodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypePeriodicPos_periodicity._cont = ASN1Dict([('slot1', 0), ('slot2', 1), ('slot4', 2), ('slot5', 3), ('slot8', 4), ('slot10', 5), ('slot16', 6), ('slot20', 7), ('slot32', 8), ('slot40', 9), ('slot64', 10), ('slot80', 11), ('slot160', 12), ('slot320', 13), ('slot640', 14), ('slot1280', 15), ('slot2560', 16), ('slot5120', 17), ('slot10240', 18), ('slot40960', 19), ('slot81920', 20), ('slot128', 21), ('slot256', 22), ('slot512', 23), ('slot20480', 24)])
    _ResourceTypePeriodicPos_periodicity._ext = ['slot128', 'slot256', 'slot512', 'slot20480']
    _ResourceTypePeriodicPos_offset = INT(name='offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypePeriodicPos_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=81919)], ev=[], er=[])
    _ResourceTypePeriodicPos_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceTypePeriodicPos_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ResourceTypePeriodicPos_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ResourceTypePeriodicPos_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypePeriodicPos_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypePeriodicPos_iE_Extensions__item__id._const_tab = ____ResourceTypePeriodicPos_iE_Extensions__item__id_tab
    ___ResourceTypePeriodicPos_iE_Extensions__item__id._const_tab_at = None
    ___ResourceTypePeriodicPos_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResourceTypePeriodicPos_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResourceTypePeriodicPos_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypePeriodicPos_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypePeriodicPos_iE_Extensions__item__criticality._const_tab = ____ResourceTypePeriodicPos_iE_Extensions__item__criticality_tab
    ___ResourceTypePeriodicPos_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceTypePeriodicPos_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResourceTypePeriodicPos_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResourceTypePeriodicPos_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypePeriodicPos_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypePeriodicPos_iE_Extensions__item__extensionValue._const_tab = ____ResourceTypePeriodicPos_iE_Extensions__item__extensionValue_tab
    ___ResourceTypePeriodicPos_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResourceTypePeriodicPos_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResourceTypePeriodicPos_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResourceTypePeriodicPos_iE_Extensions__item__id),
        ('criticality', ___ResourceTypePeriodicPos_iE_Extensions__item__criticality),
        ('extensionValue', ___ResourceTypePeriodicPos_iE_Extensions__item__extensionValue),
        ])
    __ResourceTypePeriodicPos_iE_Extensions__item_._ext = None
    _ResourceTypePeriodicPos_iE_Extensions._cont = __ResourceTypePeriodicPos_iE_Extensions__item_
    _ResourceTypePeriodicPos_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceTypePeriodicPos._cont = ASN1Dict([
        ('periodicity', _ResourceTypePeriodicPos_periodicity),
        ('offset', _ResourceTypePeriodicPos_offset),
        ('iE-Extensions', _ResourceTypePeriodicPos_iE_Extensions),
        ])
    ResourceTypePeriodicPos._ext = None
    
    #-----< ResourceTypePeriodicPos-ExtIEs >-----#
    ResourceTypePeriodicPos_ExtIEs = CLASS(name='ResourceTypePeriodicPos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ResourceTypePeriodicPos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypeSemi-persistentPos >-----#
    ResourceTypeSemi_persistentPos = SEQ(name='ResourceTypeSemi-persistentPos', mode=MODE_TYPE)
    _ResourceTypeSemi_persistentPos_periodicity = ENUM(name='periodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypeSemi_persistentPos_periodicity._cont = ASN1Dict([('slot1', 0), ('slot2', 1), ('slot4', 2), ('slot5', 3), ('slot8', 4), ('slot10', 5), ('slot16', 6), ('slot20', 7), ('slot32', 8), ('slot40', 9), ('slot64', 10), ('slot80', 11), ('slot160', 12), ('slot320', 13), ('slot640', 14), ('slot1280', 15), ('slot2560', 16), ('slot5120', 17), ('slot10240', 18), ('slot40960', 19), ('slot81920', 20), ('slot128', 21), ('slot256', 22), ('slot512', 23), ('slot20480', 24)])
    _ResourceTypeSemi_persistentPos_periodicity._ext = ['slot128', 'slot256', 'slot512', 'slot20480']
    _ResourceTypeSemi_persistentPos_offset = INT(name='offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypeSemi_persistentPos_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=81919)], ev=[], er=[])
    _ResourceTypeSemi_persistentPos_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceTypeSemi_persistentPos_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ResourceTypeSemi_persistentPos_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypeSemi_persistentPos_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__id._const_tab = ____ResourceTypeSemi_persistentPos_iE_Extensions__item__id_tab
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__id._const_tab_at = None
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality._const_tab = ____ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality_tab
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue._const_tab = ____ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue_tab
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResourceTypeSemi_persistentPos_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResourceTypeSemi_persistentPos_iE_Extensions__item__id),
        ('criticality', ___ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality),
        ('extensionValue', ___ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue),
        ])
    __ResourceTypeSemi_persistentPos_iE_Extensions__item_._ext = None
    _ResourceTypeSemi_persistentPos_iE_Extensions._cont = __ResourceTypeSemi_persistentPos_iE_Extensions__item_
    _ResourceTypeSemi_persistentPos_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceTypeSemi_persistentPos._cont = ASN1Dict([
        ('periodicity', _ResourceTypeSemi_persistentPos_periodicity),
        ('offset', _ResourceTypeSemi_persistentPos_offset),
        ('iE-Extensions', _ResourceTypeSemi_persistentPos_iE_Extensions),
        ])
    ResourceTypeSemi_persistentPos._ext = None
    
    #-----< ResourceTypeSemi-persistentPos-ExtIEs >-----#
    ResourceTypeSemi_persistentPos_ExtIEs = CLASS(name='ResourceTypeSemi-persistentPos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ResourceTypeSemi_persistentPos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypeAperiodicPos >-----#
    ResourceTypeAperiodicPos = SEQ(name='ResourceTypeAperiodicPos', mode=MODE_TYPE)
    _ResourceTypeAperiodicPos_slotOffset = INT(name='slotOffset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypeAperiodicPos_slotOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32)], ev=None, er=[])
    _ResourceTypeAperiodicPos_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceTypeAperiodicPos_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ResourceTypeAperiodicPos_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ResourceTypeAperiodicPos_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypeAperiodicPos_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeAperiodicPos_iE_Extensions__item__id._const_tab = ____ResourceTypeAperiodicPos_iE_Extensions__item__id_tab
    ___ResourceTypeAperiodicPos_iE_Extensions__item__id._const_tab_at = None
    ___ResourceTypeAperiodicPos_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResourceTypeAperiodicPos_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResourceTypeAperiodicPos_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypeAperiodicPos_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeAperiodicPos_iE_Extensions__item__criticality._const_tab = ____ResourceTypeAperiodicPos_iE_Extensions__item__criticality_tab
    ___ResourceTypeAperiodicPos_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceTypeAperiodicPos_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue._const_tab = ____ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue_tab
    ___ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResourceTypeAperiodicPos_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResourceTypeAperiodicPos_iE_Extensions__item__id),
        ('criticality', ___ResourceTypeAperiodicPos_iE_Extensions__item__criticality),
        ('extensionValue', ___ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue),
        ])
    __ResourceTypeAperiodicPos_iE_Extensions__item_._ext = None
    _ResourceTypeAperiodicPos_iE_Extensions._cont = __ResourceTypeAperiodicPos_iE_Extensions__item_
    _ResourceTypeAperiodicPos_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceTypeAperiodicPos._cont = ASN1Dict([
        ('slotOffset', _ResourceTypeAperiodicPos_slotOffset),
        ('iE-Extensions', _ResourceTypeAperiodicPos_iE_Extensions),
        ])
    ResourceTypeAperiodicPos._ext = None
    
    #-----< ResourceTypeAperiodicPos-ExtIEs >-----#
    ResourceTypeAperiodicPos_ExtIEs = CLASS(name='ResourceTypeAperiodicPos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ResourceTypeAperiodicPos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RLCDuplicationInformation >-----#
    RLCDuplicationInformation = SEQ(name='RLCDuplicationInformation', mode=MODE_TYPE)
    _RLCDuplicationInformation_rLCDuplicationStateList = SEQ_OF(name='rLCDuplicationStateList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RLCDuplicationStateList')))
    _RLCDuplicationInformation_primaryPathIndication = ENUM(name='primaryPathIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PrimaryPathIndication')), opt=True)
    _RLCDuplicationInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RLCDuplicationInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RLCDuplicationInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RLCDuplicationInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLCDuplicationInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLCDuplicationInformation_iE_Extensions__item__id._const_tab = ____RLCDuplicationInformation_iE_Extensions__item__id_tab
    ___RLCDuplicationInformation_iE_Extensions__item__id._const_tab_at = None
    ___RLCDuplicationInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___RLCDuplicationInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RLCDuplicationInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLCDuplicationInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLCDuplicationInformation_iE_Extensions__item__criticality._const_tab = ____RLCDuplicationInformation_iE_Extensions__item__criticality_tab
    ___RLCDuplicationInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RLCDuplicationInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RLCDuplicationInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RLCDuplicationInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLCDuplicationInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLCDuplicationInformation_iE_Extensions__item__extensionValue._const_tab = ____RLCDuplicationInformation_iE_Extensions__item__extensionValue_tab
    ___RLCDuplicationInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RLCDuplicationInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RLCDuplicationInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RLCDuplicationInformation_iE_Extensions__item__id),
        ('criticality', ___RLCDuplicationInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___RLCDuplicationInformation_iE_Extensions__item__extensionValue),
        ])
    __RLCDuplicationInformation_iE_Extensions__item_._ext = None
    _RLCDuplicationInformation_iE_Extensions._cont = __RLCDuplicationInformation_iE_Extensions__item_
    _RLCDuplicationInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RLCDuplicationInformation._cont = ASN1Dict([
        ('rLCDuplicationStateList', _RLCDuplicationInformation_rLCDuplicationStateList),
        ('primaryPathIndication', _RLCDuplicationInformation_primaryPathIndication),
        ('iE-Extensions', _RLCDuplicationInformation_iE_Extensions),
        ])
    RLCDuplicationInformation._ext = None
    
    #-----< RLCDuplicationInformation-ExtIEs >-----#
    RLCDuplicationInformation_ExtIEs = CLASS(name='RLCDuplicationInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RLCDuplicationInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RLCDuplicationStateList >-----#
    RLCDuplicationStateList = SEQ_OF(name='RLCDuplicationStateList', mode=MODE_TYPE)
    _RLCDuplicationStateList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLCDuplicationState-Item')))
    RLCDuplicationStateList._cont = _RLCDuplicationStateList__item_
    RLCDuplicationStateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< RLCDuplicationState-Item >-----#
    RLCDuplicationState_Item = SEQ(name='RLCDuplicationState-Item', mode=MODE_TYPE)
    _RLCDuplicationState_Item_duplicationState = ENUM(name='duplicationState', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DuplicationState')))
    _RLCDuplicationState_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RLCDuplicationState_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RLCDuplicationState_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RLCDuplicationState_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLCDuplicationState_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLCDuplicationState_Item_iE_Extensions__item__id._const_tab = ____RLCDuplicationState_Item_iE_Extensions__item__id_tab
    ___RLCDuplicationState_Item_iE_Extensions__item__id._const_tab_at = None
    ___RLCDuplicationState_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___RLCDuplicationState_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RLCDuplicationState_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLCDuplicationState_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLCDuplicationState_Item_iE_Extensions__item__criticality._const_tab = ____RLCDuplicationState_Item_iE_Extensions__item__criticality_tab
    ___RLCDuplicationState_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RLCDuplicationState_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RLCDuplicationState_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RLCDuplicationState_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLCDuplicationState_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLCDuplicationState_Item_iE_Extensions__item__extensionValue._const_tab = ____RLCDuplicationState_Item_iE_Extensions__item__extensionValue_tab
    ___RLCDuplicationState_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RLCDuplicationState_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RLCDuplicationState_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RLCDuplicationState_Item_iE_Extensions__item__id),
        ('criticality', ___RLCDuplicationState_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___RLCDuplicationState_Item_iE_Extensions__item__extensionValue),
        ])
    __RLCDuplicationState_Item_iE_Extensions__item_._ext = None
    _RLCDuplicationState_Item_iE_Extensions._cont = __RLCDuplicationState_Item_iE_Extensions__item_
    _RLCDuplicationState_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RLCDuplicationState_Item._cont = ASN1Dict([
        ('duplicationState', _RLCDuplicationState_Item_duplicationState),
        ('iE-Extensions', _RLCDuplicationState_Item_iE_Extensions),
        ])
    RLCDuplicationState_Item._ext = []
    
    #-----< RLCDuplicationState-Item-ExtIEs >-----#
    RLCDuplicationState_Item_ExtIEs = CLASS(name='RLCDuplicationState-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RLCDuplicationState_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RLCFailureIndication >-----#
    RLCFailureIndication = SEQ(name='RLCFailureIndication', mode=MODE_TYPE)
    _RLCFailureIndication_assocatedLCID = INT(name='assocatedLCID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LCID')))
    _RLCFailureIndication_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RLCFailureIndication_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RLCFailureIndication_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RLCFailureIndication_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLCFailureIndication_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLCFailureIndication_iE_Extensions__item__id._const_tab = ____RLCFailureIndication_iE_Extensions__item__id_tab
    ___RLCFailureIndication_iE_Extensions__item__id._const_tab_at = None
    ___RLCFailureIndication_iE_Extensions__item__id._const_tab_id = 'id'
    ___RLCFailureIndication_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RLCFailureIndication_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLCFailureIndication_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLCFailureIndication_iE_Extensions__item__criticality._const_tab = ____RLCFailureIndication_iE_Extensions__item__criticality_tab
    ___RLCFailureIndication_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RLCFailureIndication_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RLCFailureIndication_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RLCFailureIndication_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLCFailureIndication_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLCFailureIndication_iE_Extensions__item__extensionValue._const_tab = ____RLCFailureIndication_iE_Extensions__item__extensionValue_tab
    ___RLCFailureIndication_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RLCFailureIndication_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RLCFailureIndication_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RLCFailureIndication_iE_Extensions__item__id),
        ('criticality', ___RLCFailureIndication_iE_Extensions__item__criticality),
        ('extensionValue', ___RLCFailureIndication_iE_Extensions__item__extensionValue),
        ])
    __RLCFailureIndication_iE_Extensions__item_._ext = None
    _RLCFailureIndication_iE_Extensions._cont = __RLCFailureIndication_iE_Extensions__item_
    _RLCFailureIndication_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RLCFailureIndication._cont = ASN1Dict([
        ('assocatedLCID', _RLCFailureIndication_assocatedLCID),
        ('iE-Extensions', _RLCFailureIndication_iE_Extensions),
        ])
    RLCFailureIndication._ext = None
    
    #-----< RLCFailureIndication-ExtIEs >-----#
    RLCFailureIndication_ExtIEs = CLASS(name='RLCFailureIndication-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RLCFailureIndication_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RLCMode >-----#
    RLCMode = ENUM(name='RLCMode', mode=MODE_TYPE)
    RLCMode._cont = ASN1Dict([('rlc-am', 0), ('rlc-um-bidirectional', 1), ('rlc-um-unidirectional-ul', 2), ('rlc-um-unidirectional-dl', 3)])
    RLCMode._ext = []
    
    #-----< RLC-Status >-----#
    RLC_Status = SEQ(name='RLC-Status', mode=MODE_TYPE)
    _RLC_Status_reestablishment_Indication = ENUM(name='reestablishment-Indication', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Reestablishment-Indication')))
    _RLC_Status_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RLC_Status_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RLC_Status_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RLC_Status_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLC_Status_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLC_Status_iE_Extensions__item__id._const_tab = ____RLC_Status_iE_Extensions__item__id_tab
    ___RLC_Status_iE_Extensions__item__id._const_tab_at = None
    ___RLC_Status_iE_Extensions__item__id._const_tab_id = 'id'
    ___RLC_Status_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RLC_Status_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLC_Status_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLC_Status_iE_Extensions__item__criticality._const_tab = ____RLC_Status_iE_Extensions__item__criticality_tab
    ___RLC_Status_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RLC_Status_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RLC_Status_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RLC_Status_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLC_Status_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLC_Status_iE_Extensions__item__extensionValue._const_tab = ____RLC_Status_iE_Extensions__item__extensionValue_tab
    ___RLC_Status_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RLC_Status_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RLC_Status_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RLC_Status_iE_Extensions__item__id),
        ('criticality', ___RLC_Status_iE_Extensions__item__criticality),
        ('extensionValue', ___RLC_Status_iE_Extensions__item__extensionValue),
        ])
    __RLC_Status_iE_Extensions__item_._ext = None
    _RLC_Status_iE_Extensions._cont = __RLC_Status_iE_Extensions__item_
    _RLC_Status_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RLC_Status._cont = ASN1Dict([
        ('reestablishment-Indication', _RLC_Status_reestablishment_Indication),
        ('iE-Extensions', _RLC_Status_iE_Extensions),
        ])
    RLC_Status._ext = []
    
    #-----< RLC-Status-ExtIEs >-----#
    RLC_Status_ExtIEs = CLASS(name='RLC-Status-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RLC_Status_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RLFReportInformationList >-----#
    RLFReportInformationList = SEQ_OF(name='RLFReportInformationList', mode=MODE_TYPE)
    _RLFReportInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLFReportInformationItem')))
    RLFReportInformationList._cont = _RLFReportInformationList__item_
    RLFReportInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< RLFReportInformationItem >-----#
    RLFReportInformationItem = SEQ(name='RLFReportInformationItem', mode=MODE_TYPE)
    _RLFReportInformationItem_nRUERLFReportContainer = OCT_STR(name='nRUERLFReportContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRUERLFReportContainer')))
    _RLFReportInformationItem_uEAssitantIdentifier = INT(name='uEAssitantIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')), opt=True)
    _RLFReportInformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RLFReportInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RLFReportInformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RLFReportInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLFReportInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLFReportInformationItem_iE_Extensions__item__id._const_tab = ____RLFReportInformationItem_iE_Extensions__item__id_tab
    ___RLFReportInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___RLFReportInformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___RLFReportInformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RLFReportInformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLFReportInformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLFReportInformationItem_iE_Extensions__item__criticality._const_tab = ____RLFReportInformationItem_iE_Extensions__item__criticality_tab
    ___RLFReportInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RLFReportInformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RLFReportInformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RLFReportInformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RLFReportInformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLFReportInformationItem_iE_Extensions__item__extensionValue._const_tab = ____RLFReportInformationItem_iE_Extensions__item__extensionValue_tab
    ___RLFReportInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RLFReportInformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RLFReportInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RLFReportInformationItem_iE_Extensions__item__id),
        ('criticality', ___RLFReportInformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___RLFReportInformationItem_iE_Extensions__item__extensionValue),
        ])
    __RLFReportInformationItem_iE_Extensions__item_._ext = None
    _RLFReportInformationItem_iE_Extensions._cont = __RLFReportInformationItem_iE_Extensions__item_
    _RLFReportInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RLFReportInformationItem._cont = ASN1Dict([
        ('nRUERLFReportContainer', _RLFReportInformationItem_nRUERLFReportContainer),
        ('uEAssitantIdentifier', _RLFReportInformationItem_uEAssitantIdentifier),
        ('iE-Extensions', _RLFReportInformationItem_iE_Extensions),
        ])
    RLFReportInformationItem._ext = []
    
    #-----< RLFReportInformationItem-ExtIEs >-----#
    RLFReportInformationItem_ExtIEs = CLASS(name='RLFReportInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RLFReportInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RIMRSDetectionStatus >-----#
    RIMRSDetectionStatus = ENUM(name='RIMRSDetectionStatus', mode=MODE_TYPE)
    RIMRSDetectionStatus._cont = ASN1Dict([('rs-detected', 0), ('rs-disappeared', 1)])
    RIMRSDetectionStatus._ext = []
    
    #-----< RRCContainer >-----#
    RRCContainer = OCT_STR(name='RRCContainer', mode=MODE_TYPE)
    
    #-----< RRCContainer-RRCSetupComplete >-----#
    RRCContainer_RRCSetupComplete = OCT_STR(name='RRCContainer-RRCSetupComplete', mode=MODE_TYPE)
    
    #-----< RRCDeliveryStatus >-----#
    RRCDeliveryStatus = SEQ(name='RRCDeliveryStatus', mode=MODE_TYPE)
    _RRCDeliveryStatus_delivery_status = INT(name='delivery-status', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PDCP-SN')))
    _RRCDeliveryStatus_triggering_message = INT(name='triggering-message', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PDCP-SN')))
    _RRCDeliveryStatus_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RRCDeliveryStatus_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RRCDeliveryStatus_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RRCDeliveryStatus_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RRCDeliveryStatus_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RRCDeliveryStatus_iE_Extensions__item__id._const_tab = ____RRCDeliveryStatus_iE_Extensions__item__id_tab
    ___RRCDeliveryStatus_iE_Extensions__item__id._const_tab_at = None
    ___RRCDeliveryStatus_iE_Extensions__item__id._const_tab_id = 'id'
    ___RRCDeliveryStatus_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RRCDeliveryStatus_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RRCDeliveryStatus_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RRCDeliveryStatus_iE_Extensions__item__criticality._const_tab = ____RRCDeliveryStatus_iE_Extensions__item__criticality_tab
    ___RRCDeliveryStatus_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RRCDeliveryStatus_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RRCDeliveryStatus_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RRCDeliveryStatus_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RRCDeliveryStatus_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RRCDeliveryStatus_iE_Extensions__item__extensionValue._const_tab = ____RRCDeliveryStatus_iE_Extensions__item__extensionValue_tab
    ___RRCDeliveryStatus_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RRCDeliveryStatus_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RRCDeliveryStatus_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RRCDeliveryStatus_iE_Extensions__item__id),
        ('criticality', ___RRCDeliveryStatus_iE_Extensions__item__criticality),
        ('extensionValue', ___RRCDeliveryStatus_iE_Extensions__item__extensionValue),
        ])
    __RRCDeliveryStatus_iE_Extensions__item_._ext = None
    _RRCDeliveryStatus_iE_Extensions._cont = __RRCDeliveryStatus_iE_Extensions__item_
    _RRCDeliveryStatus_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RRCDeliveryStatus._cont = ASN1Dict([
        ('delivery-status', _RRCDeliveryStatus_delivery_status),
        ('triggering-message', _RRCDeliveryStatus_triggering_message),
        ('iE-Extensions', _RRCDeliveryStatus_iE_Extensions),
        ])
    RRCDeliveryStatus._ext = None
    
    #-----< RRCDeliveryStatus-ExtIEs >-----#
    RRCDeliveryStatus_ExtIEs = CLASS(name='RRCDeliveryStatus-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RRCDeliveryStatus_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RRCDeliveryStatusRequest >-----#
    RRCDeliveryStatusRequest = ENUM(name='RRCDeliveryStatusRequest', mode=MODE_TYPE)
    RRCDeliveryStatusRequest._cont = ASN1Dict([('true', 0)])
    RRCDeliveryStatusRequest._ext = []
    
    #-----< RRCReconfigurationCompleteIndicator >-----#
    RRCReconfigurationCompleteIndicator = ENUM(name='RRCReconfigurationCompleteIndicator', mode=MODE_TYPE)
    RRCReconfigurationCompleteIndicator._cont = ASN1Dict([('true', 0), ('failure', 1)])
    RRCReconfigurationCompleteIndicator._ext = ['failure']
    
    #-----< RRC-Version >-----#
    RRC_Version = SEQ(name='RRC-Version', mode=MODE_TYPE)
    _RRC_Version_latest_RRC_Version = BIT_STR(name='latest-RRC-Version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RRC_Version_latest_RRC_Version._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _RRC_Version_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RRC_Version_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RRC_Version_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RRC_Version_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____RRC_Version_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE)
    _____RRC_Version_iE_Extensions__item__id_tab_val_Extension_0._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    ____RRC_Version_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 199), ('criticality', 'ignore'), ('Extension', _____RRC_Version_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RRC_Version_iE_Extensions__item__id._const_tab = ____RRC_Version_iE_Extensions__item__id_tab
    ___RRC_Version_iE_Extensions__item__id._const_tab_at = None
    ___RRC_Version_iE_Extensions__item__id._const_tab_id = 'id'
    ___RRC_Version_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RRC_Version_iE_Extensions__item__criticality._const_tab = ____RRC_Version_iE_Extensions__item__id_tab
    ___RRC_Version_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RRC_Version_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RRC_Version_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RRC_Version_iE_Extensions__item__extensionValue._const_tab = ____RRC_Version_iE_Extensions__item__id_tab
    ___RRC_Version_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RRC_Version_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RRC_Version_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RRC_Version_iE_Extensions__item__id),
        ('criticality', ___RRC_Version_iE_Extensions__item__criticality),
        ('extensionValue', ___RRC_Version_iE_Extensions__item__extensionValue),
        ])
    __RRC_Version_iE_Extensions__item_._ext = None
    _RRC_Version_iE_Extensions._cont = __RRC_Version_iE_Extensions__item_
    _RRC_Version_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RRC_Version._cont = ASN1Dict([
        ('latest-RRC-Version', _RRC_Version_latest_RRC_Version),
        ('iE-Extensions', _RRC_Version_iE_Extensions),
        ])
    RRC_Version._ext = None
    
    #-----< RRC-Version-ExtIEs >-----#
    RRC_Version_ExtIEs = CLASS(name='RRC-Version-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _RRC_Version_ExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE)
    _RRC_Version_ExtIEs_val_Extension_0._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    RRC_Version_ExtIEs._val = ASN1Set(rv=[dict([('id', 199), ('criticality', 'ignore'), ('Extension', _RRC_Version_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RoutingID >-----#
    RoutingID = OCT_STR(name='RoutingID', mode=MODE_TYPE)
    
    #-----< ResponseTime >-----#
    ResponseTime = SEQ(name='ResponseTime', mode=MODE_TYPE)
    _ResponseTime_time = INT(name='time', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResponseTime_time._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=[], er=[])
    _ResponseTime_timeUnit = ENUM(name='timeUnit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResponseTime_timeUnit._cont = ASN1Dict([('second', 0), ('ten-seconds', 1), ('ten-milliseconds', 2)])
    _ResponseTime_timeUnit._ext = []
    _ResponseTime_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResponseTime_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ResponseTime_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ResponseTime_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResponseTime_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResponseTime_iE_Extensions__item__id._const_tab = ____ResponseTime_iE_Extensions__item__id_tab
    ___ResponseTime_iE_Extensions__item__id._const_tab_at = None
    ___ResponseTime_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResponseTime_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResponseTime_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResponseTime_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResponseTime_iE_Extensions__item__criticality._const_tab = ____ResponseTime_iE_Extensions__item__criticality_tab
    ___ResponseTime_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResponseTime_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResponseTime_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResponseTime_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ResponseTime_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResponseTime_iE_Extensions__item__extensionValue._const_tab = ____ResponseTime_iE_Extensions__item__extensionValue_tab
    ___ResponseTime_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResponseTime_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResponseTime_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResponseTime_iE_Extensions__item__id),
        ('criticality', ___ResponseTime_iE_Extensions__item__criticality),
        ('extensionValue', ___ResponseTime_iE_Extensions__item__extensionValue),
        ])
    __ResponseTime_iE_Extensions__item_._ext = None
    _ResponseTime_iE_Extensions._cont = __ResponseTime_iE_Extensions__item_
    _ResponseTime_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResponseTime._cont = ASN1Dict([
        ('time', _ResponseTime_time),
        ('timeUnit', _ResponseTime_timeUnit),
        ('iE-Extensions', _ResponseTime_iE_Extensions),
        ])
    ResponseTime._ext = []
    
    #-----< ResponseTime-ExtIEs >-----#
    ResponseTime_ExtIEs = CLASS(name='ResponseTime-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ResponseTime_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RxTxTimingErrorMargin >-----#
    RxTxTimingErrorMargin = ENUM(name='RxTxTimingErrorMargin', mode=MODE_TYPE)
    RxTxTimingErrorMargin._cont = ASN1Dict([('tc0dot5', 0), ('tc1', 1), ('tc2', 2), ('tc4', 3), ('tc8', 4), ('tc12', 5), ('tc16', 6), ('tc20', 7), ('tc24', 8), ('tc32', 9), ('tc40', 10), ('tc48', 11), ('tc64', 12), ('tc80', 13), ('tc96', 14), ('tc128', 15)])
    RxTxTimingErrorMargin._ext = []
    
    #-----< SCell-FailedtoSetup-Item >-----#
    SCell_FailedtoSetup_Item = SEQ(name='SCell-FailedtoSetup-Item', mode=MODE_TYPE)
    _SCell_FailedtoSetup_Item_sCell_ID = SEQ(name='sCell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _SCell_FailedtoSetup_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _SCell_FailedtoSetup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SCell_FailedtoSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SCell_FailedtoSetup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SCell_FailedtoSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SCell_FailedtoSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCell_FailedtoSetup_Item_iE_Extensions__item__id._const_tab = ____SCell_FailedtoSetup_Item_iE_Extensions__item__id_tab
    ___SCell_FailedtoSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___SCell_FailedtoSetup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SCell_FailedtoSetup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SCell_FailedtoSetup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SCell_FailedtoSetup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCell_FailedtoSetup_Item_iE_Extensions__item__criticality._const_tab = ____SCell_FailedtoSetup_Item_iE_Extensions__item__criticality_tab
    ___SCell_FailedtoSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SCell_FailedtoSetup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SCell_FailedtoSetup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SCell_FailedtoSetup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SCell_FailedtoSetup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCell_FailedtoSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____SCell_FailedtoSetup_Item_iE_Extensions__item__extensionValue_tab
    ___SCell_FailedtoSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SCell_FailedtoSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SCell_FailedtoSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SCell_FailedtoSetup_Item_iE_Extensions__item__id),
        ('criticality', ___SCell_FailedtoSetup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SCell_FailedtoSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __SCell_FailedtoSetup_Item_iE_Extensions__item_._ext = None
    _SCell_FailedtoSetup_Item_iE_Extensions._cont = __SCell_FailedtoSetup_Item_iE_Extensions__item_
    _SCell_FailedtoSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SCell_FailedtoSetup_Item._cont = ASN1Dict([
        ('sCell-ID', _SCell_FailedtoSetup_Item_sCell_ID),
        ('cause', _SCell_FailedtoSetup_Item_cause),
        ('iE-Extensions', _SCell_FailedtoSetup_Item_iE_Extensions),
        ])
    SCell_FailedtoSetup_Item._ext = []
    
    #-----< SCell-FailedtoSetup-ItemExtIEs >-----#
    SCell_FailedtoSetup_ItemExtIEs = CLASS(name='SCell-FailedtoSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SCell_FailedtoSetup_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SCell-FailedtoSetupMod-Item >-----#
    SCell_FailedtoSetupMod_Item = SEQ(name='SCell-FailedtoSetupMod-Item', mode=MODE_TYPE)
    _SCell_FailedtoSetupMod_Item_sCell_ID = SEQ(name='sCell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _SCell_FailedtoSetupMod_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _SCell_FailedtoSetupMod_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SCell_FailedtoSetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SCell_FailedtoSetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SCell_FailedtoSetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__id._const_tab = ____SCell_FailedtoSetupMod_Item_iE_Extensions__item__id_tab
    ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SCell_FailedtoSetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SCell_FailedtoSetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__criticality._const_tab = ____SCell_FailedtoSetupMod_Item_iE_Extensions__item__criticality_tab
    ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SCell_FailedtoSetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SCell_FailedtoSetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____SCell_FailedtoSetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SCell_FailedtoSetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__id),
        ('criticality', ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __SCell_FailedtoSetupMod_Item_iE_Extensions__item_._ext = None
    _SCell_FailedtoSetupMod_Item_iE_Extensions._cont = __SCell_FailedtoSetupMod_Item_iE_Extensions__item_
    _SCell_FailedtoSetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SCell_FailedtoSetupMod_Item._cont = ASN1Dict([
        ('sCell-ID', _SCell_FailedtoSetupMod_Item_sCell_ID),
        ('cause', _SCell_FailedtoSetupMod_Item_cause),
        ('iE-Extensions', _SCell_FailedtoSetupMod_Item_iE_Extensions),
        ])
    SCell_FailedtoSetupMod_Item._ext = []
    
    #-----< SCell-FailedtoSetupMod-ItemExtIEs >-----#
    SCell_FailedtoSetupMod_ItemExtIEs = CLASS(name='SCell-FailedtoSetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SCell_FailedtoSetupMod_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SCell-ToBeRemoved-Item >-----#
    SCell_ToBeRemoved_Item = SEQ(name='SCell-ToBeRemoved-Item', mode=MODE_TYPE)
    _SCell_ToBeRemoved_Item_sCell_ID = SEQ(name='sCell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _SCell_ToBeRemoved_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SCell_ToBeRemoved_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SCell_ToBeRemoved_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SCell_ToBeRemoved_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SCell_ToBeRemoved_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCell_ToBeRemoved_Item_iE_Extensions__item__id._const_tab = ____SCell_ToBeRemoved_Item_iE_Extensions__item__id_tab
    ___SCell_ToBeRemoved_Item_iE_Extensions__item__id._const_tab_at = None
    ___SCell_ToBeRemoved_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SCell_ToBeRemoved_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SCell_ToBeRemoved_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SCell_ToBeRemoved_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCell_ToBeRemoved_Item_iE_Extensions__item__criticality._const_tab = ____SCell_ToBeRemoved_Item_iE_Extensions__item__criticality_tab
    ___SCell_ToBeRemoved_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SCell_ToBeRemoved_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SCell_ToBeRemoved_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SCell_ToBeRemoved_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SCell_ToBeRemoved_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCell_ToBeRemoved_Item_iE_Extensions__item__extensionValue._const_tab = ____SCell_ToBeRemoved_Item_iE_Extensions__item__extensionValue_tab
    ___SCell_ToBeRemoved_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SCell_ToBeRemoved_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SCell_ToBeRemoved_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SCell_ToBeRemoved_Item_iE_Extensions__item__id),
        ('criticality', ___SCell_ToBeRemoved_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SCell_ToBeRemoved_Item_iE_Extensions__item__extensionValue),
        ])
    __SCell_ToBeRemoved_Item_iE_Extensions__item_._ext = None
    _SCell_ToBeRemoved_Item_iE_Extensions._cont = __SCell_ToBeRemoved_Item_iE_Extensions__item_
    _SCell_ToBeRemoved_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SCell_ToBeRemoved_Item._cont = ASN1Dict([
        ('sCell-ID', _SCell_ToBeRemoved_Item_sCell_ID),
        ('iE-Extensions', _SCell_ToBeRemoved_Item_iE_Extensions),
        ])
    SCell_ToBeRemoved_Item._ext = []
    
    #-----< SCell-ToBeRemoved-ItemExtIEs >-----#
    SCell_ToBeRemoved_ItemExtIEs = CLASS(name='SCell-ToBeRemoved-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SCell_ToBeRemoved_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SCell-ToBeSetup-Item >-----#
    SCell_ToBeSetup_Item = SEQ(name='SCell-ToBeSetup-Item', mode=MODE_TYPE)
    _SCell_ToBeSetup_Item_sCell_ID = SEQ(name='sCell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _SCell_ToBeSetup_Item_sCellIndex = INT(name='sCellIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SCellIndex')))
    _SCell_ToBeSetup_Item_sCellULConfigured = ENUM(name='sCellULConfigured', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CellULConfigured')), opt=True)
    _SCell_ToBeSetup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SCell_ToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SCell_ToBeSetup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SCell_ToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____SCell_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServingCellMO')))
    ____SCell_ToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 182), ('criticality', 'ignore'), ('Extension', _____SCell_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SCell_ToBeSetup_Item_iE_Extensions__item__id._const_tab = ____SCell_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___SCell_ToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___SCell_ToBeSetup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SCell_ToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SCell_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____SCell_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___SCell_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SCell_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SCell_ToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SCell_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____SCell_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___SCell_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SCell_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SCell_ToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SCell_ToBeSetup_Item_iE_Extensions__item__id),
        ('criticality', ___SCell_ToBeSetup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SCell_ToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __SCell_ToBeSetup_Item_iE_Extensions__item_._ext = None
    _SCell_ToBeSetup_Item_iE_Extensions._cont = __SCell_ToBeSetup_Item_iE_Extensions__item_
    _SCell_ToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SCell_ToBeSetup_Item._cont = ASN1Dict([
        ('sCell-ID', _SCell_ToBeSetup_Item_sCell_ID),
        ('sCellIndex', _SCell_ToBeSetup_Item_sCellIndex),
        ('sCellULConfigured', _SCell_ToBeSetup_Item_sCellULConfigured),
        ('iE-Extensions', _SCell_ToBeSetup_Item_iE_Extensions),
        ])
    SCell_ToBeSetup_Item._ext = []
    
    #-----< SCell-ToBeSetup-ItemExtIEs >-----#
    SCell_ToBeSetup_ItemExtIEs = CLASS(name='SCell-ToBeSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _SCell_ToBeSetup_ItemExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServingCellMO')))
    SCell_ToBeSetup_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 182), ('criticality', 'ignore'), ('Extension', _SCell_ToBeSetup_ItemExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SCell-ToBeSetupMod-Item >-----#
    SCell_ToBeSetupMod_Item = SEQ(name='SCell-ToBeSetupMod-Item', mode=MODE_TYPE)
    _SCell_ToBeSetupMod_Item_sCell_ID = SEQ(name='sCell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _SCell_ToBeSetupMod_Item_sCellIndex = INT(name='sCellIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SCellIndex')))
    _SCell_ToBeSetupMod_Item_sCellULConfigured = ENUM(name='sCellULConfigured', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'CellULConfigured')), opt=True)
    _SCell_ToBeSetupMod_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SCell_ToBeSetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SCell_ToBeSetupMod_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SCell_ToBeSetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____SCell_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServingCellMO')))
    ____SCell_ToBeSetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 182), ('criticality', 'ignore'), ('Extension', _____SCell_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SCell_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab = ____SCell_ToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___SCell_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___SCell_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SCell_ToBeSetupMod_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SCell_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab = ____SCell_ToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___SCell_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SCell_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SCell_ToBeSetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SCell_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____SCell_ToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___SCell_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SCell_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SCell_ToBeSetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SCell_ToBeSetupMod_Item_iE_Extensions__item__id),
        ('criticality', ___SCell_ToBeSetupMod_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SCell_ToBeSetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __SCell_ToBeSetupMod_Item_iE_Extensions__item_._ext = None
    _SCell_ToBeSetupMod_Item_iE_Extensions._cont = __SCell_ToBeSetupMod_Item_iE_Extensions__item_
    _SCell_ToBeSetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SCell_ToBeSetupMod_Item._cont = ASN1Dict([
        ('sCell-ID', _SCell_ToBeSetupMod_Item_sCell_ID),
        ('sCellIndex', _SCell_ToBeSetupMod_Item_sCellIndex),
        ('sCellULConfigured', _SCell_ToBeSetupMod_Item_sCellULConfigured),
        ('iE-Extensions', _SCell_ToBeSetupMod_Item_iE_Extensions),
        ])
    SCell_ToBeSetupMod_Item._ext = []
    
    #-----< SCell-ToBeSetupMod-ItemExtIEs >-----#
    SCell_ToBeSetupMod_ItemExtIEs = CLASS(name='SCell-ToBeSetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _SCell_ToBeSetupMod_ItemExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServingCellMO')))
    SCell_ToBeSetupMod_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 182), ('criticality', 'ignore'), ('Extension', _SCell_ToBeSetupMod_ItemExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SCellIndex >-----#
    SCellIndex = INT(name='SCellIndex', mode=MODE_TYPE)
    SCellIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=31)], ev=[], er=[])
    
    #-----< SCGActivationRequest >-----#
    SCGActivationRequest = ENUM(name='SCGActivationRequest', mode=MODE_TYPE)
    SCGActivationRequest._cont = ASN1Dict([('activate-scg', 0), ('deactivate-scg', 1)])
    SCGActivationRequest._ext = []
    
    #-----< SCGActivationStatus >-----#
    SCGActivationStatus = ENUM(name='SCGActivationStatus', mode=MODE_TYPE)
    SCGActivationStatus._cont = ASN1Dict([('scg-activated', 0), ('scg-deactivated', 1)])
    SCGActivationStatus._ext = []
    
    #-----< SCGIndicator >-----#
    SCGIndicator = ENUM(name='SCGIndicator', mode=MODE_TYPE)
    SCGIndicator._cont = ASN1Dict([('released', 0)])
    SCGIndicator._ext = []
    
    #-----< SCS-480 >-----#
    SCS_480 = INT(name='SCS-480', mode=MODE_TYPE)
    SCS_480._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=319)], ev=None, er=[])
    
    #-----< SCS-960 >-----#
    SCS_960 = INT(name='SCS-960', mode=MODE_TYPE)
    SCS_960._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=639)], ev=None, er=[])
    
    #-----< SCS-SpecificCarrier >-----#
    SCS_SpecificCarrier = SEQ(name='SCS-SpecificCarrier', mode=MODE_TYPE)
    _SCS_SpecificCarrier_offsetToCarrier = INT(name='offsetToCarrier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SCS_SpecificCarrier_offsetToCarrier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2199)], ev=[], er=[])
    _SCS_SpecificCarrier_subcarrierSpacing = ENUM(name='subcarrierSpacing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SCS_SpecificCarrier_subcarrierSpacing._cont = ASN1Dict([('kHz15', 0), ('kHz30', 1), ('kHz60', 2), ('kHz120', 3), ('kHz480', 4), ('kHz960', 5)])
    _SCS_SpecificCarrier_subcarrierSpacing._ext = ['kHz480', 'kHz960']
    _SCS_SpecificCarrier_carrierBandwidth = INT(name='carrierBandwidth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SCS_SpecificCarrier_carrierBandwidth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=275)], ev=[], er=[])
    _SCS_SpecificCarrier_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SCS_SpecificCarrier_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SCS_SpecificCarrier_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SCS_SpecificCarrier_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SCS_SpecificCarrier_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCS_SpecificCarrier_iE_Extensions__item__id._const_tab = ____SCS_SpecificCarrier_iE_Extensions__item__id_tab
    ___SCS_SpecificCarrier_iE_Extensions__item__id._const_tab_at = None
    ___SCS_SpecificCarrier_iE_Extensions__item__id._const_tab_id = 'id'
    ___SCS_SpecificCarrier_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SCS_SpecificCarrier_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SCS_SpecificCarrier_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCS_SpecificCarrier_iE_Extensions__item__criticality._const_tab = ____SCS_SpecificCarrier_iE_Extensions__item__criticality_tab
    ___SCS_SpecificCarrier_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SCS_SpecificCarrier_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SCS_SpecificCarrier_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SCS_SpecificCarrier_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SCS_SpecificCarrier_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCS_SpecificCarrier_iE_Extensions__item__extensionValue._const_tab = ____SCS_SpecificCarrier_iE_Extensions__item__extensionValue_tab
    ___SCS_SpecificCarrier_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SCS_SpecificCarrier_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SCS_SpecificCarrier_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SCS_SpecificCarrier_iE_Extensions__item__id),
        ('criticality', ___SCS_SpecificCarrier_iE_Extensions__item__criticality),
        ('extensionValue', ___SCS_SpecificCarrier_iE_Extensions__item__extensionValue),
        ])
    __SCS_SpecificCarrier_iE_Extensions__item_._ext = None
    _SCS_SpecificCarrier_iE_Extensions._cont = __SCS_SpecificCarrier_iE_Extensions__item_
    _SCS_SpecificCarrier_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SCS_SpecificCarrier._cont = ASN1Dict([
        ('offsetToCarrier', _SCS_SpecificCarrier_offsetToCarrier),
        ('subcarrierSpacing', _SCS_SpecificCarrier_subcarrierSpacing),
        ('carrierBandwidth', _SCS_SpecificCarrier_carrierBandwidth),
        ('iE-Extensions', _SCS_SpecificCarrier_iE_Extensions),
        ])
    SCS_SpecificCarrier._ext = None
    
    #-----< SCS-SpecificCarrier-ExtIEs >-----#
    SCS_SpecificCarrier_ExtIEs = CLASS(name='SCS-SpecificCarrier-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SCS_SpecificCarrier_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SDTBearerConfigurationQueryIndication >-----#
    SDTBearerConfigurationQueryIndication = ENUM(name='SDTBearerConfigurationQueryIndication', mode=MODE_TYPE)
    SDTBearerConfigurationQueryIndication._cont = ASN1Dict([('true', 0)])
    SDTBearerConfigurationQueryIndication._ext = []
    
    #-----< SDTBearerConfigurationInfo >-----#
    SDTBearerConfigurationInfo = SEQ(name='SDTBearerConfigurationInfo', mode=MODE_TYPE)
    _SDTBearerConfigurationInfo_sDTBearerConfig_List = SEQ_OF(name='sDTBearerConfig-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SDTBearerConfig-List')))
    _SDTBearerConfigurationInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SDTBearerConfigurationInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SDTBearerConfigurationInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SDTBearerConfigurationInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SDTBearerConfigurationInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SDTBearerConfigurationInfo_iE_Extensions__item__id._const_tab = ____SDTBearerConfigurationInfo_iE_Extensions__item__id_tab
    ___SDTBearerConfigurationInfo_iE_Extensions__item__id._const_tab_at = None
    ___SDTBearerConfigurationInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___SDTBearerConfigurationInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SDTBearerConfigurationInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SDTBearerConfigurationInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SDTBearerConfigurationInfo_iE_Extensions__item__criticality._const_tab = ____SDTBearerConfigurationInfo_iE_Extensions__item__criticality_tab
    ___SDTBearerConfigurationInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SDTBearerConfigurationInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SDTBearerConfigurationInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SDTBearerConfigurationInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SDTBearerConfigurationInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SDTBearerConfigurationInfo_iE_Extensions__item__extensionValue._const_tab = ____SDTBearerConfigurationInfo_iE_Extensions__item__extensionValue_tab
    ___SDTBearerConfigurationInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SDTBearerConfigurationInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SDTBearerConfigurationInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SDTBearerConfigurationInfo_iE_Extensions__item__id),
        ('criticality', ___SDTBearerConfigurationInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___SDTBearerConfigurationInfo_iE_Extensions__item__extensionValue),
        ])
    __SDTBearerConfigurationInfo_iE_Extensions__item_._ext = None
    _SDTBearerConfigurationInfo_iE_Extensions._cont = __SDTBearerConfigurationInfo_iE_Extensions__item_
    _SDTBearerConfigurationInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SDTBearerConfigurationInfo._cont = ASN1Dict([
        ('sDTBearerConfig-List', _SDTBearerConfigurationInfo_sDTBearerConfig_List),
        ('iE-Extensions', _SDTBearerConfigurationInfo_iE_Extensions),
        ])
    SDTBearerConfigurationInfo._ext = None
    
    #-----< SDTBearerConfigurationInfo-ExtIEs >-----#
    SDTBearerConfigurationInfo_ExtIEs = CLASS(name='SDTBearerConfigurationInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SDTBearerConfigurationInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SDTBearerConfig-List >-----#
    SDTBearerConfig_List = SEQ_OF(name='SDTBearerConfig-List', mode=MODE_TYPE)
    _SDTBearerConfig_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SDTBearerConfig-List-Item')))
    SDTBearerConfig_List._cont = _SDTBearerConfig_List__item_
    SDTBearerConfig_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=72)], ev=None, er=[])
    
    #-----< SDTBearerConfig-List-Item >-----#
    SDTBearerConfig_List_Item = SEQ(name='SDTBearerConfig-List-Item', mode=MODE_TYPE)
    _SDTBearerConfig_List_Item_sDTBearerType = CHOICE(name='sDTBearerType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SDTBearerType')))
    _SDTBearerConfig_List_Item_sDTRLCBearerConfiguration = OCT_STR(name='sDTRLCBearerConfiguration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SDTRLCBearerConfiguration')))
    _SDTBearerConfig_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SDTBearerConfig_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SDTBearerConfig_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SDTBearerConfig_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SDTBearerConfig_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SDTBearerConfig_List_Item_iE_Extensions__item__id._const_tab = ____SDTBearerConfig_List_Item_iE_Extensions__item__id_tab
    ___SDTBearerConfig_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___SDTBearerConfig_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SDTBearerConfig_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SDTBearerConfig_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SDTBearerConfig_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SDTBearerConfig_List_Item_iE_Extensions__item__criticality._const_tab = ____SDTBearerConfig_List_Item_iE_Extensions__item__criticality_tab
    ___SDTBearerConfig_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SDTBearerConfig_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SDTBearerConfig_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SDTBearerConfig_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SDTBearerConfig_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SDTBearerConfig_List_Item_iE_Extensions__item__extensionValue._const_tab = ____SDTBearerConfig_List_Item_iE_Extensions__item__extensionValue_tab
    ___SDTBearerConfig_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SDTBearerConfig_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SDTBearerConfig_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SDTBearerConfig_List_Item_iE_Extensions__item__id),
        ('criticality', ___SDTBearerConfig_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SDTBearerConfig_List_Item_iE_Extensions__item__extensionValue),
        ])
    __SDTBearerConfig_List_Item_iE_Extensions__item_._ext = None
    _SDTBearerConfig_List_Item_iE_Extensions._cont = __SDTBearerConfig_List_Item_iE_Extensions__item_
    _SDTBearerConfig_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SDTBearerConfig_List_Item._cont = ASN1Dict([
        ('sDTBearerType', _SDTBearerConfig_List_Item_sDTBearerType),
        ('sDTRLCBearerConfiguration', _SDTBearerConfig_List_Item_sDTRLCBearerConfiguration),
        ('iE-Extensions', _SDTBearerConfig_List_Item_iE_Extensions),
        ])
    SDTBearerConfig_List_Item._ext = None
    
    #-----< SDTBearerConfig-List-Item-ExtIEs >-----#
    SDTBearerConfig_List_Item_ExtIEs = CLASS(name='SDTBearerConfig-List-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SDTBearerConfig_List_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SDTBearerType >-----#
    SDTBearerType = CHOICE(name='SDTBearerType', mode=MODE_TYPE)
    _SDTBearerType_sRB = INT(name='sRB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _SDTBearerType_dRB = INT(name='dRB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DRBID')))
    _SDTBearerType_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SDTBearerType_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SDTBearerType_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SDTBearerType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SDTBearerType_choice_extension_id._const_tab = ___SDTBearerType_choice_extension_id_tab
    __SDTBearerType_choice_extension_id._const_tab_at = None
    __SDTBearerType_choice_extension_id._const_tab_id = 'id'
    __SDTBearerType_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___SDTBearerType_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SDTBearerType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SDTBearerType_choice_extension_criticality._const_tab = ___SDTBearerType_choice_extension_criticality_tab
    __SDTBearerType_choice_extension_criticality._const_tab_at = ('..', 'id')
    __SDTBearerType_choice_extension_criticality._const_tab_id = 'criticality'
    __SDTBearerType_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___SDTBearerType_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SDTBearerType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SDTBearerType_choice_extension_value._const_tab = ___SDTBearerType_choice_extension_value_tab
    __SDTBearerType_choice_extension_value._const_tab_at = ('..', 'id')
    __SDTBearerType_choice_extension_value._const_tab_id = 'Value'
    _SDTBearerType_choice_extension._cont = ASN1Dict([
        ('id', __SDTBearerType_choice_extension_id),
        ('criticality', __SDTBearerType_choice_extension_criticality),
        ('value', __SDTBearerType_choice_extension_value),
        ])
    _SDTBearerType_choice_extension._ext = None
    SDTBearerType._cont = ASN1Dict([
        ('sRB', _SDTBearerType_sRB),
        ('dRB', _SDTBearerType_dRB),
        ('choice-extension', _SDTBearerType_choice_extension),
        ])
    SDTBearerType._ext = None
    
    #-----< SDTBearerType-ExtIEs >-----#
    SDTBearerType_ExtIEs = CLASS(name='SDTBearerType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    SDTBearerType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SDT-MAC-PHY-CG-Config >-----#
    SDT_MAC_PHY_CG_Config = OCT_STR(name='SDT-MAC-PHY-CG-Config', mode=MODE_TYPE)
    
    #-----< SDTInformation >-----#
    SDTInformation = SEQ(name='SDTInformation', mode=MODE_TYPE)
    _SDTInformation_sdtIndicator = ENUM(name='sdtIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SDTInformation_sdtIndicator._cont = ASN1Dict([('true', 0)])
    _SDTInformation_sdtIndicator._ext = []
    _SDTInformation_sdtAssistantInformation = ENUM(name='sdtAssistantInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SDTInformation_sdtAssistantInformation._cont = ASN1Dict([('singlepacket', 0), ('multiplepackets', 1)])
    _SDTInformation_sdtAssistantInformation._ext = []
    _SDTInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SDTInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SDTInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SDTInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SDTInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SDTInformation_iE_Extensions__item__id._const_tab = ____SDTInformation_iE_Extensions__item__id_tab
    ___SDTInformation_iE_Extensions__item__id._const_tab_at = None
    ___SDTInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___SDTInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SDTInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SDTInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SDTInformation_iE_Extensions__item__criticality._const_tab = ____SDTInformation_iE_Extensions__item__criticality_tab
    ___SDTInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SDTInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SDTInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SDTInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SDTInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SDTInformation_iE_Extensions__item__extensionValue._const_tab = ____SDTInformation_iE_Extensions__item__extensionValue_tab
    ___SDTInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SDTInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SDTInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SDTInformation_iE_Extensions__item__id),
        ('criticality', ___SDTInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___SDTInformation_iE_Extensions__item__extensionValue),
        ])
    __SDTInformation_iE_Extensions__item_._ext = None
    _SDTInformation_iE_Extensions._cont = __SDTInformation_iE_Extensions__item_
    _SDTInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SDTInformation._cont = ASN1Dict([
        ('sdtIndicator', _SDTInformation_sdtIndicator),
        ('sdtAssistantInformation', _SDTInformation_sdtAssistantInformation),
        ('iE-Extensions', _SDTInformation_iE_Extensions),
        ])
    SDTInformation._ext = None
    
    #-----< SDTInformation-ExtIEs >-----#
    SDTInformation_ExtIEs = CLASS(name='SDTInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SDTInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SDTRLCBearerConfiguration >-----#
    SDTRLCBearerConfiguration = OCT_STR(name='SDTRLCBearerConfiguration', mode=MODE_TYPE)
    
    #-----< SDT-Termination-Request >-----#
    SDT_Termination_Request = ENUM(name='SDT-Termination-Request', mode=MODE_TYPE)
    SDT_Termination_Request._cont = ASN1Dict([('radio-link-problem', 0), ('normal', 1)])
    SDT_Termination_Request._ext = []
    
    #-----< Search-window-information >-----#
    Search_window_information = SEQ(name='Search-window-information', mode=MODE_TYPE)
    _Search_window_information_expectedPropagationDelay = INT(name='expectedPropagationDelay', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Search_window_information_expectedPropagationDelay._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-3841, ub=3841)], ev=[], er=[])
    _Search_window_information_delayUncertainty = INT(name='delayUncertainty', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Search_window_information_delayUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=246)], ev=[], er=[])
    _Search_window_information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Search_window_information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Search_window_information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Search_window_information_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Search_window_information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Search_window_information_iE_Extensions__item__id._const_tab = ____Search_window_information_iE_Extensions__item__id_tab
    ___Search_window_information_iE_Extensions__item__id._const_tab_at = None
    ___Search_window_information_iE_Extensions__item__id._const_tab_id = 'id'
    ___Search_window_information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Search_window_information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Search_window_information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Search_window_information_iE_Extensions__item__criticality._const_tab = ____Search_window_information_iE_Extensions__item__criticality_tab
    ___Search_window_information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Search_window_information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Search_window_information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Search_window_information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Search_window_information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Search_window_information_iE_Extensions__item__extensionValue._const_tab = ____Search_window_information_iE_Extensions__item__extensionValue_tab
    ___Search_window_information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Search_window_information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Search_window_information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Search_window_information_iE_Extensions__item__id),
        ('criticality', ___Search_window_information_iE_Extensions__item__criticality),
        ('extensionValue', ___Search_window_information_iE_Extensions__item__extensionValue),
        ])
    __Search_window_information_iE_Extensions__item_._ext = None
    _Search_window_information_iE_Extensions._cont = __Search_window_information_iE_Extensions__item_
    _Search_window_information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Search_window_information._cont = ASN1Dict([
        ('expectedPropagationDelay', _Search_window_information_expectedPropagationDelay),
        ('delayUncertainty', _Search_window_information_delayUncertainty),
        ('iE-Extensions', _Search_window_information_iE_Extensions),
        ])
    Search_window_information._ext = None
    
    #-----< Search-window-information-ExtIEs >-----#
    Search_window_information_ExtIEs = CLASS(name='Search-window-information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Search_window_information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SerialNumber >-----#
    SerialNumber = BIT_STR(name='SerialNumber', mode=MODE_TYPE)
    SerialNumber._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< SIBType-PWS >-----#
    SIBType_PWS = INT(name='SIBType-PWS', mode=MODE_TYPE)
    SIBType_PWS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=8)], ev=[], er=[])
    
    #-----< SelectedBandCombinationIndex >-----#
    SelectedBandCombinationIndex = OCT_STR(name='SelectedBandCombinationIndex', mode=MODE_TYPE)
    
    #-----< SelectedFeatureSetEntryIndex >-----#
    SelectedFeatureSetEntryIndex = OCT_STR(name='SelectedFeatureSetEntryIndex', mode=MODE_TYPE)
    
    #-----< CG-ConfigInfo >-----#
    CG_ConfigInfo = OCT_STR(name='CG-ConfigInfo', mode=MODE_TYPE)
    
    #-----< ServCellIndex >-----#
    ServCellIndex = INT(name='ServCellIndex', mode=MODE_TYPE)
    ServCellIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=[], er=[])
    
    #-----< ServingCellMO >-----#
    ServingCellMO = INT(name='ServingCellMO', mode=MODE_TYPE)
    ServingCellMO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=[], er=[])
    
    #-----< ServingCellMO-List-Item >-----#
    ServingCellMO_List_Item = SEQ(name='ServingCellMO-List-Item', mode=MODE_TYPE)
    _ServingCellMO_List_Item_servingCellMO = INT(name='servingCellMO', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ServingCellMO')))
    _ServingCellMO_List_Item_sSB_Frequency = INT(name='sSB-Frequency', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ServingCellMO_List_Item_sSB_Frequency._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _ServingCellMO_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ServingCellMO_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ServingCellMO_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ServingCellMO_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ServingCellMO_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServingCellMO_List_Item_iE_Extensions__item__id._const_tab = ____ServingCellMO_List_Item_iE_Extensions__item__id_tab
    ___ServingCellMO_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___ServingCellMO_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ServingCellMO_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ServingCellMO_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ServingCellMO_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServingCellMO_List_Item_iE_Extensions__item__criticality._const_tab = ____ServingCellMO_List_Item_iE_Extensions__item__criticality_tab
    ___ServingCellMO_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ServingCellMO_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ServingCellMO_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ServingCellMO_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ServingCellMO_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServingCellMO_List_Item_iE_Extensions__item__extensionValue._const_tab = ____ServingCellMO_List_Item_iE_Extensions__item__extensionValue_tab
    ___ServingCellMO_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ServingCellMO_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ServingCellMO_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ServingCellMO_List_Item_iE_Extensions__item__id),
        ('criticality', ___ServingCellMO_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ServingCellMO_List_Item_iE_Extensions__item__extensionValue),
        ])
    __ServingCellMO_List_Item_iE_Extensions__item_._ext = None
    _ServingCellMO_List_Item_iE_Extensions._cont = __ServingCellMO_List_Item_iE_Extensions__item_
    _ServingCellMO_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ServingCellMO_List_Item._cont = ASN1Dict([
        ('servingCellMO', _ServingCellMO_List_Item_servingCellMO),
        ('sSB-Frequency', _ServingCellMO_List_Item_sSB_Frequency),
        ('iE-Extensions', _ServingCellMO_List_Item_iE_Extensions),
        ])
    ServingCellMO_List_Item._ext = None
    
    #-----< ServingCellMO-List-Item-ExtIEs >-----#
    ServingCellMO_List_Item_ExtIEs = CLASS(name='ServingCellMO-List-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ServingCellMO_List_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ServingCellMO-encoded-in-CGC-List >-----#
    ServingCellMO_encoded_in_CGC_List = SEQ_OF(name='ServingCellMO-encoded-in-CGC-List', mode=MODE_TYPE)
    _ServingCellMO_encoded_in_CGC_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServingCellMO-encoded-in-CGC-Item')))
    ServingCellMO_encoded_in_CGC_List._cont = _ServingCellMO_encoded_in_CGC_List__item_
    ServingCellMO_encoded_in_CGC_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ServingCellMO-encoded-in-CGC-Item >-----#
    ServingCellMO_encoded_in_CGC_Item = SEQ(name='ServingCellMO-encoded-in-CGC-Item', mode=MODE_TYPE)
    _ServingCellMO_encoded_in_CGC_Item_servingCellMO = INT(name='servingCellMO', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ServingCellMO')))
    _ServingCellMO_encoded_in_CGC_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__id._const_tab = ____ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__id_tab
    ___ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__id._const_tab_at = None
    ___ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__criticality._const_tab = ____ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__criticality_tab
    ___ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__extensionValue._const_tab = ____ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__extensionValue_tab
    ___ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__id),
        ('criticality', ___ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__extensionValue),
        ])
    __ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item_._ext = None
    _ServingCellMO_encoded_in_CGC_Item_iE_Extensions._cont = __ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item_
    _ServingCellMO_encoded_in_CGC_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ServingCellMO_encoded_in_CGC_Item._cont = ASN1Dict([
        ('servingCellMO', _ServingCellMO_encoded_in_CGC_Item_servingCellMO),
        ('iE-Extensions', _ServingCellMO_encoded_in_CGC_Item_iE_Extensions),
        ])
    ServingCellMO_encoded_in_CGC_Item._ext = []
    
    #-----< ServingCellMO-encoded-in-CGC-Item-ExtIEs >-----#
    ServingCellMO_encoded_in_CGC_Item_ExtIEs = CLASS(name='ServingCellMO-encoded-in-CGC-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ServingCellMO_encoded_in_CGC_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Served-Cell-Information >-----#
    Served_Cell_Information = SEQ(name='Served-Cell-Information', mode=MODE_TYPE)
    _Served_Cell_Information_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Served_Cell_Information_nRPCI = INT(name='nRPCI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRPCI')))
    _Served_Cell_Information_fiveGS_TAC = OCT_STR(name='fiveGS-TAC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FiveGS-TAC')), opt=True)
    _Served_Cell_Information_configured_EPS_TAC = OCT_STR(name='configured-EPS-TAC', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Configured-EPS-TAC')), opt=True)
    _Served_Cell_Information_servedPLMNs = SEQ_OF(name='servedPLMNs', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ServedPLMNs-List')))
    _Served_Cell_Information_nR_Mode_Info = CHOICE(name='nR-Mode-Info', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NR-Mode-Info')))
    _Served_Cell_Information_measurementTimingConfiguration = OCT_STR(name='measurementTimingConfiguration', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Served_Cell_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Served_Cell_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Served_Cell_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Served_Cell_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RANAC')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedServedPLMNs-List')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cell-Direction')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BPLMN-ID-Info-List')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellType')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ConfiguredTACIndication')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AggressorgNBSetID')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'VictimgNBSetID')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-Info-IAB-DU')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_9 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SSB-PositionsInBurst')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRPRACHConfig')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SFN-Offset')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_12 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NPNBroadcastInformation')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_13 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Supported-MBS-FSA-ID-List')))
    _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_14 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Redcap-Bcast-Information')))
    ____Served_Cell_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 139), ('criticality', 'ignore'), ('Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 196), ('criticality', 'ignore'), ('Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 201), ('criticality', 'ignore'), ('Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 223), ('criticality', 'ignore'), ('Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 232), ('criticality', 'ignore'), ('Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 425), ('criticality', 'ignore'), ('Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 251), ('criticality', 'ignore'), ('Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 252), ('criticality', 'ignore'), ('Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 290), ('criticality', 'ignore'), ('Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 357), ('criticality', 'ignore'), ('Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 358), ('criticality', 'ignore'), ('Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 429), ('criticality', 'ignore'), ('Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_11), ('presence', 'optional')]), dict([('id', 383), ('criticality', 'reject'), ('Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_12), ('presence', 'optional')]), dict([('id', 478), ('criticality', 'ignore'), ('Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_13), ('presence', 'optional')]), dict([('id', 579), ('criticality', 'ignore'), ('Extension', _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_14), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Served_Cell_Information_iE_Extensions__item__id._const_tab = ____Served_Cell_Information_iE_Extensions__item__id_tab
    ___Served_Cell_Information_iE_Extensions__item__id._const_tab_at = None
    ___Served_Cell_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___Served_Cell_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Served_Cell_Information_iE_Extensions__item__criticality._const_tab = ____Served_Cell_Information_iE_Extensions__item__id_tab
    ___Served_Cell_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Served_Cell_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Served_Cell_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Served_Cell_Information_iE_Extensions__item__extensionValue._const_tab = ____Served_Cell_Information_iE_Extensions__item__id_tab
    ___Served_Cell_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Served_Cell_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Served_Cell_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Served_Cell_Information_iE_Extensions__item__id),
        ('criticality', ___Served_Cell_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___Served_Cell_Information_iE_Extensions__item__extensionValue),
        ])
    __Served_Cell_Information_iE_Extensions__item_._ext = None
    _Served_Cell_Information_iE_Extensions._cont = __Served_Cell_Information_iE_Extensions__item_
    _Served_Cell_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Served_Cell_Information._cont = ASN1Dict([
        ('nRCGI', _Served_Cell_Information_nRCGI),
        ('nRPCI', _Served_Cell_Information_nRPCI),
        ('fiveGS-TAC', _Served_Cell_Information_fiveGS_TAC),
        ('configured-EPS-TAC', _Served_Cell_Information_configured_EPS_TAC),
        ('servedPLMNs', _Served_Cell_Information_servedPLMNs),
        ('nR-Mode-Info', _Served_Cell_Information_nR_Mode_Info),
        ('measurementTimingConfiguration', _Served_Cell_Information_measurementTimingConfiguration),
        ('iE-Extensions', _Served_Cell_Information_iE_Extensions),
        ])
    Served_Cell_Information._ext = []
    
    #-----< Served-Cell-Information-ExtIEs >-----#
    Served_Cell_Information_ExtIEs = CLASS(name='Served-Cell-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _Served_Cell_Information_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RANAC')))
    _Served_Cell_Information_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedServedPLMNs-List')))
    _Served_Cell_Information_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cell-Direction')))
    _Served_Cell_Information_ExtIEs_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BPLMN-ID-Info-List')))
    _Served_Cell_Information_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellType')))
    _Served_Cell_Information_ExtIEs_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ConfiguredTACIndication')))
    _Served_Cell_Information_ExtIEs_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AggressorgNBSetID')))
    _Served_Cell_Information_ExtIEs_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'VictimgNBSetID')))
    _Served_Cell_Information_ExtIEs_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-Info-IAB-DU')))
    _Served_Cell_Information_ExtIEs_val_Extension_9 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SSB-PositionsInBurst')))
    _Served_Cell_Information_ExtIEs_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRPRACHConfig')))
    _Served_Cell_Information_ExtIEs_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SFN-Offset')))
    _Served_Cell_Information_ExtIEs_val_Extension_12 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NPNBroadcastInformation')))
    _Served_Cell_Information_ExtIEs_val_Extension_13 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Supported-MBS-FSA-ID-List')))
    _Served_Cell_Information_ExtIEs_val_Extension_14 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Redcap-Bcast-Information')))
    Served_Cell_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 139), ('criticality', 'ignore'), ('Extension', _Served_Cell_Information_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 196), ('criticality', 'ignore'), ('Extension', _Served_Cell_Information_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 201), ('criticality', 'ignore'), ('Extension', _Served_Cell_Information_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 223), ('criticality', 'ignore'), ('Extension', _Served_Cell_Information_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 232), ('criticality', 'ignore'), ('Extension', _Served_Cell_Information_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 425), ('criticality', 'ignore'), ('Extension', _Served_Cell_Information_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 251), ('criticality', 'ignore'), ('Extension', _Served_Cell_Information_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 252), ('criticality', 'ignore'), ('Extension', _Served_Cell_Information_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 290), ('criticality', 'ignore'), ('Extension', _Served_Cell_Information_ExtIEs_val_Extension_8), ('presence', 'optional')]), dict([('id', 357), ('criticality', 'ignore'), ('Extension', _Served_Cell_Information_ExtIEs_val_Extension_9), ('presence', 'optional')]), dict([('id', 358), ('criticality', 'ignore'), ('Extension', _Served_Cell_Information_ExtIEs_val_Extension_10), ('presence', 'optional')]), dict([('id', 429), ('criticality', 'ignore'), ('Extension', _Served_Cell_Information_ExtIEs_val_Extension_11), ('presence', 'optional')]), dict([('id', 383), ('criticality', 'reject'), ('Extension', _Served_Cell_Information_ExtIEs_val_Extension_12), ('presence', 'optional')]), dict([('id', 478), ('criticality', 'ignore'), ('Extension', _Served_Cell_Information_ExtIEs_val_Extension_13), ('presence', 'optional')]), dict([('id', 579), ('criticality', 'ignore'), ('Extension', _Served_Cell_Information_ExtIEs_val_Extension_14), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Serving-Cells-List >-----#
    Serving_Cells_List = SEQ_OF(name='Serving-Cells-List', mode=MODE_TYPE)
    _Serving_Cells_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Serving-Cells-List-Item')))
    Serving_Cells_List._cont = _Serving_Cells_List__item_
    Serving_Cells_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Serving-Cells-List-Item >-----#
    Serving_Cells_List_Item = SEQ(name='Serving-Cells-List-Item', mode=MODE_TYPE)
    _Serving_Cells_List_Item_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Serving_Cells_List_Item_iAB_MT_Cell_NA_Resource_Configuration_Mode_Info = CHOICE(name='iAB-MT-Cell-NA-Resource-Configuration-Mode-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IAB-MT-Cell-NA-Resource-Configuration-Mode-Info')), opt=True)
    _Serving_Cells_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Serving_Cells_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Serving_Cells_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Serving_Cells_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Serving_Cells_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Serving_Cells_List_Item_iE_Extensions__item__id._const_tab = ____Serving_Cells_List_Item_iE_Extensions__item__id_tab
    ___Serving_Cells_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___Serving_Cells_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Serving_Cells_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Serving_Cells_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Serving_Cells_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Serving_Cells_List_Item_iE_Extensions__item__criticality._const_tab = ____Serving_Cells_List_Item_iE_Extensions__item__criticality_tab
    ___Serving_Cells_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Serving_Cells_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Serving_Cells_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Serving_Cells_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Serving_Cells_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Serving_Cells_List_Item_iE_Extensions__item__extensionValue._const_tab = ____Serving_Cells_List_Item_iE_Extensions__item__extensionValue_tab
    ___Serving_Cells_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Serving_Cells_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Serving_Cells_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Serving_Cells_List_Item_iE_Extensions__item__id),
        ('criticality', ___Serving_Cells_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Serving_Cells_List_Item_iE_Extensions__item__extensionValue),
        ])
    __Serving_Cells_List_Item_iE_Extensions__item_._ext = None
    _Serving_Cells_List_Item_iE_Extensions._cont = __Serving_Cells_List_Item_iE_Extensions__item_
    _Serving_Cells_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Serving_Cells_List_Item._cont = ASN1Dict([
        ('nRCGI', _Serving_Cells_List_Item_nRCGI),
        ('iAB-MT-Cell-NA-Resource-Configuration-Mode-Info', _Serving_Cells_List_Item_iAB_MT_Cell_NA_Resource_Configuration_Mode_Info),
        ('iE-Extensions', _Serving_Cells_List_Item_iE_Extensions),
        ])
    Serving_Cells_List_Item._ext = None
    
    #-----< Serving-Cells-List-Item-ExtIEs >-----#
    Serving_Cells_List_Item_ExtIEs = CLASS(name='Serving-Cells-List-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Serving_Cells_List_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Supported-MBS-FSA-ID-List >-----#
    Supported_MBS_FSA_ID_List = SEQ_OF(name='Supported-MBS-FSA-ID-List', mode=MODE_TYPE)
    _Supported_MBS_FSA_ID_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-FrequencySelectionArea-Identity')))
    Supported_MBS_FSA_ID_List._cont = _Supported_MBS_FSA_ID_List__item_
    Supported_MBS_FSA_ID_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< MBS-FrequencySelectionArea-Identity >-----#
    MBS_FrequencySelectionArea_Identity = OCT_STR(name='MBS-FrequencySelectionArea-Identity', mode=MODE_TYPE)
    MBS_FrequencySelectionArea_Identity._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< SFN-Offset >-----#
    SFN_Offset = SEQ(name='SFN-Offset', mode=MODE_TYPE)
    _SFN_Offset_sFN_Time_Offset = BIT_STR(name='sFN-Time-Offset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SFN_Offset_sFN_Time_Offset._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _SFN_Offset_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SFN_Offset_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SFN_Offset_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SFN_Offset_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SFN_Offset_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFN_Offset_iE_Extensions__item__id._const_tab = ____SFN_Offset_iE_Extensions__item__id_tab
    ___SFN_Offset_iE_Extensions__item__id._const_tab_at = None
    ___SFN_Offset_iE_Extensions__item__id._const_tab_id = 'id'
    ___SFN_Offset_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SFN_Offset_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SFN_Offset_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFN_Offset_iE_Extensions__item__criticality._const_tab = ____SFN_Offset_iE_Extensions__item__criticality_tab
    ___SFN_Offset_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SFN_Offset_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SFN_Offset_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SFN_Offset_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SFN_Offset_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFN_Offset_iE_Extensions__item__extensionValue._const_tab = ____SFN_Offset_iE_Extensions__item__extensionValue_tab
    ___SFN_Offset_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SFN_Offset_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SFN_Offset_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SFN_Offset_iE_Extensions__item__id),
        ('criticality', ___SFN_Offset_iE_Extensions__item__criticality),
        ('extensionValue', ___SFN_Offset_iE_Extensions__item__extensionValue),
        ])
    __SFN_Offset_iE_Extensions__item_._ext = None
    _SFN_Offset_iE_Extensions._cont = __SFN_Offset_iE_Extensions__item_
    _SFN_Offset_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SFN_Offset._cont = ASN1Dict([
        ('sFN-Time-Offset', _SFN_Offset_sFN_Time_Offset),
        ('iE-Extensions', _SFN_Offset_iE_Extensions),
        ])
    SFN_Offset._ext = []
    
    #-----< SFN-Offset-ExtIEs >-----#
    SFN_Offset_ExtIEs = CLASS(name='SFN-Offset-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SFN_Offset_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Served-Cells-To-Add-Item >-----#
    Served_Cells_To_Add_Item = SEQ(name='Served-Cells-To-Add-Item', mode=MODE_TYPE)
    _Served_Cells_To_Add_Item_served_Cell_Information = SEQ(name='served-Cell-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Served-Cell-Information')))
    _Served_Cells_To_Add_Item_gNB_DU_System_Information = SEQ(name='gNB-DU-System-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-System-Information')), opt=True)
    _Served_Cells_To_Add_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Served_Cells_To_Add_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Served_Cells_To_Add_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Served_Cells_To_Add_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Served_Cells_To_Add_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Served_Cells_To_Add_Item_iE_Extensions__item__id._const_tab = ____Served_Cells_To_Add_Item_iE_Extensions__item__id_tab
    ___Served_Cells_To_Add_Item_iE_Extensions__item__id._const_tab_at = None
    ___Served_Cells_To_Add_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Served_Cells_To_Add_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Served_Cells_To_Add_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Served_Cells_To_Add_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Served_Cells_To_Add_Item_iE_Extensions__item__criticality._const_tab = ____Served_Cells_To_Add_Item_iE_Extensions__item__criticality_tab
    ___Served_Cells_To_Add_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Served_Cells_To_Add_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Served_Cells_To_Add_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Served_Cells_To_Add_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Served_Cells_To_Add_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Served_Cells_To_Add_Item_iE_Extensions__item__extensionValue._const_tab = ____Served_Cells_To_Add_Item_iE_Extensions__item__extensionValue_tab
    ___Served_Cells_To_Add_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Served_Cells_To_Add_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Served_Cells_To_Add_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Served_Cells_To_Add_Item_iE_Extensions__item__id),
        ('criticality', ___Served_Cells_To_Add_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Served_Cells_To_Add_Item_iE_Extensions__item__extensionValue),
        ])
    __Served_Cells_To_Add_Item_iE_Extensions__item_._ext = None
    _Served_Cells_To_Add_Item_iE_Extensions._cont = __Served_Cells_To_Add_Item_iE_Extensions__item_
    _Served_Cells_To_Add_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Served_Cells_To_Add_Item._cont = ASN1Dict([
        ('served-Cell-Information', _Served_Cells_To_Add_Item_served_Cell_Information),
        ('gNB-DU-System-Information', _Served_Cells_To_Add_Item_gNB_DU_System_Information),
        ('iE-Extensions', _Served_Cells_To_Add_Item_iE_Extensions),
        ])
    Served_Cells_To_Add_Item._ext = []
    
    #-----< Served-Cells-To-Add-ItemExtIEs >-----#
    Served_Cells_To_Add_ItemExtIEs = CLASS(name='Served-Cells-To-Add-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Served_Cells_To_Add_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Served-Cells-To-Delete-Item >-----#
    Served_Cells_To_Delete_Item = SEQ(name='Served-Cells-To-Delete-Item', mode=MODE_TYPE)
    _Served_Cells_To_Delete_Item_oldNRCGI = SEQ(name='oldNRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Served_Cells_To_Delete_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Served_Cells_To_Delete_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Served_Cells_To_Delete_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Served_Cells_To_Delete_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Served_Cells_To_Delete_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Served_Cells_To_Delete_Item_iE_Extensions__item__id._const_tab = ____Served_Cells_To_Delete_Item_iE_Extensions__item__id_tab
    ___Served_Cells_To_Delete_Item_iE_Extensions__item__id._const_tab_at = None
    ___Served_Cells_To_Delete_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Served_Cells_To_Delete_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Served_Cells_To_Delete_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Served_Cells_To_Delete_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Served_Cells_To_Delete_Item_iE_Extensions__item__criticality._const_tab = ____Served_Cells_To_Delete_Item_iE_Extensions__item__criticality_tab
    ___Served_Cells_To_Delete_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Served_Cells_To_Delete_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Served_Cells_To_Delete_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Served_Cells_To_Delete_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Served_Cells_To_Delete_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Served_Cells_To_Delete_Item_iE_Extensions__item__extensionValue._const_tab = ____Served_Cells_To_Delete_Item_iE_Extensions__item__extensionValue_tab
    ___Served_Cells_To_Delete_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Served_Cells_To_Delete_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Served_Cells_To_Delete_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Served_Cells_To_Delete_Item_iE_Extensions__item__id),
        ('criticality', ___Served_Cells_To_Delete_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Served_Cells_To_Delete_Item_iE_Extensions__item__extensionValue),
        ])
    __Served_Cells_To_Delete_Item_iE_Extensions__item_._ext = None
    _Served_Cells_To_Delete_Item_iE_Extensions._cont = __Served_Cells_To_Delete_Item_iE_Extensions__item_
    _Served_Cells_To_Delete_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Served_Cells_To_Delete_Item._cont = ASN1Dict([
        ('oldNRCGI', _Served_Cells_To_Delete_Item_oldNRCGI),
        ('iE-Extensions', _Served_Cells_To_Delete_Item_iE_Extensions),
        ])
    Served_Cells_To_Delete_Item._ext = []
    
    #-----< Served-Cells-To-Delete-ItemExtIEs >-----#
    Served_Cells_To_Delete_ItemExtIEs = CLASS(name='Served-Cells-To-Delete-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Served_Cells_To_Delete_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Served-Cells-To-Modify-Item >-----#
    Served_Cells_To_Modify_Item = SEQ(name='Served-Cells-To-Modify-Item', mode=MODE_TYPE)
    _Served_Cells_To_Modify_Item_oldNRCGI = SEQ(name='oldNRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _Served_Cells_To_Modify_Item_served_Cell_Information = SEQ(name='served-Cell-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Served-Cell-Information')))
    _Served_Cells_To_Modify_Item_gNB_DU_System_Information = SEQ(name='gNB-DU-System-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-System-Information')), opt=True)
    _Served_Cells_To_Modify_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Served_Cells_To_Modify_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Served_Cells_To_Modify_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Served_Cells_To_Modify_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Served_Cells_To_Modify_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Served_Cells_To_Modify_Item_iE_Extensions__item__id._const_tab = ____Served_Cells_To_Modify_Item_iE_Extensions__item__id_tab
    ___Served_Cells_To_Modify_Item_iE_Extensions__item__id._const_tab_at = None
    ___Served_Cells_To_Modify_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Served_Cells_To_Modify_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Served_Cells_To_Modify_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Served_Cells_To_Modify_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Served_Cells_To_Modify_Item_iE_Extensions__item__criticality._const_tab = ____Served_Cells_To_Modify_Item_iE_Extensions__item__criticality_tab
    ___Served_Cells_To_Modify_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Served_Cells_To_Modify_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Served_Cells_To_Modify_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Served_Cells_To_Modify_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Served_Cells_To_Modify_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Served_Cells_To_Modify_Item_iE_Extensions__item__extensionValue._const_tab = ____Served_Cells_To_Modify_Item_iE_Extensions__item__extensionValue_tab
    ___Served_Cells_To_Modify_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Served_Cells_To_Modify_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Served_Cells_To_Modify_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Served_Cells_To_Modify_Item_iE_Extensions__item__id),
        ('criticality', ___Served_Cells_To_Modify_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Served_Cells_To_Modify_Item_iE_Extensions__item__extensionValue),
        ])
    __Served_Cells_To_Modify_Item_iE_Extensions__item_._ext = None
    _Served_Cells_To_Modify_Item_iE_Extensions._cont = __Served_Cells_To_Modify_Item_iE_Extensions__item_
    _Served_Cells_To_Modify_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Served_Cells_To_Modify_Item._cont = ASN1Dict([
        ('oldNRCGI', _Served_Cells_To_Modify_Item_oldNRCGI),
        ('served-Cell-Information', _Served_Cells_To_Modify_Item_served_Cell_Information),
        ('gNB-DU-System-Information', _Served_Cells_To_Modify_Item_gNB_DU_System_Information),
        ('iE-Extensions', _Served_Cells_To_Modify_Item_iE_Extensions),
        ])
    Served_Cells_To_Modify_Item._ext = []
    
    #-----< Served-Cells-To-Modify-ItemExtIEs >-----#
    Served_Cells_To_Modify_ItemExtIEs = CLASS(name='Served-Cells-To-Modify-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Served_Cells_To_Modify_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Served-EUTRA-Cells-Information >-----#
    Served_EUTRA_Cells_Information = SEQ(name='Served-EUTRA-Cells-Information', mode=MODE_TYPE)
    _Served_EUTRA_Cells_Information_eUTRA_Mode_Info = CHOICE(name='eUTRA-Mode-Info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-Mode-Info')))
    _Served_EUTRA_Cells_Information_protectedEUTRAResourceIndication = OCT_STR(name='protectedEUTRAResourceIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ProtectedEUTRAResourceIndication')))
    _Served_EUTRA_Cells_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Served_EUTRA_Cells_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Served_EUTRA_Cells_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Served_EUTRA_Cells_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Served_EUTRA_Cells_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Served_EUTRA_Cells_Information_iE_Extensions__item__id._const_tab = ____Served_EUTRA_Cells_Information_iE_Extensions__item__id_tab
    ___Served_EUTRA_Cells_Information_iE_Extensions__item__id._const_tab_at = None
    ___Served_EUTRA_Cells_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___Served_EUTRA_Cells_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Served_EUTRA_Cells_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Served_EUTRA_Cells_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Served_EUTRA_Cells_Information_iE_Extensions__item__criticality._const_tab = ____Served_EUTRA_Cells_Information_iE_Extensions__item__criticality_tab
    ___Served_EUTRA_Cells_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Served_EUTRA_Cells_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Served_EUTRA_Cells_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Served_EUTRA_Cells_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Served_EUTRA_Cells_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Served_EUTRA_Cells_Information_iE_Extensions__item__extensionValue._const_tab = ____Served_EUTRA_Cells_Information_iE_Extensions__item__extensionValue_tab
    ___Served_EUTRA_Cells_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Served_EUTRA_Cells_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Served_EUTRA_Cells_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Served_EUTRA_Cells_Information_iE_Extensions__item__id),
        ('criticality', ___Served_EUTRA_Cells_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___Served_EUTRA_Cells_Information_iE_Extensions__item__extensionValue),
        ])
    __Served_EUTRA_Cells_Information_iE_Extensions__item_._ext = None
    _Served_EUTRA_Cells_Information_iE_Extensions._cont = __Served_EUTRA_Cells_Information_iE_Extensions__item_
    _Served_EUTRA_Cells_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Served_EUTRA_Cells_Information._cont = ASN1Dict([
        ('eUTRA-Mode-Info', _Served_EUTRA_Cells_Information_eUTRA_Mode_Info),
        ('protectedEUTRAResourceIndication', _Served_EUTRA_Cells_Information_protectedEUTRAResourceIndication),
        ('iE-Extensions', _Served_EUTRA_Cells_Information_iE_Extensions),
        ])
    Served_EUTRA_Cells_Information._ext = []
    
    #-----< Served-EUTRA-Cell-Information-ExtIEs >-----#
    Served_EUTRA_Cell_Information_ExtIEs = CLASS(name='Served-EUTRA-Cell-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Served_EUTRA_Cell_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Service-State >-----#
    Service_State = ENUM(name='Service-State', mode=MODE_TYPE)
    Service_State._cont = ASN1Dict([('in-service', 0), ('out-of-service', 1)])
    Service_State._ext = []
    
    #-----< Service-Status >-----#
    Service_Status = SEQ(name='Service-Status', mode=MODE_TYPE)
    _Service_Status_service_state = ENUM(name='service-state', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Service-State')))
    _Service_Status_switchingOffOngoing = ENUM(name='switchingOffOngoing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Service_Status_switchingOffOngoing._cont = ASN1Dict([('true', 0)])
    _Service_Status_switchingOffOngoing._ext = []
    _Service_Status_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Service_Status_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Service_Status_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Service_Status_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Service_Status_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Service_Status_iE_Extensions__item__id._const_tab = ____Service_Status_iE_Extensions__item__id_tab
    ___Service_Status_iE_Extensions__item__id._const_tab_at = None
    ___Service_Status_iE_Extensions__item__id._const_tab_id = 'id'
    ___Service_Status_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Service_Status_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Service_Status_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Service_Status_iE_Extensions__item__criticality._const_tab = ____Service_Status_iE_Extensions__item__criticality_tab
    ___Service_Status_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Service_Status_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Service_Status_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Service_Status_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Service_Status_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Service_Status_iE_Extensions__item__extensionValue._const_tab = ____Service_Status_iE_Extensions__item__extensionValue_tab
    ___Service_Status_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Service_Status_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Service_Status_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Service_Status_iE_Extensions__item__id),
        ('criticality', ___Service_Status_iE_Extensions__item__criticality),
        ('extensionValue', ___Service_Status_iE_Extensions__item__extensionValue),
        ])
    __Service_Status_iE_Extensions__item_._ext = None
    _Service_Status_iE_Extensions._cont = __Service_Status_iE_Extensions__item_
    _Service_Status_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Service_Status._cont = ASN1Dict([
        ('service-state', _Service_Status_service_state),
        ('switchingOffOngoing', _Service_Status_switchingOffOngoing),
        ('iE-Extensions', _Service_Status_iE_Extensions),
        ])
    Service_Status._ext = []
    
    #-----< Service-Status-ExtIEs >-----#
    Service_Status_ExtIEs = CLASS(name='Service-Status-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Service_Status_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelativeTime1900 >-----#
    RelativeTime1900 = BIT_STR(name='RelativeTime1900', mode=MODE_TYPE)
    RelativeTime1900._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    
    #-----< ShortDRXCycleLength >-----#
    ShortDRXCycleLength = ENUM(name='ShortDRXCycleLength', mode=MODE_TYPE)
    ShortDRXCycleLength._cont = ASN1Dict([('ms2', 0), ('ms3', 1), ('ms4', 2), ('ms5', 3), ('ms6', 4), ('ms7', 5), ('ms8', 6), ('ms10', 7), ('ms14', 8), ('ms16', 9), ('ms20', 10), ('ms30', 11), ('ms32', 12), ('ms35', 13), ('ms40', 14), ('ms64', 15), ('ms80', 16), ('ms128', 17), ('ms160', 18), ('ms256', 19), ('ms320', 20), ('ms512', 21), ('ms640', 22)])
    ShortDRXCycleLength._ext = []
    
    #-----< ShortDRXCycleTimer >-----#
    ShortDRXCycleTimer = INT(name='ShortDRXCycleTimer', mode=MODE_TYPE)
    ShortDRXCycleTimer._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SIB1-message >-----#
    SIB1_message = OCT_STR(name='SIB1-message', mode=MODE_TYPE)
    
    #-----< SIB10-message >-----#
    SIB10_message = OCT_STR(name='SIB10-message', mode=MODE_TYPE)
    
    #-----< SIB12-message >-----#
    SIB12_message = OCT_STR(name='SIB12-message', mode=MODE_TYPE)
    
    #-----< SIB13-message >-----#
    SIB13_message = OCT_STR(name='SIB13-message', mode=MODE_TYPE)
    
    #-----< SIB14-message >-----#
    SIB14_message = OCT_STR(name='SIB14-message', mode=MODE_TYPE)
    
    #-----< SIB15-message >-----#
    SIB15_message = OCT_STR(name='SIB15-message', mode=MODE_TYPE)
    
    #-----< SIB17-message >-----#
    SIB17_message = OCT_STR(name='SIB17-message', mode=MODE_TYPE)
    
    #-----< SIB20-message >-----#
    SIB20_message = OCT_STR(name='SIB20-message', mode=MODE_TYPE)
    
    #-----< SItype >-----#
    SItype = INT(name='SItype', mode=MODE_TYPE)
    SItype._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    
    #-----< SItype-List >-----#
    SItype_List = SEQ_OF(name='SItype-List', mode=MODE_TYPE)
    _SItype_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SItype-Item')))
    SItype_List._cont = _SItype_List__item_
    SItype_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SItype-Item >-----#
    SItype_Item = SEQ(name='SItype-Item', mode=MODE_TYPE)
    _SItype_Item_sItype = INT(name='sItype', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SItype')))
    _SItype_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SItype_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SItype_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SItype_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SItype_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SItype_Item_iE_Extensions__item__id._const_tab = ____SItype_Item_iE_Extensions__item__id_tab
    ___SItype_Item_iE_Extensions__item__id._const_tab_at = None
    ___SItype_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SItype_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SItype_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SItype_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SItype_Item_iE_Extensions__item__criticality._const_tab = ____SItype_Item_iE_Extensions__item__criticality_tab
    ___SItype_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SItype_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SItype_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SItype_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SItype_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SItype_Item_iE_Extensions__item__extensionValue._const_tab = ____SItype_Item_iE_Extensions__item__extensionValue_tab
    ___SItype_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SItype_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SItype_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SItype_Item_iE_Extensions__item__id),
        ('criticality', ___SItype_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SItype_Item_iE_Extensions__item__extensionValue),
        ])
    __SItype_Item_iE_Extensions__item_._ext = None
    _SItype_Item_iE_Extensions._cont = __SItype_Item_iE_Extensions__item_
    _SItype_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SItype_Item._cont = ASN1Dict([
        ('sItype', _SItype_Item_sItype),
        ('iE-Extensions', _SItype_Item_iE_Extensions),
        ])
    SItype_Item._ext = None
    
    #-----< SItype-ItemExtIEs >-----#
    SItype_ItemExtIEs = CLASS(name='SItype-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SItype_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SibtypetobeupdatedListItem >-----#
    SibtypetobeupdatedListItem = SEQ(name='SibtypetobeupdatedListItem', mode=MODE_TYPE)
    _SibtypetobeupdatedListItem_sIBtype = INT(name='sIBtype', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SibtypetobeupdatedListItem_sIBtype._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=[], er=[])
    _SibtypetobeupdatedListItem_sIBmessage = OCT_STR(name='sIBmessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SibtypetobeupdatedListItem_valueTag = INT(name='valueTag', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SibtypetobeupdatedListItem_valueTag._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=[], er=[])
    _SibtypetobeupdatedListItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SibtypetobeupdatedListItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SibtypetobeupdatedListItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SibtypetobeupdatedListItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____SibtypetobeupdatedListItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AreaScope')))
    ____SibtypetobeupdatedListItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 240), ('criticality', 'ignore'), ('Extension', _____SibtypetobeupdatedListItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SibtypetobeupdatedListItem_iE_Extensions__item__id._const_tab = ____SibtypetobeupdatedListItem_iE_Extensions__item__id_tab
    ___SibtypetobeupdatedListItem_iE_Extensions__item__id._const_tab_at = None
    ___SibtypetobeupdatedListItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SibtypetobeupdatedListItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SibtypetobeupdatedListItem_iE_Extensions__item__criticality._const_tab = ____SibtypetobeupdatedListItem_iE_Extensions__item__id_tab
    ___SibtypetobeupdatedListItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SibtypetobeupdatedListItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SibtypetobeupdatedListItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SibtypetobeupdatedListItem_iE_Extensions__item__extensionValue._const_tab = ____SibtypetobeupdatedListItem_iE_Extensions__item__id_tab
    ___SibtypetobeupdatedListItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SibtypetobeupdatedListItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SibtypetobeupdatedListItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SibtypetobeupdatedListItem_iE_Extensions__item__id),
        ('criticality', ___SibtypetobeupdatedListItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SibtypetobeupdatedListItem_iE_Extensions__item__extensionValue),
        ])
    __SibtypetobeupdatedListItem_iE_Extensions__item_._ext = None
    _SibtypetobeupdatedListItem_iE_Extensions._cont = __SibtypetobeupdatedListItem_iE_Extensions__item_
    _SibtypetobeupdatedListItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SibtypetobeupdatedListItem._cont = ASN1Dict([
        ('sIBtype', _SibtypetobeupdatedListItem_sIBtype),
        ('sIBmessage', _SibtypetobeupdatedListItem_sIBmessage),
        ('valueTag', _SibtypetobeupdatedListItem_valueTag),
        ('iE-Extensions', _SibtypetobeupdatedListItem_iE_Extensions),
        ])
    SibtypetobeupdatedListItem._ext = []
    
    #-----< SibtypetobeupdatedListItem-ExtIEs >-----#
    SibtypetobeupdatedListItem_ExtIEs = CLASS(name='SibtypetobeupdatedListItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _SibtypetobeupdatedListItem_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AreaScope')))
    SibtypetobeupdatedListItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 240), ('criticality', 'ignore'), ('Extension', _SibtypetobeupdatedListItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SidelinkRelayConfiguration >-----#
    SidelinkRelayConfiguration = SEQ(name='SidelinkRelayConfiguration', mode=MODE_TYPE)
    _SidelinkRelayConfiguration_gNB_DU_UE_F1APIDofRelayUE = INT(name='gNB-DU-UE-F1APIDofRelayUE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _SidelinkRelayConfiguration_remoteUELocalID = INT(name='remoteUELocalID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RemoteUELocalID')))
    _SidelinkRelayConfiguration_sidelinkConfigurationContainer = OCT_STR(name='sidelinkConfigurationContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SidelinkConfigurationContainer')), opt=True)
    _SidelinkRelayConfiguration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SidelinkRelayConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SidelinkRelayConfiguration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SidelinkRelayConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SidelinkRelayConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SidelinkRelayConfiguration_iE_Extensions__item__id._const_tab = ____SidelinkRelayConfiguration_iE_Extensions__item__id_tab
    ___SidelinkRelayConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___SidelinkRelayConfiguration_iE_Extensions__item__id._const_tab_id = 'id'
    ___SidelinkRelayConfiguration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SidelinkRelayConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SidelinkRelayConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SidelinkRelayConfiguration_iE_Extensions__item__criticality._const_tab = ____SidelinkRelayConfiguration_iE_Extensions__item__criticality_tab
    ___SidelinkRelayConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SidelinkRelayConfiguration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SidelinkRelayConfiguration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SidelinkRelayConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SidelinkRelayConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SidelinkRelayConfiguration_iE_Extensions__item__extensionValue._const_tab = ____SidelinkRelayConfiguration_iE_Extensions__item__extensionValue_tab
    ___SidelinkRelayConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SidelinkRelayConfiguration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SidelinkRelayConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SidelinkRelayConfiguration_iE_Extensions__item__id),
        ('criticality', ___SidelinkRelayConfiguration_iE_Extensions__item__criticality),
        ('extensionValue', ___SidelinkRelayConfiguration_iE_Extensions__item__extensionValue),
        ])
    __SidelinkRelayConfiguration_iE_Extensions__item_._ext = None
    _SidelinkRelayConfiguration_iE_Extensions._cont = __SidelinkRelayConfiguration_iE_Extensions__item_
    _SidelinkRelayConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SidelinkRelayConfiguration._cont = ASN1Dict([
        ('gNB-DU-UE-F1APIDofRelayUE', _SidelinkRelayConfiguration_gNB_DU_UE_F1APIDofRelayUE),
        ('remoteUELocalID', _SidelinkRelayConfiguration_remoteUELocalID),
        ('sidelinkConfigurationContainer', _SidelinkRelayConfiguration_sidelinkConfigurationContainer),
        ('iE-Extensions', _SidelinkRelayConfiguration_iE_Extensions),
        ])
    SidelinkRelayConfiguration._ext = []
    
    #-----< SidelinkRelayConfiguration-ExtIEs >-----#
    SidelinkRelayConfiguration_ExtIEs = CLASS(name='SidelinkRelayConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SidelinkRelayConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SidelinkConfigurationContainer >-----#
    SidelinkConfigurationContainer = OCT_STR(name='SidelinkConfigurationContainer', mode=MODE_TYPE)
    
    #-----< SLDRBID >-----#
    SLDRBID = INT(name='SLDRBID', mode=MODE_TYPE)
    SLDRBID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=[], er=[])
    
    #-----< SLDRBInformation >-----#
    SLDRBInformation = SEQ(name='SLDRBInformation', mode=MODE_TYPE)
    _SLDRBInformation_sLDRB_QoS = SEQ(name='sLDRB-QoS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PC5QoSParameters')))
    _SLDRBInformation_flowsMappedToSLDRB_List = SEQ_OF(name='flowsMappedToSLDRB-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FlowsMappedToSLDRB-List')))
    SLDRBInformation._cont = ASN1Dict([
        ('sLDRB-QoS', _SLDRBInformation_sLDRB_QoS),
        ('flowsMappedToSLDRB-List', _SLDRBInformation_flowsMappedToSLDRB_List),
        ])
    SLDRBInformation._ext = []
    
    #-----< SLDRBs-FailedToBeModified-Item >-----#
    SLDRBs_FailedToBeModified_Item = SEQ(name='SLDRBs-FailedToBeModified-Item', mode=MODE_TYPE)
    _SLDRBs_FailedToBeModified_Item_sLDRBID = INT(name='sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_FailedToBeModified_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _SLDRBs_FailedToBeModified_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_FailedToBeModified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SLDRBs_FailedToBeModified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_FailedToBeModified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_FailedToBeModified_Item_iE_Extensions__item__id_tab
    ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SLDRBs_FailedToBeModified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_FailedToBeModified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_FailedToBeModified_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SLDRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SLDRBs_FailedToBeModified_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__id),
        ('criticality', ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_FailedToBeModified_Item_iE_Extensions__item_._ext = None
    _SLDRBs_FailedToBeModified_Item_iE_Extensions._cont = __SLDRBs_FailedToBeModified_Item_iE_Extensions__item_
    _SLDRBs_FailedToBeModified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_FailedToBeModified_Item._cont = ASN1Dict([
        ('sLDRBID', _SLDRBs_FailedToBeModified_Item_sLDRBID),
        ('cause', _SLDRBs_FailedToBeModified_Item_cause),
        ('iE-Extensions', _SLDRBs_FailedToBeModified_Item_iE_Extensions),
        ])
    SLDRBs_FailedToBeModified_Item._ext = None
    
    #-----< SLDRBs-FailedToBeModified-ItemExtIEs >-----#
    SLDRBs_FailedToBeModified_ItemExtIEs = CLASS(name='SLDRBs-FailedToBeModified-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_FailedToBeModified_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-FailedToBeSetup-Item >-----#
    SLDRBs_FailedToBeSetup_Item = SEQ(name='SLDRBs-FailedToBeSetup-Item', mode=MODE_TYPE)
    _SLDRBs_FailedToBeSetup_Item_sLDRBID = INT(name='sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_FailedToBeSetup_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _SLDRBs_FailedToBeSetup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_FailedToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab
    ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SLDRBs_FailedToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__id),
        ('criticality', ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_FailedToBeSetup_Item_iE_Extensions__item_._ext = None
    _SLDRBs_FailedToBeSetup_Item_iE_Extensions._cont = __SLDRBs_FailedToBeSetup_Item_iE_Extensions__item_
    _SLDRBs_FailedToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_FailedToBeSetup_Item._cont = ASN1Dict([
        ('sLDRBID', _SLDRBs_FailedToBeSetup_Item_sLDRBID),
        ('cause', _SLDRBs_FailedToBeSetup_Item_cause),
        ('iE-Extensions', _SLDRBs_FailedToBeSetup_Item_iE_Extensions),
        ])
    SLDRBs_FailedToBeSetup_Item._ext = None
    
    #-----< SLDRBs-FailedToBeSetup-ItemExtIEs >-----#
    SLDRBs_FailedToBeSetup_ItemExtIEs = CLASS(name='SLDRBs-FailedToBeSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_FailedToBeSetup_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-FailedToBeSetupMod-Item >-----#
    SLDRBs_FailedToBeSetupMod_Item = SEQ(name='SLDRBs-FailedToBeSetupMod-Item', mode=MODE_TYPE)
    _SLDRBs_FailedToBeSetupMod_Item_sLDRBID = INT(name='sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_FailedToBeSetupMod_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _SLDRBs_FailedToBeSetupMod_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id),
        ('criticality', ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item_._ext = None
    _SLDRBs_FailedToBeSetupMod_Item_iE_Extensions._cont = __SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item_
    _SLDRBs_FailedToBeSetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_FailedToBeSetupMod_Item._cont = ASN1Dict([
        ('sLDRBID', _SLDRBs_FailedToBeSetupMod_Item_sLDRBID),
        ('cause', _SLDRBs_FailedToBeSetupMod_Item_cause),
        ('iE-Extensions', _SLDRBs_FailedToBeSetupMod_Item_iE_Extensions),
        ])
    SLDRBs_FailedToBeSetupMod_Item._ext = None
    
    #-----< SLDRBs-FailedToBeSetupMod-ItemExtIEs >-----#
    SLDRBs_FailedToBeSetupMod_ItemExtIEs = CLASS(name='SLDRBs-FailedToBeSetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_FailedToBeSetupMod_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-Modified-Item >-----#
    SLDRBs_Modified_Item = SEQ(name='SLDRBs-Modified-Item', mode=MODE_TYPE)
    _SLDRBs_Modified_Item_sLDRBID = INT(name='sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_Modified_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_Modified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_Modified_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SLDRBs_Modified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_Modified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_Modified_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_Modified_Item_iE_Extensions__item__id_tab
    ___SLDRBs_Modified_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_Modified_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SLDRBs_Modified_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SLDRBs_Modified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_Modified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_Modified_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_Modified_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_Modified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SLDRBs_Modified_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SLDRBs_Modified_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SLDRBs_Modified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_Modified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_Modified_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_Modified_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_Modified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SLDRBs_Modified_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SLDRBs_Modified_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SLDRBs_Modified_Item_iE_Extensions__item__id),
        ('criticality', ___SLDRBs_Modified_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SLDRBs_Modified_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_Modified_Item_iE_Extensions__item_._ext = None
    _SLDRBs_Modified_Item_iE_Extensions._cont = __SLDRBs_Modified_Item_iE_Extensions__item_
    _SLDRBs_Modified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_Modified_Item._cont = ASN1Dict([
        ('sLDRBID', _SLDRBs_Modified_Item_sLDRBID),
        ('iE-Extensions', _SLDRBs_Modified_Item_iE_Extensions),
        ])
    SLDRBs_Modified_Item._ext = None
    
    #-----< SLDRBs-Modified-ItemExtIEs >-----#
    SLDRBs_Modified_ItemExtIEs = CLASS(name='SLDRBs-Modified-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_Modified_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-ModifiedConf-Item >-----#
    SLDRBs_ModifiedConf_Item = SEQ(name='SLDRBs-ModifiedConf-Item', mode=MODE_TYPE)
    _SLDRBs_ModifiedConf_Item_sLDRBID = INT(name='sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_ModifiedConf_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_ModifiedConf_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SLDRBs_ModifiedConf_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ModifiedConf_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_ModifiedConf_Item_iE_Extensions__item__id_tab
    ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SLDRBs_ModifiedConf_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ModifiedConf_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_ModifiedConf_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SLDRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SLDRBs_ModifiedConf_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__id),
        ('criticality', ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_ModifiedConf_Item_iE_Extensions__item_._ext = None
    _SLDRBs_ModifiedConf_Item_iE_Extensions._cont = __SLDRBs_ModifiedConf_Item_iE_Extensions__item_
    _SLDRBs_ModifiedConf_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_ModifiedConf_Item._cont = ASN1Dict([
        ('sLDRBID', _SLDRBs_ModifiedConf_Item_sLDRBID),
        ('iE-Extensions', _SLDRBs_ModifiedConf_Item_iE_Extensions),
        ])
    SLDRBs_ModifiedConf_Item._ext = None
    
    #-----< SLDRBs-ModifiedConf-ItemExtIEs >-----#
    SLDRBs_ModifiedConf_ItemExtIEs = CLASS(name='SLDRBs-ModifiedConf-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_ModifiedConf_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-Required-ToBeModified-Item >-----#
    SLDRBs_Required_ToBeModified_Item = SEQ(name='SLDRBs-Required-ToBeModified-Item', mode=MODE_TYPE)
    _SLDRBs_Required_ToBeModified_Item_sLDRBID = INT(name='sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_Required_ToBeModified_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_Required_ToBeModified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab
    ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SLDRBs_Required_ToBeModified_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__id),
        ('criticality', ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_Required_ToBeModified_Item_iE_Extensions__item_._ext = None
    _SLDRBs_Required_ToBeModified_Item_iE_Extensions._cont = __SLDRBs_Required_ToBeModified_Item_iE_Extensions__item_
    _SLDRBs_Required_ToBeModified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_Required_ToBeModified_Item._cont = ASN1Dict([
        ('sLDRBID', _SLDRBs_Required_ToBeModified_Item_sLDRBID),
        ('iE-Extensions', _SLDRBs_Required_ToBeModified_Item_iE_Extensions),
        ])
    SLDRBs_Required_ToBeModified_Item._ext = None
    
    #-----< SLDRBs-Required-ToBeModified-ItemExtIEs >-----#
    SLDRBs_Required_ToBeModified_ItemExtIEs = CLASS(name='SLDRBs-Required-ToBeModified-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_Required_ToBeModified_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-Required-ToBeReleased-Item >-----#
    SLDRBs_Required_ToBeReleased_Item = SEQ(name='SLDRBs-Required-ToBeReleased-Item', mode=MODE_TYPE)
    _SLDRBs_Required_ToBeReleased_Item_sLDRBID = INT(name='sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_Required_ToBeReleased_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__id_tab
    ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__id),
        ('criticality', ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item_._ext = None
    _SLDRBs_Required_ToBeReleased_Item_iE_Extensions._cont = __SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item_
    _SLDRBs_Required_ToBeReleased_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_Required_ToBeReleased_Item._cont = ASN1Dict([
        ('sLDRBID', _SLDRBs_Required_ToBeReleased_Item_sLDRBID),
        ('iE-Extensions', _SLDRBs_Required_ToBeReleased_Item_iE_Extensions),
        ])
    SLDRBs_Required_ToBeReleased_Item._ext = None
    
    #-----< SLDRBs-Required-ToBeReleased-ItemExtIEs >-----#
    SLDRBs_Required_ToBeReleased_ItemExtIEs = CLASS(name='SLDRBs-Required-ToBeReleased-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_Required_ToBeReleased_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-Setup-Item >-----#
    SLDRBs_Setup_Item = SEQ(name='SLDRBs-Setup-Item', mode=MODE_TYPE)
    _SLDRBs_Setup_Item_sLDRBID = INT(name='sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_Setup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_Setup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_Setup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SLDRBs_Setup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_Setup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_Setup_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_Setup_Item_iE_Extensions__item__id_tab
    ___SLDRBs_Setup_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_Setup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SLDRBs_Setup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SLDRBs_Setup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_Setup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_Setup_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_Setup_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_Setup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SLDRBs_Setup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SLDRBs_Setup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SLDRBs_Setup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_Setup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_Setup_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SLDRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SLDRBs_Setup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SLDRBs_Setup_Item_iE_Extensions__item__id),
        ('criticality', ___SLDRBs_Setup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SLDRBs_Setup_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_Setup_Item_iE_Extensions__item_._ext = None
    _SLDRBs_Setup_Item_iE_Extensions._cont = __SLDRBs_Setup_Item_iE_Extensions__item_
    _SLDRBs_Setup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_Setup_Item._cont = ASN1Dict([
        ('sLDRBID', _SLDRBs_Setup_Item_sLDRBID),
        ('iE-Extensions', _SLDRBs_Setup_Item_iE_Extensions),
        ])
    SLDRBs_Setup_Item._ext = None
    
    #-----< SLDRBs-Setup-ItemExtIEs >-----#
    SLDRBs_Setup_ItemExtIEs = CLASS(name='SLDRBs-Setup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_Setup_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-SetupMod-Item >-----#
    SLDRBs_SetupMod_Item = SEQ(name='SLDRBs-SetupMod-Item', mode=MODE_TYPE)
    _SLDRBs_SetupMod_Item_sLDRBID = INT(name='sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_SetupMod_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_SetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_SetupMod_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SLDRBs_SetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_SetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_SetupMod_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_SetupMod_Item_iE_Extensions__item__id_tab
    ___SLDRBs_SetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_SetupMod_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SLDRBs_SetupMod_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SLDRBs_SetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_SetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_SetupMod_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_SetupMod_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_SetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SLDRBs_SetupMod_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SLDRBs_SetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SLDRBs_SetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_SetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_SetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SLDRBs_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SLDRBs_SetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SLDRBs_SetupMod_Item_iE_Extensions__item__id),
        ('criticality', ___SLDRBs_SetupMod_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SLDRBs_SetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_SetupMod_Item_iE_Extensions__item_._ext = None
    _SLDRBs_SetupMod_Item_iE_Extensions._cont = __SLDRBs_SetupMod_Item_iE_Extensions__item_
    _SLDRBs_SetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_SetupMod_Item._cont = ASN1Dict([
        ('sLDRBID', _SLDRBs_SetupMod_Item_sLDRBID),
        ('iE-Extensions', _SLDRBs_SetupMod_Item_iE_Extensions),
        ])
    SLDRBs_SetupMod_Item._ext = None
    
    #-----< SLDRBs-SetupMod-ItemExtIEs >-----#
    SLDRBs_SetupMod_ItemExtIEs = CLASS(name='SLDRBs-SetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_SetupMod_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-ToBeModified-Item >-----#
    SLDRBs_ToBeModified_Item = SEQ(name='SLDRBs-ToBeModified-Item', mode=MODE_TYPE)
    _SLDRBs_ToBeModified_Item_sLDRBID = INT(name='sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_ToBeModified_Item_sLDRBInformation = SEQ(name='sLDRBInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBInformation')), opt=True)
    _SLDRBs_ToBeModified_Item_rLCMode = ENUM(name='rLCMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RLCMode')), opt=True)
    _SLDRBs_ToBeModified_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_ToBeModified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_ToBeModified_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SLDRBs_ToBeModified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ToBeModified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ToBeModified_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_ToBeModified_Item_iE_Extensions__item__id_tab
    ___SLDRBs_ToBeModified_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_ToBeModified_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SLDRBs_ToBeModified_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SLDRBs_ToBeModified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ToBeModified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ToBeModified_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_ToBeModified_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_ToBeModified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SLDRBs_ToBeModified_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SLDRBs_ToBeModified_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SLDRBs_ToBeModified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ToBeModified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_ToBeModified_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SLDRBs_ToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SLDRBs_ToBeModified_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SLDRBs_ToBeModified_Item_iE_Extensions__item__id),
        ('criticality', ___SLDRBs_ToBeModified_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SLDRBs_ToBeModified_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_ToBeModified_Item_iE_Extensions__item_._ext = None
    _SLDRBs_ToBeModified_Item_iE_Extensions._cont = __SLDRBs_ToBeModified_Item_iE_Extensions__item_
    _SLDRBs_ToBeModified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_ToBeModified_Item._cont = ASN1Dict([
        ('sLDRBID', _SLDRBs_ToBeModified_Item_sLDRBID),
        ('sLDRBInformation', _SLDRBs_ToBeModified_Item_sLDRBInformation),
        ('rLCMode', _SLDRBs_ToBeModified_Item_rLCMode),
        ('iE-Extensions', _SLDRBs_ToBeModified_Item_iE_Extensions),
        ])
    SLDRBs_ToBeModified_Item._ext = None
    
    #-----< SLDRBs-ToBeModified-ItemExtIEs >-----#
    SLDRBs_ToBeModified_ItemExtIEs = CLASS(name='SLDRBs-ToBeModified-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_ToBeModified_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-ToBeReleased-Item >-----#
    SLDRBs_ToBeReleased_Item = SEQ(name='SLDRBs-ToBeReleased-Item', mode=MODE_TYPE)
    _SLDRBs_ToBeReleased_Item_sLDRBID = INT(name='sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_ToBeReleased_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_ToBeReleased_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SLDRBs_ToBeReleased_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ToBeReleased_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_ToBeReleased_Item_iE_Extensions__item__id_tab
    ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SLDRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SLDRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SLDRBs_ToBeReleased_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__id),
        ('criticality', ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_ToBeReleased_Item_iE_Extensions__item_._ext = None
    _SLDRBs_ToBeReleased_Item_iE_Extensions._cont = __SLDRBs_ToBeReleased_Item_iE_Extensions__item_
    _SLDRBs_ToBeReleased_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_ToBeReleased_Item._cont = ASN1Dict([
        ('sLDRBID', _SLDRBs_ToBeReleased_Item_sLDRBID),
        ('iE-Extensions', _SLDRBs_ToBeReleased_Item_iE_Extensions),
        ])
    SLDRBs_ToBeReleased_Item._ext = None
    
    #-----< SLDRBs-ToBeReleased-ItemExtIEs >-----#
    SLDRBs_ToBeReleased_ItemExtIEs = CLASS(name='SLDRBs-ToBeReleased-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_ToBeReleased_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-ToBeSetup-Item >-----#
    SLDRBs_ToBeSetup_Item = SEQ(name='SLDRBs-ToBeSetup-Item', mode=MODE_TYPE)
    _SLDRBs_ToBeSetup_Item_sLDRBID = INT(name='sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_ToBeSetup_Item_sLDRBInformation = SEQ(name='sLDRBInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBInformation')))
    _SLDRBs_ToBeSetup_Item_rLCMode = ENUM(name='rLCMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RLCMode')))
    _SLDRBs_ToBeSetup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_ToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SLDRBs_ToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SLDRBs_ToBeSetup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ToBeSetup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_ToBeSetup_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SLDRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SLDRBs_ToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__id),
        ('criticality', ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_ToBeSetup_Item_iE_Extensions__item_._ext = None
    _SLDRBs_ToBeSetup_Item_iE_Extensions._cont = __SLDRBs_ToBeSetup_Item_iE_Extensions__item_
    _SLDRBs_ToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_ToBeSetup_Item._cont = ASN1Dict([
        ('sLDRBID', _SLDRBs_ToBeSetup_Item_sLDRBID),
        ('sLDRBInformation', _SLDRBs_ToBeSetup_Item_sLDRBInformation),
        ('rLCMode', _SLDRBs_ToBeSetup_Item_rLCMode),
        ('iE-Extensions', _SLDRBs_ToBeSetup_Item_iE_Extensions),
        ])
    SLDRBs_ToBeSetup_Item._ext = None
    
    #-----< SLDRBs-ToBeSetup-ItemExtIEs >-----#
    SLDRBs_ToBeSetup_ItemExtIEs = CLASS(name='SLDRBs-ToBeSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_ToBeSetup_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-ToBeSetupMod-Item >-----#
    SLDRBs_ToBeSetupMod_Item = SEQ(name='SLDRBs-ToBeSetupMod-Item', mode=MODE_TYPE)
    _SLDRBs_ToBeSetupMod_Item_sLDRBID = INT(name='sLDRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBID')))
    _SLDRBs_ToBeSetupMod_Item_sLDRBInformation = SEQ(name='sLDRBInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRBInformation')))
    _SLDRBs_ToBeSetupMod_Item_rLCMode = ENUM(name='rLCMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RLCMode')), opt=True)
    _SLDRBs_ToBeSetupMod_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRBs_ToBeSetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab = ____SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab = ____SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality_tab
    ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SLDRBs_ToBeSetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__id),
        ('criticality', ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __SLDRBs_ToBeSetupMod_Item_iE_Extensions__item_._ext = None
    _SLDRBs_ToBeSetupMod_Item_iE_Extensions._cont = __SLDRBs_ToBeSetupMod_Item_iE_Extensions__item_
    _SLDRBs_ToBeSetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRBs_ToBeSetupMod_Item._cont = ASN1Dict([
        ('sLDRBID', _SLDRBs_ToBeSetupMod_Item_sLDRBID),
        ('sLDRBInformation', _SLDRBs_ToBeSetupMod_Item_sLDRBInformation),
        ('rLCMode', _SLDRBs_ToBeSetupMod_Item_rLCMode),
        ('iE-Extensions', _SLDRBs_ToBeSetupMod_Item_iE_Extensions),
        ])
    SLDRBs_ToBeSetupMod_Item._ext = None
    
    #-----< SLDRBs-ToBeSetupMod-ItemExtIEs >-----#
    SLDRBs_ToBeSetupMod_ItemExtIEs = CLASS(name='SLDRBs-ToBeSetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRBs_ToBeSetupMod_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRXCycleList >-----#
    SLDRXCycleList = SEQ_OF(name='SLDRXCycleList', mode=MODE_TYPE)
    _SLDRXCycleList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRXCycleItem')))
    SLDRXCycleList._cont = _SLDRXCycleList__item_
    SLDRXCycleList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SLDRXCycleItem >-----#
    SLDRXCycleItem = SEQ(name='SLDRXCycleItem', mode=MODE_TYPE)
    _SLDRXCycleItem_rXUEID = BIT_STR(name='rXUEID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SLDRXCycleItem_rXUEID._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _SLDRXCycleItem_sLDRXInformation = CHOICE(name='sLDRXInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRXInformation')))
    _SLDRXCycleItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SLDRXCycleItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SLDRXCycleItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SLDRXCycleItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRXCycleItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRXCycleItem_iE_Extensions__item__id._const_tab = ____SLDRXCycleItem_iE_Extensions__item__id_tab
    ___SLDRXCycleItem_iE_Extensions__item__id._const_tab_at = None
    ___SLDRXCycleItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SLDRXCycleItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SLDRXCycleItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRXCycleItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRXCycleItem_iE_Extensions__item__criticality._const_tab = ____SLDRXCycleItem_iE_Extensions__item__criticality_tab
    ___SLDRXCycleItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SLDRXCycleItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SLDRXCycleItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SLDRXCycleItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SLDRXCycleItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SLDRXCycleItem_iE_Extensions__item__extensionValue._const_tab = ____SLDRXCycleItem_iE_Extensions__item__extensionValue_tab
    ___SLDRXCycleItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SLDRXCycleItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SLDRXCycleItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SLDRXCycleItem_iE_Extensions__item__id),
        ('criticality', ___SLDRXCycleItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SLDRXCycleItem_iE_Extensions__item__extensionValue),
        ])
    __SLDRXCycleItem_iE_Extensions__item_._ext = None
    _SLDRXCycleItem_iE_Extensions._cont = __SLDRXCycleItem_iE_Extensions__item_
    _SLDRXCycleItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SLDRXCycleItem._cont = ASN1Dict([
        ('rXUEID', _SLDRXCycleItem_rXUEID),
        ('sLDRXInformation', _SLDRXCycleItem_sLDRXInformation),
        ('iE-Extensions', _SLDRXCycleItem_iE_Extensions),
        ])
    SLDRXCycleItem._ext = []
    
    #-----< SLDRXCycleItem-ExtIEs >-----#
    SLDRXCycleItem_ExtIEs = CLASS(name='SLDRXCycleItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SLDRXCycleItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SLDRXInformation >-----#
    SLDRXInformation = CHOICE(name='SLDRXInformation', mode=MODE_TYPE)
    _SLDRXInformation_sLDRXCycle = ENUM(name='sLDRXCycle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRXCycleLength')))
    _SLDRXInformation_nosLDRX = ENUM(name='nosLDRX', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SLDRXConfigurationIndicator')))
    _SLDRXInformation_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRXInformation_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SLDRXInformation_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SLDRXInformation_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SLDRXInformation_choice_extension_id._const_tab = ___SLDRXInformation_choice_extension_id_tab
    __SLDRXInformation_choice_extension_id._const_tab_at = None
    __SLDRXInformation_choice_extension_id._const_tab_id = 'id'
    __SLDRXInformation_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___SLDRXInformation_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SLDRXInformation_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SLDRXInformation_choice_extension_criticality._const_tab = ___SLDRXInformation_choice_extension_criticality_tab
    __SLDRXInformation_choice_extension_criticality._const_tab_at = ('..', 'id')
    __SLDRXInformation_choice_extension_criticality._const_tab_id = 'criticality'
    __SLDRXInformation_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___SLDRXInformation_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SLDRXInformation_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SLDRXInformation_choice_extension_value._const_tab = ___SLDRXInformation_choice_extension_value_tab
    __SLDRXInformation_choice_extension_value._const_tab_at = ('..', 'id')
    __SLDRXInformation_choice_extension_value._const_tab_id = 'Value'
    _SLDRXInformation_choice_extension._cont = ASN1Dict([
        ('id', __SLDRXInformation_choice_extension_id),
        ('criticality', __SLDRXInformation_choice_extension_criticality),
        ('value', __SLDRXInformation_choice_extension_value),
        ])
    _SLDRXInformation_choice_extension._ext = None
    SLDRXInformation._cont = ASN1Dict([
        ('sLDRXCycle', _SLDRXInformation_sLDRXCycle),
        ('nosLDRX', _SLDRXInformation_nosLDRX),
        ('choice-extension', _SLDRXInformation_choice_extension),
        ])
    SLDRXInformation._ext = None
    
    #-----< SLDRXCycleLength >-----#
    SLDRXCycleLength = ENUM(name='SLDRXCycleLength', mode=MODE_TYPE)
    SLDRXCycleLength._cont = ASN1Dict([('ms10', 0), ('ms20', 1), ('ms32', 2), ('ms40', 3), ('ms60', 4), ('ms64', 5), ('ms70', 6), ('ms80', 7), ('ms128', 8), ('ms160', 9), ('ms256', 10), ('ms320', 11), ('ms512', 12), ('ms640', 13), ('ms1024', 14), ('ms1280', 15), ('ms2048', 16), ('ms2560', 17), ('ms5120', 18), ('ms10240', 19)])
    SLDRXCycleLength._ext = []
    
    #-----< SLDRXConfigurationIndicator >-----#
    SLDRXConfigurationIndicator = ENUM(name='SLDRXConfigurationIndicator', mode=MODE_TYPE)
    SLDRXConfigurationIndicator._cont = ASN1Dict([('release', 0)])
    SLDRXConfigurationIndicator._ext = []
    
    #-----< SLDRXInformation-ExtIEs >-----#
    SLDRXInformation_ExtIEs = CLASS(name='SLDRXInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    SLDRXInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SL-PHY-MAC-RLC-Config >-----#
    SL_PHY_MAC_RLC_Config = OCT_STR(name='SL-PHY-MAC-RLC-Config', mode=MODE_TYPE)
    
    #-----< SL-RLC-ChannelToAddModList >-----#
    SL_RLC_ChannelToAddModList = OCT_STR(name='SL-RLC-ChannelToAddModList', mode=MODE_TYPE)
    
    #-----< SL-ConfigDedicatedEUTRA-Info >-----#
    SL_ConfigDedicatedEUTRA_Info = OCT_STR(name='SL-ConfigDedicatedEUTRA-Info', mode=MODE_TYPE)
    
    #-----< SliceAvailableCapacity >-----#
    SliceAvailableCapacity = SEQ(name='SliceAvailableCapacity', mode=MODE_TYPE)
    _SliceAvailableCapacity_sliceAvailableCapacityList = SEQ_OF(name='sliceAvailableCapacityList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SliceAvailableCapacityList')))
    _SliceAvailableCapacity_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SliceAvailableCapacity_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SliceAvailableCapacity_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SliceAvailableCapacity_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceAvailableCapacity_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceAvailableCapacity_iE_Extensions__item__id._const_tab = ____SliceAvailableCapacity_iE_Extensions__item__id_tab
    ___SliceAvailableCapacity_iE_Extensions__item__id._const_tab_at = None
    ___SliceAvailableCapacity_iE_Extensions__item__id._const_tab_id = 'id'
    ___SliceAvailableCapacity_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SliceAvailableCapacity_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceAvailableCapacity_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceAvailableCapacity_iE_Extensions__item__criticality._const_tab = ____SliceAvailableCapacity_iE_Extensions__item__criticality_tab
    ___SliceAvailableCapacity_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SliceAvailableCapacity_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SliceAvailableCapacity_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SliceAvailableCapacity_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceAvailableCapacity_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceAvailableCapacity_iE_Extensions__item__extensionValue._const_tab = ____SliceAvailableCapacity_iE_Extensions__item__extensionValue_tab
    ___SliceAvailableCapacity_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SliceAvailableCapacity_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SliceAvailableCapacity_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SliceAvailableCapacity_iE_Extensions__item__id),
        ('criticality', ___SliceAvailableCapacity_iE_Extensions__item__criticality),
        ('extensionValue', ___SliceAvailableCapacity_iE_Extensions__item__extensionValue),
        ])
    __SliceAvailableCapacity_iE_Extensions__item_._ext = None
    _SliceAvailableCapacity_iE_Extensions._cont = __SliceAvailableCapacity_iE_Extensions__item_
    _SliceAvailableCapacity_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SliceAvailableCapacity._cont = ASN1Dict([
        ('sliceAvailableCapacityList', _SliceAvailableCapacity_sliceAvailableCapacityList),
        ('iE-Extensions', _SliceAvailableCapacity_iE_Extensions),
        ])
    SliceAvailableCapacity._ext = None
    
    #-----< SliceAvailableCapacity-ExtIEs >-----#
    SliceAvailableCapacity_ExtIEs = CLASS(name='SliceAvailableCapacity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SliceAvailableCapacity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SliceAvailableCapacityList >-----#
    SliceAvailableCapacityList = SEQ_OF(name='SliceAvailableCapacityList', mode=MODE_TYPE)
    _SliceAvailableCapacityList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SliceAvailableCapacityItem')))
    SliceAvailableCapacityList._cont = _SliceAvailableCapacityList__item_
    SliceAvailableCapacityList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< SliceAvailableCapacityItem >-----#
    SliceAvailableCapacityItem = SEQ(name='SliceAvailableCapacityItem', mode=MODE_TYPE)
    _SliceAvailableCapacityItem_pLMNIdentity = OCT_STR(name='pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _SliceAvailableCapacityItem_sNSSAIAvailableCapacity_List = SEQ_OF(name='sNSSAIAvailableCapacity-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SNSSAIAvailableCapacity-List')))
    _SliceAvailableCapacityItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SliceAvailableCapacityItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SliceAvailableCapacityItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SliceAvailableCapacityItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceAvailableCapacityItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceAvailableCapacityItem_iE_Extensions__item__id._const_tab = ____SliceAvailableCapacityItem_iE_Extensions__item__id_tab
    ___SliceAvailableCapacityItem_iE_Extensions__item__id._const_tab_at = None
    ___SliceAvailableCapacityItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SliceAvailableCapacityItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SliceAvailableCapacityItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceAvailableCapacityItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceAvailableCapacityItem_iE_Extensions__item__criticality._const_tab = ____SliceAvailableCapacityItem_iE_Extensions__item__criticality_tab
    ___SliceAvailableCapacityItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SliceAvailableCapacityItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SliceAvailableCapacityItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SliceAvailableCapacityItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceAvailableCapacityItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceAvailableCapacityItem_iE_Extensions__item__extensionValue._const_tab = ____SliceAvailableCapacityItem_iE_Extensions__item__extensionValue_tab
    ___SliceAvailableCapacityItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SliceAvailableCapacityItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SliceAvailableCapacityItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SliceAvailableCapacityItem_iE_Extensions__item__id),
        ('criticality', ___SliceAvailableCapacityItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SliceAvailableCapacityItem_iE_Extensions__item__extensionValue),
        ])
    __SliceAvailableCapacityItem_iE_Extensions__item_._ext = None
    _SliceAvailableCapacityItem_iE_Extensions._cont = __SliceAvailableCapacityItem_iE_Extensions__item_
    _SliceAvailableCapacityItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SliceAvailableCapacityItem._cont = ASN1Dict([
        ('pLMNIdentity', _SliceAvailableCapacityItem_pLMNIdentity),
        ('sNSSAIAvailableCapacity-List', _SliceAvailableCapacityItem_sNSSAIAvailableCapacity_List),
        ('iE-Extensions', _SliceAvailableCapacityItem_iE_Extensions),
        ])
    SliceAvailableCapacityItem._ext = None
    
    #-----< SliceAvailableCapacityItem-ExtIEs >-----#
    SliceAvailableCapacityItem_ExtIEs = CLASS(name='SliceAvailableCapacityItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SliceAvailableCapacityItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SNSSAIAvailableCapacity-List >-----#
    SNSSAIAvailableCapacity_List = SEQ_OF(name='SNSSAIAvailableCapacity-List', mode=MODE_TYPE)
    _SNSSAIAvailableCapacity_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SNSSAIAvailableCapacity-Item')))
    SNSSAIAvailableCapacity_List._cont = _SNSSAIAvailableCapacity_List__item_
    SNSSAIAvailableCapacity_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< SNSSAIAvailableCapacity-Item >-----#
    SNSSAIAvailableCapacity_Item = SEQ(name='SNSSAIAvailableCapacity-Item', mode=MODE_TYPE)
    _SNSSAIAvailableCapacity_Item_sNSSAI = SEQ(name='sNSSAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SNSSAI')))
    _SNSSAIAvailableCapacity_Item_sliceAvailableCapacityValueDownlink = INT(name='sliceAvailableCapacityValueDownlink', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SNSSAIAvailableCapacity_Item_sliceAvailableCapacityValueDownlink._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SNSSAIAvailableCapacity_Item_sliceAvailableCapacityValueUplink = INT(name='sliceAvailableCapacityValueUplink', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SNSSAIAvailableCapacity_Item_sliceAvailableCapacityValueUplink._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SNSSAIAvailableCapacity_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SNSSAIAvailableCapacity_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SNSSAIAvailableCapacity_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SNSSAIAvailableCapacity_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__id._const_tab = ____SNSSAIAvailableCapacity_Item_iE_Extensions__item__id_tab
    ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__id._const_tab_at = None
    ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SNSSAIAvailableCapacity_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SNSSAIAvailableCapacity_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__criticality._const_tab = ____SNSSAIAvailableCapacity_Item_iE_Extensions__item__criticality_tab
    ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SNSSAIAvailableCapacity_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SNSSAIAvailableCapacity_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__extensionValue._const_tab = ____SNSSAIAvailableCapacity_Item_iE_Extensions__item__extensionValue_tab
    ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SNSSAIAvailableCapacity_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__id),
        ('criticality', ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__extensionValue),
        ])
    __SNSSAIAvailableCapacity_Item_iE_Extensions__item_._ext = None
    _SNSSAIAvailableCapacity_Item_iE_Extensions._cont = __SNSSAIAvailableCapacity_Item_iE_Extensions__item_
    _SNSSAIAvailableCapacity_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SNSSAIAvailableCapacity_Item._cont = ASN1Dict([
        ('sNSSAI', _SNSSAIAvailableCapacity_Item_sNSSAI),
        ('sliceAvailableCapacityValueDownlink', _SNSSAIAvailableCapacity_Item_sliceAvailableCapacityValueDownlink),
        ('sliceAvailableCapacityValueUplink', _SNSSAIAvailableCapacity_Item_sliceAvailableCapacityValueUplink),
        ('iE-Extensions', _SNSSAIAvailableCapacity_Item_iE_Extensions),
        ])
    SNSSAIAvailableCapacity_Item._ext = None
    
    #-----< SNSSAIAvailableCapacity-Item-ExtIEs >-----#
    SNSSAIAvailableCapacity_Item_ExtIEs = CLASS(name='SNSSAIAvailableCapacity-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SNSSAIAvailableCapacity_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SliceRadioResourceStatus >-----#
    SliceRadioResourceStatus = SEQ(name='SliceRadioResourceStatus', mode=MODE_TYPE)
    _SliceRadioResourceStatus_sliceRadioResourceStatus = SEQ_OF(name='sliceRadioResourceStatus', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SliceRadioResourceStatus-List')))
    _SliceRadioResourceStatus_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SliceRadioResourceStatus_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SliceRadioResourceStatus_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SliceRadioResourceStatus_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceRadioResourceStatus_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceRadioResourceStatus_iE_Extensions__item__id._const_tab = ____SliceRadioResourceStatus_iE_Extensions__item__id_tab
    ___SliceRadioResourceStatus_iE_Extensions__item__id._const_tab_at = None
    ___SliceRadioResourceStatus_iE_Extensions__item__id._const_tab_id = 'id'
    ___SliceRadioResourceStatus_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SliceRadioResourceStatus_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceRadioResourceStatus_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceRadioResourceStatus_iE_Extensions__item__criticality._const_tab = ____SliceRadioResourceStatus_iE_Extensions__item__criticality_tab
    ___SliceRadioResourceStatus_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SliceRadioResourceStatus_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SliceRadioResourceStatus_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SliceRadioResourceStatus_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceRadioResourceStatus_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceRadioResourceStatus_iE_Extensions__item__extensionValue._const_tab = ____SliceRadioResourceStatus_iE_Extensions__item__extensionValue_tab
    ___SliceRadioResourceStatus_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SliceRadioResourceStatus_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SliceRadioResourceStatus_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SliceRadioResourceStatus_iE_Extensions__item__id),
        ('criticality', ___SliceRadioResourceStatus_iE_Extensions__item__criticality),
        ('extensionValue', ___SliceRadioResourceStatus_iE_Extensions__item__extensionValue),
        ])
    __SliceRadioResourceStatus_iE_Extensions__item_._ext = None
    _SliceRadioResourceStatus_iE_Extensions._cont = __SliceRadioResourceStatus_iE_Extensions__item_
    _SliceRadioResourceStatus_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SliceRadioResourceStatus._cont = ASN1Dict([
        ('sliceRadioResourceStatus', _SliceRadioResourceStatus_sliceRadioResourceStatus),
        ('iE-Extensions', _SliceRadioResourceStatus_iE_Extensions),
        ])
    SliceRadioResourceStatus._ext = None
    
    #-----< SliceRadioResourceStatus-ExtIEs >-----#
    SliceRadioResourceStatus_ExtIEs = CLASS(name='SliceRadioResourceStatus-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SliceRadioResourceStatus_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SliceRadioResourceStatus-List >-----#
    SliceRadioResourceStatus_List = SEQ_OF(name='SliceRadioResourceStatus-List', mode=MODE_TYPE)
    _SliceRadioResourceStatus_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SliceRadioResourceStatus-Item')))
    SliceRadioResourceStatus_List._cont = _SliceRadioResourceStatus_List__item_
    SliceRadioResourceStatus_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< SliceRadioResourceStatus-Item >-----#
    SliceRadioResourceStatus_Item = SEQ(name='SliceRadioResourceStatus-Item', mode=MODE_TYPE)
    _SliceRadioResourceStatus_Item_pLMNIdentity = OCT_STR(name='pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _SliceRadioResourceStatus_Item_sNSSAIRadioResourceStatus_List = SEQ_OF(name='sNSSAIRadioResourceStatus-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SNSSAIRadioResourceStatus-List')))
    _SliceRadioResourceStatus_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SliceRadioResourceStatus_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SliceRadioResourceStatus_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SliceRadioResourceStatus_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceRadioResourceStatus_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceRadioResourceStatus_Item_iE_Extensions__item__id._const_tab = ____SliceRadioResourceStatus_Item_iE_Extensions__item__id_tab
    ___SliceRadioResourceStatus_Item_iE_Extensions__item__id._const_tab_at = None
    ___SliceRadioResourceStatus_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SliceRadioResourceStatus_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SliceRadioResourceStatus_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceRadioResourceStatus_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceRadioResourceStatus_Item_iE_Extensions__item__criticality._const_tab = ____SliceRadioResourceStatus_Item_iE_Extensions__item__criticality_tab
    ___SliceRadioResourceStatus_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SliceRadioResourceStatus_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SliceRadioResourceStatus_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SliceRadioResourceStatus_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceRadioResourceStatus_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceRadioResourceStatus_Item_iE_Extensions__item__extensionValue._const_tab = ____SliceRadioResourceStatus_Item_iE_Extensions__item__extensionValue_tab
    ___SliceRadioResourceStatus_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SliceRadioResourceStatus_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SliceRadioResourceStatus_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SliceRadioResourceStatus_Item_iE_Extensions__item__id),
        ('criticality', ___SliceRadioResourceStatus_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SliceRadioResourceStatus_Item_iE_Extensions__item__extensionValue),
        ])
    __SliceRadioResourceStatus_Item_iE_Extensions__item_._ext = None
    _SliceRadioResourceStatus_Item_iE_Extensions._cont = __SliceRadioResourceStatus_Item_iE_Extensions__item_
    _SliceRadioResourceStatus_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SliceRadioResourceStatus_Item._cont = ASN1Dict([
        ('pLMNIdentity', _SliceRadioResourceStatus_Item_pLMNIdentity),
        ('sNSSAIRadioResourceStatus-List', _SliceRadioResourceStatus_Item_sNSSAIRadioResourceStatus_List),
        ('iE-Extensions', _SliceRadioResourceStatus_Item_iE_Extensions),
        ])
    SliceRadioResourceStatus_Item._ext = None
    
    #-----< SliceRadioResourceStatus-Item-ExtIEs >-----#
    SliceRadioResourceStatus_Item_ExtIEs = CLASS(name='SliceRadioResourceStatus-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SliceRadioResourceStatus_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SNSSAIRadioResourceStatus-List >-----#
    SNSSAIRadioResourceStatus_List = SEQ_OF(name='SNSSAIRadioResourceStatus-List', mode=MODE_TYPE)
    _SNSSAIRadioResourceStatus_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SNSSAIRadioResourceStatus-Item')))
    SNSSAIRadioResourceStatus_List._cont = _SNSSAIRadioResourceStatus_List__item_
    SNSSAIRadioResourceStatus_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< SNSSAIRadioResourceStatus-Item >-----#
    SNSSAIRadioResourceStatus_Item = SEQ(name='SNSSAIRadioResourceStatus-Item', mode=MODE_TYPE)
    _SNSSAIRadioResourceStatus_Item_sNSSAI = SEQ(name='sNSSAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SNSSAI')))
    _SNSSAIRadioResourceStatus_Item_sNSSAIdlGBRPRBusage = INT(name='sNSSAIdlGBRPRBusage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SNSSAIRadioResourceStatus_Item_sNSSAIdlGBRPRBusage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SNSSAIRadioResourceStatus_Item_sNSSAIulGBRPRBusage = INT(name='sNSSAIulGBRPRBusage', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SNSSAIRadioResourceStatus_Item_sNSSAIulGBRPRBusage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SNSSAIRadioResourceStatus_Item_sNSSAIdlNonGBRPRBusage = INT(name='sNSSAIdlNonGBRPRBusage', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SNSSAIRadioResourceStatus_Item_sNSSAIdlNonGBRPRBusage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SNSSAIRadioResourceStatus_Item_sNSSAIulNonGBRPRBusage = INT(name='sNSSAIulNonGBRPRBusage', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SNSSAIRadioResourceStatus_Item_sNSSAIulNonGBRPRBusage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SNSSAIRadioResourceStatus_Item_sNSSAIdlTotalPRBallocation = INT(name='sNSSAIdlTotalPRBallocation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SNSSAIRadioResourceStatus_Item_sNSSAIdlTotalPRBallocation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SNSSAIRadioResourceStatus_Item_sNSSAIulTotalPRBallocation = INT(name='sNSSAIulTotalPRBallocation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SNSSAIRadioResourceStatus_Item_sNSSAIulTotalPRBallocation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SNSSAIRadioResourceStatus_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SNSSAIRadioResourceStatus_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SNSSAIRadioResourceStatus_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SNSSAIRadioResourceStatus_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SNSSAIRadioResourceStatus_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNSSAIRadioResourceStatus_Item_iE_Extensions__item__id._const_tab = ____SNSSAIRadioResourceStatus_Item_iE_Extensions__item__id_tab
    ___SNSSAIRadioResourceStatus_Item_iE_Extensions__item__id._const_tab_at = None
    ___SNSSAIRadioResourceStatus_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SNSSAIRadioResourceStatus_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SNSSAIRadioResourceStatus_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SNSSAIRadioResourceStatus_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNSSAIRadioResourceStatus_Item_iE_Extensions__item__criticality._const_tab = ____SNSSAIRadioResourceStatus_Item_iE_Extensions__item__criticality_tab
    ___SNSSAIRadioResourceStatus_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SNSSAIRadioResourceStatus_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SNSSAIRadioResourceStatus_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SNSSAIRadioResourceStatus_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SNSSAIRadioResourceStatus_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNSSAIRadioResourceStatus_Item_iE_Extensions__item__extensionValue._const_tab = ____SNSSAIRadioResourceStatus_Item_iE_Extensions__item__extensionValue_tab
    ___SNSSAIRadioResourceStatus_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SNSSAIRadioResourceStatus_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SNSSAIRadioResourceStatus_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SNSSAIRadioResourceStatus_Item_iE_Extensions__item__id),
        ('criticality', ___SNSSAIRadioResourceStatus_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SNSSAIRadioResourceStatus_Item_iE_Extensions__item__extensionValue),
        ])
    __SNSSAIRadioResourceStatus_Item_iE_Extensions__item_._ext = None
    _SNSSAIRadioResourceStatus_Item_iE_Extensions._cont = __SNSSAIRadioResourceStatus_Item_iE_Extensions__item_
    _SNSSAIRadioResourceStatus_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SNSSAIRadioResourceStatus_Item._cont = ASN1Dict([
        ('sNSSAI', _SNSSAIRadioResourceStatus_Item_sNSSAI),
        ('sNSSAIdlGBRPRBusage', _SNSSAIRadioResourceStatus_Item_sNSSAIdlGBRPRBusage),
        ('sNSSAIulGBRPRBusage', _SNSSAIRadioResourceStatus_Item_sNSSAIulGBRPRBusage),
        ('sNSSAIdlNonGBRPRBusage', _SNSSAIRadioResourceStatus_Item_sNSSAIdlNonGBRPRBusage),
        ('sNSSAIulNonGBRPRBusage', _SNSSAIRadioResourceStatus_Item_sNSSAIulNonGBRPRBusage),
        ('sNSSAIdlTotalPRBallocation', _SNSSAIRadioResourceStatus_Item_sNSSAIdlTotalPRBallocation),
        ('sNSSAIulTotalPRBallocation', _SNSSAIRadioResourceStatus_Item_sNSSAIulTotalPRBallocation),
        ('iE-Extensions', _SNSSAIRadioResourceStatus_Item_iE_Extensions),
        ])
    SNSSAIRadioResourceStatus_Item._ext = None
    
    #-----< SNSSAIRadioResourceStatus-Item-ExtIEs >-----#
    SNSSAIRadioResourceStatus_Item_ExtIEs = CLASS(name='SNSSAIRadioResourceStatus-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SNSSAIRadioResourceStatus_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SliceSupportList >-----#
    SliceSupportList = SEQ_OF(name='SliceSupportList', mode=MODE_TYPE)
    _SliceSupportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SliceSupportItem')))
    SliceSupportList._cont = _SliceSupportList__item_
    SliceSupportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< SliceSupportItem >-----#
    SliceSupportItem = SEQ(name='SliceSupportItem', mode=MODE_TYPE)
    _SliceSupportItem_sNSSAI = SEQ(name='sNSSAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SNSSAI')))
    _SliceSupportItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SliceSupportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SliceSupportItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SliceSupportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceSupportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceSupportItem_iE_Extensions__item__id._const_tab = ____SliceSupportItem_iE_Extensions__item__id_tab
    ___SliceSupportItem_iE_Extensions__item__id._const_tab_at = None
    ___SliceSupportItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SliceSupportItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SliceSupportItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceSupportItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceSupportItem_iE_Extensions__item__criticality._const_tab = ____SliceSupportItem_iE_Extensions__item__criticality_tab
    ___SliceSupportItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SliceSupportItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SliceSupportItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SliceSupportItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceSupportItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceSupportItem_iE_Extensions__item__extensionValue._const_tab = ____SliceSupportItem_iE_Extensions__item__extensionValue_tab
    ___SliceSupportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SliceSupportItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SliceSupportItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SliceSupportItem_iE_Extensions__item__id),
        ('criticality', ___SliceSupportItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SliceSupportItem_iE_Extensions__item__extensionValue),
        ])
    __SliceSupportItem_iE_Extensions__item_._ext = None
    _SliceSupportItem_iE_Extensions._cont = __SliceSupportItem_iE_Extensions__item_
    _SliceSupportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SliceSupportItem._cont = ASN1Dict([
        ('sNSSAI', _SliceSupportItem_sNSSAI),
        ('iE-Extensions', _SliceSupportItem_iE_Extensions),
        ])
    SliceSupportItem._ext = None
    
    #-----< SliceSupportItem-ExtIEs >-----#
    SliceSupportItem_ExtIEs = CLASS(name='SliceSupportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SliceSupportItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SliceToReportList >-----#
    SliceToReportList = SEQ_OF(name='SliceToReportList', mode=MODE_TYPE)
    _SliceToReportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SliceToReportItem')))
    SliceToReportList._cont = _SliceToReportList__item_
    SliceToReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< SliceToReportItem >-----#
    SliceToReportItem = SEQ(name='SliceToReportItem', mode=MODE_TYPE)
    _SliceToReportItem_pLMNIdentity = OCT_STR(name='pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _SliceToReportItem_sNSSAIlist = SEQ_OF(name='sNSSAIlist', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SNSSAI-list')))
    _SliceToReportItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SliceToReportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SliceToReportItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SliceToReportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceToReportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceToReportItem_iE_Extensions__item__id._const_tab = ____SliceToReportItem_iE_Extensions__item__id_tab
    ___SliceToReportItem_iE_Extensions__item__id._const_tab_at = None
    ___SliceToReportItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SliceToReportItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SliceToReportItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceToReportItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceToReportItem_iE_Extensions__item__criticality._const_tab = ____SliceToReportItem_iE_Extensions__item__criticality_tab
    ___SliceToReportItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SliceToReportItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SliceToReportItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SliceToReportItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SliceToReportItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceToReportItem_iE_Extensions__item__extensionValue._const_tab = ____SliceToReportItem_iE_Extensions__item__extensionValue_tab
    ___SliceToReportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SliceToReportItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SliceToReportItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SliceToReportItem_iE_Extensions__item__id),
        ('criticality', ___SliceToReportItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SliceToReportItem_iE_Extensions__item__extensionValue),
        ])
    __SliceToReportItem_iE_Extensions__item_._ext = None
    _SliceToReportItem_iE_Extensions._cont = __SliceToReportItem_iE_Extensions__item_
    _SliceToReportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SliceToReportItem._cont = ASN1Dict([
        ('pLMNIdentity', _SliceToReportItem_pLMNIdentity),
        ('sNSSAIlist', _SliceToReportItem_sNSSAIlist),
        ('iE-Extensions', _SliceToReportItem_iE_Extensions),
        ])
    SliceToReportItem._ext = None
    
    #-----< SliceToReportItem-ExtIEs >-----#
    SliceToReportItem_ExtIEs = CLASS(name='SliceToReportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SliceToReportItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SlotNumber >-----#
    SlotNumber = INT(name='SlotNumber', mode=MODE_TYPE)
    SlotNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=79)], ev=None, er=[])
    
    #-----< SNSSAI-list >-----#
    SNSSAI_list = SEQ_OF(name='SNSSAI-list', mode=MODE_TYPE)
    _SNSSAI_list__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SNSSAI-Item')))
    SNSSAI_list._cont = _SNSSAI_list__item_
    SNSSAI_list._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< SNSSAI-Item >-----#
    SNSSAI_Item = SEQ(name='SNSSAI-Item', mode=MODE_TYPE)
    _SNSSAI_Item_sNSSAI = SEQ(name='sNSSAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SNSSAI')))
    _SNSSAI_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SNSSAI_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SNSSAI_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SNSSAI_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SNSSAI_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNSSAI_Item_iE_Extensions__item__id._const_tab = ____SNSSAI_Item_iE_Extensions__item__id_tab
    ___SNSSAI_Item_iE_Extensions__item__id._const_tab_at = None
    ___SNSSAI_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SNSSAI_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SNSSAI_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SNSSAI_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNSSAI_Item_iE_Extensions__item__criticality._const_tab = ____SNSSAI_Item_iE_Extensions__item__criticality_tab
    ___SNSSAI_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SNSSAI_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SNSSAI_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SNSSAI_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SNSSAI_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNSSAI_Item_iE_Extensions__item__extensionValue._const_tab = ____SNSSAI_Item_iE_Extensions__item__extensionValue_tab
    ___SNSSAI_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SNSSAI_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SNSSAI_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SNSSAI_Item_iE_Extensions__item__id),
        ('criticality', ___SNSSAI_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SNSSAI_Item_iE_Extensions__item__extensionValue),
        ])
    __SNSSAI_Item_iE_Extensions__item_._ext = None
    _SNSSAI_Item_iE_Extensions._cont = __SNSSAI_Item_iE_Extensions__item_
    _SNSSAI_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SNSSAI_Item._cont = ASN1Dict([
        ('sNSSAI', _SNSSAI_Item_sNSSAI),
        ('iE-Extensions', _SNSSAI_Item_iE_Extensions),
        ])
    SNSSAI_Item._ext = None
    
    #-----< SNSSAI-Item-ExtIEs >-----#
    SNSSAI_Item_ExtIEs = CLASS(name='SNSSAI-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SNSSAI_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Slot-Configuration-List >-----#
    Slot_Configuration_List = SEQ_OF(name='Slot-Configuration-List', mode=MODE_TYPE)
    _Slot_Configuration_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Slot-Configuration-Item')))
    Slot_Configuration_List._cont = _Slot_Configuration_List__item_
    Slot_Configuration_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5120)], ev=None, er=[])
    
    #-----< Slot-Configuration-Item >-----#
    Slot_Configuration_Item = SEQ(name='Slot-Configuration-Item', mode=MODE_TYPE)
    _Slot_Configuration_Item_slotIndex = INT(name='slotIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Slot_Configuration_Item_slotIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5119)], ev=[], er=[])
    _Slot_Configuration_Item_symbolAllocInSlot = CHOICE(name='symbolAllocInSlot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SymbolAllocInSlot')))
    _Slot_Configuration_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Slot_Configuration_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Slot_Configuration_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Slot_Configuration_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Slot_Configuration_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Slot_Configuration_Item_iE_Extensions__item__id._const_tab = ____Slot_Configuration_Item_iE_Extensions__item__id_tab
    ___Slot_Configuration_Item_iE_Extensions__item__id._const_tab_at = None
    ___Slot_Configuration_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Slot_Configuration_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Slot_Configuration_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Slot_Configuration_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Slot_Configuration_Item_iE_Extensions__item__criticality._const_tab = ____Slot_Configuration_Item_iE_Extensions__item__criticality_tab
    ___Slot_Configuration_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Slot_Configuration_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Slot_Configuration_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Slot_Configuration_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Slot_Configuration_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Slot_Configuration_Item_iE_Extensions__item__extensionValue._const_tab = ____Slot_Configuration_Item_iE_Extensions__item__extensionValue_tab
    ___Slot_Configuration_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Slot_Configuration_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Slot_Configuration_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Slot_Configuration_Item_iE_Extensions__item__id),
        ('criticality', ___Slot_Configuration_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Slot_Configuration_Item_iE_Extensions__item__extensionValue),
        ])
    __Slot_Configuration_Item_iE_Extensions__item_._ext = None
    _Slot_Configuration_Item_iE_Extensions._cont = __Slot_Configuration_Item_iE_Extensions__item_
    _Slot_Configuration_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Slot_Configuration_Item._cont = ASN1Dict([
        ('slotIndex', _Slot_Configuration_Item_slotIndex),
        ('symbolAllocInSlot', _Slot_Configuration_Item_symbolAllocInSlot),
        ('iE-Extensions', _Slot_Configuration_Item_iE_Extensions),
        ])
    Slot_Configuration_Item._ext = None
    
    #-----< Slot-Configuration-ItemExtIEs >-----#
    Slot_Configuration_ItemExtIEs = CLASS(name='Slot-Configuration-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Slot_Configuration_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SNSSAI >-----#
    SNSSAI = SEQ(name='SNSSAI', mode=MODE_TYPE)
    _SNSSAI_sST = OCT_STR(name='sST', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SNSSAI_sST._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _SNSSAI_sD = OCT_STR(name='sD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SNSSAI_sD._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _SNSSAI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SNSSAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SNSSAI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SNSSAI_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SNSSAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNSSAI_iE_Extensions__item__id._const_tab = ____SNSSAI_iE_Extensions__item__id_tab
    ___SNSSAI_iE_Extensions__item__id._const_tab_at = None
    ___SNSSAI_iE_Extensions__item__id._const_tab_id = 'id'
    ___SNSSAI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SNSSAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SNSSAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNSSAI_iE_Extensions__item__criticality._const_tab = ____SNSSAI_iE_Extensions__item__criticality_tab
    ___SNSSAI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SNSSAI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SNSSAI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SNSSAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SNSSAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNSSAI_iE_Extensions__item__extensionValue._const_tab = ____SNSSAI_iE_Extensions__item__extensionValue_tab
    ___SNSSAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SNSSAI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SNSSAI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SNSSAI_iE_Extensions__item__id),
        ('criticality', ___SNSSAI_iE_Extensions__item__criticality),
        ('extensionValue', ___SNSSAI_iE_Extensions__item__extensionValue),
        ])
    __SNSSAI_iE_Extensions__item_._ext = None
    _SNSSAI_iE_Extensions._cont = __SNSSAI_iE_Extensions__item_
    _SNSSAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SNSSAI._cont = ASN1Dict([
        ('sST', _SNSSAI_sST),
        ('sD', _SNSSAI_sD),
        ('iE-Extensions', _SNSSAI_iE_Extensions),
        ])
    SNSSAI._ext = None
    
    #-----< SNSSAI-ExtIEs >-----#
    SNSSAI_ExtIEs = CLASS(name='SNSSAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SNSSAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpatialDirectionInformation >-----#
    SpatialDirectionInformation = SEQ(name='SpatialDirectionInformation', mode=MODE_TYPE)
    _SpatialDirectionInformation_nR_PRSBeamInformation = SEQ(name='nR-PRSBeamInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NR-PRSBeamInformation')))
    _SpatialDirectionInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SpatialDirectionInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SpatialDirectionInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SpatialDirectionInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialDirectionInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialDirectionInformation_iE_Extensions__item__id._const_tab = ____SpatialDirectionInformation_iE_Extensions__item__id_tab
    ___SpatialDirectionInformation_iE_Extensions__item__id._const_tab_at = None
    ___SpatialDirectionInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___SpatialDirectionInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SpatialDirectionInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialDirectionInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialDirectionInformation_iE_Extensions__item__criticality._const_tab = ____SpatialDirectionInformation_iE_Extensions__item__criticality_tab
    ___SpatialDirectionInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SpatialDirectionInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SpatialDirectionInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SpatialDirectionInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialDirectionInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialDirectionInformation_iE_Extensions__item__extensionValue._const_tab = ____SpatialDirectionInformation_iE_Extensions__item__extensionValue_tab
    ___SpatialDirectionInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SpatialDirectionInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SpatialDirectionInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SpatialDirectionInformation_iE_Extensions__item__id),
        ('criticality', ___SpatialDirectionInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___SpatialDirectionInformation_iE_Extensions__item__extensionValue),
        ])
    __SpatialDirectionInformation_iE_Extensions__item_._ext = None
    _SpatialDirectionInformation_iE_Extensions._cont = __SpatialDirectionInformation_iE_Extensions__item_
    _SpatialDirectionInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SpatialDirectionInformation._cont = ASN1Dict([
        ('nR-PRSBeamInformation', _SpatialDirectionInformation_nR_PRSBeamInformation),
        ('iE-Extensions', _SpatialDirectionInformation_iE_Extensions),
        ])
    SpatialDirectionInformation._ext = None
    
    #-----< SpatialDirectionInformation-ExtIEs >-----#
    SpatialDirectionInformation_ExtIEs = CLASS(name='SpatialDirectionInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SpatialDirectionInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpatialRelationInfo >-----#
    SpatialRelationInfo = SEQ(name='SpatialRelationInfo', mode=MODE_TYPE)
    _SpatialRelationInfo_spatialRelationforResourceID = SEQ_OF(name='spatialRelationforResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SpatialRelationforResourceID')))
    _SpatialRelationInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SpatialRelationInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SpatialRelationInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SpatialRelationInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialRelationInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationInfo_iE_Extensions__item__id._const_tab = ____SpatialRelationInfo_iE_Extensions__item__id_tab
    ___SpatialRelationInfo_iE_Extensions__item__id._const_tab_at = None
    ___SpatialRelationInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___SpatialRelationInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SpatialRelationInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialRelationInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationInfo_iE_Extensions__item__criticality._const_tab = ____SpatialRelationInfo_iE_Extensions__item__criticality_tab
    ___SpatialRelationInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SpatialRelationInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SpatialRelationInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SpatialRelationInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialRelationInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationInfo_iE_Extensions__item__extensionValue._const_tab = ____SpatialRelationInfo_iE_Extensions__item__extensionValue_tab
    ___SpatialRelationInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SpatialRelationInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SpatialRelationInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SpatialRelationInfo_iE_Extensions__item__id),
        ('criticality', ___SpatialRelationInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___SpatialRelationInfo_iE_Extensions__item__extensionValue),
        ])
    __SpatialRelationInfo_iE_Extensions__item_._ext = None
    _SpatialRelationInfo_iE_Extensions._cont = __SpatialRelationInfo_iE_Extensions__item_
    _SpatialRelationInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SpatialRelationInfo._cont = ASN1Dict([
        ('spatialRelationforResourceID', _SpatialRelationInfo_spatialRelationforResourceID),
        ('iE-Extensions', _SpatialRelationInfo_iE_Extensions),
        ])
    SpatialRelationInfo._ext = None
    
    #-----< SpatialRelationInfo-ExtIEs >-----#
    SpatialRelationInfo_ExtIEs = CLASS(name='SpatialRelationInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SpatialRelationInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpatialRelationforResourceID >-----#
    SpatialRelationforResourceID = SEQ_OF(name='SpatialRelationforResourceID', mode=MODE_TYPE)
    _SpatialRelationforResourceID__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SpatialRelationforResourceIDItem')))
    SpatialRelationforResourceID._cont = _SpatialRelationforResourceID__item_
    SpatialRelationforResourceID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SpatialRelationforResourceIDItem >-----#
    SpatialRelationforResourceIDItem = SEQ(name='SpatialRelationforResourceIDItem', mode=MODE_TYPE)
    _SpatialRelationforResourceIDItem_referenceSignal = CHOICE(name='referenceSignal', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ReferenceSignal')))
    _SpatialRelationforResourceIDItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SpatialRelationforResourceIDItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SpatialRelationforResourceIDItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialRelationforResourceIDItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__id._const_tab = ____SpatialRelationforResourceIDItem_iE_Extensions__item__id_tab
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__id._const_tab_at = None
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SpatialRelationforResourceIDItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialRelationforResourceIDItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__criticality._const_tab = ____SpatialRelationforResourceIDItem_iE_Extensions__item__criticality_tab
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue._const_tab = ____SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue_tab
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SpatialRelationforResourceIDItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SpatialRelationforResourceIDItem_iE_Extensions__item__id),
        ('criticality', ___SpatialRelationforResourceIDItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue),
        ])
    __SpatialRelationforResourceIDItem_iE_Extensions__item_._ext = None
    _SpatialRelationforResourceIDItem_iE_Extensions._cont = __SpatialRelationforResourceIDItem_iE_Extensions__item_
    _SpatialRelationforResourceIDItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SpatialRelationforResourceIDItem._cont = ASN1Dict([
        ('referenceSignal', _SpatialRelationforResourceIDItem_referenceSignal),
        ('iE-Extensions', _SpatialRelationforResourceIDItem_iE_Extensions),
        ])
    SpatialRelationforResourceIDItem._ext = None
    
    #-----< SpatialRelationforResourceIDItem-ExtIEs >-----#
    SpatialRelationforResourceIDItem_ExtIEs = CLASS(name='SpatialRelationforResourceIDItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SpatialRelationforResourceIDItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpatialRelationPerSRSResource >-----#
    SpatialRelationPerSRSResource = SEQ(name='SpatialRelationPerSRSResource', mode=MODE_TYPE)
    _SpatialRelationPerSRSResource_spatialRelationPerSRSResource_List = SEQ_OF(name='spatialRelationPerSRSResource-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SpatialRelationPerSRSResource-List')))
    _SpatialRelationPerSRSResource_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SpatialRelationPerSRSResource_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SpatialRelationPerSRSResource_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SpatialRelationPerSRSResource_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialRelationPerSRSResource_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationPerSRSResource_iE_Extensions__item__id._const_tab = ____SpatialRelationPerSRSResource_iE_Extensions__item__id_tab
    ___SpatialRelationPerSRSResource_iE_Extensions__item__id._const_tab_at = None
    ___SpatialRelationPerSRSResource_iE_Extensions__item__id._const_tab_id = 'id'
    ___SpatialRelationPerSRSResource_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SpatialRelationPerSRSResource_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialRelationPerSRSResource_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationPerSRSResource_iE_Extensions__item__criticality._const_tab = ____SpatialRelationPerSRSResource_iE_Extensions__item__criticality_tab
    ___SpatialRelationPerSRSResource_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SpatialRelationPerSRSResource_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue._const_tab = ____SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue_tab
    ___SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SpatialRelationPerSRSResource_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SpatialRelationPerSRSResource_iE_Extensions__item__id),
        ('criticality', ___SpatialRelationPerSRSResource_iE_Extensions__item__criticality),
        ('extensionValue', ___SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue),
        ])
    __SpatialRelationPerSRSResource_iE_Extensions__item_._ext = None
    _SpatialRelationPerSRSResource_iE_Extensions._cont = __SpatialRelationPerSRSResource_iE_Extensions__item_
    _SpatialRelationPerSRSResource_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SpatialRelationPerSRSResource._cont = ASN1Dict([
        ('spatialRelationPerSRSResource-List', _SpatialRelationPerSRSResource_spatialRelationPerSRSResource_List),
        ('iE-Extensions', _SpatialRelationPerSRSResource_iE_Extensions),
        ])
    SpatialRelationPerSRSResource._ext = []
    
    #-----< SpatialRelationPerSRSResource-ExtIEs >-----#
    SpatialRelationPerSRSResource_ExtIEs = CLASS(name='SpatialRelationPerSRSResource-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SpatialRelationPerSRSResource_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpatialRelationPerSRSResource-List >-----#
    SpatialRelationPerSRSResource_List = SEQ_OF(name='SpatialRelationPerSRSResource-List', mode=MODE_TYPE)
    _SpatialRelationPerSRSResource_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SpatialRelationPerSRSResourceItem')))
    SpatialRelationPerSRSResource_List._cont = _SpatialRelationPerSRSResource_List__item_
    SpatialRelationPerSRSResource_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SpatialRelationPerSRSResourceItem >-----#
    SpatialRelationPerSRSResourceItem = SEQ(name='SpatialRelationPerSRSResourceItem', mode=MODE_TYPE)
    _SpatialRelationPerSRSResourceItem_referenceSignal = CHOICE(name='referenceSignal', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ReferenceSignal')))
    _SpatialRelationPerSRSResourceItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SpatialRelationPerSRSResourceItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__id._const_tab = ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__id_tab
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__id._const_tab_at = None
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality._const_tab = ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality_tab
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue._const_tab = ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue_tab
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SpatialRelationPerSRSResourceItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__id),
        ('criticality', ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue),
        ])
    __SpatialRelationPerSRSResourceItem_iE_Extensions__item_._ext = None
    _SpatialRelationPerSRSResourceItem_iE_Extensions._cont = __SpatialRelationPerSRSResourceItem_iE_Extensions__item_
    _SpatialRelationPerSRSResourceItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SpatialRelationPerSRSResourceItem._cont = ASN1Dict([
        ('referenceSignal', _SpatialRelationPerSRSResourceItem_referenceSignal),
        ('iE-Extensions', _SpatialRelationPerSRSResourceItem_iE_Extensions),
        ])
    SpatialRelationPerSRSResourceItem._ext = []
    
    #-----< SpatialRelationPerSRSResourceItem-ExtIEs >-----#
    SpatialRelationPerSRSResourceItem_ExtIEs = CLASS(name='SpatialRelationPerSRSResourceItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SpatialRelationPerSRSResourceItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpatialRelationPos >-----#
    SpatialRelationPos = CHOICE(name='SpatialRelationPos', mode=MODE_TYPE)
    _SpatialRelationPos_sSBPos = SEQ(name='sSBPos', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB')))
    _SpatialRelationPos_pRSInformationPos = SEQ(name='pRSInformationPos', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSInformationPos')))
    _SpatialRelationPos_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SpatialRelationPos_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SpatialRelationPos_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SpatialRelationPos_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SpatialRelationPos_choice_extension_id._const_tab = ___SpatialRelationPos_choice_extension_id_tab
    __SpatialRelationPos_choice_extension_id._const_tab_at = None
    __SpatialRelationPos_choice_extension_id._const_tab_id = 'id'
    __SpatialRelationPos_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___SpatialRelationPos_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SpatialRelationPos_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SpatialRelationPos_choice_extension_criticality._const_tab = ___SpatialRelationPos_choice_extension_criticality_tab
    __SpatialRelationPos_choice_extension_criticality._const_tab_at = ('..', 'id')
    __SpatialRelationPos_choice_extension_criticality._const_tab_id = 'criticality'
    __SpatialRelationPos_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___SpatialRelationPos_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SpatialRelationPos_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SpatialRelationPos_choice_extension_value._const_tab = ___SpatialRelationPos_choice_extension_value_tab
    __SpatialRelationPos_choice_extension_value._const_tab_at = ('..', 'id')
    __SpatialRelationPos_choice_extension_value._const_tab_id = 'Value'
    _SpatialRelationPos_choice_extension._cont = ASN1Dict([
        ('id', __SpatialRelationPos_choice_extension_id),
        ('criticality', __SpatialRelationPos_choice_extension_criticality),
        ('value', __SpatialRelationPos_choice_extension_value),
        ])
    _SpatialRelationPos_choice_extension._ext = None
    SpatialRelationPos._cont = ASN1Dict([
        ('sSBPos', _SpatialRelationPos_sSBPos),
        ('pRSInformationPos', _SpatialRelationPos_pRSInformationPos),
        ('choice-extension', _SpatialRelationPos_choice_extension),
        ])
    SpatialRelationPos._ext = None
    
    #-----< SpatialInformationPos-ExtIEs >-----#
    SpatialInformationPos_ExtIEs = CLASS(name='SpatialInformationPos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    SpatialInformationPos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpectrumSharingGroupID >-----#
    SpectrumSharingGroupID = INT(name='SpectrumSharingGroupID', mode=MODE_TYPE)
    SpectrumSharingGroupID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< SRBID >-----#
    SRBID = INT(name='SRBID', mode=MODE_TYPE)
    SRBID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=[], er=[])
    
    #-----< SRBs-FailedToBeSetup-Item >-----#
    SRBs_FailedToBeSetup_Item = SEQ(name='SRBs-FailedToBeSetup-Item', mode=MODE_TYPE)
    _SRBs_FailedToBeSetup_Item_sRBID = INT(name='sRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _SRBs_FailedToBeSetup_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _SRBs_FailedToBeSetup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRBs_FailedToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab = ____SRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab
    ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____SRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab
    ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____SRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab
    ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRBs_FailedToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__id),
        ('criticality', ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __SRBs_FailedToBeSetup_Item_iE_Extensions__item_._ext = None
    _SRBs_FailedToBeSetup_Item_iE_Extensions._cont = __SRBs_FailedToBeSetup_Item_iE_Extensions__item_
    _SRBs_FailedToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRBs_FailedToBeSetup_Item._cont = ASN1Dict([
        ('sRBID', _SRBs_FailedToBeSetup_Item_sRBID),
        ('cause', _SRBs_FailedToBeSetup_Item_cause),
        ('iE-Extensions', _SRBs_FailedToBeSetup_Item_iE_Extensions),
        ])
    SRBs_FailedToBeSetup_Item._ext = []
    
    #-----< SRBs-FailedToBeSetup-ItemExtIEs >-----#
    SRBs_FailedToBeSetup_ItemExtIEs = CLASS(name='SRBs-FailedToBeSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRBs_FailedToBeSetup_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRBs-FailedToBeSetupMod-Item >-----#
    SRBs_FailedToBeSetupMod_Item = SEQ(name='SRBs-FailedToBeSetupMod-Item', mode=MODE_TYPE)
    _SRBs_FailedToBeSetupMod_Item_sRBID = INT(name='sRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _SRBs_FailedToBeSetupMod_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _SRBs_FailedToBeSetupMod_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRBs_FailedToBeSetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab = ____SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab = ____SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab
    ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRBs_FailedToBeSetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id),
        ('criticality', ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __SRBs_FailedToBeSetupMod_Item_iE_Extensions__item_._ext = None
    _SRBs_FailedToBeSetupMod_Item_iE_Extensions._cont = __SRBs_FailedToBeSetupMod_Item_iE_Extensions__item_
    _SRBs_FailedToBeSetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRBs_FailedToBeSetupMod_Item._cont = ASN1Dict([
        ('sRBID', _SRBs_FailedToBeSetupMod_Item_sRBID),
        ('cause', _SRBs_FailedToBeSetupMod_Item_cause),
        ('iE-Extensions', _SRBs_FailedToBeSetupMod_Item_iE_Extensions),
        ])
    SRBs_FailedToBeSetupMod_Item._ext = []
    
    #-----< SRBs-FailedToBeSetupMod-ItemExtIEs >-----#
    SRBs_FailedToBeSetupMod_ItemExtIEs = CLASS(name='SRBs-FailedToBeSetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRBs_FailedToBeSetupMod_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRBs-Modified-Item >-----#
    SRBs_Modified_Item = SEQ(name='SRBs-Modified-Item', mode=MODE_TYPE)
    _SRBs_Modified_Item_sRBID = INT(name='sRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _SRBs_Modified_Item_lCID = INT(name='lCID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LCID')))
    _SRBs_Modified_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRBs_Modified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRBs_Modified_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SRBs_Modified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_Modified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_Modified_Item_iE_Extensions__item__id._const_tab = ____SRBs_Modified_Item_iE_Extensions__item__id_tab
    ___SRBs_Modified_Item_iE_Extensions__item__id._const_tab_at = None
    ___SRBs_Modified_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRBs_Modified_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRBs_Modified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_Modified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_Modified_Item_iE_Extensions__item__criticality._const_tab = ____SRBs_Modified_Item_iE_Extensions__item__criticality_tab
    ___SRBs_Modified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRBs_Modified_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRBs_Modified_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRBs_Modified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_Modified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_Modified_Item_iE_Extensions__item__extensionValue._const_tab = ____SRBs_Modified_Item_iE_Extensions__item__extensionValue_tab
    ___SRBs_Modified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRBs_Modified_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRBs_Modified_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRBs_Modified_Item_iE_Extensions__item__id),
        ('criticality', ___SRBs_Modified_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SRBs_Modified_Item_iE_Extensions__item__extensionValue),
        ])
    __SRBs_Modified_Item_iE_Extensions__item_._ext = None
    _SRBs_Modified_Item_iE_Extensions._cont = __SRBs_Modified_Item_iE_Extensions__item_
    _SRBs_Modified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRBs_Modified_Item._cont = ASN1Dict([
        ('sRBID', _SRBs_Modified_Item_sRBID),
        ('lCID', _SRBs_Modified_Item_lCID),
        ('iE-Extensions', _SRBs_Modified_Item_iE_Extensions),
        ])
    SRBs_Modified_Item._ext = []
    
    #-----< SRBs-Modified-ItemExtIEs >-----#
    SRBs_Modified_ItemExtIEs = CLASS(name='SRBs-Modified-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRBs_Modified_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRBs-Required-ToBeReleased-Item >-----#
    SRBs_Required_ToBeReleased_Item = SEQ(name='SRBs-Required-ToBeReleased-Item', mode=MODE_TYPE)
    _SRBs_Required_ToBeReleased_Item_sRBID = INT(name='sRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _SRBs_Required_ToBeReleased_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRBs_Required_ToBeReleased_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SRBs_Required_ToBeReleased_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_Required_ToBeReleased_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__id._const_tab = ____SRBs_Required_ToBeReleased_Item_iE_Extensions__item__id_tab
    ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__id._const_tab_at = None
    ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab = ____SRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab
    ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab = ____SRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab
    ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRBs_Required_ToBeReleased_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__id),
        ('criticality', ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue),
        ])
    __SRBs_Required_ToBeReleased_Item_iE_Extensions__item_._ext = None
    _SRBs_Required_ToBeReleased_Item_iE_Extensions._cont = __SRBs_Required_ToBeReleased_Item_iE_Extensions__item_
    _SRBs_Required_ToBeReleased_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRBs_Required_ToBeReleased_Item._cont = ASN1Dict([
        ('sRBID', _SRBs_Required_ToBeReleased_Item_sRBID),
        ('iE-Extensions', _SRBs_Required_ToBeReleased_Item_iE_Extensions),
        ])
    SRBs_Required_ToBeReleased_Item._ext = []
    
    #-----< SRBs-Required-ToBeReleased-ItemExtIEs >-----#
    SRBs_Required_ToBeReleased_ItemExtIEs = CLASS(name='SRBs-Required-ToBeReleased-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRBs_Required_ToBeReleased_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRBs-Setup-Item >-----#
    SRBs_Setup_Item = SEQ(name='SRBs-Setup-Item', mode=MODE_TYPE)
    _SRBs_Setup_Item_sRBID = INT(name='sRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _SRBs_Setup_Item_lCID = INT(name='lCID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LCID')))
    _SRBs_Setup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRBs_Setup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRBs_Setup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SRBs_Setup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_Setup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_Setup_Item_iE_Extensions__item__id._const_tab = ____SRBs_Setup_Item_iE_Extensions__item__id_tab
    ___SRBs_Setup_Item_iE_Extensions__item__id._const_tab_at = None
    ___SRBs_Setup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRBs_Setup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRBs_Setup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_Setup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_Setup_Item_iE_Extensions__item__criticality._const_tab = ____SRBs_Setup_Item_iE_Extensions__item__criticality_tab
    ___SRBs_Setup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRBs_Setup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRBs_Setup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRBs_Setup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_Setup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab = ____SRBs_Setup_Item_iE_Extensions__item__extensionValue_tab
    ___SRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRBs_Setup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRBs_Setup_Item_iE_Extensions__item__id),
        ('criticality', ___SRBs_Setup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SRBs_Setup_Item_iE_Extensions__item__extensionValue),
        ])
    __SRBs_Setup_Item_iE_Extensions__item_._ext = None
    _SRBs_Setup_Item_iE_Extensions._cont = __SRBs_Setup_Item_iE_Extensions__item_
    _SRBs_Setup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRBs_Setup_Item._cont = ASN1Dict([
        ('sRBID', _SRBs_Setup_Item_sRBID),
        ('lCID', _SRBs_Setup_Item_lCID),
        ('iE-Extensions', _SRBs_Setup_Item_iE_Extensions),
        ])
    SRBs_Setup_Item._ext = []
    
    #-----< SRBs-Setup-ItemExtIEs >-----#
    SRBs_Setup_ItemExtIEs = CLASS(name='SRBs-Setup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRBs_Setup_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRBs-SetupMod-Item >-----#
    SRBs_SetupMod_Item = SEQ(name='SRBs-SetupMod-Item', mode=MODE_TYPE)
    _SRBs_SetupMod_Item_sRBID = INT(name='sRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _SRBs_SetupMod_Item_lCID = INT(name='lCID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LCID')))
    _SRBs_SetupMod_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRBs_SetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRBs_SetupMod_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SRBs_SetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_SetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_SetupMod_Item_iE_Extensions__item__id._const_tab = ____SRBs_SetupMod_Item_iE_Extensions__item__id_tab
    ___SRBs_SetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___SRBs_SetupMod_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRBs_SetupMod_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRBs_SetupMod_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_SetupMod_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_SetupMod_Item_iE_Extensions__item__criticality._const_tab = ____SRBs_SetupMod_Item_iE_Extensions__item__criticality_tab
    ___SRBs_SetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRBs_SetupMod_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRBs_SetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRBs_SetupMod_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_SetupMod_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____SRBs_SetupMod_Item_iE_Extensions__item__extensionValue_tab
    ___SRBs_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRBs_SetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRBs_SetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRBs_SetupMod_Item_iE_Extensions__item__id),
        ('criticality', ___SRBs_SetupMod_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SRBs_SetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __SRBs_SetupMod_Item_iE_Extensions__item_._ext = None
    _SRBs_SetupMod_Item_iE_Extensions._cont = __SRBs_SetupMod_Item_iE_Extensions__item_
    _SRBs_SetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRBs_SetupMod_Item._cont = ASN1Dict([
        ('sRBID', _SRBs_SetupMod_Item_sRBID),
        ('lCID', _SRBs_SetupMod_Item_lCID),
        ('iE-Extensions', _SRBs_SetupMod_Item_iE_Extensions),
        ])
    SRBs_SetupMod_Item._ext = []
    
    #-----< SRBs-SetupMod-ItemExtIEs >-----#
    SRBs_SetupMod_ItemExtIEs = CLASS(name='SRBs-SetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRBs_SetupMod_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRBs-ToBeReleased-Item >-----#
    SRBs_ToBeReleased_Item = SEQ(name='SRBs-ToBeReleased-Item', mode=MODE_TYPE)
    _SRBs_ToBeReleased_Item_sRBID = INT(name='sRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _SRBs_ToBeReleased_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRBs_ToBeReleased_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRBs_ToBeReleased_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SRBs_ToBeReleased_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_ToBeReleased_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab = ____SRBs_ToBeReleased_Item_iE_Extensions__item__id_tab
    ___SRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab_at = None
    ___SRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRBs_ToBeReleased_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab = ____SRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab
    ___SRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab = ____SRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab
    ___SRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRBs_ToBeReleased_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRBs_ToBeReleased_Item_iE_Extensions__item__id),
        ('criticality', ___SRBs_ToBeReleased_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue),
        ])
    __SRBs_ToBeReleased_Item_iE_Extensions__item_._ext = None
    _SRBs_ToBeReleased_Item_iE_Extensions._cont = __SRBs_ToBeReleased_Item_iE_Extensions__item_
    _SRBs_ToBeReleased_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRBs_ToBeReleased_Item._cont = ASN1Dict([
        ('sRBID', _SRBs_ToBeReleased_Item_sRBID),
        ('iE-Extensions', _SRBs_ToBeReleased_Item_iE_Extensions),
        ])
    SRBs_ToBeReleased_Item._ext = []
    
    #-----< SRBs-ToBeReleased-ItemExtIEs >-----#
    SRBs_ToBeReleased_ItemExtIEs = CLASS(name='SRBs-ToBeReleased-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRBs_ToBeReleased_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRBs-ToBeSetup-Item >-----#
    SRBs_ToBeSetup_Item = SEQ(name='SRBs-ToBeSetup-Item', mode=MODE_TYPE)
    _SRBs_ToBeSetup_Item_sRBID = INT(name='sRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _SRBs_ToBeSetup_Item_duplicationIndication = ENUM(name='duplicationIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DuplicationIndication')), opt=True)
    _SRBs_ToBeSetup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRBs_ToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRBs_ToBeSetup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SRBs_ToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____SRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalDuplicationIndication')))
    _____SRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SDTRLCBearerConfiguration')))
    _____SRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_2 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelID')))
    ____SRBs_ToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 372), ('criticality', 'ignore'), ('Extension', _____SRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 593), ('criticality', 'ignore'), ('Extension', _____SRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 597), ('criticality', 'ignore'), ('Extension', _____SRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab = ____SRBs_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___SRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___SRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRBs_ToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____SRBs_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___SRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____SRBs_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___SRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRBs_ToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRBs_ToBeSetup_Item_iE_Extensions__item__id),
        ('criticality', ___SRBs_ToBeSetup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __SRBs_ToBeSetup_Item_iE_Extensions__item_._ext = None
    _SRBs_ToBeSetup_Item_iE_Extensions._cont = __SRBs_ToBeSetup_Item_iE_Extensions__item_
    _SRBs_ToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRBs_ToBeSetup_Item._cont = ASN1Dict([
        ('sRBID', _SRBs_ToBeSetup_Item_sRBID),
        ('duplicationIndication', _SRBs_ToBeSetup_Item_duplicationIndication),
        ('iE-Extensions', _SRBs_ToBeSetup_Item_iE_Extensions),
        ])
    SRBs_ToBeSetup_Item._ext = []
    
    #-----< SRBs-ToBeSetup-ItemExtIEs >-----#
    SRBs_ToBeSetup_ItemExtIEs = CLASS(name='SRBs-ToBeSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _SRBs_ToBeSetup_ItemExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalDuplicationIndication')))
    _SRBs_ToBeSetup_ItemExtIEs_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SDTRLCBearerConfiguration')))
    _SRBs_ToBeSetup_ItemExtIEs_val_Extension_2 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelID')))
    SRBs_ToBeSetup_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 372), ('criticality', 'ignore'), ('Extension', _SRBs_ToBeSetup_ItemExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 593), ('criticality', 'ignore'), ('Extension', _SRBs_ToBeSetup_ItemExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 597), ('criticality', 'ignore'), ('Extension', _SRBs_ToBeSetup_ItemExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SRBs-ToBeSetupMod-Item >-----#
    SRBs_ToBeSetupMod_Item = SEQ(name='SRBs-ToBeSetupMod-Item', mode=MODE_TYPE)
    _SRBs_ToBeSetupMod_Item_sRBID = INT(name='sRBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _SRBs_ToBeSetupMod_Item_duplicationIndication = ENUM(name='duplicationIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'DuplicationIndication')), opt=True)
    _SRBs_ToBeSetupMod_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRBs_ToBeSetupMod_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____SRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalDuplicationIndication')))
    _____SRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelID')))
    _____SRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CG-SDTindicatorSetup')))
    ____SRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 372), ('criticality', 'ignore'), ('Extension', _____SRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 597), ('criticality', 'ignore'), ('Extension', _____SRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 589), ('criticality', 'reject'), ('Extension', _____SRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab = ____SRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab_at = None
    ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab = ____SRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab = ____SRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab
    ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRBs_ToBeSetupMod_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__id),
        ('criticality', ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue),
        ])
    __SRBs_ToBeSetupMod_Item_iE_Extensions__item_._ext = None
    _SRBs_ToBeSetupMod_Item_iE_Extensions._cont = __SRBs_ToBeSetupMod_Item_iE_Extensions__item_
    _SRBs_ToBeSetupMod_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRBs_ToBeSetupMod_Item._cont = ASN1Dict([
        ('sRBID', _SRBs_ToBeSetupMod_Item_sRBID),
        ('duplicationIndication', _SRBs_ToBeSetupMod_Item_duplicationIndication),
        ('iE-Extensions', _SRBs_ToBeSetupMod_Item_iE_Extensions),
        ])
    SRBs_ToBeSetupMod_Item._ext = []
    
    #-----< SRBs-ToBeSetupMod-ItemExtIEs >-----#
    SRBs_ToBeSetupMod_ItemExtIEs = CLASS(name='SRBs-ToBeSetupMod-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _SRBs_ToBeSetupMod_ItemExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalDuplicationIndication')))
    _SRBs_ToBeSetupMod_ItemExtIEs_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelID')))
    _SRBs_ToBeSetupMod_ItemExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CG-SDTindicatorSetup')))
    SRBs_ToBeSetupMod_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 372), ('criticality', 'ignore'), ('Extension', _SRBs_ToBeSetupMod_ItemExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 597), ('criticality', 'ignore'), ('Extension', _SRBs_ToBeSetupMod_ItemExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 589), ('criticality', 'reject'), ('Extension', _SRBs_ToBeSetupMod_ItemExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SRSCarrier-List >-----#
    SRSCarrier_List = SEQ_OF(name='SRSCarrier-List', mode=MODE_TYPE)
    _SRSCarrier_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSCarrier-List-Item')))
    SRSCarrier_List._cont = _SRSCarrier_List__item_
    SRSCarrier_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SRSCarrier-List-Item >-----#
    SRSCarrier_List_Item = SEQ(name='SRSCarrier-List-Item', mode=MODE_TYPE)
    _SRSCarrier_List_Item_pointA = INT(name='pointA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSCarrier_List_Item_pointA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _SRSCarrier_List_Item_uplinkChannelBW_PerSCS_List = SEQ_OF(name='uplinkChannelBW-PerSCS-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UplinkChannelBW-PerSCS-List')))
    _SRSCarrier_List_Item_activeULBWP = SEQ(name='activeULBWP', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ActiveULBWP')))
    _SRSCarrier_List_Item_pci = INT(name='pci', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRPCI')), opt=True)
    _SRSCarrier_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSCarrier_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRSCarrier_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SRSCarrier_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSCarrier_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSCarrier_List_Item_iE_Extensions__item__id._const_tab = ____SRSCarrier_List_Item_iE_Extensions__item__id_tab
    ___SRSCarrier_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___SRSCarrier_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRSCarrier_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRSCarrier_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSCarrier_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSCarrier_List_Item_iE_Extensions__item__criticality._const_tab = ____SRSCarrier_List_Item_iE_Extensions__item__criticality_tab
    ___SRSCarrier_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRSCarrier_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRSCarrier_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRSCarrier_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSCarrier_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSCarrier_List_Item_iE_Extensions__item__extensionValue._const_tab = ____SRSCarrier_List_Item_iE_Extensions__item__extensionValue_tab
    ___SRSCarrier_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRSCarrier_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRSCarrier_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRSCarrier_List_Item_iE_Extensions__item__id),
        ('criticality', ___SRSCarrier_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SRSCarrier_List_Item_iE_Extensions__item__extensionValue),
        ])
    __SRSCarrier_List_Item_iE_Extensions__item_._ext = None
    _SRSCarrier_List_Item_iE_Extensions._cont = __SRSCarrier_List_Item_iE_Extensions__item_
    _SRSCarrier_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSCarrier_List_Item._cont = ASN1Dict([
        ('pointA', _SRSCarrier_List_Item_pointA),
        ('uplinkChannelBW-PerSCS-List', _SRSCarrier_List_Item_uplinkChannelBW_PerSCS_List),
        ('activeULBWP', _SRSCarrier_List_Item_activeULBWP),
        ('pci', _SRSCarrier_List_Item_pci),
        ('iE-Extensions', _SRSCarrier_List_Item_iE_Extensions),
        ])
    SRSCarrier_List_Item._ext = None
    
    #-----< SRSCarrier-List-Item-ExtIEs >-----#
    SRSCarrier_List_Item_ExtIEs = CLASS(name='SRSCarrier-List-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRSCarrier_List_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRSConfig >-----#
    SRSConfig = SEQ(name='SRSConfig', mode=MODE_TYPE)
    _SRSConfig_sRSResource_List = SEQ_OF(name='sRSResource-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSResource-List')), opt=True)
    _SRSConfig_posSRSResource_List = SEQ_OF(name='posSRSResource-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PosSRSResource-List')), opt=True)
    _SRSConfig_sRSResourceSet_List = SEQ_OF(name='sRSResourceSet-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceSet-List')), opt=True)
    _SRSConfig_posSRSResourceSet_List = SEQ_OF(name='posSRSResourceSet-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PosSRSResourceSet-List')), opt=True)
    _SRSConfig_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSConfig_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRSConfig_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SRSConfig_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSConfig_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSConfig_iE_Extensions__item__id._const_tab = ____SRSConfig_iE_Extensions__item__id_tab
    ___SRSConfig_iE_Extensions__item__id._const_tab_at = None
    ___SRSConfig_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRSConfig_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRSConfig_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSConfig_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSConfig_iE_Extensions__item__criticality._const_tab = ____SRSConfig_iE_Extensions__item__criticality_tab
    ___SRSConfig_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRSConfig_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRSConfig_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRSConfig_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSConfig_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSConfig_iE_Extensions__item__extensionValue._const_tab = ____SRSConfig_iE_Extensions__item__extensionValue_tab
    ___SRSConfig_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRSConfig_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRSConfig_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRSConfig_iE_Extensions__item__id),
        ('criticality', ___SRSConfig_iE_Extensions__item__criticality),
        ('extensionValue', ___SRSConfig_iE_Extensions__item__extensionValue),
        ])
    __SRSConfig_iE_Extensions__item_._ext = None
    _SRSConfig_iE_Extensions._cont = __SRSConfig_iE_Extensions__item_
    _SRSConfig_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSConfig._cont = ASN1Dict([
        ('sRSResource-List', _SRSConfig_sRSResource_List),
        ('posSRSResource-List', _SRSConfig_posSRSResource_List),
        ('sRSResourceSet-List', _SRSConfig_sRSResourceSet_List),
        ('posSRSResourceSet-List', _SRSConfig_posSRSResourceSet_List),
        ('iE-Extensions', _SRSConfig_iE_Extensions),
        ])
    SRSConfig._ext = None
    
    #-----< SRSConfig-ExtIEs >-----#
    SRSConfig_ExtIEs = CLASS(name='SRSConfig-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRSConfig_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRSConfiguration >-----#
    SRSConfiguration = SEQ(name='SRSConfiguration', mode=MODE_TYPE)
    _SRSConfiguration_sRSCarrier_List = SEQ_OF(name='sRSCarrier-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSCarrier-List')))
    _SRSConfiguration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRSConfiguration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SRSConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSConfiguration_iE_Extensions__item__id._const_tab = ____SRSConfiguration_iE_Extensions__item__id_tab
    ___SRSConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___SRSConfiguration_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRSConfiguration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRSConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSConfiguration_iE_Extensions__item__criticality._const_tab = ____SRSConfiguration_iE_Extensions__item__criticality_tab
    ___SRSConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRSConfiguration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRSConfiguration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRSConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSConfiguration_iE_Extensions__item__extensionValue._const_tab = ____SRSConfiguration_iE_Extensions__item__extensionValue_tab
    ___SRSConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRSConfiguration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRSConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRSConfiguration_iE_Extensions__item__id),
        ('criticality', ___SRSConfiguration_iE_Extensions__item__criticality),
        ('extensionValue', ___SRSConfiguration_iE_Extensions__item__extensionValue),
        ])
    __SRSConfiguration_iE_Extensions__item_._ext = None
    _SRSConfiguration_iE_Extensions._cont = __SRSConfiguration_iE_Extensions__item_
    _SRSConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSConfiguration._cont = ASN1Dict([
        ('sRSCarrier-List', _SRSConfiguration_sRSCarrier_List),
        ('iE-Extensions', _SRSConfiguration_iE_Extensions),
        ])
    SRSConfiguration._ext = None
    
    #-----< SRSConfiguration-ExtIEs >-----#
    SRSConfiguration_ExtIEs = CLASS(name='SRSConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRSConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SrsFrequency >-----#
    SrsFrequency = INT(name='SrsFrequency', mode=MODE_TYPE)
    SrsFrequency._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    
    #-----< SRSPortIndex >-----#
    SRSPortIndex = ENUM(name='SRSPortIndex', mode=MODE_TYPE)
    SRSPortIndex._cont = ASN1Dict([('id1000', 0), ('id1001', 1), ('id1002', 2), ('id1003', 3)])
    SRSPortIndex._ext = []
    
    #-----< SRSPosResourceID >-----#
    SRSPosResourceID = INT(name='SRSPosResourceID', mode=MODE_TYPE)
    SRSPosResourceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< SRSResource >-----#
    SRSResource = SEQ(name='SRSResource', mode=MODE_TYPE)
    _SRSResource_sRSResourceID = INT(name='sRSResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceID')))
    _SRSResource_nrofSRS_Ports = ENUM(name='nrofSRS-Ports', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_nrofSRS_Ports._cont = ASN1Dict([('port1', 0), ('ports2', 1), ('ports4', 2)])
    _SRSResource_nrofSRS_Ports._ext = None
    _SRSResource_transmissionComb = CHOICE(name='transmissionComb', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransmissionComb')))
    _SRSResource_startPosition = INT(name='startPosition', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_startPosition._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=13)], ev=None, er=[])
    _SRSResource_nrofSymbols = ENUM(name='nrofSymbols', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_nrofSymbols._cont = ASN1Dict([('n1', 0), ('n2', 1), ('n4', 2)])
    _SRSResource_nrofSymbols._ext = None
    _SRSResource_repetitionFactor = ENUM(name='repetitionFactor', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_repetitionFactor._cont = ASN1Dict([('n1', 0), ('n2', 1), ('n4', 2)])
    _SRSResource_repetitionFactor._ext = None
    _SRSResource_freqDomainPosition = INT(name='freqDomainPosition', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_freqDomainPosition._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=67)], ev=None, er=[])
    _SRSResource_freqDomainShift = INT(name='freqDomainShift', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_freqDomainShift._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=268)], ev=None, er=[])
    _SRSResource_c_SRS = INT(name='c-SRS', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_c_SRS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _SRSResource_b_SRS = INT(name='b-SRS', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_b_SRS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _SRSResource_b_hop = INT(name='b-hop', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_b_hop._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _SRSResource_groupOrSequenceHopping = ENUM(name='groupOrSequenceHopping', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_groupOrSequenceHopping._cont = ASN1Dict([('neither', 0), ('groupHopping', 1), ('sequenceHopping', 2)])
    _SRSResource_groupOrSequenceHopping._ext = None
    _SRSResource_resourceType = CHOICE(name='resourceType', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceType')))
    _SRSResource_sequenceId = INT(name='sequenceId', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_sequenceId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    _SRSResource_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSResource_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRSResource_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SRSResource_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSResource_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResource_iE_Extensions__item__id._const_tab = ____SRSResource_iE_Extensions__item__id_tab
    ___SRSResource_iE_Extensions__item__id._const_tab_at = None
    ___SRSResource_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRSResource_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRSResource_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSResource_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResource_iE_Extensions__item__criticality._const_tab = ____SRSResource_iE_Extensions__item__criticality_tab
    ___SRSResource_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRSResource_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRSResource_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRSResource_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSResource_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResource_iE_Extensions__item__extensionValue._const_tab = ____SRSResource_iE_Extensions__item__extensionValue_tab
    ___SRSResource_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRSResource_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRSResource_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRSResource_iE_Extensions__item__id),
        ('criticality', ___SRSResource_iE_Extensions__item__criticality),
        ('extensionValue', ___SRSResource_iE_Extensions__item__extensionValue),
        ])
    __SRSResource_iE_Extensions__item_._ext = None
    _SRSResource_iE_Extensions._cont = __SRSResource_iE_Extensions__item_
    _SRSResource_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSResource._cont = ASN1Dict([
        ('sRSResourceID', _SRSResource_sRSResourceID),
        ('nrofSRS-Ports', _SRSResource_nrofSRS_Ports),
        ('transmissionComb', _SRSResource_transmissionComb),
        ('startPosition', _SRSResource_startPosition),
        ('nrofSymbols', _SRSResource_nrofSymbols),
        ('repetitionFactor', _SRSResource_repetitionFactor),
        ('freqDomainPosition', _SRSResource_freqDomainPosition),
        ('freqDomainShift', _SRSResource_freqDomainShift),
        ('c-SRS', _SRSResource_c_SRS),
        ('b-SRS', _SRSResource_b_SRS),
        ('b-hop', _SRSResource_b_hop),
        ('groupOrSequenceHopping', _SRSResource_groupOrSequenceHopping),
        ('resourceType', _SRSResource_resourceType),
        ('sequenceId', _SRSResource_sequenceId),
        ('iE-Extensions', _SRSResource_iE_Extensions),
        ])
    SRSResource._ext = None
    
    #-----< SRSResource-ExtIEs >-----#
    SRSResource_ExtIEs = CLASS(name='SRSResource-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRSResource_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRSResourceID >-----#
    SRSResourceID = INT(name='SRSResourceID', mode=MODE_TYPE)
    SRSResourceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< SRSResourceID-List >-----#
    SRSResourceID_List = SEQ_OF(name='SRSResourceID-List', mode=MODE_TYPE)
    _SRSResourceID_List__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceID')))
    SRSResourceID_List._cont = _SRSResourceID_List__item_
    SRSResourceID_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SRSResource-List >-----#
    SRSResource_List = SEQ_OF(name='SRSResource-List', mode=MODE_TYPE)
    _SRSResource_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSResource')))
    SRSResource_List._cont = _SRSResource_List__item_
    SRSResource_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SRSResourceSet >-----#
    SRSResourceSet = SEQ(name='SRSResourceSet', mode=MODE_TYPE)
    _SRSResourceSet_sRSResourceSetID = INT(name='sRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceSetID')))
    _SRSResourceSet_sRSResourceID_List = SEQ_OF(name='sRSResourceID-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceID-List')))
    _SRSResourceSet_resourceSetType = CHOICE(name='resourceSetType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ResourceSetType')))
    _SRSResourceSet_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSResourceSet_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRSResourceSet_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SRSResourceSet_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSResourceSet_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceSet_iE_Extensions__item__id._const_tab = ____SRSResourceSet_iE_Extensions__item__id_tab
    ___SRSResourceSet_iE_Extensions__item__id._const_tab_at = None
    ___SRSResourceSet_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRSResourceSet_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRSResourceSet_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSResourceSet_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceSet_iE_Extensions__item__criticality._const_tab = ____SRSResourceSet_iE_Extensions__item__criticality_tab
    ___SRSResourceSet_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRSResourceSet_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRSResourceSet_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRSResourceSet_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSResourceSet_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceSet_iE_Extensions__item__extensionValue._const_tab = ____SRSResourceSet_iE_Extensions__item__extensionValue_tab
    ___SRSResourceSet_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRSResourceSet_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRSResourceSet_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRSResourceSet_iE_Extensions__item__id),
        ('criticality', ___SRSResourceSet_iE_Extensions__item__criticality),
        ('extensionValue', ___SRSResourceSet_iE_Extensions__item__extensionValue),
        ])
    __SRSResourceSet_iE_Extensions__item_._ext = None
    _SRSResourceSet_iE_Extensions._cont = __SRSResourceSet_iE_Extensions__item_
    _SRSResourceSet_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSResourceSet._cont = ASN1Dict([
        ('sRSResourceSetID', _SRSResourceSet_sRSResourceSetID),
        ('sRSResourceID-List', _SRSResourceSet_sRSResourceID_List),
        ('resourceSetType', _SRSResourceSet_resourceSetType),
        ('iE-Extensions', _SRSResourceSet_iE_Extensions),
        ])
    SRSResourceSet._ext = None
    
    #-----< SRSResourceSet-ExtIEs >-----#
    SRSResourceSet_ExtIEs = CLASS(name='SRSResourceSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRSResourceSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRSResourceSetID >-----#
    SRSResourceSetID = INT(name='SRSResourceSetID', mode=MODE_TYPE)
    SRSResourceSetID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    
    #-----< SRSResourceSetList >-----#
    SRSResourceSetList = SEQ_OF(name='SRSResourceSetList', mode=MODE_TYPE)
    _SRSResourceSetList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceSetItem')))
    SRSResourceSetList._cont = _SRSResourceSetList__item_
    SRSResourceSetList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SRSResourceSetItem >-----#
    SRSResourceSetItem = SEQ(name='SRSResourceSetItem', mode=MODE_TYPE)
    _SRSResourceSetItem_numSRSresourcesperset = INT(name='numSRSresourcesperset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SRSResourceSetItem_numSRSresourcesperset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=[], er=[])
    _SRSResourceSetItem_periodicityList = SEQ_OF(name='periodicityList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PeriodicityList')), opt=True)
    _SRSResourceSetItem_spatialRelationInfo = SEQ(name='spatialRelationInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SpatialRelationInfo')), opt=True)
    _SRSResourceSetItem_pathlossReferenceInfo = SEQ(name='pathlossReferenceInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PathlossReferenceInfo')), opt=True)
    _SRSResourceSetItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSResourceSetItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRSResourceSetItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SRSResourceSetItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____SRSResourceSetItem_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SpatialRelationPerSRSResource')))
    ____SRSResourceSetItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 435), ('criticality', 'ignore'), ('Extension', _____SRSResourceSetItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SRSResourceSetItem_iE_Extensions__item__id._const_tab = ____SRSResourceSetItem_iE_Extensions__item__id_tab
    ___SRSResourceSetItem_iE_Extensions__item__id._const_tab_at = None
    ___SRSResourceSetItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRSResourceSetItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SRSResourceSetItem_iE_Extensions__item__criticality._const_tab = ____SRSResourceSetItem_iE_Extensions__item__id_tab
    ___SRSResourceSetItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRSResourceSetItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRSResourceSetItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SRSResourceSetItem_iE_Extensions__item__extensionValue._const_tab = ____SRSResourceSetItem_iE_Extensions__item__id_tab
    ___SRSResourceSetItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRSResourceSetItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRSResourceSetItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRSResourceSetItem_iE_Extensions__item__id),
        ('criticality', ___SRSResourceSetItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SRSResourceSetItem_iE_Extensions__item__extensionValue),
        ])
    __SRSResourceSetItem_iE_Extensions__item_._ext = None
    _SRSResourceSetItem_iE_Extensions._cont = __SRSResourceSetItem_iE_Extensions__item_
    _SRSResourceSetItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSResourceSetItem._cont = ASN1Dict([
        ('numSRSresourcesperset', _SRSResourceSetItem_numSRSresourcesperset),
        ('periodicityList', _SRSResourceSetItem_periodicityList),
        ('spatialRelationInfo', _SRSResourceSetItem_spatialRelationInfo),
        ('pathlossReferenceInfo', _SRSResourceSetItem_pathlossReferenceInfo),
        ('iE-Extensions', _SRSResourceSetItem_iE_Extensions),
        ])
    SRSResourceSetItem._ext = None
    
    #-----< SRSResourceSetItemExtIEs >-----#
    SRSResourceSetItemExtIEs = CLASS(name='SRSResourceSetItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _SRSResourceSetItemExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SpatialRelationPerSRSResource')))
    SRSResourceSetItemExtIEs._val = ASN1Set(rv=[dict([('id', 435), ('criticality', 'ignore'), ('Extension', _SRSResourceSetItemExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SRSResourceSet-List >-----#
    SRSResourceSet_List = SEQ_OF(name='SRSResourceSet-List', mode=MODE_TYPE)
    _SRSResourceSet_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceSet')))
    SRSResourceSet_List._cont = _SRSResourceSet_List__item_
    SRSResourceSet_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SRSResourceTrigger >-----#
    SRSResourceTrigger = SEQ(name='SRSResourceTrigger', mode=MODE_TYPE)
    _SRSResourceTrigger_aperiodicSRSResourceTriggerList = SEQ_OF(name='aperiodicSRSResourceTriggerList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AperiodicSRSResourceTriggerList')))
    _SRSResourceTrigger_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSResourceTrigger_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRSResourceTrigger_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SRSResourceTrigger_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSResourceTrigger_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceTrigger_iE_Extensions__item__id._const_tab = ____SRSResourceTrigger_iE_Extensions__item__id_tab
    ___SRSResourceTrigger_iE_Extensions__item__id._const_tab_at = None
    ___SRSResourceTrigger_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRSResourceTrigger_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRSResourceTrigger_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSResourceTrigger_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceTrigger_iE_Extensions__item__criticality._const_tab = ____SRSResourceTrigger_iE_Extensions__item__criticality_tab
    ___SRSResourceTrigger_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRSResourceTrigger_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRSResourceTrigger_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRSResourceTrigger_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SRSResourceTrigger_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceTrigger_iE_Extensions__item__extensionValue._const_tab = ____SRSResourceTrigger_iE_Extensions__item__extensionValue_tab
    ___SRSResourceTrigger_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRSResourceTrigger_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRSResourceTrigger_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRSResourceTrigger_iE_Extensions__item__id),
        ('criticality', ___SRSResourceTrigger_iE_Extensions__item__criticality),
        ('extensionValue', ___SRSResourceTrigger_iE_Extensions__item__extensionValue),
        ])
    __SRSResourceTrigger_iE_Extensions__item_._ext = None
    _SRSResourceTrigger_iE_Extensions._cont = __SRSResourceTrigger_iE_Extensions__item_
    _SRSResourceTrigger_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSResourceTrigger._cont = ASN1Dict([
        ('aperiodicSRSResourceTriggerList', _SRSResourceTrigger_aperiodicSRSResourceTriggerList),
        ('iE-Extensions', _SRSResourceTrigger_iE_Extensions),
        ])
    SRSResourceTrigger._ext = None
    
    #-----< SRSResourceTrigger-ExtIEs >-----#
    SRSResourceTrigger_ExtIEs = CLASS(name='SRSResourceTrigger-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SRSResourceTrigger_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRSResourcetype >-----#
    SRSResourcetype = SEQ(name='SRSResourcetype', mode=MODE_TYPE)
    _SRSResourcetype_sRSResourceTypeChoice = CHOICE(name='sRSResourceTypeChoice', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceTypeChoice')))
    _SRSResourcetype_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSResourcetype_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SRSResourcetype_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SRSResourcetype_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____SRSResourcetype_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSPortIndex')))
    ____SRSResourcetype_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 663), ('criticality', 'ignore'), ('Extension', _____SRSResourcetype_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SRSResourcetype_iE_Extensions__item__id._const_tab = ____SRSResourcetype_iE_Extensions__item__id_tab
    ___SRSResourcetype_iE_Extensions__item__id._const_tab_at = None
    ___SRSResourcetype_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRSResourcetype_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SRSResourcetype_iE_Extensions__item__criticality._const_tab = ____SRSResourcetype_iE_Extensions__item__id_tab
    ___SRSResourcetype_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRSResourcetype_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRSResourcetype_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SRSResourcetype_iE_Extensions__item__extensionValue._const_tab = ____SRSResourcetype_iE_Extensions__item__id_tab
    ___SRSResourcetype_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRSResourcetype_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRSResourcetype_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRSResourcetype_iE_Extensions__item__id),
        ('criticality', ___SRSResourcetype_iE_Extensions__item__criticality),
        ('extensionValue', ___SRSResourcetype_iE_Extensions__item__extensionValue),
        ])
    __SRSResourcetype_iE_Extensions__item_._ext = None
    _SRSResourcetype_iE_Extensions._cont = __SRSResourcetype_iE_Extensions__item_
    _SRSResourcetype_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSResourcetype._cont = ASN1Dict([
        ('sRSResourceTypeChoice', _SRSResourcetype_sRSResourceTypeChoice),
        ('iE-Extensions', _SRSResourcetype_iE_Extensions),
        ])
    SRSResourcetype._ext = []
    
    #-----< SRSResourcetype-ExtIEs >-----#
    SRSResourcetype_ExtIEs = CLASS(name='SRSResourcetype-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _SRSResourcetype_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSPortIndex')))
    SRSResourcetype_ExtIEs._val = ASN1Set(rv=[dict([('id', 663), ('criticality', 'ignore'), ('Extension', _SRSResourcetype_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SRSResourceTypeChoice >-----#
    SRSResourceTypeChoice = CHOICE(name='SRSResourceTypeChoice', mode=MODE_TYPE)
    _SRSResourceTypeChoice_sRSResourceInfo = SEQ(name='sRSResourceInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSInfo')))
    _SRSResourceTypeChoice_posSRSResourceInfo = SEQ(name='posSRSResourceInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PosSRSInfo')))
    _SRSResourceTypeChoice_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SRSResourceTypeChoice_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SRSResourceTypeChoice_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SRSResourceTypeChoice_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SRSResourceTypeChoice_choice_extension_id._const_tab = ___SRSResourceTypeChoice_choice_extension_id_tab
    __SRSResourceTypeChoice_choice_extension_id._const_tab_at = None
    __SRSResourceTypeChoice_choice_extension_id._const_tab_id = 'id'
    __SRSResourceTypeChoice_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___SRSResourceTypeChoice_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SRSResourceTypeChoice_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SRSResourceTypeChoice_choice_extension_criticality._const_tab = ___SRSResourceTypeChoice_choice_extension_criticality_tab
    __SRSResourceTypeChoice_choice_extension_criticality._const_tab_at = ('..', 'id')
    __SRSResourceTypeChoice_choice_extension_criticality._const_tab_id = 'criticality'
    __SRSResourceTypeChoice_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___SRSResourceTypeChoice_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SRSResourceTypeChoice_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SRSResourceTypeChoice_choice_extension_value._const_tab = ___SRSResourceTypeChoice_choice_extension_value_tab
    __SRSResourceTypeChoice_choice_extension_value._const_tab_at = ('..', 'id')
    __SRSResourceTypeChoice_choice_extension_value._const_tab_id = 'Value'
    _SRSResourceTypeChoice_choice_extension._cont = ASN1Dict([
        ('id', __SRSResourceTypeChoice_choice_extension_id),
        ('criticality', __SRSResourceTypeChoice_choice_extension_criticality),
        ('value', __SRSResourceTypeChoice_choice_extension_value),
        ])
    _SRSResourceTypeChoice_choice_extension._ext = None
    SRSResourceTypeChoice._cont = ASN1Dict([
        ('sRSResourceInfo', _SRSResourceTypeChoice_sRSResourceInfo),
        ('posSRSResourceInfo', _SRSResourceTypeChoice_posSRSResourceInfo),
        ('choice-extension', _SRSResourceTypeChoice_choice_extension),
        ])
    SRSResourceTypeChoice._ext = None
    
    #-----< SRSResourceTypeChoice-ExtIEs >-----#
    SRSResourceTypeChoice_ExtIEs = CLASS(name='SRSResourceTypeChoice-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    SRSResourceTypeChoice_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRSInfo >-----#
    SRSInfo = SEQ(name='SRSInfo', mode=MODE_TYPE)
    _SRSInfo_sRSResource = INT(name='sRSResource', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceID')))
    SRSInfo._cont = ASN1Dict([
        ('sRSResource', _SRSInfo_sRSResource),
        ])
    SRSInfo._ext = []
    
    #-----< SRSPosRRCInactiveConfig >-----#
    SRSPosRRCInactiveConfig = OCT_STR(name='SRSPosRRCInactiveConfig', mode=MODE_TYPE)
    
    #-----< SRSPosRRCInactiveQueryIndication >-----#
    SRSPosRRCInactiveQueryIndication = ENUM(name='SRSPosRRCInactiveQueryIndication', mode=MODE_TYPE)
    SRSPosRRCInactiveQueryIndication._cont = ASN1Dict([('true', 0)])
    SRSPosRRCInactiveQueryIndication._ext = []
    
    #-----< PosSRSInfo >-----#
    PosSRSInfo = SEQ(name='PosSRSInfo', mode=MODE_TYPE)
    _PosSRSInfo_posSRSResourceID = INT(name='posSRSResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSPosResourceID')))
    PosSRSInfo._cont = ASN1Dict([
        ('posSRSResourceID', _PosSRSInfo_posSRSResourceID),
        ])
    PosSRSInfo._ext = []
    
    #-----< SSB >-----#
    SSB = SEQ(name='SSB', mode=MODE_TYPE)
    _SSB_pCI_NR = INT(name='pCI-NR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRPCI')))
    _SSB_ssb_index = INT(name='ssb-index', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB-Index')), opt=True)
    _SSB_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SSB_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SSB_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SSB_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSB_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSB_iE_Extensions__item__id._const_tab = ____SSB_iE_Extensions__item__id_tab
    ___SSB_iE_Extensions__item__id._const_tab_at = None
    ___SSB_iE_Extensions__item__id._const_tab_id = 'id'
    ___SSB_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SSB_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSB_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSB_iE_Extensions__item__criticality._const_tab = ____SSB_iE_Extensions__item__criticality_tab
    ___SSB_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SSB_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SSB_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SSB_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSB_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSB_iE_Extensions__item__extensionValue._const_tab = ____SSB_iE_Extensions__item__extensionValue_tab
    ___SSB_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SSB_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SSB_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SSB_iE_Extensions__item__id),
        ('criticality', ___SSB_iE_Extensions__item__criticality),
        ('extensionValue', ___SSB_iE_Extensions__item__extensionValue),
        ])
    __SSB_iE_Extensions__item_._ext = None
    _SSB_iE_Extensions._cont = __SSB_iE_Extensions__item_
    _SSB_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SSB._cont = ASN1Dict([
        ('pCI-NR', _SSB_pCI_NR),
        ('ssb-index', _SSB_ssb_index),
        ('iE-Extensions', _SSB_iE_Extensions),
        ])
    SSB._ext = None
    
    #-----< SSBCoverageModification-List >-----#
    SSBCoverageModification_List = SEQ_OF(name='SSBCoverageModification-List', mode=MODE_TYPE)
    _SSBCoverageModification_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SSBCoverageModification-Item')))
    SSBCoverageModification_List._cont = _SSBCoverageModification_List__item_
    SSBCoverageModification_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SSBCoverageModification-Item >-----#
    SSBCoverageModification_Item = SEQ(name='SSBCoverageModification-Item', mode=MODE_TYPE)
    _SSBCoverageModification_Item_sSBIndex = INT(name='sSBIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBCoverageModification_Item_sSBIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _SSBCoverageModification_Item_sSBCoverageState = INT(name='sSBCoverageState', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSBCoverageState')))
    _SSBCoverageModification_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SSBCoverageModification_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SSBCoverageModification_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SSBCoverageModification_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBCoverageModification_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBCoverageModification_Item_iE_Extensions__item__id._const_tab = ____SSBCoverageModification_Item_iE_Extensions__item__id_tab
    ___SSBCoverageModification_Item_iE_Extensions__item__id._const_tab_at = None
    ___SSBCoverageModification_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SSBCoverageModification_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SSBCoverageModification_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBCoverageModification_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBCoverageModification_Item_iE_Extensions__item__criticality._const_tab = ____SSBCoverageModification_Item_iE_Extensions__item__criticality_tab
    ___SSBCoverageModification_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SSBCoverageModification_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SSBCoverageModification_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SSBCoverageModification_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBCoverageModification_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBCoverageModification_Item_iE_Extensions__item__extensionValue._const_tab = ____SSBCoverageModification_Item_iE_Extensions__item__extensionValue_tab
    ___SSBCoverageModification_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SSBCoverageModification_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SSBCoverageModification_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SSBCoverageModification_Item_iE_Extensions__item__id),
        ('criticality', ___SSBCoverageModification_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SSBCoverageModification_Item_iE_Extensions__item__extensionValue),
        ])
    __SSBCoverageModification_Item_iE_Extensions__item_._ext = None
    _SSBCoverageModification_Item_iE_Extensions._cont = __SSBCoverageModification_Item_iE_Extensions__item_
    _SSBCoverageModification_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SSBCoverageModification_Item._cont = ASN1Dict([
        ('sSBIndex', _SSBCoverageModification_Item_sSBIndex),
        ('sSBCoverageState', _SSBCoverageModification_Item_sSBCoverageState),
        ('iE-Extensions', _SSBCoverageModification_Item_iE_Extensions),
        ])
    SSBCoverageModification_Item._ext = []
    
    #-----< SSBCoverageModification-Item-ExtIEs >-----#
    SSBCoverageModification_Item_ExtIEs = CLASS(name='SSBCoverageModification-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SSBCoverageModification_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSBCoverageState >-----#
    SSBCoverageState = INT(name='SSBCoverageState', mode=MODE_TYPE)
    SSBCoverageState._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    
    #-----< SSB-ExtIEs >-----#
    SSB_ExtIEs = CLASS(name='SSB-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SSB_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSB-freqInfo >-----#
    SSB_freqInfo = INT(name='SSB-freqInfo', mode=MODE_TYPE)
    SSB_freqInfo._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    
    #-----< SSB-Index >-----#
    SSB_Index = INT(name='SSB-Index', mode=MODE_TYPE)
    SSB_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< SSB-subcarrierSpacing >-----#
    SSB_subcarrierSpacing = ENUM(name='SSB-subcarrierSpacing', mode=MODE_TYPE)
    SSB_subcarrierSpacing._cont = ASN1Dict([('kHz15', 0), ('kHz30', 1), ('kHz120', 2), ('kHz240', 3), ('spare3', 4), ('spare2', 5), ('spare1', 6)])
    SSB_subcarrierSpacing._ext = []
    
    #-----< SSB-transmissionPeriodicity >-----#
    SSB_transmissionPeriodicity = ENUM(name='SSB-transmissionPeriodicity', mode=MODE_TYPE)
    SSB_transmissionPeriodicity._cont = ASN1Dict([('sf10', 0), ('sf20', 1), ('sf40', 2), ('sf80', 3), ('sf160', 4), ('sf320', 5), ('sf640', 6)])
    SSB_transmissionPeriodicity._ext = []
    
    #-----< SSB-transmissionTimingOffset >-----#
    SSB_transmissionTimingOffset = INT(name='SSB-transmissionTimingOffset', mode=MODE_TYPE)
    SSB_transmissionTimingOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=[], er=[])
    
    #-----< SSB-transmissionBitmap >-----#
    SSB_transmissionBitmap = CHOICE(name='SSB-transmissionBitmap', mode=MODE_TYPE)
    _SSB_transmissionBitmap_shortBitmap = BIT_STR(name='shortBitmap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_transmissionBitmap_shortBitmap._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _SSB_transmissionBitmap_mediumBitmap = BIT_STR(name='mediumBitmap', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_transmissionBitmap_mediumBitmap._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _SSB_transmissionBitmap_longBitmap = BIT_STR(name='longBitmap', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_transmissionBitmap_longBitmap._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    _SSB_transmissionBitmap_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SSB_transmissionBitmap_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SSB_transmissionBitmap_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SSB_transmissionBitmap_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SSB_transmissionBitmap_choice_extension_id._const_tab = ___SSB_transmissionBitmap_choice_extension_id_tab
    __SSB_transmissionBitmap_choice_extension_id._const_tab_at = None
    __SSB_transmissionBitmap_choice_extension_id._const_tab_id = 'id'
    __SSB_transmissionBitmap_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___SSB_transmissionBitmap_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SSB_transmissionBitmap_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SSB_transmissionBitmap_choice_extension_criticality._const_tab = ___SSB_transmissionBitmap_choice_extension_criticality_tab
    __SSB_transmissionBitmap_choice_extension_criticality._const_tab_at = ('..', 'id')
    __SSB_transmissionBitmap_choice_extension_criticality._const_tab_id = 'criticality'
    __SSB_transmissionBitmap_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___SSB_transmissionBitmap_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SSB_transmissionBitmap_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SSB_transmissionBitmap_choice_extension_value._const_tab = ___SSB_transmissionBitmap_choice_extension_value_tab
    __SSB_transmissionBitmap_choice_extension_value._const_tab_at = ('..', 'id')
    __SSB_transmissionBitmap_choice_extension_value._const_tab_id = 'Value'
    _SSB_transmissionBitmap_choice_extension._cont = ASN1Dict([
        ('id', __SSB_transmissionBitmap_choice_extension_id),
        ('criticality', __SSB_transmissionBitmap_choice_extension_criticality),
        ('value', __SSB_transmissionBitmap_choice_extension_value),
        ])
    _SSB_transmissionBitmap_choice_extension._ext = None
    SSB_transmissionBitmap._cont = ASN1Dict([
        ('shortBitmap', _SSB_transmissionBitmap_shortBitmap),
        ('mediumBitmap', _SSB_transmissionBitmap_mediumBitmap),
        ('longBitmap', _SSB_transmissionBitmap_longBitmap),
        ('choice-extension', _SSB_transmissionBitmap_choice_extension),
        ])
    SSB_transmissionBitmap._ext = None
    
    #-----< SSB-transmisisonBitmap-ExtIEs >-----#
    SSB_transmisisonBitmap_ExtIEs = CLASS(name='SSB-transmisisonBitmap-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    SSB_transmisisonBitmap_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSBAreaCapacityValueList >-----#
    SSBAreaCapacityValueList = SEQ_OF(name='SSBAreaCapacityValueList', mode=MODE_TYPE)
    _SSBAreaCapacityValueList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SSBAreaCapacityValueItem')))
    SSBAreaCapacityValueList._cont = _SSBAreaCapacityValueList__item_
    SSBAreaCapacityValueList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SSBAreaCapacityValueItem >-----#
    SSBAreaCapacityValueItem = SEQ(name='SSBAreaCapacityValueItem', mode=MODE_TYPE)
    _SSBAreaCapacityValueItem_sSBIndex = INT(name='sSBIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBAreaCapacityValueItem_sSBIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _SSBAreaCapacityValueItem_sSBAreaCapacityValue = INT(name='sSBAreaCapacityValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBAreaCapacityValueItem_sSBAreaCapacityValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaCapacityValueItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SSBAreaCapacityValueItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SSBAreaCapacityValueItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SSBAreaCapacityValueItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBAreaCapacityValueItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBAreaCapacityValueItem_iE_Extensions__item__id._const_tab = ____SSBAreaCapacityValueItem_iE_Extensions__item__id_tab
    ___SSBAreaCapacityValueItem_iE_Extensions__item__id._const_tab_at = None
    ___SSBAreaCapacityValueItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SSBAreaCapacityValueItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SSBAreaCapacityValueItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBAreaCapacityValueItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBAreaCapacityValueItem_iE_Extensions__item__criticality._const_tab = ____SSBAreaCapacityValueItem_iE_Extensions__item__criticality_tab
    ___SSBAreaCapacityValueItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SSBAreaCapacityValueItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SSBAreaCapacityValueItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SSBAreaCapacityValueItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBAreaCapacityValueItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBAreaCapacityValueItem_iE_Extensions__item__extensionValue._const_tab = ____SSBAreaCapacityValueItem_iE_Extensions__item__extensionValue_tab
    ___SSBAreaCapacityValueItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SSBAreaCapacityValueItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SSBAreaCapacityValueItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SSBAreaCapacityValueItem_iE_Extensions__item__id),
        ('criticality', ___SSBAreaCapacityValueItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SSBAreaCapacityValueItem_iE_Extensions__item__extensionValue),
        ])
    __SSBAreaCapacityValueItem_iE_Extensions__item_._ext = None
    _SSBAreaCapacityValueItem_iE_Extensions._cont = __SSBAreaCapacityValueItem_iE_Extensions__item_
    _SSBAreaCapacityValueItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SSBAreaCapacityValueItem._cont = ASN1Dict([
        ('sSBIndex', _SSBAreaCapacityValueItem_sSBIndex),
        ('sSBAreaCapacityValue', _SSBAreaCapacityValueItem_sSBAreaCapacityValue),
        ('iE-Extensions', _SSBAreaCapacityValueItem_iE_Extensions),
        ])
    SSBAreaCapacityValueItem._ext = None
    
    #-----< SSBAreaCapacityValueItem-ExtIEs >-----#
    SSBAreaCapacityValueItem_ExtIEs = CLASS(name='SSBAreaCapacityValueItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SSBAreaCapacityValueItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSBAreaRadioResourceStatusList >-----#
    SSBAreaRadioResourceStatusList = SEQ_OF(name='SSBAreaRadioResourceStatusList', mode=MODE_TYPE)
    _SSBAreaRadioResourceStatusList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SSBAreaRadioResourceStatusItem')))
    SSBAreaRadioResourceStatusList._cont = _SSBAreaRadioResourceStatusList__item_
    SSBAreaRadioResourceStatusList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SSBAreaRadioResourceStatusItem >-----#
    SSBAreaRadioResourceStatusItem = SEQ(name='SSBAreaRadioResourceStatusItem', mode=MODE_TYPE)
    _SSBAreaRadioResourceStatusItem_sSBIndex = INT(name='sSBIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBAreaRadioResourceStatusItem_sSBIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _SSBAreaRadioResourceStatusItem_sSBAreaDLGBRPRBusage = INT(name='sSBAreaDLGBRPRBusage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBAreaRadioResourceStatusItem_sSBAreaDLGBRPRBusage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaRadioResourceStatusItem_sSBAreaULGBRPRBusage = INT(name='sSBAreaULGBRPRBusage', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBAreaRadioResourceStatusItem_sSBAreaULGBRPRBusage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaRadioResourceStatusItem_sSBAreaDLnon_GBRPRBusage = INT(name='sSBAreaDLnon-GBRPRBusage', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBAreaRadioResourceStatusItem_sSBAreaDLnon_GBRPRBusage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaRadioResourceStatusItem_sSBAreaULnon_GBRPRBusage = INT(name='sSBAreaULnon-GBRPRBusage', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBAreaRadioResourceStatusItem_sSBAreaULnon_GBRPRBusage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaRadioResourceStatusItem_sSBAreaDLTotalPRBusage = INT(name='sSBAreaDLTotalPRBusage', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBAreaRadioResourceStatusItem_sSBAreaDLTotalPRBusage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaRadioResourceStatusItem_sSBAreaULTotalPRBusage = INT(name='sSBAreaULTotalPRBusage', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBAreaRadioResourceStatusItem_sSBAreaULTotalPRBusage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaRadioResourceStatusItem_dLschedulingPDCCHCCEusage = INT(name='dLschedulingPDCCHCCEusage', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SSBAreaRadioResourceStatusItem_dLschedulingPDCCHCCEusage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaRadioResourceStatusItem_uLschedulingPDCCHCCEusage = INT(name='uLschedulingPDCCHCCEusage', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SSBAreaRadioResourceStatusItem_uLschedulingPDCCHCCEusage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaRadioResourceStatusItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SSBAreaRadioResourceStatusItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SSBAreaRadioResourceStatusItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBAreaRadioResourceStatusItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__id._const_tab = ____SSBAreaRadioResourceStatusItem_iE_Extensions__item__id_tab
    ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__id._const_tab_at = None
    ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SSBAreaRadioResourceStatusItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBAreaRadioResourceStatusItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__criticality._const_tab = ____SSBAreaRadioResourceStatusItem_iE_Extensions__item__criticality_tab
    ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SSBAreaRadioResourceStatusItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBAreaRadioResourceStatusItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__extensionValue._const_tab = ____SSBAreaRadioResourceStatusItem_iE_Extensions__item__extensionValue_tab
    ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SSBAreaRadioResourceStatusItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__id),
        ('criticality', ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__extensionValue),
        ])
    __SSBAreaRadioResourceStatusItem_iE_Extensions__item_._ext = None
    _SSBAreaRadioResourceStatusItem_iE_Extensions._cont = __SSBAreaRadioResourceStatusItem_iE_Extensions__item_
    _SSBAreaRadioResourceStatusItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SSBAreaRadioResourceStatusItem._cont = ASN1Dict([
        ('sSBIndex', _SSBAreaRadioResourceStatusItem_sSBIndex),
        ('sSBAreaDLGBRPRBusage', _SSBAreaRadioResourceStatusItem_sSBAreaDLGBRPRBusage),
        ('sSBAreaULGBRPRBusage', _SSBAreaRadioResourceStatusItem_sSBAreaULGBRPRBusage),
        ('sSBAreaDLnon-GBRPRBusage', _SSBAreaRadioResourceStatusItem_sSBAreaDLnon_GBRPRBusage),
        ('sSBAreaULnon-GBRPRBusage', _SSBAreaRadioResourceStatusItem_sSBAreaULnon_GBRPRBusage),
        ('sSBAreaDLTotalPRBusage', _SSBAreaRadioResourceStatusItem_sSBAreaDLTotalPRBusage),
        ('sSBAreaULTotalPRBusage', _SSBAreaRadioResourceStatusItem_sSBAreaULTotalPRBusage),
        ('dLschedulingPDCCHCCEusage', _SSBAreaRadioResourceStatusItem_dLschedulingPDCCHCCEusage),
        ('uLschedulingPDCCHCCEusage', _SSBAreaRadioResourceStatusItem_uLschedulingPDCCHCCEusage),
        ('iE-Extensions', _SSBAreaRadioResourceStatusItem_iE_Extensions),
        ])
    SSBAreaRadioResourceStatusItem._ext = None
    
    #-----< SSBAreaRadioResourceStatusItem-ExtIEs >-----#
    SSBAreaRadioResourceStatusItem_ExtIEs = CLASS(name='SSBAreaRadioResourceStatusItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SSBAreaRadioResourceStatusItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSBInformation >-----#
    SSBInformation = SEQ(name='SSBInformation', mode=MODE_TYPE)
    _SSBInformation_sSBInformationList = SEQ_OF(name='sSBInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSBInformationList')))
    _SSBInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SSBInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SSBInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SSBInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBInformation_iE_Extensions__item__id._const_tab = ____SSBInformation_iE_Extensions__item__id_tab
    ___SSBInformation_iE_Extensions__item__id._const_tab_at = None
    ___SSBInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___SSBInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SSBInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBInformation_iE_Extensions__item__criticality._const_tab = ____SSBInformation_iE_Extensions__item__criticality_tab
    ___SSBInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SSBInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SSBInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SSBInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBInformation_iE_Extensions__item__extensionValue._const_tab = ____SSBInformation_iE_Extensions__item__extensionValue_tab
    ___SSBInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SSBInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SSBInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SSBInformation_iE_Extensions__item__id),
        ('criticality', ___SSBInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___SSBInformation_iE_Extensions__item__extensionValue),
        ])
    __SSBInformation_iE_Extensions__item_._ext = None
    _SSBInformation_iE_Extensions._cont = __SSBInformation_iE_Extensions__item_
    _SSBInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SSBInformation._cont = ASN1Dict([
        ('sSBInformationList', _SSBInformation_sSBInformationList),
        ('iE-Extensions', _SSBInformation_iE_Extensions),
        ])
    SSBInformation._ext = None
    
    #-----< SSBInformation-ExtIEs >-----#
    SSBInformation_ExtIEs = CLASS(name='SSBInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SSBInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSBInformationList >-----#
    SSBInformationList = SEQ_OF(name='SSBInformationList', mode=MODE_TYPE)
    _SSBInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SSBInformationItem')))
    SSBInformationList._cont = _SSBInformationList__item_
    SSBInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    
    #-----< SSBInformationItem >-----#
    SSBInformationItem = SEQ(name='SSBInformationItem', mode=MODE_TYPE)
    _SSBInformationItem_sSB_Configuration = SEQ(name='sSB-Configuration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB-TF-Configuration')))
    _SSBInformationItem_pCI_NR = INT(name='pCI-NR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRPCI')))
    _SSBInformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SSBInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SSBInformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SSBInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBInformationItem_iE_Extensions__item__id._const_tab = ____SSBInformationItem_iE_Extensions__item__id_tab
    ___SSBInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___SSBInformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SSBInformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SSBInformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBInformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBInformationItem_iE_Extensions__item__criticality._const_tab = ____SSBInformationItem_iE_Extensions__item__criticality_tab
    ___SSBInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SSBInformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SSBInformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SSBInformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBInformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBInformationItem_iE_Extensions__item__extensionValue._const_tab = ____SSBInformationItem_iE_Extensions__item__extensionValue_tab
    ___SSBInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SSBInformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SSBInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SSBInformationItem_iE_Extensions__item__id),
        ('criticality', ___SSBInformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SSBInformationItem_iE_Extensions__item__extensionValue),
        ])
    __SSBInformationItem_iE_Extensions__item_._ext = None
    _SSBInformationItem_iE_Extensions._cont = __SSBInformationItem_iE_Extensions__item_
    _SSBInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SSBInformationItem._cont = ASN1Dict([
        ('sSB-Configuration', _SSBInformationItem_sSB_Configuration),
        ('pCI-NR', _SSBInformationItem_pCI_NR),
        ('iE-Extensions', _SSBInformationItem_iE_Extensions),
        ])
    SSBInformationItem._ext = None
    
    #-----< SSBInformationItem-ExtIEs >-----#
    SSBInformationItem_ExtIEs = CLASS(name='SSBInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SSBInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSB-PositionsInBurst >-----#
    SSB_PositionsInBurst = CHOICE(name='SSB-PositionsInBurst', mode=MODE_TYPE)
    _SSB_PositionsInBurst_shortBitmap = BIT_STR(name='shortBitmap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_PositionsInBurst_shortBitmap._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _SSB_PositionsInBurst_mediumBitmap = BIT_STR(name='mediumBitmap', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_PositionsInBurst_mediumBitmap._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _SSB_PositionsInBurst_longBitmap = BIT_STR(name='longBitmap', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_PositionsInBurst_longBitmap._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    _SSB_PositionsInBurst_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SSB_PositionsInBurst_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SSB_PositionsInBurst_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SSB_PositionsInBurst_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SSB_PositionsInBurst_choice_extension_id._const_tab = ___SSB_PositionsInBurst_choice_extension_id_tab
    __SSB_PositionsInBurst_choice_extension_id._const_tab_at = None
    __SSB_PositionsInBurst_choice_extension_id._const_tab_id = 'id'
    __SSB_PositionsInBurst_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___SSB_PositionsInBurst_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SSB_PositionsInBurst_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SSB_PositionsInBurst_choice_extension_criticality._const_tab = ___SSB_PositionsInBurst_choice_extension_criticality_tab
    __SSB_PositionsInBurst_choice_extension_criticality._const_tab_at = ('..', 'id')
    __SSB_PositionsInBurst_choice_extension_criticality._const_tab_id = 'criticality'
    __SSB_PositionsInBurst_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___SSB_PositionsInBurst_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SSB_PositionsInBurst_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SSB_PositionsInBurst_choice_extension_value._const_tab = ___SSB_PositionsInBurst_choice_extension_value_tab
    __SSB_PositionsInBurst_choice_extension_value._const_tab_at = ('..', 'id')
    __SSB_PositionsInBurst_choice_extension_value._const_tab_id = 'Value'
    _SSB_PositionsInBurst_choice_extension._cont = ASN1Dict([
        ('id', __SSB_PositionsInBurst_choice_extension_id),
        ('criticality', __SSB_PositionsInBurst_choice_extension_criticality),
        ('value', __SSB_PositionsInBurst_choice_extension_value),
        ])
    _SSB_PositionsInBurst_choice_extension._ext = None
    SSB_PositionsInBurst._cont = ASN1Dict([
        ('shortBitmap', _SSB_PositionsInBurst_shortBitmap),
        ('mediumBitmap', _SSB_PositionsInBurst_mediumBitmap),
        ('longBitmap', _SSB_PositionsInBurst_longBitmap),
        ('choice-extension', _SSB_PositionsInBurst_choice_extension),
        ])
    SSB_PositionsInBurst._ext = None
    
    #-----< SSB-PositionsInBurst-ExtIEs >-----#
    SSB_PositionsInBurst_ExtIEs = CLASS(name='SSB-PositionsInBurst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    SSB_PositionsInBurst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSB-TF-Configuration >-----#
    SSB_TF_Configuration = SEQ(name='SSB-TF-Configuration', mode=MODE_TYPE)
    _SSB_TF_Configuration_sSB_frequency = INT(name='sSB-frequency', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_TF_Configuration_sSB_frequency._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _SSB_TF_Configuration_sSB_subcarrier_spacing = ENUM(name='sSB-subcarrier-spacing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_TF_Configuration_sSB_subcarrier_spacing._cont = ASN1Dict([('kHz15', 0), ('kHz30', 1), ('kHz60', 2), ('kHz120', 3), ('kHz240', 4)])
    _SSB_TF_Configuration_sSB_subcarrier_spacing._ext = []
    _SSB_TF_Configuration_sSB_Transmit_power = INT(name='sSB-Transmit-power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_TF_Configuration_sSB_Transmit_power._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-60, ub=50)], ev=None, er=[])
    _SSB_TF_Configuration_sSB_periodicity = ENUM(name='sSB-periodicity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_TF_Configuration_sSB_periodicity._cont = ASN1Dict([('ms5', 0), ('ms10', 1), ('ms20', 2), ('ms40', 3), ('ms80', 4), ('ms160', 5)])
    _SSB_TF_Configuration_sSB_periodicity._ext = []
    _SSB_TF_Configuration_sSB_half_frame_offset = INT(name='sSB-half-frame-offset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_TF_Configuration_sSB_half_frame_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    _SSB_TF_Configuration_sSB_SFN_offset = INT(name='sSB-SFN-offset', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_TF_Configuration_sSB_SFN_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _SSB_TF_Configuration_sSB_position_in_burst = CHOICE(name='sSB-position-in-burst', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSB-PositionsInBurst')), opt=True)
    _SSB_TF_Configuration_sFNInitialisationTime = BIT_STR(name='sFNInitialisationTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RelativeTime1900')), opt=True)
    _SSB_TF_Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SSB_TF_Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SSB_TF_Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SSB_TF_Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSB_TF_Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSB_TF_Configuration_iE_Extensions__item__id._const_tab = ____SSB_TF_Configuration_iE_Extensions__item__id_tab
    ___SSB_TF_Configuration_iE_Extensions__item__id._const_tab_at = None
    ___SSB_TF_Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___SSB_TF_Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SSB_TF_Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSB_TF_Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSB_TF_Configuration_iE_Extensions__item__criticality._const_tab = ____SSB_TF_Configuration_iE_Extensions__item__criticality_tab
    ___SSB_TF_Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SSB_TF_Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SSB_TF_Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SSB_TF_Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSB_TF_Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSB_TF_Configuration_iE_Extensions__item__extensionValue._const_tab = ____SSB_TF_Configuration_iE_Extensions__item__extensionValue_tab
    ___SSB_TF_Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SSB_TF_Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SSB_TF_Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SSB_TF_Configuration_iE_Extensions__item__id),
        ('criticality', ___SSB_TF_Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___SSB_TF_Configuration_iE_Extensions__item__extensionValue),
        ])
    __SSB_TF_Configuration_iE_Extensions__item_._ext = None
    _SSB_TF_Configuration_iE_Extensions._cont = __SSB_TF_Configuration_iE_Extensions__item_
    _SSB_TF_Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SSB_TF_Configuration._cont = ASN1Dict([
        ('sSB-frequency', _SSB_TF_Configuration_sSB_frequency),
        ('sSB-subcarrier-spacing', _SSB_TF_Configuration_sSB_subcarrier_spacing),
        ('sSB-Transmit-power', _SSB_TF_Configuration_sSB_Transmit_power),
        ('sSB-periodicity', _SSB_TF_Configuration_sSB_periodicity),
        ('sSB-half-frame-offset', _SSB_TF_Configuration_sSB_half_frame_offset),
        ('sSB-SFN-offset', _SSB_TF_Configuration_sSB_SFN_offset),
        ('sSB-position-in-burst', _SSB_TF_Configuration_sSB_position_in_burst),
        ('sFNInitialisationTime', _SSB_TF_Configuration_sFNInitialisationTime),
        ('iE-Extensions', _SSB_TF_Configuration_iE_Extensions),
        ])
    SSB_TF_Configuration._ext = None
    
    #-----< SSB-TF-Configuration-ExtIEs >-----#
    SSB_TF_Configuration_ExtIEs = CLASS(name='SSB-TF-Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SSB_TF_Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSBToReportList >-----#
    SSBToReportList = SEQ_OF(name='SSBToReportList', mode=MODE_TYPE)
    _SSBToReportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SSBToReportItem')))
    SSBToReportList._cont = _SSBToReportList__item_
    SSBToReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SSBToReportItem >-----#
    SSBToReportItem = SEQ(name='SSBToReportItem', mode=MODE_TYPE)
    _SSBToReportItem_sSBIndex = INT(name='sSBIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBToReportItem_sSBIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _SSBToReportItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SSBToReportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SSBToReportItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SSBToReportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBToReportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBToReportItem_iE_Extensions__item__id._const_tab = ____SSBToReportItem_iE_Extensions__item__id_tab
    ___SSBToReportItem_iE_Extensions__item__id._const_tab_at = None
    ___SSBToReportItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SSBToReportItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SSBToReportItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBToReportItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBToReportItem_iE_Extensions__item__criticality._const_tab = ____SSBToReportItem_iE_Extensions__item__criticality_tab
    ___SSBToReportItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SSBToReportItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SSBToReportItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SSBToReportItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SSBToReportItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBToReportItem_iE_Extensions__item__extensionValue._const_tab = ____SSBToReportItem_iE_Extensions__item__extensionValue_tab
    ___SSBToReportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SSBToReportItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SSBToReportItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SSBToReportItem_iE_Extensions__item__id),
        ('criticality', ___SSBToReportItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SSBToReportItem_iE_Extensions__item__extensionValue),
        ])
    __SSBToReportItem_iE_Extensions__item_._ext = None
    _SSBToReportItem_iE_Extensions._cont = __SSBToReportItem_iE_Extensions__item_
    _SSBToReportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SSBToReportItem._cont = ASN1Dict([
        ('sSBIndex', _SSBToReportItem_sSBIndex),
        ('iE-Extensions', _SSBToReportItem_iE_Extensions),
        ])
    SSBToReportItem._ext = None
    
    #-----< SSBToReportItem-ExtIEs >-----#
    SSBToReportItem_ExtIEs = CLASS(name='SSBToReportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SSBToReportItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< StartTimeAndDuration >-----#
    StartTimeAndDuration = SEQ(name='StartTimeAndDuration', mode=MODE_TYPE)
    _StartTimeAndDuration_startTime = BIT_STR(name='startTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RelativeTime1900')), opt=True)
    _StartTimeAndDuration_duration = INT(name='duration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _StartTimeAndDuration_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=90060)], ev=[], er=[])
    _StartTimeAndDuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __StartTimeAndDuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___StartTimeAndDuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____StartTimeAndDuration_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____StartTimeAndDuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___StartTimeAndDuration_iE_Extensions__item__id._const_tab = ____StartTimeAndDuration_iE_Extensions__item__id_tab
    ___StartTimeAndDuration_iE_Extensions__item__id._const_tab_at = None
    ___StartTimeAndDuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___StartTimeAndDuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____StartTimeAndDuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____StartTimeAndDuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___StartTimeAndDuration_iE_Extensions__item__criticality._const_tab = ____StartTimeAndDuration_iE_Extensions__item__criticality_tab
    ___StartTimeAndDuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___StartTimeAndDuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___StartTimeAndDuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____StartTimeAndDuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____StartTimeAndDuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___StartTimeAndDuration_iE_Extensions__item__extensionValue._const_tab = ____StartTimeAndDuration_iE_Extensions__item__extensionValue_tab
    ___StartTimeAndDuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___StartTimeAndDuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __StartTimeAndDuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___StartTimeAndDuration_iE_Extensions__item__id),
        ('criticality', ___StartTimeAndDuration_iE_Extensions__item__criticality),
        ('extensionValue', ___StartTimeAndDuration_iE_Extensions__item__extensionValue),
        ])
    __StartTimeAndDuration_iE_Extensions__item_._ext = None
    _StartTimeAndDuration_iE_Extensions._cont = __StartTimeAndDuration_iE_Extensions__item_
    _StartTimeAndDuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    StartTimeAndDuration._cont = ASN1Dict([
        ('startTime', _StartTimeAndDuration_startTime),
        ('duration', _StartTimeAndDuration_duration),
        ('iE-Extensions', _StartTimeAndDuration_iE_Extensions),
        ])
    StartTimeAndDuration._ext = []
    
    #-----< StartTimeAndDuration-ExtIEs >-----#
    StartTimeAndDuration_ExtIEs = CLASS(name='StartTimeAndDuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    StartTimeAndDuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SUL-Information >-----#
    SUL_Information = SEQ(name='SUL-Information', mode=MODE_TYPE)
    _SUL_Information_sUL_NRARFCN = INT(name='sUL-NRARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SUL_Information_sUL_NRARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _SUL_Information_sUL_transmission_Bandwidth = SEQ(name='sUL-transmission-Bandwidth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Transmission-Bandwidth')))
    _SUL_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SUL_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SUL_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SUL_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____SUL_Information_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')))
    _____SUL_Information_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FrequencyShift7p5khz')))
    ____SUL_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 354), ('criticality', 'ignore'), ('Extension', _____SUL_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 356), ('criticality', 'ignore'), ('Extension', _____SUL_Information_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SUL_Information_iE_Extensions__item__id._const_tab = ____SUL_Information_iE_Extensions__item__id_tab
    ___SUL_Information_iE_Extensions__item__id._const_tab_at = None
    ___SUL_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___SUL_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SUL_Information_iE_Extensions__item__criticality._const_tab = ____SUL_Information_iE_Extensions__item__id_tab
    ___SUL_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SUL_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SUL_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SUL_Information_iE_Extensions__item__extensionValue._const_tab = ____SUL_Information_iE_Extensions__item__id_tab
    ___SUL_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SUL_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SUL_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SUL_Information_iE_Extensions__item__id),
        ('criticality', ___SUL_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___SUL_Information_iE_Extensions__item__extensionValue),
        ])
    __SUL_Information_iE_Extensions__item_._ext = None
    _SUL_Information_iE_Extensions._cont = __SUL_Information_iE_Extensions__item_
    _SUL_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SUL_Information._cont = ASN1Dict([
        ('sUL-NRARFCN', _SUL_Information_sUL_NRARFCN),
        ('sUL-transmission-Bandwidth', _SUL_Information_sUL_transmission_Bandwidth),
        ('iE-Extensions', _SUL_Information_iE_Extensions),
        ])
    SUL_Information._ext = []
    
    #-----< SUL-InformationExtIEs >-----#
    SUL_InformationExtIEs = CLASS(name='SUL-InformationExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _SUL_InformationExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')))
    _SUL_InformationExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FrequencyShift7p5khz')))
    SUL_InformationExtIEs._val = ASN1Set(rv=[dict([('id', 354), ('criticality', 'ignore'), ('Extension', _SUL_InformationExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 356), ('criticality', 'ignore'), ('Extension', _SUL_InformationExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SubcarrierSpacing >-----#
    SubcarrierSpacing = ENUM(name='SubcarrierSpacing', mode=MODE_TYPE)
    SubcarrierSpacing._cont = ASN1Dict([('kHz15', 0), ('kHz30', 1), ('kHz60', 2), ('kHz120', 3), ('kHz240', 4), ('spare3', 5), ('spare2', 6), ('spare1', 7)])
    SubcarrierSpacing._ext = []
    
    #-----< SubscriberProfileIDforRFP >-----#
    SubscriberProfileIDforRFP = INT(name='SubscriberProfileIDforRFP', mode=MODE_TYPE)
    SubscriberProfileIDforRFP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=[], er=[])
    
    #-----< SuccessfulHOReportInformationList >-----#
    SuccessfulHOReportInformationList = SEQ_OF(name='SuccessfulHOReportInformationList', mode=MODE_TYPE)
    _SuccessfulHOReportInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SuccessfulHOReportInformation-Item')))
    SuccessfulHOReportInformationList._cont = _SuccessfulHOReportInformationList__item_
    SuccessfulHOReportInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SuccessfulHOReportInformation-Item >-----#
    SuccessfulHOReportInformation_Item = SEQ(name='SuccessfulHOReportInformation-Item', mode=MODE_TYPE)
    _SuccessfulHOReportInformation_Item_successfulHOReportContainer = OCT_STR(name='successfulHOReportContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SuccessfulHOReportInformation_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SuccessfulHOReportInformation_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SuccessfulHOReportInformation_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SuccessfulHOReportInformation_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SuccessfulHOReportInformation_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SuccessfulHOReportInformation_Item_iE_Extensions__item__id._const_tab = ____SuccessfulHOReportInformation_Item_iE_Extensions__item__id_tab
    ___SuccessfulHOReportInformation_Item_iE_Extensions__item__id._const_tab_at = None
    ___SuccessfulHOReportInformation_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SuccessfulHOReportInformation_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SuccessfulHOReportInformation_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SuccessfulHOReportInformation_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SuccessfulHOReportInformation_Item_iE_Extensions__item__criticality._const_tab = ____SuccessfulHOReportInformation_Item_iE_Extensions__item__criticality_tab
    ___SuccessfulHOReportInformation_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SuccessfulHOReportInformation_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SuccessfulHOReportInformation_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SuccessfulHOReportInformation_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SuccessfulHOReportInformation_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SuccessfulHOReportInformation_Item_iE_Extensions__item__extensionValue._const_tab = ____SuccessfulHOReportInformation_Item_iE_Extensions__item__extensionValue_tab
    ___SuccessfulHOReportInformation_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SuccessfulHOReportInformation_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SuccessfulHOReportInformation_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SuccessfulHOReportInformation_Item_iE_Extensions__item__id),
        ('criticality', ___SuccessfulHOReportInformation_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SuccessfulHOReportInformation_Item_iE_Extensions__item__extensionValue),
        ])
    __SuccessfulHOReportInformation_Item_iE_Extensions__item_._ext = None
    _SuccessfulHOReportInformation_Item_iE_Extensions._cont = __SuccessfulHOReportInformation_Item_iE_Extensions__item_
    _SuccessfulHOReportInformation_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SuccessfulHOReportInformation_Item._cont = ASN1Dict([
        ('successfulHOReportContainer', _SuccessfulHOReportInformation_Item_successfulHOReportContainer),
        ('iE-Extensions', _SuccessfulHOReportInformation_Item_iE_Extensions),
        ])
    SuccessfulHOReportInformation_Item._ext = None
    
    #-----< SuccessfulHOReportInformation-Item-ExtIEs >-----#
    SuccessfulHOReportInformation_Item_ExtIEs = CLASS(name='SuccessfulHOReportInformation-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SuccessfulHOReportInformation_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SULAccessIndication >-----#
    SULAccessIndication = ENUM(name='SULAccessIndication', mode=MODE_TYPE)
    SULAccessIndication._cont = ASN1Dict([('true', 0)])
    SULAccessIndication._ext = []
    
    #-----< SupportedSULFreqBandItem >-----#
    SupportedSULFreqBandItem = SEQ(name='SupportedSULFreqBandItem', mode=MODE_TYPE)
    _SupportedSULFreqBandItem_freqBandIndicatorNr = INT(name='freqBandIndicatorNr', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedSULFreqBandItem_freqBandIndicatorNr._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=[], er=[])
    _SupportedSULFreqBandItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SupportedSULFreqBandItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SupportedSULFreqBandItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SupportedSULFreqBandItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SupportedSULFreqBandItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SupportedSULFreqBandItem_iE_Extensions__item__id._const_tab = ____SupportedSULFreqBandItem_iE_Extensions__item__id_tab
    ___SupportedSULFreqBandItem_iE_Extensions__item__id._const_tab_at = None
    ___SupportedSULFreqBandItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SupportedSULFreqBandItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SupportedSULFreqBandItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SupportedSULFreqBandItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SupportedSULFreqBandItem_iE_Extensions__item__criticality._const_tab = ____SupportedSULFreqBandItem_iE_Extensions__item__criticality_tab
    ___SupportedSULFreqBandItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SupportedSULFreqBandItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SupportedSULFreqBandItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SupportedSULFreqBandItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____SupportedSULFreqBandItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SupportedSULFreqBandItem_iE_Extensions__item__extensionValue._const_tab = ____SupportedSULFreqBandItem_iE_Extensions__item__extensionValue_tab
    ___SupportedSULFreqBandItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SupportedSULFreqBandItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SupportedSULFreqBandItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SupportedSULFreqBandItem_iE_Extensions__item__id),
        ('criticality', ___SupportedSULFreqBandItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SupportedSULFreqBandItem_iE_Extensions__item__extensionValue),
        ])
    __SupportedSULFreqBandItem_iE_Extensions__item_._ext = None
    _SupportedSULFreqBandItem_iE_Extensions._cont = __SupportedSULFreqBandItem_iE_Extensions__item_
    _SupportedSULFreqBandItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SupportedSULFreqBandItem._cont = ASN1Dict([
        ('freqBandIndicatorNr', _SupportedSULFreqBandItem_freqBandIndicatorNr),
        ('iE-Extensions', _SupportedSULFreqBandItem_iE_Extensions),
        ])
    SupportedSULFreqBandItem._ext = []
    
    #-----< SupportedSULFreqBandItem-ExtIEs >-----#
    SupportedSULFreqBandItem_ExtIEs = CLASS(name='SupportedSULFreqBandItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    SupportedSULFreqBandItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SurvivalTime >-----#
    SurvivalTime = INT(name='SurvivalTime', mode=MODE_TYPE)
    SurvivalTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1920000)], ev=[], er=[])
    
    #-----< SymbolAllocInSlot >-----#
    SymbolAllocInSlot = CHOICE(name='SymbolAllocInSlot', mode=MODE_TYPE)
    _SymbolAllocInSlot_all_DL = NULL(name='all-DL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SymbolAllocInSlot_all_UL = NULL(name='all-UL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SymbolAllocInSlot_both_DL_and_UL = SEQ(name='both-DL-and-UL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NumDLULSymbols')))
    _SymbolAllocInSlot_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SymbolAllocInSlot_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SymbolAllocInSlot_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SymbolAllocInSlot_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SymbolAllocInSlot_choice_extension_id._const_tab = ___SymbolAllocInSlot_choice_extension_id_tab
    __SymbolAllocInSlot_choice_extension_id._const_tab_at = None
    __SymbolAllocInSlot_choice_extension_id._const_tab_id = 'id'
    __SymbolAllocInSlot_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___SymbolAllocInSlot_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SymbolAllocInSlot_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SymbolAllocInSlot_choice_extension_criticality._const_tab = ___SymbolAllocInSlot_choice_extension_criticality_tab
    __SymbolAllocInSlot_choice_extension_criticality._const_tab_at = ('..', 'id')
    __SymbolAllocInSlot_choice_extension_criticality._const_tab_id = 'criticality'
    __SymbolAllocInSlot_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___SymbolAllocInSlot_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SymbolAllocInSlot_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SymbolAllocInSlot_choice_extension_value._const_tab = ___SymbolAllocInSlot_choice_extension_value_tab
    __SymbolAllocInSlot_choice_extension_value._const_tab_at = ('..', 'id')
    __SymbolAllocInSlot_choice_extension_value._const_tab_id = 'Value'
    _SymbolAllocInSlot_choice_extension._cont = ASN1Dict([
        ('id', __SymbolAllocInSlot_choice_extension_id),
        ('criticality', __SymbolAllocInSlot_choice_extension_criticality),
        ('value', __SymbolAllocInSlot_choice_extension_value),
        ])
    _SymbolAllocInSlot_choice_extension._ext = None
    SymbolAllocInSlot._cont = ASN1Dict([
        ('all-DL', _SymbolAllocInSlot_all_DL),
        ('all-UL', _SymbolAllocInSlot_all_UL),
        ('both-DL-and-UL', _SymbolAllocInSlot_both_DL_and_UL),
        ('choice-extension', _SymbolAllocInSlot_choice_extension),
        ])
    SymbolAllocInSlot._ext = None
    
    #-----< SymbolAllocInSlot-ExtIEs >-----#
    SymbolAllocInSlot_ExtIEs = CLASS(name='SymbolAllocInSlot-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    SymbolAllocInSlot_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SystemFrameNumber >-----#
    SystemFrameNumber = INT(name='SystemFrameNumber', mode=MODE_TYPE)
    SystemFrameNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    
    #-----< SystemInformationAreaID >-----#
    SystemInformationAreaID = BIT_STR(name='SystemInformationAreaID', mode=MODE_TYPE)
    SystemInformationAreaID._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    
    #-----< FiveGS-TAC >-----#
    FiveGS_TAC = OCT_STR(name='FiveGS-TAC', mode=MODE_TYPE)
    FiveGS_TAC._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< Configured-EPS-TAC >-----#
    Configured_EPS_TAC = OCT_STR(name='Configured-EPS-TAC', mode=MODE_TYPE)
    Configured_EPS_TAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< TargetCellList >-----#
    TargetCellList = SEQ_OF(name='TargetCellList', mode=MODE_TYPE)
    _TargetCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TargetCellList-Item')))
    TargetCellList._cont = _TargetCellList__item_
    TargetCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TargetCellList-Item >-----#
    TargetCellList_Item = SEQ(name='TargetCellList-Item', mode=MODE_TYPE)
    _TargetCellList_Item_target_cell = SEQ(name='target-cell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _TargetCellList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargetCellList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TargetCellList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TargetCellList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TargetCellList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetCellList_Item_iE_Extensions__item__id._const_tab = ____TargetCellList_Item_iE_Extensions__item__id_tab
    ___TargetCellList_Item_iE_Extensions__item__id._const_tab_at = None
    ___TargetCellList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TargetCellList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TargetCellList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TargetCellList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetCellList_Item_iE_Extensions__item__criticality._const_tab = ____TargetCellList_Item_iE_Extensions__item__criticality_tab
    ___TargetCellList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TargetCellList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TargetCellList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TargetCellList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TargetCellList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetCellList_Item_iE_Extensions__item__extensionValue._const_tab = ____TargetCellList_Item_iE_Extensions__item__extensionValue_tab
    ___TargetCellList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TargetCellList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TargetCellList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TargetCellList_Item_iE_Extensions__item__id),
        ('criticality', ___TargetCellList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TargetCellList_Item_iE_Extensions__item__extensionValue),
        ])
    __TargetCellList_Item_iE_Extensions__item_._ext = None
    _TargetCellList_Item_iE_Extensions._cont = __TargetCellList_Item_iE_Extensions__item_
    _TargetCellList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargetCellList_Item._cont = ASN1Dict([
        ('target-cell', _TargetCellList_Item_target_cell),
        ('iE-Extensions', _TargetCellList_Item_iE_Extensions),
        ])
    TargetCellList_Item._ext = None
    
    #-----< TargetCellList-Item-ExtIEs >-----#
    TargetCellList_Item_ExtIEs = CLASS(name='TargetCellList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TargetCellList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NSAGSupportList >-----#
    NSAGSupportList = SEQ_OF(name='NSAGSupportList', mode=MODE_TYPE)
    _NSAGSupportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NSAGSupportItem')))
    NSAGSupportList._cont = _NSAGSupportList__item_
    NSAGSupportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< NSAGSupportItem >-----#
    NSAGSupportItem = SEQ(name='NSAGSupportItem', mode=MODE_TYPE)
    _NSAGSupportItem_nSAG_ID = INT(name='nSAG-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NSAG-ID')))
    _NSAGSupportItem_nSAGSliceSupport = SEQ_OF(name='nSAGSliceSupport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ExtendedSliceSupportList')))
    _NSAGSupportItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NSAGSupportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___NSAGSupportItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NSAGSupportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NSAGSupportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NSAGSupportItem_iE_Extensions__item__id._const_tab = ____NSAGSupportItem_iE_Extensions__item__id_tab
    ___NSAGSupportItem_iE_Extensions__item__id._const_tab_at = None
    ___NSAGSupportItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___NSAGSupportItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NSAGSupportItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NSAGSupportItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NSAGSupportItem_iE_Extensions__item__criticality._const_tab = ____NSAGSupportItem_iE_Extensions__item__criticality_tab
    ___NSAGSupportItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NSAGSupportItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NSAGSupportItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NSAGSupportItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____NSAGSupportItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NSAGSupportItem_iE_Extensions__item__extensionValue._const_tab = ____NSAGSupportItem_iE_Extensions__item__extensionValue_tab
    ___NSAGSupportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NSAGSupportItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NSAGSupportItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NSAGSupportItem_iE_Extensions__item__id),
        ('criticality', ___NSAGSupportItem_iE_Extensions__item__criticality),
        ('extensionValue', ___NSAGSupportItem_iE_Extensions__item__extensionValue),
        ])
    __NSAGSupportItem_iE_Extensions__item_._ext = None
    _NSAGSupportItem_iE_Extensions._cont = __NSAGSupportItem_iE_Extensions__item_
    _NSAGSupportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NSAGSupportItem._cont = ASN1Dict([
        ('nSAG-ID', _NSAGSupportItem_nSAG_ID),
        ('nSAGSliceSupport', _NSAGSupportItem_nSAGSliceSupport),
        ('iE-Extensions', _NSAGSupportItem_iE_Extensions),
        ])
    NSAGSupportItem._ext = []
    
    #-----< NSAGSupportItem-ExtIEs >-----#
    NSAGSupportItem_ExtIEs = CLASS(name='NSAGSupportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    NSAGSupportItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NSAG-ID >-----#
    NSAG_ID = INT(name='NSAG-ID', mode=MODE_TYPE)
    NSAG_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< TDD-Info >-----#
    TDD_Info = SEQ(name='TDD-Info', mode=MODE_TYPE)
    _TDD_Info_nRFreqInfo = SEQ(name='nRFreqInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRFreqInfo')))
    _TDD_Info_transmission_Bandwidth = SEQ(name='transmission-Bandwidth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Transmission-Bandwidth')))
    _TDD_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TDD_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TDD_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IntendedTDD-DL-ULConfig')))
    _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TDD-UL-DLConfigCommonNR')))
    _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')))
    ____TDD_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 256), ('criticality', 'ignore'), ('Extension', _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 361), ('criticality', 'ignore'), ('Extension', _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 354), ('criticality', 'ignore'), ('Extension', _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TDD_Info_iE_Extensions__item__id._const_tab = ____TDD_Info_iE_Extensions__item__id_tab
    ___TDD_Info_iE_Extensions__item__id._const_tab_at = None
    ___TDD_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___TDD_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TDD_Info_iE_Extensions__item__criticality._const_tab = ____TDD_Info_iE_Extensions__item__id_tab
    ___TDD_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TDD_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TDD_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TDD_Info_iE_Extensions__item__extensionValue._const_tab = ____TDD_Info_iE_Extensions__item__id_tab
    ___TDD_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TDD_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TDD_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TDD_Info_iE_Extensions__item__id),
        ('criticality', ___TDD_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___TDD_Info_iE_Extensions__item__extensionValue),
        ])
    __TDD_Info_iE_Extensions__item_._ext = None
    _TDD_Info_iE_Extensions._cont = __TDD_Info_iE_Extensions__item_
    _TDD_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_Info._cont = ASN1Dict([
        ('nRFreqInfo', _TDD_Info_nRFreqInfo),
        ('transmission-Bandwidth', _TDD_Info_transmission_Bandwidth),
        ('iE-Extensions', _TDD_Info_iE_Extensions),
        ])
    TDD_Info._ext = []
    
    #-----< TDD-Info-ExtIEs >-----#
    TDD_Info_ExtIEs = CLASS(name='TDD-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _TDD_Info_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IntendedTDD-DL-ULConfig')))
    _TDD_Info_ExtIEs_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TDD-UL-DLConfigCommonNR')))
    _TDD_Info_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCarrierList')))
    TDD_Info_ExtIEs._val = ASN1Set(rv=[dict([('id', 256), ('criticality', 'ignore'), ('Extension', _TDD_Info_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 361), ('criticality', 'ignore'), ('Extension', _TDD_Info_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 354), ('criticality', 'ignore'), ('Extension', _TDD_Info_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TDD-InfoRel16 >-----#
    TDD_InfoRel16 = SEQ(name='TDD-InfoRel16', mode=MODE_TYPE)
    _TDD_InfoRel16_tDD_FreqInfo = SEQ(name='tDD-FreqInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FreqInfoRel16')), opt=True)
    _TDD_InfoRel16_sUL_FreqInfo = SEQ(name='sUL-FreqInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'FreqInfoRel16')), opt=True)
    _TDD_InfoRel16_tDD_UL_DLConfigCommonNR = OCT_STR(name='tDD-UL-DLConfigCommonNR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TDD-UL-DLConfigCommonNR')), opt=True)
    _TDD_InfoRel16_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_InfoRel16_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TDD_InfoRel16_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TDD_InfoRel16_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TDD_InfoRel16_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_InfoRel16_iE_Extensions__item__id._const_tab = ____TDD_InfoRel16_iE_Extensions__item__id_tab
    ___TDD_InfoRel16_iE_Extensions__item__id._const_tab_at = None
    ___TDD_InfoRel16_iE_Extensions__item__id._const_tab_id = 'id'
    ___TDD_InfoRel16_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TDD_InfoRel16_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TDD_InfoRel16_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_InfoRel16_iE_Extensions__item__criticality._const_tab = ____TDD_InfoRel16_iE_Extensions__item__criticality_tab
    ___TDD_InfoRel16_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TDD_InfoRel16_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TDD_InfoRel16_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TDD_InfoRel16_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TDD_InfoRel16_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_InfoRel16_iE_Extensions__item__extensionValue._const_tab = ____TDD_InfoRel16_iE_Extensions__item__extensionValue_tab
    ___TDD_InfoRel16_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TDD_InfoRel16_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TDD_InfoRel16_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TDD_InfoRel16_iE_Extensions__item__id),
        ('criticality', ___TDD_InfoRel16_iE_Extensions__item__criticality),
        ('extensionValue', ___TDD_InfoRel16_iE_Extensions__item__extensionValue),
        ])
    __TDD_InfoRel16_iE_Extensions__item_._ext = None
    _TDD_InfoRel16_iE_Extensions._cont = __TDD_InfoRel16_iE_Extensions__item_
    _TDD_InfoRel16_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_InfoRel16._cont = ASN1Dict([
        ('tDD-FreqInfo', _TDD_InfoRel16_tDD_FreqInfo),
        ('sUL-FreqInfo', _TDD_InfoRel16_sUL_FreqInfo),
        ('tDD-UL-DLConfigCommonNR', _TDD_InfoRel16_tDD_UL_DLConfigCommonNR),
        ('iE-Extensions', _TDD_InfoRel16_iE_Extensions),
        ])
    TDD_InfoRel16._ext = []
    
    #-----< TDD-InfoRel16-ExtIEs >-----#
    TDD_InfoRel16_ExtIEs = CLASS(name='TDD-InfoRel16-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TDD_InfoRel16_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TDD-UL-DLConfigCommonNR >-----#
    TDD_UL_DLConfigCommonNR = OCT_STR(name='TDD-UL-DLConfigCommonNR', mode=MODE_TYPE)
    
    #-----< TRPTEGInformation >-----#
    TRPTEGInformation = CHOICE(name='TRPTEGInformation', mode=MODE_TYPE)
    _TRPTEGInformation_rxTx_TEG = SEQ(name='rxTx-TEG', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RxTxTEG')))
    _TRPTEGInformation_rx_TEG = SEQ(name='rx-TEG', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RxTEG')))
    _TRPTEGInformation_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __TRPTEGInformation_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___TRPTEGInformation_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPTEGInformation_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPTEGInformation_choice_extension_id._const_tab = ___TRPTEGInformation_choice_extension_id_tab
    __TRPTEGInformation_choice_extension_id._const_tab_at = None
    __TRPTEGInformation_choice_extension_id._const_tab_id = 'id'
    __TRPTEGInformation_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___TRPTEGInformation_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPTEGInformation_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPTEGInformation_choice_extension_criticality._const_tab = ___TRPTEGInformation_choice_extension_criticality_tab
    __TRPTEGInformation_choice_extension_criticality._const_tab_at = ('..', 'id')
    __TRPTEGInformation_choice_extension_criticality._const_tab_id = 'criticality'
    __TRPTEGInformation_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___TRPTEGInformation_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPTEGInformation_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPTEGInformation_choice_extension_value._const_tab = ___TRPTEGInformation_choice_extension_value_tab
    __TRPTEGInformation_choice_extension_value._const_tab_at = ('..', 'id')
    __TRPTEGInformation_choice_extension_value._const_tab_id = 'Value'
    _TRPTEGInformation_choice_extension._cont = ASN1Dict([
        ('id', __TRPTEGInformation_choice_extension_id),
        ('criticality', __TRPTEGInformation_choice_extension_criticality),
        ('value', __TRPTEGInformation_choice_extension_value),
        ])
    _TRPTEGInformation_choice_extension._ext = None
    TRPTEGInformation._cont = ASN1Dict([
        ('rxTx-TEG', _TRPTEGInformation_rxTx_TEG),
        ('rx-TEG', _TRPTEGInformation_rx_TEG),
        ('choice-extension', _TRPTEGInformation_choice_extension),
        ])
    TRPTEGInformation._ext = None
    
    #-----< TRPTEGInformation-ExtIEs >-----#
    TRPTEGInformation_ExtIEs = CLASS(name='TRPTEGInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    TRPTEGInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RxTxTEG >-----#
    RxTxTEG = SEQ(name='RxTxTEG', mode=MODE_TYPE)
    _RxTxTEG_tRP_RxTx_TEGInformation = SEQ(name='tRP-RxTx-TEGInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRP-RxTx-TEGInformation')))
    _RxTxTEG_tRP_Tx_TEGInformation = SEQ(name='tRP-Tx-TEGInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRP-Tx-TEGInformation')), opt=True)
    _RxTxTEG_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RxTxTEG_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RxTxTEG_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RxTxTEG_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RxTxTEG_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RxTxTEG_iE_Extensions__item__id._const_tab = ____RxTxTEG_iE_Extensions__item__id_tab
    ___RxTxTEG_iE_Extensions__item__id._const_tab_at = None
    ___RxTxTEG_iE_Extensions__item__id._const_tab_id = 'id'
    ___RxTxTEG_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RxTxTEG_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RxTxTEG_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RxTxTEG_iE_Extensions__item__criticality._const_tab = ____RxTxTEG_iE_Extensions__item__criticality_tab
    ___RxTxTEG_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RxTxTEG_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RxTxTEG_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RxTxTEG_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RxTxTEG_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RxTxTEG_iE_Extensions__item__extensionValue._const_tab = ____RxTxTEG_iE_Extensions__item__extensionValue_tab
    ___RxTxTEG_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RxTxTEG_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RxTxTEG_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RxTxTEG_iE_Extensions__item__id),
        ('criticality', ___RxTxTEG_iE_Extensions__item__criticality),
        ('extensionValue', ___RxTxTEG_iE_Extensions__item__extensionValue),
        ])
    __RxTxTEG_iE_Extensions__item_._ext = None
    _RxTxTEG_iE_Extensions._cont = __RxTxTEG_iE_Extensions__item_
    _RxTxTEG_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RxTxTEG._cont = ASN1Dict([
        ('tRP-RxTx-TEGInformation', _RxTxTEG_tRP_RxTx_TEGInformation),
        ('tRP-Tx-TEGInformation', _RxTxTEG_tRP_Tx_TEGInformation),
        ('iE-Extensions', _RxTxTEG_iE_Extensions),
        ])
    RxTxTEG._ext = []
    
    #-----< RxTxTEG-ExtIEs >-----#
    RxTxTEG_ExtIEs = CLASS(name='RxTxTEG-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RxTxTEG_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RxTEG >-----#
    RxTEG = SEQ(name='RxTEG', mode=MODE_TYPE)
    _RxTEG_tRP_Rx_TEGInformation = SEQ(name='tRP-Rx-TEGInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRP-Rx-TEGInformation')))
    _RxTEG_tRP_Tx_TEGInformation = SEQ(name='tRP-Tx-TEGInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRP-Tx-TEGInformation')))
    _RxTEG_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RxTEG_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___RxTEG_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RxTEG_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RxTEG_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RxTEG_iE_Extensions__item__id._const_tab = ____RxTEG_iE_Extensions__item__id_tab
    ___RxTEG_iE_Extensions__item__id._const_tab_at = None
    ___RxTEG_iE_Extensions__item__id._const_tab_id = 'id'
    ___RxTEG_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RxTEG_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RxTEG_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RxTEG_iE_Extensions__item__criticality._const_tab = ____RxTEG_iE_Extensions__item__criticality_tab
    ___RxTEG_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RxTEG_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RxTEG_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RxTEG_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____RxTEG_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RxTEG_iE_Extensions__item__extensionValue._const_tab = ____RxTEG_iE_Extensions__item__extensionValue_tab
    ___RxTEG_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RxTEG_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RxTEG_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RxTEG_iE_Extensions__item__id),
        ('criticality', ___RxTEG_iE_Extensions__item__criticality),
        ('extensionValue', ___RxTEG_iE_Extensions__item__extensionValue),
        ])
    __RxTEG_iE_Extensions__item_._ext = None
    _RxTEG_iE_Extensions._cont = __RxTEG_iE_Extensions__item_
    _RxTEG_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RxTEG._cont = ASN1Dict([
        ('tRP-Rx-TEGInformation', _RxTEG_tRP_Rx_TEGInformation),
        ('tRP-Tx-TEGInformation', _RxTEG_tRP_Tx_TEGInformation),
        ('iE-Extensions', _RxTEG_iE_Extensions),
        ])
    RxTEG._ext = []
    
    #-----< RxTEG-ExtIEs >-----#
    RxTEG_ExtIEs = CLASS(name='RxTEG-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    RxTEG_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TimeReferenceInformation >-----#
    TimeReferenceInformation = SEQ(name='TimeReferenceInformation', mode=MODE_TYPE)
    _TimeReferenceInformation_referenceTime = OCT_STR(name='referenceTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ReferenceTime')))
    _TimeReferenceInformation_referenceSFN = INT(name='referenceSFN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ReferenceSFN')))
    _TimeReferenceInformation_uncertainty = INT(name='uncertainty', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Uncertainty')))
    _TimeReferenceInformation_timeInformationType = ENUM(name='timeInformationType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TimeInformationType')))
    _TimeReferenceInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TimeReferenceInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TimeReferenceInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TimeReferenceInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TimeReferenceInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeReferenceInformation_iE_Extensions__item__id._const_tab = ____TimeReferenceInformation_iE_Extensions__item__id_tab
    ___TimeReferenceInformation_iE_Extensions__item__id._const_tab_at = None
    ___TimeReferenceInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TimeReferenceInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TimeReferenceInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TimeReferenceInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeReferenceInformation_iE_Extensions__item__criticality._const_tab = ____TimeReferenceInformation_iE_Extensions__item__criticality_tab
    ___TimeReferenceInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TimeReferenceInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TimeReferenceInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TimeReferenceInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TimeReferenceInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeReferenceInformation_iE_Extensions__item__extensionValue._const_tab = ____TimeReferenceInformation_iE_Extensions__item__extensionValue_tab
    ___TimeReferenceInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TimeReferenceInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TimeReferenceInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TimeReferenceInformation_iE_Extensions__item__id),
        ('criticality', ___TimeReferenceInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___TimeReferenceInformation_iE_Extensions__item__extensionValue),
        ])
    __TimeReferenceInformation_iE_Extensions__item_._ext = None
    _TimeReferenceInformation_iE_Extensions._cont = __TimeReferenceInformation_iE_Extensions__item_
    _TimeReferenceInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TimeReferenceInformation._cont = ASN1Dict([
        ('referenceTime', _TimeReferenceInformation_referenceTime),
        ('referenceSFN', _TimeReferenceInformation_referenceSFN),
        ('uncertainty', _TimeReferenceInformation_uncertainty),
        ('timeInformationType', _TimeReferenceInformation_timeInformationType),
        ('iE-Extensions', _TimeReferenceInformation_iE_Extensions),
        ])
    TimeReferenceInformation._ext = None
    
    #-----< TimeReferenceInformation-ExtIEs >-----#
    TimeReferenceInformation_ExtIEs = CLASS(name='TimeReferenceInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TimeReferenceInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TimeInformationType >-----#
    TimeInformationType = ENUM(name='TimeInformationType', mode=MODE_TYPE)
    TimeInformationType._cont = ASN1Dict([('localClock', 0)])
    TimeInformationType._ext = None
    
    #-----< TimeStamp >-----#
    TimeStamp = SEQ(name='TimeStamp', mode=MODE_TYPE)
    _TimeStamp_systemFrameNumber = INT(name='systemFrameNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SystemFrameNumber')))
    _TimeStamp_slotIndex = CHOICE(name='slotIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TimeStampSlotIndex')))
    _TimeStamp_measurementTime = BIT_STR(name='measurementTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RelativeTime1900')), opt=True)
    _TimeStamp_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TimeStamp_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TimeStamp_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TimeStamp_iE_Extension__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TimeStamp_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeStamp_iE_Extension__item__id._const_tab = ____TimeStamp_iE_Extension__item__id_tab
    ___TimeStamp_iE_Extension__item__id._const_tab_at = None
    ___TimeStamp_iE_Extension__item__id._const_tab_id = 'id'
    ___TimeStamp_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TimeStamp_iE_Extension__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TimeStamp_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeStamp_iE_Extension__item__criticality._const_tab = ____TimeStamp_iE_Extension__item__criticality_tab
    ___TimeStamp_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___TimeStamp_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___TimeStamp_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TimeStamp_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TimeStamp_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeStamp_iE_Extension__item__extensionValue._const_tab = ____TimeStamp_iE_Extension__item__extensionValue_tab
    ___TimeStamp_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___TimeStamp_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __TimeStamp_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___TimeStamp_iE_Extension__item__id),
        ('criticality', ___TimeStamp_iE_Extension__item__criticality),
        ('extensionValue', ___TimeStamp_iE_Extension__item__extensionValue),
        ])
    __TimeStamp_iE_Extension__item_._ext = None
    _TimeStamp_iE_Extension._cont = __TimeStamp_iE_Extension__item_
    _TimeStamp_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TimeStamp._cont = ASN1Dict([
        ('systemFrameNumber', _TimeStamp_systemFrameNumber),
        ('slotIndex', _TimeStamp_slotIndex),
        ('measurementTime', _TimeStamp_measurementTime),
        ('iE-Extension', _TimeStamp_iE_Extension),
        ])
    TimeStamp._ext = None
    
    #-----< TimeStamp-ExtIEs >-----#
    TimeStamp_ExtIEs = CLASS(name='TimeStamp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TimeStamp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TimeStampSlotIndex >-----#
    TimeStampSlotIndex = CHOICE(name='TimeStampSlotIndex', mode=MODE_TYPE)
    _TimeStampSlotIndex_sCS_15 = INT(name='sCS-15', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimeStampSlotIndex_sCS_15._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _TimeStampSlotIndex_sCS_30 = INT(name='sCS-30', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimeStampSlotIndex_sCS_30._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=19)], ev=None, er=[])
    _TimeStampSlotIndex_sCS_60 = INT(name='sCS-60', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimeStampSlotIndex_sCS_60._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=39)], ev=None, er=[])
    _TimeStampSlotIndex_sCS_120 = INT(name='sCS-120', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimeStampSlotIndex_sCS_120._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=79)], ev=None, er=[])
    _TimeStampSlotIndex_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __TimeStampSlotIndex_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___TimeStampSlotIndex_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____TimeStampSlotIndex_choice_extension_id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCS-480')))
    ____TimeStampSlotIndex_choice_extension_id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCS-960')))
    ___TimeStampSlotIndex_choice_extension_id_tab._val = ASN1Set(rv=[dict([('id', 661), ('criticality', 'reject'), ('Value', ____TimeStampSlotIndex_choice_extension_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 662), ('criticality', 'reject'), ('Value', ____TimeStampSlotIndex_choice_extension_id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __TimeStampSlotIndex_choice_extension_id._const_tab = ___TimeStampSlotIndex_choice_extension_id_tab
    __TimeStampSlotIndex_choice_extension_id._const_tab_at = None
    __TimeStampSlotIndex_choice_extension_id._const_tab_id = 'id'
    __TimeStampSlotIndex_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __TimeStampSlotIndex_choice_extension_criticality._const_tab = ___TimeStampSlotIndex_choice_extension_id_tab
    __TimeStampSlotIndex_choice_extension_criticality._const_tab_at = ('..', 'id')
    __TimeStampSlotIndex_choice_extension_criticality._const_tab_id = 'criticality'
    __TimeStampSlotIndex_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __TimeStampSlotIndex_choice_extension_value._const_tab = ___TimeStampSlotIndex_choice_extension_id_tab
    __TimeStampSlotIndex_choice_extension_value._const_tab_at = ('..', 'id')
    __TimeStampSlotIndex_choice_extension_value._const_tab_id = 'Value'
    _TimeStampSlotIndex_choice_extension._cont = ASN1Dict([
        ('id', __TimeStampSlotIndex_choice_extension_id),
        ('criticality', __TimeStampSlotIndex_choice_extension_criticality),
        ('value', __TimeStampSlotIndex_choice_extension_value),
        ])
    _TimeStampSlotIndex_choice_extension._ext = None
    TimeStampSlotIndex._cont = ASN1Dict([
        ('sCS-15', _TimeStampSlotIndex_sCS_15),
        ('sCS-30', _TimeStampSlotIndex_sCS_30),
        ('sCS-60', _TimeStampSlotIndex_sCS_60),
        ('sCS-120', _TimeStampSlotIndex_sCS_120),
        ('choice-extension', _TimeStampSlotIndex_choice_extension),
        ])
    TimeStampSlotIndex._ext = None
    
    #-----< TimeStampSlotIndex-ExtIEs >-----#
    TimeStampSlotIndex_ExtIEs = CLASS(name='TimeStampSlotIndex-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _TimeStampSlotIndex_ExtIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCS-480')))
    _TimeStampSlotIndex_ExtIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCS-960')))
    TimeStampSlotIndex_ExtIEs._val = ASN1Set(rv=[dict([('id', 661), ('criticality', 'reject'), ('Value', _TimeStampSlotIndex_ExtIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 662), ('criticality', 'reject'), ('Value', _TimeStampSlotIndex_ExtIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TimeToWait >-----#
    TimeToWait = ENUM(name='TimeToWait', mode=MODE_TYPE)
    TimeToWait._cont = ASN1Dict([('v1s', 0), ('v2s', 1), ('v5s', 2), ('v10s', 3), ('v20s', 4), ('v60s', 5)])
    TimeToWait._ext = []
    
    #-----< TimingErrorMargin >-----#
    TimingErrorMargin = ENUM(name='TimingErrorMargin', mode=MODE_TYPE)
    TimingErrorMargin._cont = ASN1Dict([('m0Tc', 0), ('m2Tc', 1), ('m4Tc', 2), ('m6Tc', 3), ('m8Tc', 4), ('m12Tc', 5), ('m16Tc', 6), ('m20Tc', 7), ('m24Tc', 8), ('m32Tc', 9), ('m40Tc', 10), ('m48Tc', 11), ('m56Tc', 12), ('m64Tc', 13), ('m72Tc', 14), ('m80Tc', 15)])
    TimingErrorMargin._ext = []
    
    #-----< TimingMeasurementQuality >-----#
    TimingMeasurementQuality = SEQ(name='TimingMeasurementQuality', mode=MODE_TYPE)
    _TimingMeasurementQuality_measurementQuality = INT(name='measurementQuality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimingMeasurementQuality_measurementQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    _TimingMeasurementQuality_resolution = ENUM(name='resolution', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimingMeasurementQuality_resolution._cont = ASN1Dict([('m0dot1', 0), ('m1', 1), ('m10', 2), ('m30', 3)])
    _TimingMeasurementQuality_resolution._ext = []
    _TimingMeasurementQuality_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TimingMeasurementQuality_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TimingMeasurementQuality_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TimingMeasurementQuality_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TimingMeasurementQuality_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimingMeasurementQuality_iE_Extensions__item__id._const_tab = ____TimingMeasurementQuality_iE_Extensions__item__id_tab
    ___TimingMeasurementQuality_iE_Extensions__item__id._const_tab_at = None
    ___TimingMeasurementQuality_iE_Extensions__item__id._const_tab_id = 'id'
    ___TimingMeasurementQuality_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TimingMeasurementQuality_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TimingMeasurementQuality_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimingMeasurementQuality_iE_Extensions__item__criticality._const_tab = ____TimingMeasurementQuality_iE_Extensions__item__criticality_tab
    ___TimingMeasurementQuality_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TimingMeasurementQuality_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TimingMeasurementQuality_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TimingMeasurementQuality_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TimingMeasurementQuality_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimingMeasurementQuality_iE_Extensions__item__extensionValue._const_tab = ____TimingMeasurementQuality_iE_Extensions__item__extensionValue_tab
    ___TimingMeasurementQuality_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TimingMeasurementQuality_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TimingMeasurementQuality_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TimingMeasurementQuality_iE_Extensions__item__id),
        ('criticality', ___TimingMeasurementQuality_iE_Extensions__item__criticality),
        ('extensionValue', ___TimingMeasurementQuality_iE_Extensions__item__extensionValue),
        ])
    __TimingMeasurementQuality_iE_Extensions__item_._ext = None
    _TimingMeasurementQuality_iE_Extensions._cont = __TimingMeasurementQuality_iE_Extensions__item_
    _TimingMeasurementQuality_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TimingMeasurementQuality._cont = ASN1Dict([
        ('measurementQuality', _TimingMeasurementQuality_measurementQuality),
        ('resolution', _TimingMeasurementQuality_resolution),
        ('iE-Extensions', _TimingMeasurementQuality_iE_Extensions),
        ])
    TimingMeasurementQuality._ext = None
    
    #-----< TimingMeasurementQuality-ExtIEs >-----#
    TimingMeasurementQuality_ExtIEs = CLASS(name='TimingMeasurementQuality-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TimingMeasurementQuality_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TMGI >-----#
    TMGI = OCT_STR(name='TMGI', mode=MODE_TYPE)
    TMGI._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< TNLAssociationUsage >-----#
    TNLAssociationUsage = ENUM(name='TNLAssociationUsage', mode=MODE_TYPE)
    TNLAssociationUsage._cont = ASN1Dict([('ue', 0), ('non-ue', 1), ('both', 2)])
    TNLAssociationUsage._ext = []
    
    #-----< TNLCapacityIndicator >-----#
    TNLCapacityIndicator = SEQ(name='TNLCapacityIndicator', mode=MODE_TYPE)
    _TNLCapacityIndicator_dLTNLOfferedCapacity = INT(name='dLTNLOfferedCapacity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TNLCapacityIndicator_dLTNLOfferedCapacity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16777216)], ev=[], er=[])
    _TNLCapacityIndicator_dLTNLAvailableCapacity = INT(name='dLTNLAvailableCapacity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TNLCapacityIndicator_dLTNLAvailableCapacity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=[], er=[])
    _TNLCapacityIndicator_uLTNLOfferedCapacity = INT(name='uLTNLOfferedCapacity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TNLCapacityIndicator_uLTNLOfferedCapacity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16777216)], ev=[], er=[])
    _TNLCapacityIndicator_uLTNLAvailableCapacity = INT(name='uLTNLAvailableCapacity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TNLCapacityIndicator_uLTNLAvailableCapacity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=[], er=[])
    _TNLCapacityIndicator_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TNLCapacityIndicator_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TNLCapacityIndicator_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TNLCapacityIndicator_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TNLCapacityIndicator_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLCapacityIndicator_iE_Extensions__item__id._const_tab = ____TNLCapacityIndicator_iE_Extensions__item__id_tab
    ___TNLCapacityIndicator_iE_Extensions__item__id._const_tab_at = None
    ___TNLCapacityIndicator_iE_Extensions__item__id._const_tab_id = 'id'
    ___TNLCapacityIndicator_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TNLCapacityIndicator_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TNLCapacityIndicator_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLCapacityIndicator_iE_Extensions__item__criticality._const_tab = ____TNLCapacityIndicator_iE_Extensions__item__criticality_tab
    ___TNLCapacityIndicator_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TNLCapacityIndicator_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TNLCapacityIndicator_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TNLCapacityIndicator_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TNLCapacityIndicator_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLCapacityIndicator_iE_Extensions__item__extensionValue._const_tab = ____TNLCapacityIndicator_iE_Extensions__item__extensionValue_tab
    ___TNLCapacityIndicator_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TNLCapacityIndicator_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TNLCapacityIndicator_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TNLCapacityIndicator_iE_Extensions__item__id),
        ('criticality', ___TNLCapacityIndicator_iE_Extensions__item__criticality),
        ('extensionValue', ___TNLCapacityIndicator_iE_Extensions__item__extensionValue),
        ])
    __TNLCapacityIndicator_iE_Extensions__item_._ext = None
    _TNLCapacityIndicator_iE_Extensions._cont = __TNLCapacityIndicator_iE_Extensions__item_
    _TNLCapacityIndicator_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TNLCapacityIndicator._cont = ASN1Dict([
        ('dLTNLOfferedCapacity', _TNLCapacityIndicator_dLTNLOfferedCapacity),
        ('dLTNLAvailableCapacity', _TNLCapacityIndicator_dLTNLAvailableCapacity),
        ('uLTNLOfferedCapacity', _TNLCapacityIndicator_uLTNLOfferedCapacity),
        ('uLTNLAvailableCapacity', _TNLCapacityIndicator_uLTNLAvailableCapacity),
        ('iE-Extensions', _TNLCapacityIndicator_iE_Extensions),
        ])
    TNLCapacityIndicator._ext = None
    
    #-----< TNLCapacityIndicator-ExtIEs >-----#
    TNLCapacityIndicator_ExtIEs = CLASS(name='TNLCapacityIndicator-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TNLCapacityIndicator_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TraceActivation >-----#
    TraceActivation = SEQ(name='TraceActivation', mode=MODE_TYPE)
    _TraceActivation_traceID = OCT_STR(name='traceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TraceID')))
    _TraceActivation_interfacesToTrace = BIT_STR(name='interfacesToTrace', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'InterfacesToTrace')))
    _TraceActivation_traceDepth = ENUM(name='traceDepth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TraceDepth')))
    _TraceActivation_traceCollectionEntityIPAddress = BIT_STR(name='traceCollectionEntityIPAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _TraceActivation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TraceActivation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TraceActivation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TraceActivation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MDTConfiguration')))
    _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_1 = STR_VIS(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'URI-address')))
    ____TraceActivation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 381), ('criticality', 'ignore'), ('Extension', _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 380), ('criticality', 'ignore'), ('Extension', _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TraceActivation_iE_Extensions__item__id._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__id._const_tab_at = None
    ___TraceActivation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TraceActivation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TraceActivation_iE_Extensions__item__criticality._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TraceActivation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TraceActivation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TraceActivation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TraceActivation_iE_Extensions__item__id),
        ('criticality', ___TraceActivation_iE_Extensions__item__criticality),
        ('extensionValue', ___TraceActivation_iE_Extensions__item__extensionValue),
        ])
    __TraceActivation_iE_Extensions__item_._ext = None
    _TraceActivation_iE_Extensions._cont = __TraceActivation_iE_Extensions__item_
    _TraceActivation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TraceActivation._cont = ASN1Dict([
        ('traceID', _TraceActivation_traceID),
        ('interfacesToTrace', _TraceActivation_interfacesToTrace),
        ('traceDepth', _TraceActivation_traceDepth),
        ('traceCollectionEntityIPAddress', _TraceActivation_traceCollectionEntityIPAddress),
        ('iE-Extensions', _TraceActivation_iE_Extensions),
        ])
    TraceActivation._ext = None
    
    #-----< TraceActivation-ExtIEs >-----#
    TraceActivation_ExtIEs = CLASS(name='TraceActivation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _TraceActivation_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MDTConfiguration')))
    _TraceActivation_ExtIEs_val_Extension_1 = STR_VIS(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'URI-address')))
    TraceActivation_ExtIEs._val = ASN1Set(rv=[dict([('id', 381), ('criticality', 'ignore'), ('Extension', _TraceActivation_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 380), ('criticality', 'ignore'), ('Extension', _TraceActivation_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TraceDepth >-----#
    TraceDepth = ENUM(name='TraceDepth', mode=MODE_TYPE)
    TraceDepth._cont = ASN1Dict([('minimum', 0), ('medium', 1), ('maximum', 2), ('minimumWithoutVendorSpecificExtension', 3), ('mediumWithoutVendorSpecificExtension', 4), ('maximumWithoutVendorSpecificExtension', 5)])
    TraceDepth._ext = []
    
    #-----< TraceID >-----#
    TraceID = OCT_STR(name='TraceID', mode=MODE_TYPE)
    TraceID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< TrafficMappingInfo >-----#
    TrafficMappingInfo = CHOICE(name='TrafficMappingInfo', mode=MODE_TYPE)
    _TrafficMappingInfo_iPtolayer2TrafficMappingInfo = SEQ(name='iPtolayer2TrafficMappingInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'IPtolayer2TrafficMappingInfo')))
    _TrafficMappingInfo_bAPlayerBHRLCchannelMappingInfo = SEQ(name='bAPlayerBHRLCchannelMappingInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BAPlayerBHRLCchannelMappingInfo')))
    _TrafficMappingInfo_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __TrafficMappingInfo_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___TrafficMappingInfo_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TrafficMappingInfo_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TrafficMappingInfo_choice_extension_id._const_tab = ___TrafficMappingInfo_choice_extension_id_tab
    __TrafficMappingInfo_choice_extension_id._const_tab_at = None
    __TrafficMappingInfo_choice_extension_id._const_tab_id = 'id'
    __TrafficMappingInfo_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___TrafficMappingInfo_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TrafficMappingInfo_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TrafficMappingInfo_choice_extension_criticality._const_tab = ___TrafficMappingInfo_choice_extension_criticality_tab
    __TrafficMappingInfo_choice_extension_criticality._const_tab_at = ('..', 'id')
    __TrafficMappingInfo_choice_extension_criticality._const_tab_id = 'criticality'
    __TrafficMappingInfo_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___TrafficMappingInfo_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TrafficMappingInfo_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TrafficMappingInfo_choice_extension_value._const_tab = ___TrafficMappingInfo_choice_extension_value_tab
    __TrafficMappingInfo_choice_extension_value._const_tab_at = ('..', 'id')
    __TrafficMappingInfo_choice_extension_value._const_tab_id = 'Value'
    _TrafficMappingInfo_choice_extension._cont = ASN1Dict([
        ('id', __TrafficMappingInfo_choice_extension_id),
        ('criticality', __TrafficMappingInfo_choice_extension_criticality),
        ('value', __TrafficMappingInfo_choice_extension_value),
        ])
    _TrafficMappingInfo_choice_extension._ext = None
    TrafficMappingInfo._cont = ASN1Dict([
        ('iPtolayer2TrafficMappingInfo', _TrafficMappingInfo_iPtolayer2TrafficMappingInfo),
        ('bAPlayerBHRLCchannelMappingInfo', _TrafficMappingInfo_bAPlayerBHRLCchannelMappingInfo),
        ('choice-extension', _TrafficMappingInfo_choice_extension),
        ])
    TrafficMappingInfo._ext = None
    
    #-----< TrafficMappingInfo-ExtIEs >-----#
    TrafficMappingInfo_ExtIEs = CLASS(name='TrafficMappingInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    TrafficMappingInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransportLayerAddress >-----#
    TransportLayerAddress = BIT_STR(name='TransportLayerAddress', mode=MODE_TYPE)
    TransportLayerAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=[], er=[])
    
    #-----< TransactionID >-----#
    TransactionID = INT(name='TransactionID', mode=MODE_TYPE)
    TransactionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< Transmission-Bandwidth >-----#
    Transmission_Bandwidth = SEQ(name='Transmission-Bandwidth', mode=MODE_TYPE)
    _Transmission_Bandwidth_nRSCS = ENUM(name='nRSCS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRSCS')))
    _Transmission_Bandwidth_nRNRB = ENUM(name='nRNRB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRNRB')))
    _Transmission_Bandwidth_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Transmission_Bandwidth_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Transmission_Bandwidth_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Transmission_Bandwidth_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Transmission_Bandwidth_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transmission_Bandwidth_iE_Extensions__item__id._const_tab = ____Transmission_Bandwidth_iE_Extensions__item__id_tab
    ___Transmission_Bandwidth_iE_Extensions__item__id._const_tab_at = None
    ___Transmission_Bandwidth_iE_Extensions__item__id._const_tab_id = 'id'
    ___Transmission_Bandwidth_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Transmission_Bandwidth_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Transmission_Bandwidth_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transmission_Bandwidth_iE_Extensions__item__criticality._const_tab = ____Transmission_Bandwidth_iE_Extensions__item__criticality_tab
    ___Transmission_Bandwidth_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Transmission_Bandwidth_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Transmission_Bandwidth_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Transmission_Bandwidth_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Transmission_Bandwidth_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transmission_Bandwidth_iE_Extensions__item__extensionValue._const_tab = ____Transmission_Bandwidth_iE_Extensions__item__extensionValue_tab
    ___Transmission_Bandwidth_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Transmission_Bandwidth_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Transmission_Bandwidth_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Transmission_Bandwidth_iE_Extensions__item__id),
        ('criticality', ___Transmission_Bandwidth_iE_Extensions__item__criticality),
        ('extensionValue', ___Transmission_Bandwidth_iE_Extensions__item__extensionValue),
        ])
    __Transmission_Bandwidth_iE_Extensions__item_._ext = None
    _Transmission_Bandwidth_iE_Extensions._cont = __Transmission_Bandwidth_iE_Extensions__item_
    _Transmission_Bandwidth_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Transmission_Bandwidth._cont = ASN1Dict([
        ('nRSCS', _Transmission_Bandwidth_nRSCS),
        ('nRNRB', _Transmission_Bandwidth_nRNRB),
        ('iE-Extensions', _Transmission_Bandwidth_iE_Extensions),
        ])
    Transmission_Bandwidth._ext = []
    
    #-----< Transmission-Bandwidth-ExtIEs >-----#
    Transmission_Bandwidth_ExtIEs = CLASS(name='Transmission-Bandwidth-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Transmission_Bandwidth_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransmissionComb >-----#
    TransmissionComb = CHOICE(name='TransmissionComb', mode=MODE_TYPE)
    _TransmissionComb_n2 = SEQ(name='n2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionComb_n2_combOffset_n2 = INT(name='combOffset-n2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionComb_n2_combOffset_n2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    __TransmissionComb_n2_cyclicShift_n2 = INT(name='cyclicShift-n2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionComb_n2_cyclicShift_n2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _TransmissionComb_n2._cont = ASN1Dict([
        ('combOffset-n2', __TransmissionComb_n2_combOffset_n2),
        ('cyclicShift-n2', __TransmissionComb_n2_cyclicShift_n2),
        ])
    _TransmissionComb_n2._ext = None
    _TransmissionComb_n4 = SEQ(name='n4', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionComb_n4_combOffset_n4 = INT(name='combOffset-n4', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionComb_n4_combOffset_n4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    __TransmissionComb_n4_cyclicShift_n4 = INT(name='cyclicShift-n4', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionComb_n4_cyclicShift_n4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=11)], ev=None, er=[])
    _TransmissionComb_n4._cont = ASN1Dict([
        ('combOffset-n4', __TransmissionComb_n4_combOffset_n4),
        ('cyclicShift-n4', __TransmissionComb_n4_cyclicShift_n4),
        ])
    _TransmissionComb_n4._ext = None
    _TransmissionComb_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __TransmissionComb_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___TransmissionComb_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TransmissionComb_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TransmissionComb_choice_extension_id._const_tab = ___TransmissionComb_choice_extension_id_tab
    __TransmissionComb_choice_extension_id._const_tab_at = None
    __TransmissionComb_choice_extension_id._const_tab_id = 'id'
    __TransmissionComb_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___TransmissionComb_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TransmissionComb_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TransmissionComb_choice_extension_criticality._const_tab = ___TransmissionComb_choice_extension_criticality_tab
    __TransmissionComb_choice_extension_criticality._const_tab_at = ('..', 'id')
    __TransmissionComb_choice_extension_criticality._const_tab_id = 'criticality'
    __TransmissionComb_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___TransmissionComb_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TransmissionComb_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TransmissionComb_choice_extension_value._const_tab = ___TransmissionComb_choice_extension_value_tab
    __TransmissionComb_choice_extension_value._const_tab_at = ('..', 'id')
    __TransmissionComb_choice_extension_value._const_tab_id = 'Value'
    _TransmissionComb_choice_extension._cont = ASN1Dict([
        ('id', __TransmissionComb_choice_extension_id),
        ('criticality', __TransmissionComb_choice_extension_criticality),
        ('value', __TransmissionComb_choice_extension_value),
        ])
    _TransmissionComb_choice_extension._ext = None
    TransmissionComb._cont = ASN1Dict([
        ('n2', _TransmissionComb_n2),
        ('n4', _TransmissionComb_n4),
        ('choice-extension', _TransmissionComb_choice_extension),
        ])
    TransmissionComb._ext = None
    
    #-----< TransmissionComb-ExtIEs >-----#
    TransmissionComb_ExtIEs = CLASS(name='TransmissionComb-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    TransmissionComb_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransmissionCombPos >-----#
    TransmissionCombPos = CHOICE(name='TransmissionCombPos', mode=MODE_TYPE)
    _TransmissionCombPos_n2 = SEQ(name='n2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n2_combOffset_n2 = INT(name='combOffset-n2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n2_combOffset_n2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    __TransmissionCombPos_n2_cyclicShift_n2 = INT(name='cyclicShift-n2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n2_cyclicShift_n2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _TransmissionCombPos_n2._cont = ASN1Dict([
        ('combOffset-n2', __TransmissionCombPos_n2_combOffset_n2),
        ('cyclicShift-n2', __TransmissionCombPos_n2_cyclicShift_n2),
        ])
    _TransmissionCombPos_n2._ext = None
    _TransmissionCombPos_n4 = SEQ(name='n4', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n4_combOffset_n4 = INT(name='combOffset-n4', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n4_combOffset_n4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    __TransmissionCombPos_n4_cyclicShift_n4 = INT(name='cyclicShift-n4', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n4_cyclicShift_n4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=11)], ev=None, er=[])
    _TransmissionCombPos_n4._cont = ASN1Dict([
        ('combOffset-n4', __TransmissionCombPos_n4_combOffset_n4),
        ('cyclicShift-n4', __TransmissionCombPos_n4_cyclicShift_n4),
        ])
    _TransmissionCombPos_n4._ext = None
    _TransmissionCombPos_n8 = SEQ(name='n8', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n8_combOffset_n8 = INT(name='combOffset-n8', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n8_combOffset_n8._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    __TransmissionCombPos_n8_cyclicShift_n8 = INT(name='cyclicShift-n8', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n8_cyclicShift_n8._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5)], ev=None, er=[])
    _TransmissionCombPos_n8._cont = ASN1Dict([
        ('combOffset-n8', __TransmissionCombPos_n8_combOffset_n8),
        ('cyclicShift-n8', __TransmissionCombPos_n8_cyclicShift_n8),
        ])
    _TransmissionCombPos_n8._ext = None
    _TransmissionCombPos_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __TransmissionCombPos_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___TransmissionCombPos_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TransmissionCombPos_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TransmissionCombPos_choice_extension_id._const_tab = ___TransmissionCombPos_choice_extension_id_tab
    __TransmissionCombPos_choice_extension_id._const_tab_at = None
    __TransmissionCombPos_choice_extension_id._const_tab_id = 'id'
    __TransmissionCombPos_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___TransmissionCombPos_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TransmissionCombPos_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TransmissionCombPos_choice_extension_criticality._const_tab = ___TransmissionCombPos_choice_extension_criticality_tab
    __TransmissionCombPos_choice_extension_criticality._const_tab_at = ('..', 'id')
    __TransmissionCombPos_choice_extension_criticality._const_tab_id = 'criticality'
    __TransmissionCombPos_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___TransmissionCombPos_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TransmissionCombPos_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TransmissionCombPos_choice_extension_value._const_tab = ___TransmissionCombPos_choice_extension_value_tab
    __TransmissionCombPos_choice_extension_value._const_tab_at = ('..', 'id')
    __TransmissionCombPos_choice_extension_value._const_tab_id = 'Value'
    _TransmissionCombPos_choice_extension._cont = ASN1Dict([
        ('id', __TransmissionCombPos_choice_extension_id),
        ('criticality', __TransmissionCombPos_choice_extension_criticality),
        ('value', __TransmissionCombPos_choice_extension_value),
        ])
    _TransmissionCombPos_choice_extension._ext = None
    TransmissionCombPos._cont = ASN1Dict([
        ('n2', _TransmissionCombPos_n2),
        ('n4', _TransmissionCombPos_n4),
        ('n8', _TransmissionCombPos_n8),
        ('choice-extension', _TransmissionCombPos_choice_extension),
        ])
    TransmissionCombPos._ext = None
    
    #-----< TransmissionCombPos-ExtIEs >-----#
    TransmissionCombPos_ExtIEs = CLASS(name='TransmissionCombPos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    TransmissionCombPos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransmissionStopIndicator >-----#
    TransmissionStopIndicator = ENUM(name='TransmissionStopIndicator', mode=MODE_TYPE)
    TransmissionStopIndicator._cont = ASN1Dict([('true', 0)])
    TransmissionStopIndicator._ext = []
    
    #-----< Transport-UP-Layer-Address-Info-To-Add-List >-----#
    Transport_UP_Layer_Address_Info_To_Add_List = SEQ_OF(name='Transport-UP-Layer-Address-Info-To-Add-List', mode=MODE_TYPE)
    _Transport_UP_Layer_Address_Info_To_Add_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-UP-Layer-Address-Info-To-Add-Item')))
    Transport_UP_Layer_Address_Info_To_Add_List._cont = _Transport_UP_Layer_Address_Info_To_Add_List__item_
    Transport_UP_Layer_Address_Info_To_Add_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Transport-UP-Layer-Address-Info-To-Add-Item >-----#
    Transport_UP_Layer_Address_Info_To_Add_Item = SEQ(name='Transport-UP-Layer-Address-Info-To-Add-Item', mode=MODE_TYPE)
    _Transport_UP_Layer_Address_Info_To_Add_Item_iP_SecTransportLayerAddress = BIT_STR(name='iP-SecTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _Transport_UP_Layer_Address_Info_To_Add_Item_gTPTransportLayerAddressToAdd = SEQ_OF(name='gTPTransportLayerAddressToAdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GTPTLAs')), opt=True)
    _Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__id._const_tab = ____Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__id_tab
    ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__id._const_tab_at = None
    ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__criticality._const_tab = ____Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__criticality_tab
    ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__extensionValue._const_tab = ____Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__extensionValue_tab
    ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__id),
        ('criticality', ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__extensionValue),
        ])
    __Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item_._ext = None
    _Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions._cont = __Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item_
    _Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Transport_UP_Layer_Address_Info_To_Add_Item._cont = ASN1Dict([
        ('iP-SecTransportLayerAddress', _Transport_UP_Layer_Address_Info_To_Add_Item_iP_SecTransportLayerAddress),
        ('gTPTransportLayerAddressToAdd', _Transport_UP_Layer_Address_Info_To_Add_Item_gTPTransportLayerAddressToAdd),
        ('iE-Extensions', _Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions),
        ])
    Transport_UP_Layer_Address_Info_To_Add_Item._ext = None
    
    #-----< Transport-UP-Layer-Address-Info-To-Add-ItemExtIEs >-----#
    Transport_UP_Layer_Address_Info_To_Add_ItemExtIEs = CLASS(name='Transport-UP-Layer-Address-Info-To-Add-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Transport_UP_Layer_Address_Info_To_Add_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Transport-UP-Layer-Address-Info-To-Remove-List >-----#
    Transport_UP_Layer_Address_Info_To_Remove_List = SEQ_OF(name='Transport-UP-Layer-Address-Info-To-Remove-List', mode=MODE_TYPE)
    _Transport_UP_Layer_Address_Info_To_Remove_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-UP-Layer-Address-Info-To-Remove-Item')))
    Transport_UP_Layer_Address_Info_To_Remove_List._cont = _Transport_UP_Layer_Address_Info_To_Remove_List__item_
    Transport_UP_Layer_Address_Info_To_Remove_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Transport-UP-Layer-Address-Info-To-Remove-Item >-----#
    Transport_UP_Layer_Address_Info_To_Remove_Item = SEQ(name='Transport-UP-Layer-Address-Info-To-Remove-Item', mode=MODE_TYPE)
    _Transport_UP_Layer_Address_Info_To_Remove_Item_iP_SecTransportLayerAddress = BIT_STR(name='iP-SecTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _Transport_UP_Layer_Address_Info_To_Remove_Item_gTPTransportLayerAddressToRemove = SEQ_OF(name='gTPTransportLayerAddressToRemove', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GTPTLAs')), opt=True)
    _Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__id._const_tab = ____Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__id_tab
    ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__id._const_tab_at = None
    ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__criticality._const_tab = ____Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__criticality_tab
    ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab = ____Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__extensionValue_tab
    ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__id),
        ('criticality', ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__extensionValue),
        ])
    __Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item_._ext = None
    _Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions._cont = __Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item_
    _Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Transport_UP_Layer_Address_Info_To_Remove_Item._cont = ASN1Dict([
        ('iP-SecTransportLayerAddress', _Transport_UP_Layer_Address_Info_To_Remove_Item_iP_SecTransportLayerAddress),
        ('gTPTransportLayerAddressToRemove', _Transport_UP_Layer_Address_Info_To_Remove_Item_gTPTransportLayerAddressToRemove),
        ('iE-Extensions', _Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions),
        ])
    Transport_UP_Layer_Address_Info_To_Remove_Item._ext = None
    
    #-----< Transport-UP-Layer-Address-Info-To-Remove-ItemExtIEs >-----#
    Transport_UP_Layer_Address_Info_To_Remove_ItemExtIEs = CLASS(name='Transport-UP-Layer-Address-Info-To-Remove-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Transport_UP_Layer_Address_Info_To_Remove_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransmissionActionIndicator >-----#
    TransmissionActionIndicator = ENUM(name='TransmissionActionIndicator', mode=MODE_TYPE)
    TransmissionActionIndicator._cont = ASN1Dict([('stop', 0), ('restart', 1)])
    TransmissionActionIndicator._ext = ['restart']
    
    #-----< TRPBeamAntennaInformation >-----#
    TRPBeamAntennaInformation = SEQ(name='TRPBeamAntennaInformation', mode=MODE_TYPE)
    _TRPBeamAntennaInformation_choice_TRP_Beam_Antenna_Info_Item = CHOICE(name='choice-TRP-Beam-Antenna-Info-Item', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Choice-TRP-Beam-Antenna-Info-Item')))
    _TRPBeamAntennaInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPBeamAntennaInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TRPBeamAntennaInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TRPBeamAntennaInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPBeamAntennaInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPBeamAntennaInformation_iE_Extensions__item__id._const_tab = ____TRPBeamAntennaInformation_iE_Extensions__item__id_tab
    ___TRPBeamAntennaInformation_iE_Extensions__item__id._const_tab_at = None
    ___TRPBeamAntennaInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRPBeamAntennaInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRPBeamAntennaInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPBeamAntennaInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPBeamAntennaInformation_iE_Extensions__item__criticality._const_tab = ____TRPBeamAntennaInformation_iE_Extensions__item__criticality_tab
    ___TRPBeamAntennaInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRPBeamAntennaInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRPBeamAntennaInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRPBeamAntennaInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPBeamAntennaInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPBeamAntennaInformation_iE_Extensions__item__extensionValue._const_tab = ____TRPBeamAntennaInformation_iE_Extensions__item__extensionValue_tab
    ___TRPBeamAntennaInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRPBeamAntennaInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRPBeamAntennaInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRPBeamAntennaInformation_iE_Extensions__item__id),
        ('criticality', ___TRPBeamAntennaInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___TRPBeamAntennaInformation_iE_Extensions__item__extensionValue),
        ])
    __TRPBeamAntennaInformation_iE_Extensions__item_._ext = None
    _TRPBeamAntennaInformation_iE_Extensions._cont = __TRPBeamAntennaInformation_iE_Extensions__item_
    _TRPBeamAntennaInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPBeamAntennaInformation._cont = ASN1Dict([
        ('choice-TRP-Beam-Antenna-Info-Item', _TRPBeamAntennaInformation_choice_TRP_Beam_Antenna_Info_Item),
        ('iE-Extensions', _TRPBeamAntennaInformation_iE_Extensions),
        ])
    TRPBeamAntennaInformation._ext = []
    
    #-----< TRPBeamAntennaInformation-ExtIEs >-----#
    TRPBeamAntennaInformation_ExtIEs = CLASS(name='TRPBeamAntennaInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TRPBeamAntennaInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Choice-TRP-Beam-Antenna-Info-Item >-----#
    Choice_TRP_Beam_Antenna_Info_Item = CHOICE(name='Choice-TRP-Beam-Antenna-Info-Item', mode=MODE_TYPE)
    _Choice_TRP_Beam_Antenna_Info_Item_reference = INT(name='reference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPID')))
    _Choice_TRP_Beam_Antenna_Info_Item_explicit = SEQ(name='explicit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRP-BeamAntennaExplicitInformation')))
    _Choice_TRP_Beam_Antenna_Info_Item_noChange = NULL(name='noChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Choice_TRP_Beam_Antenna_Info_Item_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___Choice_TRP_Beam_Antenna_Info_Item_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___Choice_TRP_Beam_Antenna_Info_Item_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_id._const_tab = ___Choice_TRP_Beam_Antenna_Info_Item_choice_extension_id_tab
    __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_id._const_tab_at = None
    __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_id._const_tab_id = 'id'
    __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___Choice_TRP_Beam_Antenna_Info_Item_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___Choice_TRP_Beam_Antenna_Info_Item_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_criticality._const_tab = ___Choice_TRP_Beam_Antenna_Info_Item_choice_extension_criticality_tab
    __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_criticality._const_tab_at = ('..', 'id')
    __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_criticality._const_tab_id = 'criticality'
    __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___Choice_TRP_Beam_Antenna_Info_Item_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___Choice_TRP_Beam_Antenna_Info_Item_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_value._const_tab = ___Choice_TRP_Beam_Antenna_Info_Item_choice_extension_value_tab
    __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_value._const_tab_at = ('..', 'id')
    __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_value._const_tab_id = 'Value'
    _Choice_TRP_Beam_Antenna_Info_Item_choice_extension._cont = ASN1Dict([
        ('id', __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_id),
        ('criticality', __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_criticality),
        ('value', __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_value),
        ])
    _Choice_TRP_Beam_Antenna_Info_Item_choice_extension._ext = None
    Choice_TRP_Beam_Antenna_Info_Item._cont = ASN1Dict([
        ('reference', _Choice_TRP_Beam_Antenna_Info_Item_reference),
        ('explicit', _Choice_TRP_Beam_Antenna_Info_Item_explicit),
        ('noChange', _Choice_TRP_Beam_Antenna_Info_Item_noChange),
        ('choice-extension', _Choice_TRP_Beam_Antenna_Info_Item_choice_extension),
        ])
    Choice_TRP_Beam_Antenna_Info_Item._ext = None
    
    #-----< Choice-TRP-Beam-Info-Item-ExtIEs >-----#
    Choice_TRP_Beam_Info_Item_ExtIEs = CLASS(name='Choice-TRP-Beam-Info-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    Choice_TRP_Beam_Info_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRP-BeamAntennaExplicitInformation >-----#
    TRP_BeamAntennaExplicitInformation = SEQ(name='TRP-BeamAntennaExplicitInformation', mode=MODE_TYPE)
    _TRP_BeamAntennaExplicitInformation_trp_BeamAntennaAngles = SEQ_OF(name='trp-BeamAntennaAngles', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRP-BeamAntennaAngles')))
    _TRP_BeamAntennaExplicitInformation_lcs_to_gcs_translation = SEQ(name='lcs-to-gcs-translation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LCS-to-GCS-Translation')), opt=True)
    _TRP_BeamAntennaExplicitInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRP_BeamAntennaExplicitInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TRP_BeamAntennaExplicitInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRP_BeamAntennaExplicitInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__id._const_tab = ____TRP_BeamAntennaExplicitInformation_iE_Extensions__item__id_tab
    ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__id._const_tab_at = None
    ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRP_BeamAntennaExplicitInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRP_BeamAntennaExplicitInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__criticality._const_tab = ____TRP_BeamAntennaExplicitInformation_iE_Extensions__item__criticality_tab
    ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRP_BeamAntennaExplicitInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRP_BeamAntennaExplicitInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__extensionValue._const_tab = ____TRP_BeamAntennaExplicitInformation_iE_Extensions__item__extensionValue_tab
    ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRP_BeamAntennaExplicitInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__id),
        ('criticality', ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__extensionValue),
        ])
    __TRP_BeamAntennaExplicitInformation_iE_Extensions__item_._ext = None
    _TRP_BeamAntennaExplicitInformation_iE_Extensions._cont = __TRP_BeamAntennaExplicitInformation_iE_Extensions__item_
    _TRP_BeamAntennaExplicitInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRP_BeamAntennaExplicitInformation._cont = ASN1Dict([
        ('trp-BeamAntennaAngles', _TRP_BeamAntennaExplicitInformation_trp_BeamAntennaAngles),
        ('lcs-to-gcs-translation', _TRP_BeamAntennaExplicitInformation_lcs_to_gcs_translation),
        ('iE-Extensions', _TRP_BeamAntennaExplicitInformation_iE_Extensions),
        ])
    TRP_BeamAntennaExplicitInformation._ext = []
    
    #-----< TRP-BeamAntennaExplicitInformation-ExtIEs >-----#
    TRP_BeamAntennaExplicitInformation_ExtIEs = CLASS(name='TRP-BeamAntennaExplicitInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TRP_BeamAntennaExplicitInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRP-BeamAntennaAngles >-----#
    TRP_BeamAntennaAngles = SEQ_OF(name='TRP-BeamAntennaAngles', mode=MODE_TYPE)
    _TRP_BeamAntennaAngles__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRP-BeamAntennaAnglesList-Item')))
    TRP_BeamAntennaAngles._cont = _TRP_BeamAntennaAngles__item_
    TRP_BeamAntennaAngles._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3600)], ev=None, er=[])
    
    #-----< TRP-BeamAntennaAnglesList-Item >-----#
    TRP_BeamAntennaAnglesList_Item = SEQ(name='TRP-BeamAntennaAnglesList-Item', mode=MODE_TYPE)
    _TRP_BeamAntennaAnglesList_Item_trp_azimuth_angle = INT(name='trp-azimuth-angle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TRP_BeamAntennaAnglesList_Item_trp_azimuth_angle._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _TRP_BeamAntennaAnglesList_Item_trp_azimuth_angle_fine = INT(name='trp-azimuth-angle-fine', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TRP_BeamAntennaAnglesList_Item_trp_azimuth_angle_fine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _TRP_BeamAntennaAnglesList_Item_trp_elevation_angle_list = SEQ_OF(name='trp-elevation-angle-list', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TRP_BeamAntennaAnglesList_Item_trp_elevation_angle_list__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRP-ElevationAngleList-Item')))
    _TRP_BeamAntennaAnglesList_Item_trp_elevation_angle_list._cont = __TRP_BeamAntennaAnglesList_Item_trp_elevation_angle_list__item_
    _TRP_BeamAntennaAnglesList_Item_trp_elevation_angle_list._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1801)], ev=None, er=[])
    _TRP_BeamAntennaAnglesList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRP_BeamAntennaAnglesList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__id._const_tab = ____TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__id_tab
    ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__id._const_tab_at = None
    ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__criticality._const_tab = ____TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__criticality_tab
    ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__extensionValue._const_tab = ____TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__extensionValue_tab
    ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRP_BeamAntennaAnglesList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__id),
        ('criticality', ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__extensionValue),
        ])
    __TRP_BeamAntennaAnglesList_Item_iE_Extensions__item_._ext = None
    _TRP_BeamAntennaAnglesList_Item_iE_Extensions._cont = __TRP_BeamAntennaAnglesList_Item_iE_Extensions__item_
    _TRP_BeamAntennaAnglesList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRP_BeamAntennaAnglesList_Item._cont = ASN1Dict([
        ('trp-azimuth-angle', _TRP_BeamAntennaAnglesList_Item_trp_azimuth_angle),
        ('trp-azimuth-angle-fine', _TRP_BeamAntennaAnglesList_Item_trp_azimuth_angle_fine),
        ('trp-elevation-angle-list', _TRP_BeamAntennaAnglesList_Item_trp_elevation_angle_list),
        ('iE-Extensions', _TRP_BeamAntennaAnglesList_Item_iE_Extensions),
        ])
    TRP_BeamAntennaAnglesList_Item._ext = []
    
    #-----< TRP-BeamAntennaAnglesList-Item-ExtIEs >-----#
    TRP_BeamAntennaAnglesList_Item_ExtIEs = CLASS(name='TRP-BeamAntennaAnglesList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TRP_BeamAntennaAnglesList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRP-ElevationAngleList-Item >-----#
    TRP_ElevationAngleList_Item = SEQ(name='TRP-ElevationAngleList-Item', mode=MODE_TYPE)
    _TRP_ElevationAngleList_Item_trp_elevation_angle = INT(name='trp-elevation-angle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TRP_ElevationAngleList_Item_trp_elevation_angle._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=180)], ev=None, er=[])
    _TRP_ElevationAngleList_Item_trp_elevation_angle_fine = INT(name='trp-elevation-angle-fine', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TRP_ElevationAngleList_Item_trp_elevation_angle_fine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _TRP_ElevationAngleList_Item_trp_beam_power_list = SEQ_OF(name='trp-beam-power-list', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TRP_ElevationAngleList_Item_trp_beam_power_list__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRP-Beam-Power-Item')))
    _TRP_ElevationAngleList_Item_trp_beam_power_list._cont = __TRP_ElevationAngleList_Item_trp_beam_power_list__item_
    _TRP_ElevationAngleList_Item_trp_beam_power_list._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=24)], ev=None, er=[])
    _TRP_ElevationAngleList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRP_ElevationAngleList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TRP_ElevationAngleList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TRP_ElevationAngleList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRP_ElevationAngleList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_ElevationAngleList_Item_iE_Extensions__item__id._const_tab = ____TRP_ElevationAngleList_Item_iE_Extensions__item__id_tab
    ___TRP_ElevationAngleList_Item_iE_Extensions__item__id._const_tab_at = None
    ___TRP_ElevationAngleList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRP_ElevationAngleList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRP_ElevationAngleList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRP_ElevationAngleList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_ElevationAngleList_Item_iE_Extensions__item__criticality._const_tab = ____TRP_ElevationAngleList_Item_iE_Extensions__item__criticality_tab
    ___TRP_ElevationAngleList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRP_ElevationAngleList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRP_ElevationAngleList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRP_ElevationAngleList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRP_ElevationAngleList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_ElevationAngleList_Item_iE_Extensions__item__extensionValue._const_tab = ____TRP_ElevationAngleList_Item_iE_Extensions__item__extensionValue_tab
    ___TRP_ElevationAngleList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRP_ElevationAngleList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRP_ElevationAngleList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRP_ElevationAngleList_Item_iE_Extensions__item__id),
        ('criticality', ___TRP_ElevationAngleList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TRP_ElevationAngleList_Item_iE_Extensions__item__extensionValue),
        ])
    __TRP_ElevationAngleList_Item_iE_Extensions__item_._ext = None
    _TRP_ElevationAngleList_Item_iE_Extensions._cont = __TRP_ElevationAngleList_Item_iE_Extensions__item_
    _TRP_ElevationAngleList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRP_ElevationAngleList_Item._cont = ASN1Dict([
        ('trp-elevation-angle', _TRP_ElevationAngleList_Item_trp_elevation_angle),
        ('trp-elevation-angle-fine', _TRP_ElevationAngleList_Item_trp_elevation_angle_fine),
        ('trp-beam-power-list', _TRP_ElevationAngleList_Item_trp_beam_power_list),
        ('iE-Extensions', _TRP_ElevationAngleList_Item_iE_Extensions),
        ])
    TRP_ElevationAngleList_Item._ext = []
    
    #-----< TRP-ElevationAngleList-Item-ExtIEs >-----#
    TRP_ElevationAngleList_Item_ExtIEs = CLASS(name='TRP-ElevationAngleList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TRP_ElevationAngleList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRP-Beam-Power-Item >-----#
    TRP_Beam_Power_Item = SEQ(name='TRP-Beam-Power-Item', mode=MODE_TYPE)
    _TRP_Beam_Power_Item_pRSResourceSetID = INT(name='pRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-Set-ID')), opt=True)
    _TRP_Beam_Power_Item_pRSResourceID = INT(name='pRSResourceID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-ID')))
    _TRP_Beam_Power_Item_relativePower = INT(name='relativePower', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TRP_Beam_Power_Item_relativePower._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=30)], ev=None, er=[])
    _TRP_Beam_Power_Item_relativePowerFine = INT(name='relativePowerFine', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TRP_Beam_Power_Item_relativePowerFine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _TRP_Beam_Power_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRP_Beam_Power_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TRP_Beam_Power_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TRP_Beam_Power_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRP_Beam_Power_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_Beam_Power_Item_iE_Extensions__item__id._const_tab = ____TRP_Beam_Power_Item_iE_Extensions__item__id_tab
    ___TRP_Beam_Power_Item_iE_Extensions__item__id._const_tab_at = None
    ___TRP_Beam_Power_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRP_Beam_Power_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRP_Beam_Power_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRP_Beam_Power_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_Beam_Power_Item_iE_Extensions__item__criticality._const_tab = ____TRP_Beam_Power_Item_iE_Extensions__item__criticality_tab
    ___TRP_Beam_Power_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRP_Beam_Power_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRP_Beam_Power_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRP_Beam_Power_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRP_Beam_Power_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_Beam_Power_Item_iE_Extensions__item__extensionValue._const_tab = ____TRP_Beam_Power_Item_iE_Extensions__item__extensionValue_tab
    ___TRP_Beam_Power_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRP_Beam_Power_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRP_Beam_Power_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRP_Beam_Power_Item_iE_Extensions__item__id),
        ('criticality', ___TRP_Beam_Power_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TRP_Beam_Power_Item_iE_Extensions__item__extensionValue),
        ])
    __TRP_Beam_Power_Item_iE_Extensions__item_._ext = None
    _TRP_Beam_Power_Item_iE_Extensions._cont = __TRP_Beam_Power_Item_iE_Extensions__item_
    _TRP_Beam_Power_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRP_Beam_Power_Item._cont = ASN1Dict([
        ('pRSResourceSetID', _TRP_Beam_Power_Item_pRSResourceSetID),
        ('pRSResourceID', _TRP_Beam_Power_Item_pRSResourceID),
        ('relativePower', _TRP_Beam_Power_Item_relativePower),
        ('relativePowerFine', _TRP_Beam_Power_Item_relativePowerFine),
        ('iE-Extensions', _TRP_Beam_Power_Item_iE_Extensions),
        ])
    TRP_Beam_Power_Item._ext = []
    
    #-----< TRP-Beam-Power-Item-ExtIEs >-----#
    TRP_Beam_Power_Item_ExtIEs = CLASS(name='TRP-Beam-Power-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TRP_Beam_Power_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPID >-----#
    TRPID = INT(name='TRPID', mode=MODE_TYPE)
    TRPID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=[], er=[])
    
    #-----< TRPInformation >-----#
    TRPInformation = SEQ(name='TRPInformation', mode=MODE_TYPE)
    _TRPInformation_tRPID = INT(name='tRPID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPID')))
    _TRPInformation_tRPInformationTypeResponseList = SEQ_OF(name='tRPInformationTypeResponseList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPInformationTypeResponseList')))
    _TRPInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TRPInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TRPInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPInformation_iE_Extensions__item__id._const_tab = ____TRPInformation_iE_Extensions__item__id_tab
    ___TRPInformation_iE_Extensions__item__id._const_tab_at = None
    ___TRPInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRPInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRPInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPInformation_iE_Extensions__item__criticality._const_tab = ____TRPInformation_iE_Extensions__item__criticality_tab
    ___TRPInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRPInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRPInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRPInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPInformation_iE_Extensions__item__extensionValue._const_tab = ____TRPInformation_iE_Extensions__item__extensionValue_tab
    ___TRPInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRPInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRPInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRPInformation_iE_Extensions__item__id),
        ('criticality', ___TRPInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___TRPInformation_iE_Extensions__item__extensionValue),
        ])
    __TRPInformation_iE_Extensions__item_._ext = None
    _TRPInformation_iE_Extensions._cont = __TRPInformation_iE_Extensions__item_
    _TRPInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPInformation._cont = ASN1Dict([
        ('tRPID', _TRPInformation_tRPID),
        ('tRPInformationTypeResponseList', _TRPInformation_tRPInformationTypeResponseList),
        ('iE-Extensions', _TRPInformation_iE_Extensions),
        ])
    TRPInformation._ext = None
    
    #-----< TRPInformation-ExtIEs >-----#
    TRPInformation_ExtIEs = CLASS(name='TRPInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TRPInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPInformationItem >-----#
    TRPInformationItem = SEQ(name='TRPInformationItem', mode=MODE_TYPE)
    _TRPInformationItem_tRPInformation = SEQ(name='tRPInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPInformation')))
    _TRPInformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TRPInformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TRPInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPInformationItem_iE_Extensions__item__id._const_tab = ____TRPInformationItem_iE_Extensions__item__id_tab
    ___TRPInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___TRPInformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRPInformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRPInformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPInformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPInformationItem_iE_Extensions__item__criticality._const_tab = ____TRPInformationItem_iE_Extensions__item__criticality_tab
    ___TRPInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRPInformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRPInformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRPInformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPInformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPInformationItem_iE_Extensions__item__extensionValue._const_tab = ____TRPInformationItem_iE_Extensions__item__extensionValue_tab
    ___TRPInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRPInformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRPInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRPInformationItem_iE_Extensions__item__id),
        ('criticality', ___TRPInformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___TRPInformationItem_iE_Extensions__item__extensionValue),
        ])
    __TRPInformationItem_iE_Extensions__item_._ext = None
    _TRPInformationItem_iE_Extensions._cont = __TRPInformationItem_iE_Extensions__item_
    _TRPInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPInformationItem._cont = ASN1Dict([
        ('tRPInformation', _TRPInformationItem_tRPInformation),
        ('iE-Extensions', _TRPInformationItem_iE_Extensions),
        ])
    TRPInformationItem._ext = None
    
    #-----< TRPInformationItem-ExtIEs >-----#
    TRPInformationItem_ExtIEs = CLASS(name='TRPInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TRPInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPInformationTypeItem >-----#
    TRPInformationTypeItem = ENUM(name='TRPInformationTypeItem', mode=MODE_TYPE)
    TRPInformationTypeItem._cont = ASN1Dict([('nrPCI', 0), ('nG-RAN-CGI', 1), ('arfcn', 2), ('pRSConfig', 3), ('sSBConfig', 4), ('sFNInitTime', 5), ('spatialDirectInfo', 6), ('geoCoord', 7), ('trp-type', 8), ('ondemandPRS', 9), ('trpTxTeg', 10), ('beam-antenna-info', 11)])
    TRPInformationTypeItem._ext = ['trp-type', 'ondemandPRS', 'trpTxTeg', 'beam-antenna-info']
    
    #-----< TRPInformationTypeResponseList >-----#
    TRPInformationTypeResponseList = SEQ_OF(name='TRPInformationTypeResponseList', mode=MODE_TYPE)
    _TRPInformationTypeResponseList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPInformationTypeResponseItem')))
    TRPInformationTypeResponseList._cont = _TRPInformationTypeResponseList__item_
    TRPInformationTypeResponseList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< TRPInformationTypeResponseItem >-----#
    TRPInformationTypeResponseItem = CHOICE(name='TRPInformationTypeResponseItem', mode=MODE_TYPE)
    _TRPInformationTypeResponseItem_pCI_NR = INT(name='pCI-NR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRPCI')))
    _TRPInformationTypeResponseItem_nG_RAN_CGI = SEQ(name='nG-RAN-CGI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _TRPInformationTypeResponseItem_nRARFCN = INT(name='nRARFCN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TRPInformationTypeResponseItem_nRARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _TRPInformationTypeResponseItem_pRSConfiguration = SEQ(name='pRSConfiguration', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSConfiguration')))
    _TRPInformationTypeResponseItem_sSBinformation = SEQ(name='sSBinformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SSBInformation')))
    _TRPInformationTypeResponseItem_sFNInitialisationTime = BIT_STR(name='sFNInitialisationTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RelativeTime1900')))
    _TRPInformationTypeResponseItem_spatialDirectionInformation = SEQ(name='spatialDirectionInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SpatialDirectionInformation')))
    _TRPInformationTypeResponseItem_geographicalCoordinates = SEQ(name='geographicalCoordinates', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GeographicalCoordinates')))
    _TRPInformationTypeResponseItem_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __TRPInformationTypeResponseItem_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___TRPInformationTypeResponseItem_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPType')))
    ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'OnDemandPRS-Info')))
    ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPTxTEGAssociation')))
    ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPBeamAntennaInformation')))
    ___TRPInformationTypeResponseItem_choice_extension_id_tab._val = ASN1Set(rv=[dict([('id', 434), ('criticality', 'reject'), ('Value', ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 551), ('criticality', 'reject'), ('Value', ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 566), ('criticality', 'reject'), ('Value', ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 577), ('criticality', 'reject'), ('Value', ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __TRPInformationTypeResponseItem_choice_extension_id._const_tab = ___TRPInformationTypeResponseItem_choice_extension_id_tab
    __TRPInformationTypeResponseItem_choice_extension_id._const_tab_at = None
    __TRPInformationTypeResponseItem_choice_extension_id._const_tab_id = 'id'
    __TRPInformationTypeResponseItem_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __TRPInformationTypeResponseItem_choice_extension_criticality._const_tab = ___TRPInformationTypeResponseItem_choice_extension_id_tab
    __TRPInformationTypeResponseItem_choice_extension_criticality._const_tab_at = ('..', 'id')
    __TRPInformationTypeResponseItem_choice_extension_criticality._const_tab_id = 'criticality'
    __TRPInformationTypeResponseItem_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __TRPInformationTypeResponseItem_choice_extension_value._const_tab = ___TRPInformationTypeResponseItem_choice_extension_id_tab
    __TRPInformationTypeResponseItem_choice_extension_value._const_tab_at = ('..', 'id')
    __TRPInformationTypeResponseItem_choice_extension_value._const_tab_id = 'Value'
    _TRPInformationTypeResponseItem_choice_extension._cont = ASN1Dict([
        ('id', __TRPInformationTypeResponseItem_choice_extension_id),
        ('criticality', __TRPInformationTypeResponseItem_choice_extension_criticality),
        ('value', __TRPInformationTypeResponseItem_choice_extension_value),
        ])
    _TRPInformationTypeResponseItem_choice_extension._ext = None
    TRPInformationTypeResponseItem._cont = ASN1Dict([
        ('pCI-NR', _TRPInformationTypeResponseItem_pCI_NR),
        ('nG-RAN-CGI', _TRPInformationTypeResponseItem_nG_RAN_CGI),
        ('nRARFCN', _TRPInformationTypeResponseItem_nRARFCN),
        ('pRSConfiguration', _TRPInformationTypeResponseItem_pRSConfiguration),
        ('sSBinformation', _TRPInformationTypeResponseItem_sSBinformation),
        ('sFNInitialisationTime', _TRPInformationTypeResponseItem_sFNInitialisationTime),
        ('spatialDirectionInformation', _TRPInformationTypeResponseItem_spatialDirectionInformation),
        ('geographicalCoordinates', _TRPInformationTypeResponseItem_geographicalCoordinates),
        ('choice-extension', _TRPInformationTypeResponseItem_choice_extension),
        ])
    TRPInformationTypeResponseItem._ext = None
    
    #-----< TRPInformationTypeResponseItem-ExtIEs >-----#
    TRPInformationTypeResponseItem_ExtIEs = CLASS(name='TRPInformationTypeResponseItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _TRPInformationTypeResponseItem_ExtIEs_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPType')))
    _TRPInformationTypeResponseItem_ExtIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'OnDemandPRS-Info')))
    _TRPInformationTypeResponseItem_ExtIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPTxTEGAssociation')))
    _TRPInformationTypeResponseItem_ExtIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPBeamAntennaInformation')))
    TRPInformationTypeResponseItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 434), ('criticality', 'reject'), ('Value', _TRPInformationTypeResponseItem_ExtIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 551), ('criticality', 'reject'), ('Value', _TRPInformationTypeResponseItem_ExtIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 566), ('criticality', 'reject'), ('Value', _TRPInformationTypeResponseItem_ExtIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 577), ('criticality', 'reject'), ('Value', _TRPInformationTypeResponseItem_ExtIEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TRPList >-----#
    TRPList = SEQ_OF(name='TRPList', mode=MODE_TYPE)
    _TRPList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPListItem')))
    TRPList._cont = _TRPList__item_
    TRPList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< TRPListItem >-----#
    TRPListItem = SEQ(name='TRPListItem', mode=MODE_TYPE)
    _TRPListItem_tRPID = INT(name='tRPID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPID')))
    _TRPListItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPListItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TRPListItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TRPListItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPListItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPListItem_iE_Extensions__item__id._const_tab = ____TRPListItem_iE_Extensions__item__id_tab
    ___TRPListItem_iE_Extensions__item__id._const_tab_at = None
    ___TRPListItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRPListItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRPListItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPListItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPListItem_iE_Extensions__item__criticality._const_tab = ____TRPListItem_iE_Extensions__item__criticality_tab
    ___TRPListItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRPListItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRPListItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRPListItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPListItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPListItem_iE_Extensions__item__extensionValue._const_tab = ____TRPListItem_iE_Extensions__item__extensionValue_tab
    ___TRPListItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRPListItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRPListItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRPListItem_iE_Extensions__item__id),
        ('criticality', ___TRPListItem_iE_Extensions__item__criticality),
        ('extensionValue', ___TRPListItem_iE_Extensions__item__extensionValue),
        ])
    __TRPListItem_iE_Extensions__item_._ext = None
    _TRPListItem_iE_Extensions._cont = __TRPListItem_iE_Extensions__item_
    _TRPListItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPListItem._cont = ASN1Dict([
        ('tRPID', _TRPListItem_tRPID),
        ('iE-Extensions', _TRPListItem_iE_Extensions),
        ])
    TRPListItem._ext = None
    
    #-----< TRPListItem-ExtIEs >-----#
    TRPListItem_ExtIEs = CLASS(name='TRPListItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TRPListItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPMeasurementQuality >-----#
    TRPMeasurementQuality = SEQ(name='TRPMeasurementQuality', mode=MODE_TYPE)
    _TRPMeasurementQuality_tRPmeasurementQuality_Item = CHOICE(name='tRPmeasurementQuality-Item', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPMeasurementQuality-Item')))
    _TRPMeasurementQuality_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPMeasurementQuality_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TRPMeasurementQuality_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TRPMeasurementQuality_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPMeasurementQuality_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPMeasurementQuality_iE_Extensions__item__id._const_tab = ____TRPMeasurementQuality_iE_Extensions__item__id_tab
    ___TRPMeasurementQuality_iE_Extensions__item__id._const_tab_at = None
    ___TRPMeasurementQuality_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRPMeasurementQuality_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRPMeasurementQuality_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPMeasurementQuality_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPMeasurementQuality_iE_Extensions__item__criticality._const_tab = ____TRPMeasurementQuality_iE_Extensions__item__criticality_tab
    ___TRPMeasurementQuality_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRPMeasurementQuality_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRPMeasurementQuality_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRPMeasurementQuality_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPMeasurementQuality_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPMeasurementQuality_iE_Extensions__item__extensionValue._const_tab = ____TRPMeasurementQuality_iE_Extensions__item__extensionValue_tab
    ___TRPMeasurementQuality_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRPMeasurementQuality_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRPMeasurementQuality_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRPMeasurementQuality_iE_Extensions__item__id),
        ('criticality', ___TRPMeasurementQuality_iE_Extensions__item__criticality),
        ('extensionValue', ___TRPMeasurementQuality_iE_Extensions__item__extensionValue),
        ])
    __TRPMeasurementQuality_iE_Extensions__item_._ext = None
    _TRPMeasurementQuality_iE_Extensions._cont = __TRPMeasurementQuality_iE_Extensions__item_
    _TRPMeasurementQuality_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPMeasurementQuality._cont = ASN1Dict([
        ('tRPmeasurementQuality-Item', _TRPMeasurementQuality_tRPmeasurementQuality_Item),
        ('iE-Extensions', _TRPMeasurementQuality_iE_Extensions),
        ])
    TRPMeasurementQuality._ext = None
    
    #-----< TRPMeasurementQuality-ExtIEs >-----#
    TRPMeasurementQuality_ExtIEs = CLASS(name='TRPMeasurementQuality-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TRPMeasurementQuality_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPMeasurementQuality-Item >-----#
    TRPMeasurementQuality_Item = CHOICE(name='TRPMeasurementQuality-Item', mode=MODE_TYPE)
    _TRPMeasurementQuality_Item_timingMeasurementQuality = SEQ(name='timingMeasurementQuality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TimingMeasurementQuality')))
    _TRPMeasurementQuality_Item_angleMeasurementQuality = SEQ(name='angleMeasurementQuality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AngleMeasurementQuality')))
    _TRPMeasurementQuality_Item_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __TRPMeasurementQuality_Item_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___TRPMeasurementQuality_Item_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPMeasurementQuality_Item_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPMeasurementQuality_Item_choice_extension_id._const_tab = ___TRPMeasurementQuality_Item_choice_extension_id_tab
    __TRPMeasurementQuality_Item_choice_extension_id._const_tab_at = None
    __TRPMeasurementQuality_Item_choice_extension_id._const_tab_id = 'id'
    __TRPMeasurementQuality_Item_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___TRPMeasurementQuality_Item_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPMeasurementQuality_Item_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPMeasurementQuality_Item_choice_extension_criticality._const_tab = ___TRPMeasurementQuality_Item_choice_extension_criticality_tab
    __TRPMeasurementQuality_Item_choice_extension_criticality._const_tab_at = ('..', 'id')
    __TRPMeasurementQuality_Item_choice_extension_criticality._const_tab_id = 'criticality'
    __TRPMeasurementQuality_Item_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___TRPMeasurementQuality_Item_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPMeasurementQuality_Item_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPMeasurementQuality_Item_choice_extension_value._const_tab = ___TRPMeasurementQuality_Item_choice_extension_value_tab
    __TRPMeasurementQuality_Item_choice_extension_value._const_tab_at = ('..', 'id')
    __TRPMeasurementQuality_Item_choice_extension_value._const_tab_id = 'Value'
    _TRPMeasurementQuality_Item_choice_extension._cont = ASN1Dict([
        ('id', __TRPMeasurementQuality_Item_choice_extension_id),
        ('criticality', __TRPMeasurementQuality_Item_choice_extension_criticality),
        ('value', __TRPMeasurementQuality_Item_choice_extension_value),
        ])
    _TRPMeasurementQuality_Item_choice_extension._ext = None
    TRPMeasurementQuality_Item._cont = ASN1Dict([
        ('timingMeasurementQuality', _TRPMeasurementQuality_Item_timingMeasurementQuality),
        ('angleMeasurementQuality', _TRPMeasurementQuality_Item_angleMeasurementQuality),
        ('choice-extension', _TRPMeasurementQuality_Item_choice_extension),
        ])
    TRPMeasurementQuality_Item._ext = None
    
    #-----< TRPMeasurementQuality-Item-ExtIEs >-----#
    TRPMeasurementQuality_Item_ExtIEs = CLASS(name='TRPMeasurementQuality-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    TRPMeasurementQuality_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRP-MeasurementRequestList >-----#
    TRP_MeasurementRequestList = SEQ_OF(name='TRP-MeasurementRequestList', mode=MODE_TYPE)
    _TRP_MeasurementRequestList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRP-MeasurementRequestItem')))
    TRP_MeasurementRequestList._cont = _TRP_MeasurementRequestList__item_
    TRP_MeasurementRequestList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< TRP-MeasurementRequestItem >-----#
    TRP_MeasurementRequestItem = SEQ(name='TRP-MeasurementRequestItem', mode=MODE_TYPE)
    _TRP_MeasurementRequestItem_tRPID = INT(name='tRPID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPID')))
    _TRP_MeasurementRequestItem_search_window_information = SEQ(name='search-window-information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Search-window-information')), opt=True)
    _TRP_MeasurementRequestItem_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRP_MeasurementRequestItem_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TRP_MeasurementRequestItem_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TRP_MeasurementRequestItem_iE_extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AoA-AssistanceInfo')))
    _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NumberOfTRPRxTEG')))
    _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NumberOfTRPRxTxTEG')))
    ____TRP_MeasurementRequestItem_iE_extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Extension', _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 552), ('criticality', 'ignore'), ('Extension', _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 564), ('criticality', 'ignore'), ('Extension', _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 565), ('criticality', 'ignore'), ('Extension', _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TRP_MeasurementRequestItem_iE_extensions__item__id._const_tab = ____TRP_MeasurementRequestItem_iE_extensions__item__id_tab
    ___TRP_MeasurementRequestItem_iE_extensions__item__id._const_tab_at = None
    ___TRP_MeasurementRequestItem_iE_extensions__item__id._const_tab_id = 'id'
    ___TRP_MeasurementRequestItem_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TRP_MeasurementRequestItem_iE_extensions__item__criticality._const_tab = ____TRP_MeasurementRequestItem_iE_extensions__item__id_tab
    ___TRP_MeasurementRequestItem_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRP_MeasurementRequestItem_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___TRP_MeasurementRequestItem_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TRP_MeasurementRequestItem_iE_extensions__item__extensionValue._const_tab = ____TRP_MeasurementRequestItem_iE_extensions__item__id_tab
    ___TRP_MeasurementRequestItem_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRP_MeasurementRequestItem_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRP_MeasurementRequestItem_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___TRP_MeasurementRequestItem_iE_extensions__item__id),
        ('criticality', ___TRP_MeasurementRequestItem_iE_extensions__item__criticality),
        ('extensionValue', ___TRP_MeasurementRequestItem_iE_extensions__item__extensionValue),
        ])
    __TRP_MeasurementRequestItem_iE_extensions__item_._ext = None
    _TRP_MeasurementRequestItem_iE_extensions._cont = __TRP_MeasurementRequestItem_iE_extensions__item_
    _TRP_MeasurementRequestItem_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRP_MeasurementRequestItem._cont = ASN1Dict([
        ('tRPID', _TRP_MeasurementRequestItem_tRPID),
        ('search-window-information', _TRP_MeasurementRequestItem_search_window_information),
        ('iE-extensions', _TRP_MeasurementRequestItem_iE_extensions),
        ])
    TRP_MeasurementRequestItem._ext = None
    
    #-----< TRP-MeasurementRequestItem-ExtIEs >-----#
    TRP_MeasurementRequestItem_ExtIEs = CLASS(name='TRP-MeasurementRequestItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _TRP_MeasurementRequestItem_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _TRP_MeasurementRequestItem_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AoA-AssistanceInfo')))
    _TRP_MeasurementRequestItem_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NumberOfTRPRxTEG')))
    _TRP_MeasurementRequestItem_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NumberOfTRPRxTxTEG')))
    TRP_MeasurementRequestItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Extension', _TRP_MeasurementRequestItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 552), ('criticality', 'ignore'), ('Extension', _TRP_MeasurementRequestItem_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 564), ('criticality', 'ignore'), ('Extension', _TRP_MeasurementRequestItem_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 565), ('criticality', 'ignore'), ('Extension', _TRP_MeasurementRequestItem_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TRP-PRS-Info-List >-----#
    TRP_PRS_Info_List = SEQ_OF(name='TRP-PRS-Info-List', mode=MODE_TYPE)
    _TRP_PRS_Info_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRP-PRS-Info-List-Item')))
    TRP_PRS_Info_List._cont = _TRP_PRS_Info_List__item_
    TRP_PRS_Info_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< TRP-PRS-Info-List-Item >-----#
    TRP_PRS_Info_List_Item = SEQ(name='TRP-PRS-Info-List-Item', mode=MODE_TYPE)
    _TRP_PRS_Info_List_Item_tRP_ID = INT(name='tRP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPID')))
    _TRP_PRS_Info_List_Item_nR_PCI = INT(name='nR-PCI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRPCI')))
    _TRP_PRS_Info_List_Item_cGI_NR = SEQ(name='cGI-NR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')), opt=True)
    _TRP_PRS_Info_List_Item_pRSConfiguration = SEQ(name='pRSConfiguration', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRSConfiguration')))
    _TRP_PRS_Info_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRP_PRS_Info_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TRP_PRS_Info_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TRP_PRS_Info_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRP_PRS_Info_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_PRS_Info_List_Item_iE_Extensions__item__id._const_tab = ____TRP_PRS_Info_List_Item_iE_Extensions__item__id_tab
    ___TRP_PRS_Info_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___TRP_PRS_Info_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRP_PRS_Info_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRP_PRS_Info_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRP_PRS_Info_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_PRS_Info_List_Item_iE_Extensions__item__criticality._const_tab = ____TRP_PRS_Info_List_Item_iE_Extensions__item__criticality_tab
    ___TRP_PRS_Info_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRP_PRS_Info_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRP_PRS_Info_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRP_PRS_Info_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRP_PRS_Info_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_PRS_Info_List_Item_iE_Extensions__item__extensionValue._const_tab = ____TRP_PRS_Info_List_Item_iE_Extensions__item__extensionValue_tab
    ___TRP_PRS_Info_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRP_PRS_Info_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRP_PRS_Info_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRP_PRS_Info_List_Item_iE_Extensions__item__id),
        ('criticality', ___TRP_PRS_Info_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TRP_PRS_Info_List_Item_iE_Extensions__item__extensionValue),
        ])
    __TRP_PRS_Info_List_Item_iE_Extensions__item_._ext = None
    _TRP_PRS_Info_List_Item_iE_Extensions._cont = __TRP_PRS_Info_List_Item_iE_Extensions__item_
    _TRP_PRS_Info_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRP_PRS_Info_List_Item._cont = ASN1Dict([
        ('tRP-ID', _TRP_PRS_Info_List_Item_tRP_ID),
        ('nR-PCI', _TRP_PRS_Info_List_Item_nR_PCI),
        ('cGI-NR', _TRP_PRS_Info_List_Item_cGI_NR),
        ('pRSConfiguration', _TRP_PRS_Info_List_Item_pRSConfiguration),
        ('iE-Extensions', _TRP_PRS_Info_List_Item_iE_Extensions),
        ])
    TRP_PRS_Info_List_Item._ext = []
    
    #-----< TRP-PRS-Info-List-Item-ExtIEs >-----#
    TRP_PRS_Info_List_Item_ExtIEs = CLASS(name='TRP-PRS-Info-List-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TRP_PRS_Info_List_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPPositionDefinitionType >-----#
    TRPPositionDefinitionType = CHOICE(name='TRPPositionDefinitionType', mode=MODE_TYPE)
    _TRPPositionDefinitionType_direct = SEQ(name='direct', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPPositionDirect')))
    _TRPPositionDefinitionType_referenced = SEQ(name='referenced', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPPositionReferenced')))
    _TRPPositionDefinitionType_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __TRPPositionDefinitionType_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___TRPPositionDefinitionType_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPPositionDefinitionType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPPositionDefinitionType_choice_extension_id._const_tab = ___TRPPositionDefinitionType_choice_extension_id_tab
    __TRPPositionDefinitionType_choice_extension_id._const_tab_at = None
    __TRPPositionDefinitionType_choice_extension_id._const_tab_id = 'id'
    __TRPPositionDefinitionType_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___TRPPositionDefinitionType_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPPositionDefinitionType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPPositionDefinitionType_choice_extension_criticality._const_tab = ___TRPPositionDefinitionType_choice_extension_criticality_tab
    __TRPPositionDefinitionType_choice_extension_criticality._const_tab_at = ('..', 'id')
    __TRPPositionDefinitionType_choice_extension_criticality._const_tab_id = 'criticality'
    __TRPPositionDefinitionType_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___TRPPositionDefinitionType_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPPositionDefinitionType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPPositionDefinitionType_choice_extension_value._const_tab = ___TRPPositionDefinitionType_choice_extension_value_tab
    __TRPPositionDefinitionType_choice_extension_value._const_tab_at = ('..', 'id')
    __TRPPositionDefinitionType_choice_extension_value._const_tab_id = 'Value'
    _TRPPositionDefinitionType_choice_extension._cont = ASN1Dict([
        ('id', __TRPPositionDefinitionType_choice_extension_id),
        ('criticality', __TRPPositionDefinitionType_choice_extension_criticality),
        ('value', __TRPPositionDefinitionType_choice_extension_value),
        ])
    _TRPPositionDefinitionType_choice_extension._ext = None
    TRPPositionDefinitionType._cont = ASN1Dict([
        ('direct', _TRPPositionDefinitionType_direct),
        ('referenced', _TRPPositionDefinitionType_referenced),
        ('choice-extension', _TRPPositionDefinitionType_choice_extension),
        ])
    TRPPositionDefinitionType._ext = None
    
    #-----< TRPPositionDefinitionType-ExtIEs >-----#
    TRPPositionDefinitionType_ExtIEs = CLASS(name='TRPPositionDefinitionType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    TRPPositionDefinitionType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPPositionDirect >-----#
    TRPPositionDirect = SEQ(name='TRPPositionDirect', mode=MODE_TYPE)
    _TRPPositionDirect_accuracy = CHOICE(name='accuracy', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPPositionDirectAccuracy')))
    _TRPPositionDirect_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPPositionDirect_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TRPPositionDirect_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TRPPositionDirect_iE_extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPPositionDirect_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPPositionDirect_iE_extensions__item__id._const_tab = ____TRPPositionDirect_iE_extensions__item__id_tab
    ___TRPPositionDirect_iE_extensions__item__id._const_tab_at = None
    ___TRPPositionDirect_iE_extensions__item__id._const_tab_id = 'id'
    ___TRPPositionDirect_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRPPositionDirect_iE_extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPPositionDirect_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPPositionDirect_iE_extensions__item__criticality._const_tab = ____TRPPositionDirect_iE_extensions__item__criticality_tab
    ___TRPPositionDirect_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRPPositionDirect_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___TRPPositionDirect_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRPPositionDirect_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPPositionDirect_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPPositionDirect_iE_extensions__item__extensionValue._const_tab = ____TRPPositionDirect_iE_extensions__item__extensionValue_tab
    ___TRPPositionDirect_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRPPositionDirect_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRPPositionDirect_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___TRPPositionDirect_iE_extensions__item__id),
        ('criticality', ___TRPPositionDirect_iE_extensions__item__criticality),
        ('extensionValue', ___TRPPositionDirect_iE_extensions__item__extensionValue),
        ])
    __TRPPositionDirect_iE_extensions__item_._ext = None
    _TRPPositionDirect_iE_extensions._cont = __TRPPositionDirect_iE_extensions__item_
    _TRPPositionDirect_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPPositionDirect._cont = ASN1Dict([
        ('accuracy', _TRPPositionDirect_accuracy),
        ('iE-extensions', _TRPPositionDirect_iE_extensions),
        ])
    TRPPositionDirect._ext = None
    
    #-----< TRPPositionDirect-ExtIEs >-----#
    TRPPositionDirect_ExtIEs = CLASS(name='TRPPositionDirect-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TRPPositionDirect_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPPositionDirectAccuracy >-----#
    TRPPositionDirectAccuracy = CHOICE(name='TRPPositionDirectAccuracy', mode=MODE_TYPE)
    _TRPPositionDirectAccuracy_tRPPosition = SEQ(name='tRPPosition', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AccessPointPosition')))
    _TRPPositionDirectAccuracy_tRPHAposition = SEQ(name='tRPHAposition', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NGRANHighAccuracyAccessPointPosition')))
    _TRPPositionDirectAccuracy_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __TRPPositionDirectAccuracy_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___TRPPositionDirectAccuracy_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPPositionDirectAccuracy_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPPositionDirectAccuracy_choice_extension_id._const_tab = ___TRPPositionDirectAccuracy_choice_extension_id_tab
    __TRPPositionDirectAccuracy_choice_extension_id._const_tab_at = None
    __TRPPositionDirectAccuracy_choice_extension_id._const_tab_id = 'id'
    __TRPPositionDirectAccuracy_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___TRPPositionDirectAccuracy_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPPositionDirectAccuracy_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPPositionDirectAccuracy_choice_extension_criticality._const_tab = ___TRPPositionDirectAccuracy_choice_extension_criticality_tab
    __TRPPositionDirectAccuracy_choice_extension_criticality._const_tab_at = ('..', 'id')
    __TRPPositionDirectAccuracy_choice_extension_criticality._const_tab_id = 'criticality'
    __TRPPositionDirectAccuracy_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___TRPPositionDirectAccuracy_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPPositionDirectAccuracy_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPPositionDirectAccuracy_choice_extension_value._const_tab = ___TRPPositionDirectAccuracy_choice_extension_value_tab
    __TRPPositionDirectAccuracy_choice_extension_value._const_tab_at = ('..', 'id')
    __TRPPositionDirectAccuracy_choice_extension_value._const_tab_id = 'Value'
    _TRPPositionDirectAccuracy_choice_extension._cont = ASN1Dict([
        ('id', __TRPPositionDirectAccuracy_choice_extension_id),
        ('criticality', __TRPPositionDirectAccuracy_choice_extension_criticality),
        ('value', __TRPPositionDirectAccuracy_choice_extension_value),
        ])
    _TRPPositionDirectAccuracy_choice_extension._ext = None
    TRPPositionDirectAccuracy._cont = ASN1Dict([
        ('tRPPosition', _TRPPositionDirectAccuracy_tRPPosition),
        ('tRPHAposition', _TRPPositionDirectAccuracy_tRPHAposition),
        ('choice-extension', _TRPPositionDirectAccuracy_choice_extension),
        ])
    TRPPositionDirectAccuracy._ext = None
    
    #-----< TRPPositionDirectAccuracy-ExtIEs >-----#
    TRPPositionDirectAccuracy_ExtIEs = CLASS(name='TRPPositionDirectAccuracy-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    TRPPositionDirectAccuracy_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPPositionReferenced >-----#
    TRPPositionReferenced = SEQ(name='TRPPositionReferenced', mode=MODE_TYPE)
    _TRPPositionReferenced_referencePoint = CHOICE(name='referencePoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ReferencePoint')))
    _TRPPositionReferenced_referencePointType = CHOICE(name='referencePointType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPReferencePointType')))
    _TRPPositionReferenced_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPPositionReferenced_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TRPPositionReferenced_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TRPPositionReferenced_iE_extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPPositionReferenced_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPPositionReferenced_iE_extensions__item__id._const_tab = ____TRPPositionReferenced_iE_extensions__item__id_tab
    ___TRPPositionReferenced_iE_extensions__item__id._const_tab_at = None
    ___TRPPositionReferenced_iE_extensions__item__id._const_tab_id = 'id'
    ___TRPPositionReferenced_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRPPositionReferenced_iE_extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPPositionReferenced_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPPositionReferenced_iE_extensions__item__criticality._const_tab = ____TRPPositionReferenced_iE_extensions__item__criticality_tab
    ___TRPPositionReferenced_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRPPositionReferenced_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___TRPPositionReferenced_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRPPositionReferenced_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPPositionReferenced_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPPositionReferenced_iE_extensions__item__extensionValue._const_tab = ____TRPPositionReferenced_iE_extensions__item__extensionValue_tab
    ___TRPPositionReferenced_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRPPositionReferenced_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRPPositionReferenced_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___TRPPositionReferenced_iE_extensions__item__id),
        ('criticality', ___TRPPositionReferenced_iE_extensions__item__criticality),
        ('extensionValue', ___TRPPositionReferenced_iE_extensions__item__extensionValue),
        ])
    __TRPPositionReferenced_iE_extensions__item_._ext = None
    _TRPPositionReferenced_iE_extensions._cont = __TRPPositionReferenced_iE_extensions__item_
    _TRPPositionReferenced_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPPositionReferenced._cont = ASN1Dict([
        ('referencePoint', _TRPPositionReferenced_referencePoint),
        ('referencePointType', _TRPPositionReferenced_referencePointType),
        ('iE-extensions', _TRPPositionReferenced_iE_extensions),
        ])
    TRPPositionReferenced._ext = None
    
    #-----< TRPPositionReferenced-ExtIEs >-----#
    TRPPositionReferenced_ExtIEs = CLASS(name='TRPPositionReferenced-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TRPPositionReferenced_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPReferencePointType >-----#
    TRPReferencePointType = CHOICE(name='TRPReferencePointType', mode=MODE_TYPE)
    _TRPReferencePointType_tRPPositionRelativeGeodetic = SEQ(name='tRPPositionRelativeGeodetic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RelativeGeodeticLocation')))
    _TRPReferencePointType_tRPPositionRelativeCartesian = SEQ(name='tRPPositionRelativeCartesian', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RelativeCartesianLocation')))
    _TRPReferencePointType_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __TRPReferencePointType_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___TRPReferencePointType_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPReferencePointType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPReferencePointType_choice_extension_id._const_tab = ___TRPReferencePointType_choice_extension_id_tab
    __TRPReferencePointType_choice_extension_id._const_tab_at = None
    __TRPReferencePointType_choice_extension_id._const_tab_id = 'id'
    __TRPReferencePointType_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___TRPReferencePointType_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPReferencePointType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPReferencePointType_choice_extension_criticality._const_tab = ___TRPReferencePointType_choice_extension_criticality_tab
    __TRPReferencePointType_choice_extension_criticality._const_tab_at = ('..', 'id')
    __TRPReferencePointType_choice_extension_criticality._const_tab_id = 'criticality'
    __TRPReferencePointType_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___TRPReferencePointType_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___TRPReferencePointType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPReferencePointType_choice_extension_value._const_tab = ___TRPReferencePointType_choice_extension_value_tab
    __TRPReferencePointType_choice_extension_value._const_tab_at = ('..', 'id')
    __TRPReferencePointType_choice_extension_value._const_tab_id = 'Value'
    _TRPReferencePointType_choice_extension._cont = ASN1Dict([
        ('id', __TRPReferencePointType_choice_extension_id),
        ('criticality', __TRPReferencePointType_choice_extension_criticality),
        ('value', __TRPReferencePointType_choice_extension_value),
        ])
    _TRPReferencePointType_choice_extension._ext = None
    TRPReferencePointType._cont = ASN1Dict([
        ('tRPPositionRelativeGeodetic', _TRPReferencePointType_tRPPositionRelativeGeodetic),
        ('tRPPositionRelativeCartesian', _TRPReferencePointType_tRPPositionRelativeCartesian),
        ('choice-extension', _TRPReferencePointType_choice_extension),
        ])
    TRPReferencePointType._ext = None
    
    #-----< TRPReferencePointType-ExtIEs >-----#
    TRPReferencePointType_ExtIEs = CLASS(name='TRPReferencePointType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    TRPReferencePointType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRP-Rx-TEGInformation >-----#
    TRP_Rx_TEGInformation = SEQ(name='TRP-Rx-TEGInformation', mode=MODE_TYPE)
    _TRP_Rx_TEGInformation_tRP_Rx_TEGID = INT(name='tRP-Rx-TEGID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TRP_Rx_TEGInformation_tRP_Rx_TEGID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    _TRP_Rx_TEGInformation_tRP_Rx_TimingErrorMargin = ENUM(name='tRP-Rx-TimingErrorMargin', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TimingErrorMargin')))
    _TRP_Rx_TEGInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRP_Rx_TEGInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TRP_Rx_TEGInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TRP_Rx_TEGInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRP_Rx_TEGInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_Rx_TEGInformation_iE_Extensions__item__id._const_tab = ____TRP_Rx_TEGInformation_iE_Extensions__item__id_tab
    ___TRP_Rx_TEGInformation_iE_Extensions__item__id._const_tab_at = None
    ___TRP_Rx_TEGInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRP_Rx_TEGInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRP_Rx_TEGInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRP_Rx_TEGInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_Rx_TEGInformation_iE_Extensions__item__criticality._const_tab = ____TRP_Rx_TEGInformation_iE_Extensions__item__criticality_tab
    ___TRP_Rx_TEGInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRP_Rx_TEGInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRP_Rx_TEGInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRP_Rx_TEGInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRP_Rx_TEGInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_Rx_TEGInformation_iE_Extensions__item__extensionValue._const_tab = ____TRP_Rx_TEGInformation_iE_Extensions__item__extensionValue_tab
    ___TRP_Rx_TEGInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRP_Rx_TEGInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRP_Rx_TEGInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRP_Rx_TEGInformation_iE_Extensions__item__id),
        ('criticality', ___TRP_Rx_TEGInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___TRP_Rx_TEGInformation_iE_Extensions__item__extensionValue),
        ])
    __TRP_Rx_TEGInformation_iE_Extensions__item_._ext = None
    _TRP_Rx_TEGInformation_iE_Extensions._cont = __TRP_Rx_TEGInformation_iE_Extensions__item_
    _TRP_Rx_TEGInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRP_Rx_TEGInformation._cont = ASN1Dict([
        ('tRP-Rx-TEGID', _TRP_Rx_TEGInformation_tRP_Rx_TEGID),
        ('tRP-Rx-TimingErrorMargin', _TRP_Rx_TEGInformation_tRP_Rx_TimingErrorMargin),
        ('iE-Extensions', _TRP_Rx_TEGInformation_iE_Extensions),
        ])
    TRP_Rx_TEGInformation._ext = []
    
    #-----< TRP-Rx-TEGInformation-ExtIEs >-----#
    TRP_Rx_TEGInformation_ExtIEs = CLASS(name='TRP-Rx-TEGInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TRP_Rx_TEGInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRP-RxTx-TEGInformation >-----#
    TRP_RxTx_TEGInformation = SEQ(name='TRP-RxTx-TEGInformation', mode=MODE_TYPE)
    _TRP_RxTx_TEGInformation_tRP_RxTx_TEGID = INT(name='tRP-RxTx-TEGID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TRP_RxTx_TEGInformation_tRP_RxTx_TEGID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _TRP_RxTx_TEGInformation_tRP_RxTx_TimingErrorMargin = ENUM(name='tRP-RxTx-TimingErrorMargin', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RxTxTimingErrorMargin')))
    _TRP_RxTx_TEGInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRP_RxTx_TEGInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TRP_RxTx_TEGInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TRP_RxTx_TEGInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRP_RxTx_TEGInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_RxTx_TEGInformation_iE_Extensions__item__id._const_tab = ____TRP_RxTx_TEGInformation_iE_Extensions__item__id_tab
    ___TRP_RxTx_TEGInformation_iE_Extensions__item__id._const_tab_at = None
    ___TRP_RxTx_TEGInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRP_RxTx_TEGInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRP_RxTx_TEGInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRP_RxTx_TEGInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_RxTx_TEGInformation_iE_Extensions__item__criticality._const_tab = ____TRP_RxTx_TEGInformation_iE_Extensions__item__criticality_tab
    ___TRP_RxTx_TEGInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRP_RxTx_TEGInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRP_RxTx_TEGInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRP_RxTx_TEGInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRP_RxTx_TEGInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_RxTx_TEGInformation_iE_Extensions__item__extensionValue._const_tab = ____TRP_RxTx_TEGInformation_iE_Extensions__item__extensionValue_tab
    ___TRP_RxTx_TEGInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRP_RxTx_TEGInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRP_RxTx_TEGInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRP_RxTx_TEGInformation_iE_Extensions__item__id),
        ('criticality', ___TRP_RxTx_TEGInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___TRP_RxTx_TEGInformation_iE_Extensions__item__extensionValue),
        ])
    __TRP_RxTx_TEGInformation_iE_Extensions__item_._ext = None
    _TRP_RxTx_TEGInformation_iE_Extensions._cont = __TRP_RxTx_TEGInformation_iE_Extensions__item_
    _TRP_RxTx_TEGInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRP_RxTx_TEGInformation._cont = ASN1Dict([
        ('tRP-RxTx-TEGID', _TRP_RxTx_TEGInformation_tRP_RxTx_TEGID),
        ('tRP-RxTx-TimingErrorMargin', _TRP_RxTx_TEGInformation_tRP_RxTx_TimingErrorMargin),
        ('iE-Extensions', _TRP_RxTx_TEGInformation_iE_Extensions),
        ])
    TRP_RxTx_TEGInformation._ext = []
    
    #-----< TRP-RxTx-TEGInformation-ExtIEs >-----#
    TRP_RxTx_TEGInformation_ExtIEs = CLASS(name='TRP-RxTx-TEGInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TRP_RxTx_TEGInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRP-Tx-TEGInformation >-----#
    TRP_Tx_TEGInformation = SEQ(name='TRP-Tx-TEGInformation', mode=MODE_TYPE)
    _TRP_Tx_TEGInformation_tRP_Tx_TEGID = INT(name='tRP-Tx-TEGID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TRP_Tx_TEGInformation_tRP_Tx_TEGID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _TRP_Tx_TEGInformation_tRP_Tx_TimingErrorMargin = ENUM(name='tRP-Tx-TimingErrorMargin', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TimingErrorMargin')))
    _TRP_Tx_TEGInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRP_Tx_TEGInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TRP_Tx_TEGInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TRP_Tx_TEGInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRP_Tx_TEGInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_Tx_TEGInformation_iE_Extensions__item__id._const_tab = ____TRP_Tx_TEGInformation_iE_Extensions__item__id_tab
    ___TRP_Tx_TEGInformation_iE_Extensions__item__id._const_tab_at = None
    ___TRP_Tx_TEGInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRP_Tx_TEGInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRP_Tx_TEGInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRP_Tx_TEGInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_Tx_TEGInformation_iE_Extensions__item__criticality._const_tab = ____TRP_Tx_TEGInformation_iE_Extensions__item__criticality_tab
    ___TRP_Tx_TEGInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRP_Tx_TEGInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRP_Tx_TEGInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRP_Tx_TEGInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRP_Tx_TEGInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_Tx_TEGInformation_iE_Extensions__item__extensionValue._const_tab = ____TRP_Tx_TEGInformation_iE_Extensions__item__extensionValue_tab
    ___TRP_Tx_TEGInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRP_Tx_TEGInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRP_Tx_TEGInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRP_Tx_TEGInformation_iE_Extensions__item__id),
        ('criticality', ___TRP_Tx_TEGInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___TRP_Tx_TEGInformation_iE_Extensions__item__extensionValue),
        ])
    __TRP_Tx_TEGInformation_iE_Extensions__item_._ext = None
    _TRP_Tx_TEGInformation_iE_Extensions._cont = __TRP_Tx_TEGInformation_iE_Extensions__item_
    _TRP_Tx_TEGInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRP_Tx_TEGInformation._cont = ASN1Dict([
        ('tRP-Tx-TEGID', _TRP_Tx_TEGInformation_tRP_Tx_TEGID),
        ('tRP-Tx-TimingErrorMargin', _TRP_Tx_TEGInformation_tRP_Tx_TimingErrorMargin),
        ('iE-Extensions', _TRP_Tx_TEGInformation_iE_Extensions),
        ])
    TRP_Tx_TEGInformation._ext = []
    
    #-----< TRP-Tx-TEGInformation-ExtIEs >-----#
    TRP_Tx_TEGInformation_ExtIEs = CLASS(name='TRP-Tx-TEGInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TRP_Tx_TEGInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPTxTEGAssociation >-----#
    TRPTxTEGAssociation = SEQ_OF(name='TRPTxTEGAssociation', mode=MODE_TYPE)
    _TRPTxTEGAssociation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPTEG-Item')))
    TRPTxTEGAssociation._cont = _TRPTxTEGAssociation__item_
    TRPTxTEGAssociation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TRPTEG-Item >-----#
    TRPTEG_Item = SEQ(name='TRPTEG-Item', mode=MODE_TYPE)
    _TRPTEG_Item_tRP_Tx_TEGInformation = SEQ(name='tRP-Tx-TEGInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRP-Tx-TEGInformation')))
    _TRPTEG_Item_dl_PRSResourceSetID = INT(name='dl-PRSResourceSetID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-Set-ID')))
    _TRPTEG_Item_dl_PRSResourceID_List = SEQ_OF(name='dl-PRSResourceID-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TRPTEG_Item_dl_PRSResourceID_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DLPRSResourceID-Item')))
    _TRPTEG_Item_dl_PRSResourceID_List._cont = __TRPTEG_Item_dl_PRSResourceID_List__item_
    _TRPTEG_Item_dl_PRSResourceID_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _TRPTEG_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPTEG_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TRPTEG_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TRPTEG_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPTEG_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPTEG_Item_iE_Extensions__item__id._const_tab = ____TRPTEG_Item_iE_Extensions__item__id_tab
    ___TRPTEG_Item_iE_Extensions__item__id._const_tab_at = None
    ___TRPTEG_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRPTEG_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRPTEG_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPTEG_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPTEG_Item_iE_Extensions__item__criticality._const_tab = ____TRPTEG_Item_iE_Extensions__item__criticality_tab
    ___TRPTEG_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRPTEG_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRPTEG_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRPTEG_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TRPTEG_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPTEG_Item_iE_Extensions__item__extensionValue._const_tab = ____TRPTEG_Item_iE_Extensions__item__extensionValue_tab
    ___TRPTEG_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRPTEG_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRPTEG_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRPTEG_Item_iE_Extensions__item__id),
        ('criticality', ___TRPTEG_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TRPTEG_Item_iE_Extensions__item__extensionValue),
        ])
    __TRPTEG_Item_iE_Extensions__item_._ext = None
    _TRPTEG_Item_iE_Extensions._cont = __TRPTEG_Item_iE_Extensions__item_
    _TRPTEG_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPTEG_Item._cont = ASN1Dict([
        ('tRP-Tx-TEGInformation', _TRPTEG_Item_tRP_Tx_TEGInformation),
        ('dl-PRSResourceSetID', _TRPTEG_Item_dl_PRSResourceSetID),
        ('dl-PRSResourceID-List', _TRPTEG_Item_dl_PRSResourceID_List),
        ('iE-Extensions', _TRPTEG_Item_iE_Extensions),
        ])
    TRPTEG_Item._ext = []
    
    #-----< TRPTEGItem-ExtIEs >-----#
    TRPTEGItem_ExtIEs = CLASS(name='TRPTEGItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TRPTEGItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DLPRSResourceID-Item >-----#
    DLPRSResourceID_Item = SEQ(name='DLPRSResourceID-Item', mode=MODE_TYPE)
    _DLPRSResourceID_Item_dl_PRSResourceID = INT(name='dl-PRSResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PRS-Resource-ID')))
    _DLPRSResourceID_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DLPRSResourceID_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___DLPRSResourceID_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DLPRSResourceID_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLPRSResourceID_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceID_Item_iE_Extensions__item__id._const_tab = ____DLPRSResourceID_Item_iE_Extensions__item__id_tab
    ___DLPRSResourceID_Item_iE_Extensions__item__id._const_tab_at = None
    ___DLPRSResourceID_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DLPRSResourceID_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DLPRSResourceID_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLPRSResourceID_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceID_Item_iE_Extensions__item__criticality._const_tab = ____DLPRSResourceID_Item_iE_Extensions__item__criticality_tab
    ___DLPRSResourceID_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DLPRSResourceID_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DLPRSResourceID_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DLPRSResourceID_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____DLPRSResourceID_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceID_Item_iE_Extensions__item__extensionValue._const_tab = ____DLPRSResourceID_Item_iE_Extensions__item__extensionValue_tab
    ___DLPRSResourceID_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DLPRSResourceID_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DLPRSResourceID_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DLPRSResourceID_Item_iE_Extensions__item__id),
        ('criticality', ___DLPRSResourceID_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DLPRSResourceID_Item_iE_Extensions__item__extensionValue),
        ])
    __DLPRSResourceID_Item_iE_Extensions__item_._ext = None
    _DLPRSResourceID_Item_iE_Extensions._cont = __DLPRSResourceID_Item_iE_Extensions__item_
    _DLPRSResourceID_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DLPRSResourceID_Item._cont = ASN1Dict([
        ('dl-PRSResourceID', _DLPRSResourceID_Item_dl_PRSResourceID),
        ('iE-Extensions', _DLPRSResourceID_Item_iE_Extensions),
        ])
    DLPRSResourceID_Item._ext = []
    
    #-----< DLPRSResource-Item-ExtIEs >-----#
    DLPRSResource_Item_ExtIEs = CLASS(name='DLPRSResource-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    DLPRSResource_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TypeOfError >-----#
    TypeOfError = ENUM(name='TypeOfError', mode=MODE_TYPE)
    TypeOfError._cont = ASN1Dict([('not-understood', 0), ('missing', 1)])
    TypeOfError._ext = []
    
    #-----< Transport-Layer-Address-Info >-----#
    Transport_Layer_Address_Info = SEQ(name='Transport-Layer-Address-Info', mode=MODE_TYPE)
    _Transport_Layer_Address_Info_transport_UP_Layer_Address_Info_To_Add_List = SEQ_OF(name='transport-UP-Layer-Address-Info-To-Add-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Transport-UP-Layer-Address-Info-To-Add-List')), opt=True)
    _Transport_Layer_Address_Info_transport_UP_Layer_Address_Info_To_Remove_List = SEQ_OF(name='transport-UP-Layer-Address-Info-To-Remove-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Transport-UP-Layer-Address-Info-To-Remove-List')), opt=True)
    _Transport_Layer_Address_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Transport_Layer_Address_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___Transport_Layer_Address_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Transport_Layer_Address_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Transport_Layer_Address_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_Layer_Address_Info_iE_Extensions__item__id._const_tab = ____Transport_Layer_Address_Info_iE_Extensions__item__id_tab
    ___Transport_Layer_Address_Info_iE_Extensions__item__id._const_tab_at = None
    ___Transport_Layer_Address_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___Transport_Layer_Address_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Transport_Layer_Address_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Transport_Layer_Address_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_Layer_Address_Info_iE_Extensions__item__criticality._const_tab = ____Transport_Layer_Address_Info_iE_Extensions__item__criticality_tab
    ___Transport_Layer_Address_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Transport_Layer_Address_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Transport_Layer_Address_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Transport_Layer_Address_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____Transport_Layer_Address_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_Layer_Address_Info_iE_Extensions__item__extensionValue._const_tab = ____Transport_Layer_Address_Info_iE_Extensions__item__extensionValue_tab
    ___Transport_Layer_Address_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Transport_Layer_Address_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Transport_Layer_Address_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Transport_Layer_Address_Info_iE_Extensions__item__id),
        ('criticality', ___Transport_Layer_Address_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___Transport_Layer_Address_Info_iE_Extensions__item__extensionValue),
        ])
    __Transport_Layer_Address_Info_iE_Extensions__item_._ext = None
    _Transport_Layer_Address_Info_iE_Extensions._cont = __Transport_Layer_Address_Info_iE_Extensions__item_
    _Transport_Layer_Address_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Transport_Layer_Address_Info._cont = ASN1Dict([
        ('transport-UP-Layer-Address-Info-To-Add-List', _Transport_Layer_Address_Info_transport_UP_Layer_Address_Info_To_Add_List),
        ('transport-UP-Layer-Address-Info-To-Remove-List', _Transport_Layer_Address_Info_transport_UP_Layer_Address_Info_To_Remove_List),
        ('iE-Extensions', _Transport_Layer_Address_Info_iE_Extensions),
        ])
    Transport_Layer_Address_Info._ext = None
    
    #-----< Transport-Layer-Address-Info-ExtIEs >-----#
    Transport_Layer_Address_Info_ExtIEs = CLASS(name='Transport-Layer-Address-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    Transport_Layer_Address_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPType >-----#
    TRPType = ENUM(name='TRPType', mode=MODE_TYPE)
    TRPType._cont = ASN1Dict([('prsOnlyTP', 0), ('srsOnlyRP', 1), ('tp', 2), ('rp', 3), ('trp', 4)])
    TRPType._ext = []
    
    #-----< TSCAssistanceInformation >-----#
    TSCAssistanceInformation = SEQ(name='TSCAssistanceInformation', mode=MODE_TYPE)
    _TSCAssistanceInformation_periodicity = INT(name='periodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Periodicity')))
    _TSCAssistanceInformation_burstArrivalTime = OCT_STR(name='burstArrivalTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BurstArrivalTime')), opt=True)
    _TSCAssistanceInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TSCAssistanceInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TSCAssistanceInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TSCAssistanceInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____TSCAssistanceInformation_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SurvivalTime')))
    ____TSCAssistanceInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 540), ('criticality', 'ignore'), ('Extension', _____TSCAssistanceInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TSCAssistanceInformation_iE_Extensions__item__id._const_tab = ____TSCAssistanceInformation_iE_Extensions__item__id_tab
    ___TSCAssistanceInformation_iE_Extensions__item__id._const_tab_at = None
    ___TSCAssistanceInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TSCAssistanceInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TSCAssistanceInformation_iE_Extensions__item__criticality._const_tab = ____TSCAssistanceInformation_iE_Extensions__item__id_tab
    ___TSCAssistanceInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TSCAssistanceInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TSCAssistanceInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TSCAssistanceInformation_iE_Extensions__item__extensionValue._const_tab = ____TSCAssistanceInformation_iE_Extensions__item__id_tab
    ___TSCAssistanceInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TSCAssistanceInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TSCAssistanceInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TSCAssistanceInformation_iE_Extensions__item__id),
        ('criticality', ___TSCAssistanceInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___TSCAssistanceInformation_iE_Extensions__item__extensionValue),
        ])
    __TSCAssistanceInformation_iE_Extensions__item_._ext = None
    _TSCAssistanceInformation_iE_Extensions._cont = __TSCAssistanceInformation_iE_Extensions__item_
    _TSCAssistanceInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TSCAssistanceInformation._cont = ASN1Dict([
        ('periodicity', _TSCAssistanceInformation_periodicity),
        ('burstArrivalTime', _TSCAssistanceInformation_burstArrivalTime),
        ('iE-Extensions', _TSCAssistanceInformation_iE_Extensions),
        ])
    TSCAssistanceInformation._ext = []
    
    #-----< TSCAssistanceInformation-ExtIEs >-----#
    TSCAssistanceInformation_ExtIEs = CLASS(name='TSCAssistanceInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _TSCAssistanceInformation_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SurvivalTime')))
    TSCAssistanceInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 540), ('criticality', 'ignore'), ('Extension', _TSCAssistanceInformation_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TSCTrafficCharacteristics >-----#
    TSCTrafficCharacteristics = SEQ(name='TSCTrafficCharacteristics', mode=MODE_TYPE)
    _TSCTrafficCharacteristics_tSCAssistanceInformationDL = SEQ(name='tSCAssistanceInformationDL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TSCAssistanceInformation')), opt=True)
    _TSCTrafficCharacteristics_tSCAssistanceInformationUL = SEQ(name='tSCAssistanceInformationUL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TSCAssistanceInformation')), opt=True)
    _TSCTrafficCharacteristics_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TSCTrafficCharacteristics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TSCTrafficCharacteristics_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TSCTrafficCharacteristics_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TSCTrafficCharacteristics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TSCTrafficCharacteristics_iE_Extensions__item__id._const_tab = ____TSCTrafficCharacteristics_iE_Extensions__item__id_tab
    ___TSCTrafficCharacteristics_iE_Extensions__item__id._const_tab_at = None
    ___TSCTrafficCharacteristics_iE_Extensions__item__id._const_tab_id = 'id'
    ___TSCTrafficCharacteristics_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TSCTrafficCharacteristics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TSCTrafficCharacteristics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TSCTrafficCharacteristics_iE_Extensions__item__criticality._const_tab = ____TSCTrafficCharacteristics_iE_Extensions__item__criticality_tab
    ___TSCTrafficCharacteristics_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TSCTrafficCharacteristics_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TSCTrafficCharacteristics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____TSCTrafficCharacteristics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue._const_tab = ____TSCTrafficCharacteristics_iE_Extensions__item__extensionValue_tab
    ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TSCTrafficCharacteristics_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TSCTrafficCharacteristics_iE_Extensions__item__id),
        ('criticality', ___TSCTrafficCharacteristics_iE_Extensions__item__criticality),
        ('extensionValue', ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue),
        ])
    __TSCTrafficCharacteristics_iE_Extensions__item_._ext = None
    _TSCTrafficCharacteristics_iE_Extensions._cont = __TSCTrafficCharacteristics_iE_Extensions__item_
    _TSCTrafficCharacteristics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TSCTrafficCharacteristics._cont = ASN1Dict([
        ('tSCAssistanceInformationDL', _TSCTrafficCharacteristics_tSCAssistanceInformationDL),
        ('tSCAssistanceInformationUL', _TSCTrafficCharacteristics_tSCAssistanceInformationUL),
        ('iE-Extensions', _TSCTrafficCharacteristics_iE_Extensions),
        ])
    TSCTrafficCharacteristics._ext = []
    
    #-----< TSCTrafficCharacteristics-ExtIEs >-----#
    TSCTrafficCharacteristics_ExtIEs = CLASS(name='TSCTrafficCharacteristics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    TSCTrafficCharacteristics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRP-MeasurementUpdateList >-----#
    TRP_MeasurementUpdateList = SEQ_OF(name='TRP-MeasurementUpdateList', mode=MODE_TYPE)
    _TRP_MeasurementUpdateList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRP-MeasurementUpdateItem')))
    TRP_MeasurementUpdateList._cont = _TRP_MeasurementUpdateList__item_
    TRP_MeasurementUpdateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< TRP-MeasurementUpdateItem >-----#
    TRP_MeasurementUpdateItem = SEQ(name='TRP-MeasurementUpdateItem', mode=MODE_TYPE)
    _TRP_MeasurementUpdateItem_tRP_ID = INT(name='tRP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TRPID')))
    _TRP_MeasurementUpdateItem_aoA_window_information = SEQ(name='aoA-window-information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AoA-AssistanceInfo')), opt=True)
    _TRP_MeasurementUpdateItem_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRP_MeasurementUpdateItem_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___TRP_MeasurementUpdateItem_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TRP_MeasurementUpdateItem_iE_extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____TRP_MeasurementUpdateItem_iE_extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NumberOfTRPRxTEG')))
    _____TRP_MeasurementUpdateItem_iE_extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NumberOfTRPRxTxTEG')))
    ____TRP_MeasurementUpdateItem_iE_extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 564), ('criticality', 'ignore'), ('Extension', _____TRP_MeasurementUpdateItem_iE_extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 565), ('criticality', 'ignore'), ('Extension', _____TRP_MeasurementUpdateItem_iE_extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TRP_MeasurementUpdateItem_iE_extensions__item__id._const_tab = ____TRP_MeasurementUpdateItem_iE_extensions__item__id_tab
    ___TRP_MeasurementUpdateItem_iE_extensions__item__id._const_tab_at = None
    ___TRP_MeasurementUpdateItem_iE_extensions__item__id._const_tab_id = 'id'
    ___TRP_MeasurementUpdateItem_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TRP_MeasurementUpdateItem_iE_extensions__item__criticality._const_tab = ____TRP_MeasurementUpdateItem_iE_extensions__item__id_tab
    ___TRP_MeasurementUpdateItem_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRP_MeasurementUpdateItem_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___TRP_MeasurementUpdateItem_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TRP_MeasurementUpdateItem_iE_extensions__item__extensionValue._const_tab = ____TRP_MeasurementUpdateItem_iE_extensions__item__id_tab
    ___TRP_MeasurementUpdateItem_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRP_MeasurementUpdateItem_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRP_MeasurementUpdateItem_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___TRP_MeasurementUpdateItem_iE_extensions__item__id),
        ('criticality', ___TRP_MeasurementUpdateItem_iE_extensions__item__criticality),
        ('extensionValue', ___TRP_MeasurementUpdateItem_iE_extensions__item__extensionValue),
        ])
    __TRP_MeasurementUpdateItem_iE_extensions__item_._ext = None
    _TRP_MeasurementUpdateItem_iE_extensions._cont = __TRP_MeasurementUpdateItem_iE_extensions__item_
    _TRP_MeasurementUpdateItem_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRP_MeasurementUpdateItem._cont = ASN1Dict([
        ('tRP-ID', _TRP_MeasurementUpdateItem_tRP_ID),
        ('aoA-window-information', _TRP_MeasurementUpdateItem_aoA_window_information),
        ('iE-extensions', _TRP_MeasurementUpdateItem_iE_extensions),
        ])
    TRP_MeasurementUpdateItem._ext = []
    
    #-----< TRP-MeasurementUpdateItem-ExtIEs >-----#
    TRP_MeasurementUpdateItem_ExtIEs = CLASS(name='TRP-MeasurementUpdateItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _TRP_MeasurementUpdateItem_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NumberOfTRPRxTEG')))
    _TRP_MeasurementUpdateItem_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NumberOfTRPRxTxTEG')))
    TRP_MeasurementUpdateItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 564), ('criticality', 'ignore'), ('Extension', _TRP_MeasurementUpdateItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 565), ('criticality', 'ignore'), ('Extension', _TRP_MeasurementUpdateItem_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TwoPHRModeMCG >-----#
    TwoPHRModeMCG = ENUM(name='TwoPHRModeMCG', mode=MODE_TYPE)
    TwoPHRModeMCG._cont = ASN1Dict([('enabled', 0)])
    TwoPHRModeMCG._ext = []
    
    #-----< TwoPHRModeSCG >-----#
    TwoPHRModeSCG = ENUM(name='TwoPHRModeSCG', mode=MODE_TYPE)
    TwoPHRModeSCG._cont = ASN1Dict([('enabled', 0)])
    TwoPHRModeSCG._ext = []
    
    #-----< UAC-Assistance-Info >-----#
    UAC_Assistance_Info = SEQ(name='UAC-Assistance-Info', mode=MODE_TYPE)
    _UAC_Assistance_Info_uACPLMN_List = SEQ_OF(name='uACPLMN-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UACPLMN-List')))
    _UAC_Assistance_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UAC_Assistance_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UAC_Assistance_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UAC_Assistance_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UAC_Assistance_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UAC_Assistance_Info_iE_Extensions__item__id._const_tab = ____UAC_Assistance_Info_iE_Extensions__item__id_tab
    ___UAC_Assistance_Info_iE_Extensions__item__id._const_tab_at = None
    ___UAC_Assistance_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___UAC_Assistance_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UAC_Assistance_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UAC_Assistance_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UAC_Assistance_Info_iE_Extensions__item__criticality._const_tab = ____UAC_Assistance_Info_iE_Extensions__item__criticality_tab
    ___UAC_Assistance_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UAC_Assistance_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UAC_Assistance_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UAC_Assistance_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UAC_Assistance_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UAC_Assistance_Info_iE_Extensions__item__extensionValue._const_tab = ____UAC_Assistance_Info_iE_Extensions__item__extensionValue_tab
    ___UAC_Assistance_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UAC_Assistance_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UAC_Assistance_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UAC_Assistance_Info_iE_Extensions__item__id),
        ('criticality', ___UAC_Assistance_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___UAC_Assistance_Info_iE_Extensions__item__extensionValue),
        ])
    __UAC_Assistance_Info_iE_Extensions__item_._ext = None
    _UAC_Assistance_Info_iE_Extensions._cont = __UAC_Assistance_Info_iE_Extensions__item_
    _UAC_Assistance_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UAC_Assistance_Info._cont = ASN1Dict([
        ('uACPLMN-List', _UAC_Assistance_Info_uACPLMN_List),
        ('iE-Extensions', _UAC_Assistance_Info_iE_Extensions),
        ])
    UAC_Assistance_Info._ext = None
    
    #-----< UAC-Assistance-InfoExtIEs >-----#
    UAC_Assistance_InfoExtIEs = CLASS(name='UAC-Assistance-InfoExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UAC_Assistance_InfoExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UACPLMN-List >-----#
    UACPLMN_List = SEQ_OF(name='UACPLMN-List', mode=MODE_TYPE)
    _UACPLMN_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UACPLMN-Item')))
    UACPLMN_List._cont = _UACPLMN_List__item_
    UACPLMN_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< UACPLMN-Item >-----#
    UACPLMN_Item = SEQ(name='UACPLMN-Item', mode=MODE_TYPE)
    _UACPLMN_Item_pLMNIdentity = OCT_STR(name='pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _UACPLMN_Item_uACType_List = SEQ_OF(name='uACType-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UACType-List')))
    _UACPLMN_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UACPLMN_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UACPLMN_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UACPLMN_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____UACPLMN_Item_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NID')))
    ____UACPLMN_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 385), ('criticality', 'ignore'), ('Extension', _____UACPLMN_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UACPLMN_Item_iE_Extensions__item__id._const_tab = ____UACPLMN_Item_iE_Extensions__item__id_tab
    ___UACPLMN_Item_iE_Extensions__item__id._const_tab_at = None
    ___UACPLMN_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___UACPLMN_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UACPLMN_Item_iE_Extensions__item__criticality._const_tab = ____UACPLMN_Item_iE_Extensions__item__id_tab
    ___UACPLMN_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UACPLMN_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UACPLMN_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UACPLMN_Item_iE_Extensions__item__extensionValue._const_tab = ____UACPLMN_Item_iE_Extensions__item__id_tab
    ___UACPLMN_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UACPLMN_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UACPLMN_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UACPLMN_Item_iE_Extensions__item__id),
        ('criticality', ___UACPLMN_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___UACPLMN_Item_iE_Extensions__item__extensionValue),
        ])
    __UACPLMN_Item_iE_Extensions__item_._ext = None
    _UACPLMN_Item_iE_Extensions._cont = __UACPLMN_Item_iE_Extensions__item_
    _UACPLMN_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UACPLMN_Item._cont = ASN1Dict([
        ('pLMNIdentity', _UACPLMN_Item_pLMNIdentity),
        ('uACType-List', _UACPLMN_Item_uACType_List),
        ('iE-Extensions', _UACPLMN_Item_iE_Extensions),
        ])
    UACPLMN_Item._ext = None
    
    #-----< UACPLMN-Item-ExtIEs >-----#
    UACPLMN_Item_ExtIEs = CLASS(name='UACPLMN-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _UACPLMN_Item_ExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NID')))
    UACPLMN_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 385), ('criticality', 'ignore'), ('Extension', _UACPLMN_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UACType-List >-----#
    UACType_List = SEQ_OF(name='UACType-List', mode=MODE_TYPE)
    _UACType_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UACType-Item')))
    UACType_List._cont = _UACType_List__item_
    UACType_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< UACType-Item >-----#
    UACType_Item = SEQ(name='UACType-Item', mode=MODE_TYPE)
    _UACType_Item_uACReductionIndication = INT(name='uACReductionIndication', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UACReductionIndication')))
    _UACType_Item_uACCategoryType = CHOICE(name='uACCategoryType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UACCategoryType')))
    _UACType_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UACType_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UACType_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UACType_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UACType_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UACType_Item_iE_Extensions__item__id._const_tab = ____UACType_Item_iE_Extensions__item__id_tab
    ___UACType_Item_iE_Extensions__item__id._const_tab_at = None
    ___UACType_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___UACType_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UACType_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UACType_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UACType_Item_iE_Extensions__item__criticality._const_tab = ____UACType_Item_iE_Extensions__item__criticality_tab
    ___UACType_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UACType_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UACType_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UACType_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UACType_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UACType_Item_iE_Extensions__item__extensionValue._const_tab = ____UACType_Item_iE_Extensions__item__extensionValue_tab
    ___UACType_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UACType_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UACType_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UACType_Item_iE_Extensions__item__id),
        ('criticality', ___UACType_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___UACType_Item_iE_Extensions__item__extensionValue),
        ])
    __UACType_Item_iE_Extensions__item_._ext = None
    _UACType_Item_iE_Extensions._cont = __UACType_Item_iE_Extensions__item_
    _UACType_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UACType_Item._cont = ASN1Dict([
        ('uACReductionIndication', _UACType_Item_uACReductionIndication),
        ('uACCategoryType', _UACType_Item_uACCategoryType),
        ('iE-Extensions', _UACType_Item_iE_Extensions),
        ])
    UACType_Item._ext = None
    
    #-----< UACType-Item-ExtIEs >-----#
    UACType_Item_ExtIEs = CLASS(name='UACType-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UACType_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UACCategoryType >-----#
    UACCategoryType = CHOICE(name='UACCategoryType', mode=MODE_TYPE)
    _UACCategoryType_uACstandardized = ENUM(name='uACstandardized', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UACAction')))
    _UACCategoryType_uACOperatorDefined = SEQ(name='uACOperatorDefined', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UACOperatorDefined')))
    _UACCategoryType_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UACCategoryType_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___UACCategoryType_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UACCategoryType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UACCategoryType_choice_extension_id._const_tab = ___UACCategoryType_choice_extension_id_tab
    __UACCategoryType_choice_extension_id._const_tab_at = None
    __UACCategoryType_choice_extension_id._const_tab_id = 'id'
    __UACCategoryType_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___UACCategoryType_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UACCategoryType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UACCategoryType_choice_extension_criticality._const_tab = ___UACCategoryType_choice_extension_criticality_tab
    __UACCategoryType_choice_extension_criticality._const_tab_at = ('..', 'id')
    __UACCategoryType_choice_extension_criticality._const_tab_id = 'criticality'
    __UACCategoryType_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___UACCategoryType_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UACCategoryType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UACCategoryType_choice_extension_value._const_tab = ___UACCategoryType_choice_extension_value_tab
    __UACCategoryType_choice_extension_value._const_tab_at = ('..', 'id')
    __UACCategoryType_choice_extension_value._const_tab_id = 'Value'
    _UACCategoryType_choice_extension._cont = ASN1Dict([
        ('id', __UACCategoryType_choice_extension_id),
        ('criticality', __UACCategoryType_choice_extension_criticality),
        ('value', __UACCategoryType_choice_extension_value),
        ])
    _UACCategoryType_choice_extension._ext = None
    UACCategoryType._cont = ASN1Dict([
        ('uACstandardized', _UACCategoryType_uACstandardized),
        ('uACOperatorDefined', _UACCategoryType_uACOperatorDefined),
        ('choice-extension', _UACCategoryType_choice_extension),
        ])
    UACCategoryType._ext = None
    
    #-----< UACCategoryType-ExtIEs >-----#
    UACCategoryType_ExtIEs = CLASS(name='UACCategoryType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    UACCategoryType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UACOperatorDefined >-----#
    UACOperatorDefined = SEQ(name='UACOperatorDefined', mode=MODE_TYPE)
    _UACOperatorDefined_accessCategory = INT(name='accessCategory', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UACOperatorDefined_accessCategory._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=32, ub=63)], ev=[], er=[])
    _UACOperatorDefined_accessIdentity = BIT_STR(name='accessIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UACOperatorDefined_accessIdentity._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    _UACOperatorDefined_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UACOperatorDefined_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UACOperatorDefined_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UACOperatorDefined_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UACOperatorDefined_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UACOperatorDefined_iE_Extensions__item__id._const_tab = ____UACOperatorDefined_iE_Extensions__item__id_tab
    ___UACOperatorDefined_iE_Extensions__item__id._const_tab_at = None
    ___UACOperatorDefined_iE_Extensions__item__id._const_tab_id = 'id'
    ___UACOperatorDefined_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UACOperatorDefined_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UACOperatorDefined_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UACOperatorDefined_iE_Extensions__item__criticality._const_tab = ____UACOperatorDefined_iE_Extensions__item__criticality_tab
    ___UACOperatorDefined_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UACOperatorDefined_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UACOperatorDefined_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UACOperatorDefined_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UACOperatorDefined_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UACOperatorDefined_iE_Extensions__item__extensionValue._const_tab = ____UACOperatorDefined_iE_Extensions__item__extensionValue_tab
    ___UACOperatorDefined_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UACOperatorDefined_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UACOperatorDefined_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UACOperatorDefined_iE_Extensions__item__id),
        ('criticality', ___UACOperatorDefined_iE_Extensions__item__criticality),
        ('extensionValue', ___UACOperatorDefined_iE_Extensions__item__extensionValue),
        ])
    __UACOperatorDefined_iE_Extensions__item_._ext = None
    _UACOperatorDefined_iE_Extensions._cont = __UACOperatorDefined_iE_Extensions__item_
    _UACOperatorDefined_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UACOperatorDefined._cont = ASN1Dict([
        ('accessCategory', _UACOperatorDefined_accessCategory),
        ('accessIdentity', _UACOperatorDefined_accessIdentity),
        ('iE-Extensions', _UACOperatorDefined_iE_Extensions),
        ])
    UACOperatorDefined._ext = None
    
    #-----< UACOperatorDefined-ExtIEs >-----#
    UACOperatorDefined_ExtIEs = CLASS(name='UACOperatorDefined-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UACOperatorDefined_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UACAction >-----#
    UACAction = ENUM(name='UACAction', mode=MODE_TYPE)
    UACAction._cont = ASN1Dict([('reject-non-emergency-mo-dt', 0), ('reject-rrc-cr-signalling', 1), ('permit-emergency-sessions-and-mobile-terminated-services-only', 2), ('permit-high-priority-sessions-and-mobile-terminated-services-only', 3)])
    UACAction._ext = []
    
    #-----< UACReductionIndication >-----#
    UACReductionIndication = INT(name='UACReductionIndication', mode=MODE_TYPE)
    UACReductionIndication._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< UE-associatedLogicalF1-ConnectionItem >-----#
    UE_associatedLogicalF1_ConnectionItem = SEQ(name='UE-associatedLogicalF1-ConnectionItem', mode=MODE_TYPE)
    _UE_associatedLogicalF1_ConnectionItem_gNB_CU_UE_F1AP_ID = INT(name='gNB-CU-UE-F1AP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')), opt=True)
    _UE_associatedLogicalF1_ConnectionItem_gNB_DU_UE_F1AP_ID = INT(name='gNB-DU-UE-F1AP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')), opt=True)
    _UE_associatedLogicalF1_ConnectionItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__id._const_tab = ____UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__id_tab
    ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__id._const_tab_at = None
    ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__criticality._const_tab = ____UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__criticality_tab
    ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__extensionValue._const_tab = ____UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__extensionValue_tab
    ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__id),
        ('criticality', ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__extensionValue),
        ])
    __UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item_._ext = None
    _UE_associatedLogicalF1_ConnectionItem_iE_Extensions._cont = __UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item_
    _UE_associatedLogicalF1_ConnectionItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_associatedLogicalF1_ConnectionItem._cont = ASN1Dict([
        ('gNB-CU-UE-F1AP-ID', _UE_associatedLogicalF1_ConnectionItem_gNB_CU_UE_F1AP_ID),
        ('gNB-DU-UE-F1AP-ID', _UE_associatedLogicalF1_ConnectionItem_gNB_DU_UE_F1AP_ID),
        ('iE-Extensions', _UE_associatedLogicalF1_ConnectionItem_iE_Extensions),
        ])
    UE_associatedLogicalF1_ConnectionItem._ext = []
    
    #-----< UEAssistanceInformation >-----#
    UEAssistanceInformation = OCT_STR(name='UEAssistanceInformation', mode=MODE_TYPE)
    
    #-----< UEAssistanceInformationEUTRA >-----#
    UEAssistanceInformationEUTRA = OCT_STR(name='UEAssistanceInformationEUTRA', mode=MODE_TYPE)
    
    #-----< UE-associatedLogicalF1-ConnectionItemExtIEs >-----#
    UE_associatedLogicalF1_ConnectionItemExtIEs = CLASS(name='UE-associatedLogicalF1-ConnectionItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UE_associatedLogicalF1_ConnectionItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-CapabilityRAT-ContainerList >-----#
    UE_CapabilityRAT_ContainerList = OCT_STR(name='UE-CapabilityRAT-ContainerList', mode=MODE_TYPE)
    
    #-----< UEContextNotRetrievable >-----#
    UEContextNotRetrievable = ENUM(name='UEContextNotRetrievable', mode=MODE_TYPE)
    UEContextNotRetrievable._cont = ASN1Dict([('true', 0)])
    UEContextNotRetrievable._ext = []
    
    #-----< UEIdentityIndexValue >-----#
    UEIdentityIndexValue = CHOICE(name='UEIdentityIndexValue', mode=MODE_TYPE)
    _UEIdentityIndexValue_indexLength10 = BIT_STR(name='indexLength10', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UEIdentityIndexValue_indexLength10._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _UEIdentityIndexValue_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UEIdentityIndexValue_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___UEIdentityIndexValue_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UEIdentityIndexValue_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UEIdentityIndexValue_choice_extension_id._const_tab = ___UEIdentityIndexValue_choice_extension_id_tab
    __UEIdentityIndexValue_choice_extension_id._const_tab_at = None
    __UEIdentityIndexValue_choice_extension_id._const_tab_id = 'id'
    __UEIdentityIndexValue_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___UEIdentityIndexValue_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UEIdentityIndexValue_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UEIdentityIndexValue_choice_extension_criticality._const_tab = ___UEIdentityIndexValue_choice_extension_criticality_tab
    __UEIdentityIndexValue_choice_extension_criticality._const_tab_at = ('..', 'id')
    __UEIdentityIndexValue_choice_extension_criticality._const_tab_id = 'criticality'
    __UEIdentityIndexValue_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___UEIdentityIndexValue_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UEIdentityIndexValue_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UEIdentityIndexValue_choice_extension_value._const_tab = ___UEIdentityIndexValue_choice_extension_value_tab
    __UEIdentityIndexValue_choice_extension_value._const_tab_at = ('..', 'id')
    __UEIdentityIndexValue_choice_extension_value._const_tab_id = 'Value'
    _UEIdentityIndexValue_choice_extension._cont = ASN1Dict([
        ('id', __UEIdentityIndexValue_choice_extension_id),
        ('criticality', __UEIdentityIndexValue_choice_extension_criticality),
        ('value', __UEIdentityIndexValue_choice_extension_value),
        ])
    _UEIdentityIndexValue_choice_extension._ext = None
    UEIdentityIndexValue._cont = ASN1Dict([
        ('indexLength10', _UEIdentityIndexValue_indexLength10),
        ('choice-extension', _UEIdentityIndexValue_choice_extension),
        ])
    UEIdentityIndexValue._ext = None
    
    #-----< UEIdentityIndexValueChoice-ExtIEs >-----#
    UEIdentityIndexValueChoice_ExtIEs = CLASS(name='UEIdentityIndexValueChoice-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    UEIdentityIndexValueChoice_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEIdentity-List-For-Paging-Item >-----#
    UEIdentity_List_For_Paging_Item = SEQ(name='UEIdentity-List-For-Paging-Item', mode=MODE_TYPE)
    _UEIdentity_List_For_Paging_Item_uEIdentityIndexValue = CHOICE(name='uEIdentityIndexValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UEIdentityIndexValue')))
    _UEIdentity_List_For_Paging_Item_pagingDRX = ENUM(name='pagingDRX', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'PagingDRX')), opt=True)
    _UEIdentity_List_For_Paging_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEIdentity_List_For_Paging_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UEIdentity_List_For_Paging_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UEIdentity_List_For_Paging_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UEIdentity_List_For_Paging_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEIdentity_List_For_Paging_Item_iE_Extensions__item__id._const_tab = ____UEIdentity_List_For_Paging_Item_iE_Extensions__item__id_tab
    ___UEIdentity_List_For_Paging_Item_iE_Extensions__item__id._const_tab_at = None
    ___UEIdentity_List_For_Paging_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___UEIdentity_List_For_Paging_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UEIdentity_List_For_Paging_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UEIdentity_List_For_Paging_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEIdentity_List_For_Paging_Item_iE_Extensions__item__criticality._const_tab = ____UEIdentity_List_For_Paging_Item_iE_Extensions__item__criticality_tab
    ___UEIdentity_List_For_Paging_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UEIdentity_List_For_Paging_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UEIdentity_List_For_Paging_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UEIdentity_List_For_Paging_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UEIdentity_List_For_Paging_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEIdentity_List_For_Paging_Item_iE_Extensions__item__extensionValue._const_tab = ____UEIdentity_List_For_Paging_Item_iE_Extensions__item__extensionValue_tab
    ___UEIdentity_List_For_Paging_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UEIdentity_List_For_Paging_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UEIdentity_List_For_Paging_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UEIdentity_List_For_Paging_Item_iE_Extensions__item__id),
        ('criticality', ___UEIdentity_List_For_Paging_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___UEIdentity_List_For_Paging_Item_iE_Extensions__item__extensionValue),
        ])
    __UEIdentity_List_For_Paging_Item_iE_Extensions__item_._ext = None
    _UEIdentity_List_For_Paging_Item_iE_Extensions._cont = __UEIdentity_List_For_Paging_Item_iE_Extensions__item_
    _UEIdentity_List_For_Paging_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEIdentity_List_For_Paging_Item._cont = ASN1Dict([
        ('uEIdentityIndexValue', _UEIdentity_List_For_Paging_Item_uEIdentityIndexValue),
        ('pagingDRX', _UEIdentity_List_For_Paging_Item_pagingDRX),
        ('iE-Extensions', _UEIdentity_List_For_Paging_Item_iE_Extensions),
        ])
    UEIdentity_List_For_Paging_Item._ext = None
    
    #-----< UEIdentity-List-For-Paging-Item-ExtIEs >-----#
    UEIdentity_List_For_Paging_Item_ExtIEs = CLASS(name='UEIdentity-List-For-Paging-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UEIdentity_List_For_Paging_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-MulticastMRBs-ConfirmedToBeModified-Item >-----#
    UE_MulticastMRBs_ConfirmedToBeModified_Item = SEQ(name='UE-MulticastMRBs-ConfirmedToBeModified-Item', mode=MODE_TYPE)
    _UE_MulticastMRBs_ConfirmedToBeModified_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _UE_MulticastMRBs_ConfirmedToBeModified_Item_mrb_type_reconfiguration = ENUM(name='mrb-type-reconfiguration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MBSPTPRetransmissionTunnelRequired')), opt=True)
    _UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__id._const_tab = ____UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__id_tab
    ___UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__id._const_tab_at = None
    ___UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__criticality._const_tab = ____UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__criticality_tab
    ___UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab = ____UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__extensionValue_tab
    ___UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__id),
        ('criticality', ___UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__extensionValue),
        ])
    __UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item_._ext = None
    _UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions._cont = __UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item_
    _UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_MulticastMRBs_ConfirmedToBeModified_Item._cont = ASN1Dict([
        ('mRB-ID', _UE_MulticastMRBs_ConfirmedToBeModified_Item_mRB_ID),
        ('mrb-type-reconfiguration', _UE_MulticastMRBs_ConfirmedToBeModified_Item_mrb_type_reconfiguration),
        ('iE-Extensions', _UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions),
        ])
    UE_MulticastMRBs_ConfirmedToBeModified_Item._ext = None
    
    #-----< UE-MulticastMRBs-ConfirmedToBeModified-Item-ExtIEs >-----#
    UE_MulticastMRBs_ConfirmedToBeModified_Item_ExtIEs = CLASS(name='UE-MulticastMRBs-ConfirmedToBeModified-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UE_MulticastMRBs_ConfirmedToBeModified_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-MulticastMRBs-RequiredToBeModified-Item >-----#
    UE_MulticastMRBs_RequiredToBeModified_Item = SEQ(name='UE-MulticastMRBs-RequiredToBeModified-Item', mode=MODE_TYPE)
    _UE_MulticastMRBs_RequiredToBeModified_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _UE_MulticastMRBs_RequiredToBeModified_Item_mrb_type_reconfiguration = ENUM(name='mrb-type-reconfiguration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UE_MulticastMRBs_RequiredToBeModified_Item_mrb_type_reconfiguration._cont = ASN1Dict([('true', 0)])
    _UE_MulticastMRBs_RequiredToBeModified_Item_mrb_type_reconfiguration._ext = []
    _UE_MulticastMRBs_RequiredToBeModified_Item_mrb_reconfigured_RLCtype = ENUM(name='mrb-reconfigured-RLCtype', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UE_MulticastMRBs_RequiredToBeModified_Item_mrb_reconfigured_RLCtype._cont = ASN1Dict([('rlc-um-ptp', 0), ('rlc-am-ptp', 1), ('rlc-um-dl-ptm', 2), ('two-rlc-um-dl-ptp-and-dl-ptm', 3), ('three-rlc-um-dl-ptp-ul-ptp-dl-ptm', 4), ('two-rlc-am-ptp-um-dl-ptm', 5)])
    _UE_MulticastMRBs_RequiredToBeModified_Item_mrb_reconfigured_RLCtype._ext = []
    _UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastF1UContextReferenceCU')))
    ____UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 681), ('criticality', 'reject'), ('Extension', _____UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__id._const_tab = ____UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__id_tab
    ___UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__id._const_tab_at = None
    ___UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__criticality._const_tab = ____UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__id_tab
    ___UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__extensionValue._const_tab = ____UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__id_tab
    ___UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__id),
        ('criticality', ___UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__extensionValue),
        ])
    __UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item_._ext = None
    _UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions._cont = __UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item_
    _UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_MulticastMRBs_RequiredToBeModified_Item._cont = ASN1Dict([
        ('mRB-ID', _UE_MulticastMRBs_RequiredToBeModified_Item_mRB_ID),
        ('mrb-type-reconfiguration', _UE_MulticastMRBs_RequiredToBeModified_Item_mrb_type_reconfiguration),
        ('mrb-reconfigured-RLCtype', _UE_MulticastMRBs_RequiredToBeModified_Item_mrb_reconfigured_RLCtype),
        ('iE-Extensions', _UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions),
        ])
    UE_MulticastMRBs_RequiredToBeModified_Item._ext = None
    
    #-----< UE-MulticastMRBs-RequiredToBeModified-Item-ExtIEs >-----#
    UE_MulticastMRBs_RequiredToBeModified_Item_ExtIEs = CLASS(name='UE-MulticastMRBs-RequiredToBeModified-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _UE_MulticastMRBs_RequiredToBeModified_Item_ExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastF1UContextReferenceCU')))
    UE_MulticastMRBs_RequiredToBeModified_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 681), ('criticality', 'reject'), ('Extension', _UE_MulticastMRBs_RequiredToBeModified_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UE-MulticastMRBs-RequiredToBeReleased-Item >-----#
    UE_MulticastMRBs_RequiredToBeReleased_Item = SEQ(name='UE-MulticastMRBs-RequiredToBeReleased-Item', mode=MODE_TYPE)
    _UE_MulticastMRBs_RequiredToBeReleased_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__id._const_tab = ____UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__id_tab
    ___UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__id._const_tab_at = None
    ___UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__criticality._const_tab = ____UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__criticality_tab
    ___UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab = ____UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__extensionValue_tab
    ___UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__id),
        ('criticality', ___UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__extensionValue),
        ])
    __UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item_._ext = None
    _UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions._cont = __UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item_
    _UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_MulticastMRBs_RequiredToBeReleased_Item._cont = ASN1Dict([
        ('mRB-ID', _UE_MulticastMRBs_RequiredToBeReleased_Item_mRB_ID),
        ('iE-Extensions', _UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions),
        ])
    UE_MulticastMRBs_RequiredToBeReleased_Item._ext = None
    
    #-----< UE-MulticastMRBs-RequiredToBeReleased-Item-ExtIEs >-----#
    UE_MulticastMRBs_RequiredToBeReleased_Item_ExtIEs = CLASS(name='UE-MulticastMRBs-RequiredToBeReleased-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UE_MulticastMRBs_RequiredToBeReleased_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-MulticastMRBs-Setup-Item >-----#
    UE_MulticastMRBs_Setup_Item = SEQ(name='UE-MulticastMRBs-Setup-Item', mode=MODE_TYPE)
    _UE_MulticastMRBs_Setup_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _UE_MulticastMRBs_Setup_Item_multicastF1UContextReferenceCU = OCT_STR(name='multicastF1UContextReferenceCU', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MulticastF1UContextReferenceCU')), opt=True)
    _UE_MulticastMRBs_Setup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_MulticastMRBs_Setup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UE_MulticastMRBs_Setup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_MulticastMRBs_Setup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UE_MulticastMRBs_Setup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_MulticastMRBs_Setup_Item_iE_Extensions__item__id._const_tab = ____UE_MulticastMRBs_Setup_Item_iE_Extensions__item__id_tab
    ___UE_MulticastMRBs_Setup_Item_iE_Extensions__item__id._const_tab_at = None
    ___UE_MulticastMRBs_Setup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_MulticastMRBs_Setup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UE_MulticastMRBs_Setup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UE_MulticastMRBs_Setup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_MulticastMRBs_Setup_Item_iE_Extensions__item__criticality._const_tab = ____UE_MulticastMRBs_Setup_Item_iE_Extensions__item__criticality_tab
    ___UE_MulticastMRBs_Setup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_MulticastMRBs_Setup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_MulticastMRBs_Setup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UE_MulticastMRBs_Setup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UE_MulticastMRBs_Setup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_MulticastMRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab = ____UE_MulticastMRBs_Setup_Item_iE_Extensions__item__extensionValue_tab
    ___UE_MulticastMRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_MulticastMRBs_Setup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_MulticastMRBs_Setup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_MulticastMRBs_Setup_Item_iE_Extensions__item__id),
        ('criticality', ___UE_MulticastMRBs_Setup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_MulticastMRBs_Setup_Item_iE_Extensions__item__extensionValue),
        ])
    __UE_MulticastMRBs_Setup_Item_iE_Extensions__item_._ext = None
    _UE_MulticastMRBs_Setup_Item_iE_Extensions._cont = __UE_MulticastMRBs_Setup_Item_iE_Extensions__item_
    _UE_MulticastMRBs_Setup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_MulticastMRBs_Setup_Item._cont = ASN1Dict([
        ('mRB-ID', _UE_MulticastMRBs_Setup_Item_mRB_ID),
        ('multicastF1UContextReferenceCU', _UE_MulticastMRBs_Setup_Item_multicastF1UContextReferenceCU),
        ('iE-Extensions', _UE_MulticastMRBs_Setup_Item_iE_Extensions),
        ])
    UE_MulticastMRBs_Setup_Item._ext = None
    
    #-----< UE-MulticastMRBs-Setup-Item-ExtIEs >-----#
    UE_MulticastMRBs_Setup_Item_ExtIEs = CLASS(name='UE-MulticastMRBs-Setup-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UE_MulticastMRBs_Setup_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-MulticastMRBs-ToBeReleased-Item >-----#
    UE_MulticastMRBs_ToBeReleased_Item = SEQ(name='UE-MulticastMRBs-ToBeReleased-Item', mode=MODE_TYPE)
    _UE_MulticastMRBs_ToBeReleased_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab = ____UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__id_tab
    ___UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab_at = None
    ___UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab = ____UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab
    ___UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab = ____UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab
    ___UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__id),
        ('criticality', ___UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue),
        ])
    __UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item_._ext = None
    _UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions._cont = __UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item_
    _UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_MulticastMRBs_ToBeReleased_Item._cont = ASN1Dict([
        ('mRB-ID', _UE_MulticastMRBs_ToBeReleased_Item_mRB_ID),
        ('iE-Extensions', _UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions),
        ])
    UE_MulticastMRBs_ToBeReleased_Item._ext = None
    
    #-----< UE-MulticastMRBs-ToBeReleased-Item-ExtIEs >-----#
    UE_MulticastMRBs_ToBeReleased_Item_ExtIEs = CLASS(name='UE-MulticastMRBs-ToBeReleased-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UE_MulticastMRBs_ToBeReleased_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-MulticastMRBs-ToBeSetup-Item >-----#
    UE_MulticastMRBs_ToBeSetup_Item = SEQ(name='UE-MulticastMRBs-ToBeSetup-Item', mode=MODE_TYPE)
    _UE_MulticastMRBs_ToBeSetup_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _UE_MulticastMRBs_ToBeSetup_Item_mbsPTPRetransmissionTunnelRequired = ENUM(name='mbsPTPRetransmissionTunnelRequired', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MBSPTPRetransmissionTunnelRequired')), opt=True)
    _UE_MulticastMRBs_ToBeSetup_Item_mbsPTPForwardingRequiredInformation = CHOICE(name='mbsPTPForwardingRequiredInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ProgressInformation')), opt=True)
    _UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    ____UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 671), ('criticality', 'ignore'), ('Extension', _____UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab = ____UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__id),
        ('criticality', ___UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item_._ext = None
    _UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions._cont = __UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item_
    _UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_MulticastMRBs_ToBeSetup_Item._cont = ASN1Dict([
        ('mRB-ID', _UE_MulticastMRBs_ToBeSetup_Item_mRB_ID),
        ('mbsPTPRetransmissionTunnelRequired', _UE_MulticastMRBs_ToBeSetup_Item_mbsPTPRetransmissionTunnelRequired),
        ('mbsPTPForwardingRequiredInformation', _UE_MulticastMRBs_ToBeSetup_Item_mbsPTPForwardingRequiredInformation),
        ('iE-Extensions', _UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions),
        ])
    UE_MulticastMRBs_ToBeSetup_Item._ext = None
    
    #-----< UE-MulticastMRBs-ToBeSetup-Item-ExtIEs >-----#
    UE_MulticastMRBs_ToBeSetup_Item_ExtIEs = CLASS(name='UE-MulticastMRBs-ToBeSetup-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _UE_MulticastMRBs_ToBeSetup_Item_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    UE_MulticastMRBs_ToBeSetup_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 671), ('criticality', 'ignore'), ('Extension', _UE_MulticastMRBs_ToBeSetup_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UE-MulticastMRBs-ToBeSetup-atModify-Item >-----#
    UE_MulticastMRBs_ToBeSetup_atModify_Item = SEQ(name='UE-MulticastMRBs-ToBeSetup-atModify-Item', mode=MODE_TYPE)
    _UE_MulticastMRBs_ToBeSetup_atModify_Item_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ID')))
    _UE_MulticastMRBs_ToBeSetup_atModify_Item_mbsPTPRetransmissionTunnelRequired = ENUM(name='mbsPTPRetransmissionTunnelRequired', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MBSPTPRetransmissionTunnelRequired')), opt=True)
    _UE_MulticastMRBs_ToBeSetup_atModify_Item_mbsPTPForwardingRequiredInformation = CHOICE(name='mbsPTPForwardingRequiredInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'MRB-ProgressInformation')), opt=True)
    _UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__id._const_tab = ____UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__id_tab
    ___UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__id._const_tab_at = None
    ___UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__criticality._const_tab = ____UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__criticality_tab
    ___UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__extensionValue._const_tab = ____UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__extensionValue_tab
    ___UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__id),
        ('criticality', ___UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__extensionValue),
        ])
    __UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item_._ext = None
    _UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions._cont = __UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item_
    _UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_MulticastMRBs_ToBeSetup_atModify_Item._cont = ASN1Dict([
        ('mRB-ID', _UE_MulticastMRBs_ToBeSetup_atModify_Item_mRB_ID),
        ('mbsPTPRetransmissionTunnelRequired', _UE_MulticastMRBs_ToBeSetup_atModify_Item_mbsPTPRetransmissionTunnelRequired),
        ('mbsPTPForwardingRequiredInformation', _UE_MulticastMRBs_ToBeSetup_atModify_Item_mbsPTPForwardingRequiredInformation),
        ('iE-Extensions', _UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions),
        ])
    UE_MulticastMRBs_ToBeSetup_atModify_Item._ext = None
    
    #-----< UE-MulticastMRBs-ToBeSetup-atModify-Item-ExtIEs >-----#
    UE_MulticastMRBs_ToBeSetup_atModify_Item_ExtIEs = CLASS(name='UE-MulticastMRBs-ToBeSetup-atModify-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UE_MulticastMRBs_ToBeSetup_atModify_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEPagingCapability >-----#
    UEPagingCapability = SEQ(name='UEPagingCapability', mode=MODE_TYPE)
    _UEPagingCapability_iNACTIVEStatePODetermination = ENUM(name='iNACTIVEStatePODetermination', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UEPagingCapability_iNACTIVEStatePODetermination._cont = ASN1Dict([('supported', 0)])
    _UEPagingCapability_iNACTIVEStatePODetermination._ext = []
    _UEPagingCapability_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEPagingCapability_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UEPagingCapability_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UEPagingCapability_iE_Extension__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____UEPagingCapability_iE_Extension__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RedCapIndication')))
    ____UEPagingCapability_iE_Extension__item__id_tab._val = ASN1Set(rv=[dict([('id', 673), ('criticality', 'ignore'), ('Extension', _____UEPagingCapability_iE_Extension__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEPagingCapability_iE_Extension__item__id._const_tab = ____UEPagingCapability_iE_Extension__item__id_tab
    ___UEPagingCapability_iE_Extension__item__id._const_tab_at = None
    ___UEPagingCapability_iE_Extension__item__id._const_tab_id = 'id'
    ___UEPagingCapability_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UEPagingCapability_iE_Extension__item__criticality._const_tab = ____UEPagingCapability_iE_Extension__item__id_tab
    ___UEPagingCapability_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___UEPagingCapability_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___UEPagingCapability_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UEPagingCapability_iE_Extension__item__extensionValue._const_tab = ____UEPagingCapability_iE_Extension__item__id_tab
    ___UEPagingCapability_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___UEPagingCapability_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __UEPagingCapability_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___UEPagingCapability_iE_Extension__item__id),
        ('criticality', ___UEPagingCapability_iE_Extension__item__criticality),
        ('extensionValue', ___UEPagingCapability_iE_Extension__item__extensionValue),
        ])
    __UEPagingCapability_iE_Extension__item_._ext = None
    _UEPagingCapability_iE_Extension._cont = __UEPagingCapability_iE_Extension__item_
    _UEPagingCapability_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEPagingCapability._cont = ASN1Dict([
        ('iNACTIVEStatePODetermination', _UEPagingCapability_iNACTIVEStatePODetermination),
        ('iE-Extension', _UEPagingCapability_iE_Extension),
        ])
    UEPagingCapability._ext = []
    
    #-----< UEPagingCapability-ExtIEs >-----#
    UEPagingCapability_ExtIEs = CLASS(name='UEPagingCapability-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _UEPagingCapability_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RedCapIndication')))
    UEPagingCapability_ExtIEs._val = ASN1Set(rv=[dict([('id', 673), ('criticality', 'ignore'), ('Extension', _UEPagingCapability_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEReportingInformation >-----#
    UEReportingInformation = SEQ(name='UEReportingInformation', mode=MODE_TYPE)
    _UEReportingInformation_reportingAmount = ENUM(name='reportingAmount', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UEReportingInformation_reportingAmount._cont = ASN1Dict([('ma0', 0), ('ma1', 1), ('ma2', 2), ('ma4', 3), ('ma8', 4), ('ma16', 5), ('ma32', 6), ('ma64', 7)])
    _UEReportingInformation_reportingAmount._ext = None
    _UEReportingInformation_reportingInterval = ENUM(name='reportingInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UEReportingInformation_reportingInterval._cont = ASN1Dict([('none', 0), ('one', 1), ('two', 2), ('four', 3), ('eight', 4), ('ten', 5), ('sixteen', 6), ('twenty', 7), ('thirty-two', 8), ('sixty-four', 9)])
    _UEReportingInformation_reportingInterval._ext = []
    _UEReportingInformation_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEReportingInformation_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UEReportingInformation_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UEReportingInformation_iE_extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UEReportingInformation_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEReportingInformation_iE_extensions__item__id._const_tab = ____UEReportingInformation_iE_extensions__item__id_tab
    ___UEReportingInformation_iE_extensions__item__id._const_tab_at = None
    ___UEReportingInformation_iE_extensions__item__id._const_tab_id = 'id'
    ___UEReportingInformation_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UEReportingInformation_iE_extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UEReportingInformation_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEReportingInformation_iE_extensions__item__criticality._const_tab = ____UEReportingInformation_iE_extensions__item__criticality_tab
    ___UEReportingInformation_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UEReportingInformation_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___UEReportingInformation_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UEReportingInformation_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UEReportingInformation_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEReportingInformation_iE_extensions__item__extensionValue._const_tab = ____UEReportingInformation_iE_extensions__item__extensionValue_tab
    ___UEReportingInformation_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UEReportingInformation_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __UEReportingInformation_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___UEReportingInformation_iE_extensions__item__id),
        ('criticality', ___UEReportingInformation_iE_extensions__item__criticality),
        ('extensionValue', ___UEReportingInformation_iE_extensions__item__extensionValue),
        ])
    __UEReportingInformation_iE_extensions__item_._ext = None
    _UEReportingInformation_iE_extensions._cont = __UEReportingInformation_iE_extensions__item_
    _UEReportingInformation_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEReportingInformation._cont = ASN1Dict([
        ('reportingAmount', _UEReportingInformation_reportingAmount),
        ('reportingInterval', _UEReportingInformation_reportingInterval),
        ('iE-extensions', _UEReportingInformation_iE_extensions),
        ])
    UEReportingInformation._ext = []
    
    #-----< UEReportingInformation-ExtIEs >-----#
    UEReportingInformation_ExtIEs = CLASS(name='UEReportingInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UEReportingInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UlTxDirectCurrentMoreCarrierInformation >-----#
    UlTxDirectCurrentMoreCarrierInformation = OCT_STR(name='UlTxDirectCurrentMoreCarrierInformation', mode=MODE_TYPE)
    
    #-----< UL-AoA >-----#
    UL_AoA = SEQ(name='UL-AoA', mode=MODE_TYPE)
    _UL_AoA_azimuthAoA = INT(name='azimuthAoA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UL_AoA_azimuthAoA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    _UL_AoA_zenithAoA = INT(name='zenithAoA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UL_AoA_zenithAoA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1799)], ev=None, er=[])
    _UL_AoA_lCS_to_GCS_Translation = SEQ(name='lCS-to-GCS-Translation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LCS-to-GCS-Translation')), opt=True)
    _UL_AoA_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_AoA_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UL_AoA_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_AoA_iE_extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_AoA_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_AoA_iE_extensions__item__id._const_tab = ____UL_AoA_iE_extensions__item__id_tab
    ___UL_AoA_iE_extensions__item__id._const_tab_at = None
    ___UL_AoA_iE_extensions__item__id._const_tab_id = 'id'
    ___UL_AoA_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_AoA_iE_extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_AoA_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_AoA_iE_extensions__item__criticality._const_tab = ____UL_AoA_iE_extensions__item__criticality_tab
    ___UL_AoA_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_AoA_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_AoA_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_AoA_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_AoA_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_AoA_iE_extensions__item__extensionValue._const_tab = ____UL_AoA_iE_extensions__item__extensionValue_tab
    ___UL_AoA_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_AoA_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_AoA_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___UL_AoA_iE_extensions__item__id),
        ('criticality', ___UL_AoA_iE_extensions__item__criticality),
        ('extensionValue', ___UL_AoA_iE_extensions__item__extensionValue),
        ])
    __UL_AoA_iE_extensions__item_._ext = None
    _UL_AoA_iE_extensions._cont = __UL_AoA_iE_extensions__item_
    _UL_AoA_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_AoA._cont = ASN1Dict([
        ('azimuthAoA', _UL_AoA_azimuthAoA),
        ('zenithAoA', _UL_AoA_zenithAoA),
        ('lCS-to-GCS-Translation', _UL_AoA_lCS_to_GCS_Translation),
        ('iE-extensions', _UL_AoA_iE_extensions),
        ])
    UL_AoA._ext = []
    
    #-----< UL-AoA-ExtIEs >-----#
    UL_AoA_ExtIEs = CLASS(name='UL-AoA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UL_AoA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-BH-Non-UP-Traffic-Mapping >-----#
    UL_BH_Non_UP_Traffic_Mapping = SEQ(name='UL-BH-Non-UP-Traffic-Mapping', mode=MODE_TYPE)
    _UL_BH_Non_UP_Traffic_Mapping_uL_BH_Non_UP_Traffic_Mapping_List = SEQ_OF(name='uL-BH-Non-UP-Traffic-Mapping-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UL-BH-Non-UP-Traffic-Mapping-List')))
    _UL_BH_Non_UP_Traffic_Mapping_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__id._const_tab = ____UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__id_tab
    ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__id._const_tab_at = None
    ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__criticality._const_tab = ____UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__criticality_tab
    ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__extensionValue._const_tab = ____UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__extensionValue_tab
    ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__id),
        ('criticality', ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__extensionValue),
        ])
    __UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item_._ext = None
    _UL_BH_Non_UP_Traffic_Mapping_iE_Extensions._cont = __UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item_
    _UL_BH_Non_UP_Traffic_Mapping_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_BH_Non_UP_Traffic_Mapping._cont = ASN1Dict([
        ('uL-BH-Non-UP-Traffic-Mapping-List', _UL_BH_Non_UP_Traffic_Mapping_uL_BH_Non_UP_Traffic_Mapping_List),
        ('iE-Extensions', _UL_BH_Non_UP_Traffic_Mapping_iE_Extensions),
        ])
    UL_BH_Non_UP_Traffic_Mapping._ext = None
    
    #-----< UL-BH-Non-UP-Traffic-Mapping-ExtIEs >-----#
    UL_BH_Non_UP_Traffic_Mapping_ExtIEs = CLASS(name='UL-BH-Non-UP-Traffic-Mapping-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UL_BH_Non_UP_Traffic_Mapping_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-BH-Non-UP-Traffic-Mapping-List >-----#
    UL_BH_Non_UP_Traffic_Mapping_List = SEQ_OF(name='UL-BH-Non-UP-Traffic-Mapping-List', mode=MODE_TYPE)
    _UL_BH_Non_UP_Traffic_Mapping_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-BH-Non-UP-Traffic-Mapping-Item')))
    UL_BH_Non_UP_Traffic_Mapping_List._cont = _UL_BH_Non_UP_Traffic_Mapping_List__item_
    UL_BH_Non_UP_Traffic_Mapping_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< UL-BH-Non-UP-Traffic-Mapping-Item >-----#
    UL_BH_Non_UP_Traffic_Mapping_Item = SEQ(name='UL-BH-Non-UP-Traffic-Mapping-Item', mode=MODE_TYPE)
    _UL_BH_Non_UP_Traffic_Mapping_Item_nonUPTrafficType = ENUM(name='nonUPTrafficType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'NonUPTrafficType')))
    _UL_BH_Non_UP_Traffic_Mapping_Item_bHInfo = SEQ(name='bHInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHInfo')))
    _UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__id._const_tab = ____UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__id_tab
    ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__id._const_tab_at = None
    ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__criticality._const_tab = ____UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__criticality_tab
    ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__extensionValue._const_tab = ____UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__extensionValue_tab
    ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__id),
        ('criticality', ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__extensionValue),
        ])
    __UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item_._ext = None
    _UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions._cont = __UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item_
    _UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_BH_Non_UP_Traffic_Mapping_Item._cont = ASN1Dict([
        ('nonUPTrafficType', _UL_BH_Non_UP_Traffic_Mapping_Item_nonUPTrafficType),
        ('bHInfo', _UL_BH_Non_UP_Traffic_Mapping_Item_bHInfo),
        ('iE-Extensions', _UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions),
        ])
    UL_BH_Non_UP_Traffic_Mapping_Item._ext = None
    
    #-----< UL-BH-Non-UP-Traffic-Mapping-ItemExtIEs >-----#
    UL_BH_Non_UP_Traffic_Mapping_ItemExtIEs = CLASS(name='UL-BH-Non-UP-Traffic-Mapping-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UL_BH_Non_UP_Traffic_Mapping_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ULConfiguration >-----#
    ULConfiguration = SEQ(name='ULConfiguration', mode=MODE_TYPE)
    _ULConfiguration_uLUEConfiguration = ENUM(name='uLUEConfiguration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'ULUEConfiguration')))
    _ULConfiguration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ULConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ULConfiguration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ULConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ULConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ULConfiguration_iE_Extensions__item__id._const_tab = ____ULConfiguration_iE_Extensions__item__id_tab
    ___ULConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___ULConfiguration_iE_Extensions__item__id._const_tab_id = 'id'
    ___ULConfiguration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ULConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ULConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ULConfiguration_iE_Extensions__item__criticality._const_tab = ____ULConfiguration_iE_Extensions__item__criticality_tab
    ___ULConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ULConfiguration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ULConfiguration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ULConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ULConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ULConfiguration_iE_Extensions__item__extensionValue._const_tab = ____ULConfiguration_iE_Extensions__item__extensionValue_tab
    ___ULConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ULConfiguration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ULConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ULConfiguration_iE_Extensions__item__id),
        ('criticality', ___ULConfiguration_iE_Extensions__item__criticality),
        ('extensionValue', ___ULConfiguration_iE_Extensions__item__extensionValue),
        ])
    __ULConfiguration_iE_Extensions__item_._ext = None
    _ULConfiguration_iE_Extensions._cont = __ULConfiguration_iE_Extensions__item_
    _ULConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ULConfiguration._cont = ASN1Dict([
        ('uLUEConfiguration', _ULConfiguration_uLUEConfiguration),
        ('iE-Extensions', _ULConfiguration_iE_Extensions),
        ])
    ULConfiguration._ext = []
    
    #-----< ULConfigurationExtIEs >-----#
    ULConfigurationExtIEs = CLASS(name='ULConfigurationExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ULConfigurationExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-GapFR2-Config >-----#
    UL_GapFR2_Config = OCT_STR(name='UL-GapFR2-Config', mode=MODE_TYPE)
    
    #-----< UL-RTOA-Measurement >-----#
    UL_RTOA_Measurement = SEQ(name='UL-RTOA-Measurement', mode=MODE_TYPE)
    _UL_RTOA_Measurement_uL_RTOA_MeasurementItem = CHOICE(name='uL-RTOA-MeasurementItem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UL-RTOA-MeasurementItem')))
    _UL_RTOA_Measurement_additionalPath_List = SEQ_OF(name='additionalPath-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'AdditionalPath-List')), opt=True)
    _UL_RTOA_Measurement_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_RTOA_Measurement_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UL_RTOA_Measurement_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_RTOA_Measurement_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____UL_RTOA_Measurement_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedAdditionalPathList')))
    _____UL_RTOA_Measurement_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRP-Rx-TEGInformation')))
    ____UL_RTOA_Measurement_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 561), ('criticality', 'ignore'), ('Extension', _____UL_RTOA_Measurement_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 568), ('criticality', 'ignore'), ('Extension', _____UL_RTOA_Measurement_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UL_RTOA_Measurement_iE_Extensions__item__id._const_tab = ____UL_RTOA_Measurement_iE_Extensions__item__id_tab
    ___UL_RTOA_Measurement_iE_Extensions__item__id._const_tab_at = None
    ___UL_RTOA_Measurement_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_RTOA_Measurement_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UL_RTOA_Measurement_iE_Extensions__item__criticality._const_tab = ____UL_RTOA_Measurement_iE_Extensions__item__id_tab
    ___UL_RTOA_Measurement_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_RTOA_Measurement_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_RTOA_Measurement_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UL_RTOA_Measurement_iE_Extensions__item__extensionValue._const_tab = ____UL_RTOA_Measurement_iE_Extensions__item__id_tab
    ___UL_RTOA_Measurement_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_RTOA_Measurement_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_RTOA_Measurement_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_RTOA_Measurement_iE_Extensions__item__id),
        ('criticality', ___UL_RTOA_Measurement_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_RTOA_Measurement_iE_Extensions__item__extensionValue),
        ])
    __UL_RTOA_Measurement_iE_Extensions__item_._ext = None
    _UL_RTOA_Measurement_iE_Extensions._cont = __UL_RTOA_Measurement_iE_Extensions__item_
    _UL_RTOA_Measurement_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_RTOA_Measurement._cont = ASN1Dict([
        ('uL-RTOA-MeasurementItem', _UL_RTOA_Measurement_uL_RTOA_MeasurementItem),
        ('additionalPath-List', _UL_RTOA_Measurement_additionalPath_List),
        ('iE-Extensions', _UL_RTOA_Measurement_iE_Extensions),
        ])
    UL_RTOA_Measurement._ext = None
    
    #-----< UL-RTOA-Measurement-ExtIEs >-----#
    UL_RTOA_Measurement_ExtIEs = CLASS(name='UL-RTOA-Measurement-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _UL_RTOA_Measurement_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedAdditionalPathList')))
    _UL_RTOA_Measurement_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRP-Rx-TEGInformation')))
    UL_RTOA_Measurement_ExtIEs._val = ASN1Set(rv=[dict([('id', 561), ('criticality', 'ignore'), ('Extension', _UL_RTOA_Measurement_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 568), ('criticality', 'ignore'), ('Extension', _UL_RTOA_Measurement_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-RTOA-MeasurementItem >-----#
    UL_RTOA_MeasurementItem = CHOICE(name='UL-RTOA-MeasurementItem', mode=MODE_TYPE)
    _UL_RTOA_MeasurementItem_k0 = INT(name='k0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UL_RTOA_MeasurementItem_k0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1970049)], ev=None, er=[])
    _UL_RTOA_MeasurementItem_k1 = INT(name='k1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UL_RTOA_MeasurementItem_k1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=985025)], ev=None, er=[])
    _UL_RTOA_MeasurementItem_k2 = INT(name='k2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UL_RTOA_MeasurementItem_k2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=492513)], ev=None, er=[])
    _UL_RTOA_MeasurementItem_k3 = INT(name='k3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UL_RTOA_MeasurementItem_k3._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=246257)], ev=None, er=[])
    _UL_RTOA_MeasurementItem_k4 = INT(name='k4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UL_RTOA_MeasurementItem_k4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=123129)], ev=None, er=[])
    _UL_RTOA_MeasurementItem_k5 = INT(name='k5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UL_RTOA_MeasurementItem_k5._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=61565)], ev=None, er=[])
    _UL_RTOA_MeasurementItem_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UL_RTOA_MeasurementItem_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___UL_RTOA_MeasurementItem_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UL_RTOA_MeasurementItem_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UL_RTOA_MeasurementItem_choice_extension_id._const_tab = ___UL_RTOA_MeasurementItem_choice_extension_id_tab
    __UL_RTOA_MeasurementItem_choice_extension_id._const_tab_at = None
    __UL_RTOA_MeasurementItem_choice_extension_id._const_tab_id = 'id'
    __UL_RTOA_MeasurementItem_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___UL_RTOA_MeasurementItem_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UL_RTOA_MeasurementItem_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UL_RTOA_MeasurementItem_choice_extension_criticality._const_tab = ___UL_RTOA_MeasurementItem_choice_extension_criticality_tab
    __UL_RTOA_MeasurementItem_choice_extension_criticality._const_tab_at = ('..', 'id')
    __UL_RTOA_MeasurementItem_choice_extension_criticality._const_tab_id = 'criticality'
    __UL_RTOA_MeasurementItem_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___UL_RTOA_MeasurementItem_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UL_RTOA_MeasurementItem_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UL_RTOA_MeasurementItem_choice_extension_value._const_tab = ___UL_RTOA_MeasurementItem_choice_extension_value_tab
    __UL_RTOA_MeasurementItem_choice_extension_value._const_tab_at = ('..', 'id')
    __UL_RTOA_MeasurementItem_choice_extension_value._const_tab_id = 'Value'
    _UL_RTOA_MeasurementItem_choice_extension._cont = ASN1Dict([
        ('id', __UL_RTOA_MeasurementItem_choice_extension_id),
        ('criticality', __UL_RTOA_MeasurementItem_choice_extension_criticality),
        ('value', __UL_RTOA_MeasurementItem_choice_extension_value),
        ])
    _UL_RTOA_MeasurementItem_choice_extension._ext = None
    UL_RTOA_MeasurementItem._cont = ASN1Dict([
        ('k0', _UL_RTOA_MeasurementItem_k0),
        ('k1', _UL_RTOA_MeasurementItem_k1),
        ('k2', _UL_RTOA_MeasurementItem_k2),
        ('k3', _UL_RTOA_MeasurementItem_k3),
        ('k4', _UL_RTOA_MeasurementItem_k4),
        ('k5', _UL_RTOA_MeasurementItem_k5),
        ('choice-extension', _UL_RTOA_MeasurementItem_choice_extension),
        ])
    UL_RTOA_MeasurementItem._ext = None
    
    #-----< UL-RTOA-MeasurementItem-ExtIEs >-----#
    UL_RTOA_MeasurementItem_ExtIEs = CLASS(name='UL-RTOA-MeasurementItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    UL_RTOA_MeasurementItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-SRS-RSRP >-----#
    UL_SRS_RSRP = INT(name='UL-SRS-RSRP', mode=MODE_TYPE)
    UL_SRS_RSRP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=126)], ev=None, er=[])
    
    #-----< UL-SRS-RSRPP >-----#
    UL_SRS_RSRPP = SEQ(name='UL-SRS-RSRPP', mode=MODE_TYPE)
    _UL_SRS_RSRPP_firstPathRSRPP = INT(name='firstPathRSRPP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UL_SRS_RSRPP_firstPathRSRPP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=126)], ev=None, er=[])
    _UL_SRS_RSRPP_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_SRS_RSRPP_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UL_SRS_RSRPP_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_SRS_RSRPP_iE_extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_SRS_RSRPP_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_SRS_RSRPP_iE_extensions__item__id._const_tab = ____UL_SRS_RSRPP_iE_extensions__item__id_tab
    ___UL_SRS_RSRPP_iE_extensions__item__id._const_tab_at = None
    ___UL_SRS_RSRPP_iE_extensions__item__id._const_tab_id = 'id'
    ___UL_SRS_RSRPP_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_SRS_RSRPP_iE_extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_SRS_RSRPP_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_SRS_RSRPP_iE_extensions__item__criticality._const_tab = ____UL_SRS_RSRPP_iE_extensions__item__criticality_tab
    ___UL_SRS_RSRPP_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_SRS_RSRPP_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_SRS_RSRPP_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_SRS_RSRPP_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_SRS_RSRPP_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_SRS_RSRPP_iE_extensions__item__extensionValue._const_tab = ____UL_SRS_RSRPP_iE_extensions__item__extensionValue_tab
    ___UL_SRS_RSRPP_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_SRS_RSRPP_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_SRS_RSRPP_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___UL_SRS_RSRPP_iE_extensions__item__id),
        ('criticality', ___UL_SRS_RSRPP_iE_extensions__item__criticality),
        ('extensionValue', ___UL_SRS_RSRPP_iE_extensions__item__extensionValue),
        ])
    __UL_SRS_RSRPP_iE_extensions__item_._ext = None
    _UL_SRS_RSRPP_iE_extensions._cont = __UL_SRS_RSRPP_iE_extensions__item_
    _UL_SRS_RSRPP_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_SRS_RSRPP._cont = ASN1Dict([
        ('firstPathRSRPP', _UL_SRS_RSRPP_firstPathRSRPP),
        ('iE-extensions', _UL_SRS_RSRPP_iE_extensions),
        ])
    UL_SRS_RSRPP._ext = []
    
    #-----< UL-SRS-RSRPP-ExtIEs >-----#
    UL_SRS_RSRPP_ExtIEs = CLASS(name='UL-SRS-RSRPP-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UL_SRS_RSRPP_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ULUEConfiguration >-----#
    ULUEConfiguration = ENUM(name='ULUEConfiguration', mode=MODE_TYPE)
    ULUEConfiguration._cont = ASN1Dict([('no-data', 0), ('shared', 1), ('only', 2)])
    ULUEConfiguration._ext = []
    
    #-----< UL-UP-TNL-Information-to-Update-List-Item >-----#
    UL_UP_TNL_Information_to_Update_List_Item = SEQ(name='UL-UP-TNL-Information-to-Update-List-Item', mode=MODE_TYPE)
    _UL_UP_TNL_Information_to_Update_List_Item_uLUPTNLInformation = CHOICE(name='uLUPTNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UPTransportLayerInformation')))
    _UL_UP_TNL_Information_to_Update_List_Item_newULUPTNLInformation = CHOICE(name='newULUPTNLInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UPTransportLayerInformation')), opt=True)
    _UL_UP_TNL_Information_to_Update_List_Item_bHInfo = SEQ(name='bHInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'BHInfo')))
    _UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__id._const_tab = ____UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__id_tab
    ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__criticality._const_tab = ____UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__criticality_tab
    ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__extensionValue._const_tab = ____UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__extensionValue_tab
    ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__id),
        ('criticality', ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__extensionValue),
        ])
    __UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item_._ext = None
    _UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions._cont = __UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item_
    _UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_UP_TNL_Information_to_Update_List_Item._cont = ASN1Dict([
        ('uLUPTNLInformation', _UL_UP_TNL_Information_to_Update_List_Item_uLUPTNLInformation),
        ('newULUPTNLInformation', _UL_UP_TNL_Information_to_Update_List_Item_newULUPTNLInformation),
        ('bHInfo', _UL_UP_TNL_Information_to_Update_List_Item_bHInfo),
        ('iE-Extensions', _UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions),
        ])
    UL_UP_TNL_Information_to_Update_List_Item._ext = []
    
    #-----< UL-UP-TNL-Information-to-Update-List-ItemExtIEs >-----#
    UL_UP_TNL_Information_to_Update_List_ItemExtIEs = CLASS(name='UL-UP-TNL-Information-to-Update-List-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UL_UP_TNL_Information_to_Update_List_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-UP-TNL-Address-to-Update-List-Item >-----#
    UL_UP_TNL_Address_to_Update_List_Item = SEQ(name='UL-UP-TNL-Address-to-Update-List-Item', mode=MODE_TYPE)
    _UL_UP_TNL_Address_to_Update_List_Item_oldIPAdress = BIT_STR(name='oldIPAdress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _UL_UP_TNL_Address_to_Update_List_Item_newIPAdress = BIT_STR(name='newIPAdress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id._const_tab = ____UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id_tab
    ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality._const_tab = ____UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality_tab
    ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue._const_tab = ____UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue_tab
    ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id),
        ('criticality', ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue),
        ])
    __UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item_._ext = None
    _UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions._cont = __UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item_
    _UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_UP_TNL_Address_to_Update_List_Item._cont = ASN1Dict([
        ('oldIPAdress', _UL_UP_TNL_Address_to_Update_List_Item_oldIPAdress),
        ('newIPAdress', _UL_UP_TNL_Address_to_Update_List_Item_newIPAdress),
        ('iE-Extensions', _UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions),
        ])
    UL_UP_TNL_Address_to_Update_List_Item._ext = []
    
    #-----< UL-UP-TNL-Address-to-Update-List-ItemExtIEs >-----#
    UL_UP_TNL_Address_to_Update_List_ItemExtIEs = CLASS(name='UL-UP-TNL-Address-to-Update-List-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UL_UP_TNL_Address_to_Update_List_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ULUPTNLInformation-ToBeSetup-List >-----#
    ULUPTNLInformation_ToBeSetup_List = SEQ_OF(name='ULUPTNLInformation-ToBeSetup-List', mode=MODE_TYPE)
    _ULUPTNLInformation_ToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ULUPTNLInformation-ToBeSetup-Item')))
    ULUPTNLInformation_ToBeSetup_List._cont = _ULUPTNLInformation_ToBeSetup_List__item_
    ULUPTNLInformation_ToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< ULUPTNLInformation-ToBeSetup-Item >-----#
    ULUPTNLInformation_ToBeSetup_Item = SEQ(name='ULUPTNLInformation-ToBeSetup-Item', mode=MODE_TYPE)
    _ULUPTNLInformation_ToBeSetup_Item_uLUPTNLInformation = CHOICE(name='uLUPTNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UPTransportLayerInformation')))
    _ULUPTNLInformation_ToBeSetup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHInfo')))
    _____ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelID')))
    ____ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'ignore'), ('Extension', _____ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 598), ('criticality', 'ignore'), ('Extension', _____ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id._const_tab = ____ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id),
        ('criticality', ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item_._ext = None
    _ULUPTNLInformation_ToBeSetup_Item_iE_Extensions._cont = __ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item_
    _ULUPTNLInformation_ToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ULUPTNLInformation_ToBeSetup_Item._cont = ASN1Dict([
        ('uLUPTNLInformation', _ULUPTNLInformation_ToBeSetup_Item_uLUPTNLInformation),
        ('iE-Extensions', _ULUPTNLInformation_ToBeSetup_Item_iE_Extensions),
        ])
    ULUPTNLInformation_ToBeSetup_Item._ext = []
    
    #-----< ULUPTNLInformation-ToBeSetup-ItemExtIEs >-----#
    ULUPTNLInformation_ToBeSetup_ItemExtIEs = CLASS(name='ULUPTNLInformation-ToBeSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _ULUPTNLInformation_ToBeSetup_ItemExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHInfo')))
    _ULUPTNLInformation_ToBeSetup_ItemExtIEs_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelID')))
    ULUPTNLInformation_ToBeSetup_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'ignore'), ('Extension', _ULUPTNLInformation_ToBeSetup_ItemExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 598), ('criticality', 'ignore'), ('Extension', _ULUPTNLInformation_ToBeSetup_ItemExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Uncertainty >-----#
    Uncertainty = INT(name='Uncertainty', mode=MODE_TYPE)
    Uncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=[], er=[])
    
    #-----< UplinkChannelBW-PerSCS-List >-----#
    UplinkChannelBW_PerSCS_List = SEQ_OF(name='UplinkChannelBW-PerSCS-List', mode=MODE_TYPE)
    _UplinkChannelBW_PerSCS_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCS-SpecificCarrier')))
    UplinkChannelBW_PerSCS_List._cont = _UplinkChannelBW_PerSCS_List__item_
    UplinkChannelBW_PerSCS_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< UplinkTxDirectCurrentListInformation >-----#
    UplinkTxDirectCurrentListInformation = OCT_STR(name='UplinkTxDirectCurrentListInformation', mode=MODE_TYPE)
    
    #-----< UplinkTxDirectCurrentTwoCarrierListInfo >-----#
    UplinkTxDirectCurrentTwoCarrierListInfo = OCT_STR(name='UplinkTxDirectCurrentTwoCarrierListInfo', mode=MODE_TYPE)
    
    #-----< UPTransportLayerInformation >-----#
    UPTransportLayerInformation = CHOICE(name='UPTransportLayerInformation', mode=MODE_TYPE)
    _UPTransportLayerInformation_gTPTunnel = SEQ(name='gTPTunnel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GTPTunnel')))
    _UPTransportLayerInformation_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UPTransportLayerInformation_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___UPTransportLayerInformation_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UPTransportLayerInformation_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UPTransportLayerInformation_choice_extension_id._const_tab = ___UPTransportLayerInformation_choice_extension_id_tab
    __UPTransportLayerInformation_choice_extension_id._const_tab_at = None
    __UPTransportLayerInformation_choice_extension_id._const_tab_id = 'id'
    __UPTransportLayerInformation_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___UPTransportLayerInformation_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UPTransportLayerInformation_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UPTransportLayerInformation_choice_extension_criticality._const_tab = ___UPTransportLayerInformation_choice_extension_criticality_tab
    __UPTransportLayerInformation_choice_extension_criticality._const_tab_at = ('..', 'id')
    __UPTransportLayerInformation_choice_extension_criticality._const_tab_id = 'criticality'
    __UPTransportLayerInformation_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___UPTransportLayerInformation_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UPTransportLayerInformation_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UPTransportLayerInformation_choice_extension_value._const_tab = ___UPTransportLayerInformation_choice_extension_value_tab
    __UPTransportLayerInformation_choice_extension_value._const_tab_at = ('..', 'id')
    __UPTransportLayerInformation_choice_extension_value._const_tab_id = 'Value'
    _UPTransportLayerInformation_choice_extension._cont = ASN1Dict([
        ('id', __UPTransportLayerInformation_choice_extension_id),
        ('criticality', __UPTransportLayerInformation_choice_extension_criticality),
        ('value', __UPTransportLayerInformation_choice_extension_value),
        ])
    _UPTransportLayerInformation_choice_extension._ext = None
    UPTransportLayerInformation._cont = ASN1Dict([
        ('gTPTunnel', _UPTransportLayerInformation_gTPTunnel),
        ('choice-extension', _UPTransportLayerInformation_choice_extension),
        ])
    UPTransportLayerInformation._ext = None
    
    #-----< UPTransportLayerInformation-ExtIEs >-----#
    UPTransportLayerInformation_ExtIEs = CLASS(name='UPTransportLayerInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    UPTransportLayerInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< URI-address >-----#
    URI_address = STR_VIS(name='URI-address', mode=MODE_TYPE)
    
    #-----< Uncertainty-range-AoA >-----#
    Uncertainty_range_AoA = INT(name='Uncertainty-range-AoA', mode=MODE_TYPE)
    Uncertainty_range_AoA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    
    #-----< Uncertainty-range-ZoA >-----#
    Uncertainty_range_ZoA = INT(name='Uncertainty-range-ZoA', mode=MODE_TYPE)
    Uncertainty_range_ZoA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1799)], ev=None, er=[])
    
    #-----< UuRLCChannelID >-----#
    UuRLCChannelID = BIT_STR(name='UuRLCChannelID', mode=MODE_TYPE)
    UuRLCChannelID._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< UuRLCChannelQoSInformation >-----#
    UuRLCChannelQoSInformation = CHOICE(name='UuRLCChannelQoSInformation', mode=MODE_TYPE)
    _UuRLCChannelQoSInformation_uuRLCChannelQoS = SEQ(name='uuRLCChannelQoS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'QoSFlowLevelQoSParameters')))
    _UuRLCChannelQoSInformation_uuControlPlaneTrafficType = ENUM(name='uuControlPlaneTrafficType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UuRLCChannelQoSInformation_uuControlPlaneTrafficType._cont = ASN1Dict([('srb0', 0), ('srb1', 1), ('srb2', 2)])
    _UuRLCChannelQoSInformation_uuControlPlaneTrafficType._ext = []
    _UuRLCChannelQoSInformation_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UuRLCChannelQoSInformation_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___UuRLCChannelQoSInformation_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UuRLCChannelQoSInformation_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UuRLCChannelQoSInformation_choice_extension_id._const_tab = ___UuRLCChannelQoSInformation_choice_extension_id_tab
    __UuRLCChannelQoSInformation_choice_extension_id._const_tab_at = None
    __UuRLCChannelQoSInformation_choice_extension_id._const_tab_id = 'id'
    __UuRLCChannelQoSInformation_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___UuRLCChannelQoSInformation_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UuRLCChannelQoSInformation_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UuRLCChannelQoSInformation_choice_extension_criticality._const_tab = ___UuRLCChannelQoSInformation_choice_extension_criticality_tab
    __UuRLCChannelQoSInformation_choice_extension_criticality._const_tab_at = ('..', 'id')
    __UuRLCChannelQoSInformation_choice_extension_criticality._const_tab_id = 'criticality'
    __UuRLCChannelQoSInformation_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___UuRLCChannelQoSInformation_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___UuRLCChannelQoSInformation_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UuRLCChannelQoSInformation_choice_extension_value._const_tab = ___UuRLCChannelQoSInformation_choice_extension_value_tab
    __UuRLCChannelQoSInformation_choice_extension_value._const_tab_at = ('..', 'id')
    __UuRLCChannelQoSInformation_choice_extension_value._const_tab_id = 'Value'
    _UuRLCChannelQoSInformation_choice_extension._cont = ASN1Dict([
        ('id', __UuRLCChannelQoSInformation_choice_extension_id),
        ('criticality', __UuRLCChannelQoSInformation_choice_extension_criticality),
        ('value', __UuRLCChannelQoSInformation_choice_extension_value),
        ])
    _UuRLCChannelQoSInformation_choice_extension._ext = None
    UuRLCChannelQoSInformation._cont = ASN1Dict([
        ('uuRLCChannelQoS', _UuRLCChannelQoSInformation_uuRLCChannelQoS),
        ('uuControlPlaneTrafficType', _UuRLCChannelQoSInformation_uuControlPlaneTrafficType),
        ('choice-extension', _UuRLCChannelQoSInformation_choice_extension),
        ])
    UuRLCChannelQoSInformation._ext = None
    
    #-----< UuRLCChannelQoSInformation-ExtIEs >-----#
    UuRLCChannelQoSInformation_ExtIEs = CLASS(name='UuRLCChannelQoSInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    UuRLCChannelQoSInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UuRLCChannelToBeSetupList >-----#
    UuRLCChannelToBeSetupList = SEQ_OF(name='UuRLCChannelToBeSetupList', mode=MODE_TYPE)
    _UuRLCChannelToBeSetupList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelToBeSetupItem')))
    UuRLCChannelToBeSetupList._cont = _UuRLCChannelToBeSetupList__item_
    UuRLCChannelToBeSetupList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< UuRLCChannelToBeSetupItem >-----#
    UuRLCChannelToBeSetupItem = SEQ(name='UuRLCChannelToBeSetupItem', mode=MODE_TYPE)
    _UuRLCChannelToBeSetupItem_uuRLCChannelID = BIT_STR(name='uuRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelID')))
    _UuRLCChannelToBeSetupItem_uuRLCChannelQoSInformation = CHOICE(name='uuRLCChannelQoSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelQoSInformation')))
    _UuRLCChannelToBeSetupItem_rLCMode = ENUM(name='rLCMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RLCMode')))
    _UuRLCChannelToBeSetupItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UuRLCChannelToBeSetupItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UuRLCChannelToBeSetupItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UuRLCChannelToBeSetupItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelToBeSetupItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelToBeSetupItem_iE_Extensions__item__id._const_tab = ____UuRLCChannelToBeSetupItem_iE_Extensions__item__id_tab
    ___UuRLCChannelToBeSetupItem_iE_Extensions__item__id._const_tab_at = None
    ___UuRLCChannelToBeSetupItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UuRLCChannelToBeSetupItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UuRLCChannelToBeSetupItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelToBeSetupItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelToBeSetupItem_iE_Extensions__item__criticality._const_tab = ____UuRLCChannelToBeSetupItem_iE_Extensions__item__criticality_tab
    ___UuRLCChannelToBeSetupItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UuRLCChannelToBeSetupItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UuRLCChannelToBeSetupItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UuRLCChannelToBeSetupItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelToBeSetupItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelToBeSetupItem_iE_Extensions__item__extensionValue._const_tab = ____UuRLCChannelToBeSetupItem_iE_Extensions__item__extensionValue_tab
    ___UuRLCChannelToBeSetupItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UuRLCChannelToBeSetupItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UuRLCChannelToBeSetupItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UuRLCChannelToBeSetupItem_iE_Extensions__item__id),
        ('criticality', ___UuRLCChannelToBeSetupItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UuRLCChannelToBeSetupItem_iE_Extensions__item__extensionValue),
        ])
    __UuRLCChannelToBeSetupItem_iE_Extensions__item_._ext = None
    _UuRLCChannelToBeSetupItem_iE_Extensions._cont = __UuRLCChannelToBeSetupItem_iE_Extensions__item_
    _UuRLCChannelToBeSetupItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UuRLCChannelToBeSetupItem._cont = ASN1Dict([
        ('uuRLCChannelID', _UuRLCChannelToBeSetupItem_uuRLCChannelID),
        ('uuRLCChannelQoSInformation', _UuRLCChannelToBeSetupItem_uuRLCChannelQoSInformation),
        ('rLCMode', _UuRLCChannelToBeSetupItem_rLCMode),
        ('iE-Extensions', _UuRLCChannelToBeSetupItem_iE_Extensions),
        ])
    UuRLCChannelToBeSetupItem._ext = []
    
    #-----< UuRLCChannelToBeSetupItem-ExtIEs >-----#
    UuRLCChannelToBeSetupItem_ExtIEs = CLASS(name='UuRLCChannelToBeSetupItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UuRLCChannelToBeSetupItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UuRLCChannelToBeModifiedList >-----#
    UuRLCChannelToBeModifiedList = SEQ_OF(name='UuRLCChannelToBeModifiedList', mode=MODE_TYPE)
    _UuRLCChannelToBeModifiedList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelToBeModifiedItem')))
    UuRLCChannelToBeModifiedList._cont = _UuRLCChannelToBeModifiedList__item_
    UuRLCChannelToBeModifiedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< UuRLCChannelToBeModifiedItem >-----#
    UuRLCChannelToBeModifiedItem = SEQ(name='UuRLCChannelToBeModifiedItem', mode=MODE_TYPE)
    _UuRLCChannelToBeModifiedItem_uuRLCChannelID = BIT_STR(name='uuRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelID')))
    _UuRLCChannelToBeModifiedItem_uuRLCChannelQoSInformation = CHOICE(name='uuRLCChannelQoSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelQoSInformation')), opt=True)
    _UuRLCChannelToBeModifiedItem_rLCMode = ENUM(name='rLCMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'RLCMode')), opt=True)
    _UuRLCChannelToBeModifiedItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UuRLCChannelToBeModifiedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UuRLCChannelToBeModifiedItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UuRLCChannelToBeModifiedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelToBeModifiedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelToBeModifiedItem_iE_Extensions__item__id._const_tab = ____UuRLCChannelToBeModifiedItem_iE_Extensions__item__id_tab
    ___UuRLCChannelToBeModifiedItem_iE_Extensions__item__id._const_tab_at = None
    ___UuRLCChannelToBeModifiedItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UuRLCChannelToBeModifiedItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UuRLCChannelToBeModifiedItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelToBeModifiedItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelToBeModifiedItem_iE_Extensions__item__criticality._const_tab = ____UuRLCChannelToBeModifiedItem_iE_Extensions__item__criticality_tab
    ___UuRLCChannelToBeModifiedItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UuRLCChannelToBeModifiedItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UuRLCChannelToBeModifiedItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UuRLCChannelToBeModifiedItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelToBeModifiedItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelToBeModifiedItem_iE_Extensions__item__extensionValue._const_tab = ____UuRLCChannelToBeModifiedItem_iE_Extensions__item__extensionValue_tab
    ___UuRLCChannelToBeModifiedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UuRLCChannelToBeModifiedItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UuRLCChannelToBeModifiedItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UuRLCChannelToBeModifiedItem_iE_Extensions__item__id),
        ('criticality', ___UuRLCChannelToBeModifiedItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UuRLCChannelToBeModifiedItem_iE_Extensions__item__extensionValue),
        ])
    __UuRLCChannelToBeModifiedItem_iE_Extensions__item_._ext = None
    _UuRLCChannelToBeModifiedItem_iE_Extensions._cont = __UuRLCChannelToBeModifiedItem_iE_Extensions__item_
    _UuRLCChannelToBeModifiedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UuRLCChannelToBeModifiedItem._cont = ASN1Dict([
        ('uuRLCChannelID', _UuRLCChannelToBeModifiedItem_uuRLCChannelID),
        ('uuRLCChannelQoSInformation', _UuRLCChannelToBeModifiedItem_uuRLCChannelQoSInformation),
        ('rLCMode', _UuRLCChannelToBeModifiedItem_rLCMode),
        ('iE-Extensions', _UuRLCChannelToBeModifiedItem_iE_Extensions),
        ])
    UuRLCChannelToBeModifiedItem._ext = []
    
    #-----< UuRLCChannelToBeModifiedItem-ExtIEs >-----#
    UuRLCChannelToBeModifiedItem_ExtIEs = CLASS(name='UuRLCChannelToBeModifiedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UuRLCChannelToBeModifiedItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UuRLCChannelToBeReleasedList >-----#
    UuRLCChannelToBeReleasedList = SEQ_OF(name='UuRLCChannelToBeReleasedList', mode=MODE_TYPE)
    _UuRLCChannelToBeReleasedList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelToBeReleasedItem')))
    UuRLCChannelToBeReleasedList._cont = _UuRLCChannelToBeReleasedList__item_
    UuRLCChannelToBeReleasedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< UuRLCChannelToBeReleasedItem >-----#
    UuRLCChannelToBeReleasedItem = SEQ(name='UuRLCChannelToBeReleasedItem', mode=MODE_TYPE)
    _UuRLCChannelToBeReleasedItem_uuRLCChannelID = BIT_STR(name='uuRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelID')))
    _UuRLCChannelToBeReleasedItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UuRLCChannelToBeReleasedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UuRLCChannelToBeReleasedItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UuRLCChannelToBeReleasedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelToBeReleasedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelToBeReleasedItem_iE_Extensions__item__id._const_tab = ____UuRLCChannelToBeReleasedItem_iE_Extensions__item__id_tab
    ___UuRLCChannelToBeReleasedItem_iE_Extensions__item__id._const_tab_at = None
    ___UuRLCChannelToBeReleasedItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UuRLCChannelToBeReleasedItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UuRLCChannelToBeReleasedItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelToBeReleasedItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelToBeReleasedItem_iE_Extensions__item__criticality._const_tab = ____UuRLCChannelToBeReleasedItem_iE_Extensions__item__criticality_tab
    ___UuRLCChannelToBeReleasedItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UuRLCChannelToBeReleasedItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UuRLCChannelToBeReleasedItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UuRLCChannelToBeReleasedItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelToBeReleasedItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelToBeReleasedItem_iE_Extensions__item__extensionValue._const_tab = ____UuRLCChannelToBeReleasedItem_iE_Extensions__item__extensionValue_tab
    ___UuRLCChannelToBeReleasedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UuRLCChannelToBeReleasedItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UuRLCChannelToBeReleasedItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UuRLCChannelToBeReleasedItem_iE_Extensions__item__id),
        ('criticality', ___UuRLCChannelToBeReleasedItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UuRLCChannelToBeReleasedItem_iE_Extensions__item__extensionValue),
        ])
    __UuRLCChannelToBeReleasedItem_iE_Extensions__item_._ext = None
    _UuRLCChannelToBeReleasedItem_iE_Extensions._cont = __UuRLCChannelToBeReleasedItem_iE_Extensions__item_
    _UuRLCChannelToBeReleasedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UuRLCChannelToBeReleasedItem._cont = ASN1Dict([
        ('uuRLCChannelID', _UuRLCChannelToBeReleasedItem_uuRLCChannelID),
        ('iE-Extensions', _UuRLCChannelToBeReleasedItem_iE_Extensions),
        ])
    UuRLCChannelToBeReleasedItem._ext = []
    
    #-----< UuRLCChannelToBeReleasedItem-ExtIEs >-----#
    UuRLCChannelToBeReleasedItem_ExtIEs = CLASS(name='UuRLCChannelToBeReleasedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UuRLCChannelToBeReleasedItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UuRLCChannelSetupList >-----#
    UuRLCChannelSetupList = SEQ_OF(name='UuRLCChannelSetupList', mode=MODE_TYPE)
    _UuRLCChannelSetupList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelSetupItem')))
    UuRLCChannelSetupList._cont = _UuRLCChannelSetupList__item_
    UuRLCChannelSetupList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< UuRLCChannelSetupItem >-----#
    UuRLCChannelSetupItem = SEQ(name='UuRLCChannelSetupItem', mode=MODE_TYPE)
    _UuRLCChannelSetupItem_uuRLCChannelID = BIT_STR(name='uuRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelID')))
    _UuRLCChannelSetupItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UuRLCChannelSetupItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UuRLCChannelSetupItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UuRLCChannelSetupItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelSetupItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelSetupItem_iE_Extensions__item__id._const_tab = ____UuRLCChannelSetupItem_iE_Extensions__item__id_tab
    ___UuRLCChannelSetupItem_iE_Extensions__item__id._const_tab_at = None
    ___UuRLCChannelSetupItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UuRLCChannelSetupItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UuRLCChannelSetupItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelSetupItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelSetupItem_iE_Extensions__item__criticality._const_tab = ____UuRLCChannelSetupItem_iE_Extensions__item__criticality_tab
    ___UuRLCChannelSetupItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UuRLCChannelSetupItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UuRLCChannelSetupItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UuRLCChannelSetupItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelSetupItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelSetupItem_iE_Extensions__item__extensionValue._const_tab = ____UuRLCChannelSetupItem_iE_Extensions__item__extensionValue_tab
    ___UuRLCChannelSetupItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UuRLCChannelSetupItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UuRLCChannelSetupItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UuRLCChannelSetupItem_iE_Extensions__item__id),
        ('criticality', ___UuRLCChannelSetupItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UuRLCChannelSetupItem_iE_Extensions__item__extensionValue),
        ])
    __UuRLCChannelSetupItem_iE_Extensions__item_._ext = None
    _UuRLCChannelSetupItem_iE_Extensions._cont = __UuRLCChannelSetupItem_iE_Extensions__item_
    _UuRLCChannelSetupItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UuRLCChannelSetupItem._cont = ASN1Dict([
        ('uuRLCChannelID', _UuRLCChannelSetupItem_uuRLCChannelID),
        ('iE-Extensions', _UuRLCChannelSetupItem_iE_Extensions),
        ])
    UuRLCChannelSetupItem._ext = []
    
    #-----< UuRLCChannelSetupItem-ExtIEs >-----#
    UuRLCChannelSetupItem_ExtIEs = CLASS(name='UuRLCChannelSetupItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UuRLCChannelSetupItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UuRLCChannelFailedToBeSetupList >-----#
    UuRLCChannelFailedToBeSetupList = SEQ_OF(name='UuRLCChannelFailedToBeSetupList', mode=MODE_TYPE)
    _UuRLCChannelFailedToBeSetupList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelFailedToBeSetupItem')))
    UuRLCChannelFailedToBeSetupList._cont = _UuRLCChannelFailedToBeSetupList__item_
    UuRLCChannelFailedToBeSetupList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< UuRLCChannelFailedToBeSetupItem >-----#
    UuRLCChannelFailedToBeSetupItem = SEQ(name='UuRLCChannelFailedToBeSetupItem', mode=MODE_TYPE)
    _UuRLCChannelFailedToBeSetupItem_uuRLCChannelID = BIT_STR(name='uuRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelID')))
    _UuRLCChannelFailedToBeSetupItem_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _UuRLCChannelFailedToBeSetupItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UuRLCChannelFailedToBeSetupItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__id._const_tab = ____UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__id_tab
    ___UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__id._const_tab_at = None
    ___UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__criticality._const_tab = ____UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__criticality_tab
    ___UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__extensionValue._const_tab = ____UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__extensionValue_tab
    ___UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UuRLCChannelFailedToBeSetupItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__id),
        ('criticality', ___UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__extensionValue),
        ])
    __UuRLCChannelFailedToBeSetupItem_iE_Extensions__item_._ext = None
    _UuRLCChannelFailedToBeSetupItem_iE_Extensions._cont = __UuRLCChannelFailedToBeSetupItem_iE_Extensions__item_
    _UuRLCChannelFailedToBeSetupItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UuRLCChannelFailedToBeSetupItem._cont = ASN1Dict([
        ('uuRLCChannelID', _UuRLCChannelFailedToBeSetupItem_uuRLCChannelID),
        ('cause', _UuRLCChannelFailedToBeSetupItem_cause),
        ('iE-Extensions', _UuRLCChannelFailedToBeSetupItem_iE_Extensions),
        ])
    UuRLCChannelFailedToBeSetupItem._ext = []
    
    #-----< UuRLCChannelFailedToBeSetupItem-ExtIEs >-----#
    UuRLCChannelFailedToBeSetupItem_ExtIEs = CLASS(name='UuRLCChannelFailedToBeSetupItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UuRLCChannelFailedToBeSetupItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UuRLCChannelModifiedList >-----#
    UuRLCChannelModifiedList = SEQ_OF(name='UuRLCChannelModifiedList', mode=MODE_TYPE)
    _UuRLCChannelModifiedList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelModifiedItem')))
    UuRLCChannelModifiedList._cont = _UuRLCChannelModifiedList__item_
    UuRLCChannelModifiedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< UuRLCChannelModifiedItem >-----#
    UuRLCChannelModifiedItem = SEQ(name='UuRLCChannelModifiedItem', mode=MODE_TYPE)
    _UuRLCChannelModifiedItem_uuRLCChannelID = BIT_STR(name='uuRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelID')))
    _UuRLCChannelModifiedItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UuRLCChannelModifiedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UuRLCChannelModifiedItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UuRLCChannelModifiedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelModifiedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelModifiedItem_iE_Extensions__item__id._const_tab = ____UuRLCChannelModifiedItem_iE_Extensions__item__id_tab
    ___UuRLCChannelModifiedItem_iE_Extensions__item__id._const_tab_at = None
    ___UuRLCChannelModifiedItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UuRLCChannelModifiedItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UuRLCChannelModifiedItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelModifiedItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelModifiedItem_iE_Extensions__item__criticality._const_tab = ____UuRLCChannelModifiedItem_iE_Extensions__item__criticality_tab
    ___UuRLCChannelModifiedItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UuRLCChannelModifiedItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UuRLCChannelModifiedItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UuRLCChannelModifiedItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelModifiedItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelModifiedItem_iE_Extensions__item__extensionValue._const_tab = ____UuRLCChannelModifiedItem_iE_Extensions__item__extensionValue_tab
    ___UuRLCChannelModifiedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UuRLCChannelModifiedItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UuRLCChannelModifiedItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UuRLCChannelModifiedItem_iE_Extensions__item__id),
        ('criticality', ___UuRLCChannelModifiedItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UuRLCChannelModifiedItem_iE_Extensions__item__extensionValue),
        ])
    __UuRLCChannelModifiedItem_iE_Extensions__item_._ext = None
    _UuRLCChannelModifiedItem_iE_Extensions._cont = __UuRLCChannelModifiedItem_iE_Extensions__item_
    _UuRLCChannelModifiedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UuRLCChannelModifiedItem._cont = ASN1Dict([
        ('uuRLCChannelID', _UuRLCChannelModifiedItem_uuRLCChannelID),
        ('iE-Extensions', _UuRLCChannelModifiedItem_iE_Extensions),
        ])
    UuRLCChannelModifiedItem._ext = []
    
    #-----< UuRLCChannelModifiedItem-ExtIEs >-----#
    UuRLCChannelModifiedItem_ExtIEs = CLASS(name='UuRLCChannelModifiedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UuRLCChannelModifiedItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UuRLCChannelFailedToBeModifiedList >-----#
    UuRLCChannelFailedToBeModifiedList = SEQ_OF(name='UuRLCChannelFailedToBeModifiedList', mode=MODE_TYPE)
    _UuRLCChannelFailedToBeModifiedList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelFailedToBeModifiedItem')))
    UuRLCChannelFailedToBeModifiedList._cont = _UuRLCChannelFailedToBeModifiedList__item_
    UuRLCChannelFailedToBeModifiedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< UuRLCChannelFailedToBeModifiedItem >-----#
    UuRLCChannelFailedToBeModifiedItem = SEQ(name='UuRLCChannelFailedToBeModifiedItem', mode=MODE_TYPE)
    _UuRLCChannelFailedToBeModifiedItem_uuRLCChannelID = BIT_STR(name='uuRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelID')))
    _UuRLCChannelFailedToBeModifiedItem_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'Cause')), opt=True)
    _UuRLCChannelFailedToBeModifiedItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__id._const_tab = ____UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__id_tab
    ___UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__id._const_tab_at = None
    ___UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__criticality._const_tab = ____UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__criticality_tab
    ___UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__extensionValue._const_tab = ____UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__extensionValue_tab
    ___UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__id),
        ('criticality', ___UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__extensionValue),
        ])
    __UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item_._ext = None
    _UuRLCChannelFailedToBeModifiedItem_iE_Extensions._cont = __UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item_
    _UuRLCChannelFailedToBeModifiedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UuRLCChannelFailedToBeModifiedItem._cont = ASN1Dict([
        ('uuRLCChannelID', _UuRLCChannelFailedToBeModifiedItem_uuRLCChannelID),
        ('cause', _UuRLCChannelFailedToBeModifiedItem_cause),
        ('iE-Extensions', _UuRLCChannelFailedToBeModifiedItem_iE_Extensions),
        ])
    UuRLCChannelFailedToBeModifiedItem._ext = []
    
    #-----< UuRLCChannelFailedToBeModifiedItem-ExtIEs >-----#
    UuRLCChannelFailedToBeModifiedItem_ExtIEs = CLASS(name='UuRLCChannelFailedToBeModifiedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UuRLCChannelFailedToBeModifiedItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UuRLCChannelRequiredToBeModifiedList >-----#
    UuRLCChannelRequiredToBeModifiedList = SEQ_OF(name='UuRLCChannelRequiredToBeModifiedList', mode=MODE_TYPE)
    _UuRLCChannelRequiredToBeModifiedList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelRequiredToBeModifiedItem')))
    UuRLCChannelRequiredToBeModifiedList._cont = _UuRLCChannelRequiredToBeModifiedList__item_
    UuRLCChannelRequiredToBeModifiedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< UuRLCChannelRequiredToBeModifiedItem >-----#
    UuRLCChannelRequiredToBeModifiedItem = SEQ(name='UuRLCChannelRequiredToBeModifiedItem', mode=MODE_TYPE)
    _UuRLCChannelRequiredToBeModifiedItem_uuRLCChannelID = BIT_STR(name='uuRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelID')))
    _UuRLCChannelRequiredToBeModifiedItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__id._const_tab = ____UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__id_tab
    ___UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__id._const_tab_at = None
    ___UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__criticality._const_tab = ____UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__criticality_tab
    ___UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__extensionValue._const_tab = ____UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__extensionValue_tab
    ___UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__id),
        ('criticality', ___UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__extensionValue),
        ])
    __UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item_._ext = None
    _UuRLCChannelRequiredToBeModifiedItem_iE_Extensions._cont = __UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item_
    _UuRLCChannelRequiredToBeModifiedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UuRLCChannelRequiredToBeModifiedItem._cont = ASN1Dict([
        ('uuRLCChannelID', _UuRLCChannelRequiredToBeModifiedItem_uuRLCChannelID),
        ('iE-Extensions', _UuRLCChannelRequiredToBeModifiedItem_iE_Extensions),
        ])
    UuRLCChannelRequiredToBeModifiedItem._ext = []
    
    #-----< UuRLCChannelRequiredToBeModifiedItem-ExtIEs >-----#
    UuRLCChannelRequiredToBeModifiedItem_ExtIEs = CLASS(name='UuRLCChannelRequiredToBeModifiedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UuRLCChannelRequiredToBeModifiedItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UuRLCChannelRequiredToBeReleasedList >-----#
    UuRLCChannelRequiredToBeReleasedList = SEQ_OF(name='UuRLCChannelRequiredToBeReleasedList', mode=MODE_TYPE)
    _UuRLCChannelRequiredToBeReleasedList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelRequiredToBeReleasedItem')))
    UuRLCChannelRequiredToBeReleasedList._cont = _UuRLCChannelRequiredToBeReleasedList__item_
    UuRLCChannelRequiredToBeReleasedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< UuRLCChannelRequiredToBeReleasedItem >-----#
    UuRLCChannelRequiredToBeReleasedItem = SEQ(name='UuRLCChannelRequiredToBeReleasedItem', mode=MODE_TYPE)
    _UuRLCChannelRequiredToBeReleasedItem_uuRLCChannelID = BIT_STR(name='uuRLCChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelID')))
    _UuRLCChannelRequiredToBeReleasedItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__id._const_tab = ____UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__id_tab
    ___UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__id._const_tab_at = None
    ___UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__criticality._const_tab = ____UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__criticality_tab
    ___UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__extensionValue._const_tab = ____UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__extensionValue_tab
    ___UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__id),
        ('criticality', ___UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__extensionValue),
        ])
    __UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item_._ext = None
    _UuRLCChannelRequiredToBeReleasedItem_iE_Extensions._cont = __UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item_
    _UuRLCChannelRequiredToBeReleasedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UuRLCChannelRequiredToBeReleasedItem._cont = ASN1Dict([
        ('uuRLCChannelID', _UuRLCChannelRequiredToBeReleasedItem_uuRLCChannelID),
        ('iE-Extensions', _UuRLCChannelRequiredToBeReleasedItem_iE_Extensions),
        ])
    UuRLCChannelRequiredToBeReleasedItem._ext = []
    
    #-----< UuRLCChannelRequiredToBeReleasedItem-ExtIEs >-----#
    UuRLCChannelRequiredToBeReleasedItem_ExtIEs = CLASS(name='UuRLCChannelRequiredToBeReleasedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    UuRLCChannelRequiredToBeReleasedItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< VictimgNBSetID >-----#
    VictimgNBSetID = SEQ(name='VictimgNBSetID', mode=MODE_TYPE)
    _VictimgNBSetID_victimgNBSetID = BIT_STR(name='victimgNBSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'GNBSetID')))
    _VictimgNBSetID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __VictimgNBSetID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___VictimgNBSetID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____VictimgNBSetID_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____VictimgNBSetID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___VictimgNBSetID_iE_Extensions__item__id._const_tab = ____VictimgNBSetID_iE_Extensions__item__id_tab
    ___VictimgNBSetID_iE_Extensions__item__id._const_tab_at = None
    ___VictimgNBSetID_iE_Extensions__item__id._const_tab_id = 'id'
    ___VictimgNBSetID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____VictimgNBSetID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____VictimgNBSetID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___VictimgNBSetID_iE_Extensions__item__criticality._const_tab = ____VictimgNBSetID_iE_Extensions__item__criticality_tab
    ___VictimgNBSetID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___VictimgNBSetID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___VictimgNBSetID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____VictimgNBSetID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____VictimgNBSetID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___VictimgNBSetID_iE_Extensions__item__extensionValue._const_tab = ____VictimgNBSetID_iE_Extensions__item__extensionValue_tab
    ___VictimgNBSetID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___VictimgNBSetID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __VictimgNBSetID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___VictimgNBSetID_iE_Extensions__item__id),
        ('criticality', ___VictimgNBSetID_iE_Extensions__item__criticality),
        ('extensionValue', ___VictimgNBSetID_iE_Extensions__item__extensionValue),
        ])
    __VictimgNBSetID_iE_Extensions__item_._ext = None
    _VictimgNBSetID_iE_Extensions._cont = __VictimgNBSetID_iE_Extensions__item_
    _VictimgNBSetID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    VictimgNBSetID._cont = ASN1Dict([
        ('victimgNBSetID', _VictimgNBSetID_victimgNBSetID),
        ('iE-Extensions', _VictimgNBSetID_iE_Extensions),
        ])
    VictimgNBSetID._ext = None
    
    #-----< VictimgNBSetID-ExtIEs >-----#
    VictimgNBSetID_ExtIEs = CLASS(name='VictimgNBSetID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    VictimgNBSetID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< VehicleUE >-----#
    VehicleUE = ENUM(name='VehicleUE', mode=MODE_TYPE)
    VehicleUE._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    VehicleUE._ext = []
    
    #-----< PedestrianUE >-----#
    PedestrianUE = ENUM(name='PedestrianUE', mode=MODE_TYPE)
    PedestrianUE._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    PedestrianUE._ext = []
    
    #-----< ZoAInformation >-----#
    ZoAInformation = SEQ(name='ZoAInformation', mode=MODE_TYPE)
    _ZoAInformation_zenithAoA = INT(name='zenithAoA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ZoAInformation_zenithAoA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1799)], ev=None, er=[])
    _ZoAInformation_lCS_to_GCS_Translation = SEQ(name='lCS-to-GCS-Translation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'LCS-to-GCS-Translation')), opt=True)
    _ZoAInformation_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ZoAInformation_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___ZoAInformation_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ZoAInformation_iE_extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ZoAInformation_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ZoAInformation_iE_extensions__item__id._const_tab = ____ZoAInformation_iE_extensions__item__id_tab
    ___ZoAInformation_iE_extensions__item__id._const_tab_at = None
    ___ZoAInformation_iE_extensions__item__id._const_tab_id = 'id'
    ___ZoAInformation_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ZoAInformation_iE_extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ZoAInformation_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ZoAInformation_iE_extensions__item__criticality._const_tab = ____ZoAInformation_iE_extensions__item__criticality_tab
    ___ZoAInformation_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ZoAInformation_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___ZoAInformation_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ZoAInformation_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____ZoAInformation_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ZoAInformation_iE_extensions__item__extensionValue._const_tab = ____ZoAInformation_iE_extensions__item__extensionValue_tab
    ___ZoAInformation_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ZoAInformation_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __ZoAInformation_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___ZoAInformation_iE_extensions__item__id),
        ('criticality', ___ZoAInformation_iE_extensions__item__criticality),
        ('extensionValue', ___ZoAInformation_iE_extensions__item__extensionValue),
        ])
    __ZoAInformation_iE_extensions__item_._ext = None
    _ZoAInformation_iE_extensions._cont = __ZoAInformation_iE_extensions__item_
    _ZoAInformation_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ZoAInformation._cont = ASN1Dict([
        ('zenithAoA', _ZoAInformation_zenithAoA),
        ('lCS-to-GCS-Translation', _ZoAInformation_lCS_to_GCS_Translation),
        ('iE-extensions', _ZoAInformation_iE_extensions),
        ])
    ZoAInformation._ext = []
    
    #-----< ZoAInformation-ExtIEs >-----#
    ZoAInformation_ExtIEs = CLASS(name='ZoAInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ZoAInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    _all_ = [
        _AbortTransmission_sRSResourceSetID,
        _AbortTransmission_releaseALL,
        ___AbortTransmission_choice_extension_id_tab,
        __AbortTransmission_choice_extension_id,
        ___AbortTransmission_choice_extension_criticality_tab,
        __AbortTransmission_choice_extension_criticality,
        ___AbortTransmission_choice_extension_value_tab,
        __AbortTransmission_choice_extension_value,
        _AbortTransmission_choice_extension,
        AbortTransmission,
        AbortTransmission_ExtIEs,
        _AccessPointPosition_latitudeSign,
        _AccessPointPosition_latitude,
        _AccessPointPosition_longitude,
        _AccessPointPosition_directionOfAltitude,
        _AccessPointPosition_altitude,
        _AccessPointPosition_uncertaintySemi_major,
        _AccessPointPosition_uncertaintySemi_minor,
        _AccessPointPosition_orientationOfMajorAxis,
        _AccessPointPosition_uncertaintyAltitude,
        _AccessPointPosition_confidence,
        ____AccessPointPosition_iE_Extensions__item__id_tab,
        ___AccessPointPosition_iE_Extensions__item__id,
        ____AccessPointPosition_iE_Extensions__item__criticality_tab,
        ___AccessPointPosition_iE_Extensions__item__criticality,
        ____AccessPointPosition_iE_Extensions__item__extensionValue_tab,
        ___AccessPointPosition_iE_Extensions__item__extensionValue,
        __AccessPointPosition_iE_Extensions__item_,
        _AccessPointPosition_iE_Extensions,
        AccessPointPosition,
        AccessPointPosition_ExtIEs,
        _Activated_Cells_to_be_Updated_List__item_,
        Activated_Cells_to_be_Updated_List,
        _Activated_Cells_to_be_Updated_List_Item_nRCGI,
        _Activated_Cells_to_be_Updated_List_Item_iAB_DU_Cell_Resource_Configuration_Mode_Info,
        ____Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__id_tab,
        ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__id,
        ____Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__criticality_tab,
        ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__criticality,
        ____Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__extensionValue_tab,
        ___Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item__extensionValue,
        __Activated_Cells_to_be_Updated_List_Item_iE_Extensions__item_,
        _Activated_Cells_to_be_Updated_List_Item_iE_Extensions,
        Activated_Cells_to_be_Updated_List_Item,
        Activated_Cells_to_be_Updated_List_Item_ExtIEs,
        ActivationRequestType,
        _ActiveULBWP_locationAndBandwidth,
        _ActiveULBWP_subcarrierSpacing,
        _ActiveULBWP_cyclicPrefix,
        _ActiveULBWP_txDirectCurrentLocation,
        _ActiveULBWP_shift7dot5kHz,
        _ActiveULBWP_sRSConfig,
        ____ActiveULBWP_iE_Extensions__item__id_tab,
        ___ActiveULBWP_iE_Extensions__item__id,
        ____ActiveULBWP_iE_Extensions__item__criticality_tab,
        ___ActiveULBWP_iE_Extensions__item__criticality,
        ____ActiveULBWP_iE_Extensions__item__extensionValue_tab,
        ___ActiveULBWP_iE_Extensions__item__extensionValue,
        __ActiveULBWP_iE_Extensions__item_,
        _ActiveULBWP_iE_Extensions,
        ActiveULBWP,
        ActiveULBWP_ExtIEs,
        AdditionalDuplicationIndication,
        _AdditionalPath_List__item_,
        AdditionalPath_List,
        _AdditionalPath_Item_relativePathDelay,
        _AdditionalPath_Item_pathQuality,
        ____AdditionalPath_Item_iE_Extensions__item__id_tab,
        _____AdditionalPath_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____AdditionalPath_Item_iE_Extensions__item__id_tab_val_Extension_1,
        ___AdditionalPath_Item_iE_Extensions__item__id,
        ___AdditionalPath_Item_iE_Extensions__item__criticality,
        ___AdditionalPath_Item_iE_Extensions__item__extensionValue,
        __AdditionalPath_Item_iE_Extensions__item_,
        _AdditionalPath_Item_iE_Extensions,
        AdditionalPath_Item,
        AdditionalPath_Item_ExtIEs,
        _AdditionalPath_Item_ExtIEs_val_Extension_0,
        _AdditionalPath_Item_ExtIEs_val_Extension_1,
        _ExtendedAdditionalPathList__item_,
        ExtendedAdditionalPathList,
        _ExtendedAdditionalPathList_Item_relativeTimeOfPath,
        _ExtendedAdditionalPathList_Item_pathQuality,
        _ExtendedAdditionalPathList_Item_multipleULAoA,
        _ExtendedAdditionalPathList_Item_pathPower,
        ____ExtendedAdditionalPathList_Item_iE_Extensions__item__id_tab,
        ___ExtendedAdditionalPathList_Item_iE_Extensions__item__id,
        ____ExtendedAdditionalPathList_Item_iE_Extensions__item__criticality_tab,
        ___ExtendedAdditionalPathList_Item_iE_Extensions__item__criticality,
        ____ExtendedAdditionalPathList_Item_iE_Extensions__item__extensionValue_tab,
        ___ExtendedAdditionalPathList_Item_iE_Extensions__item__extensionValue,
        __ExtendedAdditionalPathList_Item_iE_Extensions__item_,
        _ExtendedAdditionalPathList_Item_iE_Extensions,
        ExtendedAdditionalPathList_Item,
        ExtendedAdditionalPathList_Item_ExtIEs,
        _AdditionalPDCPDuplicationTNL_List__item_,
        AdditionalPDCPDuplicationTNL_List,
        _AdditionalPDCPDuplicationTNL_Item_additionalPDCPDuplicationUPTNLInformation,
        ____AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id_tab,
        _____AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__id,
        ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__criticality,
        ___AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item__extensionValue,
        __AdditionalPDCPDuplicationTNL_Item_iE_Extensions__item_,
        _AdditionalPDCPDuplicationTNL_Item_iE_Extensions,
        AdditionalPDCPDuplicationTNL_Item,
        AdditionalPDCPDuplicationTNL_ItemExtIEs,
        _AdditionalPDCPDuplicationTNL_ItemExtIEs_val_Extension_0,
        _AdditionalSIBMessageList__item_,
        AdditionalSIBMessageList,
        _AdditionalSIBMessageList_Item_additionalSIB,
        ____AdditionalSIBMessageList_Item_iE_Extensions__item__id_tab,
        ___AdditionalSIBMessageList_Item_iE_Extensions__item__id,
        ____AdditionalSIBMessageList_Item_iE_Extensions__item__criticality_tab,
        ___AdditionalSIBMessageList_Item_iE_Extensions__item__criticality,
        ____AdditionalSIBMessageList_Item_iE_Extensions__item__extensionValue_tab,
        ___AdditionalSIBMessageList_Item_iE_Extensions__item__extensionValue,
        __AdditionalSIBMessageList_Item_iE_Extensions__item_,
        _AdditionalSIBMessageList_Item_iE_Extensions,
        AdditionalSIBMessageList_Item,
        AdditionalSIBMessageList_Item_ExtIEs,
        AdditionalRRMPriorityIndex,
        _AffectedCellsAndBeams_List__item_,
        AffectedCellsAndBeams_List,
        _AffectedCellsAndBeams_Item_nRCGI,
        _AffectedCellsAndBeams_Item_affectedSSB_List,
        ____AffectedCellsAndBeams_Item_iE_Extensions__item__id_tab,
        ___AffectedCellsAndBeams_Item_iE_Extensions__item__id,
        ____AffectedCellsAndBeams_Item_iE_Extensions__item__criticality_tab,
        ___AffectedCellsAndBeams_Item_iE_Extensions__item__criticality,
        ____AffectedCellsAndBeams_Item_iE_Extensions__item__extensionValue_tab,
        ___AffectedCellsAndBeams_Item_iE_Extensions__item__extensionValue,
        __AffectedCellsAndBeams_Item_iE_Extensions__item_,
        _AffectedCellsAndBeams_Item_iE_Extensions,
        AffectedCellsAndBeams_Item,
        AffectedCellsAndBeams_Item_ExtIEs,
        _AffectedSSB_List__item_,
        AffectedSSB_List,
        _AffectedSSB_Item_sSB_Index,
        ____AffectedSSB_Item_iE_Extensions__item__id_tab,
        ___AffectedSSB_Item_iE_Extensions__item__id,
        ____AffectedSSB_Item_iE_Extensions__item__criticality_tab,
        ___AffectedSSB_Item_iE_Extensions__item__criticality,
        ____AffectedSSB_Item_iE_Extensions__item__extensionValue_tab,
        ___AffectedSSB_Item_iE_Extensions__item__extensionValue,
        __AffectedSSB_Item_iE_Extensions__item_,
        _AffectedSSB_Item_iE_Extensions,
        AffectedSSB_Item,
        AffectedSSB_Item_ExtIEs,
        _AggressorCellList__item_,
        AggressorCellList,
        _AggressorCellList_Item_aggressorCell_ID,
        ____AggressorCellList_Item_iE_Extensions__item__id_tab,
        ___AggressorCellList_Item_iE_Extensions__item__id,
        ____AggressorCellList_Item_iE_Extensions__item__criticality_tab,
        ___AggressorCellList_Item_iE_Extensions__item__criticality,
        ____AggressorCellList_Item_iE_Extensions__item__extensionValue_tab,
        ___AggressorCellList_Item_iE_Extensions__item__extensionValue,
        __AggressorCellList_Item_iE_Extensions__item_,
        _AggressorCellList_Item_iE_Extensions,
        AggressorCellList_Item,
        AggressorCellList_Item_ExtIEs,
        _AggressorgNBSetID_aggressorgNBSetID,
        ____AggressorgNBSetID_iE_Extensions__item__id_tab,
        ___AggressorgNBSetID_iE_Extensions__item__id,
        ____AggressorgNBSetID_iE_Extensions__item__criticality_tab,
        ___AggressorgNBSetID_iE_Extensions__item__criticality,
        ____AggressorgNBSetID_iE_Extensions__item__extensionValue_tab,
        ___AggressorgNBSetID_iE_Extensions__item__extensionValue,
        __AggressorgNBSetID_iE_Extensions__item_,
        _AggressorgNBSetID_iE_Extensions,
        AggressorgNBSetID,
        AggressorgNBSetID_ExtIEs,
        _AllocationAndRetentionPriority_priorityLevel,
        _AllocationAndRetentionPriority_pre_emptionCapability,
        _AllocationAndRetentionPriority_pre_emptionVulnerability,
        ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab,
        ___AllocationAndRetentionPriority_iE_Extensions__item__id,
        ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab,
        ___AllocationAndRetentionPriority_iE_Extensions__item__criticality,
        ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab,
        ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue,
        __AllocationAndRetentionPriority_iE_Extensions__item_,
        _AllocationAndRetentionPriority_iE_Extensions,
        AllocationAndRetentionPriority,
        AllocationAndRetentionPriority_ExtIEs,
        _AlternativeQoSParaSetList__item_,
        AlternativeQoSParaSetList,
        _AlternativeQoSParaSetItem_alternativeQoSParaSetIndex,
        _AlternativeQoSParaSetItem_guaranteedFlowBitRateDL,
        _AlternativeQoSParaSetItem_guaranteedFlowBitRateUL,
        _AlternativeQoSParaSetItem_packetDelayBudget,
        _AlternativeQoSParaSetItem_packetErrorRate,
        ____AlternativeQoSParaSetItem_iE_Extensions__item__id_tab,
        ___AlternativeQoSParaSetItem_iE_Extensions__item__id,
        ____AlternativeQoSParaSetItem_iE_Extensions__item__criticality_tab,
        ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality,
        ____AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue_tab,
        ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue,
        __AlternativeQoSParaSetItem_iE_Extensions__item_,
        _AlternativeQoSParaSetItem_iE_Extensions,
        AlternativeQoSParaSetItem,
        AlternativeQoSParaSetItem_ExtIEs,
        _AngleMeasurementQuality_azimuthQuality,
        _AngleMeasurementQuality_zenithQuality,
        _AngleMeasurementQuality_resolution,
        ____AngleMeasurementQuality_iE_Extensions__item__id_tab,
        ___AngleMeasurementQuality_iE_Extensions__item__id,
        ____AngleMeasurementQuality_iE_Extensions__item__criticality_tab,
        ___AngleMeasurementQuality_iE_Extensions__item__criticality,
        ____AngleMeasurementQuality_iE_Extensions__item__extensionValue_tab,
        ___AngleMeasurementQuality_iE_Extensions__item__extensionValue,
        __AngleMeasurementQuality_iE_Extensions__item_,
        _AngleMeasurementQuality_iE_Extensions,
        AngleMeasurementQuality,
        AngleMeasurementQuality_ExtIEs,
        _AperiodicSRSResourceTriggerList__item_,
        AperiodicSRSResourceTriggerList,
        AperiodicSRSResourceTrigger,
        _Associated_SCell_Item_sCell_ID,
        ____Associated_SCell_Item_iE_Extensions__item__id_tab,
        ___Associated_SCell_Item_iE_Extensions__item__id,
        ____Associated_SCell_Item_iE_Extensions__item__criticality_tab,
        ___Associated_SCell_Item_iE_Extensions__item__criticality,
        ____Associated_SCell_Item_iE_Extensions__item__extensionValue_tab,
        ___Associated_SCell_Item_iE_Extensions__item__extensionValue,
        __Associated_SCell_Item_iE_Extensions__item_,
        _Associated_SCell_Item_iE_Extensions,
        Associated_SCell_Item,
        Associated_SCell_ItemExtIEs,
        _AvailablePLMNList__item_,
        AvailablePLMNList,
        _AvailablePLMNList_Item_pLMNIdentity,
        ____AvailablePLMNList_Item_iE_Extensions__item__id_tab,
        ___AvailablePLMNList_Item_iE_Extensions__item__id,
        ____AvailablePLMNList_Item_iE_Extensions__item__criticality_tab,
        ___AvailablePLMNList_Item_iE_Extensions__item__criticality,
        ____AvailablePLMNList_Item_iE_Extensions__item__extensionValue_tab,
        ___AvailablePLMNList_Item_iE_Extensions__item__extensionValue,
        __AvailablePLMNList_Item_iE_Extensions__item_,
        _AvailablePLMNList_Item_iE_Extensions,
        AvailablePLMNList_Item,
        AvailablePLMNList_Item_ExtIEs,
        _AvailableSNPN_ID_List__item_,
        AvailableSNPN_ID_List,
        _AvailableSNPN_ID_List_Item_pLMN_Identity,
        _AvailableSNPN_ID_List_Item_availableNIDList,
        ____AvailableSNPN_ID_List_Item_iE_Extensions__item__id_tab,
        ___AvailableSNPN_ID_List_Item_iE_Extensions__item__id,
        ____AvailableSNPN_ID_List_Item_iE_Extensions__item__criticality_tab,
        ___AvailableSNPN_ID_List_Item_iE_Extensions__item__criticality,
        ____AvailableSNPN_ID_List_Item_iE_Extensions__item__extensionValue_tab,
        ___AvailableSNPN_ID_List_Item_iE_Extensions__item__extensionValue,
        __AvailableSNPN_ID_List_Item_iE_Extensions__item_,
        _AvailableSNPN_ID_List_Item_iE_Extensions,
        AvailableSNPN_ID_List_Item,
        AvailableSNPN_ID_List_ItemExtIEs,
        AveragingWindow,
        AreaScope,
        _AoA_AssistanceInfo_angleMeasurement,
        _AoA_AssistanceInfo_lCS_to_GCS_Translation,
        ____AoA_AssistanceInfo_iE_Extensions__item__id_tab,
        ___AoA_AssistanceInfo_iE_Extensions__item__id,
        ____AoA_AssistanceInfo_iE_Extensions__item__criticality_tab,
        ___AoA_AssistanceInfo_iE_Extensions__item__criticality,
        ____AoA_AssistanceInfo_iE_Extensions__item__extensionValue_tab,
        ___AoA_AssistanceInfo_iE_Extensions__item__extensionValue,
        __AoA_AssistanceInfo_iE_Extensions__item_,
        _AoA_AssistanceInfo_iE_Extensions,
        AoA_AssistanceInfo,
        AoA_AssistanceInfo_ExtIEs,
        _AngleMeasurementType_expected_ULAoA,
        _AngleMeasurementType_expected_ZoA,
        ___AngleMeasurementType_choice_extension_id_tab,
        __AngleMeasurementType_choice_extension_id,
        ___AngleMeasurementType_choice_extension_criticality_tab,
        __AngleMeasurementType_choice_extension_criticality,
        ___AngleMeasurementType_choice_extension_value_tab,
        __AngleMeasurementType_choice_extension_value,
        _AngleMeasurementType_choice_extension,
        AngleMeasurementType,
        AngleMeasurementType_ExtIEs,
        AppLayerBufferLevelList,
        ARP_ID,
        _ARPLocationInformation__item_,
        ARPLocationInformation,
        _ARPLocationInformation_Item_aRP_ID,
        _ARPLocationInformation_Item_aRPLocationType,
        ____ARPLocationInformation_Item_iE_Extensions__item__id_tab,
        ___ARPLocationInformation_Item_iE_Extensions__item__id,
        ____ARPLocationInformation_Item_iE_Extensions__item__criticality_tab,
        ___ARPLocationInformation_Item_iE_Extensions__item__criticality,
        ____ARPLocationInformation_Item_iE_Extensions__item__extensionValue_tab,
        ___ARPLocationInformation_Item_iE_Extensions__item__extensionValue,
        __ARPLocationInformation_Item_iE_Extensions__item_,
        _ARPLocationInformation_Item_iE_Extensions,
        ARPLocationInformation_Item,
        ARPLocationInformation_ExtIEs,
        _ARPLocationType_aRPPositionRelativeGeodetic,
        _ARPLocationType_aRPPositionRelativeCartesian,
        ___ARPLocationType_choice_extension_id_tab,
        __ARPLocationType_choice_extension_id,
        ___ARPLocationType_choice_extension_criticality_tab,
        __ARPLocationType_choice_extension_criticality,
        ___ARPLocationType_choice_extension_value_tab,
        __ARPLocationType_choice_extension_value,
        _ARPLocationType_choice_extension,
        ARPLocationType,
        ARPLocationType_ExtIEs,
        _BAP_Header_Rewriting_Added_List_Item_ingressBAPRoutingID,
        _BAP_Header_Rewriting_Added_List_Item_egressBAPRoutingID,
        _BAP_Header_Rewriting_Added_List_Item_nonF1terminatingTopologyIndicator,
        ____BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__id_tab,
        ___BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__id,
        ____BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__criticality_tab,
        ___BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__criticality,
        ____BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__extensionValue_tab,
        ___BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item__extensionValue,
        __BAP_Header_Rewriting_Added_List_Item_iE_Extensions__item_,
        _BAP_Header_Rewriting_Added_List_Item_iE_Extensions,
        BAP_Header_Rewriting_Added_List_Item,
        BAP_Header_Rewriting_Added_List_Item_ExtIEs,
        _BAP_Header_Rewriting_Removed_List_Item_ingressBAPRoutingID,
        ____BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__id_tab,
        ___BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__id,
        ____BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__criticality_tab,
        ___BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__criticality,
        ____BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__extensionValue_tab,
        ___BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item__extensionValue,
        __BAP_Header_Rewriting_Removed_List_Item_iE_Extensions__item_,
        _BAP_Header_Rewriting_Removed_List_Item_iE_Extensions,
        BAP_Header_Rewriting_Removed_List_Item,
        BAP_Header_Rewriting_Removed_List_Item_ExtIEs,
        _BandwidthSRS_fR1,
        _BandwidthSRS_fR2,
        ___BandwidthSRS_choice_extension_id_tab,
        __BandwidthSRS_choice_extension_id,
        ___BandwidthSRS_choice_extension_criticality_tab,
        __BandwidthSRS_choice_extension_criticality,
        ___BandwidthSRS_choice_extension_value_tab,
        __BandwidthSRS_choice_extension_value,
        _BandwidthSRS_choice_extension,
        BandwidthSRS,
        BandwidthSRS_ExtIEs,
        BAPAddress,
        BAPCtrlPDUChannel,
        _BAPlayerBHRLCchannelMappingInfo_bAPlayerBHRLCchannelMappingInfoToAdd,
        _BAPlayerBHRLCchannelMappingInfo_bAPlayerBHRLCchannelMappingInfoToRemove,
        ____BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__id_tab,
        ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__id,
        ____BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__criticality_tab,
        ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__criticality,
        ____BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__extensionValue_tab,
        ___BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item__extensionValue,
        __BAPlayerBHRLCchannelMappingInfo_iE_Extensions__item_,
        _BAPlayerBHRLCchannelMappingInfo_iE_Extensions,
        BAPlayerBHRLCchannelMappingInfo,
        BAPlayerBHRLCchannelMappingInfo_ExtIEs,
        _BAPlayerBHRLCchannelMappingInfoList__item_,
        BAPlayerBHRLCchannelMappingInfoList,
        _BAPlayerBHRLCchannelMappingInfo_Item_mappingInformationIndex,
        _BAPlayerBHRLCchannelMappingInfo_Item_priorHopBAPAddress,
        _BAPlayerBHRLCchannelMappingInfo_Item_ingressbHRLCChannelID,
        _BAPlayerBHRLCchannelMappingInfo_Item_nextHopBAPAddress,
        _BAPlayerBHRLCchannelMappingInfo_Item_egressbHRLCChannelID,
        ____BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id_tab,
        _____BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id_tab_val_Extension_1,
        ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__id,
        ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__criticality,
        ___BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item__extensionValue,
        __BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions__item_,
        _BAPlayerBHRLCchannelMappingInfo_Item_iE_Extensions,
        BAPlayerBHRLCchannelMappingInfo_Item,
        BAPlayerBHRLCchannelMappingInfo_ItemExtIEs,
        _BAPlayerBHRLCchannelMappingInfo_ItemExtIEs_val_Extension_0,
        _BAPlayerBHRLCchannelMappingInfo_ItemExtIEs_val_Extension_1,
        BAPPathID,
        _BAPRoutingID_bAPAddress,
        _BAPRoutingID_bAPPathID,
        ____BAPRoutingID_iE_Extensions__item__id_tab,
        ___BAPRoutingID_iE_Extensions__item__id,
        ____BAPRoutingID_iE_Extensions__item__criticality_tab,
        ___BAPRoutingID_iE_Extensions__item__criticality,
        ____BAPRoutingID_iE_Extensions__item__extensionValue_tab,
        ___BAPRoutingID_iE_Extensions__item__extensionValue,
        __BAPRoutingID_iE_Extensions__item_,
        _BAPRoutingID_iE_Extensions,
        BAPRoutingID,
        BAPRoutingIDExtIEs,
        _BCBearerContextF1U_TNLInfo_locationindpendent,
        _BCBearerContextF1U_TNLInfo_locationdependent,
        ___BCBearerContextF1U_TNLInfo_choice_extension_id_tab,
        __BCBearerContextF1U_TNLInfo_choice_extension_id,
        ___BCBearerContextF1U_TNLInfo_choice_extension_criticality_tab,
        __BCBearerContextF1U_TNLInfo_choice_extension_criticality,
        ___BCBearerContextF1U_TNLInfo_choice_extension_value_tab,
        __BCBearerContextF1U_TNLInfo_choice_extension_value,
        _BCBearerContextF1U_TNLInfo_choice_extension,
        BCBearerContextF1U_TNLInfo,
        BCBearerContextF1U_TNLInfo_ExtIEs,
        BitRate,
        BearerTypeChange,
        BHRLCChannelID,
        _BHChannels_FailedToBeModified_Item_bHRLCChannelID,
        _BHChannels_FailedToBeModified_Item_cause,
        ____BHChannels_FailedToBeModified_Item_iE_Extensions__item__id_tab,
        ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__id,
        ____BHChannels_FailedToBeModified_Item_iE_Extensions__item__criticality_tab,
        ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__criticality,
        ____BHChannels_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab,
        ___BHChannels_FailedToBeModified_Item_iE_Extensions__item__extensionValue,
        __BHChannels_FailedToBeModified_Item_iE_Extensions__item_,
        _BHChannels_FailedToBeModified_Item_iE_Extensions,
        BHChannels_FailedToBeModified_Item,
        BHChannels_FailedToBeModified_ItemExtIEs,
        _BHChannels_FailedToBeSetup_Item_bHRLCChannelID,
        _BHChannels_FailedToBeSetup_Item_cause,
        ____BHChannels_FailedToBeSetup_Item_iE_Extensions__item__id_tab,
        ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__id,
        ____BHChannels_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab,
        ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__criticality,
        ____BHChannels_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab,
        ___BHChannels_FailedToBeSetup_Item_iE_Extensions__item__extensionValue,
        __BHChannels_FailedToBeSetup_Item_iE_Extensions__item_,
        _BHChannels_FailedToBeSetup_Item_iE_Extensions,
        BHChannels_FailedToBeSetup_Item,
        BHChannels_FailedToBeSetup_ItemExtIEs,
        _BHChannels_FailedToBeSetupMod_Item_bHRLCChannelID,
        _BHChannels_FailedToBeSetupMod_Item_cause,
        ____BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab,
        ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__id,
        ____BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab,
        ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__criticality,
        ____BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue,
        __BHChannels_FailedToBeSetupMod_Item_iE_Extensions__item_,
        _BHChannels_FailedToBeSetupMod_Item_iE_Extensions,
        BHChannels_FailedToBeSetupMod_Item,
        BHChannels_FailedToBeSetupMod_ItemExtIEs,
        _BHChannels_Modified_Item_bHRLCChannelID,
        ____BHChannels_Modified_Item_iE_Extensions__item__id_tab,
        ___BHChannels_Modified_Item_iE_Extensions__item__id,
        ____BHChannels_Modified_Item_iE_Extensions__item__criticality_tab,
        ___BHChannels_Modified_Item_iE_Extensions__item__criticality,
        ____BHChannels_Modified_Item_iE_Extensions__item__extensionValue_tab,
        ___BHChannels_Modified_Item_iE_Extensions__item__extensionValue,
        __BHChannels_Modified_Item_iE_Extensions__item_,
        _BHChannels_Modified_Item_iE_Extensions,
        BHChannels_Modified_Item,
        BHChannels_Modified_ItemExtIEs,
        _BHChannels_Required_ToBeReleased_Item_bHRLCChannelID,
        ____BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__id_tab,
        ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__id,
        ____BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab,
        ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__criticality,
        ____BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab,
        ___BHChannels_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue,
        __BHChannels_Required_ToBeReleased_Item_iE_Extensions__item_,
        _BHChannels_Required_ToBeReleased_Item_iE_Extensions,
        BHChannels_Required_ToBeReleased_Item,
        BHChannels_Required_ToBeReleased_ItemExtIEs,
        _BHChannels_Setup_Item_bHRLCChannelID,
        ____BHChannels_Setup_Item_iE_Extensions__item__id_tab,
        ___BHChannels_Setup_Item_iE_Extensions__item__id,
        ____BHChannels_Setup_Item_iE_Extensions__item__criticality_tab,
        ___BHChannels_Setup_Item_iE_Extensions__item__criticality,
        ____BHChannels_Setup_Item_iE_Extensions__item__extensionValue_tab,
        ___BHChannels_Setup_Item_iE_Extensions__item__extensionValue,
        __BHChannels_Setup_Item_iE_Extensions__item_,
        _BHChannels_Setup_Item_iE_Extensions,
        BHChannels_Setup_Item,
        BHChannels_Setup_ItemExtIEs,
        _BHChannels_SetupMod_Item_bHRLCChannelID,
        ____BHChannels_SetupMod_Item_iE_Extensions__item__id_tab,
        ___BHChannels_SetupMod_Item_iE_Extensions__item__id,
        ____BHChannels_SetupMod_Item_iE_Extensions__item__criticality_tab,
        ___BHChannels_SetupMod_Item_iE_Extensions__item__criticality,
        ____BHChannels_SetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___BHChannels_SetupMod_Item_iE_Extensions__item__extensionValue,
        __BHChannels_SetupMod_Item_iE_Extensions__item_,
        _BHChannels_SetupMod_Item_iE_Extensions,
        BHChannels_SetupMod_Item,
        BHChannels_SetupMod_ItemExtIEs,
        _BHChannels_ToBeModified_Item_bHRLCChannelID,
        _BHChannels_ToBeModified_Item_bHQoSInformation,
        _BHChannels_ToBeModified_Item_rLCmode,
        _BHChannels_ToBeModified_Item_bAPCtrlPDUChannel,
        _BHChannels_ToBeModified_Item_trafficMappingInfo,
        ____BHChannels_ToBeModified_Item_iE_Extensions__item__id_tab,
        ___BHChannels_ToBeModified_Item_iE_Extensions__item__id,
        ____BHChannels_ToBeModified_Item_iE_Extensions__item__criticality_tab,
        ___BHChannels_ToBeModified_Item_iE_Extensions__item__criticality,
        ____BHChannels_ToBeModified_Item_iE_Extensions__item__extensionValue_tab,
        ___BHChannels_ToBeModified_Item_iE_Extensions__item__extensionValue,
        __BHChannels_ToBeModified_Item_iE_Extensions__item_,
        _BHChannels_ToBeModified_Item_iE_Extensions,
        BHChannels_ToBeModified_Item,
        BHChannels_ToBeModified_ItemExtIEs,
        _BHChannels_ToBeReleased_Item_bHRLCChannelID,
        ____BHChannels_ToBeReleased_Item_iE_Extensions__item__id_tab,
        ___BHChannels_ToBeReleased_Item_iE_Extensions__item__id,
        ____BHChannels_ToBeReleased_Item_iE_Extensions__item__criticality_tab,
        ___BHChannels_ToBeReleased_Item_iE_Extensions__item__criticality,
        ____BHChannels_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab,
        ___BHChannels_ToBeReleased_Item_iE_Extensions__item__extensionValue,
        __BHChannels_ToBeReleased_Item_iE_Extensions__item_,
        _BHChannels_ToBeReleased_Item_iE_Extensions,
        BHChannels_ToBeReleased_Item,
        BHChannels_ToBeReleased_ItemExtIEs,
        _BHChannels_ToBeSetup_Item_bHRLCChannelID,
        _BHChannels_ToBeSetup_Item_bHQoSInformation,
        _BHChannels_ToBeSetup_Item_rLCmode,
        _BHChannels_ToBeSetup_Item_bAPCtrlPDUChannel,
        _BHChannels_ToBeSetup_Item_trafficMappingInfo,
        ____BHChannels_ToBeSetup_Item_iE_Extensions__item__id_tab,
        ___BHChannels_ToBeSetup_Item_iE_Extensions__item__id,
        ____BHChannels_ToBeSetup_Item_iE_Extensions__item__criticality_tab,
        ___BHChannels_ToBeSetup_Item_iE_Extensions__item__criticality,
        ____BHChannels_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab,
        ___BHChannels_ToBeSetup_Item_iE_Extensions__item__extensionValue,
        __BHChannels_ToBeSetup_Item_iE_Extensions__item_,
        _BHChannels_ToBeSetup_Item_iE_Extensions,
        BHChannels_ToBeSetup_Item,
        BHChannels_ToBeSetup_ItemExtIEs,
        _BHChannels_ToBeSetupMod_Item_bHRLCChannelID,
        _BHChannels_ToBeSetupMod_Item_bHQoSInformation,
        _BHChannels_ToBeSetupMod_Item_rLCmode,
        _BHChannels_ToBeSetupMod_Item_bAPCtrlPDUChannel,
        _BHChannels_ToBeSetupMod_Item_trafficMappingInfo,
        ____BHChannels_ToBeSetupMod_Item_iE_Extensions__item__id_tab,
        ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__id,
        ____BHChannels_ToBeSetupMod_Item_iE_Extensions__item__criticality_tab,
        ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__criticality,
        ____BHChannels_ToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___BHChannels_ToBeSetupMod_Item_iE_Extensions__item__extensionValue,
        __BHChannels_ToBeSetupMod_Item_iE_Extensions__item_,
        _BHChannels_ToBeSetupMod_Item_iE_Extensions,
        BHChannels_ToBeSetupMod_Item,
        BHChannels_ToBeSetupMod_ItemExtIEs,
        _BHInfo_bAProutingID,
        _BHInfo_egressBHRLCCHList,
        ____BHInfo_iE_Extensions__item__id_tab,
        _____BHInfo_iE_Extensions__item__id_tab_val_Extension_0,
        ___BHInfo_iE_Extensions__item__id,
        ___BHInfo_iE_Extensions__item__criticality,
        ___BHInfo_iE_Extensions__item__extensionValue,
        __BHInfo_iE_Extensions__item_,
        _BHInfo_iE_Extensions,
        BHInfo,
        BHInfo_ExtIEs,
        _BHInfo_ExtIEs_val_Extension_0,
        _BHQoSInformation_bHRLCCHQoS,
        _BHQoSInformation_eUTRANBHRLCCHQoS,
        _BHQoSInformation_cPTrafficType,
        ___BHQoSInformation_choice_extension_id_tab,
        __BHQoSInformation_choice_extension_id,
        ___BHQoSInformation_choice_extension_criticality_tab,
        __BHQoSInformation_choice_extension_criticality,
        ___BHQoSInformation_choice_extension_value_tab,
        __BHQoSInformation_choice_extension_value,
        _BHQoSInformation_choice_extension,
        BHQoSInformation,
        BHQoSInformation_ExtIEs,
        _BHRLCCHList__item_,
        BHRLCCHList,
        _BHRLCCHItem_bHRLCChannelID,
        ____BHRLCCHItem_iE_Extensions__item__id_tab,
        ___BHRLCCHItem_iE_Extensions__item__id,
        ____BHRLCCHItem_iE_Extensions__item__criticality_tab,
        ___BHRLCCHItem_iE_Extensions__item__criticality,
        ____BHRLCCHItem_iE_Extensions__item__extensionValue_tab,
        ___BHRLCCHItem_iE_Extensions__item__extensionValue,
        __BHRLCCHItem_iE_Extensions__item_,
        _BHRLCCHItem_iE_Extensions,
        BHRLCCHItem,
        BHRLCCHItemExtIEs,
        _BH_Routing_Information_Added_List_Item_bAPRoutingID,
        _BH_Routing_Information_Added_List_Item_nextHopBAPAddress,
        ____BH_Routing_Information_Added_List_Item_iE_Extensions__item__id_tab,
        _____BH_Routing_Information_Added_List_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__id,
        ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__criticality,
        ___BH_Routing_Information_Added_List_Item_iE_Extensions__item__extensionValue,
        __BH_Routing_Information_Added_List_Item_iE_Extensions__item_,
        _BH_Routing_Information_Added_List_Item_iE_Extensions,
        BH_Routing_Information_Added_List_Item,
        BH_Routing_Information_Added_List_ItemExtIEs,
        _BH_Routing_Information_Added_List_ItemExtIEs_val_Extension_0,
        _BH_Routing_Information_Removed_List_Item_bAPRoutingID,
        ____BH_Routing_Information_Removed_List_Item_iE_Extensions__item__id_tab,
        ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__id,
        ____BH_Routing_Information_Removed_List_Item_iE_Extensions__item__criticality_tab,
        ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__criticality,
        ____BH_Routing_Information_Removed_List_Item_iE_Extensions__item__extensionValue_tab,
        ___BH_Routing_Information_Removed_List_Item_iE_Extensions__item__extensionValue,
        __BH_Routing_Information_Removed_List_Item_iE_Extensions__item_,
        _BH_Routing_Information_Removed_List_Item_iE_Extensions,
        BH_Routing_Information_Removed_List_Item,
        BH_Routing_Information_Removed_List_ItemExtIEs,
        _BPLMN_ID_Info_List__item_,
        BPLMN_ID_Info_List,
        _BPLMN_ID_Info_Item_pLMN_Identity_List,
        _BPLMN_ID_Info_Item_extended_PLMN_Identity_List,
        _BPLMN_ID_Info_Item_fiveGS_TAC,
        _BPLMN_ID_Info_Item_nr_cell_ID,
        _BPLMN_ID_Info_Item_ranac,
        ____BPLMN_ID_Info_Item_iE_Extensions__item__id_tab,
        _____BPLMN_ID_Info_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____BPLMN_ID_Info_Item_iE_Extensions__item__id_tab_val_Extension_1,
        ___BPLMN_ID_Info_Item_iE_Extensions__item__id,
        ___BPLMN_ID_Info_Item_iE_Extensions__item__criticality,
        ___BPLMN_ID_Info_Item_iE_Extensions__item__extensionValue,
        __BPLMN_ID_Info_Item_iE_Extensions__item_,
        _BPLMN_ID_Info_Item_iE_Extensions,
        BPLMN_ID_Info_Item,
        BPLMN_ID_Info_ItemExtIEs,
        _BPLMN_ID_Info_ItemExtIEs_val_Extension_0,
        _BPLMN_ID_Info_ItemExtIEs_val_Extension_1,
        _ServedPLMNs_List__item_,
        ServedPLMNs_List,
        _ServedPLMNs_Item_pLMN_Identity,
        ____ServedPLMNs_Item_iE_Extensions__item__id_tab,
        _____ServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____ServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____ServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_2,
        _____ServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_3,
        ___ServedPLMNs_Item_iE_Extensions__item__id,
        ___ServedPLMNs_Item_iE_Extensions__item__criticality,
        ___ServedPLMNs_Item_iE_Extensions__item__extensionValue,
        __ServedPLMNs_Item_iE_Extensions__item_,
        _ServedPLMNs_Item_iE_Extensions,
        ServedPLMNs_Item,
        ServedPLMNs_ItemExtIEs,
        _ServedPLMNs_ItemExtIEs_val_Extension_0,
        _ServedPLMNs_ItemExtIEs_val_Extension_1,
        _ServedPLMNs_ItemExtIEs_val_Extension_2,
        _ServedPLMNs_ItemExtIEs_val_Extension_3,
        _BroadcastCAGList__item_,
        BroadcastCAGList,
        _BroadcastMRBs_FailedToBeModified_Item_mRB_ID,
        _BroadcastMRBs_FailedToBeModified_Item_cause,
        ____BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__id_tab,
        ___BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__id,
        ____BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__criticality_tab,
        ___BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__criticality,
        ____BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab,
        ___BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue,
        __BroadcastMRBs_FailedToBeModified_Item_iE_Extensions__item_,
        _BroadcastMRBs_FailedToBeModified_Item_iE_Extensions,
        BroadcastMRBs_FailedToBeModified_Item,
        BroadcastMRBs_FailedtoBeModified_Item_ExtIEs,
        _BroadcastMRBs_FailedToBeSetup_Item_mRB_ID,
        _BroadcastMRBs_FailedToBeSetup_Item_cause,
        ____BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab,
        ___BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__id,
        ____BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab,
        ___BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality,
        ____BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab,
        ___BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue,
        __BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions__item_,
        _BroadcastMRBs_FailedToBeSetup_Item_iE_Extensions,
        BroadcastMRBs_FailedToBeSetup_Item,
        BroadcastMRBs_FailedToBeSetup_Item_ExtIEs,
        _BroadcastMRBs_FailedToBeSetupMod_Item_mRB_ID,
        _BroadcastMRBs_FailedToBeSetupMod_Item_cause,
        ____BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab,
        ___BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id,
        ____BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab,
        ___BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality,
        ____BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue,
        __BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item_,
        _BroadcastMRBs_FailedToBeSetupMod_Item_iE_Extensions,
        BroadcastMRBs_FailedToBeSetupMod_Item,
        BroadcastMRBs_FailedToBeSetupMod_Item_ExtIEs,
        _BroadcastMRBs_Modified_Item_mRB_ID,
        _BroadcastMRBs_Modified_Item_bcBearerCtxtF1U_TNLInfoatDU,
        ____BroadcastMRBs_Modified_Item_iE_Extensions__item__id_tab,
        ___BroadcastMRBs_Modified_Item_iE_Extensions__item__id,
        ____BroadcastMRBs_Modified_Item_iE_Extensions__item__criticality_tab,
        ___BroadcastMRBs_Modified_Item_iE_Extensions__item__criticality,
        ____BroadcastMRBs_Modified_Item_iE_Extensions__item__extensionValue_tab,
        ___BroadcastMRBs_Modified_Item_iE_Extensions__item__extensionValue,
        __BroadcastMRBs_Modified_Item_iE_Extensions__item_,
        _BroadcastMRBs_Modified_Item_iE_Extensions,
        BroadcastMRBs_Modified_Item,
        BroadcastMRBs_Modified_Item_ExtIEs,
        _BroadcastMRBs_Setup_Item_mRB_ID,
        _BroadcastMRBs_Setup_Item_bcBearerCtxtF1U_TNLInfoatDU,
        ____BroadcastMRBs_Setup_Item_iE_Extensions__item__id_tab,
        ___BroadcastMRBs_Setup_Item_iE_Extensions__item__id,
        ____BroadcastMRBs_Setup_Item_iE_Extensions__item__criticality_tab,
        ___BroadcastMRBs_Setup_Item_iE_Extensions__item__criticality,
        ____BroadcastMRBs_Setup_Item_iE_Extensions__item__extensionValue_tab,
        ___BroadcastMRBs_Setup_Item_iE_Extensions__item__extensionValue,
        __BroadcastMRBs_Setup_Item_iE_Extensions__item_,
        _BroadcastMRBs_Setup_Item_iE_Extensions,
        BroadcastMRBs_Setup_Item,
        BroadcastMRBs_Setup_Item_ExtIEs,
        _BroadcastMRBs_SetupMod_Item_mRB_ID,
        _BroadcastMRBs_SetupMod_Item_bcBearerCtxtF1U_TNLInfoatDU,
        ____BroadcastMRBs_SetupMod_Item_iE_Extensions__item__id_tab,
        ___BroadcastMRBs_SetupMod_Item_iE_Extensions__item__id,
        ____BroadcastMRBs_SetupMod_Item_iE_Extensions__item__criticality_tab,
        ___BroadcastMRBs_SetupMod_Item_iE_Extensions__item__criticality,
        ____BroadcastMRBs_SetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___BroadcastMRBs_SetupMod_Item_iE_Extensions__item__extensionValue,
        __BroadcastMRBs_SetupMod_Item_iE_Extensions__item_,
        _BroadcastMRBs_SetupMod_Item_iE_Extensions,
        BroadcastMRBs_SetupMod_Item,
        BroadcastMRBs_SetupMod_Item_ExtIEs,
        _BroadcastMRBs_ToBeModified_Item_mRB_ID,
        _BroadcastMRBs_ToBeModified_Item_mRB_QoSInformation,
        _BroadcastMRBs_ToBeModified_Item_mBS_Flows_Mapped_To_MRB_List,
        _BroadcastMRBs_ToBeModified_Item_bcBearerCtxtF1U_TNLInfoatCU,
        ____BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__id_tab,
        ___BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__id,
        ____BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__criticality_tab,
        ___BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__criticality,
        ____BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__extensionValue_tab,
        ___BroadcastMRBs_ToBeModified_Item_iE_Extensions__item__extensionValue,
        __BroadcastMRBs_ToBeModified_Item_iE_Extensions__item_,
        _BroadcastMRBs_ToBeModified_Item_iE_Extensions,
        BroadcastMRBs_ToBeModified_Item,
        BroadcastMRBs_ToBeModified_Item_ExtIEs,
        _BroadcastMRBs_ToBeReleased_Item_mRB_ID,
        ____BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__id_tab,
        ___BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__id,
        ____BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab,
        ___BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality,
        ____BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab,
        ___BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue,
        __BroadcastMRBs_ToBeReleased_Item_iE_Extensions__item_,
        _BroadcastMRBs_ToBeReleased_Item_iE_Extensions,
        BroadcastMRBs_ToBeReleased_Item,
        BroadcastMRBs_ToBeReleased_ItemExtIEs,
        _BroadcastMRBs_ToBeSetup_Item_mRB_ID,
        _BroadcastMRBs_ToBeSetup_Item_mRB_QoSInformation,
        _BroadcastMRBs_ToBeSetup_Item_mBS_Flows_Mapped_To_MRB_List,
        _BroadcastMRBs_ToBeSetup_Item_bcBearerCtxtF1U_TNLInfoatCU,
        ____BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__id_tab,
        ___BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__id,
        ____BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality_tab,
        ___BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality,
        ____BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab,
        ___BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue,
        __BroadcastMRBs_ToBeSetup_Item_iE_Extensions__item_,
        _BroadcastMRBs_ToBeSetup_Item_iE_Extensions,
        BroadcastMRBs_ToBeSetup_Item,
        BroadcastMRBs_ToBeSetup_Item_ExtIEs,
        _BroadcastMRBs_ToBeSetupMod_Item_mRB_ID,
        _BroadcastMRBs_ToBeSetupMod_Item_mRB_QoSInformation,
        _BroadcastMRBs_ToBeSetupMod_Item_mBS_Flows_Mapped_To_MRB_List,
        _BroadcastMRBs_ToBeSetupMod_Item_bcBearerCtxtF1U_TNLInfoatCU,
        ____BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab,
        ___BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__id,
        ____BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality_tab,
        ___BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality,
        ____BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue,
        __BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions__item_,
        _BroadcastMRBs_ToBeSetupMod_Item_iE_Extensions,
        BroadcastMRBs_ToBeSetupMod_Item,
        BroadcastMRBs_ToBeSetupMod_Item_ExtIEs,
        _BroadcastNIDList__item_,
        BroadcastNIDList,
        _BroadcastSNPN_ID_List__item_,
        BroadcastSNPN_ID_List,
        _BroadcastSNPN_ID_List_Item_pLMN_Identity,
        _BroadcastSNPN_ID_List_Item_broadcastNIDList,
        ____BroadcastSNPN_ID_List_Item_iE_Extensions__item__id_tab,
        ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__id,
        ____BroadcastSNPN_ID_List_Item_iE_Extensions__item__criticality_tab,
        ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__criticality,
        ____BroadcastSNPN_ID_List_Item_iE_Extensions__item__extensionValue_tab,
        ___BroadcastSNPN_ID_List_Item_iE_Extensions__item__extensionValue,
        __BroadcastSNPN_ID_List_Item_iE_Extensions__item_,
        _BroadcastSNPN_ID_List_Item_iE_Extensions,
        BroadcastSNPN_ID_List_Item,
        BroadcastSNPN_ID_List_ItemExtIEs,
        _BroadcastPNI_NPN_ID_List__item_,
        BroadcastPNI_NPN_ID_List,
        _BroadcastPNI_NPN_ID_List_Item_pLMN_Identity,
        _BroadcastPNI_NPN_ID_List_Item_broadcastCAGList,
        ____BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__id_tab,
        ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__id,
        ____BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__criticality_tab,
        ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__criticality,
        ____BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__extensionValue_tab,
        ___BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item__extensionValue,
        __BroadcastPNI_NPN_ID_List_Item_iE_Extensions__item_,
        _BroadcastPNI_NPN_ID_List_Item_iE_Extensions,
        BroadcastPNI_NPN_ID_List_Item,
        BroadcastPNI_NPN_ID_List_ItemExtIEs,
        _BroadcastAreaScope_completeSuccess,
        _BroadcastAreaScope_partialSuccess,
        ___BroadcastAreaScope_choice_extension_id_tab,
        __BroadcastAreaScope_choice_extension_id,
        ___BroadcastAreaScope_choice_extension_criticality_tab,
        __BroadcastAreaScope_choice_extension_criticality,
        ___BroadcastAreaScope_choice_extension_value_tab,
        __BroadcastAreaScope_choice_extension_value,
        _BroadcastAreaScope_choice_extension,
        BroadcastAreaScope,
        BroadcastAreaScope_ExtIEs,
        _BroadcastCellList__item_,
        BroadcastCellList,
        _Broadcast_Cell_List_Item_cellID,
        ____Broadcast_Cell_List_Item_iE_Extensions__item__id_tab,
        ___Broadcast_Cell_List_Item_iE_Extensions__item__id,
        ____Broadcast_Cell_List_Item_iE_Extensions__item__criticality_tab,
        ___Broadcast_Cell_List_Item_iE_Extensions__item__criticality,
        ____Broadcast_Cell_List_Item_iE_Extensions__item__extensionValue_tab,
        ___Broadcast_Cell_List_Item_iE_Extensions__item__extensionValue,
        __Broadcast_Cell_List_Item_iE_Extensions__item_,
        _Broadcast_Cell_List_Item_iE_Extensions,
        Broadcast_Cell_List_Item,
        Broadcast_Cell_List_ItemExtIEs,
        BufferSizeThresh,
        BurstArrivalTime,
        CAGID,
        Cancel_all_Warning_Messages_Indicator,
        _Candidate_SpCell_Item_candidate_SpCell_ID,
        ____Candidate_SpCell_Item_iE_Extensions__item__id_tab,
        ___Candidate_SpCell_Item_iE_Extensions__item__id,
        ____Candidate_SpCell_Item_iE_Extensions__item__criticality_tab,
        ___Candidate_SpCell_Item_iE_Extensions__item__criticality,
        ____Candidate_SpCell_Item_iE_Extensions__item__extensionValue_tab,
        ___Candidate_SpCell_Item_iE_Extensions__item__extensionValue,
        __Candidate_SpCell_Item_iE_Extensions__item_,
        _Candidate_SpCell_Item_iE_Extensions,
        Candidate_SpCell_Item,
        Candidate_SpCell_ItemExtIEs,
        _CapacityValue_capacityValue,
        _CapacityValue_sSBAreaCapacityValueList,
        ____CapacityValue_iE_Extensions__item__id_tab,
        ___CapacityValue_iE_Extensions__item__id,
        ____CapacityValue_iE_Extensions__item__criticality_tab,
        ___CapacityValue_iE_Extensions__item__criticality,
        ____CapacityValue_iE_Extensions__item__extensionValue_tab,
        ___CapacityValue_iE_Extensions__item__extensionValue,
        __CapacityValue_iE_Extensions__item_,
        _CapacityValue_iE_Extensions,
        CapacityValue,
        CapacityValue_ExtIEs,
        _Cause_radioNetwork,
        _Cause_transport,
        _Cause_protocol,
        _Cause_misc,
        ___Cause_choice_extension_id_tab,
        __Cause_choice_extension_id,
        ___Cause_choice_extension_criticality_tab,
        __Cause_choice_extension_criticality,
        ___Cause_choice_extension_value_tab,
        __Cause_choice_extension_value,
        _Cause_choice_extension,
        Cause,
        Cause_ExtIEs,
        CauseMisc,
        CauseProtocol,
        CauseRadioNetwork,
        CauseTransport,
        CellGroupConfig,
        CellCapacityClassValue,
        Cell_Direction,
        _CellMeasurementResultList__item_,
        CellMeasurementResultList,
        _CellMeasurementResultItem_cellID,
        _CellMeasurementResultItem_radioResourceStatus,
        _CellMeasurementResultItem_compositeAvailableCapacityGroup,
        _CellMeasurementResultItem_sliceAvailableCapacity,
        _CellMeasurementResultItem_numberofActiveUEs,
        ____CellMeasurementResultItem_iE_Extensions__item__id_tab,
        _____CellMeasurementResultItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___CellMeasurementResultItem_iE_Extensions__item__id,
        ___CellMeasurementResultItem_iE_Extensions__item__criticality,
        ___CellMeasurementResultItem_iE_Extensions__item__extensionValue,
        __CellMeasurementResultItem_iE_Extensions__item_,
        _CellMeasurementResultItem_iE_Extensions,
        CellMeasurementResultItem,
        CellMeasurementResultItem_ExtIEs,
        _CellMeasurementResultItem_ExtIEs_val_Extension_0,
        Cell_Portion_ID,
        _CellsForSON_List__item_,
        CellsForSON_List,
        _CellsForSON_Item_nRCGI,
        _CellsForSON_Item_neighbourNR_CellsForSON_List,
        ____CellsForSON_Item_iE_Extensions__item__id_tab,
        ___CellsForSON_Item_iE_Extensions__item__id,
        ____CellsForSON_Item_iE_Extensions__item__criticality_tab,
        ___CellsForSON_Item_iE_Extensions__item__criticality,
        ____CellsForSON_Item_iE_Extensions__item__extensionValue_tab,
        ___CellsForSON_Item_iE_Extensions__item__extensionValue,
        __CellsForSON_Item_iE_Extensions__item_,
        _CellsForSON_Item_iE_Extensions,
        CellsForSON_Item,
        CellsForSON_Item_ExtIEs,
        _Cells_Failed_to_be_Activated_List_Item_nRCGI,
        _Cells_Failed_to_be_Activated_List_Item_cause,
        ____Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__id_tab,
        ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__id,
        ____Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__criticality_tab,
        ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__criticality,
        ____Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__extensionValue_tab,
        ___Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item__extensionValue,
        __Cells_Failed_to_be_Activated_List_Item_iE_Extensions__item_,
        _Cells_Failed_to_be_Activated_List_Item_iE_Extensions,
        Cells_Failed_to_be_Activated_List_Item,
        Cells_Failed_to_be_Activated_List_ItemExtIEs,
        _Cells_Status_Item_nRCGI,
        _Cells_Status_Item_service_status,
        ____Cells_Status_Item_iE_Extensions__item__id_tab,
        ___Cells_Status_Item_iE_Extensions__item__id,
        ____Cells_Status_Item_iE_Extensions__item__criticality_tab,
        ___Cells_Status_Item_iE_Extensions__item__criticality,
        ____Cells_Status_Item_iE_Extensions__item__extensionValue_tab,
        ___Cells_Status_Item_iE_Extensions__item__extensionValue,
        __Cells_Status_Item_iE_Extensions__item_,
        _Cells_Status_Item_iE_Extensions,
        Cells_Status_Item,
        Cells_Status_ItemExtIEs,
        _Cells_To_Be_Broadcast_Item_nRCGI,
        ____Cells_To_Be_Broadcast_Item_iE_Extensions__item__id_tab,
        ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__id,
        ____Cells_To_Be_Broadcast_Item_iE_Extensions__item__criticality_tab,
        ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__criticality,
        ____Cells_To_Be_Broadcast_Item_iE_Extensions__item__extensionValue_tab,
        ___Cells_To_Be_Broadcast_Item_iE_Extensions__item__extensionValue,
        __Cells_To_Be_Broadcast_Item_iE_Extensions__item_,
        _Cells_To_Be_Broadcast_Item_iE_Extensions,
        Cells_To_Be_Broadcast_Item,
        Cells_To_Be_Broadcast_ItemExtIEs,
        _Cells_Broadcast_Completed_Item_nRCGI,
        ____Cells_Broadcast_Completed_Item_iE_Extensions__item__id_tab,
        ___Cells_Broadcast_Completed_Item_iE_Extensions__item__id,
        ____Cells_Broadcast_Completed_Item_iE_Extensions__item__criticality_tab,
        ___Cells_Broadcast_Completed_Item_iE_Extensions__item__criticality,
        ____Cells_Broadcast_Completed_Item_iE_Extensions__item__extensionValue_tab,
        ___Cells_Broadcast_Completed_Item_iE_Extensions__item__extensionValue,
        __Cells_Broadcast_Completed_Item_iE_Extensions__item_,
        _Cells_Broadcast_Completed_Item_iE_Extensions,
        Cells_Broadcast_Completed_Item,
        Cells_Broadcast_Completed_ItemExtIEs,
        _Broadcast_To_Be_Cancelled_Item_nRCGI,
        ____Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__id_tab,
        ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__id,
        ____Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__criticality_tab,
        ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__criticality,
        ____Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__extensionValue_tab,
        ___Broadcast_To_Be_Cancelled_Item_iE_Extensions__item__extensionValue,
        __Broadcast_To_Be_Cancelled_Item_iE_Extensions__item_,
        _Broadcast_To_Be_Cancelled_Item_iE_Extensions,
        Broadcast_To_Be_Cancelled_Item,
        Broadcast_To_Be_Cancelled_ItemExtIEs,
        _Cells_Broadcast_Cancelled_Item_nRCGI,
        _Cells_Broadcast_Cancelled_Item_numberOfBroadcasts,
        ____Cells_Broadcast_Cancelled_Item_iE_Extensions__item__id_tab,
        ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__id,
        ____Cells_Broadcast_Cancelled_Item_iE_Extensions__item__criticality_tab,
        ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__criticality,
        ____Cells_Broadcast_Cancelled_Item_iE_Extensions__item__extensionValue_tab,
        ___Cells_Broadcast_Cancelled_Item_iE_Extensions__item__extensionValue,
        __Cells_Broadcast_Cancelled_Item_iE_Extensions__item_,
        _Cells_Broadcast_Cancelled_Item_iE_Extensions,
        Cells_Broadcast_Cancelled_Item,
        Cells_Broadcast_Cancelled_ItemExtIEs,
        _Cells_to_be_Activated_List_Item_nRCGI,
        _Cells_to_be_Activated_List_Item_nRPCI,
        ____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab,
        _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_2,
        _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_3,
        _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_4,
        _____Cells_to_be_Activated_List_Item_iE_Extensions__item__id_tab_val_Extension_5,
        ___Cells_to_be_Activated_List_Item_iE_Extensions__item__id,
        ___Cells_to_be_Activated_List_Item_iE_Extensions__item__criticality,
        ___Cells_to_be_Activated_List_Item_iE_Extensions__item__extensionValue,
        __Cells_to_be_Activated_List_Item_iE_Extensions__item_,
        _Cells_to_be_Activated_List_Item_iE_Extensions,
        Cells_to_be_Activated_List_Item,
        Cells_to_be_Activated_List_ItemExtIEs,
        _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_0,
        _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_1,
        _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_2,
        _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_3,
        _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_4,
        _Cells_to_be_Activated_List_ItemExtIEs_val_Extension_5,
        _Cells_to_be_Deactivated_List_Item_nRCGI,
        ____Cells_to_be_Deactivated_List_Item_iE_Extensions__item__id_tab,
        ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__id,
        ____Cells_to_be_Deactivated_List_Item_iE_Extensions__item__criticality_tab,
        ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__criticality,
        ____Cells_to_be_Deactivated_List_Item_iE_Extensions__item__extensionValue_tab,
        ___Cells_to_be_Deactivated_List_Item_iE_Extensions__item__extensionValue,
        __Cells_to_be_Deactivated_List_Item_iE_Extensions__item_,
        _Cells_to_be_Deactivated_List_Item_iE_Extensions,
        Cells_to_be_Deactivated_List_Item,
        Cells_to_be_Deactivated_List_ItemExtIEs,
        _Cells_to_be_Barred_Item_nRCGI,
        _Cells_to_be_Barred_Item_cellBarred,
        ____Cells_to_be_Barred_Item_iE_Extensions__item__id_tab,
        _____Cells_to_be_Barred_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___Cells_to_be_Barred_Item_iE_Extensions__item__id,
        ___Cells_to_be_Barred_Item_iE_Extensions__item__criticality,
        ___Cells_to_be_Barred_Item_iE_Extensions__item__extensionValue,
        __Cells_to_be_Barred_Item_iE_Extensions__item_,
        _Cells_to_be_Barred_Item_iE_Extensions,
        Cells_to_be_Barred_Item,
        Cells_to_be_Barred_Item_ExtIEs,
        _Cells_to_be_Barred_Item_ExtIEs_val_Extension_0,
        CellBarred,
        CellSize,
        _CellToReportList__item_,
        CellToReportList,
        _CellToReportItem_cellID,
        _CellToReportItem_sSBToReportList,
        _CellToReportItem_sliceToReportList,
        ____CellToReportItem_iE_Extensions__item__id_tab,
        ___CellToReportItem_iE_Extensions__item__id,
        ____CellToReportItem_iE_Extensions__item__criticality_tab,
        ___CellToReportItem_iE_Extensions__item__criticality,
        ____CellToReportItem_iE_Extensions__item__extensionValue_tab,
        ___CellToReportItem_iE_Extensions__item__extensionValue,
        __CellToReportItem_iE_Extensions__item_,
        _CellToReportItem_iE_Extensions,
        CellToReportItem,
        CellToReportItem_ExtIEs,
        _CellType_cellSize,
        ____CellType_iE_Extensions__item__id_tab,
        ___CellType_iE_Extensions__item__id,
        ____CellType_iE_Extensions__item__criticality_tab,
        ___CellType_iE_Extensions__item__criticality,
        ____CellType_iE_Extensions__item__extensionValue_tab,
        ___CellType_iE_Extensions__item__extensionValue,
        __CellType_iE_Extensions__item_,
        _CellType_iE_Extensions,
        CellType,
        CellType_ExtIEs,
        CellULConfigured,
        CG_SDTQueryIndication,
        CG_SDTKeptIndicator,
        CG_SDTindicatorSetup,
        CG_SDTindicatorMod,
        _CG_SDTSessionInfo_gNB_CU_UE_F1AP_ID,
        _CG_SDTSessionInfo_gNB_DU_UE_F1AP_ID,
        ____CG_SDTSessionInfo_iE_Extensions__item__id_tab,
        ___CG_SDTSessionInfo_iE_Extensions__item__id,
        ____CG_SDTSessionInfo_iE_Extensions__item__criticality_tab,
        ___CG_SDTSessionInfo_iE_Extensions__item__criticality,
        ____CG_SDTSessionInfo_iE_Extensions__item__extensionValue_tab,
        ___CG_SDTSessionInfo_iE_Extensions__item__extensionValue,
        __CG_SDTSessionInfo_iE_Extensions__item_,
        _CG_SDTSessionInfo_iE_Extensions,
        CG_SDTSessionInfo,
        CG_SDTSessionInfo_ExtIEs,
        ChannelOccupancyTimePercentage,
        _Child_IAB_Nodes_NA_Resource_List__item_,
        Child_IAB_Nodes_NA_Resource_List,
        _Child_IAB_Nodes_NA_Resource_List_Item_gNB_CU_UE_F1AP_ID,
        _Child_IAB_Nodes_NA_Resource_List_Item_gNB_DU_UE_F1AP_ID,
        _Child_IAB_Nodes_NA_Resource_List_Item_nA_Resource_Configuration_List,
        ____Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__id_tab,
        ___Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__id,
        ____Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__criticality_tab,
        ___Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__criticality,
        ____Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__extensionValue_tab,
        ___Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item__extensionValue,
        __Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions__item_,
        _Child_IAB_Nodes_NA_Resource_List_Item_iE_Extensions,
        Child_IAB_Nodes_NA_Resource_List_Item,
        Child_IAB_Nodes_NA_Resource_List_Item_ExtIEs,
        _Child_Node_Cells_List__item_,
        Child_Node_Cells_List,
        _Child_Node_Cells_List_Item_nRCGI,
        _Child_Node_Cells_List_Item_iAB_DU_Cell_Resource_Configuration_Mode_Info,
        _Child_Node_Cells_List_Item_iAB_STC_Info,
        _Child_Node_Cells_List_Item_rACH_Config_Common,
        _Child_Node_Cells_List_Item_rACH_Config_Common_IAB,
        _Child_Node_Cells_List_Item_cSI_RS_Configuration,
        _Child_Node_Cells_List_Item_sR_Configuration,
        _Child_Node_Cells_List_Item_pDCCH_ConfigSIB1,
        _Child_Node_Cells_List_Item_sCS_Common,
        _Child_Node_Cells_List_Item_multiplexingInfo,
        ____Child_Node_Cells_List_Item_iE_Extensions__item__id_tab,
        ___Child_Node_Cells_List_Item_iE_Extensions__item__id,
        ____Child_Node_Cells_List_Item_iE_Extensions__item__criticality_tab,
        ___Child_Node_Cells_List_Item_iE_Extensions__item__criticality,
        ____Child_Node_Cells_List_Item_iE_Extensions__item__extensionValue_tab,
        ___Child_Node_Cells_List_Item_iE_Extensions__item__extensionValue,
        __Child_Node_Cells_List_Item_iE_Extensions__item_,
        _Child_Node_Cells_List_Item_iE_Extensions,
        Child_Node_Cells_List_Item,
        Child_Node_Cells_List_Item_ExtIEs,
        _Child_Nodes_List__item_,
        Child_Nodes_List,
        _Child_Nodes_List_Item_gNB_CU_UE_F1AP_ID,
        _Child_Nodes_List_Item_gNB_DU_UE_F1AP_ID,
        _Child_Nodes_List_Item_child_Node_Cells_List,
        ____Child_Nodes_List_Item_iE_Extensions__item__id_tab,
        ___Child_Nodes_List_Item_iE_Extensions__item__id,
        ____Child_Nodes_List_Item_iE_Extensions__item__criticality_tab,
        ___Child_Nodes_List_Item_iE_Extensions__item__criticality,
        ____Child_Nodes_List_Item_iE_Extensions__item__extensionValue_tab,
        ___Child_Nodes_List_Item_iE_Extensions__item__extensionValue,
        __Child_Nodes_List_Item_iE_Extensions__item_,
        _Child_Nodes_List_Item_iE_Extensions,
        Child_Nodes_List_Item,
        Child_Nodes_List_Item_ExtIEs,
        CHOtrigger_InterDU,
        CHOtrigger_IntraDU,
        CNSubgroupID,
        _CNUEPagingIdentity_fiveG_S_TMSI,
        ___CNUEPagingIdentity_choice_extension_id_tab,
        __CNUEPagingIdentity_choice_extension_id,
        ___CNUEPagingIdentity_choice_extension_criticality_tab,
        __CNUEPagingIdentity_choice_extension_criticality,
        ___CNUEPagingIdentity_choice_extension_value_tab,
        __CNUEPagingIdentity_choice_extension_value,
        _CNUEPagingIdentity_choice_extension,
        CNUEPagingIdentity,
        CNUEPagingIdentity_ExtIEs,
        _CompositeAvailableCapacityGroup_compositeAvailableCapacityDownlink,
        _CompositeAvailableCapacityGroup_compositeAvailableCapacityUplink,
        ____CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab,
        _____CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab_val_Extension_0,
        ___CompositeAvailableCapacityGroup_iE_Extensions__item__id,
        ___CompositeAvailableCapacityGroup_iE_Extensions__item__criticality,
        ___CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue,
        __CompositeAvailableCapacityGroup_iE_Extensions__item_,
        _CompositeAvailableCapacityGroup_iE_Extensions,
        CompositeAvailableCapacityGroup,
        CompositeAvailableCapacityGroup_ExtIEs,
        _CompositeAvailableCapacityGroup_ExtIEs_val_Extension_0,
        _CompositeAvailableCapacity_cellCapacityClassValue,
        _CompositeAvailableCapacity_capacityValue,
        ____CompositeAvailableCapacity_iE_Extensions__item__id_tab,
        ___CompositeAvailableCapacity_iE_Extensions__item__id,
        ____CompositeAvailableCapacity_iE_Extensions__item__criticality_tab,
        ___CompositeAvailableCapacity_iE_Extensions__item__criticality,
        ____CompositeAvailableCapacity_iE_Extensions__item__extensionValue_tab,
        ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue,
        __CompositeAvailableCapacity_iE_Extensions__item_,
        _CompositeAvailableCapacity_iE_Extensions,
        CompositeAvailableCapacity,
        CompositeAvailableCapacity_ExtIEs,
        CHO_Probability,
        _ConditionalInterDUMobilityInformation_cho_trigger,
        _ConditionalInterDUMobilityInformation_targetgNB_DUUEF1APID,
        ____ConditionalInterDUMobilityInformation_iE_Extensions__item__id_tab,
        _____ConditionalInterDUMobilityInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___ConditionalInterDUMobilityInformation_iE_Extensions__item__id,
        ___ConditionalInterDUMobilityInformation_iE_Extensions__item__criticality,
        ___ConditionalInterDUMobilityInformation_iE_Extensions__item__extensionValue,
        __ConditionalInterDUMobilityInformation_iE_Extensions__item_,
        _ConditionalInterDUMobilityInformation_iE_Extensions,
        ConditionalInterDUMobilityInformation,
        ConditionalInterDUMobilityInformation_ExtIEs,
        _ConditionalInterDUMobilityInformation_ExtIEs_val_Extension_0,
        _ConditionalIntraDUMobilityInformation_cho_trigger,
        _ConditionalIntraDUMobilityInformation_targetCellsTocancel,
        ____ConditionalIntraDUMobilityInformation_iE_Extensions__item__id_tab,
        _____ConditionalIntraDUMobilityInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__id,
        ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__criticality,
        ___ConditionalIntraDUMobilityInformation_iE_Extensions__item__extensionValue,
        __ConditionalIntraDUMobilityInformation_iE_Extensions__item_,
        _ConditionalIntraDUMobilityInformation_iE_Extensions,
        ConditionalIntraDUMobilityInformation,
        ConditionalIntraDUMobilityInformation_ExtIEs,
        _ConditionalIntraDUMobilityInformation_ExtIEs_val_Extension_0,
        ConfigRestrictInfoDAPS,
        ConfiguredTACIndication,
        CoordinateID,
        _Coverage_Modification_Notification_coverage_Modification_List,
        ____Coverage_Modification_Notification_iE_Extensions__item__id_tab,
        ___Coverage_Modification_Notification_iE_Extensions__item__id,
        ____Coverage_Modification_Notification_iE_Extensions__item__criticality_tab,
        ___Coverage_Modification_Notification_iE_Extensions__item__criticality,
        ____Coverage_Modification_Notification_iE_Extensions__item__extensionValue_tab,
        ___Coverage_Modification_Notification_iE_Extensions__item__extensionValue,
        __Coverage_Modification_Notification_iE_Extensions__item_,
        _Coverage_Modification_Notification_iE_Extensions,
        Coverage_Modification_Notification,
        Coverage_Modification_Notification_ExtIEs,
        _Coverage_Modification_List__item_,
        Coverage_Modification_List,
        _Coverage_Modification_Item_nRCGI,
        _Coverage_Modification_Item_cellCoverageState,
        _Coverage_Modification_Item_sSBCoverageModificationList,
        ____Coverage_Modification_Item_iE_Extension__item__id_tab,
        ___Coverage_Modification_Item_iE_Extension__item__id,
        ____Coverage_Modification_Item_iE_Extension__item__criticality_tab,
        ___Coverage_Modification_Item_iE_Extension__item__criticality,
        ____Coverage_Modification_Item_iE_Extension__item__extensionValue_tab,
        ___Coverage_Modification_Item_iE_Extension__item__extensionValue,
        __Coverage_Modification_Item_iE_Extension__item_,
        _Coverage_Modification_Item_iE_Extension,
        Coverage_Modification_Item,
        Coverage_Modification_Item_ExtIEs,
        CellCoverageState,
        _CCO_Assistance_Information_cCO_issue_detection,
        _CCO_Assistance_Information_affectedCellsAndBeams_List,
        ____CCO_Assistance_Information_iE_Extensions__item__id_tab,
        ___CCO_Assistance_Information_iE_Extensions__item__id,
        ____CCO_Assistance_Information_iE_Extensions__item__criticality_tab,
        ___CCO_Assistance_Information_iE_Extensions__item__criticality,
        ____CCO_Assistance_Information_iE_Extensions__item__extensionValue_tab,
        ___CCO_Assistance_Information_iE_Extensions__item__extensionValue,
        __CCO_Assistance_Information_iE_Extensions__item_,
        _CCO_Assistance_Information_iE_Extensions,
        CCO_Assistance_Information,
        CCO_Assistance_Information_ExtIEs,
        CCO_issue_detection,
        _CP_TransportLayerAddress_endpoint_IP_address,
        _CP_TransportLayerAddress_endpoint_IP_address_and_port,
        ___CP_TransportLayerAddress_choice_extension_id_tab,
        __CP_TransportLayerAddress_choice_extension_id,
        ___CP_TransportLayerAddress_choice_extension_criticality_tab,
        __CP_TransportLayerAddress_choice_extension_criticality,
        ___CP_TransportLayerAddress_choice_extension_value_tab,
        __CP_TransportLayerAddress_choice_extension_value,
        _CP_TransportLayerAddress_choice_extension,
        CP_TransportLayerAddress,
        CP_TransportLayerAddress_ExtIEs,
        _CPACMCGInformation_cpac_trigger,
        _CPACMCGInformation_pscellid,
        ____CPACMCGInformation_iE_Extensions__item__id_tab,
        ___CPACMCGInformation_iE_Extensions__item__id,
        ____CPACMCGInformation_iE_Extensions__item__criticality_tab,
        ___CPACMCGInformation_iE_Extensions__item__criticality,
        ____CPACMCGInformation_iE_Extensions__item__extensionValue_tab,
        ___CPACMCGInformation_iE_Extensions__item__extensionValue,
        __CPACMCGInformation_iE_Extensions__item_,
        _CPACMCGInformation_iE_Extensions,
        CPACMCGInformation,
        CPACMCGInformation_ExtIEs,
        CPAC_trigger,
        CPTrafficType,
        _CriticalityDiagnostics_procedureCode,
        _CriticalityDiagnostics_triggeringMessage,
        _CriticalityDiagnostics_procedureCriticality,
        _CriticalityDiagnostics_transactionID,
        _CriticalityDiagnostics_iEsCriticalityDiagnostics,
        ____CriticalityDiagnostics_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__id,
        ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_iE_Extensions__item_,
        _CriticalityDiagnostics_iE_Extensions,
        CriticalityDiagnostics,
        CriticalityDiagnostics_ExtIEs,
        _CriticalityDiagnostics_IE_List__item_,
        CriticalityDiagnostics_IE_List,
        _CriticalityDiagnostics_IE_Item_iECriticality,
        _CriticalityDiagnostics_IE_Item_iE_ID,
        _CriticalityDiagnostics_IE_Item_typeOfError,
        ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id,
        ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_IE_Item_iE_Extensions__item_,
        _CriticalityDiagnostics_IE_Item_iE_Extensions,
        CriticalityDiagnostics_IE_Item,
        CriticalityDiagnostics_IE_Item_ExtIEs,
        C_RNTI,
        _CUDURadioInformationType_rIM,
        ___CUDURadioInformationType_choice_extension_id_tab,
        __CUDURadioInformationType_choice_extension_id,
        ___CUDURadioInformationType_choice_extension_criticality_tab,
        __CUDURadioInformationType_choice_extension_criticality,
        ___CUDURadioInformationType_choice_extension_value_tab,
        __CUDURadioInformationType_choice_extension_value,
        _CUDURadioInformationType_choice_extension,
        CUDURadioInformationType,
        CUDURadioInformationType_ExtIEs,
        _CUDURIMInformation_victimgNBSetID,
        _CUDURIMInformation_rIMRSDetectionStatus,
        ____CUDURIMInformation_iE_Extensions__item__id_tab,
        ___CUDURIMInformation_iE_Extensions__item__id,
        ____CUDURIMInformation_iE_Extensions__item__criticality_tab,
        ___CUDURIMInformation_iE_Extensions__item__criticality,
        ____CUDURIMInformation_iE_Extensions__item__extensionValue_tab,
        ___CUDURIMInformation_iE_Extensions__item__extensionValue,
        __CUDURIMInformation_iE_Extensions__item_,
        _CUDURIMInformation_iE_Extensions,
        CUDURIMInformation,
        CUDURIMInformation_ExtIEs,
        _CUtoDURRCInformation_cG_ConfigInfo,
        _CUtoDURRCInformation_uE_CapabilityRAT_ContainerList,
        _CUtoDURRCInformation_measConfig,
        ____CUtoDURRCInformation_iE_Extensions__item__id_tab,
        _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_0,
        _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_1,
        _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_2,
        _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_3,
        _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_4,
        _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_5,
        _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_6,
        _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_7,
        _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_8,
        _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_9,
        _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_10,
        _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_11,
        _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_12,
        _____CUtoDURRCInformation_iE_Extensions__item__id_tab_val_Extension_13,
        ___CUtoDURRCInformation_iE_Extensions__item__id,
        ___CUtoDURRCInformation_iE_Extensions__item__criticality,
        ___CUtoDURRCInformation_iE_Extensions__item__extensionValue,
        __CUtoDURRCInformation_iE_Extensions__item_,
        _CUtoDURRCInformation_iE_Extensions,
        CUtoDURRCInformation,
        CUtoDURRCInformation_ExtIEs,
        _CUtoDURRCInformation_ExtIEs_val_Extension_0,
        _CUtoDURRCInformation_ExtIEs_val_Extension_1,
        _CUtoDURRCInformation_ExtIEs_val_Extension_2,
        _CUtoDURRCInformation_ExtIEs_val_Extension_3,
        _CUtoDURRCInformation_ExtIEs_val_Extension_4,
        _CUtoDURRCInformation_ExtIEs_val_Extension_5,
        _CUtoDURRCInformation_ExtIEs_val_Extension_6,
        _CUtoDURRCInformation_ExtIEs_val_Extension_7,
        _CUtoDURRCInformation_ExtIEs_val_Extension_8,
        _CUtoDURRCInformation_ExtIEs_val_Extension_9,
        _CUtoDURRCInformation_ExtIEs_val_Extension_10,
        _CUtoDURRCInformation_ExtIEs_val_Extension_11,
        _CUtoDURRCInformation_ExtIEs_val_Extension_12,
        _CUtoDURRCInformation_ExtIEs_val_Extension_13,
        DAPS_HO_Status,
        DCBasedDuplicationConfigured,
        _Dedicated_SIDelivery_NeededUE_Item_gNB_CU_UE_F1AP_ID,
        _Dedicated_SIDelivery_NeededUE_Item_nRCGI,
        ____Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__id_tab,
        ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__id,
        ____Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__criticality_tab,
        ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__criticality,
        ____Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__extensionValue_tab,
        ___Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item__extensionValue,
        __Dedicated_SIDelivery_NeededUE_Item_iE_Extensions__item_,
        _Dedicated_SIDelivery_NeededUE_Item_iE_Extensions,
        Dedicated_SIDelivery_NeededUE_Item,
        DedicatedSIDeliveryNeededUE_Item_ExtIEs,
        _DL_PRS_prsid,
        _DL_PRS_dl_PRSResourceSetID,
        _DL_PRS_dl_PRSResourceID,
        ____DL_PRS_iE_Extensions__item__id_tab,
        ___DL_PRS_iE_Extensions__item__id,
        ____DL_PRS_iE_Extensions__item__criticality_tab,
        ___DL_PRS_iE_Extensions__item__criticality,
        ____DL_PRS_iE_Extensions__item__extensionValue_tab,
        ___DL_PRS_iE_Extensions__item__extensionValue,
        __DL_PRS_iE_Extensions__item_,
        _DL_PRS_iE_Extensions,
        DL_PRS,
        DL_PRS_ExtIEs,
        _DL_PRSMutingPattern_two,
        _DL_PRSMutingPattern_four,
        _DL_PRSMutingPattern_six,
        _DL_PRSMutingPattern_eight,
        _DL_PRSMutingPattern_sixteen,
        _DL_PRSMutingPattern_thirty_two,
        ___DL_PRSMutingPattern_choice_extension_id_tab,
        __DL_PRSMutingPattern_choice_extension_id,
        ___DL_PRSMutingPattern_choice_extension_criticality_tab,
        __DL_PRSMutingPattern_choice_extension_criticality,
        ___DL_PRSMutingPattern_choice_extension_value_tab,
        __DL_PRSMutingPattern_choice_extension_value,
        _DL_PRSMutingPattern_choice_extension,
        DL_PRSMutingPattern,
        DL_PRSMutingPattern_ExtIEs,
        __DLPRSResourceCoordinates_listofDL_PRSResourceSetARP__item_,
        _DLPRSResourceCoordinates_listofDL_PRSResourceSetARP,
        ____DLPRSResourceCoordinates_iE_Extensions__item__id_tab,
        ___DLPRSResourceCoordinates_iE_Extensions__item__id,
        ____DLPRSResourceCoordinates_iE_Extensions__item__criticality_tab,
        ___DLPRSResourceCoordinates_iE_Extensions__item__criticality,
        ____DLPRSResourceCoordinates_iE_Extensions__item__extensionValue_tab,
        ___DLPRSResourceCoordinates_iE_Extensions__item__extensionValue,
        __DLPRSResourceCoordinates_iE_Extensions__item_,
        _DLPRSResourceCoordinates_iE_Extensions,
        DLPRSResourceCoordinates,
        DLPRSResourceCoordinates_ExtIEs,
        _DLPRSResourceSetARP_dl_PRSResourceSetID,
        _DLPRSResourceSetARP_dL_PRSResourceSetARPLocation,
        __DLPRSResourceSetARP_listofDL_PRSResourceARP__item_,
        _DLPRSResourceSetARP_listofDL_PRSResourceARP,
        ____DLPRSResourceSetARP_iE_Extensions__item__id_tab,
        ___DLPRSResourceSetARP_iE_Extensions__item__id,
        ____DLPRSResourceSetARP_iE_Extensions__item__criticality_tab,
        ___DLPRSResourceSetARP_iE_Extensions__item__criticality,
        ____DLPRSResourceSetARP_iE_Extensions__item__extensionValue_tab,
        ___DLPRSResourceSetARP_iE_Extensions__item__extensionValue,
        __DLPRSResourceSetARP_iE_Extensions__item_,
        _DLPRSResourceSetARP_iE_Extensions,
        DLPRSResourceSetARP,
        DLPRSResourceSetARP_ExtIEs,
        _DL_PRSResourceSetARPLocation_relativeGeodeticLocation,
        _DL_PRSResourceSetARPLocation_relativeCartesianLocation,
        ___DL_PRSResourceSetARPLocation_choice_Extension_id_tab,
        __DL_PRSResourceSetARPLocation_choice_Extension_id,
        ___DL_PRSResourceSetARPLocation_choice_Extension_criticality_tab,
        __DL_PRSResourceSetARPLocation_choice_Extension_criticality,
        ___DL_PRSResourceSetARPLocation_choice_Extension_value_tab,
        __DL_PRSResourceSetARPLocation_choice_Extension_value,
        _DL_PRSResourceSetARPLocation_choice_Extension,
        DL_PRSResourceSetARPLocation,
        DL_PRSResourceSetARPLocation_ExtIEs,
        _DLPRSResourceARP_dl_PRSResourceID,
        _DLPRSResourceARP_dL_PRSResourceARPLocation,
        ____DLPRSResourceARP_iE_Extensions__item__id_tab,
        ___DLPRSResourceARP_iE_Extensions__item__id,
        ____DLPRSResourceARP_iE_Extensions__item__criticality_tab,
        ___DLPRSResourceARP_iE_Extensions__item__criticality,
        ____DLPRSResourceARP_iE_Extensions__item__extensionValue_tab,
        ___DLPRSResourceARP_iE_Extensions__item__extensionValue,
        __DLPRSResourceARP_iE_Extensions__item_,
        _DLPRSResourceARP_iE_Extensions,
        DLPRSResourceARP,
        DLPRSResourceARP_ExtIEs,
        _DL_PRSResourceARPLocation_relativeGeodeticLocation,
        _DL_PRSResourceARPLocation_relativeCartesianLocation,
        ___DL_PRSResourceARPLocation_choice_Extension_id_tab,
        __DL_PRSResourceARPLocation_choice_Extension_id,
        ___DL_PRSResourceARPLocation_choice_Extension_criticality_tab,
        __DL_PRSResourceARPLocation_choice_Extension_criticality,
        ___DL_PRSResourceARPLocation_choice_Extension_value_tab,
        __DL_PRSResourceARPLocation_choice_Extension_value,
        _DL_PRSResourceARPLocation_choice_Extension,
        DL_PRSResourceARPLocation,
        DL_PRSResourceARPLocation_ExtIEs,
        _DL_UP_TNL_Address_to_Update_List_Item_oldIPAdress,
        _DL_UP_TNL_Address_to_Update_List_Item_newIPAdress,
        ____DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id_tab,
        ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id,
        ____DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality_tab,
        ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality,
        ____DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue_tab,
        ___DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue,
        __DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item_,
        _DL_UP_TNL_Address_to_Update_List_Item_iE_Extensions,
        DL_UP_TNL_Address_to_Update_List_Item,
        DL_UP_TNL_Address_to_Update_List_ItemExtIEs,
        _DLUPTNLInformation_ToBeSetup_List__item_,
        DLUPTNLInformation_ToBeSetup_List,
        _DLUPTNLInformation_ToBeSetup_Item_dLUPTNLInformation,
        ____DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab,
        ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id,
        ____DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality_tab,
        ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality,
        ____DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab,
        ___DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue,
        __DLUPTNLInformation_ToBeSetup_Item_iE_Extensions__item_,
        _DLUPTNLInformation_ToBeSetup_Item_iE_Extensions,
        DLUPTNLInformation_ToBeSetup_Item,
        DLUPTNLInformation_ToBeSetup_ItemExtIEs,
        _DRB_Activity_Item_dRBID,
        _DRB_Activity_Item_dRB_Activity,
        ____DRB_Activity_Item_iE_Extensions__item__id_tab,
        ___DRB_Activity_Item_iE_Extensions__item__id,
        ____DRB_Activity_Item_iE_Extensions__item__criticality_tab,
        ___DRB_Activity_Item_iE_Extensions__item__criticality,
        ____DRB_Activity_Item_iE_Extensions__item__extensionValue_tab,
        ___DRB_Activity_Item_iE_Extensions__item__extensionValue,
        __DRB_Activity_Item_iE_Extensions__item_,
        _DRB_Activity_Item_iE_Extensions,
        DRB_Activity_Item,
        DRB_Activity_ItemExtIEs,
        DRB_Activity,
        DRBID,
        _DRBs_FailedToBeModified_Item_dRBID,
        _DRBs_FailedToBeModified_Item_cause,
        ____DRBs_FailedToBeModified_Item_iE_Extensions__item__id_tab,
        ___DRBs_FailedToBeModified_Item_iE_Extensions__item__id,
        ____DRBs_FailedToBeModified_Item_iE_Extensions__item__criticality_tab,
        ___DRBs_FailedToBeModified_Item_iE_Extensions__item__criticality,
        ____DRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab,
        ___DRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue,
        __DRBs_FailedToBeModified_Item_iE_Extensions__item_,
        _DRBs_FailedToBeModified_Item_iE_Extensions,
        DRBs_FailedToBeModified_Item,
        DRBs_FailedToBeModified_ItemExtIEs,
        _DRBs_FailedToBeSetup_Item_dRBID,
        _DRBs_FailedToBeSetup_Item_cause,
        ____DRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab,
        ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__id,
        ____DRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab,
        ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality,
        ____DRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab,
        ___DRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue,
        __DRBs_FailedToBeSetup_Item_iE_Extensions__item_,
        _DRBs_FailedToBeSetup_Item_iE_Extensions,
        DRBs_FailedToBeSetup_Item,
        DRBs_FailedToBeSetup_ItemExtIEs,
        _DRBs_FailedToBeSetupMod_Item_dRBID,
        _DRBs_FailedToBeSetupMod_Item_cause,
        ____DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab,
        ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id,
        ____DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab,
        ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality,
        ____DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___DRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue,
        __DRBs_FailedToBeSetupMod_Item_iE_Extensions__item_,
        _DRBs_FailedToBeSetupMod_Item_iE_Extensions,
        DRBs_FailedToBeSetupMod_Item,
        DRBs_FailedToBeSetupMod_ItemExtIEs,
        _DRB_Information_dRB_QoS,
        _DRB_Information_sNSSAI,
        _DRB_Information_notificationControl,
        _DRB_Information_flows_Mapped_To_DRB_List,
        ____DRB_Information_iE_Extensions__item__id_tab,
        ___DRB_Information_iE_Extensions__item__id,
        ____DRB_Information_iE_Extensions__item__criticality_tab,
        ___DRB_Information_iE_Extensions__item__criticality,
        ____DRB_Information_iE_Extensions__item__extensionValue_tab,
        ___DRB_Information_iE_Extensions__item__extensionValue,
        __DRB_Information_iE_Extensions__item_,
        _DRB_Information_iE_Extensions,
        DRB_Information,
        DRB_Information_ItemExtIEs,
        _DRBs_Modified_Item_dRBID,
        _DRBs_Modified_Item_lCID,
        _DRBs_Modified_Item_dLUPTNLInformation_ToBeSetup_List,
        ____DRBs_Modified_Item_iE_Extensions__item__id_tab,
        _____DRBs_Modified_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRBs_Modified_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____DRBs_Modified_Item_iE_Extensions__item__id_tab_val_Extension_2,
        ___DRBs_Modified_Item_iE_Extensions__item__id,
        ___DRBs_Modified_Item_iE_Extensions__item__criticality,
        ___DRBs_Modified_Item_iE_Extensions__item__extensionValue,
        __DRBs_Modified_Item_iE_Extensions__item_,
        _DRBs_Modified_Item_iE_Extensions,
        DRBs_Modified_Item,
        DRBs_Modified_ItemExtIEs,
        _DRBs_Modified_ItemExtIEs_val_Extension_0,
        _DRBs_Modified_ItemExtIEs_val_Extension_1,
        _DRBs_Modified_ItemExtIEs_val_Extension_2,
        _DRBs_ModifiedConf_Item_dRBID,
        _DRBs_ModifiedConf_Item_uLUPTNLInformation_ToBeSetup_List,
        ____DRBs_ModifiedConf_Item_iE_Extensions__item__id_tab,
        _____DRBs_ModifiedConf_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___DRBs_ModifiedConf_Item_iE_Extensions__item__id,
        ___DRBs_ModifiedConf_Item_iE_Extensions__item__criticality,
        ___DRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue,
        __DRBs_ModifiedConf_Item_iE_Extensions__item_,
        _DRBs_ModifiedConf_Item_iE_Extensions,
        DRBs_ModifiedConf_Item,
        DRBs_ModifiedConf_ItemExtIEs,
        _DRBs_ModifiedConf_ItemExtIEs_val_Extension_0,
        _DRB_Notify_Item_dRBID,
        _DRB_Notify_Item_notification_Cause,
        ____DRB_Notify_Item_iE_Extensions__item__id_tab,
        _____DRB_Notify_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___DRB_Notify_Item_iE_Extensions__item__id,
        ___DRB_Notify_Item_iE_Extensions__item__criticality,
        ___DRB_Notify_Item_iE_Extensions__item__extensionValue,
        __DRB_Notify_Item_iE_Extensions__item_,
        _DRB_Notify_Item_iE_Extensions,
        DRB_Notify_Item,
        DRB_Notify_ItemExtIEs,
        _DRB_Notify_ItemExtIEs_val_Extension_0,
        _DRBs_Required_ToBeModified_Item_dRBID,
        _DRBs_Required_ToBeModified_Item_dLUPTNLInformation_ToBeSetup_List,
        ____DRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab,
        _____DRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_1,
        ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__id,
        ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality,
        ___DRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue,
        __DRBs_Required_ToBeModified_Item_iE_Extensions__item_,
        _DRBs_Required_ToBeModified_Item_iE_Extensions,
        DRBs_Required_ToBeModified_Item,
        DRBs_Required_ToBeModified_ItemExtIEs,
        _DRBs_Required_ToBeModified_ItemExtIEs_val_Extension_0,
        _DRBs_Required_ToBeModified_ItemExtIEs_val_Extension_1,
        _DRBs_Required_ToBeReleased_Item_dRBID,
        ____DRBs_Required_ToBeReleased_Item_iE_Extensions__item__id_tab,
        ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__id,
        ____DRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab,
        ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality,
        ____DRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab,
        ___DRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue,
        __DRBs_Required_ToBeReleased_Item_iE_Extensions__item_,
        _DRBs_Required_ToBeReleased_Item_iE_Extensions,
        DRBs_Required_ToBeReleased_Item,
        DRBs_Required_ToBeReleased_ItemExtIEs,
        _DRBs_Setup_Item_dRBID,
        _DRBs_Setup_Item_lCID,
        _DRBs_Setup_Item_dLUPTNLInformation_ToBeSetup_List,
        ____DRBs_Setup_Item_iE_Extensions__item__id_tab,
        _____DRBs_Setup_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRBs_Setup_Item_iE_Extensions__item__id_tab_val_Extension_1,
        ___DRBs_Setup_Item_iE_Extensions__item__id,
        ___DRBs_Setup_Item_iE_Extensions__item__criticality,
        ___DRBs_Setup_Item_iE_Extensions__item__extensionValue,
        __DRBs_Setup_Item_iE_Extensions__item_,
        _DRBs_Setup_Item_iE_Extensions,
        DRBs_Setup_Item,
        DRBs_Setup_ItemExtIEs,
        _DRBs_Setup_ItemExtIEs_val_Extension_0,
        _DRBs_Setup_ItemExtIEs_val_Extension_1,
        _DRBs_SetupMod_Item_dRBID,
        _DRBs_SetupMod_Item_lCID,
        _DRBs_SetupMod_Item_dLUPTNLInformation_ToBeSetup_List,
        ____DRBs_SetupMod_Item_iE_Extensions__item__id_tab,
        _____DRBs_SetupMod_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRBs_SetupMod_Item_iE_Extensions__item__id_tab_val_Extension_1,
        ___DRBs_SetupMod_Item_iE_Extensions__item__id,
        ___DRBs_SetupMod_Item_iE_Extensions__item__criticality,
        ___DRBs_SetupMod_Item_iE_Extensions__item__extensionValue,
        __DRBs_SetupMod_Item_iE_Extensions__item_,
        _DRBs_SetupMod_Item_iE_Extensions,
        DRBs_SetupMod_Item,
        DRBs_SetupMod_ItemExtIEs,
        _DRBs_SetupMod_ItemExtIEs_val_Extension_0,
        _DRBs_SetupMod_ItemExtIEs_val_Extension_1,
        _DRBs_ToBeModified_Item_dRBID,
        _DRBs_ToBeModified_Item_qoSInformation,
        _DRBs_ToBeModified_Item_uLUPTNLInformation_ToBeSetup_List,
        _DRBs_ToBeModified_Item_uLConfiguration,
        ____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab,
        _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_2,
        _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_3,
        _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_4,
        _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_5,
        _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_6,
        _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_7,
        _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_8,
        _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_9,
        _____DRBs_ToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_10,
        ___DRBs_ToBeModified_Item_iE_Extensions__item__id,
        ___DRBs_ToBeModified_Item_iE_Extensions__item__criticality,
        ___DRBs_ToBeModified_Item_iE_Extensions__item__extensionValue,
        __DRBs_ToBeModified_Item_iE_Extensions__item_,
        _DRBs_ToBeModified_Item_iE_Extensions,
        DRBs_ToBeModified_Item,
        DRBs_ToBeModified_ItemExtIEs,
        _DRBs_ToBeModified_ItemExtIEs_val_Extension_0,
        _DRBs_ToBeModified_ItemExtIEs_val_Extension_1,
        _DRBs_ToBeModified_ItemExtIEs_val_Extension_2,
        _DRBs_ToBeModified_ItemExtIEs_val_Extension_3,
        _DRBs_ToBeModified_ItemExtIEs_val_Extension_4,
        _DRBs_ToBeModified_ItemExtIEs_val_Extension_5,
        _DRBs_ToBeModified_ItemExtIEs_val_Extension_6,
        _DRBs_ToBeModified_ItemExtIEs_val_Extension_7,
        _DRBs_ToBeModified_ItemExtIEs_val_Extension_8,
        _DRBs_ToBeModified_ItemExtIEs_val_Extension_9,
        _DRBs_ToBeModified_ItemExtIEs_val_Extension_10,
        _DRBs_ToBeReleased_Item_dRBID,
        ____DRBs_ToBeReleased_Item_iE_Extensions__item__id_tab,
        ___DRBs_ToBeReleased_Item_iE_Extensions__item__id,
        ____DRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab,
        ___DRBs_ToBeReleased_Item_iE_Extensions__item__criticality,
        ____DRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab,
        ___DRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue,
        __DRBs_ToBeReleased_Item_iE_Extensions__item_,
        _DRBs_ToBeReleased_Item_iE_Extensions,
        DRBs_ToBeReleased_Item,
        DRBs_ToBeReleased_ItemExtIEs,
        _DRBs_ToBeSetup_Item_dRBID,
        _DRBs_ToBeSetup_Item_qoSInformation,
        _DRBs_ToBeSetup_Item_uLUPTNLInformation_ToBeSetup_List,
        _DRBs_ToBeSetup_Item_rLCMode,
        _DRBs_ToBeSetup_Item_uLConfiguration,
        _DRBs_ToBeSetup_Item_duplicationActivation,
        ____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab,
        _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_2,
        _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_3,
        _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_4,
        _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_5,
        _____DRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_6,
        ___DRBs_ToBeSetup_Item_iE_Extensions__item__id,
        ___DRBs_ToBeSetup_Item_iE_Extensions__item__criticality,
        ___DRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue,
        __DRBs_ToBeSetup_Item_iE_Extensions__item_,
        _DRBs_ToBeSetup_Item_iE_Extensions,
        DRBs_ToBeSetup_Item,
        DRBs_ToBeSetup_ItemExtIEs,
        _DRBs_ToBeSetup_ItemExtIEs_val_Extension_0,
        _DRBs_ToBeSetup_ItemExtIEs_val_Extension_1,
        _DRBs_ToBeSetup_ItemExtIEs_val_Extension_2,
        _DRBs_ToBeSetup_ItemExtIEs_val_Extension_3,
        _DRBs_ToBeSetup_ItemExtIEs_val_Extension_4,
        _DRBs_ToBeSetup_ItemExtIEs_val_Extension_5,
        _DRBs_ToBeSetup_ItemExtIEs_val_Extension_6,
        _DRBs_ToBeSetupMod_Item_dRBID,
        _DRBs_ToBeSetupMod_Item_qoSInformation,
        _DRBs_ToBeSetupMod_Item_uLUPTNLInformation_ToBeSetup_List,
        _DRBs_ToBeSetupMod_Item_rLCMode,
        _DRBs_ToBeSetupMod_Item_uLConfiguration,
        _DRBs_ToBeSetupMod_Item_duplicationActivation,
        ____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab,
        _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_2,
        _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_3,
        _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_4,
        _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_5,
        _____DRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_6,
        ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__id,
        ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality,
        ___DRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue,
        __DRBs_ToBeSetupMod_Item_iE_Extensions__item_,
        _DRBs_ToBeSetupMod_Item_iE_Extensions,
        DRBs_ToBeSetupMod_Item,
        DRBs_ToBeSetupMod_ItemExtIEs,
        _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_0,
        _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_1,
        _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_2,
        _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_3,
        _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_4,
        _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_5,
        _DRBs_ToBeSetupMod_ItemExtIEs_val_Extension_6,
        _DRXCycle_longDRXCycleLength,
        _DRXCycle_shortDRXCycleLength,
        _DRXCycle_shortDRXCycleTimer,
        ____DRXCycle_iE_Extensions__item__id_tab,
        ___DRXCycle_iE_Extensions__item__id,
        ____DRXCycle_iE_Extensions__item__criticality_tab,
        ___DRXCycle_iE_Extensions__item__criticality,
        ____DRXCycle_iE_Extensions__item__extensionValue_tab,
        ___DRXCycle_iE_Extensions__item__extensionValue,
        __DRXCycle_iE_Extensions__item_,
        _DRXCycle_iE_Extensions,
        DRXCycle,
        DRXCycle_ExtIEs,
        DRX_Config,
        DRXConfigurationIndicator,
        DRX_LongCycleStartOffset,
        _DSInformationList__item_,
        DSInformationList,
        DSCP,
        DUtoCURRCContainer,
        _DUCURadioInformationType_rIM,
        ___DUCURadioInformationType_choice_extension_id_tab,
        __DUCURadioInformationType_choice_extension_id,
        ___DUCURadioInformationType_choice_extension_criticality_tab,
        __DUCURadioInformationType_choice_extension_criticality,
        ___DUCURadioInformationType_choice_extension_value_tab,
        __DUCURadioInformationType_choice_extension_value,
        _DUCURadioInformationType_choice_extension,
        DUCURadioInformationType,
        DUCURadioInformationType_ExtIEs,
        _DUCURIMInformation_victimgNBSetID,
        _DUCURIMInformation_rIMRSDetectionStatus,
        _DUCURIMInformation_aggressorCellList,
        ____DUCURIMInformation_iE_Extensions__item__id_tab,
        ___DUCURIMInformation_iE_Extensions__item__id,
        ____DUCURIMInformation_iE_Extensions__item__criticality_tab,
        ___DUCURIMInformation_iE_Extensions__item__criticality,
        ____DUCURIMInformation_iE_Extensions__item__extensionValue_tab,
        ___DUCURIMInformation_iE_Extensions__item__extensionValue,
        __DUCURIMInformation_iE_Extensions__item_,
        _DUCURIMInformation_iE_Extensions,
        DUCURIMInformation,
        DUCURIMInformation_ExtIEs,
        _DUF_Slot_Config_Item_explicitFormat,
        _DUF_Slot_Config_Item_implicitFormat,
        ___DUF_Slot_Config_Item_choice_extension_id_tab,
        __DUF_Slot_Config_Item_choice_extension_id,
        ___DUF_Slot_Config_Item_choice_extension_criticality_tab,
        __DUF_Slot_Config_Item_choice_extension_criticality,
        ___DUF_Slot_Config_Item_choice_extension_value_tab,
        __DUF_Slot_Config_Item_choice_extension_value,
        _DUF_Slot_Config_Item_choice_extension,
        DUF_Slot_Config_Item,
        DUF_Slot_Config_Item_ExtIEs,
        _DUF_Slot_Config_List__item_,
        DUF_Slot_Config_List,
        DUFSlotformatIndex,
        DUFTransmissionPeriodicity,
        DU_RX_MT_RX,
        DU_TX_MT_TX,
        DU_RX_MT_TX,
        DU_TX_MT_RX,
        DU_RX_MT_RX_Extend,
        DU_TX_MT_TX_Extend,
        DU_RX_MT_TX_Extend,
        DU_TX_MT_RX_Extend,
        _DUtoCURRCInformation_cellGroupConfig,
        _DUtoCURRCInformation_measGapConfig,
        _DUtoCURRCInformation_requestedP_MaxFR1,
        ____DUtoCURRCInformation_iE_Extensions__item__id_tab,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_0,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_1,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_2,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_3,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_4,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_5,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_6,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_7,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_8,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_9,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_10,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_11,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_12,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_13,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_14,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_15,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_16,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_17,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_18,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_19,
        _____DUtoCURRCInformation_iE_Extensions__item__id_tab_val_Extension_20,
        ___DUtoCURRCInformation_iE_Extensions__item__id,
        ___DUtoCURRCInformation_iE_Extensions__item__criticality,
        ___DUtoCURRCInformation_iE_Extensions__item__extensionValue,
        __DUtoCURRCInformation_iE_Extensions__item_,
        _DUtoCURRCInformation_iE_Extensions,
        DUtoCURRCInformation,
        DUtoCURRCInformation_ExtIEs,
        _DUtoCURRCInformation_ExtIEs_val_Extension_0,
        _DUtoCURRCInformation_ExtIEs_val_Extension_1,
        _DUtoCURRCInformation_ExtIEs_val_Extension_2,
        _DUtoCURRCInformation_ExtIEs_val_Extension_3,
        _DUtoCURRCInformation_ExtIEs_val_Extension_4,
        _DUtoCURRCInformation_ExtIEs_val_Extension_5,
        _DUtoCURRCInformation_ExtIEs_val_Extension_6,
        _DUtoCURRCInformation_ExtIEs_val_Extension_7,
        _DUtoCURRCInformation_ExtIEs_val_Extension_8,
        _DUtoCURRCInformation_ExtIEs_val_Extension_9,
        _DUtoCURRCInformation_ExtIEs_val_Extension_10,
        _DUtoCURRCInformation_ExtIEs_val_Extension_11,
        _DUtoCURRCInformation_ExtIEs_val_Extension_12,
        _DUtoCURRCInformation_ExtIEs_val_Extension_13,
        _DUtoCURRCInformation_ExtIEs_val_Extension_14,
        _DUtoCURRCInformation_ExtIEs_val_Extension_15,
        _DUtoCURRCInformation_ExtIEs_val_Extension_16,
        _DUtoCURRCInformation_ExtIEs_val_Extension_17,
        _DUtoCURRCInformation_ExtIEs_val_Extension_18,
        _DUtoCURRCInformation_ExtIEs_val_Extension_19,
        _DUtoCURRCInformation_ExtIEs_val_Extension_20,
        DuplicationActivation,
        DuplicationIndication,
        DuplicationState,
        _Dynamic5QIDescriptor_qoSPriorityLevel,
        _Dynamic5QIDescriptor_packetDelayBudget,
        _Dynamic5QIDescriptor_packetErrorRate,
        _Dynamic5QIDescriptor_fiveQI,
        _Dynamic5QIDescriptor_delayCritical,
        _Dynamic5QIDescriptor_averagingWindow,
        _Dynamic5QIDescriptor_maxDataBurstVolume,
        ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab,
        _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0,
        _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1,
        _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_2,
        ___Dynamic5QIDescriptor_iE_Extensions__item__id,
        ___Dynamic5QIDescriptor_iE_Extensions__item__criticality,
        ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue,
        __Dynamic5QIDescriptor_iE_Extensions__item_,
        _Dynamic5QIDescriptor_iE_Extensions,
        Dynamic5QIDescriptor,
        Dynamic5QIDescriptor_ExtIEs,
        _Dynamic5QIDescriptor_ExtIEs_val_Extension_0,
        _Dynamic5QIDescriptor_ExtIEs_val_Extension_1,
        _Dynamic5QIDescriptor_ExtIEs_val_Extension_2,
        _DynamicPQIDescriptor_resourceType,
        _DynamicPQIDescriptor_qoSPriorityLevel,
        _DynamicPQIDescriptor_packetDelayBudget,
        _DynamicPQIDescriptor_packetErrorRate,
        _DynamicPQIDescriptor_averagingWindow,
        _DynamicPQIDescriptor_maxDataBurstVolume,
        ____DynamicPQIDescriptor_iE_Extensions__item__id_tab,
        ___DynamicPQIDescriptor_iE_Extensions__item__id,
        ____DynamicPQIDescriptor_iE_Extensions__item__criticality_tab,
        ___DynamicPQIDescriptor_iE_Extensions__item__criticality,
        ____DynamicPQIDescriptor_iE_Extensions__item__extensionValue_tab,
        ___DynamicPQIDescriptor_iE_Extensions__item__extensionValue,
        __DynamicPQIDescriptor_iE_Extensions__item_,
        _DynamicPQIDescriptor_iE_Extensions,
        DynamicPQIDescriptor,
        DynamicPQIDescriptor_ExtIEs,
        ___E_CID_MeasurementQuantities__item__id_tab,
        ____E_CID_MeasurementQuantities__item__id_tab_val_Value_0,
        __E_CID_MeasurementQuantities__item__id,
        __E_CID_MeasurementQuantities__item__criticality,
        __E_CID_MeasurementQuantities__item__value,
        _E_CID_MeasurementQuantities__item_,
        E_CID_MeasurementQuantities,
        E_CID_MeasurementQuantities_ItemIEs,
        _E_CID_MeasurementQuantities_ItemIEs_val_Value_0,
        _E_CID_MeasurementQuantities_Item_e_CIDmeasurementQuantitiesValue,
        ____E_CID_MeasurementQuantities_Item_iE_Extensions__item__id_tab,
        ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__id,
        ____E_CID_MeasurementQuantities_Item_iE_Extensions__item__criticality_tab,
        ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__criticality,
        ____E_CID_MeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab,
        ___E_CID_MeasurementQuantities_Item_iE_Extensions__item__extensionValue,
        __E_CID_MeasurementQuantities_Item_iE_Extensions__item_,
        _E_CID_MeasurementQuantities_Item_iE_Extensions,
        E_CID_MeasurementQuantities_Item,
        E_CID_MeasurementQuantitiesValue_ExtIEs,
        E_CID_MeasurementQuantitiesValue,
        _E_CID_MeasurementResult_geographicalCoordinates,
        _E_CID_MeasurementResult_measuredResults_List,
        ____E_CID_MeasurementResult_iE_Extensions__item__id_tab,
        ___E_CID_MeasurementResult_iE_Extensions__item__id,
        ____E_CID_MeasurementResult_iE_Extensions__item__criticality_tab,
        ___E_CID_MeasurementResult_iE_Extensions__item__criticality,
        ____E_CID_MeasurementResult_iE_Extensions__item__extensionValue_tab,
        ___E_CID_MeasurementResult_iE_Extensions__item__extensionValue,
        __E_CID_MeasurementResult_iE_Extensions__item_,
        _E_CID_MeasurementResult_iE_Extensions,
        E_CID_MeasurementResult,
        E_CID_MeasurementResult_ExtIEs,
        _E_CID_MeasuredResults_List__item_,
        E_CID_MeasuredResults_List,
        _E_CID_MeasuredResults_Item_e_CID_MeasuredResults_Value,
        ____E_CID_MeasuredResults_Item_iE_Extensions__item__id_tab,
        ___E_CID_MeasuredResults_Item_iE_Extensions__item__id,
        ____E_CID_MeasuredResults_Item_iE_Extensions__item__criticality_tab,
        ___E_CID_MeasuredResults_Item_iE_Extensions__item__criticality,
        ____E_CID_MeasuredResults_Item_iE_Extensions__item__extensionValue_tab,
        ___E_CID_MeasuredResults_Item_iE_Extensions__item__extensionValue,
        __E_CID_MeasuredResults_Item_iE_Extensions__item_,
        _E_CID_MeasuredResults_Item_iE_Extensions,
        E_CID_MeasuredResults_Item,
        E_CID_MeasuredResults_Item_ExtIEs,
        _E_CID_MeasuredResults_Value_valueAngleofArrivalNR,
        ___E_CID_MeasuredResults_Value_choice_extension_id_tab,
        ____E_CID_MeasuredResults_Value_choice_extension_id_tab_val_Value_0,
        __E_CID_MeasuredResults_Value_choice_extension_id,
        __E_CID_MeasuredResults_Value_choice_extension_criticality,
        __E_CID_MeasuredResults_Value_choice_extension_value,
        _E_CID_MeasuredResults_Value_choice_extension,
        E_CID_MeasuredResults_Value,
        E_CID_MeasuredResults_Value_ExtIEs,
        _E_CID_MeasuredResults_Value_ExtIEs_val_Value_0,
        E_CID_ReportCharacteristics,
        _EgressBHRLCCHList__item_,
        EgressBHRLCCHList,
        _EgressBHRLCCHItem_nextHopBAPAddress,
        _EgressBHRLCCHItem_bHRLCChannelID,
        ____EgressBHRLCCHItem_iE_Extensions__item__id_tab,
        ___EgressBHRLCCHItem_iE_Extensions__item__id,
        ____EgressBHRLCCHItem_iE_Extensions__item__criticality_tab,
        ___EgressBHRLCCHItem_iE_Extensions__item__criticality,
        ____EgressBHRLCCHItem_iE_Extensions__item__extensionValue_tab,
        ___EgressBHRLCCHItem_iE_Extensions__item__extensionValue,
        __EgressBHRLCCHItem_iE_Extensions__item_,
        _EgressBHRLCCHItem_iE_Extensions,
        EgressBHRLCCHItem,
        EgressBHRLCCHItemExtIEs,
        EgressNonF1terminatingTopologyIndicator,
        _Endpoint_IP_address_and_port_endpointIPAddress,
        ____Endpoint_IP_address_and_port_iE_Extensions__item__id_tab,
        _____Endpoint_IP_address_and_port_iE_Extensions__item__id_tab_val_Extension_0,
        ___Endpoint_IP_address_and_port_iE_Extensions__item__id,
        ___Endpoint_IP_address_and_port_iE_Extensions__item__criticality,
        ___Endpoint_IP_address_and_port_iE_Extensions__item__extensionValue,
        __Endpoint_IP_address_and_port_iE_Extensions__item_,
        _Endpoint_IP_address_and_port_iE_Extensions,
        Endpoint_IP_address_and_port,
        Endpoint_IP_address_and_port_ExtIEs,
        _Endpoint_IP_address_and_port_ExtIEs_val_Extension_0,
        EnergyDetectionThreshold,
        _ExtendedAvailablePLMN_List__item_,
        ExtendedAvailablePLMN_List,
        _ExtendedAvailablePLMN_Item_pLMNIdentity,
        ____ExtendedAvailablePLMN_Item_iE_Extensions__item__id_tab,
        ___ExtendedAvailablePLMN_Item_iE_Extensions__item__id,
        ____ExtendedAvailablePLMN_Item_iE_Extensions__item__criticality_tab,
        ___ExtendedAvailablePLMN_Item_iE_Extensions__item__criticality,
        ____ExtendedAvailablePLMN_Item_iE_Extensions__item__extensionValue_tab,
        ___ExtendedAvailablePLMN_Item_iE_Extensions__item__extensionValue,
        __ExtendedAvailablePLMN_Item_iE_Extensions__item_,
        _ExtendedAvailablePLMN_Item_iE_Extensions,
        ExtendedAvailablePLMN_Item,
        _ExplicitFormat_permutation,
        _ExplicitFormat_noofDownlinkSymbols,
        _ExplicitFormat_noofUplinkSymbols,
        ____ExplicitFormat_iE_Extensions__item__id_tab,
        ___ExplicitFormat_iE_Extensions__item__id,
        ____ExplicitFormat_iE_Extensions__item__criticality_tab,
        ___ExplicitFormat_iE_Extensions__item__criticality,
        ____ExplicitFormat_iE_Extensions__item__extensionValue_tab,
        ___ExplicitFormat_iE_Extensions__item__extensionValue,
        __ExplicitFormat_iE_Extensions__item_,
        _ExplicitFormat_iE_Extensions,
        ExplicitFormat,
        ExplicitFormat_ExtIEs,
        ExtendedAvailablePLMN_Item_ExtIEs,
        _ExtendedServedPLMNs_List__item_,
        ExtendedServedPLMNs_List,
        _ExtendedServedPLMNs_Item_pLMN_Identity,
        _ExtendedServedPLMNs_Item_tAISliceSupportList,
        ____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab,
        _____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____ExtendedServedPLMNs_Item_iE_Extensions__item__id_tab_val_Extension_2,
        ___ExtendedServedPLMNs_Item_iE_Extensions__item__id,
        ___ExtendedServedPLMNs_Item_iE_Extensions__item__criticality,
        ___ExtendedServedPLMNs_Item_iE_Extensions__item__extensionValue,
        __ExtendedServedPLMNs_Item_iE_Extensions__item_,
        _ExtendedServedPLMNs_Item_iE_Extensions,
        ExtendedServedPLMNs_Item,
        ExtendedServedPLMNs_ItemExtIEs,
        _ExtendedServedPLMNs_ItemExtIEs_val_Extension_0,
        _ExtendedServedPLMNs_ItemExtIEs_val_Extension_1,
        _ExtendedServedPLMNs_ItemExtIEs_val_Extension_2,
        _ExtendedSliceSupportList__item_,
        ExtendedSliceSupportList,
        ExtendedUEIdentityIndexValue,
        _EUTRACells_List__item_,
        EUTRACells_List,
        _EUTRACells_List_item_eUTRA_Cell_ID,
        _EUTRACells_List_item_served_EUTRA_Cells_Information,
        ____EUTRACells_List_item_iE_Extensions__item__id_tab,
        ___EUTRACells_List_item_iE_Extensions__item__id,
        ____EUTRACells_List_item_iE_Extensions__item__criticality_tab,
        ___EUTRACells_List_item_iE_Extensions__item__criticality,
        ____EUTRACells_List_item_iE_Extensions__item__extensionValue_tab,
        ___EUTRACells_List_item_iE_Extensions__item__extensionValue,
        __EUTRACells_List_item_iE_Extensions__item_,
        _EUTRACells_List_item_iE_Extensions,
        EUTRACells_List_item,
        EUTRACells_List_itemExtIEs,
        EUTRA_Cell_ID,
        _EUTRA_Coex_FDD_Info_uL_EARFCN,
        _EUTRA_Coex_FDD_Info_dL_EARFCN,
        _EUTRA_Coex_FDD_Info_uL_Transmission_Bandwidth,
        _EUTRA_Coex_FDD_Info_dL_Transmission_Bandwidth,
        ____EUTRA_Coex_FDD_Info_iE_Extensions__item__id_tab,
        ___EUTRA_Coex_FDD_Info_iE_Extensions__item__id,
        ____EUTRA_Coex_FDD_Info_iE_Extensions__item__criticality_tab,
        ___EUTRA_Coex_FDD_Info_iE_Extensions__item__criticality,
        ____EUTRA_Coex_FDD_Info_iE_Extensions__item__extensionValue_tab,
        ___EUTRA_Coex_FDD_Info_iE_Extensions__item__extensionValue,
        __EUTRA_Coex_FDD_Info_iE_Extensions__item_,
        _EUTRA_Coex_FDD_Info_iE_Extensions,
        EUTRA_Coex_FDD_Info,
        EUTRA_Coex_FDD_Info_ExtIEs,
        _EUTRA_Coex_Mode_Info_fDD,
        _EUTRA_Coex_Mode_Info_tDD,
        EUTRA_Coex_Mode_Info,
        _EUTRA_Coex_TDD_Info_eARFCN,
        _EUTRA_Coex_TDD_Info_transmission_Bandwidth,
        _EUTRA_Coex_TDD_Info_subframeAssignment,
        _EUTRA_Coex_TDD_Info_specialSubframe_Info,
        ____EUTRA_Coex_TDD_Info_iE_Extensions__item__id_tab,
        ___EUTRA_Coex_TDD_Info_iE_Extensions__item__id,
        ____EUTRA_Coex_TDD_Info_iE_Extensions__item__criticality_tab,
        ___EUTRA_Coex_TDD_Info_iE_Extensions__item__criticality,
        ____EUTRA_Coex_TDD_Info_iE_Extensions__item__extensionValue_tab,
        ___EUTRA_Coex_TDD_Info_iE_Extensions__item__extensionValue,
        __EUTRA_Coex_TDD_Info_iE_Extensions__item_,
        _EUTRA_Coex_TDD_Info_iE_Extensions,
        EUTRA_Coex_TDD_Info,
        EUTRA_Coex_TDD_Info_ExtIEs,
        EUTRA_CyclicPrefixDL,
        EUTRA_CyclicPrefixUL,
        _EUTRA_PRACH_Configuration_rootSequenceIndex,
        _EUTRA_PRACH_Configuration_zeroCorrelationIndex,
        _EUTRA_PRACH_Configuration_highSpeedFlag,
        _EUTRA_PRACH_Configuration_prach_FreqOffset,
        _EUTRA_PRACH_Configuration_prach_ConfigIndex,
        ____EUTRA_PRACH_Configuration_iE_Extensions__item__id_tab,
        ___EUTRA_PRACH_Configuration_iE_Extensions__item__id,
        ____EUTRA_PRACH_Configuration_iE_Extensions__item__criticality_tab,
        ___EUTRA_PRACH_Configuration_iE_Extensions__item__criticality,
        ____EUTRA_PRACH_Configuration_iE_Extensions__item__extensionValue_tab,
        ___EUTRA_PRACH_Configuration_iE_Extensions__item__extensionValue,
        __EUTRA_PRACH_Configuration_iE_Extensions__item_,
        _EUTRA_PRACH_Configuration_iE_Extensions,
        EUTRA_PRACH_Configuration,
        EUTRA_PRACH_Configuration_ExtIEs,
        _EUTRA_SpecialSubframe_Info_specialSubframePatterns,
        _EUTRA_SpecialSubframe_Info_cyclicPrefixDL,
        _EUTRA_SpecialSubframe_Info_cyclicPrefixUL,
        ____EUTRA_SpecialSubframe_Info_iE_Extensions__item__id_tab,
        ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__id,
        ____EUTRA_SpecialSubframe_Info_iE_Extensions__item__criticality_tab,
        ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__criticality,
        ____EUTRA_SpecialSubframe_Info_iE_Extensions__item__extensionValue_tab,
        ___EUTRA_SpecialSubframe_Info_iE_Extensions__item__extensionValue,
        __EUTRA_SpecialSubframe_Info_iE_Extensions__item_,
        _EUTRA_SpecialSubframe_Info_iE_Extensions,
        EUTRA_SpecialSubframe_Info,
        EUTRA_SpecialSubframe_Info_ExtIEs,
        EUTRA_SpecialSubframePatterns,
        EUTRA_SubframeAssignment,
        EUTRA_Transmission_Bandwidth,
        _EUTRANQoS_qCI,
        _EUTRANQoS_allocationAndRetentionPriority,
        _EUTRANQoS_gbrQosInformation,
        ____EUTRANQoS_iE_Extensions__item__id_tab,
        _____EUTRANQoS_iE_Extensions__item__id_tab_val_Extension_0,
        ___EUTRANQoS_iE_Extensions__item__id,
        ___EUTRANQoS_iE_Extensions__item__criticality,
        ___EUTRANQoS_iE_Extensions__item__extensionValue,
        __EUTRANQoS_iE_Extensions__item_,
        _EUTRANQoS_iE_Extensions,
        EUTRANQoS,
        EUTRANQoS_ExtIEs,
        _EUTRANQoS_ExtIEs_val_Extension_0,
        ExecuteDuplication,
        ExtendedEARFCN,
        _EUTRA_Mode_Info_eUTRAFDD,
        _EUTRA_Mode_Info_eUTRATDD,
        ___EUTRA_Mode_Info_choice_extension_id_tab,
        __EUTRA_Mode_Info_choice_extension_id,
        ___EUTRA_Mode_Info_choice_extension_criticality_tab,
        __EUTRA_Mode_Info_choice_extension_criticality,
        ___EUTRA_Mode_Info_choice_extension_value_tab,
        __EUTRA_Mode_Info_choice_extension_value,
        _EUTRA_Mode_Info_choice_extension,
        EUTRA_Mode_Info,
        EUTRA_Mode_Info_ExtIEs,
        EUTRA_NR_CellResourceCoordinationReq_Container,
        EUTRA_NR_CellResourceCoordinationReqAck_Container,
        _EUTRA_FDD_Info_uL_offsetToPointA,
        _EUTRA_FDD_Info_dL_offsetToPointA,
        ____EUTRA_FDD_Info_iE_Extensions__item__id_tab,
        ___EUTRA_FDD_Info_iE_Extensions__item__id,
        ____EUTRA_FDD_Info_iE_Extensions__item__criticality_tab,
        ___EUTRA_FDD_Info_iE_Extensions__item__criticality,
        ____EUTRA_FDD_Info_iE_Extensions__item__extensionValue_tab,
        ___EUTRA_FDD_Info_iE_Extensions__item__extensionValue,
        __EUTRA_FDD_Info_iE_Extensions__item_,
        _EUTRA_FDD_Info_iE_Extensions,
        EUTRA_FDD_Info,
        EUTRA_FDD_Info_ExtIEs,
        _EUTRA_TDD_Info_offsetToPointA,
        ____EUTRA_TDD_Info_iE_Extensions__item__id_tab,
        ___EUTRA_TDD_Info_iE_Extensions__item__id,
        ____EUTRA_TDD_Info_iE_Extensions__item__criticality_tab,
        ___EUTRA_TDD_Info_iE_Extensions__item__criticality,
        ____EUTRA_TDD_Info_iE_Extensions__item__extensionValue_tab,
        ___EUTRA_TDD_Info_iE_Extensions__item__extensionValue,
        __EUTRA_TDD_Info_iE_Extensions__item_,
        _EUTRA_TDD_Info_iE_Extensions,
        EUTRA_TDD_Info,
        EUTRA_TDD_Info_ExtIEs,
        EventType,
        ExtendedPacketDelayBudget,
        _Expected_UL_AoA_expected_Azimuth_AoA,
        _Expected_UL_AoA_expected_Zenith_AoA,
        ____Expected_UL_AoA_iE_extensions__item__id_tab,
        ___Expected_UL_AoA_iE_extensions__item__id,
        ____Expected_UL_AoA_iE_extensions__item__criticality_tab,
        ___Expected_UL_AoA_iE_extensions__item__criticality,
        ____Expected_UL_AoA_iE_extensions__item__extensionValue_tab,
        ___Expected_UL_AoA_iE_extensions__item__extensionValue,
        __Expected_UL_AoA_iE_extensions__item_,
        _Expected_UL_AoA_iE_extensions,
        Expected_UL_AoA,
        Expected_UL_AoA_ExtIEs,
        _Expected_ZoA_only_expected_ZoA_only,
        ____Expected_ZoA_only_iE_extensions__item__id_tab,
        ___Expected_ZoA_only_iE_extensions__item__id,
        ____Expected_ZoA_only_iE_extensions__item__criticality_tab,
        ___Expected_ZoA_only_iE_extensions__item__criticality,
        ____Expected_ZoA_only_iE_extensions__item__extensionValue_tab,
        ___Expected_ZoA_only_iE_extensions__item__extensionValue,
        __Expected_ZoA_only_iE_extensions__item_,
        _Expected_ZoA_only_iE_extensions,
        Expected_ZoA_only,
        Expected_ZoA_only_ExtIEs,
        _Expected_Azimuth_AoA_expected_Azimuth_AoA_value,
        _Expected_Azimuth_AoA_expected_Azimuth_AoA_uncertainty,
        ____Expected_Azimuth_AoA_iE_Extensions__item__id_tab,
        ___Expected_Azimuth_AoA_iE_Extensions__item__id,
        ____Expected_Azimuth_AoA_iE_Extensions__item__criticality_tab,
        ___Expected_Azimuth_AoA_iE_Extensions__item__criticality,
        ____Expected_Azimuth_AoA_iE_Extensions__item__extensionValue_tab,
        ___Expected_Azimuth_AoA_iE_Extensions__item__extensionValue,
        __Expected_Azimuth_AoA_iE_Extensions__item_,
        _Expected_Azimuth_AoA_iE_Extensions,
        Expected_Azimuth_AoA,
        Expected_Azimuth_AoA_ExtIEs,
        _Expected_Zenith_AoA_expected_Zenith_AoA_value,
        _Expected_Zenith_AoA_expected_Zenith_AoA_uncertainty,
        ____Expected_Zenith_AoA_iE_Extensions__item__id_tab,
        ___Expected_Zenith_AoA_iE_Extensions__item__id,
        ____Expected_Zenith_AoA_iE_Extensions__item__criticality_tab,
        ___Expected_Zenith_AoA_iE_Extensions__item__criticality,
        ____Expected_Zenith_AoA_iE_Extensions__item__extensionValue_tab,
        ___Expected_Zenith_AoA_iE_Extensions__item__extensionValue,
        __Expected_Zenith_AoA_iE_Extensions__item_,
        _Expected_Zenith_AoA_iE_Extensions,
        Expected_Zenith_AoA,
        Expected_Zenith_AoA_ExtIEs,
        Expected_Value_AoA,
        Expected_Value_ZoA,
        F1CPathNSA,
        _F1CTransferPath_f1CPathNSA,
        ____F1CTransferPath_iE_Extensions__item__id_tab,
        ___F1CTransferPath_iE_Extensions__item__id,
        ____F1CTransferPath_iE_Extensions__item__criticality_tab,
        ___F1CTransferPath_iE_Extensions__item__criticality,
        ____F1CTransferPath_iE_Extensions__item__extensionValue_tab,
        ___F1CTransferPath_iE_Extensions__item__extensionValue,
        __F1CTransferPath_iE_Extensions__item_,
        _F1CTransferPath_iE_Extensions,
        F1CTransferPath,
        F1CTransferPath_ExtIEs,
        F1CPathNRDC,
        _F1CTransferPathNRDC_f1CPathNRDC,
        ____F1CTransferPathNRDC_iE_Extensions__item__id_tab,
        ___F1CTransferPathNRDC_iE_Extensions__item__id,
        ____F1CTransferPathNRDC_iE_Extensions__item__criticality_tab,
        ___F1CTransferPathNRDC_iE_Extensions__item__criticality,
        ____F1CTransferPathNRDC_iE_Extensions__item__extensionValue_tab,
        ___F1CTransferPathNRDC_iE_Extensions__item__extensionValue,
        __F1CTransferPathNRDC_iE_Extensions__item_,
        _F1CTransferPathNRDC_iE_Extensions,
        F1CTransferPathNRDC,
        F1CTransferPathNRDC_ExtIEs,
        _FDD_Info_uL_NRFreqInfo,
        _FDD_Info_dL_NRFreqInfo,
        _FDD_Info_uL_Transmission_Bandwidth,
        _FDD_Info_dL_Transmission_Bandwidth,
        ____FDD_Info_iE_Extensions__item__id_tab,
        _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_0,
        _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_1,
        ___FDD_Info_iE_Extensions__item__id,
        ___FDD_Info_iE_Extensions__item__criticality,
        ___FDD_Info_iE_Extensions__item__extensionValue,
        __FDD_Info_iE_Extensions__item_,
        _FDD_Info_iE_Extensions,
        FDD_Info,
        FDD_Info_ExtIEs,
        _FDD_Info_ExtIEs_val_Extension_0,
        _FDD_Info_ExtIEs_val_Extension_1,
        _FDD_InfoRel16_uL_FreqInfo,
        _FDD_InfoRel16_sUL_FreqInfo,
        ____FDD_InfoRel16_iE_Extensions__item__id_tab,
        ___FDD_InfoRel16_iE_Extensions__item__id,
        ____FDD_InfoRel16_iE_Extensions__item__criticality_tab,
        ___FDD_InfoRel16_iE_Extensions__item__criticality,
        ____FDD_InfoRel16_iE_Extensions__item__extensionValue_tab,
        ___FDD_InfoRel16_iE_Extensions__item__extensionValue,
        __FDD_InfoRel16_iE_Extensions__item_,
        _FDD_InfoRel16_iE_Extensions,
        FDD_InfoRel16,
        FDD_InfoRel16_ExtIEs,
        _FiveG_ProSeAuthorized_fiveG_proSeDirectDiscovery,
        _FiveG_ProSeAuthorized_fiveG_proSeDirectCommunication,
        _FiveG_ProSeAuthorized_fiveG_ProSeLayer2UEtoNetworkRelay,
        _FiveG_ProSeAuthorized_fiveG_ProSeLayer3UEtoNetworkRelay,
        _FiveG_ProSeAuthorized_fiveG_ProSeLayer2RemoteUE,
        ____FiveG_ProSeAuthorized_iE_Extensions__item__id_tab,
        ___FiveG_ProSeAuthorized_iE_Extensions__item__id,
        ____FiveG_ProSeAuthorized_iE_Extensions__item__criticality_tab,
        ___FiveG_ProSeAuthorized_iE_Extensions__item__criticality,
        ____FiveG_ProSeAuthorized_iE_Extensions__item__extensionValue_tab,
        ___FiveG_ProSeAuthorized_iE_Extensions__item__extensionValue,
        __FiveG_ProSeAuthorized_iE_Extensions__item_,
        _FiveG_ProSeAuthorized_iE_Extensions,
        FiveG_ProSeAuthorized,
        FiveG_ProSeAuthorized_ExtIEs,
        FiveG_ProSeDirectDiscovery,
        FiveG_ProSeDirectCommunication,
        FiveG_ProSeLayer2UEtoNetworkRelay,
        FiveG_ProSeLayer3UEtoNetworkRelay,
        FiveG_ProSeLayer2RemoteUE,
        _Flows_Mapped_To_DRB_List__item_,
        Flows_Mapped_To_DRB_List,
        _Flows_Mapped_To_DRB_Item_qoSFlowIdentifier,
        _Flows_Mapped_To_DRB_Item_qoSFlowLevelQoSParameters,
        ____Flows_Mapped_To_DRB_Item_iE_Extensions__item__id_tab,
        _____Flows_Mapped_To_DRB_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____Flows_Mapped_To_DRB_Item_iE_Extensions__item__id_tab_val_Extension_1,
        ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__id,
        ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__criticality,
        ___Flows_Mapped_To_DRB_Item_iE_Extensions__item__extensionValue,
        __Flows_Mapped_To_DRB_Item_iE_Extensions__item_,
        _Flows_Mapped_To_DRB_Item_iE_Extensions,
        Flows_Mapped_To_DRB_Item,
        Flows_Mapped_To_DRB_ItemExtIEs,
        _Flows_Mapped_To_DRB_ItemExtIEs_val_Extension_0,
        _Flows_Mapped_To_DRB_ItemExtIEs_val_Extension_1,
        FR1_Bandwidth,
        FR2_Bandwidth,
        _FreqBandNrItem_freqBandIndicatorNr,
        __FreqBandNrItem_supportedSULBandList__item_,
        _FreqBandNrItem_supportedSULBandList,
        ____FreqBandNrItem_iE_Extensions__item__id_tab,
        ___FreqBandNrItem_iE_Extensions__item__id,
        ____FreqBandNrItem_iE_Extensions__item__criticality_tab,
        ___FreqBandNrItem_iE_Extensions__item__criticality,
        ____FreqBandNrItem_iE_Extensions__item__extensionValue_tab,
        ___FreqBandNrItem_iE_Extensions__item__extensionValue,
        __FreqBandNrItem_iE_Extensions__item_,
        _FreqBandNrItem_iE_Extensions,
        FreqBandNrItem,
        FreqBandNrItem_ExtIEs,
        _FreqDomainLength_l839,
        _FreqDomainLength_l139,
        ___FreqDomainLength_choice_extension_id_tab,
        ____FreqDomainLength_choice_extension_id_tab_val_Value_0,
        ____FreqDomainLength_choice_extension_id_tab_val_Value_1,
        __FreqDomainLength_choice_extension_id,
        __FreqDomainLength_choice_extension_criticality,
        __FreqDomainLength_choice_extension_value,
        _FreqDomainLength_choice_extension,
        FreqDomainLength,
        FreqDomainLength_ExtIEs,
        _FreqDomainLength_ExtIEs_val_Value_0,
        _FreqDomainLength_ExtIEs_val_Value_1,
        _FreqInfoRel16_nRARFCN,
        _FreqInfoRel16_frequencyShift7p5khz,
        _FreqInfoRel16_carrierList,
        ____FreqInfoRel16_iE_Extensions__item__id_tab,
        ___FreqInfoRel16_iE_Extensions__item__id,
        ____FreqInfoRel16_iE_Extensions__item__criticality_tab,
        ___FreqInfoRel16_iE_Extensions__item__criticality,
        ____FreqInfoRel16_iE_Extensions__item__extensionValue_tab,
        ___FreqInfoRel16_iE_Extensions__item__extensionValue,
        __FreqInfoRel16_iE_Extensions__item_,
        _FreqInfoRel16_iE_Extensions,
        FreqInfoRel16,
        FreqInfoRel16_ExtIEs,
        FrequencyShift7p5khz,
        _Frequency_Domain_HSNA_Configuration_List__item_,
        Frequency_Domain_HSNA_Configuration_List,
        _Frequency_Domain_HSNA_Configuration_Item_rBSetIndex,
        _Frequency_Domain_HSNA_Configuration_Item_frequency_Domain_HSNA_Slot_Configuration_List,
        ____Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__id_tab,
        ___Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__id,
        ____Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__criticality_tab,
        ___Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__criticality,
        ____Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__extensionValue_tab,
        ___Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item__extensionValue,
        __Frequency_Domain_HSNA_Configuration_Item_iE_Extensions__item_,
        _Frequency_Domain_HSNA_Configuration_Item_iE_Extensions,
        Frequency_Domain_HSNA_Configuration_Item,
        Frequency_Domain_HSNA_Configuration_Item_ExtIEs,
        _Frequency_Domain_HSNA_Slot_Configuration_List__item_,
        Frequency_Domain_HSNA_Slot_Configuration_List,
        _Frequency_Domain_HSNA_Slot_Configuration_Item_slotIndex,
        _Frequency_Domain_HSNA_Slot_Configuration_Item_hSNADownlink,
        _Frequency_Domain_HSNA_Slot_Configuration_Item_hSNAUplink,
        _Frequency_Domain_HSNA_Slot_Configuration_Item_hSNAFlexible,
        ____Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__id_tab,
        ___Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__id,
        ____Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__criticality_tab,
        ___Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__criticality,
        ____Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__extensionValue_tab,
        ___Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item__extensionValue,
        __Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions__item_,
        _Frequency_Domain_HSNA_Slot_Configuration_Item_iE_Extensions,
        Frequency_Domain_HSNA_Slot_Configuration_Item,
        Frequency_Domain_HSNA_Slot_Configuration_Item_ExtIEs,
        FullConfiguration,
        _FlowsMappedToSLDRB_List__item_,
        FlowsMappedToSLDRB_List,
        _FlowsMappedToSLDRB_Item_pc5QoSFlowIdentifier,
        ____FlowsMappedToSLDRB_Item_iE_Extensions__item__id_tab,
        ___FlowsMappedToSLDRB_Item_iE_Extensions__item__id,
        ____FlowsMappedToSLDRB_Item_iE_Extensions__item__criticality_tab,
        ___FlowsMappedToSLDRB_Item_iE_Extensions__item__criticality,
        ____FlowsMappedToSLDRB_Item_iE_Extensions__item__extensionValue_tab,
        ___FlowsMappedToSLDRB_Item_iE_Extensions__item__extensionValue,
        __FlowsMappedToSLDRB_Item_iE_Extensions__item_,
        _FlowsMappedToSLDRB_Item_iE_Extensions,
        FlowsMappedToSLDRB_Item,
        FlowsMappedToSLDRB_Item_ExtIEs,
        _GBR_QosInformation_e_RAB_MaximumBitrateDL,
        _GBR_QosInformation_e_RAB_MaximumBitrateUL,
        _GBR_QosInformation_e_RAB_GuaranteedBitrateDL,
        _GBR_QosInformation_e_RAB_GuaranteedBitrateUL,
        ____GBR_QosInformation_iE_Extensions__item__id_tab,
        ___GBR_QosInformation_iE_Extensions__item__id,
        ____GBR_QosInformation_iE_Extensions__item__criticality_tab,
        ___GBR_QosInformation_iE_Extensions__item__criticality,
        ____GBR_QosInformation_iE_Extensions__item__extensionValue_tab,
        ___GBR_QosInformation_iE_Extensions__item__extensionValue,
        __GBR_QosInformation_iE_Extensions__item_,
        _GBR_QosInformation_iE_Extensions,
        GBR_QosInformation,
        GBR_QosInformation_ExtIEs,
        _GBR_QoSFlowInformation_maxFlowBitRateDownlink,
        _GBR_QoSFlowInformation_maxFlowBitRateUplink,
        _GBR_QoSFlowInformation_guaranteedFlowBitRateDownlink,
        _GBR_QoSFlowInformation_guaranteedFlowBitRateUplink,
        _GBR_QoSFlowInformation_maxPacketLossRateDownlink,
        _GBR_QoSFlowInformation_maxPacketLossRateUplink,
        ____GBR_QoSFlowInformation_iE_Extensions__item__id_tab,
        _____GBR_QoSFlowInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___GBR_QoSFlowInformation_iE_Extensions__item__id,
        ___GBR_QoSFlowInformation_iE_Extensions__item__criticality,
        ___GBR_QoSFlowInformation_iE_Extensions__item__extensionValue,
        __GBR_QoSFlowInformation_iE_Extensions__item_,
        _GBR_QoSFlowInformation_iE_Extensions,
        GBR_QoSFlowInformation,
        GBR_QosFlowInformation_ExtIEs,
        _GBR_QosFlowInformation_ExtIEs_val_Extension_0,
        CG_Config,
        _GeographicalCoordinates_tRPPositionDefinitionType,
        _GeographicalCoordinates_dLPRSResourceCoordinates,
        ____GeographicalCoordinates_iE_Extensions__item__id_tab,
        _____GeographicalCoordinates_iE_Extensions__item__id_tab_val_Extension_0,
        ___GeographicalCoordinates_iE_Extensions__item__id,
        ___GeographicalCoordinates_iE_Extensions__item__criticality,
        ___GeographicalCoordinates_iE_Extensions__item__extensionValue,
        __GeographicalCoordinates_iE_Extensions__item_,
        _GeographicalCoordinates_iE_Extensions,
        GeographicalCoordinates,
        GeographicalCoordinates_ExtIEs,
        _GeographicalCoordinates_ExtIEs_val_Extension_0,
        GNB_CU_MBS_F1AP_ID,
        GNBCUMeasurementID,
        GNBDUMeasurementID,
        __GNB_CUSystemInformation_sibtypetobeupdatedlist__item_,
        _GNB_CUSystemInformation_sibtypetobeupdatedlist,
        ____GNB_CUSystemInformation_iE_Extensions__item__id_tab,
        _____GNB_CUSystemInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___GNB_CUSystemInformation_iE_Extensions__item__id,
        ___GNB_CUSystemInformation_iE_Extensions__item__criticality,
        ___GNB_CUSystemInformation_iE_Extensions__item__extensionValue,
        __GNB_CUSystemInformation_iE_Extensions__item_,
        _GNB_CUSystemInformation_iE_Extensions,
        GNB_CUSystemInformation,
        GNB_CUSystemInformation_ExtIEs,
        _GNB_CUSystemInformation_ExtIEs_val_Extension_0,
        _GNB_CU_TNL_Association_Setup_Item_tNLAssociationTransportLayerAddress,
        ____GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__id_tab,
        ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__id,
        ____GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__criticality_tab,
        ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__criticality,
        ____GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__extensionValue_tab,
        ___GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item__extensionValue,
        __GNB_CU_TNL_Association_Setup_Item_iE_Extensions__item_,
        _GNB_CU_TNL_Association_Setup_Item_iE_Extensions,
        GNB_CU_TNL_Association_Setup_Item,
        GNB_CU_TNL_Association_Setup_Item_ExtIEs,
        _GNB_CU_TNL_Association_Failed_To_Setup_Item_tNLAssociationTransportLayerAddress,
        _GNB_CU_TNL_Association_Failed_To_Setup_Item_cause,
        ____GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__id_tab,
        ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__id,
        ____GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__criticality_tab,
        ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__criticality,
        ____GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__extensionValue_tab,
        ___GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item__extensionValue,
        __GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions__item_,
        _GNB_CU_TNL_Association_Failed_To_Setup_Item_iE_Extensions,
        GNB_CU_TNL_Association_Failed_To_Setup_Item,
        GNB_CU_TNL_Association_Failed_To_Setup_Item_ExtIEs,
        _GNB_CU_TNL_Association_To_Add_Item_tNLAssociationTransportLayerAddress,
        _GNB_CU_TNL_Association_To_Add_Item_tNLAssociationUsage,
        ____GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__id_tab,
        ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__id,
        ____GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__criticality_tab,
        ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__criticality,
        ____GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__extensionValue_tab,
        ___GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item__extensionValue,
        __GNB_CU_TNL_Association_To_Add_Item_iE_Extensions__item_,
        _GNB_CU_TNL_Association_To_Add_Item_iE_Extensions,
        GNB_CU_TNL_Association_To_Add_Item,
        GNB_CU_TNL_Association_To_Add_Item_ExtIEs,
        _GNB_CU_TNL_Association_To_Remove_Item_tNLAssociationTransportLayerAddress,
        ____GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab,
        _____GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__id,
        ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality,
        ___GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue,
        __GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions__item_,
        _GNB_CU_TNL_Association_To_Remove_Item_iE_Extensions,
        GNB_CU_TNL_Association_To_Remove_Item,
        GNB_CU_TNL_Association_To_Remove_Item_ExtIEs,
        _GNB_CU_TNL_Association_To_Remove_Item_ExtIEs_val_Extension_0,
        _GNB_CU_TNL_Association_To_Update_Item_tNLAssociationTransportLayerAddress,
        _GNB_CU_TNL_Association_To_Update_Item_tNLAssociationUsage,
        ____GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__id_tab,
        ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__id,
        ____GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__criticality_tab,
        ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__criticality,
        ____GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__extensionValue_tab,
        ___GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item__extensionValue,
        __GNB_CU_TNL_Association_To_Update_Item_iE_Extensions__item_,
        _GNB_CU_TNL_Association_To_Update_Item_iE_Extensions,
        GNB_CU_TNL_Association_To_Update_Item,
        GNB_CU_TNL_Association_To_Update_Item_ExtIEs,
        GNB_CU_UE_F1AP_ID,
        _GNB_DU_Cell_Resource_Configuration_subcarrierSpacing,
        _GNB_DU_Cell_Resource_Configuration_dUFTransmissionPeriodicity,
        _GNB_DU_Cell_Resource_Configuration_dUF_Slot_Config_List,
        _GNB_DU_Cell_Resource_Configuration_hSNATransmissionPeriodicity,
        _GNB_DU_Cell_Resource_Configuration_hsNSASlotConfigList,
        ____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id_tab,
        _____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id_tab_val_Extension_0,
        _____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id_tab_val_Extension_1,
        _____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id_tab_val_Extension_2,
        _____GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id_tab_val_Extension_3,
        ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__id,
        ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__criticality,
        ___GNB_DU_Cell_Resource_Configuration_iE_Extensions__item__extensionValue,
        __GNB_DU_Cell_Resource_Configuration_iE_Extensions__item_,
        _GNB_DU_Cell_Resource_Configuration_iE_Extensions,
        GNB_DU_Cell_Resource_Configuration,
        GNB_DU_Cell_Resource_Configuration_ExtIEs,
        _GNB_DU_Cell_Resource_Configuration_ExtIEs_val_Extension_0,
        _GNB_DU_Cell_Resource_Configuration_ExtIEs_val_Extension_1,
        _GNB_DU_Cell_Resource_Configuration_ExtIEs_val_Extension_2,
        _GNB_DU_Cell_Resource_Configuration_ExtIEs_val_Extension_3,
        GNB_DU_MBS_F1AP_ID,
        GNB_DU_UE_F1AP_ID,
        GNB_DU_ID,
        GNB_CU_Name,
        GNB_DU_Name,
        _Extended_GNB_CU_Name_gNB_CU_NameVisibleString,
        _Extended_GNB_CU_Name_gNB_CU_NameUTF8String,
        ____Extended_GNB_CU_Name_iE_Extensions__item__id_tab,
        ___Extended_GNB_CU_Name_iE_Extensions__item__id,
        ____Extended_GNB_CU_Name_iE_Extensions__item__criticality_tab,
        ___Extended_GNB_CU_Name_iE_Extensions__item__criticality,
        ____Extended_GNB_CU_Name_iE_Extensions__item__extensionValue_tab,
        ___Extended_GNB_CU_Name_iE_Extensions__item__extensionValue,
        __Extended_GNB_CU_Name_iE_Extensions__item_,
        _Extended_GNB_CU_Name_iE_Extensions,
        Extended_GNB_CU_Name,
        Extended_GNB_CU_Name_ExtIEs,
        GNB_CU_NameVisibleString,
        GNB_CU_NameUTF8String,
        _Extended_GNB_DU_Name_gNB_DU_NameVisibleString,
        _Extended_GNB_DU_Name_gNB_DU_NameUTF8String,
        ____Extended_GNB_DU_Name_iE_Extensions__item__id_tab,
        ___Extended_GNB_DU_Name_iE_Extensions__item__id,
        ____Extended_GNB_DU_Name_iE_Extensions__item__criticality_tab,
        ___Extended_GNB_DU_Name_iE_Extensions__item__criticality,
        ____Extended_GNB_DU_Name_iE_Extensions__item__extensionValue_tab,
        ___Extended_GNB_DU_Name_iE_Extensions__item__extensionValue,
        __Extended_GNB_DU_Name_iE_Extensions__item_,
        _Extended_GNB_DU_Name_iE_Extensions,
        Extended_GNB_DU_Name,
        Extended_GNB_DU_Name_ExtIEs,
        GNB_DU_NameVisibleString,
        GNB_DU_NameUTF8String,
        _GNB_DU_Served_Cells_Item_served_Cell_Information,
        _GNB_DU_Served_Cells_Item_gNB_DU_System_Information,
        ____GNB_DU_Served_Cells_Item_iE_Extensions__item__id_tab,
        ___GNB_DU_Served_Cells_Item_iE_Extensions__item__id,
        ____GNB_DU_Served_Cells_Item_iE_Extensions__item__criticality_tab,
        ___GNB_DU_Served_Cells_Item_iE_Extensions__item__criticality,
        ____GNB_DU_Served_Cells_Item_iE_Extensions__item__extensionValue_tab,
        ___GNB_DU_Served_Cells_Item_iE_Extensions__item__extensionValue,
        __GNB_DU_Served_Cells_Item_iE_Extensions__item_,
        _GNB_DU_Served_Cells_Item_iE_Extensions,
        GNB_DU_Served_Cells_Item,
        GNB_DU_Served_Cells_ItemExtIEs,
        _GNB_DU_System_Information_mIB_message,
        _GNB_DU_System_Information_sIB1_message,
        ____GNB_DU_System_Information_iE_Extensions__item__id_tab,
        _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_1,
        _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_2,
        _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_3,
        _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_4,
        _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_5,
        _____GNB_DU_System_Information_iE_Extensions__item__id_tab_val_Extension_6,
        ___GNB_DU_System_Information_iE_Extensions__item__id,
        ___GNB_DU_System_Information_iE_Extensions__item__criticality,
        ___GNB_DU_System_Information_iE_Extensions__item__extensionValue,
        __GNB_DU_System_Information_iE_Extensions__item_,
        _GNB_DU_System_Information_iE_Extensions,
        GNB_DU_System_Information,
        GNB_DU_System_Information_ExtIEs,
        _GNB_DU_System_Information_ExtIEs_val_Extension_0,
        _GNB_DU_System_Information_ExtIEs_val_Extension_1,
        _GNB_DU_System_Information_ExtIEs_val_Extension_2,
        _GNB_DU_System_Information_ExtIEs_val_Extension_3,
        _GNB_DU_System_Information_ExtIEs_val_Extension_4,
        _GNB_DU_System_Information_ExtIEs_val_Extension_5,
        _GNB_DU_System_Information_ExtIEs_val_Extension_6,
        GNB_DUConfigurationQuery,
        GNBDUOverloadInformation,
        _GNB_DU_TNL_Association_To_Remove_Item_tNLAssociationTransportLayerAddress,
        _GNB_DU_TNL_Association_To_Remove_Item_tNLAssociationTransportLayerAddressgNBCU,
        ____GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__id_tab,
        ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__id,
        ____GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality_tab,
        ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__criticality,
        ____GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue_tab,
        ___GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item__extensionValue,
        __GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions__item_,
        _GNB_DU_TNL_Association_To_Remove_Item_iE_Extensions,
        GNB_DU_TNL_Association_To_Remove_Item,
        GNB_DU_TNL_Association_To_Remove_Item_ExtIEs,
        _GNBDUUESliceMaximumBitRateList__item_,
        GNBDUUESliceMaximumBitRateList,
        _GNBDUUESliceMaximumBitRateItem_sNSSAI,
        _GNBDUUESliceMaximumBitRateItem_uESliceMaximumBitRateUL,
        ____GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__id_tab,
        ___GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__id,
        ____GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__criticality_tab,
        ___GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__criticality,
        ____GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__extensionValue_tab,
        ___GNBDUUESliceMaximumBitRateItem_iE_Extensions__item__extensionValue,
        __GNBDUUESliceMaximumBitRateItem_iE_Extensions__item_,
        _GNBDUUESliceMaximumBitRateItem_iE_Extensions,
        GNBDUUESliceMaximumBitRateItem,
        GNBDUUESliceMaximumBitRateItem_ExtIEs,
        _GNB_RxTxTimeDiff_rxTxTimeDiff,
        _GNB_RxTxTimeDiff_additionalPath_List,
        ____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab,
        _____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab_val_Extension_0,
        _____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab_val_Extension_1,
        ___GNB_RxTxTimeDiff_iE_Extensions__item__id,
        ___GNB_RxTxTimeDiff_iE_Extensions__item__criticality,
        ___GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue,
        __GNB_RxTxTimeDiff_iE_Extensions__item_,
        _GNB_RxTxTimeDiff_iE_Extensions,
        GNB_RxTxTimeDiff,
        GNB_RxTxTimeDiff_ExtIEs,
        _GNB_RxTxTimeDiff_ExtIEs_val_Extension_0,
        _GNB_RxTxTimeDiff_ExtIEs_val_Extension_1,
        _GNBRxTxTimeDiffMeas_k0,
        _GNBRxTxTimeDiffMeas_k1,
        _GNBRxTxTimeDiffMeas_k2,
        _GNBRxTxTimeDiffMeas_k3,
        _GNBRxTxTimeDiffMeas_k4,
        _GNBRxTxTimeDiffMeas_k5,
        ___GNBRxTxTimeDiffMeas_choice_extension_id_tab,
        __GNBRxTxTimeDiffMeas_choice_extension_id,
        ___GNBRxTxTimeDiffMeas_choice_extension_criticality_tab,
        __GNBRxTxTimeDiffMeas_choice_extension_criticality,
        ___GNBRxTxTimeDiffMeas_choice_extension_value_tab,
        __GNBRxTxTimeDiffMeas_choice_extension_value,
        _GNBRxTxTimeDiffMeas_choice_extension,
        GNBRxTxTimeDiffMeas,
        GNBRxTxTimeDiffMeas_ExtIEs,
        GNBSetID,
        GTP_TEID,
        _GTPTLAs__item_,
        GTPTLAs,
        _GTPTLA_Item_gTPTransportLayerAddress,
        ____GTPTLA_Item_iE_Extensions__item__id_tab,
        ___GTPTLA_Item_iE_Extensions__item__id,
        ____GTPTLA_Item_iE_Extensions__item__criticality_tab,
        ___GTPTLA_Item_iE_Extensions__item__criticality,
        ____GTPTLA_Item_iE_Extensions__item__extensionValue_tab,
        ___GTPTLA_Item_iE_Extensions__item__extensionValue,
        __GTPTLA_Item_iE_Extensions__item_,
        _GTPTLA_Item_iE_Extensions,
        GTPTLA_Item,
        GTPTLA_Item_ExtIEs,
        _GTPTunnel_transportLayerAddress,
        _GTPTunnel_gTP_TEID,
        ____GTPTunnel_iE_Extensions__item__id_tab,
        ___GTPTunnel_iE_Extensions__item__id,
        ____GTPTunnel_iE_Extensions__item__criticality_tab,
        ___GTPTunnel_iE_Extensions__item__criticality,
        ____GTPTunnel_iE_Extensions__item__extensionValue_tab,
        ___GTPTunnel_iE_Extensions__item__extensionValue,
        __GTPTunnel_iE_Extensions__item_,
        _GTPTunnel_iE_Extensions,
        GTPTunnel,
        GTPTunnel_ExtIEs,
        HandoverPreparationInformation,
        _HardwareLoadIndicator_dLHardwareLoadIndicator,
        _HardwareLoadIndicator_uLHardwareLoadIndicator,
        ____HardwareLoadIndicator_iE_Extensions__item__id_tab,
        ___HardwareLoadIndicator_iE_Extensions__item__id,
        ____HardwareLoadIndicator_iE_Extensions__item__criticality_tab,
        ___HardwareLoadIndicator_iE_Extensions__item__criticality,
        ____HardwareLoadIndicator_iE_Extensions__item__extensionValue_tab,
        ___HardwareLoadIndicator_iE_Extensions__item__extensionValue,
        __HardwareLoadIndicator_iE_Extensions__item_,
        _HardwareLoadIndicator_iE_Extensions,
        HardwareLoadIndicator,
        HardwareLoadIndicator_ExtIEs,
        _HSNASlotConfigList__item_,
        HSNASlotConfigList,
        _HSNASlotConfigItem_hSNADownlink,
        _HSNASlotConfigItem_hSNAUplink,
        _HSNASlotConfigItem_hSNAFlexible,
        ____HSNASlotConfigItem_iE_Extensions__item__id_tab,
        ___HSNASlotConfigItem_iE_Extensions__item__id,
        ____HSNASlotConfigItem_iE_Extensions__item__criticality_tab,
        ___HSNASlotConfigItem_iE_Extensions__item__criticality,
        ____HSNASlotConfigItem_iE_Extensions__item__extensionValue_tab,
        ___HSNASlotConfigItem_iE_Extensions__item__extensionValue,
        __HSNASlotConfigItem_iE_Extensions__item_,
        _HSNASlotConfigItem_iE_Extensions,
        HSNASlotConfigItem,
        HSNASlotConfigItem_ExtIEs,
        HSNADownlink,
        HSNAFlexible,
        HSNAUplink,
        HSNATransmissionPeriodicity,
        IAB_Barred,
        IABConditionalRRCMessageDeliveryIndication,
        _IABCongestionIndication_iAB_Congestion_Indication_List,
        ____IABCongestionIndication_iE_Extensions__item__id_tab,
        ___IABCongestionIndication_iE_Extensions__item__id,
        ____IABCongestionIndication_iE_Extensions__item__criticality_tab,
        ___IABCongestionIndication_iE_Extensions__item__criticality,
        ____IABCongestionIndication_iE_Extensions__item__extensionValue_tab,
        ___IABCongestionIndication_iE_Extensions__item__extensionValue,
        __IABCongestionIndication_iE_Extensions__item_,
        _IABCongestionIndication_iE_Extensions,
        IABCongestionIndication,
        IAB_Congestion_Indication_List_ExtIEs,
        _IAB_Congestion_Indication_List__item_,
        IAB_Congestion_Indication_List,
        _IAB_Congestion_Indication_Item_childNodeIdentifier,
        _IAB_Congestion_Indication_Item_bHRLCCHList,
        ____IAB_Congestion_Indication_Item_iE_Extensions__item__id_tab,
        ___IAB_Congestion_Indication_Item_iE_Extensions__item__id,
        ____IAB_Congestion_Indication_Item_iE_Extensions__item__criticality_tab,
        ___IAB_Congestion_Indication_Item_iE_Extensions__item__criticality,
        ____IAB_Congestion_Indication_Item_iE_Extensions__item__extensionValue_tab,
        ___IAB_Congestion_Indication_Item_iE_Extensions__item__extensionValue,
        __IAB_Congestion_Indication_Item_iE_Extensions__item_,
        _IAB_Congestion_Indication_Item_iE_Extensions,
        IAB_Congestion_Indication_Item,
        IAB_Congestion_Indication_ItemExtIEs,
        _IAB_Info_IAB_donor_CU_iAB_STC_Info,
        ____IAB_Info_IAB_donor_CU_iE_Extensions__item__id_tab,
        ___IAB_Info_IAB_donor_CU_iE_Extensions__item__id,
        ____IAB_Info_IAB_donor_CU_iE_Extensions__item__criticality_tab,
        ___IAB_Info_IAB_donor_CU_iE_Extensions__item__criticality,
        ____IAB_Info_IAB_donor_CU_iE_Extensions__item__extensionValue_tab,
        ___IAB_Info_IAB_donor_CU_iE_Extensions__item__extensionValue,
        __IAB_Info_IAB_donor_CU_iE_Extensions__item_,
        _IAB_Info_IAB_donor_CU_iE_Extensions,
        IAB_Info_IAB_donor_CU,
        IAB_Info_IAB_donor_CU_ExtIEs,
        _IAB_Info_IAB_DU_multiplexingInfo,
        _IAB_Info_IAB_DU_iAB_STC_Info,
        ____IAB_Info_IAB_DU_iE_Extensions__item__id_tab,
        ___IAB_Info_IAB_DU_iE_Extensions__item__id,
        ____IAB_Info_IAB_DU_iE_Extensions__item__criticality_tab,
        ___IAB_Info_IAB_DU_iE_Extensions__item__criticality,
        ____IAB_Info_IAB_DU_iE_Extensions__item__extensionValue_tab,
        ___IAB_Info_IAB_DU_iE_Extensions__item__extensionValue,
        __IAB_Info_IAB_DU_iE_Extensions__item_,
        _IAB_Info_IAB_DU_iE_Extensions,
        IAB_Info_IAB_DU,
        IAB_Info_IAB_DU_ExtIEs,
        _IAB_MT_Cell_List__item_,
        IAB_MT_Cell_List,
        _IAB_MT_Cell_List_Item_nRCellIdentity,
        _IAB_MT_Cell_List_Item_dU_RX_MT_RX,
        _IAB_MT_Cell_List_Item_dU_TX_MT_TX,
        _IAB_MT_Cell_List_Item_dU_RX_MT_TX,
        _IAB_MT_Cell_List_Item_dU_TX_MT_RX,
        ____IAB_MT_Cell_List_Item_iE_Extensions__item__id_tab,
        _____IAB_MT_Cell_List_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____IAB_MT_Cell_List_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____IAB_MT_Cell_List_Item_iE_Extensions__item__id_tab_val_Extension_2,
        _____IAB_MT_Cell_List_Item_iE_Extensions__item__id_tab_val_Extension_3,
        ___IAB_MT_Cell_List_Item_iE_Extensions__item__id,
        ___IAB_MT_Cell_List_Item_iE_Extensions__item__criticality,
        ___IAB_MT_Cell_List_Item_iE_Extensions__item__extensionValue,
        __IAB_MT_Cell_List_Item_iE_Extensions__item_,
        _IAB_MT_Cell_List_Item_iE_Extensions,
        IAB_MT_Cell_List_Item,
        IAB_MT_Cell_List_Item_ExtIEs,
        _IAB_MT_Cell_List_Item_ExtIEs_val_Extension_0,
        _IAB_MT_Cell_List_Item_ExtIEs_val_Extension_1,
        _IAB_MT_Cell_List_Item_ExtIEs_val_Extension_2,
        _IAB_MT_Cell_List_Item_ExtIEs_val_Extension_3,
        _IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_fDD,
        _IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_tDD,
        ___IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_id_tab,
        __IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_id,
        ___IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_criticality_tab,
        __IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_criticality,
        ___IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_value_tab,
        __IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension_value,
        _IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_choice_extension,
        IAB_MT_Cell_NA_Resource_Configuration_Mode_Info,
        IAB_MT_Cell_NA_Resource_Configuration_Mode_Info_ExtIEs,
        _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_gNB_DU_Cell_NA_Resource_Configuration_FDD_UL,
        _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_gNB_DU_Cell_NA_Resource_Configuration_FDD_DL,
        _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_uL_FreqInfo,
        _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_uL_Transmission_Bandwidth,
        _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_uL_NR_Carrier_List,
        _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_dL_FreqInfo,
        _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_dL_Transmission_Bandwidth,
        _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_dL_NR_Carrier_List,
        ____IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab,
        ___IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__id,
        ____IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality_tab,
        ___IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality,
        ____IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue_tab,
        ___IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue,
        __IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions__item_,
        _IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_iE_Extensions,
        IAB_MT_Cell_NA_Resource_Configuration_FDD_Info,
        IAB_MT_Cell_NA_Resource_Configuration_FDD_Info_ExtIEs,
        _IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_gNB_DU_Cell_NA_Resourc_Configuration_TDD,
        _IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_nRFreqInfo,
        _IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_transmission_Bandwidth,
        _IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_nR_Carrier_List,
        ____IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__id_tab,
        ___IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__id,
        ____IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality_tab,
        ___IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality,
        ____IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue_tab,
        ___IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue,
        __IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions__item_,
        _IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_iE_Extensions,
        IAB_MT_Cell_NA_Resource_Configuration_TDD_Info,
        IAB_MT_Cell_NA_Resource_Configuration_TDD_Info_ExtIEs,
        _IAB_STC_Info_iAB_STC_Info_List,
        ____IAB_STC_Info_iE_Extensions__item__id_tab,
        ___IAB_STC_Info_iE_Extensions__item__id,
        ____IAB_STC_Info_iE_Extensions__item__criticality_tab,
        ___IAB_STC_Info_iE_Extensions__item__criticality,
        ____IAB_STC_Info_iE_Extensions__item__extensionValue_tab,
        ___IAB_STC_Info_iE_Extensions__item__extensionValue,
        __IAB_STC_Info_iE_Extensions__item_,
        _IAB_STC_Info_iE_Extensions,
        IAB_STC_Info,
        IAB_STC_Info_ExtIEs,
        _IAB_STC_Info_List__item_,
        IAB_STC_Info_List,
        _IAB_STC_Info_Item_sSB_freqInfo,
        _IAB_STC_Info_Item_sSB_subcarrierSpacing,
        _IAB_STC_Info_Item_sSB_transmissionPeriodicity,
        _IAB_STC_Info_Item_sSB_transmissionTimingOffset,
        _IAB_STC_Info_Item_sSB_transmissionBitmap,
        ____IAB_STC_Info_Item_iE_Extensions__item__id_tab,
        ___IAB_STC_Info_Item_iE_Extensions__item__id,
        ____IAB_STC_Info_Item_iE_Extensions__item__criticality_tab,
        ___IAB_STC_Info_Item_iE_Extensions__item__criticality,
        ____IAB_STC_Info_Item_iE_Extensions__item__extensionValue_tab,
        ___IAB_STC_Info_Item_iE_Extensions__item__extensionValue,
        __IAB_STC_Info_Item_iE_Extensions__item_,
        _IAB_STC_Info_Item_iE_Extensions,
        IAB_STC_Info_Item,
        IAB_STC_Info_Item_ExtIEs,
        _IAB_Allocated_TNL_Address_Item_iABTNLAddress,
        _IAB_Allocated_TNL_Address_Item_iABTNLAddressUsage,
        ____IAB_Allocated_TNL_Address_Item_iE_Extensions__item__id_tab,
        ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__id,
        ____IAB_Allocated_TNL_Address_Item_iE_Extensions__item__criticality_tab,
        ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__criticality,
        ____IAB_Allocated_TNL_Address_Item_iE_Extensions__item__extensionValue_tab,
        ___IAB_Allocated_TNL_Address_Item_iE_Extensions__item__extensionValue,
        __IAB_Allocated_TNL_Address_Item_iE_Extensions__item_,
        _IAB_Allocated_TNL_Address_Item_iE_Extensions,
        IAB_Allocated_TNL_Address_Item,
        IAB_Allocated_TNL_Address_Item_ExtIEs,
        _IAB_DU_Cell_Resource_Configuration_Mode_Info_fDD,
        _IAB_DU_Cell_Resource_Configuration_Mode_Info_tDD,
        ___IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_id_tab,
        __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_id,
        ___IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_criticality_tab,
        __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_criticality,
        ___IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_value_tab,
        __IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension_value,
        _IAB_DU_Cell_Resource_Configuration_Mode_Info_choice_extension,
        IAB_DU_Cell_Resource_Configuration_Mode_Info,
        IAB_DU_Cell_Resource_Configuration_Mode_Info_ExtIEs,
        _IAB_DU_Cell_Resource_Configuration_FDD_Info_gNB_DU_Cell_Resource_Configuration_FDD_UL,
        _IAB_DU_Cell_Resource_Configuration_FDD_Info_gNB_DU_Cell_Resource_Configuration_FDD_DL,
        ____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab,
        _____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab_val_Extension_0,
        _____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab_val_Extension_1,
        _____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab_val_Extension_2,
        _____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab_val_Extension_3,
        _____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab_val_Extension_4,
        _____IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id_tab_val_Extension_5,
        ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__id,
        ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__criticality,
        ___IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item__extensionValue,
        __IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions__item_,
        _IAB_DU_Cell_Resource_Configuration_FDD_Info_iE_Extensions,
        IAB_DU_Cell_Resource_Configuration_FDD_Info,
        IAB_DU_Cell_Resource_Configuration_FDD_Info_ExtIEs,
        _IAB_DU_Cell_Resource_Configuration_FDD_Info_ExtIEs_val_Extension_0,
        _IAB_DU_Cell_Resource_Configuration_FDD_Info_ExtIEs_val_Extension_1,
        _IAB_DU_Cell_Resource_Configuration_FDD_Info_ExtIEs_val_Extension_2,
        _IAB_DU_Cell_Resource_Configuration_FDD_Info_ExtIEs_val_Extension_3,
        _IAB_DU_Cell_Resource_Configuration_FDD_Info_ExtIEs_val_Extension_4,
        _IAB_DU_Cell_Resource_Configuration_FDD_Info_ExtIEs_val_Extension_5,
        _IAB_DU_Cell_Resource_Configuration_TDD_Info_gNB_DU_Cell_Resourc_Configuration_TDD,
        ____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id_tab,
        _____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id_tab_val_Extension_0,
        _____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id_tab_val_Extension_1,
        _____IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id_tab_val_Extension_2,
        ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__id,
        ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__criticality,
        ___IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item__extensionValue,
        __IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions__item_,
        _IAB_DU_Cell_Resource_Configuration_TDD_Info_iE_Extensions,
        IAB_DU_Cell_Resource_Configuration_TDD_Info,
        IAB_DU_Cell_Resource_Configuration_TDD_Info_ExtIEs,
        _IAB_DU_Cell_Resource_Configuration_TDD_Info_ExtIEs_val_Extension_0,
        _IAB_DU_Cell_Resource_Configuration_TDD_Info_ExtIEs_val_Extension_1,
        _IAB_DU_Cell_Resource_Configuration_TDD_Info_ExtIEs_val_Extension_2,
        _IABIPv6RequestType_iPv6Address,
        _IABIPv6RequestType_iPv6Prefix,
        ___IABIPv6RequestType_choice_extension_id_tab,
        __IABIPv6RequestType_choice_extension_id,
        ___IABIPv6RequestType_choice_extension_criticality_tab,
        __IABIPv6RequestType_choice_extension_criticality,
        ___IABIPv6RequestType_choice_extension_value_tab,
        __IABIPv6RequestType_choice_extension_value,
        _IABIPv6RequestType_choice_extension,
        IABIPv6RequestType,
        IABIPv6RequestType_ExtIEs,
        _IABTNLAddress_iPv4Address,
        _IABTNLAddress_iPv6Address,
        _IABTNLAddress_iPv6Prefix,
        ___IABTNLAddress_choice_extension_id_tab,
        __IABTNLAddress_choice_extension_id,
        ___IABTNLAddress_choice_extension_criticality_tab,
        __IABTNLAddress_choice_extension_criticality,
        ___IABTNLAddress_choice_extension_value_tab,
        __IABTNLAddress_choice_extension_value,
        _IABTNLAddress_choice_extension,
        IABTNLAddress,
        IABTNLAddress_ExtIEs,
        _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedAllTraffic,
        _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedF1_C,
        _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedF1_U,
        _IABTNLAddressesRequested_tNLAddressesOrPrefixesRequestedNoNF1,
        ____IABTNLAddressesRequested_iE_Extensions__item__id_tab,
        ___IABTNLAddressesRequested_iE_Extensions__item__id,
        ____IABTNLAddressesRequested_iE_Extensions__item__criticality_tab,
        ___IABTNLAddressesRequested_iE_Extensions__item__criticality,
        ____IABTNLAddressesRequested_iE_Extensions__item__extensionValue_tab,
        ___IABTNLAddressesRequested_iE_Extensions__item__extensionValue,
        __IABTNLAddressesRequested_iE_Extensions__item_,
        _IABTNLAddressesRequested_iE_Extensions,
        IABTNLAddressesRequested,
        IABTNLAddressesRequested_ExtIEs,
        _IAB_TNL_Addresses_To_Remove_Item_iABTNLAddress,
        ____IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__id_tab,
        ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__id,
        ____IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__criticality_tab,
        ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__criticality,
        ____IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__extensionValue_tab,
        ___IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item__extensionValue,
        __IAB_TNL_Addresses_To_Remove_Item_iE_Extensions__item_,
        _IAB_TNL_Addresses_To_Remove_Item_iE_Extensions,
        IAB_TNL_Addresses_To_Remove_Item,
        IAB_TNL_Addresses_To_Remove_Item_ExtIEs,
        _IAB_TNL_Addresses_Exception_iABTNLAddressList,
        ____IAB_TNL_Addresses_Exception_iE_Extensions__item__id_tab,
        ___IAB_TNL_Addresses_Exception_iE_Extensions__item__id,
        ____IAB_TNL_Addresses_Exception_iE_Extensions__item__criticality_tab,
        ___IAB_TNL_Addresses_Exception_iE_Extensions__item__criticality,
        ____IAB_TNL_Addresses_Exception_iE_Extensions__item__extensionValue_tab,
        ___IAB_TNL_Addresses_Exception_iE_Extensions__item__extensionValue,
        __IAB_TNL_Addresses_Exception_iE_Extensions__item_,
        _IAB_TNL_Addresses_Exception_iE_Extensions,
        IAB_TNL_Addresses_Exception,
        IAB_TNL_Addresses_Exception_ExtIEs,
        _IABTNLAddressList__item_,
        IABTNLAddressList,
        _IABTNLAddress_Item_iABTNLAddress,
        ____IABTNLAddress_Item_iE_Extensions__item__id_tab,
        ___IABTNLAddress_Item_iE_Extensions__item__id,
        ____IABTNLAddress_Item_iE_Extensions__item__criticality_tab,
        ___IABTNLAddress_Item_iE_Extensions__item__criticality,
        ____IABTNLAddress_Item_iE_Extensions__item__extensionValue_tab,
        ___IABTNLAddress_Item_iE_Extensions__item__extensionValue,
        __IABTNLAddress_Item_iE_Extensions__item_,
        _IABTNLAddress_Item_iE_Extensions,
        IABTNLAddress_Item,
        IABTNLAddress_ItemExtIEs,
        IABTNLAddressUsage,
        _IABv4AddressesRequested_iABv4AddressesRequested,
        ____IABv4AddressesRequested_iE_Extensions__item__id_tab,
        ___IABv4AddressesRequested_iE_Extensions__item__id,
        ____IABv4AddressesRequested_iE_Extensions__item__criticality_tab,
        ___IABv4AddressesRequested_iE_Extensions__item__criticality,
        ____IABv4AddressesRequested_iE_Extensions__item__extensionValue_tab,
        ___IABv4AddressesRequested_iE_Extensions__item__extensionValue,
        __IABv4AddressesRequested_iE_Extensions__item_,
        _IABv4AddressesRequested_iE_Extensions,
        IABv4AddressesRequested,
        IABv4AddressesRequested_ExtIEs,
        _ImplicitFormat_dUFSlotformatIndex,
        ____ImplicitFormat_iE_Extensions__item__id_tab,
        ___ImplicitFormat_iE_Extensions__item__id,
        ____ImplicitFormat_iE_Extensions__item__criticality_tab,
        ___ImplicitFormat_iE_Extensions__item__criticality,
        ____ImplicitFormat_iE_Extensions__item__extensionValue_tab,
        ___ImplicitFormat_iE_Extensions__item__extensionValue,
        __ImplicitFormat_iE_Extensions__item_,
        _ImplicitFormat_iE_Extensions,
        ImplicitFormat,
        ImplicitFormat_ExtIEs,
        IgnorePRACHConfiguration,
        IgnoreResourceCoordinationContainer,
        InactivityMonitoringRequest,
        InactivityMonitoringResponse,
        InterfacesToTrace,
        _IntendedTDD_DL_ULConfig_nRSCS,
        _IntendedTDD_DL_ULConfig_nRCP,
        _IntendedTDD_DL_ULConfig_nRDLULTxPeriodicity,
        _IntendedTDD_DL_ULConfig_slot_Configuration_List,
        ____IntendedTDD_DL_ULConfig_iE_Extensions__item__id_tab,
        ___IntendedTDD_DL_ULConfig_iE_Extensions__item__id,
        ____IntendedTDD_DL_ULConfig_iE_Extensions__item__criticality_tab,
        ___IntendedTDD_DL_ULConfig_iE_Extensions__item__criticality,
        ____IntendedTDD_DL_ULConfig_iE_Extensions__item__extensionValue_tab,
        ___IntendedTDD_DL_ULConfig_iE_Extensions__item__extensionValue,
        __IntendedTDD_DL_ULConfig_iE_Extensions__item_,
        _IntendedTDD_DL_ULConfig_iE_Extensions,
        IntendedTDD_DL_ULConfig,
        InterFrequencyConfig_NoGap,
        IngressNonF1terminatingTopologyIndicator,
        IntendedTDD_DL_ULConfig_ExtIEs,
        _IPHeaderInformation_destinationIABTNLAddress,
        _IPHeaderInformation_dsInformationList,
        _IPHeaderInformation_iPv6FlowLabel,
        ____IPHeaderInformation_iE_Extensions__item__id_tab,
        ___IPHeaderInformation_iE_Extensions__item__id,
        ____IPHeaderInformation_iE_Extensions__item__criticality_tab,
        ___IPHeaderInformation_iE_Extensions__item__criticality,
        ____IPHeaderInformation_iE_Extensions__item__extensionValue_tab,
        ___IPHeaderInformation_iE_Extensions__item__extensionValue,
        __IPHeaderInformation_iE_Extensions__item_,
        _IPHeaderInformation_iE_Extensions,
        IPHeaderInformation,
        IPHeaderInformation_ItemExtIEs,
        _IPtolayer2TrafficMappingInfo_iPtolayer2TrafficMappingInfoToAdd,
        _IPtolayer2TrafficMappingInfo_iPtolayer2TrafficMappingInfoToRemove,
        ____IPtolayer2TrafficMappingInfo_iE_Extensions__item__id_tab,
        ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__id,
        ____IPtolayer2TrafficMappingInfo_iE_Extensions__item__criticality_tab,
        ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__criticality,
        ____IPtolayer2TrafficMappingInfo_iE_Extensions__item__extensionValue_tab,
        ___IPtolayer2TrafficMappingInfo_iE_Extensions__item__extensionValue,
        __IPtolayer2TrafficMappingInfo_iE_Extensions__item_,
        _IPtolayer2TrafficMappingInfo_iE_Extensions,
        IPtolayer2TrafficMappingInfo,
        _IPtolayer2TrafficMappingInfoList__item_,
        IPtolayer2TrafficMappingInfoList,
        _IPtolayer2TrafficMappingInfo_Item_mappingInformationIndex,
        _IPtolayer2TrafficMappingInfo_Item_iPHeaderInformation,
        _IPtolayer2TrafficMappingInfo_Item_bHInfo,
        ____IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__id_tab,
        ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__id,
        ____IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__criticality_tab,
        ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__criticality,
        ____IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__extensionValue_tab,
        ___IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item__extensionValue,
        __IPtolayer2TrafficMappingInfo_Item_iE_Extensions__item_,
        _IPtolayer2TrafficMappingInfo_Item_iE_Extensions,
        IPtolayer2TrafficMappingInfo_Item,
        IPtolayer2TrafficMappingInfo_ItemExtIEs,
        _L139Info_prachSCS,
        _L139Info_rootSequenceIndex,
        ____L139Info_iE_Extension__item__id_tab,
        ___L139Info_iE_Extension__item__id,
        ____L139Info_iE_Extension__item__criticality_tab,
        ___L139Info_iE_Extension__item__criticality,
        ____L139Info_iE_Extension__item__extensionValue_tab,
        ___L139Info_iE_Extension__item__extensionValue,
        __L139Info_iE_Extension__item_,
        _L139Info_iE_Extension,
        L139Info,
        L139Info_ExtIEs,
        _L839Info_rootSequenceIndex,
        _L839Info_restrictedSetConfig,
        ____L839Info_iE_Extension__item__id_tab,
        ___L839Info_iE_Extension__item__id,
        ____L839Info_iE_Extension__item__criticality_tab,
        ___L839Info_iE_Extension__item__criticality,
        ____L839Info_iE_Extension__item__extensionValue_tab,
        ___L839Info_iE_Extension__item__extensionValue,
        __L839Info_iE_Extension__item_,
        _L839Info_iE_Extension,
        L839Info,
        L839Info_ExtIEs,
        _L571Info_prachSCSForL571,
        _L571Info_rootSequenceIndex,
        ____L571Info_iE_Extension__item__id_tab,
        ___L571Info_iE_Extension__item__id,
        ____L571Info_iE_Extension__item__criticality_tab,
        ___L571Info_iE_Extension__item__criticality,
        ____L571Info_iE_Extension__item__extensionValue_tab,
        ___L571Info_iE_Extension__item__extensionValue,
        __L571Info_iE_Extension__item_,
        _L571Info_iE_Extension,
        L571Info,
        L571Info_ExtIEs,
        _L1151Info_prachSCSForL1151,
        _L1151Info_rootSequenceIndex,
        ____L1151Info_iE_Extension__item__id_tab,
        ___L1151Info_iE_Extension__item__id,
        ____L1151Info_iE_Extension__item__criticality_tab,
        ___L1151Info_iE_Extension__item__criticality,
        ____L1151Info_iE_Extension__item__extensionValue_tab,
        ___L1151Info_iE_Extension__item__extensionValue,
        __L1151Info_iE_Extension__item_,
        _L1151Info_iE_Extension,
        L1151Info,
        L1151Info_ExtIEs,
        LastUsedCellIndication,
        LCID,
        _LCS_to_GCS_Translation_alpha,
        _LCS_to_GCS_Translation_beta,
        _LCS_to_GCS_Translation_gamma,
        ____LCS_to_GCS_Translation_iE_Extensions__item__id_tab,
        ___LCS_to_GCS_Translation_iE_Extensions__item__id,
        ____LCS_to_GCS_Translation_iE_Extensions__item__criticality_tab,
        ___LCS_to_GCS_Translation_iE_Extensions__item__criticality,
        ____LCS_to_GCS_Translation_iE_Extensions__item__extensionValue_tab,
        ___LCS_to_GCS_Translation_iE_Extensions__item__extensionValue,
        __LCS_to_GCS_Translation_iE_Extensions__item_,
        _LCS_to_GCS_Translation_iE_Extensions,
        LCS_to_GCS_Translation,
        LCS_to_GCS_Translation_ExtIEs,
        _LCStoGCSTranslationList__item_,
        LCStoGCSTranslationList,
        _LCStoGCSTranslation_alpha,
        _LCStoGCSTranslation_alpha_fine,
        _LCStoGCSTranslation_beta,
        _LCStoGCSTranslation_beta_fine,
        _LCStoGCSTranslation_gamma,
        _LCStoGCSTranslation_gamma_fine,
        ____LCStoGCSTranslation_iE_Extensions__item__id_tab,
        ___LCStoGCSTranslation_iE_Extensions__item__id,
        ____LCStoGCSTranslation_iE_Extensions__item__criticality_tab,
        ___LCStoGCSTranslation_iE_Extensions__item__criticality,
        ____LCStoGCSTranslation_iE_Extensions__item__extensionValue_tab,
        ___LCStoGCSTranslation_iE_Extensions__item__extensionValue,
        __LCStoGCSTranslation_iE_Extensions__item_,
        _LCStoGCSTranslation_iE_Extensions,
        LCStoGCSTranslation,
        LCStoGCSTranslation_ExtIEs,
        LMF_MeasurementID,
        LMF_UE_MeasurementID,
        _LocationDependentMBSF1UInformation__item_,
        LocationDependentMBSF1UInformation,
        _LocationDependentMBSF1UInformation_Item_mbsAreaSession_ID,
        _LocationDependentMBSF1UInformation_Item_mbs_f1u_info_at_CU,
        ____LocationDependentMBSF1UInformation_Item_iE_Extensions__item__id_tab,
        ___LocationDependentMBSF1UInformation_Item_iE_Extensions__item__id,
        ____LocationDependentMBSF1UInformation_Item_iE_Extensions__item__criticality_tab,
        ___LocationDependentMBSF1UInformation_Item_iE_Extensions__item__criticality,
        ____LocationDependentMBSF1UInformation_Item_iE_Extensions__item__extensionValue_tab,
        ___LocationDependentMBSF1UInformation_Item_iE_Extensions__item__extensionValue,
        __LocationDependentMBSF1UInformation_Item_iE_Extensions__item_,
        _LocationDependentMBSF1UInformation_Item_iE_Extensions,
        LocationDependentMBSF1UInformation_Item,
        LocationDependentMBSF1UInformation_Item_ExtIEs,
        LocationMeasurementInformation,
        _LocationUncertainty_horizontalUncertainty,
        _LocationUncertainty_horizontalConfidence,
        _LocationUncertainty_verticalUncertainty,
        _LocationUncertainty_verticalConfidence,
        ____LocationUncertainty_iE_Extensions__item__id_tab,
        ___LocationUncertainty_iE_Extensions__item__id,
        ____LocationUncertainty_iE_Extensions__item__criticality_tab,
        ___LocationUncertainty_iE_Extensions__item__criticality,
        ____LocationUncertainty_iE_Extensions__item__extensionValue_tab,
        ___LocationUncertainty_iE_Extensions__item__extensionValue,
        __LocationUncertainty_iE_Extensions__item_,
        _LocationUncertainty_iE_Extensions,
        LocationUncertainty,
        LocationUncertainty_ExtIEs,
        LongDRXCycleLength,
        LowerLayerPresenceStatusChange,
        LoS_NLoSIndicatorHard,
        LoS_NLoSIndicatorSoft,
        _LoS_NLoSInformation_loS_NLoSIndicatorSoft,
        _LoS_NLoSInformation_loS_NLoSIndicatorHard,
        ___LoS_NLoSInformation_choice_Extension_id_tab,
        __LoS_NLoSInformation_choice_Extension_id,
        ___LoS_NLoSInformation_choice_Extension_criticality_tab,
        __LoS_NLoSInformation_choice_Extension_criticality,
        ___LoS_NLoSInformation_choice_Extension_value_tab,
        __LoS_NLoSInformation_choice_Extension_value,
        _LoS_NLoSInformation_choice_Extension,
        LoS_NLoSInformation,
        LoS_NLoSInformation_ExtIEs,
        _LTEUESidelinkAggregateMaximumBitrate_uELTESidelinkAggregateMaximumBitrate,
        ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab,
        ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id,
        ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab,
        ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality,
        ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab,
        ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue,
        __LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item_,
        _LTEUESidelinkAggregateMaximumBitrate_iE_Extensions,
        LTEUESidelinkAggregateMaximumBitrate,
        LTEUESidelinkAggregateMaximumBitrate_ExtIEs,
        _LTEV2XServicesAuthorized_vehicleUE,
        _LTEV2XServicesAuthorized_pedestrianUE,
        ____LTEV2XServicesAuthorized_iE_Extensions__item__id_tab,
        ___LTEV2XServicesAuthorized_iE_Extensions__item__id,
        ____LTEV2XServicesAuthorized_iE_Extensions__item__criticality_tab,
        ___LTEV2XServicesAuthorized_iE_Extensions__item__criticality,
        ____LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab,
        ___LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue,
        __LTEV2XServicesAuthorized_iE_Extensions__item_,
        _LTEV2XServicesAuthorized_iE_Extensions,
        LTEV2XServicesAuthorized,
        LTEV2XServicesAuthorized_ExtIEs,
        MappingInformationIndex,
        _MappingInformationtoRemove__item_,
        MappingInformationtoRemove,
        MaskedIMEISV,
        MaxDataBurstVolume,
        MaxPacketLossRate,
        MBS_Broadcast_NeighbourCellList,
        _MBS_Flows_Mapped_To_MRB_List__item_,
        MBS_Flows_Mapped_To_MRB_List,
        _MBS_Flows_Mapped_To_MRB_Item_mBS_QoSFlowIdentifier,
        _MBS_Flows_Mapped_To_MRB_Item_mbs_QoSFlowLevelQoSParameters,
        ____MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__id_tab,
        ___MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__id,
        ____MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__criticality_tab,
        ___MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__criticality,
        ____MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__extensionValue_tab,
        ___MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item__extensionValue,
        __MBS_Flows_Mapped_To_MRB_Item_iE_Extensions__item_,
        _MBS_Flows_Mapped_To_MRB_Item_iE_Extensions,
        MBS_Flows_Mapped_To_MRB_Item,
        MBS_Flows_Mapped_To_MRB_Item_ExtIEs,
        _MBSF1UInformation_mbs_f1u_info,
        ____MBSF1UInformation_iE_Extensions__item__id_tab,
        ___MBSF1UInformation_iE_Extensions__item__id,
        ____MBSF1UInformation_iE_Extensions__item__criticality_tab,
        ___MBSF1UInformation_iE_Extensions__item__criticality,
        ____MBSF1UInformation_iE_Extensions__item__extensionValue_tab,
        ___MBSF1UInformation_iE_Extensions__item__extensionValue,
        __MBSF1UInformation_iE_Extensions__item_,
        _MBSF1UInformation_iE_Extensions,
        MBSF1UInformation,
        MBSF1UInformation_ExtIEs,
        MBSInterestIndication,
        _MBS_Session_ID_tMGI,
        _MBS_Session_ID_nID,
        ____MBS_Session_ID_iE_Extensions__item__id_tab,
        ___MBS_Session_ID_iE_Extensions__item__id,
        ____MBS_Session_ID_iE_Extensions__item__criticality_tab,
        ___MBS_Session_ID_iE_Extensions__item__criticality,
        ____MBS_Session_ID_iE_Extensions__item__extensionValue_tab,
        ___MBS_Session_ID_iE_Extensions__item__extensionValue,
        __MBS_Session_ID_iE_Extensions__item_,
        _MBS_Session_ID_iE_Extensions,
        MBS_Session_ID,
        MBS_Session_ID_ExtIEs,
        MBS_Area_Session_ID,
        _MBS_CUtoDURRCInformation_mBS_Broadcast_Cell_List,
        _MBS_CUtoDURRCInformation_mBS_Broadcast_MRB_List,
        ____MBS_CUtoDURRCInformation_iE_Extensions__item__id_tab,
        ___MBS_CUtoDURRCInformation_iE_Extensions__item__id,
        ____MBS_CUtoDURRCInformation_iE_Extensions__item__criticality_tab,
        ___MBS_CUtoDURRCInformation_iE_Extensions__item__criticality,
        ____MBS_CUtoDURRCInformation_iE_Extensions__item__extensionValue_tab,
        ___MBS_CUtoDURRCInformation_iE_Extensions__item__extensionValue,
        __MBS_CUtoDURRCInformation_iE_Extensions__item_,
        _MBS_CUtoDURRCInformation_iE_Extensions,
        MBS_CUtoDURRCInformation,
        MBS_CUtoDURRCInformation_ExtIEs,
        _MBS_Broadcast_Cell_List__item_,
        MBS_Broadcast_Cell_List,
        _MBS_Broadcast_Cell_Item_nRCGI,
        _MBS_Broadcast_Cell_Item_mtch_neighbourCell,
        ____MBS_Broadcast_Cell_Item_iE_Extensions__item__id_tab,
        ___MBS_Broadcast_Cell_Item_iE_Extensions__item__id,
        ____MBS_Broadcast_Cell_Item_iE_Extensions__item__criticality_tab,
        ___MBS_Broadcast_Cell_Item_iE_Extensions__item__criticality,
        ____MBS_Broadcast_Cell_Item_iE_Extensions__item__extensionValue_tab,
        ___MBS_Broadcast_Cell_Item_iE_Extensions__item__extensionValue,
        __MBS_Broadcast_Cell_Item_iE_Extensions__item_,
        _MBS_Broadcast_Cell_Item_iE_Extensions,
        MBS_Broadcast_Cell_Item,
        MBS_Broadcast_Cell_Item_ExtIEs,
        _MBS_Broadcast_MRB_List__item_,
        MBS_Broadcast_MRB_List,
        _MBS_Broadcast_MRB_Item_mRB_ID,
        _MBS_Broadcast_MRB_Item_mRB_PDCP_Config_Broadcast,
        ____MBS_Broadcast_MRB_Item_iE_Extensions__item__id_tab,
        ___MBS_Broadcast_MRB_Item_iE_Extensions__item__id,
        ____MBS_Broadcast_MRB_Item_iE_Extensions__item__criticality_tab,
        ___MBS_Broadcast_MRB_Item_iE_Extensions__item__criticality,
        ____MBS_Broadcast_MRB_Item_iE_Extensions__item__extensionValue_tab,
        ___MBS_Broadcast_MRB_Item_iE_Extensions__item__extensionValue,
        __MBS_Broadcast_MRB_Item_iE_Extensions__item_,
        _MBS_Broadcast_MRB_Item_iE_Extensions,
        MBS_Broadcast_MRB_Item,
        MBS_Broadcast_MRB_Item_ExtIEs,
        _MBSMulticastF1UContextDescriptor_multicastF1UContextReferenceF1,
        _MBSMulticastF1UContextDescriptor_mc_F1UCtxtusage,
        _MBSMulticastF1UContextDescriptor_mbsAreaSession,
        ____MBSMulticastF1UContextDescriptor_iE_Extensions__item__id_tab,
        ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__id,
        ____MBSMulticastF1UContextDescriptor_iE_Extensions__item__criticality_tab,
        ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__criticality,
        ____MBSMulticastF1UContextDescriptor_iE_Extensions__item__extensionValue_tab,
        ___MBSMulticastF1UContextDescriptor_iE_Extensions__item__extensionValue,
        __MBSMulticastF1UContextDescriptor_iE_Extensions__item_,
        _MBSMulticastF1UContextDescriptor_iE_Extensions,
        MBSMulticastF1UContextDescriptor,
        MBSMulticastF1UContextDescriptor_ExtIEs,
        _MulticastF1UContext_ToBeSetup_Item_mRB_ID,
        _MulticastF1UContext_ToBeSetup_Item_mbs_f1u_info_at_DU,
        _MulticastF1UContext_ToBeSetup_Item_mbsProgressInformation,
        ____MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__id_tab,
        ___MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__id,
        ____MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__criticality_tab,
        ___MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__criticality,
        ____MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab,
        ___MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item__extensionValue,
        __MulticastF1UContext_ToBeSetup_Item_iE_Extensions__item_,
        _MulticastF1UContext_ToBeSetup_Item_iE_Extensions,
        MulticastF1UContext_ToBeSetup_Item,
        MulticastF1UContext_ToBeSetup_Item_ExtIEs,
        _MulticastF1UContext_Setup_Item_mRB_ID,
        _MulticastF1UContext_Setup_Item_mbs_f1u_info_at_CU,
        ____MulticastF1UContext_Setup_Item_iE_Extensions__item__id_tab,
        ___MulticastF1UContext_Setup_Item_iE_Extensions__item__id,
        ____MulticastF1UContext_Setup_Item_iE_Extensions__item__criticality_tab,
        ___MulticastF1UContext_Setup_Item_iE_Extensions__item__criticality,
        ____MulticastF1UContext_Setup_Item_iE_Extensions__item__extensionValue_tab,
        ___MulticastF1UContext_Setup_Item_iE_Extensions__item__extensionValue,
        __MulticastF1UContext_Setup_Item_iE_Extensions__item_,
        _MulticastF1UContext_Setup_Item_iE_Extensions,
        MulticastF1UContext_Setup_Item,
        MulticastF1UContext_Setup_Item_ExtIEs,
        _MulticastF1UContext_FailedToBeSetup_Item_mRB_ID,
        _MulticastF1UContext_FailedToBeSetup_Item_cause,
        ____MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__id_tab,
        ___MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__id,
        ____MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab,
        ___MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__criticality,
        ____MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab,
        ___MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item__extensionValue,
        __MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions__item_,
        _MulticastF1UContext_FailedToBeSetup_Item_iE_Extensions,
        MulticastF1UContext_FailedToBeSetup_Item,
        MulticastF1UContext_FailedToBeSetup_Item_ExtIEs,
        MBSPTPRetransmissionTunnelRequired,
        _MBS_ServiceArea_locationindependent,
        _MBS_ServiceArea_locationdependent,
        ___MBS_ServiceArea_choice_Extensions_id_tab,
        __MBS_ServiceArea_choice_Extensions_id,
        ___MBS_ServiceArea_choice_Extensions_criticality_tab,
        __MBS_ServiceArea_choice_Extensions_criticality,
        ___MBS_ServiceArea_choice_Extensions_value_tab,
        __MBS_ServiceArea_choice_Extensions_value,
        _MBS_ServiceArea_choice_Extensions,
        MBS_ServiceArea,
        MBSServiceArea_ExtIEs,
        _MBS_ServiceAreaInformation_mBS_ServiceAreaCellList,
        _MBS_ServiceAreaInformation_mBS_ServiceAreaTAIList,
        ____MBS_ServiceAreaInformation_iE_Extensions__item__id_tab,
        ___MBS_ServiceAreaInformation_iE_Extensions__item__id,
        ____MBS_ServiceAreaInformation_iE_Extensions__item__criticality_tab,
        ___MBS_ServiceAreaInformation_iE_Extensions__item__criticality,
        ____MBS_ServiceAreaInformation_iE_Extensions__item__extensionValue_tab,
        ___MBS_ServiceAreaInformation_iE_Extensions__item__extensionValue,
        __MBS_ServiceAreaInformation_iE_Extensions__item_,
        _MBS_ServiceAreaInformation_iE_Extensions,
        MBS_ServiceAreaInformation,
        MBS_ServiceAreaInformation_ExtIEs,
        _MBS_ServiceAreaCellList__item_,
        MBS_ServiceAreaCellList,
        _MBS_ServiceAreaTAIList__item_,
        MBS_ServiceAreaTAIList,
        _MBS_ServiceAreaTAIList_Item_plmn_ID,
        _MBS_ServiceAreaTAIList_Item_five5_TAC,
        ____MBS_ServiceAreaTAIList_Item_iE_Extensions__item__id_tab,
        ___MBS_ServiceAreaTAIList_Item_iE_Extensions__item__id,
        ____MBS_ServiceAreaTAIList_Item_iE_Extensions__item__criticality_tab,
        ___MBS_ServiceAreaTAIList_Item_iE_Extensions__item__criticality,
        ____MBS_ServiceAreaTAIList_Item_iE_Extensions__item__extensionValue_tab,
        ___MBS_ServiceAreaTAIList_Item_iE_Extensions__item__extensionValue,
        __MBS_ServiceAreaTAIList_Item_iE_Extensions__item_,
        _MBS_ServiceAreaTAIList_Item_iE_Extensions,
        MBS_ServiceAreaTAIList_Item,
        MBS_ServiceAreaTAIList_Item_ExtIEs,
        _MBS_ServiceAreaInformationList__item_,
        MBS_ServiceAreaInformationList,
        _MBS_ServiceAreaInformationItem_mBS_AreaSessionID,
        _MBS_ServiceAreaInformationItem_mBS_ServiceAreaInformation,
        ____MBS_ServiceAreaInformationItem_iE_Extensions__item__id_tab,
        ___MBS_ServiceAreaInformationItem_iE_Extensions__item__id,
        ____MBS_ServiceAreaInformationItem_iE_Extensions__item__criticality_tab,
        ___MBS_ServiceAreaInformationItem_iE_Extensions__item__criticality,
        ____MBS_ServiceAreaInformationItem_iE_Extensions__item__extensionValue_tab,
        ___MBS_ServiceAreaInformationItem_iE_Extensions__item__extensionValue,
        __MBS_ServiceAreaInformationItem_iE_Extensions__item_,
        _MBS_ServiceAreaInformationItem_iE_Extensions,
        MBS_ServiceAreaInformationItem,
        MBS_ServiceAreaInformationItem_ExtIEs,
        _MC_PagingCell_Item_nRCGI,
        ____MC_PagingCell_Item_iE_Extensions__item__id_tab,
        ___MC_PagingCell_Item_iE_Extensions__item__id,
        ____MC_PagingCell_Item_iE_Extensions__item__criticality_tab,
        ___MC_PagingCell_Item_iE_Extensions__item__criticality,
        ____MC_PagingCell_Item_iE_Extensions__item__extensionValue_tab,
        ___MC_PagingCell_Item_iE_Extensions__item__extensionValue,
        __MC_PagingCell_Item_iE_Extensions__item_,
        _MC_PagingCell_Item_iE_Extensions,
        MC_PagingCell_Item,
        MC_PagingCell_ItemExtIEs,
        MIB_message,
        MeasConfig,
        MeasGapConfig,
        MeasGapSharingConfig,
        PosMeasurementAmount,
        MeasurementBeamInfoRequest,
        _MeasurementBeamInfo_pRS_Resource_ID,
        _MeasurementBeamInfo_pRS_Resource_Set_ID,
        _MeasurementBeamInfo_sSB_Index,
        ____MeasurementBeamInfo_iE_Extensions__item__id_tab,
        ___MeasurementBeamInfo_iE_Extensions__item__id,
        ____MeasurementBeamInfo_iE_Extensions__item__criticality_tab,
        ___MeasurementBeamInfo_iE_Extensions__item__criticality,
        ____MeasurementBeamInfo_iE_Extensions__item__extensionValue_tab,
        ___MeasurementBeamInfo_iE_Extensions__item__extensionValue,
        __MeasurementBeamInfo_iE_Extensions__item_,
        _MeasurementBeamInfo_iE_Extensions,
        MeasurementBeamInfo,
        MeasurementBeamInfo_ExtIEs,
        MeasurementTimingConfiguration,
        MessageIdentifier,
        MeasurementTimeOccasion,
        MeasurementCharacteristicsRequestIndicator,
        _MRB_ProgressInformation_pdcp_SN12,
        _MRB_ProgressInformation_pdcp_SN18,
        ___MRB_ProgressInformation_choice_extension_id_tab,
        __MRB_ProgressInformation_choice_extension_id,
        ___MRB_ProgressInformation_choice_extension_criticality_tab,
        __MRB_ProgressInformation_choice_extension_criticality,
        ___MRB_ProgressInformation_choice_extension_value_tab,
        __MRB_ProgressInformation_choice_extension_value,
        _MRB_ProgressInformation_choice_extension,
        MRB_ProgressInformation,
        MRB_ProgressInformation_ExtIEs,
        MulticastF1UContextReferenceF1,
        MulticastF1UContextReferenceCU,
        _MultipleULAoA_multipleULAoA,
        ____MultipleULAoA_iE_Extensions__item__id_tab,
        ___MultipleULAoA_iE_Extensions__item__id,
        ____MultipleULAoA_iE_Extensions__item__criticality_tab,
        ___MultipleULAoA_iE_Extensions__item__criticality,
        ____MultipleULAoA_iE_Extensions__item__extensionValue_tab,
        ___MultipleULAoA_iE_Extensions__item__extensionValue,
        __MultipleULAoA_iE_Extensions__item_,
        _MultipleULAoA_iE_Extensions,
        MultipleULAoA,
        MultipleULAoA_ExtIEs,
        _MultipleULAoA_List__item_,
        MultipleULAoA_List,
        _MultipleULAoA_Item_uL_AoA,
        _MultipleULAoA_Item_ul_ZoA,
        ___MultipleULAoA_Item_choice_extension_id_tab,
        __MultipleULAoA_Item_choice_extension_id,
        ___MultipleULAoA_Item_choice_extension_criticality_tab,
        __MultipleULAoA_Item_choice_extension_criticality,
        ___MultipleULAoA_Item_choice_extension_value_tab,
        __MultipleULAoA_Item_choice_extension_value,
        _MultipleULAoA_Item_choice_extension,
        MultipleULAoA_Item,
        MultipleULAoA_Item_ExtIEs,
        MDTPollutedMeasurementIndicator,
        MRB_ID,
        _MulticastMBSSessionList__item_,
        MulticastMBSSessionList,
        _MulticastMBSSessionList_Item_mbsSessionId,
        ____MulticastMBSSessionList_Item_iE_Extensions__item__id_tab,
        ___MulticastMBSSessionList_Item_iE_Extensions__item__id,
        ____MulticastMBSSessionList_Item_iE_Extensions__item__criticality_tab,
        ___MulticastMBSSessionList_Item_iE_Extensions__item__criticality,
        ____MulticastMBSSessionList_Item_iE_Extensions__item__extensionValue_tab,
        ___MulticastMBSSessionList_Item_iE_Extensions__item__extensionValue,
        __MulticastMBSSessionList_Item_iE_Extensions__item_,
        _MulticastMBSSessionList_Item_iE_Extensions,
        MulticastMBSSessionList_Item,
        MulticastMBSSessionList_Item_ExtIEs,
        _MulticastMRBs_FailedToBeModified_Item_mRB_ID,
        _MulticastMRBs_FailedToBeModified_Item_cause,
        ____MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__id_tab,
        ___MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__id,
        ____MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__criticality_tab,
        ___MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__criticality,
        ____MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab,
        ___MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue,
        __MulticastMRBs_FailedToBeModified_Item_iE_Extensions__item_,
        _MulticastMRBs_FailedToBeModified_Item_iE_Extensions,
        MulticastMRBs_FailedToBeModified_Item,
        MulticastMRBs_FailedtoBeModified_Item_ExtIEs,
        _MulticastMRBs_FailedToBeSetup_Item_mRB_ID,
        _MulticastMRBs_FailedToBeSetup_Item_cause,
        ____MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab,
        ___MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__id,
        ____MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab,
        ___MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality,
        ____MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab,
        ___MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue,
        __MulticastMRBs_FailedToBeSetup_Item_iE_Extensions__item_,
        _MulticastMRBs_FailedToBeSetup_Item_iE_Extensions,
        MulticastMRBs_FailedToBeSetup_Item,
        MulticastMRBs_FailedToBeSetup_Item_ExtIEs,
        _MulticastMRBs_FailedToBeSetupMod_Item_mRB_ID,
        _MulticastMRBs_FailedToBeSetupMod_Item_cause,
        ____MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab,
        ___MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id,
        ____MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab,
        ___MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality,
        ____MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue,
        __MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions__item_,
        _MulticastMRBs_FailedToBeSetupMod_Item_iE_Extensions,
        MulticastMRBs_FailedToBeSetupMod_Item,
        MulticastMRBs_FailedToBeSetupMod_Item_ExtIEs,
        _MulticastMRBs_Modified_Item_mRB_ID,
        ____MulticastMRBs_Modified_Item_iE_Extensions__item__id_tab,
        ___MulticastMRBs_Modified_Item_iE_Extensions__item__id,
        ____MulticastMRBs_Modified_Item_iE_Extensions__item__criticality_tab,
        ___MulticastMRBs_Modified_Item_iE_Extensions__item__criticality,
        ____MulticastMRBs_Modified_Item_iE_Extensions__item__extensionValue_tab,
        ___MulticastMRBs_Modified_Item_iE_Extensions__item__extensionValue,
        __MulticastMRBs_Modified_Item_iE_Extensions__item_,
        _MulticastMRBs_Modified_Item_iE_Extensions,
        MulticastMRBs_Modified_Item,
        MulticastMRBs_Modified_Item_ExtIEs,
        _MulticastMRBs_Setup_Item_mRB_ID,
        ____MulticastMRBs_Setup_Item_iE_Extensions__item__id_tab,
        ___MulticastMRBs_Setup_Item_iE_Extensions__item__id,
        ____MulticastMRBs_Setup_Item_iE_Extensions__item__criticality_tab,
        ___MulticastMRBs_Setup_Item_iE_Extensions__item__criticality,
        ____MulticastMRBs_Setup_Item_iE_Extensions__item__extensionValue_tab,
        ___MulticastMRBs_Setup_Item_iE_Extensions__item__extensionValue,
        __MulticastMRBs_Setup_Item_iE_Extensions__item_,
        _MulticastMRBs_Setup_Item_iE_Extensions,
        MulticastMRBs_Setup_Item,
        MulticastMRBs_Setup_Item_ExtIEs,
        _MulticastMRBs_SetupMod_Item_mRB_ID,
        ____MulticastMRBs_SetupMod_Item_iE_Extensions__item__id_tab,
        ___MulticastMRBs_SetupMod_Item_iE_Extensions__item__id,
        ____MulticastMRBs_SetupMod_Item_iE_Extensions__item__criticality_tab,
        ___MulticastMRBs_SetupMod_Item_iE_Extensions__item__criticality,
        ____MulticastMRBs_SetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___MulticastMRBs_SetupMod_Item_iE_Extensions__item__extensionValue,
        __MulticastMRBs_SetupMod_Item_iE_Extensions__item_,
        _MulticastMRBs_SetupMod_Item_iE_Extensions,
        MulticastMRBs_SetupMod_Item,
        MulticastMRBs_SetupMod_Item_ExtIEs,
        _MulticastMRBs_ToBeModified_Item_mRB_ID,
        _MulticastMRBs_ToBeModified_Item_mRB_QoSInformation,
        _MulticastMRBs_ToBeModified_Item_mBS_Flows_Mapped_To_MRB_List,
        _MulticastMRBs_ToBeModified_Item_mBS_DL_PDCP_SN_Length,
        ____MulticastMRBs_ToBeModified_Item_iE_Extensions__item__id_tab,
        ___MulticastMRBs_ToBeModified_Item_iE_Extensions__item__id,
        ____MulticastMRBs_ToBeModified_Item_iE_Extensions__item__criticality_tab,
        ___MulticastMRBs_ToBeModified_Item_iE_Extensions__item__criticality,
        ____MulticastMRBs_ToBeModified_Item_iE_Extensions__item__extensionValue_tab,
        ___MulticastMRBs_ToBeModified_Item_iE_Extensions__item__extensionValue,
        __MulticastMRBs_ToBeModified_Item_iE_Extensions__item_,
        _MulticastMRBs_ToBeModified_Item_iE_Extensions,
        MulticastMRBs_ToBeModified_Item,
        MulticastMRBs_ToBeModified_Item_ExtIEs,
        _MulticastMRBs_ToBeReleased_Item_mRB_ID,
        ____MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__id_tab,
        ___MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__id,
        ____MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab,
        ___MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality,
        ____MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab,
        ___MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue,
        __MulticastMRBs_ToBeReleased_Item_iE_Extensions__item_,
        _MulticastMRBs_ToBeReleased_Item_iE_Extensions,
        MulticastMRBs_ToBeReleased_Item,
        MulticastMRBs_ToBeReleased_ItemExtIEs,
        _MulticastMRBs_ToBeSetup_Item_mRB_ID,
        _MulticastMRBs_ToBeSetup_Item_mRB_QoSInformation,
        _MulticastMRBs_ToBeSetup_Item_mBS_Flows_Mapped_To_MRB_List,
        _MulticastMRBs_ToBeSetup_Item_mBS_DL_PDCP_SN_Length,
        ____MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__id_tab,
        ___MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__id,
        ____MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality_tab,
        ___MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality,
        ____MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab,
        ___MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue,
        __MulticastMRBs_ToBeSetup_Item_iE_Extensions__item_,
        _MulticastMRBs_ToBeSetup_Item_iE_Extensions,
        MulticastMRBs_ToBeSetup_Item,
        MulticastMRBs_ToBeSetup_Item_ExtIEs,
        _MulticastMRBs_ToBeSetupMod_Item_mRB_ID,
        _MulticastMRBs_ToBeSetupMod_Item_mRB_QoSInformation,
        _MulticastMRBs_ToBeSetupMod_Item_mBS_Flows_Mapped_To_MRB_List,
        _MulticastMRBs_ToBeSetupMod_Item_mBS_DL_PDCP_SN_Length,
        ____MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab,
        ___MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__id,
        ____MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality_tab,
        ___MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality,
        ____MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue,
        __MulticastMRBs_ToBeSetupMod_Item_iE_Extensions__item_,
        _MulticastMRBs_ToBeSetupMod_Item_iE_Extensions,
        MulticastMRBs_ToBeSetupMod_Item,
        MulticastMRBs_ToBeSetupMod_Item_ExtIEs,
        _MultiplexingInfo_iAB_MT_Cell_List,
        ____MultiplexingInfo_iE_Extensions__item__id_tab,
        ___MultiplexingInfo_iE_Extensions__item__id,
        ____MultiplexingInfo_iE_Extensions__item__criticality_tab,
        ___MultiplexingInfo_iE_Extensions__item__criticality,
        ____MultiplexingInfo_iE_Extensions__item__extensionValue_tab,
        ___MultiplexingInfo_iE_Extensions__item__extensionValue,
        __MultiplexingInfo_iE_Extensions__item_,
        _MultiplexingInfo_iE_Extensions,
        MultiplexingInfo,
        MultiplexingInfo_ExtIEs,
        M2Configuration,
        _M5Configuration_m5period,
        _M5Configuration_m5_links_to_log,
        ____M5Configuration_iE_Extensions__item__id_tab,
        _____M5Configuration_iE_Extensions__item__id_tab_val_Extension_0,
        ___M5Configuration_iE_Extensions__item__id,
        ___M5Configuration_iE_Extensions__item__criticality,
        ___M5Configuration_iE_Extensions__item__extensionValue,
        __M5Configuration_iE_Extensions__item_,
        _M5Configuration_iE_Extensions,
        M5Configuration,
        M5Configuration_ExtIEs,
        _M5Configuration_ExtIEs_val_Extension_0,
        M5period,
        M5ReportAmount,
        M5_Links_to_log,
        _M6Configuration_m6report_Interval,
        _M6Configuration_m6_links_to_log,
        ____M6Configuration_iE_Extensions__item__id_tab,
        _____M6Configuration_iE_Extensions__item__id_tab_val_Extension_0,
        ___M6Configuration_iE_Extensions__item__id,
        ___M6Configuration_iE_Extensions__item__criticality,
        ___M6Configuration_iE_Extensions__item__extensionValue,
        __M6Configuration_iE_Extensions__item_,
        _M6Configuration_iE_Extensions,
        M6Configuration,
        M6Configuration_ExtIEs,
        _M6Configuration_ExtIEs_val_Extension_0,
        M6report_Interval,
        M6ReportAmount,
        M6_Links_to_log,
        _M7Configuration_m7period,
        _M7Configuration_m7_links_to_log,
        ____M7Configuration_iE_Extensions__item__id_tab,
        _____M7Configuration_iE_Extensions__item__id_tab_val_Extension_0,
        ___M7Configuration_iE_Extensions__item__id,
        ___M7Configuration_iE_Extensions__item__criticality,
        ___M7Configuration_iE_Extensions__item__extensionValue,
        __M7Configuration_iE_Extensions__item_,
        _M7Configuration_iE_Extensions,
        M7Configuration,
        M7Configuration_ExtIEs,
        _M7Configuration_ExtIEs_val_Extension_0,
        M7period,
        M7ReportAmount,
        M7_Links_to_log,
        MDT_Activation,
        _MDTConfiguration_mdt_Activation,
        _MDTConfiguration_measurementsToActivate,
        _MDTConfiguration_m2Configuration,
        _MDTConfiguration_m5Configuration,
        _MDTConfiguration_m6Configuration,
        _MDTConfiguration_m7Configuration,
        ____MDTConfiguration_iE_Extensions__item__id_tab,
        ___MDTConfiguration_iE_Extensions__item__id,
        ____MDTConfiguration_iE_Extensions__item__criticality_tab,
        ___MDTConfiguration_iE_Extensions__item__criticality,
        ____MDTConfiguration_iE_Extensions__item__extensionValue_tab,
        ___MDTConfiguration_iE_Extensions__item__extensionValue,
        __MDTConfiguration_iE_Extensions__item_,
        _MDTConfiguration_iE_Extensions,
        MDTConfiguration,
        MDTConfiguration_ExtIEs,
        _MDTPLMNList__item_,
        MDTPLMNList,
        _MDTPLMNModificationList__item_,
        MDTPLMNModificationList,
        _MeasuredResultsValue_uL_AngleOfArrival,
        _MeasuredResultsValue_uL_SRS_RSRP,
        _MeasuredResultsValue_uL_RTOA,
        _MeasuredResultsValue_gNB_RxTxTimeDiff,
        ___MeasuredResultsValue_choice_extension_id_tab,
        ____MeasuredResultsValue_choice_extension_id_tab_val_Value_0,
        ____MeasuredResultsValue_choice_extension_id_tab_val_Value_1,
        ____MeasuredResultsValue_choice_extension_id_tab_val_Value_2,
        __MeasuredResultsValue_choice_extension_id,
        __MeasuredResultsValue_choice_extension_criticality,
        __MeasuredResultsValue_choice_extension_value,
        _MeasuredResultsValue_choice_extension,
        MeasuredResultsValue,
        MeasuredResultsValue_ExtIEs,
        _MeasuredResultsValue_ExtIEs_val_Value_0,
        _MeasuredResultsValue_ExtIEs_val_Value_1,
        _MeasuredResultsValue_ExtIEs_val_Value_2,
        MeasurementsToActivate,
        MUSIM_GapConfig,
        _NA_Resource_Configuration_List__item_,
        NA_Resource_Configuration_List,
        _NA_Resource_Configuration_Item_nADownlink,
        _NA_Resource_Configuration_Item_nAUplink,
        _NA_Resource_Configuration_Item_nAFlexible,
        ____NA_Resource_Configuration_Item_iE_Extensions__item__id_tab,
        ___NA_Resource_Configuration_Item_iE_Extensions__item__id,
        ____NA_Resource_Configuration_Item_iE_Extensions__item__criticality_tab,
        ___NA_Resource_Configuration_Item_iE_Extensions__item__criticality,
        ____NA_Resource_Configuration_Item_iE_Extensions__item__extensionValue_tab,
        ___NA_Resource_Configuration_Item_iE_Extensions__item__extensionValue,
        __NA_Resource_Configuration_Item_iE_Extensions__item_,
        _NA_Resource_Configuration_Item_iE_Extensions,
        NA_Resource_Configuration_Item,
        NA_Resource_Configuration_Item_ExtIEs,
        NADownlink,
        NAFlexible,
        NAUplink,
        _Neighbour_Node_Cells_List__item_,
        Neighbour_Node_Cells_List,
        _Neighbour_Node_Cells_List_Item_nRCGI,
        _Neighbour_Node_Cells_List_Item_gNB_CU_UE_F1AP_ID,
        _Neighbour_Node_Cells_List_Item_gNB_DU_UE_F1AP_ID,
        _Neighbour_Node_Cells_List_Item_peer_Parent_Node_Indicator,
        _Neighbour_Node_Cells_List_Item_iAB_DU_Cell_Resource_Configuration_Mode_Info,
        _Neighbour_Node_Cells_List_Item_iAB_STC_Info,
        _Neighbour_Node_Cells_List_Item_rACH_Config_Common,
        _Neighbour_Node_Cells_List_Item_rACH_Config_Common_IAB,
        _Neighbour_Node_Cells_List_Item_cSI_RS_Configuration,
        _Neighbour_Node_Cells_List_Item_sR_Configuration,
        _Neighbour_Node_Cells_List_Item_pDCCH_ConfigSIB1,
        _Neighbour_Node_Cells_List_Item_sCS_Common,
        ____Neighbour_Node_Cells_List_Item_iE_Extensions__item__id_tab,
        ___Neighbour_Node_Cells_List_Item_iE_Extensions__item__id,
        ____Neighbour_Node_Cells_List_Item_iE_Extensions__item__criticality_tab,
        ___Neighbour_Node_Cells_List_Item_iE_Extensions__item__criticality,
        ____Neighbour_Node_Cells_List_Item_iE_Extensions__item__extensionValue_tab,
        ___Neighbour_Node_Cells_List_Item_iE_Extensions__item__extensionValue,
        __Neighbour_Node_Cells_List_Item_iE_Extensions__item_,
        _Neighbour_Node_Cells_List_Item_iE_Extensions,
        Neighbour_Node_Cells_List_Item,
        Neighbour_Node_Cells_List_Item_ExtIEs,
        NeedforGap,
        NeedForGapsInfoNR,
        NeedForGapNCSGInfoNR,
        NeedForGapNCSGInfoEUTRA,
        _Neighbour_Cell_Information_Item_nRCGI,
        _Neighbour_Cell_Information_Item_intendedTDD_DL_ULConfig,
        ____Neighbour_Cell_Information_Item_iE_Extensions__item__id_tab,
        ___Neighbour_Cell_Information_Item_iE_Extensions__item__id,
        ____Neighbour_Cell_Information_Item_iE_Extensions__item__criticality_tab,
        ___Neighbour_Cell_Information_Item_iE_Extensions__item__criticality,
        ____Neighbour_Cell_Information_Item_iE_Extensions__item__extensionValue_tab,
        ___Neighbour_Cell_Information_Item_iE_Extensions__item__extensionValue,
        __Neighbour_Cell_Information_Item_iE_Extensions__item_,
        _Neighbour_Cell_Information_Item_iE_Extensions,
        Neighbour_Cell_Information_Item,
        Neighbour_Cell_Information_ItemExtIEs,
        _NeighbourNR_CellsForSON_List__item_,
        NeighbourNR_CellsForSON_List,
        _NeighbourNR_CellsForSON_Item_nRCGI,
        _NeighbourNR_CellsForSON_Item_nR_ModeInfoRel16,
        _NeighbourNR_CellsForSON_Item_sSB_PositionsInBurst,
        _NeighbourNR_CellsForSON_Item_nRPRACHConfig,
        ____NeighbourNR_CellsForSON_Item_iE_Extensions__item__id_tab,
        ___NeighbourNR_CellsForSON_Item_iE_Extensions__item__id,
        ____NeighbourNR_CellsForSON_Item_iE_Extensions__item__criticality_tab,
        ___NeighbourNR_CellsForSON_Item_iE_Extensions__item__criticality,
        ____NeighbourNR_CellsForSON_Item_iE_Extensions__item__extensionValue_tab,
        ___NeighbourNR_CellsForSON_Item_iE_Extensions__item__extensionValue,
        __NeighbourNR_CellsForSON_Item_iE_Extensions__item_,
        _NeighbourNR_CellsForSON_Item_iE_Extensions,
        NeighbourNR_CellsForSON_Item,
        NeighbourNR_CellsForSON_Item_ExtIEs,
        _NGRANAllocationAndRetentionPriority_priorityLevel,
        _NGRANAllocationAndRetentionPriority_pre_emptionCapability,
        _NGRANAllocationAndRetentionPriority_pre_emptionVulnerability,
        ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__id_tab,
        ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__id,
        ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality_tab,
        ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__criticality,
        ____NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab,
        ___NGRANAllocationAndRetentionPriority_iE_Extensions__item__extensionValue,
        __NGRANAllocationAndRetentionPriority_iE_Extensions__item_,
        _NGRANAllocationAndRetentionPriority_iE_Extensions,
        NGRANAllocationAndRetentionPriority,
        NGRANAllocationAndRetentionPriority_ExtIEs,
        _NGRANHighAccuracyAccessPointPosition_latitude,
        _NGRANHighAccuracyAccessPointPosition_longitude,
        _NGRANHighAccuracyAccessPointPosition_altitude,
        _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_major,
        _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_minor,
        _NGRANHighAccuracyAccessPointPosition_orientationOfMajorAxis,
        _NGRANHighAccuracyAccessPointPosition_horizontalConfidence,
        _NGRANHighAccuracyAccessPointPosition_uncertaintyAltitude,
        _NGRANHighAccuracyAccessPointPosition_verticalConfidence,
        ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id_tab,
        ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id,
        ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality_tab,
        ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality,
        ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue_tab,
        ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue,
        __NGRANHighAccuracyAccessPointPosition_iE_Extensions__item_,
        _NGRANHighAccuracyAccessPointPosition_iE_Extensions,
        NGRANHighAccuracyAccessPointPosition,
        NGRANHighAccuracyAccessPointPosition_ExtIEs,
        NID,
        NonF1terminatingTopologyIndicator,
        _NR_CGI_List_For_Restart_Item_nRCGI,
        ____NR_CGI_List_For_Restart_Item_iE_Extensions__item__id_tab,
        ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__id,
        ____NR_CGI_List_For_Restart_Item_iE_Extensions__item__criticality_tab,
        ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__criticality,
        ____NR_CGI_List_For_Restart_Item_iE_Extensions__item__extensionValue_tab,
        ___NR_CGI_List_For_Restart_Item_iE_Extensions__item__extensionValue,
        __NR_CGI_List_For_Restart_Item_iE_Extensions__item_,
        _NR_CGI_List_For_Restart_Item_iE_Extensions,
        NR_CGI_List_For_Restart_Item,
        NR_CGI_List_For_Restart_ItemExtIEs,
        _NR_PRSBeamInformation_nR_PRSBeamInformationList,
        _NR_PRSBeamInformation_lCStoGCSTranslationList,
        ____NR_PRSBeamInformation_iE_Extensions__item__id_tab,
        ___NR_PRSBeamInformation_iE_Extensions__item__id,
        ____NR_PRSBeamInformation_iE_Extensions__item__criticality_tab,
        ___NR_PRSBeamInformation_iE_Extensions__item__criticality,
        ____NR_PRSBeamInformation_iE_Extensions__item__extensionValue_tab,
        ___NR_PRSBeamInformation_iE_Extensions__item__extensionValue,
        __NR_PRSBeamInformation_iE_Extensions__item_,
        _NR_PRSBeamInformation_iE_Extensions,
        NR_PRSBeamInformation,
        NR_PRSBeamInformation_ExtIEs,
        _NR_PRSBeamInformationList__item_,
        NR_PRSBeamInformationList,
        _NR_PRSBeamInformationItem_pRSResourceSetID,
        _NR_PRSBeamInformationItem_pRSAngleList,
        ____NR_PRSBeamInformationItem_iE_Extensions__item__id_tab,
        ___NR_PRSBeamInformationItem_iE_Extensions__item__id,
        ____NR_PRSBeamInformationItem_iE_Extensions__item__criticality_tab,
        ___NR_PRSBeamInformationItem_iE_Extensions__item__criticality,
        ____NR_PRSBeamInformationItem_iE_Extensions__item__extensionValue_tab,
        ___NR_PRSBeamInformationItem_iE_Extensions__item__extensionValue,
        __NR_PRSBeamInformationItem_iE_Extensions__item_,
        _NR_PRSBeamInformationItem_iE_Extensions,
        NR_PRSBeamInformationItem,
        NR_PRSBeamInformationItem_ExtIEs,
        NR_TADV,
        NRRedCapUEIndication,
        _NRPagingeDRXInformation_nrpaging_eDRX_Cycle_Idle,
        _NRPagingeDRXInformation_nrpaging_Time_Window,
        ____NRPagingeDRXInformation_iE_Extensions__item__id_tab,
        ___NRPagingeDRXInformation_iE_Extensions__item__id,
        ____NRPagingeDRXInformation_iE_Extensions__item__criticality_tab,
        ___NRPagingeDRXInformation_iE_Extensions__item__criticality,
        ____NRPagingeDRXInformation_iE_Extensions__item__extensionValue_tab,
        ___NRPagingeDRXInformation_iE_Extensions__item__extensionValue,
        __NRPagingeDRXInformation_iE_Extensions__item_,
        _NRPagingeDRXInformation_iE_Extensions,
        NRPagingeDRXInformation,
        NRPagingeDRXInformation_ExtIEs,
        NRPaging_eDRX_Cycle_Idle,
        NRPaging_Time_Window,
        _NRPagingeDRXInformationforRRCINACTIVE_nrpaging_eDRX_Cycle_Inactive,
        ____NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__id_tab,
        ___NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__id,
        ____NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__criticality_tab,
        ___NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__criticality,
        ____NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__extensionValue_tab,
        ___NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item__extensionValue,
        __NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions__item_,
        _NRPagingeDRXInformationforRRCINACTIVE_iE_Extensions,
        NRPagingeDRXInformationforRRCINACTIVE,
        NRPagingeDRXInformationforRRCINACTIVE_ExtIEs,
        NRPaging_eDRX_Cycle_Inactive,
        _NonDynamic5QIDescriptor_fiveQI,
        _NonDynamic5QIDescriptor_qoSPriorityLevel,
        _NonDynamic5QIDescriptor_averagingWindow,
        _NonDynamic5QIDescriptor_maxDataBurstVolume,
        ____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab,
        _____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0,
        _____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1,
        ___NonDynamic5QIDescriptor_iE_Extensions__item__id,
        ___NonDynamic5QIDescriptor_iE_Extensions__item__criticality,
        ___NonDynamic5QIDescriptor_iE_Extensions__item__extensionValue,
        __NonDynamic5QIDescriptor_iE_Extensions__item_,
        _NonDynamic5QIDescriptor_iE_Extensions,
        NonDynamic5QIDescriptor,
        NonDynamic5QIDescriptor_ExtIEs,
        _NonDynamic5QIDescriptor_ExtIEs_val_Extension_0,
        _NonDynamic5QIDescriptor_ExtIEs_val_Extension_1,
        _NonDynamicPQIDescriptor_fiveQI,
        _NonDynamicPQIDescriptor_qoSPriorityLevel,
        _NonDynamicPQIDescriptor_averagingWindow,
        _NonDynamicPQIDescriptor_maxDataBurstVolume,
        ____NonDynamicPQIDescriptor_iE_Extensions__item__id_tab,
        ___NonDynamicPQIDescriptor_iE_Extensions__item__id,
        ____NonDynamicPQIDescriptor_iE_Extensions__item__criticality_tab,
        ___NonDynamicPQIDescriptor_iE_Extensions__item__criticality,
        ____NonDynamicPQIDescriptor_iE_Extensions__item__extensionValue_tab,
        ___NonDynamicPQIDescriptor_iE_Extensions__item__extensionValue,
        __NonDynamicPQIDescriptor_iE_Extensions__item_,
        _NonDynamicPQIDescriptor_iE_Extensions,
        NonDynamicPQIDescriptor,
        NonDynamicPQIDescriptor_ExtIEs,
        NonUPTrafficType,
        NoofDownlinkSymbols,
        NoofUplinkSymbols,
        Notification_Cause,
        NotificationControl,
        _NotificationInformation_message_Identifier,
        _NotificationInformation_serialNumber,
        ____NotificationInformation_iE_Extensions__item__id_tab,
        ___NotificationInformation_iE_Extensions__item__id,
        ____NotificationInformation_iE_Extensions__item__criticality_tab,
        ___NotificationInformation_iE_Extensions__item__criticality,
        ____NotificationInformation_iE_Extensions__item__extensionValue_tab,
        ___NotificationInformation_iE_Extensions__item__extensionValue,
        __NotificationInformation_iE_Extensions__item_,
        _NotificationInformation_iE_Extensions,
        NotificationInformation,
        NotificationInformationExtIEs,
        _NPNBroadcastInformation_sNPN_Broadcast_Information,
        _NPNBroadcastInformation_pNI_NPN_Broadcast_Information,
        ___NPNBroadcastInformation_choice_extension_id_tab,
        __NPNBroadcastInformation_choice_extension_id,
        ___NPNBroadcastInformation_choice_extension_criticality_tab,
        __NPNBroadcastInformation_choice_extension_criticality,
        ___NPNBroadcastInformation_choice_extension_value_tab,
        __NPNBroadcastInformation_choice_extension_value,
        _NPNBroadcastInformation_choice_extension,
        NPNBroadcastInformation,
        NPNBroadcastInformation_ExtIEs,
        _NPN_Broadcast_Information_SNPN_broadcastSNPNID_List,
        ____NPN_Broadcast_Information_SNPN_iE_Extension__item__id_tab,
        ___NPN_Broadcast_Information_SNPN_iE_Extension__item__id,
        ____NPN_Broadcast_Information_SNPN_iE_Extension__item__criticality_tab,
        ___NPN_Broadcast_Information_SNPN_iE_Extension__item__criticality,
        ____NPN_Broadcast_Information_SNPN_iE_Extension__item__extensionValue_tab,
        ___NPN_Broadcast_Information_SNPN_iE_Extension__item__extensionValue,
        __NPN_Broadcast_Information_SNPN_iE_Extension__item_,
        _NPN_Broadcast_Information_SNPN_iE_Extension,
        NPN_Broadcast_Information_SNPN,
        NPN_Broadcast_Information_SNPN_ExtIEs,
        _NPN_Broadcast_Information_PNI_NPN_broadcastPNI_NPN_ID_Information,
        ____NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__id_tab,
        ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__id,
        ____NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__criticality_tab,
        ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__criticality,
        ____NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__extensionValue_tab,
        ___NPN_Broadcast_Information_PNI_NPN_iE_Extension__item__extensionValue,
        __NPN_Broadcast_Information_PNI_NPN_iE_Extension__item_,
        _NPN_Broadcast_Information_PNI_NPN_iE_Extension,
        NPN_Broadcast_Information_PNI_NPN,
        NPN_Broadcast_Information_PNI_NPN_ExtIEs,
        _NPNSupportInfo_sNPN_Information,
        ___NPNSupportInfo_choice_extension_id_tab,
        __NPNSupportInfo_choice_extension_id,
        ___NPNSupportInfo_choice_extension_criticality_tab,
        __NPNSupportInfo_choice_extension_criticality,
        ___NPNSupportInfo_choice_extension_value_tab,
        __NPNSupportInfo_choice_extension_value,
        _NPNSupportInfo_choice_extension,
        NPNSupportInfo,
        NPNSupportInfo_ExtIEs,
        _NRCarrierList__item_,
        NRCarrierList,
        _NRCarrierItem_carrierSCS,
        _NRCarrierItem_offsetToCarrier,
        _NRCarrierItem_carrierBandwidth,
        ____NRCarrierItem_iE_Extension__item__id_tab,
        ___NRCarrierItem_iE_Extension__item__id,
        ____NRCarrierItem_iE_Extension__item__criticality_tab,
        ___NRCarrierItem_iE_Extension__item__criticality,
        ____NRCarrierItem_iE_Extension__item__extensionValue_tab,
        ___NRCarrierItem_iE_Extension__item__extensionValue,
        __NRCarrierItem_iE_Extension__item_,
        _NRCarrierItem_iE_Extension,
        NRCarrierItem,
        NRCarrierItem_ExtIEs,
        _NRFreqInfo_nRARFCN,
        _NRFreqInfo_sul_Information,
        __NRFreqInfo_freqBandListNr__item_,
        _NRFreqInfo_freqBandListNr,
        ____NRFreqInfo_iE_Extensions__item__id_tab,
        _____NRFreqInfo_iE_Extensions__item__id_tab_val_Extension_0,
        ___NRFreqInfo_iE_Extensions__item__id,
        ___NRFreqInfo_iE_Extensions__item__criticality,
        ___NRFreqInfo_iE_Extensions__item__extensionValue,
        __NRFreqInfo_iE_Extensions__item_,
        _NRFreqInfo_iE_Extensions,
        NRFreqInfo,
        NRFreqInfoExtIEs,
        _NRFreqInfoExtIEs_val_Extension_0,
        _NRCGI_pLMN_Identity,
        _NRCGI_nRCellIdentity,
        ____NRCGI_iE_Extensions__item__id_tab,
        ___NRCGI_iE_Extensions__item__id,
        ____NRCGI_iE_Extensions__item__criticality_tab,
        ___NRCGI_iE_Extensions__item__criticality,
        ____NRCGI_iE_Extensions__item__extensionValue_tab,
        ___NRCGI_iE_Extensions__item__extensionValue,
        __NRCGI_iE_Extensions__item_,
        _NRCGI_iE_Extensions,
        NRCGI,
        NRCGI_ExtIEs,
        _NR_Mode_Info_fDD,
        _NR_Mode_Info_tDD,
        ___NR_Mode_Info_choice_extension_id_tab,
        ____NR_Mode_Info_choice_extension_id_tab_val_Value_0,
        __NR_Mode_Info_choice_extension_id,
        __NR_Mode_Info_choice_extension_criticality,
        __NR_Mode_Info_choice_extension_value,
        _NR_Mode_Info_choice_extension,
        NR_Mode_Info,
        NR_Mode_Info_ExtIEs,
        _NR_Mode_Info_ExtIEs_val_Value_0,
        _NR_ModeInfoRel16_fDD,
        _NR_ModeInfoRel16_tDD,
        ___NR_ModeInfoRel16_choice_extension_id_tab,
        __NR_ModeInfoRel16_choice_extension_id,
        ___NR_ModeInfoRel16_choice_extension_criticality_tab,
        __NR_ModeInfoRel16_choice_extension_criticality,
        ___NR_ModeInfoRel16_choice_extension_value_tab,
        __NR_ModeInfoRel16_choice_extension_value,
        _NR_ModeInfoRel16_choice_extension,
        NR_ModeInfoRel16,
        NR_ModeInfoRel16_ExtIEs,
        _NRPRACHConfig_ulPRACHConfigList,
        _NRPRACHConfig_sulPRACHConfigList,
        ____NRPRACHConfig_iE_Extension__item__id_tab,
        ___NRPRACHConfig_iE_Extension__item__id,
        ____NRPRACHConfig_iE_Extension__item__criticality_tab,
        ___NRPRACHConfig_iE_Extension__item__criticality,
        ____NRPRACHConfig_iE_Extension__item__extensionValue_tab,
        ___NRPRACHConfig_iE_Extension__item__extensionValue,
        __NRPRACHConfig_iE_Extension__item_,
        _NRPRACHConfig_iE_Extension,
        NRPRACHConfig,
        NRPRACHConfig_ExtIEs,
        NRCellIdentity,
        NRNRB,
        NRPCI,
        _NRPRACHConfigList__item_,
        NRPRACHConfigList,
        _NRPRACHConfigItem_nRSCS,
        _NRPRACHConfigItem_prachFreqStartfromCarrier,
        _NRPRACHConfigItem_prachFDM,
        _NRPRACHConfigItem_prachConfigIndex,
        _NRPRACHConfigItem_ssb_perRACH_Occasion,
        _NRPRACHConfigItem_freqDomainLength,
        _NRPRACHConfigItem_zeroCorrelZoneConfig,
        ____NRPRACHConfigItem_iE_Extension__item__id_tab,
        ___NRPRACHConfigItem_iE_Extension__item__id,
        ____NRPRACHConfigItem_iE_Extension__item__criticality_tab,
        ___NRPRACHConfigItem_iE_Extension__item__criticality,
        ____NRPRACHConfigItem_iE_Extension__item__extensionValue_tab,
        ___NRPRACHConfigItem_iE_Extension__item__extensionValue,
        __NRPRACHConfigItem_iE_Extension__item_,
        _NRPRACHConfigItem_iE_Extension,
        NRPRACHConfigItem,
        NRPRACHConfigItem_ExtIEs,
        NRSCS,
        NRUERLFReportContainer,
        _NR_U_Channel_Info_List__item_,
        NR_U_Channel_Info_List,
        _NR_U_Channel_Info_Item_nr_U_channel_ID,
        _NR_U_Channel_Info_Item_nR_ARFCN,
        _NR_U_Channel_Info_Item_bandwidth,
        ____NR_U_Channel_Info_Item_iE_Extensions__item__id_tab,
        ___NR_U_Channel_Info_Item_iE_Extensions__item__id,
        ____NR_U_Channel_Info_Item_iE_Extensions__item__criticality_tab,
        ___NR_U_Channel_Info_Item_iE_Extensions__item__criticality,
        ____NR_U_Channel_Info_Item_iE_Extensions__item__extensionValue_tab,
        ___NR_U_Channel_Info_Item_iE_Extensions__item__extensionValue,
        __NR_U_Channel_Info_Item_iE_Extensions__item_,
        _NR_U_Channel_Info_Item_iE_Extensions,
        NR_U_Channel_Info_Item,
        NR_U_Channel_Info_List_ExtIEs,
        _NR_U_Channel_List__item_,
        NR_U_Channel_List,
        _NR_U_Channel_Item_nR_U_ChannelID,
        _NR_U_Channel_Item_channelOccupancyTimePercentageDL,
        _NR_U_Channel_Item_energyDetectionThreshold,
        ____NR_U_Channel_Item_iE_Extensions__item__id_tab,
        ___NR_U_Channel_Item_iE_Extensions__item__id,
        ____NR_U_Channel_Item_iE_Extensions__item__criticality_tab,
        ___NR_U_Channel_Item_iE_Extensions__item__criticality,
        ____NR_U_Channel_Item_iE_Extensions__item__extensionValue_tab,
        ___NR_U_Channel_Item_iE_Extensions__item__extensionValue,
        __NR_U_Channel_Item_iE_Extensions__item_,
        _NR_U_Channel_Item_iE_Extensions,
        NR_U_Channel_Item,
        NR_U_Channel_Item_ExtIEs,
        NumberofActiveUEs,
        NumberOfBroadcasts,
        NumberofBroadcastRequest,
        NumberOfTRPRxTEG,
        NumberOfTRPRxTxTEG,
        _NumDLULSymbols_numDLSymbols,
        _NumDLULSymbols_numULSymbols,
        ____NumDLULSymbols_iE_Extensions__item__id_tab,
        _____NumDLULSymbols_iE_Extensions__item__id_tab_val_Extension_0,
        ___NumDLULSymbols_iE_Extensions__item__id,
        ___NumDLULSymbols_iE_Extensions__item__criticality,
        ___NumDLULSymbols_iE_Extensions__item__extensionValue,
        __NumDLULSymbols_iE_Extensions__item_,
        _NumDLULSymbols_iE_Extensions,
        NumDLULSymbols,
        NumDLULSymbols_ExtIEs,
        _NumDLULSymbols_ExtIEs_val_Extension_0,
        _NRV2XServicesAuthorized_vehicleUE,
        _NRV2XServicesAuthorized_pedestrianUE,
        ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab,
        ___NRV2XServicesAuthorized_iE_Extensions__item__id,
        ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab,
        ___NRV2XServicesAuthorized_iE_Extensions__item__criticality,
        ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab,
        ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue,
        __NRV2XServicesAuthorized_iE_Extensions__item_,
        _NRV2XServicesAuthorized_iE_Extensions,
        NRV2XServicesAuthorized,
        NRV2XServicesAuthorized_ExtIEs,
        _NRUESidelinkAggregateMaximumBitrate_uENRSidelinkAggregateMaximumBitrate,
        ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab,
        ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id,
        ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab,
        ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality,
        ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab,
        ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue,
        __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_,
        _NRUESidelinkAggregateMaximumBitrate_iE_Extensions,
        NRUESidelinkAggregateMaximumBitrate,
        NRUESidelinkAggregateMaximumBitrate_ExtIEs,
        NZP_CSI_RS_ResourceID,
        OffsetToPointA,
        _OnDemandPRS_Info_onDemandPRSRequestAllowed,
        _OnDemandPRS_Info_allowedResourceSetPeriodicityValues,
        _OnDemandPRS_Info_allowedPRSBandwidthValues,
        _OnDemandPRS_Info_allowedResourceRepetitionFactorValues,
        _OnDemandPRS_Info_allowedResourceNumberOfSymbolsValues,
        _OnDemandPRS_Info_allowedCombSizeValues,
        ____OnDemandPRS_Info_iE_Extensions__item__id_tab,
        ___OnDemandPRS_Info_iE_Extensions__item__id,
        ____OnDemandPRS_Info_iE_Extensions__item__criticality_tab,
        ___OnDemandPRS_Info_iE_Extensions__item__criticality,
        ____OnDemandPRS_Info_iE_Extensions__item__extensionValue_tab,
        ___OnDemandPRS_Info_iE_Extensions__item__extensionValue,
        __OnDemandPRS_Info_iE_Extensions__item_,
        _OnDemandPRS_Info_iE_Extensions,
        OnDemandPRS_Info,
        OnDemandPRS_Info_ExtIEs,
        PacketDelayBudget,
        _PacketErrorRate_pER_Scalar,
        _PacketErrorRate_pER_Exponent,
        ____PacketErrorRate_iE_Extensions__item__id_tab,
        ___PacketErrorRate_iE_Extensions__item__id,
        ____PacketErrorRate_iE_Extensions__item__criticality_tab,
        ___PacketErrorRate_iE_Extensions__item__criticality,
        ____PacketErrorRate_iE_Extensions__item__extensionValue_tab,
        ___PacketErrorRate_iE_Extensions__item__extensionValue,
        __PacketErrorRate_iE_Extensions__item_,
        _PacketErrorRate_iE_Extensions,
        PacketErrorRate,
        PacketErrorRate_ExtIEs,
        PER_Scalar,
        PER_Exponent,
        _PagingCell_Item_nRCGI,
        ____PagingCell_Item_iE_Extensions__item__id_tab,
        _____PagingCell_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____PagingCell_Item_iE_Extensions__item__id_tab_val_Extension_1,
        ___PagingCell_Item_iE_Extensions__item__id,
        ___PagingCell_Item_iE_Extensions__item__criticality,
        ___PagingCell_Item_iE_Extensions__item__extensionValue,
        __PagingCell_Item_iE_Extensions__item_,
        _PagingCell_Item_iE_Extensions,
        PagingCell_Item,
        PagingCell_ItemExtIEs,
        _PagingCell_ItemExtIEs_val_Extension_0,
        _PagingCell_ItemExtIEs_val_Extension_1,
        PagingDRX,
        _PagingIdentity_rANUEPagingIdentity,
        _PagingIdentity_cNUEPagingIdentity,
        ___PagingIdentity_choice_extension_id_tab,
        __PagingIdentity_choice_extension_id,
        ___PagingIdentity_choice_extension_criticality_tab,
        __PagingIdentity_choice_extension_criticality,
        ___PagingIdentity_choice_extension_value_tab,
        __PagingIdentity_choice_extension_value,
        _PagingIdentity_choice_extension,
        PagingIdentity,
        PagingCause,
        PagingIdentity_ExtIEs,
        PagingOrigin,
        PagingPriority,
        _PEIPSAssistanceInfo_cNSubgroupID,
        ____PEIPSAssistanceInfo_iE_Extensions__item__id_tab,
        ___PEIPSAssistanceInfo_iE_Extensions__item__id,
        ____PEIPSAssistanceInfo_iE_Extensions__item__criticality_tab,
        ___PEIPSAssistanceInfo_iE_Extensions__item__criticality,
        ____PEIPSAssistanceInfo_iE_Extensions__item__extensionValue_tab,
        ___PEIPSAssistanceInfo_iE_Extensions__item__extensionValue,
        __PEIPSAssistanceInfo_iE_Extensions__item_,
        _PEIPSAssistanceInfo_iE_Extensions,
        PEIPSAssistanceInfo,
        PEIPSAssistanceInfo_ExtIEs,
        _RelativePathDelay_k0,
        _RelativePathDelay_k1,
        _RelativePathDelay_k2,
        _RelativePathDelay_k3,
        _RelativePathDelay_k4,
        _RelativePathDelay_k5,
        ___RelativePathDelay_choice_extension_id_tab,
        __RelativePathDelay_choice_extension_id,
        ___RelativePathDelay_choice_extension_criticality_tab,
        __RelativePathDelay_choice_extension_criticality,
        ___RelativePathDelay_choice_extension_value_tab,
        __RelativePathDelay_choice_extension_value,
        _RelativePathDelay_choice_extension,
        RelativePathDelay,
        RelativePathDelay_ExtIEs,
        _Parent_IAB_Nodes_NA_Resource_Configuration_List__item_,
        Parent_IAB_Nodes_NA_Resource_Configuration_List,
        _Parent_IAB_Nodes_NA_Resource_Configuration_Item_nADownlink,
        _Parent_IAB_Nodes_NA_Resource_Configuration_Item_nAUplink,
        _Parent_IAB_Nodes_NA_Resource_Configuration_Item_nAFlexible,
        ____Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__id_tab,
        ___Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__id,
        ____Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__criticality_tab,
        ___Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__criticality,
        ____Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__extensionValue_tab,
        ___Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item__extensionValue,
        __Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions__item_,
        _Parent_IAB_Nodes_NA_Resource_Configuration_Item_iE_Extensions,
        Parent_IAB_Nodes_NA_Resource_Configuration_Item,
        Parent_IAB_Nodes_NA_Resource_Configuration_Item_ExtIEs,
        _PartialSuccessCell_broadcastCellList,
        ____PartialSuccessCell_iE_Extensions__item__id_tab,
        ___PartialSuccessCell_iE_Extensions__item__id,
        ____PartialSuccessCell_iE_Extensions__item__criticality_tab,
        ___PartialSuccessCell_iE_Extensions__item__criticality,
        ____PartialSuccessCell_iE_Extensions__item__extensionValue_tab,
        ___PartialSuccessCell_iE_Extensions__item__extensionValue,
        __PartialSuccessCell_iE_Extensions__item_,
        _PartialSuccessCell_iE_Extensions,
        PartialSuccessCell,
        PartialSuccessCell_ExtIEs,
        _PathlossReferenceInfo_pathlossReferenceSignal,
        ____PathlossReferenceInfo_iE_Extensions__item__id_tab,
        ___PathlossReferenceInfo_iE_Extensions__item__id,
        ____PathlossReferenceInfo_iE_Extensions__item__criticality_tab,
        ___PathlossReferenceInfo_iE_Extensions__item__criticality,
        ____PathlossReferenceInfo_iE_Extensions__item__extensionValue_tab,
        ___PathlossReferenceInfo_iE_Extensions__item__extensionValue,
        __PathlossReferenceInfo_iE_Extensions__item_,
        _PathlossReferenceInfo_iE_Extensions,
        PathlossReferenceInfo,
        PathlossReferenceInfo_ExtIEs,
        _PathlossReferenceSignal_sSB,
        _PathlossReferenceSignal_dL_PRS,
        ___PathlossReferenceSignal_choice_extension_id_tab,
        __PathlossReferenceSignal_choice_extension_id,
        ___PathlossReferenceSignal_choice_extension_criticality_tab,
        __PathlossReferenceSignal_choice_extension_criticality,
        ___PathlossReferenceSignal_choice_extension_value_tab,
        __PathlossReferenceSignal_choice_extension_value,
        _PathlossReferenceSignal_choice_extension,
        PathlossReferenceSignal,
        PathlossReferenceSignal_ExtIEs,
        _PathSwitchConfiguration_targetRelayUEID,
        _PathSwitchConfiguration_remoteUELocalID,
        _PathSwitchConfiguration_t420,
        ____PathSwitchConfiguration_iE_Extensions__item__id_tab,
        ___PathSwitchConfiguration_iE_Extensions__item__id,
        ____PathSwitchConfiguration_iE_Extensions__item__criticality_tab,
        ___PathSwitchConfiguration_iE_Extensions__item__criticality,
        ____PathSwitchConfiguration_iE_Extensions__item__extensionValue_tab,
        ___PathSwitchConfiguration_iE_Extensions__item__extensionValue,
        __PathSwitchConfiguration_iE_Extensions__item_,
        _PathSwitchConfiguration_iE_Extensions,
        PathSwitchConfiguration,
        PathSwitchConfiguration_ExtIEs,
        PC5QoSFlowIdentifier,
        _PC5_QoS_Characteristics_non_Dynamic_PQI,
        _PC5_QoS_Characteristics_dynamic_PQI,
        ___PC5_QoS_Characteristics_choice_extension_id_tab,
        __PC5_QoS_Characteristics_choice_extension_id,
        ___PC5_QoS_Characteristics_choice_extension_criticality_tab,
        __PC5_QoS_Characteristics_choice_extension_criticality,
        ___PC5_QoS_Characteristics_choice_extension_value_tab,
        __PC5_QoS_Characteristics_choice_extension_value,
        _PC5_QoS_Characteristics_choice_extension,
        PC5_QoS_Characteristics,
        PC5_QoS_Characteristics_ExtIEs,
        _PC5QoSParameters_pC5_QoS_Characteristics,
        _PC5QoSParameters_pC5_QoS_Flow_Bit_Rates,
        ____PC5QoSParameters_iE_Extensions__item__id_tab,
        ___PC5QoSParameters_iE_Extensions__item__id,
        ____PC5QoSParameters_iE_Extensions__item__criticality_tab,
        ___PC5QoSParameters_iE_Extensions__item__criticality,
        ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab,
        ___PC5QoSParameters_iE_Extensions__item__extensionValue,
        __PC5QoSParameters_iE_Extensions__item_,
        _PC5QoSParameters_iE_Extensions,
        PC5QoSParameters,
        PC5QoSParameters_ExtIEs,
        _PC5FlowBitRates_guaranteedFlowBitRate,
        _PC5FlowBitRates_maximumFlowBitRate,
        ____PC5FlowBitRates_iE_Extensions__item__id_tab,
        ___PC5FlowBitRates_iE_Extensions__item__id,
        ____PC5FlowBitRates_iE_Extensions__item__criticality_tab,
        ___PC5FlowBitRates_iE_Extensions__item__criticality,
        ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab,
        ___PC5FlowBitRates_iE_Extensions__item__extensionValue,
        __PC5FlowBitRates_iE_Extensions__item_,
        _PC5FlowBitRates_iE_Extensions,
        PC5FlowBitRates,
        PC5FlowBitRates_ExtIEs,
        PC5RLCChannelID,
        _PC5RLCChannelQoSInformation_pC5RLCChannelQoS,
        _PC5RLCChannelQoSInformation_pC5ControlPlaneTrafficType,
        ___PC5RLCChannelQoSInformation_choice_extension_id_tab,
        __PC5RLCChannelQoSInformation_choice_extension_id,
        ___PC5RLCChannelQoSInformation_choice_extension_criticality_tab,
        __PC5RLCChannelQoSInformation_choice_extension_criticality,
        ___PC5RLCChannelQoSInformation_choice_extension_value_tab,
        __PC5RLCChannelQoSInformation_choice_extension_value,
        _PC5RLCChannelQoSInformation_choice_extension,
        PC5RLCChannelQoSInformation,
        PC5RLCChannelQoSInformation_ExtIEs,
        _PC5RLCChannelToBeSetupList__item_,
        PC5RLCChannelToBeSetupList,
        _PC5RLCChannelToBeSetupItem_pC5RLCChannelID,
        _PC5RLCChannelToBeSetupItem_remoteUELocalID,
        _PC5RLCChannelToBeSetupItem_pC5RLCChannelQoSInformation,
        _PC5RLCChannelToBeSetupItem_rLCMode,
        ____PC5RLCChannelToBeSetupItem_iE_Extensions__item__id_tab,
        ___PC5RLCChannelToBeSetupItem_iE_Extensions__item__id,
        ____PC5RLCChannelToBeSetupItem_iE_Extensions__item__criticality_tab,
        ___PC5RLCChannelToBeSetupItem_iE_Extensions__item__criticality,
        ____PC5RLCChannelToBeSetupItem_iE_Extensions__item__extensionValue_tab,
        ___PC5RLCChannelToBeSetupItem_iE_Extensions__item__extensionValue,
        __PC5RLCChannelToBeSetupItem_iE_Extensions__item_,
        _PC5RLCChannelToBeSetupItem_iE_Extensions,
        PC5RLCChannelToBeSetupItem,
        PC5RLCChannelToBeSetupItem_ExtIEs,
        _PC5RLCChannelToBeModifiedList__item_,
        PC5RLCChannelToBeModifiedList,
        _PC5RLCChannelToBeModifiedItem_pC5RLCChannelID,
        _PC5RLCChannelToBeModifiedItem_remoteUELocalID,
        _PC5RLCChannelToBeModifiedItem_pC5RLCChannelQoSInformation,
        _PC5RLCChannelToBeModifiedItem_rLCMode,
        ____PC5RLCChannelToBeModifiedItem_iE_Extensions__item__id_tab,
        ___PC5RLCChannelToBeModifiedItem_iE_Extensions__item__id,
        ____PC5RLCChannelToBeModifiedItem_iE_Extensions__item__criticality_tab,
        ___PC5RLCChannelToBeModifiedItem_iE_Extensions__item__criticality,
        ____PC5RLCChannelToBeModifiedItem_iE_Extensions__item__extensionValue_tab,
        ___PC5RLCChannelToBeModifiedItem_iE_Extensions__item__extensionValue,
        __PC5RLCChannelToBeModifiedItem_iE_Extensions__item_,
        _PC5RLCChannelToBeModifiedItem_iE_Extensions,
        PC5RLCChannelToBeModifiedItem,
        PC5RLCChannelToBeModifiedItem_ExtIEs,
        _PC5RLCChannelToBeReleasedList__item_,
        PC5RLCChannelToBeReleasedList,
        _PC5RLCChannelToBeReleasedItem_pC5RLCChannelID,
        _PC5RLCChannelToBeReleasedItem_remoteUELocalID,
        ____PC5RLCChannelToBeReleasedItem_iE_Extensions__item__id_tab,
        ___PC5RLCChannelToBeReleasedItem_iE_Extensions__item__id,
        ____PC5RLCChannelToBeReleasedItem_iE_Extensions__item__criticality_tab,
        ___PC5RLCChannelToBeReleasedItem_iE_Extensions__item__criticality,
        ____PC5RLCChannelToBeReleasedItem_iE_Extensions__item__extensionValue_tab,
        ___PC5RLCChannelToBeReleasedItem_iE_Extensions__item__extensionValue,
        __PC5RLCChannelToBeReleasedItem_iE_Extensions__item_,
        _PC5RLCChannelToBeReleasedItem_iE_Extensions,
        PC5RLCChannelToBeReleasedItem,
        PC5RLCChannelToBeReleasedItem_ExtIEs,
        _PC5RLCChannelSetupList__item_,
        PC5RLCChannelSetupList,
        _PC5RLCChannelSetupItem_pC5RLCChannelID,
        _PC5RLCChannelSetupItem_remoteUELocalID,
        ____PC5RLCChannelSetupItem_iE_Extensions__item__id_tab,
        ___PC5RLCChannelSetupItem_iE_Extensions__item__id,
        ____PC5RLCChannelSetupItem_iE_Extensions__item__criticality_tab,
        ___PC5RLCChannelSetupItem_iE_Extensions__item__criticality,
        ____PC5RLCChannelSetupItem_iE_Extensions__item__extensionValue_tab,
        ___PC5RLCChannelSetupItem_iE_Extensions__item__extensionValue,
        __PC5RLCChannelSetupItem_iE_Extensions__item_,
        _PC5RLCChannelSetupItem_iE_Extensions,
        PC5RLCChannelSetupItem,
        PC5RLCChannelSetupItem_ExtIEs,
        _PC5RLCChannelFailedToBeSetupList__item_,
        PC5RLCChannelFailedToBeSetupList,
        _PC5RLCChannelFailedToBeSetupItem_pC5RLCChannelID,
        _PC5RLCChannelFailedToBeSetupItem_remoteUELocalID,
        _PC5RLCChannelFailedToBeSetupItem_cause,
        ____PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__id_tab,
        ___PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__id,
        ____PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__criticality_tab,
        ___PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__criticality,
        ____PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__extensionValue_tab,
        ___PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item__extensionValue,
        __PC5RLCChannelFailedToBeSetupItem_iE_Extensions__item_,
        _PC5RLCChannelFailedToBeSetupItem_iE_Extensions,
        PC5RLCChannelFailedToBeSetupItem,
        PC5RLCChannelFailedToBeSetupItem_ExtIEs,
        _PC5RLCChannelModifiedList__item_,
        PC5RLCChannelModifiedList,
        _PC5RLCChannelModifiedItem_pC5RLCChannelID,
        _PC5RLCChannelModifiedItem_remoteUELocalID,
        ____PC5RLCChannelModifiedItem_iE_Extensions__item__id_tab,
        ___PC5RLCChannelModifiedItem_iE_Extensions__item__id,
        ____PC5RLCChannelModifiedItem_iE_Extensions__item__criticality_tab,
        ___PC5RLCChannelModifiedItem_iE_Extensions__item__criticality,
        ____PC5RLCChannelModifiedItem_iE_Extensions__item__extensionValue_tab,
        ___PC5RLCChannelModifiedItem_iE_Extensions__item__extensionValue,
        __PC5RLCChannelModifiedItem_iE_Extensions__item_,
        _PC5RLCChannelModifiedItem_iE_Extensions,
        PC5RLCChannelModifiedItem,
        PC5RLCChannelModifiedItem_ExtIEs,
        _PC5RLCChannelFailedToBeModifiedList__item_,
        PC5RLCChannelFailedToBeModifiedList,
        _PC5RLCChannelFailedToBeModifiedItem_pC5RLCChannelID,
        _PC5RLCChannelFailedToBeModifiedItem_remoteUELocalID,
        _PC5RLCChannelFailedToBeModifiedItem_cause,
        ____PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__id_tab,
        ___PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__id,
        ____PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__criticality_tab,
        ___PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__criticality,
        ____PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__extensionValue_tab,
        ___PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item__extensionValue,
        __PC5RLCChannelFailedToBeModifiedItem_iE_Extensions__item_,
        _PC5RLCChannelFailedToBeModifiedItem_iE_Extensions,
        PC5RLCChannelFailedToBeModifiedItem,
        PC5RLCChannelFailedToBeModifiedItem_ExtIEs,
        _PC5RLCChannelRequiredToBeModifiedList__item_,
        PC5RLCChannelRequiredToBeModifiedList,
        _PC5RLCChannelRequiredToBeModifiedItem_pC5RLCChannelID,
        _PC5RLCChannelRequiredToBeModifiedItem_remoteUELocalID,
        ____PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__id_tab,
        ___PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__id,
        ____PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__criticality_tab,
        ___PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__criticality,
        ____PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__extensionValue_tab,
        ___PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item__extensionValue,
        __PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions__item_,
        _PC5RLCChannelRequiredToBeModifiedItem_iE_Extensions,
        PC5RLCChannelRequiredToBeModifiedItem,
        PC5RLCChannelRequiredToBeModifiedItem_ExtIEs,
        _PC5RLCChannelRequiredToBeReleasedList__item_,
        PC5RLCChannelRequiredToBeReleasedList,
        _PC5RLCChannelRequiredToBeReleasedItem_pC5RLCChannelID,
        _PC5RLCChannelRequiredToBeReleasedItem_remoteUELocalID,
        ____PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__id_tab,
        ___PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__id,
        ____PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__criticality_tab,
        ___PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__criticality,
        ____PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__extensionValue_tab,
        ___PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item__extensionValue,
        __PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions__item_,
        _PC5RLCChannelRequiredToBeReleasedItem_iE_Extensions,
        PC5RLCChannelRequiredToBeReleasedItem,
        PC5RLCChannelRequiredToBeReleasedItem_ExtIEs,
        PDCCH_BlindDetectionSCG,
        PDCMeasurementPeriodicity,
        ___PDCMeasurementQuantities__item__id_tab,
        ____PDCMeasurementQuantities__item__id_tab_val_Value_0,
        __PDCMeasurementQuantities__item__id,
        __PDCMeasurementQuantities__item__criticality,
        __PDCMeasurementQuantities__item__value,
        _PDCMeasurementQuantities__item_,
        PDCMeasurementQuantities,
        PDCMeasurementQuantities_ItemIEs,
        _PDCMeasurementQuantities_ItemIEs_val_Value_0,
        _PDCMeasurementQuantities_Item_pDCmeasurementQuantitiesValue,
        ____PDCMeasurementQuantities_Item_iE_Extensions__item__id_tab,
        ___PDCMeasurementQuantities_Item_iE_Extensions__item__id,
        ____PDCMeasurementQuantities_Item_iE_Extensions__item__criticality_tab,
        ___PDCMeasurementQuantities_Item_iE_Extensions__item__criticality,
        ____PDCMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab,
        ___PDCMeasurementQuantities_Item_iE_Extensions__item__extensionValue,
        __PDCMeasurementQuantities_Item_iE_Extensions__item_,
        _PDCMeasurementQuantities_Item_iE_Extensions,
        PDCMeasurementQuantities_Item,
        PDCMeasurementQuantitiesValue_ExtIEs,
        PDCMeasurementQuantitiesValue,
        _PDCMeasurementResult_pDCMeasuredResultsList,
        ____PDCMeasurementResult_iE_Extensions__item__id_tab,
        ___PDCMeasurementResult_iE_Extensions__item__id,
        ____PDCMeasurementResult_iE_Extensions__item__criticality_tab,
        ___PDCMeasurementResult_iE_Extensions__item__criticality,
        ____PDCMeasurementResult_iE_Extensions__item__extensionValue_tab,
        ___PDCMeasurementResult_iE_Extensions__item__extensionValue,
        __PDCMeasurementResult_iE_Extensions__item_,
        _PDCMeasurementResult_iE_Extensions,
        PDCMeasurementResult,
        PDCMeasurementResult_ExtIEs,
        _PDCMeasuredResultsList__item_,
        PDCMeasuredResultsList,
        _PDCMeasuredResults_Item_pDCMeasuredResults_Value,
        ____PDCMeasuredResults_Item_iE_Extensions__item__id_tab,
        ___PDCMeasuredResults_Item_iE_Extensions__item__id,
        ____PDCMeasuredResults_Item_iE_Extensions__item__criticality_tab,
        ___PDCMeasuredResults_Item_iE_Extensions__item__criticality,
        ____PDCMeasuredResults_Item_iE_Extensions__item__extensionValue_tab,
        ___PDCMeasuredResults_Item_iE_Extensions__item__extensionValue,
        __PDCMeasuredResults_Item_iE_Extensions__item_,
        _PDCMeasuredResults_Item_iE_Extensions,
        PDCMeasuredResults_Item,
        PDCMeasuredResults_Item_ExtIEs,
        _PDCMeasuredResults_Value_pDC_TADV_NR,
        _PDCMeasuredResults_Value_pDC_RxTxTimeDiff,
        ___PDCMeasuredResults_Value_choice_extension_id_tab,
        __PDCMeasuredResults_Value_choice_extension_id,
        ___PDCMeasuredResults_Value_choice_extension_criticality_tab,
        __PDCMeasuredResults_Value_choice_extension_criticality,
        ___PDCMeasuredResults_Value_choice_extension_value_tab,
        __PDCMeasuredResults_Value_choice_extension_value,
        _PDCMeasuredResults_Value_choice_extension,
        PDCMeasuredResults_Value,
        PDCMeasuredResults_Value_ExtIEs,
        PDCReportType,
        PDC_RxTxTimeDiff,
        PDC_TADV_NR,
        PDCP_SN,
        PDCPSNLength,
        PDUSessionID,
        PEISubgroupingSupportIndication,
        ReportingPeriodicityValue,
        Periodicity,
        PeriodicitySRS,
        _PeriodicityList__item_,
        PeriodicityList,
        _PeriodicityList_Item_periodicitySRS,
        ____PeriodicityList_Item_iE_Extensions__item__id_tab,
        ___PeriodicityList_Item_iE_Extensions__item__id,
        ____PeriodicityList_Item_iE_Extensions__item__criticality_tab,
        ___PeriodicityList_Item_iE_Extensions__item__criticality,
        ____PeriodicityList_Item_iE_Extensions__item__extensionValue_tab,
        ___PeriodicityList_Item_iE_Extensions__item__extensionValue,
        __PeriodicityList_Item_iE_Extensions__item_,
        _PeriodicityList_Item_iE_Extensions,
        PeriodicityList_Item,
        PeriodicityList_ItemExtIEs,
        Permutation,
        Ph_InfoMCG,
        Ph_InfoSCG,
        PLMN_Identity,
        PlayoutDelayForMediaStartup,
        PortNumber,
        PosAssistance_Information,
        PosAssistanceInformationFailureList,
        PosBroadcast,
        PosConextRevIndication,
        _PositioningBroadcastCells__item_,
        PositioningBroadcastCells,
        _PosMeasGapPreConfigList_posMeasGapPreConfigToAddModList,
        _PosMeasGapPreConfigList_posMeasGapPreConfigToReleaseList,
        ____PosMeasGapPreConfigList_iE_Extensions__item__id_tab,
        ___PosMeasGapPreConfigList_iE_Extensions__item__id,
        ____PosMeasGapPreConfigList_iE_Extensions__item__criticality_tab,
        ___PosMeasGapPreConfigList_iE_Extensions__item__criticality,
        ____PosMeasGapPreConfigList_iE_Extensions__item__extensionValue_tab,
        ___PosMeasGapPreConfigList_iE_Extensions__item__extensionValue,
        __PosMeasGapPreConfigList_iE_Extensions__item_,
        _PosMeasGapPreConfigList_iE_Extensions,
        PosMeasGapPreConfigList,
        PosMeasGapPreConfigList_ExtIEs,
        MeasurementPeriodicity,
        MeasurementPeriodicityExtended,
        PosMeasurementPeriodicityNR_AoA,
        _PosMeasurementQuantities__item_,
        PosMeasurementQuantities,
        _PosMeasurementQuantities_Item_posMeasurementType,
        _PosMeasurementQuantities_Item_timingReportingGranularityFactor,
        ____PosMeasurementQuantities_Item_iE_Extensions__item__id_tab,
        ___PosMeasurementQuantities_Item_iE_Extensions__item__id,
        ____PosMeasurementQuantities_Item_iE_Extensions__item__criticality_tab,
        ___PosMeasurementQuantities_Item_iE_Extensions__item__criticality,
        ____PosMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab,
        ___PosMeasurementQuantities_Item_iE_Extensions__item__extensionValue,
        __PosMeasurementQuantities_Item_iE_Extensions__item_,
        _PosMeasurementQuantities_Item_iE_Extensions,
        PosMeasurementQuantities_Item,
        PosMeasurementQuantities_ItemExtIEs,
        _PosMeasurementResult__item_,
        PosMeasurementResult,
        _PosMeasurementResultItem_measuredResultsValue,
        _PosMeasurementResultItem_timeStamp,
        _PosMeasurementResultItem_measurementQuality,
        _PosMeasurementResultItem_measurementBeamInfo,
        ____PosMeasurementResultItem_iE_Extensions__item__id_tab,
        _____PosMeasurementResultItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____PosMeasurementResultItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____PosMeasurementResultItem_iE_Extensions__item__id_tab_val_Extension_2,
        ___PosMeasurementResultItem_iE_Extensions__item__id,
        ___PosMeasurementResultItem_iE_Extensions__item__criticality,
        ___PosMeasurementResultItem_iE_Extensions__item__extensionValue,
        __PosMeasurementResultItem_iE_Extensions__item_,
        _PosMeasurementResultItem_iE_Extensions,
        PosMeasurementResultItem,
        PosMeasurementResultItemExtIEs,
        _PosMeasurementResultItemExtIEs_val_Extension_0,
        _PosMeasurementResultItemExtIEs_val_Extension_1,
        _PosMeasurementResultItemExtIEs_val_Extension_2,
        _PosMeasurementResultList__item_,
        PosMeasurementResultList,
        _PosMeasurementResultList_Item_posMeasurementResult,
        _PosMeasurementResultList_Item_tRPID,
        ____PosMeasurementResultList_Item_iE_Extensions__item__id_tab,
        _____PosMeasurementResultList_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___PosMeasurementResultList_Item_iE_Extensions__item__id,
        ___PosMeasurementResultList_Item_iE_Extensions__item__criticality,
        ___PosMeasurementResultList_Item_iE_Extensions__item__extensionValue,
        __PosMeasurementResultList_Item_iE_Extensions__item_,
        _PosMeasurementResultList_Item_iE_Extensions,
        PosMeasurementResultList_Item,
        PosMeasurementResultList_ItemExtIEs,
        _PosMeasurementResultList_ItemExtIEs_val_Extension_0,
        PosMeasurementType,
        PosReportCharacteristics,
        _PosResourceSetType_periodic,
        _PosResourceSetType_semi_persistent,
        _PosResourceSetType_aperiodic,
        ___PosResourceSetType_choice_extension_id_tab,
        __PosResourceSetType_choice_extension_id,
        ___PosResourceSetType_choice_extension_criticality_tab,
        __PosResourceSetType_choice_extension_criticality,
        ___PosResourceSetType_choice_extension_value_tab,
        __PosResourceSetType_choice_extension_value,
        _PosResourceSetType_choice_extension,
        PosResourceSetType,
        PosResourceSetType_ExtIEs,
        _PosResourceSetTypePR_posperiodicSet,
        ____PosResourceSetTypePR_iE_Extensions__item__id_tab,
        ___PosResourceSetTypePR_iE_Extensions__item__id,
        ____PosResourceSetTypePR_iE_Extensions__item__criticality_tab,
        ___PosResourceSetTypePR_iE_Extensions__item__criticality,
        ____PosResourceSetTypePR_iE_Extensions__item__extensionValue_tab,
        ___PosResourceSetTypePR_iE_Extensions__item__extensionValue,
        __PosResourceSetTypePR_iE_Extensions__item_,
        _PosResourceSetTypePR_iE_Extensions,
        PosResourceSetTypePR,
        PosResourceSetTypePR_ExtIEs,
        _PosResourceSetTypeSP_possemi_persistentSet,
        ____PosResourceSetTypeSP_iE_Extensions__item__id_tab,
        ___PosResourceSetTypeSP_iE_Extensions__item__id,
        ____PosResourceSetTypeSP_iE_Extensions__item__criticality_tab,
        ___PosResourceSetTypeSP_iE_Extensions__item__criticality,
        ____PosResourceSetTypeSP_iE_Extensions__item__extensionValue_tab,
        ___PosResourceSetTypeSP_iE_Extensions__item__extensionValue,
        __PosResourceSetTypeSP_iE_Extensions__item_,
        _PosResourceSetTypeSP_iE_Extensions,
        PosResourceSetTypeSP,
        PosResourceSetTypeSP_ExtIEs,
        _PosResourceSetTypeAP_sRSResourceTrigger_List,
        ____PosResourceSetTypeAP_iE_Extensions__item__id_tab,
        ___PosResourceSetTypeAP_iE_Extensions__item__id,
        ____PosResourceSetTypeAP_iE_Extensions__item__criticality_tab,
        ___PosResourceSetTypeAP_iE_Extensions__item__criticality,
        ____PosResourceSetTypeAP_iE_Extensions__item__extensionValue_tab,
        ___PosResourceSetTypeAP_iE_Extensions__item__extensionValue,
        __PosResourceSetTypeAP_iE_Extensions__item_,
        _PosResourceSetTypeAP_iE_Extensions,
        PosResourceSetTypeAP,
        PosResourceSetTypeAP_ExtIEs,
        _PosSItypeList__item_,
        PosSItypeList,
        _PosSItype_Item_posItype,
        ____PosSItype_Item_iE_Extensions__item__id_tab,
        ___PosSItype_Item_iE_Extensions__item__id,
        ____PosSItype_Item_iE_Extensions__item__criticality_tab,
        ___PosSItype_Item_iE_Extensions__item__criticality,
        ____PosSItype_Item_iE_Extensions__item__extensionValue_tab,
        ___PosSItype_Item_iE_Extensions__item__extensionValue,
        __PosSItype_Item_iE_Extensions__item_,
        _PosSItype_Item_iE_Extensions,
        PosSItype_Item,
        PosSItype_ItemExtIEs,
        PosSItype,
        _PosSRSResourceID_List__item_,
        PosSRSResourceID_List,
        _PosSRSResource_Item_srs_PosResourceId,
        _PosSRSResource_Item_transmissionCombPos,
        _PosSRSResource_Item_startPosition,
        _PosSRSResource_Item_nrofSymbols,
        _PosSRSResource_Item_freqDomainShift,
        _PosSRSResource_Item_c_SRS,
        _PosSRSResource_Item_groupOrSequenceHopping,
        _PosSRSResource_Item_resourceTypePos,
        _PosSRSResource_Item_sequenceId,
        _PosSRSResource_Item_spatialRelationPos,
        ____PosSRSResource_Item_iE_Extensions__item__id_tab,
        ___PosSRSResource_Item_iE_Extensions__item__id,
        ____PosSRSResource_Item_iE_Extensions__item__criticality_tab,
        ___PosSRSResource_Item_iE_Extensions__item__criticality,
        ____PosSRSResource_Item_iE_Extensions__item__extensionValue_tab,
        ___PosSRSResource_Item_iE_Extensions__item__extensionValue,
        __PosSRSResource_Item_iE_Extensions__item_,
        _PosSRSResource_Item_iE_Extensions,
        PosSRSResource_Item,
        PosSRSResource_Item_ExtIEs,
        _PosSRSResource_List__item_,
        PosSRSResource_List,
        _PosSRSResourceSet_Item_possrsResourceSetID,
        _PosSRSResourceSet_Item_possRSResourceID_List,
        _PosSRSResourceSet_Item_posresourceSetType,
        ____PosSRSResourceSet_Item_iE_Extensions__item__id_tab,
        ___PosSRSResourceSet_Item_iE_Extensions__item__id,
        ____PosSRSResourceSet_Item_iE_Extensions__item__criticality_tab,
        ___PosSRSResourceSet_Item_iE_Extensions__item__criticality,
        ____PosSRSResourceSet_Item_iE_Extensions__item__extensionValue_tab,
        ___PosSRSResourceSet_Item_iE_Extensions__item__extensionValue,
        __PosSRSResourceSet_Item_iE_Extensions__item_,
        _PosSRSResourceSet_Item_iE_Extensions,
        PosSRSResourceSet_Item,
        PosSRSResourceSet_Item_ExtIEs,
        _PosSRSResourceSet_List__item_,
        PosSRSResourceSet_List,
        PrimaryPathIndication,
        Pre_emptionCapability,
        Pre_emptionVulnerability,
        PriorityLevel,
        ProtectedEUTRAResourceIndication,
        _Protected_EUTRA_Resources_Item_spectrumSharingGroupID,
        _Protected_EUTRA_Resources_Item_eUTRACells_List,
        ____Protected_EUTRA_Resources_Item_iE_Extensions__item__id_tab,
        ___Protected_EUTRA_Resources_Item_iE_Extensions__item__id,
        ____Protected_EUTRA_Resources_Item_iE_Extensions__item__criticality_tab,
        ___Protected_EUTRA_Resources_Item_iE_Extensions__item__criticality,
        ____Protected_EUTRA_Resources_Item_iE_Extensions__item__extensionValue_tab,
        ___Protected_EUTRA_Resources_Item_iE_Extensions__item__extensionValue,
        __Protected_EUTRA_Resources_Item_iE_Extensions__item_,
        _Protected_EUTRA_Resources_Item_iE_Extensions,
        Protected_EUTRA_Resources_Item,
        Protected_EUTRA_Resources_ItemExtIEs,
        _PRSConfiguration_pRSResourceSet_List,
        ____PRSConfiguration_iE_Extensions__item__id_tab,
        ___PRSConfiguration_iE_Extensions__item__id,
        ____PRSConfiguration_iE_Extensions__item__criticality_tab,
        ___PRSConfiguration_iE_Extensions__item__criticality,
        ____PRSConfiguration_iE_Extensions__item__extensionValue_tab,
        ___PRSConfiguration_iE_Extensions__item__extensionValue,
        __PRSConfiguration_iE_Extensions__item_,
        _PRSConfiguration_iE_Extensions,
        PRSConfiguration,
        PRSConfiguration_ExtIEs,
        _PRSInformationPos_pRS_IDPos,
        _PRSInformationPos_pRS_Resource_Set_IDPos,
        _PRSInformationPos_pRS_Resource_IDPos,
        ____PRSInformationPos_iE_Extensions__item__id_tab,
        ___PRSInformationPos_iE_Extensions__item__id,
        ____PRSInformationPos_iE_Extensions__item__criticality_tab,
        ___PRSInformationPos_iE_Extensions__item__criticality,
        ____PRSInformationPos_iE_Extensions__item__extensionValue_tab,
        ___PRSInformationPos_iE_Extensions__item__extensionValue,
        __PRSInformationPos_iE_Extensions__item_,
        _PRSInformationPos_iE_Extensions,
        PRSInformationPos,
        PRSInformationPos_ExtIEs,
        _PRS_Measurement_Info_List__item_,
        PRS_Measurement_Info_List,
        _PRS_Measurement_Info_List_Item_pointA,
        _PRS_Measurement_Info_List_Item_measPRSPeriodicity,
        _PRS_Measurement_Info_List_Item_measPRSOffset,
        _PRS_Measurement_Info_List_Item_measurementPRSLength,
        ____PRS_Measurement_Info_List_Item_iE_Extensions__item__id_tab,
        ___PRS_Measurement_Info_List_Item_iE_Extensions__item__id,
        ____PRS_Measurement_Info_List_Item_iE_Extensions__item__criticality_tab,
        ___PRS_Measurement_Info_List_Item_iE_Extensions__item__criticality,
        ____PRS_Measurement_Info_List_Item_iE_Extensions__item__extensionValue_tab,
        ___PRS_Measurement_Info_List_Item_iE_Extensions__item__extensionValue,
        __PRS_Measurement_Info_List_Item_iE_Extensions__item_,
        _PRS_Measurement_Info_List_Item_iE_Extensions,
        PRS_Measurement_Info_List_Item,
        PRS_Measurement_Info_List_Item_ExtIEs,
        _Potential_SpCell_Item_potential_SpCell_ID,
        ____Potential_SpCell_Item_iE_Extensions__item__id_tab,
        ___Potential_SpCell_Item_iE_Extensions__item__id,
        ____Potential_SpCell_Item_iE_Extensions__item__criticality_tab,
        ___Potential_SpCell_Item_iE_Extensions__item__criticality,
        ____Potential_SpCell_Item_iE_Extensions__item__extensionValue_tab,
        ___Potential_SpCell_Item_iE_Extensions__item__extensionValue,
        __Potential_SpCell_Item_iE_Extensions__item_,
        _Potential_SpCell_Item_iE_Extensions,
        Potential_SpCell_Item,
        Potential_SpCell_ItemExtIEs,
        _PRSAngleList__item_,
        PRSAngleList,
        _PRSAngleItem_nR_PRS_Azimuth,
        _PRSAngleItem_nR_PRS_Azimuth_fine,
        _PRSAngleItem_nR_PRS_Elevation,
        _PRSAngleItem_nR_PRS_Elevation_fine,
        ____PRSAngleItem_iE_Extensions__item__id_tab,
        _____PRSAngleItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___PRSAngleItem_iE_Extensions__item__id,
        ___PRSAngleItem_iE_Extensions__item__criticality,
        ___PRSAngleItem_iE_Extensions__item__extensionValue,
        __PRSAngleItem_iE_Extensions__item_,
        _PRSAngleItem_iE_Extensions,
        PRSAngleItem,
        PRSAngleItem_ItemExtIEs,
        _PRSAngleItem_ItemExtIEs_val_Extension_0,
        PRSConfigRequestType,
        _PRSMuting_pRSMutingOption1,
        _PRSMuting_pRSMutingOption2,
        ____PRSMuting_iE_Extensions__item__id_tab,
        ___PRSMuting_iE_Extensions__item__id,
        ____PRSMuting_iE_Extensions__item__criticality_tab,
        ___PRSMuting_iE_Extensions__item__criticality,
        ____PRSMuting_iE_Extensions__item__extensionValue_tab,
        ___PRSMuting_iE_Extensions__item__extensionValue,
        __PRSMuting_iE_Extensions__item_,
        _PRSMuting_iE_Extensions,
        PRSMuting,
        PRSMuting_ExtIEs,
        _PRSMutingOption1_mutingPattern,
        _PRSMutingOption1_mutingBitRepetitionFactor,
        ____PRSMutingOption1_iE_Extensions__item__id_tab,
        ___PRSMutingOption1_iE_Extensions__item__id,
        ____PRSMutingOption1_iE_Extensions__item__criticality_tab,
        ___PRSMutingOption1_iE_Extensions__item__criticality,
        ____PRSMutingOption1_iE_Extensions__item__extensionValue_tab,
        ___PRSMutingOption1_iE_Extensions__item__extensionValue,
        __PRSMutingOption1_iE_Extensions__item_,
        _PRSMutingOption1_iE_Extensions,
        PRSMutingOption1,
        PRSMutingOption1_ExtIEs,
        _PRSMutingOption2_mutingPattern,
        ____PRSMutingOption2_iE_Extensions__item__id_tab,
        ___PRSMutingOption2_iE_Extensions__item__id,
        ____PRSMutingOption2_iE_Extensions__item__criticality_tab,
        ___PRSMutingOption2_iE_Extensions__item__criticality,
        ____PRSMutingOption2_iE_Extensions__item__extensionValue_tab,
        ___PRSMutingOption2_iE_Extensions__item__extensionValue,
        __PRSMutingOption2_iE_Extensions__item_,
        _PRSMutingOption2_iE_Extensions,
        PRSMutingOption2,
        PRSMutingOption2_ExtIEs,
        PRS_Resource_ID,
        _PRSResource_List__item_,
        PRSResource_List,
        _PRSResource_Item_pRSResourceID,
        _PRSResource_Item_sequenceID,
        _PRSResource_Item_rEOffset,
        _PRSResource_Item_resourceSlotOffset,
        _PRSResource_Item_resourceSymbolOffset,
        _PRSResource_Item_qCLInfo,
        ____PRSResource_Item_iE_Extensions__item__id_tab,
        ___PRSResource_Item_iE_Extensions__item__id,
        ____PRSResource_Item_iE_Extensions__item__criticality_tab,
        ___PRSResource_Item_iE_Extensions__item__criticality,
        ____PRSResource_Item_iE_Extensions__item__extensionValue_tab,
        ___PRSResource_Item_iE_Extensions__item__extensionValue,
        __PRSResource_Item_iE_Extensions__item_,
        _PRSResource_Item_iE_Extensions,
        PRSResource_Item,
        PRSResource_Item_ExtIEs,
        _PRSResource_QCLInfo_qCLSourceSSB,
        _PRSResource_QCLInfo_qCLSourcePRS,
        ___PRSResource_QCLInfo_choice_extension_id_tab,
        __PRSResource_QCLInfo_choice_extension_id,
        ___PRSResource_QCLInfo_choice_extension_criticality_tab,
        __PRSResource_QCLInfo_choice_extension_criticality,
        ___PRSResource_QCLInfo_choice_extension_value_tab,
        __PRSResource_QCLInfo_choice_extension_value,
        _PRSResource_QCLInfo_choice_extension,
        PRSResource_QCLInfo,
        PRSResource_QCLInfo_ExtIEs,
        _PRSResource_QCLSourceSSB_pCI_NR,
        _PRSResource_QCLSourceSSB_sSB_Index,
        ____PRSResource_QCLSourceSSB_iE_Extensions__item__id_tab,
        ___PRSResource_QCLSourceSSB_iE_Extensions__item__id,
        ____PRSResource_QCLSourceSSB_iE_Extensions__item__criticality_tab,
        ___PRSResource_QCLSourceSSB_iE_Extensions__item__criticality,
        ____PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue_tab,
        ___PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue,
        __PRSResource_QCLSourceSSB_iE_Extensions__item_,
        _PRSResource_QCLSourceSSB_iE_Extensions,
        PRSResource_QCLSourceSSB,
        PRSResource_QCLSourceSSB_ExtIEs,
        _PRSResource_QCLSourcePRS_qCLSourcePRSResourceSetID,
        _PRSResource_QCLSourcePRS_qCLSourcePRSResourceID,
        ____PRSResource_QCLSourcePRS_iE_Extensions__item__id_tab,
        ___PRSResource_QCLSourcePRS_iE_Extensions__item__id,
        ____PRSResource_QCLSourcePRS_iE_Extensions__item__criticality_tab,
        ___PRSResource_QCLSourcePRS_iE_Extensions__item__criticality,
        ____PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue_tab,
        ___PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue,
        __PRSResource_QCLSourcePRS_iE_Extensions__item_,
        _PRSResource_QCLSourcePRS_iE_Extensions,
        PRSResource_QCLSourcePRS,
        PRSResource_QCLSourcePRS_ExtIEs,
        PRS_Resource_Set_ID,
        _PRSResourceSet_List__item_,
        PRSResourceSet_List,
        _PRSResourceSet_Item_pRSResourceSetID,
        _PRSResourceSet_Item_subcarrierSpacing,
        _PRSResourceSet_Item_pRSbandwidth,
        _PRSResourceSet_Item_startPRB,
        _PRSResourceSet_Item_pointA,
        _PRSResourceSet_Item_combSize,
        _PRSResourceSet_Item_cPType,
        _PRSResourceSet_Item_resourceSetPeriodicity,
        _PRSResourceSet_Item_resourceSetSlotOffset,
        _PRSResourceSet_Item_resourceRepetitionFactor,
        _PRSResourceSet_Item_resourceTimeGap,
        _PRSResourceSet_Item_resourceNumberofSymbols,
        _PRSResourceSet_Item_pRSMuting,
        _PRSResourceSet_Item_pRSResourceTransmitPower,
        _PRSResourceSet_Item_pRSResource_List,
        ____PRSResourceSet_Item_iE_Extensions__item__id_tab,
        ___PRSResourceSet_Item_iE_Extensions__item__id,
        ____PRSResourceSet_Item_iE_Extensions__item__criticality_tab,
        ___PRSResourceSet_Item_iE_Extensions__item__criticality,
        ____PRSResourceSet_Item_iE_Extensions__item__extensionValue_tab,
        ___PRSResourceSet_Item_iE_Extensions__item__extensionValue,
        __PRSResourceSet_Item_iE_Extensions__item_,
        _PRSResourceSet_Item_iE_Extensions,
        PRSResourceSet_Item,
        PRSResourceSet_Item_ExtIEs,
        _PRSTransmissionOffIndication_pRSTransmissionOffPerTRP,
        _PRSTransmissionOffIndication_pRSTransmissionOffPerResourceSet,
        _PRSTransmissionOffIndication_pRSTransmissionOffPerResource,
        ___PRSTransmissionOffIndication_choice_extension_id_tab,
        __PRSTransmissionOffIndication_choice_extension_id,
        ___PRSTransmissionOffIndication_choice_extension_criticality_tab,
        __PRSTransmissionOffIndication_choice_extension_criticality,
        ___PRSTransmissionOffIndication_choice_extension_value_tab,
        __PRSTransmissionOffIndication_choice_extension_value,
        _PRSTransmissionOffIndication_choice_extension,
        PRSTransmissionOffIndication,
        PRSTransmissionOffIndication_ExtIEs,
        _PRSTransmissionOffPerResource__item_,
        PRSTransmissionOffPerResource,
        _PRSTransmissionOffPerResource_Item_pRSResourceSetID,
        __PRSTransmissionOffPerResource_Item_pRSTransmissionOffIndicationPerResourceList__item_,
        _PRSTransmissionOffPerResource_Item_pRSTransmissionOffIndicationPerResourceList,
        ____PRSTransmissionOffPerResource_Item_iE_Extensions__item__id_tab,
        ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__id,
        ____PRSTransmissionOffPerResource_Item_iE_Extensions__item__criticality_tab,
        ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__criticality,
        ____PRSTransmissionOffPerResource_Item_iE_Extensions__item__extensionValue_tab,
        ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__extensionValue,
        __PRSTransmissionOffPerResource_Item_iE_Extensions__item_,
        _PRSTransmissionOffPerResource_Item_iE_Extensions,
        PRSTransmissionOffPerResource_Item,
        PRSTransmissionOffPerResource_Item_ExtIEs,
        _PRSTransmissionOffIndicationPerResource_Item_pRSResourceID,
        ____PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__id_tab,
        ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__id,
        ____PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__criticality_tab,
        ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__criticality,
        ____PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__extensionValue_tab,
        ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__extensionValue,
        __PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item_,
        _PRSTransmissionOffIndicationPerResource_Item_iE_Extensions,
        PRSTransmissionOffIndicationPerResource_Item,
        PRSTransmissionOffIndicationPerResource_Item_ExtIEs,
        _PRSTransmissionOffInformation_pRSTransmissionOffIndication,
        ____PRSTransmissionOffInformation_iE_Extensions__item__id_tab,
        ___PRSTransmissionOffInformation_iE_Extensions__item__id,
        ____PRSTransmissionOffInformation_iE_Extensions__item__criticality_tab,
        ___PRSTransmissionOffInformation_iE_Extensions__item__criticality,
        ____PRSTransmissionOffInformation_iE_Extensions__item__extensionValue_tab,
        ___PRSTransmissionOffInformation_iE_Extensions__item__extensionValue,
        __PRSTransmissionOffInformation_iE_Extensions__item_,
        _PRSTransmissionOffInformation_iE_Extensions,
        PRSTransmissionOffInformation,
        PRSTransmissionOffInformation_ExtIEs,
        _PRSTransmissionOffPerResourceSet__item_,
        PRSTransmissionOffPerResourceSet,
        _PRSTransmissionOffPerResourceSet_Item_pRSResourceSetID,
        ____PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__id_tab,
        ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__id,
        ____PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__criticality_tab,
        ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__criticality,
        ____PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__extensionValue_tab,
        ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__extensionValue,
        __PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item_,
        _PRSTransmissionOffPerResourceSet_Item_iE_Extensions,
        PRSTransmissionOffPerResourceSet_Item,
        PRSTransmissionOffPerResourceSet_Item_ExtIEs,
        _PWS_Failed_NR_CGI_Item_nRCGI,
        _PWS_Failed_NR_CGI_Item_numberOfBroadcasts,
        ____PWS_Failed_NR_CGI_Item_iE_Extensions__item__id_tab,
        ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__id,
        ____PWS_Failed_NR_CGI_Item_iE_Extensions__item__criticality_tab,
        ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__criticality,
        ____PWS_Failed_NR_CGI_Item_iE_Extensions__item__extensionValue_tab,
        ___PWS_Failed_NR_CGI_Item_iE_Extensions__item__extensionValue,
        __PWS_Failed_NR_CGI_Item_iE_Extensions__item_,
        _PWS_Failed_NR_CGI_Item_iE_Extensions,
        PWS_Failed_NR_CGI_Item,
        PWS_Failed_NR_CGI_ItemExtIEs,
        _PWSSystemInformation_sIBtype,
        _PWSSystemInformation_sIBmessage,
        ____PWSSystemInformation_iE_Extensions__item__id_tab,
        _____PWSSystemInformation_iE_Extensions__item__id_tab_val_Extension_0,
        _____PWSSystemInformation_iE_Extensions__item__id_tab_val_Extension_1,
        ___PWSSystemInformation_iE_Extensions__item__id,
        ___PWSSystemInformation_iE_Extensions__item__criticality,
        ___PWSSystemInformation_iE_Extensions__item__extensionValue,
        __PWSSystemInformation_iE_Extensions__item_,
        _PWSSystemInformation_iE_Extensions,
        PWSSystemInformation,
        PWSSystemInformationExtIEs,
        _PWSSystemInformationExtIEs_val_Extension_0,
        _PWSSystemInformationExtIEs_val_Extension_1,
        PrivacyIndicator,
        PRS_ID,
        _PRSTRPList__item_,
        PRSTRPList,
        _PRSTRPItem_tRP_ID,
        _PRSTRPItem_requestedDLPRSTransmissionCharacteristics,
        _PRSTRPItem_pRSTransmissionOffInformation,
        ____PRSTRPItem_iE_Extensions__item__id_tab,
        ___PRSTRPItem_iE_Extensions__item__id,
        ____PRSTRPItem_iE_Extensions__item__criticality_tab,
        ___PRSTRPItem_iE_Extensions__item__criticality,
        ____PRSTRPItem_iE_Extensions__item__extensionValue_tab,
        ___PRSTRPItem_iE_Extensions__item__extensionValue,
        __PRSTRPItem_iE_Extensions__item_,
        _PRSTRPItem_iE_Extensions,
        PRSTRPItem,
        PRSTRPItem_ExtIEs,
        _RequestedDLPRSTransmissionCharacteristics_requestedDLPRSResourceSet_List,
        _RequestedDLPRSTransmissionCharacteristics_numberofFrequencyLayers,
        _RequestedDLPRSTransmissionCharacteristics_startTimeAndDuration,
        ____RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__id_tab,
        ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__id,
        ____RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__criticality_tab,
        ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__criticality,
        ____RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__extensionValue_tab,
        ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__extensionValue,
        __RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item_,
        _RequestedDLPRSTransmissionCharacteristics_iE_Extensions,
        RequestedDLPRSTransmissionCharacteristics,
        RequestedDLPRSTransmissionCharacteristics_ExtIEs,
        _RequestedDLPRSResourceSet_List__item_,
        RequestedDLPRSResourceSet_List,
        _RequestedDLPRSResourceSet_Item_pRSbandwidth,
        _RequestedDLPRSResourceSet_Item_combSize,
        _RequestedDLPRSResourceSet_Item_resourceSetPeriodicity,
        _RequestedDLPRSResourceSet_Item_resourceRepetitionFactor,
        _RequestedDLPRSResourceSet_Item_resourceNumberofSymbols,
        _RequestedDLPRSResourceSet_Item_requestedDLPRSResource_List,
        _RequestedDLPRSResourceSet_Item_resourceSetStartTimeAndDuration,
        ____RequestedDLPRSResourceSet_Item_iE_Extensions__item__id_tab,
        ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__id,
        ____RequestedDLPRSResourceSet_Item_iE_Extensions__item__criticality_tab,
        ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__criticality,
        ____RequestedDLPRSResourceSet_Item_iE_Extensions__item__extensionValue_tab,
        ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__extensionValue,
        __RequestedDLPRSResourceSet_Item_iE_Extensions__item_,
        _RequestedDLPRSResourceSet_Item_iE_Extensions,
        RequestedDLPRSResourceSet_Item,
        RequestedDLPRSResourceSet_Item_ExtIEs,
        _RequestedDLPRSResource_List__item_,
        RequestedDLPRSResource_List,
        _RequestedDLPRSResource_Item_qCLInfo,
        ____RequestedDLPRSResource_Item_iE_Extensions__item__id_tab,
        ___RequestedDLPRSResource_Item_iE_Extensions__item__id,
        ____RequestedDLPRSResource_Item_iE_Extensions__item__criticality_tab,
        ___RequestedDLPRSResource_Item_iE_Extensions__item__criticality,
        ____RequestedDLPRSResource_Item_iE_Extensions__item__extensionValue_tab,
        ___RequestedDLPRSResource_Item_iE_Extensions__item__extensionValue,
        __RequestedDLPRSResource_Item_iE_Extensions__item_,
        _RequestedDLPRSResource_Item_iE_Extensions,
        RequestedDLPRSResource_Item,
        RequestedDLPRSResource_Item_ExtIEs,
        _PRSTransmissionTRPList__item_,
        PRSTransmissionTRPList,
        _PRSTransmissionTRPItem_tRP_ID,
        _PRSTransmissionTRPItem_pRSConfiguration,
        ____PRSTransmissionTRPItem_iE_Extensions__item__id_tab,
        ___PRSTransmissionTRPItem_iE_Extensions__item__id,
        ____PRSTransmissionTRPItem_iE_Extensions__item__criticality_tab,
        ___PRSTransmissionTRPItem_iE_Extensions__item__criticality,
        ____PRSTransmissionTRPItem_iE_Extensions__item__extensionValue_tab,
        ___PRSTransmissionTRPItem_iE_Extensions__item__extensionValue,
        __PRSTransmissionTRPItem_iE_Extensions__item_,
        _PRSTransmissionTRPItem_iE_Extensions,
        PRSTransmissionTRPItem,
        PRSTransmissionTRPItem_ExtIEs,
        QCI,
        _QoEInformation_qoEInformationList,
        ____QoEInformation_iE_Extensions__item__id_tab,
        ___QoEInformation_iE_Extensions__item__id,
        ____QoEInformation_iE_Extensions__item__criticality_tab,
        ___QoEInformation_iE_Extensions__item__criticality,
        ____QoEInformation_iE_Extensions__item__extensionValue_tab,
        ___QoEInformation_iE_Extensions__item__extensionValue,
        __QoEInformation_iE_Extensions__item_,
        _QoEInformation_iE_Extensions,
        QoEInformation,
        QoEInformation_ExtIEs,
        _QoEInformationList__item_,
        QoEInformationList,
        _QoEInformationList_Item_qoEMetrics,
        ____QoEInformationList_Item_iE_Extensions__item__id_tab,
        ___QoEInformationList_Item_iE_Extensions__item__id,
        ____QoEInformationList_Item_iE_Extensions__item__criticality_tab,
        ___QoEInformationList_Item_iE_Extensions__item__criticality,
        ____QoEInformationList_Item_iE_Extensions__item__extensionValue_tab,
        ___QoEInformationList_Item_iE_Extensions__item__extensionValue,
        __QoEInformationList_Item_iE_Extensions__item_,
        _QoEInformationList_Item_iE_Extensions,
        QoEInformationList_Item,
        QoEInformationList_Item_ExtIEs,
        _QoEMetrics_appLayerBufferLevelList,
        _QoEMetrics_playoutDelayForMediaStartup,
        ____QoEMetrics_iE_Extensions__item__id_tab,
        ___QoEMetrics_iE_Extensions__item__id,
        ____QoEMetrics_iE_Extensions__item__criticality_tab,
        ___QoEMetrics_iE_Extensions__item__criticality,
        ____QoEMetrics_iE_Extensions__item__extensionValue_tab,
        ___QoEMetrics_iE_Extensions__item__extensionValue,
        __QoEMetrics_iE_Extensions__item_,
        _QoEMetrics_iE_Extensions,
        QoEMetrics,
        QoEMetrics_ExtIEs,
        _QoS_Characteristics_non_Dynamic_5QI,
        _QoS_Characteristics_dynamic_5QI,
        ___QoS_Characteristics_choice_extension_id_tab,
        __QoS_Characteristics_choice_extension_id,
        ___QoS_Characteristics_choice_extension_criticality_tab,
        __QoS_Characteristics_choice_extension_criticality,
        ___QoS_Characteristics_choice_extension_value_tab,
        __QoS_Characteristics_choice_extension_value,
        _QoS_Characteristics_choice_extension,
        QoS_Characteristics,
        QoS_Characteristics_ExtIEs,
        QoSFlowIdentifier,
        _QoSFlowLevelQoSParameters_qoS_Characteristics,
        _QoSFlowLevelQoSParameters_nGRANallocationRetentionPriority,
        _QoSFlowLevelQoSParameters_gBR_QoS_Flow_Information,
        _QoSFlowLevelQoSParameters_reflective_QoS_Attribute,
        ____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab,
        _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_0,
        _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_1,
        _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_2,
        _____QoSFlowLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_3,
        ___QoSFlowLevelQoSParameters_iE_Extensions__item__id,
        ___QoSFlowLevelQoSParameters_iE_Extensions__item__criticality,
        ___QoSFlowLevelQoSParameters_iE_Extensions__item__extensionValue,
        __QoSFlowLevelQoSParameters_iE_Extensions__item_,
        _QoSFlowLevelQoSParameters_iE_Extensions,
        QoSFlowLevelQoSParameters,
        QoSFlowLevelQoSParameters_ExtIEs,
        _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_0,
        _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_1,
        _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_2,
        _QoSFlowLevelQoSParameters_ExtIEs_val_Extension_3,
        QoSFlowMappingIndication,
        _QoSInformation_eUTRANQoS,
        ___QoSInformation_choice_extension_id_tab,
        ____QoSInformation_choice_extension_id_tab_val_Value_0,
        __QoSInformation_choice_extension_id,
        __QoSInformation_choice_extension_criticality,
        __QoSInformation_choice_extension_value,
        _QoSInformation_choice_extension,
        QoSInformation,
        QoSInformation_ExtIEs,
        _QoSInformation_ExtIEs_val_Value_0,
        QosMonitoringRequest,
        QoSParaSetIndex,
        QoSParaSetNotifyIndex,
        RACH_Config_Common,
        RACH_Config_Common_IAB,
        RACHReportContainer,
        _RACHReportInformationList__item_,
        RACHReportInformationList,
        _RACHReportInformationItem_rACHReportContainer,
        _RACHReportInformationItem_uEAssitantIdentifier,
        ____RACHReportInformationItem_iE_Extensions__item__id_tab,
        ___RACHReportInformationItem_iE_Extensions__item__id,
        ____RACHReportInformationItem_iE_Extensions__item__criticality_tab,
        ___RACHReportInformationItem_iE_Extensions__item__criticality,
        ____RACHReportInformationItem_iE_Extensions__item__extensionValue_tab,
        ___RACHReportInformationItem_iE_Extensions__item__extensionValue,
        __RACHReportInformationItem_iE_Extensions__item_,
        _RACHReportInformationItem_iE_Extensions,
        RACHReportInformationItem,
        RACHReportInformationItem_ExtIEs,
        _RadioResourceStatus_sSBAreaRadioResourceStatusList,
        ____RadioResourceStatus_iE_Extensions__item__id_tab,
        _____RadioResourceStatus_iE_Extensions__item__id_tab_val_Extension_0,
        _____RadioResourceStatus_iE_Extensions__item__id_tab_val_Extension_1,
        ___RadioResourceStatus_iE_Extensions__item__id,
        ___RadioResourceStatus_iE_Extensions__item__criticality,
        ___RadioResourceStatus_iE_Extensions__item__extensionValue,
        __RadioResourceStatus_iE_Extensions__item_,
        _RadioResourceStatus_iE_Extensions,
        RadioResourceStatus,
        RadioResourceStatus_ExtIEs,
        _RadioResourceStatus_ExtIEs_val_Extension_0,
        _RadioResourceStatus_ExtIEs_val_Extension_1,
        _MIMOPRBusageInformation_dl_GBR_PRB_usage_for_MIMO,
        _MIMOPRBusageInformation_ul_GBR_PRB_usage_for_MIMO,
        _MIMOPRBusageInformation_dl_non_GBR_PRB_usage_for_MIMO,
        _MIMOPRBusageInformation_ul_non_GBR_PRB_usage_for_MIMO,
        _MIMOPRBusageInformation_dl_Total_PRB_usage_for_MIMO,
        _MIMOPRBusageInformation_ul_Total_PRB_usage_for_MIMO,
        ____MIMOPRBusageInformation_iE_Extensions__item__id_tab,
        ___MIMOPRBusageInformation_iE_Extensions__item__id,
        ____MIMOPRBusageInformation_iE_Extensions__item__criticality_tab,
        ___MIMOPRBusageInformation_iE_Extensions__item__criticality,
        ____MIMOPRBusageInformation_iE_Extensions__item__extensionValue_tab,
        ___MIMOPRBusageInformation_iE_Extensions__item__extensionValue,
        __MIMOPRBusageInformation_iE_Extensions__item_,
        _MIMOPRBusageInformation_iE_Extensions,
        MIMOPRBusageInformation,
        MIMOPRBusageInformation_ExtIEs,
        RANAC,
        RAN_MeasurementID,
        RAN_UE_MeasurementID,
        RAN_UE_PDC_MeasID,
        RANUEID,
        _RANUEPagingIdentity_iRNTI,
        ____RANUEPagingIdentity_iE_Extensions__item__id_tab,
        ___RANUEPagingIdentity_iE_Extensions__item__id,
        ____RANUEPagingIdentity_iE_Extensions__item__criticality_tab,
        ___RANUEPagingIdentity_iE_Extensions__item__criticality,
        ____RANUEPagingIdentity_iE_Extensions__item__extensionValue_tab,
        ___RANUEPagingIdentity_iE_Extensions__item__extensionValue,
        __RANUEPagingIdentity_iE_Extensions__item_,
        _RANUEPagingIdentity_iE_Extensions,
        RANUEPagingIdentity,
        RANUEPagingIdentity_ExtIEs,
        _RAT_FrequencyPriorityInformation_eNDC,
        _RAT_FrequencyPriorityInformation_nGRAN,
        ___RAT_FrequencyPriorityInformation_choice_extension_id_tab,
        __RAT_FrequencyPriorityInformation_choice_extension_id,
        ___RAT_FrequencyPriorityInformation_choice_extension_criticality_tab,
        __RAT_FrequencyPriorityInformation_choice_extension_criticality,
        ___RAT_FrequencyPriorityInformation_choice_extension_value_tab,
        __RAT_FrequencyPriorityInformation_choice_extension_value,
        _RAT_FrequencyPriorityInformation_choice_extension,
        RAT_FrequencyPriorityInformation,
        RAT_FrequencyPriorityInformation_ExtIEs,
        RAT_FrequencySelectionPriority,
        _RBSetConfiguration_subcarrierSpacing,
        _RBSetConfiguration_rBSetSize,
        _RBSetConfiguration_nUmberRBsets,
        ____RBSetConfiguration_iE_Extensions__item__id_tab,
        ___RBSetConfiguration_iE_Extensions__item__id,
        ____RBSetConfiguration_iE_Extensions__item__criticality_tab,
        ___RBSetConfiguration_iE_Extensions__item__criticality,
        ____RBSetConfiguration_iE_Extensions__item__extensionValue_tab,
        ___RBSetConfiguration_iE_Extensions__item__extensionValue,
        __RBSetConfiguration_iE_Extensions__item_,
        _RBSetConfiguration_iE_Extensions,
        RBSetConfiguration,
        RBSetConfiguration_ExtIEs,
        RBSetSize,
        Re_routingEnableIndicator,
        Redcap_Bcast_Information,
        RedCapIndication,
        Reestablishment_Indication,
        _ReferencePoint_coordinateID,
        _ReferencePoint_referencePointCoordinate,
        _ReferencePoint_referencePointCoordinateHA,
        ___ReferencePoint_choice_Extension_id_tab,
        __ReferencePoint_choice_Extension_id,
        ___ReferencePoint_choice_Extension_criticality_tab,
        __ReferencePoint_choice_Extension_criticality,
        ___ReferencePoint_choice_Extension_value_tab,
        __ReferencePoint_choice_Extension_value,
        _ReferencePoint_choice_Extension,
        ReferencePoint,
        ReferencePoint_ExtIEs,
        ReferenceSFN,
        _ReferenceSignal_nZP_CSI_RS,
        _ReferenceSignal_sSB,
        _ReferenceSignal_sRS,
        _ReferenceSignal_positioningSRS,
        _ReferenceSignal_dL_PRS,
        ___ReferenceSignal_choice_extension_id_tab,
        __ReferenceSignal_choice_extension_id,
        ___ReferenceSignal_choice_extension_criticality_tab,
        __ReferenceSignal_choice_extension_criticality,
        ___ReferenceSignal_choice_extension_value_tab,
        __ReferenceSignal_choice_extension_value,
        _ReferenceSignal_choice_extension,
        ReferenceSignal,
        ReferenceSignal_ExtIEs,
        _RelativeCartesianLocation_xYZunit,
        _RelativeCartesianLocation_xvalue,
        _RelativeCartesianLocation_yvalue,
        _RelativeCartesianLocation_zvalue,
        _RelativeCartesianLocation_locationUncertainty,
        ____RelativeCartesianLocation_iE_Extensions__item__id_tab,
        ___RelativeCartesianLocation_iE_Extensions__item__id,
        ____RelativeCartesianLocation_iE_Extensions__item__criticality_tab,
        ___RelativeCartesianLocation_iE_Extensions__item__criticality,
        ____RelativeCartesianLocation_iE_Extensions__item__extensionValue_tab,
        ___RelativeCartesianLocation_iE_Extensions__item__extensionValue,
        __RelativeCartesianLocation_iE_Extensions__item_,
        _RelativeCartesianLocation_iE_Extensions,
        RelativeCartesianLocation,
        RelativeCartesianLocation_ExtIEs,
        _RelativeGeodeticLocation_milli_Arc_SecondUnits,
        _RelativeGeodeticLocation_heightUnits,
        _RelativeGeodeticLocation_deltaLatitude,
        _RelativeGeodeticLocation_deltaLongitude,
        _RelativeGeodeticLocation_deltaHeight,
        _RelativeGeodeticLocation_locationUncertainty,
        ____RelativeGeodeticLocation_iE_extensions__item__id_tab,
        ___RelativeGeodeticLocation_iE_extensions__item__id,
        ____RelativeGeodeticLocation_iE_extensions__item__criticality_tab,
        ___RelativeGeodeticLocation_iE_extensions__item__criticality,
        ____RelativeGeodeticLocation_iE_extensions__item__extensionValue_tab,
        ___RelativeGeodeticLocation_iE_extensions__item__extensionValue,
        __RelativeGeodeticLocation_iE_extensions__item_,
        _RelativeGeodeticLocation_iE_extensions,
        RelativeGeodeticLocation,
        RelativeGeodeticLocation_ExtIEs,
        RemoteUELocalID,
        ReferenceTime,
        RegistrationRequest,
        ReportCharacteristics,
        ReportingPeriodicity,
        RequestedBandCombinationIndex,
        RequestedFeatureSetEntryIndex,
        RequestedP_MaxFR2,
        Requested_PDCCH_BlindDetectionSCG,
        _RequestedSRSTransmissionCharacteristics_numberOfTransmissions,
        _RequestedSRSTransmissionCharacteristics_resourceType,
        _RequestedSRSTransmissionCharacteristics_bandwidthSRS,
        _RequestedSRSTransmissionCharacteristics_sRSResourceSetList,
        _RequestedSRSTransmissionCharacteristics_sSBInformation,
        ____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab,
        _____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab_val_Extension_0,
        ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id,
        ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__criticality,
        ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__extensionValue,
        __RequestedSRSTransmissionCharacteristics_iE_Extensions__item_,
        _RequestedSRSTransmissionCharacteristics_iE_Extensions,
        RequestedSRSTransmissionCharacteristics,
        RequestedSRSTransmissionCharacteristics_ExtIEs,
        _RequestedSRSTransmissionCharacteristics_ExtIEs_val_Extension_0,
        RequestType,
        _ResourceCoordinationEUTRACellInfo_eUTRA_Mode_Info,
        _ResourceCoordinationEUTRACellInfo_eUTRA_PRACH_Configuration,
        ____ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id_tab,
        _____ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id_tab_val_Extension_0,
        ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__id,
        ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__criticality,
        ___ResourceCoordinationEUTRACellInfo_iE_Extensions__item__extensionValue,
        __ResourceCoordinationEUTRACellInfo_iE_Extensions__item_,
        _ResourceCoordinationEUTRACellInfo_iE_Extensions,
        ResourceCoordinationEUTRACellInfo,
        ResourceCoordinationEUTRACellInfo_ExtIEs,
        _ResourceCoordinationEUTRACellInfo_ExtIEs_val_Extension_0,
        _ResourceCoordinationTransferInformation_meNB_Cell_ID,
        _ResourceCoordinationTransferInformation_resourceCoordinationEUTRACellInfo,
        ____ResourceCoordinationTransferInformation_iE_Extensions__item__id_tab,
        ___ResourceCoordinationTransferInformation_iE_Extensions__item__id,
        ____ResourceCoordinationTransferInformation_iE_Extensions__item__criticality_tab,
        ___ResourceCoordinationTransferInformation_iE_Extensions__item__criticality,
        ____ResourceCoordinationTransferInformation_iE_Extensions__item__extensionValue_tab,
        ___ResourceCoordinationTransferInformation_iE_Extensions__item__extensionValue,
        __ResourceCoordinationTransferInformation_iE_Extensions__item_,
        _ResourceCoordinationTransferInformation_iE_Extensions,
        ResourceCoordinationTransferInformation,
        ResourceCoordinationTransferInformation_ExtIEs,
        ResourceCoordinationTransferContainer,
        _ResourceSetType_periodic,
        _ResourceSetType_semi_persistent,
        _ResourceSetType_aperiodic,
        ___ResourceSetType_choice_extension_id_tab,
        __ResourceSetType_choice_extension_id,
        ___ResourceSetType_choice_extension_criticality_tab,
        __ResourceSetType_choice_extension_criticality,
        ___ResourceSetType_choice_extension_value_tab,
        __ResourceSetType_choice_extension_value,
        _ResourceSetType_choice_extension,
        ResourceSetType,
        ResourceSetType_ExtIEs,
        _ResourceSetTypePeriodic_periodicSet,
        ____ResourceSetTypePeriodic_iE_Extensions__item__id_tab,
        ___ResourceSetTypePeriodic_iE_Extensions__item__id,
        ____ResourceSetTypePeriodic_iE_Extensions__item__criticality_tab,
        ___ResourceSetTypePeriodic_iE_Extensions__item__criticality,
        ____ResourceSetTypePeriodic_iE_Extensions__item__extensionValue_tab,
        ___ResourceSetTypePeriodic_iE_Extensions__item__extensionValue,
        __ResourceSetTypePeriodic_iE_Extensions__item_,
        _ResourceSetTypePeriodic_iE_Extensions,
        ResourceSetTypePeriodic,
        ResourceSetTypePeriodic_ExtIEs,
        _ResourceSetTypeSemi_persistent_semi_persistentSet,
        ____ResourceSetTypeSemi_persistent_iE_Extensions__item__id_tab,
        ___ResourceSetTypeSemi_persistent_iE_Extensions__item__id,
        ____ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality_tab,
        ___ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality,
        ____ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue_tab,
        ___ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue,
        __ResourceSetTypeSemi_persistent_iE_Extensions__item_,
        _ResourceSetTypeSemi_persistent_iE_Extensions,
        ResourceSetTypeSemi_persistent,
        ResourceSetTypeSemi_persistent_ExtIEs,
        _ResourceSetTypeAperiodic_sRSResourceTrigger_List,
        _ResourceSetTypeAperiodic_slotoffset,
        ____ResourceSetTypeAperiodic_iE_Extensions__item__id_tab,
        ___ResourceSetTypeAperiodic_iE_Extensions__item__id,
        ____ResourceSetTypeAperiodic_iE_Extensions__item__criticality_tab,
        ___ResourceSetTypeAperiodic_iE_Extensions__item__criticality,
        ____ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue_tab,
        ___ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue,
        __ResourceSetTypeAperiodic_iE_Extensions__item_,
        _ResourceSetTypeAperiodic_iE_Extensions,
        ResourceSetTypeAperiodic,
        ResourceSetTypeAperiodic_ExtIEs,
        RepetitionPeriod,
        _ReportingRequestType_eventType,
        _ReportingRequestType_reportingPeriodicityValue,
        ____ReportingRequestType_iE_Extensions__item__id_tab,
        ___ReportingRequestType_iE_Extensions__item__id,
        ____ReportingRequestType_iE_Extensions__item__criticality_tab,
        ___ReportingRequestType_iE_Extensions__item__criticality,
        ____ReportingRequestType_iE_Extensions__item__extensionValue_tab,
        ___ReportingRequestType_iE_Extensions__item__extensionValue,
        __ReportingRequestType_iE_Extensions__item_,
        _ReportingRequestType_iE_Extensions,
        ReportingRequestType,
        ReportingRequestType_ExtIEs,
        _ResourceType_periodic,
        _ResourceType_semi_persistent,
        _ResourceType_aperiodic,
        ___ResourceType_choice_extension_id_tab,
        __ResourceType_choice_extension_id,
        ___ResourceType_choice_extension_criticality_tab,
        __ResourceType_choice_extension_criticality,
        ___ResourceType_choice_extension_value_tab,
        __ResourceType_choice_extension_value,
        _ResourceType_choice_extension,
        ResourceType,
        ResourceType_ExtIEs,
        _ResourceTypePeriodic_periodicity,
        _ResourceTypePeriodic_offset,
        ____ResourceTypePeriodic_iE_Extensions__item__id_tab,
        ___ResourceTypePeriodic_iE_Extensions__item__id,
        ____ResourceTypePeriodic_iE_Extensions__item__criticality_tab,
        ___ResourceTypePeriodic_iE_Extensions__item__criticality,
        ____ResourceTypePeriodic_iE_Extensions__item__extensionValue_tab,
        ___ResourceTypePeriodic_iE_Extensions__item__extensionValue,
        __ResourceTypePeriodic_iE_Extensions__item_,
        _ResourceTypePeriodic_iE_Extensions,
        ResourceTypePeriodic,
        ResourceTypePeriodic_ExtIEs,
        _ResourceTypeSemi_persistent_periodicity,
        _ResourceTypeSemi_persistent_offset,
        ____ResourceTypeSemi_persistent_iE_Extensions__item__id_tab,
        ___ResourceTypeSemi_persistent_iE_Extensions__item__id,
        ____ResourceTypeSemi_persistent_iE_Extensions__item__criticality_tab,
        ___ResourceTypeSemi_persistent_iE_Extensions__item__criticality,
        ____ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue_tab,
        ___ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue,
        __ResourceTypeSemi_persistent_iE_Extensions__item_,
        _ResourceTypeSemi_persistent_iE_Extensions,
        ResourceTypeSemi_persistent,
        ResourceTypeSemi_persistent_ExtIEs,
        _ResourceTypeAperiodic_aperiodicResourceType,
        ____ResourceTypeAperiodic_iE_Extensions__item__id_tab,
        ___ResourceTypeAperiodic_iE_Extensions__item__id,
        ____ResourceTypeAperiodic_iE_Extensions__item__criticality_tab,
        ___ResourceTypeAperiodic_iE_Extensions__item__criticality,
        ____ResourceTypeAperiodic_iE_Extensions__item__extensionValue_tab,
        ___ResourceTypeAperiodic_iE_Extensions__item__extensionValue,
        __ResourceTypeAperiodic_iE_Extensions__item_,
        _ResourceTypeAperiodic_iE_Extensions,
        ResourceTypeAperiodic,
        ResourceTypeAperiodic_ExtIEs,
        _ResourceTypePos_periodic,
        _ResourceTypePos_semi_persistent,
        _ResourceTypePos_aperiodic,
        ___ResourceTypePos_choice_extension_id_tab,
        __ResourceTypePos_choice_extension_id,
        ___ResourceTypePos_choice_extension_criticality_tab,
        __ResourceTypePos_choice_extension_criticality,
        ___ResourceTypePos_choice_extension_value_tab,
        __ResourceTypePos_choice_extension_value,
        _ResourceTypePos_choice_extension,
        ResourceTypePos,
        ResourceTypePos_ExtIEs,
        _ResourceTypePeriodicPos_periodicity,
        _ResourceTypePeriodicPos_offset,
        ____ResourceTypePeriodicPos_iE_Extensions__item__id_tab,
        ___ResourceTypePeriodicPos_iE_Extensions__item__id,
        ____ResourceTypePeriodicPos_iE_Extensions__item__criticality_tab,
        ___ResourceTypePeriodicPos_iE_Extensions__item__criticality,
        ____ResourceTypePeriodicPos_iE_Extensions__item__extensionValue_tab,
        ___ResourceTypePeriodicPos_iE_Extensions__item__extensionValue,
        __ResourceTypePeriodicPos_iE_Extensions__item_,
        _ResourceTypePeriodicPos_iE_Extensions,
        ResourceTypePeriodicPos,
        ResourceTypePeriodicPos_ExtIEs,
        _ResourceTypeSemi_persistentPos_periodicity,
        _ResourceTypeSemi_persistentPos_offset,
        ____ResourceTypeSemi_persistentPos_iE_Extensions__item__id_tab,
        ___ResourceTypeSemi_persistentPos_iE_Extensions__item__id,
        ____ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality_tab,
        ___ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality,
        ____ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue_tab,
        ___ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue,
        __ResourceTypeSemi_persistentPos_iE_Extensions__item_,
        _ResourceTypeSemi_persistentPos_iE_Extensions,
        ResourceTypeSemi_persistentPos,
        ResourceTypeSemi_persistentPos_ExtIEs,
        _ResourceTypeAperiodicPos_slotOffset,
        ____ResourceTypeAperiodicPos_iE_Extensions__item__id_tab,
        ___ResourceTypeAperiodicPos_iE_Extensions__item__id,
        ____ResourceTypeAperiodicPos_iE_Extensions__item__criticality_tab,
        ___ResourceTypeAperiodicPos_iE_Extensions__item__criticality,
        ____ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue_tab,
        ___ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue,
        __ResourceTypeAperiodicPos_iE_Extensions__item_,
        _ResourceTypeAperiodicPos_iE_Extensions,
        ResourceTypeAperiodicPos,
        ResourceTypeAperiodicPos_ExtIEs,
        _RLCDuplicationInformation_rLCDuplicationStateList,
        _RLCDuplicationInformation_primaryPathIndication,
        ____RLCDuplicationInformation_iE_Extensions__item__id_tab,
        ___RLCDuplicationInformation_iE_Extensions__item__id,
        ____RLCDuplicationInformation_iE_Extensions__item__criticality_tab,
        ___RLCDuplicationInformation_iE_Extensions__item__criticality,
        ____RLCDuplicationInformation_iE_Extensions__item__extensionValue_tab,
        ___RLCDuplicationInformation_iE_Extensions__item__extensionValue,
        __RLCDuplicationInformation_iE_Extensions__item_,
        _RLCDuplicationInformation_iE_Extensions,
        RLCDuplicationInformation,
        RLCDuplicationInformation_ExtIEs,
        _RLCDuplicationStateList__item_,
        RLCDuplicationStateList,
        _RLCDuplicationState_Item_duplicationState,
        ____RLCDuplicationState_Item_iE_Extensions__item__id_tab,
        ___RLCDuplicationState_Item_iE_Extensions__item__id,
        ____RLCDuplicationState_Item_iE_Extensions__item__criticality_tab,
        ___RLCDuplicationState_Item_iE_Extensions__item__criticality,
        ____RLCDuplicationState_Item_iE_Extensions__item__extensionValue_tab,
        ___RLCDuplicationState_Item_iE_Extensions__item__extensionValue,
        __RLCDuplicationState_Item_iE_Extensions__item_,
        _RLCDuplicationState_Item_iE_Extensions,
        RLCDuplicationState_Item,
        RLCDuplicationState_Item_ExtIEs,
        _RLCFailureIndication_assocatedLCID,
        ____RLCFailureIndication_iE_Extensions__item__id_tab,
        ___RLCFailureIndication_iE_Extensions__item__id,
        ____RLCFailureIndication_iE_Extensions__item__criticality_tab,
        ___RLCFailureIndication_iE_Extensions__item__criticality,
        ____RLCFailureIndication_iE_Extensions__item__extensionValue_tab,
        ___RLCFailureIndication_iE_Extensions__item__extensionValue,
        __RLCFailureIndication_iE_Extensions__item_,
        _RLCFailureIndication_iE_Extensions,
        RLCFailureIndication,
        RLCFailureIndication_ExtIEs,
        RLCMode,
        _RLC_Status_reestablishment_Indication,
        ____RLC_Status_iE_Extensions__item__id_tab,
        ___RLC_Status_iE_Extensions__item__id,
        ____RLC_Status_iE_Extensions__item__criticality_tab,
        ___RLC_Status_iE_Extensions__item__criticality,
        ____RLC_Status_iE_Extensions__item__extensionValue_tab,
        ___RLC_Status_iE_Extensions__item__extensionValue,
        __RLC_Status_iE_Extensions__item_,
        _RLC_Status_iE_Extensions,
        RLC_Status,
        RLC_Status_ExtIEs,
        _RLFReportInformationList__item_,
        RLFReportInformationList,
        _RLFReportInformationItem_nRUERLFReportContainer,
        _RLFReportInformationItem_uEAssitantIdentifier,
        ____RLFReportInformationItem_iE_Extensions__item__id_tab,
        ___RLFReportInformationItem_iE_Extensions__item__id,
        ____RLFReportInformationItem_iE_Extensions__item__criticality_tab,
        ___RLFReportInformationItem_iE_Extensions__item__criticality,
        ____RLFReportInformationItem_iE_Extensions__item__extensionValue_tab,
        ___RLFReportInformationItem_iE_Extensions__item__extensionValue,
        __RLFReportInformationItem_iE_Extensions__item_,
        _RLFReportInformationItem_iE_Extensions,
        RLFReportInformationItem,
        RLFReportInformationItem_ExtIEs,
        RIMRSDetectionStatus,
        RRCContainer,
        RRCContainer_RRCSetupComplete,
        _RRCDeliveryStatus_delivery_status,
        _RRCDeliveryStatus_triggering_message,
        ____RRCDeliveryStatus_iE_Extensions__item__id_tab,
        ___RRCDeliveryStatus_iE_Extensions__item__id,
        ____RRCDeliveryStatus_iE_Extensions__item__criticality_tab,
        ___RRCDeliveryStatus_iE_Extensions__item__criticality,
        ____RRCDeliveryStatus_iE_Extensions__item__extensionValue_tab,
        ___RRCDeliveryStatus_iE_Extensions__item__extensionValue,
        __RRCDeliveryStatus_iE_Extensions__item_,
        _RRCDeliveryStatus_iE_Extensions,
        RRCDeliveryStatus,
        RRCDeliveryStatus_ExtIEs,
        RRCDeliveryStatusRequest,
        RRCReconfigurationCompleteIndicator,
        _RRC_Version_latest_RRC_Version,
        ____RRC_Version_iE_Extensions__item__id_tab,
        _____RRC_Version_iE_Extensions__item__id_tab_val_Extension_0,
        ___RRC_Version_iE_Extensions__item__id,
        ___RRC_Version_iE_Extensions__item__criticality,
        ___RRC_Version_iE_Extensions__item__extensionValue,
        __RRC_Version_iE_Extensions__item_,
        _RRC_Version_iE_Extensions,
        RRC_Version,
        RRC_Version_ExtIEs,
        _RRC_Version_ExtIEs_val_Extension_0,
        RoutingID,
        _ResponseTime_time,
        _ResponseTime_timeUnit,
        ____ResponseTime_iE_Extensions__item__id_tab,
        ___ResponseTime_iE_Extensions__item__id,
        ____ResponseTime_iE_Extensions__item__criticality_tab,
        ___ResponseTime_iE_Extensions__item__criticality,
        ____ResponseTime_iE_Extensions__item__extensionValue_tab,
        ___ResponseTime_iE_Extensions__item__extensionValue,
        __ResponseTime_iE_Extensions__item_,
        _ResponseTime_iE_Extensions,
        ResponseTime,
        ResponseTime_ExtIEs,
        RxTxTimingErrorMargin,
        _SCell_FailedtoSetup_Item_sCell_ID,
        _SCell_FailedtoSetup_Item_cause,
        ____SCell_FailedtoSetup_Item_iE_Extensions__item__id_tab,
        ___SCell_FailedtoSetup_Item_iE_Extensions__item__id,
        ____SCell_FailedtoSetup_Item_iE_Extensions__item__criticality_tab,
        ___SCell_FailedtoSetup_Item_iE_Extensions__item__criticality,
        ____SCell_FailedtoSetup_Item_iE_Extensions__item__extensionValue_tab,
        ___SCell_FailedtoSetup_Item_iE_Extensions__item__extensionValue,
        __SCell_FailedtoSetup_Item_iE_Extensions__item_,
        _SCell_FailedtoSetup_Item_iE_Extensions,
        SCell_FailedtoSetup_Item,
        SCell_FailedtoSetup_ItemExtIEs,
        _SCell_FailedtoSetupMod_Item_sCell_ID,
        _SCell_FailedtoSetupMod_Item_cause,
        ____SCell_FailedtoSetupMod_Item_iE_Extensions__item__id_tab,
        ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__id,
        ____SCell_FailedtoSetupMod_Item_iE_Extensions__item__criticality_tab,
        ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__criticality,
        ____SCell_FailedtoSetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___SCell_FailedtoSetupMod_Item_iE_Extensions__item__extensionValue,
        __SCell_FailedtoSetupMod_Item_iE_Extensions__item_,
        _SCell_FailedtoSetupMod_Item_iE_Extensions,
        SCell_FailedtoSetupMod_Item,
        SCell_FailedtoSetupMod_ItemExtIEs,
        _SCell_ToBeRemoved_Item_sCell_ID,
        ____SCell_ToBeRemoved_Item_iE_Extensions__item__id_tab,
        ___SCell_ToBeRemoved_Item_iE_Extensions__item__id,
        ____SCell_ToBeRemoved_Item_iE_Extensions__item__criticality_tab,
        ___SCell_ToBeRemoved_Item_iE_Extensions__item__criticality,
        ____SCell_ToBeRemoved_Item_iE_Extensions__item__extensionValue_tab,
        ___SCell_ToBeRemoved_Item_iE_Extensions__item__extensionValue,
        __SCell_ToBeRemoved_Item_iE_Extensions__item_,
        _SCell_ToBeRemoved_Item_iE_Extensions,
        SCell_ToBeRemoved_Item,
        SCell_ToBeRemoved_ItemExtIEs,
        _SCell_ToBeSetup_Item_sCell_ID,
        _SCell_ToBeSetup_Item_sCellIndex,
        _SCell_ToBeSetup_Item_sCellULConfigured,
        ____SCell_ToBeSetup_Item_iE_Extensions__item__id_tab,
        _____SCell_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___SCell_ToBeSetup_Item_iE_Extensions__item__id,
        ___SCell_ToBeSetup_Item_iE_Extensions__item__criticality,
        ___SCell_ToBeSetup_Item_iE_Extensions__item__extensionValue,
        __SCell_ToBeSetup_Item_iE_Extensions__item_,
        _SCell_ToBeSetup_Item_iE_Extensions,
        SCell_ToBeSetup_Item,
        SCell_ToBeSetup_ItemExtIEs,
        _SCell_ToBeSetup_ItemExtIEs_val_Extension_0,
        _SCell_ToBeSetupMod_Item_sCell_ID,
        _SCell_ToBeSetupMod_Item_sCellIndex,
        _SCell_ToBeSetupMod_Item_sCellULConfigured,
        ____SCell_ToBeSetupMod_Item_iE_Extensions__item__id_tab,
        _____SCell_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___SCell_ToBeSetupMod_Item_iE_Extensions__item__id,
        ___SCell_ToBeSetupMod_Item_iE_Extensions__item__criticality,
        ___SCell_ToBeSetupMod_Item_iE_Extensions__item__extensionValue,
        __SCell_ToBeSetupMod_Item_iE_Extensions__item_,
        _SCell_ToBeSetupMod_Item_iE_Extensions,
        SCell_ToBeSetupMod_Item,
        SCell_ToBeSetupMod_ItemExtIEs,
        _SCell_ToBeSetupMod_ItemExtIEs_val_Extension_0,
        SCellIndex,
        SCGActivationRequest,
        SCGActivationStatus,
        SCGIndicator,
        SCS_480,
        SCS_960,
        _SCS_SpecificCarrier_offsetToCarrier,
        _SCS_SpecificCarrier_subcarrierSpacing,
        _SCS_SpecificCarrier_carrierBandwidth,
        ____SCS_SpecificCarrier_iE_Extensions__item__id_tab,
        ___SCS_SpecificCarrier_iE_Extensions__item__id,
        ____SCS_SpecificCarrier_iE_Extensions__item__criticality_tab,
        ___SCS_SpecificCarrier_iE_Extensions__item__criticality,
        ____SCS_SpecificCarrier_iE_Extensions__item__extensionValue_tab,
        ___SCS_SpecificCarrier_iE_Extensions__item__extensionValue,
        __SCS_SpecificCarrier_iE_Extensions__item_,
        _SCS_SpecificCarrier_iE_Extensions,
        SCS_SpecificCarrier,
        SCS_SpecificCarrier_ExtIEs,
        SDTBearerConfigurationQueryIndication,
        _SDTBearerConfigurationInfo_sDTBearerConfig_List,
        ____SDTBearerConfigurationInfo_iE_Extensions__item__id_tab,
        ___SDTBearerConfigurationInfo_iE_Extensions__item__id,
        ____SDTBearerConfigurationInfo_iE_Extensions__item__criticality_tab,
        ___SDTBearerConfigurationInfo_iE_Extensions__item__criticality,
        ____SDTBearerConfigurationInfo_iE_Extensions__item__extensionValue_tab,
        ___SDTBearerConfigurationInfo_iE_Extensions__item__extensionValue,
        __SDTBearerConfigurationInfo_iE_Extensions__item_,
        _SDTBearerConfigurationInfo_iE_Extensions,
        SDTBearerConfigurationInfo,
        SDTBearerConfigurationInfo_ExtIEs,
        _SDTBearerConfig_List__item_,
        SDTBearerConfig_List,
        _SDTBearerConfig_List_Item_sDTBearerType,
        _SDTBearerConfig_List_Item_sDTRLCBearerConfiguration,
        ____SDTBearerConfig_List_Item_iE_Extensions__item__id_tab,
        ___SDTBearerConfig_List_Item_iE_Extensions__item__id,
        ____SDTBearerConfig_List_Item_iE_Extensions__item__criticality_tab,
        ___SDTBearerConfig_List_Item_iE_Extensions__item__criticality,
        ____SDTBearerConfig_List_Item_iE_Extensions__item__extensionValue_tab,
        ___SDTBearerConfig_List_Item_iE_Extensions__item__extensionValue,
        __SDTBearerConfig_List_Item_iE_Extensions__item_,
        _SDTBearerConfig_List_Item_iE_Extensions,
        SDTBearerConfig_List_Item,
        SDTBearerConfig_List_Item_ExtIEs,
        _SDTBearerType_sRB,
        _SDTBearerType_dRB,
        ___SDTBearerType_choice_extension_id_tab,
        __SDTBearerType_choice_extension_id,
        ___SDTBearerType_choice_extension_criticality_tab,
        __SDTBearerType_choice_extension_criticality,
        ___SDTBearerType_choice_extension_value_tab,
        __SDTBearerType_choice_extension_value,
        _SDTBearerType_choice_extension,
        SDTBearerType,
        SDTBearerType_ExtIEs,
        SDT_MAC_PHY_CG_Config,
        _SDTInformation_sdtIndicator,
        _SDTInformation_sdtAssistantInformation,
        ____SDTInformation_iE_Extensions__item__id_tab,
        ___SDTInformation_iE_Extensions__item__id,
        ____SDTInformation_iE_Extensions__item__criticality_tab,
        ___SDTInformation_iE_Extensions__item__criticality,
        ____SDTInformation_iE_Extensions__item__extensionValue_tab,
        ___SDTInformation_iE_Extensions__item__extensionValue,
        __SDTInformation_iE_Extensions__item_,
        _SDTInformation_iE_Extensions,
        SDTInformation,
        SDTInformation_ExtIEs,
        SDTRLCBearerConfiguration,
        SDT_Termination_Request,
        _Search_window_information_expectedPropagationDelay,
        _Search_window_information_delayUncertainty,
        ____Search_window_information_iE_Extensions__item__id_tab,
        ___Search_window_information_iE_Extensions__item__id,
        ____Search_window_information_iE_Extensions__item__criticality_tab,
        ___Search_window_information_iE_Extensions__item__criticality,
        ____Search_window_information_iE_Extensions__item__extensionValue_tab,
        ___Search_window_information_iE_Extensions__item__extensionValue,
        __Search_window_information_iE_Extensions__item_,
        _Search_window_information_iE_Extensions,
        Search_window_information,
        Search_window_information_ExtIEs,
        SerialNumber,
        SIBType_PWS,
        SelectedBandCombinationIndex,
        SelectedFeatureSetEntryIndex,
        CG_ConfigInfo,
        ServCellIndex,
        ServingCellMO,
        _ServingCellMO_List_Item_servingCellMO,
        _ServingCellMO_List_Item_sSB_Frequency,
        ____ServingCellMO_List_Item_iE_Extensions__item__id_tab,
        ___ServingCellMO_List_Item_iE_Extensions__item__id,
        ____ServingCellMO_List_Item_iE_Extensions__item__criticality_tab,
        ___ServingCellMO_List_Item_iE_Extensions__item__criticality,
        ____ServingCellMO_List_Item_iE_Extensions__item__extensionValue_tab,
        ___ServingCellMO_List_Item_iE_Extensions__item__extensionValue,
        __ServingCellMO_List_Item_iE_Extensions__item_,
        _ServingCellMO_List_Item_iE_Extensions,
        ServingCellMO_List_Item,
        ServingCellMO_List_Item_ExtIEs,
        _ServingCellMO_encoded_in_CGC_List__item_,
        ServingCellMO_encoded_in_CGC_List,
        _ServingCellMO_encoded_in_CGC_Item_servingCellMO,
        ____ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__id_tab,
        ___ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__id,
        ____ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__criticality_tab,
        ___ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__criticality,
        ____ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__extensionValue_tab,
        ___ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item__extensionValue,
        __ServingCellMO_encoded_in_CGC_Item_iE_Extensions__item_,
        _ServingCellMO_encoded_in_CGC_Item_iE_Extensions,
        ServingCellMO_encoded_in_CGC_Item,
        ServingCellMO_encoded_in_CGC_Item_ExtIEs,
        _Served_Cell_Information_nRCGI,
        _Served_Cell_Information_nRPCI,
        _Served_Cell_Information_fiveGS_TAC,
        _Served_Cell_Information_configured_EPS_TAC,
        _Served_Cell_Information_servedPLMNs,
        _Served_Cell_Information_nR_Mode_Info,
        _Served_Cell_Information_measurementTimingConfiguration,
        ____Served_Cell_Information_iE_Extensions__item__id_tab,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_1,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_2,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_3,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_4,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_5,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_6,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_7,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_8,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_9,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_10,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_11,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_12,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_13,
        _____Served_Cell_Information_iE_Extensions__item__id_tab_val_Extension_14,
        ___Served_Cell_Information_iE_Extensions__item__id,
        ___Served_Cell_Information_iE_Extensions__item__criticality,
        ___Served_Cell_Information_iE_Extensions__item__extensionValue,
        __Served_Cell_Information_iE_Extensions__item_,
        _Served_Cell_Information_iE_Extensions,
        Served_Cell_Information,
        Served_Cell_Information_ExtIEs,
        _Served_Cell_Information_ExtIEs_val_Extension_0,
        _Served_Cell_Information_ExtIEs_val_Extension_1,
        _Served_Cell_Information_ExtIEs_val_Extension_2,
        _Served_Cell_Information_ExtIEs_val_Extension_3,
        _Served_Cell_Information_ExtIEs_val_Extension_4,
        _Served_Cell_Information_ExtIEs_val_Extension_5,
        _Served_Cell_Information_ExtIEs_val_Extension_6,
        _Served_Cell_Information_ExtIEs_val_Extension_7,
        _Served_Cell_Information_ExtIEs_val_Extension_8,
        _Served_Cell_Information_ExtIEs_val_Extension_9,
        _Served_Cell_Information_ExtIEs_val_Extension_10,
        _Served_Cell_Information_ExtIEs_val_Extension_11,
        _Served_Cell_Information_ExtIEs_val_Extension_12,
        _Served_Cell_Information_ExtIEs_val_Extension_13,
        _Served_Cell_Information_ExtIEs_val_Extension_14,
        _Serving_Cells_List__item_,
        Serving_Cells_List,
        _Serving_Cells_List_Item_nRCGI,
        _Serving_Cells_List_Item_iAB_MT_Cell_NA_Resource_Configuration_Mode_Info,
        ____Serving_Cells_List_Item_iE_Extensions__item__id_tab,
        ___Serving_Cells_List_Item_iE_Extensions__item__id,
        ____Serving_Cells_List_Item_iE_Extensions__item__criticality_tab,
        ___Serving_Cells_List_Item_iE_Extensions__item__criticality,
        ____Serving_Cells_List_Item_iE_Extensions__item__extensionValue_tab,
        ___Serving_Cells_List_Item_iE_Extensions__item__extensionValue,
        __Serving_Cells_List_Item_iE_Extensions__item_,
        _Serving_Cells_List_Item_iE_Extensions,
        Serving_Cells_List_Item,
        Serving_Cells_List_Item_ExtIEs,
        _Supported_MBS_FSA_ID_List__item_,
        Supported_MBS_FSA_ID_List,
        MBS_FrequencySelectionArea_Identity,
        _SFN_Offset_sFN_Time_Offset,
        ____SFN_Offset_iE_Extensions__item__id_tab,
        ___SFN_Offset_iE_Extensions__item__id,
        ____SFN_Offset_iE_Extensions__item__criticality_tab,
        ___SFN_Offset_iE_Extensions__item__criticality,
        ____SFN_Offset_iE_Extensions__item__extensionValue_tab,
        ___SFN_Offset_iE_Extensions__item__extensionValue,
        __SFN_Offset_iE_Extensions__item_,
        _SFN_Offset_iE_Extensions,
        SFN_Offset,
        SFN_Offset_ExtIEs,
        _Served_Cells_To_Add_Item_served_Cell_Information,
        _Served_Cells_To_Add_Item_gNB_DU_System_Information,
        ____Served_Cells_To_Add_Item_iE_Extensions__item__id_tab,
        ___Served_Cells_To_Add_Item_iE_Extensions__item__id,
        ____Served_Cells_To_Add_Item_iE_Extensions__item__criticality_tab,
        ___Served_Cells_To_Add_Item_iE_Extensions__item__criticality,
        ____Served_Cells_To_Add_Item_iE_Extensions__item__extensionValue_tab,
        ___Served_Cells_To_Add_Item_iE_Extensions__item__extensionValue,
        __Served_Cells_To_Add_Item_iE_Extensions__item_,
        _Served_Cells_To_Add_Item_iE_Extensions,
        Served_Cells_To_Add_Item,
        Served_Cells_To_Add_ItemExtIEs,
        _Served_Cells_To_Delete_Item_oldNRCGI,
        ____Served_Cells_To_Delete_Item_iE_Extensions__item__id_tab,
        ___Served_Cells_To_Delete_Item_iE_Extensions__item__id,
        ____Served_Cells_To_Delete_Item_iE_Extensions__item__criticality_tab,
        ___Served_Cells_To_Delete_Item_iE_Extensions__item__criticality,
        ____Served_Cells_To_Delete_Item_iE_Extensions__item__extensionValue_tab,
        ___Served_Cells_To_Delete_Item_iE_Extensions__item__extensionValue,
        __Served_Cells_To_Delete_Item_iE_Extensions__item_,
        _Served_Cells_To_Delete_Item_iE_Extensions,
        Served_Cells_To_Delete_Item,
        Served_Cells_To_Delete_ItemExtIEs,
        _Served_Cells_To_Modify_Item_oldNRCGI,
        _Served_Cells_To_Modify_Item_served_Cell_Information,
        _Served_Cells_To_Modify_Item_gNB_DU_System_Information,
        ____Served_Cells_To_Modify_Item_iE_Extensions__item__id_tab,
        ___Served_Cells_To_Modify_Item_iE_Extensions__item__id,
        ____Served_Cells_To_Modify_Item_iE_Extensions__item__criticality_tab,
        ___Served_Cells_To_Modify_Item_iE_Extensions__item__criticality,
        ____Served_Cells_To_Modify_Item_iE_Extensions__item__extensionValue_tab,
        ___Served_Cells_To_Modify_Item_iE_Extensions__item__extensionValue,
        __Served_Cells_To_Modify_Item_iE_Extensions__item_,
        _Served_Cells_To_Modify_Item_iE_Extensions,
        Served_Cells_To_Modify_Item,
        Served_Cells_To_Modify_ItemExtIEs,
        _Served_EUTRA_Cells_Information_eUTRA_Mode_Info,
        _Served_EUTRA_Cells_Information_protectedEUTRAResourceIndication,
        ____Served_EUTRA_Cells_Information_iE_Extensions__item__id_tab,
        ___Served_EUTRA_Cells_Information_iE_Extensions__item__id,
        ____Served_EUTRA_Cells_Information_iE_Extensions__item__criticality_tab,
        ___Served_EUTRA_Cells_Information_iE_Extensions__item__criticality,
        ____Served_EUTRA_Cells_Information_iE_Extensions__item__extensionValue_tab,
        ___Served_EUTRA_Cells_Information_iE_Extensions__item__extensionValue,
        __Served_EUTRA_Cells_Information_iE_Extensions__item_,
        _Served_EUTRA_Cells_Information_iE_Extensions,
        Served_EUTRA_Cells_Information,
        Served_EUTRA_Cell_Information_ExtIEs,
        Service_State,
        _Service_Status_service_state,
        _Service_Status_switchingOffOngoing,
        ____Service_Status_iE_Extensions__item__id_tab,
        ___Service_Status_iE_Extensions__item__id,
        ____Service_Status_iE_Extensions__item__criticality_tab,
        ___Service_Status_iE_Extensions__item__criticality,
        ____Service_Status_iE_Extensions__item__extensionValue_tab,
        ___Service_Status_iE_Extensions__item__extensionValue,
        __Service_Status_iE_Extensions__item_,
        _Service_Status_iE_Extensions,
        Service_Status,
        Service_Status_ExtIEs,
        RelativeTime1900,
        ShortDRXCycleLength,
        ShortDRXCycleTimer,
        SIB1_message,
        SIB10_message,
        SIB12_message,
        SIB13_message,
        SIB14_message,
        SIB15_message,
        SIB17_message,
        SIB20_message,
        SItype,
        _SItype_List__item_,
        SItype_List,
        _SItype_Item_sItype,
        ____SItype_Item_iE_Extensions__item__id_tab,
        ___SItype_Item_iE_Extensions__item__id,
        ____SItype_Item_iE_Extensions__item__criticality_tab,
        ___SItype_Item_iE_Extensions__item__criticality,
        ____SItype_Item_iE_Extensions__item__extensionValue_tab,
        ___SItype_Item_iE_Extensions__item__extensionValue,
        __SItype_Item_iE_Extensions__item_,
        _SItype_Item_iE_Extensions,
        SItype_Item,
        SItype_ItemExtIEs,
        _SibtypetobeupdatedListItem_sIBtype,
        _SibtypetobeupdatedListItem_sIBmessage,
        _SibtypetobeupdatedListItem_valueTag,
        ____SibtypetobeupdatedListItem_iE_Extensions__item__id_tab,
        _____SibtypetobeupdatedListItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___SibtypetobeupdatedListItem_iE_Extensions__item__id,
        ___SibtypetobeupdatedListItem_iE_Extensions__item__criticality,
        ___SibtypetobeupdatedListItem_iE_Extensions__item__extensionValue,
        __SibtypetobeupdatedListItem_iE_Extensions__item_,
        _SibtypetobeupdatedListItem_iE_Extensions,
        SibtypetobeupdatedListItem,
        SibtypetobeupdatedListItem_ExtIEs,
        _SibtypetobeupdatedListItem_ExtIEs_val_Extension_0,
        _SidelinkRelayConfiguration_gNB_DU_UE_F1APIDofRelayUE,
        _SidelinkRelayConfiguration_remoteUELocalID,
        _SidelinkRelayConfiguration_sidelinkConfigurationContainer,
        ____SidelinkRelayConfiguration_iE_Extensions__item__id_tab,
        ___SidelinkRelayConfiguration_iE_Extensions__item__id,
        ____SidelinkRelayConfiguration_iE_Extensions__item__criticality_tab,
        ___SidelinkRelayConfiguration_iE_Extensions__item__criticality,
        ____SidelinkRelayConfiguration_iE_Extensions__item__extensionValue_tab,
        ___SidelinkRelayConfiguration_iE_Extensions__item__extensionValue,
        __SidelinkRelayConfiguration_iE_Extensions__item_,
        _SidelinkRelayConfiguration_iE_Extensions,
        SidelinkRelayConfiguration,
        SidelinkRelayConfiguration_ExtIEs,
        SidelinkConfigurationContainer,
        SLDRBID,
        _SLDRBInformation_sLDRB_QoS,
        _SLDRBInformation_flowsMappedToSLDRB_List,
        SLDRBInformation,
        _SLDRBs_FailedToBeModified_Item_sLDRBID,
        _SLDRBs_FailedToBeModified_Item_cause,
        ____SLDRBs_FailedToBeModified_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__id,
        ____SLDRBs_FailedToBeModified_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__criticality,
        ____SLDRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_FailedToBeModified_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_FailedToBeModified_Item_iE_Extensions__item_,
        _SLDRBs_FailedToBeModified_Item_iE_Extensions,
        SLDRBs_FailedToBeModified_Item,
        SLDRBs_FailedToBeModified_ItemExtIEs,
        _SLDRBs_FailedToBeSetup_Item_sLDRBID,
        _SLDRBs_FailedToBeSetup_Item_cause,
        ____SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__id,
        ____SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality,
        ____SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_FailedToBeSetup_Item_iE_Extensions__item_,
        _SLDRBs_FailedToBeSetup_Item_iE_Extensions,
        SLDRBs_FailedToBeSetup_Item,
        SLDRBs_FailedToBeSetup_ItemExtIEs,
        _SLDRBs_FailedToBeSetupMod_Item_sLDRBID,
        _SLDRBs_FailedToBeSetupMod_Item_cause,
        ____SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id,
        ____SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality,
        ____SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_FailedToBeSetupMod_Item_iE_Extensions__item_,
        _SLDRBs_FailedToBeSetupMod_Item_iE_Extensions,
        SLDRBs_FailedToBeSetupMod_Item,
        SLDRBs_FailedToBeSetupMod_ItemExtIEs,
        _SLDRBs_Modified_Item_sLDRBID,
        ____SLDRBs_Modified_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_Modified_Item_iE_Extensions__item__id,
        ____SLDRBs_Modified_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_Modified_Item_iE_Extensions__item__criticality,
        ____SLDRBs_Modified_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_Modified_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_Modified_Item_iE_Extensions__item_,
        _SLDRBs_Modified_Item_iE_Extensions,
        SLDRBs_Modified_Item,
        SLDRBs_Modified_ItemExtIEs,
        _SLDRBs_ModifiedConf_Item_sLDRBID,
        ____SLDRBs_ModifiedConf_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__id,
        ____SLDRBs_ModifiedConf_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__criticality,
        ____SLDRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_ModifiedConf_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_ModifiedConf_Item_iE_Extensions__item_,
        _SLDRBs_ModifiedConf_Item_iE_Extensions,
        SLDRBs_ModifiedConf_Item,
        SLDRBs_ModifiedConf_ItemExtIEs,
        _SLDRBs_Required_ToBeModified_Item_sLDRBID,
        ____SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__id,
        ____SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__criticality,
        ____SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_Required_ToBeModified_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_Required_ToBeModified_Item_iE_Extensions__item_,
        _SLDRBs_Required_ToBeModified_Item_iE_Extensions,
        SLDRBs_Required_ToBeModified_Item,
        SLDRBs_Required_ToBeModified_ItemExtIEs,
        _SLDRBs_Required_ToBeReleased_Item_sLDRBID,
        ____SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__id,
        ____SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality,
        ____SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_Required_ToBeReleased_Item_iE_Extensions__item_,
        _SLDRBs_Required_ToBeReleased_Item_iE_Extensions,
        SLDRBs_Required_ToBeReleased_Item,
        SLDRBs_Required_ToBeReleased_ItemExtIEs,
        _SLDRBs_Setup_Item_sLDRBID,
        ____SLDRBs_Setup_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_Setup_Item_iE_Extensions__item__id,
        ____SLDRBs_Setup_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_Setup_Item_iE_Extensions__item__criticality,
        ____SLDRBs_Setup_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_Setup_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_Setup_Item_iE_Extensions__item_,
        _SLDRBs_Setup_Item_iE_Extensions,
        SLDRBs_Setup_Item,
        SLDRBs_Setup_ItemExtIEs,
        _SLDRBs_SetupMod_Item_sLDRBID,
        ____SLDRBs_SetupMod_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_SetupMod_Item_iE_Extensions__item__id,
        ____SLDRBs_SetupMod_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_SetupMod_Item_iE_Extensions__item__criticality,
        ____SLDRBs_SetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_SetupMod_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_SetupMod_Item_iE_Extensions__item_,
        _SLDRBs_SetupMod_Item_iE_Extensions,
        SLDRBs_SetupMod_Item,
        SLDRBs_SetupMod_ItemExtIEs,
        _SLDRBs_ToBeModified_Item_sLDRBID,
        _SLDRBs_ToBeModified_Item_sLDRBInformation,
        _SLDRBs_ToBeModified_Item_rLCMode,
        ____SLDRBs_ToBeModified_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_ToBeModified_Item_iE_Extensions__item__id,
        ____SLDRBs_ToBeModified_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_ToBeModified_Item_iE_Extensions__item__criticality,
        ____SLDRBs_ToBeModified_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_ToBeModified_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_ToBeModified_Item_iE_Extensions__item_,
        _SLDRBs_ToBeModified_Item_iE_Extensions,
        SLDRBs_ToBeModified_Item,
        SLDRBs_ToBeModified_ItemExtIEs,
        _SLDRBs_ToBeReleased_Item_sLDRBID,
        ____SLDRBs_ToBeReleased_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__id,
        ____SLDRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__criticality,
        ____SLDRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_ToBeReleased_Item_iE_Extensions__item_,
        _SLDRBs_ToBeReleased_Item_iE_Extensions,
        SLDRBs_ToBeReleased_Item,
        SLDRBs_ToBeReleased_ItemExtIEs,
        _SLDRBs_ToBeSetup_Item_sLDRBID,
        _SLDRBs_ToBeSetup_Item_sLDRBInformation,
        _SLDRBs_ToBeSetup_Item_rLCMode,
        ____SLDRBs_ToBeSetup_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__id,
        ____SLDRBs_ToBeSetup_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__criticality,
        ____SLDRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_ToBeSetup_Item_iE_Extensions__item_,
        _SLDRBs_ToBeSetup_Item_iE_Extensions,
        SLDRBs_ToBeSetup_Item,
        SLDRBs_ToBeSetup_ItemExtIEs,
        _SLDRBs_ToBeSetupMod_Item_sLDRBID,
        _SLDRBs_ToBeSetupMod_Item_sLDRBInformation,
        _SLDRBs_ToBeSetupMod_Item_rLCMode,
        ____SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab,
        ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__id,
        ____SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality_tab,
        ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality,
        ____SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___SLDRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue,
        __SLDRBs_ToBeSetupMod_Item_iE_Extensions__item_,
        _SLDRBs_ToBeSetupMod_Item_iE_Extensions,
        SLDRBs_ToBeSetupMod_Item,
        SLDRBs_ToBeSetupMod_ItemExtIEs,
        _SLDRXCycleList__item_,
        SLDRXCycleList,
        _SLDRXCycleItem_rXUEID,
        _SLDRXCycleItem_sLDRXInformation,
        ____SLDRXCycleItem_iE_Extensions__item__id_tab,
        ___SLDRXCycleItem_iE_Extensions__item__id,
        ____SLDRXCycleItem_iE_Extensions__item__criticality_tab,
        ___SLDRXCycleItem_iE_Extensions__item__criticality,
        ____SLDRXCycleItem_iE_Extensions__item__extensionValue_tab,
        ___SLDRXCycleItem_iE_Extensions__item__extensionValue,
        __SLDRXCycleItem_iE_Extensions__item_,
        _SLDRXCycleItem_iE_Extensions,
        SLDRXCycleItem,
        SLDRXCycleItem_ExtIEs,
        _SLDRXInformation_sLDRXCycle,
        _SLDRXInformation_nosLDRX,
        ___SLDRXInformation_choice_extension_id_tab,
        __SLDRXInformation_choice_extension_id,
        ___SLDRXInformation_choice_extension_criticality_tab,
        __SLDRXInformation_choice_extension_criticality,
        ___SLDRXInformation_choice_extension_value_tab,
        __SLDRXInformation_choice_extension_value,
        _SLDRXInformation_choice_extension,
        SLDRXInformation,
        SLDRXCycleLength,
        SLDRXConfigurationIndicator,
        SLDRXInformation_ExtIEs,
        SL_PHY_MAC_RLC_Config,
        SL_RLC_ChannelToAddModList,
        SL_ConfigDedicatedEUTRA_Info,
        _SliceAvailableCapacity_sliceAvailableCapacityList,
        ____SliceAvailableCapacity_iE_Extensions__item__id_tab,
        ___SliceAvailableCapacity_iE_Extensions__item__id,
        ____SliceAvailableCapacity_iE_Extensions__item__criticality_tab,
        ___SliceAvailableCapacity_iE_Extensions__item__criticality,
        ____SliceAvailableCapacity_iE_Extensions__item__extensionValue_tab,
        ___SliceAvailableCapacity_iE_Extensions__item__extensionValue,
        __SliceAvailableCapacity_iE_Extensions__item_,
        _SliceAvailableCapacity_iE_Extensions,
        SliceAvailableCapacity,
        SliceAvailableCapacity_ExtIEs,
        _SliceAvailableCapacityList__item_,
        SliceAvailableCapacityList,
        _SliceAvailableCapacityItem_pLMNIdentity,
        _SliceAvailableCapacityItem_sNSSAIAvailableCapacity_List,
        ____SliceAvailableCapacityItem_iE_Extensions__item__id_tab,
        ___SliceAvailableCapacityItem_iE_Extensions__item__id,
        ____SliceAvailableCapacityItem_iE_Extensions__item__criticality_tab,
        ___SliceAvailableCapacityItem_iE_Extensions__item__criticality,
        ____SliceAvailableCapacityItem_iE_Extensions__item__extensionValue_tab,
        ___SliceAvailableCapacityItem_iE_Extensions__item__extensionValue,
        __SliceAvailableCapacityItem_iE_Extensions__item_,
        _SliceAvailableCapacityItem_iE_Extensions,
        SliceAvailableCapacityItem,
        SliceAvailableCapacityItem_ExtIEs,
        _SNSSAIAvailableCapacity_List__item_,
        SNSSAIAvailableCapacity_List,
        _SNSSAIAvailableCapacity_Item_sNSSAI,
        _SNSSAIAvailableCapacity_Item_sliceAvailableCapacityValueDownlink,
        _SNSSAIAvailableCapacity_Item_sliceAvailableCapacityValueUplink,
        ____SNSSAIAvailableCapacity_Item_iE_Extensions__item__id_tab,
        ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__id,
        ____SNSSAIAvailableCapacity_Item_iE_Extensions__item__criticality_tab,
        ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__criticality,
        ____SNSSAIAvailableCapacity_Item_iE_Extensions__item__extensionValue_tab,
        ___SNSSAIAvailableCapacity_Item_iE_Extensions__item__extensionValue,
        __SNSSAIAvailableCapacity_Item_iE_Extensions__item_,
        _SNSSAIAvailableCapacity_Item_iE_Extensions,
        SNSSAIAvailableCapacity_Item,
        SNSSAIAvailableCapacity_Item_ExtIEs,
        _SliceRadioResourceStatus_sliceRadioResourceStatus,
        ____SliceRadioResourceStatus_iE_Extensions__item__id_tab,
        ___SliceRadioResourceStatus_iE_Extensions__item__id,
        ____SliceRadioResourceStatus_iE_Extensions__item__criticality_tab,
        ___SliceRadioResourceStatus_iE_Extensions__item__criticality,
        ____SliceRadioResourceStatus_iE_Extensions__item__extensionValue_tab,
        ___SliceRadioResourceStatus_iE_Extensions__item__extensionValue,
        __SliceRadioResourceStatus_iE_Extensions__item_,
        _SliceRadioResourceStatus_iE_Extensions,
        SliceRadioResourceStatus,
        SliceRadioResourceStatus_ExtIEs,
        _SliceRadioResourceStatus_List__item_,
        SliceRadioResourceStatus_List,
        _SliceRadioResourceStatus_Item_pLMNIdentity,
        _SliceRadioResourceStatus_Item_sNSSAIRadioResourceStatus_List,
        ____SliceRadioResourceStatus_Item_iE_Extensions__item__id_tab,
        ___SliceRadioResourceStatus_Item_iE_Extensions__item__id,
        ____SliceRadioResourceStatus_Item_iE_Extensions__item__criticality_tab,
        ___SliceRadioResourceStatus_Item_iE_Extensions__item__criticality,
        ____SliceRadioResourceStatus_Item_iE_Extensions__item__extensionValue_tab,
        ___SliceRadioResourceStatus_Item_iE_Extensions__item__extensionValue,
        __SliceRadioResourceStatus_Item_iE_Extensions__item_,
        _SliceRadioResourceStatus_Item_iE_Extensions,
        SliceRadioResourceStatus_Item,
        SliceRadioResourceStatus_Item_ExtIEs,
        _SNSSAIRadioResourceStatus_List__item_,
        SNSSAIRadioResourceStatus_List,
        _SNSSAIRadioResourceStatus_Item_sNSSAI,
        _SNSSAIRadioResourceStatus_Item_sNSSAIdlGBRPRBusage,
        _SNSSAIRadioResourceStatus_Item_sNSSAIulGBRPRBusage,
        _SNSSAIRadioResourceStatus_Item_sNSSAIdlNonGBRPRBusage,
        _SNSSAIRadioResourceStatus_Item_sNSSAIulNonGBRPRBusage,
        _SNSSAIRadioResourceStatus_Item_sNSSAIdlTotalPRBallocation,
        _SNSSAIRadioResourceStatus_Item_sNSSAIulTotalPRBallocation,
        ____SNSSAIRadioResourceStatus_Item_iE_Extensions__item__id_tab,
        ___SNSSAIRadioResourceStatus_Item_iE_Extensions__item__id,
        ____SNSSAIRadioResourceStatus_Item_iE_Extensions__item__criticality_tab,
        ___SNSSAIRadioResourceStatus_Item_iE_Extensions__item__criticality,
        ____SNSSAIRadioResourceStatus_Item_iE_Extensions__item__extensionValue_tab,
        ___SNSSAIRadioResourceStatus_Item_iE_Extensions__item__extensionValue,
        __SNSSAIRadioResourceStatus_Item_iE_Extensions__item_,
        _SNSSAIRadioResourceStatus_Item_iE_Extensions,
        SNSSAIRadioResourceStatus_Item,
        SNSSAIRadioResourceStatus_Item_ExtIEs,
        _SliceSupportList__item_,
        SliceSupportList,
        _SliceSupportItem_sNSSAI,
        ____SliceSupportItem_iE_Extensions__item__id_tab,
        ___SliceSupportItem_iE_Extensions__item__id,
        ____SliceSupportItem_iE_Extensions__item__criticality_tab,
        ___SliceSupportItem_iE_Extensions__item__criticality,
        ____SliceSupportItem_iE_Extensions__item__extensionValue_tab,
        ___SliceSupportItem_iE_Extensions__item__extensionValue,
        __SliceSupportItem_iE_Extensions__item_,
        _SliceSupportItem_iE_Extensions,
        SliceSupportItem,
        SliceSupportItem_ExtIEs,
        _SliceToReportList__item_,
        SliceToReportList,
        _SliceToReportItem_pLMNIdentity,
        _SliceToReportItem_sNSSAIlist,
        ____SliceToReportItem_iE_Extensions__item__id_tab,
        ___SliceToReportItem_iE_Extensions__item__id,
        ____SliceToReportItem_iE_Extensions__item__criticality_tab,
        ___SliceToReportItem_iE_Extensions__item__criticality,
        ____SliceToReportItem_iE_Extensions__item__extensionValue_tab,
        ___SliceToReportItem_iE_Extensions__item__extensionValue,
        __SliceToReportItem_iE_Extensions__item_,
        _SliceToReportItem_iE_Extensions,
        SliceToReportItem,
        SliceToReportItem_ExtIEs,
        SlotNumber,
        _SNSSAI_list__item_,
        SNSSAI_list,
        _SNSSAI_Item_sNSSAI,
        ____SNSSAI_Item_iE_Extensions__item__id_tab,
        ___SNSSAI_Item_iE_Extensions__item__id,
        ____SNSSAI_Item_iE_Extensions__item__criticality_tab,
        ___SNSSAI_Item_iE_Extensions__item__criticality,
        ____SNSSAI_Item_iE_Extensions__item__extensionValue_tab,
        ___SNSSAI_Item_iE_Extensions__item__extensionValue,
        __SNSSAI_Item_iE_Extensions__item_,
        _SNSSAI_Item_iE_Extensions,
        SNSSAI_Item,
        SNSSAI_Item_ExtIEs,
        _Slot_Configuration_List__item_,
        Slot_Configuration_List,
        _Slot_Configuration_Item_slotIndex,
        _Slot_Configuration_Item_symbolAllocInSlot,
        ____Slot_Configuration_Item_iE_Extensions__item__id_tab,
        ___Slot_Configuration_Item_iE_Extensions__item__id,
        ____Slot_Configuration_Item_iE_Extensions__item__criticality_tab,
        ___Slot_Configuration_Item_iE_Extensions__item__criticality,
        ____Slot_Configuration_Item_iE_Extensions__item__extensionValue_tab,
        ___Slot_Configuration_Item_iE_Extensions__item__extensionValue,
        __Slot_Configuration_Item_iE_Extensions__item_,
        _Slot_Configuration_Item_iE_Extensions,
        Slot_Configuration_Item,
        Slot_Configuration_ItemExtIEs,
        _SNSSAI_sST,
        _SNSSAI_sD,
        ____SNSSAI_iE_Extensions__item__id_tab,
        ___SNSSAI_iE_Extensions__item__id,
        ____SNSSAI_iE_Extensions__item__criticality_tab,
        ___SNSSAI_iE_Extensions__item__criticality,
        ____SNSSAI_iE_Extensions__item__extensionValue_tab,
        ___SNSSAI_iE_Extensions__item__extensionValue,
        __SNSSAI_iE_Extensions__item_,
        _SNSSAI_iE_Extensions,
        SNSSAI,
        SNSSAI_ExtIEs,
        _SpatialDirectionInformation_nR_PRSBeamInformation,
        ____SpatialDirectionInformation_iE_Extensions__item__id_tab,
        ___SpatialDirectionInformation_iE_Extensions__item__id,
        ____SpatialDirectionInformation_iE_Extensions__item__criticality_tab,
        ___SpatialDirectionInformation_iE_Extensions__item__criticality,
        ____SpatialDirectionInformation_iE_Extensions__item__extensionValue_tab,
        ___SpatialDirectionInformation_iE_Extensions__item__extensionValue,
        __SpatialDirectionInformation_iE_Extensions__item_,
        _SpatialDirectionInformation_iE_Extensions,
        SpatialDirectionInformation,
        SpatialDirectionInformation_ExtIEs,
        _SpatialRelationInfo_spatialRelationforResourceID,
        ____SpatialRelationInfo_iE_Extensions__item__id_tab,
        ___SpatialRelationInfo_iE_Extensions__item__id,
        ____SpatialRelationInfo_iE_Extensions__item__criticality_tab,
        ___SpatialRelationInfo_iE_Extensions__item__criticality,
        ____SpatialRelationInfo_iE_Extensions__item__extensionValue_tab,
        ___SpatialRelationInfo_iE_Extensions__item__extensionValue,
        __SpatialRelationInfo_iE_Extensions__item_,
        _SpatialRelationInfo_iE_Extensions,
        SpatialRelationInfo,
        SpatialRelationInfo_ExtIEs,
        _SpatialRelationforResourceID__item_,
        SpatialRelationforResourceID,
        _SpatialRelationforResourceIDItem_referenceSignal,
        ____SpatialRelationforResourceIDItem_iE_Extensions__item__id_tab,
        ___SpatialRelationforResourceIDItem_iE_Extensions__item__id,
        ____SpatialRelationforResourceIDItem_iE_Extensions__item__criticality_tab,
        ___SpatialRelationforResourceIDItem_iE_Extensions__item__criticality,
        ____SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue_tab,
        ___SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue,
        __SpatialRelationforResourceIDItem_iE_Extensions__item_,
        _SpatialRelationforResourceIDItem_iE_Extensions,
        SpatialRelationforResourceIDItem,
        SpatialRelationforResourceIDItem_ExtIEs,
        _SpatialRelationPerSRSResource_spatialRelationPerSRSResource_List,
        ____SpatialRelationPerSRSResource_iE_Extensions__item__id_tab,
        ___SpatialRelationPerSRSResource_iE_Extensions__item__id,
        ____SpatialRelationPerSRSResource_iE_Extensions__item__criticality_tab,
        ___SpatialRelationPerSRSResource_iE_Extensions__item__criticality,
        ____SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue_tab,
        ___SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue,
        __SpatialRelationPerSRSResource_iE_Extensions__item_,
        _SpatialRelationPerSRSResource_iE_Extensions,
        SpatialRelationPerSRSResource,
        SpatialRelationPerSRSResource_ExtIEs,
        _SpatialRelationPerSRSResource_List__item_,
        SpatialRelationPerSRSResource_List,
        _SpatialRelationPerSRSResourceItem_referenceSignal,
        ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__id_tab,
        ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__id,
        ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality_tab,
        ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality,
        ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue_tab,
        ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue,
        __SpatialRelationPerSRSResourceItem_iE_Extensions__item_,
        _SpatialRelationPerSRSResourceItem_iE_Extensions,
        SpatialRelationPerSRSResourceItem,
        SpatialRelationPerSRSResourceItem_ExtIEs,
        _SpatialRelationPos_sSBPos,
        _SpatialRelationPos_pRSInformationPos,
        ___SpatialRelationPos_choice_extension_id_tab,
        __SpatialRelationPos_choice_extension_id,
        ___SpatialRelationPos_choice_extension_criticality_tab,
        __SpatialRelationPos_choice_extension_criticality,
        ___SpatialRelationPos_choice_extension_value_tab,
        __SpatialRelationPos_choice_extension_value,
        _SpatialRelationPos_choice_extension,
        SpatialRelationPos,
        SpatialInformationPos_ExtIEs,
        SpectrumSharingGroupID,
        SRBID,
        _SRBs_FailedToBeSetup_Item_sRBID,
        _SRBs_FailedToBeSetup_Item_cause,
        ____SRBs_FailedToBeSetup_Item_iE_Extensions__item__id_tab,
        ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__id,
        ____SRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality_tab,
        ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__criticality,
        ____SRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue_tab,
        ___SRBs_FailedToBeSetup_Item_iE_Extensions__item__extensionValue,
        __SRBs_FailedToBeSetup_Item_iE_Extensions__item_,
        _SRBs_FailedToBeSetup_Item_iE_Extensions,
        SRBs_FailedToBeSetup_Item,
        SRBs_FailedToBeSetup_ItemExtIEs,
        _SRBs_FailedToBeSetupMod_Item_sRBID,
        _SRBs_FailedToBeSetupMod_Item_cause,
        ____SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id_tab,
        ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__id,
        ____SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality_tab,
        ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__criticality,
        ____SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___SRBs_FailedToBeSetupMod_Item_iE_Extensions__item__extensionValue,
        __SRBs_FailedToBeSetupMod_Item_iE_Extensions__item_,
        _SRBs_FailedToBeSetupMod_Item_iE_Extensions,
        SRBs_FailedToBeSetupMod_Item,
        SRBs_FailedToBeSetupMod_ItemExtIEs,
        _SRBs_Modified_Item_sRBID,
        _SRBs_Modified_Item_lCID,
        ____SRBs_Modified_Item_iE_Extensions__item__id_tab,
        ___SRBs_Modified_Item_iE_Extensions__item__id,
        ____SRBs_Modified_Item_iE_Extensions__item__criticality_tab,
        ___SRBs_Modified_Item_iE_Extensions__item__criticality,
        ____SRBs_Modified_Item_iE_Extensions__item__extensionValue_tab,
        ___SRBs_Modified_Item_iE_Extensions__item__extensionValue,
        __SRBs_Modified_Item_iE_Extensions__item_,
        _SRBs_Modified_Item_iE_Extensions,
        SRBs_Modified_Item,
        SRBs_Modified_ItemExtIEs,
        _SRBs_Required_ToBeReleased_Item_sRBID,
        ____SRBs_Required_ToBeReleased_Item_iE_Extensions__item__id_tab,
        ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__id,
        ____SRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality_tab,
        ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__criticality,
        ____SRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab,
        ___SRBs_Required_ToBeReleased_Item_iE_Extensions__item__extensionValue,
        __SRBs_Required_ToBeReleased_Item_iE_Extensions__item_,
        _SRBs_Required_ToBeReleased_Item_iE_Extensions,
        SRBs_Required_ToBeReleased_Item,
        SRBs_Required_ToBeReleased_ItemExtIEs,
        _SRBs_Setup_Item_sRBID,
        _SRBs_Setup_Item_lCID,
        ____SRBs_Setup_Item_iE_Extensions__item__id_tab,
        ___SRBs_Setup_Item_iE_Extensions__item__id,
        ____SRBs_Setup_Item_iE_Extensions__item__criticality_tab,
        ___SRBs_Setup_Item_iE_Extensions__item__criticality,
        ____SRBs_Setup_Item_iE_Extensions__item__extensionValue_tab,
        ___SRBs_Setup_Item_iE_Extensions__item__extensionValue,
        __SRBs_Setup_Item_iE_Extensions__item_,
        _SRBs_Setup_Item_iE_Extensions,
        SRBs_Setup_Item,
        SRBs_Setup_ItemExtIEs,
        _SRBs_SetupMod_Item_sRBID,
        _SRBs_SetupMod_Item_lCID,
        ____SRBs_SetupMod_Item_iE_Extensions__item__id_tab,
        ___SRBs_SetupMod_Item_iE_Extensions__item__id,
        ____SRBs_SetupMod_Item_iE_Extensions__item__criticality_tab,
        ___SRBs_SetupMod_Item_iE_Extensions__item__criticality,
        ____SRBs_SetupMod_Item_iE_Extensions__item__extensionValue_tab,
        ___SRBs_SetupMod_Item_iE_Extensions__item__extensionValue,
        __SRBs_SetupMod_Item_iE_Extensions__item_,
        _SRBs_SetupMod_Item_iE_Extensions,
        SRBs_SetupMod_Item,
        SRBs_SetupMod_ItemExtIEs,
        _SRBs_ToBeReleased_Item_sRBID,
        ____SRBs_ToBeReleased_Item_iE_Extensions__item__id_tab,
        ___SRBs_ToBeReleased_Item_iE_Extensions__item__id,
        ____SRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab,
        ___SRBs_ToBeReleased_Item_iE_Extensions__item__criticality,
        ____SRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab,
        ___SRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue,
        __SRBs_ToBeReleased_Item_iE_Extensions__item_,
        _SRBs_ToBeReleased_Item_iE_Extensions,
        SRBs_ToBeReleased_Item,
        SRBs_ToBeReleased_ItemExtIEs,
        _SRBs_ToBeSetup_Item_sRBID,
        _SRBs_ToBeSetup_Item_duplicationIndication,
        ____SRBs_ToBeSetup_Item_iE_Extensions__item__id_tab,
        _____SRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____SRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____SRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_2,
        ___SRBs_ToBeSetup_Item_iE_Extensions__item__id,
        ___SRBs_ToBeSetup_Item_iE_Extensions__item__criticality,
        ___SRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue,
        __SRBs_ToBeSetup_Item_iE_Extensions__item_,
        _SRBs_ToBeSetup_Item_iE_Extensions,
        SRBs_ToBeSetup_Item,
        SRBs_ToBeSetup_ItemExtIEs,
        _SRBs_ToBeSetup_ItemExtIEs_val_Extension_0,
        _SRBs_ToBeSetup_ItemExtIEs_val_Extension_1,
        _SRBs_ToBeSetup_ItemExtIEs_val_Extension_2,
        _SRBs_ToBeSetupMod_Item_sRBID,
        _SRBs_ToBeSetupMod_Item_duplicationIndication,
        ____SRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab,
        _____SRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____SRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____SRBs_ToBeSetupMod_Item_iE_Extensions__item__id_tab_val_Extension_2,
        ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__id,
        ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__criticality,
        ___SRBs_ToBeSetupMod_Item_iE_Extensions__item__extensionValue,
        __SRBs_ToBeSetupMod_Item_iE_Extensions__item_,
        _SRBs_ToBeSetupMod_Item_iE_Extensions,
        SRBs_ToBeSetupMod_Item,
        SRBs_ToBeSetupMod_ItemExtIEs,
        _SRBs_ToBeSetupMod_ItemExtIEs_val_Extension_0,
        _SRBs_ToBeSetupMod_ItemExtIEs_val_Extension_1,
        _SRBs_ToBeSetupMod_ItemExtIEs_val_Extension_2,
        _SRSCarrier_List__item_,
        SRSCarrier_List,
        _SRSCarrier_List_Item_pointA,
        _SRSCarrier_List_Item_uplinkChannelBW_PerSCS_List,
        _SRSCarrier_List_Item_activeULBWP,
        _SRSCarrier_List_Item_pci,
        ____SRSCarrier_List_Item_iE_Extensions__item__id_tab,
        ___SRSCarrier_List_Item_iE_Extensions__item__id,
        ____SRSCarrier_List_Item_iE_Extensions__item__criticality_tab,
        ___SRSCarrier_List_Item_iE_Extensions__item__criticality,
        ____SRSCarrier_List_Item_iE_Extensions__item__extensionValue_tab,
        ___SRSCarrier_List_Item_iE_Extensions__item__extensionValue,
        __SRSCarrier_List_Item_iE_Extensions__item_,
        _SRSCarrier_List_Item_iE_Extensions,
        SRSCarrier_List_Item,
        SRSCarrier_List_Item_ExtIEs,
        _SRSConfig_sRSResource_List,
        _SRSConfig_posSRSResource_List,
        _SRSConfig_sRSResourceSet_List,
        _SRSConfig_posSRSResourceSet_List,
        ____SRSConfig_iE_Extensions__item__id_tab,
        ___SRSConfig_iE_Extensions__item__id,
        ____SRSConfig_iE_Extensions__item__criticality_tab,
        ___SRSConfig_iE_Extensions__item__criticality,
        ____SRSConfig_iE_Extensions__item__extensionValue_tab,
        ___SRSConfig_iE_Extensions__item__extensionValue,
        __SRSConfig_iE_Extensions__item_,
        _SRSConfig_iE_Extensions,
        SRSConfig,
        SRSConfig_ExtIEs,
        _SRSConfiguration_sRSCarrier_List,
        ____SRSConfiguration_iE_Extensions__item__id_tab,
        ___SRSConfiguration_iE_Extensions__item__id,
        ____SRSConfiguration_iE_Extensions__item__criticality_tab,
        ___SRSConfiguration_iE_Extensions__item__criticality,
        ____SRSConfiguration_iE_Extensions__item__extensionValue_tab,
        ___SRSConfiguration_iE_Extensions__item__extensionValue,
        __SRSConfiguration_iE_Extensions__item_,
        _SRSConfiguration_iE_Extensions,
        SRSConfiguration,
        SRSConfiguration_ExtIEs,
        SrsFrequency,
        SRSPortIndex,
        SRSPosResourceID,
        _SRSResource_sRSResourceID,
        _SRSResource_nrofSRS_Ports,
        _SRSResource_transmissionComb,
        _SRSResource_startPosition,
        _SRSResource_nrofSymbols,
        _SRSResource_repetitionFactor,
        _SRSResource_freqDomainPosition,
        _SRSResource_freqDomainShift,
        _SRSResource_c_SRS,
        _SRSResource_b_SRS,
        _SRSResource_b_hop,
        _SRSResource_groupOrSequenceHopping,
        _SRSResource_resourceType,
        _SRSResource_sequenceId,
        ____SRSResource_iE_Extensions__item__id_tab,
        ___SRSResource_iE_Extensions__item__id,
        ____SRSResource_iE_Extensions__item__criticality_tab,
        ___SRSResource_iE_Extensions__item__criticality,
        ____SRSResource_iE_Extensions__item__extensionValue_tab,
        ___SRSResource_iE_Extensions__item__extensionValue,
        __SRSResource_iE_Extensions__item_,
        _SRSResource_iE_Extensions,
        SRSResource,
        SRSResource_ExtIEs,
        SRSResourceID,
        _SRSResourceID_List__item_,
        SRSResourceID_List,
        _SRSResource_List__item_,
        SRSResource_List,
        _SRSResourceSet_sRSResourceSetID,
        _SRSResourceSet_sRSResourceID_List,
        _SRSResourceSet_resourceSetType,
        ____SRSResourceSet_iE_Extensions__item__id_tab,
        ___SRSResourceSet_iE_Extensions__item__id,
        ____SRSResourceSet_iE_Extensions__item__criticality_tab,
        ___SRSResourceSet_iE_Extensions__item__criticality,
        ____SRSResourceSet_iE_Extensions__item__extensionValue_tab,
        ___SRSResourceSet_iE_Extensions__item__extensionValue,
        __SRSResourceSet_iE_Extensions__item_,
        _SRSResourceSet_iE_Extensions,
        SRSResourceSet,
        SRSResourceSet_ExtIEs,
        SRSResourceSetID,
        _SRSResourceSetList__item_,
        SRSResourceSetList,
        _SRSResourceSetItem_numSRSresourcesperset,
        _SRSResourceSetItem_periodicityList,
        _SRSResourceSetItem_spatialRelationInfo,
        _SRSResourceSetItem_pathlossReferenceInfo,
        ____SRSResourceSetItem_iE_Extensions__item__id_tab,
        _____SRSResourceSetItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___SRSResourceSetItem_iE_Extensions__item__id,
        ___SRSResourceSetItem_iE_Extensions__item__criticality,
        ___SRSResourceSetItem_iE_Extensions__item__extensionValue,
        __SRSResourceSetItem_iE_Extensions__item_,
        _SRSResourceSetItem_iE_Extensions,
        SRSResourceSetItem,
        SRSResourceSetItemExtIEs,
        _SRSResourceSetItemExtIEs_val_Extension_0,
        _SRSResourceSet_List__item_,
        SRSResourceSet_List,
        _SRSResourceTrigger_aperiodicSRSResourceTriggerList,
        ____SRSResourceTrigger_iE_Extensions__item__id_tab,
        ___SRSResourceTrigger_iE_Extensions__item__id,
        ____SRSResourceTrigger_iE_Extensions__item__criticality_tab,
        ___SRSResourceTrigger_iE_Extensions__item__criticality,
        ____SRSResourceTrigger_iE_Extensions__item__extensionValue_tab,
        ___SRSResourceTrigger_iE_Extensions__item__extensionValue,
        __SRSResourceTrigger_iE_Extensions__item_,
        _SRSResourceTrigger_iE_Extensions,
        SRSResourceTrigger,
        SRSResourceTrigger_ExtIEs,
        _SRSResourcetype_sRSResourceTypeChoice,
        ____SRSResourcetype_iE_Extensions__item__id_tab,
        _____SRSResourcetype_iE_Extensions__item__id_tab_val_Extension_0,
        ___SRSResourcetype_iE_Extensions__item__id,
        ___SRSResourcetype_iE_Extensions__item__criticality,
        ___SRSResourcetype_iE_Extensions__item__extensionValue,
        __SRSResourcetype_iE_Extensions__item_,
        _SRSResourcetype_iE_Extensions,
        SRSResourcetype,
        SRSResourcetype_ExtIEs,
        _SRSResourcetype_ExtIEs_val_Extension_0,
        _SRSResourceTypeChoice_sRSResourceInfo,
        _SRSResourceTypeChoice_posSRSResourceInfo,
        ___SRSResourceTypeChoice_choice_extension_id_tab,
        __SRSResourceTypeChoice_choice_extension_id,
        ___SRSResourceTypeChoice_choice_extension_criticality_tab,
        __SRSResourceTypeChoice_choice_extension_criticality,
        ___SRSResourceTypeChoice_choice_extension_value_tab,
        __SRSResourceTypeChoice_choice_extension_value,
        _SRSResourceTypeChoice_choice_extension,
        SRSResourceTypeChoice,
        SRSResourceTypeChoice_ExtIEs,
        _SRSInfo_sRSResource,
        SRSInfo,
        SRSPosRRCInactiveConfig,
        SRSPosRRCInactiveQueryIndication,
        _PosSRSInfo_posSRSResourceID,
        PosSRSInfo,
        _SSB_pCI_NR,
        _SSB_ssb_index,
        ____SSB_iE_Extensions__item__id_tab,
        ___SSB_iE_Extensions__item__id,
        ____SSB_iE_Extensions__item__criticality_tab,
        ___SSB_iE_Extensions__item__criticality,
        ____SSB_iE_Extensions__item__extensionValue_tab,
        ___SSB_iE_Extensions__item__extensionValue,
        __SSB_iE_Extensions__item_,
        _SSB_iE_Extensions,
        SSB,
        _SSBCoverageModification_List__item_,
        SSBCoverageModification_List,
        _SSBCoverageModification_Item_sSBIndex,
        _SSBCoverageModification_Item_sSBCoverageState,
        ____SSBCoverageModification_Item_iE_Extensions__item__id_tab,
        ___SSBCoverageModification_Item_iE_Extensions__item__id,
        ____SSBCoverageModification_Item_iE_Extensions__item__criticality_tab,
        ___SSBCoverageModification_Item_iE_Extensions__item__criticality,
        ____SSBCoverageModification_Item_iE_Extensions__item__extensionValue_tab,
        ___SSBCoverageModification_Item_iE_Extensions__item__extensionValue,
        __SSBCoverageModification_Item_iE_Extensions__item_,
        _SSBCoverageModification_Item_iE_Extensions,
        SSBCoverageModification_Item,
        SSBCoverageModification_Item_ExtIEs,
        SSBCoverageState,
        SSB_ExtIEs,
        SSB_freqInfo,
        SSB_Index,
        SSB_subcarrierSpacing,
        SSB_transmissionPeriodicity,
        SSB_transmissionTimingOffset,
        _SSB_transmissionBitmap_shortBitmap,
        _SSB_transmissionBitmap_mediumBitmap,
        _SSB_transmissionBitmap_longBitmap,
        ___SSB_transmissionBitmap_choice_extension_id_tab,
        __SSB_transmissionBitmap_choice_extension_id,
        ___SSB_transmissionBitmap_choice_extension_criticality_tab,
        __SSB_transmissionBitmap_choice_extension_criticality,
        ___SSB_transmissionBitmap_choice_extension_value_tab,
        __SSB_transmissionBitmap_choice_extension_value,
        _SSB_transmissionBitmap_choice_extension,
        SSB_transmissionBitmap,
        SSB_transmisisonBitmap_ExtIEs,
        _SSBAreaCapacityValueList__item_,
        SSBAreaCapacityValueList,
        _SSBAreaCapacityValueItem_sSBIndex,
        _SSBAreaCapacityValueItem_sSBAreaCapacityValue,
        ____SSBAreaCapacityValueItem_iE_Extensions__item__id_tab,
        ___SSBAreaCapacityValueItem_iE_Extensions__item__id,
        ____SSBAreaCapacityValueItem_iE_Extensions__item__criticality_tab,
        ___SSBAreaCapacityValueItem_iE_Extensions__item__criticality,
        ____SSBAreaCapacityValueItem_iE_Extensions__item__extensionValue_tab,
        ___SSBAreaCapacityValueItem_iE_Extensions__item__extensionValue,
        __SSBAreaCapacityValueItem_iE_Extensions__item_,
        _SSBAreaCapacityValueItem_iE_Extensions,
        SSBAreaCapacityValueItem,
        SSBAreaCapacityValueItem_ExtIEs,
        _SSBAreaRadioResourceStatusList__item_,
        SSBAreaRadioResourceStatusList,
        _SSBAreaRadioResourceStatusItem_sSBIndex,
        _SSBAreaRadioResourceStatusItem_sSBAreaDLGBRPRBusage,
        _SSBAreaRadioResourceStatusItem_sSBAreaULGBRPRBusage,
        _SSBAreaRadioResourceStatusItem_sSBAreaDLnon_GBRPRBusage,
        _SSBAreaRadioResourceStatusItem_sSBAreaULnon_GBRPRBusage,
        _SSBAreaRadioResourceStatusItem_sSBAreaDLTotalPRBusage,
        _SSBAreaRadioResourceStatusItem_sSBAreaULTotalPRBusage,
        _SSBAreaRadioResourceStatusItem_dLschedulingPDCCHCCEusage,
        _SSBAreaRadioResourceStatusItem_uLschedulingPDCCHCCEusage,
        ____SSBAreaRadioResourceStatusItem_iE_Extensions__item__id_tab,
        ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__id,
        ____SSBAreaRadioResourceStatusItem_iE_Extensions__item__criticality_tab,
        ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__criticality,
        ____SSBAreaRadioResourceStatusItem_iE_Extensions__item__extensionValue_tab,
        ___SSBAreaRadioResourceStatusItem_iE_Extensions__item__extensionValue,
        __SSBAreaRadioResourceStatusItem_iE_Extensions__item_,
        _SSBAreaRadioResourceStatusItem_iE_Extensions,
        SSBAreaRadioResourceStatusItem,
        SSBAreaRadioResourceStatusItem_ExtIEs,
        _SSBInformation_sSBInformationList,
        ____SSBInformation_iE_Extensions__item__id_tab,
        ___SSBInformation_iE_Extensions__item__id,
        ____SSBInformation_iE_Extensions__item__criticality_tab,
        ___SSBInformation_iE_Extensions__item__criticality,
        ____SSBInformation_iE_Extensions__item__extensionValue_tab,
        ___SSBInformation_iE_Extensions__item__extensionValue,
        __SSBInformation_iE_Extensions__item_,
        _SSBInformation_iE_Extensions,
        SSBInformation,
        SSBInformation_ExtIEs,
        _SSBInformationList__item_,
        SSBInformationList,
        _SSBInformationItem_sSB_Configuration,
        _SSBInformationItem_pCI_NR,
        ____SSBInformationItem_iE_Extensions__item__id_tab,
        ___SSBInformationItem_iE_Extensions__item__id,
        ____SSBInformationItem_iE_Extensions__item__criticality_tab,
        ___SSBInformationItem_iE_Extensions__item__criticality,
        ____SSBInformationItem_iE_Extensions__item__extensionValue_tab,
        ___SSBInformationItem_iE_Extensions__item__extensionValue,
        __SSBInformationItem_iE_Extensions__item_,
        _SSBInformationItem_iE_Extensions,
        SSBInformationItem,
        SSBInformationItem_ExtIEs,
        _SSB_PositionsInBurst_shortBitmap,
        _SSB_PositionsInBurst_mediumBitmap,
        _SSB_PositionsInBurst_longBitmap,
        ___SSB_PositionsInBurst_choice_extension_id_tab,
        __SSB_PositionsInBurst_choice_extension_id,
        ___SSB_PositionsInBurst_choice_extension_criticality_tab,
        __SSB_PositionsInBurst_choice_extension_criticality,
        ___SSB_PositionsInBurst_choice_extension_value_tab,
        __SSB_PositionsInBurst_choice_extension_value,
        _SSB_PositionsInBurst_choice_extension,
        SSB_PositionsInBurst,
        SSB_PositionsInBurst_ExtIEs,
        _SSB_TF_Configuration_sSB_frequency,
        _SSB_TF_Configuration_sSB_subcarrier_spacing,
        _SSB_TF_Configuration_sSB_Transmit_power,
        _SSB_TF_Configuration_sSB_periodicity,
        _SSB_TF_Configuration_sSB_half_frame_offset,
        _SSB_TF_Configuration_sSB_SFN_offset,
        _SSB_TF_Configuration_sSB_position_in_burst,
        _SSB_TF_Configuration_sFNInitialisationTime,
        ____SSB_TF_Configuration_iE_Extensions__item__id_tab,
        ___SSB_TF_Configuration_iE_Extensions__item__id,
        ____SSB_TF_Configuration_iE_Extensions__item__criticality_tab,
        ___SSB_TF_Configuration_iE_Extensions__item__criticality,
        ____SSB_TF_Configuration_iE_Extensions__item__extensionValue_tab,
        ___SSB_TF_Configuration_iE_Extensions__item__extensionValue,
        __SSB_TF_Configuration_iE_Extensions__item_,
        _SSB_TF_Configuration_iE_Extensions,
        SSB_TF_Configuration,
        SSB_TF_Configuration_ExtIEs,
        _SSBToReportList__item_,
        SSBToReportList,
        _SSBToReportItem_sSBIndex,
        ____SSBToReportItem_iE_Extensions__item__id_tab,
        ___SSBToReportItem_iE_Extensions__item__id,
        ____SSBToReportItem_iE_Extensions__item__criticality_tab,
        ___SSBToReportItem_iE_Extensions__item__criticality,
        ____SSBToReportItem_iE_Extensions__item__extensionValue_tab,
        ___SSBToReportItem_iE_Extensions__item__extensionValue,
        __SSBToReportItem_iE_Extensions__item_,
        _SSBToReportItem_iE_Extensions,
        SSBToReportItem,
        SSBToReportItem_ExtIEs,
        _StartTimeAndDuration_startTime,
        _StartTimeAndDuration_duration,
        ____StartTimeAndDuration_iE_Extensions__item__id_tab,
        ___StartTimeAndDuration_iE_Extensions__item__id,
        ____StartTimeAndDuration_iE_Extensions__item__criticality_tab,
        ___StartTimeAndDuration_iE_Extensions__item__criticality,
        ____StartTimeAndDuration_iE_Extensions__item__extensionValue_tab,
        ___StartTimeAndDuration_iE_Extensions__item__extensionValue,
        __StartTimeAndDuration_iE_Extensions__item_,
        _StartTimeAndDuration_iE_Extensions,
        StartTimeAndDuration,
        StartTimeAndDuration_ExtIEs,
        _SUL_Information_sUL_NRARFCN,
        _SUL_Information_sUL_transmission_Bandwidth,
        ____SUL_Information_iE_Extensions__item__id_tab,
        _____SUL_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____SUL_Information_iE_Extensions__item__id_tab_val_Extension_1,
        ___SUL_Information_iE_Extensions__item__id,
        ___SUL_Information_iE_Extensions__item__criticality,
        ___SUL_Information_iE_Extensions__item__extensionValue,
        __SUL_Information_iE_Extensions__item_,
        _SUL_Information_iE_Extensions,
        SUL_Information,
        SUL_InformationExtIEs,
        _SUL_InformationExtIEs_val_Extension_0,
        _SUL_InformationExtIEs_val_Extension_1,
        SubcarrierSpacing,
        SubscriberProfileIDforRFP,
        _SuccessfulHOReportInformationList__item_,
        SuccessfulHOReportInformationList,
        _SuccessfulHOReportInformation_Item_successfulHOReportContainer,
        ____SuccessfulHOReportInformation_Item_iE_Extensions__item__id_tab,
        ___SuccessfulHOReportInformation_Item_iE_Extensions__item__id,
        ____SuccessfulHOReportInformation_Item_iE_Extensions__item__criticality_tab,
        ___SuccessfulHOReportInformation_Item_iE_Extensions__item__criticality,
        ____SuccessfulHOReportInformation_Item_iE_Extensions__item__extensionValue_tab,
        ___SuccessfulHOReportInformation_Item_iE_Extensions__item__extensionValue,
        __SuccessfulHOReportInformation_Item_iE_Extensions__item_,
        _SuccessfulHOReportInformation_Item_iE_Extensions,
        SuccessfulHOReportInformation_Item,
        SuccessfulHOReportInformation_Item_ExtIEs,
        SULAccessIndication,
        _SupportedSULFreqBandItem_freqBandIndicatorNr,
        ____SupportedSULFreqBandItem_iE_Extensions__item__id_tab,
        ___SupportedSULFreqBandItem_iE_Extensions__item__id,
        ____SupportedSULFreqBandItem_iE_Extensions__item__criticality_tab,
        ___SupportedSULFreqBandItem_iE_Extensions__item__criticality,
        ____SupportedSULFreqBandItem_iE_Extensions__item__extensionValue_tab,
        ___SupportedSULFreqBandItem_iE_Extensions__item__extensionValue,
        __SupportedSULFreqBandItem_iE_Extensions__item_,
        _SupportedSULFreqBandItem_iE_Extensions,
        SupportedSULFreqBandItem,
        SupportedSULFreqBandItem_ExtIEs,
        SurvivalTime,
        _SymbolAllocInSlot_all_DL,
        _SymbolAllocInSlot_all_UL,
        _SymbolAllocInSlot_both_DL_and_UL,
        ___SymbolAllocInSlot_choice_extension_id_tab,
        __SymbolAllocInSlot_choice_extension_id,
        ___SymbolAllocInSlot_choice_extension_criticality_tab,
        __SymbolAllocInSlot_choice_extension_criticality,
        ___SymbolAllocInSlot_choice_extension_value_tab,
        __SymbolAllocInSlot_choice_extension_value,
        _SymbolAllocInSlot_choice_extension,
        SymbolAllocInSlot,
        SymbolAllocInSlot_ExtIEs,
        SystemFrameNumber,
        SystemInformationAreaID,
        FiveGS_TAC,
        Configured_EPS_TAC,
        _TargetCellList__item_,
        TargetCellList,
        _TargetCellList_Item_target_cell,
        ____TargetCellList_Item_iE_Extensions__item__id_tab,
        ___TargetCellList_Item_iE_Extensions__item__id,
        ____TargetCellList_Item_iE_Extensions__item__criticality_tab,
        ___TargetCellList_Item_iE_Extensions__item__criticality,
        ____TargetCellList_Item_iE_Extensions__item__extensionValue_tab,
        ___TargetCellList_Item_iE_Extensions__item__extensionValue,
        __TargetCellList_Item_iE_Extensions__item_,
        _TargetCellList_Item_iE_Extensions,
        TargetCellList_Item,
        TargetCellList_Item_ExtIEs,
        _NSAGSupportList__item_,
        NSAGSupportList,
        _NSAGSupportItem_nSAG_ID,
        _NSAGSupportItem_nSAGSliceSupport,
        ____NSAGSupportItem_iE_Extensions__item__id_tab,
        ___NSAGSupportItem_iE_Extensions__item__id,
        ____NSAGSupportItem_iE_Extensions__item__criticality_tab,
        ___NSAGSupportItem_iE_Extensions__item__criticality,
        ____NSAGSupportItem_iE_Extensions__item__extensionValue_tab,
        ___NSAGSupportItem_iE_Extensions__item__extensionValue,
        __NSAGSupportItem_iE_Extensions__item_,
        _NSAGSupportItem_iE_Extensions,
        NSAGSupportItem,
        NSAGSupportItem_ExtIEs,
        NSAG_ID,
        _TDD_Info_nRFreqInfo,
        _TDD_Info_transmission_Bandwidth,
        ____TDD_Info_iE_Extensions__item__id_tab,
        _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_0,
        _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_1,
        _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_2,
        ___TDD_Info_iE_Extensions__item__id,
        ___TDD_Info_iE_Extensions__item__criticality,
        ___TDD_Info_iE_Extensions__item__extensionValue,
        __TDD_Info_iE_Extensions__item_,
        _TDD_Info_iE_Extensions,
        TDD_Info,
        TDD_Info_ExtIEs,
        _TDD_Info_ExtIEs_val_Extension_0,
        _TDD_Info_ExtIEs_val_Extension_1,
        _TDD_Info_ExtIEs_val_Extension_2,
        _TDD_InfoRel16_tDD_FreqInfo,
        _TDD_InfoRel16_sUL_FreqInfo,
        _TDD_InfoRel16_tDD_UL_DLConfigCommonNR,
        ____TDD_InfoRel16_iE_Extensions__item__id_tab,
        ___TDD_InfoRel16_iE_Extensions__item__id,
        ____TDD_InfoRel16_iE_Extensions__item__criticality_tab,
        ___TDD_InfoRel16_iE_Extensions__item__criticality,
        ____TDD_InfoRel16_iE_Extensions__item__extensionValue_tab,
        ___TDD_InfoRel16_iE_Extensions__item__extensionValue,
        __TDD_InfoRel16_iE_Extensions__item_,
        _TDD_InfoRel16_iE_Extensions,
        TDD_InfoRel16,
        TDD_InfoRel16_ExtIEs,
        TDD_UL_DLConfigCommonNR,
        _TRPTEGInformation_rxTx_TEG,
        _TRPTEGInformation_rx_TEG,
        ___TRPTEGInformation_choice_extension_id_tab,
        __TRPTEGInformation_choice_extension_id,
        ___TRPTEGInformation_choice_extension_criticality_tab,
        __TRPTEGInformation_choice_extension_criticality,
        ___TRPTEGInformation_choice_extension_value_tab,
        __TRPTEGInformation_choice_extension_value,
        _TRPTEGInformation_choice_extension,
        TRPTEGInformation,
        TRPTEGInformation_ExtIEs,
        _RxTxTEG_tRP_RxTx_TEGInformation,
        _RxTxTEG_tRP_Tx_TEGInformation,
        ____RxTxTEG_iE_Extensions__item__id_tab,
        ___RxTxTEG_iE_Extensions__item__id,
        ____RxTxTEG_iE_Extensions__item__criticality_tab,
        ___RxTxTEG_iE_Extensions__item__criticality,
        ____RxTxTEG_iE_Extensions__item__extensionValue_tab,
        ___RxTxTEG_iE_Extensions__item__extensionValue,
        __RxTxTEG_iE_Extensions__item_,
        _RxTxTEG_iE_Extensions,
        RxTxTEG,
        RxTxTEG_ExtIEs,
        _RxTEG_tRP_Rx_TEGInformation,
        _RxTEG_tRP_Tx_TEGInformation,
        ____RxTEG_iE_Extensions__item__id_tab,
        ___RxTEG_iE_Extensions__item__id,
        ____RxTEG_iE_Extensions__item__criticality_tab,
        ___RxTEG_iE_Extensions__item__criticality,
        ____RxTEG_iE_Extensions__item__extensionValue_tab,
        ___RxTEG_iE_Extensions__item__extensionValue,
        __RxTEG_iE_Extensions__item_,
        _RxTEG_iE_Extensions,
        RxTEG,
        RxTEG_ExtIEs,
        _TimeReferenceInformation_referenceTime,
        _TimeReferenceInformation_referenceSFN,
        _TimeReferenceInformation_uncertainty,
        _TimeReferenceInformation_timeInformationType,
        ____TimeReferenceInformation_iE_Extensions__item__id_tab,
        ___TimeReferenceInformation_iE_Extensions__item__id,
        ____TimeReferenceInformation_iE_Extensions__item__criticality_tab,
        ___TimeReferenceInformation_iE_Extensions__item__criticality,
        ____TimeReferenceInformation_iE_Extensions__item__extensionValue_tab,
        ___TimeReferenceInformation_iE_Extensions__item__extensionValue,
        __TimeReferenceInformation_iE_Extensions__item_,
        _TimeReferenceInformation_iE_Extensions,
        TimeReferenceInformation,
        TimeReferenceInformation_ExtIEs,
        TimeInformationType,
        _TimeStamp_systemFrameNumber,
        _TimeStamp_slotIndex,
        _TimeStamp_measurementTime,
        ____TimeStamp_iE_Extension__item__id_tab,
        ___TimeStamp_iE_Extension__item__id,
        ____TimeStamp_iE_Extension__item__criticality_tab,
        ___TimeStamp_iE_Extension__item__criticality,
        ____TimeStamp_iE_Extension__item__extensionValue_tab,
        ___TimeStamp_iE_Extension__item__extensionValue,
        __TimeStamp_iE_Extension__item_,
        _TimeStamp_iE_Extension,
        TimeStamp,
        TimeStamp_ExtIEs,
        _TimeStampSlotIndex_sCS_15,
        _TimeStampSlotIndex_sCS_30,
        _TimeStampSlotIndex_sCS_60,
        _TimeStampSlotIndex_sCS_120,
        ___TimeStampSlotIndex_choice_extension_id_tab,
        ____TimeStampSlotIndex_choice_extension_id_tab_val_Value_0,
        ____TimeStampSlotIndex_choice_extension_id_tab_val_Value_1,
        __TimeStampSlotIndex_choice_extension_id,
        __TimeStampSlotIndex_choice_extension_criticality,
        __TimeStampSlotIndex_choice_extension_value,
        _TimeStampSlotIndex_choice_extension,
        TimeStampSlotIndex,
        TimeStampSlotIndex_ExtIEs,
        _TimeStampSlotIndex_ExtIEs_val_Value_0,
        _TimeStampSlotIndex_ExtIEs_val_Value_1,
        TimeToWait,
        TimingErrorMargin,
        _TimingMeasurementQuality_measurementQuality,
        _TimingMeasurementQuality_resolution,
        ____TimingMeasurementQuality_iE_Extensions__item__id_tab,
        ___TimingMeasurementQuality_iE_Extensions__item__id,
        ____TimingMeasurementQuality_iE_Extensions__item__criticality_tab,
        ___TimingMeasurementQuality_iE_Extensions__item__criticality,
        ____TimingMeasurementQuality_iE_Extensions__item__extensionValue_tab,
        ___TimingMeasurementQuality_iE_Extensions__item__extensionValue,
        __TimingMeasurementQuality_iE_Extensions__item_,
        _TimingMeasurementQuality_iE_Extensions,
        TimingMeasurementQuality,
        TimingMeasurementQuality_ExtIEs,
        TMGI,
        TNLAssociationUsage,
        _TNLCapacityIndicator_dLTNLOfferedCapacity,
        _TNLCapacityIndicator_dLTNLAvailableCapacity,
        _TNLCapacityIndicator_uLTNLOfferedCapacity,
        _TNLCapacityIndicator_uLTNLAvailableCapacity,
        ____TNLCapacityIndicator_iE_Extensions__item__id_tab,
        ___TNLCapacityIndicator_iE_Extensions__item__id,
        ____TNLCapacityIndicator_iE_Extensions__item__criticality_tab,
        ___TNLCapacityIndicator_iE_Extensions__item__criticality,
        ____TNLCapacityIndicator_iE_Extensions__item__extensionValue_tab,
        ___TNLCapacityIndicator_iE_Extensions__item__extensionValue,
        __TNLCapacityIndicator_iE_Extensions__item_,
        _TNLCapacityIndicator_iE_Extensions,
        TNLCapacityIndicator,
        TNLCapacityIndicator_ExtIEs,
        _TraceActivation_traceID,
        _TraceActivation_interfacesToTrace,
        _TraceActivation_traceDepth,
        _TraceActivation_traceCollectionEntityIPAddress,
        ____TraceActivation_iE_Extensions__item__id_tab,
        _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0,
        _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_1,
        ___TraceActivation_iE_Extensions__item__id,
        ___TraceActivation_iE_Extensions__item__criticality,
        ___TraceActivation_iE_Extensions__item__extensionValue,
        __TraceActivation_iE_Extensions__item_,
        _TraceActivation_iE_Extensions,
        TraceActivation,
        TraceActivation_ExtIEs,
        _TraceActivation_ExtIEs_val_Extension_0,
        _TraceActivation_ExtIEs_val_Extension_1,
        TraceDepth,
        TraceID,
        _TrafficMappingInfo_iPtolayer2TrafficMappingInfo,
        _TrafficMappingInfo_bAPlayerBHRLCchannelMappingInfo,
        ___TrafficMappingInfo_choice_extension_id_tab,
        __TrafficMappingInfo_choice_extension_id,
        ___TrafficMappingInfo_choice_extension_criticality_tab,
        __TrafficMappingInfo_choice_extension_criticality,
        ___TrafficMappingInfo_choice_extension_value_tab,
        __TrafficMappingInfo_choice_extension_value,
        _TrafficMappingInfo_choice_extension,
        TrafficMappingInfo,
        TrafficMappingInfo_ExtIEs,
        TransportLayerAddress,
        TransactionID,
        _Transmission_Bandwidth_nRSCS,
        _Transmission_Bandwidth_nRNRB,
        ____Transmission_Bandwidth_iE_Extensions__item__id_tab,
        ___Transmission_Bandwidth_iE_Extensions__item__id,
        ____Transmission_Bandwidth_iE_Extensions__item__criticality_tab,
        ___Transmission_Bandwidth_iE_Extensions__item__criticality,
        ____Transmission_Bandwidth_iE_Extensions__item__extensionValue_tab,
        ___Transmission_Bandwidth_iE_Extensions__item__extensionValue,
        __Transmission_Bandwidth_iE_Extensions__item_,
        _Transmission_Bandwidth_iE_Extensions,
        Transmission_Bandwidth,
        Transmission_Bandwidth_ExtIEs,
        __TransmissionComb_n2_combOffset_n2,
        __TransmissionComb_n2_cyclicShift_n2,
        _TransmissionComb_n2,
        __TransmissionComb_n4_combOffset_n4,
        __TransmissionComb_n4_cyclicShift_n4,
        _TransmissionComb_n4,
        ___TransmissionComb_choice_extension_id_tab,
        __TransmissionComb_choice_extension_id,
        ___TransmissionComb_choice_extension_criticality_tab,
        __TransmissionComb_choice_extension_criticality,
        ___TransmissionComb_choice_extension_value_tab,
        __TransmissionComb_choice_extension_value,
        _TransmissionComb_choice_extension,
        TransmissionComb,
        TransmissionComb_ExtIEs,
        __TransmissionCombPos_n2_combOffset_n2,
        __TransmissionCombPos_n2_cyclicShift_n2,
        _TransmissionCombPos_n2,
        __TransmissionCombPos_n4_combOffset_n4,
        __TransmissionCombPos_n4_cyclicShift_n4,
        _TransmissionCombPos_n4,
        __TransmissionCombPos_n8_combOffset_n8,
        __TransmissionCombPos_n8_cyclicShift_n8,
        _TransmissionCombPos_n8,
        ___TransmissionCombPos_choice_extension_id_tab,
        __TransmissionCombPos_choice_extension_id,
        ___TransmissionCombPos_choice_extension_criticality_tab,
        __TransmissionCombPos_choice_extension_criticality,
        ___TransmissionCombPos_choice_extension_value_tab,
        __TransmissionCombPos_choice_extension_value,
        _TransmissionCombPos_choice_extension,
        TransmissionCombPos,
        TransmissionCombPos_ExtIEs,
        TransmissionStopIndicator,
        _Transport_UP_Layer_Address_Info_To_Add_List__item_,
        Transport_UP_Layer_Address_Info_To_Add_List,
        _Transport_UP_Layer_Address_Info_To_Add_Item_iP_SecTransportLayerAddress,
        _Transport_UP_Layer_Address_Info_To_Add_Item_gTPTransportLayerAddressToAdd,
        ____Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__id_tab,
        ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__id,
        ____Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__criticality_tab,
        ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__criticality,
        ____Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__extensionValue_tab,
        ___Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item__extensionValue,
        __Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions__item_,
        _Transport_UP_Layer_Address_Info_To_Add_Item_iE_Extensions,
        Transport_UP_Layer_Address_Info_To_Add_Item,
        Transport_UP_Layer_Address_Info_To_Add_ItemExtIEs,
        _Transport_UP_Layer_Address_Info_To_Remove_List__item_,
        Transport_UP_Layer_Address_Info_To_Remove_List,
        _Transport_UP_Layer_Address_Info_To_Remove_Item_iP_SecTransportLayerAddress,
        _Transport_UP_Layer_Address_Info_To_Remove_Item_gTPTransportLayerAddressToRemove,
        ____Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__id_tab,
        ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__id,
        ____Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__criticality_tab,
        ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__criticality,
        ____Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__extensionValue_tab,
        ___Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item__extensionValue,
        __Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions__item_,
        _Transport_UP_Layer_Address_Info_To_Remove_Item_iE_Extensions,
        Transport_UP_Layer_Address_Info_To_Remove_Item,
        Transport_UP_Layer_Address_Info_To_Remove_ItemExtIEs,
        TransmissionActionIndicator,
        _TRPBeamAntennaInformation_choice_TRP_Beam_Antenna_Info_Item,
        ____TRPBeamAntennaInformation_iE_Extensions__item__id_tab,
        ___TRPBeamAntennaInformation_iE_Extensions__item__id,
        ____TRPBeamAntennaInformation_iE_Extensions__item__criticality_tab,
        ___TRPBeamAntennaInformation_iE_Extensions__item__criticality,
        ____TRPBeamAntennaInformation_iE_Extensions__item__extensionValue_tab,
        ___TRPBeamAntennaInformation_iE_Extensions__item__extensionValue,
        __TRPBeamAntennaInformation_iE_Extensions__item_,
        _TRPBeamAntennaInformation_iE_Extensions,
        TRPBeamAntennaInformation,
        TRPBeamAntennaInformation_ExtIEs,
        _Choice_TRP_Beam_Antenna_Info_Item_reference,
        _Choice_TRP_Beam_Antenna_Info_Item_explicit,
        _Choice_TRP_Beam_Antenna_Info_Item_noChange,
        ___Choice_TRP_Beam_Antenna_Info_Item_choice_extension_id_tab,
        __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_id,
        ___Choice_TRP_Beam_Antenna_Info_Item_choice_extension_criticality_tab,
        __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_criticality,
        ___Choice_TRP_Beam_Antenna_Info_Item_choice_extension_value_tab,
        __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_value,
        _Choice_TRP_Beam_Antenna_Info_Item_choice_extension,
        Choice_TRP_Beam_Antenna_Info_Item,
        Choice_TRP_Beam_Info_Item_ExtIEs,
        _TRP_BeamAntennaExplicitInformation_trp_BeamAntennaAngles,
        _TRP_BeamAntennaExplicitInformation_lcs_to_gcs_translation,
        ____TRP_BeamAntennaExplicitInformation_iE_Extensions__item__id_tab,
        ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__id,
        ____TRP_BeamAntennaExplicitInformation_iE_Extensions__item__criticality_tab,
        ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__criticality,
        ____TRP_BeamAntennaExplicitInformation_iE_Extensions__item__extensionValue_tab,
        ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__extensionValue,
        __TRP_BeamAntennaExplicitInformation_iE_Extensions__item_,
        _TRP_BeamAntennaExplicitInformation_iE_Extensions,
        TRP_BeamAntennaExplicitInformation,
        TRP_BeamAntennaExplicitInformation_ExtIEs,
        _TRP_BeamAntennaAngles__item_,
        TRP_BeamAntennaAngles,
        _TRP_BeamAntennaAnglesList_Item_trp_azimuth_angle,
        _TRP_BeamAntennaAnglesList_Item_trp_azimuth_angle_fine,
        __TRP_BeamAntennaAnglesList_Item_trp_elevation_angle_list__item_,
        _TRP_BeamAntennaAnglesList_Item_trp_elevation_angle_list,
        ____TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__id_tab,
        ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__id,
        ____TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__criticality_tab,
        ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__criticality,
        ____TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__extensionValue_tab,
        ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__extensionValue,
        __TRP_BeamAntennaAnglesList_Item_iE_Extensions__item_,
        _TRP_BeamAntennaAnglesList_Item_iE_Extensions,
        TRP_BeamAntennaAnglesList_Item,
        TRP_BeamAntennaAnglesList_Item_ExtIEs,
        _TRP_ElevationAngleList_Item_trp_elevation_angle,
        _TRP_ElevationAngleList_Item_trp_elevation_angle_fine,
        __TRP_ElevationAngleList_Item_trp_beam_power_list__item_,
        _TRP_ElevationAngleList_Item_trp_beam_power_list,
        ____TRP_ElevationAngleList_Item_iE_Extensions__item__id_tab,
        ___TRP_ElevationAngleList_Item_iE_Extensions__item__id,
        ____TRP_ElevationAngleList_Item_iE_Extensions__item__criticality_tab,
        ___TRP_ElevationAngleList_Item_iE_Extensions__item__criticality,
        ____TRP_ElevationAngleList_Item_iE_Extensions__item__extensionValue_tab,
        ___TRP_ElevationAngleList_Item_iE_Extensions__item__extensionValue,
        __TRP_ElevationAngleList_Item_iE_Extensions__item_,
        _TRP_ElevationAngleList_Item_iE_Extensions,
        TRP_ElevationAngleList_Item,
        TRP_ElevationAngleList_Item_ExtIEs,
        _TRP_Beam_Power_Item_pRSResourceSetID,
        _TRP_Beam_Power_Item_pRSResourceID,
        _TRP_Beam_Power_Item_relativePower,
        _TRP_Beam_Power_Item_relativePowerFine,
        ____TRP_Beam_Power_Item_iE_Extensions__item__id_tab,
        ___TRP_Beam_Power_Item_iE_Extensions__item__id,
        ____TRP_Beam_Power_Item_iE_Extensions__item__criticality_tab,
        ___TRP_Beam_Power_Item_iE_Extensions__item__criticality,
        ____TRP_Beam_Power_Item_iE_Extensions__item__extensionValue_tab,
        ___TRP_Beam_Power_Item_iE_Extensions__item__extensionValue,
        __TRP_Beam_Power_Item_iE_Extensions__item_,
        _TRP_Beam_Power_Item_iE_Extensions,
        TRP_Beam_Power_Item,
        TRP_Beam_Power_Item_ExtIEs,
        TRPID,
        _TRPInformation_tRPID,
        _TRPInformation_tRPInformationTypeResponseList,
        ____TRPInformation_iE_Extensions__item__id_tab,
        ___TRPInformation_iE_Extensions__item__id,
        ____TRPInformation_iE_Extensions__item__criticality_tab,
        ___TRPInformation_iE_Extensions__item__criticality,
        ____TRPInformation_iE_Extensions__item__extensionValue_tab,
        ___TRPInformation_iE_Extensions__item__extensionValue,
        __TRPInformation_iE_Extensions__item_,
        _TRPInformation_iE_Extensions,
        TRPInformation,
        TRPInformation_ExtIEs,
        _TRPInformationItem_tRPInformation,
        ____TRPInformationItem_iE_Extensions__item__id_tab,
        ___TRPInformationItem_iE_Extensions__item__id,
        ____TRPInformationItem_iE_Extensions__item__criticality_tab,
        ___TRPInformationItem_iE_Extensions__item__criticality,
        ____TRPInformationItem_iE_Extensions__item__extensionValue_tab,
        ___TRPInformationItem_iE_Extensions__item__extensionValue,
        __TRPInformationItem_iE_Extensions__item_,
        _TRPInformationItem_iE_Extensions,
        TRPInformationItem,
        TRPInformationItem_ExtIEs,
        TRPInformationTypeItem,
        _TRPInformationTypeResponseList__item_,
        TRPInformationTypeResponseList,
        _TRPInformationTypeResponseItem_pCI_NR,
        _TRPInformationTypeResponseItem_nG_RAN_CGI,
        _TRPInformationTypeResponseItem_nRARFCN,
        _TRPInformationTypeResponseItem_pRSConfiguration,
        _TRPInformationTypeResponseItem_sSBinformation,
        _TRPInformationTypeResponseItem_sFNInitialisationTime,
        _TRPInformationTypeResponseItem_spatialDirectionInformation,
        _TRPInformationTypeResponseItem_geographicalCoordinates,
        ___TRPInformationTypeResponseItem_choice_extension_id_tab,
        ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_0,
        ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_1,
        ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_2,
        ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_3,
        __TRPInformationTypeResponseItem_choice_extension_id,
        __TRPInformationTypeResponseItem_choice_extension_criticality,
        __TRPInformationTypeResponseItem_choice_extension_value,
        _TRPInformationTypeResponseItem_choice_extension,
        TRPInformationTypeResponseItem,
        TRPInformationTypeResponseItem_ExtIEs,
        _TRPInformationTypeResponseItem_ExtIEs_val_Value_0,
        _TRPInformationTypeResponseItem_ExtIEs_val_Value_1,
        _TRPInformationTypeResponseItem_ExtIEs_val_Value_2,
        _TRPInformationTypeResponseItem_ExtIEs_val_Value_3,
        _TRPList__item_,
        TRPList,
        _TRPListItem_tRPID,
        ____TRPListItem_iE_Extensions__item__id_tab,
        ___TRPListItem_iE_Extensions__item__id,
        ____TRPListItem_iE_Extensions__item__criticality_tab,
        ___TRPListItem_iE_Extensions__item__criticality,
        ____TRPListItem_iE_Extensions__item__extensionValue_tab,
        ___TRPListItem_iE_Extensions__item__extensionValue,
        __TRPListItem_iE_Extensions__item_,
        _TRPListItem_iE_Extensions,
        TRPListItem,
        TRPListItem_ExtIEs,
        _TRPMeasurementQuality_tRPmeasurementQuality_Item,
        ____TRPMeasurementQuality_iE_Extensions__item__id_tab,
        ___TRPMeasurementQuality_iE_Extensions__item__id,
        ____TRPMeasurementQuality_iE_Extensions__item__criticality_tab,
        ___TRPMeasurementQuality_iE_Extensions__item__criticality,
        ____TRPMeasurementQuality_iE_Extensions__item__extensionValue_tab,
        ___TRPMeasurementQuality_iE_Extensions__item__extensionValue,
        __TRPMeasurementQuality_iE_Extensions__item_,
        _TRPMeasurementQuality_iE_Extensions,
        TRPMeasurementQuality,
        TRPMeasurementQuality_ExtIEs,
        _TRPMeasurementQuality_Item_timingMeasurementQuality,
        _TRPMeasurementQuality_Item_angleMeasurementQuality,
        ___TRPMeasurementQuality_Item_choice_extension_id_tab,
        __TRPMeasurementQuality_Item_choice_extension_id,
        ___TRPMeasurementQuality_Item_choice_extension_criticality_tab,
        __TRPMeasurementQuality_Item_choice_extension_criticality,
        ___TRPMeasurementQuality_Item_choice_extension_value_tab,
        __TRPMeasurementQuality_Item_choice_extension_value,
        _TRPMeasurementQuality_Item_choice_extension,
        TRPMeasurementQuality_Item,
        TRPMeasurementQuality_Item_ExtIEs,
        _TRP_MeasurementRequestList__item_,
        TRP_MeasurementRequestList,
        _TRP_MeasurementRequestItem_tRPID,
        _TRP_MeasurementRequestItem_search_window_information,
        ____TRP_MeasurementRequestItem_iE_extensions__item__id_tab,
        _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_0,
        _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_1,
        _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_2,
        _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_3,
        ___TRP_MeasurementRequestItem_iE_extensions__item__id,
        ___TRP_MeasurementRequestItem_iE_extensions__item__criticality,
        ___TRP_MeasurementRequestItem_iE_extensions__item__extensionValue,
        __TRP_MeasurementRequestItem_iE_extensions__item_,
        _TRP_MeasurementRequestItem_iE_extensions,
        TRP_MeasurementRequestItem,
        TRP_MeasurementRequestItem_ExtIEs,
        _TRP_MeasurementRequestItem_ExtIEs_val_Extension_0,
        _TRP_MeasurementRequestItem_ExtIEs_val_Extension_1,
        _TRP_MeasurementRequestItem_ExtIEs_val_Extension_2,
        _TRP_MeasurementRequestItem_ExtIEs_val_Extension_3,
        _TRP_PRS_Info_List__item_,
        TRP_PRS_Info_List,
        _TRP_PRS_Info_List_Item_tRP_ID,
        _TRP_PRS_Info_List_Item_nR_PCI,
        _TRP_PRS_Info_List_Item_cGI_NR,
        _TRP_PRS_Info_List_Item_pRSConfiguration,
        ____TRP_PRS_Info_List_Item_iE_Extensions__item__id_tab,
        ___TRP_PRS_Info_List_Item_iE_Extensions__item__id,
        ____TRP_PRS_Info_List_Item_iE_Extensions__item__criticality_tab,
        ___TRP_PRS_Info_List_Item_iE_Extensions__item__criticality,
        ____TRP_PRS_Info_List_Item_iE_Extensions__item__extensionValue_tab,
        ___TRP_PRS_Info_List_Item_iE_Extensions__item__extensionValue,
        __TRP_PRS_Info_List_Item_iE_Extensions__item_,
        _TRP_PRS_Info_List_Item_iE_Extensions,
        TRP_PRS_Info_List_Item,
        TRP_PRS_Info_List_Item_ExtIEs,
        _TRPPositionDefinitionType_direct,
        _TRPPositionDefinitionType_referenced,
        ___TRPPositionDefinitionType_choice_extension_id_tab,
        __TRPPositionDefinitionType_choice_extension_id,
        ___TRPPositionDefinitionType_choice_extension_criticality_tab,
        __TRPPositionDefinitionType_choice_extension_criticality,
        ___TRPPositionDefinitionType_choice_extension_value_tab,
        __TRPPositionDefinitionType_choice_extension_value,
        _TRPPositionDefinitionType_choice_extension,
        TRPPositionDefinitionType,
        TRPPositionDefinitionType_ExtIEs,
        _TRPPositionDirect_accuracy,
        ____TRPPositionDirect_iE_extensions__item__id_tab,
        ___TRPPositionDirect_iE_extensions__item__id,
        ____TRPPositionDirect_iE_extensions__item__criticality_tab,
        ___TRPPositionDirect_iE_extensions__item__criticality,
        ____TRPPositionDirect_iE_extensions__item__extensionValue_tab,
        ___TRPPositionDirect_iE_extensions__item__extensionValue,
        __TRPPositionDirect_iE_extensions__item_,
        _TRPPositionDirect_iE_extensions,
        TRPPositionDirect,
        TRPPositionDirect_ExtIEs,
        _TRPPositionDirectAccuracy_tRPPosition,
        _TRPPositionDirectAccuracy_tRPHAposition,
        ___TRPPositionDirectAccuracy_choice_extension_id_tab,
        __TRPPositionDirectAccuracy_choice_extension_id,
        ___TRPPositionDirectAccuracy_choice_extension_criticality_tab,
        __TRPPositionDirectAccuracy_choice_extension_criticality,
        ___TRPPositionDirectAccuracy_choice_extension_value_tab,
        __TRPPositionDirectAccuracy_choice_extension_value,
        _TRPPositionDirectAccuracy_choice_extension,
        TRPPositionDirectAccuracy,
        TRPPositionDirectAccuracy_ExtIEs,
        _TRPPositionReferenced_referencePoint,
        _TRPPositionReferenced_referencePointType,
        ____TRPPositionReferenced_iE_extensions__item__id_tab,
        ___TRPPositionReferenced_iE_extensions__item__id,
        ____TRPPositionReferenced_iE_extensions__item__criticality_tab,
        ___TRPPositionReferenced_iE_extensions__item__criticality,
        ____TRPPositionReferenced_iE_extensions__item__extensionValue_tab,
        ___TRPPositionReferenced_iE_extensions__item__extensionValue,
        __TRPPositionReferenced_iE_extensions__item_,
        _TRPPositionReferenced_iE_extensions,
        TRPPositionReferenced,
        TRPPositionReferenced_ExtIEs,
        _TRPReferencePointType_tRPPositionRelativeGeodetic,
        _TRPReferencePointType_tRPPositionRelativeCartesian,
        ___TRPReferencePointType_choice_extension_id_tab,
        __TRPReferencePointType_choice_extension_id,
        ___TRPReferencePointType_choice_extension_criticality_tab,
        __TRPReferencePointType_choice_extension_criticality,
        ___TRPReferencePointType_choice_extension_value_tab,
        __TRPReferencePointType_choice_extension_value,
        _TRPReferencePointType_choice_extension,
        TRPReferencePointType,
        TRPReferencePointType_ExtIEs,
        _TRP_Rx_TEGInformation_tRP_Rx_TEGID,
        _TRP_Rx_TEGInformation_tRP_Rx_TimingErrorMargin,
        ____TRP_Rx_TEGInformation_iE_Extensions__item__id_tab,
        ___TRP_Rx_TEGInformation_iE_Extensions__item__id,
        ____TRP_Rx_TEGInformation_iE_Extensions__item__criticality_tab,
        ___TRP_Rx_TEGInformation_iE_Extensions__item__criticality,
        ____TRP_Rx_TEGInformation_iE_Extensions__item__extensionValue_tab,
        ___TRP_Rx_TEGInformation_iE_Extensions__item__extensionValue,
        __TRP_Rx_TEGInformation_iE_Extensions__item_,
        _TRP_Rx_TEGInformation_iE_Extensions,
        TRP_Rx_TEGInformation,
        TRP_Rx_TEGInformation_ExtIEs,
        _TRP_RxTx_TEGInformation_tRP_RxTx_TEGID,
        _TRP_RxTx_TEGInformation_tRP_RxTx_TimingErrorMargin,
        ____TRP_RxTx_TEGInformation_iE_Extensions__item__id_tab,
        ___TRP_RxTx_TEGInformation_iE_Extensions__item__id,
        ____TRP_RxTx_TEGInformation_iE_Extensions__item__criticality_tab,
        ___TRP_RxTx_TEGInformation_iE_Extensions__item__criticality,
        ____TRP_RxTx_TEGInformation_iE_Extensions__item__extensionValue_tab,
        ___TRP_RxTx_TEGInformation_iE_Extensions__item__extensionValue,
        __TRP_RxTx_TEGInformation_iE_Extensions__item_,
        _TRP_RxTx_TEGInformation_iE_Extensions,
        TRP_RxTx_TEGInformation,
        TRP_RxTx_TEGInformation_ExtIEs,
        _TRP_Tx_TEGInformation_tRP_Tx_TEGID,
        _TRP_Tx_TEGInformation_tRP_Tx_TimingErrorMargin,
        ____TRP_Tx_TEGInformation_iE_Extensions__item__id_tab,
        ___TRP_Tx_TEGInformation_iE_Extensions__item__id,
        ____TRP_Tx_TEGInformation_iE_Extensions__item__criticality_tab,
        ___TRP_Tx_TEGInformation_iE_Extensions__item__criticality,
        ____TRP_Tx_TEGInformation_iE_Extensions__item__extensionValue_tab,
        ___TRP_Tx_TEGInformation_iE_Extensions__item__extensionValue,
        __TRP_Tx_TEGInformation_iE_Extensions__item_,
        _TRP_Tx_TEGInformation_iE_Extensions,
        TRP_Tx_TEGInformation,
        TRP_Tx_TEGInformation_ExtIEs,
        _TRPTxTEGAssociation__item_,
        TRPTxTEGAssociation,
        _TRPTEG_Item_tRP_Tx_TEGInformation,
        _TRPTEG_Item_dl_PRSResourceSetID,
        __TRPTEG_Item_dl_PRSResourceID_List__item_,
        _TRPTEG_Item_dl_PRSResourceID_List,
        ____TRPTEG_Item_iE_Extensions__item__id_tab,
        ___TRPTEG_Item_iE_Extensions__item__id,
        ____TRPTEG_Item_iE_Extensions__item__criticality_tab,
        ___TRPTEG_Item_iE_Extensions__item__criticality,
        ____TRPTEG_Item_iE_Extensions__item__extensionValue_tab,
        ___TRPTEG_Item_iE_Extensions__item__extensionValue,
        __TRPTEG_Item_iE_Extensions__item_,
        _TRPTEG_Item_iE_Extensions,
        TRPTEG_Item,
        TRPTEGItem_ExtIEs,
        _DLPRSResourceID_Item_dl_PRSResourceID,
        ____DLPRSResourceID_Item_iE_Extensions__item__id_tab,
        ___DLPRSResourceID_Item_iE_Extensions__item__id,
        ____DLPRSResourceID_Item_iE_Extensions__item__criticality_tab,
        ___DLPRSResourceID_Item_iE_Extensions__item__criticality,
        ____DLPRSResourceID_Item_iE_Extensions__item__extensionValue_tab,
        ___DLPRSResourceID_Item_iE_Extensions__item__extensionValue,
        __DLPRSResourceID_Item_iE_Extensions__item_,
        _DLPRSResourceID_Item_iE_Extensions,
        DLPRSResourceID_Item,
        DLPRSResource_Item_ExtIEs,
        TypeOfError,
        _Transport_Layer_Address_Info_transport_UP_Layer_Address_Info_To_Add_List,
        _Transport_Layer_Address_Info_transport_UP_Layer_Address_Info_To_Remove_List,
        ____Transport_Layer_Address_Info_iE_Extensions__item__id_tab,
        ___Transport_Layer_Address_Info_iE_Extensions__item__id,
        ____Transport_Layer_Address_Info_iE_Extensions__item__criticality_tab,
        ___Transport_Layer_Address_Info_iE_Extensions__item__criticality,
        ____Transport_Layer_Address_Info_iE_Extensions__item__extensionValue_tab,
        ___Transport_Layer_Address_Info_iE_Extensions__item__extensionValue,
        __Transport_Layer_Address_Info_iE_Extensions__item_,
        _Transport_Layer_Address_Info_iE_Extensions,
        Transport_Layer_Address_Info,
        Transport_Layer_Address_Info_ExtIEs,
        TRPType,
        _TSCAssistanceInformation_periodicity,
        _TSCAssistanceInformation_burstArrivalTime,
        ____TSCAssistanceInformation_iE_Extensions__item__id_tab,
        _____TSCAssistanceInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___TSCAssistanceInformation_iE_Extensions__item__id,
        ___TSCAssistanceInformation_iE_Extensions__item__criticality,
        ___TSCAssistanceInformation_iE_Extensions__item__extensionValue,
        __TSCAssistanceInformation_iE_Extensions__item_,
        _TSCAssistanceInformation_iE_Extensions,
        TSCAssistanceInformation,
        TSCAssistanceInformation_ExtIEs,
        _TSCAssistanceInformation_ExtIEs_val_Extension_0,
        _TSCTrafficCharacteristics_tSCAssistanceInformationDL,
        _TSCTrafficCharacteristics_tSCAssistanceInformationUL,
        ____TSCTrafficCharacteristics_iE_Extensions__item__id_tab,
        ___TSCTrafficCharacteristics_iE_Extensions__item__id,
        ____TSCTrafficCharacteristics_iE_Extensions__item__criticality_tab,
        ___TSCTrafficCharacteristics_iE_Extensions__item__criticality,
        ____TSCTrafficCharacteristics_iE_Extensions__item__extensionValue_tab,
        ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue,
        __TSCTrafficCharacteristics_iE_Extensions__item_,
        _TSCTrafficCharacteristics_iE_Extensions,
        TSCTrafficCharacteristics,
        TSCTrafficCharacteristics_ExtIEs,
        _TRP_MeasurementUpdateList__item_,
        TRP_MeasurementUpdateList,
        _TRP_MeasurementUpdateItem_tRP_ID,
        _TRP_MeasurementUpdateItem_aoA_window_information,
        ____TRP_MeasurementUpdateItem_iE_extensions__item__id_tab,
        _____TRP_MeasurementUpdateItem_iE_extensions__item__id_tab_val_Extension_0,
        _____TRP_MeasurementUpdateItem_iE_extensions__item__id_tab_val_Extension_1,
        ___TRP_MeasurementUpdateItem_iE_extensions__item__id,
        ___TRP_MeasurementUpdateItem_iE_extensions__item__criticality,
        ___TRP_MeasurementUpdateItem_iE_extensions__item__extensionValue,
        __TRP_MeasurementUpdateItem_iE_extensions__item_,
        _TRP_MeasurementUpdateItem_iE_extensions,
        TRP_MeasurementUpdateItem,
        TRP_MeasurementUpdateItem_ExtIEs,
        _TRP_MeasurementUpdateItem_ExtIEs_val_Extension_0,
        _TRP_MeasurementUpdateItem_ExtIEs_val_Extension_1,
        TwoPHRModeMCG,
        TwoPHRModeSCG,
        _UAC_Assistance_Info_uACPLMN_List,
        ____UAC_Assistance_Info_iE_Extensions__item__id_tab,
        ___UAC_Assistance_Info_iE_Extensions__item__id,
        ____UAC_Assistance_Info_iE_Extensions__item__criticality_tab,
        ___UAC_Assistance_Info_iE_Extensions__item__criticality,
        ____UAC_Assistance_Info_iE_Extensions__item__extensionValue_tab,
        ___UAC_Assistance_Info_iE_Extensions__item__extensionValue,
        __UAC_Assistance_Info_iE_Extensions__item_,
        _UAC_Assistance_Info_iE_Extensions,
        UAC_Assistance_Info,
        UAC_Assistance_InfoExtIEs,
        _UACPLMN_List__item_,
        UACPLMN_List,
        _UACPLMN_Item_pLMNIdentity,
        _UACPLMN_Item_uACType_List,
        ____UACPLMN_Item_iE_Extensions__item__id_tab,
        _____UACPLMN_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___UACPLMN_Item_iE_Extensions__item__id,
        ___UACPLMN_Item_iE_Extensions__item__criticality,
        ___UACPLMN_Item_iE_Extensions__item__extensionValue,
        __UACPLMN_Item_iE_Extensions__item_,
        _UACPLMN_Item_iE_Extensions,
        UACPLMN_Item,
        UACPLMN_Item_ExtIEs,
        _UACPLMN_Item_ExtIEs_val_Extension_0,
        _UACType_List__item_,
        UACType_List,
        _UACType_Item_uACReductionIndication,
        _UACType_Item_uACCategoryType,
        ____UACType_Item_iE_Extensions__item__id_tab,
        ___UACType_Item_iE_Extensions__item__id,
        ____UACType_Item_iE_Extensions__item__criticality_tab,
        ___UACType_Item_iE_Extensions__item__criticality,
        ____UACType_Item_iE_Extensions__item__extensionValue_tab,
        ___UACType_Item_iE_Extensions__item__extensionValue,
        __UACType_Item_iE_Extensions__item_,
        _UACType_Item_iE_Extensions,
        UACType_Item,
        UACType_Item_ExtIEs,
        _UACCategoryType_uACstandardized,
        _UACCategoryType_uACOperatorDefined,
        ___UACCategoryType_choice_extension_id_tab,
        __UACCategoryType_choice_extension_id,
        ___UACCategoryType_choice_extension_criticality_tab,
        __UACCategoryType_choice_extension_criticality,
        ___UACCategoryType_choice_extension_value_tab,
        __UACCategoryType_choice_extension_value,
        _UACCategoryType_choice_extension,
        UACCategoryType,
        UACCategoryType_ExtIEs,
        _UACOperatorDefined_accessCategory,
        _UACOperatorDefined_accessIdentity,
        ____UACOperatorDefined_iE_Extensions__item__id_tab,
        ___UACOperatorDefined_iE_Extensions__item__id,
        ____UACOperatorDefined_iE_Extensions__item__criticality_tab,
        ___UACOperatorDefined_iE_Extensions__item__criticality,
        ____UACOperatorDefined_iE_Extensions__item__extensionValue_tab,
        ___UACOperatorDefined_iE_Extensions__item__extensionValue,
        __UACOperatorDefined_iE_Extensions__item_,
        _UACOperatorDefined_iE_Extensions,
        UACOperatorDefined,
        UACOperatorDefined_ExtIEs,
        UACAction,
        UACReductionIndication,
        _UE_associatedLogicalF1_ConnectionItem_gNB_CU_UE_F1AP_ID,
        _UE_associatedLogicalF1_ConnectionItem_gNB_DU_UE_F1AP_ID,
        ____UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__id_tab,
        ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__id,
        ____UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__criticality_tab,
        ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__criticality,
        ____UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__extensionValue_tab,
        ___UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item__extensionValue,
        __UE_associatedLogicalF1_ConnectionItem_iE_Extensions__item_,
        _UE_associatedLogicalF1_ConnectionItem_iE_Extensions,
        UE_associatedLogicalF1_ConnectionItem,
        UEAssistanceInformation,
        UEAssistanceInformationEUTRA,
        UE_associatedLogicalF1_ConnectionItemExtIEs,
        UE_CapabilityRAT_ContainerList,
        UEContextNotRetrievable,
        _UEIdentityIndexValue_indexLength10,
        ___UEIdentityIndexValue_choice_extension_id_tab,
        __UEIdentityIndexValue_choice_extension_id,
        ___UEIdentityIndexValue_choice_extension_criticality_tab,
        __UEIdentityIndexValue_choice_extension_criticality,
        ___UEIdentityIndexValue_choice_extension_value_tab,
        __UEIdentityIndexValue_choice_extension_value,
        _UEIdentityIndexValue_choice_extension,
        UEIdentityIndexValue,
        UEIdentityIndexValueChoice_ExtIEs,
        _UEIdentity_List_For_Paging_Item_uEIdentityIndexValue,
        _UEIdentity_List_For_Paging_Item_pagingDRX,
        ____UEIdentity_List_For_Paging_Item_iE_Extensions__item__id_tab,
        ___UEIdentity_List_For_Paging_Item_iE_Extensions__item__id,
        ____UEIdentity_List_For_Paging_Item_iE_Extensions__item__criticality_tab,
        ___UEIdentity_List_For_Paging_Item_iE_Extensions__item__criticality,
        ____UEIdentity_List_For_Paging_Item_iE_Extensions__item__extensionValue_tab,
        ___UEIdentity_List_For_Paging_Item_iE_Extensions__item__extensionValue,
        __UEIdentity_List_For_Paging_Item_iE_Extensions__item_,
        _UEIdentity_List_For_Paging_Item_iE_Extensions,
        UEIdentity_List_For_Paging_Item,
        UEIdentity_List_For_Paging_Item_ExtIEs,
        _UE_MulticastMRBs_ConfirmedToBeModified_Item_mRB_ID,
        _UE_MulticastMRBs_ConfirmedToBeModified_Item_mrb_type_reconfiguration,
        ____UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__id_tab,
        ___UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__id,
        ____UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__criticality_tab,
        ___UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__criticality,
        ____UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__extensionValue_tab,
        ___UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item__extensionValue,
        __UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions__item_,
        _UE_MulticastMRBs_ConfirmedToBeModified_Item_iE_Extensions,
        UE_MulticastMRBs_ConfirmedToBeModified_Item,
        UE_MulticastMRBs_ConfirmedToBeModified_Item_ExtIEs,
        _UE_MulticastMRBs_RequiredToBeModified_Item_mRB_ID,
        _UE_MulticastMRBs_RequiredToBeModified_Item_mrb_type_reconfiguration,
        _UE_MulticastMRBs_RequiredToBeModified_Item_mrb_reconfigured_RLCtype,
        ____UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__id_tab,
        _____UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__id,
        ___UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__criticality,
        ___UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item__extensionValue,
        __UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions__item_,
        _UE_MulticastMRBs_RequiredToBeModified_Item_iE_Extensions,
        UE_MulticastMRBs_RequiredToBeModified_Item,
        UE_MulticastMRBs_RequiredToBeModified_Item_ExtIEs,
        _UE_MulticastMRBs_RequiredToBeModified_Item_ExtIEs_val_Extension_0,
        _UE_MulticastMRBs_RequiredToBeReleased_Item_mRB_ID,
        ____UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__id_tab,
        ___UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__id,
        ____UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__criticality_tab,
        ___UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__criticality,
        ____UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__extensionValue_tab,
        ___UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item__extensionValue,
        __UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions__item_,
        _UE_MulticastMRBs_RequiredToBeReleased_Item_iE_Extensions,
        UE_MulticastMRBs_RequiredToBeReleased_Item,
        UE_MulticastMRBs_RequiredToBeReleased_Item_ExtIEs,
        _UE_MulticastMRBs_Setup_Item_mRB_ID,
        _UE_MulticastMRBs_Setup_Item_multicastF1UContextReferenceCU,
        ____UE_MulticastMRBs_Setup_Item_iE_Extensions__item__id_tab,
        ___UE_MulticastMRBs_Setup_Item_iE_Extensions__item__id,
        ____UE_MulticastMRBs_Setup_Item_iE_Extensions__item__criticality_tab,
        ___UE_MulticastMRBs_Setup_Item_iE_Extensions__item__criticality,
        ____UE_MulticastMRBs_Setup_Item_iE_Extensions__item__extensionValue_tab,
        ___UE_MulticastMRBs_Setup_Item_iE_Extensions__item__extensionValue,
        __UE_MulticastMRBs_Setup_Item_iE_Extensions__item_,
        _UE_MulticastMRBs_Setup_Item_iE_Extensions,
        UE_MulticastMRBs_Setup_Item,
        UE_MulticastMRBs_Setup_Item_ExtIEs,
        _UE_MulticastMRBs_ToBeReleased_Item_mRB_ID,
        ____UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__id_tab,
        ___UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__id,
        ____UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality_tab,
        ___UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__criticality,
        ____UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue_tab,
        ___UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item__extensionValue,
        __UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions__item_,
        _UE_MulticastMRBs_ToBeReleased_Item_iE_Extensions,
        UE_MulticastMRBs_ToBeReleased_Item,
        UE_MulticastMRBs_ToBeReleased_Item_ExtIEs,
        _UE_MulticastMRBs_ToBeSetup_Item_mRB_ID,
        _UE_MulticastMRBs_ToBeSetup_Item_mbsPTPRetransmissionTunnelRequired,
        _UE_MulticastMRBs_ToBeSetup_Item_mbsPTPForwardingRequiredInformation,
        ____UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__id_tab,
        _____UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__id,
        ___UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__criticality,
        ___UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item__extensionValue,
        __UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions__item_,
        _UE_MulticastMRBs_ToBeSetup_Item_iE_Extensions,
        UE_MulticastMRBs_ToBeSetup_Item,
        UE_MulticastMRBs_ToBeSetup_Item_ExtIEs,
        _UE_MulticastMRBs_ToBeSetup_Item_ExtIEs_val_Extension_0,
        _UE_MulticastMRBs_ToBeSetup_atModify_Item_mRB_ID,
        _UE_MulticastMRBs_ToBeSetup_atModify_Item_mbsPTPRetransmissionTunnelRequired,
        _UE_MulticastMRBs_ToBeSetup_atModify_Item_mbsPTPForwardingRequiredInformation,
        ____UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__id_tab,
        ___UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__id,
        ____UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__criticality_tab,
        ___UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__criticality,
        ____UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__extensionValue_tab,
        ___UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item__extensionValue,
        __UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions__item_,
        _UE_MulticastMRBs_ToBeSetup_atModify_Item_iE_Extensions,
        UE_MulticastMRBs_ToBeSetup_atModify_Item,
        UE_MulticastMRBs_ToBeSetup_atModify_Item_ExtIEs,
        _UEPagingCapability_iNACTIVEStatePODetermination,
        ____UEPagingCapability_iE_Extension__item__id_tab,
        _____UEPagingCapability_iE_Extension__item__id_tab_val_Extension_0,
        ___UEPagingCapability_iE_Extension__item__id,
        ___UEPagingCapability_iE_Extension__item__criticality,
        ___UEPagingCapability_iE_Extension__item__extensionValue,
        __UEPagingCapability_iE_Extension__item_,
        _UEPagingCapability_iE_Extension,
        UEPagingCapability,
        UEPagingCapability_ExtIEs,
        _UEPagingCapability_ExtIEs_val_Extension_0,
        _UEReportingInformation_reportingAmount,
        _UEReportingInformation_reportingInterval,
        ____UEReportingInformation_iE_extensions__item__id_tab,
        ___UEReportingInformation_iE_extensions__item__id,
        ____UEReportingInformation_iE_extensions__item__criticality_tab,
        ___UEReportingInformation_iE_extensions__item__criticality,
        ____UEReportingInformation_iE_extensions__item__extensionValue_tab,
        ___UEReportingInformation_iE_extensions__item__extensionValue,
        __UEReportingInformation_iE_extensions__item_,
        _UEReportingInformation_iE_extensions,
        UEReportingInformation,
        UEReportingInformation_ExtIEs,
        UlTxDirectCurrentMoreCarrierInformation,
        _UL_AoA_azimuthAoA,
        _UL_AoA_zenithAoA,
        _UL_AoA_lCS_to_GCS_Translation,
        ____UL_AoA_iE_extensions__item__id_tab,
        ___UL_AoA_iE_extensions__item__id,
        ____UL_AoA_iE_extensions__item__criticality_tab,
        ___UL_AoA_iE_extensions__item__criticality,
        ____UL_AoA_iE_extensions__item__extensionValue_tab,
        ___UL_AoA_iE_extensions__item__extensionValue,
        __UL_AoA_iE_extensions__item_,
        _UL_AoA_iE_extensions,
        UL_AoA,
        UL_AoA_ExtIEs,
        _UL_BH_Non_UP_Traffic_Mapping_uL_BH_Non_UP_Traffic_Mapping_List,
        ____UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__id_tab,
        ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__id,
        ____UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__criticality_tab,
        ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__criticality,
        ____UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__extensionValue_tab,
        ___UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item__extensionValue,
        __UL_BH_Non_UP_Traffic_Mapping_iE_Extensions__item_,
        _UL_BH_Non_UP_Traffic_Mapping_iE_Extensions,
        UL_BH_Non_UP_Traffic_Mapping,
        UL_BH_Non_UP_Traffic_Mapping_ExtIEs,
        _UL_BH_Non_UP_Traffic_Mapping_List__item_,
        UL_BH_Non_UP_Traffic_Mapping_List,
        _UL_BH_Non_UP_Traffic_Mapping_Item_nonUPTrafficType,
        _UL_BH_Non_UP_Traffic_Mapping_Item_bHInfo,
        ____UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__id_tab,
        ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__id,
        ____UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__criticality_tab,
        ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__criticality,
        ____UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__extensionValue_tab,
        ___UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item__extensionValue,
        __UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions__item_,
        _UL_BH_Non_UP_Traffic_Mapping_Item_iE_Extensions,
        UL_BH_Non_UP_Traffic_Mapping_Item,
        UL_BH_Non_UP_Traffic_Mapping_ItemExtIEs,
        _ULConfiguration_uLUEConfiguration,
        ____ULConfiguration_iE_Extensions__item__id_tab,
        ___ULConfiguration_iE_Extensions__item__id,
        ____ULConfiguration_iE_Extensions__item__criticality_tab,
        ___ULConfiguration_iE_Extensions__item__criticality,
        ____ULConfiguration_iE_Extensions__item__extensionValue_tab,
        ___ULConfiguration_iE_Extensions__item__extensionValue,
        __ULConfiguration_iE_Extensions__item_,
        _ULConfiguration_iE_Extensions,
        ULConfiguration,
        ULConfigurationExtIEs,
        UL_GapFR2_Config,
        _UL_RTOA_Measurement_uL_RTOA_MeasurementItem,
        _UL_RTOA_Measurement_additionalPath_List,
        ____UL_RTOA_Measurement_iE_Extensions__item__id_tab,
        _____UL_RTOA_Measurement_iE_Extensions__item__id_tab_val_Extension_0,
        _____UL_RTOA_Measurement_iE_Extensions__item__id_tab_val_Extension_1,
        ___UL_RTOA_Measurement_iE_Extensions__item__id,
        ___UL_RTOA_Measurement_iE_Extensions__item__criticality,
        ___UL_RTOA_Measurement_iE_Extensions__item__extensionValue,
        __UL_RTOA_Measurement_iE_Extensions__item_,
        _UL_RTOA_Measurement_iE_Extensions,
        UL_RTOA_Measurement,
        UL_RTOA_Measurement_ExtIEs,
        _UL_RTOA_Measurement_ExtIEs_val_Extension_0,
        _UL_RTOA_Measurement_ExtIEs_val_Extension_1,
        _UL_RTOA_MeasurementItem_k0,
        _UL_RTOA_MeasurementItem_k1,
        _UL_RTOA_MeasurementItem_k2,
        _UL_RTOA_MeasurementItem_k3,
        _UL_RTOA_MeasurementItem_k4,
        _UL_RTOA_MeasurementItem_k5,
        ___UL_RTOA_MeasurementItem_choice_extension_id_tab,
        __UL_RTOA_MeasurementItem_choice_extension_id,
        ___UL_RTOA_MeasurementItem_choice_extension_criticality_tab,
        __UL_RTOA_MeasurementItem_choice_extension_criticality,
        ___UL_RTOA_MeasurementItem_choice_extension_value_tab,
        __UL_RTOA_MeasurementItem_choice_extension_value,
        _UL_RTOA_MeasurementItem_choice_extension,
        UL_RTOA_MeasurementItem,
        UL_RTOA_MeasurementItem_ExtIEs,
        UL_SRS_RSRP,
        _UL_SRS_RSRPP_firstPathRSRPP,
        ____UL_SRS_RSRPP_iE_extensions__item__id_tab,
        ___UL_SRS_RSRPP_iE_extensions__item__id,
        ____UL_SRS_RSRPP_iE_extensions__item__criticality_tab,
        ___UL_SRS_RSRPP_iE_extensions__item__criticality,
        ____UL_SRS_RSRPP_iE_extensions__item__extensionValue_tab,
        ___UL_SRS_RSRPP_iE_extensions__item__extensionValue,
        __UL_SRS_RSRPP_iE_extensions__item_,
        _UL_SRS_RSRPP_iE_extensions,
        UL_SRS_RSRPP,
        UL_SRS_RSRPP_ExtIEs,
        ULUEConfiguration,
        _UL_UP_TNL_Information_to_Update_List_Item_uLUPTNLInformation,
        _UL_UP_TNL_Information_to_Update_List_Item_newULUPTNLInformation,
        _UL_UP_TNL_Information_to_Update_List_Item_bHInfo,
        ____UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__id_tab,
        ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__id,
        ____UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__criticality_tab,
        ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__criticality,
        ____UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__extensionValue_tab,
        ___UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item__extensionValue,
        __UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions__item_,
        _UL_UP_TNL_Information_to_Update_List_Item_iE_Extensions,
        UL_UP_TNL_Information_to_Update_List_Item,
        UL_UP_TNL_Information_to_Update_List_ItemExtIEs,
        _UL_UP_TNL_Address_to_Update_List_Item_oldIPAdress,
        _UL_UP_TNL_Address_to_Update_List_Item_newIPAdress,
        ____UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id_tab,
        ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__id,
        ____UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality_tab,
        ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__criticality,
        ____UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue_tab,
        ___UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item__extensionValue,
        __UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions__item_,
        _UL_UP_TNL_Address_to_Update_List_Item_iE_Extensions,
        UL_UP_TNL_Address_to_Update_List_Item,
        UL_UP_TNL_Address_to_Update_List_ItemExtIEs,
        _ULUPTNLInformation_ToBeSetup_List__item_,
        ULUPTNLInformation_ToBeSetup_List,
        _ULUPTNLInformation_ToBeSetup_Item_uLUPTNLInformation,
        ____ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab,
        _____ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_1,
        ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__id,
        ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__criticality,
        ___ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item__extensionValue,
        __ULUPTNLInformation_ToBeSetup_Item_iE_Extensions__item_,
        _ULUPTNLInformation_ToBeSetup_Item_iE_Extensions,
        ULUPTNLInformation_ToBeSetup_Item,
        ULUPTNLInformation_ToBeSetup_ItemExtIEs,
        _ULUPTNLInformation_ToBeSetup_ItemExtIEs_val_Extension_0,
        _ULUPTNLInformation_ToBeSetup_ItemExtIEs_val_Extension_1,
        Uncertainty,
        _UplinkChannelBW_PerSCS_List__item_,
        UplinkChannelBW_PerSCS_List,
        UplinkTxDirectCurrentListInformation,
        UplinkTxDirectCurrentTwoCarrierListInfo,
        _UPTransportLayerInformation_gTPTunnel,
        ___UPTransportLayerInformation_choice_extension_id_tab,
        __UPTransportLayerInformation_choice_extension_id,
        ___UPTransportLayerInformation_choice_extension_criticality_tab,
        __UPTransportLayerInformation_choice_extension_criticality,
        ___UPTransportLayerInformation_choice_extension_value_tab,
        __UPTransportLayerInformation_choice_extension_value,
        _UPTransportLayerInformation_choice_extension,
        UPTransportLayerInformation,
        UPTransportLayerInformation_ExtIEs,
        URI_address,
        Uncertainty_range_AoA,
        Uncertainty_range_ZoA,
        UuRLCChannelID,
        _UuRLCChannelQoSInformation_uuRLCChannelQoS,
        _UuRLCChannelQoSInformation_uuControlPlaneTrafficType,
        ___UuRLCChannelQoSInformation_choice_extension_id_tab,
        __UuRLCChannelQoSInformation_choice_extension_id,
        ___UuRLCChannelQoSInformation_choice_extension_criticality_tab,
        __UuRLCChannelQoSInformation_choice_extension_criticality,
        ___UuRLCChannelQoSInformation_choice_extension_value_tab,
        __UuRLCChannelQoSInformation_choice_extension_value,
        _UuRLCChannelQoSInformation_choice_extension,
        UuRLCChannelQoSInformation,
        UuRLCChannelQoSInformation_ExtIEs,
        _UuRLCChannelToBeSetupList__item_,
        UuRLCChannelToBeSetupList,
        _UuRLCChannelToBeSetupItem_uuRLCChannelID,
        _UuRLCChannelToBeSetupItem_uuRLCChannelQoSInformation,
        _UuRLCChannelToBeSetupItem_rLCMode,
        ____UuRLCChannelToBeSetupItem_iE_Extensions__item__id_tab,
        ___UuRLCChannelToBeSetupItem_iE_Extensions__item__id,
        ____UuRLCChannelToBeSetupItem_iE_Extensions__item__criticality_tab,
        ___UuRLCChannelToBeSetupItem_iE_Extensions__item__criticality,
        ____UuRLCChannelToBeSetupItem_iE_Extensions__item__extensionValue_tab,
        ___UuRLCChannelToBeSetupItem_iE_Extensions__item__extensionValue,
        __UuRLCChannelToBeSetupItem_iE_Extensions__item_,
        _UuRLCChannelToBeSetupItem_iE_Extensions,
        UuRLCChannelToBeSetupItem,
        UuRLCChannelToBeSetupItem_ExtIEs,
        _UuRLCChannelToBeModifiedList__item_,
        UuRLCChannelToBeModifiedList,
        _UuRLCChannelToBeModifiedItem_uuRLCChannelID,
        _UuRLCChannelToBeModifiedItem_uuRLCChannelQoSInformation,
        _UuRLCChannelToBeModifiedItem_rLCMode,
        ____UuRLCChannelToBeModifiedItem_iE_Extensions__item__id_tab,
        ___UuRLCChannelToBeModifiedItem_iE_Extensions__item__id,
        ____UuRLCChannelToBeModifiedItem_iE_Extensions__item__criticality_tab,
        ___UuRLCChannelToBeModifiedItem_iE_Extensions__item__criticality,
        ____UuRLCChannelToBeModifiedItem_iE_Extensions__item__extensionValue_tab,
        ___UuRLCChannelToBeModifiedItem_iE_Extensions__item__extensionValue,
        __UuRLCChannelToBeModifiedItem_iE_Extensions__item_,
        _UuRLCChannelToBeModifiedItem_iE_Extensions,
        UuRLCChannelToBeModifiedItem,
        UuRLCChannelToBeModifiedItem_ExtIEs,
        _UuRLCChannelToBeReleasedList__item_,
        UuRLCChannelToBeReleasedList,
        _UuRLCChannelToBeReleasedItem_uuRLCChannelID,
        ____UuRLCChannelToBeReleasedItem_iE_Extensions__item__id_tab,
        ___UuRLCChannelToBeReleasedItem_iE_Extensions__item__id,
        ____UuRLCChannelToBeReleasedItem_iE_Extensions__item__criticality_tab,
        ___UuRLCChannelToBeReleasedItem_iE_Extensions__item__criticality,
        ____UuRLCChannelToBeReleasedItem_iE_Extensions__item__extensionValue_tab,
        ___UuRLCChannelToBeReleasedItem_iE_Extensions__item__extensionValue,
        __UuRLCChannelToBeReleasedItem_iE_Extensions__item_,
        _UuRLCChannelToBeReleasedItem_iE_Extensions,
        UuRLCChannelToBeReleasedItem,
        UuRLCChannelToBeReleasedItem_ExtIEs,
        _UuRLCChannelSetupList__item_,
        UuRLCChannelSetupList,
        _UuRLCChannelSetupItem_uuRLCChannelID,
        ____UuRLCChannelSetupItem_iE_Extensions__item__id_tab,
        ___UuRLCChannelSetupItem_iE_Extensions__item__id,
        ____UuRLCChannelSetupItem_iE_Extensions__item__criticality_tab,
        ___UuRLCChannelSetupItem_iE_Extensions__item__criticality,
        ____UuRLCChannelSetupItem_iE_Extensions__item__extensionValue_tab,
        ___UuRLCChannelSetupItem_iE_Extensions__item__extensionValue,
        __UuRLCChannelSetupItem_iE_Extensions__item_,
        _UuRLCChannelSetupItem_iE_Extensions,
        UuRLCChannelSetupItem,
        UuRLCChannelSetupItem_ExtIEs,
        _UuRLCChannelFailedToBeSetupList__item_,
        UuRLCChannelFailedToBeSetupList,
        _UuRLCChannelFailedToBeSetupItem_uuRLCChannelID,
        _UuRLCChannelFailedToBeSetupItem_cause,
        ____UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__id_tab,
        ___UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__id,
        ____UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__criticality_tab,
        ___UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__criticality,
        ____UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__extensionValue_tab,
        ___UuRLCChannelFailedToBeSetupItem_iE_Extensions__item__extensionValue,
        __UuRLCChannelFailedToBeSetupItem_iE_Extensions__item_,
        _UuRLCChannelFailedToBeSetupItem_iE_Extensions,
        UuRLCChannelFailedToBeSetupItem,
        UuRLCChannelFailedToBeSetupItem_ExtIEs,
        _UuRLCChannelModifiedList__item_,
        UuRLCChannelModifiedList,
        _UuRLCChannelModifiedItem_uuRLCChannelID,
        ____UuRLCChannelModifiedItem_iE_Extensions__item__id_tab,
        ___UuRLCChannelModifiedItem_iE_Extensions__item__id,
        ____UuRLCChannelModifiedItem_iE_Extensions__item__criticality_tab,
        ___UuRLCChannelModifiedItem_iE_Extensions__item__criticality,
        ____UuRLCChannelModifiedItem_iE_Extensions__item__extensionValue_tab,
        ___UuRLCChannelModifiedItem_iE_Extensions__item__extensionValue,
        __UuRLCChannelModifiedItem_iE_Extensions__item_,
        _UuRLCChannelModifiedItem_iE_Extensions,
        UuRLCChannelModifiedItem,
        UuRLCChannelModifiedItem_ExtIEs,
        _UuRLCChannelFailedToBeModifiedList__item_,
        UuRLCChannelFailedToBeModifiedList,
        _UuRLCChannelFailedToBeModifiedItem_uuRLCChannelID,
        _UuRLCChannelFailedToBeModifiedItem_cause,
        ____UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__id_tab,
        ___UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__id,
        ____UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__criticality_tab,
        ___UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__criticality,
        ____UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__extensionValue_tab,
        ___UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item__extensionValue,
        __UuRLCChannelFailedToBeModifiedItem_iE_Extensions__item_,
        _UuRLCChannelFailedToBeModifiedItem_iE_Extensions,
        UuRLCChannelFailedToBeModifiedItem,
        UuRLCChannelFailedToBeModifiedItem_ExtIEs,
        _UuRLCChannelRequiredToBeModifiedList__item_,
        UuRLCChannelRequiredToBeModifiedList,
        _UuRLCChannelRequiredToBeModifiedItem_uuRLCChannelID,
        ____UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__id_tab,
        ___UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__id,
        ____UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__criticality_tab,
        ___UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__criticality,
        ____UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__extensionValue_tab,
        ___UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item__extensionValue,
        __UuRLCChannelRequiredToBeModifiedItem_iE_Extensions__item_,
        _UuRLCChannelRequiredToBeModifiedItem_iE_Extensions,
        UuRLCChannelRequiredToBeModifiedItem,
        UuRLCChannelRequiredToBeModifiedItem_ExtIEs,
        _UuRLCChannelRequiredToBeReleasedList__item_,
        UuRLCChannelRequiredToBeReleasedList,
        _UuRLCChannelRequiredToBeReleasedItem_uuRLCChannelID,
        ____UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__id_tab,
        ___UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__id,
        ____UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__criticality_tab,
        ___UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__criticality,
        ____UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__extensionValue_tab,
        ___UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item__extensionValue,
        __UuRLCChannelRequiredToBeReleasedItem_iE_Extensions__item_,
        _UuRLCChannelRequiredToBeReleasedItem_iE_Extensions,
        UuRLCChannelRequiredToBeReleasedItem,
        UuRLCChannelRequiredToBeReleasedItem_ExtIEs,
        _VictimgNBSetID_victimgNBSetID,
        ____VictimgNBSetID_iE_Extensions__item__id_tab,
        ___VictimgNBSetID_iE_Extensions__item__id,
        ____VictimgNBSetID_iE_Extensions__item__criticality_tab,
        ___VictimgNBSetID_iE_Extensions__item__criticality,
        ____VictimgNBSetID_iE_Extensions__item__extensionValue_tab,
        ___VictimgNBSetID_iE_Extensions__item__extensionValue,
        __VictimgNBSetID_iE_Extensions__item_,
        _VictimgNBSetID_iE_Extensions,
        VictimgNBSetID,
        VictimgNBSetID_ExtIEs,
        VehicleUE,
        PedestrianUE,
        _ZoAInformation_zenithAoA,
        _ZoAInformation_lCS_to_GCS_Translation,
        ____ZoAInformation_iE_extensions__item__id_tab,
        ___ZoAInformation_iE_extensions__item__id,
        ____ZoAInformation_iE_extensions__item__criticality_tab,
        ___ZoAInformation_iE_extensions__item__criticality,
        ____ZoAInformation_iE_extensions__item__extensionValue_tab,
        ___ZoAInformation_iE_extensions__item__extensionValue,
        __ZoAInformation_iE_extensions__item_,
        _ZoAInformation_iE_extensions,
        ZoAInformation,
        ZoAInformation_ExtIEs,
    ]

class F1AP_PDU_Contents:

    _name_  = 'F1AP-PDU-Contents'
    _oid_   = [0, 4, 0, 0, 22, 3, 3, 1, 1]
    
    _obj_ = [
        'Reset',
        'ResetIEs',
        'ResetType',
        'ResetType-ExtIEs',
        'ResetAll',
        'UE-associatedLogicalF1-ConnectionListRes',
        'UE-associatedLogicalF1-ConnectionItemRes',
        'ResetAcknowledge',
        'ResetAcknowledgeIEs',
        'UE-associatedLogicalF1-ConnectionListResAck',
        'UE-associatedLogicalF1-ConnectionItemResAck',
        'ErrorIndication',
        'ErrorIndicationIEs',
        'F1SetupRequest',
        'F1SetupRequestIEs',
        'GNB-DU-Served-Cells-List',
        'GNB-DU-Served-Cells-ItemIEs',
        'F1SetupResponse',
        'F1SetupResponseIEs',
        'Cells-to-be-Activated-List',
        'Cells-to-be-Activated-List-ItemIEs',
        'F1SetupFailure',
        'F1SetupFailureIEs',
        'GNBDUConfigurationUpdate',
        'GNBDUConfigurationUpdateIEs',
        'Served-Cells-To-Add-List',
        'Served-Cells-To-Modify-List',
        'Served-Cells-To-Delete-List',
        'Cells-Status-List',
        'Dedicated-SIDelivery-NeededUE-List',
        'GNB-DU-TNL-Association-To-Remove-List',
        'Served-Cells-To-Add-ItemIEs',
        'Served-Cells-To-Modify-ItemIEs',
        'Served-Cells-To-Delete-ItemIEs',
        'Cells-Status-ItemIEs',
        'Dedicated-SIDelivery-NeededUE-ItemIEs',
        'GNB-DU-TNL-Association-To-Remove-ItemIEs',
        'GNBDUConfigurationUpdateAcknowledge',
        'GNBDUConfigurationUpdateAcknowledgeIEs',
        'GNBDUConfigurationUpdateFailure',
        'GNBDUConfigurationUpdateFailureIEs',
        'GNBCUConfigurationUpdate',
        'GNBCUConfigurationUpdateIEs',
        'Cells-to-be-Deactivated-List',
        'GNB-CU-TNL-Association-To-Add-List',
        'GNB-CU-TNL-Association-To-Remove-List',
        'GNB-CU-TNL-Association-To-Update-List',
        'Cells-to-be-Barred-List',
        'Cells-to-be-Deactivated-List-ItemIEs',
        'GNB-CU-TNL-Association-To-Add-ItemIEs',
        'GNB-CU-TNL-Association-To-Remove-ItemIEs',
        'GNB-CU-TNL-Association-To-Update-ItemIEs',
        'Cells-to-be-Barred-ItemIEs',
        'Protected-EUTRA-Resources-List',
        'Protected-EUTRA-Resources-ItemIEs',
        'Neighbour-Cell-Information-List',
        'Neighbour-Cell-Information-ItemIEs',
        'GNBCUConfigurationUpdateAcknowledge',
        'GNBCUConfigurationUpdateAcknowledgeIEs',
        'Cells-Failed-to-be-Activated-List',
        'GNB-CU-TNL-Association-Setup-List',
        'GNB-CU-TNL-Association-Failed-To-Setup-List',
        'Cells-Failed-to-be-Activated-List-ItemIEs',
        'GNB-CU-TNL-Association-Setup-ItemIEs',
        'GNB-CU-TNL-Association-Failed-To-Setup-ItemIEs',
        'GNBCUConfigurationUpdateFailure',
        'GNBCUConfigurationUpdateFailureIEs',
        'GNBDUResourceCoordinationRequest',
        'GNBDUResourceCoordinationRequest-IEs',
        'GNBDUResourceCoordinationResponse',
        'GNBDUResourceCoordinationResponse-IEs',
        'UEContextSetupRequest',
        'UEContextSetupRequestIEs',
        'Candidate-SpCell-List',
        'SCell-ToBeSetup-List',
        'SRBs-ToBeSetup-List',
        'DRBs-ToBeSetup-List',
        'BHChannels-ToBeSetup-List',
        'SLDRBs-ToBeSetup-List',
        'UE-MulticastMRBs-ToBeSetup-List',
        'ServingCellMO-List',
        'Candidate-SpCell-ItemIEs',
        'SCell-ToBeSetup-ItemIEs',
        'SRBs-ToBeSetup-ItemIEs',
        'DRBs-ToBeSetup-ItemIEs',
        'BHChannels-ToBeSetup-ItemIEs',
        'SLDRBs-ToBeSetup-ItemIEs',
        'UE-MulticastMRBs-ToBeSetup-ItemIEs',
        'ServingCellMO-List-ItemIEs',
        'UEContextSetupResponse',
        'UEContextSetupResponseIEs',
        'DRBs-Setup-List',
        'SRBs-FailedToBeSetup-List',
        'DRBs-FailedToBeSetup-List',
        'SCell-FailedtoSetup-List',
        'SRBs-Setup-List',
        'BHChannels-Setup-List',
        'BHChannels-FailedToBeSetup-List',
        'DRBs-Setup-ItemIEs',
        'SRBs-Setup-ItemIEs',
        'SRBs-FailedToBeSetup-ItemIEs',
        'DRBs-FailedToBeSetup-ItemIEs',
        'SCell-FailedtoSetup-ItemIEs',
        'BHChannels-Setup-ItemIEs',
        'BHChannels-FailedToBeSetup-ItemIEs',
        'SLDRBs-Setup-List',
        'SLDRBs-FailedToBeSetup-List',
        'SLDRBs-Setup-ItemIEs',
        'SLDRBs-FailedToBeSetup-ItemIEs',
        'UEContextSetupFailure',
        'UEContextSetupFailureIEs',
        'Potential-SpCell-List',
        'Potential-SpCell-ItemIEs',
        'UEContextReleaseRequest',
        'UEContextReleaseRequestIEs',
        'UEContextReleaseCommand',
        'UEContextReleaseCommandIEs',
        'UEContextReleaseComplete',
        'UEContextReleaseCompleteIEs',
        'UEContextModificationRequest',
        'UEContextModificationRequestIEs',
        'SCell-ToBeSetupMod-List',
        'SCell-ToBeRemoved-List',
        'SRBs-ToBeSetupMod-List',
        'DRBs-ToBeSetupMod-List',
        'BHChannels-ToBeSetupMod-List',
        'DRBs-ToBeModified-List',
        'BHChannels-ToBeModified-List',
        'SRBs-ToBeReleased-List',
        'DRBs-ToBeReleased-List',
        'BHChannels-ToBeReleased-List',
        'UE-MulticastMRBs-ToBeSetup-atModify-List',
        'UE-MulticastMRBs-ToBeReleased-List',
        'SCell-ToBeSetupMod-ItemIEs',
        'SCell-ToBeRemoved-ItemIEs',
        'SRBs-ToBeSetupMod-ItemIEs',
        'DRBs-ToBeSetupMod-ItemIEs',
        'DRBs-ToBeModified-ItemIEs',
        'SRBs-ToBeReleased-ItemIEs',
        'DRBs-ToBeReleased-ItemIEs',
        'BHChannels-ToBeSetupMod-ItemIEs',
        'BHChannels-ToBeModified-ItemIEs',
        'BHChannels-ToBeReleased-ItemIEs',
        'SLDRBs-ToBeSetupMod-List',
        'SLDRBs-ToBeModified-List',
        'SLDRBs-ToBeReleased-List',
        'SLDRBs-ToBeSetupMod-ItemIEs',
        'SLDRBs-ToBeModified-ItemIEs',
        'SLDRBs-ToBeReleased-ItemIEs',
        'UE-MulticastMRBs-ToBeSetup-atModify-ItemIEs',
        'UE-MulticastMRBs-ToBeReleased-ItemIEs',
        'UEContextModificationResponse',
        'UEContextModificationResponseIEs',
        'DRBs-SetupMod-List',
        'DRBs-Modified-List',
        'SRBs-SetupMod-List',
        'SRBs-Modified-List',
        'DRBs-FailedToBeModified-List',
        'SRBs-FailedToBeSetupMod-List',
        'DRBs-FailedToBeSetupMod-List',
        'SCell-FailedtoSetupMod-List',
        'BHChannels-SetupMod-List',
        'BHChannels-Modified-List',
        'BHChannels-FailedToBeModified-List',
        'BHChannels-FailedToBeSetupMod-List',
        'Associated-SCell-List',
        'DRBs-SetupMod-ItemIEs',
        'DRBs-Modified-ItemIEs',
        'SRBs-SetupMod-ItemIEs',
        'SRBs-Modified-ItemIEs',
        'SRBs-FailedToBeSetupMod-ItemIEs',
        'DRBs-FailedToBeSetupMod-ItemIEs',
        'DRBs-FailedToBeModified-ItemIEs',
        'SCell-FailedtoSetupMod-ItemIEs',
        'Associated-SCell-ItemIEs',
        'BHChannels-SetupMod-ItemIEs',
        'BHChannels-Modified-ItemIEs',
        'BHChannels-FailedToBeSetupMod-ItemIEs',
        'BHChannels-FailedToBeModified-ItemIEs',
        'SLDRBs-SetupMod-List',
        'SLDRBs-Modified-List',
        'SLDRBs-FailedToBeModified-List',
        'SLDRBs-FailedToBeSetupMod-List',
        'SLDRBs-SetupMod-ItemIEs',
        'SLDRBs-Modified-ItemIEs',
        'SLDRBs-FailedToBeSetupMod-ItemIEs',
        'SLDRBs-FailedToBeModified-ItemIEs',
        'UE-MulticastMRBs-Setup-List',
        'UE-MulticastMRBs-Setup-ItemIEs',
        'UEContextModificationFailure',
        'UEContextModificationFailureIEs',
        'UEContextModificationRequired',
        'UEContextModificationRequiredIEs',
        'DRBs-Required-ToBeModified-List',
        'DRBs-Required-ToBeReleased-List',
        'SRBs-Required-ToBeReleased-List',
        'BHChannels-Required-ToBeReleased-List',
        'DRBs-Required-ToBeModified-ItemIEs',
        'DRBs-Required-ToBeReleased-ItemIEs',
        'SRBs-Required-ToBeReleased-ItemIEs',
        'BHChannels-Required-ToBeReleased-ItemIEs',
        'SLDRBs-Required-ToBeModified-List',
        'SLDRBs-Required-ToBeReleased-List',
        'SLDRBs-Required-ToBeModified-ItemIEs',
        'SLDRBs-Required-ToBeReleased-ItemIEs',
        'UE-MulticastMRBs-RequiredToBeModified-List',
        'UE-MulticastMRBs-RequiredToBeModified-ItemIEs',
        'UE-MulticastMRBs-RequiredToBeReleased-List',
        'UE-MulticastMRBs-RequiredToBeReleased-ItemIEs',
        'UEContextModificationConfirm',
        'UEContextModificationConfirmIEs',
        'DRBs-ModifiedConf-List',
        'DRBs-ModifiedConf-ItemIEs',
        'SLDRBs-ModifiedConf-List',
        'SLDRBs-ModifiedConf-ItemIEs',
        'UE-MulticastMRBs-ConfirmedToBeModified-List',
        'UE-MulticastMRBs-ConfirmedToBeModified-ItemIEs',
        'UEContextModificationRefuse',
        'UEContextModificationRefuseIEs',
        'WriteReplaceWarningRequest',
        'WriteReplaceWarningRequestIEs',
        'Cells-To-Be-Broadcast-List',
        'Cells-To-Be-Broadcast-List-ItemIEs',
        'WriteReplaceWarningResponse',
        'WriteReplaceWarningResponseIEs',
        'Cells-Broadcast-Completed-List',
        'Cells-Broadcast-Completed-List-ItemIEs',
        'PWSCancelRequest',
        'PWSCancelRequestIEs',
        'Broadcast-To-Be-Cancelled-List',
        'Broadcast-To-Be-Cancelled-List-ItemIEs',
        'PWSCancelResponse',
        'PWSCancelResponseIEs',
        'Cells-Broadcast-Cancelled-List',
        'Cells-Broadcast-Cancelled-List-ItemIEs',
        'UEInactivityNotification',
        'UEInactivityNotificationIEs',
        'DRB-Activity-List',
        'DRB-Activity-ItemIEs',
        'InitialULRRCMessageTransfer',
        'InitialULRRCMessageTransferIEs',
        'DLRRCMessageTransfer',
        'DLRRCMessageTransferIEs',
        'ULRRCMessageTransfer',
        'ULRRCMessageTransferIEs',
        'PrivateMessage',
        'PrivateMessage-IEs',
        'SystemInformationDeliveryCommand',
        'SystemInformationDeliveryCommandIEs',
        'Paging',
        'PagingIEs',
        'PagingCell-list',
        'PagingCell-ItemIEs',
        'Notify',
        'NotifyIEs',
        'DRB-Notify-List',
        'DRB-Notify-ItemIEs',
        'NetworkAccessRateReduction',
        'NetworkAccessRateReductionIEs',
        'PWSRestartIndication',
        'PWSRestartIndicationIEs',
        'NR-CGI-List-For-Restart-List',
        'NR-CGI-List-For-Restart-List-ItemIEs',
        'PWSFailureIndication',
        'PWSFailureIndicationIEs',
        'PWS-Failed-NR-CGI-List',
        'PWS-Failed-NR-CGI-List-ItemIEs',
        'GNBDUStatusIndication',
        'GNBDUStatusIndicationIEs',
        'RRCDeliveryReport',
        'RRCDeliveryReportIEs',
        'F1RemovalRequest',
        'F1RemovalRequestIEs',
        'F1RemovalResponse',
        'F1RemovalResponseIEs',
        'F1RemovalFailure',
        'F1RemovalFailureIEs',
        'TraceStart',
        'TraceStartIEs',
        'DeactivateTrace',
        'DeactivateTraceIEs',
        'CellTrafficTrace',
        'CellTrafficTraceIEs',
        'DUCURadioInformationTransfer',
        'DUCURadioInformationTransferIEs',
        'CUDURadioInformationTransfer',
        'CUDURadioInformationTransferIEs',
        'BAPMappingConfiguration',
        'BAPMappingConfiguration-IEs',
        'BH-Routing-Information-Added-List',
        'BH-Routing-Information-Removed-List',
        'BH-Routing-Information-Added-List-ItemIEs',
        'BH-Routing-Information-Removed-List-ItemIEs',
        'BAP-Header-Rewriting-Added-List',
        'BAP-Header-Rewriting-Added-List-ItemIEs',
        'BAP-Header-Rewriting-Removed-List',
        'BAP-Header-Rewriting-Removed-List-ItemIEs',
        'BAPMappingConfigurationAcknowledge',
        'BAPMappingConfigurationAcknowledge-IEs',
        'BAPMappingConfigurationFailure',
        'BAPMappingConfigurationFailureIEs',
        'GNBDUResourceConfiguration',
        'GNBDUResourceConfigurationIEs',
        'GNBDUResourceConfigurationAcknowledge',
        'GNBDUResourceConfigurationAcknowledgeIEs',
        'GNBDUResourceConfigurationFailure',
        'GNBDUResourceConfigurationFailureIEs',
        'IABTNLAddressRequest',
        'IABTNLAddressRequestIEs',
        'IAB-TNL-Addresses-To-Remove-List',
        'IAB-TNL-Addresses-To-Remove-ItemIEs',
        'IABTNLAddressResponse',
        'IABTNLAddressResponseIEs',
        'IAB-Allocated-TNL-Address-List',
        'IAB-Allocated-TNL-Address-List-ItemIEs',
        'IABTNLAddressFailure',
        'IABTNLAddressFailureIEs',
        'IABUPConfigurationUpdateRequest',
        'IABUPConfigurationUpdateRequestIEs',
        'UL-UP-TNL-Information-to-Update-List',
        'UL-UP-TNL-Information-to-Update-List-ItemIEs',
        'UL-UP-TNL-Address-to-Update-List',
        'UL-UP-TNL-Address-to-Update-List-ItemIEs',
        'IABUPConfigurationUpdateResponse',
        'IABUPConfigurationUpdateResponseIEs',
        'DL-UP-TNL-Address-to-Update-List',
        'DL-UP-TNL-Address-to-Update-List-ItemIEs',
        'IABUPConfigurationUpdateFailure',
        'IABUPConfigurationUpdateFailureIEs',
        'ResourceStatusRequest',
        'ResourceStatusRequestIEs',
        'ResourceStatusResponse',
        'ResourceStatusResponseIEs',
        'ResourceStatusFailure',
        'ResourceStatusFailureIEs',
        'ResourceStatusUpdate',
        'ResourceStatusUpdateIEs',
        'AccessAndMobilityIndication',
        'AccessAndMobilityIndicationIEs',
        'ReferenceTimeInformationReportingControl',
        'ReferenceTimeInformationReportingControlIEs',
        'ReferenceTimeInformationReport',
        'ReferenceTimeInformationReportIEs',
        'AccessSuccess',
        'AccessSuccessIEs',
        'PositioningAssistanceInformationControl',
        'PositioningAssistanceInformationControlIEs',
        'PositioningAssistanceInformationFeedback',
        'PositioningAssistanceInformationFeedbackIEs',
        'PositioningMeasurementRequest',
        'PositioningMeasurementRequestIEs',
        'PositioningMeasurementResponse',
        'PositioningMeasurementResponseIEs',
        'PositioningMeasurementFailure',
        'PositioningMeasurementFailureIEs',
        'PositioningMeasurementReport',
        'PositioningMeasurementReportIEs',
        'PositioningMeasurementAbort',
        'PositioningMeasurementAbortIEs',
        'PositioningMeasurementFailureIndication',
        'PositioningMeasurementFailureIndicationIEs',
        'PositioningMeasurementUpdate',
        'PositioningMeasurementUpdateIEs',
        'TRPInformationRequest',
        'TRPInformationRequestIEs',
        'TRPInformationTypeListTRPReq',
        'TRPInformationTypeItemTRPReq',
        'TRPInformationResponse',
        'TRPInformationResponseIEs',
        'TRPInformationListTRPResp',
        'TRPInformationItemTRPResp',
        'TRPInformationFailure',
        'TRPInformationFailureIEs',
        'PositioningInformationRequest',
        'PositioningInformationRequestIEs',
        'PositioningInformationResponse',
        'PositioningInformationResponseIEs',
        'PositioningInformationFailure',
        'PositioningInformationFailureIEs',
        'PositioningActivationRequest',
        'PositioningActivationRequestIEs',
        'SRSType',
        'SRSType-ExtIEs',
        'SemipersistentSRS',
        'SemipersistentSRS-ExtIEs',
        'AperiodicSRS',
        'AperiodicSRS-ExtIEs',
        'PositioningActivationResponse',
        'PositioningActivationResponseIEs',
        'PositioningActivationFailure',
        'PositioningActivationFailureIEs',
        'PositioningDeactivation',
        'PositioningDeactivationIEs',
        'PositioningInformationUpdate',
        'PositioningInformationUpdateIEs',
        'E-CIDMeasurementInitiationRequest',
        'E-CIDMeasurementInitiationRequest-IEs',
        'E-CIDMeasurementInitiationResponse',
        'E-CIDMeasurementInitiationResponse-IEs',
        'E-CIDMeasurementInitiationFailure',
        'E-CIDMeasurementInitiationFailure-IEs',
        'E-CIDMeasurementFailureIndication',
        'E-CIDMeasurementFailureIndication-IEs',
        'E-CIDMeasurementReport',
        'E-CIDMeasurementReport-IEs',
        'E-CIDMeasurementTerminationCommand',
        'E-CIDMeasurementTerminationCommand-IEs',
        'BroadcastContextSetupRequest',
        'BroadcastContextSetupRequestIEs',
        'BroadcastMRBs-ToBeSetup-List',
        'BroadcastMRBs-ToBeSetup-ItemIEs',
        'BroadcastContextSetupResponse',
        'BroadcastContextSetupResponseIEs',
        'BroadcastMRBs-Setup-List',
        'BroadcastMRBs-FailedToBeSetup-List',
        'BroadcastMRBs-Setup-ItemIEs',
        'BroadcastMRBs-FailedToBeSetup-ItemIEs',
        'BroadcastContextSetupFailure',
        'BroadcastContextSetupFailureIEs',
        'BroadcastContextReleaseCommand',
        'BroadcastContextReleaseCommandIEs',
        'BroadcastContextReleaseComplete',
        'BroadcastContextReleaseCompleteIEs',
        'BroadcastContextReleaseRequest',
        'BroadcastContextReleaseRequestIEs',
        'BroadcastContextModificationRequest',
        'BroadcastContextModificationRequestIEs',
        'BroadcastMRBs-ToBeSetupMod-List',
        'BroadcastMRBs-ToBeModified-List',
        'BroadcastMRBs-ToBeReleased-List',
        'BroadcastMRBs-ToBeSetupMod-ItemIEs',
        'BroadcastMRBs-ToBeModified-ItemIEs',
        'BroadcastMRBs-ToBeReleased-ItemIEs',
        'BroadcastContextModificationResponse',
        'BroadcastContextModificationResponseIEs',
        'BroadcastMRBs-SetupMod-List',
        'BroadcastMRBs-FailedToBeSetupMod-List',
        'BroadcastMRBs-Modified-List',
        'BroadcastMRBs-FailedToBeModified-List',
        'BroadcastMRBs-SetupMod-ItemIEs',
        'BroadcastMRBs-FailedToBeSetupMod-ItemIEs',
        'BroadcastMRBs-Modified-ItemIEs',
        'BroadcastMRBs-FailedToBeModified-ItemIEs',
        'BroadcastContextModificationFailure',
        'BroadcastContextModificationFailureIEs',
        'MulticastGroupPaging',
        'MulticastGroupPagingIEs',
        'UEIdentity-List-For-Paging-List',
        'UEIdentity-List-For-Paging-ItemIEs',
        'MC-PagingCell-list',
        'MC-PagingCell-ItemIEs',
        'MulticastContextSetupRequest',
        'MulticastContextSetupRequestIEs',
        'MulticastMRBs-ToBeSetup-List',
        'MulticastMRBs-ToBeSetup-ItemIEs',
        'MulticastContextSetupResponse',
        'MulticastContextSetupResponseIEs',
        'MulticastMRBs-Setup-List',
        'MulticastMRBs-FailedToBeSetup-List',
        'MulticastMRBs-Setup-ItemIEs',
        'MulticastMRBs-FailedToBeSetup-ItemIEs',
        'MulticastContextSetupFailure',
        'MulticastContextSetupFailureIEs',
        'MulticastContextReleaseCommand',
        'MulticastContextReleaseCommandIEs',
        'MulticastContextReleaseComplete',
        'MulticastContextReleaseCompleteIEs',
        'MulticastContextReleaseRequest',
        'MulticastContextReleaseRequestIEs',
        'MulticastContextModificationRequest',
        'MulticastContextModificationRequestIEs',
        'MulticastMRBs-ToBeSetupMod-List',
        'MulticastMRBs-ToBeSetupMod-ItemIEs',
        'MulticastMRBs-ToBeModified-List',
        'MulticastMRBs-ToBeModified-ItemIEs',
        'MulticastMRBs-ToBeReleased-List',
        'MulticastMRBs-ToBeReleased-ItemIEs',
        'MulticastContextModificationResponse',
        'MulticastContextModificationResponseIEs',
        'MulticastMRBs-SetupMod-List',
        'MulticastMRBs-SetupMod-ItemIEs',
        'MulticastMRBs-FailedToBeSetupMod-List',
        'MulticastMRBs-FailedToBeSetupMod-ItemIEs',
        'MulticastMRBs-Modified-List',
        'MulticastMRBs-Modified-ItemIEs',
        'MulticastMRBs-FailedToBeModified-List',
        'MulticastMRBs-FailedToBeModified-ItemIEs',
        'MulticastContextModificationFailure',
        'MulticastContextModificationFailureIEs',
        'MulticastDistributionSetupRequest',
        'MulticastDistributionSetupRequestIEs',
        'MulticastF1UContext-ToBeSetup-List',
        'MulticastF1UContext-ToBeSetup-ItemIEs',
        'MulticastDistributionSetupResponse',
        'MulticastDistributionSetupResponseIEs',
        'MulticastF1UContext-Setup-List',
        'MulticastF1UContext-Setup-ItemIEs',
        'MulticastF1UContext-FailedToBeSetup-List',
        'MulticastF1UContext-FailedToBeSetup-ItemIEs',
        'MulticastDistributionSetupFailure',
        'MulticastDistributionSetupFailureIEs',
        'MulticastDistributionReleaseCommand',
        'MulticastDistributionReleaseCommandIEs',
        'MulticastDistributionReleaseComplete',
        'MulticastDistributionReleaseCompleteIEs',
        'PDCMeasurementInitiationRequest',
        'PDCMeasurementInitiationRequest-IEs',
        'PDCMeasurementInitiationResponse',
        'PDCMeasurementInitiationResponse-IEs',
        'PDCMeasurementInitiationFailure',
        'PDCMeasurementInitiationFailure-IEs',
        'PDCMeasurementReport',
        'PDCMeasurementReport-IEs',
        'PDCMeasurementTerminationCommand',
        'PDCMeasurementTerminationCommand-IEs',
        'PDCMeasurementFailureIndication',
        'PDCMeasurementFailureIndication-IEs',
        'PRSConfigurationRequest',
        'PRSConfigurationRequest-IEs',
        'PRSConfigurationResponse',
        'PRSConfigurationResponse-IEs',
        'PRSConfigurationFailure',
        'PRSConfigurationFailure-IEs',
        'MeasurementPreconfigurationRequired',
        'MeasurementPreconfigurationRequired-IEs',
        'MeasurementPreconfigurationConfirm',
        'MeasurementPreconfigurationConfirm-IEs',
        'MeasurementPreconfigurationRefuse',
        'MeasurementPreconfigurationRefuse-IEs',
        'MeasurementActivation',
        'MeasurementActivation-IEs',
        'QoEInformationTransfer',
        'QoEInformationTransfer-IEs',
        'PosSystemInformationDeliveryCommand',
        'PosSystemInformationDeliveryCommandIEs',
        ]
    _type_ = [
        'Reset',
        'ResetType',
        'ResetAll',
        'UE-associatedLogicalF1-ConnectionListRes',
        'ResetAcknowledge',
        'UE-associatedLogicalF1-ConnectionListResAck',
        'ErrorIndication',
        'F1SetupRequest',
        'GNB-DU-Served-Cells-List',
        'F1SetupResponse',
        'Cells-to-be-Activated-List',
        'F1SetupFailure',
        'GNBDUConfigurationUpdate',
        'Served-Cells-To-Add-List',
        'Served-Cells-To-Modify-List',
        'Served-Cells-To-Delete-List',
        'Cells-Status-List',
        'Dedicated-SIDelivery-NeededUE-List',
        'GNB-DU-TNL-Association-To-Remove-List',
        'GNBDUConfigurationUpdateAcknowledge',
        'GNBDUConfigurationUpdateFailure',
        'GNBCUConfigurationUpdate',
        'Cells-to-be-Deactivated-List',
        'GNB-CU-TNL-Association-To-Add-List',
        'GNB-CU-TNL-Association-To-Remove-List',
        'GNB-CU-TNL-Association-To-Update-List',
        'Cells-to-be-Barred-List',
        'Protected-EUTRA-Resources-List',
        'Neighbour-Cell-Information-List',
        'GNBCUConfigurationUpdateAcknowledge',
        'Cells-Failed-to-be-Activated-List',
        'GNB-CU-TNL-Association-Setup-List',
        'GNB-CU-TNL-Association-Failed-To-Setup-List',
        'GNBCUConfigurationUpdateFailure',
        'GNBDUResourceCoordinationRequest',
        'GNBDUResourceCoordinationResponse',
        'UEContextSetupRequest',
        'Candidate-SpCell-List',
        'SCell-ToBeSetup-List',
        'SRBs-ToBeSetup-List',
        'DRBs-ToBeSetup-List',
        'BHChannels-ToBeSetup-List',
        'SLDRBs-ToBeSetup-List',
        'UE-MulticastMRBs-ToBeSetup-List',
        'ServingCellMO-List',
        'UEContextSetupResponse',
        'DRBs-Setup-List',
        'SRBs-FailedToBeSetup-List',
        'DRBs-FailedToBeSetup-List',
        'SCell-FailedtoSetup-List',
        'SRBs-Setup-List',
        'BHChannels-Setup-List',
        'BHChannels-FailedToBeSetup-List',
        'SLDRBs-Setup-List',
        'SLDRBs-FailedToBeSetup-List',
        'UEContextSetupFailure',
        'Potential-SpCell-List',
        'UEContextReleaseRequest',
        'UEContextReleaseCommand',
        'UEContextReleaseComplete',
        'UEContextModificationRequest',
        'SCell-ToBeSetupMod-List',
        'SCell-ToBeRemoved-List',
        'SRBs-ToBeSetupMod-List',
        'DRBs-ToBeSetupMod-List',
        'BHChannels-ToBeSetupMod-List',
        'DRBs-ToBeModified-List',
        'BHChannels-ToBeModified-List',
        'SRBs-ToBeReleased-List',
        'DRBs-ToBeReleased-List',
        'BHChannels-ToBeReleased-List',
        'UE-MulticastMRBs-ToBeSetup-atModify-List',
        'UE-MulticastMRBs-ToBeReleased-List',
        'SLDRBs-ToBeSetupMod-List',
        'SLDRBs-ToBeModified-List',
        'SLDRBs-ToBeReleased-List',
        'UEContextModificationResponse',
        'DRBs-SetupMod-List',
        'DRBs-Modified-List',
        'SRBs-SetupMod-List',
        'SRBs-Modified-List',
        'DRBs-FailedToBeModified-List',
        'SRBs-FailedToBeSetupMod-List',
        'DRBs-FailedToBeSetupMod-List',
        'SCell-FailedtoSetupMod-List',
        'BHChannels-SetupMod-List',
        'BHChannels-Modified-List',
        'BHChannels-FailedToBeModified-List',
        'BHChannels-FailedToBeSetupMod-List',
        'Associated-SCell-List',
        'SLDRBs-SetupMod-List',
        'SLDRBs-Modified-List',
        'SLDRBs-FailedToBeModified-List',
        'SLDRBs-FailedToBeSetupMod-List',
        'UE-MulticastMRBs-Setup-List',
        'UEContextModificationFailure',
        'UEContextModificationRequired',
        'DRBs-Required-ToBeModified-List',
        'DRBs-Required-ToBeReleased-List',
        'SRBs-Required-ToBeReleased-List',
        'BHChannels-Required-ToBeReleased-List',
        'SLDRBs-Required-ToBeModified-List',
        'SLDRBs-Required-ToBeReleased-List',
        'UE-MulticastMRBs-RequiredToBeModified-List',
        'UE-MulticastMRBs-RequiredToBeReleased-List',
        'UEContextModificationConfirm',
        'DRBs-ModifiedConf-List',
        'SLDRBs-ModifiedConf-List',
        'UE-MulticastMRBs-ConfirmedToBeModified-List',
        'UEContextModificationRefuse',
        'WriteReplaceWarningRequest',
        'Cells-To-Be-Broadcast-List',
        'WriteReplaceWarningResponse',
        'Cells-Broadcast-Completed-List',
        'PWSCancelRequest',
        'Broadcast-To-Be-Cancelled-List',
        'PWSCancelResponse',
        'Cells-Broadcast-Cancelled-List',
        'UEInactivityNotification',
        'DRB-Activity-List',
        'InitialULRRCMessageTransfer',
        'DLRRCMessageTransfer',
        'ULRRCMessageTransfer',
        'PrivateMessage',
        'SystemInformationDeliveryCommand',
        'Paging',
        'PagingCell-list',
        'Notify',
        'DRB-Notify-List',
        'NetworkAccessRateReduction',
        'PWSRestartIndication',
        'NR-CGI-List-For-Restart-List',
        'PWSFailureIndication',
        'PWS-Failed-NR-CGI-List',
        'GNBDUStatusIndication',
        'RRCDeliveryReport',
        'F1RemovalRequest',
        'F1RemovalResponse',
        'F1RemovalFailure',
        'TraceStart',
        'DeactivateTrace',
        'CellTrafficTrace',
        'DUCURadioInformationTransfer',
        'CUDURadioInformationTransfer',
        'BAPMappingConfiguration',
        'BH-Routing-Information-Added-List',
        'BH-Routing-Information-Removed-List',
        'BAP-Header-Rewriting-Added-List',
        'BAP-Header-Rewriting-Removed-List',
        'BAPMappingConfigurationAcknowledge',
        'BAPMappingConfigurationFailure',
        'GNBDUResourceConfiguration',
        'GNBDUResourceConfigurationAcknowledge',
        'GNBDUResourceConfigurationFailure',
        'IABTNLAddressRequest',
        'IAB-TNL-Addresses-To-Remove-List',
        'IABTNLAddressResponse',
        'IAB-Allocated-TNL-Address-List',
        'IABTNLAddressFailure',
        'IABUPConfigurationUpdateRequest',
        'UL-UP-TNL-Information-to-Update-List',
        'UL-UP-TNL-Address-to-Update-List',
        'IABUPConfigurationUpdateResponse',
        'DL-UP-TNL-Address-to-Update-List',
        'IABUPConfigurationUpdateFailure',
        'ResourceStatusRequest',
        'ResourceStatusResponse',
        'ResourceStatusFailure',
        'ResourceStatusUpdate',
        'AccessAndMobilityIndication',
        'ReferenceTimeInformationReportingControl',
        'ReferenceTimeInformationReport',
        'AccessSuccess',
        'PositioningAssistanceInformationControl',
        'PositioningAssistanceInformationFeedback',
        'PositioningMeasurementRequest',
        'PositioningMeasurementResponse',
        'PositioningMeasurementFailure',
        'PositioningMeasurementReport',
        'PositioningMeasurementAbort',
        'PositioningMeasurementFailureIndication',
        'PositioningMeasurementUpdate',
        'TRPInformationRequest',
        'TRPInformationTypeListTRPReq',
        'TRPInformationResponse',
        'TRPInformationListTRPResp',
        'TRPInformationFailure',
        'PositioningInformationRequest',
        'PositioningInformationResponse',
        'PositioningInformationFailure',
        'PositioningActivationRequest',
        'SRSType',
        'SemipersistentSRS',
        'AperiodicSRS',
        'PositioningActivationResponse',
        'PositioningActivationFailure',
        'PositioningDeactivation',
        'PositioningInformationUpdate',
        'E-CIDMeasurementInitiationRequest',
        'E-CIDMeasurementInitiationResponse',
        'E-CIDMeasurementInitiationFailure',
        'E-CIDMeasurementFailureIndication',
        'E-CIDMeasurementReport',
        'E-CIDMeasurementTerminationCommand',
        'BroadcastContextSetupRequest',
        'BroadcastMRBs-ToBeSetup-List',
        'BroadcastContextSetupResponse',
        'BroadcastMRBs-Setup-List',
        'BroadcastMRBs-FailedToBeSetup-List',
        'BroadcastContextSetupFailure',
        'BroadcastContextReleaseCommand',
        'BroadcastContextReleaseComplete',
        'BroadcastContextReleaseRequest',
        'BroadcastContextModificationRequest',
        'BroadcastMRBs-ToBeSetupMod-List',
        'BroadcastMRBs-ToBeModified-List',
        'BroadcastMRBs-ToBeReleased-List',
        'BroadcastContextModificationResponse',
        'BroadcastMRBs-SetupMod-List',
        'BroadcastMRBs-FailedToBeSetupMod-List',
        'BroadcastMRBs-Modified-List',
        'BroadcastMRBs-FailedToBeModified-List',
        'BroadcastContextModificationFailure',
        'MulticastGroupPaging',
        'UEIdentity-List-For-Paging-List',
        'MC-PagingCell-list',
        'MulticastContextSetupRequest',
        'MulticastMRBs-ToBeSetup-List',
        'MulticastContextSetupResponse',
        'MulticastMRBs-Setup-List',
        'MulticastMRBs-FailedToBeSetup-List',
        'MulticastContextSetupFailure',
        'MulticastContextReleaseCommand',
        'MulticastContextReleaseComplete',
        'MulticastContextReleaseRequest',
        'MulticastContextModificationRequest',
        'MulticastMRBs-ToBeSetupMod-List',
        'MulticastMRBs-ToBeModified-List',
        'MulticastMRBs-ToBeReleased-List',
        'MulticastContextModificationResponse',
        'MulticastMRBs-SetupMod-List',
        'MulticastMRBs-FailedToBeSetupMod-List',
        'MulticastMRBs-Modified-List',
        'MulticastMRBs-FailedToBeModified-List',
        'MulticastContextModificationFailure',
        'MulticastDistributionSetupRequest',
        'MulticastF1UContext-ToBeSetup-List',
        'MulticastDistributionSetupResponse',
        'MulticastF1UContext-Setup-List',
        'MulticastF1UContext-FailedToBeSetup-List',
        'MulticastDistributionSetupFailure',
        'MulticastDistributionReleaseCommand',
        'MulticastDistributionReleaseComplete',
        'PDCMeasurementInitiationRequest',
        'PDCMeasurementInitiationResponse',
        'PDCMeasurementInitiationFailure',
        'PDCMeasurementReport',
        'PDCMeasurementTerminationCommand',
        'PDCMeasurementFailureIndication',
        'PRSConfigurationRequest',
        'PRSConfigurationResponse',
        'PRSConfigurationFailure',
        'MeasurementPreconfigurationRequired',
        'MeasurementPreconfigurationConfirm',
        'MeasurementPreconfigurationRefuse',
        'MeasurementActivation',
        'QoEInformationTransfer',
        'PosSystemInformationDeliveryCommand',
        ]
    _set_ = [
        'ResetIEs',
        'ResetType-ExtIEs',
        'UE-associatedLogicalF1-ConnectionItemRes',
        'ResetAcknowledgeIEs',
        'UE-associatedLogicalF1-ConnectionItemResAck',
        'ErrorIndicationIEs',
        'F1SetupRequestIEs',
        'GNB-DU-Served-Cells-ItemIEs',
        'F1SetupResponseIEs',
        'Cells-to-be-Activated-List-ItemIEs',
        'F1SetupFailureIEs',
        'GNBDUConfigurationUpdateIEs',
        'Served-Cells-To-Add-ItemIEs',
        'Served-Cells-To-Modify-ItemIEs',
        'Served-Cells-To-Delete-ItemIEs',
        'Cells-Status-ItemIEs',
        'Dedicated-SIDelivery-NeededUE-ItemIEs',
        'GNB-DU-TNL-Association-To-Remove-ItemIEs',
        'GNBDUConfigurationUpdateAcknowledgeIEs',
        'GNBDUConfigurationUpdateFailureIEs',
        'GNBCUConfigurationUpdateIEs',
        'Cells-to-be-Deactivated-List-ItemIEs',
        'GNB-CU-TNL-Association-To-Add-ItemIEs',
        'GNB-CU-TNL-Association-To-Remove-ItemIEs',
        'GNB-CU-TNL-Association-To-Update-ItemIEs',
        'Cells-to-be-Barred-ItemIEs',
        'Protected-EUTRA-Resources-ItemIEs',
        'Neighbour-Cell-Information-ItemIEs',
        'GNBCUConfigurationUpdateAcknowledgeIEs',
        'Cells-Failed-to-be-Activated-List-ItemIEs',
        'GNB-CU-TNL-Association-Setup-ItemIEs',
        'GNB-CU-TNL-Association-Failed-To-Setup-ItemIEs',
        'GNBCUConfigurationUpdateFailureIEs',
        'GNBDUResourceCoordinationRequest-IEs',
        'GNBDUResourceCoordinationResponse-IEs',
        'UEContextSetupRequestIEs',
        'Candidate-SpCell-ItemIEs',
        'SCell-ToBeSetup-ItemIEs',
        'SRBs-ToBeSetup-ItemIEs',
        'DRBs-ToBeSetup-ItemIEs',
        'BHChannels-ToBeSetup-ItemIEs',
        'SLDRBs-ToBeSetup-ItemIEs',
        'UE-MulticastMRBs-ToBeSetup-ItemIEs',
        'ServingCellMO-List-ItemIEs',
        'UEContextSetupResponseIEs',
        'DRBs-Setup-ItemIEs',
        'SRBs-Setup-ItemIEs',
        'SRBs-FailedToBeSetup-ItemIEs',
        'DRBs-FailedToBeSetup-ItemIEs',
        'SCell-FailedtoSetup-ItemIEs',
        'BHChannels-Setup-ItemIEs',
        'BHChannels-FailedToBeSetup-ItemIEs',
        'SLDRBs-Setup-ItemIEs',
        'SLDRBs-FailedToBeSetup-ItemIEs',
        'UEContextSetupFailureIEs',
        'Potential-SpCell-ItemIEs',
        'UEContextReleaseRequestIEs',
        'UEContextReleaseCommandIEs',
        'UEContextReleaseCompleteIEs',
        'UEContextModificationRequestIEs',
        'SCell-ToBeSetupMod-ItemIEs',
        'SCell-ToBeRemoved-ItemIEs',
        'SRBs-ToBeSetupMod-ItemIEs',
        'DRBs-ToBeSetupMod-ItemIEs',
        'DRBs-ToBeModified-ItemIEs',
        'SRBs-ToBeReleased-ItemIEs',
        'DRBs-ToBeReleased-ItemIEs',
        'BHChannels-ToBeSetupMod-ItemIEs',
        'BHChannels-ToBeModified-ItemIEs',
        'BHChannels-ToBeReleased-ItemIEs',
        'SLDRBs-ToBeSetupMod-ItemIEs',
        'SLDRBs-ToBeModified-ItemIEs',
        'SLDRBs-ToBeReleased-ItemIEs',
        'UE-MulticastMRBs-ToBeSetup-atModify-ItemIEs',
        'UE-MulticastMRBs-ToBeReleased-ItemIEs',
        'UEContextModificationResponseIEs',
        'DRBs-SetupMod-ItemIEs',
        'DRBs-Modified-ItemIEs',
        'SRBs-SetupMod-ItemIEs',
        'SRBs-Modified-ItemIEs',
        'SRBs-FailedToBeSetupMod-ItemIEs',
        'DRBs-FailedToBeSetupMod-ItemIEs',
        'DRBs-FailedToBeModified-ItemIEs',
        'SCell-FailedtoSetupMod-ItemIEs',
        'Associated-SCell-ItemIEs',
        'BHChannels-SetupMod-ItemIEs',
        'BHChannels-Modified-ItemIEs',
        'BHChannels-FailedToBeSetupMod-ItemIEs',
        'BHChannels-FailedToBeModified-ItemIEs',
        'SLDRBs-SetupMod-ItemIEs',
        'SLDRBs-Modified-ItemIEs',
        'SLDRBs-FailedToBeSetupMod-ItemIEs',
        'SLDRBs-FailedToBeModified-ItemIEs',
        'UE-MulticastMRBs-Setup-ItemIEs',
        'UEContextModificationFailureIEs',
        'UEContextModificationRequiredIEs',
        'DRBs-Required-ToBeModified-ItemIEs',
        'DRBs-Required-ToBeReleased-ItemIEs',
        'SRBs-Required-ToBeReleased-ItemIEs',
        'BHChannels-Required-ToBeReleased-ItemIEs',
        'SLDRBs-Required-ToBeModified-ItemIEs',
        'SLDRBs-Required-ToBeReleased-ItemIEs',
        'UE-MulticastMRBs-RequiredToBeModified-ItemIEs',
        'UE-MulticastMRBs-RequiredToBeReleased-ItemIEs',
        'UEContextModificationConfirmIEs',
        'DRBs-ModifiedConf-ItemIEs',
        'SLDRBs-ModifiedConf-ItemIEs',
        'UE-MulticastMRBs-ConfirmedToBeModified-ItemIEs',
        'UEContextModificationRefuseIEs',
        'WriteReplaceWarningRequestIEs',
        'Cells-To-Be-Broadcast-List-ItemIEs',
        'WriteReplaceWarningResponseIEs',
        'Cells-Broadcast-Completed-List-ItemIEs',
        'PWSCancelRequestIEs',
        'Broadcast-To-Be-Cancelled-List-ItemIEs',
        'PWSCancelResponseIEs',
        'Cells-Broadcast-Cancelled-List-ItemIEs',
        'UEInactivityNotificationIEs',
        'DRB-Activity-ItemIEs',
        'InitialULRRCMessageTransferIEs',
        'DLRRCMessageTransferIEs',
        'ULRRCMessageTransferIEs',
        'PrivateMessage-IEs',
        'SystemInformationDeliveryCommandIEs',
        'PagingIEs',
        'PagingCell-ItemIEs',
        'NotifyIEs',
        'DRB-Notify-ItemIEs',
        'NetworkAccessRateReductionIEs',
        'PWSRestartIndicationIEs',
        'NR-CGI-List-For-Restart-List-ItemIEs',
        'PWSFailureIndicationIEs',
        'PWS-Failed-NR-CGI-List-ItemIEs',
        'GNBDUStatusIndicationIEs',
        'RRCDeliveryReportIEs',
        'F1RemovalRequestIEs',
        'F1RemovalResponseIEs',
        'F1RemovalFailureIEs',
        'TraceStartIEs',
        'DeactivateTraceIEs',
        'CellTrafficTraceIEs',
        'DUCURadioInformationTransferIEs',
        'CUDURadioInformationTransferIEs',
        'BAPMappingConfiguration-IEs',
        'BH-Routing-Information-Added-List-ItemIEs',
        'BH-Routing-Information-Removed-List-ItemIEs',
        'BAP-Header-Rewriting-Added-List-ItemIEs',
        'BAP-Header-Rewriting-Removed-List-ItemIEs',
        'BAPMappingConfigurationAcknowledge-IEs',
        'BAPMappingConfigurationFailureIEs',
        'GNBDUResourceConfigurationIEs',
        'GNBDUResourceConfigurationAcknowledgeIEs',
        'GNBDUResourceConfigurationFailureIEs',
        'IABTNLAddressRequestIEs',
        'IAB-TNL-Addresses-To-Remove-ItemIEs',
        'IABTNLAddressResponseIEs',
        'IAB-Allocated-TNL-Address-List-ItemIEs',
        'IABTNLAddressFailureIEs',
        'IABUPConfigurationUpdateRequestIEs',
        'UL-UP-TNL-Information-to-Update-List-ItemIEs',
        'UL-UP-TNL-Address-to-Update-List-ItemIEs',
        'IABUPConfigurationUpdateResponseIEs',
        'DL-UP-TNL-Address-to-Update-List-ItemIEs',
        'IABUPConfigurationUpdateFailureIEs',
        'ResourceStatusRequestIEs',
        'ResourceStatusResponseIEs',
        'ResourceStatusFailureIEs',
        'ResourceStatusUpdateIEs',
        'AccessAndMobilityIndicationIEs',
        'ReferenceTimeInformationReportingControlIEs',
        'ReferenceTimeInformationReportIEs',
        'AccessSuccessIEs',
        'PositioningAssistanceInformationControlIEs',
        'PositioningAssistanceInformationFeedbackIEs',
        'PositioningMeasurementRequestIEs',
        'PositioningMeasurementResponseIEs',
        'PositioningMeasurementFailureIEs',
        'PositioningMeasurementReportIEs',
        'PositioningMeasurementAbortIEs',
        'PositioningMeasurementFailureIndicationIEs',
        'PositioningMeasurementUpdateIEs',
        'TRPInformationRequestIEs',
        'TRPInformationTypeItemTRPReq',
        'TRPInformationResponseIEs',
        'TRPInformationItemTRPResp',
        'TRPInformationFailureIEs',
        'PositioningInformationRequestIEs',
        'PositioningInformationResponseIEs',
        'PositioningInformationFailureIEs',
        'PositioningActivationRequestIEs',
        'SRSType-ExtIEs',
        'SemipersistentSRS-ExtIEs',
        'AperiodicSRS-ExtIEs',
        'PositioningActivationResponseIEs',
        'PositioningActivationFailureIEs',
        'PositioningDeactivationIEs',
        'PositioningInformationUpdateIEs',
        'E-CIDMeasurementInitiationRequest-IEs',
        'E-CIDMeasurementInitiationResponse-IEs',
        'E-CIDMeasurementInitiationFailure-IEs',
        'E-CIDMeasurementFailureIndication-IEs',
        'E-CIDMeasurementReport-IEs',
        'E-CIDMeasurementTerminationCommand-IEs',
        'BroadcastContextSetupRequestIEs',
        'BroadcastMRBs-ToBeSetup-ItemIEs',
        'BroadcastContextSetupResponseIEs',
        'BroadcastMRBs-Setup-ItemIEs',
        'BroadcastMRBs-FailedToBeSetup-ItemIEs',
        'BroadcastContextSetupFailureIEs',
        'BroadcastContextReleaseCommandIEs',
        'BroadcastContextReleaseCompleteIEs',
        'BroadcastContextReleaseRequestIEs',
        'BroadcastContextModificationRequestIEs',
        'BroadcastMRBs-ToBeSetupMod-ItemIEs',
        'BroadcastMRBs-ToBeModified-ItemIEs',
        'BroadcastMRBs-ToBeReleased-ItemIEs',
        'BroadcastContextModificationResponseIEs',
        'BroadcastMRBs-SetupMod-ItemIEs',
        'BroadcastMRBs-FailedToBeSetupMod-ItemIEs',
        'BroadcastMRBs-Modified-ItemIEs',
        'BroadcastMRBs-FailedToBeModified-ItemIEs',
        'BroadcastContextModificationFailureIEs',
        'MulticastGroupPagingIEs',
        'UEIdentity-List-For-Paging-ItemIEs',
        'MC-PagingCell-ItemIEs',
        'MulticastContextSetupRequestIEs',
        'MulticastMRBs-ToBeSetup-ItemIEs',
        'MulticastContextSetupResponseIEs',
        'MulticastMRBs-Setup-ItemIEs',
        'MulticastMRBs-FailedToBeSetup-ItemIEs',
        'MulticastContextSetupFailureIEs',
        'MulticastContextReleaseCommandIEs',
        'MulticastContextReleaseCompleteIEs',
        'MulticastContextReleaseRequestIEs',
        'MulticastContextModificationRequestIEs',
        'MulticastMRBs-ToBeSetupMod-ItemIEs',
        'MulticastMRBs-ToBeModified-ItemIEs',
        'MulticastMRBs-ToBeReleased-ItemIEs',
        'MulticastContextModificationResponseIEs',
        'MulticastMRBs-SetupMod-ItemIEs',
        'MulticastMRBs-FailedToBeSetupMod-ItemIEs',
        'MulticastMRBs-Modified-ItemIEs',
        'MulticastMRBs-FailedToBeModified-ItemIEs',
        'MulticastContextModificationFailureIEs',
        'MulticastDistributionSetupRequestIEs',
        'MulticastF1UContext-ToBeSetup-ItemIEs',
        'MulticastDistributionSetupResponseIEs',
        'MulticastF1UContext-Setup-ItemIEs',
        'MulticastF1UContext-FailedToBeSetup-ItemIEs',
        'MulticastDistributionSetupFailureIEs',
        'MulticastDistributionReleaseCommandIEs',
        'MulticastDistributionReleaseCompleteIEs',
        'PDCMeasurementInitiationRequest-IEs',
        'PDCMeasurementInitiationResponse-IEs',
        'PDCMeasurementInitiationFailure-IEs',
        'PDCMeasurementReport-IEs',
        'PDCMeasurementTerminationCommand-IEs',
        'PDCMeasurementFailureIndication-IEs',
        'PRSConfigurationRequest-IEs',
        'PRSConfigurationResponse-IEs',
        'PRSConfigurationFailure-IEs',
        'MeasurementPreconfigurationRequired-IEs',
        'MeasurementPreconfigurationConfirm-IEs',
        'MeasurementPreconfigurationRefuse-IEs',
        'MeasurementActivation-IEs',
        'QoEInformationTransfer-IEs',
        'PosSystemInformationDeliveryCommandIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        'ResetIEs',
        'ResetType-ExtIEs',
        'UE-associatedLogicalF1-ConnectionItemRes',
        'ResetAcknowledgeIEs',
        'UE-associatedLogicalF1-ConnectionItemResAck',
        'ErrorIndicationIEs',
        'F1SetupRequestIEs',
        'GNB-DU-Served-Cells-ItemIEs',
        'F1SetupResponseIEs',
        'Cells-to-be-Activated-List-ItemIEs',
        'F1SetupFailureIEs',
        'GNBDUConfigurationUpdateIEs',
        'Served-Cells-To-Add-ItemIEs',
        'Served-Cells-To-Modify-ItemIEs',
        'Served-Cells-To-Delete-ItemIEs',
        'Cells-Status-ItemIEs',
        'Dedicated-SIDelivery-NeededUE-ItemIEs',
        'GNB-DU-TNL-Association-To-Remove-ItemIEs',
        'GNBDUConfigurationUpdateAcknowledgeIEs',
        'GNBDUConfigurationUpdateFailureIEs',
        'GNBCUConfigurationUpdateIEs',
        'Cells-to-be-Deactivated-List-ItemIEs',
        'GNB-CU-TNL-Association-To-Add-ItemIEs',
        'GNB-CU-TNL-Association-To-Remove-ItemIEs',
        'GNB-CU-TNL-Association-To-Update-ItemIEs',
        'Cells-to-be-Barred-ItemIEs',
        'Protected-EUTRA-Resources-ItemIEs',
        'Neighbour-Cell-Information-ItemIEs',
        'GNBCUConfigurationUpdateAcknowledgeIEs',
        'Cells-Failed-to-be-Activated-List-ItemIEs',
        'GNB-CU-TNL-Association-Setup-ItemIEs',
        'GNB-CU-TNL-Association-Failed-To-Setup-ItemIEs',
        'GNBCUConfigurationUpdateFailureIEs',
        'GNBDUResourceCoordinationRequest-IEs',
        'GNBDUResourceCoordinationResponse-IEs',
        'UEContextSetupRequestIEs',
        'Candidate-SpCell-ItemIEs',
        'SCell-ToBeSetup-ItemIEs',
        'SRBs-ToBeSetup-ItemIEs',
        'DRBs-ToBeSetup-ItemIEs',
        'BHChannels-ToBeSetup-ItemIEs',
        'SLDRBs-ToBeSetup-ItemIEs',
        'UE-MulticastMRBs-ToBeSetup-ItemIEs',
        'ServingCellMO-List-ItemIEs',
        'UEContextSetupResponseIEs',
        'DRBs-Setup-ItemIEs',
        'SRBs-Setup-ItemIEs',
        'SRBs-FailedToBeSetup-ItemIEs',
        'DRBs-FailedToBeSetup-ItemIEs',
        'SCell-FailedtoSetup-ItemIEs',
        'BHChannels-Setup-ItemIEs',
        'BHChannels-FailedToBeSetup-ItemIEs',
        'SLDRBs-Setup-ItemIEs',
        'SLDRBs-FailedToBeSetup-ItemIEs',
        'UEContextSetupFailureIEs',
        'Potential-SpCell-ItemIEs',
        'UEContextReleaseRequestIEs',
        'UEContextReleaseCommandIEs',
        'UEContextReleaseCompleteIEs',
        'UEContextModificationRequestIEs',
        'SCell-ToBeSetupMod-ItemIEs',
        'SCell-ToBeRemoved-ItemIEs',
        'SRBs-ToBeSetupMod-ItemIEs',
        'DRBs-ToBeSetupMod-ItemIEs',
        'DRBs-ToBeModified-ItemIEs',
        'SRBs-ToBeReleased-ItemIEs',
        'DRBs-ToBeReleased-ItemIEs',
        'BHChannels-ToBeSetupMod-ItemIEs',
        'BHChannels-ToBeModified-ItemIEs',
        'BHChannels-ToBeReleased-ItemIEs',
        'SLDRBs-ToBeSetupMod-ItemIEs',
        'SLDRBs-ToBeModified-ItemIEs',
        'SLDRBs-ToBeReleased-ItemIEs',
        'UE-MulticastMRBs-ToBeSetup-atModify-ItemIEs',
        'UE-MulticastMRBs-ToBeReleased-ItemIEs',
        'UEContextModificationResponseIEs',
        'DRBs-SetupMod-ItemIEs',
        'DRBs-Modified-ItemIEs',
        'SRBs-SetupMod-ItemIEs',
        'SRBs-Modified-ItemIEs',
        'SRBs-FailedToBeSetupMod-ItemIEs',
        'DRBs-FailedToBeSetupMod-ItemIEs',
        'DRBs-FailedToBeModified-ItemIEs',
        'SCell-FailedtoSetupMod-ItemIEs',
        'Associated-SCell-ItemIEs',
        'BHChannels-SetupMod-ItemIEs',
        'BHChannels-Modified-ItemIEs',
        'BHChannels-FailedToBeSetupMod-ItemIEs',
        'BHChannels-FailedToBeModified-ItemIEs',
        'SLDRBs-SetupMod-ItemIEs',
        'SLDRBs-Modified-ItemIEs',
        'SLDRBs-FailedToBeSetupMod-ItemIEs',
        'SLDRBs-FailedToBeModified-ItemIEs',
        'UE-MulticastMRBs-Setup-ItemIEs',
        'UEContextModificationFailureIEs',
        'UEContextModificationRequiredIEs',
        'DRBs-Required-ToBeModified-ItemIEs',
        'DRBs-Required-ToBeReleased-ItemIEs',
        'SRBs-Required-ToBeReleased-ItemIEs',
        'BHChannels-Required-ToBeReleased-ItemIEs',
        'SLDRBs-Required-ToBeModified-ItemIEs',
        'SLDRBs-Required-ToBeReleased-ItemIEs',
        'UE-MulticastMRBs-RequiredToBeModified-ItemIEs',
        'UE-MulticastMRBs-RequiredToBeReleased-ItemIEs',
        'UEContextModificationConfirmIEs',
        'DRBs-ModifiedConf-ItemIEs',
        'SLDRBs-ModifiedConf-ItemIEs',
        'UE-MulticastMRBs-ConfirmedToBeModified-ItemIEs',
        'UEContextModificationRefuseIEs',
        'WriteReplaceWarningRequestIEs',
        'Cells-To-Be-Broadcast-List-ItemIEs',
        'WriteReplaceWarningResponseIEs',
        'Cells-Broadcast-Completed-List-ItemIEs',
        'PWSCancelRequestIEs',
        'Broadcast-To-Be-Cancelled-List-ItemIEs',
        'PWSCancelResponseIEs',
        'Cells-Broadcast-Cancelled-List-ItemIEs',
        'UEInactivityNotificationIEs',
        'DRB-Activity-ItemIEs',
        'InitialULRRCMessageTransferIEs',
        'DLRRCMessageTransferIEs',
        'ULRRCMessageTransferIEs',
        'PrivateMessage-IEs',
        'SystemInformationDeliveryCommandIEs',
        'PagingIEs',
        'PagingCell-ItemIEs',
        'NotifyIEs',
        'DRB-Notify-ItemIEs',
        'NetworkAccessRateReductionIEs',
        'PWSRestartIndicationIEs',
        'NR-CGI-List-For-Restart-List-ItemIEs',
        'PWSFailureIndicationIEs',
        'PWS-Failed-NR-CGI-List-ItemIEs',
        'GNBDUStatusIndicationIEs',
        'RRCDeliveryReportIEs',
        'F1RemovalRequestIEs',
        'F1RemovalResponseIEs',
        'F1RemovalFailureIEs',
        'TraceStartIEs',
        'DeactivateTraceIEs',
        'CellTrafficTraceIEs',
        'DUCURadioInformationTransferIEs',
        'CUDURadioInformationTransferIEs',
        'BAPMappingConfiguration-IEs',
        'BH-Routing-Information-Added-List-ItemIEs',
        'BH-Routing-Information-Removed-List-ItemIEs',
        'BAP-Header-Rewriting-Added-List-ItemIEs',
        'BAP-Header-Rewriting-Removed-List-ItemIEs',
        'BAPMappingConfigurationAcknowledge-IEs',
        'BAPMappingConfigurationFailureIEs',
        'GNBDUResourceConfigurationIEs',
        'GNBDUResourceConfigurationAcknowledgeIEs',
        'GNBDUResourceConfigurationFailureIEs',
        'IABTNLAddressRequestIEs',
        'IAB-TNL-Addresses-To-Remove-ItemIEs',
        'IABTNLAddressResponseIEs',
        'IAB-Allocated-TNL-Address-List-ItemIEs',
        'IABTNLAddressFailureIEs',
        'IABUPConfigurationUpdateRequestIEs',
        'UL-UP-TNL-Information-to-Update-List-ItemIEs',
        'UL-UP-TNL-Address-to-Update-List-ItemIEs',
        'IABUPConfigurationUpdateResponseIEs',
        'DL-UP-TNL-Address-to-Update-List-ItemIEs',
        'IABUPConfigurationUpdateFailureIEs',
        'ResourceStatusRequestIEs',
        'ResourceStatusResponseIEs',
        'ResourceStatusFailureIEs',
        'ResourceStatusUpdateIEs',
        'AccessAndMobilityIndicationIEs',
        'ReferenceTimeInformationReportingControlIEs',
        'ReferenceTimeInformationReportIEs',
        'AccessSuccessIEs',
        'PositioningAssistanceInformationControlIEs',
        'PositioningAssistanceInformationFeedbackIEs',
        'PositioningMeasurementRequestIEs',
        'PositioningMeasurementResponseIEs',
        'PositioningMeasurementFailureIEs',
        'PositioningMeasurementReportIEs',
        'PositioningMeasurementAbortIEs',
        'PositioningMeasurementFailureIndicationIEs',
        'PositioningMeasurementUpdateIEs',
        'TRPInformationRequestIEs',
        'TRPInformationTypeItemTRPReq',
        'TRPInformationResponseIEs',
        'TRPInformationItemTRPResp',
        'TRPInformationFailureIEs',
        'PositioningInformationRequestIEs',
        'PositioningInformationResponseIEs',
        'PositioningInformationFailureIEs',
        'PositioningActivationRequestIEs',
        'SRSType-ExtIEs',
        'SemipersistentSRS-ExtIEs',
        'AperiodicSRS-ExtIEs',
        'PositioningActivationResponseIEs',
        'PositioningActivationFailureIEs',
        'PositioningDeactivationIEs',
        'PositioningInformationUpdateIEs',
        'E-CIDMeasurementInitiationRequest-IEs',
        'E-CIDMeasurementInitiationResponse-IEs',
        'E-CIDMeasurementInitiationFailure-IEs',
        'E-CIDMeasurementFailureIndication-IEs',
        'E-CIDMeasurementReport-IEs',
        'E-CIDMeasurementTerminationCommand-IEs',
        'BroadcastContextSetupRequestIEs',
        'BroadcastMRBs-ToBeSetup-ItemIEs',
        'BroadcastContextSetupResponseIEs',
        'BroadcastMRBs-Setup-ItemIEs',
        'BroadcastMRBs-FailedToBeSetup-ItemIEs',
        'BroadcastContextSetupFailureIEs',
        'BroadcastContextReleaseCommandIEs',
        'BroadcastContextReleaseCompleteIEs',
        'BroadcastContextReleaseRequestIEs',
        'BroadcastContextModificationRequestIEs',
        'BroadcastMRBs-ToBeSetupMod-ItemIEs',
        'BroadcastMRBs-ToBeModified-ItemIEs',
        'BroadcastMRBs-ToBeReleased-ItemIEs',
        'BroadcastContextModificationResponseIEs',
        'BroadcastMRBs-SetupMod-ItemIEs',
        'BroadcastMRBs-FailedToBeSetupMod-ItemIEs',
        'BroadcastMRBs-Modified-ItemIEs',
        'BroadcastMRBs-FailedToBeModified-ItemIEs',
        'BroadcastContextModificationFailureIEs',
        'MulticastGroupPagingIEs',
        'UEIdentity-List-For-Paging-ItemIEs',
        'MC-PagingCell-ItemIEs',
        'MulticastContextSetupRequestIEs',
        'MulticastMRBs-ToBeSetup-ItemIEs',
        'MulticastContextSetupResponseIEs',
        'MulticastMRBs-Setup-ItemIEs',
        'MulticastMRBs-FailedToBeSetup-ItemIEs',
        'MulticastContextSetupFailureIEs',
        'MulticastContextReleaseCommandIEs',
        'MulticastContextReleaseCompleteIEs',
        'MulticastContextReleaseRequestIEs',
        'MulticastContextModificationRequestIEs',
        'MulticastMRBs-ToBeSetupMod-ItemIEs',
        'MulticastMRBs-ToBeModified-ItemIEs',
        'MulticastMRBs-ToBeReleased-ItemIEs',
        'MulticastContextModificationResponseIEs',
        'MulticastMRBs-SetupMod-ItemIEs',
        'MulticastMRBs-FailedToBeSetupMod-ItemIEs',
        'MulticastMRBs-Modified-ItemIEs',
        'MulticastMRBs-FailedToBeModified-ItemIEs',
        'MulticastContextModificationFailureIEs',
        'MulticastDistributionSetupRequestIEs',
        'MulticastF1UContext-ToBeSetup-ItemIEs',
        'MulticastDistributionSetupResponseIEs',
        'MulticastF1UContext-Setup-ItemIEs',
        'MulticastF1UContext-FailedToBeSetup-ItemIEs',
        'MulticastDistributionSetupFailureIEs',
        'MulticastDistributionReleaseCommandIEs',
        'MulticastDistributionReleaseCompleteIEs',
        'PDCMeasurementInitiationRequest-IEs',
        'PDCMeasurementInitiationResponse-IEs',
        'PDCMeasurementInitiationFailure-IEs',
        'PDCMeasurementReport-IEs',
        'PDCMeasurementTerminationCommand-IEs',
        'PDCMeasurementFailureIndication-IEs',
        'PRSConfigurationRequest-IEs',
        'PRSConfigurationResponse-IEs',
        'PRSConfigurationFailure-IEs',
        'MeasurementPreconfigurationRequired-IEs',
        'MeasurementPreconfigurationConfirm-IEs',
        'MeasurementPreconfigurationRefuse-IEs',
        'MeasurementActivation-IEs',
        'QoEInformationTransfer-IEs',
        'PosSystemInformationDeliveryCommandIEs',
        ]
    _param_ = [
        ]
    
    #-----< Reset >-----#
    Reset = SEQ(name='Reset', mode=MODE_TYPE)
    _Reset_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __Reset_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___Reset_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____Reset_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____Reset_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____Reset_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____Reset_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResetType')))
    ____Reset_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____Reset_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____Reset_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 48), ('criticality', 'reject'), ('Value', _____Reset_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___Reset_protocolIEs__item__id._const_tab = ____Reset_protocolIEs__item__id_tab
    ___Reset_protocolIEs__item__id._const_tab_at = None
    ___Reset_protocolIEs__item__id._const_tab_id = 'id'
    ___Reset_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___Reset_protocolIEs__item__criticality._const_tab = ____Reset_protocolIEs__item__id_tab
    ___Reset_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___Reset_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___Reset_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___Reset_protocolIEs__item__value._const_tab = ____Reset_protocolIEs__item__id_tab
    ___Reset_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___Reset_protocolIEs__item__value._const_tab_id = 'Value'
    __Reset_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___Reset_protocolIEs__item__id),
        ('criticality', ___Reset_protocolIEs__item__criticality),
        ('value', ___Reset_protocolIEs__item__value),
        ])
    __Reset_protocolIEs__item_._ext = None
    _Reset_protocolIEs._cont = __Reset_protocolIEs__item_
    _Reset_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    Reset._cont = ASN1Dict([
        ('protocolIEs', _Reset_protocolIEs),
        ])
    Reset._ext = []
    
    #-----< ResetIEs >-----#
    ResetIEs = CLASS(name='ResetIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _ResetIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _ResetIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _ResetIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResetType')))
    ResetIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _ResetIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _ResetIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 48), ('criticality', 'reject'), ('Value', _ResetIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ResetType >-----#
    ResetType = CHOICE(name='ResetType', mode=MODE_TYPE)
    _ResetType_f1_Interface = ENUM(name='f1-Interface', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResetAll')))
    _ResetType_partOfF1_Interface = SEQ_OF(name='partOfF1-Interface', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-PDU-Contents', 'UE-associatedLogicalF1-ConnectionListRes')))
    _ResetType_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __ResetType_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___ResetType_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ResetType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResetType_choice_extension_id._const_tab = ___ResetType_choice_extension_id_tab
    __ResetType_choice_extension_id._const_tab_at = None
    __ResetType_choice_extension_id._const_tab_id = 'id'
    __ResetType_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___ResetType_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ResetType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResetType_choice_extension_criticality._const_tab = ___ResetType_choice_extension_criticality_tab
    __ResetType_choice_extension_criticality._const_tab_at = ('..', 'id')
    __ResetType_choice_extension_criticality._const_tab_id = 'criticality'
    __ResetType_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___ResetType_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___ResetType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResetType_choice_extension_value._const_tab = ___ResetType_choice_extension_value_tab
    __ResetType_choice_extension_value._const_tab_at = ('..', 'id')
    __ResetType_choice_extension_value._const_tab_id = 'Value'
    _ResetType_choice_extension._cont = ASN1Dict([
        ('id', __ResetType_choice_extension_id),
        ('criticality', __ResetType_choice_extension_criticality),
        ('value', __ResetType_choice_extension_value),
        ])
    _ResetType_choice_extension._ext = None
    ResetType._cont = ASN1Dict([
        ('f1-Interface', _ResetType_f1_Interface),
        ('partOfF1-Interface', _ResetType_partOfF1_Interface),
        ('choice-extension', _ResetType_choice_extension),
        ])
    ResetType._ext = None
    
    #-----< ResetType-ExtIEs >-----#
    ResetType_ExtIEs = CLASS(name='ResetType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ResetType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResetAll >-----#
    ResetAll = ENUM(name='ResetAll', mode=MODE_TYPE)
    ResetAll._cont = ASN1Dict([('reset-all', 0)])
    ResetAll._ext = []
    
    #-----< UE-associatedLogicalF1-ConnectionListRes >-----#
    UE_associatedLogicalF1_ConnectionListRes = SEQ_OF(name='UE-associatedLogicalF1-ConnectionListRes', mode=MODE_TYPE)
    _UE_associatedLogicalF1_ConnectionListRes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UE_associatedLogicalF1_ConnectionListRes__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___UE_associatedLogicalF1_ConnectionListRes__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____UE_associatedLogicalF1_ConnectionListRes__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UE-associatedLogicalF1-ConnectionItem')))
    ___UE_associatedLogicalF1_ConnectionListRes__item__id_tab._val = ASN1Set(rv=[dict([('id', 80), ('criticality', 'reject'), ('Value', ____UE_associatedLogicalF1_ConnectionListRes__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __UE_associatedLogicalF1_ConnectionListRes__item__id._const_tab = ___UE_associatedLogicalF1_ConnectionListRes__item__id_tab
    __UE_associatedLogicalF1_ConnectionListRes__item__id._const_tab_at = None
    __UE_associatedLogicalF1_ConnectionListRes__item__id._const_tab_id = 'id'
    __UE_associatedLogicalF1_ConnectionListRes__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __UE_associatedLogicalF1_ConnectionListRes__item__criticality._const_tab = ___UE_associatedLogicalF1_ConnectionListRes__item__id_tab
    __UE_associatedLogicalF1_ConnectionListRes__item__criticality._const_tab_at = ('..', 'id')
    __UE_associatedLogicalF1_ConnectionListRes__item__criticality._const_tab_id = 'criticality'
    __UE_associatedLogicalF1_ConnectionListRes__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __UE_associatedLogicalF1_ConnectionListRes__item__value._const_tab = ___UE_associatedLogicalF1_ConnectionListRes__item__id_tab
    __UE_associatedLogicalF1_ConnectionListRes__item__value._const_tab_at = ('..', 'id')
    __UE_associatedLogicalF1_ConnectionListRes__item__value._const_tab_id = 'Value'
    _UE_associatedLogicalF1_ConnectionListRes__item_._cont = ASN1Dict([
        ('id', __UE_associatedLogicalF1_ConnectionListRes__item__id),
        ('criticality', __UE_associatedLogicalF1_ConnectionListRes__item__criticality),
        ('value', __UE_associatedLogicalF1_ConnectionListRes__item__value),
        ])
    _UE_associatedLogicalF1_ConnectionListRes__item_._ext = None
    UE_associatedLogicalF1_ConnectionListRes._cont = _UE_associatedLogicalF1_ConnectionListRes__item_
    UE_associatedLogicalF1_ConnectionListRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< UE-associatedLogicalF1-ConnectionItemRes >-----#
    UE_associatedLogicalF1_ConnectionItemRes = CLASS(name='UE-associatedLogicalF1-ConnectionItemRes', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UE_associatedLogicalF1_ConnectionItemRes_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UE-associatedLogicalF1-ConnectionItem')))
    UE_associatedLogicalF1_ConnectionItemRes._val = ASN1Set(rv=[dict([('id', 80), ('criticality', 'reject'), ('Value', _UE_associatedLogicalF1_ConnectionItemRes_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ResetAcknowledge >-----#
    ResetAcknowledge = SEQ(name='ResetAcknowledge', mode=MODE_TYPE)
    _ResetAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __ResetAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___ResetAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____ResetAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UE-associatedLogicalF1-ConnectionListResAck')))
    _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____ResetAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 81), ('criticality', 'ignore'), ('Value', _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResetAcknowledge_protocolIEs__item__id._const_tab = ____ResetAcknowledge_protocolIEs__item__id_tab
    ___ResetAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___ResetAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___ResetAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___ResetAcknowledge_protocolIEs__item__criticality._const_tab = ____ResetAcknowledge_protocolIEs__item__id_tab
    ___ResetAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ResetAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ResetAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___ResetAcknowledge_protocolIEs__item__value._const_tab = ____ResetAcknowledge_protocolIEs__item__id_tab
    ___ResetAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ResetAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __ResetAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ResetAcknowledge_protocolIEs__item__id),
        ('criticality', ___ResetAcknowledge_protocolIEs__item__criticality),
        ('value', ___ResetAcknowledge_protocolIEs__item__value),
        ])
    __ResetAcknowledge_protocolIEs__item_._ext = None
    _ResetAcknowledge_protocolIEs._cont = __ResetAcknowledge_protocolIEs__item_
    _ResetAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResetAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _ResetAcknowledge_protocolIEs),
        ])
    ResetAcknowledge._ext = []
    
    #-----< ResetAcknowledgeIEs >-----#
    ResetAcknowledgeIEs = CLASS(name='ResetAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _ResetAcknowledgeIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _ResetAcknowledgeIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UE-associatedLogicalF1-ConnectionListResAck')))
    _ResetAcknowledgeIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ResetAcknowledgeIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _ResetAcknowledgeIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 81), ('criticality', 'ignore'), ('Value', _ResetAcknowledgeIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _ResetAcknowledgeIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UE-associatedLogicalF1-ConnectionListResAck >-----#
    UE_associatedLogicalF1_ConnectionListResAck = SEQ_OF(name='UE-associatedLogicalF1-ConnectionListResAck', mode=MODE_TYPE)
    _UE_associatedLogicalF1_ConnectionListResAck__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UE_associatedLogicalF1_ConnectionListResAck__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___UE_associatedLogicalF1_ConnectionListResAck__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____UE_associatedLogicalF1_ConnectionListResAck__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UE-associatedLogicalF1-ConnectionItem')))
    ___UE_associatedLogicalF1_ConnectionListResAck__item__id_tab._val = ASN1Set(rv=[dict([('id', 80), ('criticality', 'ignore'), ('Value', ____UE_associatedLogicalF1_ConnectionListResAck__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __UE_associatedLogicalF1_ConnectionListResAck__item__id._const_tab = ___UE_associatedLogicalF1_ConnectionListResAck__item__id_tab
    __UE_associatedLogicalF1_ConnectionListResAck__item__id._const_tab_at = None
    __UE_associatedLogicalF1_ConnectionListResAck__item__id._const_tab_id = 'id'
    __UE_associatedLogicalF1_ConnectionListResAck__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __UE_associatedLogicalF1_ConnectionListResAck__item__criticality._const_tab = ___UE_associatedLogicalF1_ConnectionListResAck__item__id_tab
    __UE_associatedLogicalF1_ConnectionListResAck__item__criticality._const_tab_at = ('..', 'id')
    __UE_associatedLogicalF1_ConnectionListResAck__item__criticality._const_tab_id = 'criticality'
    __UE_associatedLogicalF1_ConnectionListResAck__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __UE_associatedLogicalF1_ConnectionListResAck__item__value._const_tab = ___UE_associatedLogicalF1_ConnectionListResAck__item__id_tab
    __UE_associatedLogicalF1_ConnectionListResAck__item__value._const_tab_at = ('..', 'id')
    __UE_associatedLogicalF1_ConnectionListResAck__item__value._const_tab_id = 'Value'
    _UE_associatedLogicalF1_ConnectionListResAck__item_._cont = ASN1Dict([
        ('id', __UE_associatedLogicalF1_ConnectionListResAck__item__id),
        ('criticality', __UE_associatedLogicalF1_ConnectionListResAck__item__criticality),
        ('value', __UE_associatedLogicalF1_ConnectionListResAck__item__value),
        ])
    _UE_associatedLogicalF1_ConnectionListResAck__item_._ext = None
    UE_associatedLogicalF1_ConnectionListResAck._cont = _UE_associatedLogicalF1_ConnectionListResAck__item_
    UE_associatedLogicalF1_ConnectionListResAck._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< UE-associatedLogicalF1-ConnectionItemResAck >-----#
    UE_associatedLogicalF1_ConnectionItemResAck = CLASS(name='UE-associatedLogicalF1-ConnectionItemResAck', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UE_associatedLogicalF1_ConnectionItemResAck_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UE-associatedLogicalF1-ConnectionItem')))
    UE_associatedLogicalF1_ConnectionItemResAck._val = ASN1Set(rv=[dict([('id', 80), ('criticality', 'ignore'), ('Value', _UE_associatedLogicalF1_ConnectionItemResAck_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ErrorIndication >-----#
    ErrorIndication = SEQ(name='ErrorIndication', mode=MODE_TYPE)
    _ErrorIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __ErrorIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___ErrorIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____ErrorIndication_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____ErrorIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 41), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolIEs__item__id._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__id._const_tab_at = None
    ___ErrorIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___ErrorIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___ErrorIndication_protocolIEs__item__criticality._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ErrorIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___ErrorIndication_protocolIEs__item__value._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __ErrorIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ErrorIndication_protocolIEs__item__id),
        ('criticality', ___ErrorIndication_protocolIEs__item__criticality),
        ('value', ___ErrorIndication_protocolIEs__item__value),
        ])
    __ErrorIndication_protocolIEs__item_._ext = None
    _ErrorIndication_protocolIEs._cont = __ErrorIndication_protocolIEs__item_
    _ErrorIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ErrorIndication._cont = ASN1Dict([
        ('protocolIEs', _ErrorIndication_protocolIEs),
        ])
    ErrorIndication._ext = []
    
    #-----< ErrorIndicationIEs >-----#
    ErrorIndicationIEs = CLASS(name='ErrorIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _ErrorIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _ErrorIndicationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _ErrorIndicationIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _ErrorIndicationIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _ErrorIndicationIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ErrorIndicationIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _ErrorIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 41), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< F1SetupRequest >-----#
    F1SetupRequest = SEQ(name='F1SetupRequest', mode=MODE_TYPE)
    _F1SetupRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __F1SetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___F1SetupRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____F1SetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-ID')))
    _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_2 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-Name')))
    _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-DU-Served-Cells-List')))
    _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRC-Version')))
    _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-Layer-Address-Info')))
    _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_6 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Extended-GNB-DU-Name')))
    ____F1SetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 42), ('criticality', 'reject'), ('Value', _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 44), ('criticality', 'reject'), ('Value', _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'reject'), ('Value', _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 254), ('criticality', 'ignore'), ('Value', _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 281), ('criticality', 'ignore'), ('Value', _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 427), ('criticality', 'ignore'), ('Value', _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___F1SetupRequest_protocolIEs__item__id._const_tab = ____F1SetupRequest_protocolIEs__item__id_tab
    ___F1SetupRequest_protocolIEs__item__id._const_tab_at = None
    ___F1SetupRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___F1SetupRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___F1SetupRequest_protocolIEs__item__criticality._const_tab = ____F1SetupRequest_protocolIEs__item__id_tab
    ___F1SetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___F1SetupRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___F1SetupRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___F1SetupRequest_protocolIEs__item__value._const_tab = ____F1SetupRequest_protocolIEs__item__id_tab
    ___F1SetupRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___F1SetupRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __F1SetupRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___F1SetupRequest_protocolIEs__item__id),
        ('criticality', ___F1SetupRequest_protocolIEs__item__criticality),
        ('value', ___F1SetupRequest_protocolIEs__item__value),
        ])
    __F1SetupRequest_protocolIEs__item_._ext = None
    _F1SetupRequest_protocolIEs._cont = __F1SetupRequest_protocolIEs__item_
    _F1SetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    F1SetupRequest._cont = ASN1Dict([
        ('protocolIEs', _F1SetupRequest_protocolIEs),
        ])
    F1SetupRequest._ext = []
    
    #-----< F1SetupRequestIEs >-----#
    F1SetupRequestIEs = CLASS(name='F1SetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _F1SetupRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _F1SetupRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-ID')))
    _F1SetupRequestIEs_val_Value_2 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-Name')))
    _F1SetupRequestIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-DU-Served-Cells-List')))
    _F1SetupRequestIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRC-Version')))
    _F1SetupRequestIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-Layer-Address-Info')))
    _F1SetupRequestIEs_val_Value_6 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    _F1SetupRequestIEs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Extended-GNB-DU-Name')))
    F1SetupRequestIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _F1SetupRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 42), ('criticality', 'reject'), ('Value', _F1SetupRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _F1SetupRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 44), ('criticality', 'reject'), ('Value', _F1SetupRequestIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'reject'), ('Value', _F1SetupRequestIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 254), ('criticality', 'ignore'), ('Value', _F1SetupRequestIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 281), ('criticality', 'ignore'), ('Value', _F1SetupRequestIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 427), ('criticality', 'ignore'), ('Value', _F1SetupRequestIEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNB-DU-Served-Cells-List >-----#
    GNB_DU_Served_Cells_List = SEQ_OF(name='GNB-DU-Served-Cells-List', mode=MODE_TYPE)
    _GNB_DU_Served_Cells_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __GNB_DU_Served_Cells_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___GNB_DU_Served_Cells_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____GNB_DU_Served_Cells_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-Served-Cells-Item')))
    ___GNB_DU_Served_Cells_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 43), ('criticality', 'reject'), ('Value', ____GNB_DU_Served_Cells_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __GNB_DU_Served_Cells_List__item__id._const_tab = ___GNB_DU_Served_Cells_List__item__id_tab
    __GNB_DU_Served_Cells_List__item__id._const_tab_at = None
    __GNB_DU_Served_Cells_List__item__id._const_tab_id = 'id'
    __GNB_DU_Served_Cells_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __GNB_DU_Served_Cells_List__item__criticality._const_tab = ___GNB_DU_Served_Cells_List__item__id_tab
    __GNB_DU_Served_Cells_List__item__criticality._const_tab_at = ('..', 'id')
    __GNB_DU_Served_Cells_List__item__criticality._const_tab_id = 'criticality'
    __GNB_DU_Served_Cells_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __GNB_DU_Served_Cells_List__item__value._const_tab = ___GNB_DU_Served_Cells_List__item__id_tab
    __GNB_DU_Served_Cells_List__item__value._const_tab_at = ('..', 'id')
    __GNB_DU_Served_Cells_List__item__value._const_tab_id = 'Value'
    _GNB_DU_Served_Cells_List__item_._cont = ASN1Dict([
        ('id', __GNB_DU_Served_Cells_List__item__id),
        ('criticality', __GNB_DU_Served_Cells_List__item__criticality),
        ('value', __GNB_DU_Served_Cells_List__item__value),
        ])
    _GNB_DU_Served_Cells_List__item_._ext = None
    GNB_DU_Served_Cells_List._cont = _GNB_DU_Served_Cells_List__item_
    GNB_DU_Served_Cells_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< GNB-DU-Served-Cells-ItemIEs >-----#
    GNB_DU_Served_Cells_ItemIEs = CLASS(name='GNB-DU-Served-Cells-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNB_DU_Served_Cells_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-Served-Cells-Item')))
    GNB_DU_Served_Cells_ItemIEs._val = ASN1Set(rv=[dict([('id', 43), ('criticality', 'reject'), ('Value', _GNB_DU_Served_Cells_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< F1SetupResponse >-----#
    F1SetupResponse = SEQ(name='F1SetupResponse', mode=MODE_TYPE)
    _F1SetupResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __F1SetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___F1SetupResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____F1SetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_1 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-Name')))
    _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-to-be-Activated-List')))
    _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRC-Version')))
    _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-Layer-Address-Info')))
    _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-BH-Non-UP-Traffic-Mapping')))
    _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_6 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Extended-GNB-CU-Name')))
    ____F1SetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 82), ('criticality', 'ignore'), ('Value', _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 170), ('criticality', 'reject'), ('Value', _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 254), ('criticality', 'ignore'), ('Value', _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 287), ('criticality', 'reject'), ('Value', _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 281), ('criticality', 'ignore'), ('Value', _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 426), ('criticality', 'ignore'), ('Value', _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___F1SetupResponse_protocolIEs__item__id._const_tab = ____F1SetupResponse_protocolIEs__item__id_tab
    ___F1SetupResponse_protocolIEs__item__id._const_tab_at = None
    ___F1SetupResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___F1SetupResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___F1SetupResponse_protocolIEs__item__criticality._const_tab = ____F1SetupResponse_protocolIEs__item__id_tab
    ___F1SetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___F1SetupResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___F1SetupResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___F1SetupResponse_protocolIEs__item__value._const_tab = ____F1SetupResponse_protocolIEs__item__id_tab
    ___F1SetupResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___F1SetupResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __F1SetupResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___F1SetupResponse_protocolIEs__item__id),
        ('criticality', ___F1SetupResponse_protocolIEs__item__criticality),
        ('value', ___F1SetupResponse_protocolIEs__item__value),
        ])
    __F1SetupResponse_protocolIEs__item_._ext = None
    _F1SetupResponse_protocolIEs._cont = __F1SetupResponse_protocolIEs__item_
    _F1SetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    F1SetupResponse._cont = ASN1Dict([
        ('protocolIEs', _F1SetupResponse_protocolIEs),
        ])
    F1SetupResponse._ext = []
    
    #-----< F1SetupResponseIEs >-----#
    F1SetupResponseIEs = CLASS(name='F1SetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _F1SetupResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _F1SetupResponseIEs_val_Value_1 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-Name')))
    _F1SetupResponseIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-to-be-Activated-List')))
    _F1SetupResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRC-Version')))
    _F1SetupResponseIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-Layer-Address-Info')))
    _F1SetupResponseIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-BH-Non-UP-Traffic-Mapping')))
    _F1SetupResponseIEs_val_Value_6 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    _F1SetupResponseIEs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Extended-GNB-CU-Name')))
    F1SetupResponseIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _F1SetupResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 82), ('criticality', 'ignore'), ('Value', _F1SetupResponseIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _F1SetupResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 170), ('criticality', 'reject'), ('Value', _F1SetupResponseIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 254), ('criticality', 'ignore'), ('Value', _F1SetupResponseIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 287), ('criticality', 'reject'), ('Value', _F1SetupResponseIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 281), ('criticality', 'ignore'), ('Value', _F1SetupResponseIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 426), ('criticality', 'ignore'), ('Value', _F1SetupResponseIEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Cells-to-be-Activated-List >-----#
    Cells_to_be_Activated_List = SEQ_OF(name='Cells-to-be-Activated-List', mode=MODE_TYPE)
    _Cells_to_be_Activated_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Cells_to_be_Activated_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___Cells_to_be_Activated_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Cells_to_be_Activated_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-to-be-Activated-List-Item')))
    ___Cells_to_be_Activated_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'reject'), ('Value', ____Cells_to_be_Activated_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Cells_to_be_Activated_List__item__id._const_tab = ___Cells_to_be_Activated_List__item__id_tab
    __Cells_to_be_Activated_List__item__id._const_tab_at = None
    __Cells_to_be_Activated_List__item__id._const_tab_id = 'id'
    __Cells_to_be_Activated_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __Cells_to_be_Activated_List__item__criticality._const_tab = ___Cells_to_be_Activated_List__item__id_tab
    __Cells_to_be_Activated_List__item__criticality._const_tab_at = ('..', 'id')
    __Cells_to_be_Activated_List__item__criticality._const_tab_id = 'criticality'
    __Cells_to_be_Activated_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __Cells_to_be_Activated_List__item__value._const_tab = ___Cells_to_be_Activated_List__item__id_tab
    __Cells_to_be_Activated_List__item__value._const_tab_at = ('..', 'id')
    __Cells_to_be_Activated_List__item__value._const_tab_id = 'Value'
    _Cells_to_be_Activated_List__item_._cont = ASN1Dict([
        ('id', __Cells_to_be_Activated_List__item__id),
        ('criticality', __Cells_to_be_Activated_List__item__criticality),
        ('value', __Cells_to_be_Activated_List__item__value),
        ])
    _Cells_to_be_Activated_List__item_._ext = None
    Cells_to_be_Activated_List._cont = _Cells_to_be_Activated_List__item_
    Cells_to_be_Activated_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< Cells-to-be-Activated-List-ItemIEs >-----#
    Cells_to_be_Activated_List_ItemIEs = CLASS(name='Cells-to-be-Activated-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Cells_to_be_Activated_List_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-to-be-Activated-List-Item')))
    Cells_to_be_Activated_List_ItemIEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'reject'), ('Value', _Cells_to_be_Activated_List_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< F1SetupFailure >-----#
    F1SetupFailure = SEQ(name='F1SetupFailure', mode=MODE_TYPE)
    _F1SetupFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __F1SetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___F1SetupFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____F1SetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____F1SetupFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____F1SetupFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____F1SetupFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _____F1SetupFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____F1SetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____F1SetupFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____F1SetupFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _____F1SetupFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____F1SetupFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___F1SetupFailure_protocolIEs__item__id._const_tab = ____F1SetupFailure_protocolIEs__item__id_tab
    ___F1SetupFailure_protocolIEs__item__id._const_tab_at = None
    ___F1SetupFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___F1SetupFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___F1SetupFailure_protocolIEs__item__criticality._const_tab = ____F1SetupFailure_protocolIEs__item__id_tab
    ___F1SetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___F1SetupFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___F1SetupFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___F1SetupFailure_protocolIEs__item__value._const_tab = ____F1SetupFailure_protocolIEs__item__id_tab
    ___F1SetupFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___F1SetupFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __F1SetupFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___F1SetupFailure_protocolIEs__item__id),
        ('criticality', ___F1SetupFailure_protocolIEs__item__criticality),
        ('value', ___F1SetupFailure_protocolIEs__item__value),
        ])
    __F1SetupFailure_protocolIEs__item_._ext = None
    _F1SetupFailure_protocolIEs._cont = __F1SetupFailure_protocolIEs__item_
    _F1SetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    F1SetupFailure._cont = ASN1Dict([
        ('protocolIEs', _F1SetupFailure_protocolIEs),
        ])
    F1SetupFailure._ext = []
    
    #-----< F1SetupFailureIEs >-----#
    F1SetupFailureIEs = CLASS(name='F1SetupFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _F1SetupFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _F1SetupFailureIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _F1SetupFailureIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _F1SetupFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    F1SetupFailureIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _F1SetupFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _F1SetupFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _F1SetupFailureIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _F1SetupFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNBDUConfigurationUpdate >-----#
    GNBDUConfigurationUpdate = SEQ(name='GNBDUConfigurationUpdate', mode=MODE_TYPE)
    _GNBDUConfigurationUpdate_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __GNBDUConfigurationUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___GNBDUConfigurationUpdate_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____GNBDUConfigurationUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Served-Cells-To-Add-List')))
    _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Served-Cells-To-Modify-List')))
    _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Served-Cells-To-Delete-List')))
    _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-Status-List')))
    _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Dedicated-SIDelivery-NeededUE-List')))
    _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-ID')))
    _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-DU-TNL-Association-To-Remove-List')))
    _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-Layer-Address-Info')))
    _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Coverage-Modification-Notification')))
    _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_10 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-Name')))
    _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Extended-GNB-DU-Name')))
    ____GNBDUConfigurationUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'reject'), ('Value', _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 62), ('criticality', 'reject'), ('Value', _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 60), ('criticality', 'reject'), ('Value', _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 89), ('criticality', 'reject'), ('Value', _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 189), ('criticality', 'ignore'), ('Value', _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 42), ('criticality', 'reject'), ('Value', _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 228), ('criticality', 'reject'), ('Value', _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 254), ('criticality', 'ignore'), ('Value', _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 446), ('criticality', 'ignore'), ('Value', _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 427), ('criticality', 'ignore'), ('Value', _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNBDUConfigurationUpdate_protocolIEs__item__id._const_tab = ____GNBDUConfigurationUpdate_protocolIEs__item__id_tab
    ___GNBDUConfigurationUpdate_protocolIEs__item__id._const_tab_at = None
    ___GNBDUConfigurationUpdate_protocolIEs__item__id._const_tab_id = 'id'
    ___GNBDUConfigurationUpdate_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___GNBDUConfigurationUpdate_protocolIEs__item__criticality._const_tab = ____GNBDUConfigurationUpdate_protocolIEs__item__id_tab
    ___GNBDUConfigurationUpdate_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNBDUConfigurationUpdate_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNBDUConfigurationUpdate_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___GNBDUConfigurationUpdate_protocolIEs__item__value._const_tab = ____GNBDUConfigurationUpdate_protocolIEs__item__id_tab
    ___GNBDUConfigurationUpdate_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNBDUConfigurationUpdate_protocolIEs__item__value._const_tab_id = 'Value'
    __GNBDUConfigurationUpdate_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNBDUConfigurationUpdate_protocolIEs__item__id),
        ('criticality', ___GNBDUConfigurationUpdate_protocolIEs__item__criticality),
        ('value', ___GNBDUConfigurationUpdate_protocolIEs__item__value),
        ])
    __GNBDUConfigurationUpdate_protocolIEs__item_._ext = None
    _GNBDUConfigurationUpdate_protocolIEs._cont = __GNBDUConfigurationUpdate_protocolIEs__item_
    _GNBDUConfigurationUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNBDUConfigurationUpdate._cont = ASN1Dict([
        ('protocolIEs', _GNBDUConfigurationUpdate_protocolIEs),
        ])
    GNBDUConfigurationUpdate._ext = []
    
    #-----< GNBDUConfigurationUpdateIEs >-----#
    GNBDUConfigurationUpdateIEs = CLASS(name='GNBDUConfigurationUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNBDUConfigurationUpdateIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _GNBDUConfigurationUpdateIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Served-Cells-To-Add-List')))
    _GNBDUConfigurationUpdateIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Served-Cells-To-Modify-List')))
    _GNBDUConfigurationUpdateIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Served-Cells-To-Delete-List')))
    _GNBDUConfigurationUpdateIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-Status-List')))
    _GNBDUConfigurationUpdateIEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Dedicated-SIDelivery-NeededUE-List')))
    _GNBDUConfigurationUpdateIEs_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-ID')))
    _GNBDUConfigurationUpdateIEs_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-DU-TNL-Association-To-Remove-List')))
    _GNBDUConfigurationUpdateIEs_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-Layer-Address-Info')))
    _GNBDUConfigurationUpdateIEs_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Coverage-Modification-Notification')))
    _GNBDUConfigurationUpdateIEs_val_Value_10 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-Name')))
    _GNBDUConfigurationUpdateIEs_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Extended-GNB-DU-Name')))
    GNBDUConfigurationUpdateIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _GNBDUConfigurationUpdateIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'reject'), ('Value', _GNBDUConfigurationUpdateIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 62), ('criticality', 'reject'), ('Value', _GNBDUConfigurationUpdateIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 60), ('criticality', 'reject'), ('Value', _GNBDUConfigurationUpdateIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 89), ('criticality', 'reject'), ('Value', _GNBDUConfigurationUpdateIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 189), ('criticality', 'ignore'), ('Value', _GNBDUConfigurationUpdateIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 42), ('criticality', 'reject'), ('Value', _GNBDUConfigurationUpdateIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 228), ('criticality', 'reject'), ('Value', _GNBDUConfigurationUpdateIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 254), ('criticality', 'ignore'), ('Value', _GNBDUConfigurationUpdateIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 446), ('criticality', 'ignore'), ('Value', _GNBDUConfigurationUpdateIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _GNBDUConfigurationUpdateIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 427), ('criticality', 'ignore'), ('Value', _GNBDUConfigurationUpdateIEs_val_Value_11), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Served-Cells-To-Add-List >-----#
    Served_Cells_To_Add_List = SEQ_OF(name='Served-Cells-To-Add-List', mode=MODE_TYPE)
    _Served_Cells_To_Add_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Served_Cells_To_Add_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___Served_Cells_To_Add_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Served_Cells_To_Add_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Served-Cells-To-Add-Item')))
    ___Served_Cells_To_Add_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', ____Served_Cells_To_Add_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Served_Cells_To_Add_List__item__id._const_tab = ___Served_Cells_To_Add_List__item__id_tab
    __Served_Cells_To_Add_List__item__id._const_tab_at = None
    __Served_Cells_To_Add_List__item__id._const_tab_id = 'id'
    __Served_Cells_To_Add_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __Served_Cells_To_Add_List__item__criticality._const_tab = ___Served_Cells_To_Add_List__item__id_tab
    __Served_Cells_To_Add_List__item__criticality._const_tab_at = ('..', 'id')
    __Served_Cells_To_Add_List__item__criticality._const_tab_id = 'criticality'
    __Served_Cells_To_Add_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __Served_Cells_To_Add_List__item__value._const_tab = ___Served_Cells_To_Add_List__item__id_tab
    __Served_Cells_To_Add_List__item__value._const_tab_at = ('..', 'id')
    __Served_Cells_To_Add_List__item__value._const_tab_id = 'Value'
    _Served_Cells_To_Add_List__item_._cont = ASN1Dict([
        ('id', __Served_Cells_To_Add_List__item__id),
        ('criticality', __Served_Cells_To_Add_List__item__criticality),
        ('value', __Served_Cells_To_Add_List__item__value),
        ])
    _Served_Cells_To_Add_List__item_._ext = None
    Served_Cells_To_Add_List._cont = _Served_Cells_To_Add_List__item_
    Served_Cells_To_Add_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< Served-Cells-To-Modify-List >-----#
    Served_Cells_To_Modify_List = SEQ_OF(name='Served-Cells-To-Modify-List', mode=MODE_TYPE)
    _Served_Cells_To_Modify_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Served_Cells_To_Modify_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___Served_Cells_To_Modify_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Served_Cells_To_Modify_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Served-Cells-To-Modify-Item')))
    ___Served_Cells_To_Modify_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 61), ('criticality', 'reject'), ('Value', ____Served_Cells_To_Modify_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Served_Cells_To_Modify_List__item__id._const_tab = ___Served_Cells_To_Modify_List__item__id_tab
    __Served_Cells_To_Modify_List__item__id._const_tab_at = None
    __Served_Cells_To_Modify_List__item__id._const_tab_id = 'id'
    __Served_Cells_To_Modify_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __Served_Cells_To_Modify_List__item__criticality._const_tab = ___Served_Cells_To_Modify_List__item__id_tab
    __Served_Cells_To_Modify_List__item__criticality._const_tab_at = ('..', 'id')
    __Served_Cells_To_Modify_List__item__criticality._const_tab_id = 'criticality'
    __Served_Cells_To_Modify_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __Served_Cells_To_Modify_List__item__value._const_tab = ___Served_Cells_To_Modify_List__item__id_tab
    __Served_Cells_To_Modify_List__item__value._const_tab_at = ('..', 'id')
    __Served_Cells_To_Modify_List__item__value._const_tab_id = 'Value'
    _Served_Cells_To_Modify_List__item_._cont = ASN1Dict([
        ('id', __Served_Cells_To_Modify_List__item__id),
        ('criticality', __Served_Cells_To_Modify_List__item__criticality),
        ('value', __Served_Cells_To_Modify_List__item__value),
        ])
    _Served_Cells_To_Modify_List__item_._ext = None
    Served_Cells_To_Modify_List._cont = _Served_Cells_To_Modify_List__item_
    Served_Cells_To_Modify_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< Served-Cells-To-Delete-List >-----#
    Served_Cells_To_Delete_List = SEQ_OF(name='Served-Cells-To-Delete-List', mode=MODE_TYPE)
    _Served_Cells_To_Delete_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Served_Cells_To_Delete_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___Served_Cells_To_Delete_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Served_Cells_To_Delete_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Served-Cells-To-Delete-Item')))
    ___Served_Cells_To_Delete_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 59), ('criticality', 'reject'), ('Value', ____Served_Cells_To_Delete_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Served_Cells_To_Delete_List__item__id._const_tab = ___Served_Cells_To_Delete_List__item__id_tab
    __Served_Cells_To_Delete_List__item__id._const_tab_at = None
    __Served_Cells_To_Delete_List__item__id._const_tab_id = 'id'
    __Served_Cells_To_Delete_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __Served_Cells_To_Delete_List__item__criticality._const_tab = ___Served_Cells_To_Delete_List__item__id_tab
    __Served_Cells_To_Delete_List__item__criticality._const_tab_at = ('..', 'id')
    __Served_Cells_To_Delete_List__item__criticality._const_tab_id = 'criticality'
    __Served_Cells_To_Delete_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __Served_Cells_To_Delete_List__item__value._const_tab = ___Served_Cells_To_Delete_List__item__id_tab
    __Served_Cells_To_Delete_List__item__value._const_tab_at = ('..', 'id')
    __Served_Cells_To_Delete_List__item__value._const_tab_id = 'Value'
    _Served_Cells_To_Delete_List__item_._cont = ASN1Dict([
        ('id', __Served_Cells_To_Delete_List__item__id),
        ('criticality', __Served_Cells_To_Delete_List__item__criticality),
        ('value', __Served_Cells_To_Delete_List__item__value),
        ])
    _Served_Cells_To_Delete_List__item_._ext = None
    Served_Cells_To_Delete_List._cont = _Served_Cells_To_Delete_List__item_
    Served_Cells_To_Delete_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< Cells-Status-List >-----#
    Cells_Status_List = SEQ_OF(name='Cells-Status-List', mode=MODE_TYPE)
    _Cells_Status_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Cells_Status_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___Cells_Status_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Cells_Status_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-Status-Item')))
    ___Cells_Status_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 88), ('criticality', 'reject'), ('Value', ____Cells_Status_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Cells_Status_List__item__id._const_tab = ___Cells_Status_List__item__id_tab
    __Cells_Status_List__item__id._const_tab_at = None
    __Cells_Status_List__item__id._const_tab_id = 'id'
    __Cells_Status_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __Cells_Status_List__item__criticality._const_tab = ___Cells_Status_List__item__id_tab
    __Cells_Status_List__item__criticality._const_tab_at = ('..', 'id')
    __Cells_Status_List__item__criticality._const_tab_id = 'criticality'
    __Cells_Status_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __Cells_Status_List__item__value._const_tab = ___Cells_Status_List__item__id_tab
    __Cells_Status_List__item__value._const_tab_at = ('..', 'id')
    __Cells_Status_List__item__value._const_tab_id = 'Value'
    _Cells_Status_List__item_._cont = ASN1Dict([
        ('id', __Cells_Status_List__item__id),
        ('criticality', __Cells_Status_List__item__criticality),
        ('value', __Cells_Status_List__item__value),
        ])
    _Cells_Status_List__item_._ext = None
    Cells_Status_List._cont = _Cells_Status_List__item_
    Cells_Status_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=512)], ev=None, er=[])
    
    #-----< Dedicated-SIDelivery-NeededUE-List >-----#
    Dedicated_SIDelivery_NeededUE_List = SEQ_OF(name='Dedicated-SIDelivery-NeededUE-List', mode=MODE_TYPE)
    _Dedicated_SIDelivery_NeededUE_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Dedicated_SIDelivery_NeededUE_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___Dedicated_SIDelivery_NeededUE_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Dedicated_SIDelivery_NeededUE_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Dedicated-SIDelivery-NeededUE-Item')))
    ___Dedicated_SIDelivery_NeededUE_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 190), ('criticality', 'ignore'), ('Value', ____Dedicated_SIDelivery_NeededUE_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Dedicated_SIDelivery_NeededUE_List__item__id._const_tab = ___Dedicated_SIDelivery_NeededUE_List__item__id_tab
    __Dedicated_SIDelivery_NeededUE_List__item__id._const_tab_at = None
    __Dedicated_SIDelivery_NeededUE_List__item__id._const_tab_id = 'id'
    __Dedicated_SIDelivery_NeededUE_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __Dedicated_SIDelivery_NeededUE_List__item__criticality._const_tab = ___Dedicated_SIDelivery_NeededUE_List__item__id_tab
    __Dedicated_SIDelivery_NeededUE_List__item__criticality._const_tab_at = ('..', 'id')
    __Dedicated_SIDelivery_NeededUE_List__item__criticality._const_tab_id = 'criticality'
    __Dedicated_SIDelivery_NeededUE_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __Dedicated_SIDelivery_NeededUE_List__item__value._const_tab = ___Dedicated_SIDelivery_NeededUE_List__item__id_tab
    __Dedicated_SIDelivery_NeededUE_List__item__value._const_tab_at = ('..', 'id')
    __Dedicated_SIDelivery_NeededUE_List__item__value._const_tab_id = 'Value'
    _Dedicated_SIDelivery_NeededUE_List__item_._cont = ASN1Dict([
        ('id', __Dedicated_SIDelivery_NeededUE_List__item__id),
        ('criticality', __Dedicated_SIDelivery_NeededUE_List__item__criticality),
        ('value', __Dedicated_SIDelivery_NeededUE_List__item__value),
        ])
    _Dedicated_SIDelivery_NeededUE_List__item_._ext = None
    Dedicated_SIDelivery_NeededUE_List._cont = _Dedicated_SIDelivery_NeededUE_List__item_
    Dedicated_SIDelivery_NeededUE_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< GNB-DU-TNL-Association-To-Remove-List >-----#
    GNB_DU_TNL_Association_To_Remove_List = SEQ_OF(name='GNB-DU-TNL-Association-To-Remove-List', mode=MODE_TYPE)
    _GNB_DU_TNL_Association_To_Remove_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __GNB_DU_TNL_Association_To_Remove_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___GNB_DU_TNL_Association_To_Remove_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____GNB_DU_TNL_Association_To_Remove_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-TNL-Association-To-Remove-Item')))
    ___GNB_DU_TNL_Association_To_Remove_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 227), ('criticality', 'reject'), ('Value', ____GNB_DU_TNL_Association_To_Remove_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __GNB_DU_TNL_Association_To_Remove_List__item__id._const_tab = ___GNB_DU_TNL_Association_To_Remove_List__item__id_tab
    __GNB_DU_TNL_Association_To_Remove_List__item__id._const_tab_at = None
    __GNB_DU_TNL_Association_To_Remove_List__item__id._const_tab_id = 'id'
    __GNB_DU_TNL_Association_To_Remove_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __GNB_DU_TNL_Association_To_Remove_List__item__criticality._const_tab = ___GNB_DU_TNL_Association_To_Remove_List__item__id_tab
    __GNB_DU_TNL_Association_To_Remove_List__item__criticality._const_tab_at = ('..', 'id')
    __GNB_DU_TNL_Association_To_Remove_List__item__criticality._const_tab_id = 'criticality'
    __GNB_DU_TNL_Association_To_Remove_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __GNB_DU_TNL_Association_To_Remove_List__item__value._const_tab = ___GNB_DU_TNL_Association_To_Remove_List__item__id_tab
    __GNB_DU_TNL_Association_To_Remove_List__item__value._const_tab_at = ('..', 'id')
    __GNB_DU_TNL_Association_To_Remove_List__item__value._const_tab_id = 'Value'
    _GNB_DU_TNL_Association_To_Remove_List__item_._cont = ASN1Dict([
        ('id', __GNB_DU_TNL_Association_To_Remove_List__item__id),
        ('criticality', __GNB_DU_TNL_Association_To_Remove_List__item__criticality),
        ('value', __GNB_DU_TNL_Association_To_Remove_List__item__value),
        ])
    _GNB_DU_TNL_Association_To_Remove_List__item_._ext = None
    GNB_DU_TNL_Association_To_Remove_List._cont = _GNB_DU_TNL_Association_To_Remove_List__item_
    GNB_DU_TNL_Association_To_Remove_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Served-Cells-To-Add-ItemIEs >-----#
    Served_Cells_To_Add_ItemIEs = CLASS(name='Served-Cells-To-Add-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Served_Cells_To_Add_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Served-Cells-To-Add-Item')))
    Served_Cells_To_Add_ItemIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _Served_Cells_To_Add_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Served-Cells-To-Modify-ItemIEs >-----#
    Served_Cells_To_Modify_ItemIEs = CLASS(name='Served-Cells-To-Modify-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Served_Cells_To_Modify_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Served-Cells-To-Modify-Item')))
    Served_Cells_To_Modify_ItemIEs._val = ASN1Set(rv=[dict([('id', 61), ('criticality', 'reject'), ('Value', _Served_Cells_To_Modify_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Served-Cells-To-Delete-ItemIEs >-----#
    Served_Cells_To_Delete_ItemIEs = CLASS(name='Served-Cells-To-Delete-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Served_Cells_To_Delete_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Served-Cells-To-Delete-Item')))
    Served_Cells_To_Delete_ItemIEs._val = ASN1Set(rv=[dict([('id', 59), ('criticality', 'reject'), ('Value', _Served_Cells_To_Delete_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Cells-Status-ItemIEs >-----#
    Cells_Status_ItemIEs = CLASS(name='Cells-Status-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Cells_Status_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-Status-Item')))
    Cells_Status_ItemIEs._val = ASN1Set(rv=[dict([('id', 88), ('criticality', 'reject'), ('Value', _Cells_Status_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Dedicated-SIDelivery-NeededUE-ItemIEs >-----#
    Dedicated_SIDelivery_NeededUE_ItemIEs = CLASS(name='Dedicated-SIDelivery-NeededUE-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Dedicated_SIDelivery_NeededUE_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Dedicated-SIDelivery-NeededUE-Item')))
    Dedicated_SIDelivery_NeededUE_ItemIEs._val = ASN1Set(rv=[dict([('id', 190), ('criticality', 'ignore'), ('Value', _Dedicated_SIDelivery_NeededUE_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GNB-DU-TNL-Association-To-Remove-ItemIEs >-----#
    GNB_DU_TNL_Association_To_Remove_ItemIEs = CLASS(name='GNB-DU-TNL-Association-To-Remove-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNB_DU_TNL_Association_To_Remove_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-TNL-Association-To-Remove-Item')))
    GNB_DU_TNL_Association_To_Remove_ItemIEs._val = ASN1Set(rv=[dict([('id', 227), ('criticality', 'reject'), ('Value', _GNB_DU_TNL_Association_To_Remove_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GNBDUConfigurationUpdateAcknowledge >-----#
    GNBDUConfigurationUpdateAcknowledge = SEQ(name='GNBDUConfigurationUpdateAcknowledge', mode=MODE_TYPE)
    _GNBDUConfigurationUpdateAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __GNBDUConfigurationUpdateAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-to-be-Activated-List')))
    _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-to-be-Deactivated-List')))
    _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-Layer-Address-Info')))
    _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-BH-Non-UP-Traffic-Mapping')))
    _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_6 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellsForSON-List')))
    ____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 254), ('criticality', 'ignore'), ('Value', _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 287), ('criticality', 'reject'), ('Value', _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 281), ('criticality', 'ignore'), ('Value', _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 449), ('criticality', 'ignore'), ('Value', _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab = ____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab = ____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab = ____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __GNBDUConfigurationUpdateAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id),
        ('criticality', ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__criticality),
        ('value', ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__value),
        ])
    __GNBDUConfigurationUpdateAcknowledge_protocolIEs__item_._ext = None
    _GNBDUConfigurationUpdateAcknowledge_protocolIEs._cont = __GNBDUConfigurationUpdateAcknowledge_protocolIEs__item_
    _GNBDUConfigurationUpdateAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNBDUConfigurationUpdateAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _GNBDUConfigurationUpdateAcknowledge_protocolIEs),
        ])
    GNBDUConfigurationUpdateAcknowledge._ext = []
    
    #-----< GNBDUConfigurationUpdateAcknowledgeIEs >-----#
    GNBDUConfigurationUpdateAcknowledgeIEs = CLASS(name='GNBDUConfigurationUpdateAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-to-be-Activated-List')))
    _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-to-be-Deactivated-List')))
    _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-Layer-Address-Info')))
    _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-BH-Non-UP-Traffic-Mapping')))
    _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_6 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellsForSON-List')))
    GNBDUConfigurationUpdateAcknowledgeIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 254), ('criticality', 'ignore'), ('Value', _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 287), ('criticality', 'reject'), ('Value', _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 281), ('criticality', 'ignore'), ('Value', _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 449), ('criticality', 'ignore'), ('Value', _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNBDUConfigurationUpdateFailure >-----#
    GNBDUConfigurationUpdateFailure = SEQ(name='GNBDUConfigurationUpdateFailure', mode=MODE_TYPE)
    _GNBDUConfigurationUpdateFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __GNBDUConfigurationUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___GNBDUConfigurationUpdateFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNBDUConfigurationUpdateFailure_protocolIEs__item__id._const_tab = ____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___GNBDUConfigurationUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___GNBDUConfigurationUpdateFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___GNBDUConfigurationUpdateFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___GNBDUConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab = ____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___GNBDUConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNBDUConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNBDUConfigurationUpdateFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___GNBDUConfigurationUpdateFailure_protocolIEs__item__value._const_tab = ____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___GNBDUConfigurationUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNBDUConfigurationUpdateFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __GNBDUConfigurationUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNBDUConfigurationUpdateFailure_protocolIEs__item__id),
        ('criticality', ___GNBDUConfigurationUpdateFailure_protocolIEs__item__criticality),
        ('value', ___GNBDUConfigurationUpdateFailure_protocolIEs__item__value),
        ])
    __GNBDUConfigurationUpdateFailure_protocolIEs__item_._ext = None
    _GNBDUConfigurationUpdateFailure_protocolIEs._cont = __GNBDUConfigurationUpdateFailure_protocolIEs__item_
    _GNBDUConfigurationUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNBDUConfigurationUpdateFailure._cont = ASN1Dict([
        ('protocolIEs', _GNBDUConfigurationUpdateFailure_protocolIEs),
        ])
    GNBDUConfigurationUpdateFailure._ext = []
    
    #-----< GNBDUConfigurationUpdateFailureIEs >-----#
    GNBDUConfigurationUpdateFailureIEs = CLASS(name='GNBDUConfigurationUpdateFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNBDUConfigurationUpdateFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _GNBDUConfigurationUpdateFailureIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _GNBDUConfigurationUpdateFailureIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _GNBDUConfigurationUpdateFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    GNBDUConfigurationUpdateFailureIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _GNBDUConfigurationUpdateFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _GNBDUConfigurationUpdateFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _GNBDUConfigurationUpdateFailureIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _GNBDUConfigurationUpdateFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNBCUConfigurationUpdate >-----#
    GNBCUConfigurationUpdate = SEQ(name='GNBCUConfigurationUpdate', mode=MODE_TYPE)
    _GNBCUConfigurationUpdate_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __GNBCUConfigurationUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___GNBCUConfigurationUpdate_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____GNBCUConfigurationUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-to-be-Activated-List')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-to-be-Deactivated-List')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-CU-TNL-Association-To-Add-List')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-CU-TNL-Association-To-Remove-List')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-CU-TNL-Association-To-Update-List')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-to-be-Barred-List')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Protected-EUTRA-Resources-List')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_8 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Neighbour-Cell-Information-List')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-Layer-Address-Info')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-BH-Non-UP-Traffic-Mapping')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_11 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_12 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CCO-Assistance-Information')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_13 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellsForSON-List')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_14 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-Name')))
    _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_15 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Extended-GNB-CU-Name')))
    ____GNBCUConfigurationUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 123), ('criticality', 'ignore'), ('Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 125), ('criticality', 'ignore'), ('Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 129), ('criticality', 'ignore'), ('Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 105), ('criticality', 'reject'), ('Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 244), ('criticality', 'ignore'), ('Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 254), ('criticality', 'ignore'), ('Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 287), ('criticality', 'reject'), ('Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 281), ('criticality', 'ignore'), ('Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 447), ('criticality', 'ignore'), ('Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 449), ('criticality', 'ignore'), ('Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 82), ('criticality', 'ignore'), ('Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 426), ('criticality', 'ignore'), ('Value', _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNBCUConfigurationUpdate_protocolIEs__item__id._const_tab = ____GNBCUConfigurationUpdate_protocolIEs__item__id_tab
    ___GNBCUConfigurationUpdate_protocolIEs__item__id._const_tab_at = None
    ___GNBCUConfigurationUpdate_protocolIEs__item__id._const_tab_id = 'id'
    ___GNBCUConfigurationUpdate_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___GNBCUConfigurationUpdate_protocolIEs__item__criticality._const_tab = ____GNBCUConfigurationUpdate_protocolIEs__item__id_tab
    ___GNBCUConfigurationUpdate_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNBCUConfigurationUpdate_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNBCUConfigurationUpdate_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___GNBCUConfigurationUpdate_protocolIEs__item__value._const_tab = ____GNBCUConfigurationUpdate_protocolIEs__item__id_tab
    ___GNBCUConfigurationUpdate_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNBCUConfigurationUpdate_protocolIEs__item__value._const_tab_id = 'Value'
    __GNBCUConfigurationUpdate_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNBCUConfigurationUpdate_protocolIEs__item__id),
        ('criticality', ___GNBCUConfigurationUpdate_protocolIEs__item__criticality),
        ('value', ___GNBCUConfigurationUpdate_protocolIEs__item__value),
        ])
    __GNBCUConfigurationUpdate_protocolIEs__item_._ext = None
    _GNBCUConfigurationUpdate_protocolIEs._cont = __GNBCUConfigurationUpdate_protocolIEs__item_
    _GNBCUConfigurationUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNBCUConfigurationUpdate._cont = ASN1Dict([
        ('protocolIEs', _GNBCUConfigurationUpdate_protocolIEs),
        ])
    GNBCUConfigurationUpdate._ext = []
    
    #-----< GNBCUConfigurationUpdateIEs >-----#
    GNBCUConfigurationUpdateIEs = CLASS(name='GNBCUConfigurationUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNBCUConfigurationUpdateIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _GNBCUConfigurationUpdateIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-to-be-Activated-List')))
    _GNBCUConfigurationUpdateIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-to-be-Deactivated-List')))
    _GNBCUConfigurationUpdateIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-CU-TNL-Association-To-Add-List')))
    _GNBCUConfigurationUpdateIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-CU-TNL-Association-To-Remove-List')))
    _GNBCUConfigurationUpdateIEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-CU-TNL-Association-To-Update-List')))
    _GNBCUConfigurationUpdateIEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-to-be-Barred-List')))
    _GNBCUConfigurationUpdateIEs_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Protected-EUTRA-Resources-List')))
    _GNBCUConfigurationUpdateIEs_val_Value_8 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Neighbour-Cell-Information-List')))
    _GNBCUConfigurationUpdateIEs_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-Layer-Address-Info')))
    _GNBCUConfigurationUpdateIEs_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-BH-Non-UP-Traffic-Mapping')))
    _GNBCUConfigurationUpdateIEs_val_Value_11 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    _GNBCUConfigurationUpdateIEs_val_Value_12 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CCO-Assistance-Information')))
    _GNBCUConfigurationUpdateIEs_val_Value_13 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellsForSON-List')))
    _GNBCUConfigurationUpdateIEs_val_Value_14 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-Name')))
    _GNBCUConfigurationUpdateIEs_val_Value_15 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Extended-GNB-CU-Name')))
    GNBCUConfigurationUpdateIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _GNBCUConfigurationUpdateIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _GNBCUConfigurationUpdateIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _GNBCUConfigurationUpdateIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _GNBCUConfigurationUpdateIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 123), ('criticality', 'ignore'), ('Value', _GNBCUConfigurationUpdateIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 125), ('criticality', 'ignore'), ('Value', _GNBCUConfigurationUpdateIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 129), ('criticality', 'ignore'), ('Value', _GNBCUConfigurationUpdateIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 105), ('criticality', 'reject'), ('Value', _GNBCUConfigurationUpdateIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 244), ('criticality', 'ignore'), ('Value', _GNBCUConfigurationUpdateIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 254), ('criticality', 'ignore'), ('Value', _GNBCUConfigurationUpdateIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 287), ('criticality', 'reject'), ('Value', _GNBCUConfigurationUpdateIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 281), ('criticality', 'ignore'), ('Value', _GNBCUConfigurationUpdateIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 447), ('criticality', 'ignore'), ('Value', _GNBCUConfigurationUpdateIEs_val_Value_12), ('presence', 'optional')]), dict([('id', 449), ('criticality', 'ignore'), ('Value', _GNBCUConfigurationUpdateIEs_val_Value_13), ('presence', 'optional')]), dict([('id', 82), ('criticality', 'ignore'), ('Value', _GNBCUConfigurationUpdateIEs_val_Value_14), ('presence', 'optional')]), dict([('id', 426), ('criticality', 'ignore'), ('Value', _GNBCUConfigurationUpdateIEs_val_Value_15), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Cells-to-be-Deactivated-List >-----#
    Cells_to_be_Deactivated_List = SEQ_OF(name='Cells-to-be-Deactivated-List', mode=MODE_TYPE)
    _Cells_to_be_Deactivated_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Cells_to_be_Deactivated_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___Cells_to_be_Deactivated_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Cells_to_be_Deactivated_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-to-be-Deactivated-List-Item')))
    ___Cells_to_be_Deactivated_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 6), ('criticality', 'reject'), ('Value', ____Cells_to_be_Deactivated_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Cells_to_be_Deactivated_List__item__id._const_tab = ___Cells_to_be_Deactivated_List__item__id_tab
    __Cells_to_be_Deactivated_List__item__id._const_tab_at = None
    __Cells_to_be_Deactivated_List__item__id._const_tab_id = 'id'
    __Cells_to_be_Deactivated_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __Cells_to_be_Deactivated_List__item__criticality._const_tab = ___Cells_to_be_Deactivated_List__item__id_tab
    __Cells_to_be_Deactivated_List__item__criticality._const_tab_at = ('..', 'id')
    __Cells_to_be_Deactivated_List__item__criticality._const_tab_id = 'criticality'
    __Cells_to_be_Deactivated_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __Cells_to_be_Deactivated_List__item__value._const_tab = ___Cells_to_be_Deactivated_List__item__id_tab
    __Cells_to_be_Deactivated_List__item__value._const_tab_at = ('..', 'id')
    __Cells_to_be_Deactivated_List__item__value._const_tab_id = 'Value'
    _Cells_to_be_Deactivated_List__item_._cont = ASN1Dict([
        ('id', __Cells_to_be_Deactivated_List__item__id),
        ('criticality', __Cells_to_be_Deactivated_List__item__criticality),
        ('value', __Cells_to_be_Deactivated_List__item__value),
        ])
    _Cells_to_be_Deactivated_List__item_._ext = None
    Cells_to_be_Deactivated_List._cont = _Cells_to_be_Deactivated_List__item_
    Cells_to_be_Deactivated_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< GNB-CU-TNL-Association-To-Add-List >-----#
    GNB_CU_TNL_Association_To_Add_List = SEQ_OF(name='GNB-CU-TNL-Association-To-Add-List', mode=MODE_TYPE)
    _GNB_CU_TNL_Association_To_Add_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __GNB_CU_TNL_Association_To_Add_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___GNB_CU_TNL_Association_To_Add_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____GNB_CU_TNL_Association_To_Add_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-TNL-Association-To-Add-Item')))
    ___GNB_CU_TNL_Association_To_Add_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 120), ('criticality', 'ignore'), ('Value', ____GNB_CU_TNL_Association_To_Add_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __GNB_CU_TNL_Association_To_Add_List__item__id._const_tab = ___GNB_CU_TNL_Association_To_Add_List__item__id_tab
    __GNB_CU_TNL_Association_To_Add_List__item__id._const_tab_at = None
    __GNB_CU_TNL_Association_To_Add_List__item__id._const_tab_id = 'id'
    __GNB_CU_TNL_Association_To_Add_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __GNB_CU_TNL_Association_To_Add_List__item__criticality._const_tab = ___GNB_CU_TNL_Association_To_Add_List__item__id_tab
    __GNB_CU_TNL_Association_To_Add_List__item__criticality._const_tab_at = ('..', 'id')
    __GNB_CU_TNL_Association_To_Add_List__item__criticality._const_tab_id = 'criticality'
    __GNB_CU_TNL_Association_To_Add_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __GNB_CU_TNL_Association_To_Add_List__item__value._const_tab = ___GNB_CU_TNL_Association_To_Add_List__item__id_tab
    __GNB_CU_TNL_Association_To_Add_List__item__value._const_tab_at = ('..', 'id')
    __GNB_CU_TNL_Association_To_Add_List__item__value._const_tab_id = 'Value'
    _GNB_CU_TNL_Association_To_Add_List__item_._cont = ASN1Dict([
        ('id', __GNB_CU_TNL_Association_To_Add_List__item__id),
        ('criticality', __GNB_CU_TNL_Association_To_Add_List__item__criticality),
        ('value', __GNB_CU_TNL_Association_To_Add_List__item__value),
        ])
    _GNB_CU_TNL_Association_To_Add_List__item_._ext = None
    GNB_CU_TNL_Association_To_Add_List._cont = _GNB_CU_TNL_Association_To_Add_List__item_
    GNB_CU_TNL_Association_To_Add_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< GNB-CU-TNL-Association-To-Remove-List >-----#
    GNB_CU_TNL_Association_To_Remove_List = SEQ_OF(name='GNB-CU-TNL-Association-To-Remove-List', mode=MODE_TYPE)
    _GNB_CU_TNL_Association_To_Remove_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __GNB_CU_TNL_Association_To_Remove_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___GNB_CU_TNL_Association_To_Remove_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____GNB_CU_TNL_Association_To_Remove_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-TNL-Association-To-Remove-Item')))
    ___GNB_CU_TNL_Association_To_Remove_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 122), ('criticality', 'ignore'), ('Value', ____GNB_CU_TNL_Association_To_Remove_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __GNB_CU_TNL_Association_To_Remove_List__item__id._const_tab = ___GNB_CU_TNL_Association_To_Remove_List__item__id_tab
    __GNB_CU_TNL_Association_To_Remove_List__item__id._const_tab_at = None
    __GNB_CU_TNL_Association_To_Remove_List__item__id._const_tab_id = 'id'
    __GNB_CU_TNL_Association_To_Remove_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __GNB_CU_TNL_Association_To_Remove_List__item__criticality._const_tab = ___GNB_CU_TNL_Association_To_Remove_List__item__id_tab
    __GNB_CU_TNL_Association_To_Remove_List__item__criticality._const_tab_at = ('..', 'id')
    __GNB_CU_TNL_Association_To_Remove_List__item__criticality._const_tab_id = 'criticality'
    __GNB_CU_TNL_Association_To_Remove_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __GNB_CU_TNL_Association_To_Remove_List__item__value._const_tab = ___GNB_CU_TNL_Association_To_Remove_List__item__id_tab
    __GNB_CU_TNL_Association_To_Remove_List__item__value._const_tab_at = ('..', 'id')
    __GNB_CU_TNL_Association_To_Remove_List__item__value._const_tab_id = 'Value'
    _GNB_CU_TNL_Association_To_Remove_List__item_._cont = ASN1Dict([
        ('id', __GNB_CU_TNL_Association_To_Remove_List__item__id),
        ('criticality', __GNB_CU_TNL_Association_To_Remove_List__item__criticality),
        ('value', __GNB_CU_TNL_Association_To_Remove_List__item__value),
        ])
    _GNB_CU_TNL_Association_To_Remove_List__item_._ext = None
    GNB_CU_TNL_Association_To_Remove_List._cont = _GNB_CU_TNL_Association_To_Remove_List__item_
    GNB_CU_TNL_Association_To_Remove_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< GNB-CU-TNL-Association-To-Update-List >-----#
    GNB_CU_TNL_Association_To_Update_List = SEQ_OF(name='GNB-CU-TNL-Association-To-Update-List', mode=MODE_TYPE)
    _GNB_CU_TNL_Association_To_Update_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __GNB_CU_TNL_Association_To_Update_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___GNB_CU_TNL_Association_To_Update_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____GNB_CU_TNL_Association_To_Update_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-TNL-Association-To-Update-Item')))
    ___GNB_CU_TNL_Association_To_Update_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 124), ('criticality', 'ignore'), ('Value', ____GNB_CU_TNL_Association_To_Update_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __GNB_CU_TNL_Association_To_Update_List__item__id._const_tab = ___GNB_CU_TNL_Association_To_Update_List__item__id_tab
    __GNB_CU_TNL_Association_To_Update_List__item__id._const_tab_at = None
    __GNB_CU_TNL_Association_To_Update_List__item__id._const_tab_id = 'id'
    __GNB_CU_TNL_Association_To_Update_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __GNB_CU_TNL_Association_To_Update_List__item__criticality._const_tab = ___GNB_CU_TNL_Association_To_Update_List__item__id_tab
    __GNB_CU_TNL_Association_To_Update_List__item__criticality._const_tab_at = ('..', 'id')
    __GNB_CU_TNL_Association_To_Update_List__item__criticality._const_tab_id = 'criticality'
    __GNB_CU_TNL_Association_To_Update_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __GNB_CU_TNL_Association_To_Update_List__item__value._const_tab = ___GNB_CU_TNL_Association_To_Update_List__item__id_tab
    __GNB_CU_TNL_Association_To_Update_List__item__value._const_tab_at = ('..', 'id')
    __GNB_CU_TNL_Association_To_Update_List__item__value._const_tab_id = 'Value'
    _GNB_CU_TNL_Association_To_Update_List__item_._cont = ASN1Dict([
        ('id', __GNB_CU_TNL_Association_To_Update_List__item__id),
        ('criticality', __GNB_CU_TNL_Association_To_Update_List__item__criticality),
        ('value', __GNB_CU_TNL_Association_To_Update_List__item__value),
        ])
    _GNB_CU_TNL_Association_To_Update_List__item_._ext = None
    GNB_CU_TNL_Association_To_Update_List._cont = _GNB_CU_TNL_Association_To_Update_List__item_
    GNB_CU_TNL_Association_To_Update_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Cells-to-be-Barred-List >-----#
    Cells_to_be_Barred_List = SEQ_OF(name='Cells-to-be-Barred-List', mode=MODE_TYPE)
    _Cells_to_be_Barred_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Cells_to_be_Barred_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___Cells_to_be_Barred_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Cells_to_be_Barred_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-to-be-Barred-Item')))
    ___Cells_to_be_Barred_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 130), ('criticality', 'ignore'), ('Value', ____Cells_to_be_Barred_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Cells_to_be_Barred_List__item__id._const_tab = ___Cells_to_be_Barred_List__item__id_tab
    __Cells_to_be_Barred_List__item__id._const_tab_at = None
    __Cells_to_be_Barred_List__item__id._const_tab_id = 'id'
    __Cells_to_be_Barred_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __Cells_to_be_Barred_List__item__criticality._const_tab = ___Cells_to_be_Barred_List__item__id_tab
    __Cells_to_be_Barred_List__item__criticality._const_tab_at = ('..', 'id')
    __Cells_to_be_Barred_List__item__criticality._const_tab_id = 'criticality'
    __Cells_to_be_Barred_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __Cells_to_be_Barred_List__item__value._const_tab = ___Cells_to_be_Barred_List__item__id_tab
    __Cells_to_be_Barred_List__item__value._const_tab_at = ('..', 'id')
    __Cells_to_be_Barred_List__item__value._const_tab_id = 'Value'
    _Cells_to_be_Barred_List__item_._cont = ASN1Dict([
        ('id', __Cells_to_be_Barred_List__item__id),
        ('criticality', __Cells_to_be_Barred_List__item__criticality),
        ('value', __Cells_to_be_Barred_List__item__value),
        ])
    _Cells_to_be_Barred_List__item_._ext = None
    Cells_to_be_Barred_List._cont = _Cells_to_be_Barred_List__item_
    Cells_to_be_Barred_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< Cells-to-be-Deactivated-List-ItemIEs >-----#
    Cells_to_be_Deactivated_List_ItemIEs = CLASS(name='Cells-to-be-Deactivated-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Cells_to_be_Deactivated_List_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-to-be-Deactivated-List-Item')))
    Cells_to_be_Deactivated_List_ItemIEs._val = ASN1Set(rv=[dict([('id', 6), ('criticality', 'reject'), ('Value', _Cells_to_be_Deactivated_List_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-TNL-Association-To-Add-ItemIEs >-----#
    GNB_CU_TNL_Association_To_Add_ItemIEs = CLASS(name='GNB-CU-TNL-Association-To-Add-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNB_CU_TNL_Association_To_Add_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-TNL-Association-To-Add-Item')))
    GNB_CU_TNL_Association_To_Add_ItemIEs._val = ASN1Set(rv=[dict([('id', 120), ('criticality', 'ignore'), ('Value', _GNB_CU_TNL_Association_To_Add_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-TNL-Association-To-Remove-ItemIEs >-----#
    GNB_CU_TNL_Association_To_Remove_ItemIEs = CLASS(name='GNB-CU-TNL-Association-To-Remove-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNB_CU_TNL_Association_To_Remove_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-TNL-Association-To-Remove-Item')))
    GNB_CU_TNL_Association_To_Remove_ItemIEs._val = ASN1Set(rv=[dict([('id', 122), ('criticality', 'ignore'), ('Value', _GNB_CU_TNL_Association_To_Remove_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-TNL-Association-To-Update-ItemIEs >-----#
    GNB_CU_TNL_Association_To_Update_ItemIEs = CLASS(name='GNB-CU-TNL-Association-To-Update-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNB_CU_TNL_Association_To_Update_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-TNL-Association-To-Update-Item')))
    GNB_CU_TNL_Association_To_Update_ItemIEs._val = ASN1Set(rv=[dict([('id', 124), ('criticality', 'ignore'), ('Value', _GNB_CU_TNL_Association_To_Update_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Cells-to-be-Barred-ItemIEs >-----#
    Cells_to_be_Barred_ItemIEs = CLASS(name='Cells-to-be-Barred-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Cells_to_be_Barred_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-to-be-Barred-Item')))
    Cells_to_be_Barred_ItemIEs._val = ASN1Set(rv=[dict([('id', 130), ('criticality', 'ignore'), ('Value', _Cells_to_be_Barred_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Protected-EUTRA-Resources-List >-----#
    Protected_EUTRA_Resources_List = SEQ_OF(name='Protected-EUTRA-Resources-List', mode=MODE_TYPE)
    _Protected_EUTRA_Resources_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Protected_EUTRA_Resources_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___Protected_EUTRA_Resources_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Protected_EUTRA_Resources_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Protected-EUTRA-Resources-Item')))
    ___Protected_EUTRA_Resources_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 168), ('criticality', 'reject'), ('Value', ____Protected_EUTRA_Resources_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Protected_EUTRA_Resources_List__item__id._const_tab = ___Protected_EUTRA_Resources_List__item__id_tab
    __Protected_EUTRA_Resources_List__item__id._const_tab_at = None
    __Protected_EUTRA_Resources_List__item__id._const_tab_id = 'id'
    __Protected_EUTRA_Resources_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __Protected_EUTRA_Resources_List__item__criticality._const_tab = ___Protected_EUTRA_Resources_List__item__id_tab
    __Protected_EUTRA_Resources_List__item__criticality._const_tab_at = ('..', 'id')
    __Protected_EUTRA_Resources_List__item__criticality._const_tab_id = 'criticality'
    __Protected_EUTRA_Resources_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __Protected_EUTRA_Resources_List__item__value._const_tab = ___Protected_EUTRA_Resources_List__item__id_tab
    __Protected_EUTRA_Resources_List__item__value._const_tab_at = ('..', 'id')
    __Protected_EUTRA_Resources_List__item__value._const_tab_id = 'Value'
    _Protected_EUTRA_Resources_List__item_._cont = ASN1Dict([
        ('id', __Protected_EUTRA_Resources_List__item__id),
        ('criticality', __Protected_EUTRA_Resources_List__item__criticality),
        ('value', __Protected_EUTRA_Resources_List__item__value),
        ])
    _Protected_EUTRA_Resources_List__item_._ext = None
    Protected_EUTRA_Resources_List._cont = _Protected_EUTRA_Resources_List__item_
    Protected_EUTRA_Resources_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Protected-EUTRA-Resources-ItemIEs >-----#
    Protected_EUTRA_Resources_ItemIEs = CLASS(name='Protected-EUTRA-Resources-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Protected_EUTRA_Resources_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Protected-EUTRA-Resources-Item')))
    Protected_EUTRA_Resources_ItemIEs._val = ASN1Set(rv=[dict([('id', 168), ('criticality', 'reject'), ('Value', _Protected_EUTRA_Resources_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Neighbour-Cell-Information-List >-----#
    Neighbour_Cell_Information_List = SEQ_OF(name='Neighbour-Cell-Information-List', mode=MODE_TYPE)
    _Neighbour_Cell_Information_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Neighbour_Cell_Information_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___Neighbour_Cell_Information_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Neighbour_Cell_Information_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Neighbour-Cell-Information-Item')))
    ___Neighbour_Cell_Information_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 255), ('criticality', 'ignore'), ('Value', ____Neighbour_Cell_Information_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Neighbour_Cell_Information_List__item__id._const_tab = ___Neighbour_Cell_Information_List__item__id_tab
    __Neighbour_Cell_Information_List__item__id._const_tab_at = None
    __Neighbour_Cell_Information_List__item__id._const_tab_id = 'id'
    __Neighbour_Cell_Information_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __Neighbour_Cell_Information_List__item__criticality._const_tab = ___Neighbour_Cell_Information_List__item__id_tab
    __Neighbour_Cell_Information_List__item__criticality._const_tab_at = ('..', 'id')
    __Neighbour_Cell_Information_List__item__criticality._const_tab_id = 'criticality'
    __Neighbour_Cell_Information_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __Neighbour_Cell_Information_List__item__value._const_tab = ___Neighbour_Cell_Information_List__item__id_tab
    __Neighbour_Cell_Information_List__item__value._const_tab_at = ('..', 'id')
    __Neighbour_Cell_Information_List__item__value._const_tab_id = 'Value'
    _Neighbour_Cell_Information_List__item_._cont = ASN1Dict([
        ('id', __Neighbour_Cell_Information_List__item__id),
        ('criticality', __Neighbour_Cell_Information_List__item__criticality),
        ('value', __Neighbour_Cell_Information_List__item__value),
        ])
    _Neighbour_Cell_Information_List__item_._ext = None
    Neighbour_Cell_Information_List._cont = _Neighbour_Cell_Information_List__item_
    Neighbour_Cell_Information_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< Neighbour-Cell-Information-ItemIEs >-----#
    Neighbour_Cell_Information_ItemIEs = CLASS(name='Neighbour-Cell-Information-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Neighbour_Cell_Information_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Neighbour-Cell-Information-Item')))
    Neighbour_Cell_Information_ItemIEs._val = ASN1Set(rv=[dict([('id', 255), ('criticality', 'ignore'), ('Value', _Neighbour_Cell_Information_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GNBCUConfigurationUpdateAcknowledge >-----#
    GNBCUConfigurationUpdateAcknowledge = SEQ(name='GNBCUConfigurationUpdateAcknowledge', mode=MODE_TYPE)
    _GNBCUConfigurationUpdateAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __GNBCUConfigurationUpdateAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-Failed-to-be-Activated-List')))
    _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-CU-TNL-Association-Setup-List')))
    _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-CU-TNL-Association-Failed-To-Setup-List')))
    _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Dedicated-SIDelivery-NeededUE-List')))
    _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-Layer-Address-Info')))
    ____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'reject'), ('Value', _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 132), ('criticality', 'ignore'), ('Value', _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 134), ('criticality', 'ignore'), ('Value', _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 189), ('criticality', 'ignore'), ('Value', _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 254), ('criticality', 'ignore'), ('Value', _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab = ____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab = ____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab = ____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __GNBCUConfigurationUpdateAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id),
        ('criticality', ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__criticality),
        ('value', ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__value),
        ])
    __GNBCUConfigurationUpdateAcknowledge_protocolIEs__item_._ext = None
    _GNBCUConfigurationUpdateAcknowledge_protocolIEs._cont = __GNBCUConfigurationUpdateAcknowledge_protocolIEs__item_
    _GNBCUConfigurationUpdateAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNBCUConfigurationUpdateAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _GNBCUConfigurationUpdateAcknowledge_protocolIEs),
        ])
    GNBCUConfigurationUpdateAcknowledge._ext = []
    
    #-----< GNBCUConfigurationUpdateAcknowledgeIEs >-----#
    GNBCUConfigurationUpdateAcknowledgeIEs = CLASS(name='GNBCUConfigurationUpdateAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-Failed-to-be-Activated-List')))
    _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-CU-TNL-Association-Setup-List')))
    _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNB-CU-TNL-Association-Failed-To-Setup-List')))
    _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Dedicated-SIDelivery-NeededUE-List')))
    _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Transport-Layer-Address-Info')))
    GNBCUConfigurationUpdateAcknowledgeIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'reject'), ('Value', _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 132), ('criticality', 'ignore'), ('Value', _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 134), ('criticality', 'ignore'), ('Value', _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 189), ('criticality', 'ignore'), ('Value', _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 254), ('criticality', 'ignore'), ('Value', _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Cells-Failed-to-be-Activated-List >-----#
    Cells_Failed_to_be_Activated_List = SEQ_OF(name='Cells-Failed-to-be-Activated-List', mode=MODE_TYPE)
    _Cells_Failed_to_be_Activated_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Cells_Failed_to_be_Activated_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___Cells_Failed_to_be_Activated_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Cells_Failed_to_be_Activated_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-Failed-to-be-Activated-List-Item')))
    ___Cells_Failed_to_be_Activated_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', ____Cells_Failed_to_be_Activated_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Cells_Failed_to_be_Activated_List__item__id._const_tab = ___Cells_Failed_to_be_Activated_List__item__id_tab
    __Cells_Failed_to_be_Activated_List__item__id._const_tab_at = None
    __Cells_Failed_to_be_Activated_List__item__id._const_tab_id = 'id'
    __Cells_Failed_to_be_Activated_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __Cells_Failed_to_be_Activated_List__item__criticality._const_tab = ___Cells_Failed_to_be_Activated_List__item__id_tab
    __Cells_Failed_to_be_Activated_List__item__criticality._const_tab_at = ('..', 'id')
    __Cells_Failed_to_be_Activated_List__item__criticality._const_tab_id = 'criticality'
    __Cells_Failed_to_be_Activated_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __Cells_Failed_to_be_Activated_List__item__value._const_tab = ___Cells_Failed_to_be_Activated_List__item__id_tab
    __Cells_Failed_to_be_Activated_List__item__value._const_tab_at = ('..', 'id')
    __Cells_Failed_to_be_Activated_List__item__value._const_tab_id = 'Value'
    _Cells_Failed_to_be_Activated_List__item_._cont = ASN1Dict([
        ('id', __Cells_Failed_to_be_Activated_List__item__id),
        ('criticality', __Cells_Failed_to_be_Activated_List__item__criticality),
        ('value', __Cells_Failed_to_be_Activated_List__item__value),
        ])
    _Cells_Failed_to_be_Activated_List__item_._ext = None
    Cells_Failed_to_be_Activated_List._cont = _Cells_Failed_to_be_Activated_List__item_
    Cells_Failed_to_be_Activated_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< GNB-CU-TNL-Association-Setup-List >-----#
    GNB_CU_TNL_Association_Setup_List = SEQ_OF(name='GNB-CU-TNL-Association-Setup-List', mode=MODE_TYPE)
    _GNB_CU_TNL_Association_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __GNB_CU_TNL_Association_Setup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___GNB_CU_TNL_Association_Setup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____GNB_CU_TNL_Association_Setup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-TNL-Association-Setup-Item')))
    ___GNB_CU_TNL_Association_Setup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 133), ('criticality', 'ignore'), ('Value', ____GNB_CU_TNL_Association_Setup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __GNB_CU_TNL_Association_Setup_List__item__id._const_tab = ___GNB_CU_TNL_Association_Setup_List__item__id_tab
    __GNB_CU_TNL_Association_Setup_List__item__id._const_tab_at = None
    __GNB_CU_TNL_Association_Setup_List__item__id._const_tab_id = 'id'
    __GNB_CU_TNL_Association_Setup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __GNB_CU_TNL_Association_Setup_List__item__criticality._const_tab = ___GNB_CU_TNL_Association_Setup_List__item__id_tab
    __GNB_CU_TNL_Association_Setup_List__item__criticality._const_tab_at = ('..', 'id')
    __GNB_CU_TNL_Association_Setup_List__item__criticality._const_tab_id = 'criticality'
    __GNB_CU_TNL_Association_Setup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __GNB_CU_TNL_Association_Setup_List__item__value._const_tab = ___GNB_CU_TNL_Association_Setup_List__item__id_tab
    __GNB_CU_TNL_Association_Setup_List__item__value._const_tab_at = ('..', 'id')
    __GNB_CU_TNL_Association_Setup_List__item__value._const_tab_id = 'Value'
    _GNB_CU_TNL_Association_Setup_List__item_._cont = ASN1Dict([
        ('id', __GNB_CU_TNL_Association_Setup_List__item__id),
        ('criticality', __GNB_CU_TNL_Association_Setup_List__item__criticality),
        ('value', __GNB_CU_TNL_Association_Setup_List__item__value),
        ])
    _GNB_CU_TNL_Association_Setup_List__item_._ext = None
    GNB_CU_TNL_Association_Setup_List._cont = _GNB_CU_TNL_Association_Setup_List__item_
    GNB_CU_TNL_Association_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< GNB-CU-TNL-Association-Failed-To-Setup-List >-----#
    GNB_CU_TNL_Association_Failed_To_Setup_List = SEQ_OF(name='GNB-CU-TNL-Association-Failed-To-Setup-List', mode=MODE_TYPE)
    _GNB_CU_TNL_Association_Failed_To_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __GNB_CU_TNL_Association_Failed_To_Setup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___GNB_CU_TNL_Association_Failed_To_Setup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____GNB_CU_TNL_Association_Failed_To_Setup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-TNL-Association-Failed-To-Setup-Item')))
    ___GNB_CU_TNL_Association_Failed_To_Setup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 135), ('criticality', 'ignore'), ('Value', ____GNB_CU_TNL_Association_Failed_To_Setup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __GNB_CU_TNL_Association_Failed_To_Setup_List__item__id._const_tab = ___GNB_CU_TNL_Association_Failed_To_Setup_List__item__id_tab
    __GNB_CU_TNL_Association_Failed_To_Setup_List__item__id._const_tab_at = None
    __GNB_CU_TNL_Association_Failed_To_Setup_List__item__id._const_tab_id = 'id'
    __GNB_CU_TNL_Association_Failed_To_Setup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __GNB_CU_TNL_Association_Failed_To_Setup_List__item__criticality._const_tab = ___GNB_CU_TNL_Association_Failed_To_Setup_List__item__id_tab
    __GNB_CU_TNL_Association_Failed_To_Setup_List__item__criticality._const_tab_at = ('..', 'id')
    __GNB_CU_TNL_Association_Failed_To_Setup_List__item__criticality._const_tab_id = 'criticality'
    __GNB_CU_TNL_Association_Failed_To_Setup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __GNB_CU_TNL_Association_Failed_To_Setup_List__item__value._const_tab = ___GNB_CU_TNL_Association_Failed_To_Setup_List__item__id_tab
    __GNB_CU_TNL_Association_Failed_To_Setup_List__item__value._const_tab_at = ('..', 'id')
    __GNB_CU_TNL_Association_Failed_To_Setup_List__item__value._const_tab_id = 'Value'
    _GNB_CU_TNL_Association_Failed_To_Setup_List__item_._cont = ASN1Dict([
        ('id', __GNB_CU_TNL_Association_Failed_To_Setup_List__item__id),
        ('criticality', __GNB_CU_TNL_Association_Failed_To_Setup_List__item__criticality),
        ('value', __GNB_CU_TNL_Association_Failed_To_Setup_List__item__value),
        ])
    _GNB_CU_TNL_Association_Failed_To_Setup_List__item_._ext = None
    GNB_CU_TNL_Association_Failed_To_Setup_List._cont = _GNB_CU_TNL_Association_Failed_To_Setup_List__item_
    GNB_CU_TNL_Association_Failed_To_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Cells-Failed-to-be-Activated-List-ItemIEs >-----#
    Cells_Failed_to_be_Activated_List_ItemIEs = CLASS(name='Cells-Failed-to-be-Activated-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Cells_Failed_to_be_Activated_List_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-Failed-to-be-Activated-List-Item')))
    Cells_Failed_to_be_Activated_List_ItemIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _Cells_Failed_to_be_Activated_List_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-TNL-Association-Setup-ItemIEs >-----#
    GNB_CU_TNL_Association_Setup_ItemIEs = CLASS(name='GNB-CU-TNL-Association-Setup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNB_CU_TNL_Association_Setup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-TNL-Association-Setup-Item')))
    GNB_CU_TNL_Association_Setup_ItemIEs._val = ASN1Set(rv=[dict([('id', 133), ('criticality', 'ignore'), ('Value', _GNB_CU_TNL_Association_Setup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GNB-CU-TNL-Association-Failed-To-Setup-ItemIEs >-----#
    GNB_CU_TNL_Association_Failed_To_Setup_ItemIEs = CLASS(name='GNB-CU-TNL-Association-Failed-To-Setup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNB_CU_TNL_Association_Failed_To_Setup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-TNL-Association-Failed-To-Setup-Item')))
    GNB_CU_TNL_Association_Failed_To_Setup_ItemIEs._val = ASN1Set(rv=[dict([('id', 135), ('criticality', 'ignore'), ('Value', _GNB_CU_TNL_Association_Failed_To_Setup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GNBCUConfigurationUpdateFailure >-----#
    GNBCUConfigurationUpdateFailure = SEQ(name='GNBCUConfigurationUpdateFailure', mode=MODE_TYPE)
    _GNBCUConfigurationUpdateFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __GNBCUConfigurationUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___GNBCUConfigurationUpdateFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNBCUConfigurationUpdateFailure_protocolIEs__item__id._const_tab = ____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___GNBCUConfigurationUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___GNBCUConfigurationUpdateFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___GNBCUConfigurationUpdateFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___GNBCUConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab = ____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___GNBCUConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNBCUConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNBCUConfigurationUpdateFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___GNBCUConfigurationUpdateFailure_protocolIEs__item__value._const_tab = ____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___GNBCUConfigurationUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNBCUConfigurationUpdateFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __GNBCUConfigurationUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNBCUConfigurationUpdateFailure_protocolIEs__item__id),
        ('criticality', ___GNBCUConfigurationUpdateFailure_protocolIEs__item__criticality),
        ('value', ___GNBCUConfigurationUpdateFailure_protocolIEs__item__value),
        ])
    __GNBCUConfigurationUpdateFailure_protocolIEs__item_._ext = None
    _GNBCUConfigurationUpdateFailure_protocolIEs._cont = __GNBCUConfigurationUpdateFailure_protocolIEs__item_
    _GNBCUConfigurationUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNBCUConfigurationUpdateFailure._cont = ASN1Dict([
        ('protocolIEs', _GNBCUConfigurationUpdateFailure_protocolIEs),
        ])
    GNBCUConfigurationUpdateFailure._ext = []
    
    #-----< GNBCUConfigurationUpdateFailureIEs >-----#
    GNBCUConfigurationUpdateFailureIEs = CLASS(name='GNBCUConfigurationUpdateFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNBCUConfigurationUpdateFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _GNBCUConfigurationUpdateFailureIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _GNBCUConfigurationUpdateFailureIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _GNBCUConfigurationUpdateFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    GNBCUConfigurationUpdateFailureIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _GNBCUConfigurationUpdateFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _GNBCUConfigurationUpdateFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _GNBCUConfigurationUpdateFailureIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _GNBCUConfigurationUpdateFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNBDUResourceCoordinationRequest >-----#
    GNBDUResourceCoordinationRequest = SEQ(name='GNBDUResourceCoordinationRequest', mode=MODE_TYPE)
    _GNBDUResourceCoordinationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __GNBDUResourceCoordinationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___GNBDUResourceCoordinationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RequestType')))
    _____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-NR-CellResourceCoordinationReq-Container')))
    _____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IgnoreResourceCoordinationContainer')))
    ____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 106), ('criticality', 'reject'), ('Value', _____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 101), ('criticality', 'reject'), ('Value', _____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 213), ('criticality', 'reject'), ('Value', _____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNBDUResourceCoordinationRequest_protocolIEs__item__id._const_tab = ____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab
    ___GNBDUResourceCoordinationRequest_protocolIEs__item__id._const_tab_at = None
    ___GNBDUResourceCoordinationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___GNBDUResourceCoordinationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___GNBDUResourceCoordinationRequest_protocolIEs__item__criticality._const_tab = ____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab
    ___GNBDUResourceCoordinationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNBDUResourceCoordinationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNBDUResourceCoordinationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___GNBDUResourceCoordinationRequest_protocolIEs__item__value._const_tab = ____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab
    ___GNBDUResourceCoordinationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNBDUResourceCoordinationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __GNBDUResourceCoordinationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNBDUResourceCoordinationRequest_protocolIEs__item__id),
        ('criticality', ___GNBDUResourceCoordinationRequest_protocolIEs__item__criticality),
        ('value', ___GNBDUResourceCoordinationRequest_protocolIEs__item__value),
        ])
    __GNBDUResourceCoordinationRequest_protocolIEs__item_._ext = None
    _GNBDUResourceCoordinationRequest_protocolIEs._cont = __GNBDUResourceCoordinationRequest_protocolIEs__item_
    _GNBDUResourceCoordinationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNBDUResourceCoordinationRequest._cont = ASN1Dict([
        ('protocolIEs', _GNBDUResourceCoordinationRequest_protocolIEs),
        ])
    GNBDUResourceCoordinationRequest._ext = []
    
    #-----< GNBDUResourceCoordinationRequest-IEs >-----#
    GNBDUResourceCoordinationRequest_IEs = CLASS(name='GNBDUResourceCoordinationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNBDUResourceCoordinationRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _GNBDUResourceCoordinationRequest_IEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RequestType')))
    _GNBDUResourceCoordinationRequest_IEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-NR-CellResourceCoordinationReq-Container')))
    _GNBDUResourceCoordinationRequest_IEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IgnoreResourceCoordinationContainer')))
    GNBDUResourceCoordinationRequest_IEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _GNBDUResourceCoordinationRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 106), ('criticality', 'reject'), ('Value', _GNBDUResourceCoordinationRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 101), ('criticality', 'reject'), ('Value', _GNBDUResourceCoordinationRequest_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 213), ('criticality', 'reject'), ('Value', _GNBDUResourceCoordinationRequest_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNBDUResourceCoordinationResponse >-----#
    GNBDUResourceCoordinationResponse = SEQ(name='GNBDUResourceCoordinationResponse', mode=MODE_TYPE)
    _GNBDUResourceCoordinationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __GNBDUResourceCoordinationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___GNBDUResourceCoordinationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____GNBDUResourceCoordinationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____GNBDUResourceCoordinationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____GNBDUResourceCoordinationResponse_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-NR-CellResourceCoordinationReqAck-Container')))
    ____GNBDUResourceCoordinationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____GNBDUResourceCoordinationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 102), ('criticality', 'reject'), ('Value', _____GNBDUResourceCoordinationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___GNBDUResourceCoordinationResponse_protocolIEs__item__id._const_tab = ____GNBDUResourceCoordinationResponse_protocolIEs__item__id_tab
    ___GNBDUResourceCoordinationResponse_protocolIEs__item__id._const_tab_at = None
    ___GNBDUResourceCoordinationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___GNBDUResourceCoordinationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___GNBDUResourceCoordinationResponse_protocolIEs__item__criticality._const_tab = ____GNBDUResourceCoordinationResponse_protocolIEs__item__id_tab
    ___GNBDUResourceCoordinationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNBDUResourceCoordinationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNBDUResourceCoordinationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___GNBDUResourceCoordinationResponse_protocolIEs__item__value._const_tab = ____GNBDUResourceCoordinationResponse_protocolIEs__item__id_tab
    ___GNBDUResourceCoordinationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNBDUResourceCoordinationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __GNBDUResourceCoordinationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNBDUResourceCoordinationResponse_protocolIEs__item__id),
        ('criticality', ___GNBDUResourceCoordinationResponse_protocolIEs__item__criticality),
        ('value', ___GNBDUResourceCoordinationResponse_protocolIEs__item__value),
        ])
    __GNBDUResourceCoordinationResponse_protocolIEs__item_._ext = None
    _GNBDUResourceCoordinationResponse_protocolIEs._cont = __GNBDUResourceCoordinationResponse_protocolIEs__item_
    _GNBDUResourceCoordinationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNBDUResourceCoordinationResponse._cont = ASN1Dict([
        ('protocolIEs', _GNBDUResourceCoordinationResponse_protocolIEs),
        ])
    GNBDUResourceCoordinationResponse._ext = []
    
    #-----< GNBDUResourceCoordinationResponse-IEs >-----#
    GNBDUResourceCoordinationResponse_IEs = CLASS(name='GNBDUResourceCoordinationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNBDUResourceCoordinationResponse_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _GNBDUResourceCoordinationResponse_IEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'EUTRA-NR-CellResourceCoordinationReqAck-Container')))
    GNBDUResourceCoordinationResponse_IEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _GNBDUResourceCoordinationResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 102), ('criticality', 'reject'), ('Value', _GNBDUResourceCoordinationResponse_IEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEContextSetupRequest >-----#
    UEContextSetupRequest = SEQ(name='UEContextSetupRequest', mode=MODE_TYPE)
    _UEContextSetupRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEContextSetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextSetupRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____UEContextSetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServCellIndex')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellULConfigured')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CUtoDURRCInformation')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Candidate-SpCell-List')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRXCycle')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_8 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferContainer')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_9 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SCell-ToBeSetup-List')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_10 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-ToBeSetup-List')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_11 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-ToBeSetup-List')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'InactivityMonitoringRequest')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_13 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAT-FrequencyPriorityInformation')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_14 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_15 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MaskedIMEISV')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_16 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_17 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_18 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCDeliveryStatusRequest')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_19 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferInformation')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_20 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServingCellMO')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_21 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_22 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RANUEID')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_23 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TraceActivation')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_24 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_25 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-ToBeSetup-List')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_26 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_27 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRV2XServicesAuthorized')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_28 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LTEV2XServicesAuthorized')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_29 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_30 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LTEUESidelinkAggregateMaximumBitrate')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_31 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_32 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-ToBeSetup-List')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_33 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ConditionalInterDUMobilityInformation')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_34 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MDTPLMNList')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_35 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NID')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_36 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'F1CTransferPath')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_37 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'F1CTransferPathNRDC')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_38 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MDTPollutedMeasurementIndicator')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_39 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCGActivationRequest')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_40 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CG-SDTSessionInfo')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_41 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FiveG-ProSeAuthorized')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_42 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_43 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_44 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelToBeSetupList')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_45 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelToBeSetupList')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_46 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PathSwitchConfiguration')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_47 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBDUUESliceMaximumBitRateList')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_48 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMBSSessionList')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_49 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UE-MulticastMRBs-ToBeSetup-List')))
    _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_50 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ServingCellMO-List')))
    ____UEContextSetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 63), ('criticality', 'reject'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 107), ('criticality', 'reject'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 96), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'reject'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'mandatory')]), dict([('id', 90), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 38), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 49), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 54), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 74), ('criticality', 'reject'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 35), ('criticality', 'reject'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 97), ('criticality', 'reject'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 108), ('criticality', 'reject'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 50), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 126), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 165), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_17), ('presence', 'conditional')]), dict([('id', 184), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_18), ('presence', 'optional')]), dict([('id', 195), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_19), ('presence', 'optional')]), dict([('id', 182), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_20), ('presence', 'optional')]), dict([('id', 217), ('criticality', 'reject'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_21), ('presence', 'optional')]), dict([('id', 226), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_22), ('presence', 'optional')]), dict([('id', 242), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_23), ('presence', 'optional')]), dict([('id', 248), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_24), ('presence', 'optional')]), dict([('id', 258), ('criticality', 'reject'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_25), ('presence', 'optional')]), dict([('id', 282), ('criticality', 'reject'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_26), ('presence', 'optional')]), dict([('id', 306), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_27), ('presence', 'optional')]), dict([('id', 307), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_28), ('presence', 'optional')]), dict([('id', 308), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_29), ('presence', 'optional')]), dict([('id', 309), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_30), ('presence', 'optional')]), dict([('id', 340), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_31), ('presence', 'optional')]), dict([('id', 330), ('criticality', 'reject'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_32), ('presence', 'optional')]), dict([('id', 373), ('criticality', 'reject'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_33), ('presence', 'optional')]), dict([('id', 377), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_34), ('presence', 'optional')]), dict([('id', 382), ('criticality', 'reject'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_35), ('presence', 'optional')]), dict([('id', 428), ('criticality', 'reject'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_36), ('presence', 'optional')]), dict([('id', 511), ('criticality', 'reject'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_37), ('presence', 'optional')]), dict([('id', 536), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_38), ('presence', 'optional')]), dict([('id', 547), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_39), ('presence', 'optional')]), dict([('id', 591), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_40), ('presence', 'optional')]), dict([('id', 594), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_41), ('presence', 'optional')]), dict([('id', 595), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_42), ('presence', 'optional')]), dict([('id', 596), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_43), ('presence', 'optional')]), dict([('id', 599), ('criticality', 'reject'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_44), ('presence', 'optional')]), dict([('id', 608), ('criticality', 'reject'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_45), ('presence', 'optional')]), dict([('id', 619), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_46), ('presence', 'optional')]), dict([('id', 626), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_47), ('presence', 'optional')]), dict([('id', 632), ('criticality', 'reject'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_48), ('presence', 'optional')]), dict([('id', 630), ('criticality', 'reject'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_49), ('presence', 'optional')]), dict([('id', 695), ('criticality', 'ignore'), ('Value', _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_50), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextSetupRequest_protocolIEs__item__id._const_tab = ____UEContextSetupRequest_protocolIEs__item__id_tab
    ___UEContextSetupRequest_protocolIEs__item__id._const_tab_at = None
    ___UEContextSetupRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextSetupRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextSetupRequest_protocolIEs__item__criticality._const_tab = ____UEContextSetupRequest_protocolIEs__item__id_tab
    ___UEContextSetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextSetupRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextSetupRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___UEContextSetupRequest_protocolIEs__item__value._const_tab = ____UEContextSetupRequest_protocolIEs__item__id_tab
    ___UEContextSetupRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextSetupRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextSetupRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextSetupRequest_protocolIEs__item__id),
        ('criticality', ___UEContextSetupRequest_protocolIEs__item__criticality),
        ('value', ___UEContextSetupRequest_protocolIEs__item__value),
        ])
    __UEContextSetupRequest_protocolIEs__item_._ext = None
    _UEContextSetupRequest_protocolIEs._cont = __UEContextSetupRequest_protocolIEs__item_
    _UEContextSetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextSetupRequest._cont = ASN1Dict([
        ('protocolIEs', _UEContextSetupRequest_protocolIEs),
        ])
    UEContextSetupRequest._ext = []
    
    #-----< UEContextSetupRequestIEs >-----#
    UEContextSetupRequestIEs = CLASS(name='UEContextSetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEContextSetupRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEContextSetupRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextSetupRequestIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _UEContextSetupRequestIEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServCellIndex')))
    _UEContextSetupRequestIEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellULConfigured')))
    _UEContextSetupRequestIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CUtoDURRCInformation')))
    _UEContextSetupRequestIEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Candidate-SpCell-List')))
    _UEContextSetupRequestIEs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRXCycle')))
    _UEContextSetupRequestIEs_val_Value_8 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferContainer')))
    _UEContextSetupRequestIEs_val_Value_9 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SCell-ToBeSetup-List')))
    _UEContextSetupRequestIEs_val_Value_10 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-ToBeSetup-List')))
    _UEContextSetupRequestIEs_val_Value_11 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-ToBeSetup-List')))
    _UEContextSetupRequestIEs_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'InactivityMonitoringRequest')))
    _UEContextSetupRequestIEs_val_Value_13 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAT-FrequencyPriorityInformation')))
    _UEContextSetupRequestIEs_val_Value_14 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _UEContextSetupRequestIEs_val_Value_15 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MaskedIMEISV')))
    _UEContextSetupRequestIEs_val_Value_16 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _UEContextSetupRequestIEs_val_Value_17 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _UEContextSetupRequestIEs_val_Value_18 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCDeliveryStatusRequest')))
    _UEContextSetupRequestIEs_val_Value_19 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferInformation')))
    _UEContextSetupRequestIEs_val_Value_20 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServingCellMO')))
    _UEContextSetupRequestIEs_val_Value_21 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextSetupRequestIEs_val_Value_22 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RANUEID')))
    _UEContextSetupRequestIEs_val_Value_23 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TraceActivation')))
    _UEContextSetupRequestIEs_val_Value_24 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _UEContextSetupRequestIEs_val_Value_25 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-ToBeSetup-List')))
    _UEContextSetupRequestIEs_val_Value_26 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAPAddress')))
    _UEContextSetupRequestIEs_val_Value_27 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRV2XServicesAuthorized')))
    _UEContextSetupRequestIEs_val_Value_28 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LTEV2XServicesAuthorized')))
    _UEContextSetupRequestIEs_val_Value_29 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _UEContextSetupRequestIEs_val_Value_30 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LTEUESidelinkAggregateMaximumBitrate')))
    _UEContextSetupRequestIEs_val_Value_31 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _UEContextSetupRequestIEs_val_Value_32 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-ToBeSetup-List')))
    _UEContextSetupRequestIEs_val_Value_33 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ConditionalInterDUMobilityInformation')))
    _UEContextSetupRequestIEs_val_Value_34 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MDTPLMNList')))
    _UEContextSetupRequestIEs_val_Value_35 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NID')))
    _UEContextSetupRequestIEs_val_Value_36 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'F1CTransferPath')))
    _UEContextSetupRequestIEs_val_Value_37 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'F1CTransferPathNRDC')))
    _UEContextSetupRequestIEs_val_Value_38 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MDTPollutedMeasurementIndicator')))
    _UEContextSetupRequestIEs_val_Value_39 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCGActivationRequest')))
    _UEContextSetupRequestIEs_val_Value_40 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CG-SDTSessionInfo')))
    _UEContextSetupRequestIEs_val_Value_41 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FiveG-ProSeAuthorized')))
    _UEContextSetupRequestIEs_val_Value_42 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _UEContextSetupRequestIEs_val_Value_43 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _UEContextSetupRequestIEs_val_Value_44 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelToBeSetupList')))
    _UEContextSetupRequestIEs_val_Value_45 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelToBeSetupList')))
    _UEContextSetupRequestIEs_val_Value_46 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PathSwitchConfiguration')))
    _UEContextSetupRequestIEs_val_Value_47 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBDUUESliceMaximumBitRateList')))
    _UEContextSetupRequestIEs_val_Value_48 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMBSSessionList')))
    _UEContextSetupRequestIEs_val_Value_49 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UE-MulticastMRBs-ToBeSetup-List')))
    _UEContextSetupRequestIEs_val_Value_50 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ServingCellMO-List')))
    UEContextSetupRequestIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _UEContextSetupRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 63), ('criticality', 'reject'), ('Value', _UEContextSetupRequestIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 107), ('criticality', 'reject'), ('Value', _UEContextSetupRequestIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 96), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'reject'), ('Value', _UEContextSetupRequestIEs_val_Value_5), ('presence', 'mandatory')]), dict([('id', 90), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 38), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 49), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 54), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 74), ('criticality', 'reject'), ('Value', _UEContextSetupRequestIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 35), ('criticality', 'reject'), ('Value', _UEContextSetupRequestIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 97), ('criticality', 'reject'), ('Value', _UEContextSetupRequestIEs_val_Value_12), ('presence', 'optional')]), dict([('id', 108), ('criticality', 'reject'), ('Value', _UEContextSetupRequestIEs_val_Value_13), ('presence', 'optional')]), dict([('id', 50), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_14), ('presence', 'optional')]), dict([('id', 126), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_15), ('presence', 'optional')]), dict([('id', 165), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_16), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_17), ('presence', 'conditional')]), dict([('id', 184), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_18), ('presence', 'optional')]), dict([('id', 195), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_19), ('presence', 'optional')]), dict([('id', 182), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_20), ('presence', 'optional')]), dict([('id', 217), ('criticality', 'reject'), ('Value', _UEContextSetupRequestIEs_val_Value_21), ('presence', 'optional')]), dict([('id', 226), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_22), ('presence', 'optional')]), dict([('id', 242), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_23), ('presence', 'optional')]), dict([('id', 248), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_24), ('presence', 'optional')]), dict([('id', 258), ('criticality', 'reject'), ('Value', _UEContextSetupRequestIEs_val_Value_25), ('presence', 'optional')]), dict([('id', 282), ('criticality', 'reject'), ('Value', _UEContextSetupRequestIEs_val_Value_26), ('presence', 'optional')]), dict([('id', 306), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_27), ('presence', 'optional')]), dict([('id', 307), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_28), ('presence', 'optional')]), dict([('id', 308), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_29), ('presence', 'optional')]), dict([('id', 309), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_30), ('presence', 'optional')]), dict([('id', 340), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_31), ('presence', 'optional')]), dict([('id', 330), ('criticality', 'reject'), ('Value', _UEContextSetupRequestIEs_val_Value_32), ('presence', 'optional')]), dict([('id', 373), ('criticality', 'reject'), ('Value', _UEContextSetupRequestIEs_val_Value_33), ('presence', 'optional')]), dict([('id', 377), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_34), ('presence', 'optional')]), dict([('id', 382), ('criticality', 'reject'), ('Value', _UEContextSetupRequestIEs_val_Value_35), ('presence', 'optional')]), dict([('id', 428), ('criticality', 'reject'), ('Value', _UEContextSetupRequestIEs_val_Value_36), ('presence', 'optional')]), dict([('id', 511), ('criticality', 'reject'), ('Value', _UEContextSetupRequestIEs_val_Value_37), ('presence', 'optional')]), dict([('id', 536), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_38), ('presence', 'optional')]), dict([('id', 547), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_39), ('presence', 'optional')]), dict([('id', 591), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_40), ('presence', 'optional')]), dict([('id', 594), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_41), ('presence', 'optional')]), dict([('id', 595), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_42), ('presence', 'optional')]), dict([('id', 596), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_43), ('presence', 'optional')]), dict([('id', 599), ('criticality', 'reject'), ('Value', _UEContextSetupRequestIEs_val_Value_44), ('presence', 'optional')]), dict([('id', 608), ('criticality', 'reject'), ('Value', _UEContextSetupRequestIEs_val_Value_45), ('presence', 'optional')]), dict([('id', 619), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_46), ('presence', 'optional')]), dict([('id', 626), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_47), ('presence', 'optional')]), dict([('id', 632), ('criticality', 'reject'), ('Value', _UEContextSetupRequestIEs_val_Value_48), ('presence', 'optional')]), dict([('id', 630), ('criticality', 'reject'), ('Value', _UEContextSetupRequestIEs_val_Value_49), ('presence', 'optional')]), dict([('id', 695), ('criticality', 'ignore'), ('Value', _UEContextSetupRequestIEs_val_Value_50), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Candidate-SpCell-List >-----#
    Candidate_SpCell_List = SEQ_OF(name='Candidate-SpCell-List', mode=MODE_TYPE)
    _Candidate_SpCell_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Candidate_SpCell_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___Candidate_SpCell_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Candidate_SpCell_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Candidate-SpCell-Item')))
    ___Candidate_SpCell_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 91), ('criticality', 'ignore'), ('Value', ____Candidate_SpCell_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Candidate_SpCell_List__item__id._const_tab = ___Candidate_SpCell_List__item__id_tab
    __Candidate_SpCell_List__item__id._const_tab_at = None
    __Candidate_SpCell_List__item__id._const_tab_id = 'id'
    __Candidate_SpCell_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __Candidate_SpCell_List__item__criticality._const_tab = ___Candidate_SpCell_List__item__id_tab
    __Candidate_SpCell_List__item__criticality._const_tab_at = ('..', 'id')
    __Candidate_SpCell_List__item__criticality._const_tab_id = 'criticality'
    __Candidate_SpCell_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __Candidate_SpCell_List__item__value._const_tab = ___Candidate_SpCell_List__item__id_tab
    __Candidate_SpCell_List__item__value._const_tab_at = ('..', 'id')
    __Candidate_SpCell_List__item__value._const_tab_id = 'Value'
    _Candidate_SpCell_List__item_._cont = ASN1Dict([
        ('id', __Candidate_SpCell_List__item__id),
        ('criticality', __Candidate_SpCell_List__item__criticality),
        ('value', __Candidate_SpCell_List__item__value),
        ])
    _Candidate_SpCell_List__item_._ext = None
    Candidate_SpCell_List._cont = _Candidate_SpCell_List__item_
    Candidate_SpCell_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SCell-ToBeSetup-List >-----#
    SCell_ToBeSetup_List = SEQ_OF(name='SCell-ToBeSetup-List', mode=MODE_TYPE)
    _SCell_ToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SCell_ToBeSetup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SCell_ToBeSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SCell_ToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCell-ToBeSetup-Item')))
    ___SCell_ToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 53), ('criticality', 'ignore'), ('Value', ____SCell_ToBeSetup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SCell_ToBeSetup_List__item__id._const_tab = ___SCell_ToBeSetup_List__item__id_tab
    __SCell_ToBeSetup_List__item__id._const_tab_at = None
    __SCell_ToBeSetup_List__item__id._const_tab_id = 'id'
    __SCell_ToBeSetup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SCell_ToBeSetup_List__item__criticality._const_tab = ___SCell_ToBeSetup_List__item__id_tab
    __SCell_ToBeSetup_List__item__criticality._const_tab_at = ('..', 'id')
    __SCell_ToBeSetup_List__item__criticality._const_tab_id = 'criticality'
    __SCell_ToBeSetup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SCell_ToBeSetup_List__item__value._const_tab = ___SCell_ToBeSetup_List__item__id_tab
    __SCell_ToBeSetup_List__item__value._const_tab_at = ('..', 'id')
    __SCell_ToBeSetup_List__item__value._const_tab_id = 'Value'
    _SCell_ToBeSetup_List__item_._cont = ASN1Dict([
        ('id', __SCell_ToBeSetup_List__item__id),
        ('criticality', __SCell_ToBeSetup_List__item__criticality),
        ('value', __SCell_ToBeSetup_List__item__value),
        ])
    _SCell_ToBeSetup_List__item_._ext = None
    SCell_ToBeSetup_List._cont = _SCell_ToBeSetup_List__item_
    SCell_ToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SRBs-ToBeSetup-List >-----#
    SRBs_ToBeSetup_List = SEQ_OF(name='SRBs-ToBeSetup-List', mode=MODE_TYPE)
    _SRBs_ToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SRBs_ToBeSetup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SRBs_ToBeSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SRBs_ToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-ToBeSetup-Item')))
    ___SRBs_ToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 73), ('criticality', 'reject'), ('Value', ____SRBs_ToBeSetup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SRBs_ToBeSetup_List__item__id._const_tab = ___SRBs_ToBeSetup_List__item__id_tab
    __SRBs_ToBeSetup_List__item__id._const_tab_at = None
    __SRBs_ToBeSetup_List__item__id._const_tab_id = 'id'
    __SRBs_ToBeSetup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SRBs_ToBeSetup_List__item__criticality._const_tab = ___SRBs_ToBeSetup_List__item__id_tab
    __SRBs_ToBeSetup_List__item__criticality._const_tab_at = ('..', 'id')
    __SRBs_ToBeSetup_List__item__criticality._const_tab_id = 'criticality'
    __SRBs_ToBeSetup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SRBs_ToBeSetup_List__item__value._const_tab = ___SRBs_ToBeSetup_List__item__id_tab
    __SRBs_ToBeSetup_List__item__value._const_tab_at = ('..', 'id')
    __SRBs_ToBeSetup_List__item__value._const_tab_id = 'Value'
    _SRBs_ToBeSetup_List__item_._cont = ASN1Dict([
        ('id', __SRBs_ToBeSetup_List__item__id),
        ('criticality', __SRBs_ToBeSetup_List__item__criticality),
        ('value', __SRBs_ToBeSetup_List__item__value),
        ])
    _SRBs_ToBeSetup_List__item_._ext = None
    SRBs_ToBeSetup_List._cont = _SRBs_ToBeSetup_List__item_
    SRBs_ToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< DRBs-ToBeSetup-List >-----#
    DRBs_ToBeSetup_List = SEQ_OF(name='DRBs-ToBeSetup-List', mode=MODE_TYPE)
    _DRBs_ToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_ToBeSetup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___DRBs_ToBeSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_ToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-ToBeSetup-Item')))
    ___DRBs_ToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 34), ('criticality', 'reject'), ('Value', ____DRBs_ToBeSetup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_ToBeSetup_List__item__id._const_tab = ___DRBs_ToBeSetup_List__item__id_tab
    __DRBs_ToBeSetup_List__item__id._const_tab_at = None
    __DRBs_ToBeSetup_List__item__id._const_tab_id = 'id'
    __DRBs_ToBeSetup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __DRBs_ToBeSetup_List__item__criticality._const_tab = ___DRBs_ToBeSetup_List__item__id_tab
    __DRBs_ToBeSetup_List__item__criticality._const_tab_at = ('..', 'id')
    __DRBs_ToBeSetup_List__item__criticality._const_tab_id = 'criticality'
    __DRBs_ToBeSetup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __DRBs_ToBeSetup_List__item__value._const_tab = ___DRBs_ToBeSetup_List__item__id_tab
    __DRBs_ToBeSetup_List__item__value._const_tab_at = ('..', 'id')
    __DRBs_ToBeSetup_List__item__value._const_tab_id = 'Value'
    _DRBs_ToBeSetup_List__item_._cont = ASN1Dict([
        ('id', __DRBs_ToBeSetup_List__item__id),
        ('criticality', __DRBs_ToBeSetup_List__item__criticality),
        ('value', __DRBs_ToBeSetup_List__item__value),
        ])
    _DRBs_ToBeSetup_List__item_._ext = None
    DRBs_ToBeSetup_List._cont = _DRBs_ToBeSetup_List__item_
    DRBs_ToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< BHChannels-ToBeSetup-List >-----#
    BHChannels_ToBeSetup_List = SEQ_OF(name='BHChannels-ToBeSetup-List', mode=MODE_TYPE)
    _BHChannels_ToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BHChannels_ToBeSetup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BHChannels_ToBeSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BHChannels_ToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-ToBeSetup-Item')))
    ___BHChannels_ToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 259), ('criticality', 'reject'), ('Value', ____BHChannels_ToBeSetup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __BHChannels_ToBeSetup_List__item__id._const_tab = ___BHChannels_ToBeSetup_List__item__id_tab
    __BHChannels_ToBeSetup_List__item__id._const_tab_at = None
    __BHChannels_ToBeSetup_List__item__id._const_tab_id = 'id'
    __BHChannels_ToBeSetup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __BHChannels_ToBeSetup_List__item__criticality._const_tab = ___BHChannels_ToBeSetup_List__item__id_tab
    __BHChannels_ToBeSetup_List__item__criticality._const_tab_at = ('..', 'id')
    __BHChannels_ToBeSetup_List__item__criticality._const_tab_id = 'criticality'
    __BHChannels_ToBeSetup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __BHChannels_ToBeSetup_List__item__value._const_tab = ___BHChannels_ToBeSetup_List__item__id_tab
    __BHChannels_ToBeSetup_List__item__value._const_tab_at = ('..', 'id')
    __BHChannels_ToBeSetup_List__item__value._const_tab_id = 'Value'
    _BHChannels_ToBeSetup_List__item_._cont = ASN1Dict([
        ('id', __BHChannels_ToBeSetup_List__item__id),
        ('criticality', __BHChannels_ToBeSetup_List__item__criticality),
        ('value', __BHChannels_ToBeSetup_List__item__value),
        ])
    _BHChannels_ToBeSetup_List__item_._ext = None
    BHChannels_ToBeSetup_List._cont = _BHChannels_ToBeSetup_List__item_
    BHChannels_ToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< SLDRBs-ToBeSetup-List >-----#
    SLDRBs_ToBeSetup_List = SEQ_OF(name='SLDRBs-ToBeSetup-List', mode=MODE_TYPE)
    _SLDRBs_ToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_ToBeSetup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SLDRBs_ToBeSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_ToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-ToBeSetup-Item')))
    ___SLDRBs_ToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 329), ('criticality', 'reject'), ('Value', ____SLDRBs_ToBeSetup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_ToBeSetup_List__item__id._const_tab = ___SLDRBs_ToBeSetup_List__item__id_tab
    __SLDRBs_ToBeSetup_List__item__id._const_tab_at = None
    __SLDRBs_ToBeSetup_List__item__id._const_tab_id = 'id'
    __SLDRBs_ToBeSetup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SLDRBs_ToBeSetup_List__item__criticality._const_tab = ___SLDRBs_ToBeSetup_List__item__id_tab
    __SLDRBs_ToBeSetup_List__item__criticality._const_tab_at = ('..', 'id')
    __SLDRBs_ToBeSetup_List__item__criticality._const_tab_id = 'criticality'
    __SLDRBs_ToBeSetup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SLDRBs_ToBeSetup_List__item__value._const_tab = ___SLDRBs_ToBeSetup_List__item__id_tab
    __SLDRBs_ToBeSetup_List__item__value._const_tab_at = ('..', 'id')
    __SLDRBs_ToBeSetup_List__item__value._const_tab_id = 'Value'
    _SLDRBs_ToBeSetup_List__item_._cont = ASN1Dict([
        ('id', __SLDRBs_ToBeSetup_List__item__id),
        ('criticality', __SLDRBs_ToBeSetup_List__item__criticality),
        ('value', __SLDRBs_ToBeSetup_List__item__value),
        ])
    _SLDRBs_ToBeSetup_List__item_._ext = None
    SLDRBs_ToBeSetup_List._cont = _SLDRBs_ToBeSetup_List__item_
    SLDRBs_ToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< UE-MulticastMRBs-ToBeSetup-List >-----#
    UE_MulticastMRBs_ToBeSetup_List = SEQ_OF(name='UE-MulticastMRBs-ToBeSetup-List', mode=MODE_TYPE)
    _UE_MulticastMRBs_ToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UE_MulticastMRBs_ToBeSetup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___UE_MulticastMRBs_ToBeSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____UE_MulticastMRBs_ToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UE-MulticastMRBs-ToBeSetup-Item')))
    ___UE_MulticastMRBs_ToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 631), ('criticality', 'reject'), ('Value', ____UE_MulticastMRBs_ToBeSetup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __UE_MulticastMRBs_ToBeSetup_List__item__id._const_tab = ___UE_MulticastMRBs_ToBeSetup_List__item__id_tab
    __UE_MulticastMRBs_ToBeSetup_List__item__id._const_tab_at = None
    __UE_MulticastMRBs_ToBeSetup_List__item__id._const_tab_id = 'id'
    __UE_MulticastMRBs_ToBeSetup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __UE_MulticastMRBs_ToBeSetup_List__item__criticality._const_tab = ___UE_MulticastMRBs_ToBeSetup_List__item__id_tab
    __UE_MulticastMRBs_ToBeSetup_List__item__criticality._const_tab_at = ('..', 'id')
    __UE_MulticastMRBs_ToBeSetup_List__item__criticality._const_tab_id = 'criticality'
    __UE_MulticastMRBs_ToBeSetup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __UE_MulticastMRBs_ToBeSetup_List__item__value._const_tab = ___UE_MulticastMRBs_ToBeSetup_List__item__id_tab
    __UE_MulticastMRBs_ToBeSetup_List__item__value._const_tab_at = ('..', 'id')
    __UE_MulticastMRBs_ToBeSetup_List__item__value._const_tab_id = 'Value'
    _UE_MulticastMRBs_ToBeSetup_List__item_._cont = ASN1Dict([
        ('id', __UE_MulticastMRBs_ToBeSetup_List__item__id),
        ('criticality', __UE_MulticastMRBs_ToBeSetup_List__item__criticality),
        ('value', __UE_MulticastMRBs_ToBeSetup_List__item__value),
        ])
    _UE_MulticastMRBs_ToBeSetup_List__item_._ext = None
    UE_MulticastMRBs_ToBeSetup_List._cont = _UE_MulticastMRBs_ToBeSetup_List__item_
    UE_MulticastMRBs_ToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< ServingCellMO-List >-----#
    ServingCellMO_List = SEQ_OF(name='ServingCellMO-List', mode=MODE_TYPE)
    _ServingCellMO_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __ServingCellMO_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___ServingCellMO_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____ServingCellMO_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServingCellMO-List-Item')))
    ___ServingCellMO_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 696), ('criticality', 'reject'), ('Value', ____ServingCellMO_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __ServingCellMO_List__item__id._const_tab = ___ServingCellMO_List__item__id_tab
    __ServingCellMO_List__item__id._const_tab_at = None
    __ServingCellMO_List__item__id._const_tab_id = 'id'
    __ServingCellMO_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __ServingCellMO_List__item__criticality._const_tab = ___ServingCellMO_List__item__id_tab
    __ServingCellMO_List__item__criticality._const_tab_at = ('..', 'id')
    __ServingCellMO_List__item__criticality._const_tab_id = 'criticality'
    __ServingCellMO_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __ServingCellMO_List__item__value._const_tab = ___ServingCellMO_List__item__id_tab
    __ServingCellMO_List__item__value._const_tab_at = ('..', 'id')
    __ServingCellMO_List__item__value._const_tab_id = 'Value'
    _ServingCellMO_List__item_._cont = ASN1Dict([
        ('id', __ServingCellMO_List__item__id),
        ('criticality', __ServingCellMO_List__item__criticality),
        ('value', __ServingCellMO_List__item__value),
        ])
    _ServingCellMO_List__item_._ext = None
    ServingCellMO_List._cont = _ServingCellMO_List__item_
    ServingCellMO_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Candidate-SpCell-ItemIEs >-----#
    Candidate_SpCell_ItemIEs = CLASS(name='Candidate-SpCell-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Candidate_SpCell_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Candidate-SpCell-Item')))
    Candidate_SpCell_ItemIEs._val = ASN1Set(rv=[dict([('id', 91), ('criticality', 'ignore'), ('Value', _Candidate_SpCell_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SCell-ToBeSetup-ItemIEs >-----#
    SCell_ToBeSetup_ItemIEs = CLASS(name='SCell-ToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SCell_ToBeSetup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCell-ToBeSetup-Item')))
    SCell_ToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([('id', 53), ('criticality', 'ignore'), ('Value', _SCell_ToBeSetup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SRBs-ToBeSetup-ItemIEs >-----#
    SRBs_ToBeSetup_ItemIEs = CLASS(name='SRBs-ToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SRBs_ToBeSetup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-ToBeSetup-Item')))
    SRBs_ToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([('id', 73), ('criticality', 'reject'), ('Value', _SRBs_ToBeSetup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-ToBeSetup-ItemIEs >-----#
    DRBs_ToBeSetup_ItemIEs = CLASS(name='DRBs-ToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_ToBeSetup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-ToBeSetup-Item')))
    DRBs_ToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([('id', 34), ('criticality', 'reject'), ('Value', _DRBs_ToBeSetup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BHChannels-ToBeSetup-ItemIEs >-----#
    BHChannels_ToBeSetup_ItemIEs = CLASS(name='BHChannels-ToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BHChannels_ToBeSetup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-ToBeSetup-Item')))
    BHChannels_ToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([('id', 259), ('criticality', 'reject'), ('Value', _BHChannels_ToBeSetup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-ToBeSetup-ItemIEs >-----#
    SLDRBs_ToBeSetup_ItemIEs = CLASS(name='SLDRBs-ToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_ToBeSetup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-ToBeSetup-Item')))
    SLDRBs_ToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([('id', 329), ('criticality', 'reject'), ('Value', _SLDRBs_ToBeSetup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UE-MulticastMRBs-ToBeSetup-ItemIEs >-----#
    UE_MulticastMRBs_ToBeSetup_ItemIEs = CLASS(name='UE-MulticastMRBs-ToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UE_MulticastMRBs_ToBeSetup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UE-MulticastMRBs-ToBeSetup-Item')))
    UE_MulticastMRBs_ToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([('id', 631), ('criticality', 'reject'), ('Value', _UE_MulticastMRBs_ToBeSetup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ServingCellMO-List-ItemIEs >-----#
    ServingCellMO_List_ItemIEs = CLASS(name='ServingCellMO-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _ServingCellMO_List_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServingCellMO-List-Item')))
    ServingCellMO_List_ItemIEs._val = ASN1Set(rv=[dict([('id', 696), ('criticality', 'reject'), ('Value', _ServingCellMO_List_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEContextSetupResponse >-----#
    UEContextSetupResponse = SEQ(name='UEContextSetupResponse', mode=MODE_TYPE)
    _UEContextSetupResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEContextSetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextSetupResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____UEContextSetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DUtoCURRCInformation')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'C-RNTI')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferContainer')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FullConfiguration')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-Setup-List')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-FailedToBeSetup-List')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_8 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-FailedToBeSetup-List')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_9 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SCell-FailedtoSetup-List')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'InactivityMonitoringResponse')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_12 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-Setup-List')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_13 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-Setup-List')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_14 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-FailedToBeSetup-List')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_15 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-Setup-List')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_16 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-FailedToBeSetup-List')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_17 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_18 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCGActivationStatus')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_19 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelSetupList')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_20 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelFailedToBeSetupList')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_21 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelSetupList')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_22 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelFailedToBeSetupList')))
    _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_23 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServingCellMO-encoded-in-CGC-List')))
    ____UEContextSetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 39), ('criticality', 'reject'), ('Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 95), ('criticality', 'ignore'), ('Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 49), ('criticality', 'ignore'), ('Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 94), ('criticality', 'reject'), ('Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 27), ('criticality', 'ignore'), ('Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 66), ('criticality', 'ignore'), ('Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 83), ('criticality', 'ignore'), ('Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 98), ('criticality', 'reject'), ('Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 202), ('criticality', 'ignore'), ('Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 260), ('criticality', 'ignore'), ('Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 279), ('criticality', 'ignore'), ('Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 324), ('criticality', 'ignore'), ('Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 316), ('criticality', 'ignore'), ('Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')]), dict([('id', 376), ('criticality', 'reject'), ('Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_17), ('presence', 'optional')]), dict([('id', 548), ('criticality', 'ignore'), ('Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_18), ('presence', 'optional')]), dict([('id', 602), ('criticality', 'ignore'), ('Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_19), ('presence', 'optional')]), dict([('id', 603), ('criticality', 'ignore'), ('Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_20), ('presence', 'optional')]), dict([('id', 611), ('criticality', 'ignore'), ('Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_21), ('presence', 'optional')]), dict([('id', 612), ('criticality', 'ignore'), ('Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_22), ('presence', 'optional')]), dict([('id', 697), ('criticality', 'ignore'), ('Value', _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_23), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextSetupResponse_protocolIEs__item__id._const_tab = ____UEContextSetupResponse_protocolIEs__item__id_tab
    ___UEContextSetupResponse_protocolIEs__item__id._const_tab_at = None
    ___UEContextSetupResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextSetupResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextSetupResponse_protocolIEs__item__criticality._const_tab = ____UEContextSetupResponse_protocolIEs__item__id_tab
    ___UEContextSetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextSetupResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextSetupResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___UEContextSetupResponse_protocolIEs__item__value._const_tab = ____UEContextSetupResponse_protocolIEs__item__id_tab
    ___UEContextSetupResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextSetupResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextSetupResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextSetupResponse_protocolIEs__item__id),
        ('criticality', ___UEContextSetupResponse_protocolIEs__item__criticality),
        ('value', ___UEContextSetupResponse_protocolIEs__item__value),
        ])
    __UEContextSetupResponse_protocolIEs__item_._ext = None
    _UEContextSetupResponse_protocolIEs._cont = __UEContextSetupResponse_protocolIEs__item_
    _UEContextSetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextSetupResponse._cont = ASN1Dict([
        ('protocolIEs', _UEContextSetupResponse_protocolIEs),
        ])
    UEContextSetupResponse._ext = []
    
    #-----< UEContextSetupResponseIEs >-----#
    UEContextSetupResponseIEs = CLASS(name='UEContextSetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEContextSetupResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEContextSetupResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextSetupResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DUtoCURRCInformation')))
    _UEContextSetupResponseIEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'C-RNTI')))
    _UEContextSetupResponseIEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferContainer')))
    _UEContextSetupResponseIEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FullConfiguration')))
    _UEContextSetupResponseIEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-Setup-List')))
    _UEContextSetupResponseIEs_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-FailedToBeSetup-List')))
    _UEContextSetupResponseIEs_val_Value_8 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-FailedToBeSetup-List')))
    _UEContextSetupResponseIEs_val_Value_9 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SCell-FailedtoSetup-List')))
    _UEContextSetupResponseIEs_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'InactivityMonitoringResponse')))
    _UEContextSetupResponseIEs_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _UEContextSetupResponseIEs_val_Value_12 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-Setup-List')))
    _UEContextSetupResponseIEs_val_Value_13 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-Setup-List')))
    _UEContextSetupResponseIEs_val_Value_14 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-FailedToBeSetup-List')))
    _UEContextSetupResponseIEs_val_Value_15 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-Setup-List')))
    _UEContextSetupResponseIEs_val_Value_16 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-FailedToBeSetup-List')))
    _UEContextSetupResponseIEs_val_Value_17 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _UEContextSetupResponseIEs_val_Value_18 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCGActivationStatus')))
    _UEContextSetupResponseIEs_val_Value_19 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelSetupList')))
    _UEContextSetupResponseIEs_val_Value_20 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelFailedToBeSetupList')))
    _UEContextSetupResponseIEs_val_Value_21 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelSetupList')))
    _UEContextSetupResponseIEs_val_Value_22 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelFailedToBeSetupList')))
    _UEContextSetupResponseIEs_val_Value_23 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServingCellMO-encoded-in-CGC-List')))
    UEContextSetupResponseIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _UEContextSetupResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _UEContextSetupResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 39), ('criticality', 'reject'), ('Value', _UEContextSetupResponseIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 95), ('criticality', 'ignore'), ('Value', _UEContextSetupResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 49), ('criticality', 'ignore'), ('Value', _UEContextSetupResponseIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 94), ('criticality', 'reject'), ('Value', _UEContextSetupResponseIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 27), ('criticality', 'ignore'), ('Value', _UEContextSetupResponseIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 66), ('criticality', 'ignore'), ('Value', _UEContextSetupResponseIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _UEContextSetupResponseIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 83), ('criticality', 'ignore'), ('Value', _UEContextSetupResponseIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 98), ('criticality', 'reject'), ('Value', _UEContextSetupResponseIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _UEContextSetupResponseIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 202), ('criticality', 'ignore'), ('Value', _UEContextSetupResponseIEs_val_Value_12), ('presence', 'optional')]), dict([('id', 260), ('criticality', 'ignore'), ('Value', _UEContextSetupResponseIEs_val_Value_13), ('presence', 'optional')]), dict([('id', 279), ('criticality', 'ignore'), ('Value', _UEContextSetupResponseIEs_val_Value_14), ('presence', 'optional')]), dict([('id', 324), ('criticality', 'ignore'), ('Value', _UEContextSetupResponseIEs_val_Value_15), ('presence', 'optional')]), dict([('id', 316), ('criticality', 'ignore'), ('Value', _UEContextSetupResponseIEs_val_Value_16), ('presence', 'optional')]), dict([('id', 376), ('criticality', 'reject'), ('Value', _UEContextSetupResponseIEs_val_Value_17), ('presence', 'optional')]), dict([('id', 548), ('criticality', 'ignore'), ('Value', _UEContextSetupResponseIEs_val_Value_18), ('presence', 'optional')]), dict([('id', 602), ('criticality', 'ignore'), ('Value', _UEContextSetupResponseIEs_val_Value_19), ('presence', 'optional')]), dict([('id', 603), ('criticality', 'ignore'), ('Value', _UEContextSetupResponseIEs_val_Value_20), ('presence', 'optional')]), dict([('id', 611), ('criticality', 'ignore'), ('Value', _UEContextSetupResponseIEs_val_Value_21), ('presence', 'optional')]), dict([('id', 612), ('criticality', 'ignore'), ('Value', _UEContextSetupResponseIEs_val_Value_22), ('presence', 'optional')]), dict([('id', 697), ('criticality', 'ignore'), ('Value', _UEContextSetupResponseIEs_val_Value_23), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-Setup-List >-----#
    DRBs_Setup_List = SEQ_OF(name='DRBs-Setup-List', mode=MODE_TYPE)
    _DRBs_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_Setup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___DRBs_Setup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_Setup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-Setup-Item')))
    ___DRBs_Setup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 26), ('criticality', 'ignore'), ('Value', ____DRBs_Setup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_Setup_List__item__id._const_tab = ___DRBs_Setup_List__item__id_tab
    __DRBs_Setup_List__item__id._const_tab_at = None
    __DRBs_Setup_List__item__id._const_tab_id = 'id'
    __DRBs_Setup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __DRBs_Setup_List__item__criticality._const_tab = ___DRBs_Setup_List__item__id_tab
    __DRBs_Setup_List__item__criticality._const_tab_at = ('..', 'id')
    __DRBs_Setup_List__item__criticality._const_tab_id = 'criticality'
    __DRBs_Setup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __DRBs_Setup_List__item__value._const_tab = ___DRBs_Setup_List__item__id_tab
    __DRBs_Setup_List__item__value._const_tab_at = ('..', 'id')
    __DRBs_Setup_List__item__value._const_tab_id = 'Value'
    _DRBs_Setup_List__item_._cont = ASN1Dict([
        ('id', __DRBs_Setup_List__item__id),
        ('criticality', __DRBs_Setup_List__item__criticality),
        ('value', __DRBs_Setup_List__item__value),
        ])
    _DRBs_Setup_List__item_._ext = None
    DRBs_Setup_List._cont = _DRBs_Setup_List__item_
    DRBs_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SRBs-FailedToBeSetup-List >-----#
    SRBs_FailedToBeSetup_List = SEQ_OF(name='SRBs-FailedToBeSetup-List', mode=MODE_TYPE)
    _SRBs_FailedToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SRBs_FailedToBeSetup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SRBs_FailedToBeSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SRBs_FailedToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-FailedToBeSetup-Item')))
    ___SRBs_FailedToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 65), ('criticality', 'ignore'), ('Value', ____SRBs_FailedToBeSetup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SRBs_FailedToBeSetup_List__item__id._const_tab = ___SRBs_FailedToBeSetup_List__item__id_tab
    __SRBs_FailedToBeSetup_List__item__id._const_tab_at = None
    __SRBs_FailedToBeSetup_List__item__id._const_tab_id = 'id'
    __SRBs_FailedToBeSetup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SRBs_FailedToBeSetup_List__item__criticality._const_tab = ___SRBs_FailedToBeSetup_List__item__id_tab
    __SRBs_FailedToBeSetup_List__item__criticality._const_tab_at = ('..', 'id')
    __SRBs_FailedToBeSetup_List__item__criticality._const_tab_id = 'criticality'
    __SRBs_FailedToBeSetup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SRBs_FailedToBeSetup_List__item__value._const_tab = ___SRBs_FailedToBeSetup_List__item__id_tab
    __SRBs_FailedToBeSetup_List__item__value._const_tab_at = ('..', 'id')
    __SRBs_FailedToBeSetup_List__item__value._const_tab_id = 'Value'
    _SRBs_FailedToBeSetup_List__item_._cont = ASN1Dict([
        ('id', __SRBs_FailedToBeSetup_List__item__id),
        ('criticality', __SRBs_FailedToBeSetup_List__item__criticality),
        ('value', __SRBs_FailedToBeSetup_List__item__value),
        ])
    _SRBs_FailedToBeSetup_List__item_._ext = None
    SRBs_FailedToBeSetup_List._cont = _SRBs_FailedToBeSetup_List__item_
    SRBs_FailedToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< DRBs-FailedToBeSetup-List >-----#
    DRBs_FailedToBeSetup_List = SEQ_OF(name='DRBs-FailedToBeSetup-List', mode=MODE_TYPE)
    _DRBs_FailedToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_FailedToBeSetup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___DRBs_FailedToBeSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_FailedToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-FailedToBeSetup-Item')))
    ___DRBs_FailedToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 14), ('criticality', 'ignore'), ('Value', ____DRBs_FailedToBeSetup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_FailedToBeSetup_List__item__id._const_tab = ___DRBs_FailedToBeSetup_List__item__id_tab
    __DRBs_FailedToBeSetup_List__item__id._const_tab_at = None
    __DRBs_FailedToBeSetup_List__item__id._const_tab_id = 'id'
    __DRBs_FailedToBeSetup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __DRBs_FailedToBeSetup_List__item__criticality._const_tab = ___DRBs_FailedToBeSetup_List__item__id_tab
    __DRBs_FailedToBeSetup_List__item__criticality._const_tab_at = ('..', 'id')
    __DRBs_FailedToBeSetup_List__item__criticality._const_tab_id = 'criticality'
    __DRBs_FailedToBeSetup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __DRBs_FailedToBeSetup_List__item__value._const_tab = ___DRBs_FailedToBeSetup_List__item__id_tab
    __DRBs_FailedToBeSetup_List__item__value._const_tab_at = ('..', 'id')
    __DRBs_FailedToBeSetup_List__item__value._const_tab_id = 'Value'
    _DRBs_FailedToBeSetup_List__item_._cont = ASN1Dict([
        ('id', __DRBs_FailedToBeSetup_List__item__id),
        ('criticality', __DRBs_FailedToBeSetup_List__item__criticality),
        ('value', __DRBs_FailedToBeSetup_List__item__value),
        ])
    _DRBs_FailedToBeSetup_List__item_._ext = None
    DRBs_FailedToBeSetup_List._cont = _DRBs_FailedToBeSetup_List__item_
    DRBs_FailedToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SCell-FailedtoSetup-List >-----#
    SCell_FailedtoSetup_List = SEQ_OF(name='SCell-FailedtoSetup-List', mode=MODE_TYPE)
    _SCell_FailedtoSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SCell_FailedtoSetup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SCell_FailedtoSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SCell_FailedtoSetup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCell-FailedtoSetup-Item')))
    ___SCell_FailedtoSetup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 84), ('criticality', 'ignore'), ('Value', ____SCell_FailedtoSetup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SCell_FailedtoSetup_List__item__id._const_tab = ___SCell_FailedtoSetup_List__item__id_tab
    __SCell_FailedtoSetup_List__item__id._const_tab_at = None
    __SCell_FailedtoSetup_List__item__id._const_tab_id = 'id'
    __SCell_FailedtoSetup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SCell_FailedtoSetup_List__item__criticality._const_tab = ___SCell_FailedtoSetup_List__item__id_tab
    __SCell_FailedtoSetup_List__item__criticality._const_tab_at = ('..', 'id')
    __SCell_FailedtoSetup_List__item__criticality._const_tab_id = 'criticality'
    __SCell_FailedtoSetup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SCell_FailedtoSetup_List__item__value._const_tab = ___SCell_FailedtoSetup_List__item__id_tab
    __SCell_FailedtoSetup_List__item__value._const_tab_at = ('..', 'id')
    __SCell_FailedtoSetup_List__item__value._const_tab_id = 'Value'
    _SCell_FailedtoSetup_List__item_._cont = ASN1Dict([
        ('id', __SCell_FailedtoSetup_List__item__id),
        ('criticality', __SCell_FailedtoSetup_List__item__criticality),
        ('value', __SCell_FailedtoSetup_List__item__value),
        ])
    _SCell_FailedtoSetup_List__item_._ext = None
    SCell_FailedtoSetup_List._cont = _SCell_FailedtoSetup_List__item_
    SCell_FailedtoSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SRBs-Setup-List >-----#
    SRBs_Setup_List = SEQ_OF(name='SRBs-Setup-List', mode=MODE_TYPE)
    _SRBs_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SRBs_Setup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SRBs_Setup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SRBs_Setup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-Setup-Item')))
    ___SRBs_Setup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 203), ('criticality', 'ignore'), ('Value', ____SRBs_Setup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SRBs_Setup_List__item__id._const_tab = ___SRBs_Setup_List__item__id_tab
    __SRBs_Setup_List__item__id._const_tab_at = None
    __SRBs_Setup_List__item__id._const_tab_id = 'id'
    __SRBs_Setup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SRBs_Setup_List__item__criticality._const_tab = ___SRBs_Setup_List__item__id_tab
    __SRBs_Setup_List__item__criticality._const_tab_at = ('..', 'id')
    __SRBs_Setup_List__item__criticality._const_tab_id = 'criticality'
    __SRBs_Setup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SRBs_Setup_List__item__value._const_tab = ___SRBs_Setup_List__item__id_tab
    __SRBs_Setup_List__item__value._const_tab_at = ('..', 'id')
    __SRBs_Setup_List__item__value._const_tab_id = 'Value'
    _SRBs_Setup_List__item_._cont = ASN1Dict([
        ('id', __SRBs_Setup_List__item__id),
        ('criticality', __SRBs_Setup_List__item__criticality),
        ('value', __SRBs_Setup_List__item__value),
        ])
    _SRBs_Setup_List__item_._ext = None
    SRBs_Setup_List._cont = _SRBs_Setup_List__item_
    SRBs_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< BHChannels-Setup-List >-----#
    BHChannels_Setup_List = SEQ_OF(name='BHChannels-Setup-List', mode=MODE_TYPE)
    _BHChannels_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BHChannels_Setup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BHChannels_Setup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BHChannels_Setup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-Setup-Item')))
    ___BHChannels_Setup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 261), ('criticality', 'ignore'), ('Value', ____BHChannels_Setup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __BHChannels_Setup_List__item__id._const_tab = ___BHChannels_Setup_List__item__id_tab
    __BHChannels_Setup_List__item__id._const_tab_at = None
    __BHChannels_Setup_List__item__id._const_tab_id = 'id'
    __BHChannels_Setup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __BHChannels_Setup_List__item__criticality._const_tab = ___BHChannels_Setup_List__item__id_tab
    __BHChannels_Setup_List__item__criticality._const_tab_at = ('..', 'id')
    __BHChannels_Setup_List__item__criticality._const_tab_id = 'criticality'
    __BHChannels_Setup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __BHChannels_Setup_List__item__value._const_tab = ___BHChannels_Setup_List__item__id_tab
    __BHChannels_Setup_List__item__value._const_tab_at = ('..', 'id')
    __BHChannels_Setup_List__item__value._const_tab_id = 'Value'
    _BHChannels_Setup_List__item_._cont = ASN1Dict([
        ('id', __BHChannels_Setup_List__item__id),
        ('criticality', __BHChannels_Setup_List__item__criticality),
        ('value', __BHChannels_Setup_List__item__value),
        ])
    _BHChannels_Setup_List__item_._ext = None
    BHChannels_Setup_List._cont = _BHChannels_Setup_List__item_
    BHChannels_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< BHChannels-FailedToBeSetup-List >-----#
    BHChannels_FailedToBeSetup_List = SEQ_OF(name='BHChannels-FailedToBeSetup-List', mode=MODE_TYPE)
    _BHChannels_FailedToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BHChannels_FailedToBeSetup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BHChannels_FailedToBeSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BHChannels_FailedToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-FailedToBeSetup-Item')))
    ___BHChannels_FailedToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 278), ('criticality', 'ignore'), ('Value', ____BHChannels_FailedToBeSetup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __BHChannels_FailedToBeSetup_List__item__id._const_tab = ___BHChannels_FailedToBeSetup_List__item__id_tab
    __BHChannels_FailedToBeSetup_List__item__id._const_tab_at = None
    __BHChannels_FailedToBeSetup_List__item__id._const_tab_id = 'id'
    __BHChannels_FailedToBeSetup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __BHChannels_FailedToBeSetup_List__item__criticality._const_tab = ___BHChannels_FailedToBeSetup_List__item__id_tab
    __BHChannels_FailedToBeSetup_List__item__criticality._const_tab_at = ('..', 'id')
    __BHChannels_FailedToBeSetup_List__item__criticality._const_tab_id = 'criticality'
    __BHChannels_FailedToBeSetup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __BHChannels_FailedToBeSetup_List__item__value._const_tab = ___BHChannels_FailedToBeSetup_List__item__id_tab
    __BHChannels_FailedToBeSetup_List__item__value._const_tab_at = ('..', 'id')
    __BHChannels_FailedToBeSetup_List__item__value._const_tab_id = 'Value'
    _BHChannels_FailedToBeSetup_List__item_._cont = ASN1Dict([
        ('id', __BHChannels_FailedToBeSetup_List__item__id),
        ('criticality', __BHChannels_FailedToBeSetup_List__item__criticality),
        ('value', __BHChannels_FailedToBeSetup_List__item__value),
        ])
    _BHChannels_FailedToBeSetup_List__item_._ext = None
    BHChannels_FailedToBeSetup_List._cont = _BHChannels_FailedToBeSetup_List__item_
    BHChannels_FailedToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< DRBs-Setup-ItemIEs >-----#
    DRBs_Setup_ItemIEs = CLASS(name='DRBs-Setup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_Setup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-Setup-Item')))
    DRBs_Setup_ItemIEs._val = ASN1Set(rv=[dict([('id', 26), ('criticality', 'ignore'), ('Value', _DRBs_Setup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SRBs-Setup-ItemIEs >-----#
    SRBs_Setup_ItemIEs = CLASS(name='SRBs-Setup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SRBs_Setup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-Setup-Item')))
    SRBs_Setup_ItemIEs._val = ASN1Set(rv=[dict([('id', 203), ('criticality', 'ignore'), ('Value', _SRBs_Setup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SRBs-FailedToBeSetup-ItemIEs >-----#
    SRBs_FailedToBeSetup_ItemIEs = CLASS(name='SRBs-FailedToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SRBs_FailedToBeSetup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-FailedToBeSetup-Item')))
    SRBs_FailedToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([('id', 65), ('criticality', 'ignore'), ('Value', _SRBs_FailedToBeSetup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-FailedToBeSetup-ItemIEs >-----#
    DRBs_FailedToBeSetup_ItemIEs = CLASS(name='DRBs-FailedToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_FailedToBeSetup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-FailedToBeSetup-Item')))
    DRBs_FailedToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([('id', 14), ('criticality', 'ignore'), ('Value', _DRBs_FailedToBeSetup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SCell-FailedtoSetup-ItemIEs >-----#
    SCell_FailedtoSetup_ItemIEs = CLASS(name='SCell-FailedtoSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SCell_FailedtoSetup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCell-FailedtoSetup-Item')))
    SCell_FailedtoSetup_ItemIEs._val = ASN1Set(rv=[dict([('id', 84), ('criticality', 'ignore'), ('Value', _SCell_FailedtoSetup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BHChannels-Setup-ItemIEs >-----#
    BHChannels_Setup_ItemIEs = CLASS(name='BHChannels-Setup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BHChannels_Setup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-Setup-Item')))
    BHChannels_Setup_ItemIEs._val = ASN1Set(rv=[dict([('id', 261), ('criticality', 'ignore'), ('Value', _BHChannels_Setup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BHChannels-FailedToBeSetup-ItemIEs >-----#
    BHChannels_FailedToBeSetup_ItemIEs = CLASS(name='BHChannels-FailedToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BHChannels_FailedToBeSetup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-FailedToBeSetup-Item')))
    BHChannels_FailedToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([('id', 278), ('criticality', 'ignore'), ('Value', _BHChannels_FailedToBeSetup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-Setup-List >-----#
    SLDRBs_Setup_List = SEQ_OF(name='SLDRBs-Setup-List', mode=MODE_TYPE)
    _SLDRBs_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_Setup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SLDRBs_Setup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_Setup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-Setup-Item')))
    ___SLDRBs_Setup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 323), ('criticality', 'ignore'), ('Value', ____SLDRBs_Setup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_Setup_List__item__id._const_tab = ___SLDRBs_Setup_List__item__id_tab
    __SLDRBs_Setup_List__item__id._const_tab_at = None
    __SLDRBs_Setup_List__item__id._const_tab_id = 'id'
    __SLDRBs_Setup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SLDRBs_Setup_List__item__criticality._const_tab = ___SLDRBs_Setup_List__item__id_tab
    __SLDRBs_Setup_List__item__criticality._const_tab_at = ('..', 'id')
    __SLDRBs_Setup_List__item__criticality._const_tab_id = 'criticality'
    __SLDRBs_Setup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SLDRBs_Setup_List__item__value._const_tab = ___SLDRBs_Setup_List__item__id_tab
    __SLDRBs_Setup_List__item__value._const_tab_at = ('..', 'id')
    __SLDRBs_Setup_List__item__value._const_tab_id = 'Value'
    _SLDRBs_Setup_List__item_._cont = ASN1Dict([
        ('id', __SLDRBs_Setup_List__item__id),
        ('criticality', __SLDRBs_Setup_List__item__criticality),
        ('value', __SLDRBs_Setup_List__item__value),
        ])
    _SLDRBs_Setup_List__item_._ext = None
    SLDRBs_Setup_List._cont = _SLDRBs_Setup_List__item_
    SLDRBs_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< SLDRBs-FailedToBeSetup-List >-----#
    SLDRBs_FailedToBeSetup_List = SEQ_OF(name='SLDRBs-FailedToBeSetup-List', mode=MODE_TYPE)
    _SLDRBs_FailedToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_FailedToBeSetup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SLDRBs_FailedToBeSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_FailedToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-FailedToBeSetup-Item')))
    ___SLDRBs_FailedToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 315), ('criticality', 'ignore'), ('Value', ____SLDRBs_FailedToBeSetup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_FailedToBeSetup_List__item__id._const_tab = ___SLDRBs_FailedToBeSetup_List__item__id_tab
    __SLDRBs_FailedToBeSetup_List__item__id._const_tab_at = None
    __SLDRBs_FailedToBeSetup_List__item__id._const_tab_id = 'id'
    __SLDRBs_FailedToBeSetup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SLDRBs_FailedToBeSetup_List__item__criticality._const_tab = ___SLDRBs_FailedToBeSetup_List__item__id_tab
    __SLDRBs_FailedToBeSetup_List__item__criticality._const_tab_at = ('..', 'id')
    __SLDRBs_FailedToBeSetup_List__item__criticality._const_tab_id = 'criticality'
    __SLDRBs_FailedToBeSetup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SLDRBs_FailedToBeSetup_List__item__value._const_tab = ___SLDRBs_FailedToBeSetup_List__item__id_tab
    __SLDRBs_FailedToBeSetup_List__item__value._const_tab_at = ('..', 'id')
    __SLDRBs_FailedToBeSetup_List__item__value._const_tab_id = 'Value'
    _SLDRBs_FailedToBeSetup_List__item_._cont = ASN1Dict([
        ('id', __SLDRBs_FailedToBeSetup_List__item__id),
        ('criticality', __SLDRBs_FailedToBeSetup_List__item__criticality),
        ('value', __SLDRBs_FailedToBeSetup_List__item__value),
        ])
    _SLDRBs_FailedToBeSetup_List__item_._ext = None
    SLDRBs_FailedToBeSetup_List._cont = _SLDRBs_FailedToBeSetup_List__item_
    SLDRBs_FailedToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< SLDRBs-Setup-ItemIEs >-----#
    SLDRBs_Setup_ItemIEs = CLASS(name='SLDRBs-Setup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_Setup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-Setup-Item')))
    SLDRBs_Setup_ItemIEs._val = ASN1Set(rv=[dict([('id', 323), ('criticality', 'ignore'), ('Value', _SLDRBs_Setup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-FailedToBeSetup-ItemIEs >-----#
    SLDRBs_FailedToBeSetup_ItemIEs = CLASS(name='SLDRBs-FailedToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_FailedToBeSetup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-FailedToBeSetup-Item')))
    SLDRBs_FailedToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([('id', 315), ('criticality', 'ignore'), ('Value', _SLDRBs_FailedToBeSetup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEContextSetupFailure >-----#
    UEContextSetupFailure = SEQ(name='UEContextSetupFailure', mode=MODE_TYPE)
    _UEContextSetupFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEContextSetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextSetupFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____UEContextSetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Potential-SpCell-List')))
    _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    ____UEContextSetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'ignore'), ('Value', _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 92), ('criticality', 'ignore'), ('Value', _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 376), ('criticality', 'reject'), ('Value', _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextSetupFailure_protocolIEs__item__id._const_tab = ____UEContextSetupFailure_protocolIEs__item__id_tab
    ___UEContextSetupFailure_protocolIEs__item__id._const_tab_at = None
    ___UEContextSetupFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextSetupFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextSetupFailure_protocolIEs__item__criticality._const_tab = ____UEContextSetupFailure_protocolIEs__item__id_tab
    ___UEContextSetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextSetupFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextSetupFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___UEContextSetupFailure_protocolIEs__item__value._const_tab = ____UEContextSetupFailure_protocolIEs__item__id_tab
    ___UEContextSetupFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextSetupFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextSetupFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextSetupFailure_protocolIEs__item__id),
        ('criticality', ___UEContextSetupFailure_protocolIEs__item__criticality),
        ('value', ___UEContextSetupFailure_protocolIEs__item__value),
        ])
    __UEContextSetupFailure_protocolIEs__item_._ext = None
    _UEContextSetupFailure_protocolIEs._cont = __UEContextSetupFailure_protocolIEs__item_
    _UEContextSetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextSetupFailure._cont = ASN1Dict([
        ('protocolIEs', _UEContextSetupFailure_protocolIEs),
        ])
    UEContextSetupFailure._ext = []
    
    #-----< UEContextSetupFailureIEs >-----#
    UEContextSetupFailureIEs = CLASS(name='UEContextSetupFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEContextSetupFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEContextSetupFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextSetupFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _UEContextSetupFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _UEContextSetupFailureIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Potential-SpCell-List')))
    _UEContextSetupFailureIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    UEContextSetupFailureIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _UEContextSetupFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'ignore'), ('Value', _UEContextSetupFailureIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _UEContextSetupFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _UEContextSetupFailureIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 92), ('criticality', 'ignore'), ('Value', _UEContextSetupFailureIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 376), ('criticality', 'reject'), ('Value', _UEContextSetupFailureIEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Potential-SpCell-List >-----#
    Potential_SpCell_List = SEQ_OF(name='Potential-SpCell-List', mode=MODE_TYPE)
    _Potential_SpCell_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Potential_SpCell_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___Potential_SpCell_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Potential_SpCell_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Potential-SpCell-Item')))
    ___Potential_SpCell_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 93), ('criticality', 'ignore'), ('Value', ____Potential_SpCell_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Potential_SpCell_List__item__id._const_tab = ___Potential_SpCell_List__item__id_tab
    __Potential_SpCell_List__item__id._const_tab_at = None
    __Potential_SpCell_List__item__id._const_tab_id = 'id'
    __Potential_SpCell_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __Potential_SpCell_List__item__criticality._const_tab = ___Potential_SpCell_List__item__id_tab
    __Potential_SpCell_List__item__criticality._const_tab_at = ('..', 'id')
    __Potential_SpCell_List__item__criticality._const_tab_id = 'criticality'
    __Potential_SpCell_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __Potential_SpCell_List__item__value._const_tab = ___Potential_SpCell_List__item__id_tab
    __Potential_SpCell_List__item__value._const_tab_at = ('..', 'id')
    __Potential_SpCell_List__item__value._const_tab_id = 'Value'
    _Potential_SpCell_List__item_._cont = ASN1Dict([
        ('id', __Potential_SpCell_List__item__id),
        ('criticality', __Potential_SpCell_List__item__criticality),
        ('value', __Potential_SpCell_List__item__value),
        ])
    _Potential_SpCell_List__item_._ext = None
    Potential_SpCell_List._cont = _Potential_SpCell_List__item_
    Potential_SpCell_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=64)], ev=None, er=[])
    
    #-----< Potential-SpCell-ItemIEs >-----#
    Potential_SpCell_ItemIEs = CLASS(name='Potential-SpCell-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Potential_SpCell_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Potential-SpCell-Item')))
    Potential_SpCell_ItemIEs._val = ASN1Set(rv=[dict([('id', 93), ('criticality', 'ignore'), ('Value', _Potential_SpCell_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEContextReleaseRequest >-----#
    UEContextReleaseRequest = SEQ(name='UEContextReleaseRequest', mode=MODE_TYPE)
    _UEContextReleaseRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEContextReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextReleaseRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____UEContextReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TargetCellList')))
    ____UEContextReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 375), ('criticality', 'reject'), ('Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextReleaseRequest_protocolIEs__item__id._const_tab = ____UEContextReleaseRequest_protocolIEs__item__id_tab
    ___UEContextReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___UEContextReleaseRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextReleaseRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextReleaseRequest_protocolIEs__item__criticality._const_tab = ____UEContextReleaseRequest_protocolIEs__item__id_tab
    ___UEContextReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextReleaseRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextReleaseRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___UEContextReleaseRequest_protocolIEs__item__value._const_tab = ____UEContextReleaseRequest_protocolIEs__item__id_tab
    ___UEContextReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextReleaseRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextReleaseRequest_protocolIEs__item__id),
        ('criticality', ___UEContextReleaseRequest_protocolIEs__item__criticality),
        ('value', ___UEContextReleaseRequest_protocolIEs__item__value),
        ])
    __UEContextReleaseRequest_protocolIEs__item_._ext = None
    _UEContextReleaseRequest_protocolIEs._cont = __UEContextReleaseRequest_protocolIEs__item_
    _UEContextReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextReleaseRequest._cont = ASN1Dict([
        ('protocolIEs', _UEContextReleaseRequest_protocolIEs),
        ])
    UEContextReleaseRequest._ext = []
    
    #-----< UEContextReleaseRequestIEs >-----#
    UEContextReleaseRequestIEs = CLASS(name='UEContextReleaseRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEContextReleaseRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEContextReleaseRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextReleaseRequestIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _UEContextReleaseRequestIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TargetCellList')))
    UEContextReleaseRequestIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _UEContextReleaseRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _UEContextReleaseRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _UEContextReleaseRequestIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 375), ('criticality', 'reject'), ('Value', _UEContextReleaseRequestIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextReleaseCommand >-----#
    UEContextReleaseCommand = SEQ(name='UEContextReleaseCommand', mode=MODE_TYPE)
    _UEContextReleaseCommand_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEContextReleaseCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextReleaseCommand_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____UEContextReleaseCommand_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExecuteDuplication')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCDeliveryStatusRequest')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_8 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TargetCellList')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosConextRevIndication')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CG-SDTKeptIndicator')))
    ____UEContextReleaseCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 50), ('criticality', 'ignore'), ('Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 64), ('criticality', 'ignore'), ('Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_4), ('presence', 'conditional')]), dict([('id', 47), ('criticality', 'ignore'), ('Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 109), ('criticality', 'ignore'), ('Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 184), ('criticality', 'ignore'), ('Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 375), ('criticality', 'reject'), ('Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 576), ('criticality', 'reject'), ('Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 588), ('criticality', 'ignore'), ('Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextReleaseCommand_protocolIEs__item__id._const_tab = ____UEContextReleaseCommand_protocolIEs__item__id_tab
    ___UEContextReleaseCommand_protocolIEs__item__id._const_tab_at = None
    ___UEContextReleaseCommand_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextReleaseCommand_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextReleaseCommand_protocolIEs__item__criticality._const_tab = ____UEContextReleaseCommand_protocolIEs__item__id_tab
    ___UEContextReleaseCommand_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextReleaseCommand_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextReleaseCommand_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___UEContextReleaseCommand_protocolIEs__item__value._const_tab = ____UEContextReleaseCommand_protocolIEs__item__id_tab
    ___UEContextReleaseCommand_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextReleaseCommand_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextReleaseCommand_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextReleaseCommand_protocolIEs__item__id),
        ('criticality', ___UEContextReleaseCommand_protocolIEs__item__criticality),
        ('value', ___UEContextReleaseCommand_protocolIEs__item__value),
        ])
    __UEContextReleaseCommand_protocolIEs__item_._ext = None
    _UEContextReleaseCommand_protocolIEs._cont = __UEContextReleaseCommand_protocolIEs__item_
    _UEContextReleaseCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextReleaseCommand._cont = ASN1Dict([
        ('protocolIEs', _UEContextReleaseCommand_protocolIEs),
        ])
    UEContextReleaseCommand._ext = []
    
    #-----< UEContextReleaseCommandIEs >-----#
    UEContextReleaseCommandIEs = CLASS(name='UEContextReleaseCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEContextReleaseCommandIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEContextReleaseCommandIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextReleaseCommandIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _UEContextReleaseCommandIEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _UEContextReleaseCommandIEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _UEContextReleaseCommandIEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextReleaseCommandIEs_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExecuteDuplication')))
    _UEContextReleaseCommandIEs_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCDeliveryStatusRequest')))
    _UEContextReleaseCommandIEs_val_Value_8 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TargetCellList')))
    _UEContextReleaseCommandIEs_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosConextRevIndication')))
    _UEContextReleaseCommandIEs_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CG-SDTKeptIndicator')))
    UEContextReleaseCommandIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _UEContextReleaseCommandIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _UEContextReleaseCommandIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _UEContextReleaseCommandIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 50), ('criticality', 'ignore'), ('Value', _UEContextReleaseCommandIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 64), ('criticality', 'ignore'), ('Value', _UEContextReleaseCommandIEs_val_Value_4), ('presence', 'conditional')]), dict([('id', 47), ('criticality', 'ignore'), ('Value', _UEContextReleaseCommandIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 109), ('criticality', 'ignore'), ('Value', _UEContextReleaseCommandIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 184), ('criticality', 'ignore'), ('Value', _UEContextReleaseCommandIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 375), ('criticality', 'reject'), ('Value', _UEContextReleaseCommandIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 576), ('criticality', 'reject'), ('Value', _UEContextReleaseCommandIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 588), ('criticality', 'ignore'), ('Value', _UEContextReleaseCommandIEs_val_Value_10), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextReleaseComplete >-----#
    UEContextReleaseComplete = SEQ(name='UEContextReleaseComplete', mode=MODE_TYPE)
    _UEContextReleaseComplete_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEContextReleaseComplete_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextReleaseComplete_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____UEContextReleaseComplete_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____UEContextReleaseComplete_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextReleaseComplete_protocolIEs__item__id._const_tab = ____UEContextReleaseComplete_protocolIEs__item__id_tab
    ___UEContextReleaseComplete_protocolIEs__item__id._const_tab_at = None
    ___UEContextReleaseComplete_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextReleaseComplete_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextReleaseComplete_protocolIEs__item__criticality._const_tab = ____UEContextReleaseComplete_protocolIEs__item__id_tab
    ___UEContextReleaseComplete_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextReleaseComplete_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextReleaseComplete_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___UEContextReleaseComplete_protocolIEs__item__value._const_tab = ____UEContextReleaseComplete_protocolIEs__item__id_tab
    ___UEContextReleaseComplete_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextReleaseComplete_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextReleaseComplete_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextReleaseComplete_protocolIEs__item__id),
        ('criticality', ___UEContextReleaseComplete_protocolIEs__item__criticality),
        ('value', ___UEContextReleaseComplete_protocolIEs__item__value),
        ])
    __UEContextReleaseComplete_protocolIEs__item_._ext = None
    _UEContextReleaseComplete_protocolIEs._cont = __UEContextReleaseComplete_protocolIEs__item_
    _UEContextReleaseComplete_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextReleaseComplete._cont = ASN1Dict([
        ('protocolIEs', _UEContextReleaseComplete_protocolIEs),
        ])
    UEContextReleaseComplete._ext = []
    
    #-----< UEContextReleaseCompleteIEs >-----#
    UEContextReleaseCompleteIEs = CLASS(name='UEContextReleaseCompleteIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEContextReleaseCompleteIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEContextReleaseCompleteIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextReleaseCompleteIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    UEContextReleaseCompleteIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _UEContextReleaseCompleteIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _UEContextReleaseCompleteIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _UEContextReleaseCompleteIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationRequest >-----#
    UEContextModificationRequest = SEQ(name='UEContextModificationRequest', mode=MODE_TYPE)
    _UEContextModificationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____UEContextModificationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServCellIndex')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellULConfigured')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRXCycle')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CUtoDURRCInformation')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransmissionActionIndicator')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_8 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferContainer')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCReconfigurationCompleteIndicator')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_10 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_11 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SCell-ToBeSetupMod-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_12 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SCell-ToBeRemoved-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_13 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-ToBeSetupMod-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_14 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-ToBeSetupMod-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_15 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-ToBeModified-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_16 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-ToBeReleased-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_17 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-ToBeReleased-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_18 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'InactivityMonitoringRequest')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_19 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAT-FrequencyPriorityInformation')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_20 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRXConfigurationIndicator')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_21 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLCFailureIndication')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_22 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UplinkTxDirectCurrentListInformation')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_23 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DUConfigurationQuery')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_24 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_25 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExecuteDuplication')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_26 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCDeliveryStatusRequest')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_27 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferInformation')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_28 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServingCellMO')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_29 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NeedforGap')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_30 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FullConfiguration')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_31 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_32 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LowerLayerPresenceStatusChange')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_33 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-ToBeSetupMod-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_34 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-ToBeModified-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_35 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-ToBeReleased-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_36 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRV2XServicesAuthorized')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_37 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LTEV2XServicesAuthorized')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_38 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_39 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LTEUESidelinkAggregateMaximumBitrate')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_40 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_41 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-ToBeSetupMod-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_42 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-ToBeModified-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_43 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-ToBeReleased-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_44 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ConditionalIntraDUMobilityInformation')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_45 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'F1CTransferPath')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_46 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCGIndicator')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_47 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UplinkTxDirectCurrentTwoCarrierListInfo')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_48 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IABConditionalRRCMessageDeliveryIndication')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_49 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'F1CTransferPathNRDC')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_50 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MDTPollutedMeasurementIndicator')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_51 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCGActivationRequest')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_52 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CG-SDTQueryIndication')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_53 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FiveG-ProSeAuthorized')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_54 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_55 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_56 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RemoteUELocalID')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_57 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelToBeSetupList')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_58 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelToBeModifiedList')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_59 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelToBeReleasedList')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_60 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelToBeSetupList')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_61 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelToBeModifiedList')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_62 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelToBeReleasedList')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_63 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PathSwitchConfiguration')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_64 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBDUUESliceMaximumBitRateList')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_65 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMBSSessionList')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_66 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMBSSessionList')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_67 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UE-MulticastMRBs-ToBeSetup-atModify-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_68 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UE-MulticastMRBs-ToBeReleased-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_69 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRXCycleList')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_70 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MDTPLMNModificationList')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_71 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SDTBearerConfigurationQueryIndication')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_72 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DAPS-HO-Status')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_73 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ServingCellMO-List')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_74 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UlTxDirectCurrentMoreCarrierInformation')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_75 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CPACMCGInformation')))
    ____UEContextModificationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 63), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 107), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 38), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 79), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 49), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 87), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 50), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 56), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 52), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 76), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 37), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 31), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 72), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')]), dict([('id', 33), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_17), ('presence', 'optional')]), dict([('id', 97), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_18), ('presence', 'optional')]), dict([('id', 108), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_19), ('presence', 'optional')]), dict([('id', 159), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_20), ('presence', 'optional')]), dict([('id', 174), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_21), ('presence', 'optional')]), dict([('id', 175), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_22), ('presence', 'optional')]), dict([('id', 162), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_23), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_24), ('presence', 'optional')]), dict([('id', 109), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_25), ('presence', 'optional')]), dict([('id', 184), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_26), ('presence', 'optional')]), dict([('id', 195), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_27), ('presence', 'optional')]), dict([('id', 182), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_28), ('presence', 'optional')]), dict([('id', 215), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_29), ('presence', 'optional')]), dict([('id', 94), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_30), ('presence', 'optional')]), dict([('id', 248), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_31), ('presence', 'optional')]), dict([('id', 253), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_32), ('presence', 'optional')]), dict([('id', 267), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_33), ('presence', 'optional')]), dict([('id', 263), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_34), ('presence', 'optional')]), dict([('id', 265), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_35), ('presence', 'optional')]), dict([('id', 306), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_36), ('presence', 'optional')]), dict([('id', 307), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_37), ('presence', 'optional')]), dict([('id', 308), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_38), ('presence', 'optional')]), dict([('id', 309), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_39), ('presence', 'optional')]), dict([('id', 340), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_40), ('presence', 'optional')]), dict([('id', 332), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_41), ('presence', 'optional')]), dict([('id', 326), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_42), ('presence', 'optional')]), dict([('id', 328), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_43), ('presence', 'optional')]), dict([('id', 374), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_44), ('presence', 'optional')]), dict([('id', 428), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_45), ('presence', 'optional')]), dict([('id', 432), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_46), ('presence', 'optional')]), dict([('id', 684), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_47), ('presence', 'optional')]), dict([('id', 510), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_48), ('presence', 'optional')]), dict([('id', 511), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_49), ('presence', 'optional')]), dict([('id', 536), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_50), ('presence', 'optional')]), dict([('id', 547), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_51), ('presence', 'optional')]), dict([('id', 586), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_52), ('presence', 'optional')]), dict([('id', 594), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_53), ('presence', 'optional')]), dict([('id', 595), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_54), ('presence', 'optional')]), dict([('id', 596), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_55), ('presence', 'optional')]), dict([('id', 618), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_56), ('presence', 'optional')]), dict([('id', 599), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_57), ('presence', 'optional')]), dict([('id', 600), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_58), ('presence', 'optional')]), dict([('id', 601), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_59), ('presence', 'optional')]), dict([('id', 608), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_60), ('presence', 'optional')]), dict([('id', 609), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_61), ('presence', 'optional')]), dict([('id', 610), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_62), ('presence', 'optional')]), dict([('id', 619), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_63), ('presence', 'optional')]), dict([('id', 626), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_64), ('presence', 'optional')]), dict([('id', 632), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_65), ('presence', 'optional')]), dict([('id', 633), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_66), ('presence', 'optional')]), dict([('id', 685), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_67), ('presence', 'optional')]), dict([('id', 628), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_68), ('presence', 'optional')]), dict([('id', 643), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_69), ('presence', 'optional')]), dict([('id', 647), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_70), ('presence', 'optional')]), dict([('id', 675), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_71), ('presence', 'optional')]), dict([('id', 683), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_72), ('presence', 'optional')]), dict([('id', 695), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_73), ('presence', 'optional')]), dict([('id', 690), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_74), ('presence', 'optional')]), dict([('id', 691), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_75), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationRequest_protocolIEs__item__id._const_tab = ____UEContextModificationRequest_protocolIEs__item__id_tab
    ___UEContextModificationRequest_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextModificationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextModificationRequest_protocolIEs__item__criticality._const_tab = ____UEContextModificationRequest_protocolIEs__item__id_tab
    ___UEContextModificationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextModificationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextModificationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___UEContextModificationRequest_protocolIEs__item__value._const_tab = ____UEContextModificationRequest_protocolIEs__item__id_tab
    ___UEContextModificationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextModificationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextModificationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextModificationRequest_protocolIEs__item__id),
        ('criticality', ___UEContextModificationRequest_protocolIEs__item__criticality),
        ('value', ___UEContextModificationRequest_protocolIEs__item__value),
        ])
    __UEContextModificationRequest_protocolIEs__item_._ext = None
    _UEContextModificationRequest_protocolIEs._cont = __UEContextModificationRequest_protocolIEs__item_
    _UEContextModificationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationRequest._cont = ASN1Dict([
        ('protocolIEs', _UEContextModificationRequest_protocolIEs),
        ])
    UEContextModificationRequest._ext = []
    
    #-----< UEContextModificationRequestIEs >-----#
    UEContextModificationRequestIEs = CLASS(name='UEContextModificationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEContextModificationRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEContextModificationRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextModificationRequestIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _UEContextModificationRequestIEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServCellIndex')))
    _UEContextModificationRequestIEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellULConfigured')))
    _UEContextModificationRequestIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRXCycle')))
    _UEContextModificationRequestIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CUtoDURRCInformation')))
    _UEContextModificationRequestIEs_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransmissionActionIndicator')))
    _UEContextModificationRequestIEs_val_Value_8 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferContainer')))
    _UEContextModificationRequestIEs_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCReconfigurationCompleteIndicator')))
    _UEContextModificationRequestIEs_val_Value_10 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _UEContextModificationRequestIEs_val_Value_11 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SCell-ToBeSetupMod-List')))
    _UEContextModificationRequestIEs_val_Value_12 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SCell-ToBeRemoved-List')))
    _UEContextModificationRequestIEs_val_Value_13 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-ToBeSetupMod-List')))
    _UEContextModificationRequestIEs_val_Value_14 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-ToBeSetupMod-List')))
    _UEContextModificationRequestIEs_val_Value_15 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-ToBeModified-List')))
    _UEContextModificationRequestIEs_val_Value_16 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-ToBeReleased-List')))
    _UEContextModificationRequestIEs_val_Value_17 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-ToBeReleased-List')))
    _UEContextModificationRequestIEs_val_Value_18 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'InactivityMonitoringRequest')))
    _UEContextModificationRequestIEs_val_Value_19 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAT-FrequencyPriorityInformation')))
    _UEContextModificationRequestIEs_val_Value_20 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRXConfigurationIndicator')))
    _UEContextModificationRequestIEs_val_Value_21 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLCFailureIndication')))
    _UEContextModificationRequestIEs_val_Value_22 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UplinkTxDirectCurrentListInformation')))
    _UEContextModificationRequestIEs_val_Value_23 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DUConfigurationQuery')))
    _UEContextModificationRequestIEs_val_Value_24 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _UEContextModificationRequestIEs_val_Value_25 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExecuteDuplication')))
    _UEContextModificationRequestIEs_val_Value_26 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCDeliveryStatusRequest')))
    _UEContextModificationRequestIEs_val_Value_27 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferInformation')))
    _UEContextModificationRequestIEs_val_Value_28 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServingCellMO')))
    _UEContextModificationRequestIEs_val_Value_29 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NeedforGap')))
    _UEContextModificationRequestIEs_val_Value_30 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FullConfiguration')))
    _UEContextModificationRequestIEs_val_Value_31 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _UEContextModificationRequestIEs_val_Value_32 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LowerLayerPresenceStatusChange')))
    _UEContextModificationRequestIEs_val_Value_33 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-ToBeSetupMod-List')))
    _UEContextModificationRequestIEs_val_Value_34 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-ToBeModified-List')))
    _UEContextModificationRequestIEs_val_Value_35 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-ToBeReleased-List')))
    _UEContextModificationRequestIEs_val_Value_36 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRV2XServicesAuthorized')))
    _UEContextModificationRequestIEs_val_Value_37 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LTEV2XServicesAuthorized')))
    _UEContextModificationRequestIEs_val_Value_38 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _UEContextModificationRequestIEs_val_Value_39 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LTEUESidelinkAggregateMaximumBitrate')))
    _UEContextModificationRequestIEs_val_Value_40 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _UEContextModificationRequestIEs_val_Value_41 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-ToBeSetupMod-List')))
    _UEContextModificationRequestIEs_val_Value_42 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-ToBeModified-List')))
    _UEContextModificationRequestIEs_val_Value_43 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-ToBeReleased-List')))
    _UEContextModificationRequestIEs_val_Value_44 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ConditionalIntraDUMobilityInformation')))
    _UEContextModificationRequestIEs_val_Value_45 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'F1CTransferPath')))
    _UEContextModificationRequestIEs_val_Value_46 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCGIndicator')))
    _UEContextModificationRequestIEs_val_Value_47 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UplinkTxDirectCurrentTwoCarrierListInfo')))
    _UEContextModificationRequestIEs_val_Value_48 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IABConditionalRRCMessageDeliveryIndication')))
    _UEContextModificationRequestIEs_val_Value_49 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'F1CTransferPathNRDC')))
    _UEContextModificationRequestIEs_val_Value_50 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MDTPollutedMeasurementIndicator')))
    _UEContextModificationRequestIEs_val_Value_51 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCGActivationRequest')))
    _UEContextModificationRequestIEs_val_Value_52 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CG-SDTQueryIndication')))
    _UEContextModificationRequestIEs_val_Value_53 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FiveG-ProSeAuthorized')))
    _UEContextModificationRequestIEs_val_Value_54 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _UEContextModificationRequestIEs_val_Value_55 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BitRate')))
    _UEContextModificationRequestIEs_val_Value_56 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RemoteUELocalID')))
    _UEContextModificationRequestIEs_val_Value_57 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelToBeSetupList')))
    _UEContextModificationRequestIEs_val_Value_58 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelToBeModifiedList')))
    _UEContextModificationRequestIEs_val_Value_59 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelToBeReleasedList')))
    _UEContextModificationRequestIEs_val_Value_60 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelToBeSetupList')))
    _UEContextModificationRequestIEs_val_Value_61 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelToBeModifiedList')))
    _UEContextModificationRequestIEs_val_Value_62 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelToBeReleasedList')))
    _UEContextModificationRequestIEs_val_Value_63 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PathSwitchConfiguration')))
    _UEContextModificationRequestIEs_val_Value_64 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBDUUESliceMaximumBitRateList')))
    _UEContextModificationRequestIEs_val_Value_65 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMBSSessionList')))
    _UEContextModificationRequestIEs_val_Value_66 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMBSSessionList')))
    _UEContextModificationRequestIEs_val_Value_67 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UE-MulticastMRBs-ToBeSetup-atModify-List')))
    _UEContextModificationRequestIEs_val_Value_68 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UE-MulticastMRBs-ToBeReleased-List')))
    _UEContextModificationRequestIEs_val_Value_69 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRXCycleList')))
    _UEContextModificationRequestIEs_val_Value_70 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MDTPLMNModificationList')))
    _UEContextModificationRequestIEs_val_Value_71 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SDTBearerConfigurationQueryIndication')))
    _UEContextModificationRequestIEs_val_Value_72 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DAPS-HO-Status')))
    _UEContextModificationRequestIEs_val_Value_73 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ServingCellMO-List')))
    _UEContextModificationRequestIEs_val_Value_74 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UlTxDirectCurrentMoreCarrierInformation')))
    _UEContextModificationRequestIEs_val_Value_75 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CPACMCGInformation')))
    UEContextModificationRequestIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 63), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 107), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 38), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 79), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 49), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 87), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 50), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 56), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 52), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_12), ('presence', 'optional')]), dict([('id', 76), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_13), ('presence', 'optional')]), dict([('id', 37), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_14), ('presence', 'optional')]), dict([('id', 31), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_15), ('presence', 'optional')]), dict([('id', 72), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_16), ('presence', 'optional')]), dict([('id', 33), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_17), ('presence', 'optional')]), dict([('id', 97), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_18), ('presence', 'optional')]), dict([('id', 108), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_19), ('presence', 'optional')]), dict([('id', 159), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_20), ('presence', 'optional')]), dict([('id', 174), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_21), ('presence', 'optional')]), dict([('id', 175), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_22), ('presence', 'optional')]), dict([('id', 162), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_23), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_24), ('presence', 'optional')]), dict([('id', 109), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_25), ('presence', 'optional')]), dict([('id', 184), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_26), ('presence', 'optional')]), dict([('id', 195), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_27), ('presence', 'optional')]), dict([('id', 182), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_28), ('presence', 'optional')]), dict([('id', 215), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_29), ('presence', 'optional')]), dict([('id', 94), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_30), ('presence', 'optional')]), dict([('id', 248), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_31), ('presence', 'optional')]), dict([('id', 253), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_32), ('presence', 'optional')]), dict([('id', 267), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_33), ('presence', 'optional')]), dict([('id', 263), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_34), ('presence', 'optional')]), dict([('id', 265), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_35), ('presence', 'optional')]), dict([('id', 306), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_36), ('presence', 'optional')]), dict([('id', 307), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_37), ('presence', 'optional')]), dict([('id', 308), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_38), ('presence', 'optional')]), dict([('id', 309), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_39), ('presence', 'optional')]), dict([('id', 340), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_40), ('presence', 'optional')]), dict([('id', 332), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_41), ('presence', 'optional')]), dict([('id', 326), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_42), ('presence', 'optional')]), dict([('id', 328), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_43), ('presence', 'optional')]), dict([('id', 374), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_44), ('presence', 'optional')]), dict([('id', 428), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_45), ('presence', 'optional')]), dict([('id', 432), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_46), ('presence', 'optional')]), dict([('id', 684), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_47), ('presence', 'optional')]), dict([('id', 510), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_48), ('presence', 'optional')]), dict([('id', 511), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_49), ('presence', 'optional')]), dict([('id', 536), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_50), ('presence', 'optional')]), dict([('id', 547), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_51), ('presence', 'optional')]), dict([('id', 586), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_52), ('presence', 'optional')]), dict([('id', 594), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_53), ('presence', 'optional')]), dict([('id', 595), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_54), ('presence', 'optional')]), dict([('id', 596), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_55), ('presence', 'optional')]), dict([('id', 618), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_56), ('presence', 'optional')]), dict([('id', 599), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_57), ('presence', 'optional')]), dict([('id', 600), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_58), ('presence', 'optional')]), dict([('id', 601), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_59), ('presence', 'optional')]), dict([('id', 608), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_60), ('presence', 'optional')]), dict([('id', 609), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_61), ('presence', 'optional')]), dict([('id', 610), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_62), ('presence', 'optional')]), dict([('id', 619), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_63), ('presence', 'optional')]), dict([('id', 626), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_64), ('presence', 'optional')]), dict([('id', 632), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_65), ('presence', 'optional')]), dict([('id', 633), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_66), ('presence', 'optional')]), dict([('id', 685), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_67), ('presence', 'optional')]), dict([('id', 628), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_68), ('presence', 'optional')]), dict([('id', 643), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_69), ('presence', 'optional')]), dict([('id', 647), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_70), ('presence', 'optional')]), dict([('id', 675), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_71), ('presence', 'optional')]), dict([('id', 683), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_72), ('presence', 'optional')]), dict([('id', 695), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_73), ('presence', 'optional')]), dict([('id', 690), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_74), ('presence', 'optional')]), dict([('id', 691), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_75), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SCell-ToBeSetupMod-List >-----#
    SCell_ToBeSetupMod_List = SEQ_OF(name='SCell-ToBeSetupMod-List', mode=MODE_TYPE)
    _SCell_ToBeSetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SCell_ToBeSetupMod_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SCell_ToBeSetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SCell_ToBeSetupMod_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCell-ToBeSetupMod-Item')))
    ___SCell_ToBeSetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 55), ('criticality', 'ignore'), ('Value', ____SCell_ToBeSetupMod_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SCell_ToBeSetupMod_List__item__id._const_tab = ___SCell_ToBeSetupMod_List__item__id_tab
    __SCell_ToBeSetupMod_List__item__id._const_tab_at = None
    __SCell_ToBeSetupMod_List__item__id._const_tab_id = 'id'
    __SCell_ToBeSetupMod_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SCell_ToBeSetupMod_List__item__criticality._const_tab = ___SCell_ToBeSetupMod_List__item__id_tab
    __SCell_ToBeSetupMod_List__item__criticality._const_tab_at = ('..', 'id')
    __SCell_ToBeSetupMod_List__item__criticality._const_tab_id = 'criticality'
    __SCell_ToBeSetupMod_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SCell_ToBeSetupMod_List__item__value._const_tab = ___SCell_ToBeSetupMod_List__item__id_tab
    __SCell_ToBeSetupMod_List__item__value._const_tab_at = ('..', 'id')
    __SCell_ToBeSetupMod_List__item__value._const_tab_id = 'Value'
    _SCell_ToBeSetupMod_List__item_._cont = ASN1Dict([
        ('id', __SCell_ToBeSetupMod_List__item__id),
        ('criticality', __SCell_ToBeSetupMod_List__item__criticality),
        ('value', __SCell_ToBeSetupMod_List__item__value),
        ])
    _SCell_ToBeSetupMod_List__item_._ext = None
    SCell_ToBeSetupMod_List._cont = _SCell_ToBeSetupMod_List__item_
    SCell_ToBeSetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SCell-ToBeRemoved-List >-----#
    SCell_ToBeRemoved_List = SEQ_OF(name='SCell-ToBeRemoved-List', mode=MODE_TYPE)
    _SCell_ToBeRemoved_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SCell_ToBeRemoved_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SCell_ToBeRemoved_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SCell_ToBeRemoved_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCell-ToBeRemoved-Item')))
    ___SCell_ToBeRemoved_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 51), ('criticality', 'ignore'), ('Value', ____SCell_ToBeRemoved_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SCell_ToBeRemoved_List__item__id._const_tab = ___SCell_ToBeRemoved_List__item__id_tab
    __SCell_ToBeRemoved_List__item__id._const_tab_at = None
    __SCell_ToBeRemoved_List__item__id._const_tab_id = 'id'
    __SCell_ToBeRemoved_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SCell_ToBeRemoved_List__item__criticality._const_tab = ___SCell_ToBeRemoved_List__item__id_tab
    __SCell_ToBeRemoved_List__item__criticality._const_tab_at = ('..', 'id')
    __SCell_ToBeRemoved_List__item__criticality._const_tab_id = 'criticality'
    __SCell_ToBeRemoved_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SCell_ToBeRemoved_List__item__value._const_tab = ___SCell_ToBeRemoved_List__item__id_tab
    __SCell_ToBeRemoved_List__item__value._const_tab_at = ('..', 'id')
    __SCell_ToBeRemoved_List__item__value._const_tab_id = 'Value'
    _SCell_ToBeRemoved_List__item_._cont = ASN1Dict([
        ('id', __SCell_ToBeRemoved_List__item__id),
        ('criticality', __SCell_ToBeRemoved_List__item__criticality),
        ('value', __SCell_ToBeRemoved_List__item__value),
        ])
    _SCell_ToBeRemoved_List__item_._ext = None
    SCell_ToBeRemoved_List._cont = _SCell_ToBeRemoved_List__item_
    SCell_ToBeRemoved_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SRBs-ToBeSetupMod-List >-----#
    SRBs_ToBeSetupMod_List = SEQ_OF(name='SRBs-ToBeSetupMod-List', mode=MODE_TYPE)
    _SRBs_ToBeSetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SRBs_ToBeSetupMod_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SRBs_ToBeSetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SRBs_ToBeSetupMod_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-ToBeSetupMod-Item')))
    ___SRBs_ToBeSetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 75), ('criticality', 'reject'), ('Value', ____SRBs_ToBeSetupMod_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SRBs_ToBeSetupMod_List__item__id._const_tab = ___SRBs_ToBeSetupMod_List__item__id_tab
    __SRBs_ToBeSetupMod_List__item__id._const_tab_at = None
    __SRBs_ToBeSetupMod_List__item__id._const_tab_id = 'id'
    __SRBs_ToBeSetupMod_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SRBs_ToBeSetupMod_List__item__criticality._const_tab = ___SRBs_ToBeSetupMod_List__item__id_tab
    __SRBs_ToBeSetupMod_List__item__criticality._const_tab_at = ('..', 'id')
    __SRBs_ToBeSetupMod_List__item__criticality._const_tab_id = 'criticality'
    __SRBs_ToBeSetupMod_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SRBs_ToBeSetupMod_List__item__value._const_tab = ___SRBs_ToBeSetupMod_List__item__id_tab
    __SRBs_ToBeSetupMod_List__item__value._const_tab_at = ('..', 'id')
    __SRBs_ToBeSetupMod_List__item__value._const_tab_id = 'Value'
    _SRBs_ToBeSetupMod_List__item_._cont = ASN1Dict([
        ('id', __SRBs_ToBeSetupMod_List__item__id),
        ('criticality', __SRBs_ToBeSetupMod_List__item__criticality),
        ('value', __SRBs_ToBeSetupMod_List__item__value),
        ])
    _SRBs_ToBeSetupMod_List__item_._ext = None
    SRBs_ToBeSetupMod_List._cont = _SRBs_ToBeSetupMod_List__item_
    SRBs_ToBeSetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< DRBs-ToBeSetupMod-List >-----#
    DRBs_ToBeSetupMod_List = SEQ_OF(name='DRBs-ToBeSetupMod-List', mode=MODE_TYPE)
    _DRBs_ToBeSetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_ToBeSetupMod_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___DRBs_ToBeSetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_ToBeSetupMod_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-ToBeSetupMod-Item')))
    ___DRBs_ToBeSetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 36), ('criticality', 'reject'), ('Value', ____DRBs_ToBeSetupMod_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_ToBeSetupMod_List__item__id._const_tab = ___DRBs_ToBeSetupMod_List__item__id_tab
    __DRBs_ToBeSetupMod_List__item__id._const_tab_at = None
    __DRBs_ToBeSetupMod_List__item__id._const_tab_id = 'id'
    __DRBs_ToBeSetupMod_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __DRBs_ToBeSetupMod_List__item__criticality._const_tab = ___DRBs_ToBeSetupMod_List__item__id_tab
    __DRBs_ToBeSetupMod_List__item__criticality._const_tab_at = ('..', 'id')
    __DRBs_ToBeSetupMod_List__item__criticality._const_tab_id = 'criticality'
    __DRBs_ToBeSetupMod_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __DRBs_ToBeSetupMod_List__item__value._const_tab = ___DRBs_ToBeSetupMod_List__item__id_tab
    __DRBs_ToBeSetupMod_List__item__value._const_tab_at = ('..', 'id')
    __DRBs_ToBeSetupMod_List__item__value._const_tab_id = 'Value'
    _DRBs_ToBeSetupMod_List__item_._cont = ASN1Dict([
        ('id', __DRBs_ToBeSetupMod_List__item__id),
        ('criticality', __DRBs_ToBeSetupMod_List__item__criticality),
        ('value', __DRBs_ToBeSetupMod_List__item__value),
        ])
    _DRBs_ToBeSetupMod_List__item_._ext = None
    DRBs_ToBeSetupMod_List._cont = _DRBs_ToBeSetupMod_List__item_
    DRBs_ToBeSetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< BHChannels-ToBeSetupMod-List >-----#
    BHChannels_ToBeSetupMod_List = SEQ_OF(name='BHChannels-ToBeSetupMod-List', mode=MODE_TYPE)
    _BHChannels_ToBeSetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BHChannels_ToBeSetupMod_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BHChannels_ToBeSetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BHChannels_ToBeSetupMod_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-ToBeSetupMod-Item')))
    ___BHChannels_ToBeSetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 266), ('criticality', 'reject'), ('Value', ____BHChannels_ToBeSetupMod_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __BHChannels_ToBeSetupMod_List__item__id._const_tab = ___BHChannels_ToBeSetupMod_List__item__id_tab
    __BHChannels_ToBeSetupMod_List__item__id._const_tab_at = None
    __BHChannels_ToBeSetupMod_List__item__id._const_tab_id = 'id'
    __BHChannels_ToBeSetupMod_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __BHChannels_ToBeSetupMod_List__item__criticality._const_tab = ___BHChannels_ToBeSetupMod_List__item__id_tab
    __BHChannels_ToBeSetupMod_List__item__criticality._const_tab_at = ('..', 'id')
    __BHChannels_ToBeSetupMod_List__item__criticality._const_tab_id = 'criticality'
    __BHChannels_ToBeSetupMod_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __BHChannels_ToBeSetupMod_List__item__value._const_tab = ___BHChannels_ToBeSetupMod_List__item__id_tab
    __BHChannels_ToBeSetupMod_List__item__value._const_tab_at = ('..', 'id')
    __BHChannels_ToBeSetupMod_List__item__value._const_tab_id = 'Value'
    _BHChannels_ToBeSetupMod_List__item_._cont = ASN1Dict([
        ('id', __BHChannels_ToBeSetupMod_List__item__id),
        ('criticality', __BHChannels_ToBeSetupMod_List__item__criticality),
        ('value', __BHChannels_ToBeSetupMod_List__item__value),
        ])
    _BHChannels_ToBeSetupMod_List__item_._ext = None
    BHChannels_ToBeSetupMod_List._cont = _BHChannels_ToBeSetupMod_List__item_
    BHChannels_ToBeSetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< DRBs-ToBeModified-List >-----#
    DRBs_ToBeModified_List = SEQ_OF(name='DRBs-ToBeModified-List', mode=MODE_TYPE)
    _DRBs_ToBeModified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_ToBeModified_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___DRBs_ToBeModified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_ToBeModified_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-ToBeModified-Item')))
    ___DRBs_ToBeModified_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 30), ('criticality', 'reject'), ('Value', ____DRBs_ToBeModified_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_ToBeModified_List__item__id._const_tab = ___DRBs_ToBeModified_List__item__id_tab
    __DRBs_ToBeModified_List__item__id._const_tab_at = None
    __DRBs_ToBeModified_List__item__id._const_tab_id = 'id'
    __DRBs_ToBeModified_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __DRBs_ToBeModified_List__item__criticality._const_tab = ___DRBs_ToBeModified_List__item__id_tab
    __DRBs_ToBeModified_List__item__criticality._const_tab_at = ('..', 'id')
    __DRBs_ToBeModified_List__item__criticality._const_tab_id = 'criticality'
    __DRBs_ToBeModified_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __DRBs_ToBeModified_List__item__value._const_tab = ___DRBs_ToBeModified_List__item__id_tab
    __DRBs_ToBeModified_List__item__value._const_tab_at = ('..', 'id')
    __DRBs_ToBeModified_List__item__value._const_tab_id = 'Value'
    _DRBs_ToBeModified_List__item_._cont = ASN1Dict([
        ('id', __DRBs_ToBeModified_List__item__id),
        ('criticality', __DRBs_ToBeModified_List__item__criticality),
        ('value', __DRBs_ToBeModified_List__item__value),
        ])
    _DRBs_ToBeModified_List__item_._ext = None
    DRBs_ToBeModified_List._cont = _DRBs_ToBeModified_List__item_
    DRBs_ToBeModified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< BHChannels-ToBeModified-List >-----#
    BHChannels_ToBeModified_List = SEQ_OF(name='BHChannels-ToBeModified-List', mode=MODE_TYPE)
    _BHChannels_ToBeModified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BHChannels_ToBeModified_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BHChannels_ToBeModified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BHChannels_ToBeModified_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-ToBeModified-Item')))
    ___BHChannels_ToBeModified_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 262), ('criticality', 'reject'), ('Value', ____BHChannels_ToBeModified_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __BHChannels_ToBeModified_List__item__id._const_tab = ___BHChannels_ToBeModified_List__item__id_tab
    __BHChannels_ToBeModified_List__item__id._const_tab_at = None
    __BHChannels_ToBeModified_List__item__id._const_tab_id = 'id'
    __BHChannels_ToBeModified_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __BHChannels_ToBeModified_List__item__criticality._const_tab = ___BHChannels_ToBeModified_List__item__id_tab
    __BHChannels_ToBeModified_List__item__criticality._const_tab_at = ('..', 'id')
    __BHChannels_ToBeModified_List__item__criticality._const_tab_id = 'criticality'
    __BHChannels_ToBeModified_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __BHChannels_ToBeModified_List__item__value._const_tab = ___BHChannels_ToBeModified_List__item__id_tab
    __BHChannels_ToBeModified_List__item__value._const_tab_at = ('..', 'id')
    __BHChannels_ToBeModified_List__item__value._const_tab_id = 'Value'
    _BHChannels_ToBeModified_List__item_._cont = ASN1Dict([
        ('id', __BHChannels_ToBeModified_List__item__id),
        ('criticality', __BHChannels_ToBeModified_List__item__criticality),
        ('value', __BHChannels_ToBeModified_List__item__value),
        ])
    _BHChannels_ToBeModified_List__item_._ext = None
    BHChannels_ToBeModified_List._cont = _BHChannels_ToBeModified_List__item_
    BHChannels_ToBeModified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< SRBs-ToBeReleased-List >-----#
    SRBs_ToBeReleased_List = SEQ_OF(name='SRBs-ToBeReleased-List', mode=MODE_TYPE)
    _SRBs_ToBeReleased_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SRBs_ToBeReleased_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SRBs_ToBeReleased_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SRBs_ToBeReleased_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-ToBeReleased-Item')))
    ___SRBs_ToBeReleased_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 71), ('criticality', 'reject'), ('Value', ____SRBs_ToBeReleased_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SRBs_ToBeReleased_List__item__id._const_tab = ___SRBs_ToBeReleased_List__item__id_tab
    __SRBs_ToBeReleased_List__item__id._const_tab_at = None
    __SRBs_ToBeReleased_List__item__id._const_tab_id = 'id'
    __SRBs_ToBeReleased_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SRBs_ToBeReleased_List__item__criticality._const_tab = ___SRBs_ToBeReleased_List__item__id_tab
    __SRBs_ToBeReleased_List__item__criticality._const_tab_at = ('..', 'id')
    __SRBs_ToBeReleased_List__item__criticality._const_tab_id = 'criticality'
    __SRBs_ToBeReleased_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SRBs_ToBeReleased_List__item__value._const_tab = ___SRBs_ToBeReleased_List__item__id_tab
    __SRBs_ToBeReleased_List__item__value._const_tab_at = ('..', 'id')
    __SRBs_ToBeReleased_List__item__value._const_tab_id = 'Value'
    _SRBs_ToBeReleased_List__item_._cont = ASN1Dict([
        ('id', __SRBs_ToBeReleased_List__item__id),
        ('criticality', __SRBs_ToBeReleased_List__item__criticality),
        ('value', __SRBs_ToBeReleased_List__item__value),
        ])
    _SRBs_ToBeReleased_List__item_._ext = None
    SRBs_ToBeReleased_List._cont = _SRBs_ToBeReleased_List__item_
    SRBs_ToBeReleased_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< DRBs-ToBeReleased-List >-----#
    DRBs_ToBeReleased_List = SEQ_OF(name='DRBs-ToBeReleased-List', mode=MODE_TYPE)
    _DRBs_ToBeReleased_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_ToBeReleased_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___DRBs_ToBeReleased_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_ToBeReleased_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-ToBeReleased-Item')))
    ___DRBs_ToBeReleased_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 32), ('criticality', 'reject'), ('Value', ____DRBs_ToBeReleased_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_ToBeReleased_List__item__id._const_tab = ___DRBs_ToBeReleased_List__item__id_tab
    __DRBs_ToBeReleased_List__item__id._const_tab_at = None
    __DRBs_ToBeReleased_List__item__id._const_tab_id = 'id'
    __DRBs_ToBeReleased_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __DRBs_ToBeReleased_List__item__criticality._const_tab = ___DRBs_ToBeReleased_List__item__id_tab
    __DRBs_ToBeReleased_List__item__criticality._const_tab_at = ('..', 'id')
    __DRBs_ToBeReleased_List__item__criticality._const_tab_id = 'criticality'
    __DRBs_ToBeReleased_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __DRBs_ToBeReleased_List__item__value._const_tab = ___DRBs_ToBeReleased_List__item__id_tab
    __DRBs_ToBeReleased_List__item__value._const_tab_at = ('..', 'id')
    __DRBs_ToBeReleased_List__item__value._const_tab_id = 'Value'
    _DRBs_ToBeReleased_List__item_._cont = ASN1Dict([
        ('id', __DRBs_ToBeReleased_List__item__id),
        ('criticality', __DRBs_ToBeReleased_List__item__criticality),
        ('value', __DRBs_ToBeReleased_List__item__value),
        ])
    _DRBs_ToBeReleased_List__item_._ext = None
    DRBs_ToBeReleased_List._cont = _DRBs_ToBeReleased_List__item_
    DRBs_ToBeReleased_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< BHChannels-ToBeReleased-List >-----#
    BHChannels_ToBeReleased_List = SEQ_OF(name='BHChannels-ToBeReleased-List', mode=MODE_TYPE)
    _BHChannels_ToBeReleased_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BHChannels_ToBeReleased_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BHChannels_ToBeReleased_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BHChannels_ToBeReleased_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-ToBeReleased-Item')))
    ___BHChannels_ToBeReleased_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 264), ('criticality', 'reject'), ('Value', ____BHChannels_ToBeReleased_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __BHChannels_ToBeReleased_List__item__id._const_tab = ___BHChannels_ToBeReleased_List__item__id_tab
    __BHChannels_ToBeReleased_List__item__id._const_tab_at = None
    __BHChannels_ToBeReleased_List__item__id._const_tab_id = 'id'
    __BHChannels_ToBeReleased_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __BHChannels_ToBeReleased_List__item__criticality._const_tab = ___BHChannels_ToBeReleased_List__item__id_tab
    __BHChannels_ToBeReleased_List__item__criticality._const_tab_at = ('..', 'id')
    __BHChannels_ToBeReleased_List__item__criticality._const_tab_id = 'criticality'
    __BHChannels_ToBeReleased_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __BHChannels_ToBeReleased_List__item__value._const_tab = ___BHChannels_ToBeReleased_List__item__id_tab
    __BHChannels_ToBeReleased_List__item__value._const_tab_at = ('..', 'id')
    __BHChannels_ToBeReleased_List__item__value._const_tab_id = 'Value'
    _BHChannels_ToBeReleased_List__item_._cont = ASN1Dict([
        ('id', __BHChannels_ToBeReleased_List__item__id),
        ('criticality', __BHChannels_ToBeReleased_List__item__criticality),
        ('value', __BHChannels_ToBeReleased_List__item__value),
        ])
    _BHChannels_ToBeReleased_List__item_._ext = None
    BHChannels_ToBeReleased_List._cont = _BHChannels_ToBeReleased_List__item_
    BHChannels_ToBeReleased_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< UE-MulticastMRBs-ToBeSetup-atModify-List >-----#
    UE_MulticastMRBs_ToBeSetup_atModify_List = SEQ_OF(name='UE-MulticastMRBs-ToBeSetup-atModify-List', mode=MODE_TYPE)
    _UE_MulticastMRBs_ToBeSetup_atModify_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UE_MulticastMRBs_ToBeSetup_atModify_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___UE_MulticastMRBs_ToBeSetup_atModify_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____UE_MulticastMRBs_ToBeSetup_atModify_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UE-MulticastMRBs-ToBeSetup-atModify-Item')))
    ___UE_MulticastMRBs_ToBeSetup_atModify_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 686), ('criticality', 'reject'), ('Value', ____UE_MulticastMRBs_ToBeSetup_atModify_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __UE_MulticastMRBs_ToBeSetup_atModify_List__item__id._const_tab = ___UE_MulticastMRBs_ToBeSetup_atModify_List__item__id_tab
    __UE_MulticastMRBs_ToBeSetup_atModify_List__item__id._const_tab_at = None
    __UE_MulticastMRBs_ToBeSetup_atModify_List__item__id._const_tab_id = 'id'
    __UE_MulticastMRBs_ToBeSetup_atModify_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __UE_MulticastMRBs_ToBeSetup_atModify_List__item__criticality._const_tab = ___UE_MulticastMRBs_ToBeSetup_atModify_List__item__id_tab
    __UE_MulticastMRBs_ToBeSetup_atModify_List__item__criticality._const_tab_at = ('..', 'id')
    __UE_MulticastMRBs_ToBeSetup_atModify_List__item__criticality._const_tab_id = 'criticality'
    __UE_MulticastMRBs_ToBeSetup_atModify_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __UE_MulticastMRBs_ToBeSetup_atModify_List__item__value._const_tab = ___UE_MulticastMRBs_ToBeSetup_atModify_List__item__id_tab
    __UE_MulticastMRBs_ToBeSetup_atModify_List__item__value._const_tab_at = ('..', 'id')
    __UE_MulticastMRBs_ToBeSetup_atModify_List__item__value._const_tab_id = 'Value'
    _UE_MulticastMRBs_ToBeSetup_atModify_List__item_._cont = ASN1Dict([
        ('id', __UE_MulticastMRBs_ToBeSetup_atModify_List__item__id),
        ('criticality', __UE_MulticastMRBs_ToBeSetup_atModify_List__item__criticality),
        ('value', __UE_MulticastMRBs_ToBeSetup_atModify_List__item__value),
        ])
    _UE_MulticastMRBs_ToBeSetup_atModify_List__item_._ext = None
    UE_MulticastMRBs_ToBeSetup_atModify_List._cont = _UE_MulticastMRBs_ToBeSetup_atModify_List__item_
    UE_MulticastMRBs_ToBeSetup_atModify_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< UE-MulticastMRBs-ToBeReleased-List >-----#
    UE_MulticastMRBs_ToBeReleased_List = SEQ_OF(name='UE-MulticastMRBs-ToBeReleased-List', mode=MODE_TYPE)
    _UE_MulticastMRBs_ToBeReleased_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UE_MulticastMRBs_ToBeReleased_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___UE_MulticastMRBs_ToBeReleased_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____UE_MulticastMRBs_ToBeReleased_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UE-MulticastMRBs-ToBeReleased-Item')))
    ___UE_MulticastMRBs_ToBeReleased_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 629), ('criticality', 'reject'), ('Value', ____UE_MulticastMRBs_ToBeReleased_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __UE_MulticastMRBs_ToBeReleased_List__item__id._const_tab = ___UE_MulticastMRBs_ToBeReleased_List__item__id_tab
    __UE_MulticastMRBs_ToBeReleased_List__item__id._const_tab_at = None
    __UE_MulticastMRBs_ToBeReleased_List__item__id._const_tab_id = 'id'
    __UE_MulticastMRBs_ToBeReleased_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __UE_MulticastMRBs_ToBeReleased_List__item__criticality._const_tab = ___UE_MulticastMRBs_ToBeReleased_List__item__id_tab
    __UE_MulticastMRBs_ToBeReleased_List__item__criticality._const_tab_at = ('..', 'id')
    __UE_MulticastMRBs_ToBeReleased_List__item__criticality._const_tab_id = 'criticality'
    __UE_MulticastMRBs_ToBeReleased_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __UE_MulticastMRBs_ToBeReleased_List__item__value._const_tab = ___UE_MulticastMRBs_ToBeReleased_List__item__id_tab
    __UE_MulticastMRBs_ToBeReleased_List__item__value._const_tab_at = ('..', 'id')
    __UE_MulticastMRBs_ToBeReleased_List__item__value._const_tab_id = 'Value'
    _UE_MulticastMRBs_ToBeReleased_List__item_._cont = ASN1Dict([
        ('id', __UE_MulticastMRBs_ToBeReleased_List__item__id),
        ('criticality', __UE_MulticastMRBs_ToBeReleased_List__item__criticality),
        ('value', __UE_MulticastMRBs_ToBeReleased_List__item__value),
        ])
    _UE_MulticastMRBs_ToBeReleased_List__item_._ext = None
    UE_MulticastMRBs_ToBeReleased_List._cont = _UE_MulticastMRBs_ToBeReleased_List__item_
    UE_MulticastMRBs_ToBeReleased_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SCell-ToBeSetupMod-ItemIEs >-----#
    SCell_ToBeSetupMod_ItemIEs = CLASS(name='SCell-ToBeSetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SCell_ToBeSetupMod_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCell-ToBeSetupMod-Item')))
    SCell_ToBeSetupMod_ItemIEs._val = ASN1Set(rv=[dict([('id', 55), ('criticality', 'ignore'), ('Value', _SCell_ToBeSetupMod_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SCell-ToBeRemoved-ItemIEs >-----#
    SCell_ToBeRemoved_ItemIEs = CLASS(name='SCell-ToBeRemoved-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SCell_ToBeRemoved_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCell-ToBeRemoved-Item')))
    SCell_ToBeRemoved_ItemIEs._val = ASN1Set(rv=[dict([('id', 51), ('criticality', 'ignore'), ('Value', _SCell_ToBeRemoved_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SRBs-ToBeSetupMod-ItemIEs >-----#
    SRBs_ToBeSetupMod_ItemIEs = CLASS(name='SRBs-ToBeSetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SRBs_ToBeSetupMod_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-ToBeSetupMod-Item')))
    SRBs_ToBeSetupMod_ItemIEs._val = ASN1Set(rv=[dict([('id', 75), ('criticality', 'reject'), ('Value', _SRBs_ToBeSetupMod_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-ToBeSetupMod-ItemIEs >-----#
    DRBs_ToBeSetupMod_ItemIEs = CLASS(name='DRBs-ToBeSetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_ToBeSetupMod_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-ToBeSetupMod-Item')))
    DRBs_ToBeSetupMod_ItemIEs._val = ASN1Set(rv=[dict([('id', 36), ('criticality', 'reject'), ('Value', _DRBs_ToBeSetupMod_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-ToBeModified-ItemIEs >-----#
    DRBs_ToBeModified_ItemIEs = CLASS(name='DRBs-ToBeModified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_ToBeModified_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-ToBeModified-Item')))
    DRBs_ToBeModified_ItemIEs._val = ASN1Set(rv=[dict([('id', 30), ('criticality', 'reject'), ('Value', _DRBs_ToBeModified_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SRBs-ToBeReleased-ItemIEs >-----#
    SRBs_ToBeReleased_ItemIEs = CLASS(name='SRBs-ToBeReleased-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SRBs_ToBeReleased_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-ToBeReleased-Item')))
    SRBs_ToBeReleased_ItemIEs._val = ASN1Set(rv=[dict([('id', 71), ('criticality', 'reject'), ('Value', _SRBs_ToBeReleased_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-ToBeReleased-ItemIEs >-----#
    DRBs_ToBeReleased_ItemIEs = CLASS(name='DRBs-ToBeReleased-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_ToBeReleased_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-ToBeReleased-Item')))
    DRBs_ToBeReleased_ItemIEs._val = ASN1Set(rv=[dict([('id', 32), ('criticality', 'reject'), ('Value', _DRBs_ToBeReleased_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BHChannels-ToBeSetupMod-ItemIEs >-----#
    BHChannels_ToBeSetupMod_ItemIEs = CLASS(name='BHChannels-ToBeSetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BHChannels_ToBeSetupMod_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-ToBeSetupMod-Item')))
    BHChannels_ToBeSetupMod_ItemIEs._val = ASN1Set(rv=[dict([('id', 266), ('criticality', 'reject'), ('Value', _BHChannels_ToBeSetupMod_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BHChannels-ToBeModified-ItemIEs >-----#
    BHChannels_ToBeModified_ItemIEs = CLASS(name='BHChannels-ToBeModified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BHChannels_ToBeModified_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-ToBeModified-Item')))
    BHChannels_ToBeModified_ItemIEs._val = ASN1Set(rv=[dict([('id', 262), ('criticality', 'reject'), ('Value', _BHChannels_ToBeModified_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BHChannels-ToBeReleased-ItemIEs >-----#
    BHChannels_ToBeReleased_ItemIEs = CLASS(name='BHChannels-ToBeReleased-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BHChannels_ToBeReleased_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-ToBeReleased-Item')))
    BHChannels_ToBeReleased_ItemIEs._val = ASN1Set(rv=[dict([('id', 264), ('criticality', 'reject'), ('Value', _BHChannels_ToBeReleased_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-ToBeSetupMod-List >-----#
    SLDRBs_ToBeSetupMod_List = SEQ_OF(name='SLDRBs-ToBeSetupMod-List', mode=MODE_TYPE)
    _SLDRBs_ToBeSetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_ToBeSetupMod_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SLDRBs_ToBeSetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_ToBeSetupMod_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-ToBeSetupMod-Item')))
    ___SLDRBs_ToBeSetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 331), ('criticality', 'reject'), ('Value', ____SLDRBs_ToBeSetupMod_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_ToBeSetupMod_List__item__id._const_tab = ___SLDRBs_ToBeSetupMod_List__item__id_tab
    __SLDRBs_ToBeSetupMod_List__item__id._const_tab_at = None
    __SLDRBs_ToBeSetupMod_List__item__id._const_tab_id = 'id'
    __SLDRBs_ToBeSetupMod_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SLDRBs_ToBeSetupMod_List__item__criticality._const_tab = ___SLDRBs_ToBeSetupMod_List__item__id_tab
    __SLDRBs_ToBeSetupMod_List__item__criticality._const_tab_at = ('..', 'id')
    __SLDRBs_ToBeSetupMod_List__item__criticality._const_tab_id = 'criticality'
    __SLDRBs_ToBeSetupMod_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SLDRBs_ToBeSetupMod_List__item__value._const_tab = ___SLDRBs_ToBeSetupMod_List__item__id_tab
    __SLDRBs_ToBeSetupMod_List__item__value._const_tab_at = ('..', 'id')
    __SLDRBs_ToBeSetupMod_List__item__value._const_tab_id = 'Value'
    _SLDRBs_ToBeSetupMod_List__item_._cont = ASN1Dict([
        ('id', __SLDRBs_ToBeSetupMod_List__item__id),
        ('criticality', __SLDRBs_ToBeSetupMod_List__item__criticality),
        ('value', __SLDRBs_ToBeSetupMod_List__item__value),
        ])
    _SLDRBs_ToBeSetupMod_List__item_._ext = None
    SLDRBs_ToBeSetupMod_List._cont = _SLDRBs_ToBeSetupMod_List__item_
    SLDRBs_ToBeSetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< SLDRBs-ToBeModified-List >-----#
    SLDRBs_ToBeModified_List = SEQ_OF(name='SLDRBs-ToBeModified-List', mode=MODE_TYPE)
    _SLDRBs_ToBeModified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_ToBeModified_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SLDRBs_ToBeModified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_ToBeModified_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-ToBeModified-Item')))
    ___SLDRBs_ToBeModified_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 325), ('criticality', 'reject'), ('Value', ____SLDRBs_ToBeModified_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_ToBeModified_List__item__id._const_tab = ___SLDRBs_ToBeModified_List__item__id_tab
    __SLDRBs_ToBeModified_List__item__id._const_tab_at = None
    __SLDRBs_ToBeModified_List__item__id._const_tab_id = 'id'
    __SLDRBs_ToBeModified_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SLDRBs_ToBeModified_List__item__criticality._const_tab = ___SLDRBs_ToBeModified_List__item__id_tab
    __SLDRBs_ToBeModified_List__item__criticality._const_tab_at = ('..', 'id')
    __SLDRBs_ToBeModified_List__item__criticality._const_tab_id = 'criticality'
    __SLDRBs_ToBeModified_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SLDRBs_ToBeModified_List__item__value._const_tab = ___SLDRBs_ToBeModified_List__item__id_tab
    __SLDRBs_ToBeModified_List__item__value._const_tab_at = ('..', 'id')
    __SLDRBs_ToBeModified_List__item__value._const_tab_id = 'Value'
    _SLDRBs_ToBeModified_List__item_._cont = ASN1Dict([
        ('id', __SLDRBs_ToBeModified_List__item__id),
        ('criticality', __SLDRBs_ToBeModified_List__item__criticality),
        ('value', __SLDRBs_ToBeModified_List__item__value),
        ])
    _SLDRBs_ToBeModified_List__item_._ext = None
    SLDRBs_ToBeModified_List._cont = _SLDRBs_ToBeModified_List__item_
    SLDRBs_ToBeModified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< SLDRBs-ToBeReleased-List >-----#
    SLDRBs_ToBeReleased_List = SEQ_OF(name='SLDRBs-ToBeReleased-List', mode=MODE_TYPE)
    _SLDRBs_ToBeReleased_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_ToBeReleased_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SLDRBs_ToBeReleased_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_ToBeReleased_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-ToBeReleased-Item')))
    ___SLDRBs_ToBeReleased_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 327), ('criticality', 'reject'), ('Value', ____SLDRBs_ToBeReleased_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_ToBeReleased_List__item__id._const_tab = ___SLDRBs_ToBeReleased_List__item__id_tab
    __SLDRBs_ToBeReleased_List__item__id._const_tab_at = None
    __SLDRBs_ToBeReleased_List__item__id._const_tab_id = 'id'
    __SLDRBs_ToBeReleased_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SLDRBs_ToBeReleased_List__item__criticality._const_tab = ___SLDRBs_ToBeReleased_List__item__id_tab
    __SLDRBs_ToBeReleased_List__item__criticality._const_tab_at = ('..', 'id')
    __SLDRBs_ToBeReleased_List__item__criticality._const_tab_id = 'criticality'
    __SLDRBs_ToBeReleased_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SLDRBs_ToBeReleased_List__item__value._const_tab = ___SLDRBs_ToBeReleased_List__item__id_tab
    __SLDRBs_ToBeReleased_List__item__value._const_tab_at = ('..', 'id')
    __SLDRBs_ToBeReleased_List__item__value._const_tab_id = 'Value'
    _SLDRBs_ToBeReleased_List__item_._cont = ASN1Dict([
        ('id', __SLDRBs_ToBeReleased_List__item__id),
        ('criticality', __SLDRBs_ToBeReleased_List__item__criticality),
        ('value', __SLDRBs_ToBeReleased_List__item__value),
        ])
    _SLDRBs_ToBeReleased_List__item_._ext = None
    SLDRBs_ToBeReleased_List._cont = _SLDRBs_ToBeReleased_List__item_
    SLDRBs_ToBeReleased_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< SLDRBs-ToBeSetupMod-ItemIEs >-----#
    SLDRBs_ToBeSetupMod_ItemIEs = CLASS(name='SLDRBs-ToBeSetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_ToBeSetupMod_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-ToBeSetupMod-Item')))
    SLDRBs_ToBeSetupMod_ItemIEs._val = ASN1Set(rv=[dict([('id', 331), ('criticality', 'reject'), ('Value', _SLDRBs_ToBeSetupMod_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-ToBeModified-ItemIEs >-----#
    SLDRBs_ToBeModified_ItemIEs = CLASS(name='SLDRBs-ToBeModified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_ToBeModified_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-ToBeModified-Item')))
    SLDRBs_ToBeModified_ItemIEs._val = ASN1Set(rv=[dict([('id', 325), ('criticality', 'reject'), ('Value', _SLDRBs_ToBeModified_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-ToBeReleased-ItemIEs >-----#
    SLDRBs_ToBeReleased_ItemIEs = CLASS(name='SLDRBs-ToBeReleased-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_ToBeReleased_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-ToBeReleased-Item')))
    SLDRBs_ToBeReleased_ItemIEs._val = ASN1Set(rv=[dict([('id', 327), ('criticality', 'reject'), ('Value', _SLDRBs_ToBeReleased_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UE-MulticastMRBs-ToBeSetup-atModify-ItemIEs >-----#
    UE_MulticastMRBs_ToBeSetup_atModify_ItemIEs = CLASS(name='UE-MulticastMRBs-ToBeSetup-atModify-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UE_MulticastMRBs_ToBeSetup_atModify_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UE-MulticastMRBs-ToBeSetup-atModify-Item')))
    UE_MulticastMRBs_ToBeSetup_atModify_ItemIEs._val = ASN1Set(rv=[dict([('id', 686), ('criticality', 'reject'), ('Value', _UE_MulticastMRBs_ToBeSetup_atModify_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UE-MulticastMRBs-ToBeReleased-ItemIEs >-----#
    UE_MulticastMRBs_ToBeReleased_ItemIEs = CLASS(name='UE-MulticastMRBs-ToBeReleased-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UE_MulticastMRBs_ToBeReleased_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UE-MulticastMRBs-ToBeReleased-Item')))
    UE_MulticastMRBs_ToBeReleased_ItemIEs._val = ASN1Set(rv=[dict([('id', 629), ('criticality', 'reject'), ('Value', _UE_MulticastMRBs_ToBeReleased_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationResponse >-----#
    UEContextModificationResponse = SEQ(name='UEContextModificationResponse', mode=MODE_TYPE)
    _UEContextModificationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____UEContextModificationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferContainer')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DUtoCURRCInformation')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-SetupMod-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-Modified-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-FailedToBeSetupMod-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-FailedToBeSetupMod-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_8 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SCell-FailedtoSetupMod-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_9 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-FailedToBeModified-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'InactivityMonitoringResponse')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_12 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'C-RNTI')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_13 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Associated-SCell-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_14 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-SetupMod-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_15 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-Modified-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_16 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FullConfiguration')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_17 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-SetupMod-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_18 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-Modified-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_19 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-FailedToBeSetupMod-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_20 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-FailedToBeModified-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_21 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-SetupMod-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_22 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-Modified-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_23 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-FailedToBeSetupMod-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_24 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-FailedToBeModified-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_25 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_26 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCGActivationStatus')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_27 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelSetupList')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_28 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelFailedToBeSetupList')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_29 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelModifiedList')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_30 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelFailedToBeModifiedList')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_31 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelSetupList')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_32 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelFailedToBeSetupList')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_33 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelModifiedList')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_34 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelFailedToBeModifiedList')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_35 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SDTBearerConfigurationInfo')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_36 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UE-MulticastMRBs-Setup-List')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_37 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServingCellMO-encoded-in-CGC-List')))
    ____UEContextModificationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 49), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 39), ('criticality', 'reject'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 29), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 21), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 68), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 98), ('criticality', 'reject'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 95), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 198), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 204), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 206), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 94), ('criticality', 'reject'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')]), dict([('id', 275), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_17), ('presence', 'optional')]), dict([('id', 273), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_18), ('presence', 'optional')]), dict([('id', 271), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_19), ('presence', 'optional')]), dict([('id', 269), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_20), ('presence', 'optional')]), dict([('id', 333), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_21), ('presence', 'optional')]), dict([('id', 318), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_22), ('presence', 'optional')]), dict([('id', 334), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_23), ('presence', 'optional')]), dict([('id', 314), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_24), ('presence', 'optional')]), dict([('id', 376), ('criticality', 'reject'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_25), ('presence', 'optional')]), dict([('id', 548), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_26), ('presence', 'optional')]), dict([('id', 602), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_27), ('presence', 'optional')]), dict([('id', 603), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_28), ('presence', 'optional')]), dict([('id', 604), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_29), ('presence', 'optional')]), dict([('id', 605), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_30), ('presence', 'optional')]), dict([('id', 611), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_31), ('presence', 'optional')]), dict([('id', 612), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_32), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_33), ('presence', 'optional')]), dict([('id', 613), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_34), ('presence', 'optional')]), dict([('id', 676), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_35), ('presence', 'optional')]), dict([('id', 679), ('criticality', 'reject'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_36), ('presence', 'optional')]), dict([('id', 697), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_37), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationResponse_protocolIEs__item__id._const_tab = ____UEContextModificationResponse_protocolIEs__item__id_tab
    ___UEContextModificationResponse_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextModificationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextModificationResponse_protocolIEs__item__criticality._const_tab = ____UEContextModificationResponse_protocolIEs__item__id_tab
    ___UEContextModificationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextModificationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextModificationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___UEContextModificationResponse_protocolIEs__item__value._const_tab = ____UEContextModificationResponse_protocolIEs__item__id_tab
    ___UEContextModificationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextModificationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextModificationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextModificationResponse_protocolIEs__item__id),
        ('criticality', ___UEContextModificationResponse_protocolIEs__item__criticality),
        ('value', ___UEContextModificationResponse_protocolIEs__item__value),
        ])
    __UEContextModificationResponse_protocolIEs__item_._ext = None
    _UEContextModificationResponse_protocolIEs._cont = __UEContextModificationResponse_protocolIEs__item_
    _UEContextModificationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationResponse._cont = ASN1Dict([
        ('protocolIEs', _UEContextModificationResponse_protocolIEs),
        ])
    UEContextModificationResponse._ext = []
    
    #-----< UEContextModificationResponseIEs >-----#
    UEContextModificationResponseIEs = CLASS(name='UEContextModificationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEContextModificationResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEContextModificationResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextModificationResponseIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferContainer')))
    _UEContextModificationResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DUtoCURRCInformation')))
    _UEContextModificationResponseIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-SetupMod-List')))
    _UEContextModificationResponseIEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-Modified-List')))
    _UEContextModificationResponseIEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-FailedToBeSetupMod-List')))
    _UEContextModificationResponseIEs_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-FailedToBeSetupMod-List')))
    _UEContextModificationResponseIEs_val_Value_8 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SCell-FailedtoSetupMod-List')))
    _UEContextModificationResponseIEs_val_Value_9 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-FailedToBeModified-List')))
    _UEContextModificationResponseIEs_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'InactivityMonitoringResponse')))
    _UEContextModificationResponseIEs_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _UEContextModificationResponseIEs_val_Value_12 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'C-RNTI')))
    _UEContextModificationResponseIEs_val_Value_13 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Associated-SCell-List')))
    _UEContextModificationResponseIEs_val_Value_14 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-SetupMod-List')))
    _UEContextModificationResponseIEs_val_Value_15 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-Modified-List')))
    _UEContextModificationResponseIEs_val_Value_16 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'FullConfiguration')))
    _UEContextModificationResponseIEs_val_Value_17 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-SetupMod-List')))
    _UEContextModificationResponseIEs_val_Value_18 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-Modified-List')))
    _UEContextModificationResponseIEs_val_Value_19 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-FailedToBeSetupMod-List')))
    _UEContextModificationResponseIEs_val_Value_20 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-FailedToBeModified-List')))
    _UEContextModificationResponseIEs_val_Value_21 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-SetupMod-List')))
    _UEContextModificationResponseIEs_val_Value_22 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-Modified-List')))
    _UEContextModificationResponseIEs_val_Value_23 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-FailedToBeSetupMod-List')))
    _UEContextModificationResponseIEs_val_Value_24 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-FailedToBeModified-List')))
    _UEContextModificationResponseIEs_val_Value_25 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _UEContextModificationResponseIEs_val_Value_26 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCGActivationStatus')))
    _UEContextModificationResponseIEs_val_Value_27 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelSetupList')))
    _UEContextModificationResponseIEs_val_Value_28 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelFailedToBeSetupList')))
    _UEContextModificationResponseIEs_val_Value_29 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelModifiedList')))
    _UEContextModificationResponseIEs_val_Value_30 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelFailedToBeModifiedList')))
    _UEContextModificationResponseIEs_val_Value_31 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelSetupList')))
    _UEContextModificationResponseIEs_val_Value_32 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelFailedToBeSetupList')))
    _UEContextModificationResponseIEs_val_Value_33 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelModifiedList')))
    _UEContextModificationResponseIEs_val_Value_34 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelFailedToBeModifiedList')))
    _UEContextModificationResponseIEs_val_Value_35 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SDTBearerConfigurationInfo')))
    _UEContextModificationResponseIEs_val_Value_36 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UE-MulticastMRBs-Setup-List')))
    _UEContextModificationResponseIEs_val_Value_37 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ServingCellMO-encoded-in-CGC-List')))
    UEContextModificationResponseIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _UEContextModificationResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _UEContextModificationResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 49), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 39), ('criticality', 'reject'), ('Value', _UEContextModificationResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 29), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 21), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 68), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 98), ('criticality', 'reject'), ('Value', _UEContextModificationResponseIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 95), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_12), ('presence', 'optional')]), dict([('id', 198), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_13), ('presence', 'optional')]), dict([('id', 204), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_14), ('presence', 'optional')]), dict([('id', 206), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_15), ('presence', 'optional')]), dict([('id', 94), ('criticality', 'reject'), ('Value', _UEContextModificationResponseIEs_val_Value_16), ('presence', 'optional')]), dict([('id', 275), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_17), ('presence', 'optional')]), dict([('id', 273), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_18), ('presence', 'optional')]), dict([('id', 271), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_19), ('presence', 'optional')]), dict([('id', 269), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_20), ('presence', 'optional')]), dict([('id', 333), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_21), ('presence', 'optional')]), dict([('id', 318), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_22), ('presence', 'optional')]), dict([('id', 334), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_23), ('presence', 'optional')]), dict([('id', 314), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_24), ('presence', 'optional')]), dict([('id', 376), ('criticality', 'reject'), ('Value', _UEContextModificationResponseIEs_val_Value_25), ('presence', 'optional')]), dict([('id', 548), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_26), ('presence', 'optional')]), dict([('id', 602), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_27), ('presence', 'optional')]), dict([('id', 603), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_28), ('presence', 'optional')]), dict([('id', 604), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_29), ('presence', 'optional')]), dict([('id', 605), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_30), ('presence', 'optional')]), dict([('id', 611), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_31), ('presence', 'optional')]), dict([('id', 612), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_32), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_33), ('presence', 'optional')]), dict([('id', 613), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_34), ('presence', 'optional')]), dict([('id', 676), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_35), ('presence', 'optional')]), dict([('id', 679), ('criticality', 'reject'), ('Value', _UEContextModificationResponseIEs_val_Value_36), ('presence', 'optional')]), dict([('id', 697), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_37), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-SetupMod-List >-----#
    DRBs_SetupMod_List = SEQ_OF(name='DRBs-SetupMod-List', mode=MODE_TYPE)
    _DRBs_SetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_SetupMod_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___DRBs_SetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_SetupMod_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-SetupMod-Item')))
    ___DRBs_SetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 28), ('criticality', 'ignore'), ('Value', ____DRBs_SetupMod_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_SetupMod_List__item__id._const_tab = ___DRBs_SetupMod_List__item__id_tab
    __DRBs_SetupMod_List__item__id._const_tab_at = None
    __DRBs_SetupMod_List__item__id._const_tab_id = 'id'
    __DRBs_SetupMod_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __DRBs_SetupMod_List__item__criticality._const_tab = ___DRBs_SetupMod_List__item__id_tab
    __DRBs_SetupMod_List__item__criticality._const_tab_at = ('..', 'id')
    __DRBs_SetupMod_List__item__criticality._const_tab_id = 'criticality'
    __DRBs_SetupMod_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __DRBs_SetupMod_List__item__value._const_tab = ___DRBs_SetupMod_List__item__id_tab
    __DRBs_SetupMod_List__item__value._const_tab_at = ('..', 'id')
    __DRBs_SetupMod_List__item__value._const_tab_id = 'Value'
    _DRBs_SetupMod_List__item_._cont = ASN1Dict([
        ('id', __DRBs_SetupMod_List__item__id),
        ('criticality', __DRBs_SetupMod_List__item__criticality),
        ('value', __DRBs_SetupMod_List__item__value),
        ])
    _DRBs_SetupMod_List__item_._ext = None
    DRBs_SetupMod_List._cont = _DRBs_SetupMod_List__item_
    DRBs_SetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< DRBs-Modified-List >-----#
    DRBs_Modified_List = SEQ_OF(name='DRBs-Modified-List', mode=MODE_TYPE)
    _DRBs_Modified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_Modified_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___DRBs_Modified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_Modified_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-Modified-Item')))
    ___DRBs_Modified_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 20), ('criticality', 'ignore'), ('Value', ____DRBs_Modified_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_Modified_List__item__id._const_tab = ___DRBs_Modified_List__item__id_tab
    __DRBs_Modified_List__item__id._const_tab_at = None
    __DRBs_Modified_List__item__id._const_tab_id = 'id'
    __DRBs_Modified_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __DRBs_Modified_List__item__criticality._const_tab = ___DRBs_Modified_List__item__id_tab
    __DRBs_Modified_List__item__criticality._const_tab_at = ('..', 'id')
    __DRBs_Modified_List__item__criticality._const_tab_id = 'criticality'
    __DRBs_Modified_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __DRBs_Modified_List__item__value._const_tab = ___DRBs_Modified_List__item__id_tab
    __DRBs_Modified_List__item__value._const_tab_at = ('..', 'id')
    __DRBs_Modified_List__item__value._const_tab_id = 'Value'
    _DRBs_Modified_List__item_._cont = ASN1Dict([
        ('id', __DRBs_Modified_List__item__id),
        ('criticality', __DRBs_Modified_List__item__criticality),
        ('value', __DRBs_Modified_List__item__value),
        ])
    _DRBs_Modified_List__item_._ext = None
    DRBs_Modified_List._cont = _DRBs_Modified_List__item_
    DRBs_Modified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SRBs-SetupMod-List >-----#
    SRBs_SetupMod_List = SEQ_OF(name='SRBs-SetupMod-List', mode=MODE_TYPE)
    _SRBs_SetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SRBs_SetupMod_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SRBs_SetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SRBs_SetupMod_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-SetupMod-Item')))
    ___SRBs_SetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 205), ('criticality', 'ignore'), ('Value', ____SRBs_SetupMod_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SRBs_SetupMod_List__item__id._const_tab = ___SRBs_SetupMod_List__item__id_tab
    __SRBs_SetupMod_List__item__id._const_tab_at = None
    __SRBs_SetupMod_List__item__id._const_tab_id = 'id'
    __SRBs_SetupMod_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SRBs_SetupMod_List__item__criticality._const_tab = ___SRBs_SetupMod_List__item__id_tab
    __SRBs_SetupMod_List__item__criticality._const_tab_at = ('..', 'id')
    __SRBs_SetupMod_List__item__criticality._const_tab_id = 'criticality'
    __SRBs_SetupMod_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SRBs_SetupMod_List__item__value._const_tab = ___SRBs_SetupMod_List__item__id_tab
    __SRBs_SetupMod_List__item__value._const_tab_at = ('..', 'id')
    __SRBs_SetupMod_List__item__value._const_tab_id = 'Value'
    _SRBs_SetupMod_List__item_._cont = ASN1Dict([
        ('id', __SRBs_SetupMod_List__item__id),
        ('criticality', __SRBs_SetupMod_List__item__criticality),
        ('value', __SRBs_SetupMod_List__item__value),
        ])
    _SRBs_SetupMod_List__item_._ext = None
    SRBs_SetupMod_List._cont = _SRBs_SetupMod_List__item_
    SRBs_SetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< SRBs-Modified-List >-----#
    SRBs_Modified_List = SEQ_OF(name='SRBs-Modified-List', mode=MODE_TYPE)
    _SRBs_Modified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SRBs_Modified_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SRBs_Modified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SRBs_Modified_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-Modified-Item')))
    ___SRBs_Modified_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 207), ('criticality', 'ignore'), ('Value', ____SRBs_Modified_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SRBs_Modified_List__item__id._const_tab = ___SRBs_Modified_List__item__id_tab
    __SRBs_Modified_List__item__id._const_tab_at = None
    __SRBs_Modified_List__item__id._const_tab_id = 'id'
    __SRBs_Modified_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SRBs_Modified_List__item__criticality._const_tab = ___SRBs_Modified_List__item__id_tab
    __SRBs_Modified_List__item__criticality._const_tab_at = ('..', 'id')
    __SRBs_Modified_List__item__criticality._const_tab_id = 'criticality'
    __SRBs_Modified_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SRBs_Modified_List__item__value._const_tab = ___SRBs_Modified_List__item__id_tab
    __SRBs_Modified_List__item__value._const_tab_at = ('..', 'id')
    __SRBs_Modified_List__item__value._const_tab_id = 'Value'
    _SRBs_Modified_List__item_._cont = ASN1Dict([
        ('id', __SRBs_Modified_List__item__id),
        ('criticality', __SRBs_Modified_List__item__criticality),
        ('value', __SRBs_Modified_List__item__value),
        ])
    _SRBs_Modified_List__item_._ext = None
    SRBs_Modified_List._cont = _SRBs_Modified_List__item_
    SRBs_Modified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< DRBs-FailedToBeModified-List >-----#
    DRBs_FailedToBeModified_List = SEQ_OF(name='DRBs-FailedToBeModified-List', mode=MODE_TYPE)
    _DRBs_FailedToBeModified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_FailedToBeModified_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___DRBs_FailedToBeModified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_FailedToBeModified_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-FailedToBeModified-Item')))
    ___DRBs_FailedToBeModified_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 12), ('criticality', 'ignore'), ('Value', ____DRBs_FailedToBeModified_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_FailedToBeModified_List__item__id._const_tab = ___DRBs_FailedToBeModified_List__item__id_tab
    __DRBs_FailedToBeModified_List__item__id._const_tab_at = None
    __DRBs_FailedToBeModified_List__item__id._const_tab_id = 'id'
    __DRBs_FailedToBeModified_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __DRBs_FailedToBeModified_List__item__criticality._const_tab = ___DRBs_FailedToBeModified_List__item__id_tab
    __DRBs_FailedToBeModified_List__item__criticality._const_tab_at = ('..', 'id')
    __DRBs_FailedToBeModified_List__item__criticality._const_tab_id = 'criticality'
    __DRBs_FailedToBeModified_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __DRBs_FailedToBeModified_List__item__value._const_tab = ___DRBs_FailedToBeModified_List__item__id_tab
    __DRBs_FailedToBeModified_List__item__value._const_tab_at = ('..', 'id')
    __DRBs_FailedToBeModified_List__item__value._const_tab_id = 'Value'
    _DRBs_FailedToBeModified_List__item_._cont = ASN1Dict([
        ('id', __DRBs_FailedToBeModified_List__item__id),
        ('criticality', __DRBs_FailedToBeModified_List__item__criticality),
        ('value', __DRBs_FailedToBeModified_List__item__value),
        ])
    _DRBs_FailedToBeModified_List__item_._ext = None
    DRBs_FailedToBeModified_List._cont = _DRBs_FailedToBeModified_List__item_
    DRBs_FailedToBeModified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SRBs-FailedToBeSetupMod-List >-----#
    SRBs_FailedToBeSetupMod_List = SEQ_OF(name='SRBs-FailedToBeSetupMod-List', mode=MODE_TYPE)
    _SRBs_FailedToBeSetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SRBs_FailedToBeSetupMod_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SRBs_FailedToBeSetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SRBs_FailedToBeSetupMod_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-FailedToBeSetupMod-Item')))
    ___SRBs_FailedToBeSetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 67), ('criticality', 'ignore'), ('Value', ____SRBs_FailedToBeSetupMod_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SRBs_FailedToBeSetupMod_List__item__id._const_tab = ___SRBs_FailedToBeSetupMod_List__item__id_tab
    __SRBs_FailedToBeSetupMod_List__item__id._const_tab_at = None
    __SRBs_FailedToBeSetupMod_List__item__id._const_tab_id = 'id'
    __SRBs_FailedToBeSetupMod_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SRBs_FailedToBeSetupMod_List__item__criticality._const_tab = ___SRBs_FailedToBeSetupMod_List__item__id_tab
    __SRBs_FailedToBeSetupMod_List__item__criticality._const_tab_at = ('..', 'id')
    __SRBs_FailedToBeSetupMod_List__item__criticality._const_tab_id = 'criticality'
    __SRBs_FailedToBeSetupMod_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SRBs_FailedToBeSetupMod_List__item__value._const_tab = ___SRBs_FailedToBeSetupMod_List__item__id_tab
    __SRBs_FailedToBeSetupMod_List__item__value._const_tab_at = ('..', 'id')
    __SRBs_FailedToBeSetupMod_List__item__value._const_tab_id = 'Value'
    _SRBs_FailedToBeSetupMod_List__item_._cont = ASN1Dict([
        ('id', __SRBs_FailedToBeSetupMod_List__item__id),
        ('criticality', __SRBs_FailedToBeSetupMod_List__item__criticality),
        ('value', __SRBs_FailedToBeSetupMod_List__item__value),
        ])
    _SRBs_FailedToBeSetupMod_List__item_._ext = None
    SRBs_FailedToBeSetupMod_List._cont = _SRBs_FailedToBeSetupMod_List__item_
    SRBs_FailedToBeSetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< DRBs-FailedToBeSetupMod-List >-----#
    DRBs_FailedToBeSetupMod_List = SEQ_OF(name='DRBs-FailedToBeSetupMod-List', mode=MODE_TYPE)
    _DRBs_FailedToBeSetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_FailedToBeSetupMod_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___DRBs_FailedToBeSetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_FailedToBeSetupMod_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-FailedToBeSetupMod-Item')))
    ___DRBs_FailedToBeSetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 16), ('criticality', 'ignore'), ('Value', ____DRBs_FailedToBeSetupMod_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_FailedToBeSetupMod_List__item__id._const_tab = ___DRBs_FailedToBeSetupMod_List__item__id_tab
    __DRBs_FailedToBeSetupMod_List__item__id._const_tab_at = None
    __DRBs_FailedToBeSetupMod_List__item__id._const_tab_id = 'id'
    __DRBs_FailedToBeSetupMod_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __DRBs_FailedToBeSetupMod_List__item__criticality._const_tab = ___DRBs_FailedToBeSetupMod_List__item__id_tab
    __DRBs_FailedToBeSetupMod_List__item__criticality._const_tab_at = ('..', 'id')
    __DRBs_FailedToBeSetupMod_List__item__criticality._const_tab_id = 'criticality'
    __DRBs_FailedToBeSetupMod_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __DRBs_FailedToBeSetupMod_List__item__value._const_tab = ___DRBs_FailedToBeSetupMod_List__item__id_tab
    __DRBs_FailedToBeSetupMod_List__item__value._const_tab_at = ('..', 'id')
    __DRBs_FailedToBeSetupMod_List__item__value._const_tab_id = 'Value'
    _DRBs_FailedToBeSetupMod_List__item_._cont = ASN1Dict([
        ('id', __DRBs_FailedToBeSetupMod_List__item__id),
        ('criticality', __DRBs_FailedToBeSetupMod_List__item__criticality),
        ('value', __DRBs_FailedToBeSetupMod_List__item__value),
        ])
    _DRBs_FailedToBeSetupMod_List__item_._ext = None
    DRBs_FailedToBeSetupMod_List._cont = _DRBs_FailedToBeSetupMod_List__item_
    DRBs_FailedToBeSetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SCell-FailedtoSetupMod-List >-----#
    SCell_FailedtoSetupMod_List = SEQ_OF(name='SCell-FailedtoSetupMod-List', mode=MODE_TYPE)
    _SCell_FailedtoSetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SCell_FailedtoSetupMod_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SCell_FailedtoSetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SCell_FailedtoSetupMod_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCell-FailedtoSetupMod-Item')))
    ___SCell_FailedtoSetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 86), ('criticality', 'ignore'), ('Value', ____SCell_FailedtoSetupMod_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SCell_FailedtoSetupMod_List__item__id._const_tab = ___SCell_FailedtoSetupMod_List__item__id_tab
    __SCell_FailedtoSetupMod_List__item__id._const_tab_at = None
    __SCell_FailedtoSetupMod_List__item__id._const_tab_id = 'id'
    __SCell_FailedtoSetupMod_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SCell_FailedtoSetupMod_List__item__criticality._const_tab = ___SCell_FailedtoSetupMod_List__item__id_tab
    __SCell_FailedtoSetupMod_List__item__criticality._const_tab_at = ('..', 'id')
    __SCell_FailedtoSetupMod_List__item__criticality._const_tab_id = 'criticality'
    __SCell_FailedtoSetupMod_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SCell_FailedtoSetupMod_List__item__value._const_tab = ___SCell_FailedtoSetupMod_List__item__id_tab
    __SCell_FailedtoSetupMod_List__item__value._const_tab_at = ('..', 'id')
    __SCell_FailedtoSetupMod_List__item__value._const_tab_id = 'Value'
    _SCell_FailedtoSetupMod_List__item_._cont = ASN1Dict([
        ('id', __SCell_FailedtoSetupMod_List__item__id),
        ('criticality', __SCell_FailedtoSetupMod_List__item__criticality),
        ('value', __SCell_FailedtoSetupMod_List__item__value),
        ])
    _SCell_FailedtoSetupMod_List__item_._ext = None
    SCell_FailedtoSetupMod_List._cont = _SCell_FailedtoSetupMod_List__item_
    SCell_FailedtoSetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< BHChannels-SetupMod-List >-----#
    BHChannels_SetupMod_List = SEQ_OF(name='BHChannels-SetupMod-List', mode=MODE_TYPE)
    _BHChannels_SetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BHChannels_SetupMod_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BHChannels_SetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BHChannels_SetupMod_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-SetupMod-Item')))
    ___BHChannels_SetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 274), ('criticality', 'ignore'), ('Value', ____BHChannels_SetupMod_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __BHChannels_SetupMod_List__item__id._const_tab = ___BHChannels_SetupMod_List__item__id_tab
    __BHChannels_SetupMod_List__item__id._const_tab_at = None
    __BHChannels_SetupMod_List__item__id._const_tab_id = 'id'
    __BHChannels_SetupMod_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __BHChannels_SetupMod_List__item__criticality._const_tab = ___BHChannels_SetupMod_List__item__id_tab
    __BHChannels_SetupMod_List__item__criticality._const_tab_at = ('..', 'id')
    __BHChannels_SetupMod_List__item__criticality._const_tab_id = 'criticality'
    __BHChannels_SetupMod_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __BHChannels_SetupMod_List__item__value._const_tab = ___BHChannels_SetupMod_List__item__id_tab
    __BHChannels_SetupMod_List__item__value._const_tab_at = ('..', 'id')
    __BHChannels_SetupMod_List__item__value._const_tab_id = 'Value'
    _BHChannels_SetupMod_List__item_._cont = ASN1Dict([
        ('id', __BHChannels_SetupMod_List__item__id),
        ('criticality', __BHChannels_SetupMod_List__item__criticality),
        ('value', __BHChannels_SetupMod_List__item__value),
        ])
    _BHChannels_SetupMod_List__item_._ext = None
    BHChannels_SetupMod_List._cont = _BHChannels_SetupMod_List__item_
    BHChannels_SetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< BHChannels-Modified-List >-----#
    BHChannels_Modified_List = SEQ_OF(name='BHChannels-Modified-List', mode=MODE_TYPE)
    _BHChannels_Modified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BHChannels_Modified_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BHChannels_Modified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BHChannels_Modified_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-Modified-Item')))
    ___BHChannels_Modified_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 272), ('criticality', 'ignore'), ('Value', ____BHChannels_Modified_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __BHChannels_Modified_List__item__id._const_tab = ___BHChannels_Modified_List__item__id_tab
    __BHChannels_Modified_List__item__id._const_tab_at = None
    __BHChannels_Modified_List__item__id._const_tab_id = 'id'
    __BHChannels_Modified_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __BHChannels_Modified_List__item__criticality._const_tab = ___BHChannels_Modified_List__item__id_tab
    __BHChannels_Modified_List__item__criticality._const_tab_at = ('..', 'id')
    __BHChannels_Modified_List__item__criticality._const_tab_id = 'criticality'
    __BHChannels_Modified_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __BHChannels_Modified_List__item__value._const_tab = ___BHChannels_Modified_List__item__id_tab
    __BHChannels_Modified_List__item__value._const_tab_at = ('..', 'id')
    __BHChannels_Modified_List__item__value._const_tab_id = 'Value'
    _BHChannels_Modified_List__item_._cont = ASN1Dict([
        ('id', __BHChannels_Modified_List__item__id),
        ('criticality', __BHChannels_Modified_List__item__criticality),
        ('value', __BHChannels_Modified_List__item__value),
        ])
    _BHChannels_Modified_List__item_._ext = None
    BHChannels_Modified_List._cont = _BHChannels_Modified_List__item_
    BHChannels_Modified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< BHChannels-FailedToBeModified-List >-----#
    BHChannels_FailedToBeModified_List = SEQ_OF(name='BHChannels-FailedToBeModified-List', mode=MODE_TYPE)
    _BHChannels_FailedToBeModified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BHChannels_FailedToBeModified_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BHChannels_FailedToBeModified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BHChannels_FailedToBeModified_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-FailedToBeModified-Item')))
    ___BHChannels_FailedToBeModified_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 268), ('criticality', 'ignore'), ('Value', ____BHChannels_FailedToBeModified_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __BHChannels_FailedToBeModified_List__item__id._const_tab = ___BHChannels_FailedToBeModified_List__item__id_tab
    __BHChannels_FailedToBeModified_List__item__id._const_tab_at = None
    __BHChannels_FailedToBeModified_List__item__id._const_tab_id = 'id'
    __BHChannels_FailedToBeModified_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __BHChannels_FailedToBeModified_List__item__criticality._const_tab = ___BHChannels_FailedToBeModified_List__item__id_tab
    __BHChannels_FailedToBeModified_List__item__criticality._const_tab_at = ('..', 'id')
    __BHChannels_FailedToBeModified_List__item__criticality._const_tab_id = 'criticality'
    __BHChannels_FailedToBeModified_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __BHChannels_FailedToBeModified_List__item__value._const_tab = ___BHChannels_FailedToBeModified_List__item__id_tab
    __BHChannels_FailedToBeModified_List__item__value._const_tab_at = ('..', 'id')
    __BHChannels_FailedToBeModified_List__item__value._const_tab_id = 'Value'
    _BHChannels_FailedToBeModified_List__item_._cont = ASN1Dict([
        ('id', __BHChannels_FailedToBeModified_List__item__id),
        ('criticality', __BHChannels_FailedToBeModified_List__item__criticality),
        ('value', __BHChannels_FailedToBeModified_List__item__value),
        ])
    _BHChannels_FailedToBeModified_List__item_._ext = None
    BHChannels_FailedToBeModified_List._cont = _BHChannels_FailedToBeModified_List__item_
    BHChannels_FailedToBeModified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< BHChannels-FailedToBeSetupMod-List >-----#
    BHChannels_FailedToBeSetupMod_List = SEQ_OF(name='BHChannels-FailedToBeSetupMod-List', mode=MODE_TYPE)
    _BHChannels_FailedToBeSetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BHChannels_FailedToBeSetupMod_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BHChannels_FailedToBeSetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BHChannels_FailedToBeSetupMod_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-FailedToBeSetupMod-Item')))
    ___BHChannels_FailedToBeSetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 270), ('criticality', 'ignore'), ('Value', ____BHChannels_FailedToBeSetupMod_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __BHChannels_FailedToBeSetupMod_List__item__id._const_tab = ___BHChannels_FailedToBeSetupMod_List__item__id_tab
    __BHChannels_FailedToBeSetupMod_List__item__id._const_tab_at = None
    __BHChannels_FailedToBeSetupMod_List__item__id._const_tab_id = 'id'
    __BHChannels_FailedToBeSetupMod_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __BHChannels_FailedToBeSetupMod_List__item__criticality._const_tab = ___BHChannels_FailedToBeSetupMod_List__item__id_tab
    __BHChannels_FailedToBeSetupMod_List__item__criticality._const_tab_at = ('..', 'id')
    __BHChannels_FailedToBeSetupMod_List__item__criticality._const_tab_id = 'criticality'
    __BHChannels_FailedToBeSetupMod_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __BHChannels_FailedToBeSetupMod_List__item__value._const_tab = ___BHChannels_FailedToBeSetupMod_List__item__id_tab
    __BHChannels_FailedToBeSetupMod_List__item__value._const_tab_at = ('..', 'id')
    __BHChannels_FailedToBeSetupMod_List__item__value._const_tab_id = 'Value'
    _BHChannels_FailedToBeSetupMod_List__item_._cont = ASN1Dict([
        ('id', __BHChannels_FailedToBeSetupMod_List__item__id),
        ('criticality', __BHChannels_FailedToBeSetupMod_List__item__criticality),
        ('value', __BHChannels_FailedToBeSetupMod_List__item__value),
        ])
    _BHChannels_FailedToBeSetupMod_List__item_._ext = None
    BHChannels_FailedToBeSetupMod_List._cont = _BHChannels_FailedToBeSetupMod_List__item_
    BHChannels_FailedToBeSetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< Associated-SCell-List >-----#
    Associated_SCell_List = SEQ_OF(name='Associated-SCell-List', mode=MODE_TYPE)
    _Associated_SCell_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Associated_SCell_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___Associated_SCell_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Associated_SCell_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Associated-SCell-Item')))
    ___Associated_SCell_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 200), ('criticality', 'ignore'), ('Value', ____Associated_SCell_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Associated_SCell_List__item__id._const_tab = ___Associated_SCell_List__item__id_tab
    __Associated_SCell_List__item__id._const_tab_at = None
    __Associated_SCell_List__item__id._const_tab_id = 'id'
    __Associated_SCell_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __Associated_SCell_List__item__criticality._const_tab = ___Associated_SCell_List__item__id_tab
    __Associated_SCell_List__item__criticality._const_tab_at = ('..', 'id')
    __Associated_SCell_List__item__criticality._const_tab_id = 'criticality'
    __Associated_SCell_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __Associated_SCell_List__item__value._const_tab = ___Associated_SCell_List__item__id_tab
    __Associated_SCell_List__item__value._const_tab_at = ('..', 'id')
    __Associated_SCell_List__item__value._const_tab_id = 'Value'
    _Associated_SCell_List__item_._cont = ASN1Dict([
        ('id', __Associated_SCell_List__item__id),
        ('criticality', __Associated_SCell_List__item__criticality),
        ('value', __Associated_SCell_List__item__value),
        ])
    _Associated_SCell_List__item_._ext = None
    Associated_SCell_List._cont = _Associated_SCell_List__item_
    Associated_SCell_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRBs-SetupMod-ItemIEs >-----#
    DRBs_SetupMod_ItemIEs = CLASS(name='DRBs-SetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_SetupMod_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-SetupMod-Item')))
    DRBs_SetupMod_ItemIEs._val = ASN1Set(rv=[dict([('id', 28), ('criticality', 'ignore'), ('Value', _DRBs_SetupMod_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-Modified-ItemIEs >-----#
    DRBs_Modified_ItemIEs = CLASS(name='DRBs-Modified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_Modified_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-Modified-Item')))
    DRBs_Modified_ItemIEs._val = ASN1Set(rv=[dict([('id', 20), ('criticality', 'ignore'), ('Value', _DRBs_Modified_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SRBs-SetupMod-ItemIEs >-----#
    SRBs_SetupMod_ItemIEs = CLASS(name='SRBs-SetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SRBs_SetupMod_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-SetupMod-Item')))
    SRBs_SetupMod_ItemIEs._val = ASN1Set(rv=[dict([('id', 205), ('criticality', 'ignore'), ('Value', _SRBs_SetupMod_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SRBs-Modified-ItemIEs >-----#
    SRBs_Modified_ItemIEs = CLASS(name='SRBs-Modified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SRBs_Modified_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-Modified-Item')))
    SRBs_Modified_ItemIEs._val = ASN1Set(rv=[dict([('id', 207), ('criticality', 'ignore'), ('Value', _SRBs_Modified_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SRBs-FailedToBeSetupMod-ItemIEs >-----#
    SRBs_FailedToBeSetupMod_ItemIEs = CLASS(name='SRBs-FailedToBeSetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SRBs_FailedToBeSetupMod_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-FailedToBeSetupMod-Item')))
    SRBs_FailedToBeSetupMod_ItemIEs._val = ASN1Set(rv=[dict([('id', 67), ('criticality', 'ignore'), ('Value', _SRBs_FailedToBeSetupMod_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-FailedToBeSetupMod-ItemIEs >-----#
    DRBs_FailedToBeSetupMod_ItemIEs = CLASS(name='DRBs-FailedToBeSetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_FailedToBeSetupMod_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-FailedToBeSetupMod-Item')))
    DRBs_FailedToBeSetupMod_ItemIEs._val = ASN1Set(rv=[dict([('id', 16), ('criticality', 'ignore'), ('Value', _DRBs_FailedToBeSetupMod_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-FailedToBeModified-ItemIEs >-----#
    DRBs_FailedToBeModified_ItemIEs = CLASS(name='DRBs-FailedToBeModified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_FailedToBeModified_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-FailedToBeModified-Item')))
    DRBs_FailedToBeModified_ItemIEs._val = ASN1Set(rv=[dict([('id', 12), ('criticality', 'ignore'), ('Value', _DRBs_FailedToBeModified_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SCell-FailedtoSetupMod-ItemIEs >-----#
    SCell_FailedtoSetupMod_ItemIEs = CLASS(name='SCell-FailedtoSetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SCell_FailedtoSetupMod_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SCell-FailedtoSetupMod-Item')))
    SCell_FailedtoSetupMod_ItemIEs._val = ASN1Set(rv=[dict([('id', 86), ('criticality', 'ignore'), ('Value', _SCell_FailedtoSetupMod_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Associated-SCell-ItemIEs >-----#
    Associated_SCell_ItemIEs = CLASS(name='Associated-SCell-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Associated_SCell_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Associated-SCell-Item')))
    Associated_SCell_ItemIEs._val = ASN1Set(rv=[dict([('id', 200), ('criticality', 'ignore'), ('Value', _Associated_SCell_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BHChannels-SetupMod-ItemIEs >-----#
    BHChannels_SetupMod_ItemIEs = CLASS(name='BHChannels-SetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BHChannels_SetupMod_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-SetupMod-Item')))
    BHChannels_SetupMod_ItemIEs._val = ASN1Set(rv=[dict([('id', 274), ('criticality', 'ignore'), ('Value', _BHChannels_SetupMod_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BHChannels-Modified-ItemIEs >-----#
    BHChannels_Modified_ItemIEs = CLASS(name='BHChannels-Modified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BHChannels_Modified_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-Modified-Item')))
    BHChannels_Modified_ItemIEs._val = ASN1Set(rv=[dict([('id', 272), ('criticality', 'ignore'), ('Value', _BHChannels_Modified_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BHChannels-FailedToBeSetupMod-ItemIEs >-----#
    BHChannels_FailedToBeSetupMod_ItemIEs = CLASS(name='BHChannels-FailedToBeSetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BHChannels_FailedToBeSetupMod_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-FailedToBeSetupMod-Item')))
    BHChannels_FailedToBeSetupMod_ItemIEs._val = ASN1Set(rv=[dict([('id', 270), ('criticality', 'ignore'), ('Value', _BHChannels_FailedToBeSetupMod_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BHChannels-FailedToBeModified-ItemIEs >-----#
    BHChannels_FailedToBeModified_ItemIEs = CLASS(name='BHChannels-FailedToBeModified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BHChannels_FailedToBeModified_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-FailedToBeModified-Item')))
    BHChannels_FailedToBeModified_ItemIEs._val = ASN1Set(rv=[dict([('id', 268), ('criticality', 'ignore'), ('Value', _BHChannels_FailedToBeModified_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-SetupMod-List >-----#
    SLDRBs_SetupMod_List = SEQ_OF(name='SLDRBs-SetupMod-List', mode=MODE_TYPE)
    _SLDRBs_SetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_SetupMod_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SLDRBs_SetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_SetupMod_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-SetupMod-Item')))
    ___SLDRBs_SetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 335), ('criticality', 'ignore'), ('Value', ____SLDRBs_SetupMod_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_SetupMod_List__item__id._const_tab = ___SLDRBs_SetupMod_List__item__id_tab
    __SLDRBs_SetupMod_List__item__id._const_tab_at = None
    __SLDRBs_SetupMod_List__item__id._const_tab_id = 'id'
    __SLDRBs_SetupMod_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SLDRBs_SetupMod_List__item__criticality._const_tab = ___SLDRBs_SetupMod_List__item__id_tab
    __SLDRBs_SetupMod_List__item__criticality._const_tab_at = ('..', 'id')
    __SLDRBs_SetupMod_List__item__criticality._const_tab_id = 'criticality'
    __SLDRBs_SetupMod_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SLDRBs_SetupMod_List__item__value._const_tab = ___SLDRBs_SetupMod_List__item__id_tab
    __SLDRBs_SetupMod_List__item__value._const_tab_at = ('..', 'id')
    __SLDRBs_SetupMod_List__item__value._const_tab_id = 'Value'
    _SLDRBs_SetupMod_List__item_._cont = ASN1Dict([
        ('id', __SLDRBs_SetupMod_List__item__id),
        ('criticality', __SLDRBs_SetupMod_List__item__criticality),
        ('value', __SLDRBs_SetupMod_List__item__value),
        ])
    _SLDRBs_SetupMod_List__item_._ext = None
    SLDRBs_SetupMod_List._cont = _SLDRBs_SetupMod_List__item_
    SLDRBs_SetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< SLDRBs-Modified-List >-----#
    SLDRBs_Modified_List = SEQ_OF(name='SLDRBs-Modified-List', mode=MODE_TYPE)
    _SLDRBs_Modified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_Modified_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SLDRBs_Modified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_Modified_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-Modified-Item')))
    ___SLDRBs_Modified_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 317), ('criticality', 'ignore'), ('Value', ____SLDRBs_Modified_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_Modified_List__item__id._const_tab = ___SLDRBs_Modified_List__item__id_tab
    __SLDRBs_Modified_List__item__id._const_tab_at = None
    __SLDRBs_Modified_List__item__id._const_tab_id = 'id'
    __SLDRBs_Modified_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SLDRBs_Modified_List__item__criticality._const_tab = ___SLDRBs_Modified_List__item__id_tab
    __SLDRBs_Modified_List__item__criticality._const_tab_at = ('..', 'id')
    __SLDRBs_Modified_List__item__criticality._const_tab_id = 'criticality'
    __SLDRBs_Modified_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SLDRBs_Modified_List__item__value._const_tab = ___SLDRBs_Modified_List__item__id_tab
    __SLDRBs_Modified_List__item__value._const_tab_at = ('..', 'id')
    __SLDRBs_Modified_List__item__value._const_tab_id = 'Value'
    _SLDRBs_Modified_List__item_._cont = ASN1Dict([
        ('id', __SLDRBs_Modified_List__item__id),
        ('criticality', __SLDRBs_Modified_List__item__criticality),
        ('value', __SLDRBs_Modified_List__item__value),
        ])
    _SLDRBs_Modified_List__item_._ext = None
    SLDRBs_Modified_List._cont = _SLDRBs_Modified_List__item_
    SLDRBs_Modified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< SLDRBs-FailedToBeModified-List >-----#
    SLDRBs_FailedToBeModified_List = SEQ_OF(name='SLDRBs-FailedToBeModified-List', mode=MODE_TYPE)
    _SLDRBs_FailedToBeModified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_FailedToBeModified_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SLDRBs_FailedToBeModified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_FailedToBeModified_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-FailedToBeModified-Item')))
    ___SLDRBs_FailedToBeModified_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 313), ('criticality', 'ignore'), ('Value', ____SLDRBs_FailedToBeModified_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_FailedToBeModified_List__item__id._const_tab = ___SLDRBs_FailedToBeModified_List__item__id_tab
    __SLDRBs_FailedToBeModified_List__item__id._const_tab_at = None
    __SLDRBs_FailedToBeModified_List__item__id._const_tab_id = 'id'
    __SLDRBs_FailedToBeModified_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SLDRBs_FailedToBeModified_List__item__criticality._const_tab = ___SLDRBs_FailedToBeModified_List__item__id_tab
    __SLDRBs_FailedToBeModified_List__item__criticality._const_tab_at = ('..', 'id')
    __SLDRBs_FailedToBeModified_List__item__criticality._const_tab_id = 'criticality'
    __SLDRBs_FailedToBeModified_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SLDRBs_FailedToBeModified_List__item__value._const_tab = ___SLDRBs_FailedToBeModified_List__item__id_tab
    __SLDRBs_FailedToBeModified_List__item__value._const_tab_at = ('..', 'id')
    __SLDRBs_FailedToBeModified_List__item__value._const_tab_id = 'Value'
    _SLDRBs_FailedToBeModified_List__item_._cont = ASN1Dict([
        ('id', __SLDRBs_FailedToBeModified_List__item__id),
        ('criticality', __SLDRBs_FailedToBeModified_List__item__criticality),
        ('value', __SLDRBs_FailedToBeModified_List__item__value),
        ])
    _SLDRBs_FailedToBeModified_List__item_._ext = None
    SLDRBs_FailedToBeModified_List._cont = _SLDRBs_FailedToBeModified_List__item_
    SLDRBs_FailedToBeModified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< SLDRBs-FailedToBeSetupMod-List >-----#
    SLDRBs_FailedToBeSetupMod_List = SEQ_OF(name='SLDRBs-FailedToBeSetupMod-List', mode=MODE_TYPE)
    _SLDRBs_FailedToBeSetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_FailedToBeSetupMod_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SLDRBs_FailedToBeSetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_FailedToBeSetupMod_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-FailedToBeSetupMod-Item')))
    ___SLDRBs_FailedToBeSetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 336), ('criticality', 'ignore'), ('Value', ____SLDRBs_FailedToBeSetupMod_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_FailedToBeSetupMod_List__item__id._const_tab = ___SLDRBs_FailedToBeSetupMod_List__item__id_tab
    __SLDRBs_FailedToBeSetupMod_List__item__id._const_tab_at = None
    __SLDRBs_FailedToBeSetupMod_List__item__id._const_tab_id = 'id'
    __SLDRBs_FailedToBeSetupMod_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SLDRBs_FailedToBeSetupMod_List__item__criticality._const_tab = ___SLDRBs_FailedToBeSetupMod_List__item__id_tab
    __SLDRBs_FailedToBeSetupMod_List__item__criticality._const_tab_at = ('..', 'id')
    __SLDRBs_FailedToBeSetupMod_List__item__criticality._const_tab_id = 'criticality'
    __SLDRBs_FailedToBeSetupMod_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SLDRBs_FailedToBeSetupMod_List__item__value._const_tab = ___SLDRBs_FailedToBeSetupMod_List__item__id_tab
    __SLDRBs_FailedToBeSetupMod_List__item__value._const_tab_at = ('..', 'id')
    __SLDRBs_FailedToBeSetupMod_List__item__value._const_tab_id = 'Value'
    _SLDRBs_FailedToBeSetupMod_List__item_._cont = ASN1Dict([
        ('id', __SLDRBs_FailedToBeSetupMod_List__item__id),
        ('criticality', __SLDRBs_FailedToBeSetupMod_List__item__criticality),
        ('value', __SLDRBs_FailedToBeSetupMod_List__item__value),
        ])
    _SLDRBs_FailedToBeSetupMod_List__item_._ext = None
    SLDRBs_FailedToBeSetupMod_List._cont = _SLDRBs_FailedToBeSetupMod_List__item_
    SLDRBs_FailedToBeSetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< SLDRBs-SetupMod-ItemIEs >-----#
    SLDRBs_SetupMod_ItemIEs = CLASS(name='SLDRBs-SetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_SetupMod_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-SetupMod-Item')))
    SLDRBs_SetupMod_ItemIEs._val = ASN1Set(rv=[dict([('id', 335), ('criticality', 'ignore'), ('Value', _SLDRBs_SetupMod_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-Modified-ItemIEs >-----#
    SLDRBs_Modified_ItemIEs = CLASS(name='SLDRBs-Modified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_Modified_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-Modified-Item')))
    SLDRBs_Modified_ItemIEs._val = ASN1Set(rv=[dict([('id', 317), ('criticality', 'ignore'), ('Value', _SLDRBs_Modified_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-FailedToBeSetupMod-ItemIEs >-----#
    SLDRBs_FailedToBeSetupMod_ItemIEs = CLASS(name='SLDRBs-FailedToBeSetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_FailedToBeSetupMod_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-FailedToBeSetupMod-Item')))
    SLDRBs_FailedToBeSetupMod_ItemIEs._val = ASN1Set(rv=[dict([('id', 336), ('criticality', 'ignore'), ('Value', _SLDRBs_FailedToBeSetupMod_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-FailedToBeModified-ItemIEs >-----#
    SLDRBs_FailedToBeModified_ItemIEs = CLASS(name='SLDRBs-FailedToBeModified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_FailedToBeModified_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-FailedToBeModified-Item')))
    SLDRBs_FailedToBeModified_ItemIEs._val = ASN1Set(rv=[dict([('id', 313), ('criticality', 'ignore'), ('Value', _SLDRBs_FailedToBeModified_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UE-MulticastMRBs-Setup-List >-----#
    UE_MulticastMRBs_Setup_List = SEQ_OF(name='UE-MulticastMRBs-Setup-List', mode=MODE_TYPE)
    _UE_MulticastMRBs_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UE_MulticastMRBs_Setup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___UE_MulticastMRBs_Setup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____UE_MulticastMRBs_Setup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UE-MulticastMRBs-Setup-Item')))
    ___UE_MulticastMRBs_Setup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 680), ('criticality', 'reject'), ('Value', ____UE_MulticastMRBs_Setup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __UE_MulticastMRBs_Setup_List__item__id._const_tab = ___UE_MulticastMRBs_Setup_List__item__id_tab
    __UE_MulticastMRBs_Setup_List__item__id._const_tab_at = None
    __UE_MulticastMRBs_Setup_List__item__id._const_tab_id = 'id'
    __UE_MulticastMRBs_Setup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __UE_MulticastMRBs_Setup_List__item__criticality._const_tab = ___UE_MulticastMRBs_Setup_List__item__id_tab
    __UE_MulticastMRBs_Setup_List__item__criticality._const_tab_at = ('..', 'id')
    __UE_MulticastMRBs_Setup_List__item__criticality._const_tab_id = 'criticality'
    __UE_MulticastMRBs_Setup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __UE_MulticastMRBs_Setup_List__item__value._const_tab = ___UE_MulticastMRBs_Setup_List__item__id_tab
    __UE_MulticastMRBs_Setup_List__item__value._const_tab_at = ('..', 'id')
    __UE_MulticastMRBs_Setup_List__item__value._const_tab_id = 'Value'
    _UE_MulticastMRBs_Setup_List__item_._cont = ASN1Dict([
        ('id', __UE_MulticastMRBs_Setup_List__item__id),
        ('criticality', __UE_MulticastMRBs_Setup_List__item__criticality),
        ('value', __UE_MulticastMRBs_Setup_List__item__value),
        ])
    _UE_MulticastMRBs_Setup_List__item_._ext = None
    UE_MulticastMRBs_Setup_List._cont = _UE_MulticastMRBs_Setup_List__item_
    UE_MulticastMRBs_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< UE-MulticastMRBs-Setup-ItemIEs >-----#
    UE_MulticastMRBs_Setup_ItemIEs = CLASS(name='UE-MulticastMRBs-Setup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UE_MulticastMRBs_Setup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UE-MulticastMRBs-Setup-Item')))
    UE_MulticastMRBs_Setup_ItemIEs._val = ASN1Set(rv=[dict([('id', 680), ('criticality', 'reject'), ('Value', _UE_MulticastMRBs_Setup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationFailure >-----#
    UEContextModificationFailure = SEQ(name='UEContextModificationFailure', mode=MODE_TYPE)
    _UEContextModificationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____UEContextModificationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    ____UEContextModificationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 376), ('criticality', 'reject'), ('Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationFailure_protocolIEs__item__id._const_tab = ____UEContextModificationFailure_protocolIEs__item__id_tab
    ___UEContextModificationFailure_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextModificationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextModificationFailure_protocolIEs__item__criticality._const_tab = ____UEContextModificationFailure_protocolIEs__item__id_tab
    ___UEContextModificationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextModificationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextModificationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___UEContextModificationFailure_protocolIEs__item__value._const_tab = ____UEContextModificationFailure_protocolIEs__item__id_tab
    ___UEContextModificationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextModificationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextModificationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextModificationFailure_protocolIEs__item__id),
        ('criticality', ___UEContextModificationFailure_protocolIEs__item__criticality),
        ('value', ___UEContextModificationFailure_protocolIEs__item__value),
        ])
    __UEContextModificationFailure_protocolIEs__item_._ext = None
    _UEContextModificationFailure_protocolIEs._cont = __UEContextModificationFailure_protocolIEs__item_
    _UEContextModificationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationFailure._cont = ASN1Dict([
        ('protocolIEs', _UEContextModificationFailure_protocolIEs),
        ])
    UEContextModificationFailure._ext = []
    
    #-----< UEContextModificationFailureIEs >-----#
    UEContextModificationFailureIEs = CLASS(name='UEContextModificationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEContextModificationFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEContextModificationFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextModificationFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _UEContextModificationFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _UEContextModificationFailureIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    UEContextModificationFailureIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _UEContextModificationFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _UEContextModificationFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _UEContextModificationFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _UEContextModificationFailureIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 376), ('criticality', 'reject'), ('Value', _UEContextModificationFailureIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationRequired >-----#
    UEContextModificationRequired = SEQ(name='UEContextModificationRequired', mode=MODE_TYPE)
    _UEContextModificationRequired_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationRequired_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____UEContextModificationRequired_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferContainer')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DUtoCURRCInformation')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-Required-ToBeModified-List')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-Required-ToBeReleased-List')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-Required-ToBeReleased-List')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_7 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_8 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-Required-ToBeReleased-List')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_9 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-Required-ToBeModified-List')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_10 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-Required-ToBeReleased-List')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_11 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TargetCellList')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_12 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelRequiredToBeModifiedList')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_13 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelRequiredToBeReleasedList')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_14 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelRequiredToBeModifiedList')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_15 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelRequiredToBeReleasedList')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_16 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UE-MulticastMRBs-RequiredToBeModified-List')))
    _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_17 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UE-MulticastMRBs-RequiredToBeReleased-List')))
    ____UEContextModificationRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 49), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 39), ('criticality', 'reject'), ('Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 23), ('criticality', 'reject'), ('Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 70), ('criticality', 'reject'), ('Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 25), ('criticality', 'reject'), ('Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_7), ('presence', 'mandatory')]), dict([('id', 277), ('criticality', 'reject'), ('Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 320), ('criticality', 'reject'), ('Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 322), ('criticality', 'reject'), ('Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 375), ('criticality', 'reject'), ('Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 606), ('criticality', 'reject'), ('Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 607), ('criticality', 'reject'), ('Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 614), ('criticality', 'reject'), ('Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 615), ('criticality', 'reject'), ('Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 655), ('criticality', 'reject'), ('Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')]), dict([('id', 657), ('criticality', 'reject'), ('Value', _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_17), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationRequired_protocolIEs__item__id._const_tab = ____UEContextModificationRequired_protocolIEs__item__id_tab
    ___UEContextModificationRequired_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationRequired_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextModificationRequired_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextModificationRequired_protocolIEs__item__criticality._const_tab = ____UEContextModificationRequired_protocolIEs__item__id_tab
    ___UEContextModificationRequired_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextModificationRequired_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextModificationRequired_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___UEContextModificationRequired_protocolIEs__item__value._const_tab = ____UEContextModificationRequired_protocolIEs__item__id_tab
    ___UEContextModificationRequired_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextModificationRequired_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextModificationRequired_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextModificationRequired_protocolIEs__item__id),
        ('criticality', ___UEContextModificationRequired_protocolIEs__item__criticality),
        ('value', ___UEContextModificationRequired_protocolIEs__item__value),
        ])
    __UEContextModificationRequired_protocolIEs__item_._ext = None
    _UEContextModificationRequired_protocolIEs._cont = __UEContextModificationRequired_protocolIEs__item_
    _UEContextModificationRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationRequired._cont = ASN1Dict([
        ('protocolIEs', _UEContextModificationRequired_protocolIEs),
        ])
    UEContextModificationRequired._ext = []
    
    #-----< UEContextModificationRequiredIEs >-----#
    UEContextModificationRequiredIEs = CLASS(name='UEContextModificationRequiredIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEContextModificationRequiredIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEContextModificationRequiredIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextModificationRequiredIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferContainer')))
    _UEContextModificationRequiredIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DUtoCURRCInformation')))
    _UEContextModificationRequiredIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-Required-ToBeModified-List')))
    _UEContextModificationRequiredIEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRBs-Required-ToBeReleased-List')))
    _UEContextModificationRequiredIEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-Required-ToBeReleased-List')))
    _UEContextModificationRequiredIEs_val_Value_7 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _UEContextModificationRequiredIEs_val_Value_8 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BHChannels-Required-ToBeReleased-List')))
    _UEContextModificationRequiredIEs_val_Value_9 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-Required-ToBeModified-List')))
    _UEContextModificationRequiredIEs_val_Value_10 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-Required-ToBeReleased-List')))
    _UEContextModificationRequiredIEs_val_Value_11 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TargetCellList')))
    _UEContextModificationRequiredIEs_val_Value_12 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelRequiredToBeModifiedList')))
    _UEContextModificationRequiredIEs_val_Value_13 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelRequiredToBeReleasedList')))
    _UEContextModificationRequiredIEs_val_Value_14 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelRequiredToBeModifiedList')))
    _UEContextModificationRequiredIEs_val_Value_15 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelRequiredToBeReleasedList')))
    _UEContextModificationRequiredIEs_val_Value_16 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UE-MulticastMRBs-RequiredToBeModified-List')))
    _UEContextModificationRequiredIEs_val_Value_17 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UE-MulticastMRBs-RequiredToBeReleased-List')))
    UEContextModificationRequiredIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _UEContextModificationRequiredIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _UEContextModificationRequiredIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 49), ('criticality', 'ignore'), ('Value', _UEContextModificationRequiredIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 39), ('criticality', 'reject'), ('Value', _UEContextModificationRequiredIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 23), ('criticality', 'reject'), ('Value', _UEContextModificationRequiredIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 70), ('criticality', 'reject'), ('Value', _UEContextModificationRequiredIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 25), ('criticality', 'reject'), ('Value', _UEContextModificationRequiredIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _UEContextModificationRequiredIEs_val_Value_7), ('presence', 'mandatory')]), dict([('id', 277), ('criticality', 'reject'), ('Value', _UEContextModificationRequiredIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 320), ('criticality', 'reject'), ('Value', _UEContextModificationRequiredIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 322), ('criticality', 'reject'), ('Value', _UEContextModificationRequiredIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 375), ('criticality', 'reject'), ('Value', _UEContextModificationRequiredIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 606), ('criticality', 'reject'), ('Value', _UEContextModificationRequiredIEs_val_Value_12), ('presence', 'optional')]), dict([('id', 607), ('criticality', 'reject'), ('Value', _UEContextModificationRequiredIEs_val_Value_13), ('presence', 'optional')]), dict([('id', 614), ('criticality', 'reject'), ('Value', _UEContextModificationRequiredIEs_val_Value_14), ('presence', 'optional')]), dict([('id', 615), ('criticality', 'reject'), ('Value', _UEContextModificationRequiredIEs_val_Value_15), ('presence', 'optional')]), dict([('id', 655), ('criticality', 'reject'), ('Value', _UEContextModificationRequiredIEs_val_Value_16), ('presence', 'optional')]), dict([('id', 657), ('criticality', 'reject'), ('Value', _UEContextModificationRequiredIEs_val_Value_17), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-Required-ToBeModified-List >-----#
    DRBs_Required_ToBeModified_List = SEQ_OF(name='DRBs-Required-ToBeModified-List', mode=MODE_TYPE)
    _DRBs_Required_ToBeModified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_Required_ToBeModified_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___DRBs_Required_ToBeModified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_Required_ToBeModified_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-Required-ToBeModified-Item')))
    ___DRBs_Required_ToBeModified_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 22), ('criticality', 'reject'), ('Value', ____DRBs_Required_ToBeModified_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_Required_ToBeModified_List__item__id._const_tab = ___DRBs_Required_ToBeModified_List__item__id_tab
    __DRBs_Required_ToBeModified_List__item__id._const_tab_at = None
    __DRBs_Required_ToBeModified_List__item__id._const_tab_id = 'id'
    __DRBs_Required_ToBeModified_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __DRBs_Required_ToBeModified_List__item__criticality._const_tab = ___DRBs_Required_ToBeModified_List__item__id_tab
    __DRBs_Required_ToBeModified_List__item__criticality._const_tab_at = ('..', 'id')
    __DRBs_Required_ToBeModified_List__item__criticality._const_tab_id = 'criticality'
    __DRBs_Required_ToBeModified_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __DRBs_Required_ToBeModified_List__item__value._const_tab = ___DRBs_Required_ToBeModified_List__item__id_tab
    __DRBs_Required_ToBeModified_List__item__value._const_tab_at = ('..', 'id')
    __DRBs_Required_ToBeModified_List__item__value._const_tab_id = 'Value'
    _DRBs_Required_ToBeModified_List__item_._cont = ASN1Dict([
        ('id', __DRBs_Required_ToBeModified_List__item__id),
        ('criticality', __DRBs_Required_ToBeModified_List__item__criticality),
        ('value', __DRBs_Required_ToBeModified_List__item__value),
        ])
    _DRBs_Required_ToBeModified_List__item_._ext = None
    DRBs_Required_ToBeModified_List._cont = _DRBs_Required_ToBeModified_List__item_
    DRBs_Required_ToBeModified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< DRBs-Required-ToBeReleased-List >-----#
    DRBs_Required_ToBeReleased_List = SEQ_OF(name='DRBs-Required-ToBeReleased-List', mode=MODE_TYPE)
    _DRBs_Required_ToBeReleased_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_Required_ToBeReleased_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___DRBs_Required_ToBeReleased_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_Required_ToBeReleased_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-Required-ToBeReleased-Item')))
    ___DRBs_Required_ToBeReleased_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 24), ('criticality', 'reject'), ('Value', ____DRBs_Required_ToBeReleased_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_Required_ToBeReleased_List__item__id._const_tab = ___DRBs_Required_ToBeReleased_List__item__id_tab
    __DRBs_Required_ToBeReleased_List__item__id._const_tab_at = None
    __DRBs_Required_ToBeReleased_List__item__id._const_tab_id = 'id'
    __DRBs_Required_ToBeReleased_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __DRBs_Required_ToBeReleased_List__item__criticality._const_tab = ___DRBs_Required_ToBeReleased_List__item__id_tab
    __DRBs_Required_ToBeReleased_List__item__criticality._const_tab_at = ('..', 'id')
    __DRBs_Required_ToBeReleased_List__item__criticality._const_tab_id = 'criticality'
    __DRBs_Required_ToBeReleased_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __DRBs_Required_ToBeReleased_List__item__value._const_tab = ___DRBs_Required_ToBeReleased_List__item__id_tab
    __DRBs_Required_ToBeReleased_List__item__value._const_tab_at = ('..', 'id')
    __DRBs_Required_ToBeReleased_List__item__value._const_tab_id = 'Value'
    _DRBs_Required_ToBeReleased_List__item_._cont = ASN1Dict([
        ('id', __DRBs_Required_ToBeReleased_List__item__id),
        ('criticality', __DRBs_Required_ToBeReleased_List__item__criticality),
        ('value', __DRBs_Required_ToBeReleased_List__item__value),
        ])
    _DRBs_Required_ToBeReleased_List__item_._ext = None
    DRBs_Required_ToBeReleased_List._cont = _DRBs_Required_ToBeReleased_List__item_
    DRBs_Required_ToBeReleased_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SRBs-Required-ToBeReleased-List >-----#
    SRBs_Required_ToBeReleased_List = SEQ_OF(name='SRBs-Required-ToBeReleased-List', mode=MODE_TYPE)
    _SRBs_Required_ToBeReleased_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SRBs_Required_ToBeReleased_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SRBs_Required_ToBeReleased_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SRBs_Required_ToBeReleased_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-Required-ToBeReleased-Item')))
    ___SRBs_Required_ToBeReleased_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 69), ('criticality', 'reject'), ('Value', ____SRBs_Required_ToBeReleased_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SRBs_Required_ToBeReleased_List__item__id._const_tab = ___SRBs_Required_ToBeReleased_List__item__id_tab
    __SRBs_Required_ToBeReleased_List__item__id._const_tab_at = None
    __SRBs_Required_ToBeReleased_List__item__id._const_tab_id = 'id'
    __SRBs_Required_ToBeReleased_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SRBs_Required_ToBeReleased_List__item__criticality._const_tab = ___SRBs_Required_ToBeReleased_List__item__id_tab
    __SRBs_Required_ToBeReleased_List__item__criticality._const_tab_at = ('..', 'id')
    __SRBs_Required_ToBeReleased_List__item__criticality._const_tab_id = 'criticality'
    __SRBs_Required_ToBeReleased_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SRBs_Required_ToBeReleased_List__item__value._const_tab = ___SRBs_Required_ToBeReleased_List__item__id_tab
    __SRBs_Required_ToBeReleased_List__item__value._const_tab_at = ('..', 'id')
    __SRBs_Required_ToBeReleased_List__item__value._const_tab_id = 'Value'
    _SRBs_Required_ToBeReleased_List__item_._cont = ASN1Dict([
        ('id', __SRBs_Required_ToBeReleased_List__item__id),
        ('criticality', __SRBs_Required_ToBeReleased_List__item__criticality),
        ('value', __SRBs_Required_ToBeReleased_List__item__value),
        ])
    _SRBs_Required_ToBeReleased_List__item_._ext = None
    SRBs_Required_ToBeReleased_List._cont = _SRBs_Required_ToBeReleased_List__item_
    SRBs_Required_ToBeReleased_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< BHChannels-Required-ToBeReleased-List >-----#
    BHChannels_Required_ToBeReleased_List = SEQ_OF(name='BHChannels-Required-ToBeReleased-List', mode=MODE_TYPE)
    _BHChannels_Required_ToBeReleased_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BHChannels_Required_ToBeReleased_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BHChannels_Required_ToBeReleased_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BHChannels_Required_ToBeReleased_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-Required-ToBeReleased-Item')))
    ___BHChannels_Required_ToBeReleased_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 276), ('criticality', 'reject'), ('Value', ____BHChannels_Required_ToBeReleased_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __BHChannels_Required_ToBeReleased_List__item__id._const_tab = ___BHChannels_Required_ToBeReleased_List__item__id_tab
    __BHChannels_Required_ToBeReleased_List__item__id._const_tab_at = None
    __BHChannels_Required_ToBeReleased_List__item__id._const_tab_id = 'id'
    __BHChannels_Required_ToBeReleased_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __BHChannels_Required_ToBeReleased_List__item__criticality._const_tab = ___BHChannels_Required_ToBeReleased_List__item__id_tab
    __BHChannels_Required_ToBeReleased_List__item__criticality._const_tab_at = ('..', 'id')
    __BHChannels_Required_ToBeReleased_List__item__criticality._const_tab_id = 'criticality'
    __BHChannels_Required_ToBeReleased_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __BHChannels_Required_ToBeReleased_List__item__value._const_tab = ___BHChannels_Required_ToBeReleased_List__item__id_tab
    __BHChannels_Required_ToBeReleased_List__item__value._const_tab_at = ('..', 'id')
    __BHChannels_Required_ToBeReleased_List__item__value._const_tab_id = 'Value'
    _BHChannels_Required_ToBeReleased_List__item_._cont = ASN1Dict([
        ('id', __BHChannels_Required_ToBeReleased_List__item__id),
        ('criticality', __BHChannels_Required_ToBeReleased_List__item__criticality),
        ('value', __BHChannels_Required_ToBeReleased_List__item__value),
        ])
    _BHChannels_Required_ToBeReleased_List__item_._ext = None
    BHChannels_Required_ToBeReleased_List._cont = _BHChannels_Required_ToBeReleased_List__item_
    BHChannels_Required_ToBeReleased_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< DRBs-Required-ToBeModified-ItemIEs >-----#
    DRBs_Required_ToBeModified_ItemIEs = CLASS(name='DRBs-Required-ToBeModified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_Required_ToBeModified_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-Required-ToBeModified-Item')))
    DRBs_Required_ToBeModified_ItemIEs._val = ASN1Set(rv=[dict([('id', 22), ('criticality', 'reject'), ('Value', _DRBs_Required_ToBeModified_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-Required-ToBeReleased-ItemIEs >-----#
    DRBs_Required_ToBeReleased_ItemIEs = CLASS(name='DRBs-Required-ToBeReleased-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_Required_ToBeReleased_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-Required-ToBeReleased-Item')))
    DRBs_Required_ToBeReleased_ItemIEs._val = ASN1Set(rv=[dict([('id', 24), ('criticality', 'reject'), ('Value', _DRBs_Required_ToBeReleased_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SRBs-Required-ToBeReleased-ItemIEs >-----#
    SRBs_Required_ToBeReleased_ItemIEs = CLASS(name='SRBs-Required-ToBeReleased-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SRBs_Required_ToBeReleased_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBs-Required-ToBeReleased-Item')))
    SRBs_Required_ToBeReleased_ItemIEs._val = ASN1Set(rv=[dict([('id', 69), ('criticality', 'reject'), ('Value', _SRBs_Required_ToBeReleased_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BHChannels-Required-ToBeReleased-ItemIEs >-----#
    BHChannels_Required_ToBeReleased_ItemIEs = CLASS(name='BHChannels-Required-ToBeReleased-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BHChannels_Required_ToBeReleased_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BHChannels-Required-ToBeReleased-Item')))
    BHChannels_Required_ToBeReleased_ItemIEs._val = ASN1Set(rv=[dict([('id', 276), ('criticality', 'reject'), ('Value', _BHChannels_Required_ToBeReleased_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-Required-ToBeModified-List >-----#
    SLDRBs_Required_ToBeModified_List = SEQ_OF(name='SLDRBs-Required-ToBeModified-List', mode=MODE_TYPE)
    _SLDRBs_Required_ToBeModified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_Required_ToBeModified_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SLDRBs_Required_ToBeModified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_Required_ToBeModified_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-Required-ToBeModified-Item')))
    ___SLDRBs_Required_ToBeModified_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 319), ('criticality', 'reject'), ('Value', ____SLDRBs_Required_ToBeModified_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_Required_ToBeModified_List__item__id._const_tab = ___SLDRBs_Required_ToBeModified_List__item__id_tab
    __SLDRBs_Required_ToBeModified_List__item__id._const_tab_at = None
    __SLDRBs_Required_ToBeModified_List__item__id._const_tab_id = 'id'
    __SLDRBs_Required_ToBeModified_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SLDRBs_Required_ToBeModified_List__item__criticality._const_tab = ___SLDRBs_Required_ToBeModified_List__item__id_tab
    __SLDRBs_Required_ToBeModified_List__item__criticality._const_tab_at = ('..', 'id')
    __SLDRBs_Required_ToBeModified_List__item__criticality._const_tab_id = 'criticality'
    __SLDRBs_Required_ToBeModified_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SLDRBs_Required_ToBeModified_List__item__value._const_tab = ___SLDRBs_Required_ToBeModified_List__item__id_tab
    __SLDRBs_Required_ToBeModified_List__item__value._const_tab_at = ('..', 'id')
    __SLDRBs_Required_ToBeModified_List__item__value._const_tab_id = 'Value'
    _SLDRBs_Required_ToBeModified_List__item_._cont = ASN1Dict([
        ('id', __SLDRBs_Required_ToBeModified_List__item__id),
        ('criticality', __SLDRBs_Required_ToBeModified_List__item__criticality),
        ('value', __SLDRBs_Required_ToBeModified_List__item__value),
        ])
    _SLDRBs_Required_ToBeModified_List__item_._ext = None
    SLDRBs_Required_ToBeModified_List._cont = _SLDRBs_Required_ToBeModified_List__item_
    SLDRBs_Required_ToBeModified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< SLDRBs-Required-ToBeReleased-List >-----#
    SLDRBs_Required_ToBeReleased_List = SEQ_OF(name='SLDRBs-Required-ToBeReleased-List', mode=MODE_TYPE)
    _SLDRBs_Required_ToBeReleased_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_Required_ToBeReleased_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SLDRBs_Required_ToBeReleased_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_Required_ToBeReleased_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-Required-ToBeReleased-Item')))
    ___SLDRBs_Required_ToBeReleased_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 321), ('criticality', 'reject'), ('Value', ____SLDRBs_Required_ToBeReleased_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_Required_ToBeReleased_List__item__id._const_tab = ___SLDRBs_Required_ToBeReleased_List__item__id_tab
    __SLDRBs_Required_ToBeReleased_List__item__id._const_tab_at = None
    __SLDRBs_Required_ToBeReleased_List__item__id._const_tab_id = 'id'
    __SLDRBs_Required_ToBeReleased_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SLDRBs_Required_ToBeReleased_List__item__criticality._const_tab = ___SLDRBs_Required_ToBeReleased_List__item__id_tab
    __SLDRBs_Required_ToBeReleased_List__item__criticality._const_tab_at = ('..', 'id')
    __SLDRBs_Required_ToBeReleased_List__item__criticality._const_tab_id = 'criticality'
    __SLDRBs_Required_ToBeReleased_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SLDRBs_Required_ToBeReleased_List__item__value._const_tab = ___SLDRBs_Required_ToBeReleased_List__item__id_tab
    __SLDRBs_Required_ToBeReleased_List__item__value._const_tab_at = ('..', 'id')
    __SLDRBs_Required_ToBeReleased_List__item__value._const_tab_id = 'Value'
    _SLDRBs_Required_ToBeReleased_List__item_._cont = ASN1Dict([
        ('id', __SLDRBs_Required_ToBeReleased_List__item__id),
        ('criticality', __SLDRBs_Required_ToBeReleased_List__item__criticality),
        ('value', __SLDRBs_Required_ToBeReleased_List__item__value),
        ])
    _SLDRBs_Required_ToBeReleased_List__item_._ext = None
    SLDRBs_Required_ToBeReleased_List._cont = _SLDRBs_Required_ToBeReleased_List__item_
    SLDRBs_Required_ToBeReleased_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< SLDRBs-Required-ToBeModified-ItemIEs >-----#
    SLDRBs_Required_ToBeModified_ItemIEs = CLASS(name='SLDRBs-Required-ToBeModified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_Required_ToBeModified_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-Required-ToBeModified-Item')))
    SLDRBs_Required_ToBeModified_ItemIEs._val = ASN1Set(rv=[dict([('id', 319), ('criticality', 'reject'), ('Value', _SLDRBs_Required_ToBeModified_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-Required-ToBeReleased-ItemIEs >-----#
    SLDRBs_Required_ToBeReleased_ItemIEs = CLASS(name='SLDRBs-Required-ToBeReleased-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_Required_ToBeReleased_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-Required-ToBeReleased-Item')))
    SLDRBs_Required_ToBeReleased_ItemIEs._val = ASN1Set(rv=[dict([('id', 321), ('criticality', 'reject'), ('Value', _SLDRBs_Required_ToBeReleased_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UE-MulticastMRBs-RequiredToBeModified-List >-----#
    UE_MulticastMRBs_RequiredToBeModified_List = SEQ_OF(name='UE-MulticastMRBs-RequiredToBeModified-List', mode=MODE_TYPE)
    _UE_MulticastMRBs_RequiredToBeModified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UE_MulticastMRBs_RequiredToBeModified_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___UE_MulticastMRBs_RequiredToBeModified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____UE_MulticastMRBs_RequiredToBeModified_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UE-MulticastMRBs-RequiredToBeModified-Item')))
    ___UE_MulticastMRBs_RequiredToBeModified_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 656), ('criticality', 'reject'), ('Value', ____UE_MulticastMRBs_RequiredToBeModified_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __UE_MulticastMRBs_RequiredToBeModified_List__item__id._const_tab = ___UE_MulticastMRBs_RequiredToBeModified_List__item__id_tab
    __UE_MulticastMRBs_RequiredToBeModified_List__item__id._const_tab_at = None
    __UE_MulticastMRBs_RequiredToBeModified_List__item__id._const_tab_id = 'id'
    __UE_MulticastMRBs_RequiredToBeModified_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __UE_MulticastMRBs_RequiredToBeModified_List__item__criticality._const_tab = ___UE_MulticastMRBs_RequiredToBeModified_List__item__id_tab
    __UE_MulticastMRBs_RequiredToBeModified_List__item__criticality._const_tab_at = ('..', 'id')
    __UE_MulticastMRBs_RequiredToBeModified_List__item__criticality._const_tab_id = 'criticality'
    __UE_MulticastMRBs_RequiredToBeModified_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __UE_MulticastMRBs_RequiredToBeModified_List__item__value._const_tab = ___UE_MulticastMRBs_RequiredToBeModified_List__item__id_tab
    __UE_MulticastMRBs_RequiredToBeModified_List__item__value._const_tab_at = ('..', 'id')
    __UE_MulticastMRBs_RequiredToBeModified_List__item__value._const_tab_id = 'Value'
    _UE_MulticastMRBs_RequiredToBeModified_List__item_._cont = ASN1Dict([
        ('id', __UE_MulticastMRBs_RequiredToBeModified_List__item__id),
        ('criticality', __UE_MulticastMRBs_RequiredToBeModified_List__item__criticality),
        ('value', __UE_MulticastMRBs_RequiredToBeModified_List__item__value),
        ])
    _UE_MulticastMRBs_RequiredToBeModified_List__item_._ext = None
    UE_MulticastMRBs_RequiredToBeModified_List._cont = _UE_MulticastMRBs_RequiredToBeModified_List__item_
    UE_MulticastMRBs_RequiredToBeModified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< UE-MulticastMRBs-RequiredToBeModified-ItemIEs >-----#
    UE_MulticastMRBs_RequiredToBeModified_ItemIEs = CLASS(name='UE-MulticastMRBs-RequiredToBeModified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UE_MulticastMRBs_RequiredToBeModified_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UE-MulticastMRBs-RequiredToBeModified-Item')))
    UE_MulticastMRBs_RequiredToBeModified_ItemIEs._val = ASN1Set(rv=[dict([('id', 656), ('criticality', 'reject'), ('Value', _UE_MulticastMRBs_RequiredToBeModified_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UE-MulticastMRBs-RequiredToBeReleased-List >-----#
    UE_MulticastMRBs_RequiredToBeReleased_List = SEQ_OF(name='UE-MulticastMRBs-RequiredToBeReleased-List', mode=MODE_TYPE)
    _UE_MulticastMRBs_RequiredToBeReleased_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UE_MulticastMRBs_RequiredToBeReleased_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___UE_MulticastMRBs_RequiredToBeReleased_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____UE_MulticastMRBs_RequiredToBeReleased_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UE-MulticastMRBs-RequiredToBeReleased-Item')))
    ___UE_MulticastMRBs_RequiredToBeReleased_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 658), ('criticality', 'reject'), ('Value', ____UE_MulticastMRBs_RequiredToBeReleased_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __UE_MulticastMRBs_RequiredToBeReleased_List__item__id._const_tab = ___UE_MulticastMRBs_RequiredToBeReleased_List__item__id_tab
    __UE_MulticastMRBs_RequiredToBeReleased_List__item__id._const_tab_at = None
    __UE_MulticastMRBs_RequiredToBeReleased_List__item__id._const_tab_id = 'id'
    __UE_MulticastMRBs_RequiredToBeReleased_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __UE_MulticastMRBs_RequiredToBeReleased_List__item__criticality._const_tab = ___UE_MulticastMRBs_RequiredToBeReleased_List__item__id_tab
    __UE_MulticastMRBs_RequiredToBeReleased_List__item__criticality._const_tab_at = ('..', 'id')
    __UE_MulticastMRBs_RequiredToBeReleased_List__item__criticality._const_tab_id = 'criticality'
    __UE_MulticastMRBs_RequiredToBeReleased_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __UE_MulticastMRBs_RequiredToBeReleased_List__item__value._const_tab = ___UE_MulticastMRBs_RequiredToBeReleased_List__item__id_tab
    __UE_MulticastMRBs_RequiredToBeReleased_List__item__value._const_tab_at = ('..', 'id')
    __UE_MulticastMRBs_RequiredToBeReleased_List__item__value._const_tab_id = 'Value'
    _UE_MulticastMRBs_RequiredToBeReleased_List__item_._cont = ASN1Dict([
        ('id', __UE_MulticastMRBs_RequiredToBeReleased_List__item__id),
        ('criticality', __UE_MulticastMRBs_RequiredToBeReleased_List__item__criticality),
        ('value', __UE_MulticastMRBs_RequiredToBeReleased_List__item__value),
        ])
    _UE_MulticastMRBs_RequiredToBeReleased_List__item_._ext = None
    UE_MulticastMRBs_RequiredToBeReleased_List._cont = _UE_MulticastMRBs_RequiredToBeReleased_List__item_
    UE_MulticastMRBs_RequiredToBeReleased_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< UE-MulticastMRBs-RequiredToBeReleased-ItemIEs >-----#
    UE_MulticastMRBs_RequiredToBeReleased_ItemIEs = CLASS(name='UE-MulticastMRBs-RequiredToBeReleased-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UE_MulticastMRBs_RequiredToBeReleased_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UE-MulticastMRBs-RequiredToBeReleased-Item')))
    UE_MulticastMRBs_RequiredToBeReleased_ItemIEs._val = ASN1Set(rv=[dict([('id', 658), ('criticality', 'reject'), ('Value', _UE_MulticastMRBs_RequiredToBeReleased_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationConfirm >-----#
    UEContextModificationConfirm = SEQ(name='UEContextModificationConfirm', mode=MODE_TYPE)
    _UEContextModificationConfirm_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationConfirm_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____UEContextModificationConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferContainer')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-ModifiedConf-List')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExecuteDuplication')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferInformation')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_8 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-ModifiedConf-List')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_9 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelModifiedList')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_10 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelModifiedList')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_11 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UE-MulticastMRBs-ConfirmedToBeModified-List')))
    ____UEContextModificationConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 49), ('criticality', 'ignore'), ('Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 50), ('criticality', 'ignore'), ('Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 109), ('criticality', 'ignore'), ('Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 195), ('criticality', 'ignore'), ('Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 337), ('criticality', 'ignore'), ('Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 604), ('criticality', 'reject'), ('Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'reject'), ('Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 653), ('criticality', 'reject'), ('Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationConfirm_protocolIEs__item__id._const_tab = ____UEContextModificationConfirm_protocolIEs__item__id_tab
    ___UEContextModificationConfirm_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationConfirm_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextModificationConfirm_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextModificationConfirm_protocolIEs__item__criticality._const_tab = ____UEContextModificationConfirm_protocolIEs__item__id_tab
    ___UEContextModificationConfirm_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextModificationConfirm_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextModificationConfirm_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___UEContextModificationConfirm_protocolIEs__item__value._const_tab = ____UEContextModificationConfirm_protocolIEs__item__id_tab
    ___UEContextModificationConfirm_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextModificationConfirm_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextModificationConfirm_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextModificationConfirm_protocolIEs__item__id),
        ('criticality', ___UEContextModificationConfirm_protocolIEs__item__criticality),
        ('value', ___UEContextModificationConfirm_protocolIEs__item__value),
        ])
    __UEContextModificationConfirm_protocolIEs__item_._ext = None
    _UEContextModificationConfirm_protocolIEs._cont = __UEContextModificationConfirm_protocolIEs__item_
    _UEContextModificationConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationConfirm._cont = ASN1Dict([
        ('protocolIEs', _UEContextModificationConfirm_protocolIEs),
        ])
    UEContextModificationConfirm._ext = []
    
    #-----< UEContextModificationConfirmIEs >-----#
    UEContextModificationConfirmIEs = CLASS(name='UEContextModificationConfirmIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEContextModificationConfirmIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEContextModificationConfirmIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextModificationConfirmIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferContainer')))
    _UEContextModificationConfirmIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRBs-ModifiedConf-List')))
    _UEContextModificationConfirmIEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _UEContextModificationConfirmIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _UEContextModificationConfirmIEs_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExecuteDuplication')))
    _UEContextModificationConfirmIEs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResourceCoordinationTransferInformation')))
    _UEContextModificationConfirmIEs_val_Value_8 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SLDRBs-ModifiedConf-List')))
    _UEContextModificationConfirmIEs_val_Value_9 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelModifiedList')))
    _UEContextModificationConfirmIEs_val_Value_10 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PC5RLCChannelModifiedList')))
    _UEContextModificationConfirmIEs_val_Value_11 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UE-MulticastMRBs-ConfirmedToBeModified-List')))
    UEContextModificationConfirmIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _UEContextModificationConfirmIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _UEContextModificationConfirmIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 49), ('criticality', 'ignore'), ('Value', _UEContextModificationConfirmIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _UEContextModificationConfirmIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 50), ('criticality', 'ignore'), ('Value', _UEContextModificationConfirmIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _UEContextModificationConfirmIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 109), ('criticality', 'ignore'), ('Value', _UEContextModificationConfirmIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 195), ('criticality', 'ignore'), ('Value', _UEContextModificationConfirmIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 337), ('criticality', 'ignore'), ('Value', _UEContextModificationConfirmIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 604), ('criticality', 'reject'), ('Value', _UEContextModificationConfirmIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'reject'), ('Value', _UEContextModificationConfirmIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 653), ('criticality', 'reject'), ('Value', _UEContextModificationConfirmIEs_val_Value_11), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRBs-ModifiedConf-List >-----#
    DRBs_ModifiedConf_List = SEQ_OF(name='DRBs-ModifiedConf-List', mode=MODE_TYPE)
    _DRBs_ModifiedConf_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBs_ModifiedConf_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___DRBs_ModifiedConf_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRBs_ModifiedConf_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-ModifiedConf-Item')))
    ___DRBs_ModifiedConf_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 18), ('criticality', 'ignore'), ('Value', ____DRBs_ModifiedConf_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __DRBs_ModifiedConf_List__item__id._const_tab = ___DRBs_ModifiedConf_List__item__id_tab
    __DRBs_ModifiedConf_List__item__id._const_tab_at = None
    __DRBs_ModifiedConf_List__item__id._const_tab_id = 'id'
    __DRBs_ModifiedConf_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __DRBs_ModifiedConf_List__item__criticality._const_tab = ___DRBs_ModifiedConf_List__item__id_tab
    __DRBs_ModifiedConf_List__item__criticality._const_tab_at = ('..', 'id')
    __DRBs_ModifiedConf_List__item__criticality._const_tab_id = 'criticality'
    __DRBs_ModifiedConf_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __DRBs_ModifiedConf_List__item__value._const_tab = ___DRBs_ModifiedConf_List__item__id_tab
    __DRBs_ModifiedConf_List__item__value._const_tab_at = ('..', 'id')
    __DRBs_ModifiedConf_List__item__value._const_tab_id = 'Value'
    _DRBs_ModifiedConf_List__item_._cont = ASN1Dict([
        ('id', __DRBs_ModifiedConf_List__item__id),
        ('criticality', __DRBs_ModifiedConf_List__item__criticality),
        ('value', __DRBs_ModifiedConf_List__item__value),
        ])
    _DRBs_ModifiedConf_List__item_._ext = None
    DRBs_ModifiedConf_List._cont = _DRBs_ModifiedConf_List__item_
    DRBs_ModifiedConf_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< DRBs-ModifiedConf-ItemIEs >-----#
    DRBs_ModifiedConf_ItemIEs = CLASS(name='DRBs-ModifiedConf-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRBs_ModifiedConf_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRBs-ModifiedConf-Item')))
    DRBs_ModifiedConf_ItemIEs._val = ASN1Set(rv=[dict([('id', 18), ('criticality', 'ignore'), ('Value', _DRBs_ModifiedConf_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SLDRBs-ModifiedConf-List >-----#
    SLDRBs_ModifiedConf_List = SEQ_OF(name='SLDRBs-ModifiedConf-List', mode=MODE_TYPE)
    _SLDRBs_ModifiedConf_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SLDRBs_ModifiedConf_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SLDRBs_ModifiedConf_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____SLDRBs_ModifiedConf_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-ModifiedConf-Item')))
    ___SLDRBs_ModifiedConf_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 338), ('criticality', 'ignore'), ('Value', ____SLDRBs_ModifiedConf_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SLDRBs_ModifiedConf_List__item__id._const_tab = ___SLDRBs_ModifiedConf_List__item__id_tab
    __SLDRBs_ModifiedConf_List__item__id._const_tab_at = None
    __SLDRBs_ModifiedConf_List__item__id._const_tab_id = 'id'
    __SLDRBs_ModifiedConf_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __SLDRBs_ModifiedConf_List__item__criticality._const_tab = ___SLDRBs_ModifiedConf_List__item__id_tab
    __SLDRBs_ModifiedConf_List__item__criticality._const_tab_at = ('..', 'id')
    __SLDRBs_ModifiedConf_List__item__criticality._const_tab_id = 'criticality'
    __SLDRBs_ModifiedConf_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __SLDRBs_ModifiedConf_List__item__value._const_tab = ___SLDRBs_ModifiedConf_List__item__id_tab
    __SLDRBs_ModifiedConf_List__item__value._const_tab_at = ('..', 'id')
    __SLDRBs_ModifiedConf_List__item__value._const_tab_id = 'Value'
    _SLDRBs_ModifiedConf_List__item_._cont = ASN1Dict([
        ('id', __SLDRBs_ModifiedConf_List__item__id),
        ('criticality', __SLDRBs_ModifiedConf_List__item__criticality),
        ('value', __SLDRBs_ModifiedConf_List__item__value),
        ])
    _SLDRBs_ModifiedConf_List__item_._ext = None
    SLDRBs_ModifiedConf_List._cont = _SLDRBs_ModifiedConf_List__item_
    SLDRBs_ModifiedConf_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< SLDRBs-ModifiedConf-ItemIEs >-----#
    SLDRBs_ModifiedConf_ItemIEs = CLASS(name='SLDRBs-ModifiedConf-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SLDRBs_ModifiedConf_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SLDRBs-ModifiedConf-Item')))
    SLDRBs_ModifiedConf_ItemIEs._val = ASN1Set(rv=[dict([('id', 338), ('criticality', 'ignore'), ('Value', _SLDRBs_ModifiedConf_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UE-MulticastMRBs-ConfirmedToBeModified-List >-----#
    UE_MulticastMRBs_ConfirmedToBeModified_List = SEQ_OF(name='UE-MulticastMRBs-ConfirmedToBeModified-List', mode=MODE_TYPE)
    _UE_MulticastMRBs_ConfirmedToBeModified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UE_MulticastMRBs_ConfirmedToBeModified_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___UE_MulticastMRBs_ConfirmedToBeModified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____UE_MulticastMRBs_ConfirmedToBeModified_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UE-MulticastMRBs-ConfirmedToBeModified-Item')))
    ___UE_MulticastMRBs_ConfirmedToBeModified_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 654), ('criticality', 'reject'), ('Value', ____UE_MulticastMRBs_ConfirmedToBeModified_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __UE_MulticastMRBs_ConfirmedToBeModified_List__item__id._const_tab = ___UE_MulticastMRBs_ConfirmedToBeModified_List__item__id_tab
    __UE_MulticastMRBs_ConfirmedToBeModified_List__item__id._const_tab_at = None
    __UE_MulticastMRBs_ConfirmedToBeModified_List__item__id._const_tab_id = 'id'
    __UE_MulticastMRBs_ConfirmedToBeModified_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __UE_MulticastMRBs_ConfirmedToBeModified_List__item__criticality._const_tab = ___UE_MulticastMRBs_ConfirmedToBeModified_List__item__id_tab
    __UE_MulticastMRBs_ConfirmedToBeModified_List__item__criticality._const_tab_at = ('..', 'id')
    __UE_MulticastMRBs_ConfirmedToBeModified_List__item__criticality._const_tab_id = 'criticality'
    __UE_MulticastMRBs_ConfirmedToBeModified_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __UE_MulticastMRBs_ConfirmedToBeModified_List__item__value._const_tab = ___UE_MulticastMRBs_ConfirmedToBeModified_List__item__id_tab
    __UE_MulticastMRBs_ConfirmedToBeModified_List__item__value._const_tab_at = ('..', 'id')
    __UE_MulticastMRBs_ConfirmedToBeModified_List__item__value._const_tab_id = 'Value'
    _UE_MulticastMRBs_ConfirmedToBeModified_List__item_._cont = ASN1Dict([
        ('id', __UE_MulticastMRBs_ConfirmedToBeModified_List__item__id),
        ('criticality', __UE_MulticastMRBs_ConfirmedToBeModified_List__item__criticality),
        ('value', __UE_MulticastMRBs_ConfirmedToBeModified_List__item__value),
        ])
    _UE_MulticastMRBs_ConfirmedToBeModified_List__item_._ext = None
    UE_MulticastMRBs_ConfirmedToBeModified_List._cont = _UE_MulticastMRBs_ConfirmedToBeModified_List__item_
    UE_MulticastMRBs_ConfirmedToBeModified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< UE-MulticastMRBs-ConfirmedToBeModified-ItemIEs >-----#
    UE_MulticastMRBs_ConfirmedToBeModified_ItemIEs = CLASS(name='UE-MulticastMRBs-ConfirmedToBeModified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UE_MulticastMRBs_ConfirmedToBeModified_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UE-MulticastMRBs-ConfirmedToBeModified-Item')))
    UE_MulticastMRBs_ConfirmedToBeModified_ItemIEs._val = ASN1Set(rv=[dict([('id', 654), ('criticality', 'reject'), ('Value', _UE_MulticastMRBs_ConfirmedToBeModified_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationRefuse >-----#
    UEContextModificationRefuse = SEQ(name='UEContextModificationRefuse', mode=MODE_TYPE)
    _UEContextModificationRefuse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationRefuse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationRefuse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____UEContextModificationRefuse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEContextModificationRefuse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEContextModificationRefuse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEContextModificationRefuse_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____UEContextModificationRefuse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____UEContextModificationRefuse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____UEContextModificationRefuse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____UEContextModificationRefuse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____UEContextModificationRefuse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____UEContextModificationRefuse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationRefuse_protocolIEs__item__id._const_tab = ____UEContextModificationRefuse_protocolIEs__item__id_tab
    ___UEContextModificationRefuse_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationRefuse_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextModificationRefuse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextModificationRefuse_protocolIEs__item__criticality._const_tab = ____UEContextModificationRefuse_protocolIEs__item__id_tab
    ___UEContextModificationRefuse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextModificationRefuse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextModificationRefuse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___UEContextModificationRefuse_protocolIEs__item__value._const_tab = ____UEContextModificationRefuse_protocolIEs__item__id_tab
    ___UEContextModificationRefuse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextModificationRefuse_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextModificationRefuse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextModificationRefuse_protocolIEs__item__id),
        ('criticality', ___UEContextModificationRefuse_protocolIEs__item__criticality),
        ('value', ___UEContextModificationRefuse_protocolIEs__item__value),
        ])
    __UEContextModificationRefuse_protocolIEs__item_._ext = None
    _UEContextModificationRefuse_protocolIEs._cont = __UEContextModificationRefuse_protocolIEs__item_
    _UEContextModificationRefuse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationRefuse._cont = ASN1Dict([
        ('protocolIEs', _UEContextModificationRefuse_protocolIEs),
        ])
    UEContextModificationRefuse._ext = []
    
    #-----< UEContextModificationRefuseIEs >-----#
    UEContextModificationRefuseIEs = CLASS(name='UEContextModificationRefuseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEContextModificationRefuseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEContextModificationRefuseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEContextModificationRefuseIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _UEContextModificationRefuseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    UEContextModificationRefuseIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _UEContextModificationRefuseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _UEContextModificationRefuseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _UEContextModificationRefuseIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _UEContextModificationRefuseIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< WriteReplaceWarningRequest >-----#
    WriteReplaceWarningRequest = SEQ(name='WriteReplaceWarningRequest', mode=MODE_TYPE)
    _WriteReplaceWarningRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __WriteReplaceWarningRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___WriteReplaceWarningRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____WriteReplaceWarningRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PWSSystemInformation')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RepetitionPeriod')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NumberofBroadcastRequest')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-To-Be-Broadcast-List')))
    ____WriteReplaceWarningRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 140), ('criticality', 'reject'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 141), ('criticality', 'reject'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 142), ('criticality', 'reject'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 144), ('criticality', 'reject'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___WriteReplaceWarningRequest_protocolIEs__item__id._const_tab = ____WriteReplaceWarningRequest_protocolIEs__item__id_tab
    ___WriteReplaceWarningRequest_protocolIEs__item__id._const_tab_at = None
    ___WriteReplaceWarningRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___WriteReplaceWarningRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___WriteReplaceWarningRequest_protocolIEs__item__criticality._const_tab = ____WriteReplaceWarningRequest_protocolIEs__item__id_tab
    ___WriteReplaceWarningRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___WriteReplaceWarningRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___WriteReplaceWarningRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___WriteReplaceWarningRequest_protocolIEs__item__value._const_tab = ____WriteReplaceWarningRequest_protocolIEs__item__id_tab
    ___WriteReplaceWarningRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___WriteReplaceWarningRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __WriteReplaceWarningRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___WriteReplaceWarningRequest_protocolIEs__item__id),
        ('criticality', ___WriteReplaceWarningRequest_protocolIEs__item__criticality),
        ('value', ___WriteReplaceWarningRequest_protocolIEs__item__value),
        ])
    __WriteReplaceWarningRequest_protocolIEs__item_._ext = None
    _WriteReplaceWarningRequest_protocolIEs._cont = __WriteReplaceWarningRequest_protocolIEs__item_
    _WriteReplaceWarningRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WriteReplaceWarningRequest._cont = ASN1Dict([
        ('protocolIEs', _WriteReplaceWarningRequest_protocolIEs),
        ])
    WriteReplaceWarningRequest._ext = []
    
    #-----< WriteReplaceWarningRequestIEs >-----#
    WriteReplaceWarningRequestIEs = CLASS(name='WriteReplaceWarningRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _WriteReplaceWarningRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _WriteReplaceWarningRequestIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PWSSystemInformation')))
    _WriteReplaceWarningRequestIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RepetitionPeriod')))
    _WriteReplaceWarningRequestIEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NumberofBroadcastRequest')))
    _WriteReplaceWarningRequestIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-To-Be-Broadcast-List')))
    WriteReplaceWarningRequestIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 140), ('criticality', 'reject'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 141), ('criticality', 'reject'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 142), ('criticality', 'reject'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 144), ('criticality', 'reject'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Cells-To-Be-Broadcast-List >-----#
    Cells_To_Be_Broadcast_List = SEQ_OF(name='Cells-To-Be-Broadcast-List', mode=MODE_TYPE)
    _Cells_To_Be_Broadcast_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Cells_To_Be_Broadcast_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___Cells_To_Be_Broadcast_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Cells_To_Be_Broadcast_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-To-Be-Broadcast-Item')))
    ___Cells_To_Be_Broadcast_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 145), ('criticality', 'reject'), ('Value', ____Cells_To_Be_Broadcast_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Cells_To_Be_Broadcast_List__item__id._const_tab = ___Cells_To_Be_Broadcast_List__item__id_tab
    __Cells_To_Be_Broadcast_List__item__id._const_tab_at = None
    __Cells_To_Be_Broadcast_List__item__id._const_tab_id = 'id'
    __Cells_To_Be_Broadcast_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __Cells_To_Be_Broadcast_List__item__criticality._const_tab = ___Cells_To_Be_Broadcast_List__item__id_tab
    __Cells_To_Be_Broadcast_List__item__criticality._const_tab_at = ('..', 'id')
    __Cells_To_Be_Broadcast_List__item__criticality._const_tab_id = 'criticality'
    __Cells_To_Be_Broadcast_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __Cells_To_Be_Broadcast_List__item__value._const_tab = ___Cells_To_Be_Broadcast_List__item__id_tab
    __Cells_To_Be_Broadcast_List__item__value._const_tab_at = ('..', 'id')
    __Cells_To_Be_Broadcast_List__item__value._const_tab_id = 'Value'
    _Cells_To_Be_Broadcast_List__item_._cont = ASN1Dict([
        ('id', __Cells_To_Be_Broadcast_List__item__id),
        ('criticality', __Cells_To_Be_Broadcast_List__item__criticality),
        ('value', __Cells_To_Be_Broadcast_List__item__value),
        ])
    _Cells_To_Be_Broadcast_List__item_._ext = None
    Cells_To_Be_Broadcast_List._cont = _Cells_To_Be_Broadcast_List__item_
    Cells_To_Be_Broadcast_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< Cells-To-Be-Broadcast-List-ItemIEs >-----#
    Cells_To_Be_Broadcast_List_ItemIEs = CLASS(name='Cells-To-Be-Broadcast-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Cells_To_Be_Broadcast_List_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-To-Be-Broadcast-Item')))
    Cells_To_Be_Broadcast_List_ItemIEs._val = ASN1Set(rv=[dict([('id', 145), ('criticality', 'reject'), ('Value', _Cells_To_Be_Broadcast_List_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< WriteReplaceWarningResponse >-----#
    WriteReplaceWarningResponse = SEQ(name='WriteReplaceWarningResponse', mode=MODE_TYPE)
    _WriteReplaceWarningResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __WriteReplaceWarningResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___WriteReplaceWarningResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____WriteReplaceWarningResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-Broadcast-Completed-List')))
    _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Dedicated-SIDelivery-NeededUE-List')))
    ____WriteReplaceWarningResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 146), ('criticality', 'reject'), ('Value', _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 189), ('criticality', 'ignore'), ('Value', _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___WriteReplaceWarningResponse_protocolIEs__item__id._const_tab = ____WriteReplaceWarningResponse_protocolIEs__item__id_tab
    ___WriteReplaceWarningResponse_protocolIEs__item__id._const_tab_at = None
    ___WriteReplaceWarningResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___WriteReplaceWarningResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___WriteReplaceWarningResponse_protocolIEs__item__criticality._const_tab = ____WriteReplaceWarningResponse_protocolIEs__item__id_tab
    ___WriteReplaceWarningResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___WriteReplaceWarningResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___WriteReplaceWarningResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___WriteReplaceWarningResponse_protocolIEs__item__value._const_tab = ____WriteReplaceWarningResponse_protocolIEs__item__id_tab
    ___WriteReplaceWarningResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___WriteReplaceWarningResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __WriteReplaceWarningResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___WriteReplaceWarningResponse_protocolIEs__item__id),
        ('criticality', ___WriteReplaceWarningResponse_protocolIEs__item__criticality),
        ('value', ___WriteReplaceWarningResponse_protocolIEs__item__value),
        ])
    __WriteReplaceWarningResponse_protocolIEs__item_._ext = None
    _WriteReplaceWarningResponse_protocolIEs._cont = __WriteReplaceWarningResponse_protocolIEs__item_
    _WriteReplaceWarningResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WriteReplaceWarningResponse._cont = ASN1Dict([
        ('protocolIEs', _WriteReplaceWarningResponse_protocolIEs),
        ])
    WriteReplaceWarningResponse._ext = []
    
    #-----< WriteReplaceWarningResponseIEs >-----#
    WriteReplaceWarningResponseIEs = CLASS(name='WriteReplaceWarningResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _WriteReplaceWarningResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _WriteReplaceWarningResponseIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-Broadcast-Completed-List')))
    _WriteReplaceWarningResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _WriteReplaceWarningResponseIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Dedicated-SIDelivery-NeededUE-List')))
    WriteReplaceWarningResponseIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _WriteReplaceWarningResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 146), ('criticality', 'reject'), ('Value', _WriteReplaceWarningResponseIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _WriteReplaceWarningResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 189), ('criticality', 'ignore'), ('Value', _WriteReplaceWarningResponseIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Cells-Broadcast-Completed-List >-----#
    Cells_Broadcast_Completed_List = SEQ_OF(name='Cells-Broadcast-Completed-List', mode=MODE_TYPE)
    _Cells_Broadcast_Completed_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Cells_Broadcast_Completed_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___Cells_Broadcast_Completed_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Cells_Broadcast_Completed_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-Broadcast-Completed-Item')))
    ___Cells_Broadcast_Completed_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 147), ('criticality', 'reject'), ('Value', ____Cells_Broadcast_Completed_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Cells_Broadcast_Completed_List__item__id._const_tab = ___Cells_Broadcast_Completed_List__item__id_tab
    __Cells_Broadcast_Completed_List__item__id._const_tab_at = None
    __Cells_Broadcast_Completed_List__item__id._const_tab_id = 'id'
    __Cells_Broadcast_Completed_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __Cells_Broadcast_Completed_List__item__criticality._const_tab = ___Cells_Broadcast_Completed_List__item__id_tab
    __Cells_Broadcast_Completed_List__item__criticality._const_tab_at = ('..', 'id')
    __Cells_Broadcast_Completed_List__item__criticality._const_tab_id = 'criticality'
    __Cells_Broadcast_Completed_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __Cells_Broadcast_Completed_List__item__value._const_tab = ___Cells_Broadcast_Completed_List__item__id_tab
    __Cells_Broadcast_Completed_List__item__value._const_tab_at = ('..', 'id')
    __Cells_Broadcast_Completed_List__item__value._const_tab_id = 'Value'
    _Cells_Broadcast_Completed_List__item_._cont = ASN1Dict([
        ('id', __Cells_Broadcast_Completed_List__item__id),
        ('criticality', __Cells_Broadcast_Completed_List__item__criticality),
        ('value', __Cells_Broadcast_Completed_List__item__value),
        ])
    _Cells_Broadcast_Completed_List__item_._ext = None
    Cells_Broadcast_Completed_List._cont = _Cells_Broadcast_Completed_List__item_
    Cells_Broadcast_Completed_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< Cells-Broadcast-Completed-List-ItemIEs >-----#
    Cells_Broadcast_Completed_List_ItemIEs = CLASS(name='Cells-Broadcast-Completed-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Cells_Broadcast_Completed_List_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-Broadcast-Completed-Item')))
    Cells_Broadcast_Completed_List_ItemIEs._val = ASN1Set(rv=[dict([('id', 147), ('criticality', 'reject'), ('Value', _Cells_Broadcast_Completed_List_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PWSCancelRequest >-----#
    PWSCancelRequest = SEQ(name='PWSCancelRequest', mode=MODE_TYPE)
    _PWSCancelRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PWSCancelRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PWSCancelRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PWSCancelRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NumberofBroadcastRequest')))
    _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Broadcast-To-Be-Cancelled-List')))
    _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cancel-all-Warning-Messages-Indicator')))
    _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NotificationInformation')))
    ____PWSCancelRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 142), ('criticality', 'reject'), ('Value', _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 148), ('criticality', 'reject'), ('Value', _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 220), ('criticality', 'reject'), ('Value', _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PWSCancelRequest_protocolIEs__item__id._const_tab = ____PWSCancelRequest_protocolIEs__item__id_tab
    ___PWSCancelRequest_protocolIEs__item__id._const_tab_at = None
    ___PWSCancelRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___PWSCancelRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PWSCancelRequest_protocolIEs__item__criticality._const_tab = ____PWSCancelRequest_protocolIEs__item__id_tab
    ___PWSCancelRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PWSCancelRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PWSCancelRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PWSCancelRequest_protocolIEs__item__value._const_tab = ____PWSCancelRequest_protocolIEs__item__id_tab
    ___PWSCancelRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PWSCancelRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __PWSCancelRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PWSCancelRequest_protocolIEs__item__id),
        ('criticality', ___PWSCancelRequest_protocolIEs__item__criticality),
        ('value', ___PWSCancelRequest_protocolIEs__item__value),
        ])
    __PWSCancelRequest_protocolIEs__item_._ext = None
    _PWSCancelRequest_protocolIEs._cont = __PWSCancelRequest_protocolIEs__item_
    _PWSCancelRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PWSCancelRequest._cont = ASN1Dict([
        ('protocolIEs', _PWSCancelRequest_protocolIEs),
        ])
    PWSCancelRequest._ext = []
    
    #-----< PWSCancelRequestIEs >-----#
    PWSCancelRequestIEs = CLASS(name='PWSCancelRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PWSCancelRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PWSCancelRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NumberofBroadcastRequest')))
    _PWSCancelRequestIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Broadcast-To-Be-Cancelled-List')))
    _PWSCancelRequestIEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cancel-all-Warning-Messages-Indicator')))
    _PWSCancelRequestIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NotificationInformation')))
    PWSCancelRequestIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _PWSCancelRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 142), ('criticality', 'reject'), ('Value', _PWSCancelRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 148), ('criticality', 'reject'), ('Value', _PWSCancelRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _PWSCancelRequestIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 220), ('criticality', 'reject'), ('Value', _PWSCancelRequestIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Broadcast-To-Be-Cancelled-List >-----#
    Broadcast_To_Be_Cancelled_List = SEQ_OF(name='Broadcast-To-Be-Cancelled-List', mode=MODE_TYPE)
    _Broadcast_To_Be_Cancelled_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Broadcast_To_Be_Cancelled_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___Broadcast_To_Be_Cancelled_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Broadcast_To_Be_Cancelled_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Broadcast-To-Be-Cancelled-Item')))
    ___Broadcast_To_Be_Cancelled_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 149), ('criticality', 'reject'), ('Value', ____Broadcast_To_Be_Cancelled_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Broadcast_To_Be_Cancelled_List__item__id._const_tab = ___Broadcast_To_Be_Cancelled_List__item__id_tab
    __Broadcast_To_Be_Cancelled_List__item__id._const_tab_at = None
    __Broadcast_To_Be_Cancelled_List__item__id._const_tab_id = 'id'
    __Broadcast_To_Be_Cancelled_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __Broadcast_To_Be_Cancelled_List__item__criticality._const_tab = ___Broadcast_To_Be_Cancelled_List__item__id_tab
    __Broadcast_To_Be_Cancelled_List__item__criticality._const_tab_at = ('..', 'id')
    __Broadcast_To_Be_Cancelled_List__item__criticality._const_tab_id = 'criticality'
    __Broadcast_To_Be_Cancelled_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __Broadcast_To_Be_Cancelled_List__item__value._const_tab = ___Broadcast_To_Be_Cancelled_List__item__id_tab
    __Broadcast_To_Be_Cancelled_List__item__value._const_tab_at = ('..', 'id')
    __Broadcast_To_Be_Cancelled_List__item__value._const_tab_id = 'Value'
    _Broadcast_To_Be_Cancelled_List__item_._cont = ASN1Dict([
        ('id', __Broadcast_To_Be_Cancelled_List__item__id),
        ('criticality', __Broadcast_To_Be_Cancelled_List__item__criticality),
        ('value', __Broadcast_To_Be_Cancelled_List__item__value),
        ])
    _Broadcast_To_Be_Cancelled_List__item_._ext = None
    Broadcast_To_Be_Cancelled_List._cont = _Broadcast_To_Be_Cancelled_List__item_
    Broadcast_To_Be_Cancelled_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< Broadcast-To-Be-Cancelled-List-ItemIEs >-----#
    Broadcast_To_Be_Cancelled_List_ItemIEs = CLASS(name='Broadcast-To-Be-Cancelled-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Broadcast_To_Be_Cancelled_List_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Broadcast-To-Be-Cancelled-Item')))
    Broadcast_To_Be_Cancelled_List_ItemIEs._val = ASN1Set(rv=[dict([('id', 149), ('criticality', 'reject'), ('Value', _Broadcast_To_Be_Cancelled_List_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PWSCancelResponse >-----#
    PWSCancelResponse = SEQ(name='PWSCancelResponse', mode=MODE_TYPE)
    _PWSCancelResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PWSCancelResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PWSCancelResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PWSCancelResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-Broadcast-Cancelled-List')))
    _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____PWSCancelResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 150), ('criticality', 'reject'), ('Value', _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PWSCancelResponse_protocolIEs__item__id._const_tab = ____PWSCancelResponse_protocolIEs__item__id_tab
    ___PWSCancelResponse_protocolIEs__item__id._const_tab_at = None
    ___PWSCancelResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___PWSCancelResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PWSCancelResponse_protocolIEs__item__criticality._const_tab = ____PWSCancelResponse_protocolIEs__item__id_tab
    ___PWSCancelResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PWSCancelResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PWSCancelResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PWSCancelResponse_protocolIEs__item__value._const_tab = ____PWSCancelResponse_protocolIEs__item__id_tab
    ___PWSCancelResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PWSCancelResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __PWSCancelResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PWSCancelResponse_protocolIEs__item__id),
        ('criticality', ___PWSCancelResponse_protocolIEs__item__criticality),
        ('value', ___PWSCancelResponse_protocolIEs__item__value),
        ])
    __PWSCancelResponse_protocolIEs__item_._ext = None
    _PWSCancelResponse_protocolIEs._cont = __PWSCancelResponse_protocolIEs__item_
    _PWSCancelResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PWSCancelResponse._cont = ASN1Dict([
        ('protocolIEs', _PWSCancelResponse_protocolIEs),
        ])
    PWSCancelResponse._ext = []
    
    #-----< PWSCancelResponseIEs >-----#
    PWSCancelResponseIEs = CLASS(name='PWSCancelResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PWSCancelResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PWSCancelResponseIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Cells-Broadcast-Cancelled-List')))
    _PWSCancelResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    PWSCancelResponseIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _PWSCancelResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 150), ('criticality', 'reject'), ('Value', _PWSCancelResponseIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _PWSCancelResponseIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Cells-Broadcast-Cancelled-List >-----#
    Cells_Broadcast_Cancelled_List = SEQ_OF(name='Cells-Broadcast-Cancelled-List', mode=MODE_TYPE)
    _Cells_Broadcast_Cancelled_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Cells_Broadcast_Cancelled_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___Cells_Broadcast_Cancelled_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____Cells_Broadcast_Cancelled_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-Broadcast-Cancelled-Item')))
    ___Cells_Broadcast_Cancelled_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 151), ('criticality', 'reject'), ('Value', ____Cells_Broadcast_Cancelled_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Cells_Broadcast_Cancelled_List__item__id._const_tab = ___Cells_Broadcast_Cancelled_List__item__id_tab
    __Cells_Broadcast_Cancelled_List__item__id._const_tab_at = None
    __Cells_Broadcast_Cancelled_List__item__id._const_tab_id = 'id'
    __Cells_Broadcast_Cancelled_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __Cells_Broadcast_Cancelled_List__item__criticality._const_tab = ___Cells_Broadcast_Cancelled_List__item__id_tab
    __Cells_Broadcast_Cancelled_List__item__criticality._const_tab_at = ('..', 'id')
    __Cells_Broadcast_Cancelled_List__item__criticality._const_tab_id = 'criticality'
    __Cells_Broadcast_Cancelled_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __Cells_Broadcast_Cancelled_List__item__value._const_tab = ___Cells_Broadcast_Cancelled_List__item__id_tab
    __Cells_Broadcast_Cancelled_List__item__value._const_tab_at = ('..', 'id')
    __Cells_Broadcast_Cancelled_List__item__value._const_tab_id = 'Value'
    _Cells_Broadcast_Cancelled_List__item_._cont = ASN1Dict([
        ('id', __Cells_Broadcast_Cancelled_List__item__id),
        ('criticality', __Cells_Broadcast_Cancelled_List__item__criticality),
        ('value', __Cells_Broadcast_Cancelled_List__item__value),
        ])
    _Cells_Broadcast_Cancelled_List__item_._ext = None
    Cells_Broadcast_Cancelled_List._cont = _Cells_Broadcast_Cancelled_List__item_
    Cells_Broadcast_Cancelled_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< Cells-Broadcast-Cancelled-List-ItemIEs >-----#
    Cells_Broadcast_Cancelled_List_ItemIEs = CLASS(name='Cells-Broadcast-Cancelled-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _Cells_Broadcast_Cancelled_List_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cells-Broadcast-Cancelled-Item')))
    Cells_Broadcast_Cancelled_List_ItemIEs._val = ASN1Set(rv=[dict([('id', 151), ('criticality', 'reject'), ('Value', _Cells_Broadcast_Cancelled_List_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEInactivityNotification >-----#
    UEInactivityNotification = SEQ(name='UEInactivityNotification', mode=MODE_TYPE)
    _UEInactivityNotification_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __UEInactivityNotification_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___UEInactivityNotification_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____UEInactivityNotification_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____UEInactivityNotification_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____UEInactivityNotification_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____UEInactivityNotification_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRB-Activity-List')))
    _____UEInactivityNotification_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SDT-Termination-Request')))
    ____UEInactivityNotification_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____UEInactivityNotification_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____UEInactivityNotification_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 100), ('criticality', 'reject'), ('Value', _____UEInactivityNotification_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 635), ('criticality', 'ignore'), ('Value', _____UEInactivityNotification_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEInactivityNotification_protocolIEs__item__id._const_tab = ____UEInactivityNotification_protocolIEs__item__id_tab
    ___UEInactivityNotification_protocolIEs__item__id._const_tab_at = None
    ___UEInactivityNotification_protocolIEs__item__id._const_tab_id = 'id'
    ___UEInactivityNotification_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___UEInactivityNotification_protocolIEs__item__criticality._const_tab = ____UEInactivityNotification_protocolIEs__item__id_tab
    ___UEInactivityNotification_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEInactivityNotification_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEInactivityNotification_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___UEInactivityNotification_protocolIEs__item__value._const_tab = ____UEInactivityNotification_protocolIEs__item__id_tab
    ___UEInactivityNotification_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEInactivityNotification_protocolIEs__item__value._const_tab_id = 'Value'
    __UEInactivityNotification_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEInactivityNotification_protocolIEs__item__id),
        ('criticality', ___UEInactivityNotification_protocolIEs__item__criticality),
        ('value', ___UEInactivityNotification_protocolIEs__item__value),
        ])
    __UEInactivityNotification_protocolIEs__item_._ext = None
    _UEInactivityNotification_protocolIEs._cont = __UEInactivityNotification_protocolIEs__item_
    _UEInactivityNotification_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEInactivityNotification._cont = ASN1Dict([
        ('protocolIEs', _UEInactivityNotification_protocolIEs),
        ])
    UEInactivityNotification._ext = []
    
    #-----< UEInactivityNotificationIEs >-----#
    UEInactivityNotificationIEs = CLASS(name='UEInactivityNotificationIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEInactivityNotificationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _UEInactivityNotificationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _UEInactivityNotificationIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRB-Activity-List')))
    _UEInactivityNotificationIEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SDT-Termination-Request')))
    UEInactivityNotificationIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _UEInactivityNotificationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _UEInactivityNotificationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 100), ('criticality', 'reject'), ('Value', _UEInactivityNotificationIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 635), ('criticality', 'ignore'), ('Value', _UEInactivityNotificationIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRB-Activity-List >-----#
    DRB_Activity_List = SEQ_OF(name='DRB-Activity-List', mode=MODE_TYPE)
    _DRB_Activity_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRB_Activity_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___DRB_Activity_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRB_Activity_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRB-Activity-Item')))
    ___DRB_Activity_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 99), ('criticality', 'reject'), ('Value', ____DRB_Activity_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __DRB_Activity_List__item__id._const_tab = ___DRB_Activity_List__item__id_tab
    __DRB_Activity_List__item__id._const_tab_at = None
    __DRB_Activity_List__item__id._const_tab_id = 'id'
    __DRB_Activity_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __DRB_Activity_List__item__criticality._const_tab = ___DRB_Activity_List__item__id_tab
    __DRB_Activity_List__item__criticality._const_tab_at = ('..', 'id')
    __DRB_Activity_List__item__criticality._const_tab_id = 'criticality'
    __DRB_Activity_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __DRB_Activity_List__item__value._const_tab = ___DRB_Activity_List__item__id_tab
    __DRB_Activity_List__item__value._const_tab_at = ('..', 'id')
    __DRB_Activity_List__item__value._const_tab_id = 'Value'
    _DRB_Activity_List__item_._cont = ASN1Dict([
        ('id', __DRB_Activity_List__item__id),
        ('criticality', __DRB_Activity_List__item__criticality),
        ('value', __DRB_Activity_List__item__value),
        ])
    _DRB_Activity_List__item_._ext = None
    DRB_Activity_List._cont = _DRB_Activity_List__item_
    DRB_Activity_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< DRB-Activity-ItemIEs >-----#
    DRB_Activity_ItemIEs = CLASS(name='DRB-Activity-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRB_Activity_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRB-Activity-Item')))
    DRB_Activity_ItemIEs._val = ASN1Set(rv=[dict([('id', 99), ('criticality', 'reject'), ('Value', _DRB_Activity_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< InitialULRRCMessageTransfer >-----#
    InitialULRRCMessageTransfer = SEQ(name='InitialULRRCMessageTransfer', mode=MODE_TYPE)
    _InitialULRRCMessageTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __InitialULRRCMessageTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___InitialULRRCMessageTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____InitialULRRCMessageTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'C-RNTI')))
    _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DUtoCURRCContainer')))
    _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SULAccessIndication')))
    _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RANUEID')))
    _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_8 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer-RRCSetupComplete')))
    _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRRedCapUEIndication')))
    _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SDTInformation')))
    _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SidelinkRelayConfiguration')))
    ____InitialULRRCMessageTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 41), ('criticality', 'reject'), ('Value', _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 111), ('criticality', 'reject'), ('Value', _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 95), ('criticality', 'reject'), ('Value', _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 50), ('criticality', 'reject'), ('Value', _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 128), ('criticality', 'reject'), ('Value', _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 178), ('criticality', 'ignore'), ('Value', _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 78), ('criticality', 'ignore'), ('Value', _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_6), ('presence', 'mandatory')]), dict([('id', 226), ('criticality', 'ignore'), ('Value', _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 241), ('criticality', 'ignore'), ('Value', _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 578), ('criticality', 'ignore'), ('Value', _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 592), ('criticality', 'ignore'), ('Value', _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 617), ('criticality', 'ignore'), ('Value', _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___InitialULRRCMessageTransfer_protocolIEs__item__id._const_tab = ____InitialULRRCMessageTransfer_protocolIEs__item__id_tab
    ___InitialULRRCMessageTransfer_protocolIEs__item__id._const_tab_at = None
    ___InitialULRRCMessageTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___InitialULRRCMessageTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___InitialULRRCMessageTransfer_protocolIEs__item__criticality._const_tab = ____InitialULRRCMessageTransfer_protocolIEs__item__id_tab
    ___InitialULRRCMessageTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___InitialULRRCMessageTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___InitialULRRCMessageTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___InitialULRRCMessageTransfer_protocolIEs__item__value._const_tab = ____InitialULRRCMessageTransfer_protocolIEs__item__id_tab
    ___InitialULRRCMessageTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___InitialULRRCMessageTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __InitialULRRCMessageTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___InitialULRRCMessageTransfer_protocolIEs__item__id),
        ('criticality', ___InitialULRRCMessageTransfer_protocolIEs__item__criticality),
        ('value', ___InitialULRRCMessageTransfer_protocolIEs__item__value),
        ])
    __InitialULRRCMessageTransfer_protocolIEs__item_._ext = None
    _InitialULRRCMessageTransfer_protocolIEs._cont = __InitialULRRCMessageTransfer_protocolIEs__item_
    _InitialULRRCMessageTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    InitialULRRCMessageTransfer._cont = ASN1Dict([
        ('protocolIEs', _InitialULRRCMessageTransfer_protocolIEs),
        ])
    InitialULRRCMessageTransfer._ext = []
    
    #-----< InitialULRRCMessageTransferIEs >-----#
    InitialULRRCMessageTransferIEs = CLASS(name='InitialULRRCMessageTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _InitialULRRCMessageTransferIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _InitialULRRCMessageTransferIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _InitialULRRCMessageTransferIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'C-RNTI')))
    _InitialULRRCMessageTransferIEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _InitialULRRCMessageTransferIEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DUtoCURRCContainer')))
    _InitialULRRCMessageTransferIEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SULAccessIndication')))
    _InitialULRRCMessageTransferIEs_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _InitialULRRCMessageTransferIEs_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RANUEID')))
    _InitialULRRCMessageTransferIEs_val_Value_8 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer-RRCSetupComplete')))
    _InitialULRRCMessageTransferIEs_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRRedCapUEIndication')))
    _InitialULRRCMessageTransferIEs_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SDTInformation')))
    _InitialULRRCMessageTransferIEs_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SidelinkRelayConfiguration')))
    InitialULRRCMessageTransferIEs._val = ASN1Set(rv=[dict([('id', 41), ('criticality', 'reject'), ('Value', _InitialULRRCMessageTransferIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 111), ('criticality', 'reject'), ('Value', _InitialULRRCMessageTransferIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 95), ('criticality', 'reject'), ('Value', _InitialULRRCMessageTransferIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 50), ('criticality', 'reject'), ('Value', _InitialULRRCMessageTransferIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 128), ('criticality', 'reject'), ('Value', _InitialULRRCMessageTransferIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 178), ('criticality', 'ignore'), ('Value', _InitialULRRCMessageTransferIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 78), ('criticality', 'ignore'), ('Value', _InitialULRRCMessageTransferIEs_val_Value_6), ('presence', 'mandatory')]), dict([('id', 226), ('criticality', 'ignore'), ('Value', _InitialULRRCMessageTransferIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 241), ('criticality', 'ignore'), ('Value', _InitialULRRCMessageTransferIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 578), ('criticality', 'ignore'), ('Value', _InitialULRRCMessageTransferIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 592), ('criticality', 'ignore'), ('Value', _InitialULRRCMessageTransferIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 617), ('criticality', 'ignore'), ('Value', _InitialULRRCMessageTransferIEs_val_Value_11), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DLRRCMessageTransfer >-----#
    DLRRCMessageTransfer = SEQ(name='DLRRCMessageTransfer', mode=MODE_TYPE)
    _DLRRCMessageTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __DLRRCMessageTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___DLRRCMessageTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____DLRRCMessageTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExecuteDuplication')))
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_6 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAT-FrequencyPriorityInformation')))
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCDeliveryStatusRequest')))
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_8 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UEContextNotRetrievable')))
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_9 = OCT_STR(name='Value', mode=MODE_TYPE)
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_10 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_11 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_12 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_13 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelID')))
    ____DLRRCMessageTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 47), ('criticality', 'reject'), ('Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 64), ('criticality', 'reject'), ('Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 109), ('criticality', 'ignore'), ('Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 50), ('criticality', 'reject'), ('Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_5), ('presence', 'mandatory')]), dict([('id', 108), ('criticality', 'reject'), ('Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 184), ('criticality', 'ignore'), ('Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 222), ('criticality', 'reject'), ('Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 218), ('criticality', 'reject'), ('Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 221), ('criticality', 'ignore'), ('Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 217), ('criticality', 'reject'), ('Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 248), ('criticality', 'ignore'), ('Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 597), ('criticality', 'ignore'), ('Value', _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DLRRCMessageTransfer_protocolIEs__item__id._const_tab = ____DLRRCMessageTransfer_protocolIEs__item__id_tab
    ___DLRRCMessageTransfer_protocolIEs__item__id._const_tab_at = None
    ___DLRRCMessageTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___DLRRCMessageTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___DLRRCMessageTransfer_protocolIEs__item__criticality._const_tab = ____DLRRCMessageTransfer_protocolIEs__item__id_tab
    ___DLRRCMessageTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DLRRCMessageTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DLRRCMessageTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___DLRRCMessageTransfer_protocolIEs__item__value._const_tab = ____DLRRCMessageTransfer_protocolIEs__item__id_tab
    ___DLRRCMessageTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DLRRCMessageTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __DLRRCMessageTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DLRRCMessageTransfer_protocolIEs__item__id),
        ('criticality', ___DLRRCMessageTransfer_protocolIEs__item__criticality),
        ('value', ___DLRRCMessageTransfer_protocolIEs__item__value),
        ])
    __DLRRCMessageTransfer_protocolIEs__item_._ext = None
    _DLRRCMessageTransfer_protocolIEs._cont = __DLRRCMessageTransfer_protocolIEs__item_
    _DLRRCMessageTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DLRRCMessageTransfer._cont = ASN1Dict([
        ('protocolIEs', _DLRRCMessageTransfer_protocolIEs),
        ])
    DLRRCMessageTransfer._ext = []
    
    #-----< DLRRCMessageTransferIEs >-----#
    DLRRCMessageTransferIEs = CLASS(name='DLRRCMessageTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DLRRCMessageTransferIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _DLRRCMessageTransferIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _DLRRCMessageTransferIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _DLRRCMessageTransferIEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _DLRRCMessageTransferIEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExecuteDuplication')))
    _DLRRCMessageTransferIEs_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _DLRRCMessageTransferIEs_val_Value_6 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAT-FrequencyPriorityInformation')))
    _DLRRCMessageTransferIEs_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCDeliveryStatusRequest')))
    _DLRRCMessageTransferIEs_val_Value_8 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UEContextNotRetrievable')))
    _DLRRCMessageTransferIEs_val_Value_9 = OCT_STR(name='Value', mode=MODE_TYPE)
    _DLRRCMessageTransferIEs_val_Value_10 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _DLRRCMessageTransferIEs_val_Value_11 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _DLRRCMessageTransferIEs_val_Value_12 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _DLRRCMessageTransferIEs_val_Value_13 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UuRLCChannelID')))
    DLRRCMessageTransferIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _DLRRCMessageTransferIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _DLRRCMessageTransferIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 47), ('criticality', 'reject'), ('Value', _DLRRCMessageTransferIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 64), ('criticality', 'reject'), ('Value', _DLRRCMessageTransferIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 109), ('criticality', 'ignore'), ('Value', _DLRRCMessageTransferIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 50), ('criticality', 'reject'), ('Value', _DLRRCMessageTransferIEs_val_Value_5), ('presence', 'mandatory')]), dict([('id', 108), ('criticality', 'reject'), ('Value', _DLRRCMessageTransferIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 184), ('criticality', 'ignore'), ('Value', _DLRRCMessageTransferIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 222), ('criticality', 'reject'), ('Value', _DLRRCMessageTransferIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 218), ('criticality', 'reject'), ('Value', _DLRRCMessageTransferIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 221), ('criticality', 'ignore'), ('Value', _DLRRCMessageTransferIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 217), ('criticality', 'reject'), ('Value', _DLRRCMessageTransferIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 248), ('criticality', 'ignore'), ('Value', _DLRRCMessageTransferIEs_val_Value_12), ('presence', 'optional')]), dict([('id', 597), ('criticality', 'ignore'), ('Value', _DLRRCMessageTransferIEs_val_Value_13), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ULRRCMessageTransfer >-----#
    ULRRCMessageTransfer = SEQ(name='ULRRCMessageTransfer', mode=MODE_TYPE)
    _ULRRCMessageTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __ULRRCMessageTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___ULRRCMessageTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____ULRRCMessageTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    ____ULRRCMessageTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 64), ('criticality', 'reject'), ('Value', _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 50), ('criticality', 'reject'), ('Value', _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 224), ('criticality', 'reject'), ('Value', _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 219), ('criticality', 'reject'), ('Value', _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ULRRCMessageTransfer_protocolIEs__item__id._const_tab = ____ULRRCMessageTransfer_protocolIEs__item__id_tab
    ___ULRRCMessageTransfer_protocolIEs__item__id._const_tab_at = None
    ___ULRRCMessageTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___ULRRCMessageTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___ULRRCMessageTransfer_protocolIEs__item__criticality._const_tab = ____ULRRCMessageTransfer_protocolIEs__item__id_tab
    ___ULRRCMessageTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ULRRCMessageTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ULRRCMessageTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___ULRRCMessageTransfer_protocolIEs__item__value._const_tab = ____ULRRCMessageTransfer_protocolIEs__item__id_tab
    ___ULRRCMessageTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ULRRCMessageTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __ULRRCMessageTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ULRRCMessageTransfer_protocolIEs__item__id),
        ('criticality', ___ULRRCMessageTransfer_protocolIEs__item__criticality),
        ('value', ___ULRRCMessageTransfer_protocolIEs__item__value),
        ])
    __ULRRCMessageTransfer_protocolIEs__item_._ext = None
    _ULRRCMessageTransfer_protocolIEs._cont = __ULRRCMessageTransfer_protocolIEs__item_
    _ULRRCMessageTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ULRRCMessageTransfer._cont = ASN1Dict([
        ('protocolIEs', _ULRRCMessageTransfer_protocolIEs),
        ])
    ULRRCMessageTransfer._ext = []
    
    #-----< ULRRCMessageTransferIEs >-----#
    ULRRCMessageTransferIEs = CLASS(name='ULRRCMessageTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _ULRRCMessageTransferIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _ULRRCMessageTransferIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _ULRRCMessageTransferIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    _ULRRCMessageTransferIEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCContainer')))
    _ULRRCMessageTransferIEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PLMN-Identity')))
    _ULRRCMessageTransferIEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    ULRRCMessageTransferIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _ULRRCMessageTransferIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _ULRRCMessageTransferIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 64), ('criticality', 'reject'), ('Value', _ULRRCMessageTransferIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 50), ('criticality', 'reject'), ('Value', _ULRRCMessageTransferIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 224), ('criticality', 'reject'), ('Value', _ULRRCMessageTransferIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 219), ('criticality', 'reject'), ('Value', _ULRRCMessageTransferIEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PrivateMessage >-----#
    PrivateMessage = SEQ(name='PrivateMessage', mode=MODE_TYPE)
    _PrivateMessage_privateIEs = SEQ_OF(name='privateIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'PrivateIE-Container')))
    __PrivateMessage_privateIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'PrivateIE-Field')))
    ___PrivateMessage_privateIEs__item__id = CHOICE(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PRIVATE-IES'), ['id']))
    ____PrivateMessage_privateIEs__item__id_tab = CLASS(name='_tab_F1AP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__id._const_tab = ____PrivateMessage_privateIEs__item__id_tab
    ___PrivateMessage_privateIEs__item__id._const_tab_at = None
    ___PrivateMessage_privateIEs__item__id._const_tab_id = 'id'
    ___PrivateMessage_privateIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PRIVATE-IES'), ['criticality']))
    ____PrivateMessage_privateIEs__item__criticality_tab = CLASS(name='_tab_F1AP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__criticality._const_tab = ____PrivateMessage_privateIEs__item__criticality_tab
    ___PrivateMessage_privateIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PrivateMessage_privateIEs__item__criticality._const_tab_id = 'criticality'
    ___PrivateMessage_privateIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PRIVATE-IES'), ['Value']))
    ____PrivateMessage_privateIEs__item__value_tab = CLASS(name='_tab_F1AP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__value._const_tab = ____PrivateMessage_privateIEs__item__value_tab
    ___PrivateMessage_privateIEs__item__value._const_tab_at = ('..', 'id')
    ___PrivateMessage_privateIEs__item__value._const_tab_id = 'Value'
    __PrivateMessage_privateIEs__item_._cont = ASN1Dict([
        ('id', ___PrivateMessage_privateIEs__item__id),
        ('criticality', ___PrivateMessage_privateIEs__item__criticality),
        ('value', ___PrivateMessage_privateIEs__item__value),
        ])
    __PrivateMessage_privateIEs__item_._ext = None
    _PrivateMessage_privateIEs._cont = __PrivateMessage_privateIEs__item_
    _PrivateMessage_privateIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrivateMessage._cont = ASN1Dict([
        ('privateIEs', _PrivateMessage_privateIEs),
        ])
    PrivateMessage._ext = []
    
    #-----< PrivateMessage-IEs >-----#
    PrivateMessage_IEs = CLASS(name='PrivateMessage-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PRIVATE-IES')))
    PrivateMessage_IEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SystemInformationDeliveryCommand >-----#
    SystemInformationDeliveryCommand = SEQ(name='SystemInformationDeliveryCommand', mode=MODE_TYPE)
    _SystemInformationDeliveryCommand_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __SystemInformationDeliveryCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___SystemInformationDeliveryCommand_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____SystemInformationDeliveryCommand_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____SystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____SystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _____SystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SItype-List')))
    _____SystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    ____SystemInformationDeliveryCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____SystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 111), ('criticality', 'reject'), ('Value', _____SystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 116), ('criticality', 'reject'), ('Value', _____SystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____SystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___SystemInformationDeliveryCommand_protocolIEs__item__id._const_tab = ____SystemInformationDeliveryCommand_protocolIEs__item__id_tab
    ___SystemInformationDeliveryCommand_protocolIEs__item__id._const_tab_at = None
    ___SystemInformationDeliveryCommand_protocolIEs__item__id._const_tab_id = 'id'
    ___SystemInformationDeliveryCommand_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___SystemInformationDeliveryCommand_protocolIEs__item__criticality._const_tab = ____SystemInformationDeliveryCommand_protocolIEs__item__id_tab
    ___SystemInformationDeliveryCommand_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SystemInformationDeliveryCommand_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SystemInformationDeliveryCommand_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___SystemInformationDeliveryCommand_protocolIEs__item__value._const_tab = ____SystemInformationDeliveryCommand_protocolIEs__item__id_tab
    ___SystemInformationDeliveryCommand_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SystemInformationDeliveryCommand_protocolIEs__item__value._const_tab_id = 'Value'
    __SystemInformationDeliveryCommand_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SystemInformationDeliveryCommand_protocolIEs__item__id),
        ('criticality', ___SystemInformationDeliveryCommand_protocolIEs__item__criticality),
        ('value', ___SystemInformationDeliveryCommand_protocolIEs__item__value),
        ])
    __SystemInformationDeliveryCommand_protocolIEs__item_._ext = None
    _SystemInformationDeliveryCommand_protocolIEs._cont = __SystemInformationDeliveryCommand_protocolIEs__item_
    _SystemInformationDeliveryCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SystemInformationDeliveryCommand._cont = ASN1Dict([
        ('protocolIEs', _SystemInformationDeliveryCommand_protocolIEs),
        ])
    SystemInformationDeliveryCommand._ext = []
    
    #-----< SystemInformationDeliveryCommandIEs >-----#
    SystemInformationDeliveryCommandIEs = CLASS(name='SystemInformationDeliveryCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _SystemInformationDeliveryCommandIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _SystemInformationDeliveryCommandIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _SystemInformationDeliveryCommandIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SItype-List')))
    _SystemInformationDeliveryCommandIEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    SystemInformationDeliveryCommandIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _SystemInformationDeliveryCommandIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 111), ('criticality', 'reject'), ('Value', _SystemInformationDeliveryCommandIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 116), ('criticality', 'reject'), ('Value', _SystemInformationDeliveryCommandIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _SystemInformationDeliveryCommandIEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Paging >-----#
    Paging = SEQ(name='Paging', mode=MODE_TYPE)
    _Paging_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __Paging_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___Paging_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____Paging_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____Paging_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UEIdentityIndexValue')))
    _____Paging_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingIdentity')))
    _____Paging_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingDRX')))
    _____Paging_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingPriority')))
    _____Paging_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PagingCell-list')))
    _____Paging_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingOrigin')))
    _____Paging_protocolIEs__item__id_tab_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingDRX')))
    _____Paging_protocolIEs__item__id_tab_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingDRX')))
    _____Paging_protocolIEs__item__id_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRPagingeDRXInformation')))
    _____Paging_protocolIEs__item__id_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRPagingeDRXInformationforRRCINACTIVE')))
    _____Paging_protocolIEs__item__id_tab_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingCause')))
    _____Paging_protocolIEs__item__id_tab_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PEIPSAssistanceInfo')))
    _____Paging_protocolIEs__item__id_tab_val_Value_12 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UEPagingCapability')))
    _____Paging_protocolIEs__item__id_tab_val_Value_13 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedUEIdentityIndexValue')))
    ____Paging_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 117), ('criticality', 'reject'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 127), ('criticality', 'reject'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 114), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 115), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 113), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 216), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 580), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 581), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 582), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 583), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 620), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 622), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 623), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 694), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Paging_protocolIEs__item__id._const_tab = ____Paging_protocolIEs__item__id_tab
    ___Paging_protocolIEs__item__id._const_tab_at = None
    ___Paging_protocolIEs__item__id._const_tab_id = 'id'
    ___Paging_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___Paging_protocolIEs__item__criticality._const_tab = ____Paging_protocolIEs__item__id_tab
    ___Paging_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___Paging_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___Paging_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___Paging_protocolIEs__item__value._const_tab = ____Paging_protocolIEs__item__id_tab
    ___Paging_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___Paging_protocolIEs__item__value._const_tab_id = 'Value'
    __Paging_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___Paging_protocolIEs__item__id),
        ('criticality', ___Paging_protocolIEs__item__criticality),
        ('value', ___Paging_protocolIEs__item__value),
        ])
    __Paging_protocolIEs__item_._ext = None
    _Paging_protocolIEs._cont = __Paging_protocolIEs__item_
    _Paging_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    Paging._cont = ASN1Dict([
        ('protocolIEs', _Paging_protocolIEs),
        ])
    Paging._ext = []
    
    #-----< PagingIEs >-----#
    PagingIEs = CLASS(name='PagingIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PagingIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UEIdentityIndexValue')))
    _PagingIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingIdentity')))
    _PagingIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingDRX')))
    _PagingIEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingPriority')))
    _PagingIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PagingCell-list')))
    _PagingIEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingOrigin')))
    _PagingIEs_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingDRX')))
    _PagingIEs_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingDRX')))
    _PagingIEs_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRPagingeDRXInformation')))
    _PagingIEs_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRPagingeDRXInformationforRRCINACTIVE')))
    _PagingIEs_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingCause')))
    _PagingIEs_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PEIPSAssistanceInfo')))
    _PagingIEs_val_Value_12 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UEPagingCapability')))
    _PagingIEs_val_Value_13 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ExtendedUEIdentityIndexValue')))
    PagingIEs._val = ASN1Set(rv=[dict([('id', 117), ('criticality', 'reject'), ('Value', _PagingIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 127), ('criticality', 'reject'), ('Value', _PagingIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 114), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 115), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 113), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 216), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 580), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 581), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 582), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 583), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 620), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 622), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 623), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_12), ('presence', 'optional')]), dict([('id', 694), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_13), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PagingCell-list >-----#
    PagingCell_list = SEQ_OF(name='PagingCell-list', mode=MODE_TYPE)
    _PagingCell_list__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __PagingCell_list__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___PagingCell_list__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____PagingCell_list__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingCell-Item')))
    ___PagingCell_list__item__id_tab._val = ASN1Set(rv=[dict([('id', 112), ('criticality', 'ignore'), ('Value', ____PagingCell_list__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __PagingCell_list__item__id._const_tab = ___PagingCell_list__item__id_tab
    __PagingCell_list__item__id._const_tab_at = None
    __PagingCell_list__item__id._const_tab_id = 'id'
    __PagingCell_list__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __PagingCell_list__item__criticality._const_tab = ___PagingCell_list__item__id_tab
    __PagingCell_list__item__criticality._const_tab_at = ('..', 'id')
    __PagingCell_list__item__criticality._const_tab_id = 'criticality'
    __PagingCell_list__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __PagingCell_list__item__value._const_tab = ___PagingCell_list__item__id_tab
    __PagingCell_list__item__value._const_tab_at = ('..', 'id')
    __PagingCell_list__item__value._const_tab_id = 'Value'
    _PagingCell_list__item_._cont = ASN1Dict([
        ('id', __PagingCell_list__item__id),
        ('criticality', __PagingCell_list__item__criticality),
        ('value', __PagingCell_list__item__value),
        ])
    _PagingCell_list__item_._ext = None
    PagingCell_list._cont = _PagingCell_list__item_
    PagingCell_list._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< PagingCell-ItemIEs >-----#
    PagingCell_ItemIEs = CLASS(name='PagingCell-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PagingCell_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PagingCell-Item')))
    PagingCell_ItemIEs._val = ASN1Set(rv=[dict([('id', 112), ('criticality', 'ignore'), ('Value', _PagingCell_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Notify >-----#
    Notify = SEQ(name='Notify', mode=MODE_TYPE)
    _Notify_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __Notify_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___Notify_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____Notify_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____Notify_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____Notify_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____Notify_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRB-Notify-List')))
    ____Notify_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____Notify_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____Notify_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 137), ('criticality', 'reject'), ('Value', _____Notify_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___Notify_protocolIEs__item__id._const_tab = ____Notify_protocolIEs__item__id_tab
    ___Notify_protocolIEs__item__id._const_tab_at = None
    ___Notify_protocolIEs__item__id._const_tab_id = 'id'
    ___Notify_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___Notify_protocolIEs__item__criticality._const_tab = ____Notify_protocolIEs__item__id_tab
    ___Notify_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___Notify_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___Notify_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___Notify_protocolIEs__item__value._const_tab = ____Notify_protocolIEs__item__id_tab
    ___Notify_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___Notify_protocolIEs__item__value._const_tab_id = 'Value'
    __Notify_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___Notify_protocolIEs__item__id),
        ('criticality', ___Notify_protocolIEs__item__criticality),
        ('value', ___Notify_protocolIEs__item__value),
        ])
    __Notify_protocolIEs__item_._ext = None
    _Notify_protocolIEs._cont = __Notify_protocolIEs__item_
    _Notify_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    Notify._cont = ASN1Dict([
        ('protocolIEs', _Notify_protocolIEs),
        ])
    Notify._ext = []
    
    #-----< NotifyIEs >-----#
    NotifyIEs = CLASS(name='NotifyIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _NotifyIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _NotifyIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _NotifyIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DRB-Notify-List')))
    NotifyIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _NotifyIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _NotifyIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 137), ('criticality', 'reject'), ('Value', _NotifyIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DRB-Notify-List >-----#
    DRB_Notify_List = SEQ_OF(name='DRB-Notify-List', mode=MODE_TYPE)
    _DRB_Notify_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DRB_Notify_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___DRB_Notify_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DRB_Notify_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRB-Notify-Item')))
    ___DRB_Notify_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 136), ('criticality', 'reject'), ('Value', ____DRB_Notify_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __DRB_Notify_List__item__id._const_tab = ___DRB_Notify_List__item__id_tab
    __DRB_Notify_List__item__id._const_tab_at = None
    __DRB_Notify_List__item__id._const_tab_id = 'id'
    __DRB_Notify_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __DRB_Notify_List__item__criticality._const_tab = ___DRB_Notify_List__item__id_tab
    __DRB_Notify_List__item__criticality._const_tab_at = ('..', 'id')
    __DRB_Notify_List__item__criticality._const_tab_id = 'criticality'
    __DRB_Notify_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __DRB_Notify_List__item__value._const_tab = ___DRB_Notify_List__item__id_tab
    __DRB_Notify_List__item__value._const_tab_at = ('..', 'id')
    __DRB_Notify_List__item__value._const_tab_id = 'Value'
    _DRB_Notify_List__item_._cont = ASN1Dict([
        ('id', __DRB_Notify_List__item__id),
        ('criticality', __DRB_Notify_List__item__criticality),
        ('value', __DRB_Notify_List__item__value),
        ])
    _DRB_Notify_List__item_._ext = None
    DRB_Notify_List._cont = _DRB_Notify_List__item_
    DRB_Notify_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< DRB-Notify-ItemIEs >-----#
    DRB_Notify_ItemIEs = CLASS(name='DRB-Notify-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DRB_Notify_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DRB-Notify-Item')))
    DRB_Notify_ItemIEs._val = ASN1Set(rv=[dict([('id', 136), ('criticality', 'reject'), ('Value', _DRB_Notify_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< NetworkAccessRateReduction >-----#
    NetworkAccessRateReduction = SEQ(name='NetworkAccessRateReduction', mode=MODE_TYPE)
    _NetworkAccessRateReduction_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __NetworkAccessRateReduction_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___NetworkAccessRateReduction_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____NetworkAccessRateReduction_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____NetworkAccessRateReduction_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____NetworkAccessRateReduction_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UAC-Assistance-Info')))
    ____NetworkAccessRateReduction_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____NetworkAccessRateReduction_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 225), ('criticality', 'reject'), ('Value', _____NetworkAccessRateReduction_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___NetworkAccessRateReduction_protocolIEs__item__id._const_tab = ____NetworkAccessRateReduction_protocolIEs__item__id_tab
    ___NetworkAccessRateReduction_protocolIEs__item__id._const_tab_at = None
    ___NetworkAccessRateReduction_protocolIEs__item__id._const_tab_id = 'id'
    ___NetworkAccessRateReduction_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___NetworkAccessRateReduction_protocolIEs__item__criticality._const_tab = ____NetworkAccessRateReduction_protocolIEs__item__id_tab
    ___NetworkAccessRateReduction_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___NetworkAccessRateReduction_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___NetworkAccessRateReduction_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___NetworkAccessRateReduction_protocolIEs__item__value._const_tab = ____NetworkAccessRateReduction_protocolIEs__item__id_tab
    ___NetworkAccessRateReduction_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___NetworkAccessRateReduction_protocolIEs__item__value._const_tab_id = 'Value'
    __NetworkAccessRateReduction_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___NetworkAccessRateReduction_protocolIEs__item__id),
        ('criticality', ___NetworkAccessRateReduction_protocolIEs__item__criticality),
        ('value', ___NetworkAccessRateReduction_protocolIEs__item__value),
        ])
    __NetworkAccessRateReduction_protocolIEs__item_._ext = None
    _NetworkAccessRateReduction_protocolIEs._cont = __NetworkAccessRateReduction_protocolIEs__item_
    _NetworkAccessRateReduction_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    NetworkAccessRateReduction._cont = ASN1Dict([
        ('protocolIEs', _NetworkAccessRateReduction_protocolIEs),
        ])
    NetworkAccessRateReduction._ext = []
    
    #-----< NetworkAccessRateReductionIEs >-----#
    NetworkAccessRateReductionIEs = CLASS(name='NetworkAccessRateReductionIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _NetworkAccessRateReductionIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _NetworkAccessRateReductionIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UAC-Assistance-Info')))
    NetworkAccessRateReductionIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _NetworkAccessRateReductionIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 225), ('criticality', 'reject'), ('Value', _NetworkAccessRateReductionIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PWSRestartIndication >-----#
    PWSRestartIndication = SEQ(name='PWSRestartIndication', mode=MODE_TYPE)
    _PWSRestartIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PWSRestartIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PWSRestartIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PWSRestartIndication_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'NR-CGI-List-For-Restart-List')))
    ____PWSRestartIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 152), ('criticality', 'reject'), ('Value', _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___PWSRestartIndication_protocolIEs__item__id._const_tab = ____PWSRestartIndication_protocolIEs__item__id_tab
    ___PWSRestartIndication_protocolIEs__item__id._const_tab_at = None
    ___PWSRestartIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___PWSRestartIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PWSRestartIndication_protocolIEs__item__criticality._const_tab = ____PWSRestartIndication_protocolIEs__item__id_tab
    ___PWSRestartIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PWSRestartIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PWSRestartIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PWSRestartIndication_protocolIEs__item__value._const_tab = ____PWSRestartIndication_protocolIEs__item__id_tab
    ___PWSRestartIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PWSRestartIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __PWSRestartIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PWSRestartIndication_protocolIEs__item__id),
        ('criticality', ___PWSRestartIndication_protocolIEs__item__criticality),
        ('value', ___PWSRestartIndication_protocolIEs__item__value),
        ])
    __PWSRestartIndication_protocolIEs__item_._ext = None
    _PWSRestartIndication_protocolIEs._cont = __PWSRestartIndication_protocolIEs__item_
    _PWSRestartIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PWSRestartIndication._cont = ASN1Dict([
        ('protocolIEs', _PWSRestartIndication_protocolIEs),
        ])
    PWSRestartIndication._ext = []
    
    #-----< PWSRestartIndicationIEs >-----#
    PWSRestartIndicationIEs = CLASS(name='PWSRestartIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PWSRestartIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PWSRestartIndicationIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'NR-CGI-List-For-Restart-List')))
    PWSRestartIndicationIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _PWSRestartIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 152), ('criticality', 'reject'), ('Value', _PWSRestartIndicationIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< NR-CGI-List-For-Restart-List >-----#
    NR_CGI_List_For_Restart_List = SEQ_OF(name='NR-CGI-List-For-Restart-List', mode=MODE_TYPE)
    _NR_CGI_List_For_Restart_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __NR_CGI_List_For_Restart_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___NR_CGI_List_For_Restart_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____NR_CGI_List_For_Restart_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NR-CGI-List-For-Restart-Item')))
    ___NR_CGI_List_For_Restart_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 153), ('criticality', 'reject'), ('Value', ____NR_CGI_List_For_Restart_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __NR_CGI_List_For_Restart_List__item__id._const_tab = ___NR_CGI_List_For_Restart_List__item__id_tab
    __NR_CGI_List_For_Restart_List__item__id._const_tab_at = None
    __NR_CGI_List_For_Restart_List__item__id._const_tab_id = 'id'
    __NR_CGI_List_For_Restart_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __NR_CGI_List_For_Restart_List__item__criticality._const_tab = ___NR_CGI_List_For_Restart_List__item__id_tab
    __NR_CGI_List_For_Restart_List__item__criticality._const_tab_at = ('..', 'id')
    __NR_CGI_List_For_Restart_List__item__criticality._const_tab_id = 'criticality'
    __NR_CGI_List_For_Restart_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __NR_CGI_List_For_Restart_List__item__value._const_tab = ___NR_CGI_List_For_Restart_List__item__id_tab
    __NR_CGI_List_For_Restart_List__item__value._const_tab_at = ('..', 'id')
    __NR_CGI_List_For_Restart_List__item__value._const_tab_id = 'Value'
    _NR_CGI_List_For_Restart_List__item_._cont = ASN1Dict([
        ('id', __NR_CGI_List_For_Restart_List__item__id),
        ('criticality', __NR_CGI_List_For_Restart_List__item__criticality),
        ('value', __NR_CGI_List_For_Restart_List__item__value),
        ])
    _NR_CGI_List_For_Restart_List__item_._ext = None
    NR_CGI_List_For_Restart_List._cont = _NR_CGI_List_For_Restart_List__item_
    NR_CGI_List_For_Restart_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< NR-CGI-List-For-Restart-List-ItemIEs >-----#
    NR_CGI_List_For_Restart_List_ItemIEs = CLASS(name='NR-CGI-List-For-Restart-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _NR_CGI_List_For_Restart_List_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NR-CGI-List-For-Restart-Item')))
    NR_CGI_List_For_Restart_List_ItemIEs._val = ASN1Set(rv=[dict([('id', 153), ('criticality', 'reject'), ('Value', _NR_CGI_List_For_Restart_List_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PWSFailureIndication >-----#
    PWSFailureIndication = SEQ(name='PWSFailureIndication', mode=MODE_TYPE)
    _PWSFailureIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PWSFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PWSFailureIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PWSFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWS-Failed-NR-CGI-List')))
    ____PWSFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 154), ('criticality', 'reject'), ('Value', _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PWSFailureIndication_protocolIEs__item__id._const_tab = ____PWSFailureIndication_protocolIEs__item__id_tab
    ___PWSFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___PWSFailureIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___PWSFailureIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PWSFailureIndication_protocolIEs__item__criticality._const_tab = ____PWSFailureIndication_protocolIEs__item__id_tab
    ___PWSFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PWSFailureIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PWSFailureIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PWSFailureIndication_protocolIEs__item__value._const_tab = ____PWSFailureIndication_protocolIEs__item__id_tab
    ___PWSFailureIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PWSFailureIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __PWSFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PWSFailureIndication_protocolIEs__item__id),
        ('criticality', ___PWSFailureIndication_protocolIEs__item__criticality),
        ('value', ___PWSFailureIndication_protocolIEs__item__value),
        ])
    __PWSFailureIndication_protocolIEs__item_._ext = None
    _PWSFailureIndication_protocolIEs._cont = __PWSFailureIndication_protocolIEs__item_
    _PWSFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PWSFailureIndication._cont = ASN1Dict([
        ('protocolIEs', _PWSFailureIndication_protocolIEs),
        ])
    PWSFailureIndication._ext = []
    
    #-----< PWSFailureIndicationIEs >-----#
    PWSFailureIndicationIEs = CLASS(name='PWSFailureIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PWSFailureIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PWSFailureIndicationIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWS-Failed-NR-CGI-List')))
    PWSFailureIndicationIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _PWSFailureIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 154), ('criticality', 'reject'), ('Value', _PWSFailureIndicationIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PWS-Failed-NR-CGI-List >-----#
    PWS_Failed_NR_CGI_List = SEQ_OF(name='PWS-Failed-NR-CGI-List', mode=MODE_TYPE)
    _PWS_Failed_NR_CGI_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __PWS_Failed_NR_CGI_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___PWS_Failed_NR_CGI_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____PWS_Failed_NR_CGI_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PWS-Failed-NR-CGI-Item')))
    ___PWS_Failed_NR_CGI_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', ____PWS_Failed_NR_CGI_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __PWS_Failed_NR_CGI_List__item__id._const_tab = ___PWS_Failed_NR_CGI_List__item__id_tab
    __PWS_Failed_NR_CGI_List__item__id._const_tab_at = None
    __PWS_Failed_NR_CGI_List__item__id._const_tab_id = 'id'
    __PWS_Failed_NR_CGI_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __PWS_Failed_NR_CGI_List__item__criticality._const_tab = ___PWS_Failed_NR_CGI_List__item__id_tab
    __PWS_Failed_NR_CGI_List__item__criticality._const_tab_at = ('..', 'id')
    __PWS_Failed_NR_CGI_List__item__criticality._const_tab_id = 'criticality'
    __PWS_Failed_NR_CGI_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __PWS_Failed_NR_CGI_List__item__value._const_tab = ___PWS_Failed_NR_CGI_List__item__id_tab
    __PWS_Failed_NR_CGI_List__item__value._const_tab_at = ('..', 'id')
    __PWS_Failed_NR_CGI_List__item__value._const_tab_id = 'Value'
    _PWS_Failed_NR_CGI_List__item_._cont = ASN1Dict([
        ('id', __PWS_Failed_NR_CGI_List__item__id),
        ('criticality', __PWS_Failed_NR_CGI_List__item__criticality),
        ('value', __PWS_Failed_NR_CGI_List__item__value),
        ])
    _PWS_Failed_NR_CGI_List__item_._ext = None
    PWS_Failed_NR_CGI_List._cont = _PWS_Failed_NR_CGI_List__item_
    PWS_Failed_NR_CGI_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< PWS-Failed-NR-CGI-List-ItemIEs >-----#
    PWS_Failed_NR_CGI_List_ItemIEs = CLASS(name='PWS-Failed-NR-CGI-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PWS_Failed_NR_CGI_List_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PWS-Failed-NR-CGI-Item')))
    PWS_Failed_NR_CGI_List_ItemIEs._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'reject'), ('Value', _PWS_Failed_NR_CGI_List_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GNBDUStatusIndication >-----#
    GNBDUStatusIndication = SEQ(name='GNBDUStatusIndication', mode=MODE_TYPE)
    _GNBDUStatusIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __GNBDUStatusIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___GNBDUStatusIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____GNBDUStatusIndication_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____GNBDUStatusIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____GNBDUStatusIndication_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBDUOverloadInformation')))
    _____GNBDUStatusIndication_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IABCongestionIndication')))
    ____GNBDUStatusIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____GNBDUStatusIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 172), ('criticality', 'reject'), ('Value', _____GNBDUStatusIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 509), ('criticality', 'ignore'), ('Value', _____GNBDUStatusIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNBDUStatusIndication_protocolIEs__item__id._const_tab = ____GNBDUStatusIndication_protocolIEs__item__id_tab
    ___GNBDUStatusIndication_protocolIEs__item__id._const_tab_at = None
    ___GNBDUStatusIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___GNBDUStatusIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___GNBDUStatusIndication_protocolIEs__item__criticality._const_tab = ____GNBDUStatusIndication_protocolIEs__item__id_tab
    ___GNBDUStatusIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNBDUStatusIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNBDUStatusIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___GNBDUStatusIndication_protocolIEs__item__value._const_tab = ____GNBDUStatusIndication_protocolIEs__item__id_tab
    ___GNBDUStatusIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNBDUStatusIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __GNBDUStatusIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNBDUStatusIndication_protocolIEs__item__id),
        ('criticality', ___GNBDUStatusIndication_protocolIEs__item__criticality),
        ('value', ___GNBDUStatusIndication_protocolIEs__item__value),
        ])
    __GNBDUStatusIndication_protocolIEs__item_._ext = None
    _GNBDUStatusIndication_protocolIEs._cont = __GNBDUStatusIndication_protocolIEs__item_
    _GNBDUStatusIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNBDUStatusIndication._cont = ASN1Dict([
        ('protocolIEs', _GNBDUStatusIndication_protocolIEs),
        ])
    GNBDUStatusIndication._ext = []
    
    #-----< GNBDUStatusIndicationIEs >-----#
    GNBDUStatusIndicationIEs = CLASS(name='GNBDUStatusIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNBDUStatusIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _GNBDUStatusIndicationIEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBDUOverloadInformation')))
    _GNBDUStatusIndicationIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IABCongestionIndication')))
    GNBDUStatusIndicationIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _GNBDUStatusIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 172), ('criticality', 'reject'), ('Value', _GNBDUStatusIndicationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 509), ('criticality', 'ignore'), ('Value', _GNBDUStatusIndicationIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RRCDeliveryReport >-----#
    RRCDeliveryReport = SEQ(name='RRCDeliveryReport', mode=MODE_TYPE)
    _RRCDeliveryReport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __RRCDeliveryReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___RRCDeliveryReport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____RRCDeliveryReport_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____RRCDeliveryReport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____RRCDeliveryReport_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____RRCDeliveryReport_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCDeliveryStatus')))
    _____RRCDeliveryReport_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    ____RRCDeliveryReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____RRCDeliveryReport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____RRCDeliveryReport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 185), ('criticality', 'ignore'), ('Value', _____RRCDeliveryReport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 64), ('criticality', 'ignore'), ('Value', _____RRCDeliveryReport_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RRCDeliveryReport_protocolIEs__item__id._const_tab = ____RRCDeliveryReport_protocolIEs__item__id_tab
    ___RRCDeliveryReport_protocolIEs__item__id._const_tab_at = None
    ___RRCDeliveryReport_protocolIEs__item__id._const_tab_id = 'id'
    ___RRCDeliveryReport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___RRCDeliveryReport_protocolIEs__item__criticality._const_tab = ____RRCDeliveryReport_protocolIEs__item__id_tab
    ___RRCDeliveryReport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RRCDeliveryReport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RRCDeliveryReport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___RRCDeliveryReport_protocolIEs__item__value._const_tab = ____RRCDeliveryReport_protocolIEs__item__id_tab
    ___RRCDeliveryReport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RRCDeliveryReport_protocolIEs__item__value._const_tab_id = 'Value'
    __RRCDeliveryReport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RRCDeliveryReport_protocolIEs__item__id),
        ('criticality', ___RRCDeliveryReport_protocolIEs__item__criticality),
        ('value', ___RRCDeliveryReport_protocolIEs__item__value),
        ])
    __RRCDeliveryReport_protocolIEs__item_._ext = None
    _RRCDeliveryReport_protocolIEs._cont = __RRCDeliveryReport_protocolIEs__item_
    _RRCDeliveryReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RRCDeliveryReport._cont = ASN1Dict([
        ('protocolIEs', _RRCDeliveryReport_protocolIEs),
        ])
    RRCDeliveryReport._ext = []
    
    #-----< RRCDeliveryReportIEs >-----#
    RRCDeliveryReportIEs = CLASS(name='RRCDeliveryReportIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _RRCDeliveryReportIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _RRCDeliveryReportIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _RRCDeliveryReportIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RRCDeliveryStatus')))
    _RRCDeliveryReportIEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRBID')))
    RRCDeliveryReportIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _RRCDeliveryReportIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _RRCDeliveryReportIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 185), ('criticality', 'ignore'), ('Value', _RRCDeliveryReportIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 64), ('criticality', 'ignore'), ('Value', _RRCDeliveryReportIEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< F1RemovalRequest >-----#
    F1RemovalRequest = SEQ(name='F1RemovalRequest', mode=MODE_TYPE)
    _F1RemovalRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __F1RemovalRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___F1RemovalRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____F1RemovalRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____F1RemovalRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    ____F1RemovalRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____F1RemovalRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___F1RemovalRequest_protocolIEs__item__id._const_tab = ____F1RemovalRequest_protocolIEs__item__id_tab
    ___F1RemovalRequest_protocolIEs__item__id._const_tab_at = None
    ___F1RemovalRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___F1RemovalRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___F1RemovalRequest_protocolIEs__item__criticality._const_tab = ____F1RemovalRequest_protocolIEs__item__id_tab
    ___F1RemovalRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___F1RemovalRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___F1RemovalRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___F1RemovalRequest_protocolIEs__item__value._const_tab = ____F1RemovalRequest_protocolIEs__item__id_tab
    ___F1RemovalRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___F1RemovalRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __F1RemovalRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___F1RemovalRequest_protocolIEs__item__id),
        ('criticality', ___F1RemovalRequest_protocolIEs__item__criticality),
        ('value', ___F1RemovalRequest_protocolIEs__item__value),
        ])
    __F1RemovalRequest_protocolIEs__item_._ext = None
    _F1RemovalRequest_protocolIEs._cont = __F1RemovalRequest_protocolIEs__item_
    _F1RemovalRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    F1RemovalRequest._cont = ASN1Dict([
        ('protocolIEs', _F1RemovalRequest_protocolIEs),
        ])
    F1RemovalRequest._ext = []
    
    #-----< F1RemovalRequestIEs >-----#
    F1RemovalRequestIEs = CLASS(name='F1RemovalRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _F1RemovalRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    F1RemovalRequestIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _F1RemovalRequestIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< F1RemovalResponse >-----#
    F1RemovalResponse = SEQ(name='F1RemovalResponse', mode=MODE_TYPE)
    _F1RemovalResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __F1RemovalResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___F1RemovalResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____F1RemovalResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____F1RemovalResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____F1RemovalResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____F1RemovalResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____F1RemovalResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____F1RemovalResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___F1RemovalResponse_protocolIEs__item__id._const_tab = ____F1RemovalResponse_protocolIEs__item__id_tab
    ___F1RemovalResponse_protocolIEs__item__id._const_tab_at = None
    ___F1RemovalResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___F1RemovalResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___F1RemovalResponse_protocolIEs__item__criticality._const_tab = ____F1RemovalResponse_protocolIEs__item__id_tab
    ___F1RemovalResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___F1RemovalResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___F1RemovalResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___F1RemovalResponse_protocolIEs__item__value._const_tab = ____F1RemovalResponse_protocolIEs__item__id_tab
    ___F1RemovalResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___F1RemovalResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __F1RemovalResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___F1RemovalResponse_protocolIEs__item__id),
        ('criticality', ___F1RemovalResponse_protocolIEs__item__criticality),
        ('value', ___F1RemovalResponse_protocolIEs__item__value),
        ])
    __F1RemovalResponse_protocolIEs__item_._ext = None
    _F1RemovalResponse_protocolIEs._cont = __F1RemovalResponse_protocolIEs__item_
    _F1RemovalResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    F1RemovalResponse._cont = ASN1Dict([
        ('protocolIEs', _F1RemovalResponse_protocolIEs),
        ])
    F1RemovalResponse._ext = []
    
    #-----< F1RemovalResponseIEs >-----#
    F1RemovalResponseIEs = CLASS(name='F1RemovalResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _F1RemovalResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _F1RemovalResponseIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    F1RemovalResponseIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _F1RemovalResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _F1RemovalResponseIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< F1RemovalFailure >-----#
    F1RemovalFailure = SEQ(name='F1RemovalFailure', mode=MODE_TYPE)
    _F1RemovalFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __F1RemovalFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___F1RemovalFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____F1RemovalFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____F1RemovalFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____F1RemovalFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____F1RemovalFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____F1RemovalFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____F1RemovalFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____F1RemovalFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____F1RemovalFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___F1RemovalFailure_protocolIEs__item__id._const_tab = ____F1RemovalFailure_protocolIEs__item__id_tab
    ___F1RemovalFailure_protocolIEs__item__id._const_tab_at = None
    ___F1RemovalFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___F1RemovalFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___F1RemovalFailure_protocolIEs__item__criticality._const_tab = ____F1RemovalFailure_protocolIEs__item__id_tab
    ___F1RemovalFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___F1RemovalFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___F1RemovalFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___F1RemovalFailure_protocolIEs__item__value._const_tab = ____F1RemovalFailure_protocolIEs__item__id_tab
    ___F1RemovalFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___F1RemovalFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __F1RemovalFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___F1RemovalFailure_protocolIEs__item__id),
        ('criticality', ___F1RemovalFailure_protocolIEs__item__criticality),
        ('value', ___F1RemovalFailure_protocolIEs__item__value),
        ])
    __F1RemovalFailure_protocolIEs__item_._ext = None
    _F1RemovalFailure_protocolIEs._cont = __F1RemovalFailure_protocolIEs__item_
    _F1RemovalFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    F1RemovalFailure._cont = ASN1Dict([
        ('protocolIEs', _F1RemovalFailure_protocolIEs),
        ])
    F1RemovalFailure._ext = []
    
    #-----< F1RemovalFailureIEs >-----#
    F1RemovalFailureIEs = CLASS(name='F1RemovalFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _F1RemovalFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _F1RemovalFailureIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _F1RemovalFailureIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    F1RemovalFailureIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _F1RemovalFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _F1RemovalFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _F1RemovalFailureIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TraceStart >-----#
    TraceStart = SEQ(name='TraceStart', mode=MODE_TYPE)
    _TraceStart_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __TraceStart_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___TraceStart_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____TraceStart_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____TraceStart_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____TraceStart_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____TraceStart_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TraceActivation')))
    ____TraceStart_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____TraceStart_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____TraceStart_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 242), ('criticality', 'ignore'), ('Value', _____TraceStart_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___TraceStart_protocolIEs__item__id._const_tab = ____TraceStart_protocolIEs__item__id_tab
    ___TraceStart_protocolIEs__item__id._const_tab_at = None
    ___TraceStart_protocolIEs__item__id._const_tab_id = 'id'
    ___TraceStart_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___TraceStart_protocolIEs__item__criticality._const_tab = ____TraceStart_protocolIEs__item__id_tab
    ___TraceStart_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___TraceStart_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___TraceStart_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___TraceStart_protocolIEs__item__value._const_tab = ____TraceStart_protocolIEs__item__id_tab
    ___TraceStart_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___TraceStart_protocolIEs__item__value._const_tab_id = 'Value'
    __TraceStart_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___TraceStart_protocolIEs__item__id),
        ('criticality', ___TraceStart_protocolIEs__item__criticality),
        ('value', ___TraceStart_protocolIEs__item__value),
        ])
    __TraceStart_protocolIEs__item_._ext = None
    _TraceStart_protocolIEs._cont = __TraceStart_protocolIEs__item_
    _TraceStart_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TraceStart._cont = ASN1Dict([
        ('protocolIEs', _TraceStart_protocolIEs),
        ])
    TraceStart._ext = []
    
    #-----< TraceStartIEs >-----#
    TraceStartIEs = CLASS(name='TraceStartIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _TraceStartIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _TraceStartIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _TraceStartIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TraceActivation')))
    TraceStartIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _TraceStartIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _TraceStartIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 242), ('criticality', 'ignore'), ('Value', _TraceStartIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DeactivateTrace >-----#
    DeactivateTrace = SEQ(name='DeactivateTrace', mode=MODE_TYPE)
    _DeactivateTrace_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __DeactivateTrace_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___DeactivateTrace_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____DeactivateTrace_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TraceID')))
    ____DeactivateTrace_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 243), ('criticality', 'ignore'), ('Value', _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___DeactivateTrace_protocolIEs__item__id._const_tab = ____DeactivateTrace_protocolIEs__item__id_tab
    ___DeactivateTrace_protocolIEs__item__id._const_tab_at = None
    ___DeactivateTrace_protocolIEs__item__id._const_tab_id = 'id'
    ___DeactivateTrace_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___DeactivateTrace_protocolIEs__item__criticality._const_tab = ____DeactivateTrace_protocolIEs__item__id_tab
    ___DeactivateTrace_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DeactivateTrace_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DeactivateTrace_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___DeactivateTrace_protocolIEs__item__value._const_tab = ____DeactivateTrace_protocolIEs__item__id_tab
    ___DeactivateTrace_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DeactivateTrace_protocolIEs__item__value._const_tab_id = 'Value'
    __DeactivateTrace_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DeactivateTrace_protocolIEs__item__id),
        ('criticality', ___DeactivateTrace_protocolIEs__item__criticality),
        ('value', ___DeactivateTrace_protocolIEs__item__value),
        ])
    __DeactivateTrace_protocolIEs__item_._ext = None
    _DeactivateTrace_protocolIEs._cont = __DeactivateTrace_protocolIEs__item_
    _DeactivateTrace_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DeactivateTrace._cont = ASN1Dict([
        ('protocolIEs', _DeactivateTrace_protocolIEs),
        ])
    DeactivateTrace._ext = []
    
    #-----< DeactivateTraceIEs >-----#
    DeactivateTraceIEs = CLASS(name='DeactivateTraceIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DeactivateTraceIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _DeactivateTraceIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _DeactivateTraceIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TraceID')))
    DeactivateTraceIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _DeactivateTraceIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _DeactivateTraceIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 243), ('criticality', 'ignore'), ('Value', _DeactivateTraceIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CellTrafficTrace >-----#
    CellTrafficTrace = SEQ(name='CellTrafficTrace', mode=MODE_TYPE)
    _CellTrafficTrace_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __CellTrafficTrace_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___CellTrafficTrace_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____CellTrafficTrace_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TraceID')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PrivacyIndicator')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_5 = STR_VIS(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'URI-address')))
    ____CellTrafficTrace_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 243), ('criticality', 'ignore'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 378), ('criticality', 'ignore'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 379), ('criticality', 'ignore'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 380), ('criticality', 'ignore'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellTrafficTrace_protocolIEs__item__id._const_tab = ____CellTrafficTrace_protocolIEs__item__id_tab
    ___CellTrafficTrace_protocolIEs__item__id._const_tab_at = None
    ___CellTrafficTrace_protocolIEs__item__id._const_tab_id = 'id'
    ___CellTrafficTrace_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___CellTrafficTrace_protocolIEs__item__criticality._const_tab = ____CellTrafficTrace_protocolIEs__item__id_tab
    ___CellTrafficTrace_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellTrafficTrace_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellTrafficTrace_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___CellTrafficTrace_protocolIEs__item__value._const_tab = ____CellTrafficTrace_protocolIEs__item__id_tab
    ___CellTrafficTrace_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellTrafficTrace_protocolIEs__item__value._const_tab_id = 'Value'
    __CellTrafficTrace_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellTrafficTrace_protocolIEs__item__id),
        ('criticality', ___CellTrafficTrace_protocolIEs__item__criticality),
        ('value', ___CellTrafficTrace_protocolIEs__item__value),
        ])
    __CellTrafficTrace_protocolIEs__item_._ext = None
    _CellTrafficTrace_protocolIEs._cont = __CellTrafficTrace_protocolIEs__item_
    _CellTrafficTrace_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    CellTrafficTrace._cont = ASN1Dict([
        ('protocolIEs', _CellTrafficTrace_protocolIEs),
        ])
    CellTrafficTrace._ext = []
    
    #-----< CellTrafficTraceIEs >-----#
    CellTrafficTraceIEs = CLASS(name='CellTrafficTraceIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _CellTrafficTraceIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _CellTrafficTraceIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _CellTrafficTraceIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TraceID')))
    _CellTrafficTraceIEs_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransportLayerAddress')))
    _CellTrafficTraceIEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PrivacyIndicator')))
    _CellTrafficTraceIEs_val_Value_5 = STR_VIS(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'URI-address')))
    CellTrafficTraceIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _CellTrafficTraceIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _CellTrafficTraceIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 243), ('criticality', 'ignore'), ('Value', _CellTrafficTraceIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 378), ('criticality', 'ignore'), ('Value', _CellTrafficTraceIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 379), ('criticality', 'ignore'), ('Value', _CellTrafficTraceIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 380), ('criticality', 'ignore'), ('Value', _CellTrafficTraceIEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DUCURadioInformationTransfer >-----#
    DUCURadioInformationTransfer = SEQ(name='DUCURadioInformationTransfer', mode=MODE_TYPE)
    _DUCURadioInformationTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __DUCURadioInformationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___DUCURadioInformationTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____DUCURadioInformationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____DUCURadioInformationTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____DUCURadioInformationTransfer_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DUCURadioInformationType')))
    ____DUCURadioInformationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____DUCURadioInformationTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 249), ('criticality', 'ignore'), ('Value', _____DUCURadioInformationTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___DUCURadioInformationTransfer_protocolIEs__item__id._const_tab = ____DUCURadioInformationTransfer_protocolIEs__item__id_tab
    ___DUCURadioInformationTransfer_protocolIEs__item__id._const_tab_at = None
    ___DUCURadioInformationTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___DUCURadioInformationTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___DUCURadioInformationTransfer_protocolIEs__item__criticality._const_tab = ____DUCURadioInformationTransfer_protocolIEs__item__id_tab
    ___DUCURadioInformationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DUCURadioInformationTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DUCURadioInformationTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___DUCURadioInformationTransfer_protocolIEs__item__value._const_tab = ____DUCURadioInformationTransfer_protocolIEs__item__id_tab
    ___DUCURadioInformationTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DUCURadioInformationTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __DUCURadioInformationTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DUCURadioInformationTransfer_protocolIEs__item__id),
        ('criticality', ___DUCURadioInformationTransfer_protocolIEs__item__criticality),
        ('value', ___DUCURadioInformationTransfer_protocolIEs__item__value),
        ])
    __DUCURadioInformationTransfer_protocolIEs__item_._ext = None
    _DUCURadioInformationTransfer_protocolIEs._cont = __DUCURadioInformationTransfer_protocolIEs__item_
    _DUCURadioInformationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DUCURadioInformationTransfer._cont = ASN1Dict([
        ('protocolIEs', _DUCURadioInformationTransfer_protocolIEs),
        ])
    DUCURadioInformationTransfer._ext = []
    
    #-----< DUCURadioInformationTransferIEs >-----#
    DUCURadioInformationTransferIEs = CLASS(name='DUCURadioInformationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DUCURadioInformationTransferIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _DUCURadioInformationTransferIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DUCURadioInformationType')))
    DUCURadioInformationTransferIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _DUCURadioInformationTransferIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 249), ('criticality', 'ignore'), ('Value', _DUCURadioInformationTransferIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CUDURadioInformationTransfer >-----#
    CUDURadioInformationTransfer = SEQ(name='CUDURadioInformationTransfer', mode=MODE_TYPE)
    _CUDURadioInformationTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __CUDURadioInformationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___CUDURadioInformationTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____CUDURadioInformationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____CUDURadioInformationTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____CUDURadioInformationTransfer_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CUDURadioInformationType')))
    ____CUDURadioInformationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____CUDURadioInformationTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 250), ('criticality', 'ignore'), ('Value', _____CUDURadioInformationTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___CUDURadioInformationTransfer_protocolIEs__item__id._const_tab = ____CUDURadioInformationTransfer_protocolIEs__item__id_tab
    ___CUDURadioInformationTransfer_protocolIEs__item__id._const_tab_at = None
    ___CUDURadioInformationTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___CUDURadioInformationTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___CUDURadioInformationTransfer_protocolIEs__item__criticality._const_tab = ____CUDURadioInformationTransfer_protocolIEs__item__id_tab
    ___CUDURadioInformationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CUDURadioInformationTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CUDURadioInformationTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___CUDURadioInformationTransfer_protocolIEs__item__value._const_tab = ____CUDURadioInformationTransfer_protocolIEs__item__id_tab
    ___CUDURadioInformationTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CUDURadioInformationTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __CUDURadioInformationTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CUDURadioInformationTransfer_protocolIEs__item__id),
        ('criticality', ___CUDURadioInformationTransfer_protocolIEs__item__criticality),
        ('value', ___CUDURadioInformationTransfer_protocolIEs__item__value),
        ])
    __CUDURadioInformationTransfer_protocolIEs__item_._ext = None
    _CUDURadioInformationTransfer_protocolIEs._cont = __CUDURadioInformationTransfer_protocolIEs__item_
    _CUDURadioInformationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    CUDURadioInformationTransfer._cont = ASN1Dict([
        ('protocolIEs', _CUDURadioInformationTransfer_protocolIEs),
        ])
    CUDURadioInformationTransfer._ext = []
    
    #-----< CUDURadioInformationTransferIEs >-----#
    CUDURadioInformationTransferIEs = CLASS(name='CUDURadioInformationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _CUDURadioInformationTransferIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _CUDURadioInformationTransferIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CUDURadioInformationType')))
    CUDURadioInformationTransferIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _CUDURadioInformationTransferIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 250), ('criticality', 'ignore'), ('Value', _CUDURadioInformationTransferIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BAPMappingConfiguration >-----#
    BAPMappingConfiguration = SEQ(name='BAPMappingConfiguration', mode=MODE_TYPE)
    _BAPMappingConfiguration_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __BAPMappingConfiguration_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___BAPMappingConfiguration_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____BAPMappingConfiguration_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BH-Routing-Information-Added-List')))
    _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BH-Routing-Information-Removed-List')))
    _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TrafficMappingInfo')))
    _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BufferSizeThresh')))
    _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAP-Header-Rewriting-Added-List')))
    _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Re-routingEnableIndicator')))
    _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAP-Header-Rewriting-Removed-List')))
    ____BAPMappingConfiguration_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 283), ('criticality', 'ignore'), ('Value', _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 285), ('criticality', 'ignore'), ('Value', _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 299), ('criticality', 'ignore'), ('Value', _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 512), ('criticality', 'ignore'), ('Value', _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 514), ('criticality', 'ignore'), ('Value', _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 516), ('criticality', 'ignore'), ('Value', _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 641), ('criticality', 'ignore'), ('Value', _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BAPMappingConfiguration_protocolIEs__item__id._const_tab = ____BAPMappingConfiguration_protocolIEs__item__id_tab
    ___BAPMappingConfiguration_protocolIEs__item__id._const_tab_at = None
    ___BAPMappingConfiguration_protocolIEs__item__id._const_tab_id = 'id'
    ___BAPMappingConfiguration_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___BAPMappingConfiguration_protocolIEs__item__criticality._const_tab = ____BAPMappingConfiguration_protocolIEs__item__id_tab
    ___BAPMappingConfiguration_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BAPMappingConfiguration_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BAPMappingConfiguration_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___BAPMappingConfiguration_protocolIEs__item__value._const_tab = ____BAPMappingConfiguration_protocolIEs__item__id_tab
    ___BAPMappingConfiguration_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BAPMappingConfiguration_protocolIEs__item__value._const_tab_id = 'Value'
    __BAPMappingConfiguration_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BAPMappingConfiguration_protocolIEs__item__id),
        ('criticality', ___BAPMappingConfiguration_protocolIEs__item__criticality),
        ('value', ___BAPMappingConfiguration_protocolIEs__item__value),
        ])
    __BAPMappingConfiguration_protocolIEs__item_._ext = None
    _BAPMappingConfiguration_protocolIEs._cont = __BAPMappingConfiguration_protocolIEs__item_
    _BAPMappingConfiguration_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BAPMappingConfiguration._cont = ASN1Dict([
        ('protocolIEs', _BAPMappingConfiguration_protocolIEs),
        ])
    BAPMappingConfiguration._ext = []
    
    #-----< BAPMappingConfiguration-IEs >-----#
    BAPMappingConfiguration_IEs = CLASS(name='BAPMappingConfiguration-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BAPMappingConfiguration_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _BAPMappingConfiguration_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BH-Routing-Information-Added-List')))
    _BAPMappingConfiguration_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BH-Routing-Information-Removed-List')))
    _BAPMappingConfiguration_IEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TrafficMappingInfo')))
    _BAPMappingConfiguration_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BufferSizeThresh')))
    _BAPMappingConfiguration_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAP-Header-Rewriting-Added-List')))
    _BAPMappingConfiguration_IEs_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Re-routingEnableIndicator')))
    _BAPMappingConfiguration_IEs_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAP-Header-Rewriting-Removed-List')))
    BAPMappingConfiguration_IEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _BAPMappingConfiguration_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 283), ('criticality', 'ignore'), ('Value', _BAPMappingConfiguration_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 285), ('criticality', 'ignore'), ('Value', _BAPMappingConfiguration_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 299), ('criticality', 'ignore'), ('Value', _BAPMappingConfiguration_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 512), ('criticality', 'ignore'), ('Value', _BAPMappingConfiguration_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 514), ('criticality', 'ignore'), ('Value', _BAPMappingConfiguration_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 516), ('criticality', 'ignore'), ('Value', _BAPMappingConfiguration_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 641), ('criticality', 'ignore'), ('Value', _BAPMappingConfiguration_IEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BH-Routing-Information-Added-List >-----#
    BH_Routing_Information_Added_List = SEQ_OF(name='BH-Routing-Information-Added-List', mode=MODE_TYPE)
    _BH_Routing_Information_Added_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BH_Routing_Information_Added_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BH_Routing_Information_Added_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BH_Routing_Information_Added_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BH-Routing-Information-Added-List-Item')))
    ___BH_Routing_Information_Added_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 284), ('criticality', 'ignore'), ('Value', ____BH_Routing_Information_Added_List__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    __BH_Routing_Information_Added_List__item__id._const_tab = ___BH_Routing_Information_Added_List__item__id_tab
    __BH_Routing_Information_Added_List__item__id._const_tab_at = None
    __BH_Routing_Information_Added_List__item__id._const_tab_id = 'id'
    __BH_Routing_Information_Added_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __BH_Routing_Information_Added_List__item__criticality._const_tab = ___BH_Routing_Information_Added_List__item__id_tab
    __BH_Routing_Information_Added_List__item__criticality._const_tab_at = ('..', 'id')
    __BH_Routing_Information_Added_List__item__criticality._const_tab_id = 'criticality'
    __BH_Routing_Information_Added_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __BH_Routing_Information_Added_List__item__value._const_tab = ___BH_Routing_Information_Added_List__item__id_tab
    __BH_Routing_Information_Added_List__item__value._const_tab_at = ('..', 'id')
    __BH_Routing_Information_Added_List__item__value._const_tab_id = 'Value'
    _BH_Routing_Information_Added_List__item_._cont = ASN1Dict([
        ('id', __BH_Routing_Information_Added_List__item__id),
        ('criticality', __BH_Routing_Information_Added_List__item__criticality),
        ('value', __BH_Routing_Information_Added_List__item__value),
        ])
    _BH_Routing_Information_Added_List__item_._ext = None
    BH_Routing_Information_Added_List._cont = _BH_Routing_Information_Added_List__item_
    BH_Routing_Information_Added_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< BH-Routing-Information-Removed-List >-----#
    BH_Routing_Information_Removed_List = SEQ_OF(name='BH-Routing-Information-Removed-List', mode=MODE_TYPE)
    _BH_Routing_Information_Removed_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BH_Routing_Information_Removed_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BH_Routing_Information_Removed_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BH_Routing_Information_Removed_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BH-Routing-Information-Removed-List-Item')))
    ___BH_Routing_Information_Removed_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 286), ('criticality', 'ignore'), ('Value', ____BH_Routing_Information_Removed_List__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    __BH_Routing_Information_Removed_List__item__id._const_tab = ___BH_Routing_Information_Removed_List__item__id_tab
    __BH_Routing_Information_Removed_List__item__id._const_tab_at = None
    __BH_Routing_Information_Removed_List__item__id._const_tab_id = 'id'
    __BH_Routing_Information_Removed_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __BH_Routing_Information_Removed_List__item__criticality._const_tab = ___BH_Routing_Information_Removed_List__item__id_tab
    __BH_Routing_Information_Removed_List__item__criticality._const_tab_at = ('..', 'id')
    __BH_Routing_Information_Removed_List__item__criticality._const_tab_id = 'criticality'
    __BH_Routing_Information_Removed_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __BH_Routing_Information_Removed_List__item__value._const_tab = ___BH_Routing_Information_Removed_List__item__id_tab
    __BH_Routing_Information_Removed_List__item__value._const_tab_at = ('..', 'id')
    __BH_Routing_Information_Removed_List__item__value._const_tab_id = 'Value'
    _BH_Routing_Information_Removed_List__item_._cont = ASN1Dict([
        ('id', __BH_Routing_Information_Removed_List__item__id),
        ('criticality', __BH_Routing_Information_Removed_List__item__criticality),
        ('value', __BH_Routing_Information_Removed_List__item__value),
        ])
    _BH_Routing_Information_Removed_List__item_._ext = None
    BH_Routing_Information_Removed_List._cont = _BH_Routing_Information_Removed_List__item_
    BH_Routing_Information_Removed_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< BH-Routing-Information-Added-List-ItemIEs >-----#
    BH_Routing_Information_Added_List_ItemIEs = CLASS(name='BH-Routing-Information-Added-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BH_Routing_Information_Added_List_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BH-Routing-Information-Added-List-Item')))
    BH_Routing_Information_Added_List_ItemIEs._val = ASN1Set(rv=[dict([('id', 284), ('criticality', 'ignore'), ('Value', _BH_Routing_Information_Added_List_ItemIEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BH-Routing-Information-Removed-List-ItemIEs >-----#
    BH_Routing_Information_Removed_List_ItemIEs = CLASS(name='BH-Routing-Information-Removed-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BH_Routing_Information_Removed_List_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BH-Routing-Information-Removed-List-Item')))
    BH_Routing_Information_Removed_List_ItemIEs._val = ASN1Set(rv=[dict([('id', 286), ('criticality', 'ignore'), ('Value', _BH_Routing_Information_Removed_List_ItemIEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BAP-Header-Rewriting-Added-List >-----#
    BAP_Header_Rewriting_Added_List = SEQ_OF(name='BAP-Header-Rewriting-Added-List', mode=MODE_TYPE)
    _BAP_Header_Rewriting_Added_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BAP_Header_Rewriting_Added_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BAP_Header_Rewriting_Added_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BAP_Header_Rewriting_Added_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAP-Header-Rewriting-Added-List-Item')))
    ___BAP_Header_Rewriting_Added_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 515), ('criticality', 'ignore'), ('Value', ____BAP_Header_Rewriting_Added_List__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    __BAP_Header_Rewriting_Added_List__item__id._const_tab = ___BAP_Header_Rewriting_Added_List__item__id_tab
    __BAP_Header_Rewriting_Added_List__item__id._const_tab_at = None
    __BAP_Header_Rewriting_Added_List__item__id._const_tab_id = 'id'
    __BAP_Header_Rewriting_Added_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __BAP_Header_Rewriting_Added_List__item__criticality._const_tab = ___BAP_Header_Rewriting_Added_List__item__id_tab
    __BAP_Header_Rewriting_Added_List__item__criticality._const_tab_at = ('..', 'id')
    __BAP_Header_Rewriting_Added_List__item__criticality._const_tab_id = 'criticality'
    __BAP_Header_Rewriting_Added_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __BAP_Header_Rewriting_Added_List__item__value._const_tab = ___BAP_Header_Rewriting_Added_List__item__id_tab
    __BAP_Header_Rewriting_Added_List__item__value._const_tab_at = ('..', 'id')
    __BAP_Header_Rewriting_Added_List__item__value._const_tab_id = 'Value'
    _BAP_Header_Rewriting_Added_List__item_._cont = ASN1Dict([
        ('id', __BAP_Header_Rewriting_Added_List__item__id),
        ('criticality', __BAP_Header_Rewriting_Added_List__item__criticality),
        ('value', __BAP_Header_Rewriting_Added_List__item__value),
        ])
    _BAP_Header_Rewriting_Added_List__item_._ext = None
    BAP_Header_Rewriting_Added_List._cont = _BAP_Header_Rewriting_Added_List__item_
    BAP_Header_Rewriting_Added_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< BAP-Header-Rewriting-Added-List-ItemIEs >-----#
    BAP_Header_Rewriting_Added_List_ItemIEs = CLASS(name='BAP-Header-Rewriting-Added-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BAP_Header_Rewriting_Added_List_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAP-Header-Rewriting-Added-List-Item')))
    BAP_Header_Rewriting_Added_List_ItemIEs._val = ASN1Set(rv=[dict([('id', 515), ('criticality', 'ignore'), ('Value', _BAP_Header_Rewriting_Added_List_ItemIEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BAP-Header-Rewriting-Removed-List >-----#
    BAP_Header_Rewriting_Removed_List = SEQ_OF(name='BAP-Header-Rewriting-Removed-List', mode=MODE_TYPE)
    _BAP_Header_Rewriting_Removed_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BAP_Header_Rewriting_Removed_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BAP_Header_Rewriting_Removed_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BAP_Header_Rewriting_Removed_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAP-Header-Rewriting-Removed-List-Item')))
    ___BAP_Header_Rewriting_Removed_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 642), ('criticality', 'ignore'), ('Value', ____BAP_Header_Rewriting_Removed_List__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    __BAP_Header_Rewriting_Removed_List__item__id._const_tab = ___BAP_Header_Rewriting_Removed_List__item__id_tab
    __BAP_Header_Rewriting_Removed_List__item__id._const_tab_at = None
    __BAP_Header_Rewriting_Removed_List__item__id._const_tab_id = 'id'
    __BAP_Header_Rewriting_Removed_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __BAP_Header_Rewriting_Removed_List__item__criticality._const_tab = ___BAP_Header_Rewriting_Removed_List__item__id_tab
    __BAP_Header_Rewriting_Removed_List__item__criticality._const_tab_at = ('..', 'id')
    __BAP_Header_Rewriting_Removed_List__item__criticality._const_tab_id = 'criticality'
    __BAP_Header_Rewriting_Removed_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __BAP_Header_Rewriting_Removed_List__item__value._const_tab = ___BAP_Header_Rewriting_Removed_List__item__id_tab
    __BAP_Header_Rewriting_Removed_List__item__value._const_tab_at = ('..', 'id')
    __BAP_Header_Rewriting_Removed_List__item__value._const_tab_id = 'Value'
    _BAP_Header_Rewriting_Removed_List__item_._cont = ASN1Dict([
        ('id', __BAP_Header_Rewriting_Removed_List__item__id),
        ('criticality', __BAP_Header_Rewriting_Removed_List__item__criticality),
        ('value', __BAP_Header_Rewriting_Removed_List__item__value),
        ])
    _BAP_Header_Rewriting_Removed_List__item_._ext = None
    BAP_Header_Rewriting_Removed_List._cont = _BAP_Header_Rewriting_Removed_List__item_
    BAP_Header_Rewriting_Removed_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< BAP-Header-Rewriting-Removed-List-ItemIEs >-----#
    BAP_Header_Rewriting_Removed_List_ItemIEs = CLASS(name='BAP-Header-Rewriting-Removed-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BAP_Header_Rewriting_Removed_List_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BAP-Header-Rewriting-Removed-List-Item')))
    BAP_Header_Rewriting_Removed_List_ItemIEs._val = ASN1Set(rv=[dict([('id', 642), ('criticality', 'ignore'), ('Value', _BAP_Header_Rewriting_Removed_List_ItemIEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BAPMappingConfigurationAcknowledge >-----#
    BAPMappingConfigurationAcknowledge = SEQ(name='BAPMappingConfigurationAcknowledge', mode=MODE_TYPE)
    _BAPMappingConfigurationAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __BAPMappingConfigurationAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___BAPMappingConfigurationAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____BAPMappingConfigurationAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____BAPMappingConfigurationAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____BAPMappingConfigurationAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____BAPMappingConfigurationAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____BAPMappingConfigurationAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____BAPMappingConfigurationAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BAPMappingConfigurationAcknowledge_protocolIEs__item__id._const_tab = ____BAPMappingConfigurationAcknowledge_protocolIEs__item__id_tab
    ___BAPMappingConfigurationAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___BAPMappingConfigurationAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___BAPMappingConfigurationAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___BAPMappingConfigurationAcknowledge_protocolIEs__item__criticality._const_tab = ____BAPMappingConfigurationAcknowledge_protocolIEs__item__id_tab
    ___BAPMappingConfigurationAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BAPMappingConfigurationAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BAPMappingConfigurationAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___BAPMappingConfigurationAcknowledge_protocolIEs__item__value._const_tab = ____BAPMappingConfigurationAcknowledge_protocolIEs__item__id_tab
    ___BAPMappingConfigurationAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BAPMappingConfigurationAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __BAPMappingConfigurationAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BAPMappingConfigurationAcknowledge_protocolIEs__item__id),
        ('criticality', ___BAPMappingConfigurationAcknowledge_protocolIEs__item__criticality),
        ('value', ___BAPMappingConfigurationAcknowledge_protocolIEs__item__value),
        ])
    __BAPMappingConfigurationAcknowledge_protocolIEs__item_._ext = None
    _BAPMappingConfigurationAcknowledge_protocolIEs._cont = __BAPMappingConfigurationAcknowledge_protocolIEs__item_
    _BAPMappingConfigurationAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BAPMappingConfigurationAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _BAPMappingConfigurationAcknowledge_protocolIEs),
        ])
    BAPMappingConfigurationAcknowledge._ext = []
    
    #-----< BAPMappingConfigurationAcknowledge-IEs >-----#
    BAPMappingConfigurationAcknowledge_IEs = CLASS(name='BAPMappingConfigurationAcknowledge-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BAPMappingConfigurationAcknowledge_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _BAPMappingConfigurationAcknowledge_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    BAPMappingConfigurationAcknowledge_IEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _BAPMappingConfigurationAcknowledge_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _BAPMappingConfigurationAcknowledge_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BAPMappingConfigurationFailure >-----#
    BAPMappingConfigurationFailure = SEQ(name='BAPMappingConfigurationFailure', mode=MODE_TYPE)
    _BAPMappingConfigurationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __BAPMappingConfigurationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___BAPMappingConfigurationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____BAPMappingConfigurationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____BAPMappingConfigurationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____BAPMappingConfigurationFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____BAPMappingConfigurationFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _____BAPMappingConfigurationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____BAPMappingConfigurationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____BAPMappingConfigurationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____BAPMappingConfigurationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _____BAPMappingConfigurationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____BAPMappingConfigurationFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BAPMappingConfigurationFailure_protocolIEs__item__id._const_tab = ____BAPMappingConfigurationFailure_protocolIEs__item__id_tab
    ___BAPMappingConfigurationFailure_protocolIEs__item__id._const_tab_at = None
    ___BAPMappingConfigurationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___BAPMappingConfigurationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___BAPMappingConfigurationFailure_protocolIEs__item__criticality._const_tab = ____BAPMappingConfigurationFailure_protocolIEs__item__id_tab
    ___BAPMappingConfigurationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BAPMappingConfigurationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BAPMappingConfigurationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___BAPMappingConfigurationFailure_protocolIEs__item__value._const_tab = ____BAPMappingConfigurationFailure_protocolIEs__item__id_tab
    ___BAPMappingConfigurationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BAPMappingConfigurationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __BAPMappingConfigurationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BAPMappingConfigurationFailure_protocolIEs__item__id),
        ('criticality', ___BAPMappingConfigurationFailure_protocolIEs__item__criticality),
        ('value', ___BAPMappingConfigurationFailure_protocolIEs__item__value),
        ])
    __BAPMappingConfigurationFailure_protocolIEs__item_._ext = None
    _BAPMappingConfigurationFailure_protocolIEs._cont = __BAPMappingConfigurationFailure_protocolIEs__item_
    _BAPMappingConfigurationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BAPMappingConfigurationFailure._cont = ASN1Dict([
        ('protocolIEs', _BAPMappingConfigurationFailure_protocolIEs),
        ])
    BAPMappingConfigurationFailure._ext = []
    
    #-----< BAPMappingConfigurationFailureIEs >-----#
    BAPMappingConfigurationFailureIEs = CLASS(name='BAPMappingConfigurationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BAPMappingConfigurationFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _BAPMappingConfigurationFailureIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _BAPMappingConfigurationFailureIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _BAPMappingConfigurationFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    BAPMappingConfigurationFailureIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _BAPMappingConfigurationFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _BAPMappingConfigurationFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _BAPMappingConfigurationFailureIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _BAPMappingConfigurationFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNBDUResourceConfiguration >-----#
    GNBDUResourceConfiguration = SEQ(name='GNBDUResourceConfiguration', mode=MODE_TYPE)
    _GNBDUResourceConfiguration_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __GNBDUResourceConfiguration_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___GNBDUResourceConfiguration_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____GNBDUResourceConfiguration_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____GNBDUResourceConfiguration_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____GNBDUResourceConfiguration_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Activated-Cells-to-be-Updated-List')))
    _____GNBDUResourceConfiguration_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Child-Nodes-List')))
    _____GNBDUResourceConfiguration_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Neighbour-Node-Cells-List')))
    _____GNBDUResourceConfiguration_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Serving-Cells-List')))
    ____GNBDUResourceConfiguration_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____GNBDUResourceConfiguration_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 288), ('criticality', 'reject'), ('Value', _____GNBDUResourceConfiguration_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 289), ('criticality', 'reject'), ('Value', _____GNBDUResourceConfiguration_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 533), ('criticality', 'reject'), ('Value', _____GNBDUResourceConfiguration_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 534), ('criticality', 'reject'), ('Value', _____GNBDUResourceConfiguration_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNBDUResourceConfiguration_protocolIEs__item__id._const_tab = ____GNBDUResourceConfiguration_protocolIEs__item__id_tab
    ___GNBDUResourceConfiguration_protocolIEs__item__id._const_tab_at = None
    ___GNBDUResourceConfiguration_protocolIEs__item__id._const_tab_id = 'id'
    ___GNBDUResourceConfiguration_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___GNBDUResourceConfiguration_protocolIEs__item__criticality._const_tab = ____GNBDUResourceConfiguration_protocolIEs__item__id_tab
    ___GNBDUResourceConfiguration_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNBDUResourceConfiguration_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNBDUResourceConfiguration_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___GNBDUResourceConfiguration_protocolIEs__item__value._const_tab = ____GNBDUResourceConfiguration_protocolIEs__item__id_tab
    ___GNBDUResourceConfiguration_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNBDUResourceConfiguration_protocolIEs__item__value._const_tab_id = 'Value'
    __GNBDUResourceConfiguration_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNBDUResourceConfiguration_protocolIEs__item__id),
        ('criticality', ___GNBDUResourceConfiguration_protocolIEs__item__criticality),
        ('value', ___GNBDUResourceConfiguration_protocolIEs__item__value),
        ])
    __GNBDUResourceConfiguration_protocolIEs__item_._ext = None
    _GNBDUResourceConfiguration_protocolIEs._cont = __GNBDUResourceConfiguration_protocolIEs__item_
    _GNBDUResourceConfiguration_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNBDUResourceConfiguration._cont = ASN1Dict([
        ('protocolIEs', _GNBDUResourceConfiguration_protocolIEs),
        ])
    GNBDUResourceConfiguration._ext = []
    
    #-----< GNBDUResourceConfigurationIEs >-----#
    GNBDUResourceConfigurationIEs = CLASS(name='GNBDUResourceConfigurationIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNBDUResourceConfigurationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _GNBDUResourceConfigurationIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Activated-Cells-to-be-Updated-List')))
    _GNBDUResourceConfigurationIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Child-Nodes-List')))
    _GNBDUResourceConfigurationIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Neighbour-Node-Cells-List')))
    _GNBDUResourceConfigurationIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Serving-Cells-List')))
    GNBDUResourceConfigurationIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _GNBDUResourceConfigurationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 288), ('criticality', 'reject'), ('Value', _GNBDUResourceConfigurationIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 289), ('criticality', 'reject'), ('Value', _GNBDUResourceConfigurationIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 533), ('criticality', 'reject'), ('Value', _GNBDUResourceConfigurationIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 534), ('criticality', 'reject'), ('Value', _GNBDUResourceConfigurationIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNBDUResourceConfigurationAcknowledge >-----#
    GNBDUResourceConfigurationAcknowledge = SEQ(name='GNBDUResourceConfigurationAcknowledge', mode=MODE_TYPE)
    _GNBDUResourceConfigurationAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __GNBDUResourceConfigurationAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id._const_tab = ____GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id_tab
    ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__criticality._const_tab = ____GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id_tab
    ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__value._const_tab = ____GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id_tab
    ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __GNBDUResourceConfigurationAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id),
        ('criticality', ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__criticality),
        ('value', ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__value),
        ])
    __GNBDUResourceConfigurationAcknowledge_protocolIEs__item_._ext = None
    _GNBDUResourceConfigurationAcknowledge_protocolIEs._cont = __GNBDUResourceConfigurationAcknowledge_protocolIEs__item_
    _GNBDUResourceConfigurationAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNBDUResourceConfigurationAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _GNBDUResourceConfigurationAcknowledge_protocolIEs),
        ])
    GNBDUResourceConfigurationAcknowledge._ext = []
    
    #-----< GNBDUResourceConfigurationAcknowledgeIEs >-----#
    GNBDUResourceConfigurationAcknowledgeIEs = CLASS(name='GNBDUResourceConfigurationAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNBDUResourceConfigurationAcknowledgeIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _GNBDUResourceConfigurationAcknowledgeIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    GNBDUResourceConfigurationAcknowledgeIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _GNBDUResourceConfigurationAcknowledgeIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _GNBDUResourceConfigurationAcknowledgeIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNBDUResourceConfigurationFailure >-----#
    GNBDUResourceConfigurationFailure = SEQ(name='GNBDUResourceConfigurationFailure', mode=MODE_TYPE)
    _GNBDUResourceConfigurationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __GNBDUResourceConfigurationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___GNBDUResourceConfigurationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNBDUResourceConfigurationFailure_protocolIEs__item__id._const_tab = ____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab
    ___GNBDUResourceConfigurationFailure_protocolIEs__item__id._const_tab_at = None
    ___GNBDUResourceConfigurationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___GNBDUResourceConfigurationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___GNBDUResourceConfigurationFailure_protocolIEs__item__criticality._const_tab = ____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab
    ___GNBDUResourceConfigurationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNBDUResourceConfigurationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNBDUResourceConfigurationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___GNBDUResourceConfigurationFailure_protocolIEs__item__value._const_tab = ____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab
    ___GNBDUResourceConfigurationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNBDUResourceConfigurationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __GNBDUResourceConfigurationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNBDUResourceConfigurationFailure_protocolIEs__item__id),
        ('criticality', ___GNBDUResourceConfigurationFailure_protocolIEs__item__criticality),
        ('value', ___GNBDUResourceConfigurationFailure_protocolIEs__item__value),
        ])
    __GNBDUResourceConfigurationFailure_protocolIEs__item_._ext = None
    _GNBDUResourceConfigurationFailure_protocolIEs._cont = __GNBDUResourceConfigurationFailure_protocolIEs__item_
    _GNBDUResourceConfigurationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNBDUResourceConfigurationFailure._cont = ASN1Dict([
        ('protocolIEs', _GNBDUResourceConfigurationFailure_protocolIEs),
        ])
    GNBDUResourceConfigurationFailure._ext = []
    
    #-----< GNBDUResourceConfigurationFailureIEs >-----#
    GNBDUResourceConfigurationFailureIEs = CLASS(name='GNBDUResourceConfigurationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _GNBDUResourceConfigurationFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _GNBDUResourceConfigurationFailureIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _GNBDUResourceConfigurationFailureIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _GNBDUResourceConfigurationFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    GNBDUResourceConfigurationFailureIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _GNBDUResourceConfigurationFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _GNBDUResourceConfigurationFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _GNBDUResourceConfigurationFailureIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _GNBDUResourceConfigurationFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< IABTNLAddressRequest >-----#
    IABTNLAddressRequest = SEQ(name='IABTNLAddressRequest', mode=MODE_TYPE)
    _IABTNLAddressRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __IABTNLAddressRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___IABTNLAddressRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____IABTNLAddressRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IABv4AddressesRequested')))
    _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IABIPv6RequestType')))
    _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IAB-TNL-Addresses-To-Remove-List')))
    _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-TNL-Addresses-Exception')))
    ____IABTNLAddressRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 297), ('criticality', 'reject'), ('Value', _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 296), ('criticality', 'reject'), ('Value', _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 292), ('criticality', 'reject'), ('Value', _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 513), ('criticality', 'reject'), ('Value', _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___IABTNLAddressRequest_protocolIEs__item__id._const_tab = ____IABTNLAddressRequest_protocolIEs__item__id_tab
    ___IABTNLAddressRequest_protocolIEs__item__id._const_tab_at = None
    ___IABTNLAddressRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___IABTNLAddressRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___IABTNLAddressRequest_protocolIEs__item__criticality._const_tab = ____IABTNLAddressRequest_protocolIEs__item__id_tab
    ___IABTNLAddressRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___IABTNLAddressRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___IABTNLAddressRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___IABTNLAddressRequest_protocolIEs__item__value._const_tab = ____IABTNLAddressRequest_protocolIEs__item__id_tab
    ___IABTNLAddressRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___IABTNLAddressRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __IABTNLAddressRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___IABTNLAddressRequest_protocolIEs__item__id),
        ('criticality', ___IABTNLAddressRequest_protocolIEs__item__criticality),
        ('value', ___IABTNLAddressRequest_protocolIEs__item__value),
        ])
    __IABTNLAddressRequest_protocolIEs__item_._ext = None
    _IABTNLAddressRequest_protocolIEs._cont = __IABTNLAddressRequest_protocolIEs__item_
    _IABTNLAddressRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    IABTNLAddressRequest._cont = ASN1Dict([
        ('protocolIEs', _IABTNLAddressRequest_protocolIEs),
        ])
    IABTNLAddressRequest._ext = []
    
    #-----< IABTNLAddressRequestIEs >-----#
    IABTNLAddressRequestIEs = CLASS(name='IABTNLAddressRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _IABTNLAddressRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _IABTNLAddressRequestIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IABv4AddressesRequested')))
    _IABTNLAddressRequestIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IABIPv6RequestType')))
    _IABTNLAddressRequestIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IAB-TNL-Addresses-To-Remove-List')))
    _IABTNLAddressRequestIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-TNL-Addresses-Exception')))
    IABTNLAddressRequestIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _IABTNLAddressRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 297), ('criticality', 'reject'), ('Value', _IABTNLAddressRequestIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 296), ('criticality', 'reject'), ('Value', _IABTNLAddressRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 292), ('criticality', 'reject'), ('Value', _IABTNLAddressRequestIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 513), ('criticality', 'reject'), ('Value', _IABTNLAddressRequestIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< IAB-TNL-Addresses-To-Remove-List >-----#
    IAB_TNL_Addresses_To_Remove_List = SEQ_OF(name='IAB-TNL-Addresses-To-Remove-List', mode=MODE_TYPE)
    _IAB_TNL_Addresses_To_Remove_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __IAB_TNL_Addresses_To_Remove_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___IAB_TNL_Addresses_To_Remove_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____IAB_TNL_Addresses_To_Remove_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-TNL-Addresses-To-Remove-Item')))
    ___IAB_TNL_Addresses_To_Remove_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 293), ('criticality', 'reject'), ('Value', ____IAB_TNL_Addresses_To_Remove_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __IAB_TNL_Addresses_To_Remove_List__item__id._const_tab = ___IAB_TNL_Addresses_To_Remove_List__item__id_tab
    __IAB_TNL_Addresses_To_Remove_List__item__id._const_tab_at = None
    __IAB_TNL_Addresses_To_Remove_List__item__id._const_tab_id = 'id'
    __IAB_TNL_Addresses_To_Remove_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __IAB_TNL_Addresses_To_Remove_List__item__criticality._const_tab = ___IAB_TNL_Addresses_To_Remove_List__item__id_tab
    __IAB_TNL_Addresses_To_Remove_List__item__criticality._const_tab_at = ('..', 'id')
    __IAB_TNL_Addresses_To_Remove_List__item__criticality._const_tab_id = 'criticality'
    __IAB_TNL_Addresses_To_Remove_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __IAB_TNL_Addresses_To_Remove_List__item__value._const_tab = ___IAB_TNL_Addresses_To_Remove_List__item__id_tab
    __IAB_TNL_Addresses_To_Remove_List__item__value._const_tab_at = ('..', 'id')
    __IAB_TNL_Addresses_To_Remove_List__item__value._const_tab_id = 'Value'
    _IAB_TNL_Addresses_To_Remove_List__item_._cont = ASN1Dict([
        ('id', __IAB_TNL_Addresses_To_Remove_List__item__id),
        ('criticality', __IAB_TNL_Addresses_To_Remove_List__item__criticality),
        ('value', __IAB_TNL_Addresses_To_Remove_List__item__value),
        ])
    _IAB_TNL_Addresses_To_Remove_List__item_._ext = None
    IAB_TNL_Addresses_To_Remove_List._cont = _IAB_TNL_Addresses_To_Remove_List__item_
    IAB_TNL_Addresses_To_Remove_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< IAB-TNL-Addresses-To-Remove-ItemIEs >-----#
    IAB_TNL_Addresses_To_Remove_ItemIEs = CLASS(name='IAB-TNL-Addresses-To-Remove-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _IAB_TNL_Addresses_To_Remove_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-TNL-Addresses-To-Remove-Item')))
    IAB_TNL_Addresses_To_Remove_ItemIEs._val = ASN1Set(rv=[dict([('id', 293), ('criticality', 'reject'), ('Value', _IAB_TNL_Addresses_To_Remove_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< IABTNLAddressResponse >-----#
    IABTNLAddressResponse = SEQ(name='IABTNLAddressResponse', mode=MODE_TYPE)
    _IABTNLAddressResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __IABTNLAddressResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___IABTNLAddressResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____IABTNLAddressResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____IABTNLAddressResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____IABTNLAddressResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IAB-Allocated-TNL-Address-List')))
    ____IABTNLAddressResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____IABTNLAddressResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 294), ('criticality', 'reject'), ('Value', _____IABTNLAddressResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___IABTNLAddressResponse_protocolIEs__item__id._const_tab = ____IABTNLAddressResponse_protocolIEs__item__id_tab
    ___IABTNLAddressResponse_protocolIEs__item__id._const_tab_at = None
    ___IABTNLAddressResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___IABTNLAddressResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___IABTNLAddressResponse_protocolIEs__item__criticality._const_tab = ____IABTNLAddressResponse_protocolIEs__item__id_tab
    ___IABTNLAddressResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___IABTNLAddressResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___IABTNLAddressResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___IABTNLAddressResponse_protocolIEs__item__value._const_tab = ____IABTNLAddressResponse_protocolIEs__item__id_tab
    ___IABTNLAddressResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___IABTNLAddressResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __IABTNLAddressResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___IABTNLAddressResponse_protocolIEs__item__id),
        ('criticality', ___IABTNLAddressResponse_protocolIEs__item__criticality),
        ('value', ___IABTNLAddressResponse_protocolIEs__item__value),
        ])
    __IABTNLAddressResponse_protocolIEs__item_._ext = None
    _IABTNLAddressResponse_protocolIEs._cont = __IABTNLAddressResponse_protocolIEs__item_
    _IABTNLAddressResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    IABTNLAddressResponse._cont = ASN1Dict([
        ('protocolIEs', _IABTNLAddressResponse_protocolIEs),
        ])
    IABTNLAddressResponse._ext = []
    
    #-----< IABTNLAddressResponseIEs >-----#
    IABTNLAddressResponseIEs = CLASS(name='IABTNLAddressResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _IABTNLAddressResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _IABTNLAddressResponseIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IAB-Allocated-TNL-Address-List')))
    IABTNLAddressResponseIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _IABTNLAddressResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 294), ('criticality', 'reject'), ('Value', _IABTNLAddressResponseIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< IAB-Allocated-TNL-Address-List >-----#
    IAB_Allocated_TNL_Address_List = SEQ_OF(name='IAB-Allocated-TNL-Address-List', mode=MODE_TYPE)
    _IAB_Allocated_TNL_Address_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __IAB_Allocated_TNL_Address_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___IAB_Allocated_TNL_Address_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____IAB_Allocated_TNL_Address_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-Allocated-TNL-Address-Item')))
    ___IAB_Allocated_TNL_Address_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 295), ('criticality', 'reject'), ('Value', ____IAB_Allocated_TNL_Address_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __IAB_Allocated_TNL_Address_List__item__id._const_tab = ___IAB_Allocated_TNL_Address_List__item__id_tab
    __IAB_Allocated_TNL_Address_List__item__id._const_tab_at = None
    __IAB_Allocated_TNL_Address_List__item__id._const_tab_id = 'id'
    __IAB_Allocated_TNL_Address_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __IAB_Allocated_TNL_Address_List__item__criticality._const_tab = ___IAB_Allocated_TNL_Address_List__item__id_tab
    __IAB_Allocated_TNL_Address_List__item__criticality._const_tab_at = ('..', 'id')
    __IAB_Allocated_TNL_Address_List__item__criticality._const_tab_id = 'criticality'
    __IAB_Allocated_TNL_Address_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __IAB_Allocated_TNL_Address_List__item__value._const_tab = ___IAB_Allocated_TNL_Address_List__item__id_tab
    __IAB_Allocated_TNL_Address_List__item__value._const_tab_at = ('..', 'id')
    __IAB_Allocated_TNL_Address_List__item__value._const_tab_id = 'Value'
    _IAB_Allocated_TNL_Address_List__item_._cont = ASN1Dict([
        ('id', __IAB_Allocated_TNL_Address_List__item__id),
        ('criticality', __IAB_Allocated_TNL_Address_List__item__criticality),
        ('value', __IAB_Allocated_TNL_Address_List__item__value),
        ])
    _IAB_Allocated_TNL_Address_List__item_._ext = None
    IAB_Allocated_TNL_Address_List._cont = _IAB_Allocated_TNL_Address_List__item_
    IAB_Allocated_TNL_Address_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< IAB-Allocated-TNL-Address-List-ItemIEs >-----#
    IAB_Allocated_TNL_Address_List_ItemIEs = CLASS(name='IAB-Allocated-TNL-Address-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _IAB_Allocated_TNL_Address_List_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'IAB-Allocated-TNL-Address-Item')))
    IAB_Allocated_TNL_Address_List_ItemIEs._val = ASN1Set(rv=[dict([('id', 295), ('criticality', 'reject'), ('Value', _IAB_Allocated_TNL_Address_List_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< IABTNLAddressFailure >-----#
    IABTNLAddressFailure = SEQ(name='IABTNLAddressFailure', mode=MODE_TYPE)
    _IABTNLAddressFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __IABTNLAddressFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___IABTNLAddressFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____IABTNLAddressFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____IABTNLAddressFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____IABTNLAddressFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____IABTNLAddressFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _____IABTNLAddressFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____IABTNLAddressFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____IABTNLAddressFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____IABTNLAddressFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _____IABTNLAddressFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____IABTNLAddressFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___IABTNLAddressFailure_protocolIEs__item__id._const_tab = ____IABTNLAddressFailure_protocolIEs__item__id_tab
    ___IABTNLAddressFailure_protocolIEs__item__id._const_tab_at = None
    ___IABTNLAddressFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___IABTNLAddressFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___IABTNLAddressFailure_protocolIEs__item__criticality._const_tab = ____IABTNLAddressFailure_protocolIEs__item__id_tab
    ___IABTNLAddressFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___IABTNLAddressFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___IABTNLAddressFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___IABTNLAddressFailure_protocolIEs__item__value._const_tab = ____IABTNLAddressFailure_protocolIEs__item__id_tab
    ___IABTNLAddressFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___IABTNLAddressFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __IABTNLAddressFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___IABTNLAddressFailure_protocolIEs__item__id),
        ('criticality', ___IABTNLAddressFailure_protocolIEs__item__criticality),
        ('value', ___IABTNLAddressFailure_protocolIEs__item__value),
        ])
    __IABTNLAddressFailure_protocolIEs__item_._ext = None
    _IABTNLAddressFailure_protocolIEs._cont = __IABTNLAddressFailure_protocolIEs__item_
    _IABTNLAddressFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    IABTNLAddressFailure._cont = ASN1Dict([
        ('protocolIEs', _IABTNLAddressFailure_protocolIEs),
        ])
    IABTNLAddressFailure._ext = []
    
    #-----< IABTNLAddressFailureIEs >-----#
    IABTNLAddressFailureIEs = CLASS(name='IABTNLAddressFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _IABTNLAddressFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _IABTNLAddressFailureIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _IABTNLAddressFailureIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _IABTNLAddressFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    IABTNLAddressFailureIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _IABTNLAddressFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _IABTNLAddressFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _IABTNLAddressFailureIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _IABTNLAddressFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< IABUPConfigurationUpdateRequest >-----#
    IABUPConfigurationUpdateRequest = SEQ(name='IABUPConfigurationUpdateRequest', mode=MODE_TYPE)
    _IABUPConfigurationUpdateRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __IABUPConfigurationUpdateRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___IABUPConfigurationUpdateRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UL-UP-TNL-Information-to-Update-List')))
    _____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UL-UP-TNL-Address-to-Update-List')))
    ____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 300), ('criticality', 'ignore'), ('Value', _____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 302), ('criticality', 'ignore'), ('Value', _____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___IABUPConfigurationUpdateRequest_protocolIEs__item__id._const_tab = ____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab
    ___IABUPConfigurationUpdateRequest_protocolIEs__item__id._const_tab_at = None
    ___IABUPConfigurationUpdateRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___IABUPConfigurationUpdateRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___IABUPConfigurationUpdateRequest_protocolIEs__item__criticality._const_tab = ____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab
    ___IABUPConfigurationUpdateRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___IABUPConfigurationUpdateRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___IABUPConfigurationUpdateRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___IABUPConfigurationUpdateRequest_protocolIEs__item__value._const_tab = ____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab
    ___IABUPConfigurationUpdateRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___IABUPConfigurationUpdateRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __IABUPConfigurationUpdateRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___IABUPConfigurationUpdateRequest_protocolIEs__item__id),
        ('criticality', ___IABUPConfigurationUpdateRequest_protocolIEs__item__criticality),
        ('value', ___IABUPConfigurationUpdateRequest_protocolIEs__item__value),
        ])
    __IABUPConfigurationUpdateRequest_protocolIEs__item_._ext = None
    _IABUPConfigurationUpdateRequest_protocolIEs._cont = __IABUPConfigurationUpdateRequest_protocolIEs__item_
    _IABUPConfigurationUpdateRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    IABUPConfigurationUpdateRequest._cont = ASN1Dict([
        ('protocolIEs', _IABUPConfigurationUpdateRequest_protocolIEs),
        ])
    IABUPConfigurationUpdateRequest._ext = []
    
    #-----< IABUPConfigurationUpdateRequestIEs >-----#
    IABUPConfigurationUpdateRequestIEs = CLASS(name='IABUPConfigurationUpdateRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _IABUPConfigurationUpdateRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _IABUPConfigurationUpdateRequestIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UL-UP-TNL-Information-to-Update-List')))
    _IABUPConfigurationUpdateRequestIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UL-UP-TNL-Address-to-Update-List')))
    IABUPConfigurationUpdateRequestIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _IABUPConfigurationUpdateRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 300), ('criticality', 'ignore'), ('Value', _IABUPConfigurationUpdateRequestIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 302), ('criticality', 'ignore'), ('Value', _IABUPConfigurationUpdateRequestIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-UP-TNL-Information-to-Update-List >-----#
    UL_UP_TNL_Information_to_Update_List = SEQ_OF(name='UL-UP-TNL-Information-to-Update-List', mode=MODE_TYPE)
    _UL_UP_TNL_Information_to_Update_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UL_UP_TNL_Information_to_Update_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___UL_UP_TNL_Information_to_Update_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____UL_UP_TNL_Information_to_Update_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-UP-TNL-Information-to-Update-List-Item')))
    ___UL_UP_TNL_Information_to_Update_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 301), ('criticality', 'ignore'), ('Value', ____UL_UP_TNL_Information_to_Update_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __UL_UP_TNL_Information_to_Update_List__item__id._const_tab = ___UL_UP_TNL_Information_to_Update_List__item__id_tab
    __UL_UP_TNL_Information_to_Update_List__item__id._const_tab_at = None
    __UL_UP_TNL_Information_to_Update_List__item__id._const_tab_id = 'id'
    __UL_UP_TNL_Information_to_Update_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __UL_UP_TNL_Information_to_Update_List__item__criticality._const_tab = ___UL_UP_TNL_Information_to_Update_List__item__id_tab
    __UL_UP_TNL_Information_to_Update_List__item__criticality._const_tab_at = ('..', 'id')
    __UL_UP_TNL_Information_to_Update_List__item__criticality._const_tab_id = 'criticality'
    __UL_UP_TNL_Information_to_Update_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __UL_UP_TNL_Information_to_Update_List__item__value._const_tab = ___UL_UP_TNL_Information_to_Update_List__item__id_tab
    __UL_UP_TNL_Information_to_Update_List__item__value._const_tab_at = ('..', 'id')
    __UL_UP_TNL_Information_to_Update_List__item__value._const_tab_id = 'Value'
    _UL_UP_TNL_Information_to_Update_List__item_._cont = ASN1Dict([
        ('id', __UL_UP_TNL_Information_to_Update_List__item__id),
        ('criticality', __UL_UP_TNL_Information_to_Update_List__item__criticality),
        ('value', __UL_UP_TNL_Information_to_Update_List__item__value),
        ])
    _UL_UP_TNL_Information_to_Update_List__item_._ext = None
    UL_UP_TNL_Information_to_Update_List._cont = _UL_UP_TNL_Information_to_Update_List__item_
    UL_UP_TNL_Information_to_Update_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32678)], ev=None, er=[])
    
    #-----< UL-UP-TNL-Information-to-Update-List-ItemIEs >-----#
    UL_UP_TNL_Information_to_Update_List_ItemIEs = CLASS(name='UL-UP-TNL-Information-to-Update-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UL_UP_TNL_Information_to_Update_List_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-UP-TNL-Information-to-Update-List-Item')))
    UL_UP_TNL_Information_to_Update_List_ItemIEs._val = ASN1Set(rv=[dict([('id', 301), ('criticality', 'ignore'), ('Value', _UL_UP_TNL_Information_to_Update_List_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UL-UP-TNL-Address-to-Update-List >-----#
    UL_UP_TNL_Address_to_Update_List = SEQ_OF(name='UL-UP-TNL-Address-to-Update-List', mode=MODE_TYPE)
    _UL_UP_TNL_Address_to_Update_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UL_UP_TNL_Address_to_Update_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___UL_UP_TNL_Address_to_Update_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____UL_UP_TNL_Address_to_Update_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-UP-TNL-Address-to-Update-List-Item')))
    ___UL_UP_TNL_Address_to_Update_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 303), ('criticality', 'ignore'), ('Value', ____UL_UP_TNL_Address_to_Update_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __UL_UP_TNL_Address_to_Update_List__item__id._const_tab = ___UL_UP_TNL_Address_to_Update_List__item__id_tab
    __UL_UP_TNL_Address_to_Update_List__item__id._const_tab_at = None
    __UL_UP_TNL_Address_to_Update_List__item__id._const_tab_id = 'id'
    __UL_UP_TNL_Address_to_Update_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __UL_UP_TNL_Address_to_Update_List__item__criticality._const_tab = ___UL_UP_TNL_Address_to_Update_List__item__id_tab
    __UL_UP_TNL_Address_to_Update_List__item__criticality._const_tab_at = ('..', 'id')
    __UL_UP_TNL_Address_to_Update_List__item__criticality._const_tab_id = 'criticality'
    __UL_UP_TNL_Address_to_Update_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __UL_UP_TNL_Address_to_Update_List__item__value._const_tab = ___UL_UP_TNL_Address_to_Update_List__item__id_tab
    __UL_UP_TNL_Address_to_Update_List__item__value._const_tab_at = ('..', 'id')
    __UL_UP_TNL_Address_to_Update_List__item__value._const_tab_id = 'Value'
    _UL_UP_TNL_Address_to_Update_List__item_._cont = ASN1Dict([
        ('id', __UL_UP_TNL_Address_to_Update_List__item__id),
        ('criticality', __UL_UP_TNL_Address_to_Update_List__item__criticality),
        ('value', __UL_UP_TNL_Address_to_Update_List__item__value),
        ])
    _UL_UP_TNL_Address_to_Update_List__item_._ext = None
    UL_UP_TNL_Address_to_Update_List._cont = _UL_UP_TNL_Address_to_Update_List__item_
    UL_UP_TNL_Address_to_Update_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< UL-UP-TNL-Address-to-Update-List-ItemIEs >-----#
    UL_UP_TNL_Address_to_Update_List_ItemIEs = CLASS(name='UL-UP-TNL-Address-to-Update-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UL_UP_TNL_Address_to_Update_List_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UL-UP-TNL-Address-to-Update-List-Item')))
    UL_UP_TNL_Address_to_Update_List_ItemIEs._val = ASN1Set(rv=[dict([('id', 303), ('criticality', 'ignore'), ('Value', _UL_UP_TNL_Address_to_Update_List_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< IABUPConfigurationUpdateResponse >-----#
    IABUPConfigurationUpdateResponse = SEQ(name='IABUPConfigurationUpdateResponse', mode=MODE_TYPE)
    _IABUPConfigurationUpdateResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __IABUPConfigurationUpdateResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___IABUPConfigurationUpdateResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DL-UP-TNL-Address-to-Update-List')))
    ____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 304), ('criticality', 'reject'), ('Value', _____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___IABUPConfigurationUpdateResponse_protocolIEs__item__id._const_tab = ____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab
    ___IABUPConfigurationUpdateResponse_protocolIEs__item__id._const_tab_at = None
    ___IABUPConfigurationUpdateResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___IABUPConfigurationUpdateResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___IABUPConfigurationUpdateResponse_protocolIEs__item__criticality._const_tab = ____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab
    ___IABUPConfigurationUpdateResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___IABUPConfigurationUpdateResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___IABUPConfigurationUpdateResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___IABUPConfigurationUpdateResponse_protocolIEs__item__value._const_tab = ____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab
    ___IABUPConfigurationUpdateResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___IABUPConfigurationUpdateResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __IABUPConfigurationUpdateResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___IABUPConfigurationUpdateResponse_protocolIEs__item__id),
        ('criticality', ___IABUPConfigurationUpdateResponse_protocolIEs__item__criticality),
        ('value', ___IABUPConfigurationUpdateResponse_protocolIEs__item__value),
        ])
    __IABUPConfigurationUpdateResponse_protocolIEs__item_._ext = None
    _IABUPConfigurationUpdateResponse_protocolIEs._cont = __IABUPConfigurationUpdateResponse_protocolIEs__item_
    _IABUPConfigurationUpdateResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    IABUPConfigurationUpdateResponse._cont = ASN1Dict([
        ('protocolIEs', _IABUPConfigurationUpdateResponse_protocolIEs),
        ])
    IABUPConfigurationUpdateResponse._ext = []
    
    #-----< IABUPConfigurationUpdateResponseIEs >-----#
    IABUPConfigurationUpdateResponseIEs = CLASS(name='IABUPConfigurationUpdateResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _IABUPConfigurationUpdateResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _IABUPConfigurationUpdateResponseIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _IABUPConfigurationUpdateResponseIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DL-UP-TNL-Address-to-Update-List')))
    IABUPConfigurationUpdateResponseIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _IABUPConfigurationUpdateResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _IABUPConfigurationUpdateResponseIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 304), ('criticality', 'reject'), ('Value', _IABUPConfigurationUpdateResponseIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-UP-TNL-Address-to-Update-List >-----#
    DL_UP_TNL_Address_to_Update_List = SEQ_OF(name='DL-UP-TNL-Address-to-Update-List', mode=MODE_TYPE)
    _DL_UP_TNL_Address_to_Update_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DL_UP_TNL_Address_to_Update_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___DL_UP_TNL_Address_to_Update_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____DL_UP_TNL_Address_to_Update_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DL-UP-TNL-Address-to-Update-List-Item')))
    ___DL_UP_TNL_Address_to_Update_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 305), ('criticality', 'ignore'), ('Value', ____DL_UP_TNL_Address_to_Update_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __DL_UP_TNL_Address_to_Update_List__item__id._const_tab = ___DL_UP_TNL_Address_to_Update_List__item__id_tab
    __DL_UP_TNL_Address_to_Update_List__item__id._const_tab_at = None
    __DL_UP_TNL_Address_to_Update_List__item__id._const_tab_id = 'id'
    __DL_UP_TNL_Address_to_Update_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __DL_UP_TNL_Address_to_Update_List__item__criticality._const_tab = ___DL_UP_TNL_Address_to_Update_List__item__id_tab
    __DL_UP_TNL_Address_to_Update_List__item__criticality._const_tab_at = ('..', 'id')
    __DL_UP_TNL_Address_to_Update_List__item__criticality._const_tab_id = 'criticality'
    __DL_UP_TNL_Address_to_Update_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __DL_UP_TNL_Address_to_Update_List__item__value._const_tab = ___DL_UP_TNL_Address_to_Update_List__item__id_tab
    __DL_UP_TNL_Address_to_Update_List__item__value._const_tab_at = ('..', 'id')
    __DL_UP_TNL_Address_to_Update_List__item__value._const_tab_id = 'Value'
    _DL_UP_TNL_Address_to_Update_List__item_._cont = ASN1Dict([
        ('id', __DL_UP_TNL_Address_to_Update_List__item__id),
        ('criticality', __DL_UP_TNL_Address_to_Update_List__item__criticality),
        ('value', __DL_UP_TNL_Address_to_Update_List__item__value),
        ])
    _DL_UP_TNL_Address_to_Update_List__item_._ext = None
    DL_UP_TNL_Address_to_Update_List._cont = _DL_UP_TNL_Address_to_Update_List__item_
    DL_UP_TNL_Address_to_Update_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< DL-UP-TNL-Address-to-Update-List-ItemIEs >-----#
    DL_UP_TNL_Address_to_Update_List_ItemIEs = CLASS(name='DL-UP-TNL-Address-to-Update-List-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _DL_UP_TNL_Address_to_Update_List_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'DL-UP-TNL-Address-to-Update-List-Item')))
    DL_UP_TNL_Address_to_Update_List_ItemIEs._val = ASN1Set(rv=[dict([('id', 305), ('criticality', 'ignore'), ('Value', _DL_UP_TNL_Address_to_Update_List_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< IABUPConfigurationUpdateFailure >-----#
    IABUPConfigurationUpdateFailure = SEQ(name='IABUPConfigurationUpdateFailure', mode=MODE_TYPE)
    _IABUPConfigurationUpdateFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __IABUPConfigurationUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___IABUPConfigurationUpdateFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___IABUPConfigurationUpdateFailure_protocolIEs__item__id._const_tab = ____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___IABUPConfigurationUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___IABUPConfigurationUpdateFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___IABUPConfigurationUpdateFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___IABUPConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab = ____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___IABUPConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___IABUPConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___IABUPConfigurationUpdateFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___IABUPConfigurationUpdateFailure_protocolIEs__item__value._const_tab = ____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___IABUPConfigurationUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___IABUPConfigurationUpdateFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __IABUPConfigurationUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___IABUPConfigurationUpdateFailure_protocolIEs__item__id),
        ('criticality', ___IABUPConfigurationUpdateFailure_protocolIEs__item__criticality),
        ('value', ___IABUPConfigurationUpdateFailure_protocolIEs__item__value),
        ])
    __IABUPConfigurationUpdateFailure_protocolIEs__item_._ext = None
    _IABUPConfigurationUpdateFailure_protocolIEs._cont = __IABUPConfigurationUpdateFailure_protocolIEs__item_
    _IABUPConfigurationUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    IABUPConfigurationUpdateFailure._cont = ASN1Dict([
        ('protocolIEs', _IABUPConfigurationUpdateFailure_protocolIEs),
        ])
    IABUPConfigurationUpdateFailure._ext = []
    
    #-----< IABUPConfigurationUpdateFailureIEs >-----#
    IABUPConfigurationUpdateFailureIEs = CLASS(name='IABUPConfigurationUpdateFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _IABUPConfigurationUpdateFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _IABUPConfigurationUpdateFailureIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _IABUPConfigurationUpdateFailureIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeToWait')))
    _IABUPConfigurationUpdateFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    IABUPConfigurationUpdateFailureIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _IABUPConfigurationUpdateFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _IABUPConfigurationUpdateFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _IABUPConfigurationUpdateFailureIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _IABUPConfigurationUpdateFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResourceStatusRequest >-----#
    ResourceStatusRequest = SEQ(name='ResourceStatusRequest', mode=MODE_TYPE)
    _ResourceStatusRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __ResourceStatusRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___ResourceStatusRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____ResourceStatusRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBCUMeasurementID')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBDUMeasurementID')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RegistrationRequest')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_4 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ReportCharacteristics')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellToReportList')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ReportingPeriodicity')))
    ____ResourceStatusRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 345), ('criticality', 'reject'), ('Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 346), ('criticality', 'ignore'), ('Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'conditional')]), dict([('id', 347), ('criticality', 'ignore'), ('Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 348), ('criticality', 'ignore'), ('Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'conditional')]), dict([('id', 349), ('criticality', 'ignore'), ('Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 352), ('criticality', 'ignore'), ('Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResourceStatusRequest_protocolIEs__item__id._const_tab = ____ResourceStatusRequest_protocolIEs__item__id_tab
    ___ResourceStatusRequest_protocolIEs__item__id._const_tab_at = None
    ___ResourceStatusRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___ResourceStatusRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___ResourceStatusRequest_protocolIEs__item__criticality._const_tab = ____ResourceStatusRequest_protocolIEs__item__id_tab
    ___ResourceStatusRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceStatusRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ResourceStatusRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___ResourceStatusRequest_protocolIEs__item__value._const_tab = ____ResourceStatusRequest_protocolIEs__item__id_tab
    ___ResourceStatusRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ResourceStatusRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __ResourceStatusRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ResourceStatusRequest_protocolIEs__item__id),
        ('criticality', ___ResourceStatusRequest_protocolIEs__item__criticality),
        ('value', ___ResourceStatusRequest_protocolIEs__item__value),
        ])
    __ResourceStatusRequest_protocolIEs__item_._ext = None
    _ResourceStatusRequest_protocolIEs._cont = __ResourceStatusRequest_protocolIEs__item_
    _ResourceStatusRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResourceStatusRequest._cont = ASN1Dict([
        ('protocolIEs', _ResourceStatusRequest_protocolIEs),
        ])
    ResourceStatusRequest._ext = []
    
    #-----< ResourceStatusRequestIEs >-----#
    ResourceStatusRequestIEs = CLASS(name='ResourceStatusRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _ResourceStatusRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _ResourceStatusRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBCUMeasurementID')))
    _ResourceStatusRequestIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBDUMeasurementID')))
    _ResourceStatusRequestIEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RegistrationRequest')))
    _ResourceStatusRequestIEs_val_Value_4 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ReportCharacteristics')))
    _ResourceStatusRequestIEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellToReportList')))
    _ResourceStatusRequestIEs_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ReportingPeriodicity')))
    ResourceStatusRequestIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _ResourceStatusRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 345), ('criticality', 'reject'), ('Value', _ResourceStatusRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 346), ('criticality', 'ignore'), ('Value', _ResourceStatusRequestIEs_val_Value_2), ('presence', 'conditional')]), dict([('id', 347), ('criticality', 'ignore'), ('Value', _ResourceStatusRequestIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 348), ('criticality', 'ignore'), ('Value', _ResourceStatusRequestIEs_val_Value_4), ('presence', 'conditional')]), dict([('id', 349), ('criticality', 'ignore'), ('Value', _ResourceStatusRequestIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 352), ('criticality', 'ignore'), ('Value', _ResourceStatusRequestIEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResourceStatusResponse >-----#
    ResourceStatusResponse = SEQ(name='ResourceStatusResponse', mode=MODE_TYPE)
    _ResourceStatusResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __ResourceStatusResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___ResourceStatusResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____ResourceStatusResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBCUMeasurementID')))
    _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBDUMeasurementID')))
    _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____ResourceStatusResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 345), ('criticality', 'reject'), ('Value', _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 346), ('criticality', 'ignore'), ('Value', _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResourceStatusResponse_protocolIEs__item__id._const_tab = ____ResourceStatusResponse_protocolIEs__item__id_tab
    ___ResourceStatusResponse_protocolIEs__item__id._const_tab_at = None
    ___ResourceStatusResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___ResourceStatusResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___ResourceStatusResponse_protocolIEs__item__criticality._const_tab = ____ResourceStatusResponse_protocolIEs__item__id_tab
    ___ResourceStatusResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceStatusResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ResourceStatusResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___ResourceStatusResponse_protocolIEs__item__value._const_tab = ____ResourceStatusResponse_protocolIEs__item__id_tab
    ___ResourceStatusResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ResourceStatusResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __ResourceStatusResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ResourceStatusResponse_protocolIEs__item__id),
        ('criticality', ___ResourceStatusResponse_protocolIEs__item__criticality),
        ('value', ___ResourceStatusResponse_protocolIEs__item__value),
        ])
    __ResourceStatusResponse_protocolIEs__item_._ext = None
    _ResourceStatusResponse_protocolIEs._cont = __ResourceStatusResponse_protocolIEs__item_
    _ResourceStatusResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResourceStatusResponse._cont = ASN1Dict([
        ('protocolIEs', _ResourceStatusResponse_protocolIEs),
        ])
    ResourceStatusResponse._ext = []
    
    #-----< ResourceStatusResponseIEs >-----#
    ResourceStatusResponseIEs = CLASS(name='ResourceStatusResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _ResourceStatusResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _ResourceStatusResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBCUMeasurementID')))
    _ResourceStatusResponseIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBDUMeasurementID')))
    _ResourceStatusResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ResourceStatusResponseIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _ResourceStatusResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 345), ('criticality', 'reject'), ('Value', _ResourceStatusResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 346), ('criticality', 'ignore'), ('Value', _ResourceStatusResponseIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _ResourceStatusResponseIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResourceStatusFailure >-----#
    ResourceStatusFailure = SEQ(name='ResourceStatusFailure', mode=MODE_TYPE)
    _ResourceStatusFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __ResourceStatusFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___ResourceStatusFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____ResourceStatusFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBCUMeasurementID')))
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBDUMeasurementID')))
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____ResourceStatusFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 345), ('criticality', 'reject'), ('Value', _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 346), ('criticality', 'ignore'), ('Value', _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResourceStatusFailure_protocolIEs__item__id._const_tab = ____ResourceStatusFailure_protocolIEs__item__id_tab
    ___ResourceStatusFailure_protocolIEs__item__id._const_tab_at = None
    ___ResourceStatusFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___ResourceStatusFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___ResourceStatusFailure_protocolIEs__item__criticality._const_tab = ____ResourceStatusFailure_protocolIEs__item__id_tab
    ___ResourceStatusFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceStatusFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ResourceStatusFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___ResourceStatusFailure_protocolIEs__item__value._const_tab = ____ResourceStatusFailure_protocolIEs__item__id_tab
    ___ResourceStatusFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ResourceStatusFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __ResourceStatusFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ResourceStatusFailure_protocolIEs__item__id),
        ('criticality', ___ResourceStatusFailure_protocolIEs__item__criticality),
        ('value', ___ResourceStatusFailure_protocolIEs__item__value),
        ])
    __ResourceStatusFailure_protocolIEs__item_._ext = None
    _ResourceStatusFailure_protocolIEs._cont = __ResourceStatusFailure_protocolIEs__item_
    _ResourceStatusFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResourceStatusFailure._cont = ASN1Dict([
        ('protocolIEs', _ResourceStatusFailure_protocolIEs),
        ])
    ResourceStatusFailure._ext = []
    
    #-----< ResourceStatusFailureIEs >-----#
    ResourceStatusFailureIEs = CLASS(name='ResourceStatusFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _ResourceStatusFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _ResourceStatusFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBCUMeasurementID')))
    _ResourceStatusFailureIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBDUMeasurementID')))
    _ResourceStatusFailureIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _ResourceStatusFailureIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ResourceStatusFailureIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _ResourceStatusFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 345), ('criticality', 'reject'), ('Value', _ResourceStatusFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 346), ('criticality', 'ignore'), ('Value', _ResourceStatusFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _ResourceStatusFailureIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _ResourceStatusFailureIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResourceStatusUpdate >-----#
    ResourceStatusUpdate = SEQ(name='ResourceStatusUpdate', mode=MODE_TYPE)
    _ResourceStatusUpdate_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __ResourceStatusUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___ResourceStatusUpdate_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____ResourceStatusUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBCUMeasurementID')))
    _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBDUMeasurementID')))
    _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'HardwareLoadIndicator')))
    _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TNLCapacityIndicator')))
    _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellMeasurementResultList')))
    ____ResourceStatusUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 345), ('criticality', 'reject'), ('Value', _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 346), ('criticality', 'ignore'), ('Value', _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 351), ('criticality', 'ignore'), ('Value', _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 353), ('criticality', 'ignore'), ('Value', _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 350), ('criticality', 'ignore'), ('Value', _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResourceStatusUpdate_protocolIEs__item__id._const_tab = ____ResourceStatusUpdate_protocolIEs__item__id_tab
    ___ResourceStatusUpdate_protocolIEs__item__id._const_tab_at = None
    ___ResourceStatusUpdate_protocolIEs__item__id._const_tab_id = 'id'
    ___ResourceStatusUpdate_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___ResourceStatusUpdate_protocolIEs__item__criticality._const_tab = ____ResourceStatusUpdate_protocolIEs__item__id_tab
    ___ResourceStatusUpdate_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceStatusUpdate_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ResourceStatusUpdate_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___ResourceStatusUpdate_protocolIEs__item__value._const_tab = ____ResourceStatusUpdate_protocolIEs__item__id_tab
    ___ResourceStatusUpdate_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ResourceStatusUpdate_protocolIEs__item__value._const_tab_id = 'Value'
    __ResourceStatusUpdate_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ResourceStatusUpdate_protocolIEs__item__id),
        ('criticality', ___ResourceStatusUpdate_protocolIEs__item__criticality),
        ('value', ___ResourceStatusUpdate_protocolIEs__item__value),
        ])
    __ResourceStatusUpdate_protocolIEs__item_._ext = None
    _ResourceStatusUpdate_protocolIEs._cont = __ResourceStatusUpdate_protocolIEs__item_
    _ResourceStatusUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResourceStatusUpdate._cont = ASN1Dict([
        ('protocolIEs', _ResourceStatusUpdate_protocolIEs),
        ])
    ResourceStatusUpdate._ext = []
    
    #-----< ResourceStatusUpdateIEs >-----#
    ResourceStatusUpdateIEs = CLASS(name='ResourceStatusUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _ResourceStatusUpdateIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _ResourceStatusUpdateIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBCUMeasurementID')))
    _ResourceStatusUpdateIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNBDUMeasurementID')))
    _ResourceStatusUpdateIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'HardwareLoadIndicator')))
    _ResourceStatusUpdateIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TNLCapacityIndicator')))
    _ResourceStatusUpdateIEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CellMeasurementResultList')))
    ResourceStatusUpdateIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _ResourceStatusUpdateIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 345), ('criticality', 'reject'), ('Value', _ResourceStatusUpdateIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 346), ('criticality', 'ignore'), ('Value', _ResourceStatusUpdateIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 351), ('criticality', 'ignore'), ('Value', _ResourceStatusUpdateIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 353), ('criticality', 'ignore'), ('Value', _ResourceStatusUpdateIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 350), ('criticality', 'ignore'), ('Value', _ResourceStatusUpdateIEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< AccessAndMobilityIndication >-----#
    AccessAndMobilityIndication = SEQ(name='AccessAndMobilityIndication', mode=MODE_TYPE)
    _AccessAndMobilityIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __AccessAndMobilityIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___AccessAndMobilityIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____AccessAndMobilityIndication_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____AccessAndMobilityIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____AccessAndMobilityIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RACHReportInformationList')))
    _____AccessAndMobilityIndication_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLFReportInformationList')))
    _____AccessAndMobilityIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SuccessfulHOReportInformationList')))
    ____AccessAndMobilityIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____AccessAndMobilityIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 359), ('criticality', 'ignore'), ('Value', _____AccessAndMobilityIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 360), ('criticality', 'ignore'), ('Value', _____AccessAndMobilityIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 443), ('criticality', 'ignore'), ('Value', _____AccessAndMobilityIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___AccessAndMobilityIndication_protocolIEs__item__id._const_tab = ____AccessAndMobilityIndication_protocolIEs__item__id_tab
    ___AccessAndMobilityIndication_protocolIEs__item__id._const_tab_at = None
    ___AccessAndMobilityIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___AccessAndMobilityIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___AccessAndMobilityIndication_protocolIEs__item__criticality._const_tab = ____AccessAndMobilityIndication_protocolIEs__item__id_tab
    ___AccessAndMobilityIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___AccessAndMobilityIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___AccessAndMobilityIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___AccessAndMobilityIndication_protocolIEs__item__value._const_tab = ____AccessAndMobilityIndication_protocolIEs__item__id_tab
    ___AccessAndMobilityIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___AccessAndMobilityIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __AccessAndMobilityIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___AccessAndMobilityIndication_protocolIEs__item__id),
        ('criticality', ___AccessAndMobilityIndication_protocolIEs__item__criticality),
        ('value', ___AccessAndMobilityIndication_protocolIEs__item__value),
        ])
    __AccessAndMobilityIndication_protocolIEs__item_._ext = None
    _AccessAndMobilityIndication_protocolIEs._cont = __AccessAndMobilityIndication_protocolIEs__item_
    _AccessAndMobilityIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    AccessAndMobilityIndication._cont = ASN1Dict([
        ('protocolIEs', _AccessAndMobilityIndication_protocolIEs),
        ])
    AccessAndMobilityIndication._ext = []
    
    #-----< AccessAndMobilityIndicationIEs >-----#
    AccessAndMobilityIndicationIEs = CLASS(name='AccessAndMobilityIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _AccessAndMobilityIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _AccessAndMobilityIndicationIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RACHReportInformationList')))
    _AccessAndMobilityIndicationIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RLFReportInformationList')))
    _AccessAndMobilityIndicationIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SuccessfulHOReportInformationList')))
    AccessAndMobilityIndicationIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _AccessAndMobilityIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 359), ('criticality', 'ignore'), ('Value', _AccessAndMobilityIndicationIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 360), ('criticality', 'ignore'), ('Value', _AccessAndMobilityIndicationIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 443), ('criticality', 'ignore'), ('Value', _AccessAndMobilityIndicationIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ReferenceTimeInformationReportingControl >-----#
    ReferenceTimeInformationReportingControl = SEQ(name='ReferenceTimeInformationReportingControl', mode=MODE_TYPE)
    _ReferenceTimeInformationReportingControl_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __ReferenceTimeInformationReportingControl_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___ReferenceTimeInformationReportingControl_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____ReferenceTimeInformationReportingControl_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____ReferenceTimeInformationReportingControl_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____ReferenceTimeInformationReportingControl_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ReportingRequestType')))
    ____ReferenceTimeInformationReportingControl_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____ReferenceTimeInformationReportingControl_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 365), ('criticality', 'reject'), ('Value', _____ReferenceTimeInformationReportingControl_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___ReferenceTimeInformationReportingControl_protocolIEs__item__id._const_tab = ____ReferenceTimeInformationReportingControl_protocolIEs__item__id_tab
    ___ReferenceTimeInformationReportingControl_protocolIEs__item__id._const_tab_at = None
    ___ReferenceTimeInformationReportingControl_protocolIEs__item__id._const_tab_id = 'id'
    ___ReferenceTimeInformationReportingControl_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___ReferenceTimeInformationReportingControl_protocolIEs__item__criticality._const_tab = ____ReferenceTimeInformationReportingControl_protocolIEs__item__id_tab
    ___ReferenceTimeInformationReportingControl_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ReferenceTimeInformationReportingControl_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ReferenceTimeInformationReportingControl_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___ReferenceTimeInformationReportingControl_protocolIEs__item__value._const_tab = ____ReferenceTimeInformationReportingControl_protocolIEs__item__id_tab
    ___ReferenceTimeInformationReportingControl_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ReferenceTimeInformationReportingControl_protocolIEs__item__value._const_tab_id = 'Value'
    __ReferenceTimeInformationReportingControl_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ReferenceTimeInformationReportingControl_protocolIEs__item__id),
        ('criticality', ___ReferenceTimeInformationReportingControl_protocolIEs__item__criticality),
        ('value', ___ReferenceTimeInformationReportingControl_protocolIEs__item__value),
        ])
    __ReferenceTimeInformationReportingControl_protocolIEs__item_._ext = None
    _ReferenceTimeInformationReportingControl_protocolIEs._cont = __ReferenceTimeInformationReportingControl_protocolIEs__item_
    _ReferenceTimeInformationReportingControl_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ReferenceTimeInformationReportingControl._cont = ASN1Dict([
        ('protocolIEs', _ReferenceTimeInformationReportingControl_protocolIEs),
        ])
    ReferenceTimeInformationReportingControl._ext = []
    
    #-----< ReferenceTimeInformationReportingControlIEs >-----#
    ReferenceTimeInformationReportingControlIEs = CLASS(name='ReferenceTimeInformationReportingControlIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _ReferenceTimeInformationReportingControlIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _ReferenceTimeInformationReportingControlIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ReportingRequestType')))
    ReferenceTimeInformationReportingControlIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _ReferenceTimeInformationReportingControlIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 365), ('criticality', 'reject'), ('Value', _ReferenceTimeInformationReportingControlIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ReferenceTimeInformationReport >-----#
    ReferenceTimeInformationReport = SEQ(name='ReferenceTimeInformationReport', mode=MODE_TYPE)
    _ReferenceTimeInformationReport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __ReferenceTimeInformationReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___ReferenceTimeInformationReport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____ReferenceTimeInformationReport_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____ReferenceTimeInformationReport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____ReferenceTimeInformationReport_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeReferenceInformation')))
    ____ReferenceTimeInformationReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'ignore'), ('Value', _____ReferenceTimeInformationReport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 366), ('criticality', 'ignore'), ('Value', _____ReferenceTimeInformationReport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___ReferenceTimeInformationReport_protocolIEs__item__id._const_tab = ____ReferenceTimeInformationReport_protocolIEs__item__id_tab
    ___ReferenceTimeInformationReport_protocolIEs__item__id._const_tab_at = None
    ___ReferenceTimeInformationReport_protocolIEs__item__id._const_tab_id = 'id'
    ___ReferenceTimeInformationReport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___ReferenceTimeInformationReport_protocolIEs__item__criticality._const_tab = ____ReferenceTimeInformationReport_protocolIEs__item__id_tab
    ___ReferenceTimeInformationReport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ReferenceTimeInformationReport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ReferenceTimeInformationReport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___ReferenceTimeInformationReport_protocolIEs__item__value._const_tab = ____ReferenceTimeInformationReport_protocolIEs__item__id_tab
    ___ReferenceTimeInformationReport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ReferenceTimeInformationReport_protocolIEs__item__value._const_tab_id = 'Value'
    __ReferenceTimeInformationReport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ReferenceTimeInformationReport_protocolIEs__item__id),
        ('criticality', ___ReferenceTimeInformationReport_protocolIEs__item__criticality),
        ('value', ___ReferenceTimeInformationReport_protocolIEs__item__value),
        ])
    __ReferenceTimeInformationReport_protocolIEs__item_._ext = None
    _ReferenceTimeInformationReport_protocolIEs._cont = __ReferenceTimeInformationReport_protocolIEs__item_
    _ReferenceTimeInformationReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ReferenceTimeInformationReport._cont = ASN1Dict([
        ('protocolIEs', _ReferenceTimeInformationReport_protocolIEs),
        ])
    ReferenceTimeInformationReport._ext = []
    
    #-----< ReferenceTimeInformationReportIEs >-----#
    ReferenceTimeInformationReportIEs = CLASS(name='ReferenceTimeInformationReportIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _ReferenceTimeInformationReportIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _ReferenceTimeInformationReportIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TimeReferenceInformation')))
    ReferenceTimeInformationReportIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'ignore'), ('Value', _ReferenceTimeInformationReportIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 366), ('criticality', 'ignore'), ('Value', _ReferenceTimeInformationReportIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< AccessSuccess >-----#
    AccessSuccess = SEQ(name='AccessSuccess', mode=MODE_TYPE)
    _AccessSuccess_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __AccessSuccess_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___AccessSuccess_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____AccessSuccess_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____AccessSuccess_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____AccessSuccess_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____AccessSuccess_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    ____AccessSuccess_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____AccessSuccess_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____AccessSuccess_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 111), ('criticality', 'reject'), ('Value', _____AccessSuccess_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___AccessSuccess_protocolIEs__item__id._const_tab = ____AccessSuccess_protocolIEs__item__id_tab
    ___AccessSuccess_protocolIEs__item__id._const_tab_at = None
    ___AccessSuccess_protocolIEs__item__id._const_tab_id = 'id'
    ___AccessSuccess_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___AccessSuccess_protocolIEs__item__criticality._const_tab = ____AccessSuccess_protocolIEs__item__id_tab
    ___AccessSuccess_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___AccessSuccess_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___AccessSuccess_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___AccessSuccess_protocolIEs__item__value._const_tab = ____AccessSuccess_protocolIEs__item__id_tab
    ___AccessSuccess_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___AccessSuccess_protocolIEs__item__value._const_tab_id = 'Value'
    __AccessSuccess_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___AccessSuccess_protocolIEs__item__id),
        ('criticality', ___AccessSuccess_protocolIEs__item__criticality),
        ('value', ___AccessSuccess_protocolIEs__item__value),
        ])
    __AccessSuccess_protocolIEs__item_._ext = None
    _AccessSuccess_protocolIEs._cont = __AccessSuccess_protocolIEs__item_
    _AccessSuccess_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    AccessSuccess._cont = ASN1Dict([
        ('protocolIEs', _AccessSuccess_protocolIEs),
        ])
    AccessSuccess._ext = []
    
    #-----< AccessSuccessIEs >-----#
    AccessSuccessIEs = CLASS(name='AccessSuccessIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _AccessSuccessIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _AccessSuccessIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _AccessSuccessIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    AccessSuccessIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _AccessSuccessIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _AccessSuccessIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 111), ('criticality', 'reject'), ('Value', _AccessSuccessIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PositioningAssistanceInformationControl >-----#
    PositioningAssistanceInformationControl = SEQ(name='PositioningAssistanceInformationControl', mode=MODE_TYPE)
    _PositioningAssistanceInformationControl_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningAssistanceInformationControl_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningAssistanceInformationControl_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PositioningAssistanceInformationControl_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosAssistance-Information')))
    _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosBroadcast')))
    _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PositioningBroadcastCells')))
    _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RoutingID')))
    ____PositioningAssistanceInformationControl_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 392), ('criticality', 'reject'), ('Value', _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 393), ('criticality', 'reject'), ('Value', _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 406), ('criticality', 'reject'), ('Value', _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 394), ('criticality', 'reject'), ('Value', _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositioningAssistanceInformationControl_protocolIEs__item__id._const_tab = ____PositioningAssistanceInformationControl_protocolIEs__item__id_tab
    ___PositioningAssistanceInformationControl_protocolIEs__item__id._const_tab_at = None
    ___PositioningAssistanceInformationControl_protocolIEs__item__id._const_tab_id = 'id'
    ___PositioningAssistanceInformationControl_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PositioningAssistanceInformationControl_protocolIEs__item__criticality._const_tab = ____PositioningAssistanceInformationControl_protocolIEs__item__id_tab
    ___PositioningAssistanceInformationControl_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningAssistanceInformationControl_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositioningAssistanceInformationControl_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PositioningAssistanceInformationControl_protocolIEs__item__value._const_tab = ____PositioningAssistanceInformationControl_protocolIEs__item__id_tab
    ___PositioningAssistanceInformationControl_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositioningAssistanceInformationControl_protocolIEs__item__value._const_tab_id = 'Value'
    __PositioningAssistanceInformationControl_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositioningAssistanceInformationControl_protocolIEs__item__id),
        ('criticality', ___PositioningAssistanceInformationControl_protocolIEs__item__criticality),
        ('value', ___PositioningAssistanceInformationControl_protocolIEs__item__value),
        ])
    __PositioningAssistanceInformationControl_protocolIEs__item_._ext = None
    _PositioningAssistanceInformationControl_protocolIEs._cont = __PositioningAssistanceInformationControl_protocolIEs__item_
    _PositioningAssistanceInformationControl_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningAssistanceInformationControl._cont = ASN1Dict([
        ('protocolIEs', _PositioningAssistanceInformationControl_protocolIEs),
        ])
    PositioningAssistanceInformationControl._ext = []
    
    #-----< PositioningAssistanceInformationControlIEs >-----#
    PositioningAssistanceInformationControlIEs = CLASS(name='PositioningAssistanceInformationControlIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningAssistanceInformationControlIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PositioningAssistanceInformationControlIEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosAssistance-Information')))
    _PositioningAssistanceInformationControlIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosBroadcast')))
    _PositioningAssistanceInformationControlIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PositioningBroadcastCells')))
    _PositioningAssistanceInformationControlIEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RoutingID')))
    PositioningAssistanceInformationControlIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _PositioningAssistanceInformationControlIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 392), ('criticality', 'reject'), ('Value', _PositioningAssistanceInformationControlIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 393), ('criticality', 'reject'), ('Value', _PositioningAssistanceInformationControlIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 406), ('criticality', 'reject'), ('Value', _PositioningAssistanceInformationControlIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 394), ('criticality', 'reject'), ('Value', _PositioningAssistanceInformationControlIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningAssistanceInformationFeedback >-----#
    PositioningAssistanceInformationFeedback = SEQ(name='PositioningAssistanceInformationFeedback', mode=MODE_TYPE)
    _PositioningAssistanceInformationFeedback_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningAssistanceInformationFeedback_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningAssistanceInformationFeedback_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosAssistanceInformationFailureList')))
    _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PositioningBroadcastCells')))
    _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RoutingID')))
    _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 395), ('criticality', 'reject'), ('Value', _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 406), ('criticality', 'reject'), ('Value', _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 394), ('criticality', 'reject'), ('Value', _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositioningAssistanceInformationFeedback_protocolIEs__item__id._const_tab = ____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab
    ___PositioningAssistanceInformationFeedback_protocolIEs__item__id._const_tab_at = None
    ___PositioningAssistanceInformationFeedback_protocolIEs__item__id._const_tab_id = 'id'
    ___PositioningAssistanceInformationFeedback_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PositioningAssistanceInformationFeedback_protocolIEs__item__criticality._const_tab = ____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab
    ___PositioningAssistanceInformationFeedback_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningAssistanceInformationFeedback_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositioningAssistanceInformationFeedback_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PositioningAssistanceInformationFeedback_protocolIEs__item__value._const_tab = ____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab
    ___PositioningAssistanceInformationFeedback_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositioningAssistanceInformationFeedback_protocolIEs__item__value._const_tab_id = 'Value'
    __PositioningAssistanceInformationFeedback_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositioningAssistanceInformationFeedback_protocolIEs__item__id),
        ('criticality', ___PositioningAssistanceInformationFeedback_protocolIEs__item__criticality),
        ('value', ___PositioningAssistanceInformationFeedback_protocolIEs__item__value),
        ])
    __PositioningAssistanceInformationFeedback_protocolIEs__item_._ext = None
    _PositioningAssistanceInformationFeedback_protocolIEs._cont = __PositioningAssistanceInformationFeedback_protocolIEs__item_
    _PositioningAssistanceInformationFeedback_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningAssistanceInformationFeedback._cont = ASN1Dict([
        ('protocolIEs', _PositioningAssistanceInformationFeedback_protocolIEs),
        ])
    PositioningAssistanceInformationFeedback._ext = []
    
    #-----< PositioningAssistanceInformationFeedbackIEs >-----#
    PositioningAssistanceInformationFeedbackIEs = CLASS(name='PositioningAssistanceInformationFeedbackIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningAssistanceInformationFeedbackIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PositioningAssistanceInformationFeedbackIEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosAssistanceInformationFailureList')))
    _PositioningAssistanceInformationFeedbackIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PositioningBroadcastCells')))
    _PositioningAssistanceInformationFeedbackIEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RoutingID')))
    _PositioningAssistanceInformationFeedbackIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    PositioningAssistanceInformationFeedbackIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _PositioningAssistanceInformationFeedbackIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 395), ('criticality', 'reject'), ('Value', _PositioningAssistanceInformationFeedbackIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 406), ('criticality', 'reject'), ('Value', _PositioningAssistanceInformationFeedbackIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 394), ('criticality', 'reject'), ('Value', _PositioningAssistanceInformationFeedbackIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _PositioningAssistanceInformationFeedbackIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningMeasurementRequest >-----#
    PositioningMeasurementRequest = SEQ(name='PositioningMeasurementRequest', mode=MODE_TYPE)
    _PositioningMeasurementRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningMeasurementRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningMeasurementRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PositioningMeasurementRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRP-MeasurementRequestList')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosReportCharacteristics')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementPeriodicity')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementQuantities')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_7 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RelativeTime1900')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSConfiguration')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementBeamInfoRequest')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_10 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SystemFrameNumber')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_11 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SlotNumber')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementPeriodicityExtended')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_13 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResponseTime')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_14 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementCharacteristicsRequestIndicator')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_15 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementTimeOccasion')))
    _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_16 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementAmount')))
    ____PositioningMeasurementRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 402), ('criticality', 'reject'), ('Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 411), ('criticality', 'reject'), ('Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 422), ('criticality', 'reject'), ('Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 408), ('criticality', 'reject'), ('Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 409), ('criticality', 'reject'), ('Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'conditional')]), dict([('id', 396), ('criticality', 'reject'), ('Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'mandatory')]), dict([('id', 419), ('criticality', 'ignore'), ('Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 407), ('criticality', 'ignore'), ('Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 423), ('criticality', 'ignore'), ('Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 420), ('criticality', 'ignore'), ('Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 421), ('criticality', 'ignore'), ('Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 438), ('criticality', 'reject'), ('Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_12), ('presence', 'conditional')]), dict([('id', 555), ('criticality', 'ignore'), ('Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 574), ('criticality', 'ignore'), ('Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 573), ('criticality', 'ignore'), ('Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 634), ('criticality', 'ignore'), ('Value', _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositioningMeasurementRequest_protocolIEs__item__id._const_tab = ____PositioningMeasurementRequest_protocolIEs__item__id_tab
    ___PositioningMeasurementRequest_protocolIEs__item__id._const_tab_at = None
    ___PositioningMeasurementRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___PositioningMeasurementRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PositioningMeasurementRequest_protocolIEs__item__criticality._const_tab = ____PositioningMeasurementRequest_protocolIEs__item__id_tab
    ___PositioningMeasurementRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningMeasurementRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositioningMeasurementRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PositioningMeasurementRequest_protocolIEs__item__value._const_tab = ____PositioningMeasurementRequest_protocolIEs__item__id_tab
    ___PositioningMeasurementRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositioningMeasurementRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __PositioningMeasurementRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositioningMeasurementRequest_protocolIEs__item__id),
        ('criticality', ___PositioningMeasurementRequest_protocolIEs__item__criticality),
        ('value', ___PositioningMeasurementRequest_protocolIEs__item__value),
        ])
    __PositioningMeasurementRequest_protocolIEs__item_._ext = None
    _PositioningMeasurementRequest_protocolIEs._cont = __PositioningMeasurementRequest_protocolIEs__item_
    _PositioningMeasurementRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningMeasurementRequest._cont = ASN1Dict([
        ('protocolIEs', _PositioningMeasurementRequest_protocolIEs),
        ])
    PositioningMeasurementRequest._ext = []
    
    #-----< PositioningMeasurementRequestIEs >-----#
    PositioningMeasurementRequestIEs = CLASS(name='PositioningMeasurementRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningMeasurementRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PositioningMeasurementRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _PositioningMeasurementRequestIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    _PositioningMeasurementRequestIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRP-MeasurementRequestList')))
    _PositioningMeasurementRequestIEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosReportCharacteristics')))
    _PositioningMeasurementRequestIEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementPeriodicity')))
    _PositioningMeasurementRequestIEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementQuantities')))
    _PositioningMeasurementRequestIEs_val_Value_7 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RelativeTime1900')))
    _PositioningMeasurementRequestIEs_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSConfiguration')))
    _PositioningMeasurementRequestIEs_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementBeamInfoRequest')))
    _PositioningMeasurementRequestIEs_val_Value_10 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SystemFrameNumber')))
    _PositioningMeasurementRequestIEs_val_Value_11 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SlotNumber')))
    _PositioningMeasurementRequestIEs_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementPeriodicityExtended')))
    _PositioningMeasurementRequestIEs_val_Value_13 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ResponseTime')))
    _PositioningMeasurementRequestIEs_val_Value_14 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementCharacteristicsRequestIndicator')))
    _PositioningMeasurementRequestIEs_val_Value_15 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementTimeOccasion')))
    _PositioningMeasurementRequestIEs_val_Value_16 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementAmount')))
    PositioningMeasurementRequestIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _PositioningMeasurementRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 402), ('criticality', 'reject'), ('Value', _PositioningMeasurementRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 411), ('criticality', 'reject'), ('Value', _PositioningMeasurementRequestIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 422), ('criticality', 'reject'), ('Value', _PositioningMeasurementRequestIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 408), ('criticality', 'reject'), ('Value', _PositioningMeasurementRequestIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 409), ('criticality', 'reject'), ('Value', _PositioningMeasurementRequestIEs_val_Value_5), ('presence', 'conditional')]), dict([('id', 396), ('criticality', 'reject'), ('Value', _PositioningMeasurementRequestIEs_val_Value_6), ('presence', 'mandatory')]), dict([('id', 419), ('criticality', 'ignore'), ('Value', _PositioningMeasurementRequestIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 407), ('criticality', 'ignore'), ('Value', _PositioningMeasurementRequestIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 423), ('criticality', 'ignore'), ('Value', _PositioningMeasurementRequestIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 420), ('criticality', 'ignore'), ('Value', _PositioningMeasurementRequestIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 421), ('criticality', 'ignore'), ('Value', _PositioningMeasurementRequestIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 438), ('criticality', 'reject'), ('Value', _PositioningMeasurementRequestIEs_val_Value_12), ('presence', 'conditional')]), dict([('id', 555), ('criticality', 'ignore'), ('Value', _PositioningMeasurementRequestIEs_val_Value_13), ('presence', 'optional')]), dict([('id', 574), ('criticality', 'ignore'), ('Value', _PositioningMeasurementRequestIEs_val_Value_14), ('presence', 'optional')]), dict([('id', 573), ('criticality', 'ignore'), ('Value', _PositioningMeasurementRequestIEs_val_Value_15), ('presence', 'optional')]), dict([('id', 634), ('criticality', 'ignore'), ('Value', _PositioningMeasurementRequestIEs_val_Value_16), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningMeasurementResponse >-----#
    PositioningMeasurementResponse = SEQ(name='PositioningMeasurementResponse', mode=MODE_TYPE)
    _PositioningMeasurementResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningMeasurementResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningMeasurementResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PositioningMeasurementResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementResultList')))
    _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____PositioningMeasurementResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 402), ('criticality', 'reject'), ('Value', _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 411), ('criticality', 'reject'), ('Value', _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 397), ('criticality', 'reject'), ('Value', _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositioningMeasurementResponse_protocolIEs__item__id._const_tab = ____PositioningMeasurementResponse_protocolIEs__item__id_tab
    ___PositioningMeasurementResponse_protocolIEs__item__id._const_tab_at = None
    ___PositioningMeasurementResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___PositioningMeasurementResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PositioningMeasurementResponse_protocolIEs__item__criticality._const_tab = ____PositioningMeasurementResponse_protocolIEs__item__id_tab
    ___PositioningMeasurementResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningMeasurementResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositioningMeasurementResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PositioningMeasurementResponse_protocolIEs__item__value._const_tab = ____PositioningMeasurementResponse_protocolIEs__item__id_tab
    ___PositioningMeasurementResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositioningMeasurementResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __PositioningMeasurementResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositioningMeasurementResponse_protocolIEs__item__id),
        ('criticality', ___PositioningMeasurementResponse_protocolIEs__item__criticality),
        ('value', ___PositioningMeasurementResponse_protocolIEs__item__value),
        ])
    __PositioningMeasurementResponse_protocolIEs__item_._ext = None
    _PositioningMeasurementResponse_protocolIEs._cont = __PositioningMeasurementResponse_protocolIEs__item_
    _PositioningMeasurementResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningMeasurementResponse._cont = ASN1Dict([
        ('protocolIEs', _PositioningMeasurementResponse_protocolIEs),
        ])
    PositioningMeasurementResponse._ext = []
    
    #-----< PositioningMeasurementResponseIEs >-----#
    PositioningMeasurementResponseIEs = CLASS(name='PositioningMeasurementResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningMeasurementResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PositioningMeasurementResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _PositioningMeasurementResponseIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    _PositioningMeasurementResponseIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementResultList')))
    _PositioningMeasurementResponseIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    PositioningMeasurementResponseIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _PositioningMeasurementResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 402), ('criticality', 'reject'), ('Value', _PositioningMeasurementResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 411), ('criticality', 'reject'), ('Value', _PositioningMeasurementResponseIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 397), ('criticality', 'reject'), ('Value', _PositioningMeasurementResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _PositioningMeasurementResponseIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningMeasurementFailure >-----#
    PositioningMeasurementFailure = SEQ(name='PositioningMeasurementFailure', mode=MODE_TYPE)
    _PositioningMeasurementFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningMeasurementFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningMeasurementFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PositioningMeasurementFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____PositioningMeasurementFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 402), ('criticality', 'reject'), ('Value', _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 411), ('criticality', 'reject'), ('Value', _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositioningMeasurementFailure_protocolIEs__item__id._const_tab = ____PositioningMeasurementFailure_protocolIEs__item__id_tab
    ___PositioningMeasurementFailure_protocolIEs__item__id._const_tab_at = None
    ___PositioningMeasurementFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___PositioningMeasurementFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PositioningMeasurementFailure_protocolIEs__item__criticality._const_tab = ____PositioningMeasurementFailure_protocolIEs__item__id_tab
    ___PositioningMeasurementFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningMeasurementFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositioningMeasurementFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PositioningMeasurementFailure_protocolIEs__item__value._const_tab = ____PositioningMeasurementFailure_protocolIEs__item__id_tab
    ___PositioningMeasurementFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositioningMeasurementFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __PositioningMeasurementFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositioningMeasurementFailure_protocolIEs__item__id),
        ('criticality', ___PositioningMeasurementFailure_protocolIEs__item__criticality),
        ('value', ___PositioningMeasurementFailure_protocolIEs__item__value),
        ])
    __PositioningMeasurementFailure_protocolIEs__item_._ext = None
    _PositioningMeasurementFailure_protocolIEs._cont = __PositioningMeasurementFailure_protocolIEs__item_
    _PositioningMeasurementFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningMeasurementFailure._cont = ASN1Dict([
        ('protocolIEs', _PositioningMeasurementFailure_protocolIEs),
        ])
    PositioningMeasurementFailure._ext = []
    
    #-----< PositioningMeasurementFailureIEs >-----#
    PositioningMeasurementFailureIEs = CLASS(name='PositioningMeasurementFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningMeasurementFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PositioningMeasurementFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _PositioningMeasurementFailureIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    _PositioningMeasurementFailureIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _PositioningMeasurementFailureIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    PositioningMeasurementFailureIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _PositioningMeasurementFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 402), ('criticality', 'reject'), ('Value', _PositioningMeasurementFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 411), ('criticality', 'reject'), ('Value', _PositioningMeasurementFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _PositioningMeasurementFailureIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _PositioningMeasurementFailureIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningMeasurementReport >-----#
    PositioningMeasurementReport = SEQ(name='PositioningMeasurementReport', mode=MODE_TYPE)
    _PositioningMeasurementReport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningMeasurementReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningMeasurementReport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PositioningMeasurementReport_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningMeasurementReport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PositioningMeasurementReport_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _____PositioningMeasurementReport_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    _____PositioningMeasurementReport_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementResultList')))
    ____PositioningMeasurementReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____PositioningMeasurementReport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 402), ('criticality', 'reject'), ('Value', _____PositioningMeasurementReport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 411), ('criticality', 'reject'), ('Value', _____PositioningMeasurementReport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 397), ('criticality', 'reject'), ('Value', _____PositioningMeasurementReport_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___PositioningMeasurementReport_protocolIEs__item__id._const_tab = ____PositioningMeasurementReport_protocolIEs__item__id_tab
    ___PositioningMeasurementReport_protocolIEs__item__id._const_tab_at = None
    ___PositioningMeasurementReport_protocolIEs__item__id._const_tab_id = 'id'
    ___PositioningMeasurementReport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PositioningMeasurementReport_protocolIEs__item__criticality._const_tab = ____PositioningMeasurementReport_protocolIEs__item__id_tab
    ___PositioningMeasurementReport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningMeasurementReport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositioningMeasurementReport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PositioningMeasurementReport_protocolIEs__item__value._const_tab = ____PositioningMeasurementReport_protocolIEs__item__id_tab
    ___PositioningMeasurementReport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositioningMeasurementReport_protocolIEs__item__value._const_tab_id = 'Value'
    __PositioningMeasurementReport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositioningMeasurementReport_protocolIEs__item__id),
        ('criticality', ___PositioningMeasurementReport_protocolIEs__item__criticality),
        ('value', ___PositioningMeasurementReport_protocolIEs__item__value),
        ])
    __PositioningMeasurementReport_protocolIEs__item_._ext = None
    _PositioningMeasurementReport_protocolIEs._cont = __PositioningMeasurementReport_protocolIEs__item_
    _PositioningMeasurementReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningMeasurementReport._cont = ASN1Dict([
        ('protocolIEs', _PositioningMeasurementReport_protocolIEs),
        ])
    PositioningMeasurementReport._ext = []
    
    #-----< PositioningMeasurementReportIEs >-----#
    PositioningMeasurementReportIEs = CLASS(name='PositioningMeasurementReportIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningMeasurementReportIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PositioningMeasurementReportIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _PositioningMeasurementReportIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    _PositioningMeasurementReportIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementResultList')))
    PositioningMeasurementReportIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _PositioningMeasurementReportIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 402), ('criticality', 'reject'), ('Value', _PositioningMeasurementReportIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 411), ('criticality', 'reject'), ('Value', _PositioningMeasurementReportIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 397), ('criticality', 'reject'), ('Value', _PositioningMeasurementReportIEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PositioningMeasurementAbort >-----#
    PositioningMeasurementAbort = SEQ(name='PositioningMeasurementAbort', mode=MODE_TYPE)
    _PositioningMeasurementAbort_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningMeasurementAbort_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningMeasurementAbort_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PositioningMeasurementAbort_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningMeasurementAbort_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PositioningMeasurementAbort_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _____PositioningMeasurementAbort_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    ____PositioningMeasurementAbort_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____PositioningMeasurementAbort_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 402), ('criticality', 'reject'), ('Value', _____PositioningMeasurementAbort_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 411), ('criticality', 'reject'), ('Value', _____PositioningMeasurementAbort_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___PositioningMeasurementAbort_protocolIEs__item__id._const_tab = ____PositioningMeasurementAbort_protocolIEs__item__id_tab
    ___PositioningMeasurementAbort_protocolIEs__item__id._const_tab_at = None
    ___PositioningMeasurementAbort_protocolIEs__item__id._const_tab_id = 'id'
    ___PositioningMeasurementAbort_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PositioningMeasurementAbort_protocolIEs__item__criticality._const_tab = ____PositioningMeasurementAbort_protocolIEs__item__id_tab
    ___PositioningMeasurementAbort_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningMeasurementAbort_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositioningMeasurementAbort_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PositioningMeasurementAbort_protocolIEs__item__value._const_tab = ____PositioningMeasurementAbort_protocolIEs__item__id_tab
    ___PositioningMeasurementAbort_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositioningMeasurementAbort_protocolIEs__item__value._const_tab_id = 'Value'
    __PositioningMeasurementAbort_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositioningMeasurementAbort_protocolIEs__item__id),
        ('criticality', ___PositioningMeasurementAbort_protocolIEs__item__criticality),
        ('value', ___PositioningMeasurementAbort_protocolIEs__item__value),
        ])
    __PositioningMeasurementAbort_protocolIEs__item_._ext = None
    _PositioningMeasurementAbort_protocolIEs._cont = __PositioningMeasurementAbort_protocolIEs__item_
    _PositioningMeasurementAbort_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningMeasurementAbort._cont = ASN1Dict([
        ('protocolIEs', _PositioningMeasurementAbort_protocolIEs),
        ])
    PositioningMeasurementAbort._ext = []
    
    #-----< PositioningMeasurementAbortIEs >-----#
    PositioningMeasurementAbortIEs = CLASS(name='PositioningMeasurementAbortIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningMeasurementAbortIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PositioningMeasurementAbortIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _PositioningMeasurementAbortIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    PositioningMeasurementAbortIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _PositioningMeasurementAbortIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 402), ('criticality', 'reject'), ('Value', _PositioningMeasurementAbortIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 411), ('criticality', 'reject'), ('Value', _PositioningMeasurementAbortIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PositioningMeasurementFailureIndication >-----#
    PositioningMeasurementFailureIndication = SEQ(name='PositioningMeasurementFailureIndication', mode=MODE_TYPE)
    _PositioningMeasurementFailureIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningMeasurementFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningMeasurementFailureIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    _____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    ____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 402), ('criticality', 'reject'), ('Value', _____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 411), ('criticality', 'reject'), ('Value', _____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___PositioningMeasurementFailureIndication_protocolIEs__item__id._const_tab = ____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab
    ___PositioningMeasurementFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___PositioningMeasurementFailureIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___PositioningMeasurementFailureIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PositioningMeasurementFailureIndication_protocolIEs__item__criticality._const_tab = ____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab
    ___PositioningMeasurementFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningMeasurementFailureIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositioningMeasurementFailureIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PositioningMeasurementFailureIndication_protocolIEs__item__value._const_tab = ____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab
    ___PositioningMeasurementFailureIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositioningMeasurementFailureIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __PositioningMeasurementFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositioningMeasurementFailureIndication_protocolIEs__item__id),
        ('criticality', ___PositioningMeasurementFailureIndication_protocolIEs__item__criticality),
        ('value', ___PositioningMeasurementFailureIndication_protocolIEs__item__value),
        ])
    __PositioningMeasurementFailureIndication_protocolIEs__item_._ext = None
    _PositioningMeasurementFailureIndication_protocolIEs._cont = __PositioningMeasurementFailureIndication_protocolIEs__item_
    _PositioningMeasurementFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningMeasurementFailureIndication._cont = ASN1Dict([
        ('protocolIEs', _PositioningMeasurementFailureIndication_protocolIEs),
        ])
    PositioningMeasurementFailureIndication._ext = []
    
    #-----< PositioningMeasurementFailureIndicationIEs >-----#
    PositioningMeasurementFailureIndicationIEs = CLASS(name='PositioningMeasurementFailureIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningMeasurementFailureIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PositioningMeasurementFailureIndicationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _PositioningMeasurementFailureIndicationIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    _PositioningMeasurementFailureIndicationIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    PositioningMeasurementFailureIndicationIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _PositioningMeasurementFailureIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 402), ('criticality', 'reject'), ('Value', _PositioningMeasurementFailureIndicationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 411), ('criticality', 'reject'), ('Value', _PositioningMeasurementFailureIndicationIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _PositioningMeasurementFailureIndicationIEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PositioningMeasurementUpdate >-----#
    PositioningMeasurementUpdate = SEQ(name='PositioningMeasurementUpdate', mode=MODE_TYPE)
    _PositioningMeasurementUpdate_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningMeasurementUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningMeasurementUpdate_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PositioningMeasurementUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSConfiguration')))
    _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRP-MeasurementUpdateList')))
    _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_5 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementCharacteristicsRequestIndicator')))
    _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementTimeOccasion')))
    ____PositioningMeasurementUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 402), ('criticality', 'reject'), ('Value', _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 411), ('criticality', 'reject'), ('Value', _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 407), ('criticality', 'ignore'), ('Value', _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 553), ('criticality', 'reject'), ('Value', _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 574), ('criticality', 'ignore'), ('Value', _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 573), ('criticality', 'ignore'), ('Value', _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositioningMeasurementUpdate_protocolIEs__item__id._const_tab = ____PositioningMeasurementUpdate_protocolIEs__item__id_tab
    ___PositioningMeasurementUpdate_protocolIEs__item__id._const_tab_at = None
    ___PositioningMeasurementUpdate_protocolIEs__item__id._const_tab_id = 'id'
    ___PositioningMeasurementUpdate_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PositioningMeasurementUpdate_protocolIEs__item__criticality._const_tab = ____PositioningMeasurementUpdate_protocolIEs__item__id_tab
    ___PositioningMeasurementUpdate_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningMeasurementUpdate_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositioningMeasurementUpdate_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PositioningMeasurementUpdate_protocolIEs__item__value._const_tab = ____PositioningMeasurementUpdate_protocolIEs__item__id_tab
    ___PositioningMeasurementUpdate_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositioningMeasurementUpdate_protocolIEs__item__value._const_tab_id = 'Value'
    __PositioningMeasurementUpdate_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositioningMeasurementUpdate_protocolIEs__item__id),
        ('criticality', ___PositioningMeasurementUpdate_protocolIEs__item__criticality),
        ('value', ___PositioningMeasurementUpdate_protocolIEs__item__value),
        ])
    __PositioningMeasurementUpdate_protocolIEs__item_._ext = None
    _PositioningMeasurementUpdate_protocolIEs._cont = __PositioningMeasurementUpdate_protocolIEs__item_
    _PositioningMeasurementUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningMeasurementUpdate._cont = ASN1Dict([
        ('protocolIEs', _PositioningMeasurementUpdate_protocolIEs),
        ])
    PositioningMeasurementUpdate._ext = []
    
    #-----< PositioningMeasurementUpdateIEs >-----#
    PositioningMeasurementUpdateIEs = CLASS(name='PositioningMeasurementUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningMeasurementUpdateIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PositioningMeasurementUpdateIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-MeasurementID')))
    _PositioningMeasurementUpdateIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-MeasurementID')))
    _PositioningMeasurementUpdateIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSConfiguration')))
    _PositioningMeasurementUpdateIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRP-MeasurementUpdateList')))
    _PositioningMeasurementUpdateIEs_val_Value_5 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementCharacteristicsRequestIndicator')))
    _PositioningMeasurementUpdateIEs_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementTimeOccasion')))
    PositioningMeasurementUpdateIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _PositioningMeasurementUpdateIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 402), ('criticality', 'reject'), ('Value', _PositioningMeasurementUpdateIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 411), ('criticality', 'reject'), ('Value', _PositioningMeasurementUpdateIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 407), ('criticality', 'ignore'), ('Value', _PositioningMeasurementUpdateIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 553), ('criticality', 'reject'), ('Value', _PositioningMeasurementUpdateIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 574), ('criticality', 'ignore'), ('Value', _PositioningMeasurementUpdateIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 573), ('criticality', 'ignore'), ('Value', _PositioningMeasurementUpdateIEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TRPInformationRequest >-----#
    TRPInformationRequest = SEQ(name='TRPInformationRequest', mode=MODE_TYPE)
    _TRPInformationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __TRPInformationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___TRPInformationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____TRPInformationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPList')))
    _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationTypeListTRPReq')))
    ____TRPInformationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 410), ('criticality', 'ignore'), ('Value', _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 398), ('criticality', 'reject'), ('Value', _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___TRPInformationRequest_protocolIEs__item__id._const_tab = ____TRPInformationRequest_protocolIEs__item__id_tab
    ___TRPInformationRequest_protocolIEs__item__id._const_tab_at = None
    ___TRPInformationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___TRPInformationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___TRPInformationRequest_protocolIEs__item__criticality._const_tab = ____TRPInformationRequest_protocolIEs__item__id_tab
    ___TRPInformationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___TRPInformationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___TRPInformationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___TRPInformationRequest_protocolIEs__item__value._const_tab = ____TRPInformationRequest_protocolIEs__item__id_tab
    ___TRPInformationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___TRPInformationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __TRPInformationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___TRPInformationRequest_protocolIEs__item__id),
        ('criticality', ___TRPInformationRequest_protocolIEs__item__criticality),
        ('value', ___TRPInformationRequest_protocolIEs__item__value),
        ])
    __TRPInformationRequest_protocolIEs__item_._ext = None
    _TRPInformationRequest_protocolIEs._cont = __TRPInformationRequest_protocolIEs__item_
    _TRPInformationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TRPInformationRequest._cont = ASN1Dict([
        ('protocolIEs', _TRPInformationRequest_protocolIEs),
        ])
    TRPInformationRequest._ext = []
    
    #-----< TRPInformationRequestIEs >-----#
    TRPInformationRequestIEs = CLASS(name='TRPInformationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _TRPInformationRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _TRPInformationRequestIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPList')))
    _TRPInformationRequestIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationTypeListTRPReq')))
    TRPInformationRequestIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _TRPInformationRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 410), ('criticality', 'ignore'), ('Value', _TRPInformationRequestIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 398), ('criticality', 'reject'), ('Value', _TRPInformationRequestIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TRPInformationTypeListTRPReq >-----#
    TRPInformationTypeListTRPReq = SEQ_OF(name='TRPInformationTypeListTRPReq', mode=MODE_TYPE)
    _TRPInformationTypeListTRPReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __TRPInformationTypeListTRPReq__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___TRPInformationTypeListTRPReq__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____TRPInformationTypeListTRPReq__item__id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPInformationTypeItem')))
    ___TRPInformationTypeListTRPReq__item__id_tab._val = ASN1Set(rv=[dict([('id', 399), ('criticality', 'reject'), ('Value', ____TRPInformationTypeListTRPReq__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __TRPInformationTypeListTRPReq__item__id._const_tab = ___TRPInformationTypeListTRPReq__item__id_tab
    __TRPInformationTypeListTRPReq__item__id._const_tab_at = None
    __TRPInformationTypeListTRPReq__item__id._const_tab_id = 'id'
    __TRPInformationTypeListTRPReq__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __TRPInformationTypeListTRPReq__item__criticality._const_tab = ___TRPInformationTypeListTRPReq__item__id_tab
    __TRPInformationTypeListTRPReq__item__criticality._const_tab_at = ('..', 'id')
    __TRPInformationTypeListTRPReq__item__criticality._const_tab_id = 'criticality'
    __TRPInformationTypeListTRPReq__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __TRPInformationTypeListTRPReq__item__value._const_tab = ___TRPInformationTypeListTRPReq__item__id_tab
    __TRPInformationTypeListTRPReq__item__value._const_tab_at = ('..', 'id')
    __TRPInformationTypeListTRPReq__item__value._const_tab_id = 'Value'
    _TRPInformationTypeListTRPReq__item_._cont = ASN1Dict([
        ('id', __TRPInformationTypeListTRPReq__item__id),
        ('criticality', __TRPInformationTypeListTRPReq__item__criticality),
        ('value', __TRPInformationTypeListTRPReq__item__value),
        ])
    _TRPInformationTypeListTRPReq__item_._ext = None
    TRPInformationTypeListTRPReq._cont = _TRPInformationTypeListTRPReq__item_
    TRPInformationTypeListTRPReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< TRPInformationTypeItemTRPReq >-----#
    TRPInformationTypeItemTRPReq = CLASS(name='TRPInformationTypeItemTRPReq', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _TRPInformationTypeItemTRPReq_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPInformationTypeItem')))
    TRPInformationTypeItemTRPReq._val = ASN1Set(rv=[dict([('id', 399), ('criticality', 'reject'), ('Value', _TRPInformationTypeItemTRPReq_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TRPInformationResponse >-----#
    TRPInformationResponse = SEQ(name='TRPInformationResponse', mode=MODE_TYPE)
    _TRPInformationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __TRPInformationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___TRPInformationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____TRPInformationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationListTRPResp')))
    _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____TRPInformationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 400), ('criticality', 'ignore'), ('Value', _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TRPInformationResponse_protocolIEs__item__id._const_tab = ____TRPInformationResponse_protocolIEs__item__id_tab
    ___TRPInformationResponse_protocolIEs__item__id._const_tab_at = None
    ___TRPInformationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___TRPInformationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___TRPInformationResponse_protocolIEs__item__criticality._const_tab = ____TRPInformationResponse_protocolIEs__item__id_tab
    ___TRPInformationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___TRPInformationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___TRPInformationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___TRPInformationResponse_protocolIEs__item__value._const_tab = ____TRPInformationResponse_protocolIEs__item__id_tab
    ___TRPInformationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___TRPInformationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __TRPInformationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___TRPInformationResponse_protocolIEs__item__id),
        ('criticality', ___TRPInformationResponse_protocolIEs__item__criticality),
        ('value', ___TRPInformationResponse_protocolIEs__item__value),
        ])
    __TRPInformationResponse_protocolIEs__item_._ext = None
    _TRPInformationResponse_protocolIEs._cont = __TRPInformationResponse_protocolIEs__item_
    _TRPInformationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TRPInformationResponse._cont = ASN1Dict([
        ('protocolIEs', _TRPInformationResponse_protocolIEs),
        ])
    TRPInformationResponse._ext = []
    
    #-----< TRPInformationResponseIEs >-----#
    TRPInformationResponseIEs = CLASS(name='TRPInformationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _TRPInformationResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _TRPInformationResponseIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationListTRPResp')))
    _TRPInformationResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    TRPInformationResponseIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _TRPInformationResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 400), ('criticality', 'ignore'), ('Value', _TRPInformationResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _TRPInformationResponseIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TRPInformationListTRPResp >-----#
    TRPInformationListTRPResp = SEQ_OF(name='TRPInformationListTRPResp', mode=MODE_TYPE)
    _TRPInformationListTRPResp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __TRPInformationListTRPResp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___TRPInformationListTRPResp__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____TRPInformationListTRPResp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPInformationItem')))
    ___TRPInformationListTRPResp__item__id_tab._val = ASN1Set(rv=[dict([('id', 401), ('criticality', 'ignore'), ('Value', ____TRPInformationListTRPResp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __TRPInformationListTRPResp__item__id._const_tab = ___TRPInformationListTRPResp__item__id_tab
    __TRPInformationListTRPResp__item__id._const_tab_at = None
    __TRPInformationListTRPResp__item__id._const_tab_id = 'id'
    __TRPInformationListTRPResp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __TRPInformationListTRPResp__item__criticality._const_tab = ___TRPInformationListTRPResp__item__id_tab
    __TRPInformationListTRPResp__item__criticality._const_tab_at = ('..', 'id')
    __TRPInformationListTRPResp__item__criticality._const_tab_id = 'criticality'
    __TRPInformationListTRPResp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __TRPInformationListTRPResp__item__value._const_tab = ___TRPInformationListTRPResp__item__id_tab
    __TRPInformationListTRPResp__item__value._const_tab_at = ('..', 'id')
    __TRPInformationListTRPResp__item__value._const_tab_id = 'Value'
    _TRPInformationListTRPResp__item_._cont = ASN1Dict([
        ('id', __TRPInformationListTRPResp__item__id),
        ('criticality', __TRPInformationListTRPResp__item__criticality),
        ('value', __TRPInformationListTRPResp__item__value),
        ])
    _TRPInformationListTRPResp__item_._ext = None
    TRPInformationListTRPResp._cont = _TRPInformationListTRPResp__item_
    TRPInformationListTRPResp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< TRPInformationItemTRPResp >-----#
    TRPInformationItemTRPResp = CLASS(name='TRPInformationItemTRPResp', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _TRPInformationItemTRPResp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRPInformationItem')))
    TRPInformationItemTRPResp._val = ASN1Set(rv=[dict([('id', 401), ('criticality', 'ignore'), ('Value', _TRPInformationItemTRPResp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TRPInformationFailure >-----#
    TRPInformationFailure = SEQ(name='TRPInformationFailure', mode=MODE_TYPE)
    _TRPInformationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __TRPInformationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___TRPInformationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____TRPInformationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____TRPInformationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TRPInformationFailure_protocolIEs__item__id._const_tab = ____TRPInformationFailure_protocolIEs__item__id_tab
    ___TRPInformationFailure_protocolIEs__item__id._const_tab_at = None
    ___TRPInformationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___TRPInformationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___TRPInformationFailure_protocolIEs__item__criticality._const_tab = ____TRPInformationFailure_protocolIEs__item__id_tab
    ___TRPInformationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___TRPInformationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___TRPInformationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___TRPInformationFailure_protocolIEs__item__value._const_tab = ____TRPInformationFailure_protocolIEs__item__id_tab
    ___TRPInformationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___TRPInformationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __TRPInformationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___TRPInformationFailure_protocolIEs__item__id),
        ('criticality', ___TRPInformationFailure_protocolIEs__item__criticality),
        ('value', ___TRPInformationFailure_protocolIEs__item__value),
        ])
    __TRPInformationFailure_protocolIEs__item_._ext = None
    _TRPInformationFailure_protocolIEs._cont = __TRPInformationFailure_protocolIEs__item_
    _TRPInformationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TRPInformationFailure._cont = ASN1Dict([
        ('protocolIEs', _TRPInformationFailure_protocolIEs),
        ])
    TRPInformationFailure._ext = []
    
    #-----< TRPInformationFailureIEs >-----#
    TRPInformationFailureIEs = CLASS(name='TRPInformationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _TRPInformationFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _TRPInformationFailureIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _TRPInformationFailureIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    TRPInformationFailureIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _TRPInformationFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _TRPInformationFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _TRPInformationFailureIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningInformationRequest >-----#
    PositioningInformationRequest = SEQ(name='PositioningInformationRequest', mode=MODE_TYPE)
    _PositioningInformationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningInformationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningInformationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PositioningInformationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RequestedSRSTransmissionCharacteristics')))
    _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UEReportingInformation')))
    _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSPosRRCInactiveQueryIndication')))
    ____PositioningInformationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 391), ('criticality', 'ignore'), ('Value', _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 575), ('criticality', 'ignore'), ('Value', _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 689), ('criticality', 'ignore'), ('Value', _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositioningInformationRequest_protocolIEs__item__id._const_tab = ____PositioningInformationRequest_protocolIEs__item__id_tab
    ___PositioningInformationRequest_protocolIEs__item__id._const_tab_at = None
    ___PositioningInformationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___PositioningInformationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PositioningInformationRequest_protocolIEs__item__criticality._const_tab = ____PositioningInformationRequest_protocolIEs__item__id_tab
    ___PositioningInformationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningInformationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositioningInformationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PositioningInformationRequest_protocolIEs__item__value._const_tab = ____PositioningInformationRequest_protocolIEs__item__id_tab
    ___PositioningInformationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositioningInformationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __PositioningInformationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositioningInformationRequest_protocolIEs__item__id),
        ('criticality', ___PositioningInformationRequest_protocolIEs__item__criticality),
        ('value', ___PositioningInformationRequest_protocolIEs__item__value),
        ])
    __PositioningInformationRequest_protocolIEs__item_._ext = None
    _PositioningInformationRequest_protocolIEs._cont = __PositioningInformationRequest_protocolIEs__item_
    _PositioningInformationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningInformationRequest._cont = ASN1Dict([
        ('protocolIEs', _PositioningInformationRequest_protocolIEs),
        ])
    PositioningInformationRequest._ext = []
    
    #-----< PositioningInformationRequestIEs >-----#
    PositioningInformationRequestIEs = CLASS(name='PositioningInformationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningInformationRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _PositioningInformationRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _PositioningInformationRequestIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RequestedSRSTransmissionCharacteristics')))
    _PositioningInformationRequestIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UEReportingInformation')))
    _PositioningInformationRequestIEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSPosRRCInactiveQueryIndication')))
    PositioningInformationRequestIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _PositioningInformationRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _PositioningInformationRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 391), ('criticality', 'ignore'), ('Value', _PositioningInformationRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 575), ('criticality', 'ignore'), ('Value', _PositioningInformationRequestIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 689), ('criticality', 'ignore'), ('Value', _PositioningInformationRequestIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningInformationResponse >-----#
    PositioningInformationResponse = SEQ(name='PositioningInformationResponse', mode=MODE_TYPE)
    _PositioningInformationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningInformationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningInformationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PositioningInformationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSConfiguration')))
    _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RelativeTime1900')))
    _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSPosRRCInactiveConfig')))
    ____PositioningInformationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 407), ('criticality', 'ignore'), ('Value', _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 419), ('criticality', 'ignore'), ('Value', _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 674), ('criticality', 'ignore'), ('Value', _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositioningInformationResponse_protocolIEs__item__id._const_tab = ____PositioningInformationResponse_protocolIEs__item__id_tab
    ___PositioningInformationResponse_protocolIEs__item__id._const_tab_at = None
    ___PositioningInformationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___PositioningInformationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PositioningInformationResponse_protocolIEs__item__criticality._const_tab = ____PositioningInformationResponse_protocolIEs__item__id_tab
    ___PositioningInformationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningInformationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositioningInformationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PositioningInformationResponse_protocolIEs__item__value._const_tab = ____PositioningInformationResponse_protocolIEs__item__id_tab
    ___PositioningInformationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositioningInformationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __PositioningInformationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositioningInformationResponse_protocolIEs__item__id),
        ('criticality', ___PositioningInformationResponse_protocolIEs__item__criticality),
        ('value', ___PositioningInformationResponse_protocolIEs__item__value),
        ])
    __PositioningInformationResponse_protocolIEs__item_._ext = None
    _PositioningInformationResponse_protocolIEs._cont = __PositioningInformationResponse_protocolIEs__item_
    _PositioningInformationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningInformationResponse._cont = ASN1Dict([
        ('protocolIEs', _PositioningInformationResponse_protocolIEs),
        ])
    PositioningInformationResponse._ext = []
    
    #-----< PositioningInformationResponseIEs >-----#
    PositioningInformationResponseIEs = CLASS(name='PositioningInformationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningInformationResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _PositioningInformationResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _PositioningInformationResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSConfiguration')))
    _PositioningInformationResponseIEs_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RelativeTime1900')))
    _PositioningInformationResponseIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _PositioningInformationResponseIEs_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSPosRRCInactiveConfig')))
    PositioningInformationResponseIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _PositioningInformationResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _PositioningInformationResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 407), ('criticality', 'ignore'), ('Value', _PositioningInformationResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 419), ('criticality', 'ignore'), ('Value', _PositioningInformationResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _PositioningInformationResponseIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 674), ('criticality', 'ignore'), ('Value', _PositioningInformationResponseIEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningInformationFailure >-----#
    PositioningInformationFailure = SEQ(name='PositioningInformationFailure', mode=MODE_TYPE)
    _PositioningInformationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningInformationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningInformationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PositioningInformationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____PositioningInformationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositioningInformationFailure_protocolIEs__item__id._const_tab = ____PositioningInformationFailure_protocolIEs__item__id_tab
    ___PositioningInformationFailure_protocolIEs__item__id._const_tab_at = None
    ___PositioningInformationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___PositioningInformationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PositioningInformationFailure_protocolIEs__item__criticality._const_tab = ____PositioningInformationFailure_protocolIEs__item__id_tab
    ___PositioningInformationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningInformationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositioningInformationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PositioningInformationFailure_protocolIEs__item__value._const_tab = ____PositioningInformationFailure_protocolIEs__item__id_tab
    ___PositioningInformationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositioningInformationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __PositioningInformationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositioningInformationFailure_protocolIEs__item__id),
        ('criticality', ___PositioningInformationFailure_protocolIEs__item__criticality),
        ('value', ___PositioningInformationFailure_protocolIEs__item__value),
        ])
    __PositioningInformationFailure_protocolIEs__item_._ext = None
    _PositioningInformationFailure_protocolIEs._cont = __PositioningInformationFailure_protocolIEs__item_
    _PositioningInformationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningInformationFailure._cont = ASN1Dict([
        ('protocolIEs', _PositioningInformationFailure_protocolIEs),
        ])
    PositioningInformationFailure._ext = []
    
    #-----< PositioningInformationFailureIEs >-----#
    PositioningInformationFailureIEs = CLASS(name='PositioningInformationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningInformationFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _PositioningInformationFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _PositioningInformationFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _PositioningInformationFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    PositioningInformationFailureIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _PositioningInformationFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _PositioningInformationFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _PositioningInformationFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _PositioningInformationFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningActivationRequest >-----#
    PositioningActivationRequest = SEQ(name='PositioningActivationRequest', mode=MODE_TYPE)
    _PositioningActivationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningActivationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningActivationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PositioningActivationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRSType')))
    _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RelativeTime1900')))
    ____PositioningActivationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 403), ('criticality', 'reject'), ('Value', _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 404), ('criticality', 'ignore'), ('Value', _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositioningActivationRequest_protocolIEs__item__id._const_tab = ____PositioningActivationRequest_protocolIEs__item__id_tab
    ___PositioningActivationRequest_protocolIEs__item__id._const_tab_at = None
    ___PositioningActivationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___PositioningActivationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PositioningActivationRequest_protocolIEs__item__criticality._const_tab = ____PositioningActivationRequest_protocolIEs__item__id_tab
    ___PositioningActivationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningActivationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositioningActivationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PositioningActivationRequest_protocolIEs__item__value._const_tab = ____PositioningActivationRequest_protocolIEs__item__id_tab
    ___PositioningActivationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositioningActivationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __PositioningActivationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositioningActivationRequest_protocolIEs__item__id),
        ('criticality', ___PositioningActivationRequest_protocolIEs__item__criticality),
        ('value', ___PositioningActivationRequest_protocolIEs__item__value),
        ])
    __PositioningActivationRequest_protocolIEs__item_._ext = None
    _PositioningActivationRequest_protocolIEs._cont = __PositioningActivationRequest_protocolIEs__item_
    _PositioningActivationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningActivationRequest._cont = ASN1Dict([
        ('protocolIEs', _PositioningActivationRequest_protocolIEs),
        ])
    PositioningActivationRequest._ext = []
    
    #-----< PositioningActivationRequestIEs >-----#
    PositioningActivationRequestIEs = CLASS(name='PositioningActivationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningActivationRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _PositioningActivationRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _PositioningActivationRequestIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SRSType')))
    _PositioningActivationRequestIEs_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RelativeTime1900')))
    PositioningActivationRequestIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _PositioningActivationRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _PositioningActivationRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 403), ('criticality', 'reject'), ('Value', _PositioningActivationRequestIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 404), ('criticality', 'ignore'), ('Value', _PositioningActivationRequestIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SRSType >-----#
    SRSType = CHOICE(name='SRSType', mode=MODE_TYPE)
    _SRSType_semipersistentSRS = SEQ(name='semipersistentSRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-PDU-Contents', 'SemipersistentSRS')))
    _SRSType_aperiodicSRS = SEQ(name='aperiodicSRS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-PDU-Contents', 'AperiodicSRS')))
    _SRSType_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SRSType_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___SRSType_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SRSType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SRSType_choice_extension_id._const_tab = ___SRSType_choice_extension_id_tab
    __SRSType_choice_extension_id._const_tab_at = None
    __SRSType_choice_extension_id._const_tab_id = 'id'
    __SRSType_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___SRSType_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SRSType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SRSType_choice_extension_criticality._const_tab = ___SRSType_choice_extension_criticality_tab
    __SRSType_choice_extension_criticality._const_tab_at = ('..', 'id')
    __SRSType_choice_extension_criticality._const_tab_id = 'criticality'
    __SRSType_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___SRSType_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___SRSType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SRSType_choice_extension_value._const_tab = ___SRSType_choice_extension_value_tab
    __SRSType_choice_extension_value._const_tab_at = ('..', 'id')
    __SRSType_choice_extension_value._const_tab_id = 'Value'
    _SRSType_choice_extension._cont = ASN1Dict([
        ('id', __SRSType_choice_extension_id),
        ('criticality', __SRSType_choice_extension_criticality),
        ('value', __SRSType_choice_extension_value),
        ])
    _SRSType_choice_extension._ext = None
    SRSType._cont = ASN1Dict([
        ('semipersistentSRS', _SRSType_semipersistentSRS),
        ('aperiodicSRS', _SRSType_aperiodicSRS),
        ('choice-extension', _SRSType_choice_extension),
        ])
    SRSType._ext = None
    
    #-----< SRSType-ExtIEs >-----#
    SRSType_ExtIEs = CLASS(name='SRSType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    SRSType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SemipersistentSRS >-----#
    SemipersistentSRS = SEQ(name='SemipersistentSRS', mode=MODE_TYPE)
    _SemipersistentSRS_sRSResourceSetID = INT(name='sRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceSetID')))
    _SemipersistentSRS_sRSSpatialRelation = SEQ(name='sRSSpatialRelation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SpatialRelationInfo')), opt=True)
    _SemipersistentSRS_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SemipersistentSRS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___SemipersistentSRS_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SemipersistentSRS_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _____SemipersistentSRS_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SpatialRelationPerSRSResource')))
    ____SemipersistentSRS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 435), ('criticality', 'ignore'), ('Extension', _____SemipersistentSRS_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SemipersistentSRS_iE_Extensions__item__id._const_tab = ____SemipersistentSRS_iE_Extensions__item__id_tab
    ___SemipersistentSRS_iE_Extensions__item__id._const_tab_at = None
    ___SemipersistentSRS_iE_Extensions__item__id._const_tab_id = 'id'
    ___SemipersistentSRS_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SemipersistentSRS_iE_Extensions__item__criticality._const_tab = ____SemipersistentSRS_iE_Extensions__item__id_tab
    ___SemipersistentSRS_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SemipersistentSRS_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SemipersistentSRS_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SemipersistentSRS_iE_Extensions__item__extensionValue._const_tab = ____SemipersistentSRS_iE_Extensions__item__id_tab
    ___SemipersistentSRS_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SemipersistentSRS_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SemipersistentSRS_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SemipersistentSRS_iE_Extensions__item__id),
        ('criticality', ___SemipersistentSRS_iE_Extensions__item__criticality),
        ('extensionValue', ___SemipersistentSRS_iE_Extensions__item__extensionValue),
        ])
    __SemipersistentSRS_iE_Extensions__item_._ext = None
    _SemipersistentSRS_iE_Extensions._cont = __SemipersistentSRS_iE_Extensions__item_
    _SemipersistentSRS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SemipersistentSRS._cont = ASN1Dict([
        ('sRSResourceSetID', _SemipersistentSRS_sRSResourceSetID),
        ('sRSSpatialRelation', _SemipersistentSRS_sRSSpatialRelation),
        ('iE-Extensions', _SemipersistentSRS_iE_Extensions),
        ])
    SemipersistentSRS._ext = []
    
    #-----< SemipersistentSRS-ExtIEs >-----#
    SemipersistentSRS_ExtIEs = CLASS(name='SemipersistentSRS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    _SemipersistentSRS_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SpatialRelationPerSRSResource')))
    SemipersistentSRS_ExtIEs._val = ASN1Set(rv=[dict([('id', 435), ('criticality', 'ignore'), ('Extension', _SemipersistentSRS_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< AperiodicSRS >-----#
    AperiodicSRS = SEQ(name='AperiodicSRS', mode=MODE_TYPE)
    _AperiodicSRS_aperiodic = ENUM(name='aperiodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AperiodicSRS_aperiodic._cont = ASN1Dict([('true', 0)])
    _AperiodicSRS_aperiodic._ext = []
    _AperiodicSRS_sRSResourceTrigger = SEQ(name='sRSResourceTrigger', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-IEs', 'SRSResourceTrigger')), opt=True)
    _AperiodicSRS_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AperiodicSRS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolExtensionField')))
    ___AperiodicSRS_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['id']))
    ____AperiodicSRS_iE_Extensions__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AperiodicSRS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AperiodicSRS_iE_Extensions__item__id._const_tab = ____AperiodicSRS_iE_Extensions__item__id_tab
    ___AperiodicSRS_iE_Extensions__item__id._const_tab_at = None
    ___AperiodicSRS_iE_Extensions__item__id._const_tab_id = 'id'
    ___AperiodicSRS_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AperiodicSRS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AperiodicSRS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AperiodicSRS_iE_Extensions__item__criticality._const_tab = ____AperiodicSRS_iE_Extensions__item__criticality_tab
    ___AperiodicSRS_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AperiodicSRS_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AperiodicSRS_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AperiodicSRS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_F1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    ____AperiodicSRS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AperiodicSRS_iE_Extensions__item__extensionValue._const_tab = ____AperiodicSRS_iE_Extensions__item__extensionValue_tab
    ___AperiodicSRS_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AperiodicSRS_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AperiodicSRS_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AperiodicSRS_iE_Extensions__item__id),
        ('criticality', ___AperiodicSRS_iE_Extensions__item__criticality),
        ('extensionValue', ___AperiodicSRS_iE_Extensions__item__extensionValue),
        ])
    __AperiodicSRS_iE_Extensions__item_._ext = None
    _AperiodicSRS_iE_Extensions._cont = __AperiodicSRS_iE_Extensions__item_
    _AperiodicSRS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AperiodicSRS._cont = ASN1Dict([
        ('aperiodic', _AperiodicSRS_aperiodic),
        ('sRSResourceTrigger', _AperiodicSRS_sRSResourceTrigger),
        ('iE-Extensions', _AperiodicSRS_iE_Extensions),
        ])
    AperiodicSRS._ext = []
    
    #-----< AperiodicSRS-ExtIEs >-----#
    AperiodicSRS_ExtIEs = CLASS(name='AperiodicSRS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-EXTENSION')))
    AperiodicSRS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PositioningActivationResponse >-----#
    PositioningActivationResponse = SEQ(name='PositioningActivationResponse', mode=MODE_TYPE)
    _PositioningActivationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningActivationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningActivationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PositioningActivationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SystemFrameNumber')))
    _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SlotNumber')))
    _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____PositioningActivationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 420), ('criticality', 'ignore'), ('Value', _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 421), ('criticality', 'ignore'), ('Value', _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositioningActivationResponse_protocolIEs__item__id._const_tab = ____PositioningActivationResponse_protocolIEs__item__id_tab
    ___PositioningActivationResponse_protocolIEs__item__id._const_tab_at = None
    ___PositioningActivationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___PositioningActivationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PositioningActivationResponse_protocolIEs__item__criticality._const_tab = ____PositioningActivationResponse_protocolIEs__item__id_tab
    ___PositioningActivationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningActivationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositioningActivationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PositioningActivationResponse_protocolIEs__item__value._const_tab = ____PositioningActivationResponse_protocolIEs__item__id_tab
    ___PositioningActivationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositioningActivationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __PositioningActivationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositioningActivationResponse_protocolIEs__item__id),
        ('criticality', ___PositioningActivationResponse_protocolIEs__item__criticality),
        ('value', ___PositioningActivationResponse_protocolIEs__item__value),
        ])
    __PositioningActivationResponse_protocolIEs__item_._ext = None
    _PositioningActivationResponse_protocolIEs._cont = __PositioningActivationResponse_protocolIEs__item_
    _PositioningActivationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningActivationResponse._cont = ASN1Dict([
        ('protocolIEs', _PositioningActivationResponse_protocolIEs),
        ])
    PositioningActivationResponse._ext = []
    
    #-----< PositioningActivationResponseIEs >-----#
    PositioningActivationResponseIEs = CLASS(name='PositioningActivationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningActivationResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _PositioningActivationResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _PositioningActivationResponseIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SystemFrameNumber')))
    _PositioningActivationResponseIEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SlotNumber')))
    _PositioningActivationResponseIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    PositioningActivationResponseIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _PositioningActivationResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _PositioningActivationResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 420), ('criticality', 'ignore'), ('Value', _PositioningActivationResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 421), ('criticality', 'ignore'), ('Value', _PositioningActivationResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _PositioningActivationResponseIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningActivationFailure >-----#
    PositioningActivationFailure = SEQ(name='PositioningActivationFailure', mode=MODE_TYPE)
    _PositioningActivationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningActivationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningActivationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PositioningActivationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____PositioningActivationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositioningActivationFailure_protocolIEs__item__id._const_tab = ____PositioningActivationFailure_protocolIEs__item__id_tab
    ___PositioningActivationFailure_protocolIEs__item__id._const_tab_at = None
    ___PositioningActivationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___PositioningActivationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PositioningActivationFailure_protocolIEs__item__criticality._const_tab = ____PositioningActivationFailure_protocolIEs__item__id_tab
    ___PositioningActivationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningActivationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositioningActivationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PositioningActivationFailure_protocolIEs__item__value._const_tab = ____PositioningActivationFailure_protocolIEs__item__id_tab
    ___PositioningActivationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositioningActivationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __PositioningActivationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositioningActivationFailure_protocolIEs__item__id),
        ('criticality', ___PositioningActivationFailure_protocolIEs__item__criticality),
        ('value', ___PositioningActivationFailure_protocolIEs__item__value),
        ])
    __PositioningActivationFailure_protocolIEs__item_._ext = None
    _PositioningActivationFailure_protocolIEs._cont = __PositioningActivationFailure_protocolIEs__item_
    _PositioningActivationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningActivationFailure._cont = ASN1Dict([
        ('protocolIEs', _PositioningActivationFailure_protocolIEs),
        ])
    PositioningActivationFailure._ext = []
    
    #-----< PositioningActivationFailureIEs >-----#
    PositioningActivationFailureIEs = CLASS(name='PositioningActivationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningActivationFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _PositioningActivationFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _PositioningActivationFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _PositioningActivationFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    PositioningActivationFailureIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _PositioningActivationFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _PositioningActivationFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _PositioningActivationFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _PositioningActivationFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningDeactivation >-----#
    PositioningDeactivation = SEQ(name='PositioningDeactivation', mode=MODE_TYPE)
    _PositioningDeactivation_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningDeactivation_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningDeactivation_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PositioningDeactivation_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningDeactivation_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____PositioningDeactivation_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____PositioningDeactivation_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AbortTransmission')))
    ____PositioningDeactivation_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____PositioningDeactivation_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____PositioningDeactivation_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 405), ('criticality', 'ignore'), ('Value', _____PositioningDeactivation_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___PositioningDeactivation_protocolIEs__item__id._const_tab = ____PositioningDeactivation_protocolIEs__item__id_tab
    ___PositioningDeactivation_protocolIEs__item__id._const_tab_at = None
    ___PositioningDeactivation_protocolIEs__item__id._const_tab_id = 'id'
    ___PositioningDeactivation_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PositioningDeactivation_protocolIEs__item__criticality._const_tab = ____PositioningDeactivation_protocolIEs__item__id_tab
    ___PositioningDeactivation_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningDeactivation_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositioningDeactivation_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PositioningDeactivation_protocolIEs__item__value._const_tab = ____PositioningDeactivation_protocolIEs__item__id_tab
    ___PositioningDeactivation_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositioningDeactivation_protocolIEs__item__value._const_tab_id = 'Value'
    __PositioningDeactivation_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositioningDeactivation_protocolIEs__item__id),
        ('criticality', ___PositioningDeactivation_protocolIEs__item__criticality),
        ('value', ___PositioningDeactivation_protocolIEs__item__value),
        ])
    __PositioningDeactivation_protocolIEs__item_._ext = None
    _PositioningDeactivation_protocolIEs._cont = __PositioningDeactivation_protocolIEs__item_
    _PositioningDeactivation_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningDeactivation._cont = ASN1Dict([
        ('protocolIEs', _PositioningDeactivation_protocolIEs),
        ])
    PositioningDeactivation._ext = []
    
    #-----< PositioningDeactivationIEs >-----#
    PositioningDeactivationIEs = CLASS(name='PositioningDeactivationIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningDeactivationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _PositioningDeactivationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _PositioningDeactivationIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'AbortTransmission')))
    PositioningDeactivationIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _PositioningDeactivationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _PositioningDeactivationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 405), ('criticality', 'ignore'), ('Value', _PositioningDeactivationIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PositioningInformationUpdate >-----#
    PositioningInformationUpdate = SEQ(name='PositioningInformationUpdate', mode=MODE_TYPE)
    _PositioningInformationUpdate_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PositioningInformationUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PositioningInformationUpdate_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PositioningInformationUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSConfiguration')))
    _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RelativeTime1900')))
    ____PositioningInformationUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 407), ('criticality', 'ignore'), ('Value', _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 419), ('criticality', 'ignore'), ('Value', _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositioningInformationUpdate_protocolIEs__item__id._const_tab = ____PositioningInformationUpdate_protocolIEs__item__id_tab
    ___PositioningInformationUpdate_protocolIEs__item__id._const_tab_at = None
    ___PositioningInformationUpdate_protocolIEs__item__id._const_tab_id = 'id'
    ___PositioningInformationUpdate_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PositioningInformationUpdate_protocolIEs__item__criticality._const_tab = ____PositioningInformationUpdate_protocolIEs__item__id_tab
    ___PositioningInformationUpdate_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningInformationUpdate_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositioningInformationUpdate_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PositioningInformationUpdate_protocolIEs__item__value._const_tab = ____PositioningInformationUpdate_protocolIEs__item__id_tab
    ___PositioningInformationUpdate_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositioningInformationUpdate_protocolIEs__item__value._const_tab_id = 'Value'
    __PositioningInformationUpdate_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositioningInformationUpdate_protocolIEs__item__id),
        ('criticality', ___PositioningInformationUpdate_protocolIEs__item__criticality),
        ('value', ___PositioningInformationUpdate_protocolIEs__item__value),
        ])
    __PositioningInformationUpdate_protocolIEs__item_._ext = None
    _PositioningInformationUpdate_protocolIEs._cont = __PositioningInformationUpdate_protocolIEs__item_
    _PositioningInformationUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningInformationUpdate._cont = ASN1Dict([
        ('protocolIEs', _PositioningInformationUpdate_protocolIEs),
        ])
    PositioningInformationUpdate._ext = []
    
    #-----< PositioningInformationUpdateIEs >-----#
    PositioningInformationUpdateIEs = CLASS(name='PositioningInformationUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PositioningInformationUpdateIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _PositioningInformationUpdateIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _PositioningInformationUpdateIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SRSConfiguration')))
    _PositioningInformationUpdateIEs_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RelativeTime1900')))
    PositioningInformationUpdateIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _PositioningInformationUpdateIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _PositioningInformationUpdateIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 407), ('criticality', 'ignore'), ('Value', _PositioningInformationUpdateIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 419), ('criticality', 'ignore'), ('Value', _PositioningInformationUpdateIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-CIDMeasurementInitiationRequest >-----#
    E_CIDMeasurementInitiationRequest = SEQ(name='E-CIDMeasurementInitiationRequest', mode=MODE_TYPE)
    _E_CIDMeasurementInitiationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __E_CIDMeasurementInitiationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-UE-MeasurementID')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-MeasurementID')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'E-CID-ReportCharacteristics')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementPeriodicity')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'E-CID-MeasurementQuantities')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementPeriodicityNR-AoA')))
    ____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 412), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 413), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 424), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 416), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'conditional')]), dict([('id', 414), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'mandatory')]), dict([('id', 672), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'conditional')])], rr=[], ev=None, er=[])
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__id._const_tab = ____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__id._const_tab_at = None
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab = ____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__value._const_tab = ____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __E_CIDMeasurementInitiationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E_CIDMeasurementInitiationRequest_protocolIEs__item__id),
        ('criticality', ___E_CIDMeasurementInitiationRequest_protocolIEs__item__criticality),
        ('value', ___E_CIDMeasurementInitiationRequest_protocolIEs__item__value),
        ])
    __E_CIDMeasurementInitiationRequest_protocolIEs__item_._ext = None
    _E_CIDMeasurementInitiationRequest_protocolIEs._cont = __E_CIDMeasurementInitiationRequest_protocolIEs__item_
    _E_CIDMeasurementInitiationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_CIDMeasurementInitiationRequest._cont = ASN1Dict([
        ('protocolIEs', _E_CIDMeasurementInitiationRequest_protocolIEs),
        ])
    E_CIDMeasurementInitiationRequest._ext = []
    
    #-----< E-CIDMeasurementInitiationRequest-IEs >-----#
    E_CIDMeasurementInitiationRequest_IEs = CLASS(name='E-CIDMeasurementInitiationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-UE-MeasurementID')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-MeasurementID')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'E-CID-ReportCharacteristics')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MeasurementPeriodicity')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'E-CID-MeasurementQuantities')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosMeasurementPeriodicityNR-AoA')))
    E_CIDMeasurementInitiationRequest_IEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 412), ('criticality', 'reject'), ('Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 413), ('criticality', 'reject'), ('Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 424), ('criticality', 'reject'), ('Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 416), ('criticality', 'reject'), ('Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_5), ('presence', 'conditional')]), dict([('id', 414), ('criticality', 'reject'), ('Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_6), ('presence', 'mandatory')]), dict([('id', 672), ('criticality', 'reject'), ('Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_7), ('presence', 'conditional')])], rr=[], ev=[], er=[])
    
    #-----< E-CIDMeasurementInitiationResponse >-----#
    E_CIDMeasurementInitiationResponse = SEQ(name='E-CIDMeasurementInitiationResponse', mode=MODE_TYPE)
    _E_CIDMeasurementInitiationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __E_CIDMeasurementInitiationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-UE-MeasurementID')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-MeasurementID')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'E-CID-MeasurementResult')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cell-Portion-ID')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 412), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 413), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 417), ('criticality', 'ignore'), ('Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 418), ('criticality', 'ignore'), ('Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__id._const_tab = ____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__id._const_tab_at = None
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab = ____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__value._const_tab = ____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __E_CIDMeasurementInitiationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E_CIDMeasurementInitiationResponse_protocolIEs__item__id),
        ('criticality', ___E_CIDMeasurementInitiationResponse_protocolIEs__item__criticality),
        ('value', ___E_CIDMeasurementInitiationResponse_protocolIEs__item__value),
        ])
    __E_CIDMeasurementInitiationResponse_protocolIEs__item_._ext = None
    _E_CIDMeasurementInitiationResponse_protocolIEs._cont = __E_CIDMeasurementInitiationResponse_protocolIEs__item_
    _E_CIDMeasurementInitiationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_CIDMeasurementInitiationResponse._cont = ASN1Dict([
        ('protocolIEs', _E_CIDMeasurementInitiationResponse_protocolIEs),
        ])
    E_CIDMeasurementInitiationResponse._ext = []
    
    #-----< E-CIDMeasurementInitiationResponse-IEs >-----#
    E_CIDMeasurementInitiationResponse_IEs = CLASS(name='E-CIDMeasurementInitiationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-UE-MeasurementID')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-MeasurementID')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'E-CID-MeasurementResult')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cell-Portion-ID')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    E_CIDMeasurementInitiationResponse_IEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 412), ('criticality', 'reject'), ('Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 413), ('criticality', 'reject'), ('Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 417), ('criticality', 'ignore'), ('Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 418), ('criticality', 'ignore'), ('Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-CIDMeasurementInitiationFailure >-----#
    E_CIDMeasurementInitiationFailure = SEQ(name='E-CIDMeasurementInitiationFailure', mode=MODE_TYPE)
    _E_CIDMeasurementInitiationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __E_CIDMeasurementInitiationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-UE-MeasurementID')))
    _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-MeasurementID')))
    _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 412), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 413), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__id._const_tab = ____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__id._const_tab_at = None
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab = ____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__value._const_tab = ____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __E_CIDMeasurementInitiationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E_CIDMeasurementInitiationFailure_protocolIEs__item__id),
        ('criticality', ___E_CIDMeasurementInitiationFailure_protocolIEs__item__criticality),
        ('value', ___E_CIDMeasurementInitiationFailure_protocolIEs__item__value),
        ])
    __E_CIDMeasurementInitiationFailure_protocolIEs__item_._ext = None
    _E_CIDMeasurementInitiationFailure_protocolIEs._cont = __E_CIDMeasurementInitiationFailure_protocolIEs__item_
    _E_CIDMeasurementInitiationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_CIDMeasurementInitiationFailure._cont = ASN1Dict([
        ('protocolIEs', _E_CIDMeasurementInitiationFailure_protocolIEs),
        ])
    E_CIDMeasurementInitiationFailure._ext = []
    
    #-----< E-CIDMeasurementInitiationFailure-IEs >-----#
    E_CIDMeasurementInitiationFailure_IEs = CLASS(name='E-CIDMeasurementInitiationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _E_CIDMeasurementInitiationFailure_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _E_CIDMeasurementInitiationFailure_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _E_CIDMeasurementInitiationFailure_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-UE-MeasurementID')))
    _E_CIDMeasurementInitiationFailure_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-MeasurementID')))
    _E_CIDMeasurementInitiationFailure_IEs_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _E_CIDMeasurementInitiationFailure_IEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    E_CIDMeasurementInitiationFailure_IEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _E_CIDMeasurementInitiationFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _E_CIDMeasurementInitiationFailure_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 412), ('criticality', 'reject'), ('Value', _E_CIDMeasurementInitiationFailure_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 413), ('criticality', 'reject'), ('Value', _E_CIDMeasurementInitiationFailure_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _E_CIDMeasurementInitiationFailure_IEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _E_CIDMeasurementInitiationFailure_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-CIDMeasurementFailureIndication >-----#
    E_CIDMeasurementFailureIndication = SEQ(name='E-CIDMeasurementFailureIndication', mode=MODE_TYPE)
    _E_CIDMeasurementFailureIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __E_CIDMeasurementFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-UE-MeasurementID')))
    _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-MeasurementID')))
    _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    ____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 412), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 413), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__id._const_tab = ____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__criticality._const_tab = ____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__value._const_tab = ____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __E_CIDMeasurementFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E_CIDMeasurementFailureIndication_protocolIEs__item__id),
        ('criticality', ___E_CIDMeasurementFailureIndication_protocolIEs__item__criticality),
        ('value', ___E_CIDMeasurementFailureIndication_protocolIEs__item__value),
        ])
    __E_CIDMeasurementFailureIndication_protocolIEs__item_._ext = None
    _E_CIDMeasurementFailureIndication_protocolIEs._cont = __E_CIDMeasurementFailureIndication_protocolIEs__item_
    _E_CIDMeasurementFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_CIDMeasurementFailureIndication._cont = ASN1Dict([
        ('protocolIEs', _E_CIDMeasurementFailureIndication_protocolIEs),
        ])
    E_CIDMeasurementFailureIndication._ext = []
    
    #-----< E-CIDMeasurementFailureIndication-IEs >-----#
    E_CIDMeasurementFailureIndication_IEs = CLASS(name='E-CIDMeasurementFailureIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _E_CIDMeasurementFailureIndication_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _E_CIDMeasurementFailureIndication_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _E_CIDMeasurementFailureIndication_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-UE-MeasurementID')))
    _E_CIDMeasurementFailureIndication_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-MeasurementID')))
    _E_CIDMeasurementFailureIndication_IEs_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    E_CIDMeasurementFailureIndication_IEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _E_CIDMeasurementFailureIndication_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _E_CIDMeasurementFailureIndication_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 412), ('criticality', 'reject'), ('Value', _E_CIDMeasurementFailureIndication_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 413), ('criticality', 'reject'), ('Value', _E_CIDMeasurementFailureIndication_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _E_CIDMeasurementFailureIndication_IEs_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-CIDMeasurementReport >-----#
    E_CIDMeasurementReport = SEQ(name='E-CIDMeasurementReport', mode=MODE_TYPE)
    _E_CIDMeasurementReport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __E_CIDMeasurementReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___E_CIDMeasurementReport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____E_CIDMeasurementReport_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-UE-MeasurementID')))
    _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-MeasurementID')))
    _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'E-CID-MeasurementResult')))
    _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cell-Portion-ID')))
    ____E_CIDMeasurementReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 412), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 413), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 417), ('criticality', 'ignore'), ('Value', _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 418), ('criticality', 'ignore'), ('Value', _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_CIDMeasurementReport_protocolIEs__item__id._const_tab = ____E_CIDMeasurementReport_protocolIEs__item__id_tab
    ___E_CIDMeasurementReport_protocolIEs__item__id._const_tab_at = None
    ___E_CIDMeasurementReport_protocolIEs__item__id._const_tab_id = 'id'
    ___E_CIDMeasurementReport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___E_CIDMeasurementReport_protocolIEs__item__criticality._const_tab = ____E_CIDMeasurementReport_protocolIEs__item__id_tab
    ___E_CIDMeasurementReport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E_CIDMeasurementReport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E_CIDMeasurementReport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___E_CIDMeasurementReport_protocolIEs__item__value._const_tab = ____E_CIDMeasurementReport_protocolIEs__item__id_tab
    ___E_CIDMeasurementReport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E_CIDMeasurementReport_protocolIEs__item__value._const_tab_id = 'Value'
    __E_CIDMeasurementReport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E_CIDMeasurementReport_protocolIEs__item__id),
        ('criticality', ___E_CIDMeasurementReport_protocolIEs__item__criticality),
        ('value', ___E_CIDMeasurementReport_protocolIEs__item__value),
        ])
    __E_CIDMeasurementReport_protocolIEs__item_._ext = None
    _E_CIDMeasurementReport_protocolIEs._cont = __E_CIDMeasurementReport_protocolIEs__item_
    _E_CIDMeasurementReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_CIDMeasurementReport._cont = ASN1Dict([
        ('protocolIEs', _E_CIDMeasurementReport_protocolIEs),
        ])
    E_CIDMeasurementReport._ext = []
    
    #-----< E-CIDMeasurementReport-IEs >-----#
    E_CIDMeasurementReport_IEs = CLASS(name='E-CIDMeasurementReport-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _E_CIDMeasurementReport_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _E_CIDMeasurementReport_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _E_CIDMeasurementReport_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-UE-MeasurementID')))
    _E_CIDMeasurementReport_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-MeasurementID')))
    _E_CIDMeasurementReport_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'E-CID-MeasurementResult')))
    _E_CIDMeasurementReport_IEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cell-Portion-ID')))
    E_CIDMeasurementReport_IEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _E_CIDMeasurementReport_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _E_CIDMeasurementReport_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 412), ('criticality', 'reject'), ('Value', _E_CIDMeasurementReport_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 413), ('criticality', 'reject'), ('Value', _E_CIDMeasurementReport_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 417), ('criticality', 'ignore'), ('Value', _E_CIDMeasurementReport_IEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 418), ('criticality', 'ignore'), ('Value', _E_CIDMeasurementReport_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-CIDMeasurementTerminationCommand >-----#
    E_CIDMeasurementTerminationCommand = SEQ(name='E-CIDMeasurementTerminationCommand', mode=MODE_TYPE)
    _E_CIDMeasurementTerminationCommand_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __E_CIDMeasurementTerminationCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-UE-MeasurementID')))
    _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-MeasurementID')))
    ____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 412), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 413), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__id._const_tab = ____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__id._const_tab_at = None
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__id._const_tab_id = 'id'
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__criticality._const_tab = ____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__value._const_tab = ____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__value._const_tab_id = 'Value'
    __E_CIDMeasurementTerminationCommand_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E_CIDMeasurementTerminationCommand_protocolIEs__item__id),
        ('criticality', ___E_CIDMeasurementTerminationCommand_protocolIEs__item__criticality),
        ('value', ___E_CIDMeasurementTerminationCommand_protocolIEs__item__value),
        ])
    __E_CIDMeasurementTerminationCommand_protocolIEs__item_._ext = None
    _E_CIDMeasurementTerminationCommand_protocolIEs._cont = __E_CIDMeasurementTerminationCommand_protocolIEs__item_
    _E_CIDMeasurementTerminationCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_CIDMeasurementTerminationCommand._cont = ASN1Dict([
        ('protocolIEs', _E_CIDMeasurementTerminationCommand_protocolIEs),
        ])
    E_CIDMeasurementTerminationCommand._ext = []
    
    #-----< E-CIDMeasurementTerminationCommand-IEs >-----#
    E_CIDMeasurementTerminationCommand_IEs = CLASS(name='E-CIDMeasurementTerminationCommand-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _E_CIDMeasurementTerminationCommand_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _E_CIDMeasurementTerminationCommand_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _E_CIDMeasurementTerminationCommand_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'LMF-UE-MeasurementID')))
    _E_CIDMeasurementTerminationCommand_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-MeasurementID')))
    E_CIDMeasurementTerminationCommand_IEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _E_CIDMeasurementTerminationCommand_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _E_CIDMeasurementTerminationCommand_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 412), ('criticality', 'reject'), ('Value', _E_CIDMeasurementTerminationCommand_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 413), ('criticality', 'reject'), ('Value', _E_CIDMeasurementTerminationCommand_IEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastContextSetupRequest >-----#
    BroadcastContextSetupRequest = SEQ(name='BroadcastContextSetupRequest', mode=MODE_TYPE)
    _BroadcastContextSetupRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __BroadcastContextSetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___BroadcastContextSetupRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____BroadcastContextSetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____BroadcastContextSetupRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _____BroadcastContextSetupRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-Session-ID')))
    _____BroadcastContextSetupRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-ServiceArea')))
    _____BroadcastContextSetupRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-CUtoDURRCInformation')))
    _____BroadcastContextSetupRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SNSSAI')))
    _____BroadcastContextSetupRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastMRBs-ToBeSetup-List')))
    ____BroadcastContextSetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _____BroadcastContextSetupRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 455), ('criticality', 'reject'), ('Value', _____BroadcastContextSetupRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 481), ('criticality', 'reject'), ('Value', _____BroadcastContextSetupRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 454), ('criticality', 'reject'), ('Value', _____BroadcastContextSetupRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 456), ('criticality', 'reject'), ('Value', _____BroadcastContextSetupRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 474), ('criticality', 'reject'), ('Value', _____BroadcastContextSetupRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___BroadcastContextSetupRequest_protocolIEs__item__id._const_tab = ____BroadcastContextSetupRequest_protocolIEs__item__id_tab
    ___BroadcastContextSetupRequest_protocolIEs__item__id._const_tab_at = None
    ___BroadcastContextSetupRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___BroadcastContextSetupRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___BroadcastContextSetupRequest_protocolIEs__item__criticality._const_tab = ____BroadcastContextSetupRequest_protocolIEs__item__id_tab
    ___BroadcastContextSetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastContextSetupRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BroadcastContextSetupRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___BroadcastContextSetupRequest_protocolIEs__item__value._const_tab = ____BroadcastContextSetupRequest_protocolIEs__item__id_tab
    ___BroadcastContextSetupRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BroadcastContextSetupRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __BroadcastContextSetupRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BroadcastContextSetupRequest_protocolIEs__item__id),
        ('criticality', ___BroadcastContextSetupRequest_protocolIEs__item__criticality),
        ('value', ___BroadcastContextSetupRequest_protocolIEs__item__value),
        ])
    __BroadcastContextSetupRequest_protocolIEs__item_._ext = None
    _BroadcastContextSetupRequest_protocolIEs._cont = __BroadcastContextSetupRequest_protocolIEs__item_
    _BroadcastContextSetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BroadcastContextSetupRequest._cont = ASN1Dict([
        ('protocolIEs', _BroadcastContextSetupRequest_protocolIEs),
        ])
    BroadcastContextSetupRequest._ext = []
    
    #-----< BroadcastContextSetupRequestIEs >-----#
    BroadcastContextSetupRequestIEs = CLASS(name='BroadcastContextSetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BroadcastContextSetupRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _BroadcastContextSetupRequestIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-Session-ID')))
    _BroadcastContextSetupRequestIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-ServiceArea')))
    _BroadcastContextSetupRequestIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-CUtoDURRCInformation')))
    _BroadcastContextSetupRequestIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SNSSAI')))
    _BroadcastContextSetupRequestIEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastMRBs-ToBeSetup-List')))
    BroadcastContextSetupRequestIEs._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _BroadcastContextSetupRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 455), ('criticality', 'reject'), ('Value', _BroadcastContextSetupRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 481), ('criticality', 'reject'), ('Value', _BroadcastContextSetupRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 454), ('criticality', 'reject'), ('Value', _BroadcastContextSetupRequestIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 456), ('criticality', 'reject'), ('Value', _BroadcastContextSetupRequestIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 474), ('criticality', 'reject'), ('Value', _BroadcastContextSetupRequestIEs_val_Value_5), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastMRBs-ToBeSetup-List >-----#
    BroadcastMRBs_ToBeSetup_List = SEQ_OF(name='BroadcastMRBs-ToBeSetup-List', mode=MODE_TYPE)
    _BroadcastMRBs_ToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BroadcastMRBs_ToBeSetup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BroadcastMRBs_ToBeSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BroadcastMRBs_ToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastMRBs-ToBeSetup-Item')))
    ___BroadcastMRBs_ToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 475), ('criticality', 'reject'), ('Value', ____BroadcastMRBs_ToBeSetup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __BroadcastMRBs_ToBeSetup_List__item__id._const_tab = ___BroadcastMRBs_ToBeSetup_List__item__id_tab
    __BroadcastMRBs_ToBeSetup_List__item__id._const_tab_at = None
    __BroadcastMRBs_ToBeSetup_List__item__id._const_tab_id = 'id'
    __BroadcastMRBs_ToBeSetup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __BroadcastMRBs_ToBeSetup_List__item__criticality._const_tab = ___BroadcastMRBs_ToBeSetup_List__item__id_tab
    __BroadcastMRBs_ToBeSetup_List__item__criticality._const_tab_at = ('..', 'id')
    __BroadcastMRBs_ToBeSetup_List__item__criticality._const_tab_id = 'criticality'
    __BroadcastMRBs_ToBeSetup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __BroadcastMRBs_ToBeSetup_List__item__value._const_tab = ___BroadcastMRBs_ToBeSetup_List__item__id_tab
    __BroadcastMRBs_ToBeSetup_List__item__value._const_tab_at = ('..', 'id')
    __BroadcastMRBs_ToBeSetup_List__item__value._const_tab_id = 'Value'
    _BroadcastMRBs_ToBeSetup_List__item_._cont = ASN1Dict([
        ('id', __BroadcastMRBs_ToBeSetup_List__item__id),
        ('criticality', __BroadcastMRBs_ToBeSetup_List__item__criticality),
        ('value', __BroadcastMRBs_ToBeSetup_List__item__value),
        ])
    _BroadcastMRBs_ToBeSetup_List__item_._ext = None
    BroadcastMRBs_ToBeSetup_List._cont = _BroadcastMRBs_ToBeSetup_List__item_
    BroadcastMRBs_ToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< BroadcastMRBs-ToBeSetup-ItemIEs >-----#
    BroadcastMRBs_ToBeSetup_ItemIEs = CLASS(name='BroadcastMRBs-ToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BroadcastMRBs_ToBeSetup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastMRBs-ToBeSetup-Item')))
    BroadcastMRBs_ToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([('id', 475), ('criticality', 'reject'), ('Value', _BroadcastMRBs_ToBeSetup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastContextSetupResponse >-----#
    BroadcastContextSetupResponse = SEQ(name='BroadcastContextSetupResponse', mode=MODE_TYPE)
    _BroadcastContextSetupResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __BroadcastContextSetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___BroadcastContextSetupResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____BroadcastContextSetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____BroadcastContextSetupResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _____BroadcastContextSetupResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _____BroadcastContextSetupResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastMRBs-Setup-List')))
    _____BroadcastContextSetupResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastMRBs-FailedToBeSetup-List')))
    _____BroadcastContextSetupResponse_protocolIEs__item__id_tab_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastAreaScope')))
    _____BroadcastContextSetupResponse_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____BroadcastContextSetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _____BroadcastContextSetupResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _____BroadcastContextSetupResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 466), ('criticality', 'reject'), ('Value', _____BroadcastContextSetupResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 460), ('criticality', 'ignore'), ('Value', _____BroadcastContextSetupResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 646), ('criticality', 'ignore'), ('Value', _____BroadcastContextSetupResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____BroadcastContextSetupResponse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BroadcastContextSetupResponse_protocolIEs__item__id._const_tab = ____BroadcastContextSetupResponse_protocolIEs__item__id_tab
    ___BroadcastContextSetupResponse_protocolIEs__item__id._const_tab_at = None
    ___BroadcastContextSetupResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___BroadcastContextSetupResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___BroadcastContextSetupResponse_protocolIEs__item__criticality._const_tab = ____BroadcastContextSetupResponse_protocolIEs__item__id_tab
    ___BroadcastContextSetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastContextSetupResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BroadcastContextSetupResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___BroadcastContextSetupResponse_protocolIEs__item__value._const_tab = ____BroadcastContextSetupResponse_protocolIEs__item__id_tab
    ___BroadcastContextSetupResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BroadcastContextSetupResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __BroadcastContextSetupResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BroadcastContextSetupResponse_protocolIEs__item__id),
        ('criticality', ___BroadcastContextSetupResponse_protocolIEs__item__criticality),
        ('value', ___BroadcastContextSetupResponse_protocolIEs__item__value),
        ])
    __BroadcastContextSetupResponse_protocolIEs__item_._ext = None
    _BroadcastContextSetupResponse_protocolIEs._cont = __BroadcastContextSetupResponse_protocolIEs__item_
    _BroadcastContextSetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BroadcastContextSetupResponse._cont = ASN1Dict([
        ('protocolIEs', _BroadcastContextSetupResponse_protocolIEs),
        ])
    BroadcastContextSetupResponse._ext = []
    
    #-----< BroadcastContextSetupResponseIEs >-----#
    BroadcastContextSetupResponseIEs = CLASS(name='BroadcastContextSetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BroadcastContextSetupResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _BroadcastContextSetupResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _BroadcastContextSetupResponseIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastMRBs-Setup-List')))
    _BroadcastContextSetupResponseIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastMRBs-FailedToBeSetup-List')))
    _BroadcastContextSetupResponseIEs_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastAreaScope')))
    _BroadcastContextSetupResponseIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    BroadcastContextSetupResponseIEs._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _BroadcastContextSetupResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _BroadcastContextSetupResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 466), ('criticality', 'reject'), ('Value', _BroadcastContextSetupResponseIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 460), ('criticality', 'ignore'), ('Value', _BroadcastContextSetupResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 646), ('criticality', 'ignore'), ('Value', _BroadcastContextSetupResponseIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _BroadcastContextSetupResponseIEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastMRBs-Setup-List >-----#
    BroadcastMRBs_Setup_List = SEQ_OF(name='BroadcastMRBs-Setup-List', mode=MODE_TYPE)
    _BroadcastMRBs_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BroadcastMRBs_Setup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BroadcastMRBs_Setup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BroadcastMRBs_Setup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastMRBs-Setup-Item')))
    ___BroadcastMRBs_Setup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 467), ('criticality', 'reject'), ('Value', ____BroadcastMRBs_Setup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __BroadcastMRBs_Setup_List__item__id._const_tab = ___BroadcastMRBs_Setup_List__item__id_tab
    __BroadcastMRBs_Setup_List__item__id._const_tab_at = None
    __BroadcastMRBs_Setup_List__item__id._const_tab_id = 'id'
    __BroadcastMRBs_Setup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __BroadcastMRBs_Setup_List__item__criticality._const_tab = ___BroadcastMRBs_Setup_List__item__id_tab
    __BroadcastMRBs_Setup_List__item__criticality._const_tab_at = ('..', 'id')
    __BroadcastMRBs_Setup_List__item__criticality._const_tab_id = 'criticality'
    __BroadcastMRBs_Setup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __BroadcastMRBs_Setup_List__item__value._const_tab = ___BroadcastMRBs_Setup_List__item__id_tab
    __BroadcastMRBs_Setup_List__item__value._const_tab_at = ('..', 'id')
    __BroadcastMRBs_Setup_List__item__value._const_tab_id = 'Value'
    _BroadcastMRBs_Setup_List__item_._cont = ASN1Dict([
        ('id', __BroadcastMRBs_Setup_List__item__id),
        ('criticality', __BroadcastMRBs_Setup_List__item__criticality),
        ('value', __BroadcastMRBs_Setup_List__item__value),
        ])
    _BroadcastMRBs_Setup_List__item_._ext = None
    BroadcastMRBs_Setup_List._cont = _BroadcastMRBs_Setup_List__item_
    BroadcastMRBs_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< BroadcastMRBs-FailedToBeSetup-List >-----#
    BroadcastMRBs_FailedToBeSetup_List = SEQ_OF(name='BroadcastMRBs-FailedToBeSetup-List', mode=MODE_TYPE)
    _BroadcastMRBs_FailedToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BroadcastMRBs_FailedToBeSetup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BroadcastMRBs_FailedToBeSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BroadcastMRBs_FailedToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastMRBs-FailedToBeSetup-Item')))
    ___BroadcastMRBs_FailedToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 461), ('criticality', 'ignore'), ('Value', ____BroadcastMRBs_FailedToBeSetup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __BroadcastMRBs_FailedToBeSetup_List__item__id._const_tab = ___BroadcastMRBs_FailedToBeSetup_List__item__id_tab
    __BroadcastMRBs_FailedToBeSetup_List__item__id._const_tab_at = None
    __BroadcastMRBs_FailedToBeSetup_List__item__id._const_tab_id = 'id'
    __BroadcastMRBs_FailedToBeSetup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __BroadcastMRBs_FailedToBeSetup_List__item__criticality._const_tab = ___BroadcastMRBs_FailedToBeSetup_List__item__id_tab
    __BroadcastMRBs_FailedToBeSetup_List__item__criticality._const_tab_at = ('..', 'id')
    __BroadcastMRBs_FailedToBeSetup_List__item__criticality._const_tab_id = 'criticality'
    __BroadcastMRBs_FailedToBeSetup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __BroadcastMRBs_FailedToBeSetup_List__item__value._const_tab = ___BroadcastMRBs_FailedToBeSetup_List__item__id_tab
    __BroadcastMRBs_FailedToBeSetup_List__item__value._const_tab_at = ('..', 'id')
    __BroadcastMRBs_FailedToBeSetup_List__item__value._const_tab_id = 'Value'
    _BroadcastMRBs_FailedToBeSetup_List__item_._cont = ASN1Dict([
        ('id', __BroadcastMRBs_FailedToBeSetup_List__item__id),
        ('criticality', __BroadcastMRBs_FailedToBeSetup_List__item__criticality),
        ('value', __BroadcastMRBs_FailedToBeSetup_List__item__value),
        ])
    _BroadcastMRBs_FailedToBeSetup_List__item_._ext = None
    BroadcastMRBs_FailedToBeSetup_List._cont = _BroadcastMRBs_FailedToBeSetup_List__item_
    BroadcastMRBs_FailedToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< BroadcastMRBs-Setup-ItemIEs >-----#
    BroadcastMRBs_Setup_ItemIEs = CLASS(name='BroadcastMRBs-Setup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BroadcastMRBs_Setup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastMRBs-Setup-Item')))
    BroadcastMRBs_Setup_ItemIEs._val = ASN1Set(rv=[dict([('id', 467), ('criticality', 'reject'), ('Value', _BroadcastMRBs_Setup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastMRBs-FailedToBeSetup-ItemIEs >-----#
    BroadcastMRBs_FailedToBeSetup_ItemIEs = CLASS(name='BroadcastMRBs-FailedToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BroadcastMRBs_FailedToBeSetup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastMRBs-FailedToBeSetup-Item')))
    BroadcastMRBs_FailedToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([('id', 461), ('criticality', 'ignore'), ('Value', _BroadcastMRBs_FailedToBeSetup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastContextSetupFailure >-----#
    BroadcastContextSetupFailure = SEQ(name='BroadcastContextSetupFailure', mode=MODE_TYPE)
    _BroadcastContextSetupFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __BroadcastContextSetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___BroadcastContextSetupFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____BroadcastContextSetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____BroadcastContextSetupFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____BroadcastContextSetupFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____BroadcastContextSetupFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____BroadcastContextSetupFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____BroadcastContextSetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _____BroadcastContextSetupFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'ignore'), ('Value', _____BroadcastContextSetupFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____BroadcastContextSetupFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____BroadcastContextSetupFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BroadcastContextSetupFailure_protocolIEs__item__id._const_tab = ____BroadcastContextSetupFailure_protocolIEs__item__id_tab
    ___BroadcastContextSetupFailure_protocolIEs__item__id._const_tab_at = None
    ___BroadcastContextSetupFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___BroadcastContextSetupFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___BroadcastContextSetupFailure_protocolIEs__item__criticality._const_tab = ____BroadcastContextSetupFailure_protocolIEs__item__id_tab
    ___BroadcastContextSetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastContextSetupFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BroadcastContextSetupFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___BroadcastContextSetupFailure_protocolIEs__item__value._const_tab = ____BroadcastContextSetupFailure_protocolIEs__item__id_tab
    ___BroadcastContextSetupFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BroadcastContextSetupFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __BroadcastContextSetupFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BroadcastContextSetupFailure_protocolIEs__item__id),
        ('criticality', ___BroadcastContextSetupFailure_protocolIEs__item__criticality),
        ('value', ___BroadcastContextSetupFailure_protocolIEs__item__value),
        ])
    __BroadcastContextSetupFailure_protocolIEs__item_._ext = None
    _BroadcastContextSetupFailure_protocolIEs._cont = __BroadcastContextSetupFailure_protocolIEs__item_
    _BroadcastContextSetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BroadcastContextSetupFailure._cont = ASN1Dict([
        ('protocolIEs', _BroadcastContextSetupFailure_protocolIEs),
        ])
    BroadcastContextSetupFailure._ext = []
    
    #-----< BroadcastContextSetupFailureIEs >-----#
    BroadcastContextSetupFailureIEs = CLASS(name='BroadcastContextSetupFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BroadcastContextSetupFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _BroadcastContextSetupFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _BroadcastContextSetupFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _BroadcastContextSetupFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    BroadcastContextSetupFailureIEs._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _BroadcastContextSetupFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'ignore'), ('Value', _BroadcastContextSetupFailureIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _BroadcastContextSetupFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _BroadcastContextSetupFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastContextReleaseCommand >-----#
    BroadcastContextReleaseCommand = SEQ(name='BroadcastContextReleaseCommand', mode=MODE_TYPE)
    _BroadcastContextReleaseCommand_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __BroadcastContextReleaseCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___BroadcastContextReleaseCommand_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____BroadcastContextReleaseCommand_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____BroadcastContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _____BroadcastContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _____BroadcastContextReleaseCommand_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    ____BroadcastContextReleaseCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _____BroadcastContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _____BroadcastContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____BroadcastContextReleaseCommand_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___BroadcastContextReleaseCommand_protocolIEs__item__id._const_tab = ____BroadcastContextReleaseCommand_protocolIEs__item__id_tab
    ___BroadcastContextReleaseCommand_protocolIEs__item__id._const_tab_at = None
    ___BroadcastContextReleaseCommand_protocolIEs__item__id._const_tab_id = 'id'
    ___BroadcastContextReleaseCommand_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___BroadcastContextReleaseCommand_protocolIEs__item__criticality._const_tab = ____BroadcastContextReleaseCommand_protocolIEs__item__id_tab
    ___BroadcastContextReleaseCommand_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastContextReleaseCommand_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BroadcastContextReleaseCommand_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___BroadcastContextReleaseCommand_protocolIEs__item__value._const_tab = ____BroadcastContextReleaseCommand_protocolIEs__item__id_tab
    ___BroadcastContextReleaseCommand_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BroadcastContextReleaseCommand_protocolIEs__item__value._const_tab_id = 'Value'
    __BroadcastContextReleaseCommand_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BroadcastContextReleaseCommand_protocolIEs__item__id),
        ('criticality', ___BroadcastContextReleaseCommand_protocolIEs__item__criticality),
        ('value', ___BroadcastContextReleaseCommand_protocolIEs__item__value),
        ])
    __BroadcastContextReleaseCommand_protocolIEs__item_._ext = None
    _BroadcastContextReleaseCommand_protocolIEs._cont = __BroadcastContextReleaseCommand_protocolIEs__item_
    _BroadcastContextReleaseCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BroadcastContextReleaseCommand._cont = ASN1Dict([
        ('protocolIEs', _BroadcastContextReleaseCommand_protocolIEs),
        ])
    BroadcastContextReleaseCommand._ext = []
    
    #-----< BroadcastContextReleaseCommandIEs >-----#
    BroadcastContextReleaseCommandIEs = CLASS(name='BroadcastContextReleaseCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BroadcastContextReleaseCommandIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _BroadcastContextReleaseCommandIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _BroadcastContextReleaseCommandIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    BroadcastContextReleaseCommandIEs._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _BroadcastContextReleaseCommandIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _BroadcastContextReleaseCommandIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _BroadcastContextReleaseCommandIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastContextReleaseComplete >-----#
    BroadcastContextReleaseComplete = SEQ(name='BroadcastContextReleaseComplete', mode=MODE_TYPE)
    _BroadcastContextReleaseComplete_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __BroadcastContextReleaseComplete_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___BroadcastContextReleaseComplete_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____BroadcastContextReleaseComplete_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____BroadcastContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _____BroadcastContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _____BroadcastContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____BroadcastContextReleaseComplete_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _____BroadcastContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _____BroadcastContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____BroadcastContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BroadcastContextReleaseComplete_protocolIEs__item__id._const_tab = ____BroadcastContextReleaseComplete_protocolIEs__item__id_tab
    ___BroadcastContextReleaseComplete_protocolIEs__item__id._const_tab_at = None
    ___BroadcastContextReleaseComplete_protocolIEs__item__id._const_tab_id = 'id'
    ___BroadcastContextReleaseComplete_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___BroadcastContextReleaseComplete_protocolIEs__item__criticality._const_tab = ____BroadcastContextReleaseComplete_protocolIEs__item__id_tab
    ___BroadcastContextReleaseComplete_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastContextReleaseComplete_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BroadcastContextReleaseComplete_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___BroadcastContextReleaseComplete_protocolIEs__item__value._const_tab = ____BroadcastContextReleaseComplete_protocolIEs__item__id_tab
    ___BroadcastContextReleaseComplete_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BroadcastContextReleaseComplete_protocolIEs__item__value._const_tab_id = 'Value'
    __BroadcastContextReleaseComplete_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BroadcastContextReleaseComplete_protocolIEs__item__id),
        ('criticality', ___BroadcastContextReleaseComplete_protocolIEs__item__criticality),
        ('value', ___BroadcastContextReleaseComplete_protocolIEs__item__value),
        ])
    __BroadcastContextReleaseComplete_protocolIEs__item_._ext = None
    _BroadcastContextReleaseComplete_protocolIEs._cont = __BroadcastContextReleaseComplete_protocolIEs__item_
    _BroadcastContextReleaseComplete_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BroadcastContextReleaseComplete._cont = ASN1Dict([
        ('protocolIEs', _BroadcastContextReleaseComplete_protocolIEs),
        ])
    BroadcastContextReleaseComplete._ext = []
    
    #-----< BroadcastContextReleaseCompleteIEs >-----#
    BroadcastContextReleaseCompleteIEs = CLASS(name='BroadcastContextReleaseCompleteIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BroadcastContextReleaseCompleteIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _BroadcastContextReleaseCompleteIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _BroadcastContextReleaseCompleteIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    BroadcastContextReleaseCompleteIEs._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _BroadcastContextReleaseCompleteIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _BroadcastContextReleaseCompleteIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _BroadcastContextReleaseCompleteIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastContextReleaseRequest >-----#
    BroadcastContextReleaseRequest = SEQ(name='BroadcastContextReleaseRequest', mode=MODE_TYPE)
    _BroadcastContextReleaseRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __BroadcastContextReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___BroadcastContextReleaseRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____BroadcastContextReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____BroadcastContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _____BroadcastContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _____BroadcastContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    ____BroadcastContextReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _____BroadcastContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _____BroadcastContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____BroadcastContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___BroadcastContextReleaseRequest_protocolIEs__item__id._const_tab = ____BroadcastContextReleaseRequest_protocolIEs__item__id_tab
    ___BroadcastContextReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___BroadcastContextReleaseRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___BroadcastContextReleaseRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___BroadcastContextReleaseRequest_protocolIEs__item__criticality._const_tab = ____BroadcastContextReleaseRequest_protocolIEs__item__id_tab
    ___BroadcastContextReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastContextReleaseRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BroadcastContextReleaseRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___BroadcastContextReleaseRequest_protocolIEs__item__value._const_tab = ____BroadcastContextReleaseRequest_protocolIEs__item__id_tab
    ___BroadcastContextReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BroadcastContextReleaseRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __BroadcastContextReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BroadcastContextReleaseRequest_protocolIEs__item__id),
        ('criticality', ___BroadcastContextReleaseRequest_protocolIEs__item__criticality),
        ('value', ___BroadcastContextReleaseRequest_protocolIEs__item__value),
        ])
    __BroadcastContextReleaseRequest_protocolIEs__item_._ext = None
    _BroadcastContextReleaseRequest_protocolIEs._cont = __BroadcastContextReleaseRequest_protocolIEs__item_
    _BroadcastContextReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BroadcastContextReleaseRequest._cont = ASN1Dict([
        ('protocolIEs', _BroadcastContextReleaseRequest_protocolIEs),
        ])
    BroadcastContextReleaseRequest._ext = []
    
    #-----< BroadcastContextReleaseRequestIEs >-----#
    BroadcastContextReleaseRequestIEs = CLASS(name='BroadcastContextReleaseRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BroadcastContextReleaseRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _BroadcastContextReleaseRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _BroadcastContextReleaseRequestIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    BroadcastContextReleaseRequestIEs._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _BroadcastContextReleaseRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _BroadcastContextReleaseRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _BroadcastContextReleaseRequestIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastContextModificationRequest >-----#
    BroadcastContextModificationRequest = SEQ(name='BroadcastContextModificationRequest', mode=MODE_TYPE)
    _BroadcastContextModificationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __BroadcastContextModificationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___BroadcastContextModificationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____BroadcastContextModificationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____BroadcastContextModificationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _____BroadcastContextModificationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _____BroadcastContextModificationRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-ServiceArea')))
    _____BroadcastContextModificationRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-CUtoDURRCInformation')))
    _____BroadcastContextModificationRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastMRBs-ToBeSetupMod-List')))
    _____BroadcastContextModificationRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastMRBs-ToBeModified-List')))
    _____BroadcastContextModificationRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastMRBs-ToBeReleased-List')))
    ____BroadcastContextModificationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _____BroadcastContextModificationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _____BroadcastContextModificationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 481), ('criticality', 'reject'), ('Value', _____BroadcastContextModificationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 454), ('criticality', 'reject'), ('Value', _____BroadcastContextModificationRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 476), ('criticality', 'reject'), ('Value', _____BroadcastContextModificationRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 470), ('criticality', 'reject'), ('Value', _____BroadcastContextModificationRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 472), ('criticality', 'reject'), ('Value', _____BroadcastContextModificationRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BroadcastContextModificationRequest_protocolIEs__item__id._const_tab = ____BroadcastContextModificationRequest_protocolIEs__item__id_tab
    ___BroadcastContextModificationRequest_protocolIEs__item__id._const_tab_at = None
    ___BroadcastContextModificationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___BroadcastContextModificationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___BroadcastContextModificationRequest_protocolIEs__item__criticality._const_tab = ____BroadcastContextModificationRequest_protocolIEs__item__id_tab
    ___BroadcastContextModificationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastContextModificationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BroadcastContextModificationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___BroadcastContextModificationRequest_protocolIEs__item__value._const_tab = ____BroadcastContextModificationRequest_protocolIEs__item__id_tab
    ___BroadcastContextModificationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BroadcastContextModificationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __BroadcastContextModificationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BroadcastContextModificationRequest_protocolIEs__item__id),
        ('criticality', ___BroadcastContextModificationRequest_protocolIEs__item__criticality),
        ('value', ___BroadcastContextModificationRequest_protocolIEs__item__value),
        ])
    __BroadcastContextModificationRequest_protocolIEs__item_._ext = None
    _BroadcastContextModificationRequest_protocolIEs._cont = __BroadcastContextModificationRequest_protocolIEs__item_
    _BroadcastContextModificationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BroadcastContextModificationRequest._cont = ASN1Dict([
        ('protocolIEs', _BroadcastContextModificationRequest_protocolIEs),
        ])
    BroadcastContextModificationRequest._ext = []
    
    #-----< BroadcastContextModificationRequestIEs >-----#
    BroadcastContextModificationRequestIEs = CLASS(name='BroadcastContextModificationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BroadcastContextModificationRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _BroadcastContextModificationRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _BroadcastContextModificationRequestIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-ServiceArea')))
    _BroadcastContextModificationRequestIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-CUtoDURRCInformation')))
    _BroadcastContextModificationRequestIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastMRBs-ToBeSetupMod-List')))
    _BroadcastContextModificationRequestIEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastMRBs-ToBeModified-List')))
    _BroadcastContextModificationRequestIEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastMRBs-ToBeReleased-List')))
    BroadcastContextModificationRequestIEs._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _BroadcastContextModificationRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _BroadcastContextModificationRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 481), ('criticality', 'reject'), ('Value', _BroadcastContextModificationRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 454), ('criticality', 'reject'), ('Value', _BroadcastContextModificationRequestIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 476), ('criticality', 'reject'), ('Value', _BroadcastContextModificationRequestIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 470), ('criticality', 'reject'), ('Value', _BroadcastContextModificationRequestIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 472), ('criticality', 'reject'), ('Value', _BroadcastContextModificationRequestIEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastMRBs-ToBeSetupMod-List >-----#
    BroadcastMRBs_ToBeSetupMod_List = SEQ_OF(name='BroadcastMRBs-ToBeSetupMod-List', mode=MODE_TYPE)
    _BroadcastMRBs_ToBeSetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BroadcastMRBs_ToBeSetupMod_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BroadcastMRBs_ToBeSetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BroadcastMRBs_ToBeSetupMod_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastMRBs-ToBeSetupMod-Item')))
    ___BroadcastMRBs_ToBeSetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 477), ('criticality', 'reject'), ('Value', ____BroadcastMRBs_ToBeSetupMod_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __BroadcastMRBs_ToBeSetupMod_List__item__id._const_tab = ___BroadcastMRBs_ToBeSetupMod_List__item__id_tab
    __BroadcastMRBs_ToBeSetupMod_List__item__id._const_tab_at = None
    __BroadcastMRBs_ToBeSetupMod_List__item__id._const_tab_id = 'id'
    __BroadcastMRBs_ToBeSetupMod_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __BroadcastMRBs_ToBeSetupMod_List__item__criticality._const_tab = ___BroadcastMRBs_ToBeSetupMod_List__item__id_tab
    __BroadcastMRBs_ToBeSetupMod_List__item__criticality._const_tab_at = ('..', 'id')
    __BroadcastMRBs_ToBeSetupMod_List__item__criticality._const_tab_id = 'criticality'
    __BroadcastMRBs_ToBeSetupMod_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __BroadcastMRBs_ToBeSetupMod_List__item__value._const_tab = ___BroadcastMRBs_ToBeSetupMod_List__item__id_tab
    __BroadcastMRBs_ToBeSetupMod_List__item__value._const_tab_at = ('..', 'id')
    __BroadcastMRBs_ToBeSetupMod_List__item__value._const_tab_id = 'Value'
    _BroadcastMRBs_ToBeSetupMod_List__item_._cont = ASN1Dict([
        ('id', __BroadcastMRBs_ToBeSetupMod_List__item__id),
        ('criticality', __BroadcastMRBs_ToBeSetupMod_List__item__criticality),
        ('value', __BroadcastMRBs_ToBeSetupMod_List__item__value),
        ])
    _BroadcastMRBs_ToBeSetupMod_List__item_._ext = None
    BroadcastMRBs_ToBeSetupMod_List._cont = _BroadcastMRBs_ToBeSetupMod_List__item_
    BroadcastMRBs_ToBeSetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< BroadcastMRBs-ToBeModified-List >-----#
    BroadcastMRBs_ToBeModified_List = SEQ_OF(name='BroadcastMRBs-ToBeModified-List', mode=MODE_TYPE)
    _BroadcastMRBs_ToBeModified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BroadcastMRBs_ToBeModified_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BroadcastMRBs_ToBeModified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BroadcastMRBs_ToBeModified_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastMRBs-ToBeModified-Item')))
    ___BroadcastMRBs_ToBeModified_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 471), ('criticality', 'reject'), ('Value', ____BroadcastMRBs_ToBeModified_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __BroadcastMRBs_ToBeModified_List__item__id._const_tab = ___BroadcastMRBs_ToBeModified_List__item__id_tab
    __BroadcastMRBs_ToBeModified_List__item__id._const_tab_at = None
    __BroadcastMRBs_ToBeModified_List__item__id._const_tab_id = 'id'
    __BroadcastMRBs_ToBeModified_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __BroadcastMRBs_ToBeModified_List__item__criticality._const_tab = ___BroadcastMRBs_ToBeModified_List__item__id_tab
    __BroadcastMRBs_ToBeModified_List__item__criticality._const_tab_at = ('..', 'id')
    __BroadcastMRBs_ToBeModified_List__item__criticality._const_tab_id = 'criticality'
    __BroadcastMRBs_ToBeModified_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __BroadcastMRBs_ToBeModified_List__item__value._const_tab = ___BroadcastMRBs_ToBeModified_List__item__id_tab
    __BroadcastMRBs_ToBeModified_List__item__value._const_tab_at = ('..', 'id')
    __BroadcastMRBs_ToBeModified_List__item__value._const_tab_id = 'Value'
    _BroadcastMRBs_ToBeModified_List__item_._cont = ASN1Dict([
        ('id', __BroadcastMRBs_ToBeModified_List__item__id),
        ('criticality', __BroadcastMRBs_ToBeModified_List__item__criticality),
        ('value', __BroadcastMRBs_ToBeModified_List__item__value),
        ])
    _BroadcastMRBs_ToBeModified_List__item_._ext = None
    BroadcastMRBs_ToBeModified_List._cont = _BroadcastMRBs_ToBeModified_List__item_
    BroadcastMRBs_ToBeModified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< BroadcastMRBs-ToBeReleased-List >-----#
    BroadcastMRBs_ToBeReleased_List = SEQ_OF(name='BroadcastMRBs-ToBeReleased-List', mode=MODE_TYPE)
    _BroadcastMRBs_ToBeReleased_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BroadcastMRBs_ToBeReleased_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BroadcastMRBs_ToBeReleased_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BroadcastMRBs_ToBeReleased_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastMRBs-ToBeReleased-Item')))
    ___BroadcastMRBs_ToBeReleased_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 473), ('criticality', 'reject'), ('Value', ____BroadcastMRBs_ToBeReleased_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __BroadcastMRBs_ToBeReleased_List__item__id._const_tab = ___BroadcastMRBs_ToBeReleased_List__item__id_tab
    __BroadcastMRBs_ToBeReleased_List__item__id._const_tab_at = None
    __BroadcastMRBs_ToBeReleased_List__item__id._const_tab_id = 'id'
    __BroadcastMRBs_ToBeReleased_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __BroadcastMRBs_ToBeReleased_List__item__criticality._const_tab = ___BroadcastMRBs_ToBeReleased_List__item__id_tab
    __BroadcastMRBs_ToBeReleased_List__item__criticality._const_tab_at = ('..', 'id')
    __BroadcastMRBs_ToBeReleased_List__item__criticality._const_tab_id = 'criticality'
    __BroadcastMRBs_ToBeReleased_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __BroadcastMRBs_ToBeReleased_List__item__value._const_tab = ___BroadcastMRBs_ToBeReleased_List__item__id_tab
    __BroadcastMRBs_ToBeReleased_List__item__value._const_tab_at = ('..', 'id')
    __BroadcastMRBs_ToBeReleased_List__item__value._const_tab_id = 'Value'
    _BroadcastMRBs_ToBeReleased_List__item_._cont = ASN1Dict([
        ('id', __BroadcastMRBs_ToBeReleased_List__item__id),
        ('criticality', __BroadcastMRBs_ToBeReleased_List__item__criticality),
        ('value', __BroadcastMRBs_ToBeReleased_List__item__value),
        ])
    _BroadcastMRBs_ToBeReleased_List__item_._ext = None
    BroadcastMRBs_ToBeReleased_List._cont = _BroadcastMRBs_ToBeReleased_List__item_
    BroadcastMRBs_ToBeReleased_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< BroadcastMRBs-ToBeSetupMod-ItemIEs >-----#
    BroadcastMRBs_ToBeSetupMod_ItemIEs = CLASS(name='BroadcastMRBs-ToBeSetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BroadcastMRBs_ToBeSetupMod_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastMRBs-ToBeSetupMod-Item')))
    BroadcastMRBs_ToBeSetupMod_ItemIEs._val = ASN1Set(rv=[dict([('id', 477), ('criticality', 'reject'), ('Value', _BroadcastMRBs_ToBeSetupMod_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastMRBs-ToBeModified-ItemIEs >-----#
    BroadcastMRBs_ToBeModified_ItemIEs = CLASS(name='BroadcastMRBs-ToBeModified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BroadcastMRBs_ToBeModified_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastMRBs-ToBeModified-Item')))
    BroadcastMRBs_ToBeModified_ItemIEs._val = ASN1Set(rv=[dict([('id', 471), ('criticality', 'reject'), ('Value', _BroadcastMRBs_ToBeModified_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastMRBs-ToBeReleased-ItemIEs >-----#
    BroadcastMRBs_ToBeReleased_ItemIEs = CLASS(name='BroadcastMRBs-ToBeReleased-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BroadcastMRBs_ToBeReleased_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastMRBs-ToBeReleased-Item')))
    BroadcastMRBs_ToBeReleased_ItemIEs._val = ASN1Set(rv=[dict([('id', 473), ('criticality', 'reject'), ('Value', _BroadcastMRBs_ToBeReleased_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastContextModificationResponse >-----#
    BroadcastContextModificationResponse = SEQ(name='BroadcastContextModificationResponse', mode=MODE_TYPE)
    _BroadcastContextModificationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __BroadcastContextModificationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___BroadcastContextModificationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____BroadcastContextModificationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____BroadcastContextModificationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _____BroadcastContextModificationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _____BroadcastContextModificationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastMRBs-SetupMod-List')))
    _____BroadcastContextModificationResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastMRBs-FailedToBeSetupMod-List')))
    _____BroadcastContextModificationResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastMRBs-Modified-List')))
    _____BroadcastContextModificationResponse_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastMRBs-FailedToBeModified-List')))
    _____BroadcastContextModificationResponse_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____BroadcastContextModificationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _____BroadcastContextModificationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _____BroadcastContextModificationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 468), ('criticality', 'reject'), ('Value', _____BroadcastContextModificationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 462), ('criticality', 'ignore'), ('Value', _____BroadcastContextModificationResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 464), ('criticality', 'reject'), ('Value', _____BroadcastContextModificationResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 458), ('criticality', 'ignore'), ('Value', _____BroadcastContextModificationResponse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____BroadcastContextModificationResponse_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BroadcastContextModificationResponse_protocolIEs__item__id._const_tab = ____BroadcastContextModificationResponse_protocolIEs__item__id_tab
    ___BroadcastContextModificationResponse_protocolIEs__item__id._const_tab_at = None
    ___BroadcastContextModificationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___BroadcastContextModificationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___BroadcastContextModificationResponse_protocolIEs__item__criticality._const_tab = ____BroadcastContextModificationResponse_protocolIEs__item__id_tab
    ___BroadcastContextModificationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastContextModificationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BroadcastContextModificationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___BroadcastContextModificationResponse_protocolIEs__item__value._const_tab = ____BroadcastContextModificationResponse_protocolIEs__item__id_tab
    ___BroadcastContextModificationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BroadcastContextModificationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __BroadcastContextModificationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BroadcastContextModificationResponse_protocolIEs__item__id),
        ('criticality', ___BroadcastContextModificationResponse_protocolIEs__item__criticality),
        ('value', ___BroadcastContextModificationResponse_protocolIEs__item__value),
        ])
    __BroadcastContextModificationResponse_protocolIEs__item_._ext = None
    _BroadcastContextModificationResponse_protocolIEs._cont = __BroadcastContextModificationResponse_protocolIEs__item_
    _BroadcastContextModificationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BroadcastContextModificationResponse._cont = ASN1Dict([
        ('protocolIEs', _BroadcastContextModificationResponse_protocolIEs),
        ])
    BroadcastContextModificationResponse._ext = []
    
    #-----< BroadcastContextModificationResponseIEs >-----#
    BroadcastContextModificationResponseIEs = CLASS(name='BroadcastContextModificationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BroadcastContextModificationResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _BroadcastContextModificationResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _BroadcastContextModificationResponseIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastMRBs-SetupMod-List')))
    _BroadcastContextModificationResponseIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastMRBs-FailedToBeSetupMod-List')))
    _BroadcastContextModificationResponseIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastMRBs-Modified-List')))
    _BroadcastContextModificationResponseIEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastMRBs-FailedToBeModified-List')))
    _BroadcastContextModificationResponseIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    BroadcastContextModificationResponseIEs._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _BroadcastContextModificationResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _BroadcastContextModificationResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 468), ('criticality', 'reject'), ('Value', _BroadcastContextModificationResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 462), ('criticality', 'ignore'), ('Value', _BroadcastContextModificationResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 464), ('criticality', 'reject'), ('Value', _BroadcastContextModificationResponseIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 458), ('criticality', 'ignore'), ('Value', _BroadcastContextModificationResponseIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _BroadcastContextModificationResponseIEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastMRBs-SetupMod-List >-----#
    BroadcastMRBs_SetupMod_List = SEQ_OF(name='BroadcastMRBs-SetupMod-List', mode=MODE_TYPE)
    _BroadcastMRBs_SetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BroadcastMRBs_SetupMod_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BroadcastMRBs_SetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BroadcastMRBs_SetupMod_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastMRBs-SetupMod-Item')))
    ___BroadcastMRBs_SetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 469), ('criticality', 'reject'), ('Value', ____BroadcastMRBs_SetupMod_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __BroadcastMRBs_SetupMod_List__item__id._const_tab = ___BroadcastMRBs_SetupMod_List__item__id_tab
    __BroadcastMRBs_SetupMod_List__item__id._const_tab_at = None
    __BroadcastMRBs_SetupMod_List__item__id._const_tab_id = 'id'
    __BroadcastMRBs_SetupMod_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __BroadcastMRBs_SetupMod_List__item__criticality._const_tab = ___BroadcastMRBs_SetupMod_List__item__id_tab
    __BroadcastMRBs_SetupMod_List__item__criticality._const_tab_at = ('..', 'id')
    __BroadcastMRBs_SetupMod_List__item__criticality._const_tab_id = 'criticality'
    __BroadcastMRBs_SetupMod_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __BroadcastMRBs_SetupMod_List__item__value._const_tab = ___BroadcastMRBs_SetupMod_List__item__id_tab
    __BroadcastMRBs_SetupMod_List__item__value._const_tab_at = ('..', 'id')
    __BroadcastMRBs_SetupMod_List__item__value._const_tab_id = 'Value'
    _BroadcastMRBs_SetupMod_List__item_._cont = ASN1Dict([
        ('id', __BroadcastMRBs_SetupMod_List__item__id),
        ('criticality', __BroadcastMRBs_SetupMod_List__item__criticality),
        ('value', __BroadcastMRBs_SetupMod_List__item__value),
        ])
    _BroadcastMRBs_SetupMod_List__item_._ext = None
    BroadcastMRBs_SetupMod_List._cont = _BroadcastMRBs_SetupMod_List__item_
    BroadcastMRBs_SetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< BroadcastMRBs-FailedToBeSetupMod-List >-----#
    BroadcastMRBs_FailedToBeSetupMod_List = SEQ_OF(name='BroadcastMRBs-FailedToBeSetupMod-List', mode=MODE_TYPE)
    _BroadcastMRBs_FailedToBeSetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BroadcastMRBs_FailedToBeSetupMod_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BroadcastMRBs_FailedToBeSetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BroadcastMRBs_FailedToBeSetupMod_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastMRBs-FailedToBeSetupMod-Item')))
    ___BroadcastMRBs_FailedToBeSetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 463), ('criticality', 'ignore'), ('Value', ____BroadcastMRBs_FailedToBeSetupMod_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __BroadcastMRBs_FailedToBeSetupMod_List__item__id._const_tab = ___BroadcastMRBs_FailedToBeSetupMod_List__item__id_tab
    __BroadcastMRBs_FailedToBeSetupMod_List__item__id._const_tab_at = None
    __BroadcastMRBs_FailedToBeSetupMod_List__item__id._const_tab_id = 'id'
    __BroadcastMRBs_FailedToBeSetupMod_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __BroadcastMRBs_FailedToBeSetupMod_List__item__criticality._const_tab = ___BroadcastMRBs_FailedToBeSetupMod_List__item__id_tab
    __BroadcastMRBs_FailedToBeSetupMod_List__item__criticality._const_tab_at = ('..', 'id')
    __BroadcastMRBs_FailedToBeSetupMod_List__item__criticality._const_tab_id = 'criticality'
    __BroadcastMRBs_FailedToBeSetupMod_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __BroadcastMRBs_FailedToBeSetupMod_List__item__value._const_tab = ___BroadcastMRBs_FailedToBeSetupMod_List__item__id_tab
    __BroadcastMRBs_FailedToBeSetupMod_List__item__value._const_tab_at = ('..', 'id')
    __BroadcastMRBs_FailedToBeSetupMod_List__item__value._const_tab_id = 'Value'
    _BroadcastMRBs_FailedToBeSetupMod_List__item_._cont = ASN1Dict([
        ('id', __BroadcastMRBs_FailedToBeSetupMod_List__item__id),
        ('criticality', __BroadcastMRBs_FailedToBeSetupMod_List__item__criticality),
        ('value', __BroadcastMRBs_FailedToBeSetupMod_List__item__value),
        ])
    _BroadcastMRBs_FailedToBeSetupMod_List__item_._ext = None
    BroadcastMRBs_FailedToBeSetupMod_List._cont = _BroadcastMRBs_FailedToBeSetupMod_List__item_
    BroadcastMRBs_FailedToBeSetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< BroadcastMRBs-Modified-List >-----#
    BroadcastMRBs_Modified_List = SEQ_OF(name='BroadcastMRBs-Modified-List', mode=MODE_TYPE)
    _BroadcastMRBs_Modified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BroadcastMRBs_Modified_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BroadcastMRBs_Modified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BroadcastMRBs_Modified_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastMRBs-Modified-Item')))
    ___BroadcastMRBs_Modified_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 465), ('criticality', 'reject'), ('Value', ____BroadcastMRBs_Modified_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __BroadcastMRBs_Modified_List__item__id._const_tab = ___BroadcastMRBs_Modified_List__item__id_tab
    __BroadcastMRBs_Modified_List__item__id._const_tab_at = None
    __BroadcastMRBs_Modified_List__item__id._const_tab_id = 'id'
    __BroadcastMRBs_Modified_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __BroadcastMRBs_Modified_List__item__criticality._const_tab = ___BroadcastMRBs_Modified_List__item__id_tab
    __BroadcastMRBs_Modified_List__item__criticality._const_tab_at = ('..', 'id')
    __BroadcastMRBs_Modified_List__item__criticality._const_tab_id = 'criticality'
    __BroadcastMRBs_Modified_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __BroadcastMRBs_Modified_List__item__value._const_tab = ___BroadcastMRBs_Modified_List__item__id_tab
    __BroadcastMRBs_Modified_List__item__value._const_tab_at = ('..', 'id')
    __BroadcastMRBs_Modified_List__item__value._const_tab_id = 'Value'
    _BroadcastMRBs_Modified_List__item_._cont = ASN1Dict([
        ('id', __BroadcastMRBs_Modified_List__item__id),
        ('criticality', __BroadcastMRBs_Modified_List__item__criticality),
        ('value', __BroadcastMRBs_Modified_List__item__value),
        ])
    _BroadcastMRBs_Modified_List__item_._ext = None
    BroadcastMRBs_Modified_List._cont = _BroadcastMRBs_Modified_List__item_
    BroadcastMRBs_Modified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< BroadcastMRBs-FailedToBeModified-List >-----#
    BroadcastMRBs_FailedToBeModified_List = SEQ_OF(name='BroadcastMRBs-FailedToBeModified-List', mode=MODE_TYPE)
    _BroadcastMRBs_FailedToBeModified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __BroadcastMRBs_FailedToBeModified_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___BroadcastMRBs_FailedToBeModified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____BroadcastMRBs_FailedToBeModified_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastMRBs-FailedToBeModified-Item')))
    ___BroadcastMRBs_FailedToBeModified_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 459), ('criticality', 'ignore'), ('Value', ____BroadcastMRBs_FailedToBeModified_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __BroadcastMRBs_FailedToBeModified_List__item__id._const_tab = ___BroadcastMRBs_FailedToBeModified_List__item__id_tab
    __BroadcastMRBs_FailedToBeModified_List__item__id._const_tab_at = None
    __BroadcastMRBs_FailedToBeModified_List__item__id._const_tab_id = 'id'
    __BroadcastMRBs_FailedToBeModified_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __BroadcastMRBs_FailedToBeModified_List__item__criticality._const_tab = ___BroadcastMRBs_FailedToBeModified_List__item__id_tab
    __BroadcastMRBs_FailedToBeModified_List__item__criticality._const_tab_at = ('..', 'id')
    __BroadcastMRBs_FailedToBeModified_List__item__criticality._const_tab_id = 'criticality'
    __BroadcastMRBs_FailedToBeModified_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __BroadcastMRBs_FailedToBeModified_List__item__value._const_tab = ___BroadcastMRBs_FailedToBeModified_List__item__id_tab
    __BroadcastMRBs_FailedToBeModified_List__item__value._const_tab_at = ('..', 'id')
    __BroadcastMRBs_FailedToBeModified_List__item__value._const_tab_id = 'Value'
    _BroadcastMRBs_FailedToBeModified_List__item_._cont = ASN1Dict([
        ('id', __BroadcastMRBs_FailedToBeModified_List__item__id),
        ('criticality', __BroadcastMRBs_FailedToBeModified_List__item__criticality),
        ('value', __BroadcastMRBs_FailedToBeModified_List__item__value),
        ])
    _BroadcastMRBs_FailedToBeModified_List__item_._ext = None
    BroadcastMRBs_FailedToBeModified_List._cont = _BroadcastMRBs_FailedToBeModified_List__item_
    BroadcastMRBs_FailedToBeModified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< BroadcastMRBs-SetupMod-ItemIEs >-----#
    BroadcastMRBs_SetupMod_ItemIEs = CLASS(name='BroadcastMRBs-SetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BroadcastMRBs_SetupMod_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastMRBs-SetupMod-Item')))
    BroadcastMRBs_SetupMod_ItemIEs._val = ASN1Set(rv=[dict([('id', 469), ('criticality', 'reject'), ('Value', _BroadcastMRBs_SetupMod_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastMRBs-FailedToBeSetupMod-ItemIEs >-----#
    BroadcastMRBs_FailedToBeSetupMod_ItemIEs = CLASS(name='BroadcastMRBs-FailedToBeSetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BroadcastMRBs_FailedToBeSetupMod_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastMRBs-FailedToBeSetupMod-Item')))
    BroadcastMRBs_FailedToBeSetupMod_ItemIEs._val = ASN1Set(rv=[dict([('id', 463), ('criticality', 'ignore'), ('Value', _BroadcastMRBs_FailedToBeSetupMod_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastMRBs-Modified-ItemIEs >-----#
    BroadcastMRBs_Modified_ItemIEs = CLASS(name='BroadcastMRBs-Modified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BroadcastMRBs_Modified_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastMRBs-Modified-Item')))
    BroadcastMRBs_Modified_ItemIEs._val = ASN1Set(rv=[dict([('id', 465), ('criticality', 'reject'), ('Value', _BroadcastMRBs_Modified_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastMRBs-FailedToBeModified-ItemIEs >-----#
    BroadcastMRBs_FailedToBeModified_ItemIEs = CLASS(name='BroadcastMRBs-FailedToBeModified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BroadcastMRBs_FailedToBeModified_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'BroadcastMRBs-FailedToBeModified-Item')))
    BroadcastMRBs_FailedToBeModified_ItemIEs._val = ASN1Set(rv=[dict([('id', 459), ('criticality', 'ignore'), ('Value', _BroadcastMRBs_FailedToBeModified_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastContextModificationFailure >-----#
    BroadcastContextModificationFailure = SEQ(name='BroadcastContextModificationFailure', mode=MODE_TYPE)
    _BroadcastContextModificationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __BroadcastContextModificationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___BroadcastContextModificationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____BroadcastContextModificationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____BroadcastContextModificationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _____BroadcastContextModificationFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _____BroadcastContextModificationFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____BroadcastContextModificationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____BroadcastContextModificationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _____BroadcastContextModificationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _____BroadcastContextModificationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____BroadcastContextModificationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____BroadcastContextModificationFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BroadcastContextModificationFailure_protocolIEs__item__id._const_tab = ____BroadcastContextModificationFailure_protocolIEs__item__id_tab
    ___BroadcastContextModificationFailure_protocolIEs__item__id._const_tab_at = None
    ___BroadcastContextModificationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___BroadcastContextModificationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___BroadcastContextModificationFailure_protocolIEs__item__criticality._const_tab = ____BroadcastContextModificationFailure_protocolIEs__item__id_tab
    ___BroadcastContextModificationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastContextModificationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BroadcastContextModificationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___BroadcastContextModificationFailure_protocolIEs__item__value._const_tab = ____BroadcastContextModificationFailure_protocolIEs__item__id_tab
    ___BroadcastContextModificationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BroadcastContextModificationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __BroadcastContextModificationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BroadcastContextModificationFailure_protocolIEs__item__id),
        ('criticality', ___BroadcastContextModificationFailure_protocolIEs__item__criticality),
        ('value', ___BroadcastContextModificationFailure_protocolIEs__item__value),
        ])
    __BroadcastContextModificationFailure_protocolIEs__item_._ext = None
    _BroadcastContextModificationFailure_protocolIEs._cont = __BroadcastContextModificationFailure_protocolIEs__item_
    _BroadcastContextModificationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BroadcastContextModificationFailure._cont = ASN1Dict([
        ('protocolIEs', _BroadcastContextModificationFailure_protocolIEs),
        ])
    BroadcastContextModificationFailure._ext = []
    
    #-----< BroadcastContextModificationFailureIEs >-----#
    BroadcastContextModificationFailureIEs = CLASS(name='BroadcastContextModificationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _BroadcastContextModificationFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _BroadcastContextModificationFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _BroadcastContextModificationFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _BroadcastContextModificationFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    BroadcastContextModificationFailureIEs._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _BroadcastContextModificationFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _BroadcastContextModificationFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _BroadcastContextModificationFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _BroadcastContextModificationFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MulticastGroupPaging >-----#
    MulticastGroupPaging = SEQ(name='MulticastGroupPaging', mode=MODE_TYPE)
    _MulticastGroupPaging_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __MulticastGroupPaging_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___MulticastGroupPaging_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____MulticastGroupPaging_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____MulticastGroupPaging_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-Session-ID')))
    _____MulticastGroupPaging_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEIdentity-List-For-Paging-List')))
    _____MulticastGroupPaging_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MC-PagingCell-list')))
    ____MulticastGroupPaging_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 455), ('criticality', 'reject'), ('Value', _____MulticastGroupPaging_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 479), ('criticality', 'ignore'), ('Value', _____MulticastGroupPaging_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 687), ('criticality', 'ignore'), ('Value', _____MulticastGroupPaging_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MulticastGroupPaging_protocolIEs__item__id._const_tab = ____MulticastGroupPaging_protocolIEs__item__id_tab
    ___MulticastGroupPaging_protocolIEs__item__id._const_tab_at = None
    ___MulticastGroupPaging_protocolIEs__item__id._const_tab_id = 'id'
    ___MulticastGroupPaging_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___MulticastGroupPaging_protocolIEs__item__criticality._const_tab = ____MulticastGroupPaging_protocolIEs__item__id_tab
    ___MulticastGroupPaging_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastGroupPaging_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MulticastGroupPaging_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___MulticastGroupPaging_protocolIEs__item__value._const_tab = ____MulticastGroupPaging_protocolIEs__item__id_tab
    ___MulticastGroupPaging_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MulticastGroupPaging_protocolIEs__item__value._const_tab_id = 'Value'
    __MulticastGroupPaging_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MulticastGroupPaging_protocolIEs__item__id),
        ('criticality', ___MulticastGroupPaging_protocolIEs__item__criticality),
        ('value', ___MulticastGroupPaging_protocolIEs__item__value),
        ])
    __MulticastGroupPaging_protocolIEs__item_._ext = None
    _MulticastGroupPaging_protocolIEs._cont = __MulticastGroupPaging_protocolIEs__item_
    _MulticastGroupPaging_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MulticastGroupPaging._cont = ASN1Dict([
        ('protocolIEs', _MulticastGroupPaging_protocolIEs),
        ])
    MulticastGroupPaging._ext = []
    
    #-----< MulticastGroupPagingIEs >-----#
    MulticastGroupPagingIEs = CLASS(name='MulticastGroupPagingIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastGroupPagingIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-Session-ID')))
    _MulticastGroupPagingIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEIdentity-List-For-Paging-List')))
    _MulticastGroupPagingIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MC-PagingCell-list')))
    MulticastGroupPagingIEs._val = ASN1Set(rv=[dict([('id', 455), ('criticality', 'reject'), ('Value', _MulticastGroupPagingIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 479), ('criticality', 'ignore'), ('Value', _MulticastGroupPagingIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 687), ('criticality', 'ignore'), ('Value', _MulticastGroupPagingIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEIdentity-List-For-Paging-List >-----#
    UEIdentity_List_For_Paging_List = SEQ_OF(name='UEIdentity-List-For-Paging-List', mode=MODE_TYPE)
    _UEIdentity_List_For_Paging_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UEIdentity_List_For_Paging_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___UEIdentity_List_For_Paging_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____UEIdentity_List_For_Paging_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UEIdentity-List-For-Paging-Item')))
    ___UEIdentity_List_For_Paging_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 480), ('criticality', 'ignore'), ('Value', ____UEIdentity_List_For_Paging_List__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    __UEIdentity_List_For_Paging_List__item__id._const_tab = ___UEIdentity_List_For_Paging_List__item__id_tab
    __UEIdentity_List_For_Paging_List__item__id._const_tab_at = None
    __UEIdentity_List_For_Paging_List__item__id._const_tab_id = 'id'
    __UEIdentity_List_For_Paging_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __UEIdentity_List_For_Paging_List__item__criticality._const_tab = ___UEIdentity_List_For_Paging_List__item__id_tab
    __UEIdentity_List_For_Paging_List__item__criticality._const_tab_at = ('..', 'id')
    __UEIdentity_List_For_Paging_List__item__criticality._const_tab_id = 'criticality'
    __UEIdentity_List_For_Paging_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __UEIdentity_List_For_Paging_List__item__value._const_tab = ___UEIdentity_List_For_Paging_List__item__id_tab
    __UEIdentity_List_For_Paging_List__item__value._const_tab_at = ('..', 'id')
    __UEIdentity_List_For_Paging_List__item__value._const_tab_id = 'Value'
    _UEIdentity_List_For_Paging_List__item_._cont = ASN1Dict([
        ('id', __UEIdentity_List_For_Paging_List__item__id),
        ('criticality', __UEIdentity_List_For_Paging_List__item__criticality),
        ('value', __UEIdentity_List_For_Paging_List__item__value),
        ])
    _UEIdentity_List_For_Paging_List__item_._ext = None
    UEIdentity_List_For_Paging_List._cont = _UEIdentity_List_For_Paging_List__item_
    UEIdentity_List_For_Paging_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4096)], ev=None, er=[])
    
    #-----< UEIdentity-List-For-Paging-ItemIEs >-----#
    UEIdentity_List_For_Paging_ItemIEs = CLASS(name='UEIdentity-List-For-Paging-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _UEIdentity_List_For_Paging_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'UEIdentity-List-For-Paging-Item')))
    UEIdentity_List_For_Paging_ItemIEs._val = ASN1Set(rv=[dict([('id', 480), ('criticality', 'ignore'), ('Value', _UEIdentity_List_For_Paging_ItemIEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MC-PagingCell-list >-----#
    MC_PagingCell_list = SEQ_OF(name='MC-PagingCell-list', mode=MODE_TYPE)
    _MC_PagingCell_list__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __MC_PagingCell_list__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___MC_PagingCell_list__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____MC_PagingCell_list__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MC-PagingCell-Item')))
    ___MC_PagingCell_list__item__id_tab._val = ASN1Set(rv=[dict([('id', 688), ('criticality', 'ignore'), ('Value', ____MC_PagingCell_list__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __MC_PagingCell_list__item__id._const_tab = ___MC_PagingCell_list__item__id_tab
    __MC_PagingCell_list__item__id._const_tab_at = None
    __MC_PagingCell_list__item__id._const_tab_id = 'id'
    __MC_PagingCell_list__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __MC_PagingCell_list__item__criticality._const_tab = ___MC_PagingCell_list__item__id_tab
    __MC_PagingCell_list__item__criticality._const_tab_at = ('..', 'id')
    __MC_PagingCell_list__item__criticality._const_tab_id = 'criticality'
    __MC_PagingCell_list__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __MC_PagingCell_list__item__value._const_tab = ___MC_PagingCell_list__item__id_tab
    __MC_PagingCell_list__item__value._const_tab_at = ('..', 'id')
    __MC_PagingCell_list__item__value._const_tab_id = 'Value'
    _MC_PagingCell_list__item_._cont = ASN1Dict([
        ('id', __MC_PagingCell_list__item__id),
        ('criticality', __MC_PagingCell_list__item__criticality),
        ('value', __MC_PagingCell_list__item__value),
        ])
    _MC_PagingCell_list__item_._ext = None
    MC_PagingCell_list._cont = _MC_PagingCell_list__item_
    MC_PagingCell_list._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< MC-PagingCell-ItemIEs >-----#
    MC_PagingCell_ItemIEs = CLASS(name='MC-PagingCell-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MC_PagingCell_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MC-PagingCell-Item')))
    MC_PagingCell_ItemIEs._val = ASN1Set(rv=[dict([('id', 688), ('criticality', 'ignore'), ('Value', _MC_PagingCell_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MulticastContextSetupRequest >-----#
    MulticastContextSetupRequest = SEQ(name='MulticastContextSetupRequest', mode=MODE_TYPE)
    _MulticastContextSetupRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __MulticastContextSetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___MulticastContextSetupRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____MulticastContextSetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____MulticastContextSetupRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _____MulticastContextSetupRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-Session-ID')))
    _____MulticastContextSetupRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-ServiceArea')))
    _____MulticastContextSetupRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SNSSAI')))
    _____MulticastContextSetupRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastMRBs-ToBeSetup-List')))
    ____MulticastContextSetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _____MulticastContextSetupRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 455), ('criticality', 'reject'), ('Value', _____MulticastContextSetupRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 481), ('criticality', 'reject'), ('Value', _____MulticastContextSetupRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 456), ('criticality', 'reject'), ('Value', _____MulticastContextSetupRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 498), ('criticality', 'reject'), ('Value', _____MulticastContextSetupRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MulticastContextSetupRequest_protocolIEs__item__id._const_tab = ____MulticastContextSetupRequest_protocolIEs__item__id_tab
    ___MulticastContextSetupRequest_protocolIEs__item__id._const_tab_at = None
    ___MulticastContextSetupRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___MulticastContextSetupRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___MulticastContextSetupRequest_protocolIEs__item__criticality._const_tab = ____MulticastContextSetupRequest_protocolIEs__item__id_tab
    ___MulticastContextSetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastContextSetupRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MulticastContextSetupRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___MulticastContextSetupRequest_protocolIEs__item__value._const_tab = ____MulticastContextSetupRequest_protocolIEs__item__id_tab
    ___MulticastContextSetupRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MulticastContextSetupRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __MulticastContextSetupRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MulticastContextSetupRequest_protocolIEs__item__id),
        ('criticality', ___MulticastContextSetupRequest_protocolIEs__item__criticality),
        ('value', ___MulticastContextSetupRequest_protocolIEs__item__value),
        ])
    __MulticastContextSetupRequest_protocolIEs__item_._ext = None
    _MulticastContextSetupRequest_protocolIEs._cont = __MulticastContextSetupRequest_protocolIEs__item_
    _MulticastContextSetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MulticastContextSetupRequest._cont = ASN1Dict([
        ('protocolIEs', _MulticastContextSetupRequest_protocolIEs),
        ])
    MulticastContextSetupRequest._ext = []
    
    #-----< MulticastContextSetupRequestIEs >-----#
    MulticastContextSetupRequestIEs = CLASS(name='MulticastContextSetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastContextSetupRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _MulticastContextSetupRequestIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-Session-ID')))
    _MulticastContextSetupRequestIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-ServiceArea')))
    _MulticastContextSetupRequestIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'SNSSAI')))
    _MulticastContextSetupRequestIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastMRBs-ToBeSetup-List')))
    MulticastContextSetupRequestIEs._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _MulticastContextSetupRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 455), ('criticality', 'reject'), ('Value', _MulticastContextSetupRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 481), ('criticality', 'reject'), ('Value', _MulticastContextSetupRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 456), ('criticality', 'reject'), ('Value', _MulticastContextSetupRequestIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 498), ('criticality', 'reject'), ('Value', _MulticastContextSetupRequestIEs_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MulticastMRBs-ToBeSetup-List >-----#
    MulticastMRBs_ToBeSetup_List = SEQ_OF(name='MulticastMRBs-ToBeSetup-List', mode=MODE_TYPE)
    _MulticastMRBs_ToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __MulticastMRBs_ToBeSetup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___MulticastMRBs_ToBeSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____MulticastMRBs_ToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMRBs-ToBeSetup-Item')))
    ___MulticastMRBs_ToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 499), ('criticality', 'reject'), ('Value', ____MulticastMRBs_ToBeSetup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __MulticastMRBs_ToBeSetup_List__item__id._const_tab = ___MulticastMRBs_ToBeSetup_List__item__id_tab
    __MulticastMRBs_ToBeSetup_List__item__id._const_tab_at = None
    __MulticastMRBs_ToBeSetup_List__item__id._const_tab_id = 'id'
    __MulticastMRBs_ToBeSetup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __MulticastMRBs_ToBeSetup_List__item__criticality._const_tab = ___MulticastMRBs_ToBeSetup_List__item__id_tab
    __MulticastMRBs_ToBeSetup_List__item__criticality._const_tab_at = ('..', 'id')
    __MulticastMRBs_ToBeSetup_List__item__criticality._const_tab_id = 'criticality'
    __MulticastMRBs_ToBeSetup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __MulticastMRBs_ToBeSetup_List__item__value._const_tab = ___MulticastMRBs_ToBeSetup_List__item__id_tab
    __MulticastMRBs_ToBeSetup_List__item__value._const_tab_at = ('..', 'id')
    __MulticastMRBs_ToBeSetup_List__item__value._const_tab_id = 'Value'
    _MulticastMRBs_ToBeSetup_List__item_._cont = ASN1Dict([
        ('id', __MulticastMRBs_ToBeSetup_List__item__id),
        ('criticality', __MulticastMRBs_ToBeSetup_List__item__criticality),
        ('value', __MulticastMRBs_ToBeSetup_List__item__value),
        ])
    _MulticastMRBs_ToBeSetup_List__item_._ext = None
    MulticastMRBs_ToBeSetup_List._cont = _MulticastMRBs_ToBeSetup_List__item_
    MulticastMRBs_ToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MulticastMRBs-ToBeSetup-ItemIEs >-----#
    MulticastMRBs_ToBeSetup_ItemIEs = CLASS(name='MulticastMRBs-ToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastMRBs_ToBeSetup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMRBs-ToBeSetup-Item')))
    MulticastMRBs_ToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([('id', 499), ('criticality', 'reject'), ('Value', _MulticastMRBs_ToBeSetup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MulticastContextSetupResponse >-----#
    MulticastContextSetupResponse = SEQ(name='MulticastContextSetupResponse', mode=MODE_TYPE)
    _MulticastContextSetupResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __MulticastContextSetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___MulticastContextSetupResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____MulticastContextSetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____MulticastContextSetupResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _____MulticastContextSetupResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _____MulticastContextSetupResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastMRBs-Setup-List')))
    _____MulticastContextSetupResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastMRBs-FailedToBeSetup-List')))
    _____MulticastContextSetupResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____MulticastContextSetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _____MulticastContextSetupResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _____MulticastContextSetupResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 490), ('criticality', 'reject'), ('Value', _____MulticastContextSetupResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 484), ('criticality', 'ignore'), ('Value', _____MulticastContextSetupResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____MulticastContextSetupResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MulticastContextSetupResponse_protocolIEs__item__id._const_tab = ____MulticastContextSetupResponse_protocolIEs__item__id_tab
    ___MulticastContextSetupResponse_protocolIEs__item__id._const_tab_at = None
    ___MulticastContextSetupResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___MulticastContextSetupResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___MulticastContextSetupResponse_protocolIEs__item__criticality._const_tab = ____MulticastContextSetupResponse_protocolIEs__item__id_tab
    ___MulticastContextSetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastContextSetupResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MulticastContextSetupResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___MulticastContextSetupResponse_protocolIEs__item__value._const_tab = ____MulticastContextSetupResponse_protocolIEs__item__id_tab
    ___MulticastContextSetupResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MulticastContextSetupResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __MulticastContextSetupResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MulticastContextSetupResponse_protocolIEs__item__id),
        ('criticality', ___MulticastContextSetupResponse_protocolIEs__item__criticality),
        ('value', ___MulticastContextSetupResponse_protocolIEs__item__value),
        ])
    __MulticastContextSetupResponse_protocolIEs__item_._ext = None
    _MulticastContextSetupResponse_protocolIEs._cont = __MulticastContextSetupResponse_protocolIEs__item_
    _MulticastContextSetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MulticastContextSetupResponse._cont = ASN1Dict([
        ('protocolIEs', _MulticastContextSetupResponse_protocolIEs),
        ])
    MulticastContextSetupResponse._ext = []
    
    #-----< MulticastContextSetupResponseIEs >-----#
    MulticastContextSetupResponseIEs = CLASS(name='MulticastContextSetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastContextSetupResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _MulticastContextSetupResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _MulticastContextSetupResponseIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastMRBs-Setup-List')))
    _MulticastContextSetupResponseIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastMRBs-FailedToBeSetup-List')))
    _MulticastContextSetupResponseIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    MulticastContextSetupResponseIEs._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _MulticastContextSetupResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _MulticastContextSetupResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 490), ('criticality', 'reject'), ('Value', _MulticastContextSetupResponseIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 484), ('criticality', 'ignore'), ('Value', _MulticastContextSetupResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _MulticastContextSetupResponseIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MulticastMRBs-Setup-List >-----#
    MulticastMRBs_Setup_List = SEQ_OF(name='MulticastMRBs-Setup-List', mode=MODE_TYPE)
    _MulticastMRBs_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __MulticastMRBs_Setup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___MulticastMRBs_Setup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____MulticastMRBs_Setup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMRBs-Setup-Item')))
    ___MulticastMRBs_Setup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 491), ('criticality', 'reject'), ('Value', ____MulticastMRBs_Setup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __MulticastMRBs_Setup_List__item__id._const_tab = ___MulticastMRBs_Setup_List__item__id_tab
    __MulticastMRBs_Setup_List__item__id._const_tab_at = None
    __MulticastMRBs_Setup_List__item__id._const_tab_id = 'id'
    __MulticastMRBs_Setup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __MulticastMRBs_Setup_List__item__criticality._const_tab = ___MulticastMRBs_Setup_List__item__id_tab
    __MulticastMRBs_Setup_List__item__criticality._const_tab_at = ('..', 'id')
    __MulticastMRBs_Setup_List__item__criticality._const_tab_id = 'criticality'
    __MulticastMRBs_Setup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __MulticastMRBs_Setup_List__item__value._const_tab = ___MulticastMRBs_Setup_List__item__id_tab
    __MulticastMRBs_Setup_List__item__value._const_tab_at = ('..', 'id')
    __MulticastMRBs_Setup_List__item__value._const_tab_id = 'Value'
    _MulticastMRBs_Setup_List__item_._cont = ASN1Dict([
        ('id', __MulticastMRBs_Setup_List__item__id),
        ('criticality', __MulticastMRBs_Setup_List__item__criticality),
        ('value', __MulticastMRBs_Setup_List__item__value),
        ])
    _MulticastMRBs_Setup_List__item_._ext = None
    MulticastMRBs_Setup_List._cont = _MulticastMRBs_Setup_List__item_
    MulticastMRBs_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MulticastMRBs-FailedToBeSetup-List >-----#
    MulticastMRBs_FailedToBeSetup_List = SEQ_OF(name='MulticastMRBs-FailedToBeSetup-List', mode=MODE_TYPE)
    _MulticastMRBs_FailedToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __MulticastMRBs_FailedToBeSetup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___MulticastMRBs_FailedToBeSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____MulticastMRBs_FailedToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMRBs-FailedToBeSetup-Item')))
    ___MulticastMRBs_FailedToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 485), ('criticality', 'ignore'), ('Value', ____MulticastMRBs_FailedToBeSetup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __MulticastMRBs_FailedToBeSetup_List__item__id._const_tab = ___MulticastMRBs_FailedToBeSetup_List__item__id_tab
    __MulticastMRBs_FailedToBeSetup_List__item__id._const_tab_at = None
    __MulticastMRBs_FailedToBeSetup_List__item__id._const_tab_id = 'id'
    __MulticastMRBs_FailedToBeSetup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __MulticastMRBs_FailedToBeSetup_List__item__criticality._const_tab = ___MulticastMRBs_FailedToBeSetup_List__item__id_tab
    __MulticastMRBs_FailedToBeSetup_List__item__criticality._const_tab_at = ('..', 'id')
    __MulticastMRBs_FailedToBeSetup_List__item__criticality._const_tab_id = 'criticality'
    __MulticastMRBs_FailedToBeSetup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __MulticastMRBs_FailedToBeSetup_List__item__value._const_tab = ___MulticastMRBs_FailedToBeSetup_List__item__id_tab
    __MulticastMRBs_FailedToBeSetup_List__item__value._const_tab_at = ('..', 'id')
    __MulticastMRBs_FailedToBeSetup_List__item__value._const_tab_id = 'Value'
    _MulticastMRBs_FailedToBeSetup_List__item_._cont = ASN1Dict([
        ('id', __MulticastMRBs_FailedToBeSetup_List__item__id),
        ('criticality', __MulticastMRBs_FailedToBeSetup_List__item__criticality),
        ('value', __MulticastMRBs_FailedToBeSetup_List__item__value),
        ])
    _MulticastMRBs_FailedToBeSetup_List__item_._ext = None
    MulticastMRBs_FailedToBeSetup_List._cont = _MulticastMRBs_FailedToBeSetup_List__item_
    MulticastMRBs_FailedToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MulticastMRBs-Setup-ItemIEs >-----#
    MulticastMRBs_Setup_ItemIEs = CLASS(name='MulticastMRBs-Setup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastMRBs_Setup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMRBs-Setup-Item')))
    MulticastMRBs_Setup_ItemIEs._val = ASN1Set(rv=[dict([('id', 491), ('criticality', 'reject'), ('Value', _MulticastMRBs_Setup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MulticastMRBs-FailedToBeSetup-ItemIEs >-----#
    MulticastMRBs_FailedToBeSetup_ItemIEs = CLASS(name='MulticastMRBs-FailedToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastMRBs_FailedToBeSetup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMRBs-FailedToBeSetup-Item')))
    MulticastMRBs_FailedToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([('id', 485), ('criticality', 'ignore'), ('Value', _MulticastMRBs_FailedToBeSetup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MulticastContextSetupFailure >-----#
    MulticastContextSetupFailure = SEQ(name='MulticastContextSetupFailure', mode=MODE_TYPE)
    _MulticastContextSetupFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __MulticastContextSetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___MulticastContextSetupFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____MulticastContextSetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____MulticastContextSetupFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _____MulticastContextSetupFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _____MulticastContextSetupFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____MulticastContextSetupFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____MulticastContextSetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _____MulticastContextSetupFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'ignore'), ('Value', _____MulticastContextSetupFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____MulticastContextSetupFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____MulticastContextSetupFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MulticastContextSetupFailure_protocolIEs__item__id._const_tab = ____MulticastContextSetupFailure_protocolIEs__item__id_tab
    ___MulticastContextSetupFailure_protocolIEs__item__id._const_tab_at = None
    ___MulticastContextSetupFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___MulticastContextSetupFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___MulticastContextSetupFailure_protocolIEs__item__criticality._const_tab = ____MulticastContextSetupFailure_protocolIEs__item__id_tab
    ___MulticastContextSetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastContextSetupFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MulticastContextSetupFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___MulticastContextSetupFailure_protocolIEs__item__value._const_tab = ____MulticastContextSetupFailure_protocolIEs__item__id_tab
    ___MulticastContextSetupFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MulticastContextSetupFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __MulticastContextSetupFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MulticastContextSetupFailure_protocolIEs__item__id),
        ('criticality', ___MulticastContextSetupFailure_protocolIEs__item__criticality),
        ('value', ___MulticastContextSetupFailure_protocolIEs__item__value),
        ])
    __MulticastContextSetupFailure_protocolIEs__item_._ext = None
    _MulticastContextSetupFailure_protocolIEs._cont = __MulticastContextSetupFailure_protocolIEs__item_
    _MulticastContextSetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MulticastContextSetupFailure._cont = ASN1Dict([
        ('protocolIEs', _MulticastContextSetupFailure_protocolIEs),
        ])
    MulticastContextSetupFailure._ext = []
    
    #-----< MulticastContextSetupFailureIEs >-----#
    MulticastContextSetupFailureIEs = CLASS(name='MulticastContextSetupFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastContextSetupFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _MulticastContextSetupFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _MulticastContextSetupFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _MulticastContextSetupFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    MulticastContextSetupFailureIEs._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _MulticastContextSetupFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'ignore'), ('Value', _MulticastContextSetupFailureIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _MulticastContextSetupFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _MulticastContextSetupFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MulticastContextReleaseCommand >-----#
    MulticastContextReleaseCommand = SEQ(name='MulticastContextReleaseCommand', mode=MODE_TYPE)
    _MulticastContextReleaseCommand_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __MulticastContextReleaseCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___MulticastContextReleaseCommand_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____MulticastContextReleaseCommand_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____MulticastContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _____MulticastContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _____MulticastContextReleaseCommand_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    ____MulticastContextReleaseCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _____MulticastContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _____MulticastContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____MulticastContextReleaseCommand_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MulticastContextReleaseCommand_protocolIEs__item__id._const_tab = ____MulticastContextReleaseCommand_protocolIEs__item__id_tab
    ___MulticastContextReleaseCommand_protocolIEs__item__id._const_tab_at = None
    ___MulticastContextReleaseCommand_protocolIEs__item__id._const_tab_id = 'id'
    ___MulticastContextReleaseCommand_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___MulticastContextReleaseCommand_protocolIEs__item__criticality._const_tab = ____MulticastContextReleaseCommand_protocolIEs__item__id_tab
    ___MulticastContextReleaseCommand_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastContextReleaseCommand_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MulticastContextReleaseCommand_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___MulticastContextReleaseCommand_protocolIEs__item__value._const_tab = ____MulticastContextReleaseCommand_protocolIEs__item__id_tab
    ___MulticastContextReleaseCommand_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MulticastContextReleaseCommand_protocolIEs__item__value._const_tab_id = 'Value'
    __MulticastContextReleaseCommand_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MulticastContextReleaseCommand_protocolIEs__item__id),
        ('criticality', ___MulticastContextReleaseCommand_protocolIEs__item__criticality),
        ('value', ___MulticastContextReleaseCommand_protocolIEs__item__value),
        ])
    __MulticastContextReleaseCommand_protocolIEs__item_._ext = None
    _MulticastContextReleaseCommand_protocolIEs._cont = __MulticastContextReleaseCommand_protocolIEs__item_
    _MulticastContextReleaseCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MulticastContextReleaseCommand._cont = ASN1Dict([
        ('protocolIEs', _MulticastContextReleaseCommand_protocolIEs),
        ])
    MulticastContextReleaseCommand._ext = []
    
    #-----< MulticastContextReleaseCommandIEs >-----#
    MulticastContextReleaseCommandIEs = CLASS(name='MulticastContextReleaseCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastContextReleaseCommandIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _MulticastContextReleaseCommandIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _MulticastContextReleaseCommandIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    MulticastContextReleaseCommandIEs._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _MulticastContextReleaseCommandIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _MulticastContextReleaseCommandIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _MulticastContextReleaseCommandIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MulticastContextReleaseComplete >-----#
    MulticastContextReleaseComplete = SEQ(name='MulticastContextReleaseComplete', mode=MODE_TYPE)
    _MulticastContextReleaseComplete_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __MulticastContextReleaseComplete_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___MulticastContextReleaseComplete_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____MulticastContextReleaseComplete_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____MulticastContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _____MulticastContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _____MulticastContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____MulticastContextReleaseComplete_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _____MulticastContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _____MulticastContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____MulticastContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MulticastContextReleaseComplete_protocolIEs__item__id._const_tab = ____MulticastContextReleaseComplete_protocolIEs__item__id_tab
    ___MulticastContextReleaseComplete_protocolIEs__item__id._const_tab_at = None
    ___MulticastContextReleaseComplete_protocolIEs__item__id._const_tab_id = 'id'
    ___MulticastContextReleaseComplete_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___MulticastContextReleaseComplete_protocolIEs__item__criticality._const_tab = ____MulticastContextReleaseComplete_protocolIEs__item__id_tab
    ___MulticastContextReleaseComplete_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastContextReleaseComplete_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MulticastContextReleaseComplete_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___MulticastContextReleaseComplete_protocolIEs__item__value._const_tab = ____MulticastContextReleaseComplete_protocolIEs__item__id_tab
    ___MulticastContextReleaseComplete_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MulticastContextReleaseComplete_protocolIEs__item__value._const_tab_id = 'Value'
    __MulticastContextReleaseComplete_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MulticastContextReleaseComplete_protocolIEs__item__id),
        ('criticality', ___MulticastContextReleaseComplete_protocolIEs__item__criticality),
        ('value', ___MulticastContextReleaseComplete_protocolIEs__item__value),
        ])
    __MulticastContextReleaseComplete_protocolIEs__item_._ext = None
    _MulticastContextReleaseComplete_protocolIEs._cont = __MulticastContextReleaseComplete_protocolIEs__item_
    _MulticastContextReleaseComplete_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MulticastContextReleaseComplete._cont = ASN1Dict([
        ('protocolIEs', _MulticastContextReleaseComplete_protocolIEs),
        ])
    MulticastContextReleaseComplete._ext = []
    
    #-----< MulticastContextReleaseCompleteIEs >-----#
    MulticastContextReleaseCompleteIEs = CLASS(name='MulticastContextReleaseCompleteIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastContextReleaseCompleteIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _MulticastContextReleaseCompleteIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _MulticastContextReleaseCompleteIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    MulticastContextReleaseCompleteIEs._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _MulticastContextReleaseCompleteIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _MulticastContextReleaseCompleteIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _MulticastContextReleaseCompleteIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MulticastContextReleaseRequest >-----#
    MulticastContextReleaseRequest = SEQ(name='MulticastContextReleaseRequest', mode=MODE_TYPE)
    _MulticastContextReleaseRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __MulticastContextReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___MulticastContextReleaseRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____MulticastContextReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____MulticastContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _____MulticastContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _____MulticastContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    ____MulticastContextReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _____MulticastContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _____MulticastContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____MulticastContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MulticastContextReleaseRequest_protocolIEs__item__id._const_tab = ____MulticastContextReleaseRequest_protocolIEs__item__id_tab
    ___MulticastContextReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___MulticastContextReleaseRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___MulticastContextReleaseRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___MulticastContextReleaseRequest_protocolIEs__item__criticality._const_tab = ____MulticastContextReleaseRequest_protocolIEs__item__id_tab
    ___MulticastContextReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastContextReleaseRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MulticastContextReleaseRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___MulticastContextReleaseRequest_protocolIEs__item__value._const_tab = ____MulticastContextReleaseRequest_protocolIEs__item__id_tab
    ___MulticastContextReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MulticastContextReleaseRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __MulticastContextReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MulticastContextReleaseRequest_protocolIEs__item__id),
        ('criticality', ___MulticastContextReleaseRequest_protocolIEs__item__criticality),
        ('value', ___MulticastContextReleaseRequest_protocolIEs__item__value),
        ])
    __MulticastContextReleaseRequest_protocolIEs__item_._ext = None
    _MulticastContextReleaseRequest_protocolIEs._cont = __MulticastContextReleaseRequest_protocolIEs__item_
    _MulticastContextReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MulticastContextReleaseRequest._cont = ASN1Dict([
        ('protocolIEs', _MulticastContextReleaseRequest_protocolIEs),
        ])
    MulticastContextReleaseRequest._ext = []
    
    #-----< MulticastContextReleaseRequestIEs >-----#
    MulticastContextReleaseRequestIEs = CLASS(name='MulticastContextReleaseRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastContextReleaseRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _MulticastContextReleaseRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _MulticastContextReleaseRequestIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    MulticastContextReleaseRequestIEs._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _MulticastContextReleaseRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _MulticastContextReleaseRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _MulticastContextReleaseRequestIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MulticastContextModificationRequest >-----#
    MulticastContextModificationRequest = SEQ(name='MulticastContextModificationRequest', mode=MODE_TYPE)
    _MulticastContextModificationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __MulticastContextModificationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___MulticastContextModificationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____MulticastContextModificationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____MulticastContextModificationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _____MulticastContextModificationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _____MulticastContextModificationRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-ServiceArea')))
    _____MulticastContextModificationRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastMRBs-ToBeSetupMod-List')))
    _____MulticastContextModificationRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastMRBs-ToBeModified-List')))
    _____MulticastContextModificationRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastMRBs-ToBeReleased-List')))
    ____MulticastContextModificationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _____MulticastContextModificationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _____MulticastContextModificationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 481), ('criticality', 'reject'), ('Value', _____MulticastContextModificationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 500), ('criticality', 'reject'), ('Value', _____MulticastContextModificationRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 494), ('criticality', 'reject'), ('Value', _____MulticastContextModificationRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 496), ('criticality', 'reject'), ('Value', _____MulticastContextModificationRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MulticastContextModificationRequest_protocolIEs__item__id._const_tab = ____MulticastContextModificationRequest_protocolIEs__item__id_tab
    ___MulticastContextModificationRequest_protocolIEs__item__id._const_tab_at = None
    ___MulticastContextModificationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___MulticastContextModificationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___MulticastContextModificationRequest_protocolIEs__item__criticality._const_tab = ____MulticastContextModificationRequest_protocolIEs__item__id_tab
    ___MulticastContextModificationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastContextModificationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MulticastContextModificationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___MulticastContextModificationRequest_protocolIEs__item__value._const_tab = ____MulticastContextModificationRequest_protocolIEs__item__id_tab
    ___MulticastContextModificationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MulticastContextModificationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __MulticastContextModificationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MulticastContextModificationRequest_protocolIEs__item__id),
        ('criticality', ___MulticastContextModificationRequest_protocolIEs__item__criticality),
        ('value', ___MulticastContextModificationRequest_protocolIEs__item__value),
        ])
    __MulticastContextModificationRequest_protocolIEs__item_._ext = None
    _MulticastContextModificationRequest_protocolIEs._cont = __MulticastContextModificationRequest_protocolIEs__item_
    _MulticastContextModificationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MulticastContextModificationRequest._cont = ASN1Dict([
        ('protocolIEs', _MulticastContextModificationRequest_protocolIEs),
        ])
    MulticastContextModificationRequest._ext = []
    
    #-----< MulticastContextModificationRequestIEs >-----#
    MulticastContextModificationRequestIEs = CLASS(name='MulticastContextModificationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastContextModificationRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _MulticastContextModificationRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _MulticastContextModificationRequestIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBS-ServiceArea')))
    _MulticastContextModificationRequestIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastMRBs-ToBeSetupMod-List')))
    _MulticastContextModificationRequestIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastMRBs-ToBeModified-List')))
    _MulticastContextModificationRequestIEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastMRBs-ToBeReleased-List')))
    MulticastContextModificationRequestIEs._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _MulticastContextModificationRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _MulticastContextModificationRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 481), ('criticality', 'reject'), ('Value', _MulticastContextModificationRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 500), ('criticality', 'reject'), ('Value', _MulticastContextModificationRequestIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 494), ('criticality', 'reject'), ('Value', _MulticastContextModificationRequestIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 496), ('criticality', 'reject'), ('Value', _MulticastContextModificationRequestIEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MulticastMRBs-ToBeSetupMod-List >-----#
    MulticastMRBs_ToBeSetupMod_List = SEQ_OF(name='MulticastMRBs-ToBeSetupMod-List', mode=MODE_TYPE)
    _MulticastMRBs_ToBeSetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __MulticastMRBs_ToBeSetupMod_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___MulticastMRBs_ToBeSetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____MulticastMRBs_ToBeSetupMod_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMRBs-ToBeSetupMod-Item')))
    ___MulticastMRBs_ToBeSetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 501), ('criticality', 'reject'), ('Value', ____MulticastMRBs_ToBeSetupMod_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __MulticastMRBs_ToBeSetupMod_List__item__id._const_tab = ___MulticastMRBs_ToBeSetupMod_List__item__id_tab
    __MulticastMRBs_ToBeSetupMod_List__item__id._const_tab_at = None
    __MulticastMRBs_ToBeSetupMod_List__item__id._const_tab_id = 'id'
    __MulticastMRBs_ToBeSetupMod_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __MulticastMRBs_ToBeSetupMod_List__item__criticality._const_tab = ___MulticastMRBs_ToBeSetupMod_List__item__id_tab
    __MulticastMRBs_ToBeSetupMod_List__item__criticality._const_tab_at = ('..', 'id')
    __MulticastMRBs_ToBeSetupMod_List__item__criticality._const_tab_id = 'criticality'
    __MulticastMRBs_ToBeSetupMod_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __MulticastMRBs_ToBeSetupMod_List__item__value._const_tab = ___MulticastMRBs_ToBeSetupMod_List__item__id_tab
    __MulticastMRBs_ToBeSetupMod_List__item__value._const_tab_at = ('..', 'id')
    __MulticastMRBs_ToBeSetupMod_List__item__value._const_tab_id = 'Value'
    _MulticastMRBs_ToBeSetupMod_List__item_._cont = ASN1Dict([
        ('id', __MulticastMRBs_ToBeSetupMod_List__item__id),
        ('criticality', __MulticastMRBs_ToBeSetupMod_List__item__criticality),
        ('value', __MulticastMRBs_ToBeSetupMod_List__item__value),
        ])
    _MulticastMRBs_ToBeSetupMod_List__item_._ext = None
    MulticastMRBs_ToBeSetupMod_List._cont = _MulticastMRBs_ToBeSetupMod_List__item_
    MulticastMRBs_ToBeSetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MulticastMRBs-ToBeSetupMod-ItemIEs >-----#
    MulticastMRBs_ToBeSetupMod_ItemIEs = CLASS(name='MulticastMRBs-ToBeSetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastMRBs_ToBeSetupMod_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMRBs-ToBeSetupMod-Item')))
    MulticastMRBs_ToBeSetupMod_ItemIEs._val = ASN1Set(rv=[dict([('id', 501), ('criticality', 'reject'), ('Value', _MulticastMRBs_ToBeSetupMod_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MulticastMRBs-ToBeModified-List >-----#
    MulticastMRBs_ToBeModified_List = SEQ_OF(name='MulticastMRBs-ToBeModified-List', mode=MODE_TYPE)
    _MulticastMRBs_ToBeModified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __MulticastMRBs_ToBeModified_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___MulticastMRBs_ToBeModified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____MulticastMRBs_ToBeModified_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMRBs-ToBeModified-Item')))
    ___MulticastMRBs_ToBeModified_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 495), ('criticality', 'reject'), ('Value', ____MulticastMRBs_ToBeModified_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __MulticastMRBs_ToBeModified_List__item__id._const_tab = ___MulticastMRBs_ToBeModified_List__item__id_tab
    __MulticastMRBs_ToBeModified_List__item__id._const_tab_at = None
    __MulticastMRBs_ToBeModified_List__item__id._const_tab_id = 'id'
    __MulticastMRBs_ToBeModified_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __MulticastMRBs_ToBeModified_List__item__criticality._const_tab = ___MulticastMRBs_ToBeModified_List__item__id_tab
    __MulticastMRBs_ToBeModified_List__item__criticality._const_tab_at = ('..', 'id')
    __MulticastMRBs_ToBeModified_List__item__criticality._const_tab_id = 'criticality'
    __MulticastMRBs_ToBeModified_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __MulticastMRBs_ToBeModified_List__item__value._const_tab = ___MulticastMRBs_ToBeModified_List__item__id_tab
    __MulticastMRBs_ToBeModified_List__item__value._const_tab_at = ('..', 'id')
    __MulticastMRBs_ToBeModified_List__item__value._const_tab_id = 'Value'
    _MulticastMRBs_ToBeModified_List__item_._cont = ASN1Dict([
        ('id', __MulticastMRBs_ToBeModified_List__item__id),
        ('criticality', __MulticastMRBs_ToBeModified_List__item__criticality),
        ('value', __MulticastMRBs_ToBeModified_List__item__value),
        ])
    _MulticastMRBs_ToBeModified_List__item_._ext = None
    MulticastMRBs_ToBeModified_List._cont = _MulticastMRBs_ToBeModified_List__item_
    MulticastMRBs_ToBeModified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MulticastMRBs-ToBeModified-ItemIEs >-----#
    MulticastMRBs_ToBeModified_ItemIEs = CLASS(name='MulticastMRBs-ToBeModified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastMRBs_ToBeModified_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMRBs-ToBeModified-Item')))
    MulticastMRBs_ToBeModified_ItemIEs._val = ASN1Set(rv=[dict([('id', 495), ('criticality', 'reject'), ('Value', _MulticastMRBs_ToBeModified_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MulticastMRBs-ToBeReleased-List >-----#
    MulticastMRBs_ToBeReleased_List = SEQ_OF(name='MulticastMRBs-ToBeReleased-List', mode=MODE_TYPE)
    _MulticastMRBs_ToBeReleased_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __MulticastMRBs_ToBeReleased_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___MulticastMRBs_ToBeReleased_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____MulticastMRBs_ToBeReleased_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMRBs-ToBeReleased-Item')))
    ___MulticastMRBs_ToBeReleased_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 497), ('criticality', 'reject'), ('Value', ____MulticastMRBs_ToBeReleased_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __MulticastMRBs_ToBeReleased_List__item__id._const_tab = ___MulticastMRBs_ToBeReleased_List__item__id_tab
    __MulticastMRBs_ToBeReleased_List__item__id._const_tab_at = None
    __MulticastMRBs_ToBeReleased_List__item__id._const_tab_id = 'id'
    __MulticastMRBs_ToBeReleased_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __MulticastMRBs_ToBeReleased_List__item__criticality._const_tab = ___MulticastMRBs_ToBeReleased_List__item__id_tab
    __MulticastMRBs_ToBeReleased_List__item__criticality._const_tab_at = ('..', 'id')
    __MulticastMRBs_ToBeReleased_List__item__criticality._const_tab_id = 'criticality'
    __MulticastMRBs_ToBeReleased_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __MulticastMRBs_ToBeReleased_List__item__value._const_tab = ___MulticastMRBs_ToBeReleased_List__item__id_tab
    __MulticastMRBs_ToBeReleased_List__item__value._const_tab_at = ('..', 'id')
    __MulticastMRBs_ToBeReleased_List__item__value._const_tab_id = 'Value'
    _MulticastMRBs_ToBeReleased_List__item_._cont = ASN1Dict([
        ('id', __MulticastMRBs_ToBeReleased_List__item__id),
        ('criticality', __MulticastMRBs_ToBeReleased_List__item__criticality),
        ('value', __MulticastMRBs_ToBeReleased_List__item__value),
        ])
    _MulticastMRBs_ToBeReleased_List__item_._ext = None
    MulticastMRBs_ToBeReleased_List._cont = _MulticastMRBs_ToBeReleased_List__item_
    MulticastMRBs_ToBeReleased_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MulticastMRBs-ToBeReleased-ItemIEs >-----#
    MulticastMRBs_ToBeReleased_ItemIEs = CLASS(name='MulticastMRBs-ToBeReleased-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastMRBs_ToBeReleased_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMRBs-ToBeReleased-Item')))
    MulticastMRBs_ToBeReleased_ItemIEs._val = ASN1Set(rv=[dict([('id', 497), ('criticality', 'reject'), ('Value', _MulticastMRBs_ToBeReleased_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MulticastContextModificationResponse >-----#
    MulticastContextModificationResponse = SEQ(name='MulticastContextModificationResponse', mode=MODE_TYPE)
    _MulticastContextModificationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __MulticastContextModificationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___MulticastContextModificationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____MulticastContextModificationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____MulticastContextModificationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _____MulticastContextModificationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _____MulticastContextModificationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastMRBs-SetupMod-List')))
    _____MulticastContextModificationResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastMRBs-FailedToBeSetupMod-List')))
    _____MulticastContextModificationResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastMRBs-Modified-List')))
    _____MulticastContextModificationResponse_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastMRBs-FailedToBeModified-List')))
    _____MulticastContextModificationResponse_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____MulticastContextModificationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _____MulticastContextModificationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _____MulticastContextModificationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 492), ('criticality', 'reject'), ('Value', _____MulticastContextModificationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 486), ('criticality', 'ignore'), ('Value', _____MulticastContextModificationResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 488), ('criticality', 'reject'), ('Value', _____MulticastContextModificationResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 482), ('criticality', 'ignore'), ('Value', _____MulticastContextModificationResponse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____MulticastContextModificationResponse_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MulticastContextModificationResponse_protocolIEs__item__id._const_tab = ____MulticastContextModificationResponse_protocolIEs__item__id_tab
    ___MulticastContextModificationResponse_protocolIEs__item__id._const_tab_at = None
    ___MulticastContextModificationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___MulticastContextModificationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___MulticastContextModificationResponse_protocolIEs__item__criticality._const_tab = ____MulticastContextModificationResponse_protocolIEs__item__id_tab
    ___MulticastContextModificationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastContextModificationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MulticastContextModificationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___MulticastContextModificationResponse_protocolIEs__item__value._const_tab = ____MulticastContextModificationResponse_protocolIEs__item__id_tab
    ___MulticastContextModificationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MulticastContextModificationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __MulticastContextModificationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MulticastContextModificationResponse_protocolIEs__item__id),
        ('criticality', ___MulticastContextModificationResponse_protocolIEs__item__criticality),
        ('value', ___MulticastContextModificationResponse_protocolIEs__item__value),
        ])
    __MulticastContextModificationResponse_protocolIEs__item_._ext = None
    _MulticastContextModificationResponse_protocolIEs._cont = __MulticastContextModificationResponse_protocolIEs__item_
    _MulticastContextModificationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MulticastContextModificationResponse._cont = ASN1Dict([
        ('protocolIEs', _MulticastContextModificationResponse_protocolIEs),
        ])
    MulticastContextModificationResponse._ext = []
    
    #-----< MulticastContextModificationResponseIEs >-----#
    MulticastContextModificationResponseIEs = CLASS(name='MulticastContextModificationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastContextModificationResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _MulticastContextModificationResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _MulticastContextModificationResponseIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastMRBs-SetupMod-List')))
    _MulticastContextModificationResponseIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastMRBs-FailedToBeSetupMod-List')))
    _MulticastContextModificationResponseIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastMRBs-Modified-List')))
    _MulticastContextModificationResponseIEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastMRBs-FailedToBeModified-List')))
    _MulticastContextModificationResponseIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    MulticastContextModificationResponseIEs._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _MulticastContextModificationResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _MulticastContextModificationResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 492), ('criticality', 'reject'), ('Value', _MulticastContextModificationResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 486), ('criticality', 'ignore'), ('Value', _MulticastContextModificationResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 488), ('criticality', 'reject'), ('Value', _MulticastContextModificationResponseIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 482), ('criticality', 'ignore'), ('Value', _MulticastContextModificationResponseIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _MulticastContextModificationResponseIEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MulticastMRBs-SetupMod-List >-----#
    MulticastMRBs_SetupMod_List = SEQ_OF(name='MulticastMRBs-SetupMod-List', mode=MODE_TYPE)
    _MulticastMRBs_SetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __MulticastMRBs_SetupMod_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___MulticastMRBs_SetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____MulticastMRBs_SetupMod_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMRBs-SetupMod-Item')))
    ___MulticastMRBs_SetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 493), ('criticality', 'reject'), ('Value', ____MulticastMRBs_SetupMod_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __MulticastMRBs_SetupMod_List__item__id._const_tab = ___MulticastMRBs_SetupMod_List__item__id_tab
    __MulticastMRBs_SetupMod_List__item__id._const_tab_at = None
    __MulticastMRBs_SetupMod_List__item__id._const_tab_id = 'id'
    __MulticastMRBs_SetupMod_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __MulticastMRBs_SetupMod_List__item__criticality._const_tab = ___MulticastMRBs_SetupMod_List__item__id_tab
    __MulticastMRBs_SetupMod_List__item__criticality._const_tab_at = ('..', 'id')
    __MulticastMRBs_SetupMod_List__item__criticality._const_tab_id = 'criticality'
    __MulticastMRBs_SetupMod_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __MulticastMRBs_SetupMod_List__item__value._const_tab = ___MulticastMRBs_SetupMod_List__item__id_tab
    __MulticastMRBs_SetupMod_List__item__value._const_tab_at = ('..', 'id')
    __MulticastMRBs_SetupMod_List__item__value._const_tab_id = 'Value'
    _MulticastMRBs_SetupMod_List__item_._cont = ASN1Dict([
        ('id', __MulticastMRBs_SetupMod_List__item__id),
        ('criticality', __MulticastMRBs_SetupMod_List__item__criticality),
        ('value', __MulticastMRBs_SetupMod_List__item__value),
        ])
    _MulticastMRBs_SetupMod_List__item_._ext = None
    MulticastMRBs_SetupMod_List._cont = _MulticastMRBs_SetupMod_List__item_
    MulticastMRBs_SetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MulticastMRBs-SetupMod-ItemIEs >-----#
    MulticastMRBs_SetupMod_ItemIEs = CLASS(name='MulticastMRBs-SetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastMRBs_SetupMod_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMRBs-SetupMod-Item')))
    MulticastMRBs_SetupMod_ItemIEs._val = ASN1Set(rv=[dict([('id', 493), ('criticality', 'reject'), ('Value', _MulticastMRBs_SetupMod_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MulticastMRBs-FailedToBeSetupMod-List >-----#
    MulticastMRBs_FailedToBeSetupMod_List = SEQ_OF(name='MulticastMRBs-FailedToBeSetupMod-List', mode=MODE_TYPE)
    _MulticastMRBs_FailedToBeSetupMod_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __MulticastMRBs_FailedToBeSetupMod_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___MulticastMRBs_FailedToBeSetupMod_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____MulticastMRBs_FailedToBeSetupMod_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMRBs-FailedToBeSetupMod-Item')))
    ___MulticastMRBs_FailedToBeSetupMod_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 487), ('criticality', 'ignore'), ('Value', ____MulticastMRBs_FailedToBeSetupMod_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __MulticastMRBs_FailedToBeSetupMod_List__item__id._const_tab = ___MulticastMRBs_FailedToBeSetupMod_List__item__id_tab
    __MulticastMRBs_FailedToBeSetupMod_List__item__id._const_tab_at = None
    __MulticastMRBs_FailedToBeSetupMod_List__item__id._const_tab_id = 'id'
    __MulticastMRBs_FailedToBeSetupMod_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __MulticastMRBs_FailedToBeSetupMod_List__item__criticality._const_tab = ___MulticastMRBs_FailedToBeSetupMod_List__item__id_tab
    __MulticastMRBs_FailedToBeSetupMod_List__item__criticality._const_tab_at = ('..', 'id')
    __MulticastMRBs_FailedToBeSetupMod_List__item__criticality._const_tab_id = 'criticality'
    __MulticastMRBs_FailedToBeSetupMod_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __MulticastMRBs_FailedToBeSetupMod_List__item__value._const_tab = ___MulticastMRBs_FailedToBeSetupMod_List__item__id_tab
    __MulticastMRBs_FailedToBeSetupMod_List__item__value._const_tab_at = ('..', 'id')
    __MulticastMRBs_FailedToBeSetupMod_List__item__value._const_tab_id = 'Value'
    _MulticastMRBs_FailedToBeSetupMod_List__item_._cont = ASN1Dict([
        ('id', __MulticastMRBs_FailedToBeSetupMod_List__item__id),
        ('criticality', __MulticastMRBs_FailedToBeSetupMod_List__item__criticality),
        ('value', __MulticastMRBs_FailedToBeSetupMod_List__item__value),
        ])
    _MulticastMRBs_FailedToBeSetupMod_List__item_._ext = None
    MulticastMRBs_FailedToBeSetupMod_List._cont = _MulticastMRBs_FailedToBeSetupMod_List__item_
    MulticastMRBs_FailedToBeSetupMod_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MulticastMRBs-FailedToBeSetupMod-ItemIEs >-----#
    MulticastMRBs_FailedToBeSetupMod_ItemIEs = CLASS(name='MulticastMRBs-FailedToBeSetupMod-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastMRBs_FailedToBeSetupMod_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMRBs-FailedToBeSetupMod-Item')))
    MulticastMRBs_FailedToBeSetupMod_ItemIEs._val = ASN1Set(rv=[dict([('id', 487), ('criticality', 'ignore'), ('Value', _MulticastMRBs_FailedToBeSetupMod_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MulticastMRBs-Modified-List >-----#
    MulticastMRBs_Modified_List = SEQ_OF(name='MulticastMRBs-Modified-List', mode=MODE_TYPE)
    _MulticastMRBs_Modified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __MulticastMRBs_Modified_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___MulticastMRBs_Modified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____MulticastMRBs_Modified_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMRBs-Modified-Item')))
    ___MulticastMRBs_Modified_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 489), ('criticality', 'reject'), ('Value', ____MulticastMRBs_Modified_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __MulticastMRBs_Modified_List__item__id._const_tab = ___MulticastMRBs_Modified_List__item__id_tab
    __MulticastMRBs_Modified_List__item__id._const_tab_at = None
    __MulticastMRBs_Modified_List__item__id._const_tab_id = 'id'
    __MulticastMRBs_Modified_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __MulticastMRBs_Modified_List__item__criticality._const_tab = ___MulticastMRBs_Modified_List__item__id_tab
    __MulticastMRBs_Modified_List__item__criticality._const_tab_at = ('..', 'id')
    __MulticastMRBs_Modified_List__item__criticality._const_tab_id = 'criticality'
    __MulticastMRBs_Modified_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __MulticastMRBs_Modified_List__item__value._const_tab = ___MulticastMRBs_Modified_List__item__id_tab
    __MulticastMRBs_Modified_List__item__value._const_tab_at = ('..', 'id')
    __MulticastMRBs_Modified_List__item__value._const_tab_id = 'Value'
    _MulticastMRBs_Modified_List__item_._cont = ASN1Dict([
        ('id', __MulticastMRBs_Modified_List__item__id),
        ('criticality', __MulticastMRBs_Modified_List__item__criticality),
        ('value', __MulticastMRBs_Modified_List__item__value),
        ])
    _MulticastMRBs_Modified_List__item_._ext = None
    MulticastMRBs_Modified_List._cont = _MulticastMRBs_Modified_List__item_
    MulticastMRBs_Modified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MulticastMRBs-Modified-ItemIEs >-----#
    MulticastMRBs_Modified_ItemIEs = CLASS(name='MulticastMRBs-Modified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastMRBs_Modified_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMRBs-Modified-Item')))
    MulticastMRBs_Modified_ItemIEs._val = ASN1Set(rv=[dict([('id', 489), ('criticality', 'reject'), ('Value', _MulticastMRBs_Modified_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MulticastMRBs-FailedToBeModified-List >-----#
    MulticastMRBs_FailedToBeModified_List = SEQ_OF(name='MulticastMRBs-FailedToBeModified-List', mode=MODE_TYPE)
    _MulticastMRBs_FailedToBeModified_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __MulticastMRBs_FailedToBeModified_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___MulticastMRBs_FailedToBeModified_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____MulticastMRBs_FailedToBeModified_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMRBs-FailedToBeModified-Item')))
    ___MulticastMRBs_FailedToBeModified_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 483), ('criticality', 'ignore'), ('Value', ____MulticastMRBs_FailedToBeModified_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __MulticastMRBs_FailedToBeModified_List__item__id._const_tab = ___MulticastMRBs_FailedToBeModified_List__item__id_tab
    __MulticastMRBs_FailedToBeModified_List__item__id._const_tab_at = None
    __MulticastMRBs_FailedToBeModified_List__item__id._const_tab_id = 'id'
    __MulticastMRBs_FailedToBeModified_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __MulticastMRBs_FailedToBeModified_List__item__criticality._const_tab = ___MulticastMRBs_FailedToBeModified_List__item__id_tab
    __MulticastMRBs_FailedToBeModified_List__item__criticality._const_tab_at = ('..', 'id')
    __MulticastMRBs_FailedToBeModified_List__item__criticality._const_tab_id = 'criticality'
    __MulticastMRBs_FailedToBeModified_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __MulticastMRBs_FailedToBeModified_List__item__value._const_tab = ___MulticastMRBs_FailedToBeModified_List__item__id_tab
    __MulticastMRBs_FailedToBeModified_List__item__value._const_tab_at = ('..', 'id')
    __MulticastMRBs_FailedToBeModified_List__item__value._const_tab_id = 'Value'
    _MulticastMRBs_FailedToBeModified_List__item_._cont = ASN1Dict([
        ('id', __MulticastMRBs_FailedToBeModified_List__item__id),
        ('criticality', __MulticastMRBs_FailedToBeModified_List__item__criticality),
        ('value', __MulticastMRBs_FailedToBeModified_List__item__value),
        ])
    _MulticastMRBs_FailedToBeModified_List__item_._ext = None
    MulticastMRBs_FailedToBeModified_List._cont = _MulticastMRBs_FailedToBeModified_List__item_
    MulticastMRBs_FailedToBeModified_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MulticastMRBs-FailedToBeModified-ItemIEs >-----#
    MulticastMRBs_FailedToBeModified_ItemIEs = CLASS(name='MulticastMRBs-FailedToBeModified-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastMRBs_FailedToBeModified_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastMRBs-FailedToBeModified-Item')))
    MulticastMRBs_FailedToBeModified_ItemIEs._val = ASN1Set(rv=[dict([('id', 483), ('criticality', 'ignore'), ('Value', _MulticastMRBs_FailedToBeModified_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MulticastContextModificationFailure >-----#
    MulticastContextModificationFailure = SEQ(name='MulticastContextModificationFailure', mode=MODE_TYPE)
    _MulticastContextModificationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __MulticastContextModificationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___MulticastContextModificationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____MulticastContextModificationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____MulticastContextModificationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _____MulticastContextModificationFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _____MulticastContextModificationFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____MulticastContextModificationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____MulticastContextModificationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _____MulticastContextModificationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _____MulticastContextModificationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____MulticastContextModificationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____MulticastContextModificationFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MulticastContextModificationFailure_protocolIEs__item__id._const_tab = ____MulticastContextModificationFailure_protocolIEs__item__id_tab
    ___MulticastContextModificationFailure_protocolIEs__item__id._const_tab_at = None
    ___MulticastContextModificationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___MulticastContextModificationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___MulticastContextModificationFailure_protocolIEs__item__criticality._const_tab = ____MulticastContextModificationFailure_protocolIEs__item__id_tab
    ___MulticastContextModificationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastContextModificationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MulticastContextModificationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___MulticastContextModificationFailure_protocolIEs__item__value._const_tab = ____MulticastContextModificationFailure_protocolIEs__item__id_tab
    ___MulticastContextModificationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MulticastContextModificationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __MulticastContextModificationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MulticastContextModificationFailure_protocolIEs__item__id),
        ('criticality', ___MulticastContextModificationFailure_protocolIEs__item__criticality),
        ('value', ___MulticastContextModificationFailure_protocolIEs__item__value),
        ])
    __MulticastContextModificationFailure_protocolIEs__item_._ext = None
    _MulticastContextModificationFailure_protocolIEs._cont = __MulticastContextModificationFailure_protocolIEs__item_
    _MulticastContextModificationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MulticastContextModificationFailure._cont = ASN1Dict([
        ('protocolIEs', _MulticastContextModificationFailure_protocolIEs),
        ])
    MulticastContextModificationFailure._ext = []
    
    #-----< MulticastContextModificationFailureIEs >-----#
    MulticastContextModificationFailureIEs = CLASS(name='MulticastContextModificationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastContextModificationFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _MulticastContextModificationFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _MulticastContextModificationFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _MulticastContextModificationFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    MulticastContextModificationFailureIEs._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _MulticastContextModificationFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _MulticastContextModificationFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _MulticastContextModificationFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _MulticastContextModificationFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MulticastDistributionSetupRequest >-----#
    MulticastDistributionSetupRequest = SEQ(name='MulticastDistributionSetupRequest', mode=MODE_TYPE)
    _MulticastDistributionSetupRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __MulticastDistributionSetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___MulticastDistributionSetupRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____MulticastDistributionSetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____MulticastDistributionSetupRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _____MulticastDistributionSetupRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _____MulticastDistributionSetupRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBSMulticastF1UContextDescriptor')))
    _____MulticastDistributionSetupRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastF1UContext-ToBeSetup-List')))
    ____MulticastDistributionSetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _____MulticastDistributionSetupRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _____MulticastDistributionSetupRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 502), ('criticality', 'reject'), ('Value', _____MulticastDistributionSetupRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 503), ('criticality', 'reject'), ('Value', _____MulticastDistributionSetupRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MulticastDistributionSetupRequest_protocolIEs__item__id._const_tab = ____MulticastDistributionSetupRequest_protocolIEs__item__id_tab
    ___MulticastDistributionSetupRequest_protocolIEs__item__id._const_tab_at = None
    ___MulticastDistributionSetupRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___MulticastDistributionSetupRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___MulticastDistributionSetupRequest_protocolIEs__item__criticality._const_tab = ____MulticastDistributionSetupRequest_protocolIEs__item__id_tab
    ___MulticastDistributionSetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastDistributionSetupRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MulticastDistributionSetupRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___MulticastDistributionSetupRequest_protocolIEs__item__value._const_tab = ____MulticastDistributionSetupRequest_protocolIEs__item__id_tab
    ___MulticastDistributionSetupRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MulticastDistributionSetupRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __MulticastDistributionSetupRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MulticastDistributionSetupRequest_protocolIEs__item__id),
        ('criticality', ___MulticastDistributionSetupRequest_protocolIEs__item__criticality),
        ('value', ___MulticastDistributionSetupRequest_protocolIEs__item__value),
        ])
    __MulticastDistributionSetupRequest_protocolIEs__item_._ext = None
    _MulticastDistributionSetupRequest_protocolIEs._cont = __MulticastDistributionSetupRequest_protocolIEs__item_
    _MulticastDistributionSetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MulticastDistributionSetupRequest._cont = ASN1Dict([
        ('protocolIEs', _MulticastDistributionSetupRequest_protocolIEs),
        ])
    MulticastDistributionSetupRequest._ext = []
    
    #-----< MulticastDistributionSetupRequestIEs >-----#
    MulticastDistributionSetupRequestIEs = CLASS(name='MulticastDistributionSetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastDistributionSetupRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _MulticastDistributionSetupRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _MulticastDistributionSetupRequestIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBSMulticastF1UContextDescriptor')))
    _MulticastDistributionSetupRequestIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastF1UContext-ToBeSetup-List')))
    MulticastDistributionSetupRequestIEs._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _MulticastDistributionSetupRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _MulticastDistributionSetupRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 502), ('criticality', 'reject'), ('Value', _MulticastDistributionSetupRequestIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 503), ('criticality', 'reject'), ('Value', _MulticastDistributionSetupRequestIEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MulticastF1UContext-ToBeSetup-List >-----#
    MulticastF1UContext_ToBeSetup_List = SEQ_OF(name='MulticastF1UContext-ToBeSetup-List', mode=MODE_TYPE)
    _MulticastF1UContext_ToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __MulticastF1UContext_ToBeSetup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___MulticastF1UContext_ToBeSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____MulticastF1UContext_ToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastF1UContext-ToBeSetup-Item')))
    ___MulticastF1UContext_ToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 504), ('criticality', 'reject'), ('Value', ____MulticastF1UContext_ToBeSetup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __MulticastF1UContext_ToBeSetup_List__item__id._const_tab = ___MulticastF1UContext_ToBeSetup_List__item__id_tab
    __MulticastF1UContext_ToBeSetup_List__item__id._const_tab_at = None
    __MulticastF1UContext_ToBeSetup_List__item__id._const_tab_id = 'id'
    __MulticastF1UContext_ToBeSetup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __MulticastF1UContext_ToBeSetup_List__item__criticality._const_tab = ___MulticastF1UContext_ToBeSetup_List__item__id_tab
    __MulticastF1UContext_ToBeSetup_List__item__criticality._const_tab_at = ('..', 'id')
    __MulticastF1UContext_ToBeSetup_List__item__criticality._const_tab_id = 'criticality'
    __MulticastF1UContext_ToBeSetup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __MulticastF1UContext_ToBeSetup_List__item__value._const_tab = ___MulticastF1UContext_ToBeSetup_List__item__id_tab
    __MulticastF1UContext_ToBeSetup_List__item__value._const_tab_at = ('..', 'id')
    __MulticastF1UContext_ToBeSetup_List__item__value._const_tab_id = 'Value'
    _MulticastF1UContext_ToBeSetup_List__item_._cont = ASN1Dict([
        ('id', __MulticastF1UContext_ToBeSetup_List__item__id),
        ('criticality', __MulticastF1UContext_ToBeSetup_List__item__criticality),
        ('value', __MulticastF1UContext_ToBeSetup_List__item__value),
        ])
    _MulticastF1UContext_ToBeSetup_List__item_._ext = None
    MulticastF1UContext_ToBeSetup_List._cont = _MulticastF1UContext_ToBeSetup_List__item_
    MulticastF1UContext_ToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MulticastF1UContext-ToBeSetup-ItemIEs >-----#
    MulticastF1UContext_ToBeSetup_ItemIEs = CLASS(name='MulticastF1UContext-ToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastF1UContext_ToBeSetup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastF1UContext-ToBeSetup-Item')))
    MulticastF1UContext_ToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([('id', 504), ('criticality', 'reject'), ('Value', _MulticastF1UContext_ToBeSetup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MulticastDistributionSetupResponse >-----#
    MulticastDistributionSetupResponse = SEQ(name='MulticastDistributionSetupResponse', mode=MODE_TYPE)
    _MulticastDistributionSetupResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __MulticastDistributionSetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___MulticastDistributionSetupResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____MulticastDistributionSetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____MulticastDistributionSetupResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _____MulticastDistributionSetupResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _____MulticastDistributionSetupResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBSMulticastF1UContextDescriptor')))
    _____MulticastDistributionSetupResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastF1UContext-Setup-List')))
    _____MulticastDistributionSetupResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastF1UContext-FailedToBeSetup-List')))
    _____MulticastDistributionSetupResponse_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _____MulticastDistributionSetupResponse_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastF1UContextReferenceCU')))
    ____MulticastDistributionSetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _____MulticastDistributionSetupResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _____MulticastDistributionSetupResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 502), ('criticality', 'reject'), ('Value', _____MulticastDistributionSetupResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 505), ('criticality', 'reject'), ('Value', _____MulticastDistributionSetupResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 507), ('criticality', 'ignore'), ('Value', _____MulticastDistributionSetupResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____MulticastDistributionSetupResponse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 681), ('criticality', 'reject'), ('Value', _____MulticastDistributionSetupResponse_protocolIEs__item__id_tab_val_Value_6), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MulticastDistributionSetupResponse_protocolIEs__item__id._const_tab = ____MulticastDistributionSetupResponse_protocolIEs__item__id_tab
    ___MulticastDistributionSetupResponse_protocolIEs__item__id._const_tab_at = None
    ___MulticastDistributionSetupResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___MulticastDistributionSetupResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___MulticastDistributionSetupResponse_protocolIEs__item__criticality._const_tab = ____MulticastDistributionSetupResponse_protocolIEs__item__id_tab
    ___MulticastDistributionSetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastDistributionSetupResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MulticastDistributionSetupResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___MulticastDistributionSetupResponse_protocolIEs__item__value._const_tab = ____MulticastDistributionSetupResponse_protocolIEs__item__id_tab
    ___MulticastDistributionSetupResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MulticastDistributionSetupResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __MulticastDistributionSetupResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MulticastDistributionSetupResponse_protocolIEs__item__id),
        ('criticality', ___MulticastDistributionSetupResponse_protocolIEs__item__criticality),
        ('value', ___MulticastDistributionSetupResponse_protocolIEs__item__value),
        ])
    __MulticastDistributionSetupResponse_protocolIEs__item_._ext = None
    _MulticastDistributionSetupResponse_protocolIEs._cont = __MulticastDistributionSetupResponse_protocolIEs__item_
    _MulticastDistributionSetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MulticastDistributionSetupResponse._cont = ASN1Dict([
        ('protocolIEs', _MulticastDistributionSetupResponse_protocolIEs),
        ])
    MulticastDistributionSetupResponse._ext = []
    
    #-----< MulticastDistributionSetupResponseIEs >-----#
    MulticastDistributionSetupResponseIEs = CLASS(name='MulticastDistributionSetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastDistributionSetupResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _MulticastDistributionSetupResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _MulticastDistributionSetupResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBSMulticastF1UContextDescriptor')))
    _MulticastDistributionSetupResponseIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastF1UContext-Setup-List')))
    _MulticastDistributionSetupResponseIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastF1UContext-FailedToBeSetup-List')))
    _MulticastDistributionSetupResponseIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    _MulticastDistributionSetupResponseIEs_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastF1UContextReferenceCU')))
    MulticastDistributionSetupResponseIEs._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _MulticastDistributionSetupResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _MulticastDistributionSetupResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 502), ('criticality', 'reject'), ('Value', _MulticastDistributionSetupResponseIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 505), ('criticality', 'reject'), ('Value', _MulticastDistributionSetupResponseIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 507), ('criticality', 'ignore'), ('Value', _MulticastDistributionSetupResponseIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _MulticastDistributionSetupResponseIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 681), ('criticality', 'reject'), ('Value', _MulticastDistributionSetupResponseIEs_val_Value_6), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MulticastF1UContext-Setup-List >-----#
    MulticastF1UContext_Setup_List = SEQ_OF(name='MulticastF1UContext-Setup-List', mode=MODE_TYPE)
    _MulticastF1UContext_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __MulticastF1UContext_Setup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___MulticastF1UContext_Setup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____MulticastF1UContext_Setup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastF1UContext-Setup-Item')))
    ___MulticastF1UContext_Setup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 506), ('criticality', 'reject'), ('Value', ____MulticastF1UContext_Setup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __MulticastF1UContext_Setup_List__item__id._const_tab = ___MulticastF1UContext_Setup_List__item__id_tab
    __MulticastF1UContext_Setup_List__item__id._const_tab_at = None
    __MulticastF1UContext_Setup_List__item__id._const_tab_id = 'id'
    __MulticastF1UContext_Setup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __MulticastF1UContext_Setup_List__item__criticality._const_tab = ___MulticastF1UContext_Setup_List__item__id_tab
    __MulticastF1UContext_Setup_List__item__criticality._const_tab_at = ('..', 'id')
    __MulticastF1UContext_Setup_List__item__criticality._const_tab_id = 'criticality'
    __MulticastF1UContext_Setup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __MulticastF1UContext_Setup_List__item__value._const_tab = ___MulticastF1UContext_Setup_List__item__id_tab
    __MulticastF1UContext_Setup_List__item__value._const_tab_at = ('..', 'id')
    __MulticastF1UContext_Setup_List__item__value._const_tab_id = 'Value'
    _MulticastF1UContext_Setup_List__item_._cont = ASN1Dict([
        ('id', __MulticastF1UContext_Setup_List__item__id),
        ('criticality', __MulticastF1UContext_Setup_List__item__criticality),
        ('value', __MulticastF1UContext_Setup_List__item__value),
        ])
    _MulticastF1UContext_Setup_List__item_._ext = None
    MulticastF1UContext_Setup_List._cont = _MulticastF1UContext_Setup_List__item_
    MulticastF1UContext_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MulticastF1UContext-Setup-ItemIEs >-----#
    MulticastF1UContext_Setup_ItemIEs = CLASS(name='MulticastF1UContext-Setup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastF1UContext_Setup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastF1UContext-Setup-Item')))
    MulticastF1UContext_Setup_ItemIEs._val = ASN1Set(rv=[dict([('id', 506), ('criticality', 'reject'), ('Value', _MulticastF1UContext_Setup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MulticastF1UContext-FailedToBeSetup-List >-----#
    MulticastF1UContext_FailedToBeSetup_List = SEQ_OF(name='MulticastF1UContext-FailedToBeSetup-List', mode=MODE_TYPE)
    _MulticastF1UContext_FailedToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __MulticastF1UContext_FailedToBeSetup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___MulticastF1UContext_FailedToBeSetup_List__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ____MulticastF1UContext_FailedToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastF1UContext-FailedToBeSetup-Item')))
    ___MulticastF1UContext_FailedToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 508), ('criticality', 'ignore'), ('Value', ____MulticastF1UContext_FailedToBeSetup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __MulticastF1UContext_FailedToBeSetup_List__item__id._const_tab = ___MulticastF1UContext_FailedToBeSetup_List__item__id_tab
    __MulticastF1UContext_FailedToBeSetup_List__item__id._const_tab_at = None
    __MulticastF1UContext_FailedToBeSetup_List__item__id._const_tab_id = 'id'
    __MulticastF1UContext_FailedToBeSetup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    __MulticastF1UContext_FailedToBeSetup_List__item__criticality._const_tab = ___MulticastF1UContext_FailedToBeSetup_List__item__id_tab
    __MulticastF1UContext_FailedToBeSetup_List__item__criticality._const_tab_at = ('..', 'id')
    __MulticastF1UContext_FailedToBeSetup_List__item__criticality._const_tab_id = 'criticality'
    __MulticastF1UContext_FailedToBeSetup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    __MulticastF1UContext_FailedToBeSetup_List__item__value._const_tab = ___MulticastF1UContext_FailedToBeSetup_List__item__id_tab
    __MulticastF1UContext_FailedToBeSetup_List__item__value._const_tab_at = ('..', 'id')
    __MulticastF1UContext_FailedToBeSetup_List__item__value._const_tab_id = 'Value'
    _MulticastF1UContext_FailedToBeSetup_List__item_._cont = ASN1Dict([
        ('id', __MulticastF1UContext_FailedToBeSetup_List__item__id),
        ('criticality', __MulticastF1UContext_FailedToBeSetup_List__item__criticality),
        ('value', __MulticastF1UContext_FailedToBeSetup_List__item__value),
        ])
    _MulticastF1UContext_FailedToBeSetup_List__item_._ext = None
    MulticastF1UContext_FailedToBeSetup_List._cont = _MulticastF1UContext_FailedToBeSetup_List__item_
    MulticastF1UContext_FailedToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MulticastF1UContext-FailedToBeSetup-ItemIEs >-----#
    MulticastF1UContext_FailedToBeSetup_ItemIEs = CLASS(name='MulticastF1UContext-FailedToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastF1UContext_FailedToBeSetup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MulticastF1UContext-FailedToBeSetup-Item')))
    MulticastF1UContext_FailedToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([('id', 508), ('criticality', 'ignore'), ('Value', _MulticastF1UContext_FailedToBeSetup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MulticastDistributionSetupFailure >-----#
    MulticastDistributionSetupFailure = SEQ(name='MulticastDistributionSetupFailure', mode=MODE_TYPE)
    _MulticastDistributionSetupFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __MulticastDistributionSetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___MulticastDistributionSetupFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____MulticastDistributionSetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____MulticastDistributionSetupFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _____MulticastDistributionSetupFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _____MulticastDistributionSetupFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBSMulticastF1UContextDescriptor')))
    _____MulticastDistributionSetupFailure_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____MulticastDistributionSetupFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____MulticastDistributionSetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _____MulticastDistributionSetupFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'ignore'), ('Value', _____MulticastDistributionSetupFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 502), ('criticality', 'reject'), ('Value', _____MulticastDistributionSetupFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____MulticastDistributionSetupFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____MulticastDistributionSetupFailure_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MulticastDistributionSetupFailure_protocolIEs__item__id._const_tab = ____MulticastDistributionSetupFailure_protocolIEs__item__id_tab
    ___MulticastDistributionSetupFailure_protocolIEs__item__id._const_tab_at = None
    ___MulticastDistributionSetupFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___MulticastDistributionSetupFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___MulticastDistributionSetupFailure_protocolIEs__item__criticality._const_tab = ____MulticastDistributionSetupFailure_protocolIEs__item__id_tab
    ___MulticastDistributionSetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastDistributionSetupFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MulticastDistributionSetupFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___MulticastDistributionSetupFailure_protocolIEs__item__value._const_tab = ____MulticastDistributionSetupFailure_protocolIEs__item__id_tab
    ___MulticastDistributionSetupFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MulticastDistributionSetupFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __MulticastDistributionSetupFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MulticastDistributionSetupFailure_protocolIEs__item__id),
        ('criticality', ___MulticastDistributionSetupFailure_protocolIEs__item__criticality),
        ('value', ___MulticastDistributionSetupFailure_protocolIEs__item__value),
        ])
    __MulticastDistributionSetupFailure_protocolIEs__item_._ext = None
    _MulticastDistributionSetupFailure_protocolIEs._cont = __MulticastDistributionSetupFailure_protocolIEs__item_
    _MulticastDistributionSetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MulticastDistributionSetupFailure._cont = ASN1Dict([
        ('protocolIEs', _MulticastDistributionSetupFailure_protocolIEs),
        ])
    MulticastDistributionSetupFailure._ext = []
    
    #-----< MulticastDistributionSetupFailureIEs >-----#
    MulticastDistributionSetupFailureIEs = CLASS(name='MulticastDistributionSetupFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastDistributionSetupFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _MulticastDistributionSetupFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _MulticastDistributionSetupFailureIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBSMulticastF1UContextDescriptor')))
    _MulticastDistributionSetupFailureIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _MulticastDistributionSetupFailureIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    MulticastDistributionSetupFailureIEs._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _MulticastDistributionSetupFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'ignore'), ('Value', _MulticastDistributionSetupFailureIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 502), ('criticality', 'reject'), ('Value', _MulticastDistributionSetupFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _MulticastDistributionSetupFailureIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _MulticastDistributionSetupFailureIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MulticastDistributionReleaseCommand >-----#
    MulticastDistributionReleaseCommand = SEQ(name='MulticastDistributionReleaseCommand', mode=MODE_TYPE)
    _MulticastDistributionReleaseCommand_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __MulticastDistributionReleaseCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___MulticastDistributionReleaseCommand_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____MulticastDistributionReleaseCommand_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____MulticastDistributionReleaseCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _____MulticastDistributionReleaseCommand_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _____MulticastDistributionReleaseCommand_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBSMulticastF1UContextDescriptor')))
    _____MulticastDistributionReleaseCommand_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    ____MulticastDistributionReleaseCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _____MulticastDistributionReleaseCommand_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _____MulticastDistributionReleaseCommand_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 502), ('criticality', 'reject'), ('Value', _____MulticastDistributionReleaseCommand_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____MulticastDistributionReleaseCommand_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MulticastDistributionReleaseCommand_protocolIEs__item__id._const_tab = ____MulticastDistributionReleaseCommand_protocolIEs__item__id_tab
    ___MulticastDistributionReleaseCommand_protocolIEs__item__id._const_tab_at = None
    ___MulticastDistributionReleaseCommand_protocolIEs__item__id._const_tab_id = 'id'
    ___MulticastDistributionReleaseCommand_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___MulticastDistributionReleaseCommand_protocolIEs__item__criticality._const_tab = ____MulticastDistributionReleaseCommand_protocolIEs__item__id_tab
    ___MulticastDistributionReleaseCommand_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastDistributionReleaseCommand_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MulticastDistributionReleaseCommand_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___MulticastDistributionReleaseCommand_protocolIEs__item__value._const_tab = ____MulticastDistributionReleaseCommand_protocolIEs__item__id_tab
    ___MulticastDistributionReleaseCommand_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MulticastDistributionReleaseCommand_protocolIEs__item__value._const_tab_id = 'Value'
    __MulticastDistributionReleaseCommand_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MulticastDistributionReleaseCommand_protocolIEs__item__id),
        ('criticality', ___MulticastDistributionReleaseCommand_protocolIEs__item__criticality),
        ('value', ___MulticastDistributionReleaseCommand_protocolIEs__item__value),
        ])
    __MulticastDistributionReleaseCommand_protocolIEs__item_._ext = None
    _MulticastDistributionReleaseCommand_protocolIEs._cont = __MulticastDistributionReleaseCommand_protocolIEs__item_
    _MulticastDistributionReleaseCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MulticastDistributionReleaseCommand._cont = ASN1Dict([
        ('protocolIEs', _MulticastDistributionReleaseCommand_protocolIEs),
        ])
    MulticastDistributionReleaseCommand._ext = []
    
    #-----< MulticastDistributionReleaseCommandIEs >-----#
    MulticastDistributionReleaseCommandIEs = CLASS(name='MulticastDistributionReleaseCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastDistributionReleaseCommandIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _MulticastDistributionReleaseCommandIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _MulticastDistributionReleaseCommandIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBSMulticastF1UContextDescriptor')))
    _MulticastDistributionReleaseCommandIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    MulticastDistributionReleaseCommandIEs._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _MulticastDistributionReleaseCommandIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _MulticastDistributionReleaseCommandIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 502), ('criticality', 'reject'), ('Value', _MulticastDistributionReleaseCommandIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _MulticastDistributionReleaseCommandIEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MulticastDistributionReleaseComplete >-----#
    MulticastDistributionReleaseComplete = SEQ(name='MulticastDistributionReleaseComplete', mode=MODE_TYPE)
    _MulticastDistributionReleaseComplete_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __MulticastDistributionReleaseComplete_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___MulticastDistributionReleaseComplete_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____MulticastDistributionReleaseComplete_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____MulticastDistributionReleaseComplete_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _____MulticastDistributionReleaseComplete_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _____MulticastDistributionReleaseComplete_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBSMulticastF1UContextDescriptor')))
    _____MulticastDistributionReleaseComplete_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____MulticastDistributionReleaseComplete_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _____MulticastDistributionReleaseComplete_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _____MulticastDistributionReleaseComplete_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 502), ('criticality', 'reject'), ('Value', _____MulticastDistributionReleaseComplete_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____MulticastDistributionReleaseComplete_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MulticastDistributionReleaseComplete_protocolIEs__item__id._const_tab = ____MulticastDistributionReleaseComplete_protocolIEs__item__id_tab
    ___MulticastDistributionReleaseComplete_protocolIEs__item__id._const_tab_at = None
    ___MulticastDistributionReleaseComplete_protocolIEs__item__id._const_tab_id = 'id'
    ___MulticastDistributionReleaseComplete_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___MulticastDistributionReleaseComplete_protocolIEs__item__criticality._const_tab = ____MulticastDistributionReleaseComplete_protocolIEs__item__id_tab
    ___MulticastDistributionReleaseComplete_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastDistributionReleaseComplete_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MulticastDistributionReleaseComplete_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___MulticastDistributionReleaseComplete_protocolIEs__item__value._const_tab = ____MulticastDistributionReleaseComplete_protocolIEs__item__id_tab
    ___MulticastDistributionReleaseComplete_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MulticastDistributionReleaseComplete_protocolIEs__item__value._const_tab_id = 'Value'
    __MulticastDistributionReleaseComplete_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MulticastDistributionReleaseComplete_protocolIEs__item__id),
        ('criticality', ___MulticastDistributionReleaseComplete_protocolIEs__item__criticality),
        ('value', ___MulticastDistributionReleaseComplete_protocolIEs__item__value),
        ])
    __MulticastDistributionReleaseComplete_protocolIEs__item_._ext = None
    _MulticastDistributionReleaseComplete_protocolIEs._cont = __MulticastDistributionReleaseComplete_protocolIEs__item_
    _MulticastDistributionReleaseComplete_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MulticastDistributionReleaseComplete._cont = ASN1Dict([
        ('protocolIEs', _MulticastDistributionReleaseComplete_protocolIEs),
        ])
    MulticastDistributionReleaseComplete._ext = []
    
    #-----< MulticastDistributionReleaseCompleteIEs >-----#
    MulticastDistributionReleaseCompleteIEs = CLASS(name='MulticastDistributionReleaseCompleteIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MulticastDistributionReleaseCompleteIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-MBS-F1AP-ID')))
    _MulticastDistributionReleaseCompleteIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-MBS-F1AP-ID')))
    _MulticastDistributionReleaseCompleteIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'MBSMulticastF1UContextDescriptor')))
    _MulticastDistributionReleaseCompleteIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    MulticastDistributionReleaseCompleteIEs._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Value', _MulticastDistributionReleaseCompleteIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 452), ('criticality', 'reject'), ('Value', _MulticastDistributionReleaseCompleteIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 502), ('criticality', 'reject'), ('Value', _MulticastDistributionReleaseCompleteIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _MulticastDistributionReleaseCompleteIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDCMeasurementInitiationRequest >-----#
    PDCMeasurementInitiationRequest = SEQ(name='PDCMeasurementInitiationRequest', mode=MODE_TYPE)
    _PDCMeasurementInitiationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PDCMeasurementInitiationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PDCMeasurementInitiationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PDCMeasurementInitiationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PDCMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____PDCMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____PDCMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-PDC-MeasID')))
    _____PDCMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCReportType')))
    _____PDCMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCMeasurementPeriodicity')))
    _____PDCMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCMeasurementQuantities')))
    ____PDCMeasurementInitiationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____PDCMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____PDCMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 546), ('criticality', 'reject'), ('Value', _____PDCMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 545), ('criticality', 'reject'), ('Value', _____PDCMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 541), ('criticality', 'reject'), ('Value', _____PDCMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'conditional')]), dict([('id', 542), ('criticality', 'reject'), ('Value', _____PDCMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___PDCMeasurementInitiationRequest_protocolIEs__item__id._const_tab = ____PDCMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___PDCMeasurementInitiationRequest_protocolIEs__item__id._const_tab_at = None
    ___PDCMeasurementInitiationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___PDCMeasurementInitiationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PDCMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab = ____PDCMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___PDCMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PDCMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PDCMeasurementInitiationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PDCMeasurementInitiationRequest_protocolIEs__item__value._const_tab = ____PDCMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___PDCMeasurementInitiationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PDCMeasurementInitiationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __PDCMeasurementInitiationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PDCMeasurementInitiationRequest_protocolIEs__item__id),
        ('criticality', ___PDCMeasurementInitiationRequest_protocolIEs__item__criticality),
        ('value', ___PDCMeasurementInitiationRequest_protocolIEs__item__value),
        ])
    __PDCMeasurementInitiationRequest_protocolIEs__item_._ext = None
    _PDCMeasurementInitiationRequest_protocolIEs._cont = __PDCMeasurementInitiationRequest_protocolIEs__item_
    _PDCMeasurementInitiationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDCMeasurementInitiationRequest._cont = ASN1Dict([
        ('protocolIEs', _PDCMeasurementInitiationRequest_protocolIEs),
        ])
    PDCMeasurementInitiationRequest._ext = []
    
    #-----< PDCMeasurementInitiationRequest-IEs >-----#
    PDCMeasurementInitiationRequest_IEs = CLASS(name='PDCMeasurementInitiationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PDCMeasurementInitiationRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _PDCMeasurementInitiationRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _PDCMeasurementInitiationRequest_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-PDC-MeasID')))
    _PDCMeasurementInitiationRequest_IEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCReportType')))
    _PDCMeasurementInitiationRequest_IEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCMeasurementPeriodicity')))
    _PDCMeasurementInitiationRequest_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCMeasurementQuantities')))
    PDCMeasurementInitiationRequest_IEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _PDCMeasurementInitiationRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _PDCMeasurementInitiationRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 546), ('criticality', 'reject'), ('Value', _PDCMeasurementInitiationRequest_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 545), ('criticality', 'reject'), ('Value', _PDCMeasurementInitiationRequest_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 541), ('criticality', 'reject'), ('Value', _PDCMeasurementInitiationRequest_IEs_val_Value_4), ('presence', 'conditional')]), dict([('id', 542), ('criticality', 'reject'), ('Value', _PDCMeasurementInitiationRequest_IEs_val_Value_5), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PDCMeasurementInitiationResponse >-----#
    PDCMeasurementInitiationResponse = SEQ(name='PDCMeasurementInitiationResponse', mode=MODE_TYPE)
    _PDCMeasurementInitiationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PDCMeasurementInitiationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PDCMeasurementInitiationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PDCMeasurementInitiationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PDCMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____PDCMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____PDCMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-PDC-MeasID')))
    _____PDCMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCMeasurementResult')))
    _____PDCMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____PDCMeasurementInitiationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____PDCMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____PDCMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 546), ('criticality', 'reject'), ('Value', _____PDCMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 544), ('criticality', 'ignore'), ('Value', _____PDCMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____PDCMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDCMeasurementInitiationResponse_protocolIEs__item__id._const_tab = ____PDCMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___PDCMeasurementInitiationResponse_protocolIEs__item__id._const_tab_at = None
    ___PDCMeasurementInitiationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___PDCMeasurementInitiationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PDCMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab = ____PDCMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___PDCMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PDCMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PDCMeasurementInitiationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PDCMeasurementInitiationResponse_protocolIEs__item__value._const_tab = ____PDCMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___PDCMeasurementInitiationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PDCMeasurementInitiationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __PDCMeasurementInitiationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PDCMeasurementInitiationResponse_protocolIEs__item__id),
        ('criticality', ___PDCMeasurementInitiationResponse_protocolIEs__item__criticality),
        ('value', ___PDCMeasurementInitiationResponse_protocolIEs__item__value),
        ])
    __PDCMeasurementInitiationResponse_protocolIEs__item_._ext = None
    _PDCMeasurementInitiationResponse_protocolIEs._cont = __PDCMeasurementInitiationResponse_protocolIEs__item_
    _PDCMeasurementInitiationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDCMeasurementInitiationResponse._cont = ASN1Dict([
        ('protocolIEs', _PDCMeasurementInitiationResponse_protocolIEs),
        ])
    PDCMeasurementInitiationResponse._ext = []
    
    #-----< PDCMeasurementInitiationResponse-IEs >-----#
    PDCMeasurementInitiationResponse_IEs = CLASS(name='PDCMeasurementInitiationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PDCMeasurementInitiationResponse_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _PDCMeasurementInitiationResponse_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _PDCMeasurementInitiationResponse_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-PDC-MeasID')))
    _PDCMeasurementInitiationResponse_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCMeasurementResult')))
    _PDCMeasurementInitiationResponse_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    PDCMeasurementInitiationResponse_IEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _PDCMeasurementInitiationResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _PDCMeasurementInitiationResponse_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 546), ('criticality', 'reject'), ('Value', _PDCMeasurementInitiationResponse_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 544), ('criticality', 'ignore'), ('Value', _PDCMeasurementInitiationResponse_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _PDCMeasurementInitiationResponse_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDCMeasurementInitiationFailure >-----#
    PDCMeasurementInitiationFailure = SEQ(name='PDCMeasurementInitiationFailure', mode=MODE_TYPE)
    _PDCMeasurementInitiationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PDCMeasurementInitiationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PDCMeasurementInitiationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PDCMeasurementInitiationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PDCMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____PDCMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____PDCMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-PDC-MeasID')))
    _____PDCMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____PDCMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____PDCMeasurementInitiationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____PDCMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____PDCMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 546), ('criticality', 'ignore'), ('Value', _____PDCMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____PDCMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____PDCMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDCMeasurementInitiationFailure_protocolIEs__item__id._const_tab = ____PDCMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___PDCMeasurementInitiationFailure_protocolIEs__item__id._const_tab_at = None
    ___PDCMeasurementInitiationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___PDCMeasurementInitiationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PDCMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab = ____PDCMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___PDCMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PDCMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PDCMeasurementInitiationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PDCMeasurementInitiationFailure_protocolIEs__item__value._const_tab = ____PDCMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___PDCMeasurementInitiationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PDCMeasurementInitiationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __PDCMeasurementInitiationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PDCMeasurementInitiationFailure_protocolIEs__item__id),
        ('criticality', ___PDCMeasurementInitiationFailure_protocolIEs__item__criticality),
        ('value', ___PDCMeasurementInitiationFailure_protocolIEs__item__value),
        ])
    __PDCMeasurementInitiationFailure_protocolIEs__item_._ext = None
    _PDCMeasurementInitiationFailure_protocolIEs._cont = __PDCMeasurementInitiationFailure_protocolIEs__item_
    _PDCMeasurementInitiationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDCMeasurementInitiationFailure._cont = ASN1Dict([
        ('protocolIEs', _PDCMeasurementInitiationFailure_protocolIEs),
        ])
    PDCMeasurementInitiationFailure._ext = []
    
    #-----< PDCMeasurementInitiationFailure-IEs >-----#
    PDCMeasurementInitiationFailure_IEs = CLASS(name='PDCMeasurementInitiationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PDCMeasurementInitiationFailure_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _PDCMeasurementInitiationFailure_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _PDCMeasurementInitiationFailure_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-PDC-MeasID')))
    _PDCMeasurementInitiationFailure_IEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _PDCMeasurementInitiationFailure_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    PDCMeasurementInitiationFailure_IEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _PDCMeasurementInitiationFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _PDCMeasurementInitiationFailure_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 546), ('criticality', 'ignore'), ('Value', _PDCMeasurementInitiationFailure_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _PDCMeasurementInitiationFailure_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _PDCMeasurementInitiationFailure_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDCMeasurementReport >-----#
    PDCMeasurementReport = SEQ(name='PDCMeasurementReport', mode=MODE_TYPE)
    _PDCMeasurementReport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PDCMeasurementReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PDCMeasurementReport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PDCMeasurementReport_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PDCMeasurementReport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____PDCMeasurementReport_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____PDCMeasurementReport_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-PDC-MeasID')))
    _____PDCMeasurementReport_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCMeasurementResult')))
    ____PDCMeasurementReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____PDCMeasurementReport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____PDCMeasurementReport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 546), ('criticality', 'reject'), ('Value', _____PDCMeasurementReport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 544), ('criticality', 'ignore'), ('Value', _____PDCMeasurementReport_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___PDCMeasurementReport_protocolIEs__item__id._const_tab = ____PDCMeasurementReport_protocolIEs__item__id_tab
    ___PDCMeasurementReport_protocolIEs__item__id._const_tab_at = None
    ___PDCMeasurementReport_protocolIEs__item__id._const_tab_id = 'id'
    ___PDCMeasurementReport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PDCMeasurementReport_protocolIEs__item__criticality._const_tab = ____PDCMeasurementReport_protocolIEs__item__id_tab
    ___PDCMeasurementReport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PDCMeasurementReport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PDCMeasurementReport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PDCMeasurementReport_protocolIEs__item__value._const_tab = ____PDCMeasurementReport_protocolIEs__item__id_tab
    ___PDCMeasurementReport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PDCMeasurementReport_protocolIEs__item__value._const_tab_id = 'Value'
    __PDCMeasurementReport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PDCMeasurementReport_protocolIEs__item__id),
        ('criticality', ___PDCMeasurementReport_protocolIEs__item__criticality),
        ('value', ___PDCMeasurementReport_protocolIEs__item__value),
        ])
    __PDCMeasurementReport_protocolIEs__item_._ext = None
    _PDCMeasurementReport_protocolIEs._cont = __PDCMeasurementReport_protocolIEs__item_
    _PDCMeasurementReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDCMeasurementReport._cont = ASN1Dict([
        ('protocolIEs', _PDCMeasurementReport_protocolIEs),
        ])
    PDCMeasurementReport._ext = []
    
    #-----< PDCMeasurementReport-IEs >-----#
    PDCMeasurementReport_IEs = CLASS(name='PDCMeasurementReport-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PDCMeasurementReport_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _PDCMeasurementReport_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _PDCMeasurementReport_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-PDC-MeasID')))
    _PDCMeasurementReport_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PDCMeasurementResult')))
    PDCMeasurementReport_IEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _PDCMeasurementReport_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _PDCMeasurementReport_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 546), ('criticality', 'reject'), ('Value', _PDCMeasurementReport_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 544), ('criticality', 'ignore'), ('Value', _PDCMeasurementReport_IEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PDCMeasurementTerminationCommand >-----#
    PDCMeasurementTerminationCommand = SEQ(name='PDCMeasurementTerminationCommand', mode=MODE_TYPE)
    _PDCMeasurementTerminationCommand_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PDCMeasurementTerminationCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PDCMeasurementTerminationCommand_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PDCMeasurementTerminationCommand_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PDCMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____PDCMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____PDCMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-PDC-MeasID')))
    ____PDCMeasurementTerminationCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____PDCMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____PDCMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 546), ('criticality', 'ignore'), ('Value', _____PDCMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___PDCMeasurementTerminationCommand_protocolIEs__item__id._const_tab = ____PDCMeasurementTerminationCommand_protocolIEs__item__id_tab
    ___PDCMeasurementTerminationCommand_protocolIEs__item__id._const_tab_at = None
    ___PDCMeasurementTerminationCommand_protocolIEs__item__id._const_tab_id = 'id'
    ___PDCMeasurementTerminationCommand_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PDCMeasurementTerminationCommand_protocolIEs__item__criticality._const_tab = ____PDCMeasurementTerminationCommand_protocolIEs__item__id_tab
    ___PDCMeasurementTerminationCommand_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PDCMeasurementTerminationCommand_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PDCMeasurementTerminationCommand_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PDCMeasurementTerminationCommand_protocolIEs__item__value._const_tab = ____PDCMeasurementTerminationCommand_protocolIEs__item__id_tab
    ___PDCMeasurementTerminationCommand_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PDCMeasurementTerminationCommand_protocolIEs__item__value._const_tab_id = 'Value'
    __PDCMeasurementTerminationCommand_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PDCMeasurementTerminationCommand_protocolIEs__item__id),
        ('criticality', ___PDCMeasurementTerminationCommand_protocolIEs__item__criticality),
        ('value', ___PDCMeasurementTerminationCommand_protocolIEs__item__value),
        ])
    __PDCMeasurementTerminationCommand_protocolIEs__item_._ext = None
    _PDCMeasurementTerminationCommand_protocolIEs._cont = __PDCMeasurementTerminationCommand_protocolIEs__item_
    _PDCMeasurementTerminationCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDCMeasurementTerminationCommand._cont = ASN1Dict([
        ('protocolIEs', _PDCMeasurementTerminationCommand_protocolIEs),
        ])
    PDCMeasurementTerminationCommand._ext = []
    
    #-----< PDCMeasurementTerminationCommand-IEs >-----#
    PDCMeasurementTerminationCommand_IEs = CLASS(name='PDCMeasurementTerminationCommand-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PDCMeasurementTerminationCommand_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _PDCMeasurementTerminationCommand_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _PDCMeasurementTerminationCommand_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-PDC-MeasID')))
    PDCMeasurementTerminationCommand_IEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _PDCMeasurementTerminationCommand_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _PDCMeasurementTerminationCommand_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 546), ('criticality', 'ignore'), ('Value', _PDCMeasurementTerminationCommand_IEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PDCMeasurementFailureIndication >-----#
    PDCMeasurementFailureIndication = SEQ(name='PDCMeasurementFailureIndication', mode=MODE_TYPE)
    _PDCMeasurementFailureIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PDCMeasurementFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PDCMeasurementFailureIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PDCMeasurementFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PDCMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____PDCMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____PDCMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-PDC-MeasID')))
    _____PDCMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    ____PDCMeasurementFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____PDCMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____PDCMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 546), ('criticality', 'ignore'), ('Value', _____PDCMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____PDCMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___PDCMeasurementFailureIndication_protocolIEs__item__id._const_tab = ____PDCMeasurementFailureIndication_protocolIEs__item__id_tab
    ___PDCMeasurementFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___PDCMeasurementFailureIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___PDCMeasurementFailureIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PDCMeasurementFailureIndication_protocolIEs__item__criticality._const_tab = ____PDCMeasurementFailureIndication_protocolIEs__item__id_tab
    ___PDCMeasurementFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PDCMeasurementFailureIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PDCMeasurementFailureIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PDCMeasurementFailureIndication_protocolIEs__item__value._const_tab = ____PDCMeasurementFailureIndication_protocolIEs__item__id_tab
    ___PDCMeasurementFailureIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PDCMeasurementFailureIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __PDCMeasurementFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PDCMeasurementFailureIndication_protocolIEs__item__id),
        ('criticality', ___PDCMeasurementFailureIndication_protocolIEs__item__criticality),
        ('value', ___PDCMeasurementFailureIndication_protocolIEs__item__value),
        ])
    __PDCMeasurementFailureIndication_protocolIEs__item_._ext = None
    _PDCMeasurementFailureIndication_protocolIEs._cont = __PDCMeasurementFailureIndication_protocolIEs__item_
    _PDCMeasurementFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDCMeasurementFailureIndication._cont = ASN1Dict([
        ('protocolIEs', _PDCMeasurementFailureIndication_protocolIEs),
        ])
    PDCMeasurementFailureIndication._ext = []
    
    #-----< PDCMeasurementFailureIndication-IEs >-----#
    PDCMeasurementFailureIndication_IEs = CLASS(name='PDCMeasurementFailureIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PDCMeasurementFailureIndication_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _PDCMeasurementFailureIndication_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _PDCMeasurementFailureIndication_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'RAN-UE-PDC-MeasID')))
    _PDCMeasurementFailureIndication_IEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    PDCMeasurementFailureIndication_IEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _PDCMeasurementFailureIndication_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _PDCMeasurementFailureIndication_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 546), ('criticality', 'ignore'), ('Value', _PDCMeasurementFailureIndication_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _PDCMeasurementFailureIndication_IEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PRSConfigurationRequest >-----#
    PRSConfigurationRequest = SEQ(name='PRSConfigurationRequest', mode=MODE_TYPE)
    _PRSConfigurationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PRSConfigurationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PRSConfigurationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PRSConfigurationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PRSConfigurationRequest_protocolIEs__item__id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PRSConfigRequestType')))
    _____PRSConfigurationRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PRSTRPList')))
    ____PRSConfigurationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 571), ('criticality', 'reject'), ('Value', _____PRSConfigurationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 549), ('criticality', 'ignore'), ('Value', _____PRSConfigurationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___PRSConfigurationRequest_protocolIEs__item__id._const_tab = ____PRSConfigurationRequest_protocolIEs__item__id_tab
    ___PRSConfigurationRequest_protocolIEs__item__id._const_tab_at = None
    ___PRSConfigurationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___PRSConfigurationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PRSConfigurationRequest_protocolIEs__item__criticality._const_tab = ____PRSConfigurationRequest_protocolIEs__item__id_tab
    ___PRSConfigurationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PRSConfigurationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PRSConfigurationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PRSConfigurationRequest_protocolIEs__item__value._const_tab = ____PRSConfigurationRequest_protocolIEs__item__id_tab
    ___PRSConfigurationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PRSConfigurationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __PRSConfigurationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PRSConfigurationRequest_protocolIEs__item__id),
        ('criticality', ___PRSConfigurationRequest_protocolIEs__item__criticality),
        ('value', ___PRSConfigurationRequest_protocolIEs__item__value),
        ])
    __PRSConfigurationRequest_protocolIEs__item_._ext = None
    _PRSConfigurationRequest_protocolIEs._cont = __PRSConfigurationRequest_protocolIEs__item_
    _PRSConfigurationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PRSConfigurationRequest._cont = ASN1Dict([
        ('protocolIEs', _PRSConfigurationRequest_protocolIEs),
        ])
    PRSConfigurationRequest._ext = []
    
    #-----< PRSConfigurationRequest-IEs >-----#
    PRSConfigurationRequest_IEs = CLASS(name='PRSConfigurationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PRSConfigurationRequest_IEs_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PRSConfigRequestType')))
    _PRSConfigurationRequest_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PRSTRPList')))
    PRSConfigurationRequest_IEs._val = ASN1Set(rv=[dict([('id', 571), ('criticality', 'reject'), ('Value', _PRSConfigurationRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 549), ('criticality', 'ignore'), ('Value', _PRSConfigurationRequest_IEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PRSConfigurationResponse >-----#
    PRSConfigurationResponse = SEQ(name='PRSConfigurationResponse', mode=MODE_TYPE)
    _PRSConfigurationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PRSConfigurationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PRSConfigurationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PRSConfigurationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PRSConfigurationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PRSConfigurationResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PRSTransmissionTRPList')))
    _____PRSConfigurationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____PRSConfigurationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____PRSConfigurationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 550), ('criticality', 'ignore'), ('Value', _____PRSConfigurationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____PRSConfigurationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PRSConfigurationResponse_protocolIEs__item__id._const_tab = ____PRSConfigurationResponse_protocolIEs__item__id_tab
    ___PRSConfigurationResponse_protocolIEs__item__id._const_tab_at = None
    ___PRSConfigurationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___PRSConfigurationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PRSConfigurationResponse_protocolIEs__item__criticality._const_tab = ____PRSConfigurationResponse_protocolIEs__item__id_tab
    ___PRSConfigurationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PRSConfigurationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PRSConfigurationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PRSConfigurationResponse_protocolIEs__item__value._const_tab = ____PRSConfigurationResponse_protocolIEs__item__id_tab
    ___PRSConfigurationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PRSConfigurationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __PRSConfigurationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PRSConfigurationResponse_protocolIEs__item__id),
        ('criticality', ___PRSConfigurationResponse_protocolIEs__item__criticality),
        ('value', ___PRSConfigurationResponse_protocolIEs__item__value),
        ])
    __PRSConfigurationResponse_protocolIEs__item_._ext = None
    _PRSConfigurationResponse_protocolIEs._cont = __PRSConfigurationResponse_protocolIEs__item_
    _PRSConfigurationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PRSConfigurationResponse._cont = ASN1Dict([
        ('protocolIEs', _PRSConfigurationResponse_protocolIEs),
        ])
    PRSConfigurationResponse._ext = []
    
    #-----< PRSConfigurationResponse-IEs >-----#
    PRSConfigurationResponse_IEs = CLASS(name='PRSConfigurationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PRSConfigurationResponse_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PRSConfigurationResponse_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PRSTransmissionTRPList')))
    _PRSConfigurationResponse_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    PRSConfigurationResponse_IEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _PRSConfigurationResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 550), ('criticality', 'ignore'), ('Value', _PRSConfigurationResponse_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _PRSConfigurationResponse_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PRSConfigurationFailure >-----#
    PRSConfigurationFailure = SEQ(name='PRSConfigurationFailure', mode=MODE_TYPE)
    _PRSConfigurationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PRSConfigurationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PRSConfigurationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PRSConfigurationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PRSConfigurationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PRSConfigurationFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____PRSConfigurationFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____PRSConfigurationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____PRSConfigurationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____PRSConfigurationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____PRSConfigurationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PRSConfigurationFailure_protocolIEs__item__id._const_tab = ____PRSConfigurationFailure_protocolIEs__item__id_tab
    ___PRSConfigurationFailure_protocolIEs__item__id._const_tab_at = None
    ___PRSConfigurationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___PRSConfigurationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PRSConfigurationFailure_protocolIEs__item__criticality._const_tab = ____PRSConfigurationFailure_protocolIEs__item__id_tab
    ___PRSConfigurationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PRSConfigurationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PRSConfigurationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PRSConfigurationFailure_protocolIEs__item__value._const_tab = ____PRSConfigurationFailure_protocolIEs__item__id_tab
    ___PRSConfigurationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PRSConfigurationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __PRSConfigurationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PRSConfigurationFailure_protocolIEs__item__id),
        ('criticality', ___PRSConfigurationFailure_protocolIEs__item__criticality),
        ('value', ___PRSConfigurationFailure_protocolIEs__item__value),
        ])
    __PRSConfigurationFailure_protocolIEs__item_._ext = None
    _PRSConfigurationFailure_protocolIEs._cont = __PRSConfigurationFailure_protocolIEs__item_
    _PRSConfigurationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PRSConfigurationFailure._cont = ASN1Dict([
        ('protocolIEs', _PRSConfigurationFailure_protocolIEs),
        ])
    PRSConfigurationFailure._ext = []
    
    #-----< PRSConfigurationFailure-IEs >-----#
    PRSConfigurationFailure_IEs = CLASS(name='PRSConfigurationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PRSConfigurationFailure_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PRSConfigurationFailure_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _PRSConfigurationFailure_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    PRSConfigurationFailure_IEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _PRSConfigurationFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _PRSConfigurationFailure_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _PRSConfigurationFailure_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MeasurementPreconfigurationRequired >-----#
    MeasurementPreconfigurationRequired = SEQ(name='MeasurementPreconfigurationRequired', mode=MODE_TYPE)
    _MeasurementPreconfigurationRequired_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __MeasurementPreconfigurationRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___MeasurementPreconfigurationRequired_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____MeasurementPreconfigurationRequired_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____MeasurementPreconfigurationRequired_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____MeasurementPreconfigurationRequired_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____MeasurementPreconfigurationRequired_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRP-PRS-Info-List')))
    ____MeasurementPreconfigurationRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____MeasurementPreconfigurationRequired_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____MeasurementPreconfigurationRequired_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 569), ('criticality', 'ignore'), ('Value', _____MeasurementPreconfigurationRequired_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MeasurementPreconfigurationRequired_protocolIEs__item__id._const_tab = ____MeasurementPreconfigurationRequired_protocolIEs__item__id_tab
    ___MeasurementPreconfigurationRequired_protocolIEs__item__id._const_tab_at = None
    ___MeasurementPreconfigurationRequired_protocolIEs__item__id._const_tab_id = 'id'
    ___MeasurementPreconfigurationRequired_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___MeasurementPreconfigurationRequired_protocolIEs__item__criticality._const_tab = ____MeasurementPreconfigurationRequired_protocolIEs__item__id_tab
    ___MeasurementPreconfigurationRequired_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MeasurementPreconfigurationRequired_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MeasurementPreconfigurationRequired_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___MeasurementPreconfigurationRequired_protocolIEs__item__value._const_tab = ____MeasurementPreconfigurationRequired_protocolIEs__item__id_tab
    ___MeasurementPreconfigurationRequired_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MeasurementPreconfigurationRequired_protocolIEs__item__value._const_tab_id = 'Value'
    __MeasurementPreconfigurationRequired_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MeasurementPreconfigurationRequired_protocolIEs__item__id),
        ('criticality', ___MeasurementPreconfigurationRequired_protocolIEs__item__criticality),
        ('value', ___MeasurementPreconfigurationRequired_protocolIEs__item__value),
        ])
    __MeasurementPreconfigurationRequired_protocolIEs__item_._ext = None
    _MeasurementPreconfigurationRequired_protocolIEs._cont = __MeasurementPreconfigurationRequired_protocolIEs__item_
    _MeasurementPreconfigurationRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MeasurementPreconfigurationRequired._cont = ASN1Dict([
        ('protocolIEs', _MeasurementPreconfigurationRequired_protocolIEs),
        ])
    MeasurementPreconfigurationRequired._ext = []
    
    #-----< MeasurementPreconfigurationRequired-IEs >-----#
    MeasurementPreconfigurationRequired_IEs = CLASS(name='MeasurementPreconfigurationRequired-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MeasurementPreconfigurationRequired_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _MeasurementPreconfigurationRequired_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _MeasurementPreconfigurationRequired_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TRP-PRS-Info-List')))
    MeasurementPreconfigurationRequired_IEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _MeasurementPreconfigurationRequired_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _MeasurementPreconfigurationRequired_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 569), ('criticality', 'ignore'), ('Value', _MeasurementPreconfigurationRequired_IEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MeasurementPreconfigurationConfirm >-----#
    MeasurementPreconfigurationConfirm = SEQ(name='MeasurementPreconfigurationConfirm', mode=MODE_TYPE)
    _MeasurementPreconfigurationConfirm_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __MeasurementPreconfigurationConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___MeasurementPreconfigurationConfirm_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosMeasGapPreConfigList')))
    _____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 650), ('criticality', 'ignore'), ('Value', _____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MeasurementPreconfigurationConfirm_protocolIEs__item__id._const_tab = ____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab
    ___MeasurementPreconfigurationConfirm_protocolIEs__item__id._const_tab_at = None
    ___MeasurementPreconfigurationConfirm_protocolIEs__item__id._const_tab_id = 'id'
    ___MeasurementPreconfigurationConfirm_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___MeasurementPreconfigurationConfirm_protocolIEs__item__criticality._const_tab = ____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab
    ___MeasurementPreconfigurationConfirm_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MeasurementPreconfigurationConfirm_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MeasurementPreconfigurationConfirm_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___MeasurementPreconfigurationConfirm_protocolIEs__item__value._const_tab = ____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab
    ___MeasurementPreconfigurationConfirm_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MeasurementPreconfigurationConfirm_protocolIEs__item__value._const_tab_id = 'Value'
    __MeasurementPreconfigurationConfirm_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MeasurementPreconfigurationConfirm_protocolIEs__item__id),
        ('criticality', ___MeasurementPreconfigurationConfirm_protocolIEs__item__criticality),
        ('value', ___MeasurementPreconfigurationConfirm_protocolIEs__item__value),
        ])
    __MeasurementPreconfigurationConfirm_protocolIEs__item_._ext = None
    _MeasurementPreconfigurationConfirm_protocolIEs._cont = __MeasurementPreconfigurationConfirm_protocolIEs__item_
    _MeasurementPreconfigurationConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MeasurementPreconfigurationConfirm._cont = ASN1Dict([
        ('protocolIEs', _MeasurementPreconfigurationConfirm_protocolIEs),
        ])
    MeasurementPreconfigurationConfirm._ext = []
    
    #-----< MeasurementPreconfigurationConfirm-IEs >-----#
    MeasurementPreconfigurationConfirm_IEs = CLASS(name='MeasurementPreconfigurationConfirm-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MeasurementPreconfigurationConfirm_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _MeasurementPreconfigurationConfirm_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _MeasurementPreconfigurationConfirm_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosMeasGapPreConfigList')))
    _MeasurementPreconfigurationConfirm_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    MeasurementPreconfigurationConfirm_IEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _MeasurementPreconfigurationConfirm_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _MeasurementPreconfigurationConfirm_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 650), ('criticality', 'ignore'), ('Value', _MeasurementPreconfigurationConfirm_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _MeasurementPreconfigurationConfirm_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MeasurementPreconfigurationRefuse >-----#
    MeasurementPreconfigurationRefuse = SEQ(name='MeasurementPreconfigurationRefuse', mode=MODE_TYPE)
    _MeasurementPreconfigurationRefuse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __MeasurementPreconfigurationRefuse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___MeasurementPreconfigurationRefuse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    ____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MeasurementPreconfigurationRefuse_protocolIEs__item__id._const_tab = ____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab
    ___MeasurementPreconfigurationRefuse_protocolIEs__item__id._const_tab_at = None
    ___MeasurementPreconfigurationRefuse_protocolIEs__item__id._const_tab_id = 'id'
    ___MeasurementPreconfigurationRefuse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___MeasurementPreconfigurationRefuse_protocolIEs__item__criticality._const_tab = ____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab
    ___MeasurementPreconfigurationRefuse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MeasurementPreconfigurationRefuse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MeasurementPreconfigurationRefuse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___MeasurementPreconfigurationRefuse_protocolIEs__item__value._const_tab = ____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab
    ___MeasurementPreconfigurationRefuse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MeasurementPreconfigurationRefuse_protocolIEs__item__value._const_tab_id = 'Value'
    __MeasurementPreconfigurationRefuse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MeasurementPreconfigurationRefuse_protocolIEs__item__id),
        ('criticality', ___MeasurementPreconfigurationRefuse_protocolIEs__item__criticality),
        ('value', ___MeasurementPreconfigurationRefuse_protocolIEs__item__value),
        ])
    __MeasurementPreconfigurationRefuse_protocolIEs__item_._ext = None
    _MeasurementPreconfigurationRefuse_protocolIEs._cont = __MeasurementPreconfigurationRefuse_protocolIEs__item_
    _MeasurementPreconfigurationRefuse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MeasurementPreconfigurationRefuse._cont = ASN1Dict([
        ('protocolIEs', _MeasurementPreconfigurationRefuse_protocolIEs),
        ])
    MeasurementPreconfigurationRefuse._ext = []
    
    #-----< MeasurementPreconfigurationRefuse-IEs >-----#
    MeasurementPreconfigurationRefuse_IEs = CLASS(name='MeasurementPreconfigurationRefuse-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MeasurementPreconfigurationRefuse_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _MeasurementPreconfigurationRefuse_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _MeasurementPreconfigurationRefuse_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'Cause')))
    _MeasurementPreconfigurationRefuse_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'CriticalityDiagnostics')))
    MeasurementPreconfigurationRefuse_IEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _MeasurementPreconfigurationRefuse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _MeasurementPreconfigurationRefuse_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _MeasurementPreconfigurationRefuse_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _MeasurementPreconfigurationRefuse_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MeasurementActivation >-----#
    MeasurementActivation = SEQ(name='MeasurementActivation', mode=MODE_TYPE)
    _MeasurementActivation_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __MeasurementActivation_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___MeasurementActivation_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____MeasurementActivation_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____MeasurementActivation_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____MeasurementActivation_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____MeasurementActivation_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ActivationRequestType')))
    _____MeasurementActivation_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PRS-Measurement-Info-List')))
    ____MeasurementActivation_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____MeasurementActivation_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____MeasurementActivation_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 649), ('criticality', 'reject'), ('Value', _____MeasurementActivation_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 570), ('criticality', 'ignore'), ('Value', _____MeasurementActivation_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MeasurementActivation_protocolIEs__item__id._const_tab = ____MeasurementActivation_protocolIEs__item__id_tab
    ___MeasurementActivation_protocolIEs__item__id._const_tab_at = None
    ___MeasurementActivation_protocolIEs__item__id._const_tab_id = 'id'
    ___MeasurementActivation_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___MeasurementActivation_protocolIEs__item__criticality._const_tab = ____MeasurementActivation_protocolIEs__item__id_tab
    ___MeasurementActivation_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MeasurementActivation_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MeasurementActivation_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___MeasurementActivation_protocolIEs__item__value._const_tab = ____MeasurementActivation_protocolIEs__item__id_tab
    ___MeasurementActivation_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MeasurementActivation_protocolIEs__item__value._const_tab_id = 'Value'
    __MeasurementActivation_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MeasurementActivation_protocolIEs__item__id),
        ('criticality', ___MeasurementActivation_protocolIEs__item__criticality),
        ('value', ___MeasurementActivation_protocolIEs__item__value),
        ])
    __MeasurementActivation_protocolIEs__item_._ext = None
    _MeasurementActivation_protocolIEs._cont = __MeasurementActivation_protocolIEs__item_
    _MeasurementActivation_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MeasurementActivation._cont = ASN1Dict([
        ('protocolIEs', _MeasurementActivation_protocolIEs),
        ])
    MeasurementActivation._ext = []
    
    #-----< MeasurementActivation-IEs >-----#
    MeasurementActivation_IEs = CLASS(name='MeasurementActivation-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _MeasurementActivation_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _MeasurementActivation_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _MeasurementActivation_IEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'ActivationRequestType')))
    _MeasurementActivation_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PRS-Measurement-Info-List')))
    MeasurementActivation_IEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _MeasurementActivation_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _MeasurementActivation_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 649), ('criticality', 'reject'), ('Value', _MeasurementActivation_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 570), ('criticality', 'ignore'), ('Value', _MeasurementActivation_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< QoEInformationTransfer >-----#
    QoEInformationTransfer = SEQ(name='QoEInformationTransfer', mode=MODE_TYPE)
    _QoEInformationTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __QoEInformationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___QoEInformationTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____QoEInformationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____QoEInformationTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _____QoEInformationTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _____QoEInformationTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QoEInformation')))
    ____QoEInformationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _____QoEInformationTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____QoEInformationTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 585), ('criticality', 'ignore'), ('Value', _____QoEInformationTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___QoEInformationTransfer_protocolIEs__item__id._const_tab = ____QoEInformationTransfer_protocolIEs__item__id_tab
    ___QoEInformationTransfer_protocolIEs__item__id._const_tab_at = None
    ___QoEInformationTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___QoEInformationTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___QoEInformationTransfer_protocolIEs__item__criticality._const_tab = ____QoEInformationTransfer_protocolIEs__item__id_tab
    ___QoEInformationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___QoEInformationTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___QoEInformationTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___QoEInformationTransfer_protocolIEs__item__value._const_tab = ____QoEInformationTransfer_protocolIEs__item__id_tab
    ___QoEInformationTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___QoEInformationTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __QoEInformationTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___QoEInformationTransfer_protocolIEs__item__id),
        ('criticality', ___QoEInformationTransfer_protocolIEs__item__criticality),
        ('value', ___QoEInformationTransfer_protocolIEs__item__value),
        ])
    __QoEInformationTransfer_protocolIEs__item_._ext = None
    _QoEInformationTransfer_protocolIEs._cont = __QoEInformationTransfer_protocolIEs__item_
    _QoEInformationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    QoEInformationTransfer._cont = ASN1Dict([
        ('protocolIEs', _QoEInformationTransfer_protocolIEs),
        ])
    QoEInformationTransfer._ext = []
    
    #-----< QoEInformationTransfer-IEs >-----#
    QoEInformationTransfer_IEs = CLASS(name='QoEInformationTransfer-IEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _QoEInformationTransfer_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-CU-UE-F1AP-ID')))
    _QoEInformationTransfer_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    _QoEInformationTransfer_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'QoEInformation')))
    QoEInformationTransfer_IEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'reject'), ('Value', _QoEInformationTransfer_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _QoEInformationTransfer_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 585), ('criticality', 'ignore'), ('Value', _QoEInformationTransfer_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PosSystemInformationDeliveryCommand >-----#
    PosSystemInformationDeliveryCommand = SEQ(name='PosSystemInformationDeliveryCommand', mode=MODE_TYPE)
    _PosSystemInformationDeliveryCommand_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Container')))
    __PosSystemInformationDeliveryCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-Field')))
    ___PosSystemInformationDeliveryCommand_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ____PosSystemInformationDeliveryCommand_protocolIEs__item__id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _____PosSystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _____PosSystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _____PosSystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosSItypeList')))
    _____PosSystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    ____PosSystemInformationDeliveryCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____PosSystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 111), ('criticality', 'reject'), ('Value', _____PosSystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 682), ('criticality', 'reject'), ('Value', _____PosSystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____PosSystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___PosSystemInformationDeliveryCommand_protocolIEs__item__id._const_tab = ____PosSystemInformationDeliveryCommand_protocolIEs__item__id_tab
    ___PosSystemInformationDeliveryCommand_protocolIEs__item__id._const_tab_at = None
    ___PosSystemInformationDeliveryCommand_protocolIEs__item__id._const_tab_id = 'id'
    ___PosSystemInformationDeliveryCommand_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___PosSystemInformationDeliveryCommand_protocolIEs__item__criticality._const_tab = ____PosSystemInformationDeliveryCommand_protocolIEs__item__id_tab
    ___PosSystemInformationDeliveryCommand_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PosSystemInformationDeliveryCommand_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PosSystemInformationDeliveryCommand_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___PosSystemInformationDeliveryCommand_protocolIEs__item__value._const_tab = ____PosSystemInformationDeliveryCommand_protocolIEs__item__id_tab
    ___PosSystemInformationDeliveryCommand_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PosSystemInformationDeliveryCommand_protocolIEs__item__value._const_tab_id = 'Value'
    __PosSystemInformationDeliveryCommand_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PosSystemInformationDeliveryCommand_protocolIEs__item__id),
        ('criticality', ___PosSystemInformationDeliveryCommand_protocolIEs__item__criticality),
        ('value', ___PosSystemInformationDeliveryCommand_protocolIEs__item__value),
        ])
    __PosSystemInformationDeliveryCommand_protocolIEs__item_._ext = None
    _PosSystemInformationDeliveryCommand_protocolIEs._cont = __PosSystemInformationDeliveryCommand_protocolIEs__item_
    _PosSystemInformationDeliveryCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PosSystemInformationDeliveryCommand._cont = ASN1Dict([
        ('protocolIEs', _PosSystemInformationDeliveryCommand_protocolIEs),
        ])
    PosSystemInformationDeliveryCommand._ext = []
    
    #-----< PosSystemInformationDeliveryCommandIEs >-----#
    PosSystemInformationDeliveryCommandIEs = CLASS(name='PosSystemInformationDeliveryCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    _PosSystemInformationDeliveryCommandIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'TransactionID')))
    _PosSystemInformationDeliveryCommandIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'NRCGI')))
    _PosSystemInformationDeliveryCommandIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'PosSItypeList')))
    _PosSystemInformationDeliveryCommandIEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-IEs', 'GNB-DU-UE-F1AP-ID')))
    PosSystemInformationDeliveryCommandIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _PosSystemInformationDeliveryCommandIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 111), ('criticality', 'reject'), ('Value', _PosSystemInformationDeliveryCommandIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 682), ('criticality', 'reject'), ('Value', _PosSystemInformationDeliveryCommandIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _PosSystemInformationDeliveryCommandIEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    _all_ = [
        ____Reset_protocolIEs__item__id_tab,
        _____Reset_protocolIEs__item__id_tab_val_Value_0,
        _____Reset_protocolIEs__item__id_tab_val_Value_1,
        _____Reset_protocolIEs__item__id_tab_val_Value_2,
        ___Reset_protocolIEs__item__id,
        ___Reset_protocolIEs__item__criticality,
        ___Reset_protocolIEs__item__value,
        __Reset_protocolIEs__item_,
        _Reset_protocolIEs,
        Reset,
        ResetIEs,
        _ResetIEs_val_Value_0,
        _ResetIEs_val_Value_1,
        _ResetIEs_val_Value_2,
        _ResetType_f1_Interface,
        _ResetType_partOfF1_Interface,
        ___ResetType_choice_extension_id_tab,
        __ResetType_choice_extension_id,
        ___ResetType_choice_extension_criticality_tab,
        __ResetType_choice_extension_criticality,
        ___ResetType_choice_extension_value_tab,
        __ResetType_choice_extension_value,
        _ResetType_choice_extension,
        ResetType,
        ResetType_ExtIEs,
        ResetAll,
        ___UE_associatedLogicalF1_ConnectionListRes__item__id_tab,
        ____UE_associatedLogicalF1_ConnectionListRes__item__id_tab_val_Value_0,
        __UE_associatedLogicalF1_ConnectionListRes__item__id,
        __UE_associatedLogicalF1_ConnectionListRes__item__criticality,
        __UE_associatedLogicalF1_ConnectionListRes__item__value,
        _UE_associatedLogicalF1_ConnectionListRes__item_,
        UE_associatedLogicalF1_ConnectionListRes,
        UE_associatedLogicalF1_ConnectionItemRes,
        _UE_associatedLogicalF1_ConnectionItemRes_val_Value_0,
        ____ResetAcknowledge_protocolIEs__item__id_tab,
        _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        ___ResetAcknowledge_protocolIEs__item__id,
        ___ResetAcknowledge_protocolIEs__item__criticality,
        ___ResetAcknowledge_protocolIEs__item__value,
        __ResetAcknowledge_protocolIEs__item_,
        _ResetAcknowledge_protocolIEs,
        ResetAcknowledge,
        ResetAcknowledgeIEs,
        _ResetAcknowledgeIEs_val_Value_0,
        _ResetAcknowledgeIEs_val_Value_1,
        _ResetAcknowledgeIEs_val_Value_2,
        ___UE_associatedLogicalF1_ConnectionListResAck__item__id_tab,
        ____UE_associatedLogicalF1_ConnectionListResAck__item__id_tab_val_Value_0,
        __UE_associatedLogicalF1_ConnectionListResAck__item__id,
        __UE_associatedLogicalF1_ConnectionListResAck__item__criticality,
        __UE_associatedLogicalF1_ConnectionListResAck__item__value,
        _UE_associatedLogicalF1_ConnectionListResAck__item_,
        UE_associatedLogicalF1_ConnectionListResAck,
        UE_associatedLogicalF1_ConnectionItemResAck,
        _UE_associatedLogicalF1_ConnectionItemResAck_val_Value_0,
        ____ErrorIndication_protocolIEs__item__id_tab,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4,
        ___ErrorIndication_protocolIEs__item__id,
        ___ErrorIndication_protocolIEs__item__criticality,
        ___ErrorIndication_protocolIEs__item__value,
        __ErrorIndication_protocolIEs__item_,
        _ErrorIndication_protocolIEs,
        ErrorIndication,
        ErrorIndicationIEs,
        _ErrorIndicationIEs_val_Value_0,
        _ErrorIndicationIEs_val_Value_1,
        _ErrorIndicationIEs_val_Value_2,
        _ErrorIndicationIEs_val_Value_3,
        _ErrorIndicationIEs_val_Value_4,
        ____F1SetupRequest_protocolIEs__item__id_tab,
        _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_2,
        _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_3,
        _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_4,
        _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_5,
        _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_6,
        _____F1SetupRequest_protocolIEs__item__id_tab_val_Value_7,
        ___F1SetupRequest_protocolIEs__item__id,
        ___F1SetupRequest_protocolIEs__item__criticality,
        ___F1SetupRequest_protocolIEs__item__value,
        __F1SetupRequest_protocolIEs__item_,
        _F1SetupRequest_protocolIEs,
        F1SetupRequest,
        F1SetupRequestIEs,
        _F1SetupRequestIEs_val_Value_0,
        _F1SetupRequestIEs_val_Value_1,
        _F1SetupRequestIEs_val_Value_2,
        _F1SetupRequestIEs_val_Value_3,
        _F1SetupRequestIEs_val_Value_4,
        _F1SetupRequestIEs_val_Value_5,
        _F1SetupRequestIEs_val_Value_6,
        _F1SetupRequestIEs_val_Value_7,
        ___GNB_DU_Served_Cells_List__item__id_tab,
        ____GNB_DU_Served_Cells_List__item__id_tab_val_Value_0,
        __GNB_DU_Served_Cells_List__item__id,
        __GNB_DU_Served_Cells_List__item__criticality,
        __GNB_DU_Served_Cells_List__item__value,
        _GNB_DU_Served_Cells_List__item_,
        GNB_DU_Served_Cells_List,
        GNB_DU_Served_Cells_ItemIEs,
        _GNB_DU_Served_Cells_ItemIEs_val_Value_0,
        ____F1SetupResponse_protocolIEs__item__id_tab,
        _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_3,
        _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_4,
        _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_5,
        _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_6,
        _____F1SetupResponse_protocolIEs__item__id_tab_val_Value_7,
        ___F1SetupResponse_protocolIEs__item__id,
        ___F1SetupResponse_protocolIEs__item__criticality,
        ___F1SetupResponse_protocolIEs__item__value,
        __F1SetupResponse_protocolIEs__item_,
        _F1SetupResponse_protocolIEs,
        F1SetupResponse,
        F1SetupResponseIEs,
        _F1SetupResponseIEs_val_Value_0,
        _F1SetupResponseIEs_val_Value_1,
        _F1SetupResponseIEs_val_Value_2,
        _F1SetupResponseIEs_val_Value_3,
        _F1SetupResponseIEs_val_Value_4,
        _F1SetupResponseIEs_val_Value_5,
        _F1SetupResponseIEs_val_Value_6,
        _F1SetupResponseIEs_val_Value_7,
        ___Cells_to_be_Activated_List__item__id_tab,
        ____Cells_to_be_Activated_List__item__id_tab_val_Value_0,
        __Cells_to_be_Activated_List__item__id,
        __Cells_to_be_Activated_List__item__criticality,
        __Cells_to_be_Activated_List__item__value,
        _Cells_to_be_Activated_List__item_,
        Cells_to_be_Activated_List,
        Cells_to_be_Activated_List_ItemIEs,
        _Cells_to_be_Activated_List_ItemIEs_val_Value_0,
        ____F1SetupFailure_protocolIEs__item__id_tab,
        _____F1SetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____F1SetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____F1SetupFailure_protocolIEs__item__id_tab_val_Value_2,
        _____F1SetupFailure_protocolIEs__item__id_tab_val_Value_3,
        ___F1SetupFailure_protocolIEs__item__id,
        ___F1SetupFailure_protocolIEs__item__criticality,
        ___F1SetupFailure_protocolIEs__item__value,
        __F1SetupFailure_protocolIEs__item_,
        _F1SetupFailure_protocolIEs,
        F1SetupFailure,
        F1SetupFailureIEs,
        _F1SetupFailureIEs_val_Value_0,
        _F1SetupFailureIEs_val_Value_1,
        _F1SetupFailureIEs_val_Value_2,
        _F1SetupFailureIEs_val_Value_3,
        ____GNBDUConfigurationUpdate_protocolIEs__item__id_tab,
        _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3,
        _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4,
        _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5,
        _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6,
        _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_7,
        _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_8,
        _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_9,
        _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_10,
        _____GNBDUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_11,
        ___GNBDUConfigurationUpdate_protocolIEs__item__id,
        ___GNBDUConfigurationUpdate_protocolIEs__item__criticality,
        ___GNBDUConfigurationUpdate_protocolIEs__item__value,
        __GNBDUConfigurationUpdate_protocolIEs__item_,
        _GNBDUConfigurationUpdate_protocolIEs,
        GNBDUConfigurationUpdate,
        GNBDUConfigurationUpdateIEs,
        _GNBDUConfigurationUpdateIEs_val_Value_0,
        _GNBDUConfigurationUpdateIEs_val_Value_1,
        _GNBDUConfigurationUpdateIEs_val_Value_2,
        _GNBDUConfigurationUpdateIEs_val_Value_3,
        _GNBDUConfigurationUpdateIEs_val_Value_4,
        _GNBDUConfigurationUpdateIEs_val_Value_5,
        _GNBDUConfigurationUpdateIEs_val_Value_6,
        _GNBDUConfigurationUpdateIEs_val_Value_7,
        _GNBDUConfigurationUpdateIEs_val_Value_8,
        _GNBDUConfigurationUpdateIEs_val_Value_9,
        _GNBDUConfigurationUpdateIEs_val_Value_10,
        _GNBDUConfigurationUpdateIEs_val_Value_11,
        ___Served_Cells_To_Add_List__item__id_tab,
        ____Served_Cells_To_Add_List__item__id_tab_val_Value_0,
        __Served_Cells_To_Add_List__item__id,
        __Served_Cells_To_Add_List__item__criticality,
        __Served_Cells_To_Add_List__item__value,
        _Served_Cells_To_Add_List__item_,
        Served_Cells_To_Add_List,
        ___Served_Cells_To_Modify_List__item__id_tab,
        ____Served_Cells_To_Modify_List__item__id_tab_val_Value_0,
        __Served_Cells_To_Modify_List__item__id,
        __Served_Cells_To_Modify_List__item__criticality,
        __Served_Cells_To_Modify_List__item__value,
        _Served_Cells_To_Modify_List__item_,
        Served_Cells_To_Modify_List,
        ___Served_Cells_To_Delete_List__item__id_tab,
        ____Served_Cells_To_Delete_List__item__id_tab_val_Value_0,
        __Served_Cells_To_Delete_List__item__id,
        __Served_Cells_To_Delete_List__item__criticality,
        __Served_Cells_To_Delete_List__item__value,
        _Served_Cells_To_Delete_List__item_,
        Served_Cells_To_Delete_List,
        ___Cells_Status_List__item__id_tab,
        ____Cells_Status_List__item__id_tab_val_Value_0,
        __Cells_Status_List__item__id,
        __Cells_Status_List__item__criticality,
        __Cells_Status_List__item__value,
        _Cells_Status_List__item_,
        Cells_Status_List,
        ___Dedicated_SIDelivery_NeededUE_List__item__id_tab,
        ____Dedicated_SIDelivery_NeededUE_List__item__id_tab_val_Value_0,
        __Dedicated_SIDelivery_NeededUE_List__item__id,
        __Dedicated_SIDelivery_NeededUE_List__item__criticality,
        __Dedicated_SIDelivery_NeededUE_List__item__value,
        _Dedicated_SIDelivery_NeededUE_List__item_,
        Dedicated_SIDelivery_NeededUE_List,
        ___GNB_DU_TNL_Association_To_Remove_List__item__id_tab,
        ____GNB_DU_TNL_Association_To_Remove_List__item__id_tab_val_Value_0,
        __GNB_DU_TNL_Association_To_Remove_List__item__id,
        __GNB_DU_TNL_Association_To_Remove_List__item__criticality,
        __GNB_DU_TNL_Association_To_Remove_List__item__value,
        _GNB_DU_TNL_Association_To_Remove_List__item_,
        GNB_DU_TNL_Association_To_Remove_List,
        Served_Cells_To_Add_ItemIEs,
        _Served_Cells_To_Add_ItemIEs_val_Value_0,
        Served_Cells_To_Modify_ItemIEs,
        _Served_Cells_To_Modify_ItemIEs_val_Value_0,
        Served_Cells_To_Delete_ItemIEs,
        _Served_Cells_To_Delete_ItemIEs_val_Value_0,
        Cells_Status_ItemIEs,
        _Cells_Status_ItemIEs_val_Value_0,
        Dedicated_SIDelivery_NeededUE_ItemIEs,
        _Dedicated_SIDelivery_NeededUE_ItemIEs_val_Value_0,
        GNB_DU_TNL_Association_To_Remove_ItemIEs,
        _GNB_DU_TNL_Association_To_Remove_ItemIEs_val_Value_0,
        ____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab,
        _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_6,
        _____GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_7,
        ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__id,
        ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__criticality,
        ___GNBDUConfigurationUpdateAcknowledge_protocolIEs__item__value,
        __GNBDUConfigurationUpdateAcknowledge_protocolIEs__item_,
        _GNBDUConfigurationUpdateAcknowledge_protocolIEs,
        GNBDUConfigurationUpdateAcknowledge,
        GNBDUConfigurationUpdateAcknowledgeIEs,
        _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_0,
        _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_1,
        _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_2,
        _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_3,
        _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_4,
        _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_5,
        _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_6,
        _GNBDUConfigurationUpdateAcknowledgeIEs_val_Value_7,
        ____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab,
        _____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        _____GNBDUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3,
        ___GNBDUConfigurationUpdateFailure_protocolIEs__item__id,
        ___GNBDUConfigurationUpdateFailure_protocolIEs__item__criticality,
        ___GNBDUConfigurationUpdateFailure_protocolIEs__item__value,
        __GNBDUConfigurationUpdateFailure_protocolIEs__item_,
        _GNBDUConfigurationUpdateFailure_protocolIEs,
        GNBDUConfigurationUpdateFailure,
        GNBDUConfigurationUpdateFailureIEs,
        _GNBDUConfigurationUpdateFailureIEs_val_Value_0,
        _GNBDUConfigurationUpdateFailureIEs_val_Value_1,
        _GNBDUConfigurationUpdateFailureIEs_val_Value_2,
        _GNBDUConfigurationUpdateFailureIEs_val_Value_3,
        ____GNBCUConfigurationUpdate_protocolIEs__item__id_tab,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_7,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_8,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_9,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_10,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_11,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_12,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_13,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_14,
        _____GNBCUConfigurationUpdate_protocolIEs__item__id_tab_val_Value_15,
        ___GNBCUConfigurationUpdate_protocolIEs__item__id,
        ___GNBCUConfigurationUpdate_protocolIEs__item__criticality,
        ___GNBCUConfigurationUpdate_protocolIEs__item__value,
        __GNBCUConfigurationUpdate_protocolIEs__item_,
        _GNBCUConfigurationUpdate_protocolIEs,
        GNBCUConfigurationUpdate,
        GNBCUConfigurationUpdateIEs,
        _GNBCUConfigurationUpdateIEs_val_Value_0,
        _GNBCUConfigurationUpdateIEs_val_Value_1,
        _GNBCUConfigurationUpdateIEs_val_Value_2,
        _GNBCUConfigurationUpdateIEs_val_Value_3,
        _GNBCUConfigurationUpdateIEs_val_Value_4,
        _GNBCUConfigurationUpdateIEs_val_Value_5,
        _GNBCUConfigurationUpdateIEs_val_Value_6,
        _GNBCUConfigurationUpdateIEs_val_Value_7,
        _GNBCUConfigurationUpdateIEs_val_Value_8,
        _GNBCUConfigurationUpdateIEs_val_Value_9,
        _GNBCUConfigurationUpdateIEs_val_Value_10,
        _GNBCUConfigurationUpdateIEs_val_Value_11,
        _GNBCUConfigurationUpdateIEs_val_Value_12,
        _GNBCUConfigurationUpdateIEs_val_Value_13,
        _GNBCUConfigurationUpdateIEs_val_Value_14,
        _GNBCUConfigurationUpdateIEs_val_Value_15,
        ___Cells_to_be_Deactivated_List__item__id_tab,
        ____Cells_to_be_Deactivated_List__item__id_tab_val_Value_0,
        __Cells_to_be_Deactivated_List__item__id,
        __Cells_to_be_Deactivated_List__item__criticality,
        __Cells_to_be_Deactivated_List__item__value,
        _Cells_to_be_Deactivated_List__item_,
        Cells_to_be_Deactivated_List,
        ___GNB_CU_TNL_Association_To_Add_List__item__id_tab,
        ____GNB_CU_TNL_Association_To_Add_List__item__id_tab_val_Value_0,
        __GNB_CU_TNL_Association_To_Add_List__item__id,
        __GNB_CU_TNL_Association_To_Add_List__item__criticality,
        __GNB_CU_TNL_Association_To_Add_List__item__value,
        _GNB_CU_TNL_Association_To_Add_List__item_,
        GNB_CU_TNL_Association_To_Add_List,
        ___GNB_CU_TNL_Association_To_Remove_List__item__id_tab,
        ____GNB_CU_TNL_Association_To_Remove_List__item__id_tab_val_Value_0,
        __GNB_CU_TNL_Association_To_Remove_List__item__id,
        __GNB_CU_TNL_Association_To_Remove_List__item__criticality,
        __GNB_CU_TNL_Association_To_Remove_List__item__value,
        _GNB_CU_TNL_Association_To_Remove_List__item_,
        GNB_CU_TNL_Association_To_Remove_List,
        ___GNB_CU_TNL_Association_To_Update_List__item__id_tab,
        ____GNB_CU_TNL_Association_To_Update_List__item__id_tab_val_Value_0,
        __GNB_CU_TNL_Association_To_Update_List__item__id,
        __GNB_CU_TNL_Association_To_Update_List__item__criticality,
        __GNB_CU_TNL_Association_To_Update_List__item__value,
        _GNB_CU_TNL_Association_To_Update_List__item_,
        GNB_CU_TNL_Association_To_Update_List,
        ___Cells_to_be_Barred_List__item__id_tab,
        ____Cells_to_be_Barred_List__item__id_tab_val_Value_0,
        __Cells_to_be_Barred_List__item__id,
        __Cells_to_be_Barred_List__item__criticality,
        __Cells_to_be_Barred_List__item__value,
        _Cells_to_be_Barred_List__item_,
        Cells_to_be_Barred_List,
        Cells_to_be_Deactivated_List_ItemIEs,
        _Cells_to_be_Deactivated_List_ItemIEs_val_Value_0,
        GNB_CU_TNL_Association_To_Add_ItemIEs,
        _GNB_CU_TNL_Association_To_Add_ItemIEs_val_Value_0,
        GNB_CU_TNL_Association_To_Remove_ItemIEs,
        _GNB_CU_TNL_Association_To_Remove_ItemIEs_val_Value_0,
        GNB_CU_TNL_Association_To_Update_ItemIEs,
        _GNB_CU_TNL_Association_To_Update_ItemIEs_val_Value_0,
        Cells_to_be_Barred_ItemIEs,
        _Cells_to_be_Barred_ItemIEs_val_Value_0,
        ___Protected_EUTRA_Resources_List__item__id_tab,
        ____Protected_EUTRA_Resources_List__item__id_tab_val_Value_0,
        __Protected_EUTRA_Resources_List__item__id,
        __Protected_EUTRA_Resources_List__item__criticality,
        __Protected_EUTRA_Resources_List__item__value,
        _Protected_EUTRA_Resources_List__item_,
        Protected_EUTRA_Resources_List,
        Protected_EUTRA_Resources_ItemIEs,
        _Protected_EUTRA_Resources_ItemIEs_val_Value_0,
        ___Neighbour_Cell_Information_List__item__id_tab,
        ____Neighbour_Cell_Information_List__item__id_tab_val_Value_0,
        __Neighbour_Cell_Information_List__item__id,
        __Neighbour_Cell_Information_List__item__criticality,
        __Neighbour_Cell_Information_List__item__value,
        _Neighbour_Cell_Information_List__item_,
        Neighbour_Cell_Information_List,
        Neighbour_Cell_Information_ItemIEs,
        _Neighbour_Cell_Information_ItemIEs_val_Value_0,
        ____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab,
        _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        _____GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_6,
        ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__id,
        ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__criticality,
        ___GNBCUConfigurationUpdateAcknowledge_protocolIEs__item__value,
        __GNBCUConfigurationUpdateAcknowledge_protocolIEs__item_,
        _GNBCUConfigurationUpdateAcknowledge_protocolIEs,
        GNBCUConfigurationUpdateAcknowledge,
        GNBCUConfigurationUpdateAcknowledgeIEs,
        _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_0,
        _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_1,
        _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_2,
        _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_3,
        _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_4,
        _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_5,
        _GNBCUConfigurationUpdateAcknowledgeIEs_val_Value_6,
        ___Cells_Failed_to_be_Activated_List__item__id_tab,
        ____Cells_Failed_to_be_Activated_List__item__id_tab_val_Value_0,
        __Cells_Failed_to_be_Activated_List__item__id,
        __Cells_Failed_to_be_Activated_List__item__criticality,
        __Cells_Failed_to_be_Activated_List__item__value,
        _Cells_Failed_to_be_Activated_List__item_,
        Cells_Failed_to_be_Activated_List,
        ___GNB_CU_TNL_Association_Setup_List__item__id_tab,
        ____GNB_CU_TNL_Association_Setup_List__item__id_tab_val_Value_0,
        __GNB_CU_TNL_Association_Setup_List__item__id,
        __GNB_CU_TNL_Association_Setup_List__item__criticality,
        __GNB_CU_TNL_Association_Setup_List__item__value,
        _GNB_CU_TNL_Association_Setup_List__item_,
        GNB_CU_TNL_Association_Setup_List,
        ___GNB_CU_TNL_Association_Failed_To_Setup_List__item__id_tab,
        ____GNB_CU_TNL_Association_Failed_To_Setup_List__item__id_tab_val_Value_0,
        __GNB_CU_TNL_Association_Failed_To_Setup_List__item__id,
        __GNB_CU_TNL_Association_Failed_To_Setup_List__item__criticality,
        __GNB_CU_TNL_Association_Failed_To_Setup_List__item__value,
        _GNB_CU_TNL_Association_Failed_To_Setup_List__item_,
        GNB_CU_TNL_Association_Failed_To_Setup_List,
        Cells_Failed_to_be_Activated_List_ItemIEs,
        _Cells_Failed_to_be_Activated_List_ItemIEs_val_Value_0,
        GNB_CU_TNL_Association_Setup_ItemIEs,
        _GNB_CU_TNL_Association_Setup_ItemIEs_val_Value_0,
        GNB_CU_TNL_Association_Failed_To_Setup_ItemIEs,
        _GNB_CU_TNL_Association_Failed_To_Setup_ItemIEs_val_Value_0,
        ____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab,
        _____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        _____GNBCUConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3,
        ___GNBCUConfigurationUpdateFailure_protocolIEs__item__id,
        ___GNBCUConfigurationUpdateFailure_protocolIEs__item__criticality,
        ___GNBCUConfigurationUpdateFailure_protocolIEs__item__value,
        __GNBCUConfigurationUpdateFailure_protocolIEs__item_,
        _GNBCUConfigurationUpdateFailure_protocolIEs,
        GNBCUConfigurationUpdateFailure,
        GNBCUConfigurationUpdateFailureIEs,
        _GNBCUConfigurationUpdateFailureIEs_val_Value_0,
        _GNBCUConfigurationUpdateFailureIEs_val_Value_1,
        _GNBCUConfigurationUpdateFailureIEs_val_Value_2,
        _GNBCUConfigurationUpdateFailureIEs_val_Value_3,
        ____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab,
        _____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____GNBDUResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_3,
        ___GNBDUResourceCoordinationRequest_protocolIEs__item__id,
        ___GNBDUResourceCoordinationRequest_protocolIEs__item__criticality,
        ___GNBDUResourceCoordinationRequest_protocolIEs__item__value,
        __GNBDUResourceCoordinationRequest_protocolIEs__item_,
        _GNBDUResourceCoordinationRequest_protocolIEs,
        GNBDUResourceCoordinationRequest,
        GNBDUResourceCoordinationRequest_IEs,
        _GNBDUResourceCoordinationRequest_IEs_val_Value_0,
        _GNBDUResourceCoordinationRequest_IEs_val_Value_1,
        _GNBDUResourceCoordinationRequest_IEs_val_Value_2,
        _GNBDUResourceCoordinationRequest_IEs_val_Value_3,
        ____GNBDUResourceCoordinationResponse_protocolIEs__item__id_tab,
        _____GNBDUResourceCoordinationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____GNBDUResourceCoordinationResponse_protocolIEs__item__id_tab_val_Value_1,
        ___GNBDUResourceCoordinationResponse_protocolIEs__item__id,
        ___GNBDUResourceCoordinationResponse_protocolIEs__item__criticality,
        ___GNBDUResourceCoordinationResponse_protocolIEs__item__value,
        __GNBDUResourceCoordinationResponse_protocolIEs__item_,
        _GNBDUResourceCoordinationResponse_protocolIEs,
        GNBDUResourceCoordinationResponse,
        GNBDUResourceCoordinationResponse_IEs,
        _GNBDUResourceCoordinationResponse_IEs_val_Value_0,
        _GNBDUResourceCoordinationResponse_IEs_val_Value_1,
        ____UEContextSetupRequest_protocolIEs__item__id_tab,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_6,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_7,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_8,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_9,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_10,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_11,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_12,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_13,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_14,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_15,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_16,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_17,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_18,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_19,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_20,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_21,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_22,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_23,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_24,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_25,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_26,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_27,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_28,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_29,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_30,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_31,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_32,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_33,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_34,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_35,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_36,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_37,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_38,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_39,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_40,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_41,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_42,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_43,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_44,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_45,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_46,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_47,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_48,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_49,
        _____UEContextSetupRequest_protocolIEs__item__id_tab_val_Value_50,
        ___UEContextSetupRequest_protocolIEs__item__id,
        ___UEContextSetupRequest_protocolIEs__item__criticality,
        ___UEContextSetupRequest_protocolIEs__item__value,
        __UEContextSetupRequest_protocolIEs__item_,
        _UEContextSetupRequest_protocolIEs,
        UEContextSetupRequest,
        UEContextSetupRequestIEs,
        _UEContextSetupRequestIEs_val_Value_0,
        _UEContextSetupRequestIEs_val_Value_1,
        _UEContextSetupRequestIEs_val_Value_2,
        _UEContextSetupRequestIEs_val_Value_3,
        _UEContextSetupRequestIEs_val_Value_4,
        _UEContextSetupRequestIEs_val_Value_5,
        _UEContextSetupRequestIEs_val_Value_6,
        _UEContextSetupRequestIEs_val_Value_7,
        _UEContextSetupRequestIEs_val_Value_8,
        _UEContextSetupRequestIEs_val_Value_9,
        _UEContextSetupRequestIEs_val_Value_10,
        _UEContextSetupRequestIEs_val_Value_11,
        _UEContextSetupRequestIEs_val_Value_12,
        _UEContextSetupRequestIEs_val_Value_13,
        _UEContextSetupRequestIEs_val_Value_14,
        _UEContextSetupRequestIEs_val_Value_15,
        _UEContextSetupRequestIEs_val_Value_16,
        _UEContextSetupRequestIEs_val_Value_17,
        _UEContextSetupRequestIEs_val_Value_18,
        _UEContextSetupRequestIEs_val_Value_19,
        _UEContextSetupRequestIEs_val_Value_20,
        _UEContextSetupRequestIEs_val_Value_21,
        _UEContextSetupRequestIEs_val_Value_22,
        _UEContextSetupRequestIEs_val_Value_23,
        _UEContextSetupRequestIEs_val_Value_24,
        _UEContextSetupRequestIEs_val_Value_25,
        _UEContextSetupRequestIEs_val_Value_26,
        _UEContextSetupRequestIEs_val_Value_27,
        _UEContextSetupRequestIEs_val_Value_28,
        _UEContextSetupRequestIEs_val_Value_29,
        _UEContextSetupRequestIEs_val_Value_30,
        _UEContextSetupRequestIEs_val_Value_31,
        _UEContextSetupRequestIEs_val_Value_32,
        _UEContextSetupRequestIEs_val_Value_33,
        _UEContextSetupRequestIEs_val_Value_34,
        _UEContextSetupRequestIEs_val_Value_35,
        _UEContextSetupRequestIEs_val_Value_36,
        _UEContextSetupRequestIEs_val_Value_37,
        _UEContextSetupRequestIEs_val_Value_38,
        _UEContextSetupRequestIEs_val_Value_39,
        _UEContextSetupRequestIEs_val_Value_40,
        _UEContextSetupRequestIEs_val_Value_41,
        _UEContextSetupRequestIEs_val_Value_42,
        _UEContextSetupRequestIEs_val_Value_43,
        _UEContextSetupRequestIEs_val_Value_44,
        _UEContextSetupRequestIEs_val_Value_45,
        _UEContextSetupRequestIEs_val_Value_46,
        _UEContextSetupRequestIEs_val_Value_47,
        _UEContextSetupRequestIEs_val_Value_48,
        _UEContextSetupRequestIEs_val_Value_49,
        _UEContextSetupRequestIEs_val_Value_50,
        ___Candidate_SpCell_List__item__id_tab,
        ____Candidate_SpCell_List__item__id_tab_val_Value_0,
        __Candidate_SpCell_List__item__id,
        __Candidate_SpCell_List__item__criticality,
        __Candidate_SpCell_List__item__value,
        _Candidate_SpCell_List__item_,
        Candidate_SpCell_List,
        ___SCell_ToBeSetup_List__item__id_tab,
        ____SCell_ToBeSetup_List__item__id_tab_val_Value_0,
        __SCell_ToBeSetup_List__item__id,
        __SCell_ToBeSetup_List__item__criticality,
        __SCell_ToBeSetup_List__item__value,
        _SCell_ToBeSetup_List__item_,
        SCell_ToBeSetup_List,
        ___SRBs_ToBeSetup_List__item__id_tab,
        ____SRBs_ToBeSetup_List__item__id_tab_val_Value_0,
        __SRBs_ToBeSetup_List__item__id,
        __SRBs_ToBeSetup_List__item__criticality,
        __SRBs_ToBeSetup_List__item__value,
        _SRBs_ToBeSetup_List__item_,
        SRBs_ToBeSetup_List,
        ___DRBs_ToBeSetup_List__item__id_tab,
        ____DRBs_ToBeSetup_List__item__id_tab_val_Value_0,
        __DRBs_ToBeSetup_List__item__id,
        __DRBs_ToBeSetup_List__item__criticality,
        __DRBs_ToBeSetup_List__item__value,
        _DRBs_ToBeSetup_List__item_,
        DRBs_ToBeSetup_List,
        ___BHChannels_ToBeSetup_List__item__id_tab,
        ____BHChannels_ToBeSetup_List__item__id_tab_val_Value_0,
        __BHChannels_ToBeSetup_List__item__id,
        __BHChannels_ToBeSetup_List__item__criticality,
        __BHChannels_ToBeSetup_List__item__value,
        _BHChannels_ToBeSetup_List__item_,
        BHChannels_ToBeSetup_List,
        ___SLDRBs_ToBeSetup_List__item__id_tab,
        ____SLDRBs_ToBeSetup_List__item__id_tab_val_Value_0,
        __SLDRBs_ToBeSetup_List__item__id,
        __SLDRBs_ToBeSetup_List__item__criticality,
        __SLDRBs_ToBeSetup_List__item__value,
        _SLDRBs_ToBeSetup_List__item_,
        SLDRBs_ToBeSetup_List,
        ___UE_MulticastMRBs_ToBeSetup_List__item__id_tab,
        ____UE_MulticastMRBs_ToBeSetup_List__item__id_tab_val_Value_0,
        __UE_MulticastMRBs_ToBeSetup_List__item__id,
        __UE_MulticastMRBs_ToBeSetup_List__item__criticality,
        __UE_MulticastMRBs_ToBeSetup_List__item__value,
        _UE_MulticastMRBs_ToBeSetup_List__item_,
        UE_MulticastMRBs_ToBeSetup_List,
        ___ServingCellMO_List__item__id_tab,
        ____ServingCellMO_List__item__id_tab_val_Value_0,
        __ServingCellMO_List__item__id,
        __ServingCellMO_List__item__criticality,
        __ServingCellMO_List__item__value,
        _ServingCellMO_List__item_,
        ServingCellMO_List,
        Candidate_SpCell_ItemIEs,
        _Candidate_SpCell_ItemIEs_val_Value_0,
        SCell_ToBeSetup_ItemIEs,
        _SCell_ToBeSetup_ItemIEs_val_Value_0,
        SRBs_ToBeSetup_ItemIEs,
        _SRBs_ToBeSetup_ItemIEs_val_Value_0,
        DRBs_ToBeSetup_ItemIEs,
        _DRBs_ToBeSetup_ItemIEs_val_Value_0,
        BHChannels_ToBeSetup_ItemIEs,
        _BHChannels_ToBeSetup_ItemIEs_val_Value_0,
        SLDRBs_ToBeSetup_ItemIEs,
        _SLDRBs_ToBeSetup_ItemIEs_val_Value_0,
        UE_MulticastMRBs_ToBeSetup_ItemIEs,
        _UE_MulticastMRBs_ToBeSetup_ItemIEs_val_Value_0,
        ServingCellMO_List_ItemIEs,
        _ServingCellMO_List_ItemIEs_val_Value_0,
        ____UEContextSetupResponse_protocolIEs__item__id_tab,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_6,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_7,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_8,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_9,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_10,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_11,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_12,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_13,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_14,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_15,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_16,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_17,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_18,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_19,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_20,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_21,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_22,
        _____UEContextSetupResponse_protocolIEs__item__id_tab_val_Value_23,
        ___UEContextSetupResponse_protocolIEs__item__id,
        ___UEContextSetupResponse_protocolIEs__item__criticality,
        ___UEContextSetupResponse_protocolIEs__item__value,
        __UEContextSetupResponse_protocolIEs__item_,
        _UEContextSetupResponse_protocolIEs,
        UEContextSetupResponse,
        UEContextSetupResponseIEs,
        _UEContextSetupResponseIEs_val_Value_0,
        _UEContextSetupResponseIEs_val_Value_1,
        _UEContextSetupResponseIEs_val_Value_2,
        _UEContextSetupResponseIEs_val_Value_3,
        _UEContextSetupResponseIEs_val_Value_4,
        _UEContextSetupResponseIEs_val_Value_5,
        _UEContextSetupResponseIEs_val_Value_6,
        _UEContextSetupResponseIEs_val_Value_7,
        _UEContextSetupResponseIEs_val_Value_8,
        _UEContextSetupResponseIEs_val_Value_9,
        _UEContextSetupResponseIEs_val_Value_10,
        _UEContextSetupResponseIEs_val_Value_11,
        _UEContextSetupResponseIEs_val_Value_12,
        _UEContextSetupResponseIEs_val_Value_13,
        _UEContextSetupResponseIEs_val_Value_14,
        _UEContextSetupResponseIEs_val_Value_15,
        _UEContextSetupResponseIEs_val_Value_16,
        _UEContextSetupResponseIEs_val_Value_17,
        _UEContextSetupResponseIEs_val_Value_18,
        _UEContextSetupResponseIEs_val_Value_19,
        _UEContextSetupResponseIEs_val_Value_20,
        _UEContextSetupResponseIEs_val_Value_21,
        _UEContextSetupResponseIEs_val_Value_22,
        _UEContextSetupResponseIEs_val_Value_23,
        ___DRBs_Setup_List__item__id_tab,
        ____DRBs_Setup_List__item__id_tab_val_Value_0,
        __DRBs_Setup_List__item__id,
        __DRBs_Setup_List__item__criticality,
        __DRBs_Setup_List__item__value,
        _DRBs_Setup_List__item_,
        DRBs_Setup_List,
        ___SRBs_FailedToBeSetup_List__item__id_tab,
        ____SRBs_FailedToBeSetup_List__item__id_tab_val_Value_0,
        __SRBs_FailedToBeSetup_List__item__id,
        __SRBs_FailedToBeSetup_List__item__criticality,
        __SRBs_FailedToBeSetup_List__item__value,
        _SRBs_FailedToBeSetup_List__item_,
        SRBs_FailedToBeSetup_List,
        ___DRBs_FailedToBeSetup_List__item__id_tab,
        ____DRBs_FailedToBeSetup_List__item__id_tab_val_Value_0,
        __DRBs_FailedToBeSetup_List__item__id,
        __DRBs_FailedToBeSetup_List__item__criticality,
        __DRBs_FailedToBeSetup_List__item__value,
        _DRBs_FailedToBeSetup_List__item_,
        DRBs_FailedToBeSetup_List,
        ___SCell_FailedtoSetup_List__item__id_tab,
        ____SCell_FailedtoSetup_List__item__id_tab_val_Value_0,
        __SCell_FailedtoSetup_List__item__id,
        __SCell_FailedtoSetup_List__item__criticality,
        __SCell_FailedtoSetup_List__item__value,
        _SCell_FailedtoSetup_List__item_,
        SCell_FailedtoSetup_List,
        ___SRBs_Setup_List__item__id_tab,
        ____SRBs_Setup_List__item__id_tab_val_Value_0,
        __SRBs_Setup_List__item__id,
        __SRBs_Setup_List__item__criticality,
        __SRBs_Setup_List__item__value,
        _SRBs_Setup_List__item_,
        SRBs_Setup_List,
        ___BHChannels_Setup_List__item__id_tab,
        ____BHChannels_Setup_List__item__id_tab_val_Value_0,
        __BHChannels_Setup_List__item__id,
        __BHChannels_Setup_List__item__criticality,
        __BHChannels_Setup_List__item__value,
        _BHChannels_Setup_List__item_,
        BHChannels_Setup_List,
        ___BHChannels_FailedToBeSetup_List__item__id_tab,
        ____BHChannels_FailedToBeSetup_List__item__id_tab_val_Value_0,
        __BHChannels_FailedToBeSetup_List__item__id,
        __BHChannels_FailedToBeSetup_List__item__criticality,
        __BHChannels_FailedToBeSetup_List__item__value,
        _BHChannels_FailedToBeSetup_List__item_,
        BHChannels_FailedToBeSetup_List,
        DRBs_Setup_ItemIEs,
        _DRBs_Setup_ItemIEs_val_Value_0,
        SRBs_Setup_ItemIEs,
        _SRBs_Setup_ItemIEs_val_Value_0,
        SRBs_FailedToBeSetup_ItemIEs,
        _SRBs_FailedToBeSetup_ItemIEs_val_Value_0,
        DRBs_FailedToBeSetup_ItemIEs,
        _DRBs_FailedToBeSetup_ItemIEs_val_Value_0,
        SCell_FailedtoSetup_ItemIEs,
        _SCell_FailedtoSetup_ItemIEs_val_Value_0,
        BHChannels_Setup_ItemIEs,
        _BHChannels_Setup_ItemIEs_val_Value_0,
        BHChannels_FailedToBeSetup_ItemIEs,
        _BHChannels_FailedToBeSetup_ItemIEs_val_Value_0,
        ___SLDRBs_Setup_List__item__id_tab,
        ____SLDRBs_Setup_List__item__id_tab_val_Value_0,
        __SLDRBs_Setup_List__item__id,
        __SLDRBs_Setup_List__item__criticality,
        __SLDRBs_Setup_List__item__value,
        _SLDRBs_Setup_List__item_,
        SLDRBs_Setup_List,
        ___SLDRBs_FailedToBeSetup_List__item__id_tab,
        ____SLDRBs_FailedToBeSetup_List__item__id_tab_val_Value_0,
        __SLDRBs_FailedToBeSetup_List__item__id,
        __SLDRBs_FailedToBeSetup_List__item__criticality,
        __SLDRBs_FailedToBeSetup_List__item__value,
        _SLDRBs_FailedToBeSetup_List__item_,
        SLDRBs_FailedToBeSetup_List,
        SLDRBs_Setup_ItemIEs,
        _SLDRBs_Setup_ItemIEs_val_Value_0,
        SLDRBs_FailedToBeSetup_ItemIEs,
        _SLDRBs_FailedToBeSetup_ItemIEs_val_Value_0,
        ____UEContextSetupFailure_protocolIEs__item__id_tab,
        _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextSetupFailure_protocolIEs__item__id_tab_val_Value_5,
        ___UEContextSetupFailure_protocolIEs__item__id,
        ___UEContextSetupFailure_protocolIEs__item__criticality,
        ___UEContextSetupFailure_protocolIEs__item__value,
        __UEContextSetupFailure_protocolIEs__item_,
        _UEContextSetupFailure_protocolIEs,
        UEContextSetupFailure,
        UEContextSetupFailureIEs,
        _UEContextSetupFailureIEs_val_Value_0,
        _UEContextSetupFailureIEs_val_Value_1,
        _UEContextSetupFailureIEs_val_Value_2,
        _UEContextSetupFailureIEs_val_Value_3,
        _UEContextSetupFailureIEs_val_Value_4,
        _UEContextSetupFailureIEs_val_Value_5,
        ___Potential_SpCell_List__item__id_tab,
        ____Potential_SpCell_List__item__id_tab_val_Value_0,
        __Potential_SpCell_List__item__id,
        __Potential_SpCell_List__item__criticality,
        __Potential_SpCell_List__item__value,
        _Potential_SpCell_List__item_,
        Potential_SpCell_List,
        Potential_SpCell_ItemIEs,
        _Potential_SpCell_ItemIEs_val_Value_0,
        ____UEContextReleaseRequest_protocolIEs__item__id_tab,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_3,
        ___UEContextReleaseRequest_protocolIEs__item__id,
        ___UEContextReleaseRequest_protocolIEs__item__criticality,
        ___UEContextReleaseRequest_protocolIEs__item__value,
        __UEContextReleaseRequest_protocolIEs__item_,
        _UEContextReleaseRequest_protocolIEs,
        UEContextReleaseRequest,
        UEContextReleaseRequestIEs,
        _UEContextReleaseRequestIEs_val_Value_0,
        _UEContextReleaseRequestIEs_val_Value_1,
        _UEContextReleaseRequestIEs_val_Value_2,
        _UEContextReleaseRequestIEs_val_Value_3,
        ____UEContextReleaseCommand_protocolIEs__item__id_tab,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_6,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_7,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_8,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_9,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_10,
        ___UEContextReleaseCommand_protocolIEs__item__id,
        ___UEContextReleaseCommand_protocolIEs__item__criticality,
        ___UEContextReleaseCommand_protocolIEs__item__value,
        __UEContextReleaseCommand_protocolIEs__item_,
        _UEContextReleaseCommand_protocolIEs,
        UEContextReleaseCommand,
        UEContextReleaseCommandIEs,
        _UEContextReleaseCommandIEs_val_Value_0,
        _UEContextReleaseCommandIEs_val_Value_1,
        _UEContextReleaseCommandIEs_val_Value_2,
        _UEContextReleaseCommandIEs_val_Value_3,
        _UEContextReleaseCommandIEs_val_Value_4,
        _UEContextReleaseCommandIEs_val_Value_5,
        _UEContextReleaseCommandIEs_val_Value_6,
        _UEContextReleaseCommandIEs_val_Value_7,
        _UEContextReleaseCommandIEs_val_Value_8,
        _UEContextReleaseCommandIEs_val_Value_9,
        _UEContextReleaseCommandIEs_val_Value_10,
        ____UEContextReleaseComplete_protocolIEs__item__id_tab,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2,
        ___UEContextReleaseComplete_protocolIEs__item__id,
        ___UEContextReleaseComplete_protocolIEs__item__criticality,
        ___UEContextReleaseComplete_protocolIEs__item__value,
        __UEContextReleaseComplete_protocolIEs__item_,
        _UEContextReleaseComplete_protocolIEs,
        UEContextReleaseComplete,
        UEContextReleaseCompleteIEs,
        _UEContextReleaseCompleteIEs_val_Value_0,
        _UEContextReleaseCompleteIEs_val_Value_1,
        _UEContextReleaseCompleteIEs_val_Value_2,
        ____UEContextModificationRequest_protocolIEs__item__id_tab,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_6,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_7,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_8,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_9,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_10,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_11,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_12,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_13,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_14,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_15,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_16,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_17,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_18,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_19,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_20,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_21,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_22,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_23,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_24,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_25,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_26,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_27,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_28,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_29,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_30,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_31,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_32,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_33,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_34,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_35,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_36,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_37,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_38,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_39,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_40,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_41,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_42,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_43,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_44,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_45,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_46,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_47,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_48,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_49,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_50,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_51,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_52,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_53,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_54,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_55,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_56,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_57,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_58,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_59,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_60,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_61,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_62,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_63,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_64,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_65,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_66,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_67,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_68,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_69,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_70,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_71,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_72,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_73,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_74,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_75,
        ___UEContextModificationRequest_protocolIEs__item__id,
        ___UEContextModificationRequest_protocolIEs__item__criticality,
        ___UEContextModificationRequest_protocolIEs__item__value,
        __UEContextModificationRequest_protocolIEs__item_,
        _UEContextModificationRequest_protocolIEs,
        UEContextModificationRequest,
        UEContextModificationRequestIEs,
        _UEContextModificationRequestIEs_val_Value_0,
        _UEContextModificationRequestIEs_val_Value_1,
        _UEContextModificationRequestIEs_val_Value_2,
        _UEContextModificationRequestIEs_val_Value_3,
        _UEContextModificationRequestIEs_val_Value_4,
        _UEContextModificationRequestIEs_val_Value_5,
        _UEContextModificationRequestIEs_val_Value_6,
        _UEContextModificationRequestIEs_val_Value_7,
        _UEContextModificationRequestIEs_val_Value_8,
        _UEContextModificationRequestIEs_val_Value_9,
        _UEContextModificationRequestIEs_val_Value_10,
        _UEContextModificationRequestIEs_val_Value_11,
        _UEContextModificationRequestIEs_val_Value_12,
        _UEContextModificationRequestIEs_val_Value_13,
        _UEContextModificationRequestIEs_val_Value_14,
        _UEContextModificationRequestIEs_val_Value_15,
        _UEContextModificationRequestIEs_val_Value_16,
        _UEContextModificationRequestIEs_val_Value_17,
        _UEContextModificationRequestIEs_val_Value_18,
        _UEContextModificationRequestIEs_val_Value_19,
        _UEContextModificationRequestIEs_val_Value_20,
        _UEContextModificationRequestIEs_val_Value_21,
        _UEContextModificationRequestIEs_val_Value_22,
        _UEContextModificationRequestIEs_val_Value_23,
        _UEContextModificationRequestIEs_val_Value_24,
        _UEContextModificationRequestIEs_val_Value_25,
        _UEContextModificationRequestIEs_val_Value_26,
        _UEContextModificationRequestIEs_val_Value_27,
        _UEContextModificationRequestIEs_val_Value_28,
        _UEContextModificationRequestIEs_val_Value_29,
        _UEContextModificationRequestIEs_val_Value_30,
        _UEContextModificationRequestIEs_val_Value_31,
        _UEContextModificationRequestIEs_val_Value_32,
        _UEContextModificationRequestIEs_val_Value_33,
        _UEContextModificationRequestIEs_val_Value_34,
        _UEContextModificationRequestIEs_val_Value_35,
        _UEContextModificationRequestIEs_val_Value_36,
        _UEContextModificationRequestIEs_val_Value_37,
        _UEContextModificationRequestIEs_val_Value_38,
        _UEContextModificationRequestIEs_val_Value_39,
        _UEContextModificationRequestIEs_val_Value_40,
        _UEContextModificationRequestIEs_val_Value_41,
        _UEContextModificationRequestIEs_val_Value_42,
        _UEContextModificationRequestIEs_val_Value_43,
        _UEContextModificationRequestIEs_val_Value_44,
        _UEContextModificationRequestIEs_val_Value_45,
        _UEContextModificationRequestIEs_val_Value_46,
        _UEContextModificationRequestIEs_val_Value_47,
        _UEContextModificationRequestIEs_val_Value_48,
        _UEContextModificationRequestIEs_val_Value_49,
        _UEContextModificationRequestIEs_val_Value_50,
        _UEContextModificationRequestIEs_val_Value_51,
        _UEContextModificationRequestIEs_val_Value_52,
        _UEContextModificationRequestIEs_val_Value_53,
        _UEContextModificationRequestIEs_val_Value_54,
        _UEContextModificationRequestIEs_val_Value_55,
        _UEContextModificationRequestIEs_val_Value_56,
        _UEContextModificationRequestIEs_val_Value_57,
        _UEContextModificationRequestIEs_val_Value_58,
        _UEContextModificationRequestIEs_val_Value_59,
        _UEContextModificationRequestIEs_val_Value_60,
        _UEContextModificationRequestIEs_val_Value_61,
        _UEContextModificationRequestIEs_val_Value_62,
        _UEContextModificationRequestIEs_val_Value_63,
        _UEContextModificationRequestIEs_val_Value_64,
        _UEContextModificationRequestIEs_val_Value_65,
        _UEContextModificationRequestIEs_val_Value_66,
        _UEContextModificationRequestIEs_val_Value_67,
        _UEContextModificationRequestIEs_val_Value_68,
        _UEContextModificationRequestIEs_val_Value_69,
        _UEContextModificationRequestIEs_val_Value_70,
        _UEContextModificationRequestIEs_val_Value_71,
        _UEContextModificationRequestIEs_val_Value_72,
        _UEContextModificationRequestIEs_val_Value_73,
        _UEContextModificationRequestIEs_val_Value_74,
        _UEContextModificationRequestIEs_val_Value_75,
        ___SCell_ToBeSetupMod_List__item__id_tab,
        ____SCell_ToBeSetupMod_List__item__id_tab_val_Value_0,
        __SCell_ToBeSetupMod_List__item__id,
        __SCell_ToBeSetupMod_List__item__criticality,
        __SCell_ToBeSetupMod_List__item__value,
        _SCell_ToBeSetupMod_List__item_,
        SCell_ToBeSetupMod_List,
        ___SCell_ToBeRemoved_List__item__id_tab,
        ____SCell_ToBeRemoved_List__item__id_tab_val_Value_0,
        __SCell_ToBeRemoved_List__item__id,
        __SCell_ToBeRemoved_List__item__criticality,
        __SCell_ToBeRemoved_List__item__value,
        _SCell_ToBeRemoved_List__item_,
        SCell_ToBeRemoved_List,
        ___SRBs_ToBeSetupMod_List__item__id_tab,
        ____SRBs_ToBeSetupMod_List__item__id_tab_val_Value_0,
        __SRBs_ToBeSetupMod_List__item__id,
        __SRBs_ToBeSetupMod_List__item__criticality,
        __SRBs_ToBeSetupMod_List__item__value,
        _SRBs_ToBeSetupMod_List__item_,
        SRBs_ToBeSetupMod_List,
        ___DRBs_ToBeSetupMod_List__item__id_tab,
        ____DRBs_ToBeSetupMod_List__item__id_tab_val_Value_0,
        __DRBs_ToBeSetupMod_List__item__id,
        __DRBs_ToBeSetupMod_List__item__criticality,
        __DRBs_ToBeSetupMod_List__item__value,
        _DRBs_ToBeSetupMod_List__item_,
        DRBs_ToBeSetupMod_List,
        ___BHChannels_ToBeSetupMod_List__item__id_tab,
        ____BHChannels_ToBeSetupMod_List__item__id_tab_val_Value_0,
        __BHChannels_ToBeSetupMod_List__item__id,
        __BHChannels_ToBeSetupMod_List__item__criticality,
        __BHChannels_ToBeSetupMod_List__item__value,
        _BHChannels_ToBeSetupMod_List__item_,
        BHChannels_ToBeSetupMod_List,
        ___DRBs_ToBeModified_List__item__id_tab,
        ____DRBs_ToBeModified_List__item__id_tab_val_Value_0,
        __DRBs_ToBeModified_List__item__id,
        __DRBs_ToBeModified_List__item__criticality,
        __DRBs_ToBeModified_List__item__value,
        _DRBs_ToBeModified_List__item_,
        DRBs_ToBeModified_List,
        ___BHChannels_ToBeModified_List__item__id_tab,
        ____BHChannels_ToBeModified_List__item__id_tab_val_Value_0,
        __BHChannels_ToBeModified_List__item__id,
        __BHChannels_ToBeModified_List__item__criticality,
        __BHChannels_ToBeModified_List__item__value,
        _BHChannels_ToBeModified_List__item_,
        BHChannels_ToBeModified_List,
        ___SRBs_ToBeReleased_List__item__id_tab,
        ____SRBs_ToBeReleased_List__item__id_tab_val_Value_0,
        __SRBs_ToBeReleased_List__item__id,
        __SRBs_ToBeReleased_List__item__criticality,
        __SRBs_ToBeReleased_List__item__value,
        _SRBs_ToBeReleased_List__item_,
        SRBs_ToBeReleased_List,
        ___DRBs_ToBeReleased_List__item__id_tab,
        ____DRBs_ToBeReleased_List__item__id_tab_val_Value_0,
        __DRBs_ToBeReleased_List__item__id,
        __DRBs_ToBeReleased_List__item__criticality,
        __DRBs_ToBeReleased_List__item__value,
        _DRBs_ToBeReleased_List__item_,
        DRBs_ToBeReleased_List,
        ___BHChannels_ToBeReleased_List__item__id_tab,
        ____BHChannels_ToBeReleased_List__item__id_tab_val_Value_0,
        __BHChannels_ToBeReleased_List__item__id,
        __BHChannels_ToBeReleased_List__item__criticality,
        __BHChannels_ToBeReleased_List__item__value,
        _BHChannels_ToBeReleased_List__item_,
        BHChannels_ToBeReleased_List,
        ___UE_MulticastMRBs_ToBeSetup_atModify_List__item__id_tab,
        ____UE_MulticastMRBs_ToBeSetup_atModify_List__item__id_tab_val_Value_0,
        __UE_MulticastMRBs_ToBeSetup_atModify_List__item__id,
        __UE_MulticastMRBs_ToBeSetup_atModify_List__item__criticality,
        __UE_MulticastMRBs_ToBeSetup_atModify_List__item__value,
        _UE_MulticastMRBs_ToBeSetup_atModify_List__item_,
        UE_MulticastMRBs_ToBeSetup_atModify_List,
        ___UE_MulticastMRBs_ToBeReleased_List__item__id_tab,
        ____UE_MulticastMRBs_ToBeReleased_List__item__id_tab_val_Value_0,
        __UE_MulticastMRBs_ToBeReleased_List__item__id,
        __UE_MulticastMRBs_ToBeReleased_List__item__criticality,
        __UE_MulticastMRBs_ToBeReleased_List__item__value,
        _UE_MulticastMRBs_ToBeReleased_List__item_,
        UE_MulticastMRBs_ToBeReleased_List,
        SCell_ToBeSetupMod_ItemIEs,
        _SCell_ToBeSetupMod_ItemIEs_val_Value_0,
        SCell_ToBeRemoved_ItemIEs,
        _SCell_ToBeRemoved_ItemIEs_val_Value_0,
        SRBs_ToBeSetupMod_ItemIEs,
        _SRBs_ToBeSetupMod_ItemIEs_val_Value_0,
        DRBs_ToBeSetupMod_ItemIEs,
        _DRBs_ToBeSetupMod_ItemIEs_val_Value_0,
        DRBs_ToBeModified_ItemIEs,
        _DRBs_ToBeModified_ItemIEs_val_Value_0,
        SRBs_ToBeReleased_ItemIEs,
        _SRBs_ToBeReleased_ItemIEs_val_Value_0,
        DRBs_ToBeReleased_ItemIEs,
        _DRBs_ToBeReleased_ItemIEs_val_Value_0,
        BHChannels_ToBeSetupMod_ItemIEs,
        _BHChannels_ToBeSetupMod_ItemIEs_val_Value_0,
        BHChannels_ToBeModified_ItemIEs,
        _BHChannels_ToBeModified_ItemIEs_val_Value_0,
        BHChannels_ToBeReleased_ItemIEs,
        _BHChannels_ToBeReleased_ItemIEs_val_Value_0,
        ___SLDRBs_ToBeSetupMod_List__item__id_tab,
        ____SLDRBs_ToBeSetupMod_List__item__id_tab_val_Value_0,
        __SLDRBs_ToBeSetupMod_List__item__id,
        __SLDRBs_ToBeSetupMod_List__item__criticality,
        __SLDRBs_ToBeSetupMod_List__item__value,
        _SLDRBs_ToBeSetupMod_List__item_,
        SLDRBs_ToBeSetupMod_List,
        ___SLDRBs_ToBeModified_List__item__id_tab,
        ____SLDRBs_ToBeModified_List__item__id_tab_val_Value_0,
        __SLDRBs_ToBeModified_List__item__id,
        __SLDRBs_ToBeModified_List__item__criticality,
        __SLDRBs_ToBeModified_List__item__value,
        _SLDRBs_ToBeModified_List__item_,
        SLDRBs_ToBeModified_List,
        ___SLDRBs_ToBeReleased_List__item__id_tab,
        ____SLDRBs_ToBeReleased_List__item__id_tab_val_Value_0,
        __SLDRBs_ToBeReleased_List__item__id,
        __SLDRBs_ToBeReleased_List__item__criticality,
        __SLDRBs_ToBeReleased_List__item__value,
        _SLDRBs_ToBeReleased_List__item_,
        SLDRBs_ToBeReleased_List,
        SLDRBs_ToBeSetupMod_ItemIEs,
        _SLDRBs_ToBeSetupMod_ItemIEs_val_Value_0,
        SLDRBs_ToBeModified_ItemIEs,
        _SLDRBs_ToBeModified_ItemIEs_val_Value_0,
        SLDRBs_ToBeReleased_ItemIEs,
        _SLDRBs_ToBeReleased_ItemIEs_val_Value_0,
        UE_MulticastMRBs_ToBeSetup_atModify_ItemIEs,
        _UE_MulticastMRBs_ToBeSetup_atModify_ItemIEs_val_Value_0,
        UE_MulticastMRBs_ToBeReleased_ItemIEs,
        _UE_MulticastMRBs_ToBeReleased_ItemIEs_val_Value_0,
        ____UEContextModificationResponse_protocolIEs__item__id_tab,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_6,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_7,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_8,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_9,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_10,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_11,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_12,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_13,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_14,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_15,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_16,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_17,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_18,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_19,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_20,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_21,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_22,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_23,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_24,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_25,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_26,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_27,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_28,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_29,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_30,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_31,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_32,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_33,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_34,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_35,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_36,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_37,
        ___UEContextModificationResponse_protocolIEs__item__id,
        ___UEContextModificationResponse_protocolIEs__item__criticality,
        ___UEContextModificationResponse_protocolIEs__item__value,
        __UEContextModificationResponse_protocolIEs__item_,
        _UEContextModificationResponse_protocolIEs,
        UEContextModificationResponse,
        UEContextModificationResponseIEs,
        _UEContextModificationResponseIEs_val_Value_0,
        _UEContextModificationResponseIEs_val_Value_1,
        _UEContextModificationResponseIEs_val_Value_2,
        _UEContextModificationResponseIEs_val_Value_3,
        _UEContextModificationResponseIEs_val_Value_4,
        _UEContextModificationResponseIEs_val_Value_5,
        _UEContextModificationResponseIEs_val_Value_6,
        _UEContextModificationResponseIEs_val_Value_7,
        _UEContextModificationResponseIEs_val_Value_8,
        _UEContextModificationResponseIEs_val_Value_9,
        _UEContextModificationResponseIEs_val_Value_10,
        _UEContextModificationResponseIEs_val_Value_11,
        _UEContextModificationResponseIEs_val_Value_12,
        _UEContextModificationResponseIEs_val_Value_13,
        _UEContextModificationResponseIEs_val_Value_14,
        _UEContextModificationResponseIEs_val_Value_15,
        _UEContextModificationResponseIEs_val_Value_16,
        _UEContextModificationResponseIEs_val_Value_17,
        _UEContextModificationResponseIEs_val_Value_18,
        _UEContextModificationResponseIEs_val_Value_19,
        _UEContextModificationResponseIEs_val_Value_20,
        _UEContextModificationResponseIEs_val_Value_21,
        _UEContextModificationResponseIEs_val_Value_22,
        _UEContextModificationResponseIEs_val_Value_23,
        _UEContextModificationResponseIEs_val_Value_24,
        _UEContextModificationResponseIEs_val_Value_25,
        _UEContextModificationResponseIEs_val_Value_26,
        _UEContextModificationResponseIEs_val_Value_27,
        _UEContextModificationResponseIEs_val_Value_28,
        _UEContextModificationResponseIEs_val_Value_29,
        _UEContextModificationResponseIEs_val_Value_30,
        _UEContextModificationResponseIEs_val_Value_31,
        _UEContextModificationResponseIEs_val_Value_32,
        _UEContextModificationResponseIEs_val_Value_33,
        _UEContextModificationResponseIEs_val_Value_34,
        _UEContextModificationResponseIEs_val_Value_35,
        _UEContextModificationResponseIEs_val_Value_36,
        _UEContextModificationResponseIEs_val_Value_37,
        ___DRBs_SetupMod_List__item__id_tab,
        ____DRBs_SetupMod_List__item__id_tab_val_Value_0,
        __DRBs_SetupMod_List__item__id,
        __DRBs_SetupMod_List__item__criticality,
        __DRBs_SetupMod_List__item__value,
        _DRBs_SetupMod_List__item_,
        DRBs_SetupMod_List,
        ___DRBs_Modified_List__item__id_tab,
        ____DRBs_Modified_List__item__id_tab_val_Value_0,
        __DRBs_Modified_List__item__id,
        __DRBs_Modified_List__item__criticality,
        __DRBs_Modified_List__item__value,
        _DRBs_Modified_List__item_,
        DRBs_Modified_List,
        ___SRBs_SetupMod_List__item__id_tab,
        ____SRBs_SetupMod_List__item__id_tab_val_Value_0,
        __SRBs_SetupMod_List__item__id,
        __SRBs_SetupMod_List__item__criticality,
        __SRBs_SetupMod_List__item__value,
        _SRBs_SetupMod_List__item_,
        SRBs_SetupMod_List,
        ___SRBs_Modified_List__item__id_tab,
        ____SRBs_Modified_List__item__id_tab_val_Value_0,
        __SRBs_Modified_List__item__id,
        __SRBs_Modified_List__item__criticality,
        __SRBs_Modified_List__item__value,
        _SRBs_Modified_List__item_,
        SRBs_Modified_List,
        ___DRBs_FailedToBeModified_List__item__id_tab,
        ____DRBs_FailedToBeModified_List__item__id_tab_val_Value_0,
        __DRBs_FailedToBeModified_List__item__id,
        __DRBs_FailedToBeModified_List__item__criticality,
        __DRBs_FailedToBeModified_List__item__value,
        _DRBs_FailedToBeModified_List__item_,
        DRBs_FailedToBeModified_List,
        ___SRBs_FailedToBeSetupMod_List__item__id_tab,
        ____SRBs_FailedToBeSetupMod_List__item__id_tab_val_Value_0,
        __SRBs_FailedToBeSetupMod_List__item__id,
        __SRBs_FailedToBeSetupMod_List__item__criticality,
        __SRBs_FailedToBeSetupMod_List__item__value,
        _SRBs_FailedToBeSetupMod_List__item_,
        SRBs_FailedToBeSetupMod_List,
        ___DRBs_FailedToBeSetupMod_List__item__id_tab,
        ____DRBs_FailedToBeSetupMod_List__item__id_tab_val_Value_0,
        __DRBs_FailedToBeSetupMod_List__item__id,
        __DRBs_FailedToBeSetupMod_List__item__criticality,
        __DRBs_FailedToBeSetupMod_List__item__value,
        _DRBs_FailedToBeSetupMod_List__item_,
        DRBs_FailedToBeSetupMod_List,
        ___SCell_FailedtoSetupMod_List__item__id_tab,
        ____SCell_FailedtoSetupMod_List__item__id_tab_val_Value_0,
        __SCell_FailedtoSetupMod_List__item__id,
        __SCell_FailedtoSetupMod_List__item__criticality,
        __SCell_FailedtoSetupMod_List__item__value,
        _SCell_FailedtoSetupMod_List__item_,
        SCell_FailedtoSetupMod_List,
        ___BHChannels_SetupMod_List__item__id_tab,
        ____BHChannels_SetupMod_List__item__id_tab_val_Value_0,
        __BHChannels_SetupMod_List__item__id,
        __BHChannels_SetupMod_List__item__criticality,
        __BHChannels_SetupMod_List__item__value,
        _BHChannels_SetupMod_List__item_,
        BHChannels_SetupMod_List,
        ___BHChannels_Modified_List__item__id_tab,
        ____BHChannels_Modified_List__item__id_tab_val_Value_0,
        __BHChannels_Modified_List__item__id,
        __BHChannels_Modified_List__item__criticality,
        __BHChannels_Modified_List__item__value,
        _BHChannels_Modified_List__item_,
        BHChannels_Modified_List,
        ___BHChannels_FailedToBeModified_List__item__id_tab,
        ____BHChannels_FailedToBeModified_List__item__id_tab_val_Value_0,
        __BHChannels_FailedToBeModified_List__item__id,
        __BHChannels_FailedToBeModified_List__item__criticality,
        __BHChannels_FailedToBeModified_List__item__value,
        _BHChannels_FailedToBeModified_List__item_,
        BHChannels_FailedToBeModified_List,
        ___BHChannels_FailedToBeSetupMod_List__item__id_tab,
        ____BHChannels_FailedToBeSetupMod_List__item__id_tab_val_Value_0,
        __BHChannels_FailedToBeSetupMod_List__item__id,
        __BHChannels_FailedToBeSetupMod_List__item__criticality,
        __BHChannels_FailedToBeSetupMod_List__item__value,
        _BHChannels_FailedToBeSetupMod_List__item_,
        BHChannels_FailedToBeSetupMod_List,
        ___Associated_SCell_List__item__id_tab,
        ____Associated_SCell_List__item__id_tab_val_Value_0,
        __Associated_SCell_List__item__id,
        __Associated_SCell_List__item__criticality,
        __Associated_SCell_List__item__value,
        _Associated_SCell_List__item_,
        Associated_SCell_List,
        DRBs_SetupMod_ItemIEs,
        _DRBs_SetupMod_ItemIEs_val_Value_0,
        DRBs_Modified_ItemIEs,
        _DRBs_Modified_ItemIEs_val_Value_0,
        SRBs_SetupMod_ItemIEs,
        _SRBs_SetupMod_ItemIEs_val_Value_0,
        SRBs_Modified_ItemIEs,
        _SRBs_Modified_ItemIEs_val_Value_0,
        SRBs_FailedToBeSetupMod_ItemIEs,
        _SRBs_FailedToBeSetupMod_ItemIEs_val_Value_0,
        DRBs_FailedToBeSetupMod_ItemIEs,
        _DRBs_FailedToBeSetupMod_ItemIEs_val_Value_0,
        DRBs_FailedToBeModified_ItemIEs,
        _DRBs_FailedToBeModified_ItemIEs_val_Value_0,
        SCell_FailedtoSetupMod_ItemIEs,
        _SCell_FailedtoSetupMod_ItemIEs_val_Value_0,
        Associated_SCell_ItemIEs,
        _Associated_SCell_ItemIEs_val_Value_0,
        BHChannels_SetupMod_ItemIEs,
        _BHChannels_SetupMod_ItemIEs_val_Value_0,
        BHChannels_Modified_ItemIEs,
        _BHChannels_Modified_ItemIEs_val_Value_0,
        BHChannels_FailedToBeSetupMod_ItemIEs,
        _BHChannels_FailedToBeSetupMod_ItemIEs_val_Value_0,
        BHChannels_FailedToBeModified_ItemIEs,
        _BHChannels_FailedToBeModified_ItemIEs_val_Value_0,
        ___SLDRBs_SetupMod_List__item__id_tab,
        ____SLDRBs_SetupMod_List__item__id_tab_val_Value_0,
        __SLDRBs_SetupMod_List__item__id,
        __SLDRBs_SetupMod_List__item__criticality,
        __SLDRBs_SetupMod_List__item__value,
        _SLDRBs_SetupMod_List__item_,
        SLDRBs_SetupMod_List,
        ___SLDRBs_Modified_List__item__id_tab,
        ____SLDRBs_Modified_List__item__id_tab_val_Value_0,
        __SLDRBs_Modified_List__item__id,
        __SLDRBs_Modified_List__item__criticality,
        __SLDRBs_Modified_List__item__value,
        _SLDRBs_Modified_List__item_,
        SLDRBs_Modified_List,
        ___SLDRBs_FailedToBeModified_List__item__id_tab,
        ____SLDRBs_FailedToBeModified_List__item__id_tab_val_Value_0,
        __SLDRBs_FailedToBeModified_List__item__id,
        __SLDRBs_FailedToBeModified_List__item__criticality,
        __SLDRBs_FailedToBeModified_List__item__value,
        _SLDRBs_FailedToBeModified_List__item_,
        SLDRBs_FailedToBeModified_List,
        ___SLDRBs_FailedToBeSetupMod_List__item__id_tab,
        ____SLDRBs_FailedToBeSetupMod_List__item__id_tab_val_Value_0,
        __SLDRBs_FailedToBeSetupMod_List__item__id,
        __SLDRBs_FailedToBeSetupMod_List__item__criticality,
        __SLDRBs_FailedToBeSetupMod_List__item__value,
        _SLDRBs_FailedToBeSetupMod_List__item_,
        SLDRBs_FailedToBeSetupMod_List,
        SLDRBs_SetupMod_ItemIEs,
        _SLDRBs_SetupMod_ItemIEs_val_Value_0,
        SLDRBs_Modified_ItemIEs,
        _SLDRBs_Modified_ItemIEs_val_Value_0,
        SLDRBs_FailedToBeSetupMod_ItemIEs,
        _SLDRBs_FailedToBeSetupMod_ItemIEs_val_Value_0,
        SLDRBs_FailedToBeModified_ItemIEs,
        _SLDRBs_FailedToBeModified_ItemIEs_val_Value_0,
        ___UE_MulticastMRBs_Setup_List__item__id_tab,
        ____UE_MulticastMRBs_Setup_List__item__id_tab_val_Value_0,
        __UE_MulticastMRBs_Setup_List__item__id,
        __UE_MulticastMRBs_Setup_List__item__criticality,
        __UE_MulticastMRBs_Setup_List__item__value,
        _UE_MulticastMRBs_Setup_List__item_,
        UE_MulticastMRBs_Setup_List,
        UE_MulticastMRBs_Setup_ItemIEs,
        _UE_MulticastMRBs_Setup_ItemIEs_val_Value_0,
        ____UEContextModificationFailure_protocolIEs__item__id_tab,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_4,
        ___UEContextModificationFailure_protocolIEs__item__id,
        ___UEContextModificationFailure_protocolIEs__item__criticality,
        ___UEContextModificationFailure_protocolIEs__item__value,
        __UEContextModificationFailure_protocolIEs__item_,
        _UEContextModificationFailure_protocolIEs,
        UEContextModificationFailure,
        UEContextModificationFailureIEs,
        _UEContextModificationFailureIEs_val_Value_0,
        _UEContextModificationFailureIEs_val_Value_1,
        _UEContextModificationFailureIEs_val_Value_2,
        _UEContextModificationFailureIEs_val_Value_3,
        _UEContextModificationFailureIEs_val_Value_4,
        ____UEContextModificationRequired_protocolIEs__item__id_tab,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_6,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_7,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_8,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_9,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_10,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_11,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_12,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_13,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_14,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_15,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_16,
        _____UEContextModificationRequired_protocolIEs__item__id_tab_val_Value_17,
        ___UEContextModificationRequired_protocolIEs__item__id,
        ___UEContextModificationRequired_protocolIEs__item__criticality,
        ___UEContextModificationRequired_protocolIEs__item__value,
        __UEContextModificationRequired_protocolIEs__item_,
        _UEContextModificationRequired_protocolIEs,
        UEContextModificationRequired,
        UEContextModificationRequiredIEs,
        _UEContextModificationRequiredIEs_val_Value_0,
        _UEContextModificationRequiredIEs_val_Value_1,
        _UEContextModificationRequiredIEs_val_Value_2,
        _UEContextModificationRequiredIEs_val_Value_3,
        _UEContextModificationRequiredIEs_val_Value_4,
        _UEContextModificationRequiredIEs_val_Value_5,
        _UEContextModificationRequiredIEs_val_Value_6,
        _UEContextModificationRequiredIEs_val_Value_7,
        _UEContextModificationRequiredIEs_val_Value_8,
        _UEContextModificationRequiredIEs_val_Value_9,
        _UEContextModificationRequiredIEs_val_Value_10,
        _UEContextModificationRequiredIEs_val_Value_11,
        _UEContextModificationRequiredIEs_val_Value_12,
        _UEContextModificationRequiredIEs_val_Value_13,
        _UEContextModificationRequiredIEs_val_Value_14,
        _UEContextModificationRequiredIEs_val_Value_15,
        _UEContextModificationRequiredIEs_val_Value_16,
        _UEContextModificationRequiredIEs_val_Value_17,
        ___DRBs_Required_ToBeModified_List__item__id_tab,
        ____DRBs_Required_ToBeModified_List__item__id_tab_val_Value_0,
        __DRBs_Required_ToBeModified_List__item__id,
        __DRBs_Required_ToBeModified_List__item__criticality,
        __DRBs_Required_ToBeModified_List__item__value,
        _DRBs_Required_ToBeModified_List__item_,
        DRBs_Required_ToBeModified_List,
        ___DRBs_Required_ToBeReleased_List__item__id_tab,
        ____DRBs_Required_ToBeReleased_List__item__id_tab_val_Value_0,
        __DRBs_Required_ToBeReleased_List__item__id,
        __DRBs_Required_ToBeReleased_List__item__criticality,
        __DRBs_Required_ToBeReleased_List__item__value,
        _DRBs_Required_ToBeReleased_List__item_,
        DRBs_Required_ToBeReleased_List,
        ___SRBs_Required_ToBeReleased_List__item__id_tab,
        ____SRBs_Required_ToBeReleased_List__item__id_tab_val_Value_0,
        __SRBs_Required_ToBeReleased_List__item__id,
        __SRBs_Required_ToBeReleased_List__item__criticality,
        __SRBs_Required_ToBeReleased_List__item__value,
        _SRBs_Required_ToBeReleased_List__item_,
        SRBs_Required_ToBeReleased_List,
        ___BHChannels_Required_ToBeReleased_List__item__id_tab,
        ____BHChannels_Required_ToBeReleased_List__item__id_tab_val_Value_0,
        __BHChannels_Required_ToBeReleased_List__item__id,
        __BHChannels_Required_ToBeReleased_List__item__criticality,
        __BHChannels_Required_ToBeReleased_List__item__value,
        _BHChannels_Required_ToBeReleased_List__item_,
        BHChannels_Required_ToBeReleased_List,
        DRBs_Required_ToBeModified_ItemIEs,
        _DRBs_Required_ToBeModified_ItemIEs_val_Value_0,
        DRBs_Required_ToBeReleased_ItemIEs,
        _DRBs_Required_ToBeReleased_ItemIEs_val_Value_0,
        SRBs_Required_ToBeReleased_ItemIEs,
        _SRBs_Required_ToBeReleased_ItemIEs_val_Value_0,
        BHChannels_Required_ToBeReleased_ItemIEs,
        _BHChannels_Required_ToBeReleased_ItemIEs_val_Value_0,
        ___SLDRBs_Required_ToBeModified_List__item__id_tab,
        ____SLDRBs_Required_ToBeModified_List__item__id_tab_val_Value_0,
        __SLDRBs_Required_ToBeModified_List__item__id,
        __SLDRBs_Required_ToBeModified_List__item__criticality,
        __SLDRBs_Required_ToBeModified_List__item__value,
        _SLDRBs_Required_ToBeModified_List__item_,
        SLDRBs_Required_ToBeModified_List,
        ___SLDRBs_Required_ToBeReleased_List__item__id_tab,
        ____SLDRBs_Required_ToBeReleased_List__item__id_tab_val_Value_0,
        __SLDRBs_Required_ToBeReleased_List__item__id,
        __SLDRBs_Required_ToBeReleased_List__item__criticality,
        __SLDRBs_Required_ToBeReleased_List__item__value,
        _SLDRBs_Required_ToBeReleased_List__item_,
        SLDRBs_Required_ToBeReleased_List,
        SLDRBs_Required_ToBeModified_ItemIEs,
        _SLDRBs_Required_ToBeModified_ItemIEs_val_Value_0,
        SLDRBs_Required_ToBeReleased_ItemIEs,
        _SLDRBs_Required_ToBeReleased_ItemIEs_val_Value_0,
        ___UE_MulticastMRBs_RequiredToBeModified_List__item__id_tab,
        ____UE_MulticastMRBs_RequiredToBeModified_List__item__id_tab_val_Value_0,
        __UE_MulticastMRBs_RequiredToBeModified_List__item__id,
        __UE_MulticastMRBs_RequiredToBeModified_List__item__criticality,
        __UE_MulticastMRBs_RequiredToBeModified_List__item__value,
        _UE_MulticastMRBs_RequiredToBeModified_List__item_,
        UE_MulticastMRBs_RequiredToBeModified_List,
        UE_MulticastMRBs_RequiredToBeModified_ItemIEs,
        _UE_MulticastMRBs_RequiredToBeModified_ItemIEs_val_Value_0,
        ___UE_MulticastMRBs_RequiredToBeReleased_List__item__id_tab,
        ____UE_MulticastMRBs_RequiredToBeReleased_List__item__id_tab_val_Value_0,
        __UE_MulticastMRBs_RequiredToBeReleased_List__item__id,
        __UE_MulticastMRBs_RequiredToBeReleased_List__item__criticality,
        __UE_MulticastMRBs_RequiredToBeReleased_List__item__value,
        _UE_MulticastMRBs_RequiredToBeReleased_List__item_,
        UE_MulticastMRBs_RequiredToBeReleased_List,
        UE_MulticastMRBs_RequiredToBeReleased_ItemIEs,
        _UE_MulticastMRBs_RequiredToBeReleased_ItemIEs_val_Value_0,
        ____UEContextModificationConfirm_protocolIEs__item__id_tab,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_6,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_7,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_8,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_9,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_10,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_11,
        ___UEContextModificationConfirm_protocolIEs__item__id,
        ___UEContextModificationConfirm_protocolIEs__item__criticality,
        ___UEContextModificationConfirm_protocolIEs__item__value,
        __UEContextModificationConfirm_protocolIEs__item_,
        _UEContextModificationConfirm_protocolIEs,
        UEContextModificationConfirm,
        UEContextModificationConfirmIEs,
        _UEContextModificationConfirmIEs_val_Value_0,
        _UEContextModificationConfirmIEs_val_Value_1,
        _UEContextModificationConfirmIEs_val_Value_2,
        _UEContextModificationConfirmIEs_val_Value_3,
        _UEContextModificationConfirmIEs_val_Value_4,
        _UEContextModificationConfirmIEs_val_Value_5,
        _UEContextModificationConfirmIEs_val_Value_6,
        _UEContextModificationConfirmIEs_val_Value_7,
        _UEContextModificationConfirmIEs_val_Value_8,
        _UEContextModificationConfirmIEs_val_Value_9,
        _UEContextModificationConfirmIEs_val_Value_10,
        _UEContextModificationConfirmIEs_val_Value_11,
        ___DRBs_ModifiedConf_List__item__id_tab,
        ____DRBs_ModifiedConf_List__item__id_tab_val_Value_0,
        __DRBs_ModifiedConf_List__item__id,
        __DRBs_ModifiedConf_List__item__criticality,
        __DRBs_ModifiedConf_List__item__value,
        _DRBs_ModifiedConf_List__item_,
        DRBs_ModifiedConf_List,
        DRBs_ModifiedConf_ItemIEs,
        _DRBs_ModifiedConf_ItemIEs_val_Value_0,
        ___SLDRBs_ModifiedConf_List__item__id_tab,
        ____SLDRBs_ModifiedConf_List__item__id_tab_val_Value_0,
        __SLDRBs_ModifiedConf_List__item__id,
        __SLDRBs_ModifiedConf_List__item__criticality,
        __SLDRBs_ModifiedConf_List__item__value,
        _SLDRBs_ModifiedConf_List__item_,
        SLDRBs_ModifiedConf_List,
        SLDRBs_ModifiedConf_ItemIEs,
        _SLDRBs_ModifiedConf_ItemIEs_val_Value_0,
        ___UE_MulticastMRBs_ConfirmedToBeModified_List__item__id_tab,
        ____UE_MulticastMRBs_ConfirmedToBeModified_List__item__id_tab_val_Value_0,
        __UE_MulticastMRBs_ConfirmedToBeModified_List__item__id,
        __UE_MulticastMRBs_ConfirmedToBeModified_List__item__criticality,
        __UE_MulticastMRBs_ConfirmedToBeModified_List__item__value,
        _UE_MulticastMRBs_ConfirmedToBeModified_List__item_,
        UE_MulticastMRBs_ConfirmedToBeModified_List,
        UE_MulticastMRBs_ConfirmedToBeModified_ItemIEs,
        _UE_MulticastMRBs_ConfirmedToBeModified_ItemIEs_val_Value_0,
        ____UEContextModificationRefuse_protocolIEs__item__id_tab,
        _____UEContextModificationRefuse_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationRefuse_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationRefuse_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextModificationRefuse_protocolIEs__item__id_tab_val_Value_3,
        ___UEContextModificationRefuse_protocolIEs__item__id,
        ___UEContextModificationRefuse_protocolIEs__item__criticality,
        ___UEContextModificationRefuse_protocolIEs__item__value,
        __UEContextModificationRefuse_protocolIEs__item_,
        _UEContextModificationRefuse_protocolIEs,
        UEContextModificationRefuse,
        UEContextModificationRefuseIEs,
        _UEContextModificationRefuseIEs_val_Value_0,
        _UEContextModificationRefuseIEs_val_Value_1,
        _UEContextModificationRefuseIEs_val_Value_2,
        _UEContextModificationRefuseIEs_val_Value_3,
        ____WriteReplaceWarningRequest_protocolIEs__item__id_tab,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_0,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_1,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_2,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_3,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_4,
        ___WriteReplaceWarningRequest_protocolIEs__item__id,
        ___WriteReplaceWarningRequest_protocolIEs__item__criticality,
        ___WriteReplaceWarningRequest_protocolIEs__item__value,
        __WriteReplaceWarningRequest_protocolIEs__item_,
        _WriteReplaceWarningRequest_protocolIEs,
        WriteReplaceWarningRequest,
        WriteReplaceWarningRequestIEs,
        _WriteReplaceWarningRequestIEs_val_Value_0,
        _WriteReplaceWarningRequestIEs_val_Value_1,
        _WriteReplaceWarningRequestIEs_val_Value_2,
        _WriteReplaceWarningRequestIEs_val_Value_3,
        _WriteReplaceWarningRequestIEs_val_Value_4,
        ___Cells_To_Be_Broadcast_List__item__id_tab,
        ____Cells_To_Be_Broadcast_List__item__id_tab_val_Value_0,
        __Cells_To_Be_Broadcast_List__item__id,
        __Cells_To_Be_Broadcast_List__item__criticality,
        __Cells_To_Be_Broadcast_List__item__value,
        _Cells_To_Be_Broadcast_List__item_,
        Cells_To_Be_Broadcast_List,
        Cells_To_Be_Broadcast_List_ItemIEs,
        _Cells_To_Be_Broadcast_List_ItemIEs_val_Value_0,
        ____WriteReplaceWarningResponse_protocolIEs__item__id_tab,
        _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_0,
        _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_1,
        _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_2,
        _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_3,
        ___WriteReplaceWarningResponse_protocolIEs__item__id,
        ___WriteReplaceWarningResponse_protocolIEs__item__criticality,
        ___WriteReplaceWarningResponse_protocolIEs__item__value,
        __WriteReplaceWarningResponse_protocolIEs__item_,
        _WriteReplaceWarningResponse_protocolIEs,
        WriteReplaceWarningResponse,
        WriteReplaceWarningResponseIEs,
        _WriteReplaceWarningResponseIEs_val_Value_0,
        _WriteReplaceWarningResponseIEs_val_Value_1,
        _WriteReplaceWarningResponseIEs_val_Value_2,
        _WriteReplaceWarningResponseIEs_val_Value_3,
        ___Cells_Broadcast_Completed_List__item__id_tab,
        ____Cells_Broadcast_Completed_List__item__id_tab_val_Value_0,
        __Cells_Broadcast_Completed_List__item__id,
        __Cells_Broadcast_Completed_List__item__criticality,
        __Cells_Broadcast_Completed_List__item__value,
        _Cells_Broadcast_Completed_List__item_,
        Cells_Broadcast_Completed_List,
        Cells_Broadcast_Completed_List_ItemIEs,
        _Cells_Broadcast_Completed_List_ItemIEs_val_Value_0,
        ____PWSCancelRequest_protocolIEs__item__id_tab,
        _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_1,
        _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_2,
        _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_3,
        _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_4,
        ___PWSCancelRequest_protocolIEs__item__id,
        ___PWSCancelRequest_protocolIEs__item__criticality,
        ___PWSCancelRequest_protocolIEs__item__value,
        __PWSCancelRequest_protocolIEs__item_,
        _PWSCancelRequest_protocolIEs,
        PWSCancelRequest,
        PWSCancelRequestIEs,
        _PWSCancelRequestIEs_val_Value_0,
        _PWSCancelRequestIEs_val_Value_1,
        _PWSCancelRequestIEs_val_Value_2,
        _PWSCancelRequestIEs_val_Value_3,
        _PWSCancelRequestIEs_val_Value_4,
        ___Broadcast_To_Be_Cancelled_List__item__id_tab,
        ____Broadcast_To_Be_Cancelled_List__item__id_tab_val_Value_0,
        __Broadcast_To_Be_Cancelled_List__item__id,
        __Broadcast_To_Be_Cancelled_List__item__criticality,
        __Broadcast_To_Be_Cancelled_List__item__value,
        _Broadcast_To_Be_Cancelled_List__item_,
        Broadcast_To_Be_Cancelled_List,
        Broadcast_To_Be_Cancelled_List_ItemIEs,
        _Broadcast_To_Be_Cancelled_List_ItemIEs_val_Value_0,
        ____PWSCancelResponse_protocolIEs__item__id_tab,
        _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_1,
        _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_2,
        ___PWSCancelResponse_protocolIEs__item__id,
        ___PWSCancelResponse_protocolIEs__item__criticality,
        ___PWSCancelResponse_protocolIEs__item__value,
        __PWSCancelResponse_protocolIEs__item_,
        _PWSCancelResponse_protocolIEs,
        PWSCancelResponse,
        PWSCancelResponseIEs,
        _PWSCancelResponseIEs_val_Value_0,
        _PWSCancelResponseIEs_val_Value_1,
        _PWSCancelResponseIEs_val_Value_2,
        ___Cells_Broadcast_Cancelled_List__item__id_tab,
        ____Cells_Broadcast_Cancelled_List__item__id_tab_val_Value_0,
        __Cells_Broadcast_Cancelled_List__item__id,
        __Cells_Broadcast_Cancelled_List__item__criticality,
        __Cells_Broadcast_Cancelled_List__item__value,
        _Cells_Broadcast_Cancelled_List__item_,
        Cells_Broadcast_Cancelled_List,
        Cells_Broadcast_Cancelled_List_ItemIEs,
        _Cells_Broadcast_Cancelled_List_ItemIEs_val_Value_0,
        ____UEInactivityNotification_protocolIEs__item__id_tab,
        _____UEInactivityNotification_protocolIEs__item__id_tab_val_Value_0,
        _____UEInactivityNotification_protocolIEs__item__id_tab_val_Value_1,
        _____UEInactivityNotification_protocolIEs__item__id_tab_val_Value_2,
        _____UEInactivityNotification_protocolIEs__item__id_tab_val_Value_3,
        ___UEInactivityNotification_protocolIEs__item__id,
        ___UEInactivityNotification_protocolIEs__item__criticality,
        ___UEInactivityNotification_protocolIEs__item__value,
        __UEInactivityNotification_protocolIEs__item_,
        _UEInactivityNotification_protocolIEs,
        UEInactivityNotification,
        UEInactivityNotificationIEs,
        _UEInactivityNotificationIEs_val_Value_0,
        _UEInactivityNotificationIEs_val_Value_1,
        _UEInactivityNotificationIEs_val_Value_2,
        _UEInactivityNotificationIEs_val_Value_3,
        ___DRB_Activity_List__item__id_tab,
        ____DRB_Activity_List__item__id_tab_val_Value_0,
        __DRB_Activity_List__item__id,
        __DRB_Activity_List__item__criticality,
        __DRB_Activity_List__item__value,
        _DRB_Activity_List__item_,
        DRB_Activity_List,
        DRB_Activity_ItemIEs,
        _DRB_Activity_ItemIEs_val_Value_0,
        ____InitialULRRCMessageTransfer_protocolIEs__item__id_tab,
        _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_2,
        _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_3,
        _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_4,
        _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_5,
        _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_6,
        _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_7,
        _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_8,
        _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_9,
        _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_10,
        _____InitialULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_11,
        ___InitialULRRCMessageTransfer_protocolIEs__item__id,
        ___InitialULRRCMessageTransfer_protocolIEs__item__criticality,
        ___InitialULRRCMessageTransfer_protocolIEs__item__value,
        __InitialULRRCMessageTransfer_protocolIEs__item_,
        _InitialULRRCMessageTransfer_protocolIEs,
        InitialULRRCMessageTransfer,
        InitialULRRCMessageTransferIEs,
        _InitialULRRCMessageTransferIEs_val_Value_0,
        _InitialULRRCMessageTransferIEs_val_Value_1,
        _InitialULRRCMessageTransferIEs_val_Value_2,
        _InitialULRRCMessageTransferIEs_val_Value_3,
        _InitialULRRCMessageTransferIEs_val_Value_4,
        _InitialULRRCMessageTransferIEs_val_Value_5,
        _InitialULRRCMessageTransferIEs_val_Value_6,
        _InitialULRRCMessageTransferIEs_val_Value_7,
        _InitialULRRCMessageTransferIEs_val_Value_8,
        _InitialULRRCMessageTransferIEs_val_Value_9,
        _InitialULRRCMessageTransferIEs_val_Value_10,
        _InitialULRRCMessageTransferIEs_val_Value_11,
        ____DLRRCMessageTransfer_protocolIEs__item__id_tab,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_2,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_3,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_4,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_5,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_6,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_7,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_8,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_9,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_10,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_11,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_12,
        _____DLRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_13,
        ___DLRRCMessageTransfer_protocolIEs__item__id,
        ___DLRRCMessageTransfer_protocolIEs__item__criticality,
        ___DLRRCMessageTransfer_protocolIEs__item__value,
        __DLRRCMessageTransfer_protocolIEs__item_,
        _DLRRCMessageTransfer_protocolIEs,
        DLRRCMessageTransfer,
        DLRRCMessageTransferIEs,
        _DLRRCMessageTransferIEs_val_Value_0,
        _DLRRCMessageTransferIEs_val_Value_1,
        _DLRRCMessageTransferIEs_val_Value_2,
        _DLRRCMessageTransferIEs_val_Value_3,
        _DLRRCMessageTransferIEs_val_Value_4,
        _DLRRCMessageTransferIEs_val_Value_5,
        _DLRRCMessageTransferIEs_val_Value_6,
        _DLRRCMessageTransferIEs_val_Value_7,
        _DLRRCMessageTransferIEs_val_Value_8,
        _DLRRCMessageTransferIEs_val_Value_9,
        _DLRRCMessageTransferIEs_val_Value_10,
        _DLRRCMessageTransferIEs_val_Value_11,
        _DLRRCMessageTransferIEs_val_Value_12,
        _DLRRCMessageTransferIEs_val_Value_13,
        ____ULRRCMessageTransfer_protocolIEs__item__id_tab,
        _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_2,
        _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_3,
        _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_4,
        _____ULRRCMessageTransfer_protocolIEs__item__id_tab_val_Value_5,
        ___ULRRCMessageTransfer_protocolIEs__item__id,
        ___ULRRCMessageTransfer_protocolIEs__item__criticality,
        ___ULRRCMessageTransfer_protocolIEs__item__value,
        __ULRRCMessageTransfer_protocolIEs__item_,
        _ULRRCMessageTransfer_protocolIEs,
        ULRRCMessageTransfer,
        ULRRCMessageTransferIEs,
        _ULRRCMessageTransferIEs_val_Value_0,
        _ULRRCMessageTransferIEs_val_Value_1,
        _ULRRCMessageTransferIEs_val_Value_2,
        _ULRRCMessageTransferIEs_val_Value_3,
        _ULRRCMessageTransferIEs_val_Value_4,
        _ULRRCMessageTransferIEs_val_Value_5,
        ____PrivateMessage_privateIEs__item__id_tab,
        ___PrivateMessage_privateIEs__item__id,
        ____PrivateMessage_privateIEs__item__criticality_tab,
        ___PrivateMessage_privateIEs__item__criticality,
        ____PrivateMessage_privateIEs__item__value_tab,
        ___PrivateMessage_privateIEs__item__value,
        __PrivateMessage_privateIEs__item_,
        _PrivateMessage_privateIEs,
        PrivateMessage,
        PrivateMessage_IEs,
        ____SystemInformationDeliveryCommand_protocolIEs__item__id_tab,
        _____SystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_0,
        _____SystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_1,
        _____SystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_2,
        _____SystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_3,
        ___SystemInformationDeliveryCommand_protocolIEs__item__id,
        ___SystemInformationDeliveryCommand_protocolIEs__item__criticality,
        ___SystemInformationDeliveryCommand_protocolIEs__item__value,
        __SystemInformationDeliveryCommand_protocolIEs__item_,
        _SystemInformationDeliveryCommand_protocolIEs,
        SystemInformationDeliveryCommand,
        SystemInformationDeliveryCommandIEs,
        _SystemInformationDeliveryCommandIEs_val_Value_0,
        _SystemInformationDeliveryCommandIEs_val_Value_1,
        _SystemInformationDeliveryCommandIEs_val_Value_2,
        _SystemInformationDeliveryCommandIEs_val_Value_3,
        ____Paging_protocolIEs__item__id_tab,
        _____Paging_protocolIEs__item__id_tab_val_Value_0,
        _____Paging_protocolIEs__item__id_tab_val_Value_1,
        _____Paging_protocolIEs__item__id_tab_val_Value_2,
        _____Paging_protocolIEs__item__id_tab_val_Value_3,
        _____Paging_protocolIEs__item__id_tab_val_Value_4,
        _____Paging_protocolIEs__item__id_tab_val_Value_5,
        _____Paging_protocolIEs__item__id_tab_val_Value_6,
        _____Paging_protocolIEs__item__id_tab_val_Value_7,
        _____Paging_protocolIEs__item__id_tab_val_Value_8,
        _____Paging_protocolIEs__item__id_tab_val_Value_9,
        _____Paging_protocolIEs__item__id_tab_val_Value_10,
        _____Paging_protocolIEs__item__id_tab_val_Value_11,
        _____Paging_protocolIEs__item__id_tab_val_Value_12,
        _____Paging_protocolIEs__item__id_tab_val_Value_13,
        ___Paging_protocolIEs__item__id,
        ___Paging_protocolIEs__item__criticality,
        ___Paging_protocolIEs__item__value,
        __Paging_protocolIEs__item_,
        _Paging_protocolIEs,
        Paging,
        PagingIEs,
        _PagingIEs_val_Value_0,
        _PagingIEs_val_Value_1,
        _PagingIEs_val_Value_2,
        _PagingIEs_val_Value_3,
        _PagingIEs_val_Value_4,
        _PagingIEs_val_Value_5,
        _PagingIEs_val_Value_6,
        _PagingIEs_val_Value_7,
        _PagingIEs_val_Value_8,
        _PagingIEs_val_Value_9,
        _PagingIEs_val_Value_10,
        _PagingIEs_val_Value_11,
        _PagingIEs_val_Value_12,
        _PagingIEs_val_Value_13,
        ___PagingCell_list__item__id_tab,
        ____PagingCell_list__item__id_tab_val_Value_0,
        __PagingCell_list__item__id,
        __PagingCell_list__item__criticality,
        __PagingCell_list__item__value,
        _PagingCell_list__item_,
        PagingCell_list,
        PagingCell_ItemIEs,
        _PagingCell_ItemIEs_val_Value_0,
        ____Notify_protocolIEs__item__id_tab,
        _____Notify_protocolIEs__item__id_tab_val_Value_0,
        _____Notify_protocolIEs__item__id_tab_val_Value_1,
        _____Notify_protocolIEs__item__id_tab_val_Value_2,
        ___Notify_protocolIEs__item__id,
        ___Notify_protocolIEs__item__criticality,
        ___Notify_protocolIEs__item__value,
        __Notify_protocolIEs__item_,
        _Notify_protocolIEs,
        Notify,
        NotifyIEs,
        _NotifyIEs_val_Value_0,
        _NotifyIEs_val_Value_1,
        _NotifyIEs_val_Value_2,
        ___DRB_Notify_List__item__id_tab,
        ____DRB_Notify_List__item__id_tab_val_Value_0,
        __DRB_Notify_List__item__id,
        __DRB_Notify_List__item__criticality,
        __DRB_Notify_List__item__value,
        _DRB_Notify_List__item_,
        DRB_Notify_List,
        DRB_Notify_ItemIEs,
        _DRB_Notify_ItemIEs_val_Value_0,
        ____NetworkAccessRateReduction_protocolIEs__item__id_tab,
        _____NetworkAccessRateReduction_protocolIEs__item__id_tab_val_Value_0,
        _____NetworkAccessRateReduction_protocolIEs__item__id_tab_val_Value_1,
        ___NetworkAccessRateReduction_protocolIEs__item__id,
        ___NetworkAccessRateReduction_protocolIEs__item__criticality,
        ___NetworkAccessRateReduction_protocolIEs__item__value,
        __NetworkAccessRateReduction_protocolIEs__item_,
        _NetworkAccessRateReduction_protocolIEs,
        NetworkAccessRateReduction,
        NetworkAccessRateReductionIEs,
        _NetworkAccessRateReductionIEs_val_Value_0,
        _NetworkAccessRateReductionIEs_val_Value_1,
        ____PWSRestartIndication_protocolIEs__item__id_tab,
        _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_0,
        _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_1,
        ___PWSRestartIndication_protocolIEs__item__id,
        ___PWSRestartIndication_protocolIEs__item__criticality,
        ___PWSRestartIndication_protocolIEs__item__value,
        __PWSRestartIndication_protocolIEs__item_,
        _PWSRestartIndication_protocolIEs,
        PWSRestartIndication,
        PWSRestartIndicationIEs,
        _PWSRestartIndicationIEs_val_Value_0,
        _PWSRestartIndicationIEs_val_Value_1,
        ___NR_CGI_List_For_Restart_List__item__id_tab,
        ____NR_CGI_List_For_Restart_List__item__id_tab_val_Value_0,
        __NR_CGI_List_For_Restart_List__item__id,
        __NR_CGI_List_For_Restart_List__item__criticality,
        __NR_CGI_List_For_Restart_List__item__value,
        _NR_CGI_List_For_Restart_List__item_,
        NR_CGI_List_For_Restart_List,
        NR_CGI_List_For_Restart_List_ItemIEs,
        _NR_CGI_List_For_Restart_List_ItemIEs_val_Value_0,
        ____PWSFailureIndication_protocolIEs__item__id_tab,
        _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        ___PWSFailureIndication_protocolIEs__item__id,
        ___PWSFailureIndication_protocolIEs__item__criticality,
        ___PWSFailureIndication_protocolIEs__item__value,
        __PWSFailureIndication_protocolIEs__item_,
        _PWSFailureIndication_protocolIEs,
        PWSFailureIndication,
        PWSFailureIndicationIEs,
        _PWSFailureIndicationIEs_val_Value_0,
        _PWSFailureIndicationIEs_val_Value_1,
        ___PWS_Failed_NR_CGI_List__item__id_tab,
        ____PWS_Failed_NR_CGI_List__item__id_tab_val_Value_0,
        __PWS_Failed_NR_CGI_List__item__id,
        __PWS_Failed_NR_CGI_List__item__criticality,
        __PWS_Failed_NR_CGI_List__item__value,
        _PWS_Failed_NR_CGI_List__item_,
        PWS_Failed_NR_CGI_List,
        PWS_Failed_NR_CGI_List_ItemIEs,
        _PWS_Failed_NR_CGI_List_ItemIEs_val_Value_0,
        ____GNBDUStatusIndication_protocolIEs__item__id_tab,
        _____GNBDUStatusIndication_protocolIEs__item__id_tab_val_Value_0,
        _____GNBDUStatusIndication_protocolIEs__item__id_tab_val_Value_1,
        _____GNBDUStatusIndication_protocolIEs__item__id_tab_val_Value_2,
        ___GNBDUStatusIndication_protocolIEs__item__id,
        ___GNBDUStatusIndication_protocolIEs__item__criticality,
        ___GNBDUStatusIndication_protocolIEs__item__value,
        __GNBDUStatusIndication_protocolIEs__item_,
        _GNBDUStatusIndication_protocolIEs,
        GNBDUStatusIndication,
        GNBDUStatusIndicationIEs,
        _GNBDUStatusIndicationIEs_val_Value_0,
        _GNBDUStatusIndicationIEs_val_Value_1,
        _GNBDUStatusIndicationIEs_val_Value_2,
        ____RRCDeliveryReport_protocolIEs__item__id_tab,
        _____RRCDeliveryReport_protocolIEs__item__id_tab_val_Value_0,
        _____RRCDeliveryReport_protocolIEs__item__id_tab_val_Value_1,
        _____RRCDeliveryReport_protocolIEs__item__id_tab_val_Value_2,
        _____RRCDeliveryReport_protocolIEs__item__id_tab_val_Value_3,
        ___RRCDeliveryReport_protocolIEs__item__id,
        ___RRCDeliveryReport_protocolIEs__item__criticality,
        ___RRCDeliveryReport_protocolIEs__item__value,
        __RRCDeliveryReport_protocolIEs__item_,
        _RRCDeliveryReport_protocolIEs,
        RRCDeliveryReport,
        RRCDeliveryReportIEs,
        _RRCDeliveryReportIEs_val_Value_0,
        _RRCDeliveryReportIEs_val_Value_1,
        _RRCDeliveryReportIEs_val_Value_2,
        _RRCDeliveryReportIEs_val_Value_3,
        ____F1RemovalRequest_protocolIEs__item__id_tab,
        _____F1RemovalRequest_protocolIEs__item__id_tab_val_Value_0,
        ___F1RemovalRequest_protocolIEs__item__id,
        ___F1RemovalRequest_protocolIEs__item__criticality,
        ___F1RemovalRequest_protocolIEs__item__value,
        __F1RemovalRequest_protocolIEs__item_,
        _F1RemovalRequest_protocolIEs,
        F1RemovalRequest,
        F1RemovalRequestIEs,
        _F1RemovalRequestIEs_val_Value_0,
        ____F1RemovalResponse_protocolIEs__item__id_tab,
        _____F1RemovalResponse_protocolIEs__item__id_tab_val_Value_0,
        _____F1RemovalResponse_protocolIEs__item__id_tab_val_Value_1,
        ___F1RemovalResponse_protocolIEs__item__id,
        ___F1RemovalResponse_protocolIEs__item__criticality,
        ___F1RemovalResponse_protocolIEs__item__value,
        __F1RemovalResponse_protocolIEs__item_,
        _F1RemovalResponse_protocolIEs,
        F1RemovalResponse,
        F1RemovalResponseIEs,
        _F1RemovalResponseIEs_val_Value_0,
        _F1RemovalResponseIEs_val_Value_1,
        ____F1RemovalFailure_protocolIEs__item__id_tab,
        _____F1RemovalFailure_protocolIEs__item__id_tab_val_Value_0,
        _____F1RemovalFailure_protocolIEs__item__id_tab_val_Value_1,
        _____F1RemovalFailure_protocolIEs__item__id_tab_val_Value_2,
        ___F1RemovalFailure_protocolIEs__item__id,
        ___F1RemovalFailure_protocolIEs__item__criticality,
        ___F1RemovalFailure_protocolIEs__item__value,
        __F1RemovalFailure_protocolIEs__item_,
        _F1RemovalFailure_protocolIEs,
        F1RemovalFailure,
        F1RemovalFailureIEs,
        _F1RemovalFailureIEs_val_Value_0,
        _F1RemovalFailureIEs_val_Value_1,
        _F1RemovalFailureIEs_val_Value_2,
        ____TraceStart_protocolIEs__item__id_tab,
        _____TraceStart_protocolIEs__item__id_tab_val_Value_0,
        _____TraceStart_protocolIEs__item__id_tab_val_Value_1,
        _____TraceStart_protocolIEs__item__id_tab_val_Value_2,
        ___TraceStart_protocolIEs__item__id,
        ___TraceStart_protocolIEs__item__criticality,
        ___TraceStart_protocolIEs__item__value,
        __TraceStart_protocolIEs__item_,
        _TraceStart_protocolIEs,
        TraceStart,
        TraceStartIEs,
        _TraceStartIEs_val_Value_0,
        _TraceStartIEs_val_Value_1,
        _TraceStartIEs_val_Value_2,
        ____DeactivateTrace_protocolIEs__item__id_tab,
        _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_0,
        _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_1,
        _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_2,
        ___DeactivateTrace_protocolIEs__item__id,
        ___DeactivateTrace_protocolIEs__item__criticality,
        ___DeactivateTrace_protocolIEs__item__value,
        __DeactivateTrace_protocolIEs__item_,
        _DeactivateTrace_protocolIEs,
        DeactivateTrace,
        DeactivateTraceIEs,
        _DeactivateTraceIEs_val_Value_0,
        _DeactivateTraceIEs_val_Value_1,
        _DeactivateTraceIEs_val_Value_2,
        ____CellTrafficTrace_protocolIEs__item__id_tab,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_0,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_1,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_2,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_3,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_4,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_5,
        ___CellTrafficTrace_protocolIEs__item__id,
        ___CellTrafficTrace_protocolIEs__item__criticality,
        ___CellTrafficTrace_protocolIEs__item__value,
        __CellTrafficTrace_protocolIEs__item_,
        _CellTrafficTrace_protocolIEs,
        CellTrafficTrace,
        CellTrafficTraceIEs,
        _CellTrafficTraceIEs_val_Value_0,
        _CellTrafficTraceIEs_val_Value_1,
        _CellTrafficTraceIEs_val_Value_2,
        _CellTrafficTraceIEs_val_Value_3,
        _CellTrafficTraceIEs_val_Value_4,
        _CellTrafficTraceIEs_val_Value_5,
        ____DUCURadioInformationTransfer_protocolIEs__item__id_tab,
        _____DUCURadioInformationTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____DUCURadioInformationTransfer_protocolIEs__item__id_tab_val_Value_1,
        ___DUCURadioInformationTransfer_protocolIEs__item__id,
        ___DUCURadioInformationTransfer_protocolIEs__item__criticality,
        ___DUCURadioInformationTransfer_protocolIEs__item__value,
        __DUCURadioInformationTransfer_protocolIEs__item_,
        _DUCURadioInformationTransfer_protocolIEs,
        DUCURadioInformationTransfer,
        DUCURadioInformationTransferIEs,
        _DUCURadioInformationTransferIEs_val_Value_0,
        _DUCURadioInformationTransferIEs_val_Value_1,
        ____CUDURadioInformationTransfer_protocolIEs__item__id_tab,
        _____CUDURadioInformationTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____CUDURadioInformationTransfer_protocolIEs__item__id_tab_val_Value_1,
        ___CUDURadioInformationTransfer_protocolIEs__item__id,
        ___CUDURadioInformationTransfer_protocolIEs__item__criticality,
        ___CUDURadioInformationTransfer_protocolIEs__item__value,
        __CUDURadioInformationTransfer_protocolIEs__item_,
        _CUDURadioInformationTransfer_protocolIEs,
        CUDURadioInformationTransfer,
        CUDURadioInformationTransferIEs,
        _CUDURadioInformationTransferIEs_val_Value_0,
        _CUDURadioInformationTransferIEs_val_Value_1,
        ____BAPMappingConfiguration_protocolIEs__item__id_tab,
        _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_0,
        _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_1,
        _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_2,
        _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_3,
        _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_4,
        _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_5,
        _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_6,
        _____BAPMappingConfiguration_protocolIEs__item__id_tab_val_Value_7,
        ___BAPMappingConfiguration_protocolIEs__item__id,
        ___BAPMappingConfiguration_protocolIEs__item__criticality,
        ___BAPMappingConfiguration_protocolIEs__item__value,
        __BAPMappingConfiguration_protocolIEs__item_,
        _BAPMappingConfiguration_protocolIEs,
        BAPMappingConfiguration,
        BAPMappingConfiguration_IEs,
        _BAPMappingConfiguration_IEs_val_Value_0,
        _BAPMappingConfiguration_IEs_val_Value_1,
        _BAPMappingConfiguration_IEs_val_Value_2,
        _BAPMappingConfiguration_IEs_val_Value_3,
        _BAPMappingConfiguration_IEs_val_Value_4,
        _BAPMappingConfiguration_IEs_val_Value_5,
        _BAPMappingConfiguration_IEs_val_Value_6,
        _BAPMappingConfiguration_IEs_val_Value_7,
        ___BH_Routing_Information_Added_List__item__id_tab,
        ____BH_Routing_Information_Added_List__item__id_tab_val_Value_0,
        __BH_Routing_Information_Added_List__item__id,
        __BH_Routing_Information_Added_List__item__criticality,
        __BH_Routing_Information_Added_List__item__value,
        _BH_Routing_Information_Added_List__item_,
        BH_Routing_Information_Added_List,
        ___BH_Routing_Information_Removed_List__item__id_tab,
        ____BH_Routing_Information_Removed_List__item__id_tab_val_Value_0,
        __BH_Routing_Information_Removed_List__item__id,
        __BH_Routing_Information_Removed_List__item__criticality,
        __BH_Routing_Information_Removed_List__item__value,
        _BH_Routing_Information_Removed_List__item_,
        BH_Routing_Information_Removed_List,
        BH_Routing_Information_Added_List_ItemIEs,
        _BH_Routing_Information_Added_List_ItemIEs_val_Value_0,
        BH_Routing_Information_Removed_List_ItemIEs,
        _BH_Routing_Information_Removed_List_ItemIEs_val_Value_0,
        ___BAP_Header_Rewriting_Added_List__item__id_tab,
        ____BAP_Header_Rewriting_Added_List__item__id_tab_val_Value_0,
        __BAP_Header_Rewriting_Added_List__item__id,
        __BAP_Header_Rewriting_Added_List__item__criticality,
        __BAP_Header_Rewriting_Added_List__item__value,
        _BAP_Header_Rewriting_Added_List__item_,
        BAP_Header_Rewriting_Added_List,
        BAP_Header_Rewriting_Added_List_ItemIEs,
        _BAP_Header_Rewriting_Added_List_ItemIEs_val_Value_0,
        ___BAP_Header_Rewriting_Removed_List__item__id_tab,
        ____BAP_Header_Rewriting_Removed_List__item__id_tab_val_Value_0,
        __BAP_Header_Rewriting_Removed_List__item__id,
        __BAP_Header_Rewriting_Removed_List__item__criticality,
        __BAP_Header_Rewriting_Removed_List__item__value,
        _BAP_Header_Rewriting_Removed_List__item_,
        BAP_Header_Rewriting_Removed_List,
        BAP_Header_Rewriting_Removed_List_ItemIEs,
        _BAP_Header_Rewriting_Removed_List_ItemIEs_val_Value_0,
        ____BAPMappingConfigurationAcknowledge_protocolIEs__item__id_tab,
        _____BAPMappingConfigurationAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____BAPMappingConfigurationAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        ___BAPMappingConfigurationAcknowledge_protocolIEs__item__id,
        ___BAPMappingConfigurationAcknowledge_protocolIEs__item__criticality,
        ___BAPMappingConfigurationAcknowledge_protocolIEs__item__value,
        __BAPMappingConfigurationAcknowledge_protocolIEs__item_,
        _BAPMappingConfigurationAcknowledge_protocolIEs,
        BAPMappingConfigurationAcknowledge,
        BAPMappingConfigurationAcknowledge_IEs,
        _BAPMappingConfigurationAcknowledge_IEs_val_Value_0,
        _BAPMappingConfigurationAcknowledge_IEs_val_Value_1,
        ____BAPMappingConfigurationFailure_protocolIEs__item__id_tab,
        _____BAPMappingConfigurationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____BAPMappingConfigurationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____BAPMappingConfigurationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____BAPMappingConfigurationFailure_protocolIEs__item__id_tab_val_Value_3,
        ___BAPMappingConfigurationFailure_protocolIEs__item__id,
        ___BAPMappingConfigurationFailure_protocolIEs__item__criticality,
        ___BAPMappingConfigurationFailure_protocolIEs__item__value,
        __BAPMappingConfigurationFailure_protocolIEs__item_,
        _BAPMappingConfigurationFailure_protocolIEs,
        BAPMappingConfigurationFailure,
        BAPMappingConfigurationFailureIEs,
        _BAPMappingConfigurationFailureIEs_val_Value_0,
        _BAPMappingConfigurationFailureIEs_val_Value_1,
        _BAPMappingConfigurationFailureIEs_val_Value_2,
        _BAPMappingConfigurationFailureIEs_val_Value_3,
        ____GNBDUResourceConfiguration_protocolIEs__item__id_tab,
        _____GNBDUResourceConfiguration_protocolIEs__item__id_tab_val_Value_0,
        _____GNBDUResourceConfiguration_protocolIEs__item__id_tab_val_Value_1,
        _____GNBDUResourceConfiguration_protocolIEs__item__id_tab_val_Value_2,
        _____GNBDUResourceConfiguration_protocolIEs__item__id_tab_val_Value_3,
        _____GNBDUResourceConfiguration_protocolIEs__item__id_tab_val_Value_4,
        ___GNBDUResourceConfiguration_protocolIEs__item__id,
        ___GNBDUResourceConfiguration_protocolIEs__item__criticality,
        ___GNBDUResourceConfiguration_protocolIEs__item__value,
        __GNBDUResourceConfiguration_protocolIEs__item_,
        _GNBDUResourceConfiguration_protocolIEs,
        GNBDUResourceConfiguration,
        GNBDUResourceConfigurationIEs,
        _GNBDUResourceConfigurationIEs_val_Value_0,
        _GNBDUResourceConfigurationIEs_val_Value_1,
        _GNBDUResourceConfigurationIEs_val_Value_2,
        _GNBDUResourceConfigurationIEs_val_Value_3,
        _GNBDUResourceConfigurationIEs_val_Value_4,
        ____GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id_tab,
        _____GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__id,
        ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__criticality,
        ___GNBDUResourceConfigurationAcknowledge_protocolIEs__item__value,
        __GNBDUResourceConfigurationAcknowledge_protocolIEs__item_,
        _GNBDUResourceConfigurationAcknowledge_protocolIEs,
        GNBDUResourceConfigurationAcknowledge,
        GNBDUResourceConfigurationAcknowledgeIEs,
        _GNBDUResourceConfigurationAcknowledgeIEs_val_Value_0,
        _GNBDUResourceConfigurationAcknowledgeIEs_val_Value_1,
        ____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab,
        _____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____GNBDUResourceConfigurationFailure_protocolIEs__item__id_tab_val_Value_3,
        ___GNBDUResourceConfigurationFailure_protocolIEs__item__id,
        ___GNBDUResourceConfigurationFailure_protocolIEs__item__criticality,
        ___GNBDUResourceConfigurationFailure_protocolIEs__item__value,
        __GNBDUResourceConfigurationFailure_protocolIEs__item_,
        _GNBDUResourceConfigurationFailure_protocolIEs,
        GNBDUResourceConfigurationFailure,
        GNBDUResourceConfigurationFailureIEs,
        _GNBDUResourceConfigurationFailureIEs_val_Value_0,
        _GNBDUResourceConfigurationFailureIEs_val_Value_1,
        _GNBDUResourceConfigurationFailureIEs_val_Value_2,
        _GNBDUResourceConfigurationFailureIEs_val_Value_3,
        ____IABTNLAddressRequest_protocolIEs__item__id_tab,
        _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_0,
        _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_1,
        _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_2,
        _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_3,
        _____IABTNLAddressRequest_protocolIEs__item__id_tab_val_Value_4,
        ___IABTNLAddressRequest_protocolIEs__item__id,
        ___IABTNLAddressRequest_protocolIEs__item__criticality,
        ___IABTNLAddressRequest_protocolIEs__item__value,
        __IABTNLAddressRequest_protocolIEs__item_,
        _IABTNLAddressRequest_protocolIEs,
        IABTNLAddressRequest,
        IABTNLAddressRequestIEs,
        _IABTNLAddressRequestIEs_val_Value_0,
        _IABTNLAddressRequestIEs_val_Value_1,
        _IABTNLAddressRequestIEs_val_Value_2,
        _IABTNLAddressRequestIEs_val_Value_3,
        _IABTNLAddressRequestIEs_val_Value_4,
        ___IAB_TNL_Addresses_To_Remove_List__item__id_tab,
        ____IAB_TNL_Addresses_To_Remove_List__item__id_tab_val_Value_0,
        __IAB_TNL_Addresses_To_Remove_List__item__id,
        __IAB_TNL_Addresses_To_Remove_List__item__criticality,
        __IAB_TNL_Addresses_To_Remove_List__item__value,
        _IAB_TNL_Addresses_To_Remove_List__item_,
        IAB_TNL_Addresses_To_Remove_List,
        IAB_TNL_Addresses_To_Remove_ItemIEs,
        _IAB_TNL_Addresses_To_Remove_ItemIEs_val_Value_0,
        ____IABTNLAddressResponse_protocolIEs__item__id_tab,
        _____IABTNLAddressResponse_protocolIEs__item__id_tab_val_Value_0,
        _____IABTNLAddressResponse_protocolIEs__item__id_tab_val_Value_1,
        ___IABTNLAddressResponse_protocolIEs__item__id,
        ___IABTNLAddressResponse_protocolIEs__item__criticality,
        ___IABTNLAddressResponse_protocolIEs__item__value,
        __IABTNLAddressResponse_protocolIEs__item_,
        _IABTNLAddressResponse_protocolIEs,
        IABTNLAddressResponse,
        IABTNLAddressResponseIEs,
        _IABTNLAddressResponseIEs_val_Value_0,
        _IABTNLAddressResponseIEs_val_Value_1,
        ___IAB_Allocated_TNL_Address_List__item__id_tab,
        ____IAB_Allocated_TNL_Address_List__item__id_tab_val_Value_0,
        __IAB_Allocated_TNL_Address_List__item__id,
        __IAB_Allocated_TNL_Address_List__item__criticality,
        __IAB_Allocated_TNL_Address_List__item__value,
        _IAB_Allocated_TNL_Address_List__item_,
        IAB_Allocated_TNL_Address_List,
        IAB_Allocated_TNL_Address_List_ItemIEs,
        _IAB_Allocated_TNL_Address_List_ItemIEs_val_Value_0,
        ____IABTNLAddressFailure_protocolIEs__item__id_tab,
        _____IABTNLAddressFailure_protocolIEs__item__id_tab_val_Value_0,
        _____IABTNLAddressFailure_protocolIEs__item__id_tab_val_Value_1,
        _____IABTNLAddressFailure_protocolIEs__item__id_tab_val_Value_2,
        _____IABTNLAddressFailure_protocolIEs__item__id_tab_val_Value_3,
        ___IABTNLAddressFailure_protocolIEs__item__id,
        ___IABTNLAddressFailure_protocolIEs__item__criticality,
        ___IABTNLAddressFailure_protocolIEs__item__value,
        __IABTNLAddressFailure_protocolIEs__item_,
        _IABTNLAddressFailure_protocolIEs,
        IABTNLAddressFailure,
        IABTNLAddressFailureIEs,
        _IABTNLAddressFailureIEs_val_Value_0,
        _IABTNLAddressFailureIEs_val_Value_1,
        _IABTNLAddressFailureIEs_val_Value_2,
        _IABTNLAddressFailureIEs_val_Value_3,
        ____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab,
        _____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab_val_Value_0,
        _____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab_val_Value_1,
        _____IABUPConfigurationUpdateRequest_protocolIEs__item__id_tab_val_Value_2,
        ___IABUPConfigurationUpdateRequest_protocolIEs__item__id,
        ___IABUPConfigurationUpdateRequest_protocolIEs__item__criticality,
        ___IABUPConfigurationUpdateRequest_protocolIEs__item__value,
        __IABUPConfigurationUpdateRequest_protocolIEs__item_,
        _IABUPConfigurationUpdateRequest_protocolIEs,
        IABUPConfigurationUpdateRequest,
        IABUPConfigurationUpdateRequestIEs,
        _IABUPConfigurationUpdateRequestIEs_val_Value_0,
        _IABUPConfigurationUpdateRequestIEs_val_Value_1,
        _IABUPConfigurationUpdateRequestIEs_val_Value_2,
        ___UL_UP_TNL_Information_to_Update_List__item__id_tab,
        ____UL_UP_TNL_Information_to_Update_List__item__id_tab_val_Value_0,
        __UL_UP_TNL_Information_to_Update_List__item__id,
        __UL_UP_TNL_Information_to_Update_List__item__criticality,
        __UL_UP_TNL_Information_to_Update_List__item__value,
        _UL_UP_TNL_Information_to_Update_List__item_,
        UL_UP_TNL_Information_to_Update_List,
        UL_UP_TNL_Information_to_Update_List_ItemIEs,
        _UL_UP_TNL_Information_to_Update_List_ItemIEs_val_Value_0,
        ___UL_UP_TNL_Address_to_Update_List__item__id_tab,
        ____UL_UP_TNL_Address_to_Update_List__item__id_tab_val_Value_0,
        __UL_UP_TNL_Address_to_Update_List__item__id,
        __UL_UP_TNL_Address_to_Update_List__item__criticality,
        __UL_UP_TNL_Address_to_Update_List__item__value,
        _UL_UP_TNL_Address_to_Update_List__item_,
        UL_UP_TNL_Address_to_Update_List,
        UL_UP_TNL_Address_to_Update_List_ItemIEs,
        _UL_UP_TNL_Address_to_Update_List_ItemIEs_val_Value_0,
        ____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab,
        _____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab_val_Value_0,
        _____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab_val_Value_1,
        _____IABUPConfigurationUpdateResponse_protocolIEs__item__id_tab_val_Value_2,
        ___IABUPConfigurationUpdateResponse_protocolIEs__item__id,
        ___IABUPConfigurationUpdateResponse_protocolIEs__item__criticality,
        ___IABUPConfigurationUpdateResponse_protocolIEs__item__value,
        __IABUPConfigurationUpdateResponse_protocolIEs__item_,
        _IABUPConfigurationUpdateResponse_protocolIEs,
        IABUPConfigurationUpdateResponse,
        IABUPConfigurationUpdateResponseIEs,
        _IABUPConfigurationUpdateResponseIEs_val_Value_0,
        _IABUPConfigurationUpdateResponseIEs_val_Value_1,
        _IABUPConfigurationUpdateResponseIEs_val_Value_2,
        ___DL_UP_TNL_Address_to_Update_List__item__id_tab,
        ____DL_UP_TNL_Address_to_Update_List__item__id_tab_val_Value_0,
        __DL_UP_TNL_Address_to_Update_List__item__id,
        __DL_UP_TNL_Address_to_Update_List__item__criticality,
        __DL_UP_TNL_Address_to_Update_List__item__value,
        _DL_UP_TNL_Address_to_Update_List__item_,
        DL_UP_TNL_Address_to_Update_List,
        DL_UP_TNL_Address_to_Update_List_ItemIEs,
        _DL_UP_TNL_Address_to_Update_List_ItemIEs_val_Value_0,
        ____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab,
        _____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        _____IABUPConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3,
        ___IABUPConfigurationUpdateFailure_protocolIEs__item__id,
        ___IABUPConfigurationUpdateFailure_protocolIEs__item__criticality,
        ___IABUPConfigurationUpdateFailure_protocolIEs__item__value,
        __IABUPConfigurationUpdateFailure_protocolIEs__item_,
        _IABUPConfigurationUpdateFailure_protocolIEs,
        IABUPConfigurationUpdateFailure,
        IABUPConfigurationUpdateFailureIEs,
        _IABUPConfigurationUpdateFailureIEs_val_Value_0,
        _IABUPConfigurationUpdateFailureIEs_val_Value_1,
        _IABUPConfigurationUpdateFailureIEs_val_Value_2,
        _IABUPConfigurationUpdateFailureIEs_val_Value_3,
        ____ResourceStatusRequest_protocolIEs__item__id_tab,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_0,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_1,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_2,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_3,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_4,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_5,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_6,
        ___ResourceStatusRequest_protocolIEs__item__id,
        ___ResourceStatusRequest_protocolIEs__item__criticality,
        ___ResourceStatusRequest_protocolIEs__item__value,
        __ResourceStatusRequest_protocolIEs__item_,
        _ResourceStatusRequest_protocolIEs,
        ResourceStatusRequest,
        ResourceStatusRequestIEs,
        _ResourceStatusRequestIEs_val_Value_0,
        _ResourceStatusRequestIEs_val_Value_1,
        _ResourceStatusRequestIEs_val_Value_2,
        _ResourceStatusRequestIEs_val_Value_3,
        _ResourceStatusRequestIEs_val_Value_4,
        _ResourceStatusRequestIEs_val_Value_5,
        _ResourceStatusRequestIEs_val_Value_6,
        ____ResourceStatusResponse_protocolIEs__item__id_tab,
        _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_0,
        _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_1,
        _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_2,
        _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_3,
        ___ResourceStatusResponse_protocolIEs__item__id,
        ___ResourceStatusResponse_protocolIEs__item__criticality,
        ___ResourceStatusResponse_protocolIEs__item__value,
        __ResourceStatusResponse_protocolIEs__item_,
        _ResourceStatusResponse_protocolIEs,
        ResourceStatusResponse,
        ResourceStatusResponseIEs,
        _ResourceStatusResponseIEs_val_Value_0,
        _ResourceStatusResponseIEs_val_Value_1,
        _ResourceStatusResponseIEs_val_Value_2,
        _ResourceStatusResponseIEs_val_Value_3,
        ____ResourceStatusFailure_protocolIEs__item__id_tab,
        _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_0,
        _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_1,
        _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_2,
        _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_3,
        _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_4,
        ___ResourceStatusFailure_protocolIEs__item__id,
        ___ResourceStatusFailure_protocolIEs__item__criticality,
        ___ResourceStatusFailure_protocolIEs__item__value,
        __ResourceStatusFailure_protocolIEs__item_,
        _ResourceStatusFailure_protocolIEs,
        ResourceStatusFailure,
        ResourceStatusFailureIEs,
        _ResourceStatusFailureIEs_val_Value_0,
        _ResourceStatusFailureIEs_val_Value_1,
        _ResourceStatusFailureIEs_val_Value_2,
        _ResourceStatusFailureIEs_val_Value_3,
        _ResourceStatusFailureIEs_val_Value_4,
        ____ResourceStatusUpdate_protocolIEs__item__id_tab,
        _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_3,
        _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_4,
        _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_5,
        ___ResourceStatusUpdate_protocolIEs__item__id,
        ___ResourceStatusUpdate_protocolIEs__item__criticality,
        ___ResourceStatusUpdate_protocolIEs__item__value,
        __ResourceStatusUpdate_protocolIEs__item_,
        _ResourceStatusUpdate_protocolIEs,
        ResourceStatusUpdate,
        ResourceStatusUpdateIEs,
        _ResourceStatusUpdateIEs_val_Value_0,
        _ResourceStatusUpdateIEs_val_Value_1,
        _ResourceStatusUpdateIEs_val_Value_2,
        _ResourceStatusUpdateIEs_val_Value_3,
        _ResourceStatusUpdateIEs_val_Value_4,
        _ResourceStatusUpdateIEs_val_Value_5,
        ____AccessAndMobilityIndication_protocolIEs__item__id_tab,
        _____AccessAndMobilityIndication_protocolIEs__item__id_tab_val_Value_0,
        _____AccessAndMobilityIndication_protocolIEs__item__id_tab_val_Value_1,
        _____AccessAndMobilityIndication_protocolIEs__item__id_tab_val_Value_2,
        _____AccessAndMobilityIndication_protocolIEs__item__id_tab_val_Value_3,
        ___AccessAndMobilityIndication_protocolIEs__item__id,
        ___AccessAndMobilityIndication_protocolIEs__item__criticality,
        ___AccessAndMobilityIndication_protocolIEs__item__value,
        __AccessAndMobilityIndication_protocolIEs__item_,
        _AccessAndMobilityIndication_protocolIEs,
        AccessAndMobilityIndication,
        AccessAndMobilityIndicationIEs,
        _AccessAndMobilityIndicationIEs_val_Value_0,
        _AccessAndMobilityIndicationIEs_val_Value_1,
        _AccessAndMobilityIndicationIEs_val_Value_2,
        _AccessAndMobilityIndicationIEs_val_Value_3,
        ____ReferenceTimeInformationReportingControl_protocolIEs__item__id_tab,
        _____ReferenceTimeInformationReportingControl_protocolIEs__item__id_tab_val_Value_0,
        _____ReferenceTimeInformationReportingControl_protocolIEs__item__id_tab_val_Value_1,
        ___ReferenceTimeInformationReportingControl_protocolIEs__item__id,
        ___ReferenceTimeInformationReportingControl_protocolIEs__item__criticality,
        ___ReferenceTimeInformationReportingControl_protocolIEs__item__value,
        __ReferenceTimeInformationReportingControl_protocolIEs__item_,
        _ReferenceTimeInformationReportingControl_protocolIEs,
        ReferenceTimeInformationReportingControl,
        ReferenceTimeInformationReportingControlIEs,
        _ReferenceTimeInformationReportingControlIEs_val_Value_0,
        _ReferenceTimeInformationReportingControlIEs_val_Value_1,
        ____ReferenceTimeInformationReport_protocolIEs__item__id_tab,
        _____ReferenceTimeInformationReport_protocolIEs__item__id_tab_val_Value_0,
        _____ReferenceTimeInformationReport_protocolIEs__item__id_tab_val_Value_1,
        ___ReferenceTimeInformationReport_protocolIEs__item__id,
        ___ReferenceTimeInformationReport_protocolIEs__item__criticality,
        ___ReferenceTimeInformationReport_protocolIEs__item__value,
        __ReferenceTimeInformationReport_protocolIEs__item_,
        _ReferenceTimeInformationReport_protocolIEs,
        ReferenceTimeInformationReport,
        ReferenceTimeInformationReportIEs,
        _ReferenceTimeInformationReportIEs_val_Value_0,
        _ReferenceTimeInformationReportIEs_val_Value_1,
        ____AccessSuccess_protocolIEs__item__id_tab,
        _____AccessSuccess_protocolIEs__item__id_tab_val_Value_0,
        _____AccessSuccess_protocolIEs__item__id_tab_val_Value_1,
        _____AccessSuccess_protocolIEs__item__id_tab_val_Value_2,
        ___AccessSuccess_protocolIEs__item__id,
        ___AccessSuccess_protocolIEs__item__criticality,
        ___AccessSuccess_protocolIEs__item__value,
        __AccessSuccess_protocolIEs__item_,
        _AccessSuccess_protocolIEs,
        AccessSuccess,
        AccessSuccessIEs,
        _AccessSuccessIEs_val_Value_0,
        _AccessSuccessIEs_val_Value_1,
        _AccessSuccessIEs_val_Value_2,
        ____PositioningAssistanceInformationControl_protocolIEs__item__id_tab,
        _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_3,
        _____PositioningAssistanceInformationControl_protocolIEs__item__id_tab_val_Value_4,
        ___PositioningAssistanceInformationControl_protocolIEs__item__id,
        ___PositioningAssistanceInformationControl_protocolIEs__item__criticality,
        ___PositioningAssistanceInformationControl_protocolIEs__item__value,
        __PositioningAssistanceInformationControl_protocolIEs__item_,
        _PositioningAssistanceInformationControl_protocolIEs,
        PositioningAssistanceInformationControl,
        PositioningAssistanceInformationControlIEs,
        _PositioningAssistanceInformationControlIEs_val_Value_0,
        _PositioningAssistanceInformationControlIEs_val_Value_1,
        _PositioningAssistanceInformationControlIEs_val_Value_2,
        _PositioningAssistanceInformationControlIEs_val_Value_3,
        _PositioningAssistanceInformationControlIEs_val_Value_4,
        ____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab,
        _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_3,
        _____PositioningAssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_4,
        ___PositioningAssistanceInformationFeedback_protocolIEs__item__id,
        ___PositioningAssistanceInformationFeedback_protocolIEs__item__criticality,
        ___PositioningAssistanceInformationFeedback_protocolIEs__item__value,
        __PositioningAssistanceInformationFeedback_protocolIEs__item_,
        _PositioningAssistanceInformationFeedback_protocolIEs,
        PositioningAssistanceInformationFeedback,
        PositioningAssistanceInformationFeedbackIEs,
        _PositioningAssistanceInformationFeedbackIEs_val_Value_0,
        _PositioningAssistanceInformationFeedbackIEs_val_Value_1,
        _PositioningAssistanceInformationFeedbackIEs_val_Value_2,
        _PositioningAssistanceInformationFeedbackIEs_val_Value_3,
        _PositioningAssistanceInformationFeedbackIEs_val_Value_4,
        ____PositioningMeasurementRequest_protocolIEs__item__id_tab,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_3,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_4,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_5,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_6,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_7,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_8,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_9,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_10,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_11,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_12,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_13,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_14,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_15,
        _____PositioningMeasurementRequest_protocolIEs__item__id_tab_val_Value_16,
        ___PositioningMeasurementRequest_protocolIEs__item__id,
        ___PositioningMeasurementRequest_protocolIEs__item__criticality,
        ___PositioningMeasurementRequest_protocolIEs__item__value,
        __PositioningMeasurementRequest_protocolIEs__item_,
        _PositioningMeasurementRequest_protocolIEs,
        PositioningMeasurementRequest,
        PositioningMeasurementRequestIEs,
        _PositioningMeasurementRequestIEs_val_Value_0,
        _PositioningMeasurementRequestIEs_val_Value_1,
        _PositioningMeasurementRequestIEs_val_Value_2,
        _PositioningMeasurementRequestIEs_val_Value_3,
        _PositioningMeasurementRequestIEs_val_Value_4,
        _PositioningMeasurementRequestIEs_val_Value_5,
        _PositioningMeasurementRequestIEs_val_Value_6,
        _PositioningMeasurementRequestIEs_val_Value_7,
        _PositioningMeasurementRequestIEs_val_Value_8,
        _PositioningMeasurementRequestIEs_val_Value_9,
        _PositioningMeasurementRequestIEs_val_Value_10,
        _PositioningMeasurementRequestIEs_val_Value_11,
        _PositioningMeasurementRequestIEs_val_Value_12,
        _PositioningMeasurementRequestIEs_val_Value_13,
        _PositioningMeasurementRequestIEs_val_Value_14,
        _PositioningMeasurementRequestIEs_val_Value_15,
        _PositioningMeasurementRequestIEs_val_Value_16,
        ____PositioningMeasurementResponse_protocolIEs__item__id_tab,
        _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_3,
        _____PositioningMeasurementResponse_protocolIEs__item__id_tab_val_Value_4,
        ___PositioningMeasurementResponse_protocolIEs__item__id,
        ___PositioningMeasurementResponse_protocolIEs__item__criticality,
        ___PositioningMeasurementResponse_protocolIEs__item__value,
        __PositioningMeasurementResponse_protocolIEs__item_,
        _PositioningMeasurementResponse_protocolIEs,
        PositioningMeasurementResponse,
        PositioningMeasurementResponseIEs,
        _PositioningMeasurementResponseIEs_val_Value_0,
        _PositioningMeasurementResponseIEs_val_Value_1,
        _PositioningMeasurementResponseIEs_val_Value_2,
        _PositioningMeasurementResponseIEs_val_Value_3,
        _PositioningMeasurementResponseIEs_val_Value_4,
        ____PositioningMeasurementFailure_protocolIEs__item__id_tab,
        _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_3,
        _____PositioningMeasurementFailure_protocolIEs__item__id_tab_val_Value_4,
        ___PositioningMeasurementFailure_protocolIEs__item__id,
        ___PositioningMeasurementFailure_protocolIEs__item__criticality,
        ___PositioningMeasurementFailure_protocolIEs__item__value,
        __PositioningMeasurementFailure_protocolIEs__item_,
        _PositioningMeasurementFailure_protocolIEs,
        PositioningMeasurementFailure,
        PositioningMeasurementFailureIEs,
        _PositioningMeasurementFailureIEs_val_Value_0,
        _PositioningMeasurementFailureIEs_val_Value_1,
        _PositioningMeasurementFailureIEs_val_Value_2,
        _PositioningMeasurementFailureIEs_val_Value_3,
        _PositioningMeasurementFailureIEs_val_Value_4,
        ____PositioningMeasurementReport_protocolIEs__item__id_tab,
        _____PositioningMeasurementReport_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningMeasurementReport_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningMeasurementReport_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningMeasurementReport_protocolIEs__item__id_tab_val_Value_3,
        ___PositioningMeasurementReport_protocolIEs__item__id,
        ___PositioningMeasurementReport_protocolIEs__item__criticality,
        ___PositioningMeasurementReport_protocolIEs__item__value,
        __PositioningMeasurementReport_protocolIEs__item_,
        _PositioningMeasurementReport_protocolIEs,
        PositioningMeasurementReport,
        PositioningMeasurementReportIEs,
        _PositioningMeasurementReportIEs_val_Value_0,
        _PositioningMeasurementReportIEs_val_Value_1,
        _PositioningMeasurementReportIEs_val_Value_2,
        _PositioningMeasurementReportIEs_val_Value_3,
        ____PositioningMeasurementAbort_protocolIEs__item__id_tab,
        _____PositioningMeasurementAbort_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningMeasurementAbort_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningMeasurementAbort_protocolIEs__item__id_tab_val_Value_2,
        ___PositioningMeasurementAbort_protocolIEs__item__id,
        ___PositioningMeasurementAbort_protocolIEs__item__criticality,
        ___PositioningMeasurementAbort_protocolIEs__item__value,
        __PositioningMeasurementAbort_protocolIEs__item_,
        _PositioningMeasurementAbort_protocolIEs,
        PositioningMeasurementAbort,
        PositioningMeasurementAbortIEs,
        _PositioningMeasurementAbortIEs_val_Value_0,
        _PositioningMeasurementAbortIEs_val_Value_1,
        _PositioningMeasurementAbortIEs_val_Value_2,
        ____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab,
        _____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_3,
        ___PositioningMeasurementFailureIndication_protocolIEs__item__id,
        ___PositioningMeasurementFailureIndication_protocolIEs__item__criticality,
        ___PositioningMeasurementFailureIndication_protocolIEs__item__value,
        __PositioningMeasurementFailureIndication_protocolIEs__item_,
        _PositioningMeasurementFailureIndication_protocolIEs,
        PositioningMeasurementFailureIndication,
        PositioningMeasurementFailureIndicationIEs,
        _PositioningMeasurementFailureIndicationIEs_val_Value_0,
        _PositioningMeasurementFailureIndicationIEs_val_Value_1,
        _PositioningMeasurementFailureIndicationIEs_val_Value_2,
        _PositioningMeasurementFailureIndicationIEs_val_Value_3,
        ____PositioningMeasurementUpdate_protocolIEs__item__id_tab,
        _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_3,
        _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_4,
        _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_5,
        _____PositioningMeasurementUpdate_protocolIEs__item__id_tab_val_Value_6,
        ___PositioningMeasurementUpdate_protocolIEs__item__id,
        ___PositioningMeasurementUpdate_protocolIEs__item__criticality,
        ___PositioningMeasurementUpdate_protocolIEs__item__value,
        __PositioningMeasurementUpdate_protocolIEs__item_,
        _PositioningMeasurementUpdate_protocolIEs,
        PositioningMeasurementUpdate,
        PositioningMeasurementUpdateIEs,
        _PositioningMeasurementUpdateIEs_val_Value_0,
        _PositioningMeasurementUpdateIEs_val_Value_1,
        _PositioningMeasurementUpdateIEs_val_Value_2,
        _PositioningMeasurementUpdateIEs_val_Value_3,
        _PositioningMeasurementUpdateIEs_val_Value_4,
        _PositioningMeasurementUpdateIEs_val_Value_5,
        _PositioningMeasurementUpdateIEs_val_Value_6,
        ____TRPInformationRequest_protocolIEs__item__id_tab,
        _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_2,
        ___TRPInformationRequest_protocolIEs__item__id,
        ___TRPInformationRequest_protocolIEs__item__criticality,
        ___TRPInformationRequest_protocolIEs__item__value,
        __TRPInformationRequest_protocolIEs__item_,
        _TRPInformationRequest_protocolIEs,
        TRPInformationRequest,
        TRPInformationRequestIEs,
        _TRPInformationRequestIEs_val_Value_0,
        _TRPInformationRequestIEs_val_Value_1,
        _TRPInformationRequestIEs_val_Value_2,
        ___TRPInformationTypeListTRPReq__item__id_tab,
        ____TRPInformationTypeListTRPReq__item__id_tab_val_Value_0,
        __TRPInformationTypeListTRPReq__item__id,
        __TRPInformationTypeListTRPReq__item__criticality,
        __TRPInformationTypeListTRPReq__item__value,
        _TRPInformationTypeListTRPReq__item_,
        TRPInformationTypeListTRPReq,
        TRPInformationTypeItemTRPReq,
        _TRPInformationTypeItemTRPReq_val_Value_0,
        ____TRPInformationResponse_protocolIEs__item__id_tab,
        _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_2,
        ___TRPInformationResponse_protocolIEs__item__id,
        ___TRPInformationResponse_protocolIEs__item__criticality,
        ___TRPInformationResponse_protocolIEs__item__value,
        __TRPInformationResponse_protocolIEs__item_,
        _TRPInformationResponse_protocolIEs,
        TRPInformationResponse,
        TRPInformationResponseIEs,
        _TRPInformationResponseIEs_val_Value_0,
        _TRPInformationResponseIEs_val_Value_1,
        _TRPInformationResponseIEs_val_Value_2,
        ___TRPInformationListTRPResp__item__id_tab,
        ____TRPInformationListTRPResp__item__id_tab_val_Value_0,
        __TRPInformationListTRPResp__item__id,
        __TRPInformationListTRPResp__item__criticality,
        __TRPInformationListTRPResp__item__value,
        _TRPInformationListTRPResp__item_,
        TRPInformationListTRPResp,
        TRPInformationItemTRPResp,
        _TRPInformationItemTRPResp_val_Value_0,
        ____TRPInformationFailure_protocolIEs__item__id_tab,
        _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_2,
        ___TRPInformationFailure_protocolIEs__item__id,
        ___TRPInformationFailure_protocolIEs__item__criticality,
        ___TRPInformationFailure_protocolIEs__item__value,
        __TRPInformationFailure_protocolIEs__item_,
        _TRPInformationFailure_protocolIEs,
        TRPInformationFailure,
        TRPInformationFailureIEs,
        _TRPInformationFailureIEs_val_Value_0,
        _TRPInformationFailureIEs_val_Value_1,
        _TRPInformationFailureIEs_val_Value_2,
        ____PositioningInformationRequest_protocolIEs__item__id_tab,
        _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_4,
        ___PositioningInformationRequest_protocolIEs__item__id,
        ___PositioningInformationRequest_protocolIEs__item__criticality,
        ___PositioningInformationRequest_protocolIEs__item__value,
        __PositioningInformationRequest_protocolIEs__item_,
        _PositioningInformationRequest_protocolIEs,
        PositioningInformationRequest,
        PositioningInformationRequestIEs,
        _PositioningInformationRequestIEs_val_Value_0,
        _PositioningInformationRequestIEs_val_Value_1,
        _PositioningInformationRequestIEs_val_Value_2,
        _PositioningInformationRequestIEs_val_Value_3,
        _PositioningInformationRequestIEs_val_Value_4,
        ____PositioningInformationResponse_protocolIEs__item__id_tab,
        _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_3,
        _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_4,
        _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_5,
        ___PositioningInformationResponse_protocolIEs__item__id,
        ___PositioningInformationResponse_protocolIEs__item__criticality,
        ___PositioningInformationResponse_protocolIEs__item__value,
        __PositioningInformationResponse_protocolIEs__item_,
        _PositioningInformationResponse_protocolIEs,
        PositioningInformationResponse,
        PositioningInformationResponseIEs,
        _PositioningInformationResponseIEs_val_Value_0,
        _PositioningInformationResponseIEs_val_Value_1,
        _PositioningInformationResponseIEs_val_Value_2,
        _PositioningInformationResponseIEs_val_Value_3,
        _PositioningInformationResponseIEs_val_Value_4,
        _PositioningInformationResponseIEs_val_Value_5,
        ____PositioningInformationFailure_protocolIEs__item__id_tab,
        _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_3,
        ___PositioningInformationFailure_protocolIEs__item__id,
        ___PositioningInformationFailure_protocolIEs__item__criticality,
        ___PositioningInformationFailure_protocolIEs__item__value,
        __PositioningInformationFailure_protocolIEs__item_,
        _PositioningInformationFailure_protocolIEs,
        PositioningInformationFailure,
        PositioningInformationFailureIEs,
        _PositioningInformationFailureIEs_val_Value_0,
        _PositioningInformationFailureIEs_val_Value_1,
        _PositioningInformationFailureIEs_val_Value_2,
        _PositioningInformationFailureIEs_val_Value_3,
        ____PositioningActivationRequest_protocolIEs__item__id_tab,
        _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_3,
        ___PositioningActivationRequest_protocolIEs__item__id,
        ___PositioningActivationRequest_protocolIEs__item__criticality,
        ___PositioningActivationRequest_protocolIEs__item__value,
        __PositioningActivationRequest_protocolIEs__item_,
        _PositioningActivationRequest_protocolIEs,
        PositioningActivationRequest,
        PositioningActivationRequestIEs,
        _PositioningActivationRequestIEs_val_Value_0,
        _PositioningActivationRequestIEs_val_Value_1,
        _PositioningActivationRequestIEs_val_Value_2,
        _PositioningActivationRequestIEs_val_Value_3,
        _SRSType_semipersistentSRS,
        _SRSType_aperiodicSRS,
        ___SRSType_choice_extension_id_tab,
        __SRSType_choice_extension_id,
        ___SRSType_choice_extension_criticality_tab,
        __SRSType_choice_extension_criticality,
        ___SRSType_choice_extension_value_tab,
        __SRSType_choice_extension_value,
        _SRSType_choice_extension,
        SRSType,
        SRSType_ExtIEs,
        _SemipersistentSRS_sRSResourceSetID,
        _SemipersistentSRS_sRSSpatialRelation,
        ____SemipersistentSRS_iE_Extensions__item__id_tab,
        _____SemipersistentSRS_iE_Extensions__item__id_tab_val_Extension_0,
        ___SemipersistentSRS_iE_Extensions__item__id,
        ___SemipersistentSRS_iE_Extensions__item__criticality,
        ___SemipersistentSRS_iE_Extensions__item__extensionValue,
        __SemipersistentSRS_iE_Extensions__item_,
        _SemipersistentSRS_iE_Extensions,
        SemipersistentSRS,
        SemipersistentSRS_ExtIEs,
        _SemipersistentSRS_ExtIEs_val_Extension_0,
        _AperiodicSRS_aperiodic,
        _AperiodicSRS_sRSResourceTrigger,
        ____AperiodicSRS_iE_Extensions__item__id_tab,
        ___AperiodicSRS_iE_Extensions__item__id,
        ____AperiodicSRS_iE_Extensions__item__criticality_tab,
        ___AperiodicSRS_iE_Extensions__item__criticality,
        ____AperiodicSRS_iE_Extensions__item__extensionValue_tab,
        ___AperiodicSRS_iE_Extensions__item__extensionValue,
        __AperiodicSRS_iE_Extensions__item_,
        _AperiodicSRS_iE_Extensions,
        AperiodicSRS,
        AperiodicSRS_ExtIEs,
        ____PositioningActivationResponse_protocolIEs__item__id_tab,
        _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_3,
        _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_4,
        ___PositioningActivationResponse_protocolIEs__item__id,
        ___PositioningActivationResponse_protocolIEs__item__criticality,
        ___PositioningActivationResponse_protocolIEs__item__value,
        __PositioningActivationResponse_protocolIEs__item_,
        _PositioningActivationResponse_protocolIEs,
        PositioningActivationResponse,
        PositioningActivationResponseIEs,
        _PositioningActivationResponseIEs_val_Value_0,
        _PositioningActivationResponseIEs_val_Value_1,
        _PositioningActivationResponseIEs_val_Value_2,
        _PositioningActivationResponseIEs_val_Value_3,
        _PositioningActivationResponseIEs_val_Value_4,
        ____PositioningActivationFailure_protocolIEs__item__id_tab,
        _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_3,
        ___PositioningActivationFailure_protocolIEs__item__id,
        ___PositioningActivationFailure_protocolIEs__item__criticality,
        ___PositioningActivationFailure_protocolIEs__item__value,
        __PositioningActivationFailure_protocolIEs__item_,
        _PositioningActivationFailure_protocolIEs,
        PositioningActivationFailure,
        PositioningActivationFailureIEs,
        _PositioningActivationFailureIEs_val_Value_0,
        _PositioningActivationFailureIEs_val_Value_1,
        _PositioningActivationFailureIEs_val_Value_2,
        _PositioningActivationFailureIEs_val_Value_3,
        ____PositioningDeactivation_protocolIEs__item__id_tab,
        _____PositioningDeactivation_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningDeactivation_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningDeactivation_protocolIEs__item__id_tab_val_Value_2,
        ___PositioningDeactivation_protocolIEs__item__id,
        ___PositioningDeactivation_protocolIEs__item__criticality,
        ___PositioningDeactivation_protocolIEs__item__value,
        __PositioningDeactivation_protocolIEs__item_,
        _PositioningDeactivation_protocolIEs,
        PositioningDeactivation,
        PositioningDeactivationIEs,
        _PositioningDeactivationIEs_val_Value_0,
        _PositioningDeactivationIEs_val_Value_1,
        _PositioningDeactivationIEs_val_Value_2,
        ____PositioningInformationUpdate_protocolIEs__item__id_tab,
        _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_3,
        ___PositioningInformationUpdate_protocolIEs__item__id,
        ___PositioningInformationUpdate_protocolIEs__item__criticality,
        ___PositioningInformationUpdate_protocolIEs__item__value,
        __PositioningInformationUpdate_protocolIEs__item_,
        _PositioningInformationUpdate_protocolIEs,
        PositioningInformationUpdate,
        PositioningInformationUpdateIEs,
        _PositioningInformationUpdateIEs_val_Value_0,
        _PositioningInformationUpdateIEs_val_Value_1,
        _PositioningInformationUpdateIEs_val_Value_2,
        _PositioningInformationUpdateIEs_val_Value_3,
        ____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_6,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_7,
        ___E_CIDMeasurementInitiationRequest_protocolIEs__item__id,
        ___E_CIDMeasurementInitiationRequest_protocolIEs__item__criticality,
        ___E_CIDMeasurementInitiationRequest_protocolIEs__item__value,
        __E_CIDMeasurementInitiationRequest_protocolIEs__item_,
        _E_CIDMeasurementInitiationRequest_protocolIEs,
        E_CIDMeasurementInitiationRequest,
        E_CIDMeasurementInitiationRequest_IEs,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_0,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_1,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_2,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_3,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_4,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_5,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_6,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_7,
        ____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_4,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_5,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_6,
        ___E_CIDMeasurementInitiationResponse_protocolIEs__item__id,
        ___E_CIDMeasurementInitiationResponse_protocolIEs__item__criticality,
        ___E_CIDMeasurementInitiationResponse_protocolIEs__item__value,
        __E_CIDMeasurementInitiationResponse_protocolIEs__item_,
        _E_CIDMeasurementInitiationResponse_protocolIEs,
        E_CIDMeasurementInitiationResponse,
        E_CIDMeasurementInitiationResponse_IEs,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_0,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_1,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_2,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_3,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_4,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_5,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_6,
        ____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab,
        _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_3,
        _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_4,
        _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_5,
        ___E_CIDMeasurementInitiationFailure_protocolIEs__item__id,
        ___E_CIDMeasurementInitiationFailure_protocolIEs__item__criticality,
        ___E_CIDMeasurementInitiationFailure_protocolIEs__item__value,
        __E_CIDMeasurementInitiationFailure_protocolIEs__item_,
        _E_CIDMeasurementInitiationFailure_protocolIEs,
        E_CIDMeasurementInitiationFailure,
        E_CIDMeasurementInitiationFailure_IEs,
        _E_CIDMeasurementInitiationFailure_IEs_val_Value_0,
        _E_CIDMeasurementInitiationFailure_IEs_val_Value_1,
        _E_CIDMeasurementInitiationFailure_IEs_val_Value_2,
        _E_CIDMeasurementInitiationFailure_IEs_val_Value_3,
        _E_CIDMeasurementInitiationFailure_IEs_val_Value_4,
        _E_CIDMeasurementInitiationFailure_IEs_val_Value_5,
        ____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab,
        _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2,
        _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_3,
        _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_4,
        ___E_CIDMeasurementFailureIndication_protocolIEs__item__id,
        ___E_CIDMeasurementFailureIndication_protocolIEs__item__criticality,
        ___E_CIDMeasurementFailureIndication_protocolIEs__item__value,
        __E_CIDMeasurementFailureIndication_protocolIEs__item_,
        _E_CIDMeasurementFailureIndication_protocolIEs,
        E_CIDMeasurementFailureIndication,
        E_CIDMeasurementFailureIndication_IEs,
        _E_CIDMeasurementFailureIndication_IEs_val_Value_0,
        _E_CIDMeasurementFailureIndication_IEs_val_Value_1,
        _E_CIDMeasurementFailureIndication_IEs_val_Value_2,
        _E_CIDMeasurementFailureIndication_IEs_val_Value_3,
        _E_CIDMeasurementFailureIndication_IEs_val_Value_4,
        ____E_CIDMeasurementReport_protocolIEs__item__id_tab,
        _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_0,
        _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_1,
        _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_2,
        _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_3,
        _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_4,
        _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_5,
        ___E_CIDMeasurementReport_protocolIEs__item__id,
        ___E_CIDMeasurementReport_protocolIEs__item__criticality,
        ___E_CIDMeasurementReport_protocolIEs__item__value,
        __E_CIDMeasurementReport_protocolIEs__item_,
        _E_CIDMeasurementReport_protocolIEs,
        E_CIDMeasurementReport,
        E_CIDMeasurementReport_IEs,
        _E_CIDMeasurementReport_IEs_val_Value_0,
        _E_CIDMeasurementReport_IEs_val_Value_1,
        _E_CIDMeasurementReport_IEs_val_Value_2,
        _E_CIDMeasurementReport_IEs_val_Value_3,
        _E_CIDMeasurementReport_IEs_val_Value_4,
        _E_CIDMeasurementReport_IEs_val_Value_5,
        ____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab,
        _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_0,
        _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_1,
        _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_2,
        _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_3,
        ___E_CIDMeasurementTerminationCommand_protocolIEs__item__id,
        ___E_CIDMeasurementTerminationCommand_protocolIEs__item__criticality,
        ___E_CIDMeasurementTerminationCommand_protocolIEs__item__value,
        __E_CIDMeasurementTerminationCommand_protocolIEs__item_,
        _E_CIDMeasurementTerminationCommand_protocolIEs,
        E_CIDMeasurementTerminationCommand,
        E_CIDMeasurementTerminationCommand_IEs,
        _E_CIDMeasurementTerminationCommand_IEs_val_Value_0,
        _E_CIDMeasurementTerminationCommand_IEs_val_Value_1,
        _E_CIDMeasurementTerminationCommand_IEs_val_Value_2,
        _E_CIDMeasurementTerminationCommand_IEs_val_Value_3,
        ____BroadcastContextSetupRequest_protocolIEs__item__id_tab,
        _____BroadcastContextSetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____BroadcastContextSetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____BroadcastContextSetupRequest_protocolIEs__item__id_tab_val_Value_2,
        _____BroadcastContextSetupRequest_protocolIEs__item__id_tab_val_Value_3,
        _____BroadcastContextSetupRequest_protocolIEs__item__id_tab_val_Value_4,
        _____BroadcastContextSetupRequest_protocolIEs__item__id_tab_val_Value_5,
        ___BroadcastContextSetupRequest_protocolIEs__item__id,
        ___BroadcastContextSetupRequest_protocolIEs__item__criticality,
        ___BroadcastContextSetupRequest_protocolIEs__item__value,
        __BroadcastContextSetupRequest_protocolIEs__item_,
        _BroadcastContextSetupRequest_protocolIEs,
        BroadcastContextSetupRequest,
        BroadcastContextSetupRequestIEs,
        _BroadcastContextSetupRequestIEs_val_Value_0,
        _BroadcastContextSetupRequestIEs_val_Value_1,
        _BroadcastContextSetupRequestIEs_val_Value_2,
        _BroadcastContextSetupRequestIEs_val_Value_3,
        _BroadcastContextSetupRequestIEs_val_Value_4,
        _BroadcastContextSetupRequestIEs_val_Value_5,
        ___BroadcastMRBs_ToBeSetup_List__item__id_tab,
        ____BroadcastMRBs_ToBeSetup_List__item__id_tab_val_Value_0,
        __BroadcastMRBs_ToBeSetup_List__item__id,
        __BroadcastMRBs_ToBeSetup_List__item__criticality,
        __BroadcastMRBs_ToBeSetup_List__item__value,
        _BroadcastMRBs_ToBeSetup_List__item_,
        BroadcastMRBs_ToBeSetup_List,
        BroadcastMRBs_ToBeSetup_ItemIEs,
        _BroadcastMRBs_ToBeSetup_ItemIEs_val_Value_0,
        ____BroadcastContextSetupResponse_protocolIEs__item__id_tab,
        _____BroadcastContextSetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____BroadcastContextSetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____BroadcastContextSetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____BroadcastContextSetupResponse_protocolIEs__item__id_tab_val_Value_3,
        _____BroadcastContextSetupResponse_protocolIEs__item__id_tab_val_Value_4,
        _____BroadcastContextSetupResponse_protocolIEs__item__id_tab_val_Value_5,
        ___BroadcastContextSetupResponse_protocolIEs__item__id,
        ___BroadcastContextSetupResponse_protocolIEs__item__criticality,
        ___BroadcastContextSetupResponse_protocolIEs__item__value,
        __BroadcastContextSetupResponse_protocolIEs__item_,
        _BroadcastContextSetupResponse_protocolIEs,
        BroadcastContextSetupResponse,
        BroadcastContextSetupResponseIEs,
        _BroadcastContextSetupResponseIEs_val_Value_0,
        _BroadcastContextSetupResponseIEs_val_Value_1,
        _BroadcastContextSetupResponseIEs_val_Value_2,
        _BroadcastContextSetupResponseIEs_val_Value_3,
        _BroadcastContextSetupResponseIEs_val_Value_4,
        _BroadcastContextSetupResponseIEs_val_Value_5,
        ___BroadcastMRBs_Setup_List__item__id_tab,
        ____BroadcastMRBs_Setup_List__item__id_tab_val_Value_0,
        __BroadcastMRBs_Setup_List__item__id,
        __BroadcastMRBs_Setup_List__item__criticality,
        __BroadcastMRBs_Setup_List__item__value,
        _BroadcastMRBs_Setup_List__item_,
        BroadcastMRBs_Setup_List,
        ___BroadcastMRBs_FailedToBeSetup_List__item__id_tab,
        ____BroadcastMRBs_FailedToBeSetup_List__item__id_tab_val_Value_0,
        __BroadcastMRBs_FailedToBeSetup_List__item__id,
        __BroadcastMRBs_FailedToBeSetup_List__item__criticality,
        __BroadcastMRBs_FailedToBeSetup_List__item__value,
        _BroadcastMRBs_FailedToBeSetup_List__item_,
        BroadcastMRBs_FailedToBeSetup_List,
        BroadcastMRBs_Setup_ItemIEs,
        _BroadcastMRBs_Setup_ItemIEs_val_Value_0,
        BroadcastMRBs_FailedToBeSetup_ItemIEs,
        _BroadcastMRBs_FailedToBeSetup_ItemIEs_val_Value_0,
        ____BroadcastContextSetupFailure_protocolIEs__item__id_tab,
        _____BroadcastContextSetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____BroadcastContextSetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____BroadcastContextSetupFailure_protocolIEs__item__id_tab_val_Value_2,
        _____BroadcastContextSetupFailure_protocolIEs__item__id_tab_val_Value_3,
        ___BroadcastContextSetupFailure_protocolIEs__item__id,
        ___BroadcastContextSetupFailure_protocolIEs__item__criticality,
        ___BroadcastContextSetupFailure_protocolIEs__item__value,
        __BroadcastContextSetupFailure_protocolIEs__item_,
        _BroadcastContextSetupFailure_protocolIEs,
        BroadcastContextSetupFailure,
        BroadcastContextSetupFailureIEs,
        _BroadcastContextSetupFailureIEs_val_Value_0,
        _BroadcastContextSetupFailureIEs_val_Value_1,
        _BroadcastContextSetupFailureIEs_val_Value_2,
        _BroadcastContextSetupFailureIEs_val_Value_3,
        ____BroadcastContextReleaseCommand_protocolIEs__item__id_tab,
        _____BroadcastContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0,
        _____BroadcastContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1,
        _____BroadcastContextReleaseCommand_protocolIEs__item__id_tab_val_Value_2,
        ___BroadcastContextReleaseCommand_protocolIEs__item__id,
        ___BroadcastContextReleaseCommand_protocolIEs__item__criticality,
        ___BroadcastContextReleaseCommand_protocolIEs__item__value,
        __BroadcastContextReleaseCommand_protocolIEs__item_,
        _BroadcastContextReleaseCommand_protocolIEs,
        BroadcastContextReleaseCommand,
        BroadcastContextReleaseCommandIEs,
        _BroadcastContextReleaseCommandIEs_val_Value_0,
        _BroadcastContextReleaseCommandIEs_val_Value_1,
        _BroadcastContextReleaseCommandIEs_val_Value_2,
        ____BroadcastContextReleaseComplete_protocolIEs__item__id_tab,
        _____BroadcastContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0,
        _____BroadcastContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1,
        _____BroadcastContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2,
        ___BroadcastContextReleaseComplete_protocolIEs__item__id,
        ___BroadcastContextReleaseComplete_protocolIEs__item__criticality,
        ___BroadcastContextReleaseComplete_protocolIEs__item__value,
        __BroadcastContextReleaseComplete_protocolIEs__item_,
        _BroadcastContextReleaseComplete_protocolIEs,
        BroadcastContextReleaseComplete,
        BroadcastContextReleaseCompleteIEs,
        _BroadcastContextReleaseCompleteIEs_val_Value_0,
        _BroadcastContextReleaseCompleteIEs_val_Value_1,
        _BroadcastContextReleaseCompleteIEs_val_Value_2,
        ____BroadcastContextReleaseRequest_protocolIEs__item__id_tab,
        _____BroadcastContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        _____BroadcastContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1,
        _____BroadcastContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2,
        ___BroadcastContextReleaseRequest_protocolIEs__item__id,
        ___BroadcastContextReleaseRequest_protocolIEs__item__criticality,
        ___BroadcastContextReleaseRequest_protocolIEs__item__value,
        __BroadcastContextReleaseRequest_protocolIEs__item_,
        _BroadcastContextReleaseRequest_protocolIEs,
        BroadcastContextReleaseRequest,
        BroadcastContextReleaseRequestIEs,
        _BroadcastContextReleaseRequestIEs_val_Value_0,
        _BroadcastContextReleaseRequestIEs_val_Value_1,
        _BroadcastContextReleaseRequestIEs_val_Value_2,
        ____BroadcastContextModificationRequest_protocolIEs__item__id_tab,
        _____BroadcastContextModificationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____BroadcastContextModificationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____BroadcastContextModificationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____BroadcastContextModificationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____BroadcastContextModificationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____BroadcastContextModificationRequest_protocolIEs__item__id_tab_val_Value_5,
        _____BroadcastContextModificationRequest_protocolIEs__item__id_tab_val_Value_6,
        ___BroadcastContextModificationRequest_protocolIEs__item__id,
        ___BroadcastContextModificationRequest_protocolIEs__item__criticality,
        ___BroadcastContextModificationRequest_protocolIEs__item__value,
        __BroadcastContextModificationRequest_protocolIEs__item_,
        _BroadcastContextModificationRequest_protocolIEs,
        BroadcastContextModificationRequest,
        BroadcastContextModificationRequestIEs,
        _BroadcastContextModificationRequestIEs_val_Value_0,
        _BroadcastContextModificationRequestIEs_val_Value_1,
        _BroadcastContextModificationRequestIEs_val_Value_2,
        _BroadcastContextModificationRequestIEs_val_Value_3,
        _BroadcastContextModificationRequestIEs_val_Value_4,
        _BroadcastContextModificationRequestIEs_val_Value_5,
        _BroadcastContextModificationRequestIEs_val_Value_6,
        ___BroadcastMRBs_ToBeSetupMod_List__item__id_tab,
        ____BroadcastMRBs_ToBeSetupMod_List__item__id_tab_val_Value_0,
        __BroadcastMRBs_ToBeSetupMod_List__item__id,
        __BroadcastMRBs_ToBeSetupMod_List__item__criticality,
        __BroadcastMRBs_ToBeSetupMod_List__item__value,
        _BroadcastMRBs_ToBeSetupMod_List__item_,
        BroadcastMRBs_ToBeSetupMod_List,
        ___BroadcastMRBs_ToBeModified_List__item__id_tab,
        ____BroadcastMRBs_ToBeModified_List__item__id_tab_val_Value_0,
        __BroadcastMRBs_ToBeModified_List__item__id,
        __BroadcastMRBs_ToBeModified_List__item__criticality,
        __BroadcastMRBs_ToBeModified_List__item__value,
        _BroadcastMRBs_ToBeModified_List__item_,
        BroadcastMRBs_ToBeModified_List,
        ___BroadcastMRBs_ToBeReleased_List__item__id_tab,
        ____BroadcastMRBs_ToBeReleased_List__item__id_tab_val_Value_0,
        __BroadcastMRBs_ToBeReleased_List__item__id,
        __BroadcastMRBs_ToBeReleased_List__item__criticality,
        __BroadcastMRBs_ToBeReleased_List__item__value,
        _BroadcastMRBs_ToBeReleased_List__item_,
        BroadcastMRBs_ToBeReleased_List,
        BroadcastMRBs_ToBeSetupMod_ItemIEs,
        _BroadcastMRBs_ToBeSetupMod_ItemIEs_val_Value_0,
        BroadcastMRBs_ToBeModified_ItemIEs,
        _BroadcastMRBs_ToBeModified_ItemIEs_val_Value_0,
        BroadcastMRBs_ToBeReleased_ItemIEs,
        _BroadcastMRBs_ToBeReleased_ItemIEs_val_Value_0,
        ____BroadcastContextModificationResponse_protocolIEs__item__id_tab,
        _____BroadcastContextModificationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____BroadcastContextModificationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____BroadcastContextModificationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____BroadcastContextModificationResponse_protocolIEs__item__id_tab_val_Value_3,
        _____BroadcastContextModificationResponse_protocolIEs__item__id_tab_val_Value_4,
        _____BroadcastContextModificationResponse_protocolIEs__item__id_tab_val_Value_5,
        _____BroadcastContextModificationResponse_protocolIEs__item__id_tab_val_Value_6,
        ___BroadcastContextModificationResponse_protocolIEs__item__id,
        ___BroadcastContextModificationResponse_protocolIEs__item__criticality,
        ___BroadcastContextModificationResponse_protocolIEs__item__value,
        __BroadcastContextModificationResponse_protocolIEs__item_,
        _BroadcastContextModificationResponse_protocolIEs,
        BroadcastContextModificationResponse,
        BroadcastContextModificationResponseIEs,
        _BroadcastContextModificationResponseIEs_val_Value_0,
        _BroadcastContextModificationResponseIEs_val_Value_1,
        _BroadcastContextModificationResponseIEs_val_Value_2,
        _BroadcastContextModificationResponseIEs_val_Value_3,
        _BroadcastContextModificationResponseIEs_val_Value_4,
        _BroadcastContextModificationResponseIEs_val_Value_5,
        _BroadcastContextModificationResponseIEs_val_Value_6,
        ___BroadcastMRBs_SetupMod_List__item__id_tab,
        ____BroadcastMRBs_SetupMod_List__item__id_tab_val_Value_0,
        __BroadcastMRBs_SetupMod_List__item__id,
        __BroadcastMRBs_SetupMod_List__item__criticality,
        __BroadcastMRBs_SetupMod_List__item__value,
        _BroadcastMRBs_SetupMod_List__item_,
        BroadcastMRBs_SetupMod_List,
        ___BroadcastMRBs_FailedToBeSetupMod_List__item__id_tab,
        ____BroadcastMRBs_FailedToBeSetupMod_List__item__id_tab_val_Value_0,
        __BroadcastMRBs_FailedToBeSetupMod_List__item__id,
        __BroadcastMRBs_FailedToBeSetupMod_List__item__criticality,
        __BroadcastMRBs_FailedToBeSetupMod_List__item__value,
        _BroadcastMRBs_FailedToBeSetupMod_List__item_,
        BroadcastMRBs_FailedToBeSetupMod_List,
        ___BroadcastMRBs_Modified_List__item__id_tab,
        ____BroadcastMRBs_Modified_List__item__id_tab_val_Value_0,
        __BroadcastMRBs_Modified_List__item__id,
        __BroadcastMRBs_Modified_List__item__criticality,
        __BroadcastMRBs_Modified_List__item__value,
        _BroadcastMRBs_Modified_List__item_,
        BroadcastMRBs_Modified_List,
        ___BroadcastMRBs_FailedToBeModified_List__item__id_tab,
        ____BroadcastMRBs_FailedToBeModified_List__item__id_tab_val_Value_0,
        __BroadcastMRBs_FailedToBeModified_List__item__id,
        __BroadcastMRBs_FailedToBeModified_List__item__criticality,
        __BroadcastMRBs_FailedToBeModified_List__item__value,
        _BroadcastMRBs_FailedToBeModified_List__item_,
        BroadcastMRBs_FailedToBeModified_List,
        BroadcastMRBs_SetupMod_ItemIEs,
        _BroadcastMRBs_SetupMod_ItemIEs_val_Value_0,
        BroadcastMRBs_FailedToBeSetupMod_ItemIEs,
        _BroadcastMRBs_FailedToBeSetupMod_ItemIEs_val_Value_0,
        BroadcastMRBs_Modified_ItemIEs,
        _BroadcastMRBs_Modified_ItemIEs_val_Value_0,
        BroadcastMRBs_FailedToBeModified_ItemIEs,
        _BroadcastMRBs_FailedToBeModified_ItemIEs_val_Value_0,
        ____BroadcastContextModificationFailure_protocolIEs__item__id_tab,
        _____BroadcastContextModificationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____BroadcastContextModificationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____BroadcastContextModificationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____BroadcastContextModificationFailure_protocolIEs__item__id_tab_val_Value_3,
        ___BroadcastContextModificationFailure_protocolIEs__item__id,
        ___BroadcastContextModificationFailure_protocolIEs__item__criticality,
        ___BroadcastContextModificationFailure_protocolIEs__item__value,
        __BroadcastContextModificationFailure_protocolIEs__item_,
        _BroadcastContextModificationFailure_protocolIEs,
        BroadcastContextModificationFailure,
        BroadcastContextModificationFailureIEs,
        _BroadcastContextModificationFailureIEs_val_Value_0,
        _BroadcastContextModificationFailureIEs_val_Value_1,
        _BroadcastContextModificationFailureIEs_val_Value_2,
        _BroadcastContextModificationFailureIEs_val_Value_3,
        ____MulticastGroupPaging_protocolIEs__item__id_tab,
        _____MulticastGroupPaging_protocolIEs__item__id_tab_val_Value_0,
        _____MulticastGroupPaging_protocolIEs__item__id_tab_val_Value_1,
        _____MulticastGroupPaging_protocolIEs__item__id_tab_val_Value_2,
        ___MulticastGroupPaging_protocolIEs__item__id,
        ___MulticastGroupPaging_protocolIEs__item__criticality,
        ___MulticastGroupPaging_protocolIEs__item__value,
        __MulticastGroupPaging_protocolIEs__item_,
        _MulticastGroupPaging_protocolIEs,
        MulticastGroupPaging,
        MulticastGroupPagingIEs,
        _MulticastGroupPagingIEs_val_Value_0,
        _MulticastGroupPagingIEs_val_Value_1,
        _MulticastGroupPagingIEs_val_Value_2,
        ___UEIdentity_List_For_Paging_List__item__id_tab,
        ____UEIdentity_List_For_Paging_List__item__id_tab_val_Value_0,
        __UEIdentity_List_For_Paging_List__item__id,
        __UEIdentity_List_For_Paging_List__item__criticality,
        __UEIdentity_List_For_Paging_List__item__value,
        _UEIdentity_List_For_Paging_List__item_,
        UEIdentity_List_For_Paging_List,
        UEIdentity_List_For_Paging_ItemIEs,
        _UEIdentity_List_For_Paging_ItemIEs_val_Value_0,
        ___MC_PagingCell_list__item__id_tab,
        ____MC_PagingCell_list__item__id_tab_val_Value_0,
        __MC_PagingCell_list__item__id,
        __MC_PagingCell_list__item__criticality,
        __MC_PagingCell_list__item__value,
        _MC_PagingCell_list__item_,
        MC_PagingCell_list,
        MC_PagingCell_ItemIEs,
        _MC_PagingCell_ItemIEs_val_Value_0,
        ____MulticastContextSetupRequest_protocolIEs__item__id_tab,
        _____MulticastContextSetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____MulticastContextSetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____MulticastContextSetupRequest_protocolIEs__item__id_tab_val_Value_2,
        _____MulticastContextSetupRequest_protocolIEs__item__id_tab_val_Value_3,
        _____MulticastContextSetupRequest_protocolIEs__item__id_tab_val_Value_4,
        ___MulticastContextSetupRequest_protocolIEs__item__id,
        ___MulticastContextSetupRequest_protocolIEs__item__criticality,
        ___MulticastContextSetupRequest_protocolIEs__item__value,
        __MulticastContextSetupRequest_protocolIEs__item_,
        _MulticastContextSetupRequest_protocolIEs,
        MulticastContextSetupRequest,
        MulticastContextSetupRequestIEs,
        _MulticastContextSetupRequestIEs_val_Value_0,
        _MulticastContextSetupRequestIEs_val_Value_1,
        _MulticastContextSetupRequestIEs_val_Value_2,
        _MulticastContextSetupRequestIEs_val_Value_3,
        _MulticastContextSetupRequestIEs_val_Value_4,
        ___MulticastMRBs_ToBeSetup_List__item__id_tab,
        ____MulticastMRBs_ToBeSetup_List__item__id_tab_val_Value_0,
        __MulticastMRBs_ToBeSetup_List__item__id,
        __MulticastMRBs_ToBeSetup_List__item__criticality,
        __MulticastMRBs_ToBeSetup_List__item__value,
        _MulticastMRBs_ToBeSetup_List__item_,
        MulticastMRBs_ToBeSetup_List,
        MulticastMRBs_ToBeSetup_ItemIEs,
        _MulticastMRBs_ToBeSetup_ItemIEs_val_Value_0,
        ____MulticastContextSetupResponse_protocolIEs__item__id_tab,
        _____MulticastContextSetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____MulticastContextSetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____MulticastContextSetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____MulticastContextSetupResponse_protocolIEs__item__id_tab_val_Value_3,
        _____MulticastContextSetupResponse_protocolIEs__item__id_tab_val_Value_4,
        ___MulticastContextSetupResponse_protocolIEs__item__id,
        ___MulticastContextSetupResponse_protocolIEs__item__criticality,
        ___MulticastContextSetupResponse_protocolIEs__item__value,
        __MulticastContextSetupResponse_protocolIEs__item_,
        _MulticastContextSetupResponse_protocolIEs,
        MulticastContextSetupResponse,
        MulticastContextSetupResponseIEs,
        _MulticastContextSetupResponseIEs_val_Value_0,
        _MulticastContextSetupResponseIEs_val_Value_1,
        _MulticastContextSetupResponseIEs_val_Value_2,
        _MulticastContextSetupResponseIEs_val_Value_3,
        _MulticastContextSetupResponseIEs_val_Value_4,
        ___MulticastMRBs_Setup_List__item__id_tab,
        ____MulticastMRBs_Setup_List__item__id_tab_val_Value_0,
        __MulticastMRBs_Setup_List__item__id,
        __MulticastMRBs_Setup_List__item__criticality,
        __MulticastMRBs_Setup_List__item__value,
        _MulticastMRBs_Setup_List__item_,
        MulticastMRBs_Setup_List,
        ___MulticastMRBs_FailedToBeSetup_List__item__id_tab,
        ____MulticastMRBs_FailedToBeSetup_List__item__id_tab_val_Value_0,
        __MulticastMRBs_FailedToBeSetup_List__item__id,
        __MulticastMRBs_FailedToBeSetup_List__item__criticality,
        __MulticastMRBs_FailedToBeSetup_List__item__value,
        _MulticastMRBs_FailedToBeSetup_List__item_,
        MulticastMRBs_FailedToBeSetup_List,
        MulticastMRBs_Setup_ItemIEs,
        _MulticastMRBs_Setup_ItemIEs_val_Value_0,
        MulticastMRBs_FailedToBeSetup_ItemIEs,
        _MulticastMRBs_FailedToBeSetup_ItemIEs_val_Value_0,
        ____MulticastContextSetupFailure_protocolIEs__item__id_tab,
        _____MulticastContextSetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____MulticastContextSetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____MulticastContextSetupFailure_protocolIEs__item__id_tab_val_Value_2,
        _____MulticastContextSetupFailure_protocolIEs__item__id_tab_val_Value_3,
        ___MulticastContextSetupFailure_protocolIEs__item__id,
        ___MulticastContextSetupFailure_protocolIEs__item__criticality,
        ___MulticastContextSetupFailure_protocolIEs__item__value,
        __MulticastContextSetupFailure_protocolIEs__item_,
        _MulticastContextSetupFailure_protocolIEs,
        MulticastContextSetupFailure,
        MulticastContextSetupFailureIEs,
        _MulticastContextSetupFailureIEs_val_Value_0,
        _MulticastContextSetupFailureIEs_val_Value_1,
        _MulticastContextSetupFailureIEs_val_Value_2,
        _MulticastContextSetupFailureIEs_val_Value_3,
        ____MulticastContextReleaseCommand_protocolIEs__item__id_tab,
        _____MulticastContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0,
        _____MulticastContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1,
        _____MulticastContextReleaseCommand_protocolIEs__item__id_tab_val_Value_2,
        ___MulticastContextReleaseCommand_protocolIEs__item__id,
        ___MulticastContextReleaseCommand_protocolIEs__item__criticality,
        ___MulticastContextReleaseCommand_protocolIEs__item__value,
        __MulticastContextReleaseCommand_protocolIEs__item_,
        _MulticastContextReleaseCommand_protocolIEs,
        MulticastContextReleaseCommand,
        MulticastContextReleaseCommandIEs,
        _MulticastContextReleaseCommandIEs_val_Value_0,
        _MulticastContextReleaseCommandIEs_val_Value_1,
        _MulticastContextReleaseCommandIEs_val_Value_2,
        ____MulticastContextReleaseComplete_protocolIEs__item__id_tab,
        _____MulticastContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0,
        _____MulticastContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1,
        _____MulticastContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2,
        ___MulticastContextReleaseComplete_protocolIEs__item__id,
        ___MulticastContextReleaseComplete_protocolIEs__item__criticality,
        ___MulticastContextReleaseComplete_protocolIEs__item__value,
        __MulticastContextReleaseComplete_protocolIEs__item_,
        _MulticastContextReleaseComplete_protocolIEs,
        MulticastContextReleaseComplete,
        MulticastContextReleaseCompleteIEs,
        _MulticastContextReleaseCompleteIEs_val_Value_0,
        _MulticastContextReleaseCompleteIEs_val_Value_1,
        _MulticastContextReleaseCompleteIEs_val_Value_2,
        ____MulticastContextReleaseRequest_protocolIEs__item__id_tab,
        _____MulticastContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        _____MulticastContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1,
        _____MulticastContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2,
        ___MulticastContextReleaseRequest_protocolIEs__item__id,
        ___MulticastContextReleaseRequest_protocolIEs__item__criticality,
        ___MulticastContextReleaseRequest_protocolIEs__item__value,
        __MulticastContextReleaseRequest_protocolIEs__item_,
        _MulticastContextReleaseRequest_protocolIEs,
        MulticastContextReleaseRequest,
        MulticastContextReleaseRequestIEs,
        _MulticastContextReleaseRequestIEs_val_Value_0,
        _MulticastContextReleaseRequestIEs_val_Value_1,
        _MulticastContextReleaseRequestIEs_val_Value_2,
        ____MulticastContextModificationRequest_protocolIEs__item__id_tab,
        _____MulticastContextModificationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____MulticastContextModificationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____MulticastContextModificationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____MulticastContextModificationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____MulticastContextModificationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____MulticastContextModificationRequest_protocolIEs__item__id_tab_val_Value_5,
        ___MulticastContextModificationRequest_protocolIEs__item__id,
        ___MulticastContextModificationRequest_protocolIEs__item__criticality,
        ___MulticastContextModificationRequest_protocolIEs__item__value,
        __MulticastContextModificationRequest_protocolIEs__item_,
        _MulticastContextModificationRequest_protocolIEs,
        MulticastContextModificationRequest,
        MulticastContextModificationRequestIEs,
        _MulticastContextModificationRequestIEs_val_Value_0,
        _MulticastContextModificationRequestIEs_val_Value_1,
        _MulticastContextModificationRequestIEs_val_Value_2,
        _MulticastContextModificationRequestIEs_val_Value_3,
        _MulticastContextModificationRequestIEs_val_Value_4,
        _MulticastContextModificationRequestIEs_val_Value_5,
        ___MulticastMRBs_ToBeSetupMod_List__item__id_tab,
        ____MulticastMRBs_ToBeSetupMod_List__item__id_tab_val_Value_0,
        __MulticastMRBs_ToBeSetupMod_List__item__id,
        __MulticastMRBs_ToBeSetupMod_List__item__criticality,
        __MulticastMRBs_ToBeSetupMod_List__item__value,
        _MulticastMRBs_ToBeSetupMod_List__item_,
        MulticastMRBs_ToBeSetupMod_List,
        MulticastMRBs_ToBeSetupMod_ItemIEs,
        _MulticastMRBs_ToBeSetupMod_ItemIEs_val_Value_0,
        ___MulticastMRBs_ToBeModified_List__item__id_tab,
        ____MulticastMRBs_ToBeModified_List__item__id_tab_val_Value_0,
        __MulticastMRBs_ToBeModified_List__item__id,
        __MulticastMRBs_ToBeModified_List__item__criticality,
        __MulticastMRBs_ToBeModified_List__item__value,
        _MulticastMRBs_ToBeModified_List__item_,
        MulticastMRBs_ToBeModified_List,
        MulticastMRBs_ToBeModified_ItemIEs,
        _MulticastMRBs_ToBeModified_ItemIEs_val_Value_0,
        ___MulticastMRBs_ToBeReleased_List__item__id_tab,
        ____MulticastMRBs_ToBeReleased_List__item__id_tab_val_Value_0,
        __MulticastMRBs_ToBeReleased_List__item__id,
        __MulticastMRBs_ToBeReleased_List__item__criticality,
        __MulticastMRBs_ToBeReleased_List__item__value,
        _MulticastMRBs_ToBeReleased_List__item_,
        MulticastMRBs_ToBeReleased_List,
        MulticastMRBs_ToBeReleased_ItemIEs,
        _MulticastMRBs_ToBeReleased_ItemIEs_val_Value_0,
        ____MulticastContextModificationResponse_protocolIEs__item__id_tab,
        _____MulticastContextModificationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____MulticastContextModificationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____MulticastContextModificationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____MulticastContextModificationResponse_protocolIEs__item__id_tab_val_Value_3,
        _____MulticastContextModificationResponse_protocolIEs__item__id_tab_val_Value_4,
        _____MulticastContextModificationResponse_protocolIEs__item__id_tab_val_Value_5,
        _____MulticastContextModificationResponse_protocolIEs__item__id_tab_val_Value_6,
        ___MulticastContextModificationResponse_protocolIEs__item__id,
        ___MulticastContextModificationResponse_protocolIEs__item__criticality,
        ___MulticastContextModificationResponse_protocolIEs__item__value,
        __MulticastContextModificationResponse_protocolIEs__item_,
        _MulticastContextModificationResponse_protocolIEs,
        MulticastContextModificationResponse,
        MulticastContextModificationResponseIEs,
        _MulticastContextModificationResponseIEs_val_Value_0,
        _MulticastContextModificationResponseIEs_val_Value_1,
        _MulticastContextModificationResponseIEs_val_Value_2,
        _MulticastContextModificationResponseIEs_val_Value_3,
        _MulticastContextModificationResponseIEs_val_Value_4,
        _MulticastContextModificationResponseIEs_val_Value_5,
        _MulticastContextModificationResponseIEs_val_Value_6,
        ___MulticastMRBs_SetupMod_List__item__id_tab,
        ____MulticastMRBs_SetupMod_List__item__id_tab_val_Value_0,
        __MulticastMRBs_SetupMod_List__item__id,
        __MulticastMRBs_SetupMod_List__item__criticality,
        __MulticastMRBs_SetupMod_List__item__value,
        _MulticastMRBs_SetupMod_List__item_,
        MulticastMRBs_SetupMod_List,
        MulticastMRBs_SetupMod_ItemIEs,
        _MulticastMRBs_SetupMod_ItemIEs_val_Value_0,
        ___MulticastMRBs_FailedToBeSetupMod_List__item__id_tab,
        ____MulticastMRBs_FailedToBeSetupMod_List__item__id_tab_val_Value_0,
        __MulticastMRBs_FailedToBeSetupMod_List__item__id,
        __MulticastMRBs_FailedToBeSetupMod_List__item__criticality,
        __MulticastMRBs_FailedToBeSetupMod_List__item__value,
        _MulticastMRBs_FailedToBeSetupMod_List__item_,
        MulticastMRBs_FailedToBeSetupMod_List,
        MulticastMRBs_FailedToBeSetupMod_ItemIEs,
        _MulticastMRBs_FailedToBeSetupMod_ItemIEs_val_Value_0,
        ___MulticastMRBs_Modified_List__item__id_tab,
        ____MulticastMRBs_Modified_List__item__id_tab_val_Value_0,
        __MulticastMRBs_Modified_List__item__id,
        __MulticastMRBs_Modified_List__item__criticality,
        __MulticastMRBs_Modified_List__item__value,
        _MulticastMRBs_Modified_List__item_,
        MulticastMRBs_Modified_List,
        MulticastMRBs_Modified_ItemIEs,
        _MulticastMRBs_Modified_ItemIEs_val_Value_0,
        ___MulticastMRBs_FailedToBeModified_List__item__id_tab,
        ____MulticastMRBs_FailedToBeModified_List__item__id_tab_val_Value_0,
        __MulticastMRBs_FailedToBeModified_List__item__id,
        __MulticastMRBs_FailedToBeModified_List__item__criticality,
        __MulticastMRBs_FailedToBeModified_List__item__value,
        _MulticastMRBs_FailedToBeModified_List__item_,
        MulticastMRBs_FailedToBeModified_List,
        MulticastMRBs_FailedToBeModified_ItemIEs,
        _MulticastMRBs_FailedToBeModified_ItemIEs_val_Value_0,
        ____MulticastContextModificationFailure_protocolIEs__item__id_tab,
        _____MulticastContextModificationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____MulticastContextModificationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____MulticastContextModificationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____MulticastContextModificationFailure_protocolIEs__item__id_tab_val_Value_3,
        ___MulticastContextModificationFailure_protocolIEs__item__id,
        ___MulticastContextModificationFailure_protocolIEs__item__criticality,
        ___MulticastContextModificationFailure_protocolIEs__item__value,
        __MulticastContextModificationFailure_protocolIEs__item_,
        _MulticastContextModificationFailure_protocolIEs,
        MulticastContextModificationFailure,
        MulticastContextModificationFailureIEs,
        _MulticastContextModificationFailureIEs_val_Value_0,
        _MulticastContextModificationFailureIEs_val_Value_1,
        _MulticastContextModificationFailureIEs_val_Value_2,
        _MulticastContextModificationFailureIEs_val_Value_3,
        ____MulticastDistributionSetupRequest_protocolIEs__item__id_tab,
        _____MulticastDistributionSetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____MulticastDistributionSetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____MulticastDistributionSetupRequest_protocolIEs__item__id_tab_val_Value_2,
        _____MulticastDistributionSetupRequest_protocolIEs__item__id_tab_val_Value_3,
        ___MulticastDistributionSetupRequest_protocolIEs__item__id,
        ___MulticastDistributionSetupRequest_protocolIEs__item__criticality,
        ___MulticastDistributionSetupRequest_protocolIEs__item__value,
        __MulticastDistributionSetupRequest_protocolIEs__item_,
        _MulticastDistributionSetupRequest_protocolIEs,
        MulticastDistributionSetupRequest,
        MulticastDistributionSetupRequestIEs,
        _MulticastDistributionSetupRequestIEs_val_Value_0,
        _MulticastDistributionSetupRequestIEs_val_Value_1,
        _MulticastDistributionSetupRequestIEs_val_Value_2,
        _MulticastDistributionSetupRequestIEs_val_Value_3,
        ___MulticastF1UContext_ToBeSetup_List__item__id_tab,
        ____MulticastF1UContext_ToBeSetup_List__item__id_tab_val_Value_0,
        __MulticastF1UContext_ToBeSetup_List__item__id,
        __MulticastF1UContext_ToBeSetup_List__item__criticality,
        __MulticastF1UContext_ToBeSetup_List__item__value,
        _MulticastF1UContext_ToBeSetup_List__item_,
        MulticastF1UContext_ToBeSetup_List,
        MulticastF1UContext_ToBeSetup_ItemIEs,
        _MulticastF1UContext_ToBeSetup_ItemIEs_val_Value_0,
        ____MulticastDistributionSetupResponse_protocolIEs__item__id_tab,
        _____MulticastDistributionSetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____MulticastDistributionSetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____MulticastDistributionSetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____MulticastDistributionSetupResponse_protocolIEs__item__id_tab_val_Value_3,
        _____MulticastDistributionSetupResponse_protocolIEs__item__id_tab_val_Value_4,
        _____MulticastDistributionSetupResponse_protocolIEs__item__id_tab_val_Value_5,
        _____MulticastDistributionSetupResponse_protocolIEs__item__id_tab_val_Value_6,
        ___MulticastDistributionSetupResponse_protocolIEs__item__id,
        ___MulticastDistributionSetupResponse_protocolIEs__item__criticality,
        ___MulticastDistributionSetupResponse_protocolIEs__item__value,
        __MulticastDistributionSetupResponse_protocolIEs__item_,
        _MulticastDistributionSetupResponse_protocolIEs,
        MulticastDistributionSetupResponse,
        MulticastDistributionSetupResponseIEs,
        _MulticastDistributionSetupResponseIEs_val_Value_0,
        _MulticastDistributionSetupResponseIEs_val_Value_1,
        _MulticastDistributionSetupResponseIEs_val_Value_2,
        _MulticastDistributionSetupResponseIEs_val_Value_3,
        _MulticastDistributionSetupResponseIEs_val_Value_4,
        _MulticastDistributionSetupResponseIEs_val_Value_5,
        _MulticastDistributionSetupResponseIEs_val_Value_6,
        ___MulticastF1UContext_Setup_List__item__id_tab,
        ____MulticastF1UContext_Setup_List__item__id_tab_val_Value_0,
        __MulticastF1UContext_Setup_List__item__id,
        __MulticastF1UContext_Setup_List__item__criticality,
        __MulticastF1UContext_Setup_List__item__value,
        _MulticastF1UContext_Setup_List__item_,
        MulticastF1UContext_Setup_List,
        MulticastF1UContext_Setup_ItemIEs,
        _MulticastF1UContext_Setup_ItemIEs_val_Value_0,
        ___MulticastF1UContext_FailedToBeSetup_List__item__id_tab,
        ____MulticastF1UContext_FailedToBeSetup_List__item__id_tab_val_Value_0,
        __MulticastF1UContext_FailedToBeSetup_List__item__id,
        __MulticastF1UContext_FailedToBeSetup_List__item__criticality,
        __MulticastF1UContext_FailedToBeSetup_List__item__value,
        _MulticastF1UContext_FailedToBeSetup_List__item_,
        MulticastF1UContext_FailedToBeSetup_List,
        MulticastF1UContext_FailedToBeSetup_ItemIEs,
        _MulticastF1UContext_FailedToBeSetup_ItemIEs_val_Value_0,
        ____MulticastDistributionSetupFailure_protocolIEs__item__id_tab,
        _____MulticastDistributionSetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____MulticastDistributionSetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____MulticastDistributionSetupFailure_protocolIEs__item__id_tab_val_Value_2,
        _____MulticastDistributionSetupFailure_protocolIEs__item__id_tab_val_Value_3,
        _____MulticastDistributionSetupFailure_protocolIEs__item__id_tab_val_Value_4,
        ___MulticastDistributionSetupFailure_protocolIEs__item__id,
        ___MulticastDistributionSetupFailure_protocolIEs__item__criticality,
        ___MulticastDistributionSetupFailure_protocolIEs__item__value,
        __MulticastDistributionSetupFailure_protocolIEs__item_,
        _MulticastDistributionSetupFailure_protocolIEs,
        MulticastDistributionSetupFailure,
        MulticastDistributionSetupFailureIEs,
        _MulticastDistributionSetupFailureIEs_val_Value_0,
        _MulticastDistributionSetupFailureIEs_val_Value_1,
        _MulticastDistributionSetupFailureIEs_val_Value_2,
        _MulticastDistributionSetupFailureIEs_val_Value_3,
        _MulticastDistributionSetupFailureIEs_val_Value_4,
        ____MulticastDistributionReleaseCommand_protocolIEs__item__id_tab,
        _____MulticastDistributionReleaseCommand_protocolIEs__item__id_tab_val_Value_0,
        _____MulticastDistributionReleaseCommand_protocolIEs__item__id_tab_val_Value_1,
        _____MulticastDistributionReleaseCommand_protocolIEs__item__id_tab_val_Value_2,
        _____MulticastDistributionReleaseCommand_protocolIEs__item__id_tab_val_Value_3,
        ___MulticastDistributionReleaseCommand_protocolIEs__item__id,
        ___MulticastDistributionReleaseCommand_protocolIEs__item__criticality,
        ___MulticastDistributionReleaseCommand_protocolIEs__item__value,
        __MulticastDistributionReleaseCommand_protocolIEs__item_,
        _MulticastDistributionReleaseCommand_protocolIEs,
        MulticastDistributionReleaseCommand,
        MulticastDistributionReleaseCommandIEs,
        _MulticastDistributionReleaseCommandIEs_val_Value_0,
        _MulticastDistributionReleaseCommandIEs_val_Value_1,
        _MulticastDistributionReleaseCommandIEs_val_Value_2,
        _MulticastDistributionReleaseCommandIEs_val_Value_3,
        ____MulticastDistributionReleaseComplete_protocolIEs__item__id_tab,
        _____MulticastDistributionReleaseComplete_protocolIEs__item__id_tab_val_Value_0,
        _____MulticastDistributionReleaseComplete_protocolIEs__item__id_tab_val_Value_1,
        _____MulticastDistributionReleaseComplete_protocolIEs__item__id_tab_val_Value_2,
        _____MulticastDistributionReleaseComplete_protocolIEs__item__id_tab_val_Value_3,
        ___MulticastDistributionReleaseComplete_protocolIEs__item__id,
        ___MulticastDistributionReleaseComplete_protocolIEs__item__criticality,
        ___MulticastDistributionReleaseComplete_protocolIEs__item__value,
        __MulticastDistributionReleaseComplete_protocolIEs__item_,
        _MulticastDistributionReleaseComplete_protocolIEs,
        MulticastDistributionReleaseComplete,
        MulticastDistributionReleaseCompleteIEs,
        _MulticastDistributionReleaseCompleteIEs_val_Value_0,
        _MulticastDistributionReleaseCompleteIEs_val_Value_1,
        _MulticastDistributionReleaseCompleteIEs_val_Value_2,
        _MulticastDistributionReleaseCompleteIEs_val_Value_3,
        ____PDCMeasurementInitiationRequest_protocolIEs__item__id_tab,
        _____PDCMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PDCMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____PDCMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____PDCMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____PDCMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____PDCMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5,
        ___PDCMeasurementInitiationRequest_protocolIEs__item__id,
        ___PDCMeasurementInitiationRequest_protocolIEs__item__criticality,
        ___PDCMeasurementInitiationRequest_protocolIEs__item__value,
        __PDCMeasurementInitiationRequest_protocolIEs__item_,
        _PDCMeasurementInitiationRequest_protocolIEs,
        PDCMeasurementInitiationRequest,
        PDCMeasurementInitiationRequest_IEs,
        _PDCMeasurementInitiationRequest_IEs_val_Value_0,
        _PDCMeasurementInitiationRequest_IEs_val_Value_1,
        _PDCMeasurementInitiationRequest_IEs_val_Value_2,
        _PDCMeasurementInitiationRequest_IEs_val_Value_3,
        _PDCMeasurementInitiationRequest_IEs_val_Value_4,
        _PDCMeasurementInitiationRequest_IEs_val_Value_5,
        ____PDCMeasurementInitiationResponse_protocolIEs__item__id_tab,
        _____PDCMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PDCMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____PDCMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____PDCMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3,
        _____PDCMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_4,
        ___PDCMeasurementInitiationResponse_protocolIEs__item__id,
        ___PDCMeasurementInitiationResponse_protocolIEs__item__criticality,
        ___PDCMeasurementInitiationResponse_protocolIEs__item__value,
        __PDCMeasurementInitiationResponse_protocolIEs__item_,
        _PDCMeasurementInitiationResponse_protocolIEs,
        PDCMeasurementInitiationResponse,
        PDCMeasurementInitiationResponse_IEs,
        _PDCMeasurementInitiationResponse_IEs_val_Value_0,
        _PDCMeasurementInitiationResponse_IEs_val_Value_1,
        _PDCMeasurementInitiationResponse_IEs_val_Value_2,
        _PDCMeasurementInitiationResponse_IEs_val_Value_3,
        _PDCMeasurementInitiationResponse_IEs_val_Value_4,
        ____PDCMeasurementInitiationFailure_protocolIEs__item__id_tab,
        _____PDCMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____PDCMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____PDCMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____PDCMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_3,
        _____PDCMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_4,
        ___PDCMeasurementInitiationFailure_protocolIEs__item__id,
        ___PDCMeasurementInitiationFailure_protocolIEs__item__criticality,
        ___PDCMeasurementInitiationFailure_protocolIEs__item__value,
        __PDCMeasurementInitiationFailure_protocolIEs__item_,
        _PDCMeasurementInitiationFailure_protocolIEs,
        PDCMeasurementInitiationFailure,
        PDCMeasurementInitiationFailure_IEs,
        _PDCMeasurementInitiationFailure_IEs_val_Value_0,
        _PDCMeasurementInitiationFailure_IEs_val_Value_1,
        _PDCMeasurementInitiationFailure_IEs_val_Value_2,
        _PDCMeasurementInitiationFailure_IEs_val_Value_3,
        _PDCMeasurementInitiationFailure_IEs_val_Value_4,
        ____PDCMeasurementReport_protocolIEs__item__id_tab,
        _____PDCMeasurementReport_protocolIEs__item__id_tab_val_Value_0,
        _____PDCMeasurementReport_protocolIEs__item__id_tab_val_Value_1,
        _____PDCMeasurementReport_protocolIEs__item__id_tab_val_Value_2,
        _____PDCMeasurementReport_protocolIEs__item__id_tab_val_Value_3,
        ___PDCMeasurementReport_protocolIEs__item__id,
        ___PDCMeasurementReport_protocolIEs__item__criticality,
        ___PDCMeasurementReport_protocolIEs__item__value,
        __PDCMeasurementReport_protocolIEs__item_,
        _PDCMeasurementReport_protocolIEs,
        PDCMeasurementReport,
        PDCMeasurementReport_IEs,
        _PDCMeasurementReport_IEs_val_Value_0,
        _PDCMeasurementReport_IEs_val_Value_1,
        _PDCMeasurementReport_IEs_val_Value_2,
        _PDCMeasurementReport_IEs_val_Value_3,
        ____PDCMeasurementTerminationCommand_protocolIEs__item__id_tab,
        _____PDCMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_0,
        _____PDCMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_1,
        _____PDCMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_2,
        ___PDCMeasurementTerminationCommand_protocolIEs__item__id,
        ___PDCMeasurementTerminationCommand_protocolIEs__item__criticality,
        ___PDCMeasurementTerminationCommand_protocolIEs__item__value,
        __PDCMeasurementTerminationCommand_protocolIEs__item_,
        _PDCMeasurementTerminationCommand_protocolIEs,
        PDCMeasurementTerminationCommand,
        PDCMeasurementTerminationCommand_IEs,
        _PDCMeasurementTerminationCommand_IEs_val_Value_0,
        _PDCMeasurementTerminationCommand_IEs_val_Value_1,
        _PDCMeasurementTerminationCommand_IEs_val_Value_2,
        ____PDCMeasurementFailureIndication_protocolIEs__item__id_tab,
        _____PDCMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____PDCMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        _____PDCMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2,
        _____PDCMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_3,
        ___PDCMeasurementFailureIndication_protocolIEs__item__id,
        ___PDCMeasurementFailureIndication_protocolIEs__item__criticality,
        ___PDCMeasurementFailureIndication_protocolIEs__item__value,
        __PDCMeasurementFailureIndication_protocolIEs__item_,
        _PDCMeasurementFailureIndication_protocolIEs,
        PDCMeasurementFailureIndication,
        PDCMeasurementFailureIndication_IEs,
        _PDCMeasurementFailureIndication_IEs_val_Value_0,
        _PDCMeasurementFailureIndication_IEs_val_Value_1,
        _PDCMeasurementFailureIndication_IEs_val_Value_2,
        _PDCMeasurementFailureIndication_IEs_val_Value_3,
        ____PRSConfigurationRequest_protocolIEs__item__id_tab,
        _____PRSConfigurationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PRSConfigurationRequest_protocolIEs__item__id_tab_val_Value_1,
        ___PRSConfigurationRequest_protocolIEs__item__id,
        ___PRSConfigurationRequest_protocolIEs__item__criticality,
        ___PRSConfigurationRequest_protocolIEs__item__value,
        __PRSConfigurationRequest_protocolIEs__item_,
        _PRSConfigurationRequest_protocolIEs,
        PRSConfigurationRequest,
        PRSConfigurationRequest_IEs,
        _PRSConfigurationRequest_IEs_val_Value_0,
        _PRSConfigurationRequest_IEs_val_Value_1,
        ____PRSConfigurationResponse_protocolIEs__item__id_tab,
        _____PRSConfigurationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PRSConfigurationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____PRSConfigurationResponse_protocolIEs__item__id_tab_val_Value_2,
        ___PRSConfigurationResponse_protocolIEs__item__id,
        ___PRSConfigurationResponse_protocolIEs__item__criticality,
        ___PRSConfigurationResponse_protocolIEs__item__value,
        __PRSConfigurationResponse_protocolIEs__item_,
        _PRSConfigurationResponse_protocolIEs,
        PRSConfigurationResponse,
        PRSConfigurationResponse_IEs,
        _PRSConfigurationResponse_IEs_val_Value_0,
        _PRSConfigurationResponse_IEs_val_Value_1,
        _PRSConfigurationResponse_IEs_val_Value_2,
        ____PRSConfigurationFailure_protocolIEs__item__id_tab,
        _____PRSConfigurationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____PRSConfigurationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____PRSConfigurationFailure_protocolIEs__item__id_tab_val_Value_2,
        ___PRSConfigurationFailure_protocolIEs__item__id,
        ___PRSConfigurationFailure_protocolIEs__item__criticality,
        ___PRSConfigurationFailure_protocolIEs__item__value,
        __PRSConfigurationFailure_protocolIEs__item_,
        _PRSConfigurationFailure_protocolIEs,
        PRSConfigurationFailure,
        PRSConfigurationFailure_IEs,
        _PRSConfigurationFailure_IEs_val_Value_0,
        _PRSConfigurationFailure_IEs_val_Value_1,
        _PRSConfigurationFailure_IEs_val_Value_2,
        ____MeasurementPreconfigurationRequired_protocolIEs__item__id_tab,
        _____MeasurementPreconfigurationRequired_protocolIEs__item__id_tab_val_Value_0,
        _____MeasurementPreconfigurationRequired_protocolIEs__item__id_tab_val_Value_1,
        _____MeasurementPreconfigurationRequired_protocolIEs__item__id_tab_val_Value_2,
        ___MeasurementPreconfigurationRequired_protocolIEs__item__id,
        ___MeasurementPreconfigurationRequired_protocolIEs__item__criticality,
        ___MeasurementPreconfigurationRequired_protocolIEs__item__value,
        __MeasurementPreconfigurationRequired_protocolIEs__item_,
        _MeasurementPreconfigurationRequired_protocolIEs,
        MeasurementPreconfigurationRequired,
        MeasurementPreconfigurationRequired_IEs,
        _MeasurementPreconfigurationRequired_IEs_val_Value_0,
        _MeasurementPreconfigurationRequired_IEs_val_Value_1,
        _MeasurementPreconfigurationRequired_IEs_val_Value_2,
        ____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab,
        _____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab_val_Value_0,
        _____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab_val_Value_1,
        _____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab_val_Value_2,
        _____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab_val_Value_3,
        ___MeasurementPreconfigurationConfirm_protocolIEs__item__id,
        ___MeasurementPreconfigurationConfirm_protocolIEs__item__criticality,
        ___MeasurementPreconfigurationConfirm_protocolIEs__item__value,
        __MeasurementPreconfigurationConfirm_protocolIEs__item_,
        _MeasurementPreconfigurationConfirm_protocolIEs,
        MeasurementPreconfigurationConfirm,
        MeasurementPreconfigurationConfirm_IEs,
        _MeasurementPreconfigurationConfirm_IEs_val_Value_0,
        _MeasurementPreconfigurationConfirm_IEs_val_Value_1,
        _MeasurementPreconfigurationConfirm_IEs_val_Value_2,
        _MeasurementPreconfigurationConfirm_IEs_val_Value_3,
        ____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab,
        _____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab_val_Value_0,
        _____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab_val_Value_1,
        _____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab_val_Value_2,
        _____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab_val_Value_3,
        ___MeasurementPreconfigurationRefuse_protocolIEs__item__id,
        ___MeasurementPreconfigurationRefuse_protocolIEs__item__criticality,
        ___MeasurementPreconfigurationRefuse_protocolIEs__item__value,
        __MeasurementPreconfigurationRefuse_protocolIEs__item_,
        _MeasurementPreconfigurationRefuse_protocolIEs,
        MeasurementPreconfigurationRefuse,
        MeasurementPreconfigurationRefuse_IEs,
        _MeasurementPreconfigurationRefuse_IEs_val_Value_0,
        _MeasurementPreconfigurationRefuse_IEs_val_Value_1,
        _MeasurementPreconfigurationRefuse_IEs_val_Value_2,
        _MeasurementPreconfigurationRefuse_IEs_val_Value_3,
        ____MeasurementActivation_protocolIEs__item__id_tab,
        _____MeasurementActivation_protocolIEs__item__id_tab_val_Value_0,
        _____MeasurementActivation_protocolIEs__item__id_tab_val_Value_1,
        _____MeasurementActivation_protocolIEs__item__id_tab_val_Value_2,
        _____MeasurementActivation_protocolIEs__item__id_tab_val_Value_3,
        ___MeasurementActivation_protocolIEs__item__id,
        ___MeasurementActivation_protocolIEs__item__criticality,
        ___MeasurementActivation_protocolIEs__item__value,
        __MeasurementActivation_protocolIEs__item_,
        _MeasurementActivation_protocolIEs,
        MeasurementActivation,
        MeasurementActivation_IEs,
        _MeasurementActivation_IEs_val_Value_0,
        _MeasurementActivation_IEs_val_Value_1,
        _MeasurementActivation_IEs_val_Value_2,
        _MeasurementActivation_IEs_val_Value_3,
        ____QoEInformationTransfer_protocolIEs__item__id_tab,
        _____QoEInformationTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____QoEInformationTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____QoEInformationTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___QoEInformationTransfer_protocolIEs__item__id,
        ___QoEInformationTransfer_protocolIEs__item__criticality,
        ___QoEInformationTransfer_protocolIEs__item__value,
        __QoEInformationTransfer_protocolIEs__item_,
        _QoEInformationTransfer_protocolIEs,
        QoEInformationTransfer,
        QoEInformationTransfer_IEs,
        _QoEInformationTransfer_IEs_val_Value_0,
        _QoEInformationTransfer_IEs_val_Value_1,
        _QoEInformationTransfer_IEs_val_Value_2,
        ____PosSystemInformationDeliveryCommand_protocolIEs__item__id_tab,
        _____PosSystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_0,
        _____PosSystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_1,
        _____PosSystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_2,
        _____PosSystemInformationDeliveryCommand_protocolIEs__item__id_tab_val_Value_3,
        ___PosSystemInformationDeliveryCommand_protocolIEs__item__id,
        ___PosSystemInformationDeliveryCommand_protocolIEs__item__criticality,
        ___PosSystemInformationDeliveryCommand_protocolIEs__item__value,
        __PosSystemInformationDeliveryCommand_protocolIEs__item_,
        _PosSystemInformationDeliveryCommand_protocolIEs,
        PosSystemInformationDeliveryCommand,
        PosSystemInformationDeliveryCommandIEs,
        _PosSystemInformationDeliveryCommandIEs_val_Value_0,
        _PosSystemInformationDeliveryCommandIEs_val_Value_1,
        _PosSystemInformationDeliveryCommandIEs_val_Value_2,
        _PosSystemInformationDeliveryCommandIEs_val_Value_3,
    ]

class F1AP_PDU_Descriptions:

    _name_  = 'F1AP-PDU-Descriptions'
    _oid_   = [0, 4, 0, 0, 22, 3, 3, 1, 0]
    
    _obj_ = [
        'F1AP-ELEMENTARY-PROCEDURE',
        'F1AP-PDU',
        'F1AP-PDU-ExtIEs',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        'F1AP-ELEMENTARY-PROCEDURES',
        'F1AP-ELEMENTARY-PROCEDURES-CLASS-1',
        'F1AP-ELEMENTARY-PROCEDURES-CLASS-2',
        'reset',
        'f1Setup',
        'gNBDUConfigurationUpdate',
        'gNBCUConfigurationUpdate',
        'uEContextSetup',
        'uEContextRelease',
        'uEContextModification',
        'uEContextModificationRequired',
        'writeReplaceWarning',
        'pWSCancel',
        'errorIndication',
        'uEContextReleaseRequest',
        'initialULRRCMessageTransfer',
        'dLRRCMessageTransfer',
        'uLRRCMessageTransfer',
        'uEInactivityNotification',
        'gNBDUResourceCoordination',
        'privateMessage',
        'systemInformationDelivery',
        'paging',
        'notify',
        'networkAccessRateReduction',
        'pWSRestartIndication',
        'pWSFailureIndication',
        'gNBDUStatusIndication',
        'rRCDeliveryReport',
        'f1Removal',
        'traceStart',
        'deactivateTrace',
        'dUCURadioInformationTransfer',
        'cUDURadioInformationTransfer',
        'bAPMappingConfiguration',
        'gNBDUResourceConfiguration',
        'iABTNLAddressAllocation',
        'iABUPConfigurationUpdate',
        'resourceStatusReportingInitiation',
        'resourceStatusReporting',
        'accessAndMobilityIndication',
        'referenceTimeInformationReportingControl',
        'referenceTimeInformationReport',
        'accessSuccess',
        'cellTrafficTrace',
        'positioningAssistanceInformationControl',
        'positioningAssistanceInformationFeedback',
        'positioningMeasurementExchange',
        'positioningMeasurementReport',
        'positioningMeasurementAbort',
        'positioningMeasurementFailureIndication',
        'positioningMeasurementUpdate',
        'tRPInformationExchange',
        'positioningInformationExchange',
        'positioningActivation',
        'positioningDeactivation',
        'e-CIDMeasurementInitiation',
        'e-CIDMeasurementFailureIndication',
        'e-CIDMeasurementReport',
        'e-CIDMeasurementTermination',
        'positioningInformationUpdate',
        'broadcastContextSetup',
        'broadcastContextRelease',
        'broadcastContextReleaseRequest',
        'broadcastContextModification',
        'multicastGroupPaging',
        'multicastContextSetup',
        'multicastContextRelease',
        'multicastContextReleaseRequest',
        'multicastContextModification',
        'multicastDistributionSetup',
        'multicastDistributionRelease',
        'pDCMeasurementInitiation',
        'pDCMeasurementReport',
        'pDCMeasurementTerminationCommand',
        'pDCMeasurementFailureIndication',
        'pRSConfigurationExchange',
        'measurementPreconfiguration',
        'measurementActivation',
        'qoEInformationTransfer',
        'posSystemInformationDelivery',
        ]
    _type_ = [
        'F1AP-ELEMENTARY-PROCEDURE',
        'F1AP-PDU',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        ]
    _set_ = [
        'F1AP-PDU-ExtIEs',
        'F1AP-ELEMENTARY-PROCEDURES',
        'F1AP-ELEMENTARY-PROCEDURES-CLASS-1',
        'F1AP-ELEMENTARY-PROCEDURES-CLASS-2',
        ]
    _val_ = [
        'reset',
        'f1Setup',
        'gNBDUConfigurationUpdate',
        'gNBCUConfigurationUpdate',
        'uEContextSetup',
        'uEContextRelease',
        'uEContextModification',
        'uEContextModificationRequired',
        'writeReplaceWarning',
        'pWSCancel',
        'errorIndication',
        'uEContextReleaseRequest',
        'initialULRRCMessageTransfer',
        'dLRRCMessageTransfer',
        'uLRRCMessageTransfer',
        'uEInactivityNotification',
        'gNBDUResourceCoordination',
        'privateMessage',
        'systemInformationDelivery',
        'paging',
        'notify',
        'networkAccessRateReduction',
        'pWSRestartIndication',
        'pWSFailureIndication',
        'gNBDUStatusIndication',
        'rRCDeliveryReport',
        'f1Removal',
        'traceStart',
        'deactivateTrace',
        'dUCURadioInformationTransfer',
        'cUDURadioInformationTransfer',
        'bAPMappingConfiguration',
        'gNBDUResourceConfiguration',
        'iABTNLAddressAllocation',
        'iABUPConfigurationUpdate',
        'resourceStatusReportingInitiation',
        'resourceStatusReporting',
        'accessAndMobilityIndication',
        'referenceTimeInformationReportingControl',
        'referenceTimeInformationReport',
        'accessSuccess',
        'cellTrafficTrace',
        'positioningAssistanceInformationControl',
        'positioningAssistanceInformationFeedback',
        'positioningMeasurementExchange',
        'positioningMeasurementReport',
        'positioningMeasurementAbort',
        'positioningMeasurementFailureIndication',
        'positioningMeasurementUpdate',
        'tRPInformationExchange',
        'positioningInformationExchange',
        'positioningActivation',
        'positioningDeactivation',
        'e-CIDMeasurementInitiation',
        'e-CIDMeasurementFailureIndication',
        'e-CIDMeasurementReport',
        'e-CIDMeasurementTermination',
        'positioningInformationUpdate',
        'broadcastContextSetup',
        'broadcastContextRelease',
        'broadcastContextReleaseRequest',
        'broadcastContextModification',
        'multicastGroupPaging',
        'multicastContextSetup',
        'multicastContextRelease',
        'multicastContextReleaseRequest',
        'multicastContextModification',
        'multicastDistributionSetup',
        'multicastDistributionRelease',
        'pDCMeasurementInitiation',
        'pDCMeasurementReport',
        'pDCMeasurementTerminationCommand',
        'pDCMeasurementFailureIndication',
        'pRSConfigurationExchange',
        'measurementPreconfiguration',
        'measurementActivation',
        'qoEInformationTransfer',
        'posSystemInformationDelivery',
        ]
    _class_ = [
        'F1AP-ELEMENTARY-PROCEDURE',
        'F1AP-PDU-ExtIEs',
        'F1AP-ELEMENTARY-PROCEDURES',
        'F1AP-ELEMENTARY-PROCEDURES-CLASS-1',
        'F1AP-ELEMENTARY-PROCEDURES-CLASS-2',
        'reset',
        'f1Setup',
        'gNBDUConfigurationUpdate',
        'gNBCUConfigurationUpdate',
        'uEContextSetup',
        'uEContextRelease',
        'uEContextModification',
        'uEContextModificationRequired',
        'writeReplaceWarning',
        'pWSCancel',
        'errorIndication',
        'uEContextReleaseRequest',
        'initialULRRCMessageTransfer',
        'dLRRCMessageTransfer',
        'uLRRCMessageTransfer',
        'uEInactivityNotification',
        'gNBDUResourceCoordination',
        'privateMessage',
        'systemInformationDelivery',
        'paging',
        'notify',
        'networkAccessRateReduction',
        'pWSRestartIndication',
        'pWSFailureIndication',
        'gNBDUStatusIndication',
        'rRCDeliveryReport',
        'f1Removal',
        'traceStart',
        'deactivateTrace',
        'dUCURadioInformationTransfer',
        'cUDURadioInformationTransfer',
        'bAPMappingConfiguration',
        'gNBDUResourceConfiguration',
        'iABTNLAddressAllocation',
        'iABUPConfigurationUpdate',
        'resourceStatusReportingInitiation',
        'resourceStatusReporting',
        'accessAndMobilityIndication',
        'referenceTimeInformationReportingControl',
        'referenceTimeInformationReport',
        'accessSuccess',
        'cellTrafficTrace',
        'positioningAssistanceInformationControl',
        'positioningAssistanceInformationFeedback',
        'positioningMeasurementExchange',
        'positioningMeasurementReport',
        'positioningMeasurementAbort',
        'positioningMeasurementFailureIndication',
        'positioningMeasurementUpdate',
        'tRPInformationExchange',
        'positioningInformationExchange',
        'positioningActivation',
        'positioningDeactivation',
        'e-CIDMeasurementInitiation',
        'e-CIDMeasurementFailureIndication',
        'e-CIDMeasurementReport',
        'e-CIDMeasurementTermination',
        'positioningInformationUpdate',
        'broadcastContextSetup',
        'broadcastContextRelease',
        'broadcastContextReleaseRequest',
        'broadcastContextModification',
        'multicastGroupPaging',
        'multicastContextSetup',
        'multicastContextRelease',
        'multicastContextReleaseRequest',
        'multicastContextModification',
        'multicastDistributionSetup',
        'multicastDistributionRelease',
        'pDCMeasurementInitiation',
        'pDCMeasurementReport',
        'pDCMeasurementTerminationCommand',
        'pDCMeasurementFailureIndication',
        'pRSConfigurationExchange',
        'measurementPreconfiguration',
        'measurementActivation',
        'qoEInformationTransfer',
        'posSystemInformationDelivery',
        ]
    _param_ = [
        ]
    
    #-----< F1AP-ELEMENTARY-PROCEDURE >-----#
    F1AP_ELEMENTARY_PROCEDURE = CLASS(name='F1AP-ELEMENTARY-PROCEDURE', mode=MODE_TYPE)
    _F1AP_ELEMENTARY_PROCEDURE_InitiatingMessage = OPEN(name='InitiatingMessage', mode=MODE_TYPE)
    _F1AP_ELEMENTARY_PROCEDURE_SuccessfulOutcome = OPEN(name='SuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _F1AP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome = OPEN(name='UnsuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _F1AP_ELEMENTARY_PROCEDURE_procedureCode = INT(name='procedureCode', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'ProcedureCode')), uniq=True)
    _F1AP_ELEMENTARY_PROCEDURE_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-CommonDataTypes', 'Criticality')), default='ignore')
    F1AP_ELEMENTARY_PROCEDURE._cont = ASN1Dict([
        ('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURE_InitiatingMessage),
        ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURE_SuccessfulOutcome),
        ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome),
        ('procedureCode', _F1AP_ELEMENTARY_PROCEDURE_procedureCode),
        ('criticality', _F1AP_ELEMENTARY_PROCEDURE_criticality),
        ])
    
    #-----< F1AP-PDU >-----#
    F1AP_PDU = CHOICE(name='F1AP-PDU', mode=MODE_TYPE)
    _F1AP_PDU_initiatingMessage = SEQ(name='initiatingMessage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'InitiatingMessage')))
    _F1AP_PDU_successfulOutcome = SEQ(name='successfulOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'SuccessfulOutcome')))
    _F1AP_PDU_unsuccessfulOutcome = SEQ(name='unsuccessfulOutcome', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'UnsuccessfulOutcome')))
    _F1AP_PDU_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('F1AP-Containers', 'ProtocolIE-SingleContainer')))
    __F1AP_PDU_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['id']))
    ___F1AP_PDU_choice_extension_id_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___F1AP_PDU_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __F1AP_PDU_choice_extension_id._const_tab = ___F1AP_PDU_choice_extension_id_tab
    __F1AP_PDU_choice_extension_id._const_tab_at = None
    __F1AP_PDU_choice_extension_id._const_tab_id = 'id'
    __F1AP_PDU_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['criticality']))
    ___F1AP_PDU_choice_extension_criticality_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___F1AP_PDU_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __F1AP_PDU_choice_extension_criticality._const_tab = ___F1AP_PDU_choice_extension_criticality_tab
    __F1AP_PDU_choice_extension_criticality._const_tab_at = ('..', 'id')
    __F1AP_PDU_choice_extension_criticality._const_tab_id = 'criticality'
    __F1AP_PDU_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-Containers', 'F1AP-PROTOCOL-IES'), ['Value']))
    ___F1AP_PDU_choice_extension_value_tab = CLASS(name='_tab_F1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    ___F1AP_PDU_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __F1AP_PDU_choice_extension_value._const_tab = ___F1AP_PDU_choice_extension_value_tab
    __F1AP_PDU_choice_extension_value._const_tab_at = ('..', 'id')
    __F1AP_PDU_choice_extension_value._const_tab_id = 'Value'
    _F1AP_PDU_choice_extension._cont = ASN1Dict([
        ('id', __F1AP_PDU_choice_extension_id),
        ('criticality', __F1AP_PDU_choice_extension_criticality),
        ('value', __F1AP_PDU_choice_extension_value),
        ])
    _F1AP_PDU_choice_extension._ext = None
    F1AP_PDU._cont = ASN1Dict([
        ('initiatingMessage', _F1AP_PDU_initiatingMessage),
        ('successfulOutcome', _F1AP_PDU_successfulOutcome),
        ('unsuccessfulOutcome', _F1AP_PDU_unsuccessfulOutcome),
        ('choice-extension', _F1AP_PDU_choice_extension),
        ])
    F1AP_PDU._ext = None
    
    #-----< F1AP-PDU-ExtIEs >-----#
    F1AP_PDU_ExtIEs = CLASS(name='F1AP-PDU-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('F1AP-Containers', 'F1AP-PROTOCOL-IES')))
    F1AP_PDU_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InitiatingMessage >-----#
    InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE)
    _InitiatingMessage_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __InitiatingMessage_procedureCode_tab = CLASS(name='_tab_F1AP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Reset')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResetAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdateAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdateAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseCommand')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseComplete')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRequired')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRefuse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'WriteReplaceWarningRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'WriteReplaceWarningResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSCancelRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSCancelResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceCoordinationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceCoordinationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfiguration')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfigurationAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfigurationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfiguration')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfigurationAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfigurationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_15 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_16 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_17 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_18 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_19 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_20 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_20 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_21 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_21 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextSetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_22 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextSetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_22 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextSetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextReleaseCommand')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_23 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextReleaseComplete')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextModificationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_24 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextModificationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_24 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextModificationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextSetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_25 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextSetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_25 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextSetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextReleaseCommand')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_26 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextReleaseComplete')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextModificationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_27 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextModificationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_27 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextModificationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionSetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_28 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionSetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_28 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionSetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionReleaseCommand')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_29 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionReleaseComplete')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementInitiationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_30 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementInitiationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_30 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementInitiationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PRSConfigurationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_31 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PRSConfigurationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_31 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PRSConfigurationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MeasurementPreconfigurationRequired')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_32 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MeasurementPreconfigurationConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_32 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MeasurementPreconfigurationRefuse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ErrorIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DLRRCMessageTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ULRRCMessageTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEInactivityNotification')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PrivateMessage')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'InitialULRRCMessageTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SystemInformationDeliveryCommand')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Paging')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Notify')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSRestartIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSFailureIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUStatusIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'RRCDeliveryReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'NetworkAccessRateReduction')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TraceStart')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_49 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DeactivateTrace')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_50 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DUCURadioInformationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_51 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'CUDURadioInformationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_52 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_53 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'AccessAndMobilityIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_54 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ReferenceTimeInformationReportingControl')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_55 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ReferenceTimeInformationReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_56 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'AccessSuccess')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_57 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'CellTrafficTrace')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_58 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningAssistanceInformationControl')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_59 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningAssistanceInformationFeedback')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_60 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_61 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementAbort')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_62 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementFailureIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_63 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_64 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningDeactivation')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_65 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementFailureIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_66 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_67 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementTerminationCommand')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_68 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_69 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastGroupPaging')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_70 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextReleaseRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_71 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextReleaseRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_72 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_73 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementTerminationCommand')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_74 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementFailureIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_75 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MeasurementActivation')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_76 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'QoEInformationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_77 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PosSystemInformationDeliveryCommand')))
    __InitiatingMessage_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0), ('procedureCode', 0), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7), ('procedureCode', 8), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8), ('procedureCode', 20), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9), ('procedureCode', 21), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10), ('procedureCode', 16), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_11), ('procedureCode', 26), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_12), ('procedureCode', 32), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_13), ('procedureCode', 33), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_14), ('procedureCode', 34), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_15), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_15), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_16), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_16), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_17), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_17), ('procedureCode', 41), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_18), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_18), ('procedureCode', 48), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_19), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_19), ('procedureCode', 49), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_20), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_20), ('procedureCode', 50), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_21), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_21), ('procedureCode', 52), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_22), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_22), ('procedureCode', 59), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_23), ('procedureCode', 60), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_24), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_24), ('procedureCode', 62), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_25), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_25), ('procedureCode', 64), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_26), ('procedureCode', 65), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_27), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_27), ('procedureCode', 67), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_28), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_28), ('procedureCode', 68), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_29), ('procedureCode', 69), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_30), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_30), ('procedureCode', 70), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_31), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_31), ('procedureCode', 75), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_32), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_32), ('procedureCode', 76), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40), ('procedureCode', 17), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43), ('procedureCode', 22), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44), ('procedureCode', 23), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45), ('procedureCode', 24), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46), ('procedureCode', 25), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47), ('procedureCode', 27), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48), ('procedureCode', 28), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_49), ('procedureCode', 29), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_50), ('procedureCode', 30), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_51), ('procedureCode', 31), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_52), ('procedureCode', 37), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_53), ('procedureCode', 38), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_54), ('procedureCode', 58), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_55), ('procedureCode', 57), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_56), ('procedureCode', 39), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_57), ('procedureCode', 40), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_58), ('procedureCode', 42), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_59), ('procedureCode', 43), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_60), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_61), ('procedureCode', 45), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_62), ('procedureCode', 46), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_63), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_64), ('procedureCode', 51), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_65), ('procedureCode', 53), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_66), ('procedureCode', 54), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_67), ('procedureCode', 55), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_68), ('procedureCode', 56), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_69), ('procedureCode', 63), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_70), ('procedureCode', 61), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_71), ('procedureCode', 66), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_72), ('procedureCode', 71), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_73), ('procedureCode', 79), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_74), ('procedureCode', 80), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_75), ('procedureCode', 77), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_76), ('procedureCode', 78), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_77), ('procedureCode', 81), ('criticality', 'ignore')])], rr=[], ev=None, er=[])
    _InitiatingMessage_procedureCode._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_procedureCode._const_tab_at = None
    _InitiatingMessage_procedureCode._const_tab_id = 'procedureCode'
    _InitiatingMessage_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _InitiatingMessage_criticality._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_criticality._const_tab_at = ('..', 'procedureCode')
    _InitiatingMessage_criticality._const_tab_id = 'criticality'
    _InitiatingMessage_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE'), ['InitiatingMessage']))
    _InitiatingMessage_value._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_value._const_tab_at = ('..', 'procedureCode')
    _InitiatingMessage_value._const_tab_id = 'InitiatingMessage'
    InitiatingMessage._cont = ASN1Dict([
        ('procedureCode', _InitiatingMessage_procedureCode),
        ('criticality', _InitiatingMessage_criticality),
        ('value', _InitiatingMessage_value),
        ])
    InitiatingMessage._ext = None
    
    #-----< SuccessfulOutcome >-----#
    SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE)
    _SuccessfulOutcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __SuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_F1AP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Reset')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResetAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdateAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdateAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseComplete')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRefuse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'WriteReplaceWarningRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'WriteReplaceWarningResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSCancelRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSCancelResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceCoordinationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceCoordinationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfiguration')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfigurationAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfigurationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfiguration')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfigurationAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfigurationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_15 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_17 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_18 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_19 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_20 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_21 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_21 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextSetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_22 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextSetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_22 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextSetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextReleaseCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_23 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextReleaseComplete')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextModificationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_24 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextModificationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_24 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextModificationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextSetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_25 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextSetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_25 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextSetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextReleaseCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_26 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextReleaseComplete')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextModificationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_27 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextModificationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_27 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextModificationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionSetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_28 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionSetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_28 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionSetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionReleaseCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_29 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionReleaseComplete')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementInitiationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_30 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementInitiationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_30 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementInitiationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PRSConfigurationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_31 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PRSConfigurationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_31 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PRSConfigurationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MeasurementPreconfigurationRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_32 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MeasurementPreconfigurationConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_32 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MeasurementPreconfigurationRefuse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ErrorIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DLRRCMessageTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ULRRCMessageTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEInactivityNotification')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PrivateMessage')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'InitialULRRCMessageTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SystemInformationDeliveryCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Paging')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Notify')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSRestartIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSFailureIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUStatusIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'RRCDeliveryReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'NetworkAccessRateReduction')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TraceStart')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DeactivateTrace')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DUCURadioInformationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'CUDURadioInformationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'AccessAndMobilityIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ReferenceTimeInformationReportingControl')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ReferenceTimeInformationReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'AccessSuccess')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'CellTrafficTrace')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningAssistanceInformationControl')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningAssistanceInformationFeedback')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementAbort')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementFailureIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningDeactivation')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementFailureIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_66 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_67 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementTerminationCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_68 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_69 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastGroupPaging')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_70 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextReleaseRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_71 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextReleaseRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_72 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_73 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementTerminationCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_74 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementFailureIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_75 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MeasurementActivation')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_76 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'QoEInformationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_77 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PosSystemInformationDeliveryCommand')))
    __SuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), ('procedureCode', 0), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7), ('procedureCode', 8), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), ('procedureCode', 20), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9), ('procedureCode', 21), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10), ('procedureCode', 16), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11), ('procedureCode', 26), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12), ('procedureCode', 32), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13), ('procedureCode', 33), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14), ('procedureCode', 34), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_15), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_17), ('procedureCode', 41), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_18), ('procedureCode', 48), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_19), ('procedureCode', 49), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_20), ('procedureCode', 50), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_21), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_21), ('procedureCode', 52), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_22), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_22), ('procedureCode', 59), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_23), ('procedureCode', 60), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_24), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_24), ('procedureCode', 62), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_25), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_25), ('procedureCode', 64), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_26), ('procedureCode', 65), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_27), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_27), ('procedureCode', 67), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_28), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_28), ('procedureCode', 68), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_29), ('procedureCode', 69), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_30), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_30), ('procedureCode', 70), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_31), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_31), ('procedureCode', 75), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_32), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_32), ('procedureCode', 76), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40), ('procedureCode', 17), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43), ('procedureCode', 22), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44), ('procedureCode', 23), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45), ('procedureCode', 24), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46), ('procedureCode', 25), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47), ('procedureCode', 27), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48), ('procedureCode', 28), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49), ('procedureCode', 29), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50), ('procedureCode', 30), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51), ('procedureCode', 31), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52), ('procedureCode', 37), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53), ('procedureCode', 38), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54), ('procedureCode', 58), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55), ('procedureCode', 57), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56), ('procedureCode', 39), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57), ('procedureCode', 40), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58), ('procedureCode', 42), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59), ('procedureCode', 43), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61), ('procedureCode', 45), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62), ('procedureCode', 46), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64), ('procedureCode', 51), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65), ('procedureCode', 53), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_66), ('procedureCode', 54), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_67), ('procedureCode', 55), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_68), ('procedureCode', 56), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_69), ('procedureCode', 63), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_70), ('procedureCode', 61), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_71), ('procedureCode', 66), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_72), ('procedureCode', 71), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_73), ('procedureCode', 79), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_74), ('procedureCode', 80), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_75), ('procedureCode', 77), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_76), ('procedureCode', 78), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_77), ('procedureCode', 81), ('criticality', 'ignore')])], rr=[], ev=None, er=[])
    _SuccessfulOutcome_procedureCode._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_procedureCode._const_tab_at = None
    _SuccessfulOutcome_procedureCode._const_tab_id = 'procedureCode'
    _SuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _SuccessfulOutcome_criticality._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureCode')
    _SuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _SuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE'), ['SuccessfulOutcome']))
    _SuccessfulOutcome_value._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_value._const_tab_at = ('..', 'procedureCode')
    _SuccessfulOutcome_value._const_tab_id = 'SuccessfulOutcome'
    SuccessfulOutcome._cont = ASN1Dict([
        ('procedureCode', _SuccessfulOutcome_procedureCode),
        ('criticality', _SuccessfulOutcome_criticality),
        ('value', _SuccessfulOutcome_value),
        ])
    SuccessfulOutcome._ext = None
    
    #-----< UnsuccessfulOutcome >-----#
    UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE)
    _UnsuccessfulOutcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __UnsuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_F1AP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Reset')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResetAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdateAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdateAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseComplete')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRefuse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'WriteReplaceWarningRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'WriteReplaceWarningResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSCancelRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSCancelResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceCoordinationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceCoordinationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfiguration')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfigurationAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfigurationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfiguration')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfigurationAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfigurationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_15 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_17 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_18 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_19 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_20 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_21 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_21 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextSetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_22 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextSetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_22 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextSetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextReleaseCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_23 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextReleaseComplete')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextModificationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_24 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextModificationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_24 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextModificationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextSetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_25 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextSetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_25 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextSetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextReleaseCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_26 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextReleaseComplete')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextModificationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_27 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextModificationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_27 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextModificationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionSetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_28 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionSetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_28 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionSetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionReleaseCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_29 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionReleaseComplete')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementInitiationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_30 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementInitiationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_30 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementInitiationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PRSConfigurationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_31 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PRSConfigurationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_31 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PRSConfigurationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MeasurementPreconfigurationRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_32 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MeasurementPreconfigurationConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_32 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MeasurementPreconfigurationRefuse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ErrorIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DLRRCMessageTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ULRRCMessageTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEInactivityNotification')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PrivateMessage')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'InitialULRRCMessageTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SystemInformationDeliveryCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Paging')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Notify')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSRestartIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSFailureIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUStatusIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'RRCDeliveryReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'NetworkAccessRateReduction')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TraceStart')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DeactivateTrace')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DUCURadioInformationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'CUDURadioInformationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'AccessAndMobilityIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ReferenceTimeInformationReportingControl')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ReferenceTimeInformationReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'AccessSuccess')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'CellTrafficTrace')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningAssistanceInformationControl')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningAssistanceInformationFeedback')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementAbort')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementFailureIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningDeactivation')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementFailureIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_66 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_67 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementTerminationCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_68 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_69 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastGroupPaging')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_70 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextReleaseRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_71 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextReleaseRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_72 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_73 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementTerminationCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_74 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementFailureIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_75 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MeasurementActivation')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_76 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'QoEInformationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_77 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PosSystemInformationDeliveryCommand')))
    __UnsuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), ('procedureCode', 0), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7), ('procedureCode', 8), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), ('procedureCode', 20), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9), ('procedureCode', 21), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10), ('procedureCode', 16), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11), ('procedureCode', 26), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12), ('procedureCode', 32), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13), ('procedureCode', 33), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14), ('procedureCode', 34), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_15), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_17), ('procedureCode', 41), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_18), ('procedureCode', 48), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_19), ('procedureCode', 49), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_20), ('procedureCode', 50), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_21), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_21), ('procedureCode', 52), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_22), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_22), ('procedureCode', 59), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_23), ('procedureCode', 60), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_24), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_24), ('procedureCode', 62), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_25), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_25), ('procedureCode', 64), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_26), ('procedureCode', 65), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_27), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_27), ('procedureCode', 67), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_28), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_28), ('procedureCode', 68), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_29), ('procedureCode', 69), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_30), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_30), ('procedureCode', 70), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_31), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_31), ('procedureCode', 75), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_32), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_32), ('procedureCode', 76), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40), ('procedureCode', 17), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43), ('procedureCode', 22), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44), ('procedureCode', 23), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45), ('procedureCode', 24), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46), ('procedureCode', 25), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47), ('procedureCode', 27), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48), ('procedureCode', 28), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49), ('procedureCode', 29), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50), ('procedureCode', 30), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51), ('procedureCode', 31), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52), ('procedureCode', 37), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53), ('procedureCode', 38), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54), ('procedureCode', 58), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55), ('procedureCode', 57), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56), ('procedureCode', 39), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57), ('procedureCode', 40), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58), ('procedureCode', 42), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59), ('procedureCode', 43), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61), ('procedureCode', 45), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62), ('procedureCode', 46), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64), ('procedureCode', 51), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65), ('procedureCode', 53), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_66), ('procedureCode', 54), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_67), ('procedureCode', 55), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_68), ('procedureCode', 56), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_69), ('procedureCode', 63), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_70), ('procedureCode', 61), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_71), ('procedureCode', 66), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_72), ('procedureCode', 71), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_73), ('procedureCode', 79), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_74), ('procedureCode', 80), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_75), ('procedureCode', 77), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_76), ('procedureCode', 78), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_77), ('procedureCode', 81), ('criticality', 'ignore')])], rr=[], ev=None, er=[])
    _UnsuccessfulOutcome_procedureCode._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_procedureCode._const_tab_at = None
    _UnsuccessfulOutcome_procedureCode._const_tab_id = 'procedureCode'
    _UnsuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _UnsuccessfulOutcome_criticality._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureCode')
    _UnsuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _UnsuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE'), ['UnsuccessfulOutcome']))
    _UnsuccessfulOutcome_value._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_value._const_tab_at = ('..', 'procedureCode')
    _UnsuccessfulOutcome_value._const_tab_id = 'UnsuccessfulOutcome'
    UnsuccessfulOutcome._cont = ASN1Dict([
        ('procedureCode', _UnsuccessfulOutcome_procedureCode),
        ('criticality', _UnsuccessfulOutcome_criticality),
        ('value', _UnsuccessfulOutcome_value),
        ])
    UnsuccessfulOutcome._ext = None
    
    #-----< F1AP-ELEMENTARY-PROCEDURES >-----#
    F1AP_ELEMENTARY_PROCEDURES = CLASS(name='F1AP-ELEMENTARY-PROCEDURES', mode=MODE_SET, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Reset')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResetAcknowledge')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdate')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdateAcknowledge')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdateFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdate')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdateAcknowledge')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdateFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseCommand')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseComplete')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRequired')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationConfirm')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRefuse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'WriteReplaceWarningRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'WriteReplaceWarningResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSCancelRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSCancelResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceCoordinationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceCoordinationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfiguration')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfigurationAcknowledge')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfigurationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfiguration')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfigurationAcknowledge')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfigurationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_15 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_16 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_17 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_18 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_19 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_20 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_20 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_21 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_21 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextSetupRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_22 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextSetupResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_22 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextSetupFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextReleaseCommand')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_23 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextReleaseComplete')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextModificationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_24 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextModificationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_24 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextModificationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextSetupRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_25 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextSetupResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_25 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextSetupFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextReleaseCommand')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_26 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextReleaseComplete')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextModificationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_27 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextModificationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_27 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextModificationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionSetupRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_28 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionSetupResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_28 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionSetupFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionReleaseCommand')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_29 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionReleaseComplete')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementInitiationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_30 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementInitiationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_30 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementInitiationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PRSConfigurationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_31 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PRSConfigurationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_31 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PRSConfigurationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MeasurementPreconfigurationRequired')))
    _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_32 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MeasurementPreconfigurationConfirm')))
    _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_32 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MeasurementPreconfigurationRefuse')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ErrorIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DLRRCMessageTransfer')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ULRRCMessageTransfer')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEInactivityNotification')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PrivateMessage')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'InitialULRRCMessageTransfer')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SystemInformationDeliveryCommand')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Paging')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Notify')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSRestartIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSFailureIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUStatusIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'RRCDeliveryReport')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'NetworkAccessRateReduction')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TraceStart')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DeactivateTrace')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DUCURadioInformationTransfer')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'CUDURadioInformationTransfer')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusUpdate')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'AccessAndMobilityIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ReferenceTimeInformationReportingControl')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ReferenceTimeInformationReport')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'AccessSuccess')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'CellTrafficTrace')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_58 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningAssistanceInformationControl')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_59 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningAssistanceInformationFeedback')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_60 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementReport')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_61 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementAbort')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_62 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementFailureIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_63 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementUpdate')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_64 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningDeactivation')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_65 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementFailureIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_66 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementReport')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_67 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementTerminationCommand')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_68 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationUpdate')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_69 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastGroupPaging')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_70 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextReleaseRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_71 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextReleaseRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_72 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementReport')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_73 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementTerminationCommand')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_74 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementFailureIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_75 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MeasurementActivation')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_76 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'QoEInformationTransfer')))
    _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_77 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PosSystemInformationDeliveryCommand')))
    F1AP_ELEMENTARY_PROCEDURES._val = ASN1Set(rv=[dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0), ('procedureCode', 0), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7), ('procedureCode', 8), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8), ('procedureCode', 20), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9), ('procedureCode', 21), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10), ('procedureCode', 16), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11), ('procedureCode', 26), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12), ('procedureCode', 32), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13), ('procedureCode', 33), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_14), ('procedureCode', 34), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_15), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_16), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_16), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_17), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_17), ('procedureCode', 41), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_18), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_18), ('procedureCode', 48), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_19), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_19), ('procedureCode', 49), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_20), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_20), ('procedureCode', 50), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_21), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_21), ('procedureCode', 52), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_22), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_22), ('procedureCode', 59), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_23), ('procedureCode', 60), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_24), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_24), ('procedureCode', 62), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_25), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_25), ('procedureCode', 64), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_26), ('procedureCode', 65), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_27), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_27), ('procedureCode', 67), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_28), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_28), ('procedureCode', 68), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_29), ('procedureCode', 69), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_30), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_30), ('procedureCode', 70), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_31), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_31), ('procedureCode', 75), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_32), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_32), ('procedureCode', 76), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40), ('procedureCode', 17), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43), ('procedureCode', 22), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44), ('procedureCode', 23), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45), ('procedureCode', 24), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46), ('procedureCode', 25), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47), ('procedureCode', 27), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48), ('procedureCode', 28), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49), ('procedureCode', 29), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50), ('procedureCode', 30), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51), ('procedureCode', 31), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52), ('procedureCode', 37), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53), ('procedureCode', 38), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54), ('procedureCode', 58), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55), ('procedureCode', 57), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56), ('procedureCode', 39), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57), ('procedureCode', 40), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_58), ('procedureCode', 42), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_59), ('procedureCode', 43), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_60), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_61), ('procedureCode', 45), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_62), ('procedureCode', 46), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_63), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_64), ('procedureCode', 51), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_65), ('procedureCode', 53), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_66), ('procedureCode', 54), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_67), ('procedureCode', 55), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_68), ('procedureCode', 56), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_69), ('procedureCode', 63), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_70), ('procedureCode', 61), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_71), ('procedureCode', 66), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_72), ('procedureCode', 71), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_73), ('procedureCode', 79), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_74), ('procedureCode', 80), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_75), ('procedureCode', 77), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_76), ('procedureCode', 78), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_77), ('procedureCode', 81), ('criticality', 'ignore')])], rr=[], ev=[], er=[])
    
    #-----< F1AP-ELEMENTARY-PROCEDURES-CLASS-1 >-----#
    F1AP_ELEMENTARY_PROCEDURES_CLASS_1 = CLASS(name='F1AP-ELEMENTARY-PROCEDURES-CLASS-1', mode=MODE_SET, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Reset')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResetAcknowledge')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdate')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdateAcknowledge')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdateFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdate')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdateAcknowledge')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdateFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseCommand')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseComplete')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRequired')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationConfirm')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRefuse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'WriteReplaceWarningRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'WriteReplaceWarningResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSCancelRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSCancelResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceCoordinationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceCoordinationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfiguration')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfigurationAcknowledge')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfigurationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfiguration')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfigurationAcknowledge')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfigurationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_15 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_16 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_17 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_18 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_19 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_20 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_21 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_21 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextSetupRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_22 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextSetupResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_22 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextSetupFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextReleaseCommand')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_23 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextReleaseComplete')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextModificationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_24 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextModificationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_24 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextModificationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextSetupRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_25 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextSetupResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_25 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextSetupFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextReleaseCommand')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_26 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextReleaseComplete')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextModificationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_27 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextModificationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_27 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextModificationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionSetupRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_28 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionSetupResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_28 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionSetupFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionReleaseCommand')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_29 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionReleaseComplete')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementInitiationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_30 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementInitiationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_30 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementInitiationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PRSConfigurationRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_31 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PRSConfigurationResponse')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_31 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PRSConfigurationFailure')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MeasurementPreconfigurationRequired')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_32 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MeasurementPreconfigurationConfirm')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_32 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MeasurementPreconfigurationRefuse')))
    F1AP_ELEMENTARY_PROCEDURES_CLASS_1._val = ASN1Set(rv=[dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0), ('procedureCode', 0), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7), ('procedureCode', 8), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8), ('procedureCode', 20), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9), ('procedureCode', 21), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10), ('procedureCode', 16), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11), ('procedureCode', 26), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12), ('procedureCode', 32), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13), ('procedureCode', 33), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14), ('procedureCode', 34), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_15), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_16), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_17), ('procedureCode', 41), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_18), ('procedureCode', 48), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_19), ('procedureCode', 49), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_20), ('procedureCode', 50), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_21), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_21), ('procedureCode', 52), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_22), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_22), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_22), ('procedureCode', 59), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_23), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_23), ('procedureCode', 60), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_24), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_24), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_24), ('procedureCode', 62), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_25), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_25), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_25), ('procedureCode', 64), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_26), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_26), ('procedureCode', 65), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_27), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_27), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_27), ('procedureCode', 67), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_28), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_28), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_28), ('procedureCode', 68), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_29), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_29), ('procedureCode', 69), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_30), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_30), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_30), ('procedureCode', 70), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_31), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_31), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_31), ('procedureCode', 75), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_32), ('SuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_32), ('UnsuccessfulOutcome', _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_32), ('procedureCode', 76), ('criticality', 'reject')])], rr=[], ev=[], er=[])
    
    #-----< F1AP-ELEMENTARY-PROCEDURES-CLASS-2 >-----#
    F1AP_ELEMENTARY_PROCEDURES_CLASS_2 = CLASS(name='F1AP-ELEMENTARY-PROCEDURES-CLASS-2', mode=MODE_SET, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ErrorIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DLRRCMessageTransfer')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ULRRCMessageTransfer')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEInactivityNotification')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PrivateMessage')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'InitialULRRCMessageTransfer')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SystemInformationDeliveryCommand')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Paging')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Notify')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSRestartIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSFailureIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUStatusIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'RRCDeliveryReport')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'NetworkAccessRateReduction')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TraceStart')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DeactivateTrace')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DUCURadioInformationTransfer')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'CUDURadioInformationTransfer')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusUpdate')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'AccessAndMobilityIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ReferenceTimeInformationReportingControl')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ReferenceTimeInformationReport')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'AccessSuccess')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'CellTrafficTrace')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningAssistanceInformationControl')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningAssistanceInformationFeedback')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementReport')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementAbort')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementFailureIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementUpdate')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningDeactivation')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementFailureIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementReport')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementTerminationCommand')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationUpdate')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastGroupPaging')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextReleaseRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextReleaseRequest')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementReport')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementTerminationCommand')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementFailureIndication')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MeasurementActivation')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'QoEInformationTransfer')))
    _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PosSystemInformationDeliveryCommand')))
    F1AP_ELEMENTARY_PROCEDURES_CLASS_2._val = ASN1Set(rv=[dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7), ('procedureCode', 17), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10), ('procedureCode', 22), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11), ('procedureCode', 23), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12), ('procedureCode', 24), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13), ('procedureCode', 25), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14), ('procedureCode', 27), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15), ('procedureCode', 28), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16), ('procedureCode', 29), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17), ('procedureCode', 30), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18), ('procedureCode', 31), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19), ('procedureCode', 37), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20), ('procedureCode', 38), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21), ('procedureCode', 58), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22), ('procedureCode', 57), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23), ('procedureCode', 39), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24), ('procedureCode', 40), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25), ('procedureCode', 42), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26), ('procedureCode', 43), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28), ('procedureCode', 45), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29), ('procedureCode', 46), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31), ('procedureCode', 51), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_32), ('procedureCode', 53), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_33), ('procedureCode', 54), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_34), ('procedureCode', 55), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_35), ('procedureCode', 56), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_36), ('procedureCode', 63), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_37), ('procedureCode', 61), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_38), ('procedureCode', 66), ('criticality', 'reject')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_39), ('procedureCode', 71), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_40), ('procedureCode', 79), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_41), ('procedureCode', 80), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_42), ('procedureCode', 77), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_43), ('procedureCode', 78), ('criticality', 'ignore')]), dict([('InitiatingMessage', _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_44), ('procedureCode', 81), ('criticality', 'ignore')])], rr=[], ev=[], er=[])
    
    #-----< reset >-----#
    reset = CLASS(name='reset', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _reset_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Reset')))
    _reset_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResetAcknowledge')))
    reset._val = dict([('InitiatingMessage', _reset_val_InitiatingMessage), ('SuccessfulOutcome', _reset_val_SuccessfulOutcome), ('procedureCode', 0), ('criticality', 'reject')])
    
    #-----< f1Setup >-----#
    f1Setup = CLASS(name='f1Setup', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _f1Setup_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupRequest')))
    _f1Setup_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupResponse')))
    _f1Setup_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1SetupFailure')))
    f1Setup._val = dict([('InitiatingMessage', _f1Setup_val_InitiatingMessage), ('SuccessfulOutcome', _f1Setup_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _f1Setup_val_UnsuccessfulOutcome), ('procedureCode', 1), ('criticality', 'reject')])
    
    #-----< gNBDUConfigurationUpdate >-----#
    gNBDUConfigurationUpdate = CLASS(name='gNBDUConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _gNBDUConfigurationUpdate_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdate')))
    _gNBDUConfigurationUpdate_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdateAcknowledge')))
    _gNBDUConfigurationUpdate_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUConfigurationUpdateFailure')))
    gNBDUConfigurationUpdate._val = dict([('InitiatingMessage', _gNBDUConfigurationUpdate_val_InitiatingMessage), ('SuccessfulOutcome', _gNBDUConfigurationUpdate_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _gNBDUConfigurationUpdate_val_UnsuccessfulOutcome), ('procedureCode', 3), ('criticality', 'reject')])
    
    #-----< gNBCUConfigurationUpdate >-----#
    gNBCUConfigurationUpdate = CLASS(name='gNBCUConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _gNBCUConfigurationUpdate_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdate')))
    _gNBCUConfigurationUpdate_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdateAcknowledge')))
    _gNBCUConfigurationUpdate_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBCUConfigurationUpdateFailure')))
    gNBCUConfigurationUpdate._val = dict([('InitiatingMessage', _gNBCUConfigurationUpdate_val_InitiatingMessage), ('SuccessfulOutcome', _gNBCUConfigurationUpdate_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _gNBCUConfigurationUpdate_val_UnsuccessfulOutcome), ('procedureCode', 4), ('criticality', 'reject')])
    
    #-----< uEContextSetup >-----#
    uEContextSetup = CLASS(name='uEContextSetup', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _uEContextSetup_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupRequest')))
    _uEContextSetup_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupResponse')))
    _uEContextSetup_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextSetupFailure')))
    uEContextSetup._val = dict([('InitiatingMessage', _uEContextSetup_val_InitiatingMessage), ('SuccessfulOutcome', _uEContextSetup_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _uEContextSetup_val_UnsuccessfulOutcome), ('procedureCode', 5), ('criticality', 'reject')])
    
    #-----< uEContextRelease >-----#
    uEContextRelease = CLASS(name='uEContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _uEContextRelease_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseCommand')))
    _uEContextRelease_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseComplete')))
    uEContextRelease._val = dict([('InitiatingMessage', _uEContextRelease_val_InitiatingMessage), ('SuccessfulOutcome', _uEContextRelease_val_SuccessfulOutcome), ('procedureCode', 6), ('criticality', 'reject')])
    
    #-----< uEContextModification >-----#
    uEContextModification = CLASS(name='uEContextModification', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _uEContextModification_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRequest')))
    _uEContextModification_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationResponse')))
    _uEContextModification_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationFailure')))
    uEContextModification._val = dict([('InitiatingMessage', _uEContextModification_val_InitiatingMessage), ('SuccessfulOutcome', _uEContextModification_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _uEContextModification_val_UnsuccessfulOutcome), ('procedureCode', 7), ('criticality', 'reject')])
    
    #-----< uEContextModificationRequired >-----#
    uEContextModificationRequired = CLASS(name='uEContextModificationRequired', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _uEContextModificationRequired_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRequired')))
    _uEContextModificationRequired_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationConfirm')))
    _uEContextModificationRequired_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextModificationRefuse')))
    uEContextModificationRequired._val = dict([('InitiatingMessage', _uEContextModificationRequired_val_InitiatingMessage), ('SuccessfulOutcome', _uEContextModificationRequired_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _uEContextModificationRequired_val_UnsuccessfulOutcome), ('procedureCode', 8), ('criticality', 'reject')])
    
    #-----< writeReplaceWarning >-----#
    writeReplaceWarning = CLASS(name='writeReplaceWarning', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _writeReplaceWarning_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'WriteReplaceWarningRequest')))
    _writeReplaceWarning_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'WriteReplaceWarningResponse')))
    writeReplaceWarning._val = dict([('InitiatingMessage', _writeReplaceWarning_val_InitiatingMessage), ('SuccessfulOutcome', _writeReplaceWarning_val_SuccessfulOutcome), ('procedureCode', 20), ('criticality', 'reject')])
    
    #-----< pWSCancel >-----#
    pWSCancel = CLASS(name='pWSCancel', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _pWSCancel_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSCancelRequest')))
    _pWSCancel_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSCancelResponse')))
    pWSCancel._val = dict([('InitiatingMessage', _pWSCancel_val_InitiatingMessage), ('SuccessfulOutcome', _pWSCancel_val_SuccessfulOutcome), ('procedureCode', 21), ('criticality', 'reject')])
    
    #-----< errorIndication >-----#
    errorIndication = CLASS(name='errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _errorIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ErrorIndication')))
    errorIndication._val = dict([('InitiatingMessage', _errorIndication_val_InitiatingMessage), ('procedureCode', 2), ('criticality', 'ignore')])
    
    #-----< uEContextReleaseRequest >-----#
    uEContextReleaseRequest = CLASS(name='uEContextReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _uEContextReleaseRequest_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEContextReleaseRequest')))
    uEContextReleaseRequest._val = dict([('InitiatingMessage', _uEContextReleaseRequest_val_InitiatingMessage), ('procedureCode', 10), ('criticality', 'ignore')])
    
    #-----< initialULRRCMessageTransfer >-----#
    initialULRRCMessageTransfer = CLASS(name='initialULRRCMessageTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _initialULRRCMessageTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'InitialULRRCMessageTransfer')))
    initialULRRCMessageTransfer._val = dict([('InitiatingMessage', _initialULRRCMessageTransfer_val_InitiatingMessage), ('procedureCode', 11), ('criticality', 'ignore')])
    
    #-----< dLRRCMessageTransfer >-----#
    dLRRCMessageTransfer = CLASS(name='dLRRCMessageTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _dLRRCMessageTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DLRRCMessageTransfer')))
    dLRRCMessageTransfer._val = dict([('InitiatingMessage', _dLRRCMessageTransfer_val_InitiatingMessage), ('procedureCode', 12), ('criticality', 'ignore')])
    
    #-----< uLRRCMessageTransfer >-----#
    uLRRCMessageTransfer = CLASS(name='uLRRCMessageTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _uLRRCMessageTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ULRRCMessageTransfer')))
    uLRRCMessageTransfer._val = dict([('InitiatingMessage', _uLRRCMessageTransfer_val_InitiatingMessage), ('procedureCode', 13), ('criticality', 'ignore')])
    
    #-----< uEInactivityNotification >-----#
    uEInactivityNotification = CLASS(name='uEInactivityNotification', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _uEInactivityNotification_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'UEInactivityNotification')))
    uEInactivityNotification._val = dict([('InitiatingMessage', _uEInactivityNotification_val_InitiatingMessage), ('procedureCode', 15), ('criticality', 'ignore')])
    
    #-----< gNBDUResourceCoordination >-----#
    gNBDUResourceCoordination = CLASS(name='gNBDUResourceCoordination', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _gNBDUResourceCoordination_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceCoordinationRequest')))
    _gNBDUResourceCoordination_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceCoordinationResponse')))
    gNBDUResourceCoordination._val = dict([('InitiatingMessage', _gNBDUResourceCoordination_val_InitiatingMessage), ('SuccessfulOutcome', _gNBDUResourceCoordination_val_SuccessfulOutcome), ('procedureCode', 16), ('criticality', 'reject')])
    
    #-----< privateMessage >-----#
    privateMessage = CLASS(name='privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _privateMessage_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PrivateMessage')))
    privateMessage._val = dict([('InitiatingMessage', _privateMessage_val_InitiatingMessage), ('procedureCode', 14), ('criticality', 'ignore')])
    
    #-----< systemInformationDelivery >-----#
    systemInformationDelivery = CLASS(name='systemInformationDelivery', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _systemInformationDelivery_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'SystemInformationDeliveryCommand')))
    systemInformationDelivery._val = dict([('InitiatingMessage', _systemInformationDelivery_val_InitiatingMessage), ('procedureCode', 17), ('criticality', 'ignore')])
    
    #-----< paging >-----#
    paging = CLASS(name='paging', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _paging_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Paging')))
    paging._val = dict([('InitiatingMessage', _paging_val_InitiatingMessage), ('procedureCode', 18), ('criticality', 'ignore')])
    
    #-----< notify >-----#
    notify = CLASS(name='notify', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _notify_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'Notify')))
    notify._val = dict([('InitiatingMessage', _notify_val_InitiatingMessage), ('procedureCode', 19), ('criticality', 'ignore')])
    
    #-----< networkAccessRateReduction >-----#
    networkAccessRateReduction = CLASS(name='networkAccessRateReduction', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _networkAccessRateReduction_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'NetworkAccessRateReduction')))
    networkAccessRateReduction._val = dict([('InitiatingMessage', _networkAccessRateReduction_val_InitiatingMessage), ('procedureCode', 27), ('criticality', 'ignore')])
    
    #-----< pWSRestartIndication >-----#
    pWSRestartIndication = CLASS(name='pWSRestartIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _pWSRestartIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSRestartIndication')))
    pWSRestartIndication._val = dict([('InitiatingMessage', _pWSRestartIndication_val_InitiatingMessage), ('procedureCode', 22), ('criticality', 'ignore')])
    
    #-----< pWSFailureIndication >-----#
    pWSFailureIndication = CLASS(name='pWSFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _pWSFailureIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PWSFailureIndication')))
    pWSFailureIndication._val = dict([('InitiatingMessage', _pWSFailureIndication_val_InitiatingMessage), ('procedureCode', 23), ('criticality', 'ignore')])
    
    #-----< gNBDUStatusIndication >-----#
    gNBDUStatusIndication = CLASS(name='gNBDUStatusIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _gNBDUStatusIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUStatusIndication')))
    gNBDUStatusIndication._val = dict([('InitiatingMessage', _gNBDUStatusIndication_val_InitiatingMessage), ('procedureCode', 24), ('criticality', 'ignore')])
    
    #-----< rRCDeliveryReport >-----#
    rRCDeliveryReport = CLASS(name='rRCDeliveryReport', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _rRCDeliveryReport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'RRCDeliveryReport')))
    rRCDeliveryReport._val = dict([('InitiatingMessage', _rRCDeliveryReport_val_InitiatingMessage), ('procedureCode', 25), ('criticality', 'ignore')])
    
    #-----< f1Removal >-----#
    f1Removal = CLASS(name='f1Removal', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _f1Removal_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalRequest')))
    _f1Removal_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalResponse')))
    _f1Removal_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'F1RemovalFailure')))
    f1Removal._val = dict([('InitiatingMessage', _f1Removal_val_InitiatingMessage), ('SuccessfulOutcome', _f1Removal_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _f1Removal_val_UnsuccessfulOutcome), ('procedureCode', 26), ('criticality', 'reject')])
    
    #-----< traceStart >-----#
    traceStart = CLASS(name='traceStart', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _traceStart_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TraceStart')))
    traceStart._val = dict([('InitiatingMessage', _traceStart_val_InitiatingMessage), ('procedureCode', 28), ('criticality', 'ignore')])
    
    #-----< deactivateTrace >-----#
    deactivateTrace = CLASS(name='deactivateTrace', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _deactivateTrace_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DeactivateTrace')))
    deactivateTrace._val = dict([('InitiatingMessage', _deactivateTrace_val_InitiatingMessage), ('procedureCode', 29), ('criticality', 'ignore')])
    
    #-----< dUCURadioInformationTransfer >-----#
    dUCURadioInformationTransfer = CLASS(name='dUCURadioInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _dUCURadioInformationTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'DUCURadioInformationTransfer')))
    dUCURadioInformationTransfer._val = dict([('InitiatingMessage', _dUCURadioInformationTransfer_val_InitiatingMessage), ('procedureCode', 30), ('criticality', 'ignore')])
    
    #-----< cUDURadioInformationTransfer >-----#
    cUDURadioInformationTransfer = CLASS(name='cUDURadioInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _cUDURadioInformationTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'CUDURadioInformationTransfer')))
    cUDURadioInformationTransfer._val = dict([('InitiatingMessage', _cUDURadioInformationTransfer_val_InitiatingMessage), ('procedureCode', 31), ('criticality', 'ignore')])
    
    #-----< bAPMappingConfiguration >-----#
    bAPMappingConfiguration = CLASS(name='bAPMappingConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _bAPMappingConfiguration_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfiguration')))
    _bAPMappingConfiguration_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfigurationAcknowledge')))
    _bAPMappingConfiguration_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BAPMappingConfigurationFailure')))
    bAPMappingConfiguration._val = dict([('InitiatingMessage', _bAPMappingConfiguration_val_InitiatingMessage), ('SuccessfulOutcome', _bAPMappingConfiguration_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _bAPMappingConfiguration_val_UnsuccessfulOutcome), ('procedureCode', 32), ('criticality', 'reject')])
    
    #-----< gNBDUResourceConfiguration >-----#
    gNBDUResourceConfiguration = CLASS(name='gNBDUResourceConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _gNBDUResourceConfiguration_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfiguration')))
    _gNBDUResourceConfiguration_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfigurationAcknowledge')))
    _gNBDUResourceConfiguration_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'GNBDUResourceConfigurationFailure')))
    gNBDUResourceConfiguration._val = dict([('InitiatingMessage', _gNBDUResourceConfiguration_val_InitiatingMessage), ('SuccessfulOutcome', _gNBDUResourceConfiguration_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _gNBDUResourceConfiguration_val_UnsuccessfulOutcome), ('procedureCode', 33), ('criticality', 'reject')])
    
    #-----< iABTNLAddressAllocation >-----#
    iABTNLAddressAllocation = CLASS(name='iABTNLAddressAllocation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _iABTNLAddressAllocation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressRequest')))
    _iABTNLAddressAllocation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressResponse')))
    _iABTNLAddressAllocation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABTNLAddressFailure')))
    iABTNLAddressAllocation._val = dict([('InitiatingMessage', _iABTNLAddressAllocation_val_InitiatingMessage), ('SuccessfulOutcome', _iABTNLAddressAllocation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _iABTNLAddressAllocation_val_UnsuccessfulOutcome), ('procedureCode', 34), ('criticality', 'reject')])
    
    #-----< iABUPConfigurationUpdate >-----#
    iABUPConfigurationUpdate = CLASS(name='iABUPConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _iABUPConfigurationUpdate_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateRequest')))
    _iABUPConfigurationUpdate_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateResponse')))
    _iABUPConfigurationUpdate_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'IABUPConfigurationUpdateFailure')))
    iABUPConfigurationUpdate._val = dict([('InitiatingMessage', _iABUPConfigurationUpdate_val_InitiatingMessage), ('SuccessfulOutcome', _iABUPConfigurationUpdate_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _iABUPConfigurationUpdate_val_UnsuccessfulOutcome), ('procedureCode', 35), ('criticality', 'reject')])
    
    #-----< resourceStatusReportingInitiation >-----#
    resourceStatusReportingInitiation = CLASS(name='resourceStatusReportingInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _resourceStatusReportingInitiation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusRequest')))
    _resourceStatusReportingInitiation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusResponse')))
    _resourceStatusReportingInitiation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusFailure')))
    resourceStatusReportingInitiation._val = dict([('InitiatingMessage', _resourceStatusReportingInitiation_val_InitiatingMessage), ('SuccessfulOutcome', _resourceStatusReportingInitiation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _resourceStatusReportingInitiation_val_UnsuccessfulOutcome), ('procedureCode', 36), ('criticality', 'reject')])
    
    #-----< resourceStatusReporting >-----#
    resourceStatusReporting = CLASS(name='resourceStatusReporting', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _resourceStatusReporting_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ResourceStatusUpdate')))
    resourceStatusReporting._val = dict([('InitiatingMessage', _resourceStatusReporting_val_InitiatingMessage), ('procedureCode', 37), ('criticality', 'ignore')])
    
    #-----< accessAndMobilityIndication >-----#
    accessAndMobilityIndication = CLASS(name='accessAndMobilityIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _accessAndMobilityIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'AccessAndMobilityIndication')))
    accessAndMobilityIndication._val = dict([('InitiatingMessage', _accessAndMobilityIndication_val_InitiatingMessage), ('procedureCode', 38), ('criticality', 'ignore')])
    
    #-----< referenceTimeInformationReportingControl >-----#
    referenceTimeInformationReportingControl = CLASS(name='referenceTimeInformationReportingControl', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _referenceTimeInformationReportingControl_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ReferenceTimeInformationReportingControl')))
    referenceTimeInformationReportingControl._val = dict([('InitiatingMessage', _referenceTimeInformationReportingControl_val_InitiatingMessage), ('procedureCode', 58), ('criticality', 'ignore')])
    
    #-----< referenceTimeInformationReport >-----#
    referenceTimeInformationReport = CLASS(name='referenceTimeInformationReport', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _referenceTimeInformationReport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'ReferenceTimeInformationReport')))
    referenceTimeInformationReport._val = dict([('InitiatingMessage', _referenceTimeInformationReport_val_InitiatingMessage), ('procedureCode', 57), ('criticality', 'ignore')])
    
    #-----< accessSuccess >-----#
    accessSuccess = CLASS(name='accessSuccess', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _accessSuccess_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'AccessSuccess')))
    accessSuccess._val = dict([('InitiatingMessage', _accessSuccess_val_InitiatingMessage), ('procedureCode', 39), ('criticality', 'ignore')])
    
    #-----< cellTrafficTrace >-----#
    cellTrafficTrace = CLASS(name='cellTrafficTrace', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _cellTrafficTrace_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'CellTrafficTrace')))
    cellTrafficTrace._val = dict([('InitiatingMessage', _cellTrafficTrace_val_InitiatingMessage), ('procedureCode', 40), ('criticality', 'ignore')])
    
    #-----< positioningAssistanceInformationControl >-----#
    positioningAssistanceInformationControl = CLASS(name='positioningAssistanceInformationControl', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _positioningAssistanceInformationControl_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningAssistanceInformationControl')))
    positioningAssistanceInformationControl._val = dict([('InitiatingMessage', _positioningAssistanceInformationControl_val_InitiatingMessage), ('procedureCode', 42), ('criticality', 'ignore')])
    
    #-----< positioningAssistanceInformationFeedback >-----#
    positioningAssistanceInformationFeedback = CLASS(name='positioningAssistanceInformationFeedback', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _positioningAssistanceInformationFeedback_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningAssistanceInformationFeedback')))
    positioningAssistanceInformationFeedback._val = dict([('InitiatingMessage', _positioningAssistanceInformationFeedback_val_InitiatingMessage), ('procedureCode', 43), ('criticality', 'ignore')])
    
    #-----< positioningMeasurementExchange >-----#
    positioningMeasurementExchange = CLASS(name='positioningMeasurementExchange', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _positioningMeasurementExchange_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementRequest')))
    _positioningMeasurementExchange_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementResponse')))
    _positioningMeasurementExchange_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementFailure')))
    positioningMeasurementExchange._val = dict([('InitiatingMessage', _positioningMeasurementExchange_val_InitiatingMessage), ('SuccessfulOutcome', _positioningMeasurementExchange_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _positioningMeasurementExchange_val_UnsuccessfulOutcome), ('procedureCode', 41), ('criticality', 'reject')])
    
    #-----< positioningMeasurementReport >-----#
    positioningMeasurementReport = CLASS(name='positioningMeasurementReport', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _positioningMeasurementReport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementReport')))
    positioningMeasurementReport._val = dict([('InitiatingMessage', _positioningMeasurementReport_val_InitiatingMessage), ('procedureCode', 44), ('criticality', 'ignore')])
    
    #-----< positioningMeasurementAbort >-----#
    positioningMeasurementAbort = CLASS(name='positioningMeasurementAbort', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _positioningMeasurementAbort_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementAbort')))
    positioningMeasurementAbort._val = dict([('InitiatingMessage', _positioningMeasurementAbort_val_InitiatingMessage), ('procedureCode', 45), ('criticality', 'ignore')])
    
    #-----< positioningMeasurementFailureIndication >-----#
    positioningMeasurementFailureIndication = CLASS(name='positioningMeasurementFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _positioningMeasurementFailureIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementFailureIndication')))
    positioningMeasurementFailureIndication._val = dict([('InitiatingMessage', _positioningMeasurementFailureIndication_val_InitiatingMessage), ('procedureCode', 46), ('criticality', 'ignore')])
    
    #-----< positioningMeasurementUpdate >-----#
    positioningMeasurementUpdate = CLASS(name='positioningMeasurementUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _positioningMeasurementUpdate_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningMeasurementUpdate')))
    positioningMeasurementUpdate._val = dict([('InitiatingMessage', _positioningMeasurementUpdate_val_InitiatingMessage), ('procedureCode', 47), ('criticality', 'ignore')])
    
    #-----< tRPInformationExchange >-----#
    tRPInformationExchange = CLASS(name='tRPInformationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _tRPInformationExchange_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationRequest')))
    _tRPInformationExchange_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationResponse')))
    _tRPInformationExchange_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'TRPInformationFailure')))
    tRPInformationExchange._val = dict([('InitiatingMessage', _tRPInformationExchange_val_InitiatingMessage), ('SuccessfulOutcome', _tRPInformationExchange_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _tRPInformationExchange_val_UnsuccessfulOutcome), ('procedureCode', 48), ('criticality', 'reject')])
    
    #-----< positioningInformationExchange >-----#
    positioningInformationExchange = CLASS(name='positioningInformationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _positioningInformationExchange_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationRequest')))
    _positioningInformationExchange_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationResponse')))
    _positioningInformationExchange_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationFailure')))
    positioningInformationExchange._val = dict([('InitiatingMessage', _positioningInformationExchange_val_InitiatingMessage), ('SuccessfulOutcome', _positioningInformationExchange_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _positioningInformationExchange_val_UnsuccessfulOutcome), ('procedureCode', 49), ('criticality', 'reject')])
    
    #-----< positioningActivation >-----#
    positioningActivation = CLASS(name='positioningActivation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _positioningActivation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationRequest')))
    _positioningActivation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationResponse')))
    _positioningActivation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningActivationFailure')))
    positioningActivation._val = dict([('InitiatingMessage', _positioningActivation_val_InitiatingMessage), ('SuccessfulOutcome', _positioningActivation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _positioningActivation_val_UnsuccessfulOutcome), ('procedureCode', 50), ('criticality', 'reject')])
    
    #-----< positioningDeactivation >-----#
    positioningDeactivation = CLASS(name='positioningDeactivation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _positioningDeactivation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningDeactivation')))
    positioningDeactivation._val = dict([('InitiatingMessage', _positioningDeactivation_val_InitiatingMessage), ('procedureCode', 51), ('criticality', 'ignore')])
    
    #-----< e-CIDMeasurementInitiation >-----#
    e_CIDMeasurementInitiation = CLASS(name='e-CIDMeasurementInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _e_CIDMeasurementInitiation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationRequest')))
    _e_CIDMeasurementInitiation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationResponse')))
    _e_CIDMeasurementInitiation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementInitiationFailure')))
    e_CIDMeasurementInitiation._val = dict([('InitiatingMessage', _e_CIDMeasurementInitiation_val_InitiatingMessage), ('SuccessfulOutcome', _e_CIDMeasurementInitiation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _e_CIDMeasurementInitiation_val_UnsuccessfulOutcome), ('procedureCode', 52), ('criticality', 'reject')])
    
    #-----< e-CIDMeasurementFailureIndication >-----#
    e_CIDMeasurementFailureIndication = CLASS(name='e-CIDMeasurementFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _e_CIDMeasurementFailureIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementFailureIndication')))
    e_CIDMeasurementFailureIndication._val = dict([('InitiatingMessage', _e_CIDMeasurementFailureIndication_val_InitiatingMessage), ('procedureCode', 53), ('criticality', 'ignore')])
    
    #-----< e-CIDMeasurementReport >-----#
    e_CIDMeasurementReport = CLASS(name='e-CIDMeasurementReport', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _e_CIDMeasurementReport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementReport')))
    e_CIDMeasurementReport._val = dict([('InitiatingMessage', _e_CIDMeasurementReport_val_InitiatingMessage), ('procedureCode', 54), ('criticality', 'ignore')])
    
    #-----< e-CIDMeasurementTermination >-----#
    e_CIDMeasurementTermination = CLASS(name='e-CIDMeasurementTermination', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _e_CIDMeasurementTermination_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'E-CIDMeasurementTerminationCommand')))
    e_CIDMeasurementTermination._val = dict([('InitiatingMessage', _e_CIDMeasurementTermination_val_InitiatingMessage), ('procedureCode', 55), ('criticality', 'ignore')])
    
    #-----< positioningInformationUpdate >-----#
    positioningInformationUpdate = CLASS(name='positioningInformationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _positioningInformationUpdate_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PositioningInformationUpdate')))
    positioningInformationUpdate._val = dict([('InitiatingMessage', _positioningInformationUpdate_val_InitiatingMessage), ('procedureCode', 56), ('criticality', 'ignore')])
    
    #-----< broadcastContextSetup >-----#
    broadcastContextSetup = CLASS(name='broadcastContextSetup', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _broadcastContextSetup_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextSetupRequest')))
    _broadcastContextSetup_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextSetupResponse')))
    _broadcastContextSetup_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextSetupFailure')))
    broadcastContextSetup._val = dict([('InitiatingMessage', _broadcastContextSetup_val_InitiatingMessage), ('SuccessfulOutcome', _broadcastContextSetup_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _broadcastContextSetup_val_UnsuccessfulOutcome), ('procedureCode', 59), ('criticality', 'reject')])
    
    #-----< broadcastContextRelease >-----#
    broadcastContextRelease = CLASS(name='broadcastContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _broadcastContextRelease_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextReleaseCommand')))
    _broadcastContextRelease_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextReleaseComplete')))
    broadcastContextRelease._val = dict([('InitiatingMessage', _broadcastContextRelease_val_InitiatingMessage), ('SuccessfulOutcome', _broadcastContextRelease_val_SuccessfulOutcome), ('procedureCode', 60), ('criticality', 'reject')])
    
    #-----< broadcastContextReleaseRequest >-----#
    broadcastContextReleaseRequest = CLASS(name='broadcastContextReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _broadcastContextReleaseRequest_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextReleaseRequest')))
    broadcastContextReleaseRequest._val = dict([('InitiatingMessage', _broadcastContextReleaseRequest_val_InitiatingMessage), ('procedureCode', 61), ('criticality', 'reject')])
    
    #-----< broadcastContextModification >-----#
    broadcastContextModification = CLASS(name='broadcastContextModification', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _broadcastContextModification_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextModificationRequest')))
    _broadcastContextModification_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextModificationResponse')))
    _broadcastContextModification_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'BroadcastContextModificationFailure')))
    broadcastContextModification._val = dict([('InitiatingMessage', _broadcastContextModification_val_InitiatingMessage), ('SuccessfulOutcome', _broadcastContextModification_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _broadcastContextModification_val_UnsuccessfulOutcome), ('procedureCode', 62), ('criticality', 'reject')])
    
    #-----< multicastGroupPaging >-----#
    multicastGroupPaging = CLASS(name='multicastGroupPaging', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _multicastGroupPaging_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastGroupPaging')))
    multicastGroupPaging._val = dict([('InitiatingMessage', _multicastGroupPaging_val_InitiatingMessage), ('procedureCode', 63), ('criticality', 'ignore')])
    
    #-----< multicastContextSetup >-----#
    multicastContextSetup = CLASS(name='multicastContextSetup', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _multicastContextSetup_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextSetupRequest')))
    _multicastContextSetup_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextSetupResponse')))
    _multicastContextSetup_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextSetupFailure')))
    multicastContextSetup._val = dict([('InitiatingMessage', _multicastContextSetup_val_InitiatingMessage), ('SuccessfulOutcome', _multicastContextSetup_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _multicastContextSetup_val_UnsuccessfulOutcome), ('procedureCode', 64), ('criticality', 'reject')])
    
    #-----< multicastContextRelease >-----#
    multicastContextRelease = CLASS(name='multicastContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _multicastContextRelease_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextReleaseCommand')))
    _multicastContextRelease_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextReleaseComplete')))
    multicastContextRelease._val = dict([('InitiatingMessage', _multicastContextRelease_val_InitiatingMessage), ('SuccessfulOutcome', _multicastContextRelease_val_SuccessfulOutcome), ('procedureCode', 65), ('criticality', 'reject')])
    
    #-----< multicastContextReleaseRequest >-----#
    multicastContextReleaseRequest = CLASS(name='multicastContextReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _multicastContextReleaseRequest_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextReleaseRequest')))
    multicastContextReleaseRequest._val = dict([('InitiatingMessage', _multicastContextReleaseRequest_val_InitiatingMessage), ('procedureCode', 66), ('criticality', 'reject')])
    
    #-----< multicastContextModification >-----#
    multicastContextModification = CLASS(name='multicastContextModification', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _multicastContextModification_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextModificationRequest')))
    _multicastContextModification_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextModificationResponse')))
    _multicastContextModification_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastContextModificationFailure')))
    multicastContextModification._val = dict([('InitiatingMessage', _multicastContextModification_val_InitiatingMessage), ('SuccessfulOutcome', _multicastContextModification_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _multicastContextModification_val_UnsuccessfulOutcome), ('procedureCode', 67), ('criticality', 'reject')])
    
    #-----< multicastDistributionSetup >-----#
    multicastDistributionSetup = CLASS(name='multicastDistributionSetup', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _multicastDistributionSetup_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionSetupRequest')))
    _multicastDistributionSetup_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionSetupResponse')))
    _multicastDistributionSetup_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionSetupFailure')))
    multicastDistributionSetup._val = dict([('InitiatingMessage', _multicastDistributionSetup_val_InitiatingMessage), ('SuccessfulOutcome', _multicastDistributionSetup_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _multicastDistributionSetup_val_UnsuccessfulOutcome), ('procedureCode', 68), ('criticality', 'reject')])
    
    #-----< multicastDistributionRelease >-----#
    multicastDistributionRelease = CLASS(name='multicastDistributionRelease', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _multicastDistributionRelease_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionReleaseCommand')))
    _multicastDistributionRelease_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MulticastDistributionReleaseComplete')))
    multicastDistributionRelease._val = dict([('InitiatingMessage', _multicastDistributionRelease_val_InitiatingMessage), ('SuccessfulOutcome', _multicastDistributionRelease_val_SuccessfulOutcome), ('procedureCode', 69), ('criticality', 'reject')])
    
    #-----< pDCMeasurementInitiation >-----#
    pDCMeasurementInitiation = CLASS(name='pDCMeasurementInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _pDCMeasurementInitiation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementInitiationRequest')))
    _pDCMeasurementInitiation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementInitiationResponse')))
    _pDCMeasurementInitiation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementInitiationFailure')))
    pDCMeasurementInitiation._val = dict([('InitiatingMessage', _pDCMeasurementInitiation_val_InitiatingMessage), ('SuccessfulOutcome', _pDCMeasurementInitiation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _pDCMeasurementInitiation_val_UnsuccessfulOutcome), ('procedureCode', 70), ('criticality', 'reject')])
    
    #-----< pDCMeasurementReport >-----#
    pDCMeasurementReport = CLASS(name='pDCMeasurementReport', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _pDCMeasurementReport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementReport')))
    pDCMeasurementReport._val = dict([('InitiatingMessage', _pDCMeasurementReport_val_InitiatingMessage), ('procedureCode', 71), ('criticality', 'ignore')])
    
    #-----< pDCMeasurementTerminationCommand >-----#
    pDCMeasurementTerminationCommand = CLASS(name='pDCMeasurementTerminationCommand', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _pDCMeasurementTerminationCommand_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementTerminationCommand')))
    pDCMeasurementTerminationCommand._val = dict([('InitiatingMessage', _pDCMeasurementTerminationCommand_val_InitiatingMessage), ('procedureCode', 79), ('criticality', 'ignore')])
    
    #-----< pDCMeasurementFailureIndication >-----#
    pDCMeasurementFailureIndication = CLASS(name='pDCMeasurementFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _pDCMeasurementFailureIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PDCMeasurementFailureIndication')))
    pDCMeasurementFailureIndication._val = dict([('InitiatingMessage', _pDCMeasurementFailureIndication_val_InitiatingMessage), ('procedureCode', 80), ('criticality', 'ignore')])
    
    #-----< pRSConfigurationExchange >-----#
    pRSConfigurationExchange = CLASS(name='pRSConfigurationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _pRSConfigurationExchange_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PRSConfigurationRequest')))
    _pRSConfigurationExchange_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PRSConfigurationResponse')))
    _pRSConfigurationExchange_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PRSConfigurationFailure')))
    pRSConfigurationExchange._val = dict([('InitiatingMessage', _pRSConfigurationExchange_val_InitiatingMessage), ('SuccessfulOutcome', _pRSConfigurationExchange_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _pRSConfigurationExchange_val_UnsuccessfulOutcome), ('procedureCode', 75), ('criticality', 'reject')])
    
    #-----< measurementPreconfiguration >-----#
    measurementPreconfiguration = CLASS(name='measurementPreconfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _measurementPreconfiguration_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MeasurementPreconfigurationRequired')))
    _measurementPreconfiguration_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MeasurementPreconfigurationConfirm')))
    _measurementPreconfiguration_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MeasurementPreconfigurationRefuse')))
    measurementPreconfiguration._val = dict([('InitiatingMessage', _measurementPreconfiguration_val_InitiatingMessage), ('SuccessfulOutcome', _measurementPreconfiguration_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _measurementPreconfiguration_val_UnsuccessfulOutcome), ('procedureCode', 76), ('criticality', 'reject')])
    
    #-----< measurementActivation >-----#
    measurementActivation = CLASS(name='measurementActivation', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _measurementActivation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'MeasurementActivation')))
    measurementActivation._val = dict([('InitiatingMessage', _measurementActivation_val_InitiatingMessage), ('procedureCode', 77), ('criticality', 'ignore')])
    
    #-----< qoEInformationTransfer >-----#
    qoEInformationTransfer = CLASS(name='qoEInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _qoEInformationTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'QoEInformationTransfer')))
    qoEInformationTransfer._val = dict([('InitiatingMessage', _qoEInformationTransfer_val_InitiatingMessage), ('procedureCode', 78), ('criticality', 'ignore')])
    
    #-----< posSystemInformationDelivery >-----#
    posSystemInformationDelivery = CLASS(name='posSystemInformationDelivery', mode=MODE_VALUE, typeref=ASN1RefType(('F1AP-PDU-Descriptions', 'F1AP-ELEMENTARY-PROCEDURE')))
    _posSystemInformationDelivery_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('F1AP-PDU-Contents', 'PosSystemInformationDeliveryCommand')))
    posSystemInformationDelivery._val = dict([('InitiatingMessage', _posSystemInformationDelivery_val_InitiatingMessage), ('procedureCode', 81), ('criticality', 'ignore')])
    
    _all_ = [
        _F1AP_ELEMENTARY_PROCEDURE_InitiatingMessage,
        _F1AP_ELEMENTARY_PROCEDURE_SuccessfulOutcome,
        _F1AP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome,
        _F1AP_ELEMENTARY_PROCEDURE_procedureCode,
        _F1AP_ELEMENTARY_PROCEDURE_criticality,
        F1AP_ELEMENTARY_PROCEDURE,
        _F1AP_PDU_initiatingMessage,
        _F1AP_PDU_successfulOutcome,
        _F1AP_PDU_unsuccessfulOutcome,
        ___F1AP_PDU_choice_extension_id_tab,
        __F1AP_PDU_choice_extension_id,
        ___F1AP_PDU_choice_extension_criticality_tab,
        __F1AP_PDU_choice_extension_criticality,
        ___F1AP_PDU_choice_extension_value_tab,
        __F1AP_PDU_choice_extension_value,
        _F1AP_PDU_choice_extension,
        F1AP_PDU,
        F1AP_PDU_ExtIEs,
        __InitiatingMessage_procedureCode_tab,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_11,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_12,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_13,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_13,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_14,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_14,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_15,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_15,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_16,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_16,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_17,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_17,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_18,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_18,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_19,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_19,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_20,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_20,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_21,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_21,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_22,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_22,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_23,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_24,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_24,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_25,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_25,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_26,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_27,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_27,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_28,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_28,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_29,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_30,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_30,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_31,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_31,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_32,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_32,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_49,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_50,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_51,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_52,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_53,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_54,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_55,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_56,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_57,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_58,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_59,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_60,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_61,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_62,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_63,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_64,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_65,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_66,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_67,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_68,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_69,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_70,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_71,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_72,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_73,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_74,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_75,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_76,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_77,
        _InitiatingMessage_procedureCode,
        _InitiatingMessage_criticality,
        _InitiatingMessage_value,
        InitiatingMessage,
        __SuccessfulOutcome_procedureCode_tab,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_15,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_17,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_18,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_19,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_20,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_21,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_21,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_22,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_22,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_23,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_24,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_24,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_25,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_25,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_26,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_27,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_27,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_28,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_28,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_29,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_30,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_30,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_31,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_31,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_32,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_32,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_66,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_67,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_68,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_69,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_70,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_71,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_72,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_73,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_74,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_75,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_76,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_77,
        _SuccessfulOutcome_procedureCode,
        _SuccessfulOutcome_criticality,
        _SuccessfulOutcome_value,
        SuccessfulOutcome,
        __UnsuccessfulOutcome_procedureCode_tab,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_17,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_18,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_19,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_20,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_21,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_21,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_22,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_22,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_23,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_24,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_24,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_25,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_25,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_26,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_27,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_27,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_28,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_28,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_29,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_30,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_30,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_31,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_31,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_32,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_32,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_66,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_67,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_68,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_69,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_70,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_71,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_72,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_73,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_74,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_75,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_76,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_77,
        _UnsuccessfulOutcome_procedureCode,
        _UnsuccessfulOutcome_criticality,
        _UnsuccessfulOutcome_value,
        UnsuccessfulOutcome,
        F1AP_ELEMENTARY_PROCEDURES,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_14,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_15,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_16,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_16,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_17,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_17,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_18,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_18,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_19,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_19,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_20,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_20,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_21,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_21,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_22,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_22,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_23,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_24,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_24,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_25,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_25,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_26,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_27,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_27,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_28,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_28,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_29,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_30,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_30,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_31,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_31,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32,
        _F1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_32,
        _F1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_32,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_58,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_59,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_60,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_61,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_62,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_63,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_64,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_65,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_66,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_67,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_68,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_69,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_70,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_71,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_72,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_73,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_74,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_75,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_76,
        _F1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_77,
        F1AP_ELEMENTARY_PROCEDURES_CLASS_1,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_15,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_16,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_17,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_18,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_19,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_20,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_21,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_21,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_22,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_22,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_22,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_23,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_23,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_24,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_24,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_24,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_25,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_25,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_25,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_26,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_26,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_27,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_27,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_27,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_28,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_28,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_28,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_29,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_29,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_30,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_30,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_30,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_31,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_31,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_31,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_32,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_32,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_32,
        F1AP_ELEMENTARY_PROCEDURES_CLASS_2,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_32,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_33,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_34,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_35,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_36,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_37,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_38,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_39,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_40,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_41,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_42,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_43,
        _F1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_44,
        reset,
        _reset_val_InitiatingMessage,
        _reset_val_SuccessfulOutcome,
        f1Setup,
        _f1Setup_val_InitiatingMessage,
        _f1Setup_val_SuccessfulOutcome,
        _f1Setup_val_UnsuccessfulOutcome,
        gNBDUConfigurationUpdate,
        _gNBDUConfigurationUpdate_val_InitiatingMessage,
        _gNBDUConfigurationUpdate_val_SuccessfulOutcome,
        _gNBDUConfigurationUpdate_val_UnsuccessfulOutcome,
        gNBCUConfigurationUpdate,
        _gNBCUConfigurationUpdate_val_InitiatingMessage,
        _gNBCUConfigurationUpdate_val_SuccessfulOutcome,
        _gNBCUConfigurationUpdate_val_UnsuccessfulOutcome,
        uEContextSetup,
        _uEContextSetup_val_InitiatingMessage,
        _uEContextSetup_val_SuccessfulOutcome,
        _uEContextSetup_val_UnsuccessfulOutcome,
        uEContextRelease,
        _uEContextRelease_val_InitiatingMessage,
        _uEContextRelease_val_SuccessfulOutcome,
        uEContextModification,
        _uEContextModification_val_InitiatingMessage,
        _uEContextModification_val_SuccessfulOutcome,
        _uEContextModification_val_UnsuccessfulOutcome,
        uEContextModificationRequired,
        _uEContextModificationRequired_val_InitiatingMessage,
        _uEContextModificationRequired_val_SuccessfulOutcome,
        _uEContextModificationRequired_val_UnsuccessfulOutcome,
        writeReplaceWarning,
        _writeReplaceWarning_val_InitiatingMessage,
        _writeReplaceWarning_val_SuccessfulOutcome,
        pWSCancel,
        _pWSCancel_val_InitiatingMessage,
        _pWSCancel_val_SuccessfulOutcome,
        errorIndication,
        _errorIndication_val_InitiatingMessage,
        uEContextReleaseRequest,
        _uEContextReleaseRequest_val_InitiatingMessage,
        initialULRRCMessageTransfer,
        _initialULRRCMessageTransfer_val_InitiatingMessage,
        dLRRCMessageTransfer,
        _dLRRCMessageTransfer_val_InitiatingMessage,
        uLRRCMessageTransfer,
        _uLRRCMessageTransfer_val_InitiatingMessage,
        uEInactivityNotification,
        _uEInactivityNotification_val_InitiatingMessage,
        gNBDUResourceCoordination,
        _gNBDUResourceCoordination_val_InitiatingMessage,
        _gNBDUResourceCoordination_val_SuccessfulOutcome,
        privateMessage,
        _privateMessage_val_InitiatingMessage,
        systemInformationDelivery,
        _systemInformationDelivery_val_InitiatingMessage,
        paging,
        _paging_val_InitiatingMessage,
        notify,
        _notify_val_InitiatingMessage,
        networkAccessRateReduction,
        _networkAccessRateReduction_val_InitiatingMessage,
        pWSRestartIndication,
        _pWSRestartIndication_val_InitiatingMessage,
        pWSFailureIndication,
        _pWSFailureIndication_val_InitiatingMessage,
        gNBDUStatusIndication,
        _gNBDUStatusIndication_val_InitiatingMessage,
        rRCDeliveryReport,
        _rRCDeliveryReport_val_InitiatingMessage,
        f1Removal,
        _f1Removal_val_InitiatingMessage,
        _f1Removal_val_SuccessfulOutcome,
        _f1Removal_val_UnsuccessfulOutcome,
        traceStart,
        _traceStart_val_InitiatingMessage,
        deactivateTrace,
        _deactivateTrace_val_InitiatingMessage,
        dUCURadioInformationTransfer,
        _dUCURadioInformationTransfer_val_InitiatingMessage,
        cUDURadioInformationTransfer,
        _cUDURadioInformationTransfer_val_InitiatingMessage,
        bAPMappingConfiguration,
        _bAPMappingConfiguration_val_InitiatingMessage,
        _bAPMappingConfiguration_val_SuccessfulOutcome,
        _bAPMappingConfiguration_val_UnsuccessfulOutcome,
        gNBDUResourceConfiguration,
        _gNBDUResourceConfiguration_val_InitiatingMessage,
        _gNBDUResourceConfiguration_val_SuccessfulOutcome,
        _gNBDUResourceConfiguration_val_UnsuccessfulOutcome,
        iABTNLAddressAllocation,
        _iABTNLAddressAllocation_val_InitiatingMessage,
        _iABTNLAddressAllocation_val_SuccessfulOutcome,
        _iABTNLAddressAllocation_val_UnsuccessfulOutcome,
        iABUPConfigurationUpdate,
        _iABUPConfigurationUpdate_val_InitiatingMessage,
        _iABUPConfigurationUpdate_val_SuccessfulOutcome,
        _iABUPConfigurationUpdate_val_UnsuccessfulOutcome,
        resourceStatusReportingInitiation,
        _resourceStatusReportingInitiation_val_InitiatingMessage,
        _resourceStatusReportingInitiation_val_SuccessfulOutcome,
        _resourceStatusReportingInitiation_val_UnsuccessfulOutcome,
        resourceStatusReporting,
        _resourceStatusReporting_val_InitiatingMessage,
        accessAndMobilityIndication,
        _accessAndMobilityIndication_val_InitiatingMessage,
        referenceTimeInformationReportingControl,
        _referenceTimeInformationReportingControl_val_InitiatingMessage,
        referenceTimeInformationReport,
        _referenceTimeInformationReport_val_InitiatingMessage,
        accessSuccess,
        _accessSuccess_val_InitiatingMessage,
        cellTrafficTrace,
        _cellTrafficTrace_val_InitiatingMessage,
        positioningAssistanceInformationControl,
        _positioningAssistanceInformationControl_val_InitiatingMessage,
        positioningAssistanceInformationFeedback,
        _positioningAssistanceInformationFeedback_val_InitiatingMessage,
        positioningMeasurementExchange,
        _positioningMeasurementExchange_val_InitiatingMessage,
        _positioningMeasurementExchange_val_SuccessfulOutcome,
        _positioningMeasurementExchange_val_UnsuccessfulOutcome,
        positioningMeasurementReport,
        _positioningMeasurementReport_val_InitiatingMessage,
        positioningMeasurementAbort,
        _positioningMeasurementAbort_val_InitiatingMessage,
        positioningMeasurementFailureIndication,
        _positioningMeasurementFailureIndication_val_InitiatingMessage,
        positioningMeasurementUpdate,
        _positioningMeasurementUpdate_val_InitiatingMessage,
        tRPInformationExchange,
        _tRPInformationExchange_val_InitiatingMessage,
        _tRPInformationExchange_val_SuccessfulOutcome,
        _tRPInformationExchange_val_UnsuccessfulOutcome,
        positioningInformationExchange,
        _positioningInformationExchange_val_InitiatingMessage,
        _positioningInformationExchange_val_SuccessfulOutcome,
        _positioningInformationExchange_val_UnsuccessfulOutcome,
        positioningActivation,
        _positioningActivation_val_InitiatingMessage,
        _positioningActivation_val_SuccessfulOutcome,
        _positioningActivation_val_UnsuccessfulOutcome,
        positioningDeactivation,
        _positioningDeactivation_val_InitiatingMessage,
        e_CIDMeasurementInitiation,
        _e_CIDMeasurementInitiation_val_InitiatingMessage,
        _e_CIDMeasurementInitiation_val_SuccessfulOutcome,
        _e_CIDMeasurementInitiation_val_UnsuccessfulOutcome,
        e_CIDMeasurementFailureIndication,
        _e_CIDMeasurementFailureIndication_val_InitiatingMessage,
        e_CIDMeasurementReport,
        _e_CIDMeasurementReport_val_InitiatingMessage,
        e_CIDMeasurementTermination,
        _e_CIDMeasurementTermination_val_InitiatingMessage,
        positioningInformationUpdate,
        _positioningInformationUpdate_val_InitiatingMessage,
        broadcastContextSetup,
        _broadcastContextSetup_val_InitiatingMessage,
        _broadcastContextSetup_val_SuccessfulOutcome,
        _broadcastContextSetup_val_UnsuccessfulOutcome,
        broadcastContextRelease,
        _broadcastContextRelease_val_InitiatingMessage,
        _broadcastContextRelease_val_SuccessfulOutcome,
        broadcastContextReleaseRequest,
        _broadcastContextReleaseRequest_val_InitiatingMessage,
        broadcastContextModification,
        _broadcastContextModification_val_InitiatingMessage,
        _broadcastContextModification_val_SuccessfulOutcome,
        _broadcastContextModification_val_UnsuccessfulOutcome,
        multicastGroupPaging,
        _multicastGroupPaging_val_InitiatingMessage,
        multicastContextSetup,
        _multicastContextSetup_val_InitiatingMessage,
        _multicastContextSetup_val_SuccessfulOutcome,
        _multicastContextSetup_val_UnsuccessfulOutcome,
        multicastContextRelease,
        _multicastContextRelease_val_InitiatingMessage,
        _multicastContextRelease_val_SuccessfulOutcome,
        multicastContextReleaseRequest,
        _multicastContextReleaseRequest_val_InitiatingMessage,
        multicastContextModification,
        _multicastContextModification_val_InitiatingMessage,
        _multicastContextModification_val_SuccessfulOutcome,
        _multicastContextModification_val_UnsuccessfulOutcome,
        multicastDistributionSetup,
        _multicastDistributionSetup_val_InitiatingMessage,
        _multicastDistributionSetup_val_SuccessfulOutcome,
        _multicastDistributionSetup_val_UnsuccessfulOutcome,
        multicastDistributionRelease,
        _multicastDistributionRelease_val_InitiatingMessage,
        _multicastDistributionRelease_val_SuccessfulOutcome,
        pDCMeasurementInitiation,
        _pDCMeasurementInitiation_val_InitiatingMessage,
        _pDCMeasurementInitiation_val_SuccessfulOutcome,
        _pDCMeasurementInitiation_val_UnsuccessfulOutcome,
        pDCMeasurementReport,
        _pDCMeasurementReport_val_InitiatingMessage,
        pDCMeasurementTerminationCommand,
        _pDCMeasurementTerminationCommand_val_InitiatingMessage,
        pDCMeasurementFailureIndication,
        _pDCMeasurementFailureIndication_val_InitiatingMessage,
        pRSConfigurationExchange,
        _pRSConfigurationExchange_val_InitiatingMessage,
        _pRSConfigurationExchange_val_SuccessfulOutcome,
        _pRSConfigurationExchange_val_UnsuccessfulOutcome,
        measurementPreconfiguration,
        _measurementPreconfiguration_val_InitiatingMessage,
        _measurementPreconfiguration_val_SuccessfulOutcome,
        _measurementPreconfiguration_val_UnsuccessfulOutcome,
        measurementActivation,
        _measurementActivation_val_InitiatingMessage,
        qoEInformationTransfer,
        _qoEInformationTransfer_val_InitiatingMessage,
        posSystemInformationDelivery,
        _posSystemInformationDelivery_val_InitiatingMessage,
    ]

init_modules(F1AP_CommonDataTypes, F1AP_Constants, F1AP_Containers, F1AP_IEs, F1AP_PDU_Contents, F1AP_PDU_Descriptions)
