# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class CONF_HI3_IMS:

    _name_  = u'CONF-HI3-IMS'
    _oid_   = [0, 4, 0, 2, 2, 4, 11, 13, 0]
    
    _obj_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi3confDomainId',
        u'Conf-CC-PDU',
        u'ConfLIC-header',
        u'MediaID',
        u'TPDU-direction',
        ]
    _type_ = [
        u'Conf-CC-PDU',
        u'ConfLIC-header',
        u'MediaID',
        u'TPDU-direction',
        ]
    _set_ = [
        ]
    _val_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi3confDomainId',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< lawfulInterceptDomainId >-----#
    lawfulInterceptDomainId = OID(name=u'lawfulInterceptDomainId', mode=MODE_VALUE)
    lawfulInterceptDomainId._val = (0, 4, 0, 2, 2)
    
    #-----< threeGPPSUBDomainId >-----#
    threeGPPSUBDomainId = OID(name=u'threeGPPSUBDomainId', mode=MODE_VALUE)
    threeGPPSUBDomainId._val = (0, 4, 0, 2, 2, 4)
    
    #-----< hi3confDomainId >-----#
    hi3confDomainId = OID(name=u'hi3confDomainId', mode=MODE_VALUE)
    hi3confDomainId._val = (0, 4, 0, 2, 2, 4, 11, 13, 0)
    
    #-----< Conf-CC-PDU >-----#
    Conf_CC_PDU = SEQ(name=u'Conf-CC-PDU', mode=MODE_TYPE)
    _Conf_CC_PDU_confLIC_header = SEQ(name=u'confLIC-header', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONF-HI3-IMS', 'ConfLIC-header')))
    _Conf_CC_PDU_payload = OCT_STR(name=u'payload', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Conf_CC_PDU._cont = ASN1Dict([
        (u'confLIC-header', _Conf_CC_PDU_confLIC_header),
        (u'payload', _Conf_CC_PDU_payload),
        ])
    Conf_CC_PDU._ext = None
    
    #-----< ConfLIC-header >-----#
    ConfLIC_header = SEQ(name=u'ConfLIC-header', mode=MODE_TYPE)
    _ConfLIC_header_hi3DomainId = OID(name=u'hi3DomainId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConfLIC_header_lIID = OCT_STR(name=u'lIID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'LawfulInterceptionIdentifier')), opt=True)
    _ConfLIC_header_correlation = CHOICE(name=u'correlation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'ConfCorrelation')))
    _ConfLIC_header_timeStamp = CHOICE(name=u'timeStamp', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')), opt=True)
    _ConfLIC_header_sequence_number = INT(name=u'sequence-number', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConfLIC_header_sequence_number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ConfLIC_header_t_PDU_direction = ENUM(name=u't-PDU-direction', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONF-HI3-IMS', 'TPDU-direction')))
    _ConfLIC_header_national_HI3_ASN1parameters = SEQ(name=u'national-HI3-ASN1parameters', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Eps-HI3-PS', 'National-HI3-ASN1parameters')), opt=True)
    _ConfLIC_header_mediaID = SEQ(name=u'mediaID', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONF-HI3-IMS', 'MediaID')), opt=True)
    ConfLIC_header._cont = ASN1Dict([
        (u'hi3DomainId', _ConfLIC_header_hi3DomainId),
        (u'lIID', _ConfLIC_header_lIID),
        (u'correlation', _ConfLIC_header_correlation),
        (u'timeStamp', _ConfLIC_header_timeStamp),
        (u'sequence-number', _ConfLIC_header_sequence_number),
        (u't-PDU-direction', _ConfLIC_header_t_PDU_direction),
        (u'national-HI3-ASN1parameters', _ConfLIC_header_national_HI3_ASN1parameters),
        (u'mediaID', _ConfLIC_header_mediaID),
        ])
    ConfLIC_header._ext = []
    
    #-----< MediaID >-----#
    MediaID = SEQ(name=u'MediaID', mode=MODE_TYPE)
    _MediaID_sourceUserID = SEQ(name=u'sourceUserID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'ConfPartyInformation')), opt=True)
    _MediaID_streamID = OCT_STR(name=u'streamID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    MediaID._cont = ASN1Dict([
        (u'sourceUserID', _MediaID_sourceUserID),
        (u'streamID', _MediaID_streamID),
        ])
    MediaID._ext = []
    
    #-----< TPDU-direction >-----#
    TPDU_direction = ENUM(name=u'TPDU-direction', mode=MODE_TYPE)
    TPDU_direction._cont = ASN1Dict([(u'from-target', 1), (u'to-target', 2), (u'unknown', 3), (u'conftarget', 4), (u'from-mixer', 5), (u'to-mixer', 6), (u'combined', 7)])
    TPDU_direction._ext = None
    
    _all_ = [
        lawfulInterceptDomainId,
        threeGPPSUBDomainId,
        hi3confDomainId,
        _Conf_CC_PDU_confLIC_header,
        _Conf_CC_PDU_payload,
        Conf_CC_PDU,
        _ConfLIC_header_hi3DomainId,
        _ConfLIC_header_lIID,
        _ConfLIC_header_correlation,
        _ConfLIC_header_timeStamp,
        _ConfLIC_header_sequence_number,
        _ConfLIC_header_t_PDU_direction,
        _ConfLIC_header_national_HI3_ASN1parameters,
        _ConfLIC_header_mediaID,
        ConfLIC_header,
        _MediaID_sourceUserID,
        _MediaID_streamID,
        MediaID,
        TPDU_direction,
    ]

class CONFHI2Operations:

    _name_  = u'CONFHI2Operations'
    _oid_   = [0, 4, 0, 2, 2, 4, 10, 16, 0]
    
    _obj_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi2confDomainId',
        u'ConfIRIsContent',
        u'ConfIRISequence',
        u'ConfIRIContent',
        u'IRI-Parameters',
        u'ConfEvent',
        u'ConfPartyInformation',
        u'ConfCorrelation',
        u'PartyIdentity',
        u'IMSIdentity',
        u'SupportedMedia',
        u'MediaModification',
        u'ConfEventFailureReason',
        u'ConfEventInitiator',
        u'RecurrenceInfo',
        u'Reason',
        ]
    _type_ = [
        u'ConfIRIsContent',
        u'ConfIRISequence',
        u'ConfIRIContent',
        u'IRI-Parameters',
        u'ConfEvent',
        u'ConfPartyInformation',
        u'ConfCorrelation',
        u'PartyIdentity',
        u'IMSIdentity',
        u'SupportedMedia',
        u'MediaModification',
        u'ConfEventFailureReason',
        u'ConfEventInitiator',
        u'RecurrenceInfo',
        u'Reason',
        ]
    _set_ = [
        ]
    _val_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi2confDomainId',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< lawfulInterceptDomainId >-----#
    lawfulInterceptDomainId = OID(name=u'lawfulInterceptDomainId', mode=MODE_VALUE)
    lawfulInterceptDomainId._val = (0, 4, 0, 2, 2)
    
    #-----< threeGPPSUBDomainId >-----#
    threeGPPSUBDomainId = OID(name=u'threeGPPSUBDomainId', mode=MODE_VALUE)
    threeGPPSUBDomainId._val = (0, 4, 0, 2, 2, 4)
    
    #-----< hi2confDomainId >-----#
    hi2confDomainId = OID(name=u'hi2confDomainId', mode=MODE_VALUE)
    hi2confDomainId._val = (0, 4, 0, 2, 2, 4, 10, 16, 0)
    
    #-----< ConfIRIsContent >-----#
    ConfIRIsContent = CHOICE(name=u'ConfIRIsContent', mode=MODE_TYPE)
    _ConfIRIsContent_confiRIContent = CHOICE(name=u'confiRIContent', mode=MODE_TYPE, typeref=ASN1RefType(('CONFHI2Operations', 'ConfIRIContent')))
    _ConfIRIsContent_confIRISequence = SEQ_OF(name=u'confIRISequence', mode=MODE_TYPE, typeref=ASN1RefType(('CONFHI2Operations', 'ConfIRISequence')))
    ConfIRIsContent._cont = ASN1Dict([
        (u'confiRIContent', _ConfIRIsContent_confiRIContent),
        (u'confIRISequence', _ConfIRIsContent_confIRISequence),
        ])
    ConfIRIsContent._ext = None
    
    #-----< ConfIRISequence >-----#
    ConfIRISequence = SEQ_OF(name=u'ConfIRISequence', mode=MODE_TYPE)
    _ConfIRISequence__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CONFHI2Operations', 'ConfIRIContent')))
    ConfIRISequence._cont = _ConfIRISequence__item_
    
    #-----< ConfIRIContent >-----#
    ConfIRIContent = CHOICE(name=u'ConfIRIContent', mode=MODE_TYPE)
    _ConfIRIContent_iRI_Begin_record = SEQ(name=u'iRI-Begin-record', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'IRI-Parameters')))
    _ConfIRIContent_iRI_End_record = SEQ(name=u'iRI-End-record', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'IRI-Parameters')))
    _ConfIRIContent_iRI_Continue_record = SEQ(name=u'iRI-Continue-record', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'IRI-Parameters')))
    _ConfIRIContent_iRI_Report_record = SEQ(name=u'iRI-Report-record', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'IRI-Parameters')))
    ConfIRIContent._cont = ASN1Dict([
        (u'iRI-Begin-record', _ConfIRIContent_iRI_Begin_record),
        (u'iRI-End-record', _ConfIRIContent_iRI_End_record),
        (u'iRI-Continue-record', _ConfIRIContent_iRI_Continue_record),
        (u'iRI-Report-record', _ConfIRIContent_iRI_Report_record),
        ])
    ConfIRIContent._ext = []
    
    #-----< IRI-Parameters >-----#
    IRI_Parameters = SEQ(name=u'IRI-Parameters', mode=MODE_TYPE)
    _IRI_Parameters_hi2confDomainId = OID(name=u'hi2confDomainId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IRI_Parameters_lawfulInterceptionIdentifier = OCT_STR(name=u'lawfulInterceptionIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'LawfulInterceptionIdentifier')))
    _IRI_Parameters_timeStamp = CHOICE(name=u'timeStamp', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    _IRI_Parameters_partyInformation = SET_OF(name=u'partyInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IRI_Parameters_partyInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CONFHI2Operations', 'PartyIdentity')))
    _IRI_Parameters_partyInformation._cont = __IRI_Parameters_partyInformation__item_
    _IRI_Parameters_partyInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _IRI_Parameters_national_Parameters = SET_OF(name=u'national-Parameters', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'National-Parameters')), opt=True)
    _IRI_Parameters_networkIdentifier = SEQ(name=u'networkIdentifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'Network-Identifier')), opt=True)
    _IRI_Parameters_confEvent = ENUM(name=u'confEvent', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'ConfEvent')))
    _IRI_Parameters_correlation = CHOICE(name=u'correlation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'ConfCorrelation')), opt=True)
    _IRI_Parameters_confID = SEQ(name=u'confID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'IMSIdentity')), opt=True)
    _IRI_Parameters_tempConfID = SEQ(name=u'tempConfID', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'IMSIdentity')), opt=True)
    _IRI_Parameters_listOfPotConferees = SET_OF(name=u'listOfPotConferees', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IRI_Parameters_listOfPotConferees__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CONFHI2Operations', 'PartyIdentity')))
    _IRI_Parameters_listOfPotConferees._cont = __IRI_Parameters_listOfPotConferees__item_
    _IRI_Parameters_listOfConferees = SET_OF(name=u'listOfConferees', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IRI_Parameters_listOfConferees__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CONFHI2Operations', 'ConfPartyInformation')))
    _IRI_Parameters_listOfConferees._cont = __IRI_Parameters_listOfConferees__item_
    _IRI_Parameters_joinPartyID = SEQ(name=u'joinPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'ConfPartyInformation')), opt=True)
    _IRI_Parameters_leavePartyID = SEQ(name=u'leavePartyID', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'ConfPartyInformation')), opt=True)
    _IRI_Parameters_listOfBearerAffectedParties = SET_OF(name=u'listOfBearerAffectedParties', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IRI_Parameters_listOfBearerAffectedParties__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CONFHI2Operations', 'ConfPartyInformation')))
    _IRI_Parameters_listOfBearerAffectedParties._cont = __IRI_Parameters_listOfBearerAffectedParties__item_
    _IRI_Parameters_confEventInitiator = CHOICE(name=u'confEventInitiator', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'ConfEventInitiator')), opt=True)
    _IRI_Parameters_confEventFailureReason = CHOICE(name=u'confEventFailureReason', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'ConfEventFailureReason')), opt=True)
    _IRI_Parameters_confEndReason = OCT_STR(name=u'confEndReason', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'Reason')), opt=True)
    _IRI_Parameters_potConfStartInfo = CHOICE(name=u'potConfStartInfo', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')), opt=True)
    _IRI_Parameters_potConfEndInfo = CHOICE(name=u'potConfEndInfo', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')), opt=True)
    _IRI_Parameters_recurrenceInfo = SEQ(name=u'recurrenceInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'RecurrenceInfo')), opt=True)
    _IRI_Parameters_confControllerIDs = SET_OF(name=u'confControllerIDs', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IRI_Parameters_confControllerIDs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CONFHI2Operations', 'PartyIdentity')))
    _IRI_Parameters_confControllerIDs._cont = __IRI_Parameters_confControllerIDs__item_
    _IRI_Parameters_mediamodification = ENUM(name=u'mediamodification', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'MediaModification')), opt=True)
    _IRI_Parameters_bearerModifyPartyID = SEQ(name=u'bearerModifyPartyID', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'ConfPartyInformation')), opt=True)
    _IRI_Parameters_listOfWaitConferees = SET_OF(name=u'listOfWaitConferees', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IRI_Parameters_listOfWaitConferees__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CONFHI2Operations', 'ConfPartyInformation')))
    _IRI_Parameters_listOfWaitConferees._cont = __IRI_Parameters_listOfWaitConferees__item_
    IRI_Parameters._cont = ASN1Dict([
        (u'hi2confDomainId', _IRI_Parameters_hi2confDomainId),
        (u'lawfulInterceptionIdentifier', _IRI_Parameters_lawfulInterceptionIdentifier),
        (u'timeStamp', _IRI_Parameters_timeStamp),
        (u'partyInformation', _IRI_Parameters_partyInformation),
        (u'national-Parameters', _IRI_Parameters_national_Parameters),
        (u'networkIdentifier', _IRI_Parameters_networkIdentifier),
        (u'confEvent', _IRI_Parameters_confEvent),
        (u'correlation', _IRI_Parameters_correlation),
        (u'confID', _IRI_Parameters_confID),
        (u'tempConfID', _IRI_Parameters_tempConfID),
        (u'listOfPotConferees', _IRI_Parameters_listOfPotConferees),
        (u'listOfConferees', _IRI_Parameters_listOfConferees),
        (u'joinPartyID', _IRI_Parameters_joinPartyID),
        (u'leavePartyID', _IRI_Parameters_leavePartyID),
        (u'listOfBearerAffectedParties', _IRI_Parameters_listOfBearerAffectedParties),
        (u'confEventInitiator', _IRI_Parameters_confEventInitiator),
        (u'confEventFailureReason', _IRI_Parameters_confEventFailureReason),
        (u'confEndReason', _IRI_Parameters_confEndReason),
        (u'potConfStartInfo', _IRI_Parameters_potConfStartInfo),
        (u'potConfEndInfo', _IRI_Parameters_potConfEndInfo),
        (u'recurrenceInfo', _IRI_Parameters_recurrenceInfo),
        (u'confControllerIDs', _IRI_Parameters_confControllerIDs),
        (u'mediamodification', _IRI_Parameters_mediamodification),
        (u'bearerModifyPartyID', _IRI_Parameters_bearerModifyPartyID),
        (u'listOfWaitConferees', _IRI_Parameters_listOfWaitConferees),
        ])
    IRI_Parameters._ext = []
    
    #-----< ConfEvent >-----#
    ConfEvent = ENUM(name=u'ConfEvent', mode=MODE_TYPE)
    ConfEvent._cont = ASN1Dict([(u'confStartSuccessfull', 1), (u'confStartUnsuccessfull', 2), (u'startOfInterceptionConferenceActive', 3), (u'confPartyJoinSuccessfull', 4), (u'confPartyJoinUnsuccessfull', 5), (u'confPartyLeaveSuccessfull', 6), (u'confPartyLeaveUnsuccessfull', 7), (u'confPartyBearerModifySuccessfull', 8), (u'confPartyBearerModifyUnsuccessfull', 9), (u'confEndSuccessfull', 10), (u'confEndUnsuccessfull', 11), (u'confServCreation', 12), (u'confServUpdate', 13)])
    ConfEvent._ext = []
    
    #-----< ConfPartyInformation >-----#
    ConfPartyInformation = SEQ(name=u'ConfPartyInformation', mode=MODE_TYPE)
    _ConfPartyInformation_partyIdentity = SEQ(name=u'partyIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'PartyIdentity')), opt=True)
    _ConfPartyInformation_supportedmedia = SEQ(name=u'supportedmedia', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'SupportedMedia')), opt=True)
    ConfPartyInformation._cont = ASN1Dict([
        (u'partyIdentity', _ConfPartyInformation_partyIdentity),
        (u'supportedmedia', _ConfPartyInformation_supportedmedia),
        ])
    ConfPartyInformation._ext = []
    
    #-----< ConfCorrelation >-----#
    ConfCorrelation = CHOICE(name=u'ConfCorrelation', mode=MODE_TYPE)
    _ConfCorrelation_correlationValues = CHOICE(name=u'correlationValues', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'CorrelationValues')))
    _ConfCorrelation_correlationNumber = OCT_STR(name=u'correlationNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConfCorrelation_imsVoIP = SET_OF(name=u'imsVoIP', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'IMS-VoIP-Correlation')))
    ConfCorrelation._cont = ASN1Dict([
        (u'correlationValues', _ConfCorrelation_correlationValues),
        (u'correlationNumber', _ConfCorrelation_correlationNumber),
        (u'imsVoIP', _ConfCorrelation_imsVoIP),
        ])
    ConfCorrelation._ext = []
    
    #-----< PartyIdentity >-----#
    PartyIdentity = SEQ(name=u'PartyIdentity', mode=MODE_TYPE)
    _PartyIdentity_iMPU = SET_OF(name=u'iMPU', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyIdentity_iMPU__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CONFHI2Operations', 'IMSIdentity')))
    _PartyIdentity_iMPU._cont = __PartyIdentity_iMPU__item_
    _PartyIdentity_iMPI = SET_OF(name=u'iMPI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyIdentity_iMPI__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CONFHI2Operations', 'IMSIdentity')))
    _PartyIdentity_iMPI._cont = __PartyIdentity_iMPI__item_
    PartyIdentity._cont = ASN1Dict([
        (u'iMPU', _PartyIdentity_iMPU),
        (u'iMPI', _PartyIdentity_iMPI),
        ])
    PartyIdentity._ext = []
    
    #-----< IMSIdentity >-----#
    IMSIdentity = SEQ(name=u'IMSIdentity', mode=MODE_TYPE)
    _IMSIdentity_sip_uri = OCT_STR(name=u'sip-uri', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IMSIdentity_tel_uri = OCT_STR(name=u'tel-uri', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    IMSIdentity._cont = ASN1Dict([
        (u'sip-uri', _IMSIdentity_sip_uri),
        (u'tel-uri', _IMSIdentity_tel_uri),
        ])
    IMSIdentity._ext = []
    
    #-----< SupportedMedia >-----#
    SupportedMedia = SEQ(name=u'SupportedMedia', mode=MODE_TYPE)
    _SupportedMedia_confServerSideSDP = OCT_STR(name=u'confServerSideSDP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SupportedMedia_confUserSideSDP = OCT_STR(name=u'confUserSideSDP', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SupportedMedia._cont = ASN1Dict([
        (u'confServerSideSDP', _SupportedMedia_confServerSideSDP),
        (u'confUserSideSDP', _SupportedMedia_confUserSideSDP),
        ])
    SupportedMedia._ext = []
    
    #-----< MediaModification >-----#
    MediaModification = ENUM(name=u'MediaModification', mode=MODE_TYPE)
    MediaModification._cont = ASN1Dict([(u'add', 1), (u'remove', 2), (u'change', 3), (u'unknown', 4)])
    MediaModification._ext = []
    
    #-----< ConfEventFailureReason >-----#
    ConfEventFailureReason = CHOICE(name=u'ConfEventFailureReason', mode=MODE_TYPE)
    _ConfEventFailureReason_failedConfStartReason = OCT_STR(name=u'failedConfStartReason', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'Reason')))
    _ConfEventFailureReason_failedPartyJoinReason = OCT_STR(name=u'failedPartyJoinReason', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'Reason')))
    _ConfEventFailureReason_failedPartyLeaveReason = OCT_STR(name=u'failedPartyLeaveReason', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'Reason')))
    _ConfEventFailureReason_failedBearerModifyReason = OCT_STR(name=u'failedBearerModifyReason', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'Reason')))
    _ConfEventFailureReason_failedConfEndReason = OCT_STR(name=u'failedConfEndReason', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'Reason')))
    ConfEventFailureReason._cont = ASN1Dict([
        (u'failedConfStartReason', _ConfEventFailureReason_failedConfStartReason),
        (u'failedPartyJoinReason', _ConfEventFailureReason_failedPartyJoinReason),
        (u'failedPartyLeaveReason', _ConfEventFailureReason_failedPartyLeaveReason),
        (u'failedBearerModifyReason', _ConfEventFailureReason_failedBearerModifyReason),
        (u'failedConfEndReason', _ConfEventFailureReason_failedConfEndReason),
        ])
    ConfEventFailureReason._ext = []
    
    #-----< ConfEventInitiator >-----#
    ConfEventInitiator = CHOICE(name=u'ConfEventInitiator', mode=MODE_TYPE)
    _ConfEventInitiator_confServer = NULL(name=u'confServer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ConfEventInitiator_confTargetID = SEQ(name=u'confTargetID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'PartyIdentity')))
    _ConfEventInitiator_confPartyID = SEQ(name=u'confPartyID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CONFHI2Operations', 'PartyIdentity')))
    ConfEventInitiator._cont = ASN1Dict([
        (u'confServer', _ConfEventInitiator_confServer),
        (u'confTargetID', _ConfEventInitiator_confTargetID),
        (u'confPartyID', _ConfEventInitiator_confPartyID),
        ])
    ConfEventInitiator._ext = []
    
    #-----< RecurrenceInfo >-----#
    RecurrenceInfo = SEQ(name=u'RecurrenceInfo', mode=MODE_TYPE)
    _RecurrenceInfo_recurrenceStartDateAndTime = CHOICE(name=u'recurrenceStartDateAndTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')), opt=True)
    _RecurrenceInfo_recurrenceEndDateAndTime = CHOICE(name=u'recurrenceEndDateAndTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')), opt=True)
    _RecurrenceInfo_recurrencePattern = STR_UTF8(name=u'recurrencePattern', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    RecurrenceInfo._cont = ASN1Dict([
        (u'recurrenceStartDateAndTime', _RecurrenceInfo_recurrenceStartDateAndTime),
        (u'recurrenceEndDateAndTime', _RecurrenceInfo_recurrenceEndDateAndTime),
        (u'recurrencePattern', _RecurrenceInfo_recurrencePattern),
        ])
    RecurrenceInfo._ext = []
    
    #-----< Reason >-----#
    Reason = OCT_STR(name=u'Reason', mode=MODE_TYPE)
    
    _all_ = [
        lawfulInterceptDomainId,
        threeGPPSUBDomainId,
        hi2confDomainId,
        _ConfIRIsContent_confiRIContent,
        _ConfIRIsContent_confIRISequence,
        ConfIRIsContent,
        _ConfIRISequence__item_,
        ConfIRISequence,
        _ConfIRIContent_iRI_Begin_record,
        _ConfIRIContent_iRI_End_record,
        _ConfIRIContent_iRI_Continue_record,
        _ConfIRIContent_iRI_Report_record,
        ConfIRIContent,
        _IRI_Parameters_hi2confDomainId,
        _IRI_Parameters_lawfulInterceptionIdentifier,
        _IRI_Parameters_timeStamp,
        __IRI_Parameters_partyInformation__item_,
        _IRI_Parameters_partyInformation,
        _IRI_Parameters_national_Parameters,
        _IRI_Parameters_networkIdentifier,
        _IRI_Parameters_confEvent,
        _IRI_Parameters_correlation,
        _IRI_Parameters_confID,
        _IRI_Parameters_tempConfID,
        __IRI_Parameters_listOfPotConferees__item_,
        _IRI_Parameters_listOfPotConferees,
        __IRI_Parameters_listOfConferees__item_,
        _IRI_Parameters_listOfConferees,
        _IRI_Parameters_joinPartyID,
        _IRI_Parameters_leavePartyID,
        __IRI_Parameters_listOfBearerAffectedParties__item_,
        _IRI_Parameters_listOfBearerAffectedParties,
        _IRI_Parameters_confEventInitiator,
        _IRI_Parameters_confEventFailureReason,
        _IRI_Parameters_confEndReason,
        _IRI_Parameters_potConfStartInfo,
        _IRI_Parameters_potConfEndInfo,
        _IRI_Parameters_recurrenceInfo,
        __IRI_Parameters_confControllerIDs__item_,
        _IRI_Parameters_confControllerIDs,
        _IRI_Parameters_mediamodification,
        _IRI_Parameters_bearerModifyPartyID,
        __IRI_Parameters_listOfWaitConferees__item_,
        _IRI_Parameters_listOfWaitConferees,
        IRI_Parameters,
        ConfEvent,
        _ConfPartyInformation_partyIdentity,
        _ConfPartyInformation_supportedmedia,
        ConfPartyInformation,
        _ConfCorrelation_correlationValues,
        _ConfCorrelation_correlationNumber,
        _ConfCorrelation_imsVoIP,
        ConfCorrelation,
        __PartyIdentity_iMPU__item_,
        _PartyIdentity_iMPU,
        __PartyIdentity_iMPI__item_,
        _PartyIdentity_iMPI,
        PartyIdentity,
        _IMSIdentity_sip_uri,
        _IMSIdentity_tel_uri,
        IMSIdentity,
        _SupportedMedia_confServerSideSDP,
        _SupportedMedia_confUserSideSDP,
        SupportedMedia,
        MediaModification,
        _ConfEventFailureReason_failedConfStartReason,
        _ConfEventFailureReason_failedPartyJoinReason,
        _ConfEventFailureReason_failedPartyLeaveReason,
        _ConfEventFailureReason_failedBearerModifyReason,
        _ConfEventFailureReason_failedConfEndReason,
        ConfEventFailureReason,
        _ConfEventInitiator_confServer,
        _ConfEventInitiator_confTargetID,
        _ConfEventInitiator_confPartyID,
        ConfEventInitiator,
        _RecurrenceInfo_recurrenceStartDateAndTime,
        _RecurrenceInfo_recurrenceEndDateAndTime,
        _RecurrenceInfo_recurrencePattern,
        RecurrenceInfo,
        Reason,
    ]

class CSvoice_HI3_IP:

    _name_  = u'CSvoice-HI3-IP'
    _oid_   = [0, 4, 0, 2, 2, 4, 18, 14, 0]
    
    _obj_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi3CSvoiceDomainId',
        u'CSvoice-CC-PDU',
        u'CSvoiceLIC-header',
        ]
    _type_ = [
        u'CSvoice-CC-PDU',
        u'CSvoiceLIC-header',
        ]
    _set_ = [
        ]
    _val_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi3CSvoiceDomainId',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< lawfulInterceptDomainId >-----#
    lawfulInterceptDomainId = OID(name=u'lawfulInterceptDomainId', mode=MODE_VALUE)
    lawfulInterceptDomainId._val = (0, 4, 0, 2, 2)
    
    #-----< threeGPPSUBDomainId >-----#
    threeGPPSUBDomainId = OID(name=u'threeGPPSUBDomainId', mode=MODE_VALUE)
    threeGPPSUBDomainId._val = (0, 4, 0, 2, 2, 4)
    
    #-----< hi3CSvoiceDomainId >-----#
    hi3CSvoiceDomainId = OID(name=u'hi3CSvoiceDomainId', mode=MODE_VALUE)
    hi3CSvoiceDomainId._val = (0, 4, 0, 2, 2, 4, 18, 14, 0)
    
    #-----< CSvoice-CC-PDU >-----#
    CSvoice_CC_PDU = SEQ(name=u'CSvoice-CC-PDU', mode=MODE_TYPE)
    _CSvoice_CC_PDU_cSvoiceLIC_header = SEQ(name=u'cSvoiceLIC-header', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSvoice-HI3-IP', 'CSvoiceLIC-header')))
    _CSvoice_CC_PDU_payload = OCT_STR(name=u'payload', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    CSvoice_CC_PDU._cont = ASN1Dict([
        (u'cSvoiceLIC-header', _CSvoice_CC_PDU_cSvoiceLIC_header),
        (u'payload', _CSvoice_CC_PDU_payload),
        ])
    CSvoice_CC_PDU._ext = []
    
    #-----< CSvoiceLIC-header >-----#
    CSvoiceLIC_header = SEQ(name=u'CSvoiceLIC-header', mode=MODE_TYPE)
    _CSvoiceLIC_header_hi3CSvoiceDomainId = OID(name=u'hi3CSvoiceDomainId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CSvoiceLIC_header_lIID = OCT_STR(name=u'lIID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'LawfulInterceptionIdentifier')), opt=True)
    _CSvoiceLIC_header_communicationIdentifier = SEQ(name=u'communicationIdentifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'CommunicationIdentifier')))
    _CSvoiceLIC_header_ccLID = OCT_STR(name=u'ccLID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'CC-Link-Identifier')), opt=True)
    _CSvoiceLIC_header_timeStamp = CHOICE(name=u'timeStamp', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')), opt=True)
    _CSvoiceLIC_header_sequence_number = INT(name=u'sequence-number', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CSvoiceLIC_header_sequence_number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CSvoiceLIC_header_t_PDU_direction = ENUM(name=u't-PDU-direction', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('VoIP-HI3-IMS', 'TPDU-direction')))
    _CSvoiceLIC_header_national_HI3_ASN1parameters = SEQ(name=u'national-HI3-ASN1parameters', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Eps-HI3-PS', 'National-HI3-ASN1parameters')), opt=True)
    _CSvoiceLIC_header_payload_description = SEQ(name=u'payload-description', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('VoIP-HI3-IMS', 'Payload-description')))
    CSvoiceLIC_header._cont = ASN1Dict([
        (u'hi3CSvoiceDomainId', _CSvoiceLIC_header_hi3CSvoiceDomainId),
        (u'lIID', _CSvoiceLIC_header_lIID),
        (u'communicationIdentifier', _CSvoiceLIC_header_communicationIdentifier),
        (u'ccLID', _CSvoiceLIC_header_ccLID),
        (u'timeStamp', _CSvoiceLIC_header_timeStamp),
        (u'sequence-number', _CSvoiceLIC_header_sequence_number),
        (u't-PDU-direction', _CSvoiceLIC_header_t_PDU_direction),
        (u'national-HI3-ASN1parameters', _CSvoiceLIC_header_national_HI3_ASN1parameters),
        (u'payload-description', _CSvoiceLIC_header_payload_description),
        ])
    CSvoiceLIC_header._ext = []
    
    _all_ = [
        lawfulInterceptDomainId,
        threeGPPSUBDomainId,
        hi3CSvoiceDomainId,
        _CSvoice_CC_PDU_cSvoiceLIC_header,
        _CSvoice_CC_PDU_payload,
        CSvoice_CC_PDU,
        _CSvoiceLIC_header_hi3CSvoiceDomainId,
        _CSvoiceLIC_header_lIID,
        _CSvoiceLIC_header_communicationIdentifier,
        _CSvoiceLIC_header_ccLID,
        _CSvoiceLIC_header_timeStamp,
        _CSvoiceLIC_header_sequence_number,
        _CSvoiceLIC_header_t_PDU_direction,
        _CSvoiceLIC_header_national_HI3_ASN1parameters,
        _CSvoiceLIC_header_payload_description,
        CSvoiceLIC_header,
    ]

class EN301040:

    _name_  = u'EN301040'
    _oid_   = [0, 4, 0, 1040, 0]
    
    _obj_ = [
        u'LIACTIVATEreq',
        u'LIACTIVATEconf',
        u'LIMODIFYreq',
        u'LIMODIFYconf',
        u'LISTATUSind',
        u'TARGETACTIVITYMONITORind',
        u'TARGETCOMMSMONITORind',
        u'TTRAFFICind',
        u'CTTRAFFICind',
        u'ActivityClassType',
        u'ActivityType',
        u'AddressType',
        u'TETRAAddressType',
        u'CellIdType',
        u'LocationAreaType',
        u'LocationType',
        u'MCCType',
        u'MNCType',
        u'SSIType',
        u'CircuitIdType',
        u'SSType',
        u'StatusType',
        u'TETRACGIType',
        u'TLIIdType',
        u'TSIType',
        u'TEIType',
        ]
    _type_ = [
        u'LIACTIVATEreq',
        u'LIACTIVATEconf',
        u'LIMODIFYreq',
        u'LIMODIFYconf',
        u'LISTATUSind',
        u'TARGETACTIVITYMONITORind',
        u'TARGETCOMMSMONITORind',
        u'TTRAFFICind',
        u'CTTRAFFICind',
        u'ActivityClassType',
        u'ActivityType',
        u'AddressType',
        u'TETRAAddressType',
        u'CellIdType',
        u'LocationAreaType',
        u'LocationType',
        u'MCCType',
        u'MNCType',
        u'SSIType',
        u'CircuitIdType',
        u'SSType',
        u'StatusType',
        u'TETRACGIType',
        u'TLIIdType',
        u'TSIType',
        u'TEIType',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< LIACTIVATEreq >-----#
    LIACTIVATEreq = SEQ(name=u'LIACTIVATEreq', mode=MODE_TYPE)
    _LIACTIVATEreq_timeStamp = TIME_UTC(name=u'timeStamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LIACTIVATEreq_invokeId = INT(name=u'invokeId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LIACTIVATEreq_targetAddress = SEQ(name=u'targetAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'AddressType')))
    _LIACTIVATEreq_expiryDateTime = TIME_UTC(name=u'expiryDateTime', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LIACTIVATEreq_targetname = STR_VIS(name=u'targetname', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LIACTIVATEreq_additionaltargetdata = STR_VIS(name=u'additionaltargetdata', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LIACTIVATEreq_monitorServiceList = SEQ_OF(name=u'monitorServiceList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __LIACTIVATEreq_monitorServiceList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EN301040', 'ActivityType')))
    _LIACTIVATEreq_monitorServiceList._cont = __LIACTIVATEreq_monitorServiceList__item_
    LIACTIVATEreq._cont = ASN1Dict([
        (u'timeStamp', _LIACTIVATEreq_timeStamp),
        (u'invokeId', _LIACTIVATEreq_invokeId),
        (u'targetAddress', _LIACTIVATEreq_targetAddress),
        (u'expiryDateTime', _LIACTIVATEreq_expiryDateTime),
        (u'targetname', _LIACTIVATEreq_targetname),
        (u'additionaltargetdata', _LIACTIVATEreq_additionaltargetdata),
        (u'monitorServiceList', _LIACTIVATEreq_monitorServiceList),
        ])
    LIACTIVATEreq._ext = None
    
    #-----< LIACTIVATEconf >-----#
    LIACTIVATEconf = SEQ(name=u'LIACTIVATEconf', mode=MODE_TYPE)
    _LIACTIVATEconf_timeStamp = TIME_UTC(name=u'timeStamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LIACTIVATEconf_invokeId = INT(name=u'invokeId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LIACTIVATEconf_result = BOOL(name=u'result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LIACTIVATEconf_tLIInstanceid = BIT_STR(name=u'tLIInstanceid', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'TLIIdType')), opt=True)
    LIACTIVATEconf._cont = ASN1Dict([
        (u'timeStamp', _LIACTIVATEconf_timeStamp),
        (u'invokeId', _LIACTIVATEconf_invokeId),
        (u'result', _LIACTIVATEconf_result),
        (u'tLIInstanceid', _LIACTIVATEconf_tLIInstanceid),
        ])
    LIACTIVATEconf._ext = None
    
    #-----< LIMODIFYreq >-----#
    LIMODIFYreq = SEQ(name=u'LIMODIFYreq', mode=MODE_TYPE)
    _LIMODIFYreq_tLIInstanceid = BIT_STR(name=u'tLIInstanceid', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'TLIIdType')))
    _LIMODIFYreq_timestamp = TIME_UTC(name=u'timestamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LIMODIFYreq_modificationNumber = INT(name=u'modificationNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LIMODIFYreq_modificationType = CHOICE(name=u'modificationType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __LIMODIFYreq_modificationType_halt = BOOL(name=u'halt', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __LIMODIFYreq_modificationType_reset = BOOL(name=u'reset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __LIMODIFYreq_modificationType_expiryDateTime = TIME_UTC(name=u'expiryDateTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __LIMODIFYreq_modificationType_targetname = STR_VIS(name=u'targetname', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __LIMODIFYreq_modificationType_additionaltargetdata = STR_VIS(name=u'additionaltargetdata', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __LIMODIFYreq_modificationType_monitorServiceList = SEQ_OF(name=u'monitorServiceList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___LIMODIFYreq_modificationType_monitorServiceList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EN301040', 'ActivityType')))
    __LIMODIFYreq_modificationType_monitorServiceList._cont = ___LIMODIFYreq_modificationType_monitorServiceList__item_
    _LIMODIFYreq_modificationType._cont = ASN1Dict([
        (u'halt', __LIMODIFYreq_modificationType_halt),
        (u'reset', __LIMODIFYreq_modificationType_reset),
        (u'expiryDateTime', __LIMODIFYreq_modificationType_expiryDateTime),
        (u'targetname', __LIMODIFYreq_modificationType_targetname),
        (u'additionaltargetdata', __LIMODIFYreq_modificationType_additionaltargetdata),
        (u'monitorServiceList', __LIMODIFYreq_modificationType_monitorServiceList),
        ])
    _LIMODIFYreq_modificationType._ext = None
    LIMODIFYreq._cont = ASN1Dict([
        (u'tLIInstanceid', _LIMODIFYreq_tLIInstanceid),
        (u'timestamp', _LIMODIFYreq_timestamp),
        (u'modificationNumber', _LIMODIFYreq_modificationNumber),
        (u'modificationType', _LIMODIFYreq_modificationType),
        ])
    LIMODIFYreq._ext = None
    
    #-----< LIMODIFYconf >-----#
    LIMODIFYconf = SEQ(name=u'LIMODIFYconf', mode=MODE_TYPE)
    _LIMODIFYconf_tLIInstanceid = BIT_STR(name=u'tLIInstanceid', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'TLIIdType')))
    _LIMODIFYconf_timestamp = TIME_UTC(name=u'timestamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LIMODIFYconf_modificationNumber = INT(name=u'modificationNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LIMODIFYconf_result = BOOL(name=u'result', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    LIMODIFYconf._cont = ASN1Dict([
        (u'tLIInstanceid', _LIMODIFYconf_tLIInstanceid),
        (u'timestamp', _LIMODIFYconf_timestamp),
        (u'modificationNumber', _LIMODIFYconf_modificationNumber),
        (u'result', _LIMODIFYconf_result),
        ])
    LIMODIFYconf._ext = None
    
    #-----< LISTATUSind >-----#
    LISTATUSind = SEQ(name=u'LISTATUSind', mode=MODE_TYPE)
    _LISTATUSind_tLIInstanceid = BIT_STR(name=u'tLIInstanceid', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'TLIIdType')))
    _LISTATUSind_timestamp = TIME_UTC(name=u'timestamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LISTATUSind_tETRASysStatus = ENUM(name=u'tETRASysStatus', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'StatusType')))
    LISTATUSind._cont = ASN1Dict([
        (u'tLIInstanceid', _LISTATUSind_tLIInstanceid),
        (u'timestamp', _LISTATUSind_timestamp),
        (u'tETRASysStatus', _LISTATUSind_tETRASysStatus),
        ])
    LISTATUSind._ext = None
    
    #-----< TARGETACTIVITYMONITORind >-----#
    TARGETACTIVITYMONITORind = SEQ(name=u'TARGETACTIVITYMONITORind', mode=MODE_TYPE)
    _TARGETACTIVITYMONITORind_tLIInstanceid = BIT_STR(name=u'tLIInstanceid', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'TLIIdType')))
    _TARGETACTIVITYMONITORind_timestamp = TIME_UTC(name=u'timestamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TARGETACTIVITYMONITORind_targetLocation = CHOICE(name=u'targetLocation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('EN301040', 'LocationType')))
    _TARGETACTIVITYMONITORind_targetAction = SEQ(name=u'targetAction', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'ActivityType')))
    _TARGETACTIVITYMONITORind_supplementaryTargetaddress = SEQ(name=u'supplementaryTargetaddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'AddressType')), opt=True)
    _TARGETACTIVITYMONITORind_cotargetaddress = SEQ_OF(name=u'cotargetaddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TARGETACTIVITYMONITORind_cotargetaddress__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EN301040', 'AddressType')))
    _TARGETACTIVITYMONITORind_cotargetaddress._cont = __TARGETACTIVITYMONITORind_cotargetaddress__item_
    _TARGETACTIVITYMONITORind_cotargetlocation = SEQ_OF(name=u'cotargetlocation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TARGETACTIVITYMONITORind_cotargetlocation__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EN301040', 'LocationType')))
    _TARGETACTIVITYMONITORind_cotargetlocation._cont = __TARGETACTIVITYMONITORind_cotargetlocation__item_
    TARGETACTIVITYMONITORind._cont = ASN1Dict([
        (u'tLIInstanceid', _TARGETACTIVITYMONITORind_tLIInstanceid),
        (u'timestamp', _TARGETACTIVITYMONITORind_timestamp),
        (u'targetLocation', _TARGETACTIVITYMONITORind_targetLocation),
        (u'targetAction', _TARGETACTIVITYMONITORind_targetAction),
        (u'supplementaryTargetaddress', _TARGETACTIVITYMONITORind_supplementaryTargetaddress),
        (u'cotargetaddress', _TARGETACTIVITYMONITORind_cotargetaddress),
        (u'cotargetlocation', _TARGETACTIVITYMONITORind_cotargetlocation),
        ])
    TARGETACTIVITYMONITORind._ext = None
    
    #-----< TARGETCOMMSMONITORind >-----#
    TARGETCOMMSMONITORind = SEQ(name=u'TARGETCOMMSMONITORind', mode=MODE_TYPE)
    _TARGETCOMMSMONITORind_tLIInstanceid = BIT_STR(name=u'tLIInstanceid', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'TLIIdType')))
    _TARGETCOMMSMONITORind_timestamp = TIME_UTC(name=u'timestamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TARGETCOMMSMONITORind_targetlocation = CHOICE(name=u'targetlocation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('EN301040', 'LocationType')))
    _TARGETCOMMSMONITORind_supplementaryTargetaddress = SEQ(name=u'supplementaryTargetaddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'AddressType')), opt=True)
    _TARGETCOMMSMONITORind_targetcommsid = STR_NUM(name=u'targetcommsid', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'CircuitIdType')))
    _TARGETCOMMSMONITORind_cotargetaddress = SEQ_OF(name=u'cotargetaddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TARGETCOMMSMONITORind_cotargetaddress__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EN301040', 'AddressType')))
    _TARGETCOMMSMONITORind_cotargetaddress._cont = __TARGETCOMMSMONITORind_cotargetaddress__item_
    _TARGETCOMMSMONITORind_cotargetcommsid = SEQ_OF(name=u'cotargetcommsid', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TARGETCOMMSMONITORind_cotargetcommsid__item_ = STR_NUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EN301040', 'CircuitIdType')))
    _TARGETCOMMSMONITORind_cotargetcommsid._cont = __TARGETCOMMSMONITORind_cotargetcommsid__item_
    TARGETCOMMSMONITORind._cont = ASN1Dict([
        (u'tLIInstanceid', _TARGETCOMMSMONITORind_tLIInstanceid),
        (u'timestamp', _TARGETCOMMSMONITORind_timestamp),
        (u'targetlocation', _TARGETCOMMSMONITORind_targetlocation),
        (u'supplementaryTargetaddress', _TARGETCOMMSMONITORind_supplementaryTargetaddress),
        (u'targetcommsid', _TARGETCOMMSMONITORind_targetcommsid),
        (u'cotargetaddress', _TARGETCOMMSMONITORind_cotargetaddress),
        (u'cotargetcommsid', _TARGETCOMMSMONITORind_cotargetcommsid),
        ])
    TARGETCOMMSMONITORind._ext = None
    
    #-----< TTRAFFICind >-----#
    TTRAFFICind = SEQ(name=u'TTRAFFICind', mode=MODE_TYPE)
    _TTRAFFICind_tLIInstanceid = BIT_STR(name=u'tLIInstanceid', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'TLIIdType')))
    _TTRAFFICind_trafficPacket = BIT_STR(name=u'trafficPacket', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    TTRAFFICind._cont = ASN1Dict([
        (u'tLIInstanceid', _TTRAFFICind_tLIInstanceid),
        (u'trafficPacket', _TTRAFFICind_trafficPacket),
        ])
    TTRAFFICind._ext = None
    
    #-----< CTTRAFFICind >-----#
    CTTRAFFICind = SEQ(name=u'CTTRAFFICind', mode=MODE_TYPE)
    _CTTRAFFICind_tLIInstanceid = BIT_STR(name=u'tLIInstanceid', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'TLIIdType')))
    _CTTRAFFICind_trafficPacket = BIT_STR(name=u'trafficPacket', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    CTTRAFFICind._cont = ASN1Dict([
        (u'tLIInstanceid', _CTTRAFFICind_tLIInstanceid),
        (u'trafficPacket', _CTTRAFFICind_trafficPacket),
        ])
    CTTRAFFICind._ext = None
    
    #-----< ActivityClassType >-----#
    ActivityClassType = ENUM(name=u'ActivityClassType', mode=MODE_TYPE)
    ActivityClassType._cont = ASN1Dict([(u'allServices', 0), (u'tETRASpeech', 1), (u'singleSlotData24', 2), (u'singleSlotData48', 3), (u'singleSlotData72', 4), (u'multiSlotData224', 5), (u'multiSlotData248', 6), (u'multiSlotData272', 7), (u'multiSlotData324', 8), (u'multiSlotData348', 9), (u'multiSlotData372', 10), (u'multiSlotData424', 11), (u'multiSlotData448', 12), (u'multiSlotData472', 13), (u'sDSType1', 14), (u'sDSType2', 15), (u'sDSType3', 16), (u'sDSType4', 17), (u'status', 18), (u'sDSACKType1', 19), (u'sDSACKType2', 20), (u'sDSACKType3', 21), (u'sDSACKType4', 22), (u'statusack', 23), (u'sDSAcknowledgementsuccess', 24), (u'sDSAcknowledgementfail', 25), (u'sCLNSPacketData', 26), (u'cONSPacketData', 27), (u'internetProtocol', 28), (u'swMIauthenticationsuccess', 29), (u'swMIauthenticationfail', 30), (u'iTSIauthenticationsuccess', 31), (u'iTSIauthenticationfail', 32), (u'oTARSCKsuccess', 33), (u'oTARSCKfail', 34), (u'oTARGCKsuccess', 35), (u'oTARGCKfail', 36), (u'oTARCCKsuccess', 37), (u'oTARCCKfail', 38), (u'tARGETSUSCRIPTIONDISABLEDT', 39), (u'tARGETEQUIPMENTDISABLEDT', 40), (u'tARGETSUSCRIPTIONDISABLEDP', 41), (u'tARGETEQUIPEMENTDISABLEDP', 42), (u'tARGETSUBSCRIPTIONENABLED', 43), (u'tARGETEQUIPMENTENABLED', 44), (u'sessionregistration', 45), (u'sessionderegistration', 46), (u'mIGRATION', 47), (u'rOAMING', 48), (u'supplementaryService', 49)])
    ActivityClassType._ext = None
    
    #-----< ActivityType >-----#
    ActivityType = SEQ(name=u'ActivityType', mode=MODE_TYPE)
    _ActivityType_cctivity = ENUM(name=u'cctivity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'ActivityClassType')))
    _ActivityType_callRelation = ENUM(name=u'callRelation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ActivityType_callRelation._cont = ASN1Dict([(u'begin', 0), (u'end', 1), (u'continue', 2), (u'report', 3)])
    _ActivityType_callRelation._ext = None
    _ActivityType_direction = ENUM(name=u'direction', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ActivityType_direction._cont = ASN1Dict([(u'toTarget', 0), (u'fromTarget', 1)])
    _ActivityType_direction._ext = None
    _ActivityType_scope = ENUM(name=u'scope', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ActivityType_scope._cont = ASN1Dict([(u'point2Point', 0), (u'point2MultiPoint', 1), (u'broadcast', 2)])
    _ActivityType_scope._ext = None
    _ActivityType_cPlaneData = BIT_STR(name=u'cPlaneData', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ActivityType_sStype = ENUM(name=u'sStype', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'SSType')), opt=True)
    ActivityType._cont = ASN1Dict([
        (u'cctivity', _ActivityType_cctivity),
        (u'callRelation', _ActivityType_callRelation),
        (u'direction', _ActivityType_direction),
        (u'scope', _ActivityType_scope),
        (u'cPlaneData', _ActivityType_cPlaneData),
        (u'sStype', _ActivityType_sStype),
        ])
    ActivityType._ext = None
    
    #-----< AddressType >-----#
    AddressType = SEQ(name=u'AddressType', mode=MODE_TYPE)
    _AddressType_tSI = SEQ(name=u'tSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'TSIType')))
    _AddressType_supplementaryAddress = SEQ_OF(name=u'supplementaryAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AddressType_supplementaryAddress__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EN301040', 'TETRAAddressType')))
    _AddressType_supplementaryAddress._cont = __AddressType_supplementaryAddress__item_
    AddressType._cont = ASN1Dict([
        (u'tSI', _AddressType_tSI),
        (u'supplementaryAddress', _AddressType_supplementaryAddress),
        ])
    AddressType._ext = None
    
    #-----< TETRAAddressType >-----#
    TETRAAddressType = CHOICE(name=u'TETRAAddressType', mode=MODE_TYPE)
    _TETRAAddressType_tETRAaddress = SEQ(name=u'tETRAaddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'TSIType')))
    _TETRAAddressType_pISNaddress = STR_NUM(name=u'pISNaddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TETRAAddressType_pISNaddress._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    _TETRAAddressType_iP4address = BIT_STR(name=u'iP4address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TETRAAddressType_iP4address._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _TETRAAddressType_iP6address = BIT_STR(name=u'iP6address', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TETRAAddressType_iP6address._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    _TETRAAddressType_e164address = STR_NUM(name=u'e164address', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TETRAAddressType_e164address._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    _TETRAAddressType_tEI = BIT_STR(name=u'tEI', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'TEIType')))
    TETRAAddressType._cont = ASN1Dict([
        (u'tETRAaddress', _TETRAAddressType_tETRAaddress),
        (u'pISNaddress', _TETRAAddressType_pISNaddress),
        (u'iP4address', _TETRAAddressType_iP4address),
        (u'iP6address', _TETRAAddressType_iP6address),
        (u'e164address', _TETRAAddressType_e164address),
        (u'tEI', _TETRAAddressType_tEI),
        ])
    TETRAAddressType._ext = None
    
    #-----< CellIdType >-----#
    CellIdType = BIT_STR(name=u'CellIdType', mode=MODE_TYPE)
    CellIdType._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< LocationAreaType >-----#
    LocationAreaType = BIT_STR(name=u'LocationAreaType', mode=MODE_TYPE)
    LocationAreaType._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    
    #-----< LocationType >-----#
    LocationType = CHOICE(name=u'LocationType', mode=MODE_TYPE)
    _LocationType_mSLoc = SEQ(name=u'mSLoc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'TETRACGIType')))
    _LocationType_lSLoc = CHOICE(name=u'lSLoc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('EN301040', 'TETRAAddressType')))
    LocationType._cont = ASN1Dict([
        (u'mSLoc', _LocationType_mSLoc),
        (u'lSLoc', _LocationType_lSLoc),
        ])
    LocationType._ext = None
    
    #-----< MCCType >-----#
    MCCType = BIT_STR(name=u'MCCType', mode=MODE_TYPE)
    MCCType._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    
    #-----< MNCType >-----#
    MNCType = BIT_STR(name=u'MNCType', mode=MODE_TYPE)
    MNCType._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    
    #-----< SSIType >-----#
    SSIType = BIT_STR(name=u'SSIType', mode=MODE_TYPE)
    SSIType._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    
    #-----< CircuitIdType >-----#
    CircuitIdType = STR_NUM(name=u'CircuitIdType', mode=MODE_TYPE)
    CircuitIdType._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    
    #-----< SSType >-----#
    SSType = ENUM(name=u'SSType', mode=MODE_TYPE)
    SSType._cont = ASN1Dict([(u'ambienceListening', 0), (u'adviceofCharge', 1), (u'accessPriority', 2), (u'areaSelection', 3), (u'barringofIncomingCalls', 4), (u'barringofOutgoingCalls', 5), (u'callAuthorizedbyDispatcher', 6), (u'callCompletiontoBusySubscriber', 7), (u'callCompletiononNoReply', 8), (u'callForwardingonBusy', 9), (u'callForwardingonNoReply', 10), (u'callForwardingonNotReachable', 11), (u'callForwardingUnconditional', 12), (u'callingLineIdentificationPresentation', 13), (u'callingConnectedLineIdentificationRestriction', 14), (u'connectedLineIdentificationPresentation', 15), (u'callReport', 16), (u'callRetention', 17), (u'callWaiting', 18), (u'dynamicGroupNumberAssignment', 19), (u'discreetListening', 20), (u'callHold', 21), (u'includeCall', 22), (u'lateEntry', 23), (u'listSearchCall', 24), (u'priorityCall', 25), (u'preemptivePriorityCall', 26), (u'shortNumberAddressing', 27), (u'transferofControl', 28), (u'talkingPartyIdentification', 29)])
    SSType._ext = None
    
    #-----< StatusType >-----#
    StatusType = ENUM(name=u'StatusType', mode=MODE_TYPE)
    StatusType._cont = ASN1Dict([(u'networkFullyAvailable', 0), (u'networkErrorsAffectingIntercept', 1), (u'reconfigurationInProgress', 2), (u'sessionExpired', 3), (u'gatewayServicesUnavailable', 4)])
    StatusType._ext = None
    
    #-----< TETRACGIType >-----#
    TETRACGIType = SEQ(name=u'TETRACGIType', mode=MODE_TYPE)
    _TETRACGIType_mcc = BIT_STR(name=u'mcc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'MCCType')))
    _TETRACGIType_mnc = BIT_STR(name=u'mnc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'MNCType')))
    _TETRACGIType_lai = BIT_STR(name=u'lai', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'LocationAreaType')))
    _TETRACGIType_cI = BIT_STR(name=u'cI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'CellIdType')), opt=True)
    TETRACGIType._cont = ASN1Dict([
        (u'mcc', _TETRACGIType_mcc),
        (u'mnc', _TETRACGIType_mnc),
        (u'lai', _TETRACGIType_lai),
        (u'cI', _TETRACGIType_cI),
        ])
    TETRACGIType._ext = None
    
    #-----< TLIIdType >-----#
    TLIIdType = BIT_STR(name=u'TLIIdType', mode=MODE_TYPE)
    TLIIdType._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< TSIType >-----#
    TSIType = SEQ(name=u'TSIType', mode=MODE_TYPE)
    _TSIType_mcc = BIT_STR(name=u'mcc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'MCCType')))
    _TSIType_mnc = BIT_STR(name=u'mnc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'MNCType')))
    _TSIType_ssi = BIT_STR(name=u'ssi', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'SSIType')))
    TSIType._cont = ASN1Dict([
        (u'mcc', _TSIType_mcc),
        (u'mnc', _TSIType_mnc),
        (u'ssi', _TSIType_ssi),
        ])
    TSIType._ext = None
    
    #-----< TEIType >-----#
    TEIType = BIT_STR(name=u'TEIType', mode=MODE_TYPE)
    TEIType._const_sz = ASN1Set(rv=[60], rr=[], ev=None, er=[])
    
    _all_ = [
        _LIACTIVATEreq_timeStamp,
        _LIACTIVATEreq_invokeId,
        _LIACTIVATEreq_targetAddress,
        _LIACTIVATEreq_expiryDateTime,
        _LIACTIVATEreq_targetname,
        _LIACTIVATEreq_additionaltargetdata,
        __LIACTIVATEreq_monitorServiceList__item_,
        _LIACTIVATEreq_monitorServiceList,
        LIACTIVATEreq,
        _LIACTIVATEconf_timeStamp,
        _LIACTIVATEconf_invokeId,
        _LIACTIVATEconf_result,
        _LIACTIVATEconf_tLIInstanceid,
        LIACTIVATEconf,
        _LIMODIFYreq_tLIInstanceid,
        _LIMODIFYreq_timestamp,
        _LIMODIFYreq_modificationNumber,
        __LIMODIFYreq_modificationType_halt,
        __LIMODIFYreq_modificationType_reset,
        __LIMODIFYreq_modificationType_expiryDateTime,
        __LIMODIFYreq_modificationType_targetname,
        __LIMODIFYreq_modificationType_additionaltargetdata,
        ___LIMODIFYreq_modificationType_monitorServiceList__item_,
        __LIMODIFYreq_modificationType_monitorServiceList,
        _LIMODIFYreq_modificationType,
        LIMODIFYreq,
        _LIMODIFYconf_tLIInstanceid,
        _LIMODIFYconf_timestamp,
        _LIMODIFYconf_modificationNumber,
        _LIMODIFYconf_result,
        LIMODIFYconf,
        _LISTATUSind_tLIInstanceid,
        _LISTATUSind_timestamp,
        _LISTATUSind_tETRASysStatus,
        LISTATUSind,
        _TARGETACTIVITYMONITORind_tLIInstanceid,
        _TARGETACTIVITYMONITORind_timestamp,
        _TARGETACTIVITYMONITORind_targetLocation,
        _TARGETACTIVITYMONITORind_targetAction,
        _TARGETACTIVITYMONITORind_supplementaryTargetaddress,
        __TARGETACTIVITYMONITORind_cotargetaddress__item_,
        _TARGETACTIVITYMONITORind_cotargetaddress,
        __TARGETACTIVITYMONITORind_cotargetlocation__item_,
        _TARGETACTIVITYMONITORind_cotargetlocation,
        TARGETACTIVITYMONITORind,
        _TARGETCOMMSMONITORind_tLIInstanceid,
        _TARGETCOMMSMONITORind_timestamp,
        _TARGETCOMMSMONITORind_targetlocation,
        _TARGETCOMMSMONITORind_supplementaryTargetaddress,
        _TARGETCOMMSMONITORind_targetcommsid,
        __TARGETCOMMSMONITORind_cotargetaddress__item_,
        _TARGETCOMMSMONITORind_cotargetaddress,
        __TARGETCOMMSMONITORind_cotargetcommsid__item_,
        _TARGETCOMMSMONITORind_cotargetcommsid,
        TARGETCOMMSMONITORind,
        _TTRAFFICind_tLIInstanceid,
        _TTRAFFICind_trafficPacket,
        TTRAFFICind,
        _CTTRAFFICind_tLIInstanceid,
        _CTTRAFFICind_trafficPacket,
        CTTRAFFICind,
        ActivityClassType,
        _ActivityType_cctivity,
        _ActivityType_callRelation,
        _ActivityType_direction,
        _ActivityType_scope,
        _ActivityType_cPlaneData,
        _ActivityType_sStype,
        ActivityType,
        _AddressType_tSI,
        __AddressType_supplementaryAddress__item_,
        _AddressType_supplementaryAddress,
        AddressType,
        _TETRAAddressType_tETRAaddress,
        _TETRAAddressType_pISNaddress,
        _TETRAAddressType_iP4address,
        _TETRAAddressType_iP6address,
        _TETRAAddressType_e164address,
        _TETRAAddressType_tEI,
        TETRAAddressType,
        CellIdType,
        LocationAreaType,
        _LocationType_mSLoc,
        _LocationType_lSLoc,
        LocationType,
        MCCType,
        MNCType,
        SSIType,
        CircuitIdType,
        SSType,
        StatusType,
        _TETRACGIType_mcc,
        _TETRACGIType_mnc,
        _TETRACGIType_lai,
        _TETRACGIType_cI,
        TETRACGIType,
        TLIIdType,
        _TSIType_mcc,
        _TSIType_mnc,
        _TSIType_ssi,
        TSIType,
        TEIType,
    ]

class Eps_HI3_PS:

    _name_  = u'Eps-HI3-PS'
    _oid_   = [0, 4, 0, 2, 2, 4, 9, 12, 0]
    
    _obj_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi3DomainId',
        u'CC-PDU',
        u'ULIC-header',
        u'TPDU-direction',
        u'National-HI3-ASN1parameters',
        u'ICE-type',
        ]
    _type_ = [
        u'CC-PDU',
        u'ULIC-header',
        u'TPDU-direction',
        u'National-HI3-ASN1parameters',
        u'ICE-type',
        ]
    _set_ = [
        ]
    _val_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi3DomainId',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< lawfulInterceptDomainId >-----#
    lawfulInterceptDomainId = OID(name=u'lawfulInterceptDomainId', mode=MODE_VALUE)
    lawfulInterceptDomainId._val = (0, 4, 0, 2, 2)
    
    #-----< threeGPPSUBDomainId >-----#
    threeGPPSUBDomainId = OID(name=u'threeGPPSUBDomainId', mode=MODE_VALUE)
    threeGPPSUBDomainId._val = (0, 4, 0, 2, 2, 4)
    
    #-----< hi3DomainId >-----#
    hi3DomainId = OID(name=u'hi3DomainId', mode=MODE_VALUE)
    hi3DomainId._val = (0, 4, 0, 2, 2, 4, 9, 12, 0)
    
    #-----< CC-PDU >-----#
    CC_PDU = SEQ(name=u'CC-PDU', mode=MODE_TYPE)
    _CC_PDU_uLIC_header = SEQ(name=u'uLIC-header', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Eps-HI3-PS', 'ULIC-header')))
    _CC_PDU_payload = OCT_STR(name=u'payload', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    CC_PDU._cont = ASN1Dict([
        (u'uLIC-header', _CC_PDU_uLIC_header),
        (u'payload', _CC_PDU_payload),
        ])
    CC_PDU._ext = None
    
    #-----< ULIC-header >-----#
    ULIC_header = SEQ(name=u'ULIC-header', mode=MODE_TYPE)
    _ULIC_header_hi3DomainId = OID(name=u'hi3DomainId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ULIC_header_lIID = OCT_STR(name=u'lIID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'LawfulInterceptionIdentifier')), opt=True)
    _ULIC_header_correlation_Number = OCT_STR(name=u'correlation-Number', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'EPSCorrelationNumber')))
    _ULIC_header_timeStamp = CHOICE(name=u'timeStamp', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')), opt=True)
    _ULIC_header_sequence_number = INT(name=u'sequence-number', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ULIC_header_sequence_number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ULIC_header_t_PDU_direction = ENUM(name=u't-PDU-direction', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Eps-HI3-PS', 'TPDU-direction')))
    _ULIC_header_national_HI3_ASN1parameters = SEQ(name=u'national-HI3-ASN1parameters', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Eps-HI3-PS', 'National-HI3-ASN1parameters')), opt=True)
    _ULIC_header_ice_type = ENUM(name=u'ice-type', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Eps-HI3-PS', 'ICE-type')), opt=True)
    ULIC_header._cont = ASN1Dict([
        (u'hi3DomainId', _ULIC_header_hi3DomainId),
        (u'lIID', _ULIC_header_lIID),
        (u'correlation-Number', _ULIC_header_correlation_Number),
        (u'timeStamp', _ULIC_header_timeStamp),
        (u'sequence-number', _ULIC_header_sequence_number),
        (u't-PDU-direction', _ULIC_header_t_PDU_direction),
        (u'national-HI3-ASN1parameters', _ULIC_header_national_HI3_ASN1parameters),
        (u'ice-type', _ULIC_header_ice_type),
        ])
    ULIC_header._ext = [u'national-HI3-ASN1parameters', u'ice-type']
    
    #-----< TPDU-direction >-----#
    TPDU_direction = ENUM(name=u'TPDU-direction', mode=MODE_TYPE)
    TPDU_direction._cont = ASN1Dict([(u'from-target', 1), (u'to-target', 2), (u'unknown', 3)])
    TPDU_direction._ext = None
    
    #-----< National-HI3-ASN1parameters >-----#
    National_HI3_ASN1parameters = SEQ(name=u'National-HI3-ASN1parameters', mode=MODE_TYPE)
    _National_HI3_ASN1parameters_countryCode = STR_PRINT(name=u'countryCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _National_HI3_ASN1parameters_countryCode._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    National_HI3_ASN1parameters._cont = ASN1Dict([
        (u'countryCode', _National_HI3_ASN1parameters_countryCode),
        ])
    National_HI3_ASN1parameters._ext = []
    
    #-----< ICE-type >-----#
    ICE_type = ENUM(name=u'ICE-type', mode=MODE_TYPE)
    ICE_type._cont = ASN1Dict([(u'sgsn', 1), (u'ggsn', 2), (u's-GW', 3), (u'pDN-GW', 4), (u'colocated-SAE-GWs', 5), (u'ePDG', 6)])
    ICE_type._ext = [u's-GW', u'pDN-GW', u'colocated-SAE-GWs', u'ePDG']
    
    _all_ = [
        lawfulInterceptDomainId,
        threeGPPSUBDomainId,
        hi3DomainId,
        _CC_PDU_uLIC_header,
        _CC_PDU_payload,
        CC_PDU,
        _ULIC_header_hi3DomainId,
        _ULIC_header_lIID,
        _ULIC_header_correlation_Number,
        _ULIC_header_timeStamp,
        _ULIC_header_sequence_number,
        _ULIC_header_t_PDU_direction,
        _ULIC_header_national_HI3_ASN1parameters,
        _ULIC_header_ice_type,
        ULIC_header,
        TPDU_direction,
        _National_HI3_ASN1parameters_countryCode,
        National_HI3_ASN1parameters,
        ICE_type,
    ]

class EpsHI2Operations:

    _name_  = u'EpsHI2Operations'
    _oid_   = [0, 4, 0, 2, 2, 4, 8, 16, 1]
    
    _obj_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi2epsDomainId',
        u'EpsIRIsContent',
        u'EpsIRISequence',
        u'EpsIRIContent',
        u'IRI-Parameters',
        u'DataNodeIdentifier',
        u'LogicalFunctionType',
        u'PANI-Header-Info',
        u'PANI-Location',
        u'PartyInformation',
        u'Location',
        u'GlobalCellID',
        u'Rai',
        u'Sai',
        u'AdditionalCellID',
        u'MCC',
        u'MNC',
        u'PLMNID',
        u'NRCellID',
        u'NCGI',
        u'GSMLocation',
        u'MapDatum',
        u'UMTSLocation',
        u'GeographicalCoordinates',
        u'GA-Point',
        u'GA-PointWithUnCertainty',
        u'maxNrOfPoints',
        u'GA-Polygon',
        u'SMS-report',
        u'EPSCorrelationNumber',
        u'CorrelationValues',
        u'IMS-VoIP-Correlation',
        u'IRI-to-CC-Correlation',
        u'IRI-to-IRI-Correlation',
        u'EPSEvent',
        u'CSREvent',
        u'IMSevent',
        u'Services-Data-Information',
        u'GPRS-parameters',
        u'GPRSOperationErrorCode',
        u'LDIevent',
        u'UmtsQos',
        u'EPS-GTPV2-SpecificParameters',
        u'TypeOfBearer',
        u'EPSLocation',
        u'ProtConfigOptions',
        u'RemoteUeContextConnected',
        u'RemoteUEContext',
        u'RemoteUserID',
        u'RemoteUEIPInformation',
        u'RemoteUeContextDisconnected',
        u'EPS-PMIP-SpecificParameters',
        u'EPS-DSMIP-SpecificParameters',
        u'EPS-MIP-SpecificParameters',
        u'MediaDecryption-info',
        u'CCKeyInfo',
        u'MediaSecFailureIndication',
        u'PacketDataHeaderInformation',
        u'PacketDataHeaderReport',
        u'PacketDataHeaderMapped',
        u'TPDU-direction',
        u'PacketDataHeaderCopy',
        u'PacketDataSummaryReport',
        u'PacketFlowSummary',
        u'ReportReason',
        u'ReportInterval',
        u'TunnelProtocol',
        u'HeNBLocation',
        u'Requesting-Node-Type',
        u'Change-Of-Target-Identity',
        u'Current-Previous-Systems',
        u'ProSeTargetType',
        u'VoIPRoamingIndication',
        u'DeregistrationReason',
        u'PTCEncryptionInfo',
        u'PTC',
        u'AccessPolicyType',
        u'AlertIndicator',
        u'AssociatePresenceStatus',
        u'PresenceType',
        u'Emergency',
        u'EmergencyGroupState',
        u'PTCType',
        u'FloorActivity',
        u'GroupAuthRule',
        u'ImminentPerilInd',
        u'ImplicitFloorReq',
        u'InitiationCause',
        u'IPADirection',
        u'ListManagementAction',
        u'ListManagementType',
        u'Priority-Level',
        u'PreEstStatus',
        u'PTCAddress',
        u'RegistrationRequest',
        u'RegistrationOutcome',
        u'RTPSetting',
        u'Port-Number',
        u'TalkburstControlSetting',
        u'Talk-burst-reason-code',
        ]
    _type_ = [
        u'EpsIRIsContent',
        u'EpsIRISequence',
        u'EpsIRIContent',
        u'IRI-Parameters',
        u'DataNodeIdentifier',
        u'LogicalFunctionType',
        u'PANI-Header-Info',
        u'PANI-Location',
        u'PartyInformation',
        u'Location',
        u'GlobalCellID',
        u'Rai',
        u'Sai',
        u'AdditionalCellID',
        u'MCC',
        u'MNC',
        u'PLMNID',
        u'NRCellID',
        u'NCGI',
        u'GSMLocation',
        u'MapDatum',
        u'UMTSLocation',
        u'GeographicalCoordinates',
        u'GA-Point',
        u'GA-PointWithUnCertainty',
        u'GA-Polygon',
        u'SMS-report',
        u'EPSCorrelationNumber',
        u'CorrelationValues',
        u'IMS-VoIP-Correlation',
        u'IRI-to-CC-Correlation',
        u'IRI-to-IRI-Correlation',
        u'EPSEvent',
        u'CSREvent',
        u'IMSevent',
        u'Services-Data-Information',
        u'GPRS-parameters',
        u'GPRSOperationErrorCode',
        u'LDIevent',
        u'UmtsQos',
        u'EPS-GTPV2-SpecificParameters',
        u'TypeOfBearer',
        u'EPSLocation',
        u'ProtConfigOptions',
        u'RemoteUeContextConnected',
        u'RemoteUEContext',
        u'RemoteUserID',
        u'RemoteUEIPInformation',
        u'RemoteUeContextDisconnected',
        u'EPS-PMIP-SpecificParameters',
        u'EPS-DSMIP-SpecificParameters',
        u'EPS-MIP-SpecificParameters',
        u'MediaDecryption-info',
        u'CCKeyInfo',
        u'MediaSecFailureIndication',
        u'PacketDataHeaderInformation',
        u'PacketDataHeaderReport',
        u'PacketDataHeaderMapped',
        u'TPDU-direction',
        u'PacketDataHeaderCopy',
        u'PacketDataSummaryReport',
        u'PacketFlowSummary',
        u'ReportReason',
        u'ReportInterval',
        u'TunnelProtocol',
        u'HeNBLocation',
        u'Requesting-Node-Type',
        u'Change-Of-Target-Identity',
        u'Current-Previous-Systems',
        u'ProSeTargetType',
        u'VoIPRoamingIndication',
        u'DeregistrationReason',
        u'PTCEncryptionInfo',
        u'PTC',
        u'AccessPolicyType',
        u'AlertIndicator',
        u'AssociatePresenceStatus',
        u'PresenceType',
        u'Emergency',
        u'EmergencyGroupState',
        u'PTCType',
        u'FloorActivity',
        u'GroupAuthRule',
        u'ImminentPerilInd',
        u'ImplicitFloorReq',
        u'InitiationCause',
        u'IPADirection',
        u'ListManagementAction',
        u'ListManagementType',
        u'Priority-Level',
        u'PreEstStatus',
        u'PTCAddress',
        u'RegistrationRequest',
        u'RegistrationOutcome',
        u'RTPSetting',
        u'Port-Number',
        u'TalkburstControlSetting',
        u'Talk-burst-reason-code',
        ]
    _set_ = [
        ]
    _val_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi2epsDomainId',
        u'maxNrOfPoints',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< lawfulInterceptDomainId >-----#
    lawfulInterceptDomainId = OID(name=u'lawfulInterceptDomainId', mode=MODE_VALUE)
    lawfulInterceptDomainId._val = (0, 4, 0, 2, 2)
    
    #-----< threeGPPSUBDomainId >-----#
    threeGPPSUBDomainId = OID(name=u'threeGPPSUBDomainId', mode=MODE_VALUE)
    threeGPPSUBDomainId._val = (0, 4, 0, 2, 2, 4)
    
    #-----< hi2epsDomainId >-----#
    hi2epsDomainId = OID(name=u'hi2epsDomainId', mode=MODE_VALUE)
    hi2epsDomainId._val = (0, 4, 0, 2, 2, 4, 8, 16, 1)
    
    #-----< EpsIRIsContent >-----#
    EpsIRIsContent = CHOICE(name=u'EpsIRIsContent', mode=MODE_TYPE)
    _EpsIRIsContent_epsiRIContent = CHOICE(name=u'epsiRIContent', mode=MODE_TYPE, typeref=ASN1RefType(('EpsHI2Operations', 'EpsIRIContent')))
    _EpsIRIsContent_epsIRISequence = SEQ_OF(name=u'epsIRISequence', mode=MODE_TYPE, typeref=ASN1RefType(('EpsHI2Operations', 'EpsIRISequence')))
    EpsIRIsContent._cont = ASN1Dict([
        (u'epsiRIContent', _EpsIRIsContent_epsiRIContent),
        (u'epsIRISequence', _EpsIRIsContent_epsIRISequence),
        ])
    EpsIRIsContent._ext = None
    
    #-----< EpsIRISequence >-----#
    EpsIRISequence = SEQ_OF(name=u'EpsIRISequence', mode=MODE_TYPE)
    _EpsIRISequence__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EpsHI2Operations', 'EpsIRIContent')))
    EpsIRISequence._cont = _EpsIRISequence__item_
    
    #-----< EpsIRIContent >-----#
    EpsIRIContent = CHOICE(name=u'EpsIRIContent', mode=MODE_TYPE)
    _EpsIRIContent_iRI_Begin_record = SEQ(name=u'iRI-Begin-record', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'IRI-Parameters')))
    _EpsIRIContent_iRI_End_record = SEQ(name=u'iRI-End-record', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'IRI-Parameters')))
    _EpsIRIContent_iRI_Continue_record = SEQ(name=u'iRI-Continue-record', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'IRI-Parameters')))
    _EpsIRIContent_iRI_Report_record = SEQ(name=u'iRI-Report-record', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'IRI-Parameters')))
    EpsIRIContent._cont = ASN1Dict([
        (u'iRI-Begin-record', _EpsIRIContent_iRI_Begin_record),
        (u'iRI-End-record', _EpsIRIContent_iRI_End_record),
        (u'iRI-Continue-record', _EpsIRIContent_iRI_Continue_record),
        (u'iRI-Report-record', _EpsIRIContent_iRI_Report_record),
        ])
    EpsIRIContent._ext = None
    
    #-----< IRI-Parameters >-----#
    IRI_Parameters = SEQ(name=u'IRI-Parameters', mode=MODE_TYPE)
    _IRI_Parameters_hi2epsDomainId = OID(name=u'hi2epsDomainId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IRI_Parameters_lawfulInterceptionIdentifier = OCT_STR(name=u'lawfulInterceptionIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'LawfulInterceptionIdentifier')))
    _IRI_Parameters_timeStamp = CHOICE(name=u'timeStamp', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    _IRI_Parameters_initiator = ENUM(name=u'initiator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_initiator._cont = ASN1Dict([(u'not-Available', 0), (u'originating-Target', 1), (u'terminating-Target', 2)])
    _IRI_Parameters_initiator._ext = []
    _IRI_Parameters_locationOfTheTarget = SEQ(name=u'locationOfTheTarget', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'Location')), opt=True)
    _IRI_Parameters_partyInformation = SET_OF(name=u'partyInformation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IRI_Parameters_partyInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EpsHI2Operations', 'PartyInformation')))
    _IRI_Parameters_partyInformation._cont = __IRI_Parameters_partyInformation__item_
    _IRI_Parameters_partyInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _IRI_Parameters_serviceCenterAddress = SEQ(name=u'serviceCenterAddress', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PartyInformation')), opt=True)
    _IRI_Parameters_sMS = SEQ(name=u'sMS', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'SMS-report')), opt=True)
    _IRI_Parameters_national_Parameters = SET_OF(name=u'national-Parameters', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'National-Parameters')), opt=True)
    _IRI_Parameters_ePSCorrelationNumber = OCT_STR(name=u'ePSCorrelationNumber', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'EPSCorrelationNumber')), opt=True)
    _IRI_Parameters_ePSevent = ENUM(name=u'ePSevent', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'EPSEvent')), opt=True)
    _IRI_Parameters_sgsnAddress = CHOICE(name=u'sgsnAddress', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DataNodeAddress')), opt=True)
    _IRI_Parameters_gPRSOperationErrorCode = OCT_STR(name=u'gPRSOperationErrorCode', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'GPRSOperationErrorCode')), opt=True)
    _IRI_Parameters_ggsnAddress = CHOICE(name=u'ggsnAddress', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DataNodeAddress')), opt=True)
    _IRI_Parameters_qOS = CHOICE(name=u'qOS', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'UmtsQos')), opt=True)
    _IRI_Parameters_networkIdentifier = SEQ(name=u'networkIdentifier', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'Network-Identifier')), opt=True)
    _IRI_Parameters_sMSOriginatingAddress = CHOICE(name=u'sMSOriginatingAddress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DataNodeAddress')), opt=True)
    _IRI_Parameters_sMSTerminatingAddress = CHOICE(name=u'sMSTerminatingAddress', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DataNodeAddress')), opt=True)
    _IRI_Parameters_iMSevent = ENUM(name=u'iMSevent', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'IMSevent')), opt=True)
    _IRI_Parameters_sIPMessage = OCT_STR(name=u'sIPMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_servingSGSN_number = OCT_STR(name=u'servingSGSN-number', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_servingSGSN_number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    _IRI_Parameters_servingSGSN_address = OCT_STR(name=u'servingSGSN-address', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_servingSGSN_address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=17)], ev=None, er=[])
    _IRI_Parameters_ldiEvent = ENUM(name=u'ldiEvent', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'LDIevent')), opt=True)
    _IRI_Parameters_correlation = CHOICE(name=u'correlation', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'CorrelationValues')), opt=True)
    _IRI_Parameters_ePS_GTPV2_specificParameters = SEQ(name=u'ePS-GTPV2-specificParameters', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'EPS-GTPV2-SpecificParameters')), opt=True)
    _IRI_Parameters_ePS_PMIP_specificParameters = SEQ(name=u'ePS-PMIP-specificParameters', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'EPS-PMIP-SpecificParameters')), opt=True)
    _IRI_Parameters_ePS_DSMIP_SpecificParameters = SEQ(name=u'ePS-DSMIP-SpecificParameters', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'EPS-DSMIP-SpecificParameters')), opt=True)
    _IRI_Parameters_ePS_MIP_SpecificParameters = SEQ(name=u'ePS-MIP-SpecificParameters', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'EPS-MIP-SpecificParameters')), opt=True)
    _IRI_Parameters_servingNodeAddress = OCT_STR(name=u'servingNodeAddress', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_visitedNetworkId = STR_UTF8(name=u'visitedNetworkId', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_mediaDecryption_info = SEQ_OF(name=u'mediaDecryption-info', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'MediaDecryption-info')), opt=True)
    _IRI_Parameters_servingS4_SGSN_address = OCT_STR(name=u'servingS4-SGSN-address', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_sipMessageHeaderOffer = OCT_STR(name=u'sipMessageHeaderOffer', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_sipMessageHeaderAnswer = OCT_STR(name=u'sipMessageHeaderAnswer', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_sdpOffer = OCT_STR(name=u'sdpOffer', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_sdpAnswer = OCT_STR(name=u'sdpAnswer', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_uLITimestamp = OCT_STR(name=u'uLITimestamp', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_uLITimestamp._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _IRI_Parameters_packetDataHeaderInformation = CHOICE(name=u'packetDataHeaderInformation', mode=MODE_TYPE, tag=(49, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PacketDataHeaderInformation')), opt=True)
    _IRI_Parameters_mediaSecFailureIndication = ENUM(name=u'mediaSecFailureIndication', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'MediaSecFailureIndication')), opt=True)
    _IRI_Parameters_csgIdentity = OCT_STR(name=u'csgIdentity', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_csgIdentity._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _IRI_Parameters_heNBIdentity = OCT_STR(name=u'heNBIdentity', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_heNBiPAddress = SEQ(name=u'heNBiPAddress', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IPAddress')), opt=True)
    _IRI_Parameters_heNBLocation = SEQ(name=u'heNBLocation', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'HeNBLocation')), opt=True)
    _IRI_Parameters_tunnelProtocol = CHOICE(name=u'tunnelProtocol', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'TunnelProtocol')), opt=True)
    _IRI_Parameters_pANI_Header_Info = SEQ_OF(name=u'pANI-Header-Info', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IRI_Parameters_pANI_Header_Info__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EpsHI2Operations', 'PANI-Header-Info')))
    _IRI_Parameters_pANI_Header_Info._cont = __IRI_Parameters_pANI_Header_Info__item_
    _IRI_Parameters_imsVoIP = SET_OF(name=u'imsVoIP', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'IMS-VoIP-Correlation')), opt=True)
    _IRI_Parameters_xCAPmessage = OCT_STR(name=u'xCAPmessage', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_logicalFunctionInformation = SEQ(name=u'logicalFunctionInformation', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'DataNodeIdentifier')), opt=True)
    _IRI_Parameters_ccUnavailableReason = STR_PRINT(name=u'ccUnavailableReason', mode=MODE_TYPE, tag=(60, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_carrierSpecificData = OCT_STR(name=u'carrierSpecificData', mode=MODE_TYPE, tag=(61, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_current_previous_systems = SEQ(name=u'current-previous-systems', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'Current-Previous-Systems')), opt=True)
    _IRI_Parameters_change_Of_Target_Identity = SEQ(name=u'change-Of-Target-Identity', mode=MODE_TYPE, tag=(63, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'Change-Of-Target-Identity')), opt=True)
    _IRI_Parameters_requesting_Network_Identifier = OCT_STR(name=u'requesting-Network-Identifier', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_requesting_Node_Type = ENUM(name=u'requesting-Node-Type', mode=MODE_TYPE, tag=(65, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'Requesting-Node-Type')), opt=True)
    _IRI_Parameters_serving_System_Identifier = OCT_STR(name=u'serving-System-Identifier', mode=MODE_TYPE, tag=(66, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_proSeTargetType = ENUM(name=u'proSeTargetType', mode=MODE_TYPE, tag=(67, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'ProSeTargetType')), opt=True)
    _IRI_Parameters_proSeRelayMSISDN = OCT_STR(name=u'proSeRelayMSISDN', mode=MODE_TYPE, tag=(68, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_proSeRelayMSISDN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    _IRI_Parameters_proSeRelayIMSI = OCT_STR(name=u'proSeRelayIMSI', mode=MODE_TYPE, tag=(69, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_proSeRelayIMSI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    _IRI_Parameters_proSeRelayIMEI = OCT_STR(name=u'proSeRelayIMEI', mode=MODE_TYPE, tag=(70, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_proSeRelayIMEI._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _IRI_Parameters_extendedLocParameters = SEQ(name=u'extendedLocParameters', mode=MODE_TYPE, tag=(71, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'ExtendedLocParameters')), opt=True)
    _IRI_Parameters_locationErrorCode = INT(name=u'locationErrorCode', mode=MODE_TYPE, tag=(72, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'LocationErrorCode')), opt=True)
    _IRI_Parameters_otherIdentities = SEQ_OF(name=u'otherIdentities', mode=MODE_TYPE, tag=(73, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IRI_Parameters_otherIdentities__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EpsHI2Operations', 'PartyInformation')))
    _IRI_Parameters_otherIdentities._cont = __IRI_Parameters_otherIdentities__item_
    _IRI_Parameters_deregistrationReason = CHOICE(name=u'deregistrationReason', mode=MODE_TYPE, tag=(74, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'DeregistrationReason')), opt=True)
    _IRI_Parameters_requesting_Node_Identifier = OCT_STR(name=u'requesting-Node-Identifier', mode=MODE_TYPE, tag=(75, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_roamingIndication = ENUM(name=u'roamingIndication', mode=MODE_TYPE, tag=(76, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'VoIPRoamingIndication')), opt=True)
    _IRI_Parameters_cSREvent = ENUM(name=u'cSREvent', mode=MODE_TYPE, tag=(77, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'CSREvent')), opt=True)
    _IRI_Parameters_ptc = SEQ(name=u'ptc', mode=MODE_TYPE, tag=(78, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PTC')), opt=True)
    _IRI_Parameters_ptcEncryption = SEQ(name=u'ptcEncryption', mode=MODE_TYPE, tag=(79, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PTCEncryptionInfo')), opt=True)
    _IRI_Parameters_additionalCellIDs = SEQ_OF(name=u'additionalCellIDs', mode=MODE_TYPE, tag=(80, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IRI_Parameters_additionalCellIDs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EpsHI2Operations', 'AdditionalCellID')))
    _IRI_Parameters_additionalCellIDs._cont = __IRI_Parameters_additionalCellIDs__item_
    _IRI_Parameters_scefID = STR_UTF8(name=u'scefID', mode=MODE_TYPE, tag=(81, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_national_HI2_ASN1parameters = SEQ(name=u'national-HI2-ASN1parameters', mode=MODE_TYPE, tag=(255, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'National-HI2-ASN1parameters')), opt=True)
    IRI_Parameters._cont = ASN1Dict([
        (u'hi2epsDomainId', _IRI_Parameters_hi2epsDomainId),
        (u'lawfulInterceptionIdentifier', _IRI_Parameters_lawfulInterceptionIdentifier),
        (u'timeStamp', _IRI_Parameters_timeStamp),
        (u'initiator', _IRI_Parameters_initiator),
        (u'locationOfTheTarget', _IRI_Parameters_locationOfTheTarget),
        (u'partyInformation', _IRI_Parameters_partyInformation),
        (u'serviceCenterAddress', _IRI_Parameters_serviceCenterAddress),
        (u'sMS', _IRI_Parameters_sMS),
        (u'national-Parameters', _IRI_Parameters_national_Parameters),
        (u'ePSCorrelationNumber', _IRI_Parameters_ePSCorrelationNumber),
        (u'ePSevent', _IRI_Parameters_ePSevent),
        (u'sgsnAddress', _IRI_Parameters_sgsnAddress),
        (u'gPRSOperationErrorCode', _IRI_Parameters_gPRSOperationErrorCode),
        (u'ggsnAddress', _IRI_Parameters_ggsnAddress),
        (u'qOS', _IRI_Parameters_qOS),
        (u'networkIdentifier', _IRI_Parameters_networkIdentifier),
        (u'sMSOriginatingAddress', _IRI_Parameters_sMSOriginatingAddress),
        (u'sMSTerminatingAddress', _IRI_Parameters_sMSTerminatingAddress),
        (u'iMSevent', _IRI_Parameters_iMSevent),
        (u'sIPMessage', _IRI_Parameters_sIPMessage),
        (u'servingSGSN-number', _IRI_Parameters_servingSGSN_number),
        (u'servingSGSN-address', _IRI_Parameters_servingSGSN_address),
        (u'ldiEvent', _IRI_Parameters_ldiEvent),
        (u'correlation', _IRI_Parameters_correlation),
        (u'ePS-GTPV2-specificParameters', _IRI_Parameters_ePS_GTPV2_specificParameters),
        (u'ePS-PMIP-specificParameters', _IRI_Parameters_ePS_PMIP_specificParameters),
        (u'ePS-DSMIP-SpecificParameters', _IRI_Parameters_ePS_DSMIP_SpecificParameters),
        (u'ePS-MIP-SpecificParameters', _IRI_Parameters_ePS_MIP_SpecificParameters),
        (u'servingNodeAddress', _IRI_Parameters_servingNodeAddress),
        (u'visitedNetworkId', _IRI_Parameters_visitedNetworkId),
        (u'mediaDecryption-info', _IRI_Parameters_mediaDecryption_info),
        (u'servingS4-SGSN-address', _IRI_Parameters_servingS4_SGSN_address),
        (u'sipMessageHeaderOffer', _IRI_Parameters_sipMessageHeaderOffer),
        (u'sipMessageHeaderAnswer', _IRI_Parameters_sipMessageHeaderAnswer),
        (u'sdpOffer', _IRI_Parameters_sdpOffer),
        (u'sdpAnswer', _IRI_Parameters_sdpAnswer),
        (u'uLITimestamp', _IRI_Parameters_uLITimestamp),
        (u'packetDataHeaderInformation', _IRI_Parameters_packetDataHeaderInformation),
        (u'mediaSecFailureIndication', _IRI_Parameters_mediaSecFailureIndication),
        (u'csgIdentity', _IRI_Parameters_csgIdentity),
        (u'heNBIdentity', _IRI_Parameters_heNBIdentity),
        (u'heNBiPAddress', _IRI_Parameters_heNBiPAddress),
        (u'heNBLocation', _IRI_Parameters_heNBLocation),
        (u'tunnelProtocol', _IRI_Parameters_tunnelProtocol),
        (u'pANI-Header-Info', _IRI_Parameters_pANI_Header_Info),
        (u'imsVoIP', _IRI_Parameters_imsVoIP),
        (u'xCAPmessage', _IRI_Parameters_xCAPmessage),
        (u'logicalFunctionInformation', _IRI_Parameters_logicalFunctionInformation),
        (u'ccUnavailableReason', _IRI_Parameters_ccUnavailableReason),
        (u'carrierSpecificData', _IRI_Parameters_carrierSpecificData),
        (u'current-previous-systems', _IRI_Parameters_current_previous_systems),
        (u'change-Of-Target-Identity', _IRI_Parameters_change_Of_Target_Identity),
        (u'requesting-Network-Identifier', _IRI_Parameters_requesting_Network_Identifier),
        (u'requesting-Node-Type', _IRI_Parameters_requesting_Node_Type),
        (u'serving-System-Identifier', _IRI_Parameters_serving_System_Identifier),
        (u'proSeTargetType', _IRI_Parameters_proSeTargetType),
        (u'proSeRelayMSISDN', _IRI_Parameters_proSeRelayMSISDN),
        (u'proSeRelayIMSI', _IRI_Parameters_proSeRelayIMSI),
        (u'proSeRelayIMEI', _IRI_Parameters_proSeRelayIMEI),
        (u'extendedLocParameters', _IRI_Parameters_extendedLocParameters),
        (u'locationErrorCode', _IRI_Parameters_locationErrorCode),
        (u'otherIdentities', _IRI_Parameters_otherIdentities),
        (u'deregistrationReason', _IRI_Parameters_deregistrationReason),
        (u'requesting-Node-Identifier', _IRI_Parameters_requesting_Node_Identifier),
        (u'roamingIndication', _IRI_Parameters_roamingIndication),
        (u'cSREvent', _IRI_Parameters_cSREvent),
        (u'ptc', _IRI_Parameters_ptc),
        (u'ptcEncryption', _IRI_Parameters_ptcEncryption),
        (u'additionalCellIDs', _IRI_Parameters_additionalCellIDs),
        (u'scefID', _IRI_Parameters_scefID),
        (u'national-HI2-ASN1parameters', _IRI_Parameters_national_HI2_ASN1parameters),
        ])
    IRI_Parameters._ext = [u'ldiEvent', u'correlation', u'ePS-GTPV2-specificParameters', u'ePS-PMIP-specificParameters', u'ePS-DSMIP-SpecificParameters', u'ePS-MIP-SpecificParameters', u'servingNodeAddress', u'visitedNetworkId', u'mediaDecryption-info', u'servingS4-SGSN-address', u'sipMessageHeaderOffer', u'sipMessageHeaderAnswer', u'sdpOffer', u'sdpAnswer', u'uLITimestamp', u'packetDataHeaderInformation', u'mediaSecFailureIndication', u'csgIdentity', u'heNBIdentity', u'heNBiPAddress', u'heNBLocation', u'tunnelProtocol', u'pANI-Header-Info', u'imsVoIP', u'xCAPmessage', u'logicalFunctionInformation', u'ccUnavailableReason', u'carrierSpecificData', u'current-previous-systems', u'change-Of-Target-Identity', u'requesting-Network-Identifier', u'requesting-Node-Type', u'serving-System-Identifier', u'proSeTargetType', u'proSeRelayMSISDN', u'proSeRelayIMSI', u'proSeRelayIMEI', u'extendedLocParameters', u'locationErrorCode', u'otherIdentities', u'deregistrationReason', u'requesting-Node-Identifier', u'roamingIndication', u'cSREvent', u'ptc', u'ptcEncryption', u'additionalCellIDs', u'scefID', u'national-HI2-ASN1parameters']
    
    #-----< DataNodeIdentifier >-----#
    DataNodeIdentifier = SEQ(name=u'DataNodeIdentifier', mode=MODE_TYPE)
    _DataNodeIdentifier_dataNodeAddress = CHOICE(name=u'dataNodeAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DataNodeAddress')), opt=True)
    _DataNodeIdentifier_logicalFunctionType = ENUM(name=u'logicalFunctionType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'LogicalFunctionType')), opt=True)
    _DataNodeIdentifier_dataNodeName = STR_PRINT(name=u'dataNodeName', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DataNodeIdentifier_dataNodeName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=7, ub=25)], ev=None, er=[])
    DataNodeIdentifier._cont = ASN1Dict([
        (u'dataNodeAddress', _DataNodeIdentifier_dataNodeAddress),
        (u'logicalFunctionType', _DataNodeIdentifier_logicalFunctionType),
        (u'dataNodeName', _DataNodeIdentifier_dataNodeName),
        ])
    DataNodeIdentifier._ext = []
    
    #-----< LogicalFunctionType >-----#
    LogicalFunctionType = ENUM(name=u'LogicalFunctionType', mode=MODE_TYPE)
    LogicalFunctionType._cont = ASN1Dict([(u'pDNGW', 0), (u'mME', 1), (u'sGW', 2), (u'ePDG', 3), (u'hSS', 4)])
    LogicalFunctionType._ext = []
    
    #-----< PANI-Header-Info >-----#
    PANI_Header_Info = SEQ(name=u'PANI-Header-Info', mode=MODE_TYPE)
    _PANI_Header_Info_access_Type = OCT_STR(name=u'access-Type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PANI_Header_Info_access_Class = OCT_STR(name=u'access-Class', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PANI_Header_Info_network_Provided = NULL(name=u'network-Provided', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PANI_Header_Info_pANI_Location = SEQ(name=u'pANI-Location', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PANI-Location')), opt=True)
    PANI_Header_Info._cont = ASN1Dict([
        (u'access-Type', _PANI_Header_Info_access_Type),
        (u'access-Class', _PANI_Header_Info_access_Class),
        (u'network-Provided', _PANI_Header_Info_network_Provided),
        (u'pANI-Location', _PANI_Header_Info_pANI_Location),
        ])
    PANI_Header_Info._ext = []
    
    #-----< PANI-Location >-----#
    PANI_Location = SEQ(name=u'PANI-Location', mode=MODE_TYPE)
    _PANI_Location_raw_Location = OCT_STR(name=u'raw-Location', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PANI_Location_location = SEQ(name=u'location', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'Location')), opt=True)
    _PANI_Location_ePSLocation = SEQ(name=u'ePSLocation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'EPSLocation')), opt=True)
    PANI_Location._cont = ASN1Dict([
        (u'raw-Location', _PANI_Location_raw_Location),
        (u'location', _PANI_Location_location),
        (u'ePSLocation', _PANI_Location_ePSLocation),
        ])
    PANI_Location._ext = []
    
    #-----< PartyInformation >-----#
    PartyInformation = SEQ(name=u'PartyInformation', mode=MODE_TYPE)
    _PartyInformation_party_Qualifier = ENUM(name=u'party-Qualifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PartyInformation_party_Qualifier._cont = ASN1Dict([(u'gPRSorEPS-Target', 3)])
    _PartyInformation_party_Qualifier._ext = []
    _PartyInformation_partyIdentity = SEQ(name=u'partyIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PartyInformation_partyIdentity_imei = OCT_STR(name=u'imei', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_imei._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    __PartyInformation_partyIdentity_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_imsi._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    __PartyInformation_partyIdentity_msISDN = OCT_STR(name=u'msISDN', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_msISDN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    __PartyInformation_partyIdentity_e164_Format = OCT_STR(name=u'e164-Format', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_e164_Format._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=25)], ev=None, er=[])
    __PartyInformation_partyIdentity_sip_uri = OCT_STR(name=u'sip-uri', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_tel_uri = OCT_STR(name=u'tel-uri', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_nai = OCT_STR(name=u'nai', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_x_3GPP_Asserted_Identity = OCT_STR(name=u'x-3GPP-Asserted-Identity', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_xUI = OCT_STR(name=u'xUI', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_iMPI = OCT_STR(name=u'iMPI', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_extID = STR_UTF8(name=u'extID', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PartyInformation_partyIdentity._cont = ASN1Dict([
        (u'imei', __PartyInformation_partyIdentity_imei),
        (u'imsi', __PartyInformation_partyIdentity_imsi),
        (u'msISDN', __PartyInformation_partyIdentity_msISDN),
        (u'e164-Format', __PartyInformation_partyIdentity_e164_Format),
        (u'sip-uri', __PartyInformation_partyIdentity_sip_uri),
        (u'tel-uri', __PartyInformation_partyIdentity_tel_uri),
        (u'nai', __PartyInformation_partyIdentity_nai),
        (u'x-3GPP-Asserted-Identity', __PartyInformation_partyIdentity_x_3GPP_Asserted_Identity),
        (u'xUI', __PartyInformation_partyIdentity_xUI),
        (u'iMPI', __PartyInformation_partyIdentity_iMPI),
        (u'extID', __PartyInformation_partyIdentity_extID),
        ])
    _PartyInformation_partyIdentity._ext = [u'tel-uri', u'nai', u'x-3GPP-Asserted-Identity', u'xUI', u'iMPI', u'extID']
    _PartyInformation_services_Data_Information = SEQ(name=u'services-Data-Information', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'Services-Data-Information')), opt=True)
    PartyInformation._cont = ASN1Dict([
        (u'party-Qualifier', _PartyInformation_party_Qualifier),
        (u'partyIdentity', _PartyInformation_partyIdentity),
        (u'services-Data-Information', _PartyInformation_services_Data_Information),
        ])
    PartyInformation._ext = []
    
    #-----< Location >-----#
    Location = SEQ(name=u'Location', mode=MODE_TYPE)
    _Location_e164_Number = OCT_STR(name=u'e164-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Location_e164_Number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=25)], ev=None, er=[])
    _Location_globalCellID = OCT_STR(name=u'globalCellID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'GlobalCellID')), opt=True)
    _Location_rAI = OCT_STR(name=u'rAI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'Rai')), opt=True)
    _Location_gsmLocation = CHOICE(name=u'gsmLocation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'GSMLocation')), opt=True)
    _Location_umtsLocation = CHOICE(name=u'umtsLocation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'UMTSLocation')), opt=True)
    _Location_sAI = OCT_STR(name=u'sAI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'Sai')), opt=True)
    _Location_oldRAI = OCT_STR(name=u'oldRAI', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'Rai')), opt=True)
    _Location_civicAddress = CHOICE(name=u'civicAddress', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'CivicAddress')), opt=True)
    _Location_operatorSpecificInfo = OCT_STR(name=u'operatorSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Location_uELocationTimestamp = CHOICE(name=u'uELocationTimestamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __Location_uELocationTimestamp_timestamp = CHOICE(name=u'timestamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    __Location_uELocationTimestamp_timestampUnknown = NULL(name=u'timestampUnknown', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Location_uELocationTimestamp._cont = ASN1Dict([
        (u'timestamp', __Location_uELocationTimestamp_timestamp),
        (u'timestampUnknown', __Location_uELocationTimestamp_timestampUnknown),
        ])
    _Location_uELocationTimestamp._ext = []
    Location._cont = ASN1Dict([
        (u'e164-Number', _Location_e164_Number),
        (u'globalCellID', _Location_globalCellID),
        (u'rAI', _Location_rAI),
        (u'gsmLocation', _Location_gsmLocation),
        (u'umtsLocation', _Location_umtsLocation),
        (u'sAI', _Location_sAI),
        (u'oldRAI', _Location_oldRAI),
        (u'civicAddress', _Location_civicAddress),
        (u'operatorSpecificInfo', _Location_operatorSpecificInfo),
        (u'uELocationTimestamp', _Location_uELocationTimestamp),
        ])
    Location._ext = [u'oldRAI', u'civicAddress', u'operatorSpecificInfo', u'uELocationTimestamp']
    
    #-----< GlobalCellID >-----#
    GlobalCellID = OCT_STR(name=u'GlobalCellID', mode=MODE_TYPE)
    GlobalCellID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=7)], ev=None, er=[])
    
    #-----< Rai >-----#
    Rai = OCT_STR(name=u'Rai', mode=MODE_TYPE)
    Rai._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< Sai >-----#
    Sai = OCT_STR(name=u'Sai', mode=MODE_TYPE)
    Sai._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    
    #-----< AdditionalCellID >-----#
    AdditionalCellID = SEQ(name=u'AdditionalCellID', mode=MODE_TYPE)
    _AdditionalCellID_nCGI = SEQ(name=u'nCGI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'NCGI')))
    _AdditionalCellID_gsmLocation = CHOICE(name=u'gsmLocation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'GSMLocation')), opt=True)
    _AdditionalCellID_umtsLocation = CHOICE(name=u'umtsLocation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'UMTSLocation')), opt=True)
    _AdditionalCellID_timeOfLocation = TIME_GEN(name=u'timeOfLocation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    AdditionalCellID._cont = ASN1Dict([
        (u'nCGI', _AdditionalCellID_nCGI),
        (u'gsmLocation', _AdditionalCellID_gsmLocation),
        (u'umtsLocation', _AdditionalCellID_umtsLocation),
        (u'timeOfLocation', _AdditionalCellID_timeOfLocation),
        ])
    AdditionalCellID._ext = []
    
    #-----< MCC >-----#
    MCC = STR_NUM(name=u'MCC', mode=MODE_TYPE)
    MCC._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< MNC >-----#
    MNC = STR_NUM(name=u'MNC', mode=MODE_TYPE)
    MNC._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=3)], ev=None, er=[])
    
    #-----< PLMNID >-----#
    PLMNID = SEQ(name=u'PLMNID', mode=MODE_TYPE)
    _PLMNID_mCC = STR_NUM(name=u'mCC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'MCC')))
    _PLMNID_mNC = STR_NUM(name=u'mNC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'MNC')))
    PLMNID._cont = ASN1Dict([
        (u'mCC', _PLMNID_mCC),
        (u'mNC', _PLMNID_mNC),
        ])
    PLMNID._ext = []
    
    #-----< NRCellID >-----#
    NRCellID = BIT_STR(name=u'NRCellID', mode=MODE_TYPE)
    NRCellID._const_sz = ASN1Set(rv=[36], rr=[], ev=None, er=[])
    
    #-----< NCGI >-----#
    NCGI = SEQ(name=u'NCGI', mode=MODE_TYPE)
    _NCGI_pLMNID = SEQ(name=u'pLMNID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PLMNID')))
    _NCGI_nRCellID = BIT_STR(name=u'nRCellID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'NRCellID')))
    NCGI._cont = ASN1Dict([
        (u'pLMNID', _NCGI_pLMNID),
        (u'nRCellID', _NCGI_nRCellID),
        ])
    NCGI._ext = []
    
    #-----< GSMLocation >-----#
    GSMLocation = CHOICE(name=u'GSMLocation', mode=MODE_TYPE)
    _GSMLocation_geoCoordinates = SEQ(name=u'geoCoordinates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GSMLocation_geoCoordinates_latitude = STR_PRINT(name=u'latitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GSMLocation_geoCoordinates_latitude._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=7, ub=10)], ev=None, er=[])
    __GSMLocation_geoCoordinates_longitude = STR_PRINT(name=u'longitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GSMLocation_geoCoordinates_longitude._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=11)], ev=None, er=[])
    __GSMLocation_geoCoordinates_mapDatum = ENUM(name=u'mapDatum', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'MapDatum')), default=u'wGS84')
    __GSMLocation_geoCoordinates_azimuth = INT(name=u'azimuth', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GSMLocation_geoCoordinates_azimuth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _GSMLocation_geoCoordinates._cont = ASN1Dict([
        (u'latitude', __GSMLocation_geoCoordinates_latitude),
        (u'longitude', __GSMLocation_geoCoordinates_longitude),
        (u'mapDatum', __GSMLocation_geoCoordinates_mapDatum),
        (u'azimuth', __GSMLocation_geoCoordinates_azimuth),
        ])
    _GSMLocation_geoCoordinates._ext = [u'azimuth']
    _GSMLocation_utmCoordinates = SEQ(name=u'utmCoordinates', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GSMLocation_utmCoordinates_utm_East = STR_PRINT(name=u'utm-East', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GSMLocation_utmCoordinates_utm_East._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    __GSMLocation_utmCoordinates_utm_North = STR_PRINT(name=u'utm-North', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GSMLocation_utmCoordinates_utm_North._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    __GSMLocation_utmCoordinates_mapDatum = ENUM(name=u'mapDatum', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'MapDatum')), default=u'wGS84')
    __GSMLocation_utmCoordinates_azimuth = INT(name=u'azimuth', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GSMLocation_utmCoordinates_azimuth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _GSMLocation_utmCoordinates._cont = ASN1Dict([
        (u'utm-East', __GSMLocation_utmCoordinates_utm_East),
        (u'utm-North', __GSMLocation_utmCoordinates_utm_North),
        (u'mapDatum', __GSMLocation_utmCoordinates_mapDatum),
        (u'azimuth', __GSMLocation_utmCoordinates_azimuth),
        ])
    _GSMLocation_utmCoordinates._ext = [u'azimuth']
    _GSMLocation_utmRefCoordinates = SEQ(name=u'utmRefCoordinates', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GSMLocation_utmRefCoordinates_utmref_string = STR_PRINT(name=u'utmref-string', mode=MODE_TYPE)
    __GSMLocation_utmRefCoordinates_utmref_string._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    __GSMLocation_utmRefCoordinates_mapDatum = ENUM(name=u'mapDatum', mode=MODE_TYPE, typeref=ASN1RefType(('EpsHI2Operations', 'MapDatum')), default=u'wGS84')
    _GSMLocation_utmRefCoordinates._cont = ASN1Dict([
        (u'utmref-string', __GSMLocation_utmRefCoordinates_utmref_string),
        (u'mapDatum', __GSMLocation_utmRefCoordinates_mapDatum),
        ])
    _GSMLocation_utmRefCoordinates._ext = []
    _GSMLocation_wGS84Coordinates = OCT_STR(name=u'wGS84Coordinates', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    GSMLocation._cont = ASN1Dict([
        (u'geoCoordinates', _GSMLocation_geoCoordinates),
        (u'utmCoordinates', _GSMLocation_utmCoordinates),
        (u'utmRefCoordinates', _GSMLocation_utmRefCoordinates),
        (u'wGS84Coordinates', _GSMLocation_wGS84Coordinates),
        ])
    GSMLocation._ext = None
    
    #-----< MapDatum >-----#
    MapDatum = ENUM(name=u'MapDatum', mode=MODE_TYPE)
    MapDatum._cont = ASN1Dict([(u'wGS84', 0), (u'wGS72', 1), (u'eD50', 2)])
    MapDatum._ext = []
    
    #-----< UMTSLocation >-----#
    UMTSLocation = CHOICE(name=u'UMTSLocation', mode=MODE_TYPE)
    _UMTSLocation_point = SEQ(name=u'point', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'GA-Point')))
    _UMTSLocation_pointWithUnCertainty = SEQ(name=u'pointWithUnCertainty', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'GA-PointWithUnCertainty')))
    _UMTSLocation_polygon = SEQ_OF(name=u'polygon', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'GA-Polygon')))
    UMTSLocation._cont = ASN1Dict([
        (u'point', _UMTSLocation_point),
        (u'pointWithUnCertainty', _UMTSLocation_pointWithUnCertainty),
        (u'polygon', _UMTSLocation_polygon),
        ])
    UMTSLocation._ext = None
    
    #-----< GeographicalCoordinates >-----#
    GeographicalCoordinates = SEQ(name=u'GeographicalCoordinates', mode=MODE_TYPE)
    _GeographicalCoordinates_latitudeSign = ENUM(name=u'latitudeSign', mode=MODE_TYPE)
    _GeographicalCoordinates_latitudeSign._cont = ASN1Dict([(u'north', 0), (u'south', 1)])
    _GeographicalCoordinates_latitudeSign._ext = None
    _GeographicalCoordinates_latitude = INT(name=u'latitude', mode=MODE_TYPE)
    _GeographicalCoordinates_latitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    _GeographicalCoordinates_longitude = INT(name=u'longitude', mode=MODE_TYPE)
    _GeographicalCoordinates_longitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    GeographicalCoordinates._cont = ASN1Dict([
        (u'latitudeSign', _GeographicalCoordinates_latitudeSign),
        (u'latitude', _GeographicalCoordinates_latitude),
        (u'longitude', _GeographicalCoordinates_longitude),
        ])
    GeographicalCoordinates._ext = []
    
    #-----< GA-Point >-----#
    GA_Point = SEQ(name=u'GA-Point', mode=MODE_TYPE)
    _GA_Point_geographicalCoordinates = SEQ(name=u'geographicalCoordinates', mode=MODE_TYPE, typeref=ASN1RefType(('EpsHI2Operations', 'GeographicalCoordinates')))
    GA_Point._cont = ASN1Dict([
        (u'geographicalCoordinates', _GA_Point_geographicalCoordinates),
        ])
    GA_Point._ext = []
    
    #-----< GA-PointWithUnCertainty >-----#
    GA_PointWithUnCertainty = SEQ(name=u'GA-PointWithUnCertainty', mode=MODE_TYPE)
    _GA_PointWithUnCertainty_geographicalCoordinates = SEQ(name=u'geographicalCoordinates', mode=MODE_TYPE, typeref=ASN1RefType(('EpsHI2Operations', 'GeographicalCoordinates')))
    _GA_PointWithUnCertainty_uncertaintyCode = INT(name=u'uncertaintyCode', mode=MODE_TYPE)
    _GA_PointWithUnCertainty_uncertaintyCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    GA_PointWithUnCertainty._cont = ASN1Dict([
        (u'geographicalCoordinates', _GA_PointWithUnCertainty_geographicalCoordinates),
        (u'uncertaintyCode', _GA_PointWithUnCertainty_uncertaintyCode),
        ])
    GA_PointWithUnCertainty._ext = None
    
    #-----< maxNrOfPoints >-----#
    maxNrOfPoints = INT(name=u'maxNrOfPoints', mode=MODE_VALUE)
    maxNrOfPoints._val = 15
    
    #-----< GA-Polygon >-----#
    GA_Polygon = SEQ_OF(name=u'GA-Polygon', mode=MODE_TYPE)
    _GA_Polygon__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GA_Polygon__item__geographicalCoordinates = SEQ(name=u'geographicalCoordinates', mode=MODE_TYPE, typeref=ASN1RefType(('EpsHI2Operations', 'GeographicalCoordinates')))
    _GA_Polygon__item_._cont = ASN1Dict([
        (u'geographicalCoordinates', __GA_Polygon__item__geographicalCoordinates),
        ])
    _GA_Polygon__item_._ext = []
    GA_Polygon._cont = _GA_Polygon__item_
    GA_Polygon._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< SMS-report >-----#
    SMS_report = SEQ(name=u'SMS-report', mode=MODE_TYPE)
    _SMS_report_sMS_Contents = SEQ(name=u'sMS-Contents', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SMS_report_sMS_Contents_sms_initiator = ENUM(name=u'sms-initiator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SMS_report_sMS_Contents_sms_initiator._cont = ASN1Dict([(u'target', 0), (u'server', 1), (u'undefined-party', 2)])
    __SMS_report_sMS_Contents_sms_initiator._ext = []
    __SMS_report_sMS_Contents_transfer_status = ENUM(name=u'transfer-status', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SMS_report_sMS_Contents_transfer_status._cont = ASN1Dict([(u'succeed-transfer', 0), (u'not-succeed-transfer', 1), (u'undefined', 2)])
    __SMS_report_sMS_Contents_transfer_status._ext = []
    __SMS_report_sMS_Contents_other_message = ENUM(name=u'other-message', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SMS_report_sMS_Contents_other_message._cont = ASN1Dict([(u'yes', 0), (u'no', 1), (u'undefined', 2)])
    __SMS_report_sMS_Contents_other_message._ext = []
    __SMS_report_sMS_Contents_content = OCT_STR(name=u'content', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SMS_report_sMS_Contents_content._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=270)], ev=None, er=[])
    _SMS_report_sMS_Contents._cont = ASN1Dict([
        (u'sms-initiator', __SMS_report_sMS_Contents_sms_initiator),
        (u'transfer-status', __SMS_report_sMS_Contents_transfer_status),
        (u'other-message', __SMS_report_sMS_Contents_other_message),
        (u'content', __SMS_report_sMS_Contents_content),
        ])
    _SMS_report_sMS_Contents._ext = []
    SMS_report._cont = ASN1Dict([
        (u'sMS-Contents', _SMS_report_sMS_Contents),
        ])
    SMS_report._ext = None
    
    #-----< EPSCorrelationNumber >-----#
    EPSCorrelationNumber = OCT_STR(name=u'EPSCorrelationNumber', mode=MODE_TYPE)
    
    #-----< CorrelationValues >-----#
    CorrelationValues = CHOICE(name=u'CorrelationValues', mode=MODE_TYPE)
    _CorrelationValues_iri_to_CC = SEQ(name=u'iri-to-CC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'IRI-to-CC-Correlation')))
    _CorrelationValues_iri_to_iri = OCT_STR(name=u'iri-to-iri', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'IRI-to-IRI-Correlation')))
    _CorrelationValues_both_IRI_CC = SEQ(name=u'both-IRI-CC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CorrelationValues_both_IRI_CC_iri_CC = SEQ(name=u'iri-CC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'IRI-to-CC-Correlation')))
    __CorrelationValues_both_IRI_CC_iri_IRI = OCT_STR(name=u'iri-IRI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'IRI-to-IRI-Correlation')))
    _CorrelationValues_both_IRI_CC._cont = ASN1Dict([
        (u'iri-CC', __CorrelationValues_both_IRI_CC_iri_CC),
        (u'iri-IRI', __CorrelationValues_both_IRI_CC_iri_IRI),
        ])
    _CorrelationValues_both_IRI_CC._ext = None
    CorrelationValues._cont = ASN1Dict([
        (u'iri-to-CC', _CorrelationValues_iri_to_CC),
        (u'iri-to-iri', _CorrelationValues_iri_to_iri),
        (u'both-IRI-CC', _CorrelationValues_both_IRI_CC),
        ])
    CorrelationValues._ext = None
    
    #-----< IMS-VoIP-Correlation >-----#
    IMS_VoIP_Correlation = SET_OF(name=u'IMS-VoIP-Correlation', mode=MODE_TYPE)
    _IMS_VoIP_Correlation__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __IMS_VoIP_Correlation__item__ims_iri = OCT_STR(name=u'ims-iri', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'IRI-to-IRI-Correlation')))
    __IMS_VoIP_Correlation__item__ims_cc = SEQ(name=u'ims-cc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'IRI-to-CC-Correlation')), opt=True)
    _IMS_VoIP_Correlation__item_._cont = ASN1Dict([
        (u'ims-iri', __IMS_VoIP_Correlation__item__ims_iri),
        (u'ims-cc', __IMS_VoIP_Correlation__item__ims_cc),
        ])
    _IMS_VoIP_Correlation__item_._ext = None
    IMS_VoIP_Correlation._cont = _IMS_VoIP_Correlation__item_
    
    #-----< IRI-to-CC-Correlation >-----#
    IRI_to_CC_Correlation = SEQ(name=u'IRI-to-CC-Correlation', mode=MODE_TYPE)
    _IRI_to_CC_Correlation_cc = SET_OF(name=u'cc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __IRI_to_CC_Correlation_cc__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    _IRI_to_CC_Correlation_cc._cont = __IRI_to_CC_Correlation_cc__item_
    _IRI_to_CC_Correlation_iri = OCT_STR(name=u'iri', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    IRI_to_CC_Correlation._cont = ASN1Dict([
        (u'cc', _IRI_to_CC_Correlation_cc),
        (u'iri', _IRI_to_CC_Correlation_iri),
        ])
    IRI_to_CC_Correlation._ext = None
    
    #-----< IRI-to-IRI-Correlation >-----#
    IRI_to_IRI_Correlation = OCT_STR(name=u'IRI-to-IRI-Correlation', mode=MODE_TYPE)
    
    #-----< EPSEvent >-----#
    EPSEvent = ENUM(name=u'EPSEvent', mode=MODE_TYPE)
    EPSEvent._cont = ASN1Dict([(u'pDPContextActivation', 1), (u'startOfInterceptionWithPDPContextActive', 2), (u'pDPContextDeactivation', 4), (u'gPRSAttach', 5), (u'gPRSDetach', 6), (u'locationInfoUpdate', 10), (u'sMS', 11), (u'pDPContextModification', 13), (u'servingSystem', 14), (u'startOfInterceptionWithMSAttached', 15), (u'e-UTRANAttach', 16), (u'e-UTRANDetach', 17), (u'bearerActivation', 18), (u'startOfInterceptionWithActiveBearer', 19), (u'bearerModification', 20), (u'bearerDeactivation', 21), (u'uERequestedBearerResourceModification', 22), (u'uERequestedPDNConnectivity', 23), (u'uERequestedPDNDisconnection', 24), (u'trackingAreaEpsLocationUpdate', 25), (u'servingEvolvedPacketSystem', 26), (u'pMIPAttachTunnelActivation', 27), (u'pMIPDetachTunnelDeactivation', 28), (u'startOfInterceptWithActivePMIPTunnel', 29), (u'pMIPPdnGwInitiatedPdnDisconnection', 30), (u'mIPRegistrationTunnelActivation', 31), (u'mIPDeregistrationTunnelDeactivation', 32), (u'startOfInterceptWithActiveMIPTunnel', 33), (u'dSMIPRegistrationTunnelActivation', 34), (u'dSMIPDeregistrationTunnelDeactivation', 35), (u'startOfInterceptWithActiveDsmipTunnel', 36), (u'dSMipHaSwitch', 37), (u'pMIPResourceAllocationDeactivation', 38), (u'mIPResourceAllocationDeactivation', 39), (u'pMIPsessionModification', 40), (u'startOfInterceptWithEUTRANAttachedUE', 41), (u'dSMIPSessionModification', 42), (u'packetDataHeaderInformation', 43), (u'hSS-Subscriber-Record-Change', 44), (u'registration-Termination', 45), (u'location-Up-Date', 46), (u'cancel-Location', 47), (u'register-Location', 48), (u'location-Information-Request', 49), (u'proSeRemoteUEReport', 50), (u'proSeRemoteUEStartOfCommunication', 51), (u'proSeRemoteUEEndOfCommunication', 52), (u'startOfLIwithProSeRemoteUEOngoingComm', 53), (u'startOfLIforProSeUEtoNWRelay', 54), (u'scefRequestednonIPPDNDisconnection', 55)])
    EPSEvent._ext = [u'startOfInterceptionWithMSAttached', u'e-UTRANAttach', u'e-UTRANDetach', u'bearerActivation', u'startOfInterceptionWithActiveBearer', u'bearerModification', u'bearerDeactivation', u'uERequestedBearerResourceModification', u'uERequestedPDNConnectivity', u'uERequestedPDNDisconnection', u'trackingAreaEpsLocationUpdate', u'servingEvolvedPacketSystem', u'pMIPAttachTunnelActivation', u'pMIPDetachTunnelDeactivation', u'startOfInterceptWithActivePMIPTunnel', u'pMIPPdnGwInitiatedPdnDisconnection', u'mIPRegistrationTunnelActivation', u'mIPDeregistrationTunnelDeactivation', u'startOfInterceptWithActiveMIPTunnel', u'dSMIPRegistrationTunnelActivation', u'dSMIPDeregistrationTunnelDeactivation', u'startOfInterceptWithActiveDsmipTunnel', u'dSMipHaSwitch', u'pMIPResourceAllocationDeactivation', u'mIPResourceAllocationDeactivation', u'pMIPsessionModification', u'startOfInterceptWithEUTRANAttachedUE', u'dSMIPSessionModification', u'packetDataHeaderInformation', u'hSS-Subscriber-Record-Change', u'registration-Termination', u'location-Up-Date', u'cancel-Location', u'register-Location', u'location-Information-Request', u'proSeRemoteUEReport', u'proSeRemoteUEStartOfCommunication', u'proSeRemoteUEEndOfCommunication', u'startOfLIwithProSeRemoteUEOngoingComm', u'startOfLIforProSeUEtoNWRelay', u'scefRequestednonIPPDNDisconnection']
    
    #-----< CSREvent >-----#
    CSREvent = ENUM(name=u'CSREvent', mode=MODE_TYPE)
    CSREvent._cont = ASN1Dict([(u'cSREventMessage', 1)])
    CSREvent._ext = []
    
    #-----< IMSevent >-----#
    IMSevent = ENUM(name=u'IMSevent', mode=MODE_TYPE)
    IMSevent._cont = ASN1Dict([(u'unfilteredSIPmessage', 1), (u'sIPheaderOnly', 2), (u'decryptionKeysAvailable', 3), (u'startOfInterceptionForIMSEstablishedSession', 4), (u'xCAPRequest', 5), (u'xCAPResponse', 6), (u'ccUnavailable', 7), (u'sMSOverIMS', 8), (u'servingSystem', 9), (u'subscriberRecordChange', 10), (u'registrationTermination', 11), (u'locationInformationRequest', 12)])
    IMSevent._ext = [u'sIPheaderOnly', u'decryptionKeysAvailable', u'startOfInterceptionForIMSEstablishedSession', u'xCAPRequest', u'xCAPResponse', u'ccUnavailable', u'sMSOverIMS', u'servingSystem', u'subscriberRecordChange', u'registrationTermination', u'locationInformationRequest']
    
    #-----< Services-Data-Information >-----#
    Services_Data_Information = SEQ(name=u'Services-Data-Information', mode=MODE_TYPE)
    _Services_Data_Information_gPRS_parameters = SEQ(name=u'gPRS-parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'GPRS-parameters')), opt=True)
    Services_Data_Information._cont = ASN1Dict([
        (u'gPRS-parameters', _Services_Data_Information_gPRS_parameters),
        ])
    Services_Data_Information._ext = []
    
    #-----< GPRS-parameters >-----#
    GPRS_parameters = SEQ(name=u'GPRS-parameters', mode=MODE_TYPE)
    _GPRS_parameters_pDP_address_allocated_to_the_target = CHOICE(name=u'pDP-address-allocated-to-the-target', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DataNodeAddress')), opt=True)
    _GPRS_parameters_aPN = OCT_STR(name=u'aPN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GPRS_parameters_aPN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _GPRS_parameters_pDP_type = OCT_STR(name=u'pDP-type', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GPRS_parameters_pDP_type._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GPRS_parameters_nSAPI = OCT_STR(name=u'nSAPI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GPRS_parameters_nSAPI._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _GPRS_parameters_additionalIPaddress = CHOICE(name=u'additionalIPaddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DataNodeAddress')), opt=True)
    GPRS_parameters._cont = ASN1Dict([
        (u'pDP-address-allocated-to-the-target', _GPRS_parameters_pDP_address_allocated_to_the_target),
        (u'aPN', _GPRS_parameters_aPN),
        (u'pDP-type', _GPRS_parameters_pDP_type),
        (u'nSAPI', _GPRS_parameters_nSAPI),
        (u'additionalIPaddress', _GPRS_parameters_additionalIPaddress),
        ])
    GPRS_parameters._ext = [u'nSAPI', u'additionalIPaddress']
    
    #-----< GPRSOperationErrorCode >-----#
    GPRSOperationErrorCode = OCT_STR(name=u'GPRSOperationErrorCode', mode=MODE_TYPE)
    
    #-----< LDIevent >-----#
    LDIevent = ENUM(name=u'LDIevent', mode=MODE_TYPE)
    LDIevent._cont = ASN1Dict([(u'targetEntersIA', 1), (u'targetLeavesIA', 2)])
    LDIevent._ext = []
    
    #-----< UmtsQos >-----#
    UmtsQos = CHOICE(name=u'UmtsQos', mode=MODE_TYPE)
    _UmtsQos_qosMobileRadio = OCT_STR(name=u'qosMobileRadio', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UmtsQos_qosGn = OCT_STR(name=u'qosGn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    UmtsQos._cont = ASN1Dict([
        (u'qosMobileRadio', _UmtsQos_qosMobileRadio),
        (u'qosGn', _UmtsQos_qosGn),
        ])
    UmtsQos._ext = None
    
    #-----< EPS-GTPV2-SpecificParameters >-----#
    EPS_GTPV2_SpecificParameters = SEQ(name=u'EPS-GTPV2-SpecificParameters', mode=MODE_TYPE)
    _EPS_GTPV2_SpecificParameters_pDNAddressAllocation = OCT_STR(name=u'pDNAddressAllocation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_aPN = OCT_STR(name=u'aPN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_aPN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _EPS_GTPV2_SpecificParameters_protConfigOptions = SEQ(name=u'protConfigOptions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'ProtConfigOptions')), opt=True)
    _EPS_GTPV2_SpecificParameters_attachType = OCT_STR(name=u'attachType', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_attachType._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _EPS_GTPV2_SpecificParameters_ePSBearerIdentity = OCT_STR(name=u'ePSBearerIdentity', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_detachType = OCT_STR(name=u'detachType', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_detachType._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _EPS_GTPV2_SpecificParameters_rATType = OCT_STR(name=u'rATType', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_rATType._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _EPS_GTPV2_SpecificParameters_failedBearerActivationReason = OCT_STR(name=u'failedBearerActivationReason', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_failedBearerActivationReason._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _EPS_GTPV2_SpecificParameters_ePSBearerQoS = OCT_STR(name=u'ePSBearerQoS', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_bearerActivationType = ENUM(name=u'bearerActivationType', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'TypeOfBearer')), opt=True)
    _EPS_GTPV2_SpecificParameters_aPN_AMBR = OCT_STR(name=u'aPN-AMBR', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_procedureTransactionId = OCT_STR(name=u'procedureTransactionId', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_linkedEPSBearerId = OCT_STR(name=u'linkedEPSBearerId', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_tFT = OCT_STR(name=u'tFT', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_handoverIndication = NULL(name=u'handoverIndication', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_failedBearerModReason = OCT_STR(name=u'failedBearerModReason', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_failedBearerModReason._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _EPS_GTPV2_SpecificParameters_trafficAggregateDescription = OCT_STR(name=u'trafficAggregateDescription', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_failedTAUReason = OCT_STR(name=u'failedTAUReason', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_failedTAUReason._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _EPS_GTPV2_SpecificParameters_failedEUTRANAttachReason = OCT_STR(name=u'failedEUTRANAttachReason', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_failedEUTRANAttachReason._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _EPS_GTPV2_SpecificParameters_servingMMEaddress = OCT_STR(name=u'servingMMEaddress', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_bearerDeactivationType = ENUM(name=u'bearerDeactivationType', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'TypeOfBearer')), opt=True)
    _EPS_GTPV2_SpecificParameters_bearerDeactivationCause = OCT_STR(name=u'bearerDeactivationCause', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_bearerDeactivationCause._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _EPS_GTPV2_SpecificParameters_ePSlocationOfTheTarget = SEQ(name=u'ePSlocationOfTheTarget', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'EPSLocation')), opt=True)
    _EPS_GTPV2_SpecificParameters_pDNType = OCT_STR(name=u'pDNType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_pDNType._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _EPS_GTPV2_SpecificParameters_requestType = OCT_STR(name=u'requestType', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_requestType._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _EPS_GTPV2_SpecificParameters_uEReqPDNConnFailReason = OCT_STR(name=u'uEReqPDNConnFailReason', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_uEReqPDNConnFailReason._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _EPS_GTPV2_SpecificParameters_extendedHandoverIndication = OCT_STR(name=u'extendedHandoverIndication', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_extendedHandoverIndication._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _EPS_GTPV2_SpecificParameters_uLITimestamp = OCT_STR(name=u'uLITimestamp', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_uLITimestamp._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _EPS_GTPV2_SpecificParameters_uELocalIPAddress = OCT_STR(name=u'uELocalIPAddress', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_uEUdpPort = OCT_STR(name=u'uEUdpPort', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_uEUdpPort._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _EPS_GTPV2_SpecificParameters_tWANIdentifier = OCT_STR(name=u'tWANIdentifier', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_tWANIdentifierTimestamp = OCT_STR(name=u'tWANIdentifierTimestamp', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_GTPV2_SpecificParameters_tWANIdentifierTimestamp._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _EPS_GTPV2_SpecificParameters_proSeRemoteUeContextConnected = SEQ_OF(name=u'proSeRemoteUeContextConnected', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'RemoteUeContextConnected')), opt=True)
    _EPS_GTPV2_SpecificParameters_proSeRemoteUeContextDisconnected = OCT_STR(name=u'proSeRemoteUeContextDisconnected', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'RemoteUeContextDisconnected')), opt=True)
    _EPS_GTPV2_SpecificParameters_secondaryRATUsageIndication = NULL(name=u'secondaryRATUsageIndication', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    EPS_GTPV2_SpecificParameters._cont = ASN1Dict([
        (u'pDNAddressAllocation', _EPS_GTPV2_SpecificParameters_pDNAddressAllocation),
        (u'aPN', _EPS_GTPV2_SpecificParameters_aPN),
        (u'protConfigOptions', _EPS_GTPV2_SpecificParameters_protConfigOptions),
        (u'attachType', _EPS_GTPV2_SpecificParameters_attachType),
        (u'ePSBearerIdentity', _EPS_GTPV2_SpecificParameters_ePSBearerIdentity),
        (u'detachType', _EPS_GTPV2_SpecificParameters_detachType),
        (u'rATType', _EPS_GTPV2_SpecificParameters_rATType),
        (u'failedBearerActivationReason', _EPS_GTPV2_SpecificParameters_failedBearerActivationReason),
        (u'ePSBearerQoS', _EPS_GTPV2_SpecificParameters_ePSBearerQoS),
        (u'bearerActivationType', _EPS_GTPV2_SpecificParameters_bearerActivationType),
        (u'aPN-AMBR', _EPS_GTPV2_SpecificParameters_aPN_AMBR),
        (u'procedureTransactionId', _EPS_GTPV2_SpecificParameters_procedureTransactionId),
        (u'linkedEPSBearerId', _EPS_GTPV2_SpecificParameters_linkedEPSBearerId),
        (u'tFT', _EPS_GTPV2_SpecificParameters_tFT),
        (u'handoverIndication', _EPS_GTPV2_SpecificParameters_handoverIndication),
        (u'failedBearerModReason', _EPS_GTPV2_SpecificParameters_failedBearerModReason),
        (u'trafficAggregateDescription', _EPS_GTPV2_SpecificParameters_trafficAggregateDescription),
        (u'failedTAUReason', _EPS_GTPV2_SpecificParameters_failedTAUReason),
        (u'failedEUTRANAttachReason', _EPS_GTPV2_SpecificParameters_failedEUTRANAttachReason),
        (u'servingMMEaddress', _EPS_GTPV2_SpecificParameters_servingMMEaddress),
        (u'bearerDeactivationType', _EPS_GTPV2_SpecificParameters_bearerDeactivationType),
        (u'bearerDeactivationCause', _EPS_GTPV2_SpecificParameters_bearerDeactivationCause),
        (u'ePSlocationOfTheTarget', _EPS_GTPV2_SpecificParameters_ePSlocationOfTheTarget),
        (u'pDNType', _EPS_GTPV2_SpecificParameters_pDNType),
        (u'requestType', _EPS_GTPV2_SpecificParameters_requestType),
        (u'uEReqPDNConnFailReason', _EPS_GTPV2_SpecificParameters_uEReqPDNConnFailReason),
        (u'extendedHandoverIndication', _EPS_GTPV2_SpecificParameters_extendedHandoverIndication),
        (u'uLITimestamp', _EPS_GTPV2_SpecificParameters_uLITimestamp),
        (u'uELocalIPAddress', _EPS_GTPV2_SpecificParameters_uELocalIPAddress),
        (u'uEUdpPort', _EPS_GTPV2_SpecificParameters_uEUdpPort),
        (u'tWANIdentifier', _EPS_GTPV2_SpecificParameters_tWANIdentifier),
        (u'tWANIdentifierTimestamp', _EPS_GTPV2_SpecificParameters_tWANIdentifierTimestamp),
        (u'proSeRemoteUeContextConnected', _EPS_GTPV2_SpecificParameters_proSeRemoteUeContextConnected),
        (u'proSeRemoteUeContextDisconnected', _EPS_GTPV2_SpecificParameters_proSeRemoteUeContextDisconnected),
        (u'secondaryRATUsageIndication', _EPS_GTPV2_SpecificParameters_secondaryRATUsageIndication),
        ])
    EPS_GTPV2_SpecificParameters._ext = [u'pDNType', u'requestType', u'uEReqPDNConnFailReason', u'extendedHandoverIndication', u'uLITimestamp', u'uELocalIPAddress', u'uEUdpPort', u'tWANIdentifier', u'tWANIdentifierTimestamp', u'proSeRemoteUeContextConnected', u'proSeRemoteUeContextDisconnected', u'secondaryRATUsageIndication']
    
    #-----< TypeOfBearer >-----#
    TypeOfBearer = ENUM(name=u'TypeOfBearer', mode=MODE_TYPE)
    TypeOfBearer._cont = ASN1Dict([(u'defaultBearer', 1), (u'dedicatedBearer', 2)])
    TypeOfBearer._ext = []
    
    #-----< EPSLocation >-----#
    EPSLocation = SEQ(name=u'EPSLocation', mode=MODE_TYPE)
    _EPSLocation_userLocationInfo = OCT_STR(name=u'userLocationInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPSLocation_userLocationInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=39)], ev=None, er=[])
    _EPSLocation_gsmLocation = CHOICE(name=u'gsmLocation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'GSMLocation')), opt=True)
    _EPSLocation_umtsLocation = CHOICE(name=u'umtsLocation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'UMTSLocation')), opt=True)
    _EPSLocation_olduserLocationInfo = OCT_STR(name=u'olduserLocationInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPSLocation_olduserLocationInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=39)], ev=None, er=[])
    _EPSLocation_lastVisitedTAI = OCT_STR(name=u'lastVisitedTAI', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPSLocation_lastVisitedTAI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _EPSLocation_tAIlist = OCT_STR(name=u'tAIlist', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPSLocation_tAIlist._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=7, ub=97)], ev=None, er=[])
    _EPSLocation_threeGPP2Bsid = OCT_STR(name=u'threeGPP2Bsid', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPSLocation_threeGPP2Bsid._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    _EPSLocation_civicAddress = CHOICE(name=u'civicAddress', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'CivicAddress')), opt=True)
    _EPSLocation_operatorSpecificInfo = OCT_STR(name=u'operatorSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPSLocation_uELocationTimestamp = CHOICE(name=u'uELocationTimestamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __EPSLocation_uELocationTimestamp_timestamp = CHOICE(name=u'timestamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    __EPSLocation_uELocationTimestamp_timestampUnknown = NULL(name=u'timestampUnknown', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EPSLocation_uELocationTimestamp._cont = ASN1Dict([
        (u'timestamp', __EPSLocation_uELocationTimestamp_timestamp),
        (u'timestampUnknown', __EPSLocation_uELocationTimestamp_timestampUnknown),
        ])
    _EPSLocation_uELocationTimestamp._ext = []
    EPSLocation._cont = ASN1Dict([
        (u'userLocationInfo', _EPSLocation_userLocationInfo),
        (u'gsmLocation', _EPSLocation_gsmLocation),
        (u'umtsLocation', _EPSLocation_umtsLocation),
        (u'olduserLocationInfo', _EPSLocation_olduserLocationInfo),
        (u'lastVisitedTAI', _EPSLocation_lastVisitedTAI),
        (u'tAIlist', _EPSLocation_tAIlist),
        (u'threeGPP2Bsid', _EPSLocation_threeGPP2Bsid),
        (u'civicAddress', _EPSLocation_civicAddress),
        (u'operatorSpecificInfo', _EPSLocation_operatorSpecificInfo),
        (u'uELocationTimestamp', _EPSLocation_uELocationTimestamp),
        ])
    EPSLocation._ext = [u'threeGPP2Bsid', u'civicAddress', u'operatorSpecificInfo', u'uELocationTimestamp']
    
    #-----< ProtConfigOptions >-----#
    ProtConfigOptions = SEQ(name=u'ProtConfigOptions', mode=MODE_TYPE)
    _ProtConfigOptions_ueToNetwork = OCT_STR(name=u'ueToNetwork', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProtConfigOptions_ueToNetwork._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=251)], ev=None, er=[])
    _ProtConfigOptions_networkToUe = OCT_STR(name=u'networkToUe', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProtConfigOptions_networkToUe._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=251)], ev=None, er=[])
    ProtConfigOptions._cont = ASN1Dict([
        (u'ueToNetwork', _ProtConfigOptions_ueToNetwork),
        (u'networkToUe', _ProtConfigOptions_networkToUe),
        ])
    ProtConfigOptions._ext = []
    
    #-----< RemoteUeContextConnected >-----#
    RemoteUeContextConnected = SEQ_OF(name=u'RemoteUeContextConnected', mode=MODE_TYPE)
    _RemoteUeContextConnected__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EpsHI2Operations', 'RemoteUEContext')))
    RemoteUeContextConnected._cont = _RemoteUeContextConnected__item_
    
    #-----< RemoteUEContext >-----#
    RemoteUEContext = SEQ(name=u'RemoteUEContext', mode=MODE_TYPE)
    _RemoteUEContext_remoteUserID = OCT_STR(name=u'remoteUserID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'RemoteUserID')))
    _RemoteUEContext_remoteUEIPInformation = OCT_STR(name=u'remoteUEIPInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'RemoteUEIPInformation')))
    RemoteUEContext._cont = ASN1Dict([
        (u'remoteUserID', _RemoteUEContext_remoteUserID),
        (u'remoteUEIPInformation', _RemoteUEContext_remoteUEIPInformation),
        ])
    RemoteUEContext._ext = []
    
    #-----< RemoteUserID >-----#
    RemoteUserID = OCT_STR(name=u'RemoteUserID', mode=MODE_TYPE)
    
    #-----< RemoteUEIPInformation >-----#
    RemoteUEIPInformation = OCT_STR(name=u'RemoteUEIPInformation', mode=MODE_TYPE)
    
    #-----< RemoteUeContextDisconnected >-----#
    RemoteUeContextDisconnected = OCT_STR(name=u'RemoteUeContextDisconnected', mode=MODE_TYPE, typeref=ASN1RefType(('EpsHI2Operations', 'RemoteUserID')))
    
    #-----< EPS-PMIP-SpecificParameters >-----#
    EPS_PMIP_SpecificParameters = SEQ(name=u'EPS-PMIP-SpecificParameters', mode=MODE_TYPE)
    _EPS_PMIP_SpecificParameters_lifetime = INT(name=u'lifetime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_PMIP_SpecificParameters_lifetime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _EPS_PMIP_SpecificParameters_accessTechnologyType = OCT_STR(name=u'accessTechnologyType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_PMIP_SpecificParameters_accessTechnologyType._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _EPS_PMIP_SpecificParameters_aPN = OCT_STR(name=u'aPN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_PMIP_SpecificParameters_aPN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _EPS_PMIP_SpecificParameters_iPv6HomeNetworkPrefix = OCT_STR(name=u'iPv6HomeNetworkPrefix', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_PMIP_SpecificParameters_iPv6HomeNetworkPrefix._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    _EPS_PMIP_SpecificParameters_protConfigurationOption = OCT_STR(name=u'protConfigurationOption', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_PMIP_SpecificParameters_handoverIndication = OCT_STR(name=u'handoverIndication', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_PMIP_SpecificParameters_handoverIndication._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _EPS_PMIP_SpecificParameters_status = INT(name=u'status', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_PMIP_SpecificParameters_status._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _EPS_PMIP_SpecificParameters_revocationTrigger = INT(name=u'revocationTrigger', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_PMIP_SpecificParameters_revocationTrigger._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _EPS_PMIP_SpecificParameters_iPv4HomeAddress = OCT_STR(name=u'iPv4HomeAddress', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_PMIP_SpecificParameters_iPv4HomeAddress._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _EPS_PMIP_SpecificParameters_iPv6careOfAddress = OCT_STR(name=u'iPv6careOfAddress', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_PMIP_SpecificParameters_iPv4careOfAddress = OCT_STR(name=u'iPv4careOfAddress', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_PMIP_SpecificParameters_servingNetwork = OCT_STR(name=u'servingNetwork', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_PMIP_SpecificParameters_servingNetwork._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _EPS_PMIP_SpecificParameters_dHCPv4AddressAllocationInd = OCT_STR(name=u'dHCPv4AddressAllocationInd', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_PMIP_SpecificParameters_dHCPv4AddressAllocationInd._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _EPS_PMIP_SpecificParameters_ePSlocationOfTheTarget = SEQ(name=u'ePSlocationOfTheTarget', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'EPSLocation')), opt=True)
    EPS_PMIP_SpecificParameters._cont = ASN1Dict([
        (u'lifetime', _EPS_PMIP_SpecificParameters_lifetime),
        (u'accessTechnologyType', _EPS_PMIP_SpecificParameters_accessTechnologyType),
        (u'aPN', _EPS_PMIP_SpecificParameters_aPN),
        (u'iPv6HomeNetworkPrefix', _EPS_PMIP_SpecificParameters_iPv6HomeNetworkPrefix),
        (u'protConfigurationOption', _EPS_PMIP_SpecificParameters_protConfigurationOption),
        (u'handoverIndication', _EPS_PMIP_SpecificParameters_handoverIndication),
        (u'status', _EPS_PMIP_SpecificParameters_status),
        (u'revocationTrigger', _EPS_PMIP_SpecificParameters_revocationTrigger),
        (u'iPv4HomeAddress', _EPS_PMIP_SpecificParameters_iPv4HomeAddress),
        (u'iPv6careOfAddress', _EPS_PMIP_SpecificParameters_iPv6careOfAddress),
        (u'iPv4careOfAddress', _EPS_PMIP_SpecificParameters_iPv4careOfAddress),
        (u'servingNetwork', _EPS_PMIP_SpecificParameters_servingNetwork),
        (u'dHCPv4AddressAllocationInd', _EPS_PMIP_SpecificParameters_dHCPv4AddressAllocationInd),
        (u'ePSlocationOfTheTarget', _EPS_PMIP_SpecificParameters_ePSlocationOfTheTarget),
        ])
    EPS_PMIP_SpecificParameters._ext = [u'servingNetwork', u'dHCPv4AddressAllocationInd', u'ePSlocationOfTheTarget']
    
    #-----< EPS-DSMIP-SpecificParameters >-----#
    EPS_DSMIP_SpecificParameters = SEQ(name=u'EPS-DSMIP-SpecificParameters', mode=MODE_TYPE)
    _EPS_DSMIP_SpecificParameters_lifetime = INT(name=u'lifetime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_DSMIP_SpecificParameters_lifetime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _EPS_DSMIP_SpecificParameters_requestedIPv6HomePrefix = OCT_STR(name=u'requestedIPv6HomePrefix', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_DSMIP_SpecificParameters_requestedIPv6HomePrefix._const_sz = ASN1Set(rv=[25], rr=[], ev=None, er=[])
    _EPS_DSMIP_SpecificParameters_homeAddress = OCT_STR(name=u'homeAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_DSMIP_SpecificParameters_homeAddress._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _EPS_DSMIP_SpecificParameters_iPv4careOfAddress = OCT_STR(name=u'iPv4careOfAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_DSMIP_SpecificParameters_iPv4careOfAddress._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _EPS_DSMIP_SpecificParameters_iPv6careOfAddress = OCT_STR(name=u'iPv6careOfAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_DSMIP_SpecificParameters_iPv6careOfAddress._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _EPS_DSMIP_SpecificParameters_aPN = OCT_STR(name=u'aPN', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_DSMIP_SpecificParameters_aPN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _EPS_DSMIP_SpecificParameters_status = INT(name=u'status', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_DSMIP_SpecificParameters_status._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _EPS_DSMIP_SpecificParameters_hSS_AAA_address = OCT_STR(name=u'hSS-AAA-address', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_DSMIP_SpecificParameters_targetPDN_GW_Address = OCT_STR(name=u'targetPDN-GW-Address', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    EPS_DSMIP_SpecificParameters._cont = ASN1Dict([
        (u'lifetime', _EPS_DSMIP_SpecificParameters_lifetime),
        (u'requestedIPv6HomePrefix', _EPS_DSMIP_SpecificParameters_requestedIPv6HomePrefix),
        (u'homeAddress', _EPS_DSMIP_SpecificParameters_homeAddress),
        (u'iPv4careOfAddress', _EPS_DSMIP_SpecificParameters_iPv4careOfAddress),
        (u'iPv6careOfAddress', _EPS_DSMIP_SpecificParameters_iPv6careOfAddress),
        (u'aPN', _EPS_DSMIP_SpecificParameters_aPN),
        (u'status', _EPS_DSMIP_SpecificParameters_status),
        (u'hSS-AAA-address', _EPS_DSMIP_SpecificParameters_hSS_AAA_address),
        (u'targetPDN-GW-Address', _EPS_DSMIP_SpecificParameters_targetPDN_GW_Address),
        ])
    EPS_DSMIP_SpecificParameters._ext = []
    
    #-----< EPS-MIP-SpecificParameters >-----#
    EPS_MIP_SpecificParameters = SEQ(name=u'EPS-MIP-SpecificParameters', mode=MODE_TYPE)
    _EPS_MIP_SpecificParameters_lifetime = INT(name=u'lifetime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_MIP_SpecificParameters_lifetime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _EPS_MIP_SpecificParameters_homeAddress = OCT_STR(name=u'homeAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_MIP_SpecificParameters_homeAddress._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _EPS_MIP_SpecificParameters_careOfAddress = OCT_STR(name=u'careOfAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_MIP_SpecificParameters_careOfAddress._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _EPS_MIP_SpecificParameters_homeAgentAddress = OCT_STR(name=u'homeAgentAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_MIP_SpecificParameters_homeAgentAddress._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _EPS_MIP_SpecificParameters_code = INT(name=u'code', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_MIP_SpecificParameters_code._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _EPS_MIP_SpecificParameters_foreignDomainAddress = OCT_STR(name=u'foreignDomainAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_MIP_SpecificParameters_foreignDomainAddress._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    EPS_MIP_SpecificParameters._cont = ASN1Dict([
        (u'lifetime', _EPS_MIP_SpecificParameters_lifetime),
        (u'homeAddress', _EPS_MIP_SpecificParameters_homeAddress),
        (u'careOfAddress', _EPS_MIP_SpecificParameters_careOfAddress),
        (u'homeAgentAddress', _EPS_MIP_SpecificParameters_homeAgentAddress),
        (u'code', _EPS_MIP_SpecificParameters_code),
        (u'foreignDomainAddress', _EPS_MIP_SpecificParameters_foreignDomainAddress),
        ])
    EPS_MIP_SpecificParameters._ext = []
    
    #-----< MediaDecryption-info >-----#
    MediaDecryption_info = SEQ_OF(name=u'MediaDecryption-info', mode=MODE_TYPE)
    _MediaDecryption_info__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EpsHI2Operations', 'CCKeyInfo')))
    MediaDecryption_info._cont = _MediaDecryption_info__item_
    
    #-----< CCKeyInfo >-----#
    CCKeyInfo = SEQ(name=u'CCKeyInfo', mode=MODE_TYPE)
    _CCKeyInfo_cCCSID = OCT_STR(name=u'cCCSID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CCKeyInfo_cCDecKey = OCT_STR(name=u'cCDecKey', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CCKeyInfo_cCSalt = OCT_STR(name=u'cCSalt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    CCKeyInfo._cont = ASN1Dict([
        (u'cCCSID', _CCKeyInfo_cCCSID),
        (u'cCDecKey', _CCKeyInfo_cCDecKey),
        (u'cCSalt', _CCKeyInfo_cCSalt),
        ])
    CCKeyInfo._ext = []
    
    #-----< MediaSecFailureIndication >-----#
    MediaSecFailureIndication = ENUM(name=u'MediaSecFailureIndication', mode=MODE_TYPE)
    MediaSecFailureIndication._cont = ASN1Dict([(u'genericFailure', 0)])
    MediaSecFailureIndication._ext = []
    
    #-----< PacketDataHeaderInformation >-----#
    PacketDataHeaderInformation = CHOICE(name=u'PacketDataHeaderInformation', mode=MODE_TYPE)
    _PacketDataHeaderInformation_packetDataHeader = CHOICE(name=u'packetDataHeader', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PacketDataHeaderReport')))
    _PacketDataHeaderInformation_packetDataSummary = SEQ_OF(name=u'packetDataSummary', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PacketDataSummaryReport')))
    PacketDataHeaderInformation._cont = ASN1Dict([
        (u'packetDataHeader', _PacketDataHeaderInformation_packetDataHeader),
        (u'packetDataSummary', _PacketDataHeaderInformation_packetDataSummary),
        ])
    PacketDataHeaderInformation._ext = []
    
    #-----< PacketDataHeaderReport >-----#
    PacketDataHeaderReport = CHOICE(name=u'PacketDataHeaderReport', mode=MODE_TYPE)
    _PacketDataHeaderReport_packetDataHeaderMapped = SEQ(name=u'packetDataHeaderMapped', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PacketDataHeaderMapped')))
    _PacketDataHeaderReport_packetDataHeaderCopy = SEQ(name=u'packetDataHeaderCopy', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PacketDataHeaderCopy')))
    PacketDataHeaderReport._cont = ASN1Dict([
        (u'packetDataHeaderMapped', _PacketDataHeaderReport_packetDataHeaderMapped),
        (u'packetDataHeaderCopy', _PacketDataHeaderReport_packetDataHeaderCopy),
        ])
    PacketDataHeaderReport._ext = []
    
    #-----< PacketDataHeaderMapped >-----#
    PacketDataHeaderMapped = SEQ(name=u'PacketDataHeaderMapped', mode=MODE_TYPE)
    _PacketDataHeaderMapped_sourceIPAddress = SEQ(name=u'sourceIPAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IPAddress')))
    _PacketDataHeaderMapped_sourcePortNumber = INT(name=u'sourcePortNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PacketDataHeaderMapped_sourcePortNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PacketDataHeaderMapped_destinationIPAddress = SEQ(name=u'destinationIPAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IPAddress')))
    _PacketDataHeaderMapped_destinationPortNumber = INT(name=u'destinationPortNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PacketDataHeaderMapped_destinationPortNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PacketDataHeaderMapped_transportProtocol = INT(name=u'transportProtocol', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PacketDataHeaderMapped_packetsize = INT(name=u'packetsize', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PacketDataHeaderMapped_flowLabel = INT(name=u'flowLabel', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PacketDataHeaderMapped_packetCount = INT(name=u'packetCount', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PacketDataHeaderMapped_direction = ENUM(name=u'direction', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'TPDU-direction')))
    PacketDataHeaderMapped._cont = ASN1Dict([
        (u'sourceIPAddress', _PacketDataHeaderMapped_sourceIPAddress),
        (u'sourcePortNumber', _PacketDataHeaderMapped_sourcePortNumber),
        (u'destinationIPAddress', _PacketDataHeaderMapped_destinationIPAddress),
        (u'destinationPortNumber', _PacketDataHeaderMapped_destinationPortNumber),
        (u'transportProtocol', _PacketDataHeaderMapped_transportProtocol),
        (u'packetsize', _PacketDataHeaderMapped_packetsize),
        (u'flowLabel', _PacketDataHeaderMapped_flowLabel),
        (u'packetCount', _PacketDataHeaderMapped_packetCount),
        (u'direction', _PacketDataHeaderMapped_direction),
        ])
    PacketDataHeaderMapped._ext = []
    
    #-----< TPDU-direction >-----#
    TPDU_direction = ENUM(name=u'TPDU-direction', mode=MODE_TYPE)
    TPDU_direction._cont = ASN1Dict([(u'from-target', 1), (u'to-target', 2), (u'unknown', 3)])
    TPDU_direction._ext = None
    
    #-----< PacketDataHeaderCopy >-----#
    PacketDataHeaderCopy = SEQ(name=u'PacketDataHeaderCopy', mode=MODE_TYPE)
    _PacketDataHeaderCopy_direction = ENUM(name=u'direction', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'TPDU-direction')))
    _PacketDataHeaderCopy_headerCopy = OCT_STR(name=u'headerCopy', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    PacketDataHeaderCopy._cont = ASN1Dict([
        (u'direction', _PacketDataHeaderCopy_direction),
        (u'headerCopy', _PacketDataHeaderCopy_headerCopy),
        ])
    PacketDataHeaderCopy._ext = []
    
    #-----< PacketDataSummaryReport >-----#
    PacketDataSummaryReport = SEQ_OF(name=u'PacketDataSummaryReport', mode=MODE_TYPE)
    _PacketDataSummaryReport__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EpsHI2Operations', 'PacketFlowSummary')))
    PacketDataSummaryReport._cont = _PacketDataSummaryReport__item_
    
    #-----< PacketFlowSummary >-----#
    PacketFlowSummary = SEQ(name=u'PacketFlowSummary', mode=MODE_TYPE)
    _PacketFlowSummary_sourceIPAddress = SEQ(name=u'sourceIPAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IPAddress')))
    _PacketFlowSummary_sourcePortNumber = INT(name=u'sourcePortNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PacketFlowSummary_sourcePortNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PacketFlowSummary_destinationIPAddress = SEQ(name=u'destinationIPAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IPAddress')))
    _PacketFlowSummary_destinationPortNumber = INT(name=u'destinationPortNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PacketFlowSummary_destinationPortNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PacketFlowSummary_transportProtocol = INT(name=u'transportProtocol', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PacketFlowSummary_flowLabel = INT(name=u'flowLabel', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PacketFlowSummary_summaryPeriod = SEQ(name=u'summaryPeriod', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'ReportInterval')))
    _PacketFlowSummary_packetCount = INT(name=u'packetCount', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PacketFlowSummary_sumOfPacketSizes = INT(name=u'sumOfPacketSizes', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PacketFlowSummary_packetDataSummaryReason = ENUM(name=u'packetDataSummaryReason', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'ReportReason')))
    PacketFlowSummary._cont = ASN1Dict([
        (u'sourceIPAddress', _PacketFlowSummary_sourceIPAddress),
        (u'sourcePortNumber', _PacketFlowSummary_sourcePortNumber),
        (u'destinationIPAddress', _PacketFlowSummary_destinationIPAddress),
        (u'destinationPortNumber', _PacketFlowSummary_destinationPortNumber),
        (u'transportProtocol', _PacketFlowSummary_transportProtocol),
        (u'flowLabel', _PacketFlowSummary_flowLabel),
        (u'summaryPeriod', _PacketFlowSummary_summaryPeriod),
        (u'packetCount', _PacketFlowSummary_packetCount),
        (u'sumOfPacketSizes', _PacketFlowSummary_sumOfPacketSizes),
        (u'packetDataSummaryReason', _PacketFlowSummary_packetDataSummaryReason),
        ])
    PacketFlowSummary._ext = []
    
    #-----< ReportReason >-----#
    ReportReason = ENUM(name=u'ReportReason', mode=MODE_TYPE)
    ReportReason._cont = ASN1Dict([(u'timerExpired', 0), (u'countThresholdHit', 1), (u'pDPComtextDeactivated', 2), (u'pDPContextModification', 3), (u'otherOrUnknown', 4)])
    ReportReason._ext = []
    
    #-----< ReportInterval >-----#
    ReportInterval = SEQ(name=u'ReportInterval', mode=MODE_TYPE)
    _ReportInterval_firstPacketTimeStamp = CHOICE(name=u'firstPacketTimeStamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    _ReportInterval_lastPacketTimeStamp = CHOICE(name=u'lastPacketTimeStamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    ReportInterval._cont = ASN1Dict([
        (u'firstPacketTimeStamp', _ReportInterval_firstPacketTimeStamp),
        (u'lastPacketTimeStamp', _ReportInterval_lastPacketTimeStamp),
        ])
    ReportInterval._ext = []
    
    #-----< TunnelProtocol >-----#
    TunnelProtocol = CHOICE(name=u'TunnelProtocol', mode=MODE_TYPE)
    _TunnelProtocol_rfc2868ValueField = OCT_STR(name=u'rfc2868ValueField', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TunnelProtocol_nativeIPSec = NULL(name=u'nativeIPSec', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    TunnelProtocol._cont = ASN1Dict([
        (u'rfc2868ValueField', _TunnelProtocol_rfc2868ValueField),
        (u'nativeIPSec', _TunnelProtocol_nativeIPSec),
        ])
    TunnelProtocol._ext = []
    
    #-----< HeNBLocation >-----#
    HeNBLocation = SEQ(name=u'HeNBLocation', mode=MODE_TYPE, typeref=ASN1RefType(('EpsHI2Operations', 'EPSLocation')))
    
    #-----< Requesting-Node-Type >-----#
    Requesting_Node_Type = ENUM(name=u'Requesting-Node-Type', mode=MODE_TYPE)
    Requesting_Node_Type._cont = ASN1Dict([(u'mSC', 1), (u'sMS-Centre', 2), (u'gMLC', 3), (u'mME', 4), (u'sGSN', 5)])
    Requesting_Node_Type._ext = []
    
    #-----< Change-Of-Target-Identity >-----#
    Change_Of_Target_Identity = SEQ(name=u'Change-Of-Target-Identity', mode=MODE_TYPE)
    _Change_Of_Target_Identity_new_MSISDN = SEQ(name=u'new-MSISDN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_new_A_MSISDN = SEQ(name=u'new-A-MSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_old_MSISDN = SEQ(name=u'old-MSISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_old_A_MSISDN = SEQ(name=u'old-A-MSISDN', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_new_IMSI = SEQ(name=u'new-IMSI', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_old_IMSI = SEQ(name=u'old-IMSI', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_new_IMEI = SEQ(name=u'new-IMEI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_old_IMEI = SEQ(name=u'old-IMEI', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_new_IMPI = SEQ(name=u'new-IMPI', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_old_IMPI = SEQ(name=u'old-IMPI', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_new_SIP_URI = SEQ(name=u'new-SIP-URI', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_old_SIP_URI = SEQ(name=u'old-SIP-URI', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_new_TEL_URI = SEQ(name=u'new-TEL-URI', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_old_TEL_URI = SEQ(name=u'old-TEL-URI', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PartyInformation')), opt=True)
    Change_Of_Target_Identity._cont = ASN1Dict([
        (u'new-MSISDN', _Change_Of_Target_Identity_new_MSISDN),
        (u'new-A-MSISDN', _Change_Of_Target_Identity_new_A_MSISDN),
        (u'old-MSISDN', _Change_Of_Target_Identity_old_MSISDN),
        (u'old-A-MSISDN', _Change_Of_Target_Identity_old_A_MSISDN),
        (u'new-IMSI', _Change_Of_Target_Identity_new_IMSI),
        (u'old-IMSI', _Change_Of_Target_Identity_old_IMSI),
        (u'new-IMEI', _Change_Of_Target_Identity_new_IMEI),
        (u'old-IMEI', _Change_Of_Target_Identity_old_IMEI),
        (u'new-IMPI', _Change_Of_Target_Identity_new_IMPI),
        (u'old-IMPI', _Change_Of_Target_Identity_old_IMPI),
        (u'new-SIP-URI', _Change_Of_Target_Identity_new_SIP_URI),
        (u'old-SIP-URI', _Change_Of_Target_Identity_old_SIP_URI),
        (u'new-TEL-URI', _Change_Of_Target_Identity_new_TEL_URI),
        (u'old-TEL-URI', _Change_Of_Target_Identity_old_TEL_URI),
        ])
    Change_Of_Target_Identity._ext = [u'new-IMPI', u'old-IMPI', u'new-SIP-URI', u'old-SIP-URI', u'new-TEL-URI', u'old-TEL-URI']
    
    #-----< Current-Previous-Systems >-----#
    Current_Previous_Systems = SEQ(name=u'Current-Previous-Systems', mode=MODE_TYPE)
    _Current_Previous_Systems_serving_System_Identifier = OCT_STR(name=u'serving-System-Identifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Current_Previous_Systems_current_Serving_MME_Address = SEQ(name=u'current-Serving-MME-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'DataNodeIdentifier')), opt=True)
    _Current_Previous_Systems_previous_Serving_System_Identifier = OCT_STR(name=u'previous-Serving-System-Identifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Current_Previous_Systems_previous_Serving_MME_Address = SEQ(name=u'previous-Serving-MME-Address', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'DataNodeIdentifier')), opt=True)
    Current_Previous_Systems._cont = ASN1Dict([
        (u'serving-System-Identifier', _Current_Previous_Systems_serving_System_Identifier),
        (u'current-Serving-MME-Address', _Current_Previous_Systems_current_Serving_MME_Address),
        (u'previous-Serving-System-Identifier', _Current_Previous_Systems_previous_Serving_System_Identifier),
        (u'previous-Serving-MME-Address', _Current_Previous_Systems_previous_Serving_MME_Address),
        ])
    Current_Previous_Systems._ext = []
    
    #-----< ProSeTargetType >-----#
    ProSeTargetType = ENUM(name=u'ProSeTargetType', mode=MODE_TYPE)
    ProSeTargetType._cont = ASN1Dict([(u'pRoSeRemoteUE', 1), (u'pRoSeUEtoNwRelay', 2)])
    ProSeTargetType._ext = []
    
    #-----< VoIPRoamingIndication >-----#
    VoIPRoamingIndication = ENUM(name=u'VoIPRoamingIndication', mode=MODE_TYPE)
    VoIPRoamingIndication._cont = ASN1Dict([(u'roamingLBO', 1), (u'roamingS8HR', 2)])
    VoIPRoamingIndication._ext = []
    
    #-----< DeregistrationReason >-----#
    DeregistrationReason = CHOICE(name=u'DeregistrationReason', mode=MODE_TYPE)
    _DeregistrationReason_reason_CodeAVP = INT(name=u'reason-CodeAVP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DeregistrationReason_server_AssignmentType = INT(name=u'server-AssignmentType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    DeregistrationReason._cont = ASN1Dict([
        (u'reason-CodeAVP', _DeregistrationReason_reason_CodeAVP),
        (u'server-AssignmentType', _DeregistrationReason_server_AssignmentType),
        ])
    DeregistrationReason._ext = []
    
    #-----< PTCEncryptionInfo >-----#
    PTCEncryptionInfo = SEQ(name=u'PTCEncryptionInfo', mode=MODE_TYPE)
    _PTCEncryptionInfo_cipher = STR_UTF8(name=u'cipher', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PTCEncryptionInfo_cryptoContext = STR_UTF8(name=u'cryptoContext', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTCEncryptionInfo_key = STR_UTF8(name=u'key', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PTCEncryptionInfo_keyEncoding = STR_UTF8(name=u'keyEncoding', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PTCEncryptionInfo_salt = STR_UTF8(name=u'salt', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTCEncryptionInfo_pTCOther = STR_UTF8(name=u'pTCOther', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    PTCEncryptionInfo._cont = ASN1Dict([
        (u'cipher', _PTCEncryptionInfo_cipher),
        (u'cryptoContext', _PTCEncryptionInfo_cryptoContext),
        (u'key', _PTCEncryptionInfo_key),
        (u'keyEncoding', _PTCEncryptionInfo_keyEncoding),
        (u'salt', _PTCEncryptionInfo_salt),
        (u'pTCOther', _PTCEncryptionInfo_pTCOther),
        ])
    PTCEncryptionInfo._ext = []
    
    #-----< PTC >-----#
    PTC = SEQ(name=u'PTC', mode=MODE_TYPE)
    _PTC_abandonCause = STR_UTF8(name=u'abandonCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_accessPolicyFailure = STR_UTF8(name=u'accessPolicyFailure', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_accessPolicyType = SEQ(name=u'accessPolicyType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'AccessPolicyType')), opt=True)
    _PTC_alertIndicator = ENUM(name=u'alertIndicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'AlertIndicator')), opt=True)
    _PTC_associatePresenceStatus = SEQ(name=u'associatePresenceStatus', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'AssociatePresenceStatus')), opt=True)
    _PTC_bearer_capability = STR_UTF8(name=u'bearer-capability', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_broadcastIndicator = BOOL(name=u'broadcastIndicator', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_contactID = STR_UTF8(name=u'contactID', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_emergency = ENUM(name=u'emergency', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'Emergency')), opt=True)
    _PTC_emergencyGroupState = SEQ(name=u'emergencyGroupState', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'EmergencyGroupState')), opt=True)
    _PTC_timeStamp = CHOICE(name=u'timeStamp', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    _PTC_pTCType = ENUM(name=u'pTCType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PTCType')), opt=True)
    _PTC_failureCode = STR_UTF8(name=u'failureCode', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_floorActivity = SEQ(name=u'floorActivity', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'FloorActivity')), opt=True)
    _PTC_floorSpeakerID = SEQ(name=u'floorSpeakerID', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PTCAddress')), opt=True)
    _PTC_groupAdSender = STR_UTF8(name=u'groupAdSender', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_groupAuthRule = ENUM(name=u'groupAuthRule', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'GroupAuthRule')), opt=True)
    _PTC_groupCharacteristics = STR_UTF8(name=u'groupCharacteristics', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_holdRetrieveInd = BOOL(name=u'holdRetrieveInd', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_imminentPerilInd = ENUM(name=u'imminentPerilInd', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'ImminentPerilInd')), opt=True)
    _PTC_implicitFloorReq = ENUM(name=u'implicitFloorReq', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'ImplicitFloorReq')), opt=True)
    _PTC_initiationCause = ENUM(name=u'initiationCause', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'InitiationCause')), opt=True)
    _PTC_invitationCause = STR_UTF8(name=u'invitationCause', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_iPAPartyID = STR_UTF8(name=u'iPAPartyID', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_iPADirection = ENUM(name=u'iPADirection', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'IPADirection')), opt=True)
    _PTC_listManagementAction = ENUM(name=u'listManagementAction', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'ListManagementAction')), opt=True)
    _PTC_listManagementFailure = STR_UTF8(name=u'listManagementFailure', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_listManagementType = ENUM(name=u'listManagementType', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'ListManagementType')), opt=True)
    _PTC_maxTBTime = STR_UTF8(name=u'maxTBTime', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_mCPTTGroupID = STR_UTF8(name=u'mCPTTGroupID', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_mCPTTID = STR_UTF8(name=u'mCPTTID', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_mCPTTInd = BOOL(name=u'mCPTTInd', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_location = SEQ(name=u'location', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'Location')), opt=True)
    _PTC_mCPTTOrganizationName = STR_UTF8(name=u'mCPTTOrganizationName', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_mediaStreamAvail = BOOL(name=u'mediaStreamAvail', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_priority_Level = ENUM(name=u'priority-Level', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'Priority-Level')), opt=True)
    _PTC_preEstSessionID = STR_UTF8(name=u'preEstSessionID', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_preEstStatus = ENUM(name=u'preEstStatus', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PreEstStatus')), opt=True)
    _PTC_pTCGroupID = STR_UTF8(name=u'pTCGroupID', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_pTCIDList = STR_UTF8(name=u'pTCIDList', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_pTCMediaCapability = STR_UTF8(name=u'pTCMediaCapability', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_pTCOriginatingId = STR_UTF8(name=u'pTCOriginatingId', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_pTCOther = STR_UTF8(name=u'pTCOther', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_pTCParticipants = STR_UTF8(name=u'pTCParticipants', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_pTCParty = STR_UTF8(name=u'pTCParty', mode=MODE_TYPE, tag=(49, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_pTCPartyDrop = STR_UTF8(name=u'pTCPartyDrop', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_pTCSessionInfo = STR_UTF8(name=u'pTCSessionInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_pTCServerURI = STR_UTF8(name=u'pTCServerURI', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_pTCUserAccessPolicy = STR_UTF8(name=u'pTCUserAccessPolicy', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_pTCAddress = SEQ(name=u'pTCAddress', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PTCAddress')), opt=True)
    _PTC_queuedFloorControl = BOOL(name=u'queuedFloorControl', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_queuedPosition = STR_UTF8(name=u'queuedPosition', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_registrationRequest = ENUM(name=u'registrationRequest', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'RegistrationRequest')), opt=True)
    _PTC_registrationOutcome = ENUM(name=u'registrationOutcome', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'RegistrationOutcome')), opt=True)
    _PTC_retrieveID = STR_UTF8(name=u'retrieveID', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_rTPSetting = SEQ(name=u'rTPSetting', mode=MODE_TYPE, tag=(60, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'RTPSetting')), opt=True)
    _PTC_talkBurstPriority = ENUM(name=u'talkBurstPriority', mode=MODE_TYPE, tag=(61, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'Priority-Level')), opt=True)
    _PTC_talkBurstReason = STR_VIS(name=u'talkBurstReason', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'Talk-burst-reason-code')), opt=True)
    _PTC_talkburstControlSetting = SEQ(name=u'talkburstControlSetting', mode=MODE_TYPE, tag=(63, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'TalkburstControlSetting')), opt=True)
    _PTC_targetPresenceStatus = STR_UTF8(name=u'targetPresenceStatus', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_port_Number = INT(name=u'port-Number', mode=MODE_TYPE, tag=(65, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_port_Number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PTC._cont = ASN1Dict([
        (u'abandonCause', _PTC_abandonCause),
        (u'accessPolicyFailure', _PTC_accessPolicyFailure),
        (u'accessPolicyType', _PTC_accessPolicyType),
        (u'alertIndicator', _PTC_alertIndicator),
        (u'associatePresenceStatus', _PTC_associatePresenceStatus),
        (u'bearer-capability', _PTC_bearer_capability),
        (u'broadcastIndicator', _PTC_broadcastIndicator),
        (u'contactID', _PTC_contactID),
        (u'emergency', _PTC_emergency),
        (u'emergencyGroupState', _PTC_emergencyGroupState),
        (u'timeStamp', _PTC_timeStamp),
        (u'pTCType', _PTC_pTCType),
        (u'failureCode', _PTC_failureCode),
        (u'floorActivity', _PTC_floorActivity),
        (u'floorSpeakerID', _PTC_floorSpeakerID),
        (u'groupAdSender', _PTC_groupAdSender),
        (u'groupAuthRule', _PTC_groupAuthRule),
        (u'groupCharacteristics', _PTC_groupCharacteristics),
        (u'holdRetrieveInd', _PTC_holdRetrieveInd),
        (u'imminentPerilInd', _PTC_imminentPerilInd),
        (u'implicitFloorReq', _PTC_implicitFloorReq),
        (u'initiationCause', _PTC_initiationCause),
        (u'invitationCause', _PTC_invitationCause),
        (u'iPAPartyID', _PTC_iPAPartyID),
        (u'iPADirection', _PTC_iPADirection),
        (u'listManagementAction', _PTC_listManagementAction),
        (u'listManagementFailure', _PTC_listManagementFailure),
        (u'listManagementType', _PTC_listManagementType),
        (u'maxTBTime', _PTC_maxTBTime),
        (u'mCPTTGroupID', _PTC_mCPTTGroupID),
        (u'mCPTTID', _PTC_mCPTTID),
        (u'mCPTTInd', _PTC_mCPTTInd),
        (u'location', _PTC_location),
        (u'mCPTTOrganizationName', _PTC_mCPTTOrganizationName),
        (u'mediaStreamAvail', _PTC_mediaStreamAvail),
        (u'priority-Level', _PTC_priority_Level),
        (u'preEstSessionID', _PTC_preEstSessionID),
        (u'preEstStatus', _PTC_preEstStatus),
        (u'pTCGroupID', _PTC_pTCGroupID),
        (u'pTCIDList', _PTC_pTCIDList),
        (u'pTCMediaCapability', _PTC_pTCMediaCapability),
        (u'pTCOriginatingId', _PTC_pTCOriginatingId),
        (u'pTCOther', _PTC_pTCOther),
        (u'pTCParticipants', _PTC_pTCParticipants),
        (u'pTCParty', _PTC_pTCParty),
        (u'pTCPartyDrop', _PTC_pTCPartyDrop),
        (u'pTCSessionInfo', _PTC_pTCSessionInfo),
        (u'pTCServerURI', _PTC_pTCServerURI),
        (u'pTCUserAccessPolicy', _PTC_pTCUserAccessPolicy),
        (u'pTCAddress', _PTC_pTCAddress),
        (u'queuedFloorControl', _PTC_queuedFloorControl),
        (u'queuedPosition', _PTC_queuedPosition),
        (u'registrationRequest', _PTC_registrationRequest),
        (u'registrationOutcome', _PTC_registrationOutcome),
        (u'retrieveID', _PTC_retrieveID),
        (u'rTPSetting', _PTC_rTPSetting),
        (u'talkBurstPriority', _PTC_talkBurstPriority),
        (u'talkBurstReason', _PTC_talkBurstReason),
        (u'talkburstControlSetting', _PTC_talkburstControlSetting),
        (u'targetPresenceStatus', _PTC_targetPresenceStatus),
        (u'port-Number', _PTC_port_Number),
        ])
    PTC._ext = []
    
    #-----< AccessPolicyType >-----#
    AccessPolicyType = SEQ(name=u'AccessPolicyType', mode=MODE_TYPE)
    _AccessPolicyType_userAccessPolicyAttempt = BOOL(name=u'userAccessPolicyAttempt', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPolicyType_groupAuthorizationRulesAttempt = BOOL(name=u'groupAuthorizationRulesAttempt', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPolicyType_userAccessPolicyQuery = BOOL(name=u'userAccessPolicyQuery', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPolicyType_groupAuthorizationRulesQuery = BOOL(name=u'groupAuthorizationRulesQuery', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPolicyType_userAccessPolicyResult = STR_UTF8(name=u'userAccessPolicyResult', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPolicyType_groupAuthorizationRulesResult = STR_UTF8(name=u'groupAuthorizationRulesResult', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    AccessPolicyType._cont = ASN1Dict([
        (u'userAccessPolicyAttempt', _AccessPolicyType_userAccessPolicyAttempt),
        (u'groupAuthorizationRulesAttempt', _AccessPolicyType_groupAuthorizationRulesAttempt),
        (u'userAccessPolicyQuery', _AccessPolicyType_userAccessPolicyQuery),
        (u'groupAuthorizationRulesQuery', _AccessPolicyType_groupAuthorizationRulesQuery),
        (u'userAccessPolicyResult', _AccessPolicyType_userAccessPolicyResult),
        (u'groupAuthorizationRulesResult', _AccessPolicyType_groupAuthorizationRulesResult),
        ])
    AccessPolicyType._ext = []
    
    #-----< AlertIndicator >-----#
    AlertIndicator = ENUM(name=u'AlertIndicator', mode=MODE_TYPE)
    AlertIndicator._cont = ASN1Dict([(u'sent', 1), (u'received', 2), (u'cancelled', 3)])
    AlertIndicator._ext = []
    
    #-----< AssociatePresenceStatus >-----#
    AssociatePresenceStatus = SEQ(name=u'AssociatePresenceStatus', mode=MODE_TYPE)
    _AssociatePresenceStatus_presenceID = STR_UTF8(name=u'presenceID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AssociatePresenceStatus_presenceType = ENUM(name=u'presenceType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'PresenceType')))
    _AssociatePresenceStatus_presenceStatus = BOOL(name=u'presenceStatus', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    AssociatePresenceStatus._cont = ASN1Dict([
        (u'presenceID', _AssociatePresenceStatus_presenceID),
        (u'presenceType', _AssociatePresenceStatus_presenceType),
        (u'presenceStatus', _AssociatePresenceStatus_presenceStatus),
        ])
    AssociatePresenceStatus._ext = []
    
    #-----< PresenceType >-----#
    PresenceType = ENUM(name=u'PresenceType', mode=MODE_TYPE)
    PresenceType._cont = ASN1Dict([(u'pTCClient', 1), (u'pTCGroup', 2)])
    PresenceType._ext = []
    
    #-----< Emergency >-----#
    Emergency = ENUM(name=u'Emergency', mode=MODE_TYPE)
    Emergency._cont = ASN1Dict([(u'imminent', 1), (u'peril', 2), (u'cancel', 3)])
    Emergency._ext = []
    
    #-----< EmergencyGroupState >-----#
    EmergencyGroupState = SEQ(name=u'EmergencyGroupState', mode=MODE_TYPE)
    _EmergencyGroupState_clientEmergencyState = ENUM(name=u'clientEmergencyState', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EmergencyGroupState_clientEmergencyState._cont = ASN1Dict([(u'inform', 1), (u'response', 2), (u'cancelInform', 3), (u'cancelResponse', 4)])
    _EmergencyGroupState_clientEmergencyState._ext = []
    _EmergencyGroupState_groupEmergencyState = ENUM(name=u'groupEmergencyState', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EmergencyGroupState_groupEmergencyState._cont = ASN1Dict([(u'inForm', 1), (u'reSponse', 2), (u'cancelInform', 3), (u'cancelResponse', 4)])
    _EmergencyGroupState_groupEmergencyState._ext = []
    EmergencyGroupState._cont = ASN1Dict([
        (u'clientEmergencyState', _EmergencyGroupState_clientEmergencyState),
        (u'groupEmergencyState', _EmergencyGroupState_groupEmergencyState),
        ])
    EmergencyGroupState._ext = []
    
    #-----< PTCType >-----#
    PTCType = ENUM(name=u'PTCType', mode=MODE_TYPE)
    PTCType._cont = ASN1Dict([(u'pTCStartofInterception', 1), (u'pTCServinSystem', 2), (u'pTCSessionInitiation', 3), (u'pTCSessionAbandonEndRecord', 4), (u'pTCSessionStartContinueRecord', 5), (u'pTCSessionEndRecord', 6), (u'pTCPre-EstablishedSessionSessionRecord', 7), (u'pTCInstantPersonalAlert', 8), (u'pTCPartyJoin', 9), (u'pTCPartyDrop', 10), (u'pTCPartyHold-RetrieveRecord', 11), (u'pTCMediaModification', 12), (u'pTCGroupAdvertizement', 13), (u'pTCFloorConttrol', 14), (u'pTCTargetPressence', 15), (u'pTCAssociatePressence', 16), (u'pTCListManagementEvents', 17), (u'pTCAccessPolicyEvents', 18), (u'pTCMediaTypeNotification', 19), (u'pTCGroupCallRequest', 20), (u'pTCGroupCallCancel', 21), (u'pTCGroupCallResponse', 22), (u'pTCGroupCallInterrogate', 23), (u'pTCMCPTTImminentGroupCall', 24), (u'pTCCC', 25), (u'pTCRegistration', 26), (u'pTCEncryption', 27)])
    PTCType._ext = []
    
    #-----< FloorActivity >-----#
    FloorActivity = SEQ(name=u'FloorActivity', mode=MODE_TYPE)
    _FloorActivity_tBCP_Request = BOOL(name=u'tBCP-Request', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _FloorActivity_tBCP_Granted = BOOL(name=u'tBCP-Granted', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _FloorActivity_tBCP_Deny = BOOL(name=u'tBCP-Deny', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _FloorActivity_tBCP_Queued = BOOL(name=u'tBCP-Queued', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _FloorActivity_tBCP_Release = BOOL(name=u'tBCP-Release', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _FloorActivity_tBCP_Revoke = BOOL(name=u'tBCP-Revoke', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _FloorActivity_tBCP_Taken = BOOL(name=u'tBCP-Taken', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _FloorActivity_tBCP_Idle = BOOL(name=u'tBCP-Idle', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    FloorActivity._cont = ASN1Dict([
        (u'tBCP-Request', _FloorActivity_tBCP_Request),
        (u'tBCP-Granted', _FloorActivity_tBCP_Granted),
        (u'tBCP-Deny', _FloorActivity_tBCP_Deny),
        (u'tBCP-Queued', _FloorActivity_tBCP_Queued),
        (u'tBCP-Release', _FloorActivity_tBCP_Release),
        (u'tBCP-Revoke', _FloorActivity_tBCP_Revoke),
        (u'tBCP-Taken', _FloorActivity_tBCP_Taken),
        (u'tBCP-Idle', _FloorActivity_tBCP_Idle),
        ])
    FloorActivity._ext = []
    
    #-----< GroupAuthRule >-----#
    GroupAuthRule = ENUM(name=u'GroupAuthRule', mode=MODE_TYPE)
    GroupAuthRule._cont = ASN1Dict([(u'allow-Initiating-PtcSession', 0), (u'block-Initiating-PtcSession', 1), (u'allow-Joining-PtcSession', 2), (u'block-Joining-PtcSession', 3), (u'allow-Add-Participants', 4), (u'block-Add-Participants', 5), (u'allow-Subscription-PtcSession-State', 6), (u'block-Subscription-PtcSession-State', 7), (u'allow-Anonymity', 8), (u'forbid-Anonymity', 9)])
    GroupAuthRule._ext = []
    
    #-----< ImminentPerilInd >-----#
    ImminentPerilInd = ENUM(name=u'ImminentPerilInd', mode=MODE_TYPE)
    ImminentPerilInd._cont = ASN1Dict([(u'request', 1), (u'response', 2), (u'cancel', 3)])
    ImminentPerilInd._ext = []
    
    #-----< ImplicitFloorReq >-----#
    ImplicitFloorReq = ENUM(name=u'ImplicitFloorReq', mode=MODE_TYPE)
    ImplicitFloorReq._cont = ASN1Dict([(u'join', 1), (u'rejoin', 2), (u'release', 3)])
    ImplicitFloorReq._ext = []
    
    #-----< InitiationCause >-----#
    InitiationCause = ENUM(name=u'InitiationCause', mode=MODE_TYPE)
    InitiationCause._cont = ASN1Dict([(u'requests', 1), (u'received', 2), (u'pTCOriginatingId', 3)])
    InitiationCause._ext = []
    
    #-----< IPADirection >-----#
    IPADirection = ENUM(name=u'IPADirection', mode=MODE_TYPE)
    IPADirection._cont = ASN1Dict([(u'toTarget', 0), (u'fromTarget', 1)])
    IPADirection._ext = []
    
    #-----< ListManagementAction >-----#
    ListManagementAction = ENUM(name=u'ListManagementAction', mode=MODE_TYPE)
    ListManagementAction._cont = ASN1Dict([(u'create', 1), (u'modify', 2), (u'retrieve', 3), (u'delete', 4), (u'notify', 5)])
    ListManagementAction._ext = []
    
    #-----< ListManagementType >-----#
    ListManagementType = ENUM(name=u'ListManagementType', mode=MODE_TYPE)
    ListManagementType._cont = ASN1Dict([(u'contactListManagementAttempt', 1), (u'groupListManagementAttempt', 2), (u'contactListManagementResult', 3), (u'groupListManagementResult', 4), (u'requestSuccessful', 5)])
    ListManagementType._ext = []
    
    #-----< Priority-Level >-----#
    Priority_Level = ENUM(name=u'Priority-Level', mode=MODE_TYPE)
    Priority_Level._cont = ASN1Dict([(u'pre-emptive', 0), (u'high-priority', 1), (u'normal-priority', 2), (u'listen-only', 3)])
    Priority_Level._ext = []
    
    #-----< PreEstStatus >-----#
    PreEstStatus = ENUM(name=u'PreEstStatus', mode=MODE_TYPE)
    PreEstStatus._cont = ASN1Dict([(u'established', 1), (u'modify', 2), (u'released', 3)])
    PreEstStatus._ext = []
    
    #-----< PTCAddress >-----#
    PTCAddress = SEQ(name=u'PTCAddress', mode=MODE_TYPE)
    _PTCAddress_uri = STR_UTF8(name=u'uri', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PTCAddress_privacy_setting = BOOL(name=u'privacy-setting', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PTCAddress_privacy_alias = STR_VIS(name=u'privacy-alias', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTCAddress_nickname = STR_UTF8(name=u'nickname', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    PTCAddress._cont = ASN1Dict([
        (u'uri', _PTCAddress_uri),
        (u'privacy-setting', _PTCAddress_privacy_setting),
        (u'privacy-alias', _PTCAddress_privacy_alias),
        (u'nickname', _PTCAddress_nickname),
        ])
    PTCAddress._ext = []
    
    #-----< RegistrationRequest >-----#
    RegistrationRequest = ENUM(name=u'RegistrationRequest', mode=MODE_TYPE)
    RegistrationRequest._cont = ASN1Dict([(u'register', 1), (u're-register', 2), (u'de-register', 3)])
    RegistrationRequest._ext = []
    
    #-----< RegistrationOutcome >-----#
    RegistrationOutcome = ENUM(name=u'RegistrationOutcome', mode=MODE_TYPE)
    RegistrationOutcome._cont = ASN1Dict([(u'success', 0), (u'failure', 1)])
    RegistrationOutcome._ext = []
    
    #-----< RTPSetting >-----#
    RTPSetting = SEQ(name=u'RTPSetting', mode=MODE_TYPE)
    _RTPSetting_ip_address = SEQ(name=u'ip-address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IPAddress')))
    _RTPSetting_port_number = INT(name=u'port-number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'Port-Number')))
    RTPSetting._cont = ASN1Dict([
        (u'ip-address', _RTPSetting_ip_address),
        (u'port-number', _RTPSetting_port_number),
        ])
    RTPSetting._ext = []
    
    #-----< Port-Number >-----#
    Port_Number = INT(name=u'Port-Number', mode=MODE_TYPE)
    Port_Number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TalkburstControlSetting >-----#
    TalkburstControlSetting = SEQ(name=u'TalkburstControlSetting', mode=MODE_TYPE)
    _TalkburstControlSetting_talk_BurstControlProtocol = STR_UTF8(name=u'talk-BurstControlProtocol', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TalkburstControlSetting_talk_Burst_parameters = SET_OF(name=u'talk-Burst-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TalkburstControlSetting_talk_Burst_parameters__item_ = STR_VIS(name='_item_', mode=MODE_TYPE)
    _TalkburstControlSetting_talk_Burst_parameters._cont = __TalkburstControlSetting_talk_Burst_parameters__item_
    _TalkburstControlSetting_tBCP_PortNumber = INT(name=u'tBCP-PortNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TalkburstControlSetting_tBCP_PortNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TalkburstControlSetting._cont = ASN1Dict([
        (u'talk-BurstControlProtocol', _TalkburstControlSetting_talk_BurstControlProtocol),
        (u'talk-Burst-parameters', _TalkburstControlSetting_talk_Burst_parameters),
        (u'tBCP-PortNumber', _TalkburstControlSetting_tBCP_PortNumber),
        ])
    TalkburstControlSetting._ext = []
    
    #-----< Talk-burst-reason-code >-----#
    Talk_burst_reason_code = STR_VIS(name=u'Talk-burst-reason-code', mode=MODE_TYPE)
    
    _all_ = [
        lawfulInterceptDomainId,
        threeGPPSUBDomainId,
        hi2epsDomainId,
        _EpsIRIsContent_epsiRIContent,
        _EpsIRIsContent_epsIRISequence,
        EpsIRIsContent,
        _EpsIRISequence__item_,
        EpsIRISequence,
        _EpsIRIContent_iRI_Begin_record,
        _EpsIRIContent_iRI_End_record,
        _EpsIRIContent_iRI_Continue_record,
        _EpsIRIContent_iRI_Report_record,
        EpsIRIContent,
        _IRI_Parameters_hi2epsDomainId,
        _IRI_Parameters_lawfulInterceptionIdentifier,
        _IRI_Parameters_timeStamp,
        _IRI_Parameters_initiator,
        _IRI_Parameters_locationOfTheTarget,
        __IRI_Parameters_partyInformation__item_,
        _IRI_Parameters_partyInformation,
        _IRI_Parameters_serviceCenterAddress,
        _IRI_Parameters_sMS,
        _IRI_Parameters_national_Parameters,
        _IRI_Parameters_ePSCorrelationNumber,
        _IRI_Parameters_ePSevent,
        _IRI_Parameters_sgsnAddress,
        _IRI_Parameters_gPRSOperationErrorCode,
        _IRI_Parameters_ggsnAddress,
        _IRI_Parameters_qOS,
        _IRI_Parameters_networkIdentifier,
        _IRI_Parameters_sMSOriginatingAddress,
        _IRI_Parameters_sMSTerminatingAddress,
        _IRI_Parameters_iMSevent,
        _IRI_Parameters_sIPMessage,
        _IRI_Parameters_servingSGSN_number,
        _IRI_Parameters_servingSGSN_address,
        _IRI_Parameters_ldiEvent,
        _IRI_Parameters_correlation,
        _IRI_Parameters_ePS_GTPV2_specificParameters,
        _IRI_Parameters_ePS_PMIP_specificParameters,
        _IRI_Parameters_ePS_DSMIP_SpecificParameters,
        _IRI_Parameters_ePS_MIP_SpecificParameters,
        _IRI_Parameters_servingNodeAddress,
        _IRI_Parameters_visitedNetworkId,
        _IRI_Parameters_mediaDecryption_info,
        _IRI_Parameters_servingS4_SGSN_address,
        _IRI_Parameters_sipMessageHeaderOffer,
        _IRI_Parameters_sipMessageHeaderAnswer,
        _IRI_Parameters_sdpOffer,
        _IRI_Parameters_sdpAnswer,
        _IRI_Parameters_uLITimestamp,
        _IRI_Parameters_packetDataHeaderInformation,
        _IRI_Parameters_mediaSecFailureIndication,
        _IRI_Parameters_csgIdentity,
        _IRI_Parameters_heNBIdentity,
        _IRI_Parameters_heNBiPAddress,
        _IRI_Parameters_heNBLocation,
        _IRI_Parameters_tunnelProtocol,
        __IRI_Parameters_pANI_Header_Info__item_,
        _IRI_Parameters_pANI_Header_Info,
        _IRI_Parameters_imsVoIP,
        _IRI_Parameters_xCAPmessage,
        _IRI_Parameters_logicalFunctionInformation,
        _IRI_Parameters_ccUnavailableReason,
        _IRI_Parameters_carrierSpecificData,
        _IRI_Parameters_current_previous_systems,
        _IRI_Parameters_change_Of_Target_Identity,
        _IRI_Parameters_requesting_Network_Identifier,
        _IRI_Parameters_requesting_Node_Type,
        _IRI_Parameters_serving_System_Identifier,
        _IRI_Parameters_proSeTargetType,
        _IRI_Parameters_proSeRelayMSISDN,
        _IRI_Parameters_proSeRelayIMSI,
        _IRI_Parameters_proSeRelayIMEI,
        _IRI_Parameters_extendedLocParameters,
        _IRI_Parameters_locationErrorCode,
        __IRI_Parameters_otherIdentities__item_,
        _IRI_Parameters_otherIdentities,
        _IRI_Parameters_deregistrationReason,
        _IRI_Parameters_requesting_Node_Identifier,
        _IRI_Parameters_roamingIndication,
        _IRI_Parameters_cSREvent,
        _IRI_Parameters_ptc,
        _IRI_Parameters_ptcEncryption,
        __IRI_Parameters_additionalCellIDs__item_,
        _IRI_Parameters_additionalCellIDs,
        _IRI_Parameters_scefID,
        _IRI_Parameters_national_HI2_ASN1parameters,
        IRI_Parameters,
        _DataNodeIdentifier_dataNodeAddress,
        _DataNodeIdentifier_logicalFunctionType,
        _DataNodeIdentifier_dataNodeName,
        DataNodeIdentifier,
        LogicalFunctionType,
        _PANI_Header_Info_access_Type,
        _PANI_Header_Info_access_Class,
        _PANI_Header_Info_network_Provided,
        _PANI_Header_Info_pANI_Location,
        PANI_Header_Info,
        _PANI_Location_raw_Location,
        _PANI_Location_location,
        _PANI_Location_ePSLocation,
        PANI_Location,
        _PartyInformation_party_Qualifier,
        __PartyInformation_partyIdentity_imei,
        __PartyInformation_partyIdentity_imsi,
        __PartyInformation_partyIdentity_msISDN,
        __PartyInformation_partyIdentity_e164_Format,
        __PartyInformation_partyIdentity_sip_uri,
        __PartyInformation_partyIdentity_tel_uri,
        __PartyInformation_partyIdentity_nai,
        __PartyInformation_partyIdentity_x_3GPP_Asserted_Identity,
        __PartyInformation_partyIdentity_xUI,
        __PartyInformation_partyIdentity_iMPI,
        __PartyInformation_partyIdentity_extID,
        _PartyInformation_partyIdentity,
        _PartyInformation_services_Data_Information,
        PartyInformation,
        _Location_e164_Number,
        _Location_globalCellID,
        _Location_rAI,
        _Location_gsmLocation,
        _Location_umtsLocation,
        _Location_sAI,
        _Location_oldRAI,
        _Location_civicAddress,
        _Location_operatorSpecificInfo,
        __Location_uELocationTimestamp_timestamp,
        __Location_uELocationTimestamp_timestampUnknown,
        _Location_uELocationTimestamp,
        Location,
        GlobalCellID,
        Rai,
        Sai,
        _AdditionalCellID_nCGI,
        _AdditionalCellID_gsmLocation,
        _AdditionalCellID_umtsLocation,
        _AdditionalCellID_timeOfLocation,
        AdditionalCellID,
        MCC,
        MNC,
        _PLMNID_mCC,
        _PLMNID_mNC,
        PLMNID,
        NRCellID,
        _NCGI_pLMNID,
        _NCGI_nRCellID,
        NCGI,
        __GSMLocation_geoCoordinates_latitude,
        __GSMLocation_geoCoordinates_longitude,
        __GSMLocation_geoCoordinates_mapDatum,
        __GSMLocation_geoCoordinates_azimuth,
        _GSMLocation_geoCoordinates,
        __GSMLocation_utmCoordinates_utm_East,
        __GSMLocation_utmCoordinates_utm_North,
        __GSMLocation_utmCoordinates_mapDatum,
        __GSMLocation_utmCoordinates_azimuth,
        _GSMLocation_utmCoordinates,
        __GSMLocation_utmRefCoordinates_utmref_string,
        __GSMLocation_utmRefCoordinates_mapDatum,
        _GSMLocation_utmRefCoordinates,
        _GSMLocation_wGS84Coordinates,
        GSMLocation,
        MapDatum,
        _UMTSLocation_point,
        _UMTSLocation_pointWithUnCertainty,
        _UMTSLocation_polygon,
        UMTSLocation,
        _GeographicalCoordinates_latitudeSign,
        _GeographicalCoordinates_latitude,
        _GeographicalCoordinates_longitude,
        GeographicalCoordinates,
        _GA_Point_geographicalCoordinates,
        GA_Point,
        _GA_PointWithUnCertainty_geographicalCoordinates,
        _GA_PointWithUnCertainty_uncertaintyCode,
        GA_PointWithUnCertainty,
        maxNrOfPoints,
        __GA_Polygon__item__geographicalCoordinates,
        _GA_Polygon__item_,
        GA_Polygon,
        __SMS_report_sMS_Contents_sms_initiator,
        __SMS_report_sMS_Contents_transfer_status,
        __SMS_report_sMS_Contents_other_message,
        __SMS_report_sMS_Contents_content,
        _SMS_report_sMS_Contents,
        SMS_report,
        EPSCorrelationNumber,
        _CorrelationValues_iri_to_CC,
        _CorrelationValues_iri_to_iri,
        __CorrelationValues_both_IRI_CC_iri_CC,
        __CorrelationValues_both_IRI_CC_iri_IRI,
        _CorrelationValues_both_IRI_CC,
        CorrelationValues,
        __IMS_VoIP_Correlation__item__ims_iri,
        __IMS_VoIP_Correlation__item__ims_cc,
        _IMS_VoIP_Correlation__item_,
        IMS_VoIP_Correlation,
        __IRI_to_CC_Correlation_cc__item_,
        _IRI_to_CC_Correlation_cc,
        _IRI_to_CC_Correlation_iri,
        IRI_to_CC_Correlation,
        IRI_to_IRI_Correlation,
        EPSEvent,
        CSREvent,
        IMSevent,
        _Services_Data_Information_gPRS_parameters,
        Services_Data_Information,
        _GPRS_parameters_pDP_address_allocated_to_the_target,
        _GPRS_parameters_aPN,
        _GPRS_parameters_pDP_type,
        _GPRS_parameters_nSAPI,
        _GPRS_parameters_additionalIPaddress,
        GPRS_parameters,
        GPRSOperationErrorCode,
        LDIevent,
        _UmtsQos_qosMobileRadio,
        _UmtsQos_qosGn,
        UmtsQos,
        _EPS_GTPV2_SpecificParameters_pDNAddressAllocation,
        _EPS_GTPV2_SpecificParameters_aPN,
        _EPS_GTPV2_SpecificParameters_protConfigOptions,
        _EPS_GTPV2_SpecificParameters_attachType,
        _EPS_GTPV2_SpecificParameters_ePSBearerIdentity,
        _EPS_GTPV2_SpecificParameters_detachType,
        _EPS_GTPV2_SpecificParameters_rATType,
        _EPS_GTPV2_SpecificParameters_failedBearerActivationReason,
        _EPS_GTPV2_SpecificParameters_ePSBearerQoS,
        _EPS_GTPV2_SpecificParameters_bearerActivationType,
        _EPS_GTPV2_SpecificParameters_aPN_AMBR,
        _EPS_GTPV2_SpecificParameters_procedureTransactionId,
        _EPS_GTPV2_SpecificParameters_linkedEPSBearerId,
        _EPS_GTPV2_SpecificParameters_tFT,
        _EPS_GTPV2_SpecificParameters_handoverIndication,
        _EPS_GTPV2_SpecificParameters_failedBearerModReason,
        _EPS_GTPV2_SpecificParameters_trafficAggregateDescription,
        _EPS_GTPV2_SpecificParameters_failedTAUReason,
        _EPS_GTPV2_SpecificParameters_failedEUTRANAttachReason,
        _EPS_GTPV2_SpecificParameters_servingMMEaddress,
        _EPS_GTPV2_SpecificParameters_bearerDeactivationType,
        _EPS_GTPV2_SpecificParameters_bearerDeactivationCause,
        _EPS_GTPV2_SpecificParameters_ePSlocationOfTheTarget,
        _EPS_GTPV2_SpecificParameters_pDNType,
        _EPS_GTPV2_SpecificParameters_requestType,
        _EPS_GTPV2_SpecificParameters_uEReqPDNConnFailReason,
        _EPS_GTPV2_SpecificParameters_extendedHandoverIndication,
        _EPS_GTPV2_SpecificParameters_uLITimestamp,
        _EPS_GTPV2_SpecificParameters_uELocalIPAddress,
        _EPS_GTPV2_SpecificParameters_uEUdpPort,
        _EPS_GTPV2_SpecificParameters_tWANIdentifier,
        _EPS_GTPV2_SpecificParameters_tWANIdentifierTimestamp,
        _EPS_GTPV2_SpecificParameters_proSeRemoteUeContextConnected,
        _EPS_GTPV2_SpecificParameters_proSeRemoteUeContextDisconnected,
        _EPS_GTPV2_SpecificParameters_secondaryRATUsageIndication,
        EPS_GTPV2_SpecificParameters,
        TypeOfBearer,
        _EPSLocation_userLocationInfo,
        _EPSLocation_gsmLocation,
        _EPSLocation_umtsLocation,
        _EPSLocation_olduserLocationInfo,
        _EPSLocation_lastVisitedTAI,
        _EPSLocation_tAIlist,
        _EPSLocation_threeGPP2Bsid,
        _EPSLocation_civicAddress,
        _EPSLocation_operatorSpecificInfo,
        __EPSLocation_uELocationTimestamp_timestamp,
        __EPSLocation_uELocationTimestamp_timestampUnknown,
        _EPSLocation_uELocationTimestamp,
        EPSLocation,
        _ProtConfigOptions_ueToNetwork,
        _ProtConfigOptions_networkToUe,
        ProtConfigOptions,
        _RemoteUeContextConnected__item_,
        RemoteUeContextConnected,
        _RemoteUEContext_remoteUserID,
        _RemoteUEContext_remoteUEIPInformation,
        RemoteUEContext,
        RemoteUserID,
        RemoteUEIPInformation,
        RemoteUeContextDisconnected,
        _EPS_PMIP_SpecificParameters_lifetime,
        _EPS_PMIP_SpecificParameters_accessTechnologyType,
        _EPS_PMIP_SpecificParameters_aPN,
        _EPS_PMIP_SpecificParameters_iPv6HomeNetworkPrefix,
        _EPS_PMIP_SpecificParameters_protConfigurationOption,
        _EPS_PMIP_SpecificParameters_handoverIndication,
        _EPS_PMIP_SpecificParameters_status,
        _EPS_PMIP_SpecificParameters_revocationTrigger,
        _EPS_PMIP_SpecificParameters_iPv4HomeAddress,
        _EPS_PMIP_SpecificParameters_iPv6careOfAddress,
        _EPS_PMIP_SpecificParameters_iPv4careOfAddress,
        _EPS_PMIP_SpecificParameters_servingNetwork,
        _EPS_PMIP_SpecificParameters_dHCPv4AddressAllocationInd,
        _EPS_PMIP_SpecificParameters_ePSlocationOfTheTarget,
        EPS_PMIP_SpecificParameters,
        _EPS_DSMIP_SpecificParameters_lifetime,
        _EPS_DSMIP_SpecificParameters_requestedIPv6HomePrefix,
        _EPS_DSMIP_SpecificParameters_homeAddress,
        _EPS_DSMIP_SpecificParameters_iPv4careOfAddress,
        _EPS_DSMIP_SpecificParameters_iPv6careOfAddress,
        _EPS_DSMIP_SpecificParameters_aPN,
        _EPS_DSMIP_SpecificParameters_status,
        _EPS_DSMIP_SpecificParameters_hSS_AAA_address,
        _EPS_DSMIP_SpecificParameters_targetPDN_GW_Address,
        EPS_DSMIP_SpecificParameters,
        _EPS_MIP_SpecificParameters_lifetime,
        _EPS_MIP_SpecificParameters_homeAddress,
        _EPS_MIP_SpecificParameters_careOfAddress,
        _EPS_MIP_SpecificParameters_homeAgentAddress,
        _EPS_MIP_SpecificParameters_code,
        _EPS_MIP_SpecificParameters_foreignDomainAddress,
        EPS_MIP_SpecificParameters,
        _MediaDecryption_info__item_,
        MediaDecryption_info,
        _CCKeyInfo_cCCSID,
        _CCKeyInfo_cCDecKey,
        _CCKeyInfo_cCSalt,
        CCKeyInfo,
        MediaSecFailureIndication,
        _PacketDataHeaderInformation_packetDataHeader,
        _PacketDataHeaderInformation_packetDataSummary,
        PacketDataHeaderInformation,
        _PacketDataHeaderReport_packetDataHeaderMapped,
        _PacketDataHeaderReport_packetDataHeaderCopy,
        PacketDataHeaderReport,
        _PacketDataHeaderMapped_sourceIPAddress,
        _PacketDataHeaderMapped_sourcePortNumber,
        _PacketDataHeaderMapped_destinationIPAddress,
        _PacketDataHeaderMapped_destinationPortNumber,
        _PacketDataHeaderMapped_transportProtocol,
        _PacketDataHeaderMapped_packetsize,
        _PacketDataHeaderMapped_flowLabel,
        _PacketDataHeaderMapped_packetCount,
        _PacketDataHeaderMapped_direction,
        PacketDataHeaderMapped,
        TPDU_direction,
        _PacketDataHeaderCopy_direction,
        _PacketDataHeaderCopy_headerCopy,
        PacketDataHeaderCopy,
        _PacketDataSummaryReport__item_,
        PacketDataSummaryReport,
        _PacketFlowSummary_sourceIPAddress,
        _PacketFlowSummary_sourcePortNumber,
        _PacketFlowSummary_destinationIPAddress,
        _PacketFlowSummary_destinationPortNumber,
        _PacketFlowSummary_transportProtocol,
        _PacketFlowSummary_flowLabel,
        _PacketFlowSummary_summaryPeriod,
        _PacketFlowSummary_packetCount,
        _PacketFlowSummary_sumOfPacketSizes,
        _PacketFlowSummary_packetDataSummaryReason,
        PacketFlowSummary,
        ReportReason,
        _ReportInterval_firstPacketTimeStamp,
        _ReportInterval_lastPacketTimeStamp,
        ReportInterval,
        _TunnelProtocol_rfc2868ValueField,
        _TunnelProtocol_nativeIPSec,
        TunnelProtocol,
        HeNBLocation,
        Requesting_Node_Type,
        _Change_Of_Target_Identity_new_MSISDN,
        _Change_Of_Target_Identity_new_A_MSISDN,
        _Change_Of_Target_Identity_old_MSISDN,
        _Change_Of_Target_Identity_old_A_MSISDN,
        _Change_Of_Target_Identity_new_IMSI,
        _Change_Of_Target_Identity_old_IMSI,
        _Change_Of_Target_Identity_new_IMEI,
        _Change_Of_Target_Identity_old_IMEI,
        _Change_Of_Target_Identity_new_IMPI,
        _Change_Of_Target_Identity_old_IMPI,
        _Change_Of_Target_Identity_new_SIP_URI,
        _Change_Of_Target_Identity_old_SIP_URI,
        _Change_Of_Target_Identity_new_TEL_URI,
        _Change_Of_Target_Identity_old_TEL_URI,
        Change_Of_Target_Identity,
        _Current_Previous_Systems_serving_System_Identifier,
        _Current_Previous_Systems_current_Serving_MME_Address,
        _Current_Previous_Systems_previous_Serving_System_Identifier,
        _Current_Previous_Systems_previous_Serving_MME_Address,
        Current_Previous_Systems,
        ProSeTargetType,
        VoIPRoamingIndication,
        _DeregistrationReason_reason_CodeAVP,
        _DeregistrationReason_server_AssignmentType,
        DeregistrationReason,
        _PTCEncryptionInfo_cipher,
        _PTCEncryptionInfo_cryptoContext,
        _PTCEncryptionInfo_key,
        _PTCEncryptionInfo_keyEncoding,
        _PTCEncryptionInfo_salt,
        _PTCEncryptionInfo_pTCOther,
        PTCEncryptionInfo,
        _PTC_abandonCause,
        _PTC_accessPolicyFailure,
        _PTC_accessPolicyType,
        _PTC_alertIndicator,
        _PTC_associatePresenceStatus,
        _PTC_bearer_capability,
        _PTC_broadcastIndicator,
        _PTC_contactID,
        _PTC_emergency,
        _PTC_emergencyGroupState,
        _PTC_timeStamp,
        _PTC_pTCType,
        _PTC_failureCode,
        _PTC_floorActivity,
        _PTC_floorSpeakerID,
        _PTC_groupAdSender,
        _PTC_groupAuthRule,
        _PTC_groupCharacteristics,
        _PTC_holdRetrieveInd,
        _PTC_imminentPerilInd,
        _PTC_implicitFloorReq,
        _PTC_initiationCause,
        _PTC_invitationCause,
        _PTC_iPAPartyID,
        _PTC_iPADirection,
        _PTC_listManagementAction,
        _PTC_listManagementFailure,
        _PTC_listManagementType,
        _PTC_maxTBTime,
        _PTC_mCPTTGroupID,
        _PTC_mCPTTID,
        _PTC_mCPTTInd,
        _PTC_location,
        _PTC_mCPTTOrganizationName,
        _PTC_mediaStreamAvail,
        _PTC_priority_Level,
        _PTC_preEstSessionID,
        _PTC_preEstStatus,
        _PTC_pTCGroupID,
        _PTC_pTCIDList,
        _PTC_pTCMediaCapability,
        _PTC_pTCOriginatingId,
        _PTC_pTCOther,
        _PTC_pTCParticipants,
        _PTC_pTCParty,
        _PTC_pTCPartyDrop,
        _PTC_pTCSessionInfo,
        _PTC_pTCServerURI,
        _PTC_pTCUserAccessPolicy,
        _PTC_pTCAddress,
        _PTC_queuedFloorControl,
        _PTC_queuedPosition,
        _PTC_registrationRequest,
        _PTC_registrationOutcome,
        _PTC_retrieveID,
        _PTC_rTPSetting,
        _PTC_talkBurstPriority,
        _PTC_talkBurstReason,
        _PTC_talkburstControlSetting,
        _PTC_targetPresenceStatus,
        _PTC_port_Number,
        PTC,
        _AccessPolicyType_userAccessPolicyAttempt,
        _AccessPolicyType_groupAuthorizationRulesAttempt,
        _AccessPolicyType_userAccessPolicyQuery,
        _AccessPolicyType_groupAuthorizationRulesQuery,
        _AccessPolicyType_userAccessPolicyResult,
        _AccessPolicyType_groupAuthorizationRulesResult,
        AccessPolicyType,
        AlertIndicator,
        _AssociatePresenceStatus_presenceID,
        _AssociatePresenceStatus_presenceType,
        _AssociatePresenceStatus_presenceStatus,
        AssociatePresenceStatus,
        PresenceType,
        Emergency,
        _EmergencyGroupState_clientEmergencyState,
        _EmergencyGroupState_groupEmergencyState,
        EmergencyGroupState,
        PTCType,
        _FloorActivity_tBCP_Request,
        _FloorActivity_tBCP_Granted,
        _FloorActivity_tBCP_Deny,
        _FloorActivity_tBCP_Queued,
        _FloorActivity_tBCP_Release,
        _FloorActivity_tBCP_Revoke,
        _FloorActivity_tBCP_Taken,
        _FloorActivity_tBCP_Idle,
        FloorActivity,
        GroupAuthRule,
        ImminentPerilInd,
        ImplicitFloorReq,
        InitiationCause,
        IPADirection,
        ListManagementAction,
        ListManagementType,
        Priority_Level,
        PreEstStatus,
        _PTCAddress_uri,
        _PTCAddress_privacy_setting,
        _PTCAddress_privacy_alias,
        _PTCAddress_nickname,
        PTCAddress,
        RegistrationRequest,
        RegistrationOutcome,
        _RTPSetting_ip_address,
        _RTPSetting_port_number,
        RTPSetting,
        Port_Number,
        _TalkburstControlSetting_talk_BurstControlProtocol,
        __TalkburstControlSetting_talk_Burst_parameters__item_,
        _TalkburstControlSetting_talk_Burst_parameters,
        _TalkburstControlSetting_tBCP_PortNumber,
        TalkburstControlSetting,
        Talk_burst_reason_code,
    ]

class GCSE_HI3:

    _name_  = u'GCSE-HI3'
    _oid_   = [0, 4, 0, 2, 2, 4, 14, 13, 0]
    
    _obj_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi3gcseDomainId',
        u'Gcse-CC-PDU',
        u'GcseLIC-header',
        u'MediaID',
        u'TPDU-direction',
        ]
    _type_ = [
        u'Gcse-CC-PDU',
        u'GcseLIC-header',
        u'MediaID',
        u'TPDU-direction',
        ]
    _set_ = [
        ]
    _val_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi3gcseDomainId',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< lawfulInterceptDomainId >-----#
    lawfulInterceptDomainId = OID(name=u'lawfulInterceptDomainId', mode=MODE_VALUE)
    lawfulInterceptDomainId._val = (0, 4, 0, 2, 2)
    
    #-----< threeGPPSUBDomainId >-----#
    threeGPPSUBDomainId = OID(name=u'threeGPPSUBDomainId', mode=MODE_VALUE)
    threeGPPSUBDomainId._val = (0, 4, 0, 2, 2, 4)
    
    #-----< hi3gcseDomainId >-----#
    hi3gcseDomainId = OID(name=u'hi3gcseDomainId', mode=MODE_VALUE)
    hi3gcseDomainId._val = (0, 4, 0, 2, 2, 4, 14, 13, 0)
    
    #-----< Gcse-CC-PDU >-----#
    Gcse_CC_PDU = SEQ(name=u'Gcse-CC-PDU', mode=MODE_TYPE)
    _Gcse_CC_PDU_gcseLIC_header = SEQ(name=u'gcseLIC-header', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSE-HI3', 'GcseLIC-header')))
    _Gcse_CC_PDU_payload = OCT_STR(name=u'payload', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Gcse_CC_PDU._cont = ASN1Dict([
        (u'gcseLIC-header', _Gcse_CC_PDU_gcseLIC_header),
        (u'payload', _Gcse_CC_PDU_payload),
        ])
    Gcse_CC_PDU._ext = None
    
    #-----< GcseLIC-header >-----#
    GcseLIC_header = SEQ(name=u'GcseLIC-header', mode=MODE_TYPE)
    _GcseLIC_header_hi3gcseDomainId = OID(name=u'hi3gcseDomainId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GcseLIC_header_lIID = OCT_STR(name=u'lIID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'LawfulInterceptionIdentifier')), opt=True)
    _GcseLIC_header_correlation = OCT_STR(name=u'correlation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'GcseCorrelation')))
    _GcseLIC_header_timeStamp = CHOICE(name=u'timeStamp', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')), opt=True)
    _GcseLIC_header_sequence_number = INT(name=u'sequence-number', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GcseLIC_header_sequence_number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _GcseLIC_header_t_PDU_direction = ENUM(name=u't-PDU-direction', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSE-HI3', 'TPDU-direction')))
    _GcseLIC_header_national_HI3_ASN1parameters = SEQ(name=u'national-HI3-ASN1parameters', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Eps-HI3-PS', 'National-HI3-ASN1parameters')), opt=True)
    _GcseLIC_header_mediaID = SEQ(name=u'mediaID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSE-HI3', 'MediaID')), opt=True)
    GcseLIC_header._cont = ASN1Dict([
        (u'hi3gcseDomainId', _GcseLIC_header_hi3gcseDomainId),
        (u'lIID', _GcseLIC_header_lIID),
        (u'correlation', _GcseLIC_header_correlation),
        (u'timeStamp', _GcseLIC_header_timeStamp),
        (u'sequence-number', _GcseLIC_header_sequence_number),
        (u't-PDU-direction', _GcseLIC_header_t_PDU_direction),
        (u'national-HI3-ASN1parameters', _GcseLIC_header_national_HI3_ASN1parameters),
        (u'mediaID', _GcseLIC_header_mediaID),
        ])
    GcseLIC_header._ext = []
    
    #-----< MediaID >-----#
    MediaID = SEQ(name=u'MediaID', mode=MODE_TYPE)
    _MediaID_sourceUserID = SEQ(name=u'sourceUserID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'GcsePartyIdentity')), opt=True)
    _MediaID_streamID = OCT_STR(name=u'streamID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    MediaID._cont = ASN1Dict([
        (u'sourceUserID', _MediaID_sourceUserID),
        (u'streamID', _MediaID_streamID),
        ])
    MediaID._ext = []
    
    #-----< TPDU-direction >-----#
    TPDU_direction = ENUM(name=u'TPDU-direction', mode=MODE_TYPE)
    TPDU_direction._cont = ASN1Dict([(u'from-target', 1), (u'to-target', 2), (u'unknown', 3)])
    TPDU_direction._ext = []
    
    _all_ = [
        lawfulInterceptDomainId,
        threeGPPSUBDomainId,
        hi3gcseDomainId,
        _Gcse_CC_PDU_gcseLIC_header,
        _Gcse_CC_PDU_payload,
        Gcse_CC_PDU,
        _GcseLIC_header_hi3gcseDomainId,
        _GcseLIC_header_lIID,
        _GcseLIC_header_correlation,
        _GcseLIC_header_timeStamp,
        _GcseLIC_header_sequence_number,
        _GcseLIC_header_t_PDU_direction,
        _GcseLIC_header_national_HI3_ASN1parameters,
        _GcseLIC_header_mediaID,
        GcseLIC_header,
        _MediaID_sourceUserID,
        _MediaID_streamID,
        MediaID,
        TPDU_direction,
    ]

class GCSEHI2Operations:

    _name_  = u'GCSEHI2Operations'
    _oid_   = [0, 4, 0, 2, 2, 4, 13, 16, 0]
    
    _obj_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi2gcseDomainId',
        u'GcseIRIsContent',
        u'GcseIRISequence',
        u'GcseIRIContent',
        u'IRI-Parameters',
        u'GcseEvent',
        u'GcseCorrelation',
        u'GcsePartyIdentity',
        u'IMSIdentity',
        u'OtherIdentity',
        u'GcseGroup',
        u'GcseGroupID',
        u'ProSeUEID',
        u'GcseGroupCharacteristics',
        u'TargetConnectionMethod',
        u'Upstream',
        u'Downstream',
        u'AccessType',
        u'AccessID',
        u'VisitedNetworkID',
        u'ReservedTMGI',
        u'TMGIReservationDuration',
        u'Reason',
        ]
    _type_ = [
        u'GcseIRIsContent',
        u'GcseIRISequence',
        u'GcseIRIContent',
        u'IRI-Parameters',
        u'GcseEvent',
        u'GcseCorrelation',
        u'GcsePartyIdentity',
        u'IMSIdentity',
        u'OtherIdentity',
        u'GcseGroup',
        u'GcseGroupID',
        u'ProSeUEID',
        u'GcseGroupCharacteristics',
        u'TargetConnectionMethod',
        u'Upstream',
        u'Downstream',
        u'AccessType',
        u'AccessID',
        u'VisitedNetworkID',
        u'ReservedTMGI',
        u'TMGIReservationDuration',
        u'Reason',
        ]
    _set_ = [
        ]
    _val_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi2gcseDomainId',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< lawfulInterceptDomainId >-----#
    lawfulInterceptDomainId = OID(name=u'lawfulInterceptDomainId', mode=MODE_VALUE)
    lawfulInterceptDomainId._val = (0, 4, 0, 2, 2)
    
    #-----< threeGPPSUBDomainId >-----#
    threeGPPSUBDomainId = OID(name=u'threeGPPSUBDomainId', mode=MODE_VALUE)
    threeGPPSUBDomainId._val = (0, 4, 0, 2, 2, 4)
    
    #-----< hi2gcseDomainId >-----#
    hi2gcseDomainId = OID(name=u'hi2gcseDomainId', mode=MODE_VALUE)
    hi2gcseDomainId._val = (0, 4, 0, 2, 2, 4, 13, 16, 0)
    
    #-----< GcseIRIsContent >-----#
    GcseIRIsContent = CHOICE(name=u'GcseIRIsContent', mode=MODE_TYPE)
    _GcseIRIsContent_gcseiRIContent = CHOICE(name=u'gcseiRIContent', mode=MODE_TYPE, typeref=ASN1RefType(('GCSEHI2Operations', 'GcseIRIContent')))
    _GcseIRIsContent_gcseIRISequence = SEQ_OF(name=u'gcseIRISequence', mode=MODE_TYPE, typeref=ASN1RefType(('GCSEHI2Operations', 'GcseIRISequence')))
    GcseIRIsContent._cont = ASN1Dict([
        (u'gcseiRIContent', _GcseIRIsContent_gcseiRIContent),
        (u'gcseIRISequence', _GcseIRIsContent_gcseIRISequence),
        ])
    GcseIRIsContent._ext = None
    
    #-----< GcseIRISequence >-----#
    GcseIRISequence = SEQ_OF(name=u'GcseIRISequence', mode=MODE_TYPE)
    _GcseIRISequence__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GCSEHI2Operations', 'GcseIRIContent')))
    GcseIRISequence._cont = _GcseIRISequence__item_
    
    #-----< GcseIRIContent >-----#
    GcseIRIContent = CHOICE(name=u'GcseIRIContent', mode=MODE_TYPE)
    _GcseIRIContent_iRI_Begin_record = SEQ(name=u'iRI-Begin-record', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'IRI-Parameters')))
    _GcseIRIContent_iRI_End_record = SEQ(name=u'iRI-End-record', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'IRI-Parameters')))
    _GcseIRIContent_iRI_Continue_record = SEQ(name=u'iRI-Continue-record', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'IRI-Parameters')))
    _GcseIRIContent_iRI_Report_record = SEQ(name=u'iRI-Report-record', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'IRI-Parameters')))
    GcseIRIContent._cont = ASN1Dict([
        (u'iRI-Begin-record', _GcseIRIContent_iRI_Begin_record),
        (u'iRI-End-record', _GcseIRIContent_iRI_End_record),
        (u'iRI-Continue-record', _GcseIRIContent_iRI_Continue_record),
        (u'iRI-Report-record', _GcseIRIContent_iRI_Report_record),
        ])
    GcseIRIContent._ext = []
    
    #-----< IRI-Parameters >-----#
    IRI_Parameters = SEQ(name=u'IRI-Parameters', mode=MODE_TYPE)
    _IRI_Parameters_hi2gcseDomainId = OID(name=u'hi2gcseDomainId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IRI_Parameters_lawfulInterceptionIdentifier = OCT_STR(name=u'lawfulInterceptionIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'LawfulInterceptionIdentifier')))
    _IRI_Parameters_timeStamp = CHOICE(name=u'timeStamp', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    _IRI_Parameters_partyInformation = SET_OF(name=u'partyInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __IRI_Parameters_partyInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GCSEHI2Operations', 'GcsePartyIdentity')))
    _IRI_Parameters_partyInformation._cont = __IRI_Parameters_partyInformation__item_
    _IRI_Parameters_national_Parameters = SET_OF(name=u'national-Parameters', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'National-Parameters')), opt=True)
    _IRI_Parameters_networkIdentifier = SEQ(name=u'networkIdentifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'Network-Identifier')))
    _IRI_Parameters_gcseEvent = ENUM(name=u'gcseEvent', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'GcseEvent')))
    _IRI_Parameters_correlation = OCT_STR(name=u'correlation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'GcseCorrelation')), opt=True)
    _IRI_Parameters_targetConnectionMethod = SEQ(name=u'targetConnectionMethod', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'TargetConnectionMethod')), opt=True)
    _IRI_Parameters_gcseGroupMembers = SEQ_OF(name=u'gcseGroupMembers', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'GcseGroup')), opt=True)
    _IRI_Parameters_gcseGroupParticipants = SEQ_OF(name=u'gcseGroupParticipants', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'GcseGroup')), opt=True)
    _IRI_Parameters_gcseGroupID = SEQ(name=u'gcseGroupID', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'GcseGroupID')), opt=True)
    _IRI_Parameters_gcseGroupCharacteristics = SEQ(name=u'gcseGroupCharacteristics', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'GcseGroupCharacteristics')), opt=True)
    _IRI_Parameters_reservedTMGI = OCT_STR(name=u'reservedTMGI', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'ReservedTMGI')), opt=True)
    _IRI_Parameters_tMGIReservationDuration = OCT_STR(name=u'tMGIReservationDuration', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'TMGIReservationDuration')), opt=True)
    _IRI_Parameters_visitedNetworkID = STR_UTF8(name=u'visitedNetworkID', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'VisitedNetworkID')), opt=True)
    _IRI_Parameters_addedUserID = SEQ(name=u'addedUserID', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'GcsePartyIdentity')), opt=True)
    _IRI_Parameters_droppedUserID = SEQ(name=u'droppedUserID', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'GcsePartyIdentity')), opt=True)
    _IRI_Parameters_reasonForCommsEnd = STR_UTF8(name=u'reasonForCommsEnd', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'Reason')), opt=True)
    _IRI_Parameters_gcseLocationOfTheTarget = SEQ(name=u'gcseLocationOfTheTarget', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EpsHI2Operations', 'EPSLocation')), opt=True)
    IRI_Parameters._cont = ASN1Dict([
        (u'hi2gcseDomainId', _IRI_Parameters_hi2gcseDomainId),
        (u'lawfulInterceptionIdentifier', _IRI_Parameters_lawfulInterceptionIdentifier),
        (u'timeStamp', _IRI_Parameters_timeStamp),
        (u'partyInformation', _IRI_Parameters_partyInformation),
        (u'national-Parameters', _IRI_Parameters_national_Parameters),
        (u'networkIdentifier', _IRI_Parameters_networkIdentifier),
        (u'gcseEvent', _IRI_Parameters_gcseEvent),
        (u'correlation', _IRI_Parameters_correlation),
        (u'targetConnectionMethod', _IRI_Parameters_targetConnectionMethod),
        (u'gcseGroupMembers', _IRI_Parameters_gcseGroupMembers),
        (u'gcseGroupParticipants', _IRI_Parameters_gcseGroupParticipants),
        (u'gcseGroupID', _IRI_Parameters_gcseGroupID),
        (u'gcseGroupCharacteristics', _IRI_Parameters_gcseGroupCharacteristics),
        (u'reservedTMGI', _IRI_Parameters_reservedTMGI),
        (u'tMGIReservationDuration', _IRI_Parameters_tMGIReservationDuration),
        (u'visitedNetworkID', _IRI_Parameters_visitedNetworkID),
        (u'addedUserID', _IRI_Parameters_addedUserID),
        (u'droppedUserID', _IRI_Parameters_droppedUserID),
        (u'reasonForCommsEnd', _IRI_Parameters_reasonForCommsEnd),
        (u'gcseLocationOfTheTarget', _IRI_Parameters_gcseLocationOfTheTarget),
        ])
    IRI_Parameters._ext = []
    
    #-----< GcseEvent >-----#
    GcseEvent = ENUM(name=u'GcseEvent', mode=MODE_TYPE)
    GcseEvent._cont = ASN1Dict([(u'activationOfGcseGroupComms', 1), (u'startOfInterceptionGcseGroupComms', 2), (u'userAdded', 3), (u'userDropped', 4), (u'targetConnectionModification', 5), (u'targetdropped', 6), (u'deactivationOfGcseGroupComms', 7)])
    GcseEvent._ext = []
    
    #-----< GcseCorrelation >-----#
    GcseCorrelation = OCT_STR(name=u'GcseCorrelation', mode=MODE_TYPE)
    
    #-----< GcsePartyIdentity >-----#
    GcsePartyIdentity = SEQ(name=u'GcsePartyIdentity', mode=MODE_TYPE)
    _GcsePartyIdentity_imei = OCT_STR(name=u'imei', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GcsePartyIdentity_imei._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GcsePartyIdentity_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GcsePartyIdentity_imsi._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    _GcsePartyIdentity_iMPU = SET_OF(name=u'iMPU', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GcsePartyIdentity_iMPU__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GCSEHI2Operations', 'IMSIdentity')))
    _GcsePartyIdentity_iMPU._cont = __GcsePartyIdentity_iMPU__item_
    _GcsePartyIdentity_iMPI = SET_OF(name=u'iMPI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GcsePartyIdentity_iMPI__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GCSEHI2Operations', 'IMSIdentity')))
    _GcsePartyIdentity_iMPI._cont = __GcsePartyIdentity_iMPI__item_
    _GcsePartyIdentity_proseUEID = SET_OF(name=u'proseUEID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GcsePartyIdentity_proseUEID__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GCSEHI2Operations', 'ProSeUEID')))
    _GcsePartyIdentity_proseUEID._cont = __GcsePartyIdentity_proseUEID__item_
    _GcsePartyIdentity_otherID = SEQ(name=u'otherID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'OtherIdentity')), opt=True)
    GcsePartyIdentity._cont = ASN1Dict([
        (u'imei', _GcsePartyIdentity_imei),
        (u'imsi', _GcsePartyIdentity_imsi),
        (u'iMPU', _GcsePartyIdentity_iMPU),
        (u'iMPI', _GcsePartyIdentity_iMPI),
        (u'proseUEID', _GcsePartyIdentity_proseUEID),
        (u'otherID', _GcsePartyIdentity_otherID),
        ])
    GcsePartyIdentity._ext = []
    
    #-----< IMSIdentity >-----#
    IMSIdentity = SEQ(name=u'IMSIdentity', mode=MODE_TYPE)
    _IMSIdentity_sip_uri = OCT_STR(name=u'sip-uri', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IMSIdentity_tel_uri = OCT_STR(name=u'tel-uri', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    IMSIdentity._cont = ASN1Dict([
        (u'sip-uri', _IMSIdentity_sip_uri),
        (u'tel-uri', _IMSIdentity_tel_uri),
        ])
    IMSIdentity._ext = []
    
    #-----< OtherIdentity >-----#
    OtherIdentity = SEQ(name=u'OtherIdentity', mode=MODE_TYPE)
    _OtherIdentity_otherIdentityEncoding = STR_UTF8(name=u'otherIdentityEncoding', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OtherIdentity_otherIDInfo = OCT_STR(name=u'otherIDInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OtherIdentity._cont = ASN1Dict([
        (u'otherIdentityEncoding', _OtherIdentity_otherIdentityEncoding),
        (u'otherIDInfo', _OtherIdentity_otherIDInfo),
        ])
    OtherIdentity._ext = []
    
    #-----< GcseGroup >-----#
    GcseGroup = SEQ_OF(name=u'GcseGroup', mode=MODE_TYPE)
    _GcseGroup__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GCSEHI2Operations', 'GcsePartyIdentity')))
    GcseGroup._cont = _GcseGroup__item_
    
    #-----< GcseGroupID >-----#
    GcseGroupID = SEQ(name=u'GcseGroupID', mode=MODE_TYPE, typeref=ASN1RefType(('GCSEHI2Operations', 'GcsePartyIdentity')))
    
    #-----< ProSeUEID >-----#
    ProSeUEID = OCT_STR(name=u'ProSeUEID', mode=MODE_TYPE)
    
    #-----< GcseGroupCharacteristics >-----#
    GcseGroupCharacteristics = SEQ(name=u'GcseGroupCharacteristics', mode=MODE_TYPE)
    _GcseGroupCharacteristics_characteristicsEncoding = STR_UTF8(name=u'characteristicsEncoding', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GcseGroupCharacteristics_characteristics = OCT_STR(name=u'characteristics', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    GcseGroupCharacteristics._cont = ASN1Dict([
        (u'characteristicsEncoding', _GcseGroupCharacteristics_characteristicsEncoding),
        (u'characteristics', _GcseGroupCharacteristics_characteristics),
        ])
    GcseGroupCharacteristics._ext = []
    
    #-----< TargetConnectionMethod >-----#
    TargetConnectionMethod = SEQ(name=u'TargetConnectionMethod', mode=MODE_TYPE)
    _TargetConnectionMethod_connectionStatus = BOOL(name=u'connectionStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TargetConnectionMethod_upstream = SEQ(name=u'upstream', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'Upstream')), opt=True)
    _TargetConnectionMethod_downstream = SEQ(name=u'downstream', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'Downstream')), opt=True)
    TargetConnectionMethod._cont = ASN1Dict([
        (u'connectionStatus', _TargetConnectionMethod_connectionStatus),
        (u'upstream', _TargetConnectionMethod_upstream),
        (u'downstream', _TargetConnectionMethod_downstream),
        ])
    TargetConnectionMethod._ext = []
    
    #-----< Upstream >-----#
    Upstream = SEQ(name=u'Upstream', mode=MODE_TYPE)
    _Upstream_accessType = ENUM(name=u'accessType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'AccessType')))
    _Upstream_accessId = CHOICE(name=u'accessId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'AccessID')))
    Upstream._cont = ASN1Dict([
        (u'accessType', _Upstream_accessType),
        (u'accessId', _Upstream_accessId),
        ])
    Upstream._ext = []
    
    #-----< Downstream >-----#
    Downstream = SEQ(name=u'Downstream', mode=MODE_TYPE)
    _Downstream_accessType = ENUM(name=u'accessType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'AccessType')))
    _Downstream_accessId = CHOICE(name=u'accessId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'AccessID')))
    Downstream._cont = ASN1Dict([
        (u'accessType', _Downstream_accessType),
        (u'accessId', _Downstream_accessId),
        ])
    Downstream._ext = []
    
    #-----< AccessType >-----#
    AccessType = ENUM(name=u'AccessType', mode=MODE_TYPE)
    AccessType._cont = ASN1Dict([(u'ePS-Unicast', 1), (u'ePS-Multicast', 2)])
    AccessType._ext = []
    
    #-----< AccessID >-----#
    AccessID = CHOICE(name=u'AccessID', mode=MODE_TYPE)
    _AccessID_tMGI = OCT_STR(name=u'tMGI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GCSEHI2Operations', 'ReservedTMGI')))
    _AccessID_uEIPAddress = SEQ(name=u'uEIPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IPAddress')))
    AccessID._cont = ASN1Dict([
        (u'tMGI', _AccessID_tMGI),
        (u'uEIPAddress', _AccessID_uEIPAddress),
        ])
    AccessID._ext = []
    
    #-----< VisitedNetworkID >-----#
    VisitedNetworkID = STR_UTF8(name=u'VisitedNetworkID', mode=MODE_TYPE)
    
    #-----< ReservedTMGI >-----#
    ReservedTMGI = OCT_STR(name=u'ReservedTMGI', mode=MODE_TYPE)
    
    #-----< TMGIReservationDuration >-----#
    TMGIReservationDuration = OCT_STR(name=u'TMGIReservationDuration', mode=MODE_TYPE)
    
    #-----< Reason >-----#
    Reason = STR_UTF8(name=u'Reason', mode=MODE_TYPE)
    
    _all_ = [
        lawfulInterceptDomainId,
        threeGPPSUBDomainId,
        hi2gcseDomainId,
        _GcseIRIsContent_gcseiRIContent,
        _GcseIRIsContent_gcseIRISequence,
        GcseIRIsContent,
        _GcseIRISequence__item_,
        GcseIRISequence,
        _GcseIRIContent_iRI_Begin_record,
        _GcseIRIContent_iRI_End_record,
        _GcseIRIContent_iRI_Continue_record,
        _GcseIRIContent_iRI_Report_record,
        GcseIRIContent,
        _IRI_Parameters_hi2gcseDomainId,
        _IRI_Parameters_lawfulInterceptionIdentifier,
        _IRI_Parameters_timeStamp,
        __IRI_Parameters_partyInformation__item_,
        _IRI_Parameters_partyInformation,
        _IRI_Parameters_national_Parameters,
        _IRI_Parameters_networkIdentifier,
        _IRI_Parameters_gcseEvent,
        _IRI_Parameters_correlation,
        _IRI_Parameters_targetConnectionMethod,
        _IRI_Parameters_gcseGroupMembers,
        _IRI_Parameters_gcseGroupParticipants,
        _IRI_Parameters_gcseGroupID,
        _IRI_Parameters_gcseGroupCharacteristics,
        _IRI_Parameters_reservedTMGI,
        _IRI_Parameters_tMGIReservationDuration,
        _IRI_Parameters_visitedNetworkID,
        _IRI_Parameters_addedUserID,
        _IRI_Parameters_droppedUserID,
        _IRI_Parameters_reasonForCommsEnd,
        _IRI_Parameters_gcseLocationOfTheTarget,
        IRI_Parameters,
        GcseEvent,
        GcseCorrelation,
        _GcsePartyIdentity_imei,
        _GcsePartyIdentity_imsi,
        __GcsePartyIdentity_iMPU__item_,
        _GcsePartyIdentity_iMPU,
        __GcsePartyIdentity_iMPI__item_,
        _GcsePartyIdentity_iMPI,
        __GcsePartyIdentity_proseUEID__item_,
        _GcsePartyIdentity_proseUEID,
        _GcsePartyIdentity_otherID,
        GcsePartyIdentity,
        _IMSIdentity_sip_uri,
        _IMSIdentity_tel_uri,
        IMSIdentity,
        _OtherIdentity_otherIdentityEncoding,
        _OtherIdentity_otherIDInfo,
        OtherIdentity,
        _GcseGroup__item_,
        GcseGroup,
        GcseGroupID,
        ProSeUEID,
        _GcseGroupCharacteristics_characteristicsEncoding,
        _GcseGroupCharacteristics_characteristics,
        GcseGroupCharacteristics,
        _TargetConnectionMethod_connectionStatus,
        _TargetConnectionMethod_upstream,
        _TargetConnectionMethod_downstream,
        TargetConnectionMethod,
        _Upstream_accessType,
        _Upstream_accessId,
        Upstream,
        _Downstream_accessType,
        _Downstream_accessId,
        Downstream,
        AccessType,
        _AccessID_tMGI,
        _AccessID_uEIPAddress,
        AccessID,
        VisitedNetworkID,
        ReservedTMGI,
        TMGIReservationDuration,
        Reason,
    ]

class HI2Operations:

    _name_  = u'HI2Operations'
    _oid_   = [0, 4, 0, 2, 2, 1, 18]
    
    _obj_ = [
        u'lawfulInterceptDomainId',
        u'hi2DomainId',
        u'hi2OperationId',
        u'sending-of-IRI',
        u'IRIsContent',
        u'IRISequence',
        u'IRIContent',
        u'unknown-version',
        u'missing-parameter',
        u'unknown-parameter-value',
        u'unknown-parameter',
        u'OperationErrors',
        u'IRI-Parameters',
        u'CommunicationIdentifier',
        u'Network-Identifier',
        u'Network-Element-Identifier',
        u'CC-Link-Identifier',
        u'TimeStamp',
        u'LocalTimeStamp',
        u'PartyInformation',
        u'CallingPartyNumber',
        u'CalledPartyNumber',
        u'Location',
        u'TetraLocation',
        u'GSMLocation',
        u'MapDatum',
        u'UMTSLocation',
        u'GeographicalCoordinates',
        u'GA-Point',
        u'GA-PointWithUnCertainty',
        u'maxNrOfPoints',
        u'GA-Polygon',
        u'CallContentLinkCharacteristics',
        u'CCLink-State',
        u'Intercepted-Call-State',
        u'Services-Information',
        u'ISUP-parameters',
        u'DSS1-parameters-codeset-0',
        u'MAP-parameters',
        u'Supplementary-Services',
        u'Standard-Supplementary-Services',
        u'Non-Standard-Supplementary-Services',
        u'Other-Services',
        u'ISUP-SS-parameters',
        u'DSS1-SS-parameters-codeset-0',
        u'DSS1-SS-parameters-codeset-4',
        u'DSS1-SS-parameters-codeset-5',
        u'DSS1-SS-parameters-codeset-6',
        u'DSS1-SS-parameters-codeset-7',
        u'DSS1-SS-Invoke-Components',
        u'MAP-SS-Invoke-Components',
        u'MAP-SS-Parameters',
        u'SimpleIndication',
        u'SciDataMode',
        u'SMS-report',
        u'LawfulInterceptionIdentifier',
        u'National-Parameters',
        u'GPRSCorrelationNumber',
        u'GPRSEvent',
        u'Services-Data-Information',
        u'GPRS-parameters',
        u'GPRSOperationErrorCode',
        u'DataNodeAddress',
        u'IPAddress',
        u'IP-value',
        u'X25Address',
        u'National-HI2-ASN1parameters',
        ]
    _type_ = [
        u'IRIsContent',
        u'IRISequence',
        u'IRIContent',
        u'IRI-Parameters',
        u'CommunicationIdentifier',
        u'Network-Identifier',
        u'Network-Element-Identifier',
        u'CC-Link-Identifier',
        u'TimeStamp',
        u'LocalTimeStamp',
        u'PartyInformation',
        u'CallingPartyNumber',
        u'CalledPartyNumber',
        u'Location',
        u'TetraLocation',
        u'GSMLocation',
        u'MapDatum',
        u'UMTSLocation',
        u'GeographicalCoordinates',
        u'GA-Point',
        u'GA-PointWithUnCertainty',
        u'GA-Polygon',
        u'CallContentLinkCharacteristics',
        u'CCLink-State',
        u'Intercepted-Call-State',
        u'Services-Information',
        u'ISUP-parameters',
        u'DSS1-parameters-codeset-0',
        u'MAP-parameters',
        u'Supplementary-Services',
        u'Standard-Supplementary-Services',
        u'Non-Standard-Supplementary-Services',
        u'Other-Services',
        u'ISUP-SS-parameters',
        u'DSS1-SS-parameters-codeset-0',
        u'DSS1-SS-parameters-codeset-4',
        u'DSS1-SS-parameters-codeset-5',
        u'DSS1-SS-parameters-codeset-6',
        u'DSS1-SS-parameters-codeset-7',
        u'DSS1-SS-Invoke-Components',
        u'MAP-SS-Invoke-Components',
        u'MAP-SS-Parameters',
        u'SimpleIndication',
        u'SciDataMode',
        u'SMS-report',
        u'LawfulInterceptionIdentifier',
        u'National-Parameters',
        u'GPRSCorrelationNumber',
        u'GPRSEvent',
        u'Services-Data-Information',
        u'GPRS-parameters',
        u'GPRSOperationErrorCode',
        u'DataNodeAddress',
        u'IPAddress',
        u'IP-value',
        u'X25Address',
        u'National-HI2-ASN1parameters',
        ]
    _set_ = [
        u'OperationErrors',
        ]
    _val_ = [
        u'lawfulInterceptDomainId',
        u'hi2DomainId',
        u'hi2OperationId',
        u'sending-of-IRI',
        u'unknown-version',
        u'missing-parameter',
        u'unknown-parameter-value',
        u'unknown-parameter',
        u'maxNrOfPoints',
        ]
    _class_ = [
        u'sending-of-IRI',
        u'unknown-version',
        u'missing-parameter',
        u'unknown-parameter-value',
        u'unknown-parameter',
        u'OperationErrors',
        ]
    _param_ = [
        ]
    
    #-----< lawfulInterceptDomainId >-----#
    lawfulInterceptDomainId = OID(name=u'lawfulInterceptDomainId', mode=MODE_VALUE)
    lawfulInterceptDomainId._val = (0, 4, 0, 2, 2)
    
    #-----< hi2DomainId >-----#
    hi2DomainId = OID(name=u'hi2DomainId', mode=MODE_VALUE)
    hi2DomainId._val = (0, 4, 0, 2, 2, 1)
    
    #-----< hi2OperationId >-----#
    hi2OperationId = OID(name=u'hi2OperationId', mode=MODE_VALUE)
    hi2OperationId._val = (0, 4, 0, 2, 2, 1, 18)
    
    #-----< sending-of-IRI >-----#
    sending_of_IRI = CLASS(name=u'sending-of-IRI', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _sending_of_IRI_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('HI2Operations', 'IRIsContent')))
    sending_of_IRI._val = dict([(u'ArgumentType', _sending_of_IRI_val_ArgumentType), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 2))]), dict([(u'errorCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'operationCode', (u'global', (0, 4, 0, 2, 2, 1, 1, 1)))])
    
    #-----< IRIsContent >-----#
    IRIsContent = CHOICE(name=u'IRIsContent', mode=MODE_TYPE)
    _IRIsContent_iRIContent = CHOICE(name=u'iRIContent', mode=MODE_TYPE, typeref=ASN1RefType(('HI2Operations', 'IRIContent')))
    _IRIsContent_iRISequence = SEQ_OF(name=u'iRISequence', mode=MODE_TYPE, typeref=ASN1RefType(('HI2Operations', 'IRISequence')))
    IRIsContent._cont = ASN1Dict([
        (u'iRIContent', _IRIsContent_iRIContent),
        (u'iRISequence', _IRIsContent_iRISequence),
        ])
    IRIsContent._ext = None
    
    #-----< IRISequence >-----#
    IRISequence = SEQ_OF(name=u'IRISequence', mode=MODE_TYPE)
    _IRISequence__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HI2Operations', 'IRIContent')))
    IRISequence._cont = _IRISequence__item_
    
    #-----< IRIContent >-----#
    IRIContent = CHOICE(name=u'IRIContent', mode=MODE_TYPE)
    _IRIContent_iRI_Begin_record = SEQ(name=u'iRI-Begin-record', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IRI-Parameters')))
    _IRIContent_iRI_End_record = SEQ(name=u'iRI-End-record', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IRI-Parameters')))
    _IRIContent_iRI_Continue_record = SEQ(name=u'iRI-Continue-record', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IRI-Parameters')))
    _IRIContent_iRI_Report_record = SEQ(name=u'iRI-Report-record', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IRI-Parameters')))
    IRIContent._cont = ASN1Dict([
        (u'iRI-Begin-record', _IRIContent_iRI_Begin_record),
        (u'iRI-End-record', _IRIContent_iRI_End_record),
        (u'iRI-Continue-record', _IRIContent_iRI_Continue_record),
        (u'iRI-Report-record', _IRIContent_iRI_Report_record),
        ])
    IRIContent._ext = []
    
    #-----< unknown-version >-----#
    unknown_version = CLASS(name=u'unknown-version', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unknown_version._val = dict([(u'errorCode', (u'local', 0))])
    
    #-----< missing-parameter >-----#
    missing_parameter = CLASS(name=u'missing-parameter', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    missing_parameter._val = dict([(u'errorCode', (u'local', 1))])
    
    #-----< unknown-parameter-value >-----#
    unknown_parameter_value = CLASS(name=u'unknown-parameter-value', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unknown_parameter_value._val = dict([(u'errorCode', (u'local', 2))])
    
    #-----< unknown-parameter >-----#
    unknown_parameter = CLASS(name=u'unknown-parameter', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unknown_parameter._val = dict([(u'errorCode', (u'local', 3))])
    
    #-----< OperationErrors >-----#
    OperationErrors = CLASS(name=u'OperationErrors', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    OperationErrors._val = ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 2))]), dict([(u'errorCode', (u'local', 3))])], rr=[], ev=None, er=[])
    
    #-----< IRI-Parameters >-----#
    IRI_Parameters = SEQ(name=u'IRI-Parameters', mode=MODE_TYPE)
    _IRI_Parameters_domainID = OID(name=u'domainID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_domainID._const_val = ASN1Set(rv=[(0, 4, 0, 2, 2, 1, 18)], rr=[], ev=None, er=[])
    _IRI_Parameters_iRIversion = ENUM(name=u'iRIversion', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_iRIversion._cont = ASN1Dict([(u'version2', 2), (u'version3', 3), (u'version4', 4), (u'version5', 5), (u'version6', 6), (u'version7', 7), (u'lastVersion', 8)])
    _IRI_Parameters_iRIversion._ext = [u'version3', u'version4', u'version5', u'version6', u'version7', u'lastVersion']
    _IRI_Parameters_lawfulInterceptionIdentifier = OCT_STR(name=u'lawfulInterceptionIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'LawfulInterceptionIdentifier')))
    _IRI_Parameters_communicationIdentifier = SEQ(name=u'communicationIdentifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'CommunicationIdentifier')))
    _IRI_Parameters_timeStamp = CHOICE(name=u'timeStamp', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    _IRI_Parameters_intercepted_Call_Direct = ENUM(name=u'intercepted-Call-Direct', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_intercepted_Call_Direct._cont = ASN1Dict([(u'not-Available', 0), (u'originating-Target', 1), (u'terminating-Target', 2)])
    _IRI_Parameters_intercepted_Call_Direct._ext = []
    _IRI_Parameters_intercepted_Call_State = ENUM(name=u'intercepted-Call-State', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'Intercepted-Call-State')), opt=True)
    _IRI_Parameters_ringingDuration = OCT_STR(name=u'ringingDuration', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_ringingDuration._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _IRI_Parameters_conversationDuration = OCT_STR(name=u'conversationDuration', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_conversationDuration._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _IRI_Parameters_locationOfTheTarget = SEQ(name=u'locationOfTheTarget', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'Location')), opt=True)
    _IRI_Parameters_partyInformation = SET_OF(name=u'partyInformation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IRI_Parameters_partyInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HI2Operations', 'PartyInformation')))
    _IRI_Parameters_partyInformation._cont = __IRI_Parameters_partyInformation__item_
    _IRI_Parameters_partyInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _IRI_Parameters_callContentLinkInformation = SEQ(name=u'callContentLinkInformation', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IRI_Parameters_callContentLinkInformation_cCLink1Characteristics = SEQ(name=u'cCLink1Characteristics', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'CallContentLinkCharacteristics')), opt=True)
    __IRI_Parameters_callContentLinkInformation_cCLink2Characteristics = SEQ(name=u'cCLink2Characteristics', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'CallContentLinkCharacteristics')), opt=True)
    _IRI_Parameters_callContentLinkInformation._cont = ASN1Dict([
        (u'cCLink1Characteristics', __IRI_Parameters_callContentLinkInformation_cCLink1Characteristics),
        (u'cCLink2Characteristics', __IRI_Parameters_callContentLinkInformation_cCLink2Characteristics),
        ])
    _IRI_Parameters_callContentLinkInformation._ext = []
    _IRI_Parameters_release_Reason_Of_Intercepted_Call = OCT_STR(name=u'release-Reason-Of-Intercepted-Call', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_release_Reason_Of_Intercepted_Call._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _IRI_Parameters_nature_Of_The_intercepted_call = ENUM(name=u'nature-Of-The-intercepted-call', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_nature_Of_The_intercepted_call._cont = ASN1Dict([(u'gSM-ISDN-PSTN-circuit-call', 0), (u'gSM-SMS-Message', 1), (u'uUS4-Messages', 2), (u'tETRA-circuit-call', 3), (u'teTRA-Packet-Data', 4), (u'gPRS-Packet-Data', 5), (u'uMTS-circuit-call', 6), (u'lTE-SMS-Message', 7), (u'lTE-circuit-call', 8)])
    _IRI_Parameters_nature_Of_The_intercepted_call._ext = [u'uMTS-circuit-call', u'lTE-SMS-Message', u'lTE-circuit-call']
    _IRI_Parameters_serverCenterAddress = SEQ(name=u'serverCenterAddress', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'PartyInformation')), opt=True)
    _IRI_Parameters_sMS = SEQ(name=u'sMS', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'SMS-report')), opt=True)
    _IRI_Parameters_cC_Link_Identifier = OCT_STR(name=u'cC-Link-Identifier', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'CC-Link-Identifier')), opt=True)
    _IRI_Parameters_national_Parameters = SET_OF(name=u'national-Parameters', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'National-Parameters')), opt=True)
    _IRI_Parameters_gPRSCorrelationNumber = OCT_STR(name=u'gPRSCorrelationNumber', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'GPRSCorrelationNumber')), opt=True)
    _IRI_Parameters_gPRSevent = ENUM(name=u'gPRSevent', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'GPRSEvent')), opt=True)
    _IRI_Parameters_sgsnAddress = CHOICE(name=u'sgsnAddress', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DataNodeAddress')), opt=True)
    _IRI_Parameters_gPRSOperationErrorCode = OCT_STR(name=u'gPRSOperationErrorCode', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'GPRSOperationErrorCode')), opt=True)
    _IRI_Parameters_ggsnAddress = CHOICE(name=u'ggsnAddress', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DataNodeAddress')), opt=True)
    _IRI_Parameters_qOS = CHOICE(name=u'qOS', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'UmtsQos')), opt=True)
    _IRI_Parameters_networkIdentifier = SEQ(name=u'networkIdentifier', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'Network-Identifier')), opt=True)
    _IRI_Parameters_sMSOriginatingAddress = CHOICE(name=u'sMSOriginatingAddress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DataNodeAddress')), opt=True)
    _IRI_Parameters_sMSTerminatingAddress = CHOICE(name=u'sMSTerminatingAddress', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DataNodeAddress')), opt=True)
    _IRI_Parameters_iMSevent = ENUM(name=u'iMSevent', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'IMSevent')), opt=True)
    _IRI_Parameters_sIPMessage = OCT_STR(name=u'sIPMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_servingSGSN_number = OCT_STR(name=u'servingSGSN-number', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_servingSGSN_number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    _IRI_Parameters_servingSGSN_address = OCT_STR(name=u'servingSGSN-address', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_servingSGSN_address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=17)], ev=None, er=[])
    _IRI_Parameters_tARGETACTIVITYMONITOR = SEQ(name=u'tARGETACTIVITYMONITOR', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('TS101909201', 'TARGETACTIVITYMONITOR-1')), opt=True)
    _IRI_Parameters_ldiEvent = ENUM(name=u'ldiEvent', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'LDIevent')), opt=True)
    _IRI_Parameters_correlation = CHOICE(name=u'correlation', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'CorrelationValues')), opt=True)
    _IRI_Parameters_tARGETACTIVITYMONITORind = SEQ(name=u'tARGETACTIVITYMONITORind', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'TARGETACTIVITYMONITORind')), opt=True)
    _IRI_Parameters_tARGETCOMMSMONITORind = SEQ(name=u'tARGETCOMMSMONITORind', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'TARGETCOMMSMONITORind')), opt=True)
    _IRI_Parameters_tTRAFFICind = SEQ(name=u'tTRAFFICind', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'TTRAFFICind')), opt=True)
    _IRI_Parameters_cTTRAFFICind = SEQ(name=u'cTTRAFFICind', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EN301040', 'CTTRAFFICind')), opt=True)
    _IRI_Parameters_servingSystem = CHOICE(name=u'servingSystem', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'Network-Element-Identifier')), opt=True)
    _IRI_Parameters_national_HI2_ASN1parameters = SEQ(name=u'national-HI2-ASN1parameters', mode=MODE_TYPE, tag=(255, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'National-HI2-ASN1parameters')), opt=True)
    IRI_Parameters._cont = ASN1Dict([
        (u'domainID', _IRI_Parameters_domainID),
        (u'iRIversion', _IRI_Parameters_iRIversion),
        (u'lawfulInterceptionIdentifier', _IRI_Parameters_lawfulInterceptionIdentifier),
        (u'communicationIdentifier', _IRI_Parameters_communicationIdentifier),
        (u'timeStamp', _IRI_Parameters_timeStamp),
        (u'intercepted-Call-Direct', _IRI_Parameters_intercepted_Call_Direct),
        (u'intercepted-Call-State', _IRI_Parameters_intercepted_Call_State),
        (u'ringingDuration', _IRI_Parameters_ringingDuration),
        (u'conversationDuration', _IRI_Parameters_conversationDuration),
        (u'locationOfTheTarget', _IRI_Parameters_locationOfTheTarget),
        (u'partyInformation', _IRI_Parameters_partyInformation),
        (u'callContentLinkInformation', _IRI_Parameters_callContentLinkInformation),
        (u'release-Reason-Of-Intercepted-Call', _IRI_Parameters_release_Reason_Of_Intercepted_Call),
        (u'nature-Of-The-intercepted-call', _IRI_Parameters_nature_Of_The_intercepted_call),
        (u'serverCenterAddress', _IRI_Parameters_serverCenterAddress),
        (u'sMS', _IRI_Parameters_sMS),
        (u'cC-Link-Identifier', _IRI_Parameters_cC_Link_Identifier),
        (u'national-Parameters', _IRI_Parameters_national_Parameters),
        (u'gPRSCorrelationNumber', _IRI_Parameters_gPRSCorrelationNumber),
        (u'gPRSevent', _IRI_Parameters_gPRSevent),
        (u'sgsnAddress', _IRI_Parameters_sgsnAddress),
        (u'gPRSOperationErrorCode', _IRI_Parameters_gPRSOperationErrorCode),
        (u'ggsnAddress', _IRI_Parameters_ggsnAddress),
        (u'qOS', _IRI_Parameters_qOS),
        (u'networkIdentifier', _IRI_Parameters_networkIdentifier),
        (u'sMSOriginatingAddress', _IRI_Parameters_sMSOriginatingAddress),
        (u'sMSTerminatingAddress', _IRI_Parameters_sMSTerminatingAddress),
        (u'iMSevent', _IRI_Parameters_iMSevent),
        (u'sIPMessage', _IRI_Parameters_sIPMessage),
        (u'servingSGSN-number', _IRI_Parameters_servingSGSN_number),
        (u'servingSGSN-address', _IRI_Parameters_servingSGSN_address),
        (u'tARGETACTIVITYMONITOR', _IRI_Parameters_tARGETACTIVITYMONITOR),
        (u'ldiEvent', _IRI_Parameters_ldiEvent),
        (u'correlation', _IRI_Parameters_correlation),
        (u'tARGETACTIVITYMONITORind', _IRI_Parameters_tARGETACTIVITYMONITORind),
        (u'tARGETCOMMSMONITORind', _IRI_Parameters_tARGETCOMMSMONITORind),
        (u'tTRAFFICind', _IRI_Parameters_tTRAFFICind),
        (u'cTTRAFFICind', _IRI_Parameters_cTTRAFFICind),
        (u'servingSystem', _IRI_Parameters_servingSystem),
        (u'national-HI2-ASN1parameters', _IRI_Parameters_national_HI2_ASN1parameters),
        ])
    IRI_Parameters._ext = [u'ggsnAddress', u'qOS', u'networkIdentifier', u'sMSOriginatingAddress', u'sMSTerminatingAddress', u'iMSevent', u'sIPMessage', u'servingSGSN-number', u'servingSGSN-address', u'tARGETACTIVITYMONITOR', u'ldiEvent', u'correlation', u'tARGETACTIVITYMONITORind', u'tARGETCOMMSMONITORind', u'tTRAFFICind', u'cTTRAFFICind', u'servingSystem', u'national-HI2-ASN1parameters']
    
    #-----< CommunicationIdentifier >-----#
    CommunicationIdentifier = SEQ(name=u'CommunicationIdentifier', mode=MODE_TYPE)
    _CommunicationIdentifier_communication_Identity_Number = OCT_STR(name=u'communication-Identity-Number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CommunicationIdentifier_communication_Identity_Number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _CommunicationIdentifier_network_Identifier = SEQ(name=u'network-Identifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'Network-Identifier')))
    CommunicationIdentifier._cont = ASN1Dict([
        (u'communication-Identity-Number', _CommunicationIdentifier_communication_Identity_Number),
        (u'network-Identifier', _CommunicationIdentifier_network_Identifier),
        ])
    CommunicationIdentifier._ext = []
    
    #-----< Network-Identifier >-----#
    Network_Identifier = SEQ(name=u'Network-Identifier', mode=MODE_TYPE)
    _Network_Identifier_operator_Identifier = OCT_STR(name=u'operator-Identifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Network_Identifier_operator_Identifier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _Network_Identifier_network_Element_Identifier = CHOICE(name=u'network-Element-Identifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'Network-Element-Identifier')), opt=True)
    Network_Identifier._cont = ASN1Dict([
        (u'operator-Identifier', _Network_Identifier_operator_Identifier),
        (u'network-Element-Identifier', _Network_Identifier_network_Element_Identifier),
        ])
    Network_Identifier._ext = []
    
    #-----< Network-Element-Identifier >-----#
    Network_Element_Identifier = CHOICE(name=u'Network-Element-Identifier', mode=MODE_TYPE)
    _Network_Element_Identifier_e164_Format = OCT_STR(name=u'e164-Format', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Network_Element_Identifier_e164_Format._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=25)], ev=None, er=[])
    _Network_Element_Identifier_x25_Format = OCT_STR(name=u'x25-Format', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Network_Element_Identifier_x25_Format._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=25)], ev=None, er=[])
    _Network_Element_Identifier_iP_Format = OCT_STR(name=u'iP-Format', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Network_Element_Identifier_iP_Format._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=25)], ev=None, er=[])
    _Network_Element_Identifier_dNS_Format = OCT_STR(name=u'dNS-Format', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Network_Element_Identifier_dNS_Format._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=25)], ev=None, er=[])
    _Network_Element_Identifier_iP_Address = SEQ(name=u'iP-Address', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IPAddress')))
    Network_Element_Identifier._cont = ASN1Dict([
        (u'e164-Format', _Network_Element_Identifier_e164_Format),
        (u'x25-Format', _Network_Element_Identifier_x25_Format),
        (u'iP-Format', _Network_Element_Identifier_iP_Format),
        (u'dNS-Format', _Network_Element_Identifier_dNS_Format),
        (u'iP-Address', _Network_Element_Identifier_iP_Address),
        ])
    Network_Element_Identifier._ext = [u'iP-Address']
    
    #-----< CC-Link-Identifier >-----#
    CC_Link_Identifier = OCT_STR(name=u'CC-Link-Identifier', mode=MODE_TYPE)
    CC_Link_Identifier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TimeStamp >-----#
    TimeStamp = CHOICE(name=u'TimeStamp', mode=MODE_TYPE)
    _TimeStamp_localTime = SEQ(name=u'localTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'LocalTimeStamp')))
    _TimeStamp_utcTime = TIME_UTC(name=u'utcTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    TimeStamp._cont = ASN1Dict([
        (u'localTime', _TimeStamp_localTime),
        (u'utcTime', _TimeStamp_utcTime),
        ])
    TimeStamp._ext = None
    
    #-----< LocalTimeStamp >-----#
    LocalTimeStamp = SEQ(name=u'LocalTimeStamp', mode=MODE_TYPE)
    _LocalTimeStamp_generalizedTime = TIME_GEN(name=u'generalizedTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocalTimeStamp_winterSummerIndication = ENUM(name=u'winterSummerIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocalTimeStamp_winterSummerIndication._cont = ASN1Dict([(u'notProvided', 0), (u'winterTime', 1), (u'summerTime', 2)])
    _LocalTimeStamp_winterSummerIndication._ext = []
    LocalTimeStamp._cont = ASN1Dict([
        (u'generalizedTime', _LocalTimeStamp_generalizedTime),
        (u'winterSummerIndication', _LocalTimeStamp_winterSummerIndication),
        ])
    LocalTimeStamp._ext = None
    
    #-----< PartyInformation >-----#
    PartyInformation = SEQ(name=u'PartyInformation', mode=MODE_TYPE)
    _PartyInformation_party_Qualifier = ENUM(name=u'party-Qualifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PartyInformation_party_Qualifier._cont = ASN1Dict([(u'originating-Party', 0), (u'terminating-Party', 1), (u'forwarded-to-Party', 2), (u'gPRS-Target', 3)])
    _PartyInformation_party_Qualifier._ext = []
    _PartyInformation_partyIdentity = SEQ(name=u'partyIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PartyInformation_partyIdentity_imei = OCT_STR(name=u'imei', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_imei._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    __PartyInformation_partyIdentity_tei = OCT_STR(name=u'tei', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_tei._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    __PartyInformation_partyIdentity_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_imsi._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    __PartyInformation_partyIdentity_callingPartyNumber = CHOICE(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'CallingPartyNumber')), opt=True)
    __PartyInformation_partyIdentity_calledPartyNumber = CHOICE(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'CalledPartyNumber')), opt=True)
    __PartyInformation_partyIdentity_msISDN = OCT_STR(name=u'msISDN', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_msISDN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    __PartyInformation_partyIdentity_e164_Format = OCT_STR(name=u'e164-Format', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_e164_Format._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=25)], ev=None, er=[])
    __PartyInformation_partyIdentity_sip_uri = OCT_STR(name=u'sip-uri', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_tel_url = OCT_STR(name=u'tel-url', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_party_Validity = ENUM(name=u'party-Validity', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_party_Validity._cont = ASN1Dict([(u'trusted', 0), (u'untrusted', 1), (u'operator-added', 2)])
    __PartyInformation_partyIdentity_party_Validity._ext = []
    __PartyInformation_partyIdentity_alphanumeric = STR_UTF8(name=u'alphanumeric', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PartyInformation_partyIdentity._cont = ASN1Dict([
        (u'imei', __PartyInformation_partyIdentity_imei),
        (u'tei', __PartyInformation_partyIdentity_tei),
        (u'imsi', __PartyInformation_partyIdentity_imsi),
        (u'callingPartyNumber', __PartyInformation_partyIdentity_callingPartyNumber),
        (u'calledPartyNumber', __PartyInformation_partyIdentity_calledPartyNumber),
        (u'msISDN', __PartyInformation_partyIdentity_msISDN),
        (u'e164-Format', __PartyInformation_partyIdentity_e164_Format),
        (u'sip-uri', __PartyInformation_partyIdentity_sip_uri),
        (u'tel-url', __PartyInformation_partyIdentity_tel_url),
        (u'party-Validity', __PartyInformation_partyIdentity_party_Validity),
        (u'alphanumeric', __PartyInformation_partyIdentity_alphanumeric),
        ])
    _PartyInformation_partyIdentity._ext = [u'e164-Format', u'sip-uri', u'tel-url', u'party-Validity', u'alphanumeric']
    _PartyInformation_services_Information = SEQ(name=u'services-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'Services-Information')), opt=True)
    _PartyInformation_supplementary_Services_Information = SEQ(name=u'supplementary-Services-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'Supplementary-Services')), opt=True)
    _PartyInformation_services_Data_Information = SEQ(name=u'services-Data-Information', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'Services-Data-Information')), opt=True)
    PartyInformation._cont = ASN1Dict([
        (u'party-Qualifier', _PartyInformation_party_Qualifier),
        (u'partyIdentity', _PartyInformation_partyIdentity),
        (u'services-Information', _PartyInformation_services_Information),
        (u'supplementary-Services-Information', _PartyInformation_supplementary_Services_Information),
        (u'services-Data-Information', _PartyInformation_services_Data_Information),
        ])
    PartyInformation._ext = []
    
    #-----< CallingPartyNumber >-----#
    CallingPartyNumber = CHOICE(name=u'CallingPartyNumber', mode=MODE_TYPE)
    _CallingPartyNumber_iSUP_Format = OCT_STR(name=u'iSUP-Format', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CallingPartyNumber_iSUP_Format._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=25)], ev=None, er=[])
    _CallingPartyNumber_dSS1_Format = OCT_STR(name=u'dSS1-Format', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CallingPartyNumber_dSS1_Format._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=25)], ev=None, er=[])
    _CallingPartyNumber_mAP_Format = OCT_STR(name=u'mAP-Format', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CallingPartyNumber_mAP_Format._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=25)], ev=None, er=[])
    CallingPartyNumber._cont = ASN1Dict([
        (u'iSUP-Format', _CallingPartyNumber_iSUP_Format),
        (u'dSS1-Format', _CallingPartyNumber_dSS1_Format),
        (u'mAP-Format', _CallingPartyNumber_mAP_Format),
        ])
    CallingPartyNumber._ext = [u'mAP-Format']
    
    #-----< CalledPartyNumber >-----#
    CalledPartyNumber = CHOICE(name=u'CalledPartyNumber', mode=MODE_TYPE)
    _CalledPartyNumber_iSUP_Format = OCT_STR(name=u'iSUP-Format', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CalledPartyNumber_iSUP_Format._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=25)], ev=None, er=[])
    _CalledPartyNumber_mAP_Format = OCT_STR(name=u'mAP-Format', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CalledPartyNumber_mAP_Format._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=25)], ev=None, er=[])
    _CalledPartyNumber_dSS1_Format = OCT_STR(name=u'dSS1-Format', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CalledPartyNumber_dSS1_Format._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=25)], ev=None, er=[])
    CalledPartyNumber._cont = ASN1Dict([
        (u'iSUP-Format', _CalledPartyNumber_iSUP_Format),
        (u'mAP-Format', _CalledPartyNumber_mAP_Format),
        (u'dSS1-Format', _CalledPartyNumber_dSS1_Format),
        ])
    CalledPartyNumber._ext = []
    
    #-----< Location >-----#
    Location = SEQ(name=u'Location', mode=MODE_TYPE)
    _Location_e164_Number = OCT_STR(name=u'e164-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Location_e164_Number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=25)], ev=None, er=[])
    _Location_globalCellID = OCT_STR(name=u'globalCellID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Location_globalCellID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=7)], ev=None, er=[])
    _Location_tetraLocation = CHOICE(name=u'tetraLocation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TetraLocation')), opt=True)
    _Location_rAI = OCT_STR(name=u'rAI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Location_rAI._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    _Location_gsmLocation = CHOICE(name=u'gsmLocation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'GSMLocation')), opt=True)
    _Location_umtsLocation = CHOICE(name=u'umtsLocation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'UMTSLocation')), opt=True)
    _Location_sAI = OCT_STR(name=u'sAI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Location_sAI._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    _Location_oldRAI = OCT_STR(name=u'oldRAI', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Location_oldRAI._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    _Location_tAI = OCT_STR(name=u'tAI', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Location_tAI._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    _Location_eCGI = OCT_STR(name=u'eCGI', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Location_eCGI._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    Location._cont = ASN1Dict([
        (u'e164-Number', _Location_e164_Number),
        (u'globalCellID', _Location_globalCellID),
        (u'tetraLocation', _Location_tetraLocation),
        (u'rAI', _Location_rAI),
        (u'gsmLocation', _Location_gsmLocation),
        (u'umtsLocation', _Location_umtsLocation),
        (u'sAI', _Location_sAI),
        (u'oldRAI', _Location_oldRAI),
        (u'tAI', _Location_tAI),
        (u'eCGI', _Location_eCGI),
        ])
    Location._ext = [u'oldRAI', u'tAI', u'eCGI']
    
    #-----< TetraLocation >-----#
    TetraLocation = CHOICE(name=u'TetraLocation', mode=MODE_TYPE)
    _TetraLocation_ms_Loc = SEQ(name=u'ms-Loc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TetraLocation_ms_Loc_mcc = INT(name=u'mcc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TetraLocation_ms_Loc_mcc._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    __TetraLocation_ms_Loc_mnc = INT(name=u'mnc', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TetraLocation_ms_Loc_mnc._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    __TetraLocation_ms_Loc_lai = INT(name=u'lai', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TetraLocation_ms_Loc_lai._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    __TetraLocation_ms_Loc_ci = INT(name=u'ci', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TetraLocation_ms_Loc._cont = ASN1Dict([
        (u'mcc', __TetraLocation_ms_Loc_mcc),
        (u'mnc', __TetraLocation_ms_Loc_mnc),
        (u'lai', __TetraLocation_ms_Loc_lai),
        (u'ci', __TetraLocation_ms_Loc_ci),
        ])
    _TetraLocation_ms_Loc._ext = None
    _TetraLocation_ls_Loc = INT(name=u'ls-Loc', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    TetraLocation._cont = ASN1Dict([
        (u'ms-Loc', _TetraLocation_ms_Loc),
        (u'ls-Loc', _TetraLocation_ls_Loc),
        ])
    TetraLocation._ext = None
    
    #-----< GSMLocation >-----#
    GSMLocation = CHOICE(name=u'GSMLocation', mode=MODE_TYPE)
    _GSMLocation_geoCoordinates = SEQ(name=u'geoCoordinates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GSMLocation_geoCoordinates_latitude = STR_PRINT(name=u'latitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GSMLocation_geoCoordinates_latitude._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=7, ub=10)], ev=None, er=[])
    __GSMLocation_geoCoordinates_longitude = STR_PRINT(name=u'longitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GSMLocation_geoCoordinates_longitude._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=11)], ev=None, er=[])
    __GSMLocation_geoCoordinates_mapDatum = ENUM(name=u'mapDatum', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'MapDatum')), default=u'wGS84')
    __GSMLocation_geoCoordinates_azimuth = INT(name=u'azimuth', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GSMLocation_geoCoordinates_azimuth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _GSMLocation_geoCoordinates._cont = ASN1Dict([
        (u'latitude', __GSMLocation_geoCoordinates_latitude),
        (u'longitude', __GSMLocation_geoCoordinates_longitude),
        (u'mapDatum', __GSMLocation_geoCoordinates_mapDatum),
        (u'azimuth', __GSMLocation_geoCoordinates_azimuth),
        ])
    _GSMLocation_geoCoordinates._ext = [u'azimuth']
    _GSMLocation_utmCoordinates = SEQ(name=u'utmCoordinates', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GSMLocation_utmCoordinates_utm_East = STR_PRINT(name=u'utm-East', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GSMLocation_utmCoordinates_utm_East._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    __GSMLocation_utmCoordinates_utm_North = STR_PRINT(name=u'utm-North', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GSMLocation_utmCoordinates_utm_North._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    __GSMLocation_utmCoordinates_mapDatum = ENUM(name=u'mapDatum', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'MapDatum')), default=u'wGS84')
    __GSMLocation_utmCoordinates_azimuth = INT(name=u'azimuth', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GSMLocation_utmCoordinates_azimuth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _GSMLocation_utmCoordinates._cont = ASN1Dict([
        (u'utm-East', __GSMLocation_utmCoordinates_utm_East),
        (u'utm-North', __GSMLocation_utmCoordinates_utm_North),
        (u'mapDatum', __GSMLocation_utmCoordinates_mapDatum),
        (u'azimuth', __GSMLocation_utmCoordinates_azimuth),
        ])
    _GSMLocation_utmCoordinates._ext = [u'azimuth']
    _GSMLocation_utmRefCoordinates = SEQ(name=u'utmRefCoordinates', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GSMLocation_utmRefCoordinates_utmref_string = STR_PRINT(name=u'utmref-string', mode=MODE_TYPE)
    __GSMLocation_utmRefCoordinates_utmref_string._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    __GSMLocation_utmRefCoordinates_mapDatum = ENUM(name=u'mapDatum', mode=MODE_TYPE, typeref=ASN1RefType(('HI2Operations', 'MapDatum')), default=u'wGS84')
    _GSMLocation_utmRefCoordinates._cont = ASN1Dict([
        (u'utmref-string', __GSMLocation_utmRefCoordinates_utmref_string),
        (u'mapDatum', __GSMLocation_utmRefCoordinates_mapDatum),
        ])
    _GSMLocation_utmRefCoordinates._ext = []
    _GSMLocation_wGS84Coordinates = OCT_STR(name=u'wGS84Coordinates', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    GSMLocation._cont = ASN1Dict([
        (u'geoCoordinates', _GSMLocation_geoCoordinates),
        (u'utmCoordinates', _GSMLocation_utmCoordinates),
        (u'utmRefCoordinates', _GSMLocation_utmRefCoordinates),
        (u'wGS84Coordinates', _GSMLocation_wGS84Coordinates),
        ])
    GSMLocation._ext = None
    
    #-----< MapDatum >-----#
    MapDatum = ENUM(name=u'MapDatum', mode=MODE_TYPE)
    MapDatum._cont = ASN1Dict([(u'wGS84', 0), (u'wGS72', 1), (u'eD50', 2)])
    MapDatum._ext = []
    
    #-----< UMTSLocation >-----#
    UMTSLocation = CHOICE(name=u'UMTSLocation', mode=MODE_TYPE)
    _UMTSLocation_point = SEQ(name=u'point', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'GA-Point')))
    _UMTSLocation_pointWithUnCertainty = SEQ(name=u'pointWithUnCertainty', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'GA-PointWithUnCertainty')))
    _UMTSLocation_polygon = SEQ_OF(name=u'polygon', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'GA-Polygon')))
    UMTSLocation._cont = ASN1Dict([
        (u'point', _UMTSLocation_point),
        (u'pointWithUnCertainty', _UMTSLocation_pointWithUnCertainty),
        (u'polygon', _UMTSLocation_polygon),
        ])
    UMTSLocation._ext = []
    
    #-----< GeographicalCoordinates >-----#
    GeographicalCoordinates = SEQ(name=u'GeographicalCoordinates', mode=MODE_TYPE)
    _GeographicalCoordinates_latitudeSign = ENUM(name=u'latitudeSign', mode=MODE_TYPE)
    _GeographicalCoordinates_latitudeSign._cont = ASN1Dict([(u'north', 0), (u'south', 1)])
    _GeographicalCoordinates_latitudeSign._ext = None
    _GeographicalCoordinates_latitude = INT(name=u'latitude', mode=MODE_TYPE)
    _GeographicalCoordinates_latitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    _GeographicalCoordinates_longitude = INT(name=u'longitude', mode=MODE_TYPE)
    _GeographicalCoordinates_longitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    GeographicalCoordinates._cont = ASN1Dict([
        (u'latitudeSign', _GeographicalCoordinates_latitudeSign),
        (u'latitude', _GeographicalCoordinates_latitude),
        (u'longitude', _GeographicalCoordinates_longitude),
        ])
    GeographicalCoordinates._ext = []
    
    #-----< GA-Point >-----#
    GA_Point = SEQ(name=u'GA-Point', mode=MODE_TYPE)
    _GA_Point_geographicalCoordinates = SEQ(name=u'geographicalCoordinates', mode=MODE_TYPE, typeref=ASN1RefType(('HI2Operations', 'GeographicalCoordinates')))
    GA_Point._cont = ASN1Dict([
        (u'geographicalCoordinates', _GA_Point_geographicalCoordinates),
        ])
    GA_Point._ext = []
    
    #-----< GA-PointWithUnCertainty >-----#
    GA_PointWithUnCertainty = SEQ(name=u'GA-PointWithUnCertainty', mode=MODE_TYPE)
    _GA_PointWithUnCertainty_geographicalCoordinates = SEQ(name=u'geographicalCoordinates', mode=MODE_TYPE, typeref=ASN1RefType(('HI2Operations', 'GeographicalCoordinates')))
    _GA_PointWithUnCertainty_uncertaintyCode = INT(name=u'uncertaintyCode', mode=MODE_TYPE)
    _GA_PointWithUnCertainty_uncertaintyCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    GA_PointWithUnCertainty._cont = ASN1Dict([
        (u'geographicalCoordinates', _GA_PointWithUnCertainty_geographicalCoordinates),
        (u'uncertaintyCode', _GA_PointWithUnCertainty_uncertaintyCode),
        ])
    GA_PointWithUnCertainty._ext = None
    
    #-----< maxNrOfPoints >-----#
    maxNrOfPoints = INT(name=u'maxNrOfPoints', mode=MODE_VALUE)
    maxNrOfPoints._val = 15
    
    #-----< GA-Polygon >-----#
    GA_Polygon = SEQ_OF(name=u'GA-Polygon', mode=MODE_TYPE)
    _GA_Polygon__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GA_Polygon__item__geographicalCoordinates = SEQ(name=u'geographicalCoordinates', mode=MODE_TYPE, typeref=ASN1RefType(('HI2Operations', 'GeographicalCoordinates')))
    _GA_Polygon__item_._cont = ASN1Dict([
        (u'geographicalCoordinates', __GA_Polygon__item__geographicalCoordinates),
        ])
    _GA_Polygon__item_._ext = []
    GA_Polygon._cont = _GA_Polygon__item_
    GA_Polygon._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< CallContentLinkCharacteristics >-----#
    CallContentLinkCharacteristics = SEQ(name=u'CallContentLinkCharacteristics', mode=MODE_TYPE)
    _CallContentLinkCharacteristics_cCLink_State = ENUM(name=u'cCLink-State', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'CCLink-State')), opt=True)
    _CallContentLinkCharacteristics_release_Time = CHOICE(name=u'release-Time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')), opt=True)
    _CallContentLinkCharacteristics_release_Reason = OCT_STR(name=u'release-Reason', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CallContentLinkCharacteristics_release_Reason._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _CallContentLinkCharacteristics_lEMF_Address = CHOICE(name=u'lEMF-Address', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'CalledPartyNumber')), opt=True)
    CallContentLinkCharacteristics._cont = ASN1Dict([
        (u'cCLink-State', _CallContentLinkCharacteristics_cCLink_State),
        (u'release-Time', _CallContentLinkCharacteristics_release_Time),
        (u'release-Reason', _CallContentLinkCharacteristics_release_Reason),
        (u'lEMF-Address', _CallContentLinkCharacteristics_lEMF_Address),
        ])
    CallContentLinkCharacteristics._ext = []
    
    #-----< CCLink-State >-----#
    CCLink_State = ENUM(name=u'CCLink-State', mode=MODE_TYPE)
    CCLink_State._cont = ASN1Dict([(u'setUpInProcess', 1), (u'callActive', 2), (u'callReleased', 3), (u'lack-of-resource', 4)])
    CCLink_State._ext = []
    
    #-----< Intercepted-Call-State >-----#
    Intercepted_Call_State = ENUM(name=u'Intercepted-Call-State', mode=MODE_TYPE)
    Intercepted_Call_State._cont = ASN1Dict([(u'idle', 1), (u'setUpInProcess', 2), (u'connected', 3)])
    Intercepted_Call_State._ext = []
    
    #-----< Services-Information >-----#
    Services_Information = SEQ(name=u'Services-Information', mode=MODE_TYPE)
    _Services_Information_iSUP_parameters = SET_OF(name=u'iSUP-parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'ISUP-parameters')), opt=True)
    _Services_Information_dSS1_parameters_codeset_0 = SET_OF(name=u'dSS1-parameters-codeset-0', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DSS1-parameters-codeset-0')), opt=True)
    _Services_Information_mAP_parameters = SET_OF(name=u'mAP-parameters', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'MAP-parameters')), opt=True)
    Services_Information._cont = ASN1Dict([
        (u'iSUP-parameters', _Services_Information_iSUP_parameters),
        (u'dSS1-parameters-codeset-0', _Services_Information_dSS1_parameters_codeset_0),
        (u'mAP-parameters', _Services_Information_mAP_parameters),
        ])
    Services_Information._ext = [u'mAP-parameters']
    
    #-----< ISUP-parameters >-----#
    ISUP_parameters = SET_OF(name=u'ISUP-parameters', mode=MODE_TYPE)
    _ISUP_parameters__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    _ISUP_parameters__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    ISUP_parameters._cont = _ISUP_parameters__item_
    ISUP_parameters._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< DSS1-parameters-codeset-0 >-----#
    DSS1_parameters_codeset_0 = SET_OF(name=u'DSS1-parameters-codeset-0', mode=MODE_TYPE)
    _DSS1_parameters_codeset_0__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    _DSS1_parameters_codeset_0__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    DSS1_parameters_codeset_0._cont = _DSS1_parameters_codeset_0__item_
    DSS1_parameters_codeset_0._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< MAP-parameters >-----#
    MAP_parameters = SET_OF(name=u'MAP-parameters', mode=MODE_TYPE)
    _MAP_parameters__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    _MAP_parameters__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    MAP_parameters._cont = _MAP_parameters__item_
    MAP_parameters._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Supplementary-Services >-----#
    Supplementary_Services = SEQ(name=u'Supplementary-Services', mode=MODE_TYPE)
    _Supplementary_Services_standard_Supplementary_Services = SEQ(name=u'standard-Supplementary-Services', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'Standard-Supplementary-Services')), opt=True)
    _Supplementary_Services_non_Standard_Supplementary_Services = SET_OF(name=u'non-Standard-Supplementary-Services', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'Non-Standard-Supplementary-Services')), opt=True)
    _Supplementary_Services_other_Services = SET_OF(name=u'other-Services', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'Other-Services')), opt=True)
    Supplementary_Services._cont = ASN1Dict([
        (u'standard-Supplementary-Services', _Supplementary_Services_standard_Supplementary_Services),
        (u'non-Standard-Supplementary-Services', _Supplementary_Services_non_Standard_Supplementary_Services),
        (u'other-Services', _Supplementary_Services_other_Services),
        ])
    Supplementary_Services._ext = []
    
    #-----< Standard-Supplementary-Services >-----#
    Standard_Supplementary_Services = SEQ(name=u'Standard-Supplementary-Services', mode=MODE_TYPE)
    _Standard_Supplementary_Services_iSUP_SS_parameters = SET_OF(name=u'iSUP-SS-parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'ISUP-SS-parameters')), opt=True)
    _Standard_Supplementary_Services_dSS1_SS_parameters_codeset_0 = SET_OF(name=u'dSS1-SS-parameters-codeset-0', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DSS1-SS-parameters-codeset-0')), opt=True)
    _Standard_Supplementary_Services_dSS1_SS_parameters_codeset_4 = SET_OF(name=u'dSS1-SS-parameters-codeset-4', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DSS1-SS-parameters-codeset-4')), opt=True)
    _Standard_Supplementary_Services_dSS1_SS_parameters_codeset_5 = SET_OF(name=u'dSS1-SS-parameters-codeset-5', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DSS1-SS-parameters-codeset-5')), opt=True)
    _Standard_Supplementary_Services_dSS1_SS_parameters_codeset_6 = SET_OF(name=u'dSS1-SS-parameters-codeset-6', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DSS1-SS-parameters-codeset-6')), opt=True)
    _Standard_Supplementary_Services_dSS1_SS_parameters_codeset_7 = SET_OF(name=u'dSS1-SS-parameters-codeset-7', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DSS1-SS-parameters-codeset-7')), opt=True)
    _Standard_Supplementary_Services_dSS1_SS_Invoke_components = SET_OF(name=u'dSS1-SS-Invoke-components', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DSS1-SS-Invoke-Components')), opt=True)
    _Standard_Supplementary_Services_mAP_SS_Parameters = SET_OF(name=u'mAP-SS-Parameters', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'MAP-SS-Parameters')), opt=True)
    _Standard_Supplementary_Services_mAP_SS_Invoke_Components = SET_OF(name=u'mAP-SS-Invoke-Components', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'MAP-SS-Invoke-Components')), opt=True)
    Standard_Supplementary_Services._cont = ASN1Dict([
        (u'iSUP-SS-parameters', _Standard_Supplementary_Services_iSUP_SS_parameters),
        (u'dSS1-SS-parameters-codeset-0', _Standard_Supplementary_Services_dSS1_SS_parameters_codeset_0),
        (u'dSS1-SS-parameters-codeset-4', _Standard_Supplementary_Services_dSS1_SS_parameters_codeset_4),
        (u'dSS1-SS-parameters-codeset-5', _Standard_Supplementary_Services_dSS1_SS_parameters_codeset_5),
        (u'dSS1-SS-parameters-codeset-6', _Standard_Supplementary_Services_dSS1_SS_parameters_codeset_6),
        (u'dSS1-SS-parameters-codeset-7', _Standard_Supplementary_Services_dSS1_SS_parameters_codeset_7),
        (u'dSS1-SS-Invoke-components', _Standard_Supplementary_Services_dSS1_SS_Invoke_components),
        (u'mAP-SS-Parameters', _Standard_Supplementary_Services_mAP_SS_Parameters),
        (u'mAP-SS-Invoke-Components', _Standard_Supplementary_Services_mAP_SS_Invoke_Components),
        ])
    Standard_Supplementary_Services._ext = []
    
    #-----< Non-Standard-Supplementary-Services >-----#
    Non_Standard_Supplementary_Services = SET_OF(name=u'Non-Standard-Supplementary-Services', mode=MODE_TYPE)
    _Non_Standard_Supplementary_Services__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    __Non_Standard_Supplementary_Services__item__simpleIndication = ENUM(name=u'simpleIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'SimpleIndication')))
    __Non_Standard_Supplementary_Services__item__sciData = OCT_STR(name=u'sciData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'SciDataMode')))
    _Non_Standard_Supplementary_Services__item_._cont = ASN1Dict([
        (u'simpleIndication', __Non_Standard_Supplementary_Services__item__simpleIndication),
        (u'sciData', __Non_Standard_Supplementary_Services__item__sciData),
        ])
    _Non_Standard_Supplementary_Services__item_._ext = []
    Non_Standard_Supplementary_Services._cont = _Non_Standard_Supplementary_Services__item_
    Non_Standard_Supplementary_Services._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    
    #-----< Other-Services >-----#
    Other_Services = SET_OF(name=u'Other-Services', mode=MODE_TYPE)
    _Other_Services__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    _Other_Services__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    Other_Services._cont = _Other_Services__item_
    Other_Services._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< ISUP-SS-parameters >-----#
    ISUP_SS_parameters = SET_OF(name=u'ISUP-SS-parameters', mode=MODE_TYPE)
    _ISUP_SS_parameters__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    _ISUP_SS_parameters__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    ISUP_SS_parameters._cont = _ISUP_SS_parameters__item_
    ISUP_SS_parameters._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< DSS1-SS-parameters-codeset-0 >-----#
    DSS1_SS_parameters_codeset_0 = SET_OF(name=u'DSS1-SS-parameters-codeset-0', mode=MODE_TYPE)
    _DSS1_SS_parameters_codeset_0__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    _DSS1_SS_parameters_codeset_0__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    DSS1_SS_parameters_codeset_0._cont = _DSS1_SS_parameters_codeset_0__item_
    DSS1_SS_parameters_codeset_0._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< DSS1-SS-parameters-codeset-4 >-----#
    DSS1_SS_parameters_codeset_4 = SET_OF(name=u'DSS1-SS-parameters-codeset-4', mode=MODE_TYPE)
    _DSS1_SS_parameters_codeset_4__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    _DSS1_SS_parameters_codeset_4__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    DSS1_SS_parameters_codeset_4._cont = _DSS1_SS_parameters_codeset_4__item_
    DSS1_SS_parameters_codeset_4._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< DSS1-SS-parameters-codeset-5 >-----#
    DSS1_SS_parameters_codeset_5 = SET_OF(name=u'DSS1-SS-parameters-codeset-5', mode=MODE_TYPE)
    _DSS1_SS_parameters_codeset_5__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    _DSS1_SS_parameters_codeset_5__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    DSS1_SS_parameters_codeset_5._cont = _DSS1_SS_parameters_codeset_5__item_
    DSS1_SS_parameters_codeset_5._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< DSS1-SS-parameters-codeset-6 >-----#
    DSS1_SS_parameters_codeset_6 = SET_OF(name=u'DSS1-SS-parameters-codeset-6', mode=MODE_TYPE)
    _DSS1_SS_parameters_codeset_6__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    _DSS1_SS_parameters_codeset_6__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    DSS1_SS_parameters_codeset_6._cont = _DSS1_SS_parameters_codeset_6__item_
    DSS1_SS_parameters_codeset_6._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< DSS1-SS-parameters-codeset-7 >-----#
    DSS1_SS_parameters_codeset_7 = SET_OF(name=u'DSS1-SS-parameters-codeset-7', mode=MODE_TYPE)
    _DSS1_SS_parameters_codeset_7__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    _DSS1_SS_parameters_codeset_7__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    DSS1_SS_parameters_codeset_7._cont = _DSS1_SS_parameters_codeset_7__item_
    DSS1_SS_parameters_codeset_7._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< DSS1-SS-Invoke-Components >-----#
    DSS1_SS_Invoke_Components = SET_OF(name=u'DSS1-SS-Invoke-Components', mode=MODE_TYPE)
    _DSS1_SS_Invoke_Components__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    _DSS1_SS_Invoke_Components__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    DSS1_SS_Invoke_Components._cont = _DSS1_SS_Invoke_Components__item_
    DSS1_SS_Invoke_Components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< MAP-SS-Invoke-Components >-----#
    MAP_SS_Invoke_Components = SET_OF(name=u'MAP-SS-Invoke-Components', mode=MODE_TYPE)
    _MAP_SS_Invoke_Components__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    _MAP_SS_Invoke_Components__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    MAP_SS_Invoke_Components._cont = _MAP_SS_Invoke_Components__item_
    MAP_SS_Invoke_Components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< MAP-SS-Parameters >-----#
    MAP_SS_Parameters = SET_OF(name=u'MAP-SS-Parameters', mode=MODE_TYPE)
    _MAP_SS_Parameters__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    _MAP_SS_Parameters__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    MAP_SS_Parameters._cont = _MAP_SS_Parameters__item_
    MAP_SS_Parameters._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< SimpleIndication >-----#
    SimpleIndication = ENUM(name=u'SimpleIndication', mode=MODE_TYPE)
    SimpleIndication._cont = ASN1Dict([(u'call-Waiting-Indication', 0), (u'add-conf-Indication', 1), (u'call-on-hold-Indication', 2), (u'retrieve-Indication', 3), (u'suspend-Indication', 4), (u'resume-Indication', 5), (u'answer-Indication', 6)])
    SimpleIndication._ext = []
    
    #-----< SciDataMode >-----#
    SciDataMode = OCT_STR(name=u'SciDataMode', mode=MODE_TYPE)
    SciDataMode._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< SMS-report >-----#
    SMS_report = SEQ(name=u'SMS-report', mode=MODE_TYPE)
    _SMS_report_communicationIdentifier = SEQ(name=u'communicationIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'CommunicationIdentifier')))
    _SMS_report_timeStamp = CHOICE(name=u'timeStamp', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    _SMS_report_sMS_Contents = SEQ(name=u'sMS-Contents', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SMS_report_sMS_Contents_initiator = ENUM(name=u'initiator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SMS_report_sMS_Contents_initiator._cont = ASN1Dict([(u'target', 0), (u'server', 1), (u'undefined-party', 2)])
    __SMS_report_sMS_Contents_initiator._ext = []
    __SMS_report_sMS_Contents_transfer_status = ENUM(name=u'transfer-status', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SMS_report_sMS_Contents_transfer_status._cont = ASN1Dict([(u'succeed-transfer', 0), (u'not-succeed-transfer', 1), (u'undefined', 2)])
    __SMS_report_sMS_Contents_transfer_status._ext = []
    __SMS_report_sMS_Contents_other_message = ENUM(name=u'other-message', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SMS_report_sMS_Contents_other_message._cont = ASN1Dict([(u'yes', 0), (u'no', 1), (u'undefined', 2)])
    __SMS_report_sMS_Contents_other_message._ext = []
    __SMS_report_sMS_Contents_content = OCT_STR(name=u'content', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SMS_report_sMS_Contents_content._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=270)], ev=None, er=[])
    __SMS_report_sMS_Contents_enhancedContent = SEQ(name=u'enhancedContent', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SMS_report_sMS_Contents_enhancedContent_content = OCT_STR(name=u'content', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SMS_report_sMS_Contents_enhancedContent_character_encoding = ENUM(name=u'character-encoding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SMS_report_sMS_Contents_enhancedContent_character_encoding._cont = ASN1Dict([(u'gsm-7-bit-ascii', 0), (u'eight-bit-ascii', 1), (u'eight-bit-binary', 2), (u'ucs-2', 3), (u'utf-8', 4), (u'utf-16', 5), (u'other', 6)])
    ___SMS_report_sMS_Contents_enhancedContent_character_encoding._ext = []
    __SMS_report_sMS_Contents_enhancedContent._cont = ASN1Dict([
        (u'content', ___SMS_report_sMS_Contents_enhancedContent_content),
        (u'character-encoding', ___SMS_report_sMS_Contents_enhancedContent_character_encoding),
        ])
    __SMS_report_sMS_Contents_enhancedContent._ext = None
    _SMS_report_sMS_Contents._cont = ASN1Dict([
        (u'initiator', __SMS_report_sMS_Contents_initiator),
        (u'transfer-status', __SMS_report_sMS_Contents_transfer_status),
        (u'other-message', __SMS_report_sMS_Contents_other_message),
        (u'content', __SMS_report_sMS_Contents_content),
        (u'enhancedContent', __SMS_report_sMS_Contents_enhancedContent),
        ])
    _SMS_report_sMS_Contents._ext = [u'enhancedContent']
    SMS_report._cont = ASN1Dict([
        (u'communicationIdentifier', _SMS_report_communicationIdentifier),
        (u'timeStamp', _SMS_report_timeStamp),
        (u'sMS-Contents', _SMS_report_sMS_Contents),
        ])
    SMS_report._ext = None
    
    #-----< LawfulInterceptionIdentifier >-----#
    LawfulInterceptionIdentifier = OCT_STR(name=u'LawfulInterceptionIdentifier', mode=MODE_TYPE)
    LawfulInterceptionIdentifier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=25)], ev=None, er=[])
    
    #-----< National-Parameters >-----#
    National_Parameters = SET_OF(name=u'National-Parameters', mode=MODE_TYPE)
    _National_Parameters__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    _National_Parameters__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    National_Parameters._cont = _National_Parameters__item_
    National_Parameters._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    
    #-----< GPRSCorrelationNumber >-----#
    GPRSCorrelationNumber = OCT_STR(name=u'GPRSCorrelationNumber', mode=MODE_TYPE)
    GPRSCorrelationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=20)], ev=None, er=[])
    
    #-----< GPRSEvent >-----#
    GPRSEvent = ENUM(name=u'GPRSEvent', mode=MODE_TYPE)
    GPRSEvent._cont = ASN1Dict([(u'pDPContextActivation', 1), (u'startOfInterceptionWithPDPContextActive', 2), (u'pDPContextDeactivation', 4), (u'gPRSAttach', 5), (u'gPRSDetach', 6), (u'cellOrRAUpdate', 10), (u'sMS', 11), (u'pDPContextModification', 13), (u'endOfInterceptionWithPDPContextActive', 14)])
    GPRSEvent._ext = [u'pDPContextModification', u'endOfInterceptionWithPDPContextActive']
    
    #-----< Services-Data-Information >-----#
    Services_Data_Information = SEQ(name=u'Services-Data-Information', mode=MODE_TYPE)
    _Services_Data_Information_gPRS_parameters = SEQ(name=u'gPRS-parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'GPRS-parameters')), opt=True)
    Services_Data_Information._cont = ASN1Dict([
        (u'gPRS-parameters', _Services_Data_Information_gPRS_parameters),
        ])
    Services_Data_Information._ext = []
    
    #-----< GPRS-parameters >-----#
    GPRS_parameters = SEQ(name=u'GPRS-parameters', mode=MODE_TYPE)
    _GPRS_parameters_pDP_address_allocated_to_the_target = CHOICE(name=u'pDP-address-allocated-to-the-target', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DataNodeAddress')), opt=True)
    _GPRS_parameters_aPN = OCT_STR(name=u'aPN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GPRS_parameters_aPN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _GPRS_parameters_pDP_type = OCT_STR(name=u'pDP-type', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GPRS_parameters_pDP_type._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GPRS_parameters_nSAPI = OCT_STR(name=u'nSAPI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GPRS_parameters_nSAPI._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _GPRS_parameters_additionalIPaddress = CHOICE(name=u'additionalIPaddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DataNodeAddress')), opt=True)
    GPRS_parameters._cont = ASN1Dict([
        (u'pDP-address-allocated-to-the-target', _GPRS_parameters_pDP_address_allocated_to_the_target),
        (u'aPN', _GPRS_parameters_aPN),
        (u'pDP-type', _GPRS_parameters_pDP_type),
        (u'nSAPI', _GPRS_parameters_nSAPI),
        (u'additionalIPaddress', _GPRS_parameters_additionalIPaddress),
        ])
    GPRS_parameters._ext = [u'nSAPI', u'additionalIPaddress']
    
    #-----< GPRSOperationErrorCode >-----#
    GPRSOperationErrorCode = OCT_STR(name=u'GPRSOperationErrorCode', mode=MODE_TYPE)
    GPRSOperationErrorCode._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< DataNodeAddress >-----#
    DataNodeAddress = CHOICE(name=u'DataNodeAddress', mode=MODE_TYPE)
    _DataNodeAddress_ipAddress = SEQ(name=u'ipAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IPAddress')))
    _DataNodeAddress_x25Address = OCT_STR(name=u'x25Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'X25Address')))
    DataNodeAddress._cont = ASN1Dict([
        (u'ipAddress', _DataNodeAddress_ipAddress),
        (u'x25Address', _DataNodeAddress_x25Address),
        ])
    DataNodeAddress._ext = []
    
    #-----< IPAddress >-----#
    IPAddress = SEQ(name=u'IPAddress', mode=MODE_TYPE)
    _IPAddress_iP_type = ENUM(name=u'iP-type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IPAddress_iP_type._cont = ASN1Dict([(u'iPV4', 0), (u'iPV6', 1)])
    _IPAddress_iP_type._ext = []
    _IPAddress_iP_value = CHOICE(name=u'iP-value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IP-value')))
    _IPAddress_iP_assignment = ENUM(name=u'iP-assignment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IPAddress_iP_assignment._cont = ASN1Dict([(u'static', 1), (u'dynamic', 2), (u'notKnown', 3)])
    _IPAddress_iP_assignment._ext = []
    _IPAddress_iPv6PrefixLength = INT(name=u'iPv6PrefixLength', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IPAddress_iPv6PrefixLength._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _IPAddress_iPv4SubnetMask = OCT_STR(name=u'iPv4SubnetMask', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IPAddress_iPv4SubnetMask._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    IPAddress._cont = ASN1Dict([
        (u'iP-type', _IPAddress_iP_type),
        (u'iP-value', _IPAddress_iP_value),
        (u'iP-assignment', _IPAddress_iP_assignment),
        (u'iPv6PrefixLength', _IPAddress_iPv6PrefixLength),
        (u'iPv4SubnetMask', _IPAddress_iPv4SubnetMask),
        ])
    IPAddress._ext = [u'iPv6PrefixLength', u'iPv4SubnetMask']
    
    #-----< IP-value >-----#
    IP_value = CHOICE(name=u'IP-value', mode=MODE_TYPE)
    _IP_value_iPBinaryAddress = OCT_STR(name=u'iPBinaryAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IP_value_iPBinaryAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=16)], ev=None, er=[])
    _IP_value_iPTextAddress = STR_IA5(name=u'iPTextAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IP_value_iPTextAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=7, ub=45)], ev=None, er=[])
    IP_value._cont = ASN1Dict([
        (u'iPBinaryAddress', _IP_value_iPBinaryAddress),
        (u'iPTextAddress', _IP_value_iPTextAddress),
        ])
    IP_value._ext = []
    
    #-----< X25Address >-----#
    X25Address = OCT_STR(name=u'X25Address', mode=MODE_TYPE)
    X25Address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=25)], ev=None, er=[])
    
    #-----< National-HI2-ASN1parameters >-----#
    National_HI2_ASN1parameters = SEQ(name=u'National-HI2-ASN1parameters', mode=MODE_TYPE)
    _National_HI2_ASN1parameters_countryCode = STR_PRINT(name=u'countryCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _National_HI2_ASN1parameters_countryCode._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    National_HI2_ASN1parameters._cont = ASN1Dict([
        (u'countryCode', _National_HI2_ASN1parameters_countryCode),
        ])
    National_HI2_ASN1parameters._ext = []
    
    _all_ = [
        lawfulInterceptDomainId,
        hi2DomainId,
        hi2OperationId,
        sending_of_IRI,
        _sending_of_IRI_val_ArgumentType,
        _IRIsContent_iRIContent,
        _IRIsContent_iRISequence,
        IRIsContent,
        _IRISequence__item_,
        IRISequence,
        _IRIContent_iRI_Begin_record,
        _IRIContent_iRI_End_record,
        _IRIContent_iRI_Continue_record,
        _IRIContent_iRI_Report_record,
        IRIContent,
        unknown_version,
        missing_parameter,
        unknown_parameter_value,
        unknown_parameter,
        OperationErrors,
        _IRI_Parameters_domainID,
        _IRI_Parameters_iRIversion,
        _IRI_Parameters_lawfulInterceptionIdentifier,
        _IRI_Parameters_communicationIdentifier,
        _IRI_Parameters_timeStamp,
        _IRI_Parameters_intercepted_Call_Direct,
        _IRI_Parameters_intercepted_Call_State,
        _IRI_Parameters_ringingDuration,
        _IRI_Parameters_conversationDuration,
        _IRI_Parameters_locationOfTheTarget,
        __IRI_Parameters_partyInformation__item_,
        _IRI_Parameters_partyInformation,
        __IRI_Parameters_callContentLinkInformation_cCLink1Characteristics,
        __IRI_Parameters_callContentLinkInformation_cCLink2Characteristics,
        _IRI_Parameters_callContentLinkInformation,
        _IRI_Parameters_release_Reason_Of_Intercepted_Call,
        _IRI_Parameters_nature_Of_The_intercepted_call,
        _IRI_Parameters_serverCenterAddress,
        _IRI_Parameters_sMS,
        _IRI_Parameters_cC_Link_Identifier,
        _IRI_Parameters_national_Parameters,
        _IRI_Parameters_gPRSCorrelationNumber,
        _IRI_Parameters_gPRSevent,
        _IRI_Parameters_sgsnAddress,
        _IRI_Parameters_gPRSOperationErrorCode,
        _IRI_Parameters_ggsnAddress,
        _IRI_Parameters_qOS,
        _IRI_Parameters_networkIdentifier,
        _IRI_Parameters_sMSOriginatingAddress,
        _IRI_Parameters_sMSTerminatingAddress,
        _IRI_Parameters_iMSevent,
        _IRI_Parameters_sIPMessage,
        _IRI_Parameters_servingSGSN_number,
        _IRI_Parameters_servingSGSN_address,
        _IRI_Parameters_tARGETACTIVITYMONITOR,
        _IRI_Parameters_ldiEvent,
        _IRI_Parameters_correlation,
        _IRI_Parameters_tARGETACTIVITYMONITORind,
        _IRI_Parameters_tARGETCOMMSMONITORind,
        _IRI_Parameters_tTRAFFICind,
        _IRI_Parameters_cTTRAFFICind,
        _IRI_Parameters_servingSystem,
        _IRI_Parameters_national_HI2_ASN1parameters,
        IRI_Parameters,
        _CommunicationIdentifier_communication_Identity_Number,
        _CommunicationIdentifier_network_Identifier,
        CommunicationIdentifier,
        _Network_Identifier_operator_Identifier,
        _Network_Identifier_network_Element_Identifier,
        Network_Identifier,
        _Network_Element_Identifier_e164_Format,
        _Network_Element_Identifier_x25_Format,
        _Network_Element_Identifier_iP_Format,
        _Network_Element_Identifier_dNS_Format,
        _Network_Element_Identifier_iP_Address,
        Network_Element_Identifier,
        CC_Link_Identifier,
        _TimeStamp_localTime,
        _TimeStamp_utcTime,
        TimeStamp,
        _LocalTimeStamp_generalizedTime,
        _LocalTimeStamp_winterSummerIndication,
        LocalTimeStamp,
        _PartyInformation_party_Qualifier,
        __PartyInformation_partyIdentity_imei,
        __PartyInformation_partyIdentity_tei,
        __PartyInformation_partyIdentity_imsi,
        __PartyInformation_partyIdentity_callingPartyNumber,
        __PartyInformation_partyIdentity_calledPartyNumber,
        __PartyInformation_partyIdentity_msISDN,
        __PartyInformation_partyIdentity_e164_Format,
        __PartyInformation_partyIdentity_sip_uri,
        __PartyInformation_partyIdentity_tel_url,
        __PartyInformation_partyIdentity_party_Validity,
        __PartyInformation_partyIdentity_alphanumeric,
        _PartyInformation_partyIdentity,
        _PartyInformation_services_Information,
        _PartyInformation_supplementary_Services_Information,
        _PartyInformation_services_Data_Information,
        PartyInformation,
        _CallingPartyNumber_iSUP_Format,
        _CallingPartyNumber_dSS1_Format,
        _CallingPartyNumber_mAP_Format,
        CallingPartyNumber,
        _CalledPartyNumber_iSUP_Format,
        _CalledPartyNumber_mAP_Format,
        _CalledPartyNumber_dSS1_Format,
        CalledPartyNumber,
        _Location_e164_Number,
        _Location_globalCellID,
        _Location_tetraLocation,
        _Location_rAI,
        _Location_gsmLocation,
        _Location_umtsLocation,
        _Location_sAI,
        _Location_oldRAI,
        _Location_tAI,
        _Location_eCGI,
        Location,
        __TetraLocation_ms_Loc_mcc,
        __TetraLocation_ms_Loc_mnc,
        __TetraLocation_ms_Loc_lai,
        __TetraLocation_ms_Loc_ci,
        _TetraLocation_ms_Loc,
        _TetraLocation_ls_Loc,
        TetraLocation,
        __GSMLocation_geoCoordinates_latitude,
        __GSMLocation_geoCoordinates_longitude,
        __GSMLocation_geoCoordinates_mapDatum,
        __GSMLocation_geoCoordinates_azimuth,
        _GSMLocation_geoCoordinates,
        __GSMLocation_utmCoordinates_utm_East,
        __GSMLocation_utmCoordinates_utm_North,
        __GSMLocation_utmCoordinates_mapDatum,
        __GSMLocation_utmCoordinates_azimuth,
        _GSMLocation_utmCoordinates,
        __GSMLocation_utmRefCoordinates_utmref_string,
        __GSMLocation_utmRefCoordinates_mapDatum,
        _GSMLocation_utmRefCoordinates,
        _GSMLocation_wGS84Coordinates,
        GSMLocation,
        MapDatum,
        _UMTSLocation_point,
        _UMTSLocation_pointWithUnCertainty,
        _UMTSLocation_polygon,
        UMTSLocation,
        _GeographicalCoordinates_latitudeSign,
        _GeographicalCoordinates_latitude,
        _GeographicalCoordinates_longitude,
        GeographicalCoordinates,
        _GA_Point_geographicalCoordinates,
        GA_Point,
        _GA_PointWithUnCertainty_geographicalCoordinates,
        _GA_PointWithUnCertainty_uncertaintyCode,
        GA_PointWithUnCertainty,
        maxNrOfPoints,
        __GA_Polygon__item__geographicalCoordinates,
        _GA_Polygon__item_,
        GA_Polygon,
        _CallContentLinkCharacteristics_cCLink_State,
        _CallContentLinkCharacteristics_release_Time,
        _CallContentLinkCharacteristics_release_Reason,
        _CallContentLinkCharacteristics_lEMF_Address,
        CallContentLinkCharacteristics,
        CCLink_State,
        Intercepted_Call_State,
        _Services_Information_iSUP_parameters,
        _Services_Information_dSS1_parameters_codeset_0,
        _Services_Information_mAP_parameters,
        Services_Information,
        _ISUP_parameters__item_,
        ISUP_parameters,
        _DSS1_parameters_codeset_0__item_,
        DSS1_parameters_codeset_0,
        _MAP_parameters__item_,
        MAP_parameters,
        _Supplementary_Services_standard_Supplementary_Services,
        _Supplementary_Services_non_Standard_Supplementary_Services,
        _Supplementary_Services_other_Services,
        Supplementary_Services,
        _Standard_Supplementary_Services_iSUP_SS_parameters,
        _Standard_Supplementary_Services_dSS1_SS_parameters_codeset_0,
        _Standard_Supplementary_Services_dSS1_SS_parameters_codeset_4,
        _Standard_Supplementary_Services_dSS1_SS_parameters_codeset_5,
        _Standard_Supplementary_Services_dSS1_SS_parameters_codeset_6,
        _Standard_Supplementary_Services_dSS1_SS_parameters_codeset_7,
        _Standard_Supplementary_Services_dSS1_SS_Invoke_components,
        _Standard_Supplementary_Services_mAP_SS_Parameters,
        _Standard_Supplementary_Services_mAP_SS_Invoke_Components,
        Standard_Supplementary_Services,
        __Non_Standard_Supplementary_Services__item__simpleIndication,
        __Non_Standard_Supplementary_Services__item__sciData,
        _Non_Standard_Supplementary_Services__item_,
        Non_Standard_Supplementary_Services,
        _Other_Services__item_,
        Other_Services,
        _ISUP_SS_parameters__item_,
        ISUP_SS_parameters,
        _DSS1_SS_parameters_codeset_0__item_,
        DSS1_SS_parameters_codeset_0,
        _DSS1_SS_parameters_codeset_4__item_,
        DSS1_SS_parameters_codeset_4,
        _DSS1_SS_parameters_codeset_5__item_,
        DSS1_SS_parameters_codeset_5,
        _DSS1_SS_parameters_codeset_6__item_,
        DSS1_SS_parameters_codeset_6,
        _DSS1_SS_parameters_codeset_7__item_,
        DSS1_SS_parameters_codeset_7,
        _DSS1_SS_Invoke_Components__item_,
        DSS1_SS_Invoke_Components,
        _MAP_SS_Invoke_Components__item_,
        MAP_SS_Invoke_Components,
        _MAP_SS_Parameters__item_,
        MAP_SS_Parameters,
        SimpleIndication,
        SciDataMode,
        _SMS_report_communicationIdentifier,
        _SMS_report_timeStamp,
        __SMS_report_sMS_Contents_initiator,
        __SMS_report_sMS_Contents_transfer_status,
        __SMS_report_sMS_Contents_other_message,
        __SMS_report_sMS_Contents_content,
        ___SMS_report_sMS_Contents_enhancedContent_content,
        ___SMS_report_sMS_Contents_enhancedContent_character_encoding,
        __SMS_report_sMS_Contents_enhancedContent,
        _SMS_report_sMS_Contents,
        SMS_report,
        LawfulInterceptionIdentifier,
        _National_Parameters__item_,
        National_Parameters,
        GPRSCorrelationNumber,
        GPRSEvent,
        _Services_Data_Information_gPRS_parameters,
        Services_Data_Information,
        _GPRS_parameters_pDP_address_allocated_to_the_target,
        _GPRS_parameters_aPN,
        _GPRS_parameters_pDP_type,
        _GPRS_parameters_nSAPI,
        _GPRS_parameters_additionalIPaddress,
        GPRS_parameters,
        GPRSOperationErrorCode,
        _DataNodeAddress_ipAddress,
        _DataNodeAddress_x25Address,
        DataNodeAddress,
        _IPAddress_iP_type,
        _IPAddress_iP_value,
        _IPAddress_iP_assignment,
        _IPAddress_iPv6PrefixLength,
        _IPAddress_iPv4SubnetMask,
        IPAddress,
        _IP_value_iPBinaryAddress,
        _IP_value_iPTextAddress,
        IP_value,
        X25Address,
        _National_HI2_ASN1parameters_countryCode,
        National_HI2_ASN1parameters,
    ]

class HI3CCLinkData:

    _name_  = u'HI3CCLinkData'
    _oid_   = [0, 4, 0, 2, 2, 2, 4, 2]
    
    _obj_ = [
        u'UUS1-Content',
        u'Direction-Indication',
        u'Service-Information',
        ]
    _type_ = [
        u'UUS1-Content',
        u'Direction-Indication',
        u'Service-Information',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< UUS1-Content >-----#
    UUS1_Content = SEQ(name=u'UUS1-Content', mode=MODE_TYPE)
    _UUS1_Content_lawfullInterceptionIdentifier = OCT_STR(name=u'lawfullInterceptionIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'LawfulInterceptionIdentifier')))
    _UUS1_Content_communicationIdentifier = SEQ(name=u'communicationIdentifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'CommunicationIdentifier')))
    _UUS1_Content_cC_Link_Identifier = OCT_STR(name=u'cC-Link-Identifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'CC-Link-Identifier')), opt=True)
    _UUS1_Content_direction_Indication = ENUM(name=u'direction-Indication', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI3CCLinkData', 'Direction-Indication')))
    _UUS1_Content_bearer_capability = OCT_STR(name=u'bearer-capability', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UUS1_Content_bearer_capability._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    _UUS1_Content_service_Information = SET(name=u'service-Information', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI3CCLinkData', 'Service-Information')), opt=True)
    UUS1_Content._cont = ASN1Dict([
        (u'lawfullInterceptionIdentifier', _UUS1_Content_lawfullInterceptionIdentifier),
        (u'communicationIdentifier', _UUS1_Content_communicationIdentifier),
        (u'cC-Link-Identifier', _UUS1_Content_cC_Link_Identifier),
        (u'direction-Indication', _UUS1_Content_direction_Indication),
        (u'bearer-capability', _UUS1_Content_bearer_capability),
        (u'service-Information', _UUS1_Content_service_Information),
        ])
    UUS1_Content._ext = []
    
    #-----< Direction-Indication >-----#
    Direction_Indication = ENUM(name=u'Direction-Indication', mode=MODE_TYPE)
    Direction_Indication._cont = ASN1Dict([(u'mono-mode', 0), (u'cc-from-target', 1), (u'cc-from-other-party', 2)])
    Direction_Indication._ext = []
    
    #-----< Service-Information >-----#
    Service_Information = SET(name=u'Service-Information', mode=MODE_TYPE)
    _Service_Information_high_layer_capability = OCT_STR(name=u'high-layer-capability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Service_Information_high_layer_capability._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _Service_Information_tMR = OCT_STR(name=u'tMR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Service_Information_tMR._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _Service_Information_bearerServiceCode = OCT_STR(name=u'bearerServiceCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Service_Information_bearerServiceCode._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _Service_Information_teleServiceCode = OCT_STR(name=u'teleServiceCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Service_Information_teleServiceCode._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    Service_Information._cont = ASN1Dict([
        (u'high-layer-capability', _Service_Information_high_layer_capability),
        (u'tMR', _Service_Information_tMR),
        (u'bearerServiceCode', _Service_Information_bearerServiceCode),
        (u'teleServiceCode', _Service_Information_teleServiceCode),
        ])
    Service_Information._ext = None
    
    _all_ = [
        _UUS1_Content_lawfullInterceptionIdentifier,
        _UUS1_Content_communicationIdentifier,
        _UUS1_Content_cC_Link_Identifier,
        _UUS1_Content_direction_Indication,
        _UUS1_Content_bearer_capability,
        _UUS1_Content_service_Information,
        UUS1_Content,
        Direction_Indication,
        _Service_Information_high_layer_capability,
        _Service_Information_tMR,
        _Service_Information_bearerServiceCode,
        _Service_Information_teleServiceCode,
        Service_Information,
    ]

class IWLANUmtsHI2Operations:

    _name_  = u'IWLANUmtsHI2Operations'
    _oid_   = [0, 4, 0, 2, 2, 4, 6, 16, 0]
    
    _obj_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi2wlanDomainId',
        u'IWLANUmtsIRIsContent',
        u'IWLANUmtsIRISequence',
        u'IWLANUmtsIRIContent',
        u'IRI-Parameters',
        u'PartyInformation',
        u'CorrelationNumber',
        u'I-WLANEvent',
        u'Services-Data-Information',
        u'I-WLAN-parameters',
        u'I-WLANOperationErrorCode',
        u'I-WLANinformation',
        u'VisitedPLMNID',
        u'SessionAliveTime',
        u'PacketDataHeaderInformation',
        u'PacketDataHeaderReport',
        u'PacketDataHeaderMapped',
        u'TPDU-direction',
        u'PacketDataHeaderCopy',
        u'PacketDataSummaryReport',
        u'PacketFlowSummary',
        u'ReportReason',
        u'ReportInterval',
        ]
    _type_ = [
        u'IWLANUmtsIRIsContent',
        u'IWLANUmtsIRISequence',
        u'IWLANUmtsIRIContent',
        u'IRI-Parameters',
        u'PartyInformation',
        u'CorrelationNumber',
        u'I-WLANEvent',
        u'Services-Data-Information',
        u'I-WLAN-parameters',
        u'I-WLANOperationErrorCode',
        u'I-WLANinformation',
        u'VisitedPLMNID',
        u'SessionAliveTime',
        u'PacketDataHeaderInformation',
        u'PacketDataHeaderReport',
        u'PacketDataHeaderMapped',
        u'TPDU-direction',
        u'PacketDataHeaderCopy',
        u'PacketDataSummaryReport',
        u'PacketFlowSummary',
        u'ReportReason',
        u'ReportInterval',
        ]
    _set_ = [
        ]
    _val_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi2wlanDomainId',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< lawfulInterceptDomainId >-----#
    lawfulInterceptDomainId = OID(name=u'lawfulInterceptDomainId', mode=MODE_VALUE)
    lawfulInterceptDomainId._val = (0, 4, 0, 2, 2)
    
    #-----< threeGPPSUBDomainId >-----#
    threeGPPSUBDomainId = OID(name=u'threeGPPSUBDomainId', mode=MODE_VALUE)
    threeGPPSUBDomainId._val = (0, 4, 0, 2, 2, 4)
    
    #-----< hi2wlanDomainId >-----#
    hi2wlanDomainId = OID(name=u'hi2wlanDomainId', mode=MODE_VALUE)
    hi2wlanDomainId._val = (0, 4, 0, 2, 2, 4, 6, 16, 1)
    
    #-----< IWLANUmtsIRIsContent >-----#
    IWLANUmtsIRIsContent = CHOICE(name=u'IWLANUmtsIRIsContent', mode=MODE_TYPE)
    _IWLANUmtsIRIsContent_iWLANumtsiRIContent = CHOICE(name=u'iWLANumtsiRIContent', mode=MODE_TYPE, typeref=ASN1RefType(('IWLANUmtsHI2Operations', 'IWLANUmtsIRIContent')))
    _IWLANUmtsIRIsContent_iWLANumtsIRISequence = SEQ_OF(name=u'iWLANumtsIRISequence', mode=MODE_TYPE, typeref=ASN1RefType(('IWLANUmtsHI2Operations', 'IWLANUmtsIRISequence')))
    IWLANUmtsIRIsContent._cont = ASN1Dict([
        (u'iWLANumtsiRIContent', _IWLANUmtsIRIsContent_iWLANumtsiRIContent),
        (u'iWLANumtsIRISequence', _IWLANUmtsIRIsContent_iWLANumtsIRISequence),
        ])
    IWLANUmtsIRIsContent._ext = None
    
    #-----< IWLANUmtsIRISequence >-----#
    IWLANUmtsIRISequence = SEQ_OF(name=u'IWLANUmtsIRISequence', mode=MODE_TYPE)
    _IWLANUmtsIRISequence__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IWLANUmtsHI2Operations', 'IWLANUmtsIRIContent')))
    IWLANUmtsIRISequence._cont = _IWLANUmtsIRISequence__item_
    
    #-----< IWLANUmtsIRIContent >-----#
    IWLANUmtsIRIContent = CHOICE(name=u'IWLANUmtsIRIContent', mode=MODE_TYPE)
    _IWLANUmtsIRIContent_iRI_Begin_record = SEQ(name=u'iRI-Begin-record', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IWLANUmtsHI2Operations', 'IRI-Parameters')))
    _IWLANUmtsIRIContent_iRI_End_record = SEQ(name=u'iRI-End-record', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IWLANUmtsHI2Operations', 'IRI-Parameters')))
    _IWLANUmtsIRIContent_iRI_Report_record = SEQ(name=u'iRI-Report-record', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IWLANUmtsHI2Operations', 'IRI-Parameters')))
    IWLANUmtsIRIContent._cont = ASN1Dict([
        (u'iRI-Begin-record', _IWLANUmtsIRIContent_iRI_Begin_record),
        (u'iRI-End-record', _IWLANUmtsIRIContent_iRI_End_record),
        (u'iRI-Report-record', _IWLANUmtsIRIContent_iRI_Report_record),
        ])
    IWLANUmtsIRIContent._ext = []
    
    #-----< IRI-Parameters >-----#
    IRI_Parameters = SEQ(name=u'IRI-Parameters', mode=MODE_TYPE)
    _IRI_Parameters_hi2iwlanDomainId = OID(name=u'hi2iwlanDomainId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IRI_Parameters_lawfulInterceptionIdentifier = OCT_STR(name=u'lawfulInterceptionIdentifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'LawfulInterceptionIdentifier')))
    _IRI_Parameters_timeStamp = CHOICE(name=u'timeStamp', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    _IRI_Parameters_initiator = ENUM(name=u'initiator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_initiator._cont = ASN1Dict([(u'not-Available', 0), (u'originating-Target', 1), (u'terminating-Target', 2)])
    _IRI_Parameters_initiator._ext = []
    _IRI_Parameters_partyInformation = SET_OF(name=u'partyInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IRI_Parameters_partyInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IWLANUmtsHI2Operations', 'PartyInformation')))
    _IRI_Parameters_partyInformation._cont = __IRI_Parameters_partyInformation__item_
    _IRI_Parameters_partyInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _IRI_Parameters_national_Parameters = SET_OF(name=u'national-Parameters', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'National-Parameters')), opt=True)
    _IRI_Parameters_networkIdentifier = SEQ(name=u'networkIdentifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'Network-Identifier')), opt=True)
    _IRI_Parameters_i_WLANevent = ENUM(name=u'i-WLANevent', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IWLANUmtsHI2Operations', 'I-WLANEvent')), opt=True)
    _IRI_Parameters_correlationNumber = OCT_STR(name=u'correlationNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IWLANUmtsHI2Operations', 'CorrelationNumber')), opt=True)
    _IRI_Parameters_i_WLANOperationErrorCode = OCT_STR(name=u'i-WLANOperationErrorCode', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IWLANUmtsHI2Operations', 'I-WLANOperationErrorCode')), opt=True)
    _IRI_Parameters_i_wLANinformation = SEQ(name=u'i-wLANinformation', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IWLANUmtsHI2Operations', 'I-WLANinformation')), opt=True)
    _IRI_Parameters_visitedPLMNID = OCT_STR(name=u'visitedPLMNID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IWLANUmtsHI2Operations', 'VisitedPLMNID')), opt=True)
    _IRI_Parameters_national_HI2_ASN1parameters = SEQ(name=u'national-HI2-ASN1parameters', mode=MODE_TYPE, tag=(255, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'National-HI2-ASN1parameters')), opt=True)
    _IRI_Parameters_nSAPI = OCT_STR(name=u'nSAPI', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_nSAPI._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _IRI_Parameters_packetDataHeaderInformation = CHOICE(name=u'packetDataHeaderInformation', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IWLANUmtsHI2Operations', 'PacketDataHeaderInformation')), opt=True)
    IRI_Parameters._cont = ASN1Dict([
        (u'hi2iwlanDomainId', _IRI_Parameters_hi2iwlanDomainId),
        (u'lawfulInterceptionIdentifier', _IRI_Parameters_lawfulInterceptionIdentifier),
        (u'timeStamp', _IRI_Parameters_timeStamp),
        (u'initiator', _IRI_Parameters_initiator),
        (u'partyInformation', _IRI_Parameters_partyInformation),
        (u'national-Parameters', _IRI_Parameters_national_Parameters),
        (u'networkIdentifier', _IRI_Parameters_networkIdentifier),
        (u'i-WLANevent', _IRI_Parameters_i_WLANevent),
        (u'correlationNumber', _IRI_Parameters_correlationNumber),
        (u'i-WLANOperationErrorCode', _IRI_Parameters_i_WLANOperationErrorCode),
        (u'i-wLANinformation', _IRI_Parameters_i_wLANinformation),
        (u'visitedPLMNID', _IRI_Parameters_visitedPLMNID),
        (u'national-HI2-ASN1parameters', _IRI_Parameters_national_HI2_ASN1parameters),
        (u'nSAPI', _IRI_Parameters_nSAPI),
        (u'packetDataHeaderInformation', _IRI_Parameters_packetDataHeaderInformation),
        ])
    IRI_Parameters._ext = [u'nSAPI', u'packetDataHeaderInformation']
    
    #-----< PartyInformation >-----#
    PartyInformation = SEQ(name=u'PartyInformation', mode=MODE_TYPE)
    _PartyInformation_party_Qualifier = ENUM(name=u'party-Qualifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PartyInformation_party_Qualifier._cont = ASN1Dict([(u'iWLAN-Target', 1)])
    _PartyInformation_party_Qualifier._ext = []
    _PartyInformation_partyIdentity = SEQ(name=u'partyIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PartyInformation_partyIdentity_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_imsi._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    __PartyInformation_partyIdentity_msISDN = OCT_STR(name=u'msISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_msISDN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    __PartyInformation_partyIdentity_nai = OCT_STR(name=u'nai', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PartyInformation_partyIdentity._cont = ASN1Dict([
        (u'imsi', __PartyInformation_partyIdentity_imsi),
        (u'msISDN', __PartyInformation_partyIdentity_msISDN),
        (u'nai', __PartyInformation_partyIdentity_nai),
        ])
    _PartyInformation_partyIdentity._ext = []
    _PartyInformation_services_Data_Information = SEQ(name=u'services-Data-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IWLANUmtsHI2Operations', 'Services-Data-Information')), opt=True)
    PartyInformation._cont = ASN1Dict([
        (u'party-Qualifier', _PartyInformation_party_Qualifier),
        (u'partyIdentity', _PartyInformation_partyIdentity),
        (u'services-Data-Information', _PartyInformation_services_Data_Information),
        ])
    PartyInformation._ext = []
    
    #-----< CorrelationNumber >-----#
    CorrelationNumber = OCT_STR(name=u'CorrelationNumber', mode=MODE_TYPE)
    CorrelationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=20)], ev=None, er=[])
    
    #-----< I-WLANEvent >-----#
    I_WLANEvent = ENUM(name=u'I-WLANEvent', mode=MODE_TYPE)
    I_WLANEvent._cont = ASN1Dict([(u'i-WLANAccessInitiation', 1), (u'i-WLANAccessTermination', 2), (u'i-WLANTunnelEstablishment', 3), (u'i-WLANTunnelDisconnect', 4), (u'startOfInterceptionCommunicationActive', 5), (u'packetDataHeaderInformation', 6)])
    I_WLANEvent._ext = [u'packetDataHeaderInformation']
    
    #-----< Services-Data-Information >-----#
    Services_Data_Information = SEQ(name=u'Services-Data-Information', mode=MODE_TYPE)
    _Services_Data_Information_i_WLAN_parameters = SEQ(name=u'i-WLAN-parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IWLANUmtsHI2Operations', 'I-WLAN-parameters')), opt=True)
    Services_Data_Information._cont = ASN1Dict([
        (u'i-WLAN-parameters', _Services_Data_Information_i_WLAN_parameters),
        ])
    Services_Data_Information._ext = []
    
    #-----< I-WLAN-parameters >-----#
    I_WLAN_parameters = SEQ(name=u'I-WLAN-parameters', mode=MODE_TYPE)
    _I_WLAN_parameters_wlan_local_IP_address_of_the_target = CHOICE(name=u'wlan-local-IP-address-of-the-target', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DataNodeAddress')), opt=True)
    _I_WLAN_parameters_w_APN = OCT_STR(name=u'w-APN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _I_WLAN_parameters_w_APN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _I_WLAN_parameters_wlan_remote_IP_address_of_the_target = CHOICE(name=u'wlan-remote-IP-address-of-the-target', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DataNodeAddress')), opt=True)
    I_WLAN_parameters._cont = ASN1Dict([
        (u'wlan-local-IP-address-of-the-target', _I_WLAN_parameters_wlan_local_IP_address_of_the_target),
        (u'w-APN', _I_WLAN_parameters_w_APN),
        (u'wlan-remote-IP-address-of-the-target', _I_WLAN_parameters_wlan_remote_IP_address_of_the_target),
        ])
    I_WLAN_parameters._ext = []
    
    #-----< I-WLANOperationErrorCode >-----#
    I_WLANOperationErrorCode = OCT_STR(name=u'I-WLANOperationErrorCode', mode=MODE_TYPE)
    
    #-----< I-WLANinformation >-----#
    I_WLANinformation = SEQ(name=u'I-WLANinformation', mode=MODE_TYPE)
    _I_WLANinformation_wLANOperatorName = OCT_STR(name=u'wLANOperatorName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _I_WLANinformation_wLANLocationData = OCT_STR(name=u'wLANLocationData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _I_WLANinformation_wLANLocationInformation = OCT_STR(name=u'wLANLocationInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _I_WLANinformation_nASIPIPv6Address = SEQ(name=u'nASIPIPv6Address', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IPAddress')), opt=True)
    _I_WLANinformation_wLANMACAddress = OCT_STR(name=u'wLANMACAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _I_WLANinformation_sessionAliveTimer = OCT_STR(name=u'sessionAliveTimer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IWLANUmtsHI2Operations', 'SessionAliveTime')), opt=True)
    _I_WLANinformation_geographicalCoordinates = SEQ(name=u'geographicalCoordinates', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'GeographicalCoordinates')), opt=True)
    _I_WLANinformation_civicAddress = CHOICE(name=u'civicAddress', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'CivicAddress')), opt=True)
    I_WLANinformation._cont = ASN1Dict([
        (u'wLANOperatorName', _I_WLANinformation_wLANOperatorName),
        (u'wLANLocationData', _I_WLANinformation_wLANLocationData),
        (u'wLANLocationInformation', _I_WLANinformation_wLANLocationInformation),
        (u'nASIPIPv6Address', _I_WLANinformation_nASIPIPv6Address),
        (u'wLANMACAddress', _I_WLANinformation_wLANMACAddress),
        (u'sessionAliveTimer', _I_WLANinformation_sessionAliveTimer),
        (u'geographicalCoordinates', _I_WLANinformation_geographicalCoordinates),
        (u'civicAddress', _I_WLANinformation_civicAddress),
        ])
    I_WLANinformation._ext = [u'geographicalCoordinates', u'civicAddress']
    
    #-----< VisitedPLMNID >-----#
    VisitedPLMNID = OCT_STR(name=u'VisitedPLMNID', mode=MODE_TYPE)
    
    #-----< SessionAliveTime >-----#
    SessionAliveTime = OCT_STR(name=u'SessionAliveTime', mode=MODE_TYPE)
    
    #-----< PacketDataHeaderInformation >-----#
    PacketDataHeaderInformation = CHOICE(name=u'PacketDataHeaderInformation', mode=MODE_TYPE)
    _PacketDataHeaderInformation_packetDataHeader = CHOICE(name=u'packetDataHeader', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IWLANUmtsHI2Operations', 'PacketDataHeaderReport')))
    _PacketDataHeaderInformation_packetDataSummary = SEQ_OF(name=u'packetDataSummary', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IWLANUmtsHI2Operations', 'PacketDataSummaryReport')))
    PacketDataHeaderInformation._cont = ASN1Dict([
        (u'packetDataHeader', _PacketDataHeaderInformation_packetDataHeader),
        (u'packetDataSummary', _PacketDataHeaderInformation_packetDataSummary),
        ])
    PacketDataHeaderInformation._ext = []
    
    #-----< PacketDataHeaderReport >-----#
    PacketDataHeaderReport = CHOICE(name=u'PacketDataHeaderReport', mode=MODE_TYPE)
    _PacketDataHeaderReport_packetDataHeaderMapped = SEQ(name=u'packetDataHeaderMapped', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IWLANUmtsHI2Operations', 'PacketDataHeaderMapped')))
    _PacketDataHeaderReport_packetDataHeaderCopy = SEQ(name=u'packetDataHeaderCopy', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IWLANUmtsHI2Operations', 'PacketDataHeaderCopy')))
    PacketDataHeaderReport._cont = ASN1Dict([
        (u'packetDataHeaderMapped', _PacketDataHeaderReport_packetDataHeaderMapped),
        (u'packetDataHeaderCopy', _PacketDataHeaderReport_packetDataHeaderCopy),
        ])
    PacketDataHeaderReport._ext = []
    
    #-----< PacketDataHeaderMapped >-----#
    PacketDataHeaderMapped = SEQ(name=u'PacketDataHeaderMapped', mode=MODE_TYPE)
    _PacketDataHeaderMapped_sourceIPAddress = SEQ(name=u'sourceIPAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IPAddress')), opt=True)
    _PacketDataHeaderMapped_sourcePortNumber = INT(name=u'sourcePortNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PacketDataHeaderMapped_sourcePortNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PacketDataHeaderMapped_destinationIPAddress = SEQ(name=u'destinationIPAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IPAddress')), opt=True)
    _PacketDataHeaderMapped_destinationPortNumber = INT(name=u'destinationPortNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PacketDataHeaderMapped_destinationPortNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PacketDataHeaderMapped_transportProtocol = INT(name=u'transportProtocol', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PacketDataHeaderMapped_packetsize = INT(name=u'packetsize', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PacketDataHeaderMapped_flowLabel = INT(name=u'flowLabel', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PacketDataHeaderMapped_packetCount = INT(name=u'packetCount', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PacketDataHeaderMapped_direction = ENUM(name=u'direction', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IWLANUmtsHI2Operations', 'TPDU-direction')))
    PacketDataHeaderMapped._cont = ASN1Dict([
        (u'sourceIPAddress', _PacketDataHeaderMapped_sourceIPAddress),
        (u'sourcePortNumber', _PacketDataHeaderMapped_sourcePortNumber),
        (u'destinationIPAddress', _PacketDataHeaderMapped_destinationIPAddress),
        (u'destinationPortNumber', _PacketDataHeaderMapped_destinationPortNumber),
        (u'transportProtocol', _PacketDataHeaderMapped_transportProtocol),
        (u'packetsize', _PacketDataHeaderMapped_packetsize),
        (u'flowLabel', _PacketDataHeaderMapped_flowLabel),
        (u'packetCount', _PacketDataHeaderMapped_packetCount),
        (u'direction', _PacketDataHeaderMapped_direction),
        ])
    PacketDataHeaderMapped._ext = []
    
    #-----< TPDU-direction >-----#
    TPDU_direction = ENUM(name=u'TPDU-direction', mode=MODE_TYPE)
    TPDU_direction._cont = ASN1Dict([(u'from-target', 1), (u'to-target', 2), (u'unknown', 3)])
    TPDU_direction._ext = None
    
    #-----< PacketDataHeaderCopy >-----#
    PacketDataHeaderCopy = SEQ(name=u'PacketDataHeaderCopy', mode=MODE_TYPE)
    _PacketDataHeaderCopy_direction = ENUM(name=u'direction', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IWLANUmtsHI2Operations', 'TPDU-direction')))
    _PacketDataHeaderCopy_headerCopy = OCT_STR(name=u'headerCopy', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    PacketDataHeaderCopy._cont = ASN1Dict([
        (u'direction', _PacketDataHeaderCopy_direction),
        (u'headerCopy', _PacketDataHeaderCopy_headerCopy),
        ])
    PacketDataHeaderCopy._ext = []
    
    #-----< PacketDataSummaryReport >-----#
    PacketDataSummaryReport = SEQ_OF(name=u'PacketDataSummaryReport', mode=MODE_TYPE)
    _PacketDataSummaryReport__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IWLANUmtsHI2Operations', 'PacketFlowSummary')))
    PacketDataSummaryReport._cont = _PacketDataSummaryReport__item_
    
    #-----< PacketFlowSummary >-----#
    PacketFlowSummary = SEQ(name=u'PacketFlowSummary', mode=MODE_TYPE)
    _PacketFlowSummary_sourceIPAddress = SEQ(name=u'sourceIPAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IPAddress')))
    _PacketFlowSummary_sourcePortNumber = INT(name=u'sourcePortNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PacketFlowSummary_sourcePortNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PacketFlowSummary_destinationIPAddress = SEQ(name=u'destinationIPAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IPAddress')))
    _PacketFlowSummary_destinationPortNumber = INT(name=u'destinationPortNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PacketFlowSummary_destinationPortNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PacketFlowSummary_transportProtocol = INT(name=u'transportProtocol', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PacketFlowSummary_flowLabel = INT(name=u'flowLabel', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PacketFlowSummary_summaryPeriod = SEQ(name=u'summaryPeriod', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IWLANUmtsHI2Operations', 'ReportInterval')))
    _PacketFlowSummary_packetCount = INT(name=u'packetCount', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PacketFlowSummary_sumOfPacketSizes = INT(name=u'sumOfPacketSizes', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PacketFlowSummary_packetDataSummaryReason = ENUM(name=u'packetDataSummaryReason', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IWLANUmtsHI2Operations', 'ReportReason')))
    PacketFlowSummary._cont = ASN1Dict([
        (u'sourceIPAddress', _PacketFlowSummary_sourceIPAddress),
        (u'sourcePortNumber', _PacketFlowSummary_sourcePortNumber),
        (u'destinationIPAddress', _PacketFlowSummary_destinationIPAddress),
        (u'destinationPortNumber', _PacketFlowSummary_destinationPortNumber),
        (u'transportProtocol', _PacketFlowSummary_transportProtocol),
        (u'flowLabel', _PacketFlowSummary_flowLabel),
        (u'summaryPeriod', _PacketFlowSummary_summaryPeriod),
        (u'packetCount', _PacketFlowSummary_packetCount),
        (u'sumOfPacketSizes', _PacketFlowSummary_sumOfPacketSizes),
        (u'packetDataSummaryReason', _PacketFlowSummary_packetDataSummaryReason),
        ])
    PacketFlowSummary._ext = []
    
    #-----< ReportReason >-----#
    ReportReason = ENUM(name=u'ReportReason', mode=MODE_TYPE)
    ReportReason._cont = ASN1Dict([(u'timerExpired', 0), (u'countThresholdHit', 1), (u'pDPComtextDeactivated', 2), (u'pDPContextModification', 3), (u'otherOrUnknown', 4)])
    ReportReason._ext = []
    
    #-----< ReportInterval >-----#
    ReportInterval = SEQ(name=u'ReportInterval', mode=MODE_TYPE)
    _ReportInterval_firstPacketTimeStamp = CHOICE(name=u'firstPacketTimeStamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    _ReportInterval_lastPacketTimeStamp = CHOICE(name=u'lastPacketTimeStamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    ReportInterval._cont = ASN1Dict([
        (u'firstPacketTimeStamp', _ReportInterval_firstPacketTimeStamp),
        (u'lastPacketTimeStamp', _ReportInterval_lastPacketTimeStamp),
        ])
    ReportInterval._ext = []
    
    _all_ = [
        lawfulInterceptDomainId,
        threeGPPSUBDomainId,
        hi2wlanDomainId,
        _IWLANUmtsIRIsContent_iWLANumtsiRIContent,
        _IWLANUmtsIRIsContent_iWLANumtsIRISequence,
        IWLANUmtsIRIsContent,
        _IWLANUmtsIRISequence__item_,
        IWLANUmtsIRISequence,
        _IWLANUmtsIRIContent_iRI_Begin_record,
        _IWLANUmtsIRIContent_iRI_End_record,
        _IWLANUmtsIRIContent_iRI_Report_record,
        IWLANUmtsIRIContent,
        _IRI_Parameters_hi2iwlanDomainId,
        _IRI_Parameters_lawfulInterceptionIdentifier,
        _IRI_Parameters_timeStamp,
        _IRI_Parameters_initiator,
        __IRI_Parameters_partyInformation__item_,
        _IRI_Parameters_partyInformation,
        _IRI_Parameters_national_Parameters,
        _IRI_Parameters_networkIdentifier,
        _IRI_Parameters_i_WLANevent,
        _IRI_Parameters_correlationNumber,
        _IRI_Parameters_i_WLANOperationErrorCode,
        _IRI_Parameters_i_wLANinformation,
        _IRI_Parameters_visitedPLMNID,
        _IRI_Parameters_national_HI2_ASN1parameters,
        _IRI_Parameters_nSAPI,
        _IRI_Parameters_packetDataHeaderInformation,
        IRI_Parameters,
        _PartyInformation_party_Qualifier,
        __PartyInformation_partyIdentity_imsi,
        __PartyInformation_partyIdentity_msISDN,
        __PartyInformation_partyIdentity_nai,
        _PartyInformation_partyIdentity,
        _PartyInformation_services_Data_Information,
        PartyInformation,
        CorrelationNumber,
        I_WLANEvent,
        _Services_Data_Information_i_WLAN_parameters,
        Services_Data_Information,
        _I_WLAN_parameters_wlan_local_IP_address_of_the_target,
        _I_WLAN_parameters_w_APN,
        _I_WLAN_parameters_wlan_remote_IP_address_of_the_target,
        I_WLAN_parameters,
        I_WLANOperationErrorCode,
        _I_WLANinformation_wLANOperatorName,
        _I_WLANinformation_wLANLocationData,
        _I_WLANinformation_wLANLocationInformation,
        _I_WLANinformation_nASIPIPv6Address,
        _I_WLANinformation_wLANMACAddress,
        _I_WLANinformation_sessionAliveTimer,
        _I_WLANinformation_geographicalCoordinates,
        _I_WLANinformation_civicAddress,
        I_WLANinformation,
        VisitedPLMNID,
        SessionAliveTime,
        _PacketDataHeaderInformation_packetDataHeader,
        _PacketDataHeaderInformation_packetDataSummary,
        PacketDataHeaderInformation,
        _PacketDataHeaderReport_packetDataHeaderMapped,
        _PacketDataHeaderReport_packetDataHeaderCopy,
        PacketDataHeaderReport,
        _PacketDataHeaderMapped_sourceIPAddress,
        _PacketDataHeaderMapped_sourcePortNumber,
        _PacketDataHeaderMapped_destinationIPAddress,
        _PacketDataHeaderMapped_destinationPortNumber,
        _PacketDataHeaderMapped_transportProtocol,
        _PacketDataHeaderMapped_packetsize,
        _PacketDataHeaderMapped_flowLabel,
        _PacketDataHeaderMapped_packetCount,
        _PacketDataHeaderMapped_direction,
        PacketDataHeaderMapped,
        TPDU_direction,
        _PacketDataHeaderCopy_direction,
        _PacketDataHeaderCopy_headerCopy,
        PacketDataHeaderCopy,
        _PacketDataSummaryReport__item_,
        PacketDataSummaryReport,
        _PacketFlowSummary_sourceIPAddress,
        _PacketFlowSummary_sourcePortNumber,
        _PacketFlowSummary_destinationIPAddress,
        _PacketFlowSummary_destinationPortNumber,
        _PacketFlowSummary_transportProtocol,
        _PacketFlowSummary_flowLabel,
        _PacketFlowSummary_summaryPeriod,
        _PacketFlowSummary_packetCount,
        _PacketFlowSummary_sumOfPacketSizes,
        _PacketFlowSummary_packetDataSummaryReason,
        PacketFlowSummary,
        ReportReason,
        _ReportInterval_firstPacketTimeStamp,
        _ReportInterval_lastPacketTimeStamp,
        ReportInterval,
    ]

class MBMSUmtsHI2Operations:

    _name_  = u'MBMSUmtsHI2Operations'
    _oid_   = [0, 4, 0, 2, 2, 4, 7, 16, 0]
    
    _obj_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi2mbmsDomainId',
        u'MBMSUmtsIRIsContent',
        u'MBMSUmtsIRISequence',
        u'MBMSUmtsIRIContent',
        u'IRI-Parameters',
        u'PartyInformation',
        u'CorrelationNumber',
        u'MBMSEvent',
        u'Services-Data-Information',
        u'MBMSparameters',
        u'MBMSinformation',
        u'MBMSSerSubscriberList',
        u'MBMSNodeList',
        u'VisitedPLMNID',
        ]
    _type_ = [
        u'MBMSUmtsIRIsContent',
        u'MBMSUmtsIRISequence',
        u'MBMSUmtsIRIContent',
        u'IRI-Parameters',
        u'PartyInformation',
        u'CorrelationNumber',
        u'MBMSEvent',
        u'Services-Data-Information',
        u'MBMSparameters',
        u'MBMSinformation',
        u'MBMSSerSubscriberList',
        u'MBMSNodeList',
        u'VisitedPLMNID',
        ]
    _set_ = [
        ]
    _val_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi2mbmsDomainId',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< lawfulInterceptDomainId >-----#
    lawfulInterceptDomainId = OID(name=u'lawfulInterceptDomainId', mode=MODE_VALUE)
    lawfulInterceptDomainId._val = (0, 4, 0, 2, 2)
    
    #-----< threeGPPSUBDomainId >-----#
    threeGPPSUBDomainId = OID(name=u'threeGPPSUBDomainId', mode=MODE_VALUE)
    threeGPPSUBDomainId._val = (0, 4, 0, 2, 2, 4)
    
    #-----< hi2mbmsDomainId >-----#
    hi2mbmsDomainId = OID(name=u'hi2mbmsDomainId', mode=MODE_VALUE)
    hi2mbmsDomainId._val = (0, 4, 0, 2, 2, 4, 7, 16, 0)
    
    #-----< MBMSUmtsIRIsContent >-----#
    MBMSUmtsIRIsContent = CHOICE(name=u'MBMSUmtsIRIsContent', mode=MODE_TYPE)
    _MBMSUmtsIRIsContent_mBMSumtsiRIContent = CHOICE(name=u'mBMSumtsiRIContent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MBMSUmtsHI2Operations', 'MBMSUmtsIRIContent')))
    _MBMSUmtsIRIsContent_mBMSumtsIRISequence = SEQ_OF(name=u'mBMSumtsIRISequence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MBMSUmtsHI2Operations', 'MBMSUmtsIRISequence')))
    MBMSUmtsIRIsContent._cont = ASN1Dict([
        (u'mBMSumtsiRIContent', _MBMSUmtsIRIsContent_mBMSumtsiRIContent),
        (u'mBMSumtsIRISequence', _MBMSUmtsIRIsContent_mBMSumtsIRISequence),
        ])
    MBMSUmtsIRIsContent._ext = None
    
    #-----< MBMSUmtsIRISequence >-----#
    MBMSUmtsIRISequence = SEQ_OF(name=u'MBMSUmtsIRISequence', mode=MODE_TYPE)
    _MBMSUmtsIRISequence__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MBMSUmtsHI2Operations', 'MBMSUmtsIRIContent')))
    MBMSUmtsIRISequence._cont = _MBMSUmtsIRISequence__item_
    
    #-----< MBMSUmtsIRIContent >-----#
    MBMSUmtsIRIContent = CHOICE(name=u'MBMSUmtsIRIContent', mode=MODE_TYPE)
    _MBMSUmtsIRIContent_iRI_Begin_record = SEQ(name=u'iRI-Begin-record', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MBMSUmtsHI2Operations', 'IRI-Parameters')))
    _MBMSUmtsIRIContent_iRI_End_record = SEQ(name=u'iRI-End-record', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MBMSUmtsHI2Operations', 'IRI-Parameters')))
    _MBMSUmtsIRIContent_iRI_Report_record = SEQ(name=u'iRI-Report-record', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MBMSUmtsHI2Operations', 'IRI-Parameters')))
    MBMSUmtsIRIContent._cont = ASN1Dict([
        (u'iRI-Begin-record', _MBMSUmtsIRIContent_iRI_Begin_record),
        (u'iRI-End-record', _MBMSUmtsIRIContent_iRI_End_record),
        (u'iRI-Report-record', _MBMSUmtsIRIContent_iRI_Report_record),
        ])
    MBMSUmtsIRIContent._ext = []
    
    #-----< IRI-Parameters >-----#
    IRI_Parameters = SEQ(name=u'IRI-Parameters', mode=MODE_TYPE)
    _IRI_Parameters_hi2mbmsDomainId = OID(name=u'hi2mbmsDomainId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IRI_Parameters_lawfulInterceptionIdentifier = OCT_STR(name=u'lawfulInterceptionIdentifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'LawfulInterceptionIdentifier')))
    _IRI_Parameters_timeStamp = CHOICE(name=u'timeStamp', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    _IRI_Parameters_initiator = ENUM(name=u'initiator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_initiator._cont = ASN1Dict([(u'not-Available', 0), (u'originating-Target', 1), (u'network-initiated', 2), (u'off-online-action', 3)])
    _IRI_Parameters_initiator._ext = []
    _IRI_Parameters_partyInformation = SET_OF(name=u'partyInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IRI_Parameters_partyInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MBMSUmtsHI2Operations', 'PartyInformation')))
    _IRI_Parameters_partyInformation._cont = __IRI_Parameters_partyInformation__item_
    _IRI_Parameters_partyInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _IRI_Parameters_national_Parameters = SET_OF(name=u'national-Parameters', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'National-Parameters')), opt=True)
    _IRI_Parameters_networkIdentifier = SEQ(name=u'networkIdentifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'Network-Identifier')), opt=True)
    _IRI_Parameters_mBMSevent = ENUM(name=u'mBMSevent', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MBMSUmtsHI2Operations', 'MBMSEvent')), opt=True)
    _IRI_Parameters_correlationNumber = OCT_STR(name=u'correlationNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MBMSUmtsHI2Operations', 'CorrelationNumber')), opt=True)
    _IRI_Parameters_mbmsInformation = SEQ(name=u'mbmsInformation', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MBMSUmtsHI2Operations', 'MBMSinformation')), opt=True)
    _IRI_Parameters_visitedPLMNID = STR_UTF8(name=u'visitedPLMNID', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MBMSUmtsHI2Operations', 'VisitedPLMNID')), opt=True)
    _IRI_Parameters_national_HI2_ASN1parameters = SEQ(name=u'national-HI2-ASN1parameters', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'National-HI2-ASN1parameters')), opt=True)
    IRI_Parameters._cont = ASN1Dict([
        (u'hi2mbmsDomainId', _IRI_Parameters_hi2mbmsDomainId),
        (u'lawfulInterceptionIdentifier', _IRI_Parameters_lawfulInterceptionIdentifier),
        (u'timeStamp', _IRI_Parameters_timeStamp),
        (u'initiator', _IRI_Parameters_initiator),
        (u'partyInformation', _IRI_Parameters_partyInformation),
        (u'national-Parameters', _IRI_Parameters_national_Parameters),
        (u'networkIdentifier', _IRI_Parameters_networkIdentifier),
        (u'mBMSevent', _IRI_Parameters_mBMSevent),
        (u'correlationNumber', _IRI_Parameters_correlationNumber),
        (u'mbmsInformation', _IRI_Parameters_mbmsInformation),
        (u'visitedPLMNID', _IRI_Parameters_visitedPLMNID),
        (u'national-HI2-ASN1parameters', _IRI_Parameters_national_HI2_ASN1parameters),
        ])
    IRI_Parameters._ext = []
    
    #-----< PartyInformation >-----#
    PartyInformation = SEQ(name=u'PartyInformation', mode=MODE_TYPE)
    _PartyInformation_party_Qualifier = ENUM(name=u'party-Qualifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PartyInformation_party_Qualifier._cont = ASN1Dict([(u'mBMS-Target', 1)])
    _PartyInformation_party_Qualifier._ext = []
    _PartyInformation_partyIdentity = SEQ(name=u'partyIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PartyInformation_partyIdentity_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_imsi._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    _PartyInformation_partyIdentity._cont = ASN1Dict([
        (u'imsi', __PartyInformation_partyIdentity_imsi),
        ])
    _PartyInformation_partyIdentity._ext = []
    PartyInformation._cont = ASN1Dict([
        (u'party-Qualifier', _PartyInformation_party_Qualifier),
        (u'partyIdentity', _PartyInformation_partyIdentity),
        ])
    PartyInformation._ext = []
    
    #-----< CorrelationNumber >-----#
    CorrelationNumber = OCT_STR(name=u'CorrelationNumber', mode=MODE_TYPE)
    CorrelationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=20)], ev=None, er=[])
    
    #-----< MBMSEvent >-----#
    MBMSEvent = ENUM(name=u'MBMSEvent', mode=MODE_TYPE)
    MBMSEvent._cont = ASN1Dict([(u'mBMSServiceJoining', 1), (u'mBMSServiceLeaving', 2), (u'mBMSSubscriptionActivation', 3), (u'mBMSSubscriptionModification', 4), (u'mBMSSubscriptionTermination', 5), (u'startofInterceptWithMBMSServiceActive', 6)])
    MBMSEvent._ext = []
    
    #-----< Services-Data-Information >-----#
    Services_Data_Information = SEQ(name=u'Services-Data-Information', mode=MODE_TYPE)
    _Services_Data_Information_mBMSparameters = SEQ(name=u'mBMSparameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MBMSUmtsHI2Operations', 'MBMSparameters')), opt=True)
    Services_Data_Information._cont = ASN1Dict([
        (u'mBMSparameters', _Services_Data_Information_mBMSparameters),
        ])
    Services_Data_Information._ext = []
    
    #-----< MBMSparameters >-----#
    MBMSparameters = SEQ(name=u'MBMSparameters', mode=MODE_TYPE)
    _MBMSparameters_aPN = STR_UTF8(name=u'aPN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    MBMSparameters._cont = ASN1Dict([
        (u'aPN', _MBMSparameters_aPN),
        ])
    MBMSparameters._ext = []
    
    #-----< MBMSinformation >-----#
    MBMSinformation = SEQ(name=u'MBMSinformation', mode=MODE_TYPE)
    _MBMSinformation_mbmsServiceName = STR_UTF8(name=u'mbmsServiceName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MBMSinformation_mbms_join_time = STR_UTF8(name=u'mbms-join-time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MBMSinformation_mbms_Mode = ENUM(name=u'mbms-Mode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MBMSinformation_mbms_Mode._cont = ASN1Dict([(u'multicast', 0), (u'broadcast', 1)])
    _MBMSinformation_mbms_Mode._ext = []
    _MBMSinformation_mbmsIPIPv6Address = SEQ(name=u'mbmsIPIPv6Address', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IPAddress')), opt=True)
    _MBMSinformation_mbmsLeavingReason = ENUM(name=u'mbmsLeavingReason', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MBMSinformation_mbmsLeavingReason._cont = ASN1Dict([(u'uEinitiatedRequested', 0), (u'bMSCorNetworkTerminated', 1)])
    _MBMSinformation_mbmsLeavingReason._ext = []
    _MBMSinformation_mbmsSubsTermReason = ENUM(name=u'mbmsSubsTermReason', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MBMSinformation_mbmsSubsTermReason._cont = ASN1Dict([(u'userInitiated', 0), (u'subscriptionExpired', 1)])
    _MBMSinformation_mbmsSubsTermReason._ext = []
    _MBMSinformation_mBMSapn = STR_UTF8(name=u'mBMSapn', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MBMSinformation_mbmsSerSubscriberList = SEQ_OF(name=u'mbmsSerSubscriberList', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MBMSUmtsHI2Operations', 'MBMSSerSubscriberList')), opt=True)
    _MBMSinformation_mbmsNodeList = SEQ_OF(name=u'mbmsNodeList', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MBMSUmtsHI2Operations', 'MBMSNodeList')), opt=True)
    MBMSinformation._cont = ASN1Dict([
        (u'mbmsServiceName', _MBMSinformation_mbmsServiceName),
        (u'mbms-join-time', _MBMSinformation_mbms_join_time),
        (u'mbms-Mode', _MBMSinformation_mbms_Mode),
        (u'mbmsIPIPv6Address', _MBMSinformation_mbmsIPIPv6Address),
        (u'mbmsLeavingReason', _MBMSinformation_mbmsLeavingReason),
        (u'mbmsSubsTermReason', _MBMSinformation_mbmsSubsTermReason),
        (u'mBMSapn', _MBMSinformation_mBMSapn),
        (u'mbmsSerSubscriberList', _MBMSinformation_mbmsSerSubscriberList),
        (u'mbmsNodeList', _MBMSinformation_mbmsNodeList),
        ])
    MBMSinformation._ext = []
    
    #-----< MBMSSerSubscriberList >-----#
    MBMSSerSubscriberList = SEQ_OF(name=u'MBMSSerSubscriberList', mode=MODE_TYPE)
    _MBMSSerSubscriberList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __MBMSSerSubscriberList__item__mBMSSERSUBSCRIBERLIST = STR_UTF8(name=u'mBMSSERSUBSCRIBERLIST', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MBMSSerSubscriberList__item_._cont = ASN1Dict([
        (u'mBMSSERSUBSCRIBERLIST', __MBMSSerSubscriberList__item__mBMSSERSUBSCRIBERLIST),
        ])
    _MBMSSerSubscriberList__item_._ext = []
    MBMSSerSubscriberList._cont = _MBMSSerSubscriberList__item_
    
    #-----< MBMSNodeList >-----#
    MBMSNodeList = SEQ_OF(name=u'MBMSNodeList', mode=MODE_TYPE)
    _MBMSNodeList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __MBMSNodeList__item__mBMSNODELIST = SEQ(name=u'mBMSNODELIST', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MBMSNodeList__item__mBMSNODELIST_mbmsnodeIPAdress = SEQ(name=u'mbmsnodeIPAdress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IPAddress')), opt=True)
    ___MBMSNodeList__item__mBMSNODELIST_mbmsnodeName = STR_UTF8(name=u'mbmsnodeName', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MBMSNodeList__item__mBMSNODELIST._cont = ASN1Dict([
        (u'mbmsnodeIPAdress', ___MBMSNodeList__item__mBMSNODELIST_mbmsnodeIPAdress),
        (u'mbmsnodeName', ___MBMSNodeList__item__mBMSNODELIST_mbmsnodeName),
        ])
    __MBMSNodeList__item__mBMSNODELIST._ext = []
    _MBMSNodeList__item_._cont = ASN1Dict([
        (u'mBMSNODELIST', __MBMSNodeList__item__mBMSNODELIST),
        ])
    _MBMSNodeList__item_._ext = []
    MBMSNodeList._cont = _MBMSNodeList__item_
    
    #-----< VisitedPLMNID >-----#
    VisitedPLMNID = STR_UTF8(name=u'VisitedPLMNID', mode=MODE_TYPE)
    
    _all_ = [
        lawfulInterceptDomainId,
        threeGPPSUBDomainId,
        hi2mbmsDomainId,
        _MBMSUmtsIRIsContent_mBMSumtsiRIContent,
        _MBMSUmtsIRIsContent_mBMSumtsIRISequence,
        MBMSUmtsIRIsContent,
        _MBMSUmtsIRISequence__item_,
        MBMSUmtsIRISequence,
        _MBMSUmtsIRIContent_iRI_Begin_record,
        _MBMSUmtsIRIContent_iRI_End_record,
        _MBMSUmtsIRIContent_iRI_Report_record,
        MBMSUmtsIRIContent,
        _IRI_Parameters_hi2mbmsDomainId,
        _IRI_Parameters_lawfulInterceptionIdentifier,
        _IRI_Parameters_timeStamp,
        _IRI_Parameters_initiator,
        __IRI_Parameters_partyInformation__item_,
        _IRI_Parameters_partyInformation,
        _IRI_Parameters_national_Parameters,
        _IRI_Parameters_networkIdentifier,
        _IRI_Parameters_mBMSevent,
        _IRI_Parameters_correlationNumber,
        _IRI_Parameters_mbmsInformation,
        _IRI_Parameters_visitedPLMNID,
        _IRI_Parameters_national_HI2_ASN1parameters,
        IRI_Parameters,
        _PartyInformation_party_Qualifier,
        __PartyInformation_partyIdentity_imsi,
        _PartyInformation_partyIdentity,
        PartyInformation,
        CorrelationNumber,
        MBMSEvent,
        _Services_Data_Information_mBMSparameters,
        Services_Data_Information,
        _MBMSparameters_aPN,
        MBMSparameters,
        _MBMSinformation_mbmsServiceName,
        _MBMSinformation_mbms_join_time,
        _MBMSinformation_mbms_Mode,
        _MBMSinformation_mbmsIPIPv6Address,
        _MBMSinformation_mbmsLeavingReason,
        _MBMSinformation_mbmsSubsTermReason,
        _MBMSinformation_mBMSapn,
        _MBMSinformation_mbmsSerSubscriberList,
        _MBMSinformation_mbmsNodeList,
        MBMSinformation,
        __MBMSSerSubscriberList__item__mBMSSERSUBSCRIBERLIST,
        _MBMSSerSubscriberList__item_,
        MBMSSerSubscriberList,
        ___MBMSNodeList__item__mBMSNODELIST_mbmsnodeIPAdress,
        ___MBMSNodeList__item__mBMSNODELIST_mbmsnodeName,
        __MBMSNodeList__item__mBMSNODELIST,
        _MBMSNodeList__item_,
        MBMSNodeList,
        VisitedPLMNID,
    ]

class Mms_HI3_PS:

    _name_  = u'Mms-HI3-PS'
    _oid_   = [0, 4, 0, 2, 2, 4, 17, 16, 0]
    
    _obj_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi3DomainId',
        u'CC-PDU',
        u'MMSLIC-header',
        u'TPDU-direction',
        u'National-HI3-ASN1parameters',
        u'ICE-type',
        ]
    _type_ = [
        u'CC-PDU',
        u'MMSLIC-header',
        u'TPDU-direction',
        u'National-HI3-ASN1parameters',
        u'ICE-type',
        ]
    _set_ = [
        ]
    _val_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi3DomainId',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< lawfulInterceptDomainId >-----#
    lawfulInterceptDomainId = OID(name=u'lawfulInterceptDomainId', mode=MODE_VALUE)
    lawfulInterceptDomainId._val = (0, 4, 0, 2, 2)
    
    #-----< threeGPPSUBDomainId >-----#
    threeGPPSUBDomainId = OID(name=u'threeGPPSUBDomainId', mode=MODE_VALUE)
    threeGPPSUBDomainId._val = (0, 4, 0, 2, 2, 4)
    
    #-----< hi3DomainId >-----#
    hi3DomainId = OID(name=u'hi3DomainId', mode=MODE_VALUE)
    hi3DomainId._val = (0, 4, 0, 2, 2, 4, 17, 16, 0)
    
    #-----< CC-PDU >-----#
    CC_PDU = SEQ(name=u'CC-PDU', mode=MODE_TYPE)
    _CC_PDU_mmSLIC_header = SEQ(name=u'mmSLIC-header', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Mms-HI3-PS', 'MMSLIC-header')))
    _CC_PDU_payload = OCT_STR(name=u'payload', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    CC_PDU._cont = ASN1Dict([
        (u'mmSLIC-header', _CC_PDU_mmSLIC_header),
        (u'payload', _CC_PDU_payload),
        ])
    CC_PDU._ext = None
    
    #-----< MMSLIC-header >-----#
    MMSLIC_header = SEQ(name=u'MMSLIC-header', mode=MODE_TYPE)
    _MMSLIC_header_hi3MmsDomainId = OID(name=u'hi3MmsDomainId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMSLIC_header_lIID = OCT_STR(name=u'lIID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'LawfulInterceptionIdentifier')), opt=True)
    _MMSLIC_header_mMSCorrelationNNumber = OCT_STR(name=u'mMSCorrelationNNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'MMSCorrelationNumber')))
    _MMSLIC_header_timeStamp = CHOICE(name=u'timeStamp', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    _MMSLIC_header_t_PDU_direction = ENUM(name=u't-PDU-direction', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Mms-HI3-PS', 'TPDU-direction')))
    _MMSLIC_header_mMSVersion = INT(name=u'mMSVersion', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMSLIC_header_transactionID = STR_UTF8(name=u'transactionID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMSLIC_header_national_HI3_ASN1parameters = SEQ(name=u'national-HI3-ASN1parameters', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Mms-HI3-PS', 'National-HI3-ASN1parameters')), opt=True)
    _MMSLIC_header_ice_type = ENUM(name=u'ice-type', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Mms-HI3-PS', 'ICE-type')), opt=True)
    MMSLIC_header._cont = ASN1Dict([
        (u'hi3MmsDomainId', _MMSLIC_header_hi3MmsDomainId),
        (u'lIID', _MMSLIC_header_lIID),
        (u'mMSCorrelationNNumber', _MMSLIC_header_mMSCorrelationNNumber),
        (u'timeStamp', _MMSLIC_header_timeStamp),
        (u't-PDU-direction', _MMSLIC_header_t_PDU_direction),
        (u'mMSVersion', _MMSLIC_header_mMSVersion),
        (u'transactionID', _MMSLIC_header_transactionID),
        (u'national-HI3-ASN1parameters', _MMSLIC_header_national_HI3_ASN1parameters),
        (u'ice-type', _MMSLIC_header_ice_type),
        ])
    MMSLIC_header._ext = []
    
    #-----< TPDU-direction >-----#
    TPDU_direction = ENUM(name=u'TPDU-direction', mode=MODE_TYPE)
    TPDU_direction._cont = ASN1Dict([(u'from-target', 1), (u'to-target', 2), (u'unknown', 3)])
    TPDU_direction._ext = None
    
    #-----< National-HI3-ASN1parameters >-----#
    National_HI3_ASN1parameters = SEQ(name=u'National-HI3-ASN1parameters', mode=MODE_TYPE)
    _National_HI3_ASN1parameters_countryCode = STR_PRINT(name=u'countryCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _National_HI3_ASN1parameters_countryCode._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    National_HI3_ASN1parameters._cont = ASN1Dict([
        (u'countryCode', _National_HI3_ASN1parameters_countryCode),
        ])
    National_HI3_ASN1parameters._ext = []
    
    #-----< ICE-type >-----#
    ICE_type = ENUM(name=u'ICE-type', mode=MODE_TYPE)
    ICE_type._cont = ASN1Dict([(u'mMSC', 1), (u'mMSProxyRelay', 2)])
    ICE_type._ext = []
    
    _all_ = [
        lawfulInterceptDomainId,
        threeGPPSUBDomainId,
        hi3DomainId,
        _CC_PDU_mmSLIC_header,
        _CC_PDU_payload,
        CC_PDU,
        _MMSLIC_header_hi3MmsDomainId,
        _MMSLIC_header_lIID,
        _MMSLIC_header_mMSCorrelationNNumber,
        _MMSLIC_header_timeStamp,
        _MMSLIC_header_t_PDU_direction,
        _MMSLIC_header_mMSVersion,
        _MMSLIC_header_transactionID,
        _MMSLIC_header_national_HI3_ASN1parameters,
        _MMSLIC_header_ice_type,
        MMSLIC_header,
        TPDU_direction,
        _National_HI3_ASN1parameters_countryCode,
        National_HI3_ASN1parameters,
        ICE_type,
    ]

class MmsHI2Operations:

    _name_  = u'MmsHI2Operations'
    _oid_   = [0, 4, 0, 2, 2, 4, 16, 16, 0]
    
    _obj_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi2mmsDomainId',
        u'MmsIRIsContent',
        u'MmsIRISequence',
        u'MmsIRIContent',
        u'IRI-Parameters',
        u'PartyInformation',
        u'Address',
        u'Addresses',
        u'ClassIdentifier',
        u'ContentClass',
        u'ContentLocation',
        u'ElementDescriptor',
        u'EncodedString',
        u'EncodedTextString',
        u'From',
        u'FromAddresses',
        u'MessageClass',
        u'MMBoxDescriptionPdus',
        u'MMFlags',
        u'MMSAttributes',
        u'MMSCorrelationNumber',
        u'MMSEvent',
        u'MMSParties',
        u'MMSState',
        u'MMSStatus',
        u'ParameterName',
        u'ParameterValue',
        u'PreviouslySentBy',
        u'PreviouslySentByDateTime',
        u'Priority',
        u'ResponseStatus',
        u'ResponseStatusText',
        u'ActualResponseStatus',
        u'StoreStatus',
        u'TokenAction',
        u'YesNo',
        ]
    _type_ = [
        u'MmsIRIsContent',
        u'MmsIRISequence',
        u'MmsIRIContent',
        u'IRI-Parameters',
        u'PartyInformation',
        u'Address',
        u'Addresses',
        u'ClassIdentifier',
        u'ContentClass',
        u'ContentLocation',
        u'ElementDescriptor',
        u'EncodedString',
        u'EncodedTextString',
        u'From',
        u'FromAddresses',
        u'MessageClass',
        u'MMBoxDescriptionPdus',
        u'MMFlags',
        u'MMSAttributes',
        u'MMSCorrelationNumber',
        u'MMSEvent',
        u'MMSParties',
        u'MMSState',
        u'MMSStatus',
        u'ParameterName',
        u'ParameterValue',
        u'PreviouslySentBy',
        u'PreviouslySentByDateTime',
        u'Priority',
        u'ResponseStatus',
        u'ResponseStatusText',
        u'ActualResponseStatus',
        u'StoreStatus',
        u'TokenAction',
        u'YesNo',
        ]
    _set_ = [
        ]
    _val_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi2mmsDomainId',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< lawfulInterceptDomainId >-----#
    lawfulInterceptDomainId = OID(name=u'lawfulInterceptDomainId', mode=MODE_VALUE)
    lawfulInterceptDomainId._val = (0, 4, 0, 2, 2)
    
    #-----< threeGPPSUBDomainId >-----#
    threeGPPSUBDomainId = OID(name=u'threeGPPSUBDomainId', mode=MODE_VALUE)
    threeGPPSUBDomainId._val = (0, 4, 0, 2, 2, 4)
    
    #-----< hi2mmsDomainId >-----#
    hi2mmsDomainId = OID(name=u'hi2mmsDomainId', mode=MODE_VALUE)
    hi2mmsDomainId._val = (0, 4, 0, 2, 2, 4, 16, 16, 0)
    
    #-----< MmsIRIsContent >-----#
    MmsIRIsContent = CHOICE(name=u'MmsIRIsContent', mode=MODE_TYPE)
    _MmsIRIsContent_mmsiRIContent = CHOICE(name=u'mmsiRIContent', mode=MODE_TYPE, typeref=ASN1RefType(('MmsHI2Operations', 'MmsIRIContent')))
    _MmsIRIsContent_mmsIRISequence = SEQ_OF(name=u'mmsIRISequence', mode=MODE_TYPE, typeref=ASN1RefType(('MmsHI2Operations', 'MmsIRISequence')))
    MmsIRIsContent._cont = ASN1Dict([
        (u'mmsiRIContent', _MmsIRIsContent_mmsiRIContent),
        (u'mmsIRISequence', _MmsIRIsContent_mmsIRISequence),
        ])
    MmsIRIsContent._ext = None
    
    #-----< MmsIRISequence >-----#
    MmsIRISequence = SEQ_OF(name=u'MmsIRISequence', mode=MODE_TYPE)
    _MmsIRISequence__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MmsHI2Operations', 'MmsIRIContent')))
    MmsIRISequence._cont = _MmsIRISequence__item_
    
    #-----< MmsIRIContent >-----#
    MmsIRIContent = CHOICE(name=u'MmsIRIContent', mode=MODE_TYPE)
    _MmsIRIContent_iRI_Begin_record = SEQ(name=u'iRI-Begin-record', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'IRI-Parameters')))
    _MmsIRIContent_iRI_End_record = SEQ(name=u'iRI-End-record', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'IRI-Parameters')))
    _MmsIRIContent_iRI_Continue_record = SEQ(name=u'iRI-Continue-record', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'IRI-Parameters')))
    _MmsIRIContent_iRI_Report_record = SEQ(name=u'iRI-Report-record', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'IRI-Parameters')))
    MmsIRIContent._cont = ASN1Dict([
        (u'iRI-Begin-record', _MmsIRIContent_iRI_Begin_record),
        (u'iRI-End-record', _MmsIRIContent_iRI_End_record),
        (u'iRI-Continue-record', _MmsIRIContent_iRI_Continue_record),
        (u'iRI-Report-record', _MmsIRIContent_iRI_Report_record),
        ])
    MmsIRIContent._ext = None
    
    #-----< IRI-Parameters >-----#
    IRI_Parameters = SEQ(name=u'IRI-Parameters', mode=MODE_TYPE)
    _IRI_Parameters_hi2mmsDomainId = OID(name=u'hi2mmsDomainId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IRI_Parameters_lawfulInterceptionIdentifier = OCT_STR(name=u'lawfulInterceptionIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'LawfulInterceptionIdentifier')))
    _IRI_Parameters_timeStamp = CHOICE(name=u'timeStamp', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    _IRI_Parameters_locationOfTheTarget = SEQ(name=u'locationOfTheTarget', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'Location')), opt=True)
    _IRI_Parameters_partyInformation = SET_OF(name=u'partyInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IRI_Parameters_partyInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MmsHI2Operations', 'PartyInformation')))
    _IRI_Parameters_partyInformation._cont = __IRI_Parameters_partyInformation__item_
    _IRI_Parameters_partyInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _IRI_Parameters_mMSevent = ENUM(name=u'mMSevent', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'MMSEvent')), opt=True)
    _IRI_Parameters_serviceCenterAddress = SEQ(name=u'serviceCenterAddress', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'PartyInformation')), opt=True)
    _IRI_Parameters_mMSParties = SEQ(name=u'mMSParties', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'MMSParties')), opt=True)
    _IRI_Parameters_mMSVersion = INT(name=u'mMSVersion', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_transactionID = STR_UTF8(name=u'transactionID', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_messageID = STR_UTF8(name=u'messageID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_mMSDateTime = TIME_GEN(name=u'mMSDateTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_messageClass = CHOICE(name=u'messageClass', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'MessageClass')), opt=True)
    _IRI_Parameters_expiry = TIME_GEN(name=u'expiry', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_distributionIndicator = BOOL(name=u'distributionIndicator', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'YesNo')), opt=True)
    _IRI_Parameters_elementDescriptor = SEQ(name=u'elementDescriptor', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'ElementDescriptor')), opt=True)
    _IRI_Parameters_retrievalMode = BOOL(name=u'retrievalMode', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'YesNo')), opt=True)
    _IRI_Parameters_retrievalModeText = CHOICE(name=u'retrievalModeText', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'EncodedString')), opt=True)
    _IRI_Parameters_senderVisibility = BOOL(name=u'senderVisibility', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'YesNo')), opt=True)
    _IRI_Parameters_deliveryReport = BOOL(name=u'deliveryReport', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'YesNo')), opt=True)
    _IRI_Parameters_readReport = BOOL(name=u'readReport', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'YesNo')), opt=True)
    _IRI_Parameters_applicID = STR_UTF8(name=u'applicID', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_replyApplicID = STR_UTF8(name=u'replyApplicID', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_auxApplicInfo = STR_UTF8(name=u'auxApplicInfo', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_contentClass = ENUM(name=u'contentClass', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'ContentClass')), opt=True)
    _IRI_Parameters_dRMContent = BOOL(name=u'dRMContent', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'YesNo')), opt=True)
    _IRI_Parameters_replaceID = STR_UTF8(name=u'replaceID', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_contentLocation = SEQ(name=u'contentLocation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'ContentLocation')), opt=True)
    _IRI_Parameters_mMSStatus = ENUM(name=u'mMSStatus', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'MMSStatus')), opt=True)
    _IRI_Parameters_reportAllowed = BOOL(name=u'reportAllowed', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'YesNo')), opt=True)
    _IRI_Parameters_previouslySentBy = SEQ(name=u'previouslySentBy', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'PreviouslySentBy')), opt=True)
    _IRI_Parameters_previouslySentByDateTime = SEQ(name=u'previouslySentByDateTime', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'PreviouslySentByDateTime')), opt=True)
    _IRI_Parameters_mMState = ENUM(name=u'mMState', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'MMSState')), opt=True)
    _IRI_Parameters_desiredDeliveryTime = TIME_GEN(name=u'desiredDeliveryTime', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_deliveryReportAllowed = BOOL(name=u'deliveryReportAllowed', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'YesNo')), opt=True)
    _IRI_Parameters_store = BOOL(name=u'store', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'YesNo')), opt=True)
    _IRI_Parameters_responseStatus = SEQ(name=u'responseStatus', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'ResponseStatus')), opt=True)
    _IRI_Parameters_responseStatusText = SEQ(name=u'responseStatusText', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'ResponseStatusText')), opt=True)
    _IRI_Parameters_storeStatus = ENUM(name=u'storeStatus', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'StoreStatus')), opt=True)
    _IRI_Parameters_storeStatusText = CHOICE(name=u'storeStatusText', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'EncodedString')), opt=True)
    _IRI_Parameters_mMFlags = SEQ(name=u'mMFlags', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'MMFlags')), opt=True)
    _IRI_Parameters_mMBoxDescriptionPdus = SEQ_OF(name=u'mMBoxDescriptionPdus', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IRI_Parameters_mMBoxDescriptionPdus__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MmsHI2Operations', 'MMBoxDescriptionPdus')))
    _IRI_Parameters_mMBoxDescriptionPdus._cont = __IRI_Parameters_mMBoxDescriptionPdus__item_
    _IRI_Parameters_cancelID = STR_UTF8(name=u'cancelID', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_cancelStatus = BOOL(name=u'cancelStatus', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'YesNo')), opt=True)
    _IRI_Parameters_mMSStart = INT(name=u'mMSStart', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_mMSLimit = INT(name=u'mMSLimit', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_mMSAttributes = CHOICE(name=u'mMSAttributes', mode=MODE_TYPE, tag=(49, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'MMSAttributes')), opt=True)
    _IRI_Parameters_mMSTotals = BOOL(name=u'mMSTotals', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'YesNo')), opt=True)
    _IRI_Parameters_mMSQuotas = BOOL(name=u'mMSQuotas', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'YesNo')), opt=True)
    _IRI_Parameters_mMSMessageCount = INT(name=u'mMSMessageCount', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_messageSize = INT(name=u'messageSize', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_mMSForwardReqDateTime = TIME_GEN(name=u'mMSForwardReqDateTime', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_adaptationAllowed = BOOL(name=u'adaptationAllowed', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'YesNo')), opt=True)
    _IRI_Parameters_priority = ENUM(name=u'priority', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'Priority')), opt=True)
    _IRI_Parameters_mMSCorrelationNumber = OCT_STR(name=u'mMSCorrelationNumber', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'MMSCorrelationNumber')), opt=True)
    _IRI_Parameters_contentType = OCT_STR(name=u'contentType', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_national_Parameters = SET_OF(name=u'national-Parameters', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'National-Parameters')), opt=True)
    IRI_Parameters._cont = ASN1Dict([
        (u'hi2mmsDomainId', _IRI_Parameters_hi2mmsDomainId),
        (u'lawfulInterceptionIdentifier', _IRI_Parameters_lawfulInterceptionIdentifier),
        (u'timeStamp', _IRI_Parameters_timeStamp),
        (u'locationOfTheTarget', _IRI_Parameters_locationOfTheTarget),
        (u'partyInformation', _IRI_Parameters_partyInformation),
        (u'mMSevent', _IRI_Parameters_mMSevent),
        (u'serviceCenterAddress', _IRI_Parameters_serviceCenterAddress),
        (u'mMSParties', _IRI_Parameters_mMSParties),
        (u'mMSVersion', _IRI_Parameters_mMSVersion),
        (u'transactionID', _IRI_Parameters_transactionID),
        (u'messageID', _IRI_Parameters_messageID),
        (u'mMSDateTime', _IRI_Parameters_mMSDateTime),
        (u'messageClass', _IRI_Parameters_messageClass),
        (u'expiry', _IRI_Parameters_expiry),
        (u'distributionIndicator', _IRI_Parameters_distributionIndicator),
        (u'elementDescriptor', _IRI_Parameters_elementDescriptor),
        (u'retrievalMode', _IRI_Parameters_retrievalMode),
        (u'retrievalModeText', _IRI_Parameters_retrievalModeText),
        (u'senderVisibility', _IRI_Parameters_senderVisibility),
        (u'deliveryReport', _IRI_Parameters_deliveryReport),
        (u'readReport', _IRI_Parameters_readReport),
        (u'applicID', _IRI_Parameters_applicID),
        (u'replyApplicID', _IRI_Parameters_replyApplicID),
        (u'auxApplicInfo', _IRI_Parameters_auxApplicInfo),
        (u'contentClass', _IRI_Parameters_contentClass),
        (u'dRMContent', _IRI_Parameters_dRMContent),
        (u'replaceID', _IRI_Parameters_replaceID),
        (u'contentLocation', _IRI_Parameters_contentLocation),
        (u'mMSStatus', _IRI_Parameters_mMSStatus),
        (u'reportAllowed', _IRI_Parameters_reportAllowed),
        (u'previouslySentBy', _IRI_Parameters_previouslySentBy),
        (u'previouslySentByDateTime', _IRI_Parameters_previouslySentByDateTime),
        (u'mMState', _IRI_Parameters_mMState),
        (u'desiredDeliveryTime', _IRI_Parameters_desiredDeliveryTime),
        (u'deliveryReportAllowed', _IRI_Parameters_deliveryReportAllowed),
        (u'store', _IRI_Parameters_store),
        (u'responseStatus', _IRI_Parameters_responseStatus),
        (u'responseStatusText', _IRI_Parameters_responseStatusText),
        (u'storeStatus', _IRI_Parameters_storeStatus),
        (u'storeStatusText', _IRI_Parameters_storeStatusText),
        (u'mMFlags', _IRI_Parameters_mMFlags),
        (u'mMBoxDescriptionPdus', _IRI_Parameters_mMBoxDescriptionPdus),
        (u'cancelID', _IRI_Parameters_cancelID),
        (u'cancelStatus', _IRI_Parameters_cancelStatus),
        (u'mMSStart', _IRI_Parameters_mMSStart),
        (u'mMSLimit', _IRI_Parameters_mMSLimit),
        (u'mMSAttributes', _IRI_Parameters_mMSAttributes),
        (u'mMSTotals', _IRI_Parameters_mMSTotals),
        (u'mMSQuotas', _IRI_Parameters_mMSQuotas),
        (u'mMSMessageCount', _IRI_Parameters_mMSMessageCount),
        (u'messageSize', _IRI_Parameters_messageSize),
        (u'mMSForwardReqDateTime', _IRI_Parameters_mMSForwardReqDateTime),
        (u'adaptationAllowed', _IRI_Parameters_adaptationAllowed),
        (u'priority', _IRI_Parameters_priority),
        (u'mMSCorrelationNumber', _IRI_Parameters_mMSCorrelationNumber),
        (u'contentType', _IRI_Parameters_contentType),
        (u'national-Parameters', _IRI_Parameters_national_Parameters),
        ])
    IRI_Parameters._ext = None
    
    #-----< PartyInformation >-----#
    PartyInformation = SEQ(name=u'PartyInformation', mode=MODE_TYPE)
    _PartyInformation_party_Qualifier = ENUM(name=u'party-Qualifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PartyInformation_party_Qualifier._cont = ASN1Dict([(u'mMS-Target', 1)])
    _PartyInformation_party_Qualifier._ext = []
    _PartyInformation_partyIdentity = SEQ(name=u'partyIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PartyInformation_partyIdentity_mSISDN = OCT_STR(name=u'mSISDN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_mMSAddress = OCT_STR(name=u'mMSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_mMSAddressNonLocalID = OCT_STR(name=u'mMSAddressNonLocalID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_e_Mail = OCT_STR(name=u'e-Mail', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_e164_Format = OCT_STR(name=u'e164-Format', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_e164_Format._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=25)], ev=None, er=[])
    __PartyInformation_partyIdentity_iPAddress = SEQ(name=u'iPAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IPAddress')), opt=True)
    __PartyInformation_partyIdentity_alphanum_Shortcode = OCT_STR(name=u'alphanum-Shortcode', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_num_Shortcode = OCT_STR(name=u'num-Shortcode', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PartyInformation_partyIdentity._cont = ASN1Dict([
        (u'mSISDN', __PartyInformation_partyIdentity_mSISDN),
        (u'mMSAddress', __PartyInformation_partyIdentity_mMSAddress),
        (u'mMSAddressNonLocalID', __PartyInformation_partyIdentity_mMSAddressNonLocalID),
        (u'e-Mail', __PartyInformation_partyIdentity_e_Mail),
        (u'e164-Format', __PartyInformation_partyIdentity_e164_Format),
        (u'iPAddress', __PartyInformation_partyIdentity_iPAddress),
        (u'alphanum-Shortcode', __PartyInformation_partyIdentity_alphanum_Shortcode),
        (u'num-Shortcode', __PartyInformation_partyIdentity_num_Shortcode),
        (u'iMSI', __PartyInformation_partyIdentity_iMSI),
        ])
    _PartyInformation_partyIdentity._ext = []
    PartyInformation._cont = ASN1Dict([
        (u'party-Qualifier', _PartyInformation_party_Qualifier),
        (u'partyIdentity', _PartyInformation_partyIdentity),
        ])
    PartyInformation._ext = []
    
    #-----< Address >-----#
    Address = CHOICE(name=u'Address', mode=MODE_TYPE, typeref=ASN1RefType(('MmsHI2Operations', 'EncodedString')))
    
    #-----< Addresses >-----#
    Addresses = SEQ_OF(name=u'Addresses', mode=MODE_TYPE)
    _Addresses__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MmsHI2Operations', 'Address')))
    Addresses._cont = _Addresses__item_
    
    #-----< ClassIdentifier >-----#
    ClassIdentifier = ENUM(name=u'ClassIdentifier', mode=MODE_TYPE)
    ClassIdentifier._cont = ASN1Dict([(u'personal', 0), (u'advertisement', 1), (u'informational', 2), (u'auto', 3)])
    ClassIdentifier._ext = []
    
    #-----< ContentClass >-----#
    ContentClass = ENUM(name=u'ContentClass', mode=MODE_TYPE)
    ContentClass._cont = ASN1Dict([(u'text', 0), (u'image-basic', 1), (u'image-rich', 2), (u'video-basic', 3), (u'video-rich', 4), (u'megapixel', 5), (u'content-basic', 6), (u'content-rich', 7)])
    ContentClass._ext = []
    
    #-----< ContentLocation >-----#
    ContentLocation = SEQ(name=u'ContentLocation', mode=MODE_TYPE)
    _ContentLocation_contentLocationURI = OCT_STR(name=u'contentLocationURI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ContentLocation_statusCount = INT(name=u'statusCount', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ContentLocation._cont = ASN1Dict([
        (u'contentLocationURI', _ContentLocation_contentLocationURI),
        (u'statusCount', _ContentLocation_statusCount),
        ])
    ContentLocation._ext = []
    
    #-----< ElementDescriptor >-----#
    ElementDescriptor = SEQ(name=u'ElementDescriptor', mode=MODE_TYPE)
    _ElementDescriptor_contentReferenceValue = STR_UTF8(name=u'contentReferenceValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ElementDescriptor_parameterName = CHOICE(name=u'parameterName', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'ParameterName')))
    _ElementDescriptor_parameterValue = CHOICE(name=u'parameterValue', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'ParameterValue')))
    ElementDescriptor._cont = ASN1Dict([
        (u'contentReferenceValue', _ElementDescriptor_contentReferenceValue),
        (u'parameterName', _ElementDescriptor_parameterName),
        (u'parameterValue', _ElementDescriptor_parameterValue),
        ])
    ElementDescriptor._ext = []
    
    #-----< EncodedString >-----#
    EncodedString = CHOICE(name=u'EncodedString', mode=MODE_TYPE)
    _EncodedString_text = STR_UTF8(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EncodedString_encodedTextString = SEQ(name=u'encodedTextString', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'EncodedTextString')))
    EncodedString._cont = ASN1Dict([
        (u'text', _EncodedString_text),
        (u'encodedTextString', _EncodedString_encodedTextString),
        ])
    EncodedString._ext = []
    
    #-----< EncodedTextString >-----#
    EncodedTextString = SEQ(name=u'EncodedTextString', mode=MODE_TYPE)
    _EncodedTextString_stringType = OCT_STR(name=u'stringType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EncodedTextString_actualString = OCT_STR(name=u'actualString', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    EncodedTextString._cont = ASN1Dict([
        (u'stringType', _EncodedTextString_stringType),
        (u'actualString', _EncodedTextString_actualString),
        ])
    EncodedTextString._ext = []
    
    #-----< From >-----#
    From = SEQ_OF(name=u'From', mode=MODE_TYPE)
    _From__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MmsHI2Operations', 'FromAddresses')))
    From._cont = _From__item_
    
    #-----< FromAddresses >-----#
    FromAddresses = CHOICE(name=u'FromAddresses', mode=MODE_TYPE)
    _FromAddresses_actualAddress = CHOICE(name=u'actualAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'EncodedString')))
    _FromAddresses_insertToken = NULL(name=u'insertToken', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    FromAddresses._cont = ASN1Dict([
        (u'actualAddress', _FromAddresses_actualAddress),
        (u'insertToken', _FromAddresses_insertToken),
        ])
    FromAddresses._ext = []
    
    #-----< MessageClass >-----#
    MessageClass = CHOICE(name=u'MessageClass', mode=MODE_TYPE)
    _MessageClass_classIdentifier = ENUM(name=u'classIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'ClassIdentifier')))
    _MessageClass_tokenText = OCT_STR(name=u'tokenText', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    MessageClass._cont = ASN1Dict([
        (u'classIdentifier', _MessageClass_classIdentifier),
        (u'tokenText', _MessageClass_tokenText),
        ])
    MessageClass._ext = []
    
    #-----< MMBoxDescriptionPdus >-----#
    MMBoxDescriptionPdus = SEQ(name=u'MMBoxDescriptionPdus', mode=MODE_TYPE)
    _MMBoxDescriptionPdus_mMSCorrelation = OCT_STR(name=u'mMSCorrelation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'MMSCorrelationNumber')), opt=True)
    _MMBoxDescriptionPdus_toAddresses = SEQ_OF(name=u'toAddresses', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'Addresses')))
    _MMBoxDescriptionPdus_cCAddresses = SEQ_OF(name=u'cCAddresses', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'Addresses')), opt=True)
    _MMBoxDescriptionPdus_bCCAddresses = SEQ_OF(name=u'bCCAddresses', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'Addresses')), opt=True)
    _MMBoxDescriptionPdus_fromAddress = SEQ_OF(name=u'fromAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'From')))
    _MMBoxDescriptionPdus_messageID = STR_UTF8(name=u'messageID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMBoxDescriptionPdus_mMSDateTime = TIME_GEN(name=u'mMSDateTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBoxDescriptionPdus_previouslySentBy = SEQ(name=u'previouslySentBy', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'PreviouslySentBy')), opt=True)
    _MMBoxDescriptionPdus_previouslySentByDateTime = SEQ(name=u'previouslySentByDateTime', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'PreviouslySentByDateTime')), opt=True)
    _MMBoxDescriptionPdus_mMState = ENUM(name=u'mMState', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'MMSState')), opt=True)
    _MMBoxDescriptionPdus_mMFlags = SEQ(name=u'mMFlags', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'MMFlags')), opt=True)
    _MMBoxDescriptionPdus_messageClass = CHOICE(name=u'messageClass', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'MessageClass')), opt=True)
    _MMBoxDescriptionPdus_priority = ENUM(name=u'priority', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'Priority')), opt=True)
    _MMBoxDescriptionPdus_deliveryTime = TIME_GEN(name=u'deliveryTime', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBoxDescriptionPdus_expiry = TIME_GEN(name=u'expiry', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBoxDescriptionPdus_deliveryReport = BOOL(name=u'deliveryReport', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'YesNo')), opt=True)
    _MMBoxDescriptionPdus_readReport = BOOL(name=u'readReport', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'YesNo')), opt=True)
    _MMBoxDescriptionPdus_messageSize = INT(name=u'messageSize', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBoxDescriptionPdus_contentLocation = SEQ(name=u'contentLocation', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'ContentLocation')), opt=True)
    _MMBoxDescriptionPdus_contentType = OCT_STR(name=u'contentType', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    MMBoxDescriptionPdus._cont = ASN1Dict([
        (u'mMSCorrelation', _MMBoxDescriptionPdus_mMSCorrelation),
        (u'toAddresses', _MMBoxDescriptionPdus_toAddresses),
        (u'cCAddresses', _MMBoxDescriptionPdus_cCAddresses),
        (u'bCCAddresses', _MMBoxDescriptionPdus_bCCAddresses),
        (u'fromAddress', _MMBoxDescriptionPdus_fromAddress),
        (u'messageID', _MMBoxDescriptionPdus_messageID),
        (u'mMSDateTime', _MMBoxDescriptionPdus_mMSDateTime),
        (u'previouslySentBy', _MMBoxDescriptionPdus_previouslySentBy),
        (u'previouslySentByDateTime', _MMBoxDescriptionPdus_previouslySentByDateTime),
        (u'mMState', _MMBoxDescriptionPdus_mMState),
        (u'mMFlags', _MMBoxDescriptionPdus_mMFlags),
        (u'messageClass', _MMBoxDescriptionPdus_messageClass),
        (u'priority', _MMBoxDescriptionPdus_priority),
        (u'deliveryTime', _MMBoxDescriptionPdus_deliveryTime),
        (u'expiry', _MMBoxDescriptionPdus_expiry),
        (u'deliveryReport', _MMBoxDescriptionPdus_deliveryReport),
        (u'readReport', _MMBoxDescriptionPdus_readReport),
        (u'messageSize', _MMBoxDescriptionPdus_messageSize),
        (u'contentLocation', _MMBoxDescriptionPdus_contentLocation),
        (u'contentType', _MMBoxDescriptionPdus_contentType),
        ])
    MMBoxDescriptionPdus._ext = []
    
    #-----< MMFlags >-----#
    MMFlags = SEQ(name=u'MMFlags', mode=MODE_TYPE)
    _MMFlags_tokenAction = ENUM(name=u'tokenAction', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'TokenAction')))
    _MMFlags_mmFlagkeywords = CHOICE(name=u'mmFlagkeywords', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'EncodedString')))
    MMFlags._cont = ASN1Dict([
        (u'tokenAction', _MMFlags_tokenAction),
        (u'mmFlagkeywords', _MMFlags_mmFlagkeywords),
        ])
    MMFlags._ext = None
    
    #-----< MMSAttributes >-----#
    MMSAttributes = CHOICE(name=u'MMSAttributes', mode=MODE_TYPE)
    _MMSAttributes_attributeApplicID = STR_UTF8(name=u'attributeApplicID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMSAttributes_attributeAuxApplicInfo = STR_UTF8(name=u'attributeAuxApplicInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMSAttributes_attributeBCC = CHOICE(name=u'attributeBCC', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'Address')))
    _MMSAttributes_attributeCC = CHOICE(name=u'attributeCC', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'Address')))
    _MMSAttributes_attributeContent = OCT_STR(name=u'attributeContent', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMSAttributes_attributeContentType = OCT_STR(name=u'attributeContentType', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMSAttributes_attributeDate = TIME_GEN(name=u'attributeDate', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMSAttributes_attributeDeliveryReport = BOOL(name=u'attributeDeliveryReport', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'YesNo')))
    _MMSAttributes_attributeDeliveryTime = TIME_GEN(name=u'attributeDeliveryTime', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMSAttributes_attributeExpiry = TIME_GEN(name=u'attributeExpiry', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMSAttributes_attributeFrom = SEQ_OF(name=u'attributeFrom', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'From')))
    _MMSAttributes_attributeMessageClass = CHOICE(name=u'attributeMessageClass', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'MessageClass')))
    _MMSAttributes_attributeMessageID = STR_UTF8(name=u'attributeMessageID', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMSAttributes_attributeMessageSize = INT(name=u'attributeMessageSize', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMSAttributes_attributePriority = ENUM(name=u'attributePriority', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'Priority')))
    _MMSAttributes_attributeReadReport = BOOL(name=u'attributeReadReport', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'YesNo')))
    _MMSAttributes_attributeTo = CHOICE(name=u'attributeTo', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'Address')))
    _MMSAttributes_attributeReplyApplicID = STR_UTF8(name=u'attributeReplyApplicID', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMSAttributes_attributePreviouslySentBy = SEQ(name=u'attributePreviouslySentBy', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'PreviouslySentBy')))
    _MMSAttributes_attributePreviouslySentByDateTime = SEQ(name=u'attributePreviouslySentByDateTime', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'PreviouslySentByDateTime')))
    _MMSAttributes_attributeAdditionalHeaders = OCT_STR(name=u'attributeAdditionalHeaders', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    MMSAttributes._cont = ASN1Dict([
        (u'attributeApplicID', _MMSAttributes_attributeApplicID),
        (u'attributeAuxApplicInfo', _MMSAttributes_attributeAuxApplicInfo),
        (u'attributeBCC', _MMSAttributes_attributeBCC),
        (u'attributeCC', _MMSAttributes_attributeCC),
        (u'attributeContent', _MMSAttributes_attributeContent),
        (u'attributeContentType', _MMSAttributes_attributeContentType),
        (u'attributeDate', _MMSAttributes_attributeDate),
        (u'attributeDeliveryReport', _MMSAttributes_attributeDeliveryReport),
        (u'attributeDeliveryTime', _MMSAttributes_attributeDeliveryTime),
        (u'attributeExpiry', _MMSAttributes_attributeExpiry),
        (u'attributeFrom', _MMSAttributes_attributeFrom),
        (u'attributeMessageClass', _MMSAttributes_attributeMessageClass),
        (u'attributeMessageID', _MMSAttributes_attributeMessageID),
        (u'attributeMessageSize', _MMSAttributes_attributeMessageSize),
        (u'attributePriority', _MMSAttributes_attributePriority),
        (u'attributeReadReport', _MMSAttributes_attributeReadReport),
        (u'attributeTo', _MMSAttributes_attributeTo),
        (u'attributeReplyApplicID', _MMSAttributes_attributeReplyApplicID),
        (u'attributePreviouslySentBy', _MMSAttributes_attributePreviouslySentBy),
        (u'attributePreviouslySentByDateTime', _MMSAttributes_attributePreviouslySentByDateTime),
        (u'attributeAdditionalHeaders', _MMSAttributes_attributeAdditionalHeaders),
        ])
    MMSAttributes._ext = []
    
    #-----< MMSCorrelationNumber >-----#
    MMSCorrelationNumber = OCT_STR(name=u'MMSCorrelationNumber', mode=MODE_TYPE)
    
    #-----< MMSEvent >-----#
    MMSEvent = ENUM(name=u'MMSEvent', mode=MODE_TYPE)
    MMSEvent._cont = ASN1Dict([(u'send', 0), (u'notification', 1), (u'notificationResponse', 2), (u'retrieval', 3), (u'retrievalAcknowledgement', 4), (u'forwarding', 5), (u'store', 6), (u'upload', 7), (u'delete', 8), (u'delivery', 9), (u'readReplyFromTarget', 10), (u'readReplyToTarget', 11), (u'cancel', 12), (u'viewRequest', 13), (u'viewConfirm', 14)])
    MMSEvent._ext = []
    
    #-----< MMSParties >-----#
    MMSParties = SEQ(name=u'MMSParties', mode=MODE_TYPE)
    _MMSParties_toAddresses = SEQ_OF(name=u'toAddresses', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'Addresses')), opt=True)
    _MMSParties_cCAddresses = SEQ_OF(name=u'cCAddresses', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'Addresses')), opt=True)
    _MMSParties_bCCAddresses = SEQ_OF(name=u'bCCAddresses', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'Addresses')), opt=True)
    _MMSParties_fromAddresses = SEQ_OF(name=u'fromAddresses', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'From')), opt=True)
    MMSParties._cont = ASN1Dict([
        (u'toAddresses', _MMSParties_toAddresses),
        (u'cCAddresses', _MMSParties_cCAddresses),
        (u'bCCAddresses', _MMSParties_bCCAddresses),
        (u'fromAddresses', _MMSParties_fromAddresses),
        ])
    MMSParties._ext = []
    
    #-----< MMSState >-----#
    MMSState = ENUM(name=u'MMSState', mode=MODE_TYPE)
    MMSState._cont = ASN1Dict([(u'draft', 0), (u'sent', 1), (u'new', 2), (u'retreived', 3), (u'forwarded', 4)])
    MMSState._ext = []
    
    #-----< MMSStatus >-----#
    MMSStatus = ENUM(name=u'MMSStatus', mode=MODE_TYPE)
    MMSStatus._cont = ASN1Dict([(u'expired', 0), (u'retrieved', 1), (u'rejected', 2), (u'deferred', 3), (u'unrecognised', 4), (u'indeterminate', 5), (u'forwarded', 6), (u'unreachable', 7)])
    MMSStatus._ext = []
    
    #-----< ParameterName >-----#
    ParameterName = CHOICE(name=u'ParameterName', mode=MODE_TYPE)
    _ParameterName_integername = INT(name=u'integername', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ParameterName_textName = STR_UTF8(name=u'textName', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ParameterName._cont = ASN1Dict([
        (u'integername', _ParameterName_integername),
        (u'textName', _ParameterName_textName),
        ])
    ParameterName._ext = []
    
    #-----< ParameterValue >-----#
    ParameterValue = CHOICE(name=u'ParameterValue', mode=MODE_TYPE)
    _ParameterValue_intValue = OCT_STR(name=u'intValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ParameterValue_textValue = STR_UTF8(name=u'textValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ParameterValue._cont = ASN1Dict([
        (u'intValue', _ParameterValue_intValue),
        (u'textValue', _ParameterValue_textValue),
        ])
    ParameterValue._ext = []
    
    #-----< PreviouslySentBy >-----#
    PreviouslySentBy = SEQ(name=u'PreviouslySentBy', mode=MODE_TYPE)
    _PreviouslySentBy_forwardedCount = INT(name=u'forwardedCount', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PreviouslySentBy_forwardedPartyID = CHOICE(name=u'forwardedPartyID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'EncodedString')))
    PreviouslySentBy._cont = ASN1Dict([
        (u'forwardedCount', _PreviouslySentBy_forwardedCount),
        (u'forwardedPartyID', _PreviouslySentBy_forwardedPartyID),
        ])
    PreviouslySentBy._ext = []
    
    #-----< PreviouslySentByDateTime >-----#
    PreviouslySentByDateTime = SEQ(name=u'PreviouslySentByDateTime', mode=MODE_TYPE)
    _PreviouslySentByDateTime_forwardedCount = INT(name=u'forwardedCount', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PreviouslySentByDateTime_forwardedDateTime = TIME_GEN(name=u'forwardedDateTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    PreviouslySentByDateTime._cont = ASN1Dict([
        (u'forwardedCount', _PreviouslySentByDateTime_forwardedCount),
        (u'forwardedDateTime', _PreviouslySentByDateTime_forwardedDateTime),
        ])
    PreviouslySentByDateTime._ext = []
    
    #-----< Priority >-----#
    Priority = ENUM(name=u'Priority', mode=MODE_TYPE)
    Priority._cont = ASN1Dict([(u'low', 0), (u'normal', 1), (u'high', 2)])
    Priority._ext = []
    
    #-----< ResponseStatus >-----#
    ResponseStatus = SEQ(name=u'ResponseStatus', mode=MODE_TYPE)
    _ResponseStatus_statusCount = CHOICE(name=u'statusCount', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'EncodedString')), opt=True)
    _ResponseStatus_actualResponseStatus = ENUM(name=u'actualResponseStatus', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'ActualResponseStatus')))
    ResponseStatus._cont = ASN1Dict([
        (u'statusCount', _ResponseStatus_statusCount),
        (u'actualResponseStatus', _ResponseStatus_actualResponseStatus),
        ])
    ResponseStatus._ext = []
    
    #-----< ResponseStatusText >-----#
    ResponseStatusText = SEQ(name=u'ResponseStatusText', mode=MODE_TYPE)
    _ResponseStatusText_statusCount = CHOICE(name=u'statusCount', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'EncodedString')), opt=True)
    _ResponseStatusText_actualResponseStatusText = CHOICE(name=u'actualResponseStatusText', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MmsHI2Operations', 'EncodedString')))
    ResponseStatusText._cont = ASN1Dict([
        (u'statusCount', _ResponseStatusText_statusCount),
        (u'actualResponseStatusText', _ResponseStatusText_actualResponseStatusText),
        ])
    ResponseStatusText._ext = []
    
    #-----< ActualResponseStatus >-----#
    ActualResponseStatus = ENUM(name=u'ActualResponseStatus', mode=MODE_TYPE)
    ActualResponseStatus._cont = ASN1Dict([(u'ok', 0), (u'errorUnspecified', 1), (u'errorServiceDenied', 2), (u'errorMessageFormatCorrupt', 3), (u'errorSendingAddressUnresolved', 4), (u'errorMessageNotFound', 5), (u'errorNetworkProblem', 6), (u'errorContentNotAccepted', 7), (u'errorUnsuportedMessage', 8), (u'errorTransientFailure', 9), (u'errorTransientSendingAddressUnresolved', 10), (u'errorTransientMessageNotFound', 11), (u'errorTransientNetworkProblem', 12), (u'errorTransientPartialSucess', 13), (u'errorPermanentFailure', 14), (u'errorPermanentServiceDenied', 15), (u'errorPermanentMessageFormatCorrupt', 16), (u'errorPermanentSendingAddressUnresolved', 17), (u'errorPermanentMessageNotFound', 18), (u'errorPermanentContentNotAccepted', 19), (u'errorPermanentReplyChargingLimitationsNotMet', 20), (u'errorPermanentReplyChargingRequestNotAccepted', 21), (u'errorPermanentReplyChargingForwardingDenied', 22), (u'errorPermanentReplyChargingNotSupported', 23), (u'errorPermanentAddressHidingNotSupported', 24), (u'errorPermanentLackOfPrepaid', 25)])
    ActualResponseStatus._ext = []
    
    #-----< StoreStatus >-----#
    StoreStatus = ENUM(name=u'StoreStatus', mode=MODE_TYPE)
    StoreStatus._cont = ASN1Dict([(u'success', 0), (u'errorTransient', 1), (u'high', 2)])
    StoreStatus._ext = []
    
    #-----< TokenAction >-----#
    TokenAction = ENUM(name=u'TokenAction', mode=MODE_TYPE)
    TokenAction._cont = ASN1Dict([(u'addToken', 0), (u'removeToken', 1), (u'filterToken', 2)])
    TokenAction._ext = []
    
    #-----< YesNo >-----#
    YesNo = BOOL(name=u'YesNo', mode=MODE_TYPE)
    
    _all_ = [
        lawfulInterceptDomainId,
        threeGPPSUBDomainId,
        hi2mmsDomainId,
        _MmsIRIsContent_mmsiRIContent,
        _MmsIRIsContent_mmsIRISequence,
        MmsIRIsContent,
        _MmsIRISequence__item_,
        MmsIRISequence,
        _MmsIRIContent_iRI_Begin_record,
        _MmsIRIContent_iRI_End_record,
        _MmsIRIContent_iRI_Continue_record,
        _MmsIRIContent_iRI_Report_record,
        MmsIRIContent,
        _IRI_Parameters_hi2mmsDomainId,
        _IRI_Parameters_lawfulInterceptionIdentifier,
        _IRI_Parameters_timeStamp,
        _IRI_Parameters_locationOfTheTarget,
        __IRI_Parameters_partyInformation__item_,
        _IRI_Parameters_partyInformation,
        _IRI_Parameters_mMSevent,
        _IRI_Parameters_serviceCenterAddress,
        _IRI_Parameters_mMSParties,
        _IRI_Parameters_mMSVersion,
        _IRI_Parameters_transactionID,
        _IRI_Parameters_messageID,
        _IRI_Parameters_mMSDateTime,
        _IRI_Parameters_messageClass,
        _IRI_Parameters_expiry,
        _IRI_Parameters_distributionIndicator,
        _IRI_Parameters_elementDescriptor,
        _IRI_Parameters_retrievalMode,
        _IRI_Parameters_retrievalModeText,
        _IRI_Parameters_senderVisibility,
        _IRI_Parameters_deliveryReport,
        _IRI_Parameters_readReport,
        _IRI_Parameters_applicID,
        _IRI_Parameters_replyApplicID,
        _IRI_Parameters_auxApplicInfo,
        _IRI_Parameters_contentClass,
        _IRI_Parameters_dRMContent,
        _IRI_Parameters_replaceID,
        _IRI_Parameters_contentLocation,
        _IRI_Parameters_mMSStatus,
        _IRI_Parameters_reportAllowed,
        _IRI_Parameters_previouslySentBy,
        _IRI_Parameters_previouslySentByDateTime,
        _IRI_Parameters_mMState,
        _IRI_Parameters_desiredDeliveryTime,
        _IRI_Parameters_deliveryReportAllowed,
        _IRI_Parameters_store,
        _IRI_Parameters_responseStatus,
        _IRI_Parameters_responseStatusText,
        _IRI_Parameters_storeStatus,
        _IRI_Parameters_storeStatusText,
        _IRI_Parameters_mMFlags,
        __IRI_Parameters_mMBoxDescriptionPdus__item_,
        _IRI_Parameters_mMBoxDescriptionPdus,
        _IRI_Parameters_cancelID,
        _IRI_Parameters_cancelStatus,
        _IRI_Parameters_mMSStart,
        _IRI_Parameters_mMSLimit,
        _IRI_Parameters_mMSAttributes,
        _IRI_Parameters_mMSTotals,
        _IRI_Parameters_mMSQuotas,
        _IRI_Parameters_mMSMessageCount,
        _IRI_Parameters_messageSize,
        _IRI_Parameters_mMSForwardReqDateTime,
        _IRI_Parameters_adaptationAllowed,
        _IRI_Parameters_priority,
        _IRI_Parameters_mMSCorrelationNumber,
        _IRI_Parameters_contentType,
        _IRI_Parameters_national_Parameters,
        IRI_Parameters,
        _PartyInformation_party_Qualifier,
        __PartyInformation_partyIdentity_mSISDN,
        __PartyInformation_partyIdentity_mMSAddress,
        __PartyInformation_partyIdentity_mMSAddressNonLocalID,
        __PartyInformation_partyIdentity_e_Mail,
        __PartyInformation_partyIdentity_e164_Format,
        __PartyInformation_partyIdentity_iPAddress,
        __PartyInformation_partyIdentity_alphanum_Shortcode,
        __PartyInformation_partyIdentity_num_Shortcode,
        __PartyInformation_partyIdentity_iMSI,
        _PartyInformation_partyIdentity,
        PartyInformation,
        Address,
        _Addresses__item_,
        Addresses,
        ClassIdentifier,
        ContentClass,
        _ContentLocation_contentLocationURI,
        _ContentLocation_statusCount,
        ContentLocation,
        _ElementDescriptor_contentReferenceValue,
        _ElementDescriptor_parameterName,
        _ElementDescriptor_parameterValue,
        ElementDescriptor,
        _EncodedString_text,
        _EncodedString_encodedTextString,
        EncodedString,
        _EncodedTextString_stringType,
        _EncodedTextString_actualString,
        EncodedTextString,
        _From__item_,
        From,
        _FromAddresses_actualAddress,
        _FromAddresses_insertToken,
        FromAddresses,
        _MessageClass_classIdentifier,
        _MessageClass_tokenText,
        MessageClass,
        _MMBoxDescriptionPdus_mMSCorrelation,
        _MMBoxDescriptionPdus_toAddresses,
        _MMBoxDescriptionPdus_cCAddresses,
        _MMBoxDescriptionPdus_bCCAddresses,
        _MMBoxDescriptionPdus_fromAddress,
        _MMBoxDescriptionPdus_messageID,
        _MMBoxDescriptionPdus_mMSDateTime,
        _MMBoxDescriptionPdus_previouslySentBy,
        _MMBoxDescriptionPdus_previouslySentByDateTime,
        _MMBoxDescriptionPdus_mMState,
        _MMBoxDescriptionPdus_mMFlags,
        _MMBoxDescriptionPdus_messageClass,
        _MMBoxDescriptionPdus_priority,
        _MMBoxDescriptionPdus_deliveryTime,
        _MMBoxDescriptionPdus_expiry,
        _MMBoxDescriptionPdus_deliveryReport,
        _MMBoxDescriptionPdus_readReport,
        _MMBoxDescriptionPdus_messageSize,
        _MMBoxDescriptionPdus_contentLocation,
        _MMBoxDescriptionPdus_contentType,
        MMBoxDescriptionPdus,
        _MMFlags_tokenAction,
        _MMFlags_mmFlagkeywords,
        MMFlags,
        _MMSAttributes_attributeApplicID,
        _MMSAttributes_attributeAuxApplicInfo,
        _MMSAttributes_attributeBCC,
        _MMSAttributes_attributeCC,
        _MMSAttributes_attributeContent,
        _MMSAttributes_attributeContentType,
        _MMSAttributes_attributeDate,
        _MMSAttributes_attributeDeliveryReport,
        _MMSAttributes_attributeDeliveryTime,
        _MMSAttributes_attributeExpiry,
        _MMSAttributes_attributeFrom,
        _MMSAttributes_attributeMessageClass,
        _MMSAttributes_attributeMessageID,
        _MMSAttributes_attributeMessageSize,
        _MMSAttributes_attributePriority,
        _MMSAttributes_attributeReadReport,
        _MMSAttributes_attributeTo,
        _MMSAttributes_attributeReplyApplicID,
        _MMSAttributes_attributePreviouslySentBy,
        _MMSAttributes_attributePreviouslySentByDateTime,
        _MMSAttributes_attributeAdditionalHeaders,
        MMSAttributes,
        MMSCorrelationNumber,
        MMSEvent,
        _MMSParties_toAddresses,
        _MMSParties_cCAddresses,
        _MMSParties_bCCAddresses,
        _MMSParties_fromAddresses,
        MMSParties,
        MMSState,
        MMSStatus,
        _ParameterName_integername,
        _ParameterName_textName,
        ParameterName,
        _ParameterValue_intValue,
        _ParameterValue_textValue,
        ParameterValue,
        _PreviouslySentBy_forwardedCount,
        _PreviouslySentBy_forwardedPartyID,
        PreviouslySentBy,
        _PreviouslySentByDateTime_forwardedCount,
        _PreviouslySentByDateTime_forwardedDateTime,
        PreviouslySentByDateTime,
        Priority,
        _ResponseStatus_statusCount,
        _ResponseStatus_actualResponseStatus,
        ResponseStatus,
        _ResponseStatusText_statusCount,
        _ResponseStatusText_actualResponseStatusText,
        ResponseStatusText,
        ActualResponseStatus,
        StoreStatus,
        TokenAction,
        YesNo,
    ]

class ProSeHI2Operations:

    _name_  = u'ProSeHI2Operations'
    _oid_   = [0, 4, 0, 2, 2, 4, 15, 16, 0]
    
    _obj_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi2ProSeDomainId',
        u'ProSeIRIsContent',
        u'ProSeIRISequence',
        u'ProSeIRIContent',
        u'IRI-Parameters',
        u'ProSeEventData',
        u'ProSeDirectDiscovery',
        u'ProSeDirectDiscoveryEvent',
        u'TargetRole',
        u'DirectDiscoveryData',
        u'ProSeAppMask',
        u'ProSeMaskSequence',
        ]
    _type_ = [
        u'ProSeIRIsContent',
        u'ProSeIRISequence',
        u'ProSeIRIContent',
        u'IRI-Parameters',
        u'ProSeEventData',
        u'ProSeDirectDiscovery',
        u'ProSeDirectDiscoveryEvent',
        u'TargetRole',
        u'DirectDiscoveryData',
        u'ProSeAppMask',
        u'ProSeMaskSequence',
        ]
    _set_ = [
        ]
    _val_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi2ProSeDomainId',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< lawfulInterceptDomainId >-----#
    lawfulInterceptDomainId = OID(name=u'lawfulInterceptDomainId', mode=MODE_VALUE)
    lawfulInterceptDomainId._val = (0, 4, 0, 2, 2)
    
    #-----< threeGPPSUBDomainId >-----#
    threeGPPSUBDomainId = OID(name=u'threeGPPSUBDomainId', mode=MODE_VALUE)
    threeGPPSUBDomainId._val = (0, 4, 0, 2, 2, 4)
    
    #-----< hi2ProSeDomainId >-----#
    hi2ProSeDomainId = OID(name=u'hi2ProSeDomainId', mode=MODE_VALUE)
    hi2ProSeDomainId._val = (0, 4, 0, 2, 2, 4, 15, 16, 0)
    
    #-----< ProSeIRIsContent >-----#
    ProSeIRIsContent = CHOICE(name=u'ProSeIRIsContent', mode=MODE_TYPE)
    _ProSeIRIsContent_proseIRIContent = CHOICE(name=u'proseIRIContent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeHI2Operations', 'ProSeIRIContent')))
    _ProSeIRIsContent_proseIRISequence = SEQ_OF(name=u'proseIRISequence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeHI2Operations', 'ProSeIRISequence')))
    ProSeIRIsContent._cont = ASN1Dict([
        (u'proseIRIContent', _ProSeIRIsContent_proseIRIContent),
        (u'proseIRISequence', _ProSeIRIsContent_proseIRISequence),
        ])
    ProSeIRIsContent._ext = None
    
    #-----< ProSeIRISequence >-----#
    ProSeIRISequence = SEQ_OF(name=u'ProSeIRISequence', mode=MODE_TYPE)
    _ProSeIRISequence__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ProSeHI2Operations', 'ProSeIRIContent')))
    ProSeIRISequence._cont = _ProSeIRISequence__item_
    
    #-----< ProSeIRIContent >-----#
    ProSeIRIContent = CHOICE(name=u'ProSeIRIContent', mode=MODE_TYPE)
    _ProSeIRIContent_iRI_Report_record = SEQ(name=u'iRI-Report-record', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeHI2Operations', 'IRI-Parameters')))
    ProSeIRIContent._cont = ASN1Dict([
        (u'iRI-Report-record', _ProSeIRIContent_iRI_Report_record),
        ])
    ProSeIRIContent._ext = []
    
    #-----< IRI-Parameters >-----#
    IRI_Parameters = SEQ(name=u'IRI-Parameters', mode=MODE_TYPE)
    _IRI_Parameters_hi2ProSeDomainId = OID(name=u'hi2ProSeDomainId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IRI_Parameters_lawfulInterceptionIdentifier = OCT_STR(name=u'lawfulInterceptionIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'LawfulInterceptionIdentifier')))
    _IRI_Parameters_timeStamp = CHOICE(name=u'timeStamp', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    _IRI_Parameters_networkIdentifier = SEQ(name=u'networkIdentifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'Network-Identifier')))
    _IRI_Parameters_proseEventData = CHOICE(name=u'proseEventData', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeHI2Operations', 'ProSeEventData')))
    _IRI_Parameters_national_Parameters = SET_OF(name=u'national-Parameters', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'National-Parameters')), opt=True)
    _IRI_Parameters_national_HI2_ASN1parameters = SEQ(name=u'national-HI2-ASN1parameters', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'National-HI2-ASN1parameters')), opt=True)
    IRI_Parameters._cont = ASN1Dict([
        (u'hi2ProSeDomainId', _IRI_Parameters_hi2ProSeDomainId),
        (u'lawfulInterceptionIdentifier', _IRI_Parameters_lawfulInterceptionIdentifier),
        (u'timeStamp', _IRI_Parameters_timeStamp),
        (u'networkIdentifier', _IRI_Parameters_networkIdentifier),
        (u'proseEventData', _IRI_Parameters_proseEventData),
        (u'national-Parameters', _IRI_Parameters_national_Parameters),
        (u'national-HI2-ASN1parameters', _IRI_Parameters_national_HI2_ASN1parameters),
        ])
    IRI_Parameters._ext = []
    
    #-----< ProSeEventData >-----#
    ProSeEventData = CHOICE(name=u'ProSeEventData', mode=MODE_TYPE)
    _ProSeEventData_proseDirectDiscovery = SEQ(name=u'proseDirectDiscovery', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeHI2Operations', 'ProSeDirectDiscovery')))
    ProSeEventData._cont = ASN1Dict([
        (u'proseDirectDiscovery', _ProSeEventData_proseDirectDiscovery),
        ])
    ProSeEventData._ext = []
    
    #-----< ProSeDirectDiscovery >-----#
    ProSeDirectDiscovery = SEQ(name=u'ProSeDirectDiscovery', mode=MODE_TYPE)
    _ProSeDirectDiscovery_proseDirectDiscoveryEvent = ENUM(name=u'proseDirectDiscoveryEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeHI2Operations', 'ProSeDirectDiscoveryEvent')))
    _ProSeDirectDiscovery_targetImsi = OCT_STR(name=u'targetImsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ProSeDirectDiscovery_targetImsi._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    _ProSeDirectDiscovery_targetRole = ENUM(name=u'targetRole', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeHI2Operations', 'TargetRole')))
    _ProSeDirectDiscovery_directDiscoveryData = SEQ(name=u'directDiscoveryData', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeHI2Operations', 'DirectDiscoveryData')))
    _ProSeDirectDiscovery_metadata = STR_UTF8(name=u'metadata', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProSeDirectDiscovery_otherUeImsi = OCT_STR(name=u'otherUeImsi', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProSeDirectDiscovery_otherUeImsi._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    ProSeDirectDiscovery._cont = ASN1Dict([
        (u'proseDirectDiscoveryEvent', _ProSeDirectDiscovery_proseDirectDiscoveryEvent),
        (u'targetImsi', _ProSeDirectDiscovery_targetImsi),
        (u'targetRole', _ProSeDirectDiscovery_targetRole),
        (u'directDiscoveryData', _ProSeDirectDiscovery_directDiscoveryData),
        (u'metadata', _ProSeDirectDiscovery_metadata),
        (u'otherUeImsi', _ProSeDirectDiscovery_otherUeImsi),
        ])
    ProSeDirectDiscovery._ext = []
    
    #-----< ProSeDirectDiscoveryEvent >-----#
    ProSeDirectDiscoveryEvent = ENUM(name=u'ProSeDirectDiscoveryEvent', mode=MODE_TYPE)
    ProSeDirectDiscoveryEvent._cont = ASN1Dict([(u'proseDiscoveryRequest', 1), (u'proseMatchReport', 2)])
    ProSeDirectDiscoveryEvent._ext = []
    
    #-----< TargetRole >-----#
    TargetRole = ENUM(name=u'TargetRole', mode=MODE_TYPE)
    TargetRole._cont = ASN1Dict([(u'announcingUE', 1), (u'monitoringUE', 2)])
    TargetRole._ext = []
    
    #-----< DirectDiscoveryData >-----#
    DirectDiscoveryData = SEQ(name=u'DirectDiscoveryData', mode=MODE_TYPE)
    _DirectDiscoveryData_discoveryPLMNID = STR_UTF8(name=u'discoveryPLMNID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DirectDiscoveryData_proseAppIdName = STR_UTF8(name=u'proseAppIdName', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DirectDiscoveryData_proseAppCode = OCT_STR(name=u'proseAppCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DirectDiscoveryData_proseAppCode._const_sz = ASN1Set(rv=[23], rr=[], ev=None, er=[])
    _DirectDiscoveryData_proseAppMask = CHOICE(name=u'proseAppMask', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeHI2Operations', 'ProSeAppMask')), opt=True)
    _DirectDiscoveryData_timer = INT(name=u'timer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    DirectDiscoveryData._cont = ASN1Dict([
        (u'discoveryPLMNID', _DirectDiscoveryData_discoveryPLMNID),
        (u'proseAppIdName', _DirectDiscoveryData_proseAppIdName),
        (u'proseAppCode', _DirectDiscoveryData_proseAppCode),
        (u'proseAppMask', _DirectDiscoveryData_proseAppMask),
        (u'timer', _DirectDiscoveryData_timer),
        ])
    DirectDiscoveryData._ext = []
    
    #-----< ProSeAppMask >-----#
    ProSeAppMask = CHOICE(name=u'ProSeAppMask', mode=MODE_TYPE)
    _ProSeAppMask_proseMask = OCT_STR(name=u'proseMask', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ProSeAppMask_proseMask._const_sz = ASN1Set(rv=[23], rr=[], ev=None, er=[])
    _ProSeAppMask_proseMaskSequence = SEQ_OF(name=u'proseMaskSequence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeHI2Operations', 'ProSeMaskSequence')))
    ProSeAppMask._cont = ASN1Dict([
        (u'proseMask', _ProSeAppMask_proseMask),
        (u'proseMaskSequence', _ProSeAppMask_proseMaskSequence),
        ])
    ProSeAppMask._ext = None
    
    #-----< ProSeMaskSequence >-----#
    ProSeMaskSequence = SEQ_OF(name=u'ProSeMaskSequence', mode=MODE_TYPE)
    _ProSeMaskSequence__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    _ProSeMaskSequence__item_._const_sz = ASN1Set(rv=[23], rr=[], ev=None, er=[])
    ProSeMaskSequence._cont = _ProSeMaskSequence__item_
    
    _all_ = [
        lawfulInterceptDomainId,
        threeGPPSUBDomainId,
        hi2ProSeDomainId,
        _ProSeIRIsContent_proseIRIContent,
        _ProSeIRIsContent_proseIRISequence,
        ProSeIRIsContent,
        _ProSeIRISequence__item_,
        ProSeIRISequence,
        _ProSeIRIContent_iRI_Report_record,
        ProSeIRIContent,
        _IRI_Parameters_hi2ProSeDomainId,
        _IRI_Parameters_lawfulInterceptionIdentifier,
        _IRI_Parameters_timeStamp,
        _IRI_Parameters_networkIdentifier,
        _IRI_Parameters_proseEventData,
        _IRI_Parameters_national_Parameters,
        _IRI_Parameters_national_HI2_ASN1parameters,
        IRI_Parameters,
        _ProSeEventData_proseDirectDiscovery,
        ProSeEventData,
        _ProSeDirectDiscovery_proseDirectDiscoveryEvent,
        _ProSeDirectDiscovery_targetImsi,
        _ProSeDirectDiscovery_targetRole,
        _ProSeDirectDiscovery_directDiscoveryData,
        _ProSeDirectDiscovery_metadata,
        _ProSeDirectDiscovery_otherUeImsi,
        ProSeDirectDiscovery,
        ProSeDirectDiscoveryEvent,
        TargetRole,
        _DirectDiscoveryData_discoveryPLMNID,
        _DirectDiscoveryData_proseAppIdName,
        _DirectDiscoveryData_proseAppCode,
        _DirectDiscoveryData_proseAppMask,
        _DirectDiscoveryData_timer,
        DirectDiscoveryData,
        _ProSeAppMask_proseMask,
        _ProSeAppMask_proseMaskSequence,
        ProSeAppMask,
        _ProSeMaskSequence__item_,
        ProSeMaskSequence,
    ]

class Remote_Operations_Information_Objects:

    _name_  = u'Remote-Operations-Information-Objects'
    _oid_   = [2, 4, 5, 0]
    
    _obj_ = [
        u'OPERATION',
        u'ERROR',
        u'OPERATION-PACKAGE',
        u'CONNECTION-PACKAGE',
        u'CONTRACT',
        u'ROS-OBJECT-CLASS',
        u'Code',
        u'Priority',
        u'refuse',
        u'emptyBind',
        u'emptyUnbind',
        ]
    _type_ = [
        u'OPERATION',
        u'ERROR',
        u'OPERATION-PACKAGE',
        u'CONNECTION-PACKAGE',
        u'CONTRACT',
        u'ROS-OBJECT-CLASS',
        u'Code',
        u'Priority',
        ]
    _set_ = [
        ]
    _val_ = [
        u'refuse',
        u'emptyBind',
        u'emptyUnbind',
        ]
    _class_ = [
        u'OPERATION',
        u'ERROR',
        u'OPERATION-PACKAGE',
        u'CONNECTION-PACKAGE',
        u'CONTRACT',
        u'ROS-OBJECT-CLASS',
        u'refuse',
        u'emptyBind',
        u'emptyUnbind',
        ]
    _param_ = [
        ]
    
    #-----< OPERATION >-----#
    OPERATION = CLASS(name=u'OPERATION', mode=MODE_TYPE)
    _OPERATION_ArgumentType = OPEN(name=u'ArgumentType', mode=MODE_TYPE, opt=True)
    _OPERATION_argumentTypeOptional = BOOL(name=u'argumentTypeOptional', mode=MODE_VALUE, opt=True)
    _OPERATION_returnResult = BOOL(name=u'returnResult', mode=MODE_VALUE, default=True)
    _OPERATION_ResultType = OPEN(name=u'ResultType', mode=MODE_TYPE, opt=True)
    _OPERATION_resultTypeOptional = BOOL(name=u'resultTypeOptional', mode=MODE_VALUE, opt=True)
    _OPERATION_Errors = CLASS(name=u'Errors', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')), opt=True)
    _OPERATION_Linked = CLASS(name=u'Linked', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), opt=True)
    _OPERATION_synchronous = BOOL(name=u'synchronous', mode=MODE_VALUE, default=False)
    _OPERATION_alwaysReturns = BOOL(name=u'alwaysReturns', mode=MODE_VALUE, default=True)
    _OPERATION_InvokePriority = INT(name=u'InvokePriority', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Priority')), opt=True)
    _OPERATION_ResultPriority = INT(name=u'ResultPriority', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Priority')), opt=True)
    _OPERATION_operationCode = CHOICE(name=u'operationCode', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')), opt=True, uniq=True)
    OPERATION._cont = ASN1Dict([
        (u'ArgumentType', _OPERATION_ArgumentType),
        (u'argumentTypeOptional', _OPERATION_argumentTypeOptional),
        (u'returnResult', _OPERATION_returnResult),
        (u'ResultType', _OPERATION_ResultType),
        (u'resultTypeOptional', _OPERATION_resultTypeOptional),
        (u'Errors', _OPERATION_Errors),
        (u'Linked', _OPERATION_Linked),
        (u'synchronous', _OPERATION_synchronous),
        (u'alwaysReturns', _OPERATION_alwaysReturns),
        (u'InvokePriority', _OPERATION_InvokePriority),
        (u'ResultPriority', _OPERATION_ResultPriority),
        (u'operationCode', _OPERATION_operationCode),
        ])
    
    #-----< ERROR >-----#
    ERROR = CLASS(name=u'ERROR', mode=MODE_TYPE)
    _ERROR_ParameterType = OPEN(name=u'ParameterType', mode=MODE_TYPE, opt=True)
    _ERROR_parameterTypeOptional = BOOL(name=u'parameterTypeOptional', mode=MODE_VALUE, opt=True)
    _ERROR_ErrorPriority = INT(name=u'ErrorPriority', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Priority')), opt=True)
    _ERROR_errorCode = CHOICE(name=u'errorCode', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')), opt=True, uniq=True)
    ERROR._cont = ASN1Dict([
        (u'ParameterType', _ERROR_ParameterType),
        (u'parameterTypeOptional', _ERROR_parameterTypeOptional),
        (u'ErrorPriority', _ERROR_ErrorPriority),
        (u'errorCode', _ERROR_errorCode),
        ])
    
    #-----< OPERATION-PACKAGE >-----#
    OPERATION_PACKAGE = CLASS(name=u'OPERATION-PACKAGE', mode=MODE_TYPE)
    _OPERATION_PACKAGE_Both = CLASS(name=u'Both', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), opt=True)
    _OPERATION_PACKAGE_Consumer = CLASS(name=u'Consumer', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), opt=True)
    _OPERATION_PACKAGE_Supplier = CLASS(name=u'Supplier', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), opt=True)
    _OPERATION_PACKAGE_id = OID(name=u'id', mode=MODE_VALUE, opt=True, uniq=True)
    OPERATION_PACKAGE._cont = ASN1Dict([
        (u'Both', _OPERATION_PACKAGE_Both),
        (u'Consumer', _OPERATION_PACKAGE_Consumer),
        (u'Supplier', _OPERATION_PACKAGE_Supplier),
        (u'id', _OPERATION_PACKAGE_id),
        ])
    
    #-----< CONNECTION-PACKAGE >-----#
    CONNECTION_PACKAGE = CLASS(name=u'CONNECTION-PACKAGE', mode=MODE_TYPE)
    _CONNECTION_PACKAGE_bind = CLASS(name=u'bind', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), default=dict([(u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', -1))])], rr=[], ev=None, er=[])), (u'synchronous', True)]))
    _CONNECTION_PACKAGE_unbind = CLASS(name=u'unbind', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), default=dict([(u'synchronous', True)]))
    _CONNECTION_PACKAGE_responderCanUnbind = BOOL(name=u'responderCanUnbind', mode=MODE_VALUE, default=False)
    _CONNECTION_PACKAGE_unbindCanFail = BOOL(name=u'unbindCanFail', mode=MODE_VALUE, default=False)
    _CONNECTION_PACKAGE_id = OID(name=u'id', mode=MODE_VALUE, opt=True, uniq=True)
    CONNECTION_PACKAGE._cont = ASN1Dict([
        (u'bind', _CONNECTION_PACKAGE_bind),
        (u'unbind', _CONNECTION_PACKAGE_unbind),
        (u'responderCanUnbind', _CONNECTION_PACKAGE_responderCanUnbind),
        (u'unbindCanFail', _CONNECTION_PACKAGE_unbindCanFail),
        (u'id', _CONNECTION_PACKAGE_id),
        ])
    
    #-----< CONTRACT >-----#
    CONTRACT = CLASS(name=u'CONTRACT', mode=MODE_TYPE)
    _CONTRACT_connection = CLASS(name=u'connection', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONNECTION-PACKAGE')), opt=True)
    _CONTRACT_OperationsOf = CLASS(name=u'OperationsOf', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), opt=True)
    _CONTRACT_InitiatorConsumerOf = CLASS(name=u'InitiatorConsumerOf', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), opt=True)
    _CONTRACT_InitiatorSupplierOf = CLASS(name=u'InitiatorSupplierOf', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), opt=True)
    _CONTRACT_id = OID(name=u'id', mode=MODE_VALUE, opt=True, uniq=True)
    CONTRACT._cont = ASN1Dict([
        (u'connection', _CONTRACT_connection),
        (u'OperationsOf', _CONTRACT_OperationsOf),
        (u'InitiatorConsumerOf', _CONTRACT_InitiatorConsumerOf),
        (u'InitiatorSupplierOf', _CONTRACT_InitiatorSupplierOf),
        (u'id', _CONTRACT_id),
        ])
    
    #-----< ROS-OBJECT-CLASS >-----#
    ROS_OBJECT_CLASS = CLASS(name=u'ROS-OBJECT-CLASS', mode=MODE_TYPE)
    _ROS_OBJECT_CLASS_Is = CLASS(name=u'Is', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')), opt=True)
    _ROS_OBJECT_CLASS_Initiates = CLASS(name=u'Initiates', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')), opt=True)
    _ROS_OBJECT_CLASS_Responds = CLASS(name=u'Responds', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')), opt=True)
    _ROS_OBJECT_CLASS_InitiatesAndResponds = CLASS(name=u'InitiatesAndResponds', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')), opt=True)
    _ROS_OBJECT_CLASS_id = OID(name=u'id', mode=MODE_VALUE, uniq=True)
    ROS_OBJECT_CLASS._cont = ASN1Dict([
        (u'Is', _ROS_OBJECT_CLASS_Is),
        (u'Initiates', _ROS_OBJECT_CLASS_Initiates),
        (u'Responds', _ROS_OBJECT_CLASS_Responds),
        (u'InitiatesAndResponds', _ROS_OBJECT_CLASS_InitiatesAndResponds),
        (u'id', _ROS_OBJECT_CLASS_id),
        ])
    
    #-----< Code >-----#
    Code = CHOICE(name=u'Code', mode=MODE_TYPE)
    _Code_local = INT(name=u'local', mode=MODE_TYPE)
    _Code_global_ = OID(name=u'global', mode=MODE_TYPE)
    Code._cont = ASN1Dict([
        (u'local', _Code_local),
        (u'global', _Code_global_),
        ])
    Code._ext = None
    
    #-----< Priority >-----#
    Priority = INT(name=u'Priority', mode=MODE_TYPE)
    Priority._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< refuse >-----#
    refuse = CLASS(name=u'refuse', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    refuse._val = dict([(u'errorCode', (u'local', -1))])
    
    #-----< emptyBind >-----#
    emptyBind = CLASS(name=u'emptyBind', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    emptyBind._val = dict([(u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', -1))])], rr=[], ev=None, er=[])), (u'synchronous', True)])
    
    #-----< emptyUnbind >-----#
    emptyUnbind = CLASS(name=u'emptyUnbind', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    emptyUnbind._val = dict([(u'synchronous', True)])
    
    _all_ = [
        _OPERATION_ArgumentType,
        _OPERATION_argumentTypeOptional,
        _OPERATION_returnResult,
        _OPERATION_ResultType,
        _OPERATION_resultTypeOptional,
        _OPERATION_Errors,
        _OPERATION_Linked,
        _OPERATION_synchronous,
        _OPERATION_alwaysReturns,
        _OPERATION_InvokePriority,
        _OPERATION_ResultPriority,
        _OPERATION_operationCode,
        OPERATION,
        _ERROR_ParameterType,
        _ERROR_parameterTypeOptional,
        _ERROR_ErrorPriority,
        _ERROR_errorCode,
        ERROR,
        _OPERATION_PACKAGE_Both,
        _OPERATION_PACKAGE_Consumer,
        _OPERATION_PACKAGE_Supplier,
        _OPERATION_PACKAGE_id,
        OPERATION_PACKAGE,
        _CONNECTION_PACKAGE_bind,
        _CONNECTION_PACKAGE_unbind,
        _CONNECTION_PACKAGE_responderCanUnbind,
        _CONNECTION_PACKAGE_unbindCanFail,
        _CONNECTION_PACKAGE_id,
        CONNECTION_PACKAGE,
        _CONTRACT_connection,
        _CONTRACT_OperationsOf,
        _CONTRACT_InitiatorConsumerOf,
        _CONTRACT_InitiatorSupplierOf,
        _CONTRACT_id,
        CONTRACT,
        _ROS_OBJECT_CLASS_Is,
        _ROS_OBJECT_CLASS_Initiates,
        _ROS_OBJECT_CLASS_Responds,
        _ROS_OBJECT_CLASS_InitiatesAndResponds,
        _ROS_OBJECT_CLASS_id,
        ROS_OBJECT_CLASS,
        _Code_local,
        _Code_global_,
        Code,
        Priority,
        refuse,
        emptyBind,
        emptyUnbind,
    ]

class PCESP:

    _name_  = u'PCESP'
    _oid_   = [1, 3, 6, 1, 4, 1, 4491, 2, 2, 5, 1, 4]
    
    _obj_ = [
        u'ProtocolVersion',
        u'CdcPdu',
        u'Message',
        u'Answer',
        u'CCChange',
        u'CCClose',
        u'CCOpen',
        u'ConferencePartyChange',
        u'DialedDigitExtraction',
        u'MediaReport',
        u'NetworkSignal',
        u'Origination',
        u'Redirection',
        u'Release',
        u'ServiceInstance',
        u'SubjectSignal',
        u'TerminationAttempt',
        u'AccessingElementId',
        u'AlertingSignal',
        u'AudibleSignal',
        u'CallId',
        u'CaseId',
        u'CCCId',
        u'EventTime',
        u'FlowDirection',
        u'PartyId',
        u'RedirectedFromInfo',
        u'ResourceState',
        u'SDP',
        u'TerminalDisplayInfo',
        u'TransitCarrierId',
        ]
    _type_ = [
        u'ProtocolVersion',
        u'CdcPdu',
        u'Message',
        u'Answer',
        u'CCChange',
        u'CCClose',
        u'CCOpen',
        u'ConferencePartyChange',
        u'DialedDigitExtraction',
        u'MediaReport',
        u'NetworkSignal',
        u'Origination',
        u'Redirection',
        u'Release',
        u'ServiceInstance',
        u'SubjectSignal',
        u'TerminationAttempt',
        u'AccessingElementId',
        u'AlertingSignal',
        u'AudibleSignal',
        u'CallId',
        u'CaseId',
        u'CCCId',
        u'EventTime',
        u'FlowDirection',
        u'PartyId',
        u'RedirectedFromInfo',
        u'ResourceState',
        u'SDP',
        u'TerminalDisplayInfo',
        u'TransitCarrierId',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< ProtocolVersion >-----#
    ProtocolVersion = ENUM(name=u'ProtocolVersion', mode=MODE_TYPE)
    ProtocolVersion._cont = ASN1Dict([(u'v3', 3), (u'v4', 4)])
    ProtocolVersion._ext = []
    
    #-----< CdcPdu >-----#
    CdcPdu = SEQ(name=u'CdcPdu', mode=MODE_TYPE)
    _CdcPdu_protocolVersion = ENUM(name=u'protocolVersion', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'ProtocolVersion')))
    _CdcPdu_message = CHOICE(name=u'message', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'Message')))
    CdcPdu._cont = ASN1Dict([
        (u'protocolVersion', _CdcPdu_protocolVersion),
        (u'message', _CdcPdu_message),
        ])
    CdcPdu._ext = []
    
    #-----< Message >-----#
    Message = CHOICE(name=u'Message', mode=MODE_TYPE)
    _Message_answer = SEQ(name=u'answer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'Answer')))
    _Message_ccclose = SEQ(name=u'ccclose', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CCClose')))
    _Message_ccopen = SEQ(name=u'ccopen', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CCOpen')))
    _Message_reserved0 = NULL(name=u'reserved0', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Message_origination = SEQ(name=u'origination', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'Origination')))
    _Message_reserved1 = NULL(name=u'reserved1', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Message_redirection = SEQ(name=u'redirection', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'Redirection')))
    _Message_release = SEQ(name=u'release', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'Release')))
    _Message_reserved2 = NULL(name=u'reserved2', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Message_terminationattempt = SEQ(name=u'terminationattempt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'TerminationAttempt')))
    _Message_reserved = NULL(name=u'reserved', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Message_ccchange = SEQ(name=u'ccchange', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CCChange')))
    _Message_reserved3 = NULL(name=u'reserved3', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Message_reserved4 = NULL(name=u'reserved4', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Message_dialeddigitextraction = SEQ(name=u'dialeddigitextraction', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'DialedDigitExtraction')))
    _Message_networksignal = SEQ(name=u'networksignal', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'NetworkSignal')))
    _Message_subjectsignal = SEQ(name=u'subjectsignal', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'SubjectSignal')))
    _Message_mediareport = SEQ(name=u'mediareport', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'MediaReport')))
    _Message_serviceinstance = SEQ(name=u'serviceinstance', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'ServiceInstance')))
    _Message_confpartychange = SEQ(name=u'confpartychange', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'ConferencePartyChange')))
    Message._cont = ASN1Dict([
        (u'answer', _Message_answer),
        (u'ccclose', _Message_ccclose),
        (u'ccopen', _Message_ccopen),
        (u'reserved0', _Message_reserved0),
        (u'origination', _Message_origination),
        (u'reserved1', _Message_reserved1),
        (u'redirection', _Message_redirection),
        (u'release', _Message_release),
        (u'reserved2', _Message_reserved2),
        (u'terminationattempt', _Message_terminationattempt),
        (u'reserved', _Message_reserved),
        (u'ccchange', _Message_ccchange),
        (u'reserved3', _Message_reserved3),
        (u'reserved4', _Message_reserved4),
        (u'dialeddigitextraction', _Message_dialeddigitextraction),
        (u'networksignal', _Message_networksignal),
        (u'subjectsignal', _Message_subjectsignal),
        (u'mediareport', _Message_mediareport),
        (u'serviceinstance', _Message_serviceinstance),
        (u'confpartychange', _Message_confpartychange),
        ])
    Message._ext = []
    
    #-----< Answer >-----#
    Answer = SEQ(name=u'Answer', mode=MODE_TYPE)
    _Answer_caseId = STR_VIS(name=u'caseId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CaseId')))
    _Answer_accessingElementId = STR_VIS(name=u'accessingElementId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'AccessingElementId')))
    _Answer_eventTime = TIME_GEN(name=u'eventTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'EventTime')))
    _Answer_callId = SEQ(name=u'callId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CallId')))
    _Answer_answering = SEQ(name=u'answering', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'PartyId')), opt=True)
    Answer._cont = ASN1Dict([
        (u'caseId', _Answer_caseId),
        (u'accessingElementId', _Answer_accessingElementId),
        (u'eventTime', _Answer_eventTime),
        (u'callId', _Answer_callId),
        (u'answering', _Answer_answering),
        ])
    Answer._ext = []
    
    #-----< CCChange >-----#
    CCChange = SEQ(name=u'CCChange', mode=MODE_TYPE)
    _CCChange_caseId = STR_VIS(name=u'caseId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CaseId')))
    _CCChange_accessingElementId = STR_VIS(name=u'accessingElementId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'AccessingElementId')))
    _CCChange_eventTime = TIME_GEN(name=u'eventTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'EventTime')))
    _CCChange_callId = SEQ(name=u'callId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CallId')))
    _CCChange_cCCId = CHOICE(name=u'cCCId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCESP', 'CCCId')))
    _CCChange_subject = STR_UTF8(name=u'subject', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'SDP')), opt=True)
    _CCChange_associate = STR_UTF8(name=u'associate', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'SDP')), opt=True)
    _CCChange_flowDirection = ENUM(name=u'flowDirection', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'FlowDirection')))
    _CCChange_resourceState = ENUM(name=u'resourceState', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'ResourceState')), opt=True)
    CCChange._cont = ASN1Dict([
        (u'caseId', _CCChange_caseId),
        (u'accessingElementId', _CCChange_accessingElementId),
        (u'eventTime', _CCChange_eventTime),
        (u'callId', _CCChange_callId),
        (u'cCCId', _CCChange_cCCId),
        (u'subject', _CCChange_subject),
        (u'associate', _CCChange_associate),
        (u'flowDirection', _CCChange_flowDirection),
        (u'resourceState', _CCChange_resourceState),
        ])
    CCChange._ext = []
    
    #-----< CCClose >-----#
    CCClose = SEQ(name=u'CCClose', mode=MODE_TYPE)
    _CCClose_caseId = STR_VIS(name=u'caseId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CaseId')))
    _CCClose_accessingElementId = STR_VIS(name=u'accessingElementId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'AccessingElementId')))
    _CCClose_eventTime = TIME_GEN(name=u'eventTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'EventTime')))
    _CCClose_cCCId = CHOICE(name=u'cCCId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCESP', 'CCCId')))
    _CCClose_flowDirection = ENUM(name=u'flowDirection', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'FlowDirection')))
    CCClose._cont = ASN1Dict([
        (u'caseId', _CCClose_caseId),
        (u'accessingElementId', _CCClose_accessingElementId),
        (u'eventTime', _CCClose_eventTime),
        (u'cCCId', _CCClose_cCCId),
        (u'flowDirection', _CCClose_flowDirection),
        ])
    CCClose._ext = []
    
    #-----< CCOpen >-----#
    CCOpen = SEQ(name=u'CCOpen', mode=MODE_TYPE)
    _CCOpen_caseId = STR_VIS(name=u'caseId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CaseId')))
    _CCOpen_accessingElementId = STR_VIS(name=u'accessingElementId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'AccessingElementId')))
    _CCOpen_eventTime = TIME_GEN(name=u'eventTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'EventTime')))
    _CCOpen_ccOpenOption = CHOICE(name=u'ccOpenOption', mode=MODE_TYPE)
    __CCOpen_ccOpenOption_ccOpenTime = SEQ_OF(name=u'ccOpenTime', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___CCOpen_ccOpenOption_ccOpenTime__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCESP', 'CallId')))
    __CCOpen_ccOpenOption_ccOpenTime._cont = ___CCOpen_ccOpenOption_ccOpenTime__item_
    __CCOpen_ccOpenOption_reserved0 = NULL(name=u'reserved0', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CCOpen_ccOpenOption._cont = ASN1Dict([
        (u'ccOpenTime', __CCOpen_ccOpenOption_ccOpenTime),
        (u'reserved0', __CCOpen_ccOpenOption_reserved0),
        ])
    _CCOpen_ccOpenOption._ext = []
    _CCOpen_cCCId = CHOICE(name=u'cCCId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCESP', 'CCCId')))
    _CCOpen_subject = STR_UTF8(name=u'subject', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'SDP')), opt=True)
    _CCOpen_associate = STR_UTF8(name=u'associate', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'SDP')), opt=True)
    _CCOpen_flowDirection = ENUM(name=u'flowDirection', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'FlowDirection')))
    CCOpen._cont = ASN1Dict([
        (u'caseId', _CCOpen_caseId),
        (u'accessingElementId', _CCOpen_accessingElementId),
        (u'eventTime', _CCOpen_eventTime),
        (u'ccOpenOption', _CCOpen_ccOpenOption),
        (u'cCCId', _CCOpen_cCCId),
        (u'subject', _CCOpen_subject),
        (u'associate', _CCOpen_associate),
        (u'flowDirection', _CCOpen_flowDirection),
        ])
    CCOpen._ext = []
    
    #-----< ConferencePartyChange >-----#
    ConferencePartyChange = SEQ(name=u'ConferencePartyChange', mode=MODE_TYPE)
    _ConferencePartyChange_caseId = STR_VIS(name=u'caseId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CaseId')))
    _ConferencePartyChange_accessingElementId = STR_VIS(name=u'accessingElementId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'AccessingElementId')))
    _ConferencePartyChange_eventTime = TIME_GEN(name=u'eventTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'EventTime')))
    _ConferencePartyChange_callId = SEQ(name=u'callId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CallId')))
    _ConferencePartyChange_communicating = SEQ_OF(name=u'communicating', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ConferencePartyChange_communicating__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___ConferencePartyChange_communicating__item__partyId = SEQ_OF(name=u'partyId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ConferencePartyChange_communicating__item__partyId__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCESP', 'PartyId')))
    ___ConferencePartyChange_communicating__item__partyId._cont = ____ConferencePartyChange_communicating__item__partyId__item_
    ___ConferencePartyChange_communicating__item__cCCId = CHOICE(name=u'cCCId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCESP', 'CCCId')), opt=True)
    __ConferencePartyChange_communicating__item_._cont = ASN1Dict([
        (u'partyId', ___ConferencePartyChange_communicating__item__partyId),
        (u'cCCId', ___ConferencePartyChange_communicating__item__cCCId),
        ])
    __ConferencePartyChange_communicating__item_._ext = []
    _ConferencePartyChange_communicating._cont = __ConferencePartyChange_communicating__item_
    _ConferencePartyChange_removed = SEQ_OF(name=u'removed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ConferencePartyChange_removed__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___ConferencePartyChange_removed__item__partyId = SEQ_OF(name=u'partyId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ConferencePartyChange_removed__item__partyId__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCESP', 'PartyId')))
    ___ConferencePartyChange_removed__item__partyId._cont = ____ConferencePartyChange_removed__item__partyId__item_
    ___ConferencePartyChange_removed__item__cCCId = CHOICE(name=u'cCCId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCESP', 'CCCId')), opt=True)
    __ConferencePartyChange_removed__item_._cont = ASN1Dict([
        (u'partyId', ___ConferencePartyChange_removed__item__partyId),
        (u'cCCId', ___ConferencePartyChange_removed__item__cCCId),
        ])
    __ConferencePartyChange_removed__item_._ext = []
    _ConferencePartyChange_removed._cont = __ConferencePartyChange_removed__item_
    _ConferencePartyChange_joined = SEQ_OF(name=u'joined', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ConferencePartyChange_joined__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___ConferencePartyChange_joined__item__partyId = SEQ_OF(name=u'partyId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ConferencePartyChange_joined__item__partyId__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCESP', 'PartyId')))
    ___ConferencePartyChange_joined__item__partyId._cont = ____ConferencePartyChange_joined__item__partyId__item_
    ___ConferencePartyChange_joined__item__cCCId = CHOICE(name=u'cCCId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCESP', 'CCCId')), opt=True)
    __ConferencePartyChange_joined__item_._cont = ASN1Dict([
        (u'partyId', ___ConferencePartyChange_joined__item__partyId),
        (u'cCCId', ___ConferencePartyChange_joined__item__cCCId),
        ])
    __ConferencePartyChange_joined__item_._ext = []
    _ConferencePartyChange_joined._cont = __ConferencePartyChange_joined__item_
    ConferencePartyChange._cont = ASN1Dict([
        (u'caseId', _ConferencePartyChange_caseId),
        (u'accessingElementId', _ConferencePartyChange_accessingElementId),
        (u'eventTime', _ConferencePartyChange_eventTime),
        (u'callId', _ConferencePartyChange_callId),
        (u'communicating', _ConferencePartyChange_communicating),
        (u'removed', _ConferencePartyChange_removed),
        (u'joined', _ConferencePartyChange_joined),
        ])
    ConferencePartyChange._ext = []
    
    #-----< DialedDigitExtraction >-----#
    DialedDigitExtraction = SEQ(name=u'DialedDigitExtraction', mode=MODE_TYPE)
    _DialedDigitExtraction_caseId = STR_VIS(name=u'caseId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CaseId')))
    _DialedDigitExtraction_accessingElementId = STR_VIS(name=u'accessingElementId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'AccessingElementId')))
    _DialedDigitExtraction_eventTime = TIME_GEN(name=u'eventTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'EventTime')))
    _DialedDigitExtraction_callId = SEQ(name=u'callId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CallId')))
    _DialedDigitExtraction_digits = STR_VIS(name=u'digits', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DialedDigitExtraction_digits._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    DialedDigitExtraction._cont = ASN1Dict([
        (u'caseId', _DialedDigitExtraction_caseId),
        (u'accessingElementId', _DialedDigitExtraction_accessingElementId),
        (u'eventTime', _DialedDigitExtraction_eventTime),
        (u'callId', _DialedDigitExtraction_callId),
        (u'digits', _DialedDigitExtraction_digits),
        ])
    DialedDigitExtraction._ext = []
    
    #-----< MediaReport >-----#
    MediaReport = SEQ(name=u'MediaReport', mode=MODE_TYPE)
    _MediaReport_caseId = STR_VIS(name=u'caseId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CaseId')))
    _MediaReport_accessingElementId = STR_VIS(name=u'accessingElementId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'AccessingElementId')))
    _MediaReport_eventTime = TIME_GEN(name=u'eventTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'EventTime')))
    _MediaReport_callId = SEQ(name=u'callId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CallId')))
    _MediaReport_subject = STR_UTF8(name=u'subject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'SDP')), opt=True)
    _MediaReport_associate = STR_UTF8(name=u'associate', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'SDP')), opt=True)
    MediaReport._cont = ASN1Dict([
        (u'caseId', _MediaReport_caseId),
        (u'accessingElementId', _MediaReport_accessingElementId),
        (u'eventTime', _MediaReport_eventTime),
        (u'callId', _MediaReport_callId),
        (u'subject', _MediaReport_subject),
        (u'associate', _MediaReport_associate),
        ])
    MediaReport._ext = []
    
    #-----< NetworkSignal >-----#
    NetworkSignal = SEQ(name=u'NetworkSignal', mode=MODE_TYPE)
    _NetworkSignal_caseId = STR_VIS(name=u'caseId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CaseId')))
    _NetworkSignal_accessingElementId = STR_VIS(name=u'accessingElementId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'AccessingElementId')))
    _NetworkSignal_eventTime = TIME_GEN(name=u'eventTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'EventTime')))
    _NetworkSignal_callId = SEQ(name=u'callId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CallId')))
    _NetworkSignal_alertingSignal = ENUM(name=u'alertingSignal', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'AlertingSignal')), opt=True)
    _NetworkSignal_subjectAudibleSignal = ENUM(name=u'subjectAudibleSignal', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'AudibleSignal')), opt=True)
    _NetworkSignal_terminalDisplayInfo = SEQ(name=u'terminalDisplayInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'TerminalDisplayInfo')), opt=True)
    _NetworkSignal_other = STR_VIS(name=u'other', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NetworkSignal_other._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=[], er=[])
    _NetworkSignal_signaledToPartyId = SEQ(name=u'signaledToPartyId', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'PartyId')))
    NetworkSignal._cont = ASN1Dict([
        (u'caseId', _NetworkSignal_caseId),
        (u'accessingElementId', _NetworkSignal_accessingElementId),
        (u'eventTime', _NetworkSignal_eventTime),
        (u'callId', _NetworkSignal_callId),
        (u'alertingSignal', _NetworkSignal_alertingSignal),
        (u'subjectAudibleSignal', _NetworkSignal_subjectAudibleSignal),
        (u'terminalDisplayInfo', _NetworkSignal_terminalDisplayInfo),
        (u'other', _NetworkSignal_other),
        (u'signaledToPartyId', _NetworkSignal_signaledToPartyId),
        ])
    NetworkSignal._ext = []
    
    #-----< Origination >-----#
    Origination = SEQ(name=u'Origination', mode=MODE_TYPE)
    _Origination_caseId = STR_VIS(name=u'caseId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CaseId')))
    _Origination_accessingElementId = STR_VIS(name=u'accessingElementId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'AccessingElementId')))
    _Origination_eventTime = TIME_GEN(name=u'eventTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'EventTime')))
    _Origination_callId = SEQ(name=u'callId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CallId')))
    _Origination_calling = SEQ(name=u'calling', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'PartyId')))
    _Origination_called = SEQ(name=u'called', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'PartyId')), opt=True)
    _Origination_input = CHOICE(name=u'input', mode=MODE_TYPE)
    __Origination_input_userinput = STR_VIS(name=u'userinput', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Origination_input_userinput._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    __Origination_input_translationinput = STR_VIS(name=u'translationinput', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Origination_input_translationinput._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    _Origination_input._cont = ASN1Dict([
        (u'userinput', __Origination_input_userinput),
        (u'translationinput', __Origination_input_translationinput),
        ])
    _Origination_input._ext = []
    _Origination_reserved0 = NULL(name=u'reserved0', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Origination_transitCarrierId = STR_VIS(name=u'transitCarrierId', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'TransitCarrierId')), opt=True)
    Origination._cont = ASN1Dict([
        (u'caseId', _Origination_caseId),
        (u'accessingElementId', _Origination_accessingElementId),
        (u'eventTime', _Origination_eventTime),
        (u'callId', _Origination_callId),
        (u'calling', _Origination_calling),
        (u'called', _Origination_called),
        (u'input', _Origination_input),
        (u'reserved0', _Origination_reserved0),
        (u'transitCarrierId', _Origination_transitCarrierId),
        ])
    Origination._ext = []
    
    #-----< Redirection >-----#
    Redirection = SEQ(name=u'Redirection', mode=MODE_TYPE)
    _Redirection_caseId = STR_VIS(name=u'caseId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CaseId')))
    _Redirection_accessingElementId = STR_VIS(name=u'accessingElementId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'AccessingElementId')))
    _Redirection_eventTime = TIME_GEN(name=u'eventTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'EventTime')))
    _Redirection_old = SEQ(name=u'old', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CallId')))
    _Redirection_redirectedto = SEQ(name=u'redirectedto', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'PartyId')))
    _Redirection_transitCarrierId = STR_VIS(name=u'transitCarrierId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'TransitCarrierId')), opt=True)
    _Redirection_reserved0 = NULL(name=u'reserved0', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Redirection_reserved1 = NULL(name=u'reserved1', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Redirection_new = SEQ(name=u'new', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CallId')), opt=True)
    _Redirection_redirectedfrom = SEQ(name=u'redirectedfrom', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'PartyId')), opt=True)
    Redirection._cont = ASN1Dict([
        (u'caseId', _Redirection_caseId),
        (u'accessingElementId', _Redirection_accessingElementId),
        (u'eventTime', _Redirection_eventTime),
        (u'old', _Redirection_old),
        (u'redirectedto', _Redirection_redirectedto),
        (u'transitCarrierId', _Redirection_transitCarrierId),
        (u'reserved0', _Redirection_reserved0),
        (u'reserved1', _Redirection_reserved1),
        (u'new', _Redirection_new),
        (u'redirectedfrom', _Redirection_redirectedfrom),
        ])
    Redirection._ext = []
    
    #-----< Release >-----#
    Release = SEQ(name=u'Release', mode=MODE_TYPE)
    _Release_caseId = STR_VIS(name=u'caseId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CaseId')))
    _Release_accessingElementId = STR_VIS(name=u'accessingElementId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'AccessingElementId')))
    _Release_eventTime = TIME_GEN(name=u'eventTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'EventTime')))
    _Release_callId = SEQ(name=u'callId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CallId')))
    Release._cont = ASN1Dict([
        (u'caseId', _Release_caseId),
        (u'accessingElementId', _Release_accessingElementId),
        (u'eventTime', _Release_eventTime),
        (u'callId', _Release_callId),
        ])
    Release._ext = []
    
    #-----< ServiceInstance >-----#
    ServiceInstance = SEQ(name=u'ServiceInstance', mode=MODE_TYPE)
    _ServiceInstance_caseId = STR_VIS(name=u'caseId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CaseId')))
    _ServiceInstance_accessingElementId = STR_VIS(name=u'accessingElementId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'AccessingElementId')))
    _ServiceInstance_eventTime = TIME_GEN(name=u'eventTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'EventTime')))
    _ServiceInstance_callId = SEQ(name=u'callId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CallId')))
    _ServiceInstance_relatedCallId = SEQ(name=u'relatedCallId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CallId')), opt=True)
    _ServiceInstance_serviceName = STR_VIS(name=u'serviceName', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ServiceInstance_serviceName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=[], er=[])
    _ServiceInstance_firstCallCalling = SEQ(name=u'firstCallCalling', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'PartyId')), opt=True)
    _ServiceInstance_secondCallCalling = SEQ(name=u'secondCallCalling', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'PartyId')), opt=True)
    _ServiceInstance_called = SEQ(name=u'called', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'PartyId')), opt=True)
    _ServiceInstance_calling = SEQ(name=u'calling', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'PartyId')), opt=True)
    ServiceInstance._cont = ASN1Dict([
        (u'caseId', _ServiceInstance_caseId),
        (u'accessingElementId', _ServiceInstance_accessingElementId),
        (u'eventTime', _ServiceInstance_eventTime),
        (u'callId', _ServiceInstance_callId),
        (u'relatedCallId', _ServiceInstance_relatedCallId),
        (u'serviceName', _ServiceInstance_serviceName),
        (u'firstCallCalling', _ServiceInstance_firstCallCalling),
        (u'secondCallCalling', _ServiceInstance_secondCallCalling),
        (u'called', _ServiceInstance_called),
        (u'calling', _ServiceInstance_calling),
        ])
    ServiceInstance._ext = []
    
    #-----< SubjectSignal >-----#
    SubjectSignal = SEQ(name=u'SubjectSignal', mode=MODE_TYPE)
    _SubjectSignal_caseId = STR_VIS(name=u'caseId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CaseId')))
    _SubjectSignal_accessingElementId = STR_VIS(name=u'accessingElementId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'AccessingElementId')))
    _SubjectSignal_eventTime = TIME_GEN(name=u'eventTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'EventTime')))
    _SubjectSignal_callId = SEQ(name=u'callId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CallId')), opt=True)
    _SubjectSignal_signal = SEQ(name=u'signal', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SubjectSignal_signal_switchhookFlash = STR_VIS(name=u'switchhookFlash', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SubjectSignal_signal_switchhookFlash._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=[], er=[])
    __SubjectSignal_signal_dialedDigits = STR_VIS(name=u'dialedDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SubjectSignal_signal_dialedDigits._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=[], er=[])
    __SubjectSignal_signal_featureKey = STR_VIS(name=u'featureKey', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SubjectSignal_signal_featureKey._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=[], er=[])
    __SubjectSignal_signal_otherSignalingInformation = STR_VIS(name=u'otherSignalingInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SubjectSignal_signal_otherSignalingInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=[], er=[])
    _SubjectSignal_signal._cont = ASN1Dict([
        (u'switchhookFlash', __SubjectSignal_signal_switchhookFlash),
        (u'dialedDigits', __SubjectSignal_signal_dialedDigits),
        (u'featureKey', __SubjectSignal_signal_featureKey),
        (u'otherSignalingInformation', __SubjectSignal_signal_otherSignalingInformation),
        ])
    _SubjectSignal_signal._ext = []
    _SubjectSignal_signaledFromPartyId = SEQ(name=u'signaledFromPartyId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'PartyId')))
    SubjectSignal._cont = ASN1Dict([
        (u'caseId', _SubjectSignal_caseId),
        (u'accessingElementId', _SubjectSignal_accessingElementId),
        (u'eventTime', _SubjectSignal_eventTime),
        (u'callId', _SubjectSignal_callId),
        (u'signal', _SubjectSignal_signal),
        (u'signaledFromPartyId', _SubjectSignal_signaledFromPartyId),
        ])
    SubjectSignal._ext = []
    
    #-----< TerminationAttempt >-----#
    TerminationAttempt = SEQ(name=u'TerminationAttempt', mode=MODE_TYPE)
    _TerminationAttempt_caseId = STR_VIS(name=u'caseId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CaseId')))
    _TerminationAttempt_accessingElementId = STR_VIS(name=u'accessingElementId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'AccessingElementId')))
    _TerminationAttempt_eventTime = TIME_GEN(name=u'eventTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'EventTime')))
    _TerminationAttempt_callId = SEQ(name=u'callId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CallId')))
    _TerminationAttempt_calling = SEQ(name=u'calling', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'PartyId')), opt=True)
    _TerminationAttempt_called = SEQ(name=u'called', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'PartyId')), opt=True)
    _TerminationAttempt_reserved0 = NULL(name=u'reserved0', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TerminationAttempt_redirectedFromInfo = SEQ(name=u'redirectedFromInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'RedirectedFromInfo')), opt=True)
    TerminationAttempt._cont = ASN1Dict([
        (u'caseId', _TerminationAttempt_caseId),
        (u'accessingElementId', _TerminationAttempt_accessingElementId),
        (u'eventTime', _TerminationAttempt_eventTime),
        (u'callId', _TerminationAttempt_callId),
        (u'calling', _TerminationAttempt_calling),
        (u'called', _TerminationAttempt_called),
        (u'reserved0', _TerminationAttempt_reserved0),
        (u'redirectedFromInfo', _TerminationAttempt_redirectedFromInfo),
        ])
    TerminationAttempt._ext = []
    
    #-----< AccessingElementId >-----#
    AccessingElementId = STR_VIS(name=u'AccessingElementId', mode=MODE_TYPE)
    AccessingElementId._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=[], er=[])
    
    #-----< AlertingSignal >-----#
    AlertingSignal = ENUM(name=u'AlertingSignal', mode=MODE_TYPE)
    AlertingSignal._cont = ASN1Dict([(u'notUsed', 0), (u'alertingPattern0', 1), (u'alertingPattern1', 2), (u'alertingPattern2', 3), (u'alertingPattern3', 4), (u'alertingPattern4', 5), (u'callWaitingPattern1', 6), (u'callWaitingPattern2', 7), (u'callWaitingPattern3', 8), (u'callWaitingPattern4', 9), (u'bargeInTone', 10), (u'alertingPattern5', 11), (u'alertingPattern6', 12), (u'alertingPattern7', 13), (u'alertingPattern8', 14), (u'alertingPattern9', 15)])
    AlertingSignal._ext = []
    
    #-----< AudibleSignal >-----#
    AudibleSignal = ENUM(name=u'AudibleSignal', mode=MODE_TYPE)
    AudibleSignal._cont = ASN1Dict([(u'notUsed', 0), (u'dialTone', 1), (u'recallDialTone', 2), (u'ringbackTone', 3), (u'reorderTone', 4), (u'busyTone', 5), (u'confirmationTone', 6), (u'expensiveRouteTone', 7), (u'messageWaitingTone', 8), (u'receiverOffHookTone', 9), (u'specialInfoTone', 10), (u'denialTone', 11), (u'interceptTone', 12), (u'answerTone', 13), (u'tonesOff', 14), (u'pipTone', 15), (u'abbreviatedIntercept', 16), (u'abbreviatedCongestion', 17), (u'warningTone', 18), (u'dialToneBurst', 19), (u'numberUnObtainableTone', 20), (u'authenticationFailureTone', 21)])
    AudibleSignal._ext = []
    
    #-----< CallId >-----#
    CallId = SEQ(name=u'CallId', mode=MODE_TYPE)
    _CallId_sequencenumber = STR_VIS(name=u'sequencenumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CallId_sequencenumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=25)], ev=[], er=[])
    _CallId_systemidentity = STR_VIS(name=u'systemidentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CallId_systemidentity._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=[], er=[])
    CallId._cont = ASN1Dict([
        (u'sequencenumber', _CallId_sequencenumber),
        (u'systemidentity', _CallId_systemidentity),
        ])
    CallId._ext = []
    
    #-----< CaseId >-----#
    CaseId = STR_VIS(name=u'CaseId', mode=MODE_TYPE)
    CaseId._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=25)], ev=[], er=[])
    
    #-----< CCCId >-----#
    CCCId = CHOICE(name=u'CCCId', mode=MODE_TYPE)
    _CCCId_combCCC = STR_VIS(name=u'combCCC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CCCId_combCCC._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    _CCCId_sepCCCpair = SEQ(name=u'sepCCCpair', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CCCId_sepCCCpair_sepXmitCCC = STR_VIS(name=u'sepXmitCCC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CCCId_sepCCCpair_sepXmitCCC._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    __CCCId_sepCCCpair_sepRecvCCC = STR_VIS(name=u'sepRecvCCC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CCCId_sepCCCpair_sepRecvCCC._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    _CCCId_sepCCCpair._cont = ASN1Dict([
        (u'sepXmitCCC', __CCCId_sepCCCpair_sepXmitCCC),
        (u'sepRecvCCC', __CCCId_sepCCCpair_sepRecvCCC),
        ])
    _CCCId_sepCCCpair._ext = []
    CCCId._cont = ASN1Dict([
        (u'combCCC', _CCCId_combCCC),
        (u'sepCCCpair', _CCCId_sepCCCpair),
        ])
    CCCId._ext = []
    
    #-----< EventTime >-----#
    EventTime = TIME_GEN(name=u'EventTime', mode=MODE_TYPE)
    
    #-----< FlowDirection >-----#
    FlowDirection = ENUM(name=u'FlowDirection', mode=MODE_TYPE)
    FlowDirection._cont = ASN1Dict([(u'downstream', 1), (u'upstream', 2), (u'downstream-and-upstream', 3)])
    FlowDirection._ext = []
    
    #-----< PartyId >-----#
    PartyId = SEQ(name=u'PartyId', mode=MODE_TYPE)
    _PartyId_reserved0 = NULL(name=u'reserved0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PartyId_reserved1 = NULL(name=u'reserved1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PartyId_reserved2 = NULL(name=u'reserved2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PartyId_reserved3 = NULL(name=u'reserved3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PartyId_reserved4 = NULL(name=u'reserved4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PartyId_reserved5 = NULL(name=u'reserved5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PartyId_dn = STR_VIS(name=u'dn', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PartyId_dn._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=[], er=[])
    _PartyId_userProvided = STR_VIS(name=u'userProvided', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PartyId_userProvided._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=[], er=[])
    _PartyId_reserved6 = NULL(name=u'reserved6', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PartyId_reserved7 = NULL(name=u'reserved7', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PartyId_ipAddress = STR_VIS(name=u'ipAddress', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PartyId_ipAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    _PartyId_reserved8 = NULL(name=u'reserved8', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PartyId_trunkId = STR_VIS(name=u'trunkId', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PartyId_trunkId._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    _PartyId_reserved9 = NULL(name=u'reserved9', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PartyId_genericAddress = STR_VIS(name=u'genericAddress', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PartyId_genericAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    _PartyId_genericDigits = STR_VIS(name=u'genericDigits', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PartyId_genericDigits._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    _PartyId_genericName = STR_VIS(name=u'genericName', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PartyId_genericName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=48)], ev=[], er=[])
    _PartyId_port = STR_VIS(name=u'port', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PartyId_port._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    _PartyId_context = STR_VIS(name=u'context', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PartyId_context._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    PartyId._cont = ASN1Dict([
        (u'reserved0', _PartyId_reserved0),
        (u'reserved1', _PartyId_reserved1),
        (u'reserved2', _PartyId_reserved2),
        (u'reserved3', _PartyId_reserved3),
        (u'reserved4', _PartyId_reserved4),
        (u'reserved5', _PartyId_reserved5),
        (u'dn', _PartyId_dn),
        (u'userProvided', _PartyId_userProvided),
        (u'reserved6', _PartyId_reserved6),
        (u'reserved7', _PartyId_reserved7),
        (u'ipAddress', _PartyId_ipAddress),
        (u'reserved8', _PartyId_reserved8),
        (u'trunkId', _PartyId_trunkId),
        (u'reserved9', _PartyId_reserved9),
        (u'genericAddress', _PartyId_genericAddress),
        (u'genericDigits', _PartyId_genericDigits),
        (u'genericName', _PartyId_genericName),
        (u'port', _PartyId_port),
        (u'context', _PartyId_context),
        ])
    PartyId._ext = []
    
    #-----< RedirectedFromInfo >-----#
    RedirectedFromInfo = SEQ(name=u'RedirectedFromInfo', mode=MODE_TYPE)
    _RedirectedFromInfo_lastRedirecting = SEQ(name=u'lastRedirecting', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'PartyId')), opt=True)
    _RedirectedFromInfo_originalCalled = SEQ(name=u'originalCalled', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'PartyId')), opt=True)
    _RedirectedFromInfo_numRedirections = INT(name=u'numRedirections', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RedirectedFromInfo_numRedirections._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=[], er=[])
    RedirectedFromInfo._cont = ASN1Dict([
        (u'lastRedirecting', _RedirectedFromInfo_lastRedirecting),
        (u'originalCalled', _RedirectedFromInfo_originalCalled),
        (u'numRedirections', _RedirectedFromInfo_numRedirections),
        ])
    RedirectedFromInfo._ext = []
    
    #-----< ResourceState >-----#
    ResourceState = ENUM(name=u'ResourceState', mode=MODE_TYPE)
    ResourceState._cont = ASN1Dict([(u'reserved', 1), (u'committed', 2)])
    ResourceState._ext = []
    
    #-----< SDP >-----#
    SDP = STR_UTF8(name=u'SDP', mode=MODE_TYPE)
    
    #-----< TerminalDisplayInfo >-----#
    TerminalDisplayInfo = SEQ(name=u'TerminalDisplayInfo', mode=MODE_TYPE)
    _TerminalDisplayInfo_generalDisplay = STR_VIS(name=u'generalDisplay', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TerminalDisplayInfo_generalDisplay._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=80)], ev=[], er=[])
    _TerminalDisplayInfo_calledNumber = STR_VIS(name=u'calledNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TerminalDisplayInfo_calledNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=[], er=[])
    _TerminalDisplayInfo_callingNumber = STR_VIS(name=u'callingNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TerminalDisplayInfo_callingNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=[], er=[])
    _TerminalDisplayInfo_callingName = STR_VIS(name=u'callingName', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TerminalDisplayInfo_callingName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=[], er=[])
    _TerminalDisplayInfo_originalCalledNumber = STR_VIS(name=u'originalCalledNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TerminalDisplayInfo_originalCalledNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=[], er=[])
    _TerminalDisplayInfo_lastRedirectingNumber = STR_VIS(name=u'lastRedirectingNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TerminalDisplayInfo_lastRedirectingNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=[], er=[])
    _TerminalDisplayInfo_redirectingName = STR_VIS(name=u'redirectingName', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TerminalDisplayInfo_redirectingName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=[], er=[])
    _TerminalDisplayInfo_redirectingReason = STR_VIS(name=u'redirectingReason', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TerminalDisplayInfo_redirectingReason._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=[], er=[])
    _TerminalDisplayInfo_messageWaitingNotif = STR_VIS(name=u'messageWaitingNotif', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TerminalDisplayInfo_messageWaitingNotif._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=[], er=[])
    TerminalDisplayInfo._cont = ASN1Dict([
        (u'generalDisplay', _TerminalDisplayInfo_generalDisplay),
        (u'calledNumber', _TerminalDisplayInfo_calledNumber),
        (u'callingNumber', _TerminalDisplayInfo_callingNumber),
        (u'callingName', _TerminalDisplayInfo_callingName),
        (u'originalCalledNumber', _TerminalDisplayInfo_originalCalledNumber),
        (u'lastRedirectingNumber', _TerminalDisplayInfo_lastRedirectingNumber),
        (u'redirectingName', _TerminalDisplayInfo_redirectingName),
        (u'redirectingReason', _TerminalDisplayInfo_redirectingReason),
        (u'messageWaitingNotif', _TerminalDisplayInfo_messageWaitingNotif),
        ])
    TerminalDisplayInfo._ext = []
    
    #-----< TransitCarrierId >-----#
    TransitCarrierId = STR_VIS(name=u'TransitCarrierId', mode=MODE_TYPE)
    TransitCarrierId._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=7)], ev=[], er=[])
    
    _all_ = [
        ProtocolVersion,
        _CdcPdu_protocolVersion,
        _CdcPdu_message,
        CdcPdu,
        _Message_answer,
        _Message_ccclose,
        _Message_ccopen,
        _Message_reserved0,
        _Message_origination,
        _Message_reserved1,
        _Message_redirection,
        _Message_release,
        _Message_reserved2,
        _Message_terminationattempt,
        _Message_reserved,
        _Message_ccchange,
        _Message_reserved3,
        _Message_reserved4,
        _Message_dialeddigitextraction,
        _Message_networksignal,
        _Message_subjectsignal,
        _Message_mediareport,
        _Message_serviceinstance,
        _Message_confpartychange,
        Message,
        _Answer_caseId,
        _Answer_accessingElementId,
        _Answer_eventTime,
        _Answer_callId,
        _Answer_answering,
        Answer,
        _CCChange_caseId,
        _CCChange_accessingElementId,
        _CCChange_eventTime,
        _CCChange_callId,
        _CCChange_cCCId,
        _CCChange_subject,
        _CCChange_associate,
        _CCChange_flowDirection,
        _CCChange_resourceState,
        CCChange,
        _CCClose_caseId,
        _CCClose_accessingElementId,
        _CCClose_eventTime,
        _CCClose_cCCId,
        _CCClose_flowDirection,
        CCClose,
        _CCOpen_caseId,
        _CCOpen_accessingElementId,
        _CCOpen_eventTime,
        ___CCOpen_ccOpenOption_ccOpenTime__item_,
        __CCOpen_ccOpenOption_ccOpenTime,
        __CCOpen_ccOpenOption_reserved0,
        _CCOpen_ccOpenOption,
        _CCOpen_cCCId,
        _CCOpen_subject,
        _CCOpen_associate,
        _CCOpen_flowDirection,
        CCOpen,
        _ConferencePartyChange_caseId,
        _ConferencePartyChange_accessingElementId,
        _ConferencePartyChange_eventTime,
        _ConferencePartyChange_callId,
        ____ConferencePartyChange_communicating__item__partyId__item_,
        ___ConferencePartyChange_communicating__item__partyId,
        ___ConferencePartyChange_communicating__item__cCCId,
        __ConferencePartyChange_communicating__item_,
        _ConferencePartyChange_communicating,
        ____ConferencePartyChange_removed__item__partyId__item_,
        ___ConferencePartyChange_removed__item__partyId,
        ___ConferencePartyChange_removed__item__cCCId,
        __ConferencePartyChange_removed__item_,
        _ConferencePartyChange_removed,
        ____ConferencePartyChange_joined__item__partyId__item_,
        ___ConferencePartyChange_joined__item__partyId,
        ___ConferencePartyChange_joined__item__cCCId,
        __ConferencePartyChange_joined__item_,
        _ConferencePartyChange_joined,
        ConferencePartyChange,
        _DialedDigitExtraction_caseId,
        _DialedDigitExtraction_accessingElementId,
        _DialedDigitExtraction_eventTime,
        _DialedDigitExtraction_callId,
        _DialedDigitExtraction_digits,
        DialedDigitExtraction,
        _MediaReport_caseId,
        _MediaReport_accessingElementId,
        _MediaReport_eventTime,
        _MediaReport_callId,
        _MediaReport_subject,
        _MediaReport_associate,
        MediaReport,
        _NetworkSignal_caseId,
        _NetworkSignal_accessingElementId,
        _NetworkSignal_eventTime,
        _NetworkSignal_callId,
        _NetworkSignal_alertingSignal,
        _NetworkSignal_subjectAudibleSignal,
        _NetworkSignal_terminalDisplayInfo,
        _NetworkSignal_other,
        _NetworkSignal_signaledToPartyId,
        NetworkSignal,
        _Origination_caseId,
        _Origination_accessingElementId,
        _Origination_eventTime,
        _Origination_callId,
        _Origination_calling,
        _Origination_called,
        __Origination_input_userinput,
        __Origination_input_translationinput,
        _Origination_input,
        _Origination_reserved0,
        _Origination_transitCarrierId,
        Origination,
        _Redirection_caseId,
        _Redirection_accessingElementId,
        _Redirection_eventTime,
        _Redirection_old,
        _Redirection_redirectedto,
        _Redirection_transitCarrierId,
        _Redirection_reserved0,
        _Redirection_reserved1,
        _Redirection_new,
        _Redirection_redirectedfrom,
        Redirection,
        _Release_caseId,
        _Release_accessingElementId,
        _Release_eventTime,
        _Release_callId,
        Release,
        _ServiceInstance_caseId,
        _ServiceInstance_accessingElementId,
        _ServiceInstance_eventTime,
        _ServiceInstance_callId,
        _ServiceInstance_relatedCallId,
        _ServiceInstance_serviceName,
        _ServiceInstance_firstCallCalling,
        _ServiceInstance_secondCallCalling,
        _ServiceInstance_called,
        _ServiceInstance_calling,
        ServiceInstance,
        _SubjectSignal_caseId,
        _SubjectSignal_accessingElementId,
        _SubjectSignal_eventTime,
        _SubjectSignal_callId,
        __SubjectSignal_signal_switchhookFlash,
        __SubjectSignal_signal_dialedDigits,
        __SubjectSignal_signal_featureKey,
        __SubjectSignal_signal_otherSignalingInformation,
        _SubjectSignal_signal,
        _SubjectSignal_signaledFromPartyId,
        SubjectSignal,
        _TerminationAttempt_caseId,
        _TerminationAttempt_accessingElementId,
        _TerminationAttempt_eventTime,
        _TerminationAttempt_callId,
        _TerminationAttempt_calling,
        _TerminationAttempt_called,
        _TerminationAttempt_reserved0,
        _TerminationAttempt_redirectedFromInfo,
        TerminationAttempt,
        AccessingElementId,
        AlertingSignal,
        AudibleSignal,
        _CallId_sequencenumber,
        _CallId_systemidentity,
        CallId,
        CaseId,
        _CCCId_combCCC,
        __CCCId_sepCCCpair_sepXmitCCC,
        __CCCId_sepCCCpair_sepRecvCCC,
        _CCCId_sepCCCpair,
        CCCId,
        EventTime,
        FlowDirection,
        _PartyId_reserved0,
        _PartyId_reserved1,
        _PartyId_reserved2,
        _PartyId_reserved3,
        _PartyId_reserved4,
        _PartyId_reserved5,
        _PartyId_dn,
        _PartyId_userProvided,
        _PartyId_reserved6,
        _PartyId_reserved7,
        _PartyId_ipAddress,
        _PartyId_reserved8,
        _PartyId_trunkId,
        _PartyId_reserved9,
        _PartyId_genericAddress,
        _PartyId_genericDigits,
        _PartyId_genericName,
        _PartyId_port,
        _PartyId_context,
        PartyId,
        _RedirectedFromInfo_lastRedirecting,
        _RedirectedFromInfo_originalCalled,
        _RedirectedFromInfo_numRedirections,
        RedirectedFromInfo,
        ResourceState,
        SDP,
        _TerminalDisplayInfo_generalDisplay,
        _TerminalDisplayInfo_calledNumber,
        _TerminalDisplayInfo_callingNumber,
        _TerminalDisplayInfo_callingName,
        _TerminalDisplayInfo_originalCalledNumber,
        _TerminalDisplayInfo_lastRedirectingNumber,
        _TerminalDisplayInfo_redirectingName,
        _TerminalDisplayInfo_redirectingReason,
        _TerminalDisplayInfo_messageWaitingNotif,
        TerminalDisplayInfo,
        TransitCarrierId,
    ]

class TS101909201:

    _name_  = u'TS101909201'
    _oid_   = [0, 4, 0, 1909, 20, 1, 0]
    
    _obj_ = [
        u'TARGETACTIVITYMONITOR-1',
        u'TTRAFFIC',
        u'CTTRAFFIC',
        u'DirectionType',
        u'UserSignalType',
        u'IRITransactionType',
        u'LocationType',
        u'LIIDType',
        ]
    _type_ = [
        u'TARGETACTIVITYMONITOR-1',
        u'TTRAFFIC',
        u'CTTRAFFIC',
        u'DirectionType',
        u'UserSignalType',
        u'IRITransactionType',
        u'LocationType',
        u'LIIDType',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< TARGETACTIVITYMONITOR-1 >-----#
    TARGETACTIVITYMONITOR_1 = SEQ(name=u'TARGETACTIVITYMONITOR-1', mode=MODE_TYPE)
    _TARGETACTIVITYMONITOR_1_version = INT(name=u'version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=1)
    _TARGETACTIVITYMONITOR_1_lIInstanceid = INT(name=u'lIInstanceid', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('TS101909201', 'LIIDType')))
    _TARGETACTIVITYMONITOR_1_timestamp = TIME_UTC(name=u'timestamp', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TARGETACTIVITYMONITOR_1_targetLocation = CHOICE(name=u'targetLocation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('TS101909201', 'LocationType')))
    _TARGETACTIVITYMONITOR_1_direction = ENUM(name=u'direction', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('TS101909201', 'DirectionType')))
    _TARGETACTIVITYMONITOR_1_iRITransaction = ENUM(name=u'iRITransaction', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('TS101909201', 'IRITransactionType')), default=u'iRIreport')
    _TARGETACTIVITYMONITOR_1_iRITransactionNumber = INT(name=u'iRITransactionNumber', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TARGETACTIVITYMONITOR_1_userSignal = CHOICE(name=u'userSignal', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('TS101909201', 'UserSignalType')))
    _TARGETACTIVITYMONITOR_1_cryptoCheckSum = BIT_STR(name=u'cryptoCheckSum', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    TARGETACTIVITYMONITOR_1._cont = ASN1Dict([
        (u'version', _TARGETACTIVITYMONITOR_1_version),
        (u'lIInstanceid', _TARGETACTIVITYMONITOR_1_lIInstanceid),
        (u'timestamp', _TARGETACTIVITYMONITOR_1_timestamp),
        (u'targetLocation', _TARGETACTIVITYMONITOR_1_targetLocation),
        (u'direction', _TARGETACTIVITYMONITOR_1_direction),
        (u'iRITransaction', _TARGETACTIVITYMONITOR_1_iRITransaction),
        (u'iRITransactionNumber', _TARGETACTIVITYMONITOR_1_iRITransactionNumber),
        (u'userSignal', _TARGETACTIVITYMONITOR_1_userSignal),
        (u'cryptoCheckSum', _TARGETACTIVITYMONITOR_1_cryptoCheckSum),
        ])
    TARGETACTIVITYMONITOR_1._ext = None
    
    #-----< TTRAFFIC >-----#
    TTRAFFIC = SEQ(name=u'TTRAFFIC', mode=MODE_TYPE)
    _TTRAFFIC_version = INT(name=u'version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=1)
    _TTRAFFIC_lIInstanceid = INT(name=u'lIInstanceid', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('TS101909201', 'LIIDType')))
    _TTRAFFIC_iRITransactionNumber = INT(name=u'iRITransactionNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TTRAFFIC_trafficPacket = BIT_STR(name=u'trafficPacket', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TTRAFFIC_cryptoChecksum = BIT_STR(name=u'cryptoChecksum', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    TTRAFFIC._cont = ASN1Dict([
        (u'version', _TTRAFFIC_version),
        (u'lIInstanceid', _TTRAFFIC_lIInstanceid),
        (u'iRITransactionNumber', _TTRAFFIC_iRITransactionNumber),
        (u'trafficPacket', _TTRAFFIC_trafficPacket),
        (u'cryptoChecksum', _TTRAFFIC_cryptoChecksum),
        ])
    TTRAFFIC._ext = None
    
    #-----< CTTRAFFIC >-----#
    CTTRAFFIC = SEQ(name=u'CTTRAFFIC', mode=MODE_TYPE)
    _CTTRAFFIC_version = INT(name=u'version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=1)
    _CTTRAFFIC_lIInstanceid = INT(name=u'lIInstanceid', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('TS101909201', 'LIIDType')))
    _CTTRAFFIC_correspondentCount = INT(name=u'correspondentCount', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CTTRAFFIC_iRITransactionNumber = INT(name=u'iRITransactionNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CTTRAFFIC_trafficPacket = BIT_STR(name=u'trafficPacket', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CTTRAFFIC_cryptoChecksum = BIT_STR(name=u'cryptoChecksum', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    CTTRAFFIC._cont = ASN1Dict([
        (u'version', _CTTRAFFIC_version),
        (u'lIInstanceid', _CTTRAFFIC_lIInstanceid),
        (u'correspondentCount', _CTTRAFFIC_correspondentCount),
        (u'iRITransactionNumber', _CTTRAFFIC_iRITransactionNumber),
        (u'trafficPacket', _CTTRAFFIC_trafficPacket),
        (u'cryptoChecksum', _CTTRAFFIC_cryptoChecksum),
        ])
    CTTRAFFIC._ext = None
    
    #-----< DirectionType >-----#
    DirectionType = ENUM(name=u'DirectionType', mode=MODE_TYPE)
    DirectionType._cont = ASN1Dict([(u'toTarget', 0), (u'fromTarget', 1), (u'unknown', 2)])
    DirectionType._ext = None
    
    #-----< UserSignalType >-----#
    UserSignalType = CHOICE(name=u'UserSignalType', mode=MODE_TYPE)
    _UserSignalType_copySignal = BIT_STR(name=u'copySignal', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UserSignalType_interpretedSignal = INT(name=u'interpretedSignal', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UserSignalType_cdcPdu = SEQ(name=u'cdcPdu', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCESP', 'CdcPdu')))
    UserSignalType._cont = ASN1Dict([
        (u'copySignal', _UserSignalType_copySignal),
        (u'interpretedSignal', _UserSignalType_interpretedSignal),
        (u'cdcPdu', _UserSignalType_cdcPdu),
        ])
    UserSignalType._ext = None
    
    #-----< IRITransactionType >-----#
    IRITransactionType = ENUM(name=u'IRITransactionType', mode=MODE_TYPE)
    IRITransactionType._cont = ASN1Dict([(u'iRIbegin', 0), (u'iRIcontinue', 1), (u'iRIend', 2), (u'iRIreport', 3)])
    IRITransactionType._ext = None
    
    #-----< LocationType >-----#
    LocationType = CHOICE(name=u'LocationType', mode=MODE_TYPE)
    _LocationType_geodeticData = BIT_STR(name=u'geodeticData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationType_nameAddress = STR_PRINT(name=u'nameAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationType_nameAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    LocationType._cont = ASN1Dict([
        (u'geodeticData', _LocationType_geodeticData),
        (u'nameAddress', _LocationType_nameAddress),
        ])
    LocationType._ext = None
    
    #-----< LIIDType >-----#
    LIIDType = INT(name=u'LIIDType', mode=MODE_TYPE)
    LIIDType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    _all_ = [
        _TARGETACTIVITYMONITOR_1_version,
        _TARGETACTIVITYMONITOR_1_lIInstanceid,
        _TARGETACTIVITYMONITOR_1_timestamp,
        _TARGETACTIVITYMONITOR_1_targetLocation,
        _TARGETACTIVITYMONITOR_1_direction,
        _TARGETACTIVITYMONITOR_1_iRITransaction,
        _TARGETACTIVITYMONITOR_1_iRITransactionNumber,
        _TARGETACTIVITYMONITOR_1_userSignal,
        _TARGETACTIVITYMONITOR_1_cryptoCheckSum,
        TARGETACTIVITYMONITOR_1,
        _TTRAFFIC_version,
        _TTRAFFIC_lIInstanceid,
        _TTRAFFIC_iRITransactionNumber,
        _TTRAFFIC_trafficPacket,
        _TTRAFFIC_cryptoChecksum,
        TTRAFFIC,
        _CTTRAFFIC_version,
        _CTTRAFFIC_lIInstanceid,
        _CTTRAFFIC_correspondentCount,
        _CTTRAFFIC_iRITransactionNumber,
        _CTTRAFFIC_trafficPacket,
        _CTTRAFFIC_cryptoChecksum,
        CTTRAFFIC,
        DirectionType,
        _UserSignalType_copySignal,
        _UserSignalType_interpretedSignal,
        _UserSignalType_cdcPdu,
        UserSignalType,
        IRITransactionType,
        _LocationType_geodeticData,
        _LocationType_nameAddress,
        LocationType,
        LIIDType,
    ]

class ThreeGPP_HI1NotificationOperations:

    _name_  = u'ThreeGPP-HI1NotificationOperations'
    _oid_   = [0, 4, 0, 2, 2, 4, 0, 1, 16, 0]
    
    _obj_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'threeGPP-hi1NotificationOperationsId',
        u'threeGPP-hi1OperationId',
        u'ThreeGPP-HI1-Operation',
        u'Notification',
        u'Alarm-Indicator',
        u'ThreeGPP-National-HI1-ASN1parameters',
        u'Target-Information',
        u'TargetType',
        u'DeliveryInformation',
        u'InterceptionType',
        u'BroadcastStatus',
        ]
    _type_ = [
        u'ThreeGPP-HI1-Operation',
        u'Notification',
        u'Alarm-Indicator',
        u'ThreeGPP-National-HI1-ASN1parameters',
        u'Target-Information',
        u'TargetType',
        u'DeliveryInformation',
        u'InterceptionType',
        u'BroadcastStatus',
        ]
    _set_ = [
        ]
    _val_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'threeGPP-hi1NotificationOperationsId',
        u'threeGPP-hi1OperationId',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< lawfulInterceptDomainId >-----#
    lawfulInterceptDomainId = OID(name=u'lawfulInterceptDomainId', mode=MODE_VALUE)
    lawfulInterceptDomainId._val = (0, 4, 0, 2, 2)
    
    #-----< threeGPPSUBDomainId >-----#
    threeGPPSUBDomainId = OID(name=u'threeGPPSUBDomainId', mode=MODE_VALUE)
    threeGPPSUBDomainId._val = (0, 4, 0, 2, 2, 4)
    
    #-----< threeGPP-hi1NotificationOperationsId >-----#
    threeGPP_hi1NotificationOperationsId = OID(name=u'threeGPP-hi1NotificationOperationsId', mode=MODE_VALUE)
    threeGPP_hi1NotificationOperationsId._val = (0, 4, 0, 2, 2, 4, 0, 1)
    
    #-----< threeGPP-hi1OperationId >-----#
    threeGPP_hi1OperationId = OID(name=u'threeGPP-hi1OperationId', mode=MODE_VALUE)
    threeGPP_hi1OperationId._val = (0, 4, 0, 2, 2, 4, 0, 1, 16, 0)
    
    #-----< ThreeGPP-HI1-Operation >-----#
    ThreeGPP_HI1_Operation = CHOICE(name=u'ThreeGPP-HI1-Operation', mode=MODE_TYPE)
    _ThreeGPP_HI1_Operation_liActivated = SEQ(name=u'liActivated', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ThreeGPP-HI1NotificationOperations', 'Notification')))
    _ThreeGPP_HI1_Operation_liDeactivated = SEQ(name=u'liDeactivated', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ThreeGPP-HI1NotificationOperations', 'Notification')))
    _ThreeGPP_HI1_Operation_liModified = SEQ(name=u'liModified', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ThreeGPP-HI1NotificationOperations', 'Notification')))
    _ThreeGPP_HI1_Operation_alarms_indicator = SEQ(name=u'alarms-indicator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ThreeGPP-HI1NotificationOperations', 'Alarm-Indicator')))
    _ThreeGPP_HI1_Operation_threeGPP_National_HI1_ASN1parameters = SEQ(name=u'threeGPP-National-HI1-ASN1parameters', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ThreeGPP-HI1NotificationOperations', 'ThreeGPP-National-HI1-ASN1parameters')))
    ThreeGPP_HI1_Operation._cont = ASN1Dict([
        (u'liActivated', _ThreeGPP_HI1_Operation_liActivated),
        (u'liDeactivated', _ThreeGPP_HI1_Operation_liDeactivated),
        (u'liModified', _ThreeGPP_HI1_Operation_liModified),
        (u'alarms-indicator', _ThreeGPP_HI1_Operation_alarms_indicator),
        (u'threeGPP-National-HI1-ASN1parameters', _ThreeGPP_HI1_Operation_threeGPP_National_HI1_ASN1parameters),
        ])
    ThreeGPP_HI1_Operation._ext = []
    
    #-----< Notification >-----#
    Notification = SEQ(name=u'Notification', mode=MODE_TYPE)
    _Notification_domainID = OID(name=u'domainID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Notification_lawfulInterceptionIdentifier = OCT_STR(name=u'lawfulInterceptionIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'LawfulInterceptionIdentifier')))
    _Notification_communicationIdentifier = SEQ(name=u'communicationIdentifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'CommunicationIdentifier')), opt=True)
    _Notification_timeStamp = CHOICE(name=u'timeStamp', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    _Notification_threeGPP_National_HI1_ASN1parameters = SEQ(name=u'threeGPP-National-HI1-ASN1parameters', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ThreeGPP-HI1NotificationOperations', 'ThreeGPP-National-HI1-ASN1parameters')), opt=True)
    _Notification_target_Information = SEQ(name=u'target-Information', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ThreeGPP-HI1NotificationOperations', 'Target-Information')), opt=True)
    _Notification_network_Identifier = SEQ(name=u'network-Identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'Network-Identifier')), opt=True)
    _Notification_broadcastStatus = ENUM(name=u'broadcastStatus', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ThreeGPP-HI1NotificationOperations', 'BroadcastStatus')), opt=True)
    Notification._cont = ASN1Dict([
        (u'domainID', _Notification_domainID),
        (u'lawfulInterceptionIdentifier', _Notification_lawfulInterceptionIdentifier),
        (u'communicationIdentifier', _Notification_communicationIdentifier),
        (u'timeStamp', _Notification_timeStamp),
        (u'threeGPP-National-HI1-ASN1parameters', _Notification_threeGPP_National_HI1_ASN1parameters),
        (u'target-Information', _Notification_target_Information),
        (u'network-Identifier', _Notification_network_Identifier),
        (u'broadcastStatus', _Notification_broadcastStatus),
        ])
    Notification._ext = []
    
    #-----< Alarm-Indicator >-----#
    Alarm_Indicator = SEQ(name=u'Alarm-Indicator', mode=MODE_TYPE)
    _Alarm_Indicator_domainID = OID(name=u'domainID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Alarm_Indicator_communicationIdentifier = SEQ(name=u'communicationIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'CommunicationIdentifier')), opt=True)
    _Alarm_Indicator_timeStamp = CHOICE(name=u'timeStamp', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    _Alarm_Indicator_alarm_information = OCT_STR(name=u'alarm-information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Alarm_Indicator_alarm_information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=25)], ev=None, er=[])
    _Alarm_Indicator_lawfulInterceptionIdentifier = OCT_STR(name=u'lawfulInterceptionIdentifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'LawfulInterceptionIdentifier')), opt=True)
    _Alarm_Indicator_threeGPP_National_HI1_ASN1parameters = SEQ(name=u'threeGPP-National-HI1-ASN1parameters', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ThreeGPP-HI1NotificationOperations', 'ThreeGPP-National-HI1-ASN1parameters')), opt=True)
    _Alarm_Indicator_target_Information = SEQ(name=u'target-Information', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ThreeGPP-HI1NotificationOperations', 'Target-Information')), opt=True)
    _Alarm_Indicator_network_Identifier = SEQ(name=u'network-Identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'Network-Identifier')), opt=True)
    _Alarm_Indicator_network_Element_Information = OCT_STR(name=u'network-Element-Information', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Alarm_Indicator_network_Element_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    Alarm_Indicator._cont = ASN1Dict([
        (u'domainID', _Alarm_Indicator_domainID),
        (u'communicationIdentifier', _Alarm_Indicator_communicationIdentifier),
        (u'timeStamp', _Alarm_Indicator_timeStamp),
        (u'alarm-information', _Alarm_Indicator_alarm_information),
        (u'lawfulInterceptionIdentifier', _Alarm_Indicator_lawfulInterceptionIdentifier),
        (u'threeGPP-National-HI1-ASN1parameters', _Alarm_Indicator_threeGPP_National_HI1_ASN1parameters),
        (u'target-Information', _Alarm_Indicator_target_Information),
        (u'network-Identifier', _Alarm_Indicator_network_Identifier),
        (u'network-Element-Information', _Alarm_Indicator_network_Element_Information),
        ])
    Alarm_Indicator._ext = []
    
    #-----< ThreeGPP-National-HI1-ASN1parameters >-----#
    ThreeGPP_National_HI1_ASN1parameters = SEQ(name=u'ThreeGPP-National-HI1-ASN1parameters', mode=MODE_TYPE)
    _ThreeGPP_National_HI1_ASN1parameters_domainID = OID(name=u'domainID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ThreeGPP_National_HI1_ASN1parameters_countryCode = STR_PRINT(name=u'countryCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ThreeGPP_National_HI1_ASN1parameters_countryCode._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ThreeGPP_National_HI1_ASN1parameters._cont = ASN1Dict([
        (u'domainID', _ThreeGPP_National_HI1_ASN1parameters_domainID),
        (u'countryCode', _ThreeGPP_National_HI1_ASN1parameters_countryCode),
        ])
    ThreeGPP_National_HI1_ASN1parameters._ext = []
    
    #-----< Target-Information >-----#
    Target_Information = SEQ(name=u'Target-Information', mode=MODE_TYPE)
    _Target_Information_communicationIdentifier = SEQ(name=u'communicationIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'CommunicationIdentifier')), opt=True)
    _Target_Information_network_Identifier = SEQ(name=u'network-Identifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'Network-Identifier')), opt=True)
    _Target_Information_broadcastArea = OCT_STR(name=u'broadcastArea', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Target_Information_broadcastArea._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _Target_Information_targetType = ENUM(name=u'targetType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ThreeGPP-HI1NotificationOperations', 'TargetType')), opt=True)
    _Target_Information_deliveryInformation = SEQ(name=u'deliveryInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ThreeGPP-HI1NotificationOperations', 'DeliveryInformation')), opt=True)
    _Target_Information_liActivatedTime = CHOICE(name=u'liActivatedTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')), opt=True)
    _Target_Information_liDeactivatedTime = CHOICE(name=u'liDeactivatedTime', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')), opt=True)
    _Target_Information_liModificationTime = CHOICE(name=u'liModificationTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')), opt=True)
    _Target_Information_interceptionType = ENUM(name=u'interceptionType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ThreeGPP-HI1NotificationOperations', 'InterceptionType')), opt=True)
    _Target_Information_liSetUpTime = CHOICE(name=u'liSetUpTime', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')), opt=True)
    Target_Information._cont = ASN1Dict([
        (u'communicationIdentifier', _Target_Information_communicationIdentifier),
        (u'network-Identifier', _Target_Information_network_Identifier),
        (u'broadcastArea', _Target_Information_broadcastArea),
        (u'targetType', _Target_Information_targetType),
        (u'deliveryInformation', _Target_Information_deliveryInformation),
        (u'liActivatedTime', _Target_Information_liActivatedTime),
        (u'liDeactivatedTime', _Target_Information_liDeactivatedTime),
        (u'liModificationTime', _Target_Information_liModificationTime),
        (u'interceptionType', _Target_Information_interceptionType),
        (u'liSetUpTime', _Target_Information_liSetUpTime),
        ])
    Target_Information._ext = [u'liSetUpTime']
    
    #-----< TargetType >-----#
    TargetType = ENUM(name=u'TargetType', mode=MODE_TYPE)
    TargetType._cont = ASN1Dict([(u'mSISDN', 0), (u'iMSI', 1), (u'iMEI', 2), (u'e164-Format', 3), (u'nAI', 4), (u'sip-URI', 5), (u'tel-URI', 6), (u'iMPU', 7), (u'iMPI', 8)])
    TargetType._ext = []
    
    #-----< DeliveryInformation >-----#
    DeliveryInformation = SEQ(name=u'DeliveryInformation', mode=MODE_TYPE)
    _DeliveryInformation_hi2DeliveryNumber = CHOICE(name=u'hi2DeliveryNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'CalledPartyNumber')), opt=True)
    _DeliveryInformation_hi3DeliveryNumber = CHOICE(name=u'hi3DeliveryNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'CalledPartyNumber')), opt=True)
    _DeliveryInformation_hi2DeliveryIpAddress = SEQ(name=u'hi2DeliveryIpAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IPAddress')), opt=True)
    _DeliveryInformation_hi3DeliveryIpAddress = SEQ(name=u'hi3DeliveryIpAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IPAddress')), opt=True)
    DeliveryInformation._cont = ASN1Dict([
        (u'hi2DeliveryNumber', _DeliveryInformation_hi2DeliveryNumber),
        (u'hi3DeliveryNumber', _DeliveryInformation_hi3DeliveryNumber),
        (u'hi2DeliveryIpAddress', _DeliveryInformation_hi2DeliveryIpAddress),
        (u'hi3DeliveryIpAddress', _DeliveryInformation_hi3DeliveryIpAddress),
        ])
    DeliveryInformation._ext = []
    
    #-----< InterceptionType >-----#
    InterceptionType = ENUM(name=u'InterceptionType', mode=MODE_TYPE)
    InterceptionType._cont = ASN1Dict([(u'voiceIriCc', 0), (u'voiceIriOnly', 1), (u'dataIriCc', 2), (u'dataIriOnly', 3), (u'voiceAndDataIriCc', 4), (u'voiceAndDataIriOnly', 5)])
    InterceptionType._ext = []
    
    #-----< BroadcastStatus >-----#
    BroadcastStatus = ENUM(name=u'BroadcastStatus', mode=MODE_TYPE)
    BroadcastStatus._cont = ASN1Dict([(u'succesfull', 0), (u'unsuccesfull', 1)])
    BroadcastStatus._ext = []
    
    _all_ = [
        lawfulInterceptDomainId,
        threeGPPSUBDomainId,
        threeGPP_hi1NotificationOperationsId,
        threeGPP_hi1OperationId,
        _ThreeGPP_HI1_Operation_liActivated,
        _ThreeGPP_HI1_Operation_liDeactivated,
        _ThreeGPP_HI1_Operation_liModified,
        _ThreeGPP_HI1_Operation_alarms_indicator,
        _ThreeGPP_HI1_Operation_threeGPP_National_HI1_ASN1parameters,
        ThreeGPP_HI1_Operation,
        _Notification_domainID,
        _Notification_lawfulInterceptionIdentifier,
        _Notification_communicationIdentifier,
        _Notification_timeStamp,
        _Notification_threeGPP_National_HI1_ASN1parameters,
        _Notification_target_Information,
        _Notification_network_Identifier,
        _Notification_broadcastStatus,
        Notification,
        _Alarm_Indicator_domainID,
        _Alarm_Indicator_communicationIdentifier,
        _Alarm_Indicator_timeStamp,
        _Alarm_Indicator_alarm_information,
        _Alarm_Indicator_lawfulInterceptionIdentifier,
        _Alarm_Indicator_threeGPP_National_HI1_ASN1parameters,
        _Alarm_Indicator_target_Information,
        _Alarm_Indicator_network_Identifier,
        _Alarm_Indicator_network_Element_Information,
        Alarm_Indicator,
        _ThreeGPP_National_HI1_ASN1parameters_domainID,
        _ThreeGPP_National_HI1_ASN1parameters_countryCode,
        ThreeGPP_National_HI1_ASN1parameters,
        _Target_Information_communicationIdentifier,
        _Target_Information_network_Identifier,
        _Target_Information_broadcastArea,
        _Target_Information_targetType,
        _Target_Information_deliveryInformation,
        _Target_Information_liActivatedTime,
        _Target_Information_liDeactivatedTime,
        _Target_Information_liModificationTime,
        _Target_Information_interceptionType,
        _Target_Information_liSetUpTime,
        Target_Information,
        TargetType,
        _DeliveryInformation_hi2DeliveryNumber,
        _DeliveryInformation_hi3DeliveryNumber,
        _DeliveryInformation_hi2DeliveryIpAddress,
        _DeliveryInformation_hi3DeliveryIpAddress,
        DeliveryInformation,
        InterceptionType,
        BroadcastStatus,
    ]

class UMTS_HI3CircuitLIOperations:

    _name_  = u'UMTS-HI3CircuitLIOperations'
    _oid_   = [0, 4, 0, 2, 2, 4, 4, 16, 0]
    
    _obj_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi3CSDomainId',
        u'UMTS-Content-Report',
        ]
    _type_ = [
        u'UMTS-Content-Report',
        ]
    _set_ = [
        ]
    _val_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi3CSDomainId',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< lawfulInterceptDomainId >-----#
    lawfulInterceptDomainId = OID(name=u'lawfulInterceptDomainId', mode=MODE_VALUE)
    lawfulInterceptDomainId._val = (0, 4, 0, 2, 2)
    
    #-----< threeGPPSUBDomainId >-----#
    threeGPPSUBDomainId = OID(name=u'threeGPPSUBDomainId', mode=MODE_VALUE)
    threeGPPSUBDomainId._val = (0, 4, 0, 2, 2, 4)
    
    #-----< hi3CSDomainId >-----#
    hi3CSDomainId = OID(name=u'hi3CSDomainId', mode=MODE_VALUE)
    hi3CSDomainId._val = (0, 4, 0, 2, 2, 4, 4, 16, 0)
    
    #-----< UMTS-Content-Report >-----#
    UMTS_Content_Report = SEQ(name=u'UMTS-Content-Report', mode=MODE_TYPE)
    _UMTS_Content_Report_hi3CSDomainId = OID(name=u'hi3CSDomainId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UMTS_Content_Report_version = ENUM(name=u'version', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UMTS_Content_Report_version._cont = ASN1Dict([(u'version1', 1), (u'version8', 8)])
    _UMTS_Content_Report_version._ext = [u'version8']
    _UMTS_Content_Report_lawfulInterceptionIdentifier = OCT_STR(name=u'lawfulInterceptionIdentifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'LawfulInterceptionIdentifier')), opt=True)
    _UMTS_Content_Report_communicationIdentifier = SEQ(name=u'communicationIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'CommunicationIdentifier')))
    _UMTS_Content_Report_timeStamp = CHOICE(name=u'timeStamp', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    _UMTS_Content_Report_initiator = ENUM(name=u'initiator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UMTS_Content_Report_initiator._cont = ASN1Dict([(u'originating-party', 0), (u'terminating-party', 1), (u'forwarded-to-party', 2), (u'undefined-party', 3)])
    _UMTS_Content_Report_initiator._ext = []
    _UMTS_Content_Report_content = SEQ(name=u'content', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'Supplementary-Services')), opt=True)
    _UMTS_Content_Report_sMS_report = SEQ(name=u'sMS-report', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'SMS-report')), opt=True)
    UMTS_Content_Report._cont = ASN1Dict([
        (u'hi3CSDomainId', _UMTS_Content_Report_hi3CSDomainId),
        (u'version', _UMTS_Content_Report_version),
        (u'lawfulInterceptionIdentifier', _UMTS_Content_Report_lawfulInterceptionIdentifier),
        (u'communicationIdentifier', _UMTS_Content_Report_communicationIdentifier),
        (u'timeStamp', _UMTS_Content_Report_timeStamp),
        (u'initiator', _UMTS_Content_Report_initiator),
        (u'content', _UMTS_Content_Report_content),
        (u'sMS-report', _UMTS_Content_Report_sMS_report),
        ])
    UMTS_Content_Report._ext = []
    
    _all_ = [
        lawfulInterceptDomainId,
        threeGPPSUBDomainId,
        hi3CSDomainId,
        _UMTS_Content_Report_hi3CSDomainId,
        _UMTS_Content_Report_version,
        _UMTS_Content_Report_lawfulInterceptionIdentifier,
        _UMTS_Content_Report_communicationIdentifier,
        _UMTS_Content_Report_timeStamp,
        _UMTS_Content_Report_initiator,
        _UMTS_Content_Report_content,
        _UMTS_Content_Report_sMS_report,
        UMTS_Content_Report,
    ]

class Umts_HI3_PS:

    _name_  = u'Umts-HI3-PS'
    _oid_   = [0, 4, 0, 2, 2, 4, 2, 7, 0]
    
    _obj_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi3DomainId',
        u'CC-PDU',
        u'ULIC-header',
        u'Version',
        u'TPDU-direction',
        u'National-HI3-ASN1parameters',
        u'ICE-type',
        ]
    _type_ = [
        u'CC-PDU',
        u'ULIC-header',
        u'Version',
        u'TPDU-direction',
        u'National-HI3-ASN1parameters',
        u'ICE-type',
        ]
    _set_ = [
        ]
    _val_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi3DomainId',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< lawfulInterceptDomainId >-----#
    lawfulInterceptDomainId = OID(name=u'lawfulInterceptDomainId', mode=MODE_VALUE)
    lawfulInterceptDomainId._val = (0, 4, 0, 2, 2)
    
    #-----< threeGPPSUBDomainId >-----#
    threeGPPSUBDomainId = OID(name=u'threeGPPSUBDomainId', mode=MODE_VALUE)
    threeGPPSUBDomainId._val = (0, 4, 0, 2, 2, 4)
    
    #-----< hi3DomainId >-----#
    hi3DomainId = OID(name=u'hi3DomainId', mode=MODE_VALUE)
    hi3DomainId._val = (0, 4, 0, 2, 2, 4, 2, 7, 0)
    
    #-----< CC-PDU >-----#
    CC_PDU = SEQ(name=u'CC-PDU', mode=MODE_TYPE)
    _CC_PDU_uLIC_header = SEQ(name=u'uLIC-header', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Umts-HI3-PS', 'ULIC-header')))
    _CC_PDU_payload = OCT_STR(name=u'payload', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    CC_PDU._cont = ASN1Dict([
        (u'uLIC-header', _CC_PDU_uLIC_header),
        (u'payload', _CC_PDU_payload),
        ])
    CC_PDU._ext = None
    
    #-----< ULIC-header >-----#
    ULIC_header = SEQ(name=u'ULIC-header', mode=MODE_TYPE)
    _ULIC_header_hi3DomainId = OID(name=u'hi3DomainId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ULIC_header_version = ENUM(name=u'version', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Umts-HI3-PS', 'Version')))
    _ULIC_header_lIID = OCT_STR(name=u'lIID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'LawfulInterceptionIdentifier')), opt=True)
    _ULIC_header_correlation_Number = OCT_STR(name=u'correlation-Number', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'GPRSCorrelationNumber')))
    _ULIC_header_timeStamp = CHOICE(name=u'timeStamp', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')), opt=True)
    _ULIC_header_sequence_number = INT(name=u'sequence-number', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ULIC_header_sequence_number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ULIC_header_t_PDU_direction = ENUM(name=u't-PDU-direction', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Umts-HI3-PS', 'TPDU-direction')))
    _ULIC_header_national_HI3_ASN1parameters = SEQ(name=u'national-HI3-ASN1parameters', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Umts-HI3-PS', 'National-HI3-ASN1parameters')), opt=True)
    _ULIC_header_ice_type = ENUM(name=u'ice-type', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Umts-HI3-PS', 'ICE-type')), opt=True)
    ULIC_header._cont = ASN1Dict([
        (u'hi3DomainId', _ULIC_header_hi3DomainId),
        (u'version', _ULIC_header_version),
        (u'lIID', _ULIC_header_lIID),
        (u'correlation-Number', _ULIC_header_correlation_Number),
        (u'timeStamp', _ULIC_header_timeStamp),
        (u'sequence-number', _ULIC_header_sequence_number),
        (u't-PDU-direction', _ULIC_header_t_PDU_direction),
        (u'national-HI3-ASN1parameters', _ULIC_header_national_HI3_ASN1parameters),
        (u'ice-type', _ULIC_header_ice_type),
        ])
    ULIC_header._ext = [u'national-HI3-ASN1parameters', u'ice-type']
    
    #-----< Version >-----#
    Version = ENUM(name=u'Version', mode=MODE_TYPE)
    Version._cont = ASN1Dict([(u'version1', 1), (u'version3', 3), (u'lastVersion', 8)])
    Version._ext = [u'version3', u'lastVersion']
    
    #-----< TPDU-direction >-----#
    TPDU_direction = ENUM(name=u'TPDU-direction', mode=MODE_TYPE)
    TPDU_direction._cont = ASN1Dict([(u'from-target', 1), (u'to-target', 2), (u'unknown', 3)])
    TPDU_direction._ext = None
    
    #-----< National-HI3-ASN1parameters >-----#
    National_HI3_ASN1parameters = SEQ(name=u'National-HI3-ASN1parameters', mode=MODE_TYPE)
    _National_HI3_ASN1parameters_countryCode = STR_PRINT(name=u'countryCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _National_HI3_ASN1parameters_countryCode._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    National_HI3_ASN1parameters._cont = ASN1Dict([
        (u'countryCode', _National_HI3_ASN1parameters_countryCode),
        ])
    National_HI3_ASN1parameters._ext = []
    
    #-----< ICE-type >-----#
    ICE_type = ENUM(name=u'ICE-type', mode=MODE_TYPE)
    ICE_type._cont = ASN1Dict([(u'sgsn', 1), (u'ggsn', 2)])
    ICE_type._ext = []
    
    _all_ = [
        lawfulInterceptDomainId,
        threeGPPSUBDomainId,
        hi3DomainId,
        _CC_PDU_uLIC_header,
        _CC_PDU_payload,
        CC_PDU,
        _ULIC_header_hi3DomainId,
        _ULIC_header_version,
        _ULIC_header_lIID,
        _ULIC_header_correlation_Number,
        _ULIC_header_timeStamp,
        _ULIC_header_sequence_number,
        _ULIC_header_t_PDU_direction,
        _ULIC_header_national_HI3_ASN1parameters,
        _ULIC_header_ice_type,
        ULIC_header,
        Version,
        TPDU_direction,
        _National_HI3_ASN1parameters_countryCode,
        National_HI3_ASN1parameters,
        ICE_type,
    ]

class UmtsCS_HI2Operations:

    _name_  = u'UmtsCS-HI2Operations'
    _oid_   = [0, 4, 0, 2, 2, 4, 3, 16, 0]
    
    _obj_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi2CSDomainId',
        u'UmtsCS-IRIsContent',
        u'UmtsCS-IRISequence',
        u'UmtsCS-IRIContent',
        u'IRI-Parameters',
        u'Umts-Cs-Event',
        u'Requesting-Node-Type',
        u'Change-Of-Target-Identity',
        u'Current-Previous-Systems',
        ]
    _type_ = [
        u'UmtsCS-IRIsContent',
        u'UmtsCS-IRISequence',
        u'UmtsCS-IRIContent',
        u'IRI-Parameters',
        u'Umts-Cs-Event',
        u'Requesting-Node-Type',
        u'Change-Of-Target-Identity',
        u'Current-Previous-Systems',
        ]
    _set_ = [
        ]
    _val_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi2CSDomainId',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< lawfulInterceptDomainId >-----#
    lawfulInterceptDomainId = OID(name=u'lawfulInterceptDomainId', mode=MODE_VALUE)
    lawfulInterceptDomainId._val = (0, 4, 0, 2, 2)
    
    #-----< threeGPPSUBDomainId >-----#
    threeGPPSUBDomainId = OID(name=u'threeGPPSUBDomainId', mode=MODE_VALUE)
    threeGPPSUBDomainId._val = (0, 4, 0, 2, 2, 4)
    
    #-----< hi2CSDomainId >-----#
    hi2CSDomainId = OID(name=u'hi2CSDomainId', mode=MODE_VALUE)
    hi2CSDomainId._val = (0, 4, 0, 2, 2, 4, 3, 16, 0)
    
    #-----< UmtsCS-IRIsContent >-----#
    UmtsCS_IRIsContent = CHOICE(name=u'UmtsCS-IRIsContent', mode=MODE_TYPE)
    _UmtsCS_IRIsContent_iRIContent = CHOICE(name=u'iRIContent', mode=MODE_TYPE, typeref=ASN1RefType(('UmtsCS-HI2Operations', 'UmtsCS-IRIContent')))
    _UmtsCS_IRIsContent_iRISequence = SEQ_OF(name=u'iRISequence', mode=MODE_TYPE, typeref=ASN1RefType(('UmtsCS-HI2Operations', 'UmtsCS-IRISequence')))
    UmtsCS_IRIsContent._cont = ASN1Dict([
        (u'iRIContent', _UmtsCS_IRIsContent_iRIContent),
        (u'iRISequence', _UmtsCS_IRIsContent_iRISequence),
        ])
    UmtsCS_IRIsContent._ext = None
    
    #-----< UmtsCS-IRISequence >-----#
    UmtsCS_IRISequence = SEQ_OF(name=u'UmtsCS-IRISequence', mode=MODE_TYPE)
    _UmtsCS_IRISequence__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('UmtsCS-HI2Operations', 'UmtsCS-IRIContent')))
    UmtsCS_IRISequence._cont = _UmtsCS_IRISequence__item_
    
    #-----< UmtsCS-IRIContent >-----#
    UmtsCS_IRIContent = CHOICE(name=u'UmtsCS-IRIContent', mode=MODE_TYPE)
    _UmtsCS_IRIContent_iRI_Begin_record = SEQ(name=u'iRI-Begin-record', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsCS-HI2Operations', 'IRI-Parameters')))
    _UmtsCS_IRIContent_iRI_End_record = SEQ(name=u'iRI-End-record', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsCS-HI2Operations', 'IRI-Parameters')))
    _UmtsCS_IRIContent_iRI_Continue_record = SEQ(name=u'iRI-Continue-record', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsCS-HI2Operations', 'IRI-Parameters')))
    _UmtsCS_IRIContent_iRI_Report_record = SEQ(name=u'iRI-Report-record', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsCS-HI2Operations', 'IRI-Parameters')))
    UmtsCS_IRIContent._cont = ASN1Dict([
        (u'iRI-Begin-record', _UmtsCS_IRIContent_iRI_Begin_record),
        (u'iRI-End-record', _UmtsCS_IRIContent_iRI_End_record),
        (u'iRI-Continue-record', _UmtsCS_IRIContent_iRI_Continue_record),
        (u'iRI-Report-record', _UmtsCS_IRIContent_iRI_Report_record),
        ])
    UmtsCS_IRIContent._ext = []
    
    #-----< IRI-Parameters >-----#
    IRI_Parameters = SEQ(name=u'IRI-Parameters', mode=MODE_TYPE)
    _IRI_Parameters_hi2CSDomainId = OID(name=u'hi2CSDomainId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IRI_Parameters_iRIversion = ENUM(name=u'iRIversion', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_iRIversion._cont = ASN1Dict([(u'version1', 1), (u'version2', 2), (u'version3', 3), (u'lastVersion', 8)])
    _IRI_Parameters_iRIversion._ext = [u'version2', u'version3', u'lastVersion']
    _IRI_Parameters_lawfulInterceptionIdentifier = OCT_STR(name=u'lawfulInterceptionIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'LawfulInterceptionIdentifier')))
    _IRI_Parameters_communicationIdentifier = SEQ(name=u'communicationIdentifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'CommunicationIdentifier')))
    _IRI_Parameters_timeStamp = CHOICE(name=u'timeStamp', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    _IRI_Parameters_intercepted_Call_Direct = ENUM(name=u'intercepted-Call-Direct', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_intercepted_Call_Direct._cont = ASN1Dict([(u'not-Available', 0), (u'originating-Target', 1), (u'terminating-Target', 2)])
    _IRI_Parameters_intercepted_Call_Direct._ext = []
    _IRI_Parameters_intercepted_Call_State = ENUM(name=u'intercepted-Call-State', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'Intercepted-Call-State')), opt=True)
    _IRI_Parameters_ringingDuration = OCT_STR(name=u'ringingDuration', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_ringingDuration._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _IRI_Parameters_conversationDuration = OCT_STR(name=u'conversationDuration', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_conversationDuration._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _IRI_Parameters_locationOfTheTarget = SEQ(name=u'locationOfTheTarget', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'Location')), opt=True)
    _IRI_Parameters_partyInformation = SET_OF(name=u'partyInformation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IRI_Parameters_partyInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HI2Operations', 'PartyInformation')))
    _IRI_Parameters_partyInformation._cont = __IRI_Parameters_partyInformation__item_
    _IRI_Parameters_partyInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _IRI_Parameters_callContentLinkInformation = SEQ(name=u'callContentLinkInformation', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IRI_Parameters_callContentLinkInformation_cCLink1Characteristics = SEQ(name=u'cCLink1Characteristics', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'CallContentLinkCharacteristics')), opt=True)
    __IRI_Parameters_callContentLinkInformation_cCLink2Characteristics = SEQ(name=u'cCLink2Characteristics', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'CallContentLinkCharacteristics')), opt=True)
    _IRI_Parameters_callContentLinkInformation._cont = ASN1Dict([
        (u'cCLink1Characteristics', __IRI_Parameters_callContentLinkInformation_cCLink1Characteristics),
        (u'cCLink2Characteristics', __IRI_Parameters_callContentLinkInformation_cCLink2Characteristics),
        ])
    _IRI_Parameters_callContentLinkInformation._ext = []
    _IRI_Parameters_release_Reason_Of_Intercepted_Call = OCT_STR(name=u'release-Reason-Of-Intercepted-Call', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_release_Reason_Of_Intercepted_Call._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _IRI_Parameters_nature_Of_The_intercepted_call = ENUM(name=u'nature-Of-The-intercepted-call', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_nature_Of_The_intercepted_call._cont = ASN1Dict([(u'gSM-ISDN-PSTN-circuit-call', 0), (u'gSM-SMS-Message', 1), (u'uUS4-Messages', 2), (u'tETRA-circuit-call', 3), (u'teTRA-Packet-Data', 4), (u'gPRS-Packet-Data', 5)])
    _IRI_Parameters_nature_Of_The_intercepted_call._ext = []
    _IRI_Parameters_serviceCenterAddress = SEQ(name=u'serviceCenterAddress', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'PartyInformation')), opt=True)
    _IRI_Parameters_sMS = SEQ(name=u'sMS', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'SMS-report')), opt=True)
    _IRI_Parameters_cC_Link_Identifier = OCT_STR(name=u'cC-Link-Identifier', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'CC-Link-Identifier')), opt=True)
    _IRI_Parameters_national_Parameters = SET_OF(name=u'national-Parameters', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'National-Parameters')), opt=True)
    _IRI_Parameters_umts_Cs_Event = ENUM(name=u'umts-Cs-Event', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsCS-HI2Operations', 'Umts-Cs-Event')), opt=True)
    _IRI_Parameters_serving_System_Identifier = OCT_STR(name=u'serving-System-Identifier', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_carrierSpecificData = OCT_STR(name=u'carrierSpecificData', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_current_Previous_Systems = SEQ(name=u'current-Previous-Systems', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsCS-HI2Operations', 'Current-Previous-Systems')), opt=True)
    _IRI_Parameters_change_Of_Target_Identity = SEQ(name=u'change-Of-Target-Identity', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsCS-HI2Operations', 'Change-Of-Target-Identity')), opt=True)
    _IRI_Parameters_requesting_Network_Identifier = OCT_STR(name=u'requesting-Network-Identifier', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_requesting_Node_Type = ENUM(name=u'requesting-Node-Type', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsCS-HI2Operations', 'Requesting-Node-Type')), opt=True)
    _IRI_Parameters_extendedLocParameters = SEQ(name=u'extendedLocParameters', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'ExtendedLocParameters')), opt=True)
    _IRI_Parameters_locationErrorCode = INT(name=u'locationErrorCode', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'LocationErrorCode')), opt=True)
    _IRI_Parameters_national_HI2_ASN1parameters = SEQ(name=u'national-HI2-ASN1parameters', mode=MODE_TYPE, tag=(255, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'National-HI2-ASN1parameters')), opt=True)
    IRI_Parameters._cont = ASN1Dict([
        (u'hi2CSDomainId', _IRI_Parameters_hi2CSDomainId),
        (u'iRIversion', _IRI_Parameters_iRIversion),
        (u'lawfulInterceptionIdentifier', _IRI_Parameters_lawfulInterceptionIdentifier),
        (u'communicationIdentifier', _IRI_Parameters_communicationIdentifier),
        (u'timeStamp', _IRI_Parameters_timeStamp),
        (u'intercepted-Call-Direct', _IRI_Parameters_intercepted_Call_Direct),
        (u'intercepted-Call-State', _IRI_Parameters_intercepted_Call_State),
        (u'ringingDuration', _IRI_Parameters_ringingDuration),
        (u'conversationDuration', _IRI_Parameters_conversationDuration),
        (u'locationOfTheTarget', _IRI_Parameters_locationOfTheTarget),
        (u'partyInformation', _IRI_Parameters_partyInformation),
        (u'callContentLinkInformation', _IRI_Parameters_callContentLinkInformation),
        (u'release-Reason-Of-Intercepted-Call', _IRI_Parameters_release_Reason_Of_Intercepted_Call),
        (u'nature-Of-The-intercepted-call', _IRI_Parameters_nature_Of_The_intercepted_call),
        (u'serviceCenterAddress', _IRI_Parameters_serviceCenterAddress),
        (u'sMS', _IRI_Parameters_sMS),
        (u'cC-Link-Identifier', _IRI_Parameters_cC_Link_Identifier),
        (u'national-Parameters', _IRI_Parameters_national_Parameters),
        (u'umts-Cs-Event', _IRI_Parameters_umts_Cs_Event),
        (u'serving-System-Identifier', _IRI_Parameters_serving_System_Identifier),
        (u'carrierSpecificData', _IRI_Parameters_carrierSpecificData),
        (u'current-Previous-Systems', _IRI_Parameters_current_Previous_Systems),
        (u'change-Of-Target-Identity', _IRI_Parameters_change_Of_Target_Identity),
        (u'requesting-Network-Identifier', _IRI_Parameters_requesting_Network_Identifier),
        (u'requesting-Node-Type', _IRI_Parameters_requesting_Node_Type),
        (u'extendedLocParameters', _IRI_Parameters_extendedLocParameters),
        (u'locationErrorCode', _IRI_Parameters_locationErrorCode),
        (u'national-HI2-ASN1parameters', _IRI_Parameters_national_HI2_ASN1parameters),
        ])
    IRI_Parameters._ext = [u'umts-Cs-Event', u'serving-System-Identifier', u'carrierSpecificData', u'current-Previous-Systems', u'change-Of-Target-Identity', u'requesting-Network-Identifier', u'requesting-Node-Type', u'extendedLocParameters', u'locationErrorCode', u'national-HI2-ASN1parameters']
    
    #-----< Umts-Cs-Event >-----#
    Umts_Cs_Event = ENUM(name=u'Umts-Cs-Event', mode=MODE_TYPE)
    Umts_Cs_Event._cont = ASN1Dict([(u'call-establishment', 1), (u'answer', 2), (u'supplementary-Service', 3), (u'handover', 4), (u'release', 5), (u'sMS', 6), (u'location-update', 7), (u'subscriber-Controlled-Input', 8), (u'hLR-Subscriber-Record-Change', 9), (u'serving-System', 10), (u'cancel-Location', 11), (u'register-Location', 12), (u'location-Information-Request', 13)])
    Umts_Cs_Event._ext = [u'hLR-Subscriber-Record-Change', u'serving-System', u'cancel-Location', u'register-Location', u'location-Information-Request']
    
    #-----< Requesting-Node-Type >-----#
    Requesting_Node_Type = ENUM(name=u'Requesting-Node-Type', mode=MODE_TYPE)
    Requesting_Node_Type._cont = ASN1Dict([(u'mSC', 1), (u'sMS-Centre', 2), (u'gMLC', 3), (u'mME', 4), (u'sGSN', 5)])
    Requesting_Node_Type._ext = []
    
    #-----< Change-Of-Target-Identity >-----#
    Change_Of_Target_Identity = SEQ(name=u'Change-Of-Target-Identity', mode=MODE_TYPE)
    _Change_Of_Target_Identity_new_MSISDN = SEQ(name=u'new-MSISDN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_old_MSISDN = SEQ(name=u'old-MSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_new_IMSI = SEQ(name=u'new-IMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_old_IMSI = SEQ(name=u'old-IMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_new_IMEI = SEQ(name=u'new-IMEI', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_old_IMEI = SEQ(name=u'old-IMEI', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'PartyInformation')), opt=True)
    Change_Of_Target_Identity._cont = ASN1Dict([
        (u'new-MSISDN', _Change_Of_Target_Identity_new_MSISDN),
        (u'old-MSISDN', _Change_Of_Target_Identity_old_MSISDN),
        (u'new-IMSI', _Change_Of_Target_Identity_new_IMSI),
        (u'old-IMSI', _Change_Of_Target_Identity_old_IMSI),
        (u'new-IMEI', _Change_Of_Target_Identity_new_IMEI),
        (u'old-IMEI', _Change_Of_Target_Identity_old_IMEI),
        ])
    Change_Of_Target_Identity._ext = [u'new-IMEI', u'old-IMEI']
    
    #-----< Current-Previous-Systems >-----#
    Current_Previous_Systems = SEQ(name=u'Current-Previous-Systems', mode=MODE_TYPE)
    _Current_Previous_Systems_current_Serving_System_Identifier = OCT_STR(name=u'current-Serving-System-Identifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Current_Previous_Systems_current_Serving_MSC_Number = OCT_STR(name=u'current-Serving-MSC-Number', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Current_Previous_Systems_current_Serving_MSC_Address = OCT_STR(name=u'current-Serving-MSC-Address', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Current_Previous_Systems_previous_Serving_System_Identifier = OCT_STR(name=u'previous-Serving-System-Identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Current_Previous_Systems_previous_Serving_MSC_Number = OCT_STR(name=u'previous-Serving-MSC-Number', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Current_Previous_Systems_previous_Serving_MSC_Address = OCT_STR(name=u'previous-Serving-MSC-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    Current_Previous_Systems._cont = ASN1Dict([
        (u'current-Serving-System-Identifier', _Current_Previous_Systems_current_Serving_System_Identifier),
        (u'current-Serving-MSC-Number', _Current_Previous_Systems_current_Serving_MSC_Number),
        (u'current-Serving-MSC-Address', _Current_Previous_Systems_current_Serving_MSC_Address),
        (u'previous-Serving-System-Identifier', _Current_Previous_Systems_previous_Serving_System_Identifier),
        (u'previous-Serving-MSC-Number', _Current_Previous_Systems_previous_Serving_MSC_Number),
        (u'previous-Serving-MSC-Address', _Current_Previous_Systems_previous_Serving_MSC_Address),
        ])
    Current_Previous_Systems._ext = []
    
    _all_ = [
        lawfulInterceptDomainId,
        threeGPPSUBDomainId,
        hi2CSDomainId,
        _UmtsCS_IRIsContent_iRIContent,
        _UmtsCS_IRIsContent_iRISequence,
        UmtsCS_IRIsContent,
        _UmtsCS_IRISequence__item_,
        UmtsCS_IRISequence,
        _UmtsCS_IRIContent_iRI_Begin_record,
        _UmtsCS_IRIContent_iRI_End_record,
        _UmtsCS_IRIContent_iRI_Continue_record,
        _UmtsCS_IRIContent_iRI_Report_record,
        UmtsCS_IRIContent,
        _IRI_Parameters_hi2CSDomainId,
        _IRI_Parameters_iRIversion,
        _IRI_Parameters_lawfulInterceptionIdentifier,
        _IRI_Parameters_communicationIdentifier,
        _IRI_Parameters_timeStamp,
        _IRI_Parameters_intercepted_Call_Direct,
        _IRI_Parameters_intercepted_Call_State,
        _IRI_Parameters_ringingDuration,
        _IRI_Parameters_conversationDuration,
        _IRI_Parameters_locationOfTheTarget,
        __IRI_Parameters_partyInformation__item_,
        _IRI_Parameters_partyInformation,
        __IRI_Parameters_callContentLinkInformation_cCLink1Characteristics,
        __IRI_Parameters_callContentLinkInformation_cCLink2Characteristics,
        _IRI_Parameters_callContentLinkInformation,
        _IRI_Parameters_release_Reason_Of_Intercepted_Call,
        _IRI_Parameters_nature_Of_The_intercepted_call,
        _IRI_Parameters_serviceCenterAddress,
        _IRI_Parameters_sMS,
        _IRI_Parameters_cC_Link_Identifier,
        _IRI_Parameters_national_Parameters,
        _IRI_Parameters_umts_Cs_Event,
        _IRI_Parameters_serving_System_Identifier,
        _IRI_Parameters_carrierSpecificData,
        _IRI_Parameters_current_Previous_Systems,
        _IRI_Parameters_change_Of_Target_Identity,
        _IRI_Parameters_requesting_Network_Identifier,
        _IRI_Parameters_requesting_Node_Type,
        _IRI_Parameters_extendedLocParameters,
        _IRI_Parameters_locationErrorCode,
        _IRI_Parameters_national_HI2_ASN1parameters,
        IRI_Parameters,
        Umts_Cs_Event,
        Requesting_Node_Type,
        _Change_Of_Target_Identity_new_MSISDN,
        _Change_Of_Target_Identity_old_MSISDN,
        _Change_Of_Target_Identity_new_IMSI,
        _Change_Of_Target_Identity_old_IMSI,
        _Change_Of_Target_Identity_new_IMEI,
        _Change_Of_Target_Identity_old_IMEI,
        Change_Of_Target_Identity,
        _Current_Previous_Systems_current_Serving_System_Identifier,
        _Current_Previous_Systems_current_Serving_MSC_Number,
        _Current_Previous_Systems_current_Serving_MSC_Address,
        _Current_Previous_Systems_previous_Serving_System_Identifier,
        _Current_Previous_Systems_previous_Serving_MSC_Number,
        _Current_Previous_Systems_previous_Serving_MSC_Address,
        Current_Previous_Systems,
    ]

class UmtsHI2Operations:

    _name_  = u'UmtsHI2Operations'
    _oid_   = [0, 4, 0, 2, 2, 4, 1, 16, 1]
    
    _obj_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi2DomainId',
        u'UmtsIRIsContent',
        u'UmtsIRISequence',
        u'UmtsIRIContent',
        u'IRI-Parameters',
        u'PANI-Header-Info',
        u'PANI-Location',
        u'PartyInformation',
        u'Location',
        u'GlobalCellID',
        u'Rai',
        u'Sai',
        u'GSMLocation',
        u'MapDatum',
        u'UMTSLocation',
        u'GeographicalCoordinates',
        u'GA-Point',
        u'GA-PointWithUnCertainty',
        u'maxNrOfPoints',
        u'GA-Polygon',
        u'CivicAddress',
        u'XmlCivicAddress',
        u'DetailedCivicAddress',
        u'SMS-report',
        u'GPRSCorrelationNumber',
        u'CorrelationValues',
        u'IMS-VoIP-Correlation',
        u'IRI-to-CC-Correlation',
        u'IRI-to-IRI-Correlation',
        u'GPRSEvent',
        u'CSREvent',
        u'IMSevent',
        u'Current-Previous-Systems',
        u'Change-Of-Target-Identity',
        u'Requesting-Node-Type',
        u'Services-Data-Information',
        u'GPRS-parameters',
        u'GPRSOperationErrorCode',
        u'LDIevent',
        u'UmtsQos',
        u'MediaDecryption-info',
        u'CCKeyInfo',
        u'MediaSecFailureIndication',
        u'PacketDataHeaderInformation',
        u'PacketDataHeaderReport',
        u'PacketDataHeaderMapped',
        u'TPDU-direction',
        u'PacketDataHeaderCopy',
        u'PacketDataSummaryReport',
        u'PacketFlowSummary',
        u'ReportReason',
        u'ReportInterval',
        u'ExtendedLocParameters',
        u'LocationErrorCode',
        u'PTCEncryptionInfo',
        u'PTC',
        u'AccessPolicyType',
        u'AlertIndicator',
        u'AssociatePresenceStatus',
        u'PresenceType',
        u'Emergency',
        u'EmergencyGroupState',
        u'PTCType',
        u'FloorActivity',
        u'GroupAuthRule',
        u'ImminentPerilInd',
        u'ImplicitFloorReq',
        u'InitiationCause',
        u'IPADirection',
        u'ListManagementAction',
        u'ListManagementType',
        u'Priority-Level',
        u'PreEstStatus',
        u'PTCAddress',
        u'RegistrationRequest',
        u'RegistrationOutcome',
        u'RTPSetting',
        u'Port-Number',
        u'TalkburstControlSetting',
        u'Talk-burst-reason-code',
        ]
    _type_ = [
        u'UmtsIRIsContent',
        u'UmtsIRISequence',
        u'UmtsIRIContent',
        u'IRI-Parameters',
        u'PANI-Header-Info',
        u'PANI-Location',
        u'PartyInformation',
        u'Location',
        u'GlobalCellID',
        u'Rai',
        u'Sai',
        u'GSMLocation',
        u'MapDatum',
        u'UMTSLocation',
        u'GeographicalCoordinates',
        u'GA-Point',
        u'GA-PointWithUnCertainty',
        u'GA-Polygon',
        u'CivicAddress',
        u'XmlCivicAddress',
        u'DetailedCivicAddress',
        u'SMS-report',
        u'GPRSCorrelationNumber',
        u'CorrelationValues',
        u'IMS-VoIP-Correlation',
        u'IRI-to-CC-Correlation',
        u'IRI-to-IRI-Correlation',
        u'GPRSEvent',
        u'CSREvent',
        u'IMSevent',
        u'Current-Previous-Systems',
        u'Change-Of-Target-Identity',
        u'Requesting-Node-Type',
        u'Services-Data-Information',
        u'GPRS-parameters',
        u'GPRSOperationErrorCode',
        u'LDIevent',
        u'UmtsQos',
        u'MediaDecryption-info',
        u'CCKeyInfo',
        u'MediaSecFailureIndication',
        u'PacketDataHeaderInformation',
        u'PacketDataHeaderReport',
        u'PacketDataHeaderMapped',
        u'TPDU-direction',
        u'PacketDataHeaderCopy',
        u'PacketDataSummaryReport',
        u'PacketFlowSummary',
        u'ReportReason',
        u'ReportInterval',
        u'ExtendedLocParameters',
        u'LocationErrorCode',
        u'PTCEncryptionInfo',
        u'PTC',
        u'AccessPolicyType',
        u'AlertIndicator',
        u'AssociatePresenceStatus',
        u'PresenceType',
        u'Emergency',
        u'EmergencyGroupState',
        u'PTCType',
        u'FloorActivity',
        u'GroupAuthRule',
        u'ImminentPerilInd',
        u'ImplicitFloorReq',
        u'InitiationCause',
        u'IPADirection',
        u'ListManagementAction',
        u'ListManagementType',
        u'Priority-Level',
        u'PreEstStatus',
        u'PTCAddress',
        u'RegistrationRequest',
        u'RegistrationOutcome',
        u'RTPSetting',
        u'Port-Number',
        u'TalkburstControlSetting',
        u'Talk-burst-reason-code',
        ]
    _set_ = [
        ]
    _val_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi2DomainId',
        u'maxNrOfPoints',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< lawfulInterceptDomainId >-----#
    lawfulInterceptDomainId = OID(name=u'lawfulInterceptDomainId', mode=MODE_VALUE)
    lawfulInterceptDomainId._val = (0, 4, 0, 2, 2)
    
    #-----< threeGPPSUBDomainId >-----#
    threeGPPSUBDomainId = OID(name=u'threeGPPSUBDomainId', mode=MODE_VALUE)
    threeGPPSUBDomainId._val = (0, 4, 0, 2, 2, 4)
    
    #-----< hi2DomainId >-----#
    hi2DomainId = OID(name=u'hi2DomainId', mode=MODE_VALUE)
    hi2DomainId._val = (0, 4, 0, 2, 2, 4, 1, 16, 1)
    
    #-----< UmtsIRIsContent >-----#
    UmtsIRIsContent = CHOICE(name=u'UmtsIRIsContent', mode=MODE_TYPE)
    _UmtsIRIsContent_umtsiRIContent = CHOICE(name=u'umtsiRIContent', mode=MODE_TYPE, typeref=ASN1RefType(('UmtsHI2Operations', 'UmtsIRIContent')))
    _UmtsIRIsContent_umtsIRISequence = SEQ_OF(name=u'umtsIRISequence', mode=MODE_TYPE, typeref=ASN1RefType(('UmtsHI2Operations', 'UmtsIRISequence')))
    UmtsIRIsContent._cont = ASN1Dict([
        (u'umtsiRIContent', _UmtsIRIsContent_umtsiRIContent),
        (u'umtsIRISequence', _UmtsIRIsContent_umtsIRISequence),
        ])
    UmtsIRIsContent._ext = None
    
    #-----< UmtsIRISequence >-----#
    UmtsIRISequence = SEQ_OF(name=u'UmtsIRISequence', mode=MODE_TYPE)
    _UmtsIRISequence__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('UmtsHI2Operations', 'UmtsIRIContent')))
    UmtsIRISequence._cont = _UmtsIRISequence__item_
    
    #-----< UmtsIRIContent >-----#
    UmtsIRIContent = CHOICE(name=u'UmtsIRIContent', mode=MODE_TYPE)
    _UmtsIRIContent_iRI_Begin_record = SEQ(name=u'iRI-Begin-record', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'IRI-Parameters')))
    _UmtsIRIContent_iRI_End_record = SEQ(name=u'iRI-End-record', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'IRI-Parameters')))
    _UmtsIRIContent_iRI_Continue_record = SEQ(name=u'iRI-Continue-record', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'IRI-Parameters')))
    _UmtsIRIContent_iRI_Report_record = SEQ(name=u'iRI-Report-record', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'IRI-Parameters')))
    UmtsIRIContent._cont = ASN1Dict([
        (u'iRI-Begin-record', _UmtsIRIContent_iRI_Begin_record),
        (u'iRI-End-record', _UmtsIRIContent_iRI_End_record),
        (u'iRI-Continue-record', _UmtsIRIContent_iRI_Continue_record),
        (u'iRI-Report-record', _UmtsIRIContent_iRI_Report_record),
        ])
    UmtsIRIContent._ext = None
    
    #-----< IRI-Parameters >-----#
    IRI_Parameters = SEQ(name=u'IRI-Parameters', mode=MODE_TYPE)
    _IRI_Parameters_hi2DomainId = OID(name=u'hi2DomainId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IRI_Parameters_iRIversion = ENUM(name=u'iRIversion', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_iRIversion._cont = ASN1Dict([(u'version2', 2), (u'version3', 3), (u'version4', 4), (u'version6', 6), (u'lastVersion', 8)])
    _IRI_Parameters_iRIversion._ext = [u'version3', u'version4', u'version6', u'lastVersion']
    _IRI_Parameters_lawfulInterceptionIdentifier = OCT_STR(name=u'lawfulInterceptionIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'LawfulInterceptionIdentifier')))
    _IRI_Parameters_timeStamp = CHOICE(name=u'timeStamp', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    _IRI_Parameters_initiator = ENUM(name=u'initiator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_initiator._cont = ASN1Dict([(u'not-Available', 0), (u'originating-Target', 1), (u'terminating-Target', 2)])
    _IRI_Parameters_initiator._ext = []
    _IRI_Parameters_locationOfTheTarget = SEQ(name=u'locationOfTheTarget', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'Location')), opt=True)
    _IRI_Parameters_partyInformation = SET_OF(name=u'partyInformation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IRI_Parameters_partyInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('UmtsHI2Operations', 'PartyInformation')))
    _IRI_Parameters_partyInformation._cont = __IRI_Parameters_partyInformation__item_
    _IRI_Parameters_partyInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _IRI_Parameters_serviceCenterAddress = SEQ(name=u'serviceCenterAddress', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PartyInformation')), opt=True)
    _IRI_Parameters_sMS = SEQ(name=u'sMS', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'SMS-report')), opt=True)
    _IRI_Parameters_national_Parameters = SET_OF(name=u'national-Parameters', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'National-Parameters')), opt=True)
    _IRI_Parameters_gPRSCorrelationNumber = OCT_STR(name=u'gPRSCorrelationNumber', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'GPRSCorrelationNumber')), opt=True)
    _IRI_Parameters_gPRSevent = ENUM(name=u'gPRSevent', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'GPRSEvent')), opt=True)
    _IRI_Parameters_sgsnAddress = CHOICE(name=u'sgsnAddress', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DataNodeAddress')), opt=True)
    _IRI_Parameters_gPRSOperationErrorCode = OCT_STR(name=u'gPRSOperationErrorCode', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'GPRSOperationErrorCode')), opt=True)
    _IRI_Parameters_ggsnAddress = CHOICE(name=u'ggsnAddress', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DataNodeAddress')), opt=True)
    _IRI_Parameters_qOS = CHOICE(name=u'qOS', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'UmtsQos')), opt=True)
    _IRI_Parameters_networkIdentifier = SEQ(name=u'networkIdentifier', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'Network-Identifier')), opt=True)
    _IRI_Parameters_sMSOriginatingAddress = CHOICE(name=u'sMSOriginatingAddress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DataNodeAddress')), opt=True)
    _IRI_Parameters_sMSTerminatingAddress = CHOICE(name=u'sMSTerminatingAddress', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DataNodeAddress')), opt=True)
    _IRI_Parameters_iMSevent = ENUM(name=u'iMSevent', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'IMSevent')), opt=True)
    _IRI_Parameters_sIPMessage = OCT_STR(name=u'sIPMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_servingSGSN_number = OCT_STR(name=u'servingSGSN-number', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_servingSGSN_number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    _IRI_Parameters_servingSGSN_address = OCT_STR(name=u'servingSGSN-address', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_servingSGSN_address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=17)], ev=None, er=[])
    _IRI_Parameters_ldiEvent = ENUM(name=u'ldiEvent', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'LDIevent')), opt=True)
    _IRI_Parameters_correlation = CHOICE(name=u'correlation', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'CorrelationValues')), opt=True)
    _IRI_Parameters_mediaDecryption_info = SEQ_OF(name=u'mediaDecryption-info', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'MediaDecryption-info')), opt=True)
    _IRI_Parameters_servingS4_SGSN_address = OCT_STR(name=u'servingS4-SGSN-address', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_sipMessageHeaderOffer = OCT_STR(name=u'sipMessageHeaderOffer', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_sipMessageHeaderAnswer = OCT_STR(name=u'sipMessageHeaderAnswer', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_sdpOffer = OCT_STR(name=u'sdpOffer', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_sdpAnswer = OCT_STR(name=u'sdpAnswer', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_uLITimestamp = OCT_STR(name=u'uLITimestamp', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_uLITimestamp._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _IRI_Parameters_packetDataHeaderInformation = CHOICE(name=u'packetDataHeaderInformation', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PacketDataHeaderInformation')), opt=True)
    _IRI_Parameters_mediaSecFailureIndication = ENUM(name=u'mediaSecFailureIndication', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'MediaSecFailureIndication')), opt=True)
    _IRI_Parameters_pANI_Header_Info = SEQ_OF(name=u'pANI-Header-Info', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IRI_Parameters_pANI_Header_Info__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('UmtsHI2Operations', 'PANI-Header-Info')))
    _IRI_Parameters_pANI_Header_Info._cont = __IRI_Parameters_pANI_Header_Info__item_
    _IRI_Parameters_imsVoIP = SET_OF(name=u'imsVoIP', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'IMS-VoIP-Correlation')), opt=True)
    _IRI_Parameters_xCAPmessage = OCT_STR(name=u'xCAPmessage', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_ccUnavailableReason = STR_PRINT(name=u'ccUnavailableReason', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_carrierSpecificData = OCT_STR(name=u'carrierSpecificData', mode=MODE_TYPE, tag=(49, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_current_Previous_Systems = SEQ(name=u'current-Previous-Systems', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'Current-Previous-Systems')), opt=True)
    _IRI_Parameters_change_Of_Target_Identity = SEQ(name=u'change-Of-Target-Identity', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'Change-Of-Target-Identity')), opt=True)
    _IRI_Parameters_requesting_Network_Identifier = OCT_STR(name=u'requesting-Network-Identifier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_requesting_Node_Type = ENUM(name=u'requesting-Node-Type', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'Requesting-Node-Type')), opt=True)
    _IRI_Parameters_serving_System_Identifier = OCT_STR(name=u'serving-System-Identifier', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRI_Parameters_extendedLocParameters = SEQ(name=u'extendedLocParameters', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'ExtendedLocParameters')), opt=True)
    _IRI_Parameters_locationErrorCode = INT(name=u'locationErrorCode', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'LocationErrorCode')), opt=True)
    _IRI_Parameters_cSREvent = ENUM(name=u'cSREvent', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'CSREvent')), opt=True)
    _IRI_Parameters_ptc = SEQ(name=u'ptc', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PTC')), opt=True)
    _IRI_Parameters_ptcEncryption = SEQ(name=u'ptcEncryption', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PTCEncryptionInfo')), opt=True)
    _IRI_Parameters_national_HI2_ASN1parameters = SEQ(name=u'national-HI2-ASN1parameters', mode=MODE_TYPE, tag=(255, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'National-HI2-ASN1parameters')), opt=True)
    IRI_Parameters._cont = ASN1Dict([
        (u'hi2DomainId', _IRI_Parameters_hi2DomainId),
        (u'iRIversion', _IRI_Parameters_iRIversion),
        (u'lawfulInterceptionIdentifier', _IRI_Parameters_lawfulInterceptionIdentifier),
        (u'timeStamp', _IRI_Parameters_timeStamp),
        (u'initiator', _IRI_Parameters_initiator),
        (u'locationOfTheTarget', _IRI_Parameters_locationOfTheTarget),
        (u'partyInformation', _IRI_Parameters_partyInformation),
        (u'serviceCenterAddress', _IRI_Parameters_serviceCenterAddress),
        (u'sMS', _IRI_Parameters_sMS),
        (u'national-Parameters', _IRI_Parameters_national_Parameters),
        (u'gPRSCorrelationNumber', _IRI_Parameters_gPRSCorrelationNumber),
        (u'gPRSevent', _IRI_Parameters_gPRSevent),
        (u'sgsnAddress', _IRI_Parameters_sgsnAddress),
        (u'gPRSOperationErrorCode', _IRI_Parameters_gPRSOperationErrorCode),
        (u'ggsnAddress', _IRI_Parameters_ggsnAddress),
        (u'qOS', _IRI_Parameters_qOS),
        (u'networkIdentifier', _IRI_Parameters_networkIdentifier),
        (u'sMSOriginatingAddress', _IRI_Parameters_sMSOriginatingAddress),
        (u'sMSTerminatingAddress', _IRI_Parameters_sMSTerminatingAddress),
        (u'iMSevent', _IRI_Parameters_iMSevent),
        (u'sIPMessage', _IRI_Parameters_sIPMessage),
        (u'servingSGSN-number', _IRI_Parameters_servingSGSN_number),
        (u'servingSGSN-address', _IRI_Parameters_servingSGSN_address),
        (u'ldiEvent', _IRI_Parameters_ldiEvent),
        (u'correlation', _IRI_Parameters_correlation),
        (u'mediaDecryption-info', _IRI_Parameters_mediaDecryption_info),
        (u'servingS4-SGSN-address', _IRI_Parameters_servingS4_SGSN_address),
        (u'sipMessageHeaderOffer', _IRI_Parameters_sipMessageHeaderOffer),
        (u'sipMessageHeaderAnswer', _IRI_Parameters_sipMessageHeaderAnswer),
        (u'sdpOffer', _IRI_Parameters_sdpOffer),
        (u'sdpAnswer', _IRI_Parameters_sdpAnswer),
        (u'uLITimestamp', _IRI_Parameters_uLITimestamp),
        (u'packetDataHeaderInformation', _IRI_Parameters_packetDataHeaderInformation),
        (u'mediaSecFailureIndication', _IRI_Parameters_mediaSecFailureIndication),
        (u'pANI-Header-Info', _IRI_Parameters_pANI_Header_Info),
        (u'imsVoIP', _IRI_Parameters_imsVoIP),
        (u'xCAPmessage', _IRI_Parameters_xCAPmessage),
        (u'ccUnavailableReason', _IRI_Parameters_ccUnavailableReason),
        (u'carrierSpecificData', _IRI_Parameters_carrierSpecificData),
        (u'current-Previous-Systems', _IRI_Parameters_current_Previous_Systems),
        (u'change-Of-Target-Identity', _IRI_Parameters_change_Of_Target_Identity),
        (u'requesting-Network-Identifier', _IRI_Parameters_requesting_Network_Identifier),
        (u'requesting-Node-Type', _IRI_Parameters_requesting_Node_Type),
        (u'serving-System-Identifier', _IRI_Parameters_serving_System_Identifier),
        (u'extendedLocParameters', _IRI_Parameters_extendedLocParameters),
        (u'locationErrorCode', _IRI_Parameters_locationErrorCode),
        (u'cSREvent', _IRI_Parameters_cSREvent),
        (u'ptc', _IRI_Parameters_ptc),
        (u'ptcEncryption', _IRI_Parameters_ptcEncryption),
        (u'national-HI2-ASN1parameters', _IRI_Parameters_national_HI2_ASN1parameters),
        ])
    IRI_Parameters._ext = [u'ldiEvent', u'correlation', u'mediaDecryption-info', u'servingS4-SGSN-address', u'sipMessageHeaderOffer', u'sipMessageHeaderAnswer', u'sdpOffer', u'sdpAnswer', u'uLITimestamp', u'packetDataHeaderInformation', u'mediaSecFailureIndication', u'pANI-Header-Info', u'imsVoIP', u'xCAPmessage', u'ccUnavailableReason', u'carrierSpecificData', u'current-Previous-Systems', u'change-Of-Target-Identity', u'requesting-Network-Identifier', u'requesting-Node-Type', u'serving-System-Identifier', u'extendedLocParameters', u'locationErrorCode', u'cSREvent', u'ptc', u'ptcEncryption', u'national-HI2-ASN1parameters']
    
    #-----< PANI-Header-Info >-----#
    PANI_Header_Info = SEQ(name=u'PANI-Header-Info', mode=MODE_TYPE)
    _PANI_Header_Info_access_Type = OCT_STR(name=u'access-Type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PANI_Header_Info_access_Class = OCT_STR(name=u'access-Class', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PANI_Header_Info_network_Provided = NULL(name=u'network-Provided', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PANI_Header_Info_pANI_Location = SEQ(name=u'pANI-Location', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PANI-Location')), opt=True)
    PANI_Header_Info._cont = ASN1Dict([
        (u'access-Type', _PANI_Header_Info_access_Type),
        (u'access-Class', _PANI_Header_Info_access_Class),
        (u'network-Provided', _PANI_Header_Info_network_Provided),
        (u'pANI-Location', _PANI_Header_Info_pANI_Location),
        ])
    PANI_Header_Info._ext = []
    
    #-----< PANI-Location >-----#
    PANI_Location = SEQ(name=u'PANI-Location', mode=MODE_TYPE)
    _PANI_Location_raw_Location = OCT_STR(name=u'raw-Location', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PANI_Location_location = SEQ(name=u'location', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'Location')), opt=True)
    PANI_Location._cont = ASN1Dict([
        (u'raw-Location', _PANI_Location_raw_Location),
        (u'location', _PANI_Location_location),
        ])
    PANI_Location._ext = []
    
    #-----< PartyInformation >-----#
    PartyInformation = SEQ(name=u'PartyInformation', mode=MODE_TYPE)
    _PartyInformation_party_Qualifier = ENUM(name=u'party-Qualifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PartyInformation_party_Qualifier._cont = ASN1Dict([(u'gPRS-Target', 3)])
    _PartyInformation_party_Qualifier._ext = []
    _PartyInformation_partyIdentity = SEQ(name=u'partyIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PartyInformation_partyIdentity_imei = OCT_STR(name=u'imei', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_imei._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    __PartyInformation_partyIdentity_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_imsi._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    __PartyInformation_partyIdentity_msISDN = OCT_STR(name=u'msISDN', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_msISDN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    __PartyInformation_partyIdentity_e164_Format = OCT_STR(name=u'e164-Format', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_e164_Format._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=25)], ev=None, er=[])
    __PartyInformation_partyIdentity_sip_uri = OCT_STR(name=u'sip-uri', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_tel_uri = OCT_STR(name=u'tel-uri', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_x_3GPP_Asserted_Identity = OCT_STR(name=u'x-3GPP-Asserted-Identity', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PartyInformation_partyIdentity_xUI = OCT_STR(name=u'xUI', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PartyInformation_partyIdentity._cont = ASN1Dict([
        (u'imei', __PartyInformation_partyIdentity_imei),
        (u'imsi', __PartyInformation_partyIdentity_imsi),
        (u'msISDN', __PartyInformation_partyIdentity_msISDN),
        (u'e164-Format', __PartyInformation_partyIdentity_e164_Format),
        (u'sip-uri', __PartyInformation_partyIdentity_sip_uri),
        (u'tel-uri', __PartyInformation_partyIdentity_tel_uri),
        (u'x-3GPP-Asserted-Identity', __PartyInformation_partyIdentity_x_3GPP_Asserted_Identity),
        (u'xUI', __PartyInformation_partyIdentity_xUI),
        ])
    _PartyInformation_partyIdentity._ext = [u'tel-uri', u'x-3GPP-Asserted-Identity', u'xUI']
    _PartyInformation_services_Data_Information = SEQ(name=u'services-Data-Information', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'Services-Data-Information')), opt=True)
    PartyInformation._cont = ASN1Dict([
        (u'party-Qualifier', _PartyInformation_party_Qualifier),
        (u'partyIdentity', _PartyInformation_partyIdentity),
        (u'services-Data-Information', _PartyInformation_services_Data_Information),
        ])
    PartyInformation._ext = []
    
    #-----< Location >-----#
    Location = SEQ(name=u'Location', mode=MODE_TYPE)
    _Location_e164_Number = OCT_STR(name=u'e164-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Location_e164_Number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=25)], ev=None, er=[])
    _Location_globalCellID = OCT_STR(name=u'globalCellID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'GlobalCellID')), opt=True)
    _Location_rAI = OCT_STR(name=u'rAI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'Rai')), opt=True)
    _Location_gsmLocation = CHOICE(name=u'gsmLocation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'GSMLocation')), opt=True)
    _Location_umtsLocation = CHOICE(name=u'umtsLocation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'UMTSLocation')), opt=True)
    _Location_sAI = OCT_STR(name=u'sAI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'Sai')), opt=True)
    _Location_oldRAI = OCT_STR(name=u'oldRAI', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'Rai')), opt=True)
    _Location_tAI = OCT_STR(name=u'tAI', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Location_tAI._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    _Location_eCGI = OCT_STR(name=u'eCGI', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Location_eCGI._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _Location_civicAddress = CHOICE(name=u'civicAddress', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'CivicAddress')), opt=True)
    _Location_operatorSpecificInfo = OCT_STR(name=u'operatorSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Location_uELocationTimestamp = CHOICE(name=u'uELocationTimestamp', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __Location_uELocationTimestamp_timestamp = CHOICE(name=u'timestamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    __Location_uELocationTimestamp_timestampUnknown = NULL(name=u'timestampUnknown', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Location_uELocationTimestamp._cont = ASN1Dict([
        (u'timestamp', __Location_uELocationTimestamp_timestamp),
        (u'timestampUnknown', __Location_uELocationTimestamp_timestampUnknown),
        ])
    _Location_uELocationTimestamp._ext = []
    Location._cont = ASN1Dict([
        (u'e164-Number', _Location_e164_Number),
        (u'globalCellID', _Location_globalCellID),
        (u'rAI', _Location_rAI),
        (u'gsmLocation', _Location_gsmLocation),
        (u'umtsLocation', _Location_umtsLocation),
        (u'sAI', _Location_sAI),
        (u'oldRAI', _Location_oldRAI),
        (u'tAI', _Location_tAI),
        (u'eCGI', _Location_eCGI),
        (u'civicAddress', _Location_civicAddress),
        (u'operatorSpecificInfo', _Location_operatorSpecificInfo),
        (u'uELocationTimestamp', _Location_uELocationTimestamp),
        ])
    Location._ext = [u'oldRAI', u'tAI', u'eCGI', u'civicAddress', u'operatorSpecificInfo', u'uELocationTimestamp']
    
    #-----< GlobalCellID >-----#
    GlobalCellID = OCT_STR(name=u'GlobalCellID', mode=MODE_TYPE)
    GlobalCellID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=7)], ev=None, er=[])
    
    #-----< Rai >-----#
    Rai = OCT_STR(name=u'Rai', mode=MODE_TYPE)
    Rai._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< Sai >-----#
    Sai = OCT_STR(name=u'Sai', mode=MODE_TYPE)
    Sai._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    
    #-----< GSMLocation >-----#
    GSMLocation = CHOICE(name=u'GSMLocation', mode=MODE_TYPE)
    _GSMLocation_geoCoordinates = SEQ(name=u'geoCoordinates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GSMLocation_geoCoordinates_latitude = STR_PRINT(name=u'latitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GSMLocation_geoCoordinates_latitude._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=7, ub=10)], ev=None, er=[])
    __GSMLocation_geoCoordinates_longitude = STR_PRINT(name=u'longitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GSMLocation_geoCoordinates_longitude._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=11)], ev=None, er=[])
    __GSMLocation_geoCoordinates_mapDatum = ENUM(name=u'mapDatum', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'MapDatum')), default=u'wGS84')
    __GSMLocation_geoCoordinates_azimuth = INT(name=u'azimuth', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GSMLocation_geoCoordinates_azimuth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _GSMLocation_geoCoordinates._cont = ASN1Dict([
        (u'latitude', __GSMLocation_geoCoordinates_latitude),
        (u'longitude', __GSMLocation_geoCoordinates_longitude),
        (u'mapDatum', __GSMLocation_geoCoordinates_mapDatum),
        (u'azimuth', __GSMLocation_geoCoordinates_azimuth),
        ])
    _GSMLocation_geoCoordinates._ext = [u'azimuth']
    _GSMLocation_utmCoordinates = SEQ(name=u'utmCoordinates', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GSMLocation_utmCoordinates_utm_East = STR_PRINT(name=u'utm-East', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GSMLocation_utmCoordinates_utm_East._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    __GSMLocation_utmCoordinates_utm_North = STR_PRINT(name=u'utm-North', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GSMLocation_utmCoordinates_utm_North._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    __GSMLocation_utmCoordinates_mapDatum = ENUM(name=u'mapDatum', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'MapDatum')), default=u'wGS84')
    __GSMLocation_utmCoordinates_azimuth = INT(name=u'azimuth', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GSMLocation_utmCoordinates_azimuth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _GSMLocation_utmCoordinates._cont = ASN1Dict([
        (u'utm-East', __GSMLocation_utmCoordinates_utm_East),
        (u'utm-North', __GSMLocation_utmCoordinates_utm_North),
        (u'mapDatum', __GSMLocation_utmCoordinates_mapDatum),
        (u'azimuth', __GSMLocation_utmCoordinates_azimuth),
        ])
    _GSMLocation_utmCoordinates._ext = [u'azimuth']
    _GSMLocation_utmRefCoordinates = SEQ(name=u'utmRefCoordinates', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GSMLocation_utmRefCoordinates_utmref_string = STR_PRINT(name=u'utmref-string', mode=MODE_TYPE)
    __GSMLocation_utmRefCoordinates_utmref_string._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    __GSMLocation_utmRefCoordinates_mapDatum = ENUM(name=u'mapDatum', mode=MODE_TYPE, typeref=ASN1RefType(('UmtsHI2Operations', 'MapDatum')), default=u'wGS84')
    _GSMLocation_utmRefCoordinates._cont = ASN1Dict([
        (u'utmref-string', __GSMLocation_utmRefCoordinates_utmref_string),
        (u'mapDatum', __GSMLocation_utmRefCoordinates_mapDatum),
        ])
    _GSMLocation_utmRefCoordinates._ext = []
    _GSMLocation_wGS84Coordinates = OCT_STR(name=u'wGS84Coordinates', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    GSMLocation._cont = ASN1Dict([
        (u'geoCoordinates', _GSMLocation_geoCoordinates),
        (u'utmCoordinates', _GSMLocation_utmCoordinates),
        (u'utmRefCoordinates', _GSMLocation_utmRefCoordinates),
        (u'wGS84Coordinates', _GSMLocation_wGS84Coordinates),
        ])
    GSMLocation._ext = None
    
    #-----< MapDatum >-----#
    MapDatum = ENUM(name=u'MapDatum', mode=MODE_TYPE)
    MapDatum._cont = ASN1Dict([(u'wGS84', 0), (u'wGS72', 1), (u'eD50', 2)])
    MapDatum._ext = []
    
    #-----< UMTSLocation >-----#
    UMTSLocation = CHOICE(name=u'UMTSLocation', mode=MODE_TYPE)
    _UMTSLocation_point = SEQ(name=u'point', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'GA-Point')))
    _UMTSLocation_pointWithUnCertainty = SEQ(name=u'pointWithUnCertainty', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'GA-PointWithUnCertainty')))
    _UMTSLocation_polygon = SEQ_OF(name=u'polygon', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'GA-Polygon')))
    UMTSLocation._cont = ASN1Dict([
        (u'point', _UMTSLocation_point),
        (u'pointWithUnCertainty', _UMTSLocation_pointWithUnCertainty),
        (u'polygon', _UMTSLocation_polygon),
        ])
    UMTSLocation._ext = None
    
    #-----< GeographicalCoordinates >-----#
    GeographicalCoordinates = SEQ(name=u'GeographicalCoordinates', mode=MODE_TYPE)
    _GeographicalCoordinates_latitudeSign = ENUM(name=u'latitudeSign', mode=MODE_TYPE)
    _GeographicalCoordinates_latitudeSign._cont = ASN1Dict([(u'north', 0), (u'south', 1)])
    _GeographicalCoordinates_latitudeSign._ext = None
    _GeographicalCoordinates_latitude = INT(name=u'latitude', mode=MODE_TYPE)
    _GeographicalCoordinates_latitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    _GeographicalCoordinates_longitude = INT(name=u'longitude', mode=MODE_TYPE)
    _GeographicalCoordinates_longitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    GeographicalCoordinates._cont = ASN1Dict([
        (u'latitudeSign', _GeographicalCoordinates_latitudeSign),
        (u'latitude', _GeographicalCoordinates_latitude),
        (u'longitude', _GeographicalCoordinates_longitude),
        ])
    GeographicalCoordinates._ext = []
    
    #-----< GA-Point >-----#
    GA_Point = SEQ(name=u'GA-Point', mode=MODE_TYPE)
    _GA_Point_geographicalCoordinates = SEQ(name=u'geographicalCoordinates', mode=MODE_TYPE, typeref=ASN1RefType(('UmtsHI2Operations', 'GeographicalCoordinates')))
    GA_Point._cont = ASN1Dict([
        (u'geographicalCoordinates', _GA_Point_geographicalCoordinates),
        ])
    GA_Point._ext = []
    
    #-----< GA-PointWithUnCertainty >-----#
    GA_PointWithUnCertainty = SEQ(name=u'GA-PointWithUnCertainty', mode=MODE_TYPE)
    _GA_PointWithUnCertainty_geographicalCoordinates = SEQ(name=u'geographicalCoordinates', mode=MODE_TYPE, typeref=ASN1RefType(('UmtsHI2Operations', 'GeographicalCoordinates')))
    _GA_PointWithUnCertainty_uncertaintyCode = INT(name=u'uncertaintyCode', mode=MODE_TYPE)
    _GA_PointWithUnCertainty_uncertaintyCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    GA_PointWithUnCertainty._cont = ASN1Dict([
        (u'geographicalCoordinates', _GA_PointWithUnCertainty_geographicalCoordinates),
        (u'uncertaintyCode', _GA_PointWithUnCertainty_uncertaintyCode),
        ])
    GA_PointWithUnCertainty._ext = None
    
    #-----< maxNrOfPoints >-----#
    maxNrOfPoints = INT(name=u'maxNrOfPoints', mode=MODE_VALUE)
    maxNrOfPoints._val = 15
    
    #-----< GA-Polygon >-----#
    GA_Polygon = SEQ_OF(name=u'GA-Polygon', mode=MODE_TYPE)
    _GA_Polygon__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GA_Polygon__item__geographicalCoordinates = SEQ(name=u'geographicalCoordinates', mode=MODE_TYPE, typeref=ASN1RefType(('UmtsHI2Operations', 'GeographicalCoordinates')))
    _GA_Polygon__item_._cont = ASN1Dict([
        (u'geographicalCoordinates', __GA_Polygon__item__geographicalCoordinates),
        ])
    _GA_Polygon__item_._ext = []
    GA_Polygon._cont = _GA_Polygon__item_
    GA_Polygon._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< CivicAddress >-----#
    CivicAddress = CHOICE(name=u'CivicAddress', mode=MODE_TYPE)
    _CivicAddress_detailedCivicAddress = SET_OF(name=u'detailedCivicAddress', mode=MODE_TYPE)
    __CivicAddress_detailedCivicAddress__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('UmtsHI2Operations', 'DetailedCivicAddress')))
    _CivicAddress_detailedCivicAddress._cont = __CivicAddress_detailedCivicAddress__item_
    _CivicAddress_xmlCivicAddress = STR_UTF8(name=u'xmlCivicAddress', mode=MODE_TYPE, typeref=ASN1RefType(('UmtsHI2Operations', 'XmlCivicAddress')))
    CivicAddress._cont = ASN1Dict([
        (u'detailedCivicAddress', _CivicAddress_detailedCivicAddress),
        (u'xmlCivicAddress', _CivicAddress_xmlCivicAddress),
        ])
    CivicAddress._ext = []
    
    #-----< XmlCivicAddress >-----#
    XmlCivicAddress = STR_UTF8(name=u'XmlCivicAddress', mode=MODE_TYPE)
    
    #-----< DetailedCivicAddress >-----#
    DetailedCivicAddress = SEQ(name=u'DetailedCivicAddress', mode=MODE_TYPE)
    _DetailedCivicAddress_building = STR_UTF8(name=u'building', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_room = STR_UTF8(name=u'room', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_placeType = STR_UTF8(name=u'placeType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_postalCommunityName = STR_UTF8(name=u'postalCommunityName', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_additionalCode = STR_UTF8(name=u'additionalCode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_seat = STR_UTF8(name=u'seat', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_primaryRoad = STR_UTF8(name=u'primaryRoad', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_primaryRoadDirection = STR_UTF8(name=u'primaryRoadDirection', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_trailingStreetSuffix = STR_UTF8(name=u'trailingStreetSuffix', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_streetSuffix = STR_UTF8(name=u'streetSuffix', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_houseNumber = STR_UTF8(name=u'houseNumber', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_houseNumberSuffix = STR_UTF8(name=u'houseNumberSuffix', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_landmarkAddress = STR_UTF8(name=u'landmarkAddress', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_additionalLocation = STR_UTF8(name=u'additionalLocation', mode=MODE_TYPE, tag=(114, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_name = STR_UTF8(name=u'name', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_floor = STR_UTF8(name=u'floor', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_primaryStreet = STR_UTF8(name=u'primaryStreet', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_primaryStreetDirection = STR_UTF8(name=u'primaryStreetDirection', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_roadSection = STR_UTF8(name=u'roadSection', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_roadBranch = STR_UTF8(name=u'roadBranch', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_roadSubBranch = STR_UTF8(name=u'roadSubBranch', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_roadPreModifier = STR_UTF8(name=u'roadPreModifier', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_roadPostModifier = STR_UTF8(name=u'roadPostModifier', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_postalCode = STR_UTF8(name=u'postalCode', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_town = STR_UTF8(name=u'town', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_county = STR_UTF8(name=u'county', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DetailedCivicAddress_country = STR_UTF8(name=u'country', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DetailedCivicAddress_language = STR_UTF8(name=u'language', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    DetailedCivicAddress._cont = ASN1Dict([
        (u'building', _DetailedCivicAddress_building),
        (u'room', _DetailedCivicAddress_room),
        (u'placeType', _DetailedCivicAddress_placeType),
        (u'postalCommunityName', _DetailedCivicAddress_postalCommunityName),
        (u'additionalCode', _DetailedCivicAddress_additionalCode),
        (u'seat', _DetailedCivicAddress_seat),
        (u'primaryRoad', _DetailedCivicAddress_primaryRoad),
        (u'primaryRoadDirection', _DetailedCivicAddress_primaryRoadDirection),
        (u'trailingStreetSuffix', _DetailedCivicAddress_trailingStreetSuffix),
        (u'streetSuffix', _DetailedCivicAddress_streetSuffix),
        (u'houseNumber', _DetailedCivicAddress_houseNumber),
        (u'houseNumberSuffix', _DetailedCivicAddress_houseNumberSuffix),
        (u'landmarkAddress', _DetailedCivicAddress_landmarkAddress),
        (u'additionalLocation', _DetailedCivicAddress_additionalLocation),
        (u'name', _DetailedCivicAddress_name),
        (u'floor', _DetailedCivicAddress_floor),
        (u'primaryStreet', _DetailedCivicAddress_primaryStreet),
        (u'primaryStreetDirection', _DetailedCivicAddress_primaryStreetDirection),
        (u'roadSection', _DetailedCivicAddress_roadSection),
        (u'roadBranch', _DetailedCivicAddress_roadBranch),
        (u'roadSubBranch', _DetailedCivicAddress_roadSubBranch),
        (u'roadPreModifier', _DetailedCivicAddress_roadPreModifier),
        (u'roadPostModifier', _DetailedCivicAddress_roadPostModifier),
        (u'postalCode', _DetailedCivicAddress_postalCode),
        (u'town', _DetailedCivicAddress_town),
        (u'county', _DetailedCivicAddress_county),
        (u'country', _DetailedCivicAddress_country),
        (u'language', _DetailedCivicAddress_language),
        ])
    DetailedCivicAddress._ext = []
    
    #-----< SMS-report >-----#
    SMS_report = SEQ(name=u'SMS-report', mode=MODE_TYPE)
    _SMS_report_sMS_Contents = SEQ(name=u'sMS-Contents', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SMS_report_sMS_Contents_sms_initiator = ENUM(name=u'sms-initiator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SMS_report_sMS_Contents_sms_initiator._cont = ASN1Dict([(u'target', 0), (u'server', 1), (u'undefined-party', 2)])
    __SMS_report_sMS_Contents_sms_initiator._ext = []
    __SMS_report_sMS_Contents_transfer_status = ENUM(name=u'transfer-status', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SMS_report_sMS_Contents_transfer_status._cont = ASN1Dict([(u'succeed-transfer', 0), (u'not-succeed-transfer', 1), (u'undefined', 2)])
    __SMS_report_sMS_Contents_transfer_status._ext = []
    __SMS_report_sMS_Contents_other_message = ENUM(name=u'other-message', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SMS_report_sMS_Contents_other_message._cont = ASN1Dict([(u'yes', 0), (u'no', 1), (u'undefined', 2)])
    __SMS_report_sMS_Contents_other_message._ext = []
    __SMS_report_sMS_Contents_content = OCT_STR(name=u'content', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SMS_report_sMS_Contents_content._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=270)], ev=None, er=[])
    _SMS_report_sMS_Contents._cont = ASN1Dict([
        (u'sms-initiator', __SMS_report_sMS_Contents_sms_initiator),
        (u'transfer-status', __SMS_report_sMS_Contents_transfer_status),
        (u'other-message', __SMS_report_sMS_Contents_other_message),
        (u'content', __SMS_report_sMS_Contents_content),
        ])
    _SMS_report_sMS_Contents._ext = []
    SMS_report._cont = ASN1Dict([
        (u'sMS-Contents', _SMS_report_sMS_Contents),
        ])
    SMS_report._ext = None
    
    #-----< GPRSCorrelationNumber >-----#
    GPRSCorrelationNumber = OCT_STR(name=u'GPRSCorrelationNumber', mode=MODE_TYPE)
    GPRSCorrelationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=20)], ev=None, er=[])
    
    #-----< CorrelationValues >-----#
    CorrelationValues = CHOICE(name=u'CorrelationValues', mode=MODE_TYPE)
    _CorrelationValues_iri_to_CC = SEQ(name=u'iri-to-CC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'IRI-to-CC-Correlation')))
    _CorrelationValues_iri_to_iri = OCT_STR(name=u'iri-to-iri', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'IRI-to-IRI-Correlation')))
    _CorrelationValues_both_IRI_CC = SEQ(name=u'both-IRI-CC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CorrelationValues_both_IRI_CC_iri_CC = SEQ(name=u'iri-CC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'IRI-to-CC-Correlation')))
    __CorrelationValues_both_IRI_CC_iri_IRI = OCT_STR(name=u'iri-IRI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'IRI-to-IRI-Correlation')))
    _CorrelationValues_both_IRI_CC._cont = ASN1Dict([
        (u'iri-CC', __CorrelationValues_both_IRI_CC_iri_CC),
        (u'iri-IRI', __CorrelationValues_both_IRI_CC_iri_IRI),
        ])
    _CorrelationValues_both_IRI_CC._ext = None
    CorrelationValues._cont = ASN1Dict([
        (u'iri-to-CC', _CorrelationValues_iri_to_CC),
        (u'iri-to-iri', _CorrelationValues_iri_to_iri),
        (u'both-IRI-CC', _CorrelationValues_both_IRI_CC),
        ])
    CorrelationValues._ext = None
    
    #-----< IMS-VoIP-Correlation >-----#
    IMS_VoIP_Correlation = SET_OF(name=u'IMS-VoIP-Correlation', mode=MODE_TYPE)
    _IMS_VoIP_Correlation__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __IMS_VoIP_Correlation__item__ims_iri = OCT_STR(name=u'ims-iri', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'IRI-to-IRI-Correlation')))
    __IMS_VoIP_Correlation__item__ims_cc = SEQ(name=u'ims-cc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'IRI-to-CC-Correlation')), opt=True)
    _IMS_VoIP_Correlation__item_._cont = ASN1Dict([
        (u'ims-iri', __IMS_VoIP_Correlation__item__ims_iri),
        (u'ims-cc', __IMS_VoIP_Correlation__item__ims_cc),
        ])
    _IMS_VoIP_Correlation__item_._ext = None
    IMS_VoIP_Correlation._cont = _IMS_VoIP_Correlation__item_
    
    #-----< IRI-to-CC-Correlation >-----#
    IRI_to_CC_Correlation = SEQ(name=u'IRI-to-CC-Correlation', mode=MODE_TYPE)
    _IRI_to_CC_Correlation_cc = SET_OF(name=u'cc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __IRI_to_CC_Correlation_cc__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    _IRI_to_CC_Correlation_cc._cont = __IRI_to_CC_Correlation_cc__item_
    _IRI_to_CC_Correlation_iri = OCT_STR(name=u'iri', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    IRI_to_CC_Correlation._cont = ASN1Dict([
        (u'cc', _IRI_to_CC_Correlation_cc),
        (u'iri', _IRI_to_CC_Correlation_iri),
        ])
    IRI_to_CC_Correlation._ext = None
    
    #-----< IRI-to-IRI-Correlation >-----#
    IRI_to_IRI_Correlation = OCT_STR(name=u'IRI-to-IRI-Correlation', mode=MODE_TYPE)
    
    #-----< GPRSEvent >-----#
    GPRSEvent = ENUM(name=u'GPRSEvent', mode=MODE_TYPE)
    GPRSEvent._cont = ASN1Dict([(u'pDPContextActivation', 1), (u'startOfInterceptionWithPDPContextActive', 2), (u'pDPContextDeactivation', 4), (u'gPRSAttach', 5), (u'gPRSDetach', 6), (u'locationInfoUpdate', 10), (u'sMS', 11), (u'pDPContextModification', 13), (u'servingSystem', 14), (u'startOfInterceptionWithMSAttached', 15), (u'packetDataHeaderInformation', 16), (u'hSS-Subscriber-Record-Change', 17), (u'registration-Termination', 18), (u'location-Up-Date', 19), (u'cancel-Location', 20), (u'register-Location', 21), (u'location-Information-Request', 22)])
    GPRSEvent._ext = [u'startOfInterceptionWithMSAttached', u'packetDataHeaderInformation', u'hSS-Subscriber-Record-Change', u'registration-Termination', u'location-Up-Date', u'cancel-Location', u'register-Location', u'location-Information-Request']
    
    #-----< CSREvent >-----#
    CSREvent = ENUM(name=u'CSREvent', mode=MODE_TYPE)
    CSREvent._cont = ASN1Dict([(u'cSREventMessage', 1)])
    CSREvent._ext = []
    
    #-----< IMSevent >-----#
    IMSevent = ENUM(name=u'IMSevent', mode=MODE_TYPE)
    IMSevent._cont = ASN1Dict([(u'unfilteredSIPmessage', 1), (u'sIPheaderOnly', 2), (u'decryptionKeysAvailable', 3), (u'startOfInterceptionForIMSEstablishedSession', 4), (u'xCAPRequest', 5), (u'xCAPResponse', 6), (u'ccUnavailable', 7)])
    IMSevent._ext = [u'sIPheaderOnly', u'decryptionKeysAvailable', u'startOfInterceptionForIMSEstablishedSession', u'xCAPRequest', u'xCAPResponse', u'ccUnavailable']
    
    #-----< Current-Previous-Systems >-----#
    Current_Previous_Systems = SEQ(name=u'Current-Previous-Systems', mode=MODE_TYPE)
    _Current_Previous_Systems_serving_System_Identifier = OCT_STR(name=u'serving-System-Identifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Current_Previous_Systems_current_Serving_SGSN_Number = OCT_STR(name=u'current-Serving-SGSN-Number', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Current_Previous_Systems_current_Serving_SGSN_Address = OCT_STR(name=u'current-Serving-SGSN-Address', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Current_Previous_Systems_current_Serving_S4_SGSN_Address = OCT_STR(name=u'current-Serving-S4-SGSN-Address', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Current_Previous_Systems_previous_Serving_System_Identifier = OCT_STR(name=u'previous-Serving-System-Identifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Current_Previous_Systems_previous_Serving_SGSN_Number = OCT_STR(name=u'previous-Serving-SGSN-Number', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Current_Previous_Systems_previous_Serving_SGSN_Address = OCT_STR(name=u'previous-Serving-SGSN-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Current_Previous_Systems_previous_Serving_S4_SGSN_Address = OCT_STR(name=u'previous-Serving-S4-SGSN-Address', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    Current_Previous_Systems._cont = ASN1Dict([
        (u'serving-System-Identifier', _Current_Previous_Systems_serving_System_Identifier),
        (u'current-Serving-SGSN-Number', _Current_Previous_Systems_current_Serving_SGSN_Number),
        (u'current-Serving-SGSN-Address', _Current_Previous_Systems_current_Serving_SGSN_Address),
        (u'current-Serving-S4-SGSN-Address', _Current_Previous_Systems_current_Serving_S4_SGSN_Address),
        (u'previous-Serving-System-Identifier', _Current_Previous_Systems_previous_Serving_System_Identifier),
        (u'previous-Serving-SGSN-Number', _Current_Previous_Systems_previous_Serving_SGSN_Number),
        (u'previous-Serving-SGSN-Address', _Current_Previous_Systems_previous_Serving_SGSN_Address),
        (u'previous-Serving-S4-SGSN-Address', _Current_Previous_Systems_previous_Serving_S4_SGSN_Address),
        ])
    Current_Previous_Systems._ext = []
    
    #-----< Change-Of-Target-Identity >-----#
    Change_Of_Target_Identity = SEQ(name=u'Change-Of-Target-Identity', mode=MODE_TYPE)
    _Change_Of_Target_Identity_new_MSISDN = SEQ(name=u'new-MSISDN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_old_MSISDN = SEQ(name=u'old-MSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_new_IMSI = SEQ(name=u'new-IMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_old_IMSI = SEQ(name=u'old-IMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_new_IMEI = SEQ(name=u'new-IMEI', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_old_IMEI = SEQ(name=u'old-IMEI', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_new_IMPI = SEQ(name=u'new-IMPI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_old_IMPI = SEQ(name=u'old-IMPI', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_new_SIP_URI = SEQ(name=u'new-SIP-URI', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_old_SIP_URI = SEQ(name=u'old-SIP-URI', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_new_TEL_URI = SEQ(name=u'new-TEL-URI', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PartyInformation')), opt=True)
    _Change_Of_Target_Identity_old_TEL_URI = SEQ(name=u'old-TEL-URI', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PartyInformation')), opt=True)
    Change_Of_Target_Identity._cont = ASN1Dict([
        (u'new-MSISDN', _Change_Of_Target_Identity_new_MSISDN),
        (u'old-MSISDN', _Change_Of_Target_Identity_old_MSISDN),
        (u'new-IMSI', _Change_Of_Target_Identity_new_IMSI),
        (u'old-IMSI', _Change_Of_Target_Identity_old_IMSI),
        (u'new-IMEI', _Change_Of_Target_Identity_new_IMEI),
        (u'old-IMEI', _Change_Of_Target_Identity_old_IMEI),
        (u'new-IMPI', _Change_Of_Target_Identity_new_IMPI),
        (u'old-IMPI', _Change_Of_Target_Identity_old_IMPI),
        (u'new-SIP-URI', _Change_Of_Target_Identity_new_SIP_URI),
        (u'old-SIP-URI', _Change_Of_Target_Identity_old_SIP_URI),
        (u'new-TEL-URI', _Change_Of_Target_Identity_new_TEL_URI),
        (u'old-TEL-URI', _Change_Of_Target_Identity_old_TEL_URI),
        ])
    Change_Of_Target_Identity._ext = [u'new-IMPI', u'old-IMPI', u'new-SIP-URI', u'old-SIP-URI', u'new-TEL-URI', u'old-TEL-URI']
    
    #-----< Requesting-Node-Type >-----#
    Requesting_Node_Type = ENUM(name=u'Requesting-Node-Type', mode=MODE_TYPE)
    Requesting_Node_Type._cont = ASN1Dict([(u'mSC', 1), (u'sMS-Centre', 2), (u'gMLC', 3), (u'mME', 4), (u'sGSN', 5)])
    Requesting_Node_Type._ext = []
    
    #-----< Services-Data-Information >-----#
    Services_Data_Information = SEQ(name=u'Services-Data-Information', mode=MODE_TYPE)
    _Services_Data_Information_gPRS_parameters = SEQ(name=u'gPRS-parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'GPRS-parameters')), opt=True)
    Services_Data_Information._cont = ASN1Dict([
        (u'gPRS-parameters', _Services_Data_Information_gPRS_parameters),
        ])
    Services_Data_Information._ext = []
    
    #-----< GPRS-parameters >-----#
    GPRS_parameters = SEQ(name=u'GPRS-parameters', mode=MODE_TYPE)
    _GPRS_parameters_pDP_address_allocated_to_the_target = CHOICE(name=u'pDP-address-allocated-to-the-target', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DataNodeAddress')), opt=True)
    _GPRS_parameters_aPN = OCT_STR(name=u'aPN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GPRS_parameters_aPN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _GPRS_parameters_pDP_type = OCT_STR(name=u'pDP-type', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GPRS_parameters_pDP_type._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GPRS_parameters_nSAPI = OCT_STR(name=u'nSAPI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GPRS_parameters_nSAPI._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _GPRS_parameters_additionalIPaddress = CHOICE(name=u'additionalIPaddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'DataNodeAddress')), opt=True)
    GPRS_parameters._cont = ASN1Dict([
        (u'pDP-address-allocated-to-the-target', _GPRS_parameters_pDP_address_allocated_to_the_target),
        (u'aPN', _GPRS_parameters_aPN),
        (u'pDP-type', _GPRS_parameters_pDP_type),
        (u'nSAPI', _GPRS_parameters_nSAPI),
        (u'additionalIPaddress', _GPRS_parameters_additionalIPaddress),
        ])
    GPRS_parameters._ext = [u'nSAPI', u'additionalIPaddress']
    
    #-----< GPRSOperationErrorCode >-----#
    GPRSOperationErrorCode = OCT_STR(name=u'GPRSOperationErrorCode', mode=MODE_TYPE)
    
    #-----< LDIevent >-----#
    LDIevent = ENUM(name=u'LDIevent', mode=MODE_TYPE)
    LDIevent._cont = ASN1Dict([(u'targetEntersIA', 1), (u'targetLeavesIA', 2)])
    LDIevent._ext = []
    
    #-----< UmtsQos >-----#
    UmtsQos = CHOICE(name=u'UmtsQos', mode=MODE_TYPE)
    _UmtsQos_qosMobileRadio = OCT_STR(name=u'qosMobileRadio', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UmtsQos_qosGn = OCT_STR(name=u'qosGn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    UmtsQos._cont = ASN1Dict([
        (u'qosMobileRadio', _UmtsQos_qosMobileRadio),
        (u'qosGn', _UmtsQos_qosGn),
        ])
    UmtsQos._ext = None
    
    #-----< MediaDecryption-info >-----#
    MediaDecryption_info = SEQ_OF(name=u'MediaDecryption-info', mode=MODE_TYPE)
    _MediaDecryption_info__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('UmtsHI2Operations', 'CCKeyInfo')))
    MediaDecryption_info._cont = _MediaDecryption_info__item_
    
    #-----< CCKeyInfo >-----#
    CCKeyInfo = SEQ(name=u'CCKeyInfo', mode=MODE_TYPE)
    _CCKeyInfo_cCCSID = OCT_STR(name=u'cCCSID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CCKeyInfo_cCDecKey = OCT_STR(name=u'cCDecKey', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CCKeyInfo_cCSalt = OCT_STR(name=u'cCSalt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    CCKeyInfo._cont = ASN1Dict([
        (u'cCCSID', _CCKeyInfo_cCCSID),
        (u'cCDecKey', _CCKeyInfo_cCDecKey),
        (u'cCSalt', _CCKeyInfo_cCSalt),
        ])
    CCKeyInfo._ext = []
    
    #-----< MediaSecFailureIndication >-----#
    MediaSecFailureIndication = ENUM(name=u'MediaSecFailureIndication', mode=MODE_TYPE)
    MediaSecFailureIndication._cont = ASN1Dict([(u'genericFailure', 0)])
    MediaSecFailureIndication._ext = []
    
    #-----< PacketDataHeaderInformation >-----#
    PacketDataHeaderInformation = CHOICE(name=u'PacketDataHeaderInformation', mode=MODE_TYPE)
    _PacketDataHeaderInformation_packetDataHeader = CHOICE(name=u'packetDataHeader', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PacketDataHeaderReport')))
    _PacketDataHeaderInformation_packetDataSummary = SEQ_OF(name=u'packetDataSummary', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PacketDataSummaryReport')))
    PacketDataHeaderInformation._cont = ASN1Dict([
        (u'packetDataHeader', _PacketDataHeaderInformation_packetDataHeader),
        (u'packetDataSummary', _PacketDataHeaderInformation_packetDataSummary),
        ])
    PacketDataHeaderInformation._ext = []
    
    #-----< PacketDataHeaderReport >-----#
    PacketDataHeaderReport = CHOICE(name=u'PacketDataHeaderReport', mode=MODE_TYPE)
    _PacketDataHeaderReport_packetDataHeaderMapped = SEQ(name=u'packetDataHeaderMapped', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PacketDataHeaderMapped')))
    _PacketDataHeaderReport_packetDataHeaderCopy = SEQ(name=u'packetDataHeaderCopy', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PacketDataHeaderCopy')))
    PacketDataHeaderReport._cont = ASN1Dict([
        (u'packetDataHeaderMapped', _PacketDataHeaderReport_packetDataHeaderMapped),
        (u'packetDataHeaderCopy', _PacketDataHeaderReport_packetDataHeaderCopy),
        ])
    PacketDataHeaderReport._ext = []
    
    #-----< PacketDataHeaderMapped >-----#
    PacketDataHeaderMapped = SEQ(name=u'PacketDataHeaderMapped', mode=MODE_TYPE)
    _PacketDataHeaderMapped_sourceIPAddress = SEQ(name=u'sourceIPAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IPAddress')))
    _PacketDataHeaderMapped_sourcePortNumber = INT(name=u'sourcePortNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PacketDataHeaderMapped_sourcePortNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PacketDataHeaderMapped_destinationIPAddress = SEQ(name=u'destinationIPAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IPAddress')))
    _PacketDataHeaderMapped_destinationPortNumber = INT(name=u'destinationPortNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PacketDataHeaderMapped_destinationPortNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PacketDataHeaderMapped_transportProtocol = INT(name=u'transportProtocol', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PacketDataHeaderMapped_packetsize = INT(name=u'packetsize', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PacketDataHeaderMapped_flowLabel = INT(name=u'flowLabel', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PacketDataHeaderMapped_packetCount = INT(name=u'packetCount', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PacketDataHeaderMapped_direction = ENUM(name=u'direction', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'TPDU-direction')))
    PacketDataHeaderMapped._cont = ASN1Dict([
        (u'sourceIPAddress', _PacketDataHeaderMapped_sourceIPAddress),
        (u'sourcePortNumber', _PacketDataHeaderMapped_sourcePortNumber),
        (u'destinationIPAddress', _PacketDataHeaderMapped_destinationIPAddress),
        (u'destinationPortNumber', _PacketDataHeaderMapped_destinationPortNumber),
        (u'transportProtocol', _PacketDataHeaderMapped_transportProtocol),
        (u'packetsize', _PacketDataHeaderMapped_packetsize),
        (u'flowLabel', _PacketDataHeaderMapped_flowLabel),
        (u'packetCount', _PacketDataHeaderMapped_packetCount),
        (u'direction', _PacketDataHeaderMapped_direction),
        ])
    PacketDataHeaderMapped._ext = []
    
    #-----< TPDU-direction >-----#
    TPDU_direction = ENUM(name=u'TPDU-direction', mode=MODE_TYPE)
    TPDU_direction._cont = ASN1Dict([(u'from-target', 1), (u'to-target', 2), (u'unknown', 3)])
    TPDU_direction._ext = None
    
    #-----< PacketDataHeaderCopy >-----#
    PacketDataHeaderCopy = SEQ(name=u'PacketDataHeaderCopy', mode=MODE_TYPE)
    _PacketDataHeaderCopy_direction = ENUM(name=u'direction', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'TPDU-direction')))
    _PacketDataHeaderCopy_headerCopy = OCT_STR(name=u'headerCopy', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    PacketDataHeaderCopy._cont = ASN1Dict([
        (u'direction', _PacketDataHeaderCopy_direction),
        (u'headerCopy', _PacketDataHeaderCopy_headerCopy),
        ])
    PacketDataHeaderCopy._ext = []
    
    #-----< PacketDataSummaryReport >-----#
    PacketDataSummaryReport = SEQ_OF(name=u'PacketDataSummaryReport', mode=MODE_TYPE)
    _PacketDataSummaryReport__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('UmtsHI2Operations', 'PacketFlowSummary')))
    PacketDataSummaryReport._cont = _PacketDataSummaryReport__item_
    
    #-----< PacketFlowSummary >-----#
    PacketFlowSummary = SEQ(name=u'PacketFlowSummary', mode=MODE_TYPE)
    _PacketFlowSummary_sourceIPAddress = SEQ(name=u'sourceIPAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IPAddress')))
    _PacketFlowSummary_sourcePortNumber = INT(name=u'sourcePortNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PacketFlowSummary_sourcePortNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PacketFlowSummary_destinationIPAddress = SEQ(name=u'destinationIPAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IPAddress')))
    _PacketFlowSummary_destinationPortNumber = INT(name=u'destinationPortNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PacketFlowSummary_destinationPortNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PacketFlowSummary_transportProtocol = INT(name=u'transportProtocol', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PacketFlowSummary_flowLabel = INT(name=u'flowLabel', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PacketFlowSummary_summaryPeriod = SEQ(name=u'summaryPeriod', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'ReportInterval')))
    _PacketFlowSummary_packetCount = INT(name=u'packetCount', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PacketFlowSummary_sumOfPacketSizes = INT(name=u'sumOfPacketSizes', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PacketFlowSummary_packetDataSummaryReason = ENUM(name=u'packetDataSummaryReason', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'ReportReason')))
    PacketFlowSummary._cont = ASN1Dict([
        (u'sourceIPAddress', _PacketFlowSummary_sourceIPAddress),
        (u'sourcePortNumber', _PacketFlowSummary_sourcePortNumber),
        (u'destinationIPAddress', _PacketFlowSummary_destinationIPAddress),
        (u'destinationPortNumber', _PacketFlowSummary_destinationPortNumber),
        (u'transportProtocol', _PacketFlowSummary_transportProtocol),
        (u'flowLabel', _PacketFlowSummary_flowLabel),
        (u'summaryPeriod', _PacketFlowSummary_summaryPeriod),
        (u'packetCount', _PacketFlowSummary_packetCount),
        (u'sumOfPacketSizes', _PacketFlowSummary_sumOfPacketSizes),
        (u'packetDataSummaryReason', _PacketFlowSummary_packetDataSummaryReason),
        ])
    PacketFlowSummary._ext = []
    
    #-----< ReportReason >-----#
    ReportReason = ENUM(name=u'ReportReason', mode=MODE_TYPE)
    ReportReason._cont = ASN1Dict([(u'timerExpired', 0), (u'countThresholdHit', 1), (u'pDPComtextDeactivated', 2), (u'pDPContextModification', 3), (u'otherOrUnknown', 4)])
    ReportReason._ext = []
    
    #-----< ReportInterval >-----#
    ReportInterval = SEQ(name=u'ReportInterval', mode=MODE_TYPE)
    _ReportInterval_firstPacketTimeStamp = CHOICE(name=u'firstPacketTimeStamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    _ReportInterval_lastPacketTimeStamp = CHOICE(name=u'lastPacketTimeStamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    ReportInterval._cont = ASN1Dict([
        (u'firstPacketTimeStamp', _ReportInterval_firstPacketTimeStamp),
        (u'lastPacketTimeStamp', _ReportInterval_lastPacketTimeStamp),
        ])
    ReportInterval._ext = []
    
    #-----< ExtendedLocParameters >-----#
    ExtendedLocParameters = SEQ(name=u'ExtendedLocParameters', mode=MODE_TYPE)
    _ExtendedLocParameters_posMethod = STR_PRINT(name=u'posMethod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ExtendedLocParameters_mapData = CHOICE(name=u'mapData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ExtendedLocParameters_mapData_base64Map = STR_PRINT(name=u'base64Map', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ExtendedLocParameters_mapData_url = STR_PRINT(name=u'url', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ExtendedLocParameters_mapData._cont = ASN1Dict([
        (u'base64Map', __ExtendedLocParameters_mapData_base64Map),
        (u'url', __ExtendedLocParameters_mapData_url),
        ])
    _ExtendedLocParameters_mapData._ext = None
    _ExtendedLocParameters_altitude = SEQ(name=u'altitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ExtendedLocParameters_altitude_alt = STR_PRINT(name=u'alt', mode=MODE_TYPE)
    __ExtendedLocParameters_altitude_alt_uncertainty = STR_PRINT(name=u'alt-uncertainty', mode=MODE_TYPE, opt=True)
    _ExtendedLocParameters_altitude._cont = ASN1Dict([
        (u'alt', __ExtendedLocParameters_altitude_alt),
        (u'alt-uncertainty', __ExtendedLocParameters_altitude_alt_uncertainty),
        ])
    _ExtendedLocParameters_altitude._ext = None
    _ExtendedLocParameters_speed = STR_PRINT(name=u'speed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ExtendedLocParameters_direction = STR_PRINT(name=u'direction', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ExtendedLocParameters_level_conf = STR_PRINT(name=u'level-conf', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ExtendedLocParameters_qOS_not_met = BOOL(name=u'qOS-not-met', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ExtendedLocParameters_motionStateList = SEQ(name=u'motionStateList', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ExtendedLocParameters_motionStateList_primaryMotionState = STR_PRINT(name=u'primaryMotionState', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ExtendedLocParameters_motionStateList_secondaryMotionState = SEQ_OF(name=u'secondaryMotionState', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ExtendedLocParameters_motionStateList_secondaryMotionState__item_ = STR_PRINT(name='_item_', mode=MODE_TYPE)
    __ExtendedLocParameters_motionStateList_secondaryMotionState._cont = ___ExtendedLocParameters_motionStateList_secondaryMotionState__item_
    __ExtendedLocParameters_motionStateList_confidence = STR_PRINT(name=u'confidence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ExtendedLocParameters_motionStateList._cont = ASN1Dict([
        (u'primaryMotionState', __ExtendedLocParameters_motionStateList_primaryMotionState),
        (u'secondaryMotionState', __ExtendedLocParameters_motionStateList_secondaryMotionState),
        (u'confidence', __ExtendedLocParameters_motionStateList_confidence),
        ])
    _ExtendedLocParameters_motionStateList._ext = None
    _ExtendedLocParameters_floor = SEQ(name=u'floor', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ExtendedLocParameters_floor_floor_number = STR_PRINT(name=u'floor-number', mode=MODE_TYPE)
    __ExtendedLocParameters_floor_floor_number_uncertainty = STR_PRINT(name=u'floor-number-uncertainty', mode=MODE_TYPE, opt=True)
    _ExtendedLocParameters_floor._cont = ASN1Dict([
        (u'floor-number', __ExtendedLocParameters_floor_floor_number),
        (u'floor-number-uncertainty', __ExtendedLocParameters_floor_floor_number_uncertainty),
        ])
    _ExtendedLocParameters_floor._ext = None
    _ExtendedLocParameters_additional_info = STR_PRINT(name=u'additional-info', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ExtendedLocParameters_lALS_rawMLPPosData = STR_UTF8(name=u'lALS-rawMLPPosData', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ExtendedLocParameters._cont = ASN1Dict([
        (u'posMethod', _ExtendedLocParameters_posMethod),
        (u'mapData', _ExtendedLocParameters_mapData),
        (u'altitude', _ExtendedLocParameters_altitude),
        (u'speed', _ExtendedLocParameters_speed),
        (u'direction', _ExtendedLocParameters_direction),
        (u'level-conf', _ExtendedLocParameters_level_conf),
        (u'qOS-not-met', _ExtendedLocParameters_qOS_not_met),
        (u'motionStateList', _ExtendedLocParameters_motionStateList),
        (u'floor', _ExtendedLocParameters_floor),
        (u'additional-info', _ExtendedLocParameters_additional_info),
        (u'lALS-rawMLPPosData', _ExtendedLocParameters_lALS_rawMLPPosData),
        ])
    ExtendedLocParameters._ext = []
    
    #-----< LocationErrorCode >-----#
    LocationErrorCode = INT(name=u'LocationErrorCode', mode=MODE_TYPE)
    LocationErrorCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=699)], ev=None, er=[])
    
    #-----< PTCEncryptionInfo >-----#
    PTCEncryptionInfo = SEQ(name=u'PTCEncryptionInfo', mode=MODE_TYPE)
    _PTCEncryptionInfo_cipher = STR_UTF8(name=u'cipher', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PTCEncryptionInfo_cryptoContext = STR_UTF8(name=u'cryptoContext', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTCEncryptionInfo_key = STR_UTF8(name=u'key', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PTCEncryptionInfo_keyEncoding = STR_UTF8(name=u'keyEncoding', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PTCEncryptionInfo_salt = STR_UTF8(name=u'salt', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTCEncryptionInfo_pTCOther = STR_UTF8(name=u'pTCOther', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    PTCEncryptionInfo._cont = ASN1Dict([
        (u'cipher', _PTCEncryptionInfo_cipher),
        (u'cryptoContext', _PTCEncryptionInfo_cryptoContext),
        (u'key', _PTCEncryptionInfo_key),
        (u'keyEncoding', _PTCEncryptionInfo_keyEncoding),
        (u'salt', _PTCEncryptionInfo_salt),
        (u'pTCOther', _PTCEncryptionInfo_pTCOther),
        ])
    PTCEncryptionInfo._ext = []
    
    #-----< PTC >-----#
    PTC = SEQ(name=u'PTC', mode=MODE_TYPE)
    _PTC_abandonCause = STR_UTF8(name=u'abandonCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_accessPolicyFailure = STR_UTF8(name=u'accessPolicyFailure', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_accessPolicyType = SEQ(name=u'accessPolicyType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'AccessPolicyType')), opt=True)
    _PTC_alertIndicator = ENUM(name=u'alertIndicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'AlertIndicator')), opt=True)
    _PTC_associatePresenceStatus = SEQ(name=u'associatePresenceStatus', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'AssociatePresenceStatus')), opt=True)
    _PTC_bearer_capability = STR_UTF8(name=u'bearer-capability', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_broadcastIndicator = BOOL(name=u'broadcastIndicator', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_contactID = STR_UTF8(name=u'contactID', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_emergency = ENUM(name=u'emergency', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'Emergency')), opt=True)
    _PTC_emergencyGroupState = SEQ(name=u'emergencyGroupState', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'EmergencyGroupState')), opt=True)
    _PTC_timeStamp = CHOICE(name=u'timeStamp', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')))
    _PTC_pTCType = ENUM(name=u'pTCType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PTCType')), opt=True)
    _PTC_failureCode = STR_UTF8(name=u'failureCode', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_floorActivity = SEQ(name=u'floorActivity', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'FloorActivity')), opt=True)
    _PTC_floorSpeakerID = SEQ(name=u'floorSpeakerID', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PTCAddress')), opt=True)
    _PTC_groupAdSender = STR_UTF8(name=u'groupAdSender', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_groupAuthRule = ENUM(name=u'groupAuthRule', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'GroupAuthRule')), opt=True)
    _PTC_groupCharacteristics = STR_UTF8(name=u'groupCharacteristics', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_holdRetrieveInd = BOOL(name=u'holdRetrieveInd', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_imminentPerilInd = ENUM(name=u'imminentPerilInd', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'ImminentPerilInd')), opt=True)
    _PTC_implicitFloorReq = ENUM(name=u'implicitFloorReq', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'ImplicitFloorReq')), opt=True)
    _PTC_initiationCause = ENUM(name=u'initiationCause', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'InitiationCause')), opt=True)
    _PTC_invitationCause = STR_UTF8(name=u'invitationCause', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_iPAPartyID = STR_UTF8(name=u'iPAPartyID', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_iPADirection = ENUM(name=u'iPADirection', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'IPADirection')), opt=True)
    _PTC_listManagementAction = ENUM(name=u'listManagementAction', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'ListManagementAction')), opt=True)
    _PTC_listManagementFailure = STR_UTF8(name=u'listManagementFailure', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_listManagementType = ENUM(name=u'listManagementType', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'ListManagementType')), opt=True)
    _PTC_maxTBTime = STR_UTF8(name=u'maxTBTime', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_mCPTTGroupID = STR_UTF8(name=u'mCPTTGroupID', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_mCPTTID = STR_UTF8(name=u'mCPTTID', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_mCPTTInd = BOOL(name=u'mCPTTInd', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_location = SEQ(name=u'location', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'Location')), opt=True)
    _PTC_mCPTTOrganizationName = STR_UTF8(name=u'mCPTTOrganizationName', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_mediaStreamAvail = BOOL(name=u'mediaStreamAvail', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_priority_Level = ENUM(name=u'priority-Level', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'Priority-Level')), opt=True)
    _PTC_preEstSessionID = STR_UTF8(name=u'preEstSessionID', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_preEstStatus = ENUM(name=u'preEstStatus', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PreEstStatus')), opt=True)
    _PTC_pTCGroupID = STR_UTF8(name=u'pTCGroupID', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_pTCIDList = STR_UTF8(name=u'pTCIDList', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_pTCMediaCapability = STR_UTF8(name=u'pTCMediaCapability', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_pTCOriginatingId = STR_UTF8(name=u'pTCOriginatingId', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_pTCOther = STR_UTF8(name=u'pTCOther', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_pTCParticipants = STR_UTF8(name=u'pTCParticipants', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_pTCParty = STR_UTF8(name=u'pTCParty', mode=MODE_TYPE, tag=(49, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_pTCPartyDrop = STR_UTF8(name=u'pTCPartyDrop', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_pTCSessionInfo = STR_UTF8(name=u'pTCSessionInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_pTCServerURI = STR_UTF8(name=u'pTCServerURI', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_pTCUserAccessPolicy = STR_UTF8(name=u'pTCUserAccessPolicy', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_pTCAddress = SEQ(name=u'pTCAddress', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PTCAddress')), opt=True)
    _PTC_queuedFloorControl = BOOL(name=u'queuedFloorControl', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_queuedPosition = STR_UTF8(name=u'queuedPosition', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_registrationRequest = ENUM(name=u'registrationRequest', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'RegistrationRequest')), opt=True)
    _PTC_registrationOutcome = ENUM(name=u'registrationOutcome', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'RegistrationOutcome')), opt=True)
    _PTC_retrieveID = STR_UTF8(name=u'retrieveID', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_rTPSetting = SEQ(name=u'rTPSetting', mode=MODE_TYPE, tag=(60, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'RTPSetting')), opt=True)
    _PTC_talkBurstPriority = ENUM(name=u'talkBurstPriority', mode=MODE_TYPE, tag=(61, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'Priority-Level')), opt=True)
    _PTC_talkBurstReason = STR_VIS(name=u'talkBurstReason', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'Talk-burst-reason-code')), opt=True)
    _PTC_talkburstControlSetting = SEQ(name=u'talkburstControlSetting', mode=MODE_TYPE, tag=(63, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'TalkburstControlSetting')), opt=True)
    _PTC_targetPresenceStatus = STR_UTF8(name=u'targetPresenceStatus', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_port_Number = INT(name=u'port-Number', mode=MODE_TYPE, tag=(65, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTC_port_Number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PTC._cont = ASN1Dict([
        (u'abandonCause', _PTC_abandonCause),
        (u'accessPolicyFailure', _PTC_accessPolicyFailure),
        (u'accessPolicyType', _PTC_accessPolicyType),
        (u'alertIndicator', _PTC_alertIndicator),
        (u'associatePresenceStatus', _PTC_associatePresenceStatus),
        (u'bearer-capability', _PTC_bearer_capability),
        (u'broadcastIndicator', _PTC_broadcastIndicator),
        (u'contactID', _PTC_contactID),
        (u'emergency', _PTC_emergency),
        (u'emergencyGroupState', _PTC_emergencyGroupState),
        (u'timeStamp', _PTC_timeStamp),
        (u'pTCType', _PTC_pTCType),
        (u'failureCode', _PTC_failureCode),
        (u'floorActivity', _PTC_floorActivity),
        (u'floorSpeakerID', _PTC_floorSpeakerID),
        (u'groupAdSender', _PTC_groupAdSender),
        (u'groupAuthRule', _PTC_groupAuthRule),
        (u'groupCharacteristics', _PTC_groupCharacteristics),
        (u'holdRetrieveInd', _PTC_holdRetrieveInd),
        (u'imminentPerilInd', _PTC_imminentPerilInd),
        (u'implicitFloorReq', _PTC_implicitFloorReq),
        (u'initiationCause', _PTC_initiationCause),
        (u'invitationCause', _PTC_invitationCause),
        (u'iPAPartyID', _PTC_iPAPartyID),
        (u'iPADirection', _PTC_iPADirection),
        (u'listManagementAction', _PTC_listManagementAction),
        (u'listManagementFailure', _PTC_listManagementFailure),
        (u'listManagementType', _PTC_listManagementType),
        (u'maxTBTime', _PTC_maxTBTime),
        (u'mCPTTGroupID', _PTC_mCPTTGroupID),
        (u'mCPTTID', _PTC_mCPTTID),
        (u'mCPTTInd', _PTC_mCPTTInd),
        (u'location', _PTC_location),
        (u'mCPTTOrganizationName', _PTC_mCPTTOrganizationName),
        (u'mediaStreamAvail', _PTC_mediaStreamAvail),
        (u'priority-Level', _PTC_priority_Level),
        (u'preEstSessionID', _PTC_preEstSessionID),
        (u'preEstStatus', _PTC_preEstStatus),
        (u'pTCGroupID', _PTC_pTCGroupID),
        (u'pTCIDList', _PTC_pTCIDList),
        (u'pTCMediaCapability', _PTC_pTCMediaCapability),
        (u'pTCOriginatingId', _PTC_pTCOriginatingId),
        (u'pTCOther', _PTC_pTCOther),
        (u'pTCParticipants', _PTC_pTCParticipants),
        (u'pTCParty', _PTC_pTCParty),
        (u'pTCPartyDrop', _PTC_pTCPartyDrop),
        (u'pTCSessionInfo', _PTC_pTCSessionInfo),
        (u'pTCServerURI', _PTC_pTCServerURI),
        (u'pTCUserAccessPolicy', _PTC_pTCUserAccessPolicy),
        (u'pTCAddress', _PTC_pTCAddress),
        (u'queuedFloorControl', _PTC_queuedFloorControl),
        (u'queuedPosition', _PTC_queuedPosition),
        (u'registrationRequest', _PTC_registrationRequest),
        (u'registrationOutcome', _PTC_registrationOutcome),
        (u'retrieveID', _PTC_retrieveID),
        (u'rTPSetting', _PTC_rTPSetting),
        (u'talkBurstPriority', _PTC_talkBurstPriority),
        (u'talkBurstReason', _PTC_talkBurstReason),
        (u'talkburstControlSetting', _PTC_talkburstControlSetting),
        (u'targetPresenceStatus', _PTC_targetPresenceStatus),
        (u'port-Number', _PTC_port_Number),
        ])
    PTC._ext = []
    
    #-----< AccessPolicyType >-----#
    AccessPolicyType = SEQ(name=u'AccessPolicyType', mode=MODE_TYPE)
    _AccessPolicyType_userAccessPolicyAttempt = BOOL(name=u'userAccessPolicyAttempt', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPolicyType_groupAuthorizationRulesAttempt = BOOL(name=u'groupAuthorizationRulesAttempt', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPolicyType_userAccessPolicyQuery = BOOL(name=u'userAccessPolicyQuery', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPolicyType_groupAuthorizationRulesQuery = BOOL(name=u'groupAuthorizationRulesQuery', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPolicyType_userAccessPolicyResult = STR_UTF8(name=u'userAccessPolicyResult', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessPolicyType_groupAuthorizationRulesResult = STR_UTF8(name=u'groupAuthorizationRulesResult', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    AccessPolicyType._cont = ASN1Dict([
        (u'userAccessPolicyAttempt', _AccessPolicyType_userAccessPolicyAttempt),
        (u'groupAuthorizationRulesAttempt', _AccessPolicyType_groupAuthorizationRulesAttempt),
        (u'userAccessPolicyQuery', _AccessPolicyType_userAccessPolicyQuery),
        (u'groupAuthorizationRulesQuery', _AccessPolicyType_groupAuthorizationRulesQuery),
        (u'userAccessPolicyResult', _AccessPolicyType_userAccessPolicyResult),
        (u'groupAuthorizationRulesResult', _AccessPolicyType_groupAuthorizationRulesResult),
        ])
    AccessPolicyType._ext = []
    
    #-----< AlertIndicator >-----#
    AlertIndicator = ENUM(name=u'AlertIndicator', mode=MODE_TYPE)
    AlertIndicator._cont = ASN1Dict([(u'sent', 1), (u'received', 2), (u'cancelled', 3)])
    AlertIndicator._ext = []
    
    #-----< AssociatePresenceStatus >-----#
    AssociatePresenceStatus = SEQ(name=u'AssociatePresenceStatus', mode=MODE_TYPE)
    _AssociatePresenceStatus_presenceID = STR_UTF8(name=u'presenceID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AssociatePresenceStatus_presenceType = ENUM(name=u'presenceType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'PresenceType')))
    _AssociatePresenceStatus_presenceStatus = BOOL(name=u'presenceStatus', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    AssociatePresenceStatus._cont = ASN1Dict([
        (u'presenceID', _AssociatePresenceStatus_presenceID),
        (u'presenceType', _AssociatePresenceStatus_presenceType),
        (u'presenceStatus', _AssociatePresenceStatus_presenceStatus),
        ])
    AssociatePresenceStatus._ext = []
    
    #-----< PresenceType >-----#
    PresenceType = ENUM(name=u'PresenceType', mode=MODE_TYPE)
    PresenceType._cont = ASN1Dict([(u'pTCClient', 1), (u'pTCGroup', 2)])
    PresenceType._ext = []
    
    #-----< Emergency >-----#
    Emergency = ENUM(name=u'Emergency', mode=MODE_TYPE)
    Emergency._cont = ASN1Dict([(u'imminent', 1), (u'peril', 2), (u'cancel', 3)])
    Emergency._ext = []
    
    #-----< EmergencyGroupState >-----#
    EmergencyGroupState = SEQ(name=u'EmergencyGroupState', mode=MODE_TYPE)
    _EmergencyGroupState_clientEmergencyState = ENUM(name=u'clientEmergencyState', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EmergencyGroupState_clientEmergencyState._cont = ASN1Dict([(u'inform', 1), (u'response', 2), (u'cancelInform', 3), (u'cancelResponse', 4)])
    _EmergencyGroupState_clientEmergencyState._ext = []
    _EmergencyGroupState_groupEmergencyState = ENUM(name=u'groupEmergencyState', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EmergencyGroupState_groupEmergencyState._cont = ASN1Dict([(u'inForm', 1), (u'reSponse', 2), (u'cancelInform', 3), (u'cancelResponse', 4)])
    _EmergencyGroupState_groupEmergencyState._ext = []
    EmergencyGroupState._cont = ASN1Dict([
        (u'clientEmergencyState', _EmergencyGroupState_clientEmergencyState),
        (u'groupEmergencyState', _EmergencyGroupState_groupEmergencyState),
        ])
    EmergencyGroupState._ext = []
    
    #-----< PTCType >-----#
    PTCType = ENUM(name=u'PTCType', mode=MODE_TYPE)
    PTCType._cont = ASN1Dict([(u'pTCStartofInterception', 1), (u'pTCServinSystem', 2), (u'pTCSessionInitiation', 3), (u'pTCSessionAbandonEndRecord', 4), (u'pTCSessionStartContinueRecord', 5), (u'pTCSessionEndRecord', 6), (u'pTCPre-EstablishedSessionSessionRecord', 7), (u'pTCInstantPersonalAlert', 8), (u'pTCPartyJoin', 9), (u'pTCPartyDrop', 10), (u'pTCPartyHold-RetrieveRecord', 11), (u'pTCMediaModification', 12), (u'pTCGroupAdvertizement', 13), (u'pTCFloorConttrol', 14), (u'pTCTargetPressence', 15), (u'pTCAssociatePressence', 16), (u'pTCListManagementEvents', 17), (u'pTCAccessPolicyEvents', 18), (u'pTCMediaTypeNotification', 19), (u'pTCGroupCallRequest', 20), (u'pTCGroupCallCancel', 21), (u'pTCGroupCallResponse', 22), (u'pTCGroupCallInterrogate', 23), (u'pTCMCPTTImminentGroupCall', 24), (u'pTCCC', 25), (u'pTCRegistration', 26), (u'pTCEncryption', 27)])
    PTCType._ext = []
    
    #-----< FloorActivity >-----#
    FloorActivity = SEQ(name=u'FloorActivity', mode=MODE_TYPE)
    _FloorActivity_tBCP_Request = BOOL(name=u'tBCP-Request', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _FloorActivity_tBCP_Granted = BOOL(name=u'tBCP-Granted', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _FloorActivity_tBCP_Deny = BOOL(name=u'tBCP-Deny', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _FloorActivity_tBCP_Queued = BOOL(name=u'tBCP-Queued', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _FloorActivity_tBCP_Release = BOOL(name=u'tBCP-Release', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _FloorActivity_tBCP_Revoke = BOOL(name=u'tBCP-Revoke', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _FloorActivity_tBCP_Taken = BOOL(name=u'tBCP-Taken', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _FloorActivity_tBCP_Idle = BOOL(name=u'tBCP-Idle', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    FloorActivity._cont = ASN1Dict([
        (u'tBCP-Request', _FloorActivity_tBCP_Request),
        (u'tBCP-Granted', _FloorActivity_tBCP_Granted),
        (u'tBCP-Deny', _FloorActivity_tBCP_Deny),
        (u'tBCP-Queued', _FloorActivity_tBCP_Queued),
        (u'tBCP-Release', _FloorActivity_tBCP_Release),
        (u'tBCP-Revoke', _FloorActivity_tBCP_Revoke),
        (u'tBCP-Taken', _FloorActivity_tBCP_Taken),
        (u'tBCP-Idle', _FloorActivity_tBCP_Idle),
        ])
    FloorActivity._ext = []
    
    #-----< GroupAuthRule >-----#
    GroupAuthRule = ENUM(name=u'GroupAuthRule', mode=MODE_TYPE)
    GroupAuthRule._cont = ASN1Dict([(u'allow-Initiating-PtcSession', 0), (u'block-Initiating-PtcSession', 1), (u'allow-Joining-PtcSession', 2), (u'block-Joining-PtcSession', 3), (u'allow-Add-Participants', 4), (u'block-Add-Participants', 5), (u'allow-Subscription-PtcSession-State', 6), (u'block-Subscription-PtcSession-State', 7), (u'allow-Anonymity', 8), (u'forbid-Anonymity', 9)])
    GroupAuthRule._ext = []
    
    #-----< ImminentPerilInd >-----#
    ImminentPerilInd = ENUM(name=u'ImminentPerilInd', mode=MODE_TYPE)
    ImminentPerilInd._cont = ASN1Dict([(u'request', 1), (u'response', 2), (u'cancel', 3)])
    ImminentPerilInd._ext = []
    
    #-----< ImplicitFloorReq >-----#
    ImplicitFloorReq = ENUM(name=u'ImplicitFloorReq', mode=MODE_TYPE)
    ImplicitFloorReq._cont = ASN1Dict([(u'join', 1), (u'rejoin', 2), (u'release', 3)])
    ImplicitFloorReq._ext = []
    
    #-----< InitiationCause >-----#
    InitiationCause = ENUM(name=u'InitiationCause', mode=MODE_TYPE)
    InitiationCause._cont = ASN1Dict([(u'requests', 1), (u'received', 2), (u'pTCOriginatingId', 3)])
    InitiationCause._ext = []
    
    #-----< IPADirection >-----#
    IPADirection = ENUM(name=u'IPADirection', mode=MODE_TYPE)
    IPADirection._cont = ASN1Dict([(u'toTarget', 0), (u'fromTarget', 1)])
    IPADirection._ext = []
    
    #-----< ListManagementAction >-----#
    ListManagementAction = ENUM(name=u'ListManagementAction', mode=MODE_TYPE)
    ListManagementAction._cont = ASN1Dict([(u'create', 1), (u'modify', 2), (u'retrieve', 3), (u'delete', 4), (u'notify', 5)])
    ListManagementAction._ext = []
    
    #-----< ListManagementType >-----#
    ListManagementType = ENUM(name=u'ListManagementType', mode=MODE_TYPE)
    ListManagementType._cont = ASN1Dict([(u'contactListManagementAttempt', 1), (u'groupListManagementAttempt', 2), (u'contactListManagementResult', 3), (u'groupListManagementResult', 4), (u'requestSuccessful', 5)])
    ListManagementType._ext = []
    
    #-----< Priority-Level >-----#
    Priority_Level = ENUM(name=u'Priority-Level', mode=MODE_TYPE)
    Priority_Level._cont = ASN1Dict([(u'pre-emptive', 0), (u'high-priority', 1), (u'normal-priority', 2), (u'listen-only', 3)])
    Priority_Level._ext = []
    
    #-----< PreEstStatus >-----#
    PreEstStatus = ENUM(name=u'PreEstStatus', mode=MODE_TYPE)
    PreEstStatus._cont = ASN1Dict([(u'established', 1), (u'modify', 2), (u'released', 3)])
    PreEstStatus._ext = []
    
    #-----< PTCAddress >-----#
    PTCAddress = SEQ(name=u'PTCAddress', mode=MODE_TYPE)
    _PTCAddress_uri = STR_UTF8(name=u'uri', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PTCAddress_privacy_setting = BOOL(name=u'privacy-setting', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PTCAddress_privacy_alias = STR_VIS(name=u'privacy-alias', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PTCAddress_nickname = STR_UTF8(name=u'nickname', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    PTCAddress._cont = ASN1Dict([
        (u'uri', _PTCAddress_uri),
        (u'privacy-setting', _PTCAddress_privacy_setting),
        (u'privacy-alias', _PTCAddress_privacy_alias),
        (u'nickname', _PTCAddress_nickname),
        ])
    PTCAddress._ext = []
    
    #-----< RegistrationRequest >-----#
    RegistrationRequest = ENUM(name=u'RegistrationRequest', mode=MODE_TYPE)
    RegistrationRequest._cont = ASN1Dict([(u'register', 1), (u're-register', 2), (u'de-register', 3)])
    RegistrationRequest._ext = []
    
    #-----< RegistrationOutcome >-----#
    RegistrationOutcome = ENUM(name=u'RegistrationOutcome', mode=MODE_TYPE)
    RegistrationOutcome._cont = ASN1Dict([(u'success', 0), (u'failure', 1)])
    RegistrationOutcome._ext = []
    
    #-----< RTPSetting >-----#
    RTPSetting = SEQ(name=u'RTPSetting', mode=MODE_TYPE)
    _RTPSetting_ip_address = SEQ(name=u'ip-address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'IPAddress')))
    _RTPSetting_port_number = INT(name=u'port-number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('UmtsHI2Operations', 'Port-Number')))
    RTPSetting._cont = ASN1Dict([
        (u'ip-address', _RTPSetting_ip_address),
        (u'port-number', _RTPSetting_port_number),
        ])
    RTPSetting._ext = []
    
    #-----< Port-Number >-----#
    Port_Number = INT(name=u'Port-Number', mode=MODE_TYPE)
    Port_Number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TalkburstControlSetting >-----#
    TalkburstControlSetting = SEQ(name=u'TalkburstControlSetting', mode=MODE_TYPE)
    _TalkburstControlSetting_talk_BurstControlProtocol = STR_UTF8(name=u'talk-BurstControlProtocol', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TalkburstControlSetting_talk_Burst_parameters = SET_OF(name=u'talk-Burst-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TalkburstControlSetting_talk_Burst_parameters__item_ = STR_VIS(name='_item_', mode=MODE_TYPE)
    _TalkburstControlSetting_talk_Burst_parameters._cont = __TalkburstControlSetting_talk_Burst_parameters__item_
    _TalkburstControlSetting_tBCP_PortNumber = INT(name=u'tBCP-PortNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TalkburstControlSetting_tBCP_PortNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TalkburstControlSetting._cont = ASN1Dict([
        (u'talk-BurstControlProtocol', _TalkburstControlSetting_talk_BurstControlProtocol),
        (u'talk-Burst-parameters', _TalkburstControlSetting_talk_Burst_parameters),
        (u'tBCP-PortNumber', _TalkburstControlSetting_tBCP_PortNumber),
        ])
    TalkburstControlSetting._ext = []
    
    #-----< Talk-burst-reason-code >-----#
    Talk_burst_reason_code = STR_VIS(name=u'Talk-burst-reason-code', mode=MODE_TYPE)
    
    _all_ = [
        lawfulInterceptDomainId,
        threeGPPSUBDomainId,
        hi2DomainId,
        _UmtsIRIsContent_umtsiRIContent,
        _UmtsIRIsContent_umtsIRISequence,
        UmtsIRIsContent,
        _UmtsIRISequence__item_,
        UmtsIRISequence,
        _UmtsIRIContent_iRI_Begin_record,
        _UmtsIRIContent_iRI_End_record,
        _UmtsIRIContent_iRI_Continue_record,
        _UmtsIRIContent_iRI_Report_record,
        UmtsIRIContent,
        _IRI_Parameters_hi2DomainId,
        _IRI_Parameters_iRIversion,
        _IRI_Parameters_lawfulInterceptionIdentifier,
        _IRI_Parameters_timeStamp,
        _IRI_Parameters_initiator,
        _IRI_Parameters_locationOfTheTarget,
        __IRI_Parameters_partyInformation__item_,
        _IRI_Parameters_partyInformation,
        _IRI_Parameters_serviceCenterAddress,
        _IRI_Parameters_sMS,
        _IRI_Parameters_national_Parameters,
        _IRI_Parameters_gPRSCorrelationNumber,
        _IRI_Parameters_gPRSevent,
        _IRI_Parameters_sgsnAddress,
        _IRI_Parameters_gPRSOperationErrorCode,
        _IRI_Parameters_ggsnAddress,
        _IRI_Parameters_qOS,
        _IRI_Parameters_networkIdentifier,
        _IRI_Parameters_sMSOriginatingAddress,
        _IRI_Parameters_sMSTerminatingAddress,
        _IRI_Parameters_iMSevent,
        _IRI_Parameters_sIPMessage,
        _IRI_Parameters_servingSGSN_number,
        _IRI_Parameters_servingSGSN_address,
        _IRI_Parameters_ldiEvent,
        _IRI_Parameters_correlation,
        _IRI_Parameters_mediaDecryption_info,
        _IRI_Parameters_servingS4_SGSN_address,
        _IRI_Parameters_sipMessageHeaderOffer,
        _IRI_Parameters_sipMessageHeaderAnswer,
        _IRI_Parameters_sdpOffer,
        _IRI_Parameters_sdpAnswer,
        _IRI_Parameters_uLITimestamp,
        _IRI_Parameters_packetDataHeaderInformation,
        _IRI_Parameters_mediaSecFailureIndication,
        __IRI_Parameters_pANI_Header_Info__item_,
        _IRI_Parameters_pANI_Header_Info,
        _IRI_Parameters_imsVoIP,
        _IRI_Parameters_xCAPmessage,
        _IRI_Parameters_ccUnavailableReason,
        _IRI_Parameters_carrierSpecificData,
        _IRI_Parameters_current_Previous_Systems,
        _IRI_Parameters_change_Of_Target_Identity,
        _IRI_Parameters_requesting_Network_Identifier,
        _IRI_Parameters_requesting_Node_Type,
        _IRI_Parameters_serving_System_Identifier,
        _IRI_Parameters_extendedLocParameters,
        _IRI_Parameters_locationErrorCode,
        _IRI_Parameters_cSREvent,
        _IRI_Parameters_ptc,
        _IRI_Parameters_ptcEncryption,
        _IRI_Parameters_national_HI2_ASN1parameters,
        IRI_Parameters,
        _PANI_Header_Info_access_Type,
        _PANI_Header_Info_access_Class,
        _PANI_Header_Info_network_Provided,
        _PANI_Header_Info_pANI_Location,
        PANI_Header_Info,
        _PANI_Location_raw_Location,
        _PANI_Location_location,
        PANI_Location,
        _PartyInformation_party_Qualifier,
        __PartyInformation_partyIdentity_imei,
        __PartyInformation_partyIdentity_imsi,
        __PartyInformation_partyIdentity_msISDN,
        __PartyInformation_partyIdentity_e164_Format,
        __PartyInformation_partyIdentity_sip_uri,
        __PartyInformation_partyIdentity_tel_uri,
        __PartyInformation_partyIdentity_x_3GPP_Asserted_Identity,
        __PartyInformation_partyIdentity_xUI,
        _PartyInformation_partyIdentity,
        _PartyInformation_services_Data_Information,
        PartyInformation,
        _Location_e164_Number,
        _Location_globalCellID,
        _Location_rAI,
        _Location_gsmLocation,
        _Location_umtsLocation,
        _Location_sAI,
        _Location_oldRAI,
        _Location_tAI,
        _Location_eCGI,
        _Location_civicAddress,
        _Location_operatorSpecificInfo,
        __Location_uELocationTimestamp_timestamp,
        __Location_uELocationTimestamp_timestampUnknown,
        _Location_uELocationTimestamp,
        Location,
        GlobalCellID,
        Rai,
        Sai,
        __GSMLocation_geoCoordinates_latitude,
        __GSMLocation_geoCoordinates_longitude,
        __GSMLocation_geoCoordinates_mapDatum,
        __GSMLocation_geoCoordinates_azimuth,
        _GSMLocation_geoCoordinates,
        __GSMLocation_utmCoordinates_utm_East,
        __GSMLocation_utmCoordinates_utm_North,
        __GSMLocation_utmCoordinates_mapDatum,
        __GSMLocation_utmCoordinates_azimuth,
        _GSMLocation_utmCoordinates,
        __GSMLocation_utmRefCoordinates_utmref_string,
        __GSMLocation_utmRefCoordinates_mapDatum,
        _GSMLocation_utmRefCoordinates,
        _GSMLocation_wGS84Coordinates,
        GSMLocation,
        MapDatum,
        _UMTSLocation_point,
        _UMTSLocation_pointWithUnCertainty,
        _UMTSLocation_polygon,
        UMTSLocation,
        _GeographicalCoordinates_latitudeSign,
        _GeographicalCoordinates_latitude,
        _GeographicalCoordinates_longitude,
        GeographicalCoordinates,
        _GA_Point_geographicalCoordinates,
        GA_Point,
        _GA_PointWithUnCertainty_geographicalCoordinates,
        _GA_PointWithUnCertainty_uncertaintyCode,
        GA_PointWithUnCertainty,
        maxNrOfPoints,
        __GA_Polygon__item__geographicalCoordinates,
        _GA_Polygon__item_,
        GA_Polygon,
        __CivicAddress_detailedCivicAddress__item_,
        _CivicAddress_detailedCivicAddress,
        _CivicAddress_xmlCivicAddress,
        CivicAddress,
        XmlCivicAddress,
        _DetailedCivicAddress_building,
        _DetailedCivicAddress_room,
        _DetailedCivicAddress_placeType,
        _DetailedCivicAddress_postalCommunityName,
        _DetailedCivicAddress_additionalCode,
        _DetailedCivicAddress_seat,
        _DetailedCivicAddress_primaryRoad,
        _DetailedCivicAddress_primaryRoadDirection,
        _DetailedCivicAddress_trailingStreetSuffix,
        _DetailedCivicAddress_streetSuffix,
        _DetailedCivicAddress_houseNumber,
        _DetailedCivicAddress_houseNumberSuffix,
        _DetailedCivicAddress_landmarkAddress,
        _DetailedCivicAddress_additionalLocation,
        _DetailedCivicAddress_name,
        _DetailedCivicAddress_floor,
        _DetailedCivicAddress_primaryStreet,
        _DetailedCivicAddress_primaryStreetDirection,
        _DetailedCivicAddress_roadSection,
        _DetailedCivicAddress_roadBranch,
        _DetailedCivicAddress_roadSubBranch,
        _DetailedCivicAddress_roadPreModifier,
        _DetailedCivicAddress_roadPostModifier,
        _DetailedCivicAddress_postalCode,
        _DetailedCivicAddress_town,
        _DetailedCivicAddress_county,
        _DetailedCivicAddress_country,
        _DetailedCivicAddress_language,
        DetailedCivicAddress,
        __SMS_report_sMS_Contents_sms_initiator,
        __SMS_report_sMS_Contents_transfer_status,
        __SMS_report_sMS_Contents_other_message,
        __SMS_report_sMS_Contents_content,
        _SMS_report_sMS_Contents,
        SMS_report,
        GPRSCorrelationNumber,
        _CorrelationValues_iri_to_CC,
        _CorrelationValues_iri_to_iri,
        __CorrelationValues_both_IRI_CC_iri_CC,
        __CorrelationValues_both_IRI_CC_iri_IRI,
        _CorrelationValues_both_IRI_CC,
        CorrelationValues,
        __IMS_VoIP_Correlation__item__ims_iri,
        __IMS_VoIP_Correlation__item__ims_cc,
        _IMS_VoIP_Correlation__item_,
        IMS_VoIP_Correlation,
        __IRI_to_CC_Correlation_cc__item_,
        _IRI_to_CC_Correlation_cc,
        _IRI_to_CC_Correlation_iri,
        IRI_to_CC_Correlation,
        IRI_to_IRI_Correlation,
        GPRSEvent,
        CSREvent,
        IMSevent,
        _Current_Previous_Systems_serving_System_Identifier,
        _Current_Previous_Systems_current_Serving_SGSN_Number,
        _Current_Previous_Systems_current_Serving_SGSN_Address,
        _Current_Previous_Systems_current_Serving_S4_SGSN_Address,
        _Current_Previous_Systems_previous_Serving_System_Identifier,
        _Current_Previous_Systems_previous_Serving_SGSN_Number,
        _Current_Previous_Systems_previous_Serving_SGSN_Address,
        _Current_Previous_Systems_previous_Serving_S4_SGSN_Address,
        Current_Previous_Systems,
        _Change_Of_Target_Identity_new_MSISDN,
        _Change_Of_Target_Identity_old_MSISDN,
        _Change_Of_Target_Identity_new_IMSI,
        _Change_Of_Target_Identity_old_IMSI,
        _Change_Of_Target_Identity_new_IMEI,
        _Change_Of_Target_Identity_old_IMEI,
        _Change_Of_Target_Identity_new_IMPI,
        _Change_Of_Target_Identity_old_IMPI,
        _Change_Of_Target_Identity_new_SIP_URI,
        _Change_Of_Target_Identity_old_SIP_URI,
        _Change_Of_Target_Identity_new_TEL_URI,
        _Change_Of_Target_Identity_old_TEL_URI,
        Change_Of_Target_Identity,
        Requesting_Node_Type,
        _Services_Data_Information_gPRS_parameters,
        Services_Data_Information,
        _GPRS_parameters_pDP_address_allocated_to_the_target,
        _GPRS_parameters_aPN,
        _GPRS_parameters_pDP_type,
        _GPRS_parameters_nSAPI,
        _GPRS_parameters_additionalIPaddress,
        GPRS_parameters,
        GPRSOperationErrorCode,
        LDIevent,
        _UmtsQos_qosMobileRadio,
        _UmtsQos_qosGn,
        UmtsQos,
        _MediaDecryption_info__item_,
        MediaDecryption_info,
        _CCKeyInfo_cCCSID,
        _CCKeyInfo_cCDecKey,
        _CCKeyInfo_cCSalt,
        CCKeyInfo,
        MediaSecFailureIndication,
        _PacketDataHeaderInformation_packetDataHeader,
        _PacketDataHeaderInformation_packetDataSummary,
        PacketDataHeaderInformation,
        _PacketDataHeaderReport_packetDataHeaderMapped,
        _PacketDataHeaderReport_packetDataHeaderCopy,
        PacketDataHeaderReport,
        _PacketDataHeaderMapped_sourceIPAddress,
        _PacketDataHeaderMapped_sourcePortNumber,
        _PacketDataHeaderMapped_destinationIPAddress,
        _PacketDataHeaderMapped_destinationPortNumber,
        _PacketDataHeaderMapped_transportProtocol,
        _PacketDataHeaderMapped_packetsize,
        _PacketDataHeaderMapped_flowLabel,
        _PacketDataHeaderMapped_packetCount,
        _PacketDataHeaderMapped_direction,
        PacketDataHeaderMapped,
        TPDU_direction,
        _PacketDataHeaderCopy_direction,
        _PacketDataHeaderCopy_headerCopy,
        PacketDataHeaderCopy,
        _PacketDataSummaryReport__item_,
        PacketDataSummaryReport,
        _PacketFlowSummary_sourceIPAddress,
        _PacketFlowSummary_sourcePortNumber,
        _PacketFlowSummary_destinationIPAddress,
        _PacketFlowSummary_destinationPortNumber,
        _PacketFlowSummary_transportProtocol,
        _PacketFlowSummary_flowLabel,
        _PacketFlowSummary_summaryPeriod,
        _PacketFlowSummary_packetCount,
        _PacketFlowSummary_sumOfPacketSizes,
        _PacketFlowSummary_packetDataSummaryReason,
        PacketFlowSummary,
        ReportReason,
        _ReportInterval_firstPacketTimeStamp,
        _ReportInterval_lastPacketTimeStamp,
        ReportInterval,
        _ExtendedLocParameters_posMethod,
        __ExtendedLocParameters_mapData_base64Map,
        __ExtendedLocParameters_mapData_url,
        _ExtendedLocParameters_mapData,
        __ExtendedLocParameters_altitude_alt,
        __ExtendedLocParameters_altitude_alt_uncertainty,
        _ExtendedLocParameters_altitude,
        _ExtendedLocParameters_speed,
        _ExtendedLocParameters_direction,
        _ExtendedLocParameters_level_conf,
        _ExtendedLocParameters_qOS_not_met,
        __ExtendedLocParameters_motionStateList_primaryMotionState,
        ___ExtendedLocParameters_motionStateList_secondaryMotionState__item_,
        __ExtendedLocParameters_motionStateList_secondaryMotionState,
        __ExtendedLocParameters_motionStateList_confidence,
        _ExtendedLocParameters_motionStateList,
        __ExtendedLocParameters_floor_floor_number,
        __ExtendedLocParameters_floor_floor_number_uncertainty,
        _ExtendedLocParameters_floor,
        _ExtendedLocParameters_additional_info,
        _ExtendedLocParameters_lALS_rawMLPPosData,
        ExtendedLocParameters,
        LocationErrorCode,
        _PTCEncryptionInfo_cipher,
        _PTCEncryptionInfo_cryptoContext,
        _PTCEncryptionInfo_key,
        _PTCEncryptionInfo_keyEncoding,
        _PTCEncryptionInfo_salt,
        _PTCEncryptionInfo_pTCOther,
        PTCEncryptionInfo,
        _PTC_abandonCause,
        _PTC_accessPolicyFailure,
        _PTC_accessPolicyType,
        _PTC_alertIndicator,
        _PTC_associatePresenceStatus,
        _PTC_bearer_capability,
        _PTC_broadcastIndicator,
        _PTC_contactID,
        _PTC_emergency,
        _PTC_emergencyGroupState,
        _PTC_timeStamp,
        _PTC_pTCType,
        _PTC_failureCode,
        _PTC_floorActivity,
        _PTC_floorSpeakerID,
        _PTC_groupAdSender,
        _PTC_groupAuthRule,
        _PTC_groupCharacteristics,
        _PTC_holdRetrieveInd,
        _PTC_imminentPerilInd,
        _PTC_implicitFloorReq,
        _PTC_initiationCause,
        _PTC_invitationCause,
        _PTC_iPAPartyID,
        _PTC_iPADirection,
        _PTC_listManagementAction,
        _PTC_listManagementFailure,
        _PTC_listManagementType,
        _PTC_maxTBTime,
        _PTC_mCPTTGroupID,
        _PTC_mCPTTID,
        _PTC_mCPTTInd,
        _PTC_location,
        _PTC_mCPTTOrganizationName,
        _PTC_mediaStreamAvail,
        _PTC_priority_Level,
        _PTC_preEstSessionID,
        _PTC_preEstStatus,
        _PTC_pTCGroupID,
        _PTC_pTCIDList,
        _PTC_pTCMediaCapability,
        _PTC_pTCOriginatingId,
        _PTC_pTCOther,
        _PTC_pTCParticipants,
        _PTC_pTCParty,
        _PTC_pTCPartyDrop,
        _PTC_pTCSessionInfo,
        _PTC_pTCServerURI,
        _PTC_pTCUserAccessPolicy,
        _PTC_pTCAddress,
        _PTC_queuedFloorControl,
        _PTC_queuedPosition,
        _PTC_registrationRequest,
        _PTC_registrationOutcome,
        _PTC_retrieveID,
        _PTC_rTPSetting,
        _PTC_talkBurstPriority,
        _PTC_talkBurstReason,
        _PTC_talkburstControlSetting,
        _PTC_targetPresenceStatus,
        _PTC_port_Number,
        PTC,
        _AccessPolicyType_userAccessPolicyAttempt,
        _AccessPolicyType_groupAuthorizationRulesAttempt,
        _AccessPolicyType_userAccessPolicyQuery,
        _AccessPolicyType_groupAuthorizationRulesQuery,
        _AccessPolicyType_userAccessPolicyResult,
        _AccessPolicyType_groupAuthorizationRulesResult,
        AccessPolicyType,
        AlertIndicator,
        _AssociatePresenceStatus_presenceID,
        _AssociatePresenceStatus_presenceType,
        _AssociatePresenceStatus_presenceStatus,
        AssociatePresenceStatus,
        PresenceType,
        Emergency,
        _EmergencyGroupState_clientEmergencyState,
        _EmergencyGroupState_groupEmergencyState,
        EmergencyGroupState,
        PTCType,
        _FloorActivity_tBCP_Request,
        _FloorActivity_tBCP_Granted,
        _FloorActivity_tBCP_Deny,
        _FloorActivity_tBCP_Queued,
        _FloorActivity_tBCP_Release,
        _FloorActivity_tBCP_Revoke,
        _FloorActivity_tBCP_Taken,
        _FloorActivity_tBCP_Idle,
        FloorActivity,
        GroupAuthRule,
        ImminentPerilInd,
        ImplicitFloorReq,
        InitiationCause,
        IPADirection,
        ListManagementAction,
        ListManagementType,
        Priority_Level,
        PreEstStatus,
        _PTCAddress_uri,
        _PTCAddress_privacy_setting,
        _PTCAddress_privacy_alias,
        _PTCAddress_nickname,
        PTCAddress,
        RegistrationRequest,
        RegistrationOutcome,
        _RTPSetting_ip_address,
        _RTPSetting_port_number,
        RTPSetting,
        Port_Number,
        _TalkburstControlSetting_talk_BurstControlProtocol,
        __TalkburstControlSetting_talk_Burst_parameters__item_,
        _TalkburstControlSetting_talk_Burst_parameters,
        _TalkburstControlSetting_tBCP_PortNumber,
        TalkburstControlSetting,
        Talk_burst_reason_code,
    ]

class VoIP_HI3_IMS:

    _name_  = u'VoIP-HI3-IMS'
    _oid_   = [0, 4, 0, 2, 2, 4, 12, 15, 1]
    
    _obj_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi3voipDomainId',
        u'Voip-CC-PDU',
        u'VoipLIC-header',
        u'VoipCorrelationNumber',
        u'TPDU-direction',
        u'ICE-type',
        u'Payload-description',
        ]
    _type_ = [
        u'Voip-CC-PDU',
        u'VoipLIC-header',
        u'VoipCorrelationNumber',
        u'TPDU-direction',
        u'ICE-type',
        u'Payload-description',
        ]
    _set_ = [
        ]
    _val_ = [
        u'lawfulInterceptDomainId',
        u'threeGPPSUBDomainId',
        u'hi3voipDomainId',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< lawfulInterceptDomainId >-----#
    lawfulInterceptDomainId = OID(name=u'lawfulInterceptDomainId', mode=MODE_VALUE)
    lawfulInterceptDomainId._val = (0, 4, 0, 2, 2)
    
    #-----< threeGPPSUBDomainId >-----#
    threeGPPSUBDomainId = OID(name=u'threeGPPSUBDomainId', mode=MODE_VALUE)
    threeGPPSUBDomainId._val = (0, 4, 0, 2, 2, 4)
    
    #-----< hi3voipDomainId >-----#
    hi3voipDomainId = OID(name=u'hi3voipDomainId', mode=MODE_VALUE)
    hi3voipDomainId._val = (0, 4, 0, 2, 2, 4, 12, 15, 1)
    
    #-----< Voip-CC-PDU >-----#
    Voip_CC_PDU = SEQ(name=u'Voip-CC-PDU', mode=MODE_TYPE)
    _Voip_CC_PDU_voipLIC_header = SEQ(name=u'voipLIC-header', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('VoIP-HI3-IMS', 'VoipLIC-header')))
    _Voip_CC_PDU_payload = OCT_STR(name=u'payload', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Voip_CC_PDU._cont = ASN1Dict([
        (u'voipLIC-header', _Voip_CC_PDU_voipLIC_header),
        (u'payload', _Voip_CC_PDU_payload),
        ])
    Voip_CC_PDU._ext = None
    
    #-----< VoipLIC-header >-----#
    VoipLIC_header = SEQ(name=u'VoipLIC-header', mode=MODE_TYPE)
    _VoipLIC_header_hi3voipDomainId = OID(name=u'hi3voipDomainId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _VoipLIC_header_lIID = OCT_STR(name=u'lIID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'LawfulInterceptionIdentifier')), opt=True)
    _VoipLIC_header_voipCorrelationNumber = OCT_STR(name=u'voipCorrelationNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('VoIP-HI3-IMS', 'VoipCorrelationNumber')))
    _VoipLIC_header_timeStamp = CHOICE(name=u'timeStamp', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'TimeStamp')), opt=True)
    _VoipLIC_header_sequence_number = INT(name=u'sequence-number', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _VoipLIC_header_sequence_number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _VoipLIC_header_t_PDU_direction = ENUM(name=u't-PDU-direction', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('VoIP-HI3-IMS', 'TPDU-direction')))
    _VoipLIC_header_national_HI3_ASN1parameters = SEQ(name=u'national-HI3-ASN1parameters', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Eps-HI3-PS', 'National-HI3-ASN1parameters')), opt=True)
    _VoipLIC_header_ice_type = ENUM(name=u'ice-type', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('VoIP-HI3-IMS', 'ICE-type')), opt=True)
    _VoipLIC_header_payload_description = SEQ(name=u'payload-description', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('VoIP-HI3-IMS', 'Payload-description')), opt=True)
    _VoipLIC_header_networkIdentifier = SEQ(name=u'networkIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('HI2Operations', 'Network-Identifier')), opt=True)
    _VoipLIC_header_pTCSessionInfo = STR_UTF8(name=u'pTCSessionInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    VoipLIC_header._cont = ASN1Dict([
        (u'hi3voipDomainId', _VoipLIC_header_hi3voipDomainId),
        (u'lIID', _VoipLIC_header_lIID),
        (u'voipCorrelationNumber', _VoipLIC_header_voipCorrelationNumber),
        (u'timeStamp', _VoipLIC_header_timeStamp),
        (u'sequence-number', _VoipLIC_header_sequence_number),
        (u't-PDU-direction', _VoipLIC_header_t_PDU_direction),
        (u'national-HI3-ASN1parameters', _VoipLIC_header_national_HI3_ASN1parameters),
        (u'ice-type', _VoipLIC_header_ice_type),
        (u'payload-description', _VoipLIC_header_payload_description),
        (u'networkIdentifier', _VoipLIC_header_networkIdentifier),
        (u'pTCSessionInfo', _VoipLIC_header_pTCSessionInfo),
        ])
    VoipLIC_header._ext = [u'payload-description', u'networkIdentifier', u'pTCSessionInfo']
    
    #-----< VoipCorrelationNumber >-----#
    VoipCorrelationNumber = OCT_STR(name=u'VoipCorrelationNumber', mode=MODE_TYPE)
    
    #-----< TPDU-direction >-----#
    TPDU_direction = ENUM(name=u'TPDU-direction', mode=MODE_TYPE)
    TPDU_direction._cont = ASN1Dict([(u'from-target', 1), (u'to-target', 2), (u'combined', 3), (u'unknown', 4)])
    TPDU_direction._ext = None
    
    #-----< ICE-type >-----#
    ICE_type = ENUM(name=u'ICE-type', mode=MODE_TYPE)
    ICE_type._cont = ASN1Dict([(u'ggsn', 1), (u'pDN-GW', 2), (u'aGW', 3), (u'trGW', 4), (u'mGW', 5), (u'other', 6), (u'unknown', 7), (u'mRF', 8), (u'lmISF', 9), (u'sGW', 10)])
    ICE_type._ext = [u'mRF', u'lmISF', u'sGW']
    
    #-----< Payload-description >-----#
    Payload_description = SEQ(name=u'Payload-description', mode=MODE_TYPE)
    _Payload_description_copyOfSDPdescription = OCT_STR(name=u'copyOfSDPdescription', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Payload_description_mediaFormat = INT(name=u'mediaFormat', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Payload_description_mediaFormat._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _Payload_description_mediaAttributes = OCT_STR(name=u'mediaAttributes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    Payload_description._cont = ASN1Dict([
        (u'copyOfSDPdescription', _Payload_description_copyOfSDPdescription),
        (u'mediaFormat', _Payload_description_mediaFormat),
        (u'mediaAttributes', _Payload_description_mediaAttributes),
        ])
    Payload_description._ext = [u'mediaFormat', u'mediaAttributes']
    
    _all_ = [
        lawfulInterceptDomainId,
        threeGPPSUBDomainId,
        hi3voipDomainId,
        _Voip_CC_PDU_voipLIC_header,
        _Voip_CC_PDU_payload,
        Voip_CC_PDU,
        _VoipLIC_header_hi3voipDomainId,
        _VoipLIC_header_lIID,
        _VoipLIC_header_voipCorrelationNumber,
        _VoipLIC_header_timeStamp,
        _VoipLIC_header_sequence_number,
        _VoipLIC_header_t_PDU_direction,
        _VoipLIC_header_national_HI3_ASN1parameters,
        _VoipLIC_header_ice_type,
        _VoipLIC_header_payload_description,
        _VoipLIC_header_networkIdentifier,
        _VoipLIC_header_pTCSessionInfo,
        VoipLIC_header,
        VoipCorrelationNumber,
        TPDU_direction,
        ICE_type,
        _Payload_description_copyOfSDPdescription,
        _Payload_description_mediaFormat,
        _Payload_description_mediaAttributes,
        Payload_description,
    ]

init_modules(CONF_HI3_IMS, CONFHI2Operations, CSvoice_HI3_IP, EN301040, Eps_HI3_PS, EpsHI2Operations, GCSE_HI3, GCSEHI2Operations, HI2Operations, HI3CCLinkData, IWLANUmtsHI2Operations, MBMSUmtsHI2Operations, Mms_HI3_PS, MmsHI2Operations, ProSeHI2Operations, Remote_Operations_Information_Objects, PCESP, TS101909201, ThreeGPP_HI1NotificationOperations, UMTS_HI3CircuitLIOperations, Umts_HI3_PS, UmtsCS_HI2Operations, UmtsHI2Operations, VoIP_HI3_IMS)
